set define off
set verify off
set feedback off
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
begin wwv_flow.g_import_in_progress := true; end;
/
 
 
--application/set_environment
prompt  APPLICATION 102 - fragebogen
--
-- Application Export:
--   Application:     102
--   Name:            fragebogen
--   Date and Time:   10:51 Montag Oktober 26, 2015
--   Exported By:     SYSTEM
--   Flashback:       0
--   Export Type:     Application Export
--   Version:         4.2.5.00.08
--   Instance ID:     63126117280962
--
-- Import:
--   Using Application Builder
--   or
--   Using SQL*Plus as the Oracle user APEX_040200 or as the owner (parsing schema) of the application
 
-- Application Statistics:
--   Pages:                    111
--     Items:                2,086
--     Validations:            238
--     Processes:              734
--     Regions:                293
--     Buttons:                411
--     Dynamic Actions:        101
--   Shared Components:
--     Logic:
--       Items:                 42
--       Processes:             18
--       Build Options:          1
--     Navigation:
--       Parent Tabs:            1
--       Tab Sets:               2
--         Tabs:                30
--       Breadcrumbs:            3
--         Entries:             87
--       NavBar Entries:         1
--     Security:
--       Authentication:         4
--       Authorization:          1
--     User Interface:
--       Themes:                11
--       Templates:
--         Page:                83
--         Region:             193
--         Label:               45
--         List:               127
--         Popup LOV:            9
--         Calendar:            27
--         Breadcrumb:          18
--         Button:              38
--         Report:              65
--       LOVs:                   2
--       Shortcuts:             10
--       Plug-ins:               8
--     Globalization:
--       Messages:              42
--     Reports:
 
 
--       AAAA       PPPPP   EEEEEE  XX      XX
--      AA  AA      PP  PP  EE       XX    XX
--     AA    AA     PP  PP  EE        XX  XX
--    AAAAAAAAAA    PPPPP   EEEE       XXXX
--   AA        AA   PP      EE        XX  XX
--  AA          AA  PP      EE       XX    XX
--  AA          AA  PP      EEEEEE  XX      XX
prompt  Set Credentials...
 
begin
 
  -- Assumes you are running the script connected to SQL*Plus as the Oracle user APEX_040200 or as the owner (parsing schema) of the application.
  wwv_flow_api.set_security_group_id(p_security_group_id=>nvl(wwv_flow_application_install.get_workspace_id,2031917327559678));
 
end;
/

begin wwv_flow.g_import_in_progress := true; end;
/
begin 

select value into wwv_flow_api.g_nls_numeric_chars from nls_session_parameters where parameter='NLS_NUMERIC_CHARACTERS';

end;

/
begin execute immediate 'alter session set nls_numeric_characters=''.,''';

end;

/
begin wwv_flow.g_browser_language := 'en'; end;
/
prompt  Check Compatibility...
 
begin
 
-- This date identifies the minimum version required to import this file.
wwv_flow_api.set_version(p_version_yyyy_mm_dd=>'2012.01.01');
 
end;
/

prompt  Set Application ID...
 
begin
 
   -- SET APPLICATION ID
   wwv_flow.g_flow_id := nvl(wwv_flow_application_install.get_application_id,102);
   wwv_flow_api.g_id_offset := nvl(wwv_flow_application_install.get_offset,0);
null;
 
end;
/

--application/delete_application
 
begin
 
   -- Remove Application
wwv_flow_api.remove_flow(nvl(wwv_flow_application_install.get_application_id,102));
 
end;
/

 
begin
 
wwv_flow_audit.remove_audit_trail(nvl(wwv_flow_application_install.get_application_id,102));
null;
 
end;
/

prompt  ...ui types
--
 
begin
 
null;
 
end;
/

--application/create_application
 
begin
 
wwv_flow_api.create_flow(
  p_id    => nvl(wwv_flow_application_install.get_application_id,102),
  p_display_id=> nvl(wwv_flow_application_install.get_application_id,102),
  p_owner => nvl(wwv_flow_application_install.get_schema,'FRGBG'),
  p_name  => nvl(wwv_flow_application_install.get_application_name,'fragebogen'),
  p_alias => nvl(wwv_flow_application_install.get_application_alias,'F102'),
  p_page_view_logging => 'YES',
  p_page_protection_enabled_y_n=> 'Y',
  p_checksum_salt_last_reset => '20150917143643',
  p_max_session_length_sec=> 28800,
  p_on_max_session_timeout_url=> 'f?p=&APP_ID.:100:',
  p_on_max_idle_timeout_url=> 'f?p=&APP_ID.:100:',
  p_compatibility_mode=> '4.0',
  p_html_escaping_mode=> 'B',
  p_flow_language=> 'de-ch',
  p_flow_language_derived_from=> 'ITEM_PREFERENCE',
  p_allow_feedback_yn=> 'N',
  p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,''),
  p_publish_yn=> 'N',
  p_documentation_banner=> '',
  p_authentication=> 'PLUGIN',
  p_authentication_id=> 4256129844199370 + wwv_flow_api.g_id_offset,
  p_logout_url=> 'wwv_flow_custom_auth_std.logout?p_this_flow=&APP_ID.&amp;p_next_flow_page_sess=102:101',
  p_application_tab_set=> 1,
  p_logo_image => '/i/themes/&FAS_THEME_NAME./logo.jpg',
  p_public_url_prefix => '',
  p_public_user=> 'APEX_PUBLIC_USER',
  p_dbauth_url_prefix => '',
  p_proxy_server=> nvl(wwv_flow_application_install.get_proxy,''),
  p_cust_authentication_process=> '',
  p_cust_authentication_page=> '',
  p_flow_version=> 'Release 1.0',
  p_flow_status=> 'AVAILABLE_W_EDIT_LINK',
  p_flow_unavailable_text=> 'Diese Anwendung ist aktuell nicht verfügbar.',
  p_build_status=> 'RUN_AND_BUILD',
  p_exact_substitutions_only=> 'Y',
  p_browser_cache=>'Y',
  p_browser_frame=>'A',
  p_deep_linking=>'Y',
  p_vpd=> '',
  p_vpd_teardown_code=> '',
  p_authorize_public_pages_yn=>'Y',
  p_csv_encoding=> 'Y',
  p_auto_time_zone=> 'N',
  p_include_legacy_javascript=> 'Y',
  p_default_error_display_loc=> 'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_last_updated_by => 'OLIVER.LEMM',
  p_last_upd_yyyymmddhh24miss=> '20150917143643',
  p_ui_type_name => null,
  p_required_roles=> wwv_flow_utilities.string_to_table2(''));
 
 
end;
/

----------------
--package app map
--
prompt  ...user interfaces
--
 
begin
 
--application/user interface/desktop
wwv_flow_api.create_user_interface (
  p_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_ui_type_name => 'DESKTOP'
 ,p_display_name => 'Desktop'
 ,p_display_seq => 10
 ,p_use_auto_detect => true
 ,p_is_default => true
 ,p_theme_id => 1
 ,p_home_url => 'f?p=&APP_ID.:100:&SESSION.'
 ,p_login_url => 'f?p=&APP_ID.:100:'
 ,p_global_page_id => 0
  );
null;
 
end;
/

prompt  ...plug-in settings
--
 
begin
 
--application/plug-in setting/item_type_native_yes_no
wwv_flow_api.create_plugin_setting (
  p_id => 2628928319874835 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'ITEM TYPE'
 ,p_plugin => 'NATIVE_YES_NO'
 ,p_attribute_01 => 'Y'
 ,p_attribute_03 => 'N'
  );
--application/plug-in setting/dynamic_action_plugin_com_enkitec_clob_load
wwv_flow_api.create_plugin_setting (
  p_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'DYNAMIC ACTION'
 ,p_plugin => 'PLUGIN_COM_ENKITEC_CLOB_LOAD'
 ,p_attribute_01 => 'Y'
 ,p_attribute_02 => 'Please wait...'
 ,p_attribute_03 => 'DEFAULT'
  );
--application/plug-in setting/dynamic_action_plugin_com_skillbuilders_modal_page
wwv_flow_api.create_plugin_setting (
  p_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'DYNAMIC ACTION'
 ,p_plugin => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_attribute_01 => '1'
 ,p_attribute_02 => '.5'
 ,p_attribute_03 => 'Y'
 ,p_attribute_04 => 'none'
 ,p_attribute_05 => '100'
 ,p_attribute_06 => '300'
 ,p_attribute_07 => 'Y'
  );
--application/plug-in setting/item_type_plugin_com_skillbuilders_super_lov
wwv_flow_api.create_plugin_setting (
  p_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'ITEM TYPE'
 ,p_plugin => 'PLUGIN_COM_SKILLBUILDERS_SUPER_LOV'
 ,p_attribute_01 => 'CONTAINS_IGNORE'
 ,p_attribute_03 => 'DEFAULT'
 ,p_attribute_04 => 'drip-circle'
 ,p_attribute_06 => '400'
 ,p_attribute_07 => 'Y'
 ,p_attribute_08 => 'Your search returned no results.'
  );
null;
 
end;
/

prompt  ...authorization schemes
--
 
begin
 
--application/shared_components/security/authorization/check_page_access
wwv_flow_api.create_security_scheme (
  p_id => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'check_page_access'
 ,p_scheme_type => 'NATIVE_FUNCTION_BODY'
 ,p_attribute_01 => 'DECLARE'||unistr('\000a')||
'   v_anz           NUMBER;'||unistr('\000a')||
'   v_fehlerseite   NUMBER := 130;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''Check Zugriff 1: %1,%2,%3,%4,%5,%6'',v_prot_id,''Info'',''102/0 dynamic action check_zugriff'',:fas_schema_id,:FAS_LOGIN_PERSONENSTAMM_ID,:FAS_IDENTITAET_PERSSTAMM_ID,:APP_ID,:APP_PAGE_ID,:FAS_AUFGERUFEN_VON);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Gibt es spezielle Zugriffsdefinitionen?'||unistr('\000a')||
'   SELECT count(*) INTO v_anz'||unistr('\000a')||
'   FROM fas_app_menus'||unistr('\000a')||
'   WHERE satz_kennzeichen is null'||unistr('\000a')||
'     AND app_id = :APP_ID'||unistr('\000a')||
'     AND page_id = :APP_PAGE_ID;'||unistr('\000a')||
'   IF v_anz = 0 THEN -- Keine speziellen Berechtigungen definiert => Zugriff möglich, falls Betreuerzugang'||unistr('\000a')||
'      IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'         RETURN TRUE;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         RETURN FALSE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Check spezieller Zugriff'||unistr('\000a')||
'   IF frgbg_t.CHECK_FAS_APP_ZUGRIFF(:FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                                    :FAS_IDENTITAET_PERSSTAMM_ID,:APP_ID,:APP_PAGE_ID) >= 1 '||unistr('\000a')||
'   THEN  -- Zugriff erlaubt'||unistr('\000a')||
'      return TRUE;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      return FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--mel.p(''Check Zugriff 2: %1,%2,%3,%4,%5,%6'',v_prot_id,''Info'',''102/authorization check_page_access'',:fas_schema_id,:FAS_LOGIN_PERSONENSTAMM_ID,:FAS_IDENTITAET_PERSSTAMM_ID,:APP_ID,:APP_PAGE_ID,:FAS_AUFGERUFEN_VON);'||unistr('\000a')||
''||unistr('\000a')||
'END;'
 ,p_error_message => '&FAS_ZUGRIFF_TEXT.'
 ,p_caching => 'BY_USER_BY_PAGE_VIEW'
  );
 
end;
/

--application/shared_components/navigation/navigation_bar
prompt  ...navigation bar entries
--
 
begin
 
wwv_flow_api.create_icon_bar_item(
  p_id => 9238720490989214 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_icon_sequence=> 10,
  p_icon_image => '',
  p_icon_subtext=> '&FAS_ABMELDEN_TEXT.',
  p_icon_target=> 'f?p=&APP_ID.:999:&SESSION.::&DEBUG.::P999_LOGIN_PAGE:&FAS_LOGIN_PAGE.:',
  p_icon_image_alt=> '',
  p_icon_height=> null,
  p_icon_width=> null,
  p_icon_height2=> null,
  p_icon_width2=> null,
  p_nav_entry_is_feedback_yn => 'N',
  p_icon_bar_disp_cond=> 'DECLARE'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'RETURN(FALSE); -- Zur Zeit über Menü gelöst'||unistr('\000a')||
'-- 102 Passwort ändern (popup)'||unistr('\000a')||
'-- 134 Logo laden (popup)'||unistr('\000a')||
'IF :APP_PAGE_ID not in (105,104,215,102,134,999) AND :FAS_AUFGERUFEN_VON != ''PIS'' THEN'||unistr('\000a')||
' --  MEL.P (''Navi true page_id:%1, aufruf:%2|'', v_prot_id,''ERROR'',''fas-navi'','||unistr('\000a')||
' --         :APP_PAGE_ID,:fas_AUFGERUFEN_VON);'||unistr('\000a')||
' -- 215: Popup-Drucken, 105 = Registrierung, 104 = Benutzer vergessen,102=Popup PW ändern'||unistr('\000a')||
'  RETURN(TRUE);'||unistr('\000a')||
'ELSE'||unistr('\000a')||
' --  MEL.P (''Navi false page_id:%1, aufruf:%2|'', v_prot_id,''ERROR'',''fas-navi'','||unistr('\000a')||
' --         :APP_PAGE_ID,:fas_AUFGERUFEN_VON);'||unistr('\000a')||
'  RETURN (FALSE);'||unistr('\000a')||
'END IF;'||unistr('\000a')||
'END;',
  p_icon_bar_disp_cond_type=> 'FUNCTION_BODY',
  p_begins_on_new_line=> 'NO',
  p_cell_colspan      => 1,
  p_onclick=> '',
  p_icon_bar_comment=> '');
 
 
end;
/

prompt  ...application processes
--
--application/shared_components/logic/application_processes/init_scrollregion_height
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_prot_id   NUMBER;'||unistr('\000a')||
'   v_user      personenstamm.user_account%TYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :FAS_SCROLLREGION_HEIGHT_MAX:= frgbg_s.get_pers_option(:APP_USER,4);'||unistr('\000a')||
'   IF :FAS_SCROLLREGION_HEIGHT_MAX IS NULL THEN'||unistr('\000a')||
'      :FAS_SCROLLREGION_HEIGHT_MAX := 500;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'/* MEL.P (''Scrollheigth!''||:FAS_SCROLLREGION_HEIGHT_MAX||'' (user=''||:APP_USER||'' USer:''||:P121_USERNAME||'')! [init_scrollregion,30]'', v_PROT';

p:=p||'_ID, ''ERROR'', ''init_scrollregion,30'');'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 12151422924614296 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'AFTER_AUTHENTICATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_scrollregion_height',
  p_process_sql_clob=> p,
  p_process_error_message=> 'Fehler beim Setzen der fas_scrollregion_height in Anwendungsprozess init_scrollregion_height!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/set_fas_texte
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_sprache_id NUMBER := v(''FAS_SPRACHE_ID'');  --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_sprache_id := v(''FAS_SPRACHE_ID''); '||unistr('\000a')||
'   :fas_abmelden_text := '||unistr('\000a')||
'        frgbg_s.holen_uebersetzung(174,v_sprache_id);'||unistr('\000a')||
'   :fas_keine_daten_text := '||unistr('\000a')||
'        frgbg_s.holen_uebersetzung(759,v_sprache_id);'||unistr('\000a')||
'   :FAS_AENDERUNGWARNUNG_TEXT :=  '||unistr('\000a')||
'        frgbg_s.holen_uebersetzung(3068,v_sprache_id);'||unistr('\000a')||
'   :FA';

p:=p||'S_LOESCHABFRAGE_TEXT := '||unistr('\000a')||
'        frgbg_s.holen_uebersetzung(2195,v_sprache_id);'||unistr('\000a')||
'   :FAS_ZUGRIFF_TEXT :=  '||unistr('\000a')||
'        frgbg_s.holen_uebersetzung(3110,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/checkbestelldatum
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_neue_zeile                  varchar2(10) := '' ''; '||unistr('\000a')||
'   v_bestelldatum                DATE;'||unistr('\000a')||
'   v_plandatum                   DATE;'||unistr('\000a')||
'   v_anz_tage                    NUMBER:= 15;'||unistr('\000a')||
'   v_sprache_id                  number := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'   v_fehlertext                  VARCHAR2(4000)  := NULL;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P (''Datum = %1,%2,%3'', v_PROT_ID, ''ERROR'', ''';

p:=p||'CheckBestelldatum'','||unistr('\000a')||
'--          :P215_BESTELLDATUM,:P215_PLANDATUM);'||unistr('\000a')||
''||unistr('\000a')||
'   IF trim(:P215_BESTELLDATUM)IS NOT NULL  THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT to_number(parameter) into v_anz_tage'||unistr('\000a')||
'         FROM sysareas_frgbg'||unistr('\000a')||
'         WHERE id = 34;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         v_anz_tage := 15;'||unistr('\000a')||
'      END;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Check Eingabe ist Datum'||unistr('\000a')||
'      BEGIN '||unistr('\000a')||
'              '||unistr('\000a')||
'         v_bestelldatum :';

p:=p||'= to_date(trim(:P215_BESTELLDATUM),'||unistr('\000a')||
'                                   ''DD.MM.RRRR'');'||unistr('\000a')||
'         v_plandatum    := to_date(trim(:P215_PLANDATUM),'||unistr('\000a')||
'                                   ''DD.MM.RRRR'');'||unistr('\000a')||
'--MEL.P (''Nach konvert Datum = %1,%2,%3'', v_PROT_ID, ''ERROR'','||unistr('\000a')||
'--       ''CheckBestelldatum'',v_bestelldatum ,v_plandatum);'||unistr('\000a')||
''||unistr('\000a')||
'         IF v_plandatum - v_bestelldatum <= v_anz_tage THEN'||unistr('\000a')||
'            v_fehlertext';

p:=p||' := v_fehlertext || v_neue_zeile||'||unistr('\000a')||
'                   frgbg_s.holen_uebersetzung(3084,v_sprache_id,v_anz_tage,:P215_BESTELLDATUM);'||unistr('\000a')||
'         END IF; -- im Wertebereich ?'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         --o_fehler :=''Kann nicht in eine Zahl konvertiert werden.''; '||unistr('\000a')||
'         /*v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                   frgbg_s.holen_uebersetzung(1792,v_sprache_id,'||unistr('\000a')||
'';

p:=p||'                        v_plandatum); '||unistr('\000a')||
'         */'||unistr('\000a')||
'         -- Falsches Datumsformat wird in der nachfolgenden Validierung erkannt'||unistr('\000a')||
'         -- => keine Reaktion zu diesem Zeitpunkt'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   END IF; -- Wert eingegeben?  '||unistr('\000a')||
''||unistr('\000a')||
'   htp.prn(v_fehlertext);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   MEL.P (''Fehler bei Bestelldatumsprüfung:''||SQLERRM, v_PROT_ID, ''ERROR'', ''CheckBestelldatum'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 2188418706693514 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'checkBestelldatum',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/fill_item_from_item
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'v_anzeige varchar2(5);'||unistr('\000a')||
''||unistr('\000a')||
'begin'||unistr('\000a')||
'select decode(checkbox,''Y'',''ja'',''nein'') into v_anzeige from dual; htp.prn(v_anzeige);'||unistr('\000a')||
'end;';

wwv_flow_api.create_flow_process(
  p_id => 2350705862353429 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fill_item_from_item',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/init_fas_session
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprachcode app_sprachen.sprachcode%TYPE;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT s.sprachcode into v_sprachcode'||unistr('\000a')||
'   FROM app_sprachen s, personenstamm p'||unistr('\000a')||
'   WHERE s.id = p.app_sprache_id'||unistr('\000a')||
'     AND p.id = :fas_login_personenstamm_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Für die Zahlennotation ,. (Dezimaltrenner)'||unistr('\000a')||
'   :FSP_LANGUAGE_PREFERENCE := v_sprachcode;'||unistr('\000a')||
'--MEL.P (''nachher Sprachcode = %1,%2,%3'', v_PROT_ID, ''Info'', ''';

p:=p||'init_fas_session'',v_sprachcode,:fas_login_personenstamm_id,:FSP_LANGUAGE_PREFERENCE);'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   :FSP_LANGUAGE_PREFERENCE  := ''de-ch'';'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 2887904124092079 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_fas_session',
  p_process_sql_clob=> p,
  p_process_error_message=> 'Sprachcode konnte nicht ermittelt werden!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/get_next_fb_tab_page_id
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_next_page_id  NUMBER;'||unistr('\000a')||
'   v_gefunden      NUMBER := 0;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''1 Page:%1,nxt:%2'',v_prot_id,''TEST'',''102/on_demand:get_next_fb_tab_page_id'',:APP_PAGE_ID,:p1_next_page_id);'||unistr('\000a')||
'   v_next_page_id := :APP_PAGE_ID+1;'||unistr('\000a')||
'   v_gefunden := 0;'||unistr('\000a')||
'   WHILE v_gefunden=0 LOOP'||unistr('\000a')||
'      IF v_next_page_id > 10 AND v_next_page_id < 31 THEN -- Lab-Tab-Uebergang '||unistr('\000a')||
'         v_next_page';

p:=p||'_id := 31;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF  v_next_page_id >=1 AND v_next_page_id <= 10 THEN  -- Std-Tabs-Check'||unistr('\000a')||
'         IF  frgbg_s.check_tab_anzeigen (:P1_PERGEBNIS_ID,v(''P1_TAB''||v_next_page_id ||''_KATEGORIE_ID'')) THEN'||unistr('\000a')||
'              v_gefunden := 1;'||unistr('\000a')||
'         ELSE -- nächste Seite prüfen'||unistr('\000a')||
'              v_next_page_id := v_next_page_id + 1;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSIF v_next_page_id >= 31 AND v_next_page_';

p:=p||'id <= 35 THEN  -- Lab-Tabs-Check'||unistr('\000a')||
'         IF  frgbg_s.check_tab_anzeigen (:P1_PERGEBNIS_ID,v(''P31_TAB''||v_next_page_id ||''_KATEGORIE_ID'')) THEN'||unistr('\000a')||
'              v_gefunden := 1;'||unistr('\000a')||
'         ELSE -- nächste Seite prüfen'||unistr('\000a')||
'              v_next_page_id := v_next_page_id + 1;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSE  -- unbekanntes Check Intervall oder bisher nichts gefunden'||unistr('\000a')||
'         v_next_page_id := 95;'||unistr('\000a')||
'         v_gefun';

p:=p||'den := 1;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_next_page_id := v_next_page_id; '||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'alter version'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_next_fb_tab_page_id',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/get_ort
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'   declare  '||unistr('\000a')||
'     l_counter number;  '||unistr('\000a')||
'     l_o_name  varchar2(2000);  '||unistr('\000a')||
'   begin  '||unistr('\000a')||
'       owa_util.mime_header(''text/xml'', FALSE );  '||unistr('\000a')||
'       htp.p(''Cache-Control: no-cache'');  '||unistr('\000a')||
'       htp.p(''Pragma: no-cache'');  '||unistr('\000a')||
'       owa_util.http_header_close;  '||unistr('\000a')||
'       htp.prn(''<select>'');  '||unistr('\000a')||
'       for rec in (select '||unistr('\000a')||
''||unistr('\000a')||
'             "RANDOMDATA"."CATEGORY" as "CATEGORY",  '||unistr('\000a')||
'             "RANDOMDATA"."NAME" as "NA';

p:=p||'ME",  '||unistr('\000a')||
'             "RANDOMDATA"."ID" as "ID"   '||unistr('\000a')||
'          from "RANDOMDATA" "RANDOMDATA"  '||unistr('\000a')||
'          where "RANDOMDATA"."CATEGORY" = :TEMPORARY_ITEM)  '||unistr('\000a')||
'       loop  '||unistr('\000a')||
'         htp.prn(''<option value="'' || rec.id || ''">'' || rec.name || ''</option>'');  '||unistr('\000a')||
'       end loop;  '||unistr('\000a')||
'       htp.prn(''</select>'');   '||unistr('\000a')||
'   end;  ';

wwv_flow_api.create_flow_process(
  p_id => 4058127780787907 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_ort',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/getlanguage
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'/* wird zur Zeit nicht mehr benutzt'||unistr('\000a')||
'declare'||unistr('\000a')||
' v_language varchar2(5);'||unistr('\000a')||
'begin'||unistr('\000a')||
' select to_char(sprache_id) into v_language from app_sprachen '||unistr('\000a')||
' where id = :P1_APP_SPRACHE_ID;'||unistr('\000a')||
' htp.prn(v_language);'||unistr('\000a')||
'end;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'In Seiten Header :'||unistr('\000a')||
'<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_getlanguage()'||unistr('\000a')||
'{ '||unistr('\000a')||
'  var get = new htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=getlanguage'',0);'||unistr('\000a')||
'  get.add(''';

p:=p||'P132_APP_SPRACHE_ID'',html_GetElement(''P132_APP_SPRACHE_ID'').value);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  html_GetElement(''P132_SPRACHE_ID'').value = gReturn  }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  html_GetElement(''P132_SPRACHE_ID'').value = ''null''  }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'*/';

wwv_flow_api.create_flow_process(
  p_id => 4319825676381429 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'getlanguage',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/download_doc
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'  #OWNER#.download_doc('||unistr('\000a')||
'    i_doc_id =>      :FAS_DATEI_ID'||unistr('\000a')||
'    --,p_display => false'||unistr('\000a')||
'  );'||unistr('\000a')||
'end;';

wwv_flow_api.create_flow_process(
  p_id => 4652203075760556 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'download_doc',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/checklaborwerte
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_neue_zeile           varchar2(10) := '' ''; '||unistr('\000a')||
'   v_max_wert             NUMBER;'||unistr('\000a')||
'   v_min_wert             NUMBER;'||unistr('\000a')||
'   v_verarb_bezug_einheit_id    NUMBER;'||unistr('\000a')||
'   v_frage_text                 uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_wert_input                 varchar2(2000);'||unistr('\000a')||
'   v_zahl                        NUMBER;'||unistr('\000a')||
'   v_min                         NUMBER;'||unistr('\000a')||
'   v_max                         NUMBER;'||unistr('\000a')||
'   v_fo';

p:=p||'rmatmask_1                fantworten.formatmask_1%TYPE;'||unistr('\000a')||
'   v_inhstoff_id                 fragen.inhstoff_id%TYPE;'||unistr('\000a')||
'   v_sprache_id                  number := :fas_sprache_id;'||unistr('\000a')||
'   v_fehlertext                  VARCHAR2(4000)  := NULL;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P (''0 Menge = %1,%2,%3'', v_PROT_ID, ''ERROR'', ''CheckLaborWerte'', :P31_WERT_INPUT,:P31_ID_INPUT,:P31_EINHEIT_ID_INPUT);'||unistr('\000a')||
''||unistr('\000a')||
'   v_wert_input ';

p:=p||':= trim(:P31_WERT_INPUT);'||unistr('\000a')||
'   IF v_wert_input IS NOT NULL  THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         --NEI 21.04.10 Prüfung gegen fantwort-Tabelle'||unistr('\000a')||
'/* '||unistr('\000a')||
'        SELECT fa.max_wert, fa.min_wert,'||unistr('\000a')||
'                f.bezug_einheit_id, f.frage_text,fa.formatmask_1,inhstoff_id'||unistr('\000a')||
'         INTO v_max_wert,v_min_wert,'||unistr('\000a')||
'              v_verarb_bezug_einheit_id,v_frage_text,v_formatmask_1,'||unistr('\000a')||
'              v_inhstoff_id'||unistr('\000a')||
'         FROM ';

p:=p||'fantworten fa, v_fragen f'||unistr('\000a')||
'         WHERE f.frage_id = :P31_id_input'||unistr('\000a')||
'           AND f.frage_id = fa.frage_id'||unistr('\000a')||
'           AND rownum <= 1;-- Es darf zu einem Textfeld auch nur eine Antwort geben'||unistr('\000a')||
'*/'||unistr('\000a')||
'         SELECT fa.max_wert, fa.min_wert,'||unistr('\000a')||
'                f.bezug_einheit_id, frgbg_s.holen_uebersetzung(f.text_id_fragetext,v_sprache_id),fa.formatmask,inhstoff_id'||unistr('\000a')||
'         INTO v_max_wert,v_min_wert,'||unistr('\000a')||
'   ';

p:=p||'           v_verarb_bezug_einheit_id,v_frage_text,v_formatmask_1,'||unistr('\000a')||
'              v_inhstoff_id'||unistr('\000a')||
'         FROM fantworten fa, fragen f'||unistr('\000a')||
'         WHERE f.id = :P31_id_input'||unistr('\000a')||
'           AND f.id = fa.frage_id'||unistr('\000a')||
'           AND rownum <= 1;-- Es darf zu einem Textfeld auch nur eine Antwort geben'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         --o_fehler :=''Kann nicht in eine Zahl konvertiert werden.''; '||unistr('\000a')||
'     ';

p:=p||'    v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(551,v_sprache_id,'||unistr('\000a')||
'                           v_wert_input,v_frage_text)||SQLERRM; '||unistr('\000a')||
'      END;'||unistr('\000a')||
' '||unistr('\000a')||
'      -- Check Eingabe ist Zahl'||unistr('\000a')||
'      v_zahl := NULL;'||unistr('\000a')||
'      v_zahl := rezepte.convert_to_number(v_wert_input,'||unistr('\000a')||
'                                            ''999G999G999D99999'');'||unistr('\000a')||
'      IF v_zahl is NULL THEN'||unistr('\000a')||
'';

p:=p||'         v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                   frgbg_s.holen_uebersetzung(551,v_sprache_id,'||unistr('\000a')||
'                        v_wert_input,v_frage_text);  '||unistr('\000a')||
'      ELSIF v_zahl is not null AND '||unistr('\000a')||
'            v_max_wert is not null AND v_min_wert is not null '||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         -- Eingabezahl formatieren'||unistr('\000a')||
'--MEL.P (''Menge = %1,%2,%3'', v_PROT_ID, ''ERROR'', ''CheckLaborWerte'',v_formatmask_1';

p:=p||',v_zahl,:P31_EINHEIT_ID_INPUT);'||unistr('\000a')||
'         v_zahl := frgbg_s.fb_format_fant_wert(v_zahl,v_formatmask_1,2);'||unistr('\000a')||
'--MEL.P (''1 Menge = %1,%2,%3'', v_PROT_ID, ''ERROR'', ''CheckLaborWerte'',v_formatmask_1,v_zahl,:P31_EINHEIT_ID_INPUT);'||unistr('\000a')||
'         -- Wertebereichsprüfung'||unistr('\000a')||
'         v_max := rezepte.umrechnen_inh_bez_eh'||unistr('\000a')||
'              (v_max_wert,v_inhstoff_id,         '||unistr('\000a')||
'               v_verarb_bezug_einheit_id,:P31_EINH';

p:=p||'EIT_ID_INPUT);'||unistr('\000a')||
'         v_min := rezepte.umrechnen_inh_bez_eh'||unistr('\000a')||
'              (v_min_wert,v_inhstoff_id,         '||unistr('\000a')||
'               v_verarb_bezug_einheit_id,:P31_EINHEIT_ID_INPUT);'||unistr('\000a')||
'--MEL.P(''2 MIN/MAX Menge = %1,%2,%3'', v_PROT_ID, ''ERROR'', ''CheckLaborWerte'',:P31_wert_INPUT,v_min,v_max);'||unistr('\000a')||
''||unistr('\000a')||
'         IF v_zahl > v_max OR'||unistr('\000a')||
'            v_zahl < v_min'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            v_fehlertext := v_fehlertext || v';

p:=p||'_neue_zeile||'||unistr('\000a')||
'                   frgbg_s.holen_uebersetzung(550,v_sprache_id,'||unistr('\000a')||
'                      v_wert_input,'||unistr('\000a')||
'                      v_frage_text,'||unistr('\000a')||
'                      trim(to_char(v_min,''FM999G999G990D0999'')),'||unistr('\000a')||
'                      trim(to_char(v_max,''FM999G999G990D0999''))'||unistr('\000a')||
'                          );'||unistr('\000a')||
'         END IF; -- im Wertebereich ?'||unistr('\000a')||
'      END IF; -- Zahl?'||unistr('\000a')||
''||unistr('\000a')||
'   END IF; -- Wert eingegeben?';

p:=p||'  '||unistr('\000a')||
'   htp.prn(v_fehlertext);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   MEL.P (''Fehler =''||SQLERRM, v_PROT_ID, ''ERROR'', ''CheckLaborWerte'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 4844113825056465 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'checkLaborWerte',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/checkmessdatum
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id     number := v(''FAS_SPRACHE_ID'');'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_datum          date; '||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'mel.p(''checkdatum a %1,%2'',v_prot_id,''test'',''checkdatum'',v_fehlertext,:p31_datum);'||unistr('\000a')||
'   BEGIN '||unistr('\000a')||
'      v_datum  := to_date(trim(:p31_datum),''DD.MM.YYYY hh24:mi'');'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN'||unistr('\000a')||
'      v_fehlertext :=   '||unistr('\000a')||
'            frgbg_s.holen_u';

p:=p||'ebersetzung(3601,v_sprache_id,'||unistr('\000a')||
'            :p31_datum,:p31_frage_text);'||unistr('\000a')||
'   END ;'||unistr('\000a')||
'mel.p(''checkdatum %1,%2'',v_prot_id,''test'',''checkdatum'',v_fehlertext,:p31_datum);'||unistr('\000a')||
'   htp.prn(v_fehlertext);'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 4965126373354331 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'checkMessdatum',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/checkbestelldatumneu
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_neue_zeile                  varchar2(10) := '' ''; '||unistr('\000a')||
'   v_bestelldatum                DATE;'||unistr('\000a')||
'   v_plandatum                   DATE;'||unistr('\000a')||
'   v_anz_tage                    number:= 15;'||unistr('\000a')||
'   v_sprache_id                  number := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'   v_fehlertext                  VARCHAR2(4000)  := NULL;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P (''Datum = %1,%2,%3'', v_PROT_ID, ''ERROR'', ''';

p:=p||'CheckBestelldatum'','||unistr('\000a')||
'--          :P215_BESTELLDATUM,:P215_PLANDATUM);'||unistr('\000a')||
''||unistr('\000a')||
'   IF trim(:TEMP_BESTELLDATUM)IS NOT NULL  THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT to_number(parameter) into v_anz_tage'||unistr('\000a')||
'         FROM sysareas_frgbg'||unistr('\000a')||
'         WHERE id = 34;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         v_anz_tage := 15;'||unistr('\000a')||
'      END;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Check Eingabe ist Datum'||unistr('\000a')||
'      BEGIN '||unistr('\000a')||
'              '||unistr('\000a')||
'         v_bestelldatum :';

p:=p||'= to_date(trim(:TEMP_BESTELLDATUM),'||unistr('\000a')||
'                                   ''DD.MM.RRRR'');'||unistr('\000a')||
'         v_plandatum    := to_date(trim(:TEMP_PLANDATUM),'||unistr('\000a')||
'                                   ''DD.MM.RRRR'');'||unistr('\000a')||
'--MEL.P (''Nach konvert Datum = %1,%2,%3'', v_PROT_ID, ''ERROR'','||unistr('\000a')||
'--       ''CheckBestelldatum'',v_bestelldatum ,v_plandatum);'||unistr('\000a')||
''||unistr('\000a')||
'         IF v_plandatum - v_bestelldatum <= v_anz_tage  THEN'||unistr('\000a')||
'            v_fehlertex';

p:=p||'t := v_fehlertext || v_neue_zeile||'||unistr('\000a')||
'                   frgbg_s.holen_uebersetzung(3084,v_sprache_id,v_anz_tage ,:TEMP_BESTELLDATUM);'||unistr('\000a')||
'         END IF; -- im Wertebereich ?'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         --o_fehler :=''Kann nicht in eine Zahl konvertiert werden.''; '||unistr('\000a')||
'         /*v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                   frgbg_s.holen_uebersetzung(1792,v_sprache_id';

p:=p||','||unistr('\000a')||
'                        v_plandatum); '||unistr('\000a')||
'         */'||unistr('\000a')||
'         -- Falsches Datumsformat wird in der nachfolgenden Validierung erkannt'||unistr('\000a')||
'         -- => keine Reaktion zu diesem Zeitpunkt'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   END IF; -- Wert eingegeben?  '||unistr('\000a')||
''||unistr('\000a')||
'   htp.prn(v_fehlertext);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   MEL.P (''Fehler bei Bestelldatumsprüfung:''||SQLERRM, v_PROT_ID, ''ERROR'', ''CheckBestelldatumNeu'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 5564901375570713 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'checkBestelldatumNeu',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/gettextbeschreibunghtml
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'   FRGBG_T.A102_AP_GET_TEXT_BESCHR_HTML('||unistr('\000a')||
'        p_text_id => to_number(:P150_TEXT_ID)'||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_flow_process(
  p_id => 6916408895497451 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'GetTextBeschreibungHTML',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/gettextuebhtml
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'  FRGBG_T.A102_AP_GET_TEXT_UEB_HTML('||unistr('\000a')||
'        p_ueb_id => :P150_UEB_ID'||unistr('\000a')||
'  );'||unistr('\000a')||
'end;';

wwv_flow_api.create_flow_process(
  p_id => 6924710607043698 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'GetTextUebHTML',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/checkmnrdetails
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_mn_menge_tag_max            NUMBER;'||unistr('\000a')||
'   v_mn_menge_tag_min            NUMBER;'||unistr('\000a')||
'   v_mn_einheit_id_tag_max       NUMBER;'||unistr('\000a')||
'   v_mn_einheit_id_tag_min       NUMBER;'||unistr('\000a')||
'   v_bezeichnung                 varchar2(100);'||unistr('\000a')||
'   v_menge_input                 varchar2(2000);'||unistr('\000a')||
'   v_zahl                        NUMBER;'||unistr('\000a')||
'   v_min                         NUMBER;'||unistr('\000a')||
'   v_max                         NUMBER;'||unistr('\000a')||
'   v_spr';

p:=p||'ache_id                  number := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'   v_fehlertext                  VARCHAR2(4000)  := NULL;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --FRGBG_JOBS.SLEEP(5000);'||unistr('\000a')||
'-- Liefert einen Fehlertext, die erste Stelle markiert die Gewichtigkeit '||unistr('\000a')||
'-- des Fehlers 1= Warnung, 2= Fehler'||unistr('\000a')||
''||unistr('\000a')||
'--MEL.P (''Menge = %1,%2,%3'', v_PROT_ID, ''ERROR'', ''CheckMnrDetails'','||unistr('\000a')||
'--            :P202_MENGE_INPUT,:P20';

p:=p||'2_ID_INPUT,:P202_EINHEIT_ID_INPUT);'||unistr('\000a')||
''||unistr('\000a')||
'--v_fehlertext:= ''Wert:''||NVL(:P202_MENGE_INPUT,-1)||'' id:''||:P202_ID_INPUT||'||unistr('\000a')||
'-- '' eh-id:''||:P202_EINHEIT_ID_INPUT;'||unistr('\000a')||
'   v_menge_input := trim(:P202_MENGE_INPUT);'||unistr('\000a')||
'   IF v_menge_input IS NOT NULL  THEN'||unistr('\000a')||
'      -- Check Eingabe ist Zahl'||unistr('\000a')||
'      v_zahl := NULL;'||unistr('\000a')||
'      v_zahl := rezepte.convert_to_number(v_menge_input,'||unistr('\000a')||
'                                            ''999G999G';

p:=p||'999D99999'');'||unistr('\000a')||
'      IF v_zahl is NULL THEN'||unistr('\000a')||
'         v_fehlertext := ''2''||frgbg_s.holen_uebersetzung(551,v_sprache_id,'||unistr('\000a')||
'                        v_menge_input,v_bezeichnung);  '||unistr('\000a')||
'      ELSIF v_zahl is not null AND v_zahl <> 0 THEN'||unistr('\000a')||
'         -- Prüfung Eingabe nur max. 1 Nachkommastelle'||unistr('\000a')||
'         IF trunc(v_zahl,1) != v_zahl THEN'||unistr('\000a')||
'            v_fehlertext := ''2''||frgbg_s.holen_uebersetzung(2150,v_sprache_id';

p:=p||','||unistr('\000a')||
'                        v_menge_input,v_bezeichnung);  '||unistr('\000a')||
'         ELSE '||unistr('\000a')||
'            v_fehlertext := rezepte.check_mnr_inhgrenzwert(:P201_mn_rezept_id,'||unistr('\000a')||
'                           :P202_id_input,'||unistr('\000a')||
'                           v_zahl,:P202_EINHEIT_ID_INPUT'||unistr('\000a')||
'                      );'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      '||unistr('\000a')||
'      END IF; -- Zahl?'||unistr('\000a')||
''||unistr('\000a')||
'   END IF; -- Wert eingegeben?  '||unistr('\000a')||
'   htp.prn(trim(v_fehlertext));'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'';

p:=p||'WHEN OTHERS THEN'||unistr('\000a')||
'   MEL.P (''Fehler bei Zugriff aufg_f04 =''||SQLERRM, v_PROT_ID, ''ERROR'', ''CheckMnrDetails'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 7106115549680607 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'checkMnrDetails',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/checkproddetails
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_neue_zeile                  varchar2(10) := '' ''; '||unistr('\000a')||
'   v_bezeichnung                 varchar2(100);'||unistr('\000a')||
'   v_zahl                        NUMBER;'||unistr('\000a')||
'   v_menge_input                 varchar2(2000);'||unistr('\000a')||
'   v_sprache_id                  number := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'   v_artikel_menge               mengenarts.menge%TYPE;'||unistr('\000a')||
'   v_artikel_einheit_id          mengenarts.menge_einheit_id%TYPE';

p:=p||';'||unistr('\000a')||
'   v_mingrenze_artikelgramm      NUMBER;'||unistr('\000a')||
'   v_mingrenze_artikelanzahl     NUMBER;'||unistr('\000a')||
'   v_anzahl2                     NUMBER;'||unistr('\000a')||
'   v_entnahmeart_id              mengenarts.entnahmeart_id%TYPE;'||unistr('\000a')||
'   v_fehlertext                  VARCHAR2(4000)  := NULL;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P (''Menge = %1,%2,%3'', v_PROT_ID, ''ERROR'', ''CheckMnrDetails'','||unistr('\000a')||
'--            :P202_MENGE_INPUT,:P202_ID_INPUT,:P202_EINH';

p:=p||'EIT_ID_INPUT);'||unistr('\000a')||
''||unistr('\000a')||
'--v_fehlertext:= ''Wert:''||:P202_MENGE_INPUT||'' id:''||:P202_ID_INPUT||'||unistr('\000a')||
'-- '' eh-id:''||:P202_EINHEIT_ID_INPUT;'||unistr('\000a')||
''||unistr('\000a')||
'NULL;'||unistr('\000a')||
'   v_menge_input := trim(:P202_MENGE_INPUT);'||unistr('\000a')||
'   IF v_menge_input IS NOT NULL  THEN      -- Check Eingabe ist Zahl'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT mart_kuerzel,mart_menge,mart_menge_einheit_id,entnahmeart_id'||unistr('\000a')||
'         INTO v_bezeichnung,v_artikel_menge, v_artikel_einheit_id,';

p:=p||' v_entnahmeart_id'||unistr('\000a')||
'         FROM v_prodr_details'||unistr('\000a')||
'         WHERE mart_id = :P202_id_input'||unistr('\000a')||
'           AND prodr_id = :p201_prod_rezept_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         --o_fehler :=''Kann nicht in eine Zahl konvertiert werden.''; '||unistr('\000a')||
'         v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(575,v_sprache_id,'||unistr('\000a')||
'                           v_meng';

p:=p||'e_input,v_bezeichnung); '||unistr('\000a')||
'      END;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Check Fehler'||unistr('\000a')||
'      IF v_fehlertext IS NULL THEN'||unistr('\000a')||
'         v_zahl := NULL;'||unistr('\000a')||
'         v_zahl := rezepte.convert_to_number(v_menge_input,'||unistr('\000a')||
'                                            ''999G999G999D99999'');'||unistr('\000a')||
'         IF v_zahl is NULL THEN'||unistr('\000a')||
'            v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                   frgbg_s.holen_uebersetzung(575,v_sprache_id,'||unistr('\000a')||
' ';

p:=p||'                       v_menge_input,v_bezeichnung);  '||unistr('\000a')||
'         END IF; -- Zahl?'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'      -- CHECK Warnungen z.B. Kleinstmengen'||unistr('\000a')||
'      IF v_fehlertext IS NULL THEN'||unistr('\000a')||
'         -- Prüfen auf Kleinstmengen fuer Hinweismeldung'||unistr('\000a')||
'         -- Kleinstartikelmengen: Falls die Artikelanzahl kleiner als diese Grenze ist, erfolgt Hinweismeldung'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT to_number(parameter,';

p:=p||'''9999999999.999999999999'')        -- Dezimaltrenner ist immer Punkt'||unistr('\000a')||
'            into v_mingrenze_artikelanzahl'||unistr('\000a')||
'            FROM  sysareas'||unistr('\000a')||
'            WHERE id = 10  ;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            v_mingrenze_artikelanzahl := to_number(''0.01'',''9.99'');   -- Defaultwert, falls Zugriff fehlschlaegt'||unistr('\000a')||
'         END ;'||unistr('\000a')||
'   '||unistr('\000a')||
'         -- Kleinstartikelmengen: Falls die Artikelmenge ';

p:=p||'in Gramm (mÂ¿gliche verwiegbare Menge) kleiner als diese Grenze ist, erfolgt Hinweismeldung'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT  to_number(parameter,''9999999999.999999999999'')       -- Dezimaltrenner ist immer Punkt'||unistr('\000a')||
'            into v_mingrenze_artikelgramm'||unistr('\000a')||
'            FROM  sysareas'||unistr('\000a')||
'            WHERE id = 11  ;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            v_mingrenze_artikelgramm := to_';

p:=p||'number(''0.1'',''9.9'');   -- Defaultwert, falls Zugriff fehlschlaegt'||unistr('\000a')||
'         END ;'||unistr('\000a')||
''||unistr('\000a')||
'         IF v_entnahmeart_id in (2,3)         THEN -- Stück-/Teilentnahme Stückeinheit => Anzahl liegt vor'||unistr('\000a')||
'            v_anzahl2 := v_zahl;'||unistr('\000a')||
'         ELSE  -- Bulkentnahme =>Gewichtseinheit'||unistr('\000a')||
'            v_anzahl2 := v_zahl/rezepte.UMRECHNEN_ARTIKEL_EH(v_artikel_menge,:P202_id_input,v_artikel_einheit_id, :P202_EINHEIT_I';

p:=p||'D_INPUT);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
''||unistr('\000a')||
'         IF v_anzahl2 < v_mingrenze_artikelanzahl THEN'||unistr('\000a')||
'            v_fehlertext := ''Kleinstmenge!''||NVL(v_anzahl2,0);'||unistr('\000a')||
'         ELSIF rezepte.UMRECHNEN_ARTIKEL_EH (v_zahl,:P202_id_input,v_artikel_einheit_id,500) < v_mingrenze_artikelgramm THEN'||unistr('\000a')||
'            v_fehlertext := ''Kleinstmenge!'';   '||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'*/      '||unistr('\000a')||
''||unistr('\000a')||
'   END IF; -- Wert eingegeben?  '||unistr('\000a')||
'   htp';

p:=p||'.prn(v_fehlertext);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   MEL.P (''Fehler bei Zugriff aufg_f24 =''||SQLERRM, v_PROT_ID, ''ERROR'', ''CheckProdDetails'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 7747913093428940 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'checkProdDetails',
  p_process_sql_clob=> p,
  p_process_error_message=> '  ',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/get_item_help
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'l_counter number;'||unistr('\000a')||
'l_help varchar2(4000);'||unistr('\000a')||
'v_prot_id   number;'||unistr('\000a')||
'--l_item_id varchar2(4000);'||unistr('\000a')||
'--l_page_id varchar2(4000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--l_item_id := wwv_flow.g_x01;'||unistr('\000a')||
'--l_page_id := wwv_flow.g_x02;'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'/*mel.p(''Hilfe zu App:%1, Page:%2, ITEM:%3'',v_prot_id,''INFO'',''get_item_help'',:APP_ID,:TEMPORARY_PAGE_ID,:TEMPORARY_ITEM );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'      SELECT text  INTO l_help --v_helptext'||unistr('\000a')||
'      FROM hilfen h, v_uebe';

p:=p||'rs_texte t'||unistr('\000a')||
'      WHERE h.text_id =  t.text_id'||unistr('\000a')||
'        AND sprache_id = frgbg_s.get_sprache_id(:APP_USER) --v_sprache_id'||unistr('\000a')||
'        AND h.app_id = :APP_ID'||unistr('\000a')||
'        AND h.page_id = :TEMPORARY_PAGE_ID --l_page_id --:TEMPORARY_PAGE_ID --'||unistr('\000a')||
'        AND h.item_id = :TEMPORARY_ITEM --l_item_id --:TEMPORARY_ITEM --'||unistr('\000a')||
'       ;'||unistr('\000a')||
'/*mel.p(''Hilfe zu App:%1, Page:%2, ITEM:%3, Hilfe:%4'',v_prot_id,''INFO'',''get_item_help'',:';

p:=p||'APP_ID,:TEMPORARY_PAGE_ID,:TEMPORARY_ITEM ,l_help);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'mel.p(''Hilfe zu App:%1, Page:%2, ITEM:%3, Hilfe:%4, %5'',v_prot_id,''INFO'',''get_item_help'',:APP_ID,:TEMPORARY_PAGE_ID,:TEMPORARY_ITEM ,l_help,SQLERRM);'||unistr('\000a')||
'      l_help := null; --v_helptext := NULL;'||unistr('\000a')||
''||unistr('\000a')||
'   END;'||unistr('\000a')||
'/*'||unistr('\000a')||
'select ITEM_HELP_TEXT'||unistr('\000a')||
'into l_help'||unistr('\000a')||
'from APEX_APPLICATION_PAGE_ITEMS'||unistr('\000a')||
'where APPLICATION_ID = &APP_ID.'||unistr('\000a')||
'and PA';

p:=p||'GE_ID = l_page_id'||unistr('\000a')||
'and ITEM_ID = l_item_id;'||unistr('\000a')||
'*/'||unistr('\000a')||
'htp.prn(''<div>'');'||unistr('\000a')||
'htp.prn(l_help);'||unistr('\000a')||
'htp.prn(''</div>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 7984531420608740 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_item_help',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

--application/shared_components/logic/application_processes/checknormbereich
 
begin
 
declare
    p varchar2(32767) := null;
    l_clob clob;
    l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_neue_zeile           varchar2(10) := '' ''; '||unistr('\000a')||
'   v_frage_text                 uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_wert_input                 varchar2(2000);'||unistr('\000a')||
'   v_normbereich               varchar2(2000);'||unistr('\000a')||
'   v_sprache_id                  number := :fas_sprache_id;'||unistr('\000a')||
'   v_fehlertext                  VARCHAR2(4000)  := NULL;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'   v_ist_fr_laborbereich        number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.';

p:=p||'P (''0 Normbereich = %1,%2'', v_PROT_ID, ''ERROR'', ''checkNormbereich'', :P31_NORMBEREICH,:P31_ID_INPUT);'||unistr('\000a')||
''||unistr('\000a')||
'   v_normbereich := trim(:P31_NORMBEREICH);'||unistr('\000a')||
'   v_wert_input := trim(:P31_WERT_INPUT);'||unistr('\000a')||
''||unistr('\000a')||
'   if :P31_ID_INPUT is not null then'||unistr('\000a')||
'    begin'||unistr('\000a')||
'     select frgbg_s.holen_uebersetzung(fr.TEXT_ID_FRAGETEXT,v_sprache_id)'||unistr('\000a')||
'          ,CASE WHEN (select max(NORMIERUNGSTYP)'||unistr('\000a')||
'                    FROM FANTWORTEN'||unistr('\000a')||
'     ';

p:=p||'               where frage_id = fr.ID and satz_kennzeichen is null) = ''LABORBEREICH'''||unistr('\000a')||
'              THEN 1 ELSE 0 END'||unistr('\000a')||
'     into v_frage_text, v_ist_fr_laborbereich'||unistr('\000a')||
'     from fragen fr'||unistr('\000a')||
'     where to_char(id) = replace(:P31_ID_INPUT,''NORMB'','''');'||unistr('\000a')||
'    exception'||unistr('\000a')||
'      when others then'||unistr('\000a')||
'        raise_application_error(-20000,''Fehler beim Abruf des Fragetextes ID:''   || :P31_ID_INPUT || '' SQLERRM:'' || sqle';

p:=p||'rrm);'||unistr('\000a')||
'    end;'||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_normbereich IS NOT NULL  THEN'||unistr('\000a')||
'        --SAL 09.05.2014 Prüfe ob es ein gültiger Laborbereich ist'||unistr('\000a')||
'        IF FRGBG_T.LAB_IST_NORMBER_SYNTAX_GUELTIG(v_normbereich) = 0 THEN'||unistr('\000a')||
'             --Der Normbereich des Laborwertes %0 ist ungültig. Es darf nur ein personen spezifischer Normbereich eingegeben werden '||unistr('\000a')||
'             v_fehlertext := frgbg_s.HOLEN_UEBERSETZUNG(10018';

p:=p||',v_SPRACHE_ID, v_frage_text);'||unistr('\000a')||
'        end if;'||unistr('\000a')||
'   ELSIF v_wert_input is not null and  v_ist_fr_laborbereich = 1 then'||unistr('\000a')||
'     -- Wenn ein Wert angegeben wurde, muss auch ein Normbereich angegeben werden'||unistr('\000a')||
'     -- Sofern es sich um den Normierungstyp LABORBEREICH handelt'||unistr('\000a')||
'     v_fehlertext := frgbg_s.HOLEN_UEBERSETZUNG(10019,v_SPRACHE_ID, v_frage_text);'||unistr('\000a')||
''||unistr('\000a')||
'   END IF; -- Wert eingegeben?  '||unistr('\000a')||
''||unistr('\000a')||
'   htp.prn(v_fehle';

p:=p||'rtext);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   MEL.P (''Fehler =''||SQLERRM, v_PROT_ID, ''ERROR'', ''checkNormbereich'');'||unistr('\000a')||
'   htp.prn(SQLERRM);'||unistr('\000a')||
'END;';

wwv_flow_api.create_flow_process(
  p_id => 8539708770455208 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_process_sequence=> 1,
  p_process_point => 'ON_DEMAND',
  p_process_type=> 'PLSQL',
  p_process_name=> 'checkNormbereich',
  p_process_sql_clob=> p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=> '',
  p_process_when_type=> '',
  p_process_comment=> '');
end;
 
null;
 
end;
/

prompt  ...application items
--
--application/shared_components/logic/application_items/fas_abmelden_text
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 9025203664961837 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_ABMELDEN_TEXT'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
 ,p_item_comment => 'Element wird in den Login-Pages direkt beim Anmelden gesetzt oder bei Persmasken'||unistr('\000a')||
''
  );
 
end;
/

--application/shared_components/logic/application_items/fas_aenderungwarnung_text
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 5467725837048512 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_AENDERUNGWARNUNG_TEXT'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_aufgerufen_von
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 8991421627188085 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_AUFGERUFEN_VON'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'I'
 ,p_item_comment => 'Element wird in den Login-Pages direkt beim Anmelden gesetzt'||unistr('\000a')||
'101 auf ''KUNDE'' bzw. ''ANONYM'''||unistr('\000a')||
'120 auf ''PIS'''||unistr('\000a')||
'121 auf ''BETREUER'' bzw. ''IDENTITAET'''||unistr('\000a')||
'122 auf ''UEBERSETZER'''||unistr('\000a')||
'123 auf ''ANONYM'''||unistr('\000a')||
'124 auf ''KUNDE'''
  );
 
end;
/

--application/shared_components/logic/application_items/fas_datei_id
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 4654231041137634 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_DATEI_ID'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_identitaet
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 2530001406180781 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_IDENTITAET'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'I'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_identitaet_persstamm_id
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 2530510288249585 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_IDENTITAET_PERSSTAMM_ID'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'I'
 ,p_item_comment => 'aktive Identität'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_infozeile
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 5792924212108315 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_INFOZEILE'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
 ,p_item_comment => 'Ergänzung für die Infozeile entsprechend der Def. im Schema'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_keine_daten_text
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 10761814007783775 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_KEINE_DATEN_TEXT'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
 ,p_item_comment => 'Element wird in den Login-Pages direkt beim Anmelden gesetzt oder bei Persmasken'||unistr('\000a')||
''
  );
 
end;
/

--application/shared_components/logic/application_items/fas_loeschabfrage_text
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 2172800397491973 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_LOESCHABFRAGE_TEXT'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_login_page
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 9015814952879970 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_LOGIN_PAGE'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'I'
 ,p_item_comment => 'wird in den Login-Masken direkt beim Anmelden gesetzt'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_login_personenstamm_id
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 3744329047911043 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_LOGIN_PERSONENSTAMM_ID'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'I'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_modus_id
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 4074624205562078 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_MODUS_ID'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
 ,p_item_comment => 'FAS-Modus der DEFAULT-Identität des eingeloggten Betreuers abgeleitet aus dem Optionstyp = 27 (0= normaler Fas-Modus, 1= IABC-Modus,2= eoVital)'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_pers_aenderbar
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 4811805750286996 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_PERS_AENDERBAR'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'I'
 ,p_item_comment => 'Legt fest, ob die Daten zu dieser Person geändert werden dürfen.'||unistr('\000a')||
'Falls das Flag personenstamm.aenderbar = N steht und die Rolle "GESCHUETZTE_PERSONENDATEN_AENDERN" nicht gesetzt dürfen die Daten zu dieser Person (Stammdaten, Rezepte etc.) nicht geändert bzw. erweitert werden.'||unistr('\000a')||
'Dieses Flag wird in der Seite P110 gesetzt'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_pers_schema_id
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 2944402084032776 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_PERS_SCHEMA_ID'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
 ,p_item_comment => 'Schema_id des Kunden; wird ermittelt in Page 110 aus der bevorzugt betreuenden Identitaet des Kunden. Mit diesem Schema wird der Sprachset im Personenstamm eingegrenzt und nicht mit der aktuellen Schema-ID des Betreuers, da dieser theoretisch von einem anderen Schema kommen kann (z.B. wenn Fr. Peter für die Biogena arbeitet). '
  );
 
end;
/

--application/shared_components/logic/application_items/fas_schema_id
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 2736211515442207 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_SCHEMA_ID'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
 ,p_item_comment => 'Schema-Id der eingeloggten Person (Betreuers). Daran hängt die Anzeigesprache und das Anzeige-Theme'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_scrollregion_height_max
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 12150131319597825 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_SCROLLREGION_HEIGHT_MAX'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_sortiment_id
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 2996322999737053 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_SORTIMENT_ID'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'I'
 ,p_item_comment => 'Die aktive Identitaet bestimmt über die Identitaetenhierarchie das nächste vorhandene Sortiment über (pers_identitaet_props). Hieraus leiten sich die Preise ab.'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_sprache_id
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 9316018569975059 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_SPRACHE_ID'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'I'
 ,p_item_comment => 'Anzeigesprache (sprache_id) für FAS abhängig vom eingeloggten Benutzer, d.h. entweder die Betreuer-Sprache beim Betreuer-Login oder sonst ist es die Patientensprache.'||unistr('\000a')||
'Wird gesetzt bei allen Login-Masken und bei den Patientenstamm-Masken 1 und 110, da dort die Sprache geändert werden kann.'
  );
 
end;
/

--application/shared_components/logic/application_items/fas_theme_name
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 6305427699722843 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_THEME_NAME'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
 ,p_item_comment => 'fas_theme plus fas_schema_id '||unistr('\000a')||
'=> i/themes/fas_theme_1 => Hepart'||unistr('\000a')||
'=> i/themes/fas_theme_2 => Biogena'||unistr('\000a')||
'=> i/themes/fas_theme_3 => IABC'||unistr('\000a')||
'=> i/themes/fas_theme_4 => Eovital-Order'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''
  );
 
end;
/

--application/shared_components/logic/application_items/fas_zugriff_text
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 3889402272095431 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FAS_ZUGRIFF_TEXT'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
 ,p_item_comment => 'Element wird in den Login-Pages direkt beim Anmelden gesetzt oder bei Persmasken'||unistr('\000a')||
''
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_after_login_url
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 7177100137818754 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_AFTER_LOGIN_URL'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'B'
 ,p_item_comment => 'Used by Custom2 authentication for deep linking support'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_language_preference
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 2889416478237598 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_LANGUAGE_PREFERENCE'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_12499800077039507
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 12503818271509404 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_12499800077039507'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_12506311953526517
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 12507404812533984 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_12506311953526517'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_12514721659605017
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 12515705514609804 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_12514721659605017'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_3200507964368798
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 4438909768059092 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_3200507964368798'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_3523313843107701
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 3546725354792279 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_3523313843107701'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'S'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_3588803015630386
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 3590021374631916 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_3588803015630386'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_3628627124653251
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 3634722505915010 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_3628627124653251'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_3930816723866867
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 3948824744973282 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_3930816723866867'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_4464902988468273
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 4754603252960579 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_4464902988468273'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_4712622536239042
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 4715600406261746 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_4712622536239042'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_4742021406781853
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 4744024831830167 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_4742021406781853'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_4763703340654143
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 4764119963658951 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_4763703340654143'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_5520831490328768
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 5623312190054023 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_5520831490328768'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_6677918974782609
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 3119826309783949 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_6677918974782609'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_7181419624881178
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 4438604302059089 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_7181419624881178'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/fsp_process_state_7411110273738534
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 7438020388464889 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'FSP_PROCESS_STATE_7411110273738534'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
  );
 
end;
/

--application/shared_components/logic/application_items/temp_bestelldatum
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 5565604978656829 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'TEMP_BESTELLDATUM'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
  );
 
end;
/

--application/shared_components/logic/application_items/temporary_item
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 7983701638600170 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'TEMPORARY_ITEM'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
  );
 
end;
/

--application/shared_components/logic/application_items/temporary_page_id
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 7983329211598607 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'TEMPORARY_PAGE_ID'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
  );
 
end;
/

--application/shared_components/logic/application_items/temp_plandatum
 
begin
 
wwv_flow_api.create_flow_item (
  p_id => 5565432552655346 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'TEMP_PLANDATUM'
 ,p_scope => 'APP'
 ,p_data_type => 'VARCHAR'
 ,p_is_persistent => 'Y'
 ,p_protection_level => 'N'
  );
 
end;
/

prompt  ...application level computations
--
 
begin
 
null;
 
end;
/

prompt  ...Application Tabs
--
 
begin
 
--application/shared_components/navigation/tabs/standard/register1
wwv_flow_api.create_tab (
  p_id=> 7167906233739576 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 1,
  p_tab_name=> 'register1',
  p_tab_text => '&P1_TAB1_KATEGORIE_TEXT.',
  p_tab_step => 1,
  p_tab_also_current_for_pages => '1',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab1_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/register2
wwv_flow_api.create_tab (
  p_id=> 7364024661108873 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 2,
  p_tab_name=> 'Register2',
  p_tab_text => '&P1_TAB2_KATEGORIE_TEXT.',
  p_tab_step => 2,
  p_tab_also_current_for_pages => '2',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab2_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/register3
wwv_flow_api.create_tab (
  p_id=> 2285906171982950 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 3,
  p_tab_name=> 'Register3',
  p_tab_text => '&P1_TAB3_KATEGORIE_TEXT.',
  p_tab_step => 3,
  p_tab_also_current_for_pages => '3',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab3_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/register4
wwv_flow_api.create_tab (
  p_id=> 3825506093789421 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 4,
  p_tab_name=> 'Register4',
  p_tab_text => '&P1_TAB4_KATEGORIE_TEXT.',
  p_tab_step => 4,
  p_tab_also_current_for_pages => '4',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab4_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/register5
wwv_flow_api.create_tab (
  p_id=> 3885132721194485 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 5,
  p_tab_name=> 'REGISTER5',
  p_tab_text => '&P1_TAB5_KATEGORIE_TEXT.',
  p_tab_step => 5,
  p_tab_also_current_for_pages => '5',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab5_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/register6
wwv_flow_api.create_tab (
  p_id=> 3911514254681226 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 6,
  p_tab_name=> 'REGISTER6',
  p_tab_text => '&P1_TAB6_KATEGORIE_TEXT.',
  p_tab_step => 6,
  p_tab_also_current_for_pages => '6',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab6_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/register7
wwv_flow_api.create_tab (
  p_id=> 3912326374684759 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 7,
  p_tab_name=> 'REGISTER7',
  p_tab_text => '&P1_TAB7_KATEGORIE_TEXT.',
  p_tab_step => 7,
  p_tab_also_current_for_pages => '7',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab7_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/register8
wwv_flow_api.create_tab (
  p_id=> 3913109883689385 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 8,
  p_tab_name=> 'REGISTER8',
  p_tab_text => '&P1_TAB8_KATEGORIE_TEXT.',
  p_tab_step => 8,
  p_tab_also_current_for_pages => '8',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab8_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/register9
wwv_flow_api.create_tab (
  p_id=> 3913922003692885 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 9,
  p_tab_name=> 'REGISTER9',
  p_tab_text => '&P1_TAB9_KATEGORIE_TEXT.',
  p_tab_step => 9,
  p_tab_also_current_for_pages => '9',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab9_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/register10
wwv_flow_api.create_tab (
  p_id=> 3915313823699960 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 10,
  p_tab_name=> 'REGISTER10',
  p_tab_text => '&P1_TAB10_KATEGORIE_TEXT.',
  p_tab_step => 10,
  p_tab_also_current_for_pages => '10',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab10_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/t_labortabelle2
wwv_flow_api.create_tab (
  p_id=> 4833225825776025 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 31,
  p_tab_name=> 'T_LABORTABELLE2',
  p_tab_text => '&P31_TAB31_KATEGORIE_TEXT.',
  p_tab_step => 31,
  p_tab_also_current_for_pages => '31',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p31_tab31_kategorie_id));'||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/t_labor3
wwv_flow_api.create_tab (
  p_id=> 4853002413031668 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 32,
  p_tab_name=> 'T_LABOR3',
  p_tab_text => '&P31_TAB32_KATEGORIE_TEXT.',
  p_tab_step => 32,
  p_tab_also_current_for_pages => '32',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p31_tab32_kategorie_id));'||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/t_lab
wwv_flow_api.create_tab (
  p_id=> 4862725411045467 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 33,
  p_tab_name=> 'T_LAB',
  p_tab_text => '&P31_TAB33_KATEGORIE_TEXT.',
  p_tab_step => 33,
  p_tab_also_current_for_pages => '33',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p31_tab33_kategorie_id));'||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/t_p31_tab34_kategorie_text
wwv_flow_api.create_tab (
  p_id=> 4872903091061578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 34,
  p_tab_name=> 'T_&P31_TAB34_KATEGORIE_TEXT.',
  p_tab_text => '&P31_TAB34_KATEGORIE_TEXT.',
  p_tab_step => 34,
  p_tab_also_current_for_pages => '34',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p31_tab34_kategorie_id));'||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/t_p31_tab35_kategorie_text
wwv_flow_api.create_tab (
  p_id=> 4881510332066751 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 35,
  p_tab_name=> 'T_&P31_TAB35_KATEGORIE_TEXT.',
  p_tab_text => '&P31_TAB35_KATEGORIE_TEXT.',
  p_tab_step => 35,
  p_tab_also_current_for_pages => '35',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p31_tab35_kategorie_id));'||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/anzeige
wwv_flow_api.create_tab (
  p_id=> 5154713734112979 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 90,
  p_tab_name=> 'Anzeige',
  p_tab_text => '&P1_TAB90_KATEGORIE_TEXT.',
  p_tab_step => 90,
  p_tab_also_current_for_pages => '90',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab90_kategorie_id));'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/t_tab91kategorietext
wwv_flow_api.create_tab (
  p_id=> 5295910245244575 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 91,
  p_tab_name=> 'T_TAB91KATEGORIETEXT',
  p_tab_text => '&P1_TAB91_KATEGORIE_TEXT.',
  p_tab_step => 91,
  p_tab_also_current_for_pages => '91',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON != ''BETREUER'' THEN'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab91_kategorie_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/t_p1tab95kategorietext
wwv_flow_api.create_tab (
  p_id=> 5822522526212523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'TS1',
  p_tab_sequence=> 111,
  p_tab_name=> 'T_P1TAB95KATEGORIETEXT.',
  p_tab_text => '&P1_TAB95_KATEGORIE_TEXT.',
  p_tab_step => 95,
  p_tab_also_current_for_pages => '95',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''PIS'' THEN  -- Kurhaus'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN (frgbg_s.check_tab_anzeigen(:p1_pergebnis_id,'||unistr('\000a')||
'                                      :p1_tab95_kategorie_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab1_kategorie
wwv_flow_api.create_tab (
  p_id=> 5883227311665310 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 10,
  p_tab_name=> 'TAB1_kategorie',
  p_tab_text => '&P201_TAB1_KATEGORIE_TEXT.',
  p_tab_step => 201,
  p_tab_also_current_for_pages => '201',
  p_tab_parent_tabset=>'',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab2_kategorie
wwv_flow_api.create_tab (
  p_id=> 5890518138700535 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 20,
  p_tab_name=> 'TAB2_kategorie',
  p_tab_text => '&P201_TAB2_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '202',
  p_tab_parent_tabset=>'',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab3_kategorie
wwv_flow_api.create_tab (
  p_id=> 5914617764823404 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 30,
  p_tab_name=> 'TAB3_KATEGORIE',
  p_tab_text => '&P201_TAB3_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB3_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab4_kategorie
wwv_flow_api.create_tab (
  p_id=> 5916715601841662 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 40,
  p_tab_name=> 'TAB4_KATEGORIE',
  p_tab_text => '&P201_TAB4_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB4_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab5_kategorie
wwv_flow_api.create_tab (
  p_id=> 5917521142843293 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 50,
  p_tab_name=> 'TAB5_KATEGORIE',
  p_tab_text => '&P201_TAB5_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB5_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab6_kategorie
wwv_flow_api.create_tab (
  p_id=> 5918326683844901 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 60,
  p_tab_name=> 'TAB6_KATEGORIE',
  p_tab_text => '&P201_TAB6_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB6_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab7_kategorie
wwv_flow_api.create_tab (
  p_id=> 5919100495846784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 70,
  p_tab_name=> 'TAB7_KATEGORIE',
  p_tab_text => '&P201_TAB7_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB7_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab8_kategorie
wwv_flow_api.create_tab (
  p_id=> 5920106382848520 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 80,
  p_tab_name=> 'TAB8_KATEGORIE',
  p_tab_text => '&P201_TAB8_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB8_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab9_kategorie
wwv_flow_api.create_tab (
  p_id=> 5921014347850807 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 90,
  p_tab_name=> 'TAB9_KATEGORIE',
  p_tab_text => '&P201_TAB9_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB9_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab10_kategorie
wwv_flow_api.create_tab (
  p_id=> 5926409892877921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 100,
  p_tab_name=> 'TAB10_KATEGORIE',
  p_tab_text => '&P201_TAB10_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB10_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/tab90_kategorie
wwv_flow_api.create_tab (
  p_id=> 5927923576919684 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 110,
  p_tab_name=> 'TAB90_KATEGORIE',
  p_tab_text => '&P201_TAB90_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB90_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
--application/shared_components/navigation/tabs/standard/t_p201tab91kategorietext
wwv_flow_api.create_tab (
  p_id=> 6036703862541470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'T_TS3',
  p_tab_sequence=> 130,
  p_tab_name=> 'T_P201TAB91KATEGORIETEXT.',
  p_tab_text => '&P201_TAB91_KATEGORIE_TEXT.',
  p_tab_step => 202,
  p_tab_also_current_for_pages => '',
  p_tab_parent_tabset=>'',
  p_tab_plsql_condition=>'P201_TAB91_KATEGORIE_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_tab_comment  => '');
 
 
end;
/

prompt  ...Application Parent Tabs
--
 
begin
 
--application/shared_components/navigation/tabs/parent/t_ts2
wwv_flow_api.create_toplevel_tab (
  p_id=> 5358510427117004 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_tab_set=> 'ts2',
  p_tab_sequence=> 20,
  p_tab_name  => 'T_TS2',
  p_tab_text  => 'ts2',
  p_tab_target=> 'f?p=102:110:&SESSION.:',
  p_current_on_tabset=> 'ts2',
  p_tab_comment=> '');
 
 
end;
/

prompt  ...Shared Lists of values
--
--application/shared_components/user_interface/lov/lov_therapeuten
 
begin
 
wwv_flow_api.create_list_of_values (
  p_id       => 5616022604440135 + wwv_flow_api.g_id_offset,
  p_flow_id  => wwv_flow.g_flow_id,
  p_lov_name => 'LOV_THERAPEUTEN',
  p_lov_query=> 'select p.suchname||'', ''||p.suchadresse a,  p.personenstamm_id b'||unistr('\000a')||
'from v_perslisten_betreuer p'||unistr('\000a')||
'where p.personenstamm_id_betreuer = :fas_identitaet_persstamm_id'||unistr('\000a')||
'  and p.personenstamm_id is not null'||unistr('\000a')||
'order by 1');
 
null;
 
end;
/

--application/shared_components/user_interface/lov/p301_zeile_pro_seite_melden
 
begin
 
wwv_flow_api.create_list_of_values (
  p_id       => 2413412763729101 + wwv_flow_api.g_id_offset,
  p_flow_id  => wwv_flow.g_flow_id,
  p_lov_name => 'P301_Zeile pro Seite melden',
  p_lov_query=> '.'||to_char(2413412763729101 + wwv_flow_api.g_id_offset)||'.');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2413714693729106 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>10,
  p_lov_disp_value=>'10',
  p_lov_return_value=>'10',
  p_lov_data_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2413923492729109 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>20,
  p_lov_disp_value=>'15',
  p_lov_return_value=>'15',
  p_lov_data_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2414104196729109 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>30,
  p_lov_disp_value=>'20',
  p_lov_return_value=>'20',
  p_lov_data_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2414325301729109 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>40,
  p_lov_disp_value=>'30',
  p_lov_return_value=>'30',
  p_lov_data_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2414510834729109 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>50,
  p_lov_disp_value=>'50',
  p_lov_return_value=>'50',
  p_lov_data_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2414714183729109 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>60,
  p_lov_disp_value=>'100',
  p_lov_return_value=>'100',
  p_lov_data_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2414925542729109 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>70,
  p_lov_disp_value=>'200',
  p_lov_return_value=>'200',
  p_lov_data_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2415117257729109 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>80,
  p_lov_disp_value=>'500',
  p_lov_return_value=>'500',
  p_lov_data_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2415305227729110 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>90,
  p_lov_disp_value=>'1000',
  p_lov_return_value=>'1000',
  p_lov_data_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_static_lov_data (
  p_id=>2415525108729110 + wwv_flow_api.g_id_offset,
  p_lov_id=>2413412763729101 + wwv_flow_api.g_id_offset,
  p_lov_disp_sequence=>100,
  p_lov_disp_value=>'5000',
  p_lov_return_value=>'5000',
  p_lov_data_comment=> '');
 
null;
 
end;
/

prompt  ...Application Trees
--
--application/pages/page_groups
prompt  ...page groups
--
 
begin
 
wwv_flow_api.create_page_group(
  p_id=>3103530937219435 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_group_name=>'Alle_Seiten',
  p_group_desc=>'');
 
null;
 
end;
/

 
--application/pages/page_00000
prompt  ...PAGE 0: 0
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 0
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => '0'
 ,p_step_title => '0'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141031145231'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_HINWEISTEXT.'||unistr('\000a')||
'';

wwv_flow_api.create_page_plug (
  p_id=> 2974223555552243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 0,
  p_plug_name=> '&P1_HINWEISTITEL.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':APP_PAGE_ID in (1,2,3,4,5,6,7,8,9,10,31,32,33,34,35,90,91,95) AND :P1_HINWEISTEXT is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT x.ID ID,'||unistr('\000a')||
'       x.FAS_APP_MENU_ID PID,'||unistr('\000a')||
'       x.BEZEICHNUNG NAME,'||unistr('\000a')||
'       CASE substr(x.URL,1,4) when ''f?p='''||unistr('\000a')||
'       THEN APEX_UTIL.PREPARE_URL(frgbg_t.replace_var_in_wert(x.URL))'||unistr('\000a')||
'       ELSE ''#'''||unistr('\000a')||
'       END link,'||unistr('\000a')||
'       level'||unistr('\000a')||
'--from fas_app_menus x'||unistr('\000a')||
'--where x.id in'||unistr('\000a')||
'from (select distinct b.id,b.FAS_APP_MENU_ID,'||unistr('\000a')||
'             NVL(frgbg_s.holen_uebersetzung(b.bezeichnung_text_id,:fas_sprache_id),b';

s:=s||'.BEZEICHNUNG ) bezeichnung, '||unistr('\000a')||
'             b.URL,b.sortierung    -- Gesamthierarchie mit Oberelemente mit zugriffbaren Blattelementen: von unten nach oben LOOP'||unistr('\000a')||
'      FROM "FAS_APP_MENUS" b'||unistr('\000a')||
'      WHERE b.app_id = :APP_ID'||unistr('\000a')||
'        and b.aktiv in (1,2)'||unistr('\000a')||
'      START WITH b.ID in (SELECT m.id     -- alle zugreifbaren Blattelemente'||unistr('\000a')||
'                          from fas_app_menus m'||unistr('\000a')||
'                          WH';

s:=s||'ERE m.id not in (SELECT d.fas_app_menu_id       -- Oberelemente'||unistr('\000a')||
'                                             from fas_app_menus d'||unistr('\000a')||
'                                             WHERE d.app_id = :app_id'||unistr('\000a')||
'                                               and d.satz_kennzeichen is null'||unistr('\000a')||
'                                               and d.fas_app_menu_id is not null'||unistr('\000a')||
'                                         ';

s:=s||'   )'||unistr('\000a')||
'                            and m.page_id is not null'||unistr('\000a')||
'                            and m.app_id = :APP_ID'||unistr('\000a')||
'                            and m.SATZ_KENNZEICHEN is null'||unistr('\000a')||
'                            --  Aktuelle Page soll nicht im Menü auftauchen wg. verhindern doppeltem Aufruf'||unistr('\000a')||
'                            and m.page_id != :APP_PAGE_ID --Klappt merkwürdigerweise in APP 118 nicht ohne UNION s.u.'||unistr('\000a')||
'     ';

s:=s||'                       -- Zugriffsberechtigung inkl. Auswertung aktiv-Flag'||unistr('\000a')||
'                            and frgbg_t.CHECK_FAS_APP_ZUGRIFF(:FAS_LOGIN_PERSONENSTAMM_ID,:FAS_IDENTITAET_PERSSTAMM_ID,m.app_id,m.page_id,:FAS_AUFGERUFEN_VON) > 0'||unistr('\000a')||
'                            -- Menüpunkt überhaupt auf akt. Seite anzeigen'||unistr('\000a')||
'                            and (m.menu_visible_page_id is NULL OR instr(m.menu_visible';

s:=s||'_page_id,'';''||:APP_PAGE_ID||'';'') > 0)'||unistr('\000a')||
'                           )'||unistr('\000a')||
'       CONNECT BY PRIOR b.FAS_APP_MENU_ID = b.ID          -- von unten nach oben'||unistr('\000a')||
'              and prior b.app_id = :APP_ID'||unistr('\000a')||
'       UNION -- NEI 25.10.13 muss sein damit "and m.page_id != :APP_PAGE_ID" auch in 118 klappt, das Plugin sein sonst das Menü nicht in allen Fällen richtig aufzubauen'||unistr('\000a')||
'       SELECT -1,null,'''',''#'',9000000'||unistr('\000a')||
'   ';

s:=s||'    from dual'||unistr('\000a')||
'      ) x'||unistr('\000a')||
'START WITH x.FAS_APP_MENU_ID is null'||unistr('\000a')||
'CONNECT BY PRIOR x.ID=x.FAS_APP_MENU_ID        -- von oben nach unten'||unistr('\000a')||
'order siblings by x.SORTIERUNG';

wwv_flow_api.create_page_plug (
  p_id=> 3836307103827346 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 0,
  p_plug_name=> 'Menü',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 0,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'AFTER_HEADER',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'PLUGIN_COM.JWILSON.APEX.DROP_MENU',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':APP_PAGE_ID not in (100,101,121,122,123,124  /* Login-Seiten */'||unistr('\000a')||
'                     ,106                     /* PW anfordern vor Login */'||unistr('\000a')||
'                     ,102,103,105,104,215,134,204,306,307,999,98,99,550,995 '||unistr('\000a')||
'                      ,97,328, 403,152 /* Alle Popups */'||unistr('\000a')||
'                    )',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_attribute_01=> '0',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'<script type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'/* Lädt das "Lade-Icon" vor. Dynamic Action hat nicht funktioniert, daher der direkte Eintrag in eine HTML Region */'||unistr('\000a')||
'var iconImage = new Image();'||unistr('\000a')||
'iconImage.src = "#IMAGE_PREFIX#themes/&FAS_THEME_NAME./ajax-loader.gif";'||unistr('\000a')||
'-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
''||unistr('\000a')||
'<style type="text/css">   '||unistr('\000a')||
'    #AjaxLoadingBG .AjaxLoading{'||unistr('\000a')||
'         padding:5px;'||unistr('\000a')||
'         font-size:18px;'||unistr('\000a')||
'         width:200px;'||unistr('\000a')||
'';

s:=s||'         color:black;'||unistr('\000a')||
'         text-align:center;'||unistr('\000a')||
'         position:absolute;'||unistr('\000a')||
'         top:100px;'||unistr('\000a')||
'         left: 300px;'||unistr('\000a')||
'         border:2px solid #666;'||unistr('\000a')||
'         background-color:#FFF;'||unistr('\000a')||
'    }'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'#AjaxLoadingBG.parent { '||unistr('\000a')||
'  position:absolute;'||unistr('\000a')||
'  color: #fff;'||unistr('\000a')||
'  height: 500px;'||unistr('\000a')||
'  width: 500px;'||unistr('\000a')||
'  padding: 20px;'||unistr('\000a')||
'  margin-right: 10px;'||unistr('\000a')||
'  z-index:1000;'||unistr('\000a')||
'  display:none;'||unistr('\000a')||
'  width:100%;'||unistr('\000a')||
'  height:200px;'||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'.colorA { ';

s:=s||'background: white; }'||unistr('\000a')||
'.colorB { background: #668; }'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'/* partial opacity hack: configuration */'||unistr('\000a')||
'#AjaxLoadingBG .opacity { '||unistr('\000a')||
'	opacity: 0.5;		/* modern browser */'||unistr('\000a')||
'	-moz-opacity: 0.5;	/* older Mozilla browser */'||unistr('\000a')||
'	-ms-filter:"progid:DXImageTransform.Microsoft.Alpha(Opacity=50)"; /* IE8 in Standard Compliant Mode */'||unistr('\000a')||
'	filter:alpha(opacity=50); /* IE5.x -7.0 */'||unistr('\000a')||
'} '||unistr('\000a')||
''||unistr('\000a')||
'/* partial opacity hack, part I: Don''t ch';

s:=s||'ange the following properties! */'||unistr('\000a')||
'#AjaxLoadingBG.opacity-wrapper * {'||unistr('\000a')||
'	position:relative;'||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'#AjaxLoadingBG .opacity { '||unistr('\000a')||
'	/* partial opacity hack, part II: Don''t change the following properties! */'||unistr('\000a')||
'	width: 100%;'||unistr('\000a')||
'	height: 100%;'||unistr('\000a')||
'	position:absolute;'||unistr('\000a')||
'	top:0;'||unistr('\000a')||
'	left:0;'||unistr('\000a')||
'} '||unistr('\000a')||
''||unistr('\000a')||
'/* partial opacity hack, part III: IE6 support */'||unistr('\000a')||
'* html #AjaxLoadingBG.opacity-wrapper { '||unistr('\000a')||
'	overflow:hidden;'||unistr('\000a')||
'}'||unistr('\000a')||
'* html #AjaxLoadingBG .';

s:=s||'opacity { '||unistr('\000a')||
'	width: 2000px; '||unistr('\000a')||
'	height: 2000px;'||unistr('\000a')||
'} '||unistr('\000a')||
'</style>'||unistr('\000a')||
''||unistr('\000a')||
'<div id="AjaxLoadingBGShow"></div>'||unistr('\000a')||
'<div id="AjaxLoadingBG" class="parent opacity-wrapper" style="">'||unistr('\000a')||
'  <div class="colorA opacity"></div>'||unistr('\000a')||
'  <div class="AjaxLoading" style="">...waiting...<br /><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./ajax-loader.gif" id="wait" /></div>'||unistr('\000a')||
'</div>';

wwv_flow_api.create_page_plug (
  p_id=> 7538514655196520 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 0,
  p_plug_name=> 'Loading Icon',
  p_region_name=>'',
  p_region_attributes=> 'style="position:absolute; left:-10px; top:-10px"',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 80,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':APP_PAGE_ID in(202)',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'<iframe id="jobliste_iframe" scrolling="no" src ="f?p=&APP_ID.:550:&SESSION." style="height:100%; width:100%; border:0px; overflow:hidden; border-radius: 6px;">'||unistr('\000a')||
'</iframe>'||unistr('\000a')||
''||unistr('\000a')||
'';

wwv_flow_api.create_page_plug (
  p_id=> 8613807162770445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 0,
  p_plug_name=> 'FB App-Jobs',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 110,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'AFTER_HEADER',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'EXISTS',
  p_plug_display_when_condition => 'select  a.ID'||unistr('\000a')||
'from FRGBG.APP_JOBS a'||unistr('\000a')||
'where'||unistr('\000a')||
''||unistr('\000a')||
'  (:APP_PAGE_ID < 100 or :APP_PAGE_ID >= 130) '||unistr('\000a')||
'  and :APP_PAGE_ID not in(215,98,550,97,328,403,152)'||unistr('\000a')||
'  and app_id = :APP_ID'||unistr('\000a')||
'  and USER_ACCOUNT = :APP_USER'||unistr('\000a')||
'  and a.MUTDAT > sysdate - 24/60 -- Maximal 60 Minuten halten'||unistr('\000a')||
'  and a.satz_kennzeichen is null'||unistr('\000a')||
'  and a.visible = 1'||unistr('\000a')||
'  and (a.STATUS_ID = 1 and a.JOB_ID in (select JOB from dba_jobs_running) or a.STATUS_ID <> 1)',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_header=> '<div id="jobliste" style="position:absolute; top:40px; right:10px; width:350px;  background-color:#404040; padding:0px 0px 0px 10px; border-radius: 6px; border:1px solid #000; height:85px;">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8680917818736578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 0,
  p_plug_name=> 'fragebogen_upload',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 70,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'AFTER_HEADER',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => '(:APP_PAGE_ID >= 2 and :APP_PAGE_ID <= 10)'||unistr('\000a')||
'or '||unistr('\000a')||
'(:APP_PAGE_ID >= 31 and :APP_PAGE_ID <=35)',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_header=> '<div style="display:block">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8681128688736578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 0,
  p_name=>'P0_FB_UPLOAD_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 8680917818736578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8681311747736579 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 0,
  p_name=>'P0_FB_UPLOAD_REFESH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 8680917818736578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 4000,
  p_cHeight=> 4,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8681506076736580 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 0,
  p_name=>'P0_TIME_PICKER_CONF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 8680917818736578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'replace(replace(frgbg_s.holen_uebersetzung(9728,:FAS_SPRACHE_ID),chr(10),''''),chr(13),'''')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8681701812736580 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 0,
  p_name=>'P0_DATE_PICKER_CONF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 8680917818736578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'replace(replace(frgbg_s.holen_uebersetzung(9729,:FAS_SPRACHE_ID),chr(10),''''),chr(13),'''')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8681912977736580 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 0,
  p_name=>'P0_FB_UPLOAD_DEL_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 8680917818736578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select frgbg_s.holen_uebersetzung(9174,:FAS_SPRACHE_ID) from dual',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8682127090736581 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 0,
  p_name=>'P0_FB_UPLOAD_CONFIRM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 8680917818736578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'0',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8682309658736581 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 0,
  p_name=>'P0_UPLOAD_DOWNLOAD_LINK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 8680917818736578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select APEX_UTIL.PREPARE_URL(''f?p='' || :APP_ID || '':98:&SESSION.:DOWNLOAD_FILE:NO::'') as url from dual',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7638021471825915 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_name => 'Positioniere Ajax Loading Icon'
 ,p_event_sequence => 70
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '#AjaxLoadingBGShow'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7638328765825929 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 7638021471825915 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '    '||unistr('\000a')||
'$(''#AjaxLoadingBG'').find(".AjaxLoading").css({      '||unistr('\000a')||
'          "left": Math.floor($(window).width() * 0.45) + "px",'||unistr('\000a')||
'          "top": Math.floor($(window).height() * 0.45) + "px"   '||unistr('\000a')||
'     });'||unistr('\000a')||
''||unistr('\000a')||
'$(''#AjaxLoadingBG.parent'').css({      '||unistr('\000a')||
'          "width": ($(window).width() + 10) + "px",'||unistr('\000a')||
'          "height": ($(window).height() + 10) + "px",'||unistr('\000a')||
'          "display": "block",'||unistr('\000a')||
'          "bottom": "0px",'||unistr('\000a')||
'          "right": "0px"'||unistr('\000a')||
'     });'||unistr('\000a')||
'     '||unistr('\000a')||
''||unistr('\000a')||
'$(''#AjaxLoadingBG'').show();'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8682527861739477 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_name => 'Merke Fokus auf FB Upload Feld'
 ,p_event_sequence => 80
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.upl_container'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
 ,p_display_when_cond => 'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'||unistr('\000a')||
''
  );
wwv_flow_api.create_page_da_action (
  p_id => 8682822433739478 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8682527861739477 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '#P0_FB_UPLOAD_ID'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => '/* liefert den ID-String (Hidden-Feld) der alle Infos bezüglich der FB-Antwort enthält */'||unistr('\000a')||
'$(this.triggeringElement).find(''input[name=\"f01\"][id=\"upl_hi_'' + $(this.triggeringElement).attr(''id'').substr(6) + ''\"]'').val()'||unistr('\000a')||
''
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8682926260748550 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_name => 'Öffne FB Upload Modal Fenster'
 ,p_event_sequence => 90
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.upl_button'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
 ,p_display_when_cond => 'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'||unistr('\000a')||
''
  );
wwv_flow_api.create_page_da_action (
  p_id => 8683608605748551 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8682926260748550 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 5
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '#P0_FB_UPLOAD_ID'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => '/* liefert den ID-String (Hidden-Feld) der alle Infos bezüglich der FB-Antwort enthält */'||unistr('\000a')||
'/* Das ID Feld muss hier gesetzt werden, da nicht garantiert werden kann, das die Merke Dynamic Action vor dieser hier ausgelöst wird. Grund bisher unbekannt */'||unistr('\000a')||
'$(this.triggeringElement).parent().find(''input[name=\"f01\"][id=\"upl_hi_'' + $(this.triggeringElement).parent().attr(''id'').substr(6) + ''\"]'').val()'
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8683425168748551 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8682926260748550 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 6
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin'||unistr('\000a')||
'  :P98_ID := :P0_FB_UPLOAD_ID;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P0_FB_UPLOAD_ID'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8683203024748551 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8682926260748550 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_attribute_01 => 'Upload'
 ,p_attribute_02 => 'STATIC'
 ,p_attribute_03 => 'f?p=&APP_ID.:98:&APP_SESSION.:::::'
 ,p_attribute_06 => '#MESSAGE.t1success'
 ,p_attribute_07 => 'STATIC_PX'
 ,p_attribute_08 => '200'
 ,p_attribute_09 => '700'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8683701111750713 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_name => 'Schließe FB Upload Modal Fenster'
 ,p_event_sequence => 100
 ,p_triggering_element_type => 'DOM_OBJECT'
 ,p_triggering_element => 'document'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE|DYNAMIC ACTION|modalpageautoclose'
 ,p_da_event_comment => 'Keine Condition, da das FAS dadurch extrem verlangsamt wird'||unistr('\000a')||
'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'
  );
wwv_flow_api.create_page_da_action (
  p_id => 8684031048750715 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8683701111750713 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'v_message = this.data.$modalPageCloseObject;'||unistr('\000a')||
'$(''.t1messages'').after( v_message );'||unistr('\000a')||
'$(''#MESSAGE.t1success'').delay(2000).fadeOut(2000);'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8684201765750716 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8683701111750713 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'declare'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
' -- Hol den Inhalt des Uploadfeldes'||unistr('\000a')||
' :P0_FB_UPLOAD_REFESH := FRGBG_S.ERZEUGEN_FELDER_UPLOAD('||unistr('\000a')||
'      p_pergebnis_id   => :P1_PERGEBNIS_ID'||unistr('\000a')||
'      , p_fantwort_id  => to_number(substr(:P0_FB_UPLOAD_ID,26,8))'||unistr('\000a')||
'      , p_sprache_id   => :FAS_SPRACHE_ID'||unistr('\000a')||
' );'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P0_FB_UPLOAD_ID'
 ,p_attribute_03 => 'P0_FB_UPLOAD_REFESH'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8684307691752615 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_name => 'Lösche FB Upload'
 ,p_event_sequence => 110
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.upl_delete_link'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'click'
 ,p_display_when_cond => 'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'||unistr('\000a')||
''
  );
wwv_flow_api.create_page_da_action (
  p_id => 8684811343752615 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8684307691752615 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '#P0_FB_UPLOAD_CONFIRM'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => 'confirm($v(''P0_FB_UPLOAD_DEL_TEXT'')) ? 1 : 0'
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8684626950752615 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8684307691752615 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'declare'||unistr('\000a')||
'  v_display_only number;'||unistr('\000a')||
'  v_personenstamm_id number;'||unistr('\000a')||
'  v_fragebogen_id number;'||unistr('\000a')||
'  v_frage_id number;'||unistr('\000a')||
'  v_fantwort_id number;'||unistr('\000a')||
'  v_persantwort_id number;'||unistr('\000a')||
''||unistr('\000a')||
'  v_fehlermeldung varchar2(2000);'||unistr('\000a')||
'  v_fehlernummer number;'||unistr('\000a')||
'  v_fehler exception;'||unistr('\000a')||
'  e_ERROR_D exception;'||unistr('\000a')||
'  PRAGMA EXCEPTION_INIT(e_ERROR_D,-20000);'||unistr('\000a')||
'  v_prod_id number;'||unistr('\000a')||
'begin'||unistr('\000a')||
'  if(:P0_FB_UPLOAD_ID is not null) then'||unistr('\000a')||
''||unistr('\000a')||
'    Mel.P(''lösche FB Upload id: '' || :P0_FB_UPLOAD_ID,v_prod_id,''TEST'');'||unistr('\000a')||
''||unistr('\000a')||
'    FRGBG_S.HOLEN_IDS('||unistr('\000a')||
'     P_ID                 => :P0_FB_UPLOAD_ID'||unistr('\000a')||
'     ,P_PERSONENSTAMM_ID  => v_personenstamm_id'||unistr('\000a')||
'     ,P_FRAGEBOGEN_ID     => v_fragebogen_id'||unistr('\000a')||
'     ,P_FRAGE_ID          => v_frage_id'||unistr('\000a')||
'     ,P_FANTWORT_ID       => v_fantwort_id'||unistr('\000a')||
'     ,P_PERSANTWORT_ID    => v_persantwort_id'||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'    if(:P0_FB_UPLOAD_CONFIRM = ''1'') then'||unistr('\000a')||
''||unistr('\000a')||
'      v_display_only :=  NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY('||unistr('\000a')||
'            p_pergebnis_id                  => :P1_PERGEBNIS_ID,'||unistr('\000a')||
'            p_FANTWORT_ID                   => v_fantwort_id'||unistr('\000a')||
'      ),0);'||unistr('\000a')||
''||unistr('\000a')||
'      if(v_display_only = 1) then'||unistr('\000a')||
'          raise_application_error(-20000,frgbg_s.holen_uebersetzung(9171,:FAS_SPRACHE_ID));'||unistr('\000a')||
'      end if;'||unistr('\000a')||
''||unistr('\000a')||
'      begin'||unistr('\000a')||
'      delete from persantworten '||unistr('\000a')||
'      where'||unistr('\000a')||
'          fantwort_id = v_fantwort_id'||unistr('\000a')||
'          and pergebnis_id = :P1_PERGEBNIS_ID'||unistr('\000a')||
'          and frage_id = v_frage_id'||unistr('\000a')||
'          and fantwort_dokument_fas_id is not null;'||unistr('\000a')||
'      exception'||unistr('\000a')||
'      when others then'||unistr('\000a')||
'          v_fehlermeldung := ''Fehler beim Löschen der FB Antwort-Datei fantwort_id: '' || v_fantwort_id || '' pergebnis_id: '' || sqlerrm '||unistr('\000a')||
'             ||:P1_PERGEBNIS_ID;'||unistr('\000a')||
'          v_fehlernummer := -10;'||unistr('\000a')||
'          raise v_fehler;'||unistr('\000a')||
'      end;'||unistr('\000a')||
'     end if;'||unistr('\000a')||
''||unistr('\000a')||
'     -- Hol den Inhalt des Uploadfeldes'||unistr('\000a')||
'    :P0_FB_UPLOAD_REFESH := FRGBG_S.ERZEUGEN_FELDER_UPLOAD('||unistr('\000a')||
'      p_pergebnis_id   => :P1_PERGEBNIS_ID'||unistr('\000a')||
'      , p_fantwort_id  => v_fantwort_id'||unistr('\000a')||
'      , p_sprache_id   => :FAS_SPRACHE_ID'||unistr('\000a')||
'    );   '||unistr('\000a')||
'  end if;   '||unistr('\000a')||
''||unistr('\000a')||
'      '||unistr('\000a')||
'  '||unistr('\000a')||
'exception '||unistr('\000a')||
'  when v_fehler then'||unistr('\000a')||
'      Mel.P(v_fehlermeldung,v_prod_id,''ERROR'',''dynamic_action lösche DB Upload ['' || v_fehlernummer || ''] '' ||dbms_utility.format_error_backtrace);'||unistr('\000a')||
'      raise_application_error(-20000,frgbg_s.holen_uebersetzung(9173,:FAS_SPRACHE_ID));'||unistr('\000a')||
'  when e_ERROR_D then'||unistr('\000a')||
'      raise;'||unistr('\000a')||
'  when others then'||unistr('\000a')||
'      v_fehlermeldung := ''unbekannter Fehler in Dynamic Action aufgetreten '' || sqlerrm;'||unistr('\000a')||
'      v_fehlernummer := -999;'||unistr('\000a')||
'      Mel.P(v_fehlermeldung,v_prod_id,''ERROR'',''dynamic_action lösche DB Upload ['' || v_fehlernummer || ''] '' ||dbms_utility.format_error_backtrace);'||unistr('\000a')||
'      raise_application_error(-20000,frgbg_s.holen_uebersetzung(9173,:FAS_SPRACHE_ID));'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P0_FB_UPLOAD_ID,P0_FB_UPLOAD_CONFIRM'
 ,p_attribute_03 => 'P0_FB_UPLOAD_REFESH'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8685018080755595 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_name => 'Aktualisiere FB Upload Feld'
 ,p_event_sequence => 120
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '#P0_FB_UPLOAD_REFESH'
 ,p_triggering_condition_type => 'NOT_NULL'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 8685320480755596 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8685018080755595 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '/* ersetzt den Inhalt des Uploadfeldes nach dem Button (Enthält Links und Dateinamen) */'||unistr('\000a')||
'if($v(''P0_FB_UPLOAD_ID'') != null && $v(''P0_FB_UPLOAD_REFESH'') != null) {'||unistr('\000a')||
'   $(''div[id$="'' + parseInt($v(''P0_FB_UPLOAD_ID'').substr(26,7).trim()) + '||unistr('\000a')||
'     ''"][class="upl_sub_container"]'').replaceWith($v(''P0_FB_UPLOAD_REFESH''));'||unistr('\000a')||
''||unistr('\000a')||
'} else {'||unistr('\000a')||
' '||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8685425353757705 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_name => 'Download FB Upload Datei'
 ,p_event_sequence => 130
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.upl_download_link'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'click'
 ,p_display_when_cond => 'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'||unistr('\000a')||
''
  );
wwv_flow_api.create_page_da_action (
  p_id => 8685907732757706 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8685425353757705 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin'||unistr('\000a')||
'  :P98_ID := :P0_FB_UPLOAD_ID;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P0_FB_UPLOAD_ID'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8685715951757706 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 0
 ,p_event_id => 8685425353757705 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'redirect($v(''P0_UPLOAD_DOWNLOAD_LINK'')); '
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 0
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00001
prompt  ...PAGE 1: PERSONENSTAMM
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 1
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'PERSONENSTAMM'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function check_checkbox(p_itemname,p_text)'||unistr('\000a')||
'{'||unistr('\000a')||
' var ip=document.getElementsByTagName(''INPUT'');'||unistr('\000a')||
' var ret=new Array();'||unistr('\000a')||
' var regexp=new RegExp(''^''+p_itemname+''_'');'||unistr('\000a')||
' var l_exist=0'||unistr('\000a')||
' for (var j=0;j<ip.length;j++) {'||unistr('\000a')||
'   if (ip[j].type=="checkbox" && ip[j].id && ip[j].id.match(regexp)) {'||unistr('\000a')||
'      if (ip[j].checked && ip[j].value==7) {'||unistr('\000a')||
'        alert(p_text);'||unistr('\000a')||
'        l_exist=1;'||unistr('\000a')||
'      }'||unistr('\000a')||
'    }   '||unistr('\000a')||
' }'||unistr('\000a')||
' //alert(''Hallo:''+l_exist);'||unistr('\000a')||
' if (l_exist==1 ) {'||unistr('\000a')||
' for (var j=0;j<ip.length;j++) {'||unistr('\000a')||
'   if (ip[j].type=="checkbox" && ip[j].id && ip[j].id.match(regexp)) {'||unistr('\000a')||
'      if (ip[j].checked && ip[j].value!=7) {'||unistr('\000a')||
'        //alert(''Die Etikettoption uncheck!''+ip[j].value);'||unistr('\000a')||
'        ip[j].checked=false;'||unistr('\000a')||
'       }'||unistr('\000a')||
'   }   '||unistr('\000a')||
' }'||unistr('\000a')||
' }'||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
''
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'OLIVER.LEMM'
 ,p_last_upd_yyyymmddhh24miss => '20150917143643'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3170917966912078 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 1,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5558316633466960 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 1,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7132411261793773 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 1,
  p_plug_name=> '&P1_REGION_TITEL_MODUL_AUSW.',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 15,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7168017465739576 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 1,
  p_plug_name=> '&P1_TAB1_KATEGORIE_TEXT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 9,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="height: &FAS_SCROLLREGION_HEIGHT_MAX.px;max-width: 550px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 7168101323739579 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 1,
  p_button_sequence=> 10,
  p_button_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'') and 1=2',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4418712080947764 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 1,
  p_button_sequence=> 15,
  p_button_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_button_name    => 'P1_PASSWORT_CHANGE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_PASSWORT_CHG.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:popUp2(''&P1_PREPARE_URL_PW.'',700,380);',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'UPPER(:P1_USER_ACCOUNT)= UPPER(:APP_USER) AND :p1_id IS NOT NULL and :fas_aufgerufen_von not in (''ANONYM'',''PIS'') and'||unistr('\000a')||
':fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6263424651167846 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 1,
  p_button_sequence=> 17,
  p_button_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Auswertung',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS'' and 1=2',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3956425705854839 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 1,
  p_button_sequence=> 20,
  p_button_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_ID is not null and'||unistr('\000a')||
':fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7168202772739579 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 1,
  p_button_sequence=> 20,
  p_button_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(''&FAS_LOESCHABFRAGE_TEXT.'',''DELETE'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_ID IS NOT NULL AND :fas_aufgerufen_von not in (''ANONYM'',''PIS'') and'||unistr('\000a')||
':fas_pers_aenderbar = 1    /* Personendaten aenderbar */'||unistr('\000a')||
'/* NEI 18.12.09 abgeschaltet */',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7168305288739579 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 1,
  p_button_sequence=> 30,
  p_button_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Ändern',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_ID is not null and'||unistr('\000a')||
':fas_pers_aenderbar = 1         /* Personendaten aenderbar */'||unistr('\000a')||
'and 1=2',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7168415639739579 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 1,
  p_button_sequence=> 40,
  p_button_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstellen',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P1_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3863110544715062 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 1,
  p_button_sequence=> 50,
  p_button_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7137105991886882 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 1,
  p_button_sequence=> 80,
  p_button_plug_id => 7132411261793773+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE_MODUL_AUSW',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SAVE_MODUL_AUSW.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.submit(''SAVE_MODUL_AUSW'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'FRGBG_S.FB_CHECK_AUSWERTUNG(:P1_PERGEBNIS_ID) = 0',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5035532676610206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:1,110,140::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7168202772739579+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> '/*:p1_satzkennzeichen IS NOT NULL AND :p1_abbrechen_zu_seite = 130 and*/'||unistr('\000a')||
' :fas_aufgerufen_von = ''BETREUER''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 14-SEP-2007 11:13 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>5048429287864750 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:1::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7168202772739579+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 15,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> '/*:p1_satzkennzeichen IS NOT NULL AND :p1_abbrechen_zu_seite = 101 and*/'||unistr('\000a')||
':fas_aufgerufen_von in  (''KUNDE'',''ANONYM'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 14-SEP-2007 11:56 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>7377927488248635 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:1,31,95::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7168101323739579+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> '/*P1_AUFGERUFEN_VON is null*/ :fas_aufgerufen_von != ''PIS''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4043121777310196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:1:&SESSION.:OPT_CHANGE:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 40,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request = ''OPT_CHANGE''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 14-DEZ-2009 15:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>3864115355763817 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3863110544715062+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 50,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4068613603679862 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:1:&SESSION.:HRV_MELDUNG:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4056729101749365+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 60,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 01-FEB-2013 11:47 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>5045305345829462 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 14-SEP-2007 11:50 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1355311924442540 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_INFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 640,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1359107880649600 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_NULL_VALUE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1020,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => 'Der Regiontitel der FB-Seiten darf nicht leer sein => &P1_NULL_VALUE. mit NULL funktioniert');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2075910330746488 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 351,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'BETREUER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2733927850382550 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_PREPARE_URL_PW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 860,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prepare Url Pw',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2979030067695646 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_FRAGEBOGEN_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 410,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3194309302340800 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB1_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 420,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab1_kategorie_id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3195319691343782 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB2_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 430,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab2_kategorie_id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3290318492507295 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB3_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 440,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab3 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3368016487880300 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB4_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 441,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab4 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3369102073885570 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB5_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 442,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab5 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3370332548894342 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB6_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 443,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab6 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3371113978898500 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB7_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 444,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab7 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3371924367901431 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB8_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 445,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab8 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3373208915906495 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB9_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 446,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab9 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3374021035909971 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB10_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 447,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab10 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3374831425913014 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB4_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 462,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab4 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3375411816916753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB5_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 463,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab5 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3376219781919104 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB6_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 464,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab6 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3377000865923107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB8_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 466,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab8 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3377814371926946 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB7_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 465,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab7 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3378624761929954 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB9_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 467,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab9 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3379403767933389 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB10_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 468,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab10 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3498207273831328 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 560,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3500412252842275 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BL_PASSWORT_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 580,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Passwort ändern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Passwort Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3503123727873960 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 590,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Speichern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Speichern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3745819296109300 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_FEHLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 630,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3752310844383992 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 113,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'IDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3752520541386787 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3752727813388867 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_MOBILTELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 165,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'MOBILTELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3752903010391215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 270,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 22,
  p_cMaxlength=> 2000,
  p_cHeight=> 2,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3863409290724188 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BL_WEITER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 598,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3865103908959163 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_NEXT_PAGE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1030,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3873904446120082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_REGION_TITEL_PWD_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 601,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Pwd Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3937231409562379 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_FAX',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'FAX',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3937407299564910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 168,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'URL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4138806477547415 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_HINWEISTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 940,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Hinweistext',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4139014442549803 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_HINWEISTITEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 950,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Hinweistitel',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4215828152551194 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1040,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4824326998618604 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_REGION_TITEL_HILFETEXTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 600,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Hilfetexte',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4863927532683234 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_GEWICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 148,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160;&#160;',
  p_source=>'GEWICHT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4864107231686897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_GROESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 149,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_pre_element_text=>'&#160;',
  p_post_element_text=>'&#160;&#160;&#160;',
  p_source=>'GROESSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5065908583464293 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 750,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5109226169914171 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BEARB_MODUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 770,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bearb Modus',
  p_source=>'BEARBEITEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5198507431696835 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB90_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 469,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5199223361701429 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB90_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 449,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5275405678063414 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_REGION_TITEL_INFOTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 602,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5287931682133195 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BL_VERWERFEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 592,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5292632708222651 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB91_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 470,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab91 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5294032493232068 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB91_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 450,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab91 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5332530397092546 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_AENDERBAR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 830,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Aenderbar',
  p_source=>'AENDERBAR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5342112857115681 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_REGION_TITEL_HRV',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 603,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Hilfetexte',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5380021385462532 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BL_HRV_LADEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 597,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Auswertung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5555801986330264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1080,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'zurueck',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5626020269094190 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_ABMELDEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 960,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Abmelden',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5626402453565526 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_PERGEBNIS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 680,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persergebnis Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5626529020153535 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 760,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5684602003292204 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_PERSON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 710,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Person',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5777303001656590 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB95_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 451,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab92 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5777513390659593 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB95_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 471,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab92 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5777724818662904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB95_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 512,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'TAB92_KATEGORIE_ZEILEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5782508607837959 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_PAGE_AUSWERTUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1000,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Auswertung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5815017662548617 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_USER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 720,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pisuser',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => 'Bei externen Aufrufen wie z.B PIS kann hier der User angegeben werden, der die Erfassung durchführt, da externe Aufrufe immer mit einem Standard-User angemeldet  werden und so keine Zuordnung mehr für DB-Operationen möglich wäre. Der User wird beim Speichern der Antworten übergeben, falls dieser NULL ist wird der App-User genommen.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5928312667012412 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB1_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5928926865016565 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB2_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 501,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5929503794019332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB3_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 502,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5930113490022110 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB4_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 503,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5931030459027023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB5_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 504,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5931606002029395 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB6_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 505,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5932212582031343 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB7_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 506,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5934321371043287 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB8_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 507,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5934927604045135 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB9_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 508,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5935502801047410 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB10_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 509,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5936111113049796 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB90_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5936725658054039 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB91_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 511,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6268921644775642 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_NV_FRAGEBOGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1010,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Fragebogen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6294900682299810 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB1_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 458,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab1 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6295221461305834 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB2_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 459,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab2 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6295430811308540 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_TAB3_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 460,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab3 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7132706543801860 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_REGION_TITEL_MODUL_AUSW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 613,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7135827584826862 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_FKAT_MODULE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1100,
  p_item_plug_id => 7132411261793773+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'select LISTAGG(b, '':'') WITHIN GROUP (ORDER BY c) b'||unistr('\000a')||
'from ('||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(fkm.bezeichnung_text_id,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b ,sortierung c'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot, FKATEGORIE_MODULE fkm, PERGEBNIS_MODUL_AUSWAHL pma'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 39 /* Zusatzmodule */'||unistr('\000a')||
'  and ow.wert = fkm.ID'||unistr('\000a')||
'  and pma.FKAT_MODUL_ID = ow.wert'||unistr('\000a')||
'  and pma.PERGEBNIS_ID = :P1_PERGEBNIS_ID'||unistr('\000a')||
'order by c'||unistr('\000a')||
')',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_SHUTTLE',
  p_lov=> 'select a, b'||unistr('\000a')||
'from ('||unistr('\000a')||
'SELECT * FROM('||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(fkm.bezeichnung_text_id,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b ,sortierung c'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot, FKATEGORIE_MODULE fkm'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 39 /* Zusatzmodule */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and ow.wert = fkm.ID'||unistr('\000a')||
'   -- Identität des eingeloggten'||unistr('\000a')||
'  and (po.persstamm_id = frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          FRGBG_S.GET_IDENTITAET_BETR(:FAS_LOGIN_PERSONENSTAMM_ID)) /*Persid des Subsets sonst null */'||unistr('\000a')||
'   -- Aktive Dientität '||unistr('\000a')||
'   or po.persstamm_id = frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'  )'||unistr('\000a')||
'  '||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(fkm.bezeichnung_text_id,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b ,sortierung c'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot, FKATEGORIE_MODULE fkm, PERGEBNIS_MODUL_AUSWAHL pma'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 39 /* Zusatzmodule */'||unistr('\000a')||
'  and ow.wert = fkm.ID'||unistr('\000a')||
'  and pma.FKAT_MODUL_ID = ow.wert'||unistr('\000a')||
'  and pma.PERGEBNIS_ID = :P1_PERGEBNIS_ID'||unistr('\000a')||
')'||unistr('\000a')||
'order by c'||unistr('\000a')||
')',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 150,
  p_cMaxlength=> 4000,
  p_cHeight=> 10,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'style="width:300px;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'FRGBG_S.FB_CHECK_AUSWERTUNG(:P1_PERGEBNIS_ID) = 0',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'MOVE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7137416988908979 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_BL_SAVE_MODUL_AUSW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1100,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Auswertung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7168717072739593 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Login Benutzer Name ist nicht veränderbar.';

wwv_flow_api.create_page_item(
  p_id=>7168827716739595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 112,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'USER_ACCOUNT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von != ''BETREUER''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when=>':P1_ID is not null',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>7169410652739603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>7169627880739603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 122,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'VORNAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>7169815624739603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_STRASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 124,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'STRASSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 10 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>7170018549739603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 126,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte mit Postleitzahlen in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 10 Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>7170219852739603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_PLZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 128,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PLZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 100 beliebige Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>7170402514739603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_ORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 131,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Datumsangabe der Form TT.MM.JJJJ z.B. 20.11.2001';

wwv_flow_api.create_page_item(
  p_id=>7261332424327634 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 135,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'DD.MM.RRRR',
  p_source=>'GEBURTSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER_CLASSIC',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7291113610173051 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_FKAT_MODUL_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1090,
  p_item_plug_id => 7132411261793773+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select case when FRGBG_S.FB_CHECK_AUSWERTUNG(:P1_PERGEBNIS_ID) = 0'||unistr('\000a')||
'then'||unistr('\000a')||
'   frgbg_s.holen_uebersetzung(9177,:FAS_SPRACHE_ID)'||unistr('\000a')||
'else'||unistr('\000a')||
'  frgbg_s.holen_uebersetzung(9475,:FAS_SPRACHE_ID)  '||unistr('\000a')||
'end from dual',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Anzeigesprache';

wwv_flow_api.create_page_item(
  p_id=>7327021068748275 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 147,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      -- Sprache des Patienten von der Betreuer-Sprache ableiten'||unistr('\000a')||
'      :p1_app_sprache_id := frgbg_s.get_app_sprache_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT min(s.id) into :p1_app_sprache_id'||unistr('\000a')||
'      FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'      WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'        and fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'        AND s.standard = 1;     -- Defaultsprache       '||unistr('\000a')||
'      IF v_sprache_id is NULL THEN'||unistr('\000a')||
'         SELECT min(s.id) into :p1_app_sprache_id'||unistr('\000a')||
'         FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'         WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'           and fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'           AND s.aktiv=1; -- NEI 09.09.2014'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN (:p1_app_sprache_id);'||unistr('\000a')||
'END;',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'APP_SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select s.sprache display_value, s.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs '||unistr('\000a')||
'where fs.id = :fas_pers_schema_id'||unistr('\000a')||
'  and fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'  -- and s.sprache_id in (select sprache_id from uebersetzungen) '||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7941327369339645 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_MUTDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 780,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutdat',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9499730499597006 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_FB_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 411,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10188705467758759 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_PERS_READONLY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1110,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>10310212010938304 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_ADRESSZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 123,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSZUSATZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 40,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11331907857486731 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_ANREDE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 117,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ANREDE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select  '||unistr('\000a')||
' fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',ID,:fas_sprache_id) a,'||unistr('\000a')||
' id b'||unistr('\000a')||
'from anreden_frgbg',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Das eingegebene Land wird auf Existenz geprüft. Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>12107010169964262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 132,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'DECLARE '||unistr('\000a')||
'   v_land_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      v_land_id := frgbg_s.get_betreuer_land_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      v_land_id := NULL;   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN v_land_id;'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select substr(fas_synch.get_tab_uebersetzung(''LAND.LAND'',id,:fas_sprache_id),1,27)  a, id b'||unistr('\000a')||
'from v_laender'||unistr('\000a')||
'order by sort',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p1_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P1_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12216627490563512 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 1,
  p_name=>'P1_HEIGHT_SCROLLREGION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 800,
  p_item_plug_id => 7168017465739576+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4829714365663865 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P1_LAND_ID',
  p_validation_sequence=> 1,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P1_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'')'||unistr('\000a')||
'and :fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_when_button_pressed=> 7168305288739579 + wwv_flow_api.g_id_offset,
  p_associated_item=> 12107010169964262 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7179200746837900 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P1_LAND_exists',
  p_validation_sequence=> 23,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p1_land_id IS NOT NULL THEN'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM   v_laender'||unistr('\000a')||
'      --WHERE  UPPER(land) = UPPER(:p1_land);'||unistr('\000a')||
'      WHERE id = :p1_land_id;'||unistr('\000a')||
'      IF v_anz != 1 THEN'||unistr('\000a')||
'         --RETURN(''Ungültige Eingabe im Feld Land!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'      '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Land ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,frgbg_s.get_sprache_id(:APP_USER),'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,frgbg_s.get_sprache_id(:APP_USER),'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(211,frgbg_s.get_sprache_id(:APP_USER))),'||unistr('\000a')||
'                              ''Validierung P1_land_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'')'||unistr('\000a')||
'and :fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 12107010169964262 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7180622563844237 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P1_PLZ_ORT_exists',
  p_validation_sequence=> 33,
  p_validation => 'DECLARE'||unistr('\000a')||
'    v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --IF UPPER(:p1_land) = ''SCHWEIZ'' THEN'||unistr('\000a')||
'   IF :p1_land_id IS NOT NULL AND :p1_ort IS NOT NULL AND :p1_plz IS NOT NULL'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      IF :p1_land_id = 198   and   -- Schweiz'||unistr('\000a')||
'         :P1_EXTERN_VERWALTET = 0  -- NEI 11.07.13 Nur FAS-Verwaltete Aufträge prüfen, '||unistr('\000a')||
'                                     -- da nur diese PLZ/Ort verändert werden können,'||unistr('\000a')||
'                                     -- sonst ist GUS führend und die Änderungen kommen von dort'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         select count(*) INTO v_anz'||unistr('\000a')||
'         from v_orte'||unistr('\000a')||
'         where upper(ort) = upper(:p1_ort)'||unistr('\000a')||
'           and plz = :p1_plz;'||unistr('\000a')||
'         IF v_anz = 0 THEN'||unistr('\000a')||
'            --RETURN(''PLZ/Ort-Kombination ist ungültig!'');'||unistr('\000a')||
'            RETURN(frgbg_s.holen_uebersetzung(179,'||unistr('\000a')||
'                   :fas_sprache_id));'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Ort bzw. PLZ ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(209,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P1_plz_ort_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'') '||unistr('\000a')||
'and :fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 7170219852739603 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7262720912343300 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p1_geburtsdatum_not_null',
  p_validation_sequence=> 43,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P1_GEBURTSDATUM IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'')'||unistr('\000a')||
'and :fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 7261332424327634 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7265119789361903 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p1_geburtdatum_must_be_date',
  p_validation_sequence=> 53,
  p_validation => 'BEGIN'||unistr('\000a')||
'    IF :P1_GEBURTSDATUM IS NOT NULL THEN'||unistr('\000a')||
'      :P1_GEBURTSDATUM := '||unistr('\000a')||
'          to_char(to_date(:P1_GEBURTSDATUM,''DD.MM.RRRR''),''DD.MM.RRRR'');'||unistr('\000a')||
'      IF to_date(:P1_GEBURTSDATUM,''DD.MM.RRRR'') >= trunc(sysdate,''DD'')THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(9430,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(HTMLDB_LANG.MESSAGE(''DATUM_UNGUELTIG''));'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Ungültiges Datum!',
  p_always_execute=>'N',
  p_validation_condition=> ':p1_geburtsdatum is not null and'||unistr('\000a')||
':request in (''WEITER'',''SAVE'',''CREATE'')'||unistr('\000a')||
'and :fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 7261332424327634 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 2034014689456153 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p1_name_not_null',
  p_validation_sequence=> 93,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P1_NAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(206,:fas_sprache_id)));'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'')'||unistr('\000a')||
'and :fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 7169410652739603 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 2035200968461621 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P1_VORNAME_not_null',
  p_validation_sequence=> 103,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P1_VORNAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(205,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'')'||unistr('\000a')||
'and :fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 7169627880739603 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 2038230750470240 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P1_PLZ_not_null',
  p_validation_sequence=> 133,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P1_PLZ IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(209,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'-- NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'')'||unistr('\000a')||
'and :fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 7170219852739603 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 2039107332472910 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P1_ORT_not_null',
  p_validation_sequence=> 143,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P1_ORT IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(210,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'')'||unistr('\000a')||
'and :fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 7170402514739603 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5177517977783748 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_pflichtige_persfelder',
  p_validation_sequence=> 165,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_pruefbedingung NUMBER;'||unistr('\000a')||
'   v_geburtsdatum   personenstamm.geburtsdatum%TYPE;'||unistr('\000a')||
'   v_anrede_id      personenstamm.anrede_id%TYPE;'||unistr('\000a')||
'   v_text           VARCHAR2(10);'||unistr('\000a')||
'   v_fehlertext     VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT pruefbedingung INTO v_pruefbedingung'||unistr('\000a')||
'   FROM fragebogen'||unistr('\000a')||
'   WHERE id = :p1_fragebogen_id;'||unistr('\000a')||
'   SELECT geburtsdatum,anrede_id into v_geburtsdatum, v_anrede_id'||unistr('\000a')||
'   from personenstamm'||unistr('\000a')||
'   where id = :p1_id;'||unistr('\000a')||
'   IF v_pruefbedingung = 1 THEN'||unistr('\000a')||
'      IF v_geburtsdatum IS NULL THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(212,:fas_sprache_id))||'' ''||frgbg_s.holen_uebersetzung(4893,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_anrede_id is null OR '||unistr('\000a')||
'         v_anrede_id not in (3,4) -- Gültige Werte Mann/Frau'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         v_text :=   '||unistr('\000a')||
'          fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',3,:fas_sprache_id)'||unistr('\000a')||
'          ||''/''||'||unistr('\000a')||
'         fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',4,:fas_sprache_id);'||unistr('\000a')||
'         v_fehlertext := v_fehlertext||''<br/>''||'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(2973,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(204,:fas_sprache_id),v_text)||'' ''||frgbg_s.holen_uebersetzung(4894,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_fehlertext is not null THEN'||unistr('\000a')||
'         RETURN(v_fehlertext);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':p1_pergebnis_id is not null and :request = ''SAVE''',
  p_validation_condition_type=> 'NEVER',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3614607899709555 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_pflichtige_plz',
  p_validation_sequence=> 190,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_fehlertext     VARCHAR2 (2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON = ''ANONYM'' THEN'||unistr('\000a')||
'      -- ''Die Angabe der PLZ ist pflichtig, damit eine sinnvolle Apotheken-Liste ...'';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(4895,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN v_fehlertext;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':p1_pergebnis_id is not null and :request = ''SAVE'' AND '||unistr('\000a')||
':FAS_AUFGERUFEN_VON = ''ANONYM''',
  p_validation_condition_type=> 'NEVER',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3703908339130925 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_pflichtige_antworten',
  p_validation_sequence=> 200,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT count(*) INTO v_anz'||unistr('\000a')||
'   FROM v_alle_fragen'||unistr('\000a')||
'   WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'     and ((frage_eingabepflichtig=1 and status=2) -- unbeantw.pflichtige Fragen'||unistr('\000a')||
'          or'||unistr('\000a')||
'          (frage_eingabepflichtig=1 and status = 0)  -- unvollständig beantwortete pflichtige Fragen'||unistr('\000a')||
'         )'||unistr('\000a')||
'     and frage_fragelevel = 0 /* Keine Metafragen */;'||unistr('\000a')||
'   IF v_anz > 0 THEN'||unistr('\000a')||
'      -- RETURN (''Der Fragebogen ist noch nicht komplett ausgefüllt! Bitte auf der Übersichtsseite kontrollieren!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(1665,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(245,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':p1_pergebnis_id is not null and :request = ''SAVE''',
  p_validation_condition_type=> 'NEVER',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4057425609871331 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_hrv_datei',
  p_validation_sequence=> 210,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P1_hrv_datei is null THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(5520,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 4056729101749365 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4866724124136452 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P1_GEWICHT_Bereich',
  p_validation_sequence=> 230,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_zahl   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p1_gewicht is not null THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         v_zahl := frgbg_s.FB_FORMAT_FANT_WERT(:P1_GEWICHT,''999D9'',1);'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2151,:fas_sprache_id)||'': ''||'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(3533,:fas_sprache_id));'||unistr('\000a')||
'      END; '||unistr('\000a')||
'      :p1_gewicht:= v_zahl;'||unistr('\000a')||
'      IF :p1_gewicht < 17 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2173,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(2151,:fas_sprache_id),17));      '||unistr('\000a')||
'      ELSIF :p1_gewicht > 150 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2174,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(2151,:fas_sprache_id),150));      '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4866929665138028 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P1_GROESSE_BEREICH',
  p_validation_sequence=> 240,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_zahl   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p1_groesse is not null THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         v_zahl := frgbg_s.FB_FORMAT_FANT_WERT(:P1_groesse ,''999D9'',1);'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(4,:fas_sprache_id)||'': ''||'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(3533,:fas_sprache_id));'||unistr('\000a')||
'      END; '||unistr('\000a')||
'      :p1_groesse := v_zahl;'||unistr('\000a')||
'      IF :p1_groesse < 120 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2173,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(4,:fas_sprache_id),120));      '||unistr('\000a')||
'      ELSIF :p1_groesse > 230 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2174,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(4,:fas_sprache_id),230));      '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''WEITER'',''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'    /*:p1_satzkennzeichen := ''GELOESCHT''; */'||unistr('\000a')||
'    NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7200322618998553 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_satz_delete',
  p_process_sql_clob => p,
  p_process_error_message=> 'Datensatz konnte nicht gelöscht werden!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>7168202772739579 + wwv_flow_api.g_id_offset,
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> 'Datensatz wurde erfolgreich gelöscht!',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :p1_id IS NULL THEN'||unistr('\000a')||
'      :p1_erfuser := NVL(:p1_user,:APP_USER);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5069202396490950 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'erfuser_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>7168415639739579 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p1_mutuser := NVL(:p1_user,:APP_USER);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5070705990501415 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mutuser_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SAVE'',''DELETE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'IF :p1_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'   :p1_land_id := NULL;'||unistr('\000a')||
'END IF;';

wwv_flow_api.create_page_process(
  p_id     => 3008214546227065 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 52,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_land_id_null',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:PERSONENSTAMM:P1_ID:ID|IU';

wwv_flow_api.create_page_process(
  p_id     => 7171911437739609 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 140,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Zeile von PERSONENSTAMM verarbeiten',
  p_process_sql_clob => p,
  p_process_error_message=> '&P1_FEHLER.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'--:request in (''CREATE'',''DELETE'',''SAVE'')  '||unistr('\000a')||
'(:request in (''WEITER'',''HRV_DATEN_LADEN'',''LÖSCHEN_HRV'') AND'||unistr('\000a')||
' :P1_ID is not null and'||unistr('\000a')||
' :fas_pers_aenderbar = 1         /* Personendaten aenderbar */'||unistr('\000a')||
')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '&P1_INFO.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_blob        blob;'||unistr('\000a')||
'   v_clob        clob;'||unistr('\000a')||
'   v_dateiname   varchar2(2000);--hrv.DATEN_DATEINAME%type;'||unistr('\000a')||
'   v_mimetype    varchar2(2000);--hrv.DATEN_MIME_TYPE%type;'||unistr('\000a')||
'   v_anz         number;'||unistr('\000a')||
'   '||unistr('\000a')||
'   v_return        number;'||unistr('\000a')||
'   v_fehlermeldung varchar2(2000);'||unistr('\000a')||
'   v_fehlernummer  number;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'   v_fehler        EXCEPTION;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P1_HRV_DATEI IS NULL THEN'||unistr('\000a')||
'      --''Dat';

p:=p||'einame muss angegeben sein!5531'';'||unistr('\000a')||
'      :p1_hrv_meldung:= frgbg_s.holen_uebersetzung(5531,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung;'||unistr('\000a')||
'      v_fehlernummer := -10;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--mel.p(''Dateiname:%1'',v_prot_id,''TEST'',''102/1: hrv_daten_laden'',:P1_HRV_DATEI);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Holen der Datei'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      select'||unistr('\000a')||
'         blob_content,'||unistr('\000a')||
'         filename,'||unistr('\000a')||
'         mime_type'||unistr('\000a')||
' ';

p:=p||'     into v_blob, v_dateiname, v_mimetype'||unistr('\000a')||
'      from wwv_flow_files '||unistr('\000a')||
'      where name = :P1_HRV_DATEI;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others then '||unistr('\000a')||
'      v_fehlermeldung := SQLERRM;'||unistr('\000a')||
'      -- ''Hochladevorgang der Datei konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'      :p1_hrv_meldung := frgbg_s.holen_uebersetzung(5523,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung ||'' ''||v_fehlermeldung;'||unistr('\000a')||
'      v_fehlernum';

p:=p||'mer := -20;'||unistr('\000a')||
'      RAISE v_fehler;  '||unistr('\000a')||
'   END;'||unistr('\000a')||
'--mel.p(''Dateiname:%1,%2'',v_prot_id,''TEST'',''102/1: hrv_daten_laden'',:P1_HRV_DATEI,v_dateiname);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Der Blob in V_DATEI kann hier weiter verarbeitet werden:'||unistr('\000a')||
'   -- * Umwandeln in ein CLOB'||unistr('\000a')||
'   -- * Bildbearbeitung mit ORDIMAGE-Methoden'||unistr('\000a')||
'   -- * ...'||unistr('\000a')||
''||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'   -- In clob konvertieren inklusive unzip fals erforderlich'||unistr('\000a')||
'   v_return := HRV.HRV_FILE.convert_t';

p:=p||'o_clob('||unistr('\000a')||
'       p_file           => v_blob,'||unistr('\000a')||
'       p_file_name      => v_dateiname,'||unistr('\000a')||
'       p_output         => v_clob,'||unistr('\000a')||
'       p_output_file_name => v_dateiname); -- liefert eventuell einen Dateinamen aus dem Archiv'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'    when others then'||unistr('\000a')||
'      v_fehlermeldung := SQLERRM;'||unistr('\000a')||
'      -- ''Datei konnte nicht ordnungsgemäss validiert werden!5525 HRV-Ladevorgang abgebrochen!5524'';'||unistr('\000a')||
'      :p1_hrv_mel';

p:=p||'dung :=frgbg_s.holen_uebersetzung(5523,:fas_sprache_id)||'' ''||                 '||unistr('\000a')||
'                        frgbg_s.holen_uebersetzung(5524,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung ||'' ''||v_fehlermeldung;'||unistr('\000a')||
'      v_fehlernummer := -24;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   end;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_return = 0 THEN  -- OK 0: keine Fehler, Datei konnte in CLOB umgewandelt werden'||unistr('\000a')||
'      null;'||unistr('\000a')||
'   ELSIF v_return = -';

p:=p||'1 THEN  -- -1: Zip-Archiv ist leer'||unistr('\000a')||
'      :p1_hrv_meldung := frgbg_s.holen_uebersetzung(5523 /*8425*/,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung;'||unistr('\000a')||
'      v_fehlernummer  :=-25;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   ELSIF v_return = -2 THEN  -- -1: Dateityp ist nicht bekannt 5530'||unistr('\000a')||
'      :p1_hrv_meldung := frgbg_s.holen_uebersetzung(5530,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung;'||unistr('\000a')||
'   ';

p:=p||'   v_fehlernummer  :=-26;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Hochladevorgang der Datei konnte nicht durchgeführt werden!;'||unistr('\000a')||
'      :p1_hrv_meldung := frgbg_s.holen_uebersetzung(5523,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung||''(''||v_return||'')'';'||unistr('\000a')||
'      v_fehlernummer  :=-27;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END IF;    '||unistr('\000a')||
''||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      -- Speichern in HRV '||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
' ';

p:=p||'     FROM hrv.hrv'||unistr('\000a')||
'      WHERE pergebnisse_id = :p1_pergebnis_id;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz = 0 THEN'||unistr('\000a')||
'         hrv_table.insert_hrv( p_pergebnisse_id  => :p1_pergebnis_id,'||unistr('\000a')||
'                               p_daten           => v_clob,'||unistr('\000a')||
'                               p_daten_dateiname => v_dateiname,'||unistr('\000a')||
'                               p_daten_mime_type => v_mimetype,'||unistr('\000a')||
'                               p_daten_ladezeitpunk';

p:=p||'t => sysdate,'||unistr('\000a')||
'                               p_bemerkungen     => NULL);'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         hrv_table.update_hrv( p_pergebnisse_id  => :p1_pergebnis_id,'||unistr('\000a')||
'                               p_daten           => v_clob,'||unistr('\000a')||
'                               p_daten_dateiname => v_dateiname,'||unistr('\000a')||
'                               p_daten_mime_type => v_mimetype,'||unistr('\000a')||
'                               p_daten_ladezeitpunkt => s';

p:=p||'ysdate,'||unistr('\000a')||
'                               p_status          => 0,'||unistr('\000a')||
'                               p_bemerkungen     => NULL);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      v_fehlermeldung := SQLERRM;'||unistr('\000a')||
'      -- ''Datei konnte nicht ordnungsgemäss gespeichert werden! HRV-Ladevorgang abgebrochen!5524'';'||unistr('\000a')||
'      :p1_hrv_meldung :=frgbg_s.holen_uebersetzung(5533,:fas_sprache_id)||'' ''||                 '||unistr('\000a')||
' ';

p:=p||'                       frgbg_s.holen_uebersetzung(5524,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung ||'' ''||v_fehlermeldung;'||unistr('\000a')||
'      v_fehlernummer := -25;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Wichtig: Die Datei muss aus WWV_FLOW_FILES gelöscht werden;'||unistr('\000a')||
'   -- das passiert nicht automatisch!'||unistr('\000a')||
'   delete from wwv_flow_files where name = :P1_HRV_DATEI;'||unistr('\000a')||
''||unistr('\000a')||
'   -- HRV-Datei validieren'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'   ';

p:=p||'   v_return := hrv_table.validate_file(:p1_pergebnis_id);'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      v_fehlermeldung := SQLERRM;'||unistr('\000a')||
'      -- ''Datei konnte nicht ordnungsgemäss validiert werden!5525 HRV-Ladevorgang abgebrochen!5524'';'||unistr('\000a')||
'      :p1_hrv_meldung :=frgbg_s.holen_uebersetzung(5523,:fas_sprache_id)||'' ''||                 '||unistr('\000a')||
'                        frgbg_s.holen_uebersetzung(5524,:fas_sprache_id);'||unistr('\000a')||
'   ';

p:=p||'   v_fehlermeldung := :p1_hrv_meldung ||'' ''||v_fehlermeldung;'||unistr('\000a')||
'      v_fehlernummer := -30;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_return = 0 THEN  -- OK 0: keine Fehler, Datei ist gültig'||unistr('\000a')||
'      :p1_hrv_meldung := frgbg_s.holen_uebersetzung(5526,:fas_sprache_id);'||unistr('\000a')||
'   ELSIF v_return = -1 THEN  -- -1: Datei ist zur gross 5527'||unistr('\000a')||
'      :p1_hrv_meldung:= frgbg_s.holen_uebersetzung(5527,:fas_sprache_id);'||unistr('\000a')||
'   ';

p:=p||'   v_fehlermeldung := :p1_hrv_meldung;'||unistr('\000a')||
'      v_fehlernummer  :=-41;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   ELSIF v_return = -2 THEN  -- -2: Dateiinhalt ist ungültig 5528'||unistr('\000a')||
'      :p1_hrv_meldung:= frgbg_s.holen_uebersetzung(5528,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung;'||unistr('\000a')||
'      v_fehlernummer  :=-42;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   ELSIF v_return = -3 THEN  -- -3: Dateiname lässt Dateityp nicht erkennen 5';

p:=p||'529'||unistr('\000a')||
'      :p1_hrv_meldung:= frgbg_s.holen_uebersetzung(5529,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung;'||unistr('\000a')||
'      v_fehlernummer  :=-43;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   ELSIF v_return = -4 THEN  -- -4: Dateityp ist nicht bekannt 5530'||unistr('\000a')||
'      :p1_hrv_meldung := frgbg_s.holen_uebersetzung(5530,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung;'||unistr('\000a')||
'      v_fehlernummer  :=-44;'||unistr('\000a')||
'      RAISE v_f';

p:=p||'ehler;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Hochladevorgang der Datei konnte nicht durchgeführt werden!;'||unistr('\000a')||
'      :p1_hrv_meldung := frgbg_s.holen_uebersetzung(5523,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung||''(''||v_return||'')'';'||unistr('\000a')||
'      v_fehlernummer  :=-50;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END IF;    '||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   mel.p(v_fehlermeldung,v_prot_id,''ERROR'',''102/1: hrv_daten_laden[''||v_fehlernumme';

p:=p||'r||'']'');'||unistr('\000a')||
'   ROLLBACK;'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   v_fehlermeldung := ''Interner FEHLER beim Laden der HRV-Datei! ''||'' ''|| SQLERRM;'||unistr('\000a')||
'   v_fehlernummer:= -9999;'||unistr('\000a')||
'   mel.p(v_fehlermeldung,v_prot_id,''ERROR'',''102/1: hrv_daten_laden[''||v_fehlernummer||'']'');'||unistr('\000a')||
'   :p1_hrv_meldung :=''Hochladevorgang der Datei konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'   ROLLBACK;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4059419993964285 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 142,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hrv_daten_laden',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>4056729101749365 + wwv_flow_api.g_id_offset,
  p_process_when=>'HRV_TABLE.get_hrv_status(:P1_PERGEBNIS_ID) is null or HRV_TABLE.get_hrv_status(:P1_PERGEBNIS_ID) < 10 or HRV_TABLE.get_hrv_status(:P1_PERGEBNIS_ID) >= 20',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_blob        blob;'||unistr('\000a')||
'   v_clob        clob;'||unistr('\000a')||
'   v_dateiname   varchar2(2000);--hrv.DATEN_DATEINAME%type;'||unistr('\000a')||
'   v_mimetype    varchar2(2000);--hrv.DATEN_MIME_TYPE%type;'||unistr('\000a')||
'   v_anz         number;'||unistr('\000a')||
'   '||unistr('\000a')||
'   v_return        number;'||unistr('\000a')||
'   v_fehlermeldung varchar2(2000);'||unistr('\000a')||
'   v_fehlernummer  number;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'   v_fehler        EXCEPTION;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''Dateiname:%1'',v_prot_id,''TEST'',''102';

p:=p||'/1: hrv_daten_loeschen'',:P1_HRV_DATEI);'||unistr('\000a')||
'   -- HRV-Daten löschen'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      hrv_table.delete_hrv(:p1_pergebnis_id);'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      v_fehlermeldung := SQLERRM;'||unistr('\000a')||
'      -- ''Daten konnten nicht ordnungsgemäss gelöscht werden!5897;'||unistr('\000a')||
'      :p1_hrv_meldung :=frgbg_s.holen_uebersetzung(5897,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlermeldung := :p1_hrv_meldung ||'' ''||v_fehlermeldung;'||unistr('\000a')||
'      v_';

p:=p||'fehlernummer := -30;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   mel.p(v_fehlermeldung,v_prot_id,''ERROR'',''102/1: hrv_daten_loeschen[''||v_fehlernummer||'']'');'||unistr('\000a')||
'   ROLLBACK;'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   v_fehlermeldung := ''Interner FEHLER beim Löschen der HRV-Datei! ''||'' ''|| SQLERRM;'||unistr('\000a')||
'   v_fehlernummer:= -9999;'||unistr('\000a')||
'   mel.p(v_fehlermeldung,v_prot_id,''ERROR'',''102/1: hrv_daten_loeschen[''||v_fehlern';

p:=p||'ummer||'']'');'||unistr('\000a')||
'   :p1_hrv_meldung :=''Hochladevorgang der Datei konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'   ROLLBACK;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4824126820563240 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 143,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hrv_daten_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>4823129582488299 + wwv_flow_api.g_id_offset,
  p_process_when=>'HRV_TABLE.get_hrv_status(:P1_PERGEBNIS_ID) is null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'-- Da evt. beim Speichern die Patientensprache geändert wird, kann dies '||unistr('\000a')||
'-- auf die FAS-Sprache auswirkungen haben => FAS-Sprache neu bestimmen'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :fas_sprache_id:= frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 9331519617051009 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 145,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fas_sprache_festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 2175519022592003 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 160,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_return        number;'||unistr('\000a')||
'   v_fehlermeldung varchar2(2000);'||unistr('\000a')||
'   v_fehlernummer  number;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'   v_fehler        EXCEPTION;'||unistr('\000a')||
'   v_fehler_d      EXCEPTION;'||unistr('\000a')||
''||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   v_return := FRGBG_S.FB_SPEICHER_ZUSATZMODUL_AUSW('||unistr('\000a')||
'       p_pergebnis_id        => :P1_PERGEBNIS_ID,'||unistr('\000a')||
'       p_zusatzmodul_liste   => :P1_FKAT_MODULE'||unistr('\000a')||
'  );'||unistr('\000a')||
''||unistr('\000a')||
'   if v_return = -10 then'||unistr('\000a')||
'        -- Ein Modul das';

p:=p||' bereits eine nicht bearbeitbare Frage hat ist nicht mehr in der '||unistr('\000a')||
'        -- Auswahl enthalten'||unistr('\000a')||
'        v_fehlermeldung := frgbg_s.holen_uebersetzung(9183,:FAS_SPRACHE_ID);'||unistr('\000a')||
'        raise v_fehler_d;'||unistr('\000a')||
'   elsif v_return = -20 then'||unistr('\000a')||
'        -- Es existiert bereits ein Warenkorb der ein Zusatzmodul erfordert,'||unistr('\000a')||
'        -- dieses fehlt aber in der Auswahl'||unistr('\000a')||
'        v_fehlermeldung := frgbg_s.holen_uebersetzun';

p:=p||'g(10024,:FAS_SPRACHE_ID);'||unistr('\000a')||
'        raise v_fehler_d;'||unistr('\000a')||
'   elsif v_return = -30 then'||unistr('\000a')||
'        -- Es wurde mehr als ein Labor-Zusatzmodul ausgewählt'||unistr('\000a')||
'        v_fehlermeldung := frgbg_s.holen_uebersetzung(10017,:FAS_SPRACHE_ID);'||unistr('\000a')||
'        raise v_fehler_d;'||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Die Auswahl der Zusatzmodule wurde gespeichert. '||unistr('\000a')||
'   apex_application.g_print_success_message := frgbg_s.holen_uebersetzung(9126,:FAS_SP';

p:=p||'RACHE_ID);'||unistr('\000a')||
'  '||unistr('\000a')||
'exception '||unistr('\000a')||
'   when v_fehler then'||unistr('\000a')||
'      mel.p(v_fehlermeldung,v_prot_id,''ERROR'',''102/1: Speicher Modulauswahl[''||v_fehlernummer||'']'');'||unistr('\000a')||
'      raise_application_error(-20000,frgbg_s.holen_uebersetzung(9125,:FAS_SPRACHE_ID));'||unistr('\000a')||
'   when v_fehler_d then'||unistr('\000a')||
'     raise_application_error(-20100,v_fehlermeldung);'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      v_fehlermeldung := ''Interner FEHLER beim Speichern der Zusat';

p:=p||'zmodule! ''||'' ''|| SQLERRM;'||unistr('\000a')||
'      v_fehlernummer:= -9999;'||unistr('\000a')||
'      mel.p(v_fehlermeldung,v_prot_id,''ERROR'',''102/1: Speicher Modulauswahl[''||v_fehlernummer||'']'');'||unistr('\000a')||
'      raise_application_error(-20000,frgbg_s.holen_uebersetzung(9125,:FAS_SPRACHE_ID));'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7138028903997573 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 170,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Speicher Modulauswahl',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>7137105991886882 + wwv_flow_api.g_id_offset,
  p_process_when=>'FRGBG_S.FB_CHECK_AUSWERTUNG(:P1_PERGEBNIS_ID) = 0',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   mel.p(''Testmeldung'',v_prot_id,''TEST'',''102/1:test_meldung'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3606130290264124 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'test_meldung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P1_HEIGHT_SCROLLREGION := :FAS_SCROLLREGION_HEIGHT_MAX *0.99; --0.9905;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12217101648565501 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p1_person is null THEN  '||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,frgbg_s.holen_uebersetzung(483,v_sprache_id));   '||unistr('\000a')||
'   ELSE  -- Aufruf via Pis p1_person oder via Fragebogenliste enthält bereits die Personenstamm_id'||unistr('\000a')||
'      :p1_id := :p1_person;'||unistr('\000a')||
'   END IF; '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7181419624881178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 9,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten',
  p_process_sql_clob => p,
  p_process_error_message=> 'Login ungültig!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'Y',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   --v_preislistentyp              preislisten.typ%TYPE;'||unistr('\000a')||
'   --v_sortiment_id                sortimente.id%TYPE; '||unistr('\000a')||
'   --v_preisliste_id               preislisten.id%TYPE;  '||unistr('\000a')||
'   --v_preislisten_land_id         preislisten.land_id%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'   v_user       VARCHAR2(100);'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;  --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'   v_return     number;';

p:=p||''||unistr('\000a')||
'   v_return2    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Auswertungsseite initialisieren'||unistr('\000a')||
'   :P1_PAGE_AUSWERTUNG := 95;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Setzte das Flag zurück, das sich die letzten Druckoptionen merkt. '||unistr('\000a')||
'   -- Wenn NULL werden die aus PERS_OPTIONEN verwendeten Standards genommen.'||unistr('\000a')||
'   :P95_DRUCK_OPTIONEN_CHECKED := null;'||unistr('\000a')||
'   -- Setzte die ausgewählten Labor Warenkörbe auf den Standard zurück'||unistr('\000a')||
'   :P95_LABOR_WARENKORB_IDS := null;'||unistr('\000a')||
'  ';

p:=p||' -- Fragebogen initialisieren'||unistr('\000a')||
'   IF :p1_fragebogen_id IS NULL THEN'||unistr('\000a')||
'      :p1_fragebogen_id := 1;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--MEL.P (''fragebogen_festlegen 0: FB %1, Version %2, Pers %3,%4'', v_PROT_ID, ''TEST'', ''seite 1 fragebogen festlegen'',:p1_fragebogen_id,:p1_fb_version,:p1_id);'||unistr('\000a')||
'   IF :p1_fb_version is not null THEN'||unistr('\000a')||
'      :p1_fragebogen_id := frgbg_s.FB_GEN_ID_VERS_NR(:p1_fragebogen_id,:p1_fb_version);'||unistr('\000a')||
'      :p';

p:=p||'1_fb_version := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--MEL.P (''fragebogen_festlegen 1: %1, %2,%3,%4'', v_PROT_ID, ''TEST'', ''seite 1 fragebogen festlegen'',:p1_fragebogen_id,:p1_fb_version,:p1_bearb_modus);'||unistr('\000a')||
''||unistr('\000a')||
'   IF :p1_bearb_modus = ''KOPIEREN'' THEN -- Neue Version erstellen'||unistr('\000a')||
'      -- Kopie erzeugen, da die alte Version bereits ein MNR besitzt '||unistr('\000a')||
'      -- und dann ist die neue Version bearbeitbar'||unistr('\000a')||
'      v_return :=  frgbg_s.pe';

p:=p||'rg_set_kopieren('||unistr('\000a')||
'                              :p1_pergebnis_id,'||unistr('\000a')||
'                              1    -- NEI 15.07.10 alte Antworten übernehmen'||unistr('\000a')||
'                            );'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'      IF v_return > 0 THEN -- Kopie erfolgreich => Neue ID'||unistr('\000a')||
'         :p1_bearb_modus := ''BEARBEITEN''; '||unistr('\000a')||
''||unistr('\000a')||
'         -- Kopiere auch die Modulauswahl'||unistr('\000a')||
'         v_return2 := frgbg_s.FB_KOPIERE_FKAT_MODUL_AUSWAHL('||unistr('\000a')||
'           p_pergeb';

p:=p||'nis_id_alt => :p1_pergebnis_id,'||unistr('\000a')||
'           p_pergebnis_id_neu => v_return,'||unistr('\000a')||
'           p_fas_login_personenstamm_id => :fas_login_personenstamm_id,'||unistr('\000a')||
'           p_fas_identitaet_persstamm_id => :fas_identitaet_persstamm_id --FRGBG_S.GET_IDENTITAET_BETR(:FAS_LOGIN_PERSONENSTAMM_ID)--'||unistr('\000a')||
'         );'||unistr('\000a')||
''||unistr('\000a')||
'         if(v_return2 > 0) then -- Beim Kopieren ist was schief gegangen.'||unistr('\000a')||
'            RAISE_APPLICATION_ER';

p:=p||'ROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      to_char(v_return),''perg_set_festlegen''));'||unistr('\000a')||
'         end if;'||unistr('\000a')||
'         :p1_pergebnis_id := v_return;'||unistr('\000a')||
'      ELSIF v_return < 0 THEN -- Fehler beim kopieren'||unistr('\000a')||
'         :p1_bearb_modus := ''ANZEIGEN''; '||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                        ';

p:=p||'              to_char(v_return),''perg_set_festlegen''));'||unistr('\000a')||
'      ELSE -- p1_pergebnis_id is null'||unistr('\000a')||
'         :p1_bearb_modus := ''ANZEIGEN''; '||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      ''90'',''perg_set_festlegen''));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSIF :p1_bearb_modus = ''KOPIEREN0'' THEN -- Neue Version erstellen'||unistr('\000a')||
''||unistr('\000a')||
'      -- Kopie erzeugen, d';

p:=p||'a die alte Version bereits ein MNR besitzt '||unistr('\000a')||
'      -- und dann ist die neue Version bearbeitbar'||unistr('\000a')||
'      v_return :=  frgbg_s.perg_set_kopieren('||unistr('\000a')||
'                              :p1_pergebnis_id,'||unistr('\000a')||
'                              0    -- NEI 15.07.10 alte Antworten nicht übernehmen'||unistr('\000a')||
'                            );'||unistr('\000a')||
'      IF v_return > 0 THEN -- Kopie erfolgreich => Neue ID'||unistr('\000a')||
'         :p1_bearb_modus := ''BEARBEITE';

p:=p||'N''; '||unistr('\000a')||
''||unistr('\000a')||
'         -- Kopiere auch die Modulauswahl'||unistr('\000a')||
'         v_return2 := frgbg_s.FB_KOPIERE_FKAT_MODUL_AUSWAHL('||unistr('\000a')||
'           p_pergebnis_id_alt => :p1_pergebnis_id,'||unistr('\000a')||
'           p_pergebnis_id_neu => v_return,'||unistr('\000a')||
'           p_fas_login_personenstamm_id => :fas_login_personenstamm_id,'||unistr('\000a')||
'           p_fas_identitaet_persstamm_id => :fas_identitaet_persstamm_id'||unistr('\000a')||
'         );'||unistr('\000a')||
''||unistr('\000a')||
'         if(v_return2 > 0) then -- Beim';

p:=p||' Kopieren ist was schief gegangen.'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      to_char(v_return2),''perg_set_festlegen''));'||unistr('\000a')||
'         end if;'||unistr('\000a')||
'         :p1_pergebnis_id := v_return;'||unistr('\000a')||
'      ELSIF v_return < 0 THEN -- Fehler beim kopieren'||unistr('\000a')||
'         :p1_bearb_modus := ''ANZEIGEN''; '||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,fr';

p:=p||'gbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      to_char(v_return),''perg_set_festlegen''));'||unistr('\000a')||
'      ELSE -- p1_pergebnis_id is null'||unistr('\000a')||
'         :p1_bearb_modus := ''ANZEIGEN''; '||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      ''90'',''perg_set_festlegen''));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Aktuelles E';

p:=p||'rgebnisset festlegen bzw. anlegen'||unistr('\000a')||
'   IF :p1_pergebnis_id IS NULL THEN'||unistr('\000a')||
'      :p1_pergebnis_id := frgbg_s.perg_set_festlegen('||unistr('\000a')||
'                              :P1_FRAGEBOGEN_ID '||unistr('\000a')||
'                             ,:P1_ID '||unistr('\000a')||
'                             ,''LAST''    -- letzte Version holen, ansonsten neue erzeugen'||unistr('\000a')||
'                             ,v_sprache_id'||unistr('\000a')||
'                             ,NULL      -- Kuraufenthalt-';

p:=p||'ID'||unistr('\000a')||
'                            );'||unistr('\000a')||
''||unistr('\000a')||
'      -- Wähle die Standard-Zusatzmodule aus'||unistr('\000a')||
'      v_return :=  frgbg_s.FB_SET_FKAT_MODUL_DEF_AUSWAHL('||unistr('\000a')||
'         p_pergebnis_id                 => :p1_pergebnis_id,'||unistr('\000a')||
'         p_fas_login_personenstamm_id   => :fas_login_personenstamm_id ,'||unistr('\000a')||
'         p_fas_identitaet_persstamm_id  => :fas_identitaet_persstamm_id'||unistr('\000a')||
'       );'||unistr('\000a')||
'      if(v_return < 0) then'||unistr('\000a')||
'        RAISE_APPL';

p:=p||'ICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(9127,v_sprache_id));'||unistr('\000a')||
'      end if;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'  '||unistr('\000a')||
''||unistr('\000a')||
'   -- Defaultwerte festlegen'||unistr('\000a')||
'   IF :p1_bearb_modus = ''BEARBEITEN'' THEN'||unistr('\000a')||
'      v_return := frgbg_s.perg_set_default_ant(:p1_pergebnis_id);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         NULL;   -- Keine Fehlerausgabe bei Konvertierungsproblemen => Fehler wird in Protokoll festgehalten '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'';

p:=p||''||unistr('\000a')||
'/* wird in Page 95 gesetzt'||unistr('\000a')||
''||unistr('\000a')||
'   -- Verrechnungsland setzen'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      :p1_VERRECHNUNGSLAND := frgbg_s.get_pers_option(:APP_USER,8); -- je nach Betreuereinstellung Kunde/Betreuer'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p1_VERRECHNUNGSLAND := 1; -- Kunde'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Währungsermittlung abhängig vom Flag Verrechnungsland Betreuer oder Kunde'||unistr('\000a')||
'   :p1_waehrung_id := NVL(rezepte.get_id_';

p:=p||'waehrung_verr(:P1_ID,'||unistr('\000a')||
'                    v(''fas_identitaet_persstamm_id''), -- NEI 14.10.09 :FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                    :p1_VERRECHNUNGSLAND),27);-- sonst CHF'||unistr('\000a')||
'   :p1_verrech_land_id := rezepte.get_land_id_verr(:P1_ID,'||unistr('\000a')||
'                    v(''fas_identitaet_persstamm_id''),-- NEI 14.10.09 :FAS_LOGIN_PERSONENSTAMM_ID,   '||unistr('\000a')||
'                    :p1_VERRECHNUNGSLAND) ;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Prüfe Exi';

p:=p||'stenz der passenden Preisliste; ggf. wird die Waehrung an die Stdpreisliste angepasst'||unistr('\000a')||
'   v_preislistentyp := rezepte.get_preislisten_typ; -- z.Z. immer 1  '||unistr('\000a')||
'   v_sortiment_id := NVL(v(''FAS_SORTIMENT_ID''),'||unistr('\000a')||
'                           rezepte.GET_SORTIMENT_STD);  -- Standard-Sortiment der oberste Identitaet'||unistr('\000a')||
'   v_preisliste_id := rezepte.get_preisliste_id(:p1_waehrung_id,:p1_verrech_land_id ,'||unistr('\000a')||
'         ';

p:=p||'                v_preislistentyp,v_sortiment_id); '||unistr('\000a')||
'   :p1_waehrung_zeichen := rezepte.GET_WAEHRUNG_ZEICHEN(:p1_waehrung_id);'||unistr('\000a')||
'   :p1_preisliste_id := v_preisliste_id;'||unistr('\000a')||
'   -- Art_mwst_typ_id für Mischungen ermitteln'||unistr('\000a')||
'   /* NEI 17.04.2015 Ermittlung über Funktion wg. Ausnahmeregelung EU-Export der ApoRichter'||unistr('\000a')||
'   /* SELECT min(art_mwst_typ_id) into :p1_art_mwst_typ_id'||unistr('\000a')||
'   /* FROM laender'||unistr('\000a')||
'   /* WHERE id = ';

p:=p||':p1_verrech_land_id ; '||unistr('\000a')||
'   :p1_art_mwst_typ_id := rezepte.GET_ART_MWST_TYP_ID_MISCHUNG(:p1_verrech_land_id,p_persstamm_id_rechnsteller);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Preisfaktor festlegen'||unistr('\000a')||
'   :p1_preisfaktor := to_number(frgbg_s.get_pers_option(NULL,23,v(''fas_identitaet_persstamm_id''),'||unistr('\000a')||
'                                :FAS_LOGIN_PERSONENSTAMM_ID),''FM0.0999'');'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'--MEL.P (''Pis aufgerufen 1 %1, %2,%3,%4'', v_PROT_ID, ''TEST''';

p:=p||', ''seite 1 fragebogen festlegen'', v(''fas_identitaet_persstamm_id''),:FAS_LOGIN_PERSONENSTAMM_ID,:p1_waehrung_id);'||unistr('\000a')||
''||unistr('\000a')||
'  /* APEX_UTIL.SET_PREFERENCE(        '||unistr('\000a')||
'             p_preference => ''FSP_LANGUAGE_PREFERENCE'','||unistr('\000a')||
'             p_value      => v_sprache,'||unistr('\000a')||
'             p_user       => :APP_USER);'||unistr('\000a')||
'   :p1_text := v_sprache;'||unistr('\000a')||
'  */'||unistr('\000a')||
''||unistr('\000a')||
'/*:p1_text :=  APEX_UTIL.GET_PREFERENCE(      '||unistr('\000a')||
'                   p_preference';

p:=p||' => ''FSP_LANGUAGE_PREFERENCE'','||unistr('\000a')||
'                   p_user       => :APP_USER);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3523313843107701 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 12,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fragebogen_festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'begin'||unistr('\000a')||
' /*'||unistr('\000a')||
'  -- Lösche alle augewählten Module, die nicht mehr erlaubt sind. '||unistr('\000a')||
'  delete from PERGEBNIS_MODUL_AUSWAHL where'||unistr('\000a')||
'     pergebnis_id = :P1_PERGEBNIS_ID and'||unistr('\000a')||
'     fkat_modul_id not in ( -- Hole alle erlaubten Module-IDs aus pers_optionen'||unistr('\000a')||
'              SELECT  ow.wert b '||unistr('\000a')||
'              FROM optionswerte ow, pers_optionen po, optionstypen ot, FKATEGORIE_MODULE fkm'||unistr('\000a')||
'              where ow.o';

p:=p||'pttyp_id = ot.id  --JOIN OT '||unistr('\000a')||
'                and ow.opttyp_id = 39 --Zusatzmodule '||unistr('\000a')||
'                and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'                and ow.wert = po.wert'||unistr('\000a')||
'                and ow.wert = fkm.ID'||unistr('\000a')||
'                and (po.persstamm_id = frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          FRGBG_S.GET_IDENTITAET_BETR(:FAS_LOGIN_PERSONENSTAMM_ID)) '||unistr('\000a')||
'    or po.perss';

p:=p||'tamm_id = frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          FRGBG_S.GET_IDENTITAET_BETR(:fas_identitaet_persstamm_id)) '||unistr('\000a')||
'  );'||unistr('\000a')||
'*/'||unistr('\000a')||
'null;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7141028499011230 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 22,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_erlaubte_modul_auswahl',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'/* Für nur aus, wenn der FB noch nicht ausgewertet wurde */'||unistr('\000a')||
'FRGBG_S.FB_CHECK_AUSWERTUNG(:P1_PERGEBNIS_ID) = 0',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_prepare_url_pw:= apex_util.prepare_url('||unistr('\000a')||
'   ''f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_ID:''||:P1_ID);';

wwv_flow_api.create_page_process(
  p_id     => 2734215168388275 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 81,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_prepare_url_pw',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p1_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p1_bl_verwerfen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   --:p1_bl_loeschen  := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p1_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   --:p1_bl_aendern   := fr';

p:=p||'gbg_s.holen_uebersetzung(162,v_sprache_id);'||unistr('\000a')||
'   --:p1_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id);'||unistr('\000a')||
'   :p1_bl_passwort_chg := frgbg_s.holen_uebersetzung(171,v_sprache_id);'||unistr('\000a')||
'   :P1_BL_WEITER     := frgbg_s.holen_uebersetzung(485,v_sprache_id); '||unistr('\000a')||
'   :P1_BL_HRV_LADEN := frgbg_s.holen_uebersetzung(5546,v_sprache_id);'||unistr('\000a')||
'   :P1_BL_SAVE_MODUL_AUSW := frgbg_s.holen_uebersetzung(9124,v_sprache_i';

p:=p||'d);'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   :p1_region_titel_pwd_chg := frgbg_s.holen_uebersetzung(170,v_sprache_id);'||unistr('\000a')||
'   :p1_region_titel_hilfetexte := frgbg_s.holen_uebersetzung(220,v_sprache_id);'||unistr('\000a')||
'   :p1_region_titel_infotext := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   --:p1_region_titel_auswertung := frgbg_s.holen_uebersetzung(3054,v_sprache_id);'||unistr('\000a')||
'   :p1_region_titel_hrv := frgbg_s.holen_uebersetzung(5544,v_sprache_id);'||unistr('\000a')||
'  ';

p:=p||' :P1_REGION_TITEL_MODUL_AUSW := frgbg_s.holen_uebersetzung(9122,v_sprache_id);'||unistr('\000a')||
'   :p1_hinweistitel := frgbg_s.holen_uebersetzung(3516,v_sprache_id);'||unistr('\000a')||
'   --:p1_laborwerte_hinweistext := frgbg_s.holen_uebersetzung(3517,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p1_info := frgbg_s.holen_uebersetzung(173,v_sprache_id);'||unistr('\000a')||
'   --:p1_druckopt_info := frgbg_s.holen_uebersetzung(3538,v_sprache_id);'||unistr('\000a')||
'   :p1_fehler := frgbg_s.holen_ueb';

p:=p||'ersetzung(487,v_sprache_id); '||unistr('\000a')||
''||unistr('\000a')||
'   :P1_NV_FRAGEBOGEN := frgbg_s.holen_uebersetzung(3839,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3525802330123303 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 90,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'    i    number;'||unistr('\000a')||
'    v_sprache_id NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'    CURSOR c_kategorien '||unistr('\000a')||
'    IS'||unistr('\000a')||
'     SELECT k.*,frgbg_s.HOLEN_UEBERSETZUNG (k.tab_text_id   ,v_sprache_id) text --  u.text '||unistr('\000a')||
'     FROM fkategorien k --, uebersetzungen u -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'     WHERE k.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'       AND k.fk';

p:=p||'ategorie_id IS NULL                 -- Unterste Ebene'||unistr('\000a')||
'       --AND k.tab_text_id = u.TEXT_ID'||unistr('\000a')||
'       --AND u.SPRACHE_ID = v_sprache_id'||unistr('\000a')||
'       AND k.art = 1         -- Normale Tabs 1-10 (max. 30)'||unistr('\000a')||
'       AND k.satz_kennzeichen is null'||unistr('\000a')||
'     ORDER BY sort ;  '||unistr('\000a')||
'    CURSOR c_kategorien_labor '||unistr('\000a')||
'    IS'||unistr('\000a')||
'     SELECT k.*,frgbg_s.HOLEN_UEBERSETZUNG (k.tab_text_id   ,v_sprache_id) text --  u.text '||unistr('\000a')||
'     FROM fkate';

p:=p||'gorien k --, uebersetzungen u -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'     WHERE k.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'       AND k.fkategorie_id IS NULL                 -- Unterste Ebene'||unistr('\000a')||
'       --AND k.tab_text_id = u.TEXT_ID'||unistr('\000a')||
'       --AND u.SPRACHE_ID = v_sprache_id'||unistr('\000a')||
'       AND k.art = 2         -- Labor-Tabs 31-40 '||unistr('\000a')||
'       AND k.satz_kennzeichen is null'||unistr('\000a')||
'       AND frgbg_s.CHEC';

p:=p||'K_TAB_ANZEIGEN_N(:P1_PERGEBNIS_ID,k.id) = 1 -- NEI 8.05.14 neues Labortab TEAMW nur ausgewählte Modul-Kategorien'||unistr('\000a')||
'                                                                 -- Zur Zeit gibt es nur 1 Labortab => optimieren des Ladevorgangs; kann nach funktionaler ERmittlung der Apex-Page für Sprung aus der Übersichtsseite in die angezeigte Seite auch für die normalen Fk-Tabs erfolgen; zur Zeit';

p:=p||' aber nur bei Labortab.'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'     ORDER BY sort ;  '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- AB r_kategorien.sort 90 beginnen Sondertabs, die extra zugeordnet werden'||unistr('\000a')||
'   i := 1;'||unistr('\000a')||
'   FOR r_kategorien IN c_kategorien LOOP'||unistr('\000a')||
'      IF i = 1 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab1_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab1_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P1_TAB1_KATEGORIE_ZEILEN := r_kategorie';

p:=p||'n.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF i = 2 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab2_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab2_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P1_TAB2_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF i = 3 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab3_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab3_kategorie_text := ';

p:=p||'r_kategorien.text;'||unistr('\000a')||
'             :P1_TAB3_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF i = 4 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab4_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab4_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P1_TAB4_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF i = 5 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab5_k';

p:=p||'ategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab5_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P1_TAB5_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF i = 6 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab6_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab6_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P1_TAB6_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
' ';

p:=p||'     ELSIF i = 7 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab7_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab7_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P1_TAB7_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF i = 8 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab8_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab8_kategorie_text := r_kategorien.text;'||unistr('\000a')||
' ';

p:=p||'            :P1_TAB8_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF i = 9 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab9_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab9_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P1_TAB9_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF i = 10 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p1_tab10_kategorie_id := r_k';

p:=p||'ategorien.id;'||unistr('\000a')||
'             :p1_tab10_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P1_TAB10_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF r_kategorien.sort = 90 THEN -- Ubersicht'||unistr('\000a')||
'             :p1_tab90_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab90_kategorie_text := r_kategorien.text;         '||unistr('\000a')||
'             :P1_TAB90_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'  ';

p:=p||'    ELSIF r_kategorien.sort = 91 THEN -- Formular'||unistr('\000a')||
'             :p1_tab91_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab91_kategorie_text := r_kategorien.text;         '||unistr('\000a')||
'             :P1_TAB91_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      ELSIF r_kategorien.sort = 95 THEN -- Auswertung'||unistr('\000a')||
'             :p1_tab95_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p1_tab95_kategorie_text := r';

p:=p||'_kategorien.text;         '||unistr('\000a')||
'             :P1_TAB95_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      i := i+1;'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   i := 1;'||unistr('\000a')||
'   FOR r_kategorien IN c_kategorien_labor LOOP'||unistr('\000a')||
'       IF i = 1 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p31_tab31_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p31_tab31_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P31_TAB31_KATEGORIE';

p:=p||'_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'       ELSIF i = 2 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p31_tab32_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p31_tab32_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P31_TAB32_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'       ELSIF i = 3 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p31_tab33_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'        ';

p:=p||'     :p31_tab33_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P31_TAB33_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'       ELSIF i = 4 AND r_kategorien.sort < 90 THEN'||unistr('\000a')||
'             :p31_tab34_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p31_tab34_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P31_TAB34_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'       ELSIF i = 5 AND r_kateg';

p:=p||'orien.sort < 90 THEN'||unistr('\000a')||
'             :p31_tab35_kategorie_id := r_kategorien.id;'||unistr('\000a')||
'             :p31_tab35_kategorie_text := r_kategorien.text;'||unistr('\000a')||
'             :P31_TAB35_KATEGORIE_ZEILEN := r_kategorien.apex_anz_zeilen;'||unistr('\000a')||
'       END IF;'||unistr('\000a')||
'       i := i+1;'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3200507964368798 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 91,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Kategorien_laden',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT  frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text -- u.text'||unistr('\000a')||
'   from fkategorien fk -- uebersetzungen u -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab1_kategorie_id or'||unistr('\000a')||
'          fk.fkatego';

p:=p||'rie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab1_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     --AND u.sprache_id =:fas_sprache_id'||unistr('\000a')||
'     --and fk.HINWEIS_TEXT_ID= u.TEXT_ID'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hinweis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
'--mel.p(''Kategorie %1 Text --%2''';

p:=p||',v_prot_id,''hinweistext_init'',''test'',:p1_tab1_kategorie_id,:p1_hinweistext );'||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4126001010407220 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 92,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3867030124071646 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 160,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:PERSONENSTAMM:P1_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 7171813520739607 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 170,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Zeile abrufen aus PERSONENSTAMM',
  p_process_sql_clob => p,
  p_process_error_message=> 'Zeile kann nicht abgerufen werden.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN   -- entsprechende Routine Page 110 '||unistr('\000a')||
' IF :fas_aufgerufen_von = ''PIS'' THEN'||unistr('\000a')||
'   IF   (:p1_aenderbar = ''J'') '||unistr('\000a')||
'     OR (:p1_aenderbar = ''N'' AND'||unistr('\000a')||
'         -- speziell berechtigt'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''GESCHUETZTE_PERSONENDATEN_AENDERN'') > 0 '||unistr('\000a')||
'         )'||unistr('\000a')||
'      OR (:p1_aenderbar = ''N'' AND                 -- User hat sich selbst eingeloggt'||unistr('\000a')||
'          :fas_aufgerufen_von != ''BETREUER''';

p:=p||' and'||unistr('\000a')||
'          UPPER(:P1_USER_ACCOUNT)= UPPER(:APP_USER)'||unistr('\000a')||
'         )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :fas_pers_aenderbar := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_aenderbar := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5331701953055984 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 180,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_fas_pers_aenderbar',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  v_url varchar2(1000);'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'  v_url := APEX_UTIL.PREPARE_URL ('||unistr('\000a')||
'    p_url           => ''f?p=&APP_ID.:95:&APP_SESSION.'','||unistr('\000a')||
'    p_checksum_type => ''SESSION'''||unistr('\000a')||
'  );'||unistr('\000a')||
''||unistr('\000a')||
' owa_util.redirect_url(v_url);'||unistr('\000a')||
' apex_application.stop_apex_engine;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
' raise_application_error(-20000,''test'');'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7565415690065172 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 210,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Jump zur Auswertung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'FRGBG_S.FB_CHECK_AUSWERTUNG(:P1_PERGEBNIS_ID) = 1 and :P140_JUMP_TO_AUSW_PAGE is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'test',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   /* z.B. GUS-Adr. darf nicht im FAS verändert werden */'||unistr('\000a')||
'   :p1_pers_readonly:=frgbg_T.check_pers_extern_verwaltet(:p1_EXTERN_VERWALTET ) ; '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 10188407956752849 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 1,
  p_process_sequence=> 220,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_adr_readonly',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 1
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00002
prompt  ...PAGE 2: Aktualisieren FRAGEBOGENANZEIGE 2
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 2
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 2'
 ,p_step_title => 'Aktualisieren Fragebogenanzeige 2'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren Fragebogenanzeige'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140514134624'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'fkategorie_text,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'WHEN hilfe_text_id is not null '||unistr('\000a')||
'THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'|| hilfe_text_id||'',''||frage_text_id)'||unistr('\000a')||
'|| '''''',700,425)">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK,'||unistr('\000a')||
'frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    ANZEIGETYP_ID, FR';

s:=s||'AGEBOGEN_ID, FRAGE_ID, PERSONENSTAMM_ID, 1, 1,'||unistr('\000a')||
'    :p1_pergebnis_id,'||unistr('\000a')||
'    :fas_sprache_id --frgbg_s.get_sprache_id(:APP_USER)'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from v_fragen'||unistr('\000a')||
'where fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
' -- AND fkategorie_id = :p1_tab2_kategorie_id '||unistr('\000a')||
'  and (fkategorie_fkategorie_id = :p1_tab2_kategorie_id or'||unistr('\000a')||
'       FKATEGORIE_fkategorie_ID is null and fkategorie_id= :p1_tab2_kategorie_id'||unistr('\000a')||
'      )'||unistr('\000a')||
'  AND personens';

s:=s||'tamm_id = :p1_id'||unistr('\000a')||
'  AND sprache_id =:fas_sprache_id /*frgbg_s.get_sprache_id(:APP_USER)*/'||unistr('\000a')||
'  AND fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 2936706869150862 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 2,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_plug_query_max_columns=> 5,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'GENERIC_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB2_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'REPEAT_HEADINGS_ON_BREAK_1',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width=> 297,
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'LEFT',
  p_prn_page_footer_alignment=> 'LEFT',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3719024819259343 + wwv_flow_api.g_id_offset,
  p_region_id=> 2936706869150862 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'COL01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3719123369259345 + wwv_flow_api.g_id_offset,
  p_region_id=> 2936706869150862 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'COL02',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3719224152259345 + wwv_flow_api.g_id_offset,
  p_region_id=> 2936706869150862 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'COL03',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3719307273259345 + wwv_flow_api.g_id_offset,
  p_region_id=> 2936706869150862 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'COL04',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3719403975259345 + wwv_flow_api.g_id_offset,
  p_region_id=> 2936706869150862 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'COL05',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3171331126915939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 2,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND'||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 3733401186621528 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 2,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5563602079737128 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 2,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 35,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12571031152805784 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 2,
  p_button_sequence=> 10,
  p_button_plug_id => 2936706869150862+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'') and 1=2',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5379510387440500 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 2,
  p_button_sequence=> 15,
  p_button_plug_id => 2936706869150862+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS'' and 1=2',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2937128050150868 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 2,
  p_button_sequence=> 20,
  p_button_plug_id => 2936706869150862+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:2:&SESSION.:TEST:&DEBUG.:::',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2937307681150870 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 2,
  p_button_sequence=> 30,
  p_button_plug_id => 2936706869150862+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN'' and 1=2',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3869401399214694 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 2,
  p_button_sequence=> 40,
  p_button_plug_id => 2936706869150862+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3869712612227412 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 2,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3869401399214694+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>2938031120150876 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 2,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPLIC';

p:=p||'ATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
' :P1_FEHLER := null;'||unistr('\000a')||
' FRGBG_S.SPEICHERN'||unistr('\000a')||
'  ( '||unistr('\000a')||
'   v_user,:P1_TAB2_KATEGORIE_ID,:p1_fragebogen_id,:p1_id,:p1_pergebnis_id,'||unistr('\000a')||
'   v_sprache_id , :P1_FEHLER'||unistr('\000a')||
'  );'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung auch in pergebnisse festhal';

p:=p||'ten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 2937727204150873 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 2,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT  frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text '||unistr('\000a')||
'   from fkategorien fk '||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab2_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab2_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hi';

p:=p||'nweis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4122002180066846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 2,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 5082019814628467 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 2,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 7943415164355043 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 2,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3870513136265410 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 2,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 2
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00003
prompt  ...PAGE 3: Aktualisieren FRAGEBOGENANZEIGE 3
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 3
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 3'
 ,p_step_title => 'Aktualisieren Fragebogenanzeige 3'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren Fragebogenanzeige 2'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20131202095029'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'fkategorie_text,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'WHEN hilfe_text_id is not null '||unistr('\000a')||
'THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'|| hilfe_text_id||'',''||frage_text_id)'||unistr('\000a')||
'|| '''''',700,425)">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK,'||unistr('\000a')||
'frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    ANZEIGETYP_ID, FR';

s:=s||'AGEBOGEN_ID, FRAGE_ID, PERSONENSTAMM_ID, 1, 1,'||unistr('\000a')||
'    :p1_pergebnis_id,'||unistr('\000a')||
'    :fas_sprache_id'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from v_fragen'||unistr('\000a')||
'where fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  --AND fkategorie_id = :p1_tab3_kategorie_id '||unistr('\000a')||
'  and (fkategorie_fkategorie_id = :p1_tab3_kategorie_id or'||unistr('\000a')||
'       FKATEGORIE_fkategorie_ID is null and fkategorie_id= :p1_tab3_kategorie_id'||unistr('\000a')||
'      )'||unistr('\000a')||
'  AND personenstamm_id = :p1_id'||unistr('\000a')||
'  AND sprache_id = ';

s:=s||':fas_sprache_id'||unistr('\000a')||
'  AND fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 3005614467756332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 3,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB3_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'REPEAT_HEADINGS_ON_BREAK_1',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9557819090961017 + wwv_flow_api.g_id_offset,
  p_region_id=> 3005614467756332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4746432287421034 + wwv_flow_api.g_id_offset,
  p_region_id=> 3005614467756332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3005919010756342 + wwv_flow_api.g_id_offset,
  p_region_id=> 3005614467756332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'FRAGEBOGENANZEIGE',
  p_ref_column_name=> 'FRAGE_TEXT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3005809812756340 + wwv_flow_api.g_id_offset,
  p_region_id=> 3005614467756332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AUSWAHL',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3171719829922107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 3,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 3744324706101406 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 3,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_FEHLER IS NOT NULL',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5568418449798665 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 3,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 35,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12575504533826493 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 3,
  p_button_sequence=> 10,
  p_button_plug_id => 3005614467756332+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5380400176475417 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 3,
  p_button_sequence=> 15,
  p_button_plug_id => 3005614467756332+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3006003153756342 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 3,
  p_button_sequence=> 20,
  p_button_plug_id => 3005614467756332+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3006221404756343 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 3,
  p_button_sequence=> 30,
  p_button_plug_id => 3005614467756332+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3873322845486378 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 3,
  p_button_sequence=> 40,
  p_button_plug_id => 3005614467756332+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3876132158536415 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 3,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3873322845486378+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3007132213756350 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 3,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id;--frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'   v_prot_id     number;'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutda';

p:=p||'t THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
' :P1_FEHLER := null;'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''Vor speichern!'',v_prot_id,''TEST'',''102/3:daten_uebernehmen'');'||unistr('\000a')||
' FRGBG_S.SPEICHERN'||unistr('\000a')||
'  ( '||unistr('\000a')||
'   v_user, :P1_TAB3_KATEGORIE_ID, :p1_fragebogen_id, :p1_id,:p1_pergebnis_id,'||unistr('\000a')||
'   frgbg_s.get_sprache_id(:APP_USER), :P1_FEHLER'||unistr('\000a')||
'  );'||unistr('\000a')||
' IF :p1_fehler';

p:=p||' IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung auch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3006824974756348 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 3,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT  frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text '||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab3_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab3_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hin';

p:=p||'weis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4122207028068312 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 3,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 5083207132634245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 3,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 7954130074510701 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 3,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3881201131612575 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 3,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 3
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00004
prompt  ...PAGE 4: Aktualisieren FRAGEBOGENANZEIGE 4
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 4
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 4'
 ,p_step_title => 'Aktualisieren Fragebogenanzeige 4'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren Fragebogenanzeige 4'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20131202095138'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3172129872925039 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 4,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 3835719692813473 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 4,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5568624682800433 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 4,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'fkategorie_text,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'WHEN hilfe_text_id is not null '||unistr('\000a')||
'THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'|| hilfe_text_id||'',''||frage_text_id)'||unistr('\000a')||
'|| '''''',700,425)">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK, '||unistr('\000a')||
'frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    ANZEIGETYP_ID, F';

s:=s||'RAGEBOGEN_ID, FRAGE_ID, PERSONENSTAMM_ID, 1, 1,'||unistr('\000a')||
'    :p1_pergebnis_id,'||unistr('\000a')||
'    :fas_sprache_id'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from v_fragen'||unistr('\000a')||
'where fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  --AND fkategorie_id = :p1_tab4_kategorie_id '||unistr('\000a')||
'  and (fkategorie_fkategorie_id = :p1_tab4_kategorie_id or'||unistr('\000a')||
'       FKATEGORIE_fkategorie_ID is null and fkategorie_id= :p1_tab4_kategorie_id'||unistr('\000a')||
'      )  '||unistr('\000a')||
'  AND personenstamm_id = :p1_id'||unistr('\000a')||
'  AND sprache_id';

s:=s||' = :fas_sprache_id'||unistr('\000a')||
'  AND fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 9582321752900017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 4,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 35,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;">'||unistr('\000a')||
'',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB4_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'REPEAT_HEADINGS_ON_BREAK_1',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9582510461900025 + wwv_flow_api.g_id_offset,
  p_region_id=> 9582321752900017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9582623526900028 + wwv_flow_api.g_id_offset,
  p_region_id=> 9582321752900017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9582717676900028 + wwv_flow_api.g_id_offset,
  p_region_id=> 9582321752900017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'FRAGEBOGENANZEIGE',
  p_ref_column_name=> 'FRAGE_TEXT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9582803587900028 + wwv_flow_api.g_id_offset,
  p_region_id=> 9582321752900017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AUSWAHL',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12579028344852339 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 4,
  p_button_sequence=> 10,
  p_button_plug_id => 9582321752900017+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5380611604478707 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 4,
  p_button_sequence=> 15,
  p_button_plug_id => 9582321752900017+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 9586832272912500 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 4,
  p_button_sequence=> 20,
  p_button_plug_id => 9582321752900017+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3836102256813476 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 4,
  p_button_sequence=> 30,
  p_button_plug_id => 9582321752900017+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3873530464488606 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 4,
  p_button_sequence=> 40,
  p_button_plug_id => 9582321752900017+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3877220646552042 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 4,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3873530464488606+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3836810384813482 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 4,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id;   --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPL';

p:=p||'ICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
' :P1_FEHLER := null;'||unistr('\000a')||
' FRGBG_S.SPEICHERN'||unistr('\000a')||
'  ( '||unistr('\000a')||
'   v_user, :P1_TAB4_KATEGORIE_ID, :p1_fragebogen_id, :p1_id,:p1_pergebnis_id, '||unistr('\000a')||
'   frgbg_s.get_sprache_id(:APP_USER), :P1_FEHLER'||unistr('\000a')||
'  );'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung a';

p:=p||'uch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ; END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3836526042813482 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 4,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT  frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text '||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab4_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab4_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hin';

p:=p||'weis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4123529790368198 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 4,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 5083914058636231 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 4,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 7955005963513229 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 4,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3881427450620149 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 4,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 4
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00005
prompt  ...PAGE 5: Aktualisieren FRAGEBOGENANZEIGE 5
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 5
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 5'
 ,p_step_title => 'Aktualisieren Fragebogenanzeige 5'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren Fragebogenanzeige 2'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20131202095125'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 3906129862222779 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 5,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5431216663936112 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 5,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5568830916802267 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 5,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'fkategorie_text,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'WHEN hilfe_text_id is not null '||unistr('\000a')||
'THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'|| hilfe_text_id||'',''||frage_text_id)'||unistr('\000a')||
'|| '''''',700,425)">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK,'||unistr('\000a')||
'frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    ANZEIGETYP_ID, FR';

s:=s||'AGEBOGEN_ID, FRAGE_ID, PERSONENSTAMM_ID, 1, 1,'||unistr('\000a')||
'    :p1_pergebnis_id,'||unistr('\000a')||
'    :fas_sprache_id'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from v_fragen'||unistr('\000a')||
'where fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  --AND fkategorie_id = :p1_tab5_kategorie_id '||unistr('\000a')||
'  and (fkategorie_fkategorie_id = :p1_tab5_kategorie_id or'||unistr('\000a')||
'       FKATEGORIE_fkategorie_ID is null and fkategorie_id= :p1_tab5_kategorie_id'||unistr('\000a')||
'      )  '||unistr('\000a')||
'  AND personenstamm_id = :p1_id'||unistr('\000a')||
'  AND sprache_id ';

s:=s||'= :fas_sprache_id'||unistr('\000a')||
'  AND fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 9590010371925151 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 5,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 35,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB5_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'REPEAT_HEADINGS_ON_BREAK_1',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9590221866925151 + wwv_flow_api.g_id_offset,
  p_region_id=> 9590010371925151 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9590327602925151 + wwv_flow_api.g_id_offset,
  p_region_id=> 9590010371925151 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9590425213925151 + wwv_flow_api.g_id_offset,
  p_region_id=> 9590010371925151 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'FRAGEBOGENANZEIGE',
  p_ref_column_name=> 'FRAGE_TEXT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9590501397925151 + wwv_flow_api.g_id_offset,
  p_region_id=> 9590010371925151 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AUSWAHL',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12580416008858190 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 5,
  p_button_sequence=> 10,
  p_button_plug_id => 9590010371925151+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5380817838480434 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 5,
  p_button_sequence=> 15,
  p_button_plug_id => 9590010371925151+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3906306992222779 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 5,
  p_button_sequence=> 20,
  p_button_plug_id => 9590010371925151+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS = ''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3906511648222779 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 5,
  p_button_sequence=> 30,
  p_button_plug_id => 9590010371925151+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS = ''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3873702891490050 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 5,
  p_button_sequence=> 40,
  p_button_plug_id => 9590010371925151+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3877427572554037 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 5,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3873702891490050+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3907225421222779 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 5,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id;   --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPL';

p:=p||'ICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
' :P1_FEHLER := null;'||unistr('\000a')||
' FRGBG_S.SPEICHERN'||unistr('\000a')||
'  ( '||unistr('\000a')||
'   v_user, :P1_TAB5_KATEGORIE_ID, :p1_fragebogen_id, :p1_id,:p1_pergebnis_id, '||unistr('\000a')||
'   frgbg_s.get_sprache_id(:APP_USER), :P1_FEHLER'||unistr('\000a')||
'  );'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung a';

p:=p||'uch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3906910336222779 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 5,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT  frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab5_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab5_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hinw';

p:=p||'eis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4123701871369581 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 5,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 5084620292637995 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 5,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 7957031936520721 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 5,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3881632645621695 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 5,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 5
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00006
prompt  ...PAGE 6: Aktualisieren FRAGEBOGENANZEIGE 6
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 6
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 6'
 ,p_step_title => 'Aktualisieren Fragebogenanzeige 6'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren Fragebogenanzeige 6'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20131202095229'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3172507839928123 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 6,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 3939516399728028 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 6,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5569005074804248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 6,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'fkategorie_text,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'WHEN hilfe_text_id is not null '||unistr('\000a')||
'THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'|| hilfe_text_id||'',''||frage_text_id)'||unistr('\000a')||
'|| '''''',700,425)">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK,'||unistr('\000a')||
'frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    ANZEIGETYP_ID, FR';

s:=s||'AGEBOGEN_ID, FRAGE_ID, PERSONENSTAMM_ID, 1, 1,'||unistr('\000a')||
'    :p1_pergebnis_id,'||unistr('\000a')||
'    :fas_sprache_id'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from v_fragen'||unistr('\000a')||
'where fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  --AND fkategorie_id = :p1_tab6_kategorie_id '||unistr('\000a')||
'  and (fkategorie_fkategorie_id = :p1_tab6_kategorie_id or'||unistr('\000a')||
'       FKATEGORIE_fkategorie_ID is null and fkategorie_id= :p1_tab6_kategorie_id'||unistr('\000a')||
'      )    AND personenstamm_id = :p1_id'||unistr('\000a')||
'  AND sprache_id =';

s:=s||' :fas_sprache_id'||unistr('\000a')||
'  AND fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 9595613057944815 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 6,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 35,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB6_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'REPEAT_HEADINGS_ON_BREAK_1',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9598911492959075 + wwv_flow_api.g_id_offset,
  p_region_id=> 9595613057944815 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9595902733944817 + wwv_flow_api.g_id_offset,
  p_region_id=> 9595613057944815 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9596009849944817 + wwv_flow_api.g_id_offset,
  p_region_id=> 9595613057944815 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'FRAGEBOGENANZEIGE',
  p_ref_column_name=> 'FRAGE_TEXT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9596118476944817 + wwv_flow_api.g_id_offset,
  p_region_id=> 9595613057944815 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AUSWAHL',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12581718217868307 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 6,
  p_button_sequence=> 10,
  p_button_plug_id => 9595613057944815+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5381021993481667 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 6,
  p_button_sequence=> 15,
  p_button_plug_id => 9595613057944815+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3939725275728028 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 6,
  p_button_sequence=> 20,
  p_button_plug_id => 9595613057944815+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS = ''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3939915811728028 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 6,
  p_button_sequence=> 30,
  p_button_plug_id => 9595613057944815+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS = ''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3873907739491488 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 6,
  p_button_sequence=> 40,
  p_button_plug_id => 9595613057944815+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3877807617557726 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 6,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3873907739491488+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3940617820728029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 6,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id;   --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPL';

p:=p||'ICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
' :P1_FEHLER := null;'||unistr('\000a')||
' FRGBG_S.SPEICHERN'||unistr('\000a')||
'  ( '||unistr('\000a')||
'   v_user, :P1_TAB6_KATEGORIE_ID, :p1_fragebogen_id, :p1_id,'||unistr('\000a')||
'   :p1_pergebnis_id,frgbg_s.get_sprache_id(:APP_USER), :P1_FEHLER'||unistr('\000a')||
'  );'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung au';

p:=p||'ch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3940308996728029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 6,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT  frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text '||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab6_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab6_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hin';

p:=p||'weis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4123913645372954 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 6,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 5085329642640701 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 6,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 7957503324521898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 6,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3881805418623292 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 6,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 6
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00007
prompt  ...PAGE 7: Aktualisieren FRAGEBOGENANZEIGE 7
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 7
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 7'
 ,p_step_title => 'Aktualisieren Fragebogenanzeige 7'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren Fragebogenanzeige 7'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20131202095304'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2985128567016939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 7,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 3951519598741157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 7,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5569209922805611 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 7,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'fkategorie_text,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'WHEN hilfe_text_id is not null '||unistr('\000a')||
'THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'|| hilfe_text_id||'',''||frage_text_id)'||unistr('\000a')||
'|| '''''',700,425)">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK,'||unistr('\000a')||
'frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    ANZEIGETYP_ID, FR';

s:=s||'AGEBOGEN_ID, FRAGE_ID, PERSONENSTAMM_ID, 1, 1,'||unistr('\000a')||
'    :p1_pergebnis_id,'||unistr('\000a')||
'    :fas_sprache_id'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from v_fragen'||unistr('\000a')||
'where fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  --AND fkategorie_id = :p1_tab7_kategorie_id '||unistr('\000a')||
'  and (fkategorie_fkategorie_id = :p1_tab7_kategorie_id or'||unistr('\000a')||
'       FKATEGORIE_fkategorie_ID is null and fkategorie_id= :p1_tab7_kategorie_id'||unistr('\000a')||
'      )   '||unistr('\000a')||
'  and personenstamm_id = :p1_id'||unistr('\000a')||
'  AND sprache_id';

s:=s||' = :fas_sprache_id'||unistr('\000a')||
'  AND fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 9604401114979270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 7,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 35,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;">',
  p_footer=> '</div>'||unistr('\000a')||
'',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB7_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'REPEAT_HEADINGS_ON_BREAK_1',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_content_disposition=> 'ATTACHMENT',
  p_prn_document_header=> 'APEX',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width_units=> 'PERCENTAGE',
  p_prn_width=> 297,
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'LEFT',
  p_prn_page_footer_alignment=> 'LEFT',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9604603498979270 + wwv_flow_api.g_id_offset,
  p_region_id=> 9604401114979270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '25',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9604700226979271 + wwv_flow_api.g_id_offset,
  p_region_id=> 9604401114979270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '25',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9604814956979271 + wwv_flow_api.g_id_offset,
  p_region_id=> 9604401114979270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '25',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'FRAGEBOGENANZEIGE',
  p_ref_column_name=> 'FRAGE_TEXT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9604915865979271 + wwv_flow_api.g_id_offset,
  p_region_id=> 9604401114979270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AUSWAHL',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '25',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12582732762872529 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 7,
  p_button_sequence=> 10,
  p_button_plug_id => 9604401114979270+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5381225456482721 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 7,
  p_button_sequence=> 15,
  p_button_plug_id => 9604401114979270+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3951718400741157 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 7,
  p_button_sequence=> 20,
  p_button_plug_id => 9604401114979270+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3951914583741157 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 7,
  p_button_sequence=> 30,
  p_button_plug_id => 9604401114979270+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3874113280493109 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 7,
  p_button_sequence=> 40,
  p_button_plug_id => 9604401114979270+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3878015236559875 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 7,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3874113280493109+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3952605079741159 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 7,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id;   --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPL';

p:=p||'ICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
' :P1_FEHLER := null;'||unistr('\000a')||
' FRGBG_S.SPEICHERN'||unistr('\000a')||
'  ( '||unistr('\000a')||
'   v_user, :P1_TAB7_KATEGORIE_ID, :p1_fragebogen_id, :p1_id, '||unistr('\000a')||
'   :p1_pergebnis_id,frgbg_s.get_sprache_id(:APP_USER), :P1_FEHLER'||unistr('\000a')||
'  );'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung a';

p:=p||'uch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3952305180741159 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 7,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT  frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text '||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab7_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab7_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--me';

p:=p||'l.p(''Kategorie %1'',v_prot_id,''hinweistext_init'',''test'',:p1_tab7_kategorie_id);'||unistr('\000a')||
'   FOR r_hinweis in c_hinweis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
'--mel.p(''Kategorie %1 Text --%2'',v_prot_id,''hinweistext_init'',''test'',:p1_tab7_kategorie_id,:p1_hinweistext );'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4120808835974209 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 7,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 5086001030641951 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 7,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 7958007133523050 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 7,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3882013383625559 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 7,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 7
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00008
prompt  ...PAGE 8: Aktualisieren FRAGEBOGENANZEIGE 8
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 8
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 8'
 ,p_step_title => 'Aktualisieren Fragebogenanzeige 8'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren Fragebogenanzeige 8'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20131202095332'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 3961120367746315 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 8,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5569413385806693 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 8,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 55,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5928519472602248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 8,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'fkategorie_text,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'WHEN hilfe_text_id is not null '||unistr('\000a')||
'THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'|| hilfe_text_id||'',''||frage_text_id)'||unistr('\000a')||
'|| '''''',700,425)">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK,'||unistr('\000a')||
'frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    ANZEIGETYP_ID, FR';

s:=s||'AGEBOGEN_ID, FRAGE_ID, PERSONENSTAMM_ID, 1, 1,'||unistr('\000a')||
'    :p1_pergebnis_id,'||unistr('\000a')||
'    :fas_sprache_id'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from v_fragen'||unistr('\000a')||
'where fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  --AND fkategorie_id = :p1_tab8_kategorie_id '||unistr('\000a')||
'  and (fkategorie_fkategorie_id = :p1_tab8_kategorie_id or'||unistr('\000a')||
'       FKATEGORIE_fkategorie_ID is null and fkategorie_id= :p1_tab8_kategorie_id'||unistr('\000a')||
'      )  '||unistr('\000a')||
'  AND personenstamm_id = :p1_id'||unistr('\000a')||
'  AND sprache_id ';

s:=s||'= :fas_sprache_id'||unistr('\000a')||
'  AND fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 9610412242010846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 8,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 35,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px; min-width:1000px;">',
  p_footer=> '</div>'||unistr('\000a')||
'',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB8_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'REPEAT_HEADINGS_ON_BREAK_1',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9610600885010846 + wwv_flow_api.g_id_offset,
  p_region_id=> 9610412242010846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9610721546010846 + wwv_flow_api.g_id_offset,
  p_region_id=> 9610412242010846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9610802121010846 + wwv_flow_api.g_id_offset,
  p_region_id=> 9610412242010846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'FRAGEBOGENANZEIGE',
  p_ref_column_name=> 'FRAGE_TEXT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9610912324010846 + wwv_flow_api.g_id_offset,
  p_region_id=> 9610412242010846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AUSWAHL',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12583717655877626 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 8,
  p_button_sequence=> 10,
  p_button_plug_id => 9610412242010846+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5381429612483871 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 8,
  p_button_sequence=> 15,
  p_button_plug_id => 9610412242010846+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3961314671746317 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 8,
  p_button_sequence=> 20,
  p_button_plug_id => 9610412242010846+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3961522850746317 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 8,
  p_button_sequence=> 30,
  p_button_plug_id => 9610412242010846+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3874318821494686 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 8,
  p_button_sequence=> 40,
  p_button_plug_id => 9610412242010846+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3878425625562899 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 8,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3874318821494686+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3962200771746317 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 8,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id;   --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPL';

p:=p||'ICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
' :P1_FEHLER := null;'||unistr('\000a')||
' FRGBG_S.SPEICHERN'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    v_user, :P1_TAB8_KATEGORIE_ID, :p1_fragebogen_id, :p1_id, '||unistr('\000a')||
'    :p1_pergebnis_id,frgbg_s.get_sprache_id(:APP_USER), :P1_FEHLER'||unistr('\000a')||
'  );'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung';

p:=p||' auch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3961914921746317 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 8,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT  frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab8_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab8_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hinw';

p:=p||'eis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4124321956375368 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 8,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 5086705532643260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 8,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 7958714059525082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 8,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3882425157628960 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 8,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 8
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00009
prompt  ...PAGE 9: Aktualisieren FRAGEBOGENANZEIGE 9
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 9
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 9'
 ,p_step_title => 'Aktualisieren Fragebogenanzeige 9'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren Fragebogenanzeige 9'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'$(document).ready(function() {'||unistr('\000a')||
''||unistr('\000a')||
'   $(''td[headers^="FRAGE_TEXT"]'').css(''vertical-align'',''top'');'||unistr('\000a')||
'   $(''td[headers^="AUSWAHL_"]'').parent().find(''td[headers^="AUSWAHL_"], td[headers^="FRAGE_TEXT"] '').css({'||unistr('\000a')||
'       ''border-bottom'' :''1px solid #E3E3E3'''||unistr('\000a')||
'   });'||unistr('\000a')||
'   /*$(''td[headers="AUSWAHL_004"] label'').css({'||unistr('\000a')||
'       ''width'' :''120px'','||unistr('\000a')||
'       ''display'' : ''inline-block'','||unistr('\000a')||
'       ''vertical-align'' : ''middle'''||unistr('\000a')||
'   }'||
');*/'||unistr('\000a')||
'});'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140327103623'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 3970710045753250 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 9,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5569625506810130 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 9,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 55,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5928727437604473 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 9,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'fkategorie_text,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'WHEN hilfe_text_id is not null '||unistr('\000a')||
'THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'|| hilfe_text_id||'',''||frage_text_id)'||unistr('\000a')||
'|| '''''',700,425)">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK,'||unistr('\000a')||
'frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    ANZEIGETYP_ID, FR';

s:=s||'AGEBOGEN_ID, FRAGE_ID, PERSONENSTAMM_ID, 1, 1,'||unistr('\000a')||
'    :p1_pergebnis_id,'||unistr('\000a')||
'    :fas_sprache_id'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from v_fragen'||unistr('\000a')||
'where fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  --AND fkategorie_id = :p1_tab9_kategorie_id '||unistr('\000a')||
'  and (fkategorie_fkategorie_id = :p1_tab9_kategorie_id or'||unistr('\000a')||
'       FKATEGORIE_fkategorie_ID is null and fkategorie_id= :p1_tab9_kategorie_id'||unistr('\000a')||
'      )  '||unistr('\000a')||
'  AND personenstamm_id = :p1_id'||unistr('\000a')||
'  AND sprache_id ';

s:=s||'= :fas_sprache_id'||unistr('\000a')||
'  AND fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 9615710773029331 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 9,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 35,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px; min-width:1400px;">',
  p_footer=> '</div>'||unistr('\000a')||
'',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB9_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'REPEAT_HEADINGS_ON_BREAK_1',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9615926524029331 + wwv_flow_api.g_id_offset,
  p_region_id=> 9615710773029331 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9616030294029331 + wwv_flow_api.g_id_offset,
  p_region_id=> 9615710773029331 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9616107154029331 + wwv_flow_api.g_id_offset,
  p_region_id=> 9615710773029331 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'FRAGEBOGENANZEIGE',
  p_ref_column_name=> 'FRAGE_TEXT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9616200918029334 + wwv_flow_api.g_id_offset,
  p_region_id=> 9615710773029331 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AUSWAHL',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12589926360908525 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 9,
  p_button_sequence=> 10,
  p_button_plug_id => 9615710773029331+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5381602039485395 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 9,
  p_button_sequence=> 15,
  p_button_plug_id => 9615710773029331+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3970919805753250 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 9,
  p_button_sequence=> 20,
  p_button_plug_id => 9615710773029331+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3971102942753250 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 9,
  p_button_sequence=> 30,
  p_button_plug_id => 9615710773029331+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3874730249497995 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 9,
  p_button_sequence=> 40,
  p_button_plug_id => 9615710773029331+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3878819869570695 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 9,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3874730249497995+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3971812070753251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 9,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id;   --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPL';

p:=p||'ICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
' :P1_FEHLER := null;'||unistr('\000a')||
' FRGBG_S.SPEICHERN'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    v_user, :P1_TAB9_KATEGORIE_ID, :p1_fragebogen_id, :p1_id,:p1_pergebnis_id, '||unistr('\000a')||
'    frgbg_s.get_sprache_id(:APP_USER), :P1_FEHLER'||unistr('\000a')||
'  );'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung';

p:=p||' auch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3971520915753251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 9,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab9_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab9_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hinwe';

p:=p||'is LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4124526805376804 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 9,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 5087411073644800 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 9,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 7959218215526246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 9,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3882630005630343 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 9,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 9
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00010
prompt  ...PAGE 10: Aktualisieren FRAGEBOGENANZEIGE 10
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 10
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 10'
 ,p_step_title => 'Aktualisieren Fragebogenanzeige 10'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren Fragebogenanzeige 10'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'  '
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140630160016'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 3980412090758512 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 10,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5569829315811279 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 10,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 55,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5929411985609470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 10,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'fkategorie_text,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'WHEN hilfe_text_id is not null '||unistr('\000a')||
'THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'|| hilfe_text_id||'',''||frage_text_id)'||unistr('\000a')||
'|| '''''',700,425)">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK,'||unistr('\000a')||
'frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    ANZEIGETYP_ID, FR';

s:=s||'AGEBOGEN_ID, FRAGE_ID, PERSONENSTAMM_ID, 1,1 ,'||unistr('\000a')||
'    :p1_pergebnis_id,'||unistr('\000a')||
'    :fas_sprache_id'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from v_fragen'||unistr('\000a')||
'where fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  --AND fkategorie_id = :p1_tab10_kategorie_id '||unistr('\000a')||
'  and (fkategorie_fkategorie_id = :p1_tab10_kategorie_id or'||unistr('\000a')||
'       FKATEGORIE_fkategorie_ID is null and fkategorie_id= :p1_tab10_kategorie_id'||unistr('\000a')||
'      )  '||unistr('\000a')||
'  AND personenstamm_id = :p1_id'||unistr('\000a')||
'  AND sprache_';

s:=s||'id = :fas_sprache_id'||unistr('\000a')||
'  AND fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 9621506879047137 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 10,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 35,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px; width:800px">',
  p_footer=> '</div>'||unistr('\000a')||
'',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB10_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'REPEAT_HEADINGS_ON_BREAK_1',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9621720905047137 + wwv_flow_api.g_id_offset,
  p_region_id=> 9621506879047137 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9621828616047137 + wwv_flow_api.g_id_offset,
  p_region_id=> 9621506879047137 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9621915893047137 + wwv_flow_api.g_id_offset,
  p_region_id=> 9621506879047137 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'FRAGEBOGENANZEIGE',
  p_ref_column_name=> 'FRAGE_TEXT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9622013855047137 + wwv_flow_api.g_id_offset,
  p_region_id=> 9621506879047137 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AUSWAHL',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12591106059912112 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 10,
  p_button_sequence=> 10,
  p_button_plug_id => 9621506879047137+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5381810696487834 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 10,
  p_button_sequence=> 15,
  p_button_plug_id => 9621506879047137+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3980618524758512 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 10,
  p_button_sequence=> 20,
  p_button_plug_id => 9621506879047137+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3980805697758514 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 10,
  p_button_sequence=> 30,
  p_button_plug_id => 9621506879047137+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3874901983499304 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 10,
  p_button_sequence=> 40,
  p_button_plug_id => 9621506879047137+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3879028527573208 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 10,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3874901983499304+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3981522174758514 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 10,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id;   --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPL';

p:=p||'ICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
' :P1_FEHLER := null;'||unistr('\000a')||
' FRGBG_S.SPEICHERN'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    v_user, :P1_TAB10_KATEGORIE_ID, :p1_fragebogen_id, :p1_id,:p1_pergebnis_id, '||unistr('\000a')||
'    frgbg_s.get_sprache_id(:APP_USER), :P1_FEHLER'||unistr('\000a')||
'  );'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderun';

p:=p||'g auch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3981218871758514 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 10,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab10_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab10_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hin';

p:=p||'weis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4124905465380078 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 10,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 5088116960646479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 10,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 7959722717527507 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 10,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3882802778632014 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 10,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 10
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00013
prompt  ...PAGE 13: saferpaytest
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 13
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'saferpaytest'
 ,p_step_title => 'saferpaytest'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'saferpaytest'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20110304114752'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 1497927960298194 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 13,
  p_plug_name=> 'saferpay',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 1498132630298201 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 13,
  p_button_sequence=> 10,
  p_button_plug_id => 1497927960298194+wwv_flow_api.g_id_offset,
  p_button_name    => 'START',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Start',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 1498319208298205 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 13,
  p_button_sequence=> 20,
  p_button_plug_id => 1497927960298194+wwv_flow_api.g_id_offset,
  p_button_name    => 'CLEAR',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Clear',
  p_button_position=> 'REGION_TEMPLATE_EDIT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>1500013901298214 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 13,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&FLOW_ID.:13:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>1498319208298205+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>1500221885298215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 13,
  p_branch_name=> '',
  p_branch_action=> '&P13_URL.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>1498132630298201+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 22-SEP-2010 10:40 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>1500422005298215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 13,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:215:&SESSION.:WINDOW_CLOSE_PAY_SPEICHERN:&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':P13_PAYSTATUS = 1 and 1=2',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>1500623762298215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 13,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:215:&SESSION.:WINDOW_CLOSE_PAY_ERROR:&DEBUG.:13::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':P13_PAYSTATUS in (2,3) and 1=2',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 27-SEP-2010 11:14 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>1500830779298217 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 13,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:13:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 110,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 02-MAR-2011 15:43 by BRIGITTE.NEIDHART');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1498503673298206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 13,
  p_name=>'P13_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 1497927960298194+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Url',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 300,
  p_cMaxlength=> 32767,
  p_cHeight=> 10,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1498722709298209 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 13,
  p_name=>'P13_PAYSTATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 1497927960298194+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Paystatus',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1498912963298209 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 13,
  p_name=>'P13_RETURNPARAM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 1497927960298194+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Returnparam',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1499102981298209 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 13,
  p_name=>'P13_WARENKORB_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 1497927960298194+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_betrag   NUMBER          ;'||unistr('\000a')||
'   v_waehrung VARCHAR2(5)     ;'||unistr('\000a')||
'   v_bez      VARCHAR2(1000)  ;'||unistr('\000a')||
'   v_lnk_page NUMBER          := :APP_PAGE_ID; -- Nach Saferpay soll wieder zur aktuelle Seite'||unistr('\000a')||
'   v_bestell_nr  VARCHAR2(80) ;'||unistr('\000a')||
'   v_waehrung_id number;'||unistr('\000a')||
'   v_plandatum   date;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'mel.p(''Preis %1, Waehrung %2 (%3), datum %4, wk %5, url %6'',v_prot_id,''test'',''gen_url 102/220';

p:=p||''','||unistr('\000a')||
'          v_betrag,v_waehrung_id, v_waehrung,v_plandatum,:p13_warenkorb_id,:p13_url);'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'   SELECT NVL(wk.gesamtpreis,0)+NVL(wk.mwst_betrag_1,0)+NVL(wk.mwst_betrag_2,0),'||unistr('\000a')||
'          wk.waehrung_id,w.code,wk.plandatum, HTMLDB_UTIL.URL_ENCODE(wk.bemerkung),wk.id'||unistr('\000a')||
'   INTO   v_betrag,v_waehrung_id, v_waehrung,v_plandatum ,v_bez,v_bestell_nr'||unistr('\000a')||
'   FROM warenkoerbe wk, waehrungen w'||unistr('\000a')||
'   WHERE wk.id = :';

p:=p||'p13_warenkorb_id'||unistr('\000a')||
'     and wk.waehrung_id = w.id;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN NULL; '||unistr('\000a')||
'   END;'||unistr('\000a')||
'   v_bez := replace(replace(replace(replace(replace(replace(replace(v_bez,''Ä'',''Ae'')'||unistr('\000a')||
'                   ,''Ü'',''Ue''),''Ö'',''Oe''),''ä'',''ae''),''ü'',''ue''),''ö'',''oe''),''ß'',''ss'');'||unistr('\000a')||
''||unistr('\000a')||
'   :p13_url := frgbg_s.cc_payinit(v_betrag,v_waehrung,v_bez,v_lnk_page,v_bestell_nr);'||unistr('\000a')||
''||unistr('\000a')||
'mel.p(''Preis %1, Waehrung %2 (%3), datum %4, wk %5';

p:=p||', url %6, %7'',v_prot_id,''test'',''gen_url 102/220'','||unistr('\000a')||
'          v_betrag,v_waehrung_id, v_waehrung,v_plandatum,:p13_warenkorb_id,:p13_url,v_bez);'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1499304759298211 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 13,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_url',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>1498132630298201 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'l_host VARCHAR2(2000);'||unistr('\000a')||
'v_str  varchar2(2000);'||unistr('\000a')||
'v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--l_host := portal.wwctx_api.get_user_id;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_user_id = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_sessionid;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_sessionid = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_host;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_host = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal';

p:=p||'.wwctx_api.get_base_url;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_base_url = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := OWA_UTIL.GET_CGI_ENV(''REQUEST_PROTOCOL'');'||unistr('\000a')||
'--htp.p(''OWA_UTIL.GET_CGI_ENV("REQUEST_PROTOCOL") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''OWA_UTIL.GET_CGI_ENV("REQUEST_PROTOCOL") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := OWA_UTIL.GET_CGI_ENV(''HTTP_HOST'');'||unistr('\000a')||
'--htp.p(''OWA_UTIL.GET_CGI_ENV("HTTP_HOST") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str';

p:=p||' := v_str||'',''||''OWA_UTIL.GET_CGI_ENV("HTTP_HOST") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := hiims_r1.hiimsutil.getPortalURLPrefix;'||unistr('\000a')||
'--htp.p(''hiims_r1.hiimsutil.getPortalURLPrefix = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_query_string;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_query_string = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''QUERY_STRING'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("QUERY_STRING") = ''||l_ho';

p:=p||'st);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("QUERY_STRING") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''PATH_INFO'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("PATH_INFO") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("PATH_INFO") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''REQUEST_URI'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("REQUEST_URI") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''o';

p:=p||'wa_util.get_cgi_env("REQUEST_URI") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''DOCUMENT_URI'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("DOCUMENT_URI") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("DOCUMENT_URI") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'mel.p(v_str,v_prot_id,''INFO'',''URL'');'||unistr('\000a')||
''||unistr('\000a')||
'htp.p(''Done...'');'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS'||unistr('\000a')||
'THEN'||unistr('\000a')||
'htp.br;'||unistr('\000a')||
'htp.p(''Error!'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1499507036298212 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 13,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_afterpay_url',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p13_paystatus in (1)',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'220';

wwv_flow_api.create_page_process(
  p_id     => 1499715484298212 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 13,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'cache_clear',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>1498319208298205 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 13
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00014
prompt  ...PAGE 14: Master Detail
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 14
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Master Detail'
 ,p_step_title => 'Master Detail'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150414102544'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 18448613921840312 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 14,
  p_plug_name=> 'Edit LABOR_ANALYSEWERTE',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'"ID",'||unistr('\000a')||
'"WSH_KUNDENAUFTRAG_POS_ID",'||unistr('\000a')||
'"INH_GRENZWERTTYP_WARN",'||unistr('\000a')||
'"MENGENART_MN_REZEPT_ID",'||unistr('\000a')||
'"REICHWEITE",'||unistr('\000a')||
'"PRODKENNZ_ID",'||unistr('\000a')||
'"P_REZEPT_ID",'||unistr('\000a')||
'"MENGENART_ID",'||unistr('\000a')||
'"MENGE",'||unistr('\000a')||
'"VOLUMEN",'||unistr('\000a')||
'"GEWICHT",'||unistr('\000a')||
'"PREIS",'||unistr('\000a')||
'"MWST_BETRAG",'||unistr('\000a')||
'"MWST_SATZ",'||unistr('\000a')||
'"WK_STATUS_ID",'||unistr('\000a')||
'"STATUS_AENDERDATUM",'||unistr('\000a')||
'"STATUS_AENDERVISUM",'||unistr('\000a')||
'"ETIKETTENTYP",'||unistr('\000a')||
'"BEMERKUNG",'||unistr('\000a')||
'"ERFDAT",'||unistr('\000a')||
'"ERFUSER",'||unistr('\000a')||
'"MUTDAT",'||unistr('\000a')||
'"MUTUSER",'||unistr('\000a')||
'"INH_GRENZWERTTYP_ID",'||unistr('\000a')||
'"PROVISIONSPUNKTWERT",'||unistr('\000a')||
'"';

s:=s||'PROVISIONSPUNKTE",'||unistr('\000a')||
'"REZEPT_MENGE",'||unistr('\000a')||
'"REZEPT_GEWICHT",'||unistr('\000a')||
'"REZEPT_MENGENART_ID"'||unistr('\000a')||
'from "#OWNER#"."WARENKORB_DETAILS"'||unistr('\000a')||
'where "ID" = :P14_AUFTRAG_ID_INTERN'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 14,
  p_name=> 'WARENKORB_DETAILS Detail',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => true,
  p_new_grid_column  => true,
  p_display_column=> null,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_display_when_condition=> 'P14_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_plug_caching=> 'NOT_CACHED',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 2899210279489446+ wwv_flow_api.g_id_offset,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '10',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_no_data_found=> 'No data found.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '500',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18470009158840535 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> 'Select Row',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18458420164840478 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 2,
  p_column_heading=> 'Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18458508982840481 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'WSH_KUNDENAUFTRAG_POS_ID',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Wsh Kundenauftrag Pos Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'WSH_KUNDENAUFTRAG_POS_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18458623345840481 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'INH_GRENZWERTTYP_WARN',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Inh Grenzwerttyp Warn',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'INH_GRENZWERTTYP_WARN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18458719500840481 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_MN_REZEPT_ID',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Mengenart Mn Rezept Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MENGENART_MN_REZEPT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18458831682840481 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'REICHWEITE',
  p_column_display_sequence=> 6,
  p_column_heading=> 'Reichweite',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'REICHWEITE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18458929308840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> 'Prodkennz Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'PRODKENNZ_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459002346840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'P_REZEPT_ID',
  p_column_display_sequence=> 8,
  p_column_heading=> 'P Rezept Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'P_REZEPT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459107099840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 9,
  p_column_heading=> 'Mengenart Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459210217840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 10,
  p_column_heading=> 'Menge',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459326402840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'VOLUMEN',
  p_column_display_sequence=> 11,
  p_column_heading=> 'Volumen',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'VOLUMEN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459420084840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'GEWICHT',
  p_column_display_sequence=> 12,
  p_column_heading=> 'Gewicht',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'GEWICHT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459507562840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'PREIS',
  p_column_display_sequence=> 13,
  p_column_heading=> 'Preis',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'PREIS',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459631051840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_BETRAG',
  p_column_display_sequence=> 14,
  p_column_heading=> 'Mwst Betrag',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MWST_BETRAG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459712902840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_SATZ',
  p_column_display_sequence=> 15,
  p_column_heading=> 'Mwst Satz',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MWST_SATZ',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459801147840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS_ID',
  p_column_display_sequence=> 16,
  p_column_heading=> 'Wk Status Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'WK_STATUS_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18459900381840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERDATUM',
  p_column_display_sequence=> 17,
  p_column_heading=> 'Status Aenderdatum',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'DATE_PICKER',
  p_column_width=> '12',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'STATUS_AENDERDATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460011835840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERVISUM',
  p_column_display_sequence=> 18,
  p_column_heading=> 'Status Aendervisum',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'STATUS_AENDERVISUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460107799840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'ETIKETTENTYP',
  p_column_display_sequence=> 19,
  p_column_heading=> 'Etikettentyp',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'ETIKETTENTYP',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460212459840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 20,
  p_column_heading=> 'Bemerkung',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'BEMERKUNG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460302715840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'ERFDAT',
  p_column_display_sequence=> 21,
  p_column_heading=> 'Erfdat',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'DATE_PICKER',
  p_column_width=> '12',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'ERFDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460414554840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'ERFUSER',
  p_column_display_sequence=> 22,
  p_column_heading=> 'Erfuser',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'ERFUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460527212840482 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'MUTDAT',
  p_column_display_sequence=> 23,
  p_column_heading=> 'Mutdat',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'DATE_PICKER',
  p_column_width=> '12',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MUTDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460622428840483 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'MUTUSER',
  p_column_display_sequence=> 24,
  p_column_heading=> 'Mutuser',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MUTUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460712073840483 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'INH_GRENZWERTTYP_ID',
  p_column_display_sequence=> 25,
  p_column_heading=> 'Inh Grenzwerttyp Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'INH_GRENZWERTTYP_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460827871840483 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'PROVISIONSPUNKTWERT',
  p_column_display_sequence=> 26,
  p_column_heading=> 'Provisionspunktwert',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'PROVISIONSPUNKTWERT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18460927871840483 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 27,
  p_form_element_id=> null,
  p_column_alias=> 'PROVISIONSPUNKTE',
  p_column_display_sequence=> 27,
  p_column_heading=> 'Provisionspunkte',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'PROVISIONSPUNKTE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18461004217840483 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 28,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_MENGE',
  p_column_display_sequence=> 28,
  p_column_heading=> 'Rezept Menge',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'REZEPT_MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18461101544840483 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 29,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_GEWICHT',
  p_column_display_sequence=> 29,
  p_column_heading=> 'Rezept Gewicht',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'REZEPT_GEWICHT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18461211174840483 + wwv_flow_api.g_id_offset,
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 30,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_MENGENART_ID',
  p_column_display_sequence=> 30,
  p_column_heading=> 'Rezept Mengenart Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'REZEPT_MENGENART_ID',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 18448907389840331 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 14,
  p_button_sequence=> 30,
  p_button_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Apply Changes',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P14_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18461614972840511 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 14,
  p_button_sequence=> 40,
  p_button_plug_id => 18458112192840460+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_ADD',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Add Row',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.widget.tabular.addRow();',
  p_button_execute_validations=>'N',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18449211426840333 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 14,
  p_button_sequence=> 10,
  p_button_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Cancel',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:0:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18448823502840331 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 14,
  p_button_sequence=> 40,
  p_button_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Create',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P14_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18449022870840331 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 14,
  p_button_sequence=> 20,
  p_button_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Delete',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'P14_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'DELETE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18461532081840511 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 14,
  p_button_sequence=> 20,
  p_button_plug_id => 18458112192840460+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_MRD',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Delete Checked',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''APPLY_CHANGES_MRD'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'select 1 '||unistr('\000a')||
'from "#OWNER#"."WARENKORB_DETAILS"'||unistr('\000a')||
'where "ID" = :P14_AUFTRAG_ID_INTERN',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>18457908205840452 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:0:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'REQUEST_IN_CONDITION',
  p_branch_condition=> 'SAVE,DELETE,CREATE',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>18470107067840535 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:14:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18449829597840398 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18450031549840422 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_WARENKORB_DETAIL_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Warenkorb Detail Id',
  p_source=>'WARENKORB_DETAIL_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18450218251840425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Geburtsdatum',
  p_source=>'GEBURTSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18450427486840427 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_ANALYSEKUERZEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Analysekuerzel',
  p_source=>'ANALYSEKUERZEL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18450621439840428 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_ERGEBNISWERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Ergebniswert',
  p_source=>'ERGEBNISWERT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18450822538840428 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_EINHEIT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Einheit',
  p_source=>'EINHEIT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18451023305840429 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_WERTEBEREICH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Wertebereich',
  p_source=>'WERTEBEREICH',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 1000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18451223715840430 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_AT_BEARB_DATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'At Bearb Datum',
  p_source=>'AT_BEARB_DATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18451417584840431 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_SATZ_KENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Satz Kennzeichen',
  p_source=>'SATZ_KENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18451615887840431 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_ERFDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Erfdat',
  p_source=>'ERFDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18451818267840434 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18452015109840434 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_MUTDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Mutdat',
  p_source=>'MUTDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18452202755840435 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18452421143840435 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_DATEINAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Dateiname',
  p_source=>'DATEINAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18452619928840436 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_AT_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'At Bemerkung',
  p_source=>'AT_BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18452811520840436 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_AT_PERSANTWORT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'At Persantwort Id',
  p_source=>'AT_PERSANTWORT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18453023858840437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_ERGEBNISWERT_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Ergebniswert Text Id',
  p_source=>'ERGEBNISWERT_TEXT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18453204784840437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_ERGEBNISWERT_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Ergebniswert Text',
  p_source=>'ERGEBNISWERT_TEXT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18453426043840438 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_LABOR_ANALYSEKUERZEL_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Labor Analysekuerzel Id',
  p_source=>'LABOR_ANALYSEKUERZEL_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18453607574840438 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_BEZUG_EINHEIT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Bezug Einheit Id',
  p_source=>'BEZUG_EINHEIT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18453828571840439 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_LABOR_ERSATZWERT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Labor Ersatzwert Id',
  p_source=>'LABOR_ERSATZWERT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18454004269840439 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_MIN_WERTEBEREICH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 220,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Min Wertebereich',
  p_source=>'MIN_WERTEBEREICH',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18454203428840440 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_MAX_WERTEBEREICH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Max Wertebereich',
  p_source=>'MAX_WERTEBEREICH',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18454400457840440 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_LABOR_FAS_ERSATZWERT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Labor Fas Ersatzwert Id',
  p_source=>'LABOR_FAS_ERSATZWERT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18454602943840441 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 14,
  p_name=>'P14_LABOR_AUFTRAG_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 18448613921840312+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Labor Auftrag Status Id',
  p_source=>'LABOR_AUFTRAG_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_03 => 'right',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18462308700840519 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'WSH_KUNDENAUFTRAG_POS_ID must be numeric',
  p_validation_sequence=> 20,
  p_validation => 'WSH_KUNDENAUFTRAG_POS_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'WSH_KUNDENAUFTRAG_POS_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18462509513840522 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'INH_GRENZWERTTYP_WARN must be numeric',
  p_validation_sequence=> 30,
  p_validation => 'INH_GRENZWERTTYP_WARN',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'INH_GRENZWERTTYP_WARN',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18462715519840522 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MENGENART_MN_REZEPT_ID must be numeric',
  p_validation_sequence=> 40,
  p_validation => 'MENGENART_MN_REZEPT_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MENGENART_MN_REZEPT_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18462918137840522 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'REICHWEITE must be numeric',
  p_validation_sequence=> 50,
  p_validation => 'REICHWEITE',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'REICHWEITE',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18463100036840523 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'PRODKENNZ_ID must be numeric',
  p_validation_sequence=> 60,
  p_validation => 'PRODKENNZ_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'PRODKENNZ_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18463330782840523 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'P_REZEPT_ID must be numeric',
  p_validation_sequence=> 70,
  p_validation => 'P_REZEPT_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'P_REZEPT_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18463511678840523 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MENGENART_ID must be numeric',
  p_validation_sequence=> 80,
  p_validation => 'MENGENART_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MENGENART_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18463727656840523 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MENGE not null',
  p_validation_sequence=> 90,
  p_validation => 'MENGE',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MENGE',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18463918234840524 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MENGE must be numeric',
  p_validation_sequence=> 90,
  p_validation => 'MENGE',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MENGE',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18464111213840524 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'VOLUMEN must be numeric',
  p_validation_sequence=> 100,
  p_validation => 'VOLUMEN',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'VOLUMEN',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18464322436840524 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'GEWICHT must be numeric',
  p_validation_sequence=> 110,
  p_validation => 'GEWICHT',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'GEWICHT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18464526756840524 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'PREIS not null',
  p_validation_sequence=> 120,
  p_validation => 'PREIS',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'PREIS',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18464725247840525 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'PREIS must be numeric',
  p_validation_sequence=> 120,
  p_validation => 'PREIS',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'PREIS',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18464927201840525 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MWST_BETRAG not null',
  p_validation_sequence=> 130,
  p_validation => 'MWST_BETRAG',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MWST_BETRAG',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18465115072840525 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MWST_BETRAG must be numeric',
  p_validation_sequence=> 130,
  p_validation => 'MWST_BETRAG',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MWST_BETRAG',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18465331539840525 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MWST_SATZ not null',
  p_validation_sequence=> 140,
  p_validation => 'MWST_SATZ',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MWST_SATZ',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18465514635840525 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MWST_SATZ must be numeric',
  p_validation_sequence=> 140,
  p_validation => 'MWST_SATZ',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MWST_SATZ',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18465727099840526 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'WK_STATUS_ID not null',
  p_validation_sequence=> 150,
  p_validation => 'WK_STATUS_ID',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'WK_STATUS_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18465904273840526 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'WK_STATUS_ID must be numeric',
  p_validation_sequence=> 150,
  p_validation => 'WK_STATUS_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'WK_STATUS_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18466132398840526 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'STATUS_AENDERDATUM not null',
  p_validation_sequence=> 160,
  p_validation => 'STATUS_AENDERDATUM',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'STATUS_AENDERDATUM',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18466315528840526 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'STATUS_AENDERDATUM must be a valid date',
  p_validation_sequence=> 160,
  p_validation => 'STATUS_AENDERDATUM',
  p_validation_type => 'ITEM_IS_DATE',
  p_error_message => '#COLUMN_HEADER# must be a valid date.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'STATUS_AENDERDATUM',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18466500046840526 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'STATUS_AENDERVISUM not null',
  p_validation_sequence=> 170,
  p_validation => 'STATUS_AENDERVISUM',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'STATUS_AENDERVISUM',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18466717196840527 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'ETIKETTENTYP must be numeric',
  p_validation_sequence=> 180,
  p_validation => 'ETIKETTENTYP',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'ETIKETTENTYP',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18466909253840527 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'ERFDAT not null',
  p_validation_sequence=> 200,
  p_validation => 'ERFDAT',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'ERFDAT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18467118773840527 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'ERFDAT must be a valid date',
  p_validation_sequence=> 200,
  p_validation => 'ERFDAT',
  p_validation_type => 'ITEM_IS_DATE',
  p_error_message => '#COLUMN_HEADER# must be a valid date.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'ERFDAT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18467301442840528 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'ERFUSER not null',
  p_validation_sequence=> 210,
  p_validation => 'ERFUSER',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'ERFUSER',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18467513466840528 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MUTDAT not null',
  p_validation_sequence=> 220,
  p_validation => 'MUTDAT',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MUTDAT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18467700024840528 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MUTDAT must be a valid date',
  p_validation_sequence=> 220,
  p_validation => 'MUTDAT',
  p_validation_type => 'ITEM_IS_DATE',
  p_error_message => '#COLUMN_HEADER# must be a valid date.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MUTDAT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18467921862840528 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'MUTUSER not null',
  p_validation_sequence=> 230,
  p_validation => 'MUTUSER',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'MUTUSER',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18468102292840528 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'INH_GRENZWERTTYP_ID must be numeric',
  p_validation_sequence=> 240,
  p_validation => 'INH_GRENZWERTTYP_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'INH_GRENZWERTTYP_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18468322264840529 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'PROVISIONSPUNKTWERT not null',
  p_validation_sequence=> 250,
  p_validation => 'PROVISIONSPUNKTWERT',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'PROVISIONSPUNKTWERT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18468525757840529 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'PROVISIONSPUNKTWERT must be numeric',
  p_validation_sequence=> 250,
  p_validation => 'PROVISIONSPUNKTWERT',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'PROVISIONSPUNKTWERT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18468728800840529 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'PROVISIONSPUNKTE not null',
  p_validation_sequence=> 260,
  p_validation => 'PROVISIONSPUNKTE',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'PROVISIONSPUNKTE',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18468921170840529 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'PROVISIONSPUNKTE must be numeric',
  p_validation_sequence=> 260,
  p_validation => 'PROVISIONSPUNKTE',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'PROVISIONSPUNKTE',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18469104984840529 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'REZEPT_MENGE must be numeric',
  p_validation_sequence=> 270,
  p_validation => 'REZEPT_MENGE',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'REZEPT_MENGE',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18469303455840530 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'REZEPT_GEWICHT must be numeric',
  p_validation_sequence=> 280,
  p_validation => 'REZEPT_GEWICHT',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'REZEPT_GEWICHT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 18469504928840530 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_tabular_form_region_id => 18458112192840460 + wwv_flow_api.g_id_offset,
  p_validation_name => 'REZEPT_MENGENART_ID must be numeric',
  p_validation_sequence=> 290,
  p_validation => 'REZEPT_MENGENART_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_validation_condition=> ':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_exec_cond_for_each_row=> 'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_column=> 'REZEPT_MENGENART_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:LABOR_ANALYSEWERTE:P14_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 18457414115840448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from LABOR_ANALYSEWERTE',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:LABOR_ANALYSEWERTE:P14_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 18457603499840451 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of LABOR_ANALYSEWERTE',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_success_message=> 'Action Processed.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKORB_DETAILS:ID';

wwv_flow_api.create_page_process(
  p_id     => 18469620386840530 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_UPDATE',
  p_process_name=> 'ApplyMRU',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request like (''SAVE'') or :request like ''GET_NEXT%'' or :request like ''GET_PREV%''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKORB_DETAILS:ID';

wwv_flow_api.create_page_process(
  p_id     => 18469803144840531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 18458112192840460 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_DELETE',
  p_process_name=> 'ApplyMRD',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'APPLY_CHANGES_MRD',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '#MRD_COUNT# row(s) deleted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'14';

wwv_flow_api.create_page_process(
  p_id     => 18457827173840451 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 14,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>18449022870840331 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 14
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00031
prompt  ...PAGE 31: Aktualisieren FRAGEBOGENANZEIGE 31
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 31
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 31'
 ,p_step_title => 'Aktualisieren FRAGEBOGENANZEIGE 31'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren FRAGEBOGENANZEIGE 31'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_checklaborwerte (feld_id,wert,eh_id)'||unistr('\000a')||
'{ '||unistr('\000a')||
'  var feld_menge = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkLaborWerte'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  get.add(''P31_EINHEIT_ID_INPUT'',eh_id);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = gReturn ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = '''' ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'function f_checkdatum(feld_id,datum,fragetext)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_datum = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkMessdatum'',0);'||unistr('\000a')||
'  get.add(''P31_DATUM'',datum);'||unistr('\000a')||
'  get.add(''P31_FRAGE_TEXT'',fragetext);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'function f_checknormbereich(feld_id,normbereich,wert)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_normbereich = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkNormbereich'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_NORMBEREICH'',normbereich);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141022144358'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||''||unistr('\000a')||
'select'||unistr('\000a')||
'   f.fkategorie_text fkategorie_text,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'   WHEN hilfe_text_id is not null'||unistr('\000a')||
'   THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'   ||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'   || f.hilfe_text_id||'',''||f.frage_text_id)'||unistr('\000a')||
'   || '''''',700,425)">'''||unistr('\000a')||
'   || ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'   || ''</a>'''||unistr('\000a')||
'   ELSE '' '''||unistr('\000a')||
'   END LINK,'||unistr('\000a')||
'   apex_';

s:=s||'item.hidden(2,f.frage_id) ||'||unistr('\000a')||
'   apex_item.hidden(3,p.ID) ||'||unistr('\000a')||
'   f.FRAGE_TEXT FRAGE_TEXT,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder => Wert */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id =';

s:=s||' f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_2'||unistr('\000a')||
'                           and satz_kennzeichen is null)))||'||unistr('\000a')||
'         apex_item.text(8,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id = f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_';

s:=s||'2'||unistr('\000a')||
'                           and satz_kennzeichen is null)),'||unistr('\000a')||
'                        10,15,''tabindex="1" autocomplete="off"'||unistr('\000a')||
'   onchange="javascript:f_checklaborwerte('''''' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'''||unistr('\000a')||
'    || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0';

s:=s||') = 1 then '' disabled'' else '''' end , f.frage_ID'||unistr('\000a')||
'                       )'||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => ID der Fantwort */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,p.FANTWORT_ID)||'||unistr('\000a')||
'         apex_item.select_list_from_query(8,p.FANTWORT_ID,'||unistr('\000a')||
'            ''select frgbg_s.HOLEN_UEBERSETZUNG(fant.text_id,:fas_sprache_id), fant.id from fantworten fant where f';

s:=s||'ant.frage_id*1000000 = ''||'||unistr('\000a')||
'                                          f.frage_ID*1000000||'||unistr('\000a')||
''' and fant.satz_kennzeichen is null order by fant.sort asc '','||unistr('\000a')||
'            NULL,''NO'',NULL,NULL)'||unistr('\000a')||
'      END fantwort_zahl_eingabe,'||unistr('\000a')||
''||unistr('\000a')||
'   CASE /* Eingabefeld EH */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5  AND f.bezug_einheit_id != 181 THEN  /* Textfelder => EH-Eingabe LOV*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,';

s:=s||''||unistr('\000a')||
'               rezepte.get_inh_def_bezug_eh(f.inhstoff_id)))||'||unistr('\000a')||
'         apex_item.select_list_from_query(10,NVL(p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'                       rezepte.get_inh_def_bezug_eh(f.inhstoff_id)),'||unistr('\000a')||
'''select rezepte.get_bezug_eh_bez(u.bezug_einheit_id,:fas_sprache_id), u.bezug_einheit_id from inh_eh_disps u, bezug_einheiten be, einheiten e where u.inhstoff_id = ''||f.inhstoff_id||'' and u.satz_kenn';

s:=s||'zeichen is null and u.bezug_einheit_id = be.id and be.satz_kennzeichen is null and be.einheit_id = e.id and e.physeh_id in (SELECT e.physeh_id FROM inh_eh_umrs i, einheiten e WHERE i.inhstoff_id = ''||f.inhstoff_id||'' and i.satz_kennzeichen is null and i.einheit_id = e.id and e.satz_kennzeichen is null) order by u.sort asc'','||unistr('\000a')||
'''onchange="javascript:f_checklaborwerte('''''' || f.frage_ID || '''''',html_GetE';

s:=s||'lement('''''' || f.frage_ID || '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'' || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1'||unistr('\000a')||
'    /* OR FRGBG_T.LAB_MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 */ then '' disabled'' else '''' end,'||unistr('\000a')||
'''NO'',NULL,NULL,''EH''||f.frage_ID'||unistr('\000a')||
')'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND f.bezug_einheit_id = 1';

s:=s||'81 THEN  /* Textfelder ohne EH-Eingabe z.B. pH-Werte immer bezug_einheit 181*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,181))||'||unistr('\000a')||
'         apex_item.hidden(10,NVL(p.FANTWORT_ZAHL_2,181),NULL,''EH''||f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => Keine EH-Eingabe */'||unistr('\000a')||
'         apex_item.hidden(9,NULL)||'||unistr('\000a')||
'         apex_item.hidden(10,NULL)||'||unistr('\000a')||
'         '''''||unistr('\000a')||
'      END fantwort_eh_eingabe ,'||unistr('\000a')||
'   ';

s:=s||'apex_item.hidden(11,'||unistr('\000a')||
'                     to_char(NVL(p.messdatum,sysdate),''DD.MM.RRRR hh24:mi''))||'||unistr('\000a')||
'   apex_item.text(12,to_char(NVL(p.messdatum,sysdate),''DD.MM.YYYY hh24:mi'')'||unistr('\000a')||
',20,20,''tabindex="1" autocomplete="off" onchange="javascript:f_checkdatum(''''DAT''||f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''DAT'' || f.frage_ID || '''''').value, ''''''|| f.frage_text||'''''')"'' || case when decode(NVL(FRGBG_S.FB_CHECK_F';

s:=s||'ANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end, ''DAT''||f.frage_ID'||unistr('\000a')||
') messdatum,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         apex_item.hidden(16,NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                             WHERE frage_id = f.frage_id'||unistr('\000a')||
'                               and satz_kennzeichen is null)))||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
' ';

s:=s||'     ELSE         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         apex_item.hidden(16,p.FANTWORT_ID)||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
'      END fantwort_id,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                                           WHERE frage_id = f.frage_id'||unistr('\000a')||
'                                             and satz_kennzeichen is null))'||unistr('\000a')||
'      EL';

s:=s||'SE         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         p.FANTWORT_ID'||unistr('\000a')||
'      END fantwort_id_disp,'||unistr('\000a')||
'   p.id persantwort_id, f.frage_id frage_id,p.FANTWORT_ZAHL,p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'   CASE WHEN p.fantwort_text is NULL THEN'||unistr('\000a')||
'     CASE WHEN p.LABOR_FAS_ERSATZWERT_ID is not null THEN'||unistr('\000a')||
'        (SELECT frgbg_s.HOLEN_UEBERSETZUNG(KUERZEL_TEXT_ID,:fas_sprache_id) FROM LABOR_FAS_ERSATZWERTE WHERE ID = p.LABOR_FAS_ERSATZWER';

s:=s||'T_ID)'||unistr('\000a')||
'     ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id)'||unistr('\000a')||
'     END'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id,p.fantwort_text )'||unistr('\000a')||
'   END ersatzwert_text,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND (select max(NORMIERUNGSTYP) from FANTWORTEN where FRAGE_Id = f.FRAGE_ID) = ''LABORBEREICH'' THEN'||unistr('\000a')||
'         CASE WHEN FRGBG_T.LAB';

s:=s||'_MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 THEN'||unistr('\000a')||
'           -- Wenn Labor mehrere Normbereiche geliefert hat, dürfen diese hier nicht bearbeitet werden,'||unistr('\000a')||
'           -- da über die Maske nur personenspezifische Normbereiche eingegeben werden dürfen'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
' ';

s:=s||'          apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT))'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'           apex_item.hidden(17,CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                    CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,';

s:=s||'p.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standardnormbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                   ELSE';

s:=s||' NULL END'||unistr('\000a')||
'                END'||unistr('\000a')||
'                   ) ||'||unistr('\000a')||
'           apex_item.text(18, CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                  CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standar';

s:=s||'dnormbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                  ELSE NULL END'||unistr('\000a')||
'                END, 10,15,''tabindex="1" autocomplete="off"';

s:=s||' onblur="javascript:f_checknormbereich(''''NORMB'' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''NORMB'' ||f.frage_ID || '''''').value, html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value)"'''||unistr('\000a')||
'              || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end'||unistr('\000a')||
'            , ''NORMB'' || f.frage_ID'||unistr('\000a')||
'         )'||unistr('\000a')||
'        END'||unistr('\000a')||
'     ELSE -- Bei';

s:=s||' anderen Anzeigetypen auch keine Eingabe möglich'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
'           apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT),''NORMB'' || f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'     END fantwort_normbereich'||unistr('\000a')||
'from v_fragen f, persantworten p --, uebersetzungen u ';

s:=s||'-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'where f.fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  and (f.fkategorie_fkategorie_id = :p31_tab31_kategorie_id or'||unistr('\000a')||
'       f.FKATEGORIE_fkategorie_ID is null and f.fkategorie_id='||unistr('\000a')||
'                                              :p31_tab31_kategorie_id'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and f.personenstamm_id = :p1_id'||unistr('\000a')||
'  AND f.sprache_id = :fas_sprache_id'||unistr('\000a')||
'  AND f.fragelevel = ';

s:=s||'0 /* keine Metafragen */'||unistr('\000a')||
'  AND f.visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'  AND f.anzeigetyp_id in (3,4,5) /* Radio, Text */'||unistr('\000a')||
'  and f.frage_id = p.frage_id(+)'||unistr('\000a')||
'  and p.pergebnis_id(+) = :p1_pergebnis_id'||unistr('\000a')||
'  and p.satz_kennzeichen (+) is null'||unistr('\000a')||
'  --and f.such_text_id = u.text_id (+)'||unistr('\000a')||
'  --and u.sprache_id (+) = :fas_sprache_id'||unistr('\000a')||
'  and (:p31_suchbemerkung_NOSAVE is null OR'||unistr('\000a')||
'       --UPPER(u.text) lik';

s:=s||'e ''%''||UPPER(:p31_suchbemerkung_NOSAVE)||''%'' OR   -- NEI 20.11.13'||unistr('\000a')||
'       UPPER(frgbg_s.HOLEN_UEBERSETZUNG(f.such_text_id,:fas_sprache_id)) like ''%''||UPPER(:p31_suchbemerkung_NOSAVE)||''%'' OR'||unistr('\000a')||
'       UPPER(f.FRAGE_TEXT) like ''%''||UPPER(:p31_suchbemerkung_NOSAVE)||''%'''||unistr('\000a')||
'      )'||unistr('\000a')||
'--  and f.frage_id > 0   -- Nur zu Testzwecken'||unistr('\000a')||
'--order by f.fkategorie_sort,f.frage_sort'||unistr('\000a')||
'--order by f.fkategorie_sort,CASE WHEN';

s:=s||' p.id is null THEN 0 ELSE 1 END desc ,f.frage_text'||unistr('\000a')||
'order by f.fkategorie_sort,f.frage_text';

wwv_flow_api.create_report_region (
  p_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 31,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;margin:10px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P31_TAB31_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> 'ROW_RANGES_WITH_LINKS',
  p_query_row_count_max=> '300',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4989403377394618 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4842828058974037 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4828832649764078 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5072518542411431 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_EINGABE',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5080223573533448 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_EH_EINGABE',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5080324684533448 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MESSDATUM',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5080419818533448 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5080512596533448 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID_DISP',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4828622147764078 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'PERSANTWORT_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4928606581427196 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4945200065689817 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4946522205693039 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_2',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5502304367099145 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'ERSATZWERT_TEXT',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8516818906930485 + wwv_flow_api.g_id_offset,
  p_region_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_NORMBEREICH',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 4829507157764079 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 31,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5570022136865979 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 31,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5931822074640831 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 31,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 35,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4830528575764081 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 31,
  p_button_sequence=> 10,
  p_button_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4830311255764079 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 31,
  p_button_sequence=> 15,
  p_button_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4829931062764079 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 31,
  p_button_sequence=> 20,
  p_button_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4830119779764079 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 31,
  p_button_sequence=> 30,
  p_button_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3875203499509227 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 31,
  p_button_sequence=> 40,
  p_button_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3879310650577445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3875203499509227+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4832800546764085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4831112599764084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_ID_INPUT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Inhstoff Id Input',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4831316153764084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_WERT_INPUT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 600,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Einheit Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4831511735764084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_EINHEIT_ID_INPUT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 700,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Einheit Id Input',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4833432536787445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB31_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab31 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4833626780795289 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB31_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab31 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4833805093798414 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB31_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab31 Kategorie Zeilen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4837908959903687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB32_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 101,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab32 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4838123504907884 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB33_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 102,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab33 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4838332507910462 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB34_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 103,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab34 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4838507358912667 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB35_KATEGORIE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 104,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab35 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4838719825916276 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB32_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 131,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab32 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4838930214919223 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB33_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 132,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab33 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4839107836922250 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB34_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 133,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab34 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4839317186924926 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB35_KATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 134,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab35 Kategorie Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4839526190927542 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB32_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 151,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab32 Kategorie Zeilen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4839711776932892 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB33_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 152,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'TAB33_KATEGORIE_ZEILEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4839920780935409 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB34_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 153,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab34 Kategorie Zeilen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4840128745937712 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_TAB35_KATEGORIE_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 154,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab35 Kategorie Zeilen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4936313552776279 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_ICON_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'SUCHEN',
  p_source=>'SUCHEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_button_image_attr=> 'onclick="xwoher=2"',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4947105832971756 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_SUCHBEMERKUNG_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onclick="xwoher=2"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4965301223356551 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_DATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 710,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Datum',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4968013531473665 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_FRAGE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 720,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Frage Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8539325000431503 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 31,
  p_name=>'P31_NORMBEREICH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 730,
  p_item_plug_id => 4828404131764076+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4831807374764084 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 31,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_eingabe',
  p_validation_sequence=> 50,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_change  NUMBER := 0;'||unistr('\000a')||
'   v_fehlertext  VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Check wurde ausgelagert, da Code zu lang'||unistr('\000a')||
'   v_change := frgbg_s.fb_check_labor_eing(v_fehlertext);'||unistr('\000a')||
'   -- Fehler wird erst vor Speichern ausgewertet und mit Raise angezeigt'||unistr('\000a')||
'   :p1_fehler := v_fehlertext;'||unistr('\000a')||
'   IF v_change = 0 THEN  -- Keine Daten geändert'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(2020,v_sprache_id ));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 4830119779764079 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPLIC';

p:=p||'ATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
'  v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
'  IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
'  END IF; '||unistr('\000a')||
'  FRGBG_S.SPEICHERN_LABOR'||unistr('\000a')||
'     ( '||unistr('\000a')||
'      v_user,:p31_tab31_kategorie_id/* 71,116:P1_TAB2_KATEGORIE_ID*/,'||unistr('\000a')||
'     :p1_fragebogen_id,:p1_id,:p1_pergebnis_id,'||unistr('\000a')||
'      v_sprache_id , :P1_FEHLER'||unistr('\000a')||
'     )';

p:=p||';'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung auch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 4831917332764085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 31,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'',''SUCHEN'',''P31_SUCHBEMERKUNG_NOSAVE'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p31_tab31_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p31_tab31_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_h';

p:=p||'inweis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4832500737764085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 31,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 4832127334764085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 31,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 4832306321764085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 31,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 3883008319633574 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 31,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 31
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6440416011039150 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'FKATEGORIE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6440513995039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'LINK',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6440609584039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'FRAGE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6440712134039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'FANTWORT_ZAHL_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6440831351039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'FANTWORT_EH_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6440917728039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'MESSDATUM',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6441031946039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 7,
  p_query_column_name=> 'FANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6441109710039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 8,
  p_query_column_name=> 'FANTWORT_ID_DISP',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6441214015039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 9,
  p_query_column_name=> 'PERSANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6441319122039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 10,
  p_query_column_name=> 'FRAGE_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6441432264039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 11,
  p_query_column_name=> 'FANTWORT_ZAHL',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6441519932039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 12,
  p_query_column_name=> 'FANTWORT_ZAHL_2',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6441614844039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 13,
  p_query_column_name=> 'ERSATZWERT_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6441710387039157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 4828404131764076 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 14,
  p_query_column_name=> 'FANTWORT_NORMBEREICH',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00032
prompt  ...PAGE 32: Aktualisieren FRAGEBOGENANZEIGE 32
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 32
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 32'
 ,p_step_title => 'Aktualisieren FRAGEBOGENANZEIGE 32'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren FRAGEBOGENANZEIGE 31'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_checklaborwerte (feld_id,wert,eh_id)'||unistr('\000a')||
'{ '||unistr('\000a')||
'  var feld_menge = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkLaborWerte'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  get.add(''P31_EINHEIT_ID_INPUT'',eh_id);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = gReturn ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = '''' ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'function f_checkdatum(feld_id,datum,fragetext)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_datum = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkMessdatum'',0);'||unistr('\000a')||
'  get.add(''P31_DATUM'',datum);'||unistr('\000a')||
'  get.add(''P31_FRAGE_TEXT'',fragetext);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'function f_checknormbereich(feld_id,normbereich,wert)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_normbereich = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkNormbereich'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_NORMBEREICH'',normbereich);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141022144849'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8665919016602940 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 32,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||''||unistr('\000a')||
'select'||unistr('\000a')||
'   f.fkategorie_text fkategorie_text,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'   WHEN hilfe_text_id is not null'||unistr('\000a')||
'   THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'   ||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'   || f.hilfe_text_id||'',''||f.frage_text_id)'||unistr('\000a')||
'   || '''''',700,425)">'''||unistr('\000a')||
'   || ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'   || ''</a>'''||unistr('\000a')||
'   ELSE '' '''||unistr('\000a')||
'   END LINK,'||unistr('\000a')||
'   apex_';

s:=s||'item.hidden(2,f.frage_id) ||'||unistr('\000a')||
'   apex_item.hidden(3,p.ID) ||'||unistr('\000a')||
'   f.FRAGE_TEXT FRAGE_TEXT,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder => Wert */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id =';

s:=s||' f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_2'||unistr('\000a')||
'                           and satz_kennzeichen is null)))||'||unistr('\000a')||
'         apex_item.text(8,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id = f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_';

s:=s||'2'||unistr('\000a')||
'                           and satz_kennzeichen is null)),'||unistr('\000a')||
'                        10,15,''tabindex="1" autocomplete="off"'||unistr('\000a')||
'   onchange="javascript:f_checklaborwerte('''''' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'''||unistr('\000a')||
'    || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0';

s:=s||') = 1 then '' disabled'' else '''' end , f.frage_ID'||unistr('\000a')||
'                       )'||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => ID der Fantwort */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,p.FANTWORT_ID)||'||unistr('\000a')||
'         apex_item.select_list_from_query(8,p.FANTWORT_ID,'||unistr('\000a')||
'            ''select frgbg_s.HOLEN_UEBERSETZUNG(fant.text_id,:fas_sprache_id), fant.id from fantworten fant where f';

s:=s||'ant.frage_id*1000000 = ''||'||unistr('\000a')||
'                                          f.frage_ID*1000000||'||unistr('\000a')||
''' and fant.satz_kennzeichen is null order by fant.sort asc '','||unistr('\000a')||
'            NULL,''NO'',NULL,NULL)'||unistr('\000a')||
'      END fantwort_zahl_eingabe,'||unistr('\000a')||
''||unistr('\000a')||
'   CASE /* Eingabefeld EH */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5  AND f.bezug_einheit_id != 181 THEN  /* Textfelder => EH-Eingabe LOV*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,';

s:=s||''||unistr('\000a')||
'               rezepte.get_inh_def_bezug_eh(f.inhstoff_id)))||'||unistr('\000a')||
'         apex_item.select_list_from_query(10,NVL(p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'                       rezepte.get_inh_def_bezug_eh(f.inhstoff_id)),'||unistr('\000a')||
'''select rezepte.get_bezug_eh_bez(u.bezug_einheit_id,:fas_sprache_id), u.bezug_einheit_id from inh_eh_disps u, bezug_einheiten be, einheiten e where u.inhstoff_id = ''||f.inhstoff_id||'' and u.satz_kenn';

s:=s||'zeichen is null and u.bezug_einheit_id = be.id and be.satz_kennzeichen is null and be.einheit_id = e.id and e.physeh_id in (SELECT e.physeh_id FROM inh_eh_umrs i, einheiten e WHERE i.inhstoff_id = ''||f.inhstoff_id||'' and i.satz_kennzeichen is null and i.einheit_id = e.id and e.satz_kennzeichen is null) order by u.sort asc'','||unistr('\000a')||
'''onchange="javascript:f_checklaborwerte('''''' || f.frage_ID || '''''',html_GetE';

s:=s||'lement('''''' || f.frage_ID || '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'' || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1'||unistr('\000a')||
'    /* OR FRGBG_T.LAB_MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 */ then '' disabled'' else '''' end,'||unistr('\000a')||
'''NO'',NULL,NULL,''EH''||f.frage_ID'||unistr('\000a')||
')'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND f.bezug_einheit_id = 1';

s:=s||'81 THEN  /* Textfelder ohne EH-Eingabe z.B. pH-Werte immer bezug_einheit 181*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,181))||'||unistr('\000a')||
'         apex_item.hidden(10,NVL(p.FANTWORT_ZAHL_2,181),NULL,''EH''||f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => Keine EH-Eingabe */'||unistr('\000a')||
'         apex_item.hidden(9,NULL)||'||unistr('\000a')||
'         apex_item.hidden(10,NULL)||'||unistr('\000a')||
'         '''''||unistr('\000a')||
'      END fantwort_eh_eingabe ,'||unistr('\000a')||
'   ';

s:=s||'apex_item.hidden(11,'||unistr('\000a')||
'                     to_char(NVL(p.messdatum,sysdate),''DD.MM.RRRR hh24:mi''))||'||unistr('\000a')||
'   apex_item.text(12,to_char(NVL(p.messdatum,sysdate),''DD.MM.YYYY hh24:mi'')'||unistr('\000a')||
',20,20,''tabindex="1" autocomplete="off" onchange="javascript:f_checkdatum(''''DAT''||f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''DAT'' || f.frage_ID || '''''').value, ''''''|| f.frage_text||'''''')"'' || case when decode(NVL(FRGBG_S.FB_CHECK_F';

s:=s||'ANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end, ''DAT''||f.frage_ID'||unistr('\000a')||
') messdatum,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         apex_item.hidden(16,NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                             WHERE frage_id = f.frage_id'||unistr('\000a')||
'                               and satz_kennzeichen is null)))||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
' ';

s:=s||'     ELSE         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         apex_item.hidden(16,p.FANTWORT_ID)||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
'      END fantwort_id,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                                           WHERE frage_id = f.frage_id'||unistr('\000a')||
'                                             and satz_kennzeichen is null))'||unistr('\000a')||
'      EL';

s:=s||'SE         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         p.FANTWORT_ID'||unistr('\000a')||
'      END fantwort_id_disp,'||unistr('\000a')||
'   p.id persantwort_id, f.frage_id frage_id,p.FANTWORT_ZAHL,p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'   CASE WHEN p.fantwort_text is NULL THEN'||unistr('\000a')||
'     CASE WHEN p.LABOR_FAS_ERSATZWERT_ID is not null THEN'||unistr('\000a')||
'        (SELECT frgbg_s.HOLEN_UEBERSETZUNG(KUERZEL_TEXT_ID,:fas_sprache_id) FROM LABOR_FAS_ERSATZWERTE WHERE ID = p.LABOR_FAS_ERSATZWER';

s:=s||'T_ID)'||unistr('\000a')||
'     ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id)'||unistr('\000a')||
'     END'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id,p.fantwort_text )'||unistr('\000a')||
'   END ersatzwert_text,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND (select max(NORMIERUNGSTYP) from FANTWORTEN where FRAGE_Id = f.FRAGE_ID) = ''LABORBEREICH'' THEN'||unistr('\000a')||
'         CASE WHEN FRGBG_T.LAB';

s:=s||'_MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 THEN'||unistr('\000a')||
'           -- Wenn Labor mehrere Normbereiche geliefert hat, dürfen diese hier nicht bearbeitet werden,'||unistr('\000a')||
'           -- da über die Maske nur personenspezifische Normbereiche eingegeben werden dürfen'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
' ';

s:=s||'          apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT))'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'           apex_item.hidden(17,CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                    CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,';

s:=s||'p.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standardnormbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                   ELSE';

s:=s||' NULL END'||unistr('\000a')||
'                END'||unistr('\000a')||
'                   ) ||'||unistr('\000a')||
'           apex_item.text(18, CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                  CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standar';

s:=s||'dnormbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                  ELSE NULL END'||unistr('\000a')||
'                END, 10,15,''tabindex="1" autocomplete="off"';

s:=s||' onblur="javascript:f_checknormbereich(''''NORMB'' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''NORMB'' ||f.frage_ID || '''''').value, html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value)"'''||unistr('\000a')||
'              || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end'||unistr('\000a')||
'            , ''NORMB'' || f.frage_ID'||unistr('\000a')||
'         )'||unistr('\000a')||
'        END'||unistr('\000a')||
'     ELSE -- Bei';

s:=s||' anderen Anzeigetypen auch keine Eingabe möglich'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
'           apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT),''NORMB'' || f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'     END fantwort_normbereich'||unistr('\000a')||
'from v_fragen f, persantworten p --, uebersetzungen u ';

s:=s||'-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'where f.fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  and (f.fkategorie_fkategorie_id = :p31_tab32_kategorie_id or'||unistr('\000a')||
'       f.FKATEGORIE_fkategorie_ID is null and f.fkategorie_id='||unistr('\000a')||
'                                              :p31_tab32_kategorie_id'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and f.personenstamm_id = :p1_id'||unistr('\000a')||
'  AND f.sprache_id = :fas_sprache_id'||unistr('\000a')||
'  AND f.fragelevel = ';

s:=s||'0 /* keine Metafragen */'||unistr('\000a')||
'  AND f.visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'  AND f.anzeigetyp_id in (3,4,5) /* Radio, Text */'||unistr('\000a')||
'  and f.frage_id = p.frage_id(+)'||unistr('\000a')||
'  and p.pergebnis_id(+) = :p1_pergebnis_id'||unistr('\000a')||
'  and p.satz_kennzeichen (+) is null'||unistr('\000a')||
'  --and f.such_text_id = u.text_id (+)'||unistr('\000a')||
'  --and u.sprache_id (+) = :fas_sprache_id'||unistr('\000a')||
'  and (:p32_suchbemerkung_NOSAVE is null OR'||unistr('\000a')||
'       --UPPER(u.text) lik';

s:=s||'e ''%''||UPPER(:p32_suchbemerkung_NOSAVE)||''%'' OR   -- NEI 20.11.13'||unistr('\000a')||
'       UPPER(frgbg_s.HOLEN_UEBERSETZUNG(f.such_text_id,:fas_sprache_id)) like ''%''||UPPER(:p32_suchbemerkung_NOSAVE)||''%'' OR'||unistr('\000a')||
'       UPPER(f.FRAGE_TEXT) like ''%''||UPPER(:p32_suchbemerkung_NOSAVE)||''%'''||unistr('\000a')||
'      )'||unistr('\000a')||
'--  and f.frage_id > 0   -- Nur zu Testzwecken'||unistr('\000a')||
'--order by f.fkategorie_sort,f.frage_sort'||unistr('\000a')||
'--order by f.fkategorie_sort,CASE WHEN';

s:=s||' p.id is null THEN 0 ELSE 1 END desc ,f.frage_text'||unistr('\000a')||
'order by f.fkategorie_sort,f.frage_text';

wwv_flow_api.create_report_region (
  p_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 32,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;margin:10px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P31_TAB32_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> 'ROW_RANGES_WITH_LINKS',
  p_query_row_count_max=> '300',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8666510023602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8666615416602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8666701304602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8666822683602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_EINGABE',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8666919908602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_EH_EINGABE',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8667024054602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MESSDATUM',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8667126755602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8667215914602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID_DISP',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8667330904602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'PERSANTWORT_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8667424511602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8667529837602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8667617998602947 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_2',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8666419604602946 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'ERSATZWERT_TEXT',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8666331107602946 + wwv_flow_api.g_id_offset,
  p_region_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_NORMBEREICH',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 8673314527602956 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 32,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8673509113602957 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 32,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 35,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 8667724932602947 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 32,
  p_button_sequence=> 10,
  p_button_plug_id => 8666125852602945+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8667912149602948 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 32,
  p_button_sequence=> 15,
  p_button_plug_id => 8666125852602945+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8668102907602948 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 32,
  p_button_sequence=> 20,
  p_button_plug_id => 8666125852602945+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8668308053602948 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 32,
  p_button_sequence=> 30,
  p_button_plug_id => 8666125852602945+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8668519050602948 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 32,
  p_button_sequence=> 40,
  p_button_plug_id => 8666125852602945+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8675008534602959 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 32,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8668519050602948+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>8675204754602959 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 32,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8668701785602948 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 32,
  p_name=>'P32_ICON_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 8666125852602945+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'SUCHEN',
  p_source=>'SUCHEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_button_image_attr=> 'onclick="xwoher=2"',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8672527679602955 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 32,
  p_name=>'P32_SUCHBEMERKUNG_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 8666125852602945+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onclick="xwoher=2"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8673824688602957 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 32,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_eingabe',
  p_validation_sequence=> 50,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_change  NUMBER := 0;'||unistr('\000a')||
'   v_fehlertext  VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Check wurde ausgelagert, da Code zu lang'||unistr('\000a')||
'   v_change := frgbg_s.fb_check_labor_eing(v_fehlertext);'||unistr('\000a')||
'   -- Fehler wird erst vor Speichern ausgewertet und mit Raise angezeigt'||unistr('\000a')||
'   :p1_fehler := v_fehlertext;'||unistr('\000a')||
'   IF v_change = 0 THEN  -- Keine Daten geändert'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(2020,v_sprache_id ));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 8668308053602948 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPLIC';

p:=p||'ATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
'  v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
'  IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
'  END IF; '||unistr('\000a')||
'  FRGBG_S.SPEICHERN_LABOR'||unistr('\000a')||
'     ( '||unistr('\000a')||
'      v_user,:p31_tab32_kategorie_id/* 71,116:P1_TAB2_KATEGORIE_ID*/,'||unistr('\000a')||
'     :p1_fragebogen_id,:p1_id,:p1_pergebnis_id,'||unistr('\000a')||
'      v_sprache_id , :P1_FEHLER'||unistr('\000a')||
'     )';

p:=p||';'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung auch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8673902477602958 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 32,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'',''SUCHEN'',''P32_SUCHBEMERKUNG_NOSAVE'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p31_tab32_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p31_tab32_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_h';

p:=p||'inweis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 8674115987602958 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 32,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 8674317898602958 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 32,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 8674519439602958 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 32,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 8674720273602958 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 32,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 32
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6443417028114619 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'FKATEGORIE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6443515159114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'LINK',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6443612411114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'FRAGE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6443726693114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'FANTWORT_ZAHL_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6443812241114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'FANTWORT_EH_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6443931483114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'MESSDATUM',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6444012249114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 7,
  p_query_column_name=> 'FANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6444107832114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 8,
  p_query_column_name=> 'FANTWORT_ID_DISP',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6444227694114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 9,
  p_query_column_name=> 'PERSANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6444328850114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 10,
  p_query_column_name=> 'FRAGE_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6444431436114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 11,
  p_query_column_name=> 'FANTWORT_ZAHL',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6444514735114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 12,
  p_query_column_name=> 'FANTWORT_ZAHL_2',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6444610907114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 13,
  p_query_column_name=> 'ERSATZWERT_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6444707487114621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8666125852602945 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 14,
  p_query_column_name=> 'FANTWORT_NORMBEREICH',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00033
prompt  ...PAGE 33: Aktualisieren FRAGEBOGENANZEIGE 33
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 33
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 33'
 ,p_step_title => 'Aktualisieren FRAGEBOGENANZEIGE 33'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren FRAGEBOGENANZEIGE 31'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_checklaborwerte (feld_id,wert,eh_id)'||unistr('\000a')||
'{ '||unistr('\000a')||
'  var feld_menge = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkLaborWerte'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  get.add(''P31_EINHEIT_ID_INPUT'',eh_id);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = gReturn ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = '''' ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'function f_checkdatum(feld_id,datum,fragetext)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_datum = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkMessdatum'',0);'||unistr('\000a')||
'  get.add(''P31_DATUM'',datum);'||unistr('\000a')||
'  get.add(''P31_FRAGE_TEXT'',fragetext);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'function f_checknormbereich(feld_id,normbereich,wert)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_normbereich = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkNormbereich'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_NORMBEREICH'',normbereich);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141022144933'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'   f.fkategorie_text fkategorie_text,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'   WHEN hilfe_text_id is not null'||unistr('\000a')||
'   THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'   ||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'   || f.hilfe_text_id||'',''||f.frage_text_id)'||unistr('\000a')||
'   || '''''',700,425)">'''||unistr('\000a')||
'   || ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'   || ''</a>'''||unistr('\000a')||
'   ELSE '' '''||unistr('\000a')||
'   END LINK,'||unistr('\000a')||
'   apex_i';

s:=s||'tem.hidden(2,f.frage_id) ||'||unistr('\000a')||
'   apex_item.hidden(3,p.ID) ||'||unistr('\000a')||
'   f.FRAGE_TEXT FRAGE_TEXT,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder => Wert */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id = ';

s:=s||'f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_2'||unistr('\000a')||
'                           and satz_kennzeichen is null)))||'||unistr('\000a')||
'         apex_item.text(8,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id = f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_2';

s:=s||''||unistr('\000a')||
'                           and satz_kennzeichen is null)),'||unistr('\000a')||
'                        10,15,''tabindex="1" autocomplete="off"'||unistr('\000a')||
'   onchange="javascript:f_checklaborwerte('''''' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'''||unistr('\000a')||
'    || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0)';

s:=s||' = 1 then '' disabled'' else '''' end , f.frage_ID'||unistr('\000a')||
'                       )'||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => ID der Fantwort */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,p.FANTWORT_ID)||'||unistr('\000a')||
'         apex_item.select_list_from_query(8,p.FANTWORT_ID,'||unistr('\000a')||
'            ''select frgbg_s.HOLEN_UEBERSETZUNG(fant.text_id,:fas_sprache_id), fant.id from fantworten fant where fa';

s:=s||'nt.frage_id*1000000 = ''||'||unistr('\000a')||
'                                          f.frage_ID*1000000||'||unistr('\000a')||
''' and fant.satz_kennzeichen is null order by fant.sort asc '','||unistr('\000a')||
'            NULL,''NO'',NULL,NULL)'||unistr('\000a')||
'      END fantwort_zahl_eingabe,'||unistr('\000a')||
''||unistr('\000a')||
'   CASE /* Eingabefeld EH */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5  AND f.bezug_einheit_id != 181 THEN  /* Textfelder => EH-Eingabe LOV*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'';

s:=s||'               rezepte.get_inh_def_bezug_eh(f.inhstoff_id)))||'||unistr('\000a')||
'         apex_item.select_list_from_query(10,NVL(p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'                       rezepte.get_inh_def_bezug_eh(f.inhstoff_id)),'||unistr('\000a')||
'''select rezepte.get_bezug_eh_bez(u.bezug_einheit_id,:fas_sprache_id), u.bezug_einheit_id from inh_eh_disps u, bezug_einheiten be, einheiten e where u.inhstoff_id = ''||f.inhstoff_id||'' and u.satz_kennz';

s:=s||'eichen is null and u.bezug_einheit_id = be.id and be.satz_kennzeichen is null and be.einheit_id = e.id and e.physeh_id in (SELECT e.physeh_id FROM inh_eh_umrs i, einheiten e WHERE i.inhstoff_id = ''||f.inhstoff_id||'' and i.satz_kennzeichen is null and i.einheit_id = e.id and e.satz_kennzeichen is null) order by u.sort asc'','||unistr('\000a')||
'''onchange="javascript:f_checklaborwerte('''''' || f.frage_ID || '''''',html_GetEl';

s:=s||'ement('''''' || f.frage_ID || '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'' || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1'||unistr('\000a')||
'    /* OR FRGBG_T.LAB_MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 */ then '' disabled'' else '''' end,'||unistr('\000a')||
'''NO'',NULL,NULL,''EH''||f.frage_ID'||unistr('\000a')||
')'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND f.bezug_einheit_id = 18';

s:=s||'1 THEN  /* Textfelder ohne EH-Eingabe z.B. pH-Werte immer bezug_einheit 181*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,181))||'||unistr('\000a')||
'         apex_item.hidden(10,NVL(p.FANTWORT_ZAHL_2,181),NULL,''EH''||f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => Keine EH-Eingabe */'||unistr('\000a')||
'         apex_item.hidden(9,NULL)||'||unistr('\000a')||
'         apex_item.hidden(10,NULL)||'||unistr('\000a')||
'         '''''||unistr('\000a')||
'      END fantwort_eh_eingabe ,'||unistr('\000a')||
'   a';

s:=s||'pex_item.hidden(11,'||unistr('\000a')||
'                     to_char(NVL(p.messdatum,sysdate),''DD.MM.RRRR hh24:mi''))||'||unistr('\000a')||
'   apex_item.text(12,to_char(NVL(p.messdatum,sysdate),''DD.MM.YYYY hh24:mi'')'||unistr('\000a')||
',20,20,''tabindex="1" autocomplete="off" onchange="javascript:f_checkdatum(''''DAT''||f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''DAT'' || f.frage_ID || '''''').value, ''''''|| f.frage_text||'''''')"'' || case when decode(NVL(FRGBG_S.FB_CHECK_FA';

s:=s||'NT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end, ''DAT''||f.frage_ID'||unistr('\000a')||
') messdatum,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         apex_item.hidden(16,NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                             WHERE frage_id = f.frage_id'||unistr('\000a')||
'                               and satz_kennzeichen is null)))||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
'  ';

s:=s||'    ELSE         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         apex_item.hidden(16,p.FANTWORT_ID)||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
'      END fantwort_id,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                                           WHERE frage_id = f.frage_id'||unistr('\000a')||
'                                             and satz_kennzeichen is null))'||unistr('\000a')||
'      ELS';

s:=s||'E         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         p.FANTWORT_ID'||unistr('\000a')||
'      END fantwort_id_disp,'||unistr('\000a')||
'   p.id persantwort_id, f.frage_id frage_id,p.FANTWORT_ZAHL,p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'   CASE WHEN p.fantwort_text is NULL THEN'||unistr('\000a')||
'     CASE WHEN p.LABOR_FAS_ERSATZWERT_ID is not null THEN'||unistr('\000a')||
'        (SELECT frgbg_s.HOLEN_UEBERSETZUNG(KUERZEL_TEXT_ID,:fas_sprache_id) FROM LABOR_FAS_ERSATZWERTE WHERE ID = p.LABOR_FAS_ERSATZWERT';

s:=s||'_ID)'||unistr('\000a')||
'     ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id)'||unistr('\000a')||
'     END'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id,p.fantwort_text )'||unistr('\000a')||
'   END ersatzwert_text,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND (select max(NORMIERUNGSTYP) from FANTWORTEN where FRAGE_Id = f.FRAGE_ID) = ''LABORBEREICH'' THEN'||unistr('\000a')||
'         CASE WHEN FRGBG_T.LAB_';

s:=s||'MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 THEN'||unistr('\000a')||
'           -- Wenn Labor mehrere Normbereiche geliefert hat, dürfen diese hier nicht bearbeitet werden,'||unistr('\000a')||
'           -- da über die Maske nur personenspezifische Normbereiche eingegeben werden dürfen'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
'  ';

s:=s||'         apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT))'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'           apex_item.hidden(17,CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                    CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p';

s:=s||'.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standardnormbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                   ELSE ';

s:=s||'NULL END'||unistr('\000a')||
'                END'||unistr('\000a')||
'                   ) ||'||unistr('\000a')||
'           apex_item.text(18, CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                  CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standard';

s:=s||'normbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                  ELSE NULL END'||unistr('\000a')||
'                END, 10,15,''tabindex="1" autocomplete="off" ';

s:=s||'onblur="javascript:f_checknormbereich(''''NORMB'' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''NORMB'' ||f.frage_ID || '''''').value, html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value)"'''||unistr('\000a')||
'              || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end'||unistr('\000a')||
'            , ''NORMB'' || f.frage_ID'||unistr('\000a')||
'         )'||unistr('\000a')||
'        END'||unistr('\000a')||
'     ELSE -- Bei ';

s:=s||'anderen Anzeigetypen auch keine Eingabe möglich'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
'           apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT),''NORMB'' || f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'     END fantwort_normbereich'||unistr('\000a')||
'from v_fragen f, persantworten p --, uebersetzungen u -';

s:=s||'- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'where f.fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  and (f.fkategorie_fkategorie_id = :p31_tab33_kategorie_id or'||unistr('\000a')||
'       f.FKATEGORIE_fkategorie_ID is null and f.fkategorie_id='||unistr('\000a')||
'                                              :p31_tab33_kategorie_id'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and f.personenstamm_id = :p1_id'||unistr('\000a')||
'  AND f.sprache_id = :fas_sprache_id'||unistr('\000a')||
'  AND f.fragelevel = 0';

s:=s||' /* keine Metafragen */'||unistr('\000a')||
'  AND f.visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'  AND f.anzeigetyp_id in (3,4,5) /* Radio, Text */'||unistr('\000a')||
'  and f.frage_id = p.frage_id(+)'||unistr('\000a')||
'  and p.pergebnis_id(+) = :p1_pergebnis_id'||unistr('\000a')||
'  and p.satz_kennzeichen (+) is null'||unistr('\000a')||
'  --and f.such_text_id = u.text_id (+)'||unistr('\000a')||
'  --and u.sprache_id (+) = :fas_sprache_id'||unistr('\000a')||
'  and (:p33_suchbemerkung_NOSAVE is null OR'||unistr('\000a')||
'       --UPPER(u.text) like';

s:=s||' ''%''||UPPER(:p33_suchbemerkung_NOSAVE)||''%'' OR   -- NEI 20.11.13'||unistr('\000a')||
'       UPPER(frgbg_s.HOLEN_UEBERSETZUNG(f.such_text_id,:fas_sprache_id)) like ''%''||UPPER(:p33_suchbemerkung_NOSAVE)||''%'' OR'||unistr('\000a')||
'       UPPER(f.FRAGE_TEXT) like ''%''||UPPER(:p33_suchbemerkung_NOSAVE)||''%'''||unistr('\000a')||
'      )'||unistr('\000a')||
'--  and f.frage_id > 0   -- Nur zu Testzwecken'||unistr('\000a')||
'--order by f.fkategorie_sort,f.frage_sort'||unistr('\000a')||
'--order by f.fkategorie_sort,CASE WHEN ';

s:=s||'p.id is null THEN 0 ELSE 1 END desc ,f.frage_text'||unistr('\000a')||
'order by f.fkategorie_sort,f.frage_text';

wwv_flow_api.create_report_region (
  p_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 33,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;margin:10px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P31_TAB33_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> 'ROW_RANGES_WITH_LINKS',
  p_query_row_count_max=> '300',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8692813970826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8692913225826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8693024095826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8693128136826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_EINGABE',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8693227139826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_EH_EINGABE',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8693325613826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MESSDATUM',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8693404675826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8692113298826303 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID_DISP',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8692209387826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'PERSANTWORT_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8692304682826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8692421384826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8692508000826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_2',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8692706826826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'ERSATZWERT_TEXT',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8692607425826304 + wwv_flow_api.g_id_offset,
  p_region_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_NORMBEREICH',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 8694918132826307 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 33,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8700925493842892 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 33,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 35,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8701129649844115 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 33,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 8693509420826305 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 33,
  p_button_sequence=> 10,
  p_button_plug_id => 8691913781826302+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8693715554826305 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 33,
  p_button_sequence=> 15,
  p_button_plug_id => 8691913781826302+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8693917505826305 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 33,
  p_button_sequence=> 20,
  p_button_plug_id => 8691913781826302+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8694112164826305 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 33,
  p_button_sequence=> 30,
  p_button_plug_id => 8691913781826302+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8694330310826305 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 33,
  p_button_sequence=> 40,
  p_button_plug_id => 8691913781826302+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8697409934826313 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 33,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8694330310826305+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>8697619186826313 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 33,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8694507014826306 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 33,
  p_name=>'P33_ICON_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 8691913781826302+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'SUCHEN',
  p_source=>'SUCHEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_button_image_attr=> 'onclick="xwoher=2"',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8694711314826306 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 33,
  p_name=>'P33_SUCHBEMERKUNG_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 8691913781826302+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onclick="xwoher=2"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8696215070826311 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 33,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_eingabe',
  p_validation_sequence=> 50,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_change  NUMBER := 0;'||unistr('\000a')||
'   v_fehlertext  VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Check wurde ausgelagert, da Code zu lang'||unistr('\000a')||
'   v_change := frgbg_s.fb_check_labor_eing(v_fehlertext);'||unistr('\000a')||
'   -- Fehler wird erst vor Speichern ausgewertet und mit Raise angezeigt'||unistr('\000a')||
'   :p1_fehler := v_fehlertext;'||unistr('\000a')||
'   IF v_change = 0 THEN  -- Keine Daten geändert'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(2020,v_sprache_id ));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 8694112164826305 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPLIC';

p:=p||'ATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
'  v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
'  IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
'  END IF; '||unistr('\000a')||
'  FRGBG_S.SPEICHERN_LABOR'||unistr('\000a')||
'     ( '||unistr('\000a')||
'      v_user,:p31_tab33_kategorie_id/* 71,116:P1_TAB2_KATEGORIE_ID*/,'||unistr('\000a')||
'     :p1_fragebogen_id,:p1_id,:p1_pergebnis_id,'||unistr('\000a')||
'      v_sprache_id , :P1_FEHLER'||unistr('\000a')||
'     )';

p:=p||';'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung auch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8696917459826312 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 33,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'',''SUCHEN'',''P33_SUCHBEMERKUNG_NOSAVE'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p31_tab33_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p31_tab32_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_h';

p:=p||'inweis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 8697107240826312 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 33,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 8696300818826311 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 33,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 8696511678826312 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 33,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 8696717996826312 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 33,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 33
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6444907539118975 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'FKATEGORIE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445001122118975 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'LINK',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445103158118975 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'FRAGE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445200069118975 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'FANTWORT_ZAHL_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445309131118975 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'FANTWORT_EH_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445400992118975 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'MESSDATUM',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445511839118975 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 7,
  p_query_column_name=> 'FANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445614407118977 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 8,
  p_query_column_name=> 'FANTWORT_ID_DISP',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445727059118977 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 9,
  p_query_column_name=> 'PERSANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445805763118978 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 10,
  p_query_column_name=> 'FRAGE_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6445913679118978 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 11,
  p_query_column_name=> 'FANTWORT_ZAHL',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6446022809118978 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 12,
  p_query_column_name=> 'FANTWORT_ZAHL_2',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6446108508118978 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 13,
  p_query_column_name=> 'ERSATZWERT_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6446211050118978 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8691913781826302 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 14,
  p_query_column_name=> 'FANTWORT_NORMBEREICH',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00034
prompt  ...PAGE 34: Aktualisieren FRAGEBOGENANZEIGE 34
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 34
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 34'
 ,p_step_title => 'Aktualisieren FRAGEBOGENANZEIGE 34'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren FRAGEBOGENANZEIGE 34'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_checklaborwerte (feld_id,wert,eh_id)'||unistr('\000a')||
'{ '||unistr('\000a')||
'  var feld_menge = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkLaborWerte'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  get.add(''P31_EINHEIT_ID_INPUT'',eh_id);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = gReturn ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = '''' ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'function f_checkdatum(feld_id,datum,fragetext)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_datum = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkMessdatum'',0);'||unistr('\000a')||
'  get.add(''P31_DATUM'',datum);'||unistr('\000a')||
'  get.add(''P31_FRAGE_TEXT'',fragetext);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'function f_checknormbereich(feld_id,normbereich,wert)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_normbereich = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkNormbereich'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_NORMBEREICH'',normbereich);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141022145001'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'   f.fkategorie_text fkategorie_text,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'   WHEN hilfe_text_id is not null'||unistr('\000a')||
'   THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'   ||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'   || f.hilfe_text_id||'',''||f.frage_text_id)'||unistr('\000a')||
'   || '''''',700,425)">'''||unistr('\000a')||
'   || ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'   || ''</a>'''||unistr('\000a')||
'   ELSE '' '''||unistr('\000a')||
'   END LINK,'||unistr('\000a')||
'   apex_i';

s:=s||'tem.hidden(2,f.frage_id) ||'||unistr('\000a')||
'   apex_item.hidden(3,p.ID) ||'||unistr('\000a')||
'   f.FRAGE_TEXT FRAGE_TEXT,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder => Wert */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id = ';

s:=s||'f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_2'||unistr('\000a')||
'                           and satz_kennzeichen is null)))||'||unistr('\000a')||
'         apex_item.text(8,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id = f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_2';

s:=s||''||unistr('\000a')||
'                           and satz_kennzeichen is null)),'||unistr('\000a')||
'                        10,15,''tabindex="1" autocomplete="off"'||unistr('\000a')||
'   onchange="javascript:f_checklaborwerte('''''' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'''||unistr('\000a')||
'    || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0)';

s:=s||' = 1 then '' disabled'' else '''' end , f.frage_ID'||unistr('\000a')||
'                       )'||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => ID der Fantwort */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,p.FANTWORT_ID)||'||unistr('\000a')||
'         apex_item.select_list_from_query(8,p.FANTWORT_ID,'||unistr('\000a')||
'            ''select frgbg_s.HOLEN_UEBERSETZUNG(fant.text_id,:fas_sprache_id), fant.id from fantworten fant where fa';

s:=s||'nt.frage_id*1000000 = ''||'||unistr('\000a')||
'                                          f.frage_ID*1000000||'||unistr('\000a')||
''' and fant.satz_kennzeichen is null order by fant.sort asc '','||unistr('\000a')||
'            NULL,''NO'',NULL,NULL)'||unistr('\000a')||
'      END fantwort_zahl_eingabe,'||unistr('\000a')||
''||unistr('\000a')||
'   CASE /* Eingabefeld EH */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5  AND f.bezug_einheit_id != 181 THEN  /* Textfelder => EH-Eingabe LOV*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'';

s:=s||'               rezepte.get_inh_def_bezug_eh(f.inhstoff_id)))||'||unistr('\000a')||
'         apex_item.select_list_from_query(10,NVL(p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'                       rezepte.get_inh_def_bezug_eh(f.inhstoff_id)),'||unistr('\000a')||
'''select rezepte.get_bezug_eh_bez(u.bezug_einheit_id,:fas_sprache_id), u.bezug_einheit_id from inh_eh_disps u, bezug_einheiten be, einheiten e where u.inhstoff_id = ''||f.inhstoff_id||'' and u.satz_kennz';

s:=s||'eichen is null and u.bezug_einheit_id = be.id and be.satz_kennzeichen is null and be.einheit_id = e.id and e.physeh_id in (SELECT e.physeh_id FROM inh_eh_umrs i, einheiten e WHERE i.inhstoff_id = ''||f.inhstoff_id||'' and i.satz_kennzeichen is null and i.einheit_id = e.id and e.satz_kennzeichen is null) order by u.sort asc'','||unistr('\000a')||
'''onchange="javascript:f_checklaborwerte('''''' || f.frage_ID || '''''',html_GetEl';

s:=s||'ement('''''' || f.frage_ID || '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'' || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1'||unistr('\000a')||
'    /* OR FRGBG_T.LAB_MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 */ then '' disabled'' else '''' end,'||unistr('\000a')||
'''NO'',NULL,NULL,''EH''||f.frage_ID'||unistr('\000a')||
')'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND f.bezug_einheit_id = 18';

s:=s||'1 THEN  /* Textfelder ohne EH-Eingabe z.B. pH-Werte immer bezug_einheit 181*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,181))||'||unistr('\000a')||
'         apex_item.hidden(10,NVL(p.FANTWORT_ZAHL_2,181),NULL,''EH''||f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => Keine EH-Eingabe */'||unistr('\000a')||
'         apex_item.hidden(9,NULL)||'||unistr('\000a')||
'         apex_item.hidden(10,NULL)||'||unistr('\000a')||
'         '''''||unistr('\000a')||
'      END fantwort_eh_eingabe ,'||unistr('\000a')||
'   a';

s:=s||'pex_item.hidden(11,'||unistr('\000a')||
'                     to_char(NVL(p.messdatum,sysdate),''DD.MM.RRRR hh24:mi''))||'||unistr('\000a')||
'   apex_item.text(12,to_char(NVL(p.messdatum,sysdate),''DD.MM.YYYY hh24:mi'')'||unistr('\000a')||
',20,20,''tabindex="1" autocomplete="off" onchange="javascript:f_checkdatum(''''DAT''||f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''DAT'' || f.frage_ID || '''''').value, ''''''|| f.frage_text||'''''')"'' || case when decode(NVL(FRGBG_S.FB_CHECK_FA';

s:=s||'NT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end, ''DAT''||f.frage_ID'||unistr('\000a')||
') messdatum,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         apex_item.hidden(16,NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                             WHERE frage_id = f.frage_id'||unistr('\000a')||
'                               and satz_kennzeichen is null)))||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
'  ';

s:=s||'    ELSE         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         apex_item.hidden(16,p.FANTWORT_ID)||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
'      END fantwort_id,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                                           WHERE frage_id = f.frage_id'||unistr('\000a')||
'                                             and satz_kennzeichen is null))'||unistr('\000a')||
'      ELS';

s:=s||'E         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         p.FANTWORT_ID'||unistr('\000a')||
'      END fantwort_id_disp,'||unistr('\000a')||
'   p.id persantwort_id, f.frage_id frage_id,p.FANTWORT_ZAHL,p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'   CASE WHEN p.fantwort_text is NULL THEN'||unistr('\000a')||
'     CASE WHEN p.LABOR_FAS_ERSATZWERT_ID is not null THEN'||unistr('\000a')||
'        (SELECT frgbg_s.HOLEN_UEBERSETZUNG(KUERZEL_TEXT_ID,:fas_sprache_id) FROM LABOR_FAS_ERSATZWERTE WHERE ID = p.LABOR_FAS_ERSATZWERT';

s:=s||'_ID)'||unistr('\000a')||
'     ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id)'||unistr('\000a')||
'     END'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id,p.fantwort_text )'||unistr('\000a')||
'   END ersatzwert_text,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND (select max(NORMIERUNGSTYP) from FANTWORTEN where FRAGE_Id = f.FRAGE_ID) = ''LABORBEREICH'' THEN'||unistr('\000a')||
'         CASE WHEN FRGBG_T.LAB_';

s:=s||'MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 THEN'||unistr('\000a')||
'           -- Wenn Labor mehrere Normbereiche geliefert hat, dürfen diese hier nicht bearbeitet werden,'||unistr('\000a')||
'           -- da über die Maske nur personenspezifische Normbereiche eingegeben werden dürfen'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
'  ';

s:=s||'         apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT))'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'           apex_item.hidden(17,CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                    CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p';

s:=s||'.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standardnormbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                   ELSE ';

s:=s||'NULL END'||unistr('\000a')||
'                END'||unistr('\000a')||
'                   ) ||'||unistr('\000a')||
'           apex_item.text(18, CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                  CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standard';

s:=s||'normbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                  ELSE NULL END'||unistr('\000a')||
'                END, 10,15,''tabindex="1" autocomplete="off" ';

s:=s||'onblur="javascript:f_checknormbereich(''''NORMB'' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''NORMB'' ||f.frage_ID || '''''').value, html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value)"'''||unistr('\000a')||
'              || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end'||unistr('\000a')||
'            , ''NORMB'' || f.frage_ID'||unistr('\000a')||
'         )'||unistr('\000a')||
'        END'||unistr('\000a')||
'     ELSE -- Bei ';

s:=s||'anderen Anzeigetypen auch keine Eingabe möglich'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
'           apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT),''NORMB'' || f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'     END fantwort_normbereich'||unistr('\000a')||
'from v_fragen f, persantworten p --, uebersetzungen u -';

s:=s||'- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'where f.fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  and (f.fkategorie_fkategorie_id = :p31_tab34_kategorie_id or'||unistr('\000a')||
'       f.FKATEGORIE_fkategorie_ID is null and f.fkategorie_id='||unistr('\000a')||
'                                              :p31_tab34_kategorie_id'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and f.personenstamm_id = :p1_id'||unistr('\000a')||
'  AND f.sprache_id = :fas_sprache_id'||unistr('\000a')||
'  AND f.fragelevel = 0';

s:=s||' /* keine Metafragen */'||unistr('\000a')||
'  AND f.visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'  AND f.anzeigetyp_id in (3,4,5) /* Radio, Text */'||unistr('\000a')||
'  and f.frage_id = p.frage_id(+)'||unistr('\000a')||
'  and p.pergebnis_id(+) = :p1_pergebnis_id'||unistr('\000a')||
'  and p.satz_kennzeichen (+) is null'||unistr('\000a')||
'  --and f.such_text_id = u.text_id (+)'||unistr('\000a')||
'  --and u.sprache_id (+) = :fas_sprache_id'||unistr('\000a')||
'  and (:p34_suchbemerkung_NOSAVE is null OR'||unistr('\000a')||
'       --UPPER(u.text) like';

s:=s||' ''%''||UPPER(:p34_suchbemerkung_NOSAVE)||''%'' OR   -- NEI 20.11.13'||unistr('\000a')||
'       UPPER(frgbg_s.HOLEN_UEBERSETZUNG(f.such_text_id,:fas_sprache_id)) like ''%''||UPPER(:p34_suchbemerkung_NOSAVE)||''%'' OR'||unistr('\000a')||
'       UPPER(f.FRAGE_TEXT) like ''%''||UPPER(:p34_suchbemerkung_NOSAVE)||''%'''||unistr('\000a')||
'      )'||unistr('\000a')||
'--  and f.frage_id > 0   -- Nur zu Testzwecken'||unistr('\000a')||
'--order by f.fkategorie_sort,f.frage_sort'||unistr('\000a')||
'--order by f.fkategorie_sort,CASE WHEN ';

s:=s||'p.id is null THEN 0 ELSE 1 END desc ,f.frage_text'||unistr('\000a')||
'order by f.fkategorie_sort,f.frage_text';

wwv_flow_api.create_report_region (
  p_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 34,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;margin:10px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P31_TAB34_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> 'ROW_RANGES_WITH_LINKS',
  p_query_row_count_max=> '300',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703623531858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703726674858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703803310858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703900205858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_EINGABE',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8704027816858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_EH_EINGABE',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8704131404858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MESSDATUM',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8704227330858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8702916540858393 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID_DISP',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703025907858393 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'PERSANTWORT_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703122208858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703209698858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703323627858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_2',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703510385858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'ERSATZWERT_TEXT',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8703406236858394 + wwv_flow_api.g_id_offset,
  p_region_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_NORMBEREICH',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 8705710769858397 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 34,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8705913395858397 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 34,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 35,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8706131478858398 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 34,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 8704300956858394 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 34,
  p_button_sequence=> 10,
  p_button_plug_id => 8702723825858392+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8704525031858395 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 34,
  p_button_sequence=> 15,
  p_button_plug_id => 8702723825858392+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8704727750858395 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 34,
  p_button_sequence=> 20,
  p_button_plug_id => 8702723825858392+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8704922016858395 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 34,
  p_button_sequence=> 30,
  p_button_plug_id => 8702723825858392+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8705108749858395 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 34,
  p_button_sequence=> 40,
  p_button_plug_id => 8702723825858392+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8707612128858400 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 34,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8705108749858395+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>8707822159858401 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 34,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8705321112858396 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 34,
  p_name=>'P34_ICON_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 8702723825858392+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'SUCHEN',
  p_source=>'SUCHEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_button_image_attr=> 'onclick="xwoher=2"',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8705529977858396 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 34,
  p_name=>'P34_SUCHBEMERKUNG_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 8702723825858392+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onclick="xwoher=2"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8706413191858398 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 34,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_eingabe',
  p_validation_sequence=> 50,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_change  NUMBER := 0;'||unistr('\000a')||
'   v_fehlertext  VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Check wurde ausgelagert, da Code zu lang'||unistr('\000a')||
'   v_change := frgbg_s.fb_check_labor_eing(v_fehlertext);'||unistr('\000a')||
'   -- Fehler wird erst vor Speichern ausgewertet und mit Raise angezeigt'||unistr('\000a')||
'   :p1_fehler := v_fehlertext;'||unistr('\000a')||
'   IF v_change = 0 THEN  -- Keine Daten geändert'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(2020,v_sprache_id ));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 8704922016858395 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPLIC';

p:=p||'ATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
'  v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
'  IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
'  END IF; '||unistr('\000a')||
'  FRGBG_S.SPEICHERN_LABOR'||unistr('\000a')||
'     ( '||unistr('\000a')||
'      v_user,:p31_tab34_kategorie_id/* 71,116:P1_TAB4_KATEGORIE_ID*/,'||unistr('\000a')||
'     :p1_fragebogen_id,:p1_id,:p1_pergebnis_id,'||unistr('\000a')||
'      v_sprache_id , :P1_FEHLER'||unistr('\000a')||
'     )';

p:=p||';'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung auch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8707115545858400 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 34,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'',''SUCHEN'',''P34_SUCHBEMERKUNG_NOSAVE'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p31_tab34_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p31_tab34_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_h';

p:=p||'inweis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 8707310700858400 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 34,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 8706526824858399 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 34,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 8706726080858399 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 34,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 8706909814858399 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 34,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 34
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6446401500121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'FKATEGORIE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6446510062121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'LINK',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6446621101121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'FRAGE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6446700999121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'FANTWORT_ZAHL_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6446813110121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'FANTWORT_EH_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6446932231121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'MESSDATUM',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6447026472121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 7,
  p_query_column_name=> 'FANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6447118591121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 8,
  p_query_column_name=> 'FANTWORT_ID_DISP',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6447226655121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 9,
  p_query_column_name=> 'PERSANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6447308945121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 10,
  p_query_column_name=> 'FRAGE_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6447405359121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 11,
  p_query_column_name=> 'FANTWORT_ZAHL',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6447510073121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 12,
  p_query_column_name=> 'FANTWORT_ZAHL_2',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6447624854121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 13,
  p_query_column_name=> 'ERSATZWERT_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6447719276121858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8702723825858392 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 14,
  p_query_column_name=> 'FANTWORT_NORMBEREICH',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00035
prompt  ...PAGE 35: Aktualisieren FRAGEBOGENANZEIGE 35
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 35
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Aktualisieren FRAGEBOGENANZEIGE 35'
 ,p_step_title => 'Aktualisieren FRAGEBOGENANZEIGE 35'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Aktualisieren FRAGEBOGENANZEIGE 35'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_checklaborwerte (feld_id,wert,eh_id)'||unistr('\000a')||
'{ '||unistr('\000a')||
'  var feld_menge = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkLaborWerte'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  get.add(''P31_EINHEIT_ID_INPUT'',eh_id);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = gReturn ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = '''' ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'function f_checkdatum(feld_id,datum,fragetext)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_datum = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkMessdatum'',0);'||unistr('\000a')||
'  get.add(''P31_DATUM'',datum);'||unistr('\000a')||
'  get.add(''P31_FRAGE_TEXT'',fragetext);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_datum).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'function f_checknormbereich(feld_id,normbereich,wert)'||unistr('\000a')||
'{'||unistr('\000a')||
'  var feld_normbereich = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkNormbereich'',0);'||unistr('\000a')||
'  get.add(''P31_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P31_NORMBEREICH'',normbereich);'||unistr('\000a')||
'  get.add(''P31_WERT_INPUT'',wert);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="red";'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  '||unistr('\000a')||
'       html_GetElement(feld_normbereich).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141022145033'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'   f.fkategorie_text fkategorie_text,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'   WHEN hilfe_text_id is not null'||unistr('\000a')||
'   THEN ''<a href="javascript:popUp2('''''''||unistr('\000a')||
'   ||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'   ''f?p=&APP_ID.:103:&SESSION.::&DEBUG.::P103_hilfe_text_id,P103_frage_text_id:'''||unistr('\000a')||
'   || f.hilfe_text_id||'',''||f.frage_text_id)'||unistr('\000a')||
'   || '''''',700,425)">'''||unistr('\000a')||
'   || ''<img src="#IMAGE_PREFIX#wwv_help_ff.gif">'''||unistr('\000a')||
'   || ''</a>'''||unistr('\000a')||
'   ELSE '' '''||unistr('\000a')||
'   END LINK,'||unistr('\000a')||
'   apex_i';

s:=s||'tem.hidden(2,f.frage_id) ||'||unistr('\000a')||
'   apex_item.hidden(3,p.ID) ||'||unistr('\000a')||
'   f.FRAGE_TEXT FRAGE_TEXT,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder => Wert */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id = ';

s:=s||'f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_2'||unistr('\000a')||
'                           and satz_kennzeichen is null)))||'||unistr('\000a')||
'         apex_item.text(8,FRGBG_T.LAB_TO_CHAR(p.FANTWORT_ZAHL_1,'||unistr('\000a')||
'                        (select min(formatmask) FROM inh_eh_disps'||unistr('\000a')||
'                         WHERE inhstoff_id = f.inhstoff_id'||unistr('\000a')||
'                           and bezug_einheit_id = p.fantwort_zahl_2';

s:=s||''||unistr('\000a')||
'                           and satz_kennzeichen is null)),'||unistr('\000a')||
'                        10,15,''tabindex="1" autocomplete="off"'||unistr('\000a')||
'   onchange="javascript:f_checklaborwerte('''''' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'''||unistr('\000a')||
'    || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0)';

s:=s||' = 1 then '' disabled'' else '''' end , f.frage_ID'||unistr('\000a')||
'                       )'||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => ID der Fantwort */'||unistr('\000a')||
'         apex_item.hidden(6,p.FANTWORT_ZAHL)||'||unistr('\000a')||
'         apex_item.hidden(7,p.FANTWORT_ID)||'||unistr('\000a')||
'         apex_item.select_list_from_query(8,p.FANTWORT_ID,'||unistr('\000a')||
'            ''select frgbg_s.HOLEN_UEBERSETZUNG(fant.text_id,:fas_sprache_id), fant.id from fantworten fant where fa';

s:=s||'nt.frage_id*1000000 = ''||'||unistr('\000a')||
'                                          f.frage_ID*1000000||'||unistr('\000a')||
''' and fant.satz_kennzeichen is null order by fant.sort asc '','||unistr('\000a')||
'            NULL,''NO'',NULL,NULL)'||unistr('\000a')||
'      END fantwort_zahl_eingabe,'||unistr('\000a')||
''||unistr('\000a')||
'   CASE /* Eingabefeld EH */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5  AND f.bezug_einheit_id != 181 THEN  /* Textfelder => EH-Eingabe LOV*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'';

s:=s||'               rezepte.get_inh_def_bezug_eh(f.inhstoff_id)))||'||unistr('\000a')||
'         apex_item.select_list_from_query(10,NVL(p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'                       rezepte.get_inh_def_bezug_eh(f.inhstoff_id)),'||unistr('\000a')||
'''select rezepte.get_bezug_eh_bez(u.bezug_einheit_id,:fas_sprache_id), u.bezug_einheit_id from inh_eh_disps u, bezug_einheiten be, einheiten e where u.inhstoff_id = ''||f.inhstoff_id||'' and u.satz_kennz';

s:=s||'eichen is null and u.bezug_einheit_id = be.id and be.satz_kennzeichen is null and be.einheit_id = e.id and e.physeh_id in (SELECT e.physeh_id FROM inh_eh_umrs i, einheiten e WHERE i.inhstoff_id = ''||f.inhstoff_id||'' and i.satz_kennzeichen is null and i.einheit_id = e.id and e.satz_kennzeichen is null) order by u.sort asc'','||unistr('\000a')||
'''onchange="javascript:f_checklaborwerte('''''' || f.frage_ID || '''''',html_GetEl';

s:=s||'ement('''''' || f.frage_ID || '''''').value, html_GetElement(''''EH'' || f.frage_ID || '''''').value)"'' || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1'||unistr('\000a')||
'    /* OR FRGBG_T.LAB_MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 */ then '' disabled'' else '''' end,'||unistr('\000a')||
'''NO'',NULL,NULL,''EH''||f.frage_ID'||unistr('\000a')||
')'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND f.bezug_einheit_id = 18';

s:=s||'1 THEN  /* Textfelder ohne EH-Eingabe z.B. pH-Werte immer bezug_einheit 181*/'||unistr('\000a')||
'         apex_item.hidden(9,NVL(p.FANTWORT_ZAHL_2,181))||'||unistr('\000a')||
'         apex_item.hidden(10,NVL(p.FANTWORT_ZAHL_2,181),NULL,''EH''||f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'      ELSE         /* LOV-Auswahl Radio => Keine EH-Eingabe */'||unistr('\000a')||
'         apex_item.hidden(9,NULL)||'||unistr('\000a')||
'         apex_item.hidden(10,NULL)||'||unistr('\000a')||
'         '''''||unistr('\000a')||
'      END fantwort_eh_eingabe ,'||unistr('\000a')||
'   a';

s:=s||'pex_item.hidden(11,'||unistr('\000a')||
'                     to_char(NVL(p.messdatum,sysdate),''DD.MM.RRRR hh24:mi''))||'||unistr('\000a')||
'   apex_item.text(12,to_char(NVL(p.messdatum,sysdate),''DD.MM.YYYY hh24:mi'')'||unistr('\000a')||
',20,20,''tabindex="1" autocomplete="off" onchange="javascript:f_checkdatum(''''DAT''||f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''DAT'' || f.frage_ID || '''''').value, ''''''|| f.frage_text||'''''')"'' || case when decode(NVL(FRGBG_S.FB_CHECK_FA';

s:=s||'NT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end, ''DAT''||f.frage_ID'||unistr('\000a')||
') messdatum,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         apex_item.hidden(16,NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                             WHERE frage_id = f.frage_id'||unistr('\000a')||
'                               and satz_kennzeichen is null)))||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
'  ';

s:=s||'    ELSE         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         apex_item.hidden(16,p.FANTWORT_ID)||'||unistr('\000a')||
'         '' '''||unistr('\000a')||
'      END fantwort_id,'||unistr('\000a')||
'   CASE'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 THEN  /* Textfelder */'||unistr('\000a')||
'         NVL(p.fantwort_id,(select min(id) FROM fantworten'||unistr('\000a')||
'                                           WHERE frage_id = f.frage_id'||unistr('\000a')||
'                                             and satz_kennzeichen is null))'||unistr('\000a')||
'      ELS';

s:=s||'E         /* LOV-Auswahl Radio */'||unistr('\000a')||
'         p.FANTWORT_ID'||unistr('\000a')||
'      END fantwort_id_disp,'||unistr('\000a')||
'   p.id persantwort_id, f.frage_id frage_id,p.FANTWORT_ZAHL,p.FANTWORT_ZAHL_2,'||unistr('\000a')||
'   CASE WHEN p.fantwort_text is NULL THEN'||unistr('\000a')||
'     CASE WHEN p.LABOR_FAS_ERSATZWERT_ID is not null THEN'||unistr('\000a')||
'        (SELECT frgbg_s.HOLEN_UEBERSETZUNG(KUERZEL_TEXT_ID,:fas_sprache_id) FROM LABOR_FAS_ERSATZWERTE WHERE ID = p.LABOR_FAS_ERSATZWERT';

s:=s||'_ID)'||unistr('\000a')||
'     ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id)'||unistr('\000a')||
'     END'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(p.fantwort_text_id,:fas_sprache_id,p.fantwort_text )'||unistr('\000a')||
'   END ersatzwert_text,'||unistr('\000a')||
'   CASE /* Eingabefeld */'||unistr('\000a')||
'      WHEN f.ANZEIGETYP_ID = 5 AND (select max(NORMIERUNGSTYP) from FANTWORTEN where FRAGE_Id = f.FRAGE_ID) = ''LABORBEREICH'' THEN'||unistr('\000a')||
'         CASE WHEN FRGBG_T.LAB_';

s:=s||'MEHRERE_NORMBEREICHE_VORH(p.LABOR_NORMBEREICHE_TEXT) = 1 THEN'||unistr('\000a')||
'           -- Wenn Labor mehrere Normbereiche geliefert hat, dürfen diese hier nicht bearbeitet werden,'||unistr('\000a')||
'           -- da über die Maske nur personenspezifische Normbereiche eingegeben werden dürfen'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
'  ';

s:=s||'         apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT))'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'           apex_item.hidden(17,CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                    CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p';

s:=s||'.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standardnormbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                   ELSE ';

s:=s||'NULL END'||unistr('\000a')||
'                END'||unistr('\000a')||
'                   ) ||'||unistr('\000a')||
'           apex_item.text(18, CASE WHEN p.LABOR_NORMBEREICHE_TEXT IS NOT NULL THEN'||unistr('\000a')||
'                    FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)'||unistr('\000a')||
'                ELSE'||unistr('\000a')||
'                  CASE WHEN decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 0 THEN'||unistr('\000a')||
'                    -- Nur Standard';

s:=s||'normbereich anzeigen, wenn auch Wert eingegeben werden kann'||unistr('\000a')||
'                    FRGBG_T.LAB_GET_DEF_NORMBEREICH_TXT('||unistr('\000a')||
'                        p_inhstoff_id => f.INHSTOFF_ID,'||unistr('\000a')||
'                        p_bezug_einheit_id => NVL(p.FANTWORT_ZAHL_2,rezepte.get_inh_def_bezug_eh(f.inhstoff_id))'||unistr('\000a')||
'                    )'||unistr('\000a')||
'                  ELSE NULL END'||unistr('\000a')||
'                END, 10,15,''tabindex="1" autocomplete="off" ';

s:=s||'onblur="javascript:f_checknormbereich(''''NORMB'' || f.frage_ID ||'||unistr('\000a')||
'   '''''',html_GetElement(''''NORMB'' ||f.frage_ID || '''''').value, html_GetElement('''''' ||f.frage_ID ||'||unistr('\000a')||
'   '''''').value)"'''||unistr('\000a')||
'              || case when decode(NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY(:p1_pergebnis_id,p.fantwort_id),0),1,1,0) = 1 then '' disabled'' else '''' end'||unistr('\000a')||
'            , ''NORMB'' || f.frage_ID'||unistr('\000a')||
'         )'||unistr('\000a')||
'        END'||unistr('\000a')||
'     ELSE -- Bei ';

s:=s||'anderen Anzeigetypen auch keine Eingabe möglich'||unistr('\000a')||
'           apex_item.hidden(17,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT)) || -- Zum Abgleich ob Wert geändert wurde'||unistr('\000a')||
'           apex_item.display_and_save(18,FRGBG_T.LAB_NORMBEREICH_DISPL_FORMAT(p.LABOR_NORMBEREICHE_TEXT),''NORMB'' || f.frage_ID)'||unistr('\000a')||
''||unistr('\000a')||
'     END fantwort_normbereich'||unistr('\000a')||
'from v_fragen f, persantworten p --, uebersetzungen u -';

s:=s||'- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'where f.fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  and (f.fkategorie_fkategorie_id = :p31_tab35_kategorie_id or'||unistr('\000a')||
'       f.FKATEGORIE_fkategorie_ID is null and f.fkategorie_id='||unistr('\000a')||
'                                              :p31_tab35_kategorie_id'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and f.personenstamm_id = :p1_id'||unistr('\000a')||
'  AND f.sprache_id = :fas_sprache_id'||unistr('\000a')||
'  AND f.fragelevel = 0';

s:=s||' /* keine Metafragen */'||unistr('\000a')||
'  AND f.visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'  AND f.anzeigetyp_id in (3,4,5) /* Radio, Text */'||unistr('\000a')||
'  and f.frage_id = p.frage_id(+)'||unistr('\000a')||
'  and p.pergebnis_id(+) = :p1_pergebnis_id'||unistr('\000a')||
'  and p.satz_kennzeichen (+) is null'||unistr('\000a')||
'  --and f.such_text_id = u.text_id (+)'||unistr('\000a')||
'  --and u.sprache_id (+) = :fas_sprache_id'||unistr('\000a')||
'  and (:p35_suchbemerkung_NOSAVE is null OR'||unistr('\000a')||
'       --UPPER(u.text) like';

s:=s||' ''%''||UPPER(:p35_suchbemerkung_NOSAVE)||''%'' OR   -- NEI 20.11.13'||unistr('\000a')||
'       UPPER(frgbg_s.HOLEN_UEBERSETZUNG(f.such_text_id,:fas_sprache_id)) like ''%''||UPPER(:p35_suchbemerkung_NOSAVE)||''%'' OR'||unistr('\000a')||
'       UPPER(f.FRAGE_TEXT) like ''%''||UPPER(:p35_suchbemerkung_NOSAVE)||''%'''||unistr('\000a')||
'      )'||unistr('\000a')||
'--  and f.frage_id > 0   -- Nur zu Testzwecken'||unistr('\000a')||
'--order by f.fkategorie_sort,f.frage_sort'||unistr('\000a')||
'--order by f.fkategorie_sort,CASE WHEN ';

s:=s||'p.id is null THEN 0 ELSE 1 END desc ,f.frage_text'||unistr('\000a')||
'order by f.fkategorie_sort,f.frage_text';

wwv_flow_api.create_report_region (
  p_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 35,
  p_name=> '&P1_NULL_VALUE.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;margin:10px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P31_TAB32_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> 'ROW_RANGES_WITH_LINKS',
  p_query_row_count_max=> '300',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709427542860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'t1RegionHeader',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709501691860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709623537860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709724162860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_EINGABE',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709816435860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_EH_EINGABE',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709929099860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MESSDATUM',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8710030319860932 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8708731390860930 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ID_DISP',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8708827908860930 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'PERSANTWORT_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8708907036860930 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709009502860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709106265860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_ZAHL_2',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709318216860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'ERSATZWERT_TEXT',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8709226355860931 + wwv_flow_api.g_id_offset,
  p_region_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'FANTWORT_NORMBEREICH',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P1_FEHLER.';

wwv_flow_api.create_page_plug (
  p_id=> 8711515504860934 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 35,
  p_plug_name=> 'Fehler',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891922013489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_04',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p1_fehler is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8711719070860934 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 35,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 35,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8711901752860934 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 35,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 45,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 8710109382860932 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 35,
  p_button_sequence=> 10,
  p_button_plug_id => 8708500209860928+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8710316888860932 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 35,
  p_button_sequence=> 15,
  p_button_plug_id => 8708500209860928+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8710526813860932 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 35,
  p_button_sequence=> 20,
  p_button_plug_id => 8708500209860928+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_VERWERFEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8710708288860932 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 35,
  p_button_sequence=> 30,
  p_button_plug_id => 8708500209860928+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_SPEICHERN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P1_BEARB_MODUS=''BEARBEITEN''',
  p_button_condition2=> 'BEARBEITEN',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8710918503860933 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 35,
  p_button_sequence=> 40,
  p_button_plug_id => 8708500209860928+wwv_flow_api.g_id_offset,
  p_button_name    => 'WEITER',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_WEITER.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8713421002860936 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 35,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P1_NEXT_PAGE_ID.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8710918503860933+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-OCT-2011 11:10 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>8713617196860937 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 35,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8711104652860933 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 35,
  p_name=>'P35_ICON_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 8708500209860928+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'SUCHEN',
  p_source=>'SUCHEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_button_image_attr=> 'onclick="xwoher=2"',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8711303256860933 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 35,
  p_name=>'P35_SUCHBEMERKUNG_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 8708500209860928+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onclick="xwoher=2"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8712219464860935 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 35,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_eingabe',
  p_validation_sequence=> 50,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_change  NUMBER := 0;'||unistr('\000a')||
'   v_fehlertext  VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Check wurde ausgelagert, da Code zu lang'||unistr('\000a')||
'   v_change := frgbg_s.fb_check_labor_eing(v_fehlertext);'||unistr('\000a')||
'   -- Fehler wird erst vor Speichern ausgewertet und mit Raise angezeigt'||unistr('\000a')||
'   :p1_fehler := v_fehlertext;'||unistr('\000a')||
'   IF v_change = 0 THEN  -- Keine Daten geändert'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(2020,v_sprache_id ));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 8710708288860932 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_mutdat VARCHAR2(50);'||unistr('\000a')||
'   v_sprache_id  NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Prüfen, ob Antwortset für Fragebogen (pergebnisse) zwischenzeitlich geändert wurde'||unistr('\000a')||
'  SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'  FROM pergebnisse'||unistr('\000a')||
'  WHERE  id = :p1_pergebnis_id;'||unistr('\000a')||
'  IF v_mutdat != :p1_mutdat THEN'||unistr('\000a')||
'     RAISE_APPLIC';

p:=p||'ATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
'  v_user := NVL(:P1_USER,:APP_USER);'||unistr('\000a')||
'  IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
'  END IF; '||unistr('\000a')||
'  FRGBG_S.SPEICHERN_LABOR'||unistr('\000a')||
'     ( '||unistr('\000a')||
'      v_user,:p31_tab35_kategorie_id/* 71,116:P1_TAB2_KATEGORIE_ID*/,'||unistr('\000a')||
'     :p1_fragebogen_id,:p1_id,:p1_pergebnis_id,'||unistr('\000a')||
'      v_sprache_id , :P1_FEHLER'||unistr('\000a')||
'     )';

p:=p||';'||unistr('\000a')||
' IF :p1_fehler IS NOT NULL THEN'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,:p1_fehler );'||unistr('\000a')||
' ELSE'||unistr('\000a')||
'    -- Änderung auch in pergebnisse festhalten durch Aktualisierung von mutdat'||unistr('\000a')||
'    UPDATE pergebnisse'||unistr('\000a')||
'       SET mutdat = SYSDATE'||unistr('\000a')||
'    WHERE id = :p1_pergebnis_id ;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8712930342860936 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 35,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Daten_uebernehmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUBMIT'',''WEITER'',''SUCHEN'',''P35_SUCHBEMERKUNG_NOSAVE'') AND :P1_BEARB_MODUS=''BEARBEITEN''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p31_tab35_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p31_tab35_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_h';

p:=p||'inweis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 8713102067860936 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 35,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p1_fehler := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 8712326948860935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 35,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'p1_fehler_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO :p1_mutdat'||unistr('\000a')||
'FROM pergebnisse'||unistr('\000a')||
'WHERE ID = :p1_pergebnis_id;';

wwv_flow_api.create_page_process(
  p_id     => 8712520914860935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 35,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mutdat',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'3865911106055915';

wwv_flow_api.create_page_process(
  p_id     => 8712723683860936 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 35,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'get_next_tab_page_id',
  p_process_sql_clob => 3865911106055915 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 35
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6447927367125058 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'FKATEGORIE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448029642125058 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'LINK',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448132245125058 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'FRAGE_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448211425125058 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'FANTWORT_ZAHL_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448331700125058 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'FANTWORT_EH_EINGABE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448407077125058 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'MESSDATUM',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448529153125059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 7,
  p_query_column_name=> 'FANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448623372125059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 8,
  p_query_column_name=> 'FANTWORT_ID_DISP',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448726193125059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 9,
  p_query_column_name=> 'PERSANTWORT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448821943125059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 10,
  p_query_column_name=> 'FRAGE_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6448919256125059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 11,
  p_query_column_name=> 'FANTWORT_ZAHL',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6449018924125059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 12,
  p_query_column_name=> 'FANTWORT_ZAHL_2',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6449120130125059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 13,
  p_query_column_name=> 'ERSATZWERT_TEXT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6449209952125059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8708500209860928 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 14,
  p_query_column_name=> 'FANTWORT_NORMBEREICH',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00090
prompt  ...PAGE 90: Fragebogenüberprüfung
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 90
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Fragebogenüberprüfung'
 ,p_step_title => '&P1_TAB90_KATEGORIE_TEXT.'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Fragebogenüberprüfung'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141007165808'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3172928617934117 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 90,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'Select   /* Fragen mit Antworten */ '||unistr('\000a')||
'    frgbg_s.holen_uebersetzung(fk.text_id,f.sprache_id) kategorie_text,'||unistr('\000a')||
'    f.frage_text,'||unistr('\000a')||
'    CASE /* Prüfen, ob Eingaben vollständig */'||unistr('\000a')||
'    WHEN( '||unistr('\000a')||
'         ((FLAG = ''NUM1'' OR instr(FLAG,''N1'') > 0) AND pa.fantwort_zahl IS NULL) OR'||unistr('\000a')||
'        ((FLAG = ''TEXT1'' OR instr(FLAG,''T1'') > 0) AND pa.fantwort_text IS NULL) OR'||unistr('\000a')||
'        ((FLAG in(''DATE1'',''DATETIME1'',''TIME1'') OR';

s:=s||' regexp_instr(FLAG,''(D1)|(DT1)|(TI1)'') > 0) AND'||unistr('\000a')||
'          pa.fantwort_datum IS NULL) OR'||unistr('\000a')||
'        ((FLAG = ''NUM2'' OR instr(FLAG,''N2'') > 0) AND'||unistr('\000a')||
'        (pa.fantwort_zahl IS NULL OR pa.fantwort_zahl_1 IS NULL )) OR'||unistr('\000a')||
'        ((FLAG = ''TEXT2'' OR instr(FLAG,''T2'') > 0) AND'||unistr('\000a')||
'        (pa.fantwort_text IS NULL OR pa.fantwort_text_1 IS NULL)) OR'||unistr('\000a')||
'        ((FLAG in(''DATE2'',''DATETIME2'',''TIME2'') OR regexp_instr(FLA';

s:=s||'G,''(D2)|(DT2)|(TI2)'') > 0) AND'||unistr('\000a')||
'        (pa.fantwort_datum IS NULL OR pa.fantwort_datum_1 IS NULL)) OR'||unistr('\000a')||
'        ((FLAG = ''NUM3'' OR instr(FLAG,''N3'') > 0) AND'||unistr('\000a')||
'        (pa.fantwort_zahl IS NULL OR pa.fantwort_zahl_1 IS NULL OR'||unistr('\000a')||
'         pa.fantwort_zahl_2 IS NULL )) OR'||unistr('\000a')||
'        ((FLAG = ''TEXT3'' OR instr(FLAG,''T3'') > 0) AND'||unistr('\000a')||
'        (pa.fantwort_text IS NULL OR pa.fantwort_text_1 IS NULL OR'||unistr('\000a')||
'         pa.fan';

s:=s||'twort_text_2 IS NULL)) OR'||unistr('\000a')||
'        ((FLAG in(''DATE3'',''DATETIME3'',''TIME3'') OR regexp_instr(FLAG,''(D3)|(DT3)|(TI3)'') > 0) AND'||unistr('\000a')||
'        (pa.fantwort_datum IS NULL OR pa.fantwort_datum_1 IS NULL OR'||unistr('\000a')||
'         pa.fantwort_datum_2 IS NULL)) OR'||unistr('\000a')||
'         (f.ANZEIGETYP_ID = 17 and pa.fantwort_dokument_fas_id is null)'||unistr('\000a')||
'        )'||unistr('\000a')||
'       and f.eingabepflichtig = 1'||unistr('\000a')||
'    THEN ''<a href="'''||unistr('\000a')||
'         ||''f?p=&APP_ID.:''||t';

s:=s||'o_char(fk.apex_seiten_nr)'||unistr('\000a')||
'         ||'':&SESSION.::&DEBUG.:::'''||unistr('\000a')||
'         ||''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#ed-item.gif">'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'    ELSE '' '''||unistr('\000a')||
'    END  LINK,'||unistr('\000a')||
'    CASE /* Darstellung des Ergebnisses, bei Radio/Checkbox erst Text dann Wert,'||unistr('\000a')||
'            sonst Wert dann Text dann Verarb. EH */'||unistr('\000a')||
'    WHEN FLAG = ''NUM1'' AND f.anzeigetyp_id in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(NVL(frgbg_s.ho';

s:=s||'len_uebersetzung(fa.text_id,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''|| pa.fantwort_zahl)'||unistr('\000a')||
'    WHEN FLAG = ''NUM1'' AND f.anzeigetyp_id not in (1,2,3,4) and '||unistr('\000a')||
'         fk.art = 1 THEN -- Std.erf'||unistr('\000a')||
'         Ltrim(pa.fantwort_zahl||'' ''|| '||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')) '||unistr('\000a')||
'    WHEN FLAG = ''NUM1'' AND f.anzeigetyp_id not in (1,2,3,4) and '||unistr('\000a')||
'         fk.art = 2 THEN --';

s:=s||' Laborerf.'||unistr('\000a')||
'         Ltrim(pa.fantwort_zahl_1||'' ''|| '||unistr('\000a')||
'               --NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')) '||unistr('\000a')||
'               rezepte.get_eh(pa.fantwort_zahl_2,f.sprache_id))'||unistr('\000a')||
'    WHEN FLAG = ''TEXT1'' AND f.anzeigetyp_id in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_text)'||unistr('\000a')||
'    WHEN FLAG = ''TEXT1'' ';

s:=s||'AND f.anzeigetyp_id not in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(pa.fantwort_text||'' ''|| '||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' ''))'||unistr('\000a')||
'    WHEN FLAG in(''DATE1'',''DATETIME1'',''TIME1'')   AND f.anzeigetyp_id in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''|| to_char(pa.fantwort_datum,NVL(fa.FORMATMASK,''DD.MM.RRRR';

s:=s||' hh24:mi'')))'||unistr('\000a')||
'    WHEN FLAG in(''DATE1'',''DATETIME1'',''TIME1'')  AND f.anzeigetyp_id not in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(to_char(pa.fantwort_datum,NVL(fa.FORMATMASK,''DD.MM.RRRR hh24:mi''))||'' ''|| '||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' ''))'||unistr('\000a')||
'    WHEN FLAG = ''NUM2'' AND f.anzeigetyp_id in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id)';

s:=s||','' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_zahl||''<br>''||'||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_zahl_1)'||unistr('\000a')||
'    WHEN FLAG = ''NUM2'' AND f.anzeigetyp_id not in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(pa.fantwort_zahl||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')||''<br>''||'||unistr('\000a')||
'               pa.fantwort_zahl_1||'' ''';

s:=s||'||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' ''))'||unistr('\000a')||
'    WHEN FLAG = ''TEXT2'' AND f.anzeigetyp_id in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_text||''<br>''||'||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_text_1 )'||unistr('\000a')||
'    WHEN FLAG';

s:=s||' = ''TEXT2'' AND f.anzeigetyp_id not in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(pa.fantwort_text||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')||''<br>''||'||unistr('\000a')||
'               pa.fantwort_text_1||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' ''))'||unistr('\000a')||
'    WHEN FLAG in(''DATE2'',''DATETIME2'',''TIME2'')  AND f.anzeigetyp_id in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(NVL(frgbg_s.';

s:=s||'holen_uebersetzung(fa.text_id,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||to_char(pa.fantwort_datum,NVL(fa.FORMATMASK,''DD.MM.RRRR hh24:mi'')) ||''<br>''||'||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||to_char(pa.fantwort_datum_1,NVL(fa.FORMATMASK_1,''DD.MM.RRRR hh24:mi'')) )'||unistr('\000a')||
'    WHEN FLAG in(''DATE2'',''DATETIME2'',''TIME2'')  AND f.anzeigetyp_id not in (1';

s:=s||',2,3,4) THEN'||unistr('\000a')||
'         Ltrim(to_char(pa.fantwort_datum,NVL(fa.FORMATMASK,''DD.MM.RRRR hh24:mi''))||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')||''<br>''||'||unistr('\000a')||
'               to_char(pa.fantwort_datum_1,NVL(fa.FORMATMASK_1,''DD.MM.RRRR hh24:mi''))||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' ''))'||unistr('\000a')||
'    WHEN FLAG = ''NUM3'' AND f.anzeigetyp_id in (1,2';

s:=s||',3,4) THEN'||unistr('\000a')||
'         Ltrim(NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_zahl ||''<br>''||'||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_zahl_1 ||''<br>''||'||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id_2,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_zahl_2 )'||unistr('\000a')||
'    WHEN ';

s:=s||'FLAG = ''NUM3'' AND f.anzeigetyp_id not in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(pa.fantwort_zahl||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')||''<br>''||'||unistr('\000a')||
'               pa.fantwort_zahl_1||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' '')||'||unistr('\000a')||
'              ''<br>''||pa.fantwort_zahl_2||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id_2,f.spra';

s:=s||'che_id),'' ''))'||unistr('\000a')||
'    WHEN FLAG = ''TEXT3'' AND f.anzeigetyp_id in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_text ||''<br>''||'||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_text_1 ||''<br>''||'||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id_2,f.sprac';

s:=s||'he_id),'' '')'||unistr('\000a')||
'               ||'': ''||pa.fantwort_text_2 )'||unistr('\000a')||
'    WHEN FLAG = ''TEXT3'' AND f.anzeigetyp_id not in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(pa.fantwort_text||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')||''<br>''||'||unistr('\000a')||
'               pa.fantwort_text_1||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' '')||'||unistr('\000a')||
'              ''<br>''||pa.fantwort_text_2||';

s:=s||''' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id_2,f.sprache_id),'' ''))'||unistr('\000a')||
'    WHEN FLAG in(''DATE3'',''DATETIME3'',''TIME3'')  AND f.anzeigetyp_id in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim(NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||to_char(pa.fantwort_datum,NVL(fa.FORMATMASK,''DD.MM.RRRR hh24:mi''))||''<br>''||'||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,';

s:=s||'f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||to_char(pa.fantwort_datum_1,NVL(fa.FORMATMASK_1,''DD.MM.RRRR hh24:mi'')) ||''<br>''||'||unistr('\000a')||
'               NVL(frgbg_s.holen_uebersetzung(fa.text_id_2,f.sprache_id),'' '')'||unistr('\000a')||
'               ||'': ''||to_char(pa.fantwort_datum_2,NVL(fa.FORMATMASK_2,''DD.MM.RRRR hh24:mi'')) )'||unistr('\000a')||
'    WHEN FLAG in(''DATE3'',''DATETIME3'',''TIME3'') AND f.anzeigetyp_id not in (1,2,3,4) THEN'||unistr('\000a')||
'         Ltrim';

s:=s||'(to_char(pa.fantwort_datum,NVL(fa.FORMATMASK,''DD.MM.RRRR hh24:mi''))||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id),'' '')||''<br>''||'||unistr('\000a')||
'               to_char(pa.fantwort_datum_1,NVL(fa.FORMATMASK_1,''DD.MM.RRRR hh24:mi''))||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id_1,f.sprache_id),'' '')||'||unistr('\000a')||
'              ''<br>''||to_char(pa.fantwort_datum_2,NVL(fa.FORMATMASK_2,''DD.MM';

s:=s||'.RRRR hh24:mi''))||'' ''||'||unistr('\000a')||
'          NVL(frgbg_s.holen_uebersetzung(fa.text_id_2,f.sprache_id),'' ''))'||unistr('\000a')||
'    WHEN f.anzeigetyp_id in(17) AND pa.FANTWORT_DOKUMENT_FAS_ID is not null then'||unistr('\000a')||
'       (select BESCHREIBUNG from DOKUMENTE_FAS where id = pa.FANTWORT_DOKUMENT_FAS_ID)'||unistr('\000a')||
'    WHEN FLAG = ''TI2,T1'' THEN -- Tätigkeitsprotokoll'||unistr('\000a')||
'       to_char(pa.FANTWORT_DATUM,''HH24:MI'') || CASE WHEN pa.FANTWORT_DATUM_1 <> p';

s:=s||'a.FANTWORT_DATUM THEN '' - '' || to_char(pa.FANTWORT_DATUM_1,''HH24:MI'') ELSE null END || '' : '' || pa.FANTWORT_TEXT'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'       frgbg_s.holen_uebersetzung(fa.text_id,f.sprache_id)'||unistr('\000a')||
'    END antwort_text,'||unistr('\000a')||
'    f.frage_sort,f.fkategorie_sort'||unistr('\000a')||
'from v_fragen f, persantworten  pa , fantworten    fa,'||unistr('\000a')||
'     personenstamm p, --app_sprachen s,'||unistr('\000a')||
'     fkategorien fk '||unistr('\000a')||
'where f.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'and ';

s:=s||'f.personenstamm_id= :p1_id'||unistr('\000a')||
'and pa.FRAGE_ID  = f.frage_id'||unistr('\000a')||
'and pa.FRAGEBOGEN_ID  = f.FRAGEBOGEN_ID'||unistr('\000a')||
'and pa.personenstamm_ID  = f.PERSONENSTAMM_ID'||unistr('\000a')||
'and pa.pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'and pa.satz_kennzeichen is null   -- NEI 22.04.10'||unistr('\000a')||
'and fa.ID = pa.FANTWORT_ID'||unistr('\000a')||
'and p.id =f.personenstamm_id       '||unistr('\000a')||
'--and p.app_sprache_id = s.id     -- Sprachfestlegung aus Personenstamm'||unistr('\000a')||
'and f.sprache_id = :fas_sprache_i';

s:=s||'d'||unistr('\000a')||
'and f.FKATEGORIE_ID = fk.ID'||unistr('\000a')||
'/*and (fk.kategorietyp_id = 1 AND p.geschlecht = ''W'' '||unistr('\000a')||
'     OR fk.kategorietyp_id is NULL  OR fk.kategorietyp_id <> 1 )'||unistr('\000a')||
'*/'||unistr('\000a')||
'and (frgbg_s.CHECK_TAB_ANZEIGEN_N(:p1_pergebnis_id,f.fkategorie_id)=1 )'||unistr('\000a')||
'AND f.fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'and f.visible = 1 /* nur sichtbare Frage */'||unistr('\000a')||
'and fk.art = 1       /* nur Fragen aus Std.tabs, keine Labor-tabs */'||unistr('\000a')||
'and fk.satz_kennzei';

s:=s||'chen is null --NEI 19.05.10'||unistr('\000a')||
'and fa.satz_kennzeichen is null --NEI 19.05.10'||unistr('\000a')||
'UNION    /* Fragen ohne Antworten */'||unistr('\000a')||
'Select '||unistr('\000a')||
'    frgbg_s.holen_uebersetzung(fk.text_id,f.sprache_id) , '||unistr('\000a')||
'    f.frage_text,'||unistr('\000a')||
'    CASE'||unistr('\000a')||
'    WHEN f.eingabepflichtig = 1 '||unistr('\000a')||
'    THEN ''<a href="'''||unistr('\000a')||
'         ||''f?p=&APP_ID.:''||to_char(fk.apex_seiten_nr)'||unistr('\000a')||
'         ||'':&SESSION.::&DEBUG.:::'''||unistr('\000a')||
'         ||''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PRE';

s:=s||'FIX#ed-item.gif">'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'    ELSE '' '''||unistr('\000a')||
'    END,'||unistr('\000a')||
'    NULL,'||unistr('\000a')||
'    f.frage_sort,f.fkategorie_sort'||unistr('\000a')||
'from v_fragen f , personenstamm p, --app_sprachen s,'||unistr('\000a')||
'     fkategorien fk '||unistr('\000a')||
'where f.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'and f.personenstamm_id= :p1_id'||unistr('\000a')||
'AND ( :p1_pergebnis_id is NULL OR frage_id not in ('||unistr('\000a')||
'           Select pa1.frage_id /* Fragen zu denen es mögliche Antworten gibt */ '||unistr('\000a')||
'           from';

s:=s||' persantworten pa1, fantworten fa1'||unistr('\000a')||
'           where pa1.pergebnis_id = :p1_pergebnis_id '||unistr('\000a')||
'             and pa1.satz_kennzeichen is null'||unistr('\000a')||
'             and pa1.fantwort_id = fa1.id'||unistr('\000a')||
'             and fa1.satz_kennzeichen is null  -- NEI 19.05.10'||unistr('\000a')||
'            )          '||unistr('\000a')||
'     )'||unistr('\000a')||
'and f.FKATEGORIE_ID = fk.ID'||unistr('\000a')||
'and p.id =f.personenstamm_id'||unistr('\000a')||
'--and p.app_sprache_id = s.id'||unistr('\000a')||
'and f.sprache_id = :fas_sprache_id'||unistr('\000a')||
'/*and (';

s:=s||'fk.kategorietyp_id = 1 AND p.geschlecht = ''W'' '||unistr('\000a')||
'     OR fk.kategorietyp_id = 2 and :p1_hrv_zuletzt_geladen is not null'||unistr('\000a')||
'     OR fk.kategorietyp_id is NULL  OR fk.kategorietyp_id not in (1,2) )'||unistr('\000a')||
'*/'||unistr('\000a')||
'and (frgbg_s.CHECK_TAB_ANZEIGEN_N(:p1_pergebnis_id,f.fkategorie_id) = 1)'||unistr('\000a')||
'AND f.fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'AND f.visible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'and fk.art = 1       /* nur Frag';

s:=s||'en aus Std.tabs, keine Labor-tabs */'||unistr('\000a')||
'and fk.satz_kennzeichen is null --NEI 19.05.10'||unistr('\000a')||
'order by fkategorie_sort,frage_sort';

wwv_flow_api.create_report_region (
  p_id=> 5206305793781445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 90,
  p_name=> '&P1_TAB90_KATEGORIE_TEXT.',
  p_region_name=>'90',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;">',
  p_footer=> '</div>'||unistr('\000a')||
'',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 1,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '1:2',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB90_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> '&P90_BL_DRUCKEN.',
  p_prn_output_file_name=> 'Vitaranuebersicht',
  p_prn_content_disposition=> 'ATTACHMENT',
  p_prn_document_header=> 'APEX',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width_units=> 'PERCENTAGE',
  p_prn_width=> 210,
  p_prn_height=> 297,
  p_prn_orientation=> 'VERTICAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'LEFT',
  p_prn_page_footer_alignment=> 'LEFT',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5206820824781448 + wwv_flow_api.g_id_offset,
  p_region_id=> 5206305793781445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'KATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'fielddatabold',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '16',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5206717660781448 + wwv_flow_api.g_id_offset,
  p_region_id=> 5206305793781445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '16',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5207627407781448 + wwv_flow_api.g_id_offset,
  p_region_id=> 5206305793781445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '16',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5206902583781448 + wwv_flow_api.g_id_offset,
  p_region_id=> 5206305793781445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'ANTWORT_TEXT',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '16',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5207118368781448 + wwv_flow_api.g_id_offset,
  p_region_id=> 5206305793781445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_SORT',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '16',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5207228552781448 + wwv_flow_api.g_id_offset,
  p_region_id=> 5206305793781445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_SORT',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '16',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'&P90_INFOTEXT.'||unistr('\000a')||
'';

wwv_flow_api.create_page_plug (
  p_id=> 5243817014541787 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 90,
  p_plug_name=> '&P1_REGION_TITEL_INFOTEXT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2889831731489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_03',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5571009800871850 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 90,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 30,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12593903419920840 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 90,
  p_button_sequence=> 10,
  p_button_plug_id => 5206305793781445+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5382021432491025 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 90,
  p_button_sequence=> 20,
  p_button_plug_id => 5206305793781445+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5233421067410506 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 90,
  p_name=>'P90_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5206305793781445+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'DECLARE'||unistr('\000a')||
'   v_name   VARCHAR2(2000);'||unistr('\000a')||
'   v_land   v_laender.land%TYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'-- RETURN(:p1_name||'', ''||:p1_vorname||'', ''||:p1_geburtsdatum||'', ''||:p1_ort'||unistr('\000a')||
'--                  ||'', ''||:p1_land);'||unistr('\000a')||
'   BEGIN   '||unistr('\000a')||
'      SELECT land into v_land from v_laender where id = :p1_land_id;'||unistr('\000a')||
'   EXCEPTION '||unistr('\000a')||
'   WHEN others THEN null;'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   SELECT :p1_name||decode(:p1_vorname,null,'''','', ''||:p1_vorname)||'||unistr('\000a')||
'                    decode(:p1_geburtsdatum,null,'''','', ''||:p1_geburtsdatum)||'||unistr('\000a')||
'                    decode(:p1_ort,null,'''','', ''||:p1_ort)||'||unistr('\000a')||
'                    decode(:p1_land_id,null,'''','', ''||v_land) '||unistr('\000a')||
'   INTO v_name'||unistr('\000a')||
'   FROM DUAL;'||unistr('\000a')||
'   RETURN(v_name);'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5244627057544620 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 90,
  p_name=>'P90_INFOTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5243817014541787+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9629716948027668 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 90,
  p_name=>'P90_BL_DRUCKEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5206305793781445+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab90_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab90_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hin';

p:=p||'weis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4133923587287476 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 90,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p90_infotext := frgbg_s.holen_uebersetzung(246,:fas_sprache_id);'||unistr('\000a')||
':p90_bl_drucken := frgbg_s.holen_uebersetzung(741,:fas_sprache_id);';

wwv_flow_api.create_page_process(
  p_id     => 5289914915208059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 90,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_infotext_bl_drucken',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 90
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00091
prompt  ...PAGE 91: Formular
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 91
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Formular'
 ,p_step_title => '&P1_TAB91_KATEGORIE_TEXT.'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Formular'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141008110220'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3173307278937442 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 91,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select --u.text fkategorie_text,'||unistr('\000a')||
'       --u1.text frage_text,'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(fk.text_id,:fas_sprache_id) fkategorie_text,'||unistr('\000a')||
'       frgbg_s.HOLEN_UEBERSETZUNG(f.TEXT_ID_FRAGETEXT ,:fas_sprache_id) frage_text,'||unistr('\000a')||
'FRGBG_S.ERZEUGEN_FELDER'||unistr('\000a')||
'  ( '||unistr('\000a')||
'    f.ANZEIGETYP_ID, fk.FRAGEBOGEN_ID, f.ID, 0,1,0,0, :fas_sprache_id'||unistr('\000a')||
'  )'||unistr('\000a')||
'Auswahl'||unistr('\000a')||
'from fragen f, fkategorien fk'||unistr('\000a')||
'     --, uebersetzungen u,ueberset';

s:=s||'zungen u1-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'where fk.fragebogen_id =:p1_fragebogen_id'||unistr('\000a')||
'  AND fk.sort < 90     -- echte Fragebogenkategorien'||unistr('\000a')||
'  AND f.fkategorie_id = fk.id'||unistr('\000a')||
'  --AND fk.text_id = u.text_id'||unistr('\000a')||
'  --AND u.sprache_id = :fas_sprache_id'||unistr('\000a')||
'  --AND u1.sprache_id = u.sprache_id'||unistr('\000a')||
'  --AND f.TEXT_ID_FRAGETEXT = u1.text_id'||unistr('\000a')||
'  AND f.fragelevel = 0 /* keine Metafragen */'||unistr('\000a')||
'  AND f.v';

s:=s||'isible = 1    /* nur sichtbare Fragen anzeigen */'||unistr('\000a')||
'  AND f.satz_kennzeichen is null'||unistr('\000a')||
'  AND fk.satz_kennzeichen is null'||unistr('\000a')||
'order by fk.sort,f.sort';

wwv_flow_api.create_report_region (
  p_id=> 5305009151306631 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 91,
  p_name=> '&P1_TAB91_KATEGORIE_TEXT.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P1_HEIGHT_SCROLLREGION.px;">',
  p_footer=> '</div>'||unistr('\000a')||
'',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 2897206339489445+ wwv_flow_api.g_id_offset,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1:2',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_item=> 'P1_TAB91_KATEGORIE_ZEILEN',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '1000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5321325379466506 + wwv_flow_api.g_id_offset,
  p_region_id=> 5305009151306631 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FKATEGORIE_TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_css_class=>'fielddatabold',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5321425935466506 + wwv_flow_api.g_id_offset,
  p_region_id=> 5305009151306631 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGE_TEXT',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '20',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5321527024466506 + wwv_flow_api.g_id_offset,
  p_region_id=> 5305009151306631 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'AUSWAHL',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5571215341873400 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 91,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12594508960922404 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 91,
  p_button_sequence=> 10,
  p_button_plug_id => 5305009151306631+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5382210135497134 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 91,
  p_button_sequence=> 20,
  p_button_plug_id => 5305009151306631+wwv_flow_api.g_id_offset,
  p_button_name    => 'Auswertung',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_AUSWERTUNG.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P1_PAGE_AUSWERTUNG.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''PIS''',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5306807107306634 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 91,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5342822543986189 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 91,
  p_name=>'P91_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5305009151306631+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEGIN'||unistr('\000a')||
' RETURN(:p1_name||'',''||:p1_vorname||'', ''||:p1_geburtsdatum||'', ''||:p1_ort||'', '''||unistr('\000a')||
'                ||:p1_land);'||unistr('\000a')||
'END;',
  p_source_type=> 'ALWAYS_NULL',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab91_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab91_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_hinweis in c_hin';

p:=p||'weis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 4134308827292698 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 91,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p90_infotext := frgbg_s.holen_uebersetzung(246,:fas_sprache_id);';

wwv_flow_api.create_page_process(
  p_id     => 5345520596995054 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 91,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_infotext',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 91
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00095
prompt  ...PAGE 95: Fragebogenauswertung
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 95
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Fragebogenauswertung'
 ,p_step_title => 'Fragebogenauswertung'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_html_page_onload => 'onBeforeUnload="return WarnSave();"'
 ,p_step_sub_title => 'Fragebogenauswertung'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function check_checkbox(p_itemname,p_text)'||unistr('\000a')||
'{'||unistr('\000a')||
' var ip=document.getElementsByTagName(''INPUT'');'||unistr('\000a')||
' var ret=new Array();'||unistr('\000a')||
' var regexp=new RegExp(''^''+p_itemname+''_'');'||unistr('\000a')||
' var l_exist=0'||unistr('\000a')||
' for (var j=0;j<ip.length;j++) {'||unistr('\000a')||
'   if (ip[j].type=="checkbox" && ip[j].id && ip[j].id.match(regexp)) {'||unistr('\000a')||
'      if (ip[j].checked && ip[j].value==7) {'||unistr('\000a')||
'        alert(p_text);'||unistr('\000a')||
'        l_exist=1;'||unistr('\000a')||
'      }'||unistr('\000a')||
'    }   '||unistr('\000a')||
' }'||unistr('\000a')||
' //alert(''Hallo:''+l_exist);'||unistr('\000a')||
' if (l_exist==1 ) {'||unistr('\000a')||
' for (var j=0;j<ip.length;j++) {'||unistr('\000a')||
'   if (ip[j].type=="checkbox" && ip[j].id && ip[j].id.match(regexp)) {'||unistr('\000a')||
'      if (ip[j].checked && ip[j].value!=7) {'||unistr('\000a')||
'        //alert(''Die Etikettoption uncheck!''+ip[j].value);'||unistr('\000a')||
'        ip[j].checked=false;'||unistr('\000a')||
'       }'||unistr('\000a')||
'   }   '||unistr('\000a')||
' }'||unistr('\000a')||
' }'||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
''||unistr('\000a')||
'<script type="text/javascript">  '||unistr('\000a')||
'    <!--  '||unistr('\000a')||
'      '||unistr('\000a')||
'    function html_Submit_Progress(pThis){  '||unistr('\000a')||
'    $x_Show(''AjaxLoading'');  '||unistr('\000a')||
'    window.setTimeout(''$s("AjaxLoading",$x("AjaxLoading").innerHTML)'', 100);  '||unistr('\000a')||
'    doSubmit(''MN_REZEPT'');  '||unistr('\000a')||
'    }  '||unistr('\000a')||
'      '||unistr('\000a')||
'    function submit_HideAll(pThis){  '||unistr('\000a')||
'    $x_Hide(''wwvFlowForm'');  '||unistr('\000a')||
'    doSubmit(''MN_REZEPT'');  '||unistr('\000a')||
'    }  '||unistr('\000a')||
'      '||unistr('\000a')||
'    function submit_ButtonRegion(pThis){  '||unistr('\000a')||
'    $x_Hide(''button_region'');  '||unistr('\000a')||
'    doSubmit(''MN_REZEPT'');  '||unistr('\000a')||
'    }  '||unistr('\000a')||
'      '||unistr('\000a')||
'      '||unistr('\000a')||
'    //-->  '||unistr('\000a')||
'</script>  '||unistr('\000a')||
''
 ,p_footer_text => '    <style>   #AjaxLoading{padding:5px;font-size:18px;width:200px;text-align:center;left:15%;top:15%;position:absolute;border:2px solid #666;background-color:#FFF;}  '||unistr('\000a')||
'    </style>  '||unistr('\000a')||
'    <div id="AjaxLoading" style="display:none;">...waiting...<br /><img src="#IMAGE_PREFIX#processing.gif" id="wait" /></div>  '
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150417103004'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5571419150874542 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 95,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 41,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P1_ZURUECK_ZUR_SEITE = 323',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5814023263192051 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 95,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')'||unistr('\000a')||
'AND '||unistr('\000a')||
':P1_ZURUECK_ZUR_SEITE = 140',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5814223606192060 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 95,
  p_plug_name=> '&P95_REGION_TITEL_AUSWERTUNG.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 21,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_aufgerufen_von != ''PIS''',
  p_plug_header=> '<div style="min-width: 750px; max-width: 750px;">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5922205686427932 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 95,
  p_plug_name=> '&P95_PAGE_TITEL_PATIENT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'<script type="text/javascript">'||unistr('\000a')||
'/* Lädt das "Lade-Icon" vor. Dynamic Action hat nicht funktioniert, daher der direkte Eintrag in eine HTML Region */'||unistr('\000a')||
'var iconImage = new Image();'||unistr('\000a')||
'iconImage.src = "#IMAGE_PREFIX#themes/&FAS_THEME_NAME./ajax-loader.gif";'||unistr('\000a')||
'</script>';

wwv_flow_api.create_page_plug (
  p_id=> 5614327296858947 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 95,
  p_plug_name=> 'IMAGE_PRELOAD',
  p_region_name=>'',
  p_parent_plug_id=>5922205686427932 + wwv_flow_api.g_id_offset,
  p_escape_on_http_output=>'Y',
  p_plug_template=> 0,
  p_plug_display_sequence=> 111,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8253802822364066 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 95,
  p_plug_name=> '&P95_REGION_TITEL_DRUCKEN.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 51,
  p_plug_new_grid         => true,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'FUNCTION_BODY',
  p_plug_display_when_condition => 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* NEI 04.10.11 Endkunden-Login Keine Druckauswahl und auch nicht anzeigen */'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON = ''BETREUER'' THEN '||unistr('\000a')||
'      /*SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM mn_rezepte'||unistr('\000a')||
'      WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'        and satz_kennzeichen is null;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz > 0'||unistr('\000a')||
'      THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'      ELSE RETURN FALSE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_header=> '<div style="min-width: 750px; max-width: 750px;" id="Region_Druckoptionen" >',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5815619342192070 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 95,
  p_button_sequence=> 1,
  p_button_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:1,31,95::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON not in (''PIS'',''ANONYM'',''KUNDE'')',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5814406799192062 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 95,
  p_button_sequence=> 11,
  p_button_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_button_name    => 'AUSWERTUNG_NEUES_REZEPT',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P95_BL_AUSWERTUNG_NEUES_REZEPT.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /*SELECT count(*) into v_anz'||unistr('\000a')||
'    FROM mn_rezepte'||unistr('\000a')||
'    WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'      and satz_kennzeichen is null;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON in (''BETREUER'') THEN'||unistr('\000a')||
'      -- Auswertung vorhanden'||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
'      IF v_anz > 0'||unistr('\000a')||
'      THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'      ELSE RETURN FALSE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_button_cattributes=>'class="MN_REZEPT_WAIT"',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5814622354192068 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 95,
  p_button_sequence=> 12,
  p_button_plug_id => 8253802822364066+wwv_flow_api.g_id_offset,
  p_button_name    => 'AUSWERTUNG_DRUCKEN',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(5444705864405057+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P95_BL_AUSWERTUNG_DRUCKEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Auswertung vorhanden ?'||unistr('\000a')||
'   v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
'   IF v_anz > 0'||unistr('\000a')||
'   THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'   ELSE RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5814826756192068 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 95,
  p_button_sequence=> 13,
  p_button_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_button_name    => 'KOPIEREN',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P95_BL_KOPIEREN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON in (''BETREUER'') THEN'||unistr('\000a')||
'      -- Auswertung vorhanden ?'||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
'      IF v_anz > 0'||unistr('\000a')||
'      THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'      ELSE RETURN FALSE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5815406789192070 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 95,
  p_button_sequence=> 14,
  p_button_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_button_name    => 'KOPIEREN0',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P95_BL_KOPIEREN0.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON in (''BETREUER'') THEN'||unistr('\000a')||
'      -- Auswertung vorhanden?'||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
'      IF v_anz > 0'||unistr('\000a')||
'      THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'      ELSE RETURN FALSE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5815228789192070 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 95,
  p_button_sequence=> 15,
  p_button_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_button_name    => 'AUSWERTUNG_LOESCHEN',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P95_BL_DEL_AUSWERTUNG.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'   v_anz_module NUMBER := 0;'||unistr('\000a')||
'   v_anz_gutschein NUMBER := 0;'||unistr('\000a')||
'   v_last_mutdat DATE;'||unistr('\000a')||
'   v_prot_id   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   -- Handelt es sich um den aktuellen Antwortset?'||unistr('\000a')||
'   SELECT count(*) into v_anz'||unistr('\000a')||
'   FROM v_fb_fas'||unistr('\000a')||
'   WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'     AND perg_akt_version = 1;'||unistr('\000a')||
'--mel.p(''FB-korr:%1'',v_prot_id,''TEST'',''but_auswertung loeschen'',frgbg_s.check_fas_rolle(:APP_USER,''FB_KORRIGIEREN''));   '||unistr('\000a')||
'   -- NEI 30.07.13 korrigieren nur innerhalb eines Tages möglich'||unistr('\000a')||
'   SELECT mutdat into v_last_mutdat '||unistr('\000a')||
'   FROM pergebnisse '||unistr('\000a')||
'   WHERE id =  :p1_pergebnis_id;'||unistr('\000a')||
'   IF (trunc(v_last_mutdat + 1.5) < trunc(sysdate) AND APEX_APPLICATION.g_edit_cookie_session_id IS NULL) AND'||unistr('\000a')||
'      frgbg_s.check_fas_rolle(:APP_USER,''FB_KORRIGIEREN'') = 0 THEN '||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- SAL 24.12.2013 korrigieren nur noch wenn die Modulauswahl gültig ist. '||unistr('\000a')||
'   select count(*) into v_anz_module'||unistr('\000a')||
'   from PERGEBNIS_MODUL_AUSWAHL'||unistr('\000a')||
'   where  PERGEBNIS_ID = :P1_PERGEBNIS_ID'||unistr('\000a')||
'          and FKAT_MODUL_ID not in( -- Hole Alle Module die der Benutzer verwenden darf'||unistr('\000a')||
'            SELECT ow.wert modul_id'||unistr('\000a')||
'            FROM optionswerte ow, pers_optionen po, optionstypen ot, PERGEBNIS_MODUL_AUSWAHL pma'||unistr('\000a')||
'            where ow.opttyp_id = ot.id  -- JOIN OT '||unistr('\000a')||
'              and ow.opttyp_id = 39     -- Zusatzmodule '||unistr('\000a')||
'              and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'              and ow.wert = po.wert'||unistr('\000a')||
'              and pma.pergebnis_id = :P1_PERGEBNIS_ID'||unistr('\000a')||
'              and pma.FKAT_MODUL_ID = ow.wert'||unistr('\000a')||
'               -- Eingeloggte Identität'||unistr('\000a')||
'              and (po.persstamm_id = frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                    FRGBG_S.GET_IDENTITAET_BETR(:FAS_LOGIN_PERSONENSTAMM_ID)) -- Rechte bezogen auf eingeloggte Person'||unistr('\000a')||
'                -- Aktive Identität'||unistr('\000a')||
'                or po.persstamm_id = frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                     :fas_identitaet_persstamm_id) -- Rechte bezogen auf Identität'||unistr('\000a')||
'              )'||unistr('\000a')||
'          );'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   if(v_anz_module > 0) then'||unistr('\000a')||
'     return FALSE; -- Es gibt ungültige Module, damit darf der Fragebogen nicht mehr kopiert werden.'||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_anz > 0 and -- akt. Antwortset und akt. FB-Version'||unistr('\000a')||
'      :fas_pers_aenderbar = 1 and -- Pers.Daten änderbar '||unistr('\000a')||
'      :FAS_AUFGERUFEN_VON in (''BETREUER'')'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz > 0'||unistr('\000a')||
'      THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'      ELSE RETURN FALSE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'  ELSIF v_anz > 0 and -- akt. Antwortset und akt. FB-Version'||unistr('\000a')||
'      :fas_pers_aenderbar = 1 and -- Pers.Daten änderbar '||unistr('\000a')||
'      :FAS_AUFGERUFEN_VON in (''KUNDE'') AND '||unistr('\000a')||
'      frgbg_s.check_fas_rolle(:APP_USER,'||unistr('\000a')||
'                             ''FB_GUTSCHEINVERFAHREN'') > 0 '||unistr('\000a')||
'  THEN'||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
''||unistr('\000a')||
'      -- Noch Gutscheine vorhanden?'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT min(gutscheinanzahl) INTO v_anz_gutschein'||unistr('\000a')||
'         FROM personenstamm'||unistr('\000a')||
'         WHERE id = :p95_personenstamm_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'          v_anz_gutschein := 0;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'      IF v_anz_gutschein > 0 AND v_anz > 0 THEN'||unistr('\000a')||
'         RETURN TRUE;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         RETURN FALSE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     RETURN FALSE;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5815026339192068 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 95,
  p_button_sequence=> 16,
  p_button_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_button_name    => 'MN_REZEPT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P95_BL_REZEPT.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'   v_anz_gutschein NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p1_bearb_modus = ''BEARBEITEN'' THEN'||unistr('\000a')||
'      -- Auswertung vorhanden?'||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
'      IF v_anz > 0'||unistr('\000a')||
'      THEN RETURN FALSE; -- Auswertung vorhanden '||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         IF :FAS_AUFGERUFEN_VON in (''KUNDE'') AND'||unistr('\000a')||
'            frgbg_s.check_fas_rolle(:APP_USER,'||unistr('\000a')||
'                             ''FB_GUTSCHEINVERFAHREN'') > 0 '||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            -- Noch Gutscheine vorhanden?'||unistr('\000a')||
'            BEGIN'||unistr('\000a')||
'               SELECT min(gutscheinanzahl) '||unistr('\000a')||
'               INTO v_anz_gutschein'||unistr('\000a')||
'               FROM personenstamm'||unistr('\000a')||
'               WHERE id = :p95_personenstamm_id;'||unistr('\000a')||
'            EXCEPTION'||unistr('\000a')||
'            WHEN others THEN'||unistr('\000a')||
'               v_anz_gutschein := 0;'||unistr('\000a')||
'            END;'||unistr('\000a')||
'            IF v_anz_gutschein > 0 THEN'||unistr('\000a')||
'               RETURN TRUE;'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               RETURN FALSE;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            RETURN TRUE;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_button_cattributes=>'class="MN_REZEPT_WAIT"',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3643605036967564 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 95,
  p_button_sequence=> 17,
  p_button_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_button_name    => 'BESTELLEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P95_BL_BESTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_gutscheinstatus personenstamm.gutscheinstatus%TYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT min(gutscheinstatus) into v_gutscheinstatus'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :p95_personenstamm_id;'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''KUNDE'' AND   -- Kunde meldet sich direkt an USER_ACCOUNT=APP_USER'||unistr('\000a')||
'      frgbg_s.check_fas_rolle(:APP_USER,  -- Gutscheinverfahren'||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0 AND'||unistr('\000a')||
'      frgbg_s.FB_CHECK_AUSWERTUNG         -- Auswertung vorhanden?'||unistr('\000a')||
'         (:p1_pergebnis_id) > 0 AND '||unistr('\000a')||
'      v_gutscheinstatus = 2               -- Auswertung wurde gestartet'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      RETURN TRUE;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5821917654192104 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:95:&SESSION.:OPT_CHANGE:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request = ''OPT_CHANGE''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 14-DEZ-2009 15:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>5822129510192107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_branch_name=> '',
  p_branch_action=> 'DOKUMENTEN_DRUCK.MN_I_BERICHT?P_PERGEBNIS_ID=&P1_PERGEBNIS_ID.&P_BETREUER_ID=&FAS_LOGIN_PERSONENSTAMM_ID.&P_DRUCKOPTION=:&P95_DRUCKOPTION_NOSAVE.:&P_IDENT_ID=&FAS_IDENTITAET_PERSSTAMM_ID.&P_APO_ID=&P95_PERSSTAMM_ID_PROD_APO.&P_PREISLISTE_ID=&P95_PREISLISTE_ID.&P_VERRECH_LAND_ID=&P95_VERRECH_LAND_ID.&P_ART_MWST_TYP_ID=&P95_ART_MWST_TYP_ID.&P_PREISFAKTOR=&P95_PREISFAKTOR.&P_MODUS=&P95_DRUCKMODUS.&P_FAS_SCHEMA_ID=&FAS_SCHEMA_ID.'||unistr('\000a')||
'',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 20,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':P95_DRUCKOPTION_NOSAVE is not null and '||unistr('\000a')||
'( :request = ''AUSWERTUNG_DRUCKEN'' OR '||unistr('\000a')||
' (:fas_aufgerufen_von in (''ANONYM'',''KUNDE'') AND :request = ''MN_REZEPT'')'||unistr('\000a')||
')'||unistr('\000a')||
'and 1=2 /* Ersetzt durch Druck MNR-Bericht Prozess */',
  p_save_state_before_branch_yn=>'N',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset,
  p_branch_comment=> 'Created 03-DEZ-2007 14:50 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>3648118466346178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:95:&SESSION.:BESTELLHINWEIS:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3643605036967564+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 110,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BESTELLEN'') and :p95_bestellhinweis is not null',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 14-MRZ-2008 11:36 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4129407113785838 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:95:&SESSION.:HRV_MELDUNG:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 120,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''MN_REZEPT'',''AUSWERTUNG_LOESCHEN'') and :p95_hrv_meldung is not null',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 14-MRZ-2008 11:36 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>5822302570192107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1000,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3644921533839241 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BL_BESTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 63,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3648005606314095 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BESTELLHINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 940,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4129201656765339 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_HRV_MELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 950,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5047508849289198 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_GROESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 980,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5047716121291323 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_GEWICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 990,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5313227067436046 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_DRUCK_OPTIONEN_CHECKED',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 737,
  p_item_plug_id => 8253802822364066+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => 'Merkt sich welche Druckoptione ausgewählt wurden. ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5332727223365542 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_LABOR_WARENKORB_IDS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 727,
  p_item_plug_id => 8253802822364066+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5596825836511734 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_REZEPTREICHWEITE_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'to_number(frgbg_s.get_pers_option(:APP_USER,37),''99999999'')'||unistr('\000a')||
'',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT DECODE(ow.bezeichnung_text_id,NULL'||unistr('\000a')||
'          ,to_char(ow.wert,''FM99999'')'||unistr('\000a')||
'       ,fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id)) a'||unistr('\000a')||
'                                      ,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 37 /* Rezeptreichweite*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = to_number(po.wert ,''99999999.99999999'')'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id)'||unistr('\000a')||
'          /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT DECODE(ow.bezeichnung_text_id,NULL'||unistr('\000a')||
'          ,to_char(ow.wert,''FM99999'')'||unistr('\000a')||
'       ,fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id)) a,'||unistr('\000a')||
'       ow.wert'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 37 /* Rezeptkosten */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 2'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'BEGIN'||unistr('\000a')||
'   /* NEI 09.08.13 Endkunden-Login Keine Reichweitenauswahl und auch nicht anzeigen'||unistr('\000a')||
'      => sondern nur Default-Vorgabe (opttyp_id=7) für das Kostenset (opttyp_id = 37) vorbelegen */'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON in (''BETREUER'') THEN '||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;'||unistr('\000a')||
'',
  p_display_when_type=>'FUNCTION_BODY',
  p_read_only_when=>'DECLARE'||unistr('\000a')||
'    v_anz    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'-- Bestimmen der Anzahl der Rezeptkosten-Einträge in Auswahlliste'||unistr('\000a')||
'SELECT count(*) into v_anz'||unistr('\000a')||
'from ('||unistr('\000a')||
'SELECT  ow.id'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 37 /* Rezeptkosten*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = to_number(po.wert ,''99999999.99999999'')'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id)'||unistr('\000a')||
'          /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT ow.id'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 37 /* Rezeptkosten */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
' ) ;'||unistr('\000a')||
'IF v_anz = 1 THEN -- Nur ein Wert => Schreibgeschützt keine Auswahl'||unistr('\000a')||
'   RETURN true;'||unistr('\000a')||
'ELSE              -- Sonst Auswahlliste'||unistr('\000a')||
'   RETURN FALSE;'||unistr('\000a')||
'END IF;'||unistr('\000a')||
'end;',
  p_read_only_when_type=>'FUNCTION_BODY',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '1',
  p_attribute_02 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5598532396412451 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_EINSTELLUNGSTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(7918,:fas_sprache_id);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'style="font-weight: bold;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 6,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5602708012932689 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BUT_MNR_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'MN_REZEPT',
  p_prompt=>'&P95_BL_REZEPT.',
  p_source=>'MN_REZEPT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image_attr=> 'class="MN_REZEPT_WAIT"',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'   v_anz_gutschein NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p1_bearb_modus = ''BEARBEITEN'' THEN'||unistr('\000a')||
'      -- Auswertung vorhanden?'||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
'      IF v_anz > 0'||unistr('\000a')||
'      THEN RETURN FALSE; -- Auswertung vorhanden '||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         IF :FAS_AUFGERUFEN_VON in (''KUNDE'') AND'||unistr('\000a')||
'            frgbg_s.check_fas_rolle(:APP_USER,'||unistr('\000a')||
'                             ''FB_GUTSCHEINVERFAHREN'') > 0 '||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            -- Noch Gutscheine vorhanden?'||unistr('\000a')||
'            BEGIN'||unistr('\000a')||
'               SELECT min(gutscheinanzahl) '||unistr('\000a')||
'               INTO v_anz_gutschein'||unistr('\000a')||
'               FROM personenstamm'||unistr('\000a')||
'               WHERE id = :p95_personenstamm_id;'||unistr('\000a')||
'            EXCEPTION'||unistr('\000a')||
'            WHEN others THEN'||unistr('\000a')||
'               v_anz_gutschein := 0;'||unistr('\000a')||
'            END;'||unistr('\000a')||
'            IF v_anz_gutschein > 0 THEN'||unistr('\000a')||
'               RETURN TRUE;'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               RETURN FALSE;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            RETURN TRUE;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_display_when_type=>'FUNCTION_BODY',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5603228706957584 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BUT_AUSWERTUNG_NEUES_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'AUSWERTUNG_NEUES_REZEPT',
  p_prompt=>'&P95_BL_AUSWERTUNG_NEUES_REZEPT.',
  p_source=>'AUSWERTUNG_NEUES_REZEPT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image_attr=> 'class="MN_REZEPT_WAIT"',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /*SELECT count(*) into v_anz'||unistr('\000a')||
'    FROM mn_rezepte'||unistr('\000a')||
'    WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'      and satz_kennzeichen is null;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON in (''BETREUER'') THEN'||unistr('\000a')||
'      -- Auswertung vorhanden'||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
'      IF v_anz > 0'||unistr('\000a')||
'      THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'      ELSE RETURN FALSE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_display_when_type=>'FUNCTION_BODY',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5815823889192071 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 920,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Prod Apo',
  p_source=>'frgbg_s.get_pers_option(v(''APP_USER''),21)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5816006461192078 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_AUSGABE_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 900,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ausgabe',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT ''Vorabkopie'' a, 0 b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''Originaldruck'' a, 1 b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''per Email an Patient'' a, 2 b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''per Email an Therapeut'' a, 3 b from dual'||unistr('\000a')||
'order by 2',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'DECLARE  /* Fkt die booleschen Wert zurückgibt */'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT count(*) into v_anz'||unistr('\000a')||
'   FROM mn_rezepte'||unistr('\000a')||
'   WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'     and satz_kennzeichen is null;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_anz > 0'||unistr('\000a')||
'   THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'   ELSE RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'NONE',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5816213014192079 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_PREISLISTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 800,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisliste Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5816416722192079 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 810,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5816626780192079 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_AUSGABESPRACHE_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 890,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> ':P1_APP_SPRACHE_ID',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Ausgabesprache',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select s.sprache display_value, s.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs '||unistr('\000a')||
'where fs.id = :fas_pers_schema_id'||unistr('\000a')||
'  and fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  --and s.sprache_id in (select sprache_id from uebersetzungen) -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'%',
  p_lov_null_value=> '%null%',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'DECLARE   /* FKt die booleschen Wert zurückgibt */'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT count(*) into v_anz'||unistr('\000a')||
'   FROM mn_rezepte'||unistr('\000a')||
'   WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'     and satz_kennzeichen is null;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_anz > 0'||unistr('\000a')||
'   THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'   ELSE RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5816830664192081 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_ART_MWST_TYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 820,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisliste Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5817005766192081 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_WAEHRUNG_ZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 725,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'BEGIN'||unistr('\000a')||
'   /* NEI 04.10.11 Endkunden-Login Keine Kostenauswahl und auch nicht anzeigen'||unistr('\000a')||
'      => Waehrung auch ausblenden */'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON = ''BETREUER'' THEN '||unistr('\000a')||
'      RETURN TRUE;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;'||unistr('\000a')||
'',
  p_display_when_type=>'FUNCTION_BODY',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5817216339192081 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_VERRECHNUNGSLAND',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 750,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrechnungsland',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5817432366192081 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_REZEPTKOSTEN_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'rezepte.calc_preis_runden('||unistr('\000a')||
'    rezepte.umrechnen_waehrung('||unistr('\000a')||
'           to_number(frgbg_s.get_pers_option(:APP_USER,17),''99999999.99999999''),'||unistr('\000a')||
'              1,27,:p95_waehrung_id),NULL,10)',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'"SET_ITEM_LABEL"  (&P95_WAEHRUNG_ZEICHEN.)',
  p_post_element_text=>'&#160&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT DECODE(ow.bezeichnung_text_id,NULL'||unistr('\000a')||
'          ,to_char(rezepte.calc_preis_runden('||unistr('\000a')||
'             rezepte.umrechnen_waehrung('||unistr('\000a')||
'               ow.wert,1,27,:p95_waehrung_id),NULL,10),''FM99999D00'')'||unistr('\000a')||
'       ,fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id)) a'||unistr('\000a')||
'                                      ,'||unistr('\000a')||
'       rezepte.calc_preis_runden('||unistr('\000a')||
'             rezepte.umrechnen_waehrung('||unistr('\000a')||
'                ow.wert,1,27,:p95_waehrung_id),NULL,10) b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 17 /* Rezeptkosten*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = to_number(po.wert ,''99999999.99999999'')'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id)'||unistr('\000a')||
'          /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT DECODE(ow.bezeichnung_text_id,NULL'||unistr('\000a')||
'          ,to_char(rezepte.calc_preis_runden('||unistr('\000a')||
'             rezepte.umrechnen_waehrung('||unistr('\000a')||
'                ow.wert,1,27,:p95_waehrung_id),NULL,10),''FM99999D00'')'||unistr('\000a')||
'       ,fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id)) a,'||unistr('\000a')||
'       rezepte.calc_preis_runden('||unistr('\000a')||
'             rezepte.umrechnen_waehrung('||unistr('\000a')||
'                ow.wert,1,27,:p95_waehrung_id),NULL,10)'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 17 /* Rezeptkosten */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 2'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'BEGIN'||unistr('\000a')||
'   /* NEI 04.10.11 Endkunden-Login Keine Kostenauswahl und auch nicht anzeigen'||unistr('\000a')||
'      => sondern nur Default-Vorgabe (opttyp_id=25) für das Kostenset (opttyp_id = 17) vorbelegen */'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON in (''BETREUER'') THEN '||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;'||unistr('\000a')||
'',
  p_display_when_type=>'FUNCTION_BODY',
  p_read_only_when=>'DECLARE'||unistr('\000a')||
'    v_anz    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'-- Bestimmen der Anzahl der Rezeptkosten-Einträge in Auswahlliste'||unistr('\000a')||
'SELECT count(*) into v_anz'||unistr('\000a')||
'from ('||unistr('\000a')||
'SELECT  ow.id'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 17 /* Rezeptkosten*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = to_number(po.wert ,''99999999.99999999'')'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id)'||unistr('\000a')||
'          /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT ow.id'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 17 /* Rezeptkosten */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
' ) ;'||unistr('\000a')||
'IF v_anz = 1 THEN -- Nur ein Wert => Schreibgeschützt keine Auswahl'||unistr('\000a')||
'   RETURN true;'||unistr('\000a')||
'ELSE              -- Sonst Auswahlliste'||unistr('\000a')||
'   RETURN FALSE;'||unistr('\000a')||
'END IF;'||unistr('\000a')||
'end;',
  p_read_only_when_type=>'FUNCTION_BODY',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '1',
  p_attribute_02 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5817626388192082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 730,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Währung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5817808144192082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_DRUCKOPTION_NOSAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 757,
  p_item_plug_id => 8253802822364066+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'DECLARE'||unistr('\000a')||
'   v_text   VARCHAR2(100);'||unistr('\000a')||
'   CURSOR c_opt is'||unistr('\000a')||
'/*     select wert'||unistr('\000a')||
'     from optionswerte'||unistr('\000a')||
'     where opttyp_id = 18'||unistr('\000a')||
'       and standard = 1'||unistr('\000a')||
'     order by sortierung desc;'||unistr('\000a')||
'*/'||unistr('\000a')||
'SELECT ow.wert '||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 18 /* Druckoption */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'  and ((ow.wert = 9 and FRGBG_S.FB_IST_INHSTOFF_VORH(:P1_PERGEBNIS_ID) > 0) /* Laborparameter vorhanden */'||unistr('\000a')||
'        or (ow.wert = 10 and HRV_TABLE.exist_auswertung_hrv(:P1_PERGEBNIS_ID) > 0) /* HRV vorhanden */'||unistr('\000a')||
'        or ow.wert not in(9,10)) '||unistr('\000a')||
'  and ((:P95_DRUCK_OPTIONEN_CHECKED is null AND po.standard = 1) -- Merkt sich die Auswahl beim Absenden der Seite'||unistr('\000a')||
'     or  instr(:P95_DRUCK_OPTIONEN_CHECKED,'':'' || ow.wert || '':'') > 0'||unistr('\000a')||
'  )'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT ow.wert '||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 18 /* Druckoption*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'   and ((ow.wert = 9 and FRGBG_S.FB_IST_INHSTOFF_VORH(:P1_PERGEBNIS_ID) > 0) /* Laborparameter vorhanden */'||unistr('\000a')||
'        or (ow.wert = 10 and HRV_TABLE.exist_auswertung_hrv(:P1_PERGEBNIS_ID) > 0) /* HRV vorhanden */'||unistr('\000a')||
'        or ow.wert not in(9,10)) '||unistr('\000a')||
'   and ((:P95_DRUCK_OPTIONEN_CHECKED is null AND ow.standard = 1) '||unistr('\000a')||
'     or  instr(:P95_DRUCK_OPTIONEN_CHECKED,'':'' || ow.wert || '':'') > 0'||unistr('\000a')||
'  );'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_opt in c_opt LOOP'||unistr('\000a')||
'       v_text := r_opt.wert||'':''||v_text;'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   RETURN v_text;'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_CHECKBOX',
  p_lov=> 'select a, b'||unistr('\000a')||
'from ('||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id)'||unistr('\000a')||
'       || case when ow.wert = 9 and frgbg_s.check_fas_rolle(:APP_USER,''WK_LABOR_VERWALTEN'') = 1 then -- Laborauswahl Modalfenster'||unistr('\000a')||
'          '' <a href="'' || APEX_UTIL.PREPARE_URL(''f?p='' || :APP_ID || '':97:'' || :APP_SESSION'||unistr('\000a')||
'            || ''::NO:::'') || ''" onclick="return false;" class="labor_auftragauswahl"><img src="#IMAGE_PREFIX#list.gif" alt="" /></a>'' ||'||unistr('\000a')||
'          ( select replace('' ('' || listagg(LABOR_AUFTRAG_ID,'','') within group (order by labor_auftrag_id) || '')'','' ()'','''')'||unistr('\000a')||
'            from ( -- Liste alle ausgewählten Laboraufträge auf'||unistr('\000a')||
'                select distinct LABOR_AUFTRAG_ID'||unistr('\000a')||
'                from warenkorb_Details wd, warenkoerbe wk'||unistr('\000a')||
'                where warenkorb_id in('||unistr('\000a')||
'                     select to_number(REGEXP_SUBSTR (txt, ''[^,:]+'', 1, level))  value'||unistr('\000a')||
'                     from (select :P95_LABOR_WARENKORB_IDS as txt from dual)'||unistr('\000a')||
'                     connect by level <= length(regexp_replace(txt,''[^,:]*''))+1'||unistr('\000a')||
'                  )'||unistr('\000a')||
'                  and wk.id = wd.warenkorb_id'||unistr('\000a')||
'                  and wk.PERSSTAMM_ID_KUNDE = :P1_ID'||unistr('\000a')||
'            ))'||unistr('\000a')||
'        else null end  a,'||unistr('\000a')||
'       ow.wert b ,sortierung c'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 18 /* Druckoption */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and ((ow.wert = 9 and FRGBG_S.FB_IST_INHSTOFF_VORH(:P1_PERGEBNIS_ID) > 0) /* Laborparameter vorhanden */'||unistr('\000a')||
'        or (ow.wert = 10 and HRV_TABLE.exist_auswertung_hrv(:P1_PERGEBNIS_ID) > 0) /* HRV vorhanden */'||unistr('\000a')||
'        or ow.wert not in(9,10))'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
''||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b   ,sortierung  c'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 18 /* Druckoption*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and ((ow.wert = 9 and FRGBG_S.FB_IST_INHSTOFF_VORH(:P1_PERGEBNIS_ID) > 0) /* Laborparameter vorhanden */'||unistr('\000a')||
'        or (ow.wert = 10 and HRV_TABLE.exist_auswertung_hrv(:P1_PERGEBNIS_ID) > 0) /* HRV vorhanden */'||unistr('\000a')||
'        or ow.wert not in(9,10))'||unistr('\000a')||
'order by c'||unistr('\000a')||
');',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onChange="javascript:check_checkbox(''P95_DRUCKOPTION_NOSAVE'',''&P95_DRUCKOPT_INFO.'') " class="druckoption_checkbox"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'DECLARE'||unistr('\000a')||
'   v_anz NUMBER := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* NEI 04.10.11 Endkunden-Login Keine Druckauswahl und auch nicht anzeigen */'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON = ''BETREUER'' THEN '||unistr('\000a')||
'      /*SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM mn_rezepte'||unistr('\000a')||
'      WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'        and satz_kennzeichen is null;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_anz:= frgbg_s.FB_CHECK_AUSWERTUNG(:p1_pergebnis_id);'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz > 0'||unistr('\000a')||
'      THEN RETURN TRUE; /*Rezept vorhanden */'||unistr('\000a')||
'      ELSE RETURN FALSE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN false;'||unistr('\000a')||
'END;',
  p_display_when_type=>'FUNCTION_BODY',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'VERTICAL',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5818004854192082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_PREISFAKTOR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 830,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisfaktor',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5818213925192082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BL_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rezept',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5818420894192082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BL_DEL_AUSWERTUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 52,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Löschen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5818627378192084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BL_AUSWERTUNG_DRUCKEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 54,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rezept',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5818832002192084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BL_AUSWERTUNG_NEUES_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 58,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rezept',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5819019393192084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BL_AUSWERTUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Auswertung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5819229175192084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BL_KOPIEREN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 62,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rezept',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5819415994192084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_BL_KOPIEREN0',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 62,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rezept',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5819630299192084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_REGION_TITEL_AUSWERTUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 64,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Hilfetexte',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5819805970192084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_DRUCKOPT_INFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 900,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Druckopt Info',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5922717956427934 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_PERSONENSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Personenstamm Id',
  p_source=>'P1_ID',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5922901857427934 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_post_element_text=>'&#160&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'style="font-weight: bold;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5923103627427935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_post_element_text=>'&#160&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'style="font-weight: bold;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5923308669427935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'style="font-weight: bold;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5923521215427935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_PAGE_TITEL_PATIENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6339205178433498 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_DRUCKMODUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 930,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Druckmodus',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6775501140839126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_PERGEBNIS_ID_SHOW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 15,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'''Pergebnis-ID: ''||:P1_PERGEBNIS_ID||'', FAS-ID:''||:P1_ID',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'APEX_APPLICATION.g_edit_cookie_session_id IS NOT NULL OR frgbg_s.check_fas_rolle(:APP_USER,''FB_META_DATEN_SICHTBAR'') = 1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7477821531665335 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_HRV_CREDITS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select'||unistr('\000a')||
'    case when NVL(HRV_CREDITS_AKTUELL,0) = 1 then'||unistr('\000a')||
'        -- Nur noch ein HRV Credit vorhanden'||unistr('\000a')||
'        frgbg_s.HOLEN_UEBERSETZUNG(9450,:FAS_SPRACHE_ID)'||unistr('\000a')||
''||unistr('\000a')||
'    when NVL(HRV_CREDITS_AKTUELL,0) > 5 then'||unistr('\000a')||
'        -- %0 HRV Credits vorhanden'||unistr('\000a')||
'        frgbg_s.HOLEN_UEBERSETZUNG(9447,:FAS_SPRACHE_ID,HRV_CREDITS_AKTUELL)'||unistr('\000a')||
'    when NVL(HRV_CREDITS_AKTUELL,0) <= 5 and NVL(HRV_CREDITS_AKTUELL,0) > 1 then'||unistr('\000a')||
'        -- nur noch %0 Credits vorhanden'||unistr('\000a')||
'        frgbg_s.HOLEN_UEBERSETZUNG(9452,:FAS_SPRACHE_ID,HRV_CREDITS_AKTUELL)'||unistr('\000a')||
'    else'||unistr('\000a')||
'        -- Keine Credits vorhanden'||unistr('\000a')||
'        frgbg_s.HOLEN_UEBERSETZUNG(9448,:FAS_SPRACHE_ID)'||unistr('\000a')||
'    end  text_credits'||unistr('\000a')||
'    from frgbg.PERS_IDENTITAET_PROPS pers_prod'||unistr('\000a')||
'    where'||unistr('\000a')||
'        pers_prod.PERSSTAMM_ID =FRGBG_S.GET_IDENTITAET_KUNDE (NULL,-1,:P95_PERSONENSTAMM_ID)',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap" ',
  p_tag_attributes  => 'style="padding-left:10px;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'FRGBG_HRV.FB_HRV_FKAT_MODUL_EXISTS(:P1_PERGEBNIS_ID) = 1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8254229628456972 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_REGION_TITEL_DRUCKEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 65,
  p_item_plug_id => 5814223606192060+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8255030198523396 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 95,
  p_name=>'P95_LETZTE_PERGAUSWERTUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5922205686427932+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'style="font-weight: bold;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 16,
  p_rowspan=> 2,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'P95_LETZTE_PERGAUSWERTUNG',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5085019863176940 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_gen_neues_rezept_moeglich',
  p_validation_sequence=> 50,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_dat   date;'||unistr('\000a')||
'   v_dat_fb_neu  date;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT mutdat into v_dat'||unistr('\000a')||
'   from pergebnisse'||unistr('\000a')||
'   where id = :p1_pergebnis_id;'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT to_date(parameter,''DD.MM.YYYY hh24:mi'') into v_dat_fb_neu'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 30;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF v_dat <= v_dat_fb_neu THEN -- Neue Auswertung nötig'||unistr('\000a')||
'      -- Neue Auswertung erzwingen nur neues Rezept geht nicht'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(6656,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 5814406799192062 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5820130885192092 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_pflichtige_persfelder',
  p_validation_sequence=> 180,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_pruefbedingung NUMBER;'||unistr('\000a')||
'   v_geburtsdatum   personenstamm.geburtsdatum%TYPE;'||unistr('\000a')||
'   v_anrede_id      personenstamm.anrede_id%TYPE;'||unistr('\000a')||
'   v_groesse        personenstamm.groesse%TYPE;'||unistr('\000a')||
'   v_gewicht        personenstamm.gewicht%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'   v_text           VARCHAR2(10);'||unistr('\000a')||
'   v_fehlertext     VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT pruefbedingung INTO v_pruefbedingung'||unistr('\000a')||
'   FROM fragebogen'||unistr('\000a')||
'   WHERE id = :p1_fragebogen_id;'||unistr('\000a')||
'   SELECT geburtsdatum,anrede_id,groesse,gewicht '||unistr('\000a')||
'   into v_geburtsdatum, v_anrede_id,v_groesse,v_gewicht '||unistr('\000a')||
'   from personenstamm'||unistr('\000a')||
'   where id = :p1_id;'||unistr('\000a')||
'   IF v_pruefbedingung = 1 THEN'||unistr('\000a')||
'      IF v_geburtsdatum IS NULL THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(212,:fas_sprache_id))||'' ''||frgbg_s.holen_uebersetzung(4893,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_gewicht IS NULL THEN'||unistr('\000a')||
'         v_fehlertext := v_fehlertext||''<br/>''|| '||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(2151,:fas_sprache_id))||'' ''||frgbg_s.holen_uebersetzung(7523,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_groesse IS NULL THEN'||unistr('\000a')||
'         v_fehlertext := v_fehlertext||''<br/>''||'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(4,:fas_sprache_id))||'' ''||frgbg_s.holen_uebersetzung(7523,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_anrede_id is null OR '||unistr('\000a')||
'         v_anrede_id not in (3,4) -- Gültige Werte Mann/Frau'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         v_text :=   '||unistr('\000a')||
'          fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',3,:fas_sprache_id)'||unistr('\000a')||
'          ||''/''||'||unistr('\000a')||
'         fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',4,:fas_sprache_id);'||unistr('\000a')||
'         v_fehlertext := v_fehlertext||''<br/>''||'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(2973,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(204,:fas_sprache_id),v_text)||'' ''||frgbg_s.holen_uebersetzung(4894,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_fehlertext is not null THEN'||unistr('\000a')||
'         RETURN(v_fehlertext);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':p1_pergebnis_id is not null and :request = ''MN_REZEPT''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3613921180647145 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_pflichtige_plz',
  p_validation_sequence=> 190,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_fehlertext     VARCHAR2 (2000):= NULL;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :FAS_AUFGERUFEN_VON = ''ANONYM'' AND '||unistr('\000a')||
'      :P1_PLZ is null '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Angabe der PLZ ist pflichtig, damit eine sinnvolle Apotheken-Liste ...'';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(4895,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN v_fehlertext;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':p1_pergebnis_id is not null and :request = ''MN_REZEPT'' AND '||unistr('\000a')||
':FAS_AUFGERUFEN_VON = ''ANONYM''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5820327091192095 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_pflichtige_antworten',
  p_validation_sequence=> 200,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT count(*) INTO v_anz'||unistr('\000a')||
'   FROM v_alle_fragen'||unistr('\000a')||
'   WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'     and ((frage_eingabepflichtig=1 and status=2) -- unbeantw.pflichtige Fragen'||unistr('\000a')||
'          or'||unistr('\000a')||
'          (frage_eingabepflichtig=1 and status = 0)  -- unvollständig beantwortete pflichtige Fragen'||unistr('\000a')||
'         )'||unistr('\000a')||
'     and frage_fragelevel = 0 /* Keine Metafragen */'||unistr('\000a')||
'     and frage_visible = 1    /* nur angezeigte Fragen prüfen */'||unistr('\000a')||
'   ;'||unistr('\000a')||
'   if v_anz = 0 and FRGBG_HRV.FB_HRV_FKAT_MODUL_EXISTS(:p1_pergebnis_id) = 1 and FRGBG_HRV.FB_EXIST_HRV_DATEI(:p1_pergebnis_id) = false then'||unistr('\000a')||
'       v_anz := 1; -- Stellt sicher das eine HRV vorhanden ist, wenn das HRV Tab aktiv ist.'||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_anz > 0 THEN'||unistr('\000a')||
'      -- RETURN (''Der Fragebogen ist noch nicht komplett ausgefüllt! Bitte auf der Übersichtsseite kontrollieren!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(1665,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(245,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':p1_pergebnis_id is not null and :request = ''MN_REZEPT''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4254907210873835 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_auswertung_loeschen',
  p_validation_sequence=> 220,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_return    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_return := frgbg_s.FB_CHECK_MNR_BESTELLUNG(:P1_PERGEBNIS_ID);'||unistr('\000a')||
'   IF v_return < 0 THEN'||unistr('\000a')||
'      --RETURN ''Die Prüfung, ob bereits eine Bestellung zu dem Fragebogen durchgeführt wurde, konnte nicht durchgeführt werden! Interner Fehler bitte melden.'';'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(4878,:fas_sprache_id,'''','''');'||unistr('\000a')||
'   ELSIF v_return > 0 THEN'||unistr('\000a')||
'      -- RETURN ''Der Fragebogen kann nicht mehr korrigiert werden, da bereits eine Bestellung eines MN-Rezepts vorliegt! Bitte kopieren sie den Fragebogen und führen Sie dort ihre Änderungen durch.'';'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5578,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 5815228789192070 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 3803808460097886 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_name => 'start_show_waiting_img'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.MN_REZEPT_WAIT'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 3804101688097886 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 3803808460097886 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM.AAW.LOADINGICON'
 ,p_attribute_01 => 'START'
 ,p_attribute_02 => '...waiting...'
 ,p_attribute_03 => 'ajax-loader.gif'
 ,p_attribute_04 => '32'
 ,p_attribute_05 => '32'
 ,p_attribute_06 => '8'
 ,p_attribute_07 => '#98AAC8'
 ,p_attribute_08 => '6'
 ,p_stop_execution_on_error => 'Y'
 ,p_da_action_comment => '#IMAGE_PREFIX#themes/&FAS_THEME_NAME./ajax-loader.gif'||unistr('\000a')||
''||unistr('\000a')||
'default'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7455830779363971 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_name => 'Druck Auswertung'
 ,p_event_sequence => 30
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 5814622354192068 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7456107031363997 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 7455830779363971 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'AUSWERTUNG_DRUCKEN'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8893521199940504 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_name => 'Submit Page Button: KOPIEREN'
 ,p_event_sequence => 40
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 5814826756192068 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 8893808354940517 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 8893521199940504 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'KOPIEREN'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8894002630944623 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_name => 'Submit Page Button: KOPIEREN0'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 5815406789192070 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 8894332280944623 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 8894002630944623 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'KOPIEREN0'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8894510164965676 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_name => 'Submit Page Button: AUSWERTUNG_LOESCHEN'
 ,p_event_sequence => 60
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 5815228789192070 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 8894819544965680 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 8894510164965676 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'AUSWERTUNG_LOESCHEN'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8895102340048627 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_name => 'Submit Page Button: AUSWERTUNG_NEUES_REZEPT'
 ,p_event_sequence => 70
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 5814406799192062 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 8895404602048627 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 8895102340048627 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'AUSWERTUNG_NEUES_REZEPT'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5313427140484527 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_name => 'Merke Druckoptionen Auswahl'
 ,p_event_sequence => 80
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.druckoption_checkbox'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5313715194484529 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 5313427140484527 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'var val = "";'||unistr('\000a')||
'// Ermittle welche Druckoptionen ausgewählt wurden und merke die Auswahl damit beim Submit'||unistr('\000a')||
'// Immer noch die ausgewählten Druckoptionen ausgewählt sind'||unistr('\000a')||
'$(''input[type=checkbox].druckoption_checkbox'').each(function()'||unistr('\000a')||
'{'||unistr('\000a')||
'   $this = $(this);'||unistr('\000a')||
''||unistr('\000a')||
'   if($this.is('':checked'')) {'||unistr('\000a')||
'     if(val.length == 0) {'||unistr('\000a')||
'       val = $this.val();'||unistr('\000a')||
'     } else {'||unistr('\000a')||
'       val = val + ":" + $this.val();'||unistr('\000a')||
'     }'||unistr('\000a')||
'   }'||unistr('\000a')||
'});'||unistr('\000a')||
''||unistr('\000a')||
'$s(''P95_DRUCK_OPTIONEN_CHECKED'',":" + val + ":");'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5314620067560819 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 5313427140484527 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin'||unistr('\000a')||
'  -- Damit auch nach dem Seiten-Submit die Information welche'||unistr('\000a')||
'  -- Checkboxen ausgewählt wurden vorhanden ist. '||unistr('\000a')||
'  :P95_DRUCK_OPTIONEN_CHECKED := :P95_DRUCK_OPTIONEN_CHECKED;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P95_DRUCK_OPTIONEN_CHECKED'
 ,p_attribute_03 => 'P95_DRUCK_OPTIONEN_CHECKED'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'N'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5323518649844568 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_name => 'öffne Modal Fenster - Laborauftrag Auswahl'
 ,p_event_sequence => 90
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.labor_auftragauswahl'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5323822814844569 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 5323518649844568 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_attribute_02 => 'TRIG_ELEMENT_ATTR'
 ,p_attribute_05 => 'href'
 ,p_attribute_06 => 'div#MESSAGE.t1success'
 ,p_attribute_07 => 'AUTO'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5323902504849433 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_name => 'schliesse Modalfenster'
 ,p_event_sequence => 100
 ,p_triggering_element_type => 'DOM_OBJECT'
 ,p_triggering_element => 'document'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE|DYNAMIC ACTION|modalpageautoclose'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5324206761849434 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 5323902504849433 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'v_message = this.data.$modalPageCloseObject;'||unistr('\000a')||
'$(''.t1messages'').after( v_message );'||unistr('\000a')||
'$(''#MESSAGE.t1success'').delay(2000).fadeOut(2000);'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5329309915176039 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 5323902504849433 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin'||unistr('\000a')||
'  :P95_LABOR_WARENKORB_IDS := :P95_LABOR_WARENKORB_IDS;'||unistr('\000a')||
'end;'
 ,p_attribute_03 => 'P95_LABOR_WARENKORB_IDS'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'N'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5324420957851855 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 95
 ,p_event_id => 5323902504849433 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 30
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P95_DRUCKOPTION_NOSAVE'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hrv_parameter     fragebogen.hrv_parameter%TYPE;'||unistr('\000a')||
'   v_fas_outparameter  fragebogen.fas_outparameter%TYPE;'||unistr('\000a')||
'   v_return            NUMBER;'||unistr('\000a')||
'   v_anz               NUMBER;'||unistr('\000a')||
'   v_fehlertext        VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlermeldung     VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlernummer      number;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
'   v_hrv_credits       number;'||unistr('\000a')||
'   v_hrv_last_status   number;'||unistr('\000a')||
'   v_hrv_hash_exi';

p:=p||'sts   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''Start gen_auswertung_mn_rezept reichweite %1'',v_prot_id,''TEST'',''102/95:gen_auswertung_mn_rezept'',:P95_REZEPTREICHWEITE_NOSAVE);'||unistr('\000a')||
'   -- HRV-Auswertung in eigener Tranaktion anstossen'||unistr('\000a')||
''||unistr('\000a')||
'   IF FRGBG_HRV.FB_HRV_FKAT_MODUL_EXISTS(:p1_pergebnis_id) = 1 THEN'||unistr('\000a')||
'     '||unistr('\000a')||
'    IF FRGBG_HRV.FB_EXIST_HRV_DATEI(:p1_pergebnis_id) THEN  -- nur wenn hrv-Datei geladen wurde'||unistr('\000a')||
''||unistr('\000a')||
'      -- Parameter';

p:=p||'satz holen'||unistr('\000a')||
'      SELECT hrv_parameter, fas_outparameter INTO v_hrv_parameter, v_fas_outparameter'||unistr('\000a')||
'      FROM fragebogen'||unistr('\000a')||
'      WHERE id = :p1_fragebogen_id;'||unistr('\000a')||
'--mel.p(''Start gen_auswertung_mn_rezept HRV-Parameter %1,%2,%3'',v_prot_id,''TEST'',''102/95:gen_auswertung_mn_rezept'',v_hrv_parameter,v_fas_outparameter,:P95_GEBURTSDATUM);'||unistr('\000a')||
'      '||unistr('\000a')||
'      IF v_hrv_parameter is not null THEN'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'          ';

p:=p||'  v_return := hrv_report.create_report('||unistr('\000a')||
'                                  p_pergebnisse_id   => :p1_pergebnis_id,'||unistr('\000a')||
'                                  p_name             => :P95_NAME,'||unistr('\000a')||
'                                  p_vorname          => :P95_VORNAME,'||unistr('\000a')||
'                                  p_geburtsdatum     => to_date(:P95_GEBURTSDATUM,''DD.MM.YYYY''),'||unistr('\000a')||
'                                  p_gewicht         ';

p:=p||' => :p95_gewicht,'||unistr('\000a')||
'                                  p_groesse          => :p95_groesse,'||unistr('\000a')||
'                                  p_anrede_id        => :P110_ANREDE_ID,    -- 3=Herr,4=Frau,5=Firma'||unistr('\000a')||
'                                  p_parameter        => v_hrv_parameter,  -- '||unistr('\000a')||
'                                  p_return_parameter => v_fas_outparameter,'||unistr('\000a')||
'                                  p_akt_credits      => v';

p:=p||'_hrv_credits, /* out */'||unistr('\000a')||
'                                  p_last_hrv_status  => v_hrv_last_status, /* out */'||unistr('\000a')||
'                                  p_hash_exists      => v_hrv_hash_exists);'||unistr('\000a')||
'            '||unistr('\000a')||
''||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(5534,:fas_sprache_id);'||unistr('\000a')||
'            v_fehlernummer := -20;'||unistr('\000a')||
'            mel.p(v_fehlertext,v_prot_id,''E';

p:=p||'RROR'',''102/95: gen_auswertung_mn_rezept,  hrv[''||v_fehlernummer||'', ''||v_return||''] '' || SQLERRM);'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20002,v_fehlertext );            '||unistr('\000a')||
'            --:p95_hrv_meldung := v_fehlertext;'||unistr('\000a')||
'         END;'||unistr('\000a')||
'         IF v_return < 0 THEN'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(5534,:fas_sprache_id);'||unistr('\000a')||
'            v_fehlernummer := -25;'||unistr('\000a')||
'            mel.p(v_fehl';

p:=p||'ertext,v_prot_id,''ERROR'',''102/95: gen_auswertung_mn_rezept,  hrv[''||v_fehlernummer||'', ''||v_return||'']'' || SQLERRM);'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20002,v_fehlertext );            '||unistr('\000a')||
'            --:p95_hrv_meldung := v_fehlertext;'||unistr('\000a')||
'         elsif v_return = 10 then '||unistr('\000a')||
'               -- Keine Creditsvorhanden. Auswertung erfolgt ohne HRV'||unistr('\000a')||
'              :p95_hrv_meldung := frgbg_s.holen_uebersetzu';

p:=p||'ng(7866,:fas_sprache_id);'||unistr('\000a')||
'         elsif v_hrv_last_status is null and v_hrv_credits > 0 and v_hrv_credits <= 5 then'||unistr('\000a')||
'              -- Warnung: nur noch n HRV Credits vorhanden'||unistr('\000a')||
'              -- Nur einmal beim ersten Auswerten anzeigen'||unistr('\000a')||
'              :p95_hrv_meldung := frgbg_s.holen_uebersetzung(7916,:fas_sprache_id,v_hrv_credits);'||unistr('\000a')||
'         elsif v_hrv_last_status is null and v_hrv_credits = 0 and ';

p:=p||'v_hrv_hash_exists = 0 then'||unistr('\000a')||
'              -- Warnung keine HRV-Credits mehr verfügbar, weitere HRV-Auswertungen nicht mehr möglich.'||unistr('\000a')||
'              :p95_hrv_meldung := frgbg_s.holen_uebersetzung(7917,:fas_sprache_id);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_fehlertext :=frgbg_s.holen_uebersetzung(5534,:fas_sprache_id);'||unistr('\000a')||
'         v_fehlermeldung := v_fehlertext ||'' Der HRV-Parameter-Satz des Fragebogens';

p:=p||' konnte nicht ermittelt werden!'';'||unistr('\000a')||
'         v_fehlernummer := -30;'||unistr('\000a')||
'         mel.p(v_fehlermeldung,v_prot_id,''ERROR'',''102/95: gen_auswertung_mn_rezept,  hrv[''||v_fehlernummer||'']'');'||unistr('\000a')||
'         '||unistr('\000a')||
''||unistr('\000a')||
'         --:p95_hrv_meldung := v_fehlertext;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'     ELSE -- HRV Tab vorhanden aber keine HRV Datei'||unistr('\000a')||
'        -- RETURN (''Der Fragebogen ist noch nicht komplett ausgefüllt! Bitte auf der Übersichtssei';

p:=p||'te kontrollieren!'');'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,frgbg_s.holen_uebersetzung(5841,:fas_sprache_id));'||unistr('\000a')||
'     END IF;'||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Check pflichtige unsichtbare Felder nach HRV Load vorhanden? D.h.alle Level 0 Fragen müssen nun vorhanden sein'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT count(*) INTO v_anz'||unistr('\000a')||
'      FROM v_alle_fragen'||unistr('\000a')||
'      WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'        and ((frage_eingabepflicht';

p:=p||'ig=1 and status=2) -- unbeantw.pflichtige Fragen'||unistr('\000a')||
'          or'||unistr('\000a')||
'             (frage_eingabepflichtig=1 and status = 0)  -- unvollständig beantwortete pflichtige Fragen'||unistr('\000a')||
'            )'||unistr('\000a')||
'        and frage_fragelevel = 0 -- Keine Metafragen '||unistr('\000a')||
'        and FRAGE_BERECHNUNGSTYP is NULL -- NEI 10.05.13 Keine berechneten Werte Level O Groesse,Gewicht'||unistr('\000a')||
'      ;'||unistr('\000a')||
'      IF v_anz > 0 THEN'||unistr('\000a')||
'         -- RETURN (''Der Frag';

p:=p||'ebogen ist noch nicht komplett ausgefüllt! Bitte auf der Übersichtsseite kontrollieren!'');'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,frgbg_s.holen_uebersetzung(5841,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'   v_return := frgbg_s.GEN_FB_MN_REZEPT('||unistr('\000a')||
'                       1, -- Modus Auswertung komplett mit Rezept'||unistr('\000a')||
'                       :p1_pergebnis_id'||unistr('\000a')||
'                      ,:P95_REZEPTREICHWEITE_NO';

p:=p||'SAVE   -- NEI 09.08.13'||unistr('\000a')||
'                      ,:p95_rezeptkosten_nosave,:p95_waehrung_id,'||unistr('\000a')||
'                       -- :p95_VERRECHNUNGSLAND,   -- NEI 08.03.2012'||unistr('\000a')||
'                       :fas_sortiment_id,  -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                       :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'                      ,:app_user'||unistr('\000a')||
'                      ,:FAS_IDENTITAET_PERSSTAMM_ID -- aktive Identitaet  N';

p:=p||'EI 08.03.2012'||unistr('\000a')||
'                      ,:P95_PERSSTAMM_ID_PROD_APO   -- prod. Apo          NEI 08.03.2012'||unistr('\000a')||
'                      ,:P95_PERSSTAMM_ID_PROD_APO   -- Rechsteller: def. Prod Apo  NEI 08.03.2012'||unistr('\000a')||
'                      ,v_fehlertext);'||unistr('\000a')||
'   IF v_return <= 0 THEN --Fehler'||unistr('\000a')||
'     :p1_bearb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'     v_fehlertext := frgbg_s.holen_uebersetzung(1664,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICAT';

p:=p||'ION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p1_bearb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'/*'||unistr('\000a')||
'mel.p(''Start gen_auswertung_mn_rezept HRV-Parameter zuletzt%1,%2'',v_prot_id,''TEST'',''102/95:gen_auswertung_mn_rezept'',:p1_hrv_zuletzt_geladen,:p1_fragebogen_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- Gutschein-Verfahren der Identität aktiv'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''KUNDE'' AND   -- Kunde meldet sich direkt an USER_ACCOUNT=APP_USER'||unistr('\000a')||
'      frgbg_s';

p:=p||'.check_fas_rolle(:APP_USER,''FB_GUTSCHEINVERFAHREN'') > 0 '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      UPDATE personenstamm'||unistr('\000a')||
'      SET gutscheinanzahl = gutscheinanzahl - 1,'||unistr('\000a')||
'          gutscheinstatus = 2'||unistr('\000a')||
'      WHERE id = :p95_PERSONENSTAMM_ID;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5820804924192100 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_auswertung_mn_rezept',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':p1_pergebnis_id is not null and :request = ''MN_REZEPT''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return      NUMBER;'||unistr('\000a')||
'   v_fehlertext  VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id     NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*MEL.P (''gen_mn_rezept Druckoption:%1, Kosten:%2 '', v_prot_id,''INFO'',''gen_mn_rezept page 102/92'',:p95_druckoption_nosave,:p95_rezeptkosten_nosave);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   v_return := frgbg_s.GEN_FB_MN_REZEPT('||unistr('\000a')||
'                      2, -- Modus nur Rezept Auswertung bereits vorhanden'||unistr('\000a')||
'                      :p1_pergebnis_';

p:=p||'id '||unistr('\000a')||
'                     ,:P95_REZEPTREICHWEITE_NOSAVE  -- NEI 09.08.13'||unistr('\000a')||
'                     ,:p95_rezeptkosten_nosave,:p95_waehrung_id,'||unistr('\000a')||
'                      -- :p95_VERRECHNUNGSLAND,      -- NEI 08.03.2012'||unistr('\000a')||
'                      :fas_sortiment_id,  -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                      :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'                      ,:app_user'||unistr('\000a')||
'                      ,:FAS';

p:=p||'_IDENTITAET_PERSSTAMM_ID -- aktive Identitaet  NEI 08.03.2012'||unistr('\000a')||
'                      ,:P95_PERSSTAMM_ID_PROD_APO      -- prod. Apo          NEI 08.03.2012'||unistr('\000a')||
'                      ,:P95_PERSSTAMM_ID_PROD_APO      -- Rechsteller: def. Prod Apo  NEI 08.03.2012'||unistr('\000a')||
'                      ,v_fehlertext);'||unistr('\000a')||
'   :p1_bearb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'   IF v_return <= 0 THEN --Fehler'||unistr('\000a')||
'     v_fehlertext := frgbg_s.holen_uebe';

p:=p||'rsetzung(1664,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5821017935192100 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_mn_rezept',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p1_pergebnis_id is not null and :request = ''AUSWERTUNG_NEUES_REZEPT''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return       number;'||unistr('\000a')||
'   v_fehlernummer number;'||unistr('\000a')||
'   v_fehlertext   varchar2(2000);'||unistr('\000a')||
'   v_fehler       exception;'||unistr('\000a')||
'   v_prot_id      number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*   -- Löschen der Metafragen'||unistr('\000a')||
'   delete from persantworten'||unistr('\000a')||
'   where frage_id in (select id from fragen where fragelevel > 0)'||unistr('\000a')||
'     and pergebnis_id in (:p1_pergebnis_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Normierung entfernen'||unistr('\000a')||
'   update persantworten'||unistr('\000a')||
'   set fantwort_normwe';

p:=p||'rt_id = null,'||unistr('\000a')||
'       LABOR_MIN_NORMWERT = null,'||unistr('\000a')||
'       LABOR_MIN_NORMWERT_1 = null,'||unistr('\000a')||
'       LABOR_MAX_NORMWERT = null,'||unistr('\000a')||
'       LABOR_MAX_NORMWERT_1 = null'||unistr('\000a')||
'   where pergebnis_id in (:p1_pergebnis_id)  '||unistr('\000a')||
'     and (fantwort_normwert_id is not null'||unistr('\000a')||
'        or LABOR_MIN_NORMWERT is not null'||unistr('\000a')||
'        or LABOR_MIN_NORMWERT_1 is not null'||unistr('\000a')||
'        or LABOR_MAX_NORMWERT is not null'||unistr('\000a')||
'        or LABOR_MAX_NORMWERT_';

p:=p||'1 = null'||unistr('\000a')||
'     );'||unistr('\000a')||
''||unistr('\000a')||
'   -- Auswertung löschen'||unistr('\000a')||
'   delete from pauswertungen'||unistr('\000a')||
'   where  pergebnis_id in (:p1_pergebnis_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Rezept als gelöscht markieren, falls bereits Bestellungen durchgeführt wurden'||unistr('\000a')||
'   update mn_rezepte'||unistr('\000a')||
'   set satz_kennzeichen = ''Autom. gelöscht wg. Zurücksetzen der Auswertung! ''||'||unistr('\000a')||
'                          NVL(v(''APP_USER''),USER)||'||unistr('\000a')||
'                          '' am ''||to_char(sy';

p:=p||'sdate,''DD.MM.YYYY hh24:mi:ss'')'||unistr('\000a')||
'   where pergebnis_id in (:p1_pergebnis_id)        ;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Produktrezept als gelöscht markieren'||unistr('\000a')||
'   update prod_rezepte'||unistr('\000a')||
'   set satz_kennzeichen = ''Autom. gelöscht wg. Zurücksetzen der Auswertung! ''||'||unistr('\000a')||
'                          NVL(v(''APP_USER''),USER)||'||unistr('\000a')||
'                          '' am ''||to_char(sysdate,''DD.MM.YYYY hh24:mi:ss'')'||unistr('\000a')||
'   where id in  ( SELECT prod.id'||unistr('\000a')||
'         ';

p:=p||'         from mn_rezepte mnr,prod_rezepte prod'||unistr('\000a')||
'                  where pergebnis_id in (:p1_pergebnis_id)'||unistr('\000a')||
'                    and mnr.REZEPT_NR = prod.REZEPT_NR'||unistr('\000a')||
'                    and mnr.VERSION = prod.VERSION);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   v_return := frgbg_s.fb_del_auswertung(:p1_pergebnis_id);'||unistr('\000a')||
'   IF v_return > 0 THEN'||unistr('\000a')||
'      :p1_bearb_modus := ''BEARBEITEN'';'||unistr('\000a')||
'      :P95_LETZTE_PERGAUSWERTUNG := '''';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'     :p1_bea';

p:=p||'rb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'     v_fehlertext := frgbg_s.holen_uebersetzung(1812,:fas_sprache_id,1);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- HRV-Auswertung loeschen'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      hrv_table.reset_hrv( p_pergebnisse_id  => :p1_pergebnis_id);      '||unistr('\000a')||
' EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      v_fehlertext:= SQLERRM;'||unistr('\000a')||
'      -- ''HRV-Auswertung konnte nicht ordnungsgemäss durchgeführ';

p:=p||'t werden!'';'||unistr('\000a')||
'      :p95_hrv_meldung :=frgbg_s.holen_uebersetzung(5535,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlertext := :p95_hrv_meldung ||'' ''||v_fehlertext;'||unistr('\000a')||
'      v_fehlernummer := -25;'||unistr('\000a')||
'      mel.p(v_fehlertext,v_prot_id,''ERROR'',''102/95: gen_auswertung_mn_rezept, hrv[''||v_fehlernummer||'']'');'||unistr('\000a')||
'      --RAISE_APPLICATION_ERROR (-20003,v_fehlertext );'||unistr('\000a')||
'   END;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5821200065192100 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'auswertung_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5815228789192070 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :request = ''KOPIEREN'' THEN'||unistr('\000a')||
'      :p1_bearb_modus := ''KOPIEREN'';'||unistr('\000a')||
'   ELSIF :request = ''KOPIEREN0'' THEN'||unistr('\000a')||
'      :p1_bearb_modus := ''KOPIEREN0'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5821403422192100 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_bearb_modus_kopieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''KOPIEREN'',''KOPIEREN0'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_kunde      VARCHAR2(2000);'||unistr('\000a')||
'   v_rezept_nr  mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_version    mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_rezept     VARCHAR2(2000);'||unistr('\000a')||
'   v_return     number;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Mail-Parameter vorbereiten'||unistr('\000a')||
'   v_kunde := frgbg_s.get_pers_adresse(:p95_personenstamm_id)||'', ID: ''||:p95_personenstamm_id;'||unistr('\000a')||
'   select max(rezept_nr) int';

p:=p||'o v_rezept_nr'||unistr('\000a')||
'   from mn_rezepte '||unistr('\000a')||
'   where pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'     and satz_kennzeichen is null;'||unistr('\000a')||
'   v_version := rezepte.GET_MNR_MAX_VERSION(v_rezept_nr);'||unistr('\000a')||
'   v_rezept  := v_rezept_nr||''/''||v_version;'||unistr('\000a')||
'   v_return := frgbg_s.MAIL_TEXT'||unistr('\000a')||
'                       (NULL'||unistr('\000a')||
'                       ,:FAS_IDENTITAET_PERSSTAMM_ID'||unistr('\000a')||
'                       ,4899                     -- BETREFF_TEXT_ID'||unistr('\000a')||
'    ';

p:=p||'                   ,4898                     -- MAIL_TEXT_ID  '||unistr('\000a')||
'                       ,:p95_personenstamm_id    -- PERSSTAMM_ID_MAILABSENDER => Kunde'||unistr('\000a')||
'                       ,1                        -- Replay-Adresse'||unistr('\000a')||
'                       ,1                        -- NOTFALL_EMAIL '||unistr('\000a')||
'                       ,v_kunde                  -- Param1  '||unistr('\000a')||
'                       ,v_rezept                 -- Par';

p:=p||'am2'||unistr('\000a')||
'              );'||unistr('\000a')||
'   IF v_return <= 0 THEN'||unistr('\000a')||
'      -- ''Die Bestellung konnte nicht ordnungsgemäss an die Apotheke übermittelt werden! ...'||unistr('\000a')||
'      :p95_bestellhinweis := frgbg_s.holen_uebersetzung(4900,:fas_sprache_id,'||unistr('\000a')||
'                                        frgbg_s.get_pers_adresse(:FAS_IDENTITAET_PERSSTAMM_ID));'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- ''Die Bestellung wurde an ihre Apotheke gesendet!'';'||unistr('\000a')||
'      :p95_bestell';

p:=p||'hinweis := frgbg_s.holen_uebersetzung(4901,:fas_sprache_id,'||unistr('\000a')||
'                                        frgbg_s.get_pers_adresse(:FAS_IDENTITAET_PERSSTAMM_ID));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Gutscheinstatus erhoehen'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      UPDATE personenstamm'||unistr('\000a')||
'      SET gutscheinstatus = 3'||unistr('\000a')||
'      WHERE id = :p95_personenstamm_id;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'     v_fehlertext := ''Nach der Bestellung per Mail konnte der';

p:=p||' Gutscheinstatus nicht erhoeht werden! Kunde: ''||v_kunde'||unistr('\000a')||
'                  || '' , Apotheke: ''|| :FAS_IDENTITAET_PERSSTAMM_ID'||unistr('\000a')||
'                  || '' , Pergebnis_id: ''|| :p1_pergebnis_id'||unistr('\000a')||
'                  || '' , Rezept: ''||v_rezept||''(FAS102/P95:bestellung) ''||SQLERRM;'||unistr('\000a')||
'     mel.p(v_fehlertext,v_prot_id,''ERROR'',''FAS102/P95:bestellung,10'');'||unistr('\000a')||
'   END;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'     v_fehlertext := ''Die ';

p:=p||'Bestellung konnte nicht per Mail uebermittelt werden! Kunde: ''||v_kunde'||unistr('\000a')||
'                  || '' , Apotheke: ''|| :FAS_IDENTITAET_PERSSTAMM_ID'||unistr('\000a')||
'                  || '' , Pergebnis_id: ''|| :p1_pergebnis_id'||unistr('\000a')||
'                  || '' , Rezept: ''||v_rezept||''(FAS102/P95:bestellung) ''||SQLERRM;'||unistr('\000a')||
'     :p95_bestellhinweis := frgbg_s.holen_uebersetzung(4900,:fas_sprache_id,'||unistr('\000a')||
'                                     frg';

p:=p||'bg_s.get_pers_adresse(:FAS_IDENTITAET_PERSSTAMM_ID));'||unistr('\000a')||
'     mel.p(v_fehlertext,v_prot_id,''ERROR'',''FAS102/P95:bestellung'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3646919337034245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'bestellung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>3643605036967564 + wwv_flow_api.g_id_offset,
  p_process_when=>':fas_aufgerufen_von = ''KUNDE'' AND   /* Kunde meldet sich direkt an USER_ACCOUNT=APP_USER */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,  /* Gutscheinverfahren */'||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0 AND'||unistr('\000a')||
'frgbg_s.FB_CHECK_AUSWERTUNG         /* Auswertung vorhanden? */'||unistr('\000a')||
'         (:p1_pergebnis_id) > 0 ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id  number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   mel.p(''In write_protokoll neu perg: %1,%2,%3,%4,%5,%6,%7,%8,%9'',v_prot_id,''TEST'',''102/95 write_protokoll'',:p1_pergebnis_id,:FAS_LOGIN_PERSONENSTAMM_ID,:P95_DRUCKOPTION_NOSAVE,'||unistr('\000a')||
':FAS_IDENTITAET_PERSSTAMM_ID,:P95_PERSSTAMM_ID_PROD_APO,:P95_PREISLISTE_ID,:P95_VERRECH_LAND_ID,'||unistr('\000a')||
':P95_ART_MWST_TYP_ID,:P95_PREISFAKTOR'||unistr('\000a')||
');'||unistr('\000a')||
'   mel.p(''In write_protokoll neu %1,%2,%3,%4,%5';

p:=p||',%6,%7,%8,%9'',v_prot_id,''TEST'',''102/95 write_protokoll'',:P95_DRUCKMODUS,:FAS_SCHEMA_ID'||unistr('\000a')||
');'||unistr('\000a')||
'--RAISE_APPLICATION_ERROR (-20002,''PDF-Druck geht zur Zeit nicht! '');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3733302092162275 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 55,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'write_protokoll',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':P95_DRUCKOPTION_NOSAVE is not null and '||unistr('\000a')||
'( :request = ''AUSWERTUNG_DRUCKEN'' OR '||unistr('\000a')||
' (:fas_aufgerufen_von in (''ANONYM'',''KUNDE'') AND :request = ''MN_REZEPT'')'||unistr('\000a')||
')',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'mel.p(''In write_protokoll neu perg: %1,%2,%3,%4,%5,%6,%7,%8,%9'',v_prot_id,''TEST'',''102/95 Druck MN_I_Auswertung'',:p1_pergebnis_id,:FAS_LOGIN_PERSONENSTAMM_ID,:P95_DRUCKOPTION_NOSAVE,'||unistr('\000a')||
':FAS_IDENTITAET_PERSSTAMM_ID,:P95_PERSSTAMM_ID_PROD_APO,:P95_PREISLISTE_ID,:P95_VERRECH_LAND_ID,'||unistr('\000a')||
':P95_ART_MWST_TYP_ID,:P95_PREISFAKTOR'||unistr('\000a')||
');'||unistr('\000a')||
'   mel.p(''In write_protokoll neu %1,%2,%3';

p:=p||',%4,%5,%6,%7,%8,%9'',v_prot_id,''TEST'',''102/95 Druck MN_I_Auswertung'',:P95_DRUCKMODUS,:FAS_SCHEMA_ID'||unistr('\000a')||
');'||unistr('\000a')||
'*/'||unistr('\000a')||
'    /*DOKUMENTEN_DRUCK * /'||unistr('\000a')||
'    IREPORT.MN_I_BERICHT_JOB('||unistr('\000a')||
'           P_PERGEBNIS_ID   =>:P1_PERGEBNIS_ID,'||unistr('\000a')||
'           P_BETREUER_ID    =>:FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'           P_DRUCKOPTION    =>'''''':''||:P95_DRUCKOPTION_NOSAVE||'':'''''','||unistr('\000a')||
'           P_IDENT_ID       =>:FAS_IDENTITAET_PERSSTAMM_ID,'||unistr('\000a')||
'  ';

p:=p||'         P_APO_ID         =>:P95_PERSSTAMM_ID_PROD_APO,'||unistr('\000a')||
'           P_PREISLISTE_ID  =>:P95_PREISLISTE_ID,'||unistr('\000a')||
'           P_VERRECH_LAND_ID=>:P95_VERRECH_LAND_ID,'||unistr('\000a')||
'           P_ART_MWST_TYP_ID=>:P95_ART_MWST_TYP_ID,'||unistr('\000a')||
'           P_PREISFAKTOR    =>:P95_PREISFAKTOR,'||unistr('\000a')||
'           P_MODUS          =>:P95_DRUCKMODUS,'||unistr('\000a')||
'           P_FAS_SCHEMA_ID  =>:FAS_SCHEMA_ID'||unistr('\000a')||
'      );'||unistr('\000a')||
''||unistr('\000a')||
'   apex_application.g_unrecoverable_erro';

p:=p||'r := true;'||unistr('\000a')||
' /*  */'||unistr('\000a')||
'   --/ * '||unistr('\000a')||
'    --  Dieser Aufruf ermöglicht es den Druck als Asynchroner Job laufen zu lassen. '||unistr('\000a')||
'    -- Wird momentan nicht benötigt.'||unistr('\000a')||
'    FRGBG_JOBS.START_JOB('||unistr('\000a')||
'       p_what                    => ''IREPORT.MN_I_BERICHT_JOB('||unistr('\000a')||
'           P_PERGEBNIS_ID   => '' || :P1_PERGEBNIS_ID || '','||unistr('\000a')||
'           P_BETREUER_ID    => '' || :FAS_LOGIN_PERSONENSTAMM_ID  || '','||unistr('\000a')||
'           P_DRUCKOPTION    =>';

p:=p||' '' || '''''':'' || :P95_DRUCKOPTION_NOSAVE ||'':'''''' || '','||unistr('\000a')||
'           P_IDENT_ID       => '' || :FAS_IDENTITAET_PERSSTAMM_ID || '','||unistr('\000a')||
'           P_APO_ID         => '' || :P95_PERSSTAMM_ID_PROD_APO || '','||unistr('\000a')||
'           P_PREISLISTE_ID  => '' || :P95_PREISLISTE_ID || '','||unistr('\000a')||
'           P_VERRECH_LAND_ID=> '' || :P95_VERRECH_LAND_ID || '','||unistr('\000a')||
'           P_ART_MWST_TYP_ID=> '' || :P95_ART_MWST_TYP_ID || '','||unistr('\000a')||
'           P_PREISFA';

p:=p||'KTOR    => to_number('''''' || :P95_PREISFAKTOR || ''''''),'||unistr('\000a')||
'           P_MODUS          => '' || :P95_DRUCKMODUS || '','||unistr('\000a')||
'           P_FAS_SCHEMA_ID  => '' || :FAS_SCHEMA_ID || '','||unistr('\000a')||
'           P_WARENKORB_IDS => '''''' || :P95_LABOR_WARENKORB_IDS || '''''''||unistr('\000a')||
'       );'','||unistr('\000a')||
'       p_beschreibung   => frgbg_s.holen_uebersetzung(9103,:FAS_SPRACHE_ID),'||unistr('\000a')||
'       p_max_jobs_same          => 1,'||unistr('\000a')||
'       p_max_jobs_total         => ';

p:=p||'1,'||unistr('\000a')||
'       p_visible                => 1,'||unistr('\000a')||
'       p_valid_days             => 1,'||unistr('\000a')||
'       p_hide_by_complete       => 1'||unistr('\000a')||
'    );'||unistr('\000a')||
'   -- * /'||unistr('\000a')||
'   '||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'   when FRGBG_JOBS.E_JOB_TOO_MANY then'||unistr('\000a')||
'      raise_application_error(-20000,FRGBG_S.HOLEN_UEBERSETZUNG(10053,:APP_SPRACHE_ID));'||unistr('\000a')||
'   when others then'||unistr('\000a')||
'      mel.p(''Fehler beim Druck perg: %1,%2,%3,%4,%5,%6,%7,%8,%9 '' || sqlerrm,v_prot_id,''TEST'',''102/95 Dru';

p:=p||'ck MN_I_Auswertung'',:p1_pergebnis_id,:FAS_LOGIN_PERSONENSTAMM_ID,:P95_DRUCKOPTION_NOSAVE,'||unistr('\000a')||
':FAS_IDENTITAET_PERSSTAMM_ID,:P95_PERSSTAMM_ID_PROD_APO,:P95_PREISLISTE_ID,:P95_VERRECH_LAND_ID,'||unistr('\000a')||
':P95_ART_MWST_TYP_ID,:P95_PREISFAKTOR'||unistr('\000a')||
');'||unistr('\000a')||
'      -- Fehler beim Druck, wenden Sie sich an den Systemadmin'||unistr('\000a')||
'      raise_application_error(-20000,FRGBG_S.HOLEN_UEBERSETZUNG(9104,:APP_SPRACHE_ID));'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4001123649974876 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Druck MN_I_Auswertung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':P95_DRUCKOPTION_NOSAVE is not null and '||unistr('\000a')||
'( :request = ''AUSWERTUNG_DRUCKEN'' OR '||unistr('\000a')||
' (:fas_aufgerufen_von in (''ANONYM'',''KUNDE'') AND :request = ''MN_REZEPT'')'||unistr('\000a')||
')'||unistr('\000a')||
'',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweis VARCHAR2(4000);'||unistr('\000a')||
'   cursor c_hinweis is '||unistr('\000a')||
'   SELECT frgbg_s.HOLEN_UEBERSETZUNG (fk.HINWEIS_TEXT_ID,:fas_sprache_id) text'||unistr('\000a')||
'   from fkategorien fk'||unistr('\000a')||
'   where fk.fragebogen_id = :p1_fragebogen_id'||unistr('\000a')||
'     and (fk.fkategorie_id = :p1_tab95_kategorie_id or'||unistr('\000a')||
'          fk.fkategorie_ID is null and'||unistr('\000a')||
'                  fk.id= :p1_tab95_kategorie_id'||unistr('\000a')||
'         )'||unistr('\000a')||
'     ;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   ';

p:=p||'--MEl.P(''Anrede ID: '' || :P110_ANREDE_ID || '' pergebnis_id: '' ||  --:p1_pergebnis_id,v_prot_id,''TEST'',''102/95:hinweistext_init'');'||unistr('\000a')||
''||unistr('\000a')||
'   FOR r_hinweis in c_hinweis LOOP'||unistr('\000a')||
'       IF r_hinweis.text is not null THEN'||unistr('\000a')||
'          v_hinweis := v_hinweis||'' '' || r_hinweis.text;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p1_hinweistext := v_hinweis;'||unistr('\000a')||
''||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 5820426751192095 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweistext_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_text VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''In fehlerausgabe'',v_prot_id,''TEST'',''P95/bestellhinweis'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
''||unistr('\000a')||
'   v_text := :p95_bestellhinweis;'||unistr('\000a')||
'   :p95_bestellhinweis := NULL;'||unistr('\000a')||
'   IF v_text is not null THEN'||unistr('\000a')||
'      htp.p(''alert("''||v_text||''");'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3648525093376467 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'bestellhinweis',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''BESTELLHINWEIS'' and :p95_bestellhinweis is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_text VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''In fehlerausgabe'',v_prot_id,''TEST'',''P95/hrv_meldung'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
''||unistr('\000a')||
'   v_text := :p95_hrv_meldung;'||unistr('\000a')||
'   :p95_hrv_meldung := NULL;'||unistr('\000a')||
'   IF v_text is not null THEN'||unistr('\000a')||
'      htp.p(''alert("''||v_text||''");'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7303222856793720 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hrv_meldung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''HRV_MELDUNG'' and :p95_hrv_MELDUNG is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'/* !!!!! ACHTUNG nochmals definiert in :p95_druckoption_nosave als default value */'||unistr('\000a')||
'   v_text   VARCHAR2(100);'||unistr('\000a')||
'   CURSOR c_opt is'||unistr('\000a')||
'/*     select wert'||unistr('\000a')||
'     from optionswerte'||unistr('\000a')||
'     where opttyp_id = 18'||unistr('\000a')||
'       and standard = 1'||unistr('\000a')||
'     order by sortierung desc;'||unistr('\000a')||
'*/'||unistr('\000a')||
'SELECT ow.wert '||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */';

p:=p||''||unistr('\000a')||
'  and ow.opttyp_id = 18 /* Druckoption */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and ((ow.wert = 9 and FRGBG_S.FB_IST_INHSTOFF_VORH(:P1_PERGEBNIS_ID) > 0) /* Laborparameter vorhanden */'||unistr('\000a')||
'        or (ow.wert = 10 and HRV_TABLE.exist_auswertung_hrv(:P1_PERGEBNIS_ID) > 0) /* HRV vorhanden */'||unistr('\000a')||
'        or ow.wert not in(9,10)) '||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS';

p:=p||'_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'  and po.standard = 1'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT ow.wert '||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 18 /* Druckoption*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und kei';

p:=p||'ne Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'   and ((ow.wert = 9 and FRGBG_S.FB_IST_INHSTOFF_VORH(:P1_PERGEBNIS_ID) > 0) /* Laborparameter vorhanden */'||unistr('\000a')||
'        or (ow.wert = 10 and HRV_TABLE.exist_auswertung_hrv(:P1_PERGEBNI';

p:=p||'S_ID) > 0) /* HRV vorhanden */'||unistr('\000a')||
'        or ow.wert not in(9,10))'||unistr('\000a')||
'   and ow.standard = 1;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR r_opt in c_opt LOOP'||unistr('\000a')||
'       v_text := r_opt.wert||'':''||v_text;'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   :p95_druckoption_nosave := v_text;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3732807109125813 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_druckoptionvorgabe',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'    v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p95_personenstamm_id := :p1_id;'||unistr('\000a')||
'   select name,vorname,to_char(geburtsdatum,''DD.MM.YYYY''), groesse,gewicht'||unistr('\000a')||
'   into :p95_name,:p95_vorname,:p95_geburtsdatum, :p95_groesse,:p95_gewicht'||unistr('\000a')||
'   from personenstamm'||unistr('\000a')||
'   where id = :p95_personenstamm_id;'||unistr('\000a')||
''||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN no_data_found THEN'||unistr('\000a')||
'     -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'     v_fehlertext := f';

p:=p||'rgbg_s.holen_uebersetzung(483,:fas_sprache_id)||'' (0)'';'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'     -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'     v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5925507857485353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 80,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   :p95_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p95_bl_verwerfen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   --:p1_bl_loeschen  := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p95_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :p95_bl_aendern   ';

p:=p||':= frgbg_s.holen_uebersetzung(162,v_sprache_id);'||unistr('\000a')||
'   :p95_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id);'||unistr('\000a')||
'   :p95_bl_passwort_chg := frgbg_s.holen_uebersetzung(171,v_sprache_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   :p95_bl_rezept := frgbg_s.holen_uebersetzung(1706,v_sprache_id);'||unistr('\000a')||
'   :p95_bl_auswertung_drucken := frgbg_s.holen_uebersetzung(2711,v_sprache_id);'||unistr('\000a')||
'   :P95_BL_AUSWERTUNG_NEUES_REZEPT := frgbg_s.holen_ueber';

p:=p||'setzung(3060,v_sprache_id);'||unistr('\000a')||
'   :P95_BL_AUSWERTUNG := frgbg_s.holen_uebersetzung(3054,v_sprache_id);'||unistr('\000a')||
'   :p95_bl_kopieren := frgbg_s.holen_uebersetzung(3737,v_sprache_id); /* Kopieren mit Antworten */'||unistr('\000a')||
'   :p95_bl_kopieren0 := frgbg_s.holen_uebersetzung(3046,v_sprache_id); /* Neue FB ohne Antworten */'||unistr('\000a')||
'   :P95_BL_DEL_AUSWERTUNG := frgbg_s.holen_uebersetzung(3665,v_sprache_id);'||unistr('\000a')||
'   :p95_bl_bestellen := f';

p:=p||'rgbg_s.holen_uebersetzung(4486,v_sprache_id);'||unistr('\000a')||
'  '||unistr('\000a')||
'   --:p1_region_titel_hilfetexte := frgbg_s.holen_uebersetzung(220,v_sprache_id);'||unistr('\000a')||
'   --:p1_region_titel_infotext := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   :p95_region_titel_auswertung := frgbg_s.holen_uebersetzung(3054,v_sprache_id);'||unistr('\000a')||
'   :P95_PAGE_TITEL_PATIENT := frgbg_s.holen_uebersetzung(482,v_sprache_id);'||unistr('\000a')||
'   :P95_REGION_TITEL_drucken :=';

p:=p||' frgbg_s.holen_uebersetzung(5467,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   --:p1_hinweistitel := frgbg_s.holen_uebersetzung(3516,v_sprache_id);'||unistr('\000a')||
'   --:p1_laborwerte_hinweistext := frgbg_s.holen_uebersetzung(3517,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   --:p1_info := frgbg_s.holen_uebersetzung(173,v_sprache_id);'||unistr('\000a')||
'   :p95_druckopt_info := frgbg_s.holen_uebersetzung(3538,v_sprache_id);'||unistr('\000a')||
'   --:p1_fehler := frgbg_s.holen_uebersetzung(487,v_sprache_i';

p:=p||'d); '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5820603489192098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 82,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_preislistentyp              preislisten.typ%TYPE;'||unistr('\000a')||
'   v_sortiment_id                sortimente.id%TYPE; -- NEI 14.02.2011 Sortimentseinf.:'||unistr('\000a')||
'                                                     -- sortiment_id statt preislisten_set_id'||unistr('\000a')||
'   v_preisliste_id               preislisten.id%TYPE;  '||unistr('\000a')||
'--   v_preislisten_land_id         preislisten.land_id%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechsteller    perso';

p:=p||'nenstamm.id%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechnung       personenstamm.id%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_LIEFERUNG      personenstamm.id%TYPE;'||unistr('\000a')||
'   V_PERSSTAMM_ID_PROD_APO       personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                  VARCHAR2(2000);'||unistr('\000a')||
'   v_meldung                     VARCHAR2(2000);'||unistr('\000a')||
''||unistr('\000a')||
'   v_user       VARCHAR2(100);'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;  --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'   ';

p:=p||'v_prot_id    number;'||unistr('\000a')||
'   v_return     number;'||unistr('\000a')||
'   v_return2    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Fragebogen initialisieren'||unistr('\000a')||
'   IF :p1_fragebogen_id IS NULL THEN'||unistr('\000a')||
'      :p1_fragebogen_id := 1;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--MEL.P (''fragebogen_festlegen 0: %1, %2,%3,%4'', v_PROT_ID, ''TEST'', ''seite 1 fragebogen festlegen'',:p95_fragebogen_id,:p95_fb_version,:P95_VERRECHNUNGSLAND,:p1_bearb_modus);'||unistr('\000a')||
'   IF :p1_fb_version is not null THEN'||unistr('\000a')||
'   ';

p:=p||'   :p1_fragebogen_id := frgbg_s.FB_GEN_ID_VERS_NR(:p1_fragebogen_id,:p1_fb_version);'||unistr('\000a')||
'      :p1_fb_version := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--MEL.P (''fragebogen_festlegen 1: %1, %2,%3,%4'', v_PROT_ID, ''ERROR'', ''seite 1 fragebogen festlegen'',:p1_fragebogen_id,:p1_fb_version,:p1_bearb_modus);'||unistr('\000a')||
''||unistr('\000a')||
'   IF :p1_bearb_modus = ''KOPIEREN'' THEN -- Neue Version erstellen'||unistr('\000a')||
'      -- Kopie erzeugen, da die alte Version bereits ein';

p:=p||' MNR besitzt '||unistr('\000a')||
'      -- und dann ist die neue Version bearbeitbar'||unistr('\000a')||
'      v_return :=  frgbg_s.perg_set_kopieren('||unistr('\000a')||
'                              :p1_pergebnis_id,'||unistr('\000a')||
'                              1    -- NEI 15.07.10 alte Antworten übernehmen'||unistr('\000a')||
'                            );'||unistr('\000a')||
'      IF v_return > 0 THEN -- Kopie erfolgreich => Neue ID'||unistr('\000a')||
''||unistr('\000a')||
'         -- Kopiere auch die Modulauswahl'||unistr('\000a')||
'         v_return2 := frgbg_s.F';

p:=p||'B_KOPIERE_FKAT_MODUL_AUSWAHL('||unistr('\000a')||
'           p_pergebnis_id_alt => :p1_pergebnis_id,'||unistr('\000a')||
'           p_pergebnis_id_neu => v_return,'||unistr('\000a')||
'           p_fas_login_personenstamm_id => :fas_login_personenstamm_id,'||unistr('\000a')||
'           p_fas_identitaet_persstamm_id => :fas_identitaet_persstamm_id'||unistr('\000a')||
'         );'||unistr('\000a')||
''||unistr('\000a')||
'         if(v_return2 > 0) then -- Beim Kopieren ist was schief gegangen.'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20000,';

p:=p||'frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      to_char(v_return),''perg_set_festlegen''));'||unistr('\000a')||
'         end if;'||unistr('\000a')||
'         '||unistr('\000a')||
'         IF FRGBG_HRV.FB_EXIST_HRV_DATEI(:p1_pergebnis_id) THEN -- nur wenn hrv-Datei geladen wurde'||unistr('\000a')||
'            -- HRV kopieren'||unistr('\000a')||
'            BEGIN'||unistr('\000a')||
'               hrv_table.copy_hrv( '||unistr('\000a')||
'                             p_pergebnisse_alt => :p1_pergebnis_i';

p:=p||'d,'||unistr('\000a')||
'                             p_pergebnisse_neu => v_return'||unistr('\000a')||
'                             );'||unistr('\000a')||
'            EXCEPTION'||unistr('\000a')||
'            WHEN others THEN'||unistr('\000a')||
'               v_fehlertext:= SQLERRM;'||unistr('\000a')||
'               -- ''HRV-Auswertung konnte nicht ordnungsgemäss kopiert werden!'';'||unistr('\000a')||
'               v_meldung :=frgbg_s.holen_uebersetzung(6655,:fas_sprache_id);'||unistr('\000a')||
'               v_fehlertext := v_meldung ||'' ''||v_fehlertex';

p:=p||'t;'||unistr('\000a')||
'               mel.p(v_fehlertext,v_prot_id,''ERROR'',''102/95: fragebogen_festlegen, hrv[-25]'');'||unistr('\000a')||
'               RAISE_APPLICATION_ERROR (-20025,v_meldung );'||unistr('\000a')||
'            END;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
''||unistr('\000a')||
'         :p1_bearb_modus := ''BEARBEITEN''; '||unistr('\000a')||
'         :p1_pergebnis_id := v_return;'||unistr('\000a')||
'      ELSIF v_return < 0 THEN -- Fehler beim kopieren'||unistr('\000a')||
'         :p1_bearb_modus := ''ANZEIGEN''; '||unistr('\000a')||
'         RAISE_APPLICATION_ERR';

p:=p||'OR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      to_char(v_return),''perg_set_festlegen''));'||unistr('\000a')||
'      ELSE -- p1_pergebnis_id is null'||unistr('\000a')||
'         :p1_bearb_modus := ''ANZEIGEN''; '||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      ''90'',''perg_set_festlegen''));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      '||unistr('\000a')||
'   ELSIF ';

p:=p||':p1_bearb_modus = ''KOPIEREN0'' THEN -- Neue Version erstellen'||unistr('\000a')||
'      -- Kopie erzeugen, da die alte Version bereits ein MNR besitzt '||unistr('\000a')||
'      -- und dann ist die neue Version bearbeitbar'||unistr('\000a')||
'      v_return :=  frgbg_s.perg_set_kopieren('||unistr('\000a')||
'                              :p1_pergebnis_id,'||unistr('\000a')||
'                              0    -- NEI 15.07.10 alte Antworten nicht übernehmen'||unistr('\000a')||
'                            );'||unistr('\000a')||
'      IF v';

p:=p||'_return > 0 THEN -- Kopie erfolgreich => Neue ID'||unistr('\000a')||
'         :p1_bearb_modus := ''BEARBEITEN''; '||unistr('\000a')||
''||unistr('\000a')||
'         -- Kopiere auch die Modulauswahl'||unistr('\000a')||
'         v_return2 := frgbg_s.FB_KOPIERE_FKAT_MODUL_AUSWAHL('||unistr('\000a')||
'           p_pergebnis_id_alt => :p1_pergebnis_id,'||unistr('\000a')||
'           p_pergebnis_id_neu => v_return,'||unistr('\000a')||
'           p_fas_login_personenstamm_id => :fas_login_personenstamm_id,'||unistr('\000a')||
'           p_fas_identitaet_persstamm_';

p:=p||'id => :fas_identitaet_persstamm_id'||unistr('\000a')||
'         );'||unistr('\000a')||
''||unistr('\000a')||
'         if(v_return2 > 0) then -- Beim Kopieren ist was schief gegangen.'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      to_char(v_return2),''perg_set_festlegen''));'||unistr('\000a')||
'         end if;'||unistr('\000a')||
''||unistr('\000a')||
'         :p1_pergebnis_id := v_return;'||unistr('\000a')||
'      ELSIF v_return < 0 THEN -- Fehler beim kopie';

p:=p||'ren'||unistr('\000a')||
'         :p1_bearb_modus := ''ANZEIGEN''; '||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                                      to_char(v_return),''perg_set_festlegen''));'||unistr('\000a')||
'      ELSE -- p1_pergebnis_id is null'||unistr('\000a')||
'         :p1_bearb_modus := ''ANZEIGEN''; '||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id, '||unistr('\000a')||
'                      ';

p:=p||'                ''90'',''perg_set_festlegen''));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Aktuelles Ergebnisset festlegen bzw. anlegen'||unistr('\000a')||
'   IF :p1_pergebnis_id IS NULL THEN'||unistr('\000a')||
'      :p1_pergebnis_id := frgbg_s.perg_set_festlegen('||unistr('\000a')||
'                              :P1_FRAGEBOGEN_ID '||unistr('\000a')||
'                             ,:P1_ID '||unistr('\000a')||
'                             ,''LAST''    -- letzte Version holen, ansonsten neue erzeugen'||unistr('\000a')||
'            ';

p:=p||'                 ,v_sprache_id'||unistr('\000a')||
'                             ,NULL      -- Kuraufenthalt-ID'||unistr('\000a')||
'                            );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Defaultwerte festlegen'||unistr('\000a')||
'   IF :p1_bearb_modus = ''BEARBEITEN'' THEN'||unistr('\000a')||
'      v_return := frgbg_s.perg_set_default_ant(:p1_pergebnis_id);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         NULL;   -- Keine Fehlerausgabe bei Konvertierungsproblemen => Fehler wird in Protokoll festge';

p:=p||'halten '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* NEI 17.09.12 Verrechnungsland wird nach neuer Ermittlung wie im WK durchgefuehrt'||unistr('\000a')||
'   -- Verrechnungsland setzen'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      :p95_VERRECHNUNGSLAND := frgbg_s.get_pers_option(:APP_USER,8); -- je nach Betreuereinstellung Kunde/Betreuer'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p95_VERRECHNUNGSLAND := 1; -- Kunde'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Währungsermittlung abh';

p:=p||'ängig vom Flag Verrechnungsland Betreuer oder Kunde'||unistr('\000a')||
'   :p95_waehrung_id := NVL(rezepte.get_id_waehrung_verr(:P1_ID,'||unistr('\000a')||
'                    v(''fas_identitaet_persstamm_id''), -- NEI 14.10.09 :FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                    :p95_VERRECHNUNGSLAND),27);-- sonst CHF'||unistr('\000a')||
'   :p95_verrech_land_id := rezepte.get_land_id_verr(:P1_ID,'||unistr('\000a')||
'                    v(''fas_identitaet_persstamm_id''),-- NEI 14.10';

p:=p||'.09 :FAS_LOGIN_PERSONENSTAMM_ID,   '||unistr('\000a')||
'                    :p95_VERRECHNUNGSLAND) ;'||unistr('\000a')||
'   */'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'--------'||unistr('\000a')||
'   -- Default-Daten Verrechnungsland und Währung setzen'||unistr('\000a')||
'   -- Bestimmen Rechnungs-/Lieferadresse des Kunden'||unistr('\000a')||
'   -- Falls keine abweichende Lieferadr  kommen Werte für mwst_jn vom Kunde'||unistr('\000a')||
'   SELECT    NVL(p.PERSSTAMM_ID_RECHNUNG,:P95_PERSONENSTAMM_ID),'||unistr('\000a')||
'             NVL(p.PERSSTAMM_ID_LIEFERUNG,:P95_PERSON';

p:=p||'ENSTAMM_ID)'||unistr('\000a')||
'   INTO   v_PERSSTAMM_ID_RECHNUNG,v_PERSSTAMM_ID_LIEFERUNG'||unistr('\000a')||
'   FROM personenstamm p'||unistr('\000a')||
'   WHERE p.id = :P95_PERSONENSTAMM_ID;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Bestimmung prod. Apo'||unistr('\000a')||
'   v_persstamm_id_prod_apo := frgbg_s.get_pers_option(:APP_USER,21);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Bestimmung Rechnungssteller: Default prod. Apo'||unistr('\000a')||
'   v_persstamm_id_rechsteller := v_persstamm_id_prod_apo;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Bestimmung Verrechnungsland'||unistr('\000a')||
'   -- Verrechnungsland';

p:=p||'_id wird gemaess Rechnungssteller bzw. Lieferadr vom Patient bestimmt'||unistr('\000a')||
'   :p95_verrech_land_id := rezepte.GET_VERRECHNUNGSLAND_ID('||unistr('\000a')||
'                                v_PERSSTAMM_ID_LIEFERUNG, v_persstamm_id_rechsteller);'||unistr('\000a')||
''||unistr('\000a')||
'   :p95_waehrung_id:= rezepte.get_id_waehrung(:p95_verrech_land_id);'||unistr('\000a')||
'------------'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   -- Prüfe Existenz der passenden Preisliste; ggf. wird die Waehrung an die Stdpreisliste angepas';

p:=p||'st'||unistr('\000a')||
'   v_preislistentyp := rezepte.get_preislisten_typ(      -- NEI 06.05.13 Einfuehrung mit/ohne Mwst PL'||unistr('\000a')||
'                :p95_verrech_land_id,'||unistr('\000a')||
'                v_persstamm_id_rechsteller,'||unistr('\000a')||
'                v_persstamm_id_prod_apo,'||unistr('\000a')||
'                :fas_identitaet_persstamm_id,'||unistr('\000a')||
'                :P95_PERSONENSTAMM_ID,  -- Kunde'||unistr('\000a')||
'                v_persstamm_id_rechnung,'||unistr('\000a')||
'                v_persstamm_id_liefe';

p:=p||'rung );  '||unistr('\000a')||
'   v_sortiment_id := NVL(v(''FAS_SORTIMENT_ID''),         -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                           rezepte.GET_SORTIMENT_STD);  -- Standard-Sortiment der oberste Identitaet'||unistr('\000a')||
'   v_preisliste_id := rezepte.get_preisliste_id(:p95_waehrung_id,:p95_verrech_land_id ,'||unistr('\000a')||
'                         v_preislistentyp,v_sortiment_id); '||unistr('\000a')||
'   :p95_waehrung_zeichen := rezepte.GET_WAEHR';

p:=p||'UNG_ZEICHEN(:p95_waehrung_id);'||unistr('\000a')||
'   :p95_preisliste_id := v_preisliste_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Art_mwst_typ_id für Mischungen ermitteln'||unistr('\000a')||
'   /* NEI 17.04.15 Über Fkt., da Ausnahme bei ApoRichter EU-Export => Lebensmittel'||unistr('\000a')||
'   SELECT min(art_mwst_typ_id) into :p95_art_mwst_typ_id'||unistr('\000a')||
'   FROM laender'||unistr('\000a')||
'   WHERE id = :p95_verrech_land_id ; '||unistr('\000a')||
'   */'||unistr('\000a')||
'   :p95_art_mwst_typ_id := rezepte.GET_ART_MWST_TYP_ID_MISCHUNG (:p95_verrech_l';

p:=p||'and_id,v_persstamm_id_rechsteller);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Preisfaktor festlegen'||unistr('\000a')||
'   /* NEI 09.10.14 Preisfaktor bei prod.Apo der Hepart/Richter etc. immer 1 => unabhängig wie der Preisfaktor bei der Identität steht'||unistr('\000a')||
'   :p95_preisfaktor := to_number(frgbg_s.get_pers_option(NULL,23,v(''fas_identitaet_persstamm_id''),'||unistr('\000a')||
'                                :FAS_LOGIN_PERSONENSTAMM_ID),''FM0.0999'');'||unistr('\000a')||
'   */'||unistr('\000a')||
'   :p95_preisfaktor :=';

p:=p||' frgbg_s.WK_GET_PREISFAKTOR (:FAS_LOGIN_PERSONENSTAMM_ID,         -- Betreuer'||unistr('\000a')||
'                                                   :fas_identitaet_persstamm_id, -- Ident'||unistr('\000a')||
'                                                   v_persstamm_id_prod_apo );    -- Prod Apo'||unistr('\000a')||
'  '||unistr('\000a')||
'   -- Modus-Parameter für den MNI-Druck (Auswertungsdruck):'||unistr('\000a')||
'   -- 1 = Druck ohne Produktteil für Iabc/Eovital (FAS-SCHEMA-ID = 3)'||unistr('\000a')||
'   -- ';

p:=p||'0 = Druck komplett'||unistr('\000a')||
'   IF :FAS_SCHEMA_ID = 3 THEN'||unistr('\000a')||
'      :p95_druckmodus := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p95_druckmodus := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'--MEL.P (''fragebogen_festlegen 0: %1, %2,%3,%4'', v_PROT_ID, ''ERROR'', ''seite 1 fragebogen --festlegen'',:p95_fragebogen_id,:p95_fb_version,:P95_VERRECHNUNGSLAND);'||unistr('\000a')||
''||unistr('\000a')||
'--   MEL.P (''Pis aufgerufen 1 %1, %2,%3,%4'', v_PROT_ID, ''ERROR'', ''seite 1 fragebogen festlegen'','||unistr('\000a')||
'--v(''fas_identit';

p:=p||'aet_persstamm_id''),:FAS_LOGIN_PERSONENSTAMM_ID,:p1_waehrung_id);'||unistr('\000a')||
''||unistr('\000a')||
'  /* APEX_UTIL.SET_PREFERENCE(        '||unistr('\000a')||
'             p_preference => ''FSP_LANGUAGE_PREFERENCE'','||unistr('\000a')||
'             p_value      => v_sprache,'||unistr('\000a')||
'             p_user       => :APP_USER);'||unistr('\000a')||
'   :p1_text := v_sprache;'||unistr('\000a')||
'  */'||unistr('\000a')||
''||unistr('\000a')||
'/*:p1_text :=  APEX_UTIL.GET_PREFERENCE(      '||unistr('\000a')||
'                   p_preference => ''FSP_LANGUAGE_PREFERENCE'','||unistr('\000a')||
'                 ';

p:=p||'  p_user       => :APP_USER);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5821604285192101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 83,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fragebogen_festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'/* ACHTUNG ist nochmals in default value von :p95_rezeptkosten_nosave definiert '||unistr('\000a')||
'   sobald das Feld nicht angezeigt wird (Endkundenlogin) wird der Wert nur korrekt gesetzt per Prozess'||unistr('\000a')||
'   Aber per Prozess wird er nicht richtig gesetzt, wenn die LOV angezeigt wird (Betreuer-Login)'||unistr('\000a')||
'*/'||unistr('\000a')||
':P95_REZEPTKOSTEN_NOSAVE := '||unistr('\000a')||
'    rezepte.calc_preis_runden('||unistr('\000a')||
'       rezepte.umrechnen_waehrung('||unistr('\000a')||
'           to_number(f';

p:=p||'rgbg_s.get_pers_option(:APP_USER,17),''99999999.99999999''),'||unistr('\000a')||
'           1,27,:p95_waehrung_id)'||unistr('\000a')||
'      ,NULL,10);'||unistr('\000a')||
':P95_REZEPTREICHWEITE_NOSAVE := '||unistr('\000a')||
'    to_number(frgbg_s.get_pers_option(:APP_USER,37),''99999999'');';

wwv_flow_api.create_page_process(
  p_id     => 3731603627973479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 90,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_rezeptkostenvorgabe',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_LETZTE_PERGAUSWERTUNG   VARCHAR2(2000);'||unistr('\000a')||
'   v_rezept VARCHAR2(1000);'||unistr('\000a')||
'   v_datum  Varchar2(100);'||unistr('\000a')||
'   v_kosten VARCHAR2(100);'||unistr('\000a')||
'   v_rezept_nr  mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_version    mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_rezept_nr_split mn_rezepte.REZEPT_NR_SPLITBASIS%TYPE;'||unistr('\000a')||
'   v_mn_rezart       uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_reichweite      prod_rezepte.reichweite%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'   v_LETZTE_PERGAUSWERT';

p:=p||'UNG_2   VARCHAR2(2000);'||unistr('\000a')||
'   v_rezept_2     VARCHAR2(1000);'||unistr('\000a')||
'   v_datum_2      Varchar2(100);'||unistr('\000a')||
'   v_rezept_nr_2  mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_version_2    mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_mn_rezart_2  uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_reichweite_2 prod_rezepte.reichweite%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'   v_sprache_id      NUMBER := :FAS_SPRACHE_ID;'||unistr('\000a')||
'   v_prot_id         NUMBER;'||unistr('\000a')||
'BEGIN   '||unistr('\000a')||
'   :P95_LETZTE_PERGAUSWERTUNG := NULL;'||unistr('\000a')||
'   ';

p:=p||'BEGIN'||unistr('\000a')||
'   SELECT rezept_nr||''/''||version,'||unistr('\000a')||
'       to_char(MAN_GEAENDERT_AM,''DD.MM.YYYY hh24:mi''),'||unistr('\000a')||
'       CASE WHEN NVL(kosten,0) > 0 THEN'||unistr('\000a')||
'           to_char(kosten,''FM99999D00'')||'' ''||rezepte.GET_WAEHRUNG_ZEICHEN(waehrung_id)'||unistr('\000a')||
'       ELSE NULL'||unistr('\000a')||
'       END,'||unistr('\000a')||
'       rezept_nr, version, '||unistr('\000a')||
'       REZEPT_NR_SPLITBASIS, fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',mn_rezart_id,v_sprache_id) mn_rez';

p:=p||'art  -- NEI 26.09.13'||unistr('\000a')||
'   INTO v_rezept, v_datum, v_kosten, v_rezept_nr, v_version, v_rezept_nr_split,v_mn_rezart'||unistr('\000a')||
'   from v_mn_rezepte r, mn_rezarten mnra'||unistr('\000a')||
'   where r.mn_rezart_id = mnra.id'||unistr('\000a')||
'     and r.id ='||unistr('\000a')||
'      (SELECT max(id)'||unistr('\000a')||
'      FROM v_mn_rezepte'||unistr('\000a')||
'      WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'        and satz_kennzeichen is null'||unistr('\000a')||
'        and akt_version = 1'||unistr('\000a')||
'        and status in (0,1)               ';

p:=p||'-- keine ungültigen Rezepte'||unistr('\000a')||
'      );'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN no_data_found THEN'||unistr('\000a')||
'        return;'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Interner Fehler: Unbestimmter Fehler beim Selektieren der letzten Rezepts für Auswertung =''||to_char(:p1_pergebnis_id)||''! [F102/95:get_letzte_pergauswertung,99]''||SQLERRM );'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_rezept is not null THEN'||unistr('\000a')||
''||unistr('\000a')||
'      SELECT reichweite into v_';

p:=p||'reichweite'||unistr('\000a')||
'      FROM prod_rezepte'||unistr('\000a')||
'      WHERE rezept_nr = v_rezept_nr'||unistr('\000a')||
'        AND version = v_version;'||unistr('\000a')||
'      '||unistr('\000a')||
'      :P95_LETZTE_PERGAUSWERTUNG := frgbg_s.holen_uebersetzung(5469,v_sprache_id);'||unistr('\000a')||
'      IF v_kosten is not null and v_version = 2 and  v_rezept_nr_split is null THEN'||unistr('\000a')||
'         v_LETZTE_PERGAUSWERTUNG := frgbg_s.holen_uebersetzung(7998,v_sprache_id,v_rezept,v_datum,v_reichweite) ||'', ''||  ';

p:=p||'  '||unistr('\000a')||
'                                    frgbg_s.holen_uebersetzung(5470,v_sprache_id,v_kosten);'||unistr('\000a')||
'      ELSIF v_version > 2  and v_rezept_nr_split is null THEN'||unistr('\000a')||
'         v_LETZTE_PERGAUSWERTUNG := frgbg_s.holen_uebersetzung(7998,v_sprache_id,v_rezept,v_datum,v_reichweite) ||'', ''||  '||unistr('\000a')||
'                                    frgbg_s.holen_uebersetzung(7919,v_sprache_id);'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_LETZTE_PERGAUSW';

p:=p||'ERTUNG := frgbg_s.holen_uebersetzung(7998,v_sprache_id,v_rezept,v_datum,v_reichweite);'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
''||unistr('\000a')||
'      -- NEI 26.09.13 Prüfen, ob gesplittetes Rezept => beide Mischungen anzeigen'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_rezept_nr_split is not NULL THEN  -- Im Moment werden max. 2 Rezept angezeigt (reicht für Tag/Nacht)'||unistr('\000a')||
'         '||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT rezept_nr||''/''||version,'||unistr('\000a')||
'                to_char(MAN_GEAEN';

p:=p||'DERT_AM,''DD.MM.YYYY hh24:mi''),'||unistr('\000a')||
'                CASE WHEN NVL(kosten,0) > 0 THEN'||unistr('\000a')||
'                     to_char(kosten,''FM99999D00'')||'' ''||rezepte.GET_WAEHRUNG_ZEICHEN(waehrung_id)'||unistr('\000a')||
'                ELSE NULL'||unistr('\000a')||
'                END,'||unistr('\000a')||
'                rezept_nr, version, '||unistr('\000a')||
'                REZEPT_NR_SPLITBASIS, fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',mn_rezart_id,v_sprache_id) mn_rezart  -- NE';

p:=p||'I 26.09.13'||unistr('\000a')||
'            INTO v_rezept_2, v_datum_2, v_kosten, v_rezept_nr_2, v_version_2, v_rezept_nr_split,v_mn_rezart_2'||unistr('\000a')||
'            FROM v_mn_rezepte r, mn_rezarten mnra'||unistr('\000a')||
'            WHERE r.mn_rezart_id = mnra.id'||unistr('\000a')||
'              AND r.id ='||unistr('\000a')||
'                   (SELECT max(id)'||unistr('\000a')||
'                    FROM v_mn_rezepte'||unistr('\000a')||
'                    WHERE REZEPT_NR_SPLITBASIS = v_rezept_nr_split'||unistr('\000a')||
'                     ';

p:=p||' and satz_kennzeichen is null'||unistr('\000a')||
'                      and akt_version = 1'||unistr('\000a')||
'                      and (rezept_nr, version) not in (SELECT v_rezept_nr, v_version from dual)'||unistr('\000a')||
'                   );'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            NULL;'||unistr('\000a')||
'         END; '||unistr('\000a')||
''||unistr('\000a')||
'         -- Kosteneinschränkung für das Gesamtrezept holen '||unistr('\000a')||
'         -- => Kostenangabe nur im Gesamtrezept vorhanden, da Split ohn';

p:=p||'e Kosteneinschränkung arbeit'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT CASE WHEN NVL(kosten,0) > 0 THEN'||unistr('\000a')||
'                     to_char(kosten,''FM99999D00'')||'' ''||rezepte.GET_WAEHRUNG_ZEICHEN(waehrung_id)'||unistr('\000a')||
'                   ELSE NULL'||unistr('\000a')||
'                   END'||unistr('\000a')||
'            INTO v_kosten'||unistr('\000a')||
'            FROM v_mn_rezepte'||unistr('\000a')||
'            WHERE rezept_nr = v_rezept_nr_split'||unistr('\000a')||
'              AND version = 1;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'';

p:=p||'         WHEN others THEN'||unistr('\000a')||
'            NULL;'||unistr('\000a')||
'         END;          '||unistr('\000a')||
'         --obiges Rezept war Split-Rezept => Rezeptart vorhängen und Kosten anhängen von Gesamtrezept aber nur, wenn keine der Splitrezept zwischenzeitlich verändert wurde '||unistr('\000a')||
'         IF v_kosten is not NULL AND v_version= 2 AND v_version_2 = 2 THEN'||unistr('\000a')||
'            v_LETZTE_PERGAUSWERTUNG := v_mn_rezart ||'': ''||v_LETZTE_PERGAUSWERTUNG||';

p:=p||''', ''||'||unistr('\000a')||
'                                    frgbg_s.holen_uebersetzung(5470,v_sprache_id,v_kosten);'||unistr('\000a')||
'         ELSIF  v_version > 2 OR v_version_2 > 2 THEN'||unistr('\000a')||
'            v_LETZTE_PERGAUSWERTUNG := v_mn_rezart ||'': ''||v_LETZTE_PERGAUSWERTUNG||'', ''||'||unistr('\000a')||
'                                    frgbg_s.holen_uebersetzung(7919,v_sprache_id);'||unistr('\000a')||
'         ELSE '||unistr('\000a')||
'            v_LETZTE_PERGAUSWERTUNG := v_mn_rezart ||'': ''|';

p:=p||'|v_LETZTE_PERGAUSWERTUNG ; '||unistr('\000a')||
'         END IF;'||unistr('\000a')||
''||unistr('\000a')||
'         IF v_rezept_2 is not null THEN -- Falls noch 2. Rezept ist das die Tagmischung, da Nachtmischung immer zuletzt erstellt wird'||unistr('\000a')||
''||unistr('\000a')||
'            SELECT max(reichweite) into v_reichweite_2'||unistr('\000a')||
'            FROM prod_rezepte'||unistr('\000a')||
'            WHERE rezept_nr = v_rezept_nr_2'||unistr('\000a')||
'              AND version = v_version_2;'||unistr('\000a')||
'      '||unistr('\000a')||
'            IF v_version_2 = 2 THEN'||unistr('\000a')||
'      ';

p:=p||'         v_LETZTE_PERGAUSWERTUNG_2  := frgbg_s.holen_uebersetzung(7998,v_sprache_id,v_rezept_2,v_datum_2,v_reichweite_2);'||unistr('\000a')||
'            ELSIF v_version_2 > 2 THEN'||unistr('\000a')||
'               v_LETZTE_PERGAUSWERTUNG_2  := frgbg_s.holen_uebersetzung(7998,v_sprache_id,v_rezept_2,v_datum_2,v_reichweite_2) ||'', ''||  '||unistr('\000a')||
'                                             frgbg_s.holen_uebersetzung(7919,v_sprache_id);'||unistr('\000a')||
'         ';

p:=p||'   ELSE'||unistr('\000a')||
'               v_LETZTE_PERGAUSWERTUNG_2  := frgbg_s.holen_uebersetzung(7998,v_sprache_id,v_rezept_2,v_datum_2,v_reichweite_2);'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'            v_LETZTE_PERGAUSWERTUNG := v_mn_rezart_2 ||'': ''||v_LETZTE_PERGAUSWERTUNG_2 ||'', ''||'||unistr('\000a')||
'                     --chr(13)||'||unistr('\000a')||
'                     v_LETZTE_PERGAUSWERTUNG;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;       '||unistr('\000a')||
''||unistr('\000a')||
'      :P95_LETZTE_PERGAUSWERTU';

p:=p||'NG :=  :P95_LETZTE_PERGAUSWERTUNG||'' ''||v_LETZTE_PERGAUSWERTUNG;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   mel.p(''Text für letzte Pergauswertung kann nicht bestimmt werden!''||SQLERRM,v_prot_id,''ERROR'',''[F102/95:get_letzte_pergauswertung,99]'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8255112499565568 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 110,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_letzte_pergauswertung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_rezept VARCHAR2(1000);'||unistr('\000a')||
'   v_datum  Varchar2(100);'||unistr('\000a')||
'   v_kosten VARCHAR2(100);'||unistr('\000a')||
'   v_rezept_nr  mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_version    mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_mn_rezart       uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_reichweite      prod_rezepte.reichweite%TYPE;'||unistr('\000a')||
'   v_split_flag      number;'||unistr('\000a')||
''||unistr('\000a')||
'   v_sprache_id      NUMBER := :FAS_SPRACHE_ID;'||unistr('\000a')||
'   v_prot_id         NUMBER;'||unistr('\000a')||
'BEGIN   '||unistr('\000a')||
'   :P95_LETZ';

p:=p||'TE_PERGAUSWERTUNG := NULL;'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'   SELECT rezept_nr||''/''||version,'||unistr('\000a')||
'       to_char(MAN_GEAENDERT_AM,''DD.MM.YYYY hh24:mi''),'||unistr('\000a')||
'       CASE WHEN NVL(kosten,0) > 0 THEN'||unistr('\000a')||
'           to_char(kosten,''FM99999D00'')||'' ''||rezepte.GET_WAEHRUNG_ZEICHEN(waehrung_id)'||unistr('\000a')||
'       ELSE NULL'||unistr('\000a')||
'       END,'||unistr('\000a')||
'       rezept_nr, version, '||unistr('\000a')||
'       fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',mn_rezart_id,v_sprache_id';

p:=p||') mn_rezart  -- NEI 26.09.13'||unistr('\000a')||
'   INTO v_rezept, v_datum, v_kosten, v_rezept_nr, v_version, v_mn_rezart'||unistr('\000a')||
'   from v_mn_rezepte r, mn_rezarten mnra'||unistr('\000a')||
'   where r.mn_rezart_id = mnra.id'||unistr('\000a')||
'     and r.id ='||unistr('\000a')||
'      (SELECT max(id)'||unistr('\000a')||
'      FROM v_mn_rezepte'||unistr('\000a')||
'      WHERE pergebnis_id = :p1_pergebnis_id'||unistr('\000a')||
'        and satz_kennzeichen is null'||unistr('\000a')||
'        and akt_version = 1'||unistr('\000a')||
'        and status in (0,1)               -- keine u';

p:=p||'ngültigen Rezepte'||unistr('\000a')||
'      );'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN no_data_found THEN'||unistr('\000a')||
'        return;'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Interner Fehler: Unbestimmter Fehler beim Selektieren der letzten Rezepts für Auswertung =''||to_char(:p1_pergebnis_id)||''! [F102/95:get_letzte_pergauswertung,99]''||SQLERRM );'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_rezept is not null THEN'||unistr('\000a')||
''||unistr('\000a')||
'      SELECT reichweite into v_reichweite';

p:=p||''||unistr('\000a')||
'      FROM prod_rezepte'||unistr('\000a')||
'      WHERE rezept_nr = v_rezept_nr'||unistr('\000a')||
'        AND version = v_version;'||unistr('\000a')||
'      v_split_flag := rezepte.CHECK_MNR_SPLIT_EXIST(NULL ,v_rezept_nr, v_version );'||unistr('\000a')||
'      '||unistr('\000a')||
'      :P95_LETZTE_PERGAUSWERTUNG := frgbg_s.holen_uebersetzung(5469,v_sprache_id)||  -- Letztes Produktrezept'||unistr('\000a')||
'                                    v_mn_rezart;                                     -- Gesamtmischung'||unistr('\000a')||
'  ';

p:=p||'    IF v_split_flag > 0 THEN -- mit Split'||unistr('\000a')||
'         :P95_LETZTE_PERGAUSWERTUNG := :P95_LETZTE_PERGAUSWERTUNG ||'' ''||'||unistr('\000a')||
'                  frgbg_s.holen_uebersetzung(9202,:fas_sprache_id);        --mit Split'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      :P95_LETZTE_PERGAUSWERTUNG := :P95_LETZTE_PERGAUSWERTUNG ||'' ''||'||unistr('\000a')||
'           frgbg_s.holen_uebersetzung(7998,v_sprache_id,v_rezept,v_datum,v_reichweite);'||unistr('\000a')||
'      '||unistr('\000a')||
'      -- Manuell ';

p:=p||'geändert? '||unistr('\000a')||
'      -- Kostenanzeige nur falls keine manuelle Änderung bisher erfolgt ist,'||unistr('\000a')||
'      -- sonst nur den Hinweis nachträgl. manuell geändert'||unistr('\000a')||
'      IF  v_version = 2 and v_split_flag = 0 OR '||unistr('\000a')||
'          v_version = 3 and v_split_flag > 0 '||unistr('\000a')||
'      THEN -- keine bisherige manuelle Änderung'||unistr('\000a')||
'          IF v_kosten is not null THEN '||unistr('\000a')||
'             :P95_LETZTE_PERGAUSWERTUNG := :P95_LETZTE_PERGAUSWERTUNG ';

p:=p||'||'', ''||'||unistr('\000a')||
'                                    frgbg_s.holen_uebersetzung(5470,v_sprache_id,v_kosten);'||unistr('\000a')||
'          END IF;'||unistr('\000a')||
'      ELSE -- manuelle Änderung'||unistr('\000a')||
'          :P95_LETZTE_PERGAUSWERTUNG := :P95_LETZTE_PERGAUSWERTUNG ||'', ''||  '||unistr('\000a')||
'                                    frgbg_s.holen_uebersetzung(7919,v_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   mel.p(''Text für letzte Pergauswe';

p:=p||'rtung kann nicht bestimmt werden!''||SQLERRM,v_prot_id,''ERROR'',''[F102/95:get_letzte_pergauswertung,99]'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7373619942992160 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 120,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_letzte_pergauswertung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Setzte den Indikator, das von P1 auf P95 gesprungen werden soll zurück.'||unistr('\000a')||
'  :P140_JUMP_TO_AUSW_PAGE := null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7565709242072784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 130,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Reset  P140_JUMP_TO_AUSW_PAGE',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare '||unistr('\000a')||
'  v_warenkorb_ids varchar2(1000);'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'  -- Wählt alle Warenkörbe aus die direkt mit dem Fragebogen verbunden sind.'||unistr('\000a')||
''||unistr('\000a')||
'  select '':'' || listagg(wk.id,'':'') within group (order by wk.id) || '':'' ids'||unistr('\000a')||
'  into v_warenkorb_ids'||unistr('\000a')||
'  from warenkoerbe wk'||unistr('\000a')||
'  where'||unistr('\000a')||
'    id in(select warenkorb_id'||unistr('\000a')||
'    from warenkorb_details'||unistr('\000a')||
'    where'||unistr('\000a')||
'        pergebnis_id = :P1_PERGEBNIS_ID'||unistr('\000a')||
'    )'||unistr('\000a')||
'    and wk.WK_STATUS_ID in(60,';

p:=p||'61,50);'||unistr('\000a')||
' '||unistr('\000a')||
'  :P95_LABOR_WARENKORB_IDS := v_warenkorb_ids;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5335217993497227 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 95,
  p_process_sequence=> 140,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Setzt Standard Labor Warenkörbe',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'P95_LABOR_WARENKORB_IDS',
  p_process_when_type=>'ITEM_IS_NULL',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 95
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00097
prompt  ...PAGE 97: Auswahl FB-Laboraufträge
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 97
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Auswahl FB-Laboraufträge'
 ,p_step_title => 'Auswahl FB-Laboraufträge'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Auswahl FB-Laboraufträge'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_inline_css => 
'.warenkorb_auswahl td {'||unistr('\000a')||
'  vertical-align:top;'||unistr('\000a')||
'}'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141008155025'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select *'||unistr('\000a')||
'from ('||unistr('\000a')||
'    select'||unistr('\000a')||
'        wk.ID,'||unistr('\000a')||
'        APEX_ITEM.CHECKBOX(p_idx => 1, p_value => wk.id , p_attributes => ''class="liste_checkbox" '' ||'||unistr('\000a')||
'       '' onclick="$(''''.check_all'''').prop(''''checked'''',$(''''.liste_checkbox:checked'''').length == $(''''.liste_checkbox'''').length);"'''||unistr('\000a')||
'        || CASE WHEN INSTR(:P95_LABOR_WARENKORB_IDS,'':'' || wk.ID || '':'') > 0 THEN '' checked="checked"'' ELSE NULL END)  CHECKBOX';

s:=s||','||unistr('\000a')||
'        (select max(wd2.labor_auftrag_id) '||unistr('\000a')||
'         from WARENKORB_DETAILS wd2 '||unistr('\000a')||
'         where '||unistr('\000a')||
'            wd2.WARENKORB_ID = wk.ID'||unistr('\000a')||
'            AND wd2.LABOR_AUFTRAG_ID is not null'||unistr('\000a')||
'        ) LABOR_AUFTRAG_ID,'||unistr('\000a')||
'        (select max(BEZEICHNUNG || '' ('' || l2.ID || '')'') from labors l2, warenkorb_details wd2 where l2.id = wd2.labor_id and wd2.warenkorb_id = wk.ID) LABOR,'||unistr('\000a')||
'        wk.PLANDATUM,'||unistr('\000a')||
'       ';

s:=s||' ''<ul>'' || ('||unistr('\000a')||
'            select'||unistr('\000a')||
'              listagg(''<li style="list-style-position:outside;">'' ||  fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                    wkd.MENGENART_ID,:fas_sprache_id)'||unistr('\000a')||
'                    || '': '' || fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                    wkd.MENGENART_ID,:fas_sprache_id)    || ''</li>'''||unistr('\000a')||
'                 ,'' '')'||unistr('\000a')||
'            ';

s:=s||'  within group (order by fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                wkd.MENGENART_ID,:fas_sprache_id))                              warenkorb_artikel'||unistr('\000a')||
'            from warenkorb_Details wkd'||unistr('\000a')||
'            where wkd.WARENKORB_ID = wk.ID'||unistr('\000a')||
'               and wkd.labor_auftrag_id is not null'||unistr('\000a')||
'               and wkd.PRODKENNZ_ID = 2 -- Nur Labor Fertigartikel'||unistr('\000a')||
'        ) || ''</li>';

s:=s||''' DETAILS'||unistr('\000a')||
'    from'||unistr('\000a')||
'    warenkoerbe wk'||unistr('\000a')||
'    where'||unistr('\000a')||
'       wk.ID in(select warenkorb_id'||unistr('\000a')||
'        from warenkorb_details wd'||unistr('\000a')||
'        where'||unistr('\000a')||
'            labor_auftrag_id is not null'||unistr('\000a')||
'            and warenkorb_id in(select id'||unistr('\000a')||
'                from warenkoerbe'||unistr('\000a')||
'                where persstamm_id_kunde = :P1_ID'||unistr('\000a')||
'            )'||unistr('\000a')||
'        )'||unistr('\000a')||
'       and wk.WK_STATUS_ID in(60,61,50)'||unistr('\000a')||
'    order by ID DESC'||unistr('\000a')||
')'||unistr('\000a')||
'where rownum <=';

s:=s||' 10';

wwv_flow_api.create_report_region (
  p_id=> 5316215857889322 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 97,
  p_name=> '&P97_REGION_TITEL.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => true,
  p_new_grid_column  => true,
  p_display_column=> null,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div class="warenkorb_auswahl" style="min-width:800px; min-height:400px; ">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'No data found.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5316521095889325 + wwv_flow_api.g_id_offset,
  p_region_id=> 5316215857889322 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 2,
  p_column_heading=> 'Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>4,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5321222424638494 + wwv_flow_api.g_id_offset,
  p_region_id=> 5316215857889322 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'CHECKBOX',
  p_column_display_sequence=> 1,
  p_column_heading=> '<input type="checkbox" class="check_all" value="checkall" onclick="$(''.liste_checkbox'').prop(''checked'',$(this).prop(''checked''));"/>',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5321830595665074 + wwv_flow_api.g_id_offset,
  p_region_id=> 5316215857889322 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'LABOR_AUFTRAG_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Auftrag Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_default_sort_dir=>'desc',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5322427920772734 + wwv_flow_api.g_id_offset,
  p_region_id=> 5316215857889322 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'LABOR',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Labor',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>3,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5316621213889327 + wwv_flow_api.g_id_offset,
  p_region_id=> 5316215857889322 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PLANDATUM',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Plandatum',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>2,
  p_default_sort_dir=>'desc',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5316903613889327 + wwv_flow_api.g_id_offset,
  p_region_id=> 5316215857889322 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'DETAILS',
  p_column_display_sequence=> 6,
  p_column_heading=> 'Details',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5323305705831383 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 97,
  p_button_sequence=> 10,
  p_button_plug_id => 5316215857889322+wwv_flow_api.g_id_offset,
  p_button_name    => 'HINZUFUEGEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P97_BUT_LABEL_HINZUFUEGEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5331026650274672 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 97,
  p_branch_name=> 'Go To Page 97',
  p_branch_action=> 'f?p=&APP_ID.:97:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5317517195911623 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 97,
  p_name=>'P97_REGION_TITEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5316215857889322+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5327230958014354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 97,
  p_name=>'P97_BUT_LABEL_HINZUFUEGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5316215857889322+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5327501446047749 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 97
 ,p_name => 'Checkboxen Alle ausgewählt Check'
 ,p_event_sequence => 10
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5327809547047750 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 97
 ,p_event_id => 5327501446047749 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '$(document).ready(function() {'||unistr('\000a')||
'  $(''.check_all'').prop(''checked'',$(''.liste_checkbox:checked'').length == $(''.liste_checkbox'').length);'||unistr('\000a')||
'});'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'  -- Setzte die Labels der Elemente'||unistr('\000a')||
'  :P97_REGION_TITEL := frgbg_s.holen_uebersetzung(11176,:FAS_SPRACHE_ID);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Button'||unistr('\000a')||
'  :P97_BUT_LABEL_HINZUFUEGEN := frgbg_s.holen_uebersetzung(11177,:FAS_SPRACHE_ID);'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5318028796929710 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 97,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set item labels',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
''||unistr('\000a')||
'  -- Das Feld liegt auf dem Auswertungstab für die Druckoptionen bereit'||unistr('\000a')||
'  :P95_LABOR_WARENKORB_IDS := null;'||unistr('\000a')||
''||unistr('\000a')||
'  FOR i in 1..apex_application.g_f01.count LOOP'||unistr('\000a')||
'            '||unistr('\000a')||
'     :P95_LABOR_WARENKORB_IDS := :P95_LABOR_WARENKORB_IDS || '':'' '||unistr('\000a')||
'        || apex_application.g_f01(i); '||unistr('\000a')||
'        '||unistr('\000a')||
'  END LOOP;'||unistr('\000a')||
''||unistr('\000a')||
' :P95_LABOR_WARENKORB_IDS := '':'' || ltrim(:P95_LABOR_WARENKORB_IDS,'':'') || '':'';'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5326432735990530 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 97,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Laborauftrag Auswahl speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>5323305705831383 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Auswahl gespeichert',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 97
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00098
prompt  ...PAGE 98: Upload FB Datei
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 98
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Upload FB Datei'
 ,p_step_title => 'Upload FB Datei'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140114154416'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7200408654514751 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 98,
  p_plug_name=> '&P98_PAGE_TITLE_UPLOAD.',
  p_region_name=>'',
  p_region_attributes=> 'style="min-width:400px; width:98%;"',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 7201731426540200 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 98,
  p_button_sequence=> 10,
  p_button_plug_id => 7200408654514751+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P98_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>7233401753190529 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 98,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7201731426540200+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 30-DEC-2013 18:11 by SASCHA.LENZ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7200822853518810 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 98,
  p_name=>'P98_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 7200408654514751+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7201222984528350 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 98,
  p_name=>'P98_DATEI_UPLOAD',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 7200408654514751+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Datei',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_FILE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'WWV_FLOW_FILES',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7253515687643589 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 98,
  p_name=>'P98_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 7200408654514751+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Speichern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Speichern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7253702312649216 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 98,
  p_name=>'P98_PAGE_TITLE_UPLOAD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 7200408654514751+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_blob        blob;'||unistr('\000a')||
'   v_clob        clob;'||unistr('\000a')||
'   v_dateiname   varchar2(2000);'||unistr('\000a')||
'   v_mimetype    varchar2(2000);'||unistr('\000a')||
'   v_anz         number;'||unistr('\000a')||
'   '||unistr('\000a')||
'   v_return        number;'||unistr('\000a')||
'   v_fehlermeldung varchar2(2000);'||unistr('\000a')||
'   v_fehlernummer  number;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'   v_fehler        EXCEPTION;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P98_DATEI_UPLOAD IS NULL or :P98_ID IS NULL THEN'||unistr('\000a')||
'      --''Es wurde keine Datei angegeben!553';

p:=p||'1'';'||unistr('\000a')||
'      v_fehlermeldung := frgbg_s.holen_uebersetzung(9170,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlernummer := -10;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Holen der Datei'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      select'||unistr('\000a')||
'         blob_content,'||unistr('\000a')||
'         filename,'||unistr('\000a')||
'         mime_type'||unistr('\000a')||
'      into v_blob, v_dateiname, v_mimetype'||unistr('\000a')||
'      from wwv_flow_files '||unistr('\000a')||
'      where name = :P98_DATEI_UPLOAD;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others then '||unistr('\000a')||
'      v_feh';

p:=p||'lermeldung := SQLERRM;'||unistr('\000a')||
'      -- ''Hochladevorgang der Datei konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'      v_fehlermeldung := frgbg_s.holen_uebersetzung(5523,:fas_sprache_id) ||'' ''||v_fehlermeldung;'||unistr('\000a')||
'      v_fehlernummer := -20;'||unistr('\000a')||
'      RAISE v_fehler;  '||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   FRGBG_S.SPEICHERN_DATEI('||unistr('\000a')||
'      P_PERGEBNIS_ID    => :P1_PERGEBNIS_ID'||unistr('\000a')||
'      ,P_SPRACHE_ID     => :FAS_SPRACHE_ID'||unistr('\000a')||
'      ,P_ID_STRING      => :P';

p:=p||'98_ID'||unistr('\000a')||
'      ,P_DATEINAME      => v_dateiname'||unistr('\000a')||
'      ,P_MIME_TYPE      => v_mimetype'||unistr('\000a')||
'      ,P_DATEI          => v_blob'||unistr('\000a')||
'      ,o_fehler         => v_fehlermeldung'||unistr('\000a')||
'      ,P_KENNZEICHEN    =>''einmal'''||unistr('\000a')||
'   );'||unistr('\000a')||
''||unistr('\000a')||
'   if(v_fehlermeldung is not null) then'||unistr('\000a')||
'       v_fehlernummer := -30;'||unistr('\000a')||
'       RAISE v_fehler;'||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
' /*'||unistr('\000a')||
'   '||unistr('\000a')||
'*/ '||unistr('\000a')||
'   -- Lösche die Datei wieder aus der Datenbank'||unistr('\000a')||
'   delete from wwv_flow_files whe';

p:=p||'re name = :P98_DATEI_UPLOAD;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Datei wurde erfolgreich geladen'||unistr('\000a')||
'   apex_application.g_print_success_message := frgbg_s.holen_uebersetzung(5526,:FAS_SPRACHE_ID);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   mel.p(v_fehlermeldung,v_prot_id,''ERROR'',''102/98: Datei Abspeichern[''||v_fehlernummer||'']'');'||unistr('\000a')||
'   raise_application_error(-20000,v_fehlermeldung);    '||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   v_fehlermeldung := ''Interner FEHLER';

p:=p||' beim Laden der Datei! ''||'' ''|| SQLERRM;'||unistr('\000a')||
'   v_fehlernummer:= -9999;'||unistr('\000a')||
'   mel.p(v_fehlermeldung,v_prot_id,''ERROR'',''102/98: Datei Abspeichern[''||v_fehlernummer||'']'');'||unistr('\000a')||
'   raise_application_error(-20000,v_fehlermeldung); '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7224225116683353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 98,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Datei Abspeichern',
  p_process_sql_clob => p,
  p_process_error_message=> '#SQLERRM_TEXT#',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>7201731426540200 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  v_display_only number;'||unistr('\000a')||
'  v_personenstamm_id number;'||unistr('\000a')||
'  v_fragebogen_id number;'||unistr('\000a')||
'  v_frage_id number;'||unistr('\000a')||
'  v_fantwort_id number;'||unistr('\000a')||
'  v_persantwort_id number;'||unistr('\000a')||
''||unistr('\000a')||
'  v_fehlermeldung varchar2(2000);'||unistr('\000a')||
'  v_fehlernummer number;'||unistr('\000a')||
'  v_fehler exception;'||unistr('\000a')||
'  v_prod_id number;'||unistr('\000a')||
'  v_datei blob;'||unistr('\000a')||
'  v_dateiname varchar2(2000);'||unistr('\000a')||
'  v_mimetype varchar2(100);'||unistr('\000a')||
'  e_ERROR_D exception;'||unistr('\000a')||
'  PRAGMA EXCEPTION_INIT(e_ERROR_D,-20000)';

p:=p||';'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'    FRGBG_S.HOLEN_IDS('||unistr('\000a')||
'     P_ID                 => :P98_ID'||unistr('\000a')||
'     ,P_PERSONENSTAMM_ID  => v_personenstamm_id'||unistr('\000a')||
'     ,P_FRAGEBOGEN_ID     => v_fragebogen_id'||unistr('\000a')||
'     ,P_FRAGE_ID          => v_frage_id'||unistr('\000a')||
'     ,P_FANTWORT_ID       => v_fantwort_id'||unistr('\000a')||
'     ,P_PERSANTWORT_ID    => v_persantwort_id'||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'    begin '||unistr('\000a')||
'      select df.beschreibung, du.dokument, du.MIME_TYPE '||unistr('\000a')||
'       into v_dateiname, v_datei,';

p:=p||' v_mimetype'||unistr('\000a')||
'      from dokumente_fas df, dokumentuebersetzungen du, persantworten pantw'||unistr('\000a')||
'      where'||unistr('\000a')||
'         pantw.pergebnis_id = :P1_PERGEBNIS_ID '||unistr('\000a')||
'         and pantw.fantwort_id = v_fantwort_id'||unistr('\000a')||
'         and pantw.frage_id = v_frage_id'||unistr('\000a')||
'         and pantw.fantwort_dokument_fas_id = df.id'||unistr('\000a')||
'         and du.dokument_id = df.id'||unistr('\000a')||
'         and du.sprache_id = uebersetzung.get_abs_basis_sprache_id;'||unistr('\000a')||
'    exce';

p:=p||'ption'||unistr('\000a')||
'      when no_data_found then'||unistr('\000a')||
'         v_dateiname := null;'||unistr('\000a')||
'         v_datei := null;'||unistr('\000a')||
'      when others then'||unistr('\000a')||
'         v_fehlermeldung := ''Beim holen der FB Antwortdatei ist ein Fehler aufgetreten fantwort_id:'' || v_fantwort_id || '' pergebnis_id:'' || :P1_PERGEBNIS_ID;'||unistr('\000a')||
'         v_fehlernummer := -10;'||unistr('\000a')||
'         raise v_fehler;'||unistr('\000a')||
'    end;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    if(v_datei is not null) then'||unistr('\000a')||
'       UTIL_DATEIEN.DOWNL';

p:=p||'OAD_DATEI('||unistr('\000a')||
'          p_datei     => v_datei,'||unistr('\000a')||
'          p_dateiname => v_dateiname,'||unistr('\000a')||
'          p_mimetype  => v_mimetype'||unistr('\000a')||
'       );'||unistr('\000a')||
''||unistr('\000a')||
'      apex_application.g_unrecoverable_error := true;'||unistr('\000a')||
'    else'||unistr('\000a')||
'       raise_application_error(-20000,frgbg_s.holen_uebersetzung(9170,:FAS_SPRACHE_ID));'||unistr('\000a')||
'    end if;'||unistr('\000a')||
'exception '||unistr('\000a')||
'  when v_fehler then'||unistr('\000a')||
'      Mel.P(v_fehlermeldung,v_prod_id,''ERROR'',''Download Datei 102/98 ['' ||';

p:=p||' v_fehlernummer || ''] '' ||dbms_utility.format_error_backtrace);'||unistr('\000a')||
'      raise_application_error(-20000,frgbg_s.holen_uebersetzung(9175,:FAS_SPRACHE_ID));'||unistr('\000a')||
'  when e_ERROR_D then'||unistr('\000a')||
'      raise;'||unistr('\000a')||
'  when others then'||unistr('\000a')||
'      v_fehlermeldung := ''unbekannter Fehler aufgetreten beim herunterladen der FB Antwortdatei '' || sqlerrm;'||unistr('\000a')||
'      v_fehlernummer := -999;'||unistr('\000a')||
'      Mel.P(v_fehlermeldung,v_prod_id,''ERROR'',''Downloa';

p:=p||'d Datei 102/98 ['' || v_fehlernummer || ''] '' ||dbms_utility.format_error_backtrace);'||unistr('\000a')||
'      raise_application_error(-20000,frgbg_s.holen_uebersetzung(9175,:FAS_SPRACHE_ID));'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7250212056330295 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 98,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Download Datei',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in(''DOWNLOAD_FILE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Test',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p98_bl_speichern := frgbg_s.holen_uebersetzung(9135,v_sprache_id);'||unistr('\000a')||
'   :P98_PAGE_TITLE_UPLOAD:= frgbg_s.holen_uebersetzung(9135,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7253200449639223 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 98,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 98
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00099
prompt  ...PAGE 99: Upload Dynamic Actions
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 99
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Upload Dynamic Actions'
 ,p_step_title => 'Upload Dynamic Actions'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script type="text/javascript" >'||unistr('\000a')||
'<!--'||unistr('\000a')||
' $(document).ready(function() { '||unistr('\000a')||
''||unistr('\000a')||
'   if(parent.document) {'||unistr('\000a')||
'       // Lade die Skripte aus dem iFrame in das Hauptfenster'||unistr('\000a')||
'       // Die Skripte müssen snychron abgerufen werden, damit die inline Skripte nicht möglicherweise fehlschlagen'||unistr('\000a')||
'       parent.jQuery.ajaxSetup({async:false});'||unistr('\000a')||
'       '||unistr('\000a')||
'       // Erst alle Skript-Dateien laden'||unistr('\000a')||
'       $(''body script[src]'').each(function() { '||unistr('\000a')||
'          var $this = $(this);'||unistr('\000a')||
'          if($(''script[src="'' + $this.attr(''src'') + ''"]'',parent.document).length === 0) {'||unistr('\000a')||
'             parent.jQuery.getScript($this.attr(''src''));  '||unistr('\000a')||
'          }           '||unistr('\000a')||
'       });'||unistr('\000a')||
'       // Die Skripte müssen snychron abgerufen werden'||unistr('\000a')||
'       parent.jQuery.ajaxSetup({async:true});'||unistr('\000a')||
''||unistr('\000a')||
'       // inline Skripte'||unistr('\000a')||
'       $(''body script'').each(function() { '||unistr('\000a')||
'         var $this = $(this);'||unistr('\000a')||
'           '||unistr('\000a')||
'         if(!$this.attr(''src'')) {'||unistr('\000a')||
'            '||unistr('\000a')||
'            var exists = false;'||unistr('\000a')||
'            // Prüfe ob es das Skript schon so gibt'||unistr('\000a')||
'            $(''script'',parent.document).each(function() {'||unistr('\000a')||
'               '||unistr('\000a')||
'               if(!exists && $.trim($(this).text()) == $.trim($this.text())) {'||unistr('\000a')||
'                  exists = true;'||unistr('\000a')||
'               }'||unistr('\000a')||
'            });'||unistr('\000a')||
''||unistr('\000a')||
'            if(exists === false) {'||unistr('\000a')||
'                var script = document.createElement("script");'||unistr('\000a')||
'                script.type  = "text/javascript";'||unistr('\000a')||
'         '||unistr('\000a')||
'                script.text = $this.html();'||unistr('\000a')||
'                parent.document.body.appendChild(script);'||unistr('\000a')||
''||unistr('\000a')||
'                delete script;'||unistr('\000a')||
'            }'||unistr('\000a')||
'         }'||unistr('\000a')||
'         '||unistr('\000a')||
'       }); '||unistr('\000a')||
''||unistr('\000a')||
'       // Hänge alle Input Felder um, die die Skripte möglicherweise referenzieren'||unistr('\000a')||
'       $(''body input[id]'').each(function() {'||unistr('\000a')||
'          var $this = $(this);'||unistr('\000a')||
''||unistr('\000a')||
'          //Prüfe ob gleiches Feld schon vorhanden ist'||unistr('\000a')||
'          if($(''input[id="'' + $this.attr(''id'') + ''"]'',parent.document).length === 0) {'||unistr('\000a')||
'             $(''form'',parent.document).append(this);  // Hänge es ins Form element von der Elternseite'||unistr('\000a')||
'          }'||unistr('\000a')||
'       });   '||unistr('\000a')||
''||unistr('\000a')||
'       $(''link[href]'').each(function() {'||unistr('\000a')||
'          var $this = $(this);'||unistr('\000a')||
'          //Prüfe ob gleiches Feld schon vorhanden ist'||unistr('\000a')||
'          if($(''link[href="'' + $this.attr(''href'') + ''"]'',parent.document).length === 0) {'||unistr('\000a')||
'             $(''head'',parent.document).append(this);  // Hänge es in den Baum von der Elternseite'||unistr('\000a')||
'          }'||unistr('\000a')||
'       });     '||unistr('\000a')||
'  }'||unistr('\000a')||
'});'||unistr('\000a')||
'-->'||unistr('\000a')||
'</script>'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140515090058'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8648700822436980 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 99,
  p_plug_name=> 'fragebogen_upload',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'AFTER_HEADER',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_plug_display_when_condition => '(:APP_PAGE_ID >= 2 and :APP_PAGE_ID <= 10)'||unistr('\000a')||
'or '||unistr('\000a')||
'(:APP_PAGE_ID >= 31 and :APP_PAGE_ID <=35)',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_header=> '<div style="display:block">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8648932760436980 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 99,
  p_name=>'P99_FB_UPLOAD_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 8648700822436980+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8649105816436981 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 99,
  p_name=>'P99_FB_UPLOAD_REFESH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 8648700822436980+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 4000,
  p_cHeight=> 4,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8649300420436981 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 99,
  p_name=>'P99_TIME_PICKER_CONF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 8648700822436980+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'replace(replace(frgbg_s.holen_uebersetzung(9728,:FAS_SPRACHE_ID),chr(10),''''),chr(13),'''')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8649519093436981 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 99,
  p_name=>'P99_DATE_PICKER_CONF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 8648700822436980+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'replace(replace(frgbg_s.holen_uebersetzung(9729,:FAS_SPRACHE_ID),chr(10),''''),chr(13),'''')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8649726511436981 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 99,
  p_name=>'P99_FB_UPLOAD_DEL_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 8648700822436980+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select frgbg_s.holen_uebersetzung(9174,:FAS_SPRACHE_ID) from dual',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8649924661436982 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 99,
  p_name=>'P99_FB_UPLOAD_CONFIRM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 8648700822436980+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'0',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8650101158436982 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 99,
  p_name=>'P99_UPLOAD_DOWNLOAD_LINK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 8648700822436980+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select APEX_UTIL.PREPARE_URL(''f?p='' || :APP_ID || '':98:&SESSION.:DOWNLOAD_FILE:NO::'') as url from dual',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8621905448621534 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_name => 'Merke Fokus auf FB Upload Feld'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.upl_container'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
 ,p_display_when_cond => 'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'||unistr('\000a')||
''
  );
wwv_flow_api.create_page_da_action (
  p_id => 8622215697621535 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8621905448621534 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '#P99_FB_UPLOAD_ID'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => '/* liefert den ID-String (Hidden-Feld) der alle Infos bezüglich der FB-Antwort enthält */'||unistr('\000a')||
'$(this.triggeringElement).find(''input[name=\"f01\"][id=\"upl_hi_'' + $(this.triggeringElement).attr(''id'').substr(6) + ''\"]'').val()'||unistr('\000a')||
''
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8622313066623738 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_name => 'Öffne FB Upload Modal Fenster'
 ,p_event_sequence => 30
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.upl_button'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
 ,p_display_when_cond => 'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'||unistr('\000a')||
''
  );
wwv_flow_api.create_page_da_action (
  p_id => 8623018495623740 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8622313066623738 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 5
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '#P99_FB_UPLOAD_ID'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => '/* liefert den ID-String (Hidden-Feld) der alle Infos bezüglich der FB-Antwort enthält */'||unistr('\000a')||
'/* Das ID Feld muss hier gesetzt werden, da nicht garantiert werden kann, das die Merke Dynamic Action vor dieser hier ausgelöst wird. Grund bisher unbekannt */'||unistr('\000a')||
'$(this.triggeringElement).parent().find(''input[name=\"f01\"][id=\"upl_hi_'' + $(this.triggeringElement).parent().attr(''id'').substr(6) + ''\"]'').val()'
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8622811490623739 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8622313066623738 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 6
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin'||unistr('\000a')||
'  :P98_ID := :P99_FB_UPLOAD_ID;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P99_FB_UPLOAD_ID'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8622610952623739 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8622313066623738 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_attribute_01 => 'Upload'
 ,p_attribute_02 => 'STATIC'
 ,p_attribute_03 => 'f?p=&APP_ID.:98:&APP_SESSION.:::::'
 ,p_attribute_06 => '#MESSAGE.t1success'
 ,p_attribute_07 => 'STATIC_PX'
 ,p_attribute_08 => '200'
 ,p_attribute_09 => '700'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8623122070626381 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_name => 'Schließe FB Upload Modal Fenster'
 ,p_event_sequence => 40
 ,p_triggering_element_type => 'DOM_OBJECT'
 ,p_triggering_element => 'document'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE|DYNAMIC ACTION|modalpageautoclose'
 ,p_da_event_comment => 'Keine Condition, da das FAS dadurch extrem verlangsamt wird'||unistr('\000a')||
'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'
  );
wwv_flow_api.create_page_da_action (
  p_id => 8623405345626382 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8623122070626381 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'v_message = this.data.$modalPageCloseObject;'||unistr('\000a')||
'$(''.t1messages'').after( v_message );'||unistr('\000a')||
'$(''#MESSAGE.t1success'').delay(2000).fadeOut(2000);'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8623631495626382 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8623122070626381 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'declare'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
' -- Hol den Inhalt des Uploadfeldes'||unistr('\000a')||
' :P99_FB_UPLOAD_REFESH := FRGBG_S.ERZEUGEN_FELDER_UPLOAD('||unistr('\000a')||
'      p_pergebnis_id   => :P1_PERGEBNIS_ID'||unistr('\000a')||
'      , p_fantwort_id  => to_number(substr(:P99_FB_UPLOAD_ID,26,8))'||unistr('\000a')||
'      , p_sprache_id   => :FAS_SPRACHE_ID'||unistr('\000a')||
' );'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P99_FB_UPLOAD_ID'
 ,p_attribute_03 => 'P99_FB_UPLOAD_REFESH,P99_FB_UPLOAD_ID'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8623727958628042 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_name => 'Lösche FB Upload'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.upl_delete_link'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'click'
 ,p_display_when_cond => 'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'||unistr('\000a')||
''
  );
wwv_flow_api.create_page_da_action (
  p_id => 8624219369628044 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8623727958628042 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '#P99_FB_UPLOAD_CONFIRM'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => 'confirm($v(''P99_FB_UPLOAD_DEL_TEXT'')) ? 1 : 0'
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8624001679628043 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8623727958628042 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'declare'||unistr('\000a')||
'  v_display_only number;'||unistr('\000a')||
'  v_personenstamm_id number;'||unistr('\000a')||
'  v_fragebogen_id number;'||unistr('\000a')||
'  v_frage_id number;'||unistr('\000a')||
'  v_fantwort_id number;'||unistr('\000a')||
'  v_persantwort_id number;'||unistr('\000a')||
''||unistr('\000a')||
'  v_fehlermeldung varchar2(2000);'||unistr('\000a')||
'  v_fehlernummer number;'||unistr('\000a')||
'  v_fehler exception;'||unistr('\000a')||
'  e_ERROR_D exception;'||unistr('\000a')||
'  PRAGMA EXCEPTION_INIT(e_ERROR_D,-20000);'||unistr('\000a')||
'  v_prod_id number;'||unistr('\000a')||
'begin'||unistr('\000a')||
'  if(:P99_FB_UPLOAD_ID is not null) then'||unistr('\000a')||
''||unistr('\000a')||
'    Mel.P(''lösche FB Upload id: '' || :P99_FB_UPLOAD_ID,v_prod_id,''TEST'');'||unistr('\000a')||
''||unistr('\000a')||
'    FRGBG_S.HOLEN_IDS('||unistr('\000a')||
'     P_ID                 => :P99_FB_UPLOAD_ID'||unistr('\000a')||
'     ,P_PERSONENSTAMM_ID  => v_personenstamm_id'||unistr('\000a')||
'     ,P_FRAGEBOGEN_ID     => v_fragebogen_id'||unistr('\000a')||
'     ,P_FRAGE_ID          => v_frage_id'||unistr('\000a')||
'     ,P_FANTWORT_ID       => v_fantwort_id'||unistr('\000a')||
'     ,P_PERSANTWORT_ID    => v_persantwort_id'||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'    if(:P99_FB_UPLOAD_CONFIRM = ''1'') then'||unistr('\000a')||
''||unistr('\000a')||
'      v_display_only :=  NVL(FRGBG_S.FB_CHECK_FANT_DISPLAYONLY('||unistr('\000a')||
'            p_pergebnis_id                  => :P1_PERGEBNIS_ID,'||unistr('\000a')||
'            p_FANTWORT_ID                   => v_fantwort_id'||unistr('\000a')||
'      ),0);'||unistr('\000a')||
''||unistr('\000a')||
'      if(v_display_only = 1) then'||unistr('\000a')||
'          raise_application_error(-20000,frgbg_s.holen_uebersetzung(9171,:FAS_SPRACHE_ID));'||unistr('\000a')||
'      end if;'||unistr('\000a')||
''||unistr('\000a')||
'      begin'||unistr('\000a')||
'      delete from persantworten '||unistr('\000a')||
'      where'||unistr('\000a')||
'          fantwort_id = v_fantwort_id'||unistr('\000a')||
'          and pergebnis_id = :P1_PERGEBNIS_ID'||unistr('\000a')||
'          and frage_id = v_frage_id'||unistr('\000a')||
'          and fantwort_dokument_fas_id is not null;'||unistr('\000a')||
'      exception'||unistr('\000a')||
'      when others then'||unistr('\000a')||
'          v_fehlermeldung := ''Fehler beim Löschen der FB Antwort-Datei fantwort_id: '' || v_fantwort_id || '' pergebnis_id: '' || sqlerrm '||unistr('\000a')||
'             ||:P1_PERGEBNIS_ID;'||unistr('\000a')||
'          v_fehlernummer := -10;'||unistr('\000a')||
'          raise v_fehler;'||unistr('\000a')||
'      end;'||unistr('\000a')||
'     end if;'||unistr('\000a')||
''||unistr('\000a')||
'     -- Hol den Inhalt des Uploadfeldes'||unistr('\000a')||
'    :P99_FB_UPLOAD_REFESH := FRGBG_S.ERZEUGEN_FELDER_UPLOAD('||unistr('\000a')||
'      p_pergebnis_id   => :P1_PERGEBNIS_ID'||unistr('\000a')||
'      , p_fantwort_id  => v_fantwort_id'||unistr('\000a')||
'      , p_sprache_id   => :FAS_SPRACHE_ID'||unistr('\000a')||
'    );   '||unistr('\000a')||
'  end if;   '||unistr('\000a')||
''||unistr('\000a')||
'      '||unistr('\000a')||
'  '||unistr('\000a')||
'exception '||unistr('\000a')||
'  when v_fehler then'||unistr('\000a')||
'      Mel.P(v_fehlermeldung,v_prod_id,''ERROR'',''dynamic_action lösche DB Upload ['' || v_fehlernummer || ''] '' ||dbms_utility.format_error_backtrace);'||unistr('\000a')||
'      raise_application_error(-20000,frgbg_s.holen_uebersetzung(9173,:FAS_SPRACHE_ID));'||unistr('\000a')||
'  when e_ERROR_D then'||unistr('\000a')||
'      raise;'||unistr('\000a')||
'  when others then'||unistr('\000a')||
'      v_fehlermeldung := ''unbekannter Fehler in Dynamic Action aufgetreten '' || sqlerrm;'||unistr('\000a')||
'      v_fehlernummer := -999;'||unistr('\000a')||
'      Mel.P(v_fehlermeldung,v_prod_id,''ERROR'',''dynamic_action lösche DB Upload ['' || v_fehlernummer || ''] '' ||dbms_utility.format_error_backtrace);'||unistr('\000a')||
'      raise_application_error(-20000,frgbg_s.holen_uebersetzung(9173,:FAS_SPRACHE_ID));'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P99_FB_UPLOAD_ID,P99_FB_UPLOAD_CONFIRM'
 ,p_attribute_03 => 'P99_FB_UPLOAD_REFESH'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8624305579631065 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_name => 'Aktualisiere FB Upload Feld'
 ,p_event_sequence => 60
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '#P99_FB_UPLOAD_REFESH'
 ,p_triggering_condition_type => 'NOT_NULL'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'change'
 ,p_display_when_cond => 'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'||unistr('\000a')||
''
  );
wwv_flow_api.create_page_da_action (
  p_id => 8624627977631065 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8624305579631065 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '/* ersetzt den Inhalt des Uploadfeldes nach dem Button (Enthält Links und Dateinamen) */'||unistr('\000a')||
'if($v(''P99_FB_UPLOAD_ID'') != null && $v(''P99_FB_UPLOAD_REFESH'') != null) {'||unistr('\000a')||
'   $(''div:[id$="'' + parseInt($v(''P99_FB_UPLOAD_ID'').substr(26,8).trim()) + '||unistr('\000a')||
'     ''"][class="upl_sub_container"]'').replaceWith($v(''P99_FB_UPLOAD_REFESH''));'||unistr('\000a')||
''||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8624713197633249 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_name => 'Download FB Upload Datei'
 ,p_event_sequence => 70
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.upl_download_link'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'click'
 ,p_display_when_cond => 'FRGBG_S.CHECK_PAGE_IST_FB_TAB(:APP_PAGE_ID)'||unistr('\000a')||
''
  );
wwv_flow_api.create_page_da_action (
  p_id => 8625226610633250 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8624713197633249 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin'||unistr('\000a')||
'  :P98_ID := :P99_FB_UPLOAD_ID;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P99_FB_UPLOAD_ID'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 8625023233633250 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 99
 ,p_event_id => 8624713197633249 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'redirect($v(''P99_UPLOAD_DOWNLOAD_LINK'')); '
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 99
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00100
prompt  ...PAGE 100: Loginverteiler
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 100
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Loginverteiler'
 ,p_alias => 'LOGINVERTEILER'
 ,p_step_title => 'Loginverteiler'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2882731585489434 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'Y'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909143139'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4735726741518421 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 100,
  p_plug_name=> '&P100_PAGE_TITEL_LOGIN.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891602476489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4744913430754226 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 100,
  p_button_sequence=> 10,
  p_button_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_button_name    => 'BETREUER_LOGIN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P100_BL_BETREUER_LOGIN.',
  p_button_position=> 'TOP',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4745408020762056 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 100,
  p_button_sequence=> 20,
  p_button_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_button_name    => 'KUNDEN_LOGIN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P100_BL_KUNDEN_LOGIN.',
  p_button_position=> 'TOP',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4797802463766493 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 100,
  p_button_sequence=> 30,
  p_button_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_button_name    => 'UEBERSETZER_LOGIN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P100_BL_UEBERSETZER_LOGIN.',
  p_button_position=> 'TOP',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4736201468524235 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:124:P124_APP_SPRACHE_ID_PARAM:&P100_APP_SPRACHE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4745408020762056+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 5,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4745203270754234 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:121:&SESSION.::&DEBUG.:121:P121_APP_SPRACHE_ID_PARAM:&P100_APP_SPRACHE_ID.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4744913430754226+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4798209651787431 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:122:P122_APP_SPRACHE_ID_PARAM:&P100_APP_SPRACHE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4797802463766493+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 15,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 28-NOV-2008 11:06 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4746501188816829 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:100:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 18-NOV-2008 15:08 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3420312271931293 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_name=>'P100_WARTUNG_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4742307338787212 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_name=>'P100_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_VERTEILER"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT s.sprache, s.id'||unistr('\000a')||
'FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'order by 1'||unistr('\000a')||
''||unistr('\000a')||
'/* NEI 24.09.09 kein Optionstyp mehr für sprachen sondern schema in app_sprachen'||unistr('\000a')||
'SELECT sprache, '||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, pers_optionen po , optionstypen ot    /* Subsetzugriff * /'||unistr('\000a')||
'where po.opttyp_id = ot.id  /* JOIN OT * /'||unistr('\000a')||
'  and ot.art = 1        /* Subset * /'||unistr('\000a')||
'  and po.opttyp_id = 23  /* Sprachen * /'||unistr('\000a')||
'  and ow.id = po.wert'||unistr('\000a')||
'  /* Persid des Subsets sonst null * /'||unistr('\000a')||
'  and po.persstamm_id = :p100_pers_opt_persstamm_id '||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Appsprachen (statt Optionswerte), da keine Subsetdef. od. da Def.wertverwaltg* /'||unistr('\000a')||
'SELECT sprache,'||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, optionstypen ot'||unistr('\000a')||
'where ot.id = 23 /* Sprachen* /'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden* /'||unistr('\000a')||
'       :p100_pers_opt_persstamm_id  IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset * /'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1  '||unistr('\000a')||
'*/',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4742611971798082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_name=>'P100_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprache Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4743112795807778 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_name=>'P100_BL_BETREUER_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Betreuer Login',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4743319721809714 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_name=>'P100_BL_KUNDEN_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Kunden Login',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4743501844814100 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_name=>'P100_PAGE_TITEL_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Login',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4798602856794909 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 100,
  p_name=>'P100_BL_UEBERSETZER_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 4735726741518421+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Uebersetzer Login',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3420032572927636 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 100,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_wartung',
  p_validation_sequence=> 5,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_text   varchar2(4000);'||unistr('\000a')||
'   v_liste  varchar2(4000);'||unistr('\000a')||
'   v_flag   NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p100_wartung_flag := 0;'||unistr('\000a')||
'   SELECT to_number(parameter) INTO v_flag'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 10;'||unistr('\000a')||
'   SELECT parameter INTO v_liste'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 11;'||unistr('\000a')||
'--mel.p(''Wartungsflag:%1, Text %2'',v_prot_id,''INFO'',''FAS102/100: check_wartung'',v_flag,:P100_HINWEIS);'||unistr('\000a')||
'   IF v_flag = 1 and  -- Generelles Wartungsflag'||unistr('\000a')||
'      -- Check USER, die während der Wartung arbeiten dürfen '||unistr('\000a')||
'      --instr(UPPER(v_liste),'';''||UPPER(:p100_username)||'';'') = 0 and  '||unistr('\000a')||
'      -- Check Applikation, die gewartet werden'||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:APP_ID)||'';'') = 0    '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p100_wartung_flag := 1;'||unistr('\000a')||
'      v_text := frgbg_s.holen_uebersetzung(10,:p100_sprache_id);'||unistr('\000a')||
'      IF v_text is null or v_text = ''.'' THEN'||unistr('\000a')||
'         v_text := ''System is not available because of system maintaince! Please try again later.'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      RETURN v_text;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p100_wartung_flag := 0;'||unistr('\000a')||
'      RETURN null;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz      NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN   '||unistr('\000a')||
'/*MEL.P (''1 Schema setzen:%1, pers %2'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Prozessüberwachung'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      -- FAS-Schema über Servername ermitteln'||unistr('\000a')||
'      :fas_schema_id := frgbg_s.get_fas_schema_srv;'||unistr('\000a')||
'   ELSE -- Check gültiges Schemaangabe?'||unistr('\000a')||
'  ';

p:=p||'    BEGIN'||unistr('\000a')||
'         SELECT count(*) INTO v_anz'||unistr('\000a')||
'         FROM fas_schemas'||unistr('\000a')||
'         WHERE id = :fas_schema_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'          v_anz := 0;'||unistr('\000a')||
'      END ;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz = 0 THEN -- FAlls ungültig über Servername ermitteln'||unistr('\000a')||
'         :fas_schema_id := frgbg_s.get_fas_schema_srv;           '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   :FAS_THEME_NAME:= ''fas_theme_''||:fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- ';

p:=p||'Holen der Persstamm_id für das FAS-Schema'||unistr('\000a')||
'   --:fas_schema_persstamm_id := frgbg_s.get_pers_fas_schema(:fas_schema_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Fas-Modus setzen abhängig vom Schema'||unistr('\000a')||
'   SELECT fas_modus_id into :fas_modus_id'||unistr('\000a')||
'   FROM fas_schemas'||unistr('\000a')||
'   WHERE id = :fas_schema_id;'||unistr('\000a')||
'/* NEI 24.09.09 FAS-Schema über Servername ermitteln'||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      :fas_schema_id := frgbg_s.get_fas_schema_std;'||unistr('\000a')||
'   EN';

p:=p||'D IF;'||unistr('\000a')||
'   -- Holen der Persstamm_id für das FAS-Schema'||unistr('\000a')||
'   :fas_schema_persstamm_id := frgbg_s.get_pers_fas_schema(:fas_schema_id);'||unistr('\000a')||
'   -- Holen der Persstamm_id für die entsprechende Pers_option des Sprachen-Subsets'||unistr('\000a')||
'   :P100_PERS_OPT_PERSSTAMM_ID := '||unistr('\000a')||
'                  frgbg_s.GET_PERS_OPT_PERS_ID(:fas_schema_persstamm_id,23,'||unistr('\000a')||
'                                               :fas_schema_persstamm_id);'||unistr('\000a')||
'*';

p:=p||'/'||unistr('\000a')||
'/*MEL.P (''Schema setzen:%1, pers %2,%3'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Prozessüberwachung'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2770317497502682 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 100,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_fas_schema_fas_modus',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_sprache varchar2(50);'||unistr('\000a')||
'   v_anz        NUMBER;'||unistr('\000a')||
'   c owa_cookie.cookie;'||unistr('\000a')||
'   v_sprache_id NUMBER;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''0 app_sprache_setzen: Appsp %1, sprache %2, appsp param %3, owa %4,pos %5'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Page 121'','||unistr('\000a')||
'           to_char(:p121_app_sprache_id),'||unistr('\000a')||
'           to_char(v_sprache_id),:p121_app_sprache_id_param,'||unistr('\000a')||
'           owa_util.get_cgi_env';

p:=p||'(''HTTP_ACCEPT_LANGUAGE''),'||unistr('\000a')||
'          instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
'     -- Zunaechst aus Cookie  => Cookie wird nur in Login-Masken angelegt    -- NEI 6.6.11 '||unistr('\000a')||
'     BEGIN                                            '||unistr('\000a')||
'        c := owa_cookie.get(''FAS_SPRACHE_COOKIE'');    '||unistr('\000a')||
'        -- Check, ob Sprache zum Schema passt, sonst Sprache ungueltig => Browsersprache'||unistr('\000a')||
' ';

p:=p||'       SELECT count(*) into v_anz'||unistr('\000a')||
'        FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'        WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'          AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'          AND s.id =c.vals(1)'||unistr('\000a')||
'          AND s.aktiv=1;  -- NEI 09.09.2014'||unistr('\000a')||
'        IF v_anz > 0 THEN'||unistr('\000a')||
'           :P100_APP_SPRACHE_ID:= c.vals(1);          '||unistr('\000a')||
'        ELSE'||unistr('\000a')||
'           :P100_APP_SPRACHE_ID:=NULL;'||unistr('\000a')||
'        END IF;'||unistr('\000a')||
'   ';

p:=p||'  exception '||unistr('\000a')||
'     when others then '||unistr('\000a')||
'           :P100_APP_SPRACHE_ID:=NULL;               '||unistr('\000a')||
'     end;                                             -- NEI 6.6.11'||unistr('\000a')||
''||unistr('\000a')||
'     IF :P100_APP_SPRACHE_ID IS NULL THEN             -- NEI 6.6.11 '||unistr('\000a')||
'        -- Browsersprache holen und abgleichen mit App-Sprachen für das Schema'||unistr('\000a')||
'        BEGIN'||unistr('\000a')||
'           v_sprache := NVL(substr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE'')';

p:=p||', 1,'||unistr('\000a')||
'                        instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')-1),''en'');'||unistr('\000a')||
'        EXCEPTION'||unistr('\000a')||
'        WHEN others THEN'||unistr('\000a')||
'           v_sprache := ''en'';'||unistr('\000a')||
'        END;'||unistr('\000a')||
'        :p100_app_sprache_id := frgbg_s.get_browser_sprache(v_sprache);'||unistr('\000a')||
'     END IF;                                       -- NEI 6.6.11 '||unistr('\000a')||
''||unistr('\000a')||
' /* NEI 24.09.09 Kein Optionstyp für Sprachen mehr sondern über Schema in app_sp';

p:=p||'rachen'||unistr('\000a')||
'      IF :fas_schema_id = 2 THEN  -- Biogena '||unistr('\000a')||
'         -- Default des Sprachsubsets entsprechend der Schemavorgabe'||unistr('\000a')||
'         :p100_app_sprache_id := '||unistr('\000a')||
'                frgbg_s.get_pers_option(NULL,23,:fas_schema_persstamm_id,  '||unistr('\000a')||
'                                                :fas_schema_persstamm_id);'||unistr('\000a')||
'      ELSE '||unistr('\000a')||
'         -- Abgleich der Browser-Sprache mit dem entsprechenden Sprachsubset'||unistr('\000a')||
'    ';

p:=p||'     v_sprache := substr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                     instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''), '','')-1);'||unistr('\000a')||
'         :p100_app_sprache_id := frgbg_s.get_browser_sprache(v_sprache, '||unistr('\000a')||
'                     :P100_PERS_OPT_PERSSTAMM_ID);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4742021406781853 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 100,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'app_sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'Y',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   SELECT sprache_id into :p100_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p100_app_sprache_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6687521740002181 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 100,
  p_process_sequence=> 65,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   /* NEI obsolet, da es Schemaspezif. App-Sprachen gibt'||unistr('\000a')||
'   IF :p100_app_sprache_id IS NULL THEN'||unistr('\000a')||
'      SELECT NVL(min(parameter),3) into :p100_app_sprache_id '||unistr('\000a')||
'      from sysareas_frgbg'||unistr('\000a')||
'      where id = 5; -- Default App-Sprache'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT sprache_id into :p100_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p100_app_sprache_id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   :p100_bl_betreuer_login := frgbg_s.holen';

p:=p||'_uebersetzung(2445,:p100_sprache_id);'||unistr('\000a')||
'   :p100_bl_kunden_login := frgbg_s.holen_uebersetzung(2446,:p100_sprache_id);'||unistr('\000a')||
'   :p100_bl_uebersetzer_login := frgbg_s.holen_uebersetzung(2467,:p100_sprache_id);'||unistr('\000a')||
'   :p100_page_titel_login := frgbg_s.holen_uebersetzung(2447,:p100_sprache_id);'||unistr('\000a')||
' END;';

wwv_flow_api.create_page_process(
  p_id     => 4741814826779985 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 100,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 100
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00101
prompt  ...PAGE 101: Anmelden
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 101
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Anmelden'
 ,p_alias => 'LOGIN'
 ,p_step_title => 'Anmelden'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
''||unistr('\000a')||
'function ersetzumlaute(str) {'||unistr('\000a')||
'  str = str.replace(''ü'',''ue'').replace(''Ü'',''UE'');'||unistr('\000a')||
'  str = str.replace(''ö'',''oe'').replace(''Ö'',''OE'');'||unistr('\000a')||
'  str = str.replace(''ä'',''ae'').replace(''Ä'',''AE'');'||unistr('\000a')||
'  str = str.replace(''ß'',''s'');'||unistr('\000a')||
'  str = str.replace(''é'',''e'').replace(''É'',''E'');'||unistr('\000a')||
'  str = str.replace(''è'',''e'').replace(''È'',''E'');'||unistr('\000a')||
''||unistr('\000a')||
' return str;'||unistr('\000a')||
'}'
 ,p_step_template => 2882731585489434 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'Y'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909143321'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5866608638597989 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 101,
  p_plug_name=> '&P101_PAGE_TITEL_HINWEIS.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890721784489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 30,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => 'frgbg_s.holen_uebersetzung(10,:p101_sprache_id) !=''.''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7166822898739504 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 101,
  p_plug_name=> '&P101_PAGE_TITEL_ANMELDUNG.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>1735407750415127 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:106:&SESSION.::&DEBUG.:106:P106_USER_ACCOUNT,P106_SPRACHE_ID,P106_ZURUECK_SEITE:&P101_USERNAME.,&P101_SPRACHE_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 5,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p101_hinweis_pw is null and :request = ''Passwort''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 29-MAR-2011 12:56 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>6429928350026678 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:101:&SESSION.:PW_HINWEIS:&DEBUG.:101:P101_HINWEIS_PW:&P101_HINWEIS_PW.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3824514331224615+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'NEVER',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 09-NOV-2010 09:24 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>2020108175283923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:105:P105_APP_SPRACHE_ID:&P101_APP_SPRACHE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2015232454243639+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 16-AUG-2006 14:04 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4144908041349782 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:104::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4015828963272465+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 50,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 30-AUG-2007 10:04 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>3877730446460920 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 28-AUG-2007 11:09 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2015232454243639 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_NEU_REGISTRIEREN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'NEU',
  p_prompt=>'&P101_BL_NEU_REGISTRIEREN.',
  p_source=>'NEU',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3419416202866113 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_WARTUNG_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3824514331224615 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_PASSWORT_VERGESSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'Passwort',
  p_prompt=>'&P101_BL_PASSWORT_VERGESSEN.',
  p_source=>'Passwort',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3863729950299921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_HINWEIS_PW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3906019325555370 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT s.sprache, s.id'||unistr('\000a')||
'FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'order by 1'||unistr('\000a')||
''||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3914102674673537 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_BENUTZER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3989212004993129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_BL_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3990032436999087 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_BL_NEU_REGISTRIEREN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3990910403002129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_BL_PASSWORT_VERGESSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4015828963272465 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_BENUTZER_VERGESSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'Benutzer',
  p_prompt=>'&P101_BL_BENUTZER_VERGESSEN.',
  p_source=>'Benutzer',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4016914203277675 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_BL_BENUTZER_VERGESSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4027416926950237 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_PAGE_TITEL_ANMELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4089417412735823 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4769420232803906 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_APP_SPRACHE_ID_PARAM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'App Sprache Id Param',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5866913997597998 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 171,
  p_item_plug_id => 5866608638597989+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(10,:p101_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5867732365642681 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_PAGE_TITEL_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 141,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Hinweis',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7166917904739514 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_USERNAME',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7167016376739521 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_PASSWORD',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_PASSWORD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_encrypt_session_state_yn=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7167116652739521 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_LOGIN',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> '',
  p_item_default=> 'LOGIN',
  p_prompt=>'&P101_BL_LOGIN.',
  p_source=>'LOGIN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8948528080661921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_ANMELDEN_ANONYM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'Anonym',
  p_prompt=>'&P101_BL_ANONYM_LOGIN.',
  p_source=>'Anonym',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9308424036739348 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 101,
  p_name=>'P101_BL_ANONYM_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 7166822898739504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3419103389862494 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_wartung',
  p_validation_sequence=> 5,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_text   varchar2(4000);'||unistr('\000a')||
'   v_liste  varchar2(4000);'||unistr('\000a')||
'   v_flag   NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p101_wartung_flag := 0;'||unistr('\000a')||
'   SELECT to_number(parameter) INTO v_flag'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 10;'||unistr('\000a')||
'   SELECT parameter INTO v_liste'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 11;'||unistr('\000a')||
'--mel.p(''Wartungsflag:%1, Text %2'',v_prot_id,''INFO'',''FAS102/101: check_wartung'',v_flag,:P101_HINWEIS);'||unistr('\000a')||
'   IF v_flag = 1 and  -- Generelles Wartungsflag'||unistr('\000a')||
'      -- Check USER, die während der Wartung arbeiten dürfen '||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:p101_username)||'';'') = 0 and  '||unistr('\000a')||
'      -- Check Applikation, die gewartet werden'||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:APP_ID)||'';'') = 0    '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p101_wartung_flag := 1;'||unistr('\000a')||
'      v_text := frgbg_s.holen_uebersetzung(10,:p101_sprache_id);'||unistr('\000a')||
'      IF v_text is null or v_text = ''.'' THEN'||unistr('\000a')||
'         v_text := ''System is not available because of system maintaince! Please try again later.'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      RETURN v_text;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p101_wartung_flag := 0;'||unistr('\000a')||
'      RETURN null;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4598332719303789 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_gueltiges_login',
  p_validation_sequence=> 20,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz_login        personenstamm.login_fehlversuche%TYPE;'||unistr('\000a')||
'   v_anz_max_login    personenstamm.login_fehlversuche%TYPE;'||unistr('\000a')||
'   v_personenstamm_id personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fas_schema_id_pers personenstamm.id%TYPE;'||unistr('\000a')||
'   v_text             varchar2(2000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'-- Solange noch keine Abgrenzung zwischen Kunde und Gutschein-Kunde vorhanden ist'||unistr('\000a')||
'-- ist das Kunden-Login gesperrt => ENDKUNDEN-Login nur über Page 123(Anonym) bzw. 124(Gutschein-Verfahren)'||unistr('\000a')||
'RETURN (frgbg_s.holen_uebersetzung(476,:p101_sprache_id));'||unistr('\000a')||
''||unistr('\000a')||
'   -- Sperren des Logins nach n Fehlversuchen'||unistr('\000a')||
'   :p101_username:=TRIM(UPPER (:p101_username));'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT NVL(min(parameter),10) INTO v_anz_max_login'||unistr('\000a')||
'      FROM sysareas_frgbg'||unistr('\000a')||
'      WHERE id = 4;'||unistr('\000a')||
'      SELECT login_fehlversuche,id INTO v_anz_login, v_personenstamm_id'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE user_account = TRIM(UPPER (:p101_username));'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN '||unistr('\000a')||
'       NULL;'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF v_anz_login >= 9999.001 THEN'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(3830,:p101_sprache_id));'||unistr('\000a')||
'   ELSIF v_anz_login >= v_anz_max_login THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(477,:p101_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Schema-Prüfung'||unistr('\000a')||
'   v_fas_schema_id_pers := frgbg_s.get_fas_schema(v_personenstamm_id,''KUNDE'');'||unistr('\000a')||
'   IF v_fas_schema_id_pers = :fas_schema_id THEN'||unistr('\000a')||
'      NULL; -- alles ok'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p101_sprache_id));   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   IF frgbg_s.VALID_USER (:p101_username,:p101_password) THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET app_sprache_id = :p101_app_sprache_id,'||unistr('\000a')||
'             login_fehlversuche = 0'||unistr('\000a')||
'         WHERE id = v_personenstamm_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN OTHERS THEN '||unistr('\000a')||
'          NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET login_fehlversuche = login_fehlversuche +1'||unistr('\000a')||
'         WHERE id = v_personenstamm_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN OTHERS THEN '||unistr('\000a')||
'          NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p101_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request not in (''NEU'',''Passwort'',''Benutzer'') and '||unistr('\000a')||
':p101_WARTUNG_FLAG = 0',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6431300963491920 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_neues_pw',
  p_validation_sequence=> 30,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_PERSSTAMM_ID_MAILABSENDER personenstamm.id%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID personenstamm.id%TYPE;'||unistr('\000a')||
'   v_betreuer     personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_email     personenstamm.email%TYPE;'||unistr('\000a')||
'   v_anz_login number;'||unistr('\000a')||
'   v_return    NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p101_username IS NULL THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(447,:p101_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT login_fehlversuche,id, email, betreuer'||unistr('\000a')||
'      INTO v_anz_login, v_persstamm_id,v_email, v_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE user_account = UPPER (:p101_username);'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      -- Fehler Benutzer ist unbekannt!'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(446,:p101_sprache_id);'||unistr('\000a')||
'      RETURN (v_fehlertext);'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   IF v_email is null'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3935,:p101_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF v_anz_login != round(v_anz_login) '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3937,:p101_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   Return v_fehlertext;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 3824514331224615 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_PERSSTAMM_ID_MAILABSENDER personenstamm.id%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID personenstamm.id%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_ident personenstamm.id%TYPE;'||unistr('\000a')||
'   v_betreuer     personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_email     personenstamm.email%TYPE;'||unistr('\000a')||
'   v_anz_login number;'||unistr('\000a')||
'   v_return    NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Noch nicht freigegebene Personen login_fehlversuc';

p:=p||'he = 9999.001 führen zu Fehlermeldung'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT login_fehlversuche,id, email,betreuer'||unistr('\000a')||
'      INTO v_anz_login, v_persstamm_id,v_email,v_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE user_account = UPPER (:p101_username);'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(444,:p101_spr';

p:=p||'ache_id,:p101_username)||'||unistr('\000a')||
'                                                    '' (9999a)'';'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,v_fehlertext );     '||unistr('\000a')||
'   END;'||unistr('\000a')||
'   IF v_anz_login != round(v_anz_login) THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(444,:p101_sprache_id,:p101_username)||'||unistr('\000a')||
'                                     ';

p:=p||'               '' (9999b)'';'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,v_fehlertext ); '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Absender: 2.oberste Identität der Standardidentitaet'||unistr('\000a')||
'      v_persstamm_id_ident := frgbg_s.GET_IDENTITAET_KUNDE(NULL,-1,v_persstamm_id);'||unistr('\000a')||
'      v_PERSSTAMM_ID_MAILABSENDER := frgbg_s.get_ident_2oberste(v_persstamm_id_ident,NULL);'||unistr('\000a')||
'      IF v_persstamm_id_mailabsender <= 0 THEN -- Fehler bei der Ermittl';

p:=p||'ung der Identitaet'||unistr('\000a')||
'         -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(444,:p101_sprache_id,:p101_username)||'||unistr('\000a')||
'                                                  '' (''||to_char(v_persstamm_id_mailabsender)||'')'';'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      v_return := frgbg_s.mail_neues_passwort(';

p:=p||':p101_username,'||unistr('\000a')||
'                                              null,'||unistr('\000a')||
'                                              NULL,'||unistr('\000a')||
'                                              NULL,'||unistr('\000a')||
'                                              v_PERSSTAMM_ID_MAILABSENDER,'||unistr('\000a')||
'                                              1, -- PW-change'||unistr('\000a')||
'                                              0, -- no-reply'||unistr('\000a')||
'                              ';

p:=p||'                0 -- P_NOTFALL_EMAIL '||unistr('\000a')||
'                                            );'||unistr('\000a')||
'      IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'         -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(444,:p101_sprache_id,:p101_username)||'||unistr('\000a')||
'                                                    '' (''||to_char(v_return)||'')'';'||unistr('\000a')||
'         RAISE_APPLICATION_ER';

p:=p||'ROR (-20001,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Fehlerversuche auf 0 setzen'||unistr('\000a')||
'      UPDATE personenstamm'||unistr('\000a')||
'      SET login_fehlversuche = 0'||unistr('\000a')||
'      WHERE id = v_persstamm_id;'||unistr('\000a')||
''||unistr('\000a')||
'      :p101_hinweis_pw := frgbg_s.holen_uebersetzung(428,:p101_sprache_id,v_email); '||unistr('\000a')||
' -- mel.p(''PW-text:%1, %2'',v_prot_id,''test'',''pw_mail_versenden'',:p101_hinweis_pw,v_PERSSTAMM_ID_MAILABSENDER);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3865802901339465 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 5,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'PW_mail_versenden',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>3824514331224615 + wwv_flow_api.g_id_offset,
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   owa_util.mime_header(''text/html'', FALSE);'||unistr('\000a')||
'   owa_cookie.send('||unistr('\000a')||
'       name=>''FAS_LOGIN_USERNAME_COOKIE'','||unistr('\000a')||
'       value=>lower(:P101_USERNAME));'||unistr('\000a')||
'   owa_cookie.send('||unistr('\000a')||
'       name=>''FAS_SPRACHE_COOKIE'','||unistr('\000a')||
'       value=>:P101_APP_SPRACHE_ID);'||unistr('\000a')||
'exception '||unistr('\000a')||
'when others then '||unistr('\000a')||
'   null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7167311171739529 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Benutzername-Cookie festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'Anonym',
  p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':fas_aufgerufen_von := ''KUNDE'';'||unistr('\000a')||
':fas_login_page := :APP_PAGE_ID;'||unistr('\000a')||
':fas_sprache_id:= :p101_sprache_id;'||unistr('\000a')||
'/* NEI 20.04.09 in Anwendungsprozess '||unistr('\000a')||
':FAS_ABMELDEN_TEXT := frgbg_s.holen_uebersetzung(174,:p101_sprache_id);'||unistr('\000a')||
':FAS_AENDERUNGWARNUNG_TEXT := frgbg_s.holen_uebersetzung(3068,:p101_sprache_id);'||unistr('\000a')||
':fas_keine_daten_text := frgbg_s.holen_uebersetzung(759,:p101_sprache_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'wwv_flow_custom_auth_std.logi';

p:=p||'n('||unistr('\000a')||
'    P_UNAME       => v(''P101_USERNAME''),'||unistr('\000a')||
'    P_PASSWORD    => v(''P101_PASSWORD''),'||unistr('\000a')||
'    P_SESSION_ID  => v(''APP_SESSION''),'||unistr('\000a')||
'    --P_FLOW_PAGE   => :APP_ID||'':110:&SESSION.::NO::P110_AUFGERUFEN_VON:PERSON'''||unistr('\000a')||
'    P_FLOW_PAGE   => :APP_ID||'':110'''||unistr('\000a')||
'    );';

wwv_flow_api.create_page_process(
  p_id     => 7167225120739523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Login',
  p_process_sql_clob => p,
  p_process_error_message=> 'Ungültiges Login',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'NEU Passwort Benutzer Anonym',
  p_process_when_type=>'REQUEST_NOT_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':fas_aufgerufen_von := ''ANONYM'';'||unistr('\000a')||
':fas_login_page := :APP_PAGE_ID;'||unistr('\000a')||
':fas_sprache_id:= :p101_sprache_id;'||unistr('\000a')||
'/* NEI 20.04.09 in Anwendungsprozess'||unistr('\000a')||
':FAS_ABMELDEN_TEXT := frgbg_s.holen_uebersetzung(174,:p101_sprache_id);'||unistr('\000a')||
':FAS_AENDERUNGWARNUNG_TEXT := frgbg_s.holen_uebersetzung(3068,:p121_sprache_id);'||unistr('\000a')||
':fas_keine_daten_text := frgbg_s.holen_uebersetzung(759,:p101_sprache_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'wwv_flow_custom_auth_std.logi';

p:=p||'n('||unistr('\000a')||
'    P_UNAME       => v(''P101_USERNAME''),'||unistr('\000a')||
'    P_PASSWORD    => v(''P101_PASSWORD''),'||unistr('\000a')||
'    P_SESSION_ID  => v(''APP_SESSION''),'||unistr('\000a')||
'    --P_FLOW_PAGE   => :APP_ID||'':110:&SESSION.::NO::P110_AUFGERUFEN_VON:ANONYM'''||unistr('\000a')||
'    P_FLOW_PAGE   => :APP_ID||'':110'''||unistr('\000a')||
''||unistr('\000a')||
'    );';

wwv_flow_api.create_page_process(
  p_id     => 8960511371726295 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'login_anonym',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>8948528080661921 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 2177705572692193 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'NEU Passwort Benutzer',
  p_process_when_type=>'REQUEST_NOT_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   SELECT id INTO :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE user_account = TRIM(UPPER (:p101_username));'||unistr('\000a')||
''||unistr('\000a')||
'/*   SELECT  ''(''||NAME||''/''||userenv(''sessionid'')||'')'' INTO :FAS_IDENTITAET'||unistr('\000a')||
'   FROM PERSONENSTAMM'||unistr('\000a')||
'   WHERE id = :FAS_LOGIN_PERSONENSTAMM_ID;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- Identität in persarea sessionabhängig ablegen'||unistr('\000a')||
'   /*SELECT sid, osuser into v_session, v_user from v$session where audsid ';

p:=p||'= userenv(''sessionid'');*/'||unistr('\000a')||
'   INSERT INTO persareas (personenstamm_id,AKT_PERSSTAMM_ID_IDENTITAET, session_id )'||unistr('\000a')||
'   VALUES (:FAS_LOGIN_PERSONENSTAMM_ID, :FAS_IDENTITAET_PERSSTAMM_ID,userenv(''sessionid''));'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN '||unistr('\000a')||
'    NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3746405273188075 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'FAS_LOGIN_PERSONENSTAMM_ID_SETZEN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz      NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN   '||unistr('\000a')||
'/*MEL.P (''1 Schema setzen:%1, pers %2'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Prozessüberwachung'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      -- FAS-Schema über Servername ermitteln'||unistr('\000a')||
'      :fas_schema_id := frgbg_s.get_fas_schema_srv;'||unistr('\000a')||
'   ELSE -- Check gültiges Schemaangabe?'||unistr('\000a')||
'  ';

p:=p||'    BEGIN'||unistr('\000a')||
'         SELECT count(*) INTO v_anz'||unistr('\000a')||
'         FROM fas_schemas'||unistr('\000a')||
'         WHERE id = :fas_schema_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'          v_anz := 0;'||unistr('\000a')||
'      END ;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz = 0 THEN -- FAlls ungültig über Servername ermitteln'||unistr('\000a')||
'         :fas_schema_id := frgbg_s.get_fas_schema_srv;           '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   :FAS_THEME_NAME:= ''fas_theme_''||:fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- ';

p:=p||'Holen der Persstamm_id für das FAS-Schema'||unistr('\000a')||
'   --:fas_schema_persstamm_id := frgbg_s.get_pers_fas_schema(:fas_schema_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Fas-Modus setzen abhängig vom Schema'||unistr('\000a')||
'   SELECT fas_modus_id into :fas_modus_id'||unistr('\000a')||
'   FROM fas_schemas'||unistr('\000a')||
'   WHERE id = :fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
'/* NEI 24.09.09 FAS-Schema über Servername ermitteln'||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      :fas_schema_id := frgbg_s.get_fas_schema_std;'||unistr('\000a')||
'   E';

p:=p||'ND IF;'||unistr('\000a')||
'   -- Holen der Persstamm_id für das FAS-Schema'||unistr('\000a')||
'   :fas_schema_persstamm_id := frgbg_s.get_pers_fas_schema(:fas_schema_id);'||unistr('\000a')||
'   -- Holen der Persstamm_id für die entsprechende Pers_option des Sprachen-Subsets'||unistr('\000a')||
'   :P101_PERS_OPT_PERSSTAMM_ID := '||unistr('\000a')||
'                  frgbg_s.GET_PERS_OPT_PERS_ID(:fas_schema_persstamm_id,23,'||unistr('\000a')||
'                                               :fas_schema_persstamm_id);'||unistr('\000a')||
'';

p:=p||'*/'||unistr('\000a')||
'/*MEL.P (''Schema setzen:%1, pers %2,%3'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Prozessüberwachung'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2771115251539839 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_fas_schema_fas_modus',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''alert("''||:p101_hinweis_pw||''");'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   :p101_hinweis_pw := NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6429227732931873 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'pw_hinweis_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request=''PW_HINWEIS''',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'    v varchar2(255) := null;'||unistr('\000a')||
'    c owa_cookie.cookie;'||unistr('\000a')||
'begin'||unistr('\000a')||
'   c := owa_cookie.get(''FAS_LOGIN_USERNAME_COOKIE'');'||unistr('\000a')||
'   :P101_USERNAME := c.vals(1);'||unistr('\000a')||
'exception '||unistr('\000a')||
'when others then '||unistr('\000a')||
'   null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7167402573739529 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Benutzername-Cookie abrufen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_sprache varchar2(50);'||unistr('\000a')||
'   v_anz        NUMBER;'||unistr('\000a')||
'   c owa_cookie.cookie;'||unistr('\000a')||
'   v_sprache_id NUMBER;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''0 app_sprache_setzen: Appsp %1, sprache %2, appsp param %3, owa %4,pos %5'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Page 121'','||unistr('\000a')||
'           to_char(:p121_app_sprache_id),'||unistr('\000a')||
'           to_char(v_sprache_id),:p121_app_sprache_id_param,'||unistr('\000a')||
'           owa_util.get_cgi_env';

p:=p||'(''HTTP_ACCEPT_LANGUAGE''),'||unistr('\000a')||
'          instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'  IF :p101_app_sprache_id_param IS NULL THEN'||unistr('\000a')||
'     -- Zunaechst aus Cookie                          -- NEI 6.6.11 '||unistr('\000a')||
'     BEGIN                                            '||unistr('\000a')||
'        c := owa_cookie.get(''FAS_SPRACHE_COOKIE'');    '||unistr('\000a')||
'        -- Check, ob Sprache zum Schema passt, sonst Sprache unguel';

p:=p||'tig => Browsersprache'||unistr('\000a')||
'        SELECT count(*) into v_anz'||unistr('\000a')||
'        FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'        WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'          AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'          AND s.id =c.vals(1)'||unistr('\000a')||
'          AND s.aktiv=1;  -- NEI 09.09.2014'||unistr('\000a')||
'        IF v_anz > 0 THEN'||unistr('\000a')||
'           :P101_APP_SPRACHE_ID:= c.vals(1);          '||unistr('\000a')||
'        ELSE'||unistr('\000a')||
'           :P101_APP_SPRACHE_ID:=NU';

p:=p||'LL;'||unistr('\000a')||
'        END IF;'||unistr('\000a')||
'     exception '||unistr('\000a')||
'     when others then '||unistr('\000a')||
'           :P101_APP_SPRACHE_ID:=NULL;               '||unistr('\000a')||
'     end;                                             -- NEI 6.6.11'||unistr('\000a')||
'     IF :P101_APP_SPRACHE_ID IS NULL THEN             -- NEI 6.6.11 '||unistr('\000a')||
'        -- Browsersprache holen und abgleichen mit App-Sprachen für das Schema'||unistr('\000a')||
'        BEGIN'||unistr('\000a')||
'           v_sprache := NVL(substr(owa_util.get_cgi_env(''';

p:=p||'HTTP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                        instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')-1),''en'');'||unistr('\000a')||
'        EXCEPTION'||unistr('\000a')||
'        WHEN others THEN'||unistr('\000a')||
'           v_sprache := ''en'';'||unistr('\000a')||
'        END;'||unistr('\000a')||
'        :p101_app_sprache_id := frgbg_s.get_browser_sprache(v_sprache);'||unistr('\000a')||
'     END IF;'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     :p101_app_sprache_id := :p101_app_sprache_id_param;'||unistr('\000a')||
'     :p101_app_sprache_id_param := NULL;'||unistr('\000a')||
'  END I';

p:=p||'F;'||unistr('\000a')||
''||unistr('\000a')||
' /* NEI 24.09.09 Kein Optionstyp für Sprachen mehr sondern über Schema in app_sprachen'||unistr('\000a')||
'  IF :p101_app_sprache_id_param IS NULL THEN'||unistr('\000a')||
'--MEL.P (''1 app_sprache_setzen:%1, Browser %2'',v_prot_id,''Fehler'',''Page 121'');'||unistr('\000a')||
'     IF :fas_schema_id = 2 THEN  -- Biogena '||unistr('\000a')||
'        -- Default des Sprachsubsets entsprechend der Schemavorgabe'||unistr('\000a')||
'        :p101_app_sprache_id := '||unistr('\000a')||
'                frgbg_s.get_pers_option';

p:=p||'(NULL,23,:fas_schema_persstamm_id,  '||unistr('\000a')||
'                                                :fas_schema_persstamm_id);'||unistr('\000a')||
'     ELSE '||unistr('\000a')||
'        -- Abgleich der Browser-Sprache mit dem entsprechenden Sprachsubset'||unistr('\000a')||
'        v_sprache := substr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                        instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''), '','')-1);'||unistr('\000a')||
'        :p101_app_sprache_id := frgbg_s';

p:=p||'.get_browser_sprache(v_sprache, :P101_PERS_OPT_PERSSTAMM_ID);'||unistr('\000a')||
'     END IF;'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     :p101_app_sprache_id := :p101_app_sprache_id_param;'||unistr('\000a')||
'     :p101_app_sprache_id_param := NULL;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12506311953526517 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'app_sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'Y',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   SELECT sprache_id into :p101_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p101_app_sprache_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6688110920018057 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 35,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   /* NEI 24.09.09 Default-Sprache obsolet, da es nun Schemaspezif. App-Sprachen gibt'||unistr('\000a')||
'   IF :p101_app_sprache_id IS NULL THEN'||unistr('\000a')||
'      SELECT NVL(min(parameter),3) into :p101_app_sprache_id '||unistr('\000a')||
'      from sysareas_frgbg'||unistr('\000a')||
'      where id = 5; -- Default App-Sprache'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   SELECT sprache_id into :p101_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p101_app_sprache_id;'||unistr('\000a')||
'   :p101_bl_login :';

p:=p||'= frgbg_s.holen_uebersetzung(430,:p101_sprache_id);'||unistr('\000a')||
'   :P101_BL_PASSWORT_VERGESSEN  := frgbg_s.holen_uebersetzung(429,:p101_sprache_id);'||unistr('\000a')||
'   :p101_bl_neu_registrieren := frgbg_s.holen_uebersetzung(431,:p101_sprache_id);'||unistr('\000a')||
'   :p101_bl_benutzer_vergessen := frgbg_s.holen_uebersetzung(432,:p101_sprache_id);'||unistr('\000a')||
'   :p101_page_titel_anmeldung := frgbg_s.holen_uebersetzung(433,:p101_sprache_id);'||unistr('\000a')||
'   :P101_PAGE_';

p:=p||'TITEL_HINWEIS:=frgbg_s.holen_uebersetzung(3786,:p101_sprache_id);'||unistr('\000a')||
'   :p101_bl_anonym_login := frgbg_s.holen_uebersetzung(739,:p101_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3994405256028998 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_persstamm_id    personenstamm.id%TYPE;'||unistr('\000a')||
'   v_user_account    personenstamm.user_account%TYPE;'||unistr('\000a')||
'   v_passwort        personenstamm.passwort%TYPE;'||unistr('\000a')||
'   v_name            personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname         personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_strasse         personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_nr              personenstamm.nr%TYPE;'||unistr('\000a')||
'   v_plz             personenstamm.plz%TYPE ;'||unistr('\000a')||
'   v_ort  ';

p:=p||'           personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id         personenstamm.land_ID%TYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- User Account festlegen'||unistr('\000a')||
'   select ''ANONYM_''||to_char(anonym_seq.nextval) into v_user_account from dual;'||unistr('\000a')||
'   '||unistr('\000a')||
'   -- Passwort'||unistr('\000a')||
'   v_passwort := frgbg_s.gen_passwort;'||unistr('\000a')||
''||unistr('\000a')||
'   -- ID bestimmen'||unistr('\000a')||
'   SELECT persstamm_seq.nextval INTO v_persstamm_id FROM dual;'||unistr('\000a')||
''||unistr('\000a')||
'   INSERT INTO personenstamm ('||unistr('\000a')||
'                    id,'||unistr('\000a')||
'    ';

p:=p||'                USER_ACCOUNT ,'||unistr('\000a')||
'                    EMAIL ,'||unistr('\000a')||
'                    PASSWORT ,'||unistr('\000a')||
'                    NAME ,'||unistr('\000a')||
'                    VORNAME ,'||unistr('\000a')||
'                    --STRASSE ,'||unistr('\000a')||
'                    --NR ,'||unistr('\000a')||
'                    PLZ ,'||unistr('\000a')||
'                    ORT ,'||unistr('\000a')||
'                    --LAND ,'||unistr('\000a')||
'                    LAND_ID,'||unistr('\000a')||
'                    app_sprache_id'||unistr('\000a')||
'                    --GEBURTSDATUM,'||unistr('\000a')||
'             ';

p:=p||'       --pis_adresse_id,'||unistr('\000a')||
'                    --anrede,'||unistr('\000a')||
'                    --geschlecht,'||unistr('\000a')||
'                    --betreuer,'||unistr('\000a')||
'                    --erfuser, erfdat,mutuser, mutdat'||unistr('\000a')||
'                    )'||unistr('\000a')||
'         VALUES ('||unistr('\000a')||
'                    v_persstamm_id,'||unistr('\000a')||
'                    v_user_account,'||unistr('\000a')||
'                    NULL,  -- v_email ,'||unistr('\000a')||
'                    v_passwort,'||unistr('\000a')||
'                    ''DUMMY'',  -- v_name,'||unistr('\000a')||
'';

p:=p||'                    ''DUMMY'',  -- v_vorname,'||unistr('\000a')||
'                              -- v_strasse,v_nr,'||unistr('\000a')||
'                    NULL,        -- v_plz,'||unistr('\000a')||
'                    NULL,  -- v_ort,'||unistr('\000a')||
'                    --''DUMMY'',  -- v_land,'||unistr('\000a')||
'                    NULL,-- land_id'||unistr('\000a')||
'                    :P101_app_sprache_id'||unistr('\000a')||
'                    --v_geburtsdatum ,'||unistr('\000a')||
'                    --v_pis_adresse_id ,'||unistr('\000a')||
'                    --v_anr';

p:=p||'ede,'||unistr('\000a')||
'                    --v_geschlecht,'||unistr('\000a')||
'                    --v_betreuer,'||unistr('\000a')||
'                    --p_app_user,SYSDATE,p_app_user,SYSDATE'||unistr('\000a')||
'                       );'||unistr('\000a')||
'         :P101_USERNAME := v_user_account;'||unistr('\000a')||
'         :P101_PASSWORD := v_passwort;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8949622670669775 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 40,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'anonymer_user_erstellen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>8948528080661921 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p101_hinweis := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 4214318616516612 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 101,
  p_process_sequence=> 50,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Hinweis_initialisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 101
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00102
prompt  ...PAGE 102: PERSONENSTAMM Passwort ändern
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 102
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'PERSONENSTAMM Passwort ändern'
 ,p_step_title => 'PERSONENSTAMM Passwort ändern'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20110126082242'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5018026601039056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 102,
  p_plug_name=> '&P1_REGION_TITEL_PWD_CHG.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5018205257039056 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 102,
  p_button_sequence=> 30,
  p_button_plug_id => 5018026601039056+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P102_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> 'P102_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5018425611039056 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 102,
  p_button_sequence=> 10,
  p_button_plug_id => 5018026601039056+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P102_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4983422289311314 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 102,
  p_name=>'P102_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5018026601039056+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4984228176312992 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 102,
  p_name=>'P102_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5018026601039056+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Aendern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5018818737039057 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 102,
  p_name=>'P102_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 5018026601039056+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5019015082039057 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 102,
  p_name=>'P102_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5018026601039056+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'User Account',
  p_source=>'USER_ACCOUNT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5019423800039059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 102,
  p_name=>'P102_PASSWORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5018026601039056+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PASSWORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_PASSWORD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_encrypt_session_state_yn=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5033926679126626 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 102,
  p_name=>'P102_PASSWORT_WDH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 5018026601039056+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_PASSWORD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_encrypt_session_state_yn=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5019708891039059 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P102_PASSWORT not null',
  p_validation_sequence=> 40,
  p_validation => 'IF :p102_passwort is null THEN'||unistr('\000a')||
'   --RETURN(''Feld eingabepflichtig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(215,:fas_sprache_id)));'||unistr('\000a')||
'END IF;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Passwort Name muss einen Wert haben.',
  p_validation_condition=> 'CANCEL',
  p_validation_condition_type=> 'REQUEST_NOT_IN_CONDITION',
  p_associated_item=> 5019423800039059 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5036818283143142 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P102_PASSWORT_WDH_is_null',
  p_validation_sequence=> 45,
  p_validation => 'IF :p102_passwort_wdh is null THEN'||unistr('\000a')||
'   --RETURN(''Eingabe pflichtig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(216,:fas_sprache_id)));'||unistr('\000a')||
'END IF;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> 'CANCEL',
  p_validation_condition_type=> 'REQUEST_NOT_IN_CONDITION',
  p_associated_item=> 5033926679126626 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5035214689132621 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P102_PASSWORT_WDH',
  p_validation_sequence=> 50,
  p_validation => 'IF :p102_passwort != :p102_passwort_wdh THEN'||unistr('\000a')||
'   --RETURN(''Passworteingaben sind unterschiedlich!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(243,:fas_sprache_id));'||unistr('\000a')||
'END IF;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> 'CANCEL',
  p_validation_condition_type=> 'REQUEST_NOT_IN_CONDITION',
  p_associated_item=> 5033926679126626 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5808609021927137 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P102_PASSWORT_komplexcheck',
  p_validation_sequence=> 60,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_return   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF UPPER(:p102_passwort) = UPPER(:p102_user_account) THEN'||unistr('\000a')||
'      :p102_passwort := '''';'||unistr('\000a')||
'      :p102_passwort_wdh := '''';'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(3849,:fas_sprache_id));     '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   v_return := frgbg_s.check_passwort(:p102_passwort);'||unistr('\000a')||
'   IF v_return = 0 THEN'||unistr('\000a')||
'      :p102_passwort := '''';'||unistr('\000a')||
'      :p102_passwort_wdh := '''';'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(3769,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> 'CANCEL',
  p_validation_condition_type=> 'REQUEST_NOT_IN_CONDITION',
  p_associated_item=> 5033926679126626 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:PERSONENSTAMM:P102_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 5020330393039060 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from PERSONENSTAMM',
  p_process_sql_clob => p,
  p_process_error_message=> 'Zeile kann nicht abgerufen werden.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'--HTMLDB_UTIL.CHANGE_CURRENT_USER_PW (''schrott'');'||unistr('\000a')||
'DECLARE'||unistr('\000a')||
'   v_anzahl     number;'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;'||unistr('\000a')||
'   fehler       exception;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   UPDATE personenstamm'||unistr('\000a')||
'   SET passwort = :p102_passwort'||unistr('\000a')||
'   WHERE id = :p102_id;'||unistr('\000a')||
'   v_anzahl := sql%rowcount;'||unistr('\000a')||
'   IF v_anzahl != 1 THEN'||unistr('\000a')||
'      RAISE fehler;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN fehler THEN'||unistr('\000a')||
'   RAISE_APPLICATION_ERROR(-20001,frgbg_s.holen_u';

p:=p||'ebersetzung(487,v_sprache_id)||'' ''||'||unistr('\000a')||
'                                  frgbg_s.holen_uebersetzung(242,v_sprache_id));   '||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RAISE_APPLICATION_ERROR(-20000,frgbg_s.holen_uebersetzung(487,v_sprache_id)||'' ''||'||unistr('\000a')||
'                                  frgbg_s.holen_uebersetzung(242,v_sprache_id));'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5029211179103275 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'passwort_aendern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'CANCEL',
  p_process_when_type=>'REQUEST_NOT_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'102';

wwv_flow_api.create_page_process(
  p_id     => 5020724362039060 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'CLOSE_WINDOW';

wwv_flow_api.create_page_process(
  p_id     => 5030701614109935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLOSE_WINDOW',
  p_process_name=> 'Fenster schließen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'htp.p(''<body>'');'||unistr('\000a')||
'htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'htp.p(''window.close(this);'');'||unistr('\000a')||
'htp.p(''</script>'');'||unistr('\000a')||
'htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4226822399714015 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'popup_close',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''POPUP_CLOSE''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p102_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p102_bl_aendern := frgbg_s.holen_uebersetzung(171,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4985215494318775 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 102,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 102
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00103
prompt  ...PAGE 103: Hilfetexte
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 103
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Hilfetexte'
 ,p_alias => 'HILFE'
 ,p_step_title => 'Hilfetexte'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130320173224'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4528207981576610 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 103,
  p_plug_name=> '&P1_REGION_TITEL_HILFETEXTE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2888901989489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4528502552576610 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 103,
  p_button_sequence=> 10,
  p_button_plug_id => 4528207981576610+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P1_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4531821833580635 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 103,
  p_name=>'P103_FRAGE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4528207981576610+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_cattributes_element=>'style="font-size:15; font-weight:bold;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4547905314708342 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 103,
  p_name=>'P103_HILFE_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4528207981576610+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5396005198735445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 103,
  p_name=>'P103_FRAGE_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 65,
  p_item_plug_id => 4528207981576610+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Frage Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5397217318738885 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 103,
  p_name=>'P103_HILFE_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 4528207981576610+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Hilfe Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5403305778877528 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 103,
  p_name=>'P103_SPRACHE_IDX',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4528207981576610+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprache Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'CLOSE_WINDOW';

wwv_flow_api.create_page_process(
  p_id     => 4853415682823432 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 103,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLOSE_WINDOW',
  p_process_name=> 'Fenster schließen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p103_frage_text := frgbg_s.holen_uebersetzung(:p103_frage_text_id,frgbg_s.get_sprache_id(:APP_USER));'||unistr('\000a')||
':p103_hilfe_text := frgbg_s.holen_uebersetzung(:p103_hilfe_text_id,frgbg_s.get_sprache_id(:APP_USER));';

wwv_flow_api.create_page_process(
  p_id     => 4533227159591618 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 103,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hole_hilfetext',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 103
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00104
prompt  ...PAGE 104: Benutzer vergessen
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 104
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Benutzer vergessen'
 ,p_alias => 'BENUTZER_VERGESSEN'
 ,p_step_title => 'Benutzer vergessen'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'Y'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130116102657'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4022014455921189 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 104,
  p_plug_name=> '&P104_PAGE_TITEL_BENUTZERIDENT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4370223536873265 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 104,
  p_plug_name=> 'Hinweis',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2887429229489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_02',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'ITEM_IS_NOT_NULL',
  p_plug_display_when_condition => 'P104_HINWEIS',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4134712010237362 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 104,
  p_button_sequence=> 20,
  p_button_plug_id => 4022014455921189+wwv_flow_api.g_id_offset,
  p_button_name    => 'ABBRECHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P104_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4133631618233546 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 104,
  p_button_sequence=> 10,
  p_button_plug_id => 4022014455921189+wwv_flow_api.g_id_offset,
  p_button_name    => 'PRUEFEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P104_BL_PRUEFEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4133916219233551 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 104,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4133631618233546+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4135008024237362 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 104,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&FLOW_ID.:101:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4134712010237362+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4131724215221954 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 104,
  p_name=>'P104_EMAIL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4022014455921189+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4132502183225060 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 104,
  p_name=>'P104_KUNDENNUMMER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 4022014455921189+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4135618936239325 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 104,
  p_name=>'P104_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4022014455921189+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4136224131240892 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 104,
  p_name=>'P104_BL_PRUEFEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4022014455921189+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4140230935309114 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 104,
  p_name=>'P104_PAGE_TITEL_BENUTZERIDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 4022014455921189+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4369621673863332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 104,
  p_name=>'P104_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4370223536873265+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4246417650240078 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 104,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_eingabe',
  p_validation_sequence=> 10,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :p104_kundennummer IS NULL AND :p104_email IS NULL THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(450,:p101_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :p104_email IS NULL THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:p101_sprache_id,'||unistr('\000a')||
'                  frgbg_s.holen_uebersetzung(203,:p101_sprache_id)));     '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :p104_kundennummer IS NULL THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:p101_sprache_id,'||unistr('\000a')||
'                  frgbg_s.holen_uebersetzung(436,:p101_sprache_id)));     '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 4133631618233546 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4406601312045290 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 104,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P104_EMAIL',
  p_validation_sequence=> 20,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF instr(:p104_email,''@'') <= 1 THEN'||unistr('\000a')||
'      --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(224,:p101_sprache_id));'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'   v_string := substr(:p105_email,instr(:p104_email,''@'')+1,length(:p104_email));'||unistr('\000a')||
'   v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'   IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'      --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(225,:p101_sprache_id));'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'   -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'   IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'      --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(226,:p101_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:p101_sprache_id,'||unistr('\000a')||
'                 frgbg_s.holen_uebersetzung(223,:p101_sprache_id,     '||unistr('\000a')||
'                 frgbg_s.holen_uebersetzung(203,:p101_sprache_id)),'||unistr('\000a')||
'            ''Validierung p105_email_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4133631618233546 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4131724215221954 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return     NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_return := frgbg_s.mail_benutzer_verges(:p104_kundennummer,:p104_email,:p101_sprache_id);'||unistr('\000a')||
'   IF v_return <= 0 THEN'||unistr('\000a')||
'      -- Die Identifikation über Ihre Eingabe war nicht erfolgreich! Bitte...'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(453,:p101_sprache_id)||'||unistr('\000a')||
'                                                    '' (''||to';

p:=p||'_char(v_return)||'')'';'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p104_hinweis := frgbg_s.holen_uebersetzung(451,:p101_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4245108861228142 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 104,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mail_senden',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4133631618233546 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :p101_app_sprache_id IS NULL THEN'||unistr('\000a')||
'      :p101_app_sprache_id := 1; -- Deutsch'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   SELECT sprache_id into :p101_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p101_app_sprache_id;'||unistr('\000a')||
'   :p104_bl_abbrechen := '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(161,:p101_sprache_id);'||unistr('\000a')||
'   :P104_bl_pruefen  := '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(437,:p101_sprache_id);'||unistr('\000a')||
'   :P104_page_titel_benutze';

p:=p||'rident  := '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(434,:p101_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4139303923301260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 104,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p104_hinweis := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 4371518126881206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 104,
  p_process_sequence=> 20,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Hinweis initialisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 104
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00105
prompt  ...PAGE 105: Registrierung
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 105
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Registrierung'
 ,p_step_title => 'Registrierung'
 ,p_step_sub_title => 'Registrierung'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_page_is_public_y_n => 'Y'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909143430'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4036814099042279 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 105,
  p_plug_name=> 'Hinweis',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2887429229489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_02',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'ITEM_IS_NOT_NULL',
  p_plug_display_when_condition => 'P105_REGISTRIERUNGS_MELDUNG',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4037024889042281 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 105,
  p_plug_name=> '&P105_PAGE_TITEL_REGISTRIERUNG.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4037207533042282 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 105,
  p_plug_name=> 'Navigationspfade',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(10646621298234429 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4037420857042284 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 105,
  p_button_sequence=> 10,
  p_button_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P105_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4037812823042287 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 105,
  p_button_sequence=> 40,
  p_button_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P105_BL_ERSTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> 'P105_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4111304195978007 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 105,
  p_button_sequence=> 50,
  p_button_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_button_name    => 'SPEICHERN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P105_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> 'P105_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4049723532042315 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4037420857042284+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4049905491042323 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 11,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 22-AUG-2006 12:21 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bitte geben Sie einen Namen ein, den Sie als Benutzerkennung mit Saluscom verwenden möchten. Bis zu 100 Zeichen sind erlaubt. Die Benutzerkennung muss eindeutig sein.';

wwv_flow_api.create_page_item(
  p_id=>4038507850042295 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 11,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'USER_ACCOUNT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Sprach-Vorgabe für die nachfolgenden Anwendungen.';

wwv_flow_api.create_page_item(
  p_id=>4039225404042296 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> ':P101_APP_SPRACHE_ID',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'APP_SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT s.sprache, s.id'||unistr('\000a')||
'FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4039708323042296 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt. Die Emailadresse muss eindeutig sein.'||unistr('\000a')||
'Der Eintrag muss mit mindestens einem Zeichen beginnen, anschliessend ein @-Zeichen beinhalten, danach beliebig viele Zeichen. Nach dem Punkt sind bis zu 4 Zeichen erlaubt. Allgemeiner Aufbau: [zeichen]@[zeichen].[zeichen]';

wwv_flow_api.create_page_item(
  p_id=>4039915716042296 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_EMAIL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'EMAIL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für dieses Seitenelement ist keine Hilfe verfügbar.';

wwv_flow_api.create_page_item(
  p_id=>4040411624042298 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_PASSWORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Passwort',
  p_source=>'PASSWORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 beliebige Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4040912245042298 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 3,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 beliebige Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4041421438042298 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 4,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'VORNAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 beliebige Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4041902378042300 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_STRASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'STRASSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 10 beliebige Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4042422391042300 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 6,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte mit Postleitzahlen in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 10 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4042905134042300 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_PLZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 7,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'PLZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 100 beliebige Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4043427401042301 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_ORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 8,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'ORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für dieses Seitenelement ist keine Hilfe verfügbar.';

wwv_flow_api.create_page_item(
  p_id=>4044426505042301 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_ERFDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfdat',
  p_source=>'ERFDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für dieses Seitenelement ist keine Hilfe verfügbar.';

wwv_flow_api.create_page_item(
  p_id=>4044926597042301 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für dieses Seitenelement ist keine Hilfe verfügbar.';

wwv_flow_api.create_page_item(
  p_id=>4045423096042303 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_MUTDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutdat',
  p_source=>'MUTDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für dieses Seitenelement ist keine Hilfe verfügbar.';

wwv_flow_api.create_page_item(
  p_id=>4045915806042303 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4056900752078064 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_PAGE_TITEL_REGISTRIERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4067402839154371 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4068009419156306 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4113411992018075 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4337028370786759 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_REGISTRIERUNGS_MELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 4036814099042279+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 50,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11340625696529764 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_ANREDE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'ANREDE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select  '||unistr('\000a')||
' fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',ID,:fas_sprache_id) a,'||unistr('\000a')||
' id b'||unistr('\000a')||
'from anreden_frgbg'||unistr('\000a')||
'where id in (4,3)',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12116603383047471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 105,
  p_name=>'P105_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 9,
  p_item_plug_id => 4037024889042281+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '198',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source=>'LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select fas_synch.get_tab_uebersetzung(''LAND.LAND'',id,:fas_sprache_id)  a, id b'||unistr('\000a')||
'from v_laender'||unistr('\000a')||
'order by sort',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4048726948042310 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_EMAIL_not_null',
  p_validation_sequence=> 10,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P105_EMAIL IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:p101_sprache_id,'||unistr('\000a')||
'                  frgbg_s.holen_uebersetzung(203,:p101_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4039915716042296 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4046926892042309 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_EMAIL_check',
  p_validation_sequence=> 22,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF instr(:p105_email,''@'') <= 1 THEN'||unistr('\000a')||
'      --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(224,:p101_sprache_id));'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'   v_string := substr(:p105_email,instr(:p105_email,''@'')+1,length(:p105_email));'||unistr('\000a')||
'   v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'   IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'      --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(225,:p101_sprache_id));'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'   -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'   IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'      --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(226,:p101_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:p101_sprache_id,'||unistr('\000a')||
'                 frgbg_s.holen_uebersetzung(223,:p101_sprache_id,     '||unistr('\000a')||
'                 frgbg_s.holen_uebersetzung(203,:p101_sprache_id)),'||unistr('\000a')||
'            ''Validierung p105_email_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4039915716042296 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4047508722042309 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_EMAIL_unique',
  p_validation_sequence=> 23,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT count(*) INTO v_anz'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE UPPER(email) = UPPER(:p105_email);'||unistr('\000a')||
'   IF v_anz > 0 THEN'||unistr('\000a')||
'      --RETURN (''Die Email-Adresse ist bereits vergeben!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(445,:p101_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Keine gültige Email-Adresse!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(445,:p101_sprache_id));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4039915716042296 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4047903955042309 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_NAME_not_null',
  p_validation_sequence=> 72,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P105_NAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:p101_sprache_id,'||unistr('\000a')||
'                  frgbg_s.holen_uebersetzung(206,:p101_sprache_id)));'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4040912245042298 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4048117929042310 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_VORNAME_not_null',
  p_validation_sequence=> 82,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P105_VORNAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:p101_sprache_id,'||unistr('\000a')||
'                  frgbg_s.holen_uebersetzung(205,:p101_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4041421438042298 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4048320839042310 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_PLZ_not_null',
  p_validation_sequence=> 112,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P105_PLZ IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:p101_sprache_id,'||unistr('\000a')||
'                  frgbg_s.holen_uebersetzung(209,:p101_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; --optional 05.05.08 NEI'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4042905134042300 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4048505783042310 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_ORT_not_null',
  p_validation_sequence=> 122,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P105_ORT IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:p101_sprache_id,'||unistr('\000a')||
'                  frgbg_s.holen_uebersetzung(210,:p101_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; --optional 05.05.08 NEI'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4043427401042301 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4048920897042310 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_USER_ACCOUNT_not_null',
  p_validation_sequence=> 140,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P105_USER_ACCOUNT IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:p101_sprache_id,'||unistr('\000a')||
'                  frgbg_s.holen_uebersetzung(202,:p101_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4038507850042295 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4047709231042309 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_user_account_unique',
  p_validation_sequence=> 142,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT count(*) INTO v_anz'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE UPPER(user_account)= UPPER(:p105_user_account);'||unistr('\000a')||
'   IF v_anz > 0 THEN'||unistr('\000a')||
'      --RETURN (''Der Benutzer ist bereits vergeben!'');'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(448,:p101_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* NEI 31.08.07 keine DB-User mehr'||unistr('\000a')||
'   SELECT count(*) INTO v_anz '||unistr('\000a')||
'   FROM all_users '||unistr('\000a')||
'   WHERE UPPER(username) = UPPER(:p105_user_account);'||unistr('\000a')||
'   IF v_anz > 0 THEN'||unistr('\000a')||
'      RETURN (''Der Benutzer ist bereits vergeben!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:p101_sprache_id,'||unistr('\000a')||
'                              frgbg_s.holen_uebersetzung(223,:p101_sprache_id,'||unistr('\000a')||
'                              frgbg_s.holen_uebersetzung(202,:p101_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P1_user_account_unique''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4038507850042295 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4047116775042309 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_PLZ_ORT',
  p_validation_sequence=> 150,
  p_validation => 'DECLARE'||unistr('\000a')||
'    v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --IF UPPER(:p105_land) = ''SCHWEIZ'' THEN'||unistr('\000a')||
'   IF :p105_land_id IS NOT NULL AND :p105_ort IS NOT NULL AND '||unistr('\000a')||
'      :p105_plz IS NOT NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      IF :p105_land_id = 198 THEN -- Schweiz'||unistr('\000a')||
'         select count(*) INTO v_anz'||unistr('\000a')||
'         from v_orte'||unistr('\000a')||
'         where upper(ort) = upper(:p105_ort)'||unistr('\000a')||
'           and plz = :p105_plz;'||unistr('\000a')||
'         IF v_anz = 0 THEN'||unistr('\000a')||
'            --RETURN(''PLZ/Ort-Kombination ist ungültig!'');'||unistr('\000a')||
'            RETURN(frgbg_s.holen_uebersetzung(179,:p101_sprache_id));'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Ort bzw. PLZ ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:p101_sprache_id,'||unistr('\000a')||
'                              frgbg_s.holen_uebersetzung(223,:p101_sprache_id,'||unistr('\000a')||
'                              frgbg_s.holen_uebersetzung(209,:p101_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P1_plz_ort_exists''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4042905134042300 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4832506550822460 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_LAND_ID',
  p_validation_sequence=> 155,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P105_land_id = ''#NULL#'' OR :P105_land_id is null THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 12116603383047471 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4047314610042309 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P105_LAND',
  p_validation_sequence=> 160,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p105_land_id IS NOT NULL THEN'||unistr('\000a')||
''||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM   v_laender'||unistr('\000a')||
'      --WHERE  UPPER(land) = UPPER(:p105_land);'||unistr('\000a')||
'      WHERE id = :p105_land_id;'||unistr('\000a')||
'      IF v_anz != 1 THEN'||unistr('\000a')||
'         --RETURN(''Ungültige Eingabe im Feld Land!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(223,:p101_sprache_id,'||unistr('\000a')||
'                 frgbg_s.holen_uebersetzung(211,:p101_sprache_id)));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Land ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:p101_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:p101_sprache_id,'||unistr('\000a')||
'                              frgbg_s.holen_uebersetzung(211,:p101_sprache_id)),'||unistr('\000a')||
'          ''Validierung p105_land''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 4037812823042287 + wwv_flow_api.g_id_offset,
  p_associated_item=> 12116603383047471 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:REGISTRIERUNGEN:P105_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 4049025238042310 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_process_sequence=> 1,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Zeile abrufen aus REGISTRIERUNGEN',
  p_process_sql_clob => p,
  p_process_error_message=> 'Zeile kann nicht abgerufen werden.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:REGISTRIERUNGEN:P105_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 4049221549042312 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_process_sequence=> 1,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Zeile von REGISTRIERUNGEN verarbeiten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':P105_REGISTRIERUNGS_MELDUNG:= frgbg_s.holen_uebersetzung(449,:p101_sprache_id);';

wwv_flow_api.create_page_process(
  p_id     => 4049426510042314 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_process_sequence=> 11,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'hinweis_einblenden',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'-- Nicht direkt hinter Mail senden, da dies im Trigger von Registrierungen REGISTRIERUNGEN_AIR'||unistr('\000a')||
'-- automatisch durchgeführt wird und im Trigger kein Commit verwendet werden darf'||unistr('\000a')||
'apex_mail.push_queue;';

wwv_flow_api.create_page_process(
  p_id     => 8169323653804398 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_process_sequence=> 21,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Mailqueue versenden',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p105_bl_erstellen := frgbg_s.holen_uebersetzung(163,:p101_sprache_id);'||unistr('\000a')||
'   :P105_BL_abbrechen := frgbg_s.holen_uebersetzung(161,:p101_sprache_id);'||unistr('\000a')||
'   :P105_BL_speichern := frgbg_s.holen_uebersetzung(172,:p101_sprache_id);'||unistr('\000a')||
'   :p105_page_titel_registrierung := '||unistr('\000a')||
'           frgbg_s.holen_uebersetzung(435,:p101_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4057424994085076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_process_sequence=> 21,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':P105_REGISTRIERUNGS_MELDUNG := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 4347529118890989 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_process_sequence=> 21,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Hinweis_initialisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'-- NEI 09.12.08 null kann nicht mehr gewählt werden => wird eigentlich nicht mehr gebraucht'||unistr('\000a')||
'IF :p105_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'   :p105_land_id := NULL;'||unistr('\000a')||
'END IF;';

wwv_flow_api.create_page_process(
  p_id     => 3013816764312889 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 105,
  p_process_sequence=> 52,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_land_id_null',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 105
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00106
prompt  ...PAGE 106: Passwort_vergessen
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 106
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Passwort_vergessen'
 ,p_step_title => 'Passwort_vergessen'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'Y'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20111018105338'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 1709028376404342 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 106,
  p_plug_name=> '&P106_PAGE_TITEL_PW.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891602476489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 1782205435720868 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 106,
  p_plug_name=> '&P106_PAGE_TITEL_HINWEIS.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890721784489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p106_meldung is not null',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 1709230068404349 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 106,
  p_button_sequence=> 30,
  p_button_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P106_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p106_meldung is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 1709426722404350 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 106,
  p_button_sequence=> 10,
  p_button_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P106_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P106_ZURUECK_SEITE.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p106_meldung is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>1709612031404350 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P106_ZURUECK_SEITE.:&SESSION.::&DEBUG.:106::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>1784030462784888+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>1784316180799661 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:106:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 11,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 05-APR-2011 08:51 by BRIGITTE.NEIDHART');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1710006430404374 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'&P106_LABEL_BENUTZER.',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1712917888473081 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_MELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1714113779500232 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_EMAIL_EINGABE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 25,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'&P106_LABEL_EMAIL_EINGABE.',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when=>':p106_meldung is not null',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1716202041499845 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1719302602929630 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1723114676254801 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1724205597346725 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1724412869348834 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1724601226354957 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_PAGE_TITEL_PW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1725331055391995 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_LABEL_BENUTZER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1725503828393602 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_LABEL_EMAIL_EINGABE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1782400879720871 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 171,
  p_item_plug_id => 1782205435720868+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'P106_MELDUNG',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 70,
  p_cMaxlength=> 2000,
  p_cHeight=> 5,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1782801410729145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_PAGE_TITEL_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 175,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Hinweis',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1784030462784888 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_HINWEIS_OK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 1782205435720868+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'ENDE',
  p_prompt=>'&P106_BL_OK.',
  p_source=>'ENDE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1784921121857846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 106,
  p_name=>'P106_BL_OK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 1709028376404342+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_persstamm_id_ident personenstamm.id%TYPE;'||unistr('\000a')||
'   v_persstamm_id_MAILABSENDER personenstamm.id%TYPE;'||unistr('\000a')||
'   v_email                      personenstamm.email%TYPE;'||unistr('\000a')||
'   v_persstamm_id         personenstamm.id%TYPE;'||unistr('\000a')||
'   v_betreuer                  personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_anz_login    number;'||unistr('\000a')||
'   v_return       NUMBER;'||unistr('\000a')||
'   v_fehlertext   VARCHAR2(4000);'||unistr('\000a')||
'   v_fehlernummer NUMBER;'||unistr('\000a')||
'   v_prot_id';

p:=p||'      number;'||unistr('\000a')||
'   v_fehler       exception;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p106_meldung := NULL;'||unistr('\000a')||
'   IF :P106_email_eingabe is NULL THEN'||unistr('\000a')||
'      --''Die E-Mail-Adresse muss eingegeben werden!'''||unistr('\000a')||
'      :p106_meldung:=frgbg_s.holen_uebersetzung(4504,:p106_sprache_id);'||unistr('\000a')||
'      v_fehlernummer := -10;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :p106_user_account IS NULL THEN'||unistr('\000a')||
'      :p106_meldung:=frgbg_s.holen_uebersetzung(447,:p106_sprache_id);'||unistr('\000a')||
'      v_fehl';

p:=p||'ernummer := -20;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT login_fehlversuche,id, email, betreuer'||unistr('\000a')||
'      INTO v_anz_login, v_persstamm_id, v_email, v_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE user_account = UPPER (:p106_user_account);'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      -- Fehler Benutzer ist unbekannt!'||unistr('\000a')||
'      :p106_meldung := frgbg_s.holen_uebersetzung(446,:p106_sprache_id);'||unistr('\000a')||
'      v_fehlernummer := -';

p:=p||'30;'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF v_betreuer not in (''J'',''I'',''N'') and :p106_zurueck_seite in (121)'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      :p106_meldung:= frgbg_s.holen_uebersetzung(444,:p106_sprache_id);'||unistr('\000a')||
'      v_fehlernummer := -40;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_email is null'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      :p106_meld';

p:=p||'ung:=frgbg_s.holen_uebersetzung(3935,:p106_sprache_id);'||unistr('\000a')||
'      v_fehlernummer := -50;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF trim(LOWER(v_email)) != trim(LOWER(:P106_email_eingabe)) THEN'||unistr('\000a')||
'      --''Die E-Mail-Adresse für den Benutzer nicht gültig!'';'||unistr('\000a')||
'      :p106_meldung:= frgbg_s.holen_uebersetzung(4505,:p106_sprache_id,:P106_email_eingabe);'||unistr('\000a')||
'      v_fehlernummer := -60;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF v_anz_login != round(v_anz_login) '||unistr('\000a')||
' ';

p:=p||'  THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      :p106_meldung:=frgbg_s.holen_uebersetzung(3937,:p106_sprache_id);'||unistr('\000a')||
'      v_fehlernummer := -70;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'------------------------------------------------'||unistr('\000a')||
'   IF :p106_meldung is not null THEN'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      IF :p106_zurueck_seite in (101,124) THEN  -- Patienten-Login'||unistr('\000a')||
'         -- Absender: 2.o';

p:=p||'berste Identität der Standardidentitaet'||unistr('\000a')||
'         v_persstamm_id_ident := frgbg_s.GET_IDENTITAET_KUNDE(NULL,-1,v_persstamm_id);'||unistr('\000a')||
'         v_PERSSTAMM_ID_MAILABSENDER := frgbg_s.get_ident_2oberste(v_persstamm_id_ident,NULL);'||unistr('\000a')||
'      ELSE  -- Betreuer/Ident-Login'||unistr('\000a')||
'         -- Absender: 2.oberste Identität der Standardidentitaet'||unistr('\000a')||
'         IF v_betreuer = ''J'' THEN'||unistr('\000a')||
'            v_persstamm_id_MAILABSENDER := ';

p:=p||'frgbg_s.get_ident_2oberste(NULL,v_persstamm_id);'||unistr('\000a')||
'         ELSIF v_betreuer = ''I'' THEN'||unistr('\000a')||
'            v_persstamm_id_MAILABSENDER := frgbg_s.get_ident_2oberste(v_persstamm_id,NULL);'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            v_persstamm_id_MAILABSENDER := 0 ;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_persstamm_id_mailabsender <= 0 THEN -- Fehler bei der Ermittlung der Identitaet'||unistr('\000a')||
'         -- Fehler beim Aufbereiten der';

p:=p||' Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'         :p106_meldung:='||unistr('\000a')||
'               frgbg_s.holen_uebersetzung(444,:p106_sprache_id,:p106_user_account)||'||unistr('\000a')||
'                                         '' (''||to_char(v_persstamm_id_mailabsender)||'')'';'||unistr('\000a')||
'         v_fehlernummer := -80;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      v_return := frgbg_s.mail_neues_passwort(:p106_user_account,'||unistr('\000a')||
'                          ';

p:=p||'                    null,'||unistr('\000a')||
'                                              NULL,'||unistr('\000a')||
'                                              NULL,'||unistr('\000a')||
'                                              v_persstamm_id_MAILABSENDER,'||unistr('\000a')||
'                                              1, -- PW-change'||unistr('\000a')||
'                                              0, -- no-reply'||unistr('\000a')||
'                                              0 -- P_NOTFALL_EMAIL '||unistr('\000a')||
'    ';

p:=p||'                                        );'||unistr('\000a')||
'      IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'         -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'         :p106_meldung := frgbg_s.holen_uebersetzung(444,:p106_sprache_id,:p106_user_account)||'||unistr('\000a')||
'                                                    '' (''||to_char(v_return)||'')'';'||unistr('\000a')||
'         v_fehlernummer := -90;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END';

p:=p||' IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Fehlerversuche auf 0 setzen'||unistr('\000a')||
'      UPDATE personenstamm'||unistr('\000a')||
'      SET login_fehlversuche = 0,'||unistr('\000a')||
'          email_prot = :p106_email_eingabe'||unistr('\000a')||
'      WHERE id = v_persstamm_id;'||unistr('\000a')||
''||unistr('\000a')||
'      :p106_meldung := frgbg_s.holen_uebersetzung(428,:p106_sprache_id,:p106_email_eingabe); '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
' --mel.p(''PW-text:%1, %2'',v_prot_id,''test'',''pw_mail_versenden'',:p106_meldung,v_persstamm_id_MAILABSENDER);'||unistr('\000a')||
'EXCEPTI';

p:=p||'ON'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'     --:p106_meldung := :p106_meldung;  --utl_url.escape()'||unistr('\000a')||
'     mel.p(''Fehler bei der Aufbereitung der Passwort-Mail Persstamm-ID: %1, Email: %2'',v_prot_id,''Fehler'',''102/106:pw_mail_versenden,''||v_fehlernummer,v_persstamm_id,:p106_meldung);'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'     :p106_meldung := frgbg_s.holen_uebersetzung(444,:p106_sprache_id,:p106_email_eingabe);     '||unistr('\000a')||
'     mel.p(''Fehler bei ';

p:=p||'der Aufbereitung der Passwort-Mail Persstamm-ID: %1, Email: %2'',v_prot_id,''Fehler'',''102/106:pw_mail_versenden'',v_persstamm_id,:p106_meldung);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1719826067955256 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 106,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'PW_mail_versenden',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SAVE'',''P106_EMAIL_EINGABE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   :p106_bl_speichern := frgbg_s.holen_uebersetzung(4506,:p106_sprache_id);'||unistr('\000a')||
'   :P106_BL_abbrechen  := frgbg_s.holen_uebersetzung(510,:p106_sprache_id);'||unistr('\000a')||
'   :P106_BL_ok  := frgbg_s.holen_uebersetzung(4396,:p106_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p106_label_benutzer := frgbg_s.holen_uebersetzung(202,:p106_sprache_id);'||unistr('\000a')||
'   :p106_label_email_eingabe := frgbg_s.holen_uebersetzung(203,:';

p:=p||'p106_sprache_id);'||unistr('\000a')||
'   :p106_text := frgbg_s.holen_uebersetzung(4507,:p106_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p106_page_titel_pw := frgbg_s.holen_uebersetzung(4508,:p106_sprache_id);'||unistr('\000a')||
'   :p106_PAGE_TITEL_HINWEIS := frgbg_s.holen_uebersetzung(3786,:p106_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1723807413328371 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 106,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 106
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00110
prompt  ...PAGE 110: PATIENTENSTAMMANZEIGE
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 110
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'PATIENTENSTAMMANZEIGE'
 ,p_step_title => 'Patientenstammanzeige'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Personenstammanzeige'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Keine Hilfe verhanden.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150518114823'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3033921787870731 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 110,
  p_plug_name=> '&P110_PAGE_TITEL_RECHNUNGSADR.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON = ''BETREUER'' AND'||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_plug_header=> '<div style="min-width: 430px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3167921383534581 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 110,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3714110258647645 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 110,
  p_plug_name=> '&P110_PAGE_TITEL_LIEFERADR.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON = ''BETREUER'' AND '||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_plug_header=> '<div style="min-width: 430px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4689231200238978 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 110,
  p_plug_name=> '&P110_PAGE_TITEL_PATIENTANZEIGE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 9,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="height: &FAS_SCROLLREGION_HEIGHT_MAX.px;max-width: 550px">'||unistr('\000a')||
'',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 1314313996499157 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 11,
  p_button_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_IDENTITAET',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_IDENTITAET.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(''&P110_IDENTABFR_TEXT.'',''APPLY_CHANGES_IDENTITAET'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER'' and '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''IDENTITAET_BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p110_betreuer in (''N'')'||unistr('\000a')||
'and :p110_id is not null'||unistr('\000a')||
'and :fas_pers_aenderbar = 1'||unistr('\000a')||
'and :p110_EXTERN_VERWALTET = 0   /* nicht GUS-Verwalt.*/',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4197921092937301 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 15,
  p_button_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_BETREUER',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_BETREUER.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(''&P110_BETRABFR_TEXT.'',''APPLY_CHANGES_BETREUER'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER'' and '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p110_betreuer in (''J'',''N'')'||unistr('\000a')||
'and :p110_id is not null'||unistr('\000a')||
'and :fas_pers_aenderbar = 1'||unistr('\000a')||
'/*GUS-Verwalt.*/'||unistr('\000a')||
'and (:p110_EXTERN_VERWALTET = 0 OR '||unistr('\000a')||
'     :p110_EXTERN_VERWALTET != 0  and :p110_betreuer=''J'' --wg. Zusatzdaten moegl. fuer GUS-Personen'||unistr('\000a')||
'    )'||unistr('\000a')||
'/* Betreuer mit spez.Iabc-Betreuerzugriff duerfen nur'||unistr('\000a')||
'   Patienten zu Betreuern machen, aber nicht wieder zu'||unistr('\000a')||
'   Patienten oder gar PW des Betreuers ändern'||unistr('\000a')||
'*/'||unistr('\000a')||
'and ((frgbg_s.get_pers_option(:APP_USER,28)= 1 AND'||unistr('\000a')||
'      :p110_betreuer in (''N''))'||unistr('\000a')||
'     OR'||unistr('\000a')||
'     frgbg_s.get_pers_option(:APP_USER,28)= 0'||unistr('\000a')||
'    )',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3017725232670003 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 70,
  p_button_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_button_name    => 'RECHNUNGSADRESSE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_AUSWAEHLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON = ''BETREUER'' AND '||unistr('\000a')||
':p110_id IS NOT NULL /* vorhandener Patient */ and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3714421538647668 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 70,
  p_button_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_button_name    => 'LIEFERADRESSE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_AUSWAEHLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON = ''BETREUER'' AND '||unistr('\000a')||
':p110_id IS NOT NULL /* vorhandener Patient */'||unistr('\000a')||
'and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3048415047332504 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 80,
  p_button_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_button_name    => 'RECHLOESCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P110_PERSSTAMM_ID_RECHNUNG IS NOT NULL and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3714620328647670 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 80,
  p_button_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_button_name    => 'LIEFERLOESCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P110_PERSSTAMM_ID_LIEFERUNG IS NOT NULL and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4689612362238981 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 10,
  p_button_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2478929210395295 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 30,
  p_button_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_button_name    => 'WARENKORB',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_WARENKORB.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''BETREUER'' AND :p110_id is not null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4690400749238985 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 35,
  p_button_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_button_name    => 'PASSWORT_CHANGE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_PASSWORT_CHG.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:popUp2(''&P110_PREPARE_URL_PW.'',700,380);',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'UPPER(:P110_USER_ACCOUNT)= UPPER(:APP_USER) AND :p110_id IS NOT NULL AND :fas_aufgerufen_von != ''ANONYM'''||unistr('\000a')||
'and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4690002124238985 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 40,
  p_button_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P110_ID is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4690218325238985 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 50,
  p_button_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(''&FAS_LOESCHABFRAGE_TEXT.'',''DELETE'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p110_id is not null AND :fas_aufgerufen_von != ''ANONYM'''||unistr('\000a')||
'and :fas_pers_aenderbar = 1'||unistr('\000a')||
'and :p110_EXTERN_VERWALTET = 0   /*nicht GUS-Verwalt.*/',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4689813183238985 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 90,
  p_button_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p110_id is not null and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6716224072611042 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 110,
  p_button_sequence=> 100,
  p_button_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_button_name    => 'FB_REZEPT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P110_BL_FB_REZEPT.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P110_id',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6716515345611042 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:140::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6716224072611042+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4198222811937303 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:111:&SESSION.::&DEBUG.::P111_ID:&P110_ID.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4197921092937301+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 5,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p110_betreuer = ''J''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>2479231699395300 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:300:P300_PERSSTAMM_ID,P300_ZURUECK_SEITE:&P110_ID.,&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2478929210395295+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>3718825299812775 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:133:P133_PERSSTAMM_PATIENT_ID,P133_EXTERN_TYP:&P110_ID.,L&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3714421538647668+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 06-MAI-2008 11:13 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>3032013084789559 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:133:P133_PERSSTAMM_PATIENT_ID,P133_EXTERN_TYP:&P110_ID.,R&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3017725232670003+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 11,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 06-MAI-2008 11:13 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4713330415239046 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:110::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 12,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':fas_aufgerufen_von = ''BETREUER'' AND :REQUEST in (''DELETE'',''CANCEL'')',
  p_branch_condition_text=>'130',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 04-AUG-2006 17:22 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4713905403239051 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:110::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 31,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':fas_aufgerufen_von != ''BETREUER'' AND :REQUEST in (''DELETE'',''CANCEL'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 10-SEP-2007 14:24 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4233406165748342 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'DOKUMENTEN_DRUCK.HCK_MED_ETIKETT?P_BESTELL_ID=&P110_BESTELL_ID.&P_POSITION=&P110_HCK_MED_DRUCKPOS.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 41,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p110_bestell_id is not null and'||unistr('\000a')||
':request in (''HCK_MED'')'||unistr('\000a')||
'and 1=2 /* Ersetzt durch Druck Prozess */',
  p_save_state_before_branch_yn=>'N',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset,
  p_branch_comment=> 'Created 02-SEP-2008 09:21 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4254110689690348 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'DOKUMENTEN_DRUCK.HCK_MED_ETIKETT?P_BESTELL_ID=&P110_BESTELL_ID.&P_POSITION=&P110_HCK_MED_DRUCKPOS.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 50,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p110_bestell_id is not null and :request in (''HCK_MED_NACHDRUCK'') '||unistr('\000a')||
'and 1=2 /* Ersetzt durch Druck Prozess */',
  p_save_state_before_branch_yn=>'N',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset,
  p_branch_comment=> 'Created 02-SEP-2008 09:21 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4295117906169509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:110:&SESSION.:NACHDRUCKHINWEIS:&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 60,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p110_bestell_id is null and :request in (''HCK_MED_NACHDRUCK'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 11-SEP-2008 11:11 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>2028729864464935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:110:&SESSION.:BESTELLHINWEIS:&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 70,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BESTELLEN'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 11-SEP-2008 11:11 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4272925957055990 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:110:&SESSION.:BETREUER_HINWEIS:&DEBUG.::P110_WAHL_IDENTITAET:0',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>1314313996499157+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 80,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 05-FEB-2010 21:16 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4276404895398237 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:110:&SESSION.:BETREUER_HINWEIS:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4197921092937301+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 90,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 06-FEB-2010 20:27 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>3673513021513495 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:110:&SESSION.:GUTSCHEIN_EMAILVERSAND:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 91,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p110_gutscheinstatus = 1 and '||unistr('\000a')||
':p110_gutscheinstatus_db = 0 and'||unistr('\000a')||
':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'','||unistr('\000a')||
'             ''APPLY_CHANGES_BETREUER'',''IDENTITAET'') AND '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,  '||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0    /* Gutscheinverfahren */',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 12-OCT-2011 10:13 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4713520346239051 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1315210018535858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_IDENTABFR_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1030,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identabfrage Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1368715392037440 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PASSWORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'PASSWORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2479428910423571 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 544,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zum WK',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2588605308451184 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_WAHL_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 980,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wahl Identitaet',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2734106164385685 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PREPARE_URL_PW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 990,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prepare Url Pw',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3032701964833685 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 740,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3034503075870734 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3034728342870739 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_NAME_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3035118260870745 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_VORNAME_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3035319598870746 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_STRASSE_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3035515695870746 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_NR_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3035720404870746 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PLZ_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3035908466870746 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ORT_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3036131157870746 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_LAND_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3045210779123085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PERSSTAMM_ID_EXTERN_UPD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 750,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'P110 Persstamm Id Rechnung Upd',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3051402589404529 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PAGE_TITEL_RECHNUNGSADR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 553,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rechnung Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3052630603459917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_AUSWAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 543,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rechnungsadr',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3651513860912602 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_GUTSCHEINSTATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 68,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'GUTSCHEINSTATUS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(4902,:fas_sprache_id) a, 0 FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4903,:fas_sprache_id) a, 1 FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4904,:fas_sprache_id) a, 2 FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4905,:fas_sprache_id) a, 3 FROM DUAL'||unistr('\000a')||
'order by 2',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'frgbg_s.check_fas_rolle(:APP_USER,  /* Gutscheinverfahren */'||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0 ',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3652222349952925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_GUTSCHEINANZAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 69,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'GUTSCHEINANZAHL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'STATIC2:0;0,1;1,2;2,3;3,4;4,5;5',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'--:p110_gutscheinstatus > 0 and  dynamic action'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,  /* Gutscheinverfahren */'||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0 ',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3673124748488482 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_GUTSCHEINSTATUS_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 69,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'P110_GUTSCHEINSTATUS',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3714927573652598 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PAGE_TITEL_LIEFERADR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 556,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rechnung Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3715420563669490 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 760,
  p_item_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3715710305676020 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_NAME_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 770,
  p_item_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3716027620681029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_VORNAME_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 780,
  p_item_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3716206280684321 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_STRASSE_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 790,
  p_item_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3716415284686925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_NR_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 800,
  p_item_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3716621518688718 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PLZ_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 810,
  p_item_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3716828098690654 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ORT_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 820,
  p_item_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3717002948692765 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_LAND_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 830,
  p_item_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3718412654771359 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_EXTERN_TYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 751,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Extern Typ',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3742916967409559 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 741,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3749302842078881 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 62,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'IDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3749527083085923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 99,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 57,
  p_cMaxlength=> 2000,
  p_cHeight=> 2,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 6,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3749705397089126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_TELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 94,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3749920981093589 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_MOBILTELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 96,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'MOBILTELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3932731915448965 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_FAX',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'FAX',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3932914384453448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 97,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'URL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4154212921972106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 63,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'N',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_pre_element_text=>'&#160',
  p_post_element_text=>'&#160 &#160',
  p_source=>'BETREUER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(3578,:fas_sprache_id) a,''N'' b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(1854,:fas_sprache_id),''J''  from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(3101,:fas_sprache_id),''I''  from dual'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p110_betreuer in (''J'',''N'') ',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when=>'frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p110_betreuer in (''J'',''N'')',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4193523735484020 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_GEWICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 840,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160;&#160;&#160;',
  p_source=>'GEWICHT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND                  /* Betreuer */ '||unistr('\000a')||
':p110_rezept_nr > 0 and                       /* Rezept gewählt */'||unistr('\000a')||
'(frgbg_s.check_fas_rolle(:APP_USER,''HCK_MED'')> 0 AND  /* Rolle */'||unistr('\000a')||
' :p110_land_id = 53   OR                              /* Patient wohnt in Dtl. */'||unistr('\000a')||
' frgbg_s.check_fas_rolle(:APP_USER,''PARAMEDIFORM'')> 0 /* Rolle */'||unistr('\000a')||
') AND'||unistr('\000a')||
'(frgbg_s.check_rolle_prodr(''HCK_MED'',:p110_rezept_nr)> 0  OR /* HCK-MED-Rezept */'||unistr('\000a')||
' frgbg_s.check_rolle_prodr(''PARAMEDIFORM'',:p110_rezept_nr)> 0/* Paramedi-Rezept */'||unistr('\000a')||
')'||unistr('\000a')||
'OR'||unistr('\000a')||
'1=1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4205828489475624 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1050,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4225508126454484 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1000,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Betreuer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4253720947683887 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BESTELL_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 930,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bestell Id Hck Med',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4254906112783651 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_HCK_MED_NACHDRUCK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 901,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'HCK_MED_NACHDRUCK',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4272018183366560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1010,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Betreuer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4605314004882564 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_GROESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 841,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_pre_element_text=>'&#160;',
  p_post_element_text=>'&#160;&#160;&#160;',
  p_source=>'GROESSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND                 /* Betreuer */ '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''PARAMEDIFORM'')> 0 AND    /* Rolle Paramedi */'||unistr('\000a')||
'frgbg_s.check_rolle_prodr(''PARAMEDIFORM'',:p110_rezept_nr)> 0/* Paramedi-Rezept */'||unistr('\000a')||
'OR'||unistr('\000a')||
'1=1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4607530698311359 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_BESTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 902,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Bestellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4620502819854735 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_IDENT_OPTION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 64,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Option',
  p_pre_element_text=>'&#160 ',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT ''Mitglied'' a, 0 from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''Master'' ,1 from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' and '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''IDENTITAET_BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p110_betreuer in (''N'')'||unistr('\000a')||
'and :p110_id is not null'||unistr('\000a')||
'and :fas_pers_aenderbar = 1'||unistr('\000a')||
'and :p110_EXTERN_VERWALTET = 0   /* nicht GUS-Verwalt.*/'||unistr('\000a')||
'and frgbg_s.check_fas_rolle(:APP_USER,''COMMUNITY_ADMIN'')> 0 /*Community-Admin */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4695013528239000 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Änderung anwenden',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Ändern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4695200939239000 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Erstellen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4695416140239000 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4695626655239001 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Löschen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4695805088239001 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_PASSWORT_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 530,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Passwort ändern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Passwort Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4696000718239001 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 540,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Speichern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Speichern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4696403272239001 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_FEHLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 560,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4696606948239001 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_REGION_TITEL_PWD_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 551,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Pwd Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4696811203239003 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_INFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 570,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4698403452239006 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PERSON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 620,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Person',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4698630427239007 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_USER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 630,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pisuser',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4699423098239009 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_REGION_TITEL_HILFETEXTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 550,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Hilfetexte',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4700023701239009 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_REGION_TITEL_INFOTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 552,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4702214536239012 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Login Benutzer Name ist nicht veränderbar.';

wwv_flow_api.create_page_item(
  p_id=>4702419456239012 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 61,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'USER_ACCOUNT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von != ''BETREUER''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when=>':p110_id is not null',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.'||unistr('\000a')||
'Der Eintrag muss mit mindestens einem Zeichen beginnen, anschliessend ein @-Zeichen beinhalten, danach beliebig viele Zeichen. Nach dem Punkt sind bis zu 4 Zeichen erlaubt. Allgemeiner Aufbau: [zeichen]@[zeichen].[zeichen]';

wwv_flow_api.create_page_item(
  p_id=>4702925651239018 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_EMAIL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 65,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'EMAIL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4703927313239018 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4704410829239020 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 72,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'VORNAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4704906332239020 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_STRASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 74,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'STRASSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 10 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4705431023239020 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 76,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte mit Postleitzahlen in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 10 Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>4705914009239020 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PLZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 78,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PLZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 100 beliebige Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>4706419319239021 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_POPUP_LOV',
  p_lov=> '         SELECT distinct o.ort ||'' ''||o.PLZ a, o.ort b'||unistr('\000a')||
'         FROM   orte o,  laender l, gebiete  g'||unistr('\000a')||
'         WHERE  o.id_gebiet = g.id'||unistr('\000a')||
'           AND  g.id_land = l.id'||unistr('\000a')||
'           AND  (l.ID = :P110_LAND_ID OR :P110_land_id is null)'||unistr('\000a')||
'           AND  (o.plz like trim(:p110_plz)||''%'' OR :p110_plz is null)'||unistr('\000a')||
'           and  o.satz_kennzeichen is null '||unistr('\000a')||
'           and  l.satz_kennzeichen is null'||unistr('\000a')||
'           and  g.satz_kennzeichen is null'||unistr('\000a')||
'		   and (l.iso3_id not in (''CHE'',''LIE'') '||unistr('\000a')||
'	        		 or'||unistr('\000a')||
'	           (l.iso3_id in (''CHE'',''LIE'') and o.onrp is not null))'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'ENTERABLE',
  p_attribute_02 => 'FIRST_ROWSET_FILTER',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4707423359239023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_SATZKENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satzkennzeichen',
  p_source=>'SATZKENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Datumsangabe der Form TT.MM.JJJJ z.B. 20.11.2001';

wwv_flow_api.create_page_item(
  p_id=>4707823477239023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'DD.MM.RRRR',
  p_source=>'GEBURTSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER_CLASSIC',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Auswahl des Geschlechts.';

wwv_flow_api.create_page_item(
  p_id=>4708318791239023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_GESCHLECHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 89,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'GESCHLECHT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Anzeigesprache';

wwv_flow_api.create_page_item(
  p_id=>4708817570239023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      -- Sprache des Patienten von der Betreuer-Sprache ableiten'||unistr('\000a')||
'      :p110_app_sprache_id := frgbg_s.get_app_sprache_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT min(s.id) into :p110_app_sprache_id'||unistr('\000a')||
'      FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'      WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'        AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'        AND s.standard = 1;     -- Defaultsprache       '||unistr('\000a')||
'      IF :p110_app_sprache_id is NULL THEN'||unistr('\000a')||
'         SELECT min(s.id) into :p110_app_sprache_id'||unistr('\000a')||
'         FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'         WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'           AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'           AND s.aktiv=1;  -- NEI 09.09.2014 '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN (:p110_app_sprache_id);'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'APP_SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select s.sprache display_value, s.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs '||unistr('\000a')||
'where fs.id = :fas_pers_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  --AND s.sprache_id in (select sprache_id from uebersetzungen) -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
''||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4733819996456710 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PAGE_TITEL_PATIENTANZEIGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 554,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Title Personenstammanzeige',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4766630731809843 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PIS_PAT_AKTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 670,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pis Pat Akte Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4812726537368725 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_AENDERBAR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 970,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Aenderbar',
  p_source=>'AENDERBAR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4963306313928131 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 680,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4964514062939873 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 690,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5210424921748501 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_LOGIN_PAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 700,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Login Page',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5369121890191721 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_TAB1_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 710,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5369828124193554 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BL_FB_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 545,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.'||unistr('\000a')||
'Der Eintrag muss mit mindestens einem Zeichen beginnen, anschliessend ein @-Zeichen beinhalten, danach beliebig viele Zeichen. Nach dem Punkt sind bis zu 4 Zeichen erlaubt. Allgemeiner Aufbau: [zeichen]@[zeichen].[zeichen]';

wwv_flow_api.create_page_item(
  p_id=>5793314112701523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_EMAIL_INTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 66,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'EMAIL_INTERN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_modus_id in (1,2)',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6264009553248693 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_BETRABFR_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1020,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Betreuerabfrage Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6267305012695153 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_NV_PATIENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1040,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Patient',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8453703793004642 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_MN_REZEPT_ID_KOPIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 730,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Rezept Id Kopie',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8523304871420632 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PIS_ADRESSE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 671,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10172509861678508 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_PERS_READONLY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1051,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10304301304462069 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ADRESSZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 73,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSZUSATZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 40,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10307008782729235 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ADRESSZUSATZ_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 781,
  p_item_plug_id => 3714110258647645+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10307229560735143 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ADRESSZUSATZ_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 61,
  p_item_plug_id => 3033921787870731+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11319405639400975 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_ANREDE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 67,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ANREDE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select  '||unistr('\000a')||
' fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',ID,:fas_sprache_id) a,'||unistr('\000a')||
' id b'||unistr('\000a')||
'from anreden_frgbg',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'no help test';

wwv_flow_api.create_page_item(
  p_id=>12089300529715456 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 110,
  p_name=>'P110_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 77,
  p_item_plug_id => 4689231200238978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      -- Land des Patienten vom Betreuer-Land ableiten'||unistr('\000a')||
'      :p110_land_id := frgbg_s.get_betreuer_land_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p110_land_id := 198;  -- Default Schweiz '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN (:p110_land_id);'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select substr(fas_synch.get_tab_uebersetzung(''LAND.LAND'',id,:fas_sprache_id),1,27)  a, id b'||unistr('\000a')||
'from v_laender'||unistr('\000a')||
'order by sort',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p110_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P110_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4710717948239029 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_PLZ_not_null',
  p_validation_sequence=> 1,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P110_PLZ IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(209,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4705914009239020 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4710919286239031 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_ORT_not_null',
  p_validation_sequence=> 11,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P110_ORT IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(210,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4706419319239021 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4826323594382643 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_LAND_ID_not_null',
  p_validation_sequence=> 31,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P110_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_when_button_pressed=> 4690002124238985 + wwv_flow_api.g_id_offset,
  p_associated_item=> 12089300529715456 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4709501794239026 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_LAND_exists',
  p_validation_sequence=> 53,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p110_land_id IS NOT NULL THEN'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM   v_laender'||unistr('\000a')||
'      --WHERE  UPPER(land) = UPPER(:p110_land);'||unistr('\000a')||
'      WHERE id = :p110_land_id;'||unistr('\000a')||
'      IF v_anz != 1 THEN'||unistr('\000a')||
'         --RETURN(''Ungültige Eingabe im Feld Land!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'               frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Land ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(211,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P110_land_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 12089300529715456 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4709703415239029 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_PLZ_ORT_exists',
  p_validation_sequence=> 63,
  p_validation => 'DECLARE'||unistr('\000a')||
'    v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --IF UPPER(:p110_land) = ''SCHWEIZ'' THEN'||unistr('\000a')||
'   IF :p110_land_id IS NOT NULL AND :p110_ort IS NOT NULL AND'||unistr('\000a')||
'      :p110_plz IS NOT NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      IF :p110_land_id = 198 and -- Schweiz'||unistr('\000a')||
'         :P110_EXTERN_VERWALTET = 0  -- NEI 11.07.13 Nur FAS-Verwaltete Aufträge prüfen, '||unistr('\000a')||
'                                     -- da nur diese PLZ/Ort verändert werden können,'||unistr('\000a')||
'                                     -- sonst ist GUS führend und die Änderungen kommen von dort'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         select count(*) INTO v_anz'||unistr('\000a')||
'         from v_orte'||unistr('\000a')||
'         where upper(ort) = upper(:p110_ort)'||unistr('\000a')||
'           and plz = trim(:p110_plz);'||unistr('\000a')||
'         IF v_anz = 0 THEN'||unistr('\000a')||
'            --RETURN(''PLZ/Ort-Kombination ist ungültig!'');'||unistr('\000a')||
'            RETURN(frgbg_s.holen_uebersetzung(179,'||unistr('\000a')||
'                        :fas_sprache_id));'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Ort bzw. PLZ ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(209,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P110_plz_ort_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4705914009239020 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4709931033239029 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p110_geburtsdatum_not_null',
  p_validation_sequence=> 73,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P110_GEBURTSDATUM IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- Geburtsdatum optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4707823477239023 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4710101111239029 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p110_geburtdatum_must_be_date',
  p_validation_sequence=> 83,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P110_GEBURTSDATUM IS NOT NULL THEN'||unistr('\000a')||
'      :P110_GEBURTSDATUM := '||unistr('\000a')||
'         to_char(to_date(:P110_GEBURTSDATUM,''DD.MM.RRRR''),''DD.MM.RRRR'');'||unistr('\000a')||
'            -- to_date(:P110_GEBURTSDATUM);'||unistr('\000a')||
'      IF to_date(:P110_GEBURTSDATUM,''DD.MM.RRRR'') >= trunc(sysdate,''DD'')THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(9430,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(HTMLDB_LANG.MESSAGE(''DATUM_UNGUELTIG''));'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Ungültiges Datum!',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4707823477239023 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4710318888239029 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p110_name_not_null',
  p_validation_sequence=> 123,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P110_NAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(206,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4703927313239018 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4710502885239029 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_VORNAME_not_null',
  p_validation_sequence=> 133,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P110_VORNAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(205,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'NEVER',
  p_associated_item=> 4704410829239020 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4711127490239031 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_EMAIL_not_null',
  p_validation_sequence=> 183,
  p_validation => 'BEGIN'||unistr('\000a')||
'   -- NEI 5.5.11 check für Betreuer und Identitaet wieder aktiviert '||unistr('\000a')||
'   IF :P110_EMAIL IS NULL '||unistr('\000a')||
'      and '||unistr('\000a')||
'     (:p110_betreuer !=''N'' OR '||unistr('\000a')||
'      (:p110_gutscheinstatus > 0 AND :p110_betreuer=''N'') OR'||unistr('\000a')||
'      :request in (''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')'||unistr('\000a')||
'     )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(203,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4702925651239018 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4711310440239031 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_EMAIL_check',
  p_validation_sequence=> 190,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p110_email IS NOT NULL THEN '||unistr('\000a')||
'      IF instr(:p110_email,''@'') <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(224,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'      v_string :=  '||unistr('\000a')||
'         substr(:p110_email,instr(:p110_email,''@'')+1,length(:p110_email));'||unistr('\000a')||
'      v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'      IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'         --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(225,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'      -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'      IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(226,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,     '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(203,:fas_sprache_id)),'||unistr('\000a')||
'            ''Validierung p110_email_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4702925651239018 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5795215806749392 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_EMAIL_intern_check',
  p_validation_sequence=> 191,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p110_email_intern IS NOT NULL THEN '||unistr('\000a')||
'      IF instr(:p110_email_intern,''@'') <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(224,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'      v_string :=  '||unistr('\000a')||
'         substr(:p110_email_intern,'||unistr('\000a')||
'                  instr(:p110_email_intern,''@'')+1,length(:p110_email_intern));'||unistr('\000a')||
'      v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'      IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'         --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(225,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'      -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'      IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(226,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,     '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(3767,:fas_sprache_id)),'||unistr('\000a')||
'            ''Validierung p110_email_intern_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 5793314112701523 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4929203403791839 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_USER_ACCOUNT_EINGABE',
  p_validation_sequence=> 200,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'   v_anz   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p110_user_account IS NULL THEN'||unistr('\000a')||
'      --RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,   -- NEI 23.06.08'||unistr('\000a')||
'      --       frgbg_s.holen_uebersetzung(202,:fas_sprache_id)));'||unistr('\000a')||
'      -- User-Account autom. generieren'||unistr('\000a')||
'      :p110_user_account := frgbg_s.GEN_USER_ACCOUNT'||unistr('\000a')||
'                    (:p110_name,:p110_vorname,--:p110_geburtsdatum);'||unistr('\000a')||
'                     to_date(:p110_geburtsdatum,''DD.MM.YYYY''));'||unistr('\000a')||
'      IF :p110_user_account IS NULL THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(1814,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT count(*) INTO v_anz'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE UPPER(user_account)= UPPER(:p110_user_account);'||unistr('\000a')||
'      IF v_anz > 0 THEN'||unistr('\000a')||
'         --RETURN (''Der Benutzer ist bereits vergeben!'');'||unistr('\000a')||
'         RETURN (frgbg_s.holen_uebersetzung(448,'||unistr('\000a')||
'                      :fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'mel.p(''Exception bei Validierung P110_user_account_eingabe Name %1, Vorname %2, GEbdat %3, ACcount %4, Sprache %5, Fehler: %6'', v_PROT_ID, ''ERROR'', ''page110/val_user_account'',:p110_name,:p110_vorname,:p110_geburtsdatum,:p110_user_account,:fas_sprache_id,SQLERRM);   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(202,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P110_user_account_eingabe''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 4690002124238985 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4702419456239012 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4198804322027289 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_GEWICHT_not_null',
  p_validation_sequence=> 210,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :p110_gewicht is NULL THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(2151,:fas_sprache_id))); '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''HCK_MED'',''BESTELLEN'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4193523735484020 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4610916140100168 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_GROESSE_not_null',
  p_validation_sequence=> 230,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :p110_groesse is NULL THEN'||unistr('\000a')||
'      IF frgbg_s.check_rolle_prodr(''PARAMEDIFORM'',:p110_rezept_nr)> 0 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(4,:fas_sprache_id)));'||unistr('\000a')||
'      END IF;    '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''BESTELLEN'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4605314004882564 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4276208242910243 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_GEWICHT_Bereich',
  p_validation_sequence=> 240,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_zahl   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p110_gewicht is not null THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         v_zahl := frgbg_s.FB_FORMAT_FANT_WERT(:P110_GEWICHT,''999D9'',1);'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2151,:fas_sprache_id)||'': ''||'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(3533,:fas_sprache_id));'||unistr('\000a')||
'      END; '||unistr('\000a')||
'      :p110_gewicht:= v_zahl;'||unistr('\000a')||
'      IF :p110_gewicht < 17 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2173,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(2151,:fas_sprache_id),17));      '||unistr('\000a')||
'      ELSIF :p110_gewicht > 150 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2174,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(2151,:fas_sprache_id),150));      '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'',''HCK_MED'',''BESTELLEN'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4276812791939952 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P110_GROESSE_BEREICH',
  p_validation_sequence=> 250,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_zahl   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p110_groesse is not null THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         v_zahl := frgbg_s.FB_FORMAT_FANT_WERT(:P110_groesse ,''999D9'',1);'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(4,:fas_sprache_id)||'': ''||'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(3533,:fas_sprache_id));'||unistr('\000a')||
'      END; '||unistr('\000a')||
'      :p110_groesse := v_zahl;'||unistr('\000a')||
'      IF :p110_groesse < 120 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2173,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(4,:fas_sprache_id),120));      '||unistr('\000a')||
'      ELSIF :p110_groesse > 230 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2174,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(4,:fas_sprache_id),230));      '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'',''HCK_MED'',''BESTELLEN'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 3658019324826781 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 110
 ,p_name => 'hide_show_check_gutschein'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P110_GUTSCHEINSTATUS'
 ,p_triggering_condition_type => 'EQUALS'
 ,p_triggering_expression => '0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
 ,p_display_when_type => 'PLSQL_EXPRESSION'
 ,p_display_when_cond => 'frgbg_s.check_fas_rolle(:APP_USER,  /* Gutscheinverfahren */'||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0 '
  );
wwv_flow_api.create_page_da_action (
  p_id => 3662510226117485 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 110
 ,p_event_id => 3658019324826781 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P110_GUTSCHEINANZAHL'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 3662723732121343 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 110
 ,p_event_id => 3658019324826781 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P110_GUTSCHEINANZAHL'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 3659705134898327 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 110
 ,p_event_id => 3658019324826781 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P110_GUTSCHEINANZAHL'
 ,p_attribute_01 => 'STATIC_ASSIGNMENT'
 ,p_attribute_02 => '0'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 3659920718902895 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 110
 ,p_event_id => 3658019324826781 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P110_GUTSCHEINANZAHL'
 ,p_attribute_01 => 'FUNCTION_BODY'
 ,p_attribute_06 => 'IF NVL(:p110_gutscheinanzahl,0) = 0 THEN'||unistr('\000a')||
'   RETURN 1;'||unistr('\000a')||
'ELSE'||unistr('\000a')||
'   RETURN :p110_gutscheinanzahl;'||unistr('\000a')||
'END IF;'||unistr('\000a')||
''
 ,p_attribute_07 => 'P110_GUTSCHEINANZAHL'
 ,p_attribute_08 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :P110_PERSSTAMM_ID_RECHNUNG is not null THEN'||unistr('\000a')||
'      SELECT p.id,p.name, p.vorname, p.strasse,p.nr, p.plz, p.ort, l.land,'||unistr('\000a')||
'              p.adresszusatz'||unistr('\000a')||
'      INTO :p110_id_rechnung, :p110_name_rechnung,:p110_vorname_rechnung, '||unistr('\000a')||
'           :p110_strasse_rechnung,:p110_nr_rechnung,'||unistr('\000a')||
'           :p110_plz_rechnung,:p110_ort_rechnung, :p110_land_rechnung,'||unistr('\000a')||
'           :p110_adresszusatz_rechnung'||unistr('\000a')||
' ';

p:=p||'     FROM personenstamm p,v_laender l'||unistr('\000a')||
'      WHERE p.id = :P110_PERSSTAMM_ID_RECHNUNG '||unistr('\000a')||
'        and p.land_id = l.id (+);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p110_id_rechnung := NULL;'||unistr('\000a')||
'      :p110_name_rechnung := NULL;'||unistr('\000a')||
'      :p110_vorname_rechnung := NULL;'||unistr('\000a')||
'      :p110_adresszusatz_rechnung := NULL;'||unistr('\000a')||
'      :p110_strasse_rechnung := NULL;  '||unistr('\000a')||
'      :p110_nr_rechnung := NULL;'||unistr('\000a')||
'      :p110_plz_rechnung := NULL;'||unistr('\000a')||
'      :p110_ort_';

p:=p||'rechnung := NULL;'||unistr('\000a')||
'      :p110_land_rechnung := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :P110_PERSSTAMM_ID_LIEFERUNG is not null THEN'||unistr('\000a')||
'      SELECT p.id,p.name, p.vorname, p.strasse,p.nr, p.plz, p.ort, l.land,'||unistr('\000a')||
'             p.adresszusatz'||unistr('\000a')||
'      INTO :p110_id_lieferung, :p110_name_lieferung,:p110_vorname_lieferung, '||unistr('\000a')||
'           :p110_strasse_lieferung,:p110_nr_lieferung,'||unistr('\000a')||
'           :p110_plz_lieferung,:p110_ort_lieferu';

p:=p||'ng, :p110_land_lieferung,'||unistr('\000a')||
'           :p110_adresszusatz_lieferung'||unistr('\000a')||
'      FROM personenstamm p,v_laender l'||unistr('\000a')||
'      WHERE p.id = :P110_PERSSTAMM_ID_LIEFERUNG'||unistr('\000a')||
'        and p.land_id = l.id (+);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p110_id_lieferung := NULL;'||unistr('\000a')||
'      :p110_name_lieferung := NULL;'||unistr('\000a')||
'      :p110_vorname_lieferung := NULL;'||unistr('\000a')||
'      :p110_adresszusatz_lieferung := NULL;'||unistr('\000a')||
'      :p110_strasse_lieferung := NULL;'||unistr('\000a')||
'      :p110_n';

p:=p||'r_lieferung := NULL;'||unistr('\000a')||
'      :p110_plz_lieferung := NULL;'||unistr('\000a')||
'      :p110_ort_lieferung := NULL;'||unistr('\000a')||
'      :p110_land_lieferung := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3038027636919759 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_externe_adressen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''In setze_fas_pers_aenderbar'',v_prot_id,''INFO'',''102/110 setze_fas_pers_aenderbar'');'||unistr('\000a')||
'   IF   (:p110_aenderbar = ''J'') '||unistr('\000a')||
'     OR (:p110_aenderbar = ''N'' AND'||unistr('\000a')||
'         -- speziell berechtigt'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''GESCHUETZTE_PERSONENDATEN_AENDERN'') > 0 '||unistr('\000a')||
'         )'||unistr('\000a')||
'      OR (:p110_aenderbar = ''N'' AND                 -- User hat sich selbst e';

p:=p||'ingeloggt'||unistr('\000a')||
'          :fas_aufgerufen_von != ''BETREUER'' and'||unistr('\000a')||
'          UPPER(:P110_USER_ACCOUNT)= UPPER(:APP_USER)'||unistr('\000a')||
'         )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :fas_pers_aenderbar := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_aenderbar := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4812315671356071 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 41,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_fas_pers_aenderbar',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'    :p110_satzkennzeichen := ''GELOESCHT von ''||:APP_USER||'' am ''||SYSDATE; '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4713028572239045 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 1,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_satz_delete',
  p_process_sql_clob => p,
  p_process_error_message=> 'Datensatz konnte nicht gelöscht werden!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4690218325238985 + wwv_flow_api.g_id_offset,
  p_process_success_message=> 'Datensatz wurde erfolgreich gelöscht!',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p110_mutuser := :APP_USER;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5072225168516475 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 2,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mutuser_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'/*SAVE DELETE RECHLOE*/'||unistr('\000a')||
':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'') ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p110_passwort := frgbg_s.gen_passwort(1);'||unistr('\000a')||
'   IF frgbg_s.get_pers_option(:APP_USER,28)= 1 THEN /* IABC-Betr.zugr*/  /* NEI 11.01.10 */'||unistr('\000a')||
'      :p110_erfuser := :APP_USER||''##''||to_char(:FAS_IDENTITAET_PERSSTAMM_ID)||''##'''||unistr('\000a')||
'                                ||to_char(:FAS_LOGIN_PERSONENSTAMM_ID)||''##'';'||unistr('\000a')||
'   ELSE /* Std.zugriff Identität */              '||unistr('\000a')||
'      :p110_erfuser := :APP_USER||''##''||to_c';

p:=p||'har(:FAS_IDENTITAET_PERSSTAMM_ID)||''##'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p110_mutuser := :p110_erfuser;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4925226858741892 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 3,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'erfuser_pw_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4690002124238985 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''set_land_id_null request:%1'',v_prot_id,''INFO'',''102/110:set_land_id_null'',:request);'||unistr('\000a')||
'   IF :p110_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      :p110_land_id := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3004331319042696 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 4,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_land_id_null',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*MEL.p(''Adresse löschen: Pers=%1 Rech-id:%2  Lief-id:%3 request:%4 [page110,adresse löschen]'', v_PROT_ID, ''ERROR'', ''fas'',:p110_id,:p110_persstamm_id_rechnung,:p110_persstamm_id_lieferung,:request);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :REQUEST = ''RECHLOESCHEN'' THEN'||unistr('\000a')||
'      :P110_PERSSTAMM_ID_RECHNUNG := NULL;'||unistr('\000a')||
'/*MEL.p(''Adresse löschen2: Pers=%1 id:%2 request:%3 [page110,adresse löschen]'', v_P';

p:=p||'ROT_ID, ''ERROR'', ''fas'',:p110_id,:p110_persstamm_id_rechnung,:request);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   ELSIF :REQUEST = ''LIEFERLOESCHEN'' THEN'||unistr('\000a')||
'      :P110_PERSSTAMM_ID_LIEFERUNG := NULL;'||unistr('\000a')||
'/*MEL.p(''Adresse löschen2: Pers=%1 id:%2 request:%3 [page110,adresse löschen]'', v_PROT_ID, ''ERROR'', ''fas'',:p110_id,:p110_persstamm_id_lieferung,:request);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3044606923093509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'externe_adressen_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:PERSONENSTAMM:P110_ID:ID|IU';

wwv_flow_api.create_page_process(
  p_id     => 3740317557927156 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 11,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'personenstamm_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''IDENTITAET'',''P110_REZEPT_NR'') ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_return_key_into_item1=>'P110_ID',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'-- Da evt. beim Speichern die Patientensprache geändert wird, kann dies '||unistr('\000a')||
'-- auf die FAS-Sprache auswirkungen haben => FAS-Sprache neu bestimmen'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :fas_sprache_id:= frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 9332805896056517 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fas_sprache_festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 2176006817607351 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 61,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_persstamm_id_identitaet  pers_zugriffe.persstamm_id_betreuerzugriff%TYPE;'||unistr('\000a')||
'   v_standard                 pers_zugriffe.standard%TYPE;'||unistr('\000a')||
'   v_anz     number;'||unistr('\000a')||
'   v_anz_std number;'||unistr('\000a')||
'   v_return  number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p110_betreuer = ''N'' THEN '||unistr('\000a')||
'      -- Default-Identität der Login-Betreuers holen'||unistr('\000a')||
'      --v_persstamm_id_identitaet := frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'    ';

p:=p||'  -- Aktive Identität'||unistr('\000a')||
'      v_persstamm_id_identitaet :=:fas_identitaet_persstamm_id;'||unistr('\000a')||
'      /*'||unistr('\000a')||
'      -- Check Vorhandensein der Zugriffe'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM pers_zugriffe'||unistr('\000a')||
'      WHERE persstamm_id_betreuer = :p110_id'||unistr('\000a')||
'        AND persstamm_id_betreuerzugriff = :p110_id;'||unistr('\000a')||
'      IF v_anz = 0 THEN'||unistr('\000a')||
'         INSERT INTO pers_zugriffe (persstamm_id_betreuer,persstamm_id_betreuerzugr';

p:=p||'iff)'||unistr('\000a')||
'         VALUES (:p110_id,:p110_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      -- Check Std-Identitaeten Zugriff'||unistr('\000a')||
'      SELECT count(*) into v_anz_std'||unistr('\000a')||
'      FROM pers_zugriffe'||unistr('\000a')||
'      WHERE persstamm_id_betreuer = :p110_id'||unistr('\000a')||
'        AND standard = ''J'';'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM pers_zugriffe'||unistr('\000a')||
'      WHERE persstamm_id_betreuer = :p110_id'||unistr('\000a')||
'        AND persstamm_id_betreuerzugriff = v_persstamm_id_identita';

p:=p||'et;'||unistr('\000a')||
'      IF v_anz = 0 THEN'||unistr('\000a')||
'         IF v_anz_std = 0 THEN'||unistr('\000a')||
'            v_standard := ''J''; -- Als Standard eintragen, da bisher kein Standard vorhanden'||unistr('\000a')||
'         ELSE '||unistr('\000a')||
'            v_standard := ''N''; -- Es gibt bereits einen Standard => nur als Zugriff eintragen'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         INSERT INTO pers_zugriffe (persstamm_id_betreuer,persstamm_id_betreuerzugriff,standard)'||unistr('\000a')||
'         VALUES (:p110_id,';

p:=p||'v_persstamm_id_identitaet,v_standard);'||unistr('\000a')||
'      END IF;  '||unistr('\000a')||
'      UPDATE personenstamm'||unistr('\000a')||
'      SET betreuer = ''J'''||unistr('\000a')||
'      WHERE id = :p110_id;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_return := frgbg_s.gen_betreuer (:p110_id,v_persstamm_id_identitaet,'||unistr('\000a')||
'                                        :FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
'         ROLLBACK;'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetz';

p:=p||'ung(1915,:fas_sprache_id,v_return));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4202722457486457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 71,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'betreuer_anlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4197921092937301 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_persstamm_id_identitaet      pers_zugriffe.persstamm_id_betreuer%TYPE;'||unistr('\000a')||
'   v_persstamm_id_oberidentitaet  pers_zugriffe.persstamm_id_betreuerzugriff%TYPE;'||unistr('\000a')||
'   v_standard                     pers_zugriffe.standard%TYPE;'||unistr('\000a')||
'   v_provisionshierarchie         number;'||unistr('\000a')||
'   v_anz_std number;'||unistr('\000a')||
'   v_return  number;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p110_betreuer = ''N'' THEN '||unistr('\000a')||
'      -- Default-Identität';

p:=p||' der Login-Betreuers holen'||unistr('\000a')||
'      -- v_persstamm_id_identitaet := frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'      -- Aktive Identität'||unistr('\000a')||
'      v_persstamm_id_identitaet := :fas_identitaet_persstamm_id;'||unistr('\000a')||
'      -- Oberidentitaet holen'||unistr('\000a')||
'      SELECT persstamm_id_oberidentitaet into v_persstamm_id_oberidentitaet'||unistr('\000a')||
'      FROM pers_identitaeten'||unistr('\000a')||
'      WHERE persstamm_id_identitaet = v_persstamm_i';

p:=p||'d_identitaet;'||unistr('\000a')||
''||unistr('\000a')||
'      -- NEI 18.04.12 Pruefen, ob Provionshierachie automatisch verwaltet werden soll'||unistr('\000a')||
'      IF :p110_ident_option = 0 THEN -- Community-Mitglied ohne Rolle 24 soll angelegt werden'||unistr('\000a')||
'         v_provisionshierarchie := frgbg_s.get_pers_option(NULL,34,:fas_identitaet_persstamm_id,'||unistr('\000a')||
'                                                       :FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_p';

p:=p||'rovisionshierarchie := 0; -- Community-Master werden nie in Hierarchie eingetragen'||unistr('\000a')||
'                                      -- Haengen in der Hierarchie automatisch ganz oben'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''Beim Anlegen einer Ident/Betreuerstruktur pers: %1, Ober-Identitaet: %2, akt.Ident %3, r24: %4, Provision: %5, Return:%6! [FAS102/110,identitaet_anlegen]''||SQLERRM, v_PROT_ID, ''INFO'', ''FAS102/110,identit';

p:=p||'aet_anlegen'',:p110_id,v_persstamm_id_oberidentitaet,v_persstamm_id_identitaet,:p110_ident_option,v_provisionshierarchie,v_return);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      -- Identitaetstruktur anlegen'||unistr('\000a')||
'      v_return := frgbg_s.gen_ident_betreuer (:p110_id,v_persstamm_id_oberidentitaet,'||unistr('\000a')||
'                            v_persstamm_id_identitaet,'||unistr('\000a')||
'                            :p110_ident_option,     -- NEI 18.04.12 Rolle 24 bei Ident ei';

p:=p||'nhaengen'||unistr('\000a')||
'                            v_provisionshierarchie) -- NEI 18.04.12 Provisionshierarchie eintragen'||unistr('\000a')||
'                   ;'||unistr('\000a')||
'/*MEL.P (''Beim Anlegen einer Ident/Betreuerstruktur pers: %1, Ober-Identitaet: %2, akt.Ident %3, r24: %4, Provision: %5, Return:%6! [FAS102/110,identitaet_anlegen]''||SQLERRM, v_PROT_ID, ''INFO'', ''FAS102/110,identitaet_anlegen'',:p110_id,v_persstamm_id_oberidentitaet,v_pers';

p:=p||'stamm_id_identitaet,:p110_ident_option,v_provisionshierarchie,v_return);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR'||unistr('\000a')||
'                  (-20000,frgbg_s.holen_uebersetzung(1915,:fas_sprache_id,v_return));         '||unistr('\000a')||
'         ROLLBACK;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4272316498394365 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 81,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'identitaet_anlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>1314313996499157 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :P110_GUTSCHEINSTATUS := NVL(:P110_GUTSCHEINSTATUS,0);'||unistr('\000a')||
'   :P110_GUTSCHEINANZAHL := NVL(:P110_GUTSCHEINANZAHL,0);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3663125164150211 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_gutschein',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'    IF frgbg_s.check_fas_rolle(:APP_USER,''COMMUNITY_ADMIN'')> 0 /*Community-Admin */ THEN'||unistr('\000a')||
'       :p110_ident_option := NVL(:p110_ident_option,1);'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'       :p110_ident_option := NVL(:p110_ident_option,0);'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4630303745697010 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_ident_option',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p110_betreuer := NVL(:p110_betreuer,''N'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6346727600977400 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_betreuer',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p110_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p110_bl_loeschen  := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p110_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :p110_bl_aendern   := frgbg_s.holen_uebersetzung(162,v_sprache_id);'||unistr('\000a')||
'   :p110_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_s';

p:=p||'prache_id);'||unistr('\000a')||
'   :p110_bl_passwort_chg := frgbg_s.holen_uebersetzung(171,v_sprache_id);'||unistr('\000a')||
'   :P110_BL_warenkorb := frgbg_s.holen_uebersetzung(3097,v_sprache_id);'||unistr('\000a')||
'   :P110_BL_auswaehlen := frgbg_s.holen_uebersetzung(1597,v_sprache_id); '||unistr('\000a')||
'   --:P110_BL_hck_med := frgbg_s.holen_uebersetzung(2152,v_sprache_id); '||unistr('\000a')||
'   --:P110_BL_hck_med_nachdruck := frgbg_s.holen_uebersetzung(2217,v_sprache_id); '||unistr('\000a')||
'   --:P110_B';

p:=p||'L_bestellen := frgbg_s.holen_uebersetzung(1980,v_sprache_id); '||unistr('\000a')||
'   :p110_bl_fb_rezept := frgbg_s.holen_uebersetzung(485,v_sprache_id); '||unistr('\000a')||
'   :p110_bl_betreuer  := frgbg_s.holen_uebersetzung(1854,v_sprache_id); '||unistr('\000a')||
'   :p110_bl_identitaet:= frgbg_s.holen_uebersetzung(3581,v_sprache_id); '||unistr('\000a')||
''||unistr('\000a')||
'   :p110_region_titel_pwd_chg := frgbg_s.holen_uebersetzung(170,v_sprache_id);'||unistr('\000a')||
'   :p110_region_titel_hilfetexte := frg';

p:=p||'bg_s.holen_uebersetzung(220,v_sprache_id);'||unistr('\000a')||
'   :p110_region_titel_infotext := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   :p110_page_titel_patientanzeige := frgbg_s.holen_uebersetzung(482,v_sprache_id);'||unistr('\000a')||
'   :P110_PAGE_TITEL_RECHNUNGSADR:= frgbg_s.holen_uebersetzung(1596,v_sprache_id);'||unistr('\000a')||
'   :P110_PAGE_TITEL_LIEFERADR:= frgbg_s.holen_uebersetzung(1685,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P110_BETRABFR_TEXT := frgbg';

p:=p||'_s.holen_uebersetzung(3831,v_sprache_id);'||unistr('\000a')||
'   :P110_IDENTABFR_TEXT := frgbg_s.holen_uebersetzung(3832,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P110_NV_PATIENT := frgbg_s.holen_uebersetzung(3835,v_sprache_id);'||unistr('\000a')||
'  '||unistr('\000a')||
'   :p110_info := frgbg_s.holen_uebersetzung(173,v_sprache_id);'||unistr('\000a')||
'   :p110_fehler := frgbg_s.holen_uebersetzung(487,v_sprache_id);'||unistr('\000a')||
'   :p110_tab1_text := frgbg_s.holen_uebersetzung(484,v_sprache_id);'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4711609817239035 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 2,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''alert("''||frgbg_s.holen_uebersetzung(2249,:fas_sprache_id)||''");'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4274614489268510 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'nachdruckhinweis_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'NACHDRUCKHINWEIS',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_plandatum DATE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_plandatum := to_date(to_char(sysdate,''DD.MM.YYYY''),''DD.MM.YYYY'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''alert("''||frgbg_s.holen_uebersetzung(2000,:fas_sprache_id,v_plandatum)||''");'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2028403236409900 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 6,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'bestellhinweis_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':REQUEST in (''BESTELLHINWEIS'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_user_account   personenstamm.user_account%TYPE;'||unistr('\000a')||
'   v_passwort       personenstamm.passwort%TYPE;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   -- Holen des aktuellen PW/UserAccount: Noch bevor neue akt. Ident geholt wird '||unistr('\000a')||
'   -- und persstamm geladen wird,'||unistr('\000a')||
'   -- da dies evt. nicht funktioniert und auf die Page 130 gesprungen werden muss.'||unistr('\000a')||
'   -- Zuvor muss der Vorgang';

p:=p||' noch ordnungsgemaess abgeschlossen werden'||unistr('\000a')||
'   SELECT user_account, passwort '||unistr('\000a')||
'   INTO v_user_account, v_passwort'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :p110_id;'||unistr('\000a')||
''||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
''||unistr('\000a')||
'   IF frgbg_s.get_pers_option(:APP_USER,30) = 1 THEN -- Betreuerhinweis und PW mailen'||unistr('\000a')||
'      IF frgbg_s.get_pers_option(:APP_USER,28) = 1 THEN  -- Betreuer-/Sperr-Hinweis ohne ';

p:=p||'PW mailen'||unistr('\000a')||
'         -- Sperrhinweis anzeigen und Mail erst beim entsperren'||unistr('\000a')||
'         htp.p(''alert("''||frgbg_s.holen_uebersetzung(3768,:fas_sprache_id,'||unistr('\000a')||
'                                         --      :p110_USER_ACCOUNT)||''");'');'||unistr('\000a')||
'                                                 v_USER_ACCOUNT)||''");'');'||unistr('\000a')||
'      ELSE  -- Betreuerhinweis mit PW mailen zusätzlich Anzeige'||unistr('\000a')||
'         htp.p(''alert("''||frgbg_s.h';

p:=p||'olen_uebersetzung(3774,:fas_sprache_id,'||unistr('\000a')||
'                                         --      :p110_USER_ACCOUNT,:p110_passwort)||''");'');'||unistr('\000a')||
'                                                 v_USER_ACCOUNT,v_passwort)||''");'');'||unistr('\000a')||
'         --v_return := frgbg_s.MAIL_NEUES_PASSWORT(:p110_USER_ACCOUNT,NULL,  -- Zielperson'||unistr('\000a')||
'         v_return := frgbg_s.MAIL_NEUES_PASSWORT(v_USER_ACCOUNT,NULL,  -- Zielperson'||unistr('\000a')||
'      ';

p:=p||'                                           3771,3772,                -- Betreff-/Mailtexte'||unistr('\000a')||
'                                                 :FAS_IDENTITAET_PERSSTAMM_ID,-- Absender'||unistr('\000a')||
'                                                 0,0,   -- keine neue PW-Vergabe,no_reply-adresse'||unistr('\000a')||
'                                                 0);    -- keine Notfallemail'||unistr('\000a')||
'    '||unistr('\000a')||
'         IF v_return <= 0 THEN'||unistr('\000a')||
'       ';

p:=p||'     htp.p(''alert("''||frgbg_s.holen_uebersetzung(3773,:fas_sprache_id,'||unistr('\000a')||
'                                               --:p110_USER_ACCOUNT,:p110_passwort)||''");'');'||unistr('\000a')||
'                                               v_USER_ACCOUNT,v_passwort)||''");'');'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;  '||unistr('\000a')||
'   ELSE  -- PW anzeigen'||unistr('\000a')||
'      htp.p(''alert("''||frgbg_s.holen_uebersetzung(3580,:fas_sprache_id,'||unistr('\000a')||
'                        ';

p:=p||'                       --:p110_USER_ACCOUNT,:p110_passwort)||''");'');'||unistr('\000a')||
'                                               v_USER_ACCOUNT,v_passwort)||''");'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   mel.p(''Zugriff auf Patientendaten fehlgeschlagen Ident/Betreuerhinweis!ID %1,%2'', '||unistr('\000a')||
'          v_prot_id,''ERROR'',  '||unistr('\000a')||
'          ''102/110:betreuerhinweis_ausgeben'',:p1';

p:=p||'10_id,SQLERRM);'||unistr('\000a')||
'   RAISE_APPLICATION_ERROR(-20000,''Fehler'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4295307778185589 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 7,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'betreuerhinweis_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''BETREUER_HINWEIS'' ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'   v_return NUMBER;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*mel.p(''p110_person %1,p110_pis_pat_akte_id %2,fas_aufgerufen_von %3,:p110_id %4,%5'',v_prot_id,''INFO'', ''102/P110 get_personendaten'',:p110_person,:p110_pis_pat_akte_id,:fas_aufgerufen_von,:p110_id,:APP_USER);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :p110_person is null AND :p110_pis_pat_akte_id IS NULL '||unistr('\000a')||
'   THEN   '||unistr('\000a')||
' ';

p:=p||'     --IF :p110_abbrechen_zu_seite = 130 THEN  -- Anlegen eines Patienten'||unistr('\000a')||
'      IF :fas_aufgerufen_von = ''BETREUER'' THEN -- Anlegen eines Patienten'||unistr('\000a')||
'         --:p110_id := NULL;'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'      ELSE              -- externes Login :p110_person wird mit dem aktuellen Benutzer bestückt'||unistr('\000a')||
'         v_user  := :APP_USER;'||unistr('\000a')||
'         SELECT id   '||unistr('\000a')||
'         INTO :p110_id '||unistr('\000a')||
'         FROM personenstamm'||unistr('\000a')||
'       ';

p:=p||'  WHERE user_account = UPPER(v_user)'||unistr('\000a')||
'           AND satzkennzeichen is null;  -- gelöschte Sätze nicht mehr anzeigen'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE  -- Aufruf via Pis p110_person oder betreuer-Login enthält bereits die Personenstamm_id; '||unistr('\000a')||
'      IF :p110_person is not NULL THEN'||unistr('\000a')||
'         :p110_id := :p110_person;'||unistr('\000a')||
'      ELSE  -- Person nur in PIS => in Personenstamm von FAS anlegen'||unistr('\000a')||
'         -- Check ADR-Verwei';

p:=p||'s      NEI 13.12.07'||unistr('\000a')||
'         v_return := mailingauftraege_s.GET_ADR_VERWEIS_FAS(:p110_pis_adresse_id); '||unistr('\000a')||
'         IF v_return <= 0 THEN'||unistr('\000a')||
'            -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id)||'||unistr('\000a')||
'                                                    '' (''||to_char(v_return)||'',1)'';'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20000,v_f';

p:=p||'ehlertext );'||unistr('\000a')||
'         ELSIF v_return > 0 THEN'||unistr('\000a')||
'            :p110_id := v_return;'||unistr('\000a')||
'         ELSE -- NULL Es wurde kein Verweis gefunden => Person neu aufnehmen'||unistr('\000a')||
'            v_return := frgbg_s.gen_personenstamm(:p110_pis_pat_akte_id,NULL,:APP_USER,'||unistr('\000a')||
'                                                  1,-- mit Dummy-Passwort'||unistr('\000a')||
'                                                  1,-- mit PIS-Adr-Verweis'||unistr('\000a')||
'      ';

p:=p||'                                            0);-- als Kunde u. nicht als Betreuer'||unistr('\000a')||
'            IF v_return <= 0 THEN'||unistr('\000a')||
'               -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id)||'||unistr('\000a')||
'                                                       '' (''||to_char(v_return)||'',2)'';'||unistr('\000a')||
'               ROLLBACK;'||unistr('\000a')||
'               RAISE_APPLICATION';

p:=p||'_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               COMMIT;'||unistr('\000a')||
'               :p110_id := v_return;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         END IF;          '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF; '||unistr('\000a')||
'/*mel.p(''p110_person %1,p110_pis_pat_akte_id %2,fas_aufgerufen_von %3,:p110_id %4'',v_prot_id,''INFO'', ''102/P110 get_personendaten'',:p110_person,:p110_pis_pat_akte_id,:fas_aufgerufen_von,:p110_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
' END;';

wwv_flow_api.create_page_process(
  p_id     => 4712622536239042 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 9,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten',
  p_process_sql_clob => p,
  p_process_error_message=> 'Login ungültig!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_kunde        VARCHAR2(2000);'||unistr('\000a')||
'   v_user_account VARCHAR2(2000);'||unistr('\000a')||
'   v_hinweis      varchar2(2000);'||unistr('\000a')||
'   v_return      number := 1;'||unistr('\000a')||
'   v_prot_id     number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''Gutschein-Email versenden %1'',v_prot_id,''TEST'',''102/110:send_gutschein_email'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   --htp.p(''alert("''||frgbg_s.holen_uebersetzung(4907,:fas_sprache_id)||''")';

p:=p||';'');'||unistr('\000a')||
'   htp.p(''if (!confirm("''||frgbg_s.holen_uebersetzung(4907,:fas_sprache_id)||''")) redirect(''''f?p=&APP_ID.:110:&APP_SESSION.'''');'');'||unistr('\000a')||
''||unistr('\000a')||
'   -- Mail-Parameter vorbereiten'||unistr('\000a')||
'   -- auf p110_user_account kann nicht immer zugegriffen werden, da Feld teilweise ausgeblendet wird'||unistr('\000a')||
'   -- und daher nicht bestückt ist => Select über id'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT user_account INTO v_user_account'||unistr('\000a')||
'      FROM personenst';

p:=p||'amm'||unistr('\000a')||
'      WHERE id = :p110_id;'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''Gutschein-Email versenden %1, %2'',v_prot_id,''TEST'',''102/110:send_gutschein_email'',v_user_account,:p110_user_account);'||unistr('\000a')||
'      v_return := frgbg_s.MAIL_TEXT'||unistr('\000a')||
'                       (NULL'||unistr('\000a')||
'                       ,:p110_id'||unistr('\000a')||
'                       ,4908                     -- BETREFF_TEXT_ID'||unistr('\000a')||
'                       ,4909                     -- MAIL_TEXT_ID  '||unistr('\000a')||
'        ';

p:=p||'               ,:FAS_IDENTITAET_PERSSTAMM_ID    -- PERSSTAMM_ID_MAILABSENDER => Identität'||unistr('\000a')||
'                       ,0                        -- Replay-Adresse'||unistr('\000a')||
'                       ,1                        -- NOTFALL_EMAIL '||unistr('\000a')||
'                       ,v_user_account           -- Param1  '||unistr('\000a')||
'                       ,NULL                     -- Param2'||unistr('\000a')||
'              );'||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
'         --';

p:=p||' ''Die Email konnte nicht ordnungsgemäss übermittelt werden! ...'||unistr('\000a')||
'         v_hinweis := frgbg_s.holen_uebersetzung(4910,:fas_sprache_id,'||unistr('\000a')||
'                                        frgbg_s.get_pers_adresse(:FAS_IDENTITAET_PERSSTAMM_ID));'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         -- ''Die Email wurde versendet!'';'||unistr('\000a')||
'         v_hinweis := frgbg_s.holen_uebersetzung(4911,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others T';

p:=p||'HEN'||unistr('\000a')||
'      -- ''Die Email konnte nicht ordnungsgemäss übermittelt werden! ...'||unistr('\000a')||
'      v_hinweis := frgbg_s.holen_uebersetzung(4910,:fas_sprache_id,'||unistr('\000a')||
'                                        frgbg_s.get_pers_adresse(:FAS_IDENTITAET_PERSSTAMM_ID));'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   '||unistr('\000a')||
'   htp.p(''alert("''||v_hinweis||''");'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3673604840520539 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'send_gutschein_email',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''GUTSCHEIN_EMAILVERSAND''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_identitaet_persstamm_id   personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fas_pers_schema_id        fas_schemas.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                varchar2(2000);'||unistr('\000a')||
'   v_url                       varchar2(2000);'||unistr('\000a')||
'   v_prot_id                   number;'||unistr('\000a')||
'   v_fehler                    exception;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P (''Wahlidentitaet %1; Login-id %2; Kunde %3, fas_ident %4, p130_ident %5'', v_PROT_ID, --''ERROR'', ''';

p:=p||'aktive_identitaet_setzen'',:p110_wahl_identitaet,:fas_login_personenstamm_id,:p110_id, --:fas_identitaet_persstamm_id,:P130_IDENTITAET);'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      IF :p110_wahl_identitaet IS NOT NULL THEN  -- Prüfen, ob Identitaet neu gesetzt werden muss'||unistr('\000a')||
'         IF :p110_id IS NULL THEN -- Neue Person'||unistr('\000a')||
'            IF :p110_wahl_identitaet = 0 THEN -- aktive Identität verwend';

p:=p||'en'||unistr('\000a')||
'               v_identitaet_persstamm_id:= :fas_identitaet_persstamm_id; '||unistr('\000a')||
'            ELSE  -- eingestellte Identität verwenden'||unistr('\000a')||
'               v_identitaet_persstamm_id:= :p110_wahl_identitaet; '||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE  -- vorhandene Person'||unistr('\000a')||
'            /* NEI 16.09.11 => Zukünftig soll keine Rücksicht auf die Wahlidentität genommen werden'||unistr('\000a')||
'                               sondern nur noc';

p:=p||'h die bevorzugt betreuende Person des Kunden wird'||unistr('\000a')||
'                               aktive Identität, sofern der Betreuerzugriff hat'||unistr('\000a')||
'            v_identitaet_persstamm_id:=  '||unistr('\000a')||
'               frgbg_s.get_identitaet_kunde(:fas_login_personenstamm_id,'||unistr('\000a')||
'                                            :p110_wahl_identitaet,'||unistr('\000a')||
'                                            :p110_id);'||unistr('\000a')||
'            */'||unistr('\000a')||
'            /* NEI';

p:=p||' 20.09.13: => Zukünftig wird nur noch die bevorzugt betreuende Person des Kunden zur'||unistr('\000a')||
'                               aktive Identität egal ob der Betreuer Zugriff auf die Identität hat.'||unistr('\000a')||
'                               Er sieht den Kunden, vielleicht auch nur, weil er speziell Zugriff auf den Kunden hat, '||unistr('\000a')||
'                               da der Kunde von einer Idenität (Apo Richter) noch zusätzlich bet';

p:=p||'reut wird, '||unistr('\000a')||
'                               auf die der Betreuer auch Zugriff hat. D.h. der Betreuer hat nicht direkten Zugriff'||unistr('\000a')||
'                               auf die bevorzugt betreuende Identität und daher auf alle Kunden von dieser Identität, '||unistr('\000a')||
'                               sondern nur ein spezieller Kunde dieser bevorzugt betreuende Identität ist für den Betreuer bzw.'||unistr('\000a')||
'                          ';

p:=p||'     seiner zugreifbaren Identitäten freigeschaltet.'||unistr('\000a')||
'            */'||unistr('\000a')||
'            v_identitaet_persstamm_id:=  '||unistr('\000a')||
'               frgbg_s.get_identitaet_kunde(NULL,      --:fas_login_personenstamm_id,'||unistr('\000a')||
'                                            -1,'||unistr('\000a')||
'                                            :p110_id);'||unistr('\000a')||
''||unistr('\000a')||
'/* MEL.P (''2 Wahlidentitaet %1; Login-id %2; Ident %3;%4'', v_PROT_ID, ''TESTINFO'', aktive_identitaet_';

p:=p||'setzen'',:p110_wahl_identitaet,:fas_login_personenstamm_id,v_identitaet_persstamm_id,:p130_identitaet); '||unistr('\000a')||
'*/'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         IF v_identitaet_persstamm_id <= 0 OR '||unistr('\000a')||
'            v_identitaet_persstamm_id is NULL'||unistr('\000a')||
'         THEN '||unistr('\000a')||
'            :fas_identitaet := '''';'||unistr('\000a')||
'            :fas_identitaet_persstamm_id := NULL;'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(3098,:fas_sprache_id);'||unistr('\000a')||
'     ';

p:=p||'       RAISE v_fehler;'||unistr('\000a')||
'            --RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'            :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,'||unistr('\000a')||
'                                                          :FAS_SCHEMA_ID);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         :p110_wahl_identitaet := NULL; -- muss nur ';

p:=p||'einmal gesetzt werden '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''ANONYM'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Betreuende Identitaet für Endkunden holen'||unistr('\000a')||
'       SELECT parameter'||unistr('\000a')||
'       INTO v_identitaet_persstamm_id'||unistr('\000a')||
'       FROM sysareas_frgbg'||unistr('\000a')||
'       WHERE id = 6;'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identita';

p:=p||'et_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''KUNDE'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Holen der Identitaet aus Pers_betreuer mit standard = J'||unistr('\000a')||
'       v_identitaet_persstamm_id := frgbg_s.GET_IDENTITAET_KUNDE(NULL,-1,:p110_id);'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identit';

p:=p||'aet_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Schema-Id des Kunden setzen, abgeleitet aus der bevorzugt betreuenden Identitaet'||unistr('\000a')||
'   IF :p110_id IS NULL THEN -- Erstellen eines neuen Patienten'||unistr('\000a')||
'      :fas_pers_schema_id := :fas_schema_id; -- Schema der eingeloggten Person'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Schema der bevorzugt betreuenden Identitaet bestimmen '||unistr('\000a')||
'      v_fas_pers_schema_id := frgbg_';

p:=p||'s.get_fas_schema('||unistr('\000a')||
'            frgbg_s.get_identitaet_kunde(NULL,-1,:p110_id),'||unistr('\000a')||
'             ''IDENTITAET'');'||unistr('\000a')||
'      IF v_fas_pers_schema_id <= 0 OR '||unistr('\000a')||
'         v_fas_pers_schema_id is NULL'||unistr('\000a')||
'      THEN '||unistr('\000a')||
'         :fas_pers_schema_id := '''';'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(3505,:fas_sprache_id);'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'         --         RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
' ';

p:=p||'     ELSE'||unistr('\000a')||
'         :fas_pers_schema_id := v_fas_pers_schema_id;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Sortiment-ID der aktiven Identitaet '||unistr('\000a')||
'   -- NEI 14.02.2011 Sortimentseinfuehrung: sortiment_id statt preislisten_set_id      '||unistr('\000a')||
'   :FAS_SORTIMENT_ID:= rezepte.get_sortiment(:FAS_IDENTITAET_PERSSTAMM_ID,''IDENTITAET'');'||unistr('\000a')||
'   IF :FAS_SORTIMENT_ID <= 0 OR '||unistr('\000a')||
'      :FAS_SORTIMENT_ID is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :FAS_SORTI';

p:=p||'MENT_ID := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3518,:fas_sprache_id);'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'      --      RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''2 Wahlidentitaet %1; Login-id %2; Ident %3; Schema-kunde:%4, Schema:%5,Sortiment:%6,Person:%7'', v_PROT_ID, ''TEST'', ''aktive_identitaet_setzen'',:p110_wahl_identitaet,:fas_login_personenstamm_id,'||unistr('\000a')||
':FAS_IDENTITAE';

p:=p||'T_PERSSTAMM_ID,:fas_pers_schema_id,:fas_schema_id,:FAS_SORTIMENT_ID,:p110_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   v_url:= APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':130:''||:APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   apex_application.g_';

p:=p||'unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   mel.p(''Zugriff auf Patientendaten fehlgeschlagen!%1'',v_prot_id,''ERROR'',  '||unistr('\000a')||
'            ''102/110:aktive_identitaet_pers_schema_sortiment_setzen'',SQLERRM);'||unistr('\000a')||
'   v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'   v_url:= APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':130:''||:APP_SESSION||''::::P130_HINWEIS';

p:=p||':''||v_fehlertext);'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2588722670484542 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'aktive_identitaet_pers_schema_sortiment_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_gus_id     personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_satzkennzeichen personenstamm.satzkennzeichen%TYPE;'||unistr('\000a')||
'   v_url        VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* Identitaeten dürfen nicht gelöscht sein  */'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT gus_id,satzkennzeichen INTO v_gus_id,v_satzkennzeichen'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :FAS_IDENTITAET_PERSSTAMM_ID;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_satzkennzeichen is not null TH';

p:=p||'EN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(10179,:fas_sprache_id);'||unistr('\000a')||
'      v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':130:''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'';

p:=p||'      apex_application.g_unrecoverable_error := true;   --- stops all further page processing      '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 9389013743992053 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 21,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_zugang',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_von_mn_rezept_id mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_von_bemerkung    mn_rezepte.bemerkung%TYPE;'||unistr('\000a')||
'   v_von_bezeichnung  mn_rezepte.bezeichnung%TYPE; '||unistr('\000a')||
'   v_von_rezept_nr    mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_von_version      mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_von_reichweite   prod_rezepte.reichweite%TYPE;'||unistr('\000a')||
'   v_mn_rezept_id     mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_mn_rezept_id_neu mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_rezept_nr   ';

p:=p||'     mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_version          mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_version_neu      mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_verrechnungsland mn_rezepte.verrechnungsland%type;'||unistr('\000a')||
''||unistr('\000a')||
'   v_sprache_id   NUMBER := :fas_sprache_id;  '||unistr('\000a')||
'   v_fehlertext   VARCHAR2(2000);'||unistr('\000a')||
'   v_return       NUMBER;'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P110_MN_REZEPT_ID_KOPIE IS NOT NULL THEN'||unistr('\000a')||
' /*MEL.P (''Rezept Kopieren: Pe';

p:=p||'rs=%1 MN-REZEPT:%2! [page110,rezept_kopieren]'', v_PROT_ID, ''ERROR'', ''fas'',:p110_id,:p110_mn_rezept_id_kopie);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'      v_von_mn_rezept_id := :P110_MN_REZEPT_ID_KOPIE;'||unistr('\000a')||
'      :P110_MN_REZEPT_ID_KOPIE := NULL;'||unistr('\000a')||
'      v_return := rezepte.gen_kopie_mnr_prodr('||unistr('\000a')||
'                   v_von_mn_rezept_id,'||unistr('\000a')||
'                   -- 1 ,     -- gen_hint1=1 =>Maximalmenge muss eingehalten werden -- NEI 15.4.10'||unistr('\000a')||
'       ';

p:=p||'            0,      -- gen_hint1 = 0 => Sollmengen muessen eingehalten werden'||unistr('\000a')||
'                   NULL,   -- gen_hint2 NULL => Wert aus Vorgängerversion benutzen i.R. Reichweite'||unistr('\000a')||
'                   :p110_id,'||unistr('\000a')||
'                   :APP_USER,'||unistr('\000a')||
'                   0, --1=Def.aus der Vorgängerversion, 0= Standarddef.'||unistr('\000a')||
'                   :fas_sortiment_id,            -- NEI 14.02.2011 Sortimentseinfuehrung '||unistr('\000a')||
'  ';

p:=p||'                 :fas_identitaet_persstamm_id, -- NEI 16.09.2011 Grenzewerte pers_typ_id abhaengig'||unistr('\000a')||
'                   v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8452600976975467 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 23,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mnr_kopieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'   v_persstamm_id NUMBER;'||unistr('\000a')||
'   v_return       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.p(''Rechnungsadresse eintragen: Pers=%1 id:%2 typ:%3! [page110,rechnungsadresse speichern]'', --v_PROT_ID, ''ERROR'', ''fas'',:p110_id,:p110_persstamm_id_extern_upd,:p110_extern_typ);'||unistr('\000a')||
'   IF :P110_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND :p110_extern_typ = ''R'' THEN'||unistr('\000a')||
'      v_persstamm_id := :P110_persstamm_id_e';

p:=p||'xtern_upd;'||unistr('\000a')||
'      :P110_persstamm_id_extern_upd := NULL;'||unistr('\000a')||
'      :P110_extern_typ:= NULL;'||unistr('\000a')||
' '||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET persstamm_id_rechnung = v_persstamm_id'||unistr('\000a')||
'         WHERE id = :p110_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'/*MEL.p(''Rechnungsadresse speichern: Pers=%1 id:%2! Fehler:%3 [page110,Rechnungsadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'',:p110_';

p:=p||'id,:p110_persstamm_id_rechnung, SQLERRM);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSIF :P110_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND :p110_extern_typ = ''L'' THEN'||unistr('\000a')||
'      v_persstamm_id := :P110_persstamm_id_extern_upd;'||unistr('\000a')||
'      :P110_persstamm_id_extern_upd := NULL;'||unistr('\000a')||
'      :P110_extern_typ:= NULL;'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.p(''Lieferadresse speichern: Pers=%1 id:%2! Fehler:%3 [page110,Lieferadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'',:p110_id';

p:=p||',:P110_persstamm_id_lieferung, SQLERRM);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET persstamm_id_lieferung = v_persstamm_id'||unistr('\000a')||
'         WHERE id = :p110_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
''||unistr('\000a')||
'      END;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3033103320657289 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'externe_adressen_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p110_prepare_url_pw:= apex_util.prepare_url('||unistr('\000a')||
'   ''f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_ID:''||:P110_ID);';

wwv_flow_api.create_page_process(
  p_id     => 2734422787390471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 61,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_prepare_url_pw',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:PERSONENSTAMM:P110_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 11315123600377743 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 62,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'personenstamm_holen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   /* z.B. GUS-Adr. darf nicht im FAS verändert werden */'||unistr('\000a')||
'   :p110_pers_readonly:=frgbg_T.check_pers_extern_verwaltet(:p110_EXTERN_VERWALTET ) ; '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 10173921232746357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 64,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_adr_readonly',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DELETE wkorb_det_verordnungen_tmp'||unistr('\000a')||
'WHERE warenkorb_detail_tmp_id in (SELECT wkd.id '||unistr('\000a')||
'                           FROM warenkoerbe_tmp wk, warenkorb_details_tmp wkd'||unistr('\000a')||
'                           WHERE wk.session_id =  :app_session'||unistr('\000a')||
'                             and wk.id = wkd.warenkorb_tmp_id'||unistr('\000a')||
'                           );'||unistr('\000a')||
'DELETE warenkorb_details_tmp'||unistr('\000a')||
'WHERE warenkorb_tmp_id in (SELECT id '||unistr('\000a')||
'                 ';

p:=p||'          FROM warenkoerbe_tmp'||unistr('\000a')||
'                           WHERE session_id =  :app_session'||unistr('\000a')||
'                          );'||unistr('\000a')||
'DELETE warenkoerbe_tmp'||unistr('\000a')||
'where session_id = :app_session;';

wwv_flow_api.create_page_process(
  p_id     => 2057509592087626 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_warenkorb_tmp',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_PERSSTAMM_ID_prod_apo     personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_return                    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Adressprüfung'||unistr('\000a')||
'   IF :P110_ID is not null and (:P110_PERSSTAMM_ID_LIEFERUNG is not null or :P110_PERSSTAMM_ID_RECHNUNG is not null) THEN'||unistr('\000a')||
'      v_persstamm_id_prod_apo := frgbg_s.get_pers_option(v(''APP_USER''),21);'||unistr('\000a')||
'      v_return := ';

p:=p||'frgbg_s.WK_CHECK_ADR_KOMPATIBEL(p_persstamm_id_prod_apo => v_PERSSTAMM_ID_prod_apo,'||unistr('\000a')||
'                                               p_persstamm_id_kunde    => :P110_ID,'||unistr('\000a')||
'                                               p_persstamm_id_lieferung=> NVL(:P110_PERSSTAMM_ID_LIEFERUNG,:P110_ID),'||unistr('\000a')||
'                                               p_persstamm_id_rechnung => NVL(:P110_PERSSTAMM_ID_RECHNUNG,:P110_ID';

p:=p||'),'||unistr('\000a')||
'                                               p_warenkorb_tmp_id      => NULL,    -- NEI 05.06.2014'||unistr('\000a')||
'                                               p_sprache_id            => :fas_sprache_id ,'||unistr('\000a')||
'                                               p_fehlertext_out        => v_fehlertext'||unistr('\000a')||
'                                             );'||unistr('\000a')||
'        '||unistr('\000a')||
'      IF v_return < 0 THEN   -- Hinweismeldung; die eigentli';

p:=p||'che scharfe Prüfung findet im WK statt'||unistr('\000a')||
'         IF v_fehlertext is NOT NULL THEN'||unistr('\000a')||
'            --''Die Lieferadresse muss auch in der Schweiz liegen, da die Kunden-/ die Rechnungsadresse in der Schweiz liegt!'''||unistr('\000a')||
'            htp.p(''<body>'');'||unistr('\000a')||
'            htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'            --htp.p(''alert("''||frgbg_s.holen_uebersetzung(5689,:fas_sprache_id)||''");'');'||unistr('\000a')||
'            htp.p(''al';

p:=p||'ert("''||v_fehlertext||''");'');'||unistr('\000a')||
'            htp.p(''</script>'');'||unistr('\000a')||
'            htp.p(''</body>'');'||unistr('\000a')||
'         END IF; '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4327009203637936 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 75,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_adressen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id     number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*mel.p(''Gutscheinemail setzen status %1,statusdb %2 '',v_prot_id,''TEST'',''102/110:set_gutscheinemail'',:p110_gutscheinstatus,:p110_gutscheinstatus_db);'||unistr('\000a')||
'*/'||unistr('\000a')||
'NULL;'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :p110_gutscheinstatus = 1 and '||unistr('\000a')||
'      :p110_gutscheinstatus_db = 0 and'||unistr('\000a')||
'      :request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'','||unistr('\000a')||
'                   ''APPLY_CHANGES_BETREUER'',''I';

p:=p||'DENTITAET'') AND '||unistr('\000a')||
'      frgbg_s.check_fas_rolle(:APP_USER,  '||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0    --Gutscheinverfahren '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p110_gutscheinemail := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p110_gutscheinemail := 0; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'/*mel.p(''Gutscheinemail gesetzt %1, status %2,statusdb %3 '',v_prot_id,''TEST'',''102/110:set_gutscheinemail'',:p110_gutscheinemail,:p110_gutscheinstatus,:p110_gutscheinstatus_db);'||unistr('\000a')||
'*/'||unistr('\000a')||
'E';

p:=p||'ND;';

wwv_flow_api.create_page_process(
  p_id     => 3674918271619112 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 110,
  p_process_sequence=> 5,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_gutscheinemail',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 110
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00111
prompt  ...PAGE 111: BETREUERVERWALTUNG
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 111
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'BETREUERVERWALTUNG'
 ,p_step_title => 'BETREUERVERWALTUNG'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'BETREUERVERWALTUNG'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150206085436'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4157416138823475 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 111,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4157818654823476 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 111,
  p_plug_name=> '&P111_PAGE_TITEL_PATIENTANZEIGE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 9,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_getlanguage()'||unistr('\000a')||
'{ '||unistr('\000a')||
'  var get = new htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=getlanguage'',0);'||unistr('\000a')||
'  get.add(''P111_APP_SPRACHE_ID'',html_GetElement(''P111_APP_SPRACHE_ID'').value);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  html_GetElement(''P111_SPRACHE_ID'').value = gReturn  }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  html_GetElement(''P111_SPRACHE_ID'').value = ''null''  }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'<div style="height: &FAS_SCROLLREGION_HEIGHT_MAX.px;max-width: 550px">'||unistr('\000a')||
'',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4158813959823484 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 111,
  p_button_sequence=> 10,
  p_button_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P111_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> 'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:111::',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4159423125823484 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 111,
  p_button_sequence=> 40,
  p_button_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P111_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P111_ID',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4160022751823485 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 111,
  p_button_sequence=> 90,
  p_button_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P111_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> ':p111_id is not null and :p111_betreuer = ''J''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4210526322941756 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request IN (''P111_BETREUER_DISP'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 22-JAN-2010 12:31 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4264201758850840 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:111:&SESSION.:PASSWORT_HINWEIS:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4267928292199106+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 05-FEB-2010 12:22 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4190926463823573 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:111:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3224917996301085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PROVISIONSSTATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 68,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PROVISIONSSTATUS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(4874,:fas_sprache_id), ''E'''||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION SELECT frgbg_s.holen_uebersetzung(1854,:fas_sprache_id), ''B'''||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION SELECT frgbg_s.holen_uebersetzung(4875,:fas_sprache_id),''M'''||unistr('\000a')||
'FROM DUAL '||unistr('\000a')||
''||unistr('\000a')||
'',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'-------------',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'frgbg_s.check_fas_rolle(:APP_USER,''PROVISIONSABRECHNUNG_ADMIN'')> 0',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4160211060823487 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_STRASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 74,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'STRASSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet*/'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 10 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4160706113823503 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 76,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte mit Postleitzahlen in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 10 Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>4161227225823503 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PLZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 78,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PLZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="f_getVal_popup(this)" ;',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 100 beliebige Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>4161714192823504 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_ORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_POPUP_LOV',
  p_lov=> '         SELECT distinct o.ort ||'' ''||o.PLZ a, o.ort b'||unistr('\000a')||
'         FROM   orte o,  laender l, gebiete  g'||unistr('\000a')||
'         WHERE  o.id_gebiet = g.id'||unistr('\000a')||
'           AND  g.id_land = l.id'||unistr('\000a')||
'           AND  (l.ID = :P111_LAND_ID OR :P111_land_id is null)'||unistr('\000a')||
'           AND  (o.plz like :p111_plz||''%'' OR :p111_plz is null)'||unistr('\000a')||
'           and  o.satz_kennzeichen is null '||unistr('\000a')||
'           and  l.satz_kennzeichen is null'||unistr('\000a')||
'           and  g.satz_kennzeichen is null'||unistr('\000a')||
'		   and (l.iso3_id not in (''CHE'',''LIE'') '||unistr('\000a')||
'	        		 or'||unistr('\000a')||
'	           (l.iso3_id in (''CHE'',''LIE'') and o.onrp is not null))'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'ENTERABLE',
  p_attribute_02 => 'FIRST_ROWSET_FILTER',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4162224381823506 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_SATZKENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satzkennzeichen',
  p_source=>'SATZKENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4162432607823506 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Language',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Datumsangabe der Form TT.MM.JJJJ z.B. 20.11.2001';

wwv_flow_api.create_page_item(
  p_id=>4162615104823506 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'DD.MM.YYYY',
  p_source=>'GEBURTSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER_CLASSIC',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Auswahl des Geschlechts.';

wwv_flow_api.create_page_item(
  p_id=>4163124762823507 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_GESCHLECHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 89,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'GESCHLECHT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Anzeigesprache';

wwv_flow_api.create_page_item(
  p_id=>4163601619823509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      -- Sprache des Patienten von der Betreuer-Sprache ableiten'||unistr('\000a')||
'      :p110_app_sprache_id := frgbg_s.get_app_sprache_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT min(s.id) into :p110_app_sprache_id'||unistr('\000a')||
'      FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'      WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'        AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'        AND s.standard = 1;     -- Defaultsprache       '||unistr('\000a')||
'      IF :p110_app_sprache_id is NULL THEN'||unistr('\000a')||
'         SELECT min(s.id) into :p110_app_sprache_id'||unistr('\000a')||
'         FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'         WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'           AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'           AND s.aktiv=1;  -- NEI 09.09.2014'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN (:p110_app_sprache_id);'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'APP_SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select s.sprache display_value, s.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs '||unistr('\000a')||
'where fs.id = :fas_pers_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  --AND s.sprache_id in (select sprache_id from uebersetzungen) -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4164101685823510 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PAGE_TITEL_PATIENTANZEIGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 554,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Title Personenstammanzeige',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4164316665823510 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PIS_PAT_AKTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 670,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pis Pat Akte Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4165107143823512 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 680,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4165311559823514 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 690,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4165905316823514 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BL_FB_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 545,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4166325780823515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PIS_ADRESSE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 671,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4166708103823515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_ANREDE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 67,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ANREDE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select  '||unistr('\000a')||
' fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',ID,:fas_sprache_id) a,'||unistr('\000a')||
' id b'||unistr('\000a')||
'from anreden_frgbg',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4166905924823515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 77,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      -- Land des Patienten vom Betreuer-Land ableiten'||unistr('\000a')||
'      :p110_land_id := frgbg_s.get_betreuer_land_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p110_land_id := 198;  -- Default Schweiz '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN (:p110_land_id);'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select substr(fas_synch.get_tab_uebersetzung(''LAND.LAND'',id,:fas_sprache_id),1,27)  a, id b'||unistr('\000a')||
'from v_laender'||unistr('\000a')||
'order by sort',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_tag_attributes  => 'onchange="f_getVal_popup(this)" ;',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4170127998823520 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BL_AUSWAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 543,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rechnungsadr',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4172521642823523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 65,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'IDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4172729753823523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 99,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 22,
  p_cMaxlength=> 2000,
  p_cHeight=> 2,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4172918744823523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_TELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 94,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1   /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4173104615823523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_MOBILTELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 96,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'MOBILTELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4175517203823529 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Änderung anwenden',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Ändern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4175718953823529 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Erstellen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4175931476823531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4176125788823531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BL_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Löschen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4176316412823531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BL_PASSWORT_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 530,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Passwort ändern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Passwort Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4176506714823531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 540,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Speichern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Speichern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4176709786823531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_SPRACHE_IDX',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 561,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprache Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4176912861823531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_FEHLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 560,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4177113938823531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_REGION_TITEL_PWD_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 551,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Pwd Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4177324241823531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_INFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 570,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4177508168823532 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PERSON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 620,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Person',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4177721915823532 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_USER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 630,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pisuser',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4177904196823532 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_REGION_TITEL_HILFETEXTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 550,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Hilfetexte',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4178125589823532 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_REGION_TITEL_INFOTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 552,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4178330337823532 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '47037',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Login Benutzer Name ist nicht veränderbar.';

wwv_flow_api.create_page_item(
  p_id=>4178520668823532 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 62,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'USER_ACCOUNT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.'||unistr('\000a')||
'Der Eintrag muss mit mindestens einem Zeichen beginnen, anschliessend ein @-Zeichen beinhalten, danach beliebig viele Zeichen. Nach dem Punkt sind bis zu 4 Zeichen erlaubt. Allgemeiner Aufbau: [zeichen]@[zeichen].[zeichen]';

wwv_flow_api.create_page_item(
  p_id=>4179013741823534 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_EMAIL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 65,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'EMAIL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für dieses Seitenelement ist keine Hilfe verfügbar.';

wwv_flow_api.create_page_item(
  p_id=>4179503927823534 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PASSWORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 66,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PASSWORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4180016530823534 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>4180511646823535 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 72,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'VORNAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4181030868823537 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_FAX',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'FAX',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4181217709823537 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 97,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'URL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4181424685823537 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Betreuer',
  p_source=>'BETREUER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4200008634009326 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PREPARE_URL_PW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 990,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prepare Url Pw',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4201004337273059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_BETREUER_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 13,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'DECLARE'||unistr('\000a')||
'   v_betreuer  number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p111_betreuer = ''J'' THEN'||unistr('\000a')||
'      v_betreuer := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      v_betreuer := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN v_betreuer;'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(1854,:fas_sprache_id) a, 1 b from DUAL'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(3548,:fas_sprache_id) b, 0 from DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '2',
  p_attribute_02 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_attribute_04 => 'VERTICAL',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4201926426374079 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PERSSTAMM_ID_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_identitaet_betr(:p111_ID);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4202202793386203 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_NAME_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 11,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.get_identitaet_name(:p111_persstamm_id_identitaet);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4206711806814617 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_ADRESSE_ZEILE2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSE_ZEILE2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4206917000816120 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_ADRESSE_ZEILE3',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSE_ZEILE3',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4207124619818250 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_ADRESSE_ZEILE4',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSE_ZEILE4',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4208021764836353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_ADRESSE_ZEILE1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSE_ZEILE1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4237629209702842 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1000,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4267928292199106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PASSWORT_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 63,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'CHANGE',
  p_prompt=>'&P111_BL_PASSWORT_CHG.',
  p_source=>'CHANGE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p111_id IS NOT NULL AND :fas_aufgerufen_von = ''BETREUER'''||unistr('\000a')||
'and frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p111_betreuer = ''J''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>10316228734543663 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_ADRESSZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 73,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSZUSATZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 40,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:p111_EXTERN_VERWALTET = 1  /* GUS verwaltet */'||unistr('\000a')||
':P111_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12356531090715968 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 111,
  p_name=>'P111_PERS_READONLY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1010,
  p_item_plug_id => 4157818654823476+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4182113250823542 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P111_LAND_ID_not_null',
  p_validation_sequence=> 1,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P111_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4166905924823515 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4182328049823543 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P111_LAND_exists',
  p_validation_sequence=> 23,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p111_land_id IS NOT NULL THEN'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM   v_laender'||unistr('\000a')||
'      --WHERE  UPPER(land) = UPPER(:p111_land);'||unistr('\000a')||
'      WHERE id = :p111_land_id;'||unistr('\000a')||
'      IF v_anz != 1 THEN'||unistr('\000a')||
'         --RETURN(''Ungültige Eingabe im Feld Land!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'               frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Land ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(211,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P111_land_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4166905924823515 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4182526677823543 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P111_PLZ_ORT_exists',
  p_validation_sequence=> 33,
  p_validation => 'DECLARE'||unistr('\000a')||
'    v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --IF UPPER(:p111_land) = ''SCHWEIZ'' THEN'||unistr('\000a')||
'   IF :p111_land_id IS NOT NULL AND :p111_ort IS NOT NULL AND'||unistr('\000a')||
'      :p111_plz IS NOT NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      IF :p111_land_id = 198 THEN'||unistr('\000a')||
'         select count(*) INTO v_anz'||unistr('\000a')||
'         from v_orte'||unistr('\000a')||
'         where upper(ort) = upper(:p111_ort)'||unistr('\000a')||
'           and plz = :p111_plz;'||unistr('\000a')||
'         IF v_anz = 0 THEN'||unistr('\000a')||
'            --RETURN(''PLZ/Ort-Kombination ist ungültig!'');'||unistr('\000a')||
'            RETURN(frgbg_s.holen_uebersetzung(179,'||unistr('\000a')||
'                        :fas_sprache_id));'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Ort bzw. PLZ ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(209,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P111_plz_ort_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4161227225823503 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4182701697823543 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p111_geburtsdatum_not_null',
  p_validation_sequence=> 43,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P111_GEBURTSDATUM IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- Geburtsdatum optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4162615104823506 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4182920382823543 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p111_geburtdatum_must_be_date',
  p_validation_sequence=> 53,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P111_GEBURTSDATUM IS NOT NULL THEN'||unistr('\000a')||
'      :P111_GEBURTSDATUM := '||unistr('\000a')||
'         to_char(to_date(:P111_GEBURTSDATUM,''DD.MM.RRRR''),''DD.MM.RRRR'');'||unistr('\000a')||
'            -- to_date(:P111_GEBURTSDATUM);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(HTMLDB_LANG.MESSAGE(''DATUM_UNGUELTIG''));'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Ungültiges Datum!',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4162615104823506 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4183123516823543 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p111_name_not_null',
  p_validation_sequence=> 93,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P111_NAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(206,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4180016530823534 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4183319005823543 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P111_VORNAME_not_null',
  p_validation_sequence=> 103,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P111_VORNAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(205,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'NEVER',
  p_associated_item=> 4180511646823535 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4183511198823543 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P111_PLZ_not_null',
  p_validation_sequence=> 133,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P111_PLZ IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(209,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4161227225823503 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4183715795823543 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P111_ORT_not_null',
  p_validation_sequence=> 143,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P111_ORT IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(210,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4161714192823504 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4183919272823545 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P111_EMAIL_not_null',
  p_validation_sequence=> 153,
  p_validation => 'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF :P111_EMAIL IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(203,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4179013741823534 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4184110340823545 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P111_EMAIL_check',
  p_validation_sequence=> 160,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p111_email IS NOT NULL THEN '||unistr('\000a')||
'      IF instr(:p111_email,''@'') <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(224,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'      v_string :=  '||unistr('\000a')||
'         substr(:p111_email,instr(:p111_email,''@'')+1,length(:p111_email));'||unistr('\000a')||
'      v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'      IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'         --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(225,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'      -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'      IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(226,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,     '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(203,:fas_sprache_id)),'||unistr('\000a')||
'            ''Validierung p111_email_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4179013741823534 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4211508790996476 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P111_USER_ACCOUNT',
  p_validation_sequence=> 210,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'   v_anz   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p111_user_account IS NULL THEN'||unistr('\000a')||
'      -- User-Account autom. generieren'||unistr('\000a')||
'      :p111_user_account := frgbg_s.GEN_USER_ACCOUNT'||unistr('\000a')||
'                    (:p111_name,:p111_vorname,'||unistr('\000a')||
'                     to_date(:p111_geburtsdatum,''DD.MM.YYYY''));'||unistr('\000a')||
'      IF :p111_user_account IS NULL THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(1814,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT count(*) INTO v_anz'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE UPPER(user_account)= UPPER(:p111_user_account)'||unistr('\000a')||
'        AND id != :P111_ID;'||unistr('\000a')||
'      IF v_anz > 0 THEN'||unistr('\000a')||
'         --RETURN (''Der Benutzer ist bereits vergeben!'');'||unistr('\000a')||
'         RETURN (frgbg_s.holen_uebersetzung(448,'||unistr('\000a')||
'                      :fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'mel.p(''Exception bei Validierung P111_user_account_eingabe Name %1, Vorname %2, GEbdat %3, ACcount %4, Sprache %5, Fehler: %6'', v_PROT_ID, ''ERROR'', ''page111/val_user_account'',:p111_name,:p111_vorname,:p111_geburtsdatum,:p111_user_account,:fas_sprache_id,SQLERRM);   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(202,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P111_user_account''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'',''CHANGE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4178520668823532 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p111_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p111_bl_loeschen  := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p111_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :p111_bl_aendern   := frgbg_s.holen_uebersetzung(162,v_sprache_id);'||unistr('\000a')||
'   :p111_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_s';

p:=p||'prache_id);'||unistr('\000a')||
'   :p111_bl_passwort_chg := frgbg_s.holen_uebersetzung(171,v_sprache_id);'||unistr('\000a')||
'   :P111_BL_auswaehlen := frgbg_s.holen_uebersetzung(1597,v_sprache_id); '||unistr('\000a')||
''||unistr('\000a')||
'   :p111_region_titel_pwd_chg := frgbg_s.holen_uebersetzung(170,v_sprache_id);'||unistr('\000a')||
'   :p111_region_titel_hilfetexte := frgbg_s.holen_uebersetzung(220,v_sprache_id);'||unistr('\000a')||
'   :p111_region_titel_infotext := frgbg_s.holen_uebersetzung(247,v_sprache_id)';

p:=p||';'||unistr('\000a')||
'   :p111_page_titel_patientanzeige := frgbg_s.holen_uebersetzung(1592,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p111_info := frgbg_s.holen_uebersetzung(173,v_sprache_id);'||unistr('\000a')||
'   :p111_fehler := frgbg_s.holen_uebersetzung(487,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4188230963823564 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p111_passwort := frgbg_s.gen_passwort;';

wwv_flow_api.create_page_process(
  p_id     => 4263702665841615 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'passwort_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4267928292199106 + wwv_flow_api.g_id_offset,
  p_process_when=>':request = ''CHANGE''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''Betreuer %1,%2'',v_prot_id,''INFO'',''betreuer_setzen P111'',:p111_betreuer_disp,:p111_betreuer);'||unistr('\000a')||
'   IF :p111_betreuer_disp = 0 AND :p111_betreuer = ''J'' THEN'||unistr('\000a')||
'      -- Zugriffstruktur für Betreuer entfernen'||unistr('\000a')||
'      DELETE pers_zugriffstrukt '||unistr('\000a')||
'      WHERE persstamm_id = :p111_id; '||unistr('\000a')||
''||unistr('\000a')||
'      UPDATE personenstamm'||unistr('\000a')||
'      set betreuer = ''N'''||unistr('\000a')||
'      WHERE id = :p111_id;'||unistr('\000a')||
''||unistr('\000a')||
' ';

p:=p||'     -- Betreuerzugriffe wieder löschen wird später per Trigger durchgeführt'||unistr('\000a')||
'      /*DELETE from pers_zugriffe'||unistr('\000a')||
'      WHERE persstamm_id_betreuer =  :p111_id;'||unistr('\000a')||
'      */'||unistr('\000a')||
'--mel.p(''Betreuer %1,%2'',v_prot_id,''INFO'',''betreuer_setzen P 111'',:p111_betreuer_disp,:p111_betreuer);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4209618825873415 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 21,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'betreuer_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''P111_BETREUER_DISP''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p111_mutuser := :APP_USER;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4187005182823562 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 22,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mutuser_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE CHANGE ',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''Request %1'',v_prot_id,''INFO'',''set_land_id_null P111'',:request);'||unistr('\000a')||
'   IF :p111_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      :p111_land_id := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4187428702823564 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 32,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_land_id_null',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:PERSONENSTAMM:P111_ID:ID|IU';

wwv_flow_api.create_page_process(
  p_id     => 4188626614823564 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 41,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'personenstamm_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SAVE'',''CHANGE'') ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:PERSONENSTAMM:P111_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 4187812678823564 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 62,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'personenstamm_holen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''Passwort:''||:p111_passwort,v_prot_id,''passwort_ausgeben'',''hinweis'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''alert("''||frgbg_s.holen_uebersetzung(3580,:fas_sprache_id,'||unistr('\000a')||
'                                               :p111_USER_ACCOUNT,:p111_passwort)||''");'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4264303274860742 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 63,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'passwort_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':REQUEST in (''PASSWORT_HINWEIS'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p111_prepare_url_pw:= apex_util.prepare_url('||unistr('\000a')||
'   ''f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_ID:''||:P111_ID);';

wwv_flow_api.create_page_process(
  p_id     => 4199726857005154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 72,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_prepare_url_pw',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   /* z.B. GUS-Adr. darf nicht im FAS verändert werden */'||unistr('\000a')||
'   :p111_pers_readonly:=frgbg_T.check_pers_extern_verwaltet(:p111_EXTERN_VERWALTET ) ; '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 12356916976724950 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 111,
  p_process_sequence=> 82,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_adr_readonly',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 111
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00112
prompt  ...PAGE 112: PERSONENSTAMM_ENDKUNDE_FB
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 112
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'PERSONENSTAMM_ENDKUNDE_FB'
 ,p_step_title => 'PERSONENSTAMM_ENDKUNDE_FB'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130920174113'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3598008385702408 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 112,
  p_plug_name=> 'personenstamm',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 3605213443193031 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 112,
  p_button_sequence=> 10,
  p_button_plug_id => 3598008385702408+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Submit',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3597332177576882 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 112,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:1:P1_PERSON,P1_FRAGEBOGEN_ID,P1_FB_VERSION,P1_PERGEBNIS_ID,P1_BEARB_MODUS:&P112_PERSONENSTAMM_ID.,&P112_FRAGEBOGEN_ID.,&P112_FB_VERSION.,&P112_PERGEBNIS_ID.,&P112_BEARB_MODUS.',
  p_branch_point=> 'BEFORE_HEADER',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 30-SEP-2011 10:54 by BRIGITTE.NEIDHART');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3598317043704929 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 112,
  p_name=>'P112_PERSONENSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 3598008385702408+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Personenstamm_id',
  p_source=>'FAS_LOGIN_PERSONENSTAMM_ID',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3598522930706586 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 112,
  p_name=>'P112_FRAGEBOGEN_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 3598008385702408+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'FB',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3598702283710136 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 112,
  p_name=>'P112_FB_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 3598008385702408+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'FB-Version',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3598908862711999 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 112,
  p_name=>'P112_PERGEBNIS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 3598008385702408+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Perg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3599117174714481 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 112,
  p_name=>'P112_BEARB_MODUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 3598008385702408+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Modus',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_identitaet_persstamm_id   personenstamm.id%TYPE;'||unistr('\000a')||
'   v_persstamm_id              personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fas_pers_schema_id        fas_schemas.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                varchar2(2000);'||unistr('\000a')||
'   v_prot_id                   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*MEL.P (''Bst. FAS-login %1; aufgerufen %2'', v_PROT_ID, ''TEST'', ''102/112 aktive_identitaet_pers_schema_sortiment_setzen'',:FAS_LOGIN_PERSONEN';

p:=p||'STAMM_ID,:fas_aufgerufen_von);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- Diese Routine best. die aktive Identität, Kunden-Schema, Sortiment eines ausgewählten Kunden'||unistr('\000a')||
'   -- Persstamm_id kommt 5x vor'||unistr('\000a')||
'   v_persstamm_id := :FAS_LOGIN_PERSONENSTAMM_ID;'||unistr('\000a')||
'   IF v_persstamm_id IS NULL THEN -- Patient muss vorhanden sein'||unistr('\000a')||
'       v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,v_fehlert';

p:=p||'ext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Bestimmen der aktiven Identität'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN   -- Aktive Identität ist immer bevorzugt betreuende Identität des Kunden bzw. falls nicht vorhanden betreuende Identität des Kunden '||unistr('\000a')||
'         /*'||unistr('\000a')||
'         v_identitaet_persstamm_id:=  '||unistr('\000a')||
'                     frgbg_s.get_identitaet_kunde(:fas_login_personenstamm_id,'||unistr('\000a')||
'                                    ';

p:=p||'        -1,'||unistr('\000a')||
'                                            v_persstamm_id);      '||unistr('\000a')||
'         */'||unistr('\000a')||
'         /* NEI 20.09.13: => Zukünftig wird nur noch die bevorzugt betreuende Person des Kunden zur'||unistr('\000a')||
'                               aktive Identität egal ob der Betreuer Zugriff auf die Identität hat.'||unistr('\000a')||
'                               Er sieht den Kunden, vielleicht auch nur, weil er speziell Zugriff auf den Kun';

p:=p||'den hat, '||unistr('\000a')||
'                               da der Kunde von einer Idenität (Apo Richter) noch zusätzlich betreut wird, '||unistr('\000a')||
'                               auf die der Betreuer auch Zugriff hat. D.h. der Betreuer hat nicht direkten Zugriff'||unistr('\000a')||
'                               auf die bevorzugt betreuende Identität und daher auf alle Kunden von dieser Identität, '||unistr('\000a')||
'                               sondern nur ein s';

p:=p||'pezieller Kunde dieser bevorzugt betreuende Identität ist für den Betreuer bzw.'||unistr('\000a')||
'                               seiner zugreifbaren Identitäten freigeschaltet.'||unistr('\000a')||
'         */'||unistr('\000a')||
'         v_identitaet_persstamm_id:=  '||unistr('\000a')||
'              frgbg_s.get_identitaet_kunde( NULL,'||unistr('\000a')||
'                                            -1,'||unistr('\000a')||
'                                            v_persstamm_id);'||unistr('\000a')||
'         IF v_identitaet_persst';

p:=p||'amm_id <= 0 OR '||unistr('\000a')||
'             v_identitaet_persstamm_id is NULL'||unistr('\000a')||
'         THEN '||unistr('\000a')||
'            :fas_identitaet := '''';'||unistr('\000a')||
'            :fas_identitaet_persstamm_id := NULL;'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(3098,:fas_sprache_id);'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'            :f';

p:=p||'as_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,'||unistr('\000a')||
'                                                          :FAS_SCHEMA_ID);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''ANONYM'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Betreuende Identitaet für Endkunden holen'||unistr('\000a')||
'       SELECT parameter'||unistr('\000a')||
'       INTO v_identitaet_persstamm_id'||unistr('\000a')||
'       FROM sysareas_frgbg'||unistr('\000a')||
'      ';

p:=p||' WHERE id = 6;'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''KUNDE'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Holen der Identitaet aus Pers_betreuer mit standard = J'||unistr('\000a')||
'       v_identitaet_persstamm_id := frgbg_s.GET_IDENTITAET_KUNDE(NUL';

p:=p||'L,-1,v_persstamm_id);'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Schema-Id des Kunden setzen, abgeleitet aus der bevorzugt betreuenden Identitaet => wird beim Druck für die Auswahllistten von Kundensprache verwendet'||unistr('\000a')||
'   -- Schema der bevorzugt betreuenden Identit';

p:=p||'aet bestimmen '||unistr('\000a')||
'   v_fas_pers_schema_id := frgbg_s.get_fas_schema('||unistr('\000a')||
'         frgbg_s.get_identitaet_kunde(NULL,-1,v_persstamm_id),'||unistr('\000a')||
'          ''IDENTITAET'');'||unistr('\000a')||
'   IF v_fas_pers_schema_id <= 0 OR '||unistr('\000a')||
'      v_fas_pers_schema_id is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :fas_pers_schema_id := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3505,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   ELSE';

p:=p||''||unistr('\000a')||
'      :fas_pers_schema_id := v_fas_pers_schema_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Sortiment-ID der aktiven Identitaet '||unistr('\000a')||
'   -- NEI 14.02.2011 Sortimentseinfuehrung: sortiment_id statt preislisten_set_id      '||unistr('\000a')||
'   :FAS_SORTIMENT_ID:= rezepte.get_sortiment(:FAS_IDENTITAET_PERSSTAMM_ID,''IDENTITAET'');'||unistr('\000a')||
'   IF :FAS_SORTIMENT_ID <= 0 OR '||unistr('\000a')||
'      :FAS_SORTIMENT_ID is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :FAS_SORTIMENT_ID := '''';'||unistr('\000a')||
'      v_feh';

p:=p||'lertext := frgbg_s.holen_uebersetzung(3518,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20004,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'/*MEL.P (''Bst. genereller Parameter Wahlident %1; Login-id %2; aktive Ident %3; Schema-kunde:%4, akt.Schema:%5,Sortiment:%6,Person:%7'', v_PROT_ID, ''TEST'', ''102/112 aktive_identitaet_pers_schema_sortiment_setzen'',:p110_wahl_identitaet,:fas_login_personenstamm_id,'||unistr('\000a')||
'v_identitae';

p:=p||'t_persstamm_id,:fas_pers_schema_id,:fas_schema_id,:FAS_SORTIMENT_ID,v_persstamm_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3596821311564200 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 112,
  p_process_sequence=> 130,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'aktive_identitaet_pers_schema_sortiment_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_fehlertext       varchar2(2000);'||unistr('\000a')||
'   v_prot_id          number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Person setzen => LOGIN ist der Endkunde'||unistr('\000a')||
'   :p112_personenstamm_id  := :FAS_LOGIN_PERSONENSTAMM_ID;'||unistr('\000a')||
'   -- Fragebogen ermitteln'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      select id into :p112_fragebogen_id'||unistr('\000a')||
'      from fragebogen'||unistr('\000a')||
'      where fb_typ_id = 1 -- Mikronährstoff-FB'||unistr('\000a')||
'        and aktiv=''J'';'||unistr('\000a')||
''||unistr('\000a')||
'      SELECT '||unistr('\000a')||
'          PERSONENSTAMM_ID,'||unistr('\000a')||
' ';

p:=p||'         FRAGEBOGEN_ID, '||unistr('\000a')||
'          frgbg_s.fb_get_vers(fragebogen_id),         -- FB Version'||unistr('\000a')||
'          PERGEBNIS_ID, '||unistr('\000a')||
'          CASE WHEN frgbg_s.FB_CHECK_AUSWERTUNG(pergebnis_id)=0  -- Auswertung vorhanden? nein'||unistr('\000a')||
'               AND ((:fas_aufgerufen_von = ''KUNDE'' AND -- Gutschein-Verfahren der Identität aktiv'||unistr('\000a')||
'                     frgbg_s.check_fas_rolle(:APP_USER,''FB_GUTSCHEINVERFAHREN'') > 0'||unistr('\000a')||
'     ';

p:=p||'                )'||unistr('\000a')||
'                    OR'||unistr('\000a')||
'                     :fas_aufgerufen_von = ''ANONYM'''||unistr('\000a')||
'                    )'||unistr('\000a')||
'          THEN ''BEARBEITEN'''||unistr('\000a')||
'          ELSE ''ANZEIGEN'''||unistr('\000a')||
'          END '||unistr('\000a')||
'      INTO :p112_personenstamm_id,'||unistr('\000a')||
'           :p112_fragebogen_id,'||unistr('\000a')||
'           :p112_fb_version,'||unistr('\000a')||
'           :p112_pergebnis_id,'||unistr('\000a')||
'           :p112_bearb_modus'||unistr('\000a')||
'      FROM v_fb_fas'||unistr('\000a')||
'      WHERE personenstamm_id = :p112_per';

p:=p||'sonenstamm_id'||unistr('\000a')||
'        AND perg_akt_version = 1'||unistr('\000a')||
'        and fb_typ_id = 4;'||unistr('\000a')||
''||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      v_fehlertext := ''Der aktuelle Fragebogen (Mikronährstoff) konnte nicht ermittelt werden''||SQLERRM;'||unistr('\000a')||
'      :p112_fragebogen_id := NULL;'||unistr('\000a')||
'   END;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3597629678670688 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 112,
  p_process_sequence=> 140,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fragebogen_bestimmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_aenderbar     personenstamm.aenderbar%TYPE;'||unistr('\000a')||
'   v_user_account  personenstamm.user_account%TYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT aenderbar, user_account into v_aenderbar, v_user_account'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :p112_personenstamm_id;'||unistr('\000a')||
'   IF   (v_aenderbar = ''J'') '||unistr('\000a')||
'     OR (v_aenderbar = ''N'' AND'||unistr('\000a')||
'         -- speziell berechtigt'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''GESCHUETZTE_PERSONENDA';

p:=p||'TEN_AENDERN'') > 0 '||unistr('\000a')||
'         )'||unistr('\000a')||
'      OR (v_aenderbar = ''N'' AND                 -- User hat sich selbst eingeloggt'||unistr('\000a')||
'          :fas_aufgerufen_von != ''BETREUER'' and'||unistr('\000a')||
'          UPPER(v_USER_ACCOUNT)= UPPER(:APP_USER)'||unistr('\000a')||
'         )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :fas_pers_aenderbar := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_aenderbar := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3609013094360994 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 112,
  p_process_sequence=> 150,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_fas_pers_aenderbar',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 112
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00120
prompt  ...PAGE 120: Anmelden-via-pis
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 120
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Anmelden-via-pis'
 ,p_step_title => 'Anmelden über PIS'
 ,p_step_sub_title => 'Anmelden-Neu'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2882731585489434 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'Y'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130116105448'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5689417169533425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 120,
  p_plug_name=> 'Anmelden',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 0,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5691302599533451 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:120:&SESSION.::&DEBUG.::P120_USERNAME,P120_PASSWORD:NULL,NULL',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5097008274766979 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_name=>'P120_AUFGERUFEN_VON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 5689417169533425+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'PIS',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Aufgerufen Von',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5107021183809645 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_name=>'P120_FB_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 61,
  p_item_plug_id => 5689417169533425+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Fragebogen Version',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5689605873533437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_name=>'P120_USERNAME',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5689417169533425+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Benutzername',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5689812165533439 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_name=>'P120_PASSWORD',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5689417169533425+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kennwort',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_PASSWORD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5690011936533439 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_name=>'P120_LOGIN',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5689417169533425+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> '',
  p_item_default=> 'Anmelden',
  p_prompt=>'Anmelden',
  p_source=>'LOGIN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5738510987193709 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_name=>'P120_PERSON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 5689417169533425+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Für Person',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5770815552869540 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_name=>'P120_FB_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5689417169533425+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Fragebogen Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5773203740913375 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_name=>'P120_PERG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5689417169533425+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pergebnis Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5813701386543920 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 120,
  p_name=>'P120_PISUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 5689417169533425+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'PIS User',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':fas_aufgerufen_von := ''PIS'';'||unistr('\000a')||
':fas_login_page := 101;  -- Eigentlich wird die nicht gebraucht, da kein Abmelden in Navi-Bar '||unistr('\000a')||
':fas_sprache_id:= frgbg_s.get_sprache_id(UPPER(:P120_USERNAME));'||unistr('\000a')||
'/* NEI 20.04.09 in Anwendungsprozedur'||unistr('\000a')||
':fas_abmelden_text := '''';'||unistr('\000a')||
':fas_keine_daten_text := frgbg_s.holen_uebersetzung(759,:fas_sprache_id);'||unistr('\000a')||
':FAS_AENDERUNGWARNUNG_TEXT := frgbg_s.holen_uebersetzung(3068,:fas_sprac';

p:=p||'he_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'wwv_flow_custom_auth_std.login('||unistr('\000a')||
'       P_UNAME       => upper(v(''P120_USERNAME'')),'||unistr('\000a')||
'       P_PASSWORD    => upper(v(''P120_PASSWORD'')),'||unistr('\000a')||
'       P_SESSION_ID  => v(''APP_SESSION''),'||unistr('\000a')||
'       P_FLOW_PAGE   => :APP_ID||'':1:''||:SESSION||'||unistr('\000a')||
'                                 ''::NO::P1_PERSON,P1_FRAGEBOGEN_ID,P1_PERGEBNIS_ID,P1_USER:''||'||unistr('\000a')||
'                                :P120_PERSON||'',''||:P120_FB_ID||'',''';

p:=p||'||'||unistr('\000a')||
'                                :P120_PERG_ID||'',''||:P120_PISUSER'||unistr('\000a')||
'      );';

wwv_flow_api.create_page_process(
  p_id     => 5690617619533445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 120,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Login',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'120';

wwv_flow_api.create_page_process(
  p_id     => 5690815052533446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 120,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'Seiten-Cache-Inhalt löschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 2178531031737395 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 120,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':fas_abmelden_text := '''';';

wwv_flow_api.create_page_process(
  p_id     => 2178712461741514 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 120,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'abmelde_text_clearen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   SELECT id INTO :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE user_account = UPPER (:P120_USERNAME);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN '||unistr('\000a')||
'    NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3747124797203207 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 120,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'FAS_LOGIN_PERSONENSTAMM_ID_SETZEN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz      NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN   '||unistr('\000a')||
'/*MEL.P (''Hallo1 Schema setzen:%1, pers %2, url %3'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Prozessüberwachung hallo'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id, owa_util.get_cgi_env(''server_name'')'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      -- FAS-Schema über Servername ermitteln'||unistr('\000a')||
'      :fas_schema_id := frgbg_s.get_fa';

p:=p||'s_schema_srv;'||unistr('\000a')||
'   ELSE -- Check gültiges Schemaangabe?'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT count(*) INTO v_anz'||unistr('\000a')||
'         FROM fas_schemas'||unistr('\000a')||
'         WHERE id = :fas_schema_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'          v_anz := 0;'||unistr('\000a')||
'      END ;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz = 0 THEN -- FAlls ungültig über Servername ermitteln'||unistr('\000a')||
'         :fas_schema_id := frgbg_s.get_fas_schema_srv;           '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'  ';

p:=p||':FAS_THEME_NAME:= ''fas_theme_''||:fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Holen der Persstamm_id für das FAS-Schema'||unistr('\000a')||
'   --:fas_schema_persstamm_id := frgbg_s.get_pers_fas_schema(:fas_schema_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Fas-Modus setzen abhängig vom Schema'||unistr('\000a')||
'   SELECT fas_modus_id into :fas_modus_id'||unistr('\000a')||
'   FROM fas_schemas'||unistr('\000a')||
'   WHERE id = :fas_schema_id;'||unistr('\000a')||
'/*MEL.P (''Hallo ende Schema setzen:%1, pers %2,%3'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Prozes';

p:=p||'süberwachung'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2942700475616045 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 120,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_fas_schema_fas_modus',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_aufruf   VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id  number;'||unistr('\000a')||
'begin '||unistr('\000a')||
'IF :P120_USERNAME is not null AND :P120_PASSWORD is not null THEN'||unistr('\000a')||
'   :fas_login_page := 101;  -- Eigentlich wird die nicht gebraucht, da kein Abmelden in Navi-Bar '||unistr('\000a')||
'   :fas_aufgerufen_von := ''PIS'';'||unistr('\000a')||
'   :fas_abmelden_text := '''';'||unistr('\000a')||
'   :fas_sprache_id:= frgbg_s.get_sprache_id(UPPER(:P120_USERNAME));'||unistr('\000a')||
''||unistr('\000a')||
'   -- URL aufbauen'||unistr('\000a')||
'   v_aufruf := ''f?p';

p:=p||'=''||:APP_ID||'':1:''||:APP_SESSION||'||unistr('\000a')||
'      ''::NO::P1_PERSON,P1_FRAGEBOGEN_ID,P1_FB_VERSION,P1_PERGEBNIS_ID,P1_USER:''||'||unistr('\000a')||
'      :P120_PERSON||'',''||:P120_FB_ID||'',''||:P120_FB_VERSION||'',''||:P120_PERG_ID||'',''||:P120_PISUSER;'||unistr('\000a')||
'   -- URL mit checksum versehen'||unistr('\000a')||
'   v_aufruf := APEX_UTIL.PREPARE_URL(v_aufruf);'||unistr('\000a')||
'--mel.p(''Test: Browseraufruf! %1 '', v_prot_id,''FEHLER'',''Page120'',v_aufruf);'||unistr('\000a')||
'   -- URL setzen, damit di';

p:=p||'eser nach LOGIN aufgerufen wird'||unistr('\000a')||
'   :FSP_AFTER_LOGIN_URL:= v_aufruf;'||unistr('\000a')||
'   -- Login es wird dann nach dem Login mit der URL in FSP_AFTER_LOGIN_URL weitergemacht'||unistr('\000a')||
'   wwv_flow_custom_auth_std.login('||unistr('\000a')||
'       P_UNAME       => upper(v(''P120_USERNAME'')),'||unistr('\000a')||
'       P_PASSWORD    => upper(v(''P120_PASSWORD'')),'||unistr('\000a')||
'       P_SESSION_ID  => v(''APP_SESSION''),'||unistr('\000a')||
'       P_FLOW_PAGE   => --:APP_ID||'':1:||:SESSION||''::NO::P1_PER';

p:=p||'SON,P1_FRAGEBOGEN_ID,P1_PERGEBNIS_ID,P1_USER,P1_AUFGERUFEN_VON:''||P120_PERSON||'',''||:P120_FB_ID||'',''||:P120_PERG_ID||'','':P120_PISUSER||'',''||:P120_AUFGERUFEN_VON);'||unistr('\000a')||
'--:APP_ID||'':1:''||:SESSION||''::NO::P1_PERSON,P1_FRAGEBOGEN_ID,P1_PERGEBNIS_ID,P1_USER:''||:P120_PERSON||'',''||:P120_FB_ID||'',''||:P120_PERG_ID||'',''||:P120_PISUSER);'||unistr('\000a')||
'       :APP_ID||'':120'');'||unistr('\000a')||
'END IF; '||unistr('\000a')||
'null;'||unistr('\000a')||
'exception'||unistr('\000a')||
'when others then'||unistr('\000a')||
'   null;';

p:=p||''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5692922378544129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 120,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'anmeldung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 120
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00121
prompt  ...PAGE 121: Anmelden Betreuer
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 121
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Anmelden Betreuer'
 ,p_step_title => 'Anmelden Betreuer'
 ,p_step_sub_title => 'Anmelden Betreuer'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2882731585489434 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'Y'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20141024183800'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2251230990273813 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 121,
  p_plug_name=> '<img src="#OWNER#.UEBERSETZUNG.DISPLAY_BILD?p_bild_id=10385&p_sprache_id=357" height="29" width="113" />',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2887726313489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 30,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4461316720468240 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 121,
  p_plug_name=> '&P121_PAGE_TITEL_ANMELDUNG.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_footer=> '<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5836228678294028 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 121,
  p_plug_name=> '&P121_PAGE_TITEL_HINWEIS.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890721784489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => 'frgbg_s.holen_uebersetzung(10,:p121_sprache_id) !=''.''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>1712023336417872 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:106:&SESSION.::&DEBUG.:106:P106_USER_ACCOUNT,P106_SPRACHE_ID,P106_ZURUECK_SEITE:&P121_USERNAME.,&P121_SPRACHE_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 5,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p121_hinweis_pw is null and :request = ''PASSWORT''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 29-MAR-2011 12:56 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>1728919764992091 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:121:&SESSION.:PW_HINWEIS:&DEBUG.:121:P121_HINWEIS_PW:&P121_HINWEIS_PW.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'NEVER',
  p_branch_condition=> ':p121_hinweis_pw is not null and :request = ''PASSWORT''',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-MAR-2011 09:56 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4466222123468279 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:121:&SESSION.::&DEBUG.:121::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 28-AUG-2007 11:09 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1281423088964654 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_BL_PASSWORT_VERGESSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2253229155454985 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_BROWSERINFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 191,
  p_item_plug_id => 2251230990273813+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(10384,:p121_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 4000,
  p_cHeight=> 5,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'I',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3416830196187630 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_WARTUNG_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 181,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wartung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4461904740468260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_PAGE_TITEL_ANMELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4462127222468260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4462300613468260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_BL_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4463522828468262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_USERNAME',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_BETREUER"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4463724697468262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_PASSWORD',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_BETREUER"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_PASSWORD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_encrypt_session_state_yn=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4463916125468262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_LOGIN',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> '',
  p_item_default=> 'LOGIN',
  p_prompt=>'&P121_BL_LOGIN.',
  p_source=>'LOGIN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> true,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'S',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4464304506468264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_BETREUER"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT s.sprache, s.id'||unistr('\000a')||
'FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'order by 1'||unistr('\000a')||
''||unistr('\000a')||
'/*SELECT sprache, '||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, pers_optionen po , optionstypen ot    /* Subsetzugriff * /'||unistr('\000a')||
'where po.opttyp_id = ot.id  /* JOIN OT * /'||unistr('\000a')||
'  and ot.art = 1        /* Subset * /'||unistr('\000a')||
'  and po.opttyp_id = 23  /* Sprachen * /'||unistr('\000a')||
'  and ow.id = po.wert'||unistr('\000a')||
'  /* Persid des Subsets sonst null * /'||unistr('\000a')||
'  and po.persstamm_id = :p121_pers_opt_persstamm_id '||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Appsprachen (statt Optionswerte), da keine Subsetdef. od. da Def.wertverwaltg* /'||unistr('\000a')||
'SELECT sprache,'||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, optionstypen ot'||unistr('\000a')||
'where ot.id = 23 /* Sprachen* /'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden* /'||unistr('\000a')||
'       :p121_pers_opt_persstamm_id  IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset * /'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1  '||unistr('\000a')||
'*/',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4767016695547401 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_APP_SPRACHE_ID_PARAM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'App Sprache Id Param',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5836911971308110 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 171,
  p_item_plug_id => 5836228678294028+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(10,:p121_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 70,
  p_cMaxlength=> 2000,
  p_cHeight=> 5,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5866000533510440 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_PAGE_TITEL_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 141,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Hinweis',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6414304913483734 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_PASSWORT_VERGESSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 31,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'PASSWORT',
  p_prompt=>'&P121_BL_PASSWORT_VERGESSEN.',
  p_source=>'PASSWORT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6417113100122500 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 121,
  p_name=>'P121_HINWEIS_PW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4461316720468240+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3414910523311395 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_wartung',
  p_validation_sequence=> 5,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_text   varchar2(4000);'||unistr('\000a')||
'   v_liste  varchar2(4000);'||unistr('\000a')||
'   v_flag   NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p121_wartung_flag := 0;'||unistr('\000a')||
'   SELECT to_number(parameter) INTO v_flag'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 10;'||unistr('\000a')||
'   SELECT parameter INTO v_liste'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 11;'||unistr('\000a')||
'--mel.p(''Wartungsflag:%1, Text %2'',v_prot_id,''INFO'',''FAS102/121: check_wartung'',v_flag,:P121_HINWEIS);'||unistr('\000a')||
'   IF v_flag = 1 and  -- Generelles Wartungsflag'||unistr('\000a')||
'      -- Check USER, die während der Wartung arbeiten dürfen '||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:p121_username)||'';'') = 0 and  '||unistr('\000a')||
'      -- Check Applikation, die gewartet werden'||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:APP_ID)||'';'') = 0    '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p121_wartung_flag := 1;'||unistr('\000a')||
'      v_text := frgbg_s.holen_uebersetzung(10,:p121_sprache_id);'||unistr('\000a')||
'      IF v_text is null or v_text = ''.'' THEN'||unistr('\000a')||
'         v_text := ''System is not available because of system maintaince! Please try again later.'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      RETURN v_text;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p121_wartung_flag := 0;'||unistr('\000a')||
'      RETURN null;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4586308741265575 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_gueltiges_login',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz_login        personenstamm.login_fehlversuche%TYPE;'||unistr('\000a')||
'   v_anz_max_login    personenstamm.login_fehlversuche%TYPE;'||unistr('\000a')||
'   v_personenstamm_id personenstamm.id%TYPE;'||unistr('\000a')||
'   v_betreuer         personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_fas_schema_id_pers  pers_identitaet_props.fas_schema_id%TYPE;'||unistr('\000a')||
'   v_prot_id          number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   -- Sperren des Betreuer-Logins nach n Fehlversuchen'||unistr('\000a')||
'   :p121_username:=TRIM(UPPER (:p121_username));'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT NVL(min(parameter),5) INTO v_anz_max_login'||unistr('\000a')||
'      FROM sysareas_frgbg'||unistr('\000a')||
'      WHERE id = 3;'||unistr('\000a')||
'      SELECT login_fehlversuche,id,betreuer'||unistr('\000a')||
'      INTO v_anz_login, v_personenstamm_id, v_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE user_account = TRIM(UPPER (:p121_username));'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN '||unistr('\000a')||
'       NULL;'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   IF v_anz_login >= 9999.001 THEN'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(3830,:p121_sprache_id));'||unistr('\000a')||
'   ELSIF v_anz_login >= v_anz_max_login THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(477,:p121_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Schema-Prüfung'||unistr('\000a')||
'   IF v_betreuer = ''J'' THEN'||unistr('\000a')||
'      v_fas_schema_id_pers :='||unistr('\000a')||
'         frgbg_s.get_fas_schema_liste(v_personenstamm_id,''BETREUER'');'||unistr('\000a')||
'   ELSIF v_betreuer = ''I'' THEN'||unistr('\000a')||
'      v_fas_schema_id_pers := '||unistr('\000a')||
'         frgbg_s.get_fas_schema_liste(v_personenstamm_id,''IDENTITAET'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'MEL.P (''LOGIN-Protokoll: Pers:%1, Schema:%2|%3, aufgerufen:%4, Fas_modus:%5, User:%6, PW:%7,Client-Host:%8,App-Sprache:%9'', v_PROT_ID, ''Info'',''check gültiges Login'',v_personenstamm_id, v_fas_schema_id_pers,:fas_schema_id,:fas_aufgerufen_von,:fas_modus_id,:p121_username,:p121_password,owa_util.get_cgi_env(''REMOTE_ADDR''),:p121_app_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   IF instr(v_fas_schema_id_pers,'';''||:fas_schema_id||'';'')>0 THEN'||unistr('\000a')||
'      NULL; -- alles ok'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p121_sprache_id));   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   IF frgbg_s.VALID_USER (:p121_username,:p121_password) AND '||unistr('\000a')||
'      v_betreuer in (''J'',''I'')'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET app_sprache_id = :p121_app_sprache_id,'||unistr('\000a')||
'             login_fehlversuche = 0'||unistr('\000a')||
'         WHERE id = v_personenstamm_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN OTHERS THEN'||unistr('\000a')||
'          NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET login_fehlversuche = login_fehlversuche +1'||unistr('\000a')||
'         WHERE id = v_personenstamm_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN OTHERS THEN '||unistr('\000a')||
'          NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p121_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request not in  (''PASSWORT'') and       '||unistr('\000a')||
':p121_wartung_flag = 0',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6420705386011929 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_neues_pw',
  p_validation_sequence=> 20,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_PERSSTAMM_ID_MAILABSENDER personenstamm.id%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID personenstamm.id%TYPE;'||unistr('\000a')||
'   v_betreuer     personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_email     personenstamm.email%TYPE;'||unistr('\000a')||
'   v_anz_login number;'||unistr('\000a')||
'   v_return    NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p121_hinweis_pw:= NULL;'||unistr('\000a')||
'   IF :p121_username IS NULL THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(447,:p121_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT login_fehlversuche,id, email, betreuer'||unistr('\000a')||
'      INTO v_anz_login, v_persstamm_id,v_email, v_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE user_account = UPPER (:p121_username);'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      -- Fehler Benutzer ist unbekannt!'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(446,:p121_sprache_id);'||unistr('\000a')||
'      RETURN (v_fehlertext);'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   IF v_betreuer not in (''J'',''I'')'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(444,:p121_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF v_email is null'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3935,:p121_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF v_anz_login != round(v_anz_login) '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3937,:p121_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   Return v_fehlertext;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 6414304913483734 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4463522828468262 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'owa_util.mime_header(''text/html'', FALSE);'||unistr('\000a')||
'owa_cookie.send('||unistr('\000a')||
'    name=>''FAS_LOGIN_USERNAME_COOKIE'','||unistr('\000a')||
'    --value=>lower(:P121_USERNAME));  -- NEI 09.01.2013 Umlaute-Problem'||unistr('\000a')||
'    -- SL 04.11.2014 UTF-8 Anpassung da im UTL_HTTP standardmäßig ASCII verwendet wird.'||unistr('\000a')||
'    value=>utl_url.escape(lower(:P121_USERNAME), true,''AL32UTF8''));'||unistr('\000a')||
'owa_cookie.send('||unistr('\000a')||
'    name=>''FAS_SPRACHE_COOKIE'','||unistr('\000a')||
'    value=>:P121_AP';

p:=p||'P_SPRACHE_ID);'||unistr('\000a')||
'exception when others then null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 4465101111468278 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Benutzername-Cookie festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_betreuer  personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :fas_aufgerufen_von := ''BETREUER'';'||unistr('\000a')||
'   :fas_login_page := :APP_PAGE_ID;'||unistr('\000a')||
'   :fas_sprache_id:= :p121_sprache_id;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''betreuer lobin:%1,  %2,%3'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Login'','||unistr('\000a')||
'           to_char(:p121_username),'||unistr('\000a')||
'           :p121_sprache_id'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- Festlegen, ob Betreuer oder Identität '||unistr('\000a')||
'   ';

p:=p||'BEGIN'||unistr('\000a')||
'      SELECT betreuer into v_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE USER_ACCOUNT = TRIM(UPPER(:P121_USERNAME)); '||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20001,frgbg_s.holen_uebersetzung(476,:fas_sprache_id)||SQLERRM);'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_betreuer = ''J'' THEN'||unistr('\000a')||
'      wwv_flow_custom_auth_std.login('||unistr('\000a')||
'          P_UNAME       => v(''P121_USERNAME''),'||unistr('\000a')||
'          P_PASSWORD  ';

p:=p||'  => v(''P121_PASSWORD''),'||unistr('\000a')||
'          P_SESSION_ID  => v(''APP_SESSION''),'||unistr('\000a')||
'          P_FLOW_PAGE   => :APP_ID||'':130'''||unistr('\000a')||
'          -- P_PRESERVE_CASE => TRUE       damit wird user_account Case sensitiv => APP_USER ist danach auch CaseMixed => bei manchen Zugriffen evt. problematisch, falls umgestellt wird!!!!'||unistr('\000a')||
'          );'||unistr('\000a')||
'   ELSIF v_betreuer = ''I'' THEN'||unistr('\000a')||
'      :fas_aufgerufen_von := ''IDENTITAET'';'||unistr('\000a')||
'      wwv_';

p:=p||'flow_custom_auth_std.login('||unistr('\000a')||
'          P_UNAME       => v(''P121_USERNAME''),'||unistr('\000a')||
'          P_PASSWORD    => v(''P121_PASSWORD''),'||unistr('\000a')||
'          P_SESSION_ID  => v(''APP_SESSION''),'||unistr('\000a')||
'          P_FLOW_PAGE   => :APP_ID||'':132'''||unistr('\000a')||
'          );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4465307432468278 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Login',
  p_process_sql_clob => p,
  p_process_error_message=> 'Ungültiges Login',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 2177125480660125 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'',''P121_APP_SPRACHE_ID'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'12151422924614296';

wwv_flow_api.create_page_process(
  p_id     => 3181127780067523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'init_scrollregion_height',
  p_process_sql_clob => 12151422924614296 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_IDENTITAET_PERSSTAMM_ID personenstamm.id%TYPE;'||unistr('\000a')||
'   v_user       persareas.erfuser%TYPE;'||unistr('\000a')||
'   v_session_id persareas.session_id%TYPE;'||unistr('\000a')||
'   v_user_identifier varchar2(64);'||unistr('\000a')||
'   v_betreuer   personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_fehlertext varchar2(2000);'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''start 0 Login %1, Session-id %2, Identität-name %3, APP_USER %4'', v_prot_id,''Fehler'','||unistr('\000a')||
'        ''102/121/F';

p:=p||'AS_LOGIN_PERSONENSTAMM_ID_SETZEN'', :FAS_LOGIN_PERSONENSTAMM_ID,userenv(''sessionid''),:FAS_IDENTITAET,:APP_USER);'||unistr('\000a')||
'*/  '||unistr('\000a')||
'   SELECT id,betreuer INTO :FAS_LOGIN_PERSONENSTAMM_ID,v_betreuer'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE user_account = TRIM(UPPER (:p121_username));'||unistr('\000a')||
'   '||unistr('\000a')||
'   /* Setzen der Default-Identitaet des Betreuers */'||unistr('\000a')||
'   IF v_betreuer = ''I'' THEN'||unistr('\000a')||
'      :FAS_IDENTITAET_PERSSTAMM_ID := :FAS_LOGIN_PERSONE';

p:=p||'NSTAMM_ID;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      /* Setzen der Default-Identitaet des Betreuers */'||unistr('\000a')||
'      /*:FAS_IDENTITAET_PERSSTAMM_ID:= frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'      IF :FAS_IDENTITAET_PERSSTAMM_ID <=0 THEN'||unistr('\000a')||
'         :FAS_IDENTITAET_PERSSTAMM_ID := :FAS_LOGIN_PERSONENSTAMM_ID;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_IDENTITAET_PERSSTAMM_ID:= frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_I';

p:=p||'D);'||unistr('\000a')||
'      IF NVL(v_identitaet_persstamm_id,0) <= 0 THEN '||unistr('\000a')||
'         :fas_identitaet_persstamm_id := NULL;'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(3098,:fas_sprache_id);'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :FAS_IDENTITAET:=frgbg_s.get_identitaet_name(:FAS_IDENTIT';

p:=p||'AET_PERSSTAMM_ID);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Identität in persarea mit session-ID ablegen'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      INSERT INTO persareas (personenstamm_id,AKT_PERSSTAMM_ID_IDENTITAET, session_id )'||unistr('\000a')||
'      VALUES (:FAS_LOGIN_PERSONENSTAMM_ID, :FAS_IDENTITAET_PERSSTAMM_ID,:APP_SESSION);'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      null;'||unistr('\000a')||
'   END;'||unistr('\000a')||
'/*MEL.P (''Identität %1, Session-id %2, Identität-name %3, Betreuer_kz %4,fas_modus %5'', v_pr';

p:=p||'ot_id,''Fehler'',''102/121/FAS_LOGIN_PERSONENSTAMM_ID_SETZEN'', :FAS_IDENTITAET_PERSSTAMM_ID,:APP_SESSION,:FAS_IDENTITAET,v_betreuer,:fas_modus_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN '||unistr('\000a')||
' MEL.P (''Identität %1, Session-id %2, Identität-name %3, Fehler %4'', v_prot_id,''Fehler'','||unistr('\000a')||
'        ''102/121/FAS_LOGIN_PERSONENSTAMM_ID_SETZEN'', :FAS_IDENTITAET_PERSSTAMM_ID,:APP_SESSION,:FAS_IDENTITAET,SQLERRM);'||unistr('\000a')||
'    NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3746220033182867 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'FAS_LOGIN_PERS_ID_SETZEN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2887904124092079';

wwv_flow_api.create_page_process(
  p_id     => 2888215037133139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'init_fas_session',
  p_process_sql_clob => 2887904124092079 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz      NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'l_host VARCHAR2(2000);'||unistr('\000a')||
'v_str  varchar2(2000);'||unistr('\000a')||
'BEGIN   '||unistr('\000a')||
'/*MEL.P (''1 Schema setzen:%1, pers %2, url %3'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Prozessüberwachung'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id, owa_util.get_cgi_env(''server_name'')'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_user_id;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_user_id = ';

p:=p||'''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_sessionid;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_sessionid = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_host;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_host = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_base_url;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_base_url = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := hiims_r1.hiimsutil.getPortalURLPrefix;'||unistr('\000a')||
'--htp.p(''hiims_r1.hiims';

p:=p||'util.getPortalURLPrefix = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_query_string;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_query_string = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'l_host := OWA_UTIL.GET_CGI_ENV(''REQUEST_PROTOCOL'');'||unistr('\000a')||
'--htp.p(''OWA_UTIL.GET_CGI_ENV("REQUEST_PROTOCOL") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''OWA_UTIL.GET_CGI_ENV("REQUEST_PROTOCOL") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := OWA_UTIL.GET_CGI_ENV(''HTTP_HO';

p:=p||'ST'');'||unistr('\000a')||
'--htp.p(''OWA_UTIL.GET_CGI_ENV("HTTP_HOST") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''OWA_UTIL.GET_CGI_ENV("HTTP_HOST") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''QUERY_STRING'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("QUERY_STRING") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("QUERY_STRING") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''PATH_INFO'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_';

p:=p||'env("PATH_INFO") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("PATH_INFO") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''REQUEST_URI'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("REQUEST_URI") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("REQUEST_URI") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''DOCUMENT_URI'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("DOCUMENT_URI") = ''||l_host);';

p:=p||'htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("DOCUMENT_URI") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''SCRIPT_NAME'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("SCRIPT_NAME") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("SCRIPT_NAME") = ''||l_host;'||unistr('\000a')||
'*/'||unistr('\000a')||
'--mel.p(v_str,v_prot_id,''INFO'',''init_fas_schema_fas_modus P121'');'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'---------------'||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      :fas_sch';

p:=p||'ema_id := frgbg_s.get_fas_schema_srv;'||unistr('\000a')||
'   ELSE -- Check gültiges Schemaangabe?'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT count(*) INTO v_anz'||unistr('\000a')||
'         FROM fas_schemas'||unistr('\000a')||
'         WHERE id = :fas_schema_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'          v_anz := 0;'||unistr('\000a')||
'      END ;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz = 0 THEN -- FAlls ungültig über Servername ermitteln'||unistr('\000a')||
'         :fas_schema_id := frgbg_s.get_fas_schema_srv;           '||unistr('\000a')||
'    ';

p:=p||'  END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--mel.p(''Schema setzen:''||:fas_schema_id,v_prot_id,''INFO'',''init_fas_schema_fas_modus P121'');'||unistr('\000a')||
'   :fas_schema_id := NVL(:fas_schema_id ,1); -- Standardschema, falls keins ermittelt wurde'||unistr('\000a')||
''||unistr('\000a')||
'   :FAS_THEME_NAME:= ''fas_theme_''||:fas_schema_id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   -- Fas-Modus setzen abhängig vom Schema'||unistr('\000a')||
'   SELECT fas_modus_id into :fas_modus_id'||unistr('\000a')||
'   FROM fas_schemas'||unistr('\000a')||
'   WHERE id = :fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'';

p:=p||'--MEL.P (''Schema setzen:%1, pers %2,modus %3'','||unistr('\000a')||
'--           v_prot_id,''Fehler'',''init_fas_schema_fas_modus P121'','||unistr('\000a')||
'--           :fas_schema_id,:fas_schema_persstamm_id,:fas_modus_id);      '||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2761331269562406 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_fas_schema_fas_modus',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''PW-text:%1, %2'',v_prot_id,''test'',''pw_mail_versenden'',:p121_hinweis_pw);'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''alert("''||:p121_hinweis_pw||''");'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   :p121_hinweis_pw := NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6427604221877728 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 2,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'pw_hinweis_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request=''PW_HINWEIS''',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'    c owa_cookie.cookie;'||unistr('\000a')||
'begin'||unistr('\000a')||
'   c := owa_cookie.get(''FAS_LOGIN_USERNAME_COOKIE'');'||unistr('\000a')||
'   :P121_USERNAME := utl_url.unescape(c.vals(1),''AL32UTF8''); -- 04.11.2014 SL UTF-8 Anpassung da im UTL_HTTP standardmäßig ASCII verwendet wird.'||unistr('\000a')||
''||unistr('\000a')||
'exception when others then null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 4465505521468278 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Benutzername-Cookie abrufen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_sprache varchar2(50);'||unistr('\000a')||
'   v_anz        NUMBER;'||unistr('\000a')||
'   c owa_cookie.cookie;'||unistr('\000a')||
'   v_sprache_id NUMBER;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''0 app_sprache_setzen: Appsp %1, sprache %2, appsp param %3, owa %4,pos %5'','||unistr('\000a')||
'           v_prot_id,''TEST'',''Page 121'','||unistr('\000a')||
'           to_char(:p121_app_sprache_id),'||unistr('\000a')||
'           to_char(v_sprache_id),:p121_app_sprache_id_param,'||unistr('\000a')||
'           owa_util.get_cgi_env(''';

p:=p||'HTTP_ACCEPT_LANGUAGE''),'||unistr('\000a')||
'          instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'  IF :p121_app_sprache_id_param IS NULL THEN'||unistr('\000a')||
'     -- Zunaechst aus Cookie                          -- NEI 6.6.11 '||unistr('\000a')||
'     BEGIN                                            '||unistr('\000a')||
'        c := owa_cookie.get(''FAS_SPRACHE_COOKIE'');    '||unistr('\000a')||
'        -- Check, ob Sprache zum Schema passt, sonst Sprache unguelti';

p:=p||'g => Browsersprache'||unistr('\000a')||
'        SELECT count(*) into v_anz'||unistr('\000a')||
'        FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'        WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'          AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'          AND s.id =c.vals(1)'||unistr('\000a')||
'          AND s.aktiv=1;  -- NEI 09.09.2014'||unistr('\000a')||
'        IF v_anz > 0 THEN'||unistr('\000a')||
'           :P121_APP_SPRACHE_ID:= c.vals(1);          '||unistr('\000a')||
'        ELSE'||unistr('\000a')||
'           :P121_APP_SPRACHE_ID:=NULL';

p:=p||';'||unistr('\000a')||
'        END IF;'||unistr('\000a')||
'     exception '||unistr('\000a')||
'     when others then '||unistr('\000a')||
'           :P121_APP_SPRACHE_ID:=NULL;               '||unistr('\000a')||
'     end;                                             -- NEI 6.6.11'||unistr('\000a')||
'     IF :P121_APP_SPRACHE_ID IS NULL THEN             -- NEI 6.6.11 '||unistr('\000a')||
'        -- Browsersprache holen und abgleichen mit App-Sprachen für das Schema'||unistr('\000a')||
'        BEGIN'||unistr('\000a')||
'           v_sprache := NVL(substr(owa_util.get_cgi_env(''HT';

p:=p||'TP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                     instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')-1),''en'');'||unistr('\000a')||
'        EXCEPTION'||unistr('\000a')||
'        WHEN others THEN'||unistr('\000a')||
'           v_sprache := ''en'';'||unistr('\000a')||
'        END;'||unistr('\000a')||
'        :p121_app_sprache_id := frgbg_s.get_browser_sprache(v_sprache);'||unistr('\000a')||
'     END IF;                                       -- NEI 6.6.11 '||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     :p121_app_sprache_id := :p121_app_sprache_id_param;'||unistr('\000a')||
'';

p:=p||'     :p121_app_sprache_id_param := NULL;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' /* NEI 24.09.09 Kein Optionstyp für Sprachen mehr sondern über Schema in app_sprachen'||unistr('\000a')||
'  IF :p121_app_sprache_id_param IS NULL THEN'||unistr('\000a')||
'--MEL.P (''1 app_sprache_setzen:%1, Browser %2'',v_prot_id,''Fehler'',''Page 121'');'||unistr('\000a')||
'     IF :fas_schema_id = 2 THEN  -- Biogena '||unistr('\000a')||
'        -- Default des Sprachsubsets entsprechend der Schemavorgabe'||unistr('\000a')||
'        :p121_app_sprach';

p:=p||'e_id := '||unistr('\000a')||
'                frgbg_s.get_pers_option(NULL,23,:fas_schema_persstamm_id,  '||unistr('\000a')||
'                                                :fas_schema_persstamm_id);'||unistr('\000a')||
'     ELSE '||unistr('\000a')||
'        -- Abgleich der Browser-Sprache mit dem entsprechenden Sprachsubset'||unistr('\000a')||
'        v_sprache := substr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                        instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''), ';

p:=p||''','')-1);'||unistr('\000a')||
'        :p121_app_sprache_id := frgbg_s.get_browser_sprache(v_sprache, :P121_PERS_OPT_PERSSTAMM_ID);'||unistr('\000a')||
'     END IF;'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     :p121_app_sprache_id := :p121_app_sprache_id_param;'||unistr('\000a')||
'     :p121_app_sprache_id_param := NULL;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'/*MEL.P (''app_sprache_setzen:%1, Browser %2,%3'',v_prot_id,''TEST'',''Page 121'','||unistr('\000a')||
'           :p121_app_sprache_id,'||unistr('\000a')||
'           v_sprache,:fas_schema_persstamm_id'||unistr('\000a')||
'   ';

p:=p||'       );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12499800077039507 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'app_sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'Y',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
' --IF :p121_sprache_id is null THEN'||unistr('\000a')||
'   SELECT sprache_id into :p121_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p121_app_sprache_id;'||unistr('\000a')||
' --END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6677918974782609 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 35,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/* NEI 24.09.09 macht keinen Sinn mehr, da es Schemaspezif. Defaults gibt'||unistr('\000a')||
'     IF :p121_app_sprache_id IS NULL THEN'||unistr('\000a')||
'      SELECT NVL(min(parameter),3) into :p121_app_sprache_id '||unistr('\000a')||
'      from sysareas_frgbg'||unistr('\000a')||
'      where id = 5; -- Default App-Sprache'||unistr('\000a')||
'     END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   :p121_bl_login := frgbg_s.holen_uebersetzung(430,:p121_sprache_id);'||unistr('\000a')||
'   :p121_page_titel_anmeldung';

p:=p||' := frgbg_s.holen_uebersetzung(471,:p121_sprache_id);'||unistr('\000a')||
'   :p121_page_titel_hinweis := frgbg_s.holen_uebersetzung(3786,:p121_sprache_id);'||unistr('\000a')||
'   :P121_BL_PASSWORT_VERGESSEN  := frgbg_s.holen_uebersetzung(429,:p121_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''button_labels_setzen:%1,%2'',v_prot_id,''Fehler'',''Page 121'','||unistr('\000a')||
'           to_char(:p121_app_sprache_id),:p121_sprache_id'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4464902988468273 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 121,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 121
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00122
prompt  ...PAGE 122: Anmelden Uebersetzer
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 122
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Anmelden Uebersetzer'
 ,p_step_title => 'Anmelden Uebersetzer'
 ,p_step_sub_title => 'Anmelden Uebersetzer'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2882731585489434 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'Y'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909144648'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5868725242801521 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 122,
  p_plug_name=> '&P122_PAGE_TITEL_HINWEIS.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890721784489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => 'frgbg_s.holen_uebersetzung(10,:p122_sprache_id) !=''.''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8542105502145389 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 122,
  p_plug_name=> '&P122_PAGE_TITEL_ANMELDUNG.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8544808137145423 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 28-AUG-2007 11:09 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3419012954855748 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_WARTUNG_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 181,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4771124107984806 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_APP_SPRACHE_ID_PARAM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'App Sprache Id Param',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5869001112801521 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 171,
  p_item_plug_id => 5868725242801521+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(10,:p122_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 70,
  p_cMaxlength=> 2000,
  p_cHeight=> 5,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'1=1',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5869202170804326 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_PAGE_TITEL_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 141,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Hinweis',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8542328171145400 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_PAGE_TITEL_ANMELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8542508615145407 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8542732742145407 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_BL_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8542908797145407 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_USERNAME',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_UEBERSETZER"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8543105369145407 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_PASSWORD',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_UEBERSETZER"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_PASSWORD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_encrypt_session_state_yn=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8543316982145407 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_LOGIN',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> '',
  p_item_default=> 'LOGIN',
  p_prompt=>'&P122_BL_LOGIN.',
  p_source=>'LOGIN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'S',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8543510111145407 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 122,
  p_name=>'P122_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 8542105502145389+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_UEBERSETZER"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT s.sprache, s.id'||unistr('\000a')||
'FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'order by 1'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'SELECT sprache, '||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, pers_optionen po , optionstypen ot    /* Subsetzugriff * /'||unistr('\000a')||
'where po.opttyp_id = ot.id  /* JOIN OT * /'||unistr('\000a')||
'  and ot.art = 1        /* Subset * /'||unistr('\000a')||
'  and po.opttyp_id = 23  /* Sprachen * /'||unistr('\000a')||
'  and ow.id = po.wert'||unistr('\000a')||
'  /* Persid des Subsets sonst null * /'||unistr('\000a')||
'  and po.persstamm_id = :p122_pers_opt_persstamm_id '||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Appsprachen (statt Optionswerte), da keine Subsetdef. od. da Def.wertverwaltg* /'||unistr('\000a')||
'SELECT sprache,'||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, optionstypen ot'||unistr('\000a')||
'where ot.id = 23 /* Sprachen* /'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden* /'||unistr('\000a')||
'       :p122_pers_opt_persstamm_id  IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset * /'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1  '||unistr('\000a')||
'*/',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3418406805835079 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_wartung',
  p_validation_sequence=> 5,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_text   varchar2(4000);'||unistr('\000a')||
'   v_liste  varchar2(4000);'||unistr('\000a')||
'   v_flag   NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p122_wartung_flag := 0;'||unistr('\000a')||
'   SELECT to_number(parameter) INTO v_flag'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 10;'||unistr('\000a')||
'   SELECT parameter INTO v_liste'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 11;'||unistr('\000a')||
'--mel.p(''Wartungsflag:%1, Text %2'',v_prot_id,''INFO'',''FAS102/122: check_wartung'',v_flag,:P122_HINWEIS);'||unistr('\000a')||
'   IF v_flag = 1 and  -- Generelles Wartungsflag'||unistr('\000a')||
'      -- Check USER, die während der Wartung arbeiten dürfen '||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:p122_username)||'';'') = 0 and  '||unistr('\000a')||
'      -- Check Applikation, die gewartet werden'||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:APP_ID)||'';'') = 0    '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p122_wartung_flag := 1;'||unistr('\000a')||
'      v_text := frgbg_s.holen_uebersetzung(10,:p122_sprache_id);'||unistr('\000a')||
'      IF v_text is null or v_text = ''.'' THEN'||unistr('\000a')||
'         v_text := ''System is not available because of system maintaince! Please try again later.'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      RETURN v_text;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p122_wartung_flag := 0;'||unistr('\000a')||
'      RETURN null;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8543806295145410 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_gueltiges_login',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz              number := 0;'||unistr('\000a')||
'   v_anz_login        personenstamm.login_fehlversuche%TYPE;'||unistr('\000a')||
'   v_anz_max_login    personenstamm.login_fehlversuche%TYPE;'||unistr('\000a')||
'   v_personenstamm_id personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fas_schema_id_pers personenstamm.id%TYPE;'||unistr('\000a')||
'   v_betreuer         personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_prot_id          number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Sperren des Übersetzer-Logins nach n Fehlversuchen'||unistr('\000a')||
'   :p122_username:=TRIM(UPPER (:p122_username));'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT NVL(min(parameter),5) INTO v_anz_max_login'||unistr('\000a')||
'      FROM sysareas_frgbg'||unistr('\000a')||
'      WHERE id = 3;'||unistr('\000a')||
'      SELECT p.login_fehlversuche,p.id,p.betreuer, count(*)'||unistr('\000a')||
'      INTO v_anz_login, v_personenstamm_id, v_betreuer,v_anz'||unistr('\000a')||
'      FROM personenstamm p, uebersetzer u'||unistr('\000a')||
'      WHERE user_account = TRIM(UPPER (:p122_username))'||unistr('\000a')||
'        AND p.id = u.persstamm_id'||unistr('\000a')||
'        AND u.satzkennzeichen is null'||unistr('\000a')||
'      group by p.login_fehlversuche,p.id,p.betreuer;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN '||unistr('\000a')||
'mel.p(''Keine Uebersetzersprachen definiert! Login: %1, max:%2,anz:%3,pers:%4,v_betreuer:%5,%6'',v_prot_id,''INFO'',''102/122:check_gueltiges_login'',:p122_username,v_anz_max_login,v_anz_login,v_personenstamm_id,v_betreuer,sqlerrm);'||unistr('\000a')||
'       NULL;'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   IF v_anz = 0 THEN  -- Keine Uebersetzersprache definiert'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p122_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'/*mel.p(''max:%1,anz:%2,pers:%3,v_betreuer:%4'',v_prot_id,''TEST'',''102/122:check_gueltiges_login'',v_anz_max_login,v_anz_login,v_personenstamm_id,v_betreuer);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF v_anz_login >= v_anz_max_login THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(477,:p122_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'/* 06.08.09 Für Uebersetzer nicht notwendig Wunsch GEI'||unistr('\000a')||
'   -- Schema-Prüfung'||unistr('\000a')||
'   IF v_betreuer = ''J'' THEN'||unistr('\000a')||
'      v_fas_schema_id_pers :='||unistr('\000a')||
'         frgbg_s.get_fas_schema(v_personenstamm_id,''BETREUER'');'||unistr('\000a')||
'   ELSIF v_betreuer = ''I'' THEN'||unistr('\000a')||
'      v_fas_schema_id_pers := '||unistr('\000a')||
'         frgbg_s.get_fas_schema(v_personenstamm_id,''IDENTITAET'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF v_fas_schema_id_pers = :fas_schema_id THEN'||unistr('\000a')||
'      NULL; -- alles ok'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p122_sprache_id));   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- Gültiger User?, Betreuer?, Fas-Rolle Uebersetzer?'||unistr('\000a')||
'   IF frgbg_s.VALID_USER (:p122_username,:p122_password) AND '||unistr('\000a')||
'      v_betreuer = ''J'' AND'||unistr('\000a')||
'      frgbg_s.check_fas_rolle(:p122_username,''UEBERSETZER'') > 0'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET app_sprache_id = :p122_app_sprache_id,'||unistr('\000a')||
'             login_fehlversuche = 0'||unistr('\000a')||
'         WHERE id = v_personenstamm_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN OTHERS THEN '||unistr('\000a')||
'          NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET login_fehlversuche = login_fehlversuche +1'||unistr('\000a')||
'         WHERE id = v_personenstamm_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN OTHERS THEN '||unistr('\000a')||
'          NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p122_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':p122_wartung_flag = 0',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   owa_util.mime_header(''text/html'', FALSE);'||unistr('\000a')||
'   owa_cookie.send('||unistr('\000a')||
'       name=>''FAS_LOGIN_USERNAME_COOKIE'','||unistr('\000a')||
'       --value=>lower(:P122_USERNAME));  -- NEI 09.01.2013 Umlauteproblem'||unistr('\000a')||
'       value=>utl_url.escape(lower(:P122_USERNAME), true,''AL32UTF8''));'||unistr('\000a')||
'   owa_cookie.send('||unistr('\000a')||
'       name=>''FAS_SPRACHE_COOKIE'','||unistr('\000a')||
'       value=>:P122_APP_SPRACHE_ID);'||unistr('\000a')||
'exception '||unistr('\000a')||
'when others then '||unistr('\000a')||
'   null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8544103947145420 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Benutzername-Cookie festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':fas_aufgerufen_von := ''UEBERSETZER'';'||unistr('\000a')||
':fas_login_page := :APP_PAGE_ID;'||unistr('\000a')||
':fas_sprache_id:= :p122_sprache_id;'||unistr('\000a')||
'/* NEI 20.04.09 in Anwendungsprozedur'||unistr('\000a')||
':fas_abmelden_text := frgbg_s.holen_uebersetzung(174,:p122_sprache_id);'||unistr('\000a')||
':fas_keine_daten_text := frgbg_s.holen_uebersetzung(759,:p122_sprache_id);'||unistr('\000a')||
':FAS_AENDERUNGWARNUNG_TEXT := frgbg_s.holen_uebersetzung(3068,:p122_sprache_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'wwv_flow_custom_auth_st';

p:=p||'d.login('||unistr('\000a')||
'    P_UNAME       => v(''P122_USERNAME''),'||unistr('\000a')||
'    P_PASSWORD    => v(''P122_PASSWORD''),'||unistr('\000a')||
'    P_SESSION_ID  => v(''APP_SESSION''),'||unistr('\000a')||
'    P_FLOW_PAGE   => :APP_ID||'':150'''||unistr('\000a')||
'    );';

wwv_flow_api.create_page_process(
  p_id     => 8544330331145420 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Login',
  p_process_sql_clob => p,
  p_process_error_message=> 'Ungültiges Login',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 2178216701723789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   SELECT id INTO :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE user_account = TRIM(UPPER (:p122_username));'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN '||unistr('\000a')||
'    NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3746624666193714 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_process_sequence=> 70,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'FAS_LOGIN_PERSONENSTAMM_ID_SETZEN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz      NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN   '||unistr('\000a')||
'/*MEL.P (''1 Schema setzen:%1, pers %2'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Prozessüberwachung'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      -- FAS-Schema über Servername ermitteln'||unistr('\000a')||
'      :fas_schema_id := frgbg_s.get_fas_schema_srv;'||unistr('\000a')||
'   ELSE -- Check gültiges Schemaangabe?'||unistr('\000a')||
'  ';

p:=p||'    BEGIN'||unistr('\000a')||
'         SELECT count(*) INTO v_anz'||unistr('\000a')||
'         FROM fas_schemas'||unistr('\000a')||
'         WHERE id = :fas_schema_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'          v_anz := 0;'||unistr('\000a')||
'      END ;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz = 0 THEN -- FAlls ungültig über Servername ermitteln'||unistr('\000a')||
'         :fas_schema_id := frgbg_s.get_fas_schema_srv;           '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   :FAS_THEME_NAME:= ''fas_theme_''||:fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- ';

p:=p||'Holen der Persstamm_id für das FAS-Schema'||unistr('\000a')||
'   --:fas_schema_persstamm_id := frgbg_s.get_pers_fas_schema(:fas_schema_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Fas-Modus setzen abhängig vom Schema'||unistr('\000a')||
'   SELECT fas_modus_id into :fas_modus_id'||unistr('\000a')||
'   FROM fas_schemas'||unistr('\000a')||
'   WHERE id = :fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
'/* NEI 24.09.09 FAS-Schema über Servername ermitteln'||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      :fas_schema_id := frgbg_s.get_fas_schema_std;'||unistr('\000a')||
'   E';

p:=p||'ND IF;'||unistr('\000a')||
'   -- Holen der Persstamm_id für das FAS-Schema'||unistr('\000a')||
'   :fas_schema_persstamm_id := frgbg_s.get_pers_fas_schema(:fas_schema_id);'||unistr('\000a')||
'   -- Holen der Persstamm_id für die entsprechende Pers_option des Sprachen-Subsets'||unistr('\000a')||
'   :P122_PERS_OPT_PERSSTAMM_ID := '||unistr('\000a')||
'                  frgbg_s.GET_PERS_OPT_PERS_ID(:fas_schema_persstamm_id,23,'||unistr('\000a')||
'                                               :fas_schema_persstamm_id);'||unistr('\000a')||
'';

p:=p||'*/'||unistr('\000a')||
'/*MEL.P (''Schema setzen:%1, pers %2,%3'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Prozessüberwachung'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2772215672795509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_fas_schema_fas_modus',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'    c owa_cookie.cookie;'||unistr('\000a')||
'begin'||unistr('\000a')||
'   c := owa_cookie.get(''FAS_LOGIN_USERNAME_COOKIE'');'||unistr('\000a')||
'   :P122_USERNAME := utl_url.unescape(c.vals(1),''AL32UTF8'');'||unistr('\000a')||
'exception '||unistr('\000a')||
'when others then '||unistr('\000a')||
'   null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8544531804145421 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Benutzername-Cookie abrufen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_sprache varchar2(50);'||unistr('\000a')||
'   v_anz        NUMBER;'||unistr('\000a')||
'   c owa_cookie.cookie;'||unistr('\000a')||
'   v_sprache_id NUMBER;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''0 app_sprache_setzen: Appsp %1, sprache %2, appsp param %3, owa %4,pos %5'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Page 122'','||unistr('\000a')||
'           to_char(:p122_app_sprache_id),'||unistr('\000a')||
'           to_char(v_sprache_id),:p121_app_sprache_id_param,'||unistr('\000a')||
'           owa_util.get_cgi_env';

p:=p||'(''HTTP_ACCEPT_LANGUAGE''),'||unistr('\000a')||
'          instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'  IF :p122_app_sprache_id_param IS NULL THEN'||unistr('\000a')||
'     -- Zunaechst aus Cookie                          -- NEI 6.6.11 '||unistr('\000a')||
'     BEGIN                                            '||unistr('\000a')||
'        c := owa_cookie.get(''FAS_SPRACHE_COOKIE'');    '||unistr('\000a')||
'        -- Check, ob Sprache zum Schema passt, sonst Sprache unguel';

p:=p||'tig => Browsersprache'||unistr('\000a')||
'        SELECT count(*) into v_anz'||unistr('\000a')||
'        FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'        WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'          AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'          AND s.id =c.vals(1)'||unistr('\000a')||
'          AND s.aktiv=1;  -- NEI 09.09.2014'||unistr('\000a')||
'        IF v_anz > 0 THEN'||unistr('\000a')||
'           :P122_APP_SPRACHE_ID:= c.vals(1);          '||unistr('\000a')||
'        ELSE'||unistr('\000a')||
'           :P122_APP_SPRACHE_ID:=NU';

p:=p||'LL;'||unistr('\000a')||
'        END IF;'||unistr('\000a')||
'     exception '||unistr('\000a')||
'     when others then '||unistr('\000a')||
'           :P122_APP_SPRACHE_ID:=NULL;               '||unistr('\000a')||
'     end;                                             -- NEI 6.6.11'||unistr('\000a')||
'     IF :P122_APP_SPRACHE_ID IS NULL THEN             -- NEI 6.6.11 '||unistr('\000a')||
'        -- Browsersprache holen und abgleichen mit App-Sprachen für das Schema'||unistr('\000a')||
'        BEGIN'||unistr('\000a')||
'           v_sprache := NVL(substr(owa_util.get_cgi_env(''';

p:=p||'HTTP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                        instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')-1),''en'');'||unistr('\000a')||
'        EXCEPTION'||unistr('\000a')||
'        WHEN others THEN'||unistr('\000a')||
'           v_sprache := ''en'';'||unistr('\000a')||
'        END;'||unistr('\000a')||
'        :p122_app_sprache_id := frgbg_s.get_browser_sprache(v_sprache);'||unistr('\000a')||
'     END IF;                                       -- NEI 6.6.11 '||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     :p122_app_sprache_id := :p122_app_sprache_id_pa';

p:=p||'ram;'||unistr('\000a')||
'     :p122_app_sprache_id_param := NULL;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
' /* NEI 24.09.09 Kein Optionstyp für Sprachen mehr sondern über Schema in app_sprachen'||unistr('\000a')||
'  IF :p122_app_sprache_id_param IS NULL THEN'||unistr('\000a')||
'--MEL.P (''1 app_sprache_setzen:%1, Browser %2'',v_prot_id,''Fehler'',''Page 121'');'||unistr('\000a')||
'     IF :fas_schema_id = 2 THEN  -- Biogena '||unistr('\000a')||
'        -- Default des Sprachsubsets entsprechend der Schemavorgabe'||unistr('\000a')||
'        :p122_app_s';

p:=p||'prache_id := '||unistr('\000a')||
'                frgbg_s.get_pers_option(NULL,23,:fas_schema_persstamm_id,  '||unistr('\000a')||
'                                                :fas_schema_persstamm_id);'||unistr('\000a')||
'     ELSE '||unistr('\000a')||
'        -- Abgleich der Browser-Sprache mit dem entsprechenden Sprachsubset'||unistr('\000a')||
'        v_sprache := substr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                        instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAG';

p:=p||'E''), '','')-1);'||unistr('\000a')||
'        :p122_app_sprache_id := frgbg_s.get_browser_sprache(v_sprache, :P122_PERS_OPT_PERSSTAMM_ID);'||unistr('\000a')||
'     END IF;'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     :p122_app_sprache_id := :p122_app_sprache_id_param;'||unistr('\000a')||
'     :p122_app_sprache_id_param := NULL;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12514721659605017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'app_sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'Y',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   SELECT sprache_id into :p122_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p122_app_sprache_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6687011154809926 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* NEI 24.09.09 Default-sprache obsolet, da Schemaspezif. App-Sprache'||unistr('\000a')||
'   IF :p122_app_sprache_id IS NULL THEN'||unistr('\000a')||
'      SELECT NVL(min(parameter),3) into :p122_app_sprache_id '||unistr('\000a')||
'      from sysareas_frgbg'||unistr('\000a')||
'      where id = 5; -- Default App-Sprache'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   SELECT sprache_id into :p122_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p122_app_sprache_id;'||unistr('\000a')||
'   ';

p:=p||':p122_bl_login := frgbg_s.holen_uebersetzung(430,:p122_sprache_id);'||unistr('\000a')||
'   :p122_page_titel_anmeldung := frgbg_s.holen_uebersetzung(621,:p122_sprache_id);'||unistr('\000a')||
'   :P122_PAGE_TITEL_HINWEIS := frgbg_s.holen_uebersetzung(3786,:p122_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8543919790145417 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 122,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 122
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00123
prompt  ...PAGE 123: Anmelden anonymer Kunde
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 123
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Anmelden anonymer Kunde'
 ,p_step_title => 'Anmelden anonymer Kunde'
 ,p_step_sub_title => 'Anmelden anonymer Kunde'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2882731585489434 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'Y'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909144757'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3580801559630357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 123,
  p_plug_name=> '&P123_PAGE_TITEL_HINWEIS.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890721784489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 30,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => 'frgbg_s.holen_uebersetzung(10,:p123_sprache_id) !=''.''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3581222094630362 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 123,
  p_plug_name=> '&P123_PAGE_TITEL_ANMELDUNG.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3589715621630390 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:123:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 28-AUG-2007 11:09 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3581027213630361 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 171,
  p_item_plug_id => 3580801559630357+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(10,:p123_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3581427151630364 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_WARTUNG_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3582430112630368 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_ANONYM"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT s.sprache, s.id'||unistr('\000a')||
'FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'order by 1'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'SELECT sprache, '||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, pers_optionen po , optionstypen ot    /* Subsetzugriff * /'||unistr('\000a')||
'where po.opttyp_id = ot.id  /* JOIN OT * /'||unistr('\000a')||
'  and ot.art = 1        /* Subset  * /'||unistr('\000a')||
'  and po.opttyp_id = 23  /* Sprachen * /'||unistr('\000a')||
'  and ow.id = po.wert'||unistr('\000a')||
'  /* Persid des Subsets sonst null * /'||unistr('\000a')||
'  and po.persstamm_id = :p123_pers_opt_persstamm_id '||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Appsprachen (statt Optionswerte), da keine Subsetdef. od. da Def.wertverwaltg* /'||unistr('\000a')||
'SELECT sprache,'||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, optionstypen ot'||unistr('\000a')||
'where ot.id = 23 /* Sprachen* /'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden* /'||unistr('\000a')||
'       :p123_pers_opt_persstamm_id  IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset * /'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1  '||unistr('\000a')||
'*/',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3582607593630368 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_BENUTZER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3583831053630370 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_PAGE_TITEL_ANMELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3584006670630372 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3584219957630372 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_APP_SPRACHE_ID_PARAM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'App Sprache Id Param',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3584400824630372 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_PAGE_TITEL_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 141,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Hinweis',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3584608206630372 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_USERNAME',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3584824771630372 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_PASSWORD',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_encrypt_session_state_yn=> 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3585227728630373 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_ANMELDEN_ANONYM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'Anonym',
  p_prompt=>'&P123_BL_ANONYM_LOGIN.',
  p_source=>'Anonym',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3585410363630373 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 123,
  p_name=>'P123_BL_ANONYM_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 3581222094630362+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3586132601630379 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_wartung',
  p_validation_sequence=> 5,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_text   varchar2(4000);'||unistr('\000a')||
'   v_liste  varchar2(4000);'||unistr('\000a')||
'   v_flag   NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p123_wartung_flag := 0;'||unistr('\000a')||
'   SELECT to_number(parameter) INTO v_flag'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 10;'||unistr('\000a')||
'   SELECT parameter INTO v_liste'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 11;'||unistr('\000a')||
'--mel.p(''Wartungsflag:%1, Text %2'',v_prot_id,''INFO'',''FAS102/101: check_wartung'',v_flag,:P123_HINWEIS);'||unistr('\000a')||
'   IF v_flag = 1 and  -- Generelles Wartungsflag'||unistr('\000a')||
'      -- Check USER, die während der Wartung arbeiten dürfen '||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:p123_username)||'';'') = 0 and  '||unistr('\000a')||
'      -- Check Applikation, die gewartet werden'||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:APP_ID)||'';'') = 0    '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p123_wartung_flag := 1;'||unistr('\000a')||
'      v_text := frgbg_s.holen_uebersetzung(10,:p123_sprache_id);'||unistr('\000a')||
'      IF v_text is null or v_text = ''.'' THEN'||unistr('\000a')||
'         v_text := ''System is not available because of system maintaince! Please try again later.'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      RETURN v_text;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p123_wartung_flag := 0;'||unistr('\000a')||
'      RETURN null;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':fas_aufgerufen_von := ''ANONYM'';'||unistr('\000a')||
':fas_login_page := :APP_PAGE_ID;'||unistr('\000a')||
':fas_sprache_id:= :p123_sprache_id;'||unistr('\000a')||
'/* NEI 20.04.09 in Anwendungsprozess'||unistr('\000a')||
':FAS_ABMELDEN_TEXT := frgbg_s.holen_uebersetzung(174,:p123_sprache_id);'||unistr('\000a')||
':FAS_AENDERUNGWARNUNG_TEXT := frgbg_s.holen_uebersetzung(3068,:p121_sprache_id);'||unistr('\000a')||
':fas_keine_daten_text := frgbg_s.holen_uebersetzung(759,:p123_sprache_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'wwv_flow_custom_auth_std.logi';

p:=p||'n('||unistr('\000a')||
'    P_UNAME       => v(''P123_USERNAME''),'||unistr('\000a')||
'    P_PASSWORD    => v(''P123_PASSWORD''),'||unistr('\000a')||
'    P_SESSION_ID  => v(''APP_SESSION''),'||unistr('\000a')||
'    --P_FLOW_PAGE   => :APP_ID||'':110:&APP_SESSION.::NO::P110_AUFGERUFEN_VON:ANONYM'''||unistr('\000a')||
'    P_FLOW_PAGE   => :APP_ID||'':112:''|| v(''APP_SESSION'')||'':BRANCH_TO_PAGE_ACCEPT'''||unistr('\000a')||
''||unistr('\000a')||
'    );';

wwv_flow_api.create_page_process(
  p_id     => 3588608636630386 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'login_anonym',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>3585227728630373 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 3586224794630379 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'NEU Passwort Benutzer',
  p_process_when_type=>'',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'12151422924614296';

wwv_flow_api.create_page_process(
  p_id     => 4171405571420898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'init_scrollregion_height',
  p_process_sql_clob => 12151422924614296 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   SELECT id INTO :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE user_account = TRIM(UPPER (:p123_username));'||unistr('\000a')||
''||unistr('\000a')||
'/*   SELECT  ''(''||NAME||''/''||userenv(''sessionid'')||'')'' INTO :FAS_IDENTITAET'||unistr('\000a')||
'   FROM PERSONENSTAMM'||unistr('\000a')||
'   WHERE id = :FAS_LOGIN_PERSONENSTAMM_ID;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- Identität in persarea sessionabhängig ablegen'||unistr('\000a')||
'   /*SELECT sid, osuser into v_session, v_user from v$session where audsid ';

p:=p||'= userenv(''sessionid'');*/'||unistr('\000a')||
'   INSERT INTO persareas (personenstamm_id,AKT_PERSSTAMM_ID_IDENTITAET, session_id )'||unistr('\000a')||
'   VALUES (:FAS_LOGIN_PERSONENSTAMM_ID, :FAS_IDENTITAET_PERSSTAMM_ID,userenv(''sessionid''));'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN '||unistr('\000a')||
'    NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3586619494630381 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'FAS_LOGIN_PERSONENSTAMM_ID_SETZEN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2887904124092079';

wwv_flow_api.create_page_process(
  p_id     => 4171720809425277 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'init_fas_session',
  p_process_sql_clob => 2887904124092079 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz      NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN   '||unistr('\000a')||
'/*MEL.P (''1 Schema setzen:%1, pers %2'','||unistr('\000a')||
'           v_prot_id,''TEST'',''Anonym Login 102/123'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      -- FAS-Schema über Servername ermitteln'||unistr('\000a')||
'      :fas_schema_id := frgbg_s.get_fas_schema_srv;'||unistr('\000a')||
'   ELSE -- Check gültiges Schemaangabe?'||unistr('\000a')||
'  ';

p:=p||'    BEGIN'||unistr('\000a')||
'         SELECT count(*) INTO v_anz'||unistr('\000a')||
'         FROM fas_schemas'||unistr('\000a')||
'         WHERE id = :fas_schema_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'          v_anz := 0;'||unistr('\000a')||
'      END ;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz = 0 THEN -- FAlls ungültig über Servername ermitteln'||unistr('\000a')||
'         :fas_schema_id := frgbg_s.get_fas_schema_srv;           '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   :FAS_THEME_NAME:= ''fas_theme_''||:fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- ';

p:=p||'Fas-Modus setzen abhängig vom Schema'||unistr('\000a')||
'   SELECT fas_modus_id into :fas_modus_id'||unistr('\000a')||
'   FROM fas_schemas'||unistr('\000a')||
'   WHERE id = :fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
'MEL.P (''Schema setzen: %1, modus %2'','||unistr('\000a')||
'           v_prot_id,''TEST'',''Anonym Login 102/123'','||unistr('\000a')||
'           :fas_schema_id,:fas_modus_id'||unistr('\000a')||
'          );      '||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3586411072630381 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_fas_schema_fas_modus',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_sprache varchar2(50);'||unistr('\000a')||
'   v_anz        NUMBER;'||unistr('\000a')||
'   c owa_cookie.cookie;'||unistr('\000a')||
'   v_sprache_id NUMBER;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''0 app_sprache_setzen: Appsp %1, sprache %2, appsp param %3, owa %4,pos %5'','||unistr('\000a')||
'           v_prot_id,''Fehler'',''Page 121'','||unistr('\000a')||
'           to_char(:p121_app_sprache_id),'||unistr('\000a')||
'           to_char(v_sprache_id),:p121_app_sprache_id_param,'||unistr('\000a')||
'           owa_util.get_cgi_env';

p:=p||'(''HTTP_ACCEPT_LANGUAGE''),'||unistr('\000a')||
'          instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'  IF :p123_app_sprache_id_param IS NULL THEN'||unistr('\000a')||
'     -- Zunaechst aus Cookie                          -- NEI 6.6.11 '||unistr('\000a')||
'     BEGIN                                            '||unistr('\000a')||
'        c := owa_cookie.get(''FAS_SPRACHE_COOKIE'');    '||unistr('\000a')||
'        -- Check, ob Sprache zum Schema passt, sonst Sprache unguel';

p:=p||'tig => Browsersprache'||unistr('\000a')||
'        SELECT count(*) into v_anz'||unistr('\000a')||
'        FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'        WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'          AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'          AND s.id =c.vals(1)'||unistr('\000a')||
'          AND s.aktiv=1;  -- NEI 09.09.2014'||unistr('\000a')||
'        IF v_anz > 0 THEN'||unistr('\000a')||
'           :P123_APP_SPRACHE_ID:= c.vals(1);          '||unistr('\000a')||
'        ELSE'||unistr('\000a')||
'           :P123_APP_SPRACHE_ID:=NU';

p:=p||'LL;'||unistr('\000a')||
'        END IF;'||unistr('\000a')||
'     exception '||unistr('\000a')||
'     when others then '||unistr('\000a')||
'           :P123_APP_SPRACHE_ID:=NULL;               '||unistr('\000a')||
'     end;                                             -- NEI 6.6.11'||unistr('\000a')||
'     IF :P123_APP_SPRACHE_ID IS NULL THEN             -- NEI 6.6.11 '||unistr('\000a')||
'        -- Browsersprache holen und abgleichen mit App-Sprachen für das Schema'||unistr('\000a')||
'        BEGIN'||unistr('\000a')||
'           v_sprache := NVL(substr(owa_util.get_cgi_env(''';

p:=p||'HTTP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                        instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')-1),''en'');'||unistr('\000a')||
'        EXCEPTION'||unistr('\000a')||
'        WHEN others THEN'||unistr('\000a')||
'           v_sprache := ''en'';'||unistr('\000a')||
'        END;'||unistr('\000a')||
'        :p123_app_sprache_id := frgbg_s.get_browser_sprache(v_sprache);'||unistr('\000a')||
'     END IF;'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     :p123_app_sprache_id := :p123_app_sprache_id_param;'||unistr('\000a')||
'     :p123_app_sprache_id_param := NULL;'||unistr('\000a')||
'  END I';

p:=p||'F;'||unistr('\000a')||
''||unistr('\000a')||
' /* NEI 24.09.09 Kein Optionstyp für Sprachen mehr sondern über Schema in app_sprachen'||unistr('\000a')||
'  IF :p123_app_sprache_id_param IS NULL THEN'||unistr('\000a')||
'--MEL.P (''1 app_sprache_setzen:%1, Browser %2'',v_prot_id,''Fehler'',''Page 121'');'||unistr('\000a')||
'     IF :fas_schema_id = 2 THEN  -- Biogena '||unistr('\000a')||
'        -- Default des Sprachsubsets entsprechend der Schemavorgabe'||unistr('\000a')||
'        :p123_app_sprache_id := '||unistr('\000a')||
'                frgbg_s.get_pers_option';

p:=p||'(NULL,23,:fas_schema_persstamm_id,  '||unistr('\000a')||
'                                                :fas_schema_persstamm_id);'||unistr('\000a')||
'     ELSE '||unistr('\000a')||
'        -- Abgleich der Browser-Sprache mit dem entsprechenden Sprachsubset'||unistr('\000a')||
'        v_sprache := substr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                        instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''), '','')-1);'||unistr('\000a')||
'        :p123_app_sprache_id := frgbg_s';

p:=p||'.get_browser_sprache(v_sprache, :P123_PERS_OPT_PERSSTAMM_ID);'||unistr('\000a')||
'     END IF;'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     :p123_app_sprache_id := :p123_app_sprache_id_param;'||unistr('\000a')||
'     :p123_app_sprache_id_param := NULL;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3588803015630386 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'app_sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'Y',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   SELECT sprache_id into :p123_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p123_app_sprache_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3587620166630384 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 35,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   /* NEI 24.09.09 Default-Sprache obsolet, da es nun Schemaspezif. App-Sprachen gibt'||unistr('\000a')||
'   IF :p123_app_sprache_id IS NULL THEN'||unistr('\000a')||
'      SELECT NVL(min(parameter),3) into :p123_app_sprache_id '||unistr('\000a')||
'      from sysareas_frgbg'||unistr('\000a')||
'      where id = 5; -- Default App-Sprache'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
''||unistr('\000a')||
'   :p123_page_titel_anmeldung := frgbg_s.holen_uebersetzung(433,:p123_sprache_id);'||unistr('\000a')||
'   :P123_PAGE_TITEL_HINWEIS:=frgbg_s';

p:=p||'.holen_uebersetzung(3786,:p123_sprache_id);'||unistr('\000a')||
'   :p123_bl_anonym_login := frgbg_s.holen_uebersetzung(739,:p123_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3587002938630382 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Anlegen eines Anonymen Kunden'||unistr('\000a')||
'   v_return := frgbg_s.GEN_PERSONENSTAMM_ANONYM(:p123_app_sprache_id);'||unistr('\000a')||
'   IF v_return <= 0 THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(4892,:p123_sprache_id)||'||unistr('\000a')||
'                                  '' [GEN_PERSONENSTAMM_ANONYM,''||v_return||'']! '';'||unistr('\000a')||
'      ';

p:=p||'mel.p(v_fehlertext,v_prot_id,''ERROR'',''frgbg_s.gen_personenstamm_anonym'');'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(4892,:p123_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'         '||unistr('\000a')||
'   -- Holen username/password fürs Login'||unistr('\000a')||
'   BEGIN   '||unistr('\000a')||
'      SELECT user_account, passwort '||unistr('\000a')||
'      INTO :p123_username, :p123_password'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE ID = v_return;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THE';

p:=p||'N'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(4892,:p123_sprache_id)||'||unistr('\000a')||
'                                  '' [GEN_PERSONENSTAMM_ANONYM,-99]''||''! ''||SQLERRM;'||unistr('\000a')||
'      mel.p(v_fehlertext,v_prot_id,''ERROR'',''frgbg_s.gen_personenstamm_anonym'');'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20001,frgbg_s.holen_uebersetzung(4892,:p123_sprache_id));'||unistr('\000a')||
'   END;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3588417383630386 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 123,
  p_process_sequence=> 10,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'anonymer_user_erstellen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>3585227728630373 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 123
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00124
prompt  ...PAGE 124: Anmelden FB-Endkunde
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 124
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Anmelden FB-Endkunde'
 ,p_step_title => 'Anmelden FB-Endkunde'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Anmelden Gutschein-Endkunde'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2882731585489434 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'Y'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909144936'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3624809061653245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 124,
  p_plug_name=> '&P124_PAGE_TITEL_ANMELDUNG.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3627612401653248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 124,
  p_plug_name=> '&P124_PAGE_TITEL_HINWEIS.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890721784489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => 'frgbg_s.holen_uebersetzung(10,:p124_sprache_id) !=''.''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3631324950653257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:106:&SESSION.::&DEBUG.:106:P106_USER_ACCOUNT,P106_SPRACHE_ID,P106_ZURUECK_SEITE:&P124_USERNAME.,&P124_SPRACHE_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 5,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p124_hinweis_pw is null and :request = ''PASSWORT''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 29-MAR-2011 12:56 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3631532627653257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:124:&SESSION.:PW_HINWEIS:&DEBUG.:124:P124_HINWEIS_PW:&P124_HINWEIS_PW.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'NEVER',
  p_branch_condition=> ':p124_hinweis_pw is not null and :request = ''PASSWORT''',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 31-MAR-2011 09:56 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>3631127304653256 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:124::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 28-AUG-2007 11:09 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3625024600653245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_WARTUNG_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 181,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wartung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3625200610653245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_BL_PASSWORT_VERGESSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3625414342653245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_PAGE_TITEL_ANMELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3625606238653245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3625810716653247 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_BL_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3626011118653247 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_USERNAME',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_KUNDE"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3626217781653247 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_PASSWORD',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_KUNDE"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_PASSWORD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 40,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_encrypt_session_state_yn=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3626418586653247 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_LOGIN',
  p_data_type=> '',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> '',
  p_item_default=> 'LOGIN',
  p_prompt=>'&P124_BL_LOGIN.',
  p_source=>'LOGIN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'S',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3626603645653247 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_LOGIN_KUNDE"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT s.sprache, s.id'||unistr('\000a')||
'FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'order by 1'||unistr('\000a')||
''||unistr('\000a')||
'/*SELECT sprache, '||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, pers_optionen po , optionstypen ot    /* Subsetzugriff * /'||unistr('\000a')||
'where po.opttyp_id = ot.id  /* JOIN OT * /'||unistr('\000a')||
'  and ot.art = 1        /* Subset * /'||unistr('\000a')||
'  and po.opttyp_id = 23  /* Sprachen * /'||unistr('\000a')||
'  and ow.id = po.wert'||unistr('\000a')||
'  /* Persid des Subsets sonst null * /'||unistr('\000a')||
'  and po.persstamm_id = :p124_pers_opt_persstamm_id '||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Appsprachen (statt Optionswerte), da keine Subsetdef. od. da Def.wertverwaltg* /'||unistr('\000a')||
'SELECT sprache,'||unistr('\000a')||
'       ow.id b'||unistr('\000a')||
'FROM app_sprachen ow, optionstypen ot'||unistr('\000a')||
'where ot.id = 23 /* Sprachen* /'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden* /'||unistr('\000a')||
'       :p124_pers_opt_persstamm_id  IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset * /'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1  '||unistr('\000a')||
'*/',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3626832493653247 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_APP_SPRACHE_ID_PARAM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'App Sprache Id Param',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3627008438653248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_PAGE_TITEL_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 141,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Hinweis',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3627212546653248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_PASSWORT_VERGESSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 31,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'PASSWORT',
  p_prompt=>'&P124_BL_PASSWORT_VERGESSEN.',
  p_source=>'PASSWORT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3627427881653248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_HINWEIS_PW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 3624809061653245+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3627814410653248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 124,
  p_name=>'P124_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 171,
  p_item_plug_id => 3627612401653248+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(10,:p124_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 70,
  p_cMaxlength=> 2000,
  p_cHeight=> 5,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3628100736653250 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_wartung',
  p_validation_sequence=> 5,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_text   varchar2(4000);'||unistr('\000a')||
'   v_liste  varchar2(4000);'||unistr('\000a')||
'   v_flag   NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p124_wartung_flag := 0;'||unistr('\000a')||
'   SELECT to_number(parameter) INTO v_flag'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 10;'||unistr('\000a')||
'   SELECT parameter INTO v_liste'||unistr('\000a')||
'   FROM sysareas_frgbg'||unistr('\000a')||
'   WHERE id = 11;'||unistr('\000a')||
'--mel.p(''Wartungsflag:%1, Text %2'',v_prot_id,''INFO'',''FAS102/121: check_wartung'',v_flag,:P124_HINWEIS);'||unistr('\000a')||
'   IF v_flag = 1 and  -- Generelles Wartungsflag'||unistr('\000a')||
'      -- Check USER, die während der Wartung arbeiten dürfen '||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:p124_username)||'';'') = 0 and  '||unistr('\000a')||
'      -- Check Applikation, die gewartet werden'||unistr('\000a')||
'      instr(UPPER(v_liste),'';''||UPPER(:APP_ID)||'';'') = 0    '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p124_wartung_flag := 1;'||unistr('\000a')||
'      v_text := frgbg_s.holen_uebersetzung(10,:p124_sprache_id);'||unistr('\000a')||
'      IF v_text is null or v_text = ''.'' THEN'||unistr('\000a')||
'         v_text := ''System is not available because of system maintaince! Please try again later.'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      RETURN v_text;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p124_wartung_flag := 0;'||unistr('\000a')||
'      RETURN null;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3628320730653250 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_gueltiges_login',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz_login        personenstamm.login_fehlversuche%TYPE;'||unistr('\000a')||
'   v_anz_max_login    personenstamm.login_fehlversuche%TYPE;'||unistr('\000a')||
'   v_personenstamm_id personenstamm.id%TYPE;'||unistr('\000a')||
'   v_betreuer         personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_fas_schema_id_pers  pers_identitaet_props.fas_schema_id%TYPE;'||unistr('\000a')||
'   v_gutscheinstatus  personenstamm.gutscheinstatus%TYPE;'||unistr('\000a')||
'   v_gutscheinanzahl  personenstamm.gutscheinanzahl%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'   v_prot_id          number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Sperren des Betreuer-Logins nach n Fehlversuchen'||unistr('\000a')||
'   :p124_username:=TRIM(UPPER (:p124_username));'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT NVL(min(parameter),10) INTO v_anz_max_login'||unistr('\000a')||
'      FROM sysareas_frgbg'||unistr('\000a')||
'      WHERE id = 4;'||unistr('\000a')||
'      SELECT login_fehlversuche,id,betreuer,'||unistr('\000a')||
'             gutscheinstatus,gutscheinanzahl'||unistr('\000a')||
'      INTO v_anz_login, v_personenstamm_id, v_betreuer,'||unistr('\000a')||
'           v_gutscheinstatus, v_gutscheinanzahl'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE user_account = TRIM(UPPER (:p124_username));'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN '||unistr('\000a')||
'       NULL;'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   IF v_anz_login >= 9999.001 THEN'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(3830,:p124_sprache_id));'||unistr('\000a')||
'   ELSIF v_anz_login >= v_anz_max_login THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(477,:p124_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Schema-Prüfung'||unistr('\000a')||
'   v_fas_schema_id_pers := frgbg_s.get_fas_schema_liste(v_personenstamm_id,''KUNDE'');'||unistr('\000a')||
'   IF instr(v_fas_schema_id_pers,'';''||:fas_schema_id||'';'')>0 THEN'||unistr('\000a')||
'      NULL; -- alles ok'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p124_sprache_id));   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'MEL.P (''LOGIN-Protokoll: Pers:%1, Schema:%2|%3, aufgerufen:%4, Fas_modus:%5, User:%6, PW:%7,Client-Host:%8,App-Sprache:%9'', v_PROT_ID, ''Info'',''check gültiges Login'',v_personenstamm_id, v_fas_schema_id_pers,:fas_schema_id,:fas_aufgerufen_von,:fas_modus_id,:p124_username,:p124_password,owa_util.get_cgi_env(''REMOTE_ADDR''),:p124_app_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   IF instr(v_fas_schema_id_pers,'';''||:fas_schema_id||'';'')>0 THEN'||unistr('\000a')||
'      NULL; -- alles ok'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p124_sprache_id));   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Pruefen, ob der User für das Gutschein-Verfahren registriert ist und '||unistr('\000a')||
'   -- die Identität für das Gutscheinverfahren zugelassen ist'||unistr('\000a')||
'   IF v_gutscheinstatus = 0 OR -- User für das Gutschein-Verfahren registriert'||unistr('\000a')||
'      -- Gutschein-Verfahren der Identität aktiv                   '||unistr('\000a')||
'      frgbg_s.check_fas_rolle('||unistr('\000a')||
'         UPPER (:p124_username),'||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'','||unistr('\000a')||
'         frgbg_s.GET_IDENTITAET_KUNDE(NULL,-1,v_personenstamm_id)) = 0'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehlermeldung: Für Gutscheinverfahren nicht zugelassen'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(4897,:p124_sprache_id));   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   IF frgbg_s.VALID_USER (:p124_username,:p124_password) '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET app_sprache_id = :p124_app_sprache_id,'||unistr('\000a')||
'             login_fehlversuche = 0'||unistr('\000a')||
'         WHERE id = v_personenstamm_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN OTHERS THEN '||unistr('\000a')||
'          NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET login_fehlversuche = login_fehlversuche +1'||unistr('\000a')||
'         WHERE id = v_personenstamm_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN OTHERS THEN '||unistr('\000a')||
'          NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(476,:p124_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request not in  (''PASSWORT'') and       '||unistr('\000a')||
':p124_wartung_flag = 0',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3628515021653251 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_neues_pw',
  p_validation_sequence=> 20,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_PERSSTAMM_ID_MAILABSENDER personenstamm.id%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID personenstamm.id%TYPE;'||unistr('\000a')||
'   v_betreuer     personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_email     personenstamm.email%TYPE;'||unistr('\000a')||
'   v_anz_login number;'||unistr('\000a')||
'   v_return    NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p124_username IS NULL THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(447,:p124_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT login_fehlversuche,id, email, betreuer'||unistr('\000a')||
'      INTO v_anz_login, v_persstamm_id,v_email, v_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE user_account = UPPER (:p124_username);'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      -- Fehler Benutzer ist unbekannt!'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(446,:p124_sprache_id);'||unistr('\000a')||
'      RETURN (v_fehlertext);'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   IF v_email is null'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3935,:p124_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF v_anz_login != round(v_anz_login) '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Fehler beim Aufbereiten der Passwort-Mail für Benutzer %1!.....'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3937,:p124_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   Return v_fehlertext;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 3627212546653248 + wwv_flow_api.g_id_offset,
  p_associated_item=> 3626011118653247 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'owa_util.mime_header(''text/html'', FALSE);'||unistr('\000a')||
'owa_cookie.send('||unistr('\000a')||
'    name=>''FAS_LOGIN_USERNAME_COOKIE'','||unistr('\000a')||
'    --value=>lower(:P124_USERNAME));-- NEI 09.01.2013 Umlauteproblem'||unistr('\000a')||
'    value=>utl_url.escape(lower(:P124_USERNAME), true,''AL32UTF8'')); '||unistr('\000a')||
'owa_cookie.send('||unistr('\000a')||
'    name=>''FAS_SPRACHE_COOKIE'','||unistr('\000a')||
'    value=>:P124_APP_SPRACHE_ID);'||unistr('\000a')||
'exception when others then null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3628817769653253 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Benutzername-Cookie festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_betreuer  personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :fas_aufgerufen_von := ''KUNDE'';'||unistr('\000a')||
'   :fas_login_page := :APP_PAGE_ID;'||unistr('\000a')||
'   :fas_sprache_id:= :p124_sprache_id;'||unistr('\000a')||
''||unistr('\000a')||
'wwv_flow_custom_auth_std.login('||unistr('\000a')||
'    P_UNAME       => v(''P124_USERNAME''),'||unistr('\000a')||
'    P_PASSWORD    => v(''P124_PASSWORD''),'||unistr('\000a')||
'    P_SESSION_ID  => v(''APP_SESSION''),'||unistr('\000a')||
'    --P_FLOW_PAGE   => :APP_ID||'':110:&APP_SESSION.::NO:';

p:=p||':P110_AUFGERUFEN_VON:ANONYM'''||unistr('\000a')||
'    P_FLOW_PAGE   => :APP_ID||'':112:''|| v(''APP_SESSION'')||'':BRANCH_TO_PAGE_ACCEPT'''||unistr('\000a')||
''||unistr('\000a')||
'    );'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3629002807653253 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Login',
  p_process_sql_clob => p,
  p_process_error_message=> 'Ungültiges Login',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 3629202205653253 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'',''P124_APP_SPRACHE_ID'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'12151422924614296';

wwv_flow_api.create_page_process(
  p_id     => 3629429529653253 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'init_scrollregion_height',
  p_process_sql_clob => 12151422924614296 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   SELECT id INTO :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE user_account = TRIM(UPPER (:p124_username));'||unistr('\000a')||
''||unistr('\000a')||
'/*   SELECT  ''(''||NAME||''/''||userenv(''sessionid'')||'')'' INTO :FAS_IDENTITAET'||unistr('\000a')||
'   FROM PERSONENSTAMM'||unistr('\000a')||
'   WHERE id = :FAS_LOGIN_PERSONENSTAMM_ID;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- Identität in persarea sessionabhängig ablegen'||unistr('\000a')||
'   /*SELECT sid, osuser into v_session, v_user from v$session where audsid ';

p:=p||'= userenv(''sessionid'');*/'||unistr('\000a')||
'   INSERT INTO persareas (personenstamm_id,AKT_PERSSTAMM_ID_IDENTITAET, session_id )'||unistr('\000a')||
'   VALUES (:FAS_LOGIN_PERSONENSTAMM_ID, :FAS_IDENTITAET_PERSSTAMM_ID,userenv(''sessionid''));'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN '||unistr('\000a')||
'    NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3629610636653253 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'FAS_LOGIN_PERS_ID_SETZEN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2887904124092079';

wwv_flow_api.create_page_process(
  p_id     => 3629812809653253 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'init_fas_session',
  p_process_sql_clob => 2887904124092079 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''PASSWORT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz      NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN   '||unistr('\000a')||
'/*MEL.P (''1 Schema setzen:%1, pers %2, url %3'','||unistr('\000a')||
'           v_prot_id,''TEST'',''102/124 init_fas_schema_fas_modus'','||unistr('\000a')||
'           :fas_schema_id,:fas_schema_persstamm_id, owa_util.get_cgi_env(''server_name'')'||unistr('\000a')||
'          );      '||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'   IF :fas_schema_id is NULL THEN'||unistr('\000a')||
'      :fas_schema_id := frgbg_s.get_fas_schema_srv;'||unistr('\000a')||
'   ELSE -- Check gültiges Sch';

p:=p||'emaangabe?'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT count(*) INTO v_anz'||unistr('\000a')||
'         FROM fas_schemas'||unistr('\000a')||
'         WHERE id = :fas_schema_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'          v_anz := 0;'||unistr('\000a')||
'      END ;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_anz = 0 THEN -- FAlls ungültig über Servername ermitteln'||unistr('\000a')||
'         :fas_schema_id := frgbg_s.get_fas_schema_srv;           '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--mel.p(''Schema setzen:''||:fas_schema_id,v_pro';

p:=p||'t_id,''TEST'',''102/124 init_fas_schema_fas_modus init_fas_schema_fas_modus P124'');'||unistr('\000a')||
'   :fas_schema_id := NVL(:fas_schema_id ,1); -- Standardschema, falls keins ermittelt wurde'||unistr('\000a')||
''||unistr('\000a')||
'   :FAS_THEME_NAME:= ''fas_theme_''||:fas_schema_id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   -- Fas-Modus setzen abhängig vom Schema'||unistr('\000a')||
'   SELECT fas_modus_id into :fas_modus_id'||unistr('\000a')||
'   FROM fas_schemas'||unistr('\000a')||
'   WHERE id = :fas_schema_id;'||unistr('\000a')||
''||unistr('\000a')||
'--MEL.P (''Schema setzen:%1, pers %2';

p:=p||',modus %3'','||unistr('\000a')||
'--           v_prot_id,''TEST'',''102/124 init_fas_schema_fas_modus P124'','||unistr('\000a')||
'--           :fas_schema_id,:fas_schema_persstamm_id,:fas_modus_id);      '||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3630032499653254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_fas_schema_fas_modus',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'    c owa_cookie.cookie;'||unistr('\000a')||
'begin'||unistr('\000a')||
'   '||unistr('\000a')||
'   c := owa_cookie.get(''FAS_LOGIN_USERNAME_COOKIE'');'||unistr('\000a')||
'   :P124_USERNAME := utl_url.unescape(c.vals(1),''AL32UTF8'');'||unistr('\000a')||
''||unistr('\000a')||
'exception when others then null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 3630431738653254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Benutzername-Cookie abrufen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_sprache varchar2(50);'||unistr('\000a')||
'   v_anz        NUMBER;'||unistr('\000a')||
'   c owa_cookie.cookie;'||unistr('\000a')||
'   v_sprache_id NUMBER;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''0 app_sprache_setzen: Appsp %1, sprache %2, appsp param %3, owa %4,pos %5'','||unistr('\000a')||
'           v_prot_id,''TEST'',''Page 121'','||unistr('\000a')||
'           to_char(:p124_app_sprache_id),'||unistr('\000a')||
'           to_char(v_sprache_id),:p124_app_sprache_id_param,'||unistr('\000a')||
'           owa_util.get_cgi_env(''';

p:=p||'HTTP_ACCEPT_LANGUAGE''),'||unistr('\000a')||
'          instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'  IF :p124_app_sprache_id_param IS NULL THEN'||unistr('\000a')||
'     -- Zunaechst aus Cookie                          -- NEI 6.6.11 '||unistr('\000a')||
'     BEGIN                                            '||unistr('\000a')||
'        c := owa_cookie.get(''FAS_SPRACHE_COOKIE'');    '||unistr('\000a')||
'        -- Check, ob Sprache zum Schema passt, sonst Sprache unguelti';

p:=p||'g => Browsersprache'||unistr('\000a')||
'        SELECT count(*) into v_anz'||unistr('\000a')||
'        FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'        WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'          AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'          AND s.id =c.vals(1)'||unistr('\000a')||
'          AND s.aktiv=1;  -- NEI 09.09.2014'||unistr('\000a')||
'        IF v_anz > 0 THEN'||unistr('\000a')||
'           :P124_APP_SPRACHE_ID:= c.vals(1);          '||unistr('\000a')||
'        ELSE'||unistr('\000a')||
'           :P124_APP_SPRACHE_ID:=NULL';

p:=p||';'||unistr('\000a')||
'        END IF;'||unistr('\000a')||
'     exception '||unistr('\000a')||
'     when others then '||unistr('\000a')||
'           :P124_APP_SPRACHE_ID:=NULL;               '||unistr('\000a')||
'     end;                                             -- NEI 6.6.11'||unistr('\000a')||
'     IF :P124_APP_SPRACHE_ID IS NULL THEN             -- NEI 6.6.11 '||unistr('\000a')||
'        -- Browsersprache holen und abgleichen mit App-Sprachen für das Schema'||unistr('\000a')||
'        BEGIN'||unistr('\000a')||
'           v_sprache := NVL(substr(owa_util.get_cgi_env(''HT';

p:=p||'TP_ACCEPT_LANGUAGE''), 1,'||unistr('\000a')||
'                     instr(owa_util.get_cgi_env(''HTTP_ACCEPT_LANGUAGE''),'','')-1),''en'');'||unistr('\000a')||
'        EXCEPTION'||unistr('\000a')||
'        WHEN others THEN'||unistr('\000a')||
'           v_sprache := ''en'';'||unistr('\000a')||
'        END;'||unistr('\000a')||
'        :p124_app_sprache_id := frgbg_s.get_browser_sprache(v_sprache);'||unistr('\000a')||
'     END IF;                                       -- NEI 6.6.11 '||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     :p124_app_sprache_id := :p124_app_sprache_id_param;'||unistr('\000a')||
'';

p:=p||'     :p124_app_sprache_id_param := NULL;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
' '||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''app_sprache_setzen:%1, Browser %2,%3'',v_prot_id,''TEST'',''102/124:app_sprache_setzen'','||unistr('\000a')||
'           :p124_app_sprache_id,'||unistr('\000a')||
'           v_sprache,:fas_schema_persstamm_id'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3628627124653251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'app_sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'Y',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
' --IF :p124_sprache_id is null THEN'||unistr('\000a')||
'   SELECT sprache_id into :p124_sprache_id '||unistr('\000a')||
'   FROM app_sprachen'||unistr('\000a')||
'   WHERE id = :p124_app_sprache_id;'||unistr('\000a')||
' --END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3630626746653254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 35,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'sprache_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p124_bl_login := frgbg_s.holen_uebersetzung(430,:p124_sprache_id);'||unistr('\000a')||
'   :p124_page_titel_anmeldung := frgbg_s.holen_uebersetzung(433,:p124_sprache_id);'||unistr('\000a')||
'   :p124_page_titel_hinweis := frgbg_s.holen_uebersetzung(3786,:p124_sprache_id);'||unistr('\000a')||
'   :P124_BL_PASSWORT_VERGESSEN  := frgbg_s.holen_uebersetzung(429,:p124_sprache_id);'||unistr('\000a')||
'--   :p101_bl_benutzer_vergessen := frgbg_s.';

p:=p||'holen_uebersetzung(432,:p101_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''button_labels_setzen:%1,%2'',v_prot_id,''TEST'',''Page 124'','||unistr('\000a')||
'           to_char(:p124_app_sprache_id),:p124_sprache_id'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3630829125653254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 124,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 124
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00130
prompt  ...PAGE 130: PATIENTENLISTE
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 130
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'PATIENTENLISTE'
 ,p_step_title => 'PATIENTENLISTE'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Betreuerpatientenliste'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150206125024'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3167518004514732 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 130,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT /*distinct*/                              -- Adress-Suche'||unistr('\000a')||
'  p.Geburtsdatum,'||unistr('\000a')||
'  p.PIS_ADRESSE_ID, '||unistr('\000a')||
'  p.suchname,p.suchadresse,p.suchzusatz,'||unistr('\000a')||
'  DECODE(x.fas_betreuer,''N'',frgbg_s.holen_uebersetzung(3578,:fas_sprache_id),'||unistr('\000a')||
'                        ''J'',frgbg_s.holen_uebersetzung(1854,:fas_sprache_id),'||unistr('\000a')||
'                        ''I'',frgbg_s.holen_uebersetzung(3101,:fas_sprache_id)) '||unistr('\000a')||
'         fas_betreue';

s:=s||'r,'||unistr('\000a')||
'  p.PIS_PAT_AKTE_ID,'||unistr('\000a')||
'  CASE WHEN p.extern_verwaltet = 2 THEN  -- NEI 06.02.2015'||unistr('\000a')||
'       p.PERSONENSTAMM_ID ||'' <img src="/i/fas_images/fas_desktop/globus_klein.png">'''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'       p.PERSONENSTAMM_ID ||'' '''||unistr('\000a')||
'  END personenstamm_id_disp,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  WHEN (select count(*) '||unistr('\000a')||
'        from pers_zugriffe pz, pers_betreuer pb'||unistr('\000a')||
'        where pz.PERSSTAMM_ID_BETREUER=:p130_p';

s:=s||'ersonenstamm_id_betreuer'||unistr('\000a')||
'          and pz.PERSSTAMM_ID_BETREUERZUGRIFF = pb.PERSSTAMM_ID_BETREUER'||unistr('\000a')||
'          and pb.persstamm_id=p.PERSONENSTAMM_ID) = 0'||unistr('\000a')||
'      THEN  -- NEI 14.04.14 kein Zugriff auf Patient (keine Schnittmenge zw. pers_betreuer vom Patient und pers_zugriff vom Betreuer)=> kein FB-Rezept'||unistr('\000a')||
'     '' ''  '||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':110:''||:APP_S';

s:=s||'ESSION|| '':::110:''||'||unistr('\000a')||
'   ''P110_PERSON,P110_PIS_PAT_AKTE_ID,P110_PIS_ADRESSE_ID,P110_WAHL_IDENTITAET:'''||unistr('\000a')||
'     ||p.PERSONENSTAMM_ID||'',''||p.PIS_PAT_AKTE_ID'||unistr('\000a')||
'     ||'',''||p.PIS_ADRESSE_ID||'',''||:P130_IDENTITAET) || ''"'' '||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9491,:fas_sprache_id)||'''''')"''  '||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#edit_big.gif"  borde';

s:=s||'r="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END  fb_rezept_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  WHEN frgbg_s.wk_check_zugriff (P.PERSONENSTAMM_ID) = 0  THEN   -- NEI 15.10.13 für Kunde kein WK möglich'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':300:''||:APP_SESSION||''::&DEBUG.:300:''||'||unistr('\000a')||
'     ''P300_PERSSTAMM_ID,P300_ZURUECK_SEITE,P300_WAHL_IDENTITAET,P300_WK_ARTIKELTYP';

s:=s||'_FLAG:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID||'',''||:APP_PAGE_ID||'',''||:P130_IDENTITAET||'',2'')|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9492,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END wk_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREP';

s:=s||'ARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':300:''||:APP_SESSION||''::&DEBUG.:300:''||'||unistr('\000a')||
'     ''P300_PERSSTAMM_ID,P300_ZURUECK_SEITE,P300_WAHL_IDENTITAET,P300_WK_ARTIKELTYP_FLAG:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID||'',''||:APP_PAGE_ID||'',''||:P130_IDENTITAET||'',1'')|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9493,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMA';

s:=s||'GE_PREFIX#fndirqd.gif"x border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END wklabor_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 OR        -- nicht betreuerart 1,2 '||unistr('\000a')||
'            P.PERSONENSTAMM_ID is NULL  -- Kein FAS Patient '||unistr('\000a')||
'  THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':141:''||:APP_SESSION||''::&DEBUG.:141:''||'||unistr('\000a')||
'     ''P141_PERSONENSTAMM_ID:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID)|| ''"'''||unistr('\000a')||
'     ||'' o';

s:=s||'nmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9494,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#print06.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END direktdruck_link,'||unistr('\000a')||
'  x.fas_gus_id,'||unistr('\000a')||
'  frgbg_s.GET_PERS_ADRESSE(frgbg_s.get_identitaet_kunde(NULL,-1,p.PERSONENSTAMM_ID)) persstamm_id_ident_name'||unistr('\000a')||
'FROM personenlisten x, v_perslisten_betreuer p '||unistr('\000a')||
'where ';

s:=s||':p130_patliste_anzeigen = 1    -- Suche gestartet'||unistr('\000a')||
'  and :p130_suchart = 0              -- Adress-Suche'||unistr('\000a')||
'  and p.id = x.id'||unistr('\000a')||
'  and '||unistr('\000a')||
'     (:p130_identitaet = 0 AND :P130_PATIENTENMASTERZUGRIFF=0 AND p.personenstamm_id_betreuer in '||unistr('\000a')||
'           (SELECT pz.persstamm_id_betreuerzugriff '||unistr('\000a')||
'            FROM pers_zugriffe pz'||unistr('\000a')||
'            WHERE pz.persstamm_id_betreuer = :p130_personenstamm_id_betreuer'||unistr('\000a')||
'           ';

s:=s||'   AND (:p130_patientenzugriff = 0      /* NEI 11.01.10 Stdzugriff*/'||unistr('\000a')||
'                   and p.betreuerart in (1,2)/* damit beim IABC-Master seine'||unistr('\000a')||
'                            angelegten Betreuer (art=5) nicht doppelt kommen */'||unistr('\000a')||
'                  OR'||unistr('\000a')||
'                   :p130_patientenzugriff = 1 AND  /* IABC-Betreuerzugriff */'||unistr('\000a')||
'                   pz.persstamm_id_betreuer = pz.persstamm_id_betreuerzugri';

s:=s||'ff '||unistr('\000a')||
'                  )'||unistr('\000a')||
'           )'||unistr('\000a')||
'      OR :p130_identitaet != 0 AND p.personenstamm_id_betreuer = :p130_identitaet'||unistr('\000a')||
'      OR :p130_identitaet = 0 AND :P130_PATIENTENMASTERZUGRIFF=1       -- NEI 14.04.2014 Patientmasterzugriff'||unistr('\000a')||
'      )'||unistr('\000a')||
'  '||unistr('\000a')||
'--  AND (x.normname  like ''%''||OTA_SYNCH.OTA_NORMSTRING(:p130_suchname,2)||''%'' '||unistr('\000a')||
'  AND (x.normname  like ''%''||:p130_suchname_norm||''%'' '||unistr('\000a')||
'       OR :p130_suchname ';

s:=s||'IS NULL)'||unistr('\000a')||
'  AND (UPPER(p.suchadresse) like ''%''||UPPER(:p130_suchadresse)||''%'' '||unistr('\000a')||
'       OR :p130_suchadresse IS NULL)'||unistr('\000a')||
'  AND ((UPPER(p.suchzusatz) like ''%''||UPPER(:p130_suchzusatz)||''%'' '||unistr('\000a')||
'             and p.personenstamm_id is not null) -- nur dann gibts suchzusatz'||unistr('\000a')||
'       OR :p130_suchzusatz IS NULL)'||unistr('\000a')||
'  AND (x.fas_persstamm_id = :p130_such_persstamm_id'||unistr('\000a')||
'       OR :P130_SUCH_PERSSTAMM_ID IS NULL)'||unistr('\000a')||
'  AND (t';

s:=s||'rim(to_char(x.pis_adresse_id)) = :p130_such_pis_id OR x.fas_gus_id = :p130_such_pis_id'||unistr('\000a')||
'       OR :p130_such_pis_id IS NULL)'||unistr('\000a')||
'  /* NEI 12.12.12 Nur noch Endkunden in der Liste wg. GUS'||unistr('\000a')||
'  AND (x.fas_betreuer = :p130_typ OR NVL(:p130_typ,''%'') = ''%'')  -- Betreuertyp'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND x.fas_betreuer = ''N''           -- NEI 12.12.12'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT --distinct                                            -- Rezept-Suc';

s:=s||'he mit Rezeptnr'||unistr('\000a')||
'  p.Geburtsdatum,'||unistr('\000a')||
'  p.PIS_ADRESSE_ID, '||unistr('\000a')||
'  p.suchname,p.suchadresse,p.suchzusatz,x.fas_betreuer,'||unistr('\000a')||
'  p.PIS_PAT_AKTE_ID,'||unistr('\000a')||
'  --p.PERSONENSTAMM_ID personenstamm_id_disp,'||unistr('\000a')||
'  CASE WHEN p.extern_verwaltet = 2 THEN  -- NEI 06.02.2015'||unistr('\000a')||
'       p.PERSONENSTAMM_ID ||''*'''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'       p.PERSONENSTAMM_ID ||'' '''||unistr('\000a')||
'  END personenstamm_id_disp,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  WHEN (select coun';

s:=s||'t(*) '||unistr('\000a')||
'        from pers_zugriffe pz, pers_betreuer pb'||unistr('\000a')||
'        where pz.PERSSTAMM_ID_BETREUER=:p130_personenstamm_id_betreuer'||unistr('\000a')||
'          and pz.PERSSTAMM_ID_BETREUERZUGRIFF = pb.PERSSTAMM_ID_BETREUER'||unistr('\000a')||
'          and pb.persstamm_id=p.PERSONENSTAMM_ID) = 0'||unistr('\000a')||
'      THEN  -- NEI 14.04.14 kein Zugriff auf Patient (keine Schnittmenge zw. pers_betreuer vom Patient und pers_zugriff vom Betreuer)=> kein FB-Reze';

s:=s||'pt'||unistr('\000a')||
'     '' ''  '||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':110:''||:APP_SESSION|| ''::&DEBUG.::''||'||unistr('\000a')||
'   ''P110_PERSON,P110_PIS_PAT_AKTE_ID,P110_PIS_ADRESSE_ID,P110_WAHL_IDENTITAET:'''||unistr('\000a')||
'     ||p.PERSONENSTAMM_ID||'',''||p.PIS_PAT_AKTE_ID'||unistr('\000a')||
'     ||'',''||p.PIS_ADRESSE_ID||'',''||:P130_IDENTITAET)  ||   ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebe';

s:=s||'rsetzung(9491,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#edit_big.gif"  border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END  fb_rezept_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  WHEN frgbg_s.wk_check_zugriff (P.PERSONENSTAMM_ID) = 0 THEN  -- NEI 15.10.13 für Kunde kein WK möglich'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':300:''||:APP_SESSION|';

s:=s||'|''::&DEBUG.:300:''||'||unistr('\000a')||
'     ''P300_PERSSTAMM_ID,P300_ZURUECK_SEITE,P300_WAHL_IDENTITAET,P300_WK_ARTIKELTYP_FLAG:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID||'',''||:APP_PAGE_ID||'',''||:P130_IDENTITAET||'',2'')|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9492,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</';

s:=s||'a>'''||unistr('\000a')||
'  END wk_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':300:''||:APP_SESSION||''::&DEBUG.:300:''||'||unistr('\000a')||
'     ''P300_PERSSTAMM_ID,P300_ZURUECK_SEITE,P300_WAHL_IDENTITAET,P300_WK_ARTIKELTYP_FLAG:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID||'',''||:APP_PAGE_ID||'',''||:P130_IDENTITAET||'',1'')|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,';

s:=s||'this,''''''||frgbg_s.holen_uebersetzung(9493,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndirqd.gif"x border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END wklabor_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 OR       -- nicht betreuerart 1,2 '||unistr('\000a')||
'            P.PERSONENSTAMM_ID is NULL -- Kein FAS Patient'||unistr('\000a')||
'  THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':141:''||:APP_SE';

s:=s||'SSION||''::&DEBUG.:141:''||'||unistr('\000a')||
'     ''P141_PERSONENSTAMM_ID:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID)|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9492,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#print06.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END direktdruck_link,'||unistr('\000a')||
'  x.fas_gus_id,'||unistr('\000a')||
'  frgbg_s.GET_PERS_ADRESSE(frgbg_s.get_identitaet_kunde(NULL,-1,';

s:=s||'p.PERSONENSTAMM_ID)) '||unistr('\000a')||
'FROM personenlisten x,v_perslisten_betreuer p, mn_rezepte m  '||unistr('\000a')||
'where :p130_patliste_anzeigen = 1    -- Suche gestartet'||unistr('\000a')||
'  and :p130_suchart = 1              -- Rezept-Suche mit Rezeptnr'||unistr('\000a')||
'  and p.id = x.id'||unistr('\000a')||
'  and  '||unistr('\000a')||
'     (:p130_identitaet = 0 AND :P130_PATIENTENMASTERZUGRIFF=0 AND p.personenstamm_id_betreuer in '||unistr('\000a')||
'           (SELECT pz.persstamm_id_betreuerzugriff '||unistr('\000a')||
'            FROM p';

s:=s||'ers_zugriffe pz'||unistr('\000a')||
'            WHERE pz.persstamm_id_betreuer = :p130_personenstamm_id_betreuer'||unistr('\000a')||
'              AND (:p130_patientenzugriff = 0 AND  /* NEI 11.01.10 Stdzugriff*/'||unistr('\000a')||
'                   p.betreuerart in (1,2)     /* damit beim IABC-Master seine'||unistr('\000a')||
'                            angelegten Betreuer (art=5) nicht doppelt kommen */ '||unistr('\000a')||
'                   OR'||unistr('\000a')||
'                   :p130_patientenzugriff = 1 ';

s:=s||'AND  /* IABC-Betreuerzugriff */'||unistr('\000a')||
'                   pz.persstamm_id_betreuer = pz.persstamm_id_betreuerzugriff '||unistr('\000a')||
'                  )'||unistr('\000a')||
'           )'||unistr('\000a')||
'      OR :p130_identitaet != 0 AND p.personenstamm_id_betreuer = :p130_identitaet'||unistr('\000a')||
'      OR :p130_identitaet = 0 AND :P130_PATIENTENMASTERZUGRIFF=1         -- NEI 14.04.2014 Patientmasterzugriff'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and p.personenstamm_id = m.personenstamm_id   -- rez';

s:=s||'ept-join'||unistr('\000a')||
'  and m.rezept_nr = :p130_suchrezept_nr'||unistr('\000a')||
'  and :p130_suchrezept_nr IS not NULL'||unistr('\000a')||
'  and (UPPER(m.bemerkung) like ''%''||UPPER(:p130_suchrezeptbemerkung)||''%'' '||unistr('\000a')||
'        OR :p130_suchrezeptbemerkung IS NULL)'||unistr('\000a')||
'  /* NEI 12.12.12 Nur noch Endkunden in der Liste wg. GUS'||unistr('\000a')||
'  AND (x.fas_betreuer = :p130_typ OR NVL(:p130_typ,''%'') = ''%'')  -- Betreuertyp'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND x.fas_betreuer = ''N''           -- NEI 12.12.';

s:=s||'12'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT --distinct                                    -- Rezept-Suche ohne Rezeptnr'||unistr('\000a')||
'  p.Geburtsdatum,'||unistr('\000a')||
'  p.PIS_ADRESSE_ID, '||unistr('\000a')||
'  p.suchname,p.suchadresse,p.suchzusatz,x.fas_betreuer,'||unistr('\000a')||
'  p.PIS_PAT_AKTE_ID,'||unistr('\000a')||
'  --p.PERSONENSTAMM_ID personenstamm_id_disp,'||unistr('\000a')||
'  CASE WHEN p.extern_verwaltet = 2 THEN  -- NEI 06.02.2015'||unistr('\000a')||
'       p.PERSONENSTAMM_ID ||''*'''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'       p.PERSONENSTAMM_ID ||'' '''||unistr('\000a')||
'  END personens';

s:=s||'tamm_id_disp,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  WHEN (select count(*) '||unistr('\000a')||
'        from pers_zugriffe pz, pers_betreuer pb'||unistr('\000a')||
'        where pz.PERSSTAMM_ID_BETREUER=:p130_personenstamm_id_betreuer'||unistr('\000a')||
'          and pz.PERSSTAMM_ID_BETREUERZUGRIFF = pb.PERSSTAMM_ID_BETREUER'||unistr('\000a')||
'          and pb.persstamm_id=p.PERSONENSTAMM_ID) = 0'||unistr('\000a')||
'      THEN  -- NEI 14.04.14 kein Zugriff auf Patient (keine Schnittmeng';

s:=s||'e zw. pers_betreuer vom Patient und pers_zugriff vom Betreuer)=> kein FB-Rezept'||unistr('\000a')||
'     '' ''  '||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':110:''||:APP_SESSION|| ''::&DEBUG.::''||'||unistr('\000a')||
'   ''P110_PERSON,P110_PIS_PAT_AKTE_ID,P110_PIS_ADRESSE_ID,P110_WAHL_IDENTITAET:'''||unistr('\000a')||
'     ||p.PERSONENSTAMM_ID||'',''||p.PIS_PAT_AKTE_ID'||unistr('\000a')||
'     ||'',''||p.PIS_ADRESSE_ID||'',''||:P130_IDENTITAET)  || ''"'''||unistr('\000a')||
'     ||';

s:=s||''' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9491,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#edit_big.gif"  border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END  fb_rezept_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  WHEN frgbg_s.wk_check_zugriff (P.PERSONENSTAMM_ID) = 0 THEN  -- NEI 15.10.13 für Kunde kein WK möglich'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a h';

s:=s||'ref="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':300:''||:APP_SESSION||''::&DEBUG.:300:''||'||unistr('\000a')||
'     ''P300_PERSSTAMM_ID,P300_ZURUECK_SEITE,P300_WAHL_IDENTITAET,P300_WK_ARTIKELTYP_FLAG:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID||'',''||:APP_PAGE_ID||'',''||:P130_IDENTITAET||'',2'')|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9492,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
' ';

s:=s||'    || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'' '||unistr('\000a')||
'  END wk_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':300:''||:APP_SESSION||''::&DEBUG.:300:''||'||unistr('\000a')||
'     ''P300_PERSSTAMM_ID,P300_ZURUECK_SEITE,P300_WAHL_IDENTITAET,P300_WK_ARTIKELTYP_FLAG:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID||'',''||:APP_PAGE_ID||'',''||:P130_ID';

s:=s||'ENTITAET||'',1'')|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9493,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndirqd.gif"x border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END wklabor_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 OR       -- nicht betreuerart 1,2 '||unistr('\000a')||
'            P.PERSONENSTAMM_ID is NULL -- Kein FAS Patient'||unistr('\000a')||
'  THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'   ';

s:=s||'  ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':141:''||:APP_SESSION||''::&DEBUG.:141:''||'||unistr('\000a')||
'     ''P141_PERSONENSTAMM_ID:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID)|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9494,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#print06.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END direktdruck_link,'||unistr('\000a')||
'  x.';

s:=s||'fas_gus_id,'||unistr('\000a')||
'  frgbg_s.GET_PERS_ADRESSE(frgbg_s.get_identitaet_kunde(NULL,-1,p.PERSONENSTAMM_ID)) '||unistr('\000a')||
'FROM personenlisten x,v_perslisten_betreuer p, mn_rezepte m '||unistr('\000a')||
'where :p130_patliste_anzeigen = 1    -- Suche gestartet'||unistr('\000a')||
'  and :p130_suchart = 1              -- Rezept-Suche ohne Rezeptnr'||unistr('\000a')||
'  and p.id = x.id'||unistr('\000a')||
'  and  '||unistr('\000a')||
'     (:p130_identitaet = 0 AND :P130_PATIENTENMASTERZUGRIFF=0 AND p.personenstamm_id_betreue';

s:=s||'r in '||unistr('\000a')||
'           (SELECT pz.persstamm_id_betreuerzugriff '||unistr('\000a')||
'            FROM pers_zugriffe pz'||unistr('\000a')||
'            WHERE pz.persstamm_id_betreuer = :p130_personenstamm_id_betreuer'||unistr('\000a')||
'              AND (:p130_patientenzugriff = 0 AND  /* NEI 11.01.10 Stdzugriff*/'||unistr('\000a')||
'                   p.betreuerart in (1,2)     /* damit beim IABC-Master seine'||unistr('\000a')||
'                            angelegten Betreuer (art=5) nicht doppelt kom';

s:=s||'men */ '||unistr('\000a')||
'                   OR'||unistr('\000a')||
'                   :p130_patientenzugriff = 1 AND  /* IABC-Betreuerzugriff */'||unistr('\000a')||
'                   pz.persstamm_id_betreuer = pz.persstamm_id_betreuerzugriff '||unistr('\000a')||
'                  )'||unistr('\000a')||
'           )'||unistr('\000a')||
'      OR :p130_identitaet != 0 AND p.personenstamm_id_betreuer = :p130_identitaet'||unistr('\000a')||
'      OR :p130_identitaet = 0 AND :P130_PATIENTENMASTERZUGRIFF=1         -- NEI 14.04.2014 Patient';

s:=s||'masterzugriff'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and p.personenstamm_id = m.personenstamm_id   -- rezept-join'||unistr('\000a')||
'  and :p130_suchrezept_nr IS NULL'||unistr('\000a')||
'  and (UPPER(m.bemerkung) like ''%''||UPPER(:p130_suchrezeptbemerkung)||''%'' '||unistr('\000a')||
'        OR :p130_suchrezeptbemerkung IS NULL)'||unistr('\000a')||
'  /* NEI 12.12.12 Nur noch Endkunden in der Liste wg. GUS'||unistr('\000a')||
'  AND (x.fas_betreuer = :p130_typ OR NVL(:p130_typ,''%'') = ''%'')  -- Betreuertyp'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND x.fas_betreu';

s:=s||'er = ''N''           -- NEI 12.12.12'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT /*distinct*/                          /* Komplettlistensuche */'||unistr('\000a')||
'  p.Geburtsdatum,'||unistr('\000a')||
'  p.PIS_ADRESSE_ID, '||unistr('\000a')||
'  p.suchname,p.suchadresse,p.suchzusatz,'||unistr('\000a')||
'  DECODE(x.fas_betreuer,''N'',frgbg_s.holen_uebersetzung(3578,:fas_sprache_id),'||unistr('\000a')||
'                        ''J'',frgbg_s.holen_uebersetzung(1854,:fas_sprache_id),'||unistr('\000a')||
'                        ''I'',frgbg_s.holen_uebersetzu';

s:=s||'ng(3101,:fas_sprache_id)) '||unistr('\000a')||
'         fas_betreuer,'||unistr('\000a')||
'  p.PIS_PAT_AKTE_ID,'||unistr('\000a')||
'  --p.PERSONENSTAMM_ID personenstamm_id_disp,'||unistr('\000a')||
'  CASE WHEN p.extern_verwaltet = 2 THEN  -- NEI 06.02.2015'||unistr('\000a')||
'       p.PERSONENSTAMM_ID ||''*'''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'       p.PERSONENSTAMM_ID ||'' '''||unistr('\000a')||
'  END personenstamm_id_disp,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  WHEN (select count(*) '||unistr('\000a')||
'        from pers_zugriffe pz, pers_betreuer pb'||unistr('\000a')||
'       ';

s:=s||' where pz.PERSSTAMM_ID_BETREUER=:p130_personenstamm_id_betreuer'||unistr('\000a')||
'          and pz.PERSSTAMM_ID_BETREUERZUGRIFF = pb.PERSSTAMM_ID_BETREUER'||unistr('\000a')||
'          and pb.persstamm_id=p.PERSONENSTAMM_ID) = 0'||unistr('\000a')||
'      THEN  -- NEI 14.04.14 kein Zugriff auf Patient (keine Schnittmenge zw. pers_betreuer vom Patient und pers_zugriff vom Betreuer)=> kein FB-Rezept'||unistr('\000a')||
'     '' ''  '||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL(';

s:=s||''||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':110:''||:APP_SESSION|| '':::110:''||'||unistr('\000a')||
'   ''P110_PERSON,P110_PIS_PAT_AKTE_ID,P110_PIS_ADRESSE_ID,P110_WAHL_IDENTITAET:'''||unistr('\000a')||
'     ||p.PERSONENSTAMM_ID||'',''||p.PIS_PAT_AKTE_ID'||unistr('\000a')||
'     ||'',''||p.PIS_ADRESSE_ID||'',''||:P130_IDENTITAET)    || ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9491,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img ';

s:=s||'src="#IMAGE_PREFIX#edit_big.gif"  border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END  fb_rezept_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  WHEN frgbg_s.wk_check_zugriff(P.PERSONENSTAMM_ID) = 0 THEN  -- NEI 15.10.13 für Kunde kein WK möglich'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':300:''||:APP_SESSION||''::&DEBUG.:300:''||'||unistr('\000a')||
'     ''P300_PERSSTAMM_ID,P300_ZURUECK_SEITE,P30';

s:=s||'0_WAHL_IDENTITAET,P300_WK_ARTIKELTYP_FLAG:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID||'',''||:APP_PAGE_ID||'',''||:P130_IDENTITAET||'',2'')|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9492,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END wk_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  E';

s:=s||'LSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':300:''||:APP_SESSION||''::&DEBUG.:300:''||'||unistr('\000a')||
'     ''P300_PERSSTAMM_ID,P300_ZURUECK_SEITE,P300_WAHL_IDENTITAET,P300_WK_ARTIKELTYP_FLAG:'''||unistr('\000a')||
'     ||P.PERSONENSTAMM_ID||'',''||:APP_PAGE_ID||'',''||:P130_IDENTITAET||'',1'')|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9493,:fas_sprache_id)||'''''')"''';

s:=s||''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndirqd.gif"x border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END wklabor_link,'||unistr('\000a')||
'  CASE WHEN p.betreuerart = 5 OR       -- nicht betreuerart 1,2 '||unistr('\000a')||
'            P.PERSONENSTAMM_ID is NULL -- Kein FAS Patient'||unistr('\000a')||
'  THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':141:''||:APP_SESSION||''::&DEBUG.:141:''||'||unistr('\000a')||
'     ''P141_PERSONENSTAMM_ID:'''||unistr('\000a')||
'     ||P.P';

s:=s||'ERSONENSTAMM_ID)|| ''"'''||unistr('\000a')||
'     ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung(9494,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'     || ''>'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#print06.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END direktdruck_link,'||unistr('\000a')||
'  x.fas_gus_id,'||unistr('\000a')||
'  frgbg_s.GET_PERS_ADRESSE(frgbg_s.get_identitaet_kunde(NULL,-1,p.PERSONENSTAMM_ID)) '||unistr('\000a')||
'FROM personenlisten x, v_perslisten_betreuer';

s:=s||' p '||unistr('\000a')||
'where :p130_patliste_anzeigen = 1    -- Suche gestartet'||unistr('\000a')||
'  and :p130_suchart = 2              -- Komplettliste-Suche'||unistr('\000a')||
'  and p.id = x.id'||unistr('\000a')||
'  and ( /* Ident spezif. => Komplettliste der Identitaet */'||unistr('\000a')||
'       (:p130_patientenzugriff != 1  AND'||unistr('\000a')||
'        p.personenstamm_id_betreuer= :p130_identitaet)'||unistr('\000a')||
'      OR /* eingeschraenkter Betreuerzugriff => Komplettliste Betreuer */'||unistr('\000a')||
'       (:p130_patientenzugriff =';

s:=s||' 1 AND'||unistr('\000a')||
'        p.personenstamm_id_betreuer = :P130_PERSONENSTAMM_ID_BETREUER)'||unistr('\000a')||
'      )'||unistr('\000a')||
'  /* NEI 12.12.12 Nur noch Endkunden in der Liste wg. GUS'||unistr('\000a')||
'  AND (x.fas_betreuer = :p130_typ OR NVL(:p130_typ,''%'') = ''%'')  -- Betreuertyp'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND x.fas_betreuer = ''N''           -- NEI 12.12.12'||unistr('\000a')||
'order by suchname, geburtsdatum';

wwv_flow_api.create_report_region (
  p_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 130,
  p_name=> '&P130_PAGE_TITEL_PATIENTENLISTE.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P130_HEIGHT_PATIENTENLISTE.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(474,frgbg_s.get_sprache_id(:APP_USER)));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '300',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '10000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'XLS',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_output_file_name=> 'Patientenliste',
  p_prn_content_disposition=> 'ATTACHMENT',
  p_prn_document_header=> 'APEX',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width_units=> 'PERCENTAGE',
  p_prn_width=> 210,
  p_prn_height=> 297,
  p_prn_orientation=> 'VERTICAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'LEFT',
  p_prn_page_footer_alignment=> 'LEFT',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4491513321343496 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'GEBURTSDATUM',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4491800661343496 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'PIS_ADRESSE_ID',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':fas_modus_id = 0',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3754801493731390 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHNAME',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3754910243731393 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHADRESSE',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3755929347900300 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHZUSATZ',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4258108606321279 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'FAS_BETREUER',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':fas_modus_id != 0 and 1=2 /* NEI 12.12.12 Spalte wird nicht mehr benötigt, da nur noch Endkunden in Personenliste erlaubt */'||unistr('\000a')||
'',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'YES',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4491904863343496 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'PIS_PAT_AKTE_ID',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 12186426114288664 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'PERSONENSTAMM_ID_DISP',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '0',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5804911876208856 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'FB_REZEPT_LINK',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> 'frgbg_s.check_fas_rolle(:APP_USER,''FAS_STANDARDVERWALTUNG'')> 0',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5805700495233935 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'WK_LINK',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> 'frgbg_s.check_fas_rolle(:APP_USER,''WARENKORB_VERWALTEN'')> 0 and NVL(:fas_modus_id,0) != 1 /* 1 = IABC-Modus */',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6370229026948126 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'WKLABOR_LINK',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'FUNCTION_BODY',
  p_display_when_condition=> 'BEGIN'||unistr('\000a')||
'   -- NEI 21.10.13 App-User hat Berechtigung für Laborauftrag-Verwalten?'||unistr('\000a')||
'   IF frgbg_s.check_fas_rolle(:APP_USER,''WK_LABOR_VERWALTEN'')= 0 THEN '||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   ELSE '||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6562503024719060 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'DIREKTDRUCK_LINK',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> 'frgbg_s.check_fas_rolle(:APP_USER,''DIREKTREZEPTDRUCK'')> 0 AND '||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1 = IABC-Modus */',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4248901083369338 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'FAS_GUS_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8140221771690312 + wwv_flow_api.g_id_offset,
  p_region_id=> 4491012670343479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'PERSSTAMM_ID_IDENT_NAME',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4572110361057846 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 130,
  p_button_sequence=> 10,
  p_button_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_button_name    => 'ABBRECHEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P130_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:121:&SESSION.::&DEBUG.:130::',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 12423621003062950 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 130,
  p_button_sequence=> 40,
  p_button_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_button_name    => 'KONFIGURATION',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P130_BL_KONFIGURATION.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:132:P132_ZURUECK_ZUR_SEITE,P132_ID_PARAMETER:&APP_PAGE_ID.,&FAS_LOGIN_PERSONENSTAMM_ID.',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON=''BETREUER'' and 1=2 /*ueber Menü realisiert*/',
  p_button_condition2=> 'BETREUER',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4646728002243156 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 130,
  p_button_sequence=> 5,
  p_button_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P130_BL_SUCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4896607765357846 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 130,
  p_button_sequence=> 20,
  p_button_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_button_name    => 'ERSTELLEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P130_BL_ERSTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'NVL(frgbg_s.get_pers_option(:APP_USER,36),0) = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5298818925233614 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 130,
  p_button_sequence=> 30,
  p_button_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_button_name    => 'ALLE_ANZEIGEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P130_BL_ALLE_ANZEIGEN.',
  p_button_position=> 'REGION_TEMPLATE_NEXT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4277727491848784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:110:P110_WAHL_IDENTITAET,P110_PERSON:&P130_IDENTITAET.,',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4896607765357846+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 5,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 08-FEB-2010 20:55 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4620516667715507 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:130:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-SEP-2007 15:09 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2585125210671732 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'0',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT substr(p.name,1,30)||'', ''||substr(p.ort,1,30)||'', ''||p.id a, p.id b'||unistr('\000a')||
'FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'  AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'  AND p.betreuer = ''I'''||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(511,:fas_sprache_id), 0'||unistr('\000a')||
'from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_patientenzugriff != 1   /* 1=spez. Betreuerzugriff */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2802927479395048 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_SUCHART',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 57,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(3478,:fas_sprache_id) a,0 b'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(3479,:fas_sprache_id) , 1 '||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(3850,:fas_sprache_id) , 2 '||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'WHERE :p130_identitaet != 0   /* Identitaet ausgewaehlt */'||unistr('\000a')||
'   OR :P130_PATIENTENZUGRIFF=1 /* eingeschraenkter Betreuerzugriff Eovital/iabc*/'||unistr('\000a')||
'order by 2',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '2',
  p_attribute_02 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2804319008856248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_SUCH_PERSSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 82,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_suchart=0',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2804528359859023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_SUCH_PIS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 84,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_suchart=0 and :fas_modus_id = 0',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2805600270898170 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_SUCHREZEPTBEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_suchart=1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3756324424993573 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_SUCHREZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_suchart=1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3818515953607827 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4087825625128129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_PATIENTENZUGRIFF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 51,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Patientenzugriff',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4259518668475551 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'XP130_TYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 56,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '%',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Typ',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(632,:fas_sprache_id) a,''%'' b from dual '||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(1854,:fas_sprache_id) a,''J'' b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(3101,:fas_sprache_id) a,''I'' b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(3578,:fas_sprache_id) a,''N'' b from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_modus_id != 0 and 1=2 /* NEI 12.12.12 Spalte wird nicht mehr benötigt, da nur noch Endkunden in Personenliste erlaubt */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4493208783349526 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_PERSONENSTAMM_ID_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pers_betr',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4500514295474176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_APP_SPRACHE_ID_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'App Sprache Id Betreuer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4510622878571254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_PATLISTE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Flag Liste leer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4573223520061659 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4575106121075565 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_PAGE_TITEL_PATIENTENLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4626724586920520 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_SUCHNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160&#160&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_suchart=0',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4631012484068378 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_SUCHADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_suchart=0',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4632325297072085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_SUCHZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_suchart=0',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4650300044291870 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_BL_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Suchen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4897726119363153 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 46,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5301822781263107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_BL_ALLE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6266532408655762 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_NV_PATIENTENLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Patientenliste',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6313427027986875 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_SUCHNAME_NORM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Norm',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8141126740975602 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_PATIENTENMASTERZUGRIFF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Master',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12189211101350560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_HEIGHT_PATIENTENLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12450302593303654 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 130,
  p_name=>'P130_BL_KONFIGURATION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 47,
  p_item_plug_id => 4491012670343479+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5338730778932294 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 130
 ,p_name => 'Enter Drücken im Namensfeld'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P130_SUCHNAME'
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => 'this.browserEvent.which === 13'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'keypress'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5339008155932304 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 130
 ,p_event_id => 5338730778932294 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'apex.submit(''SUCHEN'');'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*mel.p(''patliste_leer_initialisieren request:%1;%2'',v_prot_id,''INFO'',''102/110:patliste_leer_initialisieren'',:request,:p130_suchart);*/'||unistr('\000a')||
'/*'||unistr('\000a')||
'   if :request in (''P130_SUCHART'',''P130_IDENTITAET'',''ERSTELLEN'') AND NVL(:p130_suchart,0)!=2 then'||unistr('\000a')||
'      :p130_patliste_anzeigen := 0; -- Leer initialisieren'||unistr('\000a')||
'   else'||unistr('\000a')||
'      :p130_patliste_anzeigen := 1; -- Suchen'||unistr('\000a')||
'   end if;'||unistr('\000a')||
'*';

p:=p||'/'||unistr('\000a')||
'   if :request in (''P130_SUCHART'',''P130_IDENTITAET'',''ERSTELLEN'') THEN'||unistr('\000a')||
'      IF NVL(:p130_suchart,0)!=2 then  -- Keine Komplettliste => nie Suchen'||unistr('\000a')||
'         :p130_patliste_anzeigen := 0; -- Leer initialisieren'||unistr('\000a')||
'      ELSE /*p130_suchart = 2 */'||unistr('\000a')||
'         IF :p130_identitaet = 0 and :p130_patientenzugriff != 1 '||unistr('\000a')||
'         THEN -- Komplettliste bei Identzugriff nie bei unbestimmter Ident => Suchart auf A';

p:=p||'dresssuche'||unistr('\000a')||
'             :p130_suchart := 0;'||unistr('\000a')||
'             :p130_patliste_anzeigen := 0;'||unistr('\000a')||
'         ELSE -- Komplettliste => suchen'||unistr('\000a')||
'            :p130_patliste_anzeigen := 1;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   else'||unistr('\000a')||
'      :p130_patliste_anzeigen := 1; -- Suchen'||unistr('\000a')||
'   end if;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2799524478083737 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 5,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'patliste_leer_initialisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p130_suchname := NULL;'||unistr('\000a')||
'   :p130_suchname_norm := NULL;'||unistr('\000a')||
'   :p130_suchadresse := NULL;'||unistr('\000a')||
'   :p130_suchzusatz := NULL;'||unistr('\000a')||
'   :P130_SUCH_PERSSTAMM_ID := NULL;'||unistr('\000a')||
'   :p130_such_pis_id := NULL;'||unistr('\000a')||
'   :P130_SUCHREZEPT_NR := NULL;'||unistr('\000a')||
'   :p130_suchrezeptbemerkung := NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5300004988248509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'clear_such_felder',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''ALLE_ANZEIGEN'',''P130_SUCHART'',''P130_IDENTITAET'',''ERSTELLEN'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_persstamm_id_identitaet    personenstamm.id%TYPE;'||unistr('\000a')||
'   v_name_identitaet            personenstamm.name%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'   v_prot_id                    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p130_identitaet = 0 THEN -- Standard-Identität als aktive Identität anzeigen'||unistr('\000a')||
'      v_persstamm_id_identitaet:= frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'      v_name_identitaet:=frgbg_s.get_identitaet_name(v_pe';

p:=p||'rsstamm_id_identitaet);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      v_persstamm_id_identitaet := :p130_identitaet;'||unistr('\000a')||
'      v_name_identitaet:=frgbg_s.get_identitaet_name(v_persstamm_id_identitaet);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :FAS_IDENTITAET_PERSSTAMM_ID := v_persstamm_id_identitaet;'||unistr('\000a')||
'   :fas_identitaet := v_name_identitaet;'||unistr('\000a')||
'--mel.p(:request||'' Id:''||:FAS_IDENTITAET_PERSSTAMM_ID,v_prot_id,''Info'',  ''fas/p130'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2586822465869476 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_fas_persstamm_id_identitaet',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''P130_IDENTITAET''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p130_suchname_norm:= frgbg_t.NORMSTRING(:p130_suchname,2);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6313112483982640 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'suchstring_aufbauen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4646728002243156 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Komplette Höhe ausnutzen (100% des Maximums)'||unistr('\000a')||
'   :P130_HEIGHT_Patientenliste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12190026124364415 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user VARCHAR2(100);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' and :p130_personenstamm_id_betreuer is null THEN'||unistr('\000a')||
'      -- externes Login  wird mit dem aktuellen Benutzer/Betreuer bestückt'||unistr('\000a')||
'      :p130_personenstamm_id_betreuer := :FAS_LOGIN_PERSONENSTAMM_ID;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4499600097469998 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 2,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten_betreuer',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :P130_PATIENTENZUGRIFF := NVL(frgbg_s.get_pers_option(:APP_USER,28),0);'||unistr('\000a')||
'   :P130_PATIENTENMASTERZUGRIFF := NVL(frgbg_s.get_pers_option(:APP_USER,43),0);'||unistr('\000a')||
''||unistr('\000a')||
'/*mel.p(''Patzugriff: %1'', v_prot_id,''INFO'',''102/130:init_patientenzugriff'',:P130_PATIENTENZUGRIFF);*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1385523718989616 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 3,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_patientenzugriff',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_betreuer             personenstamm.betreuer%TYPE;'||unistr('\000a')||
'   v_persstamm_id_ident   personenstamm.id %TYPE;'||unistr('\000a')||
'   v_IDENTITAET_PERSSTAMM_ID  personenstamm.id %TYPE;'||unistr('\000a')||
'   v_anz                  number;'||unistr('\000a')||
'   v_fehlertext           varchar2(2000);'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN  '||unistr('\000a')||
'/* falls bei Patientenzugriff = 1 IABC/EOVITAL-Betreuerzugriff Feld nicht angezeigt wird, wird es auf jeden Fall initialisiert *';

p:=p||'/'||unistr('\000a')||
'--mel.p(''Ident: %1!'',v_prot_id,''info'',''init_identitaet,P130'',:p130_identitaet);'||unistr('\000a')||
'   IF :p130_identitaet is NULL THEN'||unistr('\000a')||
'      IF :p130_patientenzugriff = 1 THEN  -- Ident wird nicht gesetzt, da es sowieso nach Betreuer geht'||unistr('\000a')||
'         :p130_identitaet := 0;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         /* Falls nur 1 Idenitaet vorhanden, diese setzen sonst 0 */'||unistr('\000a')||
'         SELECT count(*), min (p.id) '||unistr('\000a')||
'         into v_anz, v_perss';

p:=p||'tamm_id_ident'||unistr('\000a')||
'         FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'         WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'           AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'           AND p.betreuer = ''I'' ;'||unistr('\000a')||
'         IF v_anz = 1 THEN'||unistr('\000a')||
'            :p130_identitaet := v_persstamm_id_ident;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            :p130_identitaet := 0;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI ';

p:=p||'23.03.2010'||unistr('\000a')||
'   -- gewählte Identitaet wird auch gleich Aktive Identitaet; '||unistr('\000a')||
'   -- bei alle Anzeigen wird zu Def.Ident Betreuer'||unistr('\000a')||
'   IF :p130_identitaet = 0 THEN'||unistr('\000a')||
'      -- Default Identitaet in Fusszeile anzeigen'||unistr('\000a')||
'      /* Setzen der Default-Identitaet des Betreuers */'||unistr('\000a')||
'      IF :fas_aufgerufen_von = ''IDENTITAET'' THEN'||unistr('\000a')||
'         :FAS_IDENTITAET_PERSSTAMM_ID := :FAS_LOGIN_PERSONENSTAMM_ID;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'       ';

p:=p||'  /* Setzen der Default-Identitaet des Betreuers */'||unistr('\000a')||
'         v_IDENTITAET_PERSSTAMM_ID:= frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'         IF NVL(v_IDENTITAET_PERSSTAMM_ID,0) <=0 THEN'||unistr('\000a')||
'            :FAS_IDENTITAET_PERSSTAMM_ID := NULL;'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(3098,:fas_sprache_id);'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'         EL';

p:=p||'SE'||unistr('\000a')||
'            :FAS_IDENTITAET_PERSSTAMM_ID := v_IDENTITAET_PERSSTAMM_ID;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      :FAS_IDENTITAET:=frgbg_s.get_identitaet_name(:FAS_IDENTITAET_PERSSTAMM_ID,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Wahlidentitaet als aktive Identitaet setzen'||unistr('\000a')||
'      :FAS_IDENTITAET_PERSSTAMM_ID := :p130_identitaet;'||unistr('\000a')||
'      :FAS_IDENTITAET:=frgbg_s.get_identitaet_name(:FAS_IDENTITAET_PERSSTAMM_ID,:';

p:=p||'FAS_SCHEMA_ID);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--mel.p(''Ident: %1!'',v_prot_id,''info'',''init_identitaet,102/130'',:p130_identitaet);'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4094028270713715 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_identität',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_max                  number := 200; /* MAX. Anz f. automatische Komplettliste */'||unistr('\000a')||
'   v_anz                  number;'||unistr('\000a')||
'   v_prot_id              number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--:P130_PATIENTENZUGRIFF:=NVL(frgbg_s.get_pers_option(:APP_USER,28),0);'||unistr('\000a')||
'/*   IF :p130_suchart is null THEN'||unistr('\000a')||
'      :p130_suchart := 0;'||unistr('\000a')||
'   END IF; '||unistr('\000a')||
'   IF (:P130_IDENTITAET = 0 AND :P130_PATIENTENZUGRIFF!=1) AND :p130_suchart = 2 THEN'||unistr('\000a')||
'-';

p:=p||'-mel.p(''yypatliste_leer_initialisieren request:%1;%2'',v_prot_id,''INFO'',''102/110:patliste_leer_initialisieren'',:request,:p130_suchart);'||unistr('\000a')||
'      :p130_suchart := 0;'||unistr('\000a')||
'      :P130_PATLISTE_ANZEIGEN := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'/*mel.p(''init_suchart anz:%1;patzugr:%2,suchart:%3,ident: %4'',v_prot_id,''INFO'',''102/110:init_suchart'',v_anz, :P130_PATIENTENZUGRIFF,:p130_suchart,:P130_IDENTITAET );*/'||unistr('\000a')||
'   IF (:p130_identi';

p:=p||'taet != 0 and :P130_PATIENTENZUGRIFF !=1 /* Ident angegeben  bei Identzugriff*/'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       :P130_PATIENTENZUGRIFF = 1 /* Betreuerzugriff */'||unistr('\000a')||
'      ) AND'||unistr('\000a')||
'      :p130_suchart is null     /* erstmalige Suche */  '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- Check, ob automatische KomplettListe erstellt werden kann'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM v_perslisten_betreuer p'||unistr('\000a')||
'      where ( -- Ident spezif. => Komplettl';

p:=p||'iste der Identitaet '||unistr('\000a')||
'           (:p130_patientenzugriff != 1 AND p.personenstamm_id_betreuer=:p130_identitaet )'||unistr('\000a')||
'         OR -- eingeschraenkter Betreuerzugriff => Komplettliste Betreuer '||unistr('\000a')||
'           (:p130_patientenzugriff = 1 AND'||unistr('\000a')||
'            p.personenstamm_id_betreuer = :P130_PERSONENSTAMM_ID_BETREUER)'||unistr('\000a')||
'      );'||unistr('\000a')||
'--mel.p(''init_suchart b anz:%1;patzugr:%2,suchart:%3'',v_prot_id,''INFO'',''102/110:init_s';

p:=p||'uchart'',v_anz, :P130_PATIENTENZUGRIFF,:p130_suchart);'||unistr('\000a')||
'      IF v_anz <= v_max THEN'||unistr('\000a')||
'         :p130_suchart := 2 ;'||unistr('\000a')||
'         :P130_PATLISTE_ANZEIGEN := 1;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p130_suchart := 0 ;'||unistr('\000a')||
'         :P130_PATLISTE_ANZEIGEN := 0;         '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p130_suchart := NVL(:p130_suchart,0);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--mel.p(''init_suchart c anz:%1;patzugr:%2,suchart:%3'',v_prot_id,''INFO'',''102/110:i';

p:=p||'nit_suchart'',v_anz, :P130_PATIENTENZUGRIFF,:p130_suchart);'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6342320209873085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 8,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_suchart',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --:p130_abmelden := frgbg_s.holen_uebersetzung(174,v_sprache_id);'||unistr('\000a')||
'   :p130_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p130_bl_suchen := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p130_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id);'||unistr('\000a')||
'   :P130_BL_KONFIGURATION := frgbg_s.holen_ueb';

p:=p||'ersetzung(1593,v_sprache_id);'||unistr('\000a')||
'   :p130_bl_alle_anzeigen := frgbg_s.holen_uebersetzung(511,v_sprache_id);'||unistr('\000a')||
'   :p130_page_titel_patientenliste := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(475,v_sprache_id);'||unistr('\000a')||
'   :P130_NV_PATIENTENLISTE := frgbg_s.holen_uebersetzung(3833,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4574122959070915 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DELETE wkorb_det_verordnungen_tmp'||unistr('\000a')||
'WHERE warenkorb_detail_tmp_id in (SELECT wkd.id '||unistr('\000a')||
'                           FROM warenkoerbe_tmp wk, warenkorb_details_tmp wkd'||unistr('\000a')||
'                           WHERE wk.session_id =  :app_session'||unistr('\000a')||
'                             and wk.id = wkd.warenkorb_tmp_id'||unistr('\000a')||
'                           );'||unistr('\000a')||
'DELETE warenkorb_details_tmp'||unistr('\000a')||
'WHERE warenkorb_tmp_id in (SELECT id '||unistr('\000a')||
'                 ';

p:=p||'          FROM warenkoerbe_tmp'||unistr('\000a')||
'                           WHERE session_id =  :app_session'||unistr('\000a')||
'                          );'||unistr('\000a')||
'DELETE warenkoerbe_tmp'||unistr('\000a')||
'where session_id = :app_session;';

wwv_flow_api.create_page_process(
  p_id     => 2198100619301537 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_warenkorb_tmp',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :p130_hinweis is not null THEN'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''alert("''||:p130_hinweis||''");'');'||unistr('\000a')||
'      :p130_hinweis := NULL;'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;'||unistr('\000a')||
'';

wwv_flow_api.create_page_process(
  p_id     => 3819301287669865 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 130,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fehlerausgabe',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 130
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00131
prompt  ...PAGE 131: Betreuerpatliste_kopierauswahl
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 131
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Betreuerpatliste_kopierauswahl'
 ,p_step_title => 'Betreuerpatliste Kopierauswahl'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Betreuerpatliste Kopierauswahl'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130122121341'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT distinct'||unistr('\000a')||
'  p.PIS_ADRESSE_ID, '||unistr('\000a')||
'  p.suchname,p.suchadresse,p.suchzusatz,'||unistr('\000a')||
'  p.PIS_PAT_AKTE_ID,p.geburtsdatum,'||unistr('\000a')||
'  p.PERSONENSTAMM_ID personenstamm_id_disp,'||unistr('\000a')||
'  p.PERSONENSTAMM_ID'||unistr('\000a')||
'FROM v_perslisten_betreuer p, personenlisten x, personenstamm x1'||unistr('\000a')||
'where :p131_patliste_anzeigen = 1    -- Suche gestartet'||unistr('\000a')||
'  and x.id = p.id'||unistr('\000a')||
'  and x.fas_persstamm_id = x1.id'||unistr('\000a')||
'  and p.personenstamm_id_betreuer in '||unistr('\000a')||
'        (SE';

s:=s||'LECT persstamm_id_betreuerzugriff'||unistr('\000a')||
'         FROM pers_zugriffe'||unistr('\000a')||
'         WHERE persstamm_id_betreuer = :p131_personenstamm_id_betreuer'||unistr('\000a')||
'                /* NEI 11.01.10 */'||unistr('\000a')||
'           AND (:P131_PATIENTENZUGRIFF = 0    /* Stdzugriff*/'||unistr('\000a')||
'               OR  '||unistr('\000a')||
'                :P131_PATIENTENZUGRIFF = 1 AND/* IABC-Betr.zugr*/'||unistr('\000a')||
'                persstamm_id_betreuer = persstamm_id_betreuerzugriff '||unistr('\000a')||
'              ';

s:=s||' )'||unistr('\000a')||
'        )'||unistr('\000a')||
'  AND p.betreuerart in (1,2)  -- NEI 24.08.10 Nur Betreuer'||unistr('\000a')||
'  --AND (x.normname  like ''%''||frgbg_t.NORMSTRING(:p131_suchname,2)||''%'' '||unistr('\000a')||
'  AND (x.normname  like ''%''||:p131_suchname_norm||''%'' '||unistr('\000a')||
'       OR :p131_suchname IS NULL)'||unistr('\000a')||
'  AND (UPPER(p.suchadresse) like ''%''||UPPER(:p131_suchadresse)||''%'' '||unistr('\000a')||
'       OR :p131_suchadresse IS NULL)'||unistr('\000a')||
'  AND (UPPER(p.suchzusatz) like ''%''||UPPER(:p131_suchzusatz';

s:=s||')||''%'' '||unistr('\000a')||
'       OR :p131_suchzusatz IS NULL)'||unistr('\000a')||
'  AND (x.fas_persstamm_id = :p131_such_persstamm_id'||unistr('\000a')||
'       OR :P131_SUCH_PERSSTAMM_ID IS NULL)'||unistr('\000a')||
'  AND (x.pis_adresse_id = :p131_such_pis_id'||unistr('\000a')||
'       OR :p131_such_pis_id IS NULL)'||unistr('\000a')||
'  -- Nur auf änderbare Patienten oder mit spez. Berechtigung '||unistr('\000a')||
'  -- oder als entsprechender Patient eingeloggt'||unistr('\000a')||
'  AND (  (x1.aenderbar = ''J'') '||unistr('\000a')||
'      OR (x1.aenderbar = ''N'' AND'||unistr('\000a')||
'      ';

s:=s||'   -- speziell berechtigt'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''GESCHUETZTE_PERSONENDATEN_AENDERN'')> 0'||unistr('\000a')||
'         )'||unistr('\000a')||
'      OR (x1.aenderbar = ''N'' AND   -- User hat sich selbst eingeloggt'||unistr('\000a')||
'          :fas_aufgerufen_von != ''BETREUER'' and'||unistr('\000a')||
'          UPPER(x1.USER_ACCOUNT)= UPPER(:APP_USER)'||unistr('\000a')||
'         )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  /* NEI 12.12.12 Nur noch Endkunden in der Liste wg. GUS */'||unistr('\000a')||
'  AND x.fas_betreuer = ''N''     ';

s:=s||'     '||unistr('\000a')||
'order by p.suchname, p.geburtsdatum'||unistr('\000a')||
''||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 8431018251657459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 131,
  p_name=> '&P131_PAGE_TITEL_PATIENTENLISTE.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P131_HEIGHT_PATIENTENLISTE.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(619,frgbg_s.get_sprache_id(:APP_USER)));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '1000',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8431709165657476 + wwv_flow_api.g_id_offset,
  p_region_id=> 8431018251657459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'PIS_ADRESSE_ID',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3758115456993907 + wwv_flow_api.g_id_offset,
  p_region_id=> 8431018251657459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHNAME',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3758207276993909 + wwv_flow_api.g_id_offset,
  p_region_id=> 8431018251657459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHADRESSE',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3758312490993909 + wwv_flow_api.g_id_offset,
  p_region_id=> 8431018251657459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHZUSATZ',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8431806548657476 + wwv_flow_api.g_id_offset,
  p_region_id=> 8431018251657459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PIS_PAT_AKTE_ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8431431598657476 + wwv_flow_api.g_id_offset,
  p_region_id=> 8431018251657459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'GEBURTSDATUM',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3758426525993909 + wwv_flow_api.g_id_offset,
  p_region_id=> 8431018251657459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'PERSONENSTAMM_ID_DISP',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8431914428657476 + wwv_flow_api.g_id_offset,
  p_region_id=> 8431018251657459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'PERSONENSTAMM_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:110,140,201,131:P110_PERSON,P110_PIS_PAT_AKTE_ID,P110_MN_REZEPT_ID_KOPIE,P110_WAHL_IDENTITAET:#PERSONENSTAMM_ID#,#PIS_PAT_AKTE_ID#,&P131_MN_REZEPT_ID.,&FAS_IDENTITAET_PERSSTAMM_ID.',
  p_column_linktext=>'<img src="#IMAGE_PREFIX#edit_big.gif"  border="0">',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 8432315350657478 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 131,
  p_button_sequence=> 10,
  p_button_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_button_name    => 'ABBRECHEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P131_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:131::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8432508206657479 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 131,
  p_button_sequence=> 5,
  p_button_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P131_BL_SUCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8432918320657479 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 131,
  p_button_sequence=> 30,
  p_button_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_button_name    => 'ALLE_ANZEIGEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P131_BL_ALLE_ANZEIGEN.',
  p_button_position=> 'REGION_TEMPLATE_NEXT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8436624544657493 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:131:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-SEP-2007 15:09 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2808417976100170 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_PATLISTE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Flag Liste leer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2809009065154412 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_SUCH_PERSSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2809214606156007 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_SUCH_PIS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4030719781779184 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_SUCHNAME_NORM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Norm',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8433128808657479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_APP_SPRACHE_ID_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'App Sprache Id Betreuer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8433516465657484 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_PERSONENSTAMM_ID_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8433712020657484 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8433927954657485 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_PAGE_TITEL_PATIENTENLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8434109931657485 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 25,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8434309506657485 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_SUCHNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8434523081657485 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_SUCHADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 25,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8434709741657487 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_SUCHZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 25,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8434922522657487 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_BL_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Suchen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8435528514657489 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_BL_ALLE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8455120200018781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_MN_REZEPT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Rezept Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8531325866660958 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_PATIENTENZUGRIFF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Patientenzugriff',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12206406356481707 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 131,
  p_name=>'P131_HEIGHT_PATIENTENLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 8431018251657459+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||' :p131_patliste_anzeigen := 1;';

wwv_flow_api.create_page_process(
  p_id     => 2808501138104804 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 131,
  p_process_sequence=> 5,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'patliste_leer_initialisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p131_suchname := NULL;'||unistr('\000a')||
'   :p131_suchadresse := NULL;'||unistr('\000a')||
'   :p131_suchzusatz := NULL;'||unistr('\000a')||
'   :p131_such_persstamm_id := NULL;'||unistr('\000a')||
'   :p131_such_pis_id := NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8436316652657493 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 131,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'clear_such_felder',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>8432918320657479 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p131_suchname_norm:= frgbg_t.NORMSTRING(:p131_suchname,2);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4030800172783023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 131,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'suchstring_aufbauen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>8432508206657479 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Komplette Höhe ausnutzen (100% des Maximums)'||unistr('\000a')||
'   :P131_HEIGHT_Patientenliste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12205116614475167 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 131,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user VARCHAR2(100);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p131_personenstamm_id_betreuer is null THEN   -- externes Login  wird mit dem aktuellen Benutzer bestückt'||unistr('\000a')||
'      v_user  := HTMLDB_CUSTOM_AUTH.GET_USERNAME;'||unistr('\000a')||
'      SELECT id,app_sprache_id '||unistr('\000a')||
'      INTO :p131_personenstamm_id_betreuer , '||unistr('\000a')||
'           :p131_app_sprache_id_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE UPPER(user_account) = UPPER(v_user)'||unistr('\000a')||
'      ';

p:=p||'  AND satzkennzeichen is null;  -- gelöschte Sätze nicht mehr anzeigen'||unistr('\000a')||
'   ELSE  -- Momentan noch nicht genutzt: Aufruf via Pis p131_personenstamm_id_betreuer enthält bereits die Personenstamm_id'||unistr('\000a')||
'      SELECT id,app_sprache_id      '||unistr('\000a')||
'      INTO :p131_personenstamm_id_betreuer , '||unistr('\000a')||
'           :p131_app_sprache_id_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE id = :p131_personenstamm_id_betreuer;  '||unistr('\000a')||
'   E';

p:=p||'ND IF; '||unistr('\000a')||
' '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8435700486657490 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 131,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten_betreuer',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p131_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p131_bl_suchen := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p131_bl_alle_anzeigen := frgbg_s.holen_uebersetzung(511,v_sprache_id);'||unistr('\000a')||
'   :p131_page_titel_patientenliste := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(475,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8435921498657493 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 131,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :P131_PATIENTENZUGRIFF := NVL(frgbg_s.get_pers_option(:APP_USER,28),0);'||unistr('\000a')||
'/*mel.p(''Patzugriff: %1'', v_prot_id,''INFO'',''102/131:init_patientenzugriff'',:P131_PATIENTENZUGRIFF);*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8531409028665553 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 131,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_patientenzugriff',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 131
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00132
prompt  ...PAGE 132: BetreuerSTAMMANZEIGE
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 132
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'BetreuerSTAMMANZEIGE'
 ,p_step_title => 'Betreuerstammanzeige'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Betreuerstammanzeige'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150206083924'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3173731173944368 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 132,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 12385812576923337 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 132,
  p_plug_name=> '&P132_PAGE_TITEL_BETRANZEIGE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 9,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow:auto; height: &FAS_SCROLLREGION_HEIGHT_MAX.px;width: 620px">'||unistr('\000a')||
'',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 12618732078298165 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 132,
  p_plug_name=> 'Optionen',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 19,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 12386207470923354 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 132,
  p_button_sequence=> 10,
  p_button_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P132_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4535018046349125 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 132,
  p_button_sequence=> 70,
  p_button_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_button_name    => 'LOGO_LADEN',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P132_BL_LOGO_LADEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:popUp2(''f?p=&APP_ID.:134:&SESSION.::&DEBUG.:::'',500,250)',
  p_button_execute_validations=>'Y',
  p_button_condition=> '/*frgbg_s.check_user_typ(:app_user,''I'') = 1*/'||unistr('\000a')||
'frgbg_s.check_user_typ(:P132_USER_ACCOUNT,''I'') = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 12386422090923356 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 132,
  p_button_sequence=> 30,
  p_button_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P132_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p132_id is not null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 12624313817349665 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 132,
  p_button_sequence=> 60,
  p_button_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_button_name    => 'OPT_SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P132_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p132_id is not null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 12386807726923356 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 132,
  p_button_sequence=> 20,
  p_button_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P132_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> ':p132_id is not null',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 12387024661923356 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 132,
  p_button_sequence=> 50,
  p_button_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_button_name    => 'PASSWORT_CHANGE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P132_BL_PASSWORT_CHG.',
  p_button_position=> 'REGION_TEMPLATE_EDIT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:popUp2(''&P132_PREPARE_URL_PW.'',700,380);',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'UPPER(:P132_USER_ACCOUNT)= UPPER(:APP_USER) AND :p132_id IS NOT NULL AND :fas_aufgerufen_von != ''ANONYM''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>12405406508923414 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P132_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:132::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 12,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':fas_aufgerufen_von = ''BETREUER'' AND :REQUEST in (''DELETE'',''CANCEL'',''SAVE'',''OPT_SAVE'')',
  p_branch_condition_text=>'130',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 04-AUG-2006 17:22 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>12405227270923414 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2623826020003346 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_LOGO_ETIKETT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1150,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,20);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ot.art = 1        /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = 20 /*  Logo Etikett */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 20 /*  Logo-Etikett */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,20) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2631414947425954 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_LOGO_ETIKETT_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1160,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Logo Etikett Db',
  p_source=>'P132_LOGO_ETIKETT',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2634321597552034 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PRODUZIERENDE_APOTHEKE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1135,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,21);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.get_pers_adresse(p.id) a,'||unistr('\000a')||
'       p.id b'||unistr('\000a')||
'FROM pers_identitaet_props i,    /* spez. Eigenschaften der Identitaeten */'||unistr('\000a')||
'     personenstamm p'||unistr('\000a')||
'where i.typ = ''PA'' /* Produzierende Apotheke */'||unistr('\000a')||
'  and p.id = i.persstamm_id'||unistr('\000a')||
'order by 1'||unistr('\000a')||
'  '||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,21) = 0 ',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2634529562554334 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PRODUZIERENDE_APOTHEKE_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1136,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'druckartdb',
  p_source=>'P132_produzierende_apotheke',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2658410628706410 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_LOGO_PERSSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1141,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'frgbg_s.GET_logo_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id)',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Logo Persstamm Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2732825754230510 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PREPARE_URL_PW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1170,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prepare Url Pw',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3000825442066387 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ETIKETTENTYP_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 860,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'P132_ETIKETTENTYP',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3001115184072890 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ETIKETTENANZAHL_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 870,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'P132_ETIKETTENANZAHL',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3001322456074928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PROD_AUFTRAG_ANZAHL_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 880,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'P132_PROD_AUFTRAG_ANZAHL',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3001500424078028 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_MAX_SCREEN_HEIGHT_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1111,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'P132_MAX_SCREEN_HEIGHT',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3753523573406615 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 63,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'IDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3753731192408803 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_TELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 98,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3753907774411515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_MOBILTELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'MOBILTELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3754114700413550 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3902102432464160 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ZUSATZFORMULAR_ANZAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 841,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,5);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ot.art = 1        /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = 5 /* Zusatzformularanzahl */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 5 /* Zusatzformularanzahl */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,5) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3902320440469425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ZUSATZFORMULAR_ANZAHL_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 910,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'P132_ZUSATZFORMULAR_ANZAHL',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3934015852699595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_VERRECHNUNGSLAND',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1120,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,8);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po , optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ot.art = 1        /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = 8 /* Verrechnungsland*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 8 /* Verrechnungsland*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,8) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3934330397703781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_VERRECHNUNGSLAND_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1121,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrechnungsland Db',
  p_source=>'P132_VERRECHNUNGSLAND',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3937616995567710 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_FAX',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 99,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'FAX',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3937824960570046 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 101,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'URL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3982227954590032 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PREISFAKTOR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1130,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'to_char(to_number(frgbg_s.get_pers_option(:APP_USER,23),''FM0.0999''),''FM0D0999'');',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,23) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3982900081619837 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PREISFAKTOR_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1132,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrechnungsland Db',
  p_source=>'P132_PREISFAKTOR',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4215527674541600 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1190,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4265712324152659 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ETIKETTENDRUCKER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 940,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,9);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,9) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4265926176156632 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ETIKETTENSCHACHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 950,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,12);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 2,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,12) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4266620204173860 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_DOKUMENTENDRUCKER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 960,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,10);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,10) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4266828862176365 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_DOKUMENTENSCHACHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 970,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,13);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 2,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,13) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4267125184184734 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_HCK_MED_DRUCKER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 980,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Hck Med Drucker',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,11);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,11) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4267304190188156 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_HCK_MED_SCHACHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 990,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,14);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 2,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,14) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4270027720393668 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ETIKETTENDRUCKER_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 941,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Etikettendrucker',
  p_source=>'P132_ETIKETTENDRUCKER',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4270313652399021 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ETIKETTENSCHACHT_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 951,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Schacht',
  p_source=>'P132_ETIKETTENSCHACHT',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4270628890403440 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_DOKUMENTENDRUCKER_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 961,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Dokumentendrucker',
  p_source=>'P132_DOKUMENTENDRUCKER',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4271317939409742 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_DOKUMENTENSCHACHT_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 971,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Schacht',
  p_source=>'P132_DOKUMENTENSCHACHT',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4271713914418053 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_HCK_MED_DRUCKER_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 981,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Hck Med Drucker',
  p_source=>'P132_HCK_MED_DRUCKER',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4271922572420525 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_HCK_MED_SCHACHT_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 991,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Schacht',
  p_source=>'P132_HCK_MED_SCHACHT',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4297416985271523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_LOGO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1142,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'LOGO_KLEIN',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => '''<img src="''||APEX_UTIL.GET_BLOB_FILE_SRC(''P132_LOGO'',:P132_LOGO_PERSSTAMM_ID)||''" />''',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4537615463461928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_BL_LOGO_LADEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 531,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Logo Laden',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4552203173777548 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_DRUCKART',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 810,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,15);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po , optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ot.art = 1        /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = 15 /* Druckart */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 15 /* Druckart */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,15) = 0 or frgbg_s.check_fas_rolle(:APP_USER,''DRUCKART_AENDERN'',:FAS_IDENTITAET_PERSSTAMM_ID)= 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4552901273814898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_DRUCKART_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 850,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'druckartdb',
  p_source=>'P132_DRUCKART',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5301112879044711 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ID_PARAMETER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1200,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5301516389074097 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1210,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6267024143681768 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_NV_KONFIGURATION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1180,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Konfiguration',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10210609231167307 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PERS_READONLY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1220,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>10315701133318079 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 73,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSZUSATZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12387225137923357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 680,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12387404854923365 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 690,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12387627827923365 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 82,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select substr(fas_synch.get_tab_uebersetzung(''LAND.LAND'',id,:fas_sprache_id),1,27)  a, id b'||unistr('\000a')||
'from v_laender'||unistr('\000a')||
'order by sort',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12388624178923368 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ANREDE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 67,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ANREDE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select  '||unistr('\000a')||
' fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',ID,:fas_sprache_id) a,'||unistr('\000a')||
' id b'||unistr('\000a')||
'from anreden_frgbg',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12389213452923370 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PAGE_TITEL_BETRANZEIGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 660,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Title Personenstammanzeige',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12390029272923371 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Änderung anwenden',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Ändern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'S',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12390415054923373 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12390606935923373 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_BL_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Löschen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12390829421923373 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_BL_PASSWORT_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 530,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Passwort ändern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Passwort Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12393228867923375 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Login Benutzer Name ist nicht veränderbar.';

wwv_flow_api.create_page_item(
  p_id=>12393424120923376 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 62,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'USER_ACCOUNT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'p132_id',
  p_read_only_when_type=>'ITEM_IS_NOT_NULL',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.'||unistr('\000a')||
'Der Eintrag muss mit mindestens einem Zeichen beginnen, anschliessend ein @-Zeichen beinhalten, danach beliebig viele Zeichen. Nach dem Punkt sind bis zu 4 Zeichen erlaubt. Allgemeiner Aufbau: [zeichen]@[zeichen].[zeichen]';

wwv_flow_api.create_page_item(
  p_id=>12393930192923381 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_EMAIL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 64,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'EMAIL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für dieses Seitenelement ist keine Hilfe verfügbar.';

wwv_flow_api.create_page_item(
  p_id=>12394428430923382 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PASSWORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 66,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PASSWORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>12394929453923382 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>12395424086923384 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 72,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'VORNAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>12395901312923384 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_STRASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 74,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'STRASSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 10 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>12396429247923384 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 76,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte mit Postleitzahlen in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 10 Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>12396903226923385 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PLZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 78,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PLZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 100 beliebige Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>12397415815923385 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*NVL(:P132_EXTERN_VERWALTET,1) = 1 /*GUS-Verwalt.*/'||unistr('\000a')||
':P132_PERS_READONLY = 1 /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12398411465923387 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_SATZKENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satzkennzeichen',
  p_source=>'SATZKENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Datumsangabe der Form TT.MM.JJJJ z.B. 20.11.2001';

wwv_flow_api.create_page_item(
  p_id=>12398815481923387 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'DD.MM.YYYY',
  p_source=>'GEBURTSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER_CLASSIC',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Auswahl des Geschlechts.';

wwv_flow_api.create_page_item(
  p_id=>12399313832923387 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_GESCHLECHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'GESCHLECHT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Anzeigesprache';

wwv_flow_api.create_page_item(
  p_id=>12399816246923387 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 97,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'APP_SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select s.sprache display_value, s.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs'||unistr('\000a')||
'where fs.id = :fas_schema_id  /* Schema der Login-Person */'||unistr('\000a')||
'  and fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  --and s.sprache_id in (select sprache_id from uebersetzungen) -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12431601058142296 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 700,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSE_ZEILE1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12432728762150337 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 710,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSE_ZEILE2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12433302228152112 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE3',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 720,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSE_ZEILE3',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12433908461153950 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE4',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 730,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSE_ZEILE4',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12604107172167939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE1_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 740,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12604917908171018 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE2_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 750,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12605728643174145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE3_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 760,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12606505225176835 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE4_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 770,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12609418432208984 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE1_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 780,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12610023626210526 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE2_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 790,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12610728475211915 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE3_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 800,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12611400901213425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ADRESSE_ZEILE4_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 810,
  p_item_plug_id => 12385812576923337+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12619909961320115 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ETIKETTENTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 820,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,1);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po , optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ot.art = 1        /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = 1  /* Etikettentyp */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 1 /* Etikettentyp */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,1) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12620523121323884 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_ETIKETTENANZAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 830,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,2);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ot.art = 1        /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = 2 /* Etikettenanzahl*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 2 /* Etikettenanzahl*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,2) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12621304551328006 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_PROD_AUFTRAG_ANZAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 840,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,3);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ot.art = 1        /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = 3 /*  Anzahl Produktionsauftraege */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 3 /*  Anzahl Produktionsauftraege */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,5) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12623218535341492 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 132,
  p_name=>'P132_MAX_SCREEN_HEIGHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1110,
  p_item_plug_id => 12618732078298165+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,4)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'frgbg_s.get_opttyp_zugriff(:APP_USER,4) = 0',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4829400728650445 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P132_LAND_ID',
  p_validation_sequence=> 1,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P132_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 12386422090923356 + wwv_flow_api.g_id_offset,
  p_associated_item=> 12387627827923365 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12401819296923395 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P132_LAND_exists',
  p_validation_sequence=> 23,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT count(*) into v_anz'||unistr('\000a')||
'   FROM   v_laender'||unistr('\000a')||
'   --WHERE  UPPER(land) = UPPER(:p132_land);'||unistr('\000a')||
'   WHERE id = :p132_land_id;'||unistr('\000a')||
'   IF v_anz != 1 THEN'||unistr('\000a')||
'      --RETURN(''Ungültige Eingabe im Feld Land!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Land ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(211,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P132_land_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> 'SAVE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 12387627827923365 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12402025190923395 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P132_PLZ_ORT_exists',
  p_validation_sequence=> 33,
  p_validation => 'DECLARE'||unistr('\000a')||
'    v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --IF UPPER(:p132_land) = ''SCHWEIZ'' THEN'||unistr('\000a')||
'   IF :p132_land_id = 198 THEN'||unistr('\000a')||
'      select count(*) INTO v_anz'||unistr('\000a')||
'      from v_orte'||unistr('\000a')||
'      where upper(ort) = upper(:p132_ort)'||unistr('\000a')||
'        and plz = :p132_plz;'||unistr('\000a')||
'      IF v_anz = 0 THEN'||unistr('\000a')||
'         --RETURN(''PLZ/Ort-Kombination ist ungültig!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(179,'||unistr('\000a')||
'                     :fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF; '||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Ort bzw. PLZ ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(209,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P132_plz_ort_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> 'SAVE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 12396903226923385 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12402215748923396 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'xp132_geburtsdatum_not_null',
  p_validation_sequence=> 43,
  p_validation => 'BEGIN'||unistr('\000a')||
' /* -- Geburtsdatum optional NEI 25.09.08'||unistr('\000a')||
'   IF :P132_GEBURTSDATUM IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- Geburtsdatum optional NEI 25.09.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> ':request = ''SAVE'' and 1=2',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 12398815481923387 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12402419514923396 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p132_geburtdatum_must_be_date',
  p_validation_sequence=> 53,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P132_GEBURTSDATUM IS NOT NULL THEN'||unistr('\000a')||
'      :P132_GEBURTSDATUM := '||unistr('\000a')||
'          to_char(to_date(:P132_GEBURTSDATUM,''DD.MM.RRRR''),''DD.MM.RRRR'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(HTMLDB_LANG.MESSAGE(''DATUM_UNGUELTIG''));'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Ungültiges Datum!',
  p_validation_condition=> 'SAVE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 12398815481923387 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12402610277923396 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p132_name_not_null',
  p_validation_sequence=> 93,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P132_NAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(206,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 12394929453923382 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12400626926923390 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P132_VORNAME_not_null',
  p_validation_sequence=> 103,
  p_validation => 'BEGIN'||unistr('\000a')||
'   -- NEI 03.07.08 kein Pflichtfeld mehr bei Betreuern'||unistr('\000a')||
'   /*'||unistr('\000a')||
'   IF :P132_VORNAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(205,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 12395424086923384 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12400817956923393 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P132_PLZ_not_null',
  p_validation_sequence=> 133,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P132_PLZ IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(209,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 12396903226923385 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12401020020923393 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P132_ORT_not_null',
  p_validation_sequence=> 143,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P132_ORT IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(210,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 12397415815923385 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12401223577923395 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P132_EMAIL_not_null',
  p_validation_sequence=> 153,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P132_EMAIL IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(203,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 12393930192923381 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 12401421988923395 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P132_EMAIL_check',
  p_validation_sequence=> 160,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF instr(:p132_email,''@'') <= 1 THEN'||unistr('\000a')||
'      --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(224,:fas_sprache_id));'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'   v_string := substr(:p132_email,instr(:p132_email,''@'')+1,length(:p132_email));'||unistr('\000a')||
'   v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'   IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'      --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(225,:fas_sprache_id));'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'   -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'   IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'      --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(226,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,     '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(203,:fas_sprache_id)),'||unistr('\000a')||
'            ''Validierung p132_email_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> 'SAVE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 12393930192923381 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3985632137168470 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P132_PREISFAKTOR',
  p_validation_sequence=> 170,
  p_validation => 'DECLARE '||unistr('\000a')||
'   v_zahl    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_zahl := to_number(:P132_PREISFAKTOR,''999D999'');'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(3533,:fas_sprache_id));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 12624313817349665 + wwv_flow_api.g_id_offset,
  p_associated_item=> 3982227954590032 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'/* 16.09.08 Keine Vorbelegung mehr'||unistr('\000a')||
'   IF :p132_adresse_zeile1 IS NULL AND '||unistr('\000a')||
'      :p132_adresse_zeile2 IS NULL AND'||unistr('\000a')||
'      :p132_adresse_zeile3 IS NULL AND'||unistr('\000a')||
'      :p132_adresse_zeile4 IS NULL '||unistr('\000a')||
'   THEN   -- Adresszeilen aus Personenstamm mit ID=1 anzeigen => Default'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT adresse_zeile1,adresse_zeile2,'||unistr('\000a')||
'                adresse_zeile3,adresse_zeile4'||unistr('\000a')||
'         INTO :p132_adresse';

p:=p||'_zeile1_disp, '||unistr('\000a')||
'              :p132_adresse_zeile2_disp,'||unistr('\000a')||
'              :p132_adresse_zeile3_disp,'||unistr('\000a')||
'              :p132_adresse_zeile4_disp'||unistr('\000a')||
'         FROM personenstamm'||unistr('\000a')||
'         WHERE id = 1;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSE  -- manuell geänderte Adresszeilen aus Personenstamm anzeigen'||unistr('\000a')||
'      :p132_adresse_zeile1_disp := :p132_adresse_zeile1; '||unistr('\000a')||
'      :p132_adresse';

p:=p||'_zeile2_disp := :p132_adresse_zeile2;'||unistr('\000a')||
'      :p132_adresse_zeile3_disp := :p132_adresse_zeile3;'||unistr('\000a')||
'      :p132_adresse_zeile4_disp := :p132_adresse_zeile4;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p132_adresse_zeile1_db := :p132_adresse_zeile1_disp; '||unistr('\000a')||
'   :p132_adresse_zeile2_db := :p132_adresse_zeile2_disp;'||unistr('\000a')||
'   :p132_adresse_zeile3_db := :p132_adresse_zeile3_disp;'||unistr('\000a')||
'   :p132_adresse_zeile4_db := :p132_adresse_zeile4_disp;'||unistr('\000a')||
'*/ NULL;';

p:=p||''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12601530113155660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'xadresszeilen_initialisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'1=2',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p132_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p132_bl_loeschen  := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p132_bl_aendern   := frgbg_s.holen_uebersetzung(162,v_sprache_id);'||unistr('\000a')||
'   :p132_bl_passwort_chg := frgbg_s.holen_uebersetzung(171,v_sprache_id);'||unistr('\000a')||
'   :p132_bl_Logo_Laden := frgbg_';

p:=p||'s.holen_uebersetzung(2250,v_sprache_id);'||unistr('\000a')||
'   IF frgbg_s.check_user_typ(:app_user,''I'') = 1 THEN -- Identität'||unistr('\000a')||
'      :P132_PAGE_TITEL_BETRANZEIGE := frgbg_s.holen_uebersetzung(3579,v_sprache_id);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :P132_PAGE_TITEL_BETRANZEIGE := frgbg_s.holen_uebersetzung(1592,v_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :P132_NV_KONFIGURATION := frgbg_s.holen_uebersetzung(3834,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''Page 132,button_la';

p:=p||'bles_init Test perbetreuer  fas_schema %1 , Index --%2'',v_prot_id,''Info'',''Fragebogen'',:fas_schema_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12403324506923404 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:PERSONENSTAMM:P132_ID:ID|IU';

wwv_flow_api.create_page_process(
  p_id     => 12402912032923403 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 11,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'personenstamm_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_zahl         number; '||unistr('\000a')||
'   v_return       number;'||unistr('\000a')||
'   v_fehlertext   varchar2(2000);'||unistr('\000a')||
'   v_prot_id      number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''Personenstamm-Option Prodauf User_account:%1, akt.Ident: %2, Wert: %3,DBWert:%4'','||unistr('\000a')||
'--        v_prot_id,''Fehler'',''frgbg_s.save_pers_optionen'','||unistr('\000a')||
'--     :APP_USER, :fas_identitaet_persstamm_id, --to_char(:P132_preisfaktor),to_char(:P132_preisfaktor_DB)'||unistr('\000a')||
'--          );'||unistr('\000a')||
''||unistr('\000a')||
'';

p:=p||'   /* Druckart Option speichern nur falls Betreuer auch die Rolle Druckart_aendern besitzt */'||unistr('\000a')||
'   IF NVL(:P132_druckart_DB,''#0#'') != NVL(:P132_druckart,''#0#'') AND'||unistr('\000a')||
'      frgbg_s.check_fas_rolle(:APP_USER,''DRUCKART_AENDERN'')> 0 '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,15,:P132_druckart);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sp';

p:=p||'rache_id);'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'    /* Etikettentyp Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_ETIKETTENTYP_DB,''#0#'') != NVL(:P132_ETIKETTENTYP,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,1,:P132_ETIKETTENTYP);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'         R';

p:=p||'AISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Etikettenanz Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_ETIKETTENANZAHL_DB,''#0#'') != NVL(:P132_ETIKETTENANZAHL,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,2,:P132_ETIKETTENANZAHL);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'         RAISE_APPLICAT';

p:=p||'ION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Anzahl Produktionsauftraege Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_PROD_AUFTRAG_ANZAHL_DB,''#0#'') != NVL(:P132_PROD_AUFTRAG_ANZAHL,''#0#'') '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,3,:P132_PROD_AUFTRAG_ANZAHL);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'     ';

p:=p||'    RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Anzahl Zusatzformular Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_zusatzformular_anzahl_DB,''#0#'') != NVL(:P132_zusatzformular_ANZAHL,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,5,:P132_zusatzformular_ANZAHL);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_spra';

p:=p||'che_id);'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Etikettendrucker Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_etikettendrucker_DB,''#0#'') != NVL(:P132_etikettendrucker,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,9,:P132_etikettendrucker);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id';

p:=p||');'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Etikettenschacht Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_etikettenschacht_DB,''#0#'') != NVL(:P132_etikettenschacht,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,12,:P132_etikettenschacht);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'  ';

p:=p||'       RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Dokumentendrucker Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_dokumentendrucker_DB,''#0#'') != NVL(:P132_dokumentendrucker,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,10,:P132_dokumentendrucker);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'   ';

p:=p||'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Dokumentenschacht Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_dokumentenschacht_DB,''#0#'') != NVL(:P132_dokumentenschacht,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,13,:P132_dokumentenschacht);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'    ';

p:=p||'     RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* HCK-MED-Drucker Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_hck_med_drucker_DB,''#0#'') != NVL(:P132_hck_med_drucker,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,11,:P132_hck_med_drucker);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'         RAIS';

p:=p||'E_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* HCK-MED-Schacht Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_hck_med_schacht_DB,''#0#'') != NVL(:P132_hck_med_schacht,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,14,:P132_hck_med_schacht);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'         RAISE_APPLICA';

p:=p||'TION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Pixel Anzeigehöhe Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_MAX_SCREEN_HEIGHT_DB,''#0#'') != NVL(:P132_MAX_SCREEN_HEIGHT,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,4,:P132_MAX_SCREEN_HEIGHT);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'         RAISE_APPLICATI';

p:=p||'ON_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      :FAS_SCROLLREGION_HEIGHT_MAX := :P132_MAX_SCREEN_HEIGHT;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Verrechnungsland Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_VERRECHNUNGSLAND_DB,''#0#'') != NVL(:P132_VERRECHNUNGSLAND,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,8,:P132_VERRECHNUNGSLAND);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_ueb';

p:=p||'ersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Preisfaktor Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_PREISFAKTOR_DB,''#0#'') != NVL(:P132_PREISFAKTOR,''#0#'') THEN'||unistr('\000a')||
'      v_zahl := to_number(:P132_PREISFAKTOR,''FM0D0999'');'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,23,to_char(v_zahl,''FM0.0999''));'||unistr('\000a')||
'                      --:P13';

p:=p||'2_PREISFAKTOR);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Logo-Etikett Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_LOGO_ETIKETT_DB,''#0#'') != NVL(:P132_LOGO_ETIKETT,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,20,:P132_LOGO_ETIKETT);'||unistr('\000a')||
'     ';

p:=p||' IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   /* Produzierende Apotheke Option speichern */'||unistr('\000a')||
'   IF NVL(:P132_PRODUZIERENDE_APOTHEKE_DB,''#0#'') != NVL(:P132_PRODUZIERENDE_APOTHEKE,''#0#'') THEN'||unistr('\000a')||
'      v_return := frgbg_s.save_pers_optionen(:APP_USER,21,:P132_PRODUZIEREN';

p:=p||'DE_APOTHEKE);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1595,:fas_sprache_id);'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 3000304402041304 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 12,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'optionen_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>12624313817349665 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'-- Da evt. beim Speichern die Patientensprache geändert wird, kann dies '||unistr('\000a')||
'-- auf die FAS-Sprache auswirkungen haben => FAS-Sprache neu bestimmen'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :fas_sprache_id:= frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12404519016923409 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fas_sprache_festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 2176420108620709 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 41,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'   v_return NUMBER;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*mel.p(''Page 132,get_personendaten Test perbetreuer  fas_schema %1 , Index %2'',v_prot_id,''Info'',''Fragebogen'',:fas_schema_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :fas_aufgerufen_von in (''BETREUER'',''IDENTITAET'') THEN -- Stammdaten der Login-Person bearbeiten'||unistr('\000a')||
'      :p132_id := NVL(:p132_id_parameter,:fas_login_pe';

p:=p||'rsonenstamm_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12404127721923404 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 9,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten',
  p_process_sql_clob => p,
  p_process_error_message=> 'Login ungültig!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p132_prepare_url_pw:= apex_util.prepare_url('||unistr('\000a')||
'   ''f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_ID:''||:P132_ID);';

wwv_flow_api.create_page_process(
  p_id     => 2732928440250262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 51,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_prepare_url_pw',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:PERSONENSTAMM:P132_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 12403109646923404 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 52,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'personenstamm_holen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   /* z.B. GUS-Adr. darf nicht im FAS verändert werden */'||unistr('\000a')||
'   :p132_pers_readonly:=frgbg_T.check_pers_extern_verwaltet(:p132_EXTERN_VERWALTET ) ; '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 10210712682170536 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 61,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_adr_readonly',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'    :p132_satzkennzeichen := ''GELOESCHT''; '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12403711655923404 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 21,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_satz_delete',
  p_process_sql_clob => p,
  p_process_error_message=> 'Datensatz konnte nicht gelöscht werden!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>12386807726923356 + wwv_flow_api.g_id_offset,
  p_process_success_message=> 'Datensatz wurde erfolgreich gelöscht!',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p132_mutuser := :APP_USER;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12404301599923407 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 22,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mutuser_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'/* NEI 16.09.08 Adresszeilen nicht mehr vorbelegen'||unistr('\000a')||
'  IF NVL(:p132_adresse_zeile1_disp,''##NULL##'') != NVL(:p132_adresse_zeile1_db,''##NULL##'') OR'||unistr('\000a')||
'     NVL(:p132_adresse_zeile2_disp,''##NULL##'') != NVL(:p132_adresse_zeile2_db,''##NULL##'') OR'||unistr('\000a')||
'     NVL(:p132_adresse_zeile3_disp,''##NULL##'') != NVL(:p132_adresse_zeile3_db,''##NULL##'') OR'||unistr('\000a')||
'     NVL(:p132_adresse_zeile4_disp,''##NULL##'') != NVL(:p132_adre';

p:=p||'sse_zeile4_db,''##NULL##'')'||unistr('\000a')||
'  THEN  -- Adresszeilen manuell geändert => im Personenstamm speichern; '||unistr('\000a')||
'     :p132_adresse_zeile1 := :p132_adresse_zeile1_disp; '||unistr('\000a')||
'     :p132_adresse_zeile2 := :p132_adresse_zeile2_disp;'||unistr('\000a')||
'     :p132_adresse_zeile3 := :p132_adresse_zeile3_disp;'||unistr('\000a')||
'     :p132_adresse_zeile4 := :p132_adresse_zeile4_disp;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
'*/ NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12613616616227448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 132,
  p_process_sequence=> 41,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'xadresszeilen_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>12386422090923356 + wwv_flow_api.g_id_offset,
  p_process_when=>'1=2',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 132
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00133
prompt  ...PAGE 133: Betreuerpatliste_rechnungsauswahl
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 133
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Betreuerpatliste_rechnungsauswahl'
 ,p_step_title => 'Betreuerpatliste_rechnungsauswahl'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Betreuerpatliste_rechnungsauswahl'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150306105728'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT distinct '||unistr('\000a')||
'  p.SUCHNAME, p.SUCHADRESSE, p.SUCHZUSATZ,'||unistr('\000a')||
'  p.geburtsdatum, '||unistr('\000a')||
'  p.PERSONENSTAMM_ID personenstamm_id_disp, '||unistr('\000a')||
'  p1.gus_id fas_gus_id,'||unistr('\000a')||
'  CASE p1.betreuer'||unistr('\000a')||
'      WHEN ''I'' THEN  frgbg_s.holen_uebersetzung(3101,:fas_sprache_id)'||unistr('\000a')||
'      WHEN ''J'' THEN  frgbg_s.holen_uebersetzung(1854,:fas_sprache_id)'||unistr('\000a')||
'      WHEN ''N'' THEN  frgbg_s.holen_uebersetzung(3578,:fas_sprache_id)'||unistr('\000a')||
'      ELSE frgbg_s.hole';

s:=s||'n_uebersetzung(47,:fas_sprache_id)||'': ''||p1.betreuer'||unistr('\000a')||
'      END  typ,'||unistr('\000a')||
'  p.PERSONENSTAMM_ID'||unistr('\000a')||
'from v_pers_zusatzadressen p, personenstamm p1'||unistr('\000a')||
'where :p133_patliste_anzeigen = 1 -- Liste anzeigen'||unistr('\000a')||
'  and p.PERSONENSTAMM_ID=p1.id    -- Join'||unistr('\000a')||
'  and'||unistr('\000a')||
'(   -- Alle abhängigen Adressen zum Patient'||unistr('\000a')||
'    ( --:fas_aufgerufen_von != ''BETREUER''           -- Endkundenzugriff'||unistr('\000a')||
'      --and p.PERSONENSTAMM_ID_BETREUER is nul';

s:=s||'l     -- NEI  13.02.15 nicht mehr nur beschränkt auf Endkundenzugriff, da Webshop'||unistr('\000a')||
'      --and                                         -- diese Adressen auch anlegt und Betreuer sie sehen sollte'||unistr('\000a')||
'      p.PERSONENSTAMM_ID_MASTER = :P133_PERSSTAMM_PATIENT_ID'||unistr('\000a')||
'    )'||unistr('\000a')||
'    -- Alle zugreifbaren Adressen des Betreuers'||unistr('\000a')||
'OR  ( --:fas_aufgerufen_von = ''BETREUER'' -- Betreuerzugriff'||unistr('\000a')||
'      --and p.personenstamm_id_';

s:=s||'betreuer is not null -- NEI  13.02.15'||unistr('\000a')||
'      --and '||unistr('\000a')||
'      p.personenstamm_id_betreuer in '||unistr('\000a')||
'        (SELECT persstamm_id_betreuerzugriff'||unistr('\000a')||
'         FROM pers_zugriffe'||unistr('\000a')||
'         WHERE persstamm_id_betreuer = :p133_personenstamm_id_betreuer'||unistr('\000a')||
'                /* NEI 11.01.10 */'||unistr('\000a')||
'           AND (:p133_patientenzugriff = 0   OR /* Stdzugriff*/  '||unistr('\000a')||
'                :p133_patientenzugriff = 1 AND  /* IABC-Betreuerzu';

s:=s||'griff */ '||unistr('\000a')||
'                persstamm_id_betreuer = persstamm_id_betreuerzugriff '||unistr('\000a')||
'               )'||unistr('\000a')||
'        )'||unistr('\000a')||
'  -- Bei Patientenauswahl muss die aktive Identitaet der vorgegebene entsprech.'||unistr('\000a')||
'  and (--:P133_EXTERN_TYP = ''P'' and '||unistr('\000a')||
'       --p.personenstamm_id_betreuer = :fas_identitaet_persstamm_id  OR'||unistr('\000a')||
'       --:P133_EXTERN_TYP != ''P'''||unistr('\000a')||
'       p.personenstamm_id_betreuer = :fas_identitaet_persstamm_id'||unistr('\000a')||
'     ';

s:=s||' )'||unistr('\000a')||
'    )'||unistr('\000a')||
'OR -- 17.07.14 Bei HepartMitarbeiter mit Masterzugriff dürfen alle Identitäten mit GUS-ID '||unistr('\000a')||
'   --          als Liefer-/Rechnungsadresse gewählt werden'||unistr('\000a')||
'   (:P133_PATIENTENMASTERZUGRIFF = 1 and p1.betreuer = ''I'' AND p1.gus_id is not null)'||unistr('\000a')||
')'||unistr('\000a')||
'and '||unistr('\000a')||
'  (  -- Suchanfrage'||unistr('\000a')||
'  p.normname like ''%''||:P133_SUCHNAME_NORM||''%'' '||unistr('\000a')||
'  AND (UPPER(p.suchadresse) like ''%''||UPPER(:p133_suchadresse)||''%'' '||unistr('\000a')||
'       OR ';

s:=s||':p133_suchadresse IS NULL)'||unistr('\000a')||
'  )'||unistr('\000a')||
'/* NEI 12.12.12 Keine Betreuer mehr als Rechnungs-/Lieferadresse */'||unistr('\000a')||
'and p1.betreuer != ''J'''||unistr('\000a')||
'order by p.suchname,p.geburtsdatum';

wwv_flow_api.create_report_region (
  p_id=> 3026430112735353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 133,
  p_name=> '&P133_PAGE_TITEL_ADRESSLISTE.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P133_HEIGHT_PATIENTENLISTE.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(1598,frgbg_s.get_sprache_id(:APP_USER)));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '300',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '10000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3759504430094829 + wwv_flow_api.g_id_offset,
  p_region_id=> 3026430112735353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHNAME',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3759619051094829 + wwv_flow_api.g_id_offset,
  p_region_id=> 3026430112735353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHADRESSE',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3759717518094831 + wwv_flow_api.g_id_offset,
  p_region_id=> 3026430112735353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHZUSATZ',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3026817556735354 + wwv_flow_api.g_id_offset,
  p_region_id=> 3026430112735353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'GEBURTSDATUM',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3759807214094831 + wwv_flow_api.g_id_offset,
  p_region_id=> 3026430112735353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PERSONENSTAMM_ID_DISP',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 12515719959329908 + wwv_flow_api.g_id_offset,
  p_region_id=> 3026430112735353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'FAS_GUS_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 12444528531150129 + wwv_flow_api.g_id_offset,
  p_region_id=> 3026430112735353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'TYP',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':P133_PATIENTENMASTERZUGRIFF=1',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3027312565735354 + wwv_flow_api.g_id_offset,
  p_region_id=> 3026430112735353 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'PERSONENSTAMM_ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:110,140,201,131:P110_PERSON,P110_PERSSTAMM_ID_EXTERN_UPD,P110_EXTERN_TYP:&P133_PERSSTAMM_PATIENT_ID.,#PERSONENSTAMM_ID#,&P133_EXTERN_TYP.',
  p_column_linktext=>'<img src="#IMAGE_PREFIX#edit_big.gif"  border="0">',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'N',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3168401606576231 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 133,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 3027413588735354 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 133,
  p_button_sequence=> 10,
  p_button_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_button_name    => 'ABBRECHEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P133_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:133:P110_PERSON:&P133_PERSSTAMM_PATIENT_ID.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3027609913735356 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 133,
  p_button_sequence=> 5,
  p_button_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P133_BL_SUCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3027818824735356 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 133,
  p_button_sequence=> 30,
  p_button_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_button_name    => 'ALLE_ANZEIGEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P133_BL_ALLE_ANZEIGEN.',
  p_button_position=> 'REGION_TEMPLATE_NEXT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3031332094735360 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:133:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-SEP-2007 15:09 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1347520835688216 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_SUCHNAME_NORM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Norm',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1348203183758828 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_PATIENTENZUGRIFF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Patientenzugriff',
  p_source=>'NVL(frgbg_s.get_pers_option(:APP_USER,28),0)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2810729347349464 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_PATLISTE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Flag Liste leer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2810909392353162 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_SUCH_PERSSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2811130863359392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_SUCH_PIS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3028001905735356 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_APP_SPRACHE_ID_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'App Sprache Id Betreuer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3028218408735356 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_PERSONENSTAMM_ID_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Betreuer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3028420566735356 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3028621045735356 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_PAGE_TITEL_ADRESSLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3028803745735357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 25,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3029019250735357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_SUCHNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3029221171735357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_SUCHADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 25,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3029407037735357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_SUCHZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 25,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3029603827735357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_BL_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Suchen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3029826767735357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_PERSSTAMM_PATIENT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'personenstamm_id_patient',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3030017096735357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_BL_ALLE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3030214661735359 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_HEIGHT_PATIENTENLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3719418981829890 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_EXTERN_TYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 115,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Extern Typ',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6267715448726543 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_NV_AUSWAHL_ADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Auswahl Adresse',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8501513173809315 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_GUS_ID_PATIENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12481313431485479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 133,
  p_name=>'P133_PATIENTENMASTERZUGRIFF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 3026430112735353+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Master',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p133_suchname_norm:= frgbg_t.NORMSTRING(:p133_suchname,2);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1347627761690231 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 133,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'suchstring_aufbauen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Komplette Höhe ausnutzen (100% des Maximums)'||unistr('\000a')||
'   :P133_HEIGHT_Patientenliste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3031010725735360 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 133,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user VARCHAR2(100);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p133_personenstamm_id_betreuer is null THEN   -- externes Login  wird mit dem aktuellen Benutzer bestückt'||unistr('\000a')||
'      v_user  := :APP_USER;'||unistr('\000a')||
'      SELECT id,app_sprache_id '||unistr('\000a')||
'      INTO :p133_personenstamm_id_betreuer , '||unistr('\000a')||
'           :p133_app_sprache_id_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE UPPER(user_account) = UPPER(v_user)'||unistr('\000a')||
'        AND satzkennzeichen ';

p:=p||'is null;  -- gelöschte Sätze nicht mehr anzeigen'||unistr('\000a')||
'   ELSE  -- Momentan noch nicht genutzt: Aufruf via Pis p133_personenstamm_id_betreuer enthält bereits die Personenstamm_id'||unistr('\000a')||
'      SELECT id,app_sprache_id      '||unistr('\000a')||
'      INTO :p133_personenstamm_id_betreuer , '||unistr('\000a')||
'           :p133_app_sprache_id_betreuer'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE id = :p133_personenstamm_id_betreuer;  '||unistr('\000a')||
'   END IF; '||unistr('\000a')||
' '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3030422542735359 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 133,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten_betreuer',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p133_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p133_bl_suchen := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p133_bl_alle_anzeigen := frgbg_s.holen_uebersetzung(511,v_sprache_id);'||unistr('\000a')||
'   :P133_PAGE_TITEL_ADRESSLISTE:= '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(1599,v_sprache_id);'||unistr('\000a')||
'   :P13';

p:=p||'3_NV_AUSWAHL_ADRESSE :=frgbg_s.holen_uebersetzung(3836,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3030620168735359 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 133,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT gus_id '||unistr('\000a')||
'INTO :p133_GUS_ID_PATIENT'||unistr('\000a')||
'FROM personenstamm'||unistr('\000a')||
'where id = :P133_PERSSTAMM_PATIENT_ID;';

wwv_flow_api.create_page_process(
  p_id     => 8501614436875923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 133,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_gus_id_patient',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_PERSSTAMM_ID_ident   personenstamm.id%type;'||unistr('\000a')||
'begin'||unistr('\000a')||
'   -- Ident der Login-Person'||unistr('\000a')||
'   v_PERSSTAMM_ID_ident:= frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'   -- Masterzugriff für Ident der LOGIN-Person oder der Person selbst prüfen'||unistr('\000a')||
'   :P133_PATIENTENMASTERZUGRIFF := NVL(frgbg_s.GET_PERS_OPTION(NULL,43 ,    '||unistr('\000a')||
'            v_PERSSTAMM_ID_ident,:FAS_LOGIN_PERSONENSTAMM_ID),0);'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 12481410013489302 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 133,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_patientenzugriff',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||' :p133_patliste_anzeigen := 1;';

wwv_flow_api.create_page_process(
  p_id     => 2811500651369531 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 133,
  p_process_sequence=> 5,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'patliste_leer_initialisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p133_suchname := NULL;'||unistr('\000a')||
'   :p133_suchadresse := NULL;'||unistr('\000a')||
'   :p133_suchzusatz := NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3030811734735359 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 133,
  p_process_sequence=> 10,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'clear_such_felder',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>3027818824735356 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 133
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00134
prompt  ...PAGE 134: Betreuer-Logo laden
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 134
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Betreuer-Logo laden'
 ,p_step_title => 'Bild Laden'
 ,p_step_sub_title => 'Bild Laden'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130130115723'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4312629804951939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 134,
  p_plug_name=> '&P134_PAGE_TITEL_LOGO_LADEN.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_2',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4312818965951945 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 134,
  p_button_sequence=> 5,
  p_button_plug_id => 4312629804951939+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P134_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4313018111951948 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 134,
  p_button_sequence=> 10,
  p_button_plug_id => 4312629804951939+wwv_flow_api.g_id_offset,
  p_button_name    => 'UPLOAD_IMAGE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P134_BL_LOGO.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4583418731548581 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 134,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:134:&SESSION.:WINDOW_CLOSE:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4312818965951945+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 23-SEP-2008 11:08 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4585909624763637 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 134,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:134:&SESSION.:WINDOW_CLOSE_REFRESH:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4313018111951948+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 23-SEP-2008 11:43 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4586115165765251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 134,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:134:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 40,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 23-SEP-2008 11:44 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4319132596203298 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 134,
  p_name=>'P134_DATEINAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 4312629804951939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_FILE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'WWV_FLOW_FILES',
  p_attribute_06 => 'N',
  p_attribute_08 => 'inline',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4538324729483589 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 134,
  p_name=>'P134_BL_LOGO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4312629804951939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4538500618486050 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 134,
  p_name=>'P134_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4312629804951939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4538901442495740 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 134,
  p_name=>'P134_PAGE_TITEL_LOGO_LADEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 4312629804951939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Logo Laden',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4734215772373346 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 134,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P134_DATEINAME',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_endung VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   select Decode(instr(:p134_dateiname,''.'',-1,1),'||unistr('\000a')||
'                 0,'''',   -- falls kein Punkte gefunden=> Endung leer'||unistr('\000a')||
'                 substr(:p134_dateiname,instr(:p134_dateiname,''.'',-1,1)+1))'||unistr('\000a')||
'   into v_endung'||unistr('\000a')||
'   from dual;'||unistr('\000a')||
'   IF UPPER(v_endung) in (''JPG'',''PNG'') THEN'||unistr('\000a')||
'      NULL; -- ok'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Ungültiges Dateiformat! Erlaubte Bildformate *.jpg oder *.png.'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(2444,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4313018111951948 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4319132596203298 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p134_bl_abbrechen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   :p134_bl_Logo := frgbg_s.holen_uebersetzung(2250,v_sprache_id);'||unistr('\000a')||
'   :P134_PAGE_TITEL_LOGO_laden := frgbg_s.holen_uebersetzung(2251,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4537911784470314 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 134,
  p_process_sequence=> 51,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'htp.p(''<body>'');'||unistr('\000a')||
'htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'IF :request = ''WINDOW_CLOSE_REFRESH'' THEN'||unistr('\000a')||
'   htp.p(''parent.window.opener.location.reload();'');'||unistr('\000a')||
'END IF;'||unistr('\000a')||
'htp.p(''window.close(this);'');'||unistr('\000a')||
'htp.p(''</script>'');'||unistr('\000a')||
'htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4585007284744025 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 134,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'window_close',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':REQUEST in (''WINDOW_CLOSE'',''WINDOW_CLOSE_REFRESH'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id          NUMBER;'||unistr('\000a')||
'   v_bild             blob  := to_blob(''0'');'||unistr('\000a')||
'   v_thumb            blob  := to_blob(''0'');'||unistr('\000a')||
'   v_thumb_klein      blob  := to_blob(''0'');'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P134_dateiname  IS not null THEN '||unistr('\000a')||
'      -- Logo laden'||unistr('\000a')||
'      SELECT BLOB_CONTENT  into v_bild'||unistr('\000a')||
'      FROM HTMLDB_APPLICATION_FILES'||unistr('\000a')||
'      WHERE NAME = :P134_dateiname;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Logo auf definierte Grösse bringen'||unistr('\000a')||
'   ';

p:=p||'   ORDSYS.ORDImage.processCopy(v_bild, ''maxscale=960 600'', v_thumb);'||unistr('\000a')||
'      ORDSYS.ORDImage.processCopy(v_bild, ''maxscale=48 30'', v_thumb_klein);'||unistr('\000a')||
'      --v_thumb := v_bild ;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Logo ändern'||unistr('\000a')||
'      update personenstamm '||unistr('\000a')||
'      set logo = v_thumb,'||unistr('\000a')||
'          logo_klein = v_thumb_klein'||unistr('\000a')||
'      where id = :P132_ID;'||unistr('\000a')||
''||unistr('\000a')||
'      DELETE FROM HTMLDB_APPLICATION_FILES WHERE NAME = :P134_dateiname;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'     ';

p:=p||' -- Logo entfernen'||unistr('\000a')||
'      update personenstamm'||unistr('\000a')||
'      set logo = v_bild,'||unistr('\000a')||
'          logo_klein = v_bild'||unistr('\000a')||
'      where id = :P132_ID;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4313605453951956 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 134,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'save_logo',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4313018111951948 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_fehlertext    VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF frgbg_s.check_user_typ(:app_user,''I'')!= 1 THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3110,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2633924716434759 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 134,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_zugriff',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 134
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00135
prompt  ...PAGE 135: IDENTITAETENLISTE
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 135
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'IDENTITAETENLISTE'
 ,p_step_title => 'IDENTITAETENLISTE'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'IDENTITAETENLISTE'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140716094316'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6834529132510442 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 135,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT '||unistr('\000a')||
'     --substr(p.name,1,30)||'', ''||substr(p.ort,1,30)||'', ''||p.id name, p.id id'||unistr('\000a')||
'     x.suchname,x.suchadresse,x.suchzusatz,x.PERSSTAMM_ID,x.gus_id,'||unistr('\000a')||
'     CASE '||unistr('\000a')||
'    --WHEN frgbg_s.wkwv_check_zugriff (z.persstamm_id_betreuer ,x.PERSSTAMM_ID) = 0  THEN   -- für Betreuer kein WK möglich'||unistr('\000a')||
'    WHEN frgbg_s.wkwv_check_zugriff ( :FAS_LOGIN_PERSONENSTAMM_ID ,x.PERSSTAMM_ID) = 0  THEN   -- für Betreuer';

s:=s||' kein WK möglich'||unistr('\000a')||
'               '' '''||unistr('\000a')||
'     ELSE'||unistr('\000a')||
'        ''<a class="shopping_cart_link" onclick="return false" href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'        ''f?p=''||:APP_ID||'':500:''||:APP_SESSION||''::&DEBUG.:500:''||'||unistr('\000a')||
'        ''P500_PERSSTAMM_ID,P500_ZURUECK_SEITE:'''||unistr('\000a')||
'        ||x.PERSSTAMM_ID||'',''||:APP_PAGE_ID) || ''"'''||unistr('\000a')||
'        ||'' onmouseover="javascript:toolTip_enable(event,this,''''''||frgbg_s.holen_uebersetzung';

s:=s||'(9222,:fas_sprache_id)||'''''')"'''||unistr('\000a')||
'        ||''>'''||unistr('\000a')||
'        || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'        || ''</a>'''||unistr('\000a')||
'     END wk_link'||unistr('\000a')||
'FROM v_perslisten x,personenstamm p, pers_identitaeten pi '||unistr('\000a')||
'WHERE (p.id in (SELECT persstamm_id_betreuerzugriff -- Betreuer hat Zugriff'||unistr('\000a')||
'                FROM pers_zugriffe '||unistr('\000a')||
'                WHERE persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID '||unistr('\000a')||
'      ';

s:=s||'         )'||unistr('\000a')||
'       OR :p135_WV_master = 1                                        -- Betreuer hat Masterzugriff'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and p.id = x.persstamm_id'||unistr('\000a')||
'  AND p.betreuer = ''I'''||unistr('\000a')||
'  AND p.gus_id is not null   -- Identität muss in GUS verfügbar sein'||unistr('\000a')||
'  AND p.id = pi.persstamm_id_identitaet -- Join, damit nur korrekt angelegte Identitäten angezeigt werden'||unistr('\000a')||
'  -- Adresssuche'||unistr('\000a')||
'  AND (x.normname  like ''%''||:p135_such';

s:=s||'name_norm||''%'' '||unistr('\000a')||
'       OR :p135_suchname IS NULL)'||unistr('\000a')||
'  AND (UPPER(x.suchadresse) like ''%''||UPPER(:p135_suchadresse)||''%'' '||unistr('\000a')||
'       OR :p135_suchadresse IS NULL)'||unistr('\000a')||
'  AND ((UPPER(x.suchzusatz) like ''%''||UPPER(:p135_suchzusatz)||''%'' '||unistr('\000a')||
'             and x.persstamm_id is not null) -- nur dann gibts suchzusatz'||unistr('\000a')||
'       OR :p135_suchzusatz IS NULL)'||unistr('\000a')||
'  AND (x.persstamm_id = :p135_such_persstamm_id'||unistr('\000a')||
'       OR :P135_SU';

s:=s||'CH_PERSSTAMM_ID IS NULL)'||unistr('\000a')||
'  AND (x.gus_id = :p135_such_gus_id'||unistr('\000a')||
'       OR :p135_such_gus_id IS NULL)'||unistr('\000a')||
''||unistr('\000a')||
'order by suchname';

wwv_flow_api.create_report_region (
  p_id=> 6834713197510448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 135,
  p_name=> '&P135_PAGE_TITEL_IDENTLISTE.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P130_HEIGHT_PATIENTENLISTE.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(9087,frgbg_s.get_sprache_id(:APP_USER)));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '800',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_WITH_LINKS',
  p_query_row_count_max=> '10000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'XLS',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_output_file_name=> 'Patientenliste',
  p_prn_content_disposition=> 'ATTACHMENT',
  p_prn_document_header=> 'APEX',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width_units=> 'PERCENTAGE',
  p_prn_width=> 210,
  p_prn_height=> 297,
  p_prn_orientation=> 'VERTICAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'LEFT',
  p_prn_page_footer_alignment=> 'LEFT',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6847518079970780 + wwv_flow_api.g_id_offset,
  p_region_id=> 6834713197510448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHNAME',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '3',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6847600928970780 + wwv_flow_api.g_id_offset,
  p_region_id=> 6834713197510448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHADRESSE',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '3',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6847732564970780 + wwv_flow_api.g_id_offset,
  p_region_id=> 6834713197510448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHZUSATZ',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '3',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6847824301970780 + wwv_flow_api.g_id_offset,
  p_region_id=> 6834713197510448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'PERSSTAMM_ID',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '3',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6848009899977886 + wwv_flow_api.g_id_offset,
  p_region_id=> 6834713197510448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'GUS_ID',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '3',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6848223320000635 + wwv_flow_api.g_id_offset,
  p_region_id=> 6834713197510448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'WK_LINK',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '3',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6836232452510458 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 135,
  p_button_sequence=> 10,
  p_button_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_button_name    => 'ABBRECHEN',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P135_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P135_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:135::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6836629129510465 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 135,
  p_button_sequence=> 5,
  p_button_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P135_BL_SUCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6845108092510509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:135:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-SEP-2007 15:09 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6837610654510473 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_SUCH_PERSSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 82,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p135_suchart=0',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6837815024510474 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_SUCH_GUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 84,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p135_suchart=0 and :fas_modus_id = 0',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6838031129510474 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_SUCHREZEPTBEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p135_suchart=1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6838214585510475 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_SUCHREZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p135_suchart=1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6838407161510475 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6839014629510477 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_PERSONENSTAMM_ID_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6839612248510478 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6839815914510479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_PAGE_TITEL_IDENTLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6840013339510479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_SUCHNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160&#160&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p135_suchart=0',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6840220857510479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_SUCHADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p135_suchart=0',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6840402390510480 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_SUCHZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p135_suchart=0',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6840615393510480 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_BL_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Suchen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6840811744510480 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 46,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6841015851510480 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_BL_ALLE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6841200515510481 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_NV_IDENTLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Patientenliste',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6841415666510481 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_SUCHNAME_NORM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Norm',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6841606217510482 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_HEIGHT_PATIENTENLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6857118368917026 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '130',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7436327069570568 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_REDIRECT_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7574212825775408 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 135,
  p_name=>'P135_WV_MASTER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 6834713197510448+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7434103773507160 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 135
 ,p_name => 'Seite submit per Warenkorb-Link , redirect to 500'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.shopping_cart_link'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7436519928578035 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 135
 ,p_event_id => 7434103773507160 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P135_REDIRECT_URL'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => '$(this.triggeringElement).attr(''href'')'
 ,p_attribute_09 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 7434912347528505 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 135
 ,p_event_id => 7434103773507160 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'REDIRECT_WK'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p135_suchname := NULL;'||unistr('\000a')||
'   :p135_suchname_norm := NULL;'||unistr('\000a')||
'   :p135_suchadresse := NULL;'||unistr('\000a')||
'   :p135_suchzusatz := NULL;'||unistr('\000a')||
'   :P135_SUCH_PERSSTAMM_ID := NULL;'||unistr('\000a')||
'   :p135_such_gus_id := NULL;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6842230653510485 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 135,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'clear_such_felder',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''ALLE_ANZEIGEN'',''P135_SUCHART'',''P135_IDENTITAET'',''ERSTELLEN'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'begin'||unistr('\000a')||
'  htp.init;'||unistr('\000a')||
''||unistr('\000a')||
'  if(:P135_REDIRECT_URL is not null) then'||unistr('\000a')||
'     owa_util.redirect_url(:P135_REDIRECT_URL);'||unistr('\000a')||
'     apex_application.stop_apex_engine;'||unistr('\000a')||
'  end if;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7435910793565937 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 135,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'redirect to page 500',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request in (''REDIRECT_WK'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Komplette Höhe ausnutzen (100% des Maximums)'||unistr('\000a')||
'   :P135_HEIGHT_Patientenliste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6842809882510488 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 135,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_url        VARCHAR2(2000);'||unistr('\000a')||
'   v_patientenzugriff  NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_patientenzugriff := NVL(frgbg_s.get_pers_option(:APP_USER,28),0);'||unistr('\000a')||
'--mel.p(''Patzugriff: %1'',v_prot_id,''TEST'',''102/135:check_zugang'',v_patientenzugriff);'||unistr('\000a')||
'   IF :fas_aufgerufen_von != ''BETREUER'' OR  -- Nur Betreuer-Login'||unistr('\000a')||
'      v_patientenzugriff != 0               ';

p:=p||'-- Nur Std.-Identizugriff nicht IABC-Betreuerzugriff'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(5498,:fas_sprache_id);'||unistr('\000a')||
'      v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':130:''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''window.location.href= "''||v_url|';

p:=p||'|''"'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'      apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- NEI 12.02.14 WV-Masterzugriff'||unistr('\000a')||
'   IF frgbg_s.check_fas_rolle(:APP_USER,''WIEDERVERKAEUFER_MASTER'') > 0 THEN '||unistr('\000a')||
'      :p135_WV_MASTER := 1;'||unistr('\000a')||
'   ELSE '||unistr('\000a')||
'      :p135_WV_MASTER :=0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6843013514510488 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 135,
  p_process_sequence=> 2,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_zugang',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_nls_nc varchar2(100);'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --:p135_abmelden := frgbg_s.holen_uebersetzung(174,v_sprache_id);'||unistr('\000a')||
'   :p135_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p135_bl_suchen := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   --:p135_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_i';

p:=p||'d);'||unistr('\000a')||
'   --:P135_BL_KONFIGURATION := frgbg_s.holen_uebersetzung(1593,v_sprache_id);'||unistr('\000a')||
'   --:p135_bl_alle_anzeigen := frgbg_s.holen_uebersetzung(511,v_sprache_id);'||unistr('\000a')||
'   :P135_PAGE_TITEL_IDENTLISTE := frgbg_s.holen_uebersetzung(9088,v_sprache_id);'||unistr('\000a')||
'   :P135_NV_IDENTLISTE := frgbg_s.holen_uebersetzung(9089,v_sprache_id);'||unistr('\000a')||
'SELECT replace(value,'''''''','''''''''''') INTO v_nls_nc'||unistr('\000a')||
'   FROM V$NLS_PARAMETERS'||unistr('\000a')||
'   where param';

p:=p||'eter = ''NLS_NUMERIC_CHARACTERS'';'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''In ws_preisanf:NUMERIC_CHARACTERS: %1'',v_prot_id,''TEST'',''102/135:button_labels_setzen'',v_nls_nc);'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6843804787510493 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 135,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DELETE wkorb_det_verordnungen_tmp'||unistr('\000a')||
'WHERE warenkorb_detail_tmp_id in (SELECT wkd.id '||unistr('\000a')||
'                           FROM warenkoerbe_tmp wk, warenkorb_details_tmp wkd'||unistr('\000a')||
'                           WHERE wk.session_id =  :app_session'||unistr('\000a')||
'                             and wk.id = wkd.warenkorb_tmp_id'||unistr('\000a')||
'                           );'||unistr('\000a')||
'DELETE warenkorb_details_tmp'||unistr('\000a')||
'WHERE warenkorb_tmp_id in (SELECT id '||unistr('\000a')||
'                 ';

p:=p||'          FROM warenkoerbe_tmp'||unistr('\000a')||
'                           WHERE session_id =  :app_session'||unistr('\000a')||
'                          );'||unistr('\000a')||
'DELETE warenkoerbe_tmp'||unistr('\000a')||
'where session_id = :app_session;';

wwv_flow_api.create_page_process(
  p_id     => 6844032137510493 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 135,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_warenkorb_tmp',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :p135_hinweis is not null THEN'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''alert("''||:p135_hinweis||''");'');'||unistr('\000a')||
'      :p135_hinweis := NULL;'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;'||unistr('\000a')||
'';

wwv_flow_api.create_page_process(
  p_id     => 6844232608510496 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 135,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fehlerausgabe',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p135_suchname_norm:= frgbg_t.NORMSTRING(:p135_suchname,2);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6842614894510487 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 135,
  p_process_sequence=> 30,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'suchstring_aufbauen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SUCHEN'',''P135_SUCHNAME'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 135
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00136
prompt  ...PAGE 136: &P136_REGION_TITEL.
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 136
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => '&P136_REGION_TITEL.'
 ,p_step_title => '&P136_REGION_TITEL_ADRESSEN.'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => '&P136_REGION_TITEL.'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141121094129'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7407520741691446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT'||unistr('\000a')||
'    ps.ID FAS_ID,'||unistr('\000a')||
'    af.ANREDE ANREDE,'||unistr('\000a')||
'    ps.VORNAME VORNAME,'||unistr('\000a')||
'    ps.NAME NAME,'||unistr('\000a')||
'    ps.STRASSE STRASSE,'||unistr('\000a')||
'    ps.NR NR,'||unistr('\000a')||
'    ps.PLZ PLZ,'||unistr('\000a')||
'    ps.ORT ORT,'||unistr('\000a')||
'    ps.EMAIL EMAIL,'||unistr('\000a')||
'    ps.GESCHLECHT GESCHLECHT,'||unistr('\000a')||
'    TO_CHAR(ps.GEBURTSDATUM,''DD.MM.YYYY'') GEBURTSDATUM,'||unistr('\000a')||
'    ident.NAME || ident.VORNAME IDENTITAET,'||unistr('\000a')||
'    ps.BEMERKUNG BEMERKUNG,'||unistr('\000a')||
'    (SELECT max(PLANDATUM) LETZTE_BESTELLUNG_MISCHUNG'||unistr('\000a')||
'     FROM';

s:=s||' WARENKOERBE wk'||unistr('\000a')||
'     WHERE'||unistr('\000a')||
'       wk.PERSSTAMM_ID_KUNDE = ps.ID'||unistr('\000a')||
'       and wk.WK_STATUS_ID <= 61 -- Laufende Bestellungen oder abgeschlossen'||unistr('\000a')||
'       and wk.ID in('||unistr('\000a')||
'          SELECT WARENKORB_ID'||unistr('\000a')||
'          FROM WARENKORB_DETAILS wd'||unistr('\000a')||
'          WHERE'||unistr('\000a')||
'            ( wd.mengenart_id is null -- individuelle Mischung'||unistr('\000a')||
'              and wd.p_rezept_id is not null'||unistr('\000a')||
'            )'||unistr('\000a')||
'            or ('||unistr('\000a')||
'              wd.';

s:=s||'p_rezept_id is null'||unistr('\000a')||
'              and wd.mengenart_id in( -- Paramediform Bestellungen'||unistr('\000a')||
'                  select id from MENGENARTS'||unistr('\000a')||
'                  where mn_rezept_id in('||unistr('\000a')||
'                      select id'||unistr('\000a')||
'                      from mn_rezepte'||unistr('\000a')||
'                      where rezept_nr in('||unistr('\000a')||
'                          select rezept_nr'||unistr('\000a')||
'                          from V_GUS_PARAMEDIFORM_ARTIKELNR'||unistr('\000a')||
'             ';

s:=s||'         )'||unistr('\000a')||
'                  )'||unistr('\000a')||
'              )'||unistr('\000a')||
'            )'||unistr('\000a')||
'       )'||unistr('\000a')||
'     ) LETZTE_BESTELLUNG_MISCHUNG'||unistr('\000a')||
'FROM PERSONENSTAMM ps, PERSONENSTAMM ident, PERS_BETREUER pb, VM_ANREDEN_FRGBG_UEB af'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'  :P136_REPORT_REFRESH is not null'||unistr('\000a')||
'  AND af.ANREDE_ID = ps.ANREDE_ID'||unistr('\000a')||
'  AND af.SPRACHE_ID = :FAS_SPRACHE_ID'||unistr('\000a')||
'  AND ((:P136_IDENTITAET > 0 AND ident.id = :P136_IDENTITAET)'||unistr('\000a')||
'    or(:P136_IDENTITAET = 0 '||unistr('\000a')||
'    AN';

s:=s||'D ident.id in(-- Alle Identitäten wo die eingeloggte Zugriff drauf hat'||unistr('\000a')||
'    SELECT p.id'||unistr('\000a')||
'    FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'    WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'       AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'       AND p.betreuer = ''I'''||unistr('\000a')||
'    )'||unistr('\000a')||
'  ))'||unistr('\000a')||
'  and ps.ID = pb.PERSSTAMM_ID'||unistr('\000a')||
'  and pb.PERSSTAMM_ID_BETREUER = ident.ID'||unistr('\000a')||
'  and pb.BETREUERART = 1 -- Nur bevorzugter Bet';

s:=s||'reuer'||unistr('\000a')||
'  and ps.BETREUER = ''N'''||unistr('\000a')||
'  and ps.SATZKENNZEICHEN IS NULL'||unistr('\000a')||
'  and lower(ps.NAME) not like ''%mustermann%'''||unistr('\000a')||
'  AND lower(ps.NAME) not like ''%musterfrau%'''||unistr('\000a')||
'  and lower(ps.VORNAME) not like ''%mustermann%'''||unistr('\000a')||
'  AND lower(ps.VORNAME) not like ''%musterfrau%'''||unistr('\000a')||
'  AND lower(ps.STRASSE) not like ''musterstr%'''||unistr('\000a')||
'  and regexp_instr(trim(ps.NAME),''[0-9]+'') = 0'||unistr('\000a')||
'  and regexp_instr(trim(ps.NAME),''[0-9]+'') = 0';

wwv_flow_api.create_page_plug (
  p_id=> 7407821361691456 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_plug_name=> '&P136_REGION_TITEL_ADRESSEN.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_prn_output_show_link=> 'Y',
  p_prn_content_disposition=> 'ATTACHMENT',
  p_prn_document_header=> 'APEX',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width=> 297,
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'CENTER',
  p_prn_page_footer_alignment=> 'CENTER',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'SELECT'||unistr('\000a')||
'    ps.ID FAS_ID,'||unistr('\000a')||
'    af.ANREDE ANREDE,'||unistr('\000a')||
'    ps.VORNAME VORNAME,'||unistr('\000a')||
'    ps.NAME NAME,'||unistr('\000a')||
'    ps.STRASSE STRASSE,'||unistr('\000a')||
'    ps.NR NR,'||unistr('\000a')||
'    ps.PLZ PLZ,'||unistr('\000a')||
'    ps.ORT ORT,'||unistr('\000a')||
'    ps.EMAIL EMAIL,'||unistr('\000a')||
'    ps.GESCHLECHT GESCHLECHT,'||unistr('\000a')||
'    TO_CHAR(ps.GEBURTSDATUM,''DD.MM.YYYY'') GEBURTSDATUM,'||unistr('\000a')||
'    ident.NAME || ident.VORNAME IDENTITAET,'||unistr('\000a')||
'    ps.BEMERKUNG BEMERKUNG,'||unistr('\000a')||
'    (SELECT max(PLANDATUM) LETZTE_BESTELLUNG_MISCHUNG'||unistr('\000a')||
'     FROM';

a1:=a1||' WARENKOERBE wk'||unistr('\000a')||
'     WHERE'||unistr('\000a')||
'       wk.PERSSTAMM_ID_KUNDE = ps.ID'||unistr('\000a')||
'       and wk.WK_STATUS_ID <= 61 -- Laufende Bestellungen oder abgeschlossen'||unistr('\000a')||
'       and wk.ID in('||unistr('\000a')||
'          SELECT WARENKORB_ID'||unistr('\000a')||
'          FROM WARENKORB_DETAILS wd'||unistr('\000a')||
'          WHERE'||unistr('\000a')||
'            ( wd.mengenart_id is null -- individuelle Mischung'||unistr('\000a')||
'              and wd.p_rezept_id is not null'||unistr('\000a')||
'            )'||unistr('\000a')||
'            or ('||unistr('\000a')||
'              wd.';

a1:=a1||'p_rezept_id is null'||unistr('\000a')||
'              and wd.mengenart_id in( -- Paramediform Bestellungen'||unistr('\000a')||
'                  select id from MENGENARTS'||unistr('\000a')||
'                  where mn_rezept_id in('||unistr('\000a')||
'                      select id'||unistr('\000a')||
'                      from mn_rezepte'||unistr('\000a')||
'                      where rezept_nr in('||unistr('\000a')||
'                          select rezept_nr'||unistr('\000a')||
'                          from V_GUS_PARAMEDIFORM_ARTIKELNR'||unistr('\000a')||
'             ';

a1:=a1||'         )'||unistr('\000a')||
'                  )'||unistr('\000a')||
'              )'||unistr('\000a')||
'            )'||unistr('\000a')||
'       )'||unistr('\000a')||
'     ) LETZTE_BESTELLUNG_MISCHUNG'||unistr('\000a')||
'FROM PERSONENSTAMM ps, PERSONENSTAMM ident, PERS_BETREUER pb, VM_ANREDEN_FRGBG_UEB af'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'  :P136_REPORT_REFRESH is not null'||unistr('\000a')||
'  AND af.ANREDE_ID = ps.ANREDE_ID'||unistr('\000a')||
'  AND af.SPRACHE_ID = :FAS_SPRACHE_ID'||unistr('\000a')||
'  AND ((:P136_IDENTITAET > 0 AND ident.id = :P136_IDENTITAET)'||unistr('\000a')||
'    or(:P136_IDENTITAET = 0 '||unistr('\000a')||
'    AN';

a1:=a1||'D ident.id in(-- Alle Identitäten wo die eingeloggte Zugriff drauf hat'||unistr('\000a')||
'    SELECT p.id'||unistr('\000a')||
'    FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'    WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'       AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'       AND p.betreuer = ''I'''||unistr('\000a')||
'    )'||unistr('\000a')||
'  ))'||unistr('\000a')||
'  and ps.ID = pb.PERSSTAMM_ID'||unistr('\000a')||
'  and pb.PERSSTAMM_ID_BETREUER = ident.ID'||unistr('\000a')||
'  and pb.BETREUERART = 1 -- Nur bevorzugter Bet';

a1:=a1||'reuer'||unistr('\000a')||
'  and ps.BETREUER = ''N'''||unistr('\000a')||
'  and ps.SATZKENNZEICHEN IS NULL'||unistr('\000a')||
'  and lower(ps.NAME) not like ''%mustermann%'''||unistr('\000a')||
'  AND lower(ps.NAME) not like ''%musterfrau%'''||unistr('\000a')||
'  and lower(ps.VORNAME) not like ''%mustermann%'''||unistr('\000a')||
'  AND lower(ps.VORNAME) not like ''%musterfrau%'''||unistr('\000a')||
'  AND lower(ps.STRASSE) not like ''musterstr%'''||unistr('\000a')||
'  and regexp_instr(trim(ps.NAME),''[0-9]+'') = 0'||unistr('\000a')||
'  and regexp_instr(trim(ps.NAME),''[0-9]+'') = 0';

wwv_flow_api.create_worksheet(
  p_id=> 7407909918691456+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_region_id=> 7407821361691456+wwv_flow_api.g_id_offset,
  p_name=> '&P136_REGION_TITEL.',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '5000',
  p_max_row_count_message=> '&P136_MSG_MAX_ANZAHL_ZEILEN.',
  p_no_data_found_message=> '&FAS_KEINE_DATEN_TEXT.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'N',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y_OF_Z',
  p_pagination_display_pos=>'TOP_AND_BOTTOM_LEFT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'Y',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'N',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'Y',
  p_show_highlight=>'Y',
  p_show_computation=>'N',
  p_show_aggregate=>'N',
  p_show_chart=>'N',
  p_show_group_by=>'N',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'Y',
  p_show_reset=>'Y',
  p_show_download=>'N',
  p_show_help=>'N',
  p_download_filename=>'adressen_export',
  p_csv_output_separator=>';',
  p_csv_output_enclosed_by=>'"',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'SASCHA.LENZ',
  p_internal_uid=> 7407909918691456);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7408128574691478+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'FAS_ID',
  p_display_order          =>1,
  p_column_identifier      =>'A',
  p_column_label           =>'&P136_SPALTE_BEZ_FAS_ID.',
  p_report_label           =>'&P136_SPALTE_BEZ_FAS_ID.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7408224213691485+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'VORNAME',
  p_display_order          =>2,
  p_column_identifier      =>'B',
  p_column_label           =>'&P136_SPALTE_BEZ_VORNAME.',
  p_report_label           =>'&P136_SPALTE_BEZ_VORNAME.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7408316319691485+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'NAME',
  p_display_order          =>3,
  p_column_identifier      =>'C',
  p_column_label           =>'&P136_SPALTE_BEZ_NAME.',
  p_report_label           =>'&P136_SPALTE_BEZ_NAME.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7408410628691485+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'STRASSE',
  p_display_order          =>4,
  p_column_identifier      =>'D',
  p_column_label           =>'&P136_SPALTE_BEZ_STRASSE.',
  p_report_label           =>'&P136_SPALTE_BEZ_STRASSE.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7408520803691485+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'NR',
  p_display_order          =>5,
  p_column_identifier      =>'E',
  p_column_label           =>'&P136_SPALTE_BEZ_NR.',
  p_report_label           =>'&P136_SPALTE_BEZ_NR.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7408626165691485+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'PLZ',
  p_display_order          =>6,
  p_column_identifier      =>'F',
  p_column_label           =>'&P136_SPALTE_BEZ_PLZ.',
  p_report_label           =>'&P136_SPALTE_BEZ_PLZ.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7408705192691486+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ORT',
  p_display_order          =>7,
  p_column_identifier      =>'G',
  p_column_label           =>'&P136_SPALTE_BEZ_ORT.',
  p_report_label           =>'&P136_SPALTE_BEZ_ORT.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7408804747691486+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EMAIL',
  p_display_order          =>8,
  p_column_identifier      =>'H',
  p_column_label           =>'&P136_SPALTE_BEZ_EMAIL.',
  p_report_label           =>'&P136_SPALTE_BEZ_EMAIL.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7408913334691486+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'GESCHLECHT',
  p_display_order          =>9,
  p_column_identifier      =>'I',
  p_column_label           =>'&P136_SPALTE_BEZ_GESCHLECHT.',
  p_report_label           =>'&P136_SPALTE_BEZ_GESCHLECHT.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7409016842691486+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'GEBURTSDATUM',
  p_display_order          =>10,
  p_column_identifier      =>'J',
  p_column_label           =>'&P136_SPALTE_BEZ_GEBURTSDATUM.',
  p_report_label           =>'&P136_SPALTE_BEZ_GEBURTSDATUM.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7409124191691486+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'IDENTITAET',
  p_display_order          =>11,
  p_column_identifier      =>'K',
  p_column_label           =>'&P136_SPALTE_BEZ_IDENT.',
  p_report_label           =>'&P136_SPALTE_BEZ_IDENT.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7409207475691487+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'BEMERKUNG',
  p_display_order          =>12,
  p_column_identifier      =>'L',
  p_column_label           =>'&P136_SPALTE_BEZ_BEMERKUNG.',
  p_report_label           =>'&P136_SPALTE_BEZ_BEMERKUNG.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7417708434958597+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'LETZTE_BESTELLUNG_MISCHUNG',
  p_display_order          =>13,
  p_column_identifier      =>'M',
  p_column_label           =>'&P136_SPALTE_BEZ_LETZ_BEST.',
  p_report_label           =>'&P136_SPALTE_BEZ_LETZ_BEST.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_format_mask            =>'DD.MM.YYYY',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7442802398611457+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ANREDE',
  p_display_order          =>14,
  p_column_identifier      =>'N',
  p_column_label           =>'&P136_SPALTE_BEZ_ANREDE.',
  p_report_label           =>'&P136_SPALTE_BEZ_ANREDE.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'FAS_ID:ANREDE:VORNAME:NAME:STRASSE:NR:PLZ:ORT:EMAIL:GESCHLECHT:GEBURTSDATUM:IDENTITAET:BEMERKUNG:LETZTE_BESTELLUNG_MISCHUNG';

wwv_flow_api.create_worksheet_rpt(
  p_id => 7409522778694796+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_type             =>'REPORT',
  p_report_alias            =>'74096',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>20,
  p_report_columns          =>rc1,
  p_sort_column_1           =>'NAME',
  p_sort_direction_1        =>'ASC',
  p_sort_column_2           =>'APXWS_CC_001',
  p_sort_direction_2        =>'DESC',
  p_sort_column_3           =>'LETZTE_BESTELLUNG_MISCHUNG',
  p_sort_direction_3        =>'DESC',
  p_break_on                =>'0:0:0:0:0',
  p_break_enabled_on        =>'0:0:0:0:0',
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
begin
wwv_flow_api.create_worksheet_condition(
  p_id => 7444819087795765+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_report_id => 7409522778694796+wwv_flow_api.g_id_offset,
  p_condition_type          =>'FILTER',
  p_allow_delete            =>'Y',
  p_column_name             =>'LETZTE_BESTELLUNG_MISCHUNG',
  p_operator                =>'is not null',
  p_condition_sql           =>'"LETZTE_BESTELLUNG_MISCHUNG" is not null',
  p_condition_display       =>'#APXWS_COL_NAME# #APXWS_OP_NAME#',
  p_enabled                 =>'Y',
  p_column_format           =>'');
end;
/
begin
wwv_flow_api.create_worksheet_computation(
  p_id => 7444930920795765+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 136,
  p_worksheet_id => 7407909918691456+wwv_flow_api.g_id_offset,
  p_report_id => 7409522778694796+wwv_flow_api.g_id_offset,
  p_db_column_name    =>'APXWS_CC_001',
  p_column_identifier =>'C01',
  p_computation_expr  =>'TRUNC(M,''MONTH'')',
  p_format_mask       =>'YYYY-MON',
  p_column_type       =>'DATE',
  p_column_label      =>'Letzte Bestellung Monat',
  p_report_label      =>'Letzte Bestellung Monat');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 7411600455801909 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 136,
  p_button_sequence=> 10,
  p_button_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_button_name    => 'DOWNLOAD',
  p_button_static_id=> 'DOWNLOAD_EXCEL',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Download',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7410102161718419 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7410905815731961 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_REGION_TITEL_ADRESSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7416915144925119 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_MSG_MAX_ANZAHL_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(11614,:FAS_SPRACHE_ID,'||unistr('\000a')||
'  to_char(2000,''99999''));',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7420030169331192 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> ':FAS_IDENTITAET_PERSSTAMM_ID',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT'||unistr('\000a')||
'   substr(p.name,1,30)||'', ''||substr(p.ort,1,30)||'', ''||p.id || '' ('' ||'||unistr('\000a')||
'    (SELECT COUNT(*)'||unistr('\000a')||
'      FROM PERS_BETREUER pb, PERSONENSTAMM ps'||unistr('\000a')||
'      WHERE pb.BETREUERART = 1'||unistr('\000a')||
'         AND ps.ID = pb.PERSSTAMM_ID'||unistr('\000a')||
'         AND pb.PERSSTAMM_ID_BETREUER =  p.id'||unistr('\000a')||
'         AND ps.SATZKENNZEICHEN IS NULL'||unistr('\000a')||
'         AND ps.BETREUER = ''N'''||unistr('\000a')||
'         AND lower(ps.NAME) not like ''%mustermann%'''||unistr('\000a')||
'         AND lower(ps.NAME) not like ''%musterfrau%'''||unistr('\000a')||
'         and lower(ps.VORNAME) not like ''%mustermann%'''||unistr('\000a')||
'         AND lower(ps.VORNAME) not like ''%musterfrau%'''||unistr('\000a')||
'         AND lower(ps.STRASSE) not like ''musterstr%'''||unistr('\000a')||
'         and regexp_instr(trim(ps.NAME),''[0-9]+'') = 0'||unistr('\000a')||
'         and regexp_instr(trim(ps.NAME),''[0-9]+'') = 0'||unistr('\000a')||
'   ) || '')'' a,'||unistr('\000a')||
'   p.id b'||unistr('\000a')||
'FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'  AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'  AND p.betreuer = ''I'''||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(511,:fas_sprache_id), 0'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(11615,:fas_sprache_id), -1'||unistr('\000a')||
'from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_tag_attributes  => 'style="width:250px; height:22px;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_patientenzugriff != 1   /* 1=spez. Betreuerzugriff */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7423625239561419 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_IDENT_SUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_tag_attributes  => 'style="width:250px; height:22px;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'SELECT *'||unistr('\000a')||
'FROM('||unistr('\000a')||
'  SELECT'||unistr('\000a')||
'     count(*) a'||unistr('\000a')||
'  FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'  WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'    AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'    AND p.betreuer = ''I'''||unistr('\000a')||
')'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'   a > 20',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7428415862225301 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_REPORT_REFRESH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7428603354231169 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_LOAD_ICON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'<img src="/i/htmldb/icons/loading-gray.gif" />',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_tag_attributes  => 'style="display:none;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7432032585339102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_FAS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7432411450348918 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7432712719378763 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7433000858384257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_STRASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7433418961391081 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7433709688395371 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_PLZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7434002571398675 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_ORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7434225850402996 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_EMAIL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7434612695409094 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_GESCHLECHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7435024544418823 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7435217858421926 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7435601037429733 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7436107925441779 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_LETZ_BEST',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7445100728809715 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 136,
  p_name=>'P136_SPALTE_BEZ_ANREDE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 220,
  p_item_plug_id => 7407821361691456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7424328550588862 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_name => 'Filter Identitätenliste durch Suche'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P136_IDENT_SUCHE'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'keypress'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7424602412588867 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_event_id => 7424328550588862 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '//var shuttle_class = $(this.triggeringElement).attr(''class'').replace(''shuttle_search'','''').trim();'||unistr('\000a')||
''||unistr('\000a')||
'var suche = $(this.triggeringElement).val().toLowerCase().trim();'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'if(suche.match(/[^\w ]/i)) {'||unistr('\000a')||
''||unistr('\000a')||
'  alert(''Suchfeld darf nur Alphanumerische Zeichen haben.'');'||unistr('\000a')||
''||unistr('\000a')||
'} else {'||unistr('\000a')||
''||unistr('\000a')||
'  // Durchlaufe alle Optionen und prüfe ob sie in das Suchkriterium passen.'||unistr('\000a')||
'   $(''#P136_IDENTITAET option'').each(function() {'||unistr('\000a')||
''||unistr('\000a')||
'      var $this = $(this);'||unistr('\000a')||
''||unistr('\000a')||
'      if($this.val() == -1) {'||unistr('\000a')||
'         return;'||unistr('\000a')||
'      }'||unistr('\000a')||
''||unistr('\000a')||
'      var suchReg = new RegExp(''.*'' + suche.replace('' '',''.*'') + ''.*'');'||unistr('\000a')||
''||unistr('\000a')||
'      //alert($this.text());'||unistr('\000a')||
'      if($this.text().toLowerCase().match(suchReg)) {          '||unistr('\000a')||
'         $this.show();'||unistr('\000a')||
'      } else {'||unistr('\000a')||
'         $this.hide();'||unistr('\000a')||
'      }'||unistr('\000a')||
'    });   '||unistr('\000a')||
''||unistr('\000a')||
'  if($(''#P136_IDENTITAET option:selected'').css(''display'') == ''none'') {'||unistr('\000a')||
''||unistr('\000a')||
'     $(''#P136_IDENTITAET option[value="-1"]'').first().attr(''selected'',''selected'');'||unistr('\000a')||
''||unistr('\000a')||
'  }'||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7428704777233305 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_name => 'Load Icon einblenden'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 7407821361691456 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'apexbeforerefresh'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7429003757233338 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_event_id => 7428704777233305 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P136_LOAD_ICON'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7429109279234669 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_name => 'Load Icon ausblenden'
 ,p_event_sequence => 30
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 7407821361691456 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'apexafterrefresh'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7429406236234670 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_event_id => 7429109279234669 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P136_LOAD_ICON'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7429516551236770 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_name => 'Lade Reports'
 ,p_event_sequence => 40
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$v(''P136_REPORT_REFRESH'').length == 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7430004907236772 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_event_id => 7429516551236770 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin '||unistr('\000a')||
'  :P136_REPORT_REFRESH := 1;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P136_REPORT_REFRESH'
 ,p_attribute_03 => 'P36_REPORT_REFRESH'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 7429827885236772 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_event_id => 7429516551236770 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 7407821361691456 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7430909456272576 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_name => 'Refresh Report'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P136_IDENTITAET'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7431225580272577 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_event_id => 7430909456272576 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin'||unistr('\000a')||
'  :P136_IDENTITAET := :P136_IDENTITAET;'||unistr('\000a')||
'end;  '
 ,p_attribute_02 => 'P136_IDENTITAET'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 7431409140274054 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 136
 ,p_event_id => 7430909456272576 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 7407821361691456 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p := null;
wwv_flow_api.create_page_process(
  p_id     => 7411421795798629 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 136,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_BOX_BODY',
  p_process_type=> 'PLUGIN_GPV_IR_TO_MSEXCEL',
  p_process_name=> 'get Excel',
  p_process_sql_clob => p,
  p_attribute_05=> '5000',
  p_attribute_06=> '#DOWNLOAD_EXCEL',
  p_attribute_07=> 'E',
  p_attribute_10=> 'Y',
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  v_sprache_id number := :FAS_SPRACHE_ID;'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'   :P136_REGION_TITEL_ADRESSEN := frgbg_s.holen_uebersetzung(11611,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_FAS_ID := frgbg_s.holen_uebersetzung(3481,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_VORNAME := frgbg_s.holen_uebersetzung(205,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_NAME  := frgbg_s.holen_uebersetzung(206,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_STRASSE  := ';

p:=p||'frgbg_s.holen_uebersetzung(207,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_NR  := frgbg_s.holen_uebersetzung(208,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_PLZ  := frgbg_s.holen_uebersetzung(209,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_ORT  := frgbg_s.holen_uebersetzung(210,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_EMAIL  := frgbg_s.holen_uebersetzung(203,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_GESCHLECHT  := frgbg_s.holen_ueberset';

p:=p||'zung(213,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_GEBURTSDATUM  := frgbg_s.holen_uebersetzung(212,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_IDENT  := frgbg_s.holen_uebersetzung(3101,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_BEMERKUNG  := frgbg_s.holen_uebersetzung(1689,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_LETZ_BEST  := frgbg_s.holen_uebersetzung(11616,v_sprache_id);'||unistr('\000a')||
'   :P136_SPALTE_BEZ_ANREDE := frgbg_s.holen_uebersetz';

p:=p||'ung(204,v_sprache_id);'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7411110273738534 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 136,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set item labels',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'Y',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 136
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00140
prompt  ...PAGE 140: Fragenbogen-/ Rezepturenliste
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 140
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Fragenbogen-/ Rezepturenliste'
 ,p_step_title => 'Fragenbogen-Rezepturenliste'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Fragenbogenliste'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140211142011'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3168916169731840 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 140,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'Select '||unistr('\000a')||
'  FRAGEBOGEN_ID, FB_KURZNAME,  frgbg_s.HOLEN_UEBERSETZUNG(fb_kurzname_text_id,:fas_sprache_id) text,  --u.text, -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'  FB_VERSION, FB_TYP_ID, PERSONENSTAMM_ID, '||unistr('\000a')||
'  PS_USER_ACCOUNT, PERGEBNIS_ID, PERG_VERSIONS_ID, PERG_AKT_VERSION, '||unistr('\000a')||
'  MN_REZEPT_ID,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'  /* bearbeitbare Version */'||unistr('\000a')||
'  WHEN perg_akt_version = 1 AND      -- akt. Antworts';

s:=s||'et und akt. FB-Version'||unistr('\000a')||
'       :fas_pers_aenderbar = 1 AND   -- Pers.Daten änderbar'||unistr('\000a')||
'       --mn_rezept_id is null          -- kein Rezept'||unistr('\000a')||
'       frgbg_s.FB_CHECK_AUSWERTUNG(pergebnis_id)= 0  -- keine Auswertung'||unistr('\000a')||
'  THEN ''<a href="'''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':1:''||:APP_SESSION||''::&DEBUG.:1,2,3,4,5,6,7,8,9,10,31,32,33,34,35,90,91,95:'''||unistr('\000a')||
'||''P1_PERSON,P1_FRAGEBOGEN_ID,P1_FB_VERSION,P1_PERG';

s:=s||'EBNIS_ID,P1_BEARB_MODUS,P1_ZURUECK_ZUR_SEITE:'''||unistr('\000a')||
'||to_char(PERSONENSTAMM_ID)||'',''||to_char(trunc(FRAGEBOGEN_ID))||'','''||unistr('\000a')||
'||to_char(frgbg_s.fb_get_vers(fragebogen_id))||'','''||unistr('\000a')||
'||to_char(PERGEBNIS_ID)||'',BEARBEITEN,''||:APP_PAGE_ID)'||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#edit_big.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'/* NEI 2.2.09 Kopie erzeugen => neue Version bearbeitbar nur noch über Button */'||unistr('\000a')||
'WHEN perg_akt_version = 1 AND      ';

s:=s||'-- akt. Antwortset und akt. FB-Version'||unistr('\000a')||
'     :fas_pers_aenderbar = 1 AND   -- Pers.Daten änderbar'||unistr('\000a')||
'     --mn_rezept_id is not null      -- Rezept vorhanden'||unistr('\000a')||
'     frgbg_s.FB_CHECK_AUSWERTUNG(pergebnis_id)= 1 -- Auswertung vorhanden'||unistr('\000a')||
'THEN                                             '||unistr('\000a')||
'''<a href="'''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':1:''||:APP_SESSION||''::&DEBUG.:1,2,3,4,5,6,7,8,9,10,31,32,33,34,35,9';

s:=s||'0,91,95:'''||unistr('\000a')||
'||''P1_PERSON,P1_FRAGEBOGEN_ID,P1_FB_VERSION,P1_PERGEBNIS_ID,P1_BEARB_MODUS,P1_ZURUECK_ZUR_SEITE:'''||unistr('\000a')||
'||to_char(PERSONENSTAMM_ID)||'',''||to_char(trunc(FRAGEBOGEN_ID))||'','''||unistr('\000a')||
'||to_char(frgbg_s.fb_get_vers(fragebogen_id))||'','''||unistr('\000a')||
'||to_char(PERGEBNIS_ID)||'',ANZEIGEN,''||:APP_PAGE_ID)      /* NEI 02.02.09 KOPIE entfernt */'||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#edit_big.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE /* nur anzeig';

s:=s||'bare Version, da Vorgängerversion  */'||unistr('\000a')||
'''<a href="'''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':1:''||:APP_SESSION||''::&DEBUG.:1,2,3,4,5,6,7,8,9,10,31,32,33,34,35,90,91,95:'''||unistr('\000a')||
'||''P1_PERSON,P1_FRAGEBOGEN_ID,P1_FB_VERSION,P1_PERGEBNIS_ID,P1_BEARB_MODUS,P1_ZURUECK_ZUR_SEITE:'''||unistr('\000a')||
'||to_char(PERSONENSTAMM_ID)||'',''||to_char(trunc(FRAGEBOGEN_ID))||'','''||unistr('\000a')||
'||to_char(frgbg_s.fb_get_vers(fragebogen_id))||'','''||unistr('\000a')||
'||to_char(PE';

s:=s||'RGEBNIS_ID)||'',ANZEIGEN,''||:APP_PAGE_ID)'||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#fndsublg.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'END LINK'||unistr('\000a')||
'FROM v_fb_fas  --,uebersetzungen u -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'WHERE personenstamm_id = :p140_personenstamm_id'||unistr('\000a')||
'  AND perg_akt_version >= :p140_akt_version'||unistr('\000a')||
'  --and fb_kurzname_text_id = u.text_id'||unistr('\000a')||
'  --and u.sprache_id = :fas_sprache_id'||unistr('\000a')||
'  and ((:fas_aufger';

s:=s||'ufen_von = ''BETREUER'' and '||unistr('\000a')||
'         (fbk_klasse_id = 1 or fbk_klasse_id is null) AND  -- alle FB´s'||unistr('\000a')||
'          fb_typ_id in '||unistr('\000a')||
'           /*(SELECT b.fb_typ_id'||unistr('\000a')||
'              FROM fbtyp_betreuer b '||unistr('\000a')||
'              WHERE b.persstamm_id_betreuer = :fas_login_personenstamm_id  '||unistr('\000a')||
'              )*/'||unistr('\000a')||
'           (SELECT b.fb_typ_id'||unistr('\000a')||
'            FROM fbtyp_betreuer b '||unistr('\000a')||
'            where b.persstamm_id_betreuer in ( ';

s:=s||''||unistr('\000a')||
'               -- Definitionen der Identitaeten-Hierarchie'||unistr('\000a')||
'               select persstamm_id_identitaet         '||unistr('\000a')||
'               from pers_identitaeten'||unistr('\000a')||
'               start with persstamm_id_identitaet = :fas_identitaet_persstamm_id'||unistr('\000a')||
'               connect by prior persstamm_id_oberidentitaet ='||unistr('\000a')||
'                                persstamm_id_identitaet'||unistr('\000a')||
'               UNION -- auch Definitionen vom Be';

s:=s||'treuer relevant'||unistr('\000a')||
'               SELECT to_number(:fas_login_personenstamm_id) from dual'||unistr('\000a')||
'               )'||unistr('\000a')||
'           )'||unistr('\000a')||
'         )'||unistr('\000a')||
'        OR'||unistr('\000a')||
'        (:fas_aufgerufen_von != ''BETREUER''and '||unistr('\000a')||
'            (fbk_klasse_id = 1 or fbk_klasse_id is null) -- alle FB´s'||unistr('\000a')||
'        ) '||unistr('\000a')||
'      )'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'order by fb_kurzname,PERG_VERSIONS_ID desc;';

wwv_flow_api.create_report_region (
  p_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 140,
  p_name=> '&P140_PAGE_TITEL_FBLISTE.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 5,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_when_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'  /*keine Standardrezeptowner => FB bei Rezeptowner unsinnig*/'||unistr('\000a')||
'  SELECT count(*) INTO v_anz'||unistr('\000a')||
'  from fas_schema_standards '||unistr('\000a')||
'  where typ = 1 '||unistr('\000a')||
'    and satz_kennzeichen is null'||unistr('\000a')||
'    and referenz_id = :P140_PERSONENSTAMM_ID;'||unistr('\000a')||
''||unistr('\000a')||
'   IF  NVL(:fas_modus_id,0) != 2 /* Eovital bekommt keine FB''s */'||unistr('\000a')||
'       AND v_anz = 0             /* keine Standardrezeptowner */ '||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      RETURN TRUE;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN FALSE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_display_condition_type=> 'FUNCTION_BODY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P140_HEIGHT_FBLISTE.px;min-width: 250px; ">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(506,frgbg_s.get_sprache_id(:APP_USER)));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '1000',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5124611296608228 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FRAGEBOGEN_ID',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5124701134608231 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'FB_KURZNAME',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3700322279247356 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5124829224608231 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'FB_VERSION',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5124922733608231 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'FB_TYP_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5125006270608231 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'PERSONENSTAMM_ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5125114897608231 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'PS_USER_ACCOUNT',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5125205678608231 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'PERGEBNIS_ID',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5125318567608231 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'PERG_VERSIONS_ID',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5125402169608231 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'PERG_AKT_VERSION',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5125501576608231 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'MN_REZEPT_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5186208290900018 + wwv_flow_api.g_id_offset,
  p_region_id=> 5124311174608206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'VAL_OF_ITEM_IN_COND_EQ_COND2',
  p_display_when_condition=> 'P140_REZEPT_ERFASSEN',
  p_display_when_condition2=> '0',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT'||unistr('\000a')||
'  mn.ID, mn.REZEPT_NR, '||unistr('\000a')||
'  CASE  -- gelbes Flag'||unistr('\000a')||
'  WHEN (mn.neuberechnen = ''J'' OR '||unistr('\000a')||
'        mn.neuberechnen_sortiment = ''J'' OR     -- NEI 14.02.2011 Sortimentseinf.'||unistr('\000a')||
'        p.sortiment_id != :FAS_SORTIMENT_ID    -- NEI 26.04.11'||unistr('\000a')||
'        )'||unistr('\000a')||
'       AND'||unistr('\000a')||
'        (mn.persstamm_id_ident is not NULL AND -- NEI 16.09.11 wg. Grenzwerte'||unistr('\000a')||
'         mn.persstamm_id_ident != rezepte.GET_persstamm_id_pers_typ'||unistr('\000a')||
' ';

s:=s||'       )       '||unistr('\000a')||
'  THEN         -- gelbes Flag: Sortiment und Ident wg. Grenzwerte'||unistr('\000a')||
'    --''<span style="background-color:yellow;">''||mn.VERSION||''</span>'''||unistr('\000a')||
'       mn.VERSION'||unistr('\000a')||
'     ||'' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'     ||frgbg_s.holen_uebersetzung(4890,:fas_sprache_id)||''</br>'''||unistr('\000a')||
'     ||frgbg_s.holen_uebersetzung(4891,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'     ||''  <img src="#IMAGE_PR';

s:=s||'EFIX#yellow_flag.gif">'''||unistr('\000a')||
'  WHEN mn.neuberechnen = ''J'' OR '||unistr('\000a')||
'       mn.neuberechnen_sortiment = ''J'' OR     -- NEI 14.02.2011 Sortimentseinf.'||unistr('\000a')||
'       p.sortiment_id != :FAS_SORTIMENT_ID    -- NEI 26.04.11'||unistr('\000a')||
'  THEN         -- gelbes Flag: Sortiment '||unistr('\000a')||
'    --''<span style="background-color:yellow;">''||mn.VERSION||''</span>'''||unistr('\000a')||
'       mn.VERSION'||unistr('\000a')||
'     ||'' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'    ';

s:=s||' ||frgbg_s.holen_uebersetzung(4890,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'     ||''  <img src="#IMAGE_PREFIX#yellow_flag.gif">'''||unistr('\000a')||
'  WHEN (mn.persstamm_id_ident is not NULL AND   -- NEI 16.09.11 wg. Grenzwerte'||unistr('\000a')||
'        mn.persstamm_id_ident != rezepte.GET_persstamm_id_pers_typ'||unistr('\000a')||
'       )       '||unistr('\000a')||
'  THEN         -- gelbes Flag: Ident wg. Grenzwerte'||unistr('\000a')||
'    --''<span style="background-color:yellow;">''||mn.VERSION||''</span';

s:=s||'>'''||unistr('\000a')||
'       mn.VERSION'||unistr('\000a')||
'     ||'' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'     ||frgbg_s.holen_uebersetzung(4891,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'     ||''  <img src="#IMAGE_PREFIX#yellow_flag.gif">'''||unistr('\000a')||
'  ELSE to_char(mn.VERSION)'||unistr('\000a')||
'  END  ||'||unistr('\000a')||
'  CASE WHEN p.prod_rezstatus_id = 1      -- Arbeitsversion rotes Flag'||unistr('\000a')||
'  THEN '||unistr('\000a')||
'       '' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'     ||frg';

s:=s||'bg_s.holen_uebersetzung(4889,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'     ||''  <img src="#IMAGE_PREFIX#red_flag.gif">'''||unistr('\000a')||
'  ELSE NULL'||unistr('\000a')||
'  END  version, '||unistr('\000a')||
'  mn.AKT_VERSION, mn.BEZEICHNUNG, '||unistr('\000a')||
'  mn.MN_REZTYP_ID, '||unistr('\000a')||
'  mn.MNREZLEVEL_ID, mn.PRODHINWEIS1, mn.PRODHINWEIS2, mn.MAN_GEAENDERT_AM, '||unistr('\000a')||
'  mn.MAN_GEAENDERT_DURCH, mn.ANALYSE_ID, mn.PAT_AKTE_ID, mn.PERGEBNIS_ID, '||unistr('\000a')||
'  mn.PERSONENSTAMM_ID, '||unistr('\000a')||
'  mn.BEMERKUNG || CASE WHEN mn.z';

s:=s||'usatzbemerkung is not null THEN '||unistr('\000a')||
'           ''   <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':204:'''||unistr('\000a')||
'         ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P204_MN_REZEPT_ID:''||mn.id||'''''',1000,550)">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END  bemerkung,'||unistr('\000a')||
'  mn.SATZ_KENNZEICHEN, mn.STATUS, '||unistr('\000a')||
'  mn.MN_REZTYP_ID_VERS1,'||unistr('\000a')||
'  CASE'||unistr('\000a')||
'  /* bearbeitbare Version *';

s:=s||'/'||unistr('\000a')||
'  WHEN mn.akt_version = 1 '||unistr('\000a')||
'    AND mn.status not in (2,3) -- Rezepte, die keine ungÃ¼ltig Version besitzen '||unistr('\000a')||
'    AND mn.aenderbar = ''J'''||unistr('\000a')||
'    AND (mn.mnr_vorschrift = 0 OR   -- MNR-Vorschriften nur von Betreuern mit'||unistr('\000a')||
'         mn.mnr_vorschrift = 1 AND  -- entsprechender Rolle'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''MNR_VORSCHRIFT_VERWALTEN'') != 0'||unistr('\000a')||
'        )'||unistr('\000a')||
'    AND :fas_pers_aenderbar = 1     -- ';

s:=s||'Personendaten aenderbar'||unistr('\000a')||
'    AND :fas_modus_id !=1           -- FAS-Modus nicht Iabc  NEI 11.01.10'||unistr('\000a')||
'    /* NEI 16.09.11 wg. Grenzwertprüf. muss Ident gleich aktiver Ident sein */'||unistr('\000a')||
'    AND (mn.persstamm_id_ident is NULL OR                     -- NEI 16.09.11 '||unistr('\000a')||
'         mn.persstamm_id_ident = rezepte.GET_persstamm_id_pers_typ'||unistr('\000a')||
'        )'||unistr('\000a')||
'  THEN ''<a href="'''||unistr('\000a')||
'   ||APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':20';

s:=s||'1:''||:APP_SESSION||''::&DEBUG.:201:'''||unistr('\000a')||
'   ||''P201_PERSON,P201_MN_REZEPT_ID,P201_BEARB_MODUS:'''||unistr('\000a')||
'   ||to_char(mn.PERSONENSTAMM_ID)||'',''||to_char(mn.ID)||'',BEARBEITEN'')'||unistr('\000a')||
'   || ''">'''||unistr('\000a')||
'   || ''<img src="#IMAGE_PREFIX#edit_big.gif">'''||unistr('\000a')||
'   || ''</a>'''||unistr('\000a')||
'  ELSE /* nur anzeigbare Version, da Vorgängerversion od.nicht änderbar */'||unistr('\000a')||
'   ''<a href="'''||unistr('\000a')||
'   ||APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':201:''||:APP_SESSION||''::&DEBUG.';

s:=s||':201:'''||unistr('\000a')||
'   ||''P201_PERSON,P201_MN_REZEPT_ID,P201_BEARB_MODUS:'''||unistr('\000a')||
'   ||to_char(mn.PERSONENSTAMM_ID)||'',''||to_char(mn.ID)||'',ANZEIGEN'')'||unistr('\000a')||
'   || ''">'''||unistr('\000a')||
'   || ''<img src="#IMAGE_PREFIX#fndsublg.gif">'''||unistr('\000a')||
'   || ''</a>'''||unistr('\000a')||
'  END LINK_MNR,'||unistr('\000a')||
'  --auftragsdispo.GET_LAST_BESTELL_DAT(mn.id) mn_rezept_id_last,'||unistr('\000a')||
'  frgbg_s.WK_GET_LAST_BESTELL_DAT(p.id,NULL) mn_rezept_id_last,'||unistr('\000a')||
'  p.id prod_rezept_id'||unistr('\000a')||
'/* NEI 10.07.08 Produktrezept j';

s:=s||'a/nein nicht mehr anzeigen'||unistr('\000a')||
'  CASE'||unistr('\000a')||
'    -- anzeigbare Produktversion '||unistr('\000a')||
'  WHEN p.id IS NOT NULL'||unistr('\000a')||
'  THEN '||unistr('\000a')||
'     -- vorhanden'||unistr('\000a')||
'     frgbg_s.holen_uebersetzung(76,:fas_sprache_id)'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     -- nicht vorhanden'||unistr('\000a')||
'     frgbg_s.holen_uebersetzung(77,:fas_sprache_id)'||unistr('\000a')||
'  END LINK_PRODR'||unistr('\000a')||
'*/'||unistr('\000a')||
'from v_mn_rezepte mn,prod_rezepte p'||unistr('\000a')||
'WHERE mn.personenstamm_id = :p140_personenstamm_id'||unistr('\000a')||
'  and mn.mn_reztyp_id in (1,3,5,6)'||unistr('\000a')||
'  and';

s:=s||' mn.MN_REZTYP_ID_VERS1 in (1,3)   -- Manuelle od. FB-Rezepte'||unistr('\000a')||
'  AND mn.akt_version >= :p140_rez_akt_version'||unistr('\000a')||
'  and mn.satz_kennzeichen is null      -- keine gelöschten Versionen'||unistr('\000a')||
'  and mn.status in (0,1)               -- keine ungültigen Rezepte'||unistr('\000a')||
'  AND mn.version = p.version (+)'||unistr('\000a')||
'  AND mn.rezept_nr = p.rezept_nr (+)'||unistr('\000a')||
'  AND mn.rezept_nr_splitbasis is NULL  -- NEI 14.01.14 Kumulation Splits zu Gesamtrezep';

s:=s||'t'||unistr('\000a')||
'  AND mn.version_splitbasis is NULL    -- NEI 14.01.14 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 140,
  p_name=> '&P140_PAGE_TITEL_REZLISTE.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 900,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_when_condition=> ':P140_REZEPT_ERFASSEN= 0 AND'||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1 = IABC-Modus */',
  p_display_condition_type=> 'PLSQL_EXPRESSION',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P140_HEIGHT_REZLISTE.px;min-width: 600px; max-width: 600px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(513,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '1000',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'Keine Daten gefunden',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '2000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5377629167460710 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5377713158460712 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_default_sort_dir=>'desc',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5377817985460712 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'VERSION',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>2,
  p_default_sort_dir=>'desc',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5377922362460712 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AKT_VERSION',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378012252460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378129190460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MN_REZTYP_ID',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378217430460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'MNREZLEVEL_ID',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378330381460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'PRODHINWEIS1',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378414302460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'PRODHINWEIS2',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378506668460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'MAN_GEAENDERT_AM',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_format=> 'DD.MM.YYYY HH24:MI:SS',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378601606460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'MAN_GEAENDERT_DURCH',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378715691460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'ANALYSE_ID',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378807231460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'PAT_AKTE_ID',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5378912174460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'PERGEBNIS_ID',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5379029509460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'PERSONENSTAMM_ID',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5379132759460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5379207720460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'SATZ_KENNZEICHEN',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5379321487460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5379423102460714 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'MN_REZTYP_ID_VERS1',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6119407221528225 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'LINK_MNR',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5384611837970784 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'MN_REZEPT_ID_LAST',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_format=> 'DD.MM.YYYY',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6119505923528228 + wwv_flow_api.g_id_offset,
  p_region_id=> 5377325249460687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'PROD_REZEPT_ID',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5409217189101814 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 140,
  p_plug_name=> '&P140_PAGE_TITEL_PATIENT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5564918895471143 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 140,
  p_plug_name=> '&P140_PAGE_TITEL_REZEPT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'VAL_OF_ITEM_IN_COND_EQ_COND2',
  p_plug_display_when_condition => 'P140_REZEPT_ERFASSEN',
  p_plug_display_when_cond2=>'1',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 10736729469504373 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 140,
  p_button_sequence=> 5,
  p_button_plug_id => 5377325249460687+wwv_flow_api.g_id_offset,
  p_button_name    => 'OTA_SUCHE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P140_BL_OTA_SUCHE.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER'' AND frgbg_s.check_fas_rolle(:APP_USER,''OTA'')> 0 and'||unistr('\000a')||
':fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5565300291471143 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 140,
  p_button_sequence=> 10,
  p_button_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P140_BL_VERWERFEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6720914900646225 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 140,
  p_button_sequence=> 50,
  p_button_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_button_name    => 'ZURUECK',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P140_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> ':P110_ID is not null and NVL(:p140_rezept_erfassen,0) != 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4076615276702790 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 140,
  p_button_sequence=> 55,
  p_button_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_button_name    => 'EOVITAL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P140_BL_EOVITAL.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:250:&SESSION.::&DEBUG.::P250_PERSONENSTAMM_ID:&P140_PERSONENSTAMM_ID.',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER'' AND NVL(:p140_rezept_erfassen,0) != 1 AND'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''EOVITAL'')> 0 and'||unistr('\000a')||
':fas_pers_aenderbar = 1         /* Personendaten aenderbar */',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5460913135351231 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 140,
  p_button_sequence=> 10,
  p_button_plug_id => 5377325249460687+wwv_flow_api.g_id_offset,
  p_button_name    => 'ERSTELLEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P140_BL_ERSTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_pers_aenderbar = 1  and   /* Personendaten aenderbar */'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5565117052471143 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 140,
  p_button_sequence=> 40,
  p_button_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P140_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> 'P140_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6721204968646225 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&FLOW_ID.:110:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6720914900646225+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>10737303281506245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:145:&SESSION.::&DEBUG.::P145_FAS_NAME,P145_FAS_VORNAME:&P140_NAME.,&P140_VORNAME.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>10736729469504373+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 15,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 27-FEB-2008 15:15 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>3916818786300267 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:201:P201_PERSON,P201_MN_REZEPT_ID,P201_BEARB_MODUS:&P140_PERSONENSTAMM_ID.,&P140_MN_REZEPT_ID_NEU.,BEARBEITEN',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5565117052471143+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 24-JUN-2008 16:05 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>5565503439471145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3906822208703971 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 251,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3907328188762454 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_TOGGLE_REZEPTART',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 4,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(1815,frgbg_s.get_sprache_id(:APP_USER)) v,   '||unistr('\000a')||
'      ''MNR'' r'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(1816,frgbg_s.get_sprache_id(:APP_USER)) v,          '||unistr('\000a')||
'      ''PRODR'' r'||unistr('\000a')||
'FROM DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'frgbg_s.check_fas_rolle(:APP_USER,''NACH_PRODUKTEN_REZEPTIEREN'') != 0 and'||unistr('\000a')||
':fas_aufgerufen_von = ''BETREUER''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3917407536334843 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_MN_REZEPT_ID_NEU',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Rezept Id Neu',
  p_source_type=> 'ALWAYS_NULL',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3936720279795481 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_VERRECHNUNGSLAND',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 19,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'DECLARE'||unistr('\000a')||
'   v_optwert_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_optwert_id := frgbg_s.get_pers_option(:APP_USER,8);'||unistr('\000a')||
'   RETURN (v_optwert_id);'||unistr('\000a')||
'END;'||unistr('\000a')||
'',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'VERRECHNUNGSLAND',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 8 /* Verrechnungsland*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN */'||unistr('\000a')||
'  and ot.art = 1       /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'  and (select count(*)'||unistr('\000a')||
'       from pers_optionen po1'||unistr('\000a')||
'       where po1.persstamm_id = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'         and po1.opttyp_id = 8'||unistr('\000a')||
'       )> 0   /* Subsetdefinitionen vorhanden */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 8 /* Verrechnungsland*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN */'||unistr('\000a')||
'  and (ot.art = 0       /* DEFAULTwertverwaltung */'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       (ot.art = 1 and  /* Subset */'||unistr('\000a')||
'         (select count(*)'||unistr('\000a')||
'          from pers_optionen po1'||unistr('\000a')||
'          where po1.persstamm_id = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'            and po1.opttyp_id = 8'||unistr('\000a')||
'         )=0   /* Subsetdefinitionen nicht vorhanden */'||unistr('\000a')||
'        )'||unistr('\000a')||
'       )'||unistr('\000a')||
'order by 1'||unistr('\000a')||
'/*order by sortierung*/',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' and '||unistr('\000a')||
'1=2 /* wird nicht mehr verwendet */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '2',
  p_attribute_02 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4077126882744023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_BL_EOVITAL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Eovital',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4759505690984116 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_ZUSATZBEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 16,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zusatzbemerkung',
  p_source=>'ZUSATZBEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 4000,
  p_cHeight=> 5,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4804120963545679 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_TOGGLE_MNR_VORSCHRIFT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 3,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'MNR_VORSCHRIFT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(77,frgbg_s.get_sprache_id(:APP_USER)) v,   '||unistr('\000a')||
'      0 r'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(76,frgbg_s.get_sprache_id(:APP_USER)) v,          '||unistr('\000a')||
'      1 r'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'order by 2',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'frgbg_s.check_fas_rolle(:APP_USER,''MNR_VORSCHRIFT_VERWALTEN'') != 0 and'||unistr('\000a')||
':fas_aufgerufen_von = ''BETREUER'' ',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5128032075648389 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_PERSONENSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Personenstamm Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5128810735651668 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5129615930653175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5130422509655031 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5152801777377668 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5124311174608206+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5156519701401817 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_PAGE_TITEL_FBLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5124311174608206+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5165205314634190 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_AKT_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 5124311174608206+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(508,:fas_sprache_id) a,0 b'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(509,:fas_sprache_id) , 1 '||unistr('\000a')||
'FROM DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'SUBMIT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5380003909464001 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_PAGE_TITEL_REZLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 75,
  p_item_plug_id => 5377325249460687+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5382816900505620 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_REZ_AKT_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 5377325249460687+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(508,:fas_sprache_id) a,0 b'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(509,:fas_sprache_id) , 1 '||unistr('\000a')||
'FROM DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'SUBMIT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5423227550227718 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_PAGE_TITEL_PATIENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5464620323372257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 5377325249460687+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5542805755268625 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_REZEPT_ERFASSEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5565713238471145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5565914670471145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_REZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Rezept Nr',
  p_source=>'REZEPT_NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5566318620471145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Version',
  p_source=>'VERSION',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5566715795471146 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_AKT_VERSION_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Akt Version',
  p_source=>'AKT_VERSION',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5566903244471146 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_BEZEICHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bezeichnung',
  p_source=>'BEZEICHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5567123362471146 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_MN_REZTYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Reztyp Id',
  p_source=>'MN_REZTYP_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5567508959471146 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_MNREZLEVEL_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mnrezlevel Id',
  p_source=>'MNREZLEVEL_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5567919059471148 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_PRODHINWEIS1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prodhinweis1',
  p_source=>'PRODHINWEIS1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5568110069471148 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_PRODHINWEIS2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prodhinweis2',
  p_source=>'PRODHINWEIS2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5568527856471148 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_PERSONENSTAMM_ID_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Personenstamm Id',
  p_source=>'PERSONENSTAMM_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5568700661471148 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 15,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> ':p140_name||'' ''||:p140_vorname||'' ''||:p140_geburtsdatum',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 147,
  p_cMaxlength=> 100,
  p_cHeight=> 3,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6091410498997625 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_PAGE_TITEL_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6268103243741931 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_NV_PATIENTEN_UEBERSICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Patienten Uebersicht',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6725000402670457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_BL_VERWERFEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7346927389270000 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_MN_REZART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'P140_MN_REZART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',id,:fas_sprache_id), id'||unistr('\000a')||
'FROM MN_REZARTEN'||unistr('\000a')||
'order by sort'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7567530853164201 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_JUMP_TO_AUSW_PAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 5409217189101814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8877113343599731 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_REZEPTHINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 13,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'REZEPTHINWEIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8877928580604150 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_ARZT_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 17,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'N',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ARZT_REZEPT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(77,frgbg_s.get_sprache_id(:APP_USER)) v,   '||unistr('\000a')||
'      ''N'' r'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(76,frgbg_s.get_sprache_id(:APP_USER)) v,          '||unistr('\000a')||
'      ''J'' r'||unistr('\000a')||
'FROM DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8878705855607004 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_ARZT_REZEPT_GUELTIG_BIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 18,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'DD.MM.YYYY',
  p_source=>'ARZT_REZEPT_GUELTIG_BIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER_CLASSIC',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8894209692835201 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_REZEPTHINWEIS_EINGABE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 105,
  p_cMaxlength=> 2000,
  p_cHeight=> 3,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8927211077185742 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_REZEPTHINWEIS_ORIG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 5564918895471143+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10744420774549229 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_BL_OTA_SUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 270,
  p_item_plug_id => 5377325249460687+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10870126079274164 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_OTA_REZEPT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 5377325249460687+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10870700584276284 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_OTA_HERKUNFT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 5377325249460687+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12196004746415023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_HEIGHT_REZLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 300,
  p_item_plug_id => 5377325249460687+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12196902107423664 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 140,
  p_name=>'P140_HEIGHT_FBLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 5124311174608206+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6106232249174231 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P140_BEMERKUNG_not_null',
  p_validation_sequence=> 10,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P140_BEMERKUNG IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(517,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 5565117052471143 + wwv_flow_api.g_id_offset,
  p_associated_item=> 5568700661471148 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8933804645395051 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'arzt_rezept_gueltig_check',
  p_validation_sequence=> 20,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P140_arzt_rezept = ''N'' AND :p140_arzt_rezept_gueltig_bis IS NOT NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(658,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 5565117052471143 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4817205917649589 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'mnr_vorschrift_check',
  p_validation_sequence=> 30,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P140_toggle_mnr_vorschrift = 1 and'||unistr('\000a')||
'      :P140_TOGGLE_REZEPTART = ''PRODR'' '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(2507,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 5565117052471143 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7348726940487495 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_MN_REZART_ID',
  p_validation_sequence=> 40,
  p_validation => 'BEGIN -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'   IF :P140_MN_REZART_ID != 0 AND :P140_toggle_mnr_vorschrift = 1 THEN'||unistr('\000a')||
'      -- ''Bei Rezeptvorschriften ist nur Rezeptart "Gesamtmischung" erlaubt!'';'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(9186,:fas_sprache_id,'||unistr('\000a')||
'  fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',0,:fas_sprache_id)'||unistr('\000a')||
'           ));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 5565117052471143 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|PIS:V_MN_REZEPTE:P140_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 5569014819471150 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from V_MN_REZEPTE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Abrufen von Zeile nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF frgbg_s.check_fas_rolle(:APP_USER,''NACH_PRODUKTEN_REZEPTIEREN'') != 0 THEN'||unistr('\000a')||
'      :P140_TOGGLE_REZEPTART := ''PRODR'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :P140_TOGGLE_REZEPTART := ''MNR'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3908222741817609 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_toggle_rezept',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p140_rezept_erfassen = 1 ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT text INTO :p140_rezepthinweis_eingabe'||unistr('\000a')||
'      FROM uebersetzungen'||unistr('\000a')||
'      WHERE text_id = 634'||unistr('\000a')||
'        AND sprache_id = v_sprache_id;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN no_data_found THEN'||unistr('\000a')||
'      NULL;'||unistr('\000a')||
'   END ;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   :p140_rezepthinweis_eingabe := frgbg_s.HOLEN_UEBERSET';

p:=p||'ZUNG(634,:fas_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Beim Speichern werden nur geänderte Rezepthinweise gespeichert; Standarttext soll nicht'||unistr('\000a')||
'   -- als rezepthinweis gespeichert werden, sondern da ist nur die text_id gefüllt'||unistr('\000a')||
'   :p140_rezepthinweis_orig := :p140_rezepthinweis_eingabe;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8895621991876643 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 70,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_rezepthinweis_default',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'P140_REZEPT_ERFASSEN',
  p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2',
  p_process_when2=>'1',
  p_process_when_type2=>'',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'IF :REQUEST = ''ERSTELLEN'' THEN'||unistr('\000a')||
'   :p140_rezept_erfassen := 1;'||unistr('\000a')||
'ELSE'||unistr('\000a')||
'   :p140_rezept_erfassen := 0;'||unistr('\000a')||
'END IF;';

wwv_flow_api.create_page_process(
  p_id     => 5543322031273400 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 5,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'switch_rezept_erstellen_rezeptliste',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_status NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :P140_MN_REZTYP_ID := 3; -- manuell erstelltes Rezepts'||unistr('\000a')||
'   :P140_MNREZLEVEL_ID := 3; -- Complete'||unistr('\000a')||
'   :P140_PERSONENSTAMM_ID_1 := :P140_PERSONENSTAMM_ID;'||unistr('\000a')||
'   SELECT mn_rezept_seq.nextval into :p140_id from dual;'||unistr('\000a')||
''||unistr('\000a')||
'   :p140_bezeichnung := :p140_name||'', ''||:p140_vorname||'||unistr('\000a')||
'';

p:=p||'                        '', ''||:p140_geburtsdatum;'||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI: Die Nutzung der DB-Spalte :p140_rezepthinweis für den Originaltext hat nicht funktioniert'||unistr('\000a')||
'   -- => Einführen der Variable :p140_rezepthinweis_orig)'||unistr('\000a')||
'   IF trim(:p140_rezepthinweis_eingabe) != trim(:p140_rezepthinweis_orig) OR'||unistr('\000a')||
'      (:p140_rezepthinweis_eingabe IS NULL AND :p140_rezepthinweis_orig IS NOT NULL) OR'||unistr('\000a')||
'      (:p140_rezepthinwei';

p:=p||'s_eingabe IS NOT NULL AND :p140_rezepthinweis_orig IS NULL )'||unistr('\000a')||
'   THEN -- geänderter Rezepthinweis speichern'||unistr('\000a')||
'      :p140_rezepthinweis := :p140_rezepthinweis_eingabe;'||unistr('\000a')||
'   ELSE -- Speichern ohne rezepthinweis'||unistr('\000a')||
'      :p140_rezepthinweis := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5575224483501154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_neues_rezept',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'CREATE',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   fas_synch.ARCHIV_REZ_UPD;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3774016738425417 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fas_ota_synchronisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>10736729469504373 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   /* Null im Clob heisst nicht leer sondern ''<br />'' und das Feld ist 8 lang => manuell leeren*/'||unistr('\000a')||
'   /* damit nicht unnötig ein leeres clob mit Laenge 8 erzeugt wird */'||unistr('\000a')||
'   IF length(:P140_ZUSATZBEMERKUNG)=8  and substr(:P140_ZUSATZBEMERKUNG,1,6)=''<br />'' THEN'||unistr('\000a')||
'      :P140_ZUSATZBEMERKUNG:=empty_clob(); '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Automatic row process geht wegen CLOB nicht mehr => insert manuell auspr';

p:=p||'ogrammiert'||unistr('\000a')||
'   INSERT INTO v_mn_rezepte (id,'||unistr('\000a')||
'                             MNR_VORSCHRIFT,'||unistr('\000a')||
'                             REZEPTHINWEIS,'||unistr('\000a')||
'                             BEMERKUNG,'||unistr('\000a')||
'                             ZUSATZBEMERKUNG,                             '||unistr('\000a')||
'                             ARZT_REZEPT,'||unistr('\000a')||
'                             ARZT_REZEPT_GUELTIG_BIS,'||unistr('\000a')||
'                             VERRECHNUNGSLAND,'||unistr('\000a')||
'         ';

p:=p||'                    REZEPT_NR,'||unistr('\000a')||
'                             VERSION,'||unistr('\000a')||
'                             AKT_VERSION,'||unistr('\000a')||
'                             BEZEICHNUNG,'||unistr('\000a')||
'                             MN_REZTYP_ID,'||unistr('\000a')||
'                             MNREZLEVEL_ID,'||unistr('\000a')||
'                             PRODHINWEIS1,'||unistr('\000a')||
'                             PRODHINWEIS2,'||unistr('\000a')||
'                             PERSONENSTAMM_ID,'||unistr('\000a')||
'                           ';

p:=p||'  MN_REZART_ID                -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'             )'||unistr('\000a')||
'   VALUES (                  :p140_id,'||unistr('\000a')||
'                             :P140_TOGGLE_MNR_VORSCHRIFT,'||unistr('\000a')||
'                             :P140_REZEPTHINWEIS,'||unistr('\000a')||
'                             :P140_BEMERKUNG,'||unistr('\000a')||
'                             :P140_ZUSATZBEMERKUNG,                             '||unistr('\000a')||
'                             ';

p:=p||':P140_ARZT_REZEPT,'||unistr('\000a')||
'                             :P140_ARZT_REZEPT_GUELTIG_BIS,'||unistr('\000a')||
'                             :P140_VERRECHNUNGSLAND,'||unistr('\000a')||
'                             :P140_REZEPT_NR,'||unistr('\000a')||
'                             :P140_VERSION,'||unistr('\000a')||
'                             :P140_AKT_VERSION,'||unistr('\000a')||
'                             :P140_BEZEICHNUNG,'||unistr('\000a')||
'                             :P140_MN_REZTYP_ID,'||unistr('\000a')||
'                             :P14';

p:=p||'0_MNREZLEVEL_ID,'||unistr('\000a')||
'                             :P140_PRODHINWEIS1,'||unistr('\000a')||
'                             :P140_PRODHINWEIS2,'||unistr('\000a')||
'                             :P140_PERSONENSTAMM_ID,'||unistr('\000a')||
'                             :P140_MN_REZART_ID          -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'             );'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4760717539242962 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'insert_v_mn_rezepte',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''CREATE'' ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'PIS:V_MN_REZEPTE:P140_ID:ID|I';

wwv_flow_api.create_page_process(
  p_id     => 5569226581471150 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of V_MN_REZEPTE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Verarbeiten von Zeile der Tabelle V_MN_REZEPTE nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''CREATE'' and 1=2',
  p_process_when_type=>'NEVER',
  p_process_success_message=> 'Aktion wurde verarbeitet.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_von_mn_rezept_id  NUMBER;'||unistr('\000a')||
'   v_mn_rezept_id_neu  NUMBER;'||unistr('\000a')||
'   v_rezept_nr         NUMBER;'||unistr('\000a')||
'   v_version_neu       NUMBER;'||unistr('\000a')||
'   v_gen_hint1         number;'||unistr('\000a')||
'   v_reichweite        number;'||unistr('\000a')||
'   v_return  number := 0;'||unistr('\000a')||
'   v_fehlertext        VARCHAR2(2000);'||unistr('\000a')||
'   v_sprache_id        NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_fehler            exception;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Produktrezept mit 20 mg ';

p:=p||'Vitamin b1 automatisch erzeugen:--AND :P140_TOGGLE_REZEPTART = ''PRODR'''||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''MN-Rezept Vitamin B1 20mg: Pers=%1 REZEPT:%2 %3! [page140,produktrezept_anlegen]'', v_PROT_ID, ''TEST'', ''fas'',:P140_PERSONENSTAMM_ID,:p140_id,:P140_TOGGLE_REZEPTART );'||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :p140_id IS NOT NULL AND (:P140_TOGGLE_REZEPTART != ''PRODR'' OR '||unistr('\000a')||
'                                :P140_TOGGLE_REZEPTART IS NULL OR'||unistr('\000a')||
'             ';

p:=p||'                   :P140_TOGGLE_MNR_VORSCHRIFT = 1 )-- Vorschriften haben kein Prodrez.'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p140_mn_rezept_id_neu := :p140_ID;  -- Merken, um gleich auf Rezeptkopf springen'||unistr('\000a')||
'   ELSIF :p140_id IS NOT NULL AND :P140_TOGGLE_REZEPTART = ''PRODR'' THEN'||unistr('\000a')||
'      -- mn_rezept_id des Standardrezepts holen'||unistr('\000a')||
'      v_von_mn_rezept_id := frgbg_s.GET_PERS_OPTION(:APP_USER,6);'||unistr('\000a')||
'      -- Kopieren der Rezeptin';

p:=p||'halte'||unistr('\000a')||
'      IF v_von_mn_rezept_id IS NOT NULL THEN'||unistr('\000a')||
'         v_return := rezepte.KOPIEREN_MNR_ALLE(:p140_id,v_von_mn_rezept_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      -- Produktrezept dazu anlegen'||unistr('\000a')||
'      IF v_return > 0 THEN'||unistr('\000a')||
'         -- Rezept auf rückberechnet setzen'||unistr('\000a')||
'         UPDATE v_mn_rezepte'||unistr('\000a')||
'         set mn_reztyp_id = 5'||unistr('\000a')||
'         WHERE id = :p140_id;'||unistr('\000a')||
''||unistr('\000a')||
'         -- Neue Rezept-id/Version holen '||unistr('\000a')||
'         SELECT rez';

p:=p||'ept_nr'||unistr('\000a')||
'         INTO v_rezept_nr'||unistr('\000a')||
'         FROM mn_rezepte'||unistr('\000a')||
'         WHERE id = :p140_id;'||unistr('\000a')||
'         v_version_neu := rezepte.get_mnr_max_version(v_rezept_nr);'||unistr('\000a')||
'         select id into v_mn_rezept_id_neu'||unistr('\000a')||
'         from mn_rezepte '||unistr('\000a')||
'         where rezept_nr = v_rezept_nr'||unistr('\000a')||
'           and version = v_version_neu;'||unistr('\000a')||
'         -- Gen-Hint1 setzen: Menge überschreitbar'||unistr('\000a')||
'         v_gen_hint1 := 1;'||unistr('\000a')||
'   '||unistr('\000a')||
'         v_rei';

p:=p||'chweite := NVL(frgbg_s.GET_PERS_OPTION(:APP_USER,7),30);'||unistr('\000a')||
'         :p140_mn_rezept_id_neu := v_mn_rezept_id_neu;  -- Merken und gleich auf Rezeptkopf springen'||unistr('\000a')||
''||unistr('\000a')||
'         -- Produktrezeptgenerierung starten ohne Glättung aber mit n-Tage hochrechnen gen_hint2=n'||unistr('\000a')||
'         v_return := rezepte.gen_produktrezept(:p140_id,v_mn_rezept_id_neu,v_gen_hint1,v_reichweite,'||unistr('\000a')||
'                        :fas_sortiment_id';

p:=p||',-- NEI 14.02.2011 Sortimentseinf.'||unistr('\000a')||
'                        v_fehlertext); '||unistr('\000a')||
'/*MEL.P (''MN-Rezept 3 Vitamin B1 20mg: Pers=%1 REZEPT:%2 %3 v_return:%4! [page140,produktrezept_anlegen]'', v_PROT_ID, ''TEST'', ''fas'',:P140_PERSONENSTAMM_ID,:p140_id,:P140_TOGGLE_REZEPTART,v_return );'||unistr('\000a')||
'*/'||unistr('\000a')||
'         IF v_return = -1 THEN -- nicht ganzzahlige Stückartikel'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(578';

p:=p||',v_sprache_id);'||unistr('\000a')||
'            mel.p(''Standard-Produktrezept fehlgeschlagen: %1! [page140,produktrezept_anlegen]'', '||unistr('\000a')||
'                  v_PROT_ID, ''ERROR'', ''fas'',v_fehlertext);'||unistr('\000a')||
'            RAISE v_fehler;'||unistr('\000a')||
'         ELSIF v_return < -1 THEN  -- Fehler'||unistr('\000a')||
'            :p140_mn_rezept_id_neu := null;   -- Kein Rezept generiert'||unistr('\000a')||
'            -- Alle bisher generierten EintrÃ¤ge entfernen!!!!  => Produktrezepte, M';

p:=p||'NR-Rezept-Kopf fÃ¼r rÃ¼ckberechnet'||unistr('\000a')||
'        '||unistr('\000a')||
'            v_return := rezepte.del_alle_eintraege(:p140_id,v_mn_rezept_id_neu);'||unistr('\000a')||
'            IF v_return < 1 THEN'||unistr('\000a')||
'               --:P202_fehlertext := ''Datenbereinigung konnte nicht fehlerfrei durchgefÃ¼hrt werden!'';'||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(579,v_sprache_id);'||unistr('\000a')||
'               mel.p(''Standard-Produktrezept fehlgeschlagen: %';

p:=p||'1! [page140,produktrezept_anlegen]'', '||unistr('\000a')||
'                      v_PROT_ID, ''ERROR'', ''fas'',v_fehlertext);'||unistr('\000a')||
'               RAISE v_fehler;'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               --:P202_fehlertext := ''Fehlerhaftes Produktrezept! Daten werden bereinigt. Fehler ''||'||unistr('\000a')||
'               --                    to_char(v_return)||'': ''||v_fehlertext; '||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(580,v_sprache_i';

p:=p||'d);'||unistr('\000a')||
'               mel.p(''Standard-Produktrezept fehlgeschlagen: %1! [page140,produktrezept_anlegen]'', '||unistr('\000a')||
'                      v_PROT_ID, ''ERROR'', ''fas'',v_fehlertext);'||unistr('\000a')||
'               RAISE v_fehler;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE    -- Anzahl Artikel'||unistr('\000a')||
'            IF v_return = 0 THEN'||unistr('\000a')||
'               -- Alle bisher generierten EintrÃ¤ge entfernen!!!! => Produktrezepte, MNR-Rezept-Kopf fÃ¼r rÃ¼ckber';

p:=p||'echnet '||unistr('\000a')||
'               :p140_mn_rezept_id_neu := NULL ; -- kein Rezept generiert'||unistr('\000a')||
'               v_return := rezepte.del_alle_eintraege(:p140_id,v_mn_rezept_id_neu);'||unistr('\000a')||
'               IF v_return < 1 THEN'||unistr('\000a')||
'                  --:p202_fehlertext := '||unistr('\000a')||
'                  --     ''Datenbereinigung konnte nicht fehlerfrei durchgefÃ¼hrt werden!'';'||unistr('\000a')||
'                  v_fehlertext := frgbg_s.holen_uebersetzung(579,v_';

p:=p||'sprache_id);'||unistr('\000a')||
'                  mel.p(''Standard-Produktrezept fehlgeschlagen: %1![page140,produktrezept_anlegen]'', '||unistr('\000a')||
'                        v_PROT_ID, ''ERROR'', ''fas'',v_fehlertext);'||unistr('\000a')||
'                  RAISE v_fehler;'||unistr('\000a')||
'               ELSE'||unistr('\000a')||
'                  --:p202_fehlertext := '||unistr('\000a')||
'                  --     ''Kein passenden Artikel fÃ¼r das MNR gefunden! Daten werden bereinigt.'';'||unistr('\000a')||
'                  v_fehlert';

p:=p||'ext := frgbg_s.holen_uebersetzung(581,v_sprache_id);'||unistr('\000a')||
'                  mel.p(''Standard-Produktrezept fehlgeschlagen: %1![page140,produktrezept_anlegen]'', '||unistr('\000a')||
'                        v_PROT_ID, ''ERROR'', ''fas'',v_fehlertext);'||unistr('\000a')||
'                  RAISE v_fehler;'||unistr('\000a')||
'               END IF;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         END IF;  -- Fehlerbehandlung gen_produktrezept'||unistr('\000a')||
'         commit;'||unistr('\000a')||
'      ELSE -- Kein Standardrez';

p:=p||'ept möglich'||unistr('\000a')||
'         :p140_mn_rezept_id_neu := :p140_ID;  -- Merken, um gleich auf Rezeptkopf springen'||unistr('\000a')||
'      END IF; -- Gen_produktrezept durchführen'||unistr('\000a')||
'   END IF; -- MNR-Rezept als Basis für Produktrezept anlegen '||unistr('\000a')||
'/*MEL.P(''Gen-Prod Ende MNR-Details speichern neue Rezept-ID: %1 '',v_prot_id,''TEST'',''[page140,produktrezept_anlegen]'',:p140_mn_rezept_id_neu);   */'||unistr('\000a')||
''||unistr('\000a')||
'exception'||unistr('\000a')||
'when v_fehler then'||unistr('\000a')||
'     RAISE_';

p:=p||'APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(1915,v_sprache_id,v_fehlertext));'||unistr('\000a')||
'when others then'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(1812,v_sprache_id,1));'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3909310863031898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 35,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_rezept_und_produktrezept_standard_anlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''CREATE'' ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'P140_BEZEICHNUNG,P140_BEMERKUNG,P140_ID';

wwv_flow_api.create_page_process(
  p_id     => 5593406062366346 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_ITEMS',
  p_process_name=> 'cache_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5565117052471143 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'P140_PERSONENSTAMM_ID';

wwv_flow_api.create_page_process(
  p_id     => 6778314647053006 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_ITEMS',
  p_process_name=> 'cache_loeschen_zurueck',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>6720914900646225 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P140_HEIGHT_rezliste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'   :P140_HEIGHT_fbliste  := :FAS_SCROLLREGION_HEIGHT_MAX * 0.8;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12194619937391053 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'    v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p140_personenstamm_id IS NULL THEN'||unistr('\000a')||
'      :p140_personenstamm_id := :p110_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   select name,vorname,to_char(geburtsdatum,''DD.MM.YYYY'')'||unistr('\000a')||
'   into :p140_name,:p140_vorname,:p140_geburtsdatum'||unistr('\000a')||
'   from personenstamm'||unistr('\000a')||
'   where id = :p140_personenstamm_id;'||unistr('\000a')||
''||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN no_data_found THEN'||unistr('\000a')||
'     -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'   ';

p:=p||'  v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id)||'' (0)'';'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'     -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'     v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5131632683667510 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p140_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p140_bl_verwerfen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   :p140_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id); '||unistr('\000a')||
'   :p140_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);-- NEI 23.06.08'||unistr('\000a')||
'   :P140_bl_ota_suche := frgbg_s.holen_ueb';

p:=p||'ersetzung(756,v_sprache_id);'||unistr('\000a')||
'   :P140_bl_eovital   := frgbg_s.holen_uebersetzung(2040,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p140_page_titel_fbliste := frgbg_s.holen_uebersetzung(507,v_sprache_id);'||unistr('\000a')||
'   :p140_page_titel_rezliste := frgbg_s.holen_uebersetzung(512,v_sprache_id);'||unistr('\000a')||
'   :p140_page_titel_patient := frgbg_s.holen_uebersetzung(482,v_sprache_id);'||unistr('\000a')||
'   :p140_page_titel_rezept := frgbg_s.holen_uebersetzung(515,v_spr';

p:=p||'ache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P140_NV_PATIENTEN_UEBERSICHT := frgbg_s.holen_uebersetzung(3837,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5133932384695782 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'   v_ota_rezept_id NUMBER;'||unistr('\000a')||
'   v_bemerkung    VARCHAR2(2000);'||unistr('\000a')||
'   v_bezeichnung  VARCHAR2(100); '||unistr('\000a')||
'   v_ota_herkunft VARCHAR2(100);'||unistr('\000a')||
'   v_mn_rezept_nr           mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_mn_rezept_id_alt       mn_rezepte.id%TYPE; '||unistr('\000a')||
'   v_mn_rezept_id_neu       mn_rezepte.id%TYPE; '||unistr('\000a')||
'   v_return       NUMBER;'||unistr('\000a')||
'   v_fehlertext   VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P140_OTA_REZ';

p:=p||'EPT_ID IS NOT NULL AND :p140_ota_herkunft is NOT NULL THEN'||unistr('\000a')||
'/* MEL.P (''OTA-Rezept Kopieren: Pers=%1 OTA-REZEPT:%2! [page140,ota_rezept_kopieren]'', v_PROT_ID, ''ERROR'', ''fas'',:P140_PERSONENSTAMM_ID,:p140_ota_herkunft||''/''||:p140_ota_rezept_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'      v_ota_rezept_id := :P140_OTA_REZEPT_ID;'||unistr('\000a')||
'      :P140_OTA_REZEPT_ID := NULL;'||unistr('\000a')||
'      v_ota_herkunft := :P140_OTA_HERKUNFT;'||unistr('\000a')||
'      :P140_OTA_HERKUNFT := N';

p:=p||'ULL;'||unistr('\000a')||
''||unistr('\000a')||
'      v_bezeichnung := :p140_name||'', ''||:p140_vorname||'||unistr('\000a')||
'                       '', ''||:p140_geburtsdatum;'||unistr('\000a')||
'      v_bemerkung := v_OTA_HERKUNFT||'' Rezept mit ID ''||v_ota_rezept_id;'||unistr('\000a')||
''||unistr('\000a')||
'      v_return := fas_synch.FAS_GEN_OTA_REZEPT(v_ota_rezept_id,v_ota_herkunft,'||unistr('\000a')||
'                 :P140_PERSONENSTAMM_ID,v_bezeichnung,v_bemerkung,'||unistr('\000a')||
'                 :fas_sortiment_id );   -- NEI 14.02.2011 Sortiments';

p:=p||'einfuehrung'||unistr('\000a')||
'      IF v_return <= 0 AND v_return >= -100 THEN   -- Datenübernahme fehlerhaft'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(1518,frgbg_s.get_sprache_id(:APP_USER))'||unistr('\000a')||
'                                                  || '' (''||to_char(v_return)||'')'' ;'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'      ELSIF v_return < -100 THEN  -- Produktgenerierung fehlerhaft'||unistr('\000a')||
'        ';

p:=p||' v_fehlertext := frgbg_s.holen_uebersetzung(580,frgbg_s.get_sprache_id(:APP_USER))'||unistr('\000a')||
'                                                  || '' (''||to_char(v_return)||'')'' ;'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10871405909287237 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 41,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'ota_kopieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'  -- Damit wird festgelegt, das wenn man in den FB geht man sofort zur Auswertungseite springt, wenn der Fragebogen bereits ausgewertet ist. '||unistr('\000a')||
'  -- Die Auswertungsseite setzt diesen Wert zurück, damit man innerhalb des Fragebogens ganz normal auf den Adresstab gehen kann. '||unistr('\000a')||
'  :P140_JUMP_TO_AUSW_PAGE := 1;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7566207903100768 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 140,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'SET P140_JUMP_TO_AUSW_PAGE',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 140
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00141
prompt  ...PAGE 141: Rezepturenliste-Direktdruck
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 141
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Rezepturenliste-Direktdruck'
 ,p_step_title => 'Rezepturenliste-Direktdruck'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Rezepturenliste-Direktdruck'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20141002140755'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6564413143810768 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 141,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6564614666810776 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 141,
  p_plug_name=> '&P141_PAGE_TITEL_PATIENT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT'||unistr('\000a')||
'  mn.ID, mn.REZEPT_NR, '||unistr('\000a')||
'  CASE '||unistr('\000a')||
'  WHEN mn.neuberechnen = ''J'' OR'||unistr('\000a')||
'       mn.neuberechnen_sortiment = ''J'' -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'  THEN'||unistr('\000a')||
'    --''<span style="background-color:yellow;">''||mn.VERSION||''</span>'''||unistr('\000a')||
'       mn.VERSION'||unistr('\000a')||
'     ||'' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'     ||frgbg_s.holen_uebersetzung(4890,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'     ||''  <img src=';

s:=s||'"#IMAGE_PREFIX#yellow_flag.gif">'''||unistr('\000a')||
'  ELSE to_char(mn.VERSION)'||unistr('\000a')||
'  END '||unistr('\000a')||
'  ||'||unistr('\000a')||
'  CASE WHEN p.prod_rezstatus_id = 1'||unistr('\000a')||
'  THEN'||unistr('\000a')||
'       '' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'     ||frgbg_s.holen_uebersetzung(4889,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'     ||''  <img src="#IMAGE_PREFIX#red_flag.gif">'''||unistr('\000a')||
'  ELSE NULL'||unistr('\000a')||
'  END version, '||unistr('\000a')||
'  mn.AKT_VERSION, mn.BEZEICHNUNG, '||unistr('\000a')||
'  mn.MN_REZTYP_ID, '||unistr('\000a')||
'  mn.MNREZLEVEL_';

s:=s||'ID, mn.PRODHINWEIS1, mn.PRODHINWEIS2, mn.MAN_GEAENDERT_AM, '||unistr('\000a')||
'  mn.MAN_GEAENDERT_DURCH, mn.ANALYSE_ID, mn.PAT_AKTE_ID, mn.PERGEBNIS_ID, '||unistr('\000a')||
'  mn.PERSONENSTAMM_ID, '||unistr('\000a')||
'  mn.BEMERKUNG || CASE WHEN mn_org.zusatzbemerkung is not null THEN '||unistr('\000a')||
'           ''   <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':204:'''||unistr('\000a')||
'         ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P204_MN_REZEPT_ID:''||mn.id||'''''',1000,550)">'''||unistr('\000a')||
'         || ''<';

s:=s||'img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END  bemerkung,'||unistr('\000a')||
'  mn.SATZ_KENNZEICHEN, mn.STATUS, '||unistr('\000a')||
'  mn.MN_REZTYP_ID_VERS1,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'  /* bearbeitbare Version */'||unistr('\000a')||
'  WHEN mn.akt_version = 1 '||unistr('\000a')||
'    AND mn.status not in (2,3) -- Rezepte, die keine ungÃ¼ltig Version besitzen '||unistr('\000a')||
'    --AND mn.aenderbar = ''J''   -- NEI 02.10.14 auch nicht veränderbare Rezept sollen druckbar sei';

s:=s||'n'||unistr('\000a')||
'    AND (mn.mnr_vorschrift = 0 OR   -- MNR-Vorschriften nur von Betreuern mit'||unistr('\000a')||
'         mn.mnr_vorschrift = 1 AND  -- entsprechender Rolle'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''MNR_VORSCHRIFT_VERWALTEN'') != 0'||unistr('\000a')||
'        )'||unistr('\000a')||
'    --AND :fas_pers_aenderbar = 1     -- Personendaten aenderbar'||unistr('\000a')||
'    AND :fas_modus_id !=1           -- FAS-Modus nicht Iabc  NEI 11.01.10'||unistr('\000a')||
'    AND mn.neuberechnen = ''N''      ';

s:=s||' -- Veraltetes Rezept nicht druckbar'||unistr('\000a')||
'    AND mn.neuberechnen_sortiment = ''N'' -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'    AND p.PROD_REZSTATUS_ID != 1    -- Keine Arbeitsversion'||unistr('\000a')||
'  THEN ''<a href="'''||unistr('\000a')||
'||''javascript:popUp2(''''''||APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':215:''||:APP_SESSION||''::&DEBUG.::'''||unistr('\000a')||
'||''P215_REZEPT_NR,P215_VERSION,P215_TERRITORY,P215_SPRACHE_ID,P215_P_REZEPT_ID,P215_PERSSTAMM_ID,P215_';

s:=s||'VERRECHNUNGSLAND:'''||unistr('\000a')||
'||mn.REZEPT_NR||'',''||mn.VERSION||'',''||:P141_TERRITORY||'',''||:P141_SPRACHE_ID'||unistr('\000a')||
'||'',''|| p.ID||'',''||:P141_PERSONENSTAMM_ID||'',''||mn.VERRECHNUNGSLAND )'||unistr('\000a')||
'||'''''',1000,560)'''||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#print06.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE /* nur anzeigbare Version, da Vorgängerversion od.nicht änderbar */'||unistr('\000a')||
'/*''<a href="'''||unistr('\000a')||
'||APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':201:''||:APP_SESSION||''::&D';

s:=s||'EBUG.::'''||unistr('\000a')||
'||''P201_PERSON,P201_MN_REZEPT_ID,P201_BEARB_MODUS:'''||unistr('\000a')||
'||to_char(mn.PERSONENSTAMM_ID)||'',''||to_char(mn.ID)||'',ANZEIGEN'')'||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#fndsublg.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
''' '''||unistr('\000a')||
'END LINK_MNR,'||unistr('\000a')||
'  --auftragsdispo.GET_LAST_BESTELL_DAT(mn.id) mn_rezept_id_last,'||unistr('\000a')||
'  frgbg_s.WK_GET_LAST_BESTELL_DAT(p.id,NULL) mn_rezept_id_last,'||unistr('\000a')||
'  p.id prod_rezept_id'||unistr('\000a')||
'from v_mn_rezepte mn,prod_rezepte p, mn';

s:=s||'_rezepte mn_org'||unistr('\000a')||
'WHERE mn.personenstamm_id = :p141_personenstamm_id'||unistr('\000a')||
'  and mn.mn_reztyp_id in (1,3,5,6)'||unistr('\000a')||
'  and mn.MN_REZTYP_ID_VERS1 in (1,3)   -- Manuelle od. FB-Rezepte'||unistr('\000a')||
'  AND mn.akt_version >= :p141_rez_akt_version'||unistr('\000a')||
'  and mn.satz_kennzeichen is null      -- keine gelöschten Versionen'||unistr('\000a')||
'  and mn.status in (0,1)               -- keine ungültigen Rezepte'||unistr('\000a')||
'  AND mn.version = p.version (+)'||unistr('\000a')||
'  AND mn.rezept_n';

s:=s||'r = p.rezept_nr (+)'||unistr('\000a')||
'  AND mn.id = mn_org.id'||unistr('\000a')||
'  AND mn.rezept_nr_splitbasis is NULL  -- NEI 14.01.14 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'  AND mn.version_splitbasis is NULL    -- NEI 14.01.14 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
''||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 141,
  p_name=> '&P141_PAGE_TITEL_REZLISTE.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 900,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_when_condition=> 'NVL(:fas_modus_id,0) != 1 /* 1 = IABC-Modus */',
  p_display_condition_type=> 'PLSQL_EXPRESSION',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P141_HEIGHT_REZLISTE.px;min-width: 600px; max-width: 600px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(513,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '1000',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'Keine Daten gefunden',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '2000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6566612989810781 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6566731506810781 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_default_sort_dir=>'desc',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6566825036810781 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'VERSION',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>2,
  p_default_sort_dir=>'desc',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6566926564810781 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'AKT_VERSION',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567011040810781 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567107388810781 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MN_REZTYP_ID',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567222628810781 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'MNREZLEVEL_ID',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567306102810781 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'PRODHINWEIS1',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567402921810781 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'PRODHINWEIS2',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567507199810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'MAN_GEAENDERT_AM',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_format=> 'DD.MM.YYYY HH24:MI:SS',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567608329810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'MAN_GEAENDERT_DURCH',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567727336810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'ANALYSE_ID',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567825903810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'PAT_AKTE_ID',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6567922105810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'PERGEBNIS_ID',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6568010260810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'PERSONENSTAMM_ID',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6568125764810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6568217623810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'SATZ_KENNZEICHEN',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6568302471810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6568418156810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'MN_REZTYP_ID_VERS1',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6568521991810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'LINK_MNR',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6568610276810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'MN_REZEPT_ID_LAST',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_format=> 'DD.MM.YYYY',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6568701983810782 + wwv_flow_api.g_id_offset,
  p_region_id=> 6566417694810781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'PROD_REZEPT_ID',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6569205890810789 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 141,
  p_button_sequence=> 50,
  p_button_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_button_name    => 'ZURUECK',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P141_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6581928404810843 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6569205890810789+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>6582523076810851 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6570019087810792 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_NV_PATIENTEN_UEBERSICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Patienten Uebersicht',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6571409132810804 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_PERSONENSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Personenstamm Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6571618497810804 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6571829761810806 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6572029136810806 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6572824242810806 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_PAGE_TITEL_REZLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 75,
  p_item_plug_id => 6566417694810781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6573000816810806 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_REZ_AKT_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 6566417694810781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(508,:fas_sprache_id) a,0 b'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(509,:fas_sprache_id) , 1 '||unistr('\000a')||
'FROM DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'SUBMIT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6573204049810807 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_PAGE_TITEL_PATIENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6578018577810812 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_HEIGHT_REZLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 300,
  p_item_plug_id => 6566417694810781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6589512280014984 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'App Sprache Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6589906870022965 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_TERRITORY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Territory',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6590114489025075 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 360,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprache Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6591530138209417 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_AENDERBAR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 370,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Aenderbar',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6591704296211435 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'User Account',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6593529379379517 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_PREPARE_URL_BESTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 390,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prepare Url Bestellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6608501171947876 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 141,
  p_name=>'P141_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 400,
  p_item_plug_id => 6564614666810776+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P141_HEIGHT_rezliste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6581023468810840 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 141,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'    v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p141_personenstamm_id IS NULL THEN'||unistr('\000a')||
'      :p141_personenstamm_id := :p110_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   select name,vorname,to_char(geburtsdatum,''DD.MM.YYYY''),'||unistr('\000a')||
'          app_sprache_id,user_account,aenderbar'||unistr('\000a')||
'   into :p141_name,:p141_vorname,:p141_geburtsdatum,'||unistr('\000a')||
'        :p141_app_sprache_id,:p141_user_account,:p141_aenderbar'||unistr('\000a')||
'   from personenstamm'||unistr('\000a')||
'   where id';

p:=p||' = :p141_personenstamm_id;'||unistr('\000a')||
''||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN no_data_found THEN'||unistr('\000a')||
'     -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'     v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id)||'' (0)'';'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'     -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'     v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'     RAISE_APPLICATION';

p:=p||'_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6581203787810840 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 141,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p141_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   --:p141_bl_verwerfen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   --:p141_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id); '||unistr('\000a')||
'   --:p141_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);-- NEI 23.06.08'||unistr('\000a')||
''||unistr('\000a')||
'   :p141_page_titel_rezliste := frg';

p:=p||'bg_s.holen_uebersetzung(512,v_sprache_id);'||unistr('\000a')||
'   :p141_page_titel_patient := frgbg_s.holen_uebersetzung(482,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P141_NV_PATIENTEN_UEBERSICHT := frgbg_s.holen_uebersetzung(3837,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6581430521810840 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 141,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_identitaet_persstamm_id   personenstamm.id%TYPE;'||unistr('\000a')||
'   v_persstamm_id              personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fas_pers_schema_id        fas_schemas.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                varchar2(2000);'||unistr('\000a')||
'   v_prot_id                   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Diese Routine best. die aktive Identität, Kunden-Schema, Sortiment eines ausgewählten Kunden'||unistr('\000a')||
'   -- Persstamm_id kommt 5x vor'||unistr('\000a')||
'   v_pers';

p:=p||'stamm_id := :P141_PERSONENSTAMM_ID;'||unistr('\000a')||
'   IF v_persstamm_id IS NULL THEN -- Patient muss vorhanden sein'||unistr('\000a')||
'       v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Bestimmen der aktiven Identität'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN   -- Aktive Identität ist immer bevorzugt betreuende Identität des Kunden bzw. ';

p:=p||'falls nicht vorhanden betreuende Identität des Kunden '||unistr('\000a')||
'         /*'||unistr('\000a')||
'         v_identitaet_persstamm_id:=  '||unistr('\000a')||
'                     frgbg_s.get_identitaet_kunde(:fas_login_personenstamm_id,'||unistr('\000a')||
'                                            -1,'||unistr('\000a')||
'                                            v_persstamm_id);      '||unistr('\000a')||
'         */'||unistr('\000a')||
'         /* NEI 20.09.13: => Zukünftig wird nur noch die bevorzugt betreuende Person des';

p:=p||' Kunden zur'||unistr('\000a')||
'                               aktive Identität egal ob der Betreuer Zugriff auf die Identität hat.'||unistr('\000a')||
'                               Er sieht den Kunden, vielleicht auch nur, weil er speziell Zugriff auf den Kunden hat, '||unistr('\000a')||
'                               da der Kunde von einer Idenität (Apo Richter) noch zusätzlich betreut wird, '||unistr('\000a')||
'                               auf die der Betreuer auch Zugr';

p:=p||'iff hat. D.h. der Betreuer hat nicht direkten Zugriff'||unistr('\000a')||
'                               auf die bevorzugt betreuende Identität und daher auf alle Kunden von dieser Identität, '||unistr('\000a')||
'                               sondern nur ein spezieller Kunde dieser bevorzugt betreuende Identität ist für den Betreuer bzw.'||unistr('\000a')||
'                               seiner zugreifbaren Identitäten freigeschaltet.'||unistr('\000a')||
'         */'||unistr('\000a')||
'        ';

p:=p||' v_identitaet_persstamm_id:=  '||unistr('\000a')||
'              frgbg_s.get_identitaet_kunde( NULL,'||unistr('\000a')||
'                                            -1,'||unistr('\000a')||
'                                            v_persstamm_id);'||unistr('\000a')||
'         IF v_identitaet_persstamm_id <= 0 OR '||unistr('\000a')||
'             v_identitaet_persstamm_id is NULL'||unistr('\000a')||
'         THEN '||unistr('\000a')||
'            :fas_identitaet := '''';'||unistr('\000a')||
'            :fas_identitaet_persstamm_id := NULL;'||unistr('\000a')||
'            v_fe';

p:=p||'hlertext := frgbg_s.holen_uebersetzung(3098,:fas_sprache_id);'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'            :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,'||unistr('\000a')||
'                                                          :FAS_SCHEMA_ID);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'   ELSIF :fas_a';

p:=p||'ufgerufen_von in (''ANONYM'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Betreuende Identitaet für Endkunden holen'||unistr('\000a')||
'       SELECT parameter'||unistr('\000a')||
'       INTO v_identitaet_persstamm_id'||unistr('\000a')||
'       FROM sysareas_frgbg'||unistr('\000a')||
'       WHERE id = 6;'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
' ';

p:=p||'  ELSIF :fas_aufgerufen_von in (''KUNDE'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Holen der Identitaet aus Pers_betreuer mit standard = J'||unistr('\000a')||
'       v_identitaet_persstamm_id := frgbg_s.GET_IDENTITAET_KUNDE(NULL,-1,v_persstamm_id);'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,:FAS_SCHEMA';

p:=p||'_ID);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Schema-Id des Kunden setzen, abgeleitet aus der bevorzugt betreuenden Identitaet => wird beim Druck für die Auswahllistten von Kundensprache verwendet'||unistr('\000a')||
'   -- Schema der bevorzugt betreuenden Identitaet bestimmen '||unistr('\000a')||
'   v_fas_pers_schema_id := frgbg_s.get_fas_schema('||unistr('\000a')||
'         frgbg_s.get_identitaet_kunde(NULL,-1,v_persstamm_id),'||unistr('\000a')||
'          ''IDENTITAET'');'||unistr('\000a')||
'   IF v_fas_pers_schema_i';

p:=p||'d <= 0 OR '||unistr('\000a')||
'      v_fas_pers_schema_id is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :fas_pers_schema_id := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3505,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_schema_id := v_fas_pers_schema_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Sortiment-ID der aktiven Identitaet '||unistr('\000a')||
'   -- NEI 14.02.2011 Sortimentseinfuehrung: sortiment_id statt preislist';

p:=p||'en_set_id      '||unistr('\000a')||
'   :FAS_SORTIMENT_ID:= rezepte.get_sortiment(:FAS_IDENTITAET_PERSSTAMM_ID,''IDENTITAET'');'||unistr('\000a')||
'   IF :FAS_SORTIMENT_ID <= 0 OR '||unistr('\000a')||
'      :FAS_SORTIMENT_ID is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :FAS_SORTIMENT_ID := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3518,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20004,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'/*MEL.P (''Bst. genereller Parameter Wahlident %1; Log';

p:=p||'in-id %2; aktive Ident %3; Schema-kunde:%4, akt.Schema:%5,Sortiment:%6,Person:%7'', v_PROT_ID, ''TEST'', ''aktive_identitaet_pers_schema_sortiment_setzen'',:p110_wahl_identitaet,:fas_login_personenstamm_id,'||unistr('\000a')||
'v_identitaet_persstamm_id,:fas_pers_schema_id,:fas_schema_id,:FAS_SORTIMENT_ID,v_persstamm_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6590620647121496 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 141,
  p_process_sequence=> 91,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'aktive_identitaet_pers_schema_sortiment_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_gus_id     personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_satzkennzeichen personenstamm.satzkennzeichen%TYPE;'||unistr('\000a')||
'   v_url        VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* Identitaeten dürfen nicht gelöscht sein  */'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT gus_id,satzkennzeichen INTO v_gus_id,v_satzkennzeichen'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :FAS_IDENTITAET_PERSSTAMM_ID;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_satzkennzeichen is not null TH';

p:=p||'EN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(10179,:fas_sprache_id);'||unistr('\000a')||
'      v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':130:''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'';

p:=p||'      apex_application.g_unrecoverable_error := true;   --- stops all further page processing      '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 9389630066025132 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 141,
  p_process_sequence=> 92,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_zugang',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF   (:p141_aenderbar = ''J'') '||unistr('\000a')||
'     OR (:p141_aenderbar = ''N'' AND'||unistr('\000a')||
'         -- speziell berechtigt'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''GESCHUETZTE_PERSONENDATEN_AENDERN'') > 0 '||unistr('\000a')||
'         )'||unistr('\000a')||
'      OR (:p141_aenderbar = ''N'' AND                 -- User hat sich selbst eingeloggt'||unistr('\000a')||
'          :fas_aufgerufen_von != ''BETREUER'' and'||unistr('\000a')||
'          UPPER(:P141_USER_ACCOUNT)= UPPER(:APP_USER)'||unistr('\000a')||
'         ';

p:=p||')'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :fas_pers_aenderbar := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_aenderbar := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6591032300191087 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 141,
  p_process_sequence=> 100,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_fas_pers_aenderbar',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':P202_PREPARE_URL_BESTELLEN := '||unistr('\000a')||
'apex_util.prepare_url('||unistr('\000a')||
'''f?p=&APP_ID.:215:&SESSION.::&DEBUG.:215:P215_REZEPT_NR,P215_VERSION,P215_TERRITORY,P215_SPRACHE_ID,P215_P_REZEPT_ID,P215_PERSSTAMM_ID,P215_VERRECHNUNGSLAND:''||'||unistr('\000a')||
':P201_REZEPT_NR||'',''||:P201_VERSION||'',''||:P201_TERRITORY||'',''||:P201_SPRACHE_ID||'',''|| :P202_ID||'',''||:P201_ID||'',''||:P201_VERRECHNUNGSLAND );';

wwv_flow_api.create_page_process(
  p_id     => 6593931242389489 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 141,
  p_process_sequence=> 100,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_perpare_url_bestellen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id        number := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Sprache und Territory des Patienten festlegen für den Etikettendruck Page 215'||unistr('\000a')||
'   SELECT TERRITORY, sprache_id INTO :P141_TERRITORY , :p141_sprache_id'||unistr('\000a')||
'   FROM APP_SPRACHEN'||unistr('\000a')||
'   WHERE ID = :p141_app_sprache_id;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6589131626992215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 141,
  p_process_sequence=> 120,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'person_sprache_territory _setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 141
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00145
prompt  ...PAGE 145: OTA_patientenliste
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 145
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'OTA_patientenliste'
 ,p_step_title => 'OTA_patientenliste'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'OTA_patientenliste'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20120716195925'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3170504329898734 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 145,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT person_id,'||unistr('\000a')||
'       name||'', ''||vorname||'', ''||to_char(geburtsdatum,''DD.MM.YYYY'') Name,'||unistr('\000a')||
'       adresse||'', ''||PLZ||'' ''||Ort||'', ''||Land Adresse,bezeichnung,'||unistr('\000a')||
'       herkunft,versand_datum,'||unistr('\000a')||
'       rezept_datum,rezept_id,'||unistr('\000a')||
'              ''<a href="'''||unistr('\000a')||
'              ||APEX_UTIL.PREPARE_URL(''f?p=&APP_ID.:140:&SESSION.::&DEBUG.::'''||unistr('\000a')||
'              ||''P140_OTA_HERKUNFT,P140_OTA_REZEPT_ID:'''||unistr('\000a')||
'              ||';

s:=s||'HERKUNFT||'',''||to_char(rezept_id))'||unistr('\000a')||
'              || ''">'''||unistr('\000a')||
'              || ''<img src="#IMAGE_PREFIX#edit_big.gif">'''||unistr('\000a')||
'              || ''</a>'' link,'||unistr('\000a')||
'        suchnachname,'||unistr('\000a')||
'        suchvorname,'||unistr('\000a')||
'        name name_sort,vorname vorname_sort'||unistr('\000a')||
'from v_ota_patient_alle '||unistr('\000a')||
'WHERE herkunft not like ''VITAIMP%'' /* Rezepte laden ohne Transferrezepte */'||unistr('\000a')||
'   AND'||unistr('\000a')||
'    ( -- mind. ein Suchkriterium ist bestückt'||unistr('\000a')||
'     (:p145_fa';

s:=s||'s_name is not null OR :p145_fas_vorname is not null OR'||unistr('\000a')||
'      :p145_bezeichnung is not NULL'||unistr('\000a')||
'     )'||unistr('\000a')||
'   AND'||unistr('\000a')||
'     (:p145_fas_name is null OR'||unistr('\000a')||
'      :p145_fas_name IS NOT NULL and'||unistr('\000a')||
'      suchnachname like ''%''||frgbg_t.normstring(:p145_fas_name)||''%'')'||unistr('\000a')||
'     and'||unistr('\000a')||
'     (:p145_fas_vorname IS NULL OR'||unistr('\000a')||
'      :p145_fas_vorname is not null and'||unistr('\000a')||
'      suchvorname like ''%''||frgbg_t.normstring(:p145_fas_vorname)||''%'')'||unistr('\000a')||
'';

s:=s||'     and'||unistr('\000a')||
'     (:p145_bezeichnung IS NULL OR'||unistr('\000a')||
'      :p145_bezeichnung is not null and'||unistr('\000a')||
'      bezeichnung  like ''%''||:p145_bezeichnung||''%'')'||unistr('\000a')||
'   )'||unistr('\000a')||
'  OR'||unistr('\000a')||
'   (--  ohne Suchkriterium kein Ergebnis'||unistr('\000a')||
'     (:p145_fas_name is null AND :p145_fas_vorname is null AND'||unistr('\000a')||
'      :p145_bezeichnung is NULL AND 1=2'||unistr('\000a')||
'     )'||unistr('\000a')||
'   )'||unistr('\000a')||
'order by name_sort,vorname_sort,versand_datum_sort desc,rezept_datum desc,herkunft,rezept_id desc';

wwv_flow_api.create_report_region (
  p_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 145,
  p_name=> '&P145_PAGE_TITLE_OTA_PATIENTEN.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P145_HEIGHT_OTA_PATIENTEN.px;">'||unistr('\000a')||
''||unistr('\000a')||
'',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 2899210279489446+ wwv_flow_api.g_id_offset,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(757,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '1000',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '1:2:3',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3776001930470070 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'PERSON_ID',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10883325412332110 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'NAME',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10883424977332110 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ADRESSE',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3766400571583931 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10883504388332110 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'HERKUNFT',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 11393805414652820 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'VERSAND_DATUM',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10884904239335214 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_DATUM',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10883813579332110 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3741309901972265 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10883918517332110 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHNACHNAME',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10884002052332110 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHVORNAME',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10884104706332110 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'NAME_SORT',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10884209001332110 + wwv_flow_api.g_id_offset,
  p_region_id=> 10652909029360939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'VORNAME_SORT',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 3776216653512229 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 145,
  p_button_sequence=> 1,
  p_button_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_button_name    => 'CLEAR_SUCHE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P145_BL_CLEAR_SUCHKRITERIEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10664819674432543 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 145,
  p_button_sequence=> 5,
  p_button_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_button_name    => 'OTA_SUCHE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P145_BL_OTA_SUCHE.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10661424261414981 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 145,
  p_button_sequence=> 10,
  p_button_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P145_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>10669825393472059 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:145:P140_OTA_HERKUNFT,P140_OTA_REZEPT_ID:,',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>10661424261414981+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 27-FEB-2008 15:32 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10665126353432543 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:145:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3766716894617032 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_name=>'P145_BEZEICHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 25,
  p_item_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3777411468586387 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_name=>'P145_BL_CLEAR_SUCHKRITERIEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Clear Suchkriterien',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6271114680820950 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_name=>'P145_NV_OTA_REZEPTSUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Ota Rezeptsuche',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10657628238378228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_name=>'P145_FAS_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10658232394379460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_name=>'P145_FAS_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10662204652418792 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_name=>'P145_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10665729025435235 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_name=>'P145_BL_OTA_SUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'ota_suche',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10710120834134728 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_name=>'P145_PAGE_TITLE_OTA_PATIENTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12273506861068532 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 145,
  p_name=>'P145_HEIGHT_OTA_PATIENTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 10652909029360939+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3772930556026018 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 145,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_suchkriterien',
  p_validation_sequence=> 20,
  p_validation => 'IF :P145_fas_name is NULL AND :p145_bezeichnung IS NULL AND       '||unistr('\000a')||
'   :p145_fas_vorname is NULL'||unistr('\000a')||
'THEN'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(1726,:fas_sprache_id));'||unistr('\000a')||
'END IF;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 10664819674432543 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p145_bl_abbrechen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   :p145_bl_ota_suche := frgbg_s.holen_uebersetzung(756,v_sprache_id);'||unistr('\000a')||
'   :p145_bl_clear_suchkriterien := frgbg_s.holen_uebersetzung(1746,v_sprache_id);'||unistr('\000a')||
'   :P145_PAGE_TITLE_OTA_PATIENTEN := frgbg_s.holen_uebersetzung(758,v_sprache_id);'||unistr('\000a')||
'   :P145_NV_OTA_REZEPTSUCHE := frgbg';

p:=p||'_s.holen_uebersetzung(3840,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10662815734421960 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 145,
  p_process_sequence=> 41,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p145_fas_name := NULL;'||unistr('\000a')||
'   :p145_fas_vorname := NULL;'||unistr('\000a')||
'   :p145_bezeichnung := NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3776824318542790 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 145,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'suchkriterien_löschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>3776216653512229 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P145_HEIGHT_OTA_PATIENTEN := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12272723352063775 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 145,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 145
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00150
prompt  ...PAGE 150: Textübersetzungen
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 150
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Textübersetzungen'
 ,p_step_title => 'Textübersetzungen'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Textübersetzungen'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_inline_css => 
'.ueb_textarea {'||unistr('\000a')||
'  background-color:white;'||unistr('\000a')||
'  color:black;'||unistr('\000a')||
'  border:1px solid #DBDBDB;'||unistr('\000a')||
'  font-family:Arial;'||unistr('\000a')||
'}'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141104110022'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT'||unistr('\000a')||
'    vuu.TEXT_ID                                                   TEXT_ID,'||unistr('\000a')||
'  '||unistr('\000a')||
'  CASE WHEN INSTR(trim(T.BESCHREIBUNG),''<'') > 0 THEN ''<iframe class="ueb_textarea" id="iframe_ueb_besch_id_'' '||unistr('\000a')||
'  || vuu.TEXT_ID || ''_'' ||rownum || ''" style="display:none;width:500px;height:'''||unistr('\000a')||
'     || CASE WHEN length(T.BESCHREIBUNG) < 100 THEN'||unistr('\000a')||
'            ''80'''||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            ''150'''||unistr('\000a')||
'         END'||unistr('\000a')||
'      || ''p';

s:=s||'x;"></iframe><textarea id="ueb_besch_id_'' '||unistr('\000a')||
'  || vuu.TEXT_ID || ''_'' ||rownum || ''"'''||unistr('\000a')||
'   ELSE ''<textarea''  END || '' class="ueb_textarea" disabled="disabled" '''||unistr('\000a')||
'      || '' style="width:500px;height:'''||unistr('\000a')||
'      || CASE WHEN length(T.BESCHREIBUNG) < 100 THEN'||unistr('\000a')||
'            ''80'''||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            ''150'''||unistr('\000a')||
'         END'||unistr('\000a')||
'      || ''px;">'''||unistr('\000a')||
'        ||htf.escape_sc( substr(T.BESCHREIBUNG,1,500)) ||'||unistr('\000a')||
'        CASE WH';

s:=s||'EN length(T.BESCHREIBUNG) > 500 THEN'||unistr('\000a')||
'          ''..'''||unistr('\000a')||
'        ELSE NULL END || ''</textarea>''                          BESCHREIBUNG,'||unistr('\000a')||
'    U1_S.ISO2_ID || '' -> '' || U2_S.ISO2_ID                        SPRACHE,'||unistr('\000a')||
'  CASE WHEN vuu.T_EDITOR_TYP in(''TEXT'',''HTML'') THEN'||unistr('\000a')||
'      CASE WHEN vuu.T_EDITOR_TYP in(''HTML'') THEN '||unistr('\000a')||
'        ''<iframe style="display:none;width:600px;height:'''||unistr('\000a')||
'        || CASE WHEN vuu.U1_TEXT_LE';

s:=s||'NGTH < 100 THEN'||unistr('\000a')||
'            ''80'''||unistr('\000a')||
'          ELSE'||unistr('\000a')||
'            ''150'''||unistr('\000a')||
'          END'||unistr('\000a')||
'        || ''px;" class="ueb_textarea" id="iframe_ueb_org_ueb_id_'' || vuu.U1_ID || ''_'' || ROWNUM || ''" ></iframe>'''||unistr('\000a')||
'        || ''<textarea id="ueb_org_ueb_id_'' || vuu.U1_ID || ''_'' || ROWNUM || ''"'''||unistr('\000a')||
'      ELSE ''<textarea '' END '||unistr('\000a')||
'      || '' class="ueb_textarea" disabled="disabled" '''||unistr('\000a')||
'      || '' style="width:600px;height:'''||unistr('\000a')||
'    ';

s:=s||'  || CASE WHEN vuu.U1_TEXT_LENGTH < 100 THEN'||unistr('\000a')||
'            ''80'''||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            ''150'''||unistr('\000a')||
'         END'||unistr('\000a')||
'      || ''px;">'''||unistr('\000a')||
'        ||htf.escape_sc('||unistr('\000a')||
'            CASE WHEN vuu.U1_TEXT IS NOT NULL'||unistr('\000a')||
'            THEN substr(vuu.U1_TEXT,1,500)'||unistr('\000a')||
'            ELSE DBMS_LOB.SUBSTR(vuu.U1_CLOB_DAT,500,1)'||unistr('\000a')||
'            END ) ||'||unistr('\000a')||
'        CASE WHEN length(vuu.U1_TEXT_LENGTH) > 500 THEN'||unistr('\000a')||
'          ''..'''||unistr('\000a')||
'        ELSE N';

s:=s||'ULL END || ''</textarea>'''||unistr('\000a')||
'  WHEN vuu.T_EDITOR_TYP in(''FILE'') THEN'||unistr('\000a')||
'    ''[DATEI]'''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'    ''unknown data editor type: '' || vuu.T_EDITOR_TYP'||unistr('\000a')||
'  END                                                           ORIGINAL_TEXT,'||unistr('\000a')||
'    ''<a onclick="return false;" class="bearb_ueb" href="'''||unistr('\000a')||
'       || APEX_UTIL.PREPARE_URL(''f?p='' || :APP_ID || '':152:'' || :APP_SESSION'||unistr('\000a')||
'        || ''::NO:152:P152_ID,P152_TEXT_ID,P152_';

s:=s||'SPRACHE_ID,P152_SPRACHE_ID_VON:'' || vuu.U2_ID'||unistr('\000a')||
'        || '','' || t.ID'||unistr('\000a')||
'        || '','' || U2_S.ID'||unistr('\000a')||
'        || '','' || U1_S.ID)'||unistr('\000a')||
'        || ''"><img src="#IMAGE_PREFIX#edit_big.gif" alt=""></a>''EDIT_BUT,'||unistr('\000a')||
'    ''<div style="width:100px;">'' || NVL(UEB2_s.UEB,''Unknown Status-ID: '' || vuu.U2_TSTATUS_ID) || ''</div>''  STATUS,'||unistr('\000a')||
'    vuu.U1_SPRACHE_ID                                           U1_SPRACHE_ID,'||unistr('\000a')||
'    vuu.u';

s:=s||'2_SPRACHE_ID                                           U2_SPRACHE_ID,'||unistr('\000a')||
'    t.ERFDAT                                                      ERFASS_DATUM'||unistr('\000a')||
'from TEXTE t, FRGBG.V_UEBERS_UEBERSETZER vuu, SPRACHEN U1_S, SPRACHEN U2_S'||unistr('\000a')||
'  , ('||unistr('\000a')||
'    -- Dieses Subselect verhindert das für jede Zeile'||unistr('\000a')||
'    -- FRGBG_S.HOLEN_UEBERSETZUNG aufgerufen wird'||unistr('\000a')||
'    -- stellt die ÜBERSETZTEN Statustexte zur Verfügung'||unistr('\000a')||
'    SELECT';

s:=s||' ID STATUS_ID, NVL(FRGBG_S.HOLEN_UEBERSETZUNG(BESCHREIBUNG_TEXT_ID'||unistr('\000a')||
'        , :FAS_SPRACHE_ID),BESCHREIBUNG) || '' ('' || ID || '')'' UEB FROM TEXTSTATUS'||unistr('\000a')||
'    UNION ALL -- zu übersetzen/ Übersetzung ist nicht vorhanden'||unistr('\000a')||
'    SELECT 0 STATUS_ID, FRGBG_S.HOLEN_UEBERSETZUNG(11278, :FAS_SPRACHE_ID) UEB'||unistr('\000a')||
'        FROM DUAL'||unistr('\000a')||
'   ) UEB2_S,'||unistr('\000a')||
'   (SELECT ID DOKTYP_ID, NVL(FRGBG_S.HOLEN_UEBERSETZUNG(BESCHREIBUNG_TEXT_ID'||unistr('\000a')||
'';

s:=s||'        , :FAS_SPRACHE_ID),BESCHREIBUNG) UEB'||unistr('\000a')||
'   FROM DOKUMENTTYPEN'||unistr('\000a')||
'   ) DOK_TYP /**/'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'   :P150_REPORT_REFRESH is not null'||unistr('\000a')||
'   AND t.ID = vuu.TEXT_ID'||unistr('\000a')||
'   AND UEB2_S.STATUS_ID = vuu.U2_TSTATUS_ID'||unistr('\000a')||
'   AND DOK_TYP.DOKTYP_ID = vuu.T_DOKUMENTTYP_ID'||unistr('\000a')||
'   AND U1_S.ID = vuu.U1_SPRACHE_ID'||unistr('\000a')||
'   and U2_S.Id = vuu.U2_SPRACHE_ID'||unistr('\000a')||
'   AND (:P150_DOKUMENTTYP_IDS is null OR'||unistr('\000a')||
'    vuu.T_DOKUMENTTYP_ID in('||unistr('\000a')||
'        select ';

s:=s||'to_number(REGEXP_SUBSTR (txt, ''[^,:]+'', 1, level))  value'||unistr('\000a')||
'        from (select :P150_DOKUMENTTYP_IDS as txt from dual)'||unistr('\000a')||
'        connect by level <= length(regexp_replace(txt,''[^,:]*''))+1'||unistr('\000a')||
'   ))'||unistr('\000a')||
'   AND (:P150_SPRACHE_ID_VON = 0 OR vuu.U1_SPRACHE_ID = :P150_SPRACHE_ID_VON)'||unistr('\000a')||
'   AND (:P150_SPRACHE_ID_NACH = 0 OR vuu.U2_SPRACHE_ID = :P150_SPRACHE_ID_NACH)'||unistr('\000a')||
'   AND (:P150_TSTATUS_IDS_ZIEL is null OR :P150_TS';

s:=s||'TATUS_IDS_ZIEL = ''-1'''||unistr('\000a')||
'        OR'||unistr('\000a')||
'        vuu.U2_TSTATUS_ID in('||unistr('\000a')||
'        select to_number(REGEXP_SUBSTR (txt, ''[^,:]+'', 1, level))  value'||unistr('\000a')||
'        from (select :P150_TSTATUS_IDS_ZIEL as txt from dual)'||unistr('\000a')||
'        connect by level <= length(regexp_replace(txt,''[^,:]*''))+1'||unistr('\000a')||
'    )'||unistr('\000a')||
'   )'||unistr('\000a')||
'   AND vuu.U2_SPRACHE_ID in(-- Nur Sprachen erlauben, auf die Person auch Zugriff hat'||unistr('\000a')||
'        SELECT SPRACHE_ID'||unistr('\000a')||
'        FROM';

s:=s||' UEBERSETZER'||unistr('\000a')||
'        WHERE PERSSTAMM_ID = :P150_PERSONENSTAMM_ID'||unistr('\000a')||
'            AND REFERENZSPRACHE = 0'||unistr('\000a')||
'   )'||unistr('\000a')||
'   AND vuu.U1_SPRACHE_ID in(-- Nur Sprachen erlauben, auf die Person auch Zugriff hat'||unistr('\000a')||
'        SELECT SPRACHE_ID'||unistr('\000a')||
'        FROM UEBERSETZER'||unistr('\000a')||
'        WHERE PERSSTAMM_ID = :P150_PERSONENSTAMM_ID'||unistr('\000a')||
'          AND REFERENZSPRACHE = 1'||unistr('\000a')||
'   )'||unistr('\000a')||
'   AND (:P150_SUCH_TEXT is NULL'||unistr('\000a')||
'        OR lower(T.BESCHREIBUNG) l';

s:=s||'ike ''%'' || replace(lower(:P150_SUCH_TEXT),'' '',''%'') || ''%'''||unistr('\000a')||
'        OR lower(t.BEMERKUNG) like ''%'' || replace(lower(:P150_SUCH_TEXT),'' '',''%'') || ''%'''||unistr('\000a')||
'        OR lower(vuu.U2_TEXT) like ''%'' || replace(lower(:P150_SUCH_TEXT),'' '',''%'') || ''%'''||unistr('\000a')||
'        OR lower(vuu.U1_TEXT) like ''%'' || replace(lower(:P150_SUCH_TEXT),'' '',''%'') || ''%'''||unistr('\000a')||
'        OR lower(vuu.U2_CLOB_DAT) like ''%'' || replace(lower(:P150_SUCH_TEXT';

s:=s||'),'' '',''%'') || ''%'''||unistr('\000a')||
'        OR lower(vuu.U1_CLOB_DAT) like ''%'' || replace(lower(:P150_SUCH_TEXT),'' '',''%'') || ''%'''||unistr('\000a')||
'   )'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 150,
  p_name=> '&P150_REGION_TITEL_TEXTE.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => true,
  p_new_grid_column  => true,
  p_display_column=> null,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="width:90%">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'return (frgbg_s.holen_uebersetzung(11576,:FAS_SPRACHE_ID))',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '25',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_WITH_LINKS',
  p_query_row_count_max=> '2000',
  p_pagination_display_position=> 'TOP_AND_BOTTOM_LEFT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6738010978310688 + wwv_flow_api.g_id_offset,
  p_region_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'TEXT_ID',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6738132666310690 + wwv_flow_api.g_id_offset,
  p_region_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'BESCHREIBUNG',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '300',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6738229082310690 + wwv_flow_api.g_id_offset,
  p_region_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'SPRACHE',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6738305320310690 + wwv_flow_api.g_id_offset,
  p_region_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'ORIGINAL_TEXT',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_css_style=>'max-width:150px;',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '500',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6738426943310691 + wwv_flow_api.g_id_offset,
  p_region_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'EDIT_BUT',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6738508617310691 + wwv_flow_api.g_id_offset,
  p_region_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6777703224638927 + wwv_flow_api.g_id_offset,
  p_region_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'U1_SPRACHE_ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6777816026638929 + wwv_flow_api.g_id_offset,
  p_region_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'U2_SPRACHE_ID',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6778822152691004 + wwv_flow_api.g_id_offset,
  p_region_id=> 6737715683310660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'ERFASS_DATUM',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_format=> 'DD.MM.YYYY',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT'||unistr('\000a')||
'  u.TEXT_ID,'||unistr('\000a')||
'  s.sprache,'||unistr('\000a')||
'  CASE '||unistr('\000a')||
'  WHEN ueb.referenzsprache = 0 and substr(u.text,1,1) = ''<'' THEN -- HTML'||unistr('\000a')||
'     --apex_item.hidden(5,u.text)||'||unistr('\000a')||
'     u.text || ''...'' || ''    <a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'         ''f?p=''||:APP_ID||'':151:''||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P151_ID:''||u.id)    '||unistr('\000a')||
'         || ''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#edit_big.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'  WHEN';

s:=s||' ueb.referenzsprache = 0 THEN'||unistr('\000a')||
'      apex_item.textarea(5,u.text,1,90)'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'    u.text'||unistr('\000a')||
'  END text,'||unistr('\000a')||
'  CASE '||unistr('\000a')||
'  WHEN ueb.referenzsprache = 0 and substr(u.text,1,1) = ''<'' THEN -- HTML'||unistr('\000a')||
'     ts.beschreibung'||unistr('\000a')||
'  WHEN ueb.referenzsprache = 0 THEN'||unistr('\000a')||
'     apex_item.hidden(1,u.ID)||'||unistr('\000a')||
'     apex_item.hidden(2,u.SPRACHE_ID)||'||unistr('\000a')||
'     apex_item.hidden(3,u.text)||'||unistr('\000a')||
'     apex_item.hidden(4,u.tstatus_ID)||'||unistr('\000a')||
'     apex_item.h';

s:=s||'idden(7,to_char(u.mutdat,''DD.MM.YYYY HH24:MI:SS''))||'||unistr('\000a')||
'     APEX_ITEM.SELECT_LIST_FROM_QUERY(6,u.TSTATUS_ID,'||unistr('\000a')||
'        ''SELECT beschreibung,id FROM textstatus'',NULL,''NO'') '||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     ts.beschreibung'||unistr('\000a')||
'  END tstatus_id ,'||unistr('\000a')||
'  t.textkategorie_id'||unistr('\000a')||
'from v_uebersetzungen_ref u, sprachen s, UEBERSETZER ueb, textstatus ts,'||unistr('\000a')||
'     texte t, pers_optionen po'||unistr('\000a')||
'where u.sprache_id = s.id'||unistr('\000a')||
'and u.text_id > 1 -- 1 ist die Dum';

s:=s||'mytext'||unistr('\000a')||
'and u.tstatus_id = ts.id'||unistr('\000a')||
'and ueb.persstamm_id = :p150_personenstamm_id'||unistr('\000a')||
'and ueb.satzkennzeichen IS NULL'||unistr('\000a')||
'and u.SPRACHE_ID = ueb.SPRACHE_ID '||unistr('\000a')||
'and t.id = u.text_id'||unistr('\000a')||
'-- Join zu Persoptionen wg. textkategorien; sind keine spezifiziert sind alle'||unistr('\000a')||
'-- möglich'||unistr('\000a')||
'and t.textkategorie_id = po.wert (+)'||unistr('\000a')||
'and po.PERSSTAMM_ID(+) = :p150_personenstamm_id'||unistr('\000a')||
'and po.OPTTYP_ID(+) = 16'||unistr('\000a')||
'and (((select count(*) from pers_op';

s:=s||'tionen po1 '||unistr('\000a')||
'           where persstamm_id = :p150_personenstamm_id and opttyp_id = 16) > 0 '||unistr('\000a')||
'       and po.PERSSTAMM_ID is not null'||unistr('\000a')||
'     ) or'||unistr('\000a')||
'     ((select count(*) from pers_optionen po1 '||unistr('\000a')||
'           where persstamm_id = :p150_personenstamm_id and opttyp_id = 16) = 0'||unistr('\000a')||
'       and po.PERSSTAMM_ID is null'||unistr('\000a')||
'     )'||unistr('\000a')||
'    )'||unistr('\000a')||
'-- Einschränkungen mit den Suchfeldern'||unistr('\000a')||
'and (:p150_such_textkategorie_id is NULL OR'||unistr('\000a')||
'  ';

s:=s||'   t.textkategorie_id = :p150_such_textkategorie_id'||unistr('\000a')||
'    )'||unistr('\000a')||
'and u.text_id in (select distinct u2.text_id'||unistr('\000a')||
'                  from v_uebersetzungen_ref u2, v_uebersetzungen_ref u3, uebersetzer ueb'||unistr('\000a')||
'                  where (:p150_such_text is NULL OR '||unistr('\000a')||
'                        (UPPER(u2.text)||u2.text_id like ''%''||UPPER(:p150_such_text)||''%'''||unistr('\000a')||
'                         and (:p150_such_sprache_id is NULL OR '||unistr('\000a')||
' ';

s:=s||'                             u2.sprache_id = :p150_such_sprache_id'||unistr('\000a')||
'                             )   '||unistr('\000a')||
'                         )'||unistr('\000a')||
'                  )'||unistr('\000a')||
'                  and (:p150_such_ueb_sprache_id IS NULL OR'||unistr('\000a')||
'                        ( u3.sprache_id = :p150_such_ueb_sprache_id AND'||unistr('\000a')||
'                          u3.tstatus_id in(10,15) -- in Arbeit,geaendert'||unistr('\000a')||
'                        )'||unistr('\000a')||
'                     ';

s:=s||' )'||unistr('\000a')||
'                  and u2.text_id = u3.text_id'||unistr('\000a')||
'                  -- Nur für die eingetragenen Sprachen suchen'||unistr('\000a')||
'                  and ueb.persstamm_id = :p150_personenstamm_id'||unistr('\000a')||
'                  and ueb.satzkennzeichen is null'||unistr('\000a')||
'                  and ueb.sprache_id = u2.sprache_id'||unistr('\000a')||
'                  and ueb.sprache_id = u3.sprache_id'||unistr('\000a')||
'                )'||unistr('\000a')||
'and u.text_id <= 8436  -- NEI letzte Text-ID, die ';

s:=s||'mit dieser Maske übersetzt werden kann, danach FALLback-Mechanismus'||unistr('\000a')||
'order by u.text_id,ueb.referenzsprache desc, s.sprache asc';

wwv_flow_api.create_report_region (
  p_id=> 8593526821406340 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 150,
  p_name=> '&P150_REGION_TITEL_TEXTE.alt',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 20,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_condition_type=> 'NEVER',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(623,frgbg_s.get_sprache_id(:APP_USER)));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '99',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '1',
  p_query_num_rows_item=> 'P150_ANZ_ZEILEN',
  p_query_num_rows_type=> 'ROW_RANGES_WITH_LINKS',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Drucken',
  p_prn_output_file_name=> 'test',
  p_prn_content_disposition=> 'ATTACHMENT',
  p_prn_document_header=> 'APEX',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width_units=> 'PERCENTAGE',
  p_prn_width=> 297,
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'LEFT',
  p_prn_page_footer_alignment=> 'LEFT',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'N',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8593804134406345 + wwv_flow_api.g_id_offset,
  p_region_id=> 8593526821406340 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'TEXT_ID',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8594315013406345 + wwv_flow_api.g_id_offset,
  p_region_id=> 8593526821406340 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'SPRACHE',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8642906676815040 + wwv_flow_api.g_id_offset,
  p_region_id=> 8593526821406340 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'TEXT',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '32000',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8643006970815043 + wwv_flow_api.g_id_offset,
  p_region_id=> 8593526821406340 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'TSTATUS_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4803911014249492 + wwv_flow_api.g_id_offset,
  p_region_id=> 8593526821406340 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'TEXTKATEGORIE_ID',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 8556228426085057 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 150,
  p_button_sequence=> 30,
  p_button_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_button_name    => 'SPEICHERN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P150_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8556131733085057 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 150,
  p_button_sequence=> 10,
  p_button_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P150_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:150::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8661313592091465 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 150,
  p_button_sequence=> 10,
  p_button_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P150_BL_SUCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8620732576516773 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 150,
  p_button_sequence=> 40,
  p_button_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P150_BL_VERWERFEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8556907150085062 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:150:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6738712638340359 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_DOKUMENTTYP_IDS',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SHUTTLE',
  p_lov=> 'SELECT UEB,'||unistr('\000a')||
'    listagg(DOKTYP_ID,'':'') WITHIN GROUP (ORDER BY DOKTYP_ID) ID'||unistr('\000a')||
''||unistr('\000a')||
'FROM ('||unistr('\000a')||
'    SELECT to_char(ID) DOKTYP_ID,'||unistr('\000a')||
'    NVL(FRGBG_S.HOLEN_UEBERSETZUNG(BESCHREIBUNG_TEXT_ID'||unistr('\000a')||
'        , :FAS_SPRACHE_ID),BESCHREIBUNG) UEB'||unistr('\000a')||
'    FROM DOKUMENTTYPEN'||unistr('\000a')||
'    WHERe'||unistr('\000a')||
'         ID in('||unistr('\000a')||
'        SELECT'||unistr('\000a')||
'            DOKUMENTTYP_ID'||unistr('\000a')||
'        FROM TEXTE'||unistr('\000a')||
'    )'||unistr('\000a')||
')'||unistr('\000a')||
'GROUP BY UEB'||unistr('\000a')||
'ORDER BY UEB;',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 150,
  p_cMaxlength=> 4000,
  p_cHeight=> 10,
  p_tag_attributes  => 'style="height:100px;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'MOVE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6740902205709780 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_SPRACHE_ID_VON',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT FRGBG_S.HOLEN_UEBERSETZUNG(511,:FAS_SPRACHE_ID) SPRACHE, 0 SPRACHe_ID FROM DUAL'||unistr('\000a')||
'UNION ALL'||unistr('\000a')||
'SELECT s.SPRACHE || '' ('' || s.ISO2_ID || '')'' SPRACHE, SPRACHE_ID'||unistr('\000a')||
'FROM UEBERSETZER u, SPRACHEN s'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'    u.PERSSTAMM_ID = :P150_PERSONENSTAMM_ID'||unistr('\000a')||
'    AND u.REFERENZSPRACHE = 1'||unistr('\000a')||
'    ANd s.ID = u.SPRACHE_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when=>'SELECT *'||unistr('\000a')||
'FROM ('||unistr('\000a')||
'     SELECT '||unistr('\000a')||
'        count(*) ANZ'||unistr('\000a')||
'     FROM UEBERSETZER'||unistr('\000a')||
'     WHERE'||unistr('\000a')||
'          PERSSTAMM_ID = :P150_PERSONENSTAMM_ID'||unistr('\000a')||
'          AND REFERENZSPRACHE = 1'||unistr('\000a')||
'          AND SATZKENNZEICHEN is null'||unistr('\000a')||
''||unistr('\000a')||
')'||unistr('\000a')||
'WHERE ANZ > 1',
  p_read_only_when_type=>'NOT_EXISTS',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6742921109792191 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_SPRACHE_ID_NACH',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 300,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'DECLARE'||unistr('\000a')||
'  v_sprache_id number;'||unistr('\000a')||
'  v_anz number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'  -- Ermittle ob es nur eine Referenzsprache gibt und liefere diese zurück. sonst sollen alle angezeigt werden.'||unistr('\000a')||
'  BEGIN'||unistr('\000a')||
'     SELECT MAX(SPRACHE_ID) SPRACHE_ID,'||unistr('\000a')||
'        count(*) ANZ'||unistr('\000a')||
'     INTO'||unistr('\000a')||
'       v_sprache_id, v_anz'||unistr('\000a')||
'     FROM UEBERSETZER'||unistr('\000a')||
'     WHERE'||unistr('\000a')||
'          PERSSTAMM_ID = :P150_PERSONENSTAMM_ID'||unistr('\000a')||
'          AND REFERENZSPRACHE = 0'||unistr('\000a')||
'          AND SATZKENNZEICHEN is null;'||unistr('\000a')||
'  EXCEPTION'||unistr('\000a')||
'     WHEN OTHERS THEN'||unistr('\000a')||
'        v_anz := 0;'||unistr('\000a')||
'  END;'||unistr('\000a')||
''||unistr('\000a')||
'  IF v_anz > 1 THEN'||unistr('\000a')||
'     v_sprache_id := 0;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
'  return NVL(V_SPRACHE_ID,0);'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT FRGBG_S.HOLEN_UEBERSETZUNG(511,:FAS_SPRACHE_ID) SPRACHE, 0 SPRACHe_ID FROM DUAL'||unistr('\000a')||
'UNION ALL'||unistr('\000a')||
'SELECT s.SPRACHE || '' ('' || s.ISO2_ID || '')'' SPRACHE, SPRACHE_ID'||unistr('\000a')||
'FROM UEBERSETZER u, SPRACHEN s'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'    u.PERSSTAMM_ID = :P150_PERSONENSTAMM_ID'||unistr('\000a')||
'    AND u.REFERENZSPRACHE = 0'||unistr('\000a')||
'    ANd s.ID = u.SPRACHE_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when=>'SELECT'||unistr('\000a')||
'  *'||unistr('\000a')||
'FROM (SELECT count(*) ANZ'||unistr('\000a')||
'     FROM UEBERSETZER'||unistr('\000a')||
'     WHERE'||unistr('\000a')||
'          PERSSTAMM_ID = :P150_PERSONENSTAMM_ID'||unistr('\000a')||
'          AND REFERENZSPRACHE = 0'||unistr('\000a')||
'          AND SATZKENNZEICHEN is null'||unistr('\000a')||
')'||unistr('\000a')||
'WHERe'||unistr('\000a')||
'  ANZ > 1',
  p_read_only_when_type=>'NOT_EXISTS',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6749006887315406 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_TSTATUS_IDS_ZIEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0:10:15',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT trim(FRGBG_S.HOLEN_UEBERSETZUNG(511,:FAS_SPRACHE_ID)) BEZ, ''-1'' TSTATUS_ID FROM DUAL'||unistr('\000a')||
'UNION ALL'||unistr('\000a')||
'-- Offene Übersetzungen'||unistr('\000a')||
'SELECT trim(FRGBG_S.HOLEN_UEBERSETZUNG(11571,:FAS_SPRACHE_ID)) BEZ, ''0:10:15'' TSTATUS_ID FROM DUAL'||unistr('\000a')||
'UNION ALL -- Abgeschlossen'||unistr('\000a')||
'SELECT trim(FRGBG_S.HOLEN_UEBERSETZUNG(11572,:FAS_SPRACHE_ID)) BEZ, ''20'' TSTATUS_ID FROM DUAL'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6754207688481628 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 220,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P150_BL_SUCHEN',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'REDIRECT_URL',
  p_button_redirect_url => 'javascript:apex.submit(''SUCHEN'')',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6756417004599384 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_REPORT_REFRESH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6756801692606495 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_LOAD_ICON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'<img src="/i/htmldb/icons/loading-gray.gif" />',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_tag_attributes  => 'style="display:none;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6915029556275207 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => 'Wird verwendet um on the fly HTML Texte in iFrames zu laden. ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6922718722872742 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_UEB_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 360,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8623023703523662 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8623628897525107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_BL_VERWERFEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8624202017526809 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8628717170550157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_FEHLERTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8638700087737414 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_PERSONENSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8653011019929885 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_REGION_TITEL_TEXTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8654602061955659 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_SUCH_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8655708604004828 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_SUCH_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT sprache, sprache_id'||unistr('\000a')||
'FROM uebersetzer u, sprachen s'||unistr('\000a')||
'/* Suchsprachen:alle eingetragenen Sprachen:  Aenderungs- und Referenzsprachen */'||unistr('\000a')||
'WHERE u.sprache_id = s.id'||unistr('\000a')||
'  AND u.persstamm_id = :p150_personenstamm_id'||unistr('\000a')||
'  and u.satzkennzeichen is NULL '||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(625,:fas_sprache_id),NULL'||unistr('\000a')||
'FROM dual'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8682422407098676 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_SUCH_UEB_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT sprache, sprache_id'||unistr('\000a')||
'FROM uebersetzer u, sprachen s'||unistr('\000a')||
'WHERE u.sprache_id = s.id'||unistr('\000a')||
'  AND u.persstamm_id = :p150_personenstamm_id'||unistr('\000a')||
'  and u.satzkennzeichen is NULL'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(632,:fas_sprache_id), NULL'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8692521387249773 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_BL_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 6737715683310660+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8746932214710087 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_ANZ_ZEILEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8762031670288664 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_SUCH_TEXTKATEGORIE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 82,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select t.bezeichnung, t.id'||unistr('\000a')||
'from textkategorien t, pers_optionen po'||unistr('\000a')||
'where t.id = po.wert (+)'||unistr('\000a')||
'and po.PERSSTAMM_ID(+) = :p150_personenstamm_id'||unistr('\000a')||
'and po.OPTTYP_ID(+) = 16'||unistr('\000a')||
'and (((select count(*) from pers_optionen po1 '||unistr('\000a')||
'           where persstamm_id = :p150_personenstamm_id and opttyp_id = 16) > 0 '||unistr('\000a')||
'       and po.PERSSTAMM_ID is not null'||unistr('\000a')||
'     ) or'||unistr('\000a')||
'     ((select count(*) from pers_optionen po1 '||unistr('\000a')||
'           where persstamm_id = :p150_personenstamm_id and opttyp_id = 16) = 0'||unistr('\000a')||
'       and po.PERSSTAMM_ID is null'||unistr('\000a')||
'     )'||unistr('\000a')||
'    )'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(632,:fas_sprache_id),NULL'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'order by bezeichnung',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8764708084329178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_ANZ_TEXTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 105,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 6000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8766629733373329 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 150,
  p_name=>'P150_ANZ_ANZEIGESPRACHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 8593526821406340+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Anz Anzeigesprachen',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8608531471336678 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 150,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_eingabe',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_neue_zeile      varchar2(10) := ''<br/>''; '||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'   v_fehlertext  VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P(''MNR-Details validieren i=%1'',v_prot_id,''Info'',''MNR-Details validieren'''||unistr('\000a')||
'--          ,apex_application.g_f01.count);'||unistr('\000a')||
'   for i in 1..apex_application.g_f01.count  loop'||unistr('\000a')||
'      IF apex_application.g_f05(i) IS NULL OR apex_application.g_f06(i) IS NULL'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         -- Eingabefelder sind nicht gefüllt'||unistr('\000a')||
'         v_fehlertext := v_fehlertext ||v_neue_zeile|| '||unistr('\000a')||
'                   frgbg_s.holen_uebersetzung(622,v_sprache_id,'||unistr('\000a')||
'                          apex_application.g_f01(i)); '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   end loop;'||unistr('\000a')||
'   -- Fehlertext wird erst am Anfang vom Speichern ausgewertet und mit Raise angezeigt'||unistr('\000a')||
'   :p150_fehlertext := v_fehlertext;'||unistr('\000a')||
'   RETURN null;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_when_button_pressed=> 8556228426085057 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6756922551608856 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_name => 'Load Icon einblenden'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 6737715683310660 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'apexbeforerefresh'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6757204088608896 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_event_id => 6756922551608856 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P150_LOAD_ICON'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6757330863611255 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_name => 'Load Icon ausblenden'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 6737715683310660 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'apexafterrefresh'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6757628830611256 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_event_id => 6757330863611255 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P150_LOAD_ICON'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6757703289612784 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_name => 'Lade Reports'
 ,p_event_sequence => 30
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6758426225612786 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_event_id => 6757703289612784 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin '||unistr('\000a')||
'  :P150_REPORT_REFRESH := 1;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P150_REPORT_REFRESH'
 ,p_attribute_03 => 'P150_REPORT_REFRESH'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6758011526612785 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_event_id => 6757703289612784 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 6737715683310660 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6779808492740238 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_name => 'öffne Modal Fenster - Übersetzung bearbeiten'
 ,p_event_sequence => 40
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => 'a.bearb_ueb'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6780124237740239 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_event_id => 6779808492740238 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_attribute_02 => 'TRIG_ELEMENT_ATTR'
 ,p_attribute_05 => 'href'
 ,p_attribute_06 => 'div#MESSAGE.t1success'
 ,p_attribute_07 => 'STATIC_%'
 ,p_attribute_08 => '80'
 ,p_attribute_09 => '80'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6780222344744272 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_name => 'schliesse Modalfenster'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'DOM_OBJECT'
 ,p_triggering_element => 'document'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE|DYNAMIC ACTION|modalpageautoclose'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6780521782744273 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_event_id => 6780222344744272 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'v_message = this.data.$modalPageCloseObject;'||unistr('\000a')||
'$(''.t1messages'').after( v_message );'||unistr('\000a')||
'$(''#MESSAGE.t1success'').delay(2000).fadeOut(2000);'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6780701628746101 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_event_id => 6780222344744272 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 6737715683310660 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6915209903315924 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_name => 'Lade HTML Texte'
 ,p_event_sequence => 60
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 6737715683310660 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'apexafterrefresh'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6915513731315927 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 150
 ,p_event_id => 6915209903315924 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '$(''textarea[id^="ueb_besch_id_"]'').each(function() {'||unistr('\000a')||
''||unistr('\000a')||
'    var $this = $(this);'||unistr('\000a')||
''||unistr('\000a')||
'    var feld_id = $this.attr(''ID'');'||unistr('\000a')||
'    var text_id = feld_id.substr(13).substr(0,feld_id.substr(13).indexOf(''_''));'||unistr('\000a')||
''||unistr('\000a')||
'   var get = new htmldb_Get(null,$v(''pFlowId''), ''APPLICATION_PROCESS=GetTextBeschreibungHTML'',0);'||unistr('\000a')||
'   get.add(''P150_TEXT_ID'', text_id);'||unistr('\000a')||
'   '||unistr('\000a')||
'   var gReturn = get.get(''HTML'');'||unistr('\000a')||
''||unistr('\000a')||
'   //Setzte den HTML Code in den Iframe ein '||unistr('\000a')||
'   $(''iframe#iframe_'' + feld_id).contents().find(''html'').html(gReturn); '||unistr('\000a')||
'   '||unistr('\000a')||
'   //Blende das alte Textfeld aus'||unistr('\000a')||
'   $this.hide();'||unistr('\000a')||
'   //Zeige das neue IFrame'||unistr('\000a')||
'   $(''iframe#iframe_'' + feld_id).show();'||unistr('\000a')||
'   '||unistr('\000a')||
'   //Gib das Objekt wieder frei'||unistr('\000a')||
'   gReturn = null;'||unistr('\000a')||
''||unistr('\000a')||
'});'||unistr('\000a')||
''||unistr('\000a')||
'var count = 1;'||unistr('\000a')||
'$(''textarea[id^="ueb_org_ueb_id_"]'').each(function() {'||unistr('\000a')||
''||unistr('\000a')||
'    var $this = $(this);'||unistr('\000a')||
''||unistr('\000a')||
'    count++;'||unistr('\000a')||
''||unistr('\000a')||
'    //if(count > 3) '||unistr('\000a')||
'    //  return;'||unistr('\000a')||
''||unistr('\000a')||
'    var feld_id = $this.attr(''ID'');'||unistr('\000a')||
'    var ueb_id = feld_id.substr(15).substr(0,feld_id.substr(15).indexOf(''_''));'||unistr('\000a')||
'   '||unistr('\000a')||
'    //alert(ueb_id);'||unistr('\000a')||
'    //return;'||unistr('\000a')||
'    var get = new htmldb_Get(null,$v(''pFlowId''), ''APPLICATION_PROCESS=GetTextUebHTML'',0);'||unistr('\000a')||
'    get.add(''P150_UEB_ID'', ueb_id);'||unistr('\000a')||
'   '||unistr('\000a')||
'   var gReturn = get.get(''HTML'');'||unistr('\000a')||
''||unistr('\000a')||
'   //Setzte den HTML Code in den Iframe ein '||unistr('\000a')||
'   $(''iframe#iframe_'' + feld_id).contents().find(''html'').html(gReturn); '||unistr('\000a')||
'   '||unistr('\000a')||
'   //Blende das alte Textfeld aus'||unistr('\000a')||
'   $this.hide();'||unistr('\000a')||
'   //Zeige das neue IFrame'||unistr('\000a')||
'   $(''iframe#iframe_'' + feld_id).show();'||unistr('\000a')||
'   '||unistr('\000a')||
'   //Gib das Objekt wieder frei'||unistr('\000a')||
'   gReturn = null;'||unistr('\000a')||
''||unistr('\000a')||
'});'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_mutdat         VARCHAR2(25);'||unistr('\000a')||
'  v_prot_id        NUMBER;'||unistr('\000a')||
'  v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'  v_fehlertext     VARCHAR2(2000);'||unistr('\000a')||
'  v_gueltige_sprachen VARCHAR2(2000);'||unistr('\000a')||
'  v_sprache        VARCHAR2(20);'||unistr('\000a')||
''||unistr('\000a')||
'  CURSOR c_sprachen  '||unistr('\000a')||
'  IS  SELECT  u.sprache_id'||unistr('\000a')||
'      FROM UEBERSETZER u,personenstamm p'||unistr('\000a')||
'      WHERE p.id = u.persstamm_id'||unistr('\000a')||
'        and UPPER(p.user_account) = UPPER(:APP_USER);'||unistr('\000a')||
''||unistr('\000a')||
'';

p:=p||'BEGIN'||unistr('\000a')||
'   IF :p150_fehlertext IS NOT NULL THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,:p150_fehlertext);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Gueltige Sprachen holen'||unistr('\000a')||
'   FOR r_sprachen IN c_sprachen LOOP'||unistr('\000a')||
'       v_gueltige_sprachen := v_gueltige_sprachen ||'';''||to_char(r_sprachen.sprache_id);'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   v_gueltige_sprachen := v_gueltige_sprachen ||'';'';'||unistr('\000a')||
''||unistr('\000a')||
'   -- speichern'||unistr('\000a')||
'   for i in 1..apex_application.g_f01.count'||unistr('\000a')||
'  ';

p:=p||' loop '||unistr('\000a')||
'/*MEL.P(''Text speichern f01 %1, f02 %2, f03 %3,f04 %4, f05 %5, f06 %6,f07 %7,f08 %8,ANz: %9  %10'','||unistr('\000a')||
'           v_prot_id,'||unistr('\000a')||
'           ''Info'','||unistr('\000a')||
'           ''Text speichern'','||unistr('\000a')||
'           apex_application.g_f01(i),  -- ID'||unistr('\000a')||
'           apex_application.g_f02(i),  -- Sprache'||unistr('\000a')||
'           apex_application.g_f03(i),  -- DB-Text'||unistr('\000a')||
'           apex_application.g_f04(i),  -- DB-Status'||unistr('\000a')||
'           apex_application';

p:=p||'.g_f05(i),  -- Eingabe-Text'||unistr('\000a')||
'           apex_application.g_f06(i),  -- Eingabe-Status'||unistr('\000a')||
'           apex_application.g_f07(i),'||unistr('\000a')||
'           to_char(i),:app_user);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      IF (apex_application.g_f03(i) != apex_application.g_f05(i) OR'||unistr('\000a')||
'          apex_application.g_f04(i) != apex_application.g_f06(i)'||unistr('\000a')||
'         ) AND  -- nur Texte mit Sprachen, für die Übersetzer eingetragen ist, speichern'||unistr('\000a')||
'         instr(v_g';

p:=p||'ueltige_sprachen,'';''||apex_application.g_f02(i)||'';'') > 0'||unistr('\000a')||
'      THEN  -- Änderungen durchgeführt => speichern'||unistr('\000a')||
'         -- Prüfen, ob zwischenzeitlich von anderen geändert wurde'||unistr('\000a')||
'         SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'         FROM uebersetzungen'||unistr('\000a')||
'         WHERE id = apex_application.g_f01(i);'||unistr('\000a')||
'         IF v_mutdat != apex_application.g_f07(i) THEN'||unistr('\000a')||
'            RAISE_APPL';

p:=p||'ICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P(''Text speichern ID %1 geändert,  anz: %2'','||unistr('\000a')||
'     v_prot_id,''Info'',''Text speichern'',apex_application.g_f01(i),to_char(i));'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            UPDATE uebersetzungen'||unistr('\000a')||
'            SET text       = apex_application.g_f05(i),'||unistr('\000a')||
'                tstatus_id = apex_application.g_f06(i),'||unistr('\000a')||
'                mut';

p:=p||'user    = :APP_USER'||unistr('\000a')||
'            WHERE id = apex_application.g_f01(i);'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(487,v_sprache_id);'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'         END;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   end loop;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8603723001097640 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 150,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>8556228426085057 + wwv_flow_api.g_id_offset,
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'SELECT id INTO :p150_personenstamm_id'||unistr('\000a')||
'FROM personenstamm'||unistr('\000a')||
'where UPPER(user_account) = UPPER(:app_user);';

wwv_flow_api.create_page_process(
  p_id     => 8639225367744765 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 150,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personenstamm_id',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'     v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'     v_anz number := 3;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p150_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p150_bl_verwerfen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   :p150_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :p150_bl_suchen := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P150_REGION_TITEL_texte := ';

p:=p||'frgbg_s.holen_uebersetzung(624,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   IF :p150_anz_texte IS NULL OR :p150_anz_texte = 0 THEN'||unistr('\000a')||
'      :p150_anz_texte := 5 ; -- Default'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :p150_anz_anzeigesprachen IS NULL OR :p150_anz_anzeigesprachen = 0 THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT count(*) into :p150_anz_anzeigesprachen'||unistr('\000a')||
'         from sprachen'||unistr('\000a')||
'         where id in (select sprache_id from uebersetzer'||unistr('\000a')||
'               ';

p:=p||'       where persstamm_id = :p150_personenstamm_id'||unistr('\000a')||
'                        and satzkennzeichen is null'||unistr('\000a')||
'                     );'||unistr('\000a')||
'      EXCEPTION '||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :p150_anz_anzeigesprachen = 0 OR :p150_anz_anzeigesprachen is null THEN'||unistr('\000a')||
'      :p150_anz_anzeigesprachen := 6; -- Default'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Bestimmen der Zeilenanzahl pro Seite für den Report;';

p:=p||' Es sollen immer max. 150 Sätze sein'||unistr('\000a')||
'   :p150_anz_zeilen := :p150_anz_anzeigesprachen * :p150_anz_texte;'||unistr('\000a')||
'   :p150_anz_zeilen := NVL(:p150_anz_zeilen,150);'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8618205433499425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 150,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'     v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'     v_anz number := 3;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p150_anz_anzeigesprachen IS NULL OR :p150_anz_anzeigesprachen = 0 THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT count(*) into :p150_anz_anzeigesprachen'||unistr('\000a')||
'         from sprachen'||unistr('\000a')||
'         where id in (select sprache_id from uebersetzer'||unistr('\000a')||
'                      where persstamm_id = :p150_personenstamm_id'||unistr('\000a')||
'                     ';

p:=p||'   and satzkennzeichen is null'||unistr('\000a')||
'                     );'||unistr('\000a')||
'      EXCEPTION '||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :p150_anz_anzeigesprachen = 0 OR :p150_anz_anzeigesprachen is null THEN'||unistr('\000a')||
'      :p150_anz_anzeigesprachen := 6; -- Default'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Bestimmen der Zeilenanzahl pro Seite für den Report; Es sollen immer max. 150 Sätze sein'||unistr('\000a')||
'   :p150_anz_zeilen := :p150_anz_an';

p:=p||'zeigesprachen * :p150_anz_texte;'||unistr('\000a')||
'   :p150_anz_zeilen := NVL(:p150_anz_zeilen,150);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8822315294846467 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 150,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'anzeigezeilen_bestimmen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
' -- Dadurch werden die Berichte nicht sofort aktualisiert, sondern erst nachdem die Seite geladen wurde. Es dauert sonst zulange bis die Seite geladen ist.'||unistr('\000a')||
' :P150_REPORT_REFRESH := null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6756504890603814 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 150,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze 	P150_REPORT_REFRESH zurück',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'   FRGBG_T.A102_P150_SETZTE_STANDARDS('||unistr('\000a')||
'        p_sprache_id_von => :P150_SPRACHE_ID_VON,'||unistr('\000a')||
'        p_sprache_id_nach => :P150_SPRACHE_ID_NACH,'||unistr('\000a')||
'        p_TSTATUS_IDS_ZIEL => :P150_TSTATUS_IDS_ZIEL,'||unistr('\000a')||
'        p_PERSONENSTAMM_ID => :P150_PERSONENSTAMM_ID'||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'   mel.p(''test sprache_id: '' || :P150_SPRACHE_ID_VON , v_prot_id,''TEST'',''PAGE 150'');'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6756030816582886 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 150,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Setzte Standardwerte',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 150
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00151
prompt  ...PAGE 151: Uebersetzungen-Singlerow
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 151
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Uebersetzungen-Singlerow'
 ,p_step_title => 'Uebersetzungen-Singlerow'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130313085608'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4265024973084598 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 151,
  p_plug_name=> '&P151_REGION_TITEL_TEXTE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4265221859084601 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 151,
  p_button_sequence=> 30,
  p_button_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P151_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P151_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4265402662084602 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 151,
  p_button_sequence=> 10,
  p_button_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P151_BL_VERWERFEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4265614446084605 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:150:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4265815348084607 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4266022526084619 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'TEXT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4266231596084621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select sprache, id'||unistr('\000a')||
'from sprachen',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4266420225084621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TEXT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 4000,
  p_cHeight=> 10,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4266614843084622 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_TSTATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TSTATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT beschreibung,id FROM textstatus',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4266816942084622 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_ERFDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfdat',
  p_source=>'ERFDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4267021379084622 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4267226979084622 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_MUTDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 65,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutdat',
  p_source=>'MUTDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4267418320084623 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 75,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4272603834615617 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4272810067617450 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_BL_VERWERFEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4273019764620300 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 151,
  p_name=>'P151_REGION_TITEL_TEXTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 105,
  p_item_plug_id => 4265024973084598+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:UEBERSETZUNGEN:P151_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 4267801224084625 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 151,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from UEBERSETZUNGEN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:UEBERSETZUNGEN:P151_ID:ID|U';

wwv_flow_api.create_page_process(
  p_id     => 4268014784084626 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 151,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of UEBERSETZUNGEN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_success_message=> 'Action Processed.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'151';

wwv_flow_api.create_page_process(
  p_id     => 4268202655084626 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 151,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p151_id := 50452;';

wwv_flow_api.create_page_process(
  p_id     => 4268520412124261 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 151,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_text_id',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'     v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'     v_anz number := 3;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p151_bl_verwerfen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   :p151_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P151_REGION_TITEL_texte := frgbg_s.holen_uebersetzung(624,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4273126690622231 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 151,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 151
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00152
prompt  ...PAGE 152: Übersetzung bearbeiten
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 152
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Übersetzung bearbeiten'
 ,p_step_title => 'Übersetzung bearbeiten'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Übersetzung bearbeiten'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<style> /*td { border:1px solid black; } */ </style>'
 ,p_javascript_code => 
'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141201163307'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6764020671244090 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 152,
  p_plug_name=> '&P152_REGION_TITEL_UEBERSETZUNG.',
  p_region_name=>'',
  p_region_attributes=> 'style="width:98%; margin:10 auto;"',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 31,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'EXISTS',
  p_plug_display_when_condition => 'select a.sprache_id'||unistr('\000a')||
'from app_sprachen a'||unistr('\000a')||
'where'||unistr('\000a')||
'  a.sprache_id not in (select u.sprache_id'||unistr('\000a')||
'      from uebersetzungen u'||unistr('\000a')||
'      where u.text_id = :P152_TEXT_ID'||unistr('\000a')||
'           and satz_kennzeichen is null'||unistr('\000a')||
'  )'||unistr('\000a')||
'  and length(sprachcode) = 2'||unistr('\000a')||
'union all'||unistr('\000a')||
'select 1 from dual where :P152_ID is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6768829533244115 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 152,
  p_plug_name=> 'Keine freie Sprache Verfügbar',
  p_region_name=>'',
  p_region_attributes=> 'style="width:98%; margin:10 auto;"',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2887429229489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 41,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'NOT_EXISTS',
  p_plug_display_when_condition => 'select a.sprache_id'||unistr('\000a')||
'from app_sprachen a'||unistr('\000a')||
'where'||unistr('\000a')||
'  a.sprache_id not in (select u.sprache_id'||unistr('\000a')||
'      from uebersetzungen u'||unistr('\000a')||
'      where u.text_id = :P152_TEXT_ID'||unistr('\000a')||
'           and satz_kennzeichen is null'||unistr('\000a')||
'  )'||unistr('\000a')||
'  and length(sprachcode) = 2'||unistr('\000a')||
'union all'||unistr('\000a')||
'select 1 from dual where :P152_ID is not null',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6764802704244101 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 152,
  p_button_sequence=> 20,
  p_button_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Abbrechen',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:parent.$(parent.document).apex_modal_page(''close'');',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6769021608244116 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 152,
  p_button_sequence=> 40,
  p_button_plug_id => 6768829533244115+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:parent.$(parent.document).apex_modal_page(''close'');',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6764628683244101 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 152,
  p_button_sequence=> 10,
  p_button_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstellen',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P152_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6765007324244101 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 152,
  p_button_sequence=> 30,
  p_button_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P152_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6764427711244100 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 152,
  p_button_sequence=> 60,
  p_button_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_NEXT_ID',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&gt;',
  p_button_position=> 'REGION_TEMPLATE_NEXT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'UPDATE',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6793811350984645 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 152,
  p_button_sequence=> 70,
  p_button_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_PREVIOUS_ID',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&gt;',
  p_button_position=> 'REGION_TEMPLATE_NEXT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6773725548244139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:152:&SESSION.::&DEBUG.::P152_ID:&P152_ID_NEXT.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6764427711244100+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>6773929230244139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:152:&SESSION.::&DEBUG.::P152_ID:&P152_ID_PREV.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7923123723469286+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>6773504577244137 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:152:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 40,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 19-NOV-2013 18:11 by SASCHA.LENZ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6765217125244104 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_ID_NEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1070,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P152_ID_NEXT',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6765407073244106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_ID_PREV',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1080,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P152_ID_PREV',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6765631871244106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_ID_COUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1090,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'class="fielddata"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6765803324244106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_TEXT_ID_DISPLAY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Text-ID',
  p_source=>'P152_TEXT_ID',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap" style="width:80px;"',
  p_tag_attributes  => 'style="width:50px; padding-left:5px;  font-weight:bold;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'P152_TEXT_ID',
  p_display_when_type=>'ITEM_IS_NOT_NULL',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6766024894244107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_EDITOR_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 4000,
  p_cHeight=> 15,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 10,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'select * from texte t, dokumenttypen dt '||unistr('\000a')||
'where'||unistr('\000a')||
'   t.dokumenttyp_id = dt.id'||unistr('\000a')||
'   and dt.editor_typ = ''TEXT'''||unistr('\000a')||
'   and t.id = :P152_TEXT_ID'||unistr('\000a')||
'   and t.satz_kennzeichen is null',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6766222538244108 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_EDITOR_HTML',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 2000,
  p_cHeight=> 10,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 10,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'select * from texte t, dokumenttypen dt '||unistr('\000a')||
'where'||unistr('\000a')||
'   t.dokumenttyp_id = dt.id'||unistr('\000a')||
'   and dt.editor_typ = ''HTML'''||unistr('\000a')||
'   and t.id = :P152_TEXT_ID'||unistr('\000a')||
'   and t.satz_kennzeichen is null',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_02 => 'Full',
  p_attribute_03 => 'Y',
  p_attribute_04 => 'office2003',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6766412905244108 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_EDITOR_FILE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 410,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_FILE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'select * from texte t, dokumenttypen dt '||unistr('\000a')||
'where'||unistr('\000a')||
'   t.dokumenttyp_id = dt.id'||unistr('\000a')||
'   and dt.editor_typ = ''FILE'''||unistr('\000a')||
'   and t.id = :P152_TEXT_ID'||unistr('\000a')||
'   and t.satz_kennzeichen is null',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'WWV_FLOW_FILES',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6766611792244109 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_DOWNLOAD_FILE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 420,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select ''<a href="javascript: apex.submit(''''DOWNLOAD_FILE'''');" >'' || FRGBG_S.HOLEN_UEBERSETZUNG(8026,:FAS_SPRACHE_ID) || ''</a>'' value from uebersetzungen where id = :P152_ID and satz_kennzeichen is null',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'select * from texte t, dokumenttypen dt '||unistr('\000a')||
'where'||unistr('\000a')||
'   t.dokumenttyp_id = dt.id'||unistr('\000a')||
'   and dt.editor_typ = ''FILE'''||unistr('\000a')||
'   and t.id = :P152_TEXT_ID'||unistr('\000a')||
'   and t.satz_kennzeichen is null',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6766827578244109 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprache',
  p_source=>'SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_cattributes_element=>'style="width:100px;"',
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6767010468244110 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6767224750244110 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1060,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6767420952244110 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_HINWEIS_MELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 430,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6767616395244111 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_TSTATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '20',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TSTATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT BESCHREIBUNG , id'||unistr('\000a')||
'FROM TEXTSTATUS'||unistr('\000a')||
'WHERE ID NOT IN(30)'||unistr('\000a')||
'order by id',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_cAttributes=> 'style="width:100px;"',
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6767807404244112 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_ID_DISPLAY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'ID',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'P152_ID',
  p_display_when_type=>'ITEM_IS_NOT_NULL',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6768010673244112 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_BASIS_EDITOR_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 4000,
  p_cHeight=> 15,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'readonly="readonly"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 10,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'select * from texte t, dokumenttypen dt '||unistr('\000a')||
'where'||unistr('\000a')||
'   t.dokumenttyp_id = dt.id'||unistr('\000a')||
'   and dt.editor_typ = ''TEXT'''||unistr('\000a')||
'   and t.id = :P152_TEXT_ID'||unistr('\000a')||
'   and t.satz_kennzeichen is null',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6768209267244113 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_BASIS_EDITOR_HTML',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'ALWAYS_NULL',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 2000,
  p_cHeight=> 10,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'readonly="readonly"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 12,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'select * from texte t, dokumenttypen dt '||unistr('\000a')||
'where'||unistr('\000a')||
'   t.dokumenttyp_id = dt.id'||unistr('\000a')||
'   and dt.editor_typ = ''HTML'''||unistr('\000a')||
'   and t.id = :P152_TEXT_ID'||unistr('\000a')||
'   and t.satz_kennzeichen is null',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_02 => 'Basic',
  p_attribute_03 => 'N',
  p_attribute_04 => 'office2003',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6768417062244113 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_BASIS_DOWNLOAD_FILE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 390,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'select ''<a href="f?p='' || :APP_ID || '':'' || :APP_PAGE_ID || '':'' || apex_custom_auth.get_session_id || '':DOWNLOAD_BASIS_FILE:NO:::"  target="_blank">Download</a>'' value '||unistr('\000a')||
'from uebersetzungen '||unistr('\000a')||
'where text_id = :P152_TEXT_ID '||unistr('\000a')||
'and sprache_id = FRGBG.UEBERSETZUNG.GET_ABS_BASIS_SPRACHE_ID '||unistr('\000a')||
'and BLOB_DAT IS NOT NULL'||unistr('\000a')||
'and satz_kennzeichen is null',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'select * from texte t, dokumenttypen dt, uebersetzungen u'||unistr('\000a')||
'where'||unistr('\000a')||
'   t.dokumenttyp_id = dt.id'||unistr('\000a')||
'   and dt.editor_typ = ''FILE'''||unistr('\000a')||
'   and t.id = :P152_TEXT_ID'||unistr('\000a')||
'   and t.satz_kennzeichen is null'||unistr('\000a')||
'   and u.text_id = :P152_TEXT_ID '||unistr('\000a')||
'   and u.sprache_id = FRGBG.UEBERSETZUNG.GET_ABS_BASIS_SPRACHE_ID '||unistr('\000a')||
'   and u.BLOB_DAT IS NOT NULL',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6768612166244113 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_DOKUMENTTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 270,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'select dt.beschreibung || '' ('' || doktyp || '')'''||unistr('\000a')||
' from dokumenttypen  dt, texte t '||unistr('\000a')||
' where t.id = :P152_TEXT_ID'||unistr('\000a')||
'       and t.dokumenttyp_id = dt.id',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6769215431244116 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_KEINE_FREIE_SPRACHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6768829533244115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'Für alle verfügbaren Sprachen wurde bereits eine Übersetzung angelegt. Sie können daher keine weitere Übersetzungen mehr anlegen.',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6782307808834371 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_SPRACHE_ID_VON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6784329793839309 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_SPRACHE_NACH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'select SPRACHE || '' ('' || ID || '')'' from SPRACHEN WHERE ID = :P152_SPRACHE_ID',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6787015762861020 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_SPRACHE_VON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'select SPRACHE || '' ('' || ID || '')'' from SPRACHEN WHERE ID = :P152_SPRACHE_ID_VON',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6792317845951304 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_BL_CREATE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1100,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6792513100953458 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_BL_CANCEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1110,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6792709003955370 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_BL_SAVE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1120,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6798025959312175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 152,
  p_name=>'P152_REGION_TITEL_UEBERSETZUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1130,
  p_item_plug_id => 6764020671244090+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6773013825244133 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_name => 'leere basis felder'
 ,p_event_sequence => 10
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'apexbeforepagesubmit'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6773302059244134 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_event_id => 6773013825244133 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '/* Löscht alle Basisfelder den Inhalt, damit es bei der Formularübertragung zu keinem Fehler kommt */'||unistr('\000a')||
'/* HTML Editoren */'||unistr('\000a')||
'if(window.CKEDITOR && window.CKEDITOR.instances) {'||unistr('\000a')||
'   var prefix = ''P'' + $v(''pFlowStepId'') + ''_BASIS_EDITOR'';'||unistr('\000a')||
'   prefix = prefix.toLowerCase();'||unistr('\000a')||
''||unistr('\000a')||
'   for(i in CKEDITOR.instances) {'||unistr('\000a')||
'      '||unistr('\000a')||
'      if(CKEDITOR.instances[i].name && CKEDITOR.instances[i].name.substr(0,prefix.length).toLowerCase() == prefix) {'||unistr('\000a')||
'          CKEDITOR.instances[i].setData('''');'||unistr('\000a')||
'      }'||unistr('\000a')||
'   }'||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'/* Text Editoren */'||unistr('\000a')||
'$(''textarea[id^="P'' + $v(''pFlowStepId'') + ''_BASIS_EDITOR"]'').each(function() { '||unistr('\000a')||
'   /*alert($(this).attr(''id'')); */'||unistr('\000a')||
'   $(this).val(''''); '||unistr('\000a')||
'});'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6772215312244132 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_name => 'Hole Basis CLOB HTML'
 ,p_event_sequence => 20
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$(''#P152_BASIS_EDITOR_HTML'').length > 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6772512223244132 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_event_id => 6772215312244132 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_ENKITEC_CLOB_LOAD'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P152_BASIS_EDITOR_HTML'
 ,p_attribute_01 => 'RENDER'
 ,p_attribute_02 => 'SQL_QUERY'
 ,p_attribute_04 => ''||unistr('\000a')||
'select'||unistr('\000a')||
'  case'||unistr('\000a')||
'    when u.TEXT is not null then'||unistr('\000a')||
'      to_clob(u.TEXT)'||unistr('\000a')||
'    when u.CLOB_DAT is not null then'||unistr('\000a')||
'      u.CLOB_DAT'||unistr('\000a')||
'    else'||unistr('\000a')||
'      to_clob('''')'||unistr('\000a')||
'    end text'||unistr('\000a')||
'from uebersetzungen u'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'   and text_id = :P152_TEXT_ID'||unistr('\000a')||
'   and sprache_id = FRGBG.UEBERSETZUNG.GET_ABS_BASIS_SPRACHE_ID'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6770601383244127 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_name => 'Hole CLOB HTML'
 ,p_event_sequence => 30
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$(''#P152_EDITOR_HTML'').length > 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6770926791244129 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_event_id => 6770601383244127 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_ENKITEC_CLOB_LOAD'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P152_EDITOR_HTML'
 ,p_attribute_01 => 'RENDER'
 ,p_attribute_02 => 'SQL_QUERY'
 ,p_attribute_04 => 'select'||unistr('\000a')||
'*'||unistr('\000a')||
'from('||unistr('\000a')||
'    select'||unistr('\000a')||
'      *'||unistr('\000a')||
'     from('||unistr('\000a')||
'        select FRGBG_T.TEMP_FELD_CLOB_GET(''CLOB_COLLECTION_UEB'') text from dual'||unistr('\000a')||
'        union all'||unistr('\000a')||
'        select'||unistr('\000a')||
'          case'||unistr('\000a')||
'            when u.TEXT is not null then to_clob(u.TEXT)'||unistr('\000a')||
'            when u.CLOB_DAT is not null then u.CLOB_DAT'||unistr('\000a')||
'            else to_clob('''')'||unistr('\000a')||
'            end text'||unistr('\000a')||
'        from uebersetzungen u'||unistr('\000a')||
'        where satz_kennzeichen is null'||unistr('\000a')||
'            and text_id = :P152_TEXT_ID'||unistr('\000a')||
'            and id = :P152_ID     '||unistr('\000a')||
'     )'||unistr('\000a')||
'     where text is not null'||unistr('\000a')||
')'||unistr('\000a')||
'where rownum <= 1'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6771815828244131 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_name => 'Save CLOB HTML'
 ,p_event_sequence => 40
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$(''#P'' + $v(''pFlowStepId'') + ''_EDITOR_HTML'').length > 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'apexbeforepagesubmit'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6772130448244132 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_event_id => 6771815828244131 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_ENKITEC_CLOB_LOAD'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P152_EDITOR_HTML'
 ,p_attribute_01 => 'SUBMIT'
 ,p_attribute_05 => 'CLOB_COLLECTION_UEB'
 ,p_attribute_06 => 'N'
 ,p_attribute_07 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6772601927244133 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_name => 'Load Basis CLOB TEXT'
 ,p_event_sequence => 50
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$(''#P152_BASIS_EDITOR_TEXT'').length > 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6772918111244133 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_event_id => 6772601927244133 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_ENKITEC_CLOB_LOAD'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P152_BASIS_EDITOR_TEXT'
 ,p_attribute_01 => 'RENDER'
 ,p_attribute_02 => 'SQL_QUERY'
 ,p_attribute_04 => 'select'||unistr('\000a')||
'  case'||unistr('\000a')||
'    when u.TEXT is not null then'||unistr('\000a')||
'      to_clob(u.TEXT)'||unistr('\000a')||
'    when u.CLOB_DAT is not null then'||unistr('\000a')||
'      u.CLOB_DAT'||unistr('\000a')||
'    else'||unistr('\000a')||
'      to_clob('''')'||unistr('\000a')||
'    end text'||unistr('\000a')||
'from uebersetzungen u'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'   and text_id = :P152_TEXT_ID'||unistr('\000a')||
'   and sprache_id = FRGBG.UEBERSETZUNG.GET_ABS_BASIS_SPRACHE_ID'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6771003519244130 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_name => 'Load CLOB TEXT'
 ,p_event_sequence => 80
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$(''#P152_EDITOR_TEXT'').length > 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6771326253244131 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_event_id => 6771003519244130 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_ENKITEC_CLOB_LOAD'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P152_EDITOR_TEXT'
 ,p_attribute_01 => 'RENDER'
 ,p_attribute_02 => 'SQL_QUERY'
 ,p_attribute_04 => 'select'||unistr('\000a')||
'  case'||unistr('\000a')||
'    when u.TEXT is not null then'||unistr('\000a')||
'      to_clob(u.TEXT)'||unistr('\000a')||
'    when u.CLOB_DAT is not null then'||unistr('\000a')||
'      u.CLOB_DAT'||unistr('\000a')||
'    else'||unistr('\000a')||
'      to_clob('''')'||unistr('\000a')||
'    end text'||unistr('\000a')||
'from uebersetzungen u'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'   and text_id = :P152_TEXT_ID'||unistr('\000a')||
'   and id = :P152_ID'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6771419248244131 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_name => 'Save CLOB TEXT'
 ,p_event_sequence => 90
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$(''#P'' + $v(''pFlowStepId'') + ''_EDITOR_TEXT'').length > 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'apexbeforepagesubmit'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6771726503244131 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 152
 ,p_event_id => 6771419248244131 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_ENKITEC_CLOB_LOAD'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P152_EDITOR_TEXT'
 ,p_attribute_01 => 'SUBMIT'
 ,p_attribute_05 => 'CLOB_COLLECTION_UEB'
 ,p_attribute_06 => 'N'
 ,p_attribute_07 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:UEBERSETZUNGEN:ID::SPRACHE_ID::P152_ID:P152_ID_NEXT:P152_ID_PREV::::P152_ID_COUNT:TEXT_ID = <cbchoesc>P152_TEXT_ID and SPRACHE_ID <> UEBERSETZUNG.GET_ABS_BASIS_SPRACHE_ID';

wwv_flow_api.create_page_process(
  p_id     => 6769820128244122 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 152,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'GET_NEXT_OR_PREV_PK',
  p_process_name=> 'Get Next or Previous Primary Key Value',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_clob CLOB;'||unistr('\000a')||
'   v_file BLOB;'||unistr('\000a')||
' v_dateiname wwv_flow_files.filename%type;'||unistr('\000a')||
'   v_text varchar2(4000);'||unistr('\000a')||
''||unistr('\000a')||
'   v_fehlermeldung varchar2(2000);'||unistr('\000a')||
'   v_fehlernummer  number;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'   v_editor_typ    varchar2(10);'||unistr('\000a')||
'   v_datei_typ     varchar2(10);'||unistr('\000a')||
'   v_dateiendung   varchar2(10);'||unistr('\000a')||
''||unistr('\000a')||
'   e_ERROR EXCEPTION;'||unistr('\000a')||
'   PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'   -- Hole den Editor typen fü';

p:=p||'r den Dokumententyp'||unistr('\000a')||
'   select dt.editor_typ, lower(dt.doktyp) '||unistr('\000a')||
'   into v_editor_typ, v_datei_typ '||unistr('\000a')||
'   from dokumenttypen dt, texte t where '||unistr('\000a')||
'        dt.id = t.dokumenttyp_id'||unistr('\000a')||
'        and t.id = :P152_TEXT_ID;'||unistr('\000a')||
''||unistr('\000a')||
'   if(v_editor_typ = ''FILE'') then'||unistr('\000a')||
'   '||unistr('\000a')||
'      if(:P152_EDITOR_FILE is null) then'||unistr('\000a')||
'        v_fehlermeldung := ''Es wurde keine Datei zum hochladen ausgewählt'';'||unistr('\000a')||
'        v_fehlernummer := 10;'||unistr('\000a')||
'        ';

p:=p||'raise e_ERROR;'||unistr('\000a')||
'      end if;'||unistr('\000a')||
''||unistr('\000a')||
'     begin'||unistr('\000a')||
'      select'||unistr('\000a')||
'        blob_content,'||unistr('\000a')||
'        filename '||unistr('\000a')||
'      into v_file, v_dateiname'||unistr('\000a')||
'      from wwv_flow_files '||unistr('\000a')||
'      where name = :P152_EDITOR_FILE;'||unistr('\000a')||
'     exception'||unistr('\000a')||
'       when no_data_found then'||unistr('\000a')||
'          v_fehlermeldung := ''Datei wurde nicht korrekt hochgeladen'';'||unistr('\000a')||
'          v_fehlernummer := 20;'||unistr('\000a')||
'          raise e_ERROR;'||unistr('\000a')||
'     end;'||unistr('\000a')||
'     v_dateiendung := lower';

p:=p||'(substr(v_dateiname, -1 * length(v_datei_typ)));'||unistr('\000a')||
'     if(v_dateiendung <> v_datei_typ) then'||unistr('\000a')||
'          v_fehlermeldung := ''Dateiendung stimmt nicht mit dem Dokumententyp überein.'';'||unistr('\000a')||
'          v_fehlernummer := 25;'||unistr('\000a')||
'          raise e_ERROR;'||unistr('\000a')||
'     end if;'||unistr('\000a')||
''||unistr('\000a')||
'  else -- Ist jetzt HTML oder Text'||unistr('\000a')||
'   '||unistr('\000a')||
'     -- Der Hochladevorgang des korrekten Feldes wurde schon vom CLOB Plugin übernommen'||unistr('\000a')||
'     begin'||unistr('\000a')||
'      SELEC';

p:=p||'T clob001'||unistr('\000a')||
'      INTO v_clob'||unistr('\000a')||
'      FROM apex_collections'||unistr('\000a')||
'     WHERE collection_name = ''CLOB_COLLECTION_UEB'';'||unistr('\000a')||
'     exception '||unistr('\000a')||
'       when no_data_found then'||unistr('\000a')||
'          v_fehlermeldung := ''Konnte Clob nicht aus apex collection holen'';'||unistr('\000a')||
'          v_fehlernummer := 30;'||unistr('\000a')||
'          raise e_ERROR;'||unistr('\000a')||
'       when others then'||unistr('\000a')||
'          v_fehlermeldung := ''Unbekannter Fehler beim Holen des Clobs aus apex collectio';

p:=p||'n.'';'||unistr('\000a')||
'          v_fehlernummer := 50;'||unistr('\000a')||
'          raise e_ERROR;'||unistr('\000a')||
'     end;'||unistr('\000a')||
''||unistr('\000a')||
'     FRGBG_T.TEMP_FELD_CLOB_SPEICHERN('||unistr('\000a')||
'        p_collection_name =>  ''CLOB_COLLECTION_UEB'','||unistr('\000a')||
'        p_inhalt => v_clob'||unistr('\000a')||
'     );'||unistr('\000a')||
''||unistr('\000a')||
'     if(v_clob is null or dbms_lob.getlength(v_clob) = 0) then'||unistr('\000a')||
'       v_fehlermeldung := ''Es wurde kein Text/HTML eingegeben für die Übersetzung'';'||unistr('\000a')||
'       v_fehlernummer := 60; '||unistr('\000a')||
'       raise e_ERROR;'||unistr('\000a')||
'';

p:=p||'     end if;'||unistr('\000a')||
'  end if;'||unistr('\000a')||
''||unistr('\000a')||
'   :P152_ID := FRGBG.UEBERSETZUNG.CREATE_UEBERSETZUNG('||unistr('\000a')||
'        p_text_id      => :P152_TEXT_ID,'||unistr('\000a')||
'        p_sprache_id   => :P152_SPRACHE_ID,'||unistr('\000a')||
'        p_TSTATUS_ID   => :P152_TSTATUS_ID,'||unistr('\000a')||
'        p_TEXT         => v_clob,'||unistr('\000a')||
'        p_BLOB_DAT     => v_file'||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'    apex_application.g_print_success_message := trim(apex_application.g_print_success_message '||unistr('\000a')||
'          || '' '' || FR';

p:=p||'GBG_S.HOLEN_UEBERSETZUNG(11577,:FAS_SPRACHE_ID));'||unistr('\000a')||
''||unistr('\000a')||
'    FRGBG_T.TEMP_FELD_CLOB_LOESCHEN('||unistr('\000a')||
'        p_collection_name => ''CLOB_COLLECTION_UEB'''||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'exception'||unistr('\000a')||
'   when e_ERROR then'||unistr('\000a')||
'      MEL.P (v_fehlermeldung || '' [app:118;page:144;Übersetzung erstellen;pos'' '||unistr('\000a')||
'           || v_fehlernummer || '']'', v_PROT_ID, ''ERROR'', dbms_utility.format_error_backtrace);'||unistr('\000a')||
'      raise_application_error(-20000,v_fehlerme';

p:=p||'ldung); '||unistr('\000a')||
'   when others then '||unistr('\000a')||
'      MEL.P (''Unbekannter Fehler aufgetreten: '' || sqlerrm '||unistr('\000a')||
'          || '' [app:118;page:144;Übersetzung erstellen;pos 999]'', v_PROT_ID, ''ERROR'', dbms_utility.format_error_backtrace);'||unistr('\000a')||
'      raise_application_error(-20000,''Unbekannter Fehler aufgetreten: '' || sqlerrm); '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6769414905244118 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 152,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Übersetzung erstellen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request in (''CREATE'') and :P152_ID is null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_clob CLOB;'||unistr('\000a')||
'   v_file BLOB;'||unistr('\000a')||
'   v_dateiname wwv_flow_files.filename%type;'||unistr('\000a')||
'   v_text varchar2(4000);'||unistr('\000a')||
''||unistr('\000a')||
'   v_fehlermeldung varchar2(2000);'||unistr('\000a')||
'   v_fehlernummer  number;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'   v_editor_typ    varchar2(10);'||unistr('\000a')||
'   v_datei_typ     varchar2(10);'||unistr('\000a')||
''||unistr('\000a')||
'   e_ERROR EXCEPTION;'||unistr('\000a')||
'   PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'   -- Hole den Editor typen für den Dokumententyp'||unistr('\000a')||
'   select d';

p:=p||'t.editor_typ, lower(dt.doktyp) '||unistr('\000a')||
'   into v_editor_typ, v_datei_typ '||unistr('\000a')||
'   from dokumenttypen dt, texte t where '||unistr('\000a')||
'        dt.id = t.dokumenttyp_id'||unistr('\000a')||
'        and t.id = :P152_TEXT_ID;'||unistr('\000a')||
''||unistr('\000a')||
'   if(v_editor_typ = ''FILE'') then'||unistr('\000a')||
'   '||unistr('\000a')||
'      if(:P152_EDITOR_FILE is not null) then'||unistr('\000a')||
'        '||unistr('\000a')||
'       begin'||unistr('\000a')||
'         select'||unistr('\000a')||
'           blob_content,'||unistr('\000a')||
'           filename '||unistr('\000a')||
'         into v_file, v_dateiname'||unistr('\000a')||
'         from wwv_flow_';

p:=p||'files '||unistr('\000a')||
'         where name = :P152_EDITOR_FILE;'||unistr('\000a')||
'       exception'||unistr('\000a')||
'         when no_data_found then'||unistr('\000a')||
'            v_fehlermeldung := ''Datei wurde nicht korrekt hochgeladen'';'||unistr('\000a')||
'            v_fehlernummer := 20;'||unistr('\000a')||
'            raise e_ERROR;'||unistr('\000a')||
'       end;'||unistr('\000a')||
''||unistr('\000a')||
'       if(lower(substr(v_dateiname, -1 * length(v_datei_typ))) <> v_datei_typ) then'||unistr('\000a')||
'          v_fehlermeldung := ''Dateiendung stimmt nicht mit dem Dokumente';

p:=p||'ntyp überein.'';'||unistr('\000a')||
'          v_fehlernummer := 25;'||unistr('\000a')||
'          raise e_ERROR;'||unistr('\000a')||
'       end if;'||unistr('\000a')||
'     end if;'||unistr('\000a')||
''||unistr('\000a')||
'  else -- Ist jetzt HTML oder Text'||unistr('\000a')||
'   '||unistr('\000a')||
'     -- Der Hochladevorgang des korrekten Feldes wurde schon vom CLOB Plugin übernommen'||unistr('\000a')||
'     begin'||unistr('\000a')||
'      SELECT clob001'||unistr('\000a')||
'      INTO v_clob'||unistr('\000a')||
'      FROM apex_collections'||unistr('\000a')||
'     WHERE collection_name = ''CLOB_COLLECTION_UEB'';'||unistr('\000a')||
'     exception '||unistr('\000a')||
'       when no_data_found';

p:=p||' then'||unistr('\000a')||
'          v_fehlermeldung := ''Konnte Clob nicht aus apex collection holen'';'||unistr('\000a')||
'          v_fehlernummer := 30;'||unistr('\000a')||
'          raise e_ERROR;'||unistr('\000a')||
'       when others then'||unistr('\000a')||
'          v_fehlermeldung := ''Unbekannter Fehler beim Holen des Clobs aus apex collection.'';'||unistr('\000a')||
'          v_fehlernummer := 50;'||unistr('\000a')||
'          raise e_ERROR;'||unistr('\000a')||
'     end;'||unistr('\000a')||
''||unistr('\000a')||
'     FRGBG_T.TEMP_FELD_CLOB_SPEICHERN('||unistr('\000a')||
'        p_collection_name =>  ''CLOB_C';

p:=p||'OLLECTION_UEB'','||unistr('\000a')||
'        p_inhalt => v_clob'||unistr('\000a')||
'     );'||unistr('\000a')||
''||unistr('\000a')||
'     if(v_clob is null or dbms_lob.getlength(v_clob) = 0) then'||unistr('\000a')||
'       v_fehlermeldung := ''Es wurde kein Text/HTML eingegeben für die Übersetzung'';'||unistr('\000a')||
'       v_fehlernummer := 60; '||unistr('\000a')||
'       raise e_ERROR;'||unistr('\000a')||
'     end if;'||unistr('\000a')||
'  end if;'||unistr('\000a')||
''||unistr('\000a')||
'    -- aktualisiere Übersetzung'||unistr('\000a')||
'    FRGBG.UEBERSETZUNG.UPDATE_UEBERSETZUNG('||unistr('\000a')||
'        p_id    => :P152_ID,'||unistr('\000a')||
'        p_TSTATUS_ID';

p:=p||'       => :P152_TSTATUS_ID,'||unistr('\000a')||
'        p_TEXT       => v_CLOB,'||unistr('\000a')||
'        p_BLOB_DAT   => v_FILE'||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'    apex_application.g_print_success_message := trim(apex_application.g_print_success_message '||unistr('\000a')||
'          || '' '' || FRGBG_S.HOLEN_UEBERSETZUNG(11578,:FAS_SPRACHE_ID));'||unistr('\000a')||
''||unistr('\000a')||
'    FRGBG_T.TEMP_FELD_CLOB_LOESCHEN('||unistr('\000a')||
'        p_collection_name => ''CLOB_COLLECTION_UEB'''||unistr('\000a')||
'    );'||unistr('\000a')||
'exception'||unistr('\000a')||
'   when e_ERROR then'||unistr('\000a')||
'      M';

p:=p||'EL.P (v_fehlermeldung || '' [app:118;page:144;Update Uebersetzung;pos'' || v_fehlernummer || '']'', v_PROT_ID, ''ERROR'', dbms_utility.format_error_backtrace);'||unistr('\000a')||
'      raise_application_error(-20000,v_fehlermeldung); '||unistr('\000a')||
'   when others then '||unistr('\000a')||
'      MEL.P (''Unbekannter Fehler aufgetreten: '' || sqlerrm || '' [app:118;page:144;Update Uebersetzung;pos 999]'', v_PROT_ID, ''ERROR'', dbms_utility.format_error_backtrace)';

p:=p||';'||unistr('\000a')||
'      raise_application_error(-20000,''Unbekannter Fehler aufgetreten: '' || sqlerrm); '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6770230258244123 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 152,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Update Uebersetzung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'(:request in (''SAVE'')'||unistr('\000a')||
'or :request like ''GET_NEXT%'' or :request like ''GET_PREV%'')'||unistr('\000a')||
'and :P152_ID is not null'||unistr('\000a')||
''||unistr('\000a')||
'',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '	',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_blob blob;'||unistr('\000a')||
'   v_dateiname varchar2(100);'||unistr('\000a')||
'   v_size number;'||unistr('\000a')||
'   v_lastchange date;'||unistr('\000a')||
'   v_id number;'||unistr('\000a')||
'   v_mimetype varchar2(100);'||unistr('\000a')||
'begin'||unistr('\000a')||
' '||unistr('\000a')||
'   -- Hole Blob content'||unistr('\000a')||
'   begin'||unistr('\000a')||
'      select blob_dat,'||unistr('\000a')||
'          dbms_lob.getlength(u.blob_dat),'||unistr('\000a')||
'          u.mutdat,'||unistr('\000a')||
'          u.id,'||unistr('\000a')||
'          -- Erstelle ein Dateiname'||unistr('\000a')||
'          to_char(t.id) || ''_'' || to_char(s.id)'||unistr('\000a')||
'            || ''_'' || regexp_replac';

p:=p||'e(lower(to_Char(NVL(s.ISO2_ID,s.ISO3_ID))),''[^a-z0-9_-]'',''_'')'||unistr('\000a')||
'            || ''.'' || DOKTYP,'||unistr('\000a')||
'           dt.mimetype'||unistr('\000a')||
'     into v_blob,'||unistr('\000a')||
'        v_size,'||unistr('\000a')||
'        v_lastchange,'||unistr('\000a')||
'        v_id,'||unistr('\000a')||
'        v_dateiname,'||unistr('\000a')||
'        v_mimetype    '||unistr('\000a')||
'     from uebersetzungen u, TEXTE t, PIS.DOKUMENTTYPEN dt, sprachen s'||unistr('\000a')||
'     where text_id = :P152_TEXT_ID'||unistr('\000a')||
'         and (:request = ''DOWNLOAD_FILE'' and u.id = :P152_ID'||unistr('\000a')||
'     ';

p:=p||'         or :request = ''DOWNLOAD_BASIS_FILE'''||unistr('\000a')||
'                  and u.id = FRGBG.UEBERSETZUNG.GET_UEBERSETZUNG_ID('||unistr('\000a')||
'                      :P152_TEXT_ID,FRGBG.UEBERSETZUNG.GET_ABS_BASIS_SPRACHE_ID'||unistr('\000a')||
'                  )'||unistr('\000a')||
'         )'||unistr('\000a')||
'         and t.ID = :P152_TEXT_ID'||unistr('\000a')||
'         and t.DOKUMENTTYP_ID = dt.ID'||unistr('\000a')||
'         and s.ID = u.SPRACHE_ID'||unistr('\000a')||
'         and u.satz_kennzeichen is null;'||unistr('\000a')||
'    exception'||unistr('\000a')||
'       when no_';

p:=p||'data_found then'||unistr('\000a')||
'         raise_application_error(-20000,''Konnte keine passende Download-Datei finden.'');'||unistr('\000a')||
'    end;'||unistr('\000a')||
''||unistr('\000a')||
'  -- Im HTTP-Header wird der Dateityp gesetzt. Damit erkennt der Browser'||unistr('\000a')||
'  -- welche Applikation (bspw. MS Word) zu starten ist'||unistr('\000a')||
'  owa_util.mime_header(NVL(v_mimetype,''application/octet''),false);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Die Dateigröße wird dem Browser ebenfalls mitgeteilt'||unistr('\000a')||
'  htp.p(''Content-length:''|| v_s';

p:=p||'ize);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Das Datum (LETZTE_AENDERUNG) wird ebenfalls als HTTP-Header gesetzt'||unistr('\000a')||
'  htp.p(''Date:''||to_char(v_lastchange,''Dy, DD Mon RRRR hh24:mi:ss'')||'' CET'');'||unistr('\000a')||
''||unistr('\000a')||
'  -- Der Parameter p_display steuert, ob die Datei direkt dargestellt oder'||unistr('\000a')||
'  -- ob dem Anwender ein Download-Dialog angeboten werden soll. Wie man sehen'||unistr('\000a')||
'  -- kann, richtet sich der Browser nach den Feldern im HTTP Header.'||unistr('\000a')||
'  htp.p(''Content-Di';

p:=p||'sposition: attachment; filename=''||v_dateiname);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Der Browser soll die Datei unter keinen Umständen aus dem Cache holen.'||unistr('\000a')||
'  htp.p(''Cache-Control: must-revalidate, max-age=0'');'||unistr('\000a')||
'  htp.p(''Expires: Thu, 01 Jan 1970 01:00:00 CET'');'||unistr('\000a')||
''||unistr('\000a')||
'  -- Die Datei bekommt eine ID - damit kann der Browser sie eindeutig erkennen.'||unistr('\000a')||
'  htp.p(''Etag: TAB_DATEIEN...''||v_id||''...''||to_char(v_lastchange, ''JHH24MISS''));'||unistr('\000a')||
''||unistr('\000a')||
'  -- ';

p:=p||'Alle HTTP-Header-Felder sind gesetzt'||unistr('\000a')||
'  owa_util.http_header_close;'||unistr('\000a')||
''||unistr('\000a')||
'  -- Dieser kurze Aufruf führt den eigentlichen Datei-Download durch.'||unistr('\000a')||
'  wpg_docload.download_file(v_blob);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Damit Apex nicht die Oberfläche darstellt'||unistr('\000a')||
'  apex_application.g_unrecoverable_error := true;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6770425312244126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 152,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Download Datei',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''DOWNLOAD_FILE'',''DOWNLOAD_BASIS_FILE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:UEBERSETZUNGEN:P152_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 6770018283244122 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 152,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Automated Row Fetch UEBERSETZUNGEN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'P152_ID',
  p_process_when_type=>'ITEM_IS_NOT_NULL',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_runtime_where_clause=>'TEXT_ID = :P152_TEXT_ID and SPRACHE_ID <> UEBERSETZUNG.GET_ABS_BASIS_SPRACHE_ID',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  v_sprache_id number := :FAS_SPRACHE_ID;'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'  :P152_BL_CREATE := FRGBG_S.HOLEN_UEBERSETZUNG(163,v_sprache_id);'||unistr('\000a')||
'  :P152_BL_SAVE := FRGBG_S.HOLEN_UEBERSETZUNG(172,v_sprache_id);'||unistr('\000a')||
'  :P152_BL_CANCEL := FRGBG_S.HOLEN_UEBERSETZUNG(161,v_sprache_id);'||unistr('\000a')||
'  :P152_REGION_TITEL_UEBERSETZUNG := FRGBG_S.HOLEN_UEBERSETZUNG(11574,v_sprache_id);'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6792009643948748 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 152,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Setzte Labels',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
' '||unistr('\000a')||
''||unistr('\000a')||
'   FRGBG_T.TEMP_FELD_CLOB_LOESCHEN('||unistr('\000a')||
'      p_collection_name => ''CLOB_COLLECTION_UEB'''||unistr('\000a')||
'   );'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7696322360669758 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 152,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Clear Temp CLOB',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'CLEAR_CLOB',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  v_text_editor_typ varchar2(10);'||unistr('\000a')||
'  v_maxsize number;'||unistr('\000a')||
'  v_org_text_length number;'||unistr('\000a')||
'  v_text_length number;'||unistr('\000a')||
'  v_anteil_max_size number;'||unistr('\000a')||
'begin'||unistr('\000a')||
'  :P152_HINWEIS_MELDUNG := '''';'||unistr('\000a')||
''||unistr('\000a')||
'  if(:P152_ID is null) then'||unistr('\000a')||
'     return;'||unistr('\000a')||
'  end if;'||unistr('\000a')||
''||unistr('\000a')||
'  v_text_editor_typ := frgbg.uebersetzung.get_text_editor_typ(:P152_TEXT_ID);'||unistr('\000a')||
'  '||unistr('\000a')||
'  if(v_text_editor_typ in (''TEXT'',''HTML'')) then'||unistr('\000a')||
'    -- Hole die definierte Maximal Läng';

p:=p||'e'||unistr('\000a')||
'    begin'||unistr('\000a')||
'      select'||unistr('\000a')||
'        MAXSIZE into v_maxsize'||unistr('\000a')||
'      from texte where ID = :P152_TEXT_ID;'||unistr('\000a')||
'    exception'||unistr('\000a')||
'      when no_data_found then'||unistr('\000a')||
'         v_maxsize := null;'||unistr('\000a')||
'    end;'||unistr('\000a')||
'    '||unistr('\000a')||
'    if(v_maxsize is null ) then'||unistr('\000a')||
''||unistr('\000a')||
'       -- Hole die Textlänge der Basis-Übersetzung'||unistr('\000a')||
'      begin '||unistr('\000a')||
'        select '||unistr('\000a')||
'          case when TEXT is null then'||unistr('\000a')||
'             NVL(DBMS_LOB.GETLENGTH(CLOB_DAT),0)'||unistr('\000a')||
'          else'||unistr('\000a')||
'';

p:=p||'             NVL(length(TEXT),0)'||unistr('\000a')||
'        end'||unistr('\000a')||
'        into v_maxsize'||unistr('\000a')||
'        from uebersetzungen '||unistr('\000a')||
'        where text_id = :P152_TEXT_ID'||unistr('\000a')||
'            and sprache_id = FRGBG.UEBERSETZUNG.GET_ABS_BASIS_SPRACHE_ID;'||unistr('\000a')||
''||unistr('\000a')||
'      exception'||unistr('\000a')||
'        when no_data_found then'||unistr('\000a')||
'          v_maxsize := null;'||unistr('\000a')||
'      end;'||unistr('\000a')||
''||unistr('\000a')||
'      if(v_maxsize is null) then'||unistr('\000a')||
'        return; -- Keine Prüfung möglich, da der orginaltext nicht v';

p:=p||'orhanden ist.'||unistr('\000a')||
'      end if;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Hole den Prozentsatz um den die Übersetzung größer sein darf'||unistr('\000a')||
'      begin'||unistr('\000a')||
'        select NVL(to_number(parameter,''990.09''),0.3) into v_anteil_max_size from sysareas_frgbg where id = 38;'||unistr('\000a')||
'      exception'||unistr('\000a')||
'        when no_data_found then'||unistr('\000a')||
'           v_anteil_max_size := 0.3;'||unistr('\000a')||
'      end;'||unistr('\000a')||
''||unistr('\000a')||
'      v_maxsize := v_maxsize * (1 +  v_anteil_max_size);'||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    '||unistr('\000a')||
'    -';

p:=p||'- Hole die Textlänge der Übersetzung'||unistr('\000a')||
'    begin '||unistr('\000a')||
'      select '||unistr('\000a')||
'        case when TEXT is null then'||unistr('\000a')||
'           NVL(DBMS_LOB.GETLENGTH(CLOB_DAT),0)'||unistr('\000a')||
'        else'||unistr('\000a')||
'           NVL(length(TEXT),0)'||unistr('\000a')||
'        end'||unistr('\000a')||
'      into v_text_length'||unistr('\000a')||
'      from uebersetzungen '||unistr('\000a')||
'      where id = :P152_ID;'||unistr('\000a')||
'    exception'||unistr('\000a')||
'      when no_data_found then'||unistr('\000a')||
'        v_text_length := 0;'||unistr('\000a')||
'    end;'||unistr('\000a')||
''||unistr('\000a')||
'    if(v_text_length > v_maxsize) then';

p:=p||''||unistr('\000a')||
'        if(v_anteil_max_size is not null) then'||unistr('\000a')||
'          --Hinweis: Die Übersetzung ist länger als für den Text zugelassen ist. Maximale Prozent'||unistr('\000a')||
'          apex_application.g_notification := frgbg_s.holen_uebersetzung(9010,:APP_SPRACHE_ID,trim(to_char(v_anteil_max_size*100,''999'')));'||unistr('\000a')||
'        else'||unistr('\000a')||
'          --Hinweis: Die Übersetzung ist länger als für den Text zugelassen ist. Maximale Zeichen'||unistr('\000a')||
'     ';

p:=p||'     apex_application.g_notification := frgbg_s.holen_uebersetzung(9009,:APP_SPRACHE_ID,to_char(v_maxsize));'||unistr('\000a')||
''||unistr('\000a')||
'        end if;'||unistr('\000a')||
'        :P152_HINWEIS_MELDUNG := apex_application.g_notification;'||unistr('\000a')||
'    end if;'||unistr('\000a')||
''||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6769619613244121 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 152,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Setze Hinweismeldung für MAXSIZE',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'P152_ID',
  p_process_when_type=>'',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 152
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00201
prompt  ...PAGE 201: PERSONENSTAMM_REZEPT
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 201
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'PERSONENSTAMM_REZEPT'
 ,p_step_title => 'Personenstamm'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Personenstamm'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140818100608'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3169510591777535 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 201,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5497101072328721 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 201,
  p_plug_name=> '&P201_REGION_TITEL_ADRESSE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 5,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow: auto; height: &FAS_SCROLLREGION_HEIGHT_MAX.px;">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5653504476395504 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 201,
  p_plug_name=> '&P201_REGION_TITEL_REZEPT_KOPF.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 30,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5653728141395504 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 201,
  p_button_sequence=> 90,
  p_button_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE_REZEPT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P201_MN_REZEPT_ID IS NOT NULL AND :P201_AKT_VERSION = 1 AND :p201_bearb_modus = ''BEARBEITEN'' AND '||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 3955731895656726 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 201,
  p_button_sequence=> 10,
  p_button_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_button_name    => 'UNGUELTIG',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_REZEPT_UNGUELTIG.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(''&P201_SICHERHEITSABFRAGE.'',''UNGUELTIG'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P201_MN_REZEPT_ID IS NOT NULL AND :P201_AKT_VERSION = 1 AND :p201_bearb_modus = ''BEARBEITEN'' AND'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5497515426328725 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 201,
  p_button_sequence=> 10,
  p_button_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_condition=> ':FAS_AUFGERUFEN_VON != ''PIS''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5653807211395504 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 201,
  p_button_sequence=> 20,
  p_button_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_button_name    => 'LOESCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_VERSION_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P201_MN_REZEPT_ID IS NOT NULL AND :P201_AKT_VERSION = 1 AND :p201_bearb_modus = ''BEARBEITEN'' AND'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8423710195618510 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 201,
  p_button_sequence=> 40,
  p_button_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_button_name    => 'KOPIEREN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_KOPIEREN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von=''BETREUER''/*Betreuer-LOGIN:Patientenliste*/ '||unistr('\000a')||
'/*and :p201_mnr_aenderbar = ''J''  NEI 25.11.08*/'||unistr('\000a')||
'and -- MNR-Vorschriften können nicht kopiert werden'||unistr('\000a')||
':p201_mnr_vorschrift = 0 AND'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7353500927277738 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 201,
  p_button_sequence=> 45,
  p_button_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_button_name    => 'MISCHUNG_AUFTEILEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_SPLITTEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P201_MN_REZART_ID = 0 and  -- Gesamtrezept'||unistr('\000a')||
':P201_MN_SPLIT_FLAG=0  and  -- ohne Split'||unistr('\000a')||
':P201_MN_REZEPT_ID IS NOT NULL AND :P201_AKT_VERSION = 1 AND :p201_bearb_modus = ''BEARBEITEN'' AND'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10821915703383709 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 201,
  p_button_sequence=> 50,
  p_button_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_button_name    => 'REZEPT_DETAILS',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_REZEPTDETAILS.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8424018295618523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:131:&SESSION.::&DEBUG.::P131_MN_REZEPT_ID:&P201_MN_REZEPT_ID.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8423710195618510+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>10822218471383721 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:202:&SESSION.::&DEBUG.:202::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>10821915703383709+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>5521931951328771 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:201,202::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 20,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':fas_aufgerufen_von != ''PIS'' AND :request in (''CANCEL'',''UNGUELTIG'',''LOESCHEN'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>5629827218167964 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1341024122533429 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_MNR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 559,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'P201_REGION_TITEL_MNR',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1481512430680421 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_MNR_NEUBERECHNEN_SORTI',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1032,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mnr neuberechnen sortiment',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2060104186647875 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_VERORDNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 557,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Verordnung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2060325657654095 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_VERORDNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 511,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Verordnung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2894431768795879 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_HCK_PREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 961,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'  "SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3694527791267385 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_REICHWEITE_BMI',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 539,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'P201_BL_REICHWEITE_BMI',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3918905720771195 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_GESAMTGEWICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 940,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3919119572775215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_GESAMTVOLUMEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 950,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3919328922777917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 960,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3919510006781887 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_TAGESMENGE_G',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 970,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3919719703784731 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_TAGESMENGE_KAPS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 980,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'NVL(:fas_modus_id,0) != 2 /* 2= Eovital-Modus */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3921222576268065 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REICHWEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 990,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3931021404658687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_SATZ_KENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1000,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satz Kennzeichen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3937410581492879 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_VERRECHNUNGSLAND',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 57,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 8 /* Verrechnungsland */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN */'||unistr('\000a')||
'  and ot.art = 1       /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'  and (select count(*)'||unistr('\000a')||
'       from pers_optionen po1'||unistr('\000a')||
'       where po1.persstamm_id = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'         and po1.opttyp_id = 8'||unistr('\000a')||
'       )> 0   /* Subsetdefinitionen vorhanden */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 8 /* Verrechnungsland */'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN */'||unistr('\000a')||
'  and (ot.art = 0       /* DEFAULTwertverwaltung */'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       (ot.art = 1 and  /* Subset */'||unistr('\000a')||
'         (select count(*)'||unistr('\000a')||
'          from pers_optionen po1'||unistr('\000a')||
'          where po1.persstamm_id = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'            and po1.opttyp_id = 8'||unistr('\000a')||
'         )=0   /* Subsetdefinitionen nicht vorhanden */'||unistr('\000a')||
'        )'||unistr('\000a')||
'       )'||unistr('\000a')||
'order by 1'||unistr('\000a')||
'/*order by sortierung*/',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von =''BETREUER'' and'||unistr('\000a')||
'1= 2 /* NEI 08.02.2012 neue Verrechnungslandermittlung Flag nicht mehr anzeigen*/',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '2',
  p_attribute_02 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3956513746916446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_VERSION_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 542,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4229313345275728 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_MNR_AENDERBAR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1010,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mnr Aenderbar',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4246222387812151 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_SICHERHEITSABFRAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1020,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sicherheitsabfrage',
  p_source=>'frgbg_s.holen_uebersetzung(2195,:fas_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4397804748748884 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_GRENZWERTHINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 11,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select frgbg_s.holen_uebersetzung(hinweis_text_id,:fas_sprache_id)'||unistr('\000a')||
'from inh_grenzwerttypen'||unistr('\000a')||
'where id = rezepte.get_mnr_gwtyp_id(:P201_mn_rezept_id,1);',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_tag_attributes  => 'style="font-weight: bold; color: orange; font-size: 150%;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4542428835624828 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_DRUCKEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 538,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Drucken',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4771032493245146 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_ZUSATZBEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 46,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zusatzbemerkung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 4000,
  p_cHeight=> 5,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4808025593724959 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_MNR_VORSCHRIFT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 42,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mnr Vorschrift',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4808411703768293 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_MNR_VORSCHRIFT_J_N',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 43,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'IF :p201_mnr_vorschrift = 1 THEN'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(76,:fas_sprache_id));'||unistr('\000a')||
'ELSE'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(77,:fas_sprache_id));'||unistr('\000a')||
'END IF;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5476814332257995 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_MNR_NEUBERECHNEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1030,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mnr neuberechnen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5499516063328729 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_REZEPT_KOPF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 558,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Tab1 Kategorie Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5500301918328731 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BEARB_MODUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 680,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bearb Modus',
  p_source=>'BEARBEITEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5503517069328735 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5503707608328735 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Löschen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5504108391328735 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 540,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Speichern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Speichern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5504507863328735 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_FEHLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 560,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5504712272328735 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_PWD_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 551,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Pwd Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5504926826328735 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_INFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 570,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'S',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5506507517328739 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_PERSON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 620,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Person',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5506728566328740 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_USER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 630,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pisuser',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => 'Bei externen Aufrufen wie z.B PIS kann hier der User angegeben werden, der die Erfassung durchführt, da externe Aufrufe immer mit einem Standard-User angemeldet  werden und so keine Zuordnung mehr für DB-Operationen möglich wäre. Der User wird beim Speichern der Antworten übergeben, falls dieser NULL ist wird der App-User genommen.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5507530178328740 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_HILFETEXTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 550,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Hilfetexte',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5508118625328742 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_OPTIONEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 552,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5510314787328748 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'(',
  p_post_element_text=>')',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>5512013086328751 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>5512523131328753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 3,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Datumsangabe der Form TT.MM.JJJJ z.B. 20.11.2001';

wwv_flow_api.create_page_item(
  p_id=>5515719581328756 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 4,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_format_mask=>'DD.MM.RRRR',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Anzeigesprache';

wwv_flow_api.create_page_item(
  p_id=>5516724983328757 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 97,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'P201_APP_SPRACHE_ID',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5517803861328757 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_VERWERFEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 541,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5651906292377060 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_MN_REZEPT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Rezept Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5654913822395507 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'P201_AKT_VERSION',
  p_read_only_when2=>'0',
  p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5655326473395507 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5655702309395507 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_AKT_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'P201_MN_REZEPT_ID',
  p_read_only_when_type=>'ITEM_IS_NOT_NULL',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5655924958395509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BEZEICHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':P201_AKT_VERSION = 0 OR :p201_bearb_modus = ''ANZEIGEN''',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bemerkung';

wwv_flow_api.create_page_item(
  p_id=>5656119738395509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 147,
  p_cMaxlength=> 100,
  p_cHeight=> 2,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':P201_AKT_VERSION = 0 OR :P201_BEARB_MODUS = ''ANZEIGEN''',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5680130172945070 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_MN_REZTYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 700,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Reztyp Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5712005931288125 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_ADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 553,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5719913605394459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_REZEPT_UNGUELTIG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 543,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6108710293418406 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_REGISTRIEREN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 508,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6115619754361509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_PROD_REZEPT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 910,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prod Rezept Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6271527278834046 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_NV_REZEPTKOPF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1040,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Rezeptkopf',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6272128579853317 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_NV_RZEPTDETAILS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1050,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Rzeptdetails',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6272723647870803 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_NV_VERORDNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1060,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Verordnung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6712932132969912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 509,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7323028932114233 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_MN_REZART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',id,:fas_sprache_id), id'||unistr('\000a')||
'FROM MN_REZARTEN'||unistr('\000a')||
'order by sort'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7326104391485603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_MN_SPLIT_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 13,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT '''' a, 0 b FROM dual   -- OHne Split'||unistr('\000a')||
'UNION  -- mit Split'||unistr('\000a')||
'SELECT '' '' ||frgbg_s.holen_uebersetzung(9202,:fas_sprache_id), 1 FROM dual   ',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7355802302649015 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_FEHLERTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 554,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7366228161819904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_SPLITTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 507,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7391018877325601 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_BESTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 548,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7601403584747962 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_PRODREZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 555,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7602619299761950 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REGION_TITEL_PRODDETAILS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 556,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7745325813375817 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_RUNDEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 544,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7887112358258565 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_REICHWEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 545,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8358413801369846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 98,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprache Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8359608737377765 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_TERRITORY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 99,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Territory',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8517625803718812 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_KOPIEREN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 546,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8835412410118882 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REZEPTHINWEIS_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Text Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8836222453121815 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REZEPTHINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 52,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':P201_AKT_VERSION = 0 OR :P201_BEARB_MODUS = ''ANZEIGEN'' ',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8837000420124865 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_ARZT_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 47,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(77,:fas_sprache_id) v,   '||unistr('\000a')||
'      ''N'' r'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(76,:fas_sprache_id) v,          '||unistr('\000a')||
'      ''J'' r'||unistr('\000a')||
'FROM DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'--:P201_AKT_VERSION = 0 OR :P201_BEARB_MODUS = ''ANZEIGEN'' OR '||unistr('\000a')||
'--:P201_ARZT_REZEPT = ''J''   /* NEI 16.09.11 wg. Grenzwerte */'||unistr('\000a')||
'/* NEI 26.07.14: Feld nur änderbar, wenn Arztrezept-Grenzwerte nicht überschritten sind '||unistr('\000a')||
'DECLARE'||unistr('\000a')||
'   v_anz_ueberschreitungen   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      v_anz_ueberschreitungen := rezepte.CHECK_MNR_GRENZWERTE'||unistr('\000a')||
'                       (:p201_mn_rezept_id,'||unistr('\000a')||
'                        4,    -- Arztrezept erforderlich Grenwerttyp=1'||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN'||unistr('\000a')||
'      v_anz_ueberschreitungen := 1; -- im Fehlerfall nicht änderbar'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF :P201_AKT_VERSION = 0 OR :P201_BEARB_MODUS = ''ANZEIGEN'' '||unistr('\000a')||
'      OR (v_anz_ueberschreitungen > 0 AND :p201_arzt_rezept =''J'')'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      RETURN true; '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- NEI 18.08.14'||unistr('\000a')||
'   IF :P201_AKT_VERSION = 0 OR :P201_BEARB_MODUS = ''ANZEIGEN'' THEN'||unistr('\000a')||
'      RETURN true; '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN false;         '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_read_only_when_type=>'FUNCTION_BODY',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8837808039127042 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_ARZT_REZEPT_GUELTIG_BIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 48,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'DD.MM.YYYY',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DATE_PICKER_CLASSIC',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':P201_AKT_VERSION = 0 OR :P201_BEARB_MODUS = ''ANZEIGEN''',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8850032083294935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REZEPTHINWEIS_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 930,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11224126057036723 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_REZEPTDETAILS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 547,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11254206476267551 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_AKT_VERSION_J_N',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 41,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'IF :p201_akt_version = 1 THEN'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(76,:fas_sprache_id));'||unistr('\000a')||
'ELSE'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(77,:fas_sprache_id));'||unistr('\000a')||
'END IF;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11537312785656090 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_BL_PATIENTENLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 549,
  p_item_plug_id => 5497101072328721+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11598529124280654 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 201,
  p_name=>'P201_REZEPT_NR_VRS_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5653504476395504+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160&#160&#160&#160&#160',
  p_source=>':P201_REZEPT_NR||''/''||:P201_VERSION',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5721730359408778 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P201_BEMERKUNG',
  p_validation_sequence=> 170,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P201_BEMERKUNG IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,v_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(517,v_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 5653728141395504 + wwv_flow_api.g_id_offset,
  p_associated_item=> 5655924958395509 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8936020369484781 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'arzt_rezept_gueltig_check',
  p_validation_sequence=> 180,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P201_arzt_rezept = ''N'' AND :p201_arzt_rezept_gueltig_bis IS NOT NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(658,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 5653728141395504 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_status NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*mel.p(''rezept_speichern 102/201: %1,%2'',v_prot_id,''INFO'',''rezept_speichern 102/201'',:p201_zusatzbemerkung ,length(:p201_zusatzbemerkung )); '||unistr('\000a')||
'*/'||unistr('\000a')||
'   /* Null im Clob heisst nicht leer sondern ''<br />'' und das Feld ist 8 lang => manuell leeren*/'||unistr('\000a')||
'   /* damit nicht unnöt';

p:=p||'ig ein leeres clob mit Laenge 8 erzeugt wird */'||unistr('\000a')||
'   IF length(:p201_zusatzbemerkung)=8  and substr(:p201_zusatzbemerkung,1,6)=''<br />'' THEN'||unistr('\000a')||
'      :p201_zusatzbemerkung:=empty_clob(); '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      /* NEI 26.3.09 Rezepthinweise werden nur noch in Verordnung bearbeitet'||unistr('\000a')||
'      IF trim(:p201_rezepthinweis_db) != trim(:p201_rezepthinweis) OR'||unistr('\000a')||
'         (:p201_rezepthinweis_db IS NULL AND :p20';

p:=p||'1_rezepthinweis IS NOT NULL) OR'||unistr('\000a')||
'         (:p201_rezepthinweis_db IS NOT NULL AND :p201_rezepthinweis IS NULL )'||unistr('\000a')||
'      THEN -- geänderter Rezepthinweis speichern  mutdat = Sysdate'||unistr('\000a')||
'         --UPDATE v_mn_rezepte   NEI 07.05.08 Keine neue Version, bei diesen Änderungen'||unistr('\000a')||
'         UPDATE mn_rezepte'||unistr('\000a')||
'         SET    bezeichnung = :p201_bezeichnung,'||unistr('\000a')||
'                bemerkung   = :p201_bemerkung,'||unistr('\000a')||
'           ';

p:=p||'     --mn_reztyp_id = :p201_mn_reztyp_id,       -- NEI 25.06.08 kein ungültig setzen'||unistr('\000a')||
'                rezepthinweis = :p201_rezepthinweis,'||unistr('\000a')||
'                arzt_rezept = :p201_arzt_rezept,'||unistr('\000a')||
'                arzt_rezept_gueltig_bis = :p201_arzt_rezept_gueltig_bis,'||unistr('\000a')||
'                verrechnungsland = :p201_verrechnungsland, -- NEI 26.06.08'||unistr('\000a')||
'                mutdat = sysdate'||unistr('\000a')||
'         WHERE id = :p201_mn_rez';

p:=p||'ept_id;'||unistr('\000a')||
'      ELSE -- Speichern ohne rezepthinweis'||unistr('\000a')||
'      '||unistr('\000a')||
'--MEL.P (''MN-Rezeptkopf speichern : REZEPT:%1 %2 verrechland:%3! [page201,rezept_speichern]'', --v_PROT_ID, ''ERROR'', ''fas'',:p201_mn_rezept_id,:p201_satz_kennzeichen,:p201_verrechnungsland);'||unistr('\000a')||
''||unistr('\000a')||
'         --UPDATE v_mn_rezepte   NEI 07.05.08 Keine neue Version, bei diesen Änderungen'||unistr('\000a')||
'         UPDATE mn_rezepte'||unistr('\000a')||
'         SET    bezeichnung = :p201_b';

p:=p||'ezeichnung,'||unistr('\000a')||
'                bemerkung   = :p201_bemerkung,'||unistr('\000a')||
'                --mn_reztyp_id = :p201_mn_reztyp_id,         -- NEI 25.06.08 kein ungültig setzen'||unistr('\000a')||
'                arzt_rezept = :p201_arzt_rezept,'||unistr('\000a')||
'                arzt_rezept_gueltig_bis = :p201_arzt_rezept_gueltig_bis,'||unistr('\000a')||
'                verrechnungsland = :p201_verrechnungsland,   -- NEI 26.06.08'||unistr('\000a')||
'                mutdat = sysdate '||unistr('\000a')||
'         W';

p:=p||'HERE id = :p201_mn_rezept_id;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      --UPDATE v_mn_rezepte   NEI 07.05.08 Keine neue Version, bei diesen Änderungen'||unistr('\000a')||
'      UPDATE mn_rezepte'||unistr('\000a')||
'      SET    bezeichnung = :p201_bezeichnung,'||unistr('\000a')||
'             bemerkung   = :p201_bemerkung,'||unistr('\000a')||
'             --mn_reztyp_id = :p201_mn_reztyp_id,         -- NEI 25.06.08 kein ungültig setzen'||unistr('\000a')||
'             arzt_rezept = :p201_arzt_rezept,'||unistr('\000a')||
'       ';

p:=p||'      arzt_rezept_gueltig_bis = :p201_arzt_rezept_gueltig_bis,'||unistr('\000a')||
'             verrechnungsland = :p201_verrechnungsland,   -- NEI 26.06.08'||unistr('\000a')||
'             mutdat = sysdate ,'||unistr('\000a')||
'             zusatzbemerkung = :p201_zusatzbemerkung    -- NEI 15.05.12'||unistr('\000a')||
'      WHERE id = :p201_mn_rezept_id;'||unistr('\000a')||
''||unistr('\000a')||
' /* -- NEI 25.06.08 kein ungültig,sondern gelöscht setzen '||unistr('\000a')||
'      -- Es gibt keine neuen Versionen mehr da die Änderungen ';

p:=p||'direkt in mn_rezept gespeichert werden'||unistr('\000a')||
'      -- Falls rückberechnetes Rezept gespeichert wird, gibts neue Version => Neue ID holen'||unistr('\000a')||
'      select id, bezeichnung, bemerkung,rezept_nr, version ,akt_version,mn_reztyp_id,status  '||unistr('\000a')||
'      into :p201_mn_rezept_id,:p201_bezeichnung,:p201_bemerkung,:p201_rezept_nr,:p201_version,'||unistr('\000a')||
'           :p201_akt_version,:p201_mn_reztyp_id , v_status'||unistr('\000a')||
'      from v_mn_rezep';

p:=p||'te '||unistr('\000a')||
'      where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'        and version = rezepte.get_mnr_max_version(:p201_rezept_nr);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others then'||unistr('\000a')||
'       v_fehlertext := SQLERRM;'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                               v_fehlertext,''speichern_details'''||unistr('\000a')||
'                             ));'||unistr('\000a')||
'   END;   '||unistr('\000a')||
'/* -- Es gibt keine neuen Ve';

p:=p||'rsionen mehr da die Änderungen direkt in mn_rezept gespeichert werden'||unistr('\000a')||
''||unistr('\000a')||
'   -- evt. vorhandenes Produktrezept holen'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT id INTO :p201_prod_rezept_id'||unistr('\000a')||
'      FROM prod_rezepte'||unistr('\000a')||
'      WHERE version = :p201_version'||unistr('\000a')||
'        AND rezept_nr = :p201_rezept_nr;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN no_data_found THEN'||unistr('\000a')||
'        :p201_prod_rezept_id := NULL;'||unistr('\000a')||
'   WHEN others then'||unistr('\000a')||
'       NULL;--RAISE_APPLICATION_ERRO';

p:=p||'R (-20001,frgbg_s.holen_uebersetzung(528,v_sprache_id));'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Bearbeitungsmodus neu setzen'||unistr('\000a')||
'   IF :p201_akt_version = 1 AND '||unistr('\000a')||
'      v_status not in (2,3) -- enthält keine ungültige Rezeptversion => komplettes Rezept gültig'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p201_bearb_modus := ''BEARBEITEN'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p201_bearb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5676028478897267 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'rezept_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5653728141395504 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_status NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      UPDATE v_mn_rezepte   '||unistr('\000a')||
'      SET    mn_reztyp_id = :p201_mn_reztyp_id      '||unistr('\000a')||
'      WHERE id = :p201_mn_rezept_id;'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''MN-Rezeptkopf speichern : REZEPT:%1 %2 verrechland:%3! [page201,rezept_speichern]'', v_PROT_ID, ''ERROR'', ''fas'',:p201_mn_rezept_id';

p:=p||',:p201_satz_kennzeichen,:p201_verrechnungsland);'||unistr('\000a')||
''||unistr('\000a')||
' -- NEI 01.07.08 nicht notwending, da Page verlassen wird auf Rezepteliste und von dort neu ausgewählt'||unistr('\000a')||
'      -- Falls rückberechnetes Rezept gespeichert wird, gibts neue Version => Neue ID holen'||unistr('\000a')||
'      select id, bezeichnung, bemerkung,rezept_nr, version ,akt_version,mn_reztyp_id,status  '||unistr('\000a')||
'      into :p201_mn_rezept_id,:p201_bezeichnung,:p201_bemerku';

p:=p||'ng,:p201_rezept_nr,:p201_version,'||unistr('\000a')||
'           :p201_akt_version,:p201_mn_reztyp_id , v_status'||unistr('\000a')||
'      from v_mn_rezepte '||unistr('\000a')||
'      where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'        and version = rezepte.get_mnr_max_version(:p201_rezept_nr);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others then'||unistr('\000a')||
'       v_fehlertext := SQLERRM;'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                      ';

p:=p||'         v_fehlertext,''p201_rezept_ungueltig_setzen'''||unistr('\000a')||
'                             ));'||unistr('\000a')||
'   END;   '||unistr('\000a')||
'/* -- NEI 01.07.08 nicht notwending, da Page verlassen wird auf Rezepteliste und von dort neu ausgewählt'||unistr('\000a')||
'   -- evt. vorhandenes Produktrezept holen'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT id INTO :p201_prod_rezept_id'||unistr('\000a')||
'      FROM prod_rezepte'||unistr('\000a')||
'      WHERE version = :p201_version'||unistr('\000a')||
'        AND rezept_nr = :p201_rezept_nr;'||unistr('\000a')||
'   ';

p:=p||'EXCEPTION'||unistr('\000a')||
'   WHEN no_data_found THEN'||unistr('\000a')||
'        :p201_prod_rezept_id := NULL;'||unistr('\000a')||
'   WHEN others then'||unistr('\000a')||
'       NULL;--RAISE_APPLICATION_ERROR (-20001,frgbg_s.holen_uebersetzung(528,v_sprache_id));'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Bearbeitungsmodus neu setzen'||unistr('\000a')||
'   IF :p201_akt_version = 1 AND '||unistr('\000a')||
'      v_status not in (2,3) -- enthält keine ungültige Rezeptversion => komplettes Rezept gültig'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p201_bearb_modus := ''BE';

p:=p||'ARBEITEN'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p201_bearb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3957216741983482 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 100,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'rezept_ungueltig_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>3955731895656726 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_status NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      UPDATE mn_rezepte   '||unistr('\000a')||
'      SET   satz_kennzeichen = :p201_satz_kennzeichen, '||unistr('\000a')||
'            mutdat = sysdate'||unistr('\000a')||
'      WHERE id = :p201_mn_rezept_id;'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''MN-Rezeptkopf speichern : REZEPT:%1 %2 verrechland:%3! [page201,rezept_speichern]'', v_PROT_ID, ''ER';

p:=p||'ROR'', ''fas'',:p201_mn_rezept_id,:p201_satz_kennzeichen,:p201_verrechnungsland);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others then'||unistr('\000a')||
'       v_fehlertext := SQLERRM;'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                               v_fehlertext,''p201_version_loeschen'''||unistr('\000a')||
'                             ));'||unistr('\000a')||
'   END;    '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3957825277052237 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'version_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5653807211395504 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'    v_mn_rezept_id_neu  mn_rezepte.id%TYPE;'||unistr('\000a')||
'    v_version_neu       mn_rezepte.version%TYPE;'||unistr('\000a')||
'    v_gen_hint1         prod_rezepte.gen_hint1%TYPE;'||unistr('\000a')||
'    v_gen_hint2         prod_rezepte.gen_hint1%TYPE;'||unistr('\000a')||
'    v_reichweite        prod_rezepte.reichweite%TYPE;'||unistr('\000a')||
'    v_PROD_REZSTATUS_ID prod_rezepte.PROD_REZSTATUS_ID%TYPE;'||unistr('\000a')||
'    v_runden            number;'||unistr('\000a')||
'    v_return            number;'||unistr('\000a')||
'    v_prot_id';

p:=p||'           number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- MN-Split?'||unistr('\000a')||
'   IF :P201_MN_SPLIT_FLAG = 0 AND  -- bisher ohne Split'||unistr('\000a')||
'      :P201_MN_REZART_ID  = 0     -- Gesamtrezept'||unistr('\000a')||
'   THEN         -- Ggf. Split durchführen'||unistr('\000a')||
'--MEL.P(''Gen-Prod 1 Start MNR-Split : %1 '',v_prot_id,''TEST'',''118/201:mnr_splitten'', :p201_mn_rezept_id);'||unistr('\000a')||
' '||unistr('\000a')||
'      IF :p201_prod_rezept_id IS NOT NULL THEN  '||unistr('\000a')||
'         -- Holen der Reichweite aus dem Produktrezept ';

p:=p||'oder der Default aus den Optionswerten'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT reichweite,gen_hint1,PROD_REZSTATUS_ID INTO v_reichweite,v_gen_hint1,v_PROD_REZSTATUS_ID'||unistr('\000a')||
'            FROM prod_rezepte p'||unistr('\000a')||
'            WHERE p.id = :p201_prod_rezept_id;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'             --v_reichweite := 30;  NEI 07.07.08 Default aus Optionswerte opttyp_id =7'||unistr('\000a')||
'             v_reichweite :';

p:=p||'= NVL(frgbg_s.GET_PERS_OPTION(:APP_USER,7),30);'||unistr('\000a')||
'             v_gen_hint1 := 1;'||unistr('\000a')||
'             v_PROD_REZSTATUS_ID:= 0;'||unistr('\000a')||
'         END;'||unistr('\000a')||
'      ELSE  -- Reichweiten-Default setzen'||unistr('\000a')||
'         v_reichweite := NVL(frgbg_s.GET_PERS_OPTION(:APP_USER,7),30);'||unistr('\000a')||
'         v_gen_hint1 := 1;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_PROD_REZSTATUS_ID = 1 THEN -- Arbreitsversion des Produktrepzeptes => keine Splittung'||unistr('\000a')||
'         -- ''MNR-S';

p:=p||'plit konnte nicht durchgeführt werden, da es sich um eine Arbeitsversion des Produktrezeptes handelt!'');'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR(-20000,frgbg_s.holen_uebersetzung(9200,:fas_sprache_id));'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
''||unistr('\000a')||
'      -- Holen des Kennzeichens der Artikelrundung aus den Optionswerten'||unistr('\000a')||
'      v_runden := NVL(frgbg_s.GET_PERS_OPTION(:APP_USER,26),0);   '||unistr('\000a')||
'      IF v_runden != 0 THEN'||unistr('\000a')||
'         v_gen_hint2';

p:=p||' := -v_reichweite;  -- Negative Reichweite => n-Tage hochrechnen inkl. runden'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_gen_hint2 := v_reichweite;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      v_return := rezepte.GEN_MNR_SPLIT (:p201_mn_rezept_id,v_gen_hint1,v_gen_hint2, :fas_sortiment_id);'||unistr('\000a')||
'      IF v_return = 1 THEN'||unistr('\000a')||
'--MEL.P(''Gen-Prod 1 erfolgreicher MNR-Split : %1 '',v_prot_id,''TEST'',''118/201:mnr_splitten'', :p201_mn_rezept_id);'||unistr('\000a')||
'            -';

p:=p||'- Neue Rezept-id/Version holen '||unistr('\000a')||
'            v_version_neu := rezepte.get_mnr_max_version(:p201_rezept_nr);'||unistr('\000a')||
'            select id into v_mn_rezept_id_neu'||unistr('\000a')||
'            from mn_rezepte '||unistr('\000a')||
'            where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'              and version = v_version_neu;'||unistr('\000a')||
'--MEL.P(''Gen-Split neue Rezept-ID: %1 '',v_prot_id,''Info'',''118/201:mnr_splitten'','||unistr('\000a')||
'--        v_mn_rezept_id_neu);   '||unistr('\000a')||
'            --';

p:=p||' Neue Rezept-ID FAS bekannt machen'||unistr('\000a')||
'            :p201_mn_rezept_id := v_mn_rezept_id_neu;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'--MEL.P(''Gen-Prod 1 nicht erfolgreicher MNR-Split : %1 '',v_prot_id,''TEST'',''118/201:mnr_splitten'', :p201_mn_rezept_id);'||unistr('\000a')||
'         -- ''MNR-Split konnte nicht durchgeführt werden!'');'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR(-20001,frgbg_s.holen_uebersetzung(9201,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7354020938378136 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mnr_splitten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>7353500927277738 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:PERSONENSTAMM:P201_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 5520015854328764 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Zeile abrufen aus PERSONENSTAMM',
  p_process_sql_clob => p,
  p_process_error_message=> 'Zeile kann nicht abgerufen werden.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF :p201_person is null THEN  '||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,frgbg_s.holen_uebersetzung(483,v_sprache_id));   '||unistr('\000a')||
'   ELSE  -- Aufruf via Pis p201_person oder via Rezepturenliste enthält bereits die Personenstamm_id'||unistr('\000a')||
'      :p201_id := :p201_person;'||unistr('\000a')||
'   END IF; '||unistr('\000a')||
'   '||unistr('\000a')||
'   SELECT name, vorname, geburtsdatum, app_sp';

p:=p||'rache_id , id'||unistr('\000a')||
'   INTO :p201_name, :p201_vorname, :p201_geburtsdatum, :p201_app_sprache_id, :p201_id'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :p201_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5520831490328768 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 9,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten',
  p_process_sql_clob => p,
  p_process_error_message=> 'Login ungültig!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'Y',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p201_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p201_bl_verwerfen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   :p201_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :p201_bl_aendern   := frgbg_s.holen_uebersetzung(162,v_sprache_id);'||unistr('\000a')||
'   :p201_bl_rezept_ungueltig := frgbg_s.holen_uebersetzung';

p:=p||'(520,v_sprache_id);'||unistr('\000a')||
'   :p201_bl_version_loeschen := frgbg_s.holen_uebersetzung(1895,v_sprache_id); -- NEI 25.06.08'||unistr('\000a')||
'   --:p201_bl_bestellen   := frgbg_s.holen_uebersetzung(1980,v_sprache_id);-- NEI 06.09.12'||unistr('\000a')||
'   :p201_bl_bestellen := frgbg_s.holen_uebersetzung(1574,v_sprache_id);  -- NEI 06.09.12'||unistr('\000a')||
'   :p201_bl_registrieren := frgbg_s.holen_uebersetzung(8018,v_sprache_id);  -- NEI 10.10.13'||unistr('\000a')||
'   :P201_BL_S';

p:=p||'PLITTEN := frgbg_s.holen_uebersetzung(9199,v_sprache_id);  -- NEI 14.01.14'||unistr('\000a')||
''||unistr('\000a')||
'   :p201_bl_runden    := frgbg_s.holen_uebersetzung(574,v_sprache_id);'||unistr('\000a')||
'   :p201_bl_kopieren  := frgbg_s.holen_uebersetzung(620,v_sprache_id);'||unistr('\000a')||
'   :P201_BL_REICHWEITE:= frgbg_s.holen_uebersetzung(582,v_sprache_id);'||unistr('\000a')||
'   :P201_BL_REICHWEITE_BMI:= frgbg_s.holen_uebersetzung(1644,v_sprache_id);'||unistr('\000a')||
'   :P201_BL_REZEPTDETAILS := frgbg_';

p:=p||'s.holen_uebersetzung(1523,v_sprache_id);'||unistr('\000a')||
'   :P201_BL_PATIENTENLISTE := frgbg_s.holen_uebersetzung(475,v_sprache_id);'||unistr('\000a')||
'   :p201_bl_drucken := frgbg_s.holen_uebersetzung(741,v_sprache_id);'||unistr('\000a')||
'   :p201_bl_verordnung := frgbg_s.holen_uebersetzung(3071,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p201_region_titel_pwd_chg := frgbg_s.holen_uebersetzung(170,v_sprache_id);'||unistr('\000a')||
'   :p201_region_titel_hilfetexte := frgbg_s.holen_uebersetzun';

p:=p||'g(220,v_sprache_id);'||unistr('\000a')||
'   :p201_region_titel_optionen := frgbg_s.holen_uebersetzung(1521,v_sprache_id);'||unistr('\000a')||
'   :P201_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(482,v_sprache_id);'||unistr('\000a')||
'   :P201_REGION_TITEL_FEHLERTEXT := '''';--Kein Titel für Fehlertextanzeige in Page 202'||unistr('\000a')||
'   :P201_REGION_TITEL_PRODREZEPT := frgbg_s.holen_uebersetzung(553,v_sprache_id);'||unistr('\000a')||
'   :P201_REGION_TITEL_PRODDETAILS := frgbg_s.holen_';

p:=p||'uebersetzung(527,v_sprache_id);'||unistr('\000a')||
'   :P201_REGION_TITEL_verordnung := frgbg_s.holen_uebersetzung(3071,v_sprache_id);'||unistr('\000a')||
'   :P201_REGION_titel_REZEPT_KOPF := frgbg_s.holen_uebersetzung(515,v_sprache_id);'||unistr('\000a')||
'   :P201_REGION_TITEL_MNR := frgbg_s.holen_uebersetzung(526,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P201_NV_REZEPTKOPF:= frgbg_s.holen_uebersetzung(3841,v_sprache_id);'||unistr('\000a')||
'   :P201_NV_RZEPTDETAILS:= frgbg_s.holen_uebersetzung(';

p:=p||'3842,v_sprache_id);'||unistr('\000a')||
'   :P201_NV_VERORDNUNG:= frgbg_s.holen_uebersetzung(3843,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p201_info := frgbg_s.holen_uebersetzung(173,v_sprache_id);'||unistr('\000a')||
'   :p201_fehler := frgbg_s.holen_uebersetzung(487,v_sprache_id); '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5520227232328765 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 15,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id        number := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --:P201_SPRACHE_ID := V_SPRACHE_ID;'||unistr('\000a')||
'   -- Sprache und Territory des Patienten festlegen für den Etikettendruck Page 202'||unistr('\000a')||
'   SELECT TERRITORY, sprache_id INTO :P201_TERRITORY , :p201_sprache_id'||unistr('\000a')||
'   FROM APP_SPRACHEN'||unistr('\000a')||
'   WHERE ID = :p201_app_sprache_id;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8396232533879284 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'person_sprache_territory _setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_status NUMBER;'||unistr('\000a')||
'   v_mn_rezept_id_neu  number;'||unistr('\000a')||
'   v_sortiment_id      sortimente.id%TYPE; -- NEI 14.02.2011 Sortimentseinfuehrung        '||unistr('\000a')||
'   v_user              VARCHAR2(100);'||unistr('\000a')||
'   v_sprache_id        number := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
'   v_return            number;'||unistr('\000a')||
'   v_gehe_zu_seite     number;'||unistr('\000a')||
'   v_prod_rezept_id            prod_rezepte.id%TYPE;                 ';

p:=p||'-- NEI 25.07.11 Arbeitsversion'||unistr('\000a')||
'   v_prod_rezstatus_id         prod_rezepte.prod_rezstatus_id%TYPE;  -- NEI 25.07.11 '||unistr('\000a')||
'   v_prod_MAN_GEAENDERT_am     prod_rezepte.man_geaendert_am%tYPE;   -- NEI 25.07.11'||unistr('\000a')||
'   v_prod_MAN_GEAENDERT_durch  prod_rezepte.man_geaendert_durch%tYPE;-- NEI 25.07.11'||unistr('\000a')||
'   v_zeit              number;                                       -- NEI 25.07.11'||unistr('\000a')||
'   v_akt_version       mn_re';

p:=p||'zepte.version%TYPE;                      -- NEI 25.07.11'||unistr('\000a')||
'   v_mnr_persstamm_id_ident   mn_rezepte.persstamm_id_ident%TYPE;    -- NEI 16.09.11 Grenzwertbst.'||unistr('\000a')||
'   v_akt_persstamm_id_ident   mn_rezepte.persstamm_id_ident%TYPE;    -- NEI 16.09.11 Grenzwertbst.'||unistr('\000a')||
'   v_fehlertext        VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p201_mn_rezept_id IS NOT NULL THEN'||unistr('\000a')||
'      -- !!!!Achtung etwas weiter untern wird noch 2x auf ';

p:=p||'das Rezept in gleicher Weise zugegriffen,'||unistr('\000a')||
'      -- falls die aktuelle Arbeitsversion gelöscht wird, wird auf das Vorgängerrezept gegangen'||unistr('\000a')||
'      SELECT r.bezeichnung, r.bemerkung,r.rezept_nr, r.version ,r.akt_version,mn_reztyp_id,status,'||unistr('\000a')||
'             pv.bemerkung, -- NEI 26.3.09 rezepthinweis, '||unistr('\000a')||
'             rezepthinweis_text_id, arzt_rezept,'||unistr('\000a')||
'             to_char(arzt_rezept_gueltig_bis,''DD.MM.YYYY';

p:=p||''') ,r.satz_kennzeichen,verrechnungsland,'||unistr('\000a')||
'             r.aenderbar,mnr_vorschrift,neuberechnen,'||unistr('\000a')||
'             neuberechnen_sortiment,           -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'             pr.sortiment_id, '||unistr('\000a')||
'             pr.id,pr.prod_rezstatus_id,'||unistr('\000a')||
'             pr.MAN_GEAENDERT_AM,pr.MAN_GEAENDERT_durch,-- NEI 25.07.11 Einf. Arbeitsversion'||unistr('\000a')||
'             r.persstamm_id_ident,       -- NEI 16.09';

p:=p||'.11 Grenzwerte gemaess Identitaet'||unistr('\000a')||
'             r.zusatzbemerkung ,         -- NEI 15.05.12'||unistr('\000a')||
'             r.mn_rezart_id              -- NEI 10.01.14 Split mit rückgerechn.Gesamtrezept'||unistr('\000a')||
'        INTO :p201_bezeichnung, :p201_bemerkung,:p201_rezept_nr,:p201_version,:p201_akt_version,'||unistr('\000a')||
'             :p201_mn_reztyp_id ,v_status,'||unistr('\000a')||
'             :p201_rezepthinweis, '||unistr('\000a')||
'             :p201_rezepthinweis_text_id,'||unistr('\000a')||
'';

p:=p||'             :p201_arzt_rezept,:p201_arzt_rezept_gueltig_bis ,:p201_satz_kennzeichen,'||unistr('\000a')||
'             :p201_verrechnungsland,'||unistr('\000a')||
'             :p201_mnr_aenderbar,'||unistr('\000a')||
'             :p201_mnr_vorschrift,'||unistr('\000a')||
'             :p201_mnr_neuberechnen,'||unistr('\000a')||
'             :p201_mnr_neuberechnen_sorti,     -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'             v_sortiment_id,                   -- NEI 26.04.2011 Sortimentseinfuehru';

p:=p||'ng'||unistr('\000a')||
'             v_prod_rezept_id,v_prod_rezstatus_id,'||unistr('\000a')||
'             v_prod_MAN_GEAENDERT_AM,v_prod_MAN_GEAENDERT_durch,-- NEI 25.07.11 Einf. Arbeitsversion'||unistr('\000a')||
'             v_mnr_persstamm_id_ident          -- NEI 16.09.11 Grenzwerte gemaess Identitaet'||unistr('\000a')||
'            ,:p201_zusatzbemerkung             -- NEI 15.05.12'||unistr('\000a')||
'            ,:p201_mn_rezart_id               -- NEI 10.01.14 Split mit rückgerechn.Gesam';

p:=p||'trezept'||unistr('\000a')||
'      FROM v_mn_rezepte r, prodr_verordnungen pv, prod_rezepte pr'||unistr('\000a')||
'      WHERE r.id = :p201_mn_rezept_id'||unistr('\000a')||
'        and r.rezept_nr = pv.rezept_nr (+)'||unistr('\000a')||
'        and pv.prodkennz_id(+) = 1  -- HCK-Mischungen'||unistr('\000a')||
'        and r.rezept_nr =pr.rezept_nr (+)'||unistr('\000a')||
'        and r.version = pr.version (+)'||unistr('\000a')||
'      ;'||unistr('\000a')||
'/*MEL.P (''Check page201 rezepthinweis: p201_rezepthinweis_text_id =''||to_char(:p201_rezepthinweis_text';

p:=p||'_id )||'' sprache:''||to_char(:P201_SPRACHE_ID)||'')! [rezept_festlegen, page201]'', v_PROT_ID, ''TEST'', ''rezept_festlegen, page201''); '||unistr('\000a')||
'*/'||unistr('\000a')||
'      -- NEI 16.09.11 Bestimmen der aktuellen Persstamm_id für Pers_typ_id für Grenzwertbestimmung'||unistr('\000a')||
'      v_akt_persstamm_id_ident := rezepte.GET_persstamm_id_pers_typ;'||unistr('\000a')||
' '||unistr('\000a')||
'      -- Prüfen, ob Arbeitsversion => falls überfällige Arbeitsversion, dann Version löschen'||unistr('\000a')||
'   ';

p:=p||'   -- und auf letzte zurückgehen'||unistr('\000a')||
'      IF v_prod_rezstatus_id = 1 THEN   -- Arbeitsversion'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT NVL(parameter,180) INTO v_zeit'||unistr('\000a')||
'            FROM sysareas_frgbg'||unistr('\000a')||
'            WHERE id = 9;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            v_zeit:= 180;'||unistr('\000a')||
'         END;'||unistr('\000a')||
'         IF sysdate > v_prod_MAN_GEAENDERT_AM + v_zeit/1440 AND '||unistr('\000a')||
'            :p201_version > 2    -- ';

p:=p||'Nicht erste Rezeptversion => kann nicht auf Vorgänger zurück'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            -- Löschen der aktuellen Arbeitsversion und zurückgehen auf die letzte gültige Version'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(4887,v_sprache_id,v_prod_man_geaendert_durch,'||unistr('\000a')||
'                                           to_char(v_prod_MAN_GEAENDERT_AM,''DD.MM.YYYY hh24:MI''));'||unistr('\000a')||
'            -- Prodrezeptd';

p:=p||'etails löschen'||unistr('\000a')||
'            DELETE from prodr_details'||unistr('\000a')||
'            WHERE p_rezept_id = v_prod_rezept_id;'||unistr('\000a')||
'            --Prodrezept löschen'||unistr('\000a')||
'            DELETE FROM prod_rezepte'||unistr('\000a')||
'            WHERE id = v_prod_rezept_id;'||unistr('\000a')||
'            -- MNR-Details des Produktrezepts loeschen'||unistr('\000a')||
'            DELETE FROM mnr_details'||unistr('\000a')||
'            WHERE mn_rezept_id = :p201_mn_rezept_id;'||unistr('\000a')||
'            -- MNR löschen'||unistr('\000a')||
'            DEL';

p:=p||'ETE FROM mn_rezepte'||unistr('\000a')||
'            WHERE id = :p201_mn_rezept_id;'||unistr('\000a')||
'            -- Aktuelles Rezept initialisieren'||unistr('\000a')||
'            -- Gültiges MN-Rezept holen'||unistr('\000a')||
'            v_akt_version  := rezepte.get_prodr_max_vers(:p201_rezept_nr);'||unistr('\000a')||
'            SELECT id, bezeichnung, bemerkung,rezept_nr, version ,akt_version,mn_reztyp_id'||unistr('\000a')||
'            INTO :p201_mn_rezept_id,:p201_bezeichnung,:p201_bemerkung,:p201_rezept_n';

p:=p||'r,:p201_version,'||unistr('\000a')||
'                 :p201_akt_version,:p201_mn_reztyp_id '||unistr('\000a')||
'            FROM v_mn_rezepte '||unistr('\000a')||
'            where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'              AND version = v_akt_version;  '||unistr('\000a')||
'            -- !!!! Zugriff ähnlich wie oben nur statt mn_rezept_id über rezept_nr/version'||unistr('\000a')||
'            SELECT r.id,r.bezeichnung, r.bemerkung,r.rezept_nr, r.version ,'||unistr('\000a')||
'                   r.akt_version,mn_rez';

p:=p||'typ_id,status,'||unistr('\000a')||
'                   pv.bemerkung, -- NEI 26.3.09 rezepthinweis, '||unistr('\000a')||
'                   rezepthinweis_text_id, arzt_rezept,'||unistr('\000a')||
'                   to_char(arzt_rezept_gueltig_bis,''DD.MM.YYYY'') ,r.satz_kennzeichen,'||unistr('\000a')||
'                   verrechnungsland,'||unistr('\000a')||
'                   r.aenderbar,mnr_vorschrift,neuberechnen,'||unistr('\000a')||
'                   neuberechnen_sortiment,           -- NEI 14.02.2011 Sortimentsei';

p:=p||'nfuehrung'||unistr('\000a')||
'                   pr.sortiment_id, '||unistr('\000a')||
'                   pr.id,pr.prod_rezstatus_id, pr.MAN_GEAENDERT_AM, -- NEI 25.07.11'||unistr('\000a')||
'                   pr.MAN_GEAENDERT_durch ,          -- NEI 25.07.11 Einf. Arbeitsversion'||unistr('\000a')||
'                   r.persstamm_id_ident              -- NEI 16.09.11 Grenzwerte gemaess Identitaet'||unistr('\000a')||
'                  ,r.zusatzbemerkung            -- NEI 15.05.12'||unistr('\000a')||
'                ';

p:=p||'  ,r.mn_rezart_id               -- NEI 10.01.14 Split mit rückgerechn.Gesamtrezept'||unistr('\000a')||
'            INTO :p201_mn_rezept_id,'||unistr('\000a')||
'                 :p201_bezeichnung, :p201_bemerkung,:p201_rezept_nr,:p201_version,:p201_akt_version,'||unistr('\000a')||
'                 :p201_mn_reztyp_id ,v_status,'||unistr('\000a')||
'                 :p201_rezepthinweis, '||unistr('\000a')||
'                 :p201_rezepthinweis_text_id,'||unistr('\000a')||
'                 :p201_arzt_rezept,:p201_arzt_r';

p:=p||'ezept_gueltig_bis ,:p201_satz_kennzeichen,'||unistr('\000a')||
'                 :p201_verrechnungsland,'||unistr('\000a')||
'                 :p201_mnr_aenderbar,'||unistr('\000a')||
'                 :p201_mnr_vorschrift,'||unistr('\000a')||
'                 :p201_mnr_neuberechnen,'||unistr('\000a')||
'                 :p201_mnr_neuberechnen_sorti,     -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                 v_sortiment_id,                   -- NEI 26.04.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                ';

p:=p||' v_prod_rezept_id,v_prod_rezstatus_id,v_prod_MAN_GEAENDERT_AM,'||unistr('\000a')||
'                 v_prod_MAN_GEAENDERT_durch,       -- NEI 25.07.11 Einf. Arbeitsversion'||unistr('\000a')||
'                 v_mnr_persstamm_id_ident          -- NEI 16.09.11 Grenzwerte gemaess Identitaet'||unistr('\000a')||
'                ,:P201_zusatzbemerkung             -- NEI 15.05.12'||unistr('\000a')||
'                ,:p201_mn_rezart_id               -- NEI 10.01.14 Split mit rückgerec';

p:=p||'hn.Gesamtrezept'||unistr('\000a')||
'            FROM v_mn_rezepte r, prodr_verordnungen pv, prod_rezepte pr'||unistr('\000a')||
'            WHERE r.rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'              AND r.version = v_akt_version'||unistr('\000a')||
'              and r.rezept_nr = pv.rezept_nr (+)'||unistr('\000a')||
'              and pv.prodkennz_id(+) = 1  -- HCK-Mischungen'||unistr('\000a')||
'              and r.rezept_nr =pr.rezept_nr (+)'||unistr('\000a')||
'              and r.version = pr.version (+)'||unistr('\000a')||
'           ;'||unistr('\000a')||
''||unistr('\000a')||
'    ';

p:=p||'     ELSE'||unistr('\000a')||
'            -- Anzeige der aktuellen Arbeitsversion mit entsprechender Hinweismeldung'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(4888,v_sprache_id,v_prod_man_geaendert_durch,'||unistr('\000a')||
'                                           to_char(v_prod_MAN_GEAENDERT_AM,''DD.MM.YYYY hh24:MI''));'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         h';

p:=p||'tp.p(''alert("''||v_fehlertext||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''</body>'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'/*MEL.P (''Check 2 page201 rezepthinweis: p201_rezepthinweis_text_id =''||to_char(:p201_rezepthinweis_text_id )||'' sprache:''||to_char(:P201_SPRACHE_ID)||'')! [rezept_festlegen, page201]'', v_PROT_ID, ''TEST'', ''rezept_festlegen, page201'');'||unistr('\000a')||
'*/'||unistr('\000a')||
'      -- NEI 11.03.09 Evt. neuberechnen durchführen, da';

p:=p||' Produktrezept veraltet'||unistr('\000a')||
'      IF (:p201_mnr_neuberechnen = ''J'' OR'||unistr('\000a')||
'          :p201_mnr_neuberechnen_sorti = ''J''OR -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'          NVL(v_sortiment_id,:FAS_SORTIMENT_ID)!= :FAS_SORTIMENT_ID OR -- NEI 26.04.2011 Sorti.einf'||unistr('\000a')||
'          NVL(v_mnr_persstamm_id_ident,v_akt_persstamm_id_ident)!=     -- NEI 16.09.2011 Grenzwerte'||unistr('\000a')||
'                                             v_';

p:=p||'akt_persstamm_id_ident '||unistr('\000a')||
'         ) '||unistr('\000a')||
'         and '||unistr('\000a')||
'         :p201_akt_version =1  and -- Nur bei aktuellen Version automatische Neuberechnung'||unistr('\000a')||
'         v_status not in (2,3) AND -- enthält keine ungültige Rezeptversion => komplettes Rezept gültig'||unistr('\000a')||
'         :p201_mnr_aenderbar = ''J'' AND'||unistr('\000a')||
'         (:p201_mnr_vorschrift = 0 OR     -- MNR-Vorschriften nur von Betreuern mit'||unistr('\000a')||
'          :p201_mnr_vorschrift =';

p:=p||' 1 AND    -- entsprechender Rolle'||unistr('\000a')||
'          frgbg_s.check_fas_rolle(:APP_USER,''MNR_VORSCHRIFT_VERWALTEN'') != 0'||unistr('\000a')||
'         ) and'||unistr('\000a')||
'         :fas_pers_aenderbar = 1 -- sonst Maske im Anzeige-Modus und es kann nichts bestellt werden'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         v_return := rezepte.gen_kopie_mnr_prodr('||unistr('\000a')||
'                    :p201_mn_rezept_id, -- zu kopierendes Rezept'||unistr('\000a')||
'                    0 ,  -- gen_hint1 =>nicht Ma';

p:=p||'ximalmenge sondern Sollmenge muss eingehalten werden'||unistr('\000a')||
'                    NULL,-- gen_hint2 NULL => Wert aus Vorgängerversion benutzen i.R. Reichweite'||unistr('\000a')||
'                    :p201_id, -- Personenstamm_id'||unistr('\000a')||
'                    :APP_USER,'||unistr('\000a')||
'                    2, --1= Neue Rezeptnr mit Def.aus der Vorgängerversion, '||unistr('\000a')||
'                       --0= Neue Rezeptnr mit Standarddef.'||unistr('\000a')||
'                       --2= Rezep';

p:=p||'tnr beibehalten aber neue Version'||unistr('\000a')||
'                    :FAS_SORTIMENT_ID,           -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                    v_akt_persstamm_id_ident,    -- NEI 16.09.2011 Grenzewerte pers_typ_id abhaengig'||unistr('\000a')||
'                    v_fehlertext );'||unistr('\000a')||
'         IF v_return <= 0 THEN -- Kein MNR erzeugt'||unistr('\000a')||
'            htp.p(''<body>'');'||unistr('\000a')||
'            htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      ';

p:=p||'      htp.p(''alert("''||v_fehlertext||''");'');'||unistr('\000a')||
'            htp.p(''</script>'');'||unistr('\000a')||
'            htp.p(''</body>'');'||unistr('\000a')||
'         ELSE -- ok'||unistr('\000a')||
'            :p201_mn_rezept_id := v_return;'||unistr('\000a')||
'            SELECT bezeichnung, r.bemerkung,r.rezept_nr, version ,akt_version,mn_reztyp_id,status,'||unistr('\000a')||
'                 pv.BEMERKUNG, -- NEI 26.3.09 rezepthinweis, '||unistr('\000a')||
'                 rezepthinweis_text_id,arzt_rezept,'||unistr('\000a')||
'                ';

p:=p||' to_char(arzt_rezept_gueltig_bis,''DD.MM.YYYY'') ,r.satz_kennzeichen,verrechnungsland,'||unistr('\000a')||
'                 aenderbar,mnr_vorschrift,neuberechnen,'||unistr('\000a')||
'                 neuberechnen_sortiment,           -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                 r.persstamm_id_ident              -- NEI 16.09.11 Grenzwerte gemaess Identitaet'||unistr('\000a')||
'                ,r.zusatzbemerkung            -- NEI 15.05.12'||unistr('\000a')||
'         ';

p:=p||'       ,r.mn_rezart_id               -- NEI 10.01.14 Split mit rückgerechn.Gesamtrezept'||unistr('\000a')||
'            INTO :p201_bezeichnung, :p201_bemerkung,:p201_rezept_nr,:p201_version,:p201_akt_version,'||unistr('\000a')||
'                 :p201_mn_reztyp_id ,v_status,'||unistr('\000a')||
'                :p201_rezepthinweis, '||unistr('\000a')||
'                :p201_rezepthinweis_text_id,'||unistr('\000a')||
'                :p201_arzt_rezept,:p201_arzt_rezept_gueltig_bis ,:p201_satz_kennz';

p:=p||'eichen,'||unistr('\000a')||
'                :p201_verrechnungsland,'||unistr('\000a')||
'                :p201_mnr_aenderbar,'||unistr('\000a')||
'                :p201_mnr_vorschrift,'||unistr('\000a')||
'                :p201_mnr_neuberechnen,'||unistr('\000a')||
'                :p201_mnr_neuberechnen_sorti, -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                v_mnr_persstamm_id_ident      -- NEI 16.09.11 Grenzwerte gemaess Identitaet'||unistr('\000a')||
'               ,:p201_zusatzbemerkung         -- NEI 15.05.';

p:=p||'12'||unistr('\000a')||
'               ,:p201_mn_rezart_id            -- NEI 10.01.14 Split mit rückgerechn.Gesamtrezept'||unistr('\000a')||
'            FROM v_mn_rezepte r , prodr_verordnungen pv'||unistr('\000a')||
'            WHERE r.id = :p201_mn_rezept_id'||unistr('\000a')||
'              and r.rezept_nr = pv.rezept_nr (+)'||unistr('\000a')||
'              and pv.prodkennz_id(+) = 1;  -- HCK-Mischungen;'||unistr('\000a')||
'         END IF; '||unistr('\000a')||
'      END IF;  -- Neuberechnen'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''Check 3 page201 rezepthinweis';

p:=p||': p201_rezepthinweis_text_id =''||to_char(:p201_rezepthinweis_text_id )||'' sprache:''||to_char(:P201_SPRACHE_ID)||'')! [rezept_festlegen, page201]'', v_PROT_ID, ''TEST'', ''rezept_festlegen, page201'');'||unistr('\000a')||
'*/'||unistr('\000a')||
'      -- anzuzeigendes Rezept ist nun ermittelt und kann angezeigt werden'||unistr('\000a')||
'      IF :p201_rezepthinweis IS NULL THEN -- Default Text auf Basis Text_id holen'||unistr('\000a')||
'         /* -- NEI 20.11.13 Umstellung Zugriff';

p:=p||' uebersetzungen auf Fallback'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT text INTO :p201_rezepthinweis'||unistr('\000a')||
'            FROM uebersetzungen'||unistr('\000a')||
'            WHERE text_id = :p201_rezepthinweis_text_id '||unistr('\000a')||
'              --AND sprache_id = v_sprache_id;'||unistr('\000a')||
'              AND sprache_id = :P201_SPRACHE_ID; -- Sprache des Patienten wie beim Etiktett'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN no_data_found THEN'||unistr('\000a')||
'            NULL;'||unistr('\000a')||
'         ';

p:=p||'END ;'||unistr('\000a')||
'         */'||unistr('\000a')||
'         :p201_rezepthinweis := frgbg_s.HOLEN_UEBERSETZUNG(:p201_rezepthinweis_text_id ,:P201_SPRACHE_ID);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      -- Beim Speichern werden nur geänderte Rezepthinweise gespeichert; Standarttext soll nicht'||unistr('\000a')||
'      -- als rezepthinweis gespeichert werden, sondern da ist nur die text_id gefüllt'||unistr('\000a')||
'      :p201_rezepthinweis_db := :p201_rezepthinweis;'||unistr('\000a')||
''||unistr('\000a')||
'      -- evt. vorhandene';

p:=p||'s Produktrezept holen'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT id,reichweite,sortiment_id'||unistr('\000a')||
'           INTO :p201_prod_rezept_id,:p201_reichweite,v_sortiment_id'||unistr('\000a')||
'         FROM prod_rezepte'||unistr('\000a')||
'         WHERE version = :p201_version'||unistr('\000a')||
'           AND rezept_nr = :p201_rezept_nr;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN no_data_found THEN'||unistr('\000a')||
'         :p201_prod_rezept_id := NULL;'||unistr('\000a')||
'      WHEN others then'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-2';

p:=p||'0000,frgbg_s.holen_uebersetzung(528,v_sprache_id));'||unistr('\000a')||
'      END;'||unistr('\000a')||
'/*MEL.P (''Check 4 page201 rezepthinweis: p201_rezepthinweis_text_id =''||to_char(:p201_rezepthinweis_text_id )||'' sprache:''||to_char(:P201_SPRACHE_ID)||'')! [rezept_festlegen, page201]'', v_PROT_ID, ''TEST'', ''rezept_festlegen, page201'');'||unistr('\000a')||
'*/'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p201_bezeichnung := NULL;'||unistr('\000a')||
'      :p201_bemerkung   := NULL;'||unistr('\000a')||
'      :p201_rezept_nr   :=';

p:=p||' NULL;'||unistr('\000a')||
'      :p201_version     := NULL;'||unistr('\000a')||
'      :p201_akt_version := NULL;'||unistr('\000a')||
'      :p201_mn_reztyp_id := NULL;'||unistr('\000a')||
'      :p201_prod_rezept_id := NULL;'||unistr('\000a')||
'      :p201_rezepthinweis  := NULL;'||unistr('\000a')||
'      :p201_rezepthinweis_text_id:= NULL;'||unistr('\000a')||
'      :p201_arzt_rezept := NULL;'||unistr('\000a')||
'      :p201_arzt_rezept_gueltig_bis := NULL;'||unistr('\000a')||
'      :p201_satz_kennzeichen := NULL;'||unistr('\000a')||
'      :p201_mnr_aenderbar := NULL;'||unistr('\000a')||
'      :p201_mnr_neuberechnen';

p:=p||' := NULL;'||unistr('\000a')||
'      :p201_mnr_neuberechnen_sorti := NULL;   -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'      :p201_zusatzbemerkung:= NULL;           -- NEI 15.05.12'||unistr('\000a')||
'      :p201_mn_rezart_id := NULL;             -- NEI 10.01.14 Split mit rückgerechn.Gesamtrezept'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Bearbeitungsmodus setzen'||unistr('\000a')||
'   IF :p201_akt_version = 1 AND '||unistr('\000a')||
'      v_status not in (2,3) AND-- enthält keine ungültige Rezeptversi';

p:=p||'on => komplettes Rezept gültig'||unistr('\000a')||
'      :p201_mnr_aenderbar = ''J'' AND'||unistr('\000a')||
'      (:p201_mnr_vorschrift = 0 OR     -- MNR-Vorschriften nur von Betreuern mit'||unistr('\000a')||
'         :p201_mnr_vorschrift = 1 AND  -- entsprechender Rolle'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''MNR_VORSCHRIFT_VERWALTEN'') != 0'||unistr('\000a')||
'      ) and'||unistr('\000a')||
'      :fas_pers_aenderbar = 1  and        -- Personendaten aenderbar'||unistr('\000a')||
'      :p201_mnr_neuberechnen = ''';

p:=p||'N'' and    -- Kein Neuberechnen nötig'||unistr('\000a')||
'      :p201_mnr_neuberechnen_sorti = ''N'' and  -- Kein Neuberechnen nötig NEI 14.02.11 Sortimentseinf'||unistr('\000a')||
'      :fas_modus_id !=1   and                 -- FAS-Modus nicht Iabc  NEI 11.01.10'||unistr('\000a')||
'      (:p201_prod_rezept_id is not null       -- NEI 14.02.2011 Sortimentseinf.: Aktuelles '||unistr('\000a')||
'       and v_sortiment_id = :fas_sortiment_id -- Sortiment muss zum Prodr-Sortiment pa';

p:=p||'ssen'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       :p201_prod_rezept_id is null'||unistr('\000a')||
'      )  -- NEI 16.09.11 wg. Grenzwertbest. muss gespeicherte Ident mit aktiver Ident übereinstimmen'||unistr('\000a')||
'      and (v_mnr_persstamm_id_ident is NULL OR  '||unistr('\000a')||
'           v_mnr_persstamm_id_ident = v_akt_persstamm_id_ident'||unistr('\000a')||
'          )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p201_bearb_modus := ''BEARBEITEN'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p201_bearb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'      -- Check, ob Rezept-So';

p:=p||'rtiment dem aktuellen Sortiment entspricht'||unistr('\000a')||
'      IF NVL(v_sortiment_id,:fas_sortiment_id) != :fas_sortiment_id THEN'||unistr('\000a')||
'         --''Aktuelles Sortiment passt nicht zum Sortiment des Produktrezepts! Keine Änderung des Rezepts möglich.'';'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(4509,v_sprache_id);'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         htp.p(''ale';

p:=p||'rt("''||v_fehlertext||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''</body>'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5521027707328768 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'rezept_festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|PIS:MN_REZEPTE:P201_MN_REZEPT_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 4745812517335458 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 75,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Zeile abrufen aus MN_REZEPTE',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_preisliste_id    NUMBER;'||unistr('\000a')||
'   v_waehrung_id      v_laender.id_waehrung_verrech%TYPE;'||unistr('\000a')||
'   v_waehrung_zeichen VARCHAR2(5);'||unistr('\000a')||
'   v_eh_zeichen       VARCHAR2(10);'||unistr('\000a')||
'   v_gesamtpreis      NUMBER;'||unistr('\000a')||
'   v_mwst_betrag      NUMBER;'||unistr('\000a')||
'   v_mwst_satz1       v_laender.mwst_satz1%TYPE;'||unistr('\000a')||
'   v_hck_preis        NUMBER;'||unistr('\000a')||
'   v_hck_mwst_betrag  NUMBER;'||unistr('\000a')||
'   v_hck_mwst_satz    v_laender.mwst_satz1%TYPE;'||unistr('\000a')||
'   v_verrech_la';

p:=p||'nd_id  NUMBER;'||unistr('\000a')||
'   v_art_mwst_typ_id          number; '||unistr('\000a')||
'   v_preisfaktor      number;'||unistr('\000a')||
'   v_persstamm_id_prod_apo  personenstamm.id%TYPE;'||unistr('\000a')||
'   v_prot_id          NUMBER;'||unistr('\000a')||
'   v_return           NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF :P201_PROD_REZEPT_ID IS NOT NULL THEN'||unistr('\000a')||
'      v_eh_zeichen := fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',500,:fas_sprache_id);'||unistr('\000a')||
'      -- Gewicht und Volumen nur für den HCK-Mischungsan';

p:=p||'teil'||unistr('\000a')||
'      :p201_gesamtgewicht := '||unistr('\000a')||
'              to_char(rezepte.calc_gewicht_prod(:P201_PROD_REZEPT_ID,'||unistr('\000a')||
'                                                NULL, -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                                1),''999G999G990'')'||unistr('\000a')||
'              ||'' ''||v_eh_zeichen;'||unistr('\000a')||
''||unistr('\000a')||
'      :p201_tagesmenge_g :=   '||unistr('\000a')||
'              to_char(rezepte.calc_gewicht_prod(:P201_PROD_REZEPT_ID,'||unistr('\000a')||
'      ';

p:=p||'                                          NULL, -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                                1)/:p201_reichweite,'||unistr('\000a')||
'                      ''999G999G990'')||'' ''||v_eh_zeichen;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'      v_eh_zeichen := fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',406,:fas_sprache_id);'||unistr('\000a')||
'      :p201_gesamtvolumen :=             '||unistr('\000a')||
'              to_char(rezepte.calc_volumen_prod(:P20';

p:=p||'1_PROD_REZEPT_ID,'||unistr('\000a')||
'                                                NULL, -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                                1),'||unistr('\000a')||
'                      ''999G999G990'')                         '||unistr('\000a')||
'              ||'' ''||v_eh_zeichen;'||unistr('\000a')||
''||unistr('\000a')||
'      v_eh_zeichen := fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',1,:fas_sprache_id);'||unistr('\000a')||
'      -- Angabe Std. Kapseln: 1 Kapsel fasst 0.5ml';

p:=p||''||unistr('\000a')||
'      :p201_tagesmenge_kaps :=  '||unistr('\000a')||
'              to_char(rezepte.calc_volumen_prod(:P201_PROD_REZEPT_ID,'||unistr('\000a')||
'                                                NULL, -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                                1)/:p201_reichweite/0.5,'||unistr('\000a')||
'                      ''999G999G990'')      '||unistr('\000a')||
'              ||'' ''||v_eh_zeichen;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Preisberechnung'||unistr('\000a')||
'/* NEI 6.4.09 alte Preisberechnun';

p:=p||'g'||unistr('\000a')||
'      v_return := rezepte.calc_preisberechnung(:P201_PROD_REZEPT_ID,'||unistr('\000a')||
'                                               :p201_id,:FAS_LOGIN_PERSONENSTAMM_ID, '||unistr('\000a')||
'                                               :p201_verrechnungsland,'||unistr('\000a')||
'                                               v_gesamtpreis,'||unistr('\000a')||
'                                               v_mwst_betrag,'||unistr('\000a')||
'                                               v';

p:=p||'_mwst_satz1,'||unistr('\000a')||
'                                               v_waehrung_id'||unistr('\000a')||
'                                              );'||unistr('\000a')||
'*/'||unistr('\000a')||
'      v_persstamm_id_prod_apo := frgbg_s.get_pers_option(v(''APP_USER''),21);'||unistr('\000a')||
'      v_return := rezepte.CALC_GES_PREISBERECH('||unistr('\000a')||
'                         :P201_PROD_REZEPT_ID,'||unistr('\000a')||
'                         :p201_id,                    -- Kunde'||unistr('\000a')||
'                         :FAS_LOGIN_PERS';

p:=p||'ONENSTAMM_ID, -- Login (Betreuer od. Kunde)'||unistr('\000a')||
'                         :FAS_IDENTITAET_PERSSTAMM_ID,-- aktive Identitaet  NEI 08.03.2012'||unistr('\000a')||
'                         v_persstamm_id_prod_apo,     -- prod. Apo          NEI 08.03.2012'||unistr('\000a')||
'                         v_persstamm_id_prod_apo,     -- Rechsteller: def. Prod Apo  NEI 08.03.2012 '||unistr('\000a')||
'                         -- :p201_verrechnungsland,   -- NEI 08.03.2012'||unistr('\000a')||
' ';

p:=p||'                        v_gesamtpreis,'||unistr('\000a')||
'                         v_mwst_betrag,'||unistr('\000a')||
'                         v_waehrung_id,'||unistr('\000a')||
'                         v_verrech_land_id,'||unistr('\000a')||
'                         v_preisliste_id,'||unistr('\000a')||
'                         v_art_mwst_typ_id,'||unistr('\000a')||
'                         v_preisfaktor'||unistr('\000a')||
'                     );'||unistr('\000a')||
'/*'||unistr('\000a')||
'mel.p(''Prod.rezept_id %1,pers %2, login %3, Währ %4, verrech_id %5, preisfaktor %6,ge';

p:=p||'samtpreis:%7,mwst_betrag:%8, prod_apo %9'','||unistr('\000a')||
' v_PROT_ID, ''INFO'', ''201/gewichte_vol_menge_preis_setzen'','||unistr('\000a')||
':P201_PROD_REZEPT_ID,:p201_id,:FAS_LOGIN_PERSONENSTAMM_ID,v_waehrung_id,'||unistr('\000a')||
'v_verrech_land_id, v_preisfaktor,v_gesamtpreis,v_mwst_betrag,v_persstamm_id_prod_apo);'||unistr('\000a')||
''||unistr('\000a')||
'mel.p(''Sortiment %1,Preisliste %2'','||unistr('\000a')||
' v_PROT_ID, ''INFO'', ''201/gewichte_vol_menge_preis_setzen'','||unistr('\000a')||
':FAS_SORTIMENT_ID,v_preisliste_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'  ';

p:=p||'    -- Währungszeichen holen'||unistr('\000a')||
'      v_waehrung_zeichen := rezepte.get_waehrung_zeichen(v_waehrung_id);'||unistr('\000a')||
'      '||unistr('\000a')||
'      /* NEI 12.10.09 wird bereits in calc_ges_preisberech ermittelt, '||unistr('\000a')||
'         evt. wg. zurückgreifen Std-preisliste auch angepasst '||unistr('\000a')||
'      v_verrech_land_id := rezepte.get_land_id_verr(:p201_id,:FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                           :p201_verrechnungsland);  '||unistr('\000a')||
'      */'||unistr('\000a')||
'    ';

p:=p||'  IF v_return < 0 THEN  -- Preisberechnung hatte Fehler'||unistr('\000a')||
'          :p201_gesamtpreis := frgbg_s.holen_uebersetzung(2175,:fas_sprache_id);'||unistr('\000a')||
'          htp.p(''<body>'');'||unistr('\000a')||
'          htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'          htp.p(''alert("''||frgbg_s.holen_uebersetzung(2175,:fas_sprache_id)||''");'');'||unistr('\000a')||
'          htp.p(''</script>'');'||unistr('\000a')||
'          htp.p(''</body>'');'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p201_gesamtpreis := ';

p:=p||'to_char(v_gesamtpreis,''999G999G990D00'') ||'' ''||'||unistr('\000a')||
'            v_waehrung_zeichen||'' ''||frgbg_s.holen_uebersetzung(1874,:fas_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'         -- HCK-Preisanteil (reine Mischung ohne Fertigartikel) bestimmen'||unistr('\000a')||
'         /* 04.06.2014 Berechnung HCK-Anteil auf Splitkomponenten umgestellt und nicht via Gesamtrezept wg. Preisdifferenzen'||unistr('\000a')||
'         v_return := rezepte.calc_preis_mwst_prod(:P201_PROD_REZE';

p:=p||'PT_ID,   -- Prodrezept'||unistr('\000a')||
'                                             NULL,                    -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                             v_verrech_land_id,'||unistr('\000a')||
'                                             1, -- HCK-Mischung'||unistr('\000a')||
'                                             NULL, -- Kein spez. Artikel sondern alle HCK''s'||unistr('\000a')||
'                                             v_preislis';

p:=p||'te_id,'||unistr('\000a')||
'                                             v_art_mwst_typ_id,'||unistr('\000a')||
'                                             v_preisfaktor,'||unistr('\000a')||
'                                             v_persstamm_id_prod_apo, -- NEI 04.03.13 Mwstbest(nicht mehr) NEI 30.5.14 sondern wg. Rabattstaffelgruppe bei Mischungen'||unistr('\000a')||
'                                             0,                       -- NEI 28.03.14 ohne Rundung ganz';

p:=p||'er Packungen bei Fertigartikeln der Mischung'||unistr('\000a')||
'                                             v_hck_preis,'||unistr('\000a')||
'                                             v_hck_mwst_betrag,'||unistr('\000a')||
'                                             v_hck_mwst_satz'||unistr('\000a')||
'                                             );'||unistr('\000a')||
'         */'||unistr('\000a')||
'         v_return := rezepte.calc_preis_mwst_prod_split(:P201_PROD_REZEPT_ID,   -- Prodrezept'||unistr('\000a')||
'                  ';

p:=p||'                           NULL,                    -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                             v_verrech_land_id,'||unistr('\000a')||
'                                             1, -- HCK-Mischung'||unistr('\000a')||
'                                             NULL, -- Kein spez. Artikel sondern alle HCK''s'||unistr('\000a')||
'                                             v_preisliste_id,'||unistr('\000a')||
'                                  ';

p:=p||'           v_art_mwst_typ_id,'||unistr('\000a')||
'                                             v_preisfaktor,'||unistr('\000a')||
'                                             v_persstamm_id_prod_apo, -- NEI 04.03.13 Mwstbest(nicht mehr) NEI 30.5.14 sondern wg. Rabattstaffelgruppe bei Mischungen'||unistr('\000a')||
'                                             0,                       -- NEI 28.03.14 ohne Rundung ganzer Packungen bei Fertigartikeln der Misch';

p:=p||'ung'||unistr('\000a')||
'                                             1,                       -- alle Rezepte aus Split berücksichtigen'||unistr('\000a')||
'                                             0,                       -- NEI 18.06.14 keine Reichweitenstaffel-Rabattberechnung (=0) für Mischungen,'||unistr('\000a')||
'                                                                      --              nur  noch im WK und auf Bestellschein sonst keine';

p:=p||' Rabattrechnung'||unistr('\000a')||
'                                             v_hck_preis,'||unistr('\000a')||
'                                             v_hck_mwst_betrag,'||unistr('\000a')||
'                                             v_hck_mwst_satz'||unistr('\000a')||
'                                             );'||unistr('\000a')||
'         :p201_hck_preis := to_char(NVL(v_hck_preis+v_hck_mwst_betrag,0),''999G999G990D00'')||'' ''||'||unistr('\000a')||
'            v_waehrung_zeichen||'' ''||frgbg_s.holen_uebe';

p:=p||'rsetzung(1874,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
' '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3919821612823132 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 80,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gewichte_vol_menge_preis_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'      v_anz := rezepte.CHECK_MNR_SPLIT_EXIST(NULL,:P201_rezept_nr,:p201_version);'||unistr('\000a')||
'      IF v_anz > 0          -- Rezept mit Splitkomponenten'||unistr('\000a')||
'      THEN  '||unistr('\000a')||
'         :p201_mn_split_flag := 1;  -- mit Split'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p201_mn_split_flag := 0;  -- ohne Split'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7357114470584487 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 130,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mn_split_flag',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p201_satz_kennzeichen := ''GELOESCHT durch ''||:app_user||'' am ''||'||unistr('\000a')||
'                             to_char(sysdate,''DD.MM.YYYY hh24:mi:ss'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5678101083936660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 50,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_version_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5653807211395504 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p201_mn_reztyp_id := 6;    '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3955025877645521 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 201,
  p_process_sequence=> 90,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_rezept_ungueltig',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>3955731895656726 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 201
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00202
prompt  ...PAGE 202: MNR-Details
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 202
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'MNR-Details'
 ,p_step_title => 'Mnr-Details'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Mnr-Details'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_checkDetails (feld_id,wert,eh_id)'||unistr('\000a')||
'{ '||unistr('\000a')||
''||unistr('\000a')||
'  var feld_menge = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkMnrDetails'',0);'||unistr('\000a')||
'  var str'||unistr('\000a')||
'  get.add(''P202_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P202_MENGE_INPUT'',wert);'||unistr('\000a')||
'  get.add(''P202_EINHEIT_ID_INPUT'',eh_id);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = gReturn ;*/'||unistr('\000a')||
'       str = gReturn;'||unistr('\000a')||
'       /* NEI 29.07.14 Visualsierung Grenzwerte aerztl. Verschreibung'||unistr('\000a')||
'       if(str.charAt(0) == ''1'')'||unistr('\000a')||
'          { html_GetElement(feld_menge).style.background="yellow";'||unistr('\000a')||
'          }'||unistr('\000a')||
'       else'||unistr('\000a')||
'          { html_GetElement(feld_menge).style.background="red";'||unistr('\000a')||
'          }'||unistr('\000a')||
'       */'||unistr('\000a')||
'       switch (str.charAt(0))'||unistr('\000a')||
'        { case ''1'':'||unistr('\000a')||
'             html_GetElement(feld_menge).style.background="yellow";'||unistr('\000a')||
'             break;'||unistr('\000a')||
'          case ''3'':'||unistr('\000a')||
'             html_GetElement(feld_menge).style.background="orange";'||unistr('\000a')||
'             break;'||unistr('\000a')||
'          default:'||unistr('\000a')||
'             html_GetElement(feld_menge).style.background="red"; '||unistr('\000a')||
'             break;'||unistr('\000a')||
'        }'||unistr('\000a')||
''||unistr('\000a')||
'       $(''#AjaxLoadingBG'').hide();'||unistr('\000a')||
'       alert(str.substring(1,str.length));'||unistr('\000a')||
'  '||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = '''' ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.background="white";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  $(''#AjaxLoadingBG'').hide();'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'function f_checkProdDetails (feld_id,wert,eh_id)'||unistr('\000a')||
'{ '||unistr('\000a')||
'  var feld_menge = document.getElementById(feld_id);'||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkProdDetails'',0);'||unistr('\000a')||
'  get.add(''P202_ID_INPUT'',feld_id);'||unistr('\000a')||
'  get.add(''P202_MENGE_INPUT'',wert);'||unistr('\000a')||
'  get.add(''P202_EINHEIT_ID_INPUT'',eh_id);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = gReturn ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="red";'||unistr('\000a')||
'       $(''#AjaxLoadingBG'').hide();'||unistr('\000a')||
'       alert(gReturn);'||unistr('\000a')||
'    }'||unistr('\000a')||
'    else'||unistr('\000a')||
'    {  /*html_GetElement(''P202_FEHLERTEXT'').value = '''' ;*/'||unistr('\000a')||
'       html_GetElement(feld_menge).style.color="black";'||unistr('\000a')||
'    }'||unistr('\000a')||
'  $(''#AjaxLoadingBG'').hide();'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'function f_checkBestelldat (button_name,plandatum,bestelldatum) '||unistr('\000a')||
'{ '||unistr('\000a')||
''||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkBestelldatumNeu'',0);'||unistr('\000a')||
'  var v_confirm;'||unistr('\000a')||
''||unistr('\000a')||
'  //alert(plandatum);'||unistr('\000a')||
'  //alert(bestelldatum);'||unistr('\000a')||
'  get.add(''TEMP_PLANDATUM'',plandatum);'||unistr('\000a')||
'  get.add(''TEMP_BESTELLDATUM'',bestelldatum);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  v_confirm = confirm(gReturn);'||unistr('\000a')||
'       if (v_confirm == true)'||unistr('\000a')||
'          {'||unistr('\000a')||
'          '||unistr('\000a')||
'           doSubmit(button_name);'||unistr('\000a')||
'          }'||unistr('\000a')||
'    }'||unistr('\000a')||
'   else'||unistr('\000a')||
'    {'||unistr('\000a')||
'      doSubmit(button_name);'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150518102633'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3169909337786592 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 202,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'apex_item.hidden(1,mnrd.INH_ID) ||'||unistr('\000a')||
'apex_item.hidden(2,mnrd.MN_ID) ||'||unistr('\000a')||
'apex_item.select_list_from_query(3,MN_EINHEIT_ID,''select fas_synch.get_tab_uebersetzung(''''EINHEITEN.EH_ZEICHEN'''',id,:fas_sprache_id)  eh_zeichen, id from einheiten where flag is null and physeh_id in (select physeh_id from einheiten e, inh_eh_umrs i where e.id = i.einheit_id and i.inhstoff_id ='' ||to_char(mnrd.INH_ID)||'')';

s:=s||' order by physeh_id, basis_faktor desc'','||unistr('\000a')||
'''onchange="javascript:f_checkDetails('''''' || to_char(mnrd.INH_ID) || '''''',html_GetElement('''''' || mnrd.INH_ID || '''''').value, html_GetElement(''''EH'' || mnrd.INH_ID || '''''').value)"'','||unistr('\000a')||
'''NO'',NULL,NULL,''EH''||mnrd.INH_ID) MN_EINHEIT_ID,'||unistr('\000a')||
'apex_item.hidden(5,MN_BEMERKUNG) ||'||unistr('\000a')||
'apex_item.hidden(6,MN_MENGE_TAG_SICHER)||'||unistr('\000a')||
'apex_item.hidden(7,MN_MENGE_TAG_MAX)   ||'||unistr('\000a')||
'apex_item.hid';

s:=s||'den(8,MN_MENGE_TAG_MIN)   ||       '||unistr('\000a')||
'apex_item.hidden(9,MN_EINHEIT_ID_TAG_SICHER)|| '||unistr('\000a')||
'apex_item.hidden(10,MN_EINHEIT_ID_TAG_MAX)  || '||unistr('\000a')||
'apex_item.hidden(11,MN_EINHEIT_ID_TAG_MIN)  ||'||unistr('\000a')||
'apex_item.hidden(12,MNRD.BEZEICHNUNG) ||'||unistr('\000a')||
'apex_item.hidden(13,MN_EINHEIT_ID) ||'||unistr('\000a')||
'-- !!!Achtung MN_MENGEN Formatmask muss identisch sein wg. Änderungskontrolle'||unistr('\000a')||
'apex_item.hidden(14,to_char(MN_MENGE,''999G990D0''))|| '||unistr('\000a')||
''||unistr('\000a')||
'case subs';

s:=s||'tr(rezepte.check_mnr_inhgrenzwert(:p201_mn_rezept_id,mnrd.INH_ID, '||unistr('\000a')||
'                 mn_menge,MN_EINHEIT_ID,1),1,1) '||unistr('\000a')||
'when  ''1'' THEN '||unistr('\000a')||
'     apex_item.text(4,to_char(MN_MENGE,''999G990D0''),10,15,''tabindex="1" autocomplete="off" style="background-color:yellow" class="validateField inh_id_'' || trim(mnrd.INH_ID) || ''"'', mnrd.INH_ID) '||unistr('\000a')||
'when  ''2'' THEN '||unistr('\000a')||
'     apex_item.text(4,to_char(MN_MENGE,''999G990D0''),10,1';

s:=s||'5,''tabindex="1" autocomplete="off" style="background-color:red" class="validateField inh_id_'' || trim(mnrd.INH_ID) || ''" '', mnrd.INH_ID) '||unistr('\000a')||
'when  ''3'' THEN '||unistr('\000a')||
'     apex_item.text(4,to_char(MN_MENGE,''999G990D0''),10,15,''tabindex="1" autocomplete="off" style="background-color:orange" class="validateField inh_id_'' || trim(mnrd.INH_ID) || ''" '', mnrd.INH_ID) '||unistr('\000a')||
'ELSE'||unistr('\000a')||
'     apex_item.text(4,to_char(MN_MENGE,''999G';

s:=s||'990D0''),10,15,''tabindex="1" autocomplete="off" style="background-color:white" class="validateField inh_id_'' || trim(mnrd.INH_ID) || ''"'', mnrd.INH_ID) '||unistr('\000a')||
'END mn_menge,'||unistr('\000a')||
'"I"."ID" inhgrp_id,'||unistr('\000a')||
'fas_synch.get_tab_uebersetzung(''INHSTOFFE.BEZEICHNUNG'',i.id,:fas_sprache_id) '||unistr('\000a')||
'inhgrp_bezeichnung, '||unistr('\000a')||
'''<a onmouseover="javascript:toolTip_enable(event,this,''''''||'||unistr('\000a')||
'frgbg_s.holen_uebersetzung(4883,:fas_sprache_id,'||unistr('\000a')||
'replace';

s:=s||'(NVL(to_char(rezepte.GET_INH_GRENZWERT(mnrd.inh_ID,:p201_mn_rezept_id,null,null,1),''999G999G990D00''),''???''),'''''''',''&lsquo;''),'||unistr('\000a')||
'replace(NVL(to_char(rezepte.GET_INH_GRENZWERT(mnrd.inh_ID,:p201_mn_rezept_id,null,null,5),''999G999G990D00''),''&minus;&minus;&minus;''),'''''''',''&lsquo;''),'||unistr('\000a')||
'--replace(NVL(to_char(rezepte.GET_INH_GRENZWERT(mnrd.inh_ID,:p201_mn_rezept_id,null,null,4),''999G999G990D00''),''&minus;&minus;';

s:=s||'&minus;''),'''''''',''&lsquo;''))'||unistr('\000a')||
'replace(DECODE(rezepte.GET_INH_GRENZWERT(mnrd.inh_ID,:p201_mn_rezept_id,null,null,4),NULL,frgbg_s.holen_uebersetzung(77,:fas_sprache_id), frgbg_s.holen_uebersetzung(10377,:fas_sprache_id,to_char(rezepte.GET_INH_GRENZWERT(mnrd.inh_ID,:p201_mn_rezept_id,null,null,4),''FM999G999G990D00''))),''&lsquo;''))'||unistr('\000a')||
'||'''''')"> '''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#infoicon_status.gif" >'' || ''</a>   ';

s:=s||''' ||fas_synch.get_tab_uebersetzung(''INHSTOFFE.BEZEICHNUNG'',mnrd.inh_id,:fas_sprache_id)'||unistr('\000a')||
' bezeichnung_disp,--mnrd.bezeichnung bezeichnung_disp,'||unistr('\000a')||
'apex_item.hidden(16,inh_maximalwert)||'||unistr('\000a')||
'apex_item.hidden(17,inh_einheit_id)||'||unistr('\000a')||
'apex_item.DISPLAY_AND_SAVE(15,mnrd.mn_rezeptrelevant,''REL''||mnrd.INH_ID)  MN_rezeptrelevant'||unistr('\000a')||
'from "PIS"."V_MNR_DETAILS" mnrd, inhstoffe i'||unistr('\000a')||
'where  mnrd.mn_rezept_id = :p201_mn_rezept_';

s:=s||'id'||unistr('\000a')||
'and i.id = mnrd.inhstoff_id'||unistr('\000a')||
'and ((:p202_mn_alle_anzeigen = 0 AND mn_menge IS NOT NULL) OR'||unistr('\000a')||
'      :p202_mn_alle_anzeigen = 1'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by mnrd.sort'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 202,
  p_name=> '&P201_REGION_TITEL_MNR.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P202_HEIGHT_INHSTOFFE.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(522,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '500',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '1',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '1000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'drucken',
  p_prn_output_file_name=> 'Mikronährstoffrezept',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width=> 210,
  p_prn_height=> 297,
  p_prn_orientation=> 'VERTICAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'LEFT',
  p_prn_page_footer_alignment=> 'LEFT',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7078027376801845 + wwv_flow_api.g_id_offset,
  p_region_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'MN_EINHEIT_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '10',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7078108615801845 + wwv_flow_api.g_id_offset,
  p_region_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'MN_MENGE',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '10',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6832009880915832 + wwv_flow_api.g_id_offset,
  p_region_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'INHGRP_ID',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '30',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6832124922915832 + wwv_flow_api.g_id_offset,
  p_region_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'INHGRP_BEZEICHNUNG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '30',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6847128752968176 + wwv_flow_api.g_id_offset,
  p_region_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG_DISP',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8129702929038960 + wwv_flow_api.g_id_offset,
  p_region_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MN_REZEPTRELEVANT',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7099000040581456 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 202,
  p_plug_name=> '&P201_REGION_TITEL_FEHLERTEXT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 0,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'NEVER',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'apex_item.hidden(22,det.PRODR_DET_ID) ||'||unistr('\000a')||
'apex_item.hidden(21,det.MART_ID) ||'||unistr('\000a')||
'apex_item.hidden(25,det.ENTNAHMEART_ID) ||'||unistr('\000a')||
'apex_item.hidden(26,det.PRODR_DET_GEWICHT) ||'||unistr('\000a')||
'apex_item.hidden(27,det.PRODR_DET_EINHEIT_ID) ||'||unistr('\000a')||
'apex_item.hidden(28,det.MART_KUERZEL) ||'||unistr('\000a')||
'apex_item.hidden(29,det.MART_MENGE_EINHEIT_ID) ||'||unistr('\000a')||
'apex_item.hidden(30,det.MART_MENGE) ||'||unistr('\000a')||
'--det.MART_KUERZEL mart_kuerzel,'||unistr('\000a')||
'fas_synch.get_';

s:=s||'tab_uebersetzung(''MENGENARTS.KUERZEL'',det.mart_id,:fas_sprache_id)'||unistr('\000a')||
'         ||CASE WHEN det.mart_beschreibung is not null THEN'||unistr('\000a')||
'         ''    <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':306:'''||unistr('\000a')||
'         ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||det.mart_id||'''''',700,380)">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END mart_kuerzel,'||unistr('\000a')||
'fas_';

s:=s||'synch.get_tab_uebersetzung(''MN_REZEPTE.BEZEICHNUNG'',MART_MN_REZEPT_ID,:fas_sprache_id) '||unistr('\000a')||
'mn_rezept_bezeichnung,--det.mn_rezept_bezeichnung,'||unistr('\000a')||
'to_char(det.MART_MENGE,''999G990D0'')||'' ''||'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',e1.id,:fas_sprache_id)'||unistr('\000a')||
'mart_menge, '||unistr('\000a')||
'/*CASE WHEN :p202_verrech_land_id = 198 THEN -- 5er Runden'||unistr('\000a')||
'   to_char(rezepte.calc_preis_5runden ('||unistr('\000a')||
'           rezepte.calc_pr';

s:=s||'eis_mwst_ges(:p202_verrech_land_id,'||unistr('\000a')||
'             det.mart_prodkennz_id,det.mart_id,:p202_preisliste_id,'||unistr('\000a')||
'             :p202_art_mwst_typ_id,:p202_preisfaktor,0))'||unistr('\000a')||
'        ,''999G990D00'')||'' ''||:p202_waehrung_zeichen '||unistr('\000a')||
'ELSE'||unistr('\000a')||
'*/'||unistr('\000a')||
'   to_char(rezepte.calc_preis_mwst_ges(:p202_verrech_land_id,'||unistr('\000a')||
'             det.mart_prodkennz_id,det.mart_id,:p202_preisliste_id,'||unistr('\000a')||
'             :p202_art_mwst_typ_id, :p202_preisf';

s:=s||'aktor,:P202_PERSSTAMM_ID_PROD_APO,0)'||unistr('\000a')||
'        ,''999G990D00'')||'' ''||:p202_waehrung_zeichen '||unistr('\000a')||
'--END'||unistr('\000a')||
' stueckpreis,'||unistr('\000a')||
'fas_synch.get_tab_uebersetzung(''ENTNAHMEARTEN.BEZEICHNUNG'',det.ENTNAHMEART_ID,:fas_sprache_id) ENTNAHMEART_BEZ, --det.ENTNAHMEART_BEZ ENTNAHMEART_BEZ,'||unistr('\000a')||
'/* Mengeneingabefeld !! DB-Felder müssen gleiche Formatmask haben wg.Änderungsprüfung*/'||unistr('\000a')||
'CASE WHEN det.ENTNAHMEART_ID in (2,3) /*Teil/Stück*';

s:=s||'/ THEN'||unistr('\000a')||
'apex_item.hidden(31,to_char(det.PRODR_DET_ANZAHL2,''999G990D00''),NULL,''DB''||det.MART_ID)||'||unistr('\000a')||
'apex_item.text(24,to_char(det.PRODR_DET_ANZAHL2,''999G990D00''),8,15,''tabindex="3" autocomplete="off" class="validateProdField mart_id_'' || trim(det.MART_ID) || ''"'', det.MART_ID)'||unistr('\000a')||
'ELSE'||unistr('\000a')||
'apex_item.hidden(31,to_char(det.PRODR_DET_GEWICHT,''999G990D00''))||'||unistr('\000a')||
'apex_item.text(24,to_char(det.PRODR_DET_GEWICHT,''999G9';

s:=s||'90D00''),8,15,''class="validateProdField mart_id_'' || trim(det.MART_ID) || ''"'', det.MART_ID)'||unistr('\000a')||
'END  menge,'||unistr('\000a')||
'/* Einheiten Eingabefeld */'||unistr('\000a')||
'CASE WHEN det.ENTNAHMEART_ID in (2,3) /*Teil/Stück*/ THEN'||unistr('\000a')||
'apex_item.hidden(32,1)||'||unistr('\000a')||
'apex_item.select_list_from_query(23,1/*EH=>Stück*/,''select fas_synch.get_tab_uebersetzung(''''EINHEITEN.EH_ZEICHEN'''',id,:fas_sprache_id) eh_zeichen, id from einheiten where id = 1'',''onchan';

s:=s||'ge="javascript:   f_checkProdDetails('''''' || to_char(det.MART_ID) || '''''',html_GetElement('''''' || det.MART_ID || '''''').value, html_GetElement(''''EH'' || det.MART_ID || '''''').value)"'',''NO'',NULL,NULL,''EH''||det.MART_ID) '||unistr('\000a')||
'ELSE'||unistr('\000a')||
'apex_item.hidden(32,NVL(det.PRODR_DET_EINHEIT_ID,det.mart_menge_einheit_id))||'||unistr('\000a')||
'apex_item.select_list_from_query(23,NVL(det.PRODR_DET_EINHEIT_ID,det.mart_menge_einheit_id)/*Gewicht*/,'||unistr('\000a')||
'''';

s:=s||'select fas_synch.get_tab_uebersetzung(''''EINHEITEN.EH_ZEICHEN'''',id,:fas_sprache_id) eh_zeichen, id from einheiten where physeh_id in (5)'','||unistr('\000a')||
'''onchange="javascript:f_checkProdDetails('''''' || to_char(det.MART_ID) || '''''',html_GetElement('''''' ||det.MART_ID || '''''').value, html_GetElement(''''EH'' || det.MART_ID || '''''').value)"'',''NO'',NULL,NULL,''EH''||det.MART_ID) '||unistr('\000a')||
'END EINHEIT_ID,'||unistr('\000a')||
'det.MART_SATZ_KENNZEICHEN MART_S';

s:=s||'ATZ_KENNZEICHEN,'||unistr('\000a')||
'CASE WHEN det.ENTNAHMEART_ID in (2,3) /*Teil/Stück*/ AND'||unistr('\000a')||
'          det.PRODR_DET_GEWICHT IS NOT NULL '||unistr('\000a')||
'          AND rezepte.umrechnen_artikel_eh(det.PRODR_DET_GEWICHT,det.MART_ID,  /* Kleinsmenge */'||unistr('\000a')||
'                  det.PRODR_DET_EINHEIT_ID,500) < to_number(:P202_MIN_ARTIKELGEWICHT_GR,''99999999D99999'')'||unistr('\000a')||
'THEN'||unistr('\000a')||
'   --to_char(det.PRODR_DET_GEWICHT,''999G990D0'')||'' ''||  --NEI 18.09.13 im';

s:=s||'mer in gr anzeigen'||unistr('\000a')||
'   --  fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',e2.id,:fas_sprache_id) '||unistr('\000a')||
'''<a style="background-color:yellow" />'' ||'||unistr('\000a')||
'   to_char(rezepte.umrechnen_artikel_eh(det.PRODR_DET_GEWICHT,det.MART_ID,'||unistr('\000a')||
'                                        det.PRODR_DET_EINHEIT_ID,500),''999G990D0'')||'' ''||'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',500,:fas_sprache_id) '||unistr('\000a')||
'WHEN det.';

s:=s||'ENTNAHMEART_ID in (2,3) /*Teil/Stück*/ AND'||unistr('\000a')||
'          det.PRODR_DET_GEWICHT IS NOT NULL '||unistr('\000a')||
'THEN'||unistr('\000a')||
'   --to_char(det.PRODR_DET_GEWICHT,''999G990D0'')||'' ''||  --NEI 18.09.13 immer in gr anzeigen'||unistr('\000a')||
'   --  fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',e2.id,:fas_sprache_id) '||unistr('\000a')||
'''<a style="background-color:white" />'' ||'||unistr('\000a')||
'   to_char(rezepte.umrechnen_artikel_eh(det.PRODR_DET_GEWICHT,det.MART_ID,'||unistr('\000a')||
'             ';

s:=s||'                           det.PRODR_DET_EINHEIT_ID,500),''999G990D0'')||'' ''||'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',500,:fas_sprache_id) '||unistr('\000a')||
'ELSE ''<a style="background-color:white" />'' ||'' '''||unistr('\000a')||
'END prodr_det_gewicht'||unistr('\000a')||
'from V_PRODR_DETAILS det, einheiten e1, einheiten e2'||unistr('\000a')||
'where det.PRODR_ID = :p202_id'||unistr('\000a')||
'  and det.MART_MENGE_EINHEIT_ID = e1.id'||unistr('\000a')||
'  and det.prodr_det_einheit_id = e2.id (+)'||unistr('\000a')||
'  and ';

s:=s||'((:p202_prod_alle_anzeigen = 0 AND det.prodr_det_gewicht is not null) OR'||unistr('\000a')||
'       (:p202_prod_alle_anzeigen = 1 AND /* zusatzl. Artikel aus Sortiment */'||unistr('\000a')||
'          (det.prodr_det_gewicht is not null OR'||unistr('\000a')||
'           det.prodr_det_gewicht is null and mart_rezeptartikel = ''R'' and'||unistr('\000a')||
'           det.mart_id in (SELECT s.mengenart_id --NEI 11.02.11 Sortimentartikel'||unistr('\000a')||
'                           FROM sortiment_deta';

s:=s||'ils s'||unistr('\000a')||
'                           WHERE s.sortiment_id = :FAS_SORTIMENT_ID'||unistr('\000a')||
'                             AND s.satz_kennzeichen is null)'||unistr('\000a')||
'          )'||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by det.sortierung, NLSSORT(mn_rezept_bezeichnung, ''NLS_SORT=PUNCTUATION'') --mn_rezept_bezeichnung';

wwv_flow_api.create_report_region (
  p_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 202,
  p_name=> '&P201_REGION_TITEL_PRODDETAILS.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 32,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_when_condition=> ':P202_id is not null AND'||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_display_condition_type=> 'PLSQL_EXPRESSION',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P202_HEIGHT_PRODDETAILS.px; min-width: 620px; max-width: 620px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(548,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '1000',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'Keine Daten gefunden',
  p_query_num_rows_type=> 'ROWS_X_TO_Y',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7455332642828067 + wwv_flow_api.g_id_offset,
  p_region_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'MART_KUERZEL',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8271517510669098 + wwv_flow_api.g_id_offset,
  p_region_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'MN_REZEPT_BEZEICHNUNG',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7455411018828067 + wwv_flow_api.g_id_offset,
  p_region_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'MART_MENGE',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'RIGHT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3944425964108075 + wwv_flow_api.g_id_offset,
  p_region_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'STUECKPREIS',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'RIGHT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7455803961828067 + wwv_flow_api.g_id_offset,
  p_region_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'ENTNAHMEART_BEZ',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7740923277166895 + wwv_flow_api.g_id_offset,
  p_region_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7741715939335181 + wwv_flow_api.g_id_offset,
  p_region_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'EINHEIT_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7455611453828067 + wwv_flow_api.g_id_offset,
  p_region_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'MART_SATZ_KENNZEICHEN',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 11221306402012095 + wwv_flow_api.g_id_offset,
  p_region_id=> 7454716592828056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'PRODR_DET_GEWICHT',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'RIGHT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7484616105092904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 202,
  p_plug_name=> '&P201_REGION_TITEL_PRODREZEPT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':P202_ID is not null AND'||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_plug_header=> '<div style="min-width: 600px;max-width: 730px">'||unistr('\000a')||
''||unistr('\000a')||
'',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6746910392802923 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 10,
  p_button_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_button_name    => 'SPEICHERN',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P201_BEARB_MODUS=''BEARBEITEN'' and'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7489101804092921 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 30,
  p_button_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_button_name    => 'PROD_SPEICHERN',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P202_ID is not null AND :P201_BEARB_MODUS = ''BEARBEITEN'''||unistr('\000a')||
'AND'||unistr('\000a')||
':P202_AKT_VERSION = 1 AND -- nur akt. Vers.verÃ¤ndern '||unistr('\000a')||
':P202_STATUS not in (2,3) AND'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10824519905413340 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 1,
  p_button_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_button_name    => 'ABBRECHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 11530231953595412 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 2,
  p_button_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_button_name    => 'PATIENTENLISTE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_PATIENTENLISTE.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER'' and 1=2',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7336406093148539 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 3,
  p_button_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_button_name    => 'DruckEtikett',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_DRUCKEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> 'javascript:popUp2(''&P202_PREPARE_URL_BESTELLEN.'',1000,560);'||unistr('\000a')||
''||unistr('\000a')||
'',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P202_ID is not null and :p201_mnr_aenderbar = ''J'' and :fas_pers_aenderbar = 1 and '||unistr('\000a')||
':P201_AKT_VERSION = 1 and '||unistr('\000a')||
':p201_mnr_neuberechnen = ''N'' and'||unistr('\000a')||
':p201_mnr_neuberechnen_sorti = ''N'' and -- NEI 14.02.11 Sorti '||unistr('\000a')||
':fas_aufgerufen_von = ''BETREUER'' AND'||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */ AND'||unistr('\000a')||
':p202_PROD_REZSTATUS_ID = 2 /* nur gueltige Prodrezepte, keine'||unistr('\000a')||
'                               Arbeitsversionen */',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_button_comment=>'NEI 6.09.12 Der Button hat jetzt nur noch Druck-Funktion früher war es Drucken + Bestellen und die Maske 215 hat noch eine eigenständigen Bestellauftrag für den WK durchgeführt. Dies wird nun in der rufenden Maske über den Bestellbutton und die Verzweigung WK gemacht',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6102629415629132 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 4,
  p_button_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_WK_REGISTRIEREN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_REGISTRIEREN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P202_ID is not null and :p201_mnr_aenderbar = ''J'' and :fas_pers_aenderbar = 1 and '||unistr('\000a')||
':P201_AKT_VERSION = 1 and '||unistr('\000a')||
':p201_mnr_neuberechnen = ''N'' and'||unistr('\000a')||
':p201_mnr_neuberechnen_sorti = ''N'' and -- NEI 14.02.11 Sorti '||unistr('\000a')||
':fas_aufgerufen_von = ''BETREUER'' AND'||unistr('\000a')||
':p202_PROD_REZSTATUS_ID = 2 and /* nur gueltige Prodrezepte, keine'||unistr('\000a')||
'                               Arbeitsversionen */'||unistr('\000a')||
'(frgbg_s.check_fas_rolle(:APP_USER,''WARENKORB_VERWALTEN'')=0  OR -- Betreuer hat keine WK Rolle'||unistr('\000a')||
' frgbg_s.wk_check_zugriff (:p201_id) = 0                   -- NEI 15.10.13 für Endkunde in WK bestellen? nein'||unistr('\000a')||
') AND'||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1 = IABC-Modus */',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2057728494134473 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 5,
  p_button_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERORDNUNG',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_VERORDNUNG.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P202_ID is not null AND :P201_BEARB_MODUS = ''BEARBEITEN'''||unistr('\000a')||
'AND'||unistr('\000a')||
':P202_AKT_VERSION = 1 AND -- nur akt. Vers.verÃ¤ndern '||unistr('\000a')||
':P202_STATUS not in (2,3) and'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5553713931079714 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 5,
  p_button_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_button_name    => 'WARENKORB',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_BESTELLEN. ',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:f_checkBestelldat(''WARENKORB'',''&TEMP_PLANDATUM.'',''&TEMP_BESTELLDATUM.'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P202_ID is not null and :p201_mnr_aenderbar = ''J'' and :fas_pers_aenderbar = 1 and '||unistr('\000a')||
':P201_AKT_VERSION = 1 and '||unistr('\000a')||
':p201_mnr_neuberechnen = ''N'' and'||unistr('\000a')||
':p201_mnr_neuberechnen_sorti = ''N'' and -- NEI 14.02.11 Sorti '||unistr('\000a')||
':fas_aufgerufen_von = ''BETREUER'' AND'||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */ AND'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''WARENKORB_VERWALTEN'')> 0  AND  -- Betreuer hat WK-Rolle?'||unistr('\000a')||
'frgbg_s.wk_check_zugriff(:p201_id) = 1 and  -- NEI 15.10.13 für Endkunde in WK bestellen?'||unistr('\000a')||
':p202_PROD_REZSTATUS_ID = 2 /* nur gueltige Prodrezepte, keine'||unistr('\000a')||
'                               Arbeitsversionen */',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4541321506518656 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 6,
  p_button_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_button_name    => 'DRUCKEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_DRUCKEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P202_ID is not null and'||unistr('\000a')||
'NVL(:fas_modus_id,0) = 1 /* 1= IABC-Modus => Angebotsdruck */'||unistr('\000a')||
'AND'||unistr('\000a')||
':p202_PROD_REZSTATUS_ID = 2 /* nur gueltige Prodrezepte, keine'||unistr('\000a')||
'                              Arbeitsversionen */',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6747102833802923 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 10,
  p_button_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_VERWERFEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P201_BEARB_MODUS=''BEARBEITEN'' AND'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7488725599092920 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 10,
  p_button_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_button_name    => 'RUNDEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_RUNDEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P202_ID is not null AND :P201_BEARB_MODUS = ''BEARBEITEN'''||unistr('\000a')||
'AND'||unistr('\000a')||
':P202_AKT_VERSION = 1 AND -- nur akt. Vers.verÃ¤ndern '||unistr('\000a')||
':P202_STATUS not in (2,3) and'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7753827393615884 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 202,
  p_button_sequence=> 60,
  p_button_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_button_name    => 'PROD_CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_VERWERFEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P202_ID is not null AND :P201_BEARB_MODUS = ''BEARBEITEN'''||unistr('\000a')||
'AND'||unistr('\000a')||
':P202_AKT_VERSION = 1 AND -- nur akt. Vers.verÃ¤ndern '||unistr('\000a')||
':P202_STATUS not in (2,3) and'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5553800210085223 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.:REZEPT_IN_WK:&DEBUG.:300:P300_PERSSTAMM_ID,P300_ZURUECK_SEITE,P300_REZEPT_NR:&P201_ID.,130,&P202_REZEPT_NR.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5553713931079714+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 5,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>2058009981134475 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:203:&SESSION.::&DEBUG.::P203_REZEPT_NR:&P202_REZEPT_NR.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2057728494134473+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>10824820172413340 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>10824519905413340+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>11530518048595414 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:202,201,140,110::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>11530231953595412+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>10958007047549929 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:202:&SESSION.:FEHLERAUSGABE:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 15,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''SPEICHERN'',''PROD_SPEICHERN'',''REICHWEITE'',''REICHWEITE_BMI'',''BUT_WK_REGISTRIEREN'',''RUNDEN'') and :p202_fehlertext is not null',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 14-MRZ-2008 11:36 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4541715535535812 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_branch_name=> '',
  p_branch_action=> 'DOKUMENTEN_DRUCK.ANGEBOT?P_REZEPT_NR=&P201_REZEPT_NR.&P_REZEPT_VERSION=&P201_VERSION.&P_BETREUER_ID=&FAS_LOGIN_PERSONENSTAMM_ID.&P_IDENT_ID=&FAS_IDENTITAET_PERSSTAMM_ID.&P_APO_ID=&P02_PERSSTAMM_ID_PROD_APO.&P_PREISLISTE_ID=&P202_PREISLISTE_ID.&P_VERRECH_LAND_ID=&P202_VERRECH_LAND_ID.&P_ART_MWST_TYP_ID=&P202_ART_MWST_TYP_ID.&P_PREISFAKTOR=&P202_PREISFAKTOR.&P_MODUS=1'||unistr('\000a')||
'',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4541321506518656+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-SEP-2008 09:52 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>7544331638937714 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:202:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 24-OKT-2007 11:47 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2730404031930946 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PREPARE_URL_BESTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 970,
  p_item_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Perpare Url Bestellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2891110821477639 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_HCK_PREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 28,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>' "SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3303009372910585 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PREISLISTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 980,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisliste Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3705126354612271 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MENGE_UEBERSCHREITEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'Select frgbg_s.holen_uebersetzung(1667,:fas_sprache_id) a, 1 b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'Select frgbg_s.holen_uebersetzung(1666,:fas_sprache_id), 0 from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3924603313972203 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 27,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'  "SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3944915584180725 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_WAEHRUNG_ZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 930,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Waehrung Zeichen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3945128744184532 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MWST_SATZ1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 940,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz1',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3945624420221107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 922,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Waehrung Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3960120629643701 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_BUT_REICHWEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 51,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'REICHWEITE',
  p_prompt=>'&P201_BL_REICHWEITE.',
  p_source=>'REICHWEITE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P202_ID is not null AND :P201_BEARB_MODUS = ''BEARBEITEN'''||unistr('\000a')||
'AND'||unistr('\000a')||
':P202_AKT_VERSION = 1 AND -- nur akt. Vers.verÃ¤ndern '||unistr('\000a')||
':P202_STATUS not in (2,3) and'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3961007179743965 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_BUT_REICHWEITE_BMI',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 52,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'REICHWEITE_BMI',
  p_prompt=>'&P201_BL_REICHWEITE_BMI.',
  p_source=>'REICHWEITE_BMI',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P202_ID is not null AND :P201_BEARB_MODUS = ''BEARBEITEN'''||unistr('\000a')||
'AND'||unistr('\000a')||
':P202_AKT_VERSION = 1 AND -- nur akt. Vers.verÃ¤ndern '||unistr('\000a')||
':P202_STATUS not in (2,3) AND'||unistr('\000a')||
':fas_aufgerufen_von = ''BETREUER'' and'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')'||unistr('\000a')||
'AND 1=2 /*Deaktiviert,da Funktion zu kompliziert zu Verstehen 08.10.12*/'||unistr('\000a')||
'',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => 'BMI - Button passt nach Änderung der Reichweite die Inhstoffseite an ohne dass die Produktrezeptseite verändert wird');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3991719226326712 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PREISFAKTOR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 990,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisfaktor',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3992102481388134 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_ART_MWST_TYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1000,
  p_item_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Art Mwst Typ Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4058110892520559 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 950,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4078729399913690 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1010,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Prod Apo',
  p_source=>'frgbg_s.get_pers_option(v(''APP_USER''),21)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4228317407220125 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_AENDERBAR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 960,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'aenderbar',
  p_source=>'AENDERBAR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5898830579972933 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MIN_ARTIKELGEWICHT_GR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1020,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'min_gr',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6105804734915372 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PREPARE_URL_WK_REGISTRIER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1030,
  p_item_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6747303690802923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MN_ALLE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'Select frgbg_s.holen_uebersetzung(524,:fas_sprache_id) a, 1 b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'Select frgbg_s.holen_uebersetzung(525,:fas_sprache_id), 0 from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6747532105802925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MN_MUTDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') '||unistr('\000a')||
'FROM mn_rezepte'||unistr('\000a')||
'WHERE  id = :p201_mn_rezept_id;',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6747732617802925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_FEHLERTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 300,
  p_item_plug_id => 7099000040581456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Fehlertext',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'style="font-weight: bold; color: red"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 2,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7288222773207226 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_ID_INPUT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 7099000040581456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Inhstoff Id Input',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7306014981596700 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MNR_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 24,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'P201_BEMERKUNG',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7307627967558809 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MENGE_INPUT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 600,
  p_item_plug_id => 7099000040581456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Einheit Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7321408426852886 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MN_SPLIT_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 21,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'Select '''' a, 0 from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT '' '' ||frgbg_s.holen_uebersetzung(9202,:fas_sprache_id), 1 FROM dual   '||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7353014029624009 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_EINHEIT_ID_INPUT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 700,
  p_item_plug_id => 7099000040581456+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Einheit Id Input',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7355719871500891 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MN_REZART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'rezepte.GET_MNR_REZART_ID (:P202_REZEPT_NR,:P202_VERSION)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',id,:fas_sprache_id), id'||unistr('\000a')||
'FROM MN_REZARTEN'||unistr('\000a')||
'order by sort'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7360623165607261 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_OPERATION_OK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1040,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7484926811092909 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7485115743092909 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_REZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'REZEPT_NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7485305299092910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'VERSION',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7485527022092910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_BEZEICHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bezeichnung',
  p_source=>'BEZEICHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7485717474092910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bemerkung',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7485906394092910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PROD_REZTYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prod Reztyp Id',
  p_source=>'PROD_REZTYP_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7486128479092910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MNREZLEVEL_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mnrezlevel Id',
  p_source=>'MNREZLEVEL_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7486312189092910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PROD_REZSTATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 23,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'PROD_REZSTATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(4885,:fas_sprache_id) a, 1 b FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4884,:fas_sprache_id)  a, 2 b FROM DUAL'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4886,:fas_sprache_id)  a, 3 b FROM DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7486531280092910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_STATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status',
  p_source=>'STATUS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7486725227092912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_AKT_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Akt Version',
  p_source=>'AKT_VERSION',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Reichweite in Tagen; Produktrezept wird normalerweise für 1 Tag berechnet; Bei nicht glatten Stückentnahmen wird über die Erhöhung der Reichweite eine ganzzahlige Stückentnahme ermöglicht. Maximale Reichweite wg. Haltbarkeit 90 Tage';

wwv_flow_api.create_page_item(
  p_id=>7486909981092912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_REICHWEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'REICHWEITE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 22,
  p_cHeight=> 1,
  p_tag_attributes  => 'tabindex="2" onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'NOT (:P202_ID is not null AND :P201_BEARB_MODUS = ''BEARBEITEN'''||unistr('\000a')||
'AND'||unistr('\000a')||
':P202_AKT_VERSION = 1 AND -- nur akt. Vers.verÃ¤ndern '||unistr('\000a')||
':P202_STATUS not in (2,3) and'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Anzeige */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')'||unistr('\000a')||
''||unistr('\000a')||
')',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Abweichung in Prozent;Bei dem Versuch eine ganzzahlige Stückentnahme zu erreichen, kann eine Abweichung nötig werden, damit die max.Reichweite von 90 Tagen nicht überschritten werden muss';

wwv_flow_api.create_page_item(
  p_id=>7487417089092918 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_ABWEICHUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ABWEICHUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_help_text=> h,
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7487929303092918 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MAN_GEAENDERT_AM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Man Geaendert Am',
  p_source=>'MAN_GEAENDERT_AM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7488100294092920 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_MAN_GEAENDERT_DURCH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Man Geaendert Durch',
  p_source=>'MAN_GEAENDERT_DURCH',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7488306958092920 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_SATZ_KENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satz Kennzeichen',
  p_source=>'SATZ_KENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7488501491092920 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PRODHINWEIS2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prodhinweis2',
  p_source=>'PRODHINWEIS2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7644016292719814 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PROD_MUTDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 800,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') '||unistr('\000a')||
'FROM prod_rezepte'||unistr('\000a')||
'WHERE  id = :p201_prod_rezept_id;',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7867031434090876 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_DB_REICHWEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 900,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Db Reichweite',
  p_source=>'P202_REICHWEITE',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10143305886108373 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_GRENZWERTHINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 115,
  p_item_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select frgbg_s.holen_uebersetzung(hinweis_text_id,:fas_sprache_id)'||unistr('\000a')||
'from inh_grenzwerttypen'||unistr('\000a')||
'where id = rezepte.get_mnr_gwtyp_id(:P201_mn_rezept_id,1);',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_tag_attributes  => 'style="font-weight: bold; color: orange; font-size: 150%;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11103103873766035 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_PROD_ALLE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 7454716592828056+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'Select frgbg_s.holen_uebersetzung(1520,:fas_sprache_id) a, 1 b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'Select frgbg_s.holen_uebersetzung(1519,:fas_sprache_id), 0 from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '2',
  p_attribute_02 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>11571931005091923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>':P201_NAME ||'' ''||:P201_VORNAME||'' ''||:P201_GEBURTSDATUM',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11591025006232150 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_REZEPT_NR_VRS_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 11,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>':P202_REZEPT_NR || ''/''||:P202_VERSION||'' ''||:P201_NAME ||'' ''||:P201_VORNAME||'' ''||:P201_GEBURTSDATUM||'' ''||:P201_ID',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11694624798367539 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_GESAMTGEWICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 25,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11696704975380814 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_GESAMTVOLUMEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 26,
  p_item_plug_id => 7484616105092904+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'   "SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12241531571659317 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_HEIGHT_INHSTOFFE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 910,
  p_item_plug_id => 6745205745802917+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12242106421661492 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 202,
  p_name=>'P202_HEIGHT_PRODDETAILS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 920,
  p_item_plug_id => 7454716592828056+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7363132467281753 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_mnr_details',
  p_validation_sequence=> 5,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_neue_zeile varchar2(10) := ''<br/>''; '||unistr('\000a')||
'   v_min NUMBER;'||unistr('\000a')||
'   v_max NUMBER;'||unistr('\000a')||
'   v_zahl NUMBER;'||unistr('\000a')||
'   v_db_menge NUMBER;'||unistr('\000a')||
'   v_menge_input VARCHAR2(2000);'||unistr('\000a')||
'   v_sprache_id number := :fas_sprache_id;'||unistr('\000a')||
'   v_change  NUMBER := 0;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P(''MNR-Details validieren i=%1'',v_prot_id,''Info'',''MNR-Details validieren''  ,apex_application.g_f01.count);'||unistr('\000a')||
'   for i in 1..apex_application.g_f01.count  loop'||unistr('\000a')||
'     v_menge_input := NVL(trim(apex_application.g_f04(i)),0);'||unistr('\000a')||
'     IF v_menge_input is not null then '||unistr('\000a')||
'        v_zahl := NULL;'||unistr('\000a')||
'        -- Nur tatsächl. Änderungen prüfen u.später abspeichern mit Relevant R'||unistr('\000a')||
'        v_db_menge := rezepte.convert_to_number(apex_application.g_f14(i),''999G999G999D99999'');   '||unistr('\000a')||
'        IF apex_application.g_f13(i) != apex_application.g_f03(i)   '||unistr('\000a')||
'        THEN '||unistr('\000a')||
'           v_change := 1;  -- Einheit geändert'||unistr('\000a')||
'           -- EH-DB in angezeigte EH umrechnen'||unistr('\000a')||
'           v_db_menge := rezepte.umrechnen_inh_eh(v_db_menge,apex_application.g_f01(i),apex_application.g_f13(i),apex_application.g_f03(i));'||unistr('\000a')||
'        END IF;'||unistr('\000a')||
'        -- Speichern damit beim Speichern nicht nochmals DB-Werte an Input-Werte '||unistr('\000a')||
'        -- angepasst werden müssen, um tatsächl. Änderungen zu erkennen'||unistr('\000a')||
'        apex_application.g_f14(i) := v_db_menge;'||unistr('\000a')||
'        apex_application.g_f13(i) := apex_application.g_f03(i);'||unistr('\000a')||
'        v_zahl := rezepte.convert_to_number(v_menge_input,''999G999G999D99999''); '||unistr('\000a')||
'        -- Konvertierte Zahl wieder merken für das Speichern'||unistr('\000a')||
'        apex_application.g_f04(i) := v_zahl;    '||unistr('\000a')||
'        IF v_zahl is NULL THEN'||unistr('\000a')||
'           -- Keine gültige Zahl'||unistr('\000a')||
'           v_fehlertext := v_fehlertext||v_neue_zeile||frgbg_s.holen_uebersetzung(551,v_sprache_id,v_menge_input,apex_application.g_f12(i)); '||unistr('\000a')||
'        ELSE'||unistr('\000a')||
'           -- Nur geänderte Werte prüfen'||unistr('\000a')||
'           IF v_zahl != NVL(v_db_menge,0) THEN'||unistr('\000a')||
'              v_change := 1;       -- Menge geändert'||unistr('\000a')||
'              IF v_zahl <> 0 THEN'||unistr('\000a')||
'                 -- Wertebereichsprüfung'||unistr('\000a')||
'                 v_max := rezepte.umrechnen_inh_eh'||unistr('\000a')||
'                      (apex_application.g_f16(i),apex_application.g_f01(i),apex_application.g_f17(i),apex_application.g_f03(i));'||unistr('\000a')||
'                 v_min := 0;'||unistr('\000a')||
'                 IF v_zahl > v_max OR'||unistr('\000a')||
'                    v_zahl < v_min'||unistr('\000a')||
'                 THEN'||unistr('\000a')||
'                    v_fehlertext := v_fehlertext || v_neue_zeile|| '||unistr('\000a')||
'                            frgbg_s.holen_uebersetzung(550,v_sprache_id,v_menge_input,apex_application.g_f12(i),trim(to_char(v_min,''FM999G999G990D0999'')),'||unistr('\000a')||
'                            trim(to_char(v_max,''FM999G999G990D0999'')));'||unistr('\000a')||
'                 END IF; -- im Wertebereich ?'||unistr('\000a')||
'              END IF; -- Wert <> 0?'||unistr('\000a')||
'           ELSE'||unistr('\000a')||
'              IF :p202_id IS NULL THEN  '||unistr('\000a')||
'                 -- es existiert kein Prodrezept => Speichern zulassen damit'||unistr('\000a')||
'                 -- Prodrezept generiert werden kann'||unistr('\000a')||
'                 v_change := 1;'||unistr('\000a')||
'              END IF;'||unistr('\000a')||
'           END IF; -- geänderter Wert?'||unistr('\000a')||
'        END IF; -- gültige Zahl?  '||unistr('\000a')||
'     END IF; -- Wert eingegeben?'||unistr('\000a')||
'   end loop;'||unistr('\000a')||
'   -- Fehlertext wird erst am Anfang vom Speichern ausgewertet und mit Raise angezeigt'||unistr('\000a')||
'   :p202_fehlertext := v_fehlertext;'||unistr('\000a')||
' '||unistr('\000a')||
'   IF v_change = 0 THEN  -- Keine Daten geändert'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(2020,v_sprache_id ));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 6746910392802923 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7801722140978717 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_prod_details',
  p_validation_sequence=> 20,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_neue_zeile      varchar2(10) := ''<br/>''; '||unistr('\000a')||
'   v_zahl  NUMBER;'||unistr('\000a')||
'   v_menge_input    varchar2(2000);'||unistr('\000a')||
'   v_db_menge NUMBER;'||unistr('\000a')||
'   v_change  NUMBER := 0;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'   v_fehlertext  VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/* Doku:'||unistr('\000a')||
'   ,apex_application.g_f21(v_count)        -- mart_id'||unistr('\000a')||
'   ,apex_application.g_f22(v_count)        -- prodr_det_id '||unistr('\000a')||
'   ,apex_application.g_f23(v_count)        -- einheit_id'||unistr('\000a')||
'   ,apex_application.g_f24(v_count)        -- menge'||unistr('\000a')||
'   ,apex_application.g_f25(v_count)        -- Entnahmeart_id'||unistr('\000a')||
'   ,apex_application.g_f26(v_count)        -- prodr_det_einheit_id'||unistr('\000a')||
'   ,apex_application.g_f27(v_count)        -- prodr_det_gewicht'||unistr('\000a')||
'   ,apex_application.g_f28(v_count)        -- mart_kuerzel'||unistr('\000a')||
'*/'||unistr('\000a')||
'--MEL.P(''ProdR-Details validieren i=%1'',v_prot_id,''Info'',''ProdR-Details val.'''||unistr('\000a')||
'--          ,apex_application.g_f21.count);'||unistr('\000a')||
'   for i in 1..apex_application.g_f21.count  loop'||unistr('\000a')||
'/*      MEL.P'||unistr('\000a')||
'         (''ProdR-Details validieren i=%9 f21 %1, f22 %2,f23 %3, f24 %4, f25 %5, f26 %6,f27 %7,f28 %8'','||unistr('\000a')||
'           v_prot_id,'||unistr('\000a')||
'           ''Info'','||unistr('\000a')||
'           ''ProdR-Details validieren'''||unistr('\000a')||
'           ,apex_application.g_f21(i)'||unistr('\000a')||
'           ,apex_application.g_f22(i)'||unistr('\000a')||
'           ,apex_application.g_f23(i)'||unistr('\000a')||
'           ,apex_application.g_f24(i)'||unistr('\000a')||
'           ,apex_application.g_f25(i)'||unistr('\000a')||
'           ,apex_application.g_f26(i)'||unistr('\000a')||
'           ,apex_application.g_f27(i)'||unistr('\000a')||
'           ,apex_application.g_f28(i)'||unistr('\000a')||
'           ,i'||unistr('\000a')||
');'||unistr('\000a')||
'*/   v_menge_input := NVL(trim(apex_application.g_f24(i)),0); '||unistr('\000a')||
'     IF v_menge_input is not null then '||unistr('\000a')||
'        v_zahl := NULL;'||unistr('\000a')||
'        v_db_menge := rezepte.convert_to_number(apex_application.g_f31(i),'||unistr('\000a')||
'                                            ''999G999G999D99999'');   '||unistr('\000a')||
'        IF apex_application.g_f32(i) != apex_application.g_f23(i)  --EH geänd.? '||unistr('\000a')||
'        THEN '||unistr('\000a')||
'           v_change := 1;  -- Einheit geändert'||unistr('\000a')||
'           -- EH-DB in angezeigte EH umrechnen'||unistr('\000a')||
'           v_db_menge := rezepte.umrechnen_artikel_eh'||unistr('\000a')||
'              (v_db_menge,apex_application.g_f21(i),         '||unistr('\000a')||
'               apex_application.g_f32(i),apex_application.g_f23(i));'||unistr('\000a')||
'        END IF;'||unistr('\000a')||
'        -- Speichern damit beim Speichern nicht nochmals DB-Werte an Input-Werte '||unistr('\000a')||
'        -- angepasst werden müssen, um tatsächl. Änderungen zu erkennen'||unistr('\000a')||
'        apex_application.g_f31(i) := v_db_menge;'||unistr('\000a')||
'        apex_application.g_f32(i) := apex_application.g_f23(i);'||unistr('\000a')||
''||unistr('\000a')||
'        v_zahl := rezepte.convert_to_number(v_menge_input,'||unistr('\000a')||
'                                            ''999G999G999D99999'');'||unistr('\000a')||
'        -- Konvertierte Zahl wieder merken für das Speichern'||unistr('\000a')||
'        apex_application.g_f24(i) := v_zahl;  '||unistr('\000a')||
''||unistr('\000a')||
'        IF v_zahl is NULL THEN'||unistr('\000a')||
'           -- Keine gültige Zahl'||unistr('\000a')||
'          v_fehlertext := v_fehlertext ||v_neue_zeile|| '||unistr('\000a')||
'                   frgbg_s.holen_uebersetzung(575,v_sprache_id,'||unistr('\000a')||
'                        v_menge_input,apex_application.g_f28(i)); '||unistr('\000a')||
'        ELSE'||unistr('\000a')||
'           -- Nur geänderte Werte prüfen'||unistr('\000a')||
'           IF v_zahl != NVL(v_db_menge,0) THEN'||unistr('\000a')||
'              v_change := 1;       -- Menge geändert'||unistr('\000a')||
'           END IF;  '||unistr('\000a')||
'        END IF; -- Zahl?'||unistr('\000a')||
'     END IF; -- Wert eingegeben?  '||unistr('\000a')||
'   end loop;'||unistr('\000a')||
'   -- Fehlertext wird erst am Anfang vom Speichern ausgewertet und mit Raise angezeigt'||unistr('\000a')||
'   :p202_fehlertext := v_fehlertext;'||unistr('\000a')||
'   /* NEI 11.07.11 nicht mehr erforderlich, da Änderungen sofort'||unistr('\000a')||
'      gespeichert werden und ein Speichern, um die Arbeitsversion zur '||unistr('\000a')||
'      gültigen Version zu machen, möglich sein soll.'||unistr('\000a')||
'   */'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_change = 0 -- Keine Daten geändert'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(2020,v_sprache_id ));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''PROD_SPEICHERN'',''PROD_SPEICHERN_ARBEITSVERSION'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7875925659297365 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_reichweite',
  p_validation_sequence=> 30,
  p_validation => 'DECLARE '||unistr('\000a')||
'   v_max_reichweite NUMBER ;'||unistr('\000a')||
'   v_min_reichweite NUMBER ;'||unistr('\000a')||
'   v_anz            NUMBER ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT parameter INTO v_max_reichweite'||unistr('\000a')||
'      FROM sysareas'||unistr('\000a')||
'      WHERE id = 5;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN'||unistr('\000a')||
'      v_max_reichweite := 120 ;  -- Default, falls Zugriff fehlschlaegt'||unistr('\000a')||
'   END ;'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT parameter INTO v_min_reichweite'||unistr('\000a')||
'      FROM sysareas'||unistr('\000a')||
'      WHERE id = 12;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN'||unistr('\000a')||
'      v_min_reichweite := 15;  -- Default, falls Zugriff fehlschlaegt'||unistr('\000a')||
'   END ;'||unistr('\000a')||
'   IF :p202_reichweite IS NULL THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(585,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :p202_reichweite < v_min_reichweite OR '||unistr('\000a')||
'      :p202_reichweite > v_max_reichweite '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --RETURN (''Die Reichweite muss zwischen 1 und 90 Tagen liegen!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(584,:fas_sprache_id,'||unistr('\000a')||
'                                            v_max_reichweite,v_min_reichweite));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :p202_reichweite = :p202_db_reichweite THEN'||unistr('\000a')||
'      --RETURN (''Die Reichweite wurde nicht geändert!'');'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(583,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 3960120629643701 + wwv_flow_api.g_id_offset,
  p_associated_item=> 7486909981092912 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7656807147361741 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_reichweite_chg_offene_bestell',
  p_validation_sequence=> 40,
  p_validation => 'DECLARE '||unistr('\000a')||
'   v_return NUMBER ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- NEI 28.02.2014 Reichweite ändern, nur wenn es keine offenen Bestellungen gibt'||unistr('\000a')||
'   v_return := frgbg_s.WK_CHECK_OFFENE_MNR_BESTELL(:P202_REZEPT_NR,:P202_VERSION,NULL);'||unistr('\000a')||
'   IF v_return != 0 THEN '||unistr('\000a')||
'      -- ''Es existiert zu diesem Rezept eine offene Bestellung! Eine Änderung der Reichweite ist daher zur Zeit nicht möglich.'');'||unistr('\000a')||
'      RETURN (frgbg_s.holen_uebersetzung(9599,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 3960120629643701 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7533827919632630 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_name => 'Check Inhaltsstoffe'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.validateField'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7534127994632630 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_event_id => 7533827919632630 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 5
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => ''||unistr('\000a')||
'$(''#AjaxLoadingBGShow'').click(); // Zeige ein Wartesymbol'||unistr('\000a')||
''||unistr('\000a')||
'var cls = $(this.triggeringElement).attr(''class'');'||unistr('\000a')||
'// Inhstoff-ID ist in der Klasse versteckt'||unistr('\000a')||
'var inh_id = cls.substr(cls.indexOf(''inh_id_'') + ''inh_id_''.length);'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'// Muss asynchron sein, da sonst der IE das Loading-Icon nicht anzeigt'||unistr('\000a')||
'var callFunc = "f_checkDetails(''" + inh_id + "'',''" + $.trim($x(inh_id).value) + "'',''" + $x(''EH'' + inh_id).value + "'')"'||unistr('\000a')||
''||unistr('\000a')||
'window.setTimeout(callFunc, 1);'||unistr('\000a')||
''
 ,p_stop_execution_on_error => 'Y'
 ,p_da_action_comment => '#IMAGE_PREFIX#themes/&FAS_THEME_NAME./ajax-loader.gif'||unistr('\000a')||
''||unistr('\000a')||
'default'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7544209638583084 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_name => 'Check Produkte'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.validateProdField'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7544509975583085 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_event_id => 7544209638583084 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 5
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => ''||unistr('\000a')||
'$(''#AjaxLoadingBGShow'').click(); // Zeige ein Wartesymbol'||unistr('\000a')||
''||unistr('\000a')||
'var cls = $(this.triggeringElement).attr(''class'');'||unistr('\000a')||
''||unistr('\000a')||
'var mart_id = cls.substr(cls.indexOf(''mart_id_'') + ''mart_id_''.length);'||unistr('\000a')||
''||unistr('\000a')||
'//alert(inh_id);'||unistr('\000a')||
'// Muss asynchron sein, da sonst der IE das Loading-Icon nicht anzeigt'||unistr('\000a')||
'var callFunc = "f_checkProdDetails(''" + mart_id + "'',''" + $.trim($x(mart_id).value) + "'',''" + $.trim($x(''EH'' + mart_id).value) + "'')";'||unistr('\000a')||
''||unistr('\000a')||
'//alert(callFunc);'||unistr('\000a')||
''||unistr('\000a')||
'window.setTimeout(callFunc, 1);'||unistr('\000a')||
''
 ,p_stop_execution_on_error => 'Y'
 ,p_da_action_comment => '#IMAGE_PREFIX#themes/&FAS_THEME_NAME./ajax-loader.gif'||unistr('\000a')||
''||unistr('\000a')||
'default'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7527105784153156 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_name => 'Verlasse Eingabefelder Inhaltsstoffe'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.t1Button'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'mouseenter'
 ,p_da_event_comment => 'Wird benötigt, damit vor dem Button-Click die Eingabefelder von Inhaltsstoffen verlassen werden und deren Validierung gestartet wird. Wird das nicht gemacht, kann es sein das sie Validierung den eigentlichen Button-Click überlagert und es dadurch so wirkt, als müsste man zweimal auf Speichern klicken um wirklich zu Speichern.'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7527413509153156 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_event_id => 7527105784153156 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'if($(''#P202_PROD_ALLE_ANZEIGEN_0'').length > 0) {'||unistr('\000a')||
' '||unistr('\000a')||
'  $(''#P202_PROD_ALLE_ANZEIGEN_0'').focus();'||unistr('\000a')||
'} else {'||unistr('\000a')||
'  if($(''#P202_MENGE_UEBERSCHREITEN_0'').length >0) {'||unistr('\000a')||
'  '||unistr('\000a')||
'   $(''#P202_MENGE_UEBERSCHREITEN_0'').focus();'||unistr('\000a')||
'  }'||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7520124972543735 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_name => 'Speichern Produktseite'
 ,p_event_sequence => 60
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 7489101804092921 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7520417239543753 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_event_id => 7520124972543735 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'PROD_SPEICHERN'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7521719178598834 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_name => 'Speichern Inhaltstoffseite'
 ,p_event_sequence => 90
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 6746910392802923 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7522029482598835 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 202
 ,p_event_id => 7521719178598834 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'SPEICHERN'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|PIS:V_PROD_REZEPTE:P202_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 7493812473129620 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'fetch produkt_rezept',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE  '||unistr('\000a')||
'   v_preisliste_id    number;'||unistr('\000a')||
'   v_waehrung_id      v_laender.id_waehrung_verrech%TYPE;'||unistr('\000a')||
'   v_waehrung_zeichen VARCHAR2(5);'||unistr('\000a')||
'   v_eh_zeichen       VARCHAR2(10);'||unistr('\000a')||
'   v_gesamtpreis      NUMBER;'||unistr('\000a')||
'   v_mwst_betrag      NUMBER;'||unistr('\000a')||
'   v_mwst_satz1       v_laender.mwst_satz1%TYPE;'||unistr('\000a')||
'   v_hck_preis        NUMBER;'||unistr('\000a')||
'   v_hck_mwst_betrag  NUMBER;'||unistr('\000a')||
'   v_hck_mwst_satz    v_laender.mwst_satz1%TYPE;'||unistr('\000a')||
'   v_verrech_';

p:=p||'land_id  v_laender.id%TYPE;'||unistr('\000a')||
'   v_art_mwst_typ_id          number; '||unistr('\000a')||
'   v_preisfaktor      number;'||unistr('\000a')||
'   v_persstamm_id_prod_apo personenstamm.id%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'   v_return           NUMBER;'||unistr('\000a')||
'   v_prot_id          NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P202_id IS NOT NULL THEN'||unistr('\000a')||
'      v_eh_zeichen := fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',500,:fas_sprache_id);'||unistr('\000a')||
'      -- Gewicht und Volumen nur für den HCK-Mischungsan';

p:=p||'teil'||unistr('\000a')||
'      :p202_gesamtgewicht := '||unistr('\000a')||
'              to_char(rezepte.calc_gewicht_prod(:P202_id,'||unistr('\000a')||
'                                                NULL, -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                                1),'||unistr('\000a')||
'                      ''999G999G990'')'||unistr('\000a')||
'              ||'' ''||v_eh_zeichen;'||unistr('\000a')||
''||unistr('\000a')||
'       v_eh_zeichen := fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',406,:fas_sprache_id';

p:=p||');'||unistr('\000a')||
'      :p202_gesamtvolumen := '||unistr('\000a')||
'              to_char(rezepte.calc_volumen_prod(:P202_id,'||unistr('\000a')||
'                                                NULL, -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                                1),'||unistr('\000a')||
'                      ''999G999G990'')                             '||unistr('\000a')||
'              ||'' ''||v_eh_zeichen;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Preisberechnung'||unistr('\000a')||
'/* NEI 6.4.09 neu'||unistr('\000a')||
'      v_return := rezepte.';

p:=p||'calc_preisberechnung(:P202_ID,   -- Prodrezept'||unistr('\000a')||
'                                               :p201_id,:FAS_LOGIN_PERSONENSTAMM_ID, '||unistr('\000a')||
'                                               :p201_verrechnungsland,'||unistr('\000a')||
'                                               v_gesamtpreis,'||unistr('\000a')||
'                                               v_mwst_betrag,'||unistr('\000a')||
'                                               v_mwst_satz1,'||unistr('\000a')||
'           ';

p:=p||'                                    v_waehrung_id'||unistr('\000a')||
'                                              );'||unistr('\000a')||
'*/'||unistr('\000a')||
'      v_persstamm_id_prod_apo := frgbg_s.get_pers_option(v(''APP_USER''),21);'||unistr('\000a')||
'      :P202_PERSSTAMM_ID_PROD_APO := v_persstamm_id_prod_apo;'||unistr('\000a')||
'      v_return := rezepte.CALC_GES_PREISBERECH('||unistr('\000a')||
'                         :P202_ID,   -- Prodrezept'||unistr('\000a')||
'                         :p201_id,                     -- Kun';

p:=p||'de'||unistr('\000a')||
'                         :FAS_LOGIN_PERSONENSTAMM_ID,  -- Login (Betreuer od. Kunde)'||unistr('\000a')||
'                         :FAS_IDENTITAET_PERSSTAMM_ID ,-- aktive Identitaet  NEI 08.03.2012'||unistr('\000a')||
'                         v_persstamm_id_prod_apo,      -- prod. Apo          NEI 08.03.2012'||unistr('\000a')||
'                         v_persstamm_id_prod_apo,      -- Rechsteller: def.Prod Apo  NEI 08.03.2012 '||unistr('\000a')||
'                         --';

p:=p||' :p201_verrechnungsland,    -- NEI 08.03.2012'||unistr('\000a')||
'                         v_gesamtpreis,'||unistr('\000a')||
'                         v_mwst_betrag,'||unistr('\000a')||
'                         v_waehrung_id,'||unistr('\000a')||
'                         v_verrech_land_id,'||unistr('\000a')||
'                         v_preisliste_id,'||unistr('\000a')||
'                         v_art_mwst_typ_id,'||unistr('\000a')||
'                         v_preisfaktor'||unistr('\000a')||
'                        );'||unistr('\000a')||
'      /* NEI 12.10.09 wird bereits in ';

p:=p||'calc_ges_preisberech ermittelt, '||unistr('\000a')||
'         evt. wg. zurückgreifen Std-preisliste auch angepasst '||unistr('\000a')||
'      :p202_verrech_land_id := rezepte.get_land_id_verr(:p201_id,:FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                           :p201_verrechnungsland);  -- wird noch für Artikelliste genutzt'||unistr('\000a')||
'      */'||unistr('\000a')||
'      :p202_preisliste_id := v_preisliste_id;'||unistr('\000a')||
'      :p202_verrech_land_id :=v_verrech_land_id; '||unistr('\000a')||
'      :p202_ar';

p:=p||'t_mwst_typ_id := v_art_mwst_typ_id;'||unistr('\000a')||
'      :p202_preisfaktor := v_preisfaktor;  '||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.p(''PL %1, Verrechland %2, mwsttyp %3, preisfaktor %4'','||unistr('\000a')||
'v_prot_id,''Info'',''202/gewichte_vol_menge_preis_setzen'',v_preisliste_id,v_verrech_land_id,v_art_mwst_typ_id,v_preisfaktor);   '||unistr('\000a')||
'*/'||unistr('\000a')||
'      -- Währungszeichen holen'||unistr('\000a')||
'      v_waehrung_zeichen := rezepte.get_waehrung_zeichen(v_waehrung_id);'||unistr('\000a')||
''||unistr('\000a')||
'      :p202_waehrung_id ';

p:=p||':= v_waehrung_id;'||unistr('\000a')||
'      :p202_waehrung_zeichen := v_waehrung_zeichen;'||unistr('\000a')||
''||unistr('\000a')||
'/* 01.10.09 artikelspez. MWST-Sätze'||unistr('\000a')||
'      -- NEI 6.4.09 MWST-Satz wird bestimmt aus dem Land, da noch keine artikelspezifischen '||unistr('\000a')||
'      -- Mwstsätze vorhanden sind und bei der Preisberechnung allerdings kein eindeutiger Satz mehr '||unistr('\000a')||
'      -- ermittelt werden kann => Wird nur verwendet in der Artikelliste zur Preisanzeige'||unistr('\000a')||
'      :p2';

p:=p||'02_mwst_satz1 := rezepte.get_mwst_satz(:p202_verrech_land_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      IF v_return < 0 THEN  -- Preisberechnung hatte Fehler'||unistr('\000a')||
'          :p202_gesamtpreis := ''<br/>''||frgbg_s.holen_uebersetzung(2175,:fas_sprache_id);'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p202_gesamtpreis := '||unistr('\000a')||
'            to_char(v_gesamtpreis,''999G999G990D00'')||'' ''||'||unistr('\000a')||
'            v_waehrung_zeichen||'' ''||frgbg_s.holen_uebersetzung(1874,:fas_sprache_i';

p:=p||'d);'||unistr('\000a')||
''||unistr('\000a')||
'         -- HCK-Preisanteil (tatsächl. Mischung) bestimmen'||unistr('\000a')||
'         /* 04.06.2014 Berechnung HCK-Anteil auf Splitkomponenten umgestellt und nicht via Gesamtrezept wg. Preisdifferenzen'||unistr('\000a')||
'         v_return := rezepte.calc_preis_mwst_prod(:P202_ID,   -- Prodrezept'||unistr('\000a')||
'                                             NULL,                    -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                 ';

p:=p||'            :p202_verrech_land_id,'||unistr('\000a')||
'                                             1, -- HCK-Mischung'||unistr('\000a')||
'                                             NULL, -- Kein spez. Artikel sondern alle HCK''s'||unistr('\000a')||
'                                             v_preisliste_id,'||unistr('\000a')||
'                                             v_art_mwst_typ_id,'||unistr('\000a')||
'                                             v_preisfaktor,'||unistr('\000a')||
'                       ';

p:=p||'                      v_persstamm_id_prod_apo, -- NEI 04.03.13 Mwstbest(nicht mehr) NEI 30.5.14 sondern wg. Rabattstaffelgruppe bei Mischungen'||unistr('\000a')||
'                                             0,                       -- NEI 28.03.14 ohne Rundung ganzer Packungen bei Fertigartikeln der Mischung'||unistr('\000a')||
'                                             v_hck_preis,'||unistr('\000a')||
'                                             v_hck_';

p:=p||'mwst_betrag,'||unistr('\000a')||
'                                             v_hck_mwst_satz'||unistr('\000a')||
'                                             );'||unistr('\000a')||
'         */'||unistr('\000a')||
'         v_return := rezepte.calc_preis_mwst_prod_split(:P202_ID,   -- Prodrezept'||unistr('\000a')||
'                                             NULL,                    -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                             :p202_verrech_land_id,'||unistr('\000a')||
'              ';

p:=p||'                               1, -- HCK-Mischung'||unistr('\000a')||
'                                             NULL, -- Kein spez. Artikel sondern alle HCK''s'||unistr('\000a')||
'                                             v_preisliste_id,'||unistr('\000a')||
'                                             v_art_mwst_typ_id,'||unistr('\000a')||
'                                             v_preisfaktor,'||unistr('\000a')||
'                                             v_persstamm_id_prod_apo, --';

p:=p||' NEI 04.03.13 Mwstbest(nicht mehr) NEI 30.5.14 sondern wg. Rabattstaffelgruppe bei Mischungen'||unistr('\000a')||
'                                             0,                       -- NEI 28.03.14 ohne Rundung ganzer Packungen bei Fertigartikeln der Mischung'||unistr('\000a')||
'                                             1,                       -- alle Rezepte aus Split berücksichtigen'||unistr('\000a')||
'                                             0';

p:=p||',                       -- NEI 18.06.14 keine Reichweitenstaffel-Rabattberechnung (=0) für Mischungen,'||unistr('\000a')||
'                                                                      --              nur  noch im WK und auf Bestellschein sonst keine Rabattrechnung'||unistr('\000a')||
'                                             v_hck_preis,'||unistr('\000a')||
'                                             v_hck_mwst_betrag,'||unistr('\000a')||
'                        ';

p:=p||'                     v_hck_mwst_satz'||unistr('\000a')||
'                                             );'||unistr('\000a')||
'         :p202_hck_preis := to_char(NVL(v_hck_preis+v_hck_mwst_betrag,0),''999G999G990D00'')||'' ''||'||unistr('\000a')||
'            v_waehrung_zeichen||'' ''||frgbg_s.holen_uebersetzung(1874,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3924324868959525 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 90,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gewichte_vol_menge_preis_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_mutdat         varchar2(50);'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'   v_zahl           number;'||unistr('\000a')||
'begin'||unistr('\000a')||
'/* Doku:'||unistr('\000a')||
'   ,apex_application.g_f01(v_count)        -- inh_id'||unistr('\000a')||
'   ,apex_application.g_f02(v_count)        -- mn_id '||unistr('\000a')||
'   ,apex_application.g_f03(v_count)        -- mn_einheit_id input'||unistr('\000a')||
'   ,';

p:=p||'apex_application.g_f04(v_count)        -- mn_menge input'||unistr('\000a')||
'   ,apex_application.g_f05(v_count)        -- mn_bemerkung'||unistr('\000a')||
'   ,apex_application.g_f06(v_count)        -- mn_menge_tag_sicher'||unistr('\000a')||
'   ,apex_application.g_f07(v_count)        -- mn_menge_tag_max'||unistr('\000a')||
'   ,apex_application.g_f08(v_count)        -- mn_menge_tag_min'||unistr('\000a')||
'   ,apex_application.g_f09(v_count)        -- mn_einheit_id_tag_sicher'||unistr('\000a')||
'   ,apex_application.';

p:=p||'g_f10(v_count)        -- mn_einheit_id_tag_max'||unistr('\000a')||
'   ,apex_application.g_f11(v_count)        -- mn_einheit_id_tag_min'||unistr('\000a')||
'   ,apex_application.g_f12(v_count)        -- inhstoff_bezeichnung'||unistr('\000a')||
'   ,apex_application.g_f13(v_count)        -- mn_einheit_id DB'||unistr('\000a')||
'   ,apex_application.g_f14(v_count)        -- mn_menge DB'||unistr('\000a')||
'   ,apex_application.g_f15(v_count)        -- rezeptrelevant '||unistr('\000a')||
'   ,apex_application.g_f16(v_count)';

p:=p||'        -- inh_maximalwert'||unistr('\000a')||
'   ,apex_application.g_f17(v_count)        -- inh_einheit_id'||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :p202_fehlertext IS NOT NULL THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,:p202_fehlertext);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Prüfen, ob Rezept zwischenzeitlich geändert wurde'||unistr('\000a')||
'   SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'   FROM mn_rezepte'||unistr('\000a')||
'   WHERE  id = :p201_mn_rezept_id;'||unistr('\000a')||
'   IF v_mutdat != :p202_mn';

p:=p||'_mutdat THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      -- Zuvor Rezeptkopf speichern, falls neue Version z.B. bei rückgerechnet gebildet werden muss'||unistr('\000a')||
'      -- Dummy-Update'||unistr('\000a')||
'      UPDATE v_mn_rezepte'||unistr('\000a')||
'      SET    bezeichnung = bezeichnung'||unistr('\000a')||
'      WHERE id = :p201_mn_rezept_id;'||unistr('\000a')||
' '||unistr('\000a')||
'      -- Falls rückberechnetes Rezept gespeichert wird,';

p:=p||' gibts neue Version => Neue ID holen'||unistr('\000a')||
'      select id, bezeichnung, bemerkung,rezept_nr, version ,akt_version,mn_reztyp_id  '||unistr('\000a')||
'      into :p201_mn_rezept_id,:p201_bezeichnung,:p201_bemerkung,:p201_rezept_nr,:p201_version,'||unistr('\000a')||
'           :p201_akt_version,:p201_mn_reztyp_id '||unistr('\000a')||
'      from v_mn_rezepte '||unistr('\000a')||
'      where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'        and version = rezepte.get_mnr_max_version(:p201_rezept_nr);';

p:=p||''||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others then'||unistr('\000a')||
'       v_fehlertext := SQLERRM;'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                                  v_fehlertext,''speichern_details'''||unistr('\000a')||
'                                ));'||unistr('\000a')||
'   END;   '||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'   -- evt. vorhandenes Produktrezept holen'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT id INTO :p201_prod_rezept_id'||unistr('\000a')||
'      FROM prod_rezepte'||unistr('\000a')||
'      WHERE ve';

p:=p||'rsion = :p201_version'||unistr('\000a')||
'        AND rezept_nr = :p201_rezept_nr;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN no_data_found THEN'||unistr('\000a')||
'        :p201_prod_rezept_id := NULL;'||unistr('\000a')||
'   WHEN others then'||unistr('\000a')||
'        NULL;--RAISE_APPLICATION_ERROR (-20001,frgbg_s.holen_uebersetzung(528,v_sprache_id));'||unistr('\000a')||
'   END;'||unistr('\000a')||
'*/  '||unistr('\000a')||
'--MEL.P(''MNR-Details speichern Nr %1'',v_prot_id,''Info'',''MNR-Details speichern'','||unistr('\000a')||
'--       apex_application.g_f01.count);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Detai';

p:=p||'ls speichern'||unistr('\000a')||
'   for v_count in 1..apex_application.g_f01.count'||unistr('\000a')||
'   loop '||unistr('\000a')||
'/*MEL.P(''MNR-Details speichern f01 %1, f02 %2, f03 %3,f04 %4, f05 %5, f06 %6,f07 %7,f08 %8,ANz: %9'','||unistr('\000a')||
'           v_prot_id,'||unistr('\000a')||
'           ''Info'','||unistr('\000a')||
'           ''MNR-Details speichern'','||unistr('\000a')||
'           apex_application.g_f01(v_count),'||unistr('\000a')||
'           apex_application.g_f02(v_count),'||unistr('\000a')||
'           apex_application.g_f03(v_count),'||unistr('\000a')||
'           apex_ap';

p:=p||'plication.g_f04(v_count),'||unistr('\000a')||
'           apex_application.g_f05(v_count),'||unistr('\000a')||
'           apex_application.g_f06(v_count),'||unistr('\000a')||
'           apex_application.g_f07(v_count),'||unistr('\000a')||
'           apex_application.g_f08(v_count),'||unistr('\000a')||
'           to_char(v_count));'||unistr('\000a')||
'*/'||unistr('\000a')||
'      v_zahl := to_number(apex_application.g_f04(v_count));'||unistr('\000a')||
'      IF v_zahl != NVL(apex_application.g_f14(v_count),0) THEN'||unistr('\000a')||
'         v_return := rezepte.ins_upd_mnr_d';

p:=p||'etails'||unistr('\000a')||
'              ( :p201_mn_rezept_id                     -- mn_rezept_id'||unistr('\000a')||
'               ,apex_application.g_f02(v_count)        -- mn_id'||unistr('\000a')||
'               ,:p201_mn_reztyp_id                     -- mn_reztyp_id'||unistr('\000a')||
'               ,apex_application.g_f01(v_count)        -- inh_id '||unistr('\000a')||
'               ,apex_application.g_f03(v_count)        -- mn_einheit_id'||unistr('\000a')||
'               ,v_zahl                           ';

p:=p||'      -- mn_menge'||unistr('\000a')||
'               ,0                                      -- schuettgewicht'||unistr('\000a')||
'               ,apex_application.g_f05(v_count)        -- mn_bemerkung'||unistr('\000a')||
'               ,apex_application.g_f06(v_count)        -- mn_menge_tag_sicher'||unistr('\000a')||
'               ,apex_application.g_f07(v_count)        -- mn_menge_tag_max'||unistr('\000a')||
'               ,apex_application.g_f08(v_count)        -- mn_menge_tag_min'||unistr('\000a')||
'          ';

p:=p||'     ,apex_application.g_f09(v_count)        -- mn_einheit_id_tag_sicher'||unistr('\000a')||
'               ,apex_application.g_f10(v_count)        -- mn_einheit_id_tag_max'||unistr('\000a')||
'               ,apex_application.g_f11(v_count)        -- mn_einheit_id_tag_min'||unistr('\000a')||
'               ,''R''                                    -- rezeptrelevant'||unistr('\000a')||
'              );'||unistr('\000a')||
'         IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'            v_fehlertext := frgbg_s.h';

p:=p||'olen_uebersetzung(521,v_sprache_id,'||unistr('\000a')||
'                              to_char(apex_application.g_f08(v_count)) ,       -- inh_bez '||unistr('\000a')||
'                              to_char(:p201_mn_rezept_id)'||unistr('\000a')||
'                             );'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   end loop;'||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 26.07.14 Falls der Grenzwert für Arztrezept erforderlich (GWTYP =4) ';

p:=p||'für ein inhaltsstoff überschritten wurde'||unistr('\000a')||
'   -- => muss das Feld mn_rezepte.arzt_rezept= ''J'' gesetzt werden'||unistr('\000a')||
'   -- Check Arztrezept-Grenzwerte für MNR'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      v_return := rezepte.CHECK_MNR_GRENZWERTE'||unistr('\000a')||
'                       (:p201_mn_rezept_id ,'||unistr('\000a')||
'                        4,    -- Arztrezept erforderlich Grenwerttyp=1'||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'      IF v_return';

p:=p||' > 0 THEN'||unistr('\000a')||
'         --''Es wurden Arztrezept-Grenzwerte(GWTYP =4) bei den Inhaltsstoffen überschritten!.....'||unistr('\000a')||
'         UPDATE mn_rezepte'||unistr('\000a')||
'         SET arzt_rezept = ''J'''||unistr('\000a')||
'         WHERE id = :p201_mn_rezept_id ;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN'||unistr('\000a')||
'      v_fehlertext := SQLERRM; '||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20001,frgbg_s.holen_uebersetzung(10346,v_sprache_id,'||unistr('\000a')||
'                              ';

p:=p||'    v_fehlertext,''speichern_details'''||unistr('\000a')||
'                                ));'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6748112286802925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_mn_details',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>6746910392802923 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_mn_rezept_id_neu  NUMBER;   --mn_rezepte.id%TYPE;  '||unistr('\000a')||
'   v_mn_rezept_id_alt  NUMBER;   --mn_rezepte.id%TYPE;  '||unistr('\000a')||
'   v_version_neu       NUMBER;   --mn_rezepte.version%TYPE; '||unistr('\000a')||
'   v_prod_rezept_id    NUMBER;   --prod_rezepte.id%TYPE;'||unistr('\000a')||
'   v_reichweite        NUMBER ;'||unistr('\000a')||
'   v_runden            NUMBER := 0;'||unistr('\000a')||
'   v_return            NUMBER; '||unistr('\000a')||
''||unistr('\000a')||
'   v_fehlertext        VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id        ';

p:=p||'   NUMBER;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'   v_gen_hint1         NUMBER;'||unistr('\000a')||
'   v_gen_hint2         NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P(''Gen-Prod Start mnr : %1, Prod %2  '',v_prot_id,''TEST'',''102/202:gen-prod'', :p201_mn_rezept_id,:p202_id);'||unistr('\000a')||
'  -- Initialisierung des Status, damit nur bei erfolgereicher Operation wie '||unistr('\000a')||
'  -- Speichern, Runden ,Reichweite etc. auch der MNR-Split durchgeführt wird */'||unistr('\000a')||
'  :P2';

p:=p||'02_OPERATION_OK := 0; -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'    '||unistr('\000a')||
'  IF :P201_MN_REZTYP_ID in (1,2,3,4) and -- mn-rezepte f. die ein Prodrez erstellt werden kann'||unistr('\000a')||
'     :p201_mnr_vorschrift = 0            -- nur für normale Rezepte nicht für Vorschriften'||unistr('\000a')||
'  THEN'||unistr('\000a')||
'      -- Merken der alten Rezept-ID'||unistr('\000a')||
'      v_mn_rezept_id_alt := :p201_mn_rezept_id;'||unistr('\000a')||
''||unistr('\000a')||
'      IF :p202_id IS NOT NULL THEN   -- NEI';

p:=p||' 07.05.08'||unistr('\000a')||
'         -- Holen der Reichweite aus dem Produktrezept oder der Default aus den Optionswerten'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT reichweite INTO v_reichweite'||unistr('\000a')||
'            FROM prod_rezepte p'||unistr('\000a')||
'            WHERE p.id = :p202_id;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'             --v_reichweite := 30;  NEI 07.07.08 Default aus Optionswerte opttyp_id =7'||unistr('\000a')||
'             v_reichweite := NVL(f';

p:=p||'rgbg_s.GET_PERS_OPTION(:APP_USER,7),30);'||unistr('\000a')||
'         END;'||unistr('\000a')||
'      ELSE  -- Reichweiten-Default setzen'||unistr('\000a')||
'         v_reichweite := NVL(frgbg_s.GET_PERS_OPTION(:APP_USER,7),30);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Holen des Kennzeichens der Artikelrundung aus den Optionswerten NEI 28.12.09'||unistr('\000a')||
'      v_runden := NVL(frgbg_s.GET_PERS_OPTION(:APP_USER,26),0);   '||unistr('\000a')||
'      IF v_runden != 0 THEN'||unistr('\000a')||
'         v_gen_hint2 := -v_reichweit';

p:=p||'e;  -- Negative Reichweite => n-Tage hochrechnen inkl. runden'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_gen_hint2 := v_reichweite;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Rezept auf rückberechnet setzen'||unistr('\000a')||
'      UPDATE v_mn_rezepte'||unistr('\000a')||
'      set mn_reztyp_id = 5'||unistr('\000a')||
'      WHERE id = :p201_mn_rezept_id;'||unistr('\000a')||
'--MEL.P(''Gen-Prod 1 MNR-Details speichern Rezept-ID: %1 '',v_prot_id,''Info'',''MNR-Details speichern'','||unistr('\000a')||
'--        :p201_mn_rezept_id);   '||unistr('\000a')||
''||unistr('\000a')||
'      --';

p:=p||' Neue Rezept-id/Version holen '||unistr('\000a')||
'      v_version_neu := rezepte.get_mnr_max_version(:p201_rezept_nr);'||unistr('\000a')||
'      select id into v_mn_rezept_id_neu'||unistr('\000a')||
'      from mn_rezepte '||unistr('\000a')||
'      where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'        and version = v_version_neu;'||unistr('\000a')||
'--MEL.P(''Gen-Prod 1 MNR-Details speichern neue Rezept-ID: %1 '',v_prot_id,''Info'',''MNR-Details speichern'','||unistr('\000a')||
'--        v_mn_rezept_id_neu);   '||unistr('\000a')||
''||unistr('\000a')||
'      -- Neue Rezept';

p:=p||'-ID FAS bekannt machen'||unistr('\000a')||
'      :p201_mn_rezept_id := v_mn_rezept_id_neu;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Gen-Hint1 setzen'||unistr('\000a')||
'      v_gen_hint1 := NVL(:p202_menge_ueberschreiten,1);'||unistr('\000a')||
'--MEL.P(''Gen-Prod 1 MNR-Details speichern Rezept-ID: MN-Rezept-ID:%1,Reichweite:%2,Hint2:%3,Hint1:%4 '',v_prot_id,''Info'',''MNR-Details speichern'',        :p201_mn_rezept_id, v_reichweite,v_gen_hint2,v_gen_hint1 );   '||unistr('\000a')||
''||unistr('\000a')||
'      -- Produktrezeptgenerier';

p:=p||'ung starten ohne Glättung aber mit 30-Tage hochrechnen gen_hint2=30'||unistr('\000a')||
'      v_return := rezepte.gen_produktrezept(v_mn_rezept_id_alt,v_mn_rezept_id_neu,'||unistr('\000a')||
'                                v_gen_hint1,v_gen_hint2,'||unistr('\000a')||
'                                :fas_sortiment_id, -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                                v_fehlertext); '||unistr('\000a')||
'      IF v_return = -1 THEN -- nicht ganzzahlige Stüc';

p:=p||'kartikel'||unistr('\000a')||
'         :p202_fehlertext := frgbg_s.holen_uebersetzung(578,v_sprache_id);'||unistr('\000a')||
'      ELSIF v_return < -1 THEN  -- Fehler'||unistr('\000a')||
'         -- Alle bisher generierten EintrÃ¤ge entfernen!!!!  => Produktrezepte, MNR-Rezept-Kopf für rückberechnet'||unistr('\000a')||
'         -- Alte Rezept-ID FAS wieder anzeigen'||unistr('\000a')||
'         :p201_mn_rezept_id :=  v_mn_rezept_id_alt;'||unistr('\000a')||
'      '||unistr('\000a')||
'         v_return := rezepte.del_alle_eintraege(v_mn_r';

p:=p||'ezept_id_alt,v_mn_rezept_id_neu);'||unistr('\000a')||
'         IF v_return < 1 THEN'||unistr('\000a')||
'            --:P202_fehlertext := ''Datenbereinigung konnte nicht fehlerfrei durchgefÃ¼hrt werden!'';'||unistr('\000a')||
'            :P202_fehlertext := frgbg_s.holen_uebersetzung(579,v_sprache_id);'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            --:P202_fehlertext := ''Fehlerhaftes Produktrezept! Daten werden bereinigt. Fehler ''||'||unistr('\000a')||
'            --                    to_char(v_re';

p:=p||'turn)||'': ''||v_fehlertext; '||unistr('\000a')||
'            :P202_fehlertext := frgbg_s.holen_uebersetzung(580,v_sprache_id);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSE    -- Anzahl Artikel'||unistr('\000a')||
'         IF v_return = 0 THEN'||unistr('\000a')||
'            -- Alte Rezept-ID FAS wieder anzeigen'||unistr('\000a')||
'            :p201_mn_rezept_id :=  v_mn_rezept_id_alt;'||unistr('\000a')||
''||unistr('\000a')||
'            -- Alle bisher generierten EintrÃ¤ge entfernen!!!! => Produktrezepte, MNR-Rezept-Kopf für rückber';

p:=p||'echnet '||unistr('\000a')||
'            v_return := rezepte.del_alle_eintraege(v_mn_rezept_id_alt,v_mn_rezept_id_neu);'||unistr('\000a')||
'            IF v_return < 1 THEN'||unistr('\000a')||
'               --:p202_fehlertext := '||unistr('\000a')||
'               --     ''Datenbereinigung konnte nicht fehlerfrei durchgefÃ¼hrt werden!'';'||unistr('\000a')||
'               :P202_fehlertext := frgbg_s.holen_uebersetzung(579,v_sprache_id);'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               --:p202_fehlertext := '||unistr('\000a')||
'      ';

p:=p||'         --     ''Kein passenden Artikel fÃ¼r das MNR gefunden! Daten werden bereinigt.'';'||unistr('\000a')||
'               :P202_fehlertext := frgbg_s.holen_uebersetzung(581,v_sprache_id);'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         /*ELSE --Produktrezept wird sofort angezeigt => keine Meldung'||unistr('\000a')||
'            select id into v_prod_rezept_id'||unistr('\000a')||
'            from prod_rezepte '||unistr('\000a')||
'            where rezept_nr = :mn_rezepte.rezept_nr'||unistr('\000a')||
'            ';

p:=p||'  and version = v_version_neu;'||unistr('\000a')||
'      '||unistr('\000a')||
'            :p202_fehlertext := ''Erfolgreiches Produktrezept mit ID = ''||to_char(v_prod_rezept_id)||'||unistr('\000a')||
'                                ''! Anzahl     eingetragener Artikel:''||to_char(v_return);'||unistr('\000a')||
'          */'||unistr('\000a')||
'         ELSE '||unistr('\000a')||
'            -- Speichern, Runden ,Reichweite etc. OK => ggf. MNR-Split durchführen '||unistr('\000a')||
'            :P202_OPERATION_OK := 1; -- NEI 10.01.2014 Kumu';

p:=p||'lation Splits zu Gesamtrezept'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--MEL.P(''Gen-Prod Ende mnr : %1, Prod %2, op_ok %3  '',v_prot_id,''TEST'',''102/202:gen-prod'', :p201_mn_rezept_id,:p202_id,:p202_operation_ok);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7510124573082379 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 25,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_produktrezept',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>6746910392802923 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_mutdat         varchar2(50);'||unistr('\000a')||
'   v_status         number;'||unistr('\000a')||
'   v_session_id     VARCHAR2(250);  -- NEI 19.09.13'||unistr('\000a')||
'   v_artikelliste   varchar2(2000); -- NEI 19.09.13'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_count          integer := 1;  '||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'begin'||unistr('\000a')||
'/* Doku:'||unistr('\000a')||
'              ,apex_application.g_f0';

p:=p||'1(v_count)        -- mn_id'||unistr('\000a')||
'               ,apex_application.g_f02(v_count)        -- inh_id '||unistr('\000a')||
'               ,apex_application.g_f03(v_count)        -- mn_einheit_id'||unistr('\000a')||
'               ,apex_application.g_f04(v_count)        -- mn_menge'||unistr('\000a')||
'               ,apex_application.g_f05(v_count)        -- mn_bemerkung'||unistr('\000a')||
'               ,apex_application.g_f06(v_count)        -- mn_menge_tag_sicher'||unistr('\000a')||
'               ,ape';

p:=p||'x_application.g_f07(v_count)        -- mn_menge_tag_max'||unistr('\000a')||
'               ,apex_application.g_f08(v_count)        -- mn_menge_tag_min'||unistr('\000a')||
'               ,apex_application.g_f09(v_count)      --mn_einheit_id_tag_sicher'||unistr('\000a')||
'               ,apex_application.g_f10(v_count)        -- mn_einheit_id_tag_max'||unistr('\000a')||
'               ,apex_application.g_f11(v_count)        -- mn_einheit_id_tag_min'||unistr('\000a')||
'               ,apex_applicat';

p:=p||'ion.g_f12(v_count)        -- inhstoff_bezeichnung'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'MEL.P(''Prod-Runden Start mnr : %1, Prod %2'',v_prot_id,''TEST'',''102/202:prod_runden'', :p201_mn_rezept_id,:p202_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Initialisierung des Status, damit nur bei erfolgereicher Operation wie '||unistr('\000a')||
'   -- Speichern, Runden ,Reichweite etc. auch der MNR-Split durchgeführt wird */'||unistr('\000a')||
'   :P202_OPERATION_OK := 0; -- NEI 10.01.2014 Kumulation Splits zu Gesam';

p:=p||'trezept'||unistr('\000a')||
''||unistr('\000a')||
'   IF :p202_fehlertext IS NOT NULL THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,:p202_fehlertext);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Prüfen, ob Rezept zwischenzeitlich geändert wurde'||unistr('\000a')||
'   SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'   FROM prod_rezepte'||unistr('\000a')||
'   WHERE  id = :p202_id;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_mutdat != :p202_prod_mutdat THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_spr';

p:=p||'ache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      -- Zuvor Rezeptkopf speichern,falls neue Vers.z.B.bei gültigen Rezepten gebildet werden muss'||unistr('\000a')||
'      -- Dummy-Update'||unistr('\000a')||
'      UPDATE v_prod_rezepte'||unistr('\000a')||
'      SET    bezeichnung = bezeichnung'||unistr('\000a')||
'      WHERE id = :p202_id;'||unistr('\000a')||
' '||unistr('\000a')||
'      -- Falls gültiges Rezept gespeichert wird, gibts neue Version => Neue ID holen'||unistr('\000a')||
'      select id, bezeichnung, bemerkung,rezept_nr, version ,akt_ve';

p:=p||'rsion,prod_reztyp_id,status'||unistr('\000a')||
'      into :p202_id,:p202_bezeichnung,:p202_bemerkung,:p202_rezept_nr,:p202_version,'||unistr('\000a')||
'           :p202_akt_version,:p202_prod_reztyp_id, :p202_status'||unistr('\000a')||
'      from v_prod_rezepte '||unistr('\000a')||
'      where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'        and version = rezepte.get_mnr_max_version(:p201_rezept_nr);'||unistr('\000a')||
''||unistr('\000a')||
'      :p201_prod_rezept_id := :p202_id;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Neues MN-Rezept holen'||unistr('\000a')||
'      select id';

p:=p||', bezeichnung, bemerkung,rezept_nr, version ,akt_version,mn_reztyp_id,status  '||unistr('\000a')||
'      into :p201_mn_rezept_id,:p201_bezeichnung,:p201_bemerkung,:p201_rezept_nr,:p201_version,'||unistr('\000a')||
'           :p201_akt_version,:p201_mn_reztyp_id , v_status'||unistr('\000a')||
'      from v_mn_rezepte '||unistr('\000a')||
'      where rezept_nr = :p202_rezept_nr'||unistr('\000a')||
'        and version = :p202_version;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others then'||unistr('\000a')||
'       v_fehlertext := SQLERRM;'||unistr('\000a')||
'';

p:=p||'       RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                                  v_fehlertext,''prod_runden'''||unistr('\000a')||
'                                ));'||unistr('\000a')||
'   END;   '||unistr('\000a')||
''||unistr('\000a')||
'   v_return := rezepte.runden_prodrezept'||unistr('\000a')||
'              ( :p202_id    ,                           -- prod_rezept_id'||unistr('\000a')||
'                v_fehlertext'||unistr('\000a')||
'              );'||unistr('\000a')||
'   IF v_return <= 0 THEN -- FEHLER'||unistr('\000a')||
'      v_feh';

p:=p||'lertext := frgbg_s.holen_uebersetzung(554,v_sprache_id,'||unistr('\000a')||
'                           to_char(:p202_id)'||unistr('\000a')||
'                          );'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   /* NEI 06.11.13 CHECKS wie beim Speichern von Produktrezept auch beim Runden und '||unistr('\000a')||
'      wenn erfolgreich, dann sofort von Arbeitsversion auf gültige Version '||unistr('\000a')||
'   */'||unistr('\000a')||
'   -- Check Max-Grenzwerte'||unistr('\000a')||
'   v_retur';

p:=p||'n := rezepte.CHECK_MNR_GRENZWERTE'||unistr('\000a')||
'                       (:p201_mn_rezept_id,'||unistr('\000a')||
'                        1,    -- Maxwertprüfung Grenwerttyp=1'||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'   IF v_return > 0 THEN'||unistr('\000a')||
'      --''Es wurden Grenzwerte bei den Inhaltsstoffen überschritten!..... '||unistr('\000a')||
'      :p202_fehlertext := frgbg_s.holen_uebersetzung(4880,v_sprache_id);'||unistr('\000a')||
'   ELSIF v_return < 0 THEN'||unistr('\000a')||
'';

p:=p||'      --''Die Grenzwertprüfung konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'      :p202_fehlertext := frgbg_s.holen_uebersetzung(4881,v_sprache_id);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Gueltige Version '||unistr('\000a')||
'      UPDATE v_prod_rezepte                             '||unistr('\000a')||
'      SET    bezeichnung = bezeichnung,'||unistr('\000a')||
'             prod_rezstatus_id = 2 -- gueltige Version initieren     '||unistr('\000a')||
'      WHERE id = :p201_prod_rezept_id;       '||unistr('\000a')||
'      -- Spei';

p:=p||'chern, Runden ,Reichweite etc. erfolgreich => ggf. MNR-Split durchführen */'||unistr('\000a')||
'      :P202_OPERATION_OK := 1; -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   /* -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept  '||unistr('\000a')||
'      -- => Checks und Bearb.modus setzen, wird nun zentral gemacht im Prozess rezept_checken_neu_laden'||unistr('\000a')||
'   -- Check Warn-Grenzwerte'||unistr('\000a')||
'   IF not v_return > 0 THEN  -- Maxgr';

p:=p||'enzen nicht erreicht'||unistr('\000a')||
'      v_return := rezepte.CHECK_MNR_GRENZWERTE'||unistr('\000a')||
'                       (:p201_mn_rezept_id,'||unistr('\000a')||
'                        5,    -- Warnwertprüfung Grenwerttyp=5'||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'      IF v_return > 0 THEN'||unistr('\000a')||
'         --''Es wurden WarnGrenzwerte bei den Inhaltsstoffen überschritten!..... '||unistr('\000a')||
'         :p202_fehlertext := frgbg_s.holen_uebersetzung';

p:=p||'(4882,v_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Check Kleinstmengenartikel'||unistr('\000a')||
'   -- Kleinstartikelmengen: Falls die Artikelanzahl kleiner als diese Grenze ist, erfolgt Hinweismeldung'||unistr('\000a')||
'      v_session_id := NVL(v(''APP_SESSION''),userenv(''sessionid''));'||unistr('\000a')||
'   DELETE FROM mn_mengenarts_exclude'||unistr('\000a')||
'   WHERE session_id = v_session_id; -- wg. apex und session_pooling koennen mehrere App-sessions in einer DB-Ses';

p:=p||'sions laufen'||unistr('\000a')||
'   '||unistr('\000a')||
'   v_return := rezepte.CHECK_KLEINSTARTIKELMENGEN(:p201_prod_rezept_id,NULL,:P202_MIN_ARTIKELGEWICHT_GR);'||unistr('\000a')||
'   IF v_return > 0 THEN -- Kleinstmengen gefunden'||unistr('\000a')||
'      SELECT listagg(fas_synch.get_tab_uebersetzung(''MN_REZEPTE.BEZEICHNUNG'',m.MN_REZEPT_ID,:fas_sprache_id) ,'', '')'||unistr('\000a')||
'             WITHIN GROUP (ORDER BY m.kuerzel)  INTO v_artikelliste'||unistr('\000a')||
'      FROM mengenarts m, mn_mengenarts_excl';

p:=p||'ude me'||unistr('\000a')||
'      where m.id = me.mengenart_id'||unistr('\000a')||
'        and me.session_id = v_session_id;'||unistr('\000a')||
'      IF v_artikelliste is not null THEN'||unistr('\000a')||
'         --''Es wurden Artikel unterhalb der Kleinstmengengrenze gefunden'''||unistr('\000a')||
'         :p202_fehlertext := :p202_fehlertext||''\n''|| '||unistr('\000a')||
'                             frgbg_s.holen_uebersetzung(7988,v_sprache_id,:P202_MIN_ARTIKELGEWICHT_GR,v_artikelliste); 	'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'';

p:=p||''||unistr('\000a')||
'   -- Bearbeitungsmodus für MNR-Inhstoffe neu setzen'||unistr('\000a')||
'   IF :p201_akt_version = 1 AND '||unistr('\000a')||
'      v_status not in (2,3) -- enthält keine ungültige Rezeptversion => komplettes Rezept gültig'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p201_bearb_modus := ''BEARBEITEN'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p201_bearb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- NEI 10.01.2014 */'||unistr('\000a')||
'--MEL.P(''Prod-Runden Ende mnr : %1, Prod %2, op_ok %3  '',v_prot_id,''TEST'',''102/202:pr';

p:=p||'od_runden'', :p201_mn_rezept_id, :p202_id,:p202_operation_ok);'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7653902429408150 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'prod_runden',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>7488725599092920 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_mutdat         varchar2(50);'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'   v_zahl           number;'||unistr('\000a')||
'   v_anzahl         number;'||unistr('\000a')||
'   v_gewicht        number;'||unistr('\000a')||
'   v_einheit_id     number;'||unistr('\000a')||
'   v_session_id     VARCHAR2(250);  -- NEI 19.09.13'||unistr('\000a')||
'   v_artikelliste   varchar2(2000); -- NEI 19.09.13'||unistr('\000a')||
'   ';

p:=p||'v_status         number;'||unistr('\000a')||
'   v_prod_status    number;'||unistr('\000a')||
''||unistr('\000a')||
'begin'||unistr('\000a')||
'/* Doku:'||unistr('\000a')||
'   ,apex_application.g_f21(v_count)        -- mart_id'||unistr('\000a')||
'   ,apex_application.g_f22(v_count)        -- prodr_det_id '||unistr('\000a')||
'   ,apex_application.g_f23(v_count)        -- einheit_id Eingabe'||unistr('\000a')||
'   ,apex_application.g_f24(v_count)        -- menge Eingabe'||unistr('\000a')||
'   ,apex_application.g_f25(v_count)        -- Entnahmeart_id'||unistr('\000a')||
'   ,apex_application.g_f26(v_co';

p:=p||'unt)        -- prodr_det_einheit_id DB'||unistr('\000a')||
'   ,apex_application.g_f27(v_count)        -- prodr_det_gewicht'||unistr('\000a')||
'   ,apex_application.g_f28(v_count)        -- mart_kuerzel'||unistr('\000a')||
'   ,apex_application.g_f29(v_count)        -- mart_menge_einheit_id'||unistr('\000a')||
'   ,apex_application.g_f30(v_count)        -- mart_menge'||unistr('\000a')||
'   ,apex_application.g_f31(v_count)        -- menge DB'||unistr('\000a')||
''||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'--MEL.P(''Prod-Details Start mnr : %1, Prod %2 '',v_pro';

p:=p||'t_id,''TEST'',''102/202:speichern_prod_details'', :p201_mn_rezept_id,:p202_id);'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   -- Initialisierung des Status, damit nur bei erfolgereicher Operation wie '||unistr('\000a')||
'   -- Speichern, Runden ,Reichweite etc. auch der MNR-Split durchgeführt wird */'||unistr('\000a')||
'   :P202_OPERATION_OK := 0; -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
''||unistr('\000a')||
'   IF :p202_fehlertext IS NOT NULL THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,:p20';

p:=p||'2_fehlertext);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Prüfen, ob Rezept zwischenzeitlich geändert wurde'||unistr('\000a')||
'   SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'   FROM prod_rezepte'||unistr('\000a')||
'   WHERE  id = :p201_prod_rezept_id;'||unistr('\000a')||
'   IF v_mutdat != :p202_prod_mutdat THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      -- Zuvor Rezeptkopf speichern, falls neue ';

p:=p||'Version z.B. bei gültig gebildet werden muss'||unistr('\000a')||
'      -- Dummy-Update'||unistr('\000a')||
'/*MEL.P(''Prod-Details speichern Anzahl %1; Version %2; NR %3; Prodr_id %4; MNr_id %5;request:%6'','||unistr('\000a')||
'      v_prot_id,''Info'',''ProdR-Details speichern'','||unistr('\000a')||
'      apex_application.g_f21.count,:p201_version,:p201_rezept_nr,:p201_prod_rezept_id,'||unistr('\000a')||
'      :p201_mn_rezept_id,:request);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      UPDATE v_prod_rezepte                             '||unistr('\000a')||
'  ';

p:=p||'    SET    bezeichnung = bezeichnung  '||unistr('\000a')||
'      WHERE id = :p201_prod_rezept_id; '||unistr('\000a')||
' '||unistr('\000a')||
'      -- Falls gültiges Rezept gespeichert wird, gibts neue MN-Version => Neue ID holen'||unistr('\000a')||
'      select id, bezeichnung, bemerkung,rezept_nr, version ,akt_version,mn_reztyp_id,status  '||unistr('\000a')||
'      into :p201_mn_rezept_id,:p201_bezeichnung,:p201_bemerkung,:p201_rezept_nr,:p201_version,'||unistr('\000a')||
'           :p201_akt_version,:p201_mn_rezt';

p:=p||'yp_id,v_status '||unistr('\000a')||
'      from v_mn_rezepte '||unistr('\000a')||
'      where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'        and version = rezepte.get_prodr_max_vers(:p201_rezept_nr);  '||unistr('\000a')||
''||unistr('\000a')||
'      -- Falls gültiges Rezept gespeichert wird, gibts neue Prod-Version => Neue ID holen'||unistr('\000a')||
'      SELECT id,prod_rezstatus_id INTO :p201_prod_rezept_id,v_prod_status'||unistr('\000a')||
'      FROM prod_rezepte'||unistr('\000a')||
'      WHERE version = :p201_version'||unistr('\000a')||
'        AND rezept_nr = :';

p:=p||'p201_rezept_nr;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others then'||unistr('\000a')||
'       v_fehlertext := SQLERRM;'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                                  v_fehlertext,''speichern_prod_details'''||unistr('\000a')||
'                                ));'||unistr('\000a')||
'   END;   '||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P(''Prod-Details speichern Anzahl %1; Version %2; NR %3; Prodr_id %4; MNr_id %5'','||unistr('\000a')||
'      v_prot_id,''Info'',''P';

p:=p||'rodR-Details speichern'','||unistr('\000a')||
'      apex_application.g_f21.count,:p201_version,:p201_rezept_nr,:p201_prod_rezept_id,'||unistr('\000a')||
'      :p201_mn_rezept_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'   -- Details speichern'||unistr('\000a')||
'   for v_count in 1..apex_application.g_f21.count'||unistr('\000a')||
'   loop '||unistr('\000a')||
'/*MEL.P(''Prod-Details speichern f21 %1, f22 %2, f23 %3,f24 %4, f25 %5, f26 %6,f27 %7,f28 %8,ANz: %9'','||unistr('\000a')||
'           v_prot_id,'||unistr('\000a')||
'           ''Info'','||unistr('\000a')||
'           ''MNR-Details speiche';

p:=p||'rn'','||unistr('\000a')||
'           apex_application.g_f21(v_count),'||unistr('\000a')||
'           apex_application.g_f22(v_count),'||unistr('\000a')||
'           apex_application.g_f23(v_count),'||unistr('\000a')||
'           apex_application.g_f24(v_count),'||unistr('\000a')||
'           apex_application.g_f25(v_count),'||unistr('\000a')||
'           apex_application.g_f26(v_count),'||unistr('\000a')||
'           apex_application.g_f27(v_count),'||unistr('\000a')||
'           apex_application.g_f28(v_count),'||unistr('\000a')||
'           to_char(v_count));'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'      --v';

p:=p||'_zahl := rezepte.convert_to_number(apex_application.g_f24(v_count),''999G999G999D99999'');'||unistr('\000a')||
'      v_zahl := to_number(apex_application.g_f24(v_count));'||unistr('\000a')||
'      IF v_zahl != NVL(apex_application.g_f31(v_count),0) THEN  -- geänderte Werte'||unistr('\000a')||
''||unistr('\000a')||
'         -- Wert je nach Entnahmeart bestimmen'||unistr('\000a')||
'         IF apex_application.g_f25(v_count) in (2,3) THEN /*Stückentn.:Berechne Gewicht aus Anzahl*/'||unistr('\000a')||
'            v_einhe';

p:=p||'it_id := apex_application.g_f29(v_count) ; -- Einheit der Artikelangabe'||unistr('\000a')||
'            v_zahl := apex_application.g_f30(v_count) * v_zahl;  '||unistr('\000a')||
''||unistr('\000a')||
'            -- Prüfen, ob EH des Artikels bereits eine Gewichteinheit sonst in g umrechnen'||unistr('\000a')||
'            SELECT count(*) INTO v_anzahl'||unistr('\000a')||
'            FROM einheiten'||unistr('\000a')||
'            WHERE physeh_id = 5'||unistr('\000a')||
'              AND id = v_einheit_id;'||unistr('\000a')||
'            IF v_anzahl = 0 THEN';

p:=p||' -- Umrechnen in Gewichtseinheit g '||unistr('\000a')||
'               v_zahl := rezepte.umrechnen_artikel_eh(v_zahl,apex_application.g_f21(v_count),'||unistr('\000a')||
'                         v_einheit_id,500);  '||unistr('\000a')||
'               v_einheit_id := 500;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'     '||unistr('\000a')||
'            -- Anpassen der Einheit innerhalb der physik. Einh., damit der Wert mögl.zw. 1-999 liegt'||unistr('\000a')||
'            v_gewicht := rezepte.anpassen_einh(v_zahl,v_einhe';

p:=p||'it_id);'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            v_einheit_id := apex_application.g_f23(v_count) ;'||unistr('\000a')||
'            v_gewicht := v_zahl;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'        '||unistr('\000a')||
'         -- Speichern'||unistr('\000a')||
'         v_return := rezepte.ins_upd_prodr_detail'||unistr('\000a')||
'                 ( :p201_prod_rezept_id                   -- prod_rezept_id'||unistr('\000a')||
'                  ,apex_application.g_f22(v_count)        -- prodr_det_id'||unistr('\000a')||
'                  ,apex_application';

p:=p||'.g_f21(v_count)        -- mart_id '||unistr('\000a')||
'                  ,v_einheit_id                           -- einheit_id'||unistr('\000a')||
'                  ,v_gewicht                              -- gewicht'||unistr('\000a')||
'                  ,NULL                                   -- bemerkung'||unistr('\000a')||
'                 );'||unistr('\000a')||
'         IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(576,v_sprache_id,'||unistr('\000a')||
'                    ';

p:=p||'          to_char(apex_application.g_f28(v_count)) ,       -- mart_id '||unistr('\000a')||
'                              to_char(:p201_prod_rezept_id)'||unistr('\000a')||
'                             );'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF; -- geänderte Werte'||unistr('\000a')||
'   end loop;'||unistr('\000a')||
'   -- Tagesdosis glätten'||unistr('\000a')||
'   v_return := rezepte.glaetten_anz_prodr  ( :p201_prod_rezept_id,           -- Produktre';

p:=p||'zept-ID   '||unistr('\000a')||
'                                             0,   -- Flag: MNR muss nicht angepasst werden, s.u.'||unistr('\000a')||
'                                             v_fehlertext'||unistr('\000a')||
'                                             );  '||unistr('\000a')||
'   IF v_return <= 0 THEN'||unistr('\000a')||
'      NULL ;'||unistr('\000a')||
'   END IF; '||unistr('\000a')||
'   --v_return := rezepte.akt_mnr_details_prod ( :p201_prod_rezept_id); '||unistr('\000a')||
'   v_return := rezepte.akt_mnr_details_prod ( :p201_prod_rezep';

p:=p||'t_id,1); -- NEI 17.05.08  '||unistr('\000a')||
'   IF v_return < 1 THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(577,v_sprache_id,'||unistr('\000a')||
'                           to_char(:p201_prod_rezept_id)'||unistr('\000a')||
'                          );'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 21.07.11'||unistr('\000a')||
'   -- Check Max-Grenzwerte'||unistr('\000a')||
'   v_return := rezepte.CHECK_MNR_GRENZWERTE'||unistr('\000a')||
'                       (:p201_mn_rezept_';

p:=p||'id,'||unistr('\000a')||
'                        1,    -- Maxwertprüfung Grenwerttyp=1'||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'   IF v_return > 0 THEN'||unistr('\000a')||
'      --''Es wurden Grenzwerte bei den Inhaltsstoffen überschritten!..... '||unistr('\000a')||
'      :p202_fehlertext := frgbg_s.holen_uebersetzung(4880,v_sprache_id);'||unistr('\000a')||
'   ELSIF v_return < 0 THEN'||unistr('\000a')||
'      --''Die Grenzwertprüfung konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'      :p';

p:=p||'202_fehlertext := frgbg_s.holen_uebersetzung(4881,v_sprache_id);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Gueltige Version '||unistr('\000a')||
'      UPDATE v_prod_rezepte                             '||unistr('\000a')||
'      SET    bezeichnung = bezeichnung,'||unistr('\000a')||
'             prod_rezstatus_id = 2 -- gueltige Version initieren     '||unistr('\000a')||
'      WHERE id = :p201_prod_rezept_id; '||unistr('\000a')||
'            '||unistr('\000a')||
'      -- Speichern, Runden ,Reichweite etc. erfolgreich => ggf. MNR-Split durchf';

p:=p||'ühren */'||unistr('\000a')||
'      :P202_OPERATION_OK := 1; -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   /* -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept  '||unistr('\000a')||
'      -- => Checks und Bearb.modus setzen, wird nun zentral gemacht im Prozess rezept_checken_neu_laden'||unistr('\000a')||
'   -- Check Warn-Grenzwerte'||unistr('\000a')||
'   IF v_prodr_ok = 1 THEN  -- Maxgrenzen nicht erreicht'||unistr('\000a')||
'      v_return := rezepte.CHECK_MNR_GRENZWERT';

p:=p||'E'||unistr('\000a')||
'                       (:p201_mn_rezept_id,'||unistr('\000a')||
'                        5,    -- Warnwertprüfung Grenwerttyp=5'||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'      IF v_return > 0 THEN'||unistr('\000a')||
'         --''Es wurden WarnGrenzwerte bei den Inhaltsstoffen überschritten!..... '||unistr('\000a')||
'         :p202_fehlertext := frgbg_s.holen_uebersetzung(4882,v_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 19.09.13'||unistr('\000a')||
'';

p:=p||'   -- Check Kleinstmengenartikel'||unistr('\000a')||
'   -- Kleinstartikelmengen: Falls die Artikelanzahl kleiner als diese Grenze ist, erfolgt Hinweismeldung'||unistr('\000a')||
'      v_session_id := NVL(v(''APP_SESSION''),userenv(''sessionid''));'||unistr('\000a')||
'   DELETE FROM mn_mengenarts_exclude'||unistr('\000a')||
'   WHERE session_id = v_session_id; -- wg. apex und session_pooling koennen mehrere App-sessions in einer DB-Sessions laufen'||unistr('\000a')||
'   '||unistr('\000a')||
'   v_return := rezepte.CHECK_K';

p:=p||'LEINSTARTIKELMENGEN(:p201_prod_rezept_id,NULL,:P202_MIN_ARTIKELGEWICHT_GR);'||unistr('\000a')||
'   IF v_return > 0 THEN -- Kleinstmengen gefunden'||unistr('\000a')||
'      SELECT listagg(fas_synch.get_tab_uebersetzung(''MN_REZEPTE.BEZEICHNUNG'',m.MN_REZEPT_ID,:fas_sprache_id) ,'', '')'||unistr('\000a')||
'             WITHIN GROUP (ORDER BY m.kuerzel)  INTO v_artikelliste'||unistr('\000a')||
'      FROM mengenarts m, mn_mengenarts_exclude me'||unistr('\000a')||
'      where m.id = me.mengenart_id'||unistr('\000a')||
'     ';

p:=p||'   and me.session_id = v_session_id;'||unistr('\000a')||
'      IF v_artikelliste is not null THEN'||unistr('\000a')||
'         --''Es wurden Artikel unterhalb der Kleinstmengengrenze gefunden'''||unistr('\000a')||
'         :p202_fehlertext := :p202_fehlertext||''\n''|| '||unistr('\000a')||
'                             frgbg_s.holen_uebersetzung(7988,v_sprache_id,:P202_MIN_ARTIKELGEWICHT_GR,v_artikelliste); 	'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   -- Bearbeitungsmodus neu setzen'||unistr('\000a')||
'   IF :p';

p:=p||'201_akt_version = 1 AND '||unistr('\000a')||
'      v_status not in (2,3) -- enthält keine ungültige Rezeptversion => komplettes Rezept gültig'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p201_bearb_modus := ''BEARBEITEN'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p201_bearb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- NEI 10.01.2014 '||unistr('\000a')||
'   */'||unistr('\000a')||
'--MEL.P(''Prod-Details Ende mnr : %1, Prod %2, op_ok %3  '',v_prot_id,''TEST'',''102/202:speichern_prod_details'', :p201_mn_rezept_id,:p202_id,:p202_';

p:=p||'operation_ok);'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7811014718165759 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_prod_details',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''PROD_SPEICHERN'',''PROD_SPEICHERN_ARBEITSVERSION'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_mutdat         varchar2(50);'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_runden         number:= 0;        -- NEI 28.12.09'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
'   v_zahl           number;'||unistr('\000a')||
'   v_anzahl         number;'||unistr('\000a')||
'   v_gewicht        number;'||unistr('\000a')||
'   v_einheit_id     number;'||unistr('\000a')||
'   v_status         number;'||unistr('\000a')||
'   v_session_id     VARC';

p:=p||'HAR2(250);  -- NEI 19.09.13'||unistr('\000a')||
'   v_artikelliste   varchar2(2000); -- NEI 19.09.13'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P(''Reichweite Start mnr : %1, Prod %2 '',v_prot_id,''TEST'',''102/202:reichweite'', :p201_mn_rezept_id,:p202_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Initialisierung des Status, damit nur bei erfolgereicher Operation wie '||unistr('\000a')||
'   -- Speichern, Runden ,Reichweite etc. auch der MNR-Split durchgeführt wird '||unistr('\000a')||
'   :P202_OPERATION_OK := 0; -- NEI 10.01';

p:=p||'.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
''||unistr('\000a')||
'   -- Prüfen, ob Rezept zwischenzeitlich geändert wurde'||unistr('\000a')||
'   SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') INTO v_mutdat'||unistr('\000a')||
'   FROM prod_rezepte'||unistr('\000a')||
'   WHERE  id = :p201_prod_rezept_id;'||unistr('\000a')||
'   IF v_mutdat != :p202_prod_mutdat THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(549,v_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :p202_reichweite != :p202_db_reichweit';

p:=p||'e THEN'||unistr('\000a')||
'      IF :REQUEST = ''REICHWEITE_BMI'' THEN  -- NEI 17.05.08'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            -- Zuvor Rezeptkopf speichern, falls neue Version z.B. bei gültig gebildet werden muss'||unistr('\000a')||
'            -- Dummy-Update'||unistr('\000a')||
'            UPDATE v_prod_rezepte'||unistr('\000a')||
'            SET    bezeichnung = bezeichnung'||unistr('\000a')||
'            WHERE id = :p201_prod_rezept_id;'||unistr('\000a')||
' '||unistr('\000a')||
'            -- Falls gültiges Rezept gespeichert wird, gibts neue ';

p:=p||'MN-Version => Neue ID holen'||unistr('\000a')||
'            select id, bezeichnung, bemerkung,rezept_nr, version ,akt_version,mn_reztyp_id,status  '||unistr('\000a')||
'            into :p201_mn_rezept_id,:p201_bezeichnung,:p201_bemerkung,:p201_rezept_nr,:p201_version,'||unistr('\000a')||
'                 :p201_akt_version,:p201_mn_reztyp_id,v_status '||unistr('\000a')||
'            from v_mn_rezepte '||unistr('\000a')||
'            where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'              and version = re';

p:=p||'zepte.get_prodr_max_vers(:p201_rezept_nr);  '||unistr('\000a')||
''||unistr('\000a')||
'            -- Falls gültiges Rezept gespeichert wird, gibts neue Prod-Version => Neue ID holen'||unistr('\000a')||
'            SELECT id INTO :p201_prod_rezept_id'||unistr('\000a')||
'            FROM prod_rezepte'||unistr('\000a')||
'            WHERE version = :p201_version'||unistr('\000a')||
'              AND rezept_nr = :p201_rezept_nr;'||unistr('\000a')||
'  '||unistr('\000a')||
'            UPDATE prod_rezepte'||unistr('\000a')||
'            SET    reichweite = :p202_reichweite '||unistr('\000a')||
'      ';

p:=p||'      WHERE id = :p201_prod_rezept_id;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others then'||unistr('\000a')||
'             v_fehlertext := SQLERRM;'||unistr('\000a')||
'             RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                                        v_fehlertext,''reichweite_aendern'''||unistr('\000a')||
'                                      ));'||unistr('\000a')||
'         END;'||unistr('\000a')||
'         -- Tagesdosis glätten'||unistr('\000a')||
'         v_return := rezept';

p:=p||'e.glaetten_anz_prodr(:p201_prod_rezept_id,    -- Produktrezept-ID   '||unistr('\000a')||
'                                             0,   -- Flag: MNR muss nicht angepasst werden, s.u.'||unistr('\000a')||
'                                             v_fehlertext'||unistr('\000a')||
'                                             );  '||unistr('\000a')||
'         IF v_return <= 0 THEN'||unistr('\000a')||
'            NULL ;'||unistr('\000a')||
'         END IF; '||unistr('\000a')||
'         -- Keine Anpassungen an den Prod-Details aber mn-';

p:=p||'details anpassen'||unistr('\000a')||
'         -- mn_details noch anpassen'||unistr('\000a')||
'         v_return := rezepte.akt_mnr_details_prod ( :p201_prod_rezept_id); '||unistr('\000a')||
'         IF v_return < 1 THEN'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(577,v_sprache_id,'||unistr('\000a')||
'                                 to_char(:p201_prod_rezept_id)'||unistr('\000a')||
'                                );'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'         ';

p:=p||'END IF;'||unistr('\000a')||
'         -- NEI 28.11.12 '||unistr('\000a')||
'         -- Check Max-Grenzwerte und ggf. Status von Arbeitsversion in gültige Version setzen'||unistr('\000a')||
'         v_return := rezepte.CHECK_MNR_GRENZWERTE'||unistr('\000a')||
'                       (:p201_mn_rezept_id,'||unistr('\000a')||
'                        1,    -- Maxwertprüfung Grenwerttyp=1'||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'         IF v_return > 0 THEN'||unistr('\000a')||
'            --''Es wurden';

p:=p||' Grenzwerte bei den Inhaltsstoffen überschritten!..... '||unistr('\000a')||
'            :p202_fehlertext := frgbg_s.holen_uebersetzung(4880,v_sprache_id);'||unistr('\000a')||
'         ELSIF v_return < 0 THEN'||unistr('\000a')||
'            --''Die Grenzwertprüfung konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'            :p202_fehlertext := frgbg_s.holen_uebersetzung(4881,v_sprache_id);'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            -- Gueltige Version '||unistr('\000a')||
'            UPDATE v_prod_rezepte ';

p:=p||'                            '||unistr('\000a')||
'            SET    bezeichnung = bezeichnung,'||unistr('\000a')||
'                   prod_rezstatus_id = 2 -- gueltige Version initieren     '||unistr('\000a')||
'            WHERE id = :p201_prod_rezept_id;  '||unistr('\000a')||
'            -- Speichern, Runden ,Reichweite etc. erfolgreich => ggf. MNR-Split durchführen '||unistr('\000a')||
'            :P202_OPERATION_OK := 1; -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'   ';

p:=p||'   ELSE  -- Reichweitenanpassung '||unistr('\000a')||
'            -- NEI 04.11.08 => Keine neue Rezeptversion,da sich am MNR nichts ändert'||unistr('\000a')||
'            -- nur die Produktzusammensetzung wird auf neue Reichweite angepasst; '||unistr('\000a')||
'            -- Tagesmengen der Inhstoffe bleiben konstant'||unistr('\000a')||
'            -- NEI 28.11.12 Es muss auch bei Reichweitenanpassung eines neue Version '||unistr('\000a')||
'            -- erstellt werden, da die Produktzusammen';

p:=p||'setzung sich ändert und diese '||unistr('\000a')||
'            -- gedruckt wird. Sonst kommt es bei gleicher Version ggf. zu verschiedenen'||unistr('\000a')||
'            -- Etiketten und dadurch entstehen Verwirrungen => immer neue Version'||unistr('\000a')||
'            -- NEI 29.01.14 keine neue Rezeptversion mehr bei Reichweiteänderung, aber Splitkomponenten ebenfalls anpassen'||unistr('\000a')||
'         --BEGIN'||unistr('\000a')||
'         /* NEI 29.01.14'||unistr('\000a')||
'            -- Zuvor Rezeptkopf sp';

p:=p||'eichern, falls neue Version z.B. bei gültig gebildet werden muss'||unistr('\000a')||
'            -- Dummy-Update '||unistr('\000a')||
'            UPDATE v_prod_rezepte                         -- NEI 28.11.12'||unistr('\000a')||
'            SET    bezeichnung = bezeichnung'||unistr('\000a')||
'            WHERE id = :p201_prod_rezept_id;'||unistr('\000a')||
' '||unistr('\000a')||
'            -- NEI 28.11.12'||unistr('\000a')||
'            -- Falls gültiges Rezept gespeichert wird, gibts neue MN-Version => Neue ID holen'||unistr('\000a')||
'            select';

p:=p||' id, bezeichnung, bemerkung,rezept_nr, version ,akt_version,mn_reztyp_id,status  '||unistr('\000a')||
'            into :p201_mn_rezept_id,:p201_bezeichnung,:p201_bemerkung,:p201_rezept_nr,:p201_version,'||unistr('\000a')||
'                 :p201_akt_version,:p201_mn_reztyp_id,v_status '||unistr('\000a')||
'            from v_mn_rezepte '||unistr('\000a')||
'            where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'              and version = rezepte.get_prodr_max_vers(:p201_rezept_nr);  '||unistr('\000a')||
''||unistr('\000a')||
'';

p:=p||'            -- Falls gültiges Rezept gespeichert wird, gibts neue Prod-Version => Neue ID holen'||unistr('\000a')||
'            SELECT id INTO :p201_prod_rezept_id           -- NEI 28.11.12'||unistr('\000a')||
'            FROM prod_rezepte'||unistr('\000a')||
'            WHERE version = :p201_version'||unistr('\000a')||
'              AND rezept_nr = :p201_rezept_nr;'||unistr('\000a')||
'          */ '||unistr('\000a')||
'          /* NEI 08.04.14 Eigene Funktion, da im WK ebenfalls benötigt wird'||unistr('\000a')||
'            UPDATE pr';

p:=p||'od_rezepte'||unistr('\000a')||
'            SET    reichweite = :p202_reichweite '||unistr('\000a')||
'            WHERE id = :p201_prod_rezept_id;'||unistr('\000a')||
''||unistr('\000a')||
'            -- Ggf. Reichweiten der Splitkomponenten'||unistr('\000a')||
'            UPDATE prod_rezepte '||unistr('\000a')||
'            SET reichweite = :p202_reichweite'||unistr('\000a')||
'            WHERE id in (SELECT pr_split.id '||unistr('\000a')||
'                         FROM prod_rezepte pr_split, mn_rezepte mnr,prod_rezepte pr'||unistr('\000a')||
'                         WHERE p';

p:=p||'r.id =  :p201_prod_rezept_id'||unistr('\000a')||
'                           AND mnr.REZEPT_NR_SPLITBASIS= pr.rezept_nr'||unistr('\000a')||
'                           AND mnr.version_splitbasis =  pr.version'||unistr('\000a')||
'                           AND pr_split.rezept_nr = mnr.rezept_nr'||unistr('\000a')||
'                           AND pr_split.version = mnr.version'||unistr('\000a')||
'                         );'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others then'||unistr('\000a')||
'             v_fehlertext := SQL';

p:=p||'ERRM;'||unistr('\000a')||
'             RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                                        v_fehlertext,''reichweite_aendern'''||unistr('\000a')||
'                                      ));'||unistr('\000a')||
'         END;'||unistr('\000a')||
'         */'||unistr('\000a')||
''||unistr('\000a')||
'         /* NEI 28.11.12 da nun immer eine neue Version geholt wird, wird automatisch der Status geholt und'||unistr('\000a')||
'         -- Aktuellen Status holen für den Bearb.modu';

p:=p||'s am Ende relevant'||unistr('\000a')||
'         select status '||unistr('\000a')||
'         into v_status '||unistr('\000a')||
'         from v_mn_rezepte '||unistr('\000a')||
'         where id  = :p201_mn_rezept_id;  '||unistr('\000a')||
'         */'||unistr('\000a')||
'         /* 08.04.14 Eigene Funktion, da im WK ebenfalls benötigt wird'||unistr('\000a')||
'         -- Artikelmengen hinsichtlich der Reichweite anpassen'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            UPDATE prodr_details'||unistr('\000a')||
'            SET  gewicht = gewicht/:p202_db_reichweite * :p202_reich';

p:=p||'weite'||unistr('\000a')||
'            WHERE p_rezept_id = :p201_prod_rezept_id;'||unistr('\000a')||
''||unistr('\000a')||
'           -- Ggf. Artikelmenge der Splitkomponenten anpassen'||unistr('\000a')||
'            UPDATE prodr_details'||unistr('\000a')||
'            SET  gewicht = gewicht/:p202_db_reichweite * :p202_reichweite'||unistr('\000a')||
'            WHERE p_rezept_id in'||unistr('\000a')||
'                        (SELECT pr_split.id '||unistr('\000a')||
'                         FROM prod_rezepte pr_split, mn_rezepte mnr,prod_rezepte pr'||unistr('\000a')||
'        ';

p:=p||'                 WHERE pr.id =  :p201_prod_rezept_id'||unistr('\000a')||
'                           AND mnr.REZEPT_NR_SPLITBASIS= pr.rezept_nr'||unistr('\000a')||
'                           AND mnr.version_splitbasis =  pr.version'||unistr('\000a')||
'                           AND pr_split.rezept_nr = mnr.rezept_nr'||unistr('\000a')||
'                           AND pr_split.version = mnr.version'||unistr('\000a')||
'                         );            '||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others t';

p:=p||'hen'||unistr('\000a')||
'             v_fehlertext := SQLERRM;'||unistr('\000a')||
'             RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                                        v_fehlertext,''reichweite_aendern'''||unistr('\000a')||
'                                      ));'||unistr('\000a')||
'         END;'||unistr('\000a')||
'         */'||unistr('\000a')||
'         '||unistr('\000a')||
'         /*NEI 29.01.14 keine Änderung mehr am MNR => kein Check Max mehr notwendig'||unistr('\000a')||
'         -- NEI 28.11.12 '||unistr('\000a')||
'      ';

p:=p||'   -- Check Max-Grenzwerte und ggf. Status von Arbeitsversion in gültige Version setzen'||unistr('\000a')||
'         v_return := rezepte.CHECK_MNR_GRENZWERTE'||unistr('\000a')||
'                       (:p201_mn_rezept_id,'||unistr('\000a')||
'                        1,    -- Maxwertprüfung Grenwerttyp=1'||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'         IF v_return > 0 THEN'||unistr('\000a')||
'            --''Es wurden Grenzwerte bei den Inhaltsstoffen übers';

p:=p||'chritten!..... '||unistr('\000a')||
'            :p202_fehlertext := frgbg_s.holen_uebersetzung(4880,v_sprache_id);'||unistr('\000a')||
'         ELSIF v_return < 0 THEN'||unistr('\000a')||
'            --''Die Grenzwertprüfung konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'            :p202_fehlertext := frgbg_s.holen_uebersetzung(4881,v_sprache_id);'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            -- Gueltige Version '||unistr('\000a')||
'            UPDATE v_prod_rezepte                             '||unistr('\000a')||
'           ';

p:=p||' SET    bezeichnung = bezeichnung,'||unistr('\000a')||
'                   prod_rezstatus_id = 2 -- gueltige Version initieren     '||unistr('\000a')||
'            WHERE id = :p201_prod_rezept_id;  '||unistr('\000a')||
'            -- Speichern, Runden ,Reichweite etc. erfolgreich => ggf. MNR-Split durchführen '||unistr('\000a')||
'            :P202_OPERATION_OK := 1; -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         */'||unistr('\000a')||
''||unistr('\000a')||
'         -- NEI 08.04.14 Eigen';

p:=p||'e Funktion, da im WK ebenfalls benötigt wird'||unistr('\000a')||
'         v_return := rezepte.ANPASSEN_PRODR_REICHWEITE(:p201_prod_rezept_id,:P202_REICHWEITE);'||unistr('\000a')||
'         IF v_return <= 0 THEN'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(583,v_sprache_id);'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,v_sprache_id,'||unistr('\000a')||
'                                        v_fehlertext,''P202/reichwe';

p:=p||'ite_aendern'''||unistr('\000a')||
'                                      ));'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;  '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   /* -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept  '||unistr('\000a')||
'      -- => Checks und Bearb.modus setzen, wird nun zentral gemacht im Prozess rezept_checken_neu_laden'||unistr('\000a')||
'      -- NEI 19.09.13'||unistr('\000a')||
'      -- Check Kleinstmengenartikel'||unistr('\000a')||
'      -- Kleinstartikelmengen: Falls die Artikelanzahl kleiner als diese Grenz';

p:=p||'e ist, erfolgt Hinweismeldung'||unistr('\000a')||
'      v_session_id := NVL(v(''APP_SESSION''),userenv(''sessionid''));'||unistr('\000a')||
'      DELETE FROM mn_mengenarts_exclude'||unistr('\000a')||
'      WHERE session_id = v_session_id; -- wg. apex und session_pooling koennen mehrere App-sessions in einer DB-Sessions laufen'||unistr('\000a')||
'   '||unistr('\000a')||
'      v_return := rezepte.CHECK_KLEINSTARTIKELMENGEN(:p201_prod_rezept_id,NULL,:P202_MIN_ARTIKELGEWICHT_GR);'||unistr('\000a')||
'      IF v_return > 0 T';

p:=p||'HEN -- Kleinstmengen gefunden'||unistr('\000a')||
'         SELECT listagg(fas_synch.get_tab_uebersetzung(''MN_REZEPTE.BEZEICHNUNG'',m.MN_REZEPT_ID,:fas_sprache_id) ,'', '')'||unistr('\000a')||
'                WITHIN GROUP (ORDER BY m.kuerzel)  INTO v_artikelliste'||unistr('\000a')||
'         FROM mengenarts m, mn_mengenarts_exclude me'||unistr('\000a')||
'         where m.id = me.mengenart_id'||unistr('\000a')||
'           and me.session_id = v_session_id;'||unistr('\000a')||
'         IF v_artikelliste is not null THEN'||unistr('\000a')||
'';

p:=p||'            --''Es wurden Artikel unterhalb der Kleinstmengengrenze gefunden'''||unistr('\000a')||
'            :p202_fehlertext := :p202_fehlertext||''\n''|| '||unistr('\000a')||
'                             frgbg_s.holen_uebersetzung(7988,v_sprache_id,:P202_MIN_ARTIKELGEWICHT_GR,v_artikelliste); 	'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Bearbeitungsmodus neu setzen'||unistr('\000a')||
'      IF :p201_akt_version = 1 AND '||unistr('\000a')||
'         v_status not in (2,3) -- enth';

p:=p||'ält keine ungültige Rezeptversion => komplettes Rezept gültig'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         :p201_bearb_modus := ''BEARBEITEN'';'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p201_bearb_modus := ''ANZEIGEN'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
'   -- NEI 10.01.2014'||unistr('\000a')||
'   */'||unistr('\000a')||
'--MEL.P(''Reichweite Ende mnr : %1, Prod %2, op_ok %3  '',v_prot_id,''TEST'',''102/202:reichweite'', :p201_mn_rezept_id,:p202_id,:p202_operation_ok);'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7872525519212167 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 55,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'reichweite_aendern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'REICHWEITE REICHWEITE_BMI',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'    v_mn_rezept_id_neu  mn_rezepte.id%TYPE;'||unistr('\000a')||
'    v_version_neu       mn_rezepte.version%TYPE;'||unistr('\000a')||
'    v_gen_hint1         prod_rezepte.gen_hint1%TYPE;'||unistr('\000a')||
'    v_gen_hint2         prod_rezepte.gen_hint1%TYPE;'||unistr('\000a')||
'    v_reichweite        prod_rezepte.reichweite%TYPE;'||unistr('\000a')||
'    v_PROD_REZSTATUS_ID prod_rezepte.PROD_REZSTATUS_ID%TYPE;'||unistr('\000a')||
'    v_prod_rezept_id    prod_rezepte.ID%TYPE;'||unistr('\000a')||
'    v_status            number;';

p:=p||''||unistr('\000a')||
'    v_runden            number;'||unistr('\000a')||
'    v_return            number;'||unistr('\000a')||
'    v_prot_id           number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P(''MNR-Split Start MNR-Split : %1, Prod %2, op_ok %3,split %4,art %5 '',v_prot_id,''TEST'',''102/202:mnr_splitten'', :p201_mn_rezept_id,:p202_id,:P202_OPERATION_OK,:P202_MN_SPLIT_FLAG,:P202_MN_REZART_ID);'||unistr('\000a')||
'   -- MN-Split?'||unistr('\000a')||
'   IF :P202_OPERATION_OK  = 1 AND  -- bisherige Transaktion ok (Speichern, ';

p:=p||'Runden,Reichweite etc.)'||unistr('\000a')||
'      :P202_MN_SPLIT_FLAG = 1 AND  -- bisher mit Split => wieder splitten'||unistr('\000a')||
'      :P202_MN_REZART_ID  = 0      -- Gesamtrezept'||unistr('\000a')||
'   THEN         -- Ggf. Split durchführen'||unistr('\000a')||
'--MEL.P(''MNR-Split 1 MNR-Split : %1, Prod %2, op_ok '',v_prot_id,''TEST'',''102/202:mnr_splitten'');'||unistr('\000a')||
'      -- Bestimmen des Produktrezeptes für die Parameter'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT prodr.id INTO v_prod_rezept_';

p:=p||'id'||unistr('\000a')||
'         FROM prod_rezepte prodr, mn_rezepte mnr'||unistr('\000a')||
'         WHERE mnr.id = :p201_mn_rezept_id'||unistr('\000a')||
'           AND prodr.version = mnr.version'||unistr('\000a')||
'           AND prodr.rezept_nr = mnr.rezept_nr;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN no_data_found THEN'||unistr('\000a')||
'         v_prod_rezept_id := NULL;'||unistr('\000a')||
'      WHEN others then'||unistr('\000a')||
'         NULL;--RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(528,:fas_sprache_id));'||unistr('\000a')||
'      END;  ';

p:=p||'    '||unistr('\000a')||
'--MEL.P(''MNR-Split 2 MNR-Split : %1, Prod %2, op_ok '',v_prot_id,''TEST'',''102/202:mnr_splitten'');'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_prod_rezept_id IS NOT NULL THEN  -- prod_rezept_id'||unistr('\000a')||
'         -- Holen der Reichweite aus dem Produktrezept oder der Default aus den Optionswerten'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT reichweite,gen_hint1,PROD_REZSTATUS_ID INTO v_reichweite,v_gen_hint1,v_PROD_REZSTATUS_ID'||unistr('\000a')||
'            FROM pr';

p:=p||'od_rezepte p'||unistr('\000a')||
'            WHERE p.id = v_prod_rezept_id;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'             --v_reichweite := 30;  NEI 07.07.08 Default aus Optionswerte opttyp_id =7'||unistr('\000a')||
'             v_reichweite := NVL(frgbg_s.GET_PERS_OPTION(:APP_USER,7),30);'||unistr('\000a')||
'             v_gen_hint1 := 1;'||unistr('\000a')||
'             v_PROD_REZSTATUS_ID:= 0;'||unistr('\000a')||
'         END;'||unistr('\000a')||
'      ELSE  -- Reichweiten-Default setzen'||unistr('\000a')||
'         v_r';

p:=p||'eichweite := NVL(frgbg_s.GET_PERS_OPTION(:APP_USER,7),30);'||unistr('\000a')||
'         v_gen_hint1 := 1;'||unistr('\000a')||
'         v_PROD_REZSTATUS_ID:= 0;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_PROD_REZSTATUS_ID = 1 THEN -- Arbreitsversion des Produktrepzeptes => keine Splittung'||unistr('\000a')||
'         --''MNR-Split konnte nicht durchgeführt werden, da es sich um eine Arbeitsversion des Produktrezeptes handelt!'');'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR(-20000, frgbg_';

p:=p||'s.holen_uebersetzung(9200,:fas_sprache_id));'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'--MEL.P(''MNR-Split 3 MNR-Split : %1, Prod %2, op_ok '',v_prot_id,''TEST'',''102/202:mnr_splitten'');'||unistr('\000a')||
''||unistr('\000a')||
'      -- Holen des Kennzeichens der Artikelrundung aus den Optionswerten'||unistr('\000a')||
'      v_runden := NVL(frgbg_s.GET_PERS_OPTION(:APP_USER,26),0);   '||unistr('\000a')||
'      IF v_runden != 0 THEN'||unistr('\000a')||
'         v_gen_hint2 := -v_reichweite;  -- Negative Reichweite => n-Tage ho';

p:=p||'chrechnen inkl. runden'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_gen_hint2 := v_reichweite;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'--MEL.P(''MNR-Split 4 MNR-Split : %1, Prod %2, op_ok '',v_prot_id,''TEST'',''102/202:mnr_splitten'');'||unistr('\000a')||
''||unistr('\000a')||
'      v_return := rezepte.GEN_MNR_SPLIT (:p201_mn_rezept_id,v_gen_hint1,v_gen_hint2, :fas_sortiment_id);'||unistr('\000a')||
'      IF v_return = 1 THEN'||unistr('\000a')||
'         -- Neue Rezept-id/Version holen '||unistr('\000a')||
'         v_version_neu := rezepte.get_mnr_m';

p:=p||'ax_version(:p201_rezept_nr);'||unistr('\000a')||
'         select id into v_mn_rezept_id_neu'||unistr('\000a')||
'         from mn_rezepte '||unistr('\000a')||
'         where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'           and version = v_version_neu;'||unistr('\000a')||
''||unistr('\000a')||
'         -- Neue Rezept-ID FAS bekannt machen'||unistr('\000a')||
'         :p201_mn_rezept_id := v_mn_rezept_id_neu;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         -- ''MNR-Split konnte nicht durchgeführt werden!'');'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR(-20000, frgbg_s.h';

p:=p||'olen_uebersetzung(9201,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'--MEL.P(''MNR-Split 5 MNR-Split : %1, Prod %2, op_ok '',v_prot_id,''TEST'',''102/202:mnr_splitten'');'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--MEL.P(''MNR-Split Ende MNR-Split : %1, Prod %2 '',v_prot_id,''TEST'',''102/202:mnr_splitten'', :p201_mn_rezept_id,:p202_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7360103594563835 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 56,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mnr_splitten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request in (''SPEICHERN'',''PROD_SPEICHERN'',''REICHWEITE'',''REICHWEITE_BMI'',''RUNDEN'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_status            number;'||unistr('\000a')||
'   v_session_id        VARCHAR2(250);  -- NEI 19.09.13'||unistr('\000a')||
'   v_artikelliste      varchar2(2000); -- NEI 19.09.13'||unistr('\000a')||
'   v_prod_rezstatus_id prod_rezepte.prod_rezstatus_id%TYPE;'||unistr('\000a')||
'   v_reichweite        prod_rezepte.reichweite%TYPE;  -- NEI 29.01.14'||unistr('\000a')||
'   v_return  NUMBER;'||unistr('\000a')||
'   v_prot_id NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P(''Rezeptladen Start mnr : %1, Prod %2 '',v_prot_id,''TEST'',''102/202:';

p:=p||'rezept_neu_laden'', :p201_mn_rezept_id,:p202_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Rezeptdaten neu laden'||unistr('\000a')||
'   IF :p201_mn_rezept_id IS NOT NULL THEN'||unistr('\000a')||
'      SELECT bezeichnung, bemerkung,rezept_nr, version ,akt_version,mn_reztyp_id,status,'||unistr('\000a')||
'             MN_REZART_ID   -- NEI 14.01.14 MN-Split mit rückgerechnetem Gesamtrezept'||unistr('\000a')||
'        INTO :p201_bezeichnung, :p201_bemerkung,:p201_rezept_nr,:p201_version,:p201_akt_version,'||unistr('\000a')||
'        ';

p:=p||'     :p201_mn_reztyp_id ,v_status,'||unistr('\000a')||
'             :P201_MN_REZART_ID'||unistr('\000a')||
'      FROM v_mn_rezepte'||unistr('\000a')||
'      WHERE id = :p201_mn_rezept_id;'||unistr('\000a')||
''||unistr('\000a')||
'      -- evt. vorhandenes Produktrezept holen'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT id,prod_rezstatus_id'||unistr('\000a')||
'              ,reichweite     -- NEI 29.01.14 min-Gramm Artikelmenge je Tag => mit Reichweite hochrechnen'||unistr('\000a')||
'         INTO :p201_prod_rezept_id, v_prod_rezstatus_id'||unistr('\000a')||
'              ';

p:=p||',v_reichweite   -- NEI 29.01.14 '||unistr('\000a')||
'         FROM prod_rezepte'||unistr('\000a')||
'         WHERE version = :p201_version'||unistr('\000a')||
'           AND rezept_nr = :p201_rezept_nr;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN no_data_found THEN'||unistr('\000a')||
'         :p201_prod_rezept_id := NULL;'||unistr('\000a')||
'      WHEN others then'||unistr('\000a')||
'         NULL;--RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(528,v_sprache_id));'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p201_bezeichnung := NULL;'||unistr('\000a')||
'  ';

p:=p||'    :p201_bemerkung   := NULL;'||unistr('\000a')||
'      :p201_rezept_nr   := NULL;'||unistr('\000a')||
'      :p201_version     := NULL;'||unistr('\000a')||
'      :p201_akt_version := NULL;'||unistr('\000a')||
'      :p201_mn_reztyp_id := NULL;'||unistr('\000a')||
'      :P201_MN_REZART_ID := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'--MEL.P(''Rezeptladen vor check mnr : %1, Prod %2,status %3 '',v_prot_id,''TEST'',''102/202:rezept_neu_laden'', :p201_mn_rezept_id,:p201_prod_rezept_id,v_prod_rezstatus_id);'||unistr('\000a')||
'   -- Checks, falls Än';

p:=p||'derungen auf der Produkteseite und eine gueltige Version erstellt wurde'||unistr('\000a')||
'   -- => ggf. Hinweismeldungen f. Warngrenzen- und Kleinstmengen-Verstößen'||unistr('\000a')||
'   IF :request in (''PROD_SPEICHERN'',''REICHWEITE'',''REICHWEITE_BMI'',''RUNDEN'') AND'||unistr('\000a')||
'      v_prod_rezstatus_id = 2 -- gueltige Version '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'--MEL.P(''Rezeptladen in check mnr : %1, Prod %2,status %3 '',v_prot_id,''TEST'',''102/202:rezept_neu_laden'', :p201_mn_';

p:=p||'rezept_id,:p201_prod_rezept_id,v_prod_rezstatus_id);'||unistr('\000a')||
'      -- CHECKS f. Warngrenzen und Kleinstmengen'||unistr('\000a')||
'      -- Check Arzt-Grenzwerte                       -- NEI 29.07.14 Arztgrenzwert neu eingefügt'||unistr('\000a')||
'      v_return := rezepte.CHECK_MNR_GRENZWERTE'||unistr('\000a')||
'                       (:p201_mn_rezept_id,'||unistr('\000a')||
'                        4,    -- Arztgrenzwertprüfung Grenwerttyp=4'||unistr('\000a')||
'                        1);   -- Runden au';

p:=p||'f 1 Nachkommastelle'||unistr('\000a')||
'      IF v_return > 0 THEN'||unistr('\000a')||
'         --''Es wurden Arzt-Grenzwerte bei den Inhaltsstoffen überschritten!..... '||unistr('\000a')||
'         :p202_fehlertext := :p202_fehlertext||''\n''|| frgbg_s.holen_uebersetzung(10353,:fas_sprache_id);'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         -- Check Warn-Grenzwerte'||unistr('\000a')||
'         v_return := rezepte.CHECK_MNR_GRENZWERTE'||unistr('\000a')||
'                       (:p201_mn_rezept_id,'||unistr('\000a')||
'                        5, ';

p:=p||'   -- Warnwertprüfung Grenwerttyp=5'||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'         IF v_return > 0 THEN'||unistr('\000a')||
'            --''Es wurden WarnGrenzwerte bei den Inhaltsstoffen überschritten!..... '||unistr('\000a')||
'            :p202_fehlertext := :p202_fehlertext||''\n''|| frgbg_s.holen_uebersetzung(4882,:fas_sprache_id);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Check Kleinstmengenartikel'||unistr('\000a')||
'      -- Klei';

p:=p||'nstartikelmengen: Falls die Artikelanzahl kleiner als diese Grenze ist, erfolgt Hinweismeldung'||unistr('\000a')||
'      v_session_id := NVL(v(''APP_SESSION''),userenv(''sessionid''));'||unistr('\000a')||
'      DELETE FROM mn_mengenarts_exclude'||unistr('\000a')||
'      WHERE session_id = v_session_id; -- wg. apex und session_pooling koennen mehrere App-sessions in einer DB-Sessions laufen'||unistr('\000a')||
'   '||unistr('\000a')||
'      v_return := rezepte.CHECK_KLEINSTARTIKELMENGEN(:p201_prod_rez';

p:=p||'ept_id,NULL,:P202_MIN_ARTIKELGEWICHT_GR);'||unistr('\000a')||
'      IF v_return > 0 THEN -- Kleinstmengen gefunden'||unistr('\000a')||
'         SELECT listagg(fas_synch.get_tab_uebersetzung(''MN_REZEPTE.BEZEICHNUNG'',m.MN_REZEPT_ID,:fas_sprache_id) ,'', '')'||unistr('\000a')||
'                WITHIN GROUP (ORDER BY m.kuerzel)  INTO v_artikelliste'||unistr('\000a')||
'         FROM mengenarts m, mn_mengenarts_exclude me'||unistr('\000a')||
'         where m.id = me.mengenart_id'||unistr('\000a')||
'           and me.sessio';

p:=p||'n_id = v_session_id;'||unistr('\000a')||
'         IF v_artikelliste is not null THEN'||unistr('\000a')||
'            --''Es wurden Artikel unterhalb der Kleinstmengengrenze gefunden'''||unistr('\000a')||
'            :p202_fehlertext := :p202_fehlertext||''\n''|| '||unistr('\000a')||
'                                frgbg_s.holen_uebersetzung(7988,:fas_sprache_id,:P202_MIN_ARTIKELGEWICHT_GR*v_reichweite,v_artikelliste); 	'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'--MEL.P(''Rezeptladen nach che';

p:=p||'ck mnr : %1, Prod %2,status %3,Hinweis %4 '',v_prot_id,''TEST'',''102/202:rezept_neu_laden'', :p201_mn_rezept_id,:p201_prod_rezept_id,v_prod_rezstatus_id,:p202_fehlertext);'||unistr('\000a')||
''||unistr('\000a')||
'   END IF; -- Check auf Änderung Prodseite'||unistr('\000a')||
''||unistr('\000a')||
'   -- Bearbeitungsmodus neu setzen'||unistr('\000a')||
'   IF :p201_akt_version = 1 AND '||unistr('\000a')||
'      v_status not in (2,3) AND -- enthält keine ungültige Rezeptversion => komplettes Rezept gültig'||unistr('\000a')||
'      :p201_mnr_ae';

p:=p||'nderbar = ''J'' AND'||unistr('\000a')||
'      (:p201_mnr_vorschrift = 0 OR     -- MNR-Vorschriften nur von Betreuern mit'||unistr('\000a')||
'         :p201_mnr_vorschrift = 1 AND  -- entsprechender Rolle'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''MNR_VORSCHRIFT_VERWALTEN'') != 0'||unistr('\000a')||
'      ) and '||unistr('\000a')||
'      :fas_pers_aenderbar = 1         -- Personendaten aenderbar'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p201_bearb_modus := ''BEARBEITEN'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p201_bearb_modus := ';

p:=p||'''ANZEIGEN'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--MEL.P(''Rezeptladen Ende mnr : %1, Prod %2 '',v_prot_id,''TEST'',''102/202:rezept_neu_laden'', :p201_mn_rezept_id,:p202_id);'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''Ende rezept laden Produktrezepts =%1,MN-ID=%2,%3,%4! [seite202,rezept_neu_laden]''||to_char(SYSDATE,''DD.MM.YYYY DD.MM.YYYY HH24:MI:SS''), v_PROT_ID, ''TEST'', ''seite202,rezept_neu_laden'',to_char(:p201_prod_rezept_id),to_char(:p201_mn_rezept_id),'||unistr('\000a')||
'to_';

p:=p||'char(:p201_rezept_nr),to_char(:p201_version ));'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6748300080802928 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 57,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'rezept_checken_neu_laden',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''CANCEL'',''SPEICHERN'',''PROD_SPEICHERN'',''REICHWEITE'',''REICHWEITE_BMI'',''RUNDEN'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_akt_version       mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_fehlertext    VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id       number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p202_prod_rezstatus_id = 1 AND :request = ''PROD_CANCEL'' THEN'||unistr('\000a')||
'      -- Prodrezeptdetails löschen'||unistr('\000a')||
'      DELETE from prodr_details'||unistr('\000a')||
'      WHERE p_rezept_id = :p202_id;'||unistr('\000a')||
'      --Prodrezept löschen'||unistr('\000a')||
'      DELETE FROM prod_rezepte'||unistr('\000a')||
'      WHERE id = :p202_id;'||unistr('\000a')||
'      -- MNR-Detail';

p:=p||'s des Produktrezepts loeschen'||unistr('\000a')||
'      DELETE FROM mnr_details'||unistr('\000a')||
'      WHERE mn_rezept_id = :p201_mn_rezept_id;'||unistr('\000a')||
'      -- MNR löschen'||unistr('\000a')||
'      DELETE FROM mn_rezepte'||unistr('\000a')||
'      WHERE id = :p201_mn_rezept_id;'||unistr('\000a')||
'      -- Aktuelles Rezept initialisieren'||unistr('\000a')||
'      -- Gültiges MN-Rezept holen'||unistr('\000a')||
'      v_akt_version  := rezepte.get_prodr_max_vers(:p201_rezept_nr);'||unistr('\000a')||
'      SELECT id, bezeichnung, bemerkung,rezept_nr, version ,ak';

p:=p||'t_version,mn_reztyp_id'||unistr('\000a')||
'      INTO :p201_mn_rezept_id,:p201_bezeichnung,:p201_bemerkung,:p201_rezept_nr,:p201_version,'||unistr('\000a')||
'           :p201_akt_version,:p201_mn_reztyp_id '||unistr('\000a')||
'      FROM v_mn_rezepte '||unistr('\000a')||
'      where rezept_nr = :p201_rezept_nr'||unistr('\000a')||
'        AND version = v_akt_version;  '||unistr('\000a')||
''||unistr('\000a')||
'      -- Gültiges Prod-Rezept holen'||unistr('\000a')||
'      SELECT id INTO :p201_prod_rezept_id'||unistr('\000a')||
'      FROM prod_rezepte'||unistr('\000a')||
'      WHERE version = :p20';

p:=p||'1_version'||unistr('\000a')||
'        AND rezept_nr = :p201_rezept_nr;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others then'||unistr('\000a')||
'     v_fehlertext := SQLERRM;'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'                               v_fehlertext,''FAS/202 arbeitsversion_verwerfen'''||unistr('\000a')||
'                             ));'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3295922164187367 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 58,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'arbeitsversion_verwerfen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>7753827393615884 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_warenkorb_id  warenkoerbe.id%TYPE;'||unistr('\000a')||
'   v_return        number;'||unistr('\000a')||
''||unistr('\000a')||
'   v_wk_status_id  warenkorb_status.id%TYPE;'||unistr('\000a')||
'   v_wk_zahlungsart_id  warenkoerbe.wk_zahlungsart_id%TYPE;  '||unistr('\000a')||
'   v_etikettentyp  NUMBER;'||unistr('\000a')||
'   v_sprache_id    NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_fehlernummer  NUMBER;'||unistr('\000a')||
'   v_fehlertext    VARCHAR2(2000);'||unistr('\000a')||
'   v_fehler        exception;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P (''Bestellun';

p:=p||'g ''||:REQUEST||''|''||:FAS_LOGIN_PERSONENSTAMM_ID||''|''||:p202_persstamm_id_prod_apo, v_PROT_ID, ''TEST'',''FAS102/202 wk_registrieren'');'||unistr('\000a')||
'   --:p215_warenkorb_id := null;'||unistr('\000a')||
'   --IF :REQUEST in (''PROD_BESTELLUNG'',''PROD_BESTELLUNG_PAY'') '||unistr('\000a')||
'   --THEN'||unistr('\000a')||
'--MEL.P (''OK Bestellung gespeichert ''||:REQUEST, v_PROT_ID, ''TEST'', ''FAS102/202 wk_registrieren'');'||unistr('\000a')||
'      -- Warenkorb auf der Basis eines Rezepts mit '||unistr('\000a')||
'      -- Wa';

p:=p||'renkorb_Details erstellen, aufgesplittet nach Komponenten gemaess prodkennzeichen'||unistr('\000a')||
'      v_wk_status_id := 5;       -- Bestellung zunächst mit Status 5 und danach mit Status 60 ablegen und nicht ausführen => WK registrieren'||unistr('\000a')||
'      v_wk_zahlungsart_id := 3;  -- Vorkasse sonst geht es direkt in freigegeben im wk_gen_warenkorb   '||unistr('\000a')||
'      v_etikettentyp := frgbg_s.get_pers_option(:APP_USER,1);'||unistr('\000a')||
'      v_ret';

p:=p||'urn := frgbg_s.wk_gen_warenkorb ('||unistr('\000a')||
'                      :p201_rezept_nr,'||unistr('\000a')||
'                      :p201_version,'||unistr('\000a')||
'                      :FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                      :p202_persstamm_id_prod_apo,'||unistr('\000a')||
'                      to_date(sysdate,''DD.MM.RRRR''),'||unistr('\000a')||
'                      v_wk_status_id, -- 10= bestellt, 5=in Bezahlung, Best. noch nicht aktiviert'||unistr('\000a')||
'                      1, -- Menge imm';

p:=p||'er 1'||unistr('\000a')||
'                      v_etikettentyp,'||unistr('\000a')||
'                      :FAS_IDENTITAET_PERSSTAMM_ID,-- aktive Identitaet   NEI 08.03.2012'||unistr('\000a')||
'                      :p202_persstamm_id_prod_apo, -- Rechnungssteller: def. ProdApo NEI 08.03.2012 '||unistr('\000a')||
'                      v_wk_zahlungsart_id,         -- NEI 28.03.12'||unistr('\000a')||
'                      0, -- p_mode = 0 direkt in WK nicht temporär'||unistr('\000a')||
'                      1, -- p_fla';

p:=p||'g = 1 Fertigartikel auf ganze Packungen runden NEI 17.10.13'||unistr('\000a')||
'                      1, -- p_mnr_mode = 1 mit allen Split-Rezepten  NEI 17.10.13'||unistr('\000a')||
'                      1  -- NEI 18.06.14 Reichweitenstaffel-Rabattberechnung (=1) für Mischungen,'||unistr('\000a')||
'                         --              nur  noch im WK und auf Bestellschein sonst keine Rabattrechnung'||unistr('\000a')||
'                     );'||unistr('\000a')||
'      IF v_return <= 0 THEN --';

p:=p||' Fehler'||unistr('\000a')||
'         v_fehlernummer := -10;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_warenkorb_id := v_return;'||unistr('\000a')||
'         -- Bestellung auf abgeschlossen setzen'||unistr('\000a')||
'         v_return :=frgbg_s.WK_UPD_STATUS (v_WARENKORB_ID,NULL, 61);'||unistr('\000a')||
'         IF v_return < 0 THEN'||unistr('\000a')||
'            v_fehlernummer := -20;'||unistr('\000a')||
'            RAISE v_fehler;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'--MEL.P (''Bestellung ''||v_warenkorb_id||''|''||:';

p:=p||'request||''|''||v_wk_status_id, v_PROT_ID, ''TEST'',''FAS102/202 wk_registrieren'');'||unistr('\000a')||
'      --''Mischung wurde erfolgreich registriert!'';'||unistr('\000a')||
'      :p202_fehlertext := frgbg_s.holen_uebersetzung(8017,v_sprache_id,'||unistr('\000a')||
'                              to_char(:p201_rezept_nr)||''/''||to_char(:p201_version)'||unistr('\000a')||
'                             );'||unistr('\000a')||
'   --END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'    ROLLBACK;'||unistr('\000a')||
'    :p202_fehlertext := fr';

p:=p||'gbg_s.holen_uebersetzung(8016,v_sprache_id,'||unistr('\000a')||
'                              to_char(:p201_rezept_nr)||''/''||to_char(:p201_version)'||unistr('\000a')||
'                             );'||unistr('\000a')||
'    v_fehlertext := :p202_fehlertext ||'' (''||v_fehlernummer||'')'';'||unistr('\000a')||
'    MEL.P (v_fehlertext, v_PROT_ID, ''ERROR'', ''FAS102/202 wk_registrieren'');'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'    v_fehlertext := SQLERRM;'||unistr('\000a')||
'    ROLLBACK;'||unistr('\000a')||
'    :p202_fehlertext := frgbg_s.holen_';

p:=p||'uebersetzung(8016,v_sprache_id,'||unistr('\000a')||
'                              to_char(:p201_rezept_nr)||''/''||to_char(:p201_version)'||unistr('\000a')||
'                             );'||unistr('\000a')||
'    v_fehlertext :=  :p202_fehlertext ||'' '' ||v_fehlertext;'||unistr('\000a')||
'    MEL.P (v_fehlertext, v_PROT_ID, ''ERROR'', ''FAS102/202 wk_registrieren'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6104232682791003 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'BESTELLUNG_REGISTRIEREN',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>6102629415629132 + wwv_flow_api.g_id_offset,
  p_process_success_message=> 'Mischung erfolgreich registiert!',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p202_fehlertext := NULL;';

wwv_flow_api.create_page_process(
  p_id     => 7860119997011804 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 70,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_prod_fehlertext',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request not in (''SPEICHERN'',''PROD_SPEICHERN'',''REICHWEITE'',''REICHWEITE_BMI'',''RUNDEN'',''BUT_WK_REGISTRIEREN'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :request in (''P202_MN_ALLE_ANZEIGEN'') THEN'||unistr('\000a')||
'      IF :P202_MN_ALLE_ANZEIGEN = 1 THEN'||unistr('\000a')||
'         :P202_PROD_ALLE_ANZEIGEN := 0 ;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSIF :request in (''P202_PROD_ALLE_ANZEIGEN'') THEN'||unistr('\000a')||
'      IF :P202_PROD_ALLE_ANZEIGEN = 1 THEN'||unistr('\000a')||
'         :P202_MN_ALLE_ANZEIGEN := 0;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1238926543868601 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 90,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'alle_anzeigen_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''P202_MN_ALLE_ANZEIGEN'',''P202_PROD_ALLE_ANZEIGEN'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id  number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   mel.p(''In write_protokoll %1,%2,%3'',v_prot_id,''DEBUG'',''102/202 write_protokoll'',:p202_fehlertext,:request,:p201_mn_rezept_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1326203120111029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 200,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'write_protokoll',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P202_HEIGHT_inhstoffe := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'   :P202_HEIGHT_proddetails  := :FAS_SCROLLREGION_HEIGHT_MAX * 0.7;-- 0.76;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12240502135650850 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p202_id := :p201_prod_rezept_id;'||unistr('\000a')||
''||unistr('\000a')||
'-- Kleinstartikelmengen: Falls die Artikelmenge in Gramm (mögliche verwiegbare Menge) '||unistr('\000a')||
'-- kleiner als diese Grenze ist, erfolgt eine Hinweismeldung'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT  to_number(parameter,''99999999.99999'')      -- Dezimaltrenner ist immer Punkt'||unistr('\000a')||
'      into :P202_MIN_ARTIKELGEWICHT_GR'||unistr('\000a')||
'      FROM  sysareas'||unistr('\000a')||
'      WHERE id = 11';

p:=p||'  ;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      :P202_MIN_ARTIKELGEWICHT_GR := 1/10;   -- Defaultwert 0.1, falls Zugriff fehlschlägt'||unistr('\000a')||
'   END ;'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''Produktrezepts =%1, %2,%3,%4! [seite202,setze_rezept]''||to_char(SYSDATE,''DD.MM.YYYY DD.MM.YYYY HH24:MI:SS''), v_PROT_ID, ''TEST'', ''seite202,setze_rezept'', to_char(:p202_id),:p201_mn_rezept_id,:p201_rezept_nr,:p201_version);'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7493127233124484 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_rezept',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_text VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''In fehlerausgabe'',v_prot_id,''INFO'',''p202/fehlerausgabe'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
''||unistr('\000a')||
'   v_text := :p202_fehlertext;'||unistr('\000a')||
'   :p202_fehlertext := NULL;'||unistr('\000a')||
'   IF v_text is not null THEN'||unistr('\000a')||
'      htp.p(''alert("''||v_text||''");'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1327617327190857 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fehlerausgabe',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''FEHLERAUSGABE''  /*and :p202_fehlertext is not null*/',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'IF :p202_mn_alle_anzeigen IS NULL THEN'||unistr('\000a')||
'   IF :p201_prod_rezept_id IS NOT NULL AND :p202_mn_alle_anzeigen IS NULL THEN'||unistr('\000a')||
'     :p202_mn_alle_anzeigen := 0;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p202_mn_alle_anzeigen := 1;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END IF;';

wwv_flow_api.create_page_process(
  p_id     => 7725211859889232 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_alle_anzeigen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'      v_anz := rezepte.CHECK_MNR_SPLIT_EXIST(NULL,:P201_rezept_nr,:p201_version);'||unistr('\000a')||
'      IF v_anz > 0          -- Rezept mit Splitkomponenten'||unistr('\000a')||
'      THEN  '||unistr('\000a')||
'         :p202_mn_split_flag := 1;  -- mit Split'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p202_mn_split_flag := 0;  -- ohne Split'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7321523663857288 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_mn_split_flag',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':P202_PREPARE_URL_BESTELLEN := '||unistr('\000a')||
'apex_util.prepare_url('||unistr('\000a')||
'''f?p=&APP_ID.:215:&SESSION.::&DEBUG.:215:P215_REZEPT_NR,P215_VERSION,P215_TERRITORY,P215_SPRACHE_ID,P215_P_REZEPT_ID,P215_PERSSTAMM_ID,P215_VERRECHNUNGSLAND:''||'||unistr('\000a')||
':P201_REZEPT_NR||'',''||:P201_VERSION||'',''||:P201_TERRITORY||'',''||:P201_SPRACHE_ID||'',''|| :P202_ID||'',''||:P201_ID||'',''||:P201_VERRECHNUNGSLAND );'||unistr('\000a')||
''||unistr('\000a')||
':P202_PREPARE_URL_WK_REGISTRIER := '||unistr('\000a')||
'ape';

p:=p||'x_util.prepare_url('||unistr('\000a')||
'''f?p=&APP_ID.:215:&SESSION.:WK_REGISTRIEREN:&DEBUG.:215:P215_REZEPT_NR,P215_VERSION,P215_TERRITORY,P215_SPRACHE_ID,P215_P_REZEPT_ID,P215_PERSSTAMM_ID,P215_VERRECHNUNGSLAND:''||'||unistr('\000a')||
':P201_REZEPT_NR||'',''||:P201_VERSION||'',''||:P201_TERRITORY||'',''||:P201_SPRACHE_ID||'',''|| :P202_ID||'',''||:P201_ID||'',''||:P201_VERRECHNUNGSLAND );';

wwv_flow_api.create_page_process(
  p_id     => 2731107334045459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_perpare_url_bestellen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'  --:TEMP_BESTELLDATUM:=to_char(auftragsdispo.GET_LAST_BESTELL_DAT(:p201_mn_rezept_id),''DD.MM.YYYY'');'||unistr('\000a')||
'  :TEMP_BESTELLDATUM:= to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(:p202_id,null),''DD.MM.YYYY'');'||unistr('\000a')||
''||unistr('\000a')||
'  :TEMP_PLANDATUM:= to_char(SYSDATE,''DD.MM.YYYY'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5565112812649637 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 202,
  p_process_sequence=> 90,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_check_datum',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 202
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 12709519294098595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'MN_EINHEIT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 12709630953098595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'MN_MENGE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 12709716864098595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'INHGRP_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 12709830264098595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'INHGRP_BEZEICHNUNG',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 12709901021098595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'BEZEICHNUNG_DISP',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 12710009683098596 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6745205745802917 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'MN_REZEPTRELEVANT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00203
prompt  ...PAGE 203: prodr_verordnungen
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 203
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'prodr_verordnungen'
 ,p_step_title => 'prodr_verordnungen'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'prodr_verordnungen'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130116110753'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2047611319001714 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 203,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'   apex_item.hidden(1,PRODR_VERORDNUNG_ID)||   '||unistr('\000a')||
'   apex_item.hidden(2,REZEPT_NR)||   '||unistr('\000a')||
'   apex_item.hidden(3,PRODKENNZ_ID)||   '||unistr('\000a')||
'   apex_item.hidden(4,MENGENART_ID)|| '||unistr('\000a')||
'   apex_item.hidden(5,PRODR_VERORDNUNG_BEMERKUNG)|| '||unistr('\000a')||
'   apex_item.hidden(8,to_char(PRODR_VERORDNUNG_mutdat,''DD.MM.YYYY hh24:mi:ss''))|| '||unistr('\000a')||
'/* APEX_ITEM.DISPLAY_AND_SAVE(7,PRODKENNZ_BEZEICHNUNG) PRODKENNZ_BEZEICHNUNG, */'||unistr('\000a')||
'   APEX_I';

s:=s||'TEM.DISPLAY_AND_SAVE(7,'||unistr('\000a')||
'        fas_synch.get_tab_uebersetzung(''PRODUKTIONSKENNZEICHEN.BEZEICHNUNG'','||unistr('\000a')||
'                           PRODKENNZ_ID,:fas_sprache_id)) PRODKENNZ_BEZEICHNUNG, '||unistr('\000a')||
'   apex_item.textarea(6,PRODR_VERORDNUNG_BEMERKUNG,3,80)'||unistr('\000a')||
'         PRODR_VERORDNUNG_BEMERKUNG'||unistr('\000a')||
'from v_prodr_verordnungen'||unistr('\000a')||
'where rezept_nr =:p203_rezept_nr';

wwv_flow_api.create_report_region (
  p_id=> 2054113594054535 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 203,
  p_name=> '&P201_REGION_TITEL_VERORDNUNG.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 11,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3072,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '200',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'Keine Daten gefunden',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2054810261054542 + wwv_flow_api.g_id_offset,
  p_region_id=> 2054113594054535 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_BEZEICHNUNG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2054506708054542 + wwv_flow_api.g_id_offset,
  p_region_id=> 2054113594054535 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'PRODR_VERORDNUNG_BEMERKUNG',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 2050112859042017 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 203,
  p_button_sequence=> 30,
  p_button_plug_id => 2054113594054535+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2050411681042017 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 203,
  p_button_sequence=> 10,
  p_button_plug_id => 2054113594054535+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P201_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:202:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>2050901138042018 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 203,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:202:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2056625415086343 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 203,
  p_name=>'P203_REZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 2054113594054535+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2059817992623551 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 203,
  p_name=>'P203_HEIGHT_VERORDNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 2054113594054535+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return NUMBER;'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_return := rezepte.sav_prodr_verordnung(:APP_USER);'||unistr('\000a')||
'   IF v_return < 0 THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(1812,:fas_sprache_id,v_return);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2063022585432134 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 203,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'verordnung_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>2050112859042017 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P203_HEIGHT_verordnung := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2057205029108817 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 203,
  p_process_sequence=> 100,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 203
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00204
prompt  ...PAGE 204: SHOW_HTML_MNR_ZUSATZBEMERKUNG
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 204
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'SHOW_HTML_MNR_ZUSATZBEMERKUNG'
 ,p_step_title => 'SHOW_HTML_MNR_ZUSATZBEMERKUNG'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20120522103139'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4751225808698770 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 204,
  p_plug_name=> '&P204_REGION_TITEL_BEMERKUNG.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891602476489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT_WITH_SHORTCUTS',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4754404026045516 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 204,
  p_button_sequence=> 10,
  p_button_plug_id => 4751225808698770+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P204_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4752407341835411 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 204,
  p_name=>'P204_LANGTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 4751225808698770+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'ZUSATZBEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 2000,
  p_cHeight=> 20,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4753322279868100 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 204,
  p_name=>'P204_MN_REZEPT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4751225808698770+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4754623765051247 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 204,
  p_name=>'P204_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4751225808698770+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4756001003101484 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 204,
  p_name=>'P204_REGION_TITEL_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4751225808698770+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p204_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P204_REGION_TITEL_BEMERKUNG:=NULL;'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4754701040054191 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 204,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'CLOSE_WINDOW';

wwv_flow_api.create_page_process(
  p_id     => 4755214331067474 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 204,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLOSE_WINDOW',
  p_process_name=> 'Close Window',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|PIS:MN_REZEPTE:P204_MN_REZEPT_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 4757605177254049 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 204,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Automatic Row Fetch MN_REZEPTE',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 204
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00215
prompt  ...PAGE 215: Rezeptdruck
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 215
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Rezeptdruck'
 ,p_step_title => 'Rezeptdruck'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Rezeptdruck'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_checkBestelldat (button_name) '||unistr('\000a')||
'{ '||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkBestelldatum'',0);'||unistr('\000a')||
'  var feld_plandat   = document.getElementById(''P215_PLANDATUM'').value;'||unistr('\000a')||
'  var feld_bestelldat= document.getElementById(''P215_BESTELLDATUM'').value ;'||unistr('\000a')||
'  var v_confirm;'||unistr('\000a')||
''||unistr('\000a')||
'  /*alert (feld_bestelldat);*/'||unistr('\000a')||
'  /*alert (feld_plandat);*/'||unistr('\000a')||
'  get.add(''P215_BESTELLDATUM'',feld_bestelldat);'||unistr('\000a')||
'  get.add(''P215_PLANDATUM'',feld_plandat);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  v_confirm = confirm(gReturn);'||unistr('\000a')||
'       if (v_confirm == true)'||unistr('\000a')||
'          {'||unistr('\000a')||
'           /*doSubmit(''PROD_BESTELLUNG'');*/'||unistr('\000a')||
'           doSubmit(button_name);'||unistr('\000a')||
'          }'||unistr('\000a')||
'    }'||unistr('\000a')||
'   else'||unistr('\000a')||
'    {'||unistr('\000a')||
'      /*doSubmit(''PROD_BESTELLUNG'');*/'||unistr('\000a')||
'      doSubmit(button_name);'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140916080646'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 11442916914730010 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 215,
  p_plug_name=> '&P215_REGION_TITEL_OPTIONEN.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 30,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_pers_aenderbar = 1',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 11604823461345318 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 215,
  p_plug_name=> '&P215_REGION_TITEL_PRODREZEPT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 11437932067722251 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 215,
  p_button_sequence=> 10,
  p_button_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P215_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2743515165651275 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 215,
  p_button_sequence=> 40,
  p_button_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_button_name    => 'EXPORT',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P215_BL_REZEPT_EXPORT.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:217:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2455513329437537 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 215,
  p_button_sequence=> 50,
  p_button_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_button_name    => 'DRUCKEN_ANGEBOT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P215_BL_DRUCKEN_ANGEBOT.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P215_P_REZEPT_ID is not null'||unistr('\000a')||
'and :fas_modus_id not in (3) /* Biogena */',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 11443826434730014 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 215,
  p_button_sequence=> 60,
  p_button_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_button_name    => 'OPTION_SPEICHERN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P215_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 12000204584209476 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 215,
  p_button_sequence=> 85,
  p_button_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_button_name    => 'PROD_BESTELLUNG',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P215_BL_PROD_BESTELLUNG.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> 'javascript:f_checkBestelldat(''PROD_BESTELLUNG'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> '/*:FAS_MODUS_ID != 2 or 1=1*/'||unistr('\000a')||
':FAS_PERS_AENDERBAR = 1'||unistr('\000a')||
'and'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Angebot nicht bestellen */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')'||unistr('\000a')||
'and 1=2 /* Abgeloest durch Button zum WK*/',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6279600636340181 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 215,
  p_button_sequence=> 86,
  p_button_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_button_name    => 'PROD_BESTELLUNG_PAY',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P215_BL_PROD_BESTELLUNG_PAY.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> 'javascript:f_checkBestelldat(''PROD_BESTELLUNG_PAY'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> '/*:FAS_MODUS_ID != 2 and*/'||unistr('\000a')||
' 1=2 and /* Abgeloest durch Button zum WK ausserdem Paypal noch nicht aktiv*/'||unistr('\000a')||
':FAS_PERS_AENDERBAR = 1'||unistr('\000a')||
'and'||unistr('\000a')||
'(:fas_modus_id not in (2) /* 2 Order-Eovital nur Angebot nicht bestellen */'||unistr('\000a')||
'OR            /* ausser spez.Rezeptbearb.Freigabe */'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''REZEPTBEARBEITUNG'')> 0 '||unistr('\000a')||
')',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>11445618776740023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_branch_name=> '',
  p_branch_action=> 'DOKUMENTEN_DRUCK.HAUPTPROGRAMM?P_REZ_NR=&P215_REZEPT_NR.&P_VERSION=&P215_VERSION.&P_SPRACHE=&P215_SPRACHE_ID.&P_BETREUER_ACCOUNT=&APP_USER.&P_TERRITORY=&P215_TERRITORY.&P_ETIKETT_ANZ=&P215_ETIKETTENANZAHL.&P_ETIKETT_TYP=&P215_ETIKETTENTYP.&P_PROD_AUFTRAG_ANZ=0&P_IDENT_ID=&FAS_IDENTITAET_PERSSTAMM_ID.&P_APO_ID=&P215_PERSSTAMM_ID_PROD_APO.&P_PREISLISTE_ID=&P215_PREISLISTE_ID.&P_VERRECH_LAND_ID=&P215_VERRECH_LAND_ID.&P_ART_MWST_TYP_ID=&P215_ART_MWST_TYP_ID.&P_PREISFAKTOR=&P215_PREISFAKTOR.&P_FAS_SCHEMA_ID=&FAS_SCHEMA_ID.'||unistr('\000a')||
'',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 109,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':P215_etikettenanzahl > 0 AND :REQUEST = ''ETIDRUCKEN'''||unistr('\000a')||
'and 1=2 /* Ersetzt durch Druck Etikett Prozess */',
  p_save_state_before_branch_yn=>'N',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset,
  p_branch_comment=> 'Created 03-DEZ-2007 14:50 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>11484922126233003 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_branch_name=> '',
  p_branch_action=> 'DOKUMENTEN_DRUCK.HAUPTPROGRAMM?P_REZ_NR=&P215_REZEPT_NR.&P_VERSION=&P215_VERSION.&P_SPRACHE=&P215_SPRACHE_ID.&P_BETREUER_ACCOUNT=&APP_USER.&P_TERRITORY=&P215_TERRITORY.&P_ETIKETT_ANZ=0&P_ETIKETT_TYP=&P215_ETIKETTENTYP.&P_PROD_AUFTRAG_ANZ=&P215_PROD_AUFTRAG_ANZAHL.&P_IDENT_ID=&FAS_IDENTITAET_PERSSTAMM_ID.&P_APO_ID=&P215_PERSSTAMM_ID_PROD_APO.&P_PREISLISTE_ID=&P215_PREISLISTE_ID.&P_VERRECH_LAND_ID=&P215_VERRECH_LAND_ID.&P_ART_MWST_TYP_ID=&P215_ART_MWST_TYP_ID.&P_PREISFAKTOR=&P215_PREISFAKTOR.&P_FAS_SCHEMA_ID=&FAS_SCHEMA_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 111,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':P215_prod_auftrag_anzahl > 0 AND :REQUEST in (''PROD_PROBEDRUCKEN'')'||unistr('\000a')||
'and 1=2 /* Ersetzt durch Druck Prodauftrag Prozess */',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 03-DEZ-2007 14:50 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>2456111775474925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_branch_name=> '',
  p_branch_action=> 'DOKUMENTEN_DRUCK.ANGEBOT?P_REZEPT_NR=&P215_REZEPT_NR.&P_REZEPT_VERSION=&P215_VERSION.&P_BETREUER_ID=&FAS_LOGIN_PERSONENSTAMM_ID.&P_IDENT_ID=&FAS_IDENTITAET_PERSSTAMM_ID.&P_APO_ID=&P215_PERSSTAMM_ID_PROD_APO.&P_PREISLISTE_ID=&P215_PREISLISTE_ID.&P_VERRECH_LAND_ID=&P215_VERRECH_LAND_ID.&P_ART_MWST_TYP_ID=&P215_ART_MWST_TYP_ID.&P_PREISFAKTOR=&P215_PREISFAKTOR.&P_FAS_SCHEMA_ID=&FAS_SCHEMA_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2455513329437537+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 115,
  p_branch_condition_type=> 'NEVER',
  p_save_state_before_branch_yn=>'N',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset,
  p_branch_comment=> 'Created 17-SEP-2008 09:52 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4059200053735057 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:215:&SESSION.:CLOSE_WINDOW_SPEICHERN:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>12000204584209476+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 141,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 11-JUL-2008 10:58 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4551529409036007 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:215:&SESSION.:CLOSE_WINDOW_CANCEL:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>11437932067722251+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 145,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 11-JUL-2008 10:58 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>6277930690093284 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:220:&SESSION.:BRANCH_TO_PAGE_ACCEPT|START:&DEBUG.:220:P220_WARENKORB_ID,P220_ZURUECK_SEITE:&P215_WARENKORB_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6279600636340181+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 150,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 27-SEP-2010 10:40 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4551100272999245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:215:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 151,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 18-SEP-2008 14:56 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2182619593008500 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_BESTELLDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 25,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'/*to_char(auftragsdispo.GET_LAST_BESTELL_DAT(:p215_mn_rezept_id),''DD.MM.YYYY'')*/'||unistr('\000a')||
'frgbg_s.WK_GET_LAST_BESTELL_DAT(:p215_p_rezept_id,NULL)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2183018863055600 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_MN_REZEPT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 24,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Rezept Id',
  p_source=>'SELECT id '||unistr('\000a')||
'   from mn_rezepte'||unistr('\000a')||
'   WHERE rezept_nr = :p215_rezept_nr'||unistr('\000a')||
'     and version = :p215_version',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2227202356374387 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_BL_PROD_PROBEDRUCKEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2227511833385178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_BL_ETIDRUCKEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2455717615448254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_BL_DRUCKEN_ANGEBOT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 235,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Druck Angebot',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2638702839424126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_option(v(''APP_USER''),21)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT substr(frgbg_s.get_pers_adresse(:P215_PERSSTAMM_ID_PROD_APO),1,80) a,'||unistr('\000a')||
'       :P215_PERSSTAMM_ID_PROD_APO b'||unistr('\000a')||
'FROM dual'||unistr('\000a')||
'/*'||unistr('\000a')||
'SELECT substr(frgbg_s.get_pers_adresse(p.id),1,80) a,'||unistr('\000a')||
'       p.id b'||unistr('\000a')||
'FROM pers_identitaet_props i,    /* spez. Eigenschaften der Identitaeten * /'||unistr('\000a')||
'     personenstamm p'||unistr('\000a')||
'where i.typ = ''PA'' /* Produzierende Apotheke * /'||unistr('\000a')||
'  and p.id = i.persstamm_id'||unistr('\000a')||
'order by 1'||unistr('\000a')||
'*/',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2744518198671081 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_BL_REZEPT_EXPORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 270,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Prod Bestelldruck',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2893023971755789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_HCK_PREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 51,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'  "SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3303526950934528 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_PREISLISTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisliste Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3927409995106579 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_PERSSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3927902292123337 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3943328025675906 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_VERRECHNUNGSLAND',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrechnungsland',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3946018822465554 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Waehrung Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3946226441467753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'XP215_MWST_SATZ1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz1',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3946400253469634 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_MWST_BETRAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3946730382478340 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'XP215_GESAMTPREIS_OHNE_MWST',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtpreis Ohne Mwst',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3948106063966389 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_GESAMTGEWICHT_G',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtgewicht G',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3948313682968562 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_GESAMTVOLUMEN_ML',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 220,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtvolumen Ml',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3948730492086978 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 61,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'to_char(sysdate,''DD.MM.RRRR'')',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 12,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3960032080170779 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_BL_PROD_BESTELLUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Prod Bestelldruck',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3975719009523006 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_ART_MWST_TYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'art_mwst_typ_id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3992631279268631 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_PREISFAKTOR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 300,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisfaktor',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4046603486349003 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_HINWEIS_BESTELLUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Hinweis Bestellung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4049104215352235 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_MELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Meldung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4058517097645326 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6276704465792375 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_WARENKORB_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6291206423621979 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_BL_PROD_BESTELLUNG_PAY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 231,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Prod Bestelldruck',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7570608791990511 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_DOSENANZAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'DECLARE'||unistr('\000a')||
'   v_optwert_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_optwert_id := frgbg_s.get_pers_option(:APP_USER,40);'||unistr('\000a')||
'   RETURN (v_optwert_id);'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'        ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'        ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 40 /* Etikettenanzahl*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 40 /* Etikettenanzahl*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11443216596730014 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_ETIKETTENTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'DECLARE'||unistr('\000a')||
'   v_optwert_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_optwert_id := frgbg_s.get_pers_option(:APP_USER,1);'||unistr('\000a')||
'   RETURN (v_optwert_id);'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 1 /* Etikettentyp*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 1 /* Etikettentyp*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11443417427730014 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_PROD_AUFTRAG_ANZAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'DECLARE'||unistr('\000a')||
'   v_optwert_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_optwert_id := frgbg_s.get_pers_option(:APP_USER,3);'||unistr('\000a')||
'   RETURN (v_optwert_id);'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ot.art = 1        /* Subset */'||unistr('\000a')||
'  and ow.opttyp_id = 3 /* Prodauftraganzahl*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 3 /* Prodauftraganzahl*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11443609954730014 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_ETIKETTENANZAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'DECLARE'||unistr('\000a')||
'   v_optwert_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_optwert_id := frgbg_s.get_pers_option(:APP_USER,2);'||unistr('\000a')||
'   RETURN (v_optwert_id);'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                               ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, pers_optionen po, optionstypen ot    /* Subsetzugriff */'||unistr('\000a')||
'where ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and ow.opttyp_id = 2 /* Etikettenanzahl*/'||unistr('\000a')||
'  and ow.opttyp_id = po.opttyp_id'||unistr('\000a')||
'  and ow.wert = po.wert'||unistr('\000a')||
'  and po.persstamm_id ='||unistr('\000a')||
'      frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'          :fas_identitaet_persstamm_id) /*Persid des Subsets sonst null */'||unistr('\000a')||
'UNION'||unistr('\000a')||
'/* Zugriff auf Optionswerte, da keine Subsetdef. od. da Def.wertverwaltg*/'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''OPTIONSWERTE.BEZEICHNUNG'','||unistr('\000a')||
'                                      ow.ID,:fas_sprache_id) a,'||unistr('\000a')||
'       ow.wert b'||unistr('\000a')||
'FROM optionswerte ow, optionstypen ot'||unistr('\000a')||
'where ow.opttyp_id = 2 /* Etikettenanzahl*/'||unistr('\000a')||
'  and ow.opttyp_id = ot.id  /* JOIN OT */'||unistr('\000a')||
'  and (ot.art = 1 and /* Subset und keine Subsetdefinition gefunden*/'||unistr('\000a')||
'       frgbg_s.GET_PERS_OPT_PERS_ID(:FAS_LOGIN_PERSONENSTAMM_ID,ow.opttyp_id,'||unistr('\000a')||
'                 :fas_identitaet_persstamm_id) IS NULL'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       ot.art != 1  /* Kein Subset */'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11451230466762282 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11452410858766109 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 46,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11454301292772825 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_REGION_TITEL_OPTIONEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11455810474813306 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_REZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11456414630814464 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11457020171816126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11457910259822678 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_TERRITORY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>11605103219345331 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 22,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'SELECT NAME||'' ''||VORNAME ||'' ''||to_char(GEBURTSDATUM,''DD.MM.RRRR'')'||unistr('\000a')||
'from personenstamm'||unistr('\000a')||
'where id = :P215_persstamm_ID',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11605630727345332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_REZEPT_NR_VRS_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 23,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>':P215_REZEPT_NR||''/''||:P215_VERSION',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11617032297385675 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_REGION_TITEL_PRODREZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11681510197259309 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_GESAMTGEWICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11682318509261660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_GESAMTVOLUMEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11686125351282595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_P_REZEPT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 11604823461345318+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12009306718314175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_PROD_PROBEDRUCKEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 54,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'PROD_PROBEDRUCKEN',
  p_prompt=>'&P215_BL_PROD_PROBEDRUCKEN.',
  p_source=>'PROD_PROBEDRUCKEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12018516171449389 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_PRODUKTIONSAUFTRAG_LABEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 52,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12025321197488714 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 215,
  p_name=>'P215_ETIDRUCKEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 42,
  p_item_plug_id => 11442916914730010+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'ETIDRUCKEN',
  p_prompt=>'&P215_BL_ETIDRUCKEN.',
  p_source=>'ETIDRUCKEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> 2,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3949006774117910 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P215_plandatum_not_null',
  p_validation_sequence=> 10,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P215_plandatum IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(1894,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 12000204584209476 + wwv_flow_api.g_id_offset,
  p_associated_item=> 3948730492086978 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 3952423425349809 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P215_PLANDATUM_check',
  p_validation_sequence=> 20,
  p_validation => 'BEGIN'||unistr('\000a')||
'    IF :P215_plandatum IS NOT NULL THEN'||unistr('\000a')||
'       :P215_plandatum := '||unistr('\000a')||
'          to_char(to_date(:P215_plandatum,''DD.MM.RRRR''),''DD.MM.RRRR'');'||unistr('\000a')||
'       IF to_date(:p215_plandatum,''DD.MM.RRRR'') < to_date(SYSDATE,''DD.MM.RRRR'')'||unistr('\000a')||
'       THEN'||unistr('\000a')||
'          RETURN(frgbg_s.holen_uebersetzung(1811,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(1894,:fas_sprache_id)));'||unistr('\000a')||
'       END IF;'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(HTMLDB_LANG.MESSAGE(''DATUM_UNGUELTIG''));'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(1894,:fas_sprache_id))||''HALLO'');'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 12000204584209476 + wwv_flow_api.g_id_offset,
  p_associated_item=> 3948730492086978 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_fehlertext  VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   IF :request in (''CLOSE_WINDOW_SPEICHERN'',''WINDOW_CLOSE_PAY_SPEICHERN'') THEN'||unistr('\000a')||
'      IF :request in (''WINDOW_CLOSE_PAY_SPEICHERN'') THEN  -- WK-Status'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            update warenkorb_details'||unistr('\000a')||
'            set wk_status_id = 10'||unistr('\000a')||
'            WHERE warenkorb_id ';

p:=p||'= :p215_warenkorb_id'||unistr('\000a')||
'              AND wk_status_id= 5;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            v_fehlertext := ''Fehler beim Aktivieren der Bestellung! WK-ID:''||:p215_warenkorb_id;'||unistr('\000a')||
'            htp.p(''alert("''||v_fehlertext||'||unistr('\000a')||
'                  ''");'');'||unistr('\000a')||
'         END;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      htp.p(''alert("''||frgbg_s.holen_uebersetzung(2000,:fas_sprache_id,:p215_plandatum)||''");'');'||unistr('\000a')||
'   ELSI';

p:=p||'F :request in (''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_CANCEL'') THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         update warenkorb_details'||unistr('\000a')||
'         set wk_status_id= 90'||unistr('\000a')||
'         WHERE warenkorb_id = :p215_warenkorb_id'||unistr('\000a')||
'           AND wk_status_id= 5;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         v_fehlertext := ''Fehler beim Stornieren der Bestellung! WK-ID:''||:p215_warenkorb_id;'||unistr('\000a')||
'         htp.p(''alert("''||v_fehlertext';

p:=p||'||'||unistr('\000a')||
'            ''");'');'||unistr('\000a')||
'      END;'||unistr('\000a')||
'      IF :request = ''WINDOW_CLOSE_PAY_CANCEL'' THEN'||unistr('\000a')||
'          htp.p(''alert("''||''Manueller Zahlungsabbruch! Bestellung storniert.''||''");'');'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'          htp.p(''alert("''||''Zahlungsabbruch! Bestellung storniert.''||''");'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   htp.p(''window.close(this);'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4060828693960965 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'bestellung_aktivieren_window_close',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':REQUEST in (''CLOSE_WINDOW_CANCEL'',''CLOSE_WINDOW_SPEICHERN'','||unistr('\000a')||
'  ''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_SPEICHERN'',''WINDOW_CLOSE_PAY_CANCEL'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_preisliste_id    number;'||unistr('\000a')||
'   v_waehrung_id      v_laender.id_waehrung_verrech%TYPE;'||unistr('\000a')||
'   v_verrech_land_id  v_laender.id%TYPE;'||unistr('\000a')||
'   v_waehrung_zeichen VARCHAR2(5);'||unistr('\000a')||
'   v_eh_zeichen       VARCHAR2(10);'||unistr('\000a')||
'   v_gesamtpreis      NUMBER;'||unistr('\000a')||
'   v_hck_preis        NUMBER;'||unistr('\000a')||
'   v_hck_mwst_betrag  NUMBER;'||unistr('\000a')||
'   v_hck_mwst_satz    v_laender.mwst_satz1%TYPE;'||unistr('\000a')||
'   --v_gesamtpreis_mwst_5runden      NUMBER;'||unistr('\000a')||
'   v_mws';

p:=p||'t_satz1       v_laender.mwst_satz1%TYPE;'||unistr('\000a')||
'   v_mwst_betrag      NUMBER;'||unistr('\000a')||
'   v_art_mwst_typ_id  number; '||unistr('\000a')||
'   v_preisfaktor      NUMBER;'||unistr('\000a')||
'   v_persstamm_id_prod_apo personenstamm.id%TYPE;'||unistr('\000a')||
'   '||unistr('\000a')||
'   v_return           NUMBER;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P215_P_REZEPT_ID IS NOT NULL THEN'||unistr('\000a')||
'      v_eh_zeichen := fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',500,:fas_sprache_id);'||unistr('\000a')||
'      :p215_gesamtgewicht_g := '||unistr('\000a')||
'      ';

p:=p||'        rezepte.calc_gewicht_prod(:P215_P_REZEPT_ID,'||unistr('\000a')||
'                                        NULL, -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                        1);'||unistr('\000a')||
'      :p215_gesamtgewicht := to_char(:p215_gesamtgewicht_g,''999G999G990'')||'' ''||v_eh_zeichen;'||unistr('\000a')||
''||unistr('\000a')||
'      v_eh_zeichen := fas_synch.get_tab_uebersetzung(''EINHEITEN.EH_ZEICHEN'',406,:fas_sprache_id);'||unistr('\000a')||
'      :p215_gesamtvolumen_ml := ';

p:=p||''||unistr('\000a')||
'              rezepte.calc_volumen_prod(:P215_P_REZEPT_ID,'||unistr('\000a')||
'                                        NULL, -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                        1);'||unistr('\000a')||
'      :p215_gesamtvolumen := to_char(:p215_gesamtvolumen_ml,''999G999G990'')||'' ''||v_eh_zeichen;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Preisberechnung'||unistr('\000a')||
'/* NEI 6.4.09'||unistr('\000a')||
'      v_return := rezepte.calc_preisberechnung(:P215_P_REZEPT_ID,   -- Prodrezept'||unistr('\000a')||
' ';

p:=p||'                                              :p215_persstamm_id,'||unistr('\000a')||
'                                               :FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                                               :p215_verrechnungsland,'||unistr('\000a')||
'                                               v_gesamtpreis,'||unistr('\000a')||
'                                               v_mwst_betrag,'||unistr('\000a')||
'                                               v_mwst_satz1,'||unistr('\000a')||
'  ';

p:=p||'                                             v_waehrung_id'||unistr('\000a')||
'                                              );'||unistr('\000a')||
'*/'||unistr('\000a')||
'      v_persstamm_id_prod_apo := frgbg_s.get_pers_option(v(''APP_USER''),21);'||unistr('\000a')||
'      v_return := rezepte.CALC_GES_PREISBERECH('||unistr('\000a')||
'                         :P215_P_REZEPT_ID,   -- Prodrezept'||unistr('\000a')||
'                         :p215_persstamm_id, '||unistr('\000a')||
'                         :FAS_LOGIN_PERSONENSTAMM_ID,  -- L';

p:=p||'ogin (Betreuer od. Kunde)'||unistr('\000a')||
'                         :FAS_IDENTITAET_PERSSTAMM_ID ,-- aktive Identitaet  NEI 08.03.2012'||unistr('\000a')||
'                         v_persstamm_id_prod_apo,      -- prod. Apo          NEI 08.03.2012'||unistr('\000a')||
'                         v_persstamm_id_prod_apo,      -- Rechsteller: def.Prod Apo  NEI 08.03.2012 '||unistr('\000a')||
'                         -- :p215_verrechnungsland,    -- NEI 08.03.2012'||unistr('\000a')||
'                ';

p:=p||'         v_gesamtpreis,'||unistr('\000a')||
'                         v_mwst_betrag,'||unistr('\000a')||
'                         v_waehrung_id,'||unistr('\000a')||
'                         v_verrech_land_id,'||unistr('\000a')||
'                         v_preisliste_id,'||unistr('\000a')||
'                         v_art_mwst_typ_id,'||unistr('\000a')||
'                         v_preisfaktor'||unistr('\000a')||
'                        );'||unistr('\000a')||
'      :p215_preisliste_id := v_preisliste_id;'||unistr('\000a')||
'      :p215_art_mwst_typ_id := v_art_mwst_typ_id;'||unistr('\000a')||
'    ';

p:=p||'  :p215_preisfaktor := v_preisfaktor;'||unistr('\000a')||
'      -- Währungszeichen holen'||unistr('\000a')||
'      v_waehrung_zeichen := rezepte.get_waehrung_zeichen(v_waehrung_id);'||unistr('\000a')||
''||unistr('\000a')||
'      :p215_waehrung_id := v_waehrung_id;'||unistr('\000a')||
'      /* NEI 12.10.09 wird bereits in calc_ges_preisberech ermittelt, '||unistr('\000a')||
'         evt. wg. zurückgreifen Std-preisliste auch angepasst '||unistr('\000a')||
'      :p215_verrech_land_id := rezepte.get_land_id_verr(:p215_persstamm_id, '||unistr('\000a')||
'    ';

p:=p||'                       :FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                           :p215_verrechnungsland);  -- wird noch für Artikelliste genutzt'||unistr('\000a')||
'      */'||unistr('\000a')||
'      :p215_verrech_land_id := v_verrech_land_id;'||unistr('\000a')||
''||unistr('\000a')||
'--      :p215_mwst_betrag := v_mwst_betrag;'||unistr('\000a')||
'--      :p215_gesamtpreis_ohne_mwst:= v_gesamtpreis - v_mwst_betrag;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_return < 0 THEN  -- Preisberechnung hatte Fehler'||unistr('\000a')||
'          :p215_gesamtp';

p:=p||'reis := ''<br/>''||frgbg_s.holen_uebersetzung(2175,:fas_sprache_id);'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p215_gesamtpreis := '||unistr('\000a')||
'            to_char(v_gesamtpreis,''999G999G990D00'')||'' ''||'||unistr('\000a')||
'            v_waehrung_zeichen||'' ''||frgbg_s.holen_uebersetzung(1874,:fas_sprache_id);'||unistr('\000a')||
'         -- HCK-Preisanteil bestimmen'||unistr('\000a')||
'         /* 04.06.2014 Berechnung HCK-Anteil auf Splitkomponenten umgestellt und nicht via Gesamtrezept wg.';

p:=p||' Preisdifferenzen'||unistr('\000a')||
'         v_return := rezepte.calc_preis_mwst_prod(:P215_P_REZEPT_ID,   -- Prodrezept'||unistr('\000a')||
'                                             NULL,                    -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                             :p215_verrech_land_id,'||unistr('\000a')||
'                                             1, -- HCK-Mischung'||unistr('\000a')||
'                                             NULL, -- Kein spez';

p:=p||'. Artikel sondern alle HCK''s'||unistr('\000a')||
'                                             v_preisliste_id,'||unistr('\000a')||
'                                             v_art_mwst_typ_id,'||unistr('\000a')||
'                                             v_preisfaktor,'||unistr('\000a')||
'                                             v_persstamm_id_prod_apo, -- NEI 04.03.13 Mwstbest(nicht mehr) NEI 30.5.14 sondern wg. Rabattstaffelgruppe bei Mischungen'||unistr('\000a')||
'                   ';

p:=p||'                          0,                       -- NEI 28.03.14 ohne Rundung ganzer Packungen bei Fertigartikeln der Mischung'||unistr('\000a')||
'                                             v_hck_preis,'||unistr('\000a')||
'                                             v_hck_mwst_betrag,'||unistr('\000a')||
'                                             v_hck_mwst_satz'||unistr('\000a')||
'                                             );'||unistr('\000a')||
'         */'||unistr('\000a')||
'         v_return := rezepte';

p:=p||'.calc_preis_mwst_prod_split(:P215_P_REZEPT_ID,   -- Prodrezept'||unistr('\000a')||
'                                             NULL,                    -- NEI 09.04.14 Soll_Reichweite'||unistr('\000a')||
'                                              :p215_verrech_land_id,'||unistr('\000a')||
'                                             1, -- HCK-Mischung'||unistr('\000a')||
'                                             NULL, -- Kein spez. Artikel sondern alle HCK''s'||unistr('\000a')||
'          ';

p:=p||'                                   v_preisliste_id,'||unistr('\000a')||
'                                             v_art_mwst_typ_id,'||unistr('\000a')||
'                                             v_preisfaktor,'||unistr('\000a')||
'                                             v_persstamm_id_prod_apo, -- NEI 04.03.13 Mwstbest(nicht mehr) NEI 30.5.14 sondern wg. Rabattstaffelgruppe bei Mischungen'||unistr('\000a')||
'                                             0,           ';

p:=p||'            -- NEI 28.03.14 ohne Rundung ganzer Packungen bei Fertigartikeln der Mischung'||unistr('\000a')||
'                                             1,                       -- alle Rezepte aus Split berücksichtigen'||unistr('\000a')||
'                                             0,                       -- NEI 18.06.14 keine Reichweitenstaffel-Rabattberechnung (=0) für Mischungen,'||unistr('\000a')||
'                                                 ';

p:=p||'                     --              nur  noch im WK und auf Bestellschein sonst keine Rabattrechnung'||unistr('\000a')||
'                                             v_hck_preis,'||unistr('\000a')||
'                                             v_hck_mwst_betrag,'||unistr('\000a')||
'                                             v_hck_mwst_satz'||unistr('\000a')||
'                                             );'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'         :p215_hck_preis := to_char(NVL(v_hck_preis+v_hck_mwst_b';

p:=p||'etrag,0),''999G999G990D00'')||'' ''||'||unistr('\000a')||
'            v_waehrung_zeichen||'' ''||frgbg_s.holen_uebersetzung(1874,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3926305400048543 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 100,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gewichte_vol_menge_preis_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_warenkorb_id  warenkoerbe.id%TYPE;'||unistr('\000a')||
'   v_mwst_jn       personenstamm.mwst_jn%TYPE;'||unistr('\000a')||
'   v_return        number;'||unistr('\000a')||
''||unistr('\000a')||
'   v_mn_rezept_id  mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_bemerkung     mn_rezepte.bemerkung%TYPE;'||unistr('\000a')||
'   v_persstamm_id  mn_rezepte.personenstamm_id%TYPE;'||unistr('\000a')||
'   v_prod_rezept_id  prod_rezepte.id%TYPE;'||unistr('\000a')||
'   v_reichweite      prod_rezepte.reichweite%TYPE;'||unistr('\000a')||
'   v_rezepthinweis   mn_rezepte.rezepthinweis';

p:=p||'%TYPE;'||unistr('\000a')||
'   v_rezepthinweis_text_id   mn_rezepte.rezepthinweis_text_id%TYPE;'||unistr('\000a')||
'   v_arzt_rezept     mn_rezepte.arzt_rezept%TYPE;'||unistr('\000a')||
'   v_arzt_rezept_gueltig_bis     mn_rezepte.arzt_rezept_gueltig_bis%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechnung mn_rezepte.personenstamm_id%TYPE;'||unistr('\000a')||
'   v_persstamm_id_lieferung mn_rezepte.personenstamm_id%TYPE;'||unistr('\000a')||
'   v_persstamm_id_betreuer mn_rezepte.personenstamm_id%TYPE;'||unistr('\000a')||
'   v_wk_status_id';

p:=p||'  warenkorb_status.id%TYPE;'||unistr('\000a')||
'   v_wk_zahlungsart_id  warenkoerbe.wk_zahlungsart_id%TYPE;  -- NEI 28.03.12'||unistr('\000a')||
'   v_sprache_id    NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_fehlertext    VARCHAR2(2000);'||unistr('\000a')||
'   v_fehler        exception;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'-- ACHTUNG: Abgeloest durch Button zum WK'||unistr('\000a')||
'-- Aufruf wk_gen_bestellung veraltet'||unistr('\000a')||
'RETURN;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'--MEL.P (''Bestellung ''||:REQUEST||''|''||:FAS_LOGIN_PERSONENSTAM';

p:=p||'M_ID||''|''||:p215_persstamm_id_prod_apo, v_PROT_ID, ''TEST'',''bestellungs_speichern'');'||unistr('\000a')||
'   :p215_warenkorb_id := null;'||unistr('\000a')||
'   IF :REQUEST in (''PROD_BESTELLUNG'',''PROD_BESTELLUNG_PAY'') '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'--MEL.P (''OK Bestellung gespeichert ''||:REQUEST, v_PROT_ID, ''TEST'', ''bestellungs_speichern'');'||unistr('\000a')||
'      -- Warenkorb auf der Basis eines Rezepts mit '||unistr('\000a')||
'      -- Warenkorb_Details erstellen, aufgesplittet nach Komponenten g';

p:=p||'emaess prodkennzeichen'||unistr('\000a')||
'      -- v_wk_status_id := 10;   -- Bestellung auf Rechnung         NEI 20.02.12 '||unistr('\000a')||
'      IF :REQUEST in (''PROD_BESTELLUNG_PAY'')  THEN -- Bestellung per Kreditkarte'||unistr('\000a')||
'         v_wk_status_id := 5;'||unistr('\000a')||
'         v_wk_zahlungsart_id := 2;    -- NEI 18.03.12'||unistr('\000a')||
'      ELSE                            -- NEI 20.02.12 '||unistr('\000a')||
'         /* NEI 13.08.12 => Persopt fuer Default-Zahlungsart eingefuehrt '||unistr('\000a')||
' ';

p:=p||'        IF :FAS_IDENTITAET_PERSSTAMM_ID = 24377 THEN -- EOVITAL => Freigabe ueber WK-übersicht  '||unistr('\000a')||
'            v_wk_status_id := 5;      -- Bestellung Vorkasse'||unistr('\000a')||
'            v_wk_zahlungsart_id:= 3;  -- NEI 28.03.12'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            v_wk_status_id := 10;     -- Bestellung auf Rechnung'||unistr('\000a')||
'            v_wk_zahlungsart_id := 1; -- NEI 28.03.12'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'        */'||unistr('\000a')||
'        IF frgbg_s.get_pers';

p:=p||'_option(:APP_USER,35) = 1 THEN --Bestellung auf Rechnung'||unistr('\000a')||
'            v_wk_status_id := 10;     -- Bestellung auf Rechnung'||unistr('\000a')||
'            v_wk_zahlungsart_id := 1; '||unistr('\000a')||
'        ELSE   -- Vorauskassen'||unistr('\000a')||
'            v_wk_status_id := 5;      -- Bestellung Vorkasse'||unistr('\000a')||
'            v_wk_zahlungsart_id:= 3;  '||unistr('\000a')||
'        END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      v_return := frgbg_s.wk_gen_warenkorb ('||unistr('\000a')||
'                      :p215_rezep';

p:=p||'t_nr,'||unistr('\000a')||
'                      :p215_version,'||unistr('\000a')||
'                      :FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                      :p215_persstamm_id_prod_apo,'||unistr('\000a')||
'                      to_date(:p215_plandatum,''DD.MM.RRRR''),'||unistr('\000a')||
'                      v_wk_status_id, -- 10= bestellt, 5=in Bezahlung, Best. noch nicht aktiviert'||unistr('\000a')||
'                      1, -- Menge immer 1'||unistr('\000a')||
'                      :p215_etikettentyp,'||unistr('\000a')||
'            ';

p:=p||'          :FAS_IDENTITAET_PERSSTAMM_ID,-- aktive Identitaet   NEI 08.03.2012'||unistr('\000a')||
'                      :p215_persstamm_id_prod_apo, -- Rechnungssteller: def. ProdApo NEI 08.03.2012 '||unistr('\000a')||
'                      v_wk_zahlungsart_id          -- NEI 28.03.12'||unistr('\000a')||
'                     );'||unistr('\000a')||
'      IF v_return <= 0 THEN -- Fehler'||unistr('\000a')||
'         :p215_warenkorb_id := null;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p215_waren';

p:=p||'korb_id := v_return;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'--MEL.P (''Bestellung ''||:p215_warenkorb_id||''|''||:request||''|''||v_wk_status_id, v_PROT_ID, ''TEST'',''bestellungs_speichern'');'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'    v_fehlertext := frgbg_s.holen_uebersetzung(1915,v_sprache_id,'||unistr('\000a')||
'                              to_char(:p215_rezept_nr)||''/''||to_char(:p215_version)'||unistr('\000a')||
'                             )||SQLERRM;'||unistr('\000a')||
'    MEL.P';

p:=p||' (v_fehlertext, v_PROT_ID, ''ERROR'', ''FAS102/215 bestellung_speichern'');'||unistr('\000a')||
'    RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'    v_fehlertext := frgbg_s.holen_uebersetzung(1915,v_sprache_id,'||unistr('\000a')||
'                              to_char(:p215_rezept_nr)||''/''||to_char(:p215_version)'||unistr('\000a')||
'                             )||SQLERRM;'||unistr('\000a')||
'    MEL.P (v_fehlertext, v_PROT_ID, ''ERROR'', ''FAS102/215 bestellung_';

p:=p||'speichern'');'||unistr('\000a')||
'    RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 11645400520707662 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 5,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'bestellung_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''PROD_BESTELLUNG'',''PROD_BESTELLUNG_PAY'') and 1=2 /* Abgeloest durch Button zum WK*/',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_persstamm_id number;'||unistr('\000a')||
'   v_pers_opt_id  number;'||unistr('\000a')||
'   v_return       number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* Etikettentyp Option speichern */'||unistr('\000a')||
'   v_return := frgbg_s.save_pers_optionen(:APP_USER,1,:P215_ETIKETTENTYP);'||unistr('\000a')||
'   /* Etikettenanz Option speichern */'||unistr('\000a')||
'   v_return := frgbg_s.save_pers_optionen(:APP_USER,2,:P215_ETIKETTENANZAHL);'||unistr('\000a')||
'   /* Anzahl Produktionsauftraege Option speichern */'||unistr('\000a')||
'   v_return := frgbg_s';

p:=p||'.save_pers_optionen(:APP_USER,3,:P215_PROD_AUFTRAG_ANZAHL);'||unistr('\000a')||
'END ;';

wwv_flow_api.create_page_process(
  p_id     => 11461619309853700 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'optionen_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>11443826434730014 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
' '||unistr('\000a')||
''||unistr('\000a')||
'IREPORT.ANGEBOT('||unistr('\000a')||
'             P_REZEPT_NR       => :P215_REZEPT_NR,'||unistr('\000a')||
'             P_REZEPT_VERSION  => :P215_VERSION,'||unistr('\000a')||
'             P_BETREUER_ID     => :FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'             P_IDENT_ID        =>:FAS_IDENTITAET_PERSSTAMM_ID,'||unistr('\000a')||
'             P_APO_ID          =>:P215_PERSSTAMM_ID_PROD_APO,'||unistr('\000a')||
'             P_PREISLISTE_ID   =>:P215_PREISLISTE_ID,'||unistr('\000a')||
'             P_VERRECH_LAND_ID =';

p:=p||'>:P215_VERRECH_LAND_ID,'||unistr('\000a')||
'             P_ART_MWST_TYP_ID =>:P215_ART_MWST_TYP_ID,'||unistr('\000a')||
'             P_PREISFAKTOR     =>:P215_PREISFAKTOR,'||unistr('\000a')||
'             P_FAS_SCHEMA_ID   =>:FAS_SCHEMA_ID,'||unistr('\000a')||
'             p_get_all_splitted_r => 1'||unistr('\000a')||
'           );'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'apex_application.stop_apex_engine;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3998328882161451 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Drucken Angebot',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>2455513329437537 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   if :P215_ETIKETTENTYP not in(7) then'||unistr('\000a')||
'      IREPORT.SHOW_ETIKETT('||unistr('\000a')||
'      P_REZ_NR              =>:P215_REZEPT_NR,'||unistr('\000a')||
'      P_VERSION             =>:P215_VERSION,'||unistr('\000a')||
'      P_SPRACHE          =>:P215_SPRACHE_ID,'||unistr('\000a')||
'      P_BETREUER_ACCOUNT =>:APP_USER,'||unistr('\000a')||
'      P_TERRITORY        =>:P215_TERRITORY,'||unistr('\000a')||
'      P_ETIKETT_ANZ      =>:P215_ETIKETTENANZAHL,'||unistr('\000a')||
'      P_ETIKETT_TYP      =>:P215_ETIKETTENTYP,'||unistr('\000a')||
'      P_PR';

p:=p||'OD_AUFTRAG_ANZ =>0,'||unistr('\000a')||
'      P_IDENT_ID         =>:FAS_IDENTITAET_PERSSTAMM_ID,'||unistr('\000a')||
'      P_APO_ID           =>:P215_PERSSTAMM_ID_PROD_APO,'||unistr('\000a')||
'      P_PREISLISTE_ID    =>:P215_PREISLISTE_ID,'||unistr('\000a')||
'      P_VERRECH_LAND_ID  =>:P215_VERRECH_LAND_ID,'||unistr('\000a')||
'      P_ART_MWST_TYP_ID  =>:P215_ART_MWST_TYP_ID,'||unistr('\000a')||
'      P_PREISFAKTOR      =>:P215_PREISFAKTOR,'||unistr('\000a')||
'      P_FAS_SCHEMA_ID    =>:FAS_SCHEMA_ID,'||unistr('\000a')||
'      P_PRINTER_NAME     => nu';

p:=p||'ll,'||unistr('\000a')||
'      P_PRINT_ALSO       =>  0,'||unistr('\000a')||
'      P_ANZAHL_AUSDRUCKE =>  1,'||unistr('\000a')||
'      p_print_split_rezepte => 1,'||unistr('\000a')||
'      p_anzahl_dosen => :P215_DOSENANZAHL'||unistr('\000a')||
'    );'||unistr('\000a')||
'    else'||unistr('\000a')||
'      DOKUMENTEN_DRUCK.HAUPTPROGRAMM ('||unistr('\000a')||
'      P_REZ_NR           =>:P215_REZEPT_NR,'||unistr('\000a')||
'      P_VERSION          =>:P215_VERSION,'||unistr('\000a')||
'      P_SPRACHE          =>:P215_SPRACHE_ID,'||unistr('\000a')||
'      P_BETREUER_ACCOUNT =>:APP_USER,'||unistr('\000a')||
'      P_TERRITORY        =>:P215';

p:=p||'_TERRITORY,'||unistr('\000a')||
'      P_ETIKETT_ANZ      =>:P215_ETIKETTENANZAHL,'||unistr('\000a')||
'      P_ETIKETT_TYP      =>:P215_ETIKETTENTYP,'||unistr('\000a')||
'      P_PROD_AUFTRAG_ANZ =>0,'||unistr('\000a')||
'      P_IDENT_ID         =>:FAS_IDENTITAET_PERSSTAMM_ID,'||unistr('\000a')||
'      P_APO_ID           =>:P215_PERSSTAMM_ID_PROD_APO,'||unistr('\000a')||
'      P_PREISLISTE_ID    =>:P215_PREISLISTE_ID,'||unistr('\000a')||
'      P_VERRECH_LAND_ID  =>:P215_VERRECH_LAND_ID,'||unistr('\000a')||
'      P_ART_MWST_TYP_ID  =>:P215_ART_MWST_TYP_ID,'||unistr('\000a')||
'';

p:=p||'      P_PREISFAKTOR      =>:P215_PREISFAKTOR,'||unistr('\000a')||
'      P_FAS_SCHEMA_ID    =>:FAS_SCHEMA_ID'||unistr('\000a')||
'     );'||unistr('\000a')||
'end if;'||unistr('\000a')||
'   apex_application.stop_apex_engine;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3999016021196861 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Druck Etikett',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':P215_etikettenanzahl > 0 AND :REQUEST = ''ETIDRUCKEN'''||unistr('\000a')||
'',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IREPORT.SHOW_PROD_AUFTRAG(    '||unistr('\000a')||
'      P_REZ_NR           =>:P215_REZEPT_NR,'||unistr('\000a')||
'      P_VERSION          =>:P215_VERSION,'||unistr('\000a')||
'      P_SPRACHE          =>:P215_SPRACHE_ID,'||unistr('\000a')||
'      P_PROD_AUFTRAG_ANZ =>:P215_PROD_AUFTRAG_ANZAHL,'||unistr('\000a')||
'      P_IDENT_ID         =>:FAS_IDENTITAET_PERSSTAMM_ID,'||unistr('\000a')||
'      P_APO_ID           =>:P215_PERSSTAMM_ID_PROD_APO,'||unistr('\000a')||
'      p_print_split_rezepte   => 1'||unistr('\000a')||
' ); /*'||unistr('\000a')||
'   DOKUMENTEN_DRUCK.';

p:=p||'HAUPTPROGRAMM ('||unistr('\000a')||
'      P_REZ_NR           =>:P215_REZEPT_NR,'||unistr('\000a')||
'      P_VERSION          =>:P215_VERSION,'||unistr('\000a')||
'      P_SPRACHE          =>:P215_SPRACHE_ID,'||unistr('\000a')||
'      P_BETREUER_ACCOUNT =>:APP_USER,'||unistr('\000a')||
'      P_TERRITORY        =>:P215_TERRITORY,'||unistr('\000a')||
'      P_ETIKETT_ANZ      =>0,'||unistr('\000a')||
'      P_ETIKETT_TYP      =>:P215_ETIKETTENTYP,'||unistr('\000a')||
'      P_PROD_AUFTRAG_ANZ =>:P215_PROD_AUFTRAG_ANZAHL,'||unistr('\000a')||
'      P_IDENT_ID         =>:FAS_IDENTITA';

p:=p||'ET_PERSSTAMM_ID,'||unistr('\000a')||
'      P_APO_ID           =>:P215_PERSSTAMM_ID_PROD_APO,'||unistr('\000a')||
'      P_PREISLISTE_ID    =>:P215_PREISLISTE_ID,'||unistr('\000a')||
'      P_VERRECH_LAND_ID  =>:P215_VERRECH_LAND_ID,'||unistr('\000a')||
'      P_ART_MWST_TYP_ID  =>:P215_ART_MWST_TYP_ID,'||unistr('\000a')||
'      P_PREISFAKTOR      =>:P215_PREISFAKTOR,'||unistr('\000a')||
'      P_FAS_SCHEMA_ID    =>:FAS_SCHEMA_ID'||unistr('\000a')||
'     );*/'||unistr('\000a')||
''||unistr('\000a')||
'   apex_application.stop_apex_engine;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3999613129262234 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Druck Prodauftrag',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':P215_prod_auftrag_anzahl > 0 AND :REQUEST in (''PROD_PROBEDRUCKEN'')'||unistr('\000a')||
'',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'215';

wwv_flow_api.create_page_process(
  p_id     => 11440517492722256 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>11437932067722251 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'CLOSE_WINDOW';

wwv_flow_api.create_page_process(
  p_id     => 4063414630192093 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 70,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLOSE_WINDOW',
  p_process_name=> 'Fenster schließen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''CANCEL'',''PROD_BESTELLUNG_SP'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p215_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p215_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :P215_BL_DRUCKEN_ANGEBOT := frgbg_s.holen_uebersetzung(3095,v_sprache_id);'||unistr('\000a')||
'   :P215_BL_REZEPT_EXPORT := frgbg_s.holen_uebersetzung(3129,v_sprache_id);'||unistr('\000a')||
'   :P215_BL_PROD_PROBEDRUCKEN :=frgbg_s.holen_u';

p:=p||'ebersetzung(741,v_sprache_id);'||unistr('\000a')||
'   :P215_BL_ETIDRUCKEN :=frgbg_s.holen_uebersetzung(552,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P215_REGION_TITEL_OPTIONEN := frgbg_s.holen_uebersetzung(1521,v_sprache_id);'||unistr('\000a')||
'   :P215_REGION_TITEL_PRODREZEPT := frgbg_s.holen_uebersetzung(553,v_sprache_id);'||unistr('\000a')||
'   :P215_BL_PROD_BESTELLUNG := frgbg_s.holen_uebersetzung(1574,v_sprache_id);'||unistr('\000a')||
'   :P215_BL_PROD_BESTELLUNG_PAY:= frgbg_s.holen_ueberset';

p:=p||'zung(3847,v_sprache_id);'||unistr('\000a')||
'   :p215_hinweis_bestellung := frgbg_s.holen_uebersetzung(2000,v_sprache_id,'' '');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 11439923024722254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 215,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 215
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00216
prompt  ...PAGE 216: JA/NEIN-popup
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 216
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'JA/NEIN-popup'
 ,p_step_title => 'Ja/Nein-Popup'
 ,p_step_sub_title => 'Ja/Nein-Popup'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'FRGBG'
 ,p_last_upd_yyyymmddhh24miss => '20090708112138'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 11744821340346120 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 216,
  p_plug_name=> '&P216_REGION_TITEL_OPTIONEN.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 11745405925346121 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 216,
  p_button_sequence=> 10,
  p_button_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_button_name    => 'ANTWORT1',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P216_ANTWORT1.',
  p_button_position=> 'BELOW_BOX',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 11745618174346121 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 216,
  p_button_sequence=> 60,
  p_button_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_button_name    => 'ANTWORT2',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P216_ANTWORT2.',
  p_button_position=> 'BELOW_BOX',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>11751019075346148 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_branch_name=> '',
  p_branch_action=> 'javascript:redirect(''f?p=&APP_ID.:215:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REQUEST_ANTWORT1:NO:::'');javascript:window.close(this);',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>11745405925346121+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 109,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 03-DEZ-2007 14:50 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>11751209079346150 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P216_ZURUECK.:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REQUEST_ANTWORT2:&DEBUG.:216::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>11745618174346121+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 111,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 03-DEZ-2007 14:50 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>11852126703855857 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:215:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 121,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 15-APR-2008 14:18 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11745802939346121 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_name=>'P216_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11746002382346129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_name=>'P216_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11746223976346129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_name=>'P216_REGION_TITEL_OPTIONEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>11747809512346132 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_name=>'P216_FRAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 22,
  p_item_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Frage',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11769022119472979 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_name=>'P216_ANTWORT1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11769627314474521 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_name=>'P216_ANTWORT2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11772723074492151 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_name=>'P216_ZURUECK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>11832101208507812 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 216,
  p_name=>'P216_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 11744821340346120+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'CLOSE_WINDOW';

wwv_flow_api.create_page_process(
  p_id     => 11837004765565604 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 216,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'CLOSE_WINDOW',
  p_process_name=> 'Fenster schließen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'P216_FLAG',
  p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2',
  p_process_when2=>'10',
  p_process_when_type2=>'',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
':p216_flag := 1;'||unistr('\000a')||
'   :p216_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p216_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P216_REGION_TITEL_OPTIONEN := NULL;--frgbg_s.holen_uebersetzung(1521,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 11750330698346148 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 216,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 216
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00217
prompt  ...PAGE 217: Rezeptexport
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 217
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Rezeptexport'
 ,p_step_title => 'Rezeptexport'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Bericht 1'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140715094727'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT P.VORNAME, P.NAME, P.STRASSE, P.NR, P.PLZ, P.ORT, V.REZEPT_NR,'||unistr('\000a')||
'  V.VERSION, D.BEZEICHNUNG, D.BEZEICHNUNG_TEXT_ID, D.MN_MENGE,'||unistr('\000a')||
'  D.MN_MENGE_100G, D.MN_MENGE_100ML, D.MN_EINHEIT_ID, D.MN_MENGE_TAG'||unistr('\000a')||
'FROM V_MN_REZEPTE V, V_MNR_DETAILS D, FRGBG.PERSONENSTAMM P'||unistr('\000a')||
'WHERE D.MN_REZEPT_ID = V.ID'||unistr('\000a')||
'AND P.ID = V.PERSONENSTAMM_ID'||unistr('\000a')||
'and v.rezept_nr = :p215_rezept_nr'||unistr('\000a')||
'     and v.version = :p215_version';

wwv_flow_api.create_report_region (
  p_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 217,
  p_name=> 'Rezeptexport',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 21,
  p_query_headings_type=> 'QUERY_COLUMNS',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'Y',
  p_csv_output_link_text=> 'murkslabel',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Print',
  p_prn_content_disposition=> 'ATTACHMENT',
  p_prn_document_header=> 'APEX',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width_units=> 'PERCENTAGE',
  p_prn_width=> 297,
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'CENTER',
  p_prn_page_footer_alignment=> 'CENTER',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_exp_separator=> ';',
  p_plug_query_exp_enclosed_by=> ' ',
  p_plug_query_strip_html=> 'N',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2759529708705798 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'VORNAME',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Vorname',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2759606855705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'NAME',
  p_column_display_sequence=> 6,
  p_column_heading=> 'Name',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2759719630705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'STRASSE',
  p_column_display_sequence=> 7,
  p_column_heading=> 'Strasse',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2759806020705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'NR',
  p_column_display_sequence=> 8,
  p_column_heading=> 'Nr',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2759915414705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PLZ',
  p_column_display_sequence=> 9,
  p_column_heading=> 'Plz',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2760021402705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'ORT',
  p_column_display_sequence=> 10,
  p_column_heading=> 'Ort',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2754805329931587 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 1,
  p_column_heading=> 'Rezept Nr',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2754921579931589 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'VERSION',
  p_column_display_sequence=> 2,
  p_column_heading=> 'Version',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>2,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2755009188931589 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Bezeichnung',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2757116789931589 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG_TEXT_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Bezeichnung Text Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2760112834705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'MN_MENGE',
  p_column_display_sequence=> 11,
  p_column_heading=> 'Mn Menge',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2760215470705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'MN_MENGE_100G',
  p_column_display_sequence=> 12,
  p_column_heading=> 'Mn Menge 100g',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2760315362705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'MN_MENGE_100ML',
  p_column_display_sequence=> 13,
  p_column_heading=> 'Mn Menge 100ml',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2760427559705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'MN_EINHEIT_ID',
  p_column_display_sequence=> 14,
  p_column_heading=> 'Mn Einheit Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2760514483705801 + wwv_flow_api.g_id_offset,
  p_region_id=> 2752419312826784 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'MN_MENGE_TAG',
  p_column_display_sequence=> 15,
  p_column_heading=> 'Mn Menge Tag',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '6',
  p_column_comment=>'');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 217
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00220
prompt  ...PAGE 220: saferpaytest
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 220
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'saferpaytest'
 ,p_step_title => 'saferpaytest'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20111102114734'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6249226450141814 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 220,
  p_plug_name=> 'saferpay',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6249407881145960 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 220,
  p_button_sequence=> 10,
  p_button_plug_id => 6249226450141814+wwv_flow_api.g_id_offset,
  p_button_name    => 'START',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Start',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6251416819318878 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 220,
  p_button_sequence=> 20,
  p_button_plug_id => 6249226450141814+wwv_flow_api.g_id_offset,
  p_button_name    => 'CLEAR',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Clear',
  p_button_position=> 'REGION_TEMPLATE_EDIT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6251729500318878 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&FLOW_ID.:220:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6251416819318878+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>6252226824369039 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_branch_name=> '',
  p_branch_action=> '&P220_URL.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6249407881145960+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 22-SEP-2010 10:40 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>6249709160145964 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P220_ZURUECK_SEITE.:&SESSION.:WINDOW_CLOSE_PAY_SPEICHERN:&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':P220_PAYSTATUS = 1',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>6278913140296442 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P220_ZURUECK_SEITE.:&SESSION.:WINDOW_CLOSE_PAY_ERROR:&DEBUG.:220::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':P220_PAYSTATUS in (2)',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 27-SEP-2010 11:14 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>1504621053834495 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P220_ZURUECK_SEITE.:&SESSION.:WINDOW_CLOSE_PAY_CANCEL:&DEBUG.:220::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 110,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':P220_PAYSTATUS in (3)',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 27-SEP-2010 11:14 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1504124769778857 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_name=>'P220_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 6249226450141814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6250413515204357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_name=>'P220_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6249226450141814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Url',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 300,
  p_cMaxlength=> 32767,
  p_cHeight=> 10,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6258807971791800 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_name=>'P220_PAYSTATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 6249226450141814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Paystatus',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6259219099823407 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_name=>'P220_RETURNPARAM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 6249226450141814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Returnparam',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6277708873087042 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 220,
  p_name=>'P220_WARENKORB_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 6249226450141814+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_betrag   NUMBER          ;'||unistr('\000a')||
'   v_waehrung VARCHAR2(5)     ;'||unistr('\000a')||
'   v_persstamm_id_kunde personenstamm.id%TYPE;'||unistr('\000a')||
'   v_bez      VARCHAR2(1000)  ;'||unistr('\000a')||
'   v_lnk_page NUMBER          := :APP_PAGE_ID; -- Nach Saferpay soll wieder zur aktuelle Seite'||unistr('\000a')||
'   v_bestell_nr  VARCHAR2(80) ;'||unistr('\000a')||
'   v_waehrung_id number;'||unistr('\000a')||
'   v_plandatum   date;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*mel.p(''Preis %1, Waehrung %2 (%3), datum %4,';

p:=p||' wk %5, url %6'',v_prot_id,''test'',''gen_url 102/220'','||unistr('\000a')||
'          v_betrag,v_waehrung_id, v_waehrung,v_plandatum,:p220_warenkorb_id,:p220_url); */'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT NVL(wk.gesamtpreis,0)+NVL(wk.mwst_betrag_1,0)+NVL(wk.mwst_betrag_2,0),'||unistr('\000a')||
'          wk.waehrung_id,w.code,wk.plandatum, HTMLDB_UTIL.URL_ENCODE(wk.bemerkung),wk.id,'||unistr('\000a')||
'          wk.persstamm_id_kunde'||unistr('\000a')||
'      INTO   v_betrag,v_waehrung_id, v_wae';

p:=p||'hrung,v_plandatum ,v_bez,v_bestell_nr,'||unistr('\000a')||
'             v_persstamm_id_kunde'||unistr('\000a')||
'      FROM warenkoerbe wk, waehrungen w'||unistr('\000a')||
'      WHERE wk.id = :p220_warenkorb_id'||unistr('\000a')||
'        and wk.waehrung_id = w.id;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN NULL; '||unistr('\000a')||
'   END;'||unistr('\000a')||
'   -- Description muss belegt sein'||unistr('\000a')||
'   IF v_bez is null THEN   -- keine WK-Bemerkung'||unistr('\000a')||
'      IF v_PERSSTAMM_ID_KUNDE is not null THEN  -- Kunde vorhanden'||unistr('\000a')||
'         SELEC';

p:=p||'T HTMLDB_UTIL.URL_ENCODE(NAME||'' ''||VORNAME ||'' ''||to_char(GEBURTSDATUM,''DD.MM.RRRR''))'||unistr('\000a')||
'         INTO v_bez'||unistr('\000a')||
'         from personenstamm'||unistr('\000a')||
'         where id = v_PERSSTAMM_ID_KUNDE;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE  -- sonst WK-ID'||unistr('\000a')||
'      v_bez := ''ID:''||:p220_warenkorb_id;   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   v_bez := replace(replace(replace(replace(replace(replace(replace(v_bez,''Ä'',''Ae'')'||unistr('\000a')||
'                   ,''Ü'',''Ue''),''Ö'',''Oe''),''ä'',''';

p:=p||'ae''),''ü'',''ue''),''ö'',''oe''),''ß'',''ss'');'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   :p220_url := frgbg_s.cc_payinit(v_betrag,v_waehrung,v_bez,v_lnk_page,v_bestell_nr);'||unistr('\000a')||
''||unistr('\000a')||
'/*mel.p(''Preis %1, Waehrung %2 (%3), datum %4, wk %5, url %6, %7'',v_prot_id,''test'',''gen_url 102/220'','||unistr('\000a')||
'          v_betrag,v_waehrung_id, v_waehrung,v_plandatum,:p220_warenkorb_id,:p220_url,v_bez);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6249816155195685 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 220,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_url',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>6249407881145960 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'l_host VARCHAR2(2000);'||unistr('\000a')||
'v_str  varchar2(2000);'||unistr('\000a')||
'v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--l_host := portal.wwctx_api.get_user_id;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_user_id = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_sessionid;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_sessionid = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_host;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_host = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal';

p:=p||'.wwctx_api.get_base_url;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_base_url = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := OWA_UTIL.GET_CGI_ENV(''REQUEST_PROTOCOL'');'||unistr('\000a')||
'--htp.p(''OWA_UTIL.GET_CGI_ENV("REQUEST_PROTOCOL") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''OWA_UTIL.GET_CGI_ENV("REQUEST_PROTOCOL") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := OWA_UTIL.GET_CGI_ENV(''HTTP_HOST'');'||unistr('\000a')||
'--htp.p(''OWA_UTIL.GET_CGI_ENV("HTTP_HOST") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str';

p:=p||' := v_str||'',''||''OWA_UTIL.GET_CGI_ENV("HTTP_HOST") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := hiims_r1.hiimsutil.getPortalURLPrefix;'||unistr('\000a')||
'--htp.p(''hiims_r1.hiimsutil.getPortalURLPrefix = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'--l_host := portal.wwctx_api.get_query_string;'||unistr('\000a')||
'--htp.p(''portal.wwctx_api.get_query_string = ''||l_host);htp.br;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''QUERY_STRING'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("QUERY_STRING") = ''||l_ho';

p:=p||'st);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("QUERY_STRING") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''PATH_INFO'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("PATH_INFO") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("PATH_INFO") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''REQUEST_URI'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("REQUEST_URI") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''o';

p:=p||'wa_util.get_cgi_env("REQUEST_URI") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'l_host := owa_util.get_cgi_env(''DOCUMENT_URI'');'||unistr('\000a')||
'--htp.p(''owa_util.get_cgi_env("DOCUMENT_URI") = ''||l_host);htp.br;'||unistr('\000a')||
'v_str := v_str||'',''||''owa_util.get_cgi_env("DOCUMENT_URI") = ''||l_host;'||unistr('\000a')||
''||unistr('\000a')||
'mel.p(v_str,v_prot_id,''INFO'',''URL'');'||unistr('\000a')||
''||unistr('\000a')||
'htp.p(''Done...'');'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS'||unistr('\000a')||
'THEN'||unistr('\000a')||
'htp.br;'||unistr('\000a')||
'htp.p(''Error!'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6303827981611762 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 220,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_afterpay_url',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p220_paystatus in (1)',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'220';

wwv_flow_api.create_page_process(
  p_id     => 6251829632322565 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 220,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'cache_clear',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>6251416819318878 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 220
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00250
prompt  ...PAGE 250: eoVital-Programm
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 250
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'eoVital-Programm'
 ,p_alias => 'EOVITAL'
 ,p_step_title => 'eoVital-Programm'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130116111243'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4077706786804609 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 250,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4078116848816789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 250,
  p_plug_name=> '&P250_PAGE_TITEL_PATIENT.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 11,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT'||unistr('\000a')||
'  apex_item.hidden(1,p.ID) ||'||unistr('\000a')||
'  apex_item.hidden(3,p.TP_PROG_ID) ||'||unistr('\000a')||
'  apex_item.hidden(4,p.TP_STPHASE_ID) ||'||unistr('\000a')||
'  apex_item.hidden(5,p.PZ_KONTROLL_ID) || '||unistr('\000a')||
'  apex_item.hidden(10,to_char(pg.mutdat,''dd.mm.yyyy hh24:mi:ss''))||'||unistr('\000a')||
'  apex_item.hidden(12,:app_user)||'||unistr('\000a')||
'  apex_item.hidden(13,to_char(pzs.istzeit,''dd.mm.yyyy hh24:mi:ss''))||'||unistr('\000a')||
'  apex_item.hidden(14,to_char(pzk.endezeit,''dd.mm.yyyy hh24:mi:ss''))';

s:=s||'||'||unistr('\000a')||
'  apex_item.display_and_save(11,stp.bezeichnung) phasen_bezeichnung,'||unistr('\000a')||
'  CASE WHEN p.ist_startdatum is not null AND p.ist_endedatum is not null THEN'||unistr('\000a')||
'      NULL   -- Keine Änderungen möglich '||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'      apex_item.checkbox(2,p.id)'||unistr('\000a')||
'  END update_flag,'||unistr('\000a')||
'  CASE WHEN prozesse.tp_get_fixzeit_kunde(p.id,''ID'') IS NULL THEN'||unistr('\000a')||
'      apex_item.hidden(16,NULL) ||       '||unistr('\000a')||
'      apex_item.hidden(17,NULL) ||       ';

s:=s||''||unistr('\000a')||
'      apex_item.hidden(15,prozesse.tp_get_fixzeit_kunde(p.id,''ID'')) -- Keine Änderungen möglich'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'      apex_item.hidden(15,prozesse.tp_get_fixzeit_kunde(p.id,''ID''))||'||unistr('\000a')||
'      apex_item.hidden(17,prozesse.tp_get_fixzeit_kunde(p.id,''DATE''))||'||unistr('\000a')||
'      apex_item.text(16,prozesse.tp_get_fixzeit_kunde(p.id,''DATE''),16)'||unistr('\000a')||
'  END kundentermin,'||unistr('\000a')||
'  CASE WHEN p.ist_startdatum is not null THEN'||unistr('\000a')||
'      apex_item.h';

s:=s||'idden(6,to_char(p.plan_startdatum,''DD.MM.YYYY''))||'||unistr('\000a')||
'      apex_item.display_and_save(7,to_char(p.plan_startdatum,''DD.MM.YYYY''))'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'      apex_item.hidden(6,to_char(p.plan_startdatum,''DD.MM.YYYY'')) ||'||unistr('\000a')||
'      apex_item.text(7,to_char(p.PLAN_STARTDATUM,''DD.MM.YYYY''),11,11)'||unistr('\000a')||
'  END plan_startdatum ,'||unistr('\000a')||
'  CASE WHEN p.ist_endedatum is not null THEN '||unistr('\000a')||
'      apex_item.hidden(8,p.reichweite)||'||unistr('\000a')||
'      apex_item.';

s:=s||'display_and_save(9,p.reichweite)'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'      apex_item.hidden(8,p.reichweite)||'||unistr('\000a')||
'      apex_item.text(9,p.reichweite,5,5)'||unistr('\000a')||
'  END reichweite ,'||unistr('\000a')||
'  to_char(p.PLAN_ENDEDATUM,''DD.MM.YYYY'') plan_endedatum,'||unistr('\000a')||
'  to_char(p.IST_STARTDATUM,''DD.MM.YYYY'')ist_startdatum,'||unistr('\000a')||
'  to_char(p.IST_ENDEDATUM,''DD.MM.YYYY'') ist_endedatum ,'||unistr('\000a')||
'  p.FOLGE_NR ,'||unistr('\000a')||
'  CASE WHEN pzk.endezeit is null THEN'||unistr('\000a')||
'  ''<a href="'''||unistr('\000a')||
'  ||APEX_UTIL.PREPARE_U';

s:=s||'RL(''f?p=105:121:::&DEBUG.::'''||unistr('\000a')||
'  ||''P121_PZ_KONTROLL_ID,P121_PERSSTAMM_ID_BETREUER,P121_TP_PROGRAMM_ID,'''||unistr('\000a')||
'  ||''P121_BEARB_MODUS,FAS_FB_SESSION_ID:'''||unistr('\000a')||
'  ||to_char(p.pz_kontroll_id)||'',''||:fas_login_personenstamm_id'||unistr('\000a')||
'  ||'',''||:p250_programmauswahl'||unistr('\000a')||
'  ||'',BEARBEITEN''||'',&SESSION.'')'||unistr('\000a')||
'  || ''">'''||unistr('\000a')||
'  || ''<img src="#IMAGE_PREFIX#edit_big.gif">'''||unistr('\000a')||
'  || ''</a>'''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'  ''<a href="'''||unistr('\000a')||
'  ||APEX_UTIL.PREPARE_URL(''f?p=105:121';

s:=s||':::&DEBUG.::'''||unistr('\000a')||
'  ||''P121_PZ_KONTROLL_ID,P121_PERSSTAMM_ID,,P121_TP_PROGRAMM_ID,'''||unistr('\000a')||
'  ||''P121_BEARB_MODUS,FAS_FB_SESSION_ID:'''||unistr('\000a')||
'  ||to_char(p.pz_kontroll_id)||'',''||:fas_login_personenstamm_id'||unistr('\000a')||
'  ||'',''||:p250_programmauswahl'||unistr('\000a')||
'  ||'',ANZEIGEN''||'',&SESSION.'')'||unistr('\000a')||
'  || ''">'''||unistr('\000a')||
'  || ''<img src="#IMAGE_PREFIX#fndsublg.gif">'''||unistr('\000a')||
'  || ''</a>''  END '||unistr('\000a')||
'  link,'||unistr('\000a')||
'--  pg.bezeichnung prog_bezeichnung,'||unistr('\000a')||
'p.id,'||unistr('\000a')||
'pzs.planzeit,'||unistr('\000a')||
'pzs.istzeit,'||unistr('\000a')||
'';

s:=s||'pzk.endezeit'||unistr('\000a')||
'from therapie_programme pg, therapie_phasen p,      '||unistr('\000a')||
'     therapie_stammphasen stp,prozess_schritte pzs,prozess_kontrolle pzk'||unistr('\000a')||
'where p.satz_kennzeichen is null'||unistr('\000a')||
'  and pg.id = p.tp_prog_id'||unistr('\000a')||
'  and pg.id = :p250_PROGRAMMAUSWAHL'||unistr('\000a')||
'  and pg.status = 1'||unistr('\000a')||
'  and p.tp_stphase_id = stp.id'||unistr('\000a')||
'  and pzs.pz_kontroll_id = p.pz_kontroll_id'||unistr('\000a')||
'  and pzs.pz_ablauf_id = prozesse.pz_get_element(stp.pz_typ_id,''FIRST''';

s:=s||',NULL)'||unistr('\000a')||
'  and pzs.pz_kontroll_id = pzk.id'||unistr('\000a')||
'order by p.folge_nr';

wwv_flow_api.create_report_region (
  p_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 250,
  p_name=> '&P250_PAGE_TITEL_EOVITAL.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 21,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_when_condition=> ':p250_programmauswahl is not null',
  p_display_condition_type=> 'PLSQL_EXPRESSION',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P250_HEIGHT_EOVITAL.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(2060,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'Keine Daten gefunden',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4140623120960226 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'PHASEN_BEZEICHNUNG',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4083823540026918 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'UPDATE_FLAG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4725812331560614 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'KUNDENTERMIN',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_format=> 'DD.MM.YYYY hh24:mi',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4082906882003365 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'PLAN_STARTDATUM',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4083008114003368 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'REICHWEITE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4083102797003368 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'PLAN_ENDEDATUM',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4083231838003368 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'IST_STARTDATUM',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4083312242003368 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'IST_ENDEDATUM',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4083427098003368 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'FOLGE_NR',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7903421548949520 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'LINK',
  p_column_display_sequence=> 14,
  p_column_heading=> 'Link',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4134701234198239 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4730025277686681 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'PLANZEIT',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4145327876367726 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'ISTZEIT',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4151816329287828 + wwv_flow_api.g_id_offset,
  p_region_id=> 4082607348003354 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'ENDEZEIT',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4154211552079978 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 250,
  p_plug_name=> 'Neues Programm',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 31,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p250_programmauswahl is null',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4080025226816798 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 250,
  p_button_sequence=> 50,
  p_button_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_button_name    => 'ZURUECK',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P250_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:250::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4167131036243050 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 250,
  p_button_sequence=> 55,
  p_button_plug_id => 4082607348003354+wwv_flow_api.g_id_offset,
  p_button_name    => 'PROGRAMM_STOPPEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Programm Stoppen',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> ':P250_programmauswahl is not null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4166332674186737 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 250,
  p_button_sequence=> 60,
  p_button_plug_id => 4082607348003354+wwv_flow_api.g_id_offset,
  p_button_name    => 'NEUES_PROGRAMM',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Neues Programm',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4131514450538035 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 250,
  p_button_sequence=> 70,
  p_button_plug_id => 4082607348003354+wwv_flow_api.g_id_offset,
  p_button_name    => 'PHASE_LOESCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Phase löschen',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4133702694104037 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 250,
  p_button_sequence=> 80,
  p_button_plug_id => 4082607348003354+wwv_flow_api.g_id_offset,
  p_button_name    => 'SPEICHERN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4166013627181301 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 250,
  p_button_sequence=> 85,
  p_button_plug_id => 4154211552079978+wwv_flow_api.g_id_offset,
  p_button_name    => 'VERWERFEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Verwerfen',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4154803287106029 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 250,
  p_button_sequence=> 90,
  p_button_plug_id => 4154211552079978+wwv_flow_api.g_id_offset,
  p_button_name    => 'STARTEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Starten',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4085828407922332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:250:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4078619995816795 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_PERSONENSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Personenstamm Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4078802540816795 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4079020179816795 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4079223423816795 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4079415473816795 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_PAGE_TITEL_PATIENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4079622438816796 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_BL_EOVITAL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Eovital',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4081519581864890 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_HEIGHT_EOVITAL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Height Eovital',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4082002098897735 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4082214565901284 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_PAGE_TITEL_EOVITAL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4135409636007964 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_PROGRAMMAUSWAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 370,
  p_item_plug_id => 4082607348003354+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Programmauswahl',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT  '||unistr('\000a')||
'    bezeichnung||'' ''||to_char(startdatum)||'' - ''||to_char(endedatum) b,'||unistr('\000a')||
'    id a'||unistr('\000a')||
'FROM therapie_programme'||unistr('\000a')||
'where persstamm_id =:p250_personenstamm_id'||unistr('\000a')||
'  and status = 1'||unistr('\000a')||
'order by startdatum desc',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'SUBMIT',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4140430954953004 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_FEHLERTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 4082607348003354+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Fehlertext',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4144426823347373 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_PHASENAUSWAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 390,
  p_item_plug_id => 4082607348003354+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Neue Phase anhängen',
  p_source_type=> 'ALWAYS_NULL',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT bezeichnung a, id b'||unistr('\000a')||
'from therapie_stammphasen'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'order by bezeichnung',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'---------',
  p_lov_null_value=> '-1',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'SUBMIT',
  p_attribute_02 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4154616531090960 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_PROGRAMMBEZEICHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 400,
  p_item_plug_id => 4154211552079978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Programmbezeichnung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4155806291248832 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_PROGRAMMBEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 410,
  p_item_plug_id => 4154211552079978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Programmbemerkung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4156015426260887 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_STARTDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 405,
  p_item_plug_id => 4154211552079978+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'to_char(sysdate,''DD.MM.YYYY'')',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Startdatum',
  p_format_mask=>'DD.MM.YYYY',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DATE_PICKER_CLASSIC',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6268613894763965 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 250,
  p_name=>'P250_NV_EOVITAL_PROGRAMM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 420,
  p_item_plug_id => 4078116848816789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Eovital Programm',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4140000030811596 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_eingaben',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_mutdat  VARCHAR2(25);'||unistr('\000a')||
'   v_number  NUMBER;'||unistr('\000a')||
'   v_datum   DATE;'||unistr('\000a')||
'   v_zeit VARCHAR2(10);'||unistr('\000a')||
'   v_min_planstart  DATE;'||unistr('\000a')||
'   v_VORLAUFZEIT_REZEPT therapie_stammphasen.VORLAUFZEIT_REZEPT%TYPE ; '||unistr('\000a')||
'   v_neue_zeile  varchar2(10) := ''<br/>''; '||unistr('\000a')||
'   v_fehlertext  VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id     NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   FOR j in 1..apex_application.g_f02.count  LOOP'||unistr('\000a')||
'      FOR i in 1..apex_application.g_f01.count  LOOP'||unistr('\000a')||
'          IF apex_application.g_f01(i) = apex_application.g_f02(j) THEN'||unistr('\000a')||
'             -- Prüfen, ob Prozess-Kontrolle zwischenzeitlich geändert wurde'||unistr('\000a')||
'             SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') '||unistr('\000a')||
'             INTO v_mutdat'||unistr('\000a')||
'             FROM therapie_programme'||unistr('\000a')||
'             WHERE  id = apex_application.g_f03(i);'||unistr('\000a')||
'             IF v_mutdat != apex_application.g_f10(i) THEN'||unistr('\000a')||
'                v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                   ''1791 Die Eingaben können nicht gespeichert werden, da die Datensätze bereits anderweitig geändert wurden! Bitte nochmals die aktuellen Werte anzeigen lassen!'';'||unistr('\000a')||
'             END IF;'||unistr('\000a')||
'             -- Check Plan_startdatum'||unistr('\000a')||
'             BEGIN'||unistr('\000a')||
'                v_datum := to_date(apex_application.g_f07(i),''DD.MM.RRRR'');'||unistr('\000a')||
'             EXCEPTION'||unistr('\000a')||
'             WHEN OTHERS THEN'||unistr('\000a')||
'                v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                    ''1792 Kein gültige Datum der Form TT.MM.JJJJ für das Plandatum eingegeben!(Phase ''||apex_application.g_f11(i)||'')'';'||unistr('\000a')||
'             END;'||unistr('\000a')||
'             -- Falls 1. Schritt schon gestartet (istzeit != NULL)  -- Verschiebung nur nach hinten möglich; '||unistr('\000a')||
'             IF apex_application.g_f13(i) IS NOT NULL THEN'||unistr('\000a')||
'                /* Kleinsten Mischungsstart ermitteln => bisherige Planzeit - verzoegerung */'||unistr('\000a')||
'                SELECT '||unistr('\000a')||
'                  to_date(to_char(pzs.planzeit - NVL(pzs.verzoegerung,0)/24,''DD.MM.RRRR''),''DD.MM.RRRR'')'||unistr('\000a')||
'                into v_min_planstart '||unistr('\000a')||
'                FROM prozess_schritte pzs, prozess_ablaeufe pza, '||unistr('\000a')||
'                     prozess_kontrolle pzk'||unistr('\000a')||
'                WHERE pzs.pz_ablauf_id = pza.id'||unistr('\000a')||
'                  AND pzs.pz_kontroll_id = apex_application.g_f05(i)'||unistr('\000a')||
'                  AND pzs.pz_kontroll_id = pzk.id'||unistr('\000a')||
'                  AND pzk.pz_typ_id = pza.pz_typ_id'||unistr('\000a')||
'                  AND instr(pza.kennzeichnung, '',MISCHUNGSTART,'') > 0  ; '||unistr('\000a')||
'                IF v_datum < v_min_planstart THEN'||unistr('\000a')||
'                  v_fehlertext := v_fehlertext ||v_neue_zeile||''Der Prozess zur Phase hat begonnen! Der früheste Planstart ist: ''|| to_char(v_min_planstart,''DD.MM.YYYY'')||''!(Phase ''||apex_application.g_f11(i)||'')'';'||unistr('\000a')||
'                END IF;'||unistr('\000a')||
'             END IF;'||unistr('\000a')||
'             -- Check Reichweite'||unistr('\000a')||
'             BEGIN'||unistr('\000a')||
'                v_number := to_number(apex_application.g_f09(i));'||unistr('\000a')||
'             EXCEPTION'||unistr('\000a')||
'             WHEN OTHERS THEN'||unistr('\000a')||
'                v_fehlertext:=v_fehlertext ||v_neue_zeile||''2100 Keine gültige Zahl für die Reichweite eingegeben!(Phase ''||apex_application.g_f11(i)||'')'';'||unistr('\000a')||
'             END;'||unistr('\000a')||
'             -- Check Fixzeit'||unistr('\000a')||
'             BEGIN'||unistr('\000a')||
'                v_datum:=to_date(apex_application.g_f16(i),''DD.MM.RRRR hh24:mi'');'||unistr('\000a')||
'                -- Falls Zeitangabe 00:00, dann auf 08:00 setzen'||unistr('\000a')||
'                --v_zeit := to_char(v_datum,''hh24:mi'');'||unistr('\000a')||
'                --IF v_zeit = ''00:00'' THEN '||unistr('\000a')||
'                --   apex_application.g_f16(i):= to_char(v_datum + 8/24,''DD.MM.RRRR hh24:mi''); '||unistr('\000a')||
'                --END IF; '||unistr('\000a')||
'             EXCEPTION'||unistr('\000a')||
'             WHEN OTHERS THEN'||unistr('\000a')||
'                v_fehlertext := v_fehlertext ||v_neue_zeile||''1792 Kein gültiges Datum der Form TT.MM.JJJJ SS:MI für den Termin eingegeben!(Phase ''||apex_application.g_f11(i)||'')'';'||unistr('\000a')||
'             END;'||unistr('\000a')||
'          END IF;'||unistr('\000a')||
'      END LOOP;'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   -- Fehlertext wird erst am Anfang vom Speichern ausgewertet und mit Raise angezeigt, damit keine refresh der Daten durchführt wird'||unistr('\000a')||
'   :p250_fehlertext := v_fehlertext;'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 4133702694104037 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4143104388246292 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_del',
  p_validation_sequence=> 20,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_mutdat      VARCHAR2(25);'||unistr('\000a')||
'   v_number      NUMBER;'||unistr('\000a')||
'   v_datum       DATE;'||unistr('\000a')||
'   v_neue_zeile  varchar2(10) := ''<br/>''; '||unistr('\000a')||
''||unistr('\000a')||
'   v_fehlertext  VARCHAR2(4000);'||unistr('\000a')||
'   v_prot_id     NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P(''Löschen validieren Anzahl=%1'',v_prot_id,''Info'','||unistr('\000a')||
'-- ''Löschen validieren'',apex_application.g_f02.count);'||unistr('\000a')||
'   FOR j in 1..apex_application.g_f02.count  LOOP'||unistr('\000a')||
'      FOR i in 1..apex_application.g_f01.count  LOOP'||unistr('\000a')||
'          IF apex_application.g_f01(i) = apex_application.g_f02(j) THEN'||unistr('\000a')||
'             -- Prüfen, ob Prozess-Kontrolle zwischenzeitlich geändert wurde'||unistr('\000a')||
'             SELECT to_char(mutdat,''DD.MM.YYYY HH24:MI:SS'') '||unistr('\000a')||
'             INTO v_mutdat'||unistr('\000a')||
'             FROM therapie_programme'||unistr('\000a')||
'             WHERE  id = apex_application.g_f03(i);'||unistr('\000a')||
'             IF v_mutdat != apex_application.g_f10(i) THEN'||unistr('\000a')||
'                v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                   ''1791 Die Eingaben können nicht gespeichert werden , da die Datensätze bereits anderweitig geändert wurden! Bitte nochmals die aktuellen Werte anzeigen lassen!'';'||unistr('\000a')||
'             END IF;'||unistr('\000a')||
''||unistr('\000a')||
'             IF apex_application.g_f14(i) is not null THEN --PZendezeit gesetzt'||unistr('\000a')||
'                v_fehlertext := v_fehlertext ||v_neue_zeile||'||unistr('\000a')||
'                   ''Die Phase kann nicht gelöscht werden , da der Prozess bereits beendet wurde! (Phase ''||apex_application.g_f11(i)||'')'';'||unistr('\000a')||
'             END IF;'||unistr('\000a')||
'--MEL.P(''Löschen validieren Anzahl=%1'',v_prot_id,''Info'','||unistr('\000a')||
'-- ''Löschen validieren'',apex_application.g_f01(i));'||unistr('\000a')||
''||unistr('\000a')||
'          END IF;'||unistr('\000a')||
'      END LOOP;'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   -- Fehlertext wird erst am Anfang vom Speichern ausgewertet und mit Raise angezeigt, damit keine refresh der Daten durchführt wird'||unistr('\000a')||
'   :p250_fehlertext := v_fehlertext;'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 4131514450538035 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4155106666125890 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_programmbezeichnung',
  p_validation_sequence=> 30,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :p250_programmbezeichnung IS NULL THEN'||unistr('\000a')||
'     --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             ''Programmbezeichnung''));'||unistr('\000a')||
'             --frgbg_s.holen_uebersetzung(517,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4154803287106029 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4154616531090960 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4156617120308751 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_programmstartdatum',
  p_validation_sequence=> 40,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_datum  DATE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p250_startdatum is null THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             ''Startdatum''));'||unistr('\000a')||
'          --frgbg_s.holen_uebersetzung(517,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      v_datum := to_date(:p250_startdatum,''DD.MM.RRRR'');                            '||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN OTHERS THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(1792,:fas_sprache_id,null));'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   IF v_datum < to_date(sysdate,''DD.MM.RRRR'')   THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(1811,:fas_sprache_id,null));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_when_button_pressed=> 4154803287106029 + wwv_flow_api.g_id_offset,
  p_associated_item=> 4156015426260887 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p250_fehlertext IS NOT NULL THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,:p250_fehlertext);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   v_return := prozesse.tp_del_phasen;'||unistr('\000a')||
'   IF v_return < 0 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Fehler beim Löschen der markierten Phase! '');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4135120278954204 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'phase_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4131514450538035 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return  NUMBER;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P(''Phase speichern %1, %2, %3, %4, %5'', v_prot_id,''Info'',''Fragebogen Therapie 250'', :request);'||unistr('\000a')||
'   IF :p250_fehlertext IS NOT NULL THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,:p250_fehlertext);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'     '||unistr('\000a')||
'   v_return := prozesse.tp_save_phasen;'||unistr('\000a')||
'   IF v_return < 0 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Fehler beim Speichern der ';

p:=p||'markierten Phase! '');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4141400966029501 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_phasen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4133702694104037 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p250_phasenauswahl != -1 THEN'||unistr('\000a')||
'      v_return := prozesse.tp_ins_phase(:P250_programmauswahl,:p250_phasenauswahl,:P250_PERSONENSTAMM_ID,'||unistr('\000a')||
'                                     :APP_USER);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,''Fehler beim Anhängen der markierten Phase! '');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4144809423361264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'neue_phase',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'P250_PHASENAUSWAHL',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_return := prozesse.tp_ins_programm('||unistr('\000a')||
'                                     :p250_programmBEZEICHNUNG ,'||unistr('\000a')||
'                                     :p250_programmBEMERKUNG,'||unistr('\000a')||
'                                     :p250_startdatum ,'||unistr('\000a')||
'                                     :P250_PERSONENSTAMM_ID,'||unistr('\000a')||
'                                     :fas_login_personenstamm_id,'||unistr('\000a')||
'              ';

p:=p||'                       :APP_USER'||unistr('\000a')||
'                                    );'||unistr('\000a')||
'   IF v_return < 0 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Fehler beim Erzeugen eines Programms! '');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4155301602133896 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'neues_programm',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4154803287106029 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p250_programmauswahl:= 0;';

wwv_flow_api.create_page_process(
  p_id     => 4166606270198067 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_neues_programm',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4166332674186737 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return      NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p250_programmauswahl is not null THEN'||unistr('\000a')||
'      v_return := prozesse.tp_del_programm(:p250_programmauswahl,:app_user);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,''Fehler beim Stoppen des Programms! '');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      :P250_programmauswahl := null;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4167420001268245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'programm_stoppen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4167131036243050 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_fehlertext   VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p250_programmauswahl is null THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT max(id) into :p250_programmauswahl'||unistr('\000a')||
'         from therapie_programme'||unistr('\000a')||
'         where startdatum = ('||unistr('\000a')||
'            SELECT max(startdatum) '||unistr('\000a')||
'            FROM therapie_programme'||unistr('\000a')||
'            where persstamm_id = :p250_personenstamm_id'||unistr('\000a')||
'              and status = 1'||unistr('\000a')||
'  ';

p:=p||'         )'||unistr('\000a')||
'          and persstamm_id = :p250_personenstamm_id'||unistr('\000a')||
'          and status = 1;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN no_data_found THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         -- Zugriff auf Therapie-Programme fehlgeschlagen'||unistr('\000a')||
'         v_fehlertext := ''Zugriff auf Therapie-Programme fehlgeschlagen!''; '||unistr('\000a')||
'                         --frgbg_s.holen_uebersetzung(483,:fas_sprache_id)||'' (0)'';'||unistr('\000a')||
'         ';

p:=p||'RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSIF :p250_programmauswahl = 0 THEN'||unistr('\000a')||
'      :p250_programmauswahl := NULL;   -- Neues Programm erfassen'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4138614082255279 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_programm',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P250_HEIGHT_eovital  := :FAS_SCROLLREGION_HEIGHT_MAX * 0.85;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4080112477825014 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 80,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'    v_fehlertext VARCHAR2(4000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   select name,vorname,to_char(geburtsdatum,''DD.MM.YYYY'')'||unistr('\000a')||
'   into :p250_name,:p250_vorname,:p250_geburtsdatum'||unistr('\000a')||
'   from personenstamm'||unistr('\000a')||
'   where id = :p250_personenstamm_id;'||unistr('\000a')||
'  '||unistr('\000a')||
' '||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN no_data_found THEN'||unistr('\000a')||
'     -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'     v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id)||'' (0)'';'||unistr('\000a')||
'     RAISE_APPL';

p:=p||'ICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'     -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'     v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'     RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4080328754829715 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 80,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p250_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   --:p140_bl_verwerfen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'   --:p140_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id); '||unistr('\000a')||
'   --:p140_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);-- NEI 23.06.08'||unistr('\000a')||
'   --:P140_bl_ota_suche := frgbg_s.h';

p:=p||'olen_uebersetzung(756,v_sprache_id);'||unistr('\000a')||
'   --:P140_bl_eovital   := frgbg_s.holen_uebersetzung(2040,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p250_page_titel_eovital := frgbg_s.holen_uebersetzung(2040,v_sprache_id);'||unistr('\000a')||
'   :p250_page_titel_patient := frgbg_s.holen_uebersetzung(482,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P250_NV_EOVITAL_PROGRAMM := frgbg_s.holen_uebersetzung(3838,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4080502912831770 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 250,
  p_process_sequence=> 80,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 250
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00260
prompt  ...PAGE 260: Provisionsübersicht
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 260
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Provisionsübersicht'
 ,p_step_title => '&P260_REGION_TITEL_PROVISIONEN.'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Provisionsübersicht'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2884210922489435 + wwv_flow_api.g_id_offset
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20120628120915'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT level,'||unistr('\000a')||
'frgbg_s.get_pers_name(PERSSTAMM_ID)||'' (''||PERSSTAMM_ID||'')''  ,'||unistr('\000a')||
'--"PERSONENTYP",'||unistr('\000a')||
'--"STATUS",'||unistr('\000a')||
'to_char(NVL(PUNKTE_DIREKT,0),''FM999G990D00''),'||unistr('\000a')||
'to_char(NVL(PUNKTE_INDIREKT,0),''FM999G990D00''),'||unistr('\000a')||
'to_char(NVL(PUNKTE_GESAMT,0),''FM999G990D00''),'||unistr('\000a')||
'PROVISIONSPROZENT,'||unistr('\000a')||
'to_char(NVL(PROVISIONSBETRAG,0),''FM999G990D00''),'||unistr('\000a')||
'to_char(NVL(PROVISION_AN_ANDERE_BEZAHLT,0),''FM999G990D00''),'||unistr('\000a')||
'to_char(NVL(PROVISIONSBET';

s:=s||'RAG-PROVISION_AN_ANDERE_BEZAHLT,0),''FM999G990D00''),'||unistr('\000a')||
'CASE WHEN PERSONENTYP = ''E'' THEN frgbg_s.holen_uebersetzung(1569,357)'||unistr('\000a')||
'     ELSE frgbg_s.holen_uebersetzung(1854,357)'||unistr('\000a')||
'END'||unistr('\000a')||
'from "PROVISIONSDETAILS"'||unistr('\000a')||
'where "PROVISIONSKOPF_ID" = :p260_provisionskopf_id'||unistr('\000a')||
'  and (( (persstamm_id = :FAS_LOGIN_PERSONENSTAMM_ID and level = :p260_level) -- eigener Level'||unistr('\000a')||
'          OR'||unistr('\000a')||
'         (persstamm_id_betreuer = :FAS_LOG';

s:=s||'IN_PERSONENSTAMM_ID and level >= :p260_level +1) -- und eine Stufe tiefer'||unistr('\000a')||
'       )'||unistr('\000a')||
'      OR :p260_level= 0  -- alle Level'||unistr('\000a')||
'      )'||unistr('\000a')||
''||unistr('\000a')||
'start with persstamm_id = :p260_persstamm_id --27567 --24377--40489 -- '||unistr('\000a')||
'connect by prior persstamm_id = persstamm_id_betreuer'||unistr('\000a')||
'       and prior PROVISIONSKOPF_ID = :p260_provisionskopf_id';

wwv_flow_api.create_page_plug (
  p_id=> 3812615728380494 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 260,
  p_plug_name=> 'Provisionsübersicht',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2888602376489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'PLUGIN_DINH.DE.TREETABLE',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_attribute_01=> '10',
  p_attribute_02 => '&P260_REPORT_COLUMNS_PROV.',
  p_attribute_03 => 'Y',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3947202916977701 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 260,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 3825412524077453 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 260,
  p_button_sequence=> 10,
  p_button_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P260_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3825519797079542 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P260_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:260::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3825412524077453+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3813400687380513 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_name=>'P260_REPORT_COLUMNS_PROV',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3816425847449826 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_name=>'P260_PERSSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3816822431477249 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_name=>'P260_LEVEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3817008017482546 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_name=>'P260_PROVISIONSKOPF_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3824204943027897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_name=>'P260_STICHTAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'select stichtag from provisionskoepfe where id = :p260_provisionskopf_id',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3825810231086285 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_name=>'P260_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3826002397093420 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_name=>'P260_REGION_TITEL_PROVISIONEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3826317073107186 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_name=>'P260_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3947614475990563 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 260,
  p_name=>'P260_NV_PROVISIONSUEBERSICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 3812615728380494+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz number;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'   v_fehlernummer number;'||unistr('\000a')||
'   v_fehlertext varchar2(2000);'||unistr('\000a')||
'   v_fehler exception;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
' '||unistr('\000a')||
'   --  Provisionskopf bestimmen: max. Stichtag der aktiven Identität'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT max(id) INTO :p260_provisionskopf_id'||unistr('\000a')||
'      FROM provisionskoepfe'||unistr('\000a')||
'      WHERE persstamm_id_identitaet = frgbg_s.get_pers_option(:APP_USER,32) --:FAS_IDENTITAET_PERSSTAMM_ID'||unistr('\000a')||
'  ';

p:=p||'      AND status != ''N'''||unistr('\000a')||
'        and stichtag = (SELECT max(stichtag)'||unistr('\000a')||
'                        FROM provisionskoepfe'||unistr('\000a')||
'                        WHERE persstamm_id_identitaet = frgbg_s.get_pers_option(:APP_USER,32)  --:FAS_IDENTITAET_PERSSTAMM_ID'||unistr('\000a')||
'                          AND status != ''N'''||unistr('\000a')||
'                       );'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(4915,:f';

p:=p||'as_sprache_id);'||unistr('\000a')||
'      v_fehlernummer := -10;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Persstamm bestimmen ab dem Level die Provisionssätze angezeigt werden sollen'||unistr('\000a')||
'   -- falls Rolle PROV_UEBERSICHT_GESAMT fehlt '||unistr('\000a')||
'   --      => Login-Person mit eigenen Provsätzen und ein Level tiefer'||unistr('\000a')||
'   --      => sonst Gesamtübersicht für die Identität'||unistr('\000a')||
'   IF frgbg_s.check_fas_rolle(:APP_USER,'||unistr('\000a')||
'                           ';

p:=p||'  ''PROV_UEBERSICHT_GESAMT'') > 0 THEN'||unistr('\000a')||
'      :p260_persstamm_id := frgbg_s.get_pers_option(:APP_USER,32);--:FAS_IDENTITAET_PERSSTAMM_ID;'||unistr('\000a')||
'      :p260_level := 0;   -- alle Ebenen anzeigen'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p260_persstamm_id := frgbg_s.get_pers_option(:APP_USER,32);--:FAS_LOGIN_PERSONENSTAMM_ID;  --27567'||unistr('\000a')||
'      -- Level der Login-Person bestimmen'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT level INTO :p260_level'||unistr('\000a')||
'        ';

p:=p||' from "PROVISIONSDETAILS"   '||unistr('\000a')||
'         where "PROVISIONSKOPF_ID" = :p260_provisionskopf_id'||unistr('\000a')||
'           and persstamm_id = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'         start with persstamm_id = :p260_persstamm_id --27567 --24377--40489 --'||unistr('\000a')||
'         connect by prior persstamm_id = persstamm_id_betreuer'||unistr('\000a')||
'         and prior PROVISIONSKOPF_ID = :p260_provisionskopf_id   ;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'   ';

p:=p||'      v_fehlertext := frgbg_s.holen_uebersetzung(4915,:fas_sprache_id);'||unistr('\000a')||
'         v_fehlernummer := -25;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END;'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Prüfen, ob Provisionen vorhanden sind sonst direkt auf Startmaske'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      from "PROVISIONSDETAILS"'||unistr('\000a')||
'      where "PROVISIONSKOPF_ID" = :p260_provisionskopf_id'||unistr('\000a')||
'        and (( (persstamm_id = :FAS_LOGIN_PE';

p:=p||'RSONENSTAMM_ID and level = :p260_level) OR'||unistr('\000a')||
'               (persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID and level >= :p260_level +1)'||unistr('\000a')||
'             )'||unistr('\000a')||
'            OR :p260_level= 0'||unistr('\000a')||
'            )'||unistr('\000a')||
'      start with persstamm_id = :p260_persstamm_id --27567 --24377--40489 -- '||unistr('\000a')||
'      connect by prior persstamm_id = persstamm_id_betreuer'||unistr('\000a')||
'             and prior PROVISIONSKOPF_ID = :p260_provisionskopf';

p:=p||'_id;'||unistr('\000a')||
'      IF v_anz = 0 THEN -- Keine Sätze vorhanden'||unistr('\000a')||
'         v_fehlernummer := -20;'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(4914,:fas_sprache_id);'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(4915,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlernummer := -30;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'mel.p(''init_maske ident %2, Log';

p:=p||'in %1, pers %3'',v_prot_id,''TEST'',''102/260:init_maske'',:FAS_LOGIN_PERSONENSTAMM_ID,:FAS_IDENTITAET_PERSSTAMM_ID,:p260_persstamm_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   mel.p(v_fehlertext||'' (''||v_fehlernummer||'')'',v_prot_id,''ERROR'',''102/260:init_maske'');'||unistr('\000a')||
'   owa_util.redirect_url(APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'          ''f?p=''||:APP_ID||'':130:''||:APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext)); --- Redirec';

p:=p||'t'||unistr('\000a')||
'   apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   v_fehlertext := frgbg_s.holen_uebersetzung(4915,:fas_sprache_id)||''(99:''||SQLERRM||'')'';'||unistr('\000a')||
'   mel.p(v_fehlertext,v_prot_id,''ERROR'',''102/260:init_maske'');'||unistr('\000a')||
'   owa_util.redirect_url(APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'                  ''f?p=''||:APP_ID||'':130:''||:APP_SESSION||''::::P130_HINWEIS:'''||unistr('\000a')||
'          ';

p:=p||'      ||frgbg_s.holen_uebersetzung(4915,:fas_sprache_id))); --- Redirect'||unistr('\000a')||
'   apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3813817688380519 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 260,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_maske',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --:p130_abmelden := frgbg_s.holen_uebersetzung(174,v_sprache_id);'||unistr('\000a')||
'   :p260_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p260_region_titel_provisionen := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(4916,v_sprache_id);'||unistr('\000a')||
'   :P260_NV_Provisionsuebersicht := frgbg_s.holen_uebersetzung(4916,v_sprache_';

p:=p||'id);'||unistr('\000a')||
'   -- Tabellenüberschrift'||unistr('\000a')||
'   :p260_report_columns_prov := frgbg_s.holen_uebersetzung(4913,357,''€'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3825122998061506 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 260,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 260
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00261
prompt  ...PAGE 261: Provisionshierarchie_FAS
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 261
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Provisionshierarchie_FAS'
 ,p_step_title => 'Provisionshierarchie_FAS'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Provisionshierarchie_FAS'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2884210922489435 + wwv_flow_api.g_id_offset
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130130085843'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT level,'||unistr('\000a')||
'frgbg_s.get_pers_name(PERSSTAMM_ID)||'' (''||PERSSTAMM_ID||'')'' '||unistr('\000a')||
'/*,frgbg_s.get_pers_name(PERSSTAMM_ID_werber)||'' (''||PERSSTAMM_ID_werber||'')''  ,level ebene*/'||unistr('\000a')||
'from'||unistr('\000a')||
''||unistr('\000a')||
'        (select persstamm_id, NVL(persstamm_id_werber,to_number(:p261_persstamm_id_vorgabeident)) persstamm_id_werber,'||unistr('\000a')||
'                provisionstyp      -- alle provisionssÂ¿e aus Vorgabe-Ident'||unistr('\000a')||
'         from pers_provisione';

s:=s||'n pp, personenstamm p'||unistr('\000a')||
'         where persstamm_id in ( -- Blattident unterhalb Vorgabeident'||unistr('\000a')||
'                                 select  persstamm_id_identitaet                -- Ident unterhalb der Vorgabe-Ident'||unistr('\000a')||
'                                 from pers_identitaeten'||unistr('\000a')||
'                                 where persstamm_id_identitaet not in'||unistr('\000a')||
'                                            (SELECT persstamm_id_';

s:=s||'oberidentitaet -- Nur Blattident sind relevant'||unistr('\000a')||
'                                             from pers_identitaeten'||unistr('\000a')||
'                                             where persstamm_id_oberidentitaet is not null'||unistr('\000a')||
'                                             )'||unistr('\000a')||
''||unistr('\000a')||
'                                 start with persstamm_id_identitaet ='||unistr('\000a')||
'                                         :p261_persstamm_id_vorgabeident'||unistr('\000a')||
'   ';

s:=s||'                              connect by prior  persstamm_id_identitaet='||unistr('\000a')||
'                                                                 persstamm_id_oberidentitaet'||unistr('\000a')||
'                                )'||unistr('\000a')||
'           and pp.satz_kennzeichen is null   -- nicht gelöschte Prov.Sätze  '||unistr('\000a')||
'           and pp.persstamm_id = p.id'||unistr('\000a')||
'           and p.satzkennzeichen is null     -- nicht gelöschte Personen'||unistr('\000a')||
'         UNI';

s:=s||'ON                                                   -- Alle Blattidentitaeten unterhalb Vorgabe-Ident ohne Provisionssatz'||unistr('\000a')||
'         select persstamm_id_identitaet,to_number(:p261_persstamm_id_vorgabeident),''B'''||unistr('\000a')||
'         FROM pers_identitaeten pi, personenstamm p'||unistr('\000a')||
'         WHERE persstamm_id_identitaet in'||unistr('\000a')||
'                               ( -- Blattident unterhalb Vorgabeident'||unistr('\000a')||
'                          ';

s:=s||'       select  persstamm_id_identitaet                -- Ident unterhalb der Vorgabe-Ident'||unistr('\000a')||
'                                 from pers_identitaeten'||unistr('\000a')||
'                                 where persstamm_id_identitaet not in'||unistr('\000a')||
'                                            (SELECT persstamm_id_oberidentitaet -- Nur Blattident sind relevant'||unistr('\000a')||
'                                             from pers_identitaeten'||unistr('\000a')||
'   ';

s:=s||'                                          where persstamm_id_oberidentitaet is not null'||unistr('\000a')||
'                                             )'||unistr('\000a')||
''||unistr('\000a')||
'                                 start with persstamm_id_identitaet ='||unistr('\000a')||
'                                         :p261_persstamm_id_vorgabeident'||unistr('\000a')||
'                                 connect by prior  persstamm_id_identitaet='||unistr('\000a')||
'                                             ';

s:=s||'                    persstamm_id_oberidentitaet'||unistr('\000a')||
'                                )'||unistr('\000a')||
'           and persstamm_id_identitaet not in (select persstamm_id from pers_provisionen where satz_kennzeichen is null)    -- keine Provisionssatz'||unistr('\000a')||
'           and pi.persstamm_id_identitaet = p.id  -- nicht gelöschte Personen'||unistr('\000a')||
'           and p.satzkennzeichen is null'||unistr('\000a')||
'         UNION'||unistr('\000a')||
'         select  to_number(:p261_per';

s:=s||'sstamm_id_vorgabeident),NULL,''M'' from dual -- oberster Eintrag mit Werber NULL'||unistr('\000a')||
'        )'||unistr('\000a')||
''||unistr('\000a')||
'where :p261_level >= 0 and level<= :p261_level -- eigener Level und eine Stufe tiefer'||unistr('\000a')||
'   or :p261_level = 0   -- alle Level  '||unistr('\000a')||
'start with persstamm_id = :p261_persstamm_id_teilbaum  --7218 --27567 --24377--40489 -- '||unistr('\000a')||
'connect by prior persstamm_id = persstamm_id_werber'||unistr('\000a')||
'       ';

wwv_flow_api.create_page_plug (
  p_id=> 5648026641495330 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 261,
  p_plug_name=> '&P261_REGION_TITEL_PROVISIONEN.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2888602376489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'PLUGIN_DINH.DE.TREETABLE',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_attribute_01=> '10',
  p_attribute_02 => '&P261_REPORT_COLUMNS_PROV.',
  p_attribute_03 => 'Y',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7400022461659358 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 261,
  p_plug_name=> 'Navigation01',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5648201256495332 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 261,
  p_button_sequence=> 10,
  p_button_plug_id => 5648026641495330+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P261_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5650701923495338 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 261,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P261_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:261::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5648201256495332+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5648406626495332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 261,
  p_name=>'P261_REGION_TITEL_PROVISIONEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5648026641495330+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5648604344495334 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 261,
  p_name=>'P261_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 5648026641495330+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5648803625495334 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 261,
  p_name=>'P261_NV_PROVISIONSHIERARCHIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 5648026641495330+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5649008383495334 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 261,
  p_name=>'P261_PERSSTAMM_ID_TEILBAUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 5648026641495330+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Teilbaum',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5649413749495334 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 261,
  p_name=>'P261_PERSSTAMM_ID_VORGABEIDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5648026641495330+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Vorgabeident',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5649624132495334 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 261,
  p_name=>'P261_LEVEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5648026641495330+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5650008203495335 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 261,
  p_name=>'P261_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5648026641495330+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5653005261749196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 261,
  p_name=>'P261_REPORT_COLUMNS_PROV',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 5648026641495330+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz number;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'   v_fehlernummer number;'||unistr('\000a')||
'   v_fehlertext varchar2(2000);'||unistr('\000a')||
'   v_fehler exception;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   -- Vorgabeidentität'||unistr('\000a')||
'   :p261_persstamm_id_vorgabeident := frgbg_s.get_pers_option(:APP_USER,32);'||unistr('\000a')||
'   IF frgbg_s.check_fas_rolle(:APP_USER,'||unistr('\000a')||
'                             ''PROV_UEBERSICHT_GESAMT'') > 0 THEN'||unistr('\000a')||
'      :p261_persstamm_id_teilbaum := :p261_persstamm_id_vorga';

p:=p||'beident;'||unistr('\000a')||
'      :p261_level := 0;   -- alle Ebenen anzeigen'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Teilbaum ist Identität des Betreuers'||unistr('\000a')||
'      :p261_persstamm_id_teilbaum:= frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'      :p261_level := 2;   -- sich und eine Ebene tiefer'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'mel.p(''init_maske ident %2, Login %1, pers %3'',v_prot_id,''TEST'',''102/260:init_maske'',:FAS_LOGIN_PERSONENSTAMM_ID,:FAS_IDE';

p:=p||'NTITAET_PERSSTAMM_ID,:p261_persstamm_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   mel.p(v_fehlertext||'' (''||v_fehlernummer||'')'',v_prot_id,''ERROR'',''102/260:init_maske'');'||unistr('\000a')||
'   owa_util.redirect_url(APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'          ''f?p=''||:APP_ID||'':130:''||:APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext)); --- Redirect'||unistr('\000a')||
'   apex_application.g_unrecoverable_error := true;   --- stops all further page processi';

p:=p||'ng'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   v_fehlertext := frgbg_s.holen_uebersetzung(4915,:fas_sprache_id)||''(99:''||SQLERRM||'')'';'||unistr('\000a')||
'   mel.p(v_fehlertext,v_prot_id,''ERROR'',''102/260:init_maske'');'||unistr('\000a')||
'   owa_util.redirect_url(APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'                  ''f?p=''||:APP_ID||'':130:''||:APP_SESSION||''::::P130_HINWEIS:'''||unistr('\000a')||
'                ||frgbg_s.holen_uebersetzung(4915,:fas_sprache_id))); --- Redirect'||unistr('\000a')||
'   apex_applicati';

p:=p||'on.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5650223713495335 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 261,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_maske',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --:p130_abmelden := frgbg_s.holen_uebersetzung(174,v_sprache_id);'||unistr('\000a')||
'   :p261_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p261_region_titel_provisionen := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(5447,v_sprache_id);'||unistr('\000a')||
'   :P261_NV_PROVISIONSHIERARCHIE := frgbg_s.holen_uebersetzung(5447,v_sprache_';

p:=p||'id);'||unistr('\000a')||
'   -- Tabellenüberschrift'||unistr('\000a')||
'   :p261_report_columns_prov := frgbg_s.holen_uebersetzung(5446,357,''€'');'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5650431811495337 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 261,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 261
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00270
prompt  ...PAGE 270: Identbaum
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 270
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Identbaum'
 ,p_step_title => 'Identbaum'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Identbaum'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140319103252'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5300014070940434 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 270,
  p_plug_name=> 'Identbaum',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'JSTREE',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_query_no_data_found=>'No data found.',
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'select case when connect_by_isleaf = 1 then 0'||unistr('\000a')||
'            when level = 1             then 1'||unistr('\000a')||
'            else                           -1'||unistr('\000a')||
'       end as status, '||unistr('\000a')||
'       level, '||unistr('\000a')||
'       "NAME"||'' ''||"VORNAME"||'' ''||"PLZ"||'' '' ||"ORT"||'' (''||"PERSSTAMM_ID_IDENTITAET"||'')'' as title, '||unistr('\000a')||
'       null as icon, '||unistr('\000a')||
'       "PERSSTAMM_ID_IDENTITAET" as value, '||unistr('\000a')||
'       PERSSTAMM_ID_IDENTITAET as tooltip, '||unistr('\000a')||
'       CAS';

a1:=a1||'E '||unistr('\000a')||
'       WHEN betreuer = ''I'' THEN'||unistr('\000a')||
'          APEX_UTIL.PREPARE_URL(''f?p=&APP_ID.:132:&SESSION.::NO:132:P132_ZURUECK_ZUR_SEITE,P132_ID_PARAMETER:''||'||unistr('\000a')||
'               :APP_PAGE_ID||'',''||"PERSSTAMM_ID_IDENTITAET")'||unistr('\000a')||
'       ELSE'||unistr('\000a')||
'          NULL'||unistr('\000a')||
'       END as link '||unistr('\000a')||
'from "#OWNER#"."V_IDENT_HIERARCHIE"'||unistr('\000a')||
'start with "PERSSTAMM_ID_OBERIDENTITAET" is null'||unistr('\000a')||
'connect by prior "PERSSTAMM_ID_IDENTITAET" = "PERSSTAMM_ID_';

a1:=a1||'OBERIDENTITAET" '||unistr('\000a')||
'       and prior standard = ''J'' '||unistr('\000a')||
'order siblings by "NAME"';

wwv_flow_api.create_jstree(
  p_id => 5300227672940443+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id => 270,
  p_region_id => 5300014070940434+wwv_flow_api.g_id_offset,
  p_tree_template     =>'apple',
  p_tree_source             =>'V_IDENT_HIERARCHIE',
  p_tree_query             =>a1,
  p_tree_node_title   =>'PERSSTAMM_ID_OBERIDENTITAET',
  p_tree_node_value   =>'NAME',
  p_tree_node_icon   =>'',
  p_tree_node_link   =>'',
  p_tree_node_hints   =>'PERSSTAMM_ID_IDENTITAET',
  p_tree_start_item   =>'PERSSTAMM_ID_OBERIDENTITAET',
  p_tree_start_value   =>'',
  p_tree_button_option   =>'',
  p_show_node_link   =>'',
  p_node_link_checksum_type   =>null,
  p_tree_comment          =>'',
  p_show_hints          =>'DB',
  p_tree_has_focus          =>'N',
  p_tree_hint_text          =>'',
  p_tree_click_action          =>'S',
  p_selected_node          =>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5305003800486806 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 270,
  p_button_sequence=> 10,
  p_button_plug_id => 5300014070940434+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5305322154492028 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 270,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P270_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:270::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5305003800486806+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 130,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5305212803489411 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 270,
  p_name=>'P270_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5300014070940434+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '130',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 270
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00300
prompt  ...PAGE 300: Warenkorb
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 300
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Warenkorb'
 ,p_alias => 'WARENKORB'
 ,p_step_title => 'Warenkorb'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_checkBestelldatBestellen (button_name,plandatum,bestelldatum,rezeptnr,reichweite) '||unistr('\000a')||
'{ '||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkBestelldatumNeu'',0);'||unistr('\000a')||
'  var v_confirm;'||unistr('\000a')||
''||unistr('\000a')||
'  //alert(plandatum);'||unistr('\000a')||
'  //alert(bestelldatum);'||unistr('\000a')||
'  //alert(rezeptnr);'||unistr('\000a')||
'  get.add(''TEMP_PLANDATUM'',plandatum);'||unistr('\000a')||
'  get.add(''TEMP_BESTELLDATUM'',bestelldatum);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  v_confirm = confirm(gReturn);'||unistr('\000a')||
'       if (v_confirm == true)'||unistr('\000a')||
'          {'||unistr('\000a')||
'           html_GetElement(''P300_REZEPT_NR'').value =rezeptnr; '||unistr('\000a')||
'           html_GetElement(''P300_REZEPT_REICHWEITE'').value =reichweite; '||unistr('\000a')||
'           doSubmit(button_name);'||unistr('\000a')||
'           //apex.submit({request:''WARENKORB'',set:{''P300_REZEPT_NR'':rezeptnr}})'';'||unistr('\000a')||
'          }'||unistr('\000a')||
'    }'||unistr('\000a')||
'   else'||unistr('\000a')||
'    {'||unistr('\000a')||
'      html_GetElement(''P300_REZEPT_NR'').value =rezeptnr; '||unistr('\000a')||
'      html_GetElement(''P300_REZEPT_REICHWEITE'').value =reichweite; '||unistr('\000a')||
'      doSubmit(button_name);'||unistr('\000a')||
'      //apex.submit({request:''WARENKORB'',set:{''P300_REZEPT_NR'':rezeptnr}})'';'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150513103920'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select m.id,                                                                        /* Artikel */'||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)'||unistr('\000a')||
'      --||CASE WHEN m.beschreibung is not null THEN  -- NEI 26.03.2014 nur noch die beschreibung_text_id ist aktiv wg. langen Texten'||unistr('\000a')||
'      ||CASE WHEN m.beschreibung_text_id is not null THEN'||unistr('\000a')||
'/*         ''    <a href="''||APE';

s:=s||'X_UTIL.PREPARE_URL('||unistr('\000a')||
'         ''f?p=''||:APP_ID||'':306:''||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id)    '||unistr('\000a')||
'         || ''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'         ''    <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':306:'''||unistr('\000a')||
'         ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id||'''''',700,380)">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >';

s:=s||''''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END'||unistr('\000a')||
'      || ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'             artikel,'||unistr('\000a')||
'      to_char(rezepte.calc_preis_mwst_ges(wk.verrech_land_id,'||unistr('\000a')||
'             m.prodkennz_id,m.id,wk.preisliste_id,'||unistr('\000a')||
'             wk.art_mwst_typ_id, wk.preisfaktor,wk.persstamm_id_prod_a';

s:=s||'po,0)'||unistr('\000a')||
'        ,''999G990D00'')||'' ''||rezepte.get_waehrung_zeichen(wk.waehrung_id)'||unistr('\000a')||
'             stueckpreis,'||unistr('\000a')||
'      CASE WHEN m.dokument_id is not null THEN'||unistr('\000a')||
'      ''<img src="'' || frgbg_t.get_sys_param(63) || frgbg_s.holen_uebersetzung(NVL(m.dokument_id, 0),:fas_sprache_id) --#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         --|| NVL (m.dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ';

s:=s||'''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" width="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'      ELSE NULL END img,'||unistr('\000a')||
'/*'||unistr('\000a')||
'  ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':300:''||:APP_SESSION|| '':WARENKORB:::'''||unistr('\000a')||
'     ||''P300_MENGENART_ID:'''||unistr('\000a')||
'     ||m.id)    '||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   wk_link'||unistr('\000a')||
'*/'||unistr('\000a')||
'   CASE WHEN :p300_wk_artik';

s:=s||'eltyp_flag = 1  -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                           -- =1 heisst bereits Laborartikel im WK => keine sonstigen Artikel mehr '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      '' '''||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P300_MENGENART_ID'''':''||m.id||''}})'''||unistr('\000a')||
'        || ''">'''||unistr('\000a')||
'        || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'        || ''</a>';

s:=s||''''||unistr('\000a')||
'   END wk_link,'||unistr('\000a')||
'   1 sort_typ,'||unistr('\000a')||
'   --fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id) sort_art,'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'',m.ID,:fas_sprache_id) sort_art,'||unistr('\000a')||
'   null sort_rez,'||unistr('\000a')||
'   --to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(NULL,m.id),''DD.MM.YYYY'') last_bestelldatum,'||unistr('\000a')||
'   NULL last_bestelldatum,'||unistr('\000a')||
'   null akt_datum,'||unistr('\000a')||
'   null|| apex_item.hidden(32, NUL';

s:=s||'L) rezept_reichweite '||unistr('\000a')||
'FROM mengenarts m, sortiment_details s, --NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'     warenkoerbe_tmp wk'||unistr('\000a')||
'where m.satz_kennzeichen is null'||unistr('\000a')||
'  --and m.prodkennz_id = 2   Nur noch über Sortiment-det.verkaufsartikel'||unistr('\000a')||
'  and m.id = s.mengenart_id'||unistr('\000a')||
'  and s.sortiment_id = :fas_sortiment_id --NEI 14.02.2011 Sortimentseinf.'||unistr('\000a')||
'  and s.satz_kennzeichen is null'||unistr('\000a')||
'  and s.verkaufsartikel != ''N'''||unistr('\000a')||
'  A';

s:=s||'ND ((:P300_suche is NULL and :p300_artikelkategorie = 0 and 1=2) -- keine Ergebnisse => Maskeneinstieg '||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P300_suche is NULL and :p300_artikelkategorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P300_suche is NOT NULL AND '||unistr('\000a')||
'        instr(UPPER (fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id)'||unistr('\000a')||
'        ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG';

s:=s||''','||unistr('\000a')||
'                    m.ID,:fas_sprache_id) ),UPPER(:P300_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Artikel die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p300_id'||unistr('\000a')||
'  /*and ( m.id is not null AND'||unistr('\000a')||
'        m.id not in (SELECT mengenart_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p300_id'||unistr('\000a')||
'                       and mengenart_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       OR m.id is null';

s:=s||''||unistr('\000a')||
'      )'||unistr('\000a')||
'  */'||unistr('\000a')||
'  --AND :P300_ARTIKELKATEGORIE != -1  /* -1 nur Rezepte */ NEI 21.5.13 Einführ. Laboranforderung'||unistr('\000a')||
'  AND :P300_ARTIKELKATEGORIE not in (-1,20)  /* -1 Rezepte, 20 Laboranforderungen */'||unistr('\000a')||
'  AND ((:P300_artikelkategorie = 0 and m.artgruppe_id!=20)  OR m.artgruppe_id = :P300_artikelkategorie)'||unistr('\000a')||
'  -- Keine Artikel mit Preis -1, d.h. Preis muss >=0  => Fehler bei der Artikeluebernahme'||unistr('\000a')||
'  AND exis';

s:=s||'ts'||unistr('\000a')||
'       (select * '||unistr('\000a')||
'        from preislisten_details'||unistr('\000a')||
'        where mengenart_id = s.mengenart_id'||unistr('\000a')||
'        and preisliste_id = wk.preisliste_id'||unistr('\000a')||
'        and GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND MIN_MENGE <= 1'||unistr('\000a')||
'        AND MAX_MENGE >= 1'||unistr('\000a')||
'        AND preis >= 0'||unistr('\000a')||
'       )'||unistr('\000a')||
'UNION                                                                         ';

s:=s||'                /* Rezepte */'||unistr('\000a')||
'SELECT mnr.rezept_nr,'||unistr('\000a')||
'       mnr.rezept_nr                            '||unistr('\000a')||
'       ||''/''||mnr.version||'', '''||unistr('\000a')||
'/*       ||mnr.Bezeichnung'||unistr('\000a')||
'*/'||unistr('\000a')||
'       ||mnr.Bemerkung'||unistr('\000a')||
'       ||''</br>''|| frgbg_s.holen_uebersetzung(585,:fas_sprache_id)||'': ''||prodr.reichweite'||unistr('\000a')||
'       ||''</br> <a style="background-color:orange" >''||(select frgbg_s.holen_uebersetzung(hinweis_text_id,:fas_sprache_id) ';

s:=s||' '||unistr('\000a')||
'                   from inh_grenzwerttypen'||unistr('\000a')||
'                   where id = rezepte.get_mnr_gwtyp_id(mnr.id,1)) || ''</a>'''||unistr('\000a')||
'/*       ||DECODE(mnr.neuberechnen||mnr.neuberechnen_sortiment,'||unistr('\000a')||
'                       ''NN'','' '',''* '')         -- Neuberechnen markieren    '||unistr('\000a')||
'*/'||unistr('\000a')||
'       ||CASE WHEN mnr.neuberechnen = ''J'' OR '||unistr('\000a')||
'               mnr.neuberechnen_sortiment=''J'' OR --NEI 14.02.11 Sortimentseinf.'||unistr('\000a')||
'          ';

s:=s||'     prodr.sortiment_id != :FAS_SORTIMENT_ID -- NEI 26.4.11'||unistr('\000a')||
'         THEN           -- Neuberechnen markieren'||unistr('\000a')||
'            '' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'          ||frgbg_s.holen_uebersetzung(4890,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'          ||''  <img src="#IMAGE_PREFIX#yellow_flag.gif">  '''||unistr('\000a')||
'         ELSE NULL'||unistr('\000a')||
'         END'||unistr('\000a')||
'       ||CASE WHEN prodr.prod_rezstatus_id = 1  -- Ar';

s:=s||'beitsversion markieren'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            '' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'          ||frgbg_s.holen_uebersetzung(4889,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'          ||''  <img src="#IMAGE_PREFIX#red_flag.gif">  '''||unistr('\000a')||
'         ELSE NULL'||unistr('\000a')||
'         END'||unistr('\000a')||
'       ,'||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       ''<img src="'' || frgbg_t.get_sys_param(63) || frgbg_s.holen_uebersetzung((select min(dokument_id) fro';

s:=s||'m mengenarts where id=102),:fas_sprache_id) --#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         --|| (select min(dokument_id) from mengenarts where id=102)'||unistr('\000a')||
'         --||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" width="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'' img,'||unistr('\000a')||
'  CASE WHEN mnr.neuberechnen=''J'' OR                  -- Neuberechnen'||unistr('\000a')||
'            mnr.';

s:=s||'neuberechnen_sortiment =''J'' OR'||unistr('\000a')||
'            prodr.sortiment_id!=:fas_sortiment_id OR -- geändertes Sortiment'||unistr('\000a')||
'            prodr.PROD_REZSTATUS_ID = 1   OR         -- Arbeitsversion'||unistr('\000a')||
'            :p300_wk_artikeltyp_flag =1              -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                                     -- =1 heisst bereits Laborartikel im WK => keine Rezepte mehr '||unistr('\000a')||
'  THEN'||unistr('\000a')||
'     '' ';

s:=s||''''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'/*'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':300:''||:APP_SESSION|| '':WARENKORB:::'''||unistr('\000a')||
'     ||''P300_REZEPT_NR:'''||unistr('\000a')||
'     ||mnr.rezept_nr)    '||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'--''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P300_REZEPT_NR'''':''||mnr.rezept_nr||''}})'''||unistr('\000a')||
'''<a href="javascript:f_checkBes';

s:=s||'telldatBestellen(''''WARENKORB'''',''''''||to_char(sysdate,''DD.MM.YYYY'')'||unistr('\000a')||
'     --||'''''',''''''||to_char(auftragsdispo.GET_LAST_BESTELL_DAT(mnr.id),''DD.MM.YYYY'')'||unistr('\000a')||
'     ||'''''',''''''||to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(prodr.id,NULL),''DD.MM.YYYY'')'||unistr('\000a')||
'     ||'''''',''''''||mnr.rezept_nr'||unistr('\000a')||
'     ||'''''',html_GetElement(''''RW'' || mnr.rezept_nr || '''''').value )''   -- neu'||unistr('\000a')||
'     --||'''''')'''||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX';

s:=s||'#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END  wk_link,'||unistr('\000a')||
'  2 sort_typ,'||unistr('\000a')||
'  null sort_art,'||unistr('\000a')||
'  mnr.rezept_nr sort_rez,'||unistr('\000a')||
'  --to_char(auftragsdispo.GET_LAST_BESTELL_DAT(mnr.id),''DD.MM.YYYY''),'||unistr('\000a')||
'  to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(prodr.id,NULL),''DD.MM.YYYY''),'||unistr('\000a')||
'  to_char(sysdate,''DD.MM.YYYY''),'||unistr('\000a')||
'  NULL ||'||unistr('\000a')||
'  CASE WHEN prodr.reichweite in (SELECT reichweite_ab from wk_reichweiten_staffeln WHERE staff';

s:=s||'elgruppe_id = :p300_staffelgruppe_id) THEN'||unistr('\000a')||
'     apex_item.select_list_from_query'||unistr('\000a')||
'       (32,'||unistr('\000a')||
'       prodr.reichweite ,'||unistr('\000a')||
'       ''SELECT  frgbg_s.WK_GET_REICHW_STAFFEL_TEXT(id,NULL,NULL,357) a, reichweite_ab b from wk_reichweiten_staffeln WHERE staffelgruppe_id =''|| :p300_staffelgruppe_id ||'||unistr('\000a')||
'       '' order by 2'' ,'||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       ''NO'','||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       ''RW''||mnr.rezept_nr'||unistr('\000a')||
'       )';

s:=s||''||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'     apex_item.select_list_from_query'||unistr('\000a')||
'          (32,'||unistr('\000a')||
'           prodr.reichweite ,'||unistr('\000a')||
'           ''SELECT frgbg_s.WK_GET_REICHW_STAFFEL_TEXT(id,NULL,NULL,357) a, reichweite_ab b from wk_reichweiten_staffeln WHERE staffelgruppe_id = ''|| :p300_staffelgruppe_id ||'||unistr('\000a')||
'           '' UNION SELECT frgbg_s.WK_GET_REICHW_STAFFEL_TEXT ( NULL,''||prodr.reichweite||'',:p300_staffelgruppe_id,357),''||prodr.reich';

s:=s||'weite ||'' from dual order by 2'','||unistr('\000a')||
'           NULL,'||unistr('\000a')||
'           ''NO'','||unistr('\000a')||
'           NULL,'||unistr('\000a')||
'           NULL,'||unistr('\000a')||
'           ''RW''||mnr.rezept_nr'||unistr('\000a')||
'         )'||unistr('\000a')||
'  END'||unistr('\000a')||
'FROM v_mn_rezepte mnr, v_prod_rezepte prodr,warenkoerbe_tmp wk'||unistr('\000a')||
'WHERE mnr.personenstamm_id = :p300_persstamm_id'||unistr('\000a')||
'  AND mnr.satz_kennzeichen is null'||unistr('\000a')||
'  AND mnr.akt_version = 1 '||unistr('\000a')||
'  /* AND neuberechnen = ''N'' AND neuberechnen_sortiment = ''N''*/'||unistr('\000a')||
'  AND mnr.aende';

s:=s||'rbar = ''J'' '||unistr('\000a')||
'  AND :fas_pers_aenderbar = 1 '||unistr('\000a')||
'  AND mnr.rezept_nr = prodr.rezept_nr'||unistr('\000a')||
'  AND mnr.version = prodr.version'||unistr('\000a')||
'  /*and prodr.sortiment_id = :fas_sortiment_id*/'||unistr('\000a')||
'  -- Suchkategorie'||unistr('\000a')||
'  AND :P300_ARTIKELKATEGORIE in (-1,0)'||unistr('\000a')||
'  -- Suchbedingung'||unistr('\000a')||
'  AND ((:P300_suche is NULL and :p300_artikelkategorie = 0 and 1=2) /* keine Ergebnisse => Maskeneinstieg */'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P300_suche is NULL and :p300_art';

s:=s||'ikelkategorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P300_suche is NOT NULL AND '||unistr('\000a')||
'        instr(UPPER (mnr.rezept_nr     '||unistr('\000a')||
'        ||''/''||mnr.version '||unistr('\000a')||
'        ||mnr.bemerkung),UPPER(:P300_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Rezepte die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p300_id'||unistr('\000a')||
'/*  '||unistr('\000a')||
'and ( prodr.id not in (SELECT p_rezept_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p300_id'||unistr('\000a')||
'          ';

s:=s||'             and p_rezept_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       '||unistr('\000a')||
'      )'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'   -- Nur Rezept ohne Splitbasiseintrag'||unistr('\000a')||
'   and mnr.rezept_nr_splitbasis is NULL and mnr.version_splitbasis is null'||unistr('\000a')||
'UNION'||unistr('\000a')||
'select m.id,                                                                        /* Laborauftrag-Artikel */'||unistr('\000a')||
'      fas_synch.get_tab_uebers';

s:=s||'etzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)'||unistr('\000a')||
'      ||CASE WHEN m.beschreibung is not null THEN'||unistr('\000a')||
'/*         ''    <a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'         ''f?p=''||:APP_ID||'':306:''||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id)    '||unistr('\000a')||
'         || ''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'         ''    <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':306:''';

s:=s||''||unistr('\000a')||
'         ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id||'''''',700,380)">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END'||unistr('\000a')||
'      || ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'             artikel,'||unistr('\000a')||
'      to_char(rezepte.calc_preis_mwst_ges(wk.verrech';

s:=s||'_land_id,'||unistr('\000a')||
'             m.prodkennz_id,m.id,wk.preisliste_id,'||unistr('\000a')||
'             wk.art_mwst_typ_id, wk.preisfaktor,wk.persstamm_id_prod_apo,0)'||unistr('\000a')||
'        ,''999G990D00'')||'' ''||rezepte.get_waehrung_zeichen(wk.waehrung_id)'||unistr('\000a')||
'             stueckpreis,'||unistr('\000a')||
'      CASE WHEN m.dokument_id is not null THEN'||unistr('\000a')||
'      ''<img src="'' || frgbg_t.get_sys_param(63) || frgbg_s.holen_uebersetzung(NVL(dokument_id, 0),:fas_sprache_id) -';

s:=s||'-#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         --|| NVL (m.dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" width="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'      ELSE NULL END img,'||unistr('\000a')||
'     CASE WHEN  :p300_wk_artikeltyp_flag = 2   -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                               -- =2 heisst bereits s';

s:=s||'onstiges im WK => keine Laborartikel mehr '||unistr('\000a')||
'     THEN'||unistr('\000a')||
'        '' '''||unistr('\000a')||
'     ELSE'||unistr('\000a')||
'--      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P300_MENGENART_ID'''':''||m.id||''}})'''||unistr('\000a')||
'--      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P300_MENGENART_ID'''':''||m.id||'', ''''P300_PERGEBNIS_ID'''':''||p.id||''}})'' -- NEI 05.05.2014'||unistr('\000a')||
'        ''<a href="javascript:apex.submit({request:''''WARENKORB';

s:=s||''''',set:{''''P300_MENGENART_ID'''':''||m.id||''}})'''||unistr('\000a')||
'          || ''">'''||unistr('\000a')||
'        || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'        || ''</a>'''||unistr('\000a')||
'     END wk_link,'||unistr('\000a')||
'     1 sort_typ, '||unistr('\000a')||
'     fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'',m.ID,:fas_sprache_id) sort_art,'||unistr('\000a')||
'     null sort_rez,'||unistr('\000a')||
'     --to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(NULL,m.id),''DD.MM.YYYY'') ,'||unistr('\000a')||
'     null,'||unistr('\000a')||
'     null,'||unistr('\000a')||
'     N';

s:=s||'ULL|| apex_item.hidden(32, NULL) '||unistr('\000a')||
'FROM mengenarts m, sortiment_details s, --NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'     warenkoerbe_tmp wk'||unistr('\000a')||
'     --, pergebnisse p                  --NEI 05.05.2014 perg_id wird zuvor bereits festgelegt wg. Laborauswahl'||unistr('\000a')||
'where m.satz_kennzeichen is null'||unistr('\000a')||
'  --and m.prodkennz_id = 2   Nur noch über Sortiment-det.verkaufsartikel'||unistr('\000a')||
'  --and :P300_SA_AUFTRAGSNUMMER is not null -';

s:=s||'-NEI 05.05.2014'||unistr('\000a')||
'  and m.id = s.mengenart_id'||unistr('\000a')||
'  and s.sortiment_id = :fas_sortiment_id --NEI 14.02.2011 Sortimentseinf.'||unistr('\000a')||
'  and s.satz_kennzeichen is null'||unistr('\000a')||
'  and s.verkaufsartikel != ''N'''||unistr('\000a')||
'  AND ((:P300_suche is NULL and :p300_artikelkategorie = 0 and 1=2) -- keine Ergebnisse => Maskeneinstieg'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P300_suche is NULL and :p300_artikelkategorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P300_suche is NOT NULL A';

s:=s||'ND '||unistr('\000a')||
'        instr(UPPER (fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id)'||unistr('\000a')||
'        ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id) ),UPPER(:P300_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Artikel die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p300_id'||unistr('\000a')||
'  /*and ( m.id is not null AND'||unistr('\000a')||
'        m.id not in (SELECT mengenar';

s:=s||'t_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p300_id'||unistr('\000a')||
'                       and mengenart_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       OR m.id is null'||unistr('\000a')||
'      )'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND :P300_ARTIKELKATEGORIE in (20,0)  -- 20 Laboranforderungen, 0 Maskeneinstieg kein Ergeb. '||unistr('\000a')||
'  AND m.artgruppe_id = 20 /*Laborartikel Artikelgruppe 20*/'||unistr('\000a')||
'  -- Keine Artikel mit Preis -1, d.h. Preis mu';

s:=s||'ss >=0  => Fehler bei der Artikeluebernahme'||unistr('\000a')||
'  AND exists'||unistr('\000a')||
'       (select * '||unistr('\000a')||
'        from preislisten_details'||unistr('\000a')||
'        where mengenart_id = s.mengenart_id'||unistr('\000a')||
'        and preisliste_id = wk.preisliste_id'||unistr('\000a')||
'        and GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND MIN_MENGE <= 1'||unistr('\000a')||
'        AND MAX_MENGE >= 1'||unistr('\000a')||
'        AND preis >= 0'||unistr('\000a')||
'       )'||unistr('\000a')||
'  /* hoechste Version ei';

s:=s||'nes FB ohne Auswertung muss vorhanden sein */'||unistr('\000a')||
'  /* NEI 5.5.2014 Perg-ID wird nun direkt in der Maske bestimmt, da noch Labor-Auswahl abhängig von perg stattfinden muss'||unistr('\000a')||
'  AND p.persstamm_id = wk.persstamm_id_kunde -- Nur FB des Kunden'||unistr('\000a')||
'  and p.id is not null'||unistr('\000a')||
'  and p.versions_id = frgbg_s.GET_FB_MAX_VERSION(p.fragebogen_id,p.persstamm_id) -- hoechste Version'||unistr('\000a')||
'  and frgbg_s.FB_CHECK_AUSWERTUNG(p.id)= 0';

s:=s||''||unistr('\000a')||
'  and p.fragebogen_id = 5              -- zZ. nur FB MNR'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND (:p300_pergebnis_id is not null and :p300_labor_mit_fb >0'||unistr('\000a')||
'       OR  -- NEI 13.10.14 Laborauftrag ohne FB-Bezug'||unistr('\000a')||
'       :p300_pergebnis_id is null and :p300_labor_mit_fb = 0'||unistr('\000a')||
'      )'||unistr('\000a')||
'  AND :p300_labor_id is not null'||unistr('\000a')||
'  AND( (:P300_AUFTRAG_ID_INTERN = 0 AND :p300_sa_auftragsnummer is not null) '||unistr('\000a')||
'       OR'||unistr('\000a')||
'       (:P300_AUFTRAG_ID_INTE';

s:=s||'RN = 1)'||unistr('\000a')||
'     )'||unistr('\000a')||
'  -- NEI 05.05.2014 Laborspezifische Profile beachten'||unistr('\000a')||
'  AND (exists (SELECT *             -- Profilartikel des aktuellen Labors'||unistr('\000a')||
'              FROM labor_mengenart_profile'||unistr('\000a')||
'              WHERE satz_kennzeichen is null'||unistr('\000a')||
'                AND mengenart_id = s.mengenart_id'||unistr('\000a')||
'                AND labor_id = :p300_labor_id'||unistr('\000a')||
'             )'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       not exists ( SELECT *        -- Artikel, ';

s:=s||'die in keinem Profil von Laboren des gleichen fkategorie_modul_id(Labor neu/alt) wie des des akt. Labors vorkommen'||unistr('\000a')||
'                  FROM labor_mengenart_profile lmp'||unistr('\000a')||
'                  WHERE lmp.satz_kennzeichen is null'||unistr('\000a')||
'                    AND lmp.mengenart_id = m.id'||unistr('\000a')||
'                    and lmp.LABOR_id in (SELECT l2.id'||unistr('\000a')||
'                                         from labors l1, labors l2'||unistr('\000a')||
'            ';

s:=s||'                             WHERE l1.id = :p300_labor_id'||unistr('\000a')||
'                                           and l1.fkategorie_modul_id = l2.fkategorie_modul_id'||unistr('\000a')||
'                                        )'||unistr('\000a')||
'                   )'||unistr('\000a')||
'        )'||unistr('\000a')||
'order by  sort_typ, sort_art asc, sort_rez desc '||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 300,
  p_name=> 'ARTIKEL_REZEPTE',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 30,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P300_HEIGHT_ARTIKEL.px;width:590px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(4526,:fas_sprache_id))',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '200',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> '</br>&P300_MELDUNG_ARTSUCHE.',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '2000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4915516970469239 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4915608020469239 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ARTIKEL',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4915722551469239 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'STUECKPREIS',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie >=0 or   /* Suchbed. od. Artikel */ '||unistr('\000a')||
':p300_artikelkategorie = 20     /* Laborartikel */',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4915829156469239 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'IMG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4915932553469240 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'WK_LINK',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4916019967469240 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_TYP',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4916130739469240 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_ART',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4916224086469240 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_REZ',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4916316734469240 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'LAST_BESTELLDATUM',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie in (0,-1)  /* Suchbed. od. Rezepte*/ ',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4916411140469240 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'AKT_DATUM',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7947014405082460 + wwv_flow_api.g_id_offset,
  p_region_id=> 2106705294981578 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_REICHWEITE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie in (0,-1)  /* Suchbed. od. Rezepte*/ ',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_inline_lov=> 'SELECT 60 a, 60 b from dual UNION'||unistr('\000a')||
'SELECT 90  , 90   from dual UNION'||unistr('\000a')||
'SELECT 120 , 120  from dual '||unistr('\000a')||
'order by 1',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2155203009974810 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 300,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 4,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p300_zurueck_seite = 130',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2261314790172935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 300,
  p_plug_name=> '&P300_REGION_TITEL_WARENKORB.: &P300_NAME.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 5572010060380233+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 40,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 3,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="width: 500px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2888618264489697 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 300,
  p_plug_name=> 'Adresse',
  p_region_name=>'',
  p_parent_plug_id=>2261314790172935 + wwv_flow_api.g_id_offset,
  p_escape_on_http_output=>'N',
  p_plug_template=> 0,
  p_plug_display_sequence=> 60,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p300_flag_hide_show = 1',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'wkd."ID",'||unistr('\000a')||
'wkd."ID" ID_DISPLAY,'||unistr('\000a')||
'wkd."WARENKORB_TMP_ID",'||unistr('\000a')||
'wkd."PRODKENNZ_ID",'||unistr('\000a')||
'wkd."P_REZEPT_ID" ,'||unistr('\000a')||
'wkd."MENGENART_ID",'||unistr('\000a')||
'wkd."MENGE",'||unistr('\000a')||
'wkd."BEMERKUNG",'||unistr('\000a')||
'/*wkd."VOLUMEN",'||unistr('\000a')||
'wkd."GEWICHT",'||unistr('\000a')||
'wkd."PREIS",'||unistr('\000a')||
'wkd."MWST_BETRAG",'||unistr('\000a')||
'wkd."MWST_SATZ",'||unistr('\000a')||
'wkd."WK_STATUS_ID",'||unistr('\000a')||
'wkd."STATUS_AENDERDATUM",'||unistr('\000a')||
'wkd."STATUS_AENDERVISUM",'||unistr('\000a')||
'wkd."ETIKETTENTYP",'||unistr('\000a')||
'wkd."ERFDAT",'||unistr('\000a')||
'wkd."ERFUSER",'||unistr('\000a')||
'wkd."MUTDAT",'||unistr('\000a')||
'wkd."MUTUSER",'||unistr('\000a')||
'*/'||unistr('\000a')||
'  --pr.rezept_';

s:=s||'nr||DECODE(pr.version,NULL,NULL,''/''||pr.version) rezept_nr,  -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'  CASE WHEN mnr.rezept_nr_splitbasis is NULL AND mnr.version_splitbasis is NULL THEN'||unistr('\000a')||
'       pr.rezept_nr||DECODE(pr.version,NULL,NULL,''/''||pr.version)'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'       mnr.rezept_nr_splitbasis||DECODE(mnr.version_splitbasis,NULL,NULL,''/''||mnr.version_splitbasis)'||unistr('\000a')||
'  END rezept_nr,   '||unistr('\000a')||
'  CAS';

s:=s||'E WHEN wkd.PRODKENNZ_ID = 1 THEN -- HCK-Mischung'||unistr('\000a')||
'      frgbg_s.get_pers_name_rezept(p_rezept_id) ||''</br>''||'||unistr('\000a')||
'      frgbg_s.holen_uebersetzung(585,:fas_sprache_id)||'': ''||wkd.reichweite||'||unistr('\000a')||
'      DECODE (rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version),0,'''','||unistr('\000a')||
'         ''</br>''||fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version)'||unistr('\000a')||
'      ,:fas_spra';

s:=s||'che_id))'||unistr('\000a')||
'  ELSE '||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)|| ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'  END kuerzel,'||unistr('\000a')||
'  TRUNC(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2) einzelpreis_brutto,'||unistr('\000a')||
' (trunc(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2))*NVL(wkd.MENGE,0)'||unistr('\000a')||
'        ';

s:=s||'       gesamtpreis_brutto,'||unistr('\000a')||
'  DECODE ((select count(*) from  WKORB_DET_VERORDNUNGEN_TMP wkdv '||unistr('\000a')||
'           where WARENKORB_DETAIL_TMP_ID=wkd.id'||unistr('\000a')||
'           ),0,'''',''<span style="background-color:green;">'')'||unistr('\000a')||
'||''<a href="'''||unistr('\000a')||
'||apex_util.prepare_url(''f?p=&APP_ID.:303:&SESSION.::&DEBUG.::'''||unistr('\000a')||
'||''P303_WARENKORB_DETAIL_TMP_ID:'''||unistr('\000a')||
'||to_char(wkd.id))'||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#edit_big.gif">'''||unistr('\000a')||
'|| ''</a>''  veror';

s:=s||'d_link'||unistr('\000a')||
'/*wkd.id delete_link'||unistr('\000a')||
'''<a href="'''||unistr('\000a')||
'||''javascript:apex.submit({request:''''MULTI_ROW_DELETE'''',set:{''''P300_WK_DET_ID'''':''''#ROWNUM#''''}})'''||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#del.gif">'''||unistr('\000a')||
'|| ''</a>'' delete_link'||unistr('\000a')||
'*/'||unistr('\000a')||
',''<img src="#IMAGE_PREFIX#del.gif">'' del_icon'||unistr('\000a')||
',wkd.reichweite reichweite'||unistr('\000a')||
',mnr.rezept_nr_splitbasis,mnr.version_splitbasis'||unistr('\000a')||
'from WARENKORB_DETAILS_TMP wkd , prod_rezepte pr, mengenarts m,'||unistr('\000a')||
'     ';

s:=s||'mn_rezepte mnr  -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'where warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'  and p_rezept_id = pr.id (+)'||unistr('\000a')||
'  and mengenart_id = m.id (+)'||unistr('\000a')||
'  and (wkd.mengenart_id is NULL or wkd.mengenart_id != 101)'||unistr('\000a')||
'  AND pr.rezept_nr = mnr.rezept_nr(+) -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'  AND pr.version  = mnr.version (+)   -- NEI 10.01.2014 Kumulation Splits ';

s:=s||'zu Gesamtrezept'||unistr('\000a')||
'order by wkd.id';

wwv_flow_api.create_report_region (
  p_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 300,
  p_name=> '&P300_REGION_TITEL_WARENKORB.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 40,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 3,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P300_HEIGHT_WARENKORB.px; width: 500px">',
  p_footer=> '</div>'||unistr('\000a')||
'<script type="text/javascript">'||unistr('\000a')||
'var rowsFetched = #ROWS_FETCHED#;'||unistr('\000a')||
'if (rowsFetched == 0) {'||unistr('\000a')||
'  $x_Hide($x(''CHECK$01'').parentNode);'||unistr('\000a')||
'}'||unistr('\000a')||
'</script>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3081,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '50',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> '&P300_MELDUNG_WK.',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2993504043202462 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2299603529733590 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2299715272733590 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID_DISPLAY',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID_DISPLAY',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2299806284733590 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_TMP_ID',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WARENKORB_TMP_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2299922442733590 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PRODKENNZ_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2300008673733590 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'P_REZEPT_ID',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'P_REZEPT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2300106965733590 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2300217975733590 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'SELECT_LIST',
  p_inline_lov=> '1,2,3,4,5,6,7,8,9,10',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '5',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18627915831416255 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2305900202736600 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2306010113736600 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2306110857736600 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'EINZELPREIS_BRUTTO',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2306212196736600 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'GESAMTPREIS_BRUTTO',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2493230792944620 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'VERORD_LINK',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3082006534595475 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'DEL_ICON',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4246416743986215 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'REICHWEITE',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18635922326930982 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR_SPLITBASIS',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18636021669930982 + wwv_flow_api.g_id_offset,
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'VERSION_SPLITBASIS',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2476930558092951 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 300,
  p_plug_name=> 'Navi wk',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(2476427657082606 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p300_zurueck_seite = 110',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'',            -- Artikel'||unistr('\000a')||
'                                       ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'       kuerzel,id,sort,'||unistr('\000a')||
'       CASE WHEN dokument_id is not null THEN'||unistr('\000a')||
'         ''<img src="'' || frgbg_t.get_sys_param(63) || frgbg_s.holen_uebersetzung(NVL(dokument_id, 0),:fas_sprache_id) --#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         -';

s:=s||'-|| NVL (dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'        -- || ''" height="'''||unistr('\000a')||
'        -- || 90'||unistr('\000a')||
'        -- || ''" width="'''||unistr('\000a')||
'        -- || 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'       ELSE NULL END img'||unistr('\000a')||
'FROM artgruppen '||unistr('\000a')||
'WHERE :p300_wk_artikeltyp_flag in (2)          -- NEI 22.05.13 Keine Mischaufträge mit Laborartikel '||unistr('\000a')||
'                                                 -- (1=nur Labor,2=nur sonstige */'||unistr('\000a')||
'  and id';

s:=s||' in ('||unistr('\000a')||
'             SELECT distinct g.id'||unistr('\000a')||
'             FROM artgruppen g, mengenarts m, sortiment_details sd'||unistr('\000a')||
'             WHERE g.id = m.artgruppe_id'||unistr('\000a')||
'               AND m.satz_kennzeichen is null'||unistr('\000a')||
'               AND m.id = sd.mengenart_id'||unistr('\000a')||
'               AND sd.sortiment_id in ( :fas_sortiment_id)'||unistr('\000a')||
'               AND sd.satz_kennzeichen is null'||unistr('\000a')||
'               AND sd.verkaufsartikel != ''N'''||unistr('\000a')||
'             ';

s:=s||'  AND g.id != 20 /* nicht Laborauftragsartikel */'||unistr('\000a')||
'               AND (g.id = 76 AND  :P300_std_mischartikel>0  /* Std.Michartikel nur mit Rollenfreigabe*/'||unistr('\000a')||
'                    OR'||unistr('\000a')||
'                    g.id != 76'||unistr('\000a')||
'                   )'||unistr('\000a')||
'            )'||unistr('\000a')||
'/*UNION             NEI 10.9.12 Alle Anzeige darf nicht mehr gewählt werden'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(511,:fas_sprache_id),'||unistr('\000a')||
'       frgbg_s.holen_ueb';

s:=s||'ersetzung(511,:fas_sprache_id),0,0,'||unistr('\000a')||
'       NULL'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'*/'||unistr('\000a')||
'UNION  -- Rezepte'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4859,:fas_sprache_id),'||unistr('\000a')||
'       frgbg_s.holen_uebersetzung(4859,:fas_sprache_id),-1,0.2,'||unistr('\000a')||
'       ''<img src="'' || frgbg_t.get_sys_param(63) || frgbg_s.holen_uebersetzung(10660,:fas_sprache_id)  --#OWNER#.frgbg_t.display_thumb?p_bild_id=10660&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'        -- || ''" ';

s:=s||'height="'''||unistr('\000a')||
'        -- || 90'||unistr('\000a')||
'        -- || ''" width="'''||unistr('\000a')||
'        -- || 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'WHERE :p300_wk_artikeltyp_flag in (2)          -- NEI 22.05.13 Keine Mischaufträge mit Laborartikel '||unistr('\000a')||
'                                               -- (1=nur Labor,2=nur sonstige */'||unistr('\000a')||
'UNION  -- Laborauftrag'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'','||unistr('\000a')||
'                                ';

s:=s||'       ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'       kuerzel,id,0.1,'||unistr('\000a')||
'       CASE WHEN dokument_id is not null THEN'||unistr('\000a')||
'         ''<img src="'' || frgbg_t.get_sys_param(63) || frgbg_s.holen_uebersetzung(NVL(dokument_id, 0),:fas_sprache_id)  --#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         --|| NVL (dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'        -- || ''" height="'''||unistr('\000a')||
'        -- || 90'||unistr('\000a')||
'        -- || ';

s:=s||'''" width="'''||unistr('\000a')||
'        -- || 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'       ELSE NULL END img'||unistr('\000a')||
'FROM artgruppen '||unistr('\000a')||
'WHERE :p300_wk_artikeltyp_flag in (1)    -- NEI 22.05.13 Keine Mischaufträge mit Laborartikel '||unistr('\000a')||
'                                         -- (1=nur Labor,2=nur sonstige */'||unistr('\000a')||
'  and id in ('||unistr('\000a')||
'             SELECT distinct g.id'||unistr('\000a')||
'             FROM artgruppen g, mengenarts m, sortiment_details sd'||unistr('\000a')||
'             WHERE g.id =';

s:=s||' m.artgruppe_id'||unistr('\000a')||
'               AND m.satz_kennzeichen is null'||unistr('\000a')||
'               AND m.id = sd.mengenart_id'||unistr('\000a')||
'               AND sd.sortiment_id in ( :fas_sortiment_id)'||unistr('\000a')||
'               AND sd.satz_kennzeichen is null'||unistr('\000a')||
'               AND sd.verkaufsartikel != ''N'''||unistr('\000a')||
'               AND g.id = 20 /* nur Laborauftragsartikel */'||unistr('\000a')||
'            )'||unistr('\000a')||
'   /*and -- NEI 14.10.14 Labor ohne FB; Kategorie Labor immer anzeigen ';

s:=s||'bei Labor-WK'||unistr('\000a')||
'        (select count(*)       -- nicht ausgewertete FB zu der Person vorhanden?'||unistr('\000a')||
'         from v_fb_fas'||unistr('\000a')||
'         where personenstamm_id = :P300_PERSSTAMM_ID'||unistr('\000a')||
'           and pergebnis_id is not null'||unistr('\000a')||
'           and perg_akt_version = 1'||unistr('\000a')||
'           and frgbg_s.FB_CHECK_AUSWERTUNG(pergebnis_id)= 0'||unistr('\000a')||
'           --and fragebogen_id = 5'||unistr('\000a')||
'           and fragebogen_id = :p300_labor_mit_fb'||unistr('\000a')||
'         ';

s:=s||' ) > 0'||unistr('\000a')||
'   */'||unistr('\000a')||
'   --AND :p300_extern_verwaltet = 1 /*GUS verwaltete Auftraege */'||unistr('\000a')||
'order by 4'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 2547827419782902 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 300,
  p_name=> 'KATEGORIE',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 20,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto;height: &P300_HEIGHT_KATEGORIE.px;width: 220px ">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3666,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '100',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '1000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2548113787782902 + wwv_flow_api.g_id_offset,
  p_region_id=> 2547827419782902 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_link=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.::P300_ARTIKELKATEGORIE,P300_ARTIKELKATEGORIE_BEZ,P300_SUCHE:#ID#,#BEZEICHNUNG#,',
  p_column_linktext=>'#BEZEICHNUNG#',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2548232546782902 + wwv_flow_api.g_id_offset,
  p_region_id=> 2547827419782902 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2548331370782904 + wwv_flow_api.g_id_offset,
  p_region_id=> 2547827419782902 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2550708822277426 + wwv_flow_api.g_id_offset,
  p_region_id=> 2547827419782902 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'SORT',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7658725603355335 + wwv_flow_api.g_id_offset,
  p_region_id=> 2547827419782902 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'IMG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2727714777743396 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 300,
  p_plug_name=> '&P300_REGION_TITEL_ARTIKEL.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 5572010060380233+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_header=> '<div style="min-width: 790px;text-align:left">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 2887331808446305 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 300,
  p_button_sequence=> 10,
  p_button_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_HIDE',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P300_BL_BUT_HIDE.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:300:&SESSION.:HIDE_SHOW:&DEBUG.::P300_FLAG_HIDE_SHOW:-1',
  p_button_condition=> ':P300_FLAG_HIDE_SHOW = 1',
  p_button_condition_type=> 'NEVER',
  p_button_image_attributes=>'onmouseover="toolTip_enable(event,this,this.alt)"  popupfieldhelp ',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2887810599459149 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 300,
  p_button_sequence=> 15,
  p_button_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_show',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P300_BL_BUT_SHOW.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:300:&SESSION.:HIDE_SHOW:&DEBUG.::P300_FLAG_HIDE_SHOW:1',
  p_button_condition=> ':P300_FLAG_HIDE_SHOW = -1',
  p_button_condition_type=> 'NEVER',
  p_button_image_attributes=>'onmouseover="toolTip_enable(event,this,this.alt)"  popupfieldhelp ',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2301902298733595 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 300,
  p_button_sequence=> 20,
  p_button_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_button_name    => 'MULTI_ROW_DELETE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P300_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT * '||unistr('\000a')||
'FROM warenkorb_details_tmp '||unistr('\000a')||
'where warenkorb_tmp_id=:P300_WARENKORB_TMP_ID',
  p_button_condition_type=> 'EXISTS',
  p_button_image_attributes=>'onmouseover="toolTip_enable(event,this,this.alt)"  popupfieldhelp ',
  p_database_action=>'DELETE',
  p_button_comment=>'width="14" height="16"',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8591230192763906 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 300,
  p_button_sequence=> 30,
  p_button_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_PATIENT_AENDERN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P300_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> '/* Nur falls noch keine WK-Pos wg. Gewicht/Größe bei individualsierbaren Artikeln'||unistr('\000a')||
'*/'||unistr('\000a')||
'SELECT * '||unistr('\000a')||
'FROM warenkorb_details_tmp '||unistr('\000a')||
'where warenkorb_tmp_id=:P300_WARENKORB_TMP_ID',
  p_button_condition_type=> 'NOT_EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2135923640162310 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 300,
  p_button_sequence=> 40,
  p_button_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_button_name    => 'KASSE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P300_BL_ZUR_KASSE.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT * '||unistr('\000a')||
'FROM warenkorb_details_tmp '||unistr('\000a')||
'where warenkorb_tmp_id=:P300_WARENKORB_TMP_ID',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2155730714982825 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 300,
  p_button_sequence=> 40,
  p_button_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P300_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2572506416128257 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 300,
  p_button_sequence=> 50,
  p_button_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P300_BL_SUCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2301815859733595 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 300,
  p_button_sequence=> 30,
  p_button_plug_id => 2299322867733587+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P300_BL_SPEICHERN.',
  p_button_position=> 'TEMPLATE_DEFAULT',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT * FROM warenkorb_details_tmp where warenkorb_tmp_id=:P300_WARENKORB_TMP_ID;',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>2157823844084904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P300_ZURUECK_SEITE.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2155730714982825+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>8535906460097823 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:308:&SESSION.::&DEBUG.:308:P308_WARENKORB_TMP_ID,P308_ZURUECK_SEITE,P308_ZURUECK_SEITE_NACH_BEST:&P300_WARENKORB_TMP_ID.,&APP_PAGE_ID.,&P300_ZURUECK_SEITE.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2135923640162310+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 12,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-DEC-2012 10:51 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>6620502072625773 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:304:P304_ID,P304_ZURUECK_SEITE:&P300_PERSSTAMM_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8591230192763906+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 15,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4040905680567522 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:302:P302_ID,P302_ADRESSTYP,P302_ZURUECK_SEITE,P302_CALLING_PAGE:&P300_PERSSTAMM_ID_LIEFERUNG.,L,300,300',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4040213589465661+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 16,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4047730156716442 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:302:P302_ID,P302_ADRESSTYP,P302_ZURUECK_SEITE,P302_CALLING_PAGE:&P300_PERSSTAMM_ID_RECHNUNG.,L,300,300',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4047406607709700+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 17,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>2367018754655151 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301:P301_PERSSTAMM_ID_BETREUER,P301_persstamm_id_patient,p301_adresstyp,p301_zurueck_seite,P301_PERSSTAMM_ID_STDADRESSE:&P300_PERSSTAMM_ID_LOGIN.,&P300_PERSSTAMM_ID.,L,&APP_PAGE_ID.,&P300_PERSSTAMM_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2358920158456845+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>2367120962665176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301:P301_PERSSTAMM_ID_BETREUER,P301_persstamm_id_patient,p301_adresstyp,p301_zurueck_seite,P301_PERSSTAMM_ID_STDADRESSE:&P300_PERSSTAMM_ID_LOGIN.,&P300_PERSSTAMM_ID.,R,&APP_PAGE_ID.,&P300_PERSSTAMM_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2362013803521176+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>2517606722817134 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.::P140_PERSONENSTAMM_ID:&P300_PERSSTAMM_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2135700437155600+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 40,
  p_branch_condition_type=> 'NEVER',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 14-MAI-2009 22:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>4529109925739313 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.:FEHLERAUSGABE:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 50,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request =''WARENKORB''',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 13-MAR-2012 10:44 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4531200761200265 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.::&DEBUG.::P300_PERSSTAMM_ID_EXTERN_UPD,P300_ADRESSTYP_EXTERN:&P300_PERSSTAMM_ID_RECHSTELLER.,RS&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 60,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request = ''P300_PERSSTAMM_ID_RECHSTELLER''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-MAR-2012 12:01 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4192204855443029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.::&DEBUG.::P300_PERSSTAMM_ID_EXTERN_UPD,P300_ADRESSTYP_EXTERN:&P300_PERSSTAMM_ID_RECHSTELLER.,L&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 80,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request = ''P300_WK_VERSANDART_ID'' and :p300_wk_versandart_id = 3',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-MAR-2012 12:01 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>2138629457231645 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2108324490148045 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_MENGENART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'S',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2125503133900917 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_WARENKORB_TMP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb-ID',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2133428048106817 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_GESAMTWERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtwert',
  p_format_mask=>'999G999G999G999G990D00',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2134017575122706 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_GESAMT_MWST_BETRAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'enthaltene Mwst',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'to_char(trunc(NVL(to_number(:p300_mwst_betrag_1,''999G999G999G999G990D00''),0) + NVL(to_number(:p300_mwst_betrag_2,''999G999G999G999G990D00''),0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2134718399132434 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_WAEHRUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'rezepte.get_waehrung_zeichen(:p300_waehrung_id) /*||'' ''||:P300_INKL_MWST_LABEL*/;',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2135700437155600 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_INDIVIDUELLES_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 3,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'Rezept',
  p_prompt=>'&P300_BL_INDIV_REZEPT.',
  p_source=>'Rezept',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2151607577805854 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2211720252693314 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_ETIKETTENTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ettikettentyp',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,1);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2262102314172939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 21,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2262326610172940 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 23,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Plandatum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2262520671172940 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land Id',
  p_source=>'VERRECH_LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2262921915172942 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 22,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Waehrung Id',
  p_source=>'WAEHRUNG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2263315721172942 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtpreis',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'GESAMTPREIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2263508990172942 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_MWST_JN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Jn',
  p_source=>'MWST_JN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2263711680172942 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_MWST_BETRAG_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 1',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'MWST_BETRAG_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2263904217172943 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_MWST_BETRAG_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 2',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'MWST_BETRAG_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2264107477172943 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_MWST_SATZ_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 1',
  p_source=>'MWST_SATZ_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2264309071172943 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_MWST_SATZ_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 2',
  p_source=>'MWST_SATZ_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2264508909172943 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_WK_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wk Status Id',
  p_source=>'WK_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2264925517172945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_STATUS_AENDERDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aenderdatum',
  p_source=>'STATUS_AENDERDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2265327694172945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_STATUS_AENDERVISUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aendervisum',
  p_source=>'STATUS_AENDERVISUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2265731920172945 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2266117971172946 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Login',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2266516419172946 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2266915613172946 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bemerkung',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2326808865918787 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_LIEFERADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 6,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEGIN'||unistr('\000a')||
'   IF :p300_persstamm_id_lieferung = :p300_persstamm_id THEN'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9067,:fas_sprache_id)||'' ''||frgbg_s.holen_uebersetzung(5521,:fas_sprache_id);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.get_pers_adresse(:p300_persstamm_id_lieferung);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2327023063922879 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_RECHNUNGSADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEGIN'||unistr('\000a')||
'   IF :p300_persstamm_id_rechnung = :p300_persstamm_id THEN    -- siehe Kundenadresse'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9067,:fas_sprache_id)||'' ''||frgbg_s.holen_uebersetzung(5521,:fas_sprache_id);'||unistr('\000a')||
'   ELSIF :p300_persstamm_id_rechnung = :p300_persstamm_id_lieferung THEN --siehe Lieferadresse'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9067,:fas_sprache_id)||'' ''||frgbg_s.holen_uebersetzung(3114,:fas_sprache_id);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.get_pers_adresse(:p300_persstamm_id_rechnung);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2358920158456845 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_LIEFERADRESSE_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 7,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'LIEFERADRESSE',
  p_prompt=>'&P300_BL_AUSWAHL.',
  p_source=>'LIEFERADRESSE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2362013803521176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_RECHADR_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 11,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'RECHADRESSE',
  p_prompt=>'&P300_BL_AUSWAHL.',
  p_source=>'RECHADRESSE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2450116718251832 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PERSSTAMM_ID_EXTERN_UPD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'ext Persstamm Id Upd',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2450331740265618 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_ADRESSTYP_EXTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ext Adresstyp',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2525321811609415 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PATIENT_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'PATIENT',
  p_prompt=>'&P300_BL_AENDERN.',
  p_source=>'PATIENT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2547417676751749 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_ARTIKELKATEGORIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 4,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''ARTGRUPPEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung,id'||unistr('\000a')||
'FROM artgruppen '||unistr('\000a')||
'WHERE id in ('||unistr('\000a')||
'             SELECT distinct g.id'||unistr('\000a')||
'             FROM artgruppen g, mengenarts m, sortiment_details sd'||unistr('\000a')||
'             WHERE g.id = m.artgruppe_id'||unistr('\000a')||
'               AND m.satz_kennzeichen is null'||unistr('\000a')||
'               AND m.id = sd.mengenart_id'||unistr('\000a')||
'               AND sd.sortiment_id = :fas_sortiment_id'||unistr('\000a')||
'               AND sd.satz_kennzeichen is null'||unistr('\000a')||
'            )'||unistr('\000a')||
'/*UNION SELECT frgbg_s.holen_uebersetzung(511,:fas_sprache_id), 0 FROM DUAL*/'||unistr('\000a')||
'UNION SELECT '''', 0 FROM DUAL'||unistr('\000a')||
'UNION SELECT frgbg_s.holen_uebersetzung(4859,:fas_sprache_id),-1 FROM DUAL /*Mischungen*/'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2554908438674681 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2555122290678726 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_ZUR_KASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2555331987681500 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 270,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2555506491683550 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_AUSWAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2555713071685456 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2555921036687797 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 300,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2556108007693520 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_INDIV_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2556320474697089 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_REGION_TITEL_ARTIKEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2556528440699370 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_REGION_TITEL_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2556703983701777 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_REGION_TITEL_ADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2557322945726210 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2557510263732022 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PERSSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 360,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2558011349760653 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_REGION_TITEL_KATEGORIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 315,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2561630405841895 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_HEIGHT_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 370,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2564726567963787 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_SUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2565105012976513 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_HEIGHT_ARTIKEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2572830657135236 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 255,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2574921493596208 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_REZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 245,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'rezept',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2592015672989957 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_WAHL_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 220,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wahl Identitaet',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2644007001251520 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 15,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onChange="javascript:doSubmit(''CHANGE'') "',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2726809657647257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_HEIGHT_KATEGORIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 390,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2812119634520726 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_WK_DET_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 400,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2888025836463484 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_FLAG_HIDE_SHOW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 410,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '-1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3009209191525711 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_ARTIKELKATEGORIE_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4040213589465661 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_LIEFERADRESSE_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 8,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P300_BL_AENDERN.',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p300_persstamm_id != :p300_persstamm_id_lieferung',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4047406607709700 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_RECHADRESSE_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P300_BL_AENDERN.',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P300_persstamm_id != :p300_persstamm_id_rechnung and'||unistr('\000a')||
':p300_persstamm_id_lieferung != :p300_persstamm_id_rechnung ',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4063625135765469 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PATIENTADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_adresse(:p300_persstamm_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4064704722910926 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_INKL_MWST_LABEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4134326853892368 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_BUT_HIDE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 312,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4134616249898747 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_BL_BUT_SHOW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 313,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4191930060194876 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_WK_VERSANDART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 18,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4277614400006659 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_GROESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 470,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4277824790009602 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_GEWICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 480,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4453622024638206 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_KASSENABRECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 540,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'KASSENABRECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(10392,:fas_sprache_id) a, 1 FROM DUAL'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(10391,:fas_sprache_id) a, 0 FROM DUAL'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'SELECT *'||unistr('\000a')||
'from warenkorb_details_tmp wkd, mengenarts m'||unistr('\000a')||
'where wkd.warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'  and wkd.mengenart_id = m.id'||unistr('\000a')||
'  and m.artgruppe_id= 20;',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4520608047059639 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PERSSTAMM_ID_RECHSTELLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 14,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PERSSTAMM_ID_RECHNUNGSSTELLER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.get_pers_adresse(:p300_persstamm_id_prod_apo) a,:p300_persstamm_id_prod_apo b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'select frgbg_s.get_pers_adresse(:fas_identitaet_persstamm_id) a,:fas_identitaet_persstamm_id b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4528118358675486 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_IN_WK_FEHLERTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 430,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4802923159643116 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PERSSTAMM_PROD_APO_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 17,
  p_item_plug_id => 2888618264489697+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'P300_PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT substr(frgbg_s.get_pers_adresse(p.id),1,80) a,'||unistr('\000a')||
'       p.id b'||unistr('\000a')||
'FROM pers_identitaet_props i,    /* spez. Eigenschaften der Identitaeten */'||unistr('\000a')||
'     personenstamm p'||unistr('\000a')||
'where i.typ = ''PA'' /* Produzierende Apotheke */'||unistr('\000a')||
'  and p.id = i.persstamm_id'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4908004887068440 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4919322330600918 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_WK_ARTIKELTYP_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => 'Warenkorb für Labor oder normale Artikel/Mischungen'||unistr('\000a')||
'1=nur Laboruntersuchungen,2=nur sonstige');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4970419412356275 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_PERGEBNIS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 17,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4988908706212970 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_AERZTLICH_VERORDNET',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ärztlich verordnet',
  p_source=>'AERZTLICH_VERORDNET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(77,:fas_sprache_id) a, 0 FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(76,:fas_sprache_id) a, 1 FROM DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'SELECT *'||unistr('\000a')||
'from warenkorb_details_tmp wkd, mengenarts m'||unistr('\000a')||
'where wkd.warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'  and wkd.mengenart_id = m.id'||unistr('\000a')||
'  and m.artgruppe_id= 20;',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5054903707909894 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_SA_AUFTRAGSNUMMER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 27,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'SA-Auftragsnr',
  p_format_mask=>'99999999',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onblur="javascript:doSubmit ()"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'DECLARE'||unistr('\000a')||
'   v_anz_wk    number;'||unistr('\000a')||
'   v_anz_fb    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p300_wk_artikeltyp_flag = 1 THEN  -- Labor'||unistr('\000a')||
'      IF :P300_LABOR_MIT_FB is not null THEN -- NEI 13.10.14 Labor ohne FB-Bezug eingeführt'||unistr('\000a')||
'         IF :p300_labor_id is null THEN'||unistr('\000a')||
'            :p300_labor_auftrags_id := null; -- zur Sicherheit löschen'||unistr('\000a')||
'            RETURN false;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            IF :P300_AUFTRAG_ID_INTERN = 0 THEN'||unistr('\000a')||
'               RETURN true;'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               RETURN false;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSE -- noch keine Wahl bei FB'||unistr('\000a')||
'         RETURN false;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE '||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
' '||unistr('\000a')||
'   /* Eigener Aufruf des WK-Labors => auftragsnummer ist pflicht'||unistr('\000a')||
'   SELECT count(*) into v_anz_fb'||unistr('\000a')||
'   FROM  warenkoerbe_tmp wk, pergebnisse p'||unistr('\000a')||
'   where wk.id = :p300_id   -- WK'||unistr('\000a')||
'     -- hoechste Version eines FB ohne Auswertung muss vorhanden sein '||unistr('\000a')||
'     AND p.persstamm_id = wk.persstamm_id_kunde -- Nur FB des Kunden'||unistr('\000a')||
'     and p.id is not null'||unistr('\000a')||
'     and p.versions_id = frgbg_s.GET_FB_MAX_VERSION(p.fragebogen_id,p.persstamm_id) -- hoechste Version'||unistr('\000a')||
'     and frgbg_s.FB_CHECK_AUSWERTUNG(p.id)= 0'||unistr('\000a')||
'     and p.fragebogen_id = 5             -- zZ. nur FB MNR'||unistr('\000a')||
'   ;'||unistr('\000a')||
'   -- WK mit Einträge ohne Laboranalyse'||unistr('\000a')||
'   SELECT count(*) into v_anz_wk'||unistr('\000a')||
'   FROM warenkorb_details_tmp wkd,mengenarts m'||unistr('\000a')||
'   where wkd.warenkorb_tmp_id = :p300_id   -- WK'||unistr('\000a')||
'     and wkd.mengenart_id = m.id (+)'||unistr('\000a')||
'     and (m.artgruppe_id != 20'||unistr('\000a')||
'        OR'||unistr('\000a')||
'         m.id is null   '||unistr('\000a')||
'        )'||unistr('\000a')||
'   ;'||unistr('\000a')||
'   IF v_anz_wk > 0  OR v_anz_fb = 0 THEN'||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   ELSE '||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'END;',
  p_display_when_type=>'FUNCTION_BODY',
  p_read_only_when=>'SELECT *'||unistr('\000a')||
'from warenkorb_details_tmp wkd'||unistr('\000a')||
'where wkd.warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'  ;',
  p_read_only_when_type=>'EXISTS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5622205050890385 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_MELDUNG_ARTSUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 440,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6151103242878320 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_LABOR_MIT_FB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Fragebogen',
  p_source=>'LABOR_MIT_FB',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.HOLEN_UEBERSETZUNG(fb_kurzname_text_id,:fas_sprache_id) fb_kurzname , fragebogen_id '||unistr('\000a')||
'FROM v_fb_fas  --,uebersetzungen u -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'WHERE personenstamm_id = 47037 --:p300_personenstamm_id'||unistr('\000a')||
'  AND perg_akt_version >= 1 -- nur aktuelle Version von perg'||unistr('\000a')||
'  and ((:fas_aufgerufen_von = ''BETREUER'' and'||unistr('\000a')||
'         (fbk_klasse_id = 1 or fbk_klasse_id is null) AND  -- alle FB´s'||unistr('\000a')||
'          fb_typ_id in'||unistr('\000a')||
'           (SELECT b.fb_typ_id'||unistr('\000a')||
'            FROM fbtyp_betreuer b'||unistr('\000a')||
'            where b.persstamm_id_betreuer in ('||unistr('\000a')||
'               -- Definitionen der Identitaeten-Hierarchie'||unistr('\000a')||
'               select persstamm_id_identitaet'||unistr('\000a')||
'               from pers_identitaeten'||unistr('\000a')||
'               start with persstamm_id_identitaet = :fas_identitaet_persstamm_id'||unistr('\000a')||
'               connect by prior persstamm_id_oberidentitaet ='||unistr('\000a')||
'                                persstamm_id_identitaet'||unistr('\000a')||
'               UNION -- auch Definitionen vom Betreuer relevant'||unistr('\000a')||
'               SELECT to_number(:fas_login_personenstamm_id) from dual'||unistr('\000a')||
'               )'||unistr('\000a')||
'           )'||unistr('\000a')||
'         )'||unistr('\000a')||
'        OR'||unistr('\000a')||
'        (:fas_aufgerufen_von != ''BETREUER''and'||unistr('\000a')||
'            (fbk_klasse_id = 1 or fbk_klasse_id is null) -- alle FB´s'||unistr('\000a')||
'        )'||unistr('\000a')||
'      )'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT  ''Ohne Fragebogen'' ,0'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'order by 1  asc ',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>':p300_wk_artikeltyp_flag = 1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when=>':p300_labor_mit_fb is not null',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6273314474906021 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_NV_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6604731338559254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_VERSANDKOSTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 2261314790172935+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'SELECT to_char(NVL(sum(preis+mwst_betrag),0),''999G999G999G999G990D00'')'||unistr('\000a')||
'from warenkorb_details_tmp'||unistr('\000a')||
'where warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'  and mengenart_id = 101;',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7825323907888199 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 6,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'SUCHEN',
  p_source=>'SUCHEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7843419078700897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_MELDUNG_WK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 450,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7958221779917234 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_REZEPT_REICHWEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 247,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8327526699981458 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_LABOR_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 25,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Labor',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT bezeichnung a, id b'||unistr('\000a')||
'from labors'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'  AND '||unistr('\000a')||
'  ('||unistr('\000a')||
'  FKATEGORIE_MODUL_ID in (SELECT fkat_modul_id '||unistr('\000a')||
'                              from PERGEBNIS_MODUL_AUSWAHL '||unistr('\000a')||
'                              where pergebnis_id = :p300_pergebnis_id'||unistr('\000a')||
'                                and satz_kennzeichen is null'||unistr('\000a')||
'                             )'||unistr('\000a')||
'  AND :p300_labor_mit_fb > 0'||unistr('\000a')||
'  OR '||unistr('\000a')||
'  -- NEI 13.10.14 Laboraufträge ohne FB-Bezug'||unistr('\000a')||
'  -- Nur Labor mit auf der Basis der neue Labortabs möglich, da die Normierungen geliefert werden müssen'||unistr('\000a')||
'  :p300_labor_mit_fb = 0 and FKATEGORIE_MODUL_ID=4  '||unistr('\000a')||
'  )',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>':p300_wk_artikeltyp_flag = 1 and '||unistr('\000a')||
'-- NEI 13.10.14 Laborauftrag ohne FB-Bezug eingeführt'||unistr('\000a')||
':P300_LABOR_MIT_FB is not null'||unistr('\000a')||
'',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when=>'SELECT *'||unistr('\000a')||
'from warenkorb_details_tmp wkd'||unistr('\000a')||
'where wkd.warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'  ;',
  p_read_only_when_type=>'EXISTS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8329730639342131 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_AUFTRAG_ID_INTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 26,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8618430232467877 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_STD_MISCHARTIKEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 2106705294981578+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8854020101330846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 300,
  p_name=>'P300_STAFFELGRUPPE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 530,
  p_item_plug_id => 2727714777743396+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 2112729270137774 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'PLSQL',
  p_validation_sequence=> 1,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   mel.p(''102/300:testval request:%1,%2,%3,%4'',v_prot_id,''INFO'',''test'',:request,:P300_WK_DET_ID,:P300_MENGENART_ID,:p300_rezept_nr);'||unistr('\000a')||
'--  IF :request = ''MULTI_ROW_DELETE'' THEN'||unistr('\000a')||
'--     apex_application.g_f01(1):= :P300_WK_DET_ID;'||unistr('\000a')||
'--  END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5340626603479864 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P300_SA_AUFTRAGSNUMMER',
  p_validation_sequence=> 5,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_zahl    number;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_zahl := to_number(regexp_replace(:p300_sa_auftragsnummer,''[ ]'',''''),''99999999'');'||unistr('\000a')||
'   :p300_sa_auftragsnummer :=  v_zahl;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   RETURN (''Keine gültige Auftragsnummer!(max. 8-stellige Zahl)'');'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_associated_item=> 5054903707909894 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6683431746352184 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P300_REZEPT_NR_mengenart_id_not_null',
  p_validation_sequence=> 5,
  p_validation => 'DECLARE '||unistr('\000a')||
'   v_fehlertext   uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p300_mengenart_id is null AND :p300_rezept_nr is null '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --v_fehlertext := ''Bitte geben Sie einen Artikel oder ein Rezept ein!'';'||unistr('\000a')||
'      v_fehlertext:=frgbg_s.holen_uebersetzung(4327,:fas_sprache_id);'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request = ''WARENKORB''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6681523388971306 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P300_REZEPT_NR',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE '||unistr('\000a')||
'   v_neuberechnen mn_rezepte.neuberechnen%TYPE;'||unistr('\000a')||
'   -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'   v_neuberechnen_sortiment mn_rezepte.neuberechnen_sortiment%TYPE;'||unistr('\000a')||
'   v_aenderbar    mn_rezepte.aenderbar%TYPE;'||unistr('\000a')||
'   v_mengenart_id mengenarts.id%TYPE;'||unistr('\000a')||
'   v_arzt_rezept  mn_rezepte.arzt_rezept%TYPE; -- 26.07.14 GWTYP4 erfordert Flag arzt_rezept=J  '||unistr('\000a')||
'   v_anz_ueberschreitung NUMBER;               -- 26.07.14  '||unistr('\000a')||
'   v_mn_rezept_id mn_rezepte.arzt_rezept%TYPE; -- 26.07.14'||unistr('\000a')||
''||unistr('\000a')||
'   v_fehlertext   uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p300_rezept_nr is not null THEN'||unistr('\000a')||
'      -- Ist das Rezept gültig zum Bestellen?'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT neuberechnen, aenderbar  ,neuberechnen_sortiment, arzt_rezept,id'||unistr('\000a')||
'         INTO v_neuberechnen, v_aenderbar,v_neuberechnen_sortiment, v_arzt_rezept,v_mn_rezept_id'||unistr('\000a')||
'         FROM v_mn_rezepte'||unistr('\000a')||
'         WHERE personenstamm_id = :p300_persstamm_id AND satz_kennzeichen is null'||unistr('\000a')||
'           AND akt_version = 1 AND :fas_pers_aenderbar = 1'||unistr('\000a')||
'           AND rezept_nr = :p300_rezept_nr; '||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN no_data_found THEN --v_fehlertext := ''Rezept ist unbekannt!'';'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(4328,:fas_sprache_id)||'' (FAS-ID: ''||:p300_persstamm_id||'')'';'||unistr('\000a')||
'         RETURN v_fehlertext;'||unistr('\000a')||
'      WHEN others THEN  --''Rezept ist unbekannt! '';'||unistr('\000a')||
'         mel.p(''Interner Fehler bei der Rezeptauswahl im WK Rezept-Nr. %1; Fehler: %2'',v_prot_id,''FEHLER'',:p300_rezept_nr, SQLERRM);'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(4328,:fas_sprache_id)||'' (FAS-ID: ''||:p300_persstamm_id||'')'';'||unistr('\000a')||
'         RETURN v_fehlertext;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'      IF v_neuberechnen != ''N'' OR'||unistr('\000a')||
'         v_neuberechnen_sortiment !=''N'' -- NEI 14.02.11 Sortimentseinf.'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         --''Rezept ist nicht mehr aktuell! Bestellung nicht möglich.'';'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(4329,:fas_sprache_id);'||unistr('\000a')||
'         RETURN v_fehlertext;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF v_aenderbar != ''J'' THEN'||unistr('\000a')||
'         --''Rezept kann nicht bestellt werden!'';'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(4330,:fas_sprache_id);'||unistr('\000a')||
'         RETURN v_fehlertext;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      /* NEI 18.08.14 nicht mehr erforderlich. Die Grenzwertüberschreitung wird nur noch registriert im WK und das Flag nicht mehr im WK ausgewertet'||unistr('\000a')||
'      -- NEI 26.07.14 Check Arztrezept-Grenzwerte'||unistr('\000a')||
'      IF v_arzt_rezept = ''N'' THEN -- CHECK Grenzwerte GWTYP4-Überschreitung:=>  Flag arzt_rezept=J '||unistr('\000a')||
'         -- Falls der Grenzwert für Arztrezept => muss das Feld mn_rezepte.arzt_rezept= ''J'' gesetzt werden'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            v_anz_ueberschreitung:= rezepte.CHECK_MNR_GRENZWERTE(v_mn_rezept_id, 4,1);  '||unistr('\000a')||
'            IF v_anz_ueberschreitung > 0 THEN v_fehlertext:=frgbg_s.holen_uebersetzung(10347,:fas_sprache_id); RETURN v_fehlertext; END IF;'||unistr('\000a')||
'         EXCEPTION WHEN OTHERS THEN v_fehlertext:=frgbg_s.holen_uebersetzung(10348,:fas_sprache_id); RETURN v_fehlertext; END;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      -- NEI 04.11.14 Prüfung max. Grenzwerte nach Grenzwertumstellung von 18.08.14'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         v_anz_ueberschreitung:= rezepte.CHECK_MNR_GRENZWERTE (v_mn_rezept_id,1,-- max. Grenzwertprüfung '||unistr('\000a')||
'                        1);   -- Runden auf 1 Nachkommastelle'||unistr('\000a')||
'         IF v_anz_ueberschreitung > 0 THEN --''Es wurden max. Grenzwerte(GWTYP =1) bei den Inhaltsstoffen überschritten!.....'||unistr('\000a')||
'            v_fehlertext:=frgbg_s.holen_uebersetzung(11579,:fas_sprache_id);'||unistr('\000a')||
'            RETURN v_fehlertext;'||unistr('\000a')||
'         ELSIF v_anz_ueberschreitung < 0 THEN --''Die Grenzwertprüfung konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'            v_fehlertext:=frgbg_s.holen_uebersetzung(11580,:fas_sprache_id);'||unistr('\000a')||
'            RETURN v_fehlertext;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN OTHERS THEN --''Die Grenzwertprüfung konnte nicht durchgeführt werden!'';'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(11580,:fas_sprache_id);'||unistr('\000a')||
'         RETURN v_fehlertext;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request = ''WARENKORB''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4279006164259703 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P300_mengenart_id',
  p_validation_sequence=> 30,
  p_validation => 'DECLARE '||unistr('\000a')||
'   v_mengenart_id       mengenarts.id%TYPE;'||unistr('\000a')||
'   v_INDIVIDUALISIERBAR mengenarts.INDIVIDUALISIERBAR%TYPE;'||unistr('\000a')||
'   v_produktionsauftrag mengenarts.produktionsauftrag%TYPE;'||unistr('\000a')||
'   v_mn_rezept_id       mengenarts.mn_rezept_id%TYPE;'||unistr('\000a')||
'   v_anz                number;'||unistr('\000a')||
'   v_fehlertext         uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_prot_id            NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check1 mengenart_id %1,%2,%3,%4'',v_prot_id,''TEST'',''102/300:p300_mengenart_id'',:p300_mengenart_id, v_INDIVIDUALISIERBAR, :p300_groesse,:p300_gewicht);'||unistr('\000a')||
''||unistr('\000a')||
'   IF :p300_mengenart_id is not null THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'             SELECT m.id ,m.INDIVIDUALISIERBAR,m.produktionsauftrag, m.mn_rezept_id'||unistr('\000a')||
'             into v_mengenart_id, v_INDIVIDUALISIERBAR,v_produktionsauftrag,v_mn_rezept_id'||unistr('\000a')||
'             FROM mengenarts m, sortiment_details s'||unistr('\000a')||
'             WHERE m.id = :p300_mengenart_id'||unistr('\000a')||
'               and m.satz_kennzeichen is null'||unistr('\000a')||
'               and m.id = s.mengenart_id'||unistr('\000a')||
'               and s.satz_kennzeichen is null'||unistr('\000a')||
'               and s.sortiment_id = :fas_sortiment_id'||unistr('\000a')||
'               and s.verkaufsartikel != ''N'''||unistr('\000a')||
'            ;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN no_data_found THEN'||unistr('\000a')||
'         --v_fehlertext := ''Artikel ist unbekannt! Bestellung nicht möglich.'';'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(4331,:fas_sprache_id);'||unistr('\000a')||
'         RETURN v_fehlertext;         '||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         mel.p(''Interner Fehler bei der Artikelauswahl im WK mengenart_id %1 Fehler: %2'',v_prot_id,''FEHLER'',:p300_mengenart_id, SQLERRM);'||unistr('\000a')||
'         --v_fehlertext := ''Artikel ist unbekannt! Bestellung nicht möglich.'';'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(4331,:fas_sprache_id);'||unistr('\000a')||
'         RETURN v_fehlertext;'||unistr('\000a')||
'      END ;'||unistr('\000a')||
'--mel.p(''check2 mengenart_id %1,%2,%3,%4,%5'',v_prot_id,''TEST'',''102/300:p300_mengenart_id'',:p300_mengenart_id, v_INDIVIDUALISIERBAR, :p300_groesse,:p300_gewicht,v_produktionsauftrag);'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'      -- Grösse/Gewicht vorhanden?'||unistr('\000a')||
'      IF v_INDIVIDUALISIERBAR = 1 THEN'||unistr('\000a')||
'         -- Groesse und Gewicht muss vorhanden sein'||unistr('\000a')||
'         IF :p300_groesse is NULL OR :p300_gewicht is NULL THEN'||unistr('\000a')||
'            v_fehlertext:=frgbg_s.holen_uebersetzung(5579,:fas_sprache_id);'||unistr('\000a')||
'            RETURN v_fehlertext;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Produktionsartikel hat gültiges Rezept'||unistr('\000a')||
'      IF v_produktionsauftrag > 0 THEN'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            SELECT count(*) into v_anz'||unistr('\000a')||
'            FROM v_mn_rezepte mnr, prod_rezepte prodr'||unistr('\000a')||
'            WHERE mnr.id = v_mn_rezept_id'||unistr('\000a')||
'              AND mnr.akt_version = 1'||unistr('\000a')||
'              AND mnr.rezept_nr = prodr.rezept_nr'||unistr('\000a')||
'              AND mnr.version = prodr.version'||unistr('\000a')||
'              AND NOT (mnr.neuberechnen=''J'' OR                  -- Neuberechnen'||unistr('\000a')||
'                    mnr.neuberechnen_sortiment =''J'' OR'||unistr('\000a')||
'                    prodr.sortiment_id!=:fas_sortiment_id OR    -- geändertes Sortiment'||unistr('\000a')||
'                    prodr.PROD_REZSTATUS_ID = 1                 -- Arbeitsversion'||unistr('\000a')||
'                   ) '||unistr('\000a')||
'               ;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            mel.p(''Interner Fehler bei der Prüfung des Produktionsartikels im WK mengenart_id %1 Fehler: %2'',v_prot_id,''FEHLER'',:p300_mengenart_id, SQLERRM);'||unistr('\000a')||
'            --v_fehlertext := ''Artikel ist unbekannt! Bestellung nicht möglich.'';'||unistr('\000a')||
'            v_fehlertext:=frgbg_s.holen_uebersetzung(4331,:fas_sprache_id);'||unistr('\000a')||
'            RETURN v_fehlertext;'||unistr('\000a')||
'         END;'||unistr('\000a')||
'         IF v_anz = 0 THEN -- Std-Mischartikel ist nicht mehr gültig.'||unistr('\000a')||
'            v_fehlertext:=frgbg_s.holen_uebersetzung(10050,:fas_sprache_id);'||unistr('\000a')||
'            RETURN v_fehlertext;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request = ''WARENKORB''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5469130646298490 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_geburtsdatum_labor',
  p_validation_sequence=> 60,
  p_validation => 'DECLARE'||unistr('\000a')||
'    v_laboranforderung NUMBER;'||unistr('\000a')||
'    v_anz              NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'      SELECT count(*) into v_laboranforderung'||unistr('\000a')||
'      FROM warenkorb_details_tmp wkd, mengenarts m'||unistr('\000a')||
'      WHERE wkd.warenkorb_tmp_id = :P300_WARENKORB_TMP_ID'||unistr('\000a')||
'        AND wkd.MENGENART_ID = m.id'||unistr('\000a')||
'        AND m.artgruppe_id = 20;'||unistr('\000a')||
'      IF v_laboranforderung > 0 THEN'||unistr('\000a')||
'         SELECT count(*) INTO v_anz'||unistr('\000a')||
'         FROM personenstamm'||unistr('\000a')||
'         WHERE id = :p300_persstamm_id'||unistr('\000a')||
'           AND geburtsdatum is not null'||unistr('\000a')||
'          ;'||unistr('\000a')||
'         IF v_anz = 0 THEN'||unistr('\000a')||
'            --RETURN ''Der Laborauftrag hat einen Kunden ohne Geburtsdatum! Bitte erst das Geburtsdatum eintragen.''; '||unistr('\000a')||
'            RETURN frgbg_s.holen_uebersetzung(7647,:fas_sprache_id);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      RETURN null;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 2135923640162310 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 4416115832926337 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 300
 ,p_name => 'disable_lov_menge'
 ,p_event_sequence => 40
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'unload'
 ,p_display_when_type => 'NEVER'
  );
wwv_flow_api.create_page_da_action (
  p_id => 4416408708926357 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 300
 ,p_event_id => 4416115832926337 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '"select[id^=f02_]"'
 ,p_attribute_01 => '// Achtung direkt bevor ein submit/bevor unload durchgefuehrt wird,'||unistr('\000a')||
'// muss damit die MRUs richtig arbeiten wieder alles enabled werden '||unistr('\000a')||
'// => $("#" +menge_id).removeAttr("disabled");'||unistr('\000a')||
''||unistr('\000a')||
'if (document.wwv_flow.f05) { // Check to see at least one present'||unistr('\000a')||
''||unistr('\000a')||
'      var l = document.wwv_flow.f05.length;'||unistr('\000a')||
''||unistr('\000a')||
'      if (l == undefined) { // Have only one record'||unistr('\000a')||
'          var curr_id = document.wwv_flow.f05.id;'||unistr('\000a')||
'          var menge_id = document.wwv_flow.f02.id;   //''f02_'' + curr_id.substr( 4); MENGE-LOV'||unistr('\000a')||
'          //alert ($x(curr_id).value);'||unistr('\000a')||
'          //  $x(menge_id).readOnly = "readonly";          //reicht bei LOV nicht => disable'||unistr('\000a')||
'          //  $x(menge_id).style.background = "silver";'||unistr('\000a')||
'              $("#" +menge_id).removeAttr("disabled");'||unistr('\000a')||
'      }'||unistr('\000a')||
'      else {  // Having multiple records'||unistr('\000a')||
'   '||unistr('\000a')||
'         for (var i = 0; i < l; i++) { '||unistr('\000a')||
'             var curr_id = document.wwv_flow.f05[i].id;'||unistr('\000a')||
'             var menge_id = document.wwv_flow.f02[i].id;  //''f02_'' + curr_id.substr( 4); MENGE_LOV'||unistr('\000a')||
''||unistr('\000a')||
'             if ($x(curr_id).value != "") {'||unistr('\000a')||
'                 //alert (''P_rez:''+$x(curr_id).value);'||unistr('\000a')||
'                 //$x(menge_id).readOnly = "readonly";'||unistr('\000a')||
'                 //$x(menge_id).style.background = "silver";'||unistr('\000a')||
'                 $("#" +menge_id).removeAttr("disabled");'||unistr('\000a')||
'             }              '||unistr('\000a')||
'         }'||unistr('\000a')||
'      }'||unistr('\000a')||
'   }'||unistr('\000a')||
''
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 4417901024320850 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 300
 ,p_name => 'wk_lov_menge_reduzieren'
 ,p_event_sequence => 40
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 4418229350320852 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 300
 ,p_event_id => 4417901024320850 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '"select[id^=f02_]"'
 ,p_attribute_01 => 'if (document.wwv_flow.f05) { // Check to see at least one present'||unistr('\000a')||
'    var l = document.wwv_flow.f05.length;   //P_rezept_id'||unistr('\000a')||
'    if (l == undefined) { // Have only one record'||unistr('\000a')||
'       var curr_id = document.wwv_flow.f05.id;  // Feld P_rezept_id'||unistr('\000a')||
'       var curr_artikel_id = document.wwv_flow.f06.id;  // Feld P_mengenart'||unistr('\000a')||
'       var menge_id = document.wwv_flow.f02.id; //''f02_'' + curr_id.substr( 4); Feld Menge'||unistr('\000a')||
'       //alert (''Rezept:''+$x(curr_id).value+'' Artikel:''+$x(curr_artikel_id).value);'||unistr('\000a')||
'       if ($x(curr_id).value != "" && $x(curr_artikel_id).value == "" ) {'||unistr('\000a')||
'           var j = $x(menge_id).length;'||unistr('\000a')||
'           for (k = 1; k < j; k++)  {'||unistr('\000a')||
'              //$x(menge_id).options[$x(menge_id).length-1] = null; '||unistr('\000a')||
'              //alert (j-k); '||unistr('\000a')||
'              $x(menge_id).options[j-k] = null; '||unistr('\000a')||
'              //alert ($x(menge_id).length); '||unistr('\000a')||
'           }'||unistr('\000a')||
'       }     '||unistr('\000a')||
'    }    '||unistr('\000a')||
'    else {  // Having multiple records       '||unistr('\000a')||
'         for (var i = 0; i < l; i++) { '||unistr('\000a')||
'             var curr_id = document.wwv_flow.f05[i].id;  // Feld P_rezept_id'||unistr('\000a')||
'             var curr_artikel_id = document.wwv_flow.f06[i].id;  // Feld P_mengenart'||unistr('\000a')||
'             var menge_id = document.wwv_flow.f02[i].id; //''f02_'' + curr_id.substr( 4); Feld Menge'||unistr('\000a')||
'             //alert (''Rezept:''+$x(curr_id).value+'' Artikel:''+$x(curr_artikel_id).value);'||unistr('\000a')||
'             if ($x(curr_id).value != "" && $x(curr_artikel_id).value == "") {'||unistr('\000a')||
'                 //alert (''P_rez:''+$x(curr_id).value);'||unistr('\000a')||
'                 //$x(menge_id).readOnly = "readonly";'||unistr('\000a')||
'                 //$x(menge_id).style.background = "silver";'||unistr('\000a')||
'                 //$("#" +menge_id).attr("disabled", "disabled");'||unistr('\000a')||
'                 // Alle ausser den Ersten loeschen'||unistr('\000a')||
'                 var j = $x(menge_id).length;'||unistr('\000a')||
'                 for (k = 1; k < j; k++)  {'||unistr('\000a')||
'                      //$x(menge_id).options[$x(menge_id).length-1] = null; '||unistr('\000a')||
'                      //alert (j-k); '||unistr('\000a')||
'                      $x(menge_id).options[j-k] = null; '||unistr('\000a')||
'                      //alert ($x(menge_id).length); '||unistr('\000a')||
'                 }'||unistr('\000a')||
'             }              '||unistr('\000a')||
'         }'||unistr('\000a')||
'   }'||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 4048722287431152 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 300
 ,p_name => 'wk_aktualisierren_neu'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '"select[id^=f02_]"'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 4049022469431163 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 300
 ,p_event_id => 4048722287431152 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'SUBMIT'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_da_action_comment => 'Action execute javascriptcode:'||unistr('\000a')||
'apex.submit({request:''SUBMIT''})'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 11244121396051763 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 300
 ,p_name => 'submit WK fuer MNR-Quereinstieg mit Rezept'
 ,p_event_sequence => 60
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
 ,p_display_when_type => 'REQUEST_EQUALS_CONDITION'
 ,p_display_when_cond => 'REZEPT_IN_WK'
  );
wwv_flow_api.create_page_da_action (
  p_id => 11244412332051780 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 300
 ,p_event_id => 11244121396051763 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'WARENKORB'
 ,p_attribute_02 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p300_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_info  := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_artikelliste := frgbg_s.holen_uebersetzung(3078,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_in_warenkorb   := frgbg_s.holen_uebersetzung(3079,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_zur_kasse :';

p:=p||'= frgbg_s.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'--   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(3591,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id); '||unistr('\000a')||
'   :p300_bl_aendern := frgbg_s.holen_uebersetzung(10021,v_sprache_id); '||unistr('\000a')||
'   :p300_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprach';

p:=p||'e_id);'||unistr('\000a')||
'   :p300_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   --:P300_BL_INDIV_REZEPT := frgbg_s.holen_uebersetzung(3082,v_sprache_id);'||unistr('\000a')||
'   :P300_BL_SUCHEN := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_hide := frgbg_s.holen_uebersetzung(4924,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_show := frgbg_s.holen_uebersetzung(4923,v_sprache_id);'||unistr('\000a')||
'   :P300_INKL_MWST_LABEL:= frgbg_s.';

p:=p||'holen_uebersetzung(5522,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_REGION_TITEL_KATEGORIE:=NULL;'||unistr('\000a')||
'   :p300_region_titel_artikel:= frgbg_s.holen_uebersetzung(4858,v_sprache_id);'||unistr('\000a')||
'   :p300_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   --:P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(1569,v_sprache_id)';

p:=p||';'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_NV_WARENKORB := frgbg_s.holen_uebersetzung(3844,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'   -- Hinweistext auf Suchbedingung oder Kategorieeingabe'||unistr('\000a')||
'   IF :P300_WK_ARTIKELTYP_FLAG = 1 AND '||unistr('\000a')||
'      :P300_SA_AUFTRAGSNUMMER is null '||unistr('\000a')||
'   THEN -- Laborauftrag => Auftragsnummer eingeben'||unistr('\000a')||
'      :P300_MELDUNG_ARTSUCHE:= frgbg_s.holen_uebersetzung(8321,v_sprache_id); --''Zuerst SA-Auftragsnummer eingeben!'';'||unistr('\000a')||
'   ELSIF :P300_';

p:=p||'WK_ARTIKELTYP_FLAG = 1 AND '||unistr('\000a')||
'      :P300_SA_AUFTRAGSNUMMER is not null '||unistr('\000a')||
'   THEN -- Laborauftrag und  Auftragsnummer eingeben => Zuerst ein FB erzeugen!'||unistr('\000a')||
'      :P300_MELDUNG_ARTSUCHE:= frgbg_s.holen_uebersetzung(8322,v_sprache_id); --''Kunde hat noch keinen offenen FB. Zuerst ein FB erzeugen!'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :P300_MELDUNG_ARTSUCHE:=frgbg_s.holen_uebersetzung(5443,v_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   :P300_';

p:=p||'MELDUNG_WK:= frgbg_s.holen_uebersetzung(4860,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2156028075991557 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 51,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_aenderbar     personenstamm.aenderbar%TYPE;'||unistr('\000a')||
'   v_user_account  personenstamm.user_account%TYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT aenderbar, user_account into v_aenderbar, v_user_account'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :p300_persstamm_id;'||unistr('\000a')||
'   IF   (v_aenderbar = ''J'') '||unistr('\000a')||
'     OR (v_aenderbar = ''N'' AND'||unistr('\000a')||
'         -- speziell berechtigt'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''GESCHUETZTE_PERSONENDATEN_';

p:=p||'AENDERN'') > 0 '||unistr('\000a')||
'         )'||unistr('\000a')||
'      OR (v_aenderbar = ''N'' AND                 -- User hat sich selbst eingeloggt'||unistr('\000a')||
'          :fas_aufgerufen_von != ''BETREUER'' and'||unistr('\000a')||
'          UPPER(v_USER_ACCOUNT)= UPPER(:APP_USER)'||unistr('\000a')||
'         )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :fas_pers_aenderbar := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_aenderbar := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6608922445465053 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 91,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_fas_pers_aenderbar',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_SCROLLREGION_HEIGHT_MAX  NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'/*   :P300_HEIGHT_warenkorb := (:FAS_SCROLLREGION_HEIGHT_MAX * 0.9)-4;'||unistr('\000a')||
'   :P300_HEIGHT_artikel := (:FAS_SCROLLREGION_HEIGHT_MAX * 0.9)-4;'||unistr('\000a')||
'   :P300_HEIGHT_KATEGORIE := (:FAS_SCROLLREGION_HEIGHT_MAX * 0.9)-4;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   v_SCROLLREGION_HEIGHT_MAX:= :FAS_SCROLLREGION_HEIGHT_MAX;'||unistr('\000a')||
'   :P300_HEIGH';

p:=p||'T_warenkorb := trunc(v_SCROLLREGION_HEIGHT_MAX * 0.88);'||unistr('\000a')||
'   :P300_HEIGHT_artikel   := trunc(v_SCROLLREGION_HEIGHT_MAX * 0.88);'||unistr('\000a')||
'   :P300_HEIGHT_KATEGORIE := trunc(v_SCROLLREGION_HEIGHT_MAX * 0.88);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2169802586819835 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 100,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_prot_id   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''WK speichern vor:''||:P300_KASSENABRECHNUNG, v_prot_id,''TEST'',''102/300:speichern_wk'');'||unistr('\000a')||
'   UPDATE warenkoerbe_tmp'||unistr('\000a')||
'   SET kassenabrechnung = :P300_KASSENABRECHNUNG,'||unistr('\000a')||
'       aerztlich_verordnet = :p300_aerztlich_verordnet,'||unistr('\000a')||
'       labor_mit_fb = :p300_labor_mit_fb'||unistr('\000a')||
'   WHERE id = :p300_warenkorb_tmp_id;'||unistr('\000a')||
'--mel.p(''WK speichern nach:''||:p300_kassenabrechnung, v_pr';

p:=p||'ot_id,''TEST'',''102/300:speichern_wk'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4192512305483019 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_wk',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request in (''P300_AERZTLICH_VERORDNET'',''P300_KASSENABRECHNUNG'',''P300_LABOR_MIT_FB'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKORB_DETAILS_TMP:ID';

wwv_flow_api.create_page_process(
  p_id     => 2302626124733596 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_UPDATE',
  p_process_name=> 'ApplyMRU',
  p_process_sql_clob => p,
  p_process_error_message=> 'Verarbeiten von Aktualisierung nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''SUBMIT''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKORB_DETAILS_TMP:ID';

wwv_flow_api.create_page_process(
  p_id     => 2302822990733596 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_DELETE',
  p_process_name=> 'ApplyMRD',
  p_process_sql_clob => p,
  p_process_error_message=> 'Verarbeiten von Löschvorgang nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_rezept_nr_splitbasis  number;'||unistr('\000a')||
'   v_version_splitbasis    number;'||unistr('\000a')||
'   v_return       number;'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- NEI 10.01.14 Kumulation Splits zu Gesamtrezept  komplett neu'||unistr('\000a')||
'   -- Details löschen'||unistr('\000a')||
'   -- NEI 24.04.15 Holen der Splitbasis, statt in g_f0-Array zur Verfügung zu stellen, das geht nicht, '||unistr('\000a')||
'   -- da MRU nur auf eine Tabelle geht und alle SaveSessionState Variab';

p:=p||'len gepeichert werden in diese '||unistr('\000a')||
'   -- Tabelle und diese Spalten gibt es dann nicht in wk_details'||unistr('\000a')||
'   for v_count in 1..apex_application.g_f01.count'||unistr('\000a')||
'   loop '||unistr('\000a')||
'/*MEL.P(''Prod-Details speichern f21 %1, f22 %2, f23 %3,f24 %4, f25 %5, f26 %6,f27 %7,f28 %8,ANz: %9'','||unistr('\000a')||
'           v_prot_id,'||unistr('\000a')||
'           ''Info'','||unistr('\000a')||
'           ''MNR-Details speichern'','||unistr('\000a')||
'           apex_application.g_f01(v_count),  checkbox'||unistr('\000a')||
'           ';

p:=p||'apex_application.g_f02(v_count),  menge'||unistr('\000a')||
'           apex_application.g_f03(v_count),  bemerkung'||unistr('\000a')||
'           apex_application.g_f04(v_count),  wk_id'||unistr('\000a')||
'           apex_application.g_f05(v_count),  p_prod_rezept_id'||unistr('\000a')||
'           apex_application.g_f06(v_count),  mengenart_id'||unistr('\000a')||
'           --apex_application.g_f07(v_count),  rezept_nr_split_basis  -- NEI 24.04.2015 savestate geht wg. MRU nicht, da kein Feld in ';

p:=p||'wkdetails => wird daher in LOOP geholt'||unistr('\000a')||
'           --apex_application.g_f08(v_count),  version_split_basis    -- NEI 24.04.2015 savestate geht wg. MRU nicht, da kein Feld in wkdetails'||unistr('\000a')||
'           to_char(v_count));'||unistr('\000a')||
'*/ '||unistr('\000a')||
'/*mel.p(''pos del %1 ,Prodrez: %2, Mengenart: %3, rez_split %4, vers_split %5, bem %6, wkd %7'',v_prot_id,''TEST'', ''102/300:wk_pos_delete'',apex_application.g_f01( v_count), apex_applicat';

p:=p||'ion.g_f05( apex_application.g_f01(v_count)),apex_application.g_f06( apex_application.g_f01(v_count)),apex_application.g_f07( apex_application.g_f01(v_count)),apex_application.g_f08( apex_application.g_f01(v_count)),apex_application.g_f03( apex_application.g_f01(v_count)),apex_application.g_f04( apex_application.g_f01(v_count)));'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'       IF apex_application.g_f05(apex_application.g_f01(v_count))';

p:=p||' IS NULL         -- Kein Produktrezept'||unistr('\000a')||
'       THEN'||unistr('\000a')||
'          -- Nur markierte Position löschen'||unistr('\000a')||
'          DELETE FROM warenkorb_details_tmp'||unistr('\000a')||
'          WHERE warenkorb_tmp_id = :P300_WARENKORB_TMP_ID'||unistr('\000a')||
'            AND id =  apex_application.g_f04( apex_application.g_f01(v_count));'||unistr('\000a')||
'/*       '||unistr('\000a')||
'       ELSIF  apex_application.g_f05(apex_application.g_f01(v_count)) IS NOT NULL AND -- Produktrezept ohne Split';

p:=p||''||unistr('\000a')||
'          apex_application.g_f07(apex_application.g_f01(v_count)) IS NULL AND '||unistr('\000a')||
'          apex_application.g_f08(apex_application.g_f01(v_count)) IS NULL '||unistr('\000a')||
'       THEN'||unistr('\000a')||
'          DELETE FROM warenkorb_details_tmp'||unistr('\000a')||
'          WHERE warenkorb_tmp_id = :P300_WARENKORB_TMP_ID'||unistr('\000a')||
'            AND p_rezept_id = apex_application.g_f05(apex_application.g_f01(v_count));'||unistr('\000a')||
'*/'||unistr('\000a')||
'       ELSE -- Alle Positionen mit dem gl';

p:=p||'eichen Produktrezept löschen             -- Produktrezepte mit/ohne Split'||unistr('\000a')||
'          -- NEI 24.04.15 Holen der Splitbasis, statt in g_f0-Array zur Verfügung zu stellen, das geht nicht, '||unistr('\000a')||
'          -- da MRU nur auf eine Tabelle geht und alle SaveSessionState Variablen gepeichert werden in diese '||unistr('\000a')||
'          -- Tabelle und diese Spalten gibt es dann nicht in wk_details'||unistr('\000a')||
'          SELECT mnr.rezept_nr_sp';

p:=p||'litbasis,mnr.version_splitbasis'||unistr('\000a')||
'          INTO v_rezept_nr_splitbasis, v_version_splitbasis'||unistr('\000a')||
'          from prod_rezepte pr,  mn_rezepte mnr  -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'          where pr.id =  apex_application.g_f05(apex_application.g_f01(v_count))'||unistr('\000a')||
'            AND pr.rezept_nr = mnr.rezept_nr '||unistr('\000a')||
'            AND pr.version  = mnr.version    '||unistr('\000a')||
'          ;'||unistr('\000a')||
'          IF v_rezept_';

p:=p||'nr_splitbasis IS NULL AND '||unistr('\000a')||
'             v_version_splitbasis IS NULL '||unistr('\000a')||
'          THEN                                    -- Info über rezept_nr_splitbasis, version Splitbasis nicht vorhanden   '||unistr('\000a')||
'             DELETE FROM warenkorb_details_tmp     -- Gesamtrezept ohne Info über rezept_nr_splitbasis, version Splitbasis'||unistr('\000a')||
'             WHERE warenkorb_tmp_id = :P300_WARENKORB_TMP_ID'||unistr('\000a')||
'               AND p_re';

p:=p||'zept_id in (       -- einzelne Produktrezept, die zum Split gehören ermitteln'||unistr('\000a')||
'                        select pr1.id'||unistr('\000a')||
'                        from mn_rezepte mnr, prod_rezepte pr ,prod_rezepte pr1'||unistr('\000a')||
'                        where pr.id =apex_application.g_f05( apex_application.g_f01(v_count))'||unistr('\000a')||
'                          and mnr.rezept_nr_splitbasis = pr.rezept_nr'||unistr('\000a')||
'                          and mnr.version';

p:=p||'_splitbasis = pr.version'||unistr('\000a')||
'                          and mnr.rezept_nr = pr1.REZEPT_nr'||unistr('\000a')||
'                          and mnr.version = pr1.version'||unistr('\000a')||
'                        UNION'||unistr('\000a')||
'                        SELECT  pr.id'||unistr('\000a')||
'                        from prod_rezepte pr'||unistr('\000a')||
'                        where pr.id = apex_application.g_f05( apex_application.g_f01(v_count))-- Gesamt-Produktrezept selbst'||unistr('\000a')||
'                     ';

p:=p||'  );'||unistr('\000a')||
'          ELSE'||unistr('\000a')||
'             DELETE FROM warenkorb_details_tmp    -- Info über rezept_nr_splitbasis, version Splitbasis vorhanden'||unistr('\000a')||
'             WHERE warenkorb_tmp_id = :P300_WARENKORB_TMP_ID'||unistr('\000a')||
'               AND p_rezept_id in (       '||unistr('\000a')||
'                        select pr.id'||unistr('\000a')||
'                        from mn_rezepte mnr, prod_rezepte pr        --Splitkomponenten'||unistr('\000a')||
'                        where mnr.reze';

p:=p||'pt_nr_splitbasis = v_rezept_nr_splitbasis'||unistr('\000a')||
'                          and mnr.version_splitbasis = v_version_splitbasis'||unistr('\000a')||
'                          and mnr.rezept_nr = pr.rezept_nr'||unistr('\000a')||
'                          and mnr.version = pr.version'||unistr('\000a')||
'                        UNION'||unistr('\000a')||
'                        select pr.id                                -- Gesamtrezept selbst'||unistr('\000a')||
'                        from mn_rezepte mnr, pr';

p:=p||'od_rezepte pr'||unistr('\000a')||
'                        where mnr.rezept_nr = v_rezept_nr_splitbasis '||unistr('\000a')||
'                          and mnr.version = v_version_splitbasis'||unistr('\000a')||
'                          and mnr.rezept_nr = pr.rezept_nr'||unistr('\000a')||
'                          and mnr.version = pr.version'||unistr('\000a')||
'                       );'||unistr('\000a')||
'          END IF;'||unistr('\000a')||
'       END IF; '||unistr('\000a')||
'   end loop;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7398519528143061 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 25,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'wk_pos_delete',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request in (''MULTI_ROW_DELETE'') ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_warenkorb_detail_id  warenkorb_details_tmp.id%TYPE;'||unistr('\000a')||
'   v_prod_rezept_id       warenkorb_details_tmp.p_rezept_id%TYPE;'||unistr('\000a')||
'   v_version        prod_rezepte.version%TYPE;'||unistr('\000a')||
'   v_mengenart_id   mengenarts.id%TYPE;'||unistr('\000a')||
'   --v_labor_id       number;'||unistr('\000a')||
'   v_REZEPT_NR_SPLITBASIS   mn_rezepte.REZEPT_NR_SPLITBASIS%TYPE;-- NEI 30.09.13 MNR-Split'||unistr('\000a')||
'   v_version_splitbasis     mn_rezepte.version_splitbasis%TYP';

p:=p||'E;  -- NEI 10.01.14 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'   v_REZEPT_NR_2            mn_rezepte.REZEPT_NR%TYPE;           -- NEI 30.09.13 MNR-Split'||unistr('\000a')||
'   v_version_2              mn_rezepte.version%TYPE;             -- NEI 30.09.13 MNR-Split'||unistr('\000a')||
'   v_mn_rezart_2            mn_rezarten.bezeichnung%TYPE;        -- NEI 30.09.13 MNR-Split;  '||unistr('\000a')||
'   v_HINWEIStext            VARCHAR2(2000);'||unistr('\000a')||
'   v_split_anz            ';

p:=p||'  number;                               -- NEI 10.01.14 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'   v_reichweite_prodr       number;                               -- NEI 07.04.14 Produktrezept ggf. auf geänderte Wahlreichweite setzen'||unistr('\000a')||
'   v_etikettentyp           number;                               -- NEI 12.05.14 spez. Etikettentypen aus dem Stamm'||unistr('\000a')||
''||unistr('\000a')||
'   v_return         NUMBER;'||unistr('\000a')||
'   v_prot_id        NUMBER;';

p:=p||''||unistr('\000a')||
'   v_fehler         exception;'||unistr('\000a')||
'   v_fehler_mehrfachmisch exception;'||unistr('\000a')||
'   v_fehler_reichweite exception;'||unistr('\000a')||
'   v_fehler_labor   exception;'||unistr('\000a')||
'   v_fehlertext     VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlernummer   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''in_wk:Art %1, rezept %2,rw %3,%4,%5'',v_prot_id,''Info'',''in_warenkorb'',:p300_mengenart_id,:p300_rezept_nr,:P300_REZEPT_REICHWEITE);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_IN_WK_FEHLERTEXT:= null;'||unistr('\000a')||
'   v_HINWEIStext:= NUL';

p:=p||'L;'||unistr('\000a')||
'   v_REZEPT_NR_SPLITBASIS := null;'||unistr('\000a')||
'   -- Mischung'||unistr('\000a')||
'   IF :p300_rezept_nr is not null  THEN'||unistr('\000a')||
'      -- Aktuelle Version holen'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT version, id,reichweite INTO v_version, v_prod_rezept_id,v_reichweite_prodr '||unistr('\000a')||
'         FROM v_prod_rezepte'||unistr('\000a')||
'         WHERE akt_version = 1'||unistr('\000a')||
'           AND rezept_nr = :p300_rezept_nr;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN no_data_found THEN'||unistr('\000a')||
'         v_fehlertext';

p:=p||' := ''Ungueltiges Rezept!'';'||unistr('\000a')||
'         v_fehlernummer := 10;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         v_fehlertext := ''Rezept konnte nicht in den Warenkorb gestellt werden!''||SQLERRM;'||unistr('\000a')||
'         v_fehlernummer := 20;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END;'||unistr('\000a')||
''||unistr('\000a')||
'      IF :p300_warenkorb_tmp_id IS NULL THEN'||unistr('\000a')||
'         v_fehlertext := ''Rezept konnte nicht in den Warenkorb gestellt werden!'';'||unistr('\000a')||
'        ';

p:=p||' v_fehlernummer := 30;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         /* -- NEI 30.09.13 MNR-Split'||unistr('\000a')||
'         SELECT min(id) INTO v_warenkorb_detail_id'||unistr('\000a')||
'         FROM warenkorb_details_tmp'||unistr('\000a')||
'         WHERE warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'           AND p_rezept_id = v_prod_rezept_id  '||unistr('\000a')||
'         ;'||unistr('\000a')||
'         */'||unistr('\000a')||
'         -- NEI 30.09.13 MNR-Split: Check, ob gesplittetes MNR (Tag/Nacht)'||unistr('\000a')||
'         /* N';

p:=p||'EI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'               SELECT REZEPT_NR_SPLITBASIS'||unistr('\000a')||
'               INTO v_REZEPT_NR_SPLITBASIS '||unistr('\000a')||
'               FROM v_mn_rezepte'||unistr('\000a')||
'               WHERE REZEPT_NR = :p300_rezept_nr'||unistr('\000a')||
'                 and version = v_version;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            NULL;'||unistr('\000a')||
'         END;'||unistr('\000a')||
'         */'||unistr('\000a')||
''||unistr('\000a')||
'         -- Prüft, ob es für das Rez';

p:=p||'ept Splitkomponenten gibt => Splitbasis-Felder setzen'||unistr('\000a')||
'         v_split_anz :=  rezepte.CHECK_MNR_SPLIT_EXIST(NULL,:p300_rezept_nr,v_version);'||unistr('\000a')||
'         IF v_split_anz  > 0 THEN -- Splitkomponenten vorhanden'||unistr('\000a')||
'            v_rezept_nr_splitbasis := :p300_rezept_nr;'||unistr('\000a')||
'            v_version_splitbasis := v_version;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'         -- Prüfung, ob bereits eine Komponente des Rezeptes im WK eing';

p:=p||'tragen wurde'||unistr('\000a')||
'         SELECT min(wkd.id) INTO v_warenkorb_detail_id'||unistr('\000a')||
'         FROM prod_rezepte p, warenkorb_details_tmp wkd '||unistr('\000a')||
'         WHERE wkd.p_rezept_id = p.id'||unistr('\000a')||
'           and warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'           and (p.rezept_nr,p.version) in'||unistr('\000a')||
'                (SELECT rezept_nr, version'||unistr('\000a')||
'                  FROM mn_rezepte         -- alle Rezepte aber ohne Splitbasis => nur angeforde';

p:=p||'rtes'||unistr('\000a')||
'                  WHERE'||unistr('\000a')||
'                       (v_rezept_nr_splitbasis IS NULL and v_version_splitbasis IS NULL and rezept_nr = :p300_rezept_nr and VERSION = v_version)'||unistr('\000a')||
'                 UNION'||unistr('\000a')||
'                 SELECT rezept_nr, version'||unistr('\000a')||
'                  FROM mn_rezepte'||unistr('\000a')||
'                  WHERE                   -- alle Rezepte mit Splitbasis => alle Rezepte mit der Splitbasis i.R Tag/Nacht'||unistr('\000a')||
'    ';

p:=p||'                   (v_rezept_nr_splitbasis IS NOT NULL and v_version_splitbasis IS NOT NULL'||unistr('\000a')||
'                             and id in (SELECT id'||unistr('\000a')||
'                                        FROM v_mn_rezepte'||unistr('\000a')||
'                                        WHERE rezept_nr_splitbasis = v_rezept_nr_splitbasis'||unistr('\000a')||
'                                          and version_splitbasis = v_version_splitbasis     -- NEI 10.01.14 ';

p:=p||'Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'                                          and satz_kennzeichen is null'||unistr('\000a')||
'                                          and akt_version = 1'||unistr('\000a')||
'                                        )'||unistr('\000a')||
'                        )'||unistr('\000a')||
'                );'||unistr('\000a')||
''||unistr('\000a')||
'         IF v_warenkorb_detail_id is NULL       -- Nichts von dem Rezept bisher vorhanden'||unistr('\000a')||
'         THEN'||unistr('\000a')||
''||unistr('\000a')||
'            -- NEI 07.04.14 Produktrezep';

p:=p||'t ggf. auf neue Reichweite anpassen'||unistr('\000a')||
'            IF v_reichweite_prodr  != :p300_rezept_reichweite THEN'||unistr('\000a')||
'--mel.p(''in_wk:rezept %1,rw %2,alte rw %3,%5'',v_prot_id,''Info'',''in_warenkorb'',:p300_rezept_nr,:P300_REZEPT_REICHWEITE,v_reichweite_prodr );'||unistr('\000a')||
'               -- Reichweite ändern, nur wenn es keine offenen Bestellungen gibt'||unistr('\000a')||
'               v_return := rezepte.ANPASSEN_PRODR_REICHWEITE(v_prod_rezept_i';

p:=p||'d,:P300_REZEPT_REICHWEITE);'||unistr('\000a')||
'               IF v_return = 0 THEN'||unistr('\000a')||
'                  -- ''Es existiert zu diesem Rezept eine offene Bestellung! Eine Änderung der Reichweite ist daher zur Zeit nicht möglich.'');'||unistr('\000a')||
'                  v_fehlertext := ''Rezept konnte nicht in den Warenkorb gestellt werden! Es existiert zu diesem Rezept eine offene Bestellung! Eine Änderung der Reichweite ist daher zur Zeit nic';

p:=p||'ht möglich.'';'||unistr('\000a')||
'                  v_fehlernummer := 40;'||unistr('\000a')||
'                  RAISE v_fehler_reichweite ;'||unistr('\000a')||
'               ELSIF v_return < 0 THEN -- sonstige Fehler'||unistr('\000a')||
'                  v_fehlertext := ''Reichweitenanpassung fehltgeschlagen (v_return:''||v_return|| ''). Rezept konnte nicht in den Warenkorb gestellt werden!'';'||unistr('\000a')||
'                  v_fehlernummer := 45;'||unistr('\000a')||
'                  RAISE v_fehler;'||unistr('\000a')||
'            ';

p:=p||'   END IF;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
''||unistr('\000a')||
'            -- Warenkorb_Details erstellen, aufgesplittet nach Komponenten gemaess prodkennzeichen'||unistr('\000a')||
'            v_return := frgbg_s.wk_gen_details ('||unistr('\000a')||
'                      :p300_warenkorb_tmp_id,'||unistr('\000a')||
'                      :p300_rezept_nr,'||unistr('\000a')||
'                      v_version,'||unistr('\000a')||
'                      1, -- i.R.Menge immer 1'||unistr('\000a')||
'                      :p300_etikettentyp,'||unistr('\000a')||
'              ';

p:=p||'        1,  -- Gleicher Modus wie beim Kopf also 0=fix in WK oder 1=temporär in WK_tmp'||unistr('\000a')||
'                      1,  -- Aufrundung zu ganzen Packungen bei Fertigartikel als Bestandteil einer Mischung'||unistr('\000a')||
'                      1,  -- mit Berücksichtigung aller MNR-Split-Komponenten (Tag/Nacht)'||unistr('\000a')||
'                      1   -- NEI 18.06.14 Reichweitenstaffel-Rabattberechnung (=1) für Mischungen,'||unistr('\000a')||
'               ';

p:=p||'           --              nur  noch im WK und auf Bestellschein sonst keine Rabattrechnung'||unistr('\000a')||
'                       );'||unistr('\000a')||
'            IF v_return < 0 THEN -- Fehler'||unistr('\000a')||
'               v_fehlertext := ''Rezept konnte nicht in den Warenkorb gestellt werden!'';'||unistr('\000a')||
'               v_fehlernummer := 50;'||unistr('\000a')||
'               RAISE v_fehler;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
''||unistr('\000a')||
'            -- Ausgabe einer Hinweismeldung'||unistr('\000a')||
'            /* NEI';

p:=p||' 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'            IF v_REZEPT_NR_SPLITBASIS is not NULL AND v_version_splitbasis IS NOT NULL THEN'||unistr('\000a')||
'               SELECT count(*) INTO v_anz'||unistr('\000a')||
'               FROM v_mn_rezepte'||unistr('\000a')||
'               WHERE rezept_nr_splitbasis = v_rezept_nr_splitbasis'||unistr('\000a')||
'                 and v_version_splitbasis IS NOT NULL'||unistr('\000a')||
'                 and satz_kennzeichen is null'||unistr('\000a')||
'                 and';

p:=p||' akt_version = 1;'||unistr('\000a')||
'               IF v_anz > 1 THEN'||unistr('\000a')||
'                  --v_HINWEIStext:=''Die Mischung besteht aus mehreren Teilrezepten (z.B. Tag-/Nachtmischung). Die weiteren Rezeptkomponenten wurden automatisch dazugenommen!'';'||unistr('\000a')||
'                  v_HINWEIStext:=frgbg_s.holen_uebersetzung(9182,:fas_sprache_id);'||unistr('\000a')||
'               END IF;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'            */'||unistr('\000a')||
'            IF v_split_anz > 1 T';

p:=p||'HEN'||unistr('\000a')||
'                  --v_HINWEIStext:=''Die Mischung besteht aus mehreren Teilrezepten (z.B. Tag-/Nachtmischung). Die weiteren Rezeptkomponenten wurden automatisch dazugenommen!'';'||unistr('\000a')||
'                  v_HINWEIStext:=frgbg_s.holen_uebersetzung(9182,:fas_sprache_id);'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE   -- Rezepte oder Teile bereits vorhanden => Fehlermeldung'||unistr('\000a')||
'            -- Menge erhoehen => für alle Re';

p:=p||'zeptkomponenten auch deren Fertigartikel, '||unistr('\000a')||
'            -- evt. mehrere Positionen   '||unistr('\000a')||
'            /* NEI 17.08.11    '||unistr('\000a')||
'            UPDATE warenkorb_details_tmp'||unistr('\000a')||
'            SET menge = menge + 1'||unistr('\000a')||
'            WHERE warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'              AND p_rezept_id = v_prod_rezept_id   '||unistr('\000a')||
'            ;'||unistr('\000a')||
'            */'||unistr('\000a')||
'            /* NEI 24.02.12'||unistr('\000a')||
'            v_return := frgbg_s.wk_upd_';

p:=p||'details ('||unistr('\000a')||
'                      :p300_warenkorb_tmp_id,'||unistr('\000a')||
'                      v_prod_rezept_id   ,'||unistr('\000a')||
'                      1, -- i.R.Menge immer 1'||unistr('\000a')||
'                      1  -- Aufrundung zu ganzen Artikel bei Fertigartikel als Bestandteil einer Mischung'||unistr('\000a')||
'                       );'||unistr('\000a')||
'            IF v_return < 0 THEN -- Fehler'||unistr('\000a')||
'               v_fehlertext := ''Rezept konnte nicht nochmal in den Warenkorb ges';

p:=p||'tellt werden!'';'||unistr('\000a')||
'               v_fehlernummer := 55;'||unistr('\000a')||
'               RAISE v_fehler;'||unistr('\000a')||
'            END IF; '||unistr('\000a')||
'            */'||unistr('\000a')||
'            -- NEI 24.02.12'||unistr('\000a')||
'            -- Da die Bestellung nur mit Menge 1 arbeitet, muessen n-Stück einer Mischung in einem WK auf n-Bestellungen aufgesplittet werden. '||unistr('\000a')||
'            -- Storno einer Bestellung wird an die WK-Pos hochgereicht aber ein Bestellstorno führt den Stor';

p:=p||'no auf die komplette Menge der Posistion '||unistr('\000a')||
'            -- des Warenkorbs durch und nicht nur auf ein Stück der n-Bestellung'||unistr('\000a')||
'             v_fehlertext := ''Rezept bzw. Teilrezept (z.B. Tag-/Nachtmischung) bereits bestellt! Es kann nicht mehrfach in einen Warenkorb gestellt werden!'';'||unistr('\000a')||
'            v_fehlernummer := 55;'||unistr('\000a')||
'            RAISE v_fehler_mehrfachmisch;             '||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;';

p:=p||''||unistr('\000a')||
'      :p300_rezept_nr := NULL;'||unistr('\000a')||
'      :P300_REZEPT_REICHWEITE := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Einzelartikel '||unistr('\000a')||
'   IF :p300_mengenart_id is not null THEN'||unistr('\000a')||
'      SELECT min(id) INTO v_warenkorb_detail_id'||unistr('\000a')||
'      FROM warenkorb_details_tmp'||unistr('\000a')||
'      WHERE warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'        AND mengenart_id = :p300_mengenart_id'||unistr('\000a')||
'        AND p_rezept_id is null       -- Artikel darf nicht als Fertigart';

p:=p||'ikel in einem Rezept sein'||unistr('\000a')||
'      ;'||unistr('\000a')||
'      IF v_warenkorb_detail_id is NULL THEN'||unistr('\000a')||
'         -- Artikel nicht vorhanden => neu einfuegen'||unistr('\000a')||
'         /* NEI 05.05.2014 Labor-ID wird nun gewählt'||unistr('\000a')||
'         IF :p300_sa_auftragsnummer IS not null THEN'||unistr('\000a')||
'            v_labor_id := 1;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            v_labor_id := NULL;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         */'||unistr('\000a')||
'         -- NEI 07.05.2014 Laborauftrag mit externe Auftrag';

p:=p||'snummervergabe wie bei SA'||unistr('\000a')||
'         IF :p300_wk_artikeltyp_flag = 1 THEN  -- Laborauftrag'||unistr('\000a')||
'            -- Labor muss vorhanden sein'||unistr('\000a')||
'            IF :p300_labor_id is NULL THEN'||unistr('\000a')||
'               v_fehlertext := ''Artikel konnte nicht in den Warenkorb gestellt werden, da kein Labor ausgewählt wurde!'';'||unistr('\000a')||
'               v_fehlernummer := 74;'||unistr('\000a')||
'               RAISE v_fehler;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
''||unistr('\000a')||
'            -- Au';

p:=p||'ftragsnummer muss vorhanden sein'||unistr('\000a')||
'            IF :p300_sa_auftragsnummer is null and :P300_AUFTRAG_ID_INTERN = 0 THEN'||unistr('\000a')||
'               v_fehlertext := ''Artikel konnte nicht in den Warenkorb gestellt werden, da keine Auftragsnummer eingegeben wurde!'';'||unistr('\000a')||
'               v_fehlernummer := 75;'||unistr('\000a')||
'               RAISE v_fehler_labor;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE  -- Normalauftrag'||unistr('\000a')||
'            SELECT etikett';

p:=p||'entyp'||unistr('\000a')||
'            into v_etikettentyp'||unistr('\000a')||
'            FROM mengenarts'||unistr('\000a')||
'            WHERE id = :p300_mengenart_id;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         v_return := frgbg_s.wk_gen_details_art ('||unistr('\000a')||
'                      :p300_warenkorb_tmp_id,'||unistr('\000a')||
'                      :p300_mengenart_id,'||unistr('\000a')||
'                      1, -- i.R.Menge immer 1'||unistr('\000a')||
'                      --:p300_etikettentyp,    -- NEI 12.05.14 spez. Etikettentyp im Artik';

p:=p||'elstamm'||unistr('\000a')||
'                      v_etikettentyp,'||unistr('\000a')||
'                      1,   -- Gleicher Modus wie beim Kopf also 0=fix in WK oder 1=temporär in WK_tmp'||unistr('\000a')||
'                      :p300_pergebnis_id'||unistr('\000a')||
'                      ,:p300_sa_auftragsnummer'||unistr('\000a')||
'                      ,:p300_labor_id '||unistr('\000a')||
'                       );'||unistr('\000a')||
'         IF v_return < 0 THEN -- Fehler'||unistr('\000a')||
'            v_fehlertext := ''Artikel konnte nicht in den Wa';

p:=p||'renkorb gestellt werden!'';'||unistr('\000a')||
'            v_fehlernummer := 80;'||unistr('\000a')||
'            RAISE v_fehler;'||unistr('\000a')||
'         END IF;      '||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         -- Menge erhoehen'||unistr('\000a')||
'         UPDATE warenkorb_details_tmp'||unistr('\000a')||
'         SET menge = menge + 1'||unistr('\000a')||
'         WHERE id = v_warenkorb_detail_id;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      :p300_mengenart_id := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :P300_IN_WK_FEHLERTEXT:=v_HINWEIStext;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler_mehrfachmisch';

p:=p||' THEN'||unistr('\000a')||
'   MEL.P (v_fehlertext||'' [,FAS/P300 in_warenkorb''||to_char(-v_fehlernummer)||'']'','||unistr('\000a')||
'          v_prot_id,''INFO'',''FAS/P300 in_warenkorb'');'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(5037,:fas_sprache_id);'||unistr('\000a')||
'   :p300_mengenart_id := NULL;'||unistr('\000a')||
'   :p300_rezept_nr := NULL;'||unistr('\000a')||
'   :P300_REZEPT_REICHWEITE := NULL;'||unistr('\000a')||
'   --RAISE_APPLICATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   :P300_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'W';

p:=p||'HEN v_fehler_reichweite THEN'||unistr('\000a')||
'   MEL.P (v_fehlertext||'' [,FAS/P300 in_warenkorb''||to_char(-v_fehlernummer)||'']'','||unistr('\000a')||
'          v_prot_id,''INFO'',''FAS/P300 in_warenkorb'');'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(4326,:fas_sprache_id)||'' ''|| frgbg_s.holen_uebersetzung(9599,:fas_sprache_id);'||unistr('\000a')||
'   :p300_mengenart_id := NULL;'||unistr('\000a')||
'   :p300_rezept_nr := NULL;'||unistr('\000a')||
'   :P300_REZEPT_REICHWEITE := NULL;'||unistr('\000a')||
'   --RAISE_APPLI';

p:=p||'CATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   :P300_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'WHEN v_fehler_labor THEN'||unistr('\000a')||
'   MEL.P (v_fehlertext||'' [,FAS/P300 in_warenkorb''||to_char(-v_fehlernummer)||'']'','||unistr('\000a')||
'          v_prot_id,''INFO'',''FAS/P300 in_warenkorb'');'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(4326,:fas_sprache_id)||'' ''|| frgbg_s.holen_uebersetzung(10015,:fas_sprache_id);'||unistr('\000a')||
'   :p300_mengenart_id := NULL;'||unistr('\000a')||
'   :p';

p:=p||'300_rezept_nr := NULL;'||unistr('\000a')||
'   :P300_REZEPT_REICHWEITE := NULL;'||unistr('\000a')||
'   --RAISE_APPLICATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   :P300_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   MEL.P (v_fehlertext||'' [,FAS/P300 in_warenkorb''||to_char(-v_fehlernummer)||'']'','||unistr('\000a')||
'          v_prot_id,''ERROR'',''FAS/P300 in_warenkorb'');'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(4326,:fas_sprache_id);'||unistr('\000a')||
'   :p300_mengenart_id :';

p:=p||'= NULL;'||unistr('\000a')||
'   :p300_rezept_nr := NULL;'||unistr('\000a')||
'   :P300_REZEPT_REICHWEITE := NULL;'||unistr('\000a')||
'   --RAISE_APPLICATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   :P300_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   v_fehlertext := ''Artikel/Rezept konnte nicht in den Warenkorb gestellt werden!'' ;'||unistr('\000a')||
'   MEL.P (v_fehlertext||'' [,FAS/P300 in_warenkorb''||to_char(-99)||'']''||SQLERRM,'||unistr('\000a')||
'          v_prot_id,''ERROR'',''FAS/P300 in_warenkorb'')';

p:=p||';'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(4326,:fas_sprache_id);'||unistr('\000a')||
'   :p300_mengenart_id := NULL;'||unistr('\000a')||
'   :p300_rezept_nr := NULL;'||unistr('\000a')||
'   :P300_REZEPT_REICHWEITE := NULL;'||unistr('\000a')||
'   --RAISE_APPLICATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   :P300_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2170709324058321 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'in_warenkorb',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request =''WARENKORB''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Versandkosten einhängen'||unistr('\000a')||
'   v_return:= frgbg_s.wk_gen_versandkosten(:P300_WARENKORB_TMP_ID,1);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8536307761117161 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_versandkosten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>2135923640162310 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   mel.p(''102/300:test request:%1'',v_prot_id,''INFO'',''test'',:request);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2112315980124446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'test',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_text VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''In fehlerausgabe WK'',v_prot_id,''INFO'',''p300/fehlerausgabe'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
''||unistr('\000a')||
'   v_text := :P300_IN_WK_FEHLERTEXT;'||unistr('\000a')||
'   :P300_IN_WK_FEHLERTEXT := NULL;'||unistr('\000a')||
'   IF v_text is not null THEN'||unistr('\000a')||
'      htp.p(''alert("''||v_text||''");'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4528313772693115 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'in_wk_fehlermeldung_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''FEHLERAUSGABE'' '||unistr('\000a')||
'',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_identitaet_persstamm_id   personenstamm.id%TYPE;'||unistr('\000a')||
'   v_persstamm_id              personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fas_pers_schema_id        fas_schemas.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                varchar2(2000);'||unistr('\000a')||
'   v_prot_id                   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Diese Routine best. die aktive Identität, Kunden-Schema, Sortiment eines ausgewählten Kunden'||unistr('\000a')||
'   -- Persstamm_id kommt 5x vor'||unistr('\000a')||
'   v_pers';

p:=p||'stamm_id := :p300_persstamm_id;'||unistr('\000a')||
'   IF v_persstamm_id IS NULL THEN -- Patient muss vorhanden sein'||unistr('\000a')||
'       v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Bestimmen der aktiven Identität'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN   -- Aktive Identität ist immer bevorzugt betreuende Identität des Kunden bzw. '||unistr('\000a')||
'   ';

p:=p||'                                           -- falls nicht vorhanden betreuende Identität des Kunden '||unistr('\000a')||
'         /*'||unistr('\000a')||
'         v_identitaet_persstamm_id:=  '||unistr('\000a')||
'                     frgbg_s.get_identitaet_kunde(:fas_login_personenstamm_id,'||unistr('\000a')||
'                                            -1,'||unistr('\000a')||
'                                            v_persstamm_id);      '||unistr('\000a')||
'         */'||unistr('\000a')||
'         /* NEI 20.09.13: => Zukünftig wir';

p:=p||'d nur noch die bevorzugt betreuende Person des Kunden zur'||unistr('\000a')||
'                               aktive Identität egal ob der Betreuer Zugriff auf die Identität hat.'||unistr('\000a')||
'                               Er sieht den Kunden, vielleicht auch nur, weil er speziell Zugriff auf den Kunden hat, '||unistr('\000a')||
'                               da der Kunde von einer Idenität (Apo Richter) noch zusätzlich betreut wird, '||unistr('\000a')||
'               ';

p:=p||'                auf die der Betreuer auch Zugriff hat. D.h. der Betreuer hat nicht direkten Zugriff'||unistr('\000a')||
'                               auf die bevorzugt betreuende Identität und daher auf alle Kunden von dieser Identität, '||unistr('\000a')||
'                               sondern nur ein spezieller Kunde dieser bevorzugt betreuende Identität ist für den Betreuer bzw.'||unistr('\000a')||
'                               seiner zugreifbaren Id';

p:=p||'entitäten freigeschaltet.'||unistr('\000a')||
'         */'||unistr('\000a')||
'         v_identitaet_persstamm_id:=  '||unistr('\000a')||
'               frgbg_s.get_identitaet_kunde( NULL,'||unistr('\000a')||
'                                            -1,'||unistr('\000a')||
'                                            v_persstamm_id);'||unistr('\000a')||
'         IF v_identitaet_persstamm_id <= 0 OR '||unistr('\000a')||
'             v_identitaet_persstamm_id is NULL'||unistr('\000a')||
'         THEN '||unistr('\000a')||
'            :fas_identitaet := '''';'||unistr('\000a')||
'            :fas_id';

p:=p||'entitaet_persstamm_id := NULL;'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(3098,:fas_sprache_id);'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'            :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,'||unistr('\000a')||
'                                                          :F';

p:=p||'AS_SCHEMA_ID);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''ANONYM'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Betreuende Identitaet für Endkunden holen'||unistr('\000a')||
'       SELECT parameter'||unistr('\000a')||
'       INTO v_identitaet_persstamm_id'||unistr('\000a')||
'       FROM sysareas_frgbg'||unistr('\000a')||
'       WHERE id = 6;'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identitaet_na';

p:=p||'me(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''KUNDE'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Holen der Identitaet aus Pers_betreuer mit standard = J'||unistr('\000a')||
'       v_identitaet_persstamm_id := frgbg_s.GET_IDENTITAET_KUNDE(NULL,-1,v_persstamm_id);'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identi';

p:=p||'taet_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Schema-Id des Kunden setzen, abgeleitet aus der bevorzugt betreuenden Identitaet => wird beim Druck für die Auswahllistten von Kundensprache verwendet'||unistr('\000a')||
'   -- Schema der bevorzugt betreuenden Identitaet bestimmen '||unistr('\000a')||
'   v_fas_pers_schema_id := frgbg_s.get_fas_schema('||unistr('\000a')||
'         frgbg_s.get_identitaet_kunde(NULL,-1,v_persstamm_id),'||unistr('\000a')||
'   ';

p:=p||'       ''IDENTITAET'');'||unistr('\000a')||
'   IF v_fas_pers_schema_id <= 0 OR '||unistr('\000a')||
'      v_fas_pers_schema_id is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :fas_pers_schema_id := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3505,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_schema_id := v_fas_pers_schema_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Sortiment-ID der aktiven Identitaet '||unistr('\000a')||
'   -- NEI 14.02.2011 Sort';

p:=p||'imentseinfuehrung: sortiment_id statt preislisten_set_id      '||unistr('\000a')||
'   :FAS_SORTIMENT_ID:= rezepte.get_sortiment(:FAS_IDENTITAET_PERSSTAMM_ID,''IDENTITAET'');'||unistr('\000a')||
'   IF :FAS_SORTIMENT_ID <= 0 OR '||unistr('\000a')||
'      :FAS_SORTIMENT_ID is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :FAS_SORTIMENT_ID := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3518,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20004,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   /*';

p:=p||' Paramediform-Berechtigung setzen */'||unistr('\000a')||
'   :P300_std_mischartikel := frgbg_s.check_fas_rolle(:APP_USER,''PARAMEDIFORM'');'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''Bst. genereller Parameter Wahlident %1; Login-id %2; aktive Ident %3; Schema-kunde:%4, akt.Schema:%5,Sortiment:%6,Person:%7,artkat %8'', v_PROT_ID, ''TEST'', ''aktive_identitaet_pers_schema_sortiment_setzen'',:p110_wahl_identitaet,:fas_login_personenstamm_id,'||unistr('\000a')||
'v_identitaet_pers';

p:=p||'stamm_id,:fas_pers_schema_id,:fas_schema_id,:FAS_SORTIMENT_ID,v_persstamm_id,:P300_ARTIKELKATEGORIE);'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2591630994975403 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'aktive_identitaet_pers_schema_sortiment_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_gus_id     personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_anrede_id  personenstamm.anrede_id%TYPE;'||unistr('\000a')||
'   v_satzkennzeichen personenstamm.satzkennzeichen%TYPE;'||unistr('\000a')||
'   v_url        VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* Zukuenftig muessen die Identitaeten immer eine GUS-ID haben und dürfen nicht gelöscht sein */'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT gus_id,satzkennzeichen INTO v_gus_id,v_satzkennzeichen'||unistr('\000a')||
'   FROM p';

p:=p||'ersonenstamm'||unistr('\000a')||
'   WHERE id = :FAS_IDENTITAET_PERSSTAMM_ID;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_satzkennzeichen is not null THEN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(10179,:fas_sprache_id);'||unistr('\000a')||
'      v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':''||:P300_ZURUECK_SEITE||'':''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/';

p:=p||'javascript">'');'||unistr('\000a')||
'      htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'      apex_application.g_unrecoverable_error := true;   --- stops all further page processing      '||unistr('\000a')||
'   ELSIF v_gus_id IS NULL THEN'||unistr('\000a')||
'      --v_fehlertext := ''Wenn Sie die Warenkorb-Funktion nutzen wollen beantragen sie bitte einen Zugang bei Ihrem Kundenberater!'';'||unistr('\000a')||
'      v_fehlertext ';

p:=p||':= frgbg_s.holen_uebersetzung(5498,:fas_sprache_id);'||unistr('\000a')||
'      v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':''||:P300_ZURUECK_SEITE||'':''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
' ';

p:=p||'     apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'/*      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      --htp.p('||unistr('\000a')||
'      htp.p(''window.opener.location.href="f?p=&APP_ID.:130:&SESSION.";'');'||unistr('\000a')||
'      htp.p(''window.close(this);'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      --apex_application.stop_apex_engine;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 13.08.14 Anredetyp für den Kunden darf';

p:=p||' nicht Firma sein'||unistr('\000a')||
'   SELECT anrede_id INTO v_anrede_id'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :P300_PERSSTAMM_ID;'||unistr('\000a')||
'   IF v_anrede_id = 5 THEN -- Firma'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(10369,:fas_sprache_id);'||unistr('\000a')||
'      v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':''||:P300_ZURUECK_SEITE||'':''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'      h';

p:=p||'tp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'      apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8534601126311032 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 25,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_zugang',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz      NUMBER;'||unistr('\000a')||
'   v_prot_id  NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'-- Initialisierung, falls nicht vorgegeben=>  immer mit normalem WK'||unistr('\000a')||
'IF :p300_wk_artikeltyp_flag is NULL THEN'||unistr('\000a')||
'   :p300_wk_artikeltyp_flag := 2;  -- keine Laborartikel, nur sonstige Artikel und Mischungen'||unistr('\000a')||
'END IF;'||unistr('\000a')||
'RETURN;'||unistr('\000a')||
''||unistr('\000a')||
'/* WK wird nur noch als Labor oder Normaler WK aufgerufen von der Perssliste aus.Es wird nicht erst im WK festgelegt über ';

p:=p||'die bestellten Artikel'||unistr('\000a')||
'   -- Dieses Flag steuert, dass keine gemischten WK entstehen sondern nur WK mit Laborartikel oder'||unistr('\000a')||
'   -- WK mit nicht Laborartikel'||unistr('\000a')||
'   -- = 0 => Keine Artikel im WK'||unistr('\000a')||
'   -- = 1 => Laborartikel im WK => alle anderen Artikel-Kategorien und Rezept-Kategorie entfernen '||unistr('\000a')||
'   -- = 2 => Nicht Laborartikel oder Rezepte im WK => Laborartikel Artikelgruppe = 20 entfernen'||unistr('\000a')||
'   SELECT count(*)';

p:=p||' INTO v_anz'||unistr('\000a')||
'   FROM warenkorb_details_tmp '||unistr('\000a')||
'   WHERE warenkorb_tmp_id= :p300_warenkorb_tmp_id;'||unistr('\000a')||
'   IF v_anz > 0 THEN  -- Welche Art von Artikel'||unistr('\000a')||
'      SELECT count(*) INTO v_anz'||unistr('\000a')||
'      FROM warenkorb_details_tmp wkd'||unistr('\000a')||
'      WHERE wkd.warenkorb_tmp_id = :p300_warenkorb_tmp_id'||unistr('\000a')||
'        AND wkd.mengenart_id is not null'||unistr('\000a')||
'        AND wkd.mengenart_id in (SELECT id '||unistr('\000a')||
'                                 FROM mengena';

p:=p||'rts'||unistr('\000a')||
'                                 WHERE artgruppe_id = 20  -- Laborartikel '||unistr('\000a')||
'                                )'||unistr('\000a')||
'       ;'||unistr('\000a')||
'      IF v_anz > 0 THEN'||unistr('\000a')||
'         :p300_wk_artikeltyp_flag := 1;  -- Laborartikel'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p300_wk_artikeltyp_flag := 2;  -- keine Laborartikel, nur sonstige Artikel und Mischungen'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p300_wk_artikeltyp_flag := 0;  -- gar keine Artikel vorha';

p:=p||'nden'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4919414627617593 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 26,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_wk_artikeltyp_flag',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :P300_ARTIKELKATEGORIE := NVL( :P300_ARTIKELKATEGORIE,0);'||unistr('\000a')||
'   IF :p300_wk_artikeltyp_flag = 1 THEN -- Labor-WK'||unistr('\000a')||
'      :P300_ARTIKELKATEGORIE := 20;'||unistr('\000a')||
'   ELSE  -- normaler WK'||unistr('\000a')||
'      IF :P300_SUCHE IS NOT NULL THEN'||unistr('\000a')||
'         :P300_ARTIKELKATEGORIE := 0;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--MEL.P (''Switch kat ; artkat %1'', v_PROT_ID, ''TEST'', ''switch_artikelkategorie'',:P300_ART';

p:=p||'IKELKATEGORIE);'||unistr('\000a')||
''||unistr('\000a')||
'/* NEI 05.05.2014 '||unistr('\000a')||
'   IF :P300_SUCHE IS NOT NULL THEN'||unistr('\000a')||
'      :P300_ARTIKELKATEGORIE := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :P300_ARTIKELKATEGORIE != 20 AND :p300_sa_auftragsnummer is not null THEN'||unistr('\000a')||
'      :P300_ARTIKELKATEGORIE := 20;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :P300_ARTIKELKATEGORIE = 20 AND :p300_sa_auftragsnummer is  null THEN'||unistr('\000a')||
'      :P300_ARTIKELKATEGORIE := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5621428711755215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 28,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'switch_artikelkategorie',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_land_id                personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_VERRECH_LAND_ID        warenkoerbe.VERRECH_LAND_ID%TYPE;'||unistr('\000a')||
'   v_WAEHRUNG_ID            warenkoerbe.WAEHRUNG_ID%TYPE;'||unistr('\000a')||
'   v_MWST_JN                warenkoerbe.MWST_JN%TYPE;'||unistr('\000a')||
'   v_WK_STATUS_ID           warenkoerbe.WK_STATUS_ID%TYPE;'||unistr('\000a')||
'   v_STATUS_AENDERDATUM     warenkoerbe.STATUS_AENDERDATUM%TYPE;'||unistr('\000a')||
'   v_STATUS_AENDERVISUM     warenkoerb';

p:=p||'e.STATUS_AENDERVISUM%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_RECHNUNG  warenkoerbe.PERSSTAMM_ID_RECHNUNG%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_LOGIN     warenkoerbe.PERSSTAMM_ID_LOGIN%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_LIEFERUNG warenkoerbe.PERSSTAMM_ID_LIEFERUNG%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_prod_apo  warenkoerbe.PERSSTAMM_ID_prod_apo%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechsteller warenkoerbe.PERSSTAMM_ID_prod_apo%TYPE;'||unistr('\000a')||
'   v_extern_verwaltet       waren';

p:=p||'koerbe.extern_verwaltet%TYPE;'||unistr('\000a')||
'   v_preislistentyp       preislisten.typ%TYPE;'||unistr('\000a')||
'   v_preislisten_land_id  preislisten.land_id%TYPE;'||unistr('\000a')||
'   v_sortiment_id         sortimente.id%TYPE;   -- NEI 14.02.2011 Sortimentseinfuehrung:'||unistr('\000a')||
'                                                -- sortiment_id statt preislisten_set_id'||unistr('\000a')||
'   v_preisliste_id        preislisten.id%TYPE;'||unistr('\000a')||
'   v_art_mwst_typ_id      preislisten_details';

p:=p||'.art_mwst_typ_id%TYPE;'||unistr('\000a')||
'   v_preisfaktor          warenkoerbe.preisfaktor%TYPE;'||unistr('\000a')||
'   v_widerrufsfrist       warenkoerbe.widerrufsfrist%TYPE; -- NEI 28.03.12'||unistr('\000a')||
'   v_kassenabrechnung     warenkoerbe.kassenabrechnung%TYPE; -- NEI 26.09.2014 Flag für Labor'||unistr('\000a')||
''||unistr('\000a')||
'   v_url                  VARCHAR2(2000);'||unistr('\000a')||
'   v_sqlerror             VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlertext           VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id             ';

p:=p||'   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p300_warenkorb_tmp_id is null THEN'||unistr('\000a')||
'--mel.p(''In wk_aktualisieren init WK-ID %1'', v_prot_id,''Info'',''wk_init'',:p300_warenkorb_tmp_id);'||unistr('\000a')||
'      -- Warenkorb initialisieren'||unistr('\000a')||
'      select WARENKORB_tmp_SEQ.nextval into :p300_warenkorb_tmp_id from dual;'||unistr('\000a')||
''||unistr('\000a')||
'-- mel.p(''In wk_aktualisieren init nach holen WK-ID --%1'',v_prot_id,''Info'',''wk_aktualisieren'',:p300_warenkorb_tmp_id);'||unistr('\000a')||
''||unistr('\000a')||
'      -- De';

p:=p||'fault-Daten setzen'||unistr('\000a')||
'      IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'         -- Bestimmen Rechnungs-/Lieferadresse des Kunden'||unistr('\000a')||
'         -- Falls keine abweichende Lieferadr  kommen Werte für mwst_jn vom Kunde'||unistr('\000a')||
'         SELECT NVL(lief.mwst_jn,p.MWST_JN),'||unistr('\000a')||
'                NVL(p.PERSSTAMM_ID_RECHNUNG,:p300_persstamm_id),'||unistr('\000a')||
'                NVL(p.PERSSTAMM_ID_LIEFERUNG,:p300_persstamm_id),'||unistr('\000a')||
'                :f';

p:=p||'as_login_personenstamm_id'||unistr('\000a')||
'         INTO   v_MWST_JN,v_PERSSTAMM_ID_RECHNUNG,v_PERSSTAMM_ID_LIEFERUNG,v_persstamm_id_login'||unistr('\000a')||
'         FROM personenstamm p, personenstamm lief'||unistr('\000a')||
'         WHERE p.id = :p300_persstamm_id'||unistr('\000a')||
'          and p.PERSSTAMM_ID_LIEFERUNG = lief.id (+);'||unistr('\000a')||
''||unistr('\000a')||
'         -- Bestimmung prod. Apo'||unistr('\000a')||
'         v_persstamm_id_prod_apo := frgbg_s.get_pers_option(:APP_USER,21);'||unistr('\000a')||
''||unistr('\000a')||
'         -- Bestimmung ';

p:=p||'Rechnungssteller: Default prod. Apo'||unistr('\000a')||
'         v_persstamm_id_rechsteller := v_persstamm_id_prod_apo;'||unistr('\000a')||
''||unistr('\000a')||
'         -- Bestimmung Verrechnungsland'||unistr('\000a')||
'         -- Verrechnungsland_id wird gemaess Rechnungssteller bzw. Lieferadr vom Patient bestimmt'||unistr('\000a')||
'         v_verrech_land_id := rezepte.GET_VERRECHNUNGSLAND_ID('||unistr('\000a')||
'                                   v_PERSSTAMM_ID_LIEFERUNG, v_persstamm_id_rechsteller);'||unistr('\000a')||
'      EL';

p:=p||'SE  -- Endkunden-Login'||unistr('\000a')||
'         -- Bestimmen Rechnungs-/Lieferadresse des Kunden'||unistr('\000a')||
'         -- Falls keine abweichende Lieferadr  kommen Werte für mwst_jn vom Kunde'||unistr('\000a')||
'         SELECT NVL(lief.mwst_jn,p.MWST_JN), '||unistr('\000a')||
'                NVL(p.PERSSTAMM_ID_RECHNUNG,:p300_persstamm_id),'||unistr('\000a')||
'                NVL(p.PERSSTAMM_ID_LIEFERUNG,:p300_persstamm_id),   '||unistr('\000a')||
'                :fas_login_personenstamm_id'||unistr('\000a')||
'         INTO';

p:=p||'   v_MWST_JN, v_PERSSTAMM_ID_RECHNUNG,v_PERSSTAMM_ID_LIEFERUNG,v_persstamm_id_login'||unistr('\000a')||
'         FROM personenstamm p, personenstamm lief'||unistr('\000a')||
'         WHERE p.id = :p300_persstamm_id'||unistr('\000a')||
'          and p.PERSSTAMM_ID_LIEFERUNG = lief.id (+);'||unistr('\000a')||
''||unistr('\000a')||
'         -- Bestimmung prod. Apo'||unistr('\000a')||
'         v_persstamm_id_prod_apo := frgbg_s.get_pers_option(:APP_USER,21);'||unistr('\000a')||
''||unistr('\000a')||
'         -- Bestimmung Rechnungssteller: Default prod. Apo'||unistr('\000a')||
'  ';

p:=p||'       v_persstamm_id_rechsteller := v_persstamm_id_prod_apo;'||unistr('\000a')||
''||unistr('\000a')||
'         -- Bestimmung Verrechnungsland'||unistr('\000a')||
'         -- Verrechnungsland_id wird gemaess Rechnungssteller bzw. Lieferadr vom Patient bestimmt'||unistr('\000a')||
'         v_verrech_land_id := rezepte.GET_VERRECHNUNGSLAND_ID('||unistr('\000a')||
'                                  v_PERSSTAMM_ID_LIEFERUNG, v_persstamm_id_rechsteller);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      v_waehrung_id := rezepte.ge';

p:=p||'t_id_waehrung(v_verrech_land_id);'||unistr('\000a')||
'      -- Prüfe Existenz der passenden Preisliste; ggf. wird die Waehrung und das'||unistr('\000a')||
'      -- Verrechnungsland-ID,Typ  an die Standardpreisliste angepasst'||unistr('\000a')||
'      v_preislistentyp := rezepte.get_preislisten_typ (      -- NEI 06.05.13 Einfuehrung mit/ohne Mwst PL'||unistr('\000a')||
'                v_VERRECH_LAND_ID,'||unistr('\000a')||
'                v_persstamm_id_rechsteller,'||unistr('\000a')||
'                v_persstamm_id';

p:=p||'_prod_apo,'||unistr('\000a')||
'                :fas_identitaet_persstamm_id,'||unistr('\000a')||
'                :p300_persstamm_id,  -- Kunde'||unistr('\000a')||
'                v_persstamm_id_rechnung,'||unistr('\000a')||
'                v_persstamm_id_lieferung );'||unistr('\000a')||
''||unistr('\000a')||
'/*mel.p(''In wk_init waehrung %1, preisfaktor %2, login %3, identitaet %4,verrech %5,pl %6, mwsttyp %7'',v_prot_id,''Info'',''wk_init'',v_waehrung_id,v_preisfaktor ,v_PERSSTAMM_ID_LOGIN,:fas_identitaet_persstamm_id,v_';

p:=p||'verrech_land_id,v_preisliste_id,v_art_mwst_typ_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'      v_sortiment_id := NVL(v(''FAS_SORTIMENT_ID''),         -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                              rezepte.GET_SORTIMENT_STD);  -- Standard-Sortiment der oberste Ident.'||unistr('\000a')||
'      v_preisliste_id := rezepte.get_preisliste_id(v_waehrung_id,v_verrech_land_id,'||unistr('\000a')||
'                                                   v_preislis';

p:=p||'tentyp,v_sortiment_id); '||unistr('\000a')||
'      -- Art_mwst_typ_id für Mischungen ermitteln'||unistr('\000a')||
'      /* NEI 17.04.2015 Ermittlung über Funktion wg. Ausnahmeregelung EU-Export der ApoRichter'||unistr('\000a')||
'      SELECT min(art_mwst_typ_id) into v_art_mwst_typ_id'||unistr('\000a')||
'      FROM laender'||unistr('\000a')||
'      WHERE id = v_verrech_land_id; '||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_art_mwst_typ_id := rezepte.GET_ART_MWST_TYP_ID_MISCHUNG (v_verrech_land_id,v_persstamm_id_rechstelle';

p:=p||'r);'||unistr('\000a')||
''||unistr('\000a')||
'      -- Preisfaktor: !!! Bei Laboraufträgen ist der Preisfaktor auch immer 1, egal was bei der Identität oder beim Betreuer hinterlegt ist'||unistr('\000a')||
'      /* NEI 09.10.14 Preisfaktor für prod.Apo Hepart immer 1 auch für alle Laboraufträge unabhängig prod. Apo'||unistr('\000a')||
''||unistr('\000a')||
'      v_preisfaktor := to_number(frgbg_s.get_pers_option(NULL,23,'||unistr('\000a')||
'                           :fas_identitaet_persstamm_id,v_PERSSTAMM_ID_LOGIN)';

p:=p||',''FM0.0999'');'||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_preisfaktor := frgbg_s.WK_GET_PREISFAKTOR (v_PERSSTAMM_ID_LOGIN,         -- Betreuer'||unistr('\000a')||
'                                                   :fas_identitaet_persstamm_id, -- Ident'||unistr('\000a')||
'                                                   v_persstamm_id_prod_apo );    -- Prod Apo'||unistr('\000a')||
'      -- NEI 26.09.2014 Flag für Labor'||unistr('\000a')||
'      IF :P300_WK_ARTIKELTYP_FLAG = 1 THEN -- Laborauftrag kas';

p:=p||'senabrechnung Default=0'||unistr('\000a')||
'         v_kassenabrechnung := 0;'||unistr('\000a')||
'         v_preisfaktor := 1;    -- NEI 09.10.14 für Labor immer 1'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      v_widerrufsfrist := frgbg_s.wk_get_widerrufsfrist;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'mel.p(''In wk_init waehrung %1, preisfaktor %2, login %3, identitaet %4,verrech %5,pl %6, mwsttyp %7'',v_prot_id,''Info'',''wk_init'',v_waehrung_id,v_preisfaktor ,v_PERSSTAMM_ID_LOGIN,:fas_identitaet_persst';

p:=p||'amm_id,v_verrech_land_id,v_preisliste_id,v_art_mwst_typ_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'      INSERT INTO warenkoerbe_tmp ('||unistr('\000a')||
'                    ID ,'||unistr('\000a')||
'                    PLANDATUM ,'||unistr('\000a')||
'                    VERRECH_LAND_ID,'||unistr('\000a')||
'                    WAEHRUNG_ID,'||unistr('\000a')||
'                    MWST_JN ,'||unistr('\000a')||
'                    WK_STATUS_ID ,'||unistr('\000a')||
'                    STATUS_AENDERDATUM ,'||unistr('\000a')||
'                    STATUS_AENDERVISUM,'||unistr('\000a')||
'                    PERSST';

p:=p||'AMM_ID_RECHNUNG,'||unistr('\000a')||
'                    PERSSTAMM_ID_LOGIN,'||unistr('\000a')||
'                    PERSSTAMM_ID_LIEFERUNG ,'||unistr('\000a')||
'                    session_id,'||unistr('\000a')||
'                    persstamm_id_identitaet,'||unistr('\000a')||
'                    persstamm_id_prod_apo,'||unistr('\000a')||
'                    preisliste_id,            -- NEI 15.10.09'||unistr('\000a')||
'                    art_mwst_typ_id,          -- NEI 30.11.09 Artikel-MWST-Umstellung'||unistr('\000a')||
'                    preisfakto';

p:=p||'r               -- NEI 03.12.09'||unistr('\000a')||
'                    ,persstamm_id_kunde       -- NEI 14.01.11'||unistr('\000a')||
'                    ,sortiment_id             -- NEI 09.06.11'||unistr('\000a')||
'                    ,persstamm_id_rechnungssteller -- NEI 08.03.2012 neue Verrechnungslandbst'||unistr('\000a')||
'                    ,widerrufsfrist           -- NEI 28.03.12'||unistr('\000a')||
'                    ,kassenabrechnung         -- NEI 26.09.2014 Flag für Labor'||unistr('\000a')||
'         ';

p:=p||'           )'||unistr('\000a')||
'      VALUES (:p300_warenkorb_tmp_id,'||unistr('\000a')||
'              to_date(to_char(sysdate,''DD.MM.YYYY''),''DD.MM.YYYY''),'||unistr('\000a')||
'              v_VERRECH_LAND_ID       ,'||unistr('\000a')||
'              v_WAEHRUNG_ID            ,'||unistr('\000a')||
'              v_MWST_JN                ,'||unistr('\000a')||
'              10           ,'||unistr('\000a')||
'              sysdate     ,'||unistr('\000a')||
'              :app_user    ,'||unistr('\000a')||
'              v_PERSSTAMM_ID_RECHNUNG  ,'||unistr('\000a')||
'              v_PERSSTAMM_ID_LOGI';

p:=p||'N     ,'||unistr('\000a')||
'              v_PERSSTAMM_ID_LIEFERUNG,'||unistr('\000a')||
'              :APP_SESSION,'||unistr('\000a')||
'              :fas_identitaet_persstamm_id,'||unistr('\000a')||
'              v_persstamm_id_prod_apo,'||unistr('\000a')||
'              v_preisliste_id,            -- NEI 15.10.09'||unistr('\000a')||
'              v_art_mwst_typ_id,          -- NEI 30.11.09 Artikel-MWST-Umstellung'||unistr('\000a')||
'              v_preisfaktor               -- NEI 03.12.09'||unistr('\000a')||
'              ,:p300_persstamm_id         -';

p:=p||'- NEI 14.01.11'||unistr('\000a')||
'              ,v_sortiment_id             -- NEI 09.06.11'||unistr('\000a')||
'              ,v_persstamm_id_rechsteller -- NEI 08.03.2012'||unistr('\000a')||
'              ,v_widerrufsfrist           -- NEI 28.03.12'||unistr('\000a')||
'              ,v_kassenabrechnung         -- NEI 26.09.2014 Flag für Labor'||unistr('\000a')||
'             ); '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p300_id:=:p300_warenkorb_tmp_id;'||unistr('\000a')||
'   :p300_flag_hide_show:= -1;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Setzen Extern_verwaltet FLAG'||unistr('\000a')||
'   ';

p:=p||'IF :P300_WK_ARTIKELTYP_FLAG = 1 THEN -- Laborauftrag nie ins GUS => Übergangslösung'||unistr('\000a')||
'      v_extern_verwaltet := 0;'||unistr('\000a')||
'   ELSE  -- Alle andere WK gemäss Regel'||unistr('\000a')||
'      v_extern_verwaltet := frgbg_s.wk_check_extern_verwaltet(:p300_warenkorb_tmp_id,1);'||unistr('\000a')||
'--mel.p(''Extern verwaltete %1'',v_prot_id,''TEST'',''wk_init'',v_extern_verwaltet);'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
'   IF v_extern_verwaltet >=0 THEN'||unistr('\000a')||
'         UPDATE warenkoerbe_t';

p:=p||'mp'||unistr('\000a')||
'         SET extern_verwaltet = v_extern_verwaltet'||unistr('\000a')||
'         WHERE id = :p300_warenkorb_tmp_id;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Fehler beim Bestimmen des WK auf extern/intern verwaltet!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''In wk_aktualisieren init WK-ID ENDE %1'', v_prot_id,''Info'',''wk_init'',:p300_warenkorb_tmp_id);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   v_sqlerror:= SQLERRM;'||unistr('\000a')||
'   v_fehlertext := frgbg_s.h';

p:=p||'olen_uebersetzung(5499,:fas_sprache_id);'||unistr('\000a')||
'   v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':''||:P300_ZURUECK_SEITE||'':''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   mel.p(v_fehlertext||''(SQL: ''';

p:=p||'||v_sqlerror||'')'',v_prot_id,''ERROR'',''102/300:wk_init'');'||unistr('\000a')||
'   apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4522211482183637 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'wk_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p300_warenkorb_tmp_id is null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_labor_id_def        labors.id%TYPE;'||unistr('\000a')||
'   v_anz                 number;'||unistr('\000a')||
'   v_sprache_id          number := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id             number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p300_labor_mit_fb = 0 THEN   -- NEI 13.10.14 Laborauftrag ohne FB-Bezug'||unistr('\000a')||
'      :p300_pergebnis_id := NULL;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Hole die letzte noch nicht ausgewertete pergebnis_id, falls möglich'||unistr('\000a')||
'      IF :p300_pergebnis_id I';

p:=p||'S NULL '||unistr('\000a')||
'      THEN -- erstmals bestimmen'||unistr('\000a')||
'         select max(id) into :p300_pergebnis_id'||unistr('\000a')||
'         from pergebnisse p'||unistr('\000a')||
'         where /* hoechste Version eines FB ohne Auswertung muss vorhanden sein */'||unistr('\000a')||
'               p.persstamm_id = :p300_persstamm_id -- Nur FB des Kunden'||unistr('\000a')||
'           and p.id is not null'||unistr('\000a')||
'           and p.versions_id = frgbg_s.GET_FB_MAX_VERSION(p.fragebogen_id,p.persstamm_id) -- hoe';

p:=p||'chste Version'||unistr('\000a')||
'           and frgbg_s.FB_CHECK_AUSWERTUNG(p.id)= 0'||unistr('\000a')||
'           --and p.fragebogen_id = 5 ; -- zZ. nur MNR relevant -- NEI 13.10.14 Laborauftrag ohne FB-Bezug'||unistr('\000a')||
'           and p.fragebogen_id = :p300_labor_mit_fb;           -- NEI 13.10.14 Laborauftrag ohne FB-Bezug'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Falls nur 1 relevantes Labor in Betracht kommt, dieses vorbelegen'||unistr('\000a')||
'   IF :p300_labor_id is ';

p:=p||'NULL THEN'||unistr('\000a')||
'      SELECT count(*),min(id) into v_anz, v_labor_id_def'||unistr('\000a')||
'      from labors'||unistr('\000a')||
'      where satz_kennzeichen is null'||unistr('\000a')||
'        AND '||unistr('\000a')||
'       ('||unistr('\000a')||
'            FKATEGORIE_MODUL_ID in (SELECT fkat_modul_id '||unistr('\000a')||
'                                    from PERGEBNIS_MODUL_AUSWAHL '||unistr('\000a')||
'                                    where pergebnis_id = :p300_pergebnis_id'||unistr('\000a')||
'                                      and satz_kennzeich';

p:=p||'en is null'||unistr('\000a')||
'                                   )'||unistr('\000a')||
'            AND :p300_labor_mit_fb > 0'||unistr('\000a')||
'        OR '||unistr('\000a')||
'        -- NEI 13.10.14 Laboraufträge ohne FB-Bezug'||unistr('\000a')||
'        -- Nur Labor mit auf der Basis der neue Labortabs möglich, da die Normierungen geliefert werden müssen'||unistr('\000a')||
'        :p300_labor_mit_fb = 0 and FKATEGORIE_MODUL_ID=4  '||unistr('\000a')||
'      );'||unistr('\000a')||
'      IF v_anz = 1 THEN'||unistr('\000a')||
'         :p300_labor_id := v_labor_id_def;'||unistr('\000a')||
'   ';

p:=p||'   END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   IF  :p300_labor_id is not NULL and :P300_auftrag_id_intern is null THEN'||unistr('\000a')||
'      -- Ist ggf. eine pflichte Labor-Auftragsnummer bei externer Vergabe eingegeben?'||unistr('\000a')||
'      SELECT min(auftrag_id_intern) into :P300_auftrag_id_intern'||unistr('\000a')||
'      FROM labors'||unistr('\000a')||
'      WHERE id = :p300_labor_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8328422422046412 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 35,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_labor_info',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p300_wk_artikeltyp_flag = 1 and :p300_labor_mit_fb >= 0'||unistr('\000a')||
' ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'    v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P300_WK_ARTIKELTYP_FLAG = 1 THEN -- Labor-Wk'||unistr('\000a')||
'--mel.p(''perg %1, fb %2'', v_prot_id,''TEST'',''102/300 set_hinweisinfo_artikelliste'',:p300_pergebnis_id,:p300_labor_mit_fb);'||unistr('\000a')||
'      IF :p300_labor_mit_fb is NULL THEN  -- Zuerst FB-Auswahl treffen oder kein FB! '||unistr('\000a')||
'         :P300_MELDUNG_ARTSUCHE:=frgbg_s.holen_uebersetzung(11244,:fas_sprache_id);'||unistr('\000a')||
'         RETURN; -- ';

p:=p||'Meldung anzeigen nach Anzeige der Artikelliste, falls keine Datensätze vorhanden sind'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      IF :p300_pergebnis_id is null AND :p300_labor_mit_fb > 0 THEN  -- Zuerst ein aktiver FB erzeugen!'||unistr('\000a')||
'         :P300_MELDUNG_ARTSUCHE:= frgbg_s.holen_uebersetzung(8322,:fas_sprache_id);'||unistr('\000a')||
'         RETURN; -- Meldung anzeigen nach Anzeige der Artikelliste, falls keine Datensätze vorhanden sind'||unistr('\000a')||
'     ';

p:=p||' END IF;'||unistr('\000a')||
'      -- Ist Labor bereits ausgewählt?'||unistr('\000a')||
'      IF :p300_labor_id is NULL THEN'||unistr('\000a')||
'         :P300_MELDUNG_ARTSUCHE:= ''Bitte ein zuständiges Labor auswählen!'';'||unistr('\000a')||
'         RETURN; -- Meldung anzeigen nach Anzeige der Artikelliste, falls keine Datensätze vorhanden sind'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF :P300_auftrag_id_intern = 0 AND :P300_SA_AUFTRAGSNUMMER is NULL THEN -- externe Auftragsnummer z.B. SA => Eing';

p:=p||'abe pflichtig'||unistr('\000a')||
'         :P300_MELDUNG_ARTSUCHE:= frgbg_s.holen_uebersetzung(8321,:fas_sprache_id); --''Zuerst SA-Auftragsnummer eingeben!'';'||unistr('\000a')||
'         RETURN; -- Meldung anzeigen nach Anzeige der Artikelliste, falls keine Datensätze vorhanden sind      '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      -- Keine Artikel vorhanden: Im Labor muss es immer Artikel geben, da immer die Laborkategorie voreingestellt ist und auch nur in d';

p:=p||'ieser gesucht wird'||unistr('\000a')||
'      :P300_MELDUNG_ARTSUCHE:=frgbg_s.holen_uebersetzung(10001,:fas_sprache_id);'||unistr('\000a')||
'   ELSE -- normaler WK'||unistr('\000a')||
'      -- Info im normalen WK initialisieren'||unistr('\000a')||
'      IF :P300_suche is null and :P300_ARTIKELKATEGORIE = 0 THEN'||unistr('\000a')||
'         --Suchbed. od. Kategorie wählen '||unistr('\000a')||
'         :P300_MELDUNG_ARTSUCHE:=frgbg_s.holen_uebersetzung(5443,:fas_sprache_id);'||unistr('\000a')||
'      ELSE -- keine Artikel gefunden  '||unistr('\000a')||
'    ';

p:=p||'     :P300_MELDUNG_ARTSUCHE:=frgbg_s.holen_uebersetzung(10001,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8413119892081456 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 36,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_hinweisinfo_artikelliste',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_name   VARCHAR2(1000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P300_PERSSTAMM_ID is not null  THEN'||unistr('\000a')||
'      SELECT NAME||'' ''||VORNAME ||'' ''||to_char(GEBURTSDATUM,''DD.MM.RRRR''), gewicht, groesse'||unistr('\000a')||
'      INTO v_name, :p300_gewicht, :p300_groesse'||unistr('\000a')||
'      from personenstamm'||unistr('\000a')||
'      where id = :P300_PERSSTAMM_ID;'||unistr('\000a')||
'      :p300_name := v_name;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2551215411355015 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_person',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   DELETE FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id =  :p300_warenkorb_tmp_id'||unistr('\000a')||
'     AND mengenart_id = 101;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7857405943089656 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 65,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'delete_versandkosten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_waehrung_id          warenkoerbe_tmp.waehrung_id%TYPE;'||unistr('\000a')||
'   v_liefer_land_id       laender.id%TYPE;'||unistr('\000a')||
'   v_verrech_land_id      warenkoerbe_tmp.verrech_land_id%TYPE;'||unistr('\000a')||
'   v_preislistentyp       preislisten.typ%TYPE;'||unistr('\000a')||
'   v_preislisten_land_id  preislisten.land_id%TYPE;'||unistr('\000a')||
'   v_sortiment_id         sortimente.id%TYPE; -- NEI 14.02.2011 Sortimentseinfuehrung: '||unistr('\000a')||
'                                     ';

p:=p||'         -- sortiment_id statt preislisten_set_id'||unistr('\000a')||
'   v_preisliste_id        preislisten.id%TYPE;'||unistr('\000a')||
'   v_art_mwst_typ_id      preislisten_details.art_mwst_typ_id%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechsteller personenstamm.id%type;'||unistr('\000a')||
'   v_persstamm_id_lieferung   personenstamm.id%type;'||unistr('\000a')||
'   v_verrech_land_id_db       warenkoerbe_tmp.verrech_land_id%TYPE;'||unistr('\000a')||
'   v_waehrung_id_db           warenkoerbe_tmp.waehrung_id%TYP';

p:=p||'E;'||unistr('\000a')||
'   v_preisliste_id_db         warenkoerbe_tmp.preisliste_id%TYPE;      '||unistr('\000a')||
'   v_persstamm_id_prod_apo    warenkoerbe_tmp.persstamm_id_prod_apo%TYPE;'||unistr('\000a')||
'   v_persstamm_id_identitaet  warenkoerbe_tmp.persstamm_id_identitaet%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechnung    warenkoerbe_tmp.persstamm_id_rechnung%TYPE;'||unistr('\000a')||
'   v_persstamm_id_kunde       warenkoerbe_tmp.persstamm_id_kunde%TYPE;'||unistr('\000a')||
'   v_aerztlich_verordnet      ';

p:=p||'warenkoerbe_tmp.aerztlich_verordnet%TYPE;'||unistr('\000a')||
'   v_anz                      NUMBER;'||unistr('\000a')||
''||unistr('\000a')||
'   v_fehler            exception;'||unistr('\000a')||
'   v_return            NUMBER;'||unistr('\000a')||
'   v_prot_id           NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*MEL.P (''vor check_waerhung:MaskeWaehr %1,MaskeVerrech %2,WK_tmp_id %3, %4, %5, %6, %7'','||unistr('\000a')||
'           v_prot_id,''Info'',''change_waehrung 102/300'','||unistr('\000a')||
'          :p300_waehrung_id,:P300_VERRECH_LAND_ID,'||unistr('\000a')||
'          :p300_waren';

p:=p||'korb_tmp_id);   '||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :p300_warenkorb_tmp_id is not null THEN'||unistr('\000a')||
'      -- Prüfen, ob die angezeigte Währung noch die aktuell gültige ist'||unistr('\000a')||
'      -- Verrechnungsland bestimmen und entsprechende Währung holen'||unistr('\000a')||
'      --SELECT NVL(min(land_id),198), into v_liefer_land_id'||unistr('\000a')||
'      SELECT persstamm_id_lieferung, persstamm_id_rechnungssteller,verrech_land_id,waehrung_id, '||unistr('\000a')||
'             persstamm_id_prod_apo,pe';

p:=p||'rsstamm_id_identitaet,persstamm_id_rechnung,v_persstamm_id_kunde,preisliste_id,aerztlich_verordnet'||unistr('\000a')||
'      INTO v_persstamm_id_lieferung,v_persstamm_id_rechsteller,v_verrech_land_id_db,v_waehrung_id_db,'||unistr('\000a')||
'             v_persstamm_id_prod_apo,v_persstamm_id_identitaet,v_persstamm_id_rechnung,v_persstamm_id_kunde,v_preisliste_id_db,v_aerztlich_verordnet'||unistr('\000a')||
'      FROM warenkoerbe_tmp wk'||unistr('\000a')||
'      WHERE wk.id = ';

p:=p||':p300_warenkorb_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'      v_verrech_land_id := rezepte.get_verrechnungsland_id '||unistr('\000a')||
'                            (v_persstamm_id_lieferung,v_persstamm_id_rechsteller);'||unistr('\000a')||
''||unistr('\000a')||
'      -- NEI 13.06.13 Falls es sich um einen reinen Laboranalysen handelt soll das Verrechnungsland immer CH sein => Diese Dienstleistungen die CH-Preise und Mwst '||unistr('\000a')||
'      IF :p300_sa_auftragsnummer is not null THEN  -- Laboranalysea';

p:=p||'uftrag'||unistr('\000a')||
'         v_verrech_land_id := 198;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      v_waehrung_id := rezepte.get_id_waehrung(v_verrech_land_id);'||unistr('\000a')||
''||unistr('\000a')||
'      -- Prüfe Existenz der passenden Preisliste; ggf. wird die Waehrung und das'||unistr('\000a')||
'      -- Verrechnungsland-ID,Typ  an die Standardpreisliste angepasst'||unistr('\000a')||
'      v_preislistentyp := rezepte.get_preislisten_typ (      -- NEI 06.05.13 Einfuehrung mit/ohne Mwst PL'||unistr('\000a')||
'                v_';

p:=p||'VERRECH_LAND_ID,'||unistr('\000a')||
'                v_persstamm_id_rechsteller,'||unistr('\000a')||
'                v_persstamm_id_prod_apo,'||unistr('\000a')||
'                v_persstamm_id_identitaet,'||unistr('\000a')||
'                v_persstamm_id_kunde,'||unistr('\000a')||
'                v_persstamm_id_rechnung,'||unistr('\000a')||
'                v_persstamm_id_lieferung );'||unistr('\000a')||
''||unistr('\000a')||
'      v_sortiment_id := NVL(v(''FAS_SORTIMENT_ID''),         -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                              re';

p:=p||'zepte.GET_SORTIMENT_STD);  -- Standard-Sortiment der oberste Ident.'||unistr('\000a')||
'      v_preisliste_id := rezepte.get_preisliste_id(v_waehrung_id,v_verrech_land_id,'||unistr('\000a')||
'                                                   v_preislistentyp,v_sortiment_id); '||unistr('\000a')||
'      -- Art_mwst_typ_id für Mischungen ermitteln'||unistr('\000a')||
'      /* NEI 17.04.2015 Ermittlung über Funktion wg. Ausnahmeregelung EU-Export der ApoRichter      '||unistr('\000a')||
'      SELEC';

p:=p||'T min(art_mwst_typ_id) into v_art_mwst_typ_id'||unistr('\000a')||
'      FROM laender'||unistr('\000a')||
'      WHERE id = v_verrech_land_id; '||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_art_mwst_typ_id := rezepte.GET_ART_MWST_TYP_ID_MISCHUNG (v_verrech_land_id,v_persstamm_id_rechsteller);'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''check_waerhung nach holen :Waehrneu %1,Verrechneu %2,WK_tmp_id %3, Waehralt %4, verrechalt %5, %6, %7'','||unistr('\000a')||
'           v_prot_id,''Info'',''change_waehrung 102/300'','||unistr('\000a')||
'       ';

p:=p||'   v_waehrung_id,v_verrech_land_id,'||unistr('\000a')||
'          :p300_warenkorb_tmp_id,v_waehrung_id_db,v_verrech_land_id_db);   '||unistr('\000a')||
'*/'||unistr('\000a')||
'      -- Pruefen, ob details vorhanden sind, falls keine Details, dann aerztlich_verordnet = 0'||unistr('\000a')||
'      SELECT count(*) INTO v_anz'||unistr('\000a')||
'      from warenkorb_details_tmp wkd'||unistr('\000a')||
'      where wkd.warenkorb_tmp_id = :p300_warenkorb_tmp_id;'||unistr('\000a')||
'      IF v_anz = 0 THEN'||unistr('\000a')||
'         :p300_aerztlich_verordnet :=';

p:=p||' 0;  '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Änderung feststellen'||unistr('\000a')||
'      IF v_verrech_land_id != v_verrech_land_id_db OR'||unistr('\000a')||
'         v_waehrung_id != v_waehrung_id_db OR'||unistr('\000a')||
'         v_preisliste_id != v_preisliste_id_db or'||unistr('\000a')||
'         v_aerztlich_verordnet != :p300_aerztlich_verordnet'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         -- Warenkorb bzgl. Währung aktualisieren'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET  waehrung_id = v_waehrung_id,'||unistr('\000a')||
'   ';

p:=p||'           verrech_land_id = v_verrech_land_id,'||unistr('\000a')||
'              preisliste_id  = v_preisliste_id,'||unistr('\000a')||
'              art_mwst_typ_id = v_art_mwst_typ_id,'||unistr('\000a')||
'              aerztlich_verordnet = :p300_aerztlich_verordnet'||unistr('\000a')||
'         WHERE id = :p300_warenkorb_tmp_id;'||unistr('\000a')||
'         -- Details gemäss neuer Währung berechnen'||unistr('\000a')||
'         v_return := frgbg_s.wk_calc_details(:p300_warenkorb_tmp_id,1,1,'||unistr('\000a')||
'                       ';

p:=p||'                      1   -- NEI 18.06.14 Reichweitenstaffel-Rabattberechnung (=1) für Mischungen,'||unistr('\000a')||
'                                                 --              nur  noch im WK und auf Bestellschein sonst keine Rabattrechnung'||unistr('\000a')||
'                                             );'||unistr('\000a')||
'         IF v_return < 0 THEN'||unistr('\000a')||
'            NULL;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''check_waerhung toggle';

p:=p||':Mwsttyp %1, waehralt %2, maskeverrech %3, verrechneu%4, waehrneu%5, Return %6, PL:%7'','||unistr('\000a')||
'           v_prot_id,''Info'',''change_waehrung 102/300'','||unistr('\000a')||
'           v_art_mwst_typ_id,:p300_waehrung_id,:p300_verrech_land_id, v_verrech_land_id,     '||unistr('\000a')||
'           v_waehrung_id,v_return,v_preisliste_id); '||unistr('\000a')||
'*/           '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4523428563396764 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_waehrung_neu',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:WARENKOERBE_TMP:P300_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 2331309283642678 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 80,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from WARENKOERBE_TMP',
  p_process_sql_clob => p,
  p_process_error_message=> 'fehler in row select #SQLERRM# &P300_WARENKORB_TMP_ID.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p300_warenkorb_tmp_id is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p300_gesamtwert := to_char('||unistr('\000a')||
'NVL(to_number(:p300_gesamtpreis,''999G999G999G999G990D00''),0) + '||unistr('\000a')||
'NVL(to_number(:p300_mwst_betrag_1,''999G999G999G999G990D00''),0)+ '||unistr('\000a')||
'NVL(to_number(:p300_mwst_betrag_2,''999G999G999G999G990D00''),0),''999G999G999G999G990D00'') ;';

wwv_flow_api.create_page_process(
  p_id     => 4188415081985783 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 90,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_wk_gesamtwert',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_url                       varchar2(2000);'||unistr('\000a')||
'   v_fehlertext                uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_return                    NUMBER;'||unistr('\000a')||
'   v_prot_id                   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Adressprüfung'||unistr('\000a')||
'      v_return := frgbg_s.WK_CHECK_ADR_KOMPATIBEL(p_persstamm_id_prod_apo => :P300_PERSSTAMM_ID_prod_apo,'||unistr('\000a')||
'                                               p_persstamm_id_kunde    => :P30';

p:=p||'0_PERSSTAMM_ID,'||unistr('\000a')||
'                                               p_persstamm_id_lieferung=> :P300_PERSSTAMM_ID_LIEFERUNG,'||unistr('\000a')||
'                                               p_persstamm_id_rechnung => :P300_PERSSTAMM_ID_RECHNUNG,'||unistr('\000a')||
'                                               p_warenkorb_tmp_id      => :P300_ID,  -- NEI 05.06.2014'||unistr('\000a')||
'                                               p_sprache_id            => ';

p:=p||':fas_sprache_id ,'||unistr('\000a')||
'                                               p_fehlertext_out        => v_fehlertext'||unistr('\000a')||
'                                             );'||unistr('\000a')||
'        '||unistr('\000a')||
'      IF v_return < 0 THEN   -- Hinweismeldung; die eigentliche scharfe Prüfung findet im WK statt'||unistr('\000a')||
'         IF v_fehlertext is NOT NULL THEN'||unistr('\000a')||
'            --''Die Lieferadresse muss auch in der Schweiz liegen, da die Kunden-/ die Rechnungsad';

p:=p||'resse in der Schweiz liegt!'''||unistr('\000a')||
'            v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':''||:P300_ZURUECK_SEITE||'':''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'            htp.p(''<body>'');'||unistr('\000a')||
'            htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'            htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'            htp.p(''</script>'');'||unistr('\000a')||
'            htp.p(''';

p:=p||'</body>'');'||unistr('\000a')||
'            apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'         END IF; '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7867719610442368 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 110,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_adressen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Staffelgruppe bestimmen '||unistr('\000a')||
'   -- :p300_staffelgruppe_id := frgbg_s.GET_PERS_OPTION(NULL,42 ,:p300_PERSSTAMM_ID_PROD_APO,:p300_PERSSTAMM_ID); -- NEI 30.05.14 über die prod. Apo. der Identität'||unistr('\000a')||
'   -- Hier hat die Staffelgruppe der aktiven Ident Vorrang vor der Identhierarchie ab Prod-Apo'||unistr('\000a')||
'   :p300_staffelgruppe_id := frgbg_s.GET_PERS_OPTION(NULL,42 ,:p300_PERSSTA';

p:=p||'MM_ID_PROD_APO,:FAS_IDENTITAET_PERSSTAMM_ID);  '||unistr('\000a')||
'--mel.p(''Staffelgr upp %1, apo %2, kunde %3'', v_prot_id, ''TEST'',''102/300:get_wk_staffelgruppe_id'',:p300_staffelgruppe_id, :p300_PERSSTAMM_ID_PROD_APO,:p300_PERSSTAMM_ID);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8853732437324962 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 300,
  p_process_sequence=> 120,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_wk_staffelgruppe_id',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 300
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2245116284111509 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2245203666111515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'ID_DISPLAY',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2245306354111515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'WARENKORB_TMP_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2245400951111515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'PRODKENNZ_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2245525037111515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'P_REZEPT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2245622420111515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'MENGENART_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2245728490111515 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 7,
  p_query_column_name=> 'MENGE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18626912798416251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 8,
  p_query_column_name=> 'BEMERKUNG',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2247230468111516 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 9,
  p_query_column_name=> 'REZEPT_NR',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2247304764111516 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 10,
  p_query_column_name=> 'KUERZEL',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2247400184111516 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 11,
  p_query_column_name=> 'EINZELPREIS_BRUTTO',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2247520856111516 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 12,
  p_query_column_name=> 'GESAMTPREIS_BRUTTO',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2247630739111516 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 13,
  p_query_column_name=> 'VERORD_LINK',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2247718725111516 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 14,
  p_query_column_name=> 'DEL_ICON',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 2247815538111516 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 15,
  p_query_column_name=> 'REICHWEITE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18635709509930977 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 16,
  p_query_column_name=> 'REZEPT_NR_SPLITBASIS',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18635817374930977 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 2299322867733587 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 17,
  p_query_column_name=> 'VERSION_SPLITBASIS',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00301
prompt  ...PAGE 301: Adressliste
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 301
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Adressliste'
 ,p_step_title => 'Adressliste'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Adressliste'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150306110100'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2362603949581481 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 301,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_aufgerufen_von = ''BETREUER''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT distinct '||unistr('\000a')||
'  p.SUCHNAME, p.SUCHADRESSE, p.SUCHZUSATZ,'||unistr('\000a')||
'  p.PERSONENSTAMM_ID, '||unistr('\000a')||
'CASE'||unistr('\000a')||
'  /* Link löschen */'||unistr('\000a')||
'  WHEN  p.PERSONENSTAMM_ID_MASTER = p.PERSONENSTAMM_ID OR  '||unistr('\000a')||
'        p.PERSONENSTAMM_ID_MASTER is null OR'||unistr('\000a')||
'        frgbg_T.check_pers_extern_verwaltet(p1.EXTERN_VERWALTET ) = 1 -- extern verwaltete Adresse => readonly Adresse'||unistr('\000a')||
'  THEN'||unistr('\000a')||
'     '' ''  /* Löschen nicht erlaubt */'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'      ''<a href=';

s:=s||'"'''||unistr('\000a')||
'||apex_util.prepare_url(''f?p=&APP_ID.:301:&SESSION.::&DEBUG.::'''||unistr('\000a')||
'||''P301_PERSSTAMM_ID_DELETE:'''||unistr('\000a')||
'||to_char(p.PERSONENSTAMM_ID))'||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#FNDCANCE.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'END LINK_LOESCHEN,'||unistr('\000a')||
'CASE'||unistr('\000a')||
'  /* Link bearbeiten */'||unistr('\000a')||
'  WHEN p.aenderbar = ''J'''||unistr('\000a')||
'  THEN ''<a href="'''||unistr('\000a')||
'||apex_util.prepare_url(''f?p=&APP_ID.:302:&SESSION.::&DEBUG.::'''||unistr('\000a')||
'||''P302_ID,P302_ADRESSTYP,P302_ZURUECK_SEITE,P302_CALL';

s:=s||'ING_PAGE:'''||unistr('\000a')||
'||to_char(p.PERSONENSTAMM_ID)||'',''||:P301_ADRESSTYP||'',''||:P301_ZURUECK_SEITE||'',301'')'||unistr('\000a')||
'--||to_char(p.PERSONENSTAMM_ID)||'',''||:P301_ADRESSTYP||'',301,301'')'||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#edit_big.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
'ELSE '' '''||unistr('\000a')||
'END LINK_BEARBEITEN,'||unistr('\000a')||
'/* Link Auswahl */'||unistr('\000a')||
'''<a href="'''||unistr('\000a')||
'||apex_util.prepare_url(''f?p=&APP_ID.:''||:P301_ZURUECK_SEITE'||unistr('\000a')||
'||'':&SESSION.::&DEBUG.::'''||unistr('\000a')||
'||''P''||:P301_ZURUECK_SEIT';

s:=s||'E||''_PERSSTAMM_ID_EXTERN_UPD,P''||:P301_ZURUECK_SEITE||''_ADRESSTYP_EXTERN:'''||unistr('\000a')||
'||to_char(p.PERSONENSTAMM_ID)||'',''||:P301_ADRESSTYP)'||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'--|| ''<img src="#IMAGE_PREFIX#Fndretur.gif">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#fb_exp.gif">'''||unistr('\000a')||
'|| ''</a>'''||unistr('\000a')||
' LINK_AUSWAHL,'||unistr('\000a')||
'CASE p1.betreuer'||unistr('\000a')||
'WHEN ''I'' THEN  frgbg_s.holen_uebersetzung(3101,:fas_sprache_id)'||unistr('\000a')||
'WHEN ''J'' THEN  frgbg_s.holen_uebersetzung(1854,:fas_sprache_id)'||unistr('\000a')||
'WHEN ''';

s:=s||'N'' THEN  frgbg_s.holen_uebersetzung(3578,:fas_sprache_id)'||unistr('\000a')||
'ELSE frgbg_s.holen_uebersetzung(47,:fas_sprache_id)||'': ''||p1.betreuer'||unistr('\000a')||
'END betreuer,'||unistr('\000a')||
'p1.gus_id'||unistr('\000a')||
'from v_pers_zusatzadressen p, personenstamm p1'||unistr('\000a')||
'where :p301_PATLISTE_ANZEIGEN = 1  -- Liste anzeigen'||unistr('\000a')||
'  and'||unistr('\000a')||
'(   -- Alle abhängigen Adressen zum Patient'||unistr('\000a')||
'    ( --:fas_aufgerufen_von != ''BETREUER''           -- Endkundenzugriff'||unistr('\000a')||
'      --and p.PERSONENSTA';

s:=s||'MM_ID_BETREUER is null     -- NEI  13.02.15 nicht mehr nur beschränkt auf Endkundenzugriff, da Webshop'||unistr('\000a')||
'      --and                                         -- diese Adressen auch anlegt und Betreuer sie sehen sollte'||unistr('\000a')||
'      p.PERSONENSTAMM_ID_MASTER = :p301_persstamm_id_patient'||unistr('\000a')||
'    )'||unistr('\000a')||
'    -- Alle zugreifbaren Adressen des Betreuers'||unistr('\000a')||
'OR  ( --:fas_aufgerufen_von = ''BETREUER'' -- Betreuerzugriff'||unistr('\000a')||
'      --an';

s:=s||'d p.personenstamm_id_betreuer is not null -- NEI  13.02.15'||unistr('\000a')||
'      --and '||unistr('\000a')||
'      p.personenstamm_id_betreuer in '||unistr('\000a')||
'        (SELECT persstamm_id_betreuerzugriff'||unistr('\000a')||
'         FROM pers_zugriffe'||unistr('\000a')||
'         WHERE persstamm_id_betreuer = :p301_persstamm_id_betreuer'||unistr('\000a')||
'                /* NEI 11.01.10 */'||unistr('\000a')||
'           AND (frgbg_s.get_pers_option(:APP_USER,28)= 0  OR /* Stdzugriff*/  '||unistr('\000a')||
'                frgbg_s.get_pers_opt';

s:=s||'ion(:APP_USER,28)= 1 AND/* IABC-Betr.zugr*/'||unistr('\000a')||
'                persstamm_id_betreuer = persstamm_id_betreuerzugriff '||unistr('\000a')||
'               )'||unistr('\000a')||
'        )'||unistr('\000a')||
'  -- Bei Patientenauswahl muss die aktive Identitaet der vorgegebene entsprech.'||unistr('\000a')||
'  and (:p301_adresstyp = ''P'' and '||unistr('\000a')||
'       p.personenstamm_id_betreuer = :fas_identitaet_persstamm_id  OR'||unistr('\000a')||
'       :p301_adresstyp != ''P'''||unistr('\000a')||
'      )'||unistr('\000a')||
''||unistr('\000a')||
'    )'||unistr('\000a')||
'OR -- 17.07.14 Bei HepartMitar';

s:=s||'beiter mit Masterzugriff dürfen alle Identitäten mit GUS-ID '||unistr('\000a')||
'   --          als Liefer-/Rechnungsadresse gewählt werden'||unistr('\000a')||
'   (:P301_PATIENTENMASTERZUGRIFF = 1 and p1.betreuer = ''I'' AND p1.gus_id is not null)'||unistr('\000a')||
')'||unistr('\000a')||
'and '||unistr('\000a')||
'  (  -- Suchanfrage'||unistr('\000a')||
'  p.normname like ''%''||:p301_suchname_norm||''%'' '||unistr('\000a')||
'  AND (UPPER(p.suchadresse) like ''%''||UPPER(:p301_suchadresse)||''%'' '||unistr('\000a')||
'       OR :p301_suchadresse IS NULL)'||unistr('\000a')||
'  )'||unistr('\000a')||
'/* NEI 1';

s:=s||'2.12.12 Keine Betreuer mehr als Rechnungs-/Lieferadresse */'||unistr('\000a')||
'and p.PERSONENSTAMM_ID=p1.id'||unistr('\000a')||
'and p1.betreuer != ''J'''||unistr('\000a')||
'order by p.suchname';

wwv_flow_api.create_report_region (
  p_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 301,
  p_name=> '&P301_PAGE_TITEL_ADRESSLISTE.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P301_HEIGHT_ADRESSLISTE.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3090,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '500',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2417812540729156 + wwv_flow_api.g_id_offset,
  p_region_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHNAME',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2417911898729156 + wwv_flow_api.g_id_offset,
  p_region_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHADRESSE',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2418031971729156 + wwv_flow_api.g_id_offset,
  p_region_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'SUCHZUSATZ',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2418232642729156 + wwv_flow_api.g_id_offset,
  p_region_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'PERSONENSTAMM_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2449202210200265 + wwv_flow_api.g_id_offset,
  p_region_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'LINK_LOESCHEN',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2447709099899479 + wwv_flow_api.g_id_offset,
  p_region_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'LINK_BEARBEITEN',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2449500394218745 + wwv_flow_api.g_id_offset,
  p_region_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'LINK_AUSWAHL',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10323400020874933 + wwv_flow_api.g_id_offset,
  p_region_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'BETREUER',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':P301_PATIENTENMASTERZUGRIFF=1',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 10323531644874937 + wwv_flow_api.g_id_offset,
  p_region_id=> 2413318159729098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'GUS_ID',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2487914056072256 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 301,
  p_plug_name=> 'Navi wk',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(2476427657082606 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_aufgerufen_von != ''BETREUER''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 2433312217550298 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 301,
  p_button_sequence=> 5,
  p_button_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P301_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P301_ZURUECK_SEITE.:&SESSION.::&DEBUG.:301::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2458903650936254 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 301,
  p_button_sequence=> 8,
  p_button_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_button_name    => 'STANDARD_ADRESSE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P301_BL_STDADR.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> ':p301_adresstyp !=''P''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2422606433912998 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 301,
  p_button_sequence=> 10,
  p_button_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_button_name    => 'ALLE_ANZEIGEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P301_BL_ALLE_ANZEIGEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2422817515916223 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 301,
  p_button_sequence=> 20,
  p_button_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P301_BL_SUCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2427705721179406 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 301,
  p_button_sequence=> 30,
  p_button_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_button_name    => 'ERSTELLEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P301_BL_ERSTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'NVL(frgbg_s.get_pers_option(:APP_USER,36),0) = 1 OR'||unistr('\000a')||
':P301_ADRESSTYP =''L'' /* NEI 15.08.14 Lieferadressen dürfen immer erstellt werden, da diese im Klartext an GUS gehen, ansonsten dürfen Hepart-Mitarbeiter möglichst keine Adressen erfassen, sondern nur über FAS */',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>2428017414179407 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:302:P302_PERSSTAMM_ID_MASTER,P302_ZURUECK_SEITE,P302_ADRESSTYP,P302_CALLING_PAGE:&P300_PERSSTAMM_ID.,&P301_ZURUECK_SEITE.,&P301_ADRESSTYP.,301',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2427705721179406+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 5,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>2462413852175751 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P301_ZURUECK_SEITE.:&SESSION.::&DEBUG.:301:P&P301_ZURUECK_SEITE._PERSSTAMM_ID_EXTERN_UPD,P&P301_ZURUECK_SEITE._ADRESSTYP_EXTERN:&P301_PERSSTAMM_ID_STDADRESSE.,&P301_ADRESSTYP.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2458903650936254+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 6,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 11-MAI-2009 12:18 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>2417022211729115 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:301:&SESSION.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1176317667250992 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_PATLISTE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Flag Liste leer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1177604994332470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_SUCHNAME_NORM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Norm',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1179111368419470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_SUCHADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Suchadresse',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2365512342615440 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_PERSSTAMM_ID_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Betreuer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2365723078618542 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_PERSSTAMM_ID_PATIENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Patient',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2367420747674646 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_ADRESSTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 25,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Adresstyp',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2415825976729110 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_SUCHBEDINGUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2423003448921612 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_BL_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Suchen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2423216607925392 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_BL_ALLE_ANZEIGEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2423919640945239 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_PAGE_TITEL_ADRESSLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Adressliste',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2425132416996221 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_HEIGHT_ADRESSLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2431511543351435 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2434230355565026 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2434511093568884 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 82,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2483224960687387 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_PERSSTAMM_ID_DELETE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'zu löschender Patient',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2646609463127729 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_BL_STDADR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 83,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Bl Stdadr',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4287800282970409 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_PERSSTAMM_ID_STDADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 21,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6273802670075925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_NV_ADRESSLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Adressliste',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9546514130512200 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 301,
  p_name=>'P301_PATIENTENMASTERZUGRIFF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 2413318159729098+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p301_suchname_norm:= frgbg_t.normstring(:p301_SUCHBEDINGUNG,2);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1177326681329324 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 301,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'suchstring_aufbauen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_PERSSTAMM_ID_DELETE  personenstamm.id%TYPE;'||unistr('\000a')||
'   v_prot_id              number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P(''Pers löschen   %1, %2, %4, %5'', --v_prot_id,''Info'',''page301'',:p301_PERSSTAMM_ID_DELETE,:p301_persstamm_id_patient);'||unistr('\000a')||
''||unistr('\000a')||
'   v_PERSSTAMM_ID_DELETE := :p301_PERSSTAMM_ID_DELETE;'||unistr('\000a')||
'   :p301_PERSSTAMM_ID_DELETE := NULL;'||unistr('\000a')||
'   IF v_persstamm_id_delete is not null THEN'||unistr('\000a')||
'      -- Es dürfen nur Personenstammdat';

p:=p||'en als gelöscht markiert werden, die'||unistr('\000a')||
'      -- eine Masterreferenz besitzen, da dies reine Adressdaten von Endkunden sind'||unistr('\000a')||
'      UPDATE personenstamm'||unistr('\000a')||
'      SET satzkennzeichen = ''Gelöscht von ''||:APP_USER||'||unistr('\000a')||
'                            '' am ''||to_char(sysdate,''DD.MM.YYYY hh24:mi:ss'')'||unistr('\000a')||
'      WHERE id = v_PERSSTAMM_ID_DELETE'||unistr('\000a')||
'        and persstamm_id_master = :p301_persstamm_id_patient'||unistr('\000a')||
'        and  frgbg';

p:=p||'_T.check_pers_extern_verwaltet(EXTERN_VERWALTET ) = 0 -- NEI 13.2.15 Nur FAS-verwaltete Adressen löschen'||unistr('\000a')||
'      ; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2483504276738235 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 301,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Patient_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p301_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p301_bl_suchen := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p301_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id);'||unistr('\000a')||
'   :p301_bl_alle_anzeigen := frgbg_s.holen_uebersetzung(511,v_sprache_id);'||unistr('\000a')||
'   :p301_bl_stdadr := frgbg_s.holen_uebe';

p:=p||'rsetzung(3117,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p301_page_titel_adressliste := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(1599,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P301_NV_ADRESSLISTE := frgbg_s.holen_uebersetzung(3845,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2423530806929564 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 301,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_PERSSTAMM_ID_ident   personenstamm.id%type;'||unistr('\000a')||
'begin'||unistr('\000a')||
'   -- Ident der Login-Person'||unistr('\000a')||
'   v_PERSSTAMM_ID_ident:= frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'   -- Masterzugriff für Ident der LOGIN-Person oder der Person selbst prüfen'||unistr('\000a')||
'   :P301_PATIENTENMASTERZUGRIFF := NVL(frgbg_s.GET_PERS_OPTION(NULL,43 , v_PERSSTAMM_ID_ident,:FAS_LOGIN_PERSONENSTAMM_ID),0);'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 9546205818509736 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 301,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_patientenzugriff',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Komplette Höhe ausnutzen (100% des Maximums)'||unistr('\000a')||
'   :P301_HEIGHT_ADRESSLISTE := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2423324919927865 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 301,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*mel.p(''patliste_leer_initialisieren request:%1;%2'',v_prot_id,''INFO'',''102/301:patliste_leer_initialisieren'',:request,:p301_suchart);*/'||unistr('\000a')||
'   if :request in (''ERSTELLEN'')  then'||unistr('\000a')||
'      :p301_patliste_anzeigen := 0; -- Leer initialisieren'||unistr('\000a')||
'   else'||unistr('\000a')||
'      :p301_patliste_anzeigen := 1; -- Suchen'||unistr('\000a')||
'   end if;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1176431866255098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 301,
  p_process_sequence=> 10,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'patliste_leer_initialisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :P301_SUCHBEDINGUNG:= NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2424620033973701 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 301,
  p_process_sequence=> 40,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'clear_such_felder',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>2422606433912998 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 301
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00302
prompt  ...PAGE 302: Adress_PERSONENSTAMM
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 302
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Adress_PERSONENSTAMM'
 ,p_step_title => 'Adressenstamm'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Adress_PERSONENSTAMM'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150206104800'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2436213121638654 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 302,
  p_plug_name=> '&P302_PAGE_TITEL_ADRESSENSTAMM.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2436413318638662 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 302,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 0,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_aufgerufen_von = ''BETREUER''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2489314926110278 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 302,
  p_plug_name=> 'Navi wk',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(2476427657082606 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_aufgerufen_von != ''BETREUER''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 2436809584638664 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 302,
  p_button_sequence=> 10,
  p_button_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P302_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P302_CALLING_PAGE.:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2436626240638662 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 302,
  p_button_sequence=> 15,
  p_button_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_button_name    => 'ADRESSE_UEBERNEHMEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P302_BL_UEBERNEHMEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p302_id is not null and :p302_calling_page != 308',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2437003637638664 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 302,
  p_button_sequence=> 20,
  p_button_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P302_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(htmldb_delete_message,''DELETE'');',
  p_button_condition=> ':P302_ID is not null and :p302_persstamm_id_master is not null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2437222098638665 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 302,
  p_button_sequence=> 30,
  p_button_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P302_BL_SPEICHERN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P302_ID is not null and '||unistr('\000a')||
':P302_EXTERN_VERWALTET = 0  /*FAS-Verwalt.*/',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2437416643638665 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 302,
  p_button_sequence=> 40,
  p_button_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P302_BL_ERSTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> ':P302_ID is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>2440702526638681 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P302_ZURUECK_SEITE.:&SESSION.::&DEBUG.:302::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 11,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''DELETE'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 08-MAI-2009 09:36 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>2440930010638681 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P302_ZURUECK_SEITE.:&SESSION.::&DEBUG.:301,302:P&P302_ZURUECK_SEITE._ADRESSTYP_EXTERN,P&P302_ZURUECK_SEITE._PERSSTAMM_ID_EXTERN_UPD:&P302_ADRESSTYP.,&P302_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 21,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''ADRESSE_UEBERNEHMEN'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 08-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>2441130869638681 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2437628115638665 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_PERSSTAMM_ID_MASTER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Master',
  p_source=>'PERSSTAMM_ID_MASTER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2437816983638667 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_ANREDE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ANREDE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select  '||unistr('\000a')||
' fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',ID,:fas_sprache_id) a,'||unistr('\000a')||
' id b'||unistr('\000a')||
'from anreden_frgbg',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P302_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P302_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2438001118638667 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'DECLARE '||unistr('\000a')||
'   v_land_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      v_land_id := frgbg_s.get_betreuer_land_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      v_land_id := NULL;   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN v_land_id;'||unistr('\000a')||
'END;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select substr(fas_synch.get_tab_uebersetzung(''LAND.LAND'',id,:fas_sprache_id),1,30)  a, id b'||unistr('\000a')||
'from v_laender'||unistr('\000a')||
'order by sort',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P302_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P302_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2438222677638668 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2438426413638668 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P302_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P302_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2438612796638671 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'VORNAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P302_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P302_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2438817952638671 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_STRASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'STRASSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P302_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P302_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2439016768638671 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 10,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P302_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P302_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2439209336638671 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_PLZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PLZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 10,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P302_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P302_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2439415112638671 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_ORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P302_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P302_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2443418122703410 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_PAGE_TITEL_ADRESSENSTAMM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 300,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Titel Adressliste',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2443632321707465 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2443806133709400 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2444011458720435 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 311,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2444432583726503 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_BL_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 312,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2445208257738395 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 313,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'SPEICHERN',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2445419339741606 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_BL_UEBERNEHMEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 314,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'UEbernehmen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2458203079869812 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_ADRESSTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Adresstyp',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2484608272852910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'User Account',
  p_source=>'USER_ACCOUNT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2484826972858332 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_PASSWORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Passwort',
  p_source=>'PASSWORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2486903826955742 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_SATZKENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 360,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satzkennzeichen',
  p_source=>'SATZKENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2528022531836720 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 370,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4048930978776382 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_CALLING_PAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 400,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'calling',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4230230023636829 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 390,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6274317477099167 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_NV_ADRESSSTAMM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Adressstamm',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10309619536883690 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_ADRESSZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 61,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSZUSATZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 40,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P302_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P302_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12366628137431513 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 302,
  p_name=>'P302_PERS_READONLY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 410,
  p_item_plug_id => 2436213121638654+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 2439718514638675 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 302,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P302_NAME not null',
  p_validation_sequence=> 50,
  p_validation => 'P302_NAME',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => 'Name Name muss einen Wert haben.',
  p_associated_item=> 2438426413638668 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 2439925296638678 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 302,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P302_ANREDE_ID not null',
  p_validation_sequence=> 260,
  p_validation => 'P302_ANREDE_ID',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => 'Anrede Id Name muss einen Wert haben.',
  p_associated_item=> 2437816983638667 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 2440128151638678 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 302,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P302_LAND_ID not null',
  p_validation_sequence=> 280,
  p_validation => 'P302_LAND_ID',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => 'Land Id Name muss einen Wert haben.',
  p_associated_item=> 2438001118638667 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:PERSONENSTAMM:P302_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 2440219937638679 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 302,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from PERSONENSTAMM',
  p_process_sql_clob => p,
  p_process_error_message=> 'Abrufen von Zeile nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   /* z.B. GUS-Adr. darf nicht im FAS verändert werden */'||unistr('\000a')||
'   :p302_pers_readonly:=frgbg_T.check_pers_extern_verwaltet(:p302_EXTERN_VERWALTET ) ; '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 12366722647436238 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 302,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_adr_readonly',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p302_user_account := frgbg_s.gen_user_account(:p302_name,:p302_vorname,NULL);'||unistr('\000a')||
'   :p302_passwort := frgbg_s.gen_passwort;'||unistr('\000a')||
'   IF :fas_aufgerufen_von != ''BETREUER'' THEN  '||unistr('\000a')||
'      -- reine Adresserfassung bei Endkunden => Link zur Person eintragen'||unistr('\000a')||
'      :p302_persstamm_id_master := :P302_PERSSTAMM_ID_MASTER;'||unistr('\000a')||
'      :p302_erfuser := :APP_USER;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Adresse wird als Kunde/Patient erfa';

p:=p||'sst mit Betreuerzuordnung'||unistr('\000a')||
'      -- Per Trigger wird autom. der Betreuer zugeordnet bei Kundenerfassung'||unistr('\000a')||
'      :p302_erfuser := :APP_USER||''##''||to_char(:FAS_IDENTITAET_PERSSTAMM_ID)||''##'';'||unistr('\000a')||
'      :p302_persstamm_id_master := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2484221993847418 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 302,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_perstamm_erstellen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>2437416643638665 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p302_satzkennzeichen := ''Gelöscht von ''||:app_user||'' am ''||'||unistr('\000a')||
'                   to_char(sysdate,''DD.MM.YYYY hh24:mi:ss'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2486424689942865 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 302,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_persstamm_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>2437003637638664 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:PERSONENSTAMM:P302_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 2440400852638679 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 302,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of PERSONENSTAMM',
  p_process_sql_clob => p,
  p_process_error_message=> 'Verarbeiten von Zeile der Tabelle PERSONENSTAMM nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_return_key_into_item1=>'P302_ID',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p302_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p302_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :p302_bl_loeschen := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p302_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id);'||unistr('\000a')||
'   :p302_bl_uebernehmen := frgbg_s.holen_u';

p:=p||'ebersetzung(1597,v_sprache_id);'||unistr('\000a')||
'   :p302_page_titel_ADRESSENSTAMM := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   :P302_NV_ADRESSSTAMM := frgbg_s.holen_uebersetzung(3846,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 2444608472729015 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 302,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 302
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00303
prompt  ...PAGE 303: WK_verordnungen_tmp
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 303
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'WK_verordnungen_tmp'
 ,p_step_title => 'Verordnungen'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20131007105853'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2393923385024639 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 303,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_aufgerufen_von =''BETREUER''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."ID",'||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."ID" ID_DISPLAY,'||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."WARENKORB_DETAIL_TMP_ID",'||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."VERORDZEIT_ID",'||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."MENGE",'||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."BEMERKUNG",'||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."SATZ_KENNZEICHEN",'||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."ERFDAT",'||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."ERFUSER",'||unistr('\000a')||
'"';

s:=s||'WKORB_DET_VERORDNUNGEN_TMP"."MUTDAT",'||unistr('\000a')||
'"WKORB_DET_VERORDNUNGEN_TMP"."MUTUSER",'||unistr('\000a')||
'NVL(sort,-9999) sort'||unistr('\000a')||
'from "#OWNER#"."WKORB_DET_VERORDNUNGEN_TMP", verordzeiten v'||unistr('\000a')||
'where WARENKORB_DETAIL_TMP_ID = :p303_WARENKORB_DETAIL_TMP_ID'||unistr('\000a')||
'  and verordzeit_id = v.id (+)'||unistr('\000a')||
'order by sort'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 303,
  p_name=> 'Verordnung',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '10',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2498019874994460 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '&nbsp;',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2495503119994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 2,
  p_column_heading=> 'Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2495628009994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID_DISPLAY',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'ID_DISPLAY',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2495706623994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_DETAIL_TMP_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Warenkorb Detail Tmp Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'DISPLAY_AND_SAVE',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_default=> 'P303_WARENKORB_DETAIL_TMP_ID',
  p_column_default_type=> 'ITEM',
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'WARENKORB_DETAIL_TMP_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2495809975994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'VERORDZEIT_ID',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Zeitpunkt',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'SELECT_LIST_FROM_QUERY',
  p_inline_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''VERORDZEITEN.BEZEICHNUNG'',ID,:fas_sprache_id), id'||unistr('\000a')||
'from verordzeiten'||unistr('\000a')||
'order by sort',
  p_lov_show_nulls=> 'YES',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_default=> '1',
  p_lov_display_extra=> 'NO',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'VERORDZEIT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2495913677994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 6,
  p_column_heading=> 'Menge',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'SELECT_LIST_FROM_QUERY',
  p_inline_lov=> 'SELECT to_char(0.5,''FM0D0'') a,to_char(0.5,''FM0D0'') b from DUAL UNION'||unistr('\000a')||
'SELECT to_char(1,''FM0D0'') a,to_char(1,''FM0D0'') b from DUAL UNION'||unistr('\000a')||
'SELECT to_char(1.5,''FM0D0'') a,to_char(1.5,''FM0D0'') b from DUAL UNION'||unistr('\000a')||
'SELECT to_char(2,''FM0D0'') a,to_char(2,''FM0D0'') b from DUAL UNION'||unistr('\000a')||
'SELECT to_char(2.5,''FM0D0'') a,to_char(2,''FM0D0'') b from DUAL UNION'||unistr('\000a')||
'SELECT to_char(3,''FM0D0'') a,to_char(2,''FM0D0'') b from DUAL UNION'||unistr('\000a')||
'SELECT to_char(3.5,''FM0D0'') a,to_char(2,''FM0D0'') b from DUAL UNION'||unistr('\000a')||
'SELECT to_char(4,''FM0D0'') a,to_char(2,''FM0D0'') b from DUAL '||unistr('\000a')||
'',
  p_lov_show_nulls=> 'YES',
  p_column_width=> '5',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2496014549994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 7,
  p_column_heading=> 'Bemerkung',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXTAREA',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '50',
  p_column_height=> '2',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'BEMERKUNG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2496119395994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'SATZ_KENNZEICHEN',
  p_column_display_sequence=> 8,
  p_column_heading=> 'Satz Kennzeichen',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'SATZ_KENNZEICHEN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2496207606994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'ERFDAT',
  p_column_display_sequence=> 9,
  p_column_heading=> 'Erfdat',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'ERFDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2496311901994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'ERFUSER',
  p_column_display_sequence=> 10,
  p_column_heading=> 'Erfuser',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'ERFUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2496416662994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'MUTDAT',
  p_column_display_sequence=> 11,
  p_column_heading=> 'Mutdat',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'MUTDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 2496510599994450 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'MUTUSER',
  p_column_display_sequence=> 12,
  p_column_heading=> 'Mutuser',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WKORB_DET_VERORDNUNGEN_TMP',
  p_ref_column_name=> 'MUTUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1370513744104022 + wwv_flow_api.g_id_offset,
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'SORT',
  p_column_display_sequence=> 13,
  p_column_heading=> 'Sort',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 2515621043755070 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 303,
  p_plug_name=> 'navi wk',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(2476427657082606 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_aufgerufen_von !=''BETREUER''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 2496923000994454 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 303,
  p_button_sequence=> 35,
  p_button_plug_id => 2495208483994446+wwv_flow_api.g_id_offset,
  p_button_name    => 'ADD',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Verordnungstext hinzufügen',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2496714359994454 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 303,
  p_button_sequence=> 40,
  p_button_plug_id => 2495208483994446+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2496630504994454 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 303,
  p_button_sequence=> 10,
  p_button_plug_id => 2495208483994446+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 2496814319994454 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 303,
  p_button_sequence=> 20,
  p_button_plug_id => 2495208483994446+wwv_flow_api.g_id_offset,
  p_button_name    => 'MULTI_ROW_DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(htmldb_delete_message,''MULTI_ROW_DELETE'');',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>2429918029296496 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 303,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:303::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>2496630504994454+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 21,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 08-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>2390331917024626 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 303,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:303:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2501006386542656 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 303,
  p_name=>'P303_WARENKORB_DETAIL_TMP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 2495208483994446+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wkorb Verordnungen Tmp Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6275313499135829 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 303,
  p_name=>'P303_NV_VERORDNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 2495208483994446+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Verordnung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WKORB_DET_VERORDNUNGEN_TMP:ID';

wwv_flow_api.create_page_process(
  p_id     => 2497620257994459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 303,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_UPDATE',
  p_process_name=> 'ApplyMRU',
  p_process_sql_clob => p,
  p_process_error_message=> 'Verarbeiten von Aktualisierung nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>2496714359994454 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WKORB_DET_VERORDNUNGEN_TMP:ID';

wwv_flow_api.create_page_process(
  p_id     => 2497806237994459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 303,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_DELETE',
  p_process_name=> 'ApplyMRD',
  p_process_sql_clob => p,
  p_process_error_message=> 'Verarbeiten von Löschvorgang nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'MULTI_ROW_DELETE',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WKORB_DET_VERORDNUNGEN_TMP:ID';

wwv_flow_api.create_page_process(
  p_id     => 2498131225994460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 303,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_UPDATE',
  p_process_name=> 'ApplyMRU',
  p_process_sql_clob => p,
  p_process_error_message=> 'Verarbeiten von Aktualisierung nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>2496923000994454 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'1';

wwv_flow_api.create_page_process(
  p_id     => 2498302744994460 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 303,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 2495208483994446 + wwv_flow_api.g_id_offset,
  p_process_type=> 'ADD_ROWS_TO_TABULAR_FORM',
  p_process_name=> 'AddRows',
  p_process_sql_clob => p,
  p_process_error_message=> 'Hinzufügen von Zeilen nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>2496923000994454 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   :p302_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p302_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :p302_bl_loeschen := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p302_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id);'||unistr('\000a')||
'   :p302_bl_uebernehmen := frgbg_s.hole';

p:=p||'n_uebersetzung(1597,v_sprache_id);'||unistr('\000a')||
'   :p302_page_titel_ADRESSENSTAMM := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   :P302_NV_ADRESSSTAMM := frgbg_s.holen_uebersetzung(3846,v_sprache_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   :P303_NV_VERORDNUNG := frgbg_s.holen_uebersetzung(3843,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6274805057123985 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 303,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 303
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00304
prompt  ...PAGE 304: PATIENTENSTAMMANZEIGE
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 304
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'PATIENTENSTAMMANZEIGE'
 ,p_step_title => 'PATIENTENSTAMMANZEIGE'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'PATIENTENSTAMMANZEIGE'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150211110340'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6624320937759595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 304,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_aufgerufen_von =''BETREUER''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6624724996759595 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 304,
  p_plug_name=> '&P304_PAGE_TITEL_PATIENTANZEIGE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 9,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="height: &FAS_SCROLLREGION_HEIGHT_MAX.px;max-width: 550px">'||unistr('\000a')||
'',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6670723440849667 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 304,
  p_plug_name=> 'Navi_wk',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(2476427657082606 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':fas_aufgerufen_von !=''BETREUER''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6625910460759603 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 304,
  p_button_sequence=> 10,
  p_button_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P304_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P304_ZURUECK_SEITE.:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6673516542074695 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 304,
  p_button_sequence=> 20,
  p_button_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P304_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(''&FAS_LOESCHABFRAGE_TEXT.'',''DELETE'');',
  p_button_condition=> ':p304_id is not null AND :fas_aufgerufen_von != ''ANONYM'''||unistr('\000a')||
'and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6626520673759604 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 304,
  p_button_sequence=> 40,
  p_button_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P304_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> 'P304_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6627121354759604 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 304,
  p_button_sequence=> 90,
  p_button_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P304_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_condition=> ':p304_id is not null and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6660703812759667 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4222209545602594 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1050,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4279903225296709 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_GEWICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 106,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160;&#160;&#160;',
  p_source=>'GEWICHT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4280116862310114 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_GROESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 107,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_pre_element_text=>'&#160;',
  p_post_element_text=>'&#160;&#160;&#160;',
  p_source=>'GROESSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>6627901369759607 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_STRASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 74,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'STRASSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 10 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>6628406062759612 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 76,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte mit Postleitzahlen in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 10 Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>6628922836759612 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_PLZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 78,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PLZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 100 beliebige Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>6629420177759614 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_ORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_POPUP_LOV',
  p_lov=> '         SELECT distinct o.ort ||'' ''||o.PLZ a, o.ort b'||unistr('\000a')||
'         FROM   orte o,  laender l, gebiete  g'||unistr('\000a')||
'         WHERE  o.id_gebiet = g.id'||unistr('\000a')||
'           AND  g.id_land = l.id'||unistr('\000a')||
'           AND  (l.ID = :P304_LAND_ID OR :P304_land_id is null)'||unistr('\000a')||
'           AND  (o.plz like :p304_plz||''%'' OR :p304_plz is null)'||unistr('\000a')||
'           and  o.satz_kennzeichen is null '||unistr('\000a')||
'           and  l.satz_kennzeichen is null'||unistr('\000a')||
'           and  g.satz_kennzeichen is null'||unistr('\000a')||
'		   and (l.iso3_id not in (''CHE'',''LIE'') '||unistr('\000a')||
'	        		 or'||unistr('\000a')||
'	           (l.iso3_id in (''CHE'',''LIE'') and o.onrp is not null))'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'ENTERABLE',
  p_attribute_02 => 'FIRST_ROWSET_FILTER',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6629906980759614 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_SATZKENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satzkennzeichen',
  p_source=>'SATZKENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Datumsangabe der Form TT.MM.JJJJ z.B. 20.11.2001';

wwv_flow_api.create_page_item(
  p_id=>6630114251759615 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'DD.MM.YYYY',
  p_source=>'GEBURTSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER_CLASSIC',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Auswahl des Geschlechts.';

wwv_flow_api.create_page_item(
  p_id=>6630610062759615 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_GESCHLECHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 89,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'GESCHLECHT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Anzeigesprache';

wwv_flow_api.create_page_item(
  p_id=>6631115837759615 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      -- Sprache des Patienten von der Betreuer-Sprache ableiten'||unistr('\000a')||
'      :p110_app_sprache_id := frgbg_s.get_app_sprache_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT min(s.id) into :p110_app_sprache_id'||unistr('\000a')||
'      FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'      WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'        AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'        AND s.standard = 1;     -- Defaultsprache       '||unistr('\000a')||
'      IF :p110_app_sprache_id is NULL THEN'||unistr('\000a')||
'         SELECT min(s.id) into :p110_app_sprache_id'||unistr('\000a')||
'         FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'         WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'           AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'           AND s.aktiv=1 ; -- NEI 09.09.2014'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN (:p110_app_sprache_id);'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'APP_SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select s.sprache display_value, s.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs '||unistr('\000a')||
'where fs.id = :fas_pers_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  -- and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6631629345759617 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_PAGE_TITEL_PATIENTANZEIGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 554,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Title Personenstammanzeige',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6631823708759617 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_PIS_PAT_AKTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 670,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pis Pat Akte Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6632417496759617 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_AENDERBAR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 970,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Aenderbar',
  p_source=>'AENDERBAR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6632604917759618 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 680,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6632808998759618 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 690,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6633009364759618 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_LOGIN_PAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 700,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Login Page',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6633211791759618 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_TAB1_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 710,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6633826041759620 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_PIS_ADRESSE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 671,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6634210873759620 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_ANREDE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 68,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ANREDE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select  '||unistr('\000a')||
' fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',ID,:fas_sprache_id) a,'||unistr('\000a')||
' id b'||unistr('\000a')||
'from anreden_frgbg'||unistr('\000a')||
'/* Keine Firma */'||unistr('\000a')||
'WHERE id != 5 ',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Das eingegebene Land wird auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>6634403481759620 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 77,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      -- Land des Patienten vom Betreuer-Land ableiten'||unistr('\000a')||
'      :p110_land_id := frgbg_s.get_betreuer_land_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p110_land_id := 198;  -- Default Schweiz '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN (:p110_land_id);'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select substr(fas_synch.get_tab_uebersetzung(''LAND.LAND'',id,:fas_sprache_id),1,27)  a, id b'||unistr('\000a')||
'from v_laender'||unistr('\000a')||
'order by sort',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6640026069759628 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 63,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'IDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6640216514759628 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 99,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 62,
  p_cMaxlength=> 2000,
  p_cHeight=> 2,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6640426300759628 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_TELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 94,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6640619091759628 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_MOBILTELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 96,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'MOBILTELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6643023144759631 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Änderung anwenden',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Ändern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6643221235759631 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Erstellen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6643430723759632 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6643607088759632 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_BL_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Löschen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6643807023759632 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_BL_PASSWORT_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 530,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Passwort ändern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Passwort Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6644021369759632 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 540,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Speichern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Speichern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6644402855759632 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_FEHLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 560,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6644818129759634 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_INFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 570,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6645021839759634 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_PERSON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 620,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Person',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6645209489759634 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_USER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 630,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pisuser',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6645806439759634 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Login Benutzer Name ist nicht veränderbar.';

wwv_flow_api.create_page_item(
  p_id=>6646003712759634 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 62,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'USER_ACCOUNT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von != ''BETREUER''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when=>'p304_id',
  p_read_only_when_type=>'ITEM_IS_NOT_NULL',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.'||unistr('\000a')||
'Der Eintrag muss mit mindestens einem Zeichen beginnen, anschliessend ein @-Zeichen beinhalten, danach beliebig viele Zeichen. Nach dem Punkt sind bis zu 4 Zeichen erlaubt. Allgemeiner Aufbau: [zeichen]@[zeichen].[zeichen]';

wwv_flow_api.create_page_item(
  p_id=>6646531664759635 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_EMAIL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 65,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'EMAIL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für dieses Seitenelement ist keine Hilfe verfügbar.';

wwv_flow_api.create_page_item(
  p_id=>6647013210759635 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_PASSWORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 67,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PASSWORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>6647513684759637 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>6648016664759637 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 72,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'VORNAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6648507292759637 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_FAX',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'FAX',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6648719531759637 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 97,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'URL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6648927903759639 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 64,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'N',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BETREUER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(3578,:fas_sprache_id) a,''N'' b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(1854,:fas_sprache_id),''J''  from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(3101,:fas_sprache_id),''I''  from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p304_betreuer in (''J'',''N'')',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when=>'frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p304_betreuer in (''J'',''N'')',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6649518109759639 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_NV_PATIENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1040,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Patient',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.'||unistr('\000a')||
'Der Eintrag muss mit mindestens einem Zeichen beginnen, anschliessend ein @-Zeichen beinhalten, danach beliebig viele Zeichen. Nach dem Punkt sind bis zu 4 Zeichen erlaubt. Allgemeiner Aufbau: [zeichen]@[zeichen].[zeichen]';

wwv_flow_api.create_page_item(
  p_id=>6649727294759639 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_EMAIL_INTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 66,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'EMAIL_INTERN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_modus_id in (1,2)',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8592106044813625 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1060,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '308',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>10307622428818329 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_ADRESSZUSATZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 73,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ADRESSZUSATZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 40,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/*:P304_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/'||unistr('\000a')||
':P304_PERS_READONLY = 1   /* NEI 04.02.15 WSH Adressen extern_verwaltet=2*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12368508271471026 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 304,
  p_name=>'P304_PERS_READONLY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1070,
  p_item_plug_id => 6624724996759595+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6650709673759646 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_LAND_ID_not_null',
  p_validation_sequence=> 1,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P304_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_when_button_pressed=> 6626520673759604 + wwv_flow_api.g_id_offset,
  p_associated_item=> 6634403481759620 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6650908780759646 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_LAND_exists',
  p_validation_sequence=> 23,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p304_land_id IS NOT NULL THEN'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM   v_laender'||unistr('\000a')||
'      --WHERE  UPPER(land) = UPPER(:p304_land);'||unistr('\000a')||
'      WHERE id = :p304_land_id;'||unistr('\000a')||
'      IF v_anz != 1 THEN'||unistr('\000a')||
'         --RETURN(''Ungültige Eingabe im Feld Land!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'               frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Land ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(211,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P304_land_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6634403481759620 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6651111896759646 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_PLZ_ORT_exists',
  p_validation_sequence=> 33,
  p_validation => 'DECLARE'||unistr('\000a')||
'    v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --IF UPPER(:p304_land) = ''SCHWEIZ'' THEN'||unistr('\000a')||
'   IF :p304_land_id IS NOT NULL AND :p304_ort IS NOT NULL AND'||unistr('\000a')||
'      :p304_plz IS NOT NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      IF :p304_land_id = 198 and   -- Schweiz'||unistr('\000a')||
'         :P304_EXTERN_VERWALTET = 0  -- NEI 11.07.13 Nur FAS-Verwaltete Aufträge prüfen, '||unistr('\000a')||
'                                   -- da nur diese PLZ/Ort verändert werden können,'||unistr('\000a')||
'                                   -- sonst ist GUS führend und die Änderungen kommen von dort'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         select count(*) INTO v_anz'||unistr('\000a')||
'         from v_orte'||unistr('\000a')||
'         where upper(ort) = upper(:p304_ort)'||unistr('\000a')||
'           and plz = :p304_plz;'||unistr('\000a')||
'         IF v_anz = 0 THEN'||unistr('\000a')||
'            --RETURN(''PLZ/Ort-Kombination ist ungültig!'');'||unistr('\000a')||
'            RETURN(frgbg_s.holen_uebersetzung(179,'||unistr('\000a')||
'                        :fas_sprache_id));'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Ort bzw. PLZ ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(209,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P304_plz_ort_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6628922836759612 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6651331143759648 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p304_geburtsdatum_not_null',
  p_validation_sequence=> 43,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P304_GEBURTSDATUM IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- Geburtsdatum optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6630114251759615 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6651508532759648 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p304_geburtdatum_must_be_date',
  p_validation_sequence=> 53,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P304_GEBURTSDATUM IS NOT NULL THEN'||unistr('\000a')||
'      :P304_GEBURTSDATUM := '||unistr('\000a')||
'         to_char(to_date(:P304_GEBURTSDATUM,''DD.MM.RRRR''),''DD.MM.RRRR'');'||unistr('\000a')||
'            -- to_date(:P304_GEBURTSDATUM);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(HTMLDB_LANG.MESSAGE(''DATUM_UNGUELTIG''));'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Ungültiges Datum!',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6630114251759615 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6651712715759648 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p304_name_not_null',
  p_validation_sequence=> 93,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P304_NAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(206,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6647513684759637 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6651919784759648 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_VORNAME_not_null',
  p_validation_sequence=> 103,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P304_VORNAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(205,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'NEVER',
  p_associated_item=> 6648016664759637 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6652115671759648 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_PLZ_not_null',
  p_validation_sequence=> 133,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P304_PLZ IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(209,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6628922836759612 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6652305330759650 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_ORT_not_null',
  p_validation_sequence=> 143,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P304_ORT IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(210,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6629420177759614 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6652522601759650 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_EMAIL_not_null',
  p_validation_sequence=> 153,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P304_EMAIL IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(203,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ -- NEI 05.05.08 optionales Feld'||unistr('\000a')||
'NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6646531664759635 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6652716197759650 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_EMAIL_check',
  p_validation_sequence=> 160,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p304_email IS NOT NULL THEN '||unistr('\000a')||
'      IF instr(:p304_email,''@'') <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(224,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'      v_string :=  '||unistr('\000a')||
'         substr(:p304_email,instr(:p304_email,''@'')+1,length(:p304_email));'||unistr('\000a')||
'      v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'      IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'         --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(225,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'      -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'      IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(226,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,     '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(203,:fas_sprache_id)),'||unistr('\000a')||
'            ''Validierung p304_email_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6646531664759635 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6653312373759650 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_EMAIL_intern_check',
  p_validation_sequence=> 161,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p304_email_intern IS NOT NULL THEN '||unistr('\000a')||
'      IF instr(:p304_email_intern,''@'') <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(224,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'      v_string :=  '||unistr('\000a')||
'         substr(:p304_email_intern,'||unistr('\000a')||
'                  instr(:p304_email_intern,''@'')+1,length(:p304_email_intern));'||unistr('\000a')||
'      v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'      IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'         --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(225,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'      -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'      IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(226,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,     '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(3767,:fas_sprache_id)),'||unistr('\000a')||
'            ''Validierung p304_email_intern_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> 'SAVE CREATE',
  p_validation_condition_type=> 'REQUEST_IN_CONDITION',
  p_associated_item=> 6649727294759639 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6652908754759650 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P304_USER_ACCOUNT_EINGABE',
  p_validation_sequence=> 170,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'   v_anz   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p304_user_account IS NULL THEN'||unistr('\000a')||
'      --RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,   -- NEI 23.06.08'||unistr('\000a')||
'      --       frgbg_s.holen_uebersetzung(202,:fas_sprache_id)));'||unistr('\000a')||
'      -- User-Account autom. generieren'||unistr('\000a')||
'      :p304_user_account := frgbg_s.GEN_USER_ACCOUNT'||unistr('\000a')||
'                    (:p304_name,:p304_vorname,--:p304_geburtsdatum);'||unistr('\000a')||
'                     to_date(:p304_geburtsdatum,''DD.MM.YYYY''));'||unistr('\000a')||
'      IF :p304_user_account IS NULL THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(1814,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT count(*) INTO v_anz'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE UPPER(user_account)= UPPER(:p304_user_account);'||unistr('\000a')||
'      IF v_anz > 0 THEN'||unistr('\000a')||
'         --RETURN (''Der Benutzer ist bereits vergeben!'');'||unistr('\000a')||
'         RETURN (frgbg_s.holen_uebersetzung(448,'||unistr('\000a')||
'                      :fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'mel.p(''Exception bei Validierung P304_user_account_eingabe Name %1, Vorname %2, GEbdat %3, ACcount %4, Sprache %5, Fehler: %6'', v_PROT_ID, ''ERROR'', ''page110/val_user_account'',:p304_name,:p304_vorname,:p304_geburtsdatum,:p304_user_account,:fas_sprache_id,SQLERRM);   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(202,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P304_user_account_eingabe''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 6626520673759604 + wwv_flow_api.g_id_offset,
  p_associated_item=> 6646003712759634 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8888202314353437 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 304
 ,p_name => 'submit_page_button_speichern'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 6627121354759604 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 8888503558353438 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 304
 ,p_event_id => 8888202314353437 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'SAVE'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p304_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p304_bl_loeschen  := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p304_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :p304_bl_aendern   := frgbg_s.holen_uebersetzung(162,v_sprache_id);'||unistr('\000a')||
'   :p304_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_s';

p:=p||'prache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p304_page_titel_patientanzeige := frgbg_s.holen_uebersetzung(482,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   :P304_NV_PATIENT := frgbg_s.holen_uebersetzung(3835,v_sprache_id);'||unistr('\000a')||
'  '||unistr('\000a')||
'   :p304_info := frgbg_s.holen_uebersetzung(173,v_sprache_id);'||unistr('\000a')||
'   :p304_fehler := frgbg_s.holen_uebersetzung(487,v_sprache_id);'||unistr('\000a')||
'   :p304_tab1_text := frgbg_s.holen_uebersetzung(484,v_sprache_id);'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6656420217759660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:PERSONENSTAMM:P304_ID:ID|IU';

wwv_flow_api.create_page_process(
  p_id     => 6672819265047173 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 11,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'personenstamm_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>6627121354759604 + wwv_flow_api.g_id_offset,
  p_process_when=>':request in (''SAVE'',''DELETE'',''CREATE'',''LIEFERLOESCHEN'',''RECHLOESCHEN'') ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_return_key_into_item1=>'P304_ID',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'-- Da evt. beim Speichern die Patientensprache geändert wird, kann dies '||unistr('\000a')||
'-- auf die FAS-Sprache auswirkungen haben => FAS-Sprache neu bestimmen'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :fas_sprache_id:= frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6658019256759664 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fas_sprache_festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 6653625631759653 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 61,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:PERSONENSTAMM:P304_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 6658203359759664 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 62,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'personenstamm_holen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   /* z.B. GUS-Adr. darf nicht im FAS verändert werden */'||unistr('\000a')||
'   :p304_pers_readonly:=frgbg_T.check_pers_extern_verwaltet(:p304_EXTERN_VERWALTET ) ; '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 12368623864474514 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 72,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_adr_readonly',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'    :p304_satzkennzeichen := ''GELOESCHT''; '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6656812293759660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 21,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_satz_delete',
  p_process_sql_clob => p,
  p_process_error_message=> 'Datensatz konnte nicht gelöscht werden!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>6673516542074695 + wwv_flow_api.g_id_offset,
  p_process_success_message=> 'Datensatz wurde erfolgreich gelöscht!',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p304_mutuser := :APP_USER;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6657432057759662 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 22,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mutuser_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p304_passwort := frgbg_s.gen_passwort(1);'||unistr('\000a')||
'   IF frgbg_s.get_pers_option(:APP_USER,28)= 1 THEN /* IABC-Betr.zugr*/  /* NEI 11.01.10 */'||unistr('\000a')||
'      :p304_erfuser := :APP_USER||''##''||to_char(:FAS_IDENTITAET_PERSSTAMM_ID)||''##'''||unistr('\000a')||
'                                ||to_char(:FAS_LOGIN_PERSONENSTAMM_ID)||''##'';'||unistr('\000a')||
'   ELSE /* Std.zugriff Identität */              '||unistr('\000a')||
'      :p304_erfuser := :APP_USER||''##''||to_c';

p:=p||'har(:FAS_IDENTITAET_PERSSTAMM_ID)||''##'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p304_mutuser := :p304_erfuser;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6657228752759662 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 31,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'erfuser_pw_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>6626520673759604 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p304_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      :p304_land_id := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6654206045759653 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 304,
  p_process_sequence=> 32,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_land_id_null',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 304
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00305
prompt  ...PAGE 305: Warenkorb_Kasse
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 305
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Warenkorb_Kasse'
 ,p_step_title => 'Warenkorb_Kasse'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Warenkorb_Kasse'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150417182200'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 1118632105655223 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 305,
  p_plug_name=> '&P305_REGION_TITEL_KASSE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 5,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':request not in (''BESTELL_ERROR'',''BESTELL_OK'',''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_SPEICHERN'',''WINDOW_CLOSE_PAY_CANCEL''   ) OR :request is NULL',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'wkd."ID",'||unistr('\000a')||
'wkd."ID" ID_DISPLAY,'||unistr('\000a')||
'wkd."WARENKORB_TMP_ID",'||unistr('\000a')||
'wkd."PRODKENNZ_ID",'||unistr('\000a')||
'wkd."P_REZEPT_ID",'||unistr('\000a')||
'wkd."MENGENART_ID",'||unistr('\000a')||
'wkd."MENGE",'||unistr('\000a')||
'wkd."VOLUMEN",'||unistr('\000a')||
'wkd."GEWICHT",'||unistr('\000a')||
'wkd."PREIS",'||unistr('\000a')||
'wkd."MWST_BETRAG",'||unistr('\000a')||
'wkd."MWST_SATZ",'||unistr('\000a')||
'wkd."WK_STATUS_ID",'||unistr('\000a')||
'wkd."STATUS_AENDERDATUM",'||unistr('\000a')||
'wkd."STATUS_AENDERVISUM",'||unistr('\000a')||
'wkd."ETIKETTENTYP",'||unistr('\000a')||
'wkd."BEMERKUNG",'||unistr('\000a')||
'wkd."ERFDAT",'||unistr('\000a')||
'wkd."ERFUSER",'||unistr('\000a')||
'wkd."MUTDAT",'||unistr('\000a')||
'wkd."MUTUSER",'||unistr('\000a')||
'--pr.rezept_nr||DECO';

s:=s||'DE(pr.version,NULL,NULL,''/''||pr.version) rezept_nr,  -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'  CASE WHEN mnr.rezept_nr_splitbasis is NULL AND mnr.version_splitbasis is NULL THEN'||unistr('\000a')||
'       pr.rezept_nr||DECODE(pr.version,NULL,NULL,''/''||pr.version)'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'       mnr.rezept_nr_splitbasis||DECODE(mnr.version_splitbasis,NULL,NULL,''/''||mnr.version_splitbasis)'||unistr('\000a')||
'  END rezept_nr,   '||unistr('\000a')||
'  CASE WHEN w';

s:=s||'kd.PRODKENNZ_ID = 1 THEN -- HCK-Mischung'||unistr('\000a')||
'      frgbg_s.get_pers_name_rezept(p_rezept_id)|| ''</br>''||'||unistr('\000a')||
'      frgbg_s.holen_uebersetzung(585,:fas_sprache_id)||'': ''||wkd.reichweite||'||unistr('\000a')||
'      DECODE (rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version),0,'''','||unistr('\000a')||
'         ''</br>''||fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version)'||unistr('\000a')||
'      ,:fas_sprache_id))';

s:=s||''||unistr('\000a')||
'  ELSE '||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)|| ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'  END kuerzel,'||unistr('\000a')||
'  TRUNC(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2) einzelpreis_brutto,'||unistr('\000a')||
' (trunc(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2))*NVL(wkd.MENGE,0)'||unistr('\000a')||
'               g';

s:=s||'esamtpreis_brutto'||unistr('\000a')||
'from WARENKORB_DETAILS_TMP wkd , prod_rezepte pr, mengenarts m,'||unistr('\000a')||
'     mn_rezepte mnr  -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'where warenkorb_tmp_id = :p305_warenkorb_tmp_id'||unistr('\000a')||
'  and p_rezept_id = pr.id (+)'||unistr('\000a')||
'  and mengenart_id = m.id (+)'||unistr('\000a')||
'  and (wkd.mengenart_id is NULL or wkd.mengenart_id != 101)'||unistr('\000a')||
'  AND pr.rezept_nr = mnr.rezept_nr(+) -- NEI 10.01.2014 Kumulation Splits zu ';

s:=s||'Gesamtrezept'||unistr('\000a')||
'  AND pr.version  = mnr.version (+)   -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'order by wkd.id';

wwv_flow_api.create_report_region (
  p_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 305,
  p_name=> '&P305_REGION_TITEL_WARENKORB.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_display_when_condition=> ':request not in (''BESTELL_ERROR'',''BESTELL_OK'','||unistr('\000a')||
'''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_SPEICHERN'',''WINDOW_CLOSE_PAY_CANCEL'') or :request is NULL',
  p_display_condition_type=> 'PLSQL_EXPRESSION',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P305_HEIGHT_WARENKORB.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3081,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '100',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1119403049655229 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1119511582655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1119625101655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID_DISPLAY',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID_DISPLAY',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1119721738655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_TMP_ID',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WARENKORB_TMP_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1119815425655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PRODKENNZ_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1119904792655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'P_REZEPT_ID',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'P_REZEPT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120026064655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120110758655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_inline_lov=> '1,2,3,4,5,6,7,8,9,10',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '5',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120214464655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'VOLUMEN',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'VOLUMEN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120313877655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'GEWICHT',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'GEWICHT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120406543655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'PREIS',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PREIS',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120520532655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_BETRAG',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_BETRAG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120619460655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_SATZ',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_SATZ',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120728459655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS_ID',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WK_STATUS_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120825705655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERDATUM',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERDATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1120920106655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERVISUM',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERVISUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121004616655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'ETIKETTENTYP',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ETIKETTENTYP',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121114631655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '20',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'BEMERKUNG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121222585655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'ERFDAT',
  p_column_display_sequence=> 23,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121317453655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'ERFUSER',
  p_column_display_sequence=> 24,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121418031655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'MUTDAT',
  p_column_display_sequence=> 25,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121505644655231 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'MUTUSER',
  p_column_display_sequence=> 26,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121620478655232 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121707340655232 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121809424655232 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'EINZELPREIS_BRUTTO',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 1121925485655232 + wwv_flow_api.g_id_offset,
  p_region_id=> 1119219135655228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'GESAMTPREIS_BRUTTO',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 1122300450655234 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 305,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p305_bestell_status = ''KASSE''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 1159307770184787 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 305,
  p_plug_name=> '&P305_REGION_TITEL_BESTELLINFO.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':request in (''BESTELL_ERROR'',''BESTELL_OK'','||unistr('\000a')||
'''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_SPEICHERN'',''WINDOW_CLOSE_PAY_CANCEL'')',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 1123118816655253 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 305,
  p_button_sequence=> 10,
  p_button_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P305_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 1123921449655253 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 305,
  p_button_sequence=> 40,
  p_button_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_button_name    => 'BESTELLEN',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P305_BL_BESTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT count(* )'||unistr('\000a')||
'   INTO v_anz'||unistr('\000a')||
'   FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id=:P305_WARENKORB_TMP_ID;'||unistr('\000a')||
'   IF v_anz >0 and'||unistr('\000a')||
'      ((:P305_persstamm_id_prod_apo = 1430 and :p300_wk_artikeltyp_flag != 1) -- bei normalen Aufträgen muss prod. Apo 1430 sein'||unistr('\000a')||
'        OR  :p300_wk_artikeltyp_flag = 1 -- Laborauftrag unabhängig prod Apo => z.Z. nicht über GUS '||unistr('\000a')||
'      )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4803915437858437 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 305,
  p_button_sequence=> 50,
  p_button_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_button_name    => 'BESTELLEN_GUS',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'GUS Bestellen',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'  RETURN false; -- Was nach GUS soll geht nun immer nach GUS über BEstellen-Button'||unistr('\000a')||
'/*'||unistr('\000a')||
'   SELECT count(* )'||unistr('\000a')||
'   INTO v_anz'||unistr('\000a')||
'   FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id=:P305_WARENKORB_TMP_ID;'||unistr('\000a')||
'   IF v_anz >0 and :P305_persstamm_id_prod_apo = 1430 '||unistr('\000a')||
'      and frgbg_s.check_fas_rolle(:APP_USER,''GUS_BESTELLUNG_AUSLOESEN'')> 0 '||unistr('\000a')||
'      and :p300_wk_artikeltyp_flag != 1 -- nicht Laborauftrag'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>1138206150655285 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P305_ZURUECK_SEITE.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>1123118816655253+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>1159013741167619 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:305:&SESSION.:BESTELL_OK:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 20,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BESTELLEN'',''BESTELLEN_GUS'') and '||unistr('\000a')||
':p305_bestell_status=''BESTELL_OK'' and'||unistr('\000a')||
':p305_zahlungsart in (1,3) /* Rechnung/Vorkasse */',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-JAN-2011 09:55 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>1505005788953097 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:220:&SESSION.:BRANCH_TO_PAGE_ACCEPT|START:&DEBUG.:220:P220_WARENKORB_ID,P220_ZURUECK_SEITE:&P305_WARENKORB_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 25,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BESTELLEN'',''BESTELLEN_GUS'') '||unistr('\000a')||
'AND :p305_zahlungsart in (2) /* Kreditkarte */'||unistr('\000a')||
'AND :p305_bestell_status = ''BESTELL_OK''',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 27-SEP-2010 10:40 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>1158631618163342 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:305:&SESSION.:BESTELL_ERROR:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BESTELLEN'',''BESTELLEN_GUS'') and '||unistr('\000a')||
':p305_bestell_status=''BESTELL_ERROR''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-JAN-2011 09:55 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>1164023157350091 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P305_ZURUECK_SEITE_NACH_BEST.:&SESSION.::&DEBUG.:305,300::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>1163705795316689+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 40,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p305_bestell_status = ''BESTELL_ERROR''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-JAN-2011 10:26 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>1164201124353209 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P305_ZURUECK_SEITE_NACH_BEST.:&SESSION.::&DEBUG.:305,300::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>1163705795316689+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 50,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p305_bestell_status = ''BESTELL_OK''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-JAN-2011 10:26 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>1139405923655287 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:305:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1124318488655254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_ZAHLUNGSART',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''WK_ZAHLUNGSARTEN.BEZEICHNUNG'','||unistr('\000a')||
'                                       ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'       id'||unistr('\000a')||
'FROM WK_ZAHLUNGSARTEN'||unistr('\000a')||
'WHERE satz_kennzeichen is null '||unistr('\000a')||
'  and frgbg_s.WK_CHECK_ZAHLUNGSART(id)=1'||unistr('\000a')||
'order by sortierung',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'/* Eine Änderung ist nur möglich, wenn kein abhängiger WK eingetragen ist */'||unistr('\000a')||
':P305_WARENKORB_ID_REFERENZ is not null ',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'NONE',
  p_attribute_04 => 'VERTICAL',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1124708783655257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_WARENKORB_TMP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb-ID',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1124914122655257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_GESAMTWERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'to_char(trunc(NVL(:p305_gesamtpreis,0) + NVL(:p305_mwst_betrag_1,0)+ NVL(:p305_mwst_betrag_2,0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P305_GESAMTWERT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1125117284655257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_GESAMT_MWST_BETRAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'to_char(trunc(NVL(:p305_mwst_betrag_1,0) + NVL(:p305_mwst_betrag_2,0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1125322838655257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_WAEHRUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'&#160',
  p_post_element_text=>'&#160',
  p_source=>'rezepte.get_waehrung_zeichen(:p305_waehrung_id);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1125729621655259 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_PERSSTAMM_ID_KUNDE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id',
  p_source=>'PERSSTAMM_ID_KUNDE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1125924744655259 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'DECLARE'||unistr('\000a')||
'   v_name   VARCHAR2(1000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P305_PERSSTAMM_ID_KUNDE is not null THEN'||unistr('\000a')||
'      SELECT NAME||'' ''||VORNAME ||'' ''||to_char(GEBURTSDATUM,''DD.MM.RRRR'')'||unistr('\000a')||
'      INTO v_name'||unistr('\000a')||
'      from personenstamm'||unistr('\000a')||
'      where id = :P305_PERSSTAMM_ID_KUNDE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN v_name;'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1126100050655259 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 139,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1126309238655260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_REGION_TITEL_KASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Eingabe',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1126522446655260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_REGION_TITEL_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1127121637655260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_BL_BESTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Zur Kasse',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1127505325655260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_HEIGHT_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Height Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1127715037655260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_ETTIKETTENTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ettikettentyp',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,1);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1127925350655262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1128115954655262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 23,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Plandatum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1128303705655262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land Id',
  p_source=>'VERRECH_LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1128500833655262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 22,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Waehrung Id',
  p_source=>'WAEHRUNG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1128715706655262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtpreis',
  p_source=>'GESAMTPREIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1128928464655262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_MWST_JN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Jn',
  p_source=>'MWST_JN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1129107562655262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_MWST_BETRAG_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 1',
  p_source=>'MWST_BETRAG_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1129329821655262 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_MWST_BETRAG_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 2',
  p_source=>'MWST_BETRAG_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1129516900655264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_MWST_SATZ_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 1',
  p_source=>'MWST_SATZ_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1129724761655264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_MWST_SATZ_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 2',
  p_source=>'MWST_SATZ_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1129904743655264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_WK_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wk Status Id',
  p_source=>'WK_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1130131085655264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_STATUS_AENDERDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aenderdatum',
  p_source=>'STATUS_AENDERDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1130311881655264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_STATUS_AENDERVISUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aendervisum',
  p_source=>'STATUS_AENDERVISUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1130517372655264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1130701177655264 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Login',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1130930403655265 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1132729249655268 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_REGION_TITEL_ADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 122,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1133520668655270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1134109886655270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_WAHL_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 220,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wahl Identitaet',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1134525429655271 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_NV_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1134713591655271 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_VERSANDKOSTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160&#160&P305_WAEHRUNG.',
  p_source=>'SELECT to_char(NVL(sum(preis+mwst_betrag),0),''999G999G999G999G990D00'')'||unistr('\000a')||
'from warenkorb_details_tmp'||unistr('\000a')||
'where warenkorb_tmp_id = :p305_warenkorb_tmp_id'||unistr('\000a')||
'  and mengenart_id = 101;',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1156727435399381 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_BESTELL_STATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bestell Status',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1159604091193257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_BESTELLHINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 1159307770184787+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1163705795316689 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_HINWEIS_OK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 1159307770184787+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BESTELL_ENDE',
  p_prompt=>'OK',
  p_source=>'BESTELL_ENDE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1168717410433609 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_WARENKORB_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 215,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1189902026192664 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_NV_WK_KASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Wk Kasse',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>1190516823490257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_REGION_TITEL_BESTELLINFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 123,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Bestellinfo',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2057110930059592 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_ZURUECK_SEITE_NACH_BEST',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 215,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4066525378983062 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_INKL_MWST_LABEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 41,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4380704653497201 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_PERSSTAMM_ID_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Ident',
  p_source=>'PERSSTAMM_ID_IDENTITAET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4804626405403858 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4804823072412415 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4816813566690646 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_WK_VERSANDART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'(',
  p_post_element_text=>')',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7157712474580366 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_SORTIMENT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 1119219135655228+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'SORTIMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12599729235314250 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_WK_ZAHLUNGSART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'WK_ZAHLUNGSART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12600017146334995 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 305,
  p_name=>'P305_WARENKORB_ID_REFERENZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 1118632105655223+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'WARENKORB_ID_REFERENZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10318908675115044 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_kunde_adressen_vollstaendigkeit',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_adresszusatz personenstamm.adresszusatz%TYPE;'||unistr('\000a')||
'   v_telefon      personenstamm.telefon%TYPE;'||unistr('\000a')||
'   v_mobiltelefon personenstamm.mobiltelefon%TYPE;'||unistr('\000a')||
'   v_fax          personenstamm.fax%TYPE;'||unistr('\000a')||
'   v_gus_id       personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_anrede_id    personenstamm.anrede_id%TYPE; -- NEI 13.08.14 Kunde darf keine Firma sein'||unistr('\000a')||
'   v_wk_extern_verwaltet warenkoerbe.extern_verwaltet%TYPE;'||unistr('\000a')||
'   v_prot_id      number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/308: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Kunderadresse müssen vollständig sein, wenn der Auftrag an GUS geht und noch keine GUS-ID für den Kunden vorhanden ist, sonst kann GUS den Kunden nicht anlegen'||unistr('\000a')||
'   -- holen der Kundenadr. aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          p.gus_id,wk.extern_verwaltet,'||unistr('\000a')||
'          p.adresszusatz, p.telefon, p.mobiltelefon, p.fax,'||unistr('\000a')||
'          p.anrede_id  -- NEI 13.08.14'||unistr('\000a')||
'   INTO v_plz, v_ort, v_land_id,v_strasse,v_name,v_vorname,'||unistr('\000a')||
'        v_gus_id,v_wk_extern_verwaltet,'||unistr('\000a')||
'        v_adresszusatz, v_telefon, v_mobiltelefon, v_fax,'||unistr('\000a')||
'        v_anrede_id   -- NEI 13.08.14'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p305_id'||unistr('\000a')||
'     AND wk.persstamm_id_kunde =p.id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   -- NEI 13.08.14 immer prüfen'||unistr('\000a')||
'   --IF v_gus_id is NULL AND v_wk_extern_verwaltet = 1 -- Zur Zeit findet nur in diesem Fall von FAS in GUS eine Adressanlage statt'||unistr('\000a')||
'   --THEN'||unistr('\000a')||
'      IF (v_plz is NULL OR v_ort is NULL OR v_land_id IS NULL OR '||unistr('\000a')||
'          v_strasse IS NULL OR v_name IS NULL OR v_vorname IS NULL'||unistr('\000a')||
'         )'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         -- ''Die Kundenadresse ist unvollständig! Die Felder Name, Vorname, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'         RETURN frgbg_s.holen_uebersetzung(5901,:fas_sprache_id);	'||unistr('\000a')||
'      END IF;   '||unistr('\000a')||
''||unistr('\000a')||
'      -- NEI 03.07.14 Feldlängenprüfungen, da GUS kürzere Felder hat'||unistr('\000a')||
'      IF length(v_name) > 40 OR length(v_vorname) > 40 OR length(v_ADRESSZUSATZ)> 40 OR'||unistr('\000a')||
'         length(v_ort) > 40 OR length(v_strasse) > 40 '||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         --''Die Adressdaten (Kundenadresse) ist für unser Bestellsystem zu lang! Die Felder Name, Vorname, Strasse, Ort, Adresszusatz dürfen nur 40 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.''); '||unistr('\000a')||
'         RETURN frgbg_s.holen_uebersetzung(10165,:fas_sprache_id, frgbg_s.holen_uebersetzung(5521,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF length(v_telefon) > 20 OR length(v_mobiltelefon) > 20 OR length(v_fax)> 20 '||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         -- ''Die Kommunikationsdaten (Kundenadresse) sind für unser Bestellsystem zu lang! Die Felder Telefon, Mobiltelefon, Fax dürfen jeweils nur 20 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.'''||unistr('\000a')||
'         RETURN frgbg_s.holen_uebersetzung(10166,:fas_sprache_id, frgbg_s.holen_uebersetzung(5521,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   --END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 13.08.14 Kunde darf keine Firma sein'||unistr('\000a')||
'   IF  v_anrede_id = 5 THEN'||unistr('\000a')||
'       -- Sie verwenden als Kundenadresse eine Firma. Das ist an dieser Stelle nicht möglich. Eine Firma können Sie als abweichende Lieferadresse angeben.'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(10369,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 1123921449655253 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10319427853130011 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_lief_adressen_vollstaendigkeit',
  p_validation_sequence=> 20,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz_lief          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort_lief          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id_lief      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse_lief      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name_lief         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname_lief      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_persstamm_id_lief personenstamm.id%TYPE;'||unistr('\000a')||
'   v_adresszusatz_lief personenstamm.adresszusatz%TYPE;'||unistr('\000a')||
'   v_persstamm_id_kunde personenstamm.id%TYPE;'||unistr('\000a')||
'   v_land_id_kunde      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/308: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
''||unistr('\000a')||
'   -- Lieferadresse müssen vollständig sein'||unistr('\000a')||
'   -- holen der Lieferadr. aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          wk.persstamm_id_lieferung,wk.persstamm_id_kunde,'||unistr('\000a')||
'          p.adresszusatz'||unistr('\000a')||
'   INTO v_plz_lief, v_ort_lief, v_land_id_lief,v_strasse_lief,v_name_lief,v_vorname_lief,'||unistr('\000a')||
'          v_persstamm_id_lief,v_persstamm_id_kunde,'||unistr('\000a')||
'        v_adresszusatz_lief'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p305_id'||unistr('\000a')||
'     AND wk.persstamm_id_lieferung =p.id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF v_plz_lief is NULL OR v_ort_lief is NULL OR v_land_id_lief IS NULL OR '||unistr('\000a')||
'      v_strasse_lief IS NULL OR v_name_lief IS NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Lieferadresse ist unvollständig! Die Felder Name, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5900,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 03.07.14 Feldlängenprüfungen, da GUS kürzere Felder hat'||unistr('\000a')||
'   IF length(v_name_lief) > 40 OR length(v_vorname_lief) > 40 OR length(v_ADRESSZUSATZ_lief)> 40 OR'||unistr('\000a')||
'      length(v_ort_lief) > 40 OR length(v_strasse_lief) > 40 '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --''Die Adressdaten (Lieferadresse) ist für unser Bestellsystem zu lang! Die Felder Name, Vorname, Strasse, Ort, Adresszusatz dürfen nur 40 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.''); '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(10165,:fas_sprache_id, frgbg_s.holen_uebersetzung(3114,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   /* '||unistr('\000a')||
'   -- Kundenadresse und Lieferadresse müssen im gleichen Land sein, damit kein Währungswechsel/Mwstwechsel erfolgen muss'||unistr('\000a')||
'   IF v_persstamm_id_lief != NVL(v_persstamm_id_kunde,0) THEN'||unistr('\000a')||
'      SELECT p.land_id'||unistr('\000a')||
'      INTO v_land_id_kunde'||unistr('\000a')||
'      FROM personenstamm p'||unistr('\000a')||
'      WHERE id = v_persstamm_id_kunde;'||unistr('\000a')||
'      IF v_land_id_kunde != v_land_id_lief THEN'||unistr('\000a')||
'         RETURN frgbg_s.holen_uebersetzung(9602,:fas_sprache_id);	'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 1123921449655253 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10319601665131943 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_rech_adressen_vollstaendigkeit',
  p_validation_sequence=> 30,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz_rech          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort_rech          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id_rech      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse_rech      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name_rech         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname_rech      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_adresszusatz_rech personenstamm.adresszusatz%TYPE;'||unistr('\000a')||
'   v_telefon_rech      personenstamm.telefon%TYPE;'||unistr('\000a')||
'   v_mobiltelefon_rech personenstamm.mobiltelefon%TYPE;'||unistr('\000a')||
'   v_fax_rech          personenstamm.fax%TYPE;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/308: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Rechnungsadresse müssen vollständig sein'||unistr('\000a')||
'   -- holen der Rechadr aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          p.adresszusatz, p.telefon, p.mobiltelefon, p.fax'||unistr('\000a')||
'   INTO v_plz_rech, v_ort_rech, v_land_id_rech,v_strasse_rech,v_name_rech,v_vorname_rech,'||unistr('\000a')||
'        v_adresszusatz_rech, v_telefon_rech, v_mobiltelefon_rech, v_fax_rech'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p305_id'||unistr('\000a')||
'     AND wk.persstamm_id_rechnung =p.id;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_plz_rech is NULL OR v_ort_rech is NULL OR v_land_id_rech is NULL OR'||unistr('\000a')||
'      v_strasse_rech IS NULL OR v_name_rech IS NULL OR v_vorname_rech IS NULL  -- NEI 09.09.2014 Feld kann leer sein lt. Lilian Nutz'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Rechnungsadresse ist unvollständig! Die Felder Name, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5569,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 03.07.14 Feldlängenprüfungen, da GUS kürzere Felder hat'||unistr('\000a')||
'   IF length(v_name_rech) > 40 OR length(v_vorname_rech) > 40 OR length(v_ADRESSZUSATZ_rech)> 40 OR'||unistr('\000a')||
'      length(v_ort_rech) > 40 OR length(v_strasse_rech) > 40 '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --''Die Adressdaten (Rechnungsadresse) ist für unser Bestellsystem zu lang! Die Felder Name, Vorname, Strasse, Ort, Adresszusatz dürfen nur 40 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.''); '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(10165,:fas_sprache_id, frgbg_s.holen_uebersetzung(3113,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF length(v_telefon_rech) > 20 OR length(v_mobiltelefon_rech) > 20 OR length(v_fax_rech)> 20 '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Kommunikationsdaten (Rechnungsadresse) sind für unser Bestellsystem zu lang! Die Felder Telefon, Mobiltelefon, Fax dürfen jeweils nur 20 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.'''||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(10166,:fas_sprache_id, frgbg_s.holen_uebersetzung(3113,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 1123921449655253 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10320022228147314 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_adress_kompatibel',
  p_validation_sequence=> 40,
  p_validation => 'Declare'||unistr('\000a')||
'   v_return NUMBER;'||unistr('\000a')||
'   v_fehlertext uebersetzungen.text%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   v_return := frgbg_s.WK_CHECK_ADR_KOMPATIBEL(p_persstamm_id_prod_apo => :P305_PERSSTAMM_ID_prod_apo,'||unistr('\000a')||
'                                               p_persstamm_id_kunde    => :P305_PERSSTAMM_ID_kunde,'||unistr('\000a')||
'                                               p_persstamm_id_lieferung=> :P305_PERSSTAMM_ID_LIEFERUNG,'||unistr('\000a')||
'                                               p_persstamm_id_rechnung => :P305_PERSSTAMM_ID_RECHNUNG,'||unistr('\000a')||
'                                               p_warenkorb_tmp_id      => :P305_ID,  -- NEI 05.06.2014'||unistr('\000a')||
'                                               p_sprache_id            => :fas_sprache_id ,'||unistr('\000a')||
'                                               p_fehlertext_out        => v_fehlertext'||unistr('\000a')||
'                                               );'||unistr('\000a')||
'   IF v_return = 1 THEN'||unistr('\000a')||
'      RETURN '''';'||unistr('\000a')||
'   ELSIF v_fehlertext is not null THEN'||unistr('\000a')||
'      --''Die Lieferadresse muss auch in der Schweiz liegen, da die Kunden-/ die Rechnungsadresse in der Schweiz liegt!'''||unistr('\000a')||
'      -- ''Liefer- und Kundenadresse müssen im gleichen Land liegen'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5727,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''CANCEL'', ''KASSE'')',
  p_when_button_pressed=> 1123921449655253 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 9441921247254176 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 305
 ,p_name => 'Submit Page Button: BESTELLEN'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 1123921449655253 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 9442232473254176 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 305
 ,p_event_id => 9441921247254176 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'BESTELLEN'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p305_bl_abbrechen := --frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'                         frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p305_bl_bestellen := frgbg_s.holen_uebersetzung(4486,v_sprache_id);'||unistr('\000a')||
'   :P305_INKL_MWST_LABEL:= frgbg_s.holen_uebersetzung(5522,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p305_region_titel_kasse ';

p:=p||':= frgbg_s.holen_uebersetzung(4357,v_sprache_id);'||unistr('\000a')||
'   :p305_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :p305_region_titel_adresse := frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   :p305_region_titel_bestellinfo := frgbg_s.holen_uebersetzung(4488,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P305_NV_WK_KASSE := frgbg_s.holen_uebersetzung(4487,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende';

p:=p||''', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1135704040655276 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_process_sequence=> 51,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_wk_id                  warenkoerbe.id%TYPE;'||unistr('\000a')||
'   v_wkorb_detail_tmp_id    warenkorb_details.id%TYPE;'||unistr('\000a')||
'   v_wk_status_id           warenkoerbe.wk_status_id%TYPE;'||unistr('\000a')||
'   v_extern_verwaltet       warenkoerbe.extern_verwaltet%TYPE;'||unistr('\000a')||
'   v_reichweite             warenkorb_details.reichweite%TYPE;'||unistr('\000a')||
'   v_laborauftrag  number;  -- NEI 07.05.2014'||unistr('\000a')||
'   v_anz      number;'||unistr('\000a')||
'   v_return   number;'||unistr('\000a')||
'   v_prot_id ';

p:=p||' number;'||unistr('\000a')||
'   v_fehlertext  uebersetzungen.text%TYPE;'||unistr('\000a')||
'  '||unistr('\000a')||
'   CURSOR c_wkorb_detail is'||unistr('\000a')||
'          SELECT * '||unistr('\000a')||
'          FROM warenkorb_details_tmp'||unistr('\000a')||
'          WHERE warenkorb_tmp_id = :p305_warenkorb_tmp_id'||unistr('\000a')||
'            -- Versandkosten werden neu ermittelt'||unistr('\000a')||
'            --AND (mengenart_id != 101 OR mengenart_id is null); NEI 12.12.12 wird nicht mehr über Trigger gesteuert, sondern beim Ausloesen der Kasse, ';

p:=p||'da ggf. GUS-Anfrage'||unistr('\000a')||
'          ;'||unistr('\000a')||
'   CURSOR c_wkorb_det_verordnung is'||unistr('\000a')||
'          SELECT * '||unistr('\000a')||
'          FROM wkorb_det_verordnungen_tmp'||unistr('\000a')||
'          WHERE warenkorb_detail_tmp_id = v_wkorb_detail_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prüfen, ob Details vorhanden'||unistr('\000a')||
'   SELECT count(*) INTO v_anz'||unistr('\000a')||
'   FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id = :p305_warenkorb_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P(''speichern Kasse anz: %1, %2, %3'',v_prot_i';

p:=p||'d,''Info'',''speichern kasse 102/300'',v_anz,sqlerrm,:p305_zahlungsart);               */'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_anz = 0 THEN'||unistr('\000a')||
'      return;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   /* NEI 07.05.2014 Bei Laboraufträge muss das Feld Labor_id und labor_auftrag_id gefüllt sein für jede Position ausser Versandkosten */'||unistr('\000a')||
'   v_return := frgbg_s.WK_CHECK_LABORAUFTRAG( :p305_warenkorb_tmp_id,1 );'||unistr('\000a')||
'   IF v_return >= 1 THEN -- Laborauftrag'||unistr('\000a')||
'      v_labor';

p:=p||'auftrag := 1;  -- Labor'||unistr('\000a')||
'   ELSIF v_return < 0 THEN -- Fehler'||unistr('\000a')||
'      raise_application_error(-20001,''Der Typ(Labor/normaler WK) des Warenkorbs kann nicht bestimmt werden! '' ||SQLERRM); '||unistr('\000a')||
'   ELSE '||unistr('\000a')||
'      v_laborauftrag := 0;  -- kein Labor'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Kopieren der temporären WK ins die permanenten WK'||unistr('\000a')||
'   -- kopieren über rowtype geht nicht da wk_tmp und wk sich in der Spalte session_id unterscheid';

p:=p||'en'||unistr('\000a')||
'   select WARENKORB_SEQ.nextval into v_wk_id from dual;'||unistr('\000a')||
'   /* Status wird im onLoad gesetzt'||unistr('\000a')||
'   IF :p305_zahlungsart = 3 THEN -- Vorkasse'||unistr('\000a')||
'       v_wk_status_id := 5;         -- Z.Z noch manuelle Vorkasseanforderung später auch auf 6'||unistr('\000a')||
'   ELSIF :p305_zahlungsart = 1 THEN -- Rechnung  '||unistr('\000a')||
'       v_wk_status_id := 6;         -- Direkt auf 6 zur GUS-Prüfung und Druck'||unistr('\000a')||
'   ELSIF :p305_zahlungsart = 2 THEN -';

p:=p||'- Kreditkarte'||unistr('\000a')||
'      v_wk_status_id := 5;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
''||unistr('\000a')||
'   v_wk_status_id := 5;'||unistr('\000a')||
''||unistr('\000a')||
'   IF :request = ''BESTELLEN_GUS'' THEN'||unistr('\000a')||
'      v_extern_verwaltet := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      v_extern_verwaltet := :p305_extern_verwaltet;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 21.11.14 ggf. Bonusartikel-Positionen hinzunehmen'||unistr('\000a')||
'   v_return := frgbg_s.WK_GEN_BONUSARTIKEL(:p305_warenkorb_tmp_id,1) ;'||unistr('\000a')||
'  '||unistr('\000a')||
'   INSERT INTO warenkoerbe ('||unistr('\000a')||
'            ';

p:=p||'               ID ,'||unistr('\000a')||
'                           PLANDATUM ,'||unistr('\000a')||
'                           VERRECH_LAND_ID ,'||unistr('\000a')||
'                           WAEHRUNG_ID ,'||unistr('\000a')||
'                           GESAMTPREIS ,'||unistr('\000a')||
'                           MWST_JN ,'||unistr('\000a')||
'                           MWST_BETRAG_1 ,'||unistr('\000a')||
'                           MWST_BETRAG_2 ,'||unistr('\000a')||
'                           MWST_SATZ_1 ,'||unistr('\000a')||
'                           MWST_SATZ_2 ,'||unistr('\000a')||
'         ';

p:=p||'                  WK_STATUS_ID ,'||unistr('\000a')||
'                           STATUS_AENDERDATUM ,'||unistr('\000a')||
'                           STATUS_AENDERVISUM ,'||unistr('\000a')||
'                           PERSSTAMM_ID_RECHNUNG ,'||unistr('\000a')||
'                           PERSSTAMM_ID_LOGIN ,'||unistr('\000a')||
'                           PERSSTAMM_ID_LIEFERUNG ,'||unistr('\000a')||
'                           persstamm_id_identitaet,'||unistr('\000a')||
'                           persstamm_id_prod_apo,'||unistr('\000a')||
'                  ';

p:=p||'         persstamm_id_kunde,        -- NEI 14.01.11'||unistr('\000a')||
'                           persstamm_id_rechnungssteller, -- NEI 08.03.12 Verrechland Bestimmung neu'||unistr('\000a')||
'                           preisliste_id,             -- NEI 15.10.09'||unistr('\000a')||
'                           art_mwst_typ_id,           -- NEI 30.11.09 Artikel-MWST-Umstellung'||unistr('\000a')||
'                           preisfaktor,               -- NEI 03.12.09'||unistr('\000a')||
'             ';

p:=p||'              sortiment_id,              -- NEI 09.06.11'||unistr('\000a')||
'                           wk_zahlungsart_id,         -- NEI 28.03.12'||unistr('\000a')||
'                           widerrufsfrist,            -- NEI 28.03.12'||unistr('\000a')||
'                           extern_verwaltet,          -- NEI 12.12.12'||unistr('\000a')||
'                           wk_versandart_id,          -- NEI 04.03.13'||unistr('\000a')||
'                           aerztlich_verordnet,        -- NEI 0';

p:=p||'8.06.13'||unistr('\000a')||
'                           kassenabrechnung,          -- NEI 06.10.14'||unistr('\000a')||
'                           labor_mit_fb,              -- NEI 14.10.14'||unistr('\000a')||
'                           WARENKORB_ID_REFERENZ,     -- NEI 20.03.15'||unistr('\000a')||
'                           BEMERKUNG ,'||unistr('\000a')||
'                           ERFDAT ,'||unistr('\000a')||
'                           ERFUSER ,'||unistr('\000a')||
'                           MUTDAT ,'||unistr('\000a')||
'                           MUTUSER';

p:=p||' )'||unistr('\000a')||
'   SELECT '||unistr('\000a')||
'                           v_wk_id,'||unistr('\000a')||
'                           PLANDATUM ,'||unistr('\000a')||
'                           VERRECH_LAND_ID ,'||unistr('\000a')||
'                           WAEHRUNG_ID ,'||unistr('\000a')||
'                           GESAMTPREIS ,'||unistr('\000a')||
'                           MWST_JN ,'||unistr('\000a')||
'                           MWST_BETRAG_1 ,'||unistr('\000a')||
'                           MWST_BETRAG_2 ,'||unistr('\000a')||
'                           MWST_SATZ_1 ,'||unistr('\000a')||
'                    ';

p:=p||'       MWST_SATZ_2 ,'||unistr('\000a')||
'                           v_wk_STATUS_ID ,'||unistr('\000a')||
'                           STATUS_AENDERDATUM ,'||unistr('\000a')||
'                           STATUS_AENDERVISUM ,'||unistr('\000a')||
'                           PERSSTAMM_ID_RECHNUNG ,'||unistr('\000a')||
'                           PERSSTAMM_ID_LOGIN ,'||unistr('\000a')||
'                           PERSSTAMM_ID_LIEFERUNG ,'||unistr('\000a')||
'                           persstamm_id_identitaet,'||unistr('\000a')||
'                           persstamm';

p:=p||'_id_prod_apo,'||unistr('\000a')||
'                           persstamm_id_kunde,          -- NEI 14.01.11'||unistr('\000a')||
'                           persstamm_id_rechnungssteller,-- NEI 08.03.12'||unistr('\000a')||
'                           preisliste_id,               -- NEI 15.10.09'||unistr('\000a')||
'                           art_mwst_typ_id ,            -- NEI 30.11.09 Artikel-MWST-Umstellung'||unistr('\000a')||
'                           preisfaktor  ,               -- NEI 03.12.09'||unistr('\000a')||
' ';

p:=p||'                          sortiment_id ,               -- NEI 09.06.11'||unistr('\000a')||
'                           :p305_zahlungsart,           -- NEI 28.03.12'||unistr('\000a')||
'                           widerrufsfrist,              -- NEI 28.03.12'||unistr('\000a')||
'                           v_extern_verwaltet,          -- NEI 12.12.12'||unistr('\000a')||
'                           wk_versandart_id,            -- NEI 04.03.13'||unistr('\000a')||
'                           aerztlich_vero';

p:=p||'rdnet,        -- NEI 08.06.13'||unistr('\000a')||
'                           kassenabrechnung,           -- NEI 06.10.14'||unistr('\000a')||
'                           labor_mit_fb,               -- NEI 14.10.14'||unistr('\000a')||
'                           WARENKORB_ID_REFERENZ,      -- NEI 20.03.15'||unistr('\000a')||
'                           BEMERKUNG ,'||unistr('\000a')||
'                           SYSDATE ,'||unistr('\000a')||
'                           :APP_USER,'||unistr('\000a')||
'                           SYSDATE,'||unistr('\000a')||
'       ';

p:=p||'                    :APP_USER'||unistr('\000a')||
'   FROM warenkoerbe_tmp'||unistr('\000a')||
'   WHERE id = :p305_warenkorb_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Wkorb-Details und Verordnung kopieren'||unistr('\000a')||
'   FOR r_wkorb_detail in c_wkorb_detail LOOP'||unistr('\000a')||
'       v_wkorb_detail_tmp_id := r_wkorb_detail.id;'||unistr('\000a')||
'       select WKORB_DET_SEQ.nextval into r_wkorb_detail.id from dual ;'||unistr('\000a')||
'       r_wkorb_detail.warenkorb_tmp_id := v_wk_id;'||unistr('\000a')||
'       r_wkorb_detail.wk_status_id := v_wk_st';

p:=p||'atus_id;'||unistr('\000a')||
''||unistr('\000a')||
'       -- alle Blanks entfernen'||unistr('\000a')||
'       r_wkorb_detail.labor_auftrag_id :=regexp_replace(r_wkorb_detail.labor_auftrag_id,''[ ]'','''');'||unistr('\000a')||
''||unistr('\000a')||
'       -- Im Falle eines Produktrezeptes nochmals die Reichweite prüfen. '||unistr('\000a')||
'       -- WK-Reichweite muss mit Produktrezept übereinstimmen, sonst wurde nachträgl. '||unistr('\000a')||
'       -- nochmals die Reichweite des Prodrezeptes geändert => würde zu falschen Preisen und Meng';

p:=p||'en führen'||unistr('\000a')||
'       IF r_wkorb_detail.p_rezept_id is NOT NULL AND r_wkorb_detail.mengenart_id IS NULL THEN'||unistr('\000a')||
'          SELECT reichweite INTO v_reichweite'||unistr('\000a')||
'          FROM prod_rezepte'||unistr('\000a')||
'          WHERE ID = r_wkorb_detail.p_rezept_id;'||unistr('\000a')||
'          IF NVL(r_wkorb_detail.reichweite,0) != v_reichweite THEN'||unistr('\000a')||
'             raise_application_error(-20000,''Die Reichweite des Produktrezepte entspricht nicht mehr der v';

p:=p||'ermerkten Reichweite im Warenkorb! Bestellung kann nicht in den permanenten WK übernommen werden!''); '||unistr('\000a')||
'          END IF;'||unistr('\000a')||
'       END IF;'||unistr('\000a')||
''||unistr('\000a')||
'       -- NEI 07.05.2014 Im Falle eines Laborauftrags muss labor_id und laborauftrag_id bestückt sein'||unistr('\000a')||
'       IF v_laborauftrag = 1 THEN '||unistr('\000a')||
'          IF r_wkorb_detail.labor_id is NULL THEN'||unistr('\000a')||
'             raise_application_error(-20000,''Der Laborauftrag enthält keine L';

p:=p||'aborspezifikation! Bestellung kann nicht in den permanenten WK übernommen werden!''); '||unistr('\000a')||
'          END IF;'||unistr('\000a')||
'          '||unistr('\000a')||
'          -- Interne Warenkorb-ID als Laborauftrag-ID verwenden => Es ist sichergestellt, dass nur bei fas-vergebenen Laborauftragsnummer dieses Feld NULL ist'||unistr('\000a')||
'          IF r_wkorb_detail.labor_auftrag_id IS NULL THEN'||unistr('\000a')||
'             r_wkorb_detail.labor_auftrag_id := v_wk_id; '||unistr('\000a')||
'          ';

p:=p||'END IF;'||unistr('\000a')||
' '||unistr('\000a')||
'       END IF;'||unistr('\000a')||
''||unistr('\000a')||
'       INSERT INTO warenkorb_details'||unistr('\000a')||
'       VALUES r_wkorb_detail;'||unistr('\000a')||
'       -- Verordnungen kopieren'||unistr('\000a')||
'       FOR r_wkorb_det_verordnung in c_wkorb_det_verordnung LOOP'||unistr('\000a')||
'          select WK_VERORD_SEQ.nextval into r_wkorb_det_verordnung.id from dual;'||unistr('\000a')||
'          r_wkorb_det_verordnung.warenkorb_detail_tmp_id := r_wkorb_detail.id;'||unistr('\000a')||
'          INSERT INTO WKORB_DET_VERORDNUNGEN '||unistr('\000a')||
'    ';

p:=p||'      VALUES r_wkorb_det_verordnung;           '||unistr('\000a')||
'       END LOOP;'||unistr('\000a')||
'   END LOOP;    '||unistr('\000a')||
''||unistr('\000a')||
'   /* NEI 12.12.12 wg. GUS nicht mehr auf 50 '||unistr('\000a')||
'   -- Alle Positionen mit Fertigartikeln und Status 10 automatisch auf 50 setzen'||unistr('\000a')||
'   IF  v_wk_status_id = 10 THEN        '||unistr('\000a')||
'       v_return := frgbg_s.WK_UPD_STATUS_FERTIGARTIKEL_50(v_wk_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
''||unistr('\000a')||
'   -- TMP''s loeschen'||unistr('\000a')||
'   DELETE wkorb_det_verordnungen_tmp'||unistr('\000a')||
'   WHE';

p:=p||'RE warenkorb_detail_tmp_id in '||unistr('\000a')||
'           (SELECT id FROM warenkorb_details_tmp where warenkorb_tmp_id = :p305_warenkorb_tmp_id);'||unistr('\000a')||
''||unistr('\000a')||
'   DELETE warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id = :p305_warenkorb_tmp_id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   DELETE warenkoerbe_tmp'||unistr('\000a')||
'   WHERE id = :p305_warenkorb_tmp_id;'||unistr('\000a')||
'--RAISE_APPLICATion_error(-20000,''test'');   '||unistr('\000a')||
'   :p305_warenkorb_tmp_id := NULL;'||unistr('\000a')||
'   :p305_id := NULL;'||unistr('\000a')||
'   :p305_warenko';

p:=p||'rb_id := v_wk_id;'||unistr('\000a')||
'   :p305_bestell_status:= ''BESTELL_OK'';'||unistr('\000a')||
'/*   v_return := frgbg_s.MAIL_BESTELLUNG '||unistr('\000a')||
'                  (NULL     --P_USER_ACCOUNT'||unistr('\000a')||
'                  ,1547     --P_PERSSTAMM_ID Frau Siegwart als Zieladresse'||unistr('\000a')||
'                  , v_wk_id --P_WARENKORB_ID '||unistr('\000a')||
'                  ,:FAS_LOGIN_PERSONENSTAMM_ID     --P_PERSSTAMM_ID_MAILABSENDER '||unistr('\000a')||
'                  ,1        --P_FLAG IN NUMBER '||unistr('\000a')||
'    ';

p:=p||'              ,0        --P_NOTFALL_EMAIL'||unistr('\000a')||
'                 );'||unistr('\000a')||
'*/'||unistr('\000a')||
'--mel.p(''speichern Kasse: %1'',v_prot_id,''INFO'',''speichern kasse 102/305'',v_return);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   MEL.P (''WK-Bestellung v_anz: %1, %2, %3'',v_prot_id,''Info'',''speichern kasse 102/305'',v_anz,sqlerrm);               '||unistr('\000a')||
'   rollback;'||unistr('\000a')||
'   :p305_bestell_status:= ''BESTELL_ERROR'';'||unistr('\000a')||
'   --v_fehlertext := frgbg_s.holen_uebersetzung(18';

p:=p||'12,:fas_sprache_id,1);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1136708708655281 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_kasse',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BESTELLEN'',''BESTELLEN_GUS'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   DELETE FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id =  :p305_warenkorb_tmp_id'||unistr('\000a')||
'     AND mengenart_id = 101;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8537422755253980 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'delete_versandkosten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>1123118816655253 + wwv_flow_api.g_id_offset,
  p_process_when=>'p300_warenkorb_tmp_id',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p305_id:=:p305_warenkorb_tmp_id;'||unistr('\000a')||
'   :p305_bestell_status:= NVL(:p305_bestell_status,''KASSE'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1152117542207230 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_wk',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:WARENKOERBE_TMP:P305_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 1137711255655284 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from WARENKOERBE_TMP',
  p_process_sql_clob => p,
  p_process_error_message=> 'fehler in row select #SQLERRM# &P300_WARENKORB_TMP_ID.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p305_warenkorb_tmp_id is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Zahlungsart vorbelegen'||unistr('\000a')||
'   /* NEI 13.08.12 Zahlungsart wird durch pers_option vorbelegt'||unistr('\000a')||
'   IF :FAS_IDENTITAET_PERSSTAMM_ID = 24377 THEN -- EOVITAL => Vorkasse  '||unistr('\000a')||
'      :P305_ZAHLUNGSART := 3;  -- NEI 25.04.12'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :P305_ZAHLUNGSART := 1; -- NEI 25.04.12 -- sonst => Rechnung'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   -- Vorbelegung, falls in Page 308 durch wk_referenz ges';

p:=p||'etzt wurde'||unistr('\000a')||
'   IF :p305_WARENKORB_ID_REFERENZ is not null THEN'||unistr('\000a')||
'      :P305_ZAHLUNGSART := :p305_WK_ZAHLUNGSART_ID ;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--mel.p (''WK %1, Zahlungsart %2, zahlungsart_db %3, wk_ref %4'',v_prot_id,''TEST'',''102/305:init_wk_zahlungsart_id'',:p305_warenkorb_tmp_id,:P305_ZAHLUNGSART,:p308_WK_ZAHLUNGSART_ID,:p305_WARENKORB_ID_REFERENZ);'||unistr('\000a')||
'   IF :P305_ZAHLUNGSART is null THEN '||unistr('\000a')||
'      IF :p305_SORTIMENT_ID ';

p:=p||'= 0 THEN -- Wiederverkäufer: Bestellung auf Rechnung'||unistr('\000a')||
'         :P305_ZAHLUNGSART := 1; '||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         IF frgbg_s.get_pers_option(:APP_USER,35) = 1 THEN --Bestellung auf Rechnung'||unistr('\000a')||
'            :P305_ZAHLUNGSART := 1; '||unistr('\000a')||
'         ELSE   -- sonst Default Vorkassen'||unistr('\000a')||
'            :P305_ZAHLUNGSART := 3;     '||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12599323097304655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_process_sequence=> 55,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_wk_zahlungsart_id',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweistext VARCHAR2(2000);'||unistr('\000a')||
'   v_return      number;'||unistr('\000a')||
'   v_prot_id     number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :request in (''BESTELL_OK'',''WINDOW_CLOSE_PAY_SPEICHERN'') THEN'||unistr('\000a')||
'      :p305_bestell_status := ''BESTELL_OK'';     '||unistr('\000a')||
'      v_hinweistext:=frgbg_s.holen_uebersetzung(4386,:fas_sprache_id);'||unistr('\000a')||
'      /* NEI 12.12.12 wird in wk_aktivieren gemacht'||unistr('\000a')||
'      IF :request in (''WINDOW_CLOSE_PAY_SPEICHERN'') THEN  -- WK-';

p:=p||'Status'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            update warenkorb_details'||unistr('\000a')||
'            --set wk_status_id = 10   NEI 12.12.12'||unistr('\000a')||
'            set wk_status_id = 6   -- WK GUS-Pruefung/Dokudruck'||unistr('\000a')||
'            WHERE warenkorb_id = :p305_warenkorb_id'||unistr('\000a')||
'              AND wk_status_id= 5;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            --v_hinweistext:= ''Fehler beim Aktivieren der Bestellung! WK-ID:''||:p305_warenkorb';

p:=p||'_id;'||unistr('\000a')||
'            :p305_bestell_status := ''BESTELL_ERROR'';     '||unistr('\000a')||
'            v_hinweistext:=frgbg_s.holen_uebersetzung(4387,:fas_sprache_id); '||unistr('\000a')||
'         END;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      -- Dokumentendruck/GUS-check'||unistr('\000a')||
'      IF :p305_zahlungsart != 3 THEN -- Nicht Vorkasse => wird in WK-Übersicht manuelle gesetzt auf Rechnung gedruckt '||unistr('\000a')||
'         v_return := frgbg_s.wk_aktivieren(:p305_warenkorb_id);'||unistr('\000a')||
'    ';

p:=p||'     IF v_return < 0 THEN'||unistr('\000a')||
'            --v_hinweistext:= ''Fehler beim Aktivieren der Bestellung! WK-ID:''||:p305_warenkorb_id;'||unistr('\000a')||
'            :p305_bestell_status := ''BESTELL_ERROR'';     '||unistr('\000a')||
'            v_hinweistext:=frgbg_s.holen_uebersetzung(4387,:fas_sprache_id); '||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      -- Druck Bestellbestätigung'||unistr('\000a')||
'      v_return := frgbg_s.MAIL_EING_BESTAETIGUNG(:p305_warenkorb_id);'||unistr('\000a')||
'   E';

p:=p||'LSIF :request in (''BESTELL_ERROR'') THEN'||unistr('\000a')||
'      -- Im Submit wurde bereits ein Rollback gefahren, die Bestellung wurde nicht in den permanenten WK übernommen'||unistr('\000a')||
'      --v_hinweistext:= ''Fehler im Bestellungsvorgang! Bestellung storniert.'';  '||unistr('\000a')||
'      :p305_bestell_status := ''BESTELL_ERROR'';     '||unistr('\000a')||
'      v_hinweistext:=frgbg_s.holen_uebersetzung(4387,:fas_sprache_id); '||unistr('\000a')||
'   ELSIF :request in (''WINDOW_CLOSE_PAY';

p:=p||'_ERROR'',''WINDOW_CLOSE_PAY_CANCEL'') THEN'||unistr('\000a')||
'      -- Zahlungsvorgang erfolgte nicht => permanenter WK storniert'||unistr('\000a')||
'      --v_hinweistext:= ''Zahlungsabbruch oder Fehler im Zahlvorgang! Bestellung storniert.'';   '||unistr('\000a')||
'      v_hinweistext:=frgbg_s.holen_uebersetzung(4484,:fas_sprache_id); '||unistr('\000a')||
'      :p305_bestell_status := ''BESTELL_ERROR'';    '||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         update warenkorb_details'||unistr('\000a')||
'         set wk_status_id= ';

p:=p||'90'||unistr('\000a')||
'         WHERE warenkorb_id = :p305_warenkorb_id'||unistr('\000a')||
'           AND wk_status_id= 5;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         -- Error-Mail versenden, da Status-Update nicht möglich'||unistr('\000a')||
'         --v_hinweistext:= ''Fehler beim Stornieren der Bestellung! WK-ID:%1''||:p305_warenkorb_id;'||unistr('\000a')||
'         v_hinweistext:=frgbg_s.holen_uebersetzung(4485,:fas_sprache_id,:p305_warenkorb_id); '||unistr('\000a')||
'      END; '||unistr('\000a')||
'      IF';

p:=p||' :request in (''WINDOW_CLOSE_PAY_ERROR'') THEN'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            update warenkoerbe'||unistr('\000a')||
'            set error_flag  = 1,'||unistr('\000a')||
'                error_text  = ''Es trat ein Fehler beim Kreditkarten-Zahlvorgang auf! Die Zahlung wurde nicht durchgeführt. WK storniert!'''||unistr('\000a')||
'            WHERE id = :p305_warenkorb_id;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            -- Error-Mail versenden, da Status-Upd';

p:=p||'ate nicht möglich'||unistr('\000a')||
'            --v_hinweistext:= ''Fehler der WK-Fehlermarkierung während der Stornierung der Bestellung! WK-ID:%1''||:p305_warenkorb_id;'||unistr('\000a')||
'            v_hinweistext:=frgbg_s.holen_uebersetzung(4485,:fas_sprache_id,:p305_warenkorb_id); '||unistr('\000a')||
'         END;'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      --v_hinweistext:= ''Unbekannter Bestellstatus'';  '||unistr('\000a')||
'      -- Error-Mail versenden, da Status-Update nicht möglic';

p:=p||'h'||unistr('\000a')||
'      v_hinweistext:=frgbg_s.holen_uebersetzung(4388,:fas_sprache_id||''(''||:p305_bestell_status||'')''); '||unistr('\000a')||
'      :p305_bestell_status := ''BESTELL_ERROR'';     '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p305_bestellhinweis := v_hinweistext;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1162819460207139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'bestellung_aktivieren_bestellhinweis',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BESTELL_ERROR'',''BESTELL_OK'','||unistr('\000a')||
'''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_SPEICHERN'',''WINDOW_CLOSE_PAY_CANCEL'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P305_HEIGHT_warenkorb := :FAS_SCROLLREGION_HEIGHT_MAX * 0.8;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 1137916318655284 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 305,
  p_process_sequence=> 100,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 305
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00306
prompt  ...PAGE 306: Artikelinformation
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 306
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Artikelinformation'
 ,p_step_title => 'Artikelinformation'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<style style="text/css">'||unistr('\000a')||
'td.R span * {'||unistr('\000a')||
' /* Ermöglicht das trotz Theme allgemeiner Schriftgrösse, die Schriftgrösse über den HTML Editor angepasst werden kann. */'||unistr('\000a')||
' font-size:inherit;'||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'</style>'
 ,p_javascript_code => 
'$(document).ready(function() { '||unistr('\000a')||
'    // Hack, damit Tabellen in der Artikelbeschreibung angezeigt werden.'||unistr('\000a')||
'    $(''table[id=^"report_"] td.R td,table[id=^"report_"] td.R th'').css({'||unistr('\000a')||
'       ''border-style'':''solid'','||unistr('\000a')||
'       ''border-color'' : ''black'','||unistr('\000a')||
'       ''border-width'' : ''1px'''||unistr('\000a')||
'     });'||unistr('\000a')||
'    $(''table[id=^"report_"] td.R table'').css({'||unistr('\000a')||
'      ''border-collapse'' : ''collapse'','||unistr('\000a')||
'      ''border-spacing'' : ''0px'','||unistr('\000a')||
'  '||
'    ''border-width'' : ''1px'''||unistr('\000a')||
'    });'||unistr('\000a')||
''||unistr('\000a')||
'    //'||unistr('\000a')||
'});'||unistr('\000a')||
''||unistr('\000a')||
' 	'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'DENES.KUBICEK'
 ,p_last_upd_yyyymmddhh24miss => '20140921180747'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 3089916858860093 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 306,
  p_plug_name=> '&P306_REGION_TITEL_ARTIKEL.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891602476489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'NEVER',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'  case when :p306_bild_id is null or :p306_bild_id = 0 THEN '''''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'       ''<img src="#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         || NVL (:p306_bild_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         || ''" height="'''||unistr('\000a')||
'         || 80'||unistr('\000a')||
'         || ''" width="'''||unistr('\000a')||
'         || 80'||unistr('\000a')||
'         || ''" />'' '||unistr('\000a')||
' END'||unistr('\000a')||
'         img,'||unistr('\000a')||
'         fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'            ';

s:=s||'                               ID,:fas_sprache_id) '||unistr('\000a')||
'         ||''              ''||id artikel,'||unistr('\000a')||
'         '||unistr('\000a')||
'        fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'','||unistr('\000a')||
'                                 ARTGRUPPE_ID,:fas_sprache_id) ARTikelgruppe,'||unistr('\000a')||
'        fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                                         ID,:fas_sprache_id) kuerzel,'||unistr('\000a')||
'        fas_synch.get_t';

s:=s||'ab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                         ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'        --fas_synch.get_tab_uebersetzung(''MENGENARTS.BESCHREIBUNG'',ID,:fas_sprache_id) -- NEI 26.03.14 beschreibung deaktiviert nur beschreibung_text_id aktiv wg. langen Texten'||unistr('\000a')||
'        uebersetzung.HOLEN_UEBERSETZUNG_CLOB(BESCHREIBUNG_TEXT_ID ,:fas_SPRACHE_ID)'||unistr('\000a')||
'                       ';

s:=s||'                   beschreibung,'||unistr('\000a')||
'        menge||''   ''||rezepte.GET_EH(menge_EINHEIT_ID,:fas_SPRACHE_ID) menge'||unistr('\000a')||
'from mengenarts'||unistr('\000a')||
'where id = :p306_id';

wwv_flow_api.create_report_region (
  p_id=> 3108001207234471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 306,
  p_name=> '&P306_REGION_TITEL_ARTIKEL.',
  p_region_name=>'',
  p_template=> 2891602476489440+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 5,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div >',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 2,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3113207261248651 + wwv_flow_api.g_id_offset,
  p_region_id=> 3108001207234471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'IMG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3113007477239268 + wwv_flow_api.g_id_offset,
  p_region_id=> 3108001207234471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ARTIKEL',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3113413279259849 + wwv_flow_api.g_id_offset,
  p_region_id=> 3108001207234471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ARTIKELGRUPPE',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3110122080844028 + wwv_flow_api.g_id_offset,
  p_region_id=> 3108001207234471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3110210347844028 + wwv_flow_api.g_id_offset,
  p_region_id=> 3108001207234471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3110306712844028 + wwv_flow_api.g_id_offset,
  p_region_id=> 3108001207234471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'BESCHREIBUNG',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_css_style=>'font-weight:normal;',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 3113618736280343 + wwv_flow_api.g_id_offset,
  p_region_id=> 3108001207234471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 3090221512860096 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 306,
  p_button_sequence=> 10,
  p_button_plug_id => 3108001207234471+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P306_BL_ABBRECHEN.',
  p_button_position=> 'TOP_AND_BOTTOM',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3090326762860098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3090512070860106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 3,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3091215511860128 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_KUERZEL_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kürzel',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3091424939860128 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_MENGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 7,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'MENGE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 22,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3091600757860129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_MN_REZEPT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Rezept Id',
  p_source=>'MN_REZEPT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 38,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3091812118860129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_MENGE_EINHEIT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 8,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'&#160&#160',
  p_source=>'MENGE_EINHEIT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT eh_zeichen a,ID b'||unistr('\000a')||
'FROM einheiten'||unistr('\000a')||
'WHERE id = :p306_MENGE_EINHEIT_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 38,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3092031426860131 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_KUERZEL_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 28,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kuerzel Text Id',
  p_source=>'KUERZEL_TEXT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 22,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3092204598860134 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_BEZEICHNUNG_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bezeichnung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3092623128860134 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_BESCHREIBUNG_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Beschreibung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 4000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3093023736860135 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_ARTGRUPPE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 4,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'ARTGRUPPE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'','||unistr('\000a')||
'                                         :p306_ARTGRUPPE_ID,:fas_sprache_id) a,'||unistr('\000a')||
'       id b'||unistr('\000a')||
'from artgruppen',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3093213019860135 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_BILD_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'DOKUMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3102907479138730 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 38,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3103112328140165 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_REGION_TITEL_ARTIKEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 48,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3104213590906857 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 306,
  p_name=>'P306_BILD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 3089916858860093+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'''<img src="frgbg_t.display_thumb?p_bild_id='' ||:P306_bild_id || ''"'''||unistr('\000a')||
'         || '' height="'' || 30|| ''"'''||unistr('\000a')||
'         || '' width="''  || 30|| ''"'''||unistr('\000a')||
'         || '' />''',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>':P306_bild_id > 0',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|PIS:MENGENARTS:P306_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 3093508154860137 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 306,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from MENGENARTS',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to fetch row.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p306_kuerzel_bez:='||unistr('\000a')||
'          fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                                         :p306_ID,:fas_sprache_id);'||unistr('\000a')||
'   :p306_bezeichnung_bez:='||unistr('\000a')||
'          fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                         :p306_ID,:fas_sprache_id);'||unistr('\000a')||
'   :p306_beschreibung_bez:='||unistr('\000a')||
'          fas_synch.get_tab_uebersetzung(''MENGENAR';

p:=p||'TS.BESCHREIBUNG'','||unistr('\000a')||
'                                         :p306_ID,:fas_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3097222736944429 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 306,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_info',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p306_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P306_REGION_TITEL_artikel:=NULL;'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 3102427996125732 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 306,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'PIS:MENGENARTS:P306_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 3093724863860139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 306,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of MENGENARTS',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process row of table MENGENARTS.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> 'Action Processed.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'306';

wwv_flow_api.create_page_process(
  p_id     => 3093907980860139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 306,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'CLOSE_WINDOW';

wwv_flow_api.create_page_process(
  p_id     => 3112414047165437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 306,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLOSE_WINDOW',
  p_process_name=> 'Close Window',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 306
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00307
prompt  ...PAGE 307: Staffelpreisinformation
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 307
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Staffelpreisinformation'
 ,p_step_title => 'Staffelpreisinformation'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Staffelpreisinformation'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140602102935'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT --to_char(rezepte.CALC_PREIS_RUNDEN(PREIS,NULL,5),''999G990D00'')'||unistr('\000a')||
'    to_char(rezepte.calc_preis_mwst_ges(:p307_verrech_land_id,'||unistr('\000a')||
'             null,pd.mengenart_id,:p307_preisliste_id,'||unistr('\000a')||
'             :p307_art_mwst_typ_id,:p307_preisfaktor,NULL,0,min_menge)'||unistr('\000a')||
'        ,''999G990D00'')'||unistr('\000a')||
'     ||'' '''||unistr('\000a')||
'     ||rezepte.get_waehrung_zeichen(p.waehrung_id) preis, min_menge, max_menge,'||unistr('\000a')||
'CASE WHEN max_menge = :p30';

s:=s||'7_max_menge '||unistr('\000a')||
'     THEN ''ab ''||min_menge ||'' Packungen'''||unistr('\000a')||
'     ELSE ''bis ''||max_menge ||'' Packungen'''||unistr('\000a')||
'END menge'||unistr('\000a')||
'from preislisten_details pd, preislisten p'||unistr('\000a')||
'where preisliste_id = :p307_preisliste_id'||unistr('\000a')||
'  and mengenart_id = :p307_id'||unistr('\000a')||
'  and pd.GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'  AND pd.GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'  AND pd.preis >= 0'||unistr('\000a')||
'  and pd.satz_kennzeichen is null'||unistr('\000a')||
'  and pd.preisliste_id = p.id'||unistr('\000a')||
'order ';

s:=s||'by max_menge asc';

wwv_flow_api.create_report_region (
  p_id=> 7275927550298525 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 307,
  p_name=> '&P307_REGION_TITEL_STAFFEL.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 20,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN (frgbg_s.holen_uebersetzung(9224,:fas_sprache_id))',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7276320111298530 + wwv_flow_api.g_id_offset,
  p_region_id=> 7275927550298525 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'PREIS',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7276112389298529 + wwv_flow_api.g_id_offset,
  p_region_id=> 7275927550298525 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'MIN_MENGE',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7276223091298530 + wwv_flow_api.g_id_offset,
  p_region_id=> 7275927550298525 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'MAX_MENGE',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7286428092879502 + wwv_flow_api.g_id_offset,
  p_region_id=> 7275927550298525 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7276431577298565 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 307,
  p_plug_name=> '&P307_REGION_TITEL_ARTIKEL.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2891602476489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'--case when :p307_bild_id is null THEN '''''||unistr('\000a')||
'--ELSE'||unistr('\000a')||
'       ''<img src="#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         || NVL (:p307_bild_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         || ''" height="'''||unistr('\000a')||
'         || 80'||unistr('\000a')||
'         || ''" width="'''||unistr('\000a')||
'         || 80'||unistr('\000a')||
'         || ''" />'' '||unistr('\000a')||
'--END'||unistr('\000a')||
'         img,'||unistr('\000a')||
'         fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                                ';

s:=s||'           ID,:fas_sprache_id) '||unistr('\000a')||
'         ||''              ''||id artikel,'||unistr('\000a')||
'         '||unistr('\000a')||
'--        fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'','||unistr('\000a')||
'--                                 ARTGRUPPE_ID,:fas_sprache_id) ARTikelgruppe,'||unistr('\000a')||
'--        fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'--                                         ID,:fas_sprache_id) kuerzel,'||unistr('\000a')||
'        fas_synch.get_tab_uebersetz';

s:=s||'ung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                         ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'--        fas_synch.get_tab_uebersetzung(''MENGENARTS.BESCHREIBUNG'','||unistr('\000a')||
'--                                         ID,:fas_sprache_id) beschreibung,'||unistr('\000a')||
'        menge||''   ''||rezepte.GET_EH(menge_EINHEIT_ID,:fas_SPRACHE_ID) menge'||unistr('\000a')||
'from mengenarts'||unistr('\000a')||
'where id = :p307_id';

wwv_flow_api.create_report_region (
  p_id=> 7279214983298899 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 307,
  p_name=> '&P307_REGION_TITEL_ARTIKEL.',
  p_region_name=>'',
  p_template=> 2891602476489440+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 5,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_condition_type=> 'NEVER',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 2,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7279424483298900 + wwv_flow_api.g_id_offset,
  p_region_id=> 7279214983298899 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'IMG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7279520278298900 + wwv_flow_api.g_id_offset,
  p_region_id=> 7279214983298899 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ARTIKEL',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7279826364298900 + wwv_flow_api.g_id_offset,
  p_region_id=> 7279214983298899 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7280007929298900 + wwv_flow_api.g_id_offset,
  p_region_id=> 7279214983298899 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 7280107960298900 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 307,
  p_button_sequence=> 10,
  p_button_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P307_BL_ABBRECHEN.',
  p_button_position=> 'TOP',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>7281604981299033 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7276604301298566 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 7,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7276817200298670 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_KUERZEL_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 4,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7277021373298671 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_MENGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'MENGE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 22,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7277232167298671 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_MN_REZEPT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Rezept Id',
  p_source=>'MN_REZEPT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 38,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7277424935298672 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_MENGE_EINHEIT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 6,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'&#160&#160',
  p_source=>'MENGE_EINHEIT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT eh_zeichen a,ID b'||unistr('\000a')||
'FROM einheiten'||unistr('\000a')||
'WHERE id = :p307_MENGE_EINHEIT_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 38,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7277618722298824 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_KUERZEL_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 28,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kuerzel Text Id',
  p_source=>'KUERZEL_TEXT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 22,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7277823342298825 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_BEZEICHNUNG_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 3,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7278030459298825 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_BESCHREIBUNG_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Beschreibung',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 4000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7278224824298825 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_ARTGRUPPE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 8,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'ARTGRUPPE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'','||unistr('\000a')||
'                                         :p307_ARTGRUPPE_ID,:fas_sprache_id) a,'||unistr('\000a')||
'       id b'||unistr('\000a')||
'from artgruppen',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7278410819298826 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_BILD_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'DOKUMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7278624389298845 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 38,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7278804485298897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_REGION_TITEL_ARTIKEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 48,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7279016618298898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_BILD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'''<img src="frgbg_t.display_thumb?p_bild_id='' ||:P307_bild_id || ''"'''||unistr('\000a')||
'         || '' height="'' || 30|| ''"'''||unistr('\000a')||
'         || '' width="''  || 30|| ''"'''||unistr('\000a')||
'         || '' />''',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7281930557314649 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_PREISLISTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 58,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '55',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7285703719863047 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_MAX_MENGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 68,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'SELECT max(Max_menge)'||unistr('\000a')||
'from preislisten_details pd'||unistr('\000a')||
'where preisliste_id = :p307_preisliste_id'||unistr('\000a')||
'             and mengenart_id = :p307_id'||unistr('\000a')||
'             and pd.GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'             AND pd.GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'            AND pd.preis >= 0'||unistr('\000a')||
'  and pd.satz_kennzeichen is null',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7314221605727582 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 78,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7314606461779982 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_ART_MWST_TYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 88,
  p_item_plug_id => 7275927550298525+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7314814772782380 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_PREISFAKTOR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 98,
  p_item_plug_id => 7275927550298525+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7447804162754160 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_REGION_TITEL_STAFFEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 49,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8862302541738808 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 307,
  p_name=>'P307_WARENKORB_TMP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 108,
  p_item_plug_id => 7276431577298565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|PIS:MENGENARTS:P307_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 7280313500298905 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 307,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from MENGENARTS',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to fetch row.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p307_kuerzel_bez:='||unistr('\000a')||
'          fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                                         :p307_ID,:fas_sprache_id);'||unistr('\000a')||
'   :p307_bezeichnung_bez:='||unistr('\000a')||
'          fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                         :p307_ID,:fas_sprache_id);'||unistr('\000a')||
'   :p307_beschreibung_bez:='||unistr('\000a')||
'          fas_synch.get_tab_uebersetzung(''MENGENAR';

p:=p||'TS.BESCHREIBUNG'','||unistr('\000a')||
'                                         :p307_ID,:fas_sprache_id);'||unistr('\000a')||
'   -- Warenkorb-Infos holen'||unistr('\000a')||
'   SELECT VERRECH_LAND_ID, preisliste_id,ART_MWST_TYP_ID,PREISFAKTOR'||unistr('\000a')||
'   INTO :p307_VERRECH_LAND_ID, :p307_preisliste_id, :p307_ART_MWST_TYP_ID,:p307_PREISFAKTOR'||unistr('\000a')||
'   FROM warenkoerbe_tmp'||unistr('\000a')||
'   WHERE id = :p307_warenkorb_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7280504789299029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 307,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_info',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p307_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P307_REGION_TITEL_artikel:=NULL;'||unistr('\000a')||
'   :P307_REGION_TITEL_staffel:=frgbg_s.holen_uebersetzung(9223,v_sprache_id); '||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7280707616299029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 307,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'PIS:MENGENARTS:P307_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 7280904133299030 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 307,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of MENGENARTS',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process row of table MENGENARTS.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> 'Action Processed.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'306';

wwv_flow_api.create_page_process(
  p_id     => 7281102073299030 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 307,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'CLOSE_WINDOW';

wwv_flow_api.create_page_process(
  p_id     => 7281327945299031 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 307,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLOSE_WINDOW',
  p_process_name=> 'Close Window',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 307
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00308
prompt  ...PAGE 308: Warenkorb_Versanddaten
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 308
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Warenkorb_Versanddaten'
 ,p_step_title => 'Warenkorb_Versanddaten'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Warenkorb_Versanddaten'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150529081823'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'wkd."ID",'||unistr('\000a')||
'wkd."ID" ID_DISPLAY,'||unistr('\000a')||
'wkd."WARENKORB_TMP_ID",'||unistr('\000a')||
'wkd."PRODKENNZ_ID",'||unistr('\000a')||
'wkd."P_REZEPT_ID",'||unistr('\000a')||
'wkd."MENGENART_ID",'||unistr('\000a')||
'wkd."MENGE",'||unistr('\000a')||
'wkd."VOLUMEN",'||unistr('\000a')||
'wkd."GEWICHT",'||unistr('\000a')||
'wkd."PREIS",'||unistr('\000a')||
'wkd."MWST_BETRAG",'||unistr('\000a')||
'wkd."MWST_SATZ",'||unistr('\000a')||
'wkd."WK_STATUS_ID",'||unistr('\000a')||
'wkd."STATUS_AENDERDATUM",'||unistr('\000a')||
'wkd."STATUS_AENDERVISUM",'||unistr('\000a')||
'wkd."ETIKETTENTYP",'||unistr('\000a')||
'wkd."BEMERKUNG",'||unistr('\000a')||
'wkd."ERFDAT",'||unistr('\000a')||
'wkd."ERFUSER",'||unistr('\000a')||
'wkd."MUTDAT",'||unistr('\000a')||
'wkd."MUTUSER",'||unistr('\000a')||
'--pr.rezept_nr||DECO';

s:=s||'DE(pr.version,NULL,NULL,''/''||pr.version) rezept_nr,  -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'  CASE WHEN mnr.rezept_nr_splitbasis is NULL AND mnr.version_splitbasis is NULL THEN'||unistr('\000a')||
'       pr.rezept_nr||DECODE(pr.version,NULL,NULL,''/''||pr.version)'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'       mnr.rezept_nr_splitbasis||DECODE(mnr.version_splitbasis,NULL,NULL,''/''||mnr.version_splitbasis)'||unistr('\000a')||
'  END rezept_nr,   '||unistr('\000a')||
'  CASE WHEN w';

s:=s||'kd.PRODKENNZ_ID = 1 THEN -- HCK-Mischung'||unistr('\000a')||
'      frgbg_s.get_pers_name_rezept(p_rezept_id)|| ''</br>''||'||unistr('\000a')||
'      frgbg_s.holen_uebersetzung(585,:fas_sprache_id)||'': ''||wkd.reichweite||'||unistr('\000a')||
'      DECODE (rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version),0,'''','||unistr('\000a')||
'         ''</br>''||fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version)'||unistr('\000a')||
'      ,:fas_sprache_id))';

s:=s||''||unistr('\000a')||
'  ELSE '||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)|| ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'  END kuerzel,'||unistr('\000a')||
'  TRUNC(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2) einzelpreis_brutto,'||unistr('\000a')||
' (trunc(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2))*NVL(wkd.MENGE,0)'||unistr('\000a')||
'               g';

s:=s||'esamtpreis_brutto'||unistr('\000a')||
'from WARENKORB_DETAILS_TMP wkd , prod_rezepte pr, mengenarts m,'||unistr('\000a')||
'     mn_rezepte mnr  -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'where warenkorb_tmp_id = :p308_warenkorb_tmp_id'||unistr('\000a')||
'  and p_rezept_id = pr.id (+)'||unistr('\000a')||
'  and mengenart_id = m.id (+)'||unistr('\000a')||
'  and (wkd.mengenart_id is NULL or wkd.mengenart_id != 101)'||unistr('\000a')||
'  AND pr.rezept_nr = mnr.rezept_nr(+) -- NEI 10.01.2014 Kumulation Splits zu ';

s:=s||'Gesamtrezept'||unistr('\000a')||
'  AND pr.version  = mnr.version (+)   -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'order by wkd.id';

wwv_flow_api.create_report_region (
  p_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 308,
  p_name=> '&P308_REGION_TITEL_WARENKORB.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P305_HEIGHT_WARENKORB.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3081,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '100',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7765827143506218 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7765924895506220 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766031845506220 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID_DISPLAY',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID_DISPLAY',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766130050506220 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_TMP_ID',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WARENKORB_TMP_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766222491506220 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PRODKENNZ_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766304515506220 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'P_REZEPT_ID',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'P_REZEPT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766425481506221 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766520642506221 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_inline_lov=> '1,2,3,4,5,6,7,8,9,10',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '5',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766622599506221 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'VOLUMEN',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'VOLUMEN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766700915506221 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'GEWICHT',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'GEWICHT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766816028506221 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'PREIS',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PREIS',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7766920559506221 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_BETRAG',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_BETRAG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767005000506221 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_SATZ',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_SATZ',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767119930506221 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS_ID',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WK_STATUS_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767202220506221 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERDATUM',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERDATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767304827506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERVISUM',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERVISUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767422460506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'ETIKETTENTYP',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ETIKETTENTYP',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767521921506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '20',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'BEMERKUNG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767618997506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'ERFDAT',
  p_column_display_sequence=> 23,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767718392506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'ERFUSER',
  p_column_display_sequence=> 24,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767813770506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'MUTDAT',
  p_column_display_sequence=> 25,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7767920477506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'MUTUSER',
  p_column_display_sequence=> 26,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7768004890506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7768114628506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7768220341506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'EINZELPREIS_BRUTTO',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7768330141506222 + wwv_flow_api.g_id_offset,
  p_region_id=> 7765615436506215 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'GESAMTPREIS_BRUTTO',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7770219309506225 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 308,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7789330093546683 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 308,
  p_plug_name=> '&P308_REGION_TITEL_ADRESSE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 5,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 7799431384840406 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 308,
  p_button_sequence=> 5,
  p_button_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P308_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7799214415835546 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 308,
  p_button_sequence=> 10,
  p_button_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_button_name    => 'KASSE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P308_BL_ZUR_KASSE.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT * '||unistr('\000a')||
'FROM warenkorb_details_tmp '||unistr('\000a')||
'where warenkorb_tmp_id=:P308_WARENKORB_TMP_ID',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>7772724287506242 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P308_ZURUECK_SEITE.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7799431384840406+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>7847826583029914 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:304:P304_ID,P304_ZURUECK_SEITE:&P300_PERSSTAMM_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7791314624546686+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 15,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>7848005590033301 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:302:P302_ID,P302_ADRESSTYP,P302_ZURUECK_SEITE,P302_CALLING_PAGE:&P308_PERSSTAMM_ID_LIEFERUNG.,L,308,308',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7796110941546693+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 16,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>7848223251038436 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:302:P302_ID,P302_ADRESSTYP,P302_ZURUECK_SEITE,P302_CALLING_PAGE:&P308_PERSSTAMM_ID_RECHNUNG.,L,308,308',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7789914462546684+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 17,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>7801426554990398 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:305:&SESSION.::&DEBUG.:305:P305_WARENKORB_TMP_ID,P305_ZURUECK_SEITE,P305_ZURUECK_SEITE_NACH_BEST:&P308_WARENKORB_TMP_ID.,&APP_PAGE_ID.,&P308_ZURUECK_SEITE_NACH_BEST.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7799214415835546+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-DEC-2012 10:51 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>7848403643042240 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301:P301_PERSSTAMM_ID_BETREUER,P301_persstamm_id_patient,p301_adresstyp,p301_zurueck_seite,P301_PERSSTAMM_ID_STDADRESSE:&P308_PERSSTAMM_ID_LOGIN.,&P308_PERSSTAMM_ID_KUNDE.,L,&APP_PAGE_ID.,&P308_PERSSTAMM_ID_KUNDE.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7795104453546691+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>7848614725045381 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301:P301_PERSSTAMM_ID_BETREUER,P301_persstamm_id_patient,p301_adresstyp,p301_zurueck_seite,P301_PERSSTAMM_ID_STDADRESSE:&P308_PERSSTAMM_ID_LOGIN.,&P308_PERSSTAMM_ID_KUNDE.,R,&APP_PAGE_ID.,&P308_PERSSTAMM_ID_KUNDE.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7795309551546691+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>8877613032505035 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:308:&SESSION.::&DEBUG.::P308_PERSSTAMM_ID_EXTERN_UPD,P308_ADRESSTYP_EXTERN:&P308_PERSSTAMM_ID_RECHSTELLER.,L&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 80,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request = ''P308_WK_VERSANDART_ID'' and :p308_wk_versandart_id = 3',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-MAR-2012 12:01 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>7773930388506246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:308:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7768423526506222 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_WARENKORB_TMP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb-ID',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7768613393506222 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_GESAMTWERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'to_char(trunc(NVL(to_number(:p308_gesamtpreis,''999G999G999G999G990D00''),0) + NVL(to_number(:p308_mwst_betrag_1,''999G999G999G999G990D00''),0)+ NVL(to_number(:p308_mwst_betrag_2,''999G999G999G999G990D00''),0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P308_GESAMTWERT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7768804796506223 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_GESAMT_MWST_BETRAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'to_char(trunc(NVL(:p308_mwst_betrag_1,0) + NVL(:p308_mwst_betrag_2,0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7769021874506223 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_WAEHRUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'&#160',
  p_source=>'rezepte.get_waehrung_zeichen(:p308_waehrung_id); --||'' &P300_INKL_MWST_LABEL.'';',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7769210819506223 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_ETTIKETTENTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ettikettentyp',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,1);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7769424659506224 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_VERSANDKOSTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160&#160&P308_WAEHRUNG.',
  p_source=>'SELECT to_char(NVL(sum(preis+mwst_betrag),0),''999G999G999G999G990D00'')'||unistr('\000a')||
'from warenkorb_details_tmp'||unistr('\000a')||
'where warenkorb_tmp_id = :p308_warenkorb_tmp_id'||unistr('\000a')||
'  and mengenart_id = 101;',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7769624180506224 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_WARENKORB_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 215,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7769828607506224 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_WK_VERSANDART_ID_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'(',
  p_post_element_text=>')',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7770005307506224 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_SORTIMENT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'SORTIMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7789523949546684 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PATIENTADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_adresse(:p308_persstamm_id_kunde)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7789700567546684 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PERSSTAMM_PROD_APO_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 16,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'P308_PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT substr(frgbg_s.get_pers_adresse(p.id),1,80) a,'||unistr('\000a')||
'       p.id b'||unistr('\000a')||
'FROM pers_identitaet_props i,    /* spez. Eigenschaften der Identitaeten */'||unistr('\000a')||
'     personenstamm p'||unistr('\000a')||
'where i.typ = ''PA'' /* Produzierende Apotheke */'||unistr('\000a')||
'  and p.id = i.persstamm_id'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7789914462546684 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_RECHADRESSE_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P308_BL_AENDERN.',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P308_persstamm_id_kunde != :p308_persstamm_id_rechnung and'||unistr('\000a')||
':p308_persstamm_id_lieferung != :p308_persstamm_id_rechnung ',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7790526012546685 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_WK_VERSANDART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 17,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null'||unistr('\000a')||
'  and (id = 4 /* A-post nur innerhalb CH */ and '||unistr('\000a')||
'       198 in (SELECT land_id '||unistr('\000a')||
'               from personenstamm '||unistr('\000a')||
'               where id = :P308_PERSSTAMM_ID_RECHSTELLER) and'||unistr('\000a')||
'       198 in (SELECT land_id '||unistr('\000a')||
'               from personenstamm '||unistr('\000a')||
'               where id = :P308_PERSSTAMM_ID_lieferung)'||unistr('\000a')||
'      OR id != 4'||unistr('\000a')||
'     )'||unistr('\000a')||
'order by sortierung',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when=>'/* Eine Änderung ist nur möglich, wenn kein abhängiger WK eingetragen ist */'||unistr('\000a')||
':P308_WARENKORB_ID_REFERENZ is not null ',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7791116963546686 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_ADRESSTYP_EXTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ext Adresstyp',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7791314624546686 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PATIENT_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'PATIENT',
  p_prompt=>'&P308_BL_AENDERN.',
  p_source=>'PATIENT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7791729999546687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7791906369546687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 23,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Plandatum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7792105420546687 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 21,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land Id',
  p_source=>'VERRECH_LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7792313823546688 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 22,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Waehrung Id',
  p_source=>'WAEHRUNG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7792531031546688 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtpreis',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'GESAMTPREIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7792716520546688 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_MWST_JN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Jn',
  p_source=>'MWST_JN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7792922718546688 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_MWST_BETRAG_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 1',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'MWST_BETRAG_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7793118844546689 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_MWST_BETRAG_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 2',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'MWST_BETRAG_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7793320224546689 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_MWST_SATZ_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 1',
  p_source=>'MWST_SATZ_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7793523625546689 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_MWST_SATZ_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 2',
  p_source=>'MWST_SATZ_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7793700016546689 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_WK_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wk Status Id',
  p_source=>'WK_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7793921014546690 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_STATUS_AENDERDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aenderdatum',
  p_source=>'STATUS_AENDERDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7794103431546690 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_STATUS_AENDERVISUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aendervisum',
  p_source=>'STATUS_AENDERVISUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7794301888546690 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Login',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7794500108546690 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bemerkung',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7794712245546691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_LIEFERADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 6,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEGIN'||unistr('\000a')||
'   IF :p308_persstamm_id_lieferung = :p308_persstamm_id_kunde THEN'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9067,:fas_sprache_id)||'' ''||frgbg_s.holen_uebersetzung(5521,:fas_sprache_id);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.get_pers_adresse(:p308_persstamm_id_lieferung);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7794901661546691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_RECHNUNGSADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEGIN'||unistr('\000a')||
'   IF :p308_persstamm_id_rechnung = :p308_persstamm_id_kunde THEN    -- siehe Kundenadresse'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9067,:fas_sprache_id)||'' ''||frgbg_s.holen_uebersetzung(5521,:fas_sprache_id);'||unistr('\000a')||
'   ELSIF :p308_persstamm_id_rechnung = :p308_persstamm_id_lieferung THEN --siehe Lieferadresse'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9067,:fas_sprache_id)||'' ''||frgbg_s.holen_uebersetzung(3114,:fas_sprache_id);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.get_pers_adresse(:p308_persstamm_id_rechnung);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7795104453546691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_LIEFERADRESSE_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 7,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'LIEFERADRESSE',
  p_prompt=>'&P308_BL_AUSWAHL.',
  p_source=>'LIEFERADRESSE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P308_WARENKORB_ID_REFERENZ is null /* Eine Änderung der Lieferadresse ist nur möglich, wenn kein abhängiger WK eingetragen ist */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7795309551546691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_RECHADR_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 11,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'RECHADRESSE',
  p_prompt=>'&P308_BL_AUSWAHL.',
  p_source=>'RECHADRESSE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P308_WARENKORB_ID_REFERENZ is null /* Eine Änderung der Lieferadresse ist nur möglich, wenn kein abhängiger WK eingetragen ist */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7795500138546692 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PERSSTAMM_ID_EXTERN_UPD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'ext Persstamm Id Upd',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7795910933546692 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PERSSTAMM_ID_RECHSTELLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 14,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PERSSTAMM_ID_RECHNUNGSSTELLER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.get_pers_adresse(:p308_persstamm_id_prod_apo) a,:p308_persstamm_id_prod_apo b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'select frgbg_s.get_pers_adresse(:fas_identitaet_persstamm_id) a,:fas_identitaet_persstamm_id b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7796110941546693 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_LIEFERADRESSE_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 8,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P308_BL_AENDERN.',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p308_persstamm_id_kunde != :p308_persstamm_id_lieferung',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7797017869760790 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7797227912763741 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_ZURUECK_SEITE_NACH_BEST',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7797818608789447 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_HEIGHT_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Height Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7798100862803218 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_NV_WK_VERSAND',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 530,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7798324757810069 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_REGION_TITEL_ADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 540,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7798507227814503 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_REGION_TITEL_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 550,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7798809089824505 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_BL_ZUR_KASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 560,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7799728745849106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 570,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7803530784247143 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PERSSTAMM_ID_KUNDE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'PERSSTAMM_ID_KUNDE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7805306384353563 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 9,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7805517119356682 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7807019075423489 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_BL_AUSWAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 580,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7807218860432918 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 590,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7807507750552743 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 13,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onChange="javascript:doSubmit(''CHANGE'') "',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12542307705851560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_WARENKORB_ID_REF_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 19,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb Id Referenz',
  p_source=>'P308_WARENKORB_ID_REFERENZ',
  p_source_type=> 'ITEM',
  p_display_as=> 'PLUGIN_COM_SKILLBUILDERS_SUPER_LOV',
  p_lov=> 'SELECT wkref.id, wkref.id||'': ''||frgbg_s.GET_PERS_ADRESSE(p.id)'||unistr('\000a')||
'       --||''( ''||p.id||'')'' '||unistr('\000a')||
'       adresse, '||unistr('\000a')||
'       wkref.plandatum, p.id fas_id,'||unistr('\000a')||
'       wkref.gesamtpreis+NVL(wkref.MWST_BETRAG_1,0)+NVL(wkref.MWST_BETRAG_2,0) preis'||unistr('\000a')||
'from warenkoerbe_tmp wktmp, warenkoerbe wkref, personenstamm p'||unistr('\000a')||
'WHERE wktmp.id = :p308_id'||unistr('\000a')||
'  and wktmp.persstamm_id_identitaet =  wkref.persstamm_id_identitaet '||unistr('\000a')||
'  --and wktmp.persstamm_id_lieferung =  wkref.persstamm_id_lieferung'||unistr('\000a')||
'  --and wktmp.persstamm_id_rechnung =  wkref.persstamm_id_rechnung  '||unistr('\000a')||
'  and wktmp.waehrung_id = wkref.waehrung_id'||unistr('\000a')||
'  and wktmp.VERRECH_LAND_ID = wkref.VERRECH_LAND_ID'||unistr('\000a')||
'  and wktmp.preisliste_id = wkref.preisliste_id'||unistr('\000a')||
'  and wkref.wk_versandart_id != 3  -- keine Selbstabholer WK, da hier die Lieferadressen anzupassen sind und auch die Währung=>Neuberechnung'||unistr('\000a')||
'  --and wktmp.wk_zahlungsart_id = wkref.wk_zahlungsart_id'||unistr('\000a')||
'  and wktmp.persstamm_id_prod_apo = wkref.persstamm_id_prod_apo'||unistr('\000a')||
'  and wkref.persstamm_id_kunde = p.id'||unistr('\000a')||
'  and wkref.plandatum >= trunc(sysdate-2)'||unistr('\000a')||
'  and wkref.wk_status_id <=  10'||unistr('\000a')||
'order by 3 desc, 2 asc'||unistr('\000a')||
';',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 75,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_tag_attributes  => 'onChange="javascript:doSubmit(''WK_REF_CHANGE'') "',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_03 => '2,1',
  p_attribute_08 => 'NOT_ENTERABLE',
  p_attribute_09 => '15',
  p_attribute_10 => '&nbsp;',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>12545115455394932 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_WARENKORB_ID_REFERENZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 18,
  p_item_plug_id => 7789330093546683+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb Id Referenz',
  p_source=>'WARENKORB_ID_REFERENZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18538402564585481 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 308,
  p_name=>'P308_INKL_MWST_LABEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 41,
  p_item_plug_id => 7765615436506215+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7771115709506229 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_kunde_adressen_vollstaendigkeit',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_adresszusatz personenstamm.adresszusatz%TYPE;'||unistr('\000a')||
'   v_telefon      personenstamm.telefon%TYPE;'||unistr('\000a')||
'   v_mobiltelefon personenstamm.mobiltelefon%TYPE;'||unistr('\000a')||
'   v_fax          personenstamm.fax%TYPE;'||unistr('\000a')||
'   v_gus_id       personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_anrede_id    personenstamm.anrede_id%TYPE; -- NEI 13.08.14 Kunde darf keine Firma sein'||unistr('\000a')||
'   v_wk_extern_verwaltet warenkoerbe.extern_verwaltet%TYPE;'||unistr('\000a')||
'   v_prot_id      number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/308: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Kunderadresse müssen vollständig sein, wenn der Auftrag an GUS geht und noch keine GUS-ID für den Kunden vorhanden ist, sonst kann GUS den Kunden nicht anlegen'||unistr('\000a')||
'   -- holen der Kundenadr. aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          p.gus_id,wk.extern_verwaltet,'||unistr('\000a')||
'          p.adresszusatz, p.telefon, p.mobiltelefon, p.fax,'||unistr('\000a')||
'          p.anrede_id  -- NEI 13.08.14'||unistr('\000a')||
'   INTO v_plz, v_ort, v_land_id,v_strasse,v_name,v_vorname,'||unistr('\000a')||
'        v_gus_id,v_wk_extern_verwaltet,'||unistr('\000a')||
'        v_adresszusatz, v_telefon, v_mobiltelefon, v_fax,'||unistr('\000a')||
'        v_anrede_id   -- NEI 13.08.14'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p308_id'||unistr('\000a')||
'     AND wk.persstamm_id_kunde =p.id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   -- NEI 13.08.14 immer prüfen'||unistr('\000a')||
'   --IF v_gus_id is NULL AND v_wk_extern_verwaltet = 1 -- Zur Zeit findet nur in diesem Fall von FAS in GUS eine Adressanlage statt'||unistr('\000a')||
'   --THEN'||unistr('\000a')||
'      IF (v_plz is NULL OR v_ort is NULL OR v_land_id IS NULL OR '||unistr('\000a')||
'          v_strasse IS NULL OR v_name IS NULL OR v_vorname IS NULL'||unistr('\000a')||
'         )'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         -- ''Die Kundenadresse ist unvollständig! Die Felder Name, Vorname, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'         RETURN frgbg_s.holen_uebersetzung(5901,:fas_sprache_id);	'||unistr('\000a')||
'      END IF;   '||unistr('\000a')||
''||unistr('\000a')||
'      -- NEI 03.07.14 Feldlängenprüfungen, da GUS kürzere Felder hat'||unistr('\000a')||
'      IF length(v_name) > 40 OR length(v_vorname) > 40 OR length(v_ADRESSZUSATZ)> 40 OR'||unistr('\000a')||
'         length(v_ort) > 40 OR length(v_strasse) > 40 '||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         --''Die Adressdaten (Kundenadresse) ist für unser Bestellsystem zu lang! Die Felder Name, Vorname, Strasse, Ort, Adresszusatz dürfen nur 40 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.''); '||unistr('\000a')||
'         RETURN frgbg_s.holen_uebersetzung(10165,:fas_sprache_id, frgbg_s.holen_uebersetzung(5521,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      IF length(v_telefon) > 20 OR length(v_mobiltelefon) > 20 OR length(v_fax)> 20 '||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         -- ''Die Kommunikationsdaten (Kundenadresse) sind für unser Bestellsystem zu lang! Die Felder Telefon, Mobiltelefon, Fax dürfen jeweils nur 20 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.'''||unistr('\000a')||
'         RETURN frgbg_s.holen_uebersetzung(10166,:fas_sprache_id, frgbg_s.holen_uebersetzung(5521,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   --END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 13.08.14 Kunde darf keine Firma sein'||unistr('\000a')||
'   IF  v_anrede_id = 5 THEN'||unistr('\000a')||
'       -- Sie verwenden als Kundenadresse eine Firma. Das ist an dieser Stelle nicht möglich. Eine Firma können Sie als abweichende Lieferadresse angeben.'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(10369,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 7799214415835546 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7842125616873024 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_lief_adressen_vollstaendigkeit',
  p_validation_sequence=> 30,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz_lief          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort_lief          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id_lief      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse_lief      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name_lief         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname_lief      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_persstamm_id_lief personenstamm.id%TYPE;'||unistr('\000a')||
'   v_adresszusatz_lief personenstamm.adresszusatz%TYPE;'||unistr('\000a')||
'   v_persstamm_id_kunde personenstamm.id%TYPE;'||unistr('\000a')||
'   v_land_id_kunde      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/308: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
''||unistr('\000a')||
'   -- Lieferadresse müssen vollständig sein'||unistr('\000a')||
'   -- holen der Lieferadr. aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          wk.persstamm_id_lieferung,wk.persstamm_id_kunde,'||unistr('\000a')||
'          p.adresszusatz'||unistr('\000a')||
'   INTO v_plz_lief, v_ort_lief, v_land_id_lief,v_strasse_lief,v_name_lief,v_vorname_lief,'||unistr('\000a')||
'          v_persstamm_id_lief,v_persstamm_id_kunde,'||unistr('\000a')||
'        v_adresszusatz_lief'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p308_id'||unistr('\000a')||
'     AND wk.persstamm_id_lieferung =p.id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF v_plz_lief is NULL OR v_ort_lief is NULL OR v_land_id_lief IS NULL OR '||unistr('\000a')||
'      v_strasse_lief IS NULL OR v_name_lief IS NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Lieferadresse ist unvollständig! Die Felder Name, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5900,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 03.07.14 Feldlängenprüfungen, da GUS kürzere Felder hat'||unistr('\000a')||
'   IF length(v_name_lief) > 40 OR length(v_vorname_lief) > 40 OR length(v_ADRESSZUSATZ_lief)> 40 OR'||unistr('\000a')||
'      length(v_ort_lief) > 40 OR length(v_strasse_lief) > 40 '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --''Die Adressdaten (Lieferadresse) ist für unser Bestellsystem zu lang! Die Felder Name, Vorname, Strasse, Ort, Adresszusatz dürfen nur 40 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.''); '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(10165,:fas_sprache_id, frgbg_s.holen_uebersetzung(3114,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   /* '||unistr('\000a')||
'   -- Kundenadresse und Lieferadresse müssen im gleichen Land sein, damit kein Währungswechsel/Mwstwechsel erfolgen muss'||unistr('\000a')||
'   IF v_persstamm_id_lief != NVL(v_persstamm_id_kunde,0) THEN'||unistr('\000a')||
'      SELECT p.land_id'||unistr('\000a')||
'      INTO v_land_id_kunde'||unistr('\000a')||
'      FROM personenstamm p'||unistr('\000a')||
'      WHERE id = v_persstamm_id_kunde;'||unistr('\000a')||
'      IF v_land_id_kunde != v_land_id_lief THEN'||unistr('\000a')||
'         RETURN frgbg_s.holen_uebersetzung(9602,:fas_sprache_id);	'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 7799214415835546 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7842330810874510 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_rech_adressen_vollstaendigkeit',
  p_validation_sequence=> 40,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz_rech          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort_rech          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id_rech      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse_rech      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name_rech         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname_rech      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_adresszusatz_rech personenstamm.adresszusatz%TYPE;'||unistr('\000a')||
'   v_telefon_rech      personenstamm.telefon%TYPE;'||unistr('\000a')||
'   v_mobiltelefon_rech personenstamm.mobiltelefon%TYPE;'||unistr('\000a')||
'   v_fax_rech          personenstamm.fax%TYPE;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/308: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Rechnungsadresse müssen vollständig sein'||unistr('\000a')||
'   -- holen der Rechadr aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          p.adresszusatz, p.telefon, p.mobiltelefon, p.fax'||unistr('\000a')||
'   INTO v_plz_rech, v_ort_rech, v_land_id_rech,v_strasse_rech,v_name_rech,v_vorname_rech,'||unistr('\000a')||
'        v_adresszusatz_rech, v_telefon_rech, v_mobiltelefon_rech, v_fax_rech'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p308_id'||unistr('\000a')||
'     AND wk.persstamm_id_rechnung =p.id;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_plz_rech is NULL OR v_ort_rech is NULL OR v_land_id_rech is NULL OR'||unistr('\000a')||
'      v_strasse_rech IS NULL OR v_name_rech IS NULL OR v_vorname_rech IS NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Rechnungsadresse ist unvollständig! Die Felder Name,Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5569,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
''||unistr('\000a')||
'   -- NEI 03.07.14 Feldlängenprüfungen, da GUS kürzere Felder hat'||unistr('\000a')||
'   IF length(v_name_rech) > 40 OR length(v_vorname_rech) > 40 OR length(v_ADRESSZUSATZ_rech)> 40 OR'||unistr('\000a')||
'      length(v_ort_rech) > 40 OR length(v_strasse_rech) > 40 '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --''Die Adressdaten (Rechnungsadresse) ist für unser Bestellsystem zu lang! Die Felder Name, Vorname, Strasse, Ort, Adresszusatz dürfen nur 40 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.''); '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(10165,:fas_sprache_id, frgbg_s.holen_uebersetzung(3113,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF length(v_telefon_rech) > 20 OR length(v_mobiltelefon_rech) > 20 OR length(v_fax_rech)> 20 '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Kommunikationsdaten (Rechnungsadresse) sind für unser Bestellsystem zu lang! Die Felder Telefon, Mobiltelefon, Fax dürfen jeweils nur 20 Zeichen lang sein. Bitte korrigieren Sie die Feldeinträge entsprechend.'''||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(10166,:fas_sprache_id, frgbg_s.holen_uebersetzung(3113,:fas_sprache_id));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 7799214415835546 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7842511548878435 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_adress_kompatibel',
  p_validation_sequence=> 50,
  p_validation => 'Declare'||unistr('\000a')||
'   v_return NUMBER;'||unistr('\000a')||
'   v_fehlertext uebersetzungen.text%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   v_return := frgbg_s.WK_CHECK_ADR_KOMPATIBEL(p_persstamm_id_prod_apo => :P308_PERSSTAMM_ID_prod_apo,'||unistr('\000a')||
'                                               p_persstamm_id_kunde    => :P308_PERSSTAMM_ID_kunde,'||unistr('\000a')||
'                                               p_persstamm_id_lieferung=> :P308_PERSSTAMM_ID_LIEFERUNG,'||unistr('\000a')||
'                                               p_persstamm_id_rechnung => :P308_PERSSTAMM_ID_RECHNUNG,'||unistr('\000a')||
'                                               p_warenkorb_tmp_id      => :P308_ID,  -- NEI 05.06.2014'||unistr('\000a')||
'                                               p_sprache_id            => :fas_sprache_id ,'||unistr('\000a')||
'                                               p_fehlertext_out        => v_fehlertext'||unistr('\000a')||
'                                               );'||unistr('\000a')||
'   IF v_return = 1 THEN'||unistr('\000a')||
'      RETURN '''';'||unistr('\000a')||
'   ELSIF v_fehlertext is not null THEN'||unistr('\000a')||
'      --''Die Lieferadresse muss auch in der Schweiz liegen, da die Kunden-/ die Rechnungsadresse in der Schweiz liegt!'''||unistr('\000a')||
'      -- ''Liefer- und Kundenadresse müssen im gleichen Land liegen'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5727,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''CANCEL'', ''KASSE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p308_bl_abbrechen := --frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'                         frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p308_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id);'||unistr('\000a')||
'   :p308_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p308_BL_ZUR_KASSE :=  frgbg_s';

p:=p||'.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'   :P308_INKL_MWST_LABEL:= frgbg_s.holen_uebersetzung(5522,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p308_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :p308_region_titel_adresse := frgbg_s.holen_uebersetzung(9601,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P308_NV_WK_VERSAND:= frgbg_s.holen_uebersetzung(9600,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Inf';

p:=p||'o'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7771206961506231 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_process_sequence=> 51,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   UPDATE warenkoerbe_tmp'||unistr('\000a')||
'   SET wk_versandart_id = :p308_wk_versandart_id'||unistr('\000a')||
'   WHERE id = :p308_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7855306216134126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_versandart',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request = ''P308_WK_VERSANDART_ID''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_wk_versandart_id   warenkoerbe.wk_versandart_id%TYPE;'||unistr('\000a')||
'   v_WK_ZAHLUNGSART_ID  warenkoerbe.WK_ZAHLUNGSART_ID%TYPE;'||unistr('\000a')||
'   v_persstamm_id_lieferung warenkoerbe.persstamm_id_lieferung%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechnung  warenkoerbe.persstamm_id_rechnung%TYPE;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''1 In speichern wk_referenz %1'',v_prot_id,''TEST'',''102/308:speichern_wk_id_referenz'',''|''||NVL(:p308_wa';

p:=p||'renkorb_id_ref_disp,''X'') ||''|'');'||unistr('\000a')||
'   IF NVL(:P308_WARENKORB_ID_REFERENZ,''X'') != NVL(:P308_WARENKORB_ID_REF_DISP,''X'') THEN'||unistr('\000a')||
'      IF NVL(:P308_WARENKORB_ID_REF_DISP,''X'') = ''X'' THEN -- Referenz wieder entfernen'||unistr('\000a')||
'         -- Referenz entfernen'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET warenkorb_id_referenz = NULL'||unistr('\000a')||
'         WHERE id = :p308_id;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         SELECT wk_versandart_id, WK_ZAHLUNGSAR';

p:=p||'T_ID, persstamm_id_lieferung, persstamm_id_rechnung'||unistr('\000a')||
'         INTO v_wk_versandart_id, v_WK_ZAHLUNGSART_ID, v_persstamm_id_lieferung, v_persstamm_id_rechnung'||unistr('\000a')||
'         FROM warenkoerbe'||unistr('\000a')||
'         where id = :p308_warenkorb_id_ref_disp;'||unistr('\000a')||
'         -- Änderungen durchführen'||unistr('\000a')||
'--mel.p(''2 In speichern wk_referenz %1,%2,%3'',v_prot_id,''TEST'',''102/308:speichern_wk_id_referenz'',''|''||NVL(:p308_warenkorb_id_ref_dis';

p:=p||'p,''X'') ||''|'',v_persstamm_id_lieferung,v_persstamm_id_rechnung);'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET warenkorb_id_referenz = :p308_warenkorb_id_ref_disp,'||unistr('\000a')||
'             wk_versandart_id  = v_wk_versandart_id,'||unistr('\000a')||
'             WK_ZAHLUNGSART_ID = v_WK_ZAHLUNGSART_ID,'||unistr('\000a')||
'             persstamm_id_lieferung =  v_persstamm_id_lieferung,'||unistr('\000a')||
'             persstamm_id_rechnung = v_persstamm_id_rechnung '||unistr('\000a')||
'    ';

p:=p||'     WHERE id = :p308_id;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 12544526660325950 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_process_sequence=> 25,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_wk_id_referenz',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request=''WK_REF_CHANGE''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return number;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p (''In versankosten %1'',v_prot_id,''TEST'',''P102/308:gen_versandkosten'',:request);'||unistr('\000a')||
'   -- Versandkosten einhängen'||unistr('\000a')||
'   v_return:= frgbg_s.wk_gen_versandkosten(:P308_WARENKORB_TMP_ID,1);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7852825450673007 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_versandkosten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in ( ''P308_WK_VERSANDART_ID'',''WK_REF_CHANGE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p308_id:=:p308_warenkorb_tmp_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7771806599506239 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_wk',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'   v_PERSSTAMM_ID_EXTERN_UPD personenstamm.id%TYPE;'||unistr('\000a')||
'   v_extern_typ   VARCHAR2(2);'||unistr('\000a')||
'   v_return       NUMBER;'||unistr('\000a')||
'   v_fehlertext   VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.p(''Rechnungsadresse eintragen: Pers=%1 id:%2 typ:%3! [page308,extadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'', :p308_id,:p308_persstamm_id_extern_upd,:p308_adresstyp_extern);'||unistr('\000a')||
'   v_PERSSTAMM_ID_EXTERN_UPD := :P';

p:=p||'308_persstamm_id_extern_upd;'||unistr('\000a')||
'   v_extern_typ   := :p308_adresstyp_extern;'||unistr('\000a')||
'   :P308_persstamm_id_extern_upd := NULL;'||unistr('\000a')||
'   :P308_adresstyp_extern:= NULL;'||unistr('\000a')||
'   IF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''R'' THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET persstamm_id_rechnung = v_PERSSTAMM_ID_EXTERN_UPD'||unistr('\000a')||
'         WHERE id = :p308_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'  ';

p:=p||'       MEL.p(''Rechnungsadresse speichern: WK=%1 id:%2! Fehler:%3 [page300,Rechnungsadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'',:p308_id,v_PERSSTAMM_ID_EXTERN_UPD, SQLERRM);'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSIF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''L'' THEN'||unistr('\000a')||
'      v_return := frgbg_s.WK_CHECK_ADR_KOMPATIBEL(p_persstamm_id_prod_apo => :P308_PERSSTAMM_ID_prod_apo,'||unistr('\000a')||
'                                ';

p:=p||'               p_persstamm_id_kunde    => :P308_PERSSTAMM_ID_kunde,'||unistr('\000a')||
'                                               p_persstamm_id_lieferung=> v_PERSSTAMM_ID_EXTERN_UPD,'||unistr('\000a')||
'                                               p_persstamm_id_rechnung => :P308_PERSSTAMM_ID_RECHNUNG,'||unistr('\000a')||
'                                               p_warenkorb_tmp_id      => :P308_ID,  -- NEI 05.06.2014'||unistr('\000a')||
'                         ';

p:=p||'                      p_sprache_id            => :fas_sprache_id ,'||unistr('\000a')||
'                                               p_fehlertext_out        => v_fehlertext'||unistr('\000a')||
'                                               );'||unistr('\000a')||
'      IF v_return = 1 THEN'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            UPDATE warenkoerbe_tmp'||unistr('\000a')||
'            SET persstamm_id_lieferung = v_PERSSTAMM_ID_EXTERN_UPD'||unistr('\000a')||
'            WHERE id = :p308_id;'||unistr('\000a')||
'            -- Neue';

p:=p||' Versandkosten ermitteln'||unistr('\000a')||
'            --v_return := frgbg_s.WK_GEN_VERSANDKOSTEN( :p308_id,1) ;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            MEL.p(''Lieferadresse speichern: WK=%1 id:%2! Fehler:%3 [page308,Lieferadresse speichern]'','||unistr('\000a')||
'                  v_PROT_ID, ''ERROR'', ''fas'',:p308_id,v_PERSSTAMM_ID_EXTERN_UPD, SQLERRM);'||unistr('\000a')||
'         END;'||unistr('\000a')||
'      ELSIF v_fehlertext is not null THEN -- Adresspr';

p:=p||'üffehler; Adresse wurde nicht übernommen'||unistr('\000a')||
'         v_fehlertext:= v_fehlertext || '' ''|| frgbg_s.holen_uebersetzung(9604,:fas_sprache_id);'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         htp.p(''alert("''||v_fehlertext||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''</body>'');'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_fehlertext :=  frgbg_s.holen_uebersetzung(5727,:fas_sprache_';

p:=p||'id)||'' ''|| frgbg_s.holen_uebersetzung(9604,:fas_sprache_id);'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         htp.p(''alert("''||v_fehlertext||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''</body>'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSIF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''P'' THEN'||unistr('\000a')||
'      -- 6.12.10 Wechsel des Patient eigentlich nicht mehr möglich, d';

p:=p||'a nur noch Patientenstamm'||unistr('\000a')||
'      -- aenderbar => wk verlassen u. korrekten Patient auswaehlen'||unistr('\000a')||
'      :P308_PERSSTAMM_ID:= v_PERSSTAMM_ID_EXTERN_UPD; '||unistr('\000a')||
'   ELSIF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''RS'' THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET persstamm_id_rechnungssteller = v_PERSSTAMM_ID_EXTERN_UPD'||unistr('\000a')||
'         WHERE id = :p308_id;'||unistr('\000a')||
'         -- Neue Versandkosten ';

p:=p||'ermitteln'||unistr('\000a')||
'         --v_return := frgbg_s.WK_GEN_VERSANDKOSTEN( :p308_id,1);'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         MEL.p(''Rechnungssteller speichern: WK=%1 id:%2! Fehler:%3 [page308,Rechnungssteller speichern]'','||unistr('\000a')||
'               v_PROT_ID, ''ERROR'', ''fas'',:p308_id,v_PERSSTAMM_ID_EXTERN_UPD, SQLERRM);'||unistr('\000a')||
'      END; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7849721370227127 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'externe_adressen_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p308_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND :p308_adresstyp_extern is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_waehrung_id          warenkoerbe_tmp.waehrung_id%TYPE;'||unistr('\000a')||
'   v_liefer_land_id       laender.id%TYPE;'||unistr('\000a')||
'   v_verrech_land_id      warenkoerbe_tmp.verrech_land_id%TYPE;'||unistr('\000a')||
'   v_preislistentyp       preislisten.typ%TYPE;'||unistr('\000a')||
'   v_preislisten_land_id  preislisten.land_id%TYPE;'||unistr('\000a')||
'   v_sortiment_id         sortimente.id%TYPE; -- NEI 14.02.2011 Sortimentseinfuehrung: '||unistr('\000a')||
'                                     ';

p:=p||'         -- sortiment_id statt preislisten_set_id'||unistr('\000a')||
'   v_preisliste_id        preislisten.id%TYPE;'||unistr('\000a')||
'   v_art_mwst_typ_id      preislisten_details.art_mwst_typ_id%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechsteller personenstamm.id%type;'||unistr('\000a')||
'   v_persstamm_id_lieferung   personenstamm.id%type;'||unistr('\000a')||
'   v_verrech_land_id_db       warenkoerbe_tmp.verrech_land_id%TYPE;'||unistr('\000a')||
'   v_waehrung_id_db           warenkoerbe_tmp.waehrung_id%TYP';

p:=p||'E;'||unistr('\000a')||
'   v_preisliste_id_db         warenkoerbe_tmp.preisliste_id%TYPE;      '||unistr('\000a')||
'   v_persstamm_id_prod_apo    warenkoerbe_tmp.persstamm_id_prod_apo%TYPE;'||unistr('\000a')||
'   v_persstamm_id_identitaet  warenkoerbe_tmp.persstamm_id_identitaet%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechnung    warenkoerbe_tmp.persstamm_id_rechnung%TYPE;'||unistr('\000a')||
'   v_persstamm_id_kunde       warenkoerbe_tmp.persstamm_id_kunde%TYPE;'||unistr('\000a')||
'   v_aerztlich_verordnet      ';

p:=p||'warenkoerbe_tmp.aerztlich_verordnet%TYPE;'||unistr('\000a')||
'   v_anz                      NUMBER;'||unistr('\000a')||
''||unistr('\000a')||
'   v_fehler            exception;'||unistr('\000a')||
'   v_return            NUMBER;'||unistr('\000a')||
'   v_prot_id           NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*MEL.P (''vor check_waerhung:MaskeWaehr %1,MaskeVerrech %2,WK_tmp_id %3, %4, %5, %6, %7'','||unistr('\000a')||
'           v_prot_id,''Info'',''change_waehrung 102/300'','||unistr('\000a')||
'          :p300_waehrung_id,:P300_VERRECH_LAND_ID,'||unistr('\000a')||
'          :p300_waren';

p:=p||'korb_tmp_id);   '||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :p300_warenkorb_tmp_id is not null THEN'||unistr('\000a')||
'      -- Prüfen, ob die angezeigte Währung noch die aktuell gültige ist'||unistr('\000a')||
'      -- Verrechnungsland bestimmen und entsprechende Währung holen'||unistr('\000a')||
'      --SELECT NVL(min(land_id),198), into v_liefer_land_id'||unistr('\000a')||
'      SELECT persstamm_id_lieferung, persstamm_id_rechnungssteller,verrech_land_id,waehrung_id, '||unistr('\000a')||
'             persstamm_id_prod_apo,pe';

p:=p||'rsstamm_id_identitaet,persstamm_id_rechnung,v_persstamm_id_kunde,preisliste_id,aerztlich_verordnet'||unistr('\000a')||
'      INTO v_persstamm_id_lieferung,v_persstamm_id_rechsteller,v_verrech_land_id_db,v_waehrung_id_db,'||unistr('\000a')||
'             v_persstamm_id_prod_apo,v_persstamm_id_identitaet,v_persstamm_id_rechnung,v_persstamm_id_kunde,v_preisliste_id_db,v_aerztlich_verordnet'||unistr('\000a')||
'      FROM warenkoerbe_tmp wk'||unistr('\000a')||
'      WHERE wk.id = ';

p:=p||':p300_warenkorb_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'      v_verrech_land_id := rezepte.get_verrechnungsland_id '||unistr('\000a')||
'                            (v_persstamm_id_lieferung,v_persstamm_id_rechsteller);'||unistr('\000a')||
''||unistr('\000a')||
'      -- NEI 13.06.13 Falls es sich um einen reinen Laboranalysen handelt soll das Verrechnungsland immer CH sein => Diese Dienstleistungen die CH-Preise und Mwst '||unistr('\000a')||
'      -- Pruefen, ob details vorhanden sind, falls keine Details, d';

p:=p||'ann aerztlich_verordnet = 0'||unistr('\000a')||
'      IF :p300_sa_auftragsnummer is not null THEN  -- Laboranalyseauftrag'||unistr('\000a')||
'         v_verrech_land_id := 198;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      v_waehrung_id := rezepte.get_id_waehrung(v_verrech_land_id);'||unistr('\000a')||
''||unistr('\000a')||
'      -- Prüfe Existenz der passenden Preisliste; ggf. wird die Waehrung und das'||unistr('\000a')||
'      -- Verrechnungsland-ID,Typ  an die Standardpreisliste angepasst'||unistr('\000a')||
'      v_preislistentyp := rez';

p:=p||'epte.get_preislisten_typ (      -- NEI 06.05.13 Einfuehrung mit/ohne Mwst PL'||unistr('\000a')||
'                v_VERRECH_LAND_ID,'||unistr('\000a')||
'                v_persstamm_id_rechsteller,'||unistr('\000a')||
'                v_persstamm_id_prod_apo,'||unistr('\000a')||
'                v_persstamm_id_identitaet,'||unistr('\000a')||
'                v_persstamm_id_kunde,'||unistr('\000a')||
'                v_persstamm_id_rechnung,'||unistr('\000a')||
'                v_persstamm_id_lieferung );'||unistr('\000a')||
''||unistr('\000a')||
'      v_sortiment_id := NVL(v(''FAS_S';

p:=p||'ORTIMENT_ID''),         -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                              rezepte.GET_SORTIMENT_STD);  -- Standard-Sortiment der oberste Ident.'||unistr('\000a')||
'      v_preisliste_id := rezepte.get_preisliste_id(v_waehrung_id,v_verrech_land_id,'||unistr('\000a')||
'                                                   v_preislistentyp,v_sortiment_id); '||unistr('\000a')||
'      -- Art_mwst_typ_id für Mischungen ermitteln'||unistr('\000a')||
'      /* NEI 17.0';

p:=p||'4.2015 Ermittlung über Funktion wg. Ausnahmeregelung EU-Export der ApoRichter'||unistr('\000a')||
'      SELECT min(art_mwst_typ_id) into v_art_mwst_typ_id'||unistr('\000a')||
'      FROM laender'||unistr('\000a')||
'      WHERE id = v_verrech_land_id; '||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_art_mwst_typ_id := rezepte.GET_ART_MWST_TYP_ID_MISCHUNG (v_verrech_land_id,v_persstamm_id_rechsteller);'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''check_waerhung nach holen :Waehrneu %1,Verrechneu %2,WK_tmp_id %3, Waehralt %';

p:=p||'4, verrechalt %5, %6, %7'','||unistr('\000a')||
'           v_prot_id,''Info'',''change_waehrung 102/300'','||unistr('\000a')||
'          v_waehrung_id,v_verrech_land_id,'||unistr('\000a')||
'          :p300_warenkorb_tmp_id,v_waehrung_id_db,v_verrech_land_id_db);   '||unistr('\000a')||
'*/'||unistr('\000a')||
'      -- Pruefen, ob details vorhanden sind, falls keine Details, dann aerztlich_verordnet = 0'||unistr('\000a')||
'      SELECT count(*) INTO v_anz'||unistr('\000a')||
'      from warenkorb_details_tmp wkd'||unistr('\000a')||
'      where wkd.warenkorb_tmp_i';

p:=p||'d = :p300_warenkorb_tmp_id;'||unistr('\000a')||
'      IF v_anz = 0 THEN'||unistr('\000a')||
'         :p300_aerztlich_verordnet := 0;  '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Änderung feststellen'||unistr('\000a')||
'      IF v_verrech_land_id != v_verrech_land_id_db OR'||unistr('\000a')||
'         v_waehrung_id != v_waehrung_id_db OR'||unistr('\000a')||
'         v_preisliste_id != v_preisliste_id_db OR'||unistr('\000a')||
'         v_aerztlich_verordnet != :p300_aerztlich_verordnet'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         -- Warenkorb bzgl. Währung akt';

p:=p||'ualisieren'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET  waehrung_id = v_waehrung_id,'||unistr('\000a')||
'              verrech_land_id = v_verrech_land_id,'||unistr('\000a')||
'              preisliste_id  = v_preisliste_id,'||unistr('\000a')||
'              art_mwst_typ_id = v_art_mwst_typ_id,'||unistr('\000a')||
'              aerztlich_verordnet = :p300_aerztlich_verordnet'||unistr('\000a')||
'         WHERE id = :p300_warenkorb_tmp_id;'||unistr('\000a')||
'         -- Details gemäss neuer Währung berechnen'||unistr('\000a')||
'       ';

p:=p||'  v_return := frgbg_s.wk_calc_details(:p300_warenkorb_tmp_id,1,1,'||unistr('\000a')||
'                                             1   -- NEI 18.06.14 Reichweitenstaffel-Rabattberechnung (=1) für Mischungen,'||unistr('\000a')||
'                                                 --              nur  noch im WK und auf Bestellschein sonst keine Rabattrechnung                                            '||unistr('\000a')||
'                                      ';

p:=p||'       );'||unistr('\000a')||
'         IF v_return < 0 THEN'||unistr('\000a')||
'            NULL;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         v_return:= frgbg_s.wk_gen_versandkosten(:P308_WARENKORB_TMP_ID,1);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''check_waerhung toggle:Mwsttyp %1, waehralt %2, maskeverrech %3, verrechneu%4, waehrneu%5, Return %6, PL:%7'','||unistr('\000a')||
'           v_prot_id,''Info'',''change_waehrung 102/300'','||unistr('\000a')||
'           v_art_mwst_typ_id,:p300_waehrung_id,:';

p:=p||'p300_verrech_land_id, v_verrech_land_id,     '||unistr('\000a')||
'           v_waehrung_id,v_return,v_preisliste_id); '||unistr('\000a')||
'*/           '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8877311169494996 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_waehrung_neu',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:WARENKOERBE_TMP:P308_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 7772030994506239 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_process_sequence=> 90,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from WARENKOERBE_TMP',
  p_process_sql_clob => p,
  p_process_error_message=> 'fehler in row select #SQLERRM# &P300_WARENKORB_TMP_ID.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p308_warenkorb_tmp_id is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P308_HEIGHT_warenkorb := :FAS_SCROLLREGION_HEIGHT_MAX * 0.8;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7772417526506241 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 308,
  p_process_sequence=> 100,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 308
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00320
prompt  ...PAGE 320: Warenkorbuebersicht
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 320
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Warenkorbuebersicht'
 ,p_step_title => 'Warenkorbübersicht'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Warenkorbuebersicht'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150310125137'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'  wk.ID,'||unistr('\000a')||
'  PLANDATUM,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_kunde)||'', ''||persstamm_id_kunde ADRESSE_KUNDE ,'||unistr('\000a')||
'  GESAMTPREIS ,'||unistr('\000a')||
'  (SELECT NVL(zeichen,code) FROM waehrungen where id = WAEHRUNG_ID) WAEHRUNG,'||unistr('\000a')||
'  (SELECT iso3_id a FROM Laender WHERE id = verrech_land_id) VERRECH_LAND,'||unistr('\000a')||
'  fas_synch.get_tab_uebersetzung(''WARENKORB_STATUS.BEZEICHNUNG'','||unistr('\000a')||
'                                       wk_statu';

s:=s||'s_id,:fas_sprache_id) WK_STATUS,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_rechnung)||'', ''||persstamm_id_rechnung ADRESSE_RECHNUNG ,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_lieferung)||'', ''||persstamm_id_lieferung ADRESSE_LIEFERUNG,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_prod_apo)||'', ''||persstamm_id_prod_apo ADRESSE_PROD_APO,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_identitaet)||'', ''||persstamm_id_';

s:=s||'identitaet ADRESSE_IDENTITAET ,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_login)||'', ''||persstamm_id_login ADRESSE_BETREUER '||unistr('\000a')||
'  ,CASE WHEN ((wk_status_id in (5,7,50) AND extern_verwaltet=0) -- FAS-Aufträge'||unistr('\000a')||
'        OR    (wk_status_id = 5 AND extern_verwaltet=1)         -- GUS-Aufträge'||unistr('\000a')||
'             )'||unistr('\000a')||
'        AND error_flag is null     -- WK nicht wg. fehler ausgesteuert'||unistr('\000a')||
'        /* Eingefügt: mcg 29.08';

s:=s||'.2013 */ '||unistr('\000a')||
'        and not exists (select 1 from warenkorb_details wkd where wkd.warenkorb_id = wk.id and wkd.labor_auftrag_id is not null) '||unistr('\000a')||
'        /* Ende eingefügt mcg*/'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'        apex_item.checkbox(1,ID,''UNCHECKED'') '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'        '' '' '||unistr('\000a')||
'   END row_selector,'||unistr('\000a')||
'   erfdat,'||unistr('\000a')||
'   extern_verwaltet,'||unistr('\000a')||
'   GUS_KUNDENAUFTRAG_ID,'||unistr('\000a')||
'   CASE WHEN error_flag is null THEN -- kein Fehler'||unistr('\000a')||
'     to_char(error_flag';

s:=s||')'||unistr('\000a')||
'   WHEN wk_status_id = 6 and error_flag is not null THEN       -- Fehler mit Status 6 noch nicht an GUS'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':320:''||:APP_SESSION||'':WK_RESTART''||'':&DEBUG.::''||'||unistr('\000a')||
'     ''P320_WK_ID_RESTART:''||ID)'||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndretur.gif" border="0">''  -- shopping_cart,white_branch, fndretur,processing,refresh,unlock_enable';

s:=s||'d'||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   WHEN wk_status_id = 6.4 and error_flag is not null THEN       -- Fehler mit Status 6.4 Adressprüfung kommt mit Fehler von GUS'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':320:''||:APP_SESSION||'':WK_RESTART_GUS''||'':&DEBUG.::''||'||unistr('\000a')||
'     ''P320_WK_ID_RESTART:''||ID)'||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndretur.gif" border="0">''  -- shopping_cart,white_branc';

s:=s||'h, fndretur,processing,refresh,unlock_enabled'||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   ELSE                              -- Fehler mit Status > 6 noch nicht an GUS'||unistr('\000a')||
'     to_char(error_flag)'||unistr('\000a')||
'   END    error_flag,'||unistr('\000a')||
'   error_text,'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''WK_VERSANDARTEN.BEZEICHNUNG'','||unistr('\000a')||
'                                   WK_VERSANDART_ID,:fas_sprache_id) WK_VERSANDART,'||unistr('\000a')||
'   WSH_KUNDENAUFTRAG_ID,'||unistr('\000a')||
'   cc_transaktionsnr'||unistr('\000a')||
'  ';

s:=s||'-- ,apex_item.checkbox(1,ID,''UNCHECKED'') row_selector'||unistr('\000a')||
'from warenkoerbe wk'||unistr('\000a')||
'where  -- Bestellungen nur für Default Produzierende Apotheke des Betreuers'||unistr('\000a')||
'       PERSSTAMM_ID_PROD_APO = :p320_persstamm_id_prod_apo'||unistr('\000a')||
'  AND (:p320_nur_offene_WK = 1 AND wk_status_id < 60'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       :p320_nur_offene_wk = 0'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and (:P320_PERSSTAMM_ID_IDENTITAET=0 OR '||unistr('\000a')||
'       PERSSTAMM_ID_IDENTITAET = :P320_PERSSTA';

s:=s||'MM_ID_IDENTITAET'||unistr('\000a')||
'      )'||unistr('\000a')||
'           '||unistr('\000a')||
'      ';

wwv_flow_api.create_page_plug (
  p_id=> 4291008111260920 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_plug_name=> 'Warenkörbe',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow: auto; height: &P320_HEIGHT_WKLISTE.px;">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'select '||unistr('\000a')||
'  wk.ID,'||unistr('\000a')||
'  PLANDATUM,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_kunde)||'', ''||persstamm_id_kunde ADRESSE_KUNDE ,'||unistr('\000a')||
'  GESAMTPREIS ,'||unistr('\000a')||
'  (SELECT NVL(zeichen,code) FROM waehrungen where id = WAEHRUNG_ID) WAEHRUNG,'||unistr('\000a')||
'  (SELECT iso3_id a FROM Laender WHERE id = verrech_land_id) VERRECH_LAND,'||unistr('\000a')||
'  fas_synch.get_tab_uebersetzung(''WARENKORB_STATUS.BEZEICHNUNG'','||unistr('\000a')||
'                                       wk_statu';

a1:=a1||'s_id,:fas_sprache_id) WK_STATUS,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_rechnung)||'', ''||persstamm_id_rechnung ADRESSE_RECHNUNG ,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_lieferung)||'', ''||persstamm_id_lieferung ADRESSE_LIEFERUNG,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_prod_apo)||'', ''||persstamm_id_prod_apo ADRESSE_PROD_APO,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_identitaet)||'', ''||persstamm_id_';

a1:=a1||'identitaet ADRESSE_IDENTITAET ,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(persstamm_id_login)||'', ''||persstamm_id_login ADRESSE_BETREUER '||unistr('\000a')||
'  ,CASE WHEN ((wk_status_id in (5,7,50) AND extern_verwaltet=0) -- FAS-Aufträge'||unistr('\000a')||
'        OR    (wk_status_id = 5 AND extern_verwaltet=1)         -- GUS-Aufträge'||unistr('\000a')||
'             )'||unistr('\000a')||
'        AND error_flag is null     -- WK nicht wg. fehler ausgesteuert'||unistr('\000a')||
'        /* Eingefügt: mcg 29.08';

a1:=a1||'.2013 */ '||unistr('\000a')||
'        and not exists (select 1 from warenkorb_details wkd where wkd.warenkorb_id = wk.id and wkd.labor_auftrag_id is not null) '||unistr('\000a')||
'        /* Ende eingefügt mcg*/'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'        apex_item.checkbox(1,ID,''UNCHECKED'') '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'        '' '' '||unistr('\000a')||
'   END row_selector,'||unistr('\000a')||
'   erfdat,'||unistr('\000a')||
'   extern_verwaltet,'||unistr('\000a')||
'   GUS_KUNDENAUFTRAG_ID,'||unistr('\000a')||
'   CASE WHEN error_flag is null THEN -- kein Fehler'||unistr('\000a')||
'     to_char(error_flag';

a1:=a1||')'||unistr('\000a')||
'   WHEN wk_status_id = 6 and error_flag is not null THEN       -- Fehler mit Status 6 noch nicht an GUS'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':320:''||:APP_SESSION||'':WK_RESTART''||'':&DEBUG.::''||'||unistr('\000a')||
'     ''P320_WK_ID_RESTART:''||ID)'||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndretur.gif" border="0">''  -- shopping_cart,white_branch, fndretur,processing,refresh,unlock_enable';

a1:=a1||'d'||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   WHEN wk_status_id = 6.4 and error_flag is not null THEN       -- Fehler mit Status 6.4 Adressprüfung kommt mit Fehler von GUS'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':320:''||:APP_SESSION||'':WK_RESTART_GUS''||'':&DEBUG.::''||'||unistr('\000a')||
'     ''P320_WK_ID_RESTART:''||ID)'||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndretur.gif" border="0">''  -- shopping_cart,white_branc';

a1:=a1||'h, fndretur,processing,refresh,unlock_enabled'||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   ELSE                              -- Fehler mit Status > 6 noch nicht an GUS'||unistr('\000a')||
'     to_char(error_flag)'||unistr('\000a')||
'   END    error_flag,'||unistr('\000a')||
'   error_text,'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''WK_VERSANDARTEN.BEZEICHNUNG'','||unistr('\000a')||
'                                   WK_VERSANDART_ID,:fas_sprache_id) WK_VERSANDART,'||unistr('\000a')||
'   WSH_KUNDENAUFTRAG_ID,'||unistr('\000a')||
'   cc_transaktionsnr'||unistr('\000a')||
'  ';

a1:=a1||'-- ,apex_item.checkbox(1,ID,''UNCHECKED'') row_selector'||unistr('\000a')||
'from warenkoerbe wk'||unistr('\000a')||
'where  -- Bestellungen nur für Default Produzierende Apotheke des Betreuers'||unistr('\000a')||
'       PERSSTAMM_ID_PROD_APO = :p320_persstamm_id_prod_apo'||unistr('\000a')||
'  AND (:p320_nur_offene_WK = 1 AND wk_status_id < 60'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       :p320_nur_offene_wk = 0'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and (:P320_PERSSTAMM_ID_IDENTITAET=0 OR '||unistr('\000a')||
'       PERSSTAMM_ID_IDENTITAET = :P320_PERSSTA';

a1:=a1||'MM_ID_IDENTITAET'||unistr('\000a')||
'      )'||unistr('\000a')||
'           '||unistr('\000a')||
'      ';

wwv_flow_api.create_worksheet(
  p_id=> 4291131512260920+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_region_id=> 4291008111260920+wwv_flow_api.g_id_offset,
  p_name=> 'warenkoerbe',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '10000',
  p_max_row_count_message=> 'Die Anfrage umfasst mehr als #MAX_ROW_COUNT# Datensätze. Bitte schränken Sie ihre Anfrage ein, um ein vollständiges Ergebnis sicherzustellen!',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'Y',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y_OF_Z',
  p_pagination_display_pos=>'TOP_AND_BOTTOM_RIGHT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'C',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'Y',
  p_show_highlight=>'Y',
  p_show_computation=>'Y',
  p_show_aggregate=>'Y',
  p_show_chart=>'Y',
  p_show_group_by=>'Y',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'Y',
  p_show_reset=>'Y',
  p_show_download=>'Y',
  p_show_help=>'Y',
  p_download_formats=>'CSV:HTML:EMAIL',
  p_detail_link=>'f?p=&APP_ID.:321:&SESSION.::&DEBUG.:321:P321_ID:#ID#',
  p_detail_link_text=>'<img src="#IMAGE_PREFIX#edit_big.gif" alt="">',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'BRIGITTE.NEIDHART',
  p_internal_uid=> 1);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4378208602865948+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ROW_SELECTOR',
  p_display_order          =>1,
  p_column_identifier      =>'AH',
  p_column_label           =>'<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />',
  p_report_label           =>'<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4291326646260940+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID',
  p_display_order          =>2,
  p_column_identifier      =>'A',
  p_column_label           =>'Id',
  p_report_label           =>'Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4291416269260947+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'PLANDATUM',
  p_display_order          =>3,
  p_column_identifier      =>'B',
  p_column_label           =>'Plandatum',
  p_report_label           =>'Plandatum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4291727230260947+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'GESAMTPREIS',
  p_display_order          =>4,
  p_column_identifier      =>'E',
  p_column_label           =>'Gesamtpreis',
  p_report_label           =>'Gesamtpreis',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_format_mask            =>'999G999G999G999G990D00',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4353004787545986+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'VERRECH_LAND',
  p_display_order          =>5,
  p_column_identifier      =>'Y',
  p_column_label           =>'Verrech Land',
  p_report_label           =>'Verrech Land',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4353210422604385+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WAEHRUNG',
  p_display_order          =>6,
  p_column_identifier      =>'Z',
  p_column_label           =>'Währung',
  p_report_label           =>'Währung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'CENTER',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4353329206604385+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_KUNDE',
  p_display_order          =>7,
  p_column_identifier      =>'AA',
  p_column_label           =>'Kunde',
  p_report_label           =>'Kunde',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4353410855604385+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_RECHNUNG',
  p_display_order          =>8,
  p_column_identifier      =>'AB',
  p_column_label           =>'Rechnung',
  p_report_label           =>'Rechnung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4353504468604385+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_LIEFERUNG',
  p_display_order          =>9,
  p_column_identifier      =>'AC',
  p_column_label           =>'Lieferung',
  p_report_label           =>'Lieferung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4353614557604385+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_PROD_APO',
  p_display_order          =>10,
  p_column_identifier      =>'AD',
  p_column_label           =>'Prod Apo',
  p_report_label           =>'Prod Apo',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'HIDDEN',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4353716764604385+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_IDENTITAET',
  p_display_order          =>11,
  p_column_identifier      =>'AE',
  p_column_label           =>'Identität',
  p_report_label           =>'Identität',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4353826689604385+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_BETREUER',
  p_display_order          =>12,
  p_column_identifier      =>'AF',
  p_column_label           =>'Betreuer',
  p_report_label           =>'Betreuer',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4354015055615122+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WK_STATUS',
  p_display_order          =>13,
  p_column_identifier      =>'AG',
  p_column_label           =>'Status',
  p_report_label           =>'Status',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5551623247244098+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERFDAT',
  p_display_order          =>14,
  p_column_identifier      =>'AI',
  p_column_label           =>'Datum',
  p_report_label           =>'Datum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_format_mask            =>'DD.MM.YY/HH24:MI',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 8542831053635254+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EXTERN_VERWALTET',
  p_display_order          =>15,
  p_column_identifier      =>'AJ',
  p_column_label           =>'GUS verwalt',
  p_report_label           =>'GUS verwalt',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 8542901935635263+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'GUS_KUNDENAUFTRAG_ID',
  p_display_order          =>16,
  p_column_identifier      =>'AK',
  p_column_label           =>'Gus-Id',
  p_report_label           =>'Gus-Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 8544602556910647+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERROR_TEXT',
  p_display_order          =>18,
  p_column_identifier      =>'AM',
  p_column_label           =>'Error Text',
  p_report_label           =>'Error Text',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4818529568768620+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERROR_FLAG',
  p_display_order          =>19,
  p_column_identifier      =>'AN',
  p_column_label           =>'Error Flag',
  p_report_label           =>'Error Flag',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4886711905873798+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WK_VERSANDART',
  p_display_order          =>20,
  p_column_identifier      =>'AO',
  p_column_label           =>'Wk Versandart',
  p_report_label           =>'Wk Versandart',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 12541330958704713+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WSH_KUNDENAUFTRAG_ID',
  p_display_order          =>21,
  p_column_identifier      =>'AP',
  p_column_label           =>'Wsh Kundenauftrag Id',
  p_report_label           =>'Wsh Kundenauftrag Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 12541416012704725+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'CC_TRANSAKTIONSNR',
  p_display_order          =>22,
  p_column_identifier      =>'AQ',
  p_column_label           =>'Cc Transaktionsnr',
  p_report_label           =>'Cc Transaktionsnr',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'ROW_SELECTOR:ID:PLANDATUM:ADRESSE_KUNDE:GESAMTPREIS:WAEHRUNG:WK_STATUS:ADRESSE_IDENTITAET:WK_VERSANDART:ERROR_FLAG:ERROR_TEXT:ADRESSE_RECHNUNG:ADRESSE_BETREUER:WSH_KUNDENAUFTRAG_ID:CC_TRANSAKTIONSNR';

wwv_flow_api.create_worksheet_rpt(
  p_id => 4293704567261241+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_worksheet_id => 4291131512260920+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'42938',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>100,
  p_report_columns          =>rc1,
  p_sort_column_1           =>'PLANDATUM',
  p_sort_direction_1        =>'DESC',
  p_sort_column_2           =>'WK_STATUS',
  p_sort_direction_2        =>'DESC',
  p_sort_column_3           =>'ID',
  p_sort_direction_3        =>'DESC',
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4295029464315779 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 320,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4590917151307946 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 320,
  p_button_sequence=> 15,
  p_button_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_ANGEFORDERT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Markierte Vorkasse angefordert',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4368904984247643 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 320,
  p_button_sequence=> 20,
  p_button_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_BEZAHLT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Markierte freigeben',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4369118490251573 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 320,
  p_button_sequence=> 30,
  p_button_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_AUSGELIEFERT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Markierte ausgeliefert',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4365013806568197 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 320,
  p_button_sequence=> 10,
  p_button_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4365100085573723 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 320,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P320_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:320::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4365013806568197+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 110,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4357313697841846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 320,
  p_name=>'P320_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prod. Apotheke',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.get_pers_name(:P320_PERSSTAMM_ID_PROD_APO)||'', ''||:P320_PERSSTAMM_ID_PROD_APO a, :P320_PERSSTAMM_ID_PROD_APO b'||unistr('\000a')||
'from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4365523980580637 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 320,
  p_name=>'P320_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4367105677897731 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 320,
  p_name=>'P320_NUR_OFFENE_WK',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 15,
  p_item_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT ''Nur offene Aufträge'' a, 1 b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''Alle Aufträge'' a, 0 b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 2,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '1',
  p_attribute_02 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4374327299527089 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 320,
  p_name=>'P320_MARKIERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Markieren',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4377506590695095 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 320,
  p_name=>'P320_HEIGHT_WKLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4382413806660703 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 320,
  p_name=>'P320_PERSSTAMM_ID_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identität',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(511,:fas_sprache_id) a, 0 b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION '||unistr('\000a')||
'/*'||unistr('\000a')||
'select distinct substr(p.name,1,30)||'', ''||substr(p.ort,1,30)||'', ''||p.id, wk.persstamm_id_identitaet'||unistr('\000a')||
'from warenkoerbe wk, warenkorb_details wkd,personenstamm p'||unistr('\000a')||
'where wkd.warenkorb_id = wk.id'||unistr('\000a')||
'  /* Bestellungen nur für Default Produzierende Apotheke des Betreuers * /'||unistr('\000a')||
'  and (wk.PERSSTAMM_ID_PROD_APO = :p320_persstamm_id_prod_apo'||unistr('\000a')||
'       or'||unistr('\000a')||
'       wk.PERSSTAMM_ID_PROD_APO is null'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and wk.PERSSTAMM_ID_IDENTITAET = p.id'||unistr('\000a')||
'*/'||unistr('\000a')||
'select frgbg_s.get_pers_name(:FAS_IDENTITAET_PERSSTAMM_ID)||'', ''||:FAS_IDENTITAET_PERSSTAMM_ID, to_number(:FAS_IDENTITAET_PERSSTAMM_ID) '||unistr('\000a')||
'from dual'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '/* NEI 29.04.14 &FAS_IDENTITAET_PERSSTAMM_ID.*/'||unistr('\000a')||
'Identität nicht mehr auf die Betreuer-Identität vorbelegt, sondern alle Identitäten ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4818703520855683 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 320,
  p_name=>'P320_WK_ID_RESTART',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4291008111260920+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 2234714175211281 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 320
 ,p_name => 'nach_wk_restart_load_page'
 ,p_event_sequence => 10
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
 ,p_display_when_type => 'PLSQL_EXPRESSION'
 ,p_display_when_cond => ':request like ''WK_RESTART%'''
  );
wwv_flow_api.create_page_da_action (
  p_id => 2235016932211283 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 320
 ,p_event_id => 2234714175211281 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 2235217955211286 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 320
 ,p_event_id => 2234714175211281 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_ALERT'
 ,p_attribute_01 => 'FALSE ACTION bei Reaktivierung'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_mutdat         varchar2(50);'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
''||unistr('\000a')||
'   v_extern_verwaltet number;'||unistr('\000a')||
'   v_wk_status_id   number;'||unistr('\000a')||
'   v_wk_status_id_db number;'||unistr('\000a')||
'   v_ohne_prodauftrag   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/* Doku:'||unistr('\000a')||
'   apex_application.g_f21(v_count)        -- wk_id'||unistr('\000a')||
'*/'||unistr('\000a')||
'/* NEI 12.12.12 GUS Bestellint';

p:=p||'egration'||unistr('\000a')||
'   IF :request = ''BUT_AUSGELIEFERT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 60;'||unistr('\000a')||
'   ELSIF :request = ''BUT_BEZAHLT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 10;'||unistr('\000a')||
'   ELSIF :request = ''BUT_ANGEFORDERT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 7;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :request = ''BUT_AUSGELIEFERT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 60;'||unistr('\000a')||
'   ELSIF :request = ''BUT_BEZAHLT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 10;'||unistr('\000a')||
'   ELSIF :req';

p:=p||'uest = ''BUT_ANGEFORDERT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 6;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
' '||unistr('\000a')||
'   -- WK speichern'||unistr('\000a')||
'   for v_count in 1..apex_application.g_f01.count'||unistr('\000a')||
'   loop '||unistr('\000a')||
'      SELECT wk_status_id, extern_verwaltet'||unistr('\000a')||
'      INTO v_wk_status_id_db, v_extern_verwaltet '||unistr('\000a')||
'      FROM warenkoerbe '||unistr('\000a')||
'      WHERE id = apex_application.g_f01(v_count); '||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P(''WK markiert f01 %1, ANZ: %2, Status: %3, db:%4'','||unistr('\000a')||
'  ';

p:=p||'         v_prot_id,'||unistr('\000a')||
'           ''Info'','||unistr('\000a')||
'           ''102/320: upd_wk_status'','||unistr('\000a')||
'           apex_application.g_f01(v_count),'||unistr('\000a')||
'           apex_application.g_f01.count,'||unistr('\000a')||
'           v_wk_status_id,'||unistr('\000a')||
'           v_wk_status_id_db'||unistr('\000a')||
'        );'||unistr('\000a')||
'*/       '||unistr('\000a')||
'      IF v_extern_verwaltet = 0 THEN -- FAS-Auftrag'||unistr('\000a')||
'         IF :request = ''BUT_BEZAHLT'' THEN  -- Vorkasse bezahlt                 -- NEI 07.08.13'||unistr('\000a')||
'            v_o';

p:=p||'hne_prodauftrag :=   -- NEI 07.08.13 Laborauftraege werden ohne Prodaufträge gemacht'||unistr('\000a')||
'              frgbg_s.WK_CHECK_OHNE_PRODAUFTRAG(apex_application.g_f01(v_count)); -- NEI 07.08.13'||unistr('\000a')||
'            IF v_ohne_prodauftrag = 1 THEN                                        -- NEI 07.08.13'||unistr('\000a')||
'               v_wk_status_id := 50; --  zur Auslieferung bereit => keine Auftragsdispo nötig   '||unistr('\000a')||
'            ELSIF v_oh';

p:=p||'ne_prodauftrag  < 0 THEN  -- Fehler'||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                              apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'               RAISE_APPLICATION_ERROR (-20004,v_fehlertext );'||unistr('\000a')||
'            END IF;                                                            -- NEI 07.08.13'||unistr('\000a')||
'         END IF;                  ';

p:=p||'                                             -- NEI 07.08.13'||unistr('\000a')||
''||unistr('\000a')||
'         IF v_wk_status_id_db < v_wk_status_id THEN'||unistr('\000a')||
'            IF v_wk_status_id = 6 THEN -- Vorkasse manuell angefordert => WK aktivieren'||unistr('\000a')||
'               v_return := frgbg_s.WK_aktivieren(apex_application.g_f01(v_count));'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               -- Speichern'||unistr('\000a')||
'               v_return := frgbg_s.WK_UPD_STATUS(apex_application.g_f0';

p:=p||'1(v_count)'||unistr('\000a')||
'                                          ,NULL'||unistr('\000a')||
'                                          ,v_WK_STATUS_ID'||unistr('\000a')||
'                 );'||unistr('\000a')||
'               IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'                  v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                              apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'                  RAISE_APPLICATION_ERROR ';

p:=p||'(-20005,v_fehlertext );'||unistr('\000a')||
'               END IF;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                               apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20010,v_fehlertext );'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSIF v_extern_verwaltet = 1 THEN -- GUS-Auftrag'||unistr('\000a')||
'         IF v_wk_';

p:=p||'status_id_db < v_wk_status_id THEN'||unistr('\000a')||
'            IF v_wk_status_id = 6 THEN -- Vorkasse manuell angefordert => WK aktivieren'||unistr('\000a')||
'               v_return := frgbg_s.WK_aktivieren(apex_application.g_f01(v_count));'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                               apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'    ';

p:=p||'           RAISE_APPLICATION_ERROR (-20015,v_fehlertext );'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                               apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20020,v_fehlertext );'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzu';

p:=p||'ng(5035,v_sprache_id,'||unistr('\000a')||
'                               apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20025,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   end loop;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4372418418758060 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 320,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'upd_wk_status',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BUT_AUSGELIEFERT'',''BUT_BEZAHLT'',''BUT_ANGEFORDERT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'reset_pagination';

wwv_flow_api.create_page_process(
  p_id     => 4818930494910853 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 320,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'RESET_PAGINATION',
  p_process_name=> 'Reset Pagination',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'''WK_RESTART''',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p320_persstamm_id_prod_apo := '||unistr('\000a')||
'              frgbg_s.get_pers_option(NULL, '||unistr('\000a')||
'                       21, frgbg_s.GET_IDENTITAET_BETR(:fas_login_personenstamm_id),'||unistr('\000a')||
'                       :fas_login_personenstamm_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4358018985900183 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 320,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_prod_apo',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Komplette Höhe ausnutzen (100% des Maximums)'||unistr('\000a')||
'   :P320_HEIGHT_WKliste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4377218233689005 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 320,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'    v_return     NUMBER;'||unistr('\000a')||
'    v_url        varchar2(2000);'||unistr('\000a')||
'    v_wk_id      number;'||unistr('\000a')||
'    v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_wk_id := :P320_WK_id_restart;'||unistr('\000a')||
'   :P320_WK_id_restart := NULL;'||unistr('\000a')||
'   IF :request = ''WK_RESTART'' THEN'||unistr('\000a')||
'      v_return := frgbg_s.wk_aktivieren(v_WK_id);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         --''Fehler beim Aktivieren der Bestellung! WK-ID:''||v_WK_id;'||unistr('\000a')||
'                '||unistr('\000a')||
'--mel.p(''In f';

p:=p||'ehlerausgabe WK:''||v_WK_id,v_prot_id,''INFO'',''p320/fehlerausgabe'');'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         htp.p(''alert("''||frgbg_s.holen_uebersetzung(4387,:fas_sprache_id)||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''</body>'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSIF :request = ''WK_RESTART_GUS'' THEN'||unistr('\000a')||
'      v_return := frgbg_at.GUS_KDAUFTRAG_REAKTIVIEREN(v_WK_i';

p:=p||'d);'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
'         --''Fehler beim Aktivieren der GUS-Bestellung! WK-ID:''||v_WK_id;'||unistr('\000a')||
'--mel.p(''In fehlerausgabe WK reaktiv:''||v_WK_id,v_prot_id,''INFO'',''p320/fehlerausgabe'');'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         htp.p(''alert("''||frgbg_s.holen_uebersetzung(4387,:fas_sprache_id)||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''';

p:=p||'</body>'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4819203492978719 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 320,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'wk_restart',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request like ''WK_RESTART%'' and :P320_WK_id_restart is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 320
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00321
prompt  ...PAGE 321: Warenkorbdetails
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 321
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Warenkorbdetails'
 ,p_step_title => 'Warenkorbdetails'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140521144240'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4295124283315779 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 321,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT '||unistr('\000a')||
'   wkd."ID" "ID", '||unistr('\000a')||
'   wkd."WARENKORB_ID" "WARENKORB_ID", '||unistr('\000a')||
'   wkd."PRODKENNZ_ID" "PRODKENNZ_ID", '||unistr('\000a')||
'   wkd."P_REZEPT_ID" "P_REZEPT_ID",'||unistr('\000a')||
'  '||unistr('\000a')||
'   case when mnr.rezept_nr is not null THEN'||unistr('\000a')||
'      -- mnr.rezept_nr  ||''/'' ||mnr.version --||'', ''||mnr.Bezeichnung  NEI 25.03.14  Gesamtrezept statt Split anzeigen'||unistr('\000a')||
'       rezepte.GET_MNR_BASIS_REZ_NUMMER_VER(NULL,pr.rezept_nr,pr.version,0)'||unistr('\000a')||
'   else '''''||unistr('\000a')||
'   end';

s:=s||' rezept_bez,'||unistr('\000a')||
'   mnr.rezept_nr rezept_nr,'||unistr('\000a')||
'   mnr.version  version, '||unistr('\000a')||
'   wkd."MENGENART_ID" "MENGENART_ID", '||unistr('\000a')||
'/*'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',wkd.MENGENART_ID,'||unistr('\000a')||
'                                  :fas_sprache_id)   || ''</br>'' '||unistr('\000a')||
'   ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       wkd.MENGENART_ID,:fas_sprache_id)'||unistr('\000a')||
'             menge';

s:=s||'nart_bez,'||unistr('\000a')||
'*/'||unistr('\000a')||
'  CASE WHEN wkd.PRODKENNZ_ID = 1 THEN '||unistr('\000a')||
'      frgbg_at.GUS_KDAP_GET_GUSARTIKEL (wkd.id)|| ''</br>''|| '||unistr('\000a')||
'      frgbg_s.get_pers_name_rezept(wkd.p_rezept_id)'||unistr('\000a')||
'  ELSE '||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',wkd.MENGENART_ID,:fas_sprache_id)|| ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                      wkd.MENGENART_ID,:fas_';

s:=s||'sprache_id)'||unistr('\000a')||
'      || CASE WHEN wkd.pergebnis_id is not null THEN'||unistr('\000a')||
'                   '' (''||wkd.pergebnis_id||'')'''||unistr('\000a')||
'         END'||unistr('\000a')||
'  END mengenart_bez,'||unistr('\000a')||
''||unistr('\000a')||
'   wkd."MENGE" "MENGE", '||unistr('\000a')||
'   wkd."VOLUMEN" "VOLUMEN", '||unistr('\000a')||
'   wkd."GEWICHT" "GEWICHT", '||unistr('\000a')||
'   wkd."PREIS" "PREIS", '||unistr('\000a')||
'   (wkd."MWST_BETRAG" * menge) "MWST_BETRAG", '||unistr('\000a')||
'   wkd."MWST_SATZ" "MWST_SATZ", '||unistr('\000a')||
'   ((wkd.preis) * menge) gesamtpreis,'||unistr('\000a')||
'   wkd."WK_STATUS_ID" "WK_S';

s:=s||'TATUS_ID", '||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''WARENKORB_STATUS.BEZEICHNUNG'','||unistr('\000a')||
'                                  wkd.WK_STATUS_ID,:fas_sprache_id) WK_STATUS,'||unistr('\000a')||
'   wkd."STATUS_AENDERDATUM" "STATUS_AENDERDATUM", '||unistr('\000a')||
'   wkd."STATUS_AENDERVISUM" "STATUS_AENDERVISUM", '||unistr('\000a')||
'   wkd."ETIKETTENTYP" "ETIKETTENTYP", '||unistr('\000a')||
'   wkd."BEMERKUNG" "BEMERKUNG", '||unistr('\000a')||
'   wkd."INH_GRENZWERTTYP_ID" "INH_GRENZWERTTYP_ID", '||unistr('\000a')||
'   wkd."PROVISIO';

s:=s||'NSPUNKTWERT" "PROVISIONSPUNKTWERT", '||unistr('\000a')||
'   wkd."PROVISIONSPUNKTE" "PROVISIONSPUNKTE", '||unistr('\000a')||
'   wkd."REZEPT_MENGE" "REZEPT_MENGE", '||unistr('\000a')||
'   wkd."REZEPT_GEWICHT" "REZEPT_GEWICHT", '||unistr('\000a')||
'   wkd."REZEPT_MENGENART_ID" "REZEPT_MENGENART_ID"'||unistr('\000a')||
'  ,CASE WHEN '||unistr('\000a')||
'       (:p321_extern_verwaltet = 0 AND  -- FAS-Auftraege'||unistr('\000a')||
'         ((wkd.wk_status_id < 50 '||unistr('\000a')||
'           AND  (wkd.mengenart_id is NULL OR wkd.mengenart_id != 101) --Versan';

s:=s||'dkosten'||unistr('\000a')||
'           AND ((wkd.p_rezept_id is not null AND wkd.mengenart_id is NULL AND'||unistr('\000a')||
'                 (SELECT count(*)                   -- Mischung noch nicht in Prod'||unistr('\000a')||
'                  FROM bestellungen b, auftraege a '||unistr('\000a')||
'                  WHERE b.warenkorb_detail_id = wkd.id '||unistr('\000a')||
'                    AND b.id = a.bestell_id'||unistr('\000a')||
'                  ) = 0'||unistr('\000a')||
'                ) '||unistr('\000a')||
'                OR wkd.mengenart_id ';

s:=s||'is NOT NULL       -- ist Fertigartikel'||unistr('\000a')||
'              )'||unistr('\000a')||
'          )'||unistr('\000a')||
'         OR '||unistr('\000a')||
'          (wkd.wk_status_id >= 50 AND wkd.wk_status_id < 60)'||unistr('\000a')||
'        )'||unistr('\000a')||
'       )'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       (:p321_extern_verwaltet = 1  and --GUS-Auftraege'||unistr('\000a')||
'        wkd.wk_status_id = 5  and'||unistr('\000a')||
'        (wkd.mengenart_id is NULL OR wkd.mengenart_id != 101) --Versandkosten'||unistr('\000a')||
'       )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'    apex_item.checkbox(1,wkd.ID,''UNCHECKED'') ';

s:=s||''||unistr('\000a')||
'   ELSE '' '''||unistr('\000a')||
'   END row_selector'||unistr('\000a')||
'FROM '||unistr('\000a')||
'   WARENKORB_DETAILS wkd, mn_rezepte mnr, prod_rezepte pr'||unistr('\000a')||
'WHERE wkd.WARENKORB_ID = :P321_ID'||unistr('\000a')||
'  AND wkd.p_rezept_id = pr.id (+)'||unistr('\000a')||
'  AND pr.version = mnr.version (+)'||unistr('\000a')||
'  AND pr.rezept_nr = mnr.rezept_nr (+)'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 321,
  p_name=> 'Positionen',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 20,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_when_condition=> 'P321_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_plug_query_max_columns=> 60,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '15',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'No data found.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12"',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12"',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4320024227316127 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 24,
  p_column_heading=> 'ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4320217637316127 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_ID',
  p_column_display_sequence=> 26,
  p_column_heading=> 'Warenkorb Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'WARENKORB_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4320423181316127 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_ID',
  p_column_display_sequence=> 25,
  p_column_heading=> 'Prodkennz Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'PRODKENNZ_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4320629332316127 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'P_REZEPT_ID',
  p_column_display_sequence=> 27,
  p_column_heading=> 'P Rezept Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'P_REZEPT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4363509061349159 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_BEZ',
  p_column_display_sequence=> 2,
  p_column_heading=> 'Rezept ',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4363204989329068 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 28,
  p_column_heading=> 'Rezept Nr',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4363304836329073 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'VERSION',
  p_column_display_sequence=> 29,
  p_column_heading=> 'Version',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4320827004316127 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Artikel-ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>2,
  p_default_sort_dir=>'desc',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4363724907372677 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_BEZ',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Artikel',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4321010754316127 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Menge',
  p_column_format=> '999G990D0',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4321210342316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'VOLUMEN',
  p_column_display_sequence=> 11,
  p_column_heading=> 'Volumen',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'VOLUMEN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4321407816316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'GEWICHT',
  p_column_display_sequence=> 12,
  p_column_heading=> 'Gewicht',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'GEWICHT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4321602378316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'PREIS',
  p_column_display_sequence=> 6,
  p_column_heading=> 'Einzelpreis &P321_WAEHRUNG_ZEICHEN.',
  p_column_format=> '999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'PREIS',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4321811256316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_BETRAG',
  p_column_display_sequence=> 8,
  p_column_heading=> 'Mwst Betrag &P321_WAEHRUNG_ZEICHEN.',
  p_column_format=> '999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MWST_BETRAG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4322016544316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_SATZ',
  p_column_display_sequence=> 9,
  p_column_heading=> 'Mwst %',
  p_column_format=> '999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MWST_SATZ',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4364330110449986 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'GESAMTPREIS',
  p_column_display_sequence=> 7,
  p_column_heading=> 'Gesamt &P321_WAEHRUNG_ZEICHEN.',
  p_column_format=> '999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4322203240316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS_ID',
  p_column_display_sequence=> 13,
  p_column_heading=> 'Wk Status Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'WK_STATUS_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4364014695407636 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS',
  p_column_display_sequence=> 10,
  p_column_heading=> 'Status',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4322424320316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERDATUM',
  p_column_display_sequence=> 14,
  p_column_heading=> 'Status Aenderdatum',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'STATUS_AENDERDATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4322606590316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERVISUM',
  p_column_display_sequence=> 15,
  p_column_heading=> 'Status Aendervisum',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'STATUS_AENDERVISUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4322825361316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'ETIKETTENTYP',
  p_column_display_sequence=> 16,
  p_column_heading=> 'Etikettentyp',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'ETIKETTENTYP',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4323000447316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 17,
  p_column_heading=> 'Bemerkung',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'BEMERKUNG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4323220405316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'INH_GRENZWERTTYP_ID',
  p_column_display_sequence=> 18,
  p_column_heading=> 'Inh Grenzwerttyp Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'INH_GRENZWERTTYP_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4323408531316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'PROVISIONSPUNKTWERT',
  p_column_display_sequence=> 19,
  p_column_heading=> 'Provisionspunktwert',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'PROVISIONSPUNKTWERT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4323604722316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'PROVISIONSPUNKTE',
  p_column_display_sequence=> 20,
  p_column_heading=> 'Provisionspunkte',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'PROVISIONSPUNKTE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4323827227316129 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_MENGE',
  p_column_display_sequence=> 21,
  p_column_heading=> 'Rezept Menge',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'REZEPT_MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4324017956316130 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 27,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_GEWICHT',
  p_column_display_sequence=> 22,
  p_column_heading=> 'Rezept Gewicht',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'REZEPT_GEWICHT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4324201333316130 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 28,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_MENGENART_ID',
  p_column_display_sequence=> 23,
  p_column_heading=> 'Rezept Mengenart Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'REZEPT_MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4378622782068755 + wwv_flow_api.g_id_offset,
  p_region_id=> 4295730780315781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 29,
  p_form_element_id=> null,
  p_column_alias=> 'ROW_SELECTOR',
  p_column_display_sequence=> 1,
  p_column_heading=> '<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4305305677316068 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 321,
  p_plug_name=> 'Warenkorb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4305621794316069 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 321,
  p_button_sequence=> 30,
  p_button_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Apply Changes',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P321_ID',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4519300457584446 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 321,
  p_button_sequence=> 45,
  p_button_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_EMAIL_BESTELLBLATT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Email Bestellblatt',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4312613364316108 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 321,
  p_button_sequence=> 50,
  p_button_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_PREVIOUS_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&lt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P321_ID_PREV',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4312500066316108 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 321,
  p_button_sequence=> 60,
  p_button_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_NEXT_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&gt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_NEXT_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P321_ID_NEXT',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4370505571933411 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 321,
  p_button_sequence=> 70,
  p_button_plug_id => 4295730780315781+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_EINZELSTORNO',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Storno',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> '(:p321_wk_status_id < 60 and :p321_extern_verwaltet = 0)'||unistr('\000a')||
'OR'||unistr('\000a')||
'(:p321_wk_status_id = 5 and :p321_extern_verwaltet = 1)',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4305920712316071 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 321,
  p_button_sequence=> 10,
  p_button_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:320:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4305512658316069 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 321,
  p_button_sequence=> 40,
  p_button_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Create',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P321_ID',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4305721391316069 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 321,
  p_button_sequence=> 20,
  p_button_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Delete',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'P321_ID',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'DELETE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4371022325947676 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:321:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 40,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BUT_EINZELSTORNO'',''BUT_KOMPLETTSTORNO'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-FEB-2012 12:41 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4306501589316073 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:320:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4316411951316118 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:321:&SESSION.::&DEBUG.::P321_ID:&P321_ID_NEXT.',
  p_branch_point=> 'BEFORE_COMPUTATION',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4312500066316108+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>4316616014316121 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:321:&SESSION.::&DEBUG.::P321_ID:&P321_ID_PREV.',
  p_branch_point=> 'BEFORE_COMPUTATION',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4312613364316108+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4306706113316077 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4306922918316096 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 54,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Datum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4307131364316098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land',
  p_source=>'VERRECH_LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT iso3_id a, id b'||unistr('\000a')||
'FROM Laender'||unistr('\000a')||
'WHERE id = :p321_verrech_land_id',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4307317215316098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'WAEHRUNG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4307523860316098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preis netto',
  p_post_element_text=>'&#160&#160&P321_WAEHRUNG_ZEICHEN.',
  p_format_mask=>'999990D00',
  p_source=>'GESAMTPREIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4307707594316098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_MWST_JN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Jn',
  p_source=>'MWST_JN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4307902913316099 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_MWST_BETRAG_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 71,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst  (&P321_MWST_SATZ_1.%)',
  p_post_element_text=>'&#160&#160&P321_WAEHRUNG_ZEICHEN.',
  p_format_mask=>'999990D00',
  p_source=>'MWST_BETRAG_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4308117771316099 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_MWST_BETRAG_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst (&P321_MWST_SATZ_2.%)',
  p_post_element_text=>'&#160&#160&P321_WAEHRUNG_ZEICHEN.',
  p_format_mask=>'999990D00',
  p_source=>'MWST_BETRAG_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P321_MWST_BETRAG_2 is not null',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4308324836316099 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_MWST_SATZ_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'MWST_SATZ_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4308502729316099 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_MWST_SATZ_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'MWST_SATZ_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P321_MWST_BETRAG_2 is not null',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4308732276316099 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_WK_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 86,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status',
  p_source=>'WK_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select fas_synch.get_tab_uebersetzung(''WARENKORB_STATUS.BEZEICHNUNG'','||unistr('\000a')||
'                                       ID,:fas_sprache_id) a, id b'||unistr('\000a')||
'FROM warenkorb_status'||unistr('\000a')||
'where id = :P321_WK_STATUS_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4308911641316101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_STATUS_AENDERDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aenderdatum',
  p_source=>'STATUS_AENDERDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4309125497316101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_STATUS_AENDERVISUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aendervisum',
  p_source=>'STATUS_AENDERVISUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4309318077316101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p321_persstamm_id_rechnung)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4309525679316101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 115,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Betreuer',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p321_persstamm_id_login)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4309707407316101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 61,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p321_persstamm_id_lieferung)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4309919241316101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bemerkung',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4310119725316102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PERSSTAMM_ID_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identität',
  p_source=>'PERSSTAMM_ID_IDENTITAET',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p321_persstamm_id_identitaet)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4310304110316102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prod. Apotheke',
  p_source=>'PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p321_persstamm_id_prod_apo)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4310509263316102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PREISLISTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisliste',
  p_source=>'PREISLISTE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select bezeichnung a, id b'||unistr('\000a')||
'from preislisten '||unistr('\000a')||
'where id= :P321_PREISLISTE_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4310730627316102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_ART_MWST_TYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Art Mwst Typ Id',
  p_source=>'ART_MWST_TYP_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4310928706316102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PREISFAKTOR',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 93,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisfaktor',
  p_source=>'PREISFAKTOR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4311107428316102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PERSSTAMM_ID_KUNDE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kunde',
  p_source=>'PERSSTAMM_ID_KUNDE',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p321_persstamm_id_kunde)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4311307641316102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PROVISIONSPUNKTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Provisionspunkte',
  p_source=>'PROVISIONSPUNKTE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4311513496316104 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_PROVISIONSKOPF_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Provisionskopf Id',
  p_source=>'PROVISIONSKOPF_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4311707462316104 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_SORTIMENT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 91,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sortiment',
  p_source=>'SORTIMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT bezeichnung a, id b'||unistr('\000a')||
'from sortimente where id = :P321_SORTIMENT_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4315601784316115 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_ID_NEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'P321_ID_NEXT',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4315819034316115 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_ID_PREV',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P321_ID_PREV',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4337216453822987 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_WAEHRUNG_ZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'SELECT NVL(zeichen,code) '||unistr('\000a')||
'FROM waehrungen'||unistr('\000a')||
'where id = :P321_WAEHRUNG_ID',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4815923085655465 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_WK_VERSANDART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8543219803669887 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 321,
  p_name=>'P321_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 4305305677316068+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'GUS verwaltet ',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.holen_uebersetzung(76,357), 1 from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'select frgbg_s.holen_uebersetzung(77,357), 0 from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:WARENKOERBE:P321_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 4312026181316107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 321,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from WARENKOERBE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to fetch row.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKOERBE:ID::PLANDATUM:ID:P321_ID:P321_ID_NEXT:P321_ID_PREV:::::';

wwv_flow_api.create_page_process(
  p_id     => 4316225464316118 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 321,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'GET_NEXT_OR_PREV_PK',
  p_process_name=> 'Get Next or Previous Primary Key Value',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to run Get Next or Previous Primary Key Value process.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'      v_return := frgbg_s.MAIL_BESTELLUNG '||unistr('\000a')||
'                  (NULL     --P_USER_ACCOUNT'||unistr('\000a')||
'                  ,:FAS_LOGIN_PERSONENSTAMM_ID    --P_PERSSTAMM_ID Frau Siegwart als Zieladresse'||unistr('\000a')||
'                  ,:p321_id --P_WARENKORB_ID '||unistr('\000a')||
'                  ,:FAS_LOGIN_PERSONENSTAMM_ID     --P_PERSSTAMM_ID_MAILABSENDER '||unistr('\000a')||
'                  ,0        --P_FLAG IN NUMBER kei';

p:=p||'ne Reply-Adresse'||unistr('\000a')||
'                  ,0        --P_NOTFALL_EMAIL'||unistr('\000a')||
'                 );'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4519609723606030 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 321,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'email_bestellblatt',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BUT_EMAIL_BESTELLBLATT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_mutdat         varchar2(50);'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
''||unistr('\000a')||
'   v_count      number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/* Doku:'||unistr('\000a')||
'   apex_application.g_f21(v_count)        -- wk_id'||unistr('\000a')||
''||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :request = ''BUT_EINZELSTORNO'' THEN'||unistr('\000a')||
'      -- Details speichern'||unistr('\000a')||
'      for v_count in 1..apex_application.g_f01.count'||unistr('\000a')||
'   ';

p:=p||'   loop '||unistr('\000a')||
'/*MEL.P(''WK markiert f01 %1, ANZ: %2, WK: %3'',v_prot_id,''Info'',''102/320: upd_wk_status'',       apex_application.g_f01(v_count), apex_application.g_f01.count, :p321_id );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'            -- Speichern'||unistr('\000a')||
'            v_return := frgbg_s.WK_UPD_STATUS(NULL'||unistr('\000a')||
'                                          ,apex_application.g_f01(v_count)'||unistr('\000a')||
'                                          ,90'||unistr('\000a')||
'                 );'||unistr('\000a')||
'';

p:=p||'            IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                              apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'               RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'      end loop; '||unistr('\000a')||
'  /* ELSIF :request = ''BUT_KOMPLETTSTORNO'' THEN'||unistr('\000a')||
'      -- Speichern'||unistr('\000a')||
'      v_return := ';

p:=p||'frgbg_s.WK_UPD_STATUS(:p321_id'||unistr('\000a')||
'                                          ,NULL'||unistr('\000a')||
'                                          ,90'||unistr('\000a')||
'                 );'||unistr('\000a')||
'      IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                           apex_application.g_f01(v_count) '||unistr('\000a')||
'                          );'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
' ';

p:=p||'     END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4373211650342755 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 321,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'upd_wk_status',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BUT_EINZELSTORNO'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKOERBE:P321_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 4312229540316108 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 321,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of WARENKOERBE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process row of table WARENKOERBE.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> 'Action Processed.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'321';

wwv_flow_api.create_page_process(
  p_id     => 4312430251316108 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 321,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4305721391316069 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 321
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00322
prompt  ...PAGE 322: Laborauftragsuebersicht
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 322
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Laborauftragsuebersicht'
 ,p_step_title => 'Laborauftragsuebersicht'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Laborauftragsuebersicht'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150205105049'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'  wk.ID ,'||unistr('\000a')||
'  wk.PLANDATUM,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_kunde)||'', ''||wk.persstamm_id_kunde ADRESSE_KUNDE ,'||unistr('\000a')||
'  GESAMTPREIS ,'||unistr('\000a')||
'  (SELECT NVL(zeichen,code) FROM waehrungen where id = wk.WAEHRUNG_ID) WAEHRUNG,'||unistr('\000a')||
'  (SELECT iso3_id a FROM Laender WHERE id = wk.verrech_land_id) VERRECH_LAND'||unistr('\000a')||
'  ,fas_synch.get_tab_uebersetzung(''WARENKORB_STATUS.BEZEICHNUNG'','||unistr('\000a')||
'                                ';

s:=s||'       wk.wk_status_id,:fas_sprache_id) WK_STATUS,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_rechnung)||'', ''||wk.persstamm_id_rechnung ADRESSE_RECHNUNG ,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_lieferung)||'', ''||wk.persstamm_id_lieferung ADRESSE_LIEFERUNG,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_prod_apo)||'', ''||wk.persstamm_id_prod_apo ADRESSE_PROD_APO,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persst';

s:=s||'amm_id_identitaet)||'', ''||wk.persstamm_id_identitaet ADRESSE_IDENTITAET ,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_login)||'', ''||wk.persstamm_id_login ADRESSE_BETREUER'||unistr('\000a')||
'  ,CASE WHEN ((wk.wk_status_id in (5,7,50) AND wk.extern_verwaltet=0) -- FAS-Aufträge'||unistr('\000a')||
'        OR    (wk.wk_status_id = 5 AND wk.extern_verwaltet=1)         -- GUS-Aufträge'||unistr('\000a')||
'             )'||unistr('\000a')||
'        AND wk.error_flag is null     -- WK';

s:=s||' nicht wg. fehler ausgesteuert'||unistr('\000a')||
'        /* Eingefügt: mcg 29.08.2013'||unistr('\000a')||
'        and not exists (select 1 from warenkorb_details wkd where wkd.warenkorb_id = wk.id and wkd.labor_auftrag_id is not null)'||unistr('\000a')||
'    Ende eingefügt mcg */'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'        apex_item.checkbox(1,wk.ID,''UNCHECKED'')'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'        -- '' ''     NEI 09.10.13 vorübergehend zum Bearbeiten freigegeben, damit GUS-Aufträge auch im FAS abgeschl';

s:=s||'ossen werden können'||unistr('\000a')||
'        apex_item.checkbox(1,wk.ID,''UNCHECKED'')'||unistr('\000a')||
'   END row_selector,'||unistr('\000a')||
'   wk.erfdat,'||unistr('\000a')||
'   wk.extern_verwaltet,'||unistr('\000a')||
'   wk.GUS_KUNDENAUFTRAG_ID,'||unistr('\000a')||
'/*'||unistr('\000a')||
'   ,CASE WHEN wk.error_flag is null THEN -- kein Fehler'||unistr('\000a')||
'     to_char(wk.error_flag)'||unistr('\000a')||
'   WHEN wk.wk_status_id = 6 and wk.error_flag is not null THEN       -- Fehler mit Status 6 noch nicht an GUS'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f';

s:=s||'?p=''||:APP_ID||'':320:''||:APP_SESSION||'':WK_RESTART''||'':&DEBUG.::''||'||unistr('\000a')||
'     ''P322_WK_ID_RESTART:''||wk.ID)'||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndretur.gif" border="0">''  -- shopping_cart,white_branch, fndretur,processing,refresh,unlock_enabled'||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   WHEN wk.wk_status_id = 6.4 and wk.error_flag is not null THEN       -- Fehler mit Status 6.4 Adressprüfung kommt mit Fehler von GUS';

s:=s||''||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':320:''||:APP_SESSION||'':WK_RESTART_GUS''||'':&DEBUG.::''||'||unistr('\000a')||
'     ''P322_WK_ID_RESTART:''||wk.ID)'||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndretur.gif" border="0">''  -- shopping_cart,white_branch, fndretur,processing,refresh,unlock_enabled'||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   ELSE                              -- Fehler mit Status > 6 noch nicht an GUS'||unistr('\000a')||
' ';

s:=s||'    to_char(wk.error_flag)'||unistr('\000a')||
'   END    error_flag,'||unistr('\000a')||
'*/'||unistr('\000a')||
'   to_char(wk.error_flag) error_flag,'||unistr('\000a')||
'   error_text,'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''WK_VERSANDARTEN.BEZEICHNUNG'','||unistr('\000a')||
'                                   wk.WK_VERSANDART_ID,:fas_sprache_id) WK_VERSANDART,'||unistr('\000a')||
'   wkd_labor_auftrag_id labor_auftrag_id,'||unistr('\000a')||
'   CASE WHEN wk.erfdat > sysdate - 30 THEN'||unistr('\000a')||
'   CASE frgbg_t.LAB_GET_LABOR_STATUS (wkd_labor_auftrag_id';

s:=s||', wkd_labor_id)     -- Fremd-Laborabschluss?'||unistr('\000a')||
'   WHEN  0 THEN ''Labor offen'''||unistr('\000a')||
'   WHEN  1 THEN ''Laborabschluss'''||unistr('\000a')||
'   ELSE  ''unbekannter Fehler: ''|| frgbg_t.LAB_GET_LABOR_STATUS (wkd_labor_auftrag_id,wkd_labor_id)'||unistr('\000a')||
'   END'||unistr('\000a')||
'   ELSE ''Siehe Details'''||unistr('\000a')||
'   END labor_status,'||unistr('\000a')||
'   CASE WHEN wk.erfdat > sysdate - 30 THEN '||unistr('\000a')||
'    CASE frgbg_t.LAB_GET_FB_STATUS_WK(wk.id)         -- FB vollständig?'||unistr('\000a')||
'      WHEN 1 THEN  ''volls';

s:=s||'tändig'''||unistr('\000a')||
'      WHEN 0 THEN  ''unvollständig'''||unistr('\000a')||
'      WHEN 0.1 THEN ''unvollständig'''||unistr('\000a')||
'      WHEN 2 THEN ''vollständig'''||unistr('\000a')||
'      WHEN -1 THEN ''Auftrag-/Labor-ID fehlt'''||unistr('\000a')||
'      WHEN -2 THEN ''Übernahme fehlerhaft'''||unistr('\000a')||
'      ELSE ''unbekannter Fehler: ''||frgbg_t.LAB_GET_FB_STATUS_WK(wk.id) '||unistr('\000a')||
'    END '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      ''Siehe Auftragdetails'''||unistr('\000a')||
'   END fb_status,'||unistr('\000a')||
'   CASE WHEN wk.erfdat > sysdate - 30 AND WKD_PERGEBNIS_ID is not ';

s:=s||'null THEN'||unistr('\000a')||
'     CASE frgbg_s.FB_CHECK_AUSWERTUNG(WKD_PERGEBNIS_ID)'||unistr('\000a')||
'      WHEN 0 THEN ''nicht ausgewertet'''||unistr('\000a')||
'      WHEN 1 THEN ''ausgewertet'''||unistr('\000a')||
'      ELSE ''unbekannter Fehler: ''||frgbg_s.FB_CHECK_AUSWERTUNG(WKD_PERGEBNIS_ID)'||unistr('\000a')||
'     END'||unistr('\000a')||
'   WHEN WKD_PERGEBNIS_ID is null then'||unistr('\000a')||
'     ''ohne Fragebogen '''||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'     ''Siehe Details'''||unistr('\000a')||
'   END fb_auswertung /**/'||unistr('\000a')||
''||unistr('\000a')||
'from warenkoerbe wk, ('||unistr('\000a')||
'  select distinct -- SAL 12.08.14';

s:=s||' Distinct in eine Unterabfrage, da die Abfrage sonst zu lange dauert wegen den vielen Feldern'||unistr('\000a')||
'        wk.ID wk_id,'||unistr('\000a')||
'        wkd.labor_auftrag_id wkd_labor_auftrag_id,'||unistr('\000a')||
'        wkd.labor_id  wkd_labor_id,'||unistr('\000a')||
'        WKD.PERGEBNIS_id  WKD_PERGEBNIS_id'||unistr('\000a')||
'  from warenkoerbe wk, warenkorb_details wkd'||unistr('\000a')||
'  where  -- Bestellungen nur für Default Produzierende Apotheke des Betreuers'||unistr('\000a')||
'       -- wk.PERSSTAMM_ID_PROD_A';

s:=s||'PO = :p322_persstamm_id_prod_apo AND   -- NEI 21.10.13 nicht mehr einschränken, sonst sieht man ext. Prod.Apo bei Laboraufträge nicht mehr'||unistr('\000a')||
'        (:p322_nur_offene_WK = 1 AND wk.wk_status_id < 60'||unistr('\000a')||
'         OR'||unistr('\000a')||
'         :p322_nur_offene_wk = 0'||unistr('\000a')||
'        )'||unistr('\000a')||
'    and (:P322_PERSSTAMM_ID_IDENTITAET=0 OR'||unistr('\000a')||
'         wk.PERSSTAMM_ID_IDENTITAET = :P322_PERSSTAMM_ID_IDENTITAET'||unistr('\000a')||
'        )'||unistr('\000a')||
''||unistr('\000a')||
'    -- Join WK-WKD'||unistr('\000a')||
'    AN';

s:=s||'D wkd.warenkorb_id = wk.id'||unistr('\000a')||
'    AND wkd.labor_auftrag_id is not null'||unistr('\000a')||
') d'||unistr('\000a')||
'where'||unistr('\000a')||
'  wk.ID = d.wk_id';

wwv_flow_api.create_page_plug (
  p_id=> 5143603578959477 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_plug_name=> 'Warenkörbe',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow: auto; height: &P322_HEIGHT_WKLISTE.px;">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'select'||unistr('\000a')||
'  wk.ID ,'||unistr('\000a')||
'  wk.PLANDATUM,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_kunde)||'', ''||wk.persstamm_id_kunde ADRESSE_KUNDE ,'||unistr('\000a')||
'  GESAMTPREIS ,'||unistr('\000a')||
'  (SELECT NVL(zeichen,code) FROM waehrungen where id = wk.WAEHRUNG_ID) WAEHRUNG,'||unistr('\000a')||
'  (SELECT iso3_id a FROM Laender WHERE id = wk.verrech_land_id) VERRECH_LAND'||unistr('\000a')||
'  ,fas_synch.get_tab_uebersetzung(''WARENKORB_STATUS.BEZEICHNUNG'','||unistr('\000a')||
'                                ';

a1:=a1||'       wk.wk_status_id,:fas_sprache_id) WK_STATUS,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_rechnung)||'', ''||wk.persstamm_id_rechnung ADRESSE_RECHNUNG ,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_lieferung)||'', ''||wk.persstamm_id_lieferung ADRESSE_LIEFERUNG,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_prod_apo)||'', ''||wk.persstamm_id_prod_apo ADRESSE_PROD_APO,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persst';

a1:=a1||'amm_id_identitaet)||'', ''||wk.persstamm_id_identitaet ADRESSE_IDENTITAET ,'||unistr('\000a')||
'  frgbg_s.get_pers_adresse(wk.persstamm_id_login)||'', ''||wk.persstamm_id_login ADRESSE_BETREUER'||unistr('\000a')||
'  ,CASE WHEN ((wk.wk_status_id in (5,7,50) AND wk.extern_verwaltet=0) -- FAS-Aufträge'||unistr('\000a')||
'        OR    (wk.wk_status_id = 5 AND wk.extern_verwaltet=1)         -- GUS-Aufträge'||unistr('\000a')||
'             )'||unistr('\000a')||
'        AND wk.error_flag is null     -- WK';

a1:=a1||' nicht wg. fehler ausgesteuert'||unistr('\000a')||
'        /* Eingefügt: mcg 29.08.2013'||unistr('\000a')||
'        and not exists (select 1 from warenkorb_details wkd where wkd.warenkorb_id = wk.id and wkd.labor_auftrag_id is not null)'||unistr('\000a')||
'    Ende eingefügt mcg */'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'        apex_item.checkbox(1,wk.ID,''UNCHECKED'')'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'        -- '' ''     NEI 09.10.13 vorübergehend zum Bearbeiten freigegeben, damit GUS-Aufträge auch im FAS abgeschl';

a1:=a1||'ossen werden können'||unistr('\000a')||
'        apex_item.checkbox(1,wk.ID,''UNCHECKED'')'||unistr('\000a')||
'   END row_selector,'||unistr('\000a')||
'   wk.erfdat,'||unistr('\000a')||
'   wk.extern_verwaltet,'||unistr('\000a')||
'   wk.GUS_KUNDENAUFTRAG_ID,'||unistr('\000a')||
'/*'||unistr('\000a')||
'   ,CASE WHEN wk.error_flag is null THEN -- kein Fehler'||unistr('\000a')||
'     to_char(wk.error_flag)'||unistr('\000a')||
'   WHEN wk.wk_status_id = 6 and wk.error_flag is not null THEN       -- Fehler mit Status 6 noch nicht an GUS'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f';

a1:=a1||'?p=''||:APP_ID||'':320:''||:APP_SESSION||'':WK_RESTART''||'':&DEBUG.::''||'||unistr('\000a')||
'     ''P322_WK_ID_RESTART:''||wk.ID)'||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndretur.gif" border="0">''  -- shopping_cart,white_branch, fndretur,processing,refresh,unlock_enabled'||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   WHEN wk.wk_status_id = 6.4 and wk.error_flag is not null THEN       -- Fehler mit Status 6.4 Adressprüfung kommt mit Fehler von GUS';

a1:=a1||''||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'     ''f?p=''||:APP_ID||'':320:''||:APP_SESSION||'':WK_RESTART_GUS''||'':&DEBUG.::''||'||unistr('\000a')||
'     ''P322_WK_ID_RESTART:''||wk.ID)'||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#fndretur.gif" border="0">''  -- shopping_cart,white_branch, fndretur,processing,refresh,unlock_enabled'||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   ELSE                              -- Fehler mit Status > 6 noch nicht an GUS'||unistr('\000a')||
' ';

a1:=a1||'    to_char(wk.error_flag)'||unistr('\000a')||
'   END    error_flag,'||unistr('\000a')||
'*/'||unistr('\000a')||
'   to_char(wk.error_flag) error_flag,'||unistr('\000a')||
'   error_text,'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''WK_VERSANDARTEN.BEZEICHNUNG'','||unistr('\000a')||
'                                   wk.WK_VERSANDART_ID,:fas_sprache_id) WK_VERSANDART,'||unistr('\000a')||
'   wkd_labor_auftrag_id labor_auftrag_id,'||unistr('\000a')||
'   CASE WHEN wk.erfdat > sysdate - 30 THEN'||unistr('\000a')||
'   CASE frgbg_t.LAB_GET_LABOR_STATUS (wkd_labor_auftrag_id';

a1:=a1||', wkd_labor_id)     -- Fremd-Laborabschluss?'||unistr('\000a')||
'   WHEN  0 THEN ''Labor offen'''||unistr('\000a')||
'   WHEN  1 THEN ''Laborabschluss'''||unistr('\000a')||
'   ELSE  ''unbekannter Fehler: ''|| frgbg_t.LAB_GET_LABOR_STATUS (wkd_labor_auftrag_id,wkd_labor_id)'||unistr('\000a')||
'   END'||unistr('\000a')||
'   ELSE ''Siehe Details'''||unistr('\000a')||
'   END labor_status,'||unistr('\000a')||
'   CASE WHEN wk.erfdat > sysdate - 30 THEN '||unistr('\000a')||
'    CASE frgbg_t.LAB_GET_FB_STATUS_WK(wk.id)         -- FB vollständig?'||unistr('\000a')||
'      WHEN 1 THEN  ''volls';

a1:=a1||'tändig'''||unistr('\000a')||
'      WHEN 0 THEN  ''unvollständig'''||unistr('\000a')||
'      WHEN 0.1 THEN ''unvollständig'''||unistr('\000a')||
'      WHEN 2 THEN ''vollständig'''||unistr('\000a')||
'      WHEN -1 THEN ''Auftrag-/Labor-ID fehlt'''||unistr('\000a')||
'      WHEN -2 THEN ''Übernahme fehlerhaft'''||unistr('\000a')||
'      ELSE ''unbekannter Fehler: ''||frgbg_t.LAB_GET_FB_STATUS_WK(wk.id) '||unistr('\000a')||
'    END '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      ''Siehe Auftragdetails'''||unistr('\000a')||
'   END fb_status,'||unistr('\000a')||
'   CASE WHEN wk.erfdat > sysdate - 30 AND WKD_PERGEBNIS_ID is not ';

a1:=a1||'null THEN'||unistr('\000a')||
'     CASE frgbg_s.FB_CHECK_AUSWERTUNG(WKD_PERGEBNIS_ID)'||unistr('\000a')||
'      WHEN 0 THEN ''nicht ausgewertet'''||unistr('\000a')||
'      WHEN 1 THEN ''ausgewertet'''||unistr('\000a')||
'      ELSE ''unbekannter Fehler: ''||frgbg_s.FB_CHECK_AUSWERTUNG(WKD_PERGEBNIS_ID)'||unistr('\000a')||
'     END'||unistr('\000a')||
'   WHEN WKD_PERGEBNIS_ID is null then'||unistr('\000a')||
'     ''ohne Fragebogen '''||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'     ''Siehe Details'''||unistr('\000a')||
'   END fb_auswertung /**/'||unistr('\000a')||
''||unistr('\000a')||
'from warenkoerbe wk, ('||unistr('\000a')||
'  select distinct -- SAL 12.08.14';

a1:=a1||' Distinct in eine Unterabfrage, da die Abfrage sonst zu lange dauert wegen den vielen Feldern'||unistr('\000a')||
'        wk.ID wk_id,'||unistr('\000a')||
'        wkd.labor_auftrag_id wkd_labor_auftrag_id,'||unistr('\000a')||
'        wkd.labor_id  wkd_labor_id,'||unistr('\000a')||
'        WKD.PERGEBNIS_id  WKD_PERGEBNIS_id'||unistr('\000a')||
'  from warenkoerbe wk, warenkorb_details wkd'||unistr('\000a')||
'  where  -- Bestellungen nur für Default Produzierende Apotheke des Betreuers'||unistr('\000a')||
'       -- wk.PERSSTAMM_ID_PROD_A';

a1:=a1||'PO = :p322_persstamm_id_prod_apo AND   -- NEI 21.10.13 nicht mehr einschränken, sonst sieht man ext. Prod.Apo bei Laboraufträge nicht mehr'||unistr('\000a')||
'        (:p322_nur_offene_WK = 1 AND wk.wk_status_id < 60'||unistr('\000a')||
'         OR'||unistr('\000a')||
'         :p322_nur_offene_wk = 0'||unistr('\000a')||
'        )'||unistr('\000a')||
'    and (:P322_PERSSTAMM_ID_IDENTITAET=0 OR'||unistr('\000a')||
'         wk.PERSSTAMM_ID_IDENTITAET = :P322_PERSSTAMM_ID_IDENTITAET'||unistr('\000a')||
'        )'||unistr('\000a')||
''||unistr('\000a')||
'    -- Join WK-WKD'||unistr('\000a')||
'    AN';

a1:=a1||'D wkd.warenkorb_id = wk.id'||unistr('\000a')||
'    AND wkd.labor_auftrag_id is not null'||unistr('\000a')||
') d'||unistr('\000a')||
'where'||unistr('\000a')||
'  wk.ID = d.wk_id';

wwv_flow_api.create_worksheet(
  p_id=> 5143800403959482+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_region_id=> 5143603578959477+wwv_flow_api.g_id_offset,
  p_name=> 'warenkoerbe',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '10000',
  p_max_row_count_message=> 'Die Anfrage umfasst mehr als #MAX_ROW_COUNT# Datensätze. Bitte schränken Sie ihre Anfrage ein, um ein vollständiges Ergebnis sicherzustellen!',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'Y',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y_OF_Z',
  p_pagination_display_pos=>'TOP_AND_BOTTOM_RIGHT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'C',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'Y',
  p_show_highlight=>'Y',
  p_show_computation=>'Y',
  p_show_aggregate=>'Y',
  p_show_chart=>'Y',
  p_show_group_by=>'Y',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'Y',
  p_show_reset=>'Y',
  p_show_download=>'Y',
  p_show_help=>'Y',
  p_download_formats=>'CSV:HTML:EMAIL',
  p_detail_link=>'f?p=&APP_ID.:323:&SESSION.::&DEBUG.:323:P323_ID:#ID#',
  p_detail_link_text=>'<img src="#IMAGE_PREFIX#edit_big.gif" alt="">',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'BRIGITTE.NEIDHART',
  p_internal_uid=> 1);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144725947959497+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ROW_SELECTOR',
  p_display_order          =>1,
  p_column_identifier      =>'AH',
  p_column_label           =>'<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />',
  p_report_label           =>'<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5143927791959491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID',
  p_display_order          =>2,
  p_column_identifier      =>'A',
  p_column_label           =>'WK-ID',
  p_report_label           =>'WK-ID',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5145407276959498+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'PLANDATUM',
  p_display_order          =>3,
  p_column_identifier      =>'B',
  p_column_label           =>'Plandatum',
  p_report_label           =>'Plandatum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5145509189959498+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'GESAMTPREIS',
  p_display_order          =>4,
  p_column_identifier      =>'E',
  p_column_label           =>'Gesamtpreis',
  p_report_label           =>'Gesamtpreis',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_format_mask            =>'999G999G999G999G990D00',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5145619487959498+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'VERRECH_LAND',
  p_display_order          =>5,
  p_column_identifier      =>'Y',
  p_column_label           =>'Verrech Land',
  p_report_label           =>'Verrech Land',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5145725394959498+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WAEHRUNG',
  p_display_order          =>6,
  p_column_identifier      =>'Z',
  p_column_label           =>'Währung',
  p_report_label           =>'Währung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'CENTER',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144011099959495+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_KUNDE',
  p_display_order          =>7,
  p_column_identifier      =>'AA',
  p_column_label           =>'Kunde',
  p_report_label           =>'Kunde',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144103489959495+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_RECHNUNG',
  p_display_order          =>8,
  p_column_identifier      =>'AB',
  p_column_label           =>'Rechnung',
  p_report_label           =>'Rechnung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144212777959495+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_LIEFERUNG',
  p_display_order          =>9,
  p_column_identifier      =>'AC',
  p_column_label           =>'Lieferung',
  p_report_label           =>'Lieferung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144301865959496+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_PROD_APO',
  p_display_order          =>10,
  p_column_identifier      =>'AD',
  p_column_label           =>'Prod Apo',
  p_report_label           =>'Prod Apo',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'HIDDEN',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144418131959496+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_IDENTITAET',
  p_display_order          =>11,
  p_column_identifier      =>'AE',
  p_column_label           =>'Identität',
  p_report_label           =>'Identität',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144526356959496+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ADRESSE_BETREUER',
  p_display_order          =>12,
  p_column_identifier      =>'AF',
  p_column_label           =>'Betreuer',
  p_report_label           =>'Betreuer',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144603057959496+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WK_STATUS',
  p_display_order          =>13,
  p_column_identifier      =>'AG',
  p_column_label           =>'Status',
  p_report_label           =>'Status',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144832647959497+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERFDAT',
  p_display_order          =>14,
  p_column_identifier      =>'AI',
  p_column_label           =>'Datum',
  p_report_label           =>'Datum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_format_mask            =>'DD.MM.YY/HH24:MI',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5144902536959497+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EXTERN_VERWALTET',
  p_display_order          =>15,
  p_column_identifier      =>'AJ',
  p_column_label           =>'GUS verwalt',
  p_report_label           =>'GUS verwalt',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5145026836959497+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'GUS_KUNDENAUFTRAG_ID',
  p_display_order          =>16,
  p_column_identifier      =>'AK',
  p_column_label           =>'Gus-Id',
  p_report_label           =>'Gus-Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5145110501959497+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERROR_TEXT',
  p_display_order          =>18,
  p_column_identifier      =>'AM',
  p_column_label           =>'Error Text',
  p_report_label           =>'Error Text',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5145205334959498+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERROR_FLAG',
  p_display_order          =>19,
  p_column_identifier      =>'AN',
  p_column_label           =>'Error Flag',
  p_report_label           =>'Error Flag',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5145305393959498+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WK_VERSANDART',
  p_display_order          =>20,
  p_column_identifier      =>'AO',
  p_column_label           =>'Wk Versandart',
  p_report_label           =>'Wk Versandart',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5150222679065287+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'LABOR_AUFTRAG_ID',
  p_display_order          =>21,
  p_column_identifier      =>'AP',
  p_column_label           =>'LA-ID',
  p_report_label           =>'LA-ID',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5495927257729204+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'LABOR_STATUS',
  p_display_order          =>24,
  p_column_identifier      =>'AS',
  p_column_label           =>'Labor Status',
  p_report_label           =>'Labor Status',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5628522267574178+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'FB_AUSWERTUNG',
  p_display_order          =>25,
  p_column_identifier      =>'AT',
  p_column_label           =>'FB Auswertung',
  p_report_label           =>'FB Auswertung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6426708600015491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'FB_STATUS',
  p_display_order          =>26,
  p_column_identifier      =>'AU',
  p_column_label           =>'Fb Status',
  p_report_label           =>'Fb Status',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'ROW_SELECTOR:ID:PLANDATUM:ADRESSE_KUNDE:GESAMTPREIS:WAEHRUNG:WK_STATUS:ADRESSE_IDENTITAET:ERROR_FLAG:WK_VERSANDART:LABOR_AUFTRAG_ID:FB_STATUS:LABOR_STATUS:FB_AUSWERTUNG:';

wwv_flow_api.create_worksheet_rpt(
  p_id => 5145827447959499+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_worksheet_id => 5143800403959482+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'51459',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>100,
  p_report_columns          =>rc1,
  p_sort_column_1           =>'PLANDATUM',
  p_sort_direction_1        =>'DESC',
  p_sort_column_2           =>'WK_STATUS',
  p_sort_direction_2        =>'DESC',
  p_sort_column_3           =>'ID',
  p_sort_direction_3        =>'DESC',
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5559908977512087 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10256122768924536 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 322,
  p_plug_name=> 'Schnellverweis',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 5,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5146003107959501 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 322,
  p_button_sequence=> 15,
  p_button_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_ANGEFORDERT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Markierte Vorkasse angefordert',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5146223266959504 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 322,
  p_button_sequence=> 40,
  p_button_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_BEZAHLT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Markierte freigeben',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5146402820959504 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 322,
  p_button_sequence=> 50,
  p_button_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_AUSGELIEFERT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Markierte ausgeliefert',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5146610140959504 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 322,
  p_button_sequence=> 10,
  p_button_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5276815595328998 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 322,
  p_button_sequence=> 25,
  p_button_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_DATENBLATT_DRUCK',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Datenblatt drucken',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'N',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5493514266987374 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 322,
  p_button_sequence=> 60,
  p_button_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_LABORUEBERNAHME',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Laborübernahme',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5149730293959525 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P322_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:322::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5146610140959504+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 110,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5146820958959506 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_name=>'P322_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prod. Apotheke',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.get_pers_name(:P322_PERSSTAMM_ID_PROD_APO)||'', ''||:P322_PERSSTAMM_ID_PROD_APO a, :P322_PERSSTAMM_ID_PROD_APO b'||unistr('\000a')||
'from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5147032282959510 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_name=>'P322_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '130',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5147215687959510 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_name=>'P322_NUR_OFFENE_WK',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 15,
  p_item_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT ''Nur offene Aufträge'' a, 1 b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''Alle Aufträge'' a, 0 b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 2,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '1',
  p_attribute_02 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5147421090959511 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_name=>'P322_MARKIERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Markieren',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5147608407959512 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_name=>'P322_HEIGHT_WKLISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5147815066959512 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_name=>'P322_PERSSTAMM_ID_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identität',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(511,:fas_sprache_id) a, 0 b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION '||unistr('\000a')||
'/*'||unistr('\000a')||
'select distinct substr(p.name,1,30)||'', ''||substr(p.ort,1,30)||'', ''||p.id, wk.persstamm_id_identitaet'||unistr('\000a')||
'from warenkoerbe wk, warenkorb_details wkd,personenstamm p'||unistr('\000a')||
'where wkd.warenkorb_id = wk.id'||unistr('\000a')||
'  /* Bestellungen nur für Default Produzierende Apotheke des Betreuers * /'||unistr('\000a')||
'  and (wk.PERSSTAMM_ID_PROD_APO = :p322_persstamm_id_prod_apo'||unistr('\000a')||
'       or'||unistr('\000a')||
'       wk.PERSSTAMM_ID_PROD_APO is null'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and wk.PERSSTAMM_ID_IDENTITAET = p.id'||unistr('\000a')||
'*/'||unistr('\000a')||
'select frgbg_s.get_pers_name(:FAS_IDENTITAET_PERSSTAMM_ID)||'', ''||:FAS_IDENTITAET_PERSSTAMM_ID, to_number(:FAS_IDENTITAET_PERSSTAMM_ID) '||unistr('\000a')||
'from dual'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5148011527959513 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_name=>'P322_WK_ID_RESTART',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5494514229034674 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_name=>'P322_LABOR_UEBERNAHME_FEHLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5143603578959477+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10256320824924537 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 322,
  p_name=>'P322_QUICKMENU',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 10256122768924536+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Schnellverweis:',
  p_source=>'select'||unistr('\000a')||
''||unistr('\000a')||
' listagg(''<a href="javascript:redirect('''''' ||'||unistr('\000a')||
'    frgbg_t.PREPARE_URL(URL) || '''''');">'' || BEZEICHNUNG || ''</a>'','' | '')'||unistr('\000a')||
'    within group (order by SORTIERUNG)'||unistr('\000a')||
' from FAS_APP_MENUS'||unistr('\000a')||
'where'||unistr('\000a')||
'  FAS_APP_MENU_ID in(select FAS_APP_MENU_ID from FAS_APP_MENUS where app_id = :APP_ID and page_id = :APP_PAGE_ID)',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_mutdat         varchar2(50);'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
''||unistr('\000a')||
'   v_extern_verwaltet number;'||unistr('\000a')||
'   v_wk_status_id   number;'||unistr('\000a')||
'   v_wk_status_id_db number;'||unistr('\000a')||
'   v_ohne_prodauftrag   number;   -- NEI 07.08.13 Laboraufträge ohne Dispo'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/* Doku:'||unistr('\000a')||
'   apex_application.g_f01(v_count)       ';

p:=p||' -- wk_id'||unistr('\000a')||
'*/'||unistr('\000a')||
'/* NEI 12.12.12 GUS Bestellintegration'||unistr('\000a')||
'   IF :request = ''BUT_AUSGELIEFERT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 60;'||unistr('\000a')||
'   ELSIF :request = ''BUT_BEZAHLT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 10;'||unistr('\000a')||
'   ELSIF :request = ''BUT_ANGEFORDERT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 7;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'   IF :request = ''BUT_AUSGELIEFERT'' THEN'||unistr('\000a')||
'      v_wk_status_id := 60;'||unistr('\000a')||
'   ELSIF :request = ''BUT_BEZAHLT'' TH';

p:=p||'EN'||unistr('\000a')||
'      v_wk_status_id := 10;'||unistr('\000a')||
'   ELSIF :request = ''BUT_ANGEFORDERT'' THEN -- Vorkasse angefordert'||unistr('\000a')||
'      v_wk_status_id := 6;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- WK speichern'||unistr('\000a')||
'   for v_count in 1..apex_application.g_f01.count'||unistr('\000a')||
'   loop '||unistr('\000a')||
'      SELECT wk_status_id, extern_verwaltet'||unistr('\000a')||
'      INTO v_wk_status_id_db, v_extern_verwaltet '||unistr('\000a')||
'      FROM warenkoerbe '||unistr('\000a')||
'      WHERE id = apex_application.g_f01(v_cou';

p:=p||'nt); '||unistr('\000a')||
'      '||unistr('\000a')||
'/*MEL.P(''WK markiert f01 %1, ANZ: %2, Status: %3, db:%4 , extern_verwaltet:%5'','||unistr('\000a')||
'           v_prot_id,'||unistr('\000a')||
'           ''Info'','||unistr('\000a')||
'           ''102/322: upd_wk_status'','||unistr('\000a')||
'           apex_application.g_f01(v_count),'||unistr('\000a')||
'           apex_application.g_f01.count,'||unistr('\000a')||
'           v_wk_status_id,'||unistr('\000a')||
'           v_wk_status_id_db,v_extern_verwaltet'||unistr('\000a')||
'        );'||unistr('\000a')||
'*/       '||unistr('\000a')||
'      IF v_extern_verwaltet = 0 THEN -- FAS-Auft';

p:=p||'rag'||unistr('\000a')||
'         IF :request = ''BUT_BEZAHLT'' THEN  -- Vorkasse bezahlt                     -- NEI 07.08.13'||unistr('\000a')||
'            v_ohne_prodauftrag :=   -- NEI 07.08.13 Laborauftraege werden ohne Prodaufträge gemacht'||unistr('\000a')||
'               frgbg_s.WK_CHECK_OHNE_PRODAUFTRAG(apex_application.g_f01(v_count)); -- NEI 07.08.13'||unistr('\000a')||
'            IF v_ohne_prodauftrag = 1 THEN                                         -- NEI 07.08.13';

p:=p||''||unistr('\000a')||
'               v_wk_status_id := 50; --  zur Auslieferung bereit => keine Auftragsdispo nötig   '||unistr('\000a')||
'            ELSIF v_ohne_prodauftrag  < 0 THEN  -- Fehler'||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                              apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'               RAISE_APPLICATION_ERROR (-20004,v_fehlertext );'||unistr('\000a')||
'         ';

p:=p||'   END IF;                                                                -- NEI 07.08.13'||unistr('\000a')||
'         END IF;                                                                   -- NEI 07.08.13'||unistr('\000a')||
'         IF v_wk_status_id_db < v_wk_status_id THEN'||unistr('\000a')||
'            IF v_wk_status_id = 6 THEN -- Vorkasse manuell angefordert => WK aktivieren'||unistr('\000a')||
'               v_return := frgbg_s.WK_aktivieren(apex_application.g_f01';

p:=p||'(v_count));'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               -- Speichern'||unistr('\000a')||
'               v_return := frgbg_s.WK_UPD_STATUS(apex_application.g_f01(v_count)'||unistr('\000a')||
'                                          ,NULL'||unistr('\000a')||
'                                          ,v_WK_STATUS_ID'||unistr('\000a')||
'                 );'||unistr('\000a')||
'               IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'                  v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'          ';

p:=p||'                    apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'                  RAISE_APPLICATION_ERROR (-20005,v_fehlertext );'||unistr('\000a')||
'               END IF;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                               apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'            RAISE_APPL';

p:=p||'ICATION_ERROR (-20010,v_fehlertext );'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSIF v_extern_verwaltet = 1 THEN -- GUS-Auftrag'||unistr('\000a')||
'         IF v_wk_status_id_db < v_wk_status_id THEN'||unistr('\000a')||
'            IF v_wk_status_id = 6 THEN -- Vorkasse manuell angefordert => WK aktivieren'||unistr('\000a')||
'               v_return := frgbg_s.WK_aktivieren(apex_application.g_f01(v_count));'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               /* NEI 14.10.13 Übergangsweise zuge';

p:=p||'lassen, um die alten GUS-Aufträge abzuschliessen'||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                               apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'               RAISE_APPLICATION_ERROR (-20015,v_fehlertext );'||unistr('\000a')||
'               */'||unistr('\000a')||
'               -- NEI 14.10.13 Start  Ausnahme'||unistr('\000a')||
'               IF v_wk_status_id = 60 THEN'||unistr('\000a')||
'       ';

p:=p||'           v_return := frgbg_s.WK_UPD_STATUS(apex_application.g_f01(v_count)'||unistr('\000a')||
'                                          ,NULL'||unistr('\000a')||
'                                          ,v_WK_STATUS_ID'||unistr('\000a')||
'                    );'||unistr('\000a')||
'                  IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'                     v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                              apex_application.g_f01(v_count) ';

p:=p||''||unistr('\000a')||
'                             );'||unistr('\000a')||
'                     RAISE_APPLICATION_ERROR (-20005,v_fehlertext );'||unistr('\000a')||
'                  END IF;'||unistr('\000a')||
'               ELSE'||unistr('\000a')||
'                  v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                                  apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'                  RAISE_APPLICATION_ERROR (-20015,v_fehlertext );'||unistr('\000a')||
'       ';

p:=p||'        END IF;'||unistr('\000a')||
'               -- NEI 14.10.13 Ende'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                               apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20020,v_fehlertext );'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(5035';

p:=p||',v_sprache_id,'||unistr('\000a')||
'                               apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20025,v_fehlertext );'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   end loop;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5149022461959522 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 322,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'upd_wk_status',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BUT_AUSGELIEFERT'' ) /*,''BUT_BEZAHLT'',''BUT_ANGEFORDERT'')*/',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_return := frgbg_t.LAB_LABORDATEN_UEBERNEHMEN;'||unistr('\000a')||
'   IF v_return = 0 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Laborübernahme mit Fehler beendet!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5493703662993825 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 322,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'start_laboruebernahme',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>5493514266987374 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'reset_pagination';

wwv_flow_api.create_page_process(
  p_id     => 5148601062959519 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 322,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'RESET_PAGINATION',
  p_process_name=> 'Reset Pagination',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'''WK_RESTART''',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
''||unistr('\000a')||
'  FRGBG_T.A102_P322_DATENBLATTDRUCK('||unistr('\000a')||
'        p_warenkorb_ids => apex_application.g_f01'||unistr('\000a')||
'  );'||unistr('\000a')||
''||unistr('\000a')||
'  -- Damit Apex nicht die Oberfläche darstellt'||unistr('\000a')||
'  apex_application.g_unrecoverable_error := true;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5277531637541709 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 322,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Datenblattdruck',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'BUT_DATENBLATT_DRUCK',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p322_persstamm_id_prod_apo := '||unistr('\000a')||
'              frgbg_s.get_pers_option(NULL, '||unistr('\000a')||
'                       21, frgbg_s.GET_IDENTITAET_BETR(:fas_login_personenstamm_id),'||unistr('\000a')||
'                       :fas_login_personenstamm_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5149204984959523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 322,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_prod_apo',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Komplette Höhe ausnutzen (100% des Maximums)'||unistr('\000a')||
'   :P322_HEIGHT_WKliste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5149416916959523 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 322,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_anz number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT count(*) INTO v_anz'||unistr('\000a')||
'   FROM LABOR_ANALYSEWERTE'||unistr('\000a')||
'   WHERE at_bearb_status in (90,91);'||unistr('\000a')||
'   IF v_anz > 0 THEN'||unistr('\000a')||
'      :P322_LABOR_UEBERNAHME_FEHLER := ''Achtung! Es gibt noch Fehler in der Laborübertragung.'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :P322_LABOR_UEBERNAHME_FEHLER := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5494813321043929 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 322,
  p_process_sequence=> 25,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_laboruebernahme_fehler',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'    v_return     NUMBER;'||unistr('\000a')||
'    v_wk_id      number;'||unistr('\000a')||
'    v_prot_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_wk_id := :P322_WK_id_restart;'||unistr('\000a')||
'   :P322_WK_id_restart := NULL;'||unistr('\000a')||
'   IF :request = ''WK_RESTART'' THEN'||unistr('\000a')||
'      v_return := frgbg_s.wk_aktivieren(v_WK_id);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         --''Fehler beim Aktivieren der Bestellung! WK-ID:''||v_WK_id;'||unistr('\000a')||
'                '||unistr('\000a')||
'--mel.p(''In fehlerausgabe WK:''||v_WK_id,v_prot';

p:=p||'_id,''INFO'',''p322/fehlerausgabe'');'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         htp.p(''alert("''||frgbg_s.holen_uebersetzung(4387,:fas_sprache_id)||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''</body>'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSIF :request = ''WK_RESTART_GUS'' THEN'||unistr('\000a')||
'      v_return := frgbg_at.GUS_KDAUFTRAG_REAKTIVIEREN(v_WK_id);'||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
' ';

p:=p||'        --''Fehler beim Aktivieren der GUS-Bestellung! WK-ID:''||v_WK_id;'||unistr('\000a')||
'                '||unistr('\000a')||
'--mel.p(''In fehlerausgabe WK:''||v_WK_id,v_prot_id,''INFO'',''p322/fehlerausgabe'');'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         htp.p(''alert("''||frgbg_s.holen_uebersetzung(4387,:fas_sprache_id)||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''</body>'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'';

p:=p||'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5148828208959521 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 322,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'wk_restart',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request like ''WK_RESTART%'' and :P322_WK_id_restart is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 322
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00323
prompt  ...PAGE 323: WK-Labordetails
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 323
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'WK-Labordetails'
 ,p_step_title => 'WK-Labordetails'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'WK-Labordetails'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141104150022'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5229400300946001 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 323,
  p_plug_name=> 'Warenkorb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT '||unistr('\000a')||
'   wkd."ID" "ID", '||unistr('\000a')||
'   wkd."WARENKORB_ID" "WARENKORB_ID", '||unistr('\000a')||
'   wkd."PRODKENNZ_ID" "PRODKENNZ_ID", '||unistr('\000a')||
'   wkd."P_REZEPT_ID" "P_REZEPT_ID",'||unistr('\000a')||
'   case when mnr.rezept_nr is not null THEN'||unistr('\000a')||
'        mnr.rezept_nr                            '||unistr('\000a')||
'       ||''/'' ||mnr.version'||unistr('\000a')||
'       --||'', ''||mnr.Bezeichnung'||unistr('\000a')||
'   else '''''||unistr('\000a')||
'   end rezept_bez,'||unistr('\000a')||
'   mnr.rezept_nr rezept_nr,'||unistr('\000a')||
'   mnr.version  version, '||unistr('\000a')||
'   wkd."MENGENART_ID"';

s:=s||' "MENGENART_ID", '||unistr('\000a')||
'/*'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',wkd.MENGENART_ID,'||unistr('\000a')||
'                                  :fas_sprache_id)   || ''</br>'' '||unistr('\000a')||
'   ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       wkd.MENGENART_ID,:fas_sprache_id)'||unistr('\000a')||
'             mengenart_bez,'||unistr('\000a')||
'*/'||unistr('\000a')||
'  CASE WHEN wkd.PRODKENNZ_ID = 1 THEN '||unistr('\000a')||
'      frgbg_at.GUS_KDAP_GET_GUSARTIK';

s:=s||'EL (wkd.id)|| ''</br>''|| '||unistr('\000a')||
'      frgbg_s.get_pers_name_rezept(wkd.p_rezept_id)'||unistr('\000a')||
'  ELSE '||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',wkd.MENGENART_ID,:fas_sprache_id)|| ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                      wkd.MENGENART_ID,:fas_sprache_id)'||unistr('\000a')||
'      || CASE WHEN wkd.pergebnis_id is not null THEN'||unistr('\000a')||
'                   '' (''';

s:=s||'||wkd.pergebnis_id||'')'''||unistr('\000a')||
'         END'||unistr('\000a')||
'  END mengenart_bez,'||unistr('\000a')||
''||unistr('\000a')||
'   wkd."MENGE" "MENGE", '||unistr('\000a')||
'   wkd."VOLUMEN" "VOLUMEN", '||unistr('\000a')||
'   wkd."GEWICHT" "GEWICHT", '||unistr('\000a')||
'   wkd."PREIS" "PREIS", '||unistr('\000a')||
'   (wkd."MWST_BETRAG" * menge) "MWST_BETRAG", '||unistr('\000a')||
'   wkd."MWST_SATZ" "MWST_SATZ", '||unistr('\000a')||
'   ((wkd.preis) * menge) gesamtpreis,'||unistr('\000a')||
'   wkd."WK_STATUS_ID" "WK_STATUS_ID", '||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''WARENKORB_STATUS.BEZEICHNUNG'','||unistr('\000a')||
'          ';

s:=s||'                        wkd.WK_STATUS_ID,:fas_sprache_id) WK_STATUS,'||unistr('\000a')||
'   wkd."STATUS_AENDERDATUM" "STATUS_AENDERDATUM", '||unistr('\000a')||
'   wkd."STATUS_AENDERVISUM" "STATUS_AENDERVISUM", '||unistr('\000a')||
'   wkd."ETIKETTENTYP" "ETIKETTENTYP", '||unistr('\000a')||
'   wkd."BEMERKUNG" "BEMERKUNG", '||unistr('\000a')||
'   wkd."INH_GRENZWERTTYP_ID" "INH_GRENZWERTTYP_ID", '||unistr('\000a')||
'   wkd."PROVISIONSPUNKTWERT" "PROVISIONSPUNKTWERT", '||unistr('\000a')||
'   wkd."PROVISIONSPUNKTE" "PROVISIONSPUNKTE", '||unistr('\000a')||
'   w';

s:=s||'kd."REZEPT_MENGE" "REZEPT_MENGE", '||unistr('\000a')||
'   wkd."REZEPT_GEWICHT" "REZEPT_GEWICHT", '||unistr('\000a')||
'   wkd."REZEPT_MENGENART_ID" "REZEPT_MENGENART_ID"'||unistr('\000a')||
'  ,CASE WHEN '||unistr('\000a')||
'       (:p323_extern_verwaltet = 0 AND  -- FAS-Auftraege'||unistr('\000a')||
'         ((wkd.wk_status_id < 50 '||unistr('\000a')||
'           AND  (wkd.mengenart_id is NULL OR wkd.mengenart_id != 101) --Versandkosten'||unistr('\000a')||
'           AND ((wkd.p_rezept_id is not null AND wkd.mengenart_id is NULL AND'||unistr('\000a')||
'  ';

s:=s||'               (SELECT count(*)                   -- Mischung noch nicht in Prod'||unistr('\000a')||
'                  FROM bestellungen b, auftraege a '||unistr('\000a')||
'                  WHERE b.warenkorb_detail_id = wkd.id '||unistr('\000a')||
'                    AND b.id = a.bestell_id'||unistr('\000a')||
'                  ) = 0'||unistr('\000a')||
'                ) '||unistr('\000a')||
'                OR wkd.mengenart_id is NOT NULL       -- ist Fertigartikel'||unistr('\000a')||
'              )'||unistr('\000a')||
'          )'||unistr('\000a')||
'         OR '||unistr('\000a')||
'        ';

s:=s||'  (wkd.wk_status_id >= 50 AND wkd.wk_status_id < 60)'||unistr('\000a')||
'        )'||unistr('\000a')||
'       )'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       (:p323_extern_verwaltet = 1  and --GUS-Auftraege'||unistr('\000a')||
'        wkd.wk_status_id = 5  and'||unistr('\000a')||
'        (wkd.mengenart_id is NULL OR wkd.mengenart_id != 101) --Versandkosten'||unistr('\000a')||
'       )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'    apex_item.checkbox(1,wkd.ID,''UNCHECKED'') '||unistr('\000a')||
'   ELSE '' '''||unistr('\000a')||
'   END row_selector'||unistr('\000a')||
'FROM '||unistr('\000a')||
'   WARENKORB_DETAILS wkd, mn_rezepte mnr, prod_re';

s:=s||'zepte pr'||unistr('\000a')||
'WHERE wkd.WARENKORB_ID = :P323_ID'||unistr('\000a')||
'  AND wkd.p_rezept_id = pr.id (+)'||unistr('\000a')||
'  AND pr.version = mnr.version (+)'||unistr('\000a')||
'  AND pr.rezept_nr = mnr.rezept_nr (+)';

wwv_flow_api.create_report_region (
  p_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 323,
  p_name=> 'WK-Laborpositionen',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 30,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_when_condition=> 'P323_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P323_HEIGHT_WKD.px;width:900px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5254516912215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 2,
  p_column_heading=> 'ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5254617696215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_ID',
  p_column_display_sequence=> 3,
  p_column_heading=> 'WARENKORB_ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5254731903215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> 'PRODKENNZ_ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5254812755215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'P_REZEPT_ID',
  p_column_display_sequence=> 5,
  p_column_heading=> 'P_REZEPT_ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5254917884215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_BEZ',
  p_column_display_sequence=> 6,
  p_column_heading=> 'REZEPT_BEZ',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255011551215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 7,
  p_column_heading=> 'REZEPT_NR',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255128393215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'VERSION',
  p_column_display_sequence=> 8,
  p_column_heading=> 'VERSION',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255225986215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 9,
  p_column_heading=> 'Artikel-ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255326500215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_BEZ',
  p_column_display_sequence=> 10,
  p_column_heading=> 'Artikel',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255430644215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 11,
  p_column_heading=> 'Menge',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255522852215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'VOLUMEN',
  p_column_display_sequence=> 12,
  p_column_heading=> 'VOLUMEN',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255630535215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'GEWICHT',
  p_column_display_sequence=> 13,
  p_column_heading=> 'GEWICHT',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255731837215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'PREIS',
  p_column_display_sequence=> 14,
  p_column_heading=> 'Einzelpreis &P323_WAEHRUNG_ZEICHEN.',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255800634215666 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_BETRAG',
  p_column_display_sequence=> 16,
  p_column_heading=> 'Mwst-Betrag &P323_WAEHRUNG_ZEICHEN.',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5255907457215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_SATZ',
  p_column_display_sequence=> 17,
  p_column_heading=> 'Mwst %',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256026243215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'GESAMTPREIS',
  p_column_display_sequence=> 15,
  p_column_heading=> 'Gesamt &P323_WAEHRUNG_ZEICHEN.',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256130446215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS_ID',
  p_column_display_sequence=> 18,
  p_column_heading=> 'WK_STATUS_ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256214269215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS',
  p_column_display_sequence=> 19,
  p_column_heading=> 'Status',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256303160215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERDATUM',
  p_column_display_sequence=> 20,
  p_column_heading=> 'STATUS_AENDERDATUM',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256428023215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERVISUM',
  p_column_display_sequence=> 21,
  p_column_heading=> 'STATUS_AENDERVISUM',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256519881215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'ETIKETTENTYP',
  p_column_display_sequence=> 22,
  p_column_heading=> 'ETIKETTENTYP',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256607013215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 23,
  p_column_heading=> 'BEMERKUNG',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256732264215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'INH_GRENZWERTTYP_ID',
  p_column_display_sequence=> 24,
  p_column_heading=> 'INH_GRENZWERTTYP_ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256823249215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'PROVISIONSPUNKTWERT',
  p_column_display_sequence=> 25,
  p_column_heading=> 'PROVISIONSPUNKTWERT',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5256911500215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'PROVISIONSPUNKTE',
  p_column_display_sequence=> 26,
  p_column_heading=> 'PROVISIONSPUNKTE',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5257027688215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_MENGE',
  p_column_display_sequence=> 27,
  p_column_heading=> 'REZEPT_MENGE',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5257105291215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 27,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_GEWICHT',
  p_column_display_sequence=> 28,
  p_column_heading=> 'REZEPT_GEWICHT',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5257207543215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 28,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_MENGENART_ID',
  p_column_display_sequence=> 29,
  p_column_heading=> 'REZEPT_MENGENART_ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5257304152215667 + wwv_flow_api.g_id_offset,
  p_region_id=> 5254217516215655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 29,
  p_form_element_id=> null,
  p_column_alias=> 'ROW_SELECTOR',
  p_column_display_sequence=> 1,
  p_column_heading=> '<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||''||unistr('\000a')||
'SELECT'||unistr('\000a')||
'    wkd.id                                                                      ID,'||unistr('\000a')||
'    wkd.MENGENART_ID                                                            MENGENART_ID,'||unistr('\000a')||
'    CASE WHEN wkd.PRODKENNZ_ID = 1 THEN'||unistr('\000a')||
'      frgbg_at.GUS_KDAP_GET_GUSARTIKEL (wkd.id)|| ''</br>''||'||unistr('\000a')||
'      frgbg_s.get_pers_name_rezept(wkd.p_rezept_id)'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUER';

s:=s||'ZEL'','||unistr('\000a')||
'          wkd.MENGENART_ID,:fas_sprache_id)'||unistr('\000a')||
'      || ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                    wkd.MENGENART_ID,:fas_sprache_id)'||unistr('\000a')||
'      || CASE WHEN wkd.pergebnis_id is not null THEN'||unistr('\000a')||
'                 '' (''||wkd.pergebnis_id||'')'' ELSE NULL END'||unistr('\000a')||
'    END                                                                         MENGEN';

s:=s||'ART_BEZ,'||unistr('\000a')||
'    mi.inhstoff_id                                                              INHSTOFF_ID,'||unistr('\000a')||
'    --frgbg_s.HOLEN_UEBERSETZUNG(m.BEZEICHNUNG_TEXT_ID,357) inh_kuerzel,'||unistr('\000a')||
'    i.Bezeichnung || '' ('' || i.kuerzel ||'')''                                    KUERZEL,'||unistr('\000a')||
'    CASE frgbg_t.LAB_GET_FB_INH_STATUS (wkd.pergebnis_id,'||unistr('\000a')||
'        mi.inhstoff_id,wkd.warenkorb_id)'||unistr('\000a')||
'    WHEN 0 THEN ''fehlt'''||unistr('\000a')||
'    WHEN 1 TH';

s:=s||'EN ''vorhanden'''||unistr('\000a')||
'    WHEN 0.1 THEN ''Übernahme erforderlich'''||unistr('\000a')||
'    WHEN 2 THEN ''in Schnittstelle vorhanden'''||unistr('\000a')||
'    WHEN -1 THEN ''nicht relevant'''||unistr('\000a')||
'    WHEN 90 THEN ''Fehler in der Übernahme'''||unistr('\000a')||
'    WHEN 91 THEN ''Fehler in der Übernahme'''||unistr('\000a')||
'    ELSE ''Fehler:''||frgbg_t.LAB_GET_FB_INH_STATUS (wkd.pergebnis_id,'||unistr('\000a')||
'        mi.inhstoff_id,wkd.warenkorb_id)'||unistr('\000a')||
'    END                                                            ';

s:=s||'             STATUS,'||unistr('\000a')||
'    CASE WHEN :P323_PERGEBNIS_ID is null'||unistr('\000a')||
'        or FRGBG_S.FB_CHECK_AUSWERTUNG(:P323_PERGEBNIS_ID) = 0'||unistr('\000a')||
'    THEN'||unistr('\000a')||
'        CASE WHEN frgbg_t.LAB_GET_FB_INH_STATUS (wkd.pergebnis_id,mi.inhstoff_id,'||unistr('\000a')||
'            wkd.warenkorb_id) in(1,2,3)'||unistr('\000a')||
'        THEN'||unistr('\000a')||
'            ''<a href="'' || APEX_UTIL.PREPARE_URL(''f?p='' || :APP_ID || '':328:'''||unistr('\000a')||
'            || :APP_SESSION || ''::NO:328:P328_ID:'' ||';

s:=s||''||unistr('\000a')||
'            ('||unistr('\000a')||
'                select max(law.id)'||unistr('\000a')||
'                from v_labor_analysewerte law, labors l'||unistr('\000a')||
'                where ('||unistr('\000a')||
'                    (l.auftrag_id_intern = 1 and law.AUFTRAG_ID_INTERN = :P323_ID)'||unistr('\000a')||
'                    or (l.auftrag_id_intern = 0 and law.AUFTRAG_ID = wkd.LABOR_AUFTRAG_ID)'||unistr('\000a')||
'                )'||unistr('\000a')||
'                and law.labor_id = l.id'||unistr('\000a')||
'                and law.satz_kennzeich';

s:=s||'en is null'||unistr('\000a')||
'                and law.inhstoff_id = mi.inhstoff_id'||unistr('\000a')||
'            )'||unistr('\000a')||
'        ) || ''" onclick="return false;" class="edit_laborwert"><img src="/i/edit_big.gif" /></a>'''||unistr('\000a')||
'        WHEN frgbg_t.LAB_GET_FB_INH_STATUS (wkd.pergebnis_id,mi.inhstoff_id,'||unistr('\000a')||
'            wkd.warenkorb_id) = 0'||unistr('\000a')||
'        THEN'||unistr('\000a')||
'          ''<a href="'' || APEX_UTIL.PREPARE_URL(''f?p='' || :APP_ID || '':328:'' || :APP_SESSION'||unistr('\000a')||
'        ';

s:=s||'    || ''::NO:328:P328_AUFTRAG_ID_INTERN,P328_LABOR_ANALYSEKUERZEL_ID:'' ||'||unistr('\000a')||
'            :P323_ID || '','' ||'||unistr('\000a')||
'            ('||unistr('\000a')||
'              select -- Auf jeden Fall alle Laborwerte die das aktuelle Labor hat'||unistr('\000a')||
'                lak2.ID'||unistr('\000a')||
'              from LABOR_ANALYSEKUERZEL lak2, labors l2, inhstoffe i2'||unistr('\000a')||
'              where'||unistr('\000a')||
'                lak2.labor_id = :P328_LABOR_ID'||unistr('\000a')||
'                and lak2.satz_kennzeic';

s:=s||'hen is null'||unistr('\000a')||
'                and l2.id = lak2.labor_id'||unistr('\000a')||
'                and i2.id = lak2.inhstoff_id'||unistr('\000a')||
'                and i2.id = i.id'||unistr('\000a')||
'              union all'||unistr('\000a')||
'              select -- Laborwerte die auch andere Labore anbieten. Nimm einfach ein beliebiges'||unistr('\000a')||
'                lak2.ID'||unistr('\000a')||
'              from LABOR_ANALYSEKUERZEL lak2, labors l2, inhstoffe i2'||unistr('\000a')||
'              where'||unistr('\000a')||
'                not exists('||unistr('\000a')||
'      ';

s:=s||'              select id'||unistr('\000a')||
'                    from LABOR_ANALYSEKUERZEL lak3'||unistr('\000a')||
'                    where'||unistr('\000a')||
'                      lak3.inhstoff_id = lak2.inhstoff_id'||unistr('\000a')||
'                      and lak3.satz_kennzeichen is null'||unistr('\000a')||
'                      and lak3.id > lak2.id'||unistr('\000a')||
''||unistr('\000a')||
'                )'||unistr('\000a')||
'                and lak2.inhstoff_id not in('||unistr('\000a')||
'                      select lak3.inhstoff_id'||unistr('\000a')||
'                      from LABO';

s:=s||'R_ANALYSEKUERZEL lak3'||unistr('\000a')||
'                      where lak3.labor_id = :P328_LABOR_ID'||unistr('\000a')||
'                          and satz_kennzeichen is null'||unistr('\000a')||
'                )'||unistr('\000a')||
'                and i2.id = lak2.inhstoff_id'||unistr('\000a')||
'                and i2.id = i.id'||unistr('\000a')||
'                and l2.ID = lak2.labor_id'||unistr('\000a')||
'            ))'||unistr('\000a')||
'            || ''" onclick="return false;" class="edit_laborwert"><img src="/i/edit_big.gif" /></a>'''||unistr('\000a')||
''||unistr('\000a')||
'        EL';

s:=s||'SE'||unistr('\000a')||
'           null'||unistr('\000a')||
'        END'||unistr('\000a')||
'    ELSE ''FB ausgewertet'' END EDIT_LINK'||unistr('\000a')||
'FROM warenkorb_details wkd, mengenart_inhstoffe mi, mengenarts m,'||unistr('\000a')||
'     pis.inhstoffe i'||unistr('\000a')||
'WHERE wkd.MENGENART_ID = mi.MENGENART_ID   -- alle bestellten Laborwerte'||unistr('\000a')||
'     AND :P323_REPORT_REFRESH is not null -- Wird durch Dynamic Action gesetzt, dadurch wird erst nachdem die Seite geladen ist der Bericht geladen'||unistr('\000a')||
'     and mi.SATZ_KENN';

s:=s||'ZEICHEN is null'||unistr('\000a')||
'     and wkd.labor_auftrag_id is not null'||unistr('\000a')||
'     and m.id = mi.mengenart_id'||unistr('\000a')||
'     and m.artgruppe_id = 20               -- Laboranalysewerte'||unistr('\000a')||
'     and m.satz_kennzeichen is null'||unistr('\000a')||
'     and mi.satz_kennzeichen is null'||unistr('\000a')||
'     and wkd.warenkorb_id = :P323_ID'||unistr('\000a')||
'     and mi.inhstoff_id = i.id';

wwv_flow_api.create_report_region (
  p_id=> 5259623815397283 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 323,
  p_name=> 'Übersicht angeforderter Laborwerte',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 40,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P323_HEIGHT_INHSTOFFE.px;width:520px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '500',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '1:2',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_AND_BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5259918489397285 + wwv_flow_api.g_id_offset,
  p_region_id=> 5259623815397283 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 2,
  p_column_heading=> 'ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5260125336397286 + wwv_flow_api.g_id_offset,
  p_region_id=> 5259623815397283 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Artikel-ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5261327371455050 + wwv_flow_api.g_id_offset,
  p_region_id=> 5259623815397283 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_BEZ',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Artikel',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>2,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5260031130397286 + wwv_flow_api.g_id_offset,
  p_region_id=> 5259623815397283 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'INHSTOFF_ID',
  p_column_display_sequence=> 6,
  p_column_heading=> 'ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5262010411525834 + wwv_flow_api.g_id_offset,
  p_region_id=> 5259623815397283 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Laborwert',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5271002827994659 + wwv_flow_api.g_id_offset,
  p_region_id=> 5259623815397283 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS',
  p_column_display_sequence=> 7,
  p_column_heading=> 'Status',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>3,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6420509137620146 + wwv_flow_api.g_id_offset,
  p_region_id=> 5259623815397283 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'EDIT_LINK',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT DISTINCT la.analysekuerzel analysekuerzel,'||unistr('\000a')||
'       lk.inhstoff_id inhstoff_id,'||unistr('\000a')||
'       trim(to_char(la.ERGEBNISWERT,''FM9999990D00'')) laborwert,'||unistr('\000a')||
'       i.bezeichnung inhstoff,'||unistr('\000a')||
'       case when la.AT_BEARB_STATUS is null then'||unistr('\000a')||
'         ''Laborübernahme benötigt'''||unistr('\000a')||
'       when  la.AT_BEARB_STATUS = 20 then'||unistr('\000a')||
'         ''Keine Frage vorhanden'''||unistr('\000a')||
'       when la.AT_BEARB_STATUS = 30 then'||unistr('\000a')||
'         ''Nicht best';

s:=s||'ellt'''||unistr('\000a')||
'       when la.AT_BEARB_STATUS = 21 then'||unistr('\000a')||
'         ''kein Fragebogen vorhanden'''||unistr('\000a')||
'       else'||unistr('\000a')||
'         ''Unbekannter Status: '' || la.AT_BEARB_STATUS'||unistr('\000a')||
'       END STATUS,'||unistr('\000a')||
'       CASE WHEN :P323_PERGEBNIS_ID is null or FRGBG_S.FB_CHECK_AUSWERTUNG(:P323_PERGEBNIS_ID) = 0 THEN'||unistr('\000a')||
'          ''<a href="'' || APEX_UTIL.PREPARE_URL(''f?p='' || :APP_ID || '':328:'' || :APP_SESSION'||unistr('\000a')||
'           || ''::NO:328:P328_ID:'' |';

s:=s||'| la.ID) || ''" onclick="return false;" class="edit_laborwert"><img src="/i/edit_big.gif" /></a>'''||unistr('\000a')||
'       ELSE ''FB Ausgewertet'' END EDIT_LINK'||unistr('\000a')||
'FROM v_labor_analysewerte la, labor_analysekuerzel lk, warenkorb_details wkd, pis.inhstoffe i, labors l'||unistr('\000a')||
'WHERE wkd.warenkorb_id = :P323_ID'||unistr('\000a')||
'  AND :P323_REPORT_REFRESH is not null -- Wird durch Dynamic Action gesetzt, dadurch wird erst nachdem die Seite geladen i';

s:=s||'st der Bericht geladen'||unistr('\000a')||
'  AND la.labor_analysekuerzel_id = lk.id'||unistr('\000a')||
'  AND (la.AT_BEARB_STATUS is null or la.AT_BEARB_STATUS in (20,21,30,90)) -- nicht bestellt'||unistr('\000a')||
'  and lk.inhstoff_id = i.id'||unistr('\000a')||
'  AND ('||unistr('\000a')||
'    (l.auftrag_id_intern = 1 and la.AUFTRAG_ID_INTERN = :P323_ID)'||unistr('\000a')||
'    or (l.auftrag_id_intern = 0 and la.AUFTRAG_ID = wkd.LABOR_AUFTRAG_ID)'||unistr('\000a')||
'  )'||unistr('\000a')||
'  and la.labor_id = l.id'||unistr('\000a')||
'  and la.satz_kennzeichen is null'||unistr('\000a')||
'  and';

s:=s||' not exists('||unistr('\000a')||
'     select law.id'||unistr('\000a')||
'     from v_labor_analysewerte law, labors l'||unistr('\000a')||
'     where ('||unistr('\000a')||
'        (l.auftrag_id_intern = 1 and law.AUFTRAG_ID_INTERN = :P323_ID)'||unistr('\000a')||
'          or (l.auftrag_id_intern = 0 and law.AUFTRAG_ID = wkd.LABOR_AUFTRAG_ID)'||unistr('\000a')||
'        )'||unistr('\000a')||
'        and law.labor_id = l.id'||unistr('\000a')||
'        and law.satz_kennzeichen is null'||unistr('\000a')||
'        and law.inhstoff_id = la.inhstoff_id'||unistr('\000a')||
'        and law.id > la.id'||unistr('\000a')||
'  )';

s:=s||''||unistr('\000a')||
'  and lk.inhstoff_id not in('||unistr('\000a')||
'    select'||unistr('\000a')||
'      mi.inhstoff_id'||unistr('\000a')||
'    FROM warenkorb_details wkd, mengenart_inhstoffe mi, mengenarts m,'||unistr('\000a')||
'         pis.inhstoffe i'||unistr('\000a')||
'    WHERE wkd.MENGENART_ID = mi.MENGENART_ID   -- alle bestellten Laborwerte'||unistr('\000a')||
'         and mi.SATZ_KENNZEICHEN is null'||unistr('\000a')||
'         and wkd.labor_auftrag_id is not null'||unistr('\000a')||
'         and m.id = mi.mengenart_id'||unistr('\000a')||
'         and m.artgruppe_id = 20           ';

s:=s||'    -- Laboranalysewerte'||unistr('\000a')||
'         and m.satz_kennzeichen is null'||unistr('\000a')||
'         and mi.satz_kennzeichen is null'||unistr('\000a')||
'         and wkd.warenkorb_id = :P323_ID'||unistr('\000a')||
'         and mi.inhstoff_id = i.id'||unistr('\000a')||
'  )'||unistr('\000a')||
''||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 5544926418582789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 323,
  p_name=> 'Übersicht nicht angeforderter Laborwerte',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 35,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P323_HEIGHT_INHSTOFFE2.px;width:520px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '500',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5545219494582810 + wwv_flow_api.g_id_offset,
  p_region_id=> 5544926418582789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ANALYSEKUERZEL',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Analysekürzel',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5545306287582812 + wwv_flow_api.g_id_offset,
  p_region_id=> 5544926418582789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'INHSTOFF_ID',
  p_column_display_sequence=> 2,
  p_column_heading=> 'Inhstoff-ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403021600079869 + wwv_flow_api.g_id_offset,
  p_region_id=> 5544926418582789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'LABORWERT',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Laborwert',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6402511908069219 + wwv_flow_api.g_id_offset,
  p_region_id=> 5544926418582789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'INHSTOFF',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Inhstoff',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6416907433800510 + wwv_flow_api.g_id_offset,
  p_region_id=> 5544926418582789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS',
  p_column_display_sequence=> 6,
  p_column_heading=> 'Status',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6419927937565898 + wwv_flow_api.g_id_offset,
  p_region_id=> 5544926418582789 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'EDIT_LINK',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5558903520491596 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 323,
  p_plug_name=> 'navi_labor',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(5557414378428469 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6418723850488642 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 323,
  p_plug_name=> 'Schnellverweis',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5550204853869894 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 20,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_FB',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Fragebogen',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P323_FB_url is not null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5229614953946002 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 30,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Apply Changes',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P323_ID',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5229807579946002 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 65,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_EMAIL_BESTELLBLATT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Email Bestellblatt',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8429628265780753 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 66,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_ANALYSEANFORDERUNG',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Analyseanforderung',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5229228076946000 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 70,
  p_button_plug_id => 5254217516215655+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_EINZELSTORNO',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Storno',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> '(:p323_wk_status_id < 60 and :p323_extern_verwaltet = 0)'||unistr('\000a')||
'OR'||unistr('\000a')||
'(:p323_wk_status_id = 5 and :p323_extern_verwaltet = 1)',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_button_comment=>'(:p323_wk_status_id < 60 and :p323_extern_verwaltet = 0)'||unistr('\000a')||
'OR'||unistr('\000a')||
'(:p323_wk_status_id = 5 and :p323_extern_verwaltet = 1)'||unistr('\000a')||
'',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5230009447946002 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 70,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_PREVIOUS_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&lt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P323_ID_PREV',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5230230442946003 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 80,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_NEXT_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&gt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_NEXT_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P323_ID_NEXT',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5230414710946003 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 10,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:322:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5230600030946003 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 40,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Create',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P323_ID',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6188600743832669 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 90,
  p_button_plug_id => 5544926418582789+wwv_flow_api.g_id_offset,
  p_button_name    => 'ADD_LABOR_WERT',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Wert hinzufügen',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P323_PERGEBNIS_ID is null or FRGBG_S.FB_CHECK_AUSWERTUNG(:P323_PERGEBNIS_ID) = 0',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_button_cattributes=>'class="add_laborwert"',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6424708114818196 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 100,
  p_button_plug_id => 5259623815397283+wwv_flow_api.g_id_offset,
  p_button_name    => 'ADD_LABOR_WERT',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Wert hinzufügen',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P323_PERGEBNIS_ID is null or FRGBG_S.FB_CHECK_AUSWERTUNG(:P323_PERGEBNIS_ID) = 0',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_button_cattributes=>'class="add_laborwert"',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5230827536946003 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 20,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Delete',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'P323_ID',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'DELETE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6657110263732416 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 50,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_LABORUEBERNAHME',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Laborübernahme',
  p_button_position=> 'REGION_TEMPLATE_EDIT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 9162926729733570 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 323,
  p_button_sequence=> 100,
  p_button_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_button_name    => 'ERSTELL_RECHNUNGSBELEG',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstelle Rechnungsbeleg',
  p_button_position=> 'REGION_TEMPLATE_EDIT',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'frgbg_s.FB_CHECK_AUSWERTUNG(:P323_PERGEBNIS_ID) = 1 AND'||unistr('\000a')||
'frgbg_t.LAB_GET_FB_STATUS_WK(:P323_ID) = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5553422271357519 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_branch_name=> '',
  p_branch_action=> '&P323_FB_URL.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5550204853869894+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'ITEM_IS_NOT_NULL',
  p_branch_condition=> 'P323_FB_URL',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 01-AUG-2013 12:44 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>9163204350736615 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:323:&SESSION.:ERSTELL_RECHNUNGSBELEG2:&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>9162926729733570+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> 'frgbg_s.FB_CHECK_AUSWERTUNG(:P323_PERGEBNIS_ID) = 1 AND'||unistr('\000a')||
'frgbg_t.LAB_GET_FB_STATUS_WK(:P323_ID) = 1',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 19-JUN-2014 10:39 by SASCHA.LENZ');
 
wwv_flow_api.create_page_branch(
  p_id=>5238518907946056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:323:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 60,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BUT_EINZELSTORNO'',''BUT_KOMPLETTSTORNO'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-FEB-2012 12:41 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>5238700621946060 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:323:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 110,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>9270431004092864 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:320:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 120,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in(''CREATE'',''DELETE'',''BUT_EINZELSTORNO'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 27-JUN-2014 11:18 by SASCHA.LENZ');
 
wwv_flow_api.create_page_branch(
  p_id=>5238904785946060 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:323:&SESSION.::&DEBUG.::P323_ID:&P323_ID_NEXT.',
  p_branch_point=> 'BEFORE_COMPUTATION',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5230230442946003+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>5239115171946060 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:323:&SESSION.::&DEBUG.::P323_ID:&P323_ID_PREV.',
  p_branch_point=> 'BEFORE_COMPUTATION',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5230009447946002+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5231000068946004 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5231223708946008 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 54,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Datum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5231407316946009 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land',
  p_source=>'VERRECH_LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT iso3_id a, id b'||unistr('\000a')||
'FROM Laender'||unistr('\000a')||
'WHERE id = :p323_verrech_land_id',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5231600043946010 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'WAEHRUNG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5231825028946010 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preis netto',
  p_post_element_text=>'&#160&#160&P323_WAEHRUNG_ZEICHEN.',
  p_format_mask=>'999990D00',
  p_source=>'GESAMTPREIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5232029949946011 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_MWST_JN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Jn',
  p_source=>'MWST_JN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5232212750946012 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_MWST_BETRAG_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 71,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst  (&P323_MWST_SATZ_1.%)',
  p_post_element_text=>'&#160&#160&P323_WAEHRUNG_ZEICHEN.',
  p_format_mask=>'999990D00',
  p_source=>'MWST_BETRAG_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5232405999946012 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_MWST_BETRAG_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst (&P323_MWST_SATZ_2.%)',
  p_post_element_text=>'&#160&#160&P323_WAEHRUNG_ZEICHEN.',
  p_format_mask=>'999990D00',
  p_source=>'MWST_BETRAG_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P323_MWST_BETRAG_2 is not null',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5232622948946013 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_MWST_SATZ_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'MWST_SATZ_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5232821794946013 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_MWST_SATZ_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'MWST_SATZ_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P323_MWST_BETRAG_2 is not null',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5233015997946013 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_WK_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 86,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status',
  p_source=>'WK_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select fas_synch.get_tab_uebersetzung(''WARENKORB_STATUS.BEZEICHNUNG'','||unistr('\000a')||
'                                       ID,:fas_sprache_id) a, id b'||unistr('\000a')||
'FROM warenkorb_status'||unistr('\000a')||
'where id = :P323_WK_STATUS_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5233229438946014 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_STATUS_AENDERDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aenderdatum',
  p_source=>'STATUS_AENDERDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5233407360946015 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_STATUS_AENDERVISUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aendervisum',
  p_source=>'STATUS_AENDERVISUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5233605592946015 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p323_persstamm_id_rechnung)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5233819135946016 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 115,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Betreuer',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p323_persstamm_id_login)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5234017253946016 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 61,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p323_persstamm_id_lieferung)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5234226555946017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bemerkung',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5234403145946017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PERSSTAMM_ID_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identität',
  p_source=>'PERSSTAMM_ID_IDENTITAET',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p323_persstamm_id_identitaet)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5234625578946017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prod. Apotheke',
  p_source=>'PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p323_persstamm_id_prod_apo)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5234829015946017 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PREISLISTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisliste',
  p_source=>'PREISLISTE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select bezeichnung a, id b'||unistr('\000a')||
'from preislisten '||unistr('\000a')||
'where id= :P323_PREISLISTE_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5235028785946018 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_ART_MWST_TYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Art Mwst Typ Id',
  p_source=>'ART_MWST_TYP_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5235211615946018 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PREISFAKTOR',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 93,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Preisfaktor',
  p_source=>'PREISFAKTOR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5235413976946018 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PERSSTAMM_ID_KUNDE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kunde',
  p_source=>'PERSSTAMM_ID_KUNDE',
  p_source_type=> 'DB_COLUMN',
  p_source_post_computation => 'frgbg_s.get_pers_adresse(:p323_persstamm_id_kunde)',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5235610790946019 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PROVISIONSPUNKTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Provisionspunkte',
  p_source=>'PROVISIONSPUNKTE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5235817309946019 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PROVISIONSKOPF_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Provisionskopf Id',
  p_source=>'PROVISIONSKOPF_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5236023126946019 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_SORTIMENT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 91,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sortiment',
  p_source=>'SORTIMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT bezeichnung a, id b'||unistr('\000a')||
'from sortimente where id = :P323_SORTIMENT_ID',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'onchange="htmldb_item_change(this)"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5236229427946020 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_ID_NEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'P323_ID_NEXT',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5236419331946020 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_ID_PREV',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P323_ID_PREV',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5236623244946021 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_WAEHRUNG_ZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'SELECT NVL(zeichen,code) '||unistr('\000a')||
'FROM waehrungen'||unistr('\000a')||
'where id = :P323_WAEHRUNG_ID',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5236821152946022 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'GUS verwaltet ',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.holen_uebersetzung(76,357), 1 from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'select frgbg_s.holen_uebersetzung(77,357), 0 from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5237026434946023 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_WK_VERSANDART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Versandart',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5258321512330414 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_HEIGHT_WKD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5260821783425086 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_HEIGHT_INHSTOFFE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5546010057596991 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_HEIGHT_INHSTOFFE2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 5254217516215655+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5549703421841149 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_PERGEBNIS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 360,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 5,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5553105863343344 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_FB_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 370,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'URL',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6418930658488650 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_QUICKMENU',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 6418723850488642+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Schnellverweis:',
  p_source=>'select'||unistr('\000a')||
''||unistr('\000a')||
' listagg(''<a href="javascript:redirect('''''' ||'||unistr('\000a')||
'    frgbg_t.PREPARE_URL(URL) || '''''');">'' || BEZEICHNUNG || ''</a>'','' | '')'||unistr('\000a')||
'    within group (order by SORTIERUNG)'||unistr('\000a')||
' from FAS_APP_MENUS'||unistr('\000a')||
'where'||unistr('\000a')||
'  FAS_APP_MENU_ID in(select FAS_APP_MENU_ID from FAS_APP_MENUS where app_id = :APP_ID and page_id = 322)',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6537328612253450 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_REPORT_REFRESH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 5229400300946001+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6539708648414616 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_LOAD_ICON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 390,
  p_item_plug_id => 5544926418582789+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'<img src="/i/htmldb/icons/loading-gray.gif" />',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_tag_attributes  => 'style="display:none;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6541420256454895 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 323,
  p_name=>'P323_LOAD_ICON2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 400,
  p_item_plug_id => 5259623815397283+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'<img src="/i/htmldb/icons/loading-gray.gif" />',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_tag_attributes  => 'style="display:none;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6206209035383835 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_name => 'öffne Modal Fenster - Eingabe Laborwerte'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.add_laborwert'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6206501558383836 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6206209035383835 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_attribute_02 => 'STATIC'
 ,p_attribute_03 => 'f?p=&APP_ID.:328:&APP_SESSION.::NO:328:P328_AUFTRAG_ID_INTERN:&P323_ID.'
 ,p_attribute_06 => 'div#MESSAGE.t1success'
 ,p_attribute_07 => 'STATIC_PX'
 ,p_attribute_08 => '550'
 ,p_attribute_09 => '800'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6422310587702545 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_name => 'öffne Modal Fenster - Bearbeite Laborwerte'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => 'a.edit_laborwert'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6422617608702548 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6422310587702545 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_attribute_02 => 'TRIG_ELEMENT_ATTR'
 ,p_attribute_05 => 'href'
 ,p_attribute_06 => 'div#MESSAGE.t1success'
 ,p_attribute_07 => 'STATIC_PX'
 ,p_attribute_08 => '550'
 ,p_attribute_09 => '800'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6206701332400560 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_name => 'schliesse Modalfenster'
 ,p_event_sequence => 40
 ,p_triggering_element_type => 'DOM_OBJECT'
 ,p_triggering_element => 'document'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE|DYNAMIC ACTION|modalpageautoclose'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6207020802400561 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6206701332400560 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '//Javascript Modal Window Schliessen'||unistr('\000a')||
'v_message = this.data.$modalPageCloseObject;'||unistr('\000a')||
'$(''.t1messages'').after( v_message );'||unistr('\000a')||
'$(''#MESSAGE.t1success'').delay(2000).fadeOut(2000);'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6418028394003518 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6206701332400560 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 5544926418582789 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6418224728005152 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6206701332400560 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 30
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 5259623815397283 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6542502697470208 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_name => 'Load Icon einblenden angeforderte Laborwerte'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 5259623815397283 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'apexbeforerefresh'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6542815182470208 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6542502697470208 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P323_LOAD_ICON2'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6541602912460853 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_name => 'Load Icon ausblenden angeforderte Laborwerte'
 ,p_event_sequence => 60
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 5259623815397283 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'apexafterrefresh'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6541927503460882 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6541602912460853 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P323_LOAD_ICON2'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6542022998466607 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_name => 'Load Icon einblenden nicht angeforderte Laborwerte'
 ,p_event_sequence => 70
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 5259623815397283 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'apexbeforerefresh'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6542310838466608 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6542022998466607 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P323_LOAD_ICON'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6540721004447164 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_name => 'Load Icon ausblenden nicht angeforderte Laborwerte'
 ,p_event_sequence => 120
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 5544926418582789 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'apexafterrefresh'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6541006418447175 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6540721004447164 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P323_LOAD_ICON'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6537815875275364 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_name => 'Lade Messwert Reports'
 ,p_event_sequence => 210
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6538915839320154 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6537815875275364 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin '||unistr('\000a')||
'  :P323_REPORT_REFRESH := 1;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P323_REPORT_REFRESH'
 ,p_attribute_03 => 'P323_REPORT_REFRESH'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6538308328278034 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6537815875275364 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 5259623815397283 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6538505093279581 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 323
 ,p_event_id => 6537815875275364 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 30
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 5544926418582789 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:WARENKOERBE:P323_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 5237202679946024 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from WARENKOERBE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to fetch row.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKOERBE:ID::PLANDATUM:ID:P323_ID:P323_ID_NEXT:P323_ID_PREV:::::';

wwv_flow_api.create_page_process(
  p_id     => 5237430337946048 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'GET_NEXT_OR_PREV_PK',
  p_process_name=> 'Get Next or Previous Primary Key Value',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to run Get Next or Previous Primary Key Value process.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
' -- Dadurch werden die Berichte nicht sofort aktualisiert, sondern erst nachdem die Seite geladen wurde. Es dauert sonst zulange bis die Seite geladen ist.'||unistr('\000a')||
' :P323_REPORT_REFRESH := null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6537401199261623 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze 	P323_REPORT_REFRESH zurück',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_SCROLLREGION_HEIGHT_MAX  NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_SCROLLREGION_HEIGHT_MAX:= :FAS_SCROLLREGION_HEIGHT_MAX;'||unistr('\000a')||
'   :P323_HEIGHT_wkd := trunc(v_SCROLLREGION_HEIGHT_MAX * 0.76);'||unistr('\000a')||
'   :P323_HEIGHT_inhstoffe:= trunc(v_SCROLLREGION_HEIGHT_MAX * 0.50);'||unistr('\000a')||
'   :P323_HEIGHT_inhstoffe2:= trunc(v_SCROLLREGION_HEIGHT_MAX * 0.46);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5258431555333301 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'   v_aenderbar     personenstamm.aenderbar%TYPE;'||unistr('\000a')||
'   v_user_account  personenstamm.user_account%TYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT aenderbar, user_account'||unistr('\000a')||
'   INTO v_aenderbar, v_user_account'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :p323_persstamm_id_kunde;'||unistr('\000a')||
'--mel.p(''In setze_fas_pers_aenderbar'',v_prot_id,''INFO'',''102/323 setze_fas_pers_aenderbar'');'||unistr('\000a')||
'   IF   (v_aenderbar = ''J'') '||unistr('\000a')||
'     OR (v_';

p:=p||'aenderbar = ''N'' AND'||unistr('\000a')||
'         -- speziell berechtigt'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''GESCHUETZTE_PERSONENDATEN_AENDERN'') > 0 '||unistr('\000a')||
'         )'||unistr('\000a')||
'      OR (v_aenderbar = ''N'' AND                 -- User hat sich selbst eingeloggt'||unistr('\000a')||
'          :fas_aufgerufen_von != ''BETREUER'' and'||unistr('\000a')||
'          UPPER(v_USER_ACCOUNT)= UPPER(:APP_USER)'||unistr('\000a')||
'         )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :fas_pers_aenderbar := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_p';

p:=p||'ers_aenderbar := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5551632520275327 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 70,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_fas_pers_aenderbar',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_identitaet_persstamm_id   personenstamm.id%TYPE;'||unistr('\000a')||
'   v_persstamm_id              personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fas_pers_schema_id        fas_schemas.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                varchar2(2000);'||unistr('\000a')||
'   v_prot_id                   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Routine wird benötigt, da hier ein Quereinstieg in den FB möglich ist und daher die aktive Identität, Sortiment etc. bestimmt werden m';

p:=p||'uss'||unistr('\000a')||
''||unistr('\000a')||
'   -- Diese Routine best. die aktive Identität, Kunden-Schema, Sortiment eines ausgewählten Kunden '||unistr('\000a')||
'   -- Persstamm_id kommt 5x vor'||unistr('\000a')||
'   v_persstamm_id := :p323_persstamm_id_kunde;'||unistr('\000a')||
'   IF v_persstamm_id IS NULL THEN -- Patient muss vorhanden sein'||unistr('\000a')||
'       v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Bestimm';

p:=p||'en der aktiven Identität'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN   -- Aktive Identität ist immer bevorzugt betreuende Identität des Kunden bzw. '||unistr('\000a')||
'                                              -- falls nicht vorhanden betreuende Identität des Kunden '||unistr('\000a')||
'         /*'||unistr('\000a')||
'         v_identitaet_persstamm_id:=  '||unistr('\000a')||
'                     frgbg_s.get_identitaet_kunde(:fas_login_personenstamm_id,'||unistr('\000a')||
'                 ';

p:=p||'                           -1,'||unistr('\000a')||
'                                            v_persstamm_id);      '||unistr('\000a')||
'         */'||unistr('\000a')||
'         /* NEI 20.09.13: => Zukünftig wird nur noch die bevorzugt betreuende Person des Kunden zur'||unistr('\000a')||
'                               aktive Identität egal ob der Betreuer Zugriff auf die Identität hat.'||unistr('\000a')||
'                               Er sieht den Kunden, vielleicht auch nur, weil er speziell ';

p:=p||'Zugriff auf den Kunden hat, '||unistr('\000a')||
'                               da der Kunde von einer Idenität (Apo Richter) noch zusätzlich betreut wird, '||unistr('\000a')||
'                               auf die der Betreuer auch Zugriff hat. D.h. der Betreuer hat nicht direkten Zugriff'||unistr('\000a')||
'                               auf die bevorzugt betreuende Identität und daher auf alle Kunden von dieser Identität, '||unistr('\000a')||
'                             ';

p:=p||'  sondern nur ein spezieller Kunde dieser bevorzugt betreuende Identität ist für den Betreuer bzw.'||unistr('\000a')||
'                               seiner zugreifbaren Identitäten freigeschaltet.'||unistr('\000a')||
'         */'||unistr('\000a')||
'         v_identitaet_persstamm_id:=  '||unistr('\000a')||
'               frgbg_s.get_identitaet_kunde( NULL,'||unistr('\000a')||
'                                            -1,'||unistr('\000a')||
'                                            v_persstamm_id);'||unistr('\000a')||
'         IF';

p:=p||' v_identitaet_persstamm_id <= 0 OR '||unistr('\000a')||
'             v_identitaet_persstamm_id is NULL'||unistr('\000a')||
'         THEN '||unistr('\000a')||
'            :fas_identitaet := '''';'||unistr('\000a')||
'            :fas_identitaet_persstamm_id := NULL;'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(3098,:fas_sprache_id);'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20001,v_fehlertext );'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstam';

p:=p||'m_id;'||unistr('\000a')||
'            :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,'||unistr('\000a')||
'                                                          :FAS_SCHEMA_ID);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''ANONYM'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Betreuende Identitaet für Endkunden holen'||unistr('\000a')||
'       SELECT parameter'||unistr('\000a')||
'       INTO v_identitaet_persstamm_id'||unistr('\000a')||
'       FROM s';

p:=p||'ysareas_frgbg'||unistr('\000a')||
'       WHERE id = 6;'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''KUNDE'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Holen der Identitaet aus Pers_betreuer mit standard = J'||unistr('\000a')||
'       v_identitaet_persstamm_id := frgbg_s.GET_';

p:=p||'IDENTITAET_KUNDE(NULL,-1,v_persstamm_id);'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Schema-Id des Kunden setzen, abgeleitet aus der bevorzugt betreuenden Identitaet => wird beim Druck für die Auswahllistten von Kundensprache verwendet'||unistr('\000a')||
'   -- Schema der bevorzugt';

p:=p||' betreuenden Identitaet bestimmen '||unistr('\000a')||
'   v_fas_pers_schema_id := frgbg_s.get_fas_schema('||unistr('\000a')||
'         frgbg_s.get_identitaet_kunde(NULL,-1,v_persstamm_id),'||unistr('\000a')||
'          ''IDENTITAET'');'||unistr('\000a')||
'   IF v_fas_pers_schema_id <= 0 OR '||unistr('\000a')||
'      v_fas_pers_schema_id is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :fas_pers_schema_id := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3505,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_f';

p:=p||'ehlertext );'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_schema_id := v_fas_pers_schema_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Sortiment-ID der aktiven Identitaet '||unistr('\000a')||
'   -- NEI 14.02.2011 Sortimentseinfuehrung: sortiment_id statt preislisten_set_id      '||unistr('\000a')||
'   :FAS_SORTIMENT_ID:= rezepte.get_sortiment(:FAS_IDENTITAET_PERSSTAMM_ID,''IDENTITAET'');'||unistr('\000a')||
'   IF :FAS_SORTIMENT_ID <= 0 OR '||unistr('\000a')||
'      :FAS_SORTIMENT_ID is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :FAS_SORTIMENT_I';

p:=p||'D := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3518,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20004,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''Bst. genereller Parameter Wahlident %1; Login-id %2; aktive Ident %3; Schema-kunde:%4, akt.Schema:%5,Sortiment:%6,Person:%7'', v_PROT_ID, ''TEST'', ''aktive_identitaet_pers_schema_sortiment_setzen'',:p110_wahl_identitaet,:fas_login_personenstamm_id';

p:=p||','||unistr('\000a')||
'v_identitaet_persstamm_id,:fas_pers_schema_id,:fas_schema_id,:FAS_SORTIMENT_ID,v_persstamm_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5552232005313037 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 80,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'aktive_identitaet_pers_schema_sortiment_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_fragebogen_id  fragebogen.id%TYPE;'||unistr('\000a')||
'   v_prot_id        NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p323_fb_url := NULL;   '||unistr('\000a')||
'   '||unistr('\000a')||
'   begin'||unistr('\000a')||
'        SELECT max(pergebnis_id) into :p323_pergebnis_id'||unistr('\000a')||
'        FROM warenkorb_details wkd'||unistr('\000a')||
'        WHERE wkd.warenkorb_id = :p323_id; '||unistr('\000a')||
'   exception'||unistr('\000a')||
'        when no_data_found then'||unistr('\000a')||
'            :p323_pergebnis_id := null; -- Laborauftrag muss nicht unbedingt einen Fragebogen ha';

p:=p||'ben'||unistr('\000a')||
'   end;'||unistr('\000a')||
'      '||unistr('\000a')||
'   if :p323_pergebnis_id is not null then'||unistr('\000a')||
'   '||unistr('\000a')||
'       SELECT fragebogen_id INTO v_fragebogen_id'||unistr('\000a')||
'       FROM pergebnisse'||unistr('\000a')||
'       WHERE id = :p323_pergebnis_id;'||unistr('\000a')||
''||unistr('\000a')||
'       -- URL FB zusammenstellen'||unistr('\000a')||
'       SELECT '||unistr('\000a')||
'          CASE'||unistr('\000a')||
'          /* bearbeitbare Version */'||unistr('\000a')||
'          WHEN perg_akt_version = 1 AND      -- akt. Antwortset und akt. FB-Version'||unistr('\000a')||
'               :fas_pers_aenderbar = 1 ';

p:=p||'AND   -- Pers.Daten änderbar'||unistr('\000a')||
'               --mn_rezept_id is null          -- kein Rezept'||unistr('\000a')||
'               frgbg_s.FB_CHECK_AUSWERTUNG(pergebnis_id)= 0  -- keine Auswertung'||unistr('\000a')||
'          THEN '||unistr('\000a')||
'                ''f?p=''||:APP_ID||'':1:''||:APP_SESSION||''::&DEBUG.:1,2,3,4,5,6,7,8,9,10,31,32,33,34,35,90,91,95:'''||unistr('\000a')||
'                ||''P1_PERSON,P1_FRAGEBOGEN_ID,P1_FB_VERSION,P1_PERGEBNIS_ID,P1_BEARB_MODUS,P1_ZURUEC';

p:=p||'K_ZUR_SEITE:'''||unistr('\000a')||
'                ||to_char(PERSONENSTAMM_ID)||'',''||to_char(trunc(FRAGEBOGEN_ID))||'','''||unistr('\000a')||
'                ||to_char(frgbg_s.fb_get_vers(fragebogen_id))||'','''||unistr('\000a')||
'                ||to_char(PERGEBNIS_ID)||'',BEARBEITEN,''||:APP_PAGE_ID'||unistr('\000a')||
'          /* NEI 2.2.09 Kopie erzeugen => neue Version bearbeitbar nur noch über Button */'||unistr('\000a')||
'          WHEN perg_akt_version = 1 AND      -- akt. Antwortset und akt. ';

p:=p||'FB-Version'||unistr('\000a')||
'              :fas_pers_aenderbar = 1 AND   -- Pers.Daten änderbar'||unistr('\000a')||
'              --mn_rezept_id is not null      -- Rezept vorhanden'||unistr('\000a')||
'              frgbg_s.FB_CHECK_AUSWERTUNG(pergebnis_id)= 1 -- Auswertung vorhanden'||unistr('\000a')||
'          THEN                                             '||unistr('\000a')||
'                ''f?p=''||:APP_ID||'':1:''||:APP_SESSION||''::&DEBUG.:1,2,3,4,5,6,7,8,9,10,31,32,33,34,35,90,91,95:'''||unistr('\000a')||
' ';

p:=p||'               ||''P1_PERSON,P1_FRAGEBOGEN_ID,P1_FB_VERSION,P1_PERGEBNIS_ID,P1_BEARB_MODUS,P1_ZURUECK_ZUR_SEITE:'''||unistr('\000a')||
'                ||to_char(PERSONENSTAMM_ID)||'',''||to_char(trunc(FRAGEBOGEN_ID))||'','''||unistr('\000a')||
'                ||to_char(frgbg_s.fb_get_vers(fragebogen_id))||'','''||unistr('\000a')||
'                ||to_char(PERGEBNIS_ID)||'',ANZEIGEN,''||:APP_PAGE_ID     /* NEI 02.02.09 KOPIE entfernt */'||unistr('\000a')||
'          ELSE /* nur anzeigb';

p:=p||'are Version, da Vorgängerversion  */'||unistr('\000a')||
'                ''f?p=''||:APP_ID||'':1:''||:APP_SESSION||''::&DEBUG.:1,2,3,4,5,6,7,8,9,10,31,32,33,34,35,90,91,95:'''||unistr('\000a')||
'                ||''P1_PERSON,P1_FRAGEBOGEN_ID,P1_FB_VERSION,P1_PERGEBNIS_ID,P1_BEARB_MODUS,P1_ZURUECK_ZUR_SEITE:'''||unistr('\000a')||
'                ||to_char(PERSONENSTAMM_ID)||'',''||to_char(trunc(FRAGEBOGEN_ID))||'','''||unistr('\000a')||
'                ||to_char(frgbg_s.fb_get_vers(frageb';

p:=p||'ogen_id))||'','''||unistr('\000a')||
'                ||to_char(PERGEBNIS_ID)||'',ANZEIGEN,''||:APP_PAGE_ID'||unistr('\000a')||
'          END  LINK'||unistr('\000a')||
'          INTO :p323_FB_URL '||unistr('\000a')||
'       FROM v_fb_fas'||unistr('\000a')||
'       WHERE pergebnis_id = :p323_pergebnis_id'||unistr('\000a')||
'         and fragebogen_id = v_fragebogen_id'||unistr('\000a')||
'         and ((:fas_aufgerufen_von = ''BETREUER'' and '||unistr('\000a')||
'                (fbk_klasse_id = 1 or fbk_klasse_id is null) AND  -- alle FB´s'||unistr('\000a')||
'                 fb_typ';

p:=p||'_id in '||unistr('\000a')||
'                  /*(SELECT b.fb_typ_id'||unistr('\000a')||
'                     FROM fbtyp_betreuer b '||unistr('\000a')||
'                     WHERE b.persstamm_id_betreuer = :fas_login_personenstamm_id  '||unistr('\000a')||
'                     )*/'||unistr('\000a')||
'                  (SELECT b.fb_typ_id'||unistr('\000a')||
'                   FROM fbtyp_betreuer b '||unistr('\000a')||
'                   where b.persstamm_id_betreuer in ( '||unistr('\000a')||
'                         -- Definitionen der Identitaeten-Hierarc';

p:=p||'hie'||unistr('\000a')||
'                      select persstamm_id_identitaet         '||unistr('\000a')||
'                      from pers_identitaeten'||unistr('\000a')||
'                      start with persstamm_id_identitaet = :fas_identitaet_persstamm_id'||unistr('\000a')||
'                      connect by prior persstamm_id_oberidentitaet ='||unistr('\000a')||
'                                       persstamm_id_identitaet'||unistr('\000a')||
'                         UNION -- auch Definitionen vom Betreuer rele';

p:=p||'vant'||unistr('\000a')||
'                      SELECT to_number(:fas_login_personenstamm_id) from dual'||unistr('\000a')||
'                      )'||unistr('\000a')||
'                  )'||unistr('\000a')||
'                )'||unistr('\000a')||
'            OR'||unistr('\000a')||
'               (:fas_aufgerufen_von != ''BETREUER''and '||unistr('\000a')||
'                   (fbk_klasse_id = 1 or fbk_klasse_id is null) -- alle FB´s'||unistr('\000a')||
'               ) '||unistr('\000a')||
'             );'||unistr('\000a')||
'    end if;'||unistr('\000a')||
'    '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5549821906855887 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 100,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_fb_pergebnis_id_url',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'      v_return := frgbg_s.MAIL_BESTELLUNG '||unistr('\000a')||
'                  (NULL     --P_USER_ACCOUNT'||unistr('\000a')||
'                  ,:FAS_LOGIN_PERSONENSTAMM_ID    --P_PERSSTAMM_ID Frau Siegwart als Zieladresse'||unistr('\000a')||
'                  ,:p323_id --P_WARENKORB_ID '||unistr('\000a')||
'                  ,:FAS_LOGIN_PERSONENSTAMM_ID     --P_PERSSTAMM_ID_MAILABSENDER '||unistr('\000a')||
'                  ,0        --P_FLAG IN NUMBER kei';

p:=p||'ne Reply-Adresse'||unistr('\000a')||
'                  ,0        --P_NOTFALL_EMAIL'||unistr('\000a')||
'                 );'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5237618173946053 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'email_bestellblatt',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BUT_EMAIL_BESTELLBLATT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_return :=  labor_austausch.WK_LABOR_AUSTAUSCH_ANF(:p323_id); -- wk_id'||unistr('\000a')||
'              '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8429810519794599 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'analyseanforderung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>8429628265780753 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_mutdat         varchar2(50);'||unistr('\000a')||
'   v_fehlertext     varchar2(2000);'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'   v_sprache_id     number := :fas_sprache_id;'||unistr('\000a')||
''||unistr('\000a')||
'   v_count      number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/* Doku:'||unistr('\000a')||
'   apex_application.g_f21(v_count)        -- wk_id'||unistr('\000a')||
''||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :request = ''BUT_EINZELSTORNO'' THEN'||unistr('\000a')||
'      -- Details speichern'||unistr('\000a')||
'      for v_count in 1..apex_application.g_f01.count'||unistr('\000a')||
'   ';

p:=p||'   loop '||unistr('\000a')||
'/*MEL.P(''WK markiert f01 %1, ANZ: %2, WK: %3'',v_prot_id,''Info'',''102/320: upd_wk_status'',       apex_application.g_f01(v_count), apex_application.g_f01.count, :p323_id );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'            -- Speichern'||unistr('\000a')||
'            v_return := frgbg_s.WK_UPD_STATUS(NULL'||unistr('\000a')||
'                                          ,apex_application.g_f01(v_count)'||unistr('\000a')||
'                                          ,90'||unistr('\000a')||
'                 );'||unistr('\000a')||
'';

p:=p||'            IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                              apex_application.g_f01(v_count) '||unistr('\000a')||
'                             );'||unistr('\000a')||
'               RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'      end loop; '||unistr('\000a')||
'  /* ELSIF :request = ''BUT_KOMPLETTSTORNO'' THEN'||unistr('\000a')||
'      -- Speichern'||unistr('\000a')||
'      v_return := ';

p:=p||'frgbg_s.WK_UPD_STATUS(:p323_id'||unistr('\000a')||
'                                          ,NULL'||unistr('\000a')||
'                                          ,90'||unistr('\000a')||
'                 );'||unistr('\000a')||
'      IF v_return < 0 THEN -- FEHLER'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(5035,v_sprache_id,'||unistr('\000a')||
'                           apex_application.g_f01(v_count) '||unistr('\000a')||
'                          );'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
' ';

p:=p||'     END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5237831924946053 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'upd_wk_status',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BUT_EINZELSTORNO'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKOERBE:P323_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 5238029089946054 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of WARENKOERBE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process row of table WARENKOERBE.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> 'Action Processed.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'321';

wwv_flow_api.create_page_process(
  p_id     => 5238202218946054 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5230827536946003 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_return := frgbg_t.LAB_LABORDATEN_UEBERNEHMEN;'||unistr('\000a')||
'   IF v_return = 0 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Laborübernahme mit Fehler beendet!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6657205735733988 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'start_laboruebernahme',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>6657110263732416 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  -- Globale Variablen'||unistr('\000a')||
'    v_PROT_ID number;'||unistr('\000a')||
'    v_ERROR varchar2(32767);'||unistr('\000a')||
'    v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'    c_PROD constant varchar2(100) := ''App: '' || :APP_ID || '' Page: '''||unistr('\000a')||
'       || :APP_PAGE_ID ||'' Prozess Erstell und Download Rechnungsbeleg'';'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR EXCEPTION;'||unistr('\000a')||
'    c_ERRNR constant number := -20100;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR_D EXCEPTION;'||unistr('\000a')||
'    c_ERRNR_D constant ';

p:=p||'number := -20101;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
''||unistr('\000a')||
'    v_blob blob;'||unistr('\000a')||
'    v_mimetype varchar2(100) := ''application/octet'';'||unistr('\000a')||
'    v_size number;'||unistr('\000a')||
'    v_lastchange date;'||unistr('\000a')||
'    v_dateiname varchar2(1000);'||unistr('\000a')||
'    v_id number;'||unistr('\000a')||
''||unistr('\000a')||
'    v_warenkorb_id NUMBER;'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'    v_warenkorb_id := :P323_ID;'||unistr('\000a')||
''||unistr('\000a')||
'    begin'||unistr('\000a')||
'        v_blob  := FRGBG_T.LAB_CREATE_RECHNUNGSBELEG ('||unistr('\000a')||
'            p_warenkorb_id => v_warenkorb_';

p:=p||'id'||unistr('\000a')||
'        );'||unistr('\000a')||
'    exception'||unistr('\000a')||
'        when others then'||unistr('\000a')||
'            v_error := ''Fehler beim Erstellen des Rechnungsbelegs Warenkorb_id:'''||unistr('\000a')||
'                || v_warenkorb_id || ''. SQLERRM: '' || SQLERRM;'||unistr('\000a')||
'            v_errnr := -10;'||unistr('\000a')||
'            raise e_error;'||unistr('\000a')||
'    end;   '||unistr('\000a')||
''||unistr('\000a')||
'    if(v_blob is not null) then   '||unistr('\000a')||
'    '||unistr('\000a')||
'        v_size := dbms_lob.GETLENGTH(v_blob);'||unistr('\000a')||
'        v_lastchange := sysdate; '||unistr('\000a')||
'        v_datei';

p:=p||'name := ''Rechnungsbeleg_WK_'' || trim(to_char(v_warenkorb_id)) || ''.pdf'';'||unistr('\000a')||
'    '||unistr('\000a')||
'        -- Im HTTP-Header wird der Dateityp gesetzt. Damit erkennt der Browser'||unistr('\000a')||
'        -- welche Applikation (bspw. MS Word) zu starten ist'||unistr('\000a')||
'        owa_util.mime_header(NVL(v_mimetype,''application/octet''),false);'||unistr('\000a')||
''||unistr('\000a')||
'        -- Die Dateigröße wird dem Browser ebenfalls mitgeteilt'||unistr('\000a')||
'        htp.p(''Content-length:''|| v_size);'||unistr('\000a')||
''||unistr('\000a')||
'';

p:=p||'        -- Das Datum (LETZTE_AENDERUNG) wird ebenfalls als HTTP-Header gesetzt'||unistr('\000a')||
'        htp.p(''Date:''||to_char(v_lastchange,''Dy, DD Mon RRRR hh24:mi:ss'')||'' CET'');'||unistr('\000a')||
''||unistr('\000a')||
'        -- Der Parameter p_display steuert, ob die Datei direkt dargestellt oder'||unistr('\000a')||
'        -- ob dem Anwender ein Download-Dialog angeboten werden soll. Wie man sehen'||unistr('\000a')||
'        -- kann, richtet sich der Browser nach den Feldern im HTTP Head';

p:=p||'er.'||unistr('\000a')||
'        htp.p(''Content-Disposition: attachment; filename="''||v_dateiname || ''"'');'||unistr('\000a')||
''||unistr('\000a')||
'        -- Der Browser soll die Datei unter keinen Umständen aus dem Cache holen.'||unistr('\000a')||
'        htp.p(''Cache-Control: must-revalidate, max-age=0'');'||unistr('\000a')||
'        htp.p(''Expires: Thu, 01 Jan 1970 01:00:00 CET'');'||unistr('\000a')||
''||unistr('\000a')||
'        -- Die Datei bekommt eine ID - damit kann der Browser sie eindeutig erkennen.'||unistr('\000a')||
'        --htp.p(''Etag: TAB_';

p:=p||'DATEIEN...''||v_id||''...''||to_char(v_lastchange, ''JHH24MISS''));'||unistr('\000a')||
''||unistr('\000a')||
'        -- Alle HTTP-Header-Felder sind gesetzt'||unistr('\000a')||
'        owa_util.http_header_close;'||unistr('\000a')||
''||unistr('\000a')||
'        -- Dieser kurze Aufruf führt den eigentlichen Datei-Download durch.'||unistr('\000a')||
'        wpg_docload.download_file(v_blob);'||unistr('\000a')||
''||unistr('\000a')||
'    else'||unistr('\000a')||
'        v_error := ''Es wurde kein Rechnungsbeleg erstellt.'';'||unistr('\000a')||
'        v_errnr := -10;'||unistr('\000a')||
'        raise e_error;'||unistr('\000a')||
'    end if;   ';

p:=p||''||unistr('\000a')||
''||unistr('\000a')||
'    -- Damit Apex nicht die Oberfläche darstellt'||unistr('\000a')||
'    apex_application.g_unrecoverable_error := true;'||unistr('\000a')||
'exception'||unistr('\000a')||
'    when e_ERROR then'||unistr('\000a')||
'       MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'    when e_ERROR_D then'||unistr('\000a')||
'       raise; -- Einfach du';

p:=p||'rchreichen'||unistr('\000a')||
'    when others then'||unistr('\000a')||
'       v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLERRM:'' || SQLERRM;'||unistr('\000a')||
'       MEL.P (c_PROD || '': '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 9162423303685251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 323,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Erstell und Download Rechnungsbeleg',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':REQUEST = ''ERSTELL_RECHNUNGSBELEG2'' AND frgbg_s.FB_CHECK_AUSWERTUNG(:P323_PERGEBNIS_ID) = 1 AND'||unistr('\000a')||
'frgbg_t.LAB_GET_FB_STATUS_WK(:P323_ID) = 1',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 323
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00324
prompt  ...PAGE 324: Laboranalysewerte
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 324
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Laboranalysewerte'
 ,p_step_title => 'Übernommene Laboranalysewerte'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Laboranalysewerte'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2884210922489435 + wwv_flow_api.g_id_offset
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150422123717'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT '||unistr('\000a')||
'  apex_item.checkbox(1,id) as row_selector,'||unistr('\000a')||
'  ID,'||unistr('\000a')||
'  ID id_disp ,'||unistr('\000a')||
'  AUFTRAG_ID,'||unistr('\000a')||
'  AUFTRAG_ID_INTERN,'||unistr('\000a')||
'  WARENKORB_DETAIL_ID ,'||unistr('\000a')||
'  GEBURTSDATUM ,'||unistr('\000a')||
'  EINGANGSDATUM ,'||unistr('\000a')||
'  ANALYSEKUERZEL ,'||unistr('\000a')||
'  ERGEBNISWERT,'||unistr('\000a')||
'  EINHEIT,'||unistr('\000a')||
'  REZEPTE.GET_BEZUG_EH_BEZ(BEZUG_EINHEIT_ID,:FAS_SPRACHE_ID) einheit_bez,'||unistr('\000a')||
'  ERGEBNISWERT_TEXT,'||unistr('\000a')||
'  ERGEBNISWERT_TEXT_ID ,'||unistr('\000a')||
'  frgbg_s.holen_uebersetzung(ERGEBNISWERT_TEXT_ID,:fas_sprache_id) ';

s:=s||'ERGEBNISWERT_TEXT_BEZ,'||unistr('\000a')||
'  WERTEBEREICH ,'||unistr('\000a')||
'  LABORSTATUS,'||unistr('\000a')||
'  AT_BEARB_DATUM ,'||unistr('\000a')||
'  CASE '||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=10 THEN ''übernommen'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=20 THEN ''nicht zuordenbar'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=30 THEN ''nicht angefordert'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=90 THEN ''fehlerhaft'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=91 THEN ''schwerer Fehler'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=95 THEN ''ausgesteuert'''||unistr('\000a')||
'     WHEN AT_BEA';

s:=s||'RB_STATUS is null THEN ''nicht bearbeitet'''||unistr('\000a')||
'     ELSE ''Fehler unbekannt'''||unistr('\000a')||
'   END at_bearb_status,'||unistr('\000a')||
'  AT_ERROR ,'||unistr('\000a')||
'  DATEINAME,'||unistr('\000a')||
'  AT_BEMERKUNG,'||unistr('\000a')||
'  AT_PERSANTWORT_ID ,'||unistr('\000a')||
'  ERFDAT ,'||unistr('\000a')||
'  ERFUSER ,'||unistr('\000a')||
'  MUTDAT ,'||unistr('\000a')||
'  MUTUSER ,'||unistr('\000a')||
'  SATZ_KENNZEICHEN '||unistr('\000a')||
'FROM v_labor_analysewerte'||unistr('\000a')||
'WHERE '||unistr('\000a')||
'satz_kennzeichen is null '||unistr('\000a')||
'and ('||unistr('\000a')||
'at_bearb_status in ('||unistr('\000a')||
'                 SELECT regexp_substr(:P324_BEARB_STATUS_LISTE, ''[^:]+'', 1, LEVEL) token'||unistr('\000a')||
'';

s:=s||'                 FROM dual'||unistr('\000a')||
'                 CONNECT BY LEVEL <= length(:P324_BEARB_STATUS_LISTE) - length(REPLACE(:P324_BEARB_STATUS_LISTE, '':'', '''')) + 1'||unistr('\000a')||
'                )'||unistr('\000a')||
'OR (instr(:P324_BEARB_STATUS_LISTE,''-1'') >0 and at_bearb_status is null)   -- Status nicht bearbeitet ausgewählt'||unistr('\000a')||
'OR (:P324_BEARB_STATUS_LISTE is NULL))                                      -- kein Status ausgewählt'||unistr('\000a')||
'             ';

s:=s||' ;'||unistr('\000a')||
'';

wwv_flow_api.create_page_plug (
  p_id=> 5515514697830681 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_plug_name=> 'Laboranalysewerte',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_header=> '<div style="overflow: auto; height: &P324_HEIGHT_LISTE.px; max-width: 1500px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'SELECT '||unistr('\000a')||
'  apex_item.checkbox(1,id) as row_selector,'||unistr('\000a')||
'  ID,'||unistr('\000a')||
'  ID id_disp ,'||unistr('\000a')||
'  AUFTRAG_ID,'||unistr('\000a')||
'  AUFTRAG_ID_INTERN,'||unistr('\000a')||
'  WARENKORB_DETAIL_ID ,'||unistr('\000a')||
'  GEBURTSDATUM ,'||unistr('\000a')||
'  EINGANGSDATUM ,'||unistr('\000a')||
'  ANALYSEKUERZEL ,'||unistr('\000a')||
'  ERGEBNISWERT,'||unistr('\000a')||
'  EINHEIT,'||unistr('\000a')||
'  REZEPTE.GET_BEZUG_EH_BEZ(BEZUG_EINHEIT_ID,:FAS_SPRACHE_ID) einheit_bez,'||unistr('\000a')||
'  ERGEBNISWERT_TEXT,'||unistr('\000a')||
'  ERGEBNISWERT_TEXT_ID ,'||unistr('\000a')||
'  frgbg_s.holen_uebersetzung(ERGEBNISWERT_TEXT_ID,:fas_sprache_id) ';

a1:=a1||'ERGEBNISWERT_TEXT_BEZ,'||unistr('\000a')||
'  WERTEBEREICH ,'||unistr('\000a')||
'  LABORSTATUS,'||unistr('\000a')||
'  AT_BEARB_DATUM ,'||unistr('\000a')||
'  CASE '||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=10 THEN ''übernommen'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=20 THEN ''nicht zuordenbar'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=30 THEN ''nicht angefordert'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=90 THEN ''fehlerhaft'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=91 THEN ''schwerer Fehler'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=95 THEN ''ausgesteuert'''||unistr('\000a')||
'     WHEN AT_BEA';

a1:=a1||'RB_STATUS is null THEN ''nicht bearbeitet'''||unistr('\000a')||
'     ELSE ''Fehler unbekannt'''||unistr('\000a')||
'   END at_bearb_status,'||unistr('\000a')||
'  AT_ERROR ,'||unistr('\000a')||
'  DATEINAME,'||unistr('\000a')||
'  AT_BEMERKUNG,'||unistr('\000a')||
'  AT_PERSANTWORT_ID ,'||unistr('\000a')||
'  ERFDAT ,'||unistr('\000a')||
'  ERFUSER ,'||unistr('\000a')||
'  MUTDAT ,'||unistr('\000a')||
'  MUTUSER ,'||unistr('\000a')||
'  SATZ_KENNZEICHEN '||unistr('\000a')||
'FROM v_labor_analysewerte'||unistr('\000a')||
'WHERE '||unistr('\000a')||
'satz_kennzeichen is null '||unistr('\000a')||
'and ('||unistr('\000a')||
'at_bearb_status in ('||unistr('\000a')||
'                 SELECT regexp_substr(:P324_BEARB_STATUS_LISTE, ''[^:]+'', 1, LEVEL) token'||unistr('\000a')||
'';

a1:=a1||'                 FROM dual'||unistr('\000a')||
'                 CONNECT BY LEVEL <= length(:P324_BEARB_STATUS_LISTE) - length(REPLACE(:P324_BEARB_STATUS_LISTE, '':'', '''')) + 1'||unistr('\000a')||
'                )'||unistr('\000a')||
'OR (instr(:P324_BEARB_STATUS_LISTE,''-1'') >0 and at_bearb_status is null)   -- Status nicht bearbeitet ausgewählt'||unistr('\000a')||
'OR (:P324_BEARB_STATUS_LISTE is NULL))                                      -- kein Status ausgewählt'||unistr('\000a')||
'             ';

a1:=a1||' ;'||unistr('\000a')||
'';

wwv_flow_api.create_worksheet(
  p_id=> 5515630770830681+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_region_id=> 5515514697830681+wwv_flow_api.g_id_offset,
  p_name=> 'Laboranalysewerte',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '1000',
  p_max_row_count_message=> 'Die Anfrage umfasst mehr als #MAX_ROW_COUNT# Datensätze. Bitte schränken Sie ihre Anfrage ein, um ein vollständiges Ergebnis sicherzustellen!',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'Y',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y',
  p_pagination_display_pos=>'TOP_AND_BOTTOM_LEFT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'N',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'Y',
  p_show_highlight=>'Y',
  p_show_computation=>'Y',
  p_show_aggregate=>'Y',
  p_show_chart=>'Y',
  p_show_group_by=>'Y',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'Y',
  p_show_reset=>'Y',
  p_show_download=>'Y',
  p_show_help=>'Y',
  p_download_formats=>'CSV:HTML:EMAIL',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'BRIGITTE.NEIDHART',
  p_internal_uid=> 1);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5515806294830684+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ROW_SELECTOR',
  p_display_order          =>1,
  p_column_identifier      =>'A',
  p_column_label           =>'<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />',
  p_report_label           =>'<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5515920383830685+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID',
  p_display_order          =>2,
  p_column_identifier      =>'B',
  p_column_label           =>'Id',
  p_report_label           =>'Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5516029196830685+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID_DISP',
  p_display_order          =>3,
  p_column_identifier      =>'C',
  p_column_label           =>'Id Disp',
  p_report_label           =>'Id Disp',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5516203561830685+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'AUFTRAG_ID',
  p_display_order          =>5,
  p_column_identifier      =>'E',
  p_column_label           =>'Auftrag Id',
  p_report_label           =>'Auftrag Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 8431407617484446+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'AUFTRAG_ID_INTERN',
  p_display_order          =>6,
  p_column_identifier      =>'AC',
  p_column_label           =>'Auftrag Id Intern',
  p_report_label           =>'Auftrag Id Intern',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5516329170830685+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WARENKORB_DETAIL_ID',
  p_display_order          =>7,
  p_column_identifier      =>'F',
  p_column_label           =>'WK-Detail Id',
  p_report_label           =>'WK-Detail Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5516402788830686+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'GEBURTSDATUM',
  p_display_order          =>8,
  p_column_identifier      =>'G',
  p_column_label           =>'Geb.datum',
  p_report_label           =>'Geb.datum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5516506423830686+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EINGANGSDATUM',
  p_display_order          =>9,
  p_column_identifier      =>'H',
  p_column_label           =>'Eingang',
  p_report_label           =>'Eingang',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5516618151830686+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ANALYSEKUERZEL',
  p_display_order          =>10,
  p_column_identifier      =>'I',
  p_column_label           =>'Kürzel',
  p_report_label           =>'Kürzel',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5516732611830686+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERGEBNISWERT',
  p_display_order          =>11,
  p_column_identifier      =>'J',
  p_column_label           =>'Wert',
  p_report_label           =>'Wert',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_format_mask            =>'FM9999990D000',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5516819333830686+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EINHEIT',
  p_display_order          =>12,
  p_column_identifier      =>'K',
  p_column_label           =>'EH-Code',
  p_report_label           =>'EH-Code',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5516924933830686+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EINHEIT_BEZ',
  p_display_order          =>13,
  p_column_identifier      =>'L',
  p_column_label           =>'EH-Kürzel',
  p_report_label           =>'EH-Kürzel',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517014947830687+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERGEBNISWERT_TEXT',
  p_display_order          =>14,
  p_column_identifier      =>'M',
  p_column_label           =>'Erg. Text',
  p_report_label           =>'Erg. Text',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517110401830687+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERGEBNISWERT_TEXT_ID',
  p_display_order          =>15,
  p_column_identifier      =>'N',
  p_column_label           =>'Text Id',
  p_report_label           =>'Text Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517231984830687+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERGEBNISWERT_TEXT_BEZ',
  p_display_order          =>16,
  p_column_identifier      =>'O',
  p_column_label           =>'Text Bez',
  p_report_label           =>'Text Bez',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517327583830687+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WERTEBEREICH',
  p_display_order          =>17,
  p_column_identifier      =>'P',
  p_column_label           =>'Normbereich',
  p_report_label           =>'Normbereich',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517418433830687+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'LABORSTATUS',
  p_display_order          =>18,
  p_column_identifier      =>'Q',
  p_column_label           =>'Lab.Status',
  p_report_label           =>'Lab.Status',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517504911830688+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'AT_BEARB_DATUM',
  p_display_order          =>19,
  p_column_identifier      =>'R',
  p_column_label           =>'Bearb.Datum',
  p_report_label           =>'Bearb.Datum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517610028830688+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'AT_BEARB_STATUS',
  p_display_order          =>20,
  p_column_identifier      =>'S',
  p_column_label           =>'Bearb.Status',
  p_report_label           =>'Bearb.Status',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517711755830688+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'AT_ERROR',
  p_display_order          =>21,
  p_column_identifier      =>'T',
  p_column_label           =>'Fehlertext',
  p_report_label           =>'Fehlertext',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'LEFT',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517803315830688+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'DATEINAME',
  p_display_order          =>22,
  p_column_identifier      =>'U',
  p_column_label           =>'Dateiname',
  p_report_label           =>'Dateiname',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5517911340830688+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'AT_BEMERKUNG',
  p_display_order          =>23,
  p_column_identifier      =>'V',
  p_column_label           =>'Bemerkung',
  p_report_label           =>'Bemerkung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5518009251830689+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'AT_PERSANTWORT_ID',
  p_display_order          =>24,
  p_column_identifier      =>'W',
  p_column_label           =>'Persantwort Id',
  p_report_label           =>'Persantwort Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5518120284830689+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERFDAT',
  p_display_order          =>25,
  p_column_identifier      =>'X',
  p_column_label           =>'Erfdat',
  p_report_label           =>'Erfdat',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5518209202830689+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERFUSER',
  p_display_order          =>26,
  p_column_identifier      =>'Y',
  p_column_label           =>'Erfuser',
  p_report_label           =>'Erfuser',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5518312323830689+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'MUTDAT',
  p_display_order          =>27,
  p_column_identifier      =>'Z',
  p_column_label           =>'Mutdat',
  p_report_label           =>'Mutdat',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5518400959830689+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'MUTUSER',
  p_display_order          =>28,
  p_column_identifier      =>'AA',
  p_column_label           =>'Mutuser',
  p_report_label           =>'Mutuser',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5518527232830689+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'SATZ_KENNZEICHEN',
  p_display_order          =>29,
  p_column_identifier      =>'AB',
  p_column_label           =>'Satz Kennzeichen',
  p_report_label           =>'Satz Kennzeichen',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'ROW_SELECTOR:ID:AUFTRAG_ID:AUFTRAG_ID_INTERN:GEBURTSDATUM:EINGANGSDATUM:ANALYSEKUERZEL:ERGEBNISWERT:EINHEIT:EINHEIT_BEZ:ERGEBNISWERT_TEXT:ERGEBNISWERT_TEXT_ID:ERGEBNISWERT_TEXT_BEZ:WERTEBEREICH:LABORSTATUS:AT_BEARB_STATUS:AT_ERROR:AT_BEARB_DATUM:DATEINAME:AT_BEMERKUNG:AT_PERSANTWORT_ID:ERFDAT:ERFUSER:MUTDAT:MUTUSER:SATZ_KENNZEICHEN:';

wwv_flow_api.create_worksheet_rpt(
  p_id => 5518615736830975+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_worksheet_id => 5515630770830681+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'55187',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>100000,
  p_report_columns          =>rc1,
  p_sort_column_1           =>'ID',
  p_sort_direction_1        =>'DESC',
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5519226526988386 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10254617639752658 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 324,
  p_plug_name=> 'Schnellverweis',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 5,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5529915450158219 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 324,
  p_button_sequence=> 20,
  p_button_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_RESET_ERROR',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Fehler zurücksetzen',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5531116021224614 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 324,
  p_button_sequence=> 30,
  p_button_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_ACCEPT_ERROR',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Fehler aussteuern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5532600895428454 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 324,
  p_button_sequence=> 40,
  p_button_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_GEBURTSDATUM_ANPASSEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Geburtsdatum anpassen',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18531513699780319 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 324,
  p_button_sequence=> 50,
  p_button_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_FB_WK',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'FB-WK-Info',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8484405339745206 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 324,
  p_button_sequence=> 60,
  p_button_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_ZUR_SCHNITTSTELLE',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zur Labor-Schnittstelle',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:326:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5520112636031690 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 324,
  p_button_sequence=> 10,
  p_button_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P324_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5538828410140625 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 324,
  p_button_sequence=> 50,
  p_button_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_LABORUEBERNAHME',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Laborübernahme',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>18532301324971708 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_branch_name=> 'fb_wk_info',
  p_branch_action=> 'f?p=&APP_ID.:329:&SESSION.::&DEBUG.:329:P329_ID:&P324_LAB_AUFTRAG_ID_CHECKED.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>18531513699780319+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5520508958040049 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_HEIGHT_LISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5520720386043408 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '130',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5522608863100944 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_BEARB_STATUS_LISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5525101992482564 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_BEARB_STATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bearb Status',
  p_post_element_text=>'&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_CHECKBOX',
  p_lov=> 'SELECT ''übernommen'' a    ,  10 b FROM DUAL UNION'||unistr('\000a')||
'SELECT ''nicht zuordenbar'',  20  FROM dual UNION'||unistr('\000a')||
'SELECT ''nicht angefordert'', 30  FROM dual UNION'||unistr('\000a')||
'SELECT ''fehlerhaft''       , 90  FROM dual UNION'||unistr('\000a')||
'SELECT ''schwerer Fehler''  , 91  FROM dual UNION'||unistr('\000a')||
'SELECT ''ausgesteuert''     , 95  FROM dual UNION'||unistr('\000a')||
'SELECT ''nicht bearbeitet'', -1   FROM dual'||unistr('\000a')||
'order by 2',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '7',
  p_show_quick_picks=>'N',
  p_item_comment => 'HTML-Form-Elements-Attribute enthält nicht mehr onclick="javascript:apex.submit()" , dadurch wird nicht mehr sofort gesucht. Ist bei langen Listen nicht bedienerfreundlich, wenn man mehreres umclicken will ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5528606736051607 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_BEARB_STATUS_INIT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5532211799393705 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 8,
  p_item_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Geburtsdatum',
  p_format_mask=>'DD.MM.RRRR',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 15,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5628706954664284 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'SUCHEN',
  p_source=>'SUCHEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'RIGHT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10254830880752658 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_QUICKMENU',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 10254617639752658+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Schnellverweis:',
  p_source=>'select'||unistr('\000a')||
''||unistr('\000a')||
' listagg(''<a href="javascript:redirect('''''' ||'||unistr('\000a')||
'    frgbg_t.PREPARE_URL(URL) || '''''');">'' || BEZEICHNUNG || ''</a>'','' | '')'||unistr('\000a')||
'    within group (order by SORTIERUNG)'||unistr('\000a')||
' from FAS_APP_MENUS'||unistr('\000a')||
'where'||unistr('\000a')||
'  FAS_APP_MENU_ID in(select FAS_APP_MENU_ID from FAS_APP_MENUS where app_id = :APP_ID and page_id = :APP_PAGE_ID)',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18531813752798821 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_LAB_AUFTRAG_ID_CHECKED',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'checked',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18555003909704930 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 324,
  p_name=>'P324_HINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 5515514697830681+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5532423358406518 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 324,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P324_GEBURTSDATUM',
  p_validation_sequence=> 10,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P324_GEBURTSDATUM IS NULL THEN'||unistr('\000a')||
'      RETURN ''Das Geburtsdatum muss angegeben werden, wenn Sie das Geburtsdatum in der Laborübernahme korrigieren wollen!'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Check Geburtsdatum'||unistr('\000a')||
'   :P324_GEBURTSDATUM := '||unistr('\000a')||
'         to_char(to_date(:P324_GEBURTSDATUM,''DD.MM.RRRR''),''DD.MM.RRRR'');'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(HTMLDB_LANG.MESSAGE(''DATUM_UNGUELTIG''));'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,''Geburtsdatum''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 5532600895428454 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_associated_item=> 5532211799393705 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'   v_rec_labor_analysewerte  labor_analysewerte%ROWTYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Hier wird satzweise eine fehlerhafte FB-Laborübernahme auf unbearbeitet, dh. at_bearb_status = NULL gesetzt'||unistr('\000a')||
'   -- Soll ein ganzer Auftrag zurückgesetzt werden, muss das über die Markierung aller Positionen des Auftrags durchgeführt werden'||unistr('\000a')||
'   FOR i in 1..apex_application.g_f01.count'||unistr('\000a')||
'   LOOP'||unistr('\000a')||
'      --';

p:=p||'mel.p(''reset_error:%1,%2'',v_prot_id,''TEST'',''102/324: reset_error'', apex_application.g_f01(i));'||unistr('\000a')||
'      SELECT * into v_rec_labor_analysewerte'||unistr('\000a')||
'      FROM labor_analysewerte'||unistr('\000a')||
'      WHERE id = apex_application.g_f01(i);'||unistr('\000a')||
'--      mel.p(''reset_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_error'', '||unistr('\000a')||
'--            apex_application.g_f01(i), '||unistr('\000a')||
'--            v_rec_labor_analysewerte.auftrag_id);';

p:=p||''||unistr('\000a')||
'      IF v_rec_labor_analysewerte.at_bearb_status in (90,91,20) THEN'||unistr('\000a')||
'         mel.p(''reset_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_error'', '||unistr('\000a')||
'                apex_application.g_f01(i), v_rec_labor_analysewerte.auftrag_id); '||unistr('\000a')||
'         UPDATE labor_analysewerte'||unistr('\000a')||
'         SET at_bearb_status = NULL,'||unistr('\000a')||
'             at_error= null,'||unistr('\000a')||
'             at_persantwort_id = null,'||unistr('\000a')||
'             a';

p:=p||'t_bemerkung = null'||unistr('\000a')||
'         WHERE at_bearb_status in (90,91,20)'||unistr('\000a')||
'           AND id = apex_application.g_f01(i);        '||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5529613540119836 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 324,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'reset_error',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>5529915450158219 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'   v_rec_labor_analysewerte  labor_analysewerte%ROWTYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Hier wird satzweise eine fehlerhafte FB-Laborübernahme auf ausgesteuert gesetzt, dh. at_bearb_status = 95 gesetzt'||unistr('\000a')||
'   -- Soll ein ganzer Auftrag ausgesteuert werden, muss das über die Markierung aller Positionen des Auftrags durchgeführt werden'||unistr('\000a')||
'   FOR i in 1..apex_application.g_f01.count'||unistr('\000a')||
'   LOOP'||unistr('\000a')||
'   ';

p:=p||'   --mel.p(''reset_error:%1,%2'',v_prot_id,''TEST'',''102/324: reset_error'', apex_application.g_f01(i));'||unistr('\000a')||
'      SELECT * into v_rec_labor_analysewerte'||unistr('\000a')||
'      FROM labor_analysewerte'||unistr('\000a')||
'      WHERE id = apex_application.g_f01(i);'||unistr('\000a')||
'--      mel.p(''accept_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_error'', '||unistr('\000a')||
'--            apex_application.g_f01(i), '||unistr('\000a')||
'--            v_rec_labor_analysewerte.auftra';

p:=p||'g_id);'||unistr('\000a')||
'      IF v_rec_labor_analysewerte.at_bearb_status in (90,91) THEN'||unistr('\000a')||
'         mel.p(''accept_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_error'', '||unistr('\000a')||
'                apex_application.g_f01(i), v_rec_labor_analysewerte.auftrag_id); '||unistr('\000a')||
'         UPDATE labor_analysewerte'||unistr('\000a')||
'         SET at_bearb_status = 95'||unistr('\000a')||
'         WHERE at_bearb_status in (90,91)'||unistr('\000a')||
'           AND id = apex_application.g_';

p:=p||'f01(i);        '||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5531224332227066 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 324,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'accept_error',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>5531116021224614 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'   v_rec_labor_analysewerte  v_labor_analysewerte%ROWTYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Hier wird aus dem ersten markiertem Datensatz einer fehlerhaften FB-Laborübernahme oder'||unistr('\000a')||
'   -- eines noch nicht beararbeiteten Datensatzes, die Auftrags_id des Labors ermittelt und '||unistr('\000a')||
'   -- für alle Sätze des Auftrags mit Fehlerflag das Geburtsdatum auf das angegebene Datum korrigiert und'||unistr('\000a')||
'   -- der ';

p:=p||'Laborübernahmesatz zurückgesetzt, dh. at_bearb_status = NULL gesetzt'||unistr('\000a')||
'   -- Alle übrigen markierten Sätze werden ignoriert.'||unistr('\000a')||
'   IF apex_application.g_f01.count > 1 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,''Es darf nur ein Datensatz des Laborauftrags markiert sein!'');'||unistr('\000a')||
'   ELSIF  apex_application.g_f01.count = 0 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,''Es muss ein Datensatz des Laborauftrags markier';

p:=p||'t sein!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   FOR i in 1..apex_application.g_f01.count'||unistr('\000a')||
'   LOOP'||unistr('\000a')||
'      --mel.p(''reset_error:%1,%2'',v_prot_id,''TEST'',''102/324: reset_error'', apex_application.g_f01(i));'||unistr('\000a')||
'      SELECT * into v_rec_labor_analysewerte'||unistr('\000a')||
'      FROM v_labor_analysewerte'||unistr('\000a')||
'      WHERE id = apex_application.g_f01(i);'||unistr('\000a')||
'     mel.p(''reset_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_error'', '||unistr('\000a')||
'            ';

p:=p||'apex_application.g_f01(i), '||unistr('\000a')||
'            v_rec_labor_analysewerte.auftrag_id);'||unistr('\000a')||
'      IF v_rec_labor_analysewerte.at_bearb_status in (90,91) or  '||unistr('\000a')||
'         v_rec_labor_analysewerte.at_bearb_status is null THEN'||unistr('\000a')||
'         mel.p(''reset_geburtsdatum_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_geburtsdatum_error'', '||unistr('\000a')||
'                apex_application.g_f01(i), v_rec_labor_analysewerte.auftr';

p:=p||'ag_id); '||unistr('\000a')||
'         UPDATE labor_analysewerte'||unistr('\000a')||
'         SET at_bearb_status = NULL,'||unistr('\000a')||
'             at_error= null,'||unistr('\000a')||
'             at_persantwort_id = null,'||unistr('\000a')||
'             at_bemerkung = null,'||unistr('\000a')||
'             geburtsdatum = to_char(to_date(:P324_GEBURTSDATUM,''DD.MM.RRRR''),''DD.MM.RRRR'')'||unistr('\000a')||
'         WHERE '||unistr('\000a')||
'           (auftrag_id = v_rec_labor_analysewerte.auftrag_id or '||unistr('\000a')||
'           auftrag_id_intern = v_rec_labor_an';

p:=p||'alysewerte.auftrag_id_intern'||unistr('\000a')||
'           )AND LABOR_ANALYSEKUERZEL_ID in('||unistr('\000a')||
'                select ID '||unistr('\000a')||
'                FROM LABOR_ANALYSEKUERZEL '||unistr('\000a')||
'                where labor_id = v_rec_labor_analysewerte.labor_id and satz_kennzeichen is null'||unistr('\000a')||
'           )'||unistr('\000a')||
'            --labor_id = v_rec_labor_analysewerte.labor_id'||unistr('\000a')||
'           AND (at_bearb_status in (90,91) or at_bearb_status is null)     -- Es sollen j';

p:=p||'a nur die noch nicht bearbeiteten Sätze verändert werden bzw. fehlerhafte'||unistr('\000a')||
'           ;                                                               -- evt. bereits übernommene dürfen nicht mehr verändert werden (sollte es auch nicht geben)'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR(-20001,''Der Datensatz des Laborauftrags darf noch nicht bearbeitet sein oder muss einen Fehlerstatus haben!'');     ';

p:=p||'    '||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5536017431919799 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 324,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'reset_geburtsdatum_error',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>5532600895428454 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_return := frgbg_t.LAB_LABORDATEN_UEBERNEHMEN;'||unistr('\000a')||
'   IF v_return = 0 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Laborübernahme mit Fehler beendet!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5539330273150572 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 324,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'start_laboruebernahme',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>5538828410140625 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   i            number;'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'   v_rec_labor_analysewerte  v_labor_analysewerte%ROWTYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Hier wird aus dem ersten markiertem Datensatz einer fehlerhaften FB-Laborübernahme oder'||unistr('\000a')||
'   -- eines noch nicht beararbeiteten Datensatzes, die Auftrags_id des Labors ermittelt '||unistr('\000a')||
'   -- Mit diesen Laborauftrag wird schliesslich in die fb-wk_info-Maske verzweigt,'||unistr('\000a')||
'   -- um ggf.';

p:=p||' die pergebnis-id in den mit dem FB verbundenen Warenkörbe zu ändern'||unistr('\000a')||
'   -- Alle übrigen markierten Sätze werden ignoriert.'||unistr('\000a')||
'   :P324_LAB_AUFTRAG_ID_CHECKED:= null;'||unistr('\000a')||
'   :p324_hinweis := null;'||unistr('\000a')||
'   IF apex_application.g_f01.count > 1 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,''Es darf nur ein Datensatz des Laborauftrags markiert sein!'');'||unistr('\000a')||
'   ELSIF  apex_application.g_f01.count = 0 THEN'||unistr('\000a')||
'      RAISE_APPLICA';

p:=p||'TION_ERROR(-20001,''Es muss ein Datensatz des Laborauftrags markiert sein!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   i:= 1;'||unistr('\000a')||
'--mel.p(''reset_error:%1,%2'',v_prot_id,''TEST'',''102/324: reset_error'', apex_application.g_f01(i));'||unistr('\000a')||
'   SELECT * into v_rec_labor_analysewerte'||unistr('\000a')||
'   FROM v_labor_analysewerte'||unistr('\000a')||
'   WHERE id = apex_application.g_f01(i);'||unistr('\000a')||
'-- mel.p(''reset_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_error'', apex_a';

p:=p||'pplication.g_f01(i),           v_rec_labor_analysewerte.auftrag_id);'||unistr('\000a')||
'   IF v_rec_labor_analysewerte.AUFTRAG_ID_INTERN is NULL THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,''Der Datensatz des Laborauftrags (''||v_rec_labor_analysewerte.AUFTRAG_ID||'') hat keine Auftrag-ID-intern definiert!'');         '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_rec_labor_analysewerte.at_bearb_status in (90,91) or  '||unistr('\000a')||
'      v_rec_labor_analysewert';

p:=p||'e.at_bearb_status is null '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'--mel.p(''reset_geburtsdatum_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_geburtsdatum_error'', apex_application.g_f01(i), v_rec_labor_analysewerte.auftrag_id); '||unistr('\000a')||
'      :P324_LAB_AUFTRAG_ID_CHECKED:= apex_application.g_f01(i);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,''Der Datensatz des Laborauftrags (''||v_rec_labor_analysewerte.AUFTRAG_ID||'') d';

p:=p||'arf noch nicht bearbeitet sein oder muss einen Fehlerstatus haben!'');         '||unistr('\000a')||
'   END IF; '||unistr('\000a')||
'  '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 18531926428802912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 324,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_lab_auftrag_id_checked',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>18531513699780319 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Komplette Höhe ausnutzen (100% des Maximums)'||unistr('\000a')||
'   :P324_HEIGHT_liste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5520219909033828 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 324,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF :P324_BEARB_STATUS_INIT is not null THEN'||unistr('\000a')||
'      :P324_BEARB_STATUS := ''90:91'' ;'||unistr('\000a')||
'      :P324_BEARB_STATUS_INIT := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :P324_BEARB_STATUS_LISTE:=:P324_BEARB_STATUS;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5522727909106445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 324,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_bearb_status_liste',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'P324_BEARB_STATUS',
  p_process_when_type=>'',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :p324_hinweis is not null THEN'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''alert("''||:p324_hinweis||''");'');'||unistr('\000a')||
'      :p324_hinweis := NULL;'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 18554704959699763 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 324,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fehlerausgabe',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 324
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00325
prompt  ...PAGE 325: Umsatzliste
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 325
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Umsatzliste'
 ,p_step_title => 'Umsatzliste'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Umsatzliste'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20121029114126'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT wk.id WK_ID, wk.PERSSTAMM_ID_IDENTITAET ARZT_BETREUER,'||unistr('\000a')||
'      iab.user_account ,'||unistr('\000a')||
'      (SELECT min(persstamm_id_werber) from pers_provisionen where persstamm_id =wk.PERSSTAMM_ID_IDENTITAET) WERBER,'||unistr('\000a')||
'      wk.PERSSTAMM_ID_KUNDE  KUNDE_FAS_ID,frgbg_s.GET_PERS_NAME(wk.PERSSTAMM_ID_KUNDE) KUNDE,'||unistr('\000a')||
'      rezepte.GET_WAEHRUNG_ZEICHEN(wk.WAEHRUNG_ID)'||unistr('\000a')||
'      WAEHRUNG,wk.PLANDATUM BESTELLT,wk.WK_STATUS_I';

s:=s||'D WK_STATUS,wk.STATUS_AENDERDATUM LETZTE_STATUSAENDERUNG,'||unistr('\000a')||
'      wkd.id WK_DETAIL_ID,--NVL(wkd.mengenart_id,102) ARTIKEL,'||unistr('\000a')||
'      (select xm.kuerzel from mengenarts xm where xm.ID = NVL(wkd.mengenart_id,102)) ARTNR,'||unistr('\000a')||
'      (select ym.bezeichnung from mengenarts ym  where ym.ID = NVL(wkd.mengenart_id,102)) ARTBEZ,'||unistr('\000a')||
'      wkd.menge MENGE,wkd.preis EINZELPREIS,'||unistr('\000a')||
'      wkd.menge * wkd.preis GESAMTPREIS,'||unistr('\000a')||
'   ';

s:=s||'   wkd.wk_status_id WK_DETAIL_STATUS'||unistr('\000a')||
'FROM warenkoerbe wk, warenkorb_details wkd, personenstamm iab'||unistr('\000a')||
'WHERE --wk.provisionskopf_id is null'||unistr('\000a')||
'         --AND wk.wk_status_id >= 10   -- bestellt und bezahlt'||unistr('\000a')||
'         --AND wk.wk_status_id < 90    -- nicht storniert od. geloescht'||unistr('\000a')||
'         --AND wk.plandatum <= :v_bis_stichtag'||unistr('\000a')||
'         --AND'||unistr('\000a')||
'         iab.id = wk.persstamm_id_identitaet and'||unistr('\000a')||
'         wk.id = w';

s:=s||'kd.WARENKORB_ID     -- Join WK/wkdet'||unistr('\000a')||
'         AND (wkd.mengenart_id is NULL OR wkd.mengenart_id <> 101) --Keine Versandkostenpositionen'||unistr('\000a')||
'         and persstamm_id_identitaet in   -- alle Blattidentitaeten unterhalb der Vorgabeidentitaet'||unistr('\000a')||
'                                        ( select persstamm_id_identitaet'||unistr('\000a')||
'                                          FROM pers_identitaeten'||unistr('\000a')||
'                          ';

s:=s||'                WHERE persstamm_id_identitaet in'||unistr('\000a')||
'                                               ( -- Blattident unterhalb Vorgabeident'||unistr('\000a')||
'                                                 select'||unistr('\000a')||
'                                                   persstamm_id_identitaet                -- Ident unterhalb der Vorgabeident'||unistr('\000a')||
'                                                 from pers_identitaeten'||unistr('\000a')||
'           ';

s:=s||'                                      where persstamm_id_identitaet not in'||unistr('\000a')||
'                                                              (SELECT'||unistr('\000a')||
'                                                                  persstamm_id_oberidentitaet -- Nur Blattident sind relevant'||unistr('\000a')||
'                                                               from pers_identitaeten'||unistr('\000a')||
'                                           ';

s:=s||'                    where persstamm_id_oberidentitaet is not null'||unistr('\000a')||
'                                                              )'||unistr('\000a')||
'                                                 start with persstamm_id_identitaet = :p325_persstamm_id_vorgabeident'||unistr('\000a')||
'                                                 connect by prior  persstamm_id_identitaet=persstamm_id_oberidentitaet'||unistr('\000a')||
'                                 ';

s:=s||'              )'||unistr('\000a')||
'                                        )'||unistr('\000a')||
'       ;';

wwv_flow_api.create_page_plug (
  p_id=> 5655830177087189 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_plug_name=> 'Umsatzliste',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'SELECT wk.id WK_ID, wk.PERSSTAMM_ID_IDENTITAET ARZT_BETREUER,'||unistr('\000a')||
'      iab.user_account ,'||unistr('\000a')||
'      (SELECT min(persstamm_id_werber) from pers_provisionen where persstamm_id =wk.PERSSTAMM_ID_IDENTITAET) WERBER,'||unistr('\000a')||
'      wk.PERSSTAMM_ID_KUNDE  KUNDE_FAS_ID,frgbg_s.GET_PERS_NAME(wk.PERSSTAMM_ID_KUNDE) KUNDE,'||unistr('\000a')||
'      rezepte.GET_WAEHRUNG_ZEICHEN(wk.WAEHRUNG_ID)'||unistr('\000a')||
'      WAEHRUNG,wk.PLANDATUM BESTELLT,wk.WK_STATUS_I';

a1:=a1||'D WK_STATUS,wk.STATUS_AENDERDATUM LETZTE_STATUSAENDERUNG,'||unistr('\000a')||
'      wkd.id WK_DETAIL_ID,--NVL(wkd.mengenart_id,102) ARTIKEL,'||unistr('\000a')||
'      (select xm.kuerzel from mengenarts xm where xm.ID = NVL(wkd.mengenart_id,102)) ARTNR,'||unistr('\000a')||
'      (select ym.bezeichnung from mengenarts ym  where ym.ID = NVL(wkd.mengenart_id,102)) ARTBEZ,'||unistr('\000a')||
'      wkd.menge MENGE,wkd.preis EINZELPREIS,'||unistr('\000a')||
'      wkd.menge * wkd.preis GESAMTPREIS,'||unistr('\000a')||
'   ';

a1:=a1||'   wkd.wk_status_id WK_DETAIL_STATUS'||unistr('\000a')||
'FROM warenkoerbe wk, warenkorb_details wkd, personenstamm iab'||unistr('\000a')||
'WHERE --wk.provisionskopf_id is null'||unistr('\000a')||
'         --AND wk.wk_status_id >= 10   -- bestellt und bezahlt'||unistr('\000a')||
'         --AND wk.wk_status_id < 90    -- nicht storniert od. geloescht'||unistr('\000a')||
'         --AND wk.plandatum <= :v_bis_stichtag'||unistr('\000a')||
'         --AND'||unistr('\000a')||
'         iab.id = wk.persstamm_id_identitaet and'||unistr('\000a')||
'         wk.id = w';

a1:=a1||'kd.WARENKORB_ID     -- Join WK/wkdet'||unistr('\000a')||
'         AND (wkd.mengenart_id is NULL OR wkd.mengenart_id <> 101) --Keine Versandkostenpositionen'||unistr('\000a')||
'         and persstamm_id_identitaet in   -- alle Blattidentitaeten unterhalb der Vorgabeidentitaet'||unistr('\000a')||
'                                        ( select persstamm_id_identitaet'||unistr('\000a')||
'                                          FROM pers_identitaeten'||unistr('\000a')||
'                          ';

a1:=a1||'                WHERE persstamm_id_identitaet in'||unistr('\000a')||
'                                               ( -- Blattident unterhalb Vorgabeident'||unistr('\000a')||
'                                                 select'||unistr('\000a')||
'                                                   persstamm_id_identitaet                -- Ident unterhalb der Vorgabeident'||unistr('\000a')||
'                                                 from pers_identitaeten'||unistr('\000a')||
'           ';

a1:=a1||'                                      where persstamm_id_identitaet not in'||unistr('\000a')||
'                                                              (SELECT'||unistr('\000a')||
'                                                                  persstamm_id_oberidentitaet -- Nur Blattident sind relevant'||unistr('\000a')||
'                                                               from pers_identitaeten'||unistr('\000a')||
'                                           ';

a1:=a1||'                    where persstamm_id_oberidentitaet is not null'||unistr('\000a')||
'                                                              )'||unistr('\000a')||
'                                                 start with persstamm_id_identitaet = :p325_persstamm_id_vorgabeident'||unistr('\000a')||
'                                                 connect by prior  persstamm_id_identitaet=persstamm_id_oberidentitaet'||unistr('\000a')||
'                                 ';

a1:=a1||'              )'||unistr('\000a')||
'                                        )'||unistr('\000a')||
'       ;';

wwv_flow_api.create_worksheet(
  p_id=> 5655900978087189+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_region_id=> 5655830177087189+wwv_flow_api.g_id_offset,
  p_name=> 'Umsatzliste',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '10000',
  p_max_row_count_message=> 'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'Y',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y',
  p_pagination_display_pos=>'TOP_AND_BOTTOM_RIGHT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'Y',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'Y',
  p_show_highlight=>'Y',
  p_show_computation=>'Y',
  p_show_aggregate=>'Y',
  p_show_chart=>'Y',
  p_show_group_by=>'Y',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'N',
  p_show_reset=>'Y',
  p_show_download=>'Y',
  p_show_help=>'Y',
  p_download_formats=>'CSV:HTML:EMAIL',
  p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />',
  p_allow_exclude_null_values=>'Y',
  p_allow_hide_extra_columns=>'Y',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'BRIGITTE.NEIDHART',
  p_internal_uid=> 1);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5656118913087201+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WK_ID',
  p_display_order          =>1,
  p_column_identifier      =>'A',
  p_column_label           =>'WK_ID',
  p_report_label           =>'WK_ID',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5656209760087204+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ARZT_BETREUER',
  p_display_order          =>2,
  p_column_identifier      =>'B',
  p_column_label           =>'ARZT_BETREUER',
  p_report_label           =>'ARZT_BETREUER',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5656326200087204+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'USER_ACCOUNT',
  p_display_order          =>3,
  p_column_identifier      =>'C',
  p_column_label           =>'USER_ACCOUNT',
  p_report_label           =>'USER_ACCOUNT',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5656419210087204+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WERBER',
  p_display_order          =>4,
  p_column_identifier      =>'D',
  p_column_label           =>'WERBER',
  p_report_label           =>'WERBER',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5656604386087204+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WAEHRUNG',
  p_display_order          =>6,
  p_column_identifier      =>'F',
  p_column_label           =>'WAEHRUNG',
  p_report_label           =>'WAEHRUNG',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5656715794087204+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'BESTELLT',
  p_display_order          =>7,
  p_column_identifier      =>'G',
  p_column_label           =>'BESTELLT',
  p_report_label           =>'BESTELLT',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5656800794087204+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WK_STATUS',
  p_display_order          =>8,
  p_column_identifier      =>'H',
  p_column_label           =>'WK_STATUS',
  p_report_label           =>'WK_STATUS',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5656929928087204+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'LETZTE_STATUSAENDERUNG',
  p_display_order          =>9,
  p_column_identifier      =>'I',
  p_column_label           =>'LETZTE_STATUSAENDERUNG',
  p_report_label           =>'LETZTE_STATUSAENDERUNG',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5657032460087206+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WK_DETAIL_ID',
  p_display_order          =>10,
  p_column_identifier      =>'J',
  p_column_label           =>'WK_DETAIL_ID',
  p_report_label           =>'WK_DETAIL_ID',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5657107093087206+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ARTNR',
  p_display_order          =>11,
  p_column_identifier      =>'K',
  p_column_label           =>'ARTIKEL',
  p_report_label           =>'ARTIKEL',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5657214256087206+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ARTBEZ',
  p_display_order          =>12,
  p_column_identifier      =>'L',
  p_column_label           =>'ARTIKELBEZ',
  p_report_label           =>'ARTIKELBEZ',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5657330730087206+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'MENGE',
  p_display_order          =>13,
  p_column_identifier      =>'M',
  p_column_label           =>'MENGE',
  p_report_label           =>'MENGE',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5657505688087206+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WK_DETAIL_STATUS',
  p_display_order          =>15,
  p_column_identifier      =>'O',
  p_column_label           =>'WK_DETAIL_STATUS',
  p_report_label           =>'WK_DETAIL_STATUS',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7897027012933609+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'KUNDE_FAS_ID',
  p_display_order          =>16,
  p_column_identifier      =>'P',
  p_column_label           =>'KUNDE',
  p_report_label           =>'KUNDE',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7897132118933611+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'KUNDE',
  p_display_order          =>17,
  p_column_identifier      =>'Q',
  p_column_label           =>'KUNDEBEZ',
  p_report_label           =>'KUNDEBEZ',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7897202843933612+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EINZELPREIS',
  p_display_order          =>18,
  p_column_identifier      =>'R',
  p_column_label           =>'EINZELPREIS',
  p_report_label           =>'EINZELPREIS',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 7897331592933612+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'GESAMTPREIS',
  p_display_order          =>19,
  p_column_identifier      =>'S',
  p_column_label           =>'PREIS',
  p_report_label           =>'PREIS',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'WK_ID:ARZT_BETREUER:USER_ACCOUNT:WERBER:KUNDE_FAS_ID:KUNDE:WAEHRUNG:BESTELLT:WK_STATUS:LETZTE_STATUSAENDERUNG:WK_DETAIL_ID:ARTNR:ARTBEZ:MENGE:EINZELPREIS:GESAMTPREIS:WK_DETAIL_STATUS';

wwv_flow_api.create_worksheet_rpt(
  p_id => 5657913226101620+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 325,
  p_worksheet_id => 5655900978087189+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'56580',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>15,
  p_report_columns          =>rc1,
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6078129453790925 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 325,
  p_button_sequence=> 10,
  p_button_plug_id => 5655830177087189+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P325_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6077821142788542 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 325,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P325_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:325::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6078129453790925+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>6030719869646248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 325,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:325:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 12-SEP-2012 08:41 by BRIGITTE.NEIDHART');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5657810455100836 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 325,
  p_name=>'P325_PERSSTAMM_ID_VORGABEIDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5655830177087189+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'frgbg_s.GET_IDENT_2OBERSTE'||unistr('\000a')||
' (:fas_IDENTITAET_PERSSTAMM_ID'||unistr('\000a')||
' ,:FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
')',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Vorgabeidentität',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.get_pers_name(PERSSTAMM_ID_identitaet)||'' (''||PERSSTAMM_ID_identitaet||'')'' a , PERSSTAMM_ID_identitaet b'||unistr('\000a')||
'from pers_identitaeten pi, personenstamm p '||unistr('\000a')||
'where persstamm_id_oberidentitaet in '||unistr('\000a')||
'      ('||unistr('\000a')||
'       select persstamm_id_identitaet'||unistr('\000a')||
'       from pers_identitaeten  '||unistr('\000a')||
'       where persstamm_id_oberidentitaet is null'||unistr('\000a')||
'      )'||unistr('\000a')||
'  and pi.PERSSTAMM_ID_identitaet = p.id'||unistr('\000a')||
'  and p.satzkennzeichen is null'||unistr('\000a')||
'order by 2',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6077713870786403 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 325,
  p_name=>'P325_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5655830177087189+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6078602704802114 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 325,
  p_name=>'P325_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5655830177087189+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p325_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
' '||unistr('\000a')||
'/*'||unistr('\000a')||
'   :P300_REGION_TITEL_KATEGORIE:=NULL;'||unistr('\000a')||
'   :p300_region_titel_artikel:= frgbg_s.holen_uebersetzung(4858,v_sprache_id);'||unistr('\000a')||
'   :p300_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :P300_REGION_TITEL_ADRESSE := frgbg_s.ho';

p:=p||'len_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   --:P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(1569,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_NV_WARENKORB := frgbg_s.holen_uebersetzung(3844,v_sprache_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6078216425796608 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 325,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 325
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00326
prompt  ...PAGE 326: Laborschnittstelle
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 326
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Laborschnittstelle'
 ,p_step_title => 'Laborschnittstelle'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141128075920'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||' select'||unistr('\000a')||
'"ID",'||unistr('\000a')||
'"ID" ID_DISPLAY,'||unistr('\000a')||
'(select KUERZEL from LABORS where ID ="LABOR_ID") LABOR,'||unistr('\000a')||
'"QUELLE",'||unistr('\000a')||
'CASE'||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=10 THEN ''übernommen'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=20 THEN ''nicht zuordenbar'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=30 THEN ''nicht angefordert'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=80 THEN ''keine interne Auftrags-ID'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=90 THEN ''fehlerhaft'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=91 THEN ';

s:=s||'''schwerer Fehler'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS=95 THEN ''ausgesteuert'''||unistr('\000a')||
'     WHEN AT_BEARB_STATUS is null THEN ''nicht bearbeitet'''||unistr('\000a')||
'     ELSE ''Fehler unbekannt'''||unistr('\000a')||
'   END "AT_BEARB_STATUS",'||unistr('\000a')||
'"AT_BEARB_DATUM",'||unistr('\000a')||
'''<div style="width:300px;">'' || FEHLERMELDUNG ||''</div>'' FEHLERMELDUNG,'||unistr('\000a')||
'"SPALTE01",'||unistr('\000a')||
'"SPALTE02",'||unistr('\000a')||
'"SPALTE03",'||unistr('\000a')||
'"SPALTE04",'||unistr('\000a')||
'"SPALTE05",'||unistr('\000a')||
'"SPALTE06",'||unistr('\000a')||
'"SPALTE07",'||unistr('\000a')||
'"SPALTE08",'||unistr('\000a')||
'"SPALTE09",'||unistr('\000a')||
'"SPALTE10",'||unistr('\000a')||
'"SPALTE11"';

s:=s||','||unistr('\000a')||
'"SPALTE12",'||unistr('\000a')||
'"SPALTE13",'||unistr('\000a')||
'"SPALTE14",'||unistr('\000a')||
'"SPALTE15",'||unistr('\000a')||
'"SPALTE16",'||unistr('\000a')||
'"SPALTE17",'||unistr('\000a')||
'"SPALTE18",'||unistr('\000a')||
'"SPALTE19",'||unistr('\000a')||
'"SPALTE20",'||unistr('\000a')||
'"SATZ_KENNZEICHEN",'||unistr('\000a')||
'"ERFDAT",'||unistr('\000a')||
'"ERFUSER",'||unistr('\000a')||
'"MUTDAT",'||unistr('\000a')||
'"MUTUSER"'||unistr('\000a')||
'from "LAB_ANALYSEDATEIEN_INHALTE"'||unistr('\000a')||
'where ((:P326_BEARB_STATUS_LISTE is NULL) '||unistr('\000a')||
'or to_char(at_bearb_status) in ('||unistr('\000a')||
'                 SELECT regexp_substr(:P326_BEARB_STATUS_LISTE, ''[^:]+'', 1, LEVEL) token'||unistr('\000a')||
'                 FROM dual'||unistr('\000a')||
'   ';

s:=s||'              CONNECT BY LEVEL <= length(:P326_BEARB_STATUS_LISTE) - length(REPLACE(:P326_BEARB_STATUS_LISTE, '':'', '''')) + 1'||unistr('\000a')||
'                )'||unistr('\000a')||
'OR (instr(:P326_BEARB_STATUS_LISTE,''-1'') >0 and at_bearb_status is null)   '||unistr('\000a')||
') '||unistr('\000a')||
'AND ('||unistr('\000a')||
'   :P326_SUCHTEXT is null or'||unistr('\000a')||
'   lower(QUELLE) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(FEHLERMELDUNG) like ''%'' || replace(lower(:P326_SUCHTEXT),';

s:=s||''' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE01) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE02) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE03) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE04) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE05) like ''%'' || replace(lower(:P326_SUCHTEXT),';

s:=s||''' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE06) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE07) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE08) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE09) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE10) like ''%'' || replace(lower(:P326_SUCHTEXT),';

s:=s||''' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE11) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE12) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE13) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE14) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE15) like ''%'' || replace(lower(:P326_SUCHTEXT),';

s:=s||''' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE16) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE17) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE18) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE19) like ''%'' || replace(lower(:P326_SUCHTEXT),'' '',''%'') || ''%'' or'||unistr('\000a')||
'   lower(SPALTE20) like ''%'' || replace(lower(:P326_SUCHTEXT),';

s:=s||''' '',''%'') || ''%'''||unistr('\000a')||
')'||unistr('\000a')||
'AND (:P326_LABOR_ID is null or LABOR_ID = :P326_LABOR_ID)'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 326,
  p_name=> 'Laborschnittstelle',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 35,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 15,
  p_query_headings=> 'return frgbg_s.HOLEN_UEBERSETZUNG(9996,:FAS_SPRACHE_ID)',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '20',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'No data found.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'TOP_AND_BOTTOM_LEFT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Print',
  p_prn_content_disposition=> 'ATTACHMENT',
  p_prn_document_header=> 'APEX',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width_units=> 'PERCENTAGE',
  p_prn_width=> 297,
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'CENTER',
  p_prn_page_footer_alignment=> 'CENTER',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8335720892402823 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8331101654402796 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8331210929402799 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID_DISPLAY',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'ID_DISPLAY',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8346522975426979 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'LABOR',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8331413099402799 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'QUELLE',
  p_column_display_sequence=> 28,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'QUELLE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8331513993402799 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'AT_BEARB_STATUS',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'AT_BEARB_STATUS',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8331607724402799 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'AT_BEARB_DATUM',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'AT_BEARB_DATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8331729673402799 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'FEHLERMELDUNG',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_report_column_width=> '300',
  p_column_width=> '16',
  p_cattributes=> 'style="width:300px !important;"',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'FEHLERMELDUNG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8331812272402799 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE01',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE01',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8331903829402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE02',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE02',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332014127402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE03',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE03',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332102714402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE04',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE04',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332201924402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE05',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE05',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332303937402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE06',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE06',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332408973402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE07',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE07',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332508183402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE08',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE08',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332625802402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE09',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE09',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332731842402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE10',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE10',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332806296402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE11',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE11',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8332903252402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE12',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE12',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333028393402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE13',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '5',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE13',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333128221402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE14',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE14',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333229052402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE15',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE15',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333311880402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE16',
  p_column_display_sequence=> 23,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE16',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333423498402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE17',
  p_column_display_sequence=> 24,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE17',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333527840402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE18',
  p_column_display_sequence=> 25,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE18',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333619678402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 27,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE19',
  p_column_display_sequence=> 26,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE19',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333706620402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 28,
  p_form_element_id=> null,
  p_column_alias=> 'SPALTE20',
  p_column_display_sequence=> 27,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'TEXT',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SPALTE20',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333800468402800 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 29,
  p_form_element_id=> null,
  p_column_alias=> 'SATZ_KENNZEICHEN',
  p_column_display_sequence=> 29,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'SATZ_KENNZEICHEN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8333925377402801 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 30,
  p_form_element_id=> null,
  p_column_alias=> 'ERFDAT',
  p_column_display_sequence=> 30,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'ERFDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8334030517402801 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 31,
  p_form_element_id=> null,
  p_column_alias=> 'ERFUSER',
  p_column_display_sequence=> 31,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'ERFUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8334109109402801 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 32,
  p_form_element_id=> null,
  p_column_alias=> 'MUTDAT',
  p_column_display_sequence=> 32,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'MUTDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8334217638402801 + wwv_flow_api.g_id_offset,
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 33,
  p_form_element_id=> null,
  p_column_alias=> 'MUTUSER',
  p_column_display_sequence=> 33,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'N',
  p_print_col_width=> '0',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'LAB_ANALYSEDATEIEN_INHALTE',
  p_ref_column_name=> 'MUTUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 8402112911557582 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 326,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select	 '||unistr('\000a')||
'	 lad."ID" as "ID",'||unistr('\000a')||
'         --lad."LABOR_ID" as "LABOR_ID",'||unistr('\000a')||
'         l.KUERZEL as LABOR_KUERZEL,'||unistr('\000a')||
'	 regexp_replace(lad."PFAD",''^'' || lad.ORDNER_PFAD,'''')  as "PFAD",'||unistr('\000a')||
'         lad.ERFDAT ERFASSDATUM,'||unistr('\000a')||
'         CASE WHEN sysdate - lad.ERFDAT > (to_number(FRGBG_T.GET_SYS_PARAM(40)) /60/24)'||unistr('\000a')||
'           THEN ''fällig'''||unistr('\000a')||
'         WHEN ((to_number(FRGBG_T.GET_SYS_PARAM(40)) /60/24) - (sysdate - lad.ER';

s:=s||'FDAT)) * 24 * 60 < 1'||unistr('\000a')||
'           THEN ''fällig in < 1 Min.'''||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'           ''fällig in '' || to_char(((to_number(FRGBG_T.GET_SYS_PARAM(40)) /60/24) - (sysdate - lad.ERFDAT) ) * 60 * 24,''990'')'||unistr('\000a')||
'           || '' Min'''||unistr('\000a')||
'         END FAELLIG'||unistr('\000a')||
''||unistr('\000a')||
' from	 "LABOR_AUSTAUSCH_DATEIEN" lad, labors l'||unistr('\000a')||
'where'||unistr('\000a')||
'    lad.labor_id = l.id'||unistr('\000a')||
'    and lad.satz_kennzeichen is null'||unistr('\000a')||
'    and l.satz_kennzeichen is null'||unistr('\000a')||
'    and la';

s:=s||'d.abgearbeitet = 0';

wwv_flow_api.create_report_region (
  p_id=> 8820230396671196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 326,
  p_name=> 'Ausstehende Dateien',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 25,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_when_condition=> 'select	 *'||unistr('\000a')||
' from	 "LABOR_AUSTAUSCH_DATEIEN" lad, labors l'||unistr('\000a')||
'where'||unistr('\000a')||
'    lad.labor_id = l.id'||unistr('\000a')||
'    and lad.satz_kennzeichen is null'||unistr('\000a')||
'    and l.satz_kennzeichen is null',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8820620439671229 + wwv_flow_api.g_id_offset,
  p_region_id=> 8820230396671196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 1,
  p_column_heading=> 'ID',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8821426025679429 + wwv_flow_api.g_id_offset,
  p_region_id=> 8820230396671196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'LABOR_KUERZEL',
  p_column_display_sequence=> 2,
  p_column_heading=> 'Labor',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8820720868671229 + wwv_flow_api.g_id_offset,
  p_region_id=> 8820230396671196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'PFAD',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Datei',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8820807038671229 + wwv_flow_api.g_id_offset,
  p_region_id=> 8820230396671196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'ERFASSDATUM',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Erfassdatum',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8820909257671229 + wwv_flow_api.g_id_offset,
  p_region_id=> 8820230396671196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'FAELLIG',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Fällig',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10256603505928369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 326,
  p_plug_name=> 'Schnellverweis',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 5,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 8334404968402814 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 30,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8334330774402814 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 10,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8334527295402814 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 20,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'MULTI_ROW_DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''MULTI_ROW_DELETE'');',
  p_button_execute_validations=>'N',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8370401408298821 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 50,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'FELDER_ZURUECKSETZEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Felder Zurücksetzen',
  p_button_position=> 'RIGHT_OF_TITLE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8814117960376378 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 60,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'AUFTRAG_ZUERUECKSETZEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Auftrag Zuerücksetzen',
  p_button_position=> 'RIGHT_OF_TITLE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8381617525416977 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 80,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'FELDER_AUSSTEUERN',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Felder aussteuern',
  p_button_position=> 'RIGHT_OF_TITLE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(''Wollen Sie die Felder wirklich aussteuern?'',''FELDER_AUSSTEUERN'');',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 9317007101335686 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 90,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'AUFTRAG_AUSSTEUERN',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Auftrag aussteuern',
  p_button_position=> 'RIGHT_OF_TITLE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(''Wollen Sie die Aufträge wirklich aussteuern?'',''AUFTRAG_AUSSTEUERN'');',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8370011404273271 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 110,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'UEBERNAHME',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Felder übernehmen',
  p_button_position=> 'RIGHT_OF_TITLE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8402815943577409 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 130,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'NEUE_UEBERNAHME',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Neue Übernahme',
  p_button_position=> 'RIGHT_OF_TITLE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8403610926613809 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 326,
  p_button_sequence=> 140,
  p_button_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_button_name    => 'ZUR_LABORUEBERNAHME',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zur Laborwertübernahme',
  p_button_position=> 'RIGHT_OF_TITLE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:324:&SESSION.::&DEBUG.:RP:P324_BEARB_STATUS_INIT,P324_ZURUECK_ZUR_SEITE:90,326',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8335808617402823 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:326:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7058317736368923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_SUCHTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Suchtext',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7618023427669994 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_LABOR_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Laborauswahl',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select BEZEICHNUNG, ID '||unistr('\000a')||
'FROM LABORS'||unistr('\000a')||
'WHERE'||unistr('\000a')||
' SATZ_KENNZEICHEN IS NULL'||unistr('\000a')||
'ORDER BY BEZEICHNUNG',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'Alle Anzeigen',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8430418343411863 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_AUFTRAG_ID_INTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Auftrag ID Intern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8430504275417270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_AUFTRAG_ID_INTERN_VERGEBEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Auftrag Id Vergeben',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8435623163536289 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_BEARB_STATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Statusauswahl',
  p_post_element_text=>'&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_CHECKBOX',
  p_lov=> 'SELECT ''übernommen'' a    ,  10 b FROM DUAL UNION'||unistr('\000a')||
'SELECT ''nicht zuordenbar'',  20  FROM dual UNION'||unistr('\000a')||
'SELECT ''nicht angefordert'', 30  FROM dual UNION'||unistr('\000a')||
'SELECT ''keine interne Auftrags-ID'', 80 FROM DUAL UNION'||unistr('\000a')||
'SELECT ''fehlerhaft''       , 90  FROM dual UNION'||unistr('\000a')||
'SELECT ''schwerer Fehler''  , 91  FROM dual UNION'||unistr('\000a')||
'SELECT ''ausgesteuert''     , 95  FROM dual UNION'||unistr('\000a')||
'SELECT ''nicht bearbeitet'', -1   FROM dual'||unistr('\000a')||
'order by 2',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '4',
  p_attribute_02 => 'VERTICAL',
  p_show_quick_picks=>'N',
  p_item_comment => 'HTML-Form-Elements-Attribute enthält nicht mehr onclick="javascript:apex.submit()" , dadurch wird nicht mehr sofort gesucht. Ist bei langen Listen nicht bedienerfreundlich, wenn man mehreres umclicken will ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8449920355582810 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_BEARB_STATUS_LISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8450127627584815 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_BEARB_STATUS_INIT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8467410705608341 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'SUCHEN',
  p_source=>'SUCHEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'RIGHT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8481820925349394 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_SESSION_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 8330813148402781+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'APEX_APPLICATION.g_edit_cookie_session_id',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10256812413928369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 326,
  p_name=>'P326_QUICKMENU',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 10256603505928369+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Schnellverweis:',
  p_source=>'select'||unistr('\000a')||
''||unistr('\000a')||
' listagg(''<a href="javascript:redirect('''''' ||'||unistr('\000a')||
'    frgbg_t.PREPARE_URL(URL) || '''''');">'' || BEZEICHNUNG || ''</a>'','' | '')'||unistr('\000a')||
'    within group (order by SORTIERUNG)'||unistr('\000a')||
' from FAS_APP_MENUS'||unistr('\000a')||
'where'||unistr('\000a')||
'  FAS_APP_MENU_ID in(select FAS_APP_MENU_ID from FAS_APP_MENUS where app_id = :APP_ID and page_id = :APP_PAGE_ID)',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6428316082693083 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 326
 ,p_name => 'Button ausführen - NEUE_UEBERNAHME'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 8402815943577409 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6428617120693086 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 326
 ,p_event_id => 6428316082693083 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'NEUE_UEBERNAHME'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   -- Globale Variablen'||unistr('\000a')||
'    v_PROT_ID number;'||unistr('\000a')||
'    v_ERROR varchar2(32767);'||unistr('\000a')||
'    v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'    c_PROD constant varchar2(100) := ''App: '' || :APP_ID || '' Page: '''||unistr('\000a')||
'       || :APP_PAGE_ID ||'' Prozess Felder aussteuern'';'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR EXCEPTION;'||unistr('\000a')||
'    c_ERRNR constant number := -20100;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR_D EXCEPTION;'||unistr('\000a')||
'    c_ERRNR_D constant number := -20101;';

p:=p||''||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
'   v_rec_labor_analysewerte  LAB_ANALYSEDATEIEN_INHALTE%ROWTYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Hier wird satzweise eine fehlerhafte FB-Laborübernahme auf unbearbeitet, dh. at_bearb_status = NULL gesetzt'||unistr('\000a')||
'   -- Soll ein ganzer Auftrag zurückgesetzt werden, muss das über die Markierung aller Positionen des Auftrags durchgeführt werden'||unistr('\000a')||
''||unistr('\000a')||
'   --FOR i in NVL(apex_application.g_';

p:=p||'f01.FIRST,0)..NVL(apex_application.g_f01.LAST,-1) loop'||unistr('\000a')||
'   --  if(apex_application.g_f01.EXISTS(i)) then'||unistr('\000a')||
'   --  mel.p(''felder aussteuern g_f01: %1,%2'',v_prot_id,''TEST'',''102/324: reset_error'', i,     apex_application.g_f01(i));'||unistr('\000a')||
'   --  end if;'||unistr('\000a')||
'   --end loop;'||unistr('\000a')||
'   --FOR i in NVL(apex_application.g_f02.FIRST,0)..NVL(apex_application.g_f02.LAST,-1) loop'||unistr('\000a')||
'   --  if(apex_application.g_f02.EXISTS(i)) then'||unistr('\000a')||
'   ';

p:=p||'--  mel.p(''felder aussteuern g_f02: %1,%2'',v_prot_id,''TEST'',''102/324: reset_error'', i,     apex_application.g_f02(i));'||unistr('\000a')||
'   --  end if;'||unistr('\000a')||
'   --end loop;'||unistr('\000a')||
''||unistr('\000a')||
'   FOR i in 1..apex_application.g_f01.count'||unistr('\000a')||
'   LOOP'||unistr('\000a')||
'    '||unistr('\000a')||
'      --raise_application_error(C_ERRNR_D, apex_application.g_f02.COUNT);'||unistr('\000a')||
'begin'||unistr('\000a')||
'        SELECT * into v_rec_labor_analysewerte'||unistr('\000a')||
'        FROM LAB_ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'        WHERE id = apex_ap';

p:=p||'plication.g_f02(apex_application.g_f01(i));'||unistr('\000a')||
'      exception'||unistr('\000a')||
'        when no_data_found then'||unistr('\000a')||
'            v_error := ''Fehler beim holen des DS aus dem Labor-Übernahme-Puffer ID: '' || apex_application.g_f01(i);'||unistr('\000a')||
'            v_errnr := -10;'||unistr('\000a')||
'            raise e_error;'||unistr('\000a')||
'        when others then'||unistr('\000a')||
'            v_error := ''Unbekannter Fehler beim holen von DS aus LAbor-Übernahme-Puffer ID: '' ||apex_application';

p:=p||'.g_f01(i);'||unistr('\000a')||
'            v_errnr := -11;'||unistr('\000a')||
'            raise e_error;'||unistr('\000a')||
'      end;'||unistr('\000a')||
''||unistr('\000a')||
'--      mel.p(''reset_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_error'','||unistr('\000a')||
'--            apex_application.g_f01(i),'||unistr('\000a')||
'--            v_rec_labor_analysewerte.auftrag_id);'||unistr('\000a')||
'      IF v_rec_labor_analysewerte.at_bearb_status not in (95) THEN'||unistr('\000a')||
''||unistr('\000a')||
'         UPDATE LAB_ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'         SET at_bearb_stat';

p:=p||'us = 95'||unistr('\000a')||
'         WHERE id = apex_application.g_f02(apex_application.g_f01(i));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'exception'||unistr('\000a')||
'    when e_ERROR then'||unistr('\000a')||
'       MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'    when e_ERROR_D then'||unistr('\000a')||
'       raise; -- Einfach';

p:=p||' durchreichen'||unistr('\000a')||
'    when others then'||unistr('\000a')||
'       v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLERRM:'' || SQLERRM;'||unistr('\000a')||
'       MEL.P (c_PROD || '': '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8381824797419041 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Felder aussteuern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>8381617525416977 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   -- Globale Variablen'||unistr('\000a')||
'    v_PROT_ID number;'||unistr('\000a')||
'    v_ERROR varchar2(32767);'||unistr('\000a')||
'    v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'    c_PROD constant varchar2(100) := ''App: '' || :APP_ID || '' Page: '''||unistr('\000a')||
'       || :APP_PAGE_ID ||'' Prozess Auftrag aussteuern'';'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR EXCEPTION;'||unistr('\000a')||
'    c_ERRNR constant number := -20100;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR_D EXCEPTION;'||unistr('\000a')||
'    c_ERRNR_D constant number := -20101';

p:=p||';'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
'   v_rec_labor_analysewerte  LAB_ANALYSEDATEIEN_INHALTE%ROWTYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   '||unistr('\000a')||
'   FOR i in 1..apex_application.g_f01.count'||unistr('\000a')||
'   LOOP'||unistr('\000a')||
'    '||unistr('\000a')||
'      '||unistr('\000a')||
'begin'||unistr('\000a')||
'        SELECT * into v_rec_labor_analysewerte'||unistr('\000a')||
'        FROM LAB_ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'        WHERE id = apex_application.g_f02(apex_application.g_f01(i));'||unistr('\000a')||
'      exception'||unistr('\000a')||
'        when no_data_found then'||unistr('\000a')||
'   ';

p:=p||'         v_error := ''Fehler beim holen des DS aus dem Labor-Übernahme-Puffer ID: '' || apex_application.g_f01(i);'||unistr('\000a')||
'            v_errnr := -10;'||unistr('\000a')||
'            raise e_error;'||unistr('\000a')||
'        when others then'||unistr('\000a')||
'            v_error := ''Unbekannter Fehler beim holen von DS aus LAbor-Übernahme-Puffer ID: '' ||apex_application.g_f01(i);'||unistr('\000a')||
'            v_errnr := -11;'||unistr('\000a')||
'            raise e_error;'||unistr('\000a')||
'      end;'||unistr('\000a')||
''||unistr('\000a')||
'      UPDATE LAB_';

p:=p||'ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'         SET at_bearb_status = 95'||unistr('\000a')||
'         WHERE SPALTE01 is not null '||unistr('\000a')||
'             AND SPALTE01 = v_rec_labor_analysewerte.SPALTE01'||unistr('\000a')||
'           AND at_bearb_status not in(95);'||unistr('\000a')||
''||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'exception'||unistr('\000a')||
'    when e_ERROR then'||unistr('\000a')||
'       MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       ';

p:=p||'raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'    when e_ERROR_D then'||unistr('\000a')||
'       raise; -- Einfach durchreichen'||unistr('\000a')||
'    when others then'||unistr('\000a')||
'       v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLERRM:'' || SQLERRM;'||unistr('\000a')||
'       MEL.P (c_PROD || '': '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR)';

p:=p||';'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 9316701560334106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Auftrag aussteuern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>9317007101335686 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:LAB_ANALYSEDATEIEN_INHALTE:ID';

wwv_flow_api.create_page_process(
  p_id     => 8335305847402820 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_UPDATE',
  p_process_name=> 'ApplyMRU',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>8334404968402814 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:LAB_ANALYSEDATEIEN_INHALTE:ID';

wwv_flow_api.create_page_process(
  p_id     => 8335516681402822 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_DELETE',
  p_process_name=> 'ApplyMRD',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'MULTI_ROW_DELETE',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_process_success_message=> '#MRD_COUNT# row(s) deleted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'   v_rec_labor_analysewerte  LAB_ANALYSEDATEIEN_INHALTE%ROWTYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Hier wird satzweise eine fehlerhafte FB-Laborübernahme auf unbearbeitet, dh. at_bearb_status = NULL gesetzt'||unistr('\000a')||
'   -- Soll ein ganzer Auftrag zurückgesetzt werden, muss das über die Markierung aller Positionen des Auftrags durchgeführt werden'||unistr('\000a')||
'   FOR i in 1..apex_application.g_f01.count'||unistr('\000a')||
'   LOOP'||unistr('\000a')||
'';

p:=p||'    --  mel.p(''reset_error:%1,%2'',v_prot_id,''TEST'',''102/324: reset_error'',      apex_application.g_f02(apex_application.g_f01(i)));'||unistr('\000a')||
''||unistr('\000a')||
'      SELECT * into v_rec_labor_analysewerte'||unistr('\000a')||
'      FROM LAB_ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'      WHERE id = apex_application.g_f02(apex_application.g_f01(i));'||unistr('\000a')||
''||unistr('\000a')||
'--      mel.p(''reset_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/324: reset_error'', '||unistr('\000a')||
'--            apex_app';

p:=p||'lication.g_f01(i), '||unistr('\000a')||
'--            v_rec_labor_analysewerte.auftrag_id);'||unistr('\000a')||
'      IF v_rec_labor_analysewerte.at_bearb_status in (90) THEN'||unistr('\000a')||
'         '||unistr('\000a')||
'         UPDATE LAB_ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'         SET at_bearb_status = NULL,'||unistr('\000a')||
'             fehlermeldung= null'||unistr('\000a')||
'         WHERE at_bearb_status in (90)'||unistr('\000a')||
'           AND id = apex_application.g_f02(apex_application.g_f01(i));        '||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END LO';

p:=p||'OP;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8370617684303470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 70,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'reset_error',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>8370401408298821 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'   v_rec_labor_analysewerte  LAB_ANALYSEDATEIEN_INHALTE%ROWTYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Hier wird aus dem ersten markiertem Datensatz einer fehlerhaften FB-Laborübernahme oder'||unistr('\000a')||
'   -- eines noch nicht beararbeiteten Datensatzes, die Auftrags_id des Labors ermittelt und '||unistr('\000a')||
'   -- alle Laborübernahmesätze werden zurückgesetzt, dh. at_bearb_status = NULL gesetzt'||unistr('\000a')||
'   -- Alle übrigen mar';

p:=p||'kierten Sätze werden ignoriert.'||unistr('\000a')||
''||unistr('\000a')||
'   IF apex_application.g_f01.count > 1 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,''Es darf nur ein Datensatz des Laborauftrags markiert sein!'');'||unistr('\000a')||
'   ELSIF  apex_application.g_f01.count =0 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,''Es muss ein Datensatz des Laborauftrags markiert sein!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   FOR i in 1..apex_application.g_f01.count'||unistr('\000a')||
'   LOOP'||unistr('\000a')||
'      --mel.p(''A';

p:=p||'uftrag zurücksetzen:%1,%2'',v_prot_id,''TEST'',''102/326: Auftrag zurücksetzen'', apex_application.g_f01(i));'||unistr('\000a')||
'      SELECT * into v_rec_labor_analysewerte'||unistr('\000a')||
'      FROM LAB_ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'      WHERE id = apex_application.g_f02(apex_application.g_f01(i));'||unistr('\000a')||
''||unistr('\000a')||
'     --mel.p(''Auftrag zurücksetzen: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/326: Auftrag zurücksetzen'', '||unistr('\000a')||
'     --       apex_application.g_';

p:=p||'f02(apex_application.g_f01(i)), '||unistr('\000a')||
'     --       v_rec_labor_analysewerte.spalte01);'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_rec_labor_analysewerte.at_bearb_status in (90,91)  '||unistr('\000a')||
'         or v_rec_labor_analysewerte.at_bearb_status is null '||unistr('\000a')||
'      THEN'||unistr('\000a')||
'      --   mel.p(''reset_auftrag_intern_error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/326: reset_geburtsdatum_error'', '||unistr('\000a')||
'     --           apex_application.g_f02(apex_applicatio';

p:=p||'n.g_f01(i)), v_rec_labor_analysewerte.spalte01); '||unistr('\000a')||
''||unistr('\000a')||
'         UPDATE LAB_ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'         SET at_bearb_status = NULL,'||unistr('\000a')||
'             fehlermeldung= null'||unistr('\000a')||
'         WHERE '||unistr('\000a')||
'           spalte01 = v_rec_labor_analysewerte.spalte01'||unistr('\000a')||
'           AND labor_id = v_rec_labor_analysewerte.labor_id'||unistr('\000a')||
'           AND (at_bearb_status in (90,91) or at_bearb_status is null)     -- Es sollen ja nur die noch ';

p:=p||'nicht bearbeiteten Sätze verändert werden bzw. fehlerhafte'||unistr('\000a')||
'           ;                                                               -- evt. bereits übernommene dürfen nicht mehr verändert werden (sollte es auch nicht geben)'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR(-20001,''Der Datensatz des Laborauftrags darf noch nicht bearbeitet sein oder muss einen Fehlerstatus haben!'');         '||unistr('\000a')||
'      END ';

p:=p||'IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8815004632410421 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 80,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Auftrag zurücksetzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>8814117960376378 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Datensätze zurückgesetzt',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'    --if :P326_SESSION_ID IS NOT NULL then'||unistr('\000a')||
'    --     FRGBG.LABOR_AUSTAUSCH.DEBUG_ON;'||unistr('\000a')||
'    --else '||unistr('\000a')||
'        FRGBG.LABOR_AUSTAUSCH.DEBUG_OFF;'||unistr('\000a')||
'    --end if;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    -- Starte die Übernahme'||unistr('\000a')||
'    FRGBG.LABOR_AUSTAUSCH.LABOR_AUSTAUSCH('||unistr('\000a')||
'        p_sprache_id => :FAS_SPRACHE_ID,'||unistr('\000a')||
'        p_ignore_delay => case when :P326_SESSION_ID IS NOT NULL then 1 else 0 end'||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8403114689586519 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Neue Übernahme',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>8402815943577409 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Neue Übernahme durchgeführt',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id    NUMBER;'||unistr('\000a')||
'   v_rec_labor_analysewerte  LAB_ANALYSEDATEIEN_INHALTE%ROWTYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Hier wird aus dem ersten markiertem Datensatz einer fehlerhaften FB-Laborübernahme oder'||unistr('\000a')||
'   -- eines noch nicht beararbeiteten Datensatzes, die Auftrags_id des Labors ermittelt und '||unistr('\000a')||
'   -- für alle Sätze des Auftrags mit Fehlerflag die Interne Auftrag-ID auf die angegebene ID gesetzt und'||unistr('\000a')||
'   -';

p:=p||'- der Laborübernahmesatz zurückgesetzt, dh. at_bearb_status = NULL gesetzt'||unistr('\000a')||
'   -- Alle übrigen markierten Sätze werden ignoriert.'||unistr('\000a')||
''||unistr('\000a')||
'   IF apex_application.g_f01.count > 1 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20001,''Es darf nur ein Datensatz des Laborauftrags markiert sein! Ausgewählt: '' || apex_application.g_f01.count);'||unistr('\000a')||
'   ELSIF  apex_application.g_f01.count = 0 THEN'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR(-20';

p:=p||'001,''Es muss ein Datensatz des Laborauftrags markiert sein!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   FOR i in 1..apex_application.g_f01.count'||unistr('\000a')||
'   LOOP'||unistr('\000a')||
'      --mel.p(''reset_error:%1,%2'',v_prot_id,''TEST'',''102/326: reset_error'', apex_application.g_f01(i));'||unistr('\000a')||
'      SELECT * into v_rec_labor_analysewerte'||unistr('\000a')||
'      FROM LAB_ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'      WHERE id = apex_application.g_f02(apex_application.g_f01(i));'||unistr('\000a')||
''||unistr('\000a')||
'     mel.p(''reset_';

p:=p||'error: id:%1, labauftrag: %2'',v_prot_id,''TEST'',''102/326: reset_error'', '||unistr('\000a')||
'            apex_application.g_f02(apex_application.g_f01(i)), '||unistr('\000a')||
'            v_rec_labor_analysewerte.spalte01);'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_rec_labor_analysewerte.at_bearb_status in (90,91,80)  '||unistr('\000a')||
'         or v_rec_labor_analysewerte.at_bearb_status is null '||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         mel.p(''reset_auftrag_intern_error: id:%1, labauftrag: %2'',v_prot_id';

p:=p||',''TEST'',''102/326: reset_geburtsdatum_error'', '||unistr('\000a')||
'                apex_application.g_f02(apex_application.g_f01(i)), v_rec_labor_analysewerte.spalte01); '||unistr('\000a')||
''||unistr('\000a')||
'         UPDATE LAB_ANALYSEDATEIEN_INHALTE'||unistr('\000a')||
'         SET at_bearb_status = NULL,'||unistr('\000a')||
'             fehlermeldung= null,'||unistr('\000a')||
'             spalte02 = :P326_AUFTRAG_ID_INTERN'||unistr('\000a')||
'         WHERE '||unistr('\000a')||
'           spalte01 = v_rec_labor_analysewerte.spalte01'||unistr('\000a')||
'           AND ';

p:=p||'labor_id = v_rec_labor_analysewerte.labor_id'||unistr('\000a')||
'           AND (at_bearb_status in (90,91,80) or at_bearb_status is null)     -- Es sollen ja nur die noch nicht bearbeiteten Sätze verändert werden bzw. fehlerhafte'||unistr('\000a')||
'           ;                                                               -- evt. bereits übernommene dürfen nicht mehr verändert werden (sollte es auch nicht geben)'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         RA';

p:=p||'ISE_APPLICATION_ERROR(-20001,''Der Datensatz des Laborauftrags darf noch nicht bearbeitet sein oder muss einen Fehlerstatus haben!'');         '||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8430823668422885 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'reset_auftrag_intern_error',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>8430504275417270 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  v_return number;'||unistr('\000a')||
'begin'||unistr('\000a')||
'    -- starte die Übernahme aus der Zwischentabelle'||unistr('\000a')||
'    v_return := LABOR_AUSTAUSCH.LABOR_AUSTAUSCH_CSV_BUFFER;'||unistr('\000a')||
''||unistr('\000a')||
'    if(v_return < 0) then'||unistr('\000a')||
'        apex_application.g_print_success_message := ''Fehler bei der Übernahme aufgetreten.'';'||unistr('\000a')||
'    else'||unistr('\000a')||
'        apex_application.g_print_success_message := ''Übernahme war erfolgreich.'';'||unistr('\000a')||
'     end if;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8370229197287877 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 130,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Übernahme wiederholen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':REQUEST in (''FELDER_ZURUECKSETZEN'', ''UEBERNAHME'', ''P326_AUFTRAG_ID_INTERN_VERGEBEN'', ''AUFTRAG_ZUERUECKSETZEN'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF :P326_BEARB_STATUS_INIT is not null THEN'||unistr('\000a')||
'      :P326_BEARB_STATUS := ''90:91'' ;'||unistr('\000a')||
'      :P326_BEARB_STATUS_INIT := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :P326_BEARB_STATUS_LISTE:=:P326_BEARB_STATUS;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8449612044580410 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 326,
  p_process_sequence=> 80,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_bearb_status_liste',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'P324_BEARB_STATUS',
  p_process_when_type=>'',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 326
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6392114925214069 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6392200557214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'ID_DISPLAY',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6392311746214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'LABOR',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6392424555214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'QUELLE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6392504151214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'AT_BEARB_STATUS',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6392621968214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'AT_BEARB_DATUM',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6392714021214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 7,
  p_query_column_name=> 'FEHLERMELDUNG',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6392805267214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 8,
  p_query_column_name=> 'SPALTE01',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6392927730214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 9,
  p_query_column_name=> 'SPALTE02',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393031774214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 10,
  p_query_column_name=> 'SPALTE03',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393117862214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 11,
  p_query_column_name=> 'SPALTE04',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393202052214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 12,
  p_query_column_name=> 'SPALTE05',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393306576214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 13,
  p_query_column_name=> 'SPALTE06',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393415338214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 14,
  p_query_column_name=> 'SPALTE07',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393507060214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 15,
  p_query_column_name=> 'SPALTE08',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393621311214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 16,
  p_query_column_name=> 'SPALTE09',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393723578214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 17,
  p_query_column_name=> 'SPALTE10',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393817624214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 18,
  p_query_column_name=> 'SPALTE11',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6393928082214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 19,
  p_query_column_name=> 'SPALTE12',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394020043214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 20,
  p_query_column_name=> 'SPALTE13',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394114678214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 21,
  p_query_column_name=> 'SPALTE14',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394201050214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 22,
  p_query_column_name=> 'SPALTE15',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394314687214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 23,
  p_query_column_name=> 'SPALTE16',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394408978214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 24,
  p_query_column_name=> 'SPALTE17',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394526807214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 25,
  p_query_column_name=> 'SPALTE18',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394625705214074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 26,
  p_query_column_name=> 'SPALTE19',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394719142214075 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 27,
  p_query_column_name=> 'SPALTE20',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394812670214075 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 28,
  p_query_column_name=> 'SATZ_KENNZEICHEN',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6394905355214075 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 29,
  p_query_column_name=> 'ERFDAT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6395005447214076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 30,
  p_query_column_name=> 'ERFUSER',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6395117512214076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 31,
  p_query_column_name=> 'MUTDAT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 6395200212214076 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 8330813148402781 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 32,
  p_query_column_name=> 'MUTUSER',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00327
prompt  ...PAGE 327: Laboraustausch Dateien
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 327
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Laboraustausch Dateien'
 ,p_step_title => 'Laboraustausch Dateien'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Laboraustausch Dateien'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141111115725'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10241303736416305 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'    lad.id ID,'||unistr('\000a')||
'    APEX_ITEM.CHECKBOX(p_idx => 1, p_value => lad.ID, '||unistr('\000a')||
'         p_attributes => ''class="liste_checkbox" '' ||'||unistr('\000a')||
'       '' onclick="$(''''.check_all'''').prop(''''checked'''',$(''''.liste_checkbox:checked'''').length == $(''''.liste_checkbox'''').length);"'')  CHECKBOX, '||unistr('\000a')||
'    l.BEZEICHNUNG LABOR,'||unistr('\000a')||
'    regexp_substr(lad.PFAD,''[^/]+$'') DATEINAME,'||unistr('\000a')||
'    regexp_substr(lad.PFAD,''[^.]+$'') DATEITYP,'||unistr('\000a')||
'    to_c';

s:=s||'har(lad.ERFDAT,''DD.MM.YYYY'') EINGANGSDATUM,'||unistr('\000a')||
'    to_char(lad.ABGEARBEITET_DATUM,''DD.MM.YYYY HH24:MI'') ABGEARBEITET_AM,'||unistr('\000a')||
'    ''<a href="javascript:apex.submit({request:''''DOWNLOAD_FTP_DATEI'''',set:{''''P327_DOWNLOAD_DATEI_IDS'''':'' || lad.ID || ''}});">Download</a>'' DOWNLOAD_LINK,'||unistr('\000a')||
'    CASE WHEN ldt.AUFTRAG_ID_REGEXP is not null AND regexp_substr(regexp_substr(lad.PFAD,''[^/]+$''),ldt.AUFTRAG_ID_REGEXP) is not ';

s:=s||'null THEN'||unistr('\000a')||
'    '||unistr('\000a')||
'      CASE WHEN (SELECT COUNT(*) FROM V_LABOR_ANALYSEWERTE WHERE'||unistr('\000a')||
'        LABOR_ID = l.ID'||unistr('\000a')||
'        AND AUFTRAG_ID = regexp_substr(regexp_substr(lad.PFAD,''[^/]+$''),ldt.AUFTRAG_ID_REGEXP)'||unistr('\000a')||
'       ) > 0 THEN'||unistr('\000a')||
'         ''<span style="color:green;">Ja</span>'''||unistr('\000a')||
'       ELSE'||unistr('\000a')||
'         ''<span style="color:red; font-weight:bold;">nicht vorhanden</span>'''||unistr('\000a')||
'      END'||unistr('\000a')||
'      '||unistr('\000a')||
'        '||unistr('\000a')||
'      '||unistr('\000a')||
''||unistr('\000a')||
'    ELSE ''un';

s:=s||'bekannt'' END LABORDATEN_VORHANDEN'||unistr('\000a')||
'from LABOR_AUSTAUSCH_DATEIEN lad, labors l, LABOR_DATEITYPEN ldt'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'  abgearbeitet = 1'||unistr('\000a')||
'  and l.id = lad.labor_id'||unistr('\000a')||
'  and lad.zielpfad is not null'||unistr('\000a')||
'  and lad.satz_kennzeichen is null'||unistr('\000a')||
'  and l.SATZ_KENNZEICHEN is null'||unistr('\000a')||
'  and (NVL(:P327_LABOR_ID,-1) = -1 or lad.labor_id = :P327_LABOR_ID)'||unistr('\000a')||
'  and (:P327_EINGANGSDATUM is null or TRUNC(lad.erfdat,''DDD'') = TRUNC(to_date(:P32';

s:=s||'7_EINGANGSDATUM),''DDD''))'||unistr('\000a')||
'  and (:P327_DATEITYP is null or :P327_DATEITYP = ''-1'' or upper(:P327_DATEITYP) = ldt.dateityp)'||unistr('\000a')||
'  and ldt.labor_id = l.ID'||unistr('\000a')||
'  and ldt.dateityp = upper(regexp_substr(lad.PFAD,''[^.]+$''))';

wwv_flow_api.create_page_plug (
  p_id=> 10241706951416319 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_plug_name=> 'Laboraustausch Dateien',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'select'||unistr('\000a')||
'    lad.id ID,'||unistr('\000a')||
'    APEX_ITEM.CHECKBOX(p_idx => 1, p_value => lad.ID, '||unistr('\000a')||
'         p_attributes => ''class="liste_checkbox" '' ||'||unistr('\000a')||
'       '' onclick="$(''''.check_all'''').prop(''''checked'''',$(''''.liste_checkbox:checked'''').length == $(''''.liste_checkbox'''').length);"'')  CHECKBOX, '||unistr('\000a')||
'    l.BEZEICHNUNG LABOR,'||unistr('\000a')||
'    regexp_substr(lad.PFAD,''[^/]+$'') DATEINAME,'||unistr('\000a')||
'    regexp_substr(lad.PFAD,''[^.]+$'') DATEITYP,'||unistr('\000a')||
'    to_c';

a1:=a1||'har(lad.ERFDAT,''DD.MM.YYYY'') EINGANGSDATUM,'||unistr('\000a')||
'    to_char(lad.ABGEARBEITET_DATUM,''DD.MM.YYYY HH24:MI'') ABGEARBEITET_AM,'||unistr('\000a')||
'    ''<a href="javascript:apex.submit({request:''''DOWNLOAD_FTP_DATEI'''',set:{''''P327_DOWNLOAD_DATEI_IDS'''':'' || lad.ID || ''}});">Download</a>'' DOWNLOAD_LINK,'||unistr('\000a')||
'    CASE WHEN ldt.AUFTRAG_ID_REGEXP is not null AND regexp_substr(regexp_substr(lad.PFAD,''[^/]+$''),ldt.AUFTRAG_ID_REGEXP) is not ';

a1:=a1||'null THEN'||unistr('\000a')||
'    '||unistr('\000a')||
'      CASE WHEN (SELECT COUNT(*) FROM V_LABOR_ANALYSEWERTE WHERE'||unistr('\000a')||
'        LABOR_ID = l.ID'||unistr('\000a')||
'        AND AUFTRAG_ID = regexp_substr(regexp_substr(lad.PFAD,''[^/]+$''),ldt.AUFTRAG_ID_REGEXP)'||unistr('\000a')||
'       ) > 0 THEN'||unistr('\000a')||
'         ''<span style="color:green;">Ja</span>'''||unistr('\000a')||
'       ELSE'||unistr('\000a')||
'         ''<span style="color:red; font-weight:bold;">nicht vorhanden</span>'''||unistr('\000a')||
'      END'||unistr('\000a')||
'      '||unistr('\000a')||
'        '||unistr('\000a')||
'      '||unistr('\000a')||
''||unistr('\000a')||
'    ELSE ''un';

a1:=a1||'bekannt'' END LABORDATEN_VORHANDEN'||unistr('\000a')||
'from LABOR_AUSTAUSCH_DATEIEN lad, labors l, LABOR_DATEITYPEN ldt'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'  abgearbeitet = 1'||unistr('\000a')||
'  and l.id = lad.labor_id'||unistr('\000a')||
'  and lad.zielpfad is not null'||unistr('\000a')||
'  and lad.satz_kennzeichen is null'||unistr('\000a')||
'  and l.SATZ_KENNZEICHEN is null'||unistr('\000a')||
'  and (NVL(:P327_LABOR_ID,-1) = -1 or lad.labor_id = :P327_LABOR_ID)'||unistr('\000a')||
'  and (:P327_EINGANGSDATUM is null or TRUNC(lad.erfdat,''DDD'') = TRUNC(to_date(:P32';

a1:=a1||'7_EINGANGSDATUM),''DDD''))'||unistr('\000a')||
'  and (:P327_DATEITYP is null or :P327_DATEITYP = ''-1'' or upper(:P327_DATEITYP) = ldt.dateityp)'||unistr('\000a')||
'  and ldt.labor_id = l.ID'||unistr('\000a')||
'  and ldt.dateityp = upper(regexp_substr(lad.PFAD,''[^.]+$''))';

wwv_flow_api.create_worksheet(
  p_id=> 10241801125416319+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_region_id=> 10241706951416319+wwv_flow_api.g_id_offset,
  p_name=> 'Laboraustausch Dateien',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '100000',
  p_max_row_count_message=> 'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'N',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y_OF_Z',
  p_pagination_display_pos=>'TOP_AND_BOTTOM_LEFT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'N',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'N',
  p_show_highlight=>'N',
  p_show_computation=>'N',
  p_show_aggregate=>'N',
  p_show_chart=>'N',
  p_show_group_by=>'N',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'N',
  p_show_reset=>'N',
  p_show_download=>'N',
  p_show_help=>'N',
  p_download_formats=>'CSV:HTML:EMAIL',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'SASCHA.LENZ',
  p_internal_uid=> 1);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 10242010614416334+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID',
  p_display_order          =>1,
  p_column_identifier      =>'A',
  p_column_label           =>'Id',
  p_report_label           =>'Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 10243128385431137+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'CHECKBOX',
  p_display_order          =>2,
  p_column_identifier      =>'F',
  p_column_label           =>'<input type="checkbox" class="check_all" value="checkall" onclick="$(''.liste_checkbox'').prop(''checked'',$(this).prop(''checked''));"/>',
  p_report_label           =>'<input type="checkbox" class="check_all" value="checkall" onclick="$(''.liste_checkbox'').prop(''checked'',$(this).prop(''checked''));"/>',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 10242112634416338+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'LABOR',
  p_display_order          =>3,
  p_column_identifier      =>'B',
  p_column_label           =>'Labor',
  p_report_label           =>'Labor',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 10242207192416339+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'DATEINAME',
  p_display_order          =>4,
  p_column_identifier      =>'C',
  p_column_label           =>'Dateiname',
  p_report_label           =>'Dateiname',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 10242326501416339+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'DATEITYP',
  p_display_order          =>5,
  p_column_identifier      =>'D',
  p_column_label           =>'Dateityp',
  p_report_label           =>'Dateityp',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 10243627393459265+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EINGANGSDATUM',
  p_display_order          =>6,
  p_column_identifier      =>'G',
  p_column_label           =>'Eingangsdatum',
  p_report_label           =>'Eingangsdatum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 10242411262416339+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ABGEARBEITET_AM',
  p_display_order          =>7,
  p_column_identifier      =>'E',
  p_column_label           =>'Abgearbeitet Am',
  p_report_label           =>'Abgearbeitet Am',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 10247223396694586+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'DOWNLOAD_LINK',
  p_display_order          =>8,
  p_column_identifier      =>'H',
  p_column_label           =>'Download',
  p_report_label           =>'Download',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 10259110936517193+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'LABORDATEN_VORHANDEN',
  p_display_order          =>9,
  p_column_identifier      =>'I',
  p_column_label           =>'Messwerte vorhanden',
  p_report_label           =>'Messwerte vorhanden',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'CENTER',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'CHECKBOX:ID:LABOR:DATEINAME:DATEITYP:EINGANGSDATUM:ABGEARBEITET_AM:LABORDATEN_VORHANDEN:DOWNLOAD_LINK:';

wwv_flow_api.create_worksheet_rpt(
  p_id => 10242510593416509+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_worksheet_id => 10241801125416319+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'102426',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>50,
  p_report_columns          =>rc1,
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10243713672464698 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_plug_name=> 'Filter',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 19,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10257213202931238 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 327,
  p_plug_name=> 'Schnellverweis',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 5,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 10250421674119926 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 327,
  p_button_sequence=> 20,
  p_button_plug_id => 10241706951416319+wwv_flow_api.g_id_offset,
  p_button_name    => 'MULTI_ROW_DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Ausgewählte Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''MULTI_ROW_DELETE'');',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10243307654453477 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 327,
  p_button_sequence=> 10,
  p_button_plug_id => 10241706951416319+wwv_flow_api.g_id_offset,
  p_button_name    => 'DOWNLOAD_SELECTED',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Ausgewählte Herunterladen',
  p_button_position=> 'RIGHT_OF_IR_SEARCH_BAR',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>10248631398999764 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 327,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:327:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 11-AUG-2014 11:39 by SASCHA.LENZ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10244007223472324 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 327,
  p_name=>'P327_LABOR_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 10243713672464698+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '2',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Labor',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select BEZEICHNUNG, ID from LABORS where satz_kennzeichen is null'||unistr('\000a')||
'order by BEZEICHNUNG',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'Nicht ausgewählt',
  p_lov_null_value=> '-1',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10244429995497787 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 327,
  p_name=>'P327_EINGANGSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 10243713672464698+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Eingangsdatum',
  p_format_mask=>'DD.MM.YYYY',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => '+0d',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'MONTH_AND_YEAR',
  p_attribute_08 => '-02',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10244826494544154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 327,
  p_name=>'P327_DATEITYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 10243713672464698+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'PDF',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Dateityp',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT UNIQUE DATEITYP bez, DATEITYP val'||unistr('\000a')||
'FROM LABOR_DATEITYPEN'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'  SATZ_KENNZEICHEN IS NULL'||unistr('\000a')||
'ORDER BY DATEITYP',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'Nicht ausgewählt',
  p_lov_null_value=> '-1',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10250231192084840 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 327,
  p_name=>'P327_DOWNLOAD_DATEI_IDS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 10241706951416319+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10257406375931239 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 327,
  p_name=>'P327_QUICKMENU',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 10257213202931238+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Schnellverweis:',
  p_source=>'select'||unistr('\000a')||
''||unistr('\000a')||
' listagg(''<a href="javascript:redirect('''''' ||'||unistr('\000a')||
'    frgbg_t.PREPARE_URL(URL) || '''''');">'' || BEZEICHNUNG || ''</a>'','' | '')'||unistr('\000a')||
'    within group (order by SORTIERUNG)'||unistr('\000a')||
' from FAS_APP_MENUS'||unistr('\000a')||
'where'||unistr('\000a')||
'  FAS_APP_MENU_ID in(select FAS_APP_MENU_ID from FAS_APP_MENUS where app_id = :APP_ID and page_id = :APP_PAGE_ID)',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 10245529574592292 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 327
 ,p_name => 'aktualisiere Liste'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P327_EINGANGSDATUM,P327_LABOR_ID,P327_DATEITYP'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 10246010312596182 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 327
 ,p_event_id => 10245529574592292 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'NULL;'
 ,p_attribute_02 => 'P327_DATEITYP,P327_EINGANGSDATUM,P327_LABOR_ID'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 10246214814597530 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 327
 ,p_event_id => 10245529574592292 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 30
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 10241706951416319 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  -- Globale Variablen'||unistr('\000a')||
'    v_PROT_ID number;'||unistr('\000a')||
'    v_ERROR varchar2(32767);'||unistr('\000a')||
'    v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'    c_PROD constant varchar2(100) := ''App: '' || :APP_ID || '' Page: '''||unistr('\000a')||
'       || :APP_PAGE_ID ||''Set Download Dateien'';'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR EXCEPTION;'||unistr('\000a')||
'    c_ERRNR constant number := -20100;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR_D EXCEPTION;'||unistr('\000a')||
'    c_ERRNR_D constant number := -20101;'||unistr('\000a')||
'    PR';

p:=p||'AGMA EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
''||unistr('\000a')||
'    v_return number;'||unistr('\000a')||
''||unistr('\000a')||
'    v_ids varchar2(4000);'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'    FOR i in 1..apex_application.g_f01.count LOOP'||unistr('\000a')||
''||unistr('\000a')||
'        v_ids := v_ids || '':'' || apex_application.g_f01(i);'||unistr('\000a')||
'    end loop;'||unistr('\000a')||
'    '||unistr('\000a')||
'    :P327_DOWNLOAD_DATEI_IDS := rtrim(v_ids,'':'');'||unistr('\000a')||
''||unistr('\000a')||
'    '||unistr('\000a')||
'exception'||unistr('\000a')||
'    when e_ERROR then'||unistr('\000a')||
'       MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'      ';

p:=p||'    c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'    when e_ERROR_D then'||unistr('\000a')||
'       raise; -- Einfach durchreichen'||unistr('\000a')||
'    when others then'||unistr('\000a')||
'       v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLERRM:'' || SQLERRM;'||unistr('\000a')||
'       MEL.P (c_PROD || '': '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_';

p:=p||'error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 10248325511998002 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 327,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Set Download Datei',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>10243307654453477 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  -- Globale Variablen'||unistr('\000a')||
'    v_PROT_ID number;'||unistr('\000a')||
'    v_ERROR varchar2(32767);'||unistr('\000a')||
'    v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'    c_PROD constant varchar2(100) := ''App: '' || :APP_ID || '' Page: '''||unistr('\000a')||
'       || :APP_PAGE_ID ||'' Dateien löschen'';'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR EXCEPTION;'||unistr('\000a')||
'    c_ERRNR constant number := -20100;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR_D EXCEPTION;'||unistr('\000a')||
'    c_ERRNR_D constant number := -20101;'||unistr('\000a')||
'    PRAGMA';

p:=p||' EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
''||unistr('\000a')||
'    v_count number := 0;'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'    FOR i in 1..apex_application.g_f01.count LOOP'||unistr('\000a')||
''||unistr('\000a')||
'        UPDATE LABOR_AUSTAUSCH_DATEIEN SET'||unistr('\000a')||
'            SATZ_KENNZEICHEN = ''Gelöscht am '' || to_char(sysdate,''DD.MM.YYYY HH24:MI:SS'') || '' von '' ||  :FAS_LOGIN_USER_ACCOUNT'||unistr('\000a')||
''||unistr('\000a')||
'        WHERE ID =  apex_application.g_f01(i) AND SATZ_KENNZEICHEN IS NULL;'||unistr('\000a')||
''||unistr('\000a')||
'        v_count := v_count +1;'||unistr('\000a')||
'';

p:=p||'    end loop;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    apex_application.g_print_success_message := v_count || '' Datensätze gelöscht.'';'||unistr('\000a')||
''||unistr('\000a')||
'exception'||unistr('\000a')||
'    when e_ERROR then'||unistr('\000a')||
'       MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'    when e_ERROR_D then'||unistr('\000a')||
'       raise; -- Einfach durc';

p:=p||'hreichen'||unistr('\000a')||
'    when others then'||unistr('\000a')||
'       v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLERRM:'' || SQLERRM;'||unistr('\000a')||
'       MEL.P (c_PROD || '': '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 10250619165138102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 327,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Dateien Löschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>10250421674119926 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  -- Globale Variablen'||unistr('\000a')||
'    v_PROT_ID number;'||unistr('\000a')||
'    v_ERROR varchar2(32767);'||unistr('\000a')||
'    v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'    c_PROD constant varchar2(100) := ''App: '' || :APP_ID || '' Page: '''||unistr('\000a')||
'       || :APP_PAGE_ID ||'' Prozess Download Dateien'';'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR EXCEPTION;'||unistr('\000a')||
'    c_ERRNR constant number := -20100;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR_D EXCEPTION;'||unistr('\000a')||
'    c_ERRNR_D constant number := -20101;'||unistr('\000a')||
' ';

p:=p||'   PRAGMA EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
''||unistr('\000a')||
'    v_return number;'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    if(:P327_DOWNLOAD_DATEI_IDS is not null) then'||unistr('\000a')||
''||unistr('\000a')||
'       begin'||unistr('\000a')||
'        v_return := LABOR_AUSTAUSCH.DOWNLOAD_LABOR_DATEIEN('||unistr('\000a')||
'            p_labor_dateien_ids => :P327_DOWNLOAD_DATEI_IDS'||unistr('\000a')||
'        );'||unistr('\000a')||
'       exception'||unistr('\000a')||
'          when others then'||unistr('\000a')||
'            :P327_DOWNLOAD_DATEI_IDS := NULL;  '||unistr('\000a')||
'            --raise_application_error(c';

p:=p||'_ERRNR_D,SQLERRM);  '||unistr('\000a')||
'       end;'||unistr('\000a')||
'        '||unistr('\000a')||
'        :P327_DOWNLOAD_DATEI_IDS := NULL;     '||unistr('\000a')||
'        '||unistr('\000a')||
'         /* -- Eine Exception führt dazu das das Seitenelement nicht mehr zurück gesetzt wird.'||unistr('\000a')||
'            -- Damit befindet sich die Seite in einem Deadlock und die Exception kommt immer'||unistr('\000a')||
'        if(v_return > 0) then'||unistr('\000a')||
'               '||unistr('\000a')||
'            --apex_application.g_print_success_message := v_return |';

p:=p||'| '' heruntergeladene Dateien.'';'||unistr('\000a')||
'            -- Da eine Datei heruntergeladen wird, darf die Seite nicht angezeigt werden.'||unistr('\000a')||
'            -- apex_application.g_unrecoverable_error := true;'||unistr('\000a')||
'            null;'||unistr('\000a')||
'        else'||unistr('\000a')||
'            null;'||unistr('\000a')||
'            --raise_application_error(c_ERRNR_D,''Es konnte keine Labordatei gefunden werden.'');'||unistr('\000a')||
'        end if;   '||unistr('\000a')||
'        */  '||unistr('\000a')||
'    end if;'||unistr('\000a')||
''||unistr('\000a')||
'exception'||unistr('\000a')||
'    when e_ERRO';

p:=p||'R then'||unistr('\000a')||
'       MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'    when e_ERROR_D then'||unistr('\000a')||
'       raise; -- Einfach durchreichen'||unistr('\000a')||
'    when others then'||unistr('\000a')||
'       v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLERRM:'' || SQLERRM;'||unistr('\000a')||
'       MEL.P (c_';

p:=p||'PROD || '': '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 10248130097980432 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 327,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Download Dateien',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 327
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00328
prompt  ...PAGE 328: Laborwert bearbeiten
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 328
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Laborwert bearbeiten'
 ,p_step_title => 'Laborwert bearbeiten'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141028101054'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6178316565761236 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 328,
  p_plug_name=> 'Laborwert bearbeiten',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6178631348761237 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 328,
  p_button_sequence=> 30,
  p_button_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P328_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6178501886761237 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 328,
  p_button_sequence=> 40,
  p_button_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P328_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6178706530761237 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 328,
  p_button_sequence=> 20,
  p_button_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'P328_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'DELETE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6179520125761240 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:328:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6179728231761243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6180124809761257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_AUFTRAG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Auftrag Id',
  p_source=>'AUFTRAG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6180530395761258 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Geburtsdatum',
  p_source=>'GEBURTSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6180721948761258 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_EINGANGSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'sysdate',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Eingangsdatum',
  p_format_mask=>'DD.MM.YYYY HH24:MI',
  p_source=>'EINGANGSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6180911688761259 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_ANALYSEKUERZEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Analysekuerzel',
  p_source=>'ANALYSEKUERZEL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6181131367761259 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_ERGEBNISWERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ergebniswert',
  p_format_mask=>'FM99999990D9999999',
  p_source=>'ERGEBNISWERT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6181324234761260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_EINHEIT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Einheit',
  p_source=>'EINHEIT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6181524898761260 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_WERTEBEREICH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 360,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wertebereich',
  p_source=>'WERTEBEREICH',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 1000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6182104412761263 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_AT_BEARB_STATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 450,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'At Bearb Status',
  p_source=>'AT_BEARB_STATUS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6182505149761265 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_SATZ_KENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 470,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satz Kennzeichen',
  p_source=>'SATZ_KENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6184118681761270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_ERGEBNISWERT_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ergebniswert Text Id',
  p_source=>'ERGEBNISWERT_TEXT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6184323481761270 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_ERGEBNISWERT_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ergebniswert Text',
  p_source=>'ERGEBNISWERT_TEXT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6184525665761271 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_LABOR_ANALYSEKUERZEL_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Laborwert',
  p_source=>'LABOR_ANALYSEKUERZEL_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'PLUGIN_COM_SKILLBUILDERS_SUPER_LOV',
  p_lov=> 'select'||unistr('\000a')||
'  LABOR_ANALYSEKUERZEL_ID ID,'||unistr('\000a')||
'  i.bezeichnung || '' (EH:'' || REZEPTE.GET_BEZUG_EH_BEZ(REZEPTE.GET_INH_DEF_BEZUG_EH(i.ID),:FAS_SPRACHE_ID) || '',ID:'' || i.ID || '',K:'' || lak.ANALYSEKUERZEL || '')'' LABORWERT,'||unistr('\000a')||
'  ''<ul><li>'' || l.BEZEICHNUNG || ''</li></ul>'' LABOR,'||unistr('\000a')||
'  law.INHSTOFF_ID'||unistr('\000a')||
'from V_LABOR_ANALYSEWERTE law, INHSTOFFE i, labors l, LABOR_ANALYSEKUERZEL lak'||unistr('\000a')||
'WHERE'||unistr('\000a')||
'    law.ID = :P328_ID'||unistr('\000a')||
'    AND law.SATZ_KENNZEICHEN is null'||unistr('\000a')||
'    and i.ID = law.inhstoff_id'||unistr('\000a')||
'    and l.id = law.labor_id'||unistr('\000a')||
'    and law.LABOR_ANALYSEKUERZEL_ID = lak.ID'||unistr('\000a')||
'union all'||unistr('\000a')||
'select -- Auf jeden Fall alle Laborwerte die das aktuelle Labor hat'||unistr('\000a')||
'  lak.ID,'||unistr('\000a')||
'  i.bezeichnung || '' (EH:'' || REZEPTE.GET_BEZUG_EH_BEZ(REZEPTE.GET_INH_DEF_BEZUG_EH(i.ID),:FAS_SPRACHE_ID)  || '',ID:'' || i.ID || '',K:'' || lak.ANALYSEKUERZEL || '')'' LABORWERT,'||unistr('\000a')||
'  ''<ul><li>'' || l.BEZEICHNUNG || ''</li></ul>'' LABOR,'||unistr('\000a')||
'  lak.INHSTOFF_ID'||unistr('\000a')||
'from LABOR_ANALYSEKUERZEL lak, labors l, inhstoffe i'||unistr('\000a')||
'where'||unistr('\000a')||
'  lak.labor_id = :P328_LABOR_ID'||unistr('\000a')||
'  and lak.satz_kennzeichen is null'||unistr('\000a')||
'  and l.id = lak.labor_id'||unistr('\000a')||
'  and i.id = lak.inhstoff_id'||unistr('\000a')||
'  and i.id not in( -- Nur Werte die noch nicht vorhanden sind'||unistr('\000a')||
'    select inhstoff_id'||unistr('\000a')||
'    from V_LABOR_ANALYSEWERTE'||unistr('\000a')||
'    where AUFTRAG_ID_INTERN = :P328_AUFTRAG_ID_INTERN'||unistr('\000a')||
'       and satz_kennzeichen is null'||unistr('\000a')||
'  )'||unistr('\000a')||
'union all'||unistr('\000a')||
'select -- Laborwerte die auch andere Labore anbieten. Nimm einfach ein beliebiges'||unistr('\000a')||
'  lak.ID,'||unistr('\000a')||
'  i.bezeichnung || '' (EH:'' || REZEPTE.GET_BEZUG_EH_BEZ(REZEPTE.GET_INH_DEF_BEZUG_EH(i.ID),:FAS_SPRACHE_ID) || '',ID:'' || i.ID || '',K:'' || lak.ANALYSEKUERZEL || '')'' LABORWERT,'||unistr('\000a')||
'  ''<ul>'' || ('||unistr('\000a')||
'        SELECT DISTINCT listagg(''<li>'' || l2.BEZEICHNUNG || ''</li>'','''') within group (order by l2.bezeichnung)'||unistr('\000a')||
'        FROM LABORS l2'||unistr('\000a')||
'        where'||unistr('\000a')||
'            l2.ID in('||unistr('\000a')||
'                select labor_id'||unistr('\000a')||
'                from LABOR_ANALYSEKUERZEL lak2'||unistr('\000a')||
'                where lak2.INHSTOFF_ID = lak.INHSTOFF_ID'||unistr('\000a')||
'                    and (:P328_LABOR_ID is null or l2.ID <> :P328_LABOR_ID)'||unistr('\000a')||
'            )'||unistr('\000a')||
'  ) || ''</ul>'' LABORE,'||unistr('\000a')||
'  lak.INHSTOFF_ID'||unistr('\000a')||
'from LABOR_ANALYSEKUERZEL lak, labors l, inhstoffe i'||unistr('\000a')||
'where'||unistr('\000a')||
'  not exists('||unistr('\000a')||
'      select id'||unistr('\000a')||
'      from LABOR_ANALYSEKUERZEL lak2'||unistr('\000a')||
'      where'||unistr('\000a')||
'        inhstoff_id = lak.inhstoff_id'||unistr('\000a')||
'        and satz_kennzeichen is null'||unistr('\000a')||
'        and lak2.id > lak.id'||unistr('\000a')||
''||unistr('\000a')||
'  )'||unistr('\000a')||
'  and lak.inhstoff_id not in('||unistr('\000a')||
'        select inhstoff_id'||unistr('\000a')||
'        from LABOR_ANALYSEKUERZEL lak3'||unistr('\000a')||
'        where lak3.labor_id = :P328_LABOR_ID'||unistr('\000a')||
'            and satz_kennzeichen is null'||unistr('\000a')||
'  )'||unistr('\000a')||
'  and l.id = lak.labor_id'||unistr('\000a')||
'  and i.id = lak.inhstoff_id'||unistr('\000a')||
'  and i.id not in( -- Nur Werte die noch nicht vorhanden sind'||unistr('\000a')||
'    select inhstoff_id'||unistr('\000a')||
'    from V_LABOR_ANALYSEWERTE'||unistr('\000a')||
'    where AUFTRAG_ID_INTERN = :P328_AUFTRAG_ID_INTERN'||unistr('\000a')||
'       and satz_kennzeichen is null'||unistr('\000a')||
'  )'||unistr('\000a')||
'order by laborwert;',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>'P328_ID',
  p_read_only_when_type=>'ITEM_IS_NOT_NULL',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'Laborwert Auswahl',
  p_attribute_03 => '2,1',
  p_attribute_04 => '1,2,3,4',
  p_attribute_08 => 'NOT_ENTERABLE',
  p_attribute_09 => '15',
  p_attribute_10 => '&nbsp;',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6184708754761271 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_BEZUG_EINHEIT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 270,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'declare'||unistr('\000a')||
'  v_bezug_einheit_id number;'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'  select max(inh_displ.BEZUG_EINHEIT_ID) val'||unistr('\000a')||
'  into v_bezug_einheit_id'||unistr('\000a')||
'  from INH_EH_DISPS inh_displ, labor_analysekuerzel lak'||unistr('\000a')||
'  where'||unistr('\000a')||
'    inh_displ.INHSTOFF_ID = lak.INHSTOFF_ID'||unistr('\000a')||
'    and lak.ID = :P328_LABOR_ANALYSEKUERZEL_ID'||unistr('\000a')||
'    and inh_displ.STANDARD = 1;'||unistr('\000a')||
''||unistr('\000a')||
' return v_bezug_einheit_id;'||unistr('\000a')||
'exception'||unistr('\000a')||
'  when no_data_found then'||unistr('\000a')||
'   return null;'||unistr('\000a')||
'  when others then'||unistr('\000a')||
'    return null;'||unistr('\000a')||
'end;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'Einheit',
  p_source=>'BEZUG_EINHEIT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select'||unistr('\000a')||
'  REZEPTE.GET_BEZUG_EH_BEZ(inh_displ.BEZUG_EINHEIT_ID,:FAS_SPRACHE_ID) bez,'||unistr('\000a')||
'  inh_displ.BEZUG_EINHEIT_ID val'||unistr('\000a')||
'from INH_EH_DISPS inh_displ, labor_analysekuerzel lak'||unistr('\000a')||
'where'||unistr('\000a')||
'  inh_displ.INHSTOFF_ID = lak.INHSTOFF_ID'||unistr('\000a')||
'  and lak.ID = :P328_LABOR_ANALYSEKUERZEL_ID'||unistr('\000a')||
'order by inh_displ.STANDARD desc, bez',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_tag_attributes  => 'style="margin-left:5px;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'NO',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6185325598761272 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_MIN_WERTEBEREICH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 370,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Min. Normwert',
  p_source=>'MIN_WERTEBEREICH',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6185519611761273 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_MAX_WERTEBEREICH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Max. Normwert',
  p_source=>'MAX_WERTEBEREICH',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6185723513761273 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_LABOR_FAS_ERSATZWERT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Labor Ersatzwert',
  p_source=>'LABOR_FAS_ERSATZWERT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select '||unistr('\000a')||
'  BEZEICHNUNG || '' ('' || KUERZEL || '')'' bez,'||unistr('\000a')||
'  ID val'||unistr('\000a')||
'from LABOR_FAS_ERSATZWERTE'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'order by bez',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6185914608761274 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_LABOR_AUFTRAG_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 640,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '5',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Labor Status',
  p_source=>'LABOR_AUFTRAG_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select'||unistr('\000a')||
' KUERZEL || '': '' || BEZEICHNUNG bez,'||unistr('\000a')||
'  ID val'||unistr('\000a')||
'from LABOR_AUFTRAG_STATUS'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'order by bez',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6186108978761276 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_AUFTRAG_ID_INTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Auftrag Id Intern',
  p_source=>'AUFTRAG_ID_INTERN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6202809984254417 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_LABOR_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 650,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Labor Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6405513312463537 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_DISPLAY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'select ''Zahl'' bez , 0 val from dual'||unistr('\000a')||
'union all'||unistr('\000a')||
'select ''Ersatzwert'' bez, 1 val from dual ',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '2',
  p_attribute_02 => 'NONE',
  p_attribute_04 => 'HORIZONTAL',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6408930922546513 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_ID_DISPLAY',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'P328_ID',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'P328_ID',
  p_display_when_type=>'ITEM_IS_NOT_NULL',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6411501136590678 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 328,
  p_name=>'P328_LABOR_ANALYSEKUERZEL_DISPL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 6178316565761236+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Laborwert',
  p_source=>'select max(i.bezeichnung || '' ('' || lak.analysekuerzel || '','' || i.ID || '')'')'||unistr('\000a')||
'from labor_analysekuerzel lak, inhstoffe i'||unistr('\000a')||
'where'||unistr('\000a')||
'  lak.id = :P328_LABOR_ANALYSEKUERZEL_ID'||unistr('\000a')||
'  and i.id = lak.inhstoff_id'||unistr('\000a')||
'  and lak.satz_kennzeichen is null',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6222807836197195 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_name => 'Setze LABOR_ANALYSEKUERZEL_ID'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P328_LABOR_ANALYSEKUERZEL_ID'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6223120214197196 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_event_id => 6222807836197195 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin'||unistr('\000a')||
'  :P328_LABOR_ANALYSEKUERZEL_ID := :P328_LABOR_ANALYSEKUERZEL_ID;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P328_LABOR_ANALYSEKUERZEL_ID'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6226016075512769 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_event_id => 6222807836197195 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P328_BEZUG_EINHEIT_ID'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6407219181474901 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_name => 'Ein/Ausblenden Ergebniswert Felder'
 ,p_event_sequence => 30
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P328_DISPLAY'
 ,p_triggering_condition_type => 'EQUALS'
 ,p_triggering_expression => '0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6407510610474912 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_event_id => 6407219181474901 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P328_ERGEBNISWERT'
 ,p_attribute_01 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6407710186474915 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_event_id => 6407219181474901 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P328_ERGEBNISWERT'
 ,p_attribute_01 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6407914809477975 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_event_id => 6407219181474901 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P328_LABOR_FAS_ERSATZWERT_ID'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6408110711479883 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_event_id => 6407219181474901 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 30
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P328_LABOR_FAS_ERSATZWERT_ID'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6223229438212864 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_name => 'Einblenden/Ausblenden aller Felder'
 ,p_event_sequence => 40
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P328_LABOR_ANALYSEKUERZEL_ID'
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$v(''P328_LABOR_ANALYSEKUERZEL_ID'').length > 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6223507304212865 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_event_id => 6223229438212864 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P328_EINGANGSDATUM,P328_ERGEBNISWERT,P328_BEZUG_EINHEIT_ID,P328_MIN_WERTEBEREICH,P328_MAX_WERTEBEREICH,P328_LABOR_FAS_ERSATZWERT_ID,P328_LABOR_AUFTRAG_STATUS_ID,P328_DISPLAY,P328_ERGEBNISWERT'
 ,p_attribute_01 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6223727740218596 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_event_id => 6223229438212864 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P328_EINGANGSDATUM,P328_ERGEBNISWERT,P328_BEZUG_EINHEIT_ID,P328_MIN_WERTEBEREICH,P328_MAX_WERTEBEREICH,P328_LABOR_FAS_ERSATZWERT_ID,P328_LABOR_AUFTRAG_STATUS_ID,P328_DISPLAY,P328_ERGEBNISWERT'
 ,p_attribute_01 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6439313365896917 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_name => 'Setzte Standardnormbereich'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P328_BEZUG_EINHEIT_ID'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6439618190896919 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 328
 ,p_event_id => 6439313365896917 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'DECLARE'||unistr('\000a')||
'  v_return number;'||unistr('\000a')||
'  v_inhstoff_id number;'||unistr('\000a')||
'  v_labor_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
' IF :P328_BEZUG_EINHEIT_ID is not null THEN'||unistr('\000a')||
'  BEGIN'||unistr('\000a')||
'    SELECT'||unistr('\000a')||
'        LABOR_ID,'||unistr('\000a')||
'        INHSTOFF_ID'||unistr('\000a')||
'    INTO'||unistr('\000a')||
'        v_labor_id,'||unistr('\000a')||
'        v_inhstoff_id'||unistr('\000a')||
'    FROM LABOR_ANALYSEKUERZEL'||unistr('\000a')||
'    WHERE'||unistr('\000a')||
'        ID = :P328_LABOR_ANALYSEKUERZEL_ID'||unistr('\000a')||
'        AND SATZ_KENNZEICHEN IS NULL;'||unistr('\000a')||
'  EXCEPTION'||unistr('\000a')||
'    WHEN NO_DATA_FOUND THEN'||unistr('\000a')||
'        NULL;'||unistr('\000a')||
'  END;'||unistr('\000a')||
''||unistr('\000a')||
'  IF(v_inhstoff_id is not null) THEN'||unistr('\000a')||
''||unistr('\000a')||
'      v_return := FRGBG_T.LAB_GET_DEF_NORMBEREICH('||unistr('\000a')||
'            p_inhstoff_id => v_inhstoff_id,'||unistr('\000a')||
'            p_bezug_einheit_id => :P328_BEZUG_EINHEIT_ID,'||unistr('\000a')||
'            p_labor_id => v_labor_id,'||unistr('\000a')||
'            p_normbereich_min => :P328_MIN_WERTEBEREICH,'||unistr('\000a')||
'            p_normbereich_max => :P328_MAX_WERTEBEREICH'||unistr('\000a')||
'        );'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
' END IF;'||unistr('\000a')||
'END;'
 ,p_attribute_02 => 'P328_BEZUG_EINHEIT_ID,P328_LABOR_ANALYSEKUERZEL_ID'
 ,p_attribute_03 => 'P328_MIN_WERTEBEREICH,P328_MAX_WERTEBEREICH'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:LABOR_ANALYSEWERTE:P328_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 6209822953567668 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 328,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch from Labor_Analysewerte',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'P328_ID',
  p_process_when_type=>'ITEM_IS_NOT_NULL',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  -- Globale Variablen'||unistr('\000a')||
'    v_PROT_ID number;'||unistr('\000a')||
'    v_ERROR varchar2(32767);'||unistr('\000a')||
'    v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'    c_PROD constant varchar2(100) := ''App: '' || :APP_ID || '' Page: '''||unistr('\000a')||
'       || :APP_PAGE_ID ||'' Prozess Setze Standardwerte'';'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR EXCEPTION;'||unistr('\000a')||
'    c_ERRNR constant number := -20100;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR_D EXCEPTION;'||unistr('\000a')||
'    c_ERRNR_D constant number := -20101';

p:=p||';'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'    begin'||unistr('\000a')||
'        select'||unistr('\000a')||
'            to_char(max(pers.GEBURTSDATUM),''DD.MM.YYYY''),'||unistr('\000a')||
'            max(labor_auftrag_id) LABOR_AUFTRAG_ID,'||unistr('\000a')||
'            max(labor_id) LABOR_ID'||unistr('\000a')||
'        into'||unistr('\000a')||
'            :P328_GEBURTSDATUM,'||unistr('\000a')||
'            :P328_AUFTRAG_ID,'||unistr('\000a')||
'            :P328_LABOR_ID'||unistr('\000a')||
'        from warenkorb_details wkd, warenkoerbe wk, personenstamm pers'||unistr('\000a')||
'   ';

p:=p||'     where'||unistr('\000a')||
'            wkd.WARENKORB_ID = :P328_AUFTRAG_ID_INTERN'||unistr('\000a')||
'            and wk.PERSSTAMM_ID_KUNDE = pers.ID'||unistr('\000a')||
'            and wk.ID = :P328_AUFTRAG_ID_INTERN ;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    exception '||unistr('\000a')||
'        when no_data_found then'||unistr('\000a')||
'            null;'||unistr('\000a')||
'        when others then'||unistr('\000a')||
'            v_error := ''Fehler beim Abrufen der Standardwerte um ein Labowert hinzuzufügen. SQLERRM: '' || SQLERRM;'||unistr('\000a')||
'            v_errnr := -10;'||unistr('\000a')||
' ';

p:=p||'   end;'||unistr('\000a')||
''||unistr('\000a')||
'exception'||unistr('\000a')||
'    when e_ERROR then'||unistr('\000a')||
'       MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'    when e_ERROR_D then'||unistr('\000a')||
'       raise; -- Einfach durchreichen'||unistr('\000a')||
'    when others then'||unistr('\000a')||
'       v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLE';

p:=p||'RRM:'' || SQLERRM;'||unistr('\000a')||
'       MEL.P (c_PROD || '': '' || v_error, v_PROT_ID, ''ERROR'','||unistr('\000a')||
'          c_PROD || '': '' ||  dbms_utility.format_error_backtrace);'||unistr('\000a')||
'       raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'       raise;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6201822279018599 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 328,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Setze Default-Werte',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':P328_ID is null and :P328_AUFTRAG_ID_INTERN is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
''||unistr('\000a')||
' FRGBG_T.A102_P328_SPEICH_LABORWERT('||unistr('\000a')||
'        p_id => :P328_ID,'||unistr('\000a')||
'        p_AUFTRAG_ID => :P328_AUFTRAG_ID,'||unistr('\000a')||
'        p_GEBURTSDATUM => :P328_GEBURTSDATUM,'||unistr('\000a')||
'        p_EINGANGSDATUM => to_Date(:P328_EINGANGSDATUM,''DD.MM.YYYY HH24:MI''),'||unistr('\000a')||
'        p_ERGEBNISWERT => CASE WHEN :P328_DISPLAY = 0 THEN :P328_ERGEBNISWERT ELSE null END,'||unistr('\000a')||
'        p_LABOR_ANALYSEKUERZEL_ID => :P328_LABOR_ANALYSEKUERZEL_ID,'||unistr('\000a')||
'   ';

p:=p||'     p_BEZUG_EINHEIT_ID => :P328_BEZUG_EINHEIT_ID,'||unistr('\000a')||
'        p_MIN_WERTEBEREICH => :P328_MIN_WERTEBEREICH,'||unistr('\000a')||
'        p_MAX_WERTEBEREICH => :P328_MAX_WERTEBEREICH,'||unistr('\000a')||
'        p_LABOR_FAS_ERSATZWERT_ID => CASE WHEN :P328_DISPLAY = 1 THEN  :P328_LABOR_FAS_ERSATZWERT_ID ELSE null END,'||unistr('\000a')||
'        p_LABOR_AUFTRAG_STATUS_ID => :P328_LABOR_AUFTRAG_STATUS_ID,'||unistr('\000a')||
'        p_AUFTRAG_ID_INTERN => :P328_AUFTRAG_ID_INTERN'||unistr('\000a')||
'  ';

p:=p||'  );'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6403606667442950 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 328,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Speichere Laborwert',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request in(''SAVE'',''CREATE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Wert gespeichert',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'  frgbg_t.A102_P328_LOESCHE_LABORWERT('||unistr('\000a')||
'    p_id => :P328_ID'||unistr('\000a')||
'  );'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6423216652742153 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 328,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Lösche Laborwert',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'DELETE',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Wert gelöscht',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'328';

wwv_flow_api.create_page_process(
  p_id     => 6186930493761281 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 328,
  p_process_sequence=> 70,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>6178706530761237 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 328
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00329
prompt  ...PAGE 329: Labor-WK-FB-Verwaltung
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 329
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Labor-WK-FB-Verwaltung'
 ,p_step_title => 'Labor-WK-FB-Verwaltung'
 ,p_step_sub_title => 'Labor-WK-FB-Verwaltung'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150519092028'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 18472723782880536 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 329,
  p_plug_name=> 'Ausgewählter Laborauftrag/zugehöriger FB',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'   wkd.ID,'||unistr('\000a')||
'   wkd.warenkorb_id,'||unistr('\000a')||
'   wkd.MENGENART_ID,'||unistr('\000a')||
'   m.kuerzel,'||unistr('\000a')||
'   l.bezeichnung,'||unistr('\000a')||
'   wkd.labor_auftrag_id'||unistr('\000a')||
'from WARENKORB_DETAILS wkd, mengenarts m, labors l'||unistr('\000a')||
'where pergebnis_id = :p329_pergebnis_id'||unistr('\000a')||
'  and wkd.mengenart_id = m.id'||unistr('\000a')||
'  and wkd.labor_id = l.id'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 329,
  p_name=> 'Warenkörbe  zum Fragebogen',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => true,
  p_new_grid_row     => true,
  p_new_grid_column  => true,
  p_display_column=> null,
  p_display_point=> 'BODY_1',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_display_when_condition=> 'P329_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P329_HEIGHT_LISTE.px; ">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '500',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> '(null)',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'No data found.',
  p_query_num_rows_type=> 'ROWS_X_TO_Y_OF_Z',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18481823141880565 + wwv_flow_api.g_id_offset,
  p_region_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> 'Select Row',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18478931414880562 + wwv_flow_api.g_id_offset,
  p_region_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 2,
  p_column_heading=> 'Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18504230514127828 + wwv_flow_api.g_id_offset,
  p_region_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_ID',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Warenkorb Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18479616113880563 + wwv_flow_api.g_id_offset,
  p_region_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Mengenart Id',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS',
  p_ref_column_name=> 'MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18513106729456105 + wwv_flow_api.g_id_offset,
  p_region_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Kuerzel',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18513204814456108 + wwv_flow_api.g_id_offset,
  p_region_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG',
  p_column_display_sequence=> 6,
  p_column_heading=> 'Bezeichnung',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 18513308431456108 + wwv_flow_api.g_id_offset,
  p_region_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'LABOR_AUFTRAG_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> 'Labor Auftrag Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 18559626232216827 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 329,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 18473325217880546 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 329,
  p_button_sequence=> 30,
  p_button_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Apply Changes',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18482126516880565 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 329,
  p_button_sequence=> 40,
  p_button_plug_id => 18478725355880560+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_ADD',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Add Row',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.widget.tabular.addRow();',
  p_button_execute_validations=>'N',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18472910614880544 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 329,
  p_button_sequence=> 10,
  p_button_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:324:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18473532682880546 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 329,
  p_button_sequence=> 40,
  p_button_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Create',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18555526093781577 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 329,
  p_button_sequence=> 50,
  p_button_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_PERG_IN_WK_AENDERN',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Pergebnis ID in WK''s ändern',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(''Die Pergebnis-ID auf &P329_PERGEBNIS_ID_NEU. für alle angezeigten Warenkörbe ändern?'',''CHANGE_PERGEBNIS'');',
  p_button_execute_validations=>'N',
  p_button_condition=> ':P329_PERGEBNIS_ID_NEU != :P329_PERGEBNIS_ID',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18473117493880545 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 329,
  p_button_sequence=> 20,
  p_button_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Delete',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'DELETE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 18481924026880565 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 329,
  p_button_sequence=> 20,
  p_button_plug_id => 18478725355880560+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_MRD',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Delete Checked',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''APPLY_CHANGES_MRD'');',
  p_button_execute_validations=>'N',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>18490831644880586 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 329,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:0:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'REQUEST_IN_CONDITION',
  p_branch_condition=> 'SAVE,DELETE,CREATE',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>18491010082880587 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 329,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:329:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18473928945880550 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 329,
  p_name=>'P329_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Geburtsdatum',
  p_source=>'GEBURTSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18476903837880554 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 329,
  p_name=>'P329_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> null,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18509109784193688 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 329,
  p_name=>'P329_AUFTRAG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 15,
  p_item_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Auftrag Id',
  p_source=>'AUFTRAG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18511827864412420 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 329,
  p_name=>'P329_PERGEBNIS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'zugeord. FB-Pergebnis Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18514914228479472 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 329,
  p_name=>'P329_HEIGHT_LISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18526104030560254 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 329,
  p_name=>'P329_PATNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Name',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>18533208367059622 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 329,
  p_name=>'P329_PERGEBNIS_ID_NEU',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 18472723782880536+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'offene FB-Pergebnis Id ',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:LABOR_ANALYSEWERTE:P329_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 18490525753880585 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 329,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from LABOR_ANALYSEWERTE',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:LABOR_ANALYSEWERTE:P329_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 18490117658880585 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 329,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of LABOR_ANALYSEWERTE',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> 'Action Processed.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKORB_DETAILS:ID';

wwv_flow_api.create_page_process(
  p_id     => 18489712871880582 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 329,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_UPDATE',
  p_process_name=> 'ApplyMRU',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKORB_DETAILS:ID';

wwv_flow_api.create_page_process(
  p_id     => 18489911512880583 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 329,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_DELETE',
  p_process_name=> 'ApplyMRD',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '#MRD_COUNT# row(s) deleted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'14';

wwv_flow_api.create_page_process(
  p_id     => 18490328280880585 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 329,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>18449022870840331 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p329_pergebnis_id_neu is not null THEN'||unistr('\000a')||
'      UPDATE warenkorb_details'||unistr('\000a')||
'      set pergebnis_id = :p329_pergebnis_id_neu'||unistr('\000a')||
'      WHERE pergebnis_id = :p329_pergebnis_id;'||unistr('\000a')||
''||unistr('\000a')||
'mel.p(''WK-Laboraufträge umgehängt von Pergebnis-ID %1 auf %2!(Anzahl:%3)'',v_prot_id ,''TEST'',''102/329:change_pergebnis_in_wk'', :p329_pergebnis_id,:p329_pergebnis_id_neu,SQL%ROWCOUNT);'||unistr('\000a')||
'   END ';

p:=p||'IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 18556324062809376 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 329,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'change_pergebnis_in_wk',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request = ''CHANGE_PERGEBNIS''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'    v_auftrag_id_intern number;'||unistr('\000a')||
'    v_anz         number;'||unistr('\000a')||
'    v_persstamm_id  number;'||unistr('\000a')||
'    v_fehlertext     varchar2(2000);'||unistr('\000a')||
'    v_url            varchar2(2000);'||unistr('\000a')||
'    '||unistr('\000a')||
'    v_prot_id     number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --:P329_ID := 83461;'||unistr('\000a')||
'   SELECT auftrag_id_intern '||unistr('\000a')||
'   into v_auftrag_id_intern'||unistr('\000a')||
'   FROM labor_analysewerte'||unistr('\000a')||
'   WHERE id = :P329_id;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_auftrag_id_intern is null THEN'||unistr('\000a')||
'      v_fehlertext := ''';

p:=p||'Die Auftrag_ID_intern ist für diesen Laborauftrag nicht definiert!'';'||unistr('\000a')||
'      v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':324:''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P324_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'      a';

p:=p||'pex_application.g_unrecoverable_error := true;   --- stops all further page processing      '||unistr('\000a')||
''||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT frgbg_s.GET_PERS_NAME(PERSstamm_id_kunde)||'', ''||p.id||'', ''||p.geburtsdatum, p.id'||unistr('\000a')||
'      INTO :P329_PATNAME, v_persstamm_id'||unistr('\000a')||
'      FROM warenkoerbe wk, personenstamm p'||unistr('\000a')||
'      WHERE wk.id =  v_auftrag_id_intern'||unistr('\000a')||
'        and wk.persstamm_id_kunde = p.id'||unistr('\000a')||
'      ;'||unistr('\000a')||
'   '||unistr('\000a')||
'      SELECT min(pergebni';

p:=p||'s_id), count(*)'||unistr('\000a')||
'      INTO :p329_pergebnis_id , v_anz'||unistr('\000a')||
'      FROM warenkorb_details wkd'||unistr('\000a')||
'      WHERE warenkorb_id = v_auftrag_id_intern'||unistr('\000a')||
'      ; '||unistr('\000a')||
'     '||unistr('\000a')||
'      -- Bestimmen des aktuellen, noch nicht ausgewerteten Antwortsets zu der Person, '||unistr('\000a')||
'      -- sofern diese von der Perg-id des Laborauftrags abweicht'||unistr('\000a')||
'      select'||unistr('\000a')||
'           max(pergebnis_id)'||unistr('\000a')||
'      into :p329_pergebnis_id_neu '||unistr('\000a')||
'      FROM v_fb_fas  '||unistr('\000a')||
'';

p:=p||'      WHERE personenstamm_id = v_persstamm_id'||unistr('\000a')||
'        AND perg_akt_version >= 1                -- akt. Antwortset'||unistr('\000a')||
'        AND fragebogen_id = 5                    -- FB'||unistr('\000a')||
'        and mn_rezept_id is null                 -- noch nicht ausgewertet'||unistr('\000a')||
'        '||unistr('\000a')||
'     ;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 18491415519893898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 329,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_laborauftrag',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Komplette Höhe ausnutzen (100% des Maximums)'||unistr('\000a')||
'   :P329_HEIGHT_liste := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 18515028207481649 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 329,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 329
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18491921639929963 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18504020863127826 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'WARENKORB_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18492627028929967 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'MENGENART_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18512825165456101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'KUERZEL',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18512924998456102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'BEZEICHNUNG',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18513013630456102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 18478725355880560 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'LABOR_AUFTRAG_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00350
prompt  ...PAGE 350: Serienbriefauftraege
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 350
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Serienbriefauftraege'
 ,p_step_title => 'Serienbriefauftraege'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Serienbriefauftraege'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20130829142454'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT '||unistr('\000a')||
'  ID ,'||unistr('\000a')||
'  BEZEICHNUNG ,'||unistr('\000a')||
'  ART_ID ,'||unistr('\000a')||
'  fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_ARTEN.BEZEICHNUNG'',ART_ID ,:FAS_SPRACHE_ID) art_id_bez,'||unistr('\000a')||
'  TYP_ID ,'||unistr('\000a')||
'  fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_TYPEN.BEZEICHNUNG'',TYP_ID ,:FAS_SPRACHE_ID) typ_id_bez,'||unistr('\000a')||
'  DOKUMENT_ID_TEXT ,'||unistr('\000a')||
'  DOKUMENT_ID_BETREFF ,'||unistr('\000a')||
'  ABSENDER ,'||unistr('\000a')||
'  MAILSERVER ,'||unistr('\000a')||
'  SPRACHE_ID ,'||unistr('\000a')||
'  (select sp.sprache from sprachen sp where sp.id=sprac';

s:=s||'he_id)  sprache,'||unistr('\000a')||
'  VERANTWORTLICHER,'||unistr('\000a')||
'  persstamm_id_LOGIN,'||unistr('\000a')||
'  persstamm_id_IDENT ,'||unistr('\000a')||
'  PLANDATUM ,'||unistr('\000a')||
'  ISTDATUM ,'||unistr('\000a')||
'  mailadr_intern,'||unistr('\000a')||
'  mailadr_extern,'||unistr('\000a')||
'  mailadr_prot,'||unistr('\000a')||
'  anzahl_testmails,'||unistr('\000a')||
'  BEMERKUNG '||unistr('\000a')||
'FROM sb_auftraege'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'  and typ_id = :p350_sb_auftrag_typ_id'||unistr('\000a')||
';';

wwv_flow_api.create_page_plug (
  p_id=> 4836217520282485 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_plug_name=> '&P350_REGION_TITEL_SB_AUFTRAEGE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow: auto; height: &P350_HEIGHT_SB.px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'SELECT '||unistr('\000a')||
'  ID ,'||unistr('\000a')||
'  BEZEICHNUNG ,'||unistr('\000a')||
'  ART_ID ,'||unistr('\000a')||
'  fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_ARTEN.BEZEICHNUNG'',ART_ID ,:FAS_SPRACHE_ID) art_id_bez,'||unistr('\000a')||
'  TYP_ID ,'||unistr('\000a')||
'  fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_TYPEN.BEZEICHNUNG'',TYP_ID ,:FAS_SPRACHE_ID) typ_id_bez,'||unistr('\000a')||
'  DOKUMENT_ID_TEXT ,'||unistr('\000a')||
'  DOKUMENT_ID_BETREFF ,'||unistr('\000a')||
'  ABSENDER ,'||unistr('\000a')||
'  MAILSERVER ,'||unistr('\000a')||
'  SPRACHE_ID ,'||unistr('\000a')||
'  (select sp.sprache from sprachen sp where sp.id=sprac';

a1:=a1||'he_id)  sprache,'||unistr('\000a')||
'  VERANTWORTLICHER,'||unistr('\000a')||
'  persstamm_id_LOGIN,'||unistr('\000a')||
'  persstamm_id_IDENT ,'||unistr('\000a')||
'  PLANDATUM ,'||unistr('\000a')||
'  ISTDATUM ,'||unistr('\000a')||
'  mailadr_intern,'||unistr('\000a')||
'  mailadr_extern,'||unistr('\000a')||
'  mailadr_prot,'||unistr('\000a')||
'  anzahl_testmails,'||unistr('\000a')||
'  BEMERKUNG '||unistr('\000a')||
'FROM sb_auftraege'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'  and typ_id = :p350_sb_auftrag_typ_id'||unistr('\000a')||
';';

wwv_flow_api.create_worksheet(
  p_id=> 4836418624282487+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_region_id=> 4836217520282485+wwv_flow_api.g_id_offset,
  p_name=> 'Serienbriefauftraege',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '10000',
  p_max_row_count_message=> 'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'Y',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y',
  p_pagination_display_pos=>'BOTTOM_RIGHT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'C',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'Y',
  p_show_highlight=>'Y',
  p_show_computation=>'Y',
  p_show_aggregate=>'Y',
  p_show_chart=>'Y',
  p_show_group_by=>'Y',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'Y',
  p_show_reset=>'Y',
  p_show_download=>'Y',
  p_show_help=>'Y',
  p_download_formats=>'CSV:HTML:EMAIL',
  p_detail_link=>'f?p=&APP_ID.:&P350_DETAIL_PAGE_ID.:&SESSION.::&DEBUG.:&P350_DETAIL_PAGE_ID.:P&P350_DETAIL_PAGE_ID._ID:#ID#',
  p_detail_link_text=>'<img src="#IMAGE_PREFIX#edit_big.gif" alt="">',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'BRIGITTE.NEIDHART',
  p_internal_uid=> 1);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4836504361282490+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID',
  p_display_order          =>1,
  p_column_identifier      =>'A',
  p_column_label           =>'Id',
  p_report_label           =>'Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4836626237282490+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'BEZEICHNUNG',
  p_display_order          =>2,
  p_column_identifier      =>'B',
  p_column_label           =>'Bezeichnung',
  p_report_label           =>'Bezeichnung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4836722702282490+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ART_ID',
  p_display_order          =>3,
  p_column_identifier      =>'C',
  p_column_label           =>'Art Id',
  p_report_label           =>'Art Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'N',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4836828069282490+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'TYP_ID',
  p_display_order          =>4,
  p_column_identifier      =>'D',
  p_column_label           =>'Typ Id',
  p_report_label           =>'Typ Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4836904037282491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'DOKUMENT_ID_TEXT',
  p_display_order          =>5,
  p_column_identifier      =>'E',
  p_column_label           =>'Dokument Id Text',
  p_report_label           =>'Dokument Id Text',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4837009509282491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'DOKUMENT_ID_BETREFF',
  p_display_order          =>6,
  p_column_identifier      =>'F',
  p_column_label           =>'Dokument Id Betreff',
  p_report_label           =>'Dokument Id Betreff',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4837100144282491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ABSENDER',
  p_display_order          =>7,
  p_column_identifier      =>'G',
  p_column_label           =>'Absender',
  p_report_label           =>'Absender',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4837209695282491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'MAILSERVER',
  p_display_order          =>8,
  p_column_identifier      =>'H',
  p_column_label           =>'Mailserver',
  p_report_label           =>'Mailserver',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4837302447282491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'SPRACHE_ID',
  p_display_order          =>9,
  p_column_identifier      =>'I',
  p_column_label           =>'Sprache Id',
  p_report_label           =>'Sprache Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4837521123282491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'PLANDATUM',
  p_display_order          =>11,
  p_column_identifier      =>'K',
  p_column_label           =>'Plandatum',
  p_report_label           =>'Plandatum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4837611406282491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ISTDATUM',
  p_display_order          =>12,
  p_column_identifier      =>'L',
  p_column_label           =>'Istdatum',
  p_report_label           =>'Istdatum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4837721999282491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'BEMERKUNG',
  p_display_order          =>13,
  p_column_identifier      =>'M',
  p_column_label           =>'Bemerkung',
  p_report_label           =>'Bemerkung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4838616215297165+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'PERSSTAMM_ID_LOGIN',
  p_display_order          =>15,
  p_column_identifier      =>'O',
  p_column_label           =>'Persstamm Id Login',
  p_report_label           =>'Persstamm Id Login',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4838707113297165+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'PERSSTAMM_ID_IDENT',
  p_display_order          =>16,
  p_column_identifier      =>'P',
  p_column_label           =>'Persstamm Id Ident',
  p_report_label           =>'Persstamm Id Ident',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4838806328297165+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'MAILADR_INTERN',
  p_display_order          =>17,
  p_column_identifier      =>'Q',
  p_column_label           =>'Mailadr Intern',
  p_report_label           =>'Mailadr Intern',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4838917438297166+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'MAILADR_EXTERN',
  p_display_order          =>18,
  p_column_identifier      =>'R',
  p_column_label           =>'Mailadr Extern',
  p_report_label           =>'Mailadr Extern',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4839014357297166+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'MAILADR_PROT',
  p_display_order          =>19,
  p_column_identifier      =>'S',
  p_column_label           =>'Mailadr Prot',
  p_report_label           =>'Mailadr Prot',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4839122863297166+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ANZAHL_TESTMAILS',
  p_display_order          =>20,
  p_column_identifier      =>'T',
  p_column_label           =>'Anzahl Testmails',
  p_report_label           =>'Anzahl Testmails',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4936719140326487+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ART_ID_BEZ',
  p_display_order          =>21,
  p_column_identifier      =>'U',
  p_column_label           =>'Art',
  p_report_label           =>'Art',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4936831195326491+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'TYP_ID_BEZ',
  p_display_order          =>22,
  p_column_identifier      =>'V',
  p_column_label           =>'Typ',
  p_report_label           =>'Typ',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4937110660361845+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'SPRACHE',
  p_display_order          =>23,
  p_column_identifier      =>'W',
  p_column_label           =>'Sprache',
  p_report_label           =>'Sprache',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 4988529107124167+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'VERANTWORTLICHER',
  p_display_order          =>24,
  p_column_identifier      =>'X',
  p_column_label           =>'Verantwortlicher',
  p_report_label           =>'Verantwortlicher',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'ART_ID_BEZ:BEZEICHNUNG:ABSENDER:PLANDATUM:ISTDATUM:ID';

wwv_flow_api.create_worksheet_rpt(
  p_id => 4837827546282493+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_worksheet_id => 4836418624282487+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'48379',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>15,
  p_report_columns          =>rc1,
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5208330190566599 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 350,
  p_plug_name=> 'Serienbriefaufträge',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4987423379008928 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 350,
  p_button_sequence=> 20,
  p_button_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_NEUER_SB',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P350_BL_ERSTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4931712242201485 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 350,
  p_button_sequence=> 10,
  p_button_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P350_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5348208936899458 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:351:&SESSION.::&DEBUG.:351::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4987423379008928+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p350_sb_auftrag_typ_id= 1',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 26-JUL-2012 11:37 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>5348321750903163 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:355:&SESSION.::&DEBUG.:355::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4987423379008928+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p350_sb_auftrag_typ_id= 2',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 26-JUL-2012 11:37 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>5672013482854077 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:358:&SESSION.::&DEBUG.:358::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4987423379008928+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 40,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p350_sb_auftrag_typ_id= 3',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 26-JUL-2012 11:37 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4931320769194486 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P350_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:350::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4931712242201485+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 140,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4908417892556884 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_name=>'P350_HEIGHT_SB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4931210379191472 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_name=>'P350_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '130',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5323100483349769 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_name=>'P350_SB_AUFTRAG_TYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5323507081503052 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_name=>'P350_REGION_TITEL_SB_AUFTRAEGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5324505443559326 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_name=>'P350_NV_SB_AUFTRAEGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5406205096420881 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_name=>'P350_DETAIL_PAGE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Detail_page',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5538901256758241 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_name=>'P350_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5539111299761111 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 350,
  p_name=>'P350_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 4836217520282485+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_SCROLLREGION_HEIGHT_MAX  NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P350_HEIGHT_SB := :FAS_SCROLLREGION_HEIGHT_MAX * 1;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4908128150550355 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 350,
  p_process_sequence=> 100,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p350_sb_auftrag_typ_id = 1 THEN  --Serienbrief-Emailaufträge'||unistr('\000a')||
'      :P350_REGION_TITEL_SB_AUFTRAEGE:=frgbg_s.holen_uebersetzung(5434,v_sprache_id);'||unistr('\000a')||
'      :P350_NV_SB_AUFTRAEGE := frgbg_s.holen_uebersetzung(5435,v_sprache_id) ;'||unistr('\000a')||
'   ELSIF :p350_sb_auftrag_typ_id = 2 THEN --Serienbrief-Datenexportaufträge'||unistr('\000a')||
'      :P35';

p:=p||'0_REGION_TITEL_SB_AUFTRAEGE:=frgbg_s.holen_uebersetzung(5436,v_sprache_id) ;'||unistr('\000a')||
'      :P350_NV_SB_AUFTRAEGE := frgbg_s.holen_uebersetzung(5437,v_sprache_id) ;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :P350_REGION_TITEL_SB_AUFTRAEGE:=''Serienbrief-Typ unbekannt!!!!'' ;'||unistr('\000a')||
'      :P350_NV_SB_AUFTRAEGE:=''Serienbrief-Typ unbekannt!!!!'' ;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   :p350_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p350_bl_erste';

p:=p||'llen := frgbg_s.holen_uebersetzung(163,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'   --:p300_bl_info  := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_artikelliste := frgbg_s.holen_uebersetzung(3078,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_in_warenkorb   := frgbg_s.holen_uebersetzung(3079,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_zur_kasse := frgbg_s.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'--   :p300_bl_loeschen := frgbg_s.holen_ueber';

p:=p||'setzung(167,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(3591,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   --:P300_BL_INDIV_REZEPT := frgbg_s.holen_uebersetzung(3082,v_sprache_id);'||unistr('\000a')||
'   :P300_BL_SU';

p:=p||'CHEN := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_hide := frgbg_s.holen_uebersetzung(4924,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_show := frgbg_s.holen_uebersetzung(4923,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p300_region_titel_artikel:= frgbg_s.holen_uebersetzung(4858,v_sprache_id);'||unistr('\000a')||
'   :p300_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :P300_REGION_TITEL_ADRESSE := frgbg_s.h';

p:=p||'olen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   --:P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(1569,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_NV_WARENKORB := frgbg_s.holen_uebersetzung(3844,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4908532091560960 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 350,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :p350_sb_auftrag_typ_id = 1 THEN'||unistr('\000a')||
'      :p350_detail_page_id := 351;'||unistr('\000a')||
'   ELSIF :p350_sb_auftrag_typ_id = 2 THEN'||unistr('\000a')||
'      :p350_detail_page_id := 355;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5406628476465474 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 350,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_detail_page_id',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 350
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00351
prompt  ...PAGE 351: SB-Auftragdetails
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 351
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'SB-Auftragdetails'
 ,p_step_title => 'SB-Auftragdetails'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'SB-Auftragdetails'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'  function confirmSpeichern(message, request_ok, request_abbrechen,flag,request)'||unistr('\000a')||
'  {'||unistr('\000a')||
'     // Die Funktion fuehrt eine Confirm-Message aus sofern flag = 1'||unistr('\000a')||
'     // Bei flag = 0 kein Confirm sondern Submit mit request '||unistr('\000a')||
'     // Bei flag = 1 mit Confirm mit Message als Text und falls '||unistr('\000a')||
'     //              Confirm mit ok beantwortet wird, wird req'||
'uest request_ok'||unistr('\000a')||
'     //              sonst request_abbrechen'||unistr('\000a')||
'     var v_confirm;'||unistr('\000a')||
'     '||unistr('\000a')||
'     //alert ( flag);'||unistr('\000a')||
''||unistr('\000a')||
'     if ( flag == 0 )'||unistr('\000a')||
'        {doSubmit(request );'||unistr('\000a')||
'        }    '||unistr('\000a')||
'     else'||unistr('\000a')||
'     {'||unistr('\000a')||
'        if (message == null)'||unistr('\000a')||
'        {'||unistr('\000a')||
'          message = "Sind Sie sicher?";'||unistr('\000a')||
'        }'||unistr('\000a')||
'        v_confirm = confirm(message);'||unistr('\000a')||
'  '||unistr('\000a')||
'        if (v_confirm == true)'||unistr('\000a')||
'        {'||unistr('\000a')||
'          doSubmit(request_ok);'||unistr('\000a')||
'     '||
'   }'||unistr('\000a')||
'        else'||unistr('\000a')||
'        {'||unistr('\000a')||
'          doSubmit(request_abbrechen);'||unistr('\000a')||
'        }'||unistr('\000a')||
'     }'||unistr('\000a')||
'   }'||unistr('\000a')||
'</script>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909145253'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4840703503302232 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 351,
  p_plug_name=> '&P351_REGION_TITEL_SB_AUFTRAEGE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'"ID",'||unistr('\000a')||
'"ID" disp_id,'||unistr('\000a')||
'"SB_AUFTRAG_ID",'||unistr('\000a')||
'"REFERENZ_ID",'||unistr('\000a')||
'"ADRESSAT",'||unistr('\000a')||
'"SPRACHE_ID",'||unistr('\000a')||
'"ISTDATUM",'||unistr('\000a')||
'"SENDEFEHLER",'||unistr('\000a')||
'"GESPERRT",'||unistr('\000a')||
'"CHAMP00",'||unistr('\000a')||
'"CHAMP01",'||unistr('\000a')||
'"CHAMP02",'||unistr('\000a')||
'"CHAMP03",'||unistr('\000a')||
'"CHAMP04",'||unistr('\000a')||
'"CHAMP05",'||unistr('\000a')||
'"CHAMP06",'||unistr('\000a')||
'"CHAMP07",'||unistr('\000a')||
'"CHAMP08",'||unistr('\000a')||
'"CHAMP09",'||unistr('\000a')||
'"CHAMP10",'||unistr('\000a')||
'"CHAMP11",'||unistr('\000a')||
'"CHAMP12",'||unistr('\000a')||
'"CHAMP13",'||unistr('\000a')||
'"CHAMP14",'||unistr('\000a')||
'"CHAMP15",'||unistr('\000a')||
'"CHAMP16",'||unistr('\000a')||
'"CHAMP17",'||unistr('\000a')||
'"CHAMP18",'||unistr('\000a')||
'"CHAMP19",'||unistr('\000a')||
'"CHAMP20",'||unistr('\000a')||
'"CHAMP21",'||unistr('\000a')||
'"CHAMP22",'||unistr('\000a')||
'"CHAMP23",'||unistr('\000a')||
'"CHAMP24",'||unistr('\000a')||
'';

s:=s||'"CHAMP25",'||unistr('\000a')||
'"CHAMP26",'||unistr('\000a')||
'"CHAMP27",'||unistr('\000a')||
'"CHAMP28",'||unistr('\000a')||
'"CHAMP29",'||unistr('\000a')||
'"CHAMP30",'||unistr('\000a')||
'"CHAMP31",'||unistr('\000a')||
'"CHAMP32",'||unistr('\000a')||
'"CHAMP33",'||unistr('\000a')||
'"CHAMP34",'||unistr('\000a')||
'"CHAMP35",'||unistr('\000a')||
'"CHAMP36",'||unistr('\000a')||
'"CHAMP37",'||unistr('\000a')||
'"CHAMP38",'||unistr('\000a')||
'"CHAMP39",'||unistr('\000a')||
'"CHAMP40",'||unistr('\000a')||
'"CHAMP41",'||unistr('\000a')||
'"CHAMP42",'||unistr('\000a')||
'"CHAMP43",'||unistr('\000a')||
'"CHAMP44",'||unistr('\000a')||
'"CHAMP45",'||unistr('\000a')||
'"CHAMP46",'||unistr('\000a')||
'"CHAMP47",'||unistr('\000a')||
'"CHAMP48",'||unistr('\000a')||
'"CHAMP49",'||unistr('\000a')||
'"CHAMP50"'||unistr('\000a')||
'from SB_AUFTRAGDETAILS '||unistr('\000a')||
'where SB_AUFTRAG_ID = :P351_ID'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 351,
  p_name=> 'Auftragdetails',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_display_when_condition=> 'P351_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P351_HEIGHT_SBDETAILS.px; max-width:1200px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(:P351_REPORT_TITEL||:p351_REPORT_TITEL_CHAMP);',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '100',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'No data found.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4847905127302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4848025427302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 59,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5245804710175049 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'DISP_ID',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_link=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.::P352_SB_AUFTRAG_ID,P352_ID,P352_ZURUECK_ZUR_SEITE:#SB_AUFTRAG_ID#,#DISP_ID#,&APP_PAGE_ID.',
  p_column_linktext=>'<img src="#IMAGE_PREFIX#edit_big.gif" alt="">',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4848123027302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'SB_AUFTRAG_ID',
  p_column_display_sequence=> 60,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_default=> 'P351_ID',
  p_column_default_type=> 'ITEM',
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'SB_AUFTRAG_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5494906765556888 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'REFERENZ_ID',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4848310499302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'ADRESSAT',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'DISPLAY_AND_SAVE',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '25',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'ADRESSAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4848426918302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'SPRACHE_ID',
  p_column_display_sequence=> 61,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'SELECT_LIST_FROM_QUERY',
  p_inline_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  --and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'SPRACHE_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4846510538302243 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'ISTDATUM',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '12',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'ISTDATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5292220702432010 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'SENDEFEHLER',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4846624016302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'GESPERRT',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'SELECT_LIST_FROM_QUERY',
  p_inline_lov=> 'SELECT ''gesperrt'' a, 1 from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''aktiv'' a, 0 from dual',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_default=> '0',
  p_column_default_type=> 'FUNCTION',
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'GESPERRT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4846725289302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP00',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP00',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4846819742302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP01',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP01',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4846927098302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP02',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP02',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4847030572302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP03',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP03',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4847115733302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP04',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP04',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4847204831302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP05',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP05',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4847328890302244 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP06',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP06',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4950823357536814 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP07',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4950901535536816 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP08',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951001010536816 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP09',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951106073536816 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP10',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951223639536816 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP11',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951315801536816 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP12',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951422328536816 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP13',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951516320536816 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP14',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951618606536819 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP15',
  p_column_display_sequence=> 23,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951732068536819 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 27,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP16',
  p_column_display_sequence=> 24,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951815825536819 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 28,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP17',
  p_column_display_sequence=> 25,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4951901926536822 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 29,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP18',
  p_column_display_sequence=> 26,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952002556536822 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 30,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP19',
  p_column_display_sequence=> 27,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952100172536822 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 31,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP20',
  p_column_display_sequence=> 28,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952209239536822 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 32,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP21',
  p_column_display_sequence=> 29,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952319121536822 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 33,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP22',
  p_column_display_sequence=> 30,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952425253536822 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 34,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP23',
  p_column_display_sequence=> 31,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952508789536822 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 35,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP24',
  p_column_display_sequence=> 32,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952614218536822 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 36,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP25',
  p_column_display_sequence=> 33,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952702385536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 37,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP26',
  p_column_display_sequence=> 34,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952819649536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 38,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP27',
  p_column_display_sequence=> 35,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4952912403536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 39,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP28',
  p_column_display_sequence=> 36,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953024955536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 40,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP29',
  p_column_display_sequence=> 37,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953113692536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 41,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP30',
  p_column_display_sequence=> 38,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953204965536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 42,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP31',
  p_column_display_sequence=> 39,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953320936536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 43,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP32',
  p_column_display_sequence=> 40,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953427131536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 44,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP33',
  p_column_display_sequence=> 41,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953522062536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 45,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP34',
  p_column_display_sequence=> 42,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953604663536824 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 46,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP35',
  p_column_display_sequence=> 43,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953721917536825 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 47,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP36',
  p_column_display_sequence=> 44,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953820227536825 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 48,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP37',
  p_column_display_sequence=> 45,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4953931583536825 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 49,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP38',
  p_column_display_sequence=> 46,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4954018225536830 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 50,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP39',
  p_column_display_sequence=> 47,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4954102820536830 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 51,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP40',
  p_column_display_sequence=> 48,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4986426476766532 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 52,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP41',
  p_column_display_sequence=> 49,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4986511942766532 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 53,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP42',
  p_column_display_sequence=> 50,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4986632698766533 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 54,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP43',
  p_column_display_sequence=> 51,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4986709599766533 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 55,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP44',
  p_column_display_sequence=> 52,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4986830752766533 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 56,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP45',
  p_column_display_sequence=> 53,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4986900194766533 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 57,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP46',
  p_column_display_sequence=> 54,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4987016719766533 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 58,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP47',
  p_column_display_sequence=> 55,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4987122513766533 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 59,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP48',
  p_column_display_sequence=> 56,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4987207925766533 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 60,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP49',
  p_column_display_sequence=> 57,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 4987318237766533 + wwv_flow_api.g_id_offset,
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 61,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP50',
  p_column_display_sequence=> 58,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5209403833606257 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 351,
  p_plug_name=> 'NVAuftragdetails',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5375219568701673 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 25,
  p_button_plug_id => 4846308482302243+wwv_flow_api.g_id_offset,
  p_button_name    => 'AKTUALISIEREN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Aktualisieren',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P351_ID is not null and :p351_flag_sql_basiert = 1 and :p351_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5254212555488696 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 30,
  p_button_plug_id => 4846308482302243+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstellen',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:352:P352_SB_AUFTRAG_ID,P352_ZURUECK_ZUR_SEITE:&P351_ID.,&APP_PAGE_ID.',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p351_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5368308722790190 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 30,
  p_button_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE_AKTUALISIEREN',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmSpeichern(''Die Selektionsparameter haben sich geändert! Sollen die Auftragdetail-Daten auch aktualisiert werden?'', ''SAVE_AKTUALISIEREN'', ''SAVE'',$x(''P351_FLAG_AKTUALISIEREN'').value,''SAVE'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P351_ID is not null and :p351_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4848717594302246 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 40,
  p_button_plug_id => 4846308482302243+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_ADD1',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstellen',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:addRow();',
  p_button_execute_validations=>'N',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4841709840302233 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 50,
  p_button_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_PREVIOUS_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&lt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P351_ID_PREV',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4841900853302233 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 60,
  p_button_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_NEXT_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&gt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_NEXT_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P351_ID_NEXT',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4893726572842437 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 70,
  p_button_plug_id => 4846308482302243+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_ADD',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P351_ID is not null and :p351_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4841132006302233 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 10,
  p_button_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:350:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5266625116549168 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 80,
  p_button_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_button_name    => 'TEST',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'SB Testen',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'select 1 '||unistr('\000a')||
'from "#OWNER#"."SB_AUFTRAGDETAILS"'||unistr('\000a')||
'where "SB_AUFTRAG_ID" = :P351_ID',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5266910487563869 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 90,
  p_button_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_button_name    => 'AUSLOESEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'SB Auslösen',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'select 1 '||unistr('\000a')||
'from "#OWNER#"."SB_AUFTRAGDETAILS"'||unistr('\000a')||
'where "SB_AUFTRAG_ID" = :P351_ID and :p351_istdatum is null',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4841500182302233 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 40,
  p_button_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P351_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4840926136302232 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 20,
  p_button_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> ':P351_ID is not null and :p351_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4848525059302244 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 351,
  p_button_sequence=> 20,
  p_button_plug_id => 4846308482302243+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_MRD',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Markierte Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''APPLY_CHANGES_MRD'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'select 1 '||unistr('\000a')||
'from "#OWNER#"."SB_AUFTRAGDETAILS"'||unistr('\000a')||
'where "SB_AUFTRAG_ID" = :P351_ID  and :p351_istdatum is null',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4852804927302251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&FLOW_ID.:351:&SESSION.::&DEBUG.::P351_ID:&P351_ID_NEXT.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4841900853302233+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>4853032004302251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&FLOW_ID.:351:&SESSION.::&DEBUG.::P351_ID:&P351_ID_PREV.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4841709840302233+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>4852605172302251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:350:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_branch_condition_type=> 'REQUEST_IN_CONDITION',
  p_branch_condition=> 'DELETE,CREATE',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>4874015588492748 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:360:&SESSION.::&DEBUG.:360:P360_DOKUMENT_ID,P360_SPRACHAUSWAHL,P360_ZURUECK_ZUR_SEITE:&P351_DOKUMENT_ID_TEXT.,&P351_SPRACHE_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4873404806461271+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 50,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 25-MAY-2012 10:29 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4894116885915339 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:361:&SESSION.::&DEBUG.:361:P361_DOKUMENT_ID,P361_SPRACHAUSWAHL,P361_ZURUECK_ZUR_SEITE:&P351_DOKUMENT_ID_BETREFF.,&P351_SPRACHE_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4894032684910416+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 60,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 25-MAY-2012 10:29 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>4853201336302252 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:351:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4842123035302236 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_VERANTWORTLICHER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verantwortlich',
  p_source=>'VERANTWORTLICHER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4842310941302236 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 75,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'sysdate',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Plandatum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4842528097302236 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_ISTDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 77,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Istdatum',
  p_source=>'ISTDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4842722394302238 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4842927010302238 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_MUTDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutdat',
  p_source=>'MUTDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4843104390302238 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4843327228302238 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_ID_NEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P201_ID_NEXT',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4843505043302238 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_ID_COUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 46,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_tag_attributes  => 'class="fielddata"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4843719569302238 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_ID_PREV',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 220,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P201_ID_PREV',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4843914590302240 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 44,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4844126242302240 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_BEZEICHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEZEICHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4844301872302240 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_ART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_ARTEN.BEZEICHNUNG'',ID ,:FAS_SPRACHE_ID) bez, id'||unistr('\000a')||
'FROM sb_auftrag_arten',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p351_id is not null',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4844512008302240 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_TYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 43,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '&P350_SB_AUFTRAG_TYP_ID.',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TYP_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_TYPEN.BEZEICHNUNG'',ID ,:FAS_SPRACHE_ID) bez, id'||unistr('\000a')||
'FROM sb_auftrag_typen',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4844704246302240 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_DOKUMENT_ID_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Text',
  p_source=>'DOKUMENT_ID_TEXT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4844911704302241 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_DOKUMENT_ID_BETREFF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>' Betreff',
  p_source=>'DOKUMENT_ID_BETREFF',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4845122382302241 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_ABSENDER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Absender',
  p_source=>'ABSENDER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4845302560302241 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_MAILSERVER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 84,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'hep-exchg.hepart.local',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mailserver',
  p_source=>'MAILSERVER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4845528261302241 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '357',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  --and s.sprache_id in (select sprache_id from uebersetzungen) -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4845722606302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4845919189302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_SATZ_KENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satz Kennzeichen',
  p_source=>'SATZ_KENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4846109986302243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_ERFDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfdat',
  p_source=>'ERFDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4860506061034542 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> ':FAS_LOGIN_PERSONENSTAMM_ID',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Login',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4860905499043871 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_PERSSTAMM_ID_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> ':FAS_IDENTITAET_PERSSTAMM_ID',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Ident',
  p_source=>'PERSSTAMM_ID_IDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4873404806461271 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_BUT_DOKUMENT_BEARBEITEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 91,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'APPLY_CHANGES_DOKUMENT',
  p_prompt=>'Bearbeiten',
  p_source=>'APPLY_CHANGES_DOKUMENT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4894032684910416 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_BUT_BETREFF_BEARBEITEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 96,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'APPLY_CHANGES_BETREFF',
  p_prompt=>'Bearbeiten',
  p_source=>'APPLY_CHANGES_BETREFF',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4910521795614732 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_HEIGHT_SBDETAILS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 4846308482302243+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4921216779393470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_MAILADR_INTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Testmail intern',
  p_source=>'MAILADR_INTERN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4921432016397874 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_MAILADR_EXTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 87,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Testmail extern',
  p_source=>'MAILADR_EXTERN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4922407606428729 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_MAILADR_PROT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 89,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'sb_auftraege@hepart.ch',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Protkollmail',
  p_source=>'MAILADR_PROT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5350026588179032 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_REGION_TITEL_SB_AUFTRAEGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5353916710725516 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_IDENT_LISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 83,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identität',
  p_source=>'IDENT_LISTE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_patientenzugriff != 1   /* 1=spez. Betreuerzugriff */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5354313771762514 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_DATUM_VON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Selektion Datum von',
  p_format_mask=>'DD.MM.RRRR',
  p_source=>'DATUM_VON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 25,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>':p351_flag_sql_basiert = 1 or :p351_id is null /* Mailart kann noch gewechselt werden und dann sind die Felder nötig */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5354528316766677 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_DATUM_BIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Datum bis',
  p_format_mask=>'DD.MM.RRRR',
  p_source=>'DATUM_BIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 25,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>':p351_flag_sql_basiert = 1 or :p351_id is null /* Mailart kann noch gewechselt werden und dann sind die Felder nötig */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5367228237729513 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_PERSSTAMM_ID_WAHLIDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 82,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identität',
  p_source=>'PERSSTAMM_ID_WAHLIDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT substr(p.name,1,30)||'', ''||substr(p.ort,1,30)||'', ''||p.id a, p.id b'||unistr('\000a')||
'FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'  AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'  AND p.betreuer = ''I'''||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(511,:fas_sprache_id), 0'||unistr('\000a')||
'from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p351_flag_sql_basiert = 1 or :p351_id is null /* Mailart kann noch gewechselt werden und dann sind die Felder nötig */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5368711062809754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_FLAG_AKTUALISIEREN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 79,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> ':P351_FLAG_SQL_BASIERT',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Aktual',
  p_source=>'FLAG_AKTUALISIEREN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5470002354459380 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_FLAG_SQL_BASIERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 78,
  p_item_plug_id => 4840703503302232+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'flag_sql',
  p_source=>'select CASE WHEN sql_statement is null THEN 0'||unistr('\000a')||
'       ELSE 1'||unistr('\000a')||
'       END'||unistr('\000a')||
'from sb_auftrag_arten'||unistr('\000a')||
'where id = :p351_art_id',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5531016639999181 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_REPORT_TITEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 4846308482302243+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5531226682002090 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 351,
  p_name=>'P351_REPORT_TITEL_CHAMP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 4846308482302243+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4849428711302247 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => 4846308482302243 + wwv_flow_api.g_id_offset,
  p_validation_name => 'SPRACHE_ID must be numeric',
  p_validation_sequence=> 50,
  p_validation => 'SPRACHE_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_always_execute=>'N',
  p_validation_condition=> ':request like (''APPLY_CHANGES_ADD'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_column=> 'SPRACHE_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4849830122302247 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => 4846308482302243 + wwv_flow_api.g_id_offset,
  p_validation_name => 'GESPERRT not null',
  p_validation_sequence=> 70,
  p_validation => 'GESPERRT',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_always_execute=>'N',
  p_validation_condition=> ':request like (''APPLY_CHANGES_ADD'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_column=> 'GESPERRT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4850002892302247 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => 4846308482302243 + wwv_flow_api.g_id_offset,
  p_validation_name => 'GESPERRT must be numeric',
  p_validation_sequence=> 70,
  p_validation => 'GESPERRT',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_always_execute=>'N',
  p_validation_condition=> ':request like (''APPLY_CHANGES_ADD'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_column=> 'GESPERRT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5221832464106582 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => 4846308482302243 + wwv_flow_api.g_id_offset,
  p_validation_name => 'ADRESSAT',
  p_validation_sequence=> 80,
  p_validation => 'ADRESSAT',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => 'Feld ist eingabepflichtig!',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''APPLY_CHANGES_ADD'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_column=> 'ADRESSAT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4992403854343920 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => 4846308482302243 + wwv_flow_api.g_id_offset,
  p_validation_name => 'P351_EMAIL_absender_not_null',
  p_validation_sequence=> 210,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P351_absender IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             ''Email-Absender''));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN null;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4845122382302241 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4991904762334680 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => 4846308482302243 + wwv_flow_api.g_id_offset,
  p_validation_name => 'P351_EMAIL_absender',
  p_validation_sequence=> 215,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_fehler    VARCHAR2(2000);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_fehler := frgbg_t.check_email(:P351_absender);'||unistr('\000a')||
'   IF v_fehler is not null THEN'||unistr('\000a')||
'     RETURN v_fehler||'' (Absender)'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4845122382302241 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5210815458798842 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => 4846308482302243 + wwv_flow_api.g_id_offset,
  p_validation_name => 'P351_EMAIL_adrintern',
  p_validation_sequence=> 225,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_fehler    VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_fehler := frgbg_t.check_email(:P351_MAILADR_INTERN);'||unistr('\000a')||
'   IF v_fehler is not null THEN'||unistr('\000a')||
'     RETURN v_fehler||'' (Testmail intern)'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4921216779393470 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5211109702806687 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => 4846308482302243 + wwv_flow_api.g_id_offset,
  p_validation_name => 'P351_EMAIL_adrextern',
  p_validation_sequence=> 235,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_fehler    VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_fehler := frgbg_t.check_email(:P351_MAILADR_EXTERN);'||unistr('\000a')||
'   IF v_fehler is not null THEN'||unistr('\000a')||
'     RETURN v_fehler|| '' (Testmail extern)'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4921432016397874 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5211428748812119 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => 4846308482302243 + wwv_flow_api.g_id_offset,
  p_validation_name => 'P351_EMAIL_MAILADR_PROT',
  p_validation_sequence=> 245,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_fehler    VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_fehler := frgbg_t.check_email(:P351_MAILADR_PROT);'||unistr('\000a')||
'   IF v_fehler is not null THEN'||unistr('\000a')||
'     RETURN v_fehler|| '' (Protokollmail)'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 4922407606428729 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5363121622606894 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P351_DATUM_VON',
  p_validation_sequence=> 265,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P351_datum_von IS NULL and :p351_flag_sql_basiert = 1 THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             ''Datum von''));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN null;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 5354313771762514 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5363309286612803 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P351_DATUM_BIS',
  p_validation_sequence=> 275,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P351_datum_bis IS NULL and :p351_flag_sql_basiert = 1  THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             ''Datum bis''));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN null;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 5354528316766677 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5362325947570245 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'Datum_von_datum_bis',
  p_validation_sequence=> 290,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF to_date(:p351_datum_von,''DD:MM:YYYY'') > '||unistr('\000a')||
'      to_date(:p351_datum_bis,''DD:MM:YYYY'') THEN'||unistr('\000a')||
'      RETURN(''Datum von muss kleiner oder gleich Datum bis sein!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 5354313771762514 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5470932661506030 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 351
 ,p_name => 'set_sb_art'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P351_ART_ID'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
 ,p_display_when_type => 'PLSQL_EXPRESSION'
 ,p_display_when_cond => ':p351_id is null'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5471605253506032 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 351
 ,p_event_id => 5470932661506030 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P351_BEZEICHNUNG'
 ,p_attribute_01 => 'PLSQL_EXPRESSION'
 ,p_attribute_04 => 'fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_ARTEN.BEZEICHNUNG'',:p351_art_id ,:FAS_SPRACHE_ID) ||'' ''||to_char(sysdate,''DD.MM.YYYY hh24:mi'')'
 ,p_attribute_07 => 'P351_ART_ID'
 ,p_attribute_08 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5471231248506032 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 351
 ,p_event_id => 5470932661506030 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P351_FLAG_SQL_BASIERT'
 ,p_attribute_01 => 'SQL_STATEMENT'
 ,p_attribute_03 => 'select CASE WHEN sql_statement is null THEN 0'||unistr('\000a')||
'       ELSE 1'||unistr('\000a')||
'       END'||unistr('\000a')||
'from sb_auftrag_arten'||unistr('\000a')||
'where id = :p351_art_id'
 ,p_attribute_07 => 'P351_ART_ID'
 ,p_attribute_08 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5471401238506032 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 351
 ,p_event_id => 5470932661506030 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 30
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P351_FLAG_AKTUALISIEREN'
 ,p_attribute_01 => 'PLSQL_EXPRESSION'
 ,p_attribute_04 => ':P351_FLAG_SQL_BASIERT'
 ,p_attribute_07 => 'P351_FLAG_SQL_BASIERT'
 ,p_attribute_08 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5368906176855682 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 351
 ,p_name => 'set_flag_aktualisieren'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P351_DATUM_VON,P351_DATUM_BIS,P351_PERSSTAMM_ID_WAHLIDENT'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5369216786855682 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 351
 ,p_event_id => 5368906176855682 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P351_FLAG_AKTUALISIEREN'
 ,p_attribute_01 => 'PLSQL_EXPRESSION'
 ,p_attribute_04 => '1 * :P351_FLAG_SQL_BASIERT'
 ,p_attribute_07 => 'P351_FLAG_SQL_BASIERT'
 ,p_attribute_08 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5473217264615091 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 351
 ,p_name => 'set_flag_sql_basiert'
 ,p_event_sequence => 30
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P351_FLAG_SQL_BASIERT'
 ,p_triggering_condition_type => 'EQUALS'
 ,p_triggering_expression => '1'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5473525338615091 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 351
 ,p_event_id => 5473217264615091 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P351_DATUM_VON,P351_DATUM_BIS,P351_PERSSTAMM_ID_WAHLIDENT'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5473725707626992 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 351
 ,p_event_id => 5473217264615091 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P351_DATUM_VON,P351_DATUM_BIS,P351_PERSSTAMM_ID_WAHLIDENT'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_SCROLLREGION_HEIGHT_MAX  NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P351_HEIGHT_SBDETAILS := :FAS_SCROLLREGION_HEIGHT_MAX * 0.60;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4909624434605988 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_report_titel_text_id NUMBER;'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :P351_REGION_TITEL_SB_AUFTRAEGE:=frgbg_s.holen_uebersetzung(5434,v_sprache_id);'||unistr('\000a')||
'   --:P351_NV_SB_AUFTRAEGE := frgbg_s.holen_uebersetzung(5435,v_sprache_id) ;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Report-Header Setzen'||unistr('\000a')||
'   :p351_REPORT_TITEL :=  frgbg_s.holen_uebersetzung(5440,:FAS_SPRACHE_ID);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Column Titel ';

p:=p||'champs je nach Art setzen'||unistr('\000a')||
'   IF :p351_art_id is not null THEN'||unistr('\000a')||
'      SELECT report_titel_text_id INTO v_report_titel_text_id'||unistr('\000a')||
'      FROM sb_auftrag_arten'||unistr('\000a')||
'      WHERE id = :p351_art_id;'||unistr('\000a')||
'      IF v_report_titel_text_id is not null THEN'||unistr('\000a')||
'         :p351_REPORT_TITEL_CHAMP :='||unistr('\000a')||
'              frgbg_s.holen_uebersetzung(v_report_titel_text_id,:FAS_SPRACHE_ID);'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p351_Report_titel_CHAMP :=  ';

p:=p||''||unistr('\000a')||
'          ''CHAMP00:CHAMP01:CHAMP02:CHAMP03:CHAMP04:CHAMP05:CHAMP06:CHAMP07:CHAMP08:CHAMP09:CHAMP10:'''||unistr('\000a')||
'        ||''CHAMP11:CHAMP12:CHAMP13:CHAMP14:CHAMP15:CHAMP16:CHAMP17:CHAMP18:CHAMP19:CHAMP20:'''||unistr('\000a')||
'        ||''CHAMP21:CHAMP22:CHAMP23:CHAMP24:CHAMP25:CHAMP26:CHAMP27:CHAMP28:CHAMP29:CHAMP30:'''||unistr('\000a')||
'        ||''CHAMP31:CHAMP32:CHAMP33:CHAMP34:CHAMP35:CHAMP36:CHAMP37:CHAMP38:CHAMP39:CHAMP40:'''||unistr('\000a')||
'        ||''CHAMP41:';

p:=p||'CHAMP42:CHAMP43:CHAMP44:CHAMP45:CHAMP46:CHAMP47:CHAMP48:CHAMP49:CHAMP50:'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'   :p300_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_info  := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_artikelliste := frgbg_s.holen_uebersetzung(3078,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_in_warenkorb   := frgbg_s.holen_uebersetzung(3079,v_sprache_id);'||unistr('\000a')||
'';

p:=p||'   :p300_bl_zur_kasse := frgbg_s.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'--   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(3591,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_speichern := frgbg_s.holen_uebers';

p:=p||'etzung(172,v_sprache_id);'||unistr('\000a')||
'   --:P300_BL_INDIV_REZEPT := frgbg_s.holen_uebersetzung(3082,v_sprache_id);'||unistr('\000a')||
'   :P300_BL_SUCHEN := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_hide := frgbg_s.holen_uebersetzung(4924,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_show := frgbg_s.holen_uebersetzung(4923,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_REGION_TITEL_KATEGORIE:=NULL;'||unistr('\000a')||
'   :p300_region_titel_artikel:= frgbg_s.holen_u';

p:=p||'ebersetzung(4858,v_sprache_id);'||unistr('\000a')||
'   :p300_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   --:P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(1569,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_NV_WARENKORB := frgbg_s.holen_uebersetzung(3844,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info''';

p:=p||',''button_labels_init'');'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4909828936607305 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'IF :p351_id is null THEN'||unistr('\000a')||
'   :p351_flag_aktualisieren := :p351_flag_sql_basiert;'||unistr('\000a')||
'END IF;';

wwv_flow_api.create_page_process(
  p_id     => 5472326605542089 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 920,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_flag_aktualisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p351_id is null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_dok_id        NUMBER;'||unistr('\000a')||
'   v_dok_uebers_id NUMBER;'||unistr('\000a')||
'   v_return        NUMBER;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'mel.p(''gen_dokument %1'',v_prot_id,''TEST'',''102/351'',:request);'||unistr('\000a')||
'   IF :request in (''APPLY_CHANGES_DOKUMENT'',''CREATE'') and :P351_DOKUMENT_ID_TEXT is null THEN'||unistr('\000a')||
'mel.p(''gen_dokument %1'',v_prot_id,''TEST'',''102/351'',:request);'||unistr('\000a')||
'      /*v_return := gen_dokument;'||unistr('\000a')||
'      IF v_return <= 0 THE';

p:=p||'N'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'         -- Fehler'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      select DOKUMENT_FAS_SEQ.nextval into v_dok_id from dual;'||unistr('\000a')||
'      INSERT INTO dokumente_fas(id,beschreibung,DOKUMENTKATEGORIE_ID) '||unistr('\000a')||
'             VALUES(v_dok_id,''Serienbrief Dokument'',3);'||unistr('\000a')||
'      select DOKUMENTUEBERS_SEQ.nextval into v_dok_uebers_id from dual;'||unistr('\000a')||
'      INSERT INTO dokumentuebersetzungen(id,dokument_id,name,mime_type,sprache_';

p:=p||'id,standard)'||unistr('\000a')||
'             VALUES (v_dok_uebers_id,v_dok_id,''Serienbrief Dokument'',''text/html'',357,1);'||unistr('\000a')||
'      :P351_DOKUMENT_ID_TEXT := v_dok_id;'||unistr('\000a')||
'   ELSIF :request = ''APPLY_CHANGES_BETREFF'' and :P351_DOKUMENT_ID_BETREFF is null  THEN'||unistr('\000a')||
'mel.p(''gen_dokument %1'',v_prot_id,''TEST'',''102/351'',:request);'||unistr('\000a')||
'      /*v_return := gen_dokument;'||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'         -- Fehler'||unistr('\000a')||
'      END ';

p:=p||'IF;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      select DOKUMENT_FAS_SEQ.nextval into v_dok_id from dual;'||unistr('\000a')||
'      INSERT INTO dokumente_fas(id,beschreibung,DOKUMENTKATEGORIE_ID) '||unistr('\000a')||
'             VALUES(v_dok_id,''Serienbrief Betreff'',3);'||unistr('\000a')||
'      select DOKUMENTUEBERS_SEQ.nextval into v_dok_uebers_id from dual;'||unistr('\000a')||
'      INSERT INTO dokumentuebersetzungen(id,dokument_id,name,mime_type,sprache_id,standard)'||unistr('\000a')||
'             VALUES (v_dok_uebers_';

p:=p||'id,v_dok_id,''Serienbrief Betreff'',''text/html'',357,1);'||unistr('\000a')||
'      :P351_DOKUMENT_ID_BETREFF := v_dok_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'mel.p(''gen_dokument ende  %1, %2'',v_prot_id,''TEST'',''102/351'',:request,v_dok_id);'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4915321746986658 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 1,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_dokument',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''APPLY_CHANGES_DOKUMENT'',''APPLY_CHANGES_BETREFF'',''CREATE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :P351_SATZ_KENNZEICHEN := ''Geloescht von ''||:APP_USER||'' am ''||to_char(SYSDATE,''DD.MM.YYYY hh24:mi:ss'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4918117731420713 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 5,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_sb_geloescht',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4840926136302232 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAEGE:P351_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 4852109697302251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of SB_AUFTRAEGE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process row of table SB_AUFTRAEGE.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SAVE'',''SAVE_AKTUALISIEREN'',''CREATE'',''DELETE'',''APPLY_CHANGES_BETREFF'',''APPLY_CHANGES_DOKUMENT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAGDETAILS:ID';

wwv_flow_api.create_page_process(
  p_id     => 4851524429302249 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_UPDATE',
  p_process_name=> 'ApplyMRU',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process update.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request like (''APPLY_CHANGES_ADD'') ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAGDETAILS:ID';

wwv_flow_api.create_page_process(
  p_id     => 4851723713302249 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 4846308482302243 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_DELETE',
  p_process_name=> 'ApplyMRD',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process delete.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'APPLY_CHANGES_MRD',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '#MRD_COUNT# row(s) deleted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'    v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   mel.p(''in test dok:%1, sprache=%2'',v_prot_id,''TEST'',''102/351'',:P351_DOKUMENT_ID_TEXT,:p351_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4889711581237706 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'test',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_ident_liste   sb_auftraege.ident_liste%TYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'  IF :p351_persstamm_id_wahlident = 0 THEN'||unistr('\000a')||
'     SELECT LISTAGG(p.id, '','') WITHIN GROUP (ORDER BY p.id) '||unistr('\000a')||
'     INTO v_ident_liste'||unistr('\000a')||
'     FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'     WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'       AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'       AND p.betreuer = ''I'';'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     v_ident_li';

p:=p||'ste := :p351_persstamm_id_wahlident;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
'  UPDATE sb_auftraege'||unistr('\000a')||
'  SET ident_liste = v_ident_liste,'||unistr('\000a')||
'      flag_aktualisieren = 0'||unistr('\000a')||
'  WHERE id =:p351_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5367709499771420 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_daten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''AKTUALISIEREN'',''SAVE_AKTUALISIEREN'',''CREATE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_return    number;'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :request = ''TEST'' THEN'||unistr('\000a')||
'      v_return := frgbg_t.sb_gen_auftrag(:p351_id,1); -- Testlauf'||unistr('\000a')||
'   ELSIF :request = ''AUSLOESEN'' THEN'||unistr('\000a')||
'      v_return := frgbg_t.sb_gen_auftrag(:p351_id,0); -- Echtlauf'||unistr('\000a')||
'      UPDATE sb_auftraege'||unistr('\000a')||
'      SET istdatum = (SELECT max(istdatum) from sb_auftragdetails where sb_auftrag_id =:p351_id)'||unistr('\000a')||
'      WHERE id = :';

p:=p||'p351_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
' '||unistr('\000a')||
'  IF v_return < 0 THEN -- Mailversandt mit Fehler'||unistr('\000a')||
'      mel.p(''Mailversand mit Fehler! SB-Auftrag %1'',v_prot_id,''ERROR'',''102/351: sb_erstellen'',:p351_id );  '||unistr('\000a')||
'   ELSIF v_return = 0 THEN -- Keine Mail versendet wegen Definitionsfehler'||unistr('\000a')||
'      mel.p(''Kein Mailversand wegen Fehler! SB-Auftrag %1'',v_prot_id,''ERROR'',''102/351: sb_erstellen'',:p351_id );'||unistr('\000a')||
'   ELSE  -- Mailversand ohne Feh';

p:=p||'ler'||unistr('\000a')||
'      mel.p(''Mailversand ohne Fehler! SB-Auftrag %1'',v_prot_id,''INFO'',''102/351: sb_erstellen'',:p351_id );  '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5267324124577176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'sb_erstellen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''AUSLOESEN'',''TEST'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'351';

wwv_flow_api.create_page_process(
  p_id     => 4852321385302251 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 900,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4840926136302232 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:SB_AUFTRAEGE:P351_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 4851916345302249 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from SB_AUFTRAEGE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to fetch row.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAEGE:ID::BEZEICHNUNG::P351_ID:P351_ID_NEXT:P351_ID_PREV::::P351_ID_COUNT:';

wwv_flow_api.create_page_process(
  p_id     => 4851316121302249 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 351,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'GET_NEXT_OR_PREV_PK',
  p_process_name=> 'Get Next or Previous Primary Key Value',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to run Get Next or Previous Primary Key Value process.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 351
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00352
prompt  ...PAGE 352: SB-Auftragdetail
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 352
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'SB-Auftragdetail'
 ,p_step_title => 'SB-Auftragdetail'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'SB-Auftragdetail'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20120815102830'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5172523396399406 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 352,
  p_plug_name=> 'Auftragdetail',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5210216216628813 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 352,
  p_plug_name=> 'SB-Auftragdetail',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5173112662399412 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 352,
  p_button_sequence=> 30,
  p_button_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P352_ID is not null and :p352_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5173503274399412 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 352,
  p_button_sequence=> 50,
  p_button_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_PREVIOUS_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&lt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P352_ID_PREV',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5173729134399412 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 352,
  p_button_sequence=> 60,
  p_button_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_NEXT_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&gt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_NEXT_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P352_ID_NEXT',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5172703810399411 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 352,
  p_button_sequence=> 10,
  p_button_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:&P352_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5173328782399412 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 352,
  p_button_sequence=> 40,
  p_button_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P352_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5172930965399412 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 352,
  p_button_sequence=> 20,
  p_button_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> ':P352_ID is not null and :p352_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'DELETE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5187402070399445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&FLOW_ID.:352:&SESSION.::&DEBUG.::P352_ID:&P352_ID_NEXT.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5173729134399412+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>5187831808399445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&FLOW_ID.:352:&SESSION.::&DEBUG.::P352_ID:&P352_ID_PREV.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5173503274399412+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>5187629762399445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P352_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_branch_condition_type=> 'REQUEST_IN_CONDITION',
  p_branch_condition=> 'DELETE,CREATE',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>5188025754399445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:352:&SESSION.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 40,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5173929139399414 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'/',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5174116310399417 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_SB_AUFTRAG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Auftrag ID/Detail ID',
  p_source=>'SB_AUFTRAG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5174327672399417 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_REFERENZ_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Referenz Id',
  p_source=>'REFERENZ_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5174504323399417 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_ADRESSAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 75,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Adressat',
  p_source=>'ADRESSAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 58,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 3,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5174715565399419 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 29,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprache Id',
  p_source=>'SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5174921987399419 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_ISTDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Istdatum',
  p_source=>'ISTDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5175129625399419 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP12',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP12',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5175308257399419 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP13',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 220,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP13',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5175525221399419 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_SENDEFEHLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 25,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sendefehler',
  p_source=>'SENDEFEHLER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5175701677399419 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_GESPERRT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesperrt',
  p_source=>'GESPERRT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT ''gesperrt'' a, 1 from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''aktiv'' a, 0 from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5175927202399420 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP00',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP00',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5176119733399420 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP01',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP01',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5176303146399420 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP02',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP02',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5176525897399422 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP03',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP03',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5176701740399422 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP04',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP04',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5176903385399422 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP05',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP05',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5177127287399422 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP06',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP06',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5177304664399422 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP07',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP07',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5177521262399422 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP08',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP08',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5177730464399422 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP09',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP09',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5177902632399423 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP10',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP10',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5178110416399423 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP11',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP11',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5178315037399423 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP14',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP14',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5178530526399423 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP15',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP15',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5178711549399425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP16',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP16',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5178922443399425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP17',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP17',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5179117441399425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP18',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 270,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP18',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5179304507399425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP19',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP19',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5179516753399425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP20',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP20',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5179729774399425 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP21',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 300,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP21',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5179911768399426 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP22',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP22',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5180105914399426 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP23',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP23',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5180321819399426 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP24',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP24',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5180504092399426 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP25',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP25',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5180728303399426 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP26',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP26',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5180932485399428 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP27',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 360,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP27',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5181108261399428 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP28',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 370,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP28',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5181324252399428 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP29',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP29',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5181520511399428 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP30',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 390,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP30',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5181719803399428 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP31',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 400,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP31',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5181900428399430 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP32',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 410,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP32',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5182131208399430 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP33',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 420,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP33',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5182309830399430 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP34',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 430,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP34',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5182513660399430 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP35',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 440,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP35',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5182703225399430 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP36',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 450,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP36',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5182919224399430 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP37',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 460,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP37',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5183122918399430 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP38',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 470,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP38',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5183324532399431 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP39',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 480,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP39',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5183500062399431 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP40',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP40',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5183711086399431 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP41',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP41',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5183916930399433 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP42',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP42',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5184101414399436 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP43',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP43',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5184318196399436 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP44',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 530,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP44',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5184500611399436 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP45',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 540,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP45',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5184704791399436 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP46',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 550,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP46',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5184918203399436 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP47',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 560,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP47',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5185122867399436 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP48',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 570,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP48',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5185329362399437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP49',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 580,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP49',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5185519000399437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP50',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 590,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL_CHAMP_P352"',
  p_source=>'CHAMP50',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5185728522399437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_ID_NEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 600,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P352_ID_NEXT',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5185907857399437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_ID_PREV',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 610,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P352_ID_PREV',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5186123811399437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_ID_COUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 27,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_tag_attributes  => 'class="fielddata"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5413630517513360 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 620,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '130',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5516910266562160 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 352,
  p_name=>'P352_CHAMP_LABELS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 5172523396399406+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Champ-labels',
  p_source=>':P&P352_ZURUECK_ZUR_SEITE._REPORT_TITEL_CHAMP',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5221410684052902 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 352,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_email_ADRESSAT',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_fehler    VARCHAR2(2000);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_fehler := frgbg_t.check_email(:P352_ADRESSAT);'||unistr('\000a')||
'   IF v_fehler is not null THEN'||unistr('\000a')||
'     RETURN v_fehler||'' (Adressat)'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''CREATE'',''SAVE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 5174504323399417 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:SB_AUFTRAGDETAILS:P352_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 5187130861399444 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 352,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from SB_AUFTRAGDETAILS',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to fetch row.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAGDETAILS:ID::ID::P352_ID:P352_ID_NEXT:P352_ID_PREV::::P352_ID_COUNT:sb_auftrag_id = <cbchoesc>P352_SB_AUFTRAG_ID';

wwv_flow_api.create_page_process(
  p_id     => 5186918617399444 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 352,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'GET_NEXT_OR_PREV_PK',
  p_process_name=> 'Get Next or Previous Primary Key Value',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to run Get Next or Previous Primary Key Value process.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_report_titel_text_id NUMBER;'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'NULL;'||unistr('\000a')||
''||unistr('\000a')||
'--   :P355_REGION_TITEL_SB_AUFTRAEGE:=frgbg_s.holen_uebersetzung(5434,v_sprache_id);'||unistr('\000a')||
'   --:P355_NV_SB_AUFTRAEGE := frgbg_s.holen_uebersetzung(5435,v_sprache_id) ;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'   :p300_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_info  := frgbg_s.holen_u';

p:=p||'ebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_artikelliste := frgbg_s.holen_uebersetzung(3078,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_in_warenkorb   := frgbg_s.holen_uebersetzung(3079,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_zur_kasse := frgbg_s.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'--   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(3591,v_sprache_id)';

p:=p||';'||unistr('\000a')||
'   :p300_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   --:P300_BL_INDIV_REZEPT := frgbg_s.holen_uebersetzung(3082,v_sprache_id);'||unistr('\000a')||
'   :P300_BL_SUCHEN := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_hide := frgbg_s.holen_uebe';

p:=p||'rsetzung(4924,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_show := frgbg_s.holen_uebersetzung(4923,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_REGION_TITEL_KATEGORIE:=NULL;'||unistr('\000a')||
'   :p300_region_titel_artikel:= frgbg_s.holen_uebersetzung(4858,v_sprache_id);'||unistr('\000a')||
'   :p300_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   --:P300_REGION_T';

p:=p||'ITEL_ADRESSE := frgbg_s.holen_uebersetzung(1569,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_NV_WARENKORB := frgbg_s.holen_uebersetzung(3844,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5523513046638653 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 352,
  p_process_sequence=> 920,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAGDETAILS:P352_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 5186503082399440 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 352,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of SB_AUFTRAGDETAILS',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process row of table SB_AUFTRAGDETAILS.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'352';

wwv_flow_api.create_page_process(
  p_id     => 5186711104399444 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 352,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5172930965399412 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 352
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00355
prompt  ...PAGE 355: SB-Auftragdetails-Datenexport
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 355
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'SB-Auftragdetails-Datenexport'
 ,p_step_title => 'SB-Auftragdetails-Datenexport'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'SB-Auftragdetails-Datenexport'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'  function confirmSpeichern(message, request_ok, request_abbrechen,flag,request)'||unistr('\000a')||
'  {'||unistr('\000a')||
'     // Die Funktion fuehrt eine Confirm-Message aus sofern flag = 1'||unistr('\000a')||
'     // Bei flag = 0 kein Confirm sondern Submit mit request '||unistr('\000a')||
'     // Bei flag = 1 mit Confirm mit Message als Text und falls '||unistr('\000a')||
'     //              Confirm mit ok beantwortet wird, wird req'||
'uest request_ok'||unistr('\000a')||
'     //              sonst request_abbrechen'||unistr('\000a')||
'     var v_confirm;'||unistr('\000a')||
'     '||unistr('\000a')||
'    // alert ( flag);'||unistr('\000a')||
'    // alert ($x(''P355_FLAG_AKTUALISIEREN'').value);'||unistr('\000a')||
''||unistr('\000a')||
'     if ( flag == 0 )'||unistr('\000a')||
'        {doSubmit(request );'||unistr('\000a')||
'        }    '||unistr('\000a')||
'     else'||unistr('\000a')||
'     {'||unistr('\000a')||
'        if (message == null)'||unistr('\000a')||
'        {'||unistr('\000a')||
'          message = "Sind Sie sicher?";'||unistr('\000a')||
'        }'||unistr('\000a')||
'        v_confirm = confirm(message);'||unistr('\000a')||
'  '||unistr('\000a')||
'        if (v_confirm == t'||
'rue)'||unistr('\000a')||
'        {'||unistr('\000a')||
'          doSubmit(request_ok);'||unistr('\000a')||
'        }'||unistr('\000a')||
'        else'||unistr('\000a')||
'        {'||unistr('\000a')||
'          doSubmit(request_abbrechen);'||unistr('\000a')||
'        }'||unistr('\000a')||
'     }'||unistr('\000a')||
'   }'||unistr('\000a')||
'</script>'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909145318'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5378632202749921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 355,
  p_plug_name=> '&P355_REGION_TITEL_SB_AUFTRAEGE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'"ID",'||unistr('\000a')||
'"ID" disp_id,'||unistr('\000a')||
'"SB_AUFTRAG_ID",'||unistr('\000a')||
'"REFERENZ_ID",'||unistr('\000a')||
'"ADRESSAT",'||unistr('\000a')||
'"SPRACHE_ID",'||unistr('\000a')||
'"ISTDATUM",'||unistr('\000a')||
'"SENDEFEHLER",'||unistr('\000a')||
'"GESPERRT",'||unistr('\000a')||
'"CHAMP00",'||unistr('\000a')||
'"CHAMP01",'||unistr('\000a')||
'"CHAMP02",'||unistr('\000a')||
'"CHAMP03",'||unistr('\000a')||
'"CHAMP04",'||unistr('\000a')||
'"CHAMP05",'||unistr('\000a')||
'"CHAMP06",'||unistr('\000a')||
'"CHAMP07",'||unistr('\000a')||
'"CHAMP08",'||unistr('\000a')||
'"CHAMP09",'||unistr('\000a')||
'"CHAMP10",'||unistr('\000a')||
'"CHAMP11",'||unistr('\000a')||
'"CHAMP12",'||unistr('\000a')||
'"CHAMP13",'||unistr('\000a')||
'"CHAMP14",'||unistr('\000a')||
'"CHAMP15",'||unistr('\000a')||
'"CHAMP16",'||unistr('\000a')||
'"CHAMP17",'||unistr('\000a')||
'"CHAMP18",'||unistr('\000a')||
'"CHAMP19",'||unistr('\000a')||
'"CHAMP20",'||unistr('\000a')||
'"CHAMP21",'||unistr('\000a')||
'"CHAMP22",'||unistr('\000a')||
'"CHAMP23",'||unistr('\000a')||
'"CHAMP24",'||unistr('\000a')||
'';

s:=s||'"CHAMP25",'||unistr('\000a')||
'"CHAMP26",'||unistr('\000a')||
'"CHAMP27",'||unistr('\000a')||
'"CHAMP28",'||unistr('\000a')||
'"CHAMP29",'||unistr('\000a')||
'"CHAMP30",'||unistr('\000a')||
'"CHAMP31",'||unistr('\000a')||
'"CHAMP32",'||unistr('\000a')||
'"CHAMP33",'||unistr('\000a')||
'"CHAMP34",'||unistr('\000a')||
'"CHAMP35",'||unistr('\000a')||
'"CHAMP36",'||unistr('\000a')||
'"CHAMP37",'||unistr('\000a')||
'"CHAMP38",'||unistr('\000a')||
'"CHAMP39",'||unistr('\000a')||
'"CHAMP40",'||unistr('\000a')||
'"CHAMP41",'||unistr('\000a')||
'"CHAMP42",'||unistr('\000a')||
'"CHAMP43",'||unistr('\000a')||
'"CHAMP44",'||unistr('\000a')||
'"CHAMP45",'||unistr('\000a')||
'"CHAMP46",'||unistr('\000a')||
'"CHAMP47",'||unistr('\000a')||
'"CHAMP48",'||unistr('\000a')||
'"CHAMP49",'||unistr('\000a')||
'"CHAMP50"'||unistr('\000a')||
'from SB_AUFTRAGDETAILS '||unistr('\000a')||
'where SB_AUFTRAG_ID = :P355_ID'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 355,
  p_name=> 'Auftragdetails',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_display_when_condition=> 'P355_ID',
  p_display_condition_type=> 'ITEM_IS_NOT_NULL',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P355_HEIGHT_SBDETAILS.px; max-width:1200px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(:P355_REPORT_TITEL||:p355_REPORT_TITEL_CHAMP);',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '30',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'No data found.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '10000',
  p_pagination_display_position=> 'TOP_AND_BOTTOM_LEFT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389730842749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389801600749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 60,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5387430402749946 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'DISP_ID',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_link=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:352:P352_SB_AUFTRAG_ID,P352_ID,P352_ZURUECK_ZUR_SEITE:#SB_AUFTRAG_ID#,#DISP_ID#,&APP_PAGE_ID.',
  p_column_linktext=>'<img src="#IMAGE_PREFIX#edit_big.gif" alt="">',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389909484749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'SB_AUFTRAG_ID',
  p_column_display_sequence=> 61,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'SB_AUFTRAG_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5488609318543146 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'REFERENZ_ID',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5390108474749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'ADRESSAT',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'DISPLAY_AND_SAVE',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '25',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'ADRESSAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5390206866749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'SPRACHE_ID',
  p_column_display_sequence=> 59,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'SELECT_LIST_FROM_QUERY',
  p_inline_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  --and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'SPRACHE_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388815749749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'ISTDATUM',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '12',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'ISTDATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5387514753749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'SENDEFEHLER',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388920059749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'GESPERRT',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'SELECT_LIST_FROM_QUERY',
  p_inline_lov=> 'SELECT ''gesperrt'' a, 1 from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''aktiv'' a, 0 from dual',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'GESPERRT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389007947749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP00',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP00',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389109509749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP01',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP01',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389208865749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP02',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP02',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389305675749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP03',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP03',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389403660749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP04',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP04',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389508970749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP05',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP05',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5389602438749949 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP06',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'SB_AUFTRAGDETAILS',
  p_ref_column_name=> 'CHAMP06',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392526988749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP07',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392604235749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP08',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392705815749952 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP09',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392829206749952 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP10',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392921248749952 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP11',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5393013638749952 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP12',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5393124544749952 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP13',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5393226747749952 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP14',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5393330000749952 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP15',
  p_column_display_sequence=> 23,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5393402372749952 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 27,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP16',
  p_column_display_sequence=> 24,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388413358749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 28,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP17',
  p_column_display_sequence=> 25,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388501789749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 29,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP18',
  p_column_display_sequence=> 26,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5387607937749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 30,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP19',
  p_column_display_sequence=> 27,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5387707211749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 31,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP20',
  p_column_display_sequence=> 28,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5387816275749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 32,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP21',
  p_column_display_sequence=> 29,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5387918699749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 33,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP22',
  p_column_display_sequence=> 30,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388032120749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 34,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP23',
  p_column_display_sequence=> 31,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388109659749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 35,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP24',
  p_column_display_sequence=> 32,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388201054749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 36,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP25',
  p_column_display_sequence=> 33,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388316924749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 37,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP26',
  p_column_display_sequence=> 34,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388607603749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 38,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP27',
  p_column_display_sequence=> 35,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5388718058749947 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 39,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP28',
  p_column_display_sequence=> 36,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5390317759749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 40,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP29',
  p_column_display_sequence=> 37,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5390421118749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 41,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP30',
  p_column_display_sequence=> 38,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5390510734749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 42,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP31',
  p_column_display_sequence=> 39,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5390607370749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 43,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP32',
  p_column_display_sequence=> 40,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5390708582749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 44,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP33',
  p_column_display_sequence=> 41,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5390812657749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 45,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP34',
  p_column_display_sequence=> 42,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5390911637749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 46,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP35',
  p_column_display_sequence=> 43,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391006346749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 47,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP36',
  p_column_display_sequence=> 44,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391127776749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 48,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP37',
  p_column_display_sequence=> 45,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391216612749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 49,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP38',
  p_column_display_sequence=> 46,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391315253749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 50,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP39',
  p_column_display_sequence=> 47,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391411657749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 51,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP40',
  p_column_display_sequence=> 48,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391504398749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 52,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP41',
  p_column_display_sequence=> 49,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391611931749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 53,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP42',
  p_column_display_sequence=> 50,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391707338749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 54,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP43',
  p_column_display_sequence=> 51,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391805454749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 55,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP44',
  p_column_display_sequence=> 52,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5391928936749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 56,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP45',
  p_column_display_sequence=> 53,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392017441749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 57,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP46',
  p_column_display_sequence=> 54,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392103791749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 58,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP47',
  p_column_display_sequence=> 55,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392232431749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 59,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP48',
  p_column_display_sequence=> 56,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392302817749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 60,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP49',
  p_column_display_sequence=> 57,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5392423974749950 + wwv_flow_api.g_id_offset,
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 61,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP50',
  p_column_display_sequence=> 58,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '10',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5402127973760794 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 355,
  p_plug_name=> 'NVAuftragdetails',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'WITH file_sizes AS'||unistr('\000a')||
'     (SELECT 1048576 MEGABYTE, 1024 KILOBYTE,'||unistr('\000a')||
'             ID CHECKBOX,'||unistr('\000a')||
'             ID ID,'||unistr('\000a')||
'             SB_AUFTRAG_ID,'||unistr('\000a')||
'             DATEI_NAME,'||unistr('\000a')||
'             ERFDAT,'||unistr('\000a')||
'             DBMS_LOB.getlength(DATEI_BLOB) datei,'||unistr('\000a')||
'             DBMS_LOB.GETLENGTH (DATEI_BLOB) byte_size'||unistr('\000a')||
'        FROM SB_AUFTRAG_DATEIEN where'||unistr('\000a')||
'   SATZ_KENNZEICHEN IS NULL and sb_auftrag_id = :P355_ID)'||unistr('\000a')||
'   '||unistr('\000a')||
'SELECT  '||unistr('\000a')||
'';

s:=s||'        APEX_ITEM.CHECKBOX(p_idx => 3, p_value => id , p_attributes => ''class="jr_datei_checkbox"'')  CHECKBOX,'||unistr('\000a')||
'        ID,'||unistr('\000a')||
'        SB_AUFTRAG_ID,'||unistr('\000a')||
'        datei,'||unistr('\000a')||
'        DATEI_NAME,'||unistr('\000a')||
'        ERFDAT,'||unistr('\000a')||
'        to_char(ERFDAT,''DD.MM.YYYY HH24:MI'') ERSTELLDATUM,'||unistr('\000a')||
'        (CASE TRUNC (byte_size / MEGABYTE)'||unistr('\000a')||
'           WHEN 0'||unistr('\000a')||
'              THEN TO_CHAR ((byte_size / KILOBYTE), ''999,999'') || '' KB'''||unistr('\000a')||
'           ';

s:=s||'ELSE TO_CHAR ((byte_size / MEGABYTE), ''999,999.00'') || '' MB'''||unistr('\000a')||
'        END'||unistr('\000a')||
'       ) display_size'||unistr('\000a')||
'  FROM file_sizes';

wwv_flow_api.create_report_region (
  p_id=> 5823616028065248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 355,
  p_name=> 'Auftragsdateien',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 25,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_when_condition=> 'select'||unistr('\000a')||
'   ID'||unistr('\000a')||
'from'||unistr('\000a')||
'    SB_AUFTRAG_DATEIEN'||unistr('\000a')||
'where'||unistr('\000a')||
'   SATZ_KENNZEICHEN IS NULL and sb_auftrag_id = :P355_ID',
  p_display_condition_type=> 'EXISTS',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto;  max-width:800px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_ajax_items_to_submit=> 'P355_ID',
  p_query_row_template=> 12,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'Keine Daten gefunden',
  p_query_num_rows_item=> '500',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5829028130267445 + wwv_flow_api.g_id_offset,
  p_region_id=> 5823616028065248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECKBOX',
  p_column_display_sequence=> 2,
  p_column_heading=> '<input type="checkbox" class="check_all" value="checkall" />',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'N',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5828417385188672 + wwv_flow_api.g_id_offset,
  p_region_id=> 5823616028065248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 1,
  p_column_heading=> 'Id',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5828505827188673 + wwv_flow_api.g_id_offset,
  p_region_id=> 5823616028065248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'SB_AUFTRAG_ID',
  p_column_display_sequence=> 3,
  p_column_heading=> 'Sb Auftrag Id',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5824114936065250 + wwv_flow_api.g_id_offset,
  p_region_id=> 5823616028065248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'DATEI',
  p_column_display_sequence=> 7,
  p_column_heading=> 'Download',
  p_use_as_row_header=> 'N',
  p_column_format=> 'DOWNLOAD:SB_AUFTRAG_DATEIEN:DATEI_BLOB:ID:::DATEI_NAME:::attachment:Herunterladen',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5824021415065250 + wwv_flow_api.g_id_offset,
  p_region_id=> 5823616028065248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'DATEI_NAME',
  p_column_display_sequence=> 5,
  p_column_heading=> 'Dateiname',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>3,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5902930036483751 + wwv_flow_api.g_id_offset,
  p_region_id=> 5823616028065248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'ERFDAT',
  p_column_display_sequence=> 8,
  p_column_heading=> 'Erfdat',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_default_sort_dir=>'desc',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5906313225415582 + wwv_flow_api.g_id_offset,
  p_region_id=> 5823616028065248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'ERSTELLDATUM',
  p_column_display_sequence=> 4,
  p_column_heading=> 'Erstelldatum',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>2,
  p_default_sort_dir=>'desc',
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5892706416136879 + wwv_flow_api.g_id_offset,
  p_region_id=> 5823616028065248 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'DISPLAY_SIZE',
  p_column_display_sequence=> 6,
  p_column_heading=> 'Grösse',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5394317424749953 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 25,
  p_button_plug_id => 5387209796749941+wwv_flow_api.g_id_offset,
  p_button_name    => 'AKTUALISIEREN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Aktualisieren',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P355_ID is not null and :p355_flag_sql_basiert = 1 and :p355_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5379818695749927 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 30,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE_AKTUALISIEREN',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmSpeichern(''Die Selektionsparameter haben sich geändert! Sollen die Auftragdetail-Daten auch aktualisiert werden?'', ''SAVE_AKTUALISIEREN'', ''SAVE'',$x(''P355_FLAG_AKTUALISIEREN'').value,''SAVE'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P355_ID is not null and :p355_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5394102216749952 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 30,
  p_button_plug_id => 5387209796749941+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstellen',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:352:P352_SB_AUFTRAG_ID,P352_ZURUECK_ZUR_SEITE:&P355_ID.,&APP_PAGE_ID.',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p355_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5393923313749952 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 40,
  p_button_plug_id => 5387209796749941+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_ADD1',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstellen',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:addRow();',
  p_button_execute_validations=>'N',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5379416966749925 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 50,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_PREVIOUS_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&lt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P355_ID_PREV',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5379610422749925 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 60,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'GET_NEXT_ID',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&gt;',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:htmldb_goSubmit(''GET_NEXT_ID'')',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P355_ID_NEXT',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5393528145749952 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 70,
  p_button_plug_id => 5387209796749941+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_ADD',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P355_ID is not null and :p355_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5901408200326093 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 120,
  p_button_plug_id => 5823616028065248+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_FILES_MRD',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Markierte Löschen',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''APPLY_CHANGES_FILES_MRD'');',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5379010397749925 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 10,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:350:&SESSION.::&DEBUG.:355::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5380214340749927 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 80,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'TEST',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'CSV-Testexport',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'select 1 '||unistr('\000a')||
'from "#OWNER#"."SB_AUFTRAGDETAILS"'||unistr('\000a')||
'where "SB_AUFTRAG_ID" = :P355_ID',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5380005630749927 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 90,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'AUSLOESEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'CSV-Definitiver Export',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'select 1 '||unistr('\000a')||
'from "#OWNER#"."SB_AUFTRAGDETAILS"'||unistr('\000a')||
'where "SB_AUFTRAG_ID" = :P355_ID',
  p_button_condition_type=> 'EXISTS',
  p_button_comment=>'-- and :p355_istdatum is null',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5689019668527656 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 100,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'TEST_PDF',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'PDF Testerstellung',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT 1 '||unistr('\000a')||
'FROM "#OWNER#"."SB_AUFTRAG_ARTEN" sb_aa, "#OWNER#"."SB_AUFTRAGDETAILS" sb_ad '||unistr('\000a')||
'WHERE sb_aa.ID = :P355_ART_ID '||unistr('\000a')||
'AND  sb_aa.JR_JASPER_FILE IS NOT NULL'||unistr('\000a')||
'AND  sb_ad."SB_AUFTRAG_ID" = :P355_ID',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5689313481554307 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 110,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'AUSLOESEN_PDF',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'PDF-Definitive Erstellung',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT 1 '||unistr('\000a')||
'FROM "#OWNER#"."SB_AUFTRAG_ARTEN" sb_aa, "#OWNER#"."SB_AUFTRAGDETAILS" sb_ad '||unistr('\000a')||
'WHERE sb_aa.ID = :P355_ART_ID '||unistr('\000a')||
'AND  sb_aa.JR_JASPER_FILE IS NOT NULL'||unistr('\000a')||
'AND  sb_ad."SB_AUFTRAG_ID" = :P355_ID',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5379207149749925 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 40,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P355_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5378827816749925 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 20,
  p_button_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> ':P355_ID is not null and :p355_istdatum is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5393713974749952 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 355,
  p_button_sequence=> 20,
  p_button_plug_id => 5387209796749941+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_MRD',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Markierte Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''APPLY_CHANGES_MRD'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'select 1 '||unistr('\000a')||
'from "#OWNER#"."SB_AUFTRAGDETAILS"'||unistr('\000a')||
'where "SB_AUFTRAG_ID" = :P355_ID and :p355_istdatum is null',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5401204859749969 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:355:&SESSION.::&DEBUG.::P355_ID:&P355_ID_NEXT.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4841900853302233+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>5401430999749969 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:355:&SESSION.::&DEBUG.::P355_ID:&P355_ID_PREV.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>4841709840302233+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'This button is needed for Get Next or Previous Primary Key Value process.');
 
wwv_flow_api.create_page_branch(
  p_id=>5401020879749967 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:350:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_branch_condition_type=> 'REQUEST_IN_CONDITION',
  p_branch_condition=> 'DELETE,CREATE',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>5402015965749969 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:356:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 60,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''TEST'',''AUSLOESEN'') and 1=2',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 25-MAY-2012 10:29 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>5765008141966259 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:357:&SESSION.::&DEBUG.:358:P357_SB_AUFTRAG_ID,P357_ZURUECK_ZUR_SEITE:&P355_ID.,&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5750329005553016+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 70,
  p_branch_condition=> ':REQUEST in (''APPLY_CHANGES_BILDER_BEARBEITEN'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 30-AUG-2013 15:41 by SASCHA.LENZ');
 
wwv_flow_api.create_page_branch(
  p_id=>5701104111518049 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:360:&SESSION.::&DEBUG.:360:P360_DOKUMENT_ID,P360_SPRACHAUSWAHL,P360_ZURUECK_ZUR_SEITE:&P355_DOKUMENT_ID_TEXT.,&P355_SPRACHE_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5673129028905871+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 25-MAY-2012 10:29 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>5701309305519597 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:361:&SESSION.::&DEBUG.:361:P361_DOKUMENT_ID,P361_SPRACHAUSWAHL,P361_ZURUECK_ZUR_SEITE:&P355_DOKUMENT_ID_BETREFF.,&P355_SPRACHE_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>5695001771498435+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 110,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 25-MAY-2012 10:29 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>7839404945458846 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:355:&SESSION.:CSV:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 150,
  p_branch_condition_type=> 'REQUEST_IN_CONDITION',
  p_branch_condition=> 'TEST:AUSLOESEN',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 20-SEP-2012 15:42 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>5401622679749969 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:355:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 200,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>5431219181916949 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:356:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'BEFORE_COMPUTATION',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_branch_condition_type=> 'REQUEST_IN_CONDITION',
  p_branch_condition=> 'CSV',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 01-AUG-2012 11:43 by BRIGITTE.NEIDHART');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5381209096749930 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_PERSSTAMM_ID_WAHLIDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 82,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identität',
  p_source=>'PERSSTAMM_ID_WAHLIDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT substr(p.name,1,30)||'', ''||substr(p.ort,1,30)||'', ''||p.id a, p.id b'||unistr('\000a')||
'FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'  AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'  AND p.betreuer = ''I'''||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(511,:fas_sprache_id), 0'||unistr('\000a')||
'from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p355_flag_sql_basiert = 1 or :p355_id is null /* Mailart kann noch gewechselt werden und dann sind die Felder nötig */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5381418608749930 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_FLAG_AKTUALISIEREN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 79,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> ':p355_flag_sql_basiert',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Aktual',
  p_source=>'FLAG_AKTUALISIEREN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5381610173749930 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_VERANTWORTLICHER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verantwortlich',
  p_source=>'VERANTWORTLICHER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5381826033749932 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 75,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'sysdate',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Plandatum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5382031109749932 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_ISTDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 77,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Istdatum',
  p_source=>'ISTDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 20,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5382204458749932 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 420,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5382400712749933 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_MUTDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 430,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutdat',
  p_source=>'MUTDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5382601104749933 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 440,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5382810668749933 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_ID_NEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 450,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P201_ID_NEXT',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5383002607749933 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_ID_COUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 46,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_tag_attributes  => 'class="fielddata"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5383201619749935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_ID_PREV',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 460,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_prompt=>'P201_ID_PREV',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => 'This item is needed for Get Next or Previous Primary Key Value process.');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5383406474749935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 44,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5383604336749935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_BEZEICHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEZEICHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5383821813749935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_ART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_ARTEN.BEZEICHNUNG'',ID ,:FAS_SPRACHE_ID) bez, id'||unistr('\000a')||
'FROM sb_auftrag_arten',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p355_id is not null',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5384013333749935 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_TYP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 43,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '&P350_SB_AUFTRAG_TYP_ID.',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TYP_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_TYPEN.BEZEICHNUNG'',ID ,:FAS_SPRACHE_ID) bez, id'||unistr('\000a')||
'FROM sb_auftrag_typen',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5385015455749938 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '357',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  --and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5385228536749938 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5385417777749938 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_SATZ_KENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 400,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satz Kennzeichen',
  p_source=>'SATZ_KENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5385604006749938 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_ERFDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 410,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfdat',
  p_source=>'ERFDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5385826899749938 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> ':FAS_LOGIN_PERSONENSTAMM_ID',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Login',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5386032070749939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_PERSSTAMM_ID_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 390,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> ':FAS_IDENTITAET_PERSSTAMM_ID',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_prompt=>'Ident',
  p_source=>'PERSSTAMM_ID_IDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5386403857749939 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_REGION_TITEL_SB_AUFTRAEGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 480,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5386606928749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_DATUM_VON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Selektion Datum von',
  p_format_mask=>'DD.MM.RRRR',
  p_source=>'DATUM_VON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 25,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>':p355_flag_sql_basiert = 1 or :p355_id is null /* Mailart kann noch gewechselt werden und dann sind die Felder nötig */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5386827230749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_IDENT_LISTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 83,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identität',
  p_source=>'IDENT_LISTE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p130_patientenzugriff != 1   /* 1=spez. Betreuerzugriff */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5387020559749941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_DATUM_BIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Datum bis',
  p_format_mask=>'DD.MM.RRRR',
  p_source=>'DATUM_BIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 25,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>':p355_flag_sql_basiert = 1 or :p355_id is null /* Mailart kann noch gewechselt werden und dann sind die Felder nötig */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_04 => 'button',
  p_attribute_05 => 'N',
  p_attribute_07 => 'NONE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5394501208749953 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_HEIGHT_SBDETAILS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 470,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5439123237547592 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_FLAG_SQL_BASIERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 78,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'flag_sql',
  p_source=>'select CASE WHEN sql_statement is null THEN 0'||unistr('\000a')||
'       ELSE 1'||unistr('\000a')||
'       END'||unistr('\000a')||
'from sb_auftrag_arten'||unistr('\000a')||
'where id = :p355_art_id',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5514630465075987 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_REPORT_TITEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5515115236147275 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_REPORT_TITEL_CHAMP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5672821971894309 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_DOKUMENT_ID_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Text',
  p_source=>'DOKUMENT_ID_TEXT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_cAttributes=> 'class="JR_CONTROL"',
  p_tag_attributes  => 'class="JR_CONTROL"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5673129028905871 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_BUT_DOKUMENT_BEARBEITEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'APPLY_CHANGES_DOKUMENT',
  p_prompt=>'Bearbeiten',
  p_source=>'APPLY_CHANGES_DOKUMENT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'class="JR_CONTROL"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5677031892963477 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_HAS_JR_FILE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'HAS JR_FILE',
  p_source=>'select'||unistr('\000a')||
'    NVL((select case when sb.jr_jasper_file is not null then 1 else 0 end'||unistr('\000a')||
'      from SB_AUFTRAG_ARTEN sb where sb.id = :P355_ART_ID),0)'||unistr('\000a')||
'from dual',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5682518012082398 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_PP_FRANKIERUNG_IMAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'P.P. Frankierung (Bild)',
  p_source=>'PP_FRANKIERUNG_IMAGE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_FILE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'class="JR_CONTROL"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'DB_COLUMN',
  p_attribute_03 => 'PP_FRANKIERUNG_IMAGE_NAME',
  p_attribute_06 => 'Y',
  p_attribute_08 => 'attachment',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5694827959496557 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_DOKUMENT_ID_BETREFF',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>' Betreff',
  p_source=>'DOKUMENT_ID_BETREFF',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_cAttributes=> 'class="JR_CONTROL"',
  p_tag_attributes  => 'class="JR_CONTROL"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5695001771498435 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_BUT_BETREFF_BEARBEITEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'APPLY_CHANGES_BETREFF',
  p_prompt=>'Bearbeiten',
  p_source=>'APPLY_CHANGES_BETREFF',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'class="JR_CONTROL"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5750329005553016 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_BILDER_BEARBEITEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'APPLY_CHANGES_BILDER_BEARBEITEN',
  p_prompt=>'Inhalt Bilder Bearbeiten',
  p_source=>'APPLY_CHANGES_BILDER_BEARBEITEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_cattributes_element=>'class="JR_CONTROL"',
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5951330303377261 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 355,
  p_name=>'P355_DELETE_PP_IMAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 5378632202749921+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>' | ',
  p_source=>'<a href="javascript: apex.confirm(htmldb_delete_message,''PP_IMAGE_DELETE'')">L&ouml;schen</a>',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'select 1'||unistr('\000a')||
'      from SB_AUFTRAEGE sb where sb.id = :P355_ID and sb.PP_FRANKIERUNG_IMAGE is not null',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5396002235749960 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_tabular_form_region_id => 5387209796749941 + wwv_flow_api.g_id_offset,
  p_validation_name => 'SPRACHE_ID must be numeric',
  p_validation_sequence=> 50,
  p_validation => 'SPRACHE_ID',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_always_execute=>'N',
  p_validation_condition=> ':request like (''APPLY_CHANGES_ADD'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_column=> 'SPRACHE_ID',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5396223341749960 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_tabular_form_region_id => 5387209796749941 + wwv_flow_api.g_id_offset,
  p_validation_name => 'GESPERRT not null',
  p_validation_sequence=> 70,
  p_validation => 'GESPERRT',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#COLUMN_HEADER# must have a value.',
  p_always_execute=>'N',
  p_validation_condition=> ':request like (''APPLY_CHANGES_ADD'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_column=> 'GESPERRT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5396404720749960 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_tabular_form_region_id => 5387209796749941 + wwv_flow_api.g_id_offset,
  p_validation_name => 'GESPERRT must be numeric',
  p_validation_sequence=> 70,
  p_validation => 'GESPERRT',
  p_validation_type => 'ITEM_IS_NUMERIC',
  p_error_message => '#COLUMN_HEADER# must be numeric.',
  p_always_execute=>'N',
  p_validation_condition=> ':request like (''APPLY_CHANGES_ADD'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_column=> 'GESPERRT',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5397011586749960 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P355_DATUM_VON',
  p_validation_sequence=> 265,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P355_datum_von IS NULL and :p355_flag_sql_basiert = 1 THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             ''Datum von''));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN null;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 5386606928749941 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5397209479749960 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P355_DATUM_BIS',
  p_validation_sequence=> 275,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P355_datum_bis IS NULL and :p355_flag_sql_basiert = 1 THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             ''Datum bis''));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN null;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 5387020559749941 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5396623572749960 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'Datum_von_datum_bis',
  p_validation_sequence=> 280,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :p355_datum_von > :p355_datum_bis THEN'||unistr('\000a')||
'      RETURN(''Datum von muss kleiner oder gleich Datum bis sein!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 5386606928749941 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5400520180749966 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_name => 'set_sb_art'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P355_ART_ID'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
 ,p_display_when_type => 'PLSQL_EXPRESSION'
 ,p_display_when_cond => ':p355_id is null'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5400828181749966 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 5400520180749966 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P355_BEZEICHNUNG'
 ,p_attribute_01 => 'PLSQL_EXPRESSION'
 ,p_attribute_04 => 'fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_ARTEN.BEZEICHNUNG'',:p355_art_id ,:FAS_SPRACHE_ID) ||'' ''||to_char(sysdate,''DD.MM.YYYY hh24:mi'')'
 ,p_attribute_07 => 'P355_ART_ID'
 ,p_attribute_08 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5440415515763029 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 5400520180749966 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P355_FLAG_SQL_BASIERT'
 ,p_attribute_01 => 'SQL_STATEMENT'
 ,p_attribute_03 => 'select CASE WHEN sql_statement is null THEN 0'||unistr('\000a')||
'       ELSE 1'||unistr('\000a')||
'       END'||unistr('\000a')||
'from sb_auftrag_arten'||unistr('\000a')||
'where id = :p355_art_id'
 ,p_attribute_07 => 'P355_ART_ID'
 ,p_attribute_08 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5440611490771330 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 5400520180749966 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 30
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P355_FLAG_AKTUALISIEREN'
 ,p_attribute_01 => 'PLSQL_EXPRESSION'
 ,p_attribute_04 => ':P355_FLAG_SQL_BASIERT'
 ,p_attribute_07 => 'P355_FLAG_SQL_BASIERT'
 ,p_attribute_08 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5677229038981584 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 5400520180749966 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 40
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P355_HAS_JR_FILE'
 ,p_attribute_01 => 'SQL_STATEMENT'
 ,p_attribute_03 => 'select '||unistr('\000a')||
'        case when jr_jasper_file is not null then 1 '||unistr('\000a')||
'             else 0 '||unistr('\000a')||
'        end'||unistr('\000a')||
'from SB_AUFTRAG_ARTEN where id = :P355_ART_ID'
 ,p_attribute_07 => 'P355_ART_ID'
 ,p_attribute_08 => 'Y'
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5400131437749964 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_name => 'set_flag_aktualisieren'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P355_DATUM_VON,P355_DATUM_BIS,P355_PERSSTAMM_ID_WAHLIDENT'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5400427460749966 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 5400131437749964 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P355_FLAG_AKTUALISIEREN'
 ,p_attribute_01 => 'PLSQL_EXPRESSION'
 ,p_attribute_04 => ':P355_FLAG_SQL_BASIERT'
 ,p_attribute_07 => 'P355_FLAG_SQL_BASIERT'
 ,p_attribute_08 => 'Y'
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 7840331152608381 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_name => 'CSV Ausgabe aufrufen'
 ,p_event_sequence => 30
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
 ,p_display_when_type => 'REQUEST_EQUALS_CONDITION'
 ,p_display_when_cond => 'CSV'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7840608752608384 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 7840331152608381 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'CSV'
 ,p_attribute_02 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5677607136994178 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_name => 'show_jr_controls'
 ,p_event_sequence => 40
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P355_HAS_JR_FILE'
 ,p_triggering_condition_type => 'EQUALS'
 ,p_triggering_expression => '1'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5677911871994178 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 5677607136994178 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '.JR_CONTROL'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5678111048994178 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 5677607136994178 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '.JR_CONTROL'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6017507516867945 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_name => 'Check Alle Dateien'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.check_all'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6017804375867958 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 6017507516867945 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '.jr_datei_checkbox'
 ,p_attribute_01 => 'if($(this.triggeringElement).prop(''checked'')) {'||unistr('\000a')||
'   $(''.jr_datei_checkbox'').prop(''checked'',true);'||unistr('\000a')||
'} else {'||unistr('\000a')||
'  $(''.jr_datei_checkbox'').prop(''checked'',false);'||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6018228257921241 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_name => 'check for all jr dateien checkboxs'
 ,p_event_sequence => 60
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.jr_datei_checkbox'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6018520500921243 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 355
 ,p_event_id => 6018228257921241 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '.check_all'
 ,p_attribute_01 => '// Prüfe ob alle Checkboxen ausgewählt wurden. Wenn ja soll die Checkbox zum "alle auswählen" ausgewählt werden ansonsten markierung löschen'||unistr('\000a')||
'if($(''.jr_datei_checkbox:checked'').length == $(''.jr_datei_checkbox'').length) {'||unistr('\000a')||
'  $(''.check_all'').prop(''checked'',true);'||unistr('\000a')||
'} else {'||unistr('\000a')||
'  $(''.check_all'').prop(''checked'',false);'||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_SCROLLREGION_HEIGHT_MAX  NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P355_HEIGHT_SBDETAILS := :FAS_SCROLLREGION_HEIGHT_MAX * 0.60;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5398129714749963 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_report_titel_text_id NUMBER;'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :P355_REGION_TITEL_SB_AUFTRAEGE:=frgbg_s.holen_uebersetzung(5436,v_sprache_id);'||unistr('\000a')||
'   --:P355_NV_SB_AUFTRAEGE := frgbg_s.holen_uebersetzung(5435,v_sprache_id) ;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   -- Report-Header Setzen'||unistr('\000a')||
'   :p355_REPORT_TITEL :=  frgbg_s.holen_uebersetzung(5440,:FAS_SPRACHE_ID);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Column Titel';

p:=p||' champs je nach Art setzen'||unistr('\000a')||
'   IF :p355_art_id is not null THEN'||unistr('\000a')||
'      SELECT report_titel_text_id INTO v_report_titel_text_id'||unistr('\000a')||
'      FROM sb_auftrag_arten'||unistr('\000a')||
'      WHERE id = :p355_art_id;'||unistr('\000a')||
'      IF v_report_titel_text_id is not null THEN'||unistr('\000a')||
'         :p355_REPORT_TITEL_CHAMP:='||unistr('\000a')||
'               frgbg_s.holen_uebersetzung(v_report_titel_text_id,:FAS_SPRACHE_ID);'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         :p355_Report_titel_CHAMP := ';

p:=p||' '||unistr('\000a')||
'          ''CHAMP00:CHAMP01:CHAMP02:CHAMP03:CHAMP04:CHAMP05:CHAMP06:CHAMP07:CHAMP08:CHAMP09:CHAMP10:'''||unistr('\000a')||
'        ||''CHAMP11:CHAMP12:CHAMP13:CHAMP14:CHAMP15:CHAMP16:CHAMP17:CHAMP18:CHAMP19:CHAMP20:'''||unistr('\000a')||
'        ||''CHAMP21:CHAMP22:CHAMP23:CHAMP24:CHAMP25:CHAMP26:CHAMP27:CHAMP28:CHAMP29:CHAMP30:'''||unistr('\000a')||
'        ||''CHAMP31:CHAMP32:CHAMP33:CHAMP34:CHAMP35:CHAMP36:CHAMP37:CHAMP38:CHAMP39:CHAMP40:'''||unistr('\000a')||
'        ||''CHAMP41';

p:=p||':CHAMP42:CHAMP43:CHAMP44:CHAMP45:CHAMP46:CHAMP47:CHAMP48:CHAMP49:CHAMP50:'';'||unistr('\000a')||
'     END IF;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'   :p300_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_info  := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_artikelliste := frgbg_s.holen_uebersetzung(3078,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_in_warenkorb   := frgbg_s.holen_uebersetzung(3079,v_sprache_id);'||unistr('\000a')||
' ';

p:=p||'  :p300_bl_zur_kasse := frgbg_s.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'--   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(3591,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_speichern := frgbg_s.holen_ueberse';

p:=p||'tzung(172,v_sprache_id);'||unistr('\000a')||
'   --:P300_BL_INDIV_REZEPT := frgbg_s.holen_uebersetzung(3082,v_sprache_id);'||unistr('\000a')||
'   :P300_BL_SUCHEN := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_hide := frgbg_s.holen_uebersetzung(4924,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_show := frgbg_s.holen_uebersetzung(4923,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_REGION_TITEL_KATEGORIE:=NULL;'||unistr('\000a')||
'   :p300_region_titel_artikel:= frgbg_s.holen_ue';

p:=p||'bersetzung(4858,v_sprache_id);'||unistr('\000a')||
'   :p300_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   --:P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(1569,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_NV_WARENKORB := frgbg_s.holen_uebersetzung(3844,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',';

p:=p||'''button_labels_init'');'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5398332216749963 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'IF :p355_id is null THEN'||unistr('\000a')||
'   :p355_flag_aktualisieren := :p355_flag_sql_basiert;'||unistr('\000a')||
'END IF;';

wwv_flow_api.create_page_process(
  p_id     => 5439803563721739 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 910,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_flag_aktualisieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p355_id is null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
''||unistr('\000a')||
'begin'||unistr('\000a')||
'   UPDATE SB_AUFTRAEGE'||unistr('\000a')||
'      SET '||unistr('\000a')||
'        PP_FRANKIERUNG_IMAGE = null,'||unistr('\000a')||
'        PP_FRANKIERUNG_IMAGE_NAME = null'||unistr('\000a')||
'     where id = :P355_ID; '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5953722562441183 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 5,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'deletePPImage',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request in(''PP_IMAGE_DELETE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'PP-Image gelöscht',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_dok_id        NUMBER;'||unistr('\000a')||
'   v_dok_uebers_id NUMBER;'||unistr('\000a')||
'   v_return        NUMBER;'||unistr('\000a')||
'   v_prot_id       NUMBER;'||unistr('\000a')||
'   v_has_jasper_file number := 0;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   '||unistr('\000a')||
'   if( :P355_ART_ID is not null) then'||unistr('\000a')||
'     select case when jr_jasper_file is not null then 1 else 0 end into v_has_jasper_file'||unistr('\000a')||
'      from SB_AUFTRAG_ARTEN where id = :P355_ART_ID;'||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
'   --mel.p(''gen_dokument hase_jr_file %1'',v_pro';

p:=p||'t_id,''TEST'',''102/355'',:P355_HAS_JR_FILE);'||unistr('\000a')||
''||unistr('\000a')||
'   --mel.p(''gen_dokument %1'',v_prot_id,''TEST'',''102/355'',:request);'||unistr('\000a')||
'   IF :request in (''APPLY_CHANGES_DOKUMENT'',''CREATE'') and :P355_DOKUMENT_ID_TEXT is null'||unistr('\000a')||
'      AND v_has_jasper_file = 1 '||unistr('\000a')||
'      THEN '||unistr('\000a')||
'      '||unistr('\000a')||
'      mel.p(''gen_dokument create dokument %1'',v_prot_id,''TEST'',''102/355'',:request);'||unistr('\000a')||
'      /*v_return := gen_dokument;'||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
'   ';

p:=p||'      NULL;'||unistr('\000a')||
'         -- Fehler'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      select DOKUMENT_FAS_SEQ.nextval into v_dok_id from dual;'||unistr('\000a')||
'      INSERT INTO dokumente_fas(id,beschreibung,DOKUMENTKATEGORIE_ID) '||unistr('\000a')||
'             VALUES(v_dok_id,''Serienbrief Dokument'',3);'||unistr('\000a')||
'      select DOKUMENTUEBERS_SEQ.nextval into v_dok_uebers_id from dual;'||unistr('\000a')||
'      INSERT INTO dokumentuebersetzungen(id,dokument_id,name,mime_type,sprache_id,st';

p:=p||'andard)'||unistr('\000a')||
'             VALUES (v_dok_uebers_id,v_dok_id,''Serienbrief Dokument'',''text/html'',357,1);'||unistr('\000a')||
'      :P355_DOKUMENT_ID_TEXT := v_dok_id;'||unistr('\000a')||
''||unistr('\000a')||
'   ELSIF :request = ''APPLY_CHANGES_BETREFF'' and :P355_DOKUMENT_ID_BETREFF is null '||unistr('\000a')||
'      AND v_has_jasper_file = 1  THEN'||unistr('\000a')||
'      '||unistr('\000a')||
'      mel.p(''gen_dokument create betreff %1'',v_prot_id,''TEST'',''102/355'',:request);'||unistr('\000a')||
'      /*v_return := gen_dokument;'||unistr('\000a')||
'      IF v_retu';

p:=p||'rn <= 0 THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'         -- Fehler'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      select DOKUMENT_FAS_SEQ.nextval into v_dok_id from dual;'||unistr('\000a')||
'      INSERT INTO dokumente_fas(id,beschreibung,DOKUMENTKATEGORIE_ID) '||unistr('\000a')||
'             VALUES(v_dok_id,''Serienbrief Betreff'',3);'||unistr('\000a')||
'      select DOKUMENTUEBERS_SEQ.nextval into v_dok_uebers_id from dual;'||unistr('\000a')||
'      INSERT INTO dokumentuebersetzungen(id,dokument_id,name,mime_typ';

p:=p||'e,sprache_id,standard)'||unistr('\000a')||
'             VALUES (v_dok_uebers_id,v_dok_id,''Serienbrief Betreff'',''text/html'',357,1);'||unistr('\000a')||
'      :P355_DOKUMENT_ID_BETREFF := v_dok_id;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   mel.p(''gen_dokument ende  %1, %2'',v_prot_id,''TEST'',''102/355'',:request,v_dok_id);'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5703017149588051 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_dokument',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''APPLY_CHANGES_DOKUMENT'',''APPLY_CHANGES_BETREFF'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :P355_SATZ_KENNZEICHEN := ''Geloescht von ''||:APP_USER||'' am ''||to_char(SYSDATE,''DD.MM.YYYY hh24:mi:ss'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5399719548749964 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 25,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_sb_geloescht',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5378827816749925 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAEGE:P355_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 5398926011749963 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of SB_AUFTRAEGE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process row of table SB_AUFTRAEGE.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SAVE'',''SAVE_AKTUALISIEREN'',''CREATE'',''DELETE'', ''APPLY_CHANGES_BETREFF'',''APPLY_CHANGES_DOKUMENT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAGDETAILS:ID';

wwv_flow_api.create_page_process(
  p_id     => 5397716222749961 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_UPDATE',
  p_process_name=> 'ApplyMRU',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process update.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request like (''APPLY_CHANGES_ADD'') ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAGDETAILS:ID';

wwv_flow_api.create_page_process(
  p_id     => 5397900556749963 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 5387209796749941 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_DELETE',
  p_process_name=> 'ApplyMRD',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process delete.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'APPLY_CHANGES_MRD',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '#MRD_COUNT# row(s) deleted.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_ident_liste   sb_auftraege.ident_liste%TYPE;'||unistr('\000a')||
'   v_datum_von     date;'||unistr('\000a')||
'   v_datum_bis     date;'||unistr('\000a')||
'   v_datum_von_str     varchar2(100); '||unistr('\000a')||
'   v_datum_bis_str     varchar2(100); '||unistr('\000a')||
'   v_return            VARCHAR2(4000);'||unistr('\000a')||
'BEGIN '||unistr('\000a')||
'  BEGIN'||unistr('\000a')||
'     v_datum_von := trunc(to_date(:p355_datum_von,''DD.MM.RRRR hh24:mi:ss''));'||unistr('\000a')||
'     v_datum_bis := trunc(to_date(:p355_datum_bis,''DD.MM.RRRR hh24:mi:ss''));'||unistr('\000a')||
'  EXCE';

p:=p||'PTION '||unistr('\000a')||
'  WHEN others THEN'||unistr('\000a')||
'     NULL;'||unistr('\000a')||
'  END;'||unistr('\000a')||
''||unistr('\000a')||
'  v_datum_von_str := ''to_date(''''''||to_char(v_datum_von,''DD.MM.RRRR'')||'''''',''''DD.MM.RRRR'''')'';'||unistr('\000a')||
'  v_datum_bis_str := ''to_date(''''''||to_char(v_datum_bis,''DD.MM.RRRR'')||'''''',''''DD.MM.RRRR'''')'';'||unistr('\000a')||
''||unistr('\000a')||
'  v_return := frgbg_t.sb_gen_daten(:p355_id,'||unistr('\000a')||
'                                   v_datum_von_str,v_datum_bis_str,'||unistr('\000a')||
'                                   :p355_persstamm_id_wah';

p:=p||'lident,'||unistr('\000a')||
'                                   :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'                                   );'||unistr('\000a')||
''||unistr('\000a')||
'  IF v_return <> 1 then'||unistr('\000a')||
'      raise_application_error(-20000,''Fehler beim Generieren der Daten Fehlercode: '' || v_return);'||unistr('\000a')||
'  end if;'||unistr('\000a')||
'  IF :p355_persstamm_id_wahlident = 0 THEN'||unistr('\000a')||
'     SELECT LISTAGG(p.id, '','') WITHIN GROUP (ORDER BY p.id) '||unistr('\000a')||
'     INTO v_ident_liste'||unistr('\000a')||
'     FROM personenstamm p, pe';

p:=p||'rs_zugriffe z'||unistr('\000a')||
'     WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'       AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'       AND p.betreuer = ''I'';'||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'     v_ident_liste := :p355_persstamm_id_wahlident;'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
'  UPDATE sb_auftraege'||unistr('\000a')||
'  SET ident_liste = v_ident_liste,'||unistr('\000a')||
'      flag_aktualisieren = 0'||unistr('\000a')||
'  WHERE id =:p355_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5398528761749963 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 70,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_daten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''AKTUALISIEREN'',''SAVE_AKTUALISIEREN'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_return    number;'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Echtlauf'||unistr('\000a')||
'   UPDATE sb_auftragdetails '||unistr('\000a')||
'   SET istdatum = sysdate'||unistr('\000a')||
'   WHERE sb_auftrag_id =:p355_id'||unistr('\000a')||
'     AND gesperrt = 0'||unistr('\000a')||
'     AND satz_kennzeichen is null;'||unistr('\000a')||
'   UPDATE sb_auftraege'||unistr('\000a')||
'   SET istdatum = (SELECT max(istdatum) '||unistr('\000a')||
'                   from sb_auftragdetails '||unistr('\000a')||
'                   where sb_auftrag_id =:p355_id'||unistr('\000a')||
'                     AN';

p:=p||'D gesperrt = 0'||unistr('\000a')||
'                     AND satz_kennzeichen is null'||unistr('\000a')||
'                  )'||unistr('\000a')||
'   WHERE id = :p355_id'||unistr('\000a')||
'       ;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5399904204749964 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 80,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'definitiver_export',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''AUSLOESEN'',''AUSLOESEN_PDF'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'355';

wwv_flow_api.create_page_process(
  p_id     => 5399120890749964 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 920,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5378827816749925 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
' l_schritte number;'||unistr('\000a')||
'begin'||unistr('\000a')||
'    '||unistr('\000a')||
'    '||unistr('\000a')||
'    if(:REQUEST = ''TEST_PDF'') then'||unistr('\000a')||
''||unistr('\000a')||
'        -- Nur eine kleine PDF erstellen mit maximal 5 Datensätze'||unistr('\000a')||
'        FRGBG_JOBS.START_JOB('||unistr('\000a')||
'         p_what => ''IREPORT.CREATE_SERIENBRIEF(p_sb_auftrag_id => '' || :P355_ID || '''||unistr('\000a')||
'                , p_sb_auftrag_bezeichnung => '''''' || :P355_BEZEICHNUNG || '''''''||unistr('\000a')||
'                , p_schritte =>  1'||unistr('\000a')||
'                , p_bis_ma';

p:=p||'x => 1);'','||unistr('\000a')||
'         p_text_id_beschreibung => 7981,'||unistr('\000a')||
'         p_text_id_aufgabe_aktuell => 7981,'||unistr('\000a')||
'         p_max_jobs_same         => 4, -- gleicher Job darf nur einmal ausgelöst werden.'||unistr('\000a')||
'         p_max_jobs_total  => null -- kein Limit für Jobs insgesamt'||unistr('\000a')||
'       );'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    else'||unistr('\000a')||
'       select JR_SCHRITTE into l_schritte from SB_AUFTRAEGE s, SB_AUFTRAG_ARTEN a '||unistr('\000a')||
'       where a.id = s.art_id and s.id = :P3';

p:=p||'55_ID;'||unistr('\000a')||
''||unistr('\000a')||
'       FRGBG_JOBS.START_JOB('||unistr('\000a')||
'         p_what => ''IREPORT.CREATE_SERIENBRIEF(p_sb_auftrag_id => '' || :P355_ID || '''||unistr('\000a')||
'                , p_sb_auftrag_bezeichnung => '''''' || :P355_BEZEICHNUNG || '''''''||unistr('\000a')||
'                , p_schritte =>  '' || l_schritte || '''||unistr('\000a')||
'                , p_bis_max => null);'','||unistr('\000a')||
'         p_text_id_beschreibung => 7981,'||unistr('\000a')||
'         p_text_id_aufgabe_aktuell => 7981,'||unistr('\000a')||
'         p_max_jobs_s';

p:=p||'ame         => 4, -- gleicher Job darf nur einmal ausgelöst werden.'||unistr('\000a')||
'         p_max_jobs_total  => 4 -- maximal Jobs insgesamt'||unistr('\000a')||
'       );'||unistr('\000a')||
''||unistr('\000a')||
'    end if;'||unistr('\000a')||
''||unistr('\000a')||
'    commit;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5750001853460050 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 930,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'generate_pdf',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':REQUEST in (''AUSLOESEN_PDF'',''TEST_PDF'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
' l_value varchar2(100);'||unistr('\000a')||
' l_id number;'||unistr('\000a')||
' l_count number := 0;'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Durchlaufe alle Checkboxen um Dateien zu löschen.'||unistr('\000a')||
' FOR i IN 1..APEX_APPLICATION.G_F03.COUNT LOOP'||unistr('\000a')||
'    l_value := APEX_APPLICATION.G_F03(i);'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    if(l_value is not null and l_value <> ''0'') then'||unistr('\000a')||
'     l_id := to_number(l_value);'||unistr('\000a')||
'      '||unistr('\000a')||
''||unistr('\000a')||
'      UPDATE SB_AUFTRAG_DATEIEN set'||unistr('\000a')||
'          satz_kennzeichen = ''Geloescht von ''||:APP';

p:=p||'_USER'||unistr('\000a')||
'            ||'' am ''||to_char(SYSDATE,''DD.MM.YYYY hh24:mi:ss'')'||unistr('\000a')||
'      WHERE ID = l_id;'||unistr('\000a')||
''||unistr('\000a')||
'      l_count := l_count + 1;'||unistr('\000a')||
'    end if;'||unistr('\000a')||
'  end loop;'||unistr('\000a')||
'   '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5901729587351203 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 940,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'ApplyFilesMRD',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>5901408200326093 + wwv_flow_api.g_id_offset,
  p_process_when=>':REQUEST = ''APPLY_CHANGES_FILES_MRD''',
  p_process_when_type=>'',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Dateien wurden gelöscht',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:SB_AUFTRAEGE:P355_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 5398708145749963 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from SB_AUFTRAEGE',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to fetch row.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAEGE:ID::BEZEICHNUNG::P355_ID:P355_ID_NEXT:P355_ID_PREV::::P355_ID_COUNT:';

wwv_flow_api.create_page_process(
  p_id     => 5397525965749961 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 355,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'GET_NEXT_OR_PREV_PK',
  p_process_name=> 'Get Next or Previous Primary Key Value',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to run Get Next or Previous Primary Key Value process.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 355
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00356
prompt  ...PAGE 356: Mailing-Export Bericht CSV
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 356
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Mailing-Export Bericht CSV'
 ,p_step_title => 'Mailing-Export Bericht CSV'
 ,p_step_sub_title => 'Mailing-Export Bericht CSV'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130116113344'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select distinct'||unistr('\000a')||
'--"SB_AUFTRAG_ID",'||unistr('\000a')||
'--"ID" SB_AUFTRAG_DETAIL_ID,'||unistr('\000a')||
'--"ADRESS_REFERENZ_ID",'||unistr('\000a')||
'--"ADRESSAT",'||unistr('\000a')||
'--"SPRACHE_ID",'||unistr('\000a')||
'--"ISTDATUM",'||unistr('\000a')||
'--"SENDEFEHLER",'||unistr('\000a')||
'--"GESPERRT",'||unistr('\000a')||
'"CHAMP00",'||unistr('\000a')||
'"CHAMP01",'||unistr('\000a')||
'"CHAMP02",'||unistr('\000a')||
'"CHAMP03",'||unistr('\000a')||
'"CHAMP04",'||unistr('\000a')||
'"CHAMP05",'||unistr('\000a')||
'"CHAMP06",'||unistr('\000a')||
'"CHAMP07",'||unistr('\000a')||
'"CHAMP08",'||unistr('\000a')||
'"CHAMP09",'||unistr('\000a')||
'"CHAMP10",'||unistr('\000a')||
'"CHAMP11",'||unistr('\000a')||
'"CHAMP12",'||unistr('\000a')||
'"CHAMP13",'||unistr('\000a')||
'"CHAMP14",'||unistr('\000a')||
'"CHAMP15",'||unistr('\000a')||
'"CHAMP16",'||unistr('\000a')||
'"CHAMP17",'||unistr('\000a')||
'"CHAMP18",'||unistr('\000a')||
'"CHAMP19",'||unistr('\000a')||
'"CHAMP20",'||unistr('\000a')||
'"CHAMP';

s:=s||'21",'||unistr('\000a')||
'"CHAMP22",'||unistr('\000a')||
'"CHAMP23",'||unistr('\000a')||
'"CHAMP24",'||unistr('\000a')||
'"CHAMP25",'||unistr('\000a')||
'"CHAMP26",'||unistr('\000a')||
'"CHAMP27",'||unistr('\000a')||
'"CHAMP28",'||unistr('\000a')||
'"CHAMP29",'||unistr('\000a')||
'"CHAMP30",'||unistr('\000a')||
'"CHAMP31",'||unistr('\000a')||
'"CHAMP32",'||unistr('\000a')||
'"CHAMP33",'||unistr('\000a')||
'"CHAMP34",'||unistr('\000a')||
'"CHAMP35",'||unistr('\000a')||
'"CHAMP36",'||unistr('\000a')||
'"CHAMP37",'||unistr('\000a')||
'"CHAMP38",'||unistr('\000a')||
'"CHAMP39",'||unistr('\000a')||
'"CHAMP40",'||unistr('\000a')||
'"CHAMP41",'||unistr('\000a')||
'"CHAMP42",'||unistr('\000a')||
'"CHAMP43",'||unistr('\000a')||
'"CHAMP44",'||unistr('\000a')||
'"CHAMP45",'||unistr('\000a')||
'"CHAMP46",'||unistr('\000a')||
'"CHAMP47",'||unistr('\000a')||
'"CHAMP48",'||unistr('\000a')||
'"CHAMP49",'||unistr('\000a')||
'"CHAMP50"'||unistr('\000a')||
'from SB_AUFTRAGDETAILS '||unistr('\000a')||
'where SB_AUFTRAG_ID = :P355_ID'||unistr('\000a')||
'  and gesperrt=0'||unistr('\000a')||
'  and';

s:=s||' satz_kennzeichen is null'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 356,
  p_name=> 'Mailing Export',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 21,
  p_query_headings=> 'RETURN(:P355_REPORT_TITEL_CHAMP)',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'Keine Daten gefunden.',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'Y',
  p_csv_output_link_text=> 'murkslabel',
  p_prn_output=> 'N',
  p_prn_format=> 'PDF',
  p_prn_output_show_link=> 'Y',
  p_prn_output_link_text=> 'Print',
  p_prn_content_disposition=> 'ATTACHMENT',
  p_prn_document_header=> 'APEX',
  p_prn_units=> 'MILLIMETERS',
  p_prn_paper_size=> 'A4',
  p_prn_width_units=> 'PERCENTAGE',
  p_prn_width=> 297,
  p_prn_height=> 210,
  p_prn_orientation=> 'HORIZONTAL',
  p_prn_page_header_font_color=> '#000000',
  p_prn_page_header_font_family=> 'Helvetica',
  p_prn_page_header_font_weight=> 'normal',
  p_prn_page_header_font_size=> '12',
  p_prn_page_footer_font_color=> '#000000',
  p_prn_page_footer_font_family=> 'Helvetica',
  p_prn_page_footer_font_weight=> 'normal',
  p_prn_page_footer_font_size=> '12',
  p_prn_header_bg_color=> '#9bafde',
  p_prn_header_font_color=> '#ffffff',
  p_prn_header_font_family=> 'Helvetica',
  p_prn_header_font_weight=> 'normal',
  p_prn_header_font_size=> '10',
  p_prn_body_bg_color=> '#efefef',
  p_prn_body_font_color=> '#000000',
  p_prn_body_font_family=> 'Helvetica',
  p_prn_body_font_weight=> 'normal',
  p_prn_body_font_size=> '10',
  p_prn_border_width=> .5,
  p_prn_page_header_alignment=> 'CENTER',
  p_prn_page_footer_alignment=> 'CENTER',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_exp_separator=> ';',
  p_plug_query_exp_enclosed_by=> ' ',
  p_plug_query_strip_html=> 'N',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5501107871020782 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP00',
  p_column_display_sequence=> 51,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5423904642685738 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>1,
  p_disable_sort_column=>'N',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424026934685738 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP02',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424119654685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP03',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424201952685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP04',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424330519685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP05',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424431798685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP06',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424503712685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP07',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424616983685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP08',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424714133685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP09',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424814657685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP10',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5424905590685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP11',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425006137685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP12',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425108790685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP13',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425224234685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP14',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425303202685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP15',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425421661685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP16',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425508516685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP17',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425620762685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP18',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425726871685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP19',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425800723685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP20',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5425932066685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP21',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426029863685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP22',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426126931685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP23',
  p_column_display_sequence=> 23,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426232734685740 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP24',
  p_column_display_sequence=> 24,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426322681685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP25',
  p_column_display_sequence=> 25,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426400818685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 27,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP26',
  p_column_display_sequence=> 26,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426531686685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 28,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP27',
  p_column_display_sequence=> 27,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426625399685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 29,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP28',
  p_column_display_sequence=> 28,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426725413685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 30,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP29',
  p_column_display_sequence=> 29,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426823558685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 31,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP30',
  p_column_display_sequence=> 30,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5426917187685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 32,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP31',
  p_column_display_sequence=> 31,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427021822685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 33,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP32',
  p_column_display_sequence=> 32,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427106113685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 34,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP33',
  p_column_display_sequence=> 33,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427202222685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 35,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP34',
  p_column_display_sequence=> 34,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427307975685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 36,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP35',
  p_column_display_sequence=> 35,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427412611685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 37,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP36',
  p_column_display_sequence=> 36,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427503280685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 38,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP37',
  p_column_display_sequence=> 37,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427629463685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 39,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP38',
  p_column_display_sequence=> 38,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427726856685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 40,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP39',
  p_column_display_sequence=> 39,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427803765685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 41,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP40',
  p_column_display_sequence=> 40,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5427909645685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 42,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP41',
  p_column_display_sequence=> 41,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5428002279685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 43,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP42',
  p_column_display_sequence=> 42,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5428119647685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 44,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP43',
  p_column_display_sequence=> 43,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5428203497685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 45,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP44',
  p_column_display_sequence=> 44,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5428312533685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 46,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP45',
  p_column_display_sequence=> 45,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5428418461685741 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 47,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP46',
  p_column_display_sequence=> 46,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5428528312685743 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 48,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP47',
  p_column_display_sequence=> 47,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5428600654685743 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 49,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP48',
  p_column_display_sequence=> 48,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5428715859685743 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 50,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP49',
  p_column_display_sequence=> 49,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 5428828905685743 + wwv_flow_api.g_id_offset,
  p_region_id=> 5421112845674369 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 51,
  p_form_element_id=> null,
  p_column_alias=> 'CHAMP50',
  p_column_display_sequence=> 50,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_print_col_width=> '1',
  p_column_comment=>'');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   owa_util.redirect_url(APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'          ''f?p=''||:APP_ID||'':355:''||:APP_SESSION||'':::::'')); --- Redirect'||unistr('\000a')||
'   --apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5432225415268842 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 356,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'close_window',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 356
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00357
prompt  ...PAGE 357: SB Auftragsbilder
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 357
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'SB Auftragsbilder'
 ,p_step_title => 'SB Auftragsbilder'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20130830155252'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select "ROWID", '||unistr('\000a')||
'"ID",'||unistr('\000a')||
'"SB_AUFTRAG_ID",'||unistr('\000a')||
'CASE '||unistr('\000a')||
'   WHEN "SB_AUFTRAG_ID" is null then frgbg_s.holen_uebersetzung(7975,:FAS_SPRACHE_ID) /* ''[IST GLOBAL VERFÜGBAR]'' */'||unistr('\000a')||
'   ELSE (SELECT BEZEICHNUNG FROM SB_AUFTRAEGE WHERE id = "SB_AUFTRAG_ID") '||unistr('\000a')||
'END AUFTRAG_BEZEICHNUNG,'||unistr('\000a')||
'"KURZBEZEICHNUNG",'||unistr('\000a')||
'''##'' || "IMAGE_TAG" || ''##'' image_tag,'||unistr('\000a')||
'"TYP",'||unistr('\000a')||
'dbms_lob.getlength("BILD_BLOB") "BILD_BLOB",'||unistr('\000a')||
'BESCHREIBUNG'||unistr('\000a')||
'from "#OWNER#"';

s:=s||'."SB_AUFTRAG_BILDER" '||unistr('\000a')||
'where'||unistr('\000a')||
' ("SB_AUFTRAG_ID" is null or "SB_AUFTRAG_ID" = :P357_SB_AUFTRAG_ID)'||unistr('\000a')||
' and SATZ_KENNZEICHEN IS NULL'||unistr('\000a')||
''||unistr('\000a')||
'  '||unistr('\000a')||
'';

wwv_flow_api.create_page_plug (
  p_id=> 5724102117741067 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_plug_name=> 'SB Auftragsbilder',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 0,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'select "ROWID", '||unistr('\000a')||
'"ID",'||unistr('\000a')||
'"SB_AUFTRAG_ID",'||unistr('\000a')||
'CASE '||unistr('\000a')||
'   WHEN "SB_AUFTRAG_ID" is null then frgbg_s.holen_uebersetzung(7975,:FAS_SPRACHE_ID) /* ''[IST GLOBAL VERFÜGBAR]'' */'||unistr('\000a')||
'   ELSE (SELECT BEZEICHNUNG FROM SB_AUFTRAEGE WHERE id = "SB_AUFTRAG_ID") '||unistr('\000a')||
'END AUFTRAG_BEZEICHNUNG,'||unistr('\000a')||
'"KURZBEZEICHNUNG",'||unistr('\000a')||
'''##'' || "IMAGE_TAG" || ''##'' image_tag,'||unistr('\000a')||
'"TYP",'||unistr('\000a')||
'dbms_lob.getlength("BILD_BLOB") "BILD_BLOB",'||unistr('\000a')||
'BESCHREIBUNG'||unistr('\000a')||
'from "#OWNER#"';

a1:=a1||'."SB_AUFTRAG_BILDER" '||unistr('\000a')||
'where'||unistr('\000a')||
' ("SB_AUFTRAG_ID" is null or "SB_AUFTRAG_ID" = :P357_SB_AUFTRAG_ID)'||unistr('\000a')||
' and SATZ_KENNZEICHEN IS NULL'||unistr('\000a')||
''||unistr('\000a')||
'  '||unistr('\000a')||
'';

wwv_flow_api.create_worksheet(
  p_id=> 5724309273741068+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_region_id=> 5724102117741067+wwv_flow_api.g_id_offset,
  p_name=> 'SB Auftragsbilder',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '100000',
  p_max_row_count_message=> 'Diese Abfrage gibt über #MAX_ROW_COUNT# Zeilen zurück. Filtern Sie die Daten, um vollständige Ergebnisse zu gewährleisten.',
  p_no_data_found_message=> 'Keine Daten gefunden.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'Y',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'Y',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y',
  p_pagination_display_pos=>'BOTTOM_RIGHT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'C',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'Y',
  p_show_highlight=>'Y',
  p_show_computation=>'Y',
  p_show_aggregate=>'Y',
  p_show_chart=>'Y',
  p_show_group_by=>'Y',
  p_show_notify=>'N',
  p_show_calendar=>'Y',
  p_show_flashback=>'Y',
  p_show_reset=>'Y',
  p_show_download=>'Y',
  p_show_help=>'Y',
  p_download_formats=>'CSV:HTML:EMAIL',
  p_detail_link=>'f?p=&APP_ID.:358:&APP_SESSION.::::P358_ROWID:#ROWID#',
  p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif"  border="0">',
  p_allow_exclude_null_values=>'Y',
  p_allow_hide_extra_columns=>'Y',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_detail_view_enabled_yn=>'N',
  p_owner=>'SASCHA.LENZ',
  p_internal_uid=> 1);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5724423530741073+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ROWID',
  p_display_order          =>1,
  p_column_identifier      =>'A',
  p_column_label           =>'ROWID',
  p_report_label           =>'ROWID',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'OTHER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'HIDDEN',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'N',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5724531006741076+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID',
  p_display_order          =>2,
  p_column_identifier      =>'B',
  p_column_label           =>'Id',
  p_report_label           =>'Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5724607102741076+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'SB_AUFTRAG_ID',
  p_display_order          =>3,
  p_column_identifier      =>'C',
  p_column_label           =>'Sb Auftrag Id',
  p_report_label           =>'Sb Auftrag Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'HIDDEN',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5743432096559106+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'AUFTRAG_BEZEICHNUNG',
  p_display_order          =>4,
  p_column_identifier      =>'H',
  p_column_label           =>'Auftrag Bezeichnung',
  p_report_label           =>'Auftrag Bezeichnung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5724828768741078+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'KURZBEZEICHNUNG',
  p_display_order          =>7,
  p_column_identifier      =>'E',
  p_column_label           =>'Kurzbezeichnung',
  p_report_label           =>'Kurzbezeichnung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5724903832741078+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'TYP',
  p_display_order          =>8,
  p_column_identifier      =>'F',
  p_column_label           =>'Typ',
  p_report_label           =>'Typ',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5725028593741079+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'BILD_BLOB',
  p_display_order          =>9,
  p_column_identifier      =>'G',
  p_column_label           =>'Bild Blob',
  p_report_label           =>'Bild Blob',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_format_mask            =>'DOWNLOAD:SB_AUFTRAG_BILDER:BILD_BLOB:ID:::DATEINAME:::inline:Herunterladen',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'N',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5743619247559107+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'BESCHREIBUNG',
  p_display_order          =>10,
  p_column_identifier      =>'J',
  p_column_label           =>'Beschreibung',
  p_report_label           =>'Beschreibung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 5754401075529027+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'IMAGE_TAG',
  p_display_order          =>11,
  p_column_identifier      =>'K',
  p_column_label           =>'Image Tag',
  p_report_label           =>'Image Tag',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'ID:AUFTRAG_BEZEICHNUNG:KURZBEZEICHNUNG:IMAGE_TAG:TYP:BILD_BLOB:BESCHREIBUNG:';

wwv_flow_api.create_worksheet_rpt(
  p_id => 5727310008757846+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_worksheet_id => 5724309273741068+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'57274',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>15,
  p_report_columns          =>rc1,
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5725808083741083 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 357,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5745425609613960 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 357,
  p_button_sequence=> 30,
  p_button_plug_id => 5724102117741067+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'RIGHT_OF_IR_SEARCH_BAR',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.submit(''CANCEL'')',
  p_button_execute_validations=>'N',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5725709857741083 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 357,
  p_button_sequence=> 40,
  p_button_plug_id => 5724102117741067+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstellen',
  p_button_position=> 'RIGHT_OF_IR_SEARCH_BAR',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:358:&SESSION.::&DEBUG.:358:P358_SB_AUFTRAG_ID:&P357_SB_AUFTRAG_ID.',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5727208623757439 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 357,
  p_name=>'P357_SB_AUFTRAG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5724102117741067+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5745923578641793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 357,
  p_name=>'P357_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5724102117741067+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '130',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'begin'||unistr('\000a')||
'    -- Das flexible Verweisen auf die Ursprungsseite hat nicht funktioniert, daher dieser Weg.'||unistr('\000a')||
''||unistr('\000a')||
'    if(:P357_ZURUECK_ZUR_SEITE is not null and :P357_ZURUECK_ZUR_SEITE <> 0) then'||unistr('\000a')||
''||unistr('\000a')||
'        apex_application.g_unrecoverable_error := TRUE;'||unistr('\000a')||
'        owa_util.redirect_url(''f?p=&APP_ID.:'' || :P357_ZURUECK_ZUR_SEITE ||'':&APP_SESSION.:::::'');'||unistr('\000a')||
''||unistr('\000a')||
'        :P357_SB_AUFTRAG_ID := null;'||unistr('\000a')||
'        :P357_';

p:=p||'ZURUECK_ZUR_SEITE := null;'||unistr('\000a')||
''||unistr('\000a')||
'        '||unistr('\000a')||
'     end if;'||unistr('\000a')||
''||unistr('\000a')||
'    '||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5745107948608865 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 357,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Redirect_Page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':REQUEST in (''CANCEL'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 357
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00358
prompt  ...PAGE 358: Auftragsbild bearbeiten
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 358
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Auftragsbild bearbeiten'
 ,p_step_title => 'Auftragsbild bearbeiten'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Für diese Seite ist keine Hilfe verfügbar.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20130927153301'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5719319436741030 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 358,
  p_plug_name=> 'Auftragsbild bearbeiten',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5744529157596071 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 358,
  p_plug_name=> 'NVAuftragdetails',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 30,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5719631210741031 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 358,
  p_button_sequence=> 30,
  p_button_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Änderungen anwenden',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P358_ROWID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5719924683741032 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 358,
  p_button_sequence=> 10,
  p_button_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Abbrechen',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:357:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5719500595741031 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 358,
  p_button_sequence=> 40,
  p_button_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstellen',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P358_ROWID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5719716393741031 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 358,
  p_button_sequence=> 20,
  p_button_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'P358_ROWID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5720517475741034 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:357:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5720706458741036 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_ROWID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Rowid',
  p_source=>'ROWID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5720903183741046 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5721118131741047 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_SB_AUFTRAG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'SB Auftrag',
  p_source=>'SB_AUFTRAG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_POPUP_LOV',
  p_lov=> 'select display, value from (  select frgbg_s.holen_uebersetzung(7975,:FAS_SPRACHE_ID) display, 0 value, 1 rang  from dual'||unistr('\000a')||
'union'||unistr('\000a')||
'   Select s.BEZEICHNUNG display, s.id value, 2 rang from SB_AUFTRAEGE s, SB_AUFTRAG_ARTEN sb_a '||unistr('\000a')||
'   where s.satz_kennzeichen is null and sb_a.id = s.art_id and sb_a.jr_jasper_file is not null)'||unistr('\000a')||
'order by rang, display',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NOT_ENTERABLE',
  p_attribute_02 => 'FIRST_ROWSET',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Identifikation mit der im Serienbrief referenziert werden kann. Z.B. mit ##UNTERSCHRIFT_BILD##'||unistr('\000a')||
'Erlaubt sind nur Buchstaben, Zahlen und Unterstrich.'||unistr('\000a')||
'Die Bezeichnung muss eindeutig sein.';

wwv_flow_api.create_page_item(
  p_id=>5721522012741048 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_KURZBEZEICHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kurzbezeichnung',
  p_source=>'KURZBEZEICHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5721709078741049 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_TYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'png',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bild-Typ',
  p_source=>'TYP',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'STATIC2:PNG;png,JPG;jpg,BMP;bmp',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 20,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5721932175741049 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_BILD_BLOB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bild Blob',
  p_source=>'BILD_BLOB',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_FILE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'DB_COLUMN',
  p_attribute_03 => 'DATEINAME',
  p_attribute_06 => 'Y',
  p_attribute_07 => 'Download',
  p_attribute_08 => 'attachment',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5722127753741049 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_DATEINAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Dateiname',
  p_source=>'DATEINAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 200,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'DATEINAME',
  p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5731620893921795 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_BILD_VORSCHAU',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bild Vorschau',
  p_source=>'BILD_BLOB',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_IMAGE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'SELECT * FROM SB_AUFTRAG_BILDER WHERE ID = :P358_ID AND BILD_BLOB is not null and SATZ_KENNZEICHEN is null',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'DB_COLUMN',
  p_attribute_04 => 'DATEINAME',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5733500863020088 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_SATZ_KENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satz Kennzeichen',
  p_source=>'SATZ_KENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5733708136022204 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_ERFDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfdat',
  p_source=>'ERFDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5733914716024083 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5734119910025660 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_MUTDAT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 270,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutdat',
  p_source=>'MUTDAT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5734325451027223 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 100,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5735329223075610 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_BESCHREIBUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Beschreibung',
  p_source=>'BESCHREIBUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 150,
  p_cMaxlength=> 4000,
  p_cHeight=> 10,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5738707817249227 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_BEZ_VORHANDEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap" style="padding-left:10px;display:none"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5754603977539249 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_IMAGE_TAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Image Tag',
  p_source=>'IMAGE_TAG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5989302976103459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_HOEHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bildhöhe',
  p_source=>'HOEHE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '0',
  p_attribute_02 => '840',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5990622023108895 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 358,
  p_name=>'P358_BREITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 5719319436741030+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bildbreite',
  p_source=>'BREITE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_NUMBER_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '0',
  p_attribute_02 => '595',
  p_attribute_03 => 'right',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5732828867999868 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 358,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P358_IMAGE_TAG_GUELTIG',
  p_validation_sequence=> 20,
  p_validation => 'P358_IMAGE_TAG',
  p_validation2 => '[A-Za-b_0-9]+',
  p_validation_type => 'REGULAR_EXPRESSION',
  p_error_message => 'Nur folgende Zeichen erlaubt [A-Za-b_0-9]',
  p_always_execute=>'N',
  p_validation_condition=> ':REQUEST in (''SAVE'',''CREATE'')',
  p_only_for_changed_rows=> 'Y',
  p_associated_item=> 5754603977539249 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5735511440136680 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 358,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P358_IMAGE_TAG_FREI',
  p_validation_sequence=> 30,
  p_validation => 'SELECT * FROM SB_AUFTRAG_BILDER '||unistr('\000a')||
'WHERE'||unistr('\000a')||
'    ID <> NVL(:P358_ID,-1) AND'||unistr('\000a')||
'    IMAGE_TAG = upper(:P358_IMAGE_TAG) and satz_kennzeichen is null',
  p_validation_type => 'NOT_EXISTS',
  p_error_message => 'Image Tag schon vorhanden',
  p_always_execute=>'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_item=> 5754603977539249 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'ON_ERROR_PAGE',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5740017523327715 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 358
 ,p_name => 'IMAGE_TAG_VORHANDEN'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P358_IMAGE_TAG'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'keyup'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5741700348407955 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 358
 ,p_event_id => 5740017523327715 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 5
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P358_IMAGE_TAG'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => 'this.triggeringElement.value.toUpperCase().replace(/[^A-Z0-9_]/,'''')'
 ,p_attribute_09 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 5740321632327717 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 358
 ,p_event_id => 5740017523327715 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'declare'||unistr('\000a')||
'   l_anzahl number;'||unistr('\000a')||
'begin'||unistr('\000a')||
'   if(:P358_IMAGE_TAG is null) then'||unistr('\000a')||
'      :P358_BEZ_VORHANDEN := '''';'||unistr('\000a')||
'   else'||unistr('\000a')||
'     SELECT count(*) into l_anzahl '||unistr('\000a')||
'      from SB_AUFTRAG_BILDER where'||unistr('\000a')||
'        (:P358_ID is null or id <> :P358_ID) AND'||unistr('\000a')||
'        IMAGE_TAG = upper(:P358_IMAGE_TAG) and satz_kennzeichen is null;'||unistr('\000a')||
'     '||unistr('\000a')||
'     if( l_anzahl = 0) then -- Tag verfügbar'||unistr('\000a')||
'        :P358_BEZ_VORHANDEN := ''<span style="color:green; padding-left:10px;">'' '||unistr('\000a')||
'              || frgbg_s.holen_uebersetzung(7976, :FAS_SPRACHE_ID) || ''</span>'';'||unistr('\000a')||
'     else -- Tag bereits vergeben'||unistr('\000a')||
'        :P358_BEZ_VORHANDEN := ''<span style="color:red; padding-left:10px;">'' '||unistr('\000a')||
'              || frgbg_s.holen_uebersetzung(7977, :FAS_SPRACHE_ID) || ''</span>'';'||unistr('\000a')||
''||unistr('\000a')||
'     end if;'||unistr('\000a')||
'   end if;'||unistr('\000a')||
'     '||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P358_IMAGE_TAG,P358_ID'
 ,p_attribute_03 => 'P358_BEZ_VORHANDEN'
 ,p_attribute_04 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 5992808742171276 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 358
 ,p_name => 'set_vorschau_image_size'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P358_BREITE,P358_HOEHE'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 5993106200171286 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 358
 ,p_event_id => 5992808742171276 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P358_BILD_VORSCHAU'
 ,p_attribute_01 => '$("img#P358_BILD_VORSCHAU").css({'||unistr('\000a')||
'     width: $("#P358_BREITE").val(), '||unistr('\000a')||
'     height: $("#P358_HOEHE").val()'||unistr('\000a')||
'  });'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:SB_AUFTRAG_BILDER:P358_ROWID:ROWID';

wwv_flow_api.create_page_process(
  p_id     => 5723204561741052 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 358,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from SB_AUFTRAG_BILDER',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :P358_SATZ_KENNZEICHEN := ''Geloescht von ''||:APP_USER||'' am ''||to_char(SYSDATE,''DD.MM.YYYY hh24:mi:ss'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5734403418030297 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 358,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_sb_geloescht',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5719716393741031 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':P358_IMAGE_TAG := upper(:P358_IMAGE_TAG);';

wwv_flow_api.create_page_process(
  p_id     => 5732925882008412 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 358,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_image_tag',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':REQUEST in (''SAVE'',''CREATE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'/* '||unistr('\000a')||
''||unistr('\000a')||
' Setzte die sb auftrags id auf null um es als global zu markieren.'||unistr('\000a')||
' Die 0 ist erforderlich, damit es in der POP-UP-Liste der NULL-WErt überhaupt angezeigt wird.'||unistr('\000a')||
'*/'||unistr('\000a')||
':P358_SB_AUFTRAG_ID := null;';

wwv_flow_api.create_page_process(
  p_id     => 5761806138871104 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 358,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_sb_auftrag_id',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':P358_SB_AUFTRAG_ID = 0',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:SB_AUFTRAG_BILDER:P358_ROWID:ROWID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 5723426334741052 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 358,
  p_process_sequence=> 90,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of SB_AUFTRAG_BILDER',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_success_message=> 'Aktion wurde verarbeitet.',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'/* '||unistr('\000a')||
''||unistr('\000a')||
' Setzte die sb auftrags id wieder auf 0 wenn sie vorher auf null war.'||unistr('\000a')||
' Die 0 ist erforderlich, damit es in der POP-UP-Liste der NULL-WErt überhaupt angezeigt wird.'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
':P358_SB_AUFTRAG_ID := 0;';

wwv_flow_api.create_page_process(
  p_id     => 5762532111878609 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 358,
  p_process_sequence=> 100,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_sb_auftrag_id_back',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':P358_SB_AUFTRAG_ID is null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'358';

wwv_flow_api.create_page_process(
  p_id     => 5723624932741053 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 358,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>5719716393741031 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 358
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00360
prompt  ...PAGE 360: Dokumentverwaltung_HTML
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 360
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Dokumentverwaltung_HTML'
 ,p_step_title => 'Dokumentverwaltung'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Dokumentverwaltung'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909145639'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 4994406689893754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 360,
  p_plug_name=> 'Dokumente',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow: auto; height: &P360_HEIGHT_DOK.px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 4995031463893763 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 360,
  p_button_sequence=> 30,
  p_button_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P360_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4995403404893766 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 360,
  p_button_sequence=> 50,
  p_button_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_DOKUMENT_UPLOAD',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Neues Dokument laden',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4994615908893762 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 360,
  p_button_sequence=> 10,
  p_button_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.submit(''CANCEL'')',
  p_button_execute_validations=>'N',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4995217044893765 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 360,
  p_button_sequence=> 40,
  p_button_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Create',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P360_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 4994829549893763 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 360,
  p_button_sequence=> 20,
  p_button_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'P360_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'DELETE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>4999911418893783 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:360:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4995610046893766 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_HEIGHT_DOK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4995820101893769 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4996020306893771 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_DOKUMENT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Dokument Id',
  p_post_element_text=>'&#160&#160',
  p_source=>'DOKUMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4996225886893771 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Name',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4996407343893771 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_MIME_TYPE',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'text/html',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mime Type',
  p_source=>'MIME_TYPE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4996603101893771 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_DOKUMENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Dokument',
  p_source=>'DECLARE '||unistr('\000a')||
'   --v_string VARCHAR2(32700);'||unistr('\000a')||
'   v_string clob;'||unistr('\000a')||
'   v_laenge    number;'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'NULL;'||unistr('\000a')||
'/*'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      --select utl_raw.cast_to_varchar2(dbms_lob.substr(dokument,2000, 1)) '||unistr('\000a')||
'      select length(dokument) into v_laenge '||unistr('\000a')||
'      from dokumentuebersetzungen '||unistr('\000a')||
'      where ID = :p360_id ;'||unistr('\000a')||
'      IF v_laenge > 0 THEN'||unistr('\000a')||
'         select frgbg_t.CONVERT_BLOB_TO_CLOB(dokument)'||unistr('\000a')||
'         into v_string'||unistr('\000a')||
'         from dokumentuebersetzungen '||unistr('\000a')||
'         where ID = :p360_id ;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN no_data_found THEN '||unistr('\000a')||
'        NULL;'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'        mel.p(''Fehler beim Laden des Dokuments!'',v_prot_id,''102/352 dokument'');'||unistr('\000a')||
'        RAISE_APPLICATION_ERROR (-20000,SQLERRM);'||unistr('\000a')||
'   END;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   RETURN v_string;'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 20,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4996817227893772 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprache',
  p_source=>'SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  -- and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf '||unistr('\000a')||
'order by 1'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4997017875893772 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_STANDARD',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 46,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Standard',
  p_source=>'STANDARD',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.holen_uebersetzung(76,:fas_sprache_id) a, 1 b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'select frgbg_s.holen_uebersetzung(77,:fas_sprache_id) a, 0 b from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4997219319893772 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_DOK_UPLOAD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 26,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Neues Dokument',
  p_source=>'DOKUMENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_FILE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'DB_COLUMN',
  p_attribute_02 => 'MIME_TYPE',
  p_attribute_03 => 'NAME',
  p_attribute_06 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4997422418893774 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_SPRACHAUSWAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprachauswahl',
  p_pre_element_text=>'&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where  fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  and s.SPRACHE_ID in (SELECT sprache_id '||unistr('\000a')||
'                       from dokumentuebersetzungen '||unistr('\000a')||
'                       where dokument_id = :p360_dokument_id)'||unistr('\000a')||
'  --and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4997603634893774 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_TEXTDOKUMENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Textdokument',
  p_source=>'TEXTDOKUMENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 32000,
  p_cHeight=> 20,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4997810884893774 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_GEN_TEXT_NEUE_SPRACHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kopie Text für Sprache',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  and s.SPRACHE_ID not in (SELECT sprache_id '||unistr('\000a')||
'                           from dokumentuebersetzungen '||unistr('\000a')||
'                           where dokument_id = :p360_dokument_id)'||unistr('\000a')||
'  --and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback '||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5000320021902388 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '351',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5753801375500705 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 360,
  p_name=>'P360_VORH_IMAGE_TAGS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 4994406689893754+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verfügbare Image-Tags',
  p_source=>'declare'||unistr('\000a')||
'  l_tags_html varchar2(32767);'||unistr('\000a')||
'  cursor c_tags is select'||unistr('\000a')||
'       kurzbezeichnung,'||unistr('\000a')||
'       image_tag'||unistr('\000a')||
'     from sb_auftrag_bilder '||unistr('\000a')||
'     where '||unistr('\000a')||
'        (sb_auftrag_id is null or sb_auftrag_id = :P355_ID) and satz_kennzeichen is null;'||unistr('\000a')||
''||unistr('\000a')||
'   l_tags c_tags%rowtype;'||unistr('\000a')||
''||unistr('\000a')||
'   function add_tag( p_tag c_tags%rowtype) return varchar2'||unistr('\000a')||
'   as'||unistr('\000a')||
'   begin'||unistr('\000a')||
''||unistr('\000a')||
'       return ''<span>'' || p_tag.kurzbezeichnung || '':</span> <span style="font-weight:BOLD">##'' '||unistr('\000a')||
'         || p_tag.image_tag || ''##</span>'';'||unistr('\000a')||
'   end;'||unistr('\000a')||
'begin'||unistr('\000a')||
'   if(:P360_ZURUECK_ZUR_SEITE = 355) then'||unistr('\000a')||
'       '||unistr('\000a')||
'       open c_tags;'||unistr('\000a')||
'       loop'||unistr('\000a')||
'          fetch c_tags into l_tags;'||unistr('\000a')||
''||unistr('\000a')||
'          exit when c_tags%NOTFOUND;'||unistr('\000a')||
'          if(l_tags.image_tag is not null) then'||unistr('\000a')||
'          '||unistr('\000a')||
'              if(l_tags_html is null or l_tags_html = '''') then'||unistr('\000a')||
'                 l_tags_html := add_tag(l_tags);'||unistr('\000a')||
'              else'||unistr('\000a')||
'                 l_tags_html := l_tags_html || ''; '' || add_tag(l_tags) || ''<br/>'';'||unistr('\000a')||
'              end if;'||unistr('\000a')||
'           end if;'||unistr('\000a')||
'        end loop;'||unistr('\000a')||
''||unistr('\000a')||
'        close c_tags;'||unistr('\000a')||
''||unistr('\000a')||
'        if(l_tags_html = '''') then'||unistr('\000a')||
'           -- Keine Tags vorhanden '||unistr('\000a')||
'           return frgbg_s.holen_uebersetzung(7978,:APP_SPRACHE_ID);'||unistr('\000a')||
'        else'||unistr('\000a')||
'           return l_tags_html;'||unistr('\000a')||
'        end if;'||unistr('\000a')||
'   else'||unistr('\000a')||
'     return frgbg_s.holen_uebersetzung(7978,:APP_SPRACHE_ID);'||unistr('\000a')||
'   end if;'||unistr('\000a')||
''||unistr('\000a')||
'end;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-TOP',
  p_display_when=>':P360_ZURUECK_ZUR_SEITE = 355',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 4998123002893776 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_del_standard_dok',
  p_validation_sequence=> 10,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :request = ''DELETE'' AND :p360_standard = 1 THEN'||unistr('\000a')||
'      RETURN (''Das Dokument mit der Standard-Sprache kann nicht gelöscht werden!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 4994829549893763 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_SCROLLREGION_HEIGHT_MAX  NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P360_HEIGHT_DOK:= :FAS_SCROLLREGION_HEIGHT_MAX * 0.992;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4998213133893776 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'NULL;'||unistr('\000a')||
'/*'||unistr('\000a')||
'   :p300_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_info  := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_artikelliste := frgbg_s.holen_uebersetzung(3078,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_in_warenkorb   := frgbg_s.holen_uebersetzung(3079,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_zu';

p:=p||'r_kasse := frgbg_s.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'--   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(3591,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_speichern := frgbg_s.holen_uebersetzung(172,v_s';

p:=p||'prache_id);'||unistr('\000a')||
'   --:P300_BL_INDIV_REZEPT := frgbg_s.holen_uebersetzung(3082,v_sprache_id);'||unistr('\000a')||
'   :P300_BL_SUCHEN := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_hide := frgbg_s.holen_uebersetzung(4924,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_show := frgbg_s.holen_uebersetzung(4923,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_REGION_TITEL_KATEGORIE:=NULL;'||unistr('\000a')||
'   :p300_region_titel_artikel:= frgbg_s.holen_uebersetzung(48';

p:=p||'58,v_sprache_id);'||unistr('\000a')||
'   :p300_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   --:P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(1569,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_NV_WARENKORB := frgbg_s.holen_uebersetzung(3844,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_label';

p:=p||'s_init'');'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4999422684893782 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   select DOKUMENTUEBERS_SEQ.nextval into v_id from dual;'||unistr('\000a')||
'   INSERT INTO DOKUMENTUEBERSETZUNGEN (ID,DOKUMENT_ID,NAME,MIME_TYPE,TEXTDOKUMENT,SPRACHE_ID,STANDARD)'||unistr('\000a')||
'   SELECT v_id,dokument_id, name,mime_type,textdokument,:P360_GEN_TEXT_NEUE_SPRACHE,0'||unistr('\000a')||
'   FROM DOKUMENTUEBERSETZUNGEN '||unistr('\000a')||
'   WHERE id =:p360_id; '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4999600069893782 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_textdokument',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''P360_GEN_TEXT_NEUE_SPRACHE''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'UPDATE dokumentuebersetzungen'||unistr('\000a')||
'SET NAME =:p360_name,'||unistr('\000a')||
'    MIME_TYPE =:p360_mime_type,'||unistr('\000a')||
'    --DOKUMENT  =utl_raw.cast_to_raw(dbms_lob.substr(:p360_dokument,32767,1)),'||unistr('\000a')||
'    dokument = frgbg_t.convert_clob_to_blob(:p360_dokument),'||unistr('\000a')||
'    SPRACHE_ID =:p360_SPRACHE_ID,'||unistr('\000a')||
'    STANDARD= :p360_STANDARD'||unistr('\000a')||
'WHERE id = :p360_id;';

wwv_flow_api.create_page_process(
  p_id     => 4999030592893782 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'upd_dokumentuebersetzungen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4995031463893763 + wwv_flow_api.g_id_offset,
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:DOKUMENTUEBERSETZUNGEN:P360_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 4998607498893779 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of DOKUMENTUEBERSETZUNGEN',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process row of table DOKUMENTUEBERSETZUNGEN.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SAVE'',''DELETE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'352';

wwv_flow_api.create_page_process(
  p_id     => 4998820084893779 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>4994829549893763 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
''||unistr('\000a')||
'  l_page_nr number := 351;'||unistr('\000a')||
''||unistr('\000a')||
'begin'||unistr('\000a')||
'    -- Das flexible Verweisen auf die Ursprungsseite hat nicht funktioniert, daher dieser Weg.'||unistr('\000a')||
''||unistr('\000a')||
'    if(:P360_ZURUECK_ZUR_SEITE is not null and :P360_ZURUECK_ZUR_SEITE <> 0) then'||unistr('\000a')||
'        l_page_nr := to_number(:P360_ZURUECK_ZUR_SEITE);'||unistr('\000a')||
'     end if;'||unistr('\000a')||
''||unistr('\000a')||
'    apex_application.g_unrecoverable_error := TRUE;'||unistr('\000a')||
'    owa_util.redirect_url(''f?p=&APP_ID.:'' || l_page_nr |';

p:=p||'|'':&APP_SESSION.:::::'');'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5707510259238898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Redirect_Page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':REQUEST in (''CANCEL'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id  number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'mel.p(''In get_dokument dok_id= %1,sprache=%2'',v_prot_id,''TEST'',''102/352'',:p360_dokument_id,:p360_sprache_id);'||unistr('\000a')||
'   IF :p360_dokument_id is not null and :P360_SPRACHAUSWAHL is not null THEN'||unistr('\000a')||
'      SELECT id INTO :p360_id'||unistr('\000a')||
'      FROM dokumentuebersetzungen'||unistr('\000a')||
'      WHERE dokument_id = :p360_dokument_id'||unistr('\000a')||
'        AND sprache_id  = :P360_SPRACHAUSWAHL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 4999221123893782 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_dokument',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:DOKUMENTUEBERSETZUNGEN:P360_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 4998400927893777 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 360,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from DOKUMENTUEBERSETZUNGEN',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to fetch row.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 360
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00361
prompt  ...PAGE 361: Dokumentverwaltung_Text
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 361
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Dokumentverwaltung_Text'
 ,p_step_title => 'Dokumentverwaltung_Text'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Dokumentverwaltung_Text'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909150336'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5312815543126885 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 361,
  p_plug_name=> 'Dokumente',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow: auto; height: &P361_HEIGHT_DOK.px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 5313402327126896 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 361,
  p_button_sequence=> 30,
  p_button_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Speichern',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P361_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5313811894126896 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 361,
  p_button_sequence=> 50,
  p_button_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_DOKUMENT_UPLOAD',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Neues Dokument laden',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5313024444126890 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 361,
  p_button_sequence=> 10,
  p_button_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.submit(''CANCEL'')',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5313628310126896 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 361,
  p_button_sequence=> 40,
  p_button_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Create',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P361_ID',
  p_button_condition_type=> 'ITEM_IS_NULL',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 5313232684126895 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 361,
  p_button_sequence=> 20,
  p_button_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE'');',
  p_button_execute_validations=>'N',
  p_button_condition=> 'P361_ID',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_database_action=>'DELETE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>5318528421126926 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:361:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 100,
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5314009428126898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_HEIGHT_DOK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5314220440126901 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5314401466126903 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_DOKUMENT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Dokument Id',
  p_post_element_text=>'&#160&#160',
  p_source=>'DOKUMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5314624632126903 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Name',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5314815157126903 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_MIME_TYPE',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'text/html',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mime Type',
  p_source=>'MIME_TYPE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 4,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5315015664126903 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_DOKUMENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Dokument',
  p_source=>'DECLARE '||unistr('\000a')||
'   --v_string VARCHAR2(32700);'||unistr('\000a')||
'   v_string clob;'||unistr('\000a')||
'   v_laenge    number;'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'NULL;'||unistr('\000a')||
'/*'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      --select utl_raw.cast_to_varchar2(dbms_lob.substr(dokument,2000, 1)) '||unistr('\000a')||
'      select length(dokument) into v_laenge '||unistr('\000a')||
'      from dokumentuebersetzungen '||unistr('\000a')||
'      where ID = :p361_id ;'||unistr('\000a')||
'      IF v_laenge > 0 THEN'||unistr('\000a')||
'         select frgbg_t.CONVERT_BLOB_TO_CLOB(dokument)'||unistr('\000a')||
'         into v_string'||unistr('\000a')||
'         from dokumentuebersetzungen '||unistr('\000a')||
'         where ID = :p361_id ;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN no_data_found THEN '||unistr('\000a')||
'        NULL;'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'        mel.p(''Fehler beim Laden des Dokuments!'',v_prot_id,''102/352 dokument'');'||unistr('\000a')||
'        RAISE_APPLICATION_ERROR (-20000,SQLERRM);'||unistr('\000a')||
'   END;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   RETURN v_string;'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 2000,
  p_cHeight=> 20,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5315208412126904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprache',
  p_source=>'SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  -- and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5315424016126904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_STANDARD',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 46,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Standard',
  p_source=>'STANDARD',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select frgbg_s.holen_uebersetzung(76,:fas_sprache_id) a, 1 b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'select frgbg_s.holen_uebersetzung(77,:fas_sprache_id) a, 0 b from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5315602874126904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_DOK_UPLOAD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 26,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Neues Dokument',
  p_source=>'DOKUMENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_FILE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'DB_COLUMN',
  p_attribute_02 => 'MIME_TYPE',
  p_attribute_03 => 'NAME',
  p_attribute_06 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5315812294126906 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_SPRACHAUSWAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Sprachauswahl',
  p_pre_element_text=>'&#160',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  and s.SPRACHE_ID in (SELECT sprache_id '||unistr('\000a')||
'                       from dokumentuebersetzungen '||unistr('\000a')||
'                       where dokument_id = :p361_dokument_id)'||unistr('\000a')||
'  --and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5316017510126906 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_TEXTDOKUMENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Textdokument',
  p_source=>'TEXTDOKUMENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 80,
  p_cMaxlength=> 32000,
  p_cHeight=> 20,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 5,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5316226285126906 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_GEN_TEXT_NEUE_SPRACHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kopie Text für Sprache',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select distinct sp.sprache display_value, sp.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs, sprachen sp'||unistr('\000a')||
'where fs.id = :fas_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  and s.SPRACHE_ID = sp.id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  and s.SPRACHE_ID not in (SELECT sprache_id '||unistr('\000a')||
'                           from dokumentuebersetzungen '||unistr('\000a')||
'                           where dokument_id = :p361_dokument_id)'||unistr('\000a')||
'  -- and s.sprache_id in (select sprache_id from uebersetzungen)-- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5316430292126906 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 361,
  p_name=>'P361_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 5312815543126885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 5316712905126910 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_del_standard_dok',
  p_validation_sequence=> 10,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :request = ''DELETE'' AND :p361_standard = 1 THEN'||unistr('\000a')||
'      RETURN (''Das Dokument mit der Standard-Sprache kann nicht gelöscht werden!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 5313232684126895 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_SCROLLREGION_HEIGHT_MAX  NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P361_HEIGHT_DOK:= :FAS_SCROLLREGION_HEIGHT_MAX * 0.992;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5316824678126914 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'NULL;'||unistr('\000a')||
'/*'||unistr('\000a')||
'   :p300_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_info  := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_artikelliste := frgbg_s.holen_uebersetzung(3078,v_sprache_id);'||unistr('\000a')||
'   --:p300_bl_in_warenkorb   := frgbg_s.holen_uebersetzung(3079,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_zu';

p:=p||'r_kasse := frgbg_s.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'--   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_loeschen := frgbg_s.holen_uebersetzung(3591,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_speichern := frgbg_s.holen_uebersetzung(172,v_s';

p:=p||'prache_id);'||unistr('\000a')||
'   --:P300_BL_INDIV_REZEPT := frgbg_s.holen_uebersetzung(3082,v_sprache_id);'||unistr('\000a')||
'   :P300_BL_SUCHEN := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_hide := frgbg_s.holen_uebersetzung(4924,v_sprache_id);'||unistr('\000a')||
'   :p300_bl_but_show := frgbg_s.holen_uebersetzung(4923,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_REGION_TITEL_KATEGORIE:=NULL;'||unistr('\000a')||
'   :p300_region_titel_artikel:= frgbg_s.holen_uebersetzung(48';

p:=p||'58,v_sprache_id);'||unistr('\000a')||
'   :p300_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   --:P300_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(1569,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P300_NV_WARENKORB := frgbg_s.holen_uebersetzung(3844,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_label';

p:=p||'s_init'');'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5318010884126923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_id    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   select DOKUMENTUEBERS_SEQ.nextval into v_id from dual;'||unistr('\000a')||
'   INSERT INTO DOKUMENTUEBERSETZUNGEN (ID,DOKUMENT_ID,NAME,MIME_TYPE,TEXTDOKUMENT,SPRACHE_ID,STANDARD)'||unistr('\000a')||
'   SELECT v_id,dokument_id, name,mime_type,textdokument,:P361_GEN_TEXT_NEUE_SPRACHE,0'||unistr('\000a')||
'   FROM DOKUMENTUEBERSETZUNGEN '||unistr('\000a')||
'   WHERE id =:p361_id; '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5318208969126923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_textdokument',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''P361_GEN_TEXT_NEUE_SPRACHE''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'UPDATE dokumentuebersetzungen'||unistr('\000a')||
'SET NAME =:p361_name,'||unistr('\000a')||
'    MIME_TYPE =:p361_mime_type,'||unistr('\000a')||
'    --DOKUMENT  =utl_raw.cast_to_raw(dbms_lob.substr(:p361_dokument,32767,1)),'||unistr('\000a')||
'    dokument = frgbg_t.convert_clob_to_blob(:p361_dokument),'||unistr('\000a')||
'    SPRACHE_ID =:p361_SPRACHE_ID,'||unistr('\000a')||
'    STANDARD= :p361_STANDARD'||unistr('\000a')||
'WHERE id = :p361_id;';

wwv_flow_api.create_page_process(
  p_id     => 5317632211126921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'upd_dokumentuebersetzungen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5313402327126896 + wwv_flow_api.g_id_offset,
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:DOKUMENTUEBERSETZUNGEN:P361_ID:ID|IUD';

wwv_flow_api.create_page_process(
  p_id     => 5317228948126921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'Process Row of DOKUMENTUEBERSETZUNGEN',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to process row of table DOKUMENTUEBERSETZUNGEN.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SAVE'',''DELETE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'352';

wwv_flow_api.create_page_process(
  p_id     => 5317418790126921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'reset page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>5313232684126895 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
''||unistr('\000a')||
'  l_page_nr number := 351;'||unistr('\000a')||
''||unistr('\000a')||
'begin'||unistr('\000a')||
'    -- Das flexible Verweisen auf die Ursprungsseite hat nicht funktioniert, daher dieser Weg.'||unistr('\000a')||
''||unistr('\000a')||
'    if(:P361_ZURUECK_ZUR_SEITE is not null and :P361_ZURUECK_ZUR_SEITE <> 0) then'||unistr('\000a')||
'        l_page_nr := to_number(:P361_ZURUECK_ZUR_SEITE);'||unistr('\000a')||
'     end if;'||unistr('\000a')||
''||unistr('\000a')||
'    apex_application.g_unrecoverable_error := TRUE;'||unistr('\000a')||
'    owa_util.redirect_url(''f?p=&APP_ID.:'' || l_page_nr |';

p:=p||'|'':&APP_SESSION.:::::'');'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 5711213244580364 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_process_sequence=> 130,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Redirect_Page',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':REQUEST in (''CANCEL'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id  number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'mel.p(''In get_dokument dok_id= %1,sprache=%2'',v_prot_id,''TEST'',''102/352'',:p361_dokument_id,:p361_sprache_id);'||unistr('\000a')||
'   IF :p361_dokument_id is not null and :P361_SPRACHAUSWAHL is not null THEN'||unistr('\000a')||
'      SELECT id INTO :p361_id'||unistr('\000a')||
'      FROM dokumentuebersetzungen'||unistr('\000a')||
'      WHERE dokument_id = :p361_dokument_id'||unistr('\000a')||
'        AND sprache_id  = :P361_SPRACHAUSWAHL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5317801806126921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_dokument',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:DOKUMENTUEBERSETZUNGEN:P361_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 5317005576126914 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 361,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from DOKUMENTUEBERSETZUNGEN',
  p_process_sql_clob => p,
  p_process_error_message=> 'Unable to fetch row.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 361
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00400
prompt  ...PAGE 400: Serienbriefe
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 400
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Serienbriefe'
 ,p_step_title => 'Serienbriefe'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Serienbriefe'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140918162358'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6053323535343767 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_plug_name=> 'Serienbriefe',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT'||unistr('\000a')||
'  APEX_ITEM.CHECKBOX(p_idx => 3, p_value => d.id , p_attributes => ''class="jr_datei_checkbox"'')  CHECKBOX,'||unistr('\000a')||
'  a.ID auftrag_id,'||unistr('\000a')||
'  d.ID id,'||unistr('\000a')||
'  a.BEZEICHNUNG ,'||unistr('\000a')||
'  a.persstamm_id_LOGIN,'||unistr('\000a')||
'  a.persstamm_id_IDENT,'||unistr('\000a')||
'  --PLANDATUM ,'||unistr('\000a')||
'  a.erfdat erstelldatum,'||unistr('\000a')||
'  a.BEMERKUNG,'||unistr('\000a')||
'  dbms_lob.getlength(d.datei_blob) datei_download,'||unistr('\000a')||
' d.DATEI_NAME,'||unistr('\000a')||
' (CASE TRUNC (dbms_lob.getlength(d.datei_blob) / 1048576 /*MEGABYTE*';

s:=s||'/)'||unistr('\000a')||
'           WHEN 0'||unistr('\000a')||
'              THEN TO_CHAR ((dbms_lob.getlength(d.datei_blob) / 1024 /*KILOBYTE*/), ''999,999'') || '' KB'''||unistr('\000a')||
'           ELSE TO_CHAR ((dbms_lob.getlength(d.datei_blob) / 1048576 /*MEGABYTE*/), ''999,999.00'') || '' MB'''||unistr('\000a')||
'        END'||unistr('\000a')||
' ) display_size,'||unistr('\000a')||
' to_char(d.erfdat + 30,''DD.MM.YYYY'') wird_geloescht_am'||unistr('\000a')||
'FROM sb_auftraege a, sb_auftrag_dateien d'||unistr('\000a')||
'where a.satz_kennzeichen is null'||unistr('\000a')||
'  and d.S';

s:=s||'ATZ_KENNZEICHEN is null'||unistr('\000a')||
'  and a.typ_id = 3 -- Nur PDF Generierung'||unistr('\000a')||
'  and d.sb_auftrag_id = a.id'||unistr('\000a')||
'  and a.persstamm_id_IDENT = NVL(:FAS_IDENTITAET_PERSSTAMM_ID,1430)';

wwv_flow_api.create_page_plug (
  p_id=> 6053716717343768 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_plug_name=> '&P400_REGION_TITEL_SERIENBRIEFE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_ajax_items_to_submit=> 'FAS_IDENTITAET_PERSSTAMM_ID',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow: auto; height: &P400_HEIGHT_SBDETAILS.px; max-width:1200px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'SELECT'||unistr('\000a')||
'  APEX_ITEM.CHECKBOX(p_idx => 3, p_value => d.id , p_attributes => ''class="jr_datei_checkbox"'')  CHECKBOX,'||unistr('\000a')||
'  a.ID auftrag_id,'||unistr('\000a')||
'  d.ID id,'||unistr('\000a')||
'  a.BEZEICHNUNG ,'||unistr('\000a')||
'  a.persstamm_id_LOGIN,'||unistr('\000a')||
'  a.persstamm_id_IDENT,'||unistr('\000a')||
'  --PLANDATUM ,'||unistr('\000a')||
'  a.erfdat erstelldatum,'||unistr('\000a')||
'  a.BEMERKUNG,'||unistr('\000a')||
'  dbms_lob.getlength(d.datei_blob) datei_download,'||unistr('\000a')||
' d.DATEI_NAME,'||unistr('\000a')||
' (CASE TRUNC (dbms_lob.getlength(d.datei_blob) / 1048576 /*MEGABYTE*';

a1:=a1||'/)'||unistr('\000a')||
'           WHEN 0'||unistr('\000a')||
'              THEN TO_CHAR ((dbms_lob.getlength(d.datei_blob) / 1024 /*KILOBYTE*/), ''999,999'') || '' KB'''||unistr('\000a')||
'           ELSE TO_CHAR ((dbms_lob.getlength(d.datei_blob) / 1048576 /*MEGABYTE*/), ''999,999.00'') || '' MB'''||unistr('\000a')||
'        END'||unistr('\000a')||
' ) display_size,'||unistr('\000a')||
' to_char(d.erfdat + 30,''DD.MM.YYYY'') wird_geloescht_am'||unistr('\000a')||
'FROM sb_auftraege a, sb_auftrag_dateien d'||unistr('\000a')||
'where a.satz_kennzeichen is null'||unistr('\000a')||
'  and d.S';

a1:=a1||'ATZ_KENNZEICHEN is null'||unistr('\000a')||
'  and a.typ_id = 3 -- Nur PDF Generierung'||unistr('\000a')||
'  and d.sb_auftrag_id = a.id'||unistr('\000a')||
'  and a.persstamm_id_IDENT = NVL(:FAS_IDENTITAET_PERSSTAMM_ID,1430)';

wwv_flow_api.create_worksheet(
  p_id=> 6053825163343768+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_region_id=> 6053716717343768+wwv_flow_api.g_id_offset,
  p_name=> 'Serienbriefe',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '100000',
  p_max_row_count_message=> 'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'N',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y',
  p_pagination_display_pos=>'BOTTOM_RIGHT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'NONE',
  p_show_detail_link=>'N',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'N',
  p_show_control_break=>'N',
  p_show_highlight=>'N',
  p_show_computation=>'N',
  p_show_aggregate=>'N',
  p_show_chart=>'N',
  p_show_group_by=>'N',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'N',
  p_show_reset=>'N',
  p_show_download=>'N',
  p_show_help=>'N',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'SASCHA.LENZ',
  p_internal_uid=> 1);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6060000294681705+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID',
  p_display_order          =>1,
  p_column_identifier      =>'L',
  p_column_label           =>'Datei id',
  p_report_label           =>'Datei id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'HIDDEN',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6060405236739907+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'CHECKBOX',
  p_display_order          =>2,
  p_column_identifier      =>'M',
  p_column_label           =>'<input type="checkbox" class="check_all" value="checkall" />',
  p_report_label           =>'<input type="checkbox" class="check_all" value="checkall" />',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6054019157343769+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'AUFTRAG_ID',
  p_display_order          =>3,
  p_column_identifier      =>'A',
  p_column_label           =>'&P400_BEZ_AUFTRAG_ID.',
  p_report_label           =>'&P400_BEZ_AUFTRAG_ID.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6054225601343770+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'BEZEICHNUNG',
  p_display_order          =>5,
  p_column_identifier      =>'C',
  p_column_label           =>'&P400_BEZ_BEZEICHNUNG.',
  p_report_label           =>'&P400_BEZ_BEZEICHNUNG.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6054525186343771+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'PERSSTAMM_ID_LOGIN',
  p_display_order          =>8,
  p_column_identifier      =>'F',
  p_column_label           =>'Persstamm Id Login',
  p_report_label           =>'Persstamm Id Login',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'HIDDEN',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6054628376343771+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'PERSSTAMM_ID_IDENT',
  p_display_order          =>9,
  p_column_identifier      =>'G',
  p_column_label           =>'Persstamm Id Ident',
  p_report_label           =>'Persstamm Id Ident',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'HIDDEN',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6054714295343771+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERSTELLDATUM',
  p_display_order          =>10,
  p_column_identifier      =>'H',
  p_column_label           =>'&P400_BEZ_ERSTELLDATUM.',
  p_report_label           =>'&P400_BEZ_ERSTELLDATUM.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_format_mask            =>'DD.MM.YYYY',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6059425050651069+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'BEMERKUNG',
  p_display_order          =>11,
  p_column_identifier      =>'I',
  p_column_label           =>'Bemerkung',
  p_report_label           =>'Bemerkung',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'HIDDEN',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6059510055651070+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'DATEI_NAME',
  p_display_order          =>12,
  p_column_identifier      =>'J',
  p_column_label           =>'&P400_BEZ_DATEINAME.',
  p_report_label           =>'&P400_BEZ_DATEINAME.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6075722288076048+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'DISPLAY_SIZE',
  p_display_order          =>13,
  p_column_identifier      =>'N',
  p_column_label           =>'&P400_BEZ_DATEIGROESSE.',
  p_report_label           =>'&P400_BEZ_DATEIGROESSE.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6112206799592848+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'DATEI_DOWNLOAD',
  p_display_order          =>14,
  p_column_identifier      =>'O',
  p_column_label           =>'&P400_BEZ_DOWNLOAD.',
  p_report_label           =>'&P400_BEZ_DOWNLOAD.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_format_mask            =>'DOWNLOAD:SB_AUFTRAG_DATEIEN:DATEI_BLOB:ID:::DATEI_NAME:::attachment:Herunterladen',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6192415731194920+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WIRD_GELOESCHT_AM',
  p_display_order          =>15,
  p_column_identifier      =>'P',
  p_column_label           =>'&P400_BEZ_WIRD_GELOESCHT_AM.',
  p_report_label           =>'&P400_BEZ_WIRD_GELOESCHT_AM.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'CHECKBOX:AUFTRAG_ID:BEZEICHNUNG:ERSTELLDATUM:DISPLAY_SIZE:DATEI_NAME:DATEI_DOWNLOAD:WIRD_GELOESCHT_AM:';

wwv_flow_api.create_worksheet_rpt(
  p_id => 6055506144380624+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_worksheet_id => 6053825163343768+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'60556',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>20,
  p_report_columns          =>rc1,
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6187623602140427 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 400,
  p_plug_name=> 'Hinweis',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6058300715587219 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 400,
  p_button_sequence=> 20,
  p_button_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_NEUER_SB',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P400_BL_ERSTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6056819266431724 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 400,
  p_button_sequence=> 10,
  p_button_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P400_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'N',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6066605975768539 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 400,
  p_button_sequence=> 30,
  p_button_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_FILES_MRD',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P400_BL_DELETE_MR.',
  p_button_position=> 'RIGHT_OF_IR_SEARCH_BAR',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''APPLY_CHANGES_FILES_MRD'');',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6057114202439803 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P400_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6056819266431724+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_branch_condition_type=> 'ITEM_IS_NOT_NULL',
  p_branch_condition=> 'P400_ZURUECK_ZUR_SEITE',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 08-OCT-2013 13:34 by SASCHA.LENZ');
 
wwv_flow_api.create_page_branch(
  p_id=>6058524264594007 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::P401_ZURUECK_ZUR_SEITE:400',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6058300715587219+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 08-OCT-2013 13:59 by SASCHA.LENZ');
 
wwv_flow_api.create_page_branch(
  p_id=>3583328954007276 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_branch_name=> 'Go to 400',
  p_branch_action=> 'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6056121559422961 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '130',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6056330217425469 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6056505068427627 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6057818807573579 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_REGION_TITEL_SERIENBRIEFE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6066824675773960 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BL_DELETE_MR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6068610898025430 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_HEIGHT_LIST',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6077127146153179 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_NV_SERIENBRIEFE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6188323172159203 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_HINWEISMELDUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6187623602140427+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(8022,:FAS_SPRACHE_ID)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6196930481464169 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BEZ_AUFTRAG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(8023,:FAS_SPRACHE_ID)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6197700961474508 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BEZ_BEZEICHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(516,:FAS_SPRACHE_ID)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6198020008480000 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BEZ_ERSTELLDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung( 	8025,:FAS_SPRACHE_ID)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6198507241504700 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BEZ_WIRD_GELOESCHT_AM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(8024,:FAS_SPRACHE_ID)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6199016376516845 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BEZ_DATEINAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(2252,:FAS_SPRACHE_ID)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6199313044525275 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BEZ_DOWNLOAD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(8026,:FAS_SPRACHE_ID)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6199707896552263 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 400,
  p_name=>'P400_BEZ_DATEIGROESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 6053716717343768+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung( 8027,:FAS_SPRACHE_ID)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6067508408844955 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 400
 ,p_name => 'Check Alle Dateien'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.check_all'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6067817874844968 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 400
 ,p_event_id => 6067508408844955 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '.jr_datei_checkbox'
 ,p_attribute_01 => '$(''.jr_datei_checkbox'').prop(''checked'',$(this.triggeringElement).prop(''checked''));'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6067917759847683 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 400
 ,p_name => 'check for all jr dateien checkboxs'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.jr_datei_checkbox'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6068212051847683 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 400
 ,p_event_id => 6067917759847683 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_affected_elements_type => 'JQUERY_SELECTOR'
 ,p_affected_elements => '.check_all'
 ,p_attribute_01 => '// Prüfe ob alle Checkboxen ausgewählt wurden. Wenn ja soll die Checkbox zum "alle auswählen" ausgewählt werden ansonsten markierung löschen'||unistr('\000a')||
'$(''.check_all'').prop(''checked'',$(''.jr_datei_checkbox:checked'').length == $(''.jr_datei_checkbox'').length);'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   :p400_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p400_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id); 	'||unistr('\000a')||
'   :p400_bl_delete_mr := frgbg_s.holen_uebersetzung(8006,v_sprache_id);'||unistr('\000a')||
'   :P400_REGION_TITEL_SERIENBRIEFE := frgbg_s.holen_uebersetzung(8005,v_sprache_id);'||unistr('\000a')||
'   :P400_NV_SERI';

p:=p||'ENBRIEFE := frgbg_s.holen_uebersetzung(8005,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6056613033429997 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 400,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_SCROLLREGION_HEIGHT_MAX  NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P400_HEIGHT_LIST := :FAS_SCROLLREGION_HEIGHT_MAX * 0.60;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6068718517027683 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 400,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
' l_value varchar2(100);'||unistr('\000a')||
' l_id number;'||unistr('\000a')||
' l_count number := 0;'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Durchlaufe alle Checkboxen um Dateien zu löschen.'||unistr('\000a')||
' FOR i IN 1..APEX_APPLICATION.G_F03.COUNT LOOP'||unistr('\000a')||
'    l_value := APEX_APPLICATION.G_F03(i);'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    if(l_value is not null and l_value <> ''0'') then'||unistr('\000a')||
'     l_id := to_number(l_value);'||unistr('\000a')||
'      '||unistr('\000a')||
'      -- Lösche die Datei'||unistr('\000a')||
'      UPDATE SB_AUFTRAG_DATEIEN set'||unistr('\000a')||
'          satz_kennzeichen';

p:=p||' = ''Geloescht von ''||:APP_USER'||unistr('\000a')||
'            ||'' am ''||to_char(SYSDATE,''DD.MM.YYYY hh24:mi:ss'')'||unistr('\000a')||
'      WHERE ID = l_id;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Schau ob für einen Auftrag überhaupt noch Dateien vorhanden sind.'||unistr('\000a')||
'      select count(*) into l_count from SB_AUFTRAG_DATEIEN where'||unistr('\000a')||
'          sb_auftrag_id = (select sb_auftrag_id from SB_AUFTRAG_DATEIEN where id = l_id)'||unistr('\000a')||
'          and satz_kennzeichen is null;'||unistr('\000a')||
''||unistr('\000a')||
'    end if;'||unistr('\000a')||
'';

p:=p||'  end loop;'||unistr('\000a')||
'   '||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6067219528800812 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 400,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'ApplyFilesMRD',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>6066605975768539 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Dateien wurden gelöscht',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 400
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00401
prompt  ...PAGE 401: Erstelle Serienbrief
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 401
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Erstelle Serienbrief'
 ,p_step_title => 'Erstelle Serienbrief'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141027155208'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6076304788126234 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 401,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6077324254218550 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 401,
  p_plug_name=> '&P401_REGION_TITEL_SB_ERSTELLEN.',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 11,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6079803784259947 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 401,
  p_button_sequence=> 20,
  p_button_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_NEUER_SB',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P401_BL_ERSTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6079628933257690 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 401,
  p_button_sequence=> 10,
  p_button_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P401_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'N',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7443311997696648 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 401,
  p_button_sequence=> 30,
  p_button_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_NEUER_SB_TEST',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P401_BL_ERSTELLEN_TEST.',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6080126294266401 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P401_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:RP,401::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6079628933257690+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 40,
  p_branch_condition_type=> 'ITEM_IS_NOT_NULL',
  p_branch_condition=> 'P401_ZURUECK_ZUR_SEITE',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 08-OCT-2013 13:34 by SASCHA.LENZ');
 
wwv_flow_api.create_page_branch(
  p_id=>6080301145268661 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 50,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 08-OCT-2013 13:59 by SASCHA.LENZ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2228423364580113 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_IDENT_SUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_tag_attributes  => 'class="shuttle_search shuttle_ident"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'SELECT 1 FROM DUAL '||unistr('\000a')||
'WHERE'||unistr('\000a')||
'  (SELECT count(*)'||unistr('\000a')||
'FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'  AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'  AND p.betreuer = ''I'') > 1',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>2237608105176504 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_FRANKIERUNG_IMAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_FILE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'WWV_FLOW_FILES',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>4453820083639168 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_ANZ_DATENSAETZE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6077626463228646 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_REGION_TITEL_SB_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6078012049233912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6078224169237394 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_NV_SB_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6078911272252646 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6079422700255941 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '400',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6080904870288655 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_ART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select fas_synch.GET_TAB_UEBERSETZUNG (''SB_AUFTRAG_ARTEN.BEZEICHNUNG'',ID ,:FAS_SPRACHE_ID) bez, id'||unistr('\000a')||
'FROM sb_auftrag_arten'||unistr('\000a')||
'where JR_JASPER_FILENAME is not null -- nur jr Dateien (zur PDFs generieren können)'||unistr('\000a')||
'     and satz_kennzeichen is null '||unistr('\000a')||
'order by sortierung',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 32,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6083031329381443 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_PERSSTAMM_ID_WAHLIDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_pre_element_text=>'<div class="shuttle_ident" style="margin-bottom:10px;">',
  p_post_element_text=>'</div>',
  p_source=>'SELECT p.id b'||unistr('\000a')||
'FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'  AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'  AND p.betreuer = ''I'''||unistr('\000a')||
'  AND p.id = :FAS_IDENTITAET_PERSSTAMM_ID',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_SHUTTLE',
  p_lov=> 'SELECT substr(p.name,1,30)||'', ''||substr(p.ort,1,30)||'', ''||p.id a, p.id b'||unistr('\000a')||
'FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'  AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'  AND p.betreuer = ''I'''||unistr('\000a')||
'order by a',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 150,
  p_cMaxlength=> 4000,
  p_cHeight=> 10,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'style="width:300px; height:150px;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when=>'DECLARE'||unistr('\000a')||
'   l_anzahl number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Wenn nur eine Identität ausgewählt werden kann, dann reicht es wenn diese Angezeigt wird.'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT count(*) into l_anzahl'||unistr('\000a')||
'   FROM personenstamm p, pers_zugriffe z'||unistr('\000a')||
'   WHERE p.id = z.persstamm_id_betreuerzugriff'||unistr('\000a')||
'     AND z.persstamm_id_betreuer = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'     AND p.betreuer = ''I'';'||unistr('\000a')||
''||unistr('\000a')||
'   if l_anzahl = 1 then'||unistr('\000a')||
'     return TRUE;'||unistr('\000a')||
'   else'||unistr('\000a')||
'     return FALSE;'||unistr('\000a')||
'   end if;'||unistr('\000a')||
'end;',
  p_read_only_when_type=>'FUNCTION_BODY',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'MOVE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6083816401424411 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_PDF_SPLITTING',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_CHECKBOX',
  p_lov=> 'select frgbg_s.holen_uebersetzung(8007,:FAS_SPRACHE_ID) display, 1 value from dual',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_cattributes_element=>'style="padding-left:10px; padding-top:10px; padding-bottom:10px"',
  p_tag_attributes2=> 'style="font-weight:bold;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => '1',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6089908314205944 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_SB_ERSTELLEN_BESCHREIBUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(8010,:FAS_SPRACHE_ID)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cattributes_element=>'style="padding-bottom:5px; max-width:600px;"',
  p_tag_attributes  => 'style="white-space:pre"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899816394489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6095020640474387 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_X',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'X',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7443603471703621 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 401,
  p_name=>'P401_BL_ERSTELLEN_TEST',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 6077324254218550+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6094222194436961 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 401,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P401_PERSSTAMM_ID_WAHLIDENT',
  p_validation_sequence=> 10,
  p_validation => 'P401_PERSSTAMM_ID_WAHLIDENT',
  p_validation_type => 'ITEM_NOT_NULL',
  p_error_message => '#LABEL# must have some value.',
  p_always_execute=>'N',
  p_only_for_changed_rows=> 'Y',
  p_associated_item=> 6083031329381443 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6092417252378823 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 401
 ,p_name => 'Zeige/Ausblende Checkbox PDF Splitting'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P401_PERSSTAMM_ID_WAHLIDENT'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6092700244378827 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 401
 ,p_event_id => 6092417252378823 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P401_PRO_IDENT_EIN_PDF'
 ,p_attribute_01 => 'if($(''#P401_PERSSTAMM_ID_WAHLIDENT_RIGHT option'').size() <= 1) {'||unistr('\000a')||
'  $(''#P401_PDF_SPLITTING'').hide();'||unistr('\000a')||
'} else {'||unistr('\000a')||
'  $(''#P401_PDF_SPLITTING'').show();'||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 2229203375610539 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 401
 ,p_name => 'Ident Suche'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.shuttle_search'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'keypress'
  );
wwv_flow_api.create_page_da_action (
  p_id => 2229532120610541 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 401
 ,p_event_id => 2229203375610539 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'var shuttle_class = $(this.triggeringElement).attr(''class'').replace(''shuttle_search'','''').trim();'||unistr('\000a')||
''||unistr('\000a')||
'var suche = $(this.triggeringElement).val().toUpperCase();'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'if(suche.match(/[^\w ]/i)) {'||unistr('\000a')||
''||unistr('\000a')||
'  alert(''Suchfeld darf nur Alphanumerische Zeichen haben.'');'||unistr('\000a')||
''||unistr('\000a')||
'} else {'||unistr('\000a')||
''||unistr('\000a')||
'  // Durchlaufe alle Optionen und prüfe ob sie in das Suchkriterium passen.'||unistr('\000a')||
'   $(''div.'' + shuttle_class + '' td.shuttleSelect1 option'').each(function() {'||unistr('\000a')||
''||unistr('\000a')||
'      var $this = $(this);'||unistr('\000a')||
''||unistr('\000a')||
'      var suchReg = new RegExp(''.*'' + suche.replace('' '',''.*'') + ''.*'');'||unistr('\000a')||
''||unistr('\000a')||
'      //alert($this.text());'||unistr('\000a')||
'      if($this.text().toUpperCase().match(suchReg)) {          '||unistr('\000a')||
'         $this.show();'||unistr('\000a')||
'      } else {'||unistr('\000a')||
'         $this.hide();'||unistr('\000a')||
'      }'||unistr('\000a')||
''||unistr('\000a')||
'    '||unistr('\000a')||
''||unistr('\000a')||
'    });   '||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 4455625284678562 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 401
 ,p_name => 'Ermittle Anzahl betroffener Datensätze'
 ,p_event_sequence => 30
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P401_ART_ID,P401_PERSSTAMM_ID_WAHLIDENT'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 4455907815678564 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 401
 ,p_event_id => 4455625284678562 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'declare'||unistr('\000a')||
'  v_anz number;'||unistr('\000a')||
'  v_return number;'||unistr('\000a')||
'  v_sb_auftrag_id number;'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'  begin'||unistr('\000a')||
'     select max(id)'||unistr('\000a')||
'     into v_sb_auftrag_id -- Ermittle denn letzten Auftrag des angegeben Typs um zu ermitteln welche Personen bereits so ein Mailing erhalten haben.'||unistr('\000a')||
'     from sb_auftraege'||unistr('\000a')||
'     where art_id = :P401_ART_ID'||unistr('\000a')||
'        and test_flag = 0'||unistr('\000a')||
'        and satz_kennzeichen is null;'||unistr('\000a')||
'  exception '||unistr('\000a')||
'     when no_data_found then'||unistr('\000a')||
'       v_sb_auftrag_id := 0;'||unistr('\000a')||
'  end;'||unistr('\000a')||
''||unistr('\000a')||
'  if(:P401_ART_ID is not null) then'||unistr('\000a')||
'      v_return := FRGBG_T.SB_CALC_DATENSAETZE_ANZ('||unistr('\000a')||
'            p_sb_art_id => :P401_ART_ID,'||unistr('\000a')||
'            p_anzahl => v_anz,'||unistr('\000a')||
'            p_param0 => v_sb_auftrag_id, -- Theoretisch SB-Auftrag-ID'||unistr('\000a')||
'            p_param1 => replace(:P401_PERSSTAMM_ID_WAHLIDENT,'':'','','')'||unistr('\000a')||
'            --p_param2 varchar2 default null,'||unistr('\000a')||
'            --p_param3 varchar2 default null,'||unistr('\000a')||
'            --p_param4 varchar2 default null'||unistr('\000a')||
'       );'||unistr('\000a')||
''||unistr('\000a')||
'       if(v_return = 0) then'||unistr('\000a')||
'          :P401_ANZ_DATENSAETZE := v_anz;'||unistr('\000a')||
'       else'||unistr('\000a')||
'          :P401_ANZ_DATENSAETZE := '''';'||unistr('\000a')||
'       end if;'||unistr('\000a')||
''||unistr('\000a')||
'   end if;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P401_ART_ID,P401_PERSSTAMM_ID_WAHLIDENT'
 ,p_attribute_03 => 'P401_ANZ_DATENSAETZE'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'N'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   :p401_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p401_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_sprache_id); 	'||unistr('\000a')||
'   :p401_bl_erstellen_test := frgbg_s.holen_uebersetzung(9221,v_sprache_id); 	'||unistr('\000a')||
'   --:p400_bl_delete_mr := frgbg_s.holen_uebersetzung(8006,v_sprache_id);'||unistr('\000a')||
'   :P401_REGION_TITE';

p:=p||'L_SB_ERSTELLEN := frgbg_s.holen_uebersetzung(7981,v_sprache_id);'||unistr('\000a')||
'   :P401_NV_SB_ERSTELLEN := frgbg_s.holen_uebersetzung(7981,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6077732003230249 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 401,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   FRGBG_T.A102_P401_ERSTELLE_SERIENBRIEF('||unistr('\000a')||
'        p_PERSSTAMM_ID_WAHLIDENT       => :P401_PERSSTAMM_ID_WAHLIDENT,'||unistr('\000a')||
'        p_REQUEST                      => :REQUEST,'||unistr('\000a')||
'        p_PDF_SPLITTING                => :P401_PDF_SPLITTING,'||unistr('\000a')||
'        p_FRANKIERUNG_IMAGE            => :P401_FRANKIERUNG_IMAGE,'||unistr('\000a')||
'        p_SB_AUFTRAG_ART_ID            => :P401_ART_ID,'||unistr('\000a')||
'        p_FAS_LOGIN_PERSONENSTAMM_ID   =>';

p:=p||' :FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'        p_FAS_IDENTITAET_PERSSTAMM_ID  => :FAS_IDENTITAET_PERSSTAMM_ID,'||unistr('\000a')||
'        p_FAS_SPRACHE_ID               => :FAS_SPRACHE_ID'||unistr('\000a')||
'    );'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6095926443494983 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 401,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Erstelle Serienbrief',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request in(''BUT_NEUER_SB'',''BUT_NEUER_SB_TEST'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 401
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00402
prompt  ...PAGE 402: Serienbrief Intern
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 402
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Serienbrief Intern'
 ,p_step_title => 'Serienbrief Intern'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Serienbrief Intern'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_create_message=''Wollen Sie wirklich den finalen Druck starten?'';'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'LAVDIM.DJAFERI'
 ,p_last_upd_yyyymmddhh24miss => '20150826190230'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6452029850536130 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 402,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'  ID,'||unistr('\000a')||
'  ID ID_DISPLAY,  FAS_SYNCH.GET_TAB_UEBERSETZUNG(''SB_AUFTRAG_ARTEN.BEZEICHNUNG'',ID,:FAS_SPRACHE_ID) SERIENBRIEF_ART,'||unistr('\000a')||
'  (SELECT COUNT(*) '||unistr('\000a')||
'   FROM SB_PERS_IDENT_AUFTR_ARTEN'||unistr('\000a')||
'   WHERE SB_AUFTRAG_ART_ID = sba.ID'||unistr('\000a')||
'    AND SATZ_KENNZEICHEN IS NULL'||unistr('\000a')||
'  ) IDENTITAETEN_ANZAHL'||unistr('\000a')||
'FROM SB_AUFTRAG_ARTEN sba'||unistr('\000a')||
'WHERE '||unistr('\000a')||
'  SATZ_KENNZEICHEN IS NULL'||unistr('\000a')||
'  AND instr(FRGBG_T.GET_SYS_PARAM(69),'':'' || id || '':'')> 0'||unistr('\000a')||
'ORD';

s:=s||'ER BY SERIENBRIEF_ART';

wwv_flow_api.create_page_plug (
  p_id=> 6452307968536140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 402,
  p_plug_name=> 'Serienbrief Intern',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'select '||unistr('\000a')||
'  ID,'||unistr('\000a')||
'  ID ID_DISPLAY,  FAS_SYNCH.GET_TAB_UEBERSETZUNG(''SB_AUFTRAG_ARTEN.BEZEICHNUNG'',ID,:FAS_SPRACHE_ID) SERIENBRIEF_ART,'||unistr('\000a')||
'  (SELECT COUNT(*) '||unistr('\000a')||
'   FROM SB_PERS_IDENT_AUFTR_ARTEN'||unistr('\000a')||
'   WHERE SB_AUFTRAG_ART_ID = sba.ID'||unistr('\000a')||
'    AND SATZ_KENNZEICHEN IS NULL'||unistr('\000a')||
'  ) IDENTITAETEN_ANZAHL'||unistr('\000a')||
'FROM SB_AUFTRAG_ARTEN sba'||unistr('\000a')||
'WHERE '||unistr('\000a')||
'  SATZ_KENNZEICHEN IS NULL'||unistr('\000a')||
'  AND instr(FRGBG_T.GET_SYS_PARAM(69),'':'' || id || '':'')> 0'||unistr('\000a')||
'ORD';

a1:=a1||'ER BY SERIENBRIEF_ART';

wwv_flow_api.create_worksheet(
  p_id=> 6452431423536140+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 402,
  p_region_id=> 6452307968536140+wwv_flow_api.g_id_offset,
  p_name=> 'Serienbrief Intern',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '1000000',
  p_max_row_count_message=> 'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'N',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y',
  p_pagination_display_pos=>'BOTTOM_RIGHT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'C',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'N',
  p_show_control_break=>'N',
  p_show_highlight=>'N',
  p_show_computation=>'N',
  p_show_aggregate=>'N',
  p_show_chart=>'N',
  p_show_group_by=>'N',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'N',
  p_show_reset=>'N',
  p_show_download=>'N',
  p_show_help=>'N',
  p_download_formats=>'CSV:HTML:EMAIL',
  p_detail_link=>'f?p=&APP_ID.:403:&SESSION.::&DEBUG.:403:P403_SB_AUFTRAG_ART_ID:#ID#',
  p_detail_link_text=>'<img src="#IMAGE_PREFIX#edit_big.gif" alt="">',
  p_detail_link_attr=>'onclick="return false;" class="edit_sb_art_ident"',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'SASCHA.LENZ',
  p_internal_uid=> 6452431423536140);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6452610459536157+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 402,
  p_worksheet_id => 6452431423536140+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID',
  p_display_order          =>1,
  p_column_identifier      =>'A',
  p_column_label           =>'Id',
  p_report_label           =>'Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'HIDDEN',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6452713571536164+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 402,
  p_worksheet_id => 6452431423536140+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID_DISPLAY',
  p_display_order          =>2,
  p_column_identifier      =>'B',
  p_column_label           =>'ID',
  p_report_label           =>'ID',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6452803953536164+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 402,
  p_worksheet_id => 6452431423536140+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'SERIENBRIEF_ART',
  p_display_order          =>3,
  p_column_identifier      =>'C',
  p_column_label           =>'Serienbrief Art',
  p_report_label           =>'Serienbrief Art',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6452932764536164+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 402,
  p_worksheet_id => 6452431423536140+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'IDENTITAETEN_ANZAHL',
  p_display_order          =>4,
  p_column_identifier      =>'D',
  p_column_label           =>'Identitaeten Anzahl',
  p_report_label           =>'Identitaeten Anzahl',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'ID_DISPLAY:SERIENBRIEF_ART:IDENTITAETEN_ANZAHL';

wwv_flow_api.create_worksheet_rpt(
  p_id => 6453802451556143+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 402,
  p_worksheet_id => 6452431423536140+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'64539',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>50,
  p_report_columns          =>rc1,
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6466809535144772 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 402,
  p_button_sequence=> 10,
  p_button_plug_id => 6452307968536140+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Erstellen',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_create_message,''CREATE'');',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6467018886147486 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 402,
  p_button_sequence=> 20,
  p_button_plug_id => 6452307968536140+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE_TEST',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Testerstellung',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 19402018396575710 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 402,
  p_button_sequence=> 30,
  p_button_plug_id => 6452307968536140+wwv_flow_api.g_id_offset,
  p_button_name    => 'SBRIEF_HISTORIE',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Sbrief Historie',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6453310427543143 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 402,
  p_name=>'P402_NV_SB_SERIENBRIEF_INTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6452307968536140+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6465215892981201 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 402,
  p_name=>'P402_ANZAHL_BRIEFE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 6452307968536140+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Vorausichtliche Anzahl Briefe',
  p_source=>'0',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6465407265985183 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 402,
  p_name=>'P402_SB_AUFTRAG_ART_IDS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 6452307968536140+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select FRGBG_T.GET_SYS_PARAM(69) from dual',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6460429144790872 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_name => 'Öffne Modal Fenster: Identität hinzufügen'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.edit_sb_art_ident'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6460726714790874 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_event_id => 6460429144790872 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_attribute_02 => 'TRIG_ELEMENT_ATTR'
 ,p_attribute_05 => 'href'
 ,p_attribute_06 => 'div#MESSAGE.t1success'
 ,p_attribute_07 => 'STATIC_PX'
 ,p_attribute_08 => '600'
 ,p_attribute_09 => '900'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6460816808796840 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_name => 'schliesse Modalfenster'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'DOM_OBJECT'
 ,p_triggering_element => 'document'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE|DYNAMIC ACTION|modalpageautoclose'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6461100157796842 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_event_id => 6460816808796840 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'v_message = this.data.$modalPageCloseObject;'||unistr('\000a')||
'$(''.t1messages'').after( v_message );'||unistr('\000a')||
'$(''#MESSAGE.t1success'').delay(2000).fadeOut(2000);'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6464632750927824 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_event_id => 6460816808796840 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 6452307968536140 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6465611510012919 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_name => 'setze SB_AUFTRAG_ART_IDS'
 ,p_event_sequence => 30
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => '.liste_checkbox,.check_all'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6465921574012919 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_event_id => 6465611510012919 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'var ids = ":";'||unistr('\000a')||
'$(''input.liste_checkbox'').each('||unistr('\000a')||
'  function() {'||unistr('\000a')||
'     $this = $(this);'||unistr('\000a')||
''||unistr('\000a')||
'     if($this.prop(''checked'')) {'||unistr('\000a')||
'       ids = ids + $this.val() + ":";  '||unistr('\000a')||
'     }'||unistr('\000a')||
'  }'||unistr('\000a')||
');'||unistr('\000a')||
''||unistr('\000a')||
'$s(''P402_SB_AUFTRAG_ART_IDS'',ids);'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6466132345122954 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_name => 'Update Anzahl Serienbriefe'
 ,p_event_sequence => 40
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 6466409725122954 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_event_id => 6466132345122954 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'declare '||unistr('\000a')||
'  v_anz number;'||unistr('\000a')||
'  v_return number;'||unistr('\000a')||
'begin'||unistr('\000a')||
'  '||unistr('\000a')||
'  v_return := frgbg_t.SB_CALC_DATENSAETZE_ANZ_INT('||unistr('\000a')||
'        p_sb_art_ids => :P402_SB_AUFTRAG_ART_IDS, -- Kommagetrennte Liste von Serienbrief Auftragarten'||unistr('\000a')||
'        p_anzahl => v_anz'||unistr('\000a')||
'  );'||unistr('\000a')||
''||unistr('\000a')||
'  if(v_return = 0) then'||unistr('\000a')||
'    :P402_ANZAHL_BRIEFE := v_anz;'||unistr('\000a')||
'  else'||unistr('\000a')||
'    :P402_ANZAHL_BRIEFE := ''Fehler in der Berechnung Rückgabe: '' || v_return;'||unistr('\000a')||
'  end if;'||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P402_SB_AUFTRAG_ART_IDS'
 ,p_attribute_03 => 'P402_ANZAHL_BRIEFE'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'N'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6466714474133746 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 402
 ,p_event_id => 6466132345122954 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '$s(''P402_ANZAHL_BRIEFE'',''Wird berechnet..'');'||unistr('\000a')||
''
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  v_test_flag number;'||unistr('\000a')||
'  v_split_identitaeten number := 0;'||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'  if :REQUEST = ''CREATE_TEST'' then'||unistr('\000a')||
'    v_test_flag := 1;'||unistr('\000a')||
'  else'||unistr('\000a')||
'    v_test_flag := 0;'||unistr('\000a')||
'  end if;'||unistr('\000a')||
''||unistr('\000a')||
'  if(:P402_SB_AUFTRAG_ART_IDS = '':'') then'||unistr('\000a')||
'    raise_application_error(-20000,''Keine Serienbriefart ausgewählt.'');'||unistr('\000a')||
'  end if;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Starte den Erstellungsjob'||unistr('\000a')||
'   FRGBG_JOBS.START_JOB('||unistr('\000a')||
'         p_what => ''FRGBG_T.SB_GEN_SERIENBRIEF_I';

p:=p||'NT_JOB('||unistr('\000a')||
'              p_sb_art_ids                  => '''''' || :P402_SB_AUFTRAG_ART_IDS || '''''','||unistr('\000a')||
'              p_split_identitaeten   => '' || NVL(v_split_identitaeten,0) || '','||unistr('\000a')||
'              p_test_flag            => '' || v_test_flag || '','||unistr('\000a')||
'              p_JR_DRUCKER_ID        => NULL,'' -- Momentan nur Dummy wird später eventuell benötigt um Serienbrief direkt an einen Drucker zu schicken.'||unistr('\000a')||
'          |';

p:=p||'| ''p_sprache_id           => '' || NVL(:FAS_SPRACHE_ID,357) || '','||unistr('\000a')||
'              p_PERSSTAMM_ID_LOGIN   => '' ||  :FAS_LOGIN_PERSONENSTAMM_ID || '','||unistr('\000a')||
'              p_PERSSTAMM_ID_IDENT   => '' || :FAS_IDENTITAET_PERSSTAMM_ID || '''||unistr('\000a')||
'          );'','||unistr('\000a')||
'         p_beschreibung => frgbg_s.holen_uebersetzung(7981,:FAS_SPRACHE_ID),'||unistr('\000a')||
'         p_aufgabe_aktuell => frgbg_s.holen_uebersetzung(7981,:FAS_SPRACHE_ID),'||unistr('\000a')||
'    ';

p:=p||'     p_max_jobs_same         => 1, -- gleicher Job darf nur einmal ausgelöst werden.'||unistr('\000a')||
'         p_max_jobs_total  => 1, -- maximal Jobs insgesamt'||unistr('\000a')||
'         p_hide_by_complete => 1'||unistr('\000a')||
'       );'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6517803674838143 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 402,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Starte Serienbrieferstellung',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':REQUEST in(''CREATE'',''CREATE_TEST'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Serienbriefdruck gestartet. Sie werden per Mail informiert, sobald der Druck abgeschlossen ist',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
''||unistr('\000a')||
'  :P402_NV_SB_SERIENBRIEF_INTERN := frgbg_s.holen_uebersetzung(11259,:FAS_SPRACHE_ID);'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6453628639554193 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 402,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Setze Labels',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 402
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00403
prompt  ...PAGE 403: Serienbrief Intern Identitäten Zuordnung
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 403
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Serienbrief Intern Identitäten Zuordnung'
 ,p_step_title => 'Serienbrief Intern Identitäten Zuordnung'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Serienbrief Intern Identitäten Zuordnung'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_javascript_code => 
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141022170300'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT'||unistr('\000a')||
'   pers.ID,'||unistr('\000a')||
'   APEX_ITEM.CHECKBOX(p_idx => 1, p_value => pers.id , p_attributes => ''class="liste_checkbox" '' ||'||unistr('\000a')||
'       '' onclick="$(''''.check_all'''').prop(''''checked'''',$(''''.liste_checkbox:checked'''').length == $(''''.liste_checkbox'''').length);"'')  CHECKBOX,'||unistr('\000a')||
'   pers.NAME || pers.VORNAME IDENTITAET,'||unistr('\000a')||
'   trim(pers.STRASSE || '' '' || pers.NR) NR,'||unistr('\000a')||
'   trim(pers.PLZ || '' '' || pers.ORT) ORT,'||unistr('\000a')||
'   l.ISO2_ID L';

s:=s||'AND,'||unistr('\000a')||
'   pers.TELEFON,'||unistr('\000a')||
'   pers.FAX,'||unistr('\000a')||
'   pers.EMAIL'||unistr('\000a')||
'from PERSONENSTAMM pers, FRGBG.SB_PERS_IDENT_AUFTR_ARTEN spiaa, laender l'||unistr('\000a')||
'where'||unistr('\000a')||
'  spiaa.PERSSTAMM_ID_IDENT = pers.ID'||unistr('\000a')||
'  and spiaa.SB_AUFTRAG_ART_ID = :P403_SB_AUFTRAG_ART_ID'||unistr('\000a')||
'  and pers.SATZKENNZEICHEN is null'||unistr('\000a')||
'  and l.id = pers.land_id'||unistr('\000a')||
'order by IDENTITAET, ID';

wwv_flow_api.create_page_plug (
  p_id=> 6455019903607799 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_plug_name=> 'Identitäten',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'SELECT'||unistr('\000a')||
'   pers.ID,'||unistr('\000a')||
'   APEX_ITEM.CHECKBOX(p_idx => 1, p_value => pers.id , p_attributes => ''class="liste_checkbox" '' ||'||unistr('\000a')||
'       '' onclick="$(''''.check_all'''').prop(''''checked'''',$(''''.liste_checkbox:checked'''').length == $(''''.liste_checkbox'''').length);"'')  CHECKBOX,'||unistr('\000a')||
'   pers.NAME || pers.VORNAME IDENTITAET,'||unistr('\000a')||
'   trim(pers.STRASSE || '' '' || pers.NR) NR,'||unistr('\000a')||
'   trim(pers.PLZ || '' '' || pers.ORT) ORT,'||unistr('\000a')||
'   l.ISO2_ID L';

a1:=a1||'AND,'||unistr('\000a')||
'   pers.TELEFON,'||unistr('\000a')||
'   pers.FAX,'||unistr('\000a')||
'   pers.EMAIL'||unistr('\000a')||
'from PERSONENSTAMM pers, FRGBG.SB_PERS_IDENT_AUFTR_ARTEN spiaa, laender l'||unistr('\000a')||
'where'||unistr('\000a')||
'  spiaa.PERSSTAMM_ID_IDENT = pers.ID'||unistr('\000a')||
'  and spiaa.SB_AUFTRAG_ART_ID = :P403_SB_AUFTRAG_ART_ID'||unistr('\000a')||
'  and pers.SATZKENNZEICHEN is null'||unistr('\000a')||
'  and l.id = pers.land_id'||unistr('\000a')||
'order by IDENTITAET, ID';

wwv_flow_api.create_worksheet(
  p_id=> 6455123867607799+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_region_id=> 6455019903607799+wwv_flow_api.g_id_offset,
  p_name=> 'Report 1',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '1000000',
  p_max_row_count_message=> 'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'Y',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y',
  p_pagination_display_pos=>'BOTTOM_RIGHT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'N',
  p_show_select_columns=>'Y',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'Y',
  p_show_highlight=>'Y',
  p_show_computation=>'Y',
  p_show_aggregate=>'Y',
  p_show_chart=>'Y',
  p_show_group_by=>'Y',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'Y',
  p_show_reset=>'Y',
  p_show_download=>'Y',
  p_show_help=>'Y',
  p_download_formats=>'CSV:HTML:EMAIL',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'SASCHA.LENZ',
  p_internal_uid=> 6455123867607799);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6455308847607802+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ID',
  p_display_order          =>1,
  p_column_identifier      =>'A',
  p_column_label           =>'Id',
  p_report_label           =>'Id',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6455431056607803+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'IDENTITAET',
  p_display_order          =>2,
  p_column_identifier      =>'B',
  p_column_label           =>'Identitaet',
  p_report_label           =>'Identitaet',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6455523062607803+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'NR',
  p_display_order          =>3,
  p_column_identifier      =>'C',
  p_column_label           =>'Nr',
  p_report_label           =>'Nr',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6455616005607803+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ORT',
  p_display_order          =>4,
  p_column_identifier      =>'D',
  p_column_label           =>'Ort',
  p_report_label           =>'Ort',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6455728599607804+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'LAND',
  p_display_order          =>5,
  p_column_identifier      =>'E',
  p_column_label           =>'Land',
  p_report_label           =>'Land',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6455817198607804+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'TELEFON',
  p_display_order          =>6,
  p_column_identifier      =>'F',
  p_column_label           =>'Telefon',
  p_report_label           =>'Telefon',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6455928132607806+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'FAX',
  p_display_order          =>7,
  p_column_identifier      =>'G',
  p_column_label           =>'Fax',
  p_report_label           =>'Fax',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6456005117607806+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EMAIL',
  p_display_order          =>8,
  p_column_identifier      =>'H',
  p_column_label           =>'Email',
  p_report_label           =>'Email',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 6463503279850294+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'CHECKBOX',
  p_display_order          =>9,
  p_column_identifier      =>'I',
  p_column_label           =>'<input type="checkbox" class="check_all" value="checkall" onclick="$(''.liste_checkbox'').prop(''checked'',$(this).prop(''checked''));"/>',
  p_report_label           =>'<input type="checkbox" class="check_all" value="checkall" onclick="$(''.liste_checkbox'').prop(''checked'',$(this).prop(''checked''));"/>',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'N',
  p_allow_filtering        =>'N',
  p_allow_highlighting     =>'N',
  p_allow_ctrl_breaks      =>'N',
  p_allow_aggregations     =>'N',
  p_allow_computations     =>'N',
  p_allow_charting         =>'N',
  p_allow_group_by         =>'N',
  p_allow_hide             =>'N',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'WITHOUT_MODIFICATION',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'ID:IDENTITAET:NR:ORT:LAND:TELEFON:FAX:EMAIL:CHECKBOX';

wwv_flow_api.create_worksheet_rpt(
  p_id => 6456617089617087+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 403,
  p_worksheet_id => 6455123867607799+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'64567',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>15,
  p_report_columns          =>rc1,
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6463918118891791 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 403,
  p_button_sequence=> 10,
  p_button_plug_id => 6455019903607799+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Auswahl Löschen',
  p_button_position=> 'REGION_TEMPLATE_DELETE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.confirm(htmldb_delete_message,''DELETE_MRD'');',
  p_button_execute_validations=>'N',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6456326972611361 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 403,
  p_name=>'P403_SB_AUFTRAG_ART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6455019903607799+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6456515542616699 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 403,
  p_name=>'P403_SB_AUFTRAG_ART',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 6455019903607799+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Auftragart',
  p_source=>'select BEZEICHNUNG || '' ('' || ID || '')'' '||unistr('\000a')||
'FROM SB_AUFTRAG_ARTEN'||unistr('\000a')||
'where id = :P403_SB_AUFTRAG_ART_ID',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> 1,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6457704506667360 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 403,
  p_name=>'P403_PERSSTAMM_ID_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 6455019903607799+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identität',
  p_source_type=> 'STATIC',
  p_display_as=> 'PLUGIN_COM_SKILLBUILDERS_SUPER_LOV',
  p_lov=> 'select'||unistr('\000a')||
'  pers.ID,'||unistr('\000a')||
'   pers.NAME || pers.VORNAME IDENTITAET,'||unistr('\000a')||
'   trim(pers.STRASSE || '' '' || pers.NR) NR,'||unistr('\000a')||
'   trim(pers.PLZ || '' '' || pers.ORT) ORT,'||unistr('\000a')||
'   l.ISO2_ID LAND,'||unistr('\000a')||
'   pers.TELEFON,'||unistr('\000a')||
'   pers.FAX,'||unistr('\000a')||
'   pers.EMAIL'||unistr('\000a')||
'from'||unistr('\000a')||
'   PERSONENSTAMM pers, laender l'||unistr('\000a')||
'where'||unistr('\000a')||
'    SATZKENNZEICHEN IS NULL'||unistr('\000a')||
'    AND BETREUER = ''I'''||unistr('\000a')||
'    and l.id = pers.land_id'||unistr('\000a')||
'    and pers.id not in('||unistr('\000a')||
'        select'||unistr('\000a')||
'           spiaa.PERSSTAMM_ID_IDENT'||unistr('\000a')||
'        from  FRGBG.SB_PERS_IDENT_AUFTR_ARTEN spiaa'||unistr('\000a')||
'        where'||unistr('\000a')||
'           spiaa.SB_AUFTRAG_ART_ID = :P403_SB_AUFTRAG_ART_ID'||unistr('\000a')||
'    )'||unistr('\000a')||
'order by IDENTITAET;',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_attribute_03 => '2,1',
  p_attribute_08 => 'NOT_ENTERABLE',
  p_attribute_09 => '15',
  p_attribute_10 => '&nbsp;',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6458730136762759 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 403,
  p_name=>'P403_ADD_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 6455019903607799+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Identität hinzufügen',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin '||unistr('\000a')||
'  FRGBG_T.A102_P403_IDENT_HINZUFUEGEN('||unistr('\000a')||
'        p_persstamm_id_ident => :P403_PERSSTAMM_ID_IDENT,'||unistr('\000a')||
'        p_sb_auftrag_art_id => :P403_SB_AUFTRAG_ART_ID'||unistr('\000a')||
'    );'||unistr('\000a')||
'  :P403_PERSSTAMM_ID_IDENT := null;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6458008057737539 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 403,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Identität hinzufügen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>6458730136762759 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Identität hinzugefügt',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
'   FRGBG_T.A102_P403_IDENT_LOESCHEN('||unistr('\000a')||
'        p_pers_ids => apex_application.g_f01,'||unistr('\000a')||
'        p_sb_auftrag_art_id => :P403_SB_AUFTRAG_ART_ID'||unistr('\000a')||
'    );'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 6463707037888573 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 403,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Lösche Identität',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>'DELETE_MRD',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Datensätze gelöscht',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 403
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00405
prompt  ...PAGE 405: Serienbrief Historie
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 405
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_tab_set => 'TS1'
 ,p_name => 'Serienbrief Historie'
 ,p_step_title => 'Serienbrief Historie'
 ,p_step_sub_title => 'Serienbrief Historie'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'LAVDIM.DJAFERI'
 ,p_last_upd_yyyymmddhh24miss => '20150826192725'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 19402621852600071 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_plug_name=> 'Breadcrumb',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select '||unistr('\000a')||
'  ad.SB_AUFTRAG_ID'||unistr('\000a')||
'  ,trunc(ad.ERFDAT) Erfdat'||unistr('\000a')||
'  ,NVL(ad.IDENT_PERSSTAMM_ID, 0) AS IDENT_PERSSTAMM_ID'||unistr('\000a')||
'  ,to_number(ad.CHAMP08) AS FASID'||unistr('\000a')||
'  ,NVL(ad.CHAMP02, ''-'') AS ANREDE'||unistr('\000a')||
'  ,NVL(ad.CHAMP06, ''-'') AS LAND'||unistr('\000a')||
'  ,NVL(ad.CHAMP05, ''-'') AS ORT'||unistr('\000a')||
'  ,NVL(p.TELEFON, ''-'') AS TELEFON'||unistr('\000a')||
'  ,NVL(p.MOBILTELEFON, ''-'') AS MOBILTELEFON'||unistr('\000a')||
'  ,NVL(p.EMAIL, ''-'') AS EMAIL  '||unistr('\000a')||
'  ,wd.WARENKORB_ID'||unistr('\000a')||
'FROM '||unistr('\000a')||
'SB_AUFTRAGDETAILS ad'||unistr('\000a')||
'INNE';

s:=s||'R JOIN PERSONENSTAMM p ON (p.ID = ad.CHAMP08)'||unistr('\000a')||
'INNER JOIN WARENKORB_DETAILS wd ON (wd.ID = ad.REFERENZ_ID)';

wwv_flow_api.create_page_plug (
  p_id=> 19405429056673345 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_plug_name=> 'REG_SBRIEFH_1',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 0,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'DYNAMIC_QUERY',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'select '||unistr('\000a')||
'  ad.SB_AUFTRAG_ID'||unistr('\000a')||
'  ,trunc(ad.ERFDAT) Erfdat'||unistr('\000a')||
'  ,NVL(ad.IDENT_PERSSTAMM_ID, 0) AS IDENT_PERSSTAMM_ID'||unistr('\000a')||
'  ,to_number(ad.CHAMP08) AS FASID'||unistr('\000a')||
'  ,NVL(ad.CHAMP02, ''-'') AS ANREDE'||unistr('\000a')||
'  ,NVL(ad.CHAMP06, ''-'') AS LAND'||unistr('\000a')||
'  ,NVL(ad.CHAMP05, ''-'') AS ORT'||unistr('\000a')||
'  ,NVL(p.TELEFON, ''-'') AS TELEFON'||unistr('\000a')||
'  ,NVL(p.MOBILTELEFON, ''-'') AS MOBILTELEFON'||unistr('\000a')||
'  ,NVL(p.EMAIL, ''-'') AS EMAIL  '||unistr('\000a')||
'  ,wd.WARENKORB_ID'||unistr('\000a')||
'FROM '||unistr('\000a')||
'SB_AUFTRAGDETAILS ad'||unistr('\000a')||
'INNE';

a1:=a1||'R JOIN PERSONENSTAMM p ON (p.ID = ad.CHAMP08)'||unistr('\000a')||
'INNER JOIN WARENKORB_DETAILS wd ON (wd.ID = ad.REFERENZ_ID)';

wwv_flow_api.create_worksheet(
  p_id=> 19405512593673345+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_region_id=> 19405429056673345+wwv_flow_api.g_id_offset,
  p_name=> 'REG_SBRIEFH_1',
  p_folder_id=> null, 
  p_alias=> '',
  p_report_id_item=> '',
  p_max_row_count=> '1000000',
  p_max_row_count_message=> 'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.',
  p_no_data_found_message=> 'No data found.',
  p_max_rows_per_page=>'',
  p_search_button_label=>'',
  p_sort_asc_image=>'',
  p_sort_asc_image_attr=>'',
  p_sort_desc_image=>'',
  p_sort_desc_image_attr=>'',
  p_sql_query => a1,
  p_status=>'AVAILABLE_FOR_OWNER',
  p_allow_report_saving=>'Y',
  p_allow_save_rpt_public=>'N',
  p_allow_report_categories=>'N',
  p_show_nulls_as=>'-',
  p_pagination_type=>'ROWS_X_TO_Y',
  p_pagination_display_pos=>'BOTTOM_RIGHT',
  p_show_finder_drop_down=>'Y',
  p_show_display_row_count=>'N',
  p_show_search_bar=>'Y',
  p_show_search_textbox=>'Y',
  p_show_actions_menu=>'Y',
  p_report_list_mode=>'TABS',
  p_show_detail_link=>'N',
  p_show_select_columns=>'N',
  p_show_rows_per_page=>'Y',
  p_show_filter=>'Y',
  p_show_sort=>'Y',
  p_show_control_break=>'N',
  p_show_highlight=>'N',
  p_show_computation=>'N',
  p_show_aggregate=>'N',
  p_show_chart=>'N',
  p_show_group_by=>'N',
  p_show_notify=>'N',
  p_show_calendar=>'N',
  p_show_flashback=>'N',
  p_show_reset=>'Y',
  p_show_download=>'Y',
  p_show_help=>'Y',
  p_download_formats=>'CSV:HTML',
  p_allow_exclude_null_values=>'N',
  p_allow_hide_extra_columns=>'N',
  p_icon_view_enabled_yn=>'N',
  p_icon_view_use_custom=>'N',
  p_icon_view_columns_per_row=>1,
  p_detail_view_enabled_yn=>'N',
  p_owner=>'LAVDIM.DJAFERI',
  p_internal_uid=> 19405512593673345);
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19405709609673349+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'SB_AUFTRAG_ID',
  p_display_order          =>1,
  p_column_identifier      =>'A',
  p_column_label           =>'Auftrag Nr.',
  p_report_label           =>'Auftrag Nr.',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19405800572673350+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ERFDAT',
  p_display_order          =>2,
  p_column_identifier      =>'B',
  p_column_label           =>'Erstelldatum',
  p_report_label           =>'Erstelldatum',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'DATE',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19405917737673350+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'IDENT_PERSSTAMM_ID',
  p_display_order          =>3,
  p_column_identifier      =>'C',
  p_column_label           =>'Identität ID',
  p_report_label           =>'Identität ID',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19406018531673350+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'FASID',
  p_display_order          =>4,
  p_column_identifier      =>'D',
  p_column_label           =>'FAS ID',
  p_report_label           =>'FAS ID',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19406101798673351+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ANREDE',
  p_display_order          =>5,
  p_column_identifier      =>'E',
  p_column_label           =>'Anrede',
  p_report_label           =>'Anrede',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19406220470673351+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'LAND',
  p_display_order          =>6,
  p_column_identifier      =>'F',
  p_column_label           =>'Land',
  p_report_label           =>'Land',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19406324184673351+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'ORT',
  p_display_order          =>7,
  p_column_identifier      =>'G',
  p_column_label           =>'Ort',
  p_report_label           =>'Ort',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19406401811673353+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'TELEFON',
  p_display_order          =>8,
  p_column_identifier      =>'H',
  p_column_label           =>'Telefon',
  p_report_label           =>'Telefon',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19406529300673353+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'MOBILTELEFON',
  p_display_order          =>9,
  p_column_identifier      =>'I',
  p_column_label           =>'Mobiltelefon',
  p_report_label           =>'Mobiltelefon',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19406615141673353+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'EMAIL',
  p_display_order          =>10,
  p_column_identifier      =>'J',
  p_column_label           =>'Email',
  p_report_label           =>'Email',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'STRING',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'LEFT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
begin
wwv_flow_api.create_worksheet_column(
  p_id => 19406716035673353+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_db_column_name         =>'WARENKORB_ID',
  p_display_order          =>11,
  p_column_identifier      =>'K',
  p_column_label           =>'Warenkorb link',
  p_report_label           =>'Warenkorb link',
  p_sync_form_label        =>'Y',
  p_display_in_default_rpt =>'Y',
  p_column_link            =>'f?p=&APP_ID.:321:&SESSION.::&DEBUG.::P321_ID:#WARENKORB_ID#',
  p_column_linktext        =>'#WARENKORB_ID#',
  p_column_link_attr       =>'target="_blank"',
  p_is_sortable            =>'Y',
  p_allow_sorting          =>'Y',
  p_allow_filtering        =>'Y',
  p_allow_highlighting     =>'Y',
  p_allow_ctrl_breaks      =>'Y',
  p_allow_aggregations     =>'Y',
  p_allow_computations     =>'Y',
  p_allow_charting         =>'Y',
  p_allow_group_by         =>'Y',
  p_allow_hide             =>'Y',
  p_others_may_edit        =>'Y',
  p_others_may_view        =>'Y',
  p_column_type            =>'NUMBER',
  p_display_as             =>'TEXT',
  p_display_text_as        =>'ESCAPE_SC',
  p_heading_alignment      =>'CENTER',
  p_column_alignment       =>'RIGHT',
  p_tz_dependent           =>'N',
  p_rpt_distinct_lov       =>'Y',
  p_rpt_show_filter_lov    =>'D',
  p_rpt_filter_date_ranges =>'ALL',
  p_help_text              =>'');
end;
/
declare
    rc1 varchar2(32767) := null;
begin
rc1:=rc1||'SB_AUFTRAG_ID:ERFDAT:IDENT_PERSSTAMM_ID:FASID:ANREDE:LAND:ORT:TELEFON:MOBILTELEFON:EMAIL:WARENKORB_ID';

wwv_flow_api.create_worksheet_rpt(
  p_id => 19406832173674208+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 405,
  p_worksheet_id => 19405512593673345+wwv_flow_api.g_id_offset,
  p_session_id  => null,
  p_base_report_id  => null+wwv_flow_api.g_id_offset,
  p_application_user => 'APXWS_DEFAULT',
  p_report_seq              =>10,
  p_report_alias            =>'194069',
  p_status                  =>'PUBLIC',
  p_category_id             =>null+wwv_flow_api.g_id_offset,
  p_is_default              =>'Y',
  p_display_rows            =>15,
  p_report_columns          =>rc1,
  p_sort_column_1           =>'ERFDAT',
  p_sort_direction_1        =>'DESC NULLS LAST',
  p_sort_column_2           =>'SB_AUFTRAG_ID',
  p_sort_direction_2        =>'DESC NULLS LAST',
  p_sort_column_3           =>'FASID',
  p_sort_direction_3        =>'ASC NULLS LAST',
  p_sort_column_4           =>'0',
  p_sort_direction_4        =>'ASC',
  p_sort_column_5           =>'0',
  p_sort_direction_5        =>'ASC',
  p_sort_column_6           =>'0',
  p_sort_direction_6        =>'ASC',
  p_flashback_enabled       =>'N',
  p_calendar_display_column =>'');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 405
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00500
prompt  ...PAGE 500: Wiederverkäufer-Warenkorb
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 500
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Wiederverkäufer-Warenkorb'
 ,p_step_title => 'Wiederverkäufer-Warenkorb'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Wiederverkäufer-Warenkorb'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_welcome_text => '<script language="JavaScript1.1" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
'function f_checkBestelldatBestellen (button_name,plandatum,bestelldatum,rezeptnr) '||unistr('\000a')||
'{ '||unistr('\000a')||
'  var get = new  htmldb_Get(null,&APP_ID.,''APPLICATION_PROCESS=checkBestelldatumNeu'',0);'||unistr('\000a')||
'  var v_confirm;'||unistr('\000a')||
''||unistr('\000a')||
'  //alert(plandatum);'||unistr('\000a')||
'  //alert(bestelldatum);'||unistr('\000a')||
'  //alert(rezeptnr);'||unistr('\000a')||
'  get.add(''TEMP_PLANDATUM'',plandatum);'||unistr('\000a')||
'  get.add(''TEMP_BESTELLDATUM'',bestelldatum);'||unistr('\000a')||
'  gReturn = get.get();'||unistr('\000a')||
'  if(gReturn)'||unistr('\000a')||
'    {  v_confirm = confirm(gReturn);'||unistr('\000a')||
'       if (v_confirm == true)'||unistr('\000a')||
'          {'||unistr('\000a')||
'           html_GetElement(''P300_REZEPT_NR'').value =rezeptnr; '||unistr('\000a')||
'           doSubmit(button_name);'||unistr('\000a')||
'           //apex.submit({request:''WARENKORB'',set:{''P300_REZEPT_NR'':rezeptnr}})'';'||unistr('\000a')||
'          }'||unistr('\000a')||
'    }'||unistr('\000a')||
'   else'||unistr('\000a')||
'    {'||unistr('\000a')||
'      html_GetElement(''P300_REZEPT_NR'').value =rezeptnr; '||unistr('\000a')||
'      doSubmit(button_name);'||unistr('\000a')||
'      //apex.submit({request:''WARENKORB'',set:{''P300_REZEPT_NR'':rezeptnr}})'';'||unistr('\000a')||
'    }'||unistr('\000a')||
'  get = null; '||unistr('\000a')||
'}'||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150424090114'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select m.id,                                                                        /* Artikel */'||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)'||unistr('\000a')||
'      || CASE WHEN m.pzn is not null THEN'||unistr('\000a')||
'              '' ('' || m.pzn||'')''  '||unistr('\000a')||
'             ELSE NULL'||unistr('\000a')||
'         END'||unistr('\000a')||
'      --||CASE WHEN m.beschreibung is not null THEN  -- NEI 26.03.2014 nur noch die beschreibung_text_id ist ';

s:=s||'aktiv wg. langen Texten'||unistr('\000a')||
'      ||CASE WHEN m.beschreibung_text_id is not null THEN'||unistr('\000a')||
''||unistr('\000a')||
'/*         ''    <a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'         ''f?p=''||:APP_ID||'':306:''||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id)    '||unistr('\000a')||
'         || ''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'         ''    <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':306:'''||unistr('\000a')||
'         ||:APP_';

s:=s||'SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id||'''''',700,380)">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END'||unistr('\000a')||
'      || ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'             artikel,'||unistr('\000a')||
'     to_char(rezepte.calc_preis_mwst_ges(wk.verrech_land_id,'||unistr('\000a')||
'        ';

s:=s||'     m.prodkennz_id,m.id,wk.preisliste_id,'||unistr('\000a')||
'             wk.art_mwst_typ_id,'||unistr('\000a')||
'             wk.preisfaktor,'||unistr('\000a')||
'             wk.persstamm_id_prod_apo,0)'||unistr('\000a')||
'        ,''999G990D00'')||'' ''||rezepte.get_waehrung_zeichen(wk.waehrung_id) '||unistr('\000a')||
'     || CASE WHEN (select count(*) from preislisten_details pd where pd.mengenart_id = m.id'||unistr('\000a')||
'                                                        and pd.preisliste_id = wk.preis';

s:=s||'liste_id'||unistr('\000a')||
'                                                        and pd.GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'                                                        AND pd.GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'                                                        AND pd.preis >= 0'||unistr('\000a')||
'                                                        and pd.satz_kennzeichen is null) > 1 '||unistr('\000a')||
'           THEN --Staffelpre';

s:=s||'iskennzeichnung'||unistr('\000a')||
'               ''    <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':307:'''||unistr('\000a')||
'              ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'              --||''P307_ID,P307_PREISLISTE_ID,P307_VERRECH_LAND_ID,P307_ART_MWST_TYP_ID,P307_PREISFAKTOR:'''||unistr('\000a')||
'              --||m.id||'',''||wk.preisliste_id||'',''||wk.VERRECH_LAND_ID||'',''||wk.ART_MWST_TYP_ID||'',''||wk.PREISFAKTOR||'''''',700,380)">'''||unistr('\000a')||
'              ||''P307_ID,P307_WA';

s:=s||'RENKORB_TMP_ID:'''||unistr('\000a')||
'              ||m.id||'',''||wk.id||'''''',700,380)">'''||unistr('\000a')||
'              || ''<img src="#IMAGE_PREFIX#infoicon_status.gif" >'''||unistr('\000a')||
'              || ''</a>'''||unistr('\000a')||
'          ELSE '' '''||unistr('\000a')||
'        END '||unistr('\000a')||
'        stueckpreis,'||unistr('\000a')||
'      CASE WHEN m.dokument_id is not null THEN'||unistr('\000a')||
'      ''<img src="'' || frgbg_t.get_sys_param(63) || frgbg_s.holen_uebersetzung(NVL(dokument_id, 0),:fas_sprache_id) --#OWNER#.frgbg_t.display_th';

s:=s||'umb?p_bild_id='''||unistr('\000a')||
'         --|| NVL (m.dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" width="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'      ELSE NULL END img,'||unistr('\000a')||
'/*'||unistr('\000a')||
'  ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':300:''||:APP_SESSION|| '':WARENKORB:::'''||unistr('\000a')||
'     ||''P500_MENGENART_ID:'''||unistr('\000a')||
'     ||m.id)    '||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="';

s:=s||'#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   wk_link'||unistr('\000a')||
'*/'||unistr('\000a')||
'   CASE WHEN :p500_wk_artikeltyp_flag = 1  -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                           -- =1 heisst bereits Laborartikel im WK => keine sonstigen Artikel mehr '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      '' '''||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P500_MENGENART_ID'''':''||m.id||''}})';

s:=s||''''||unistr('\000a')||
'        || ''">'''||unistr('\000a')||
'        || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'        || ''</a>'''||unistr('\000a')||
'   END wk_link,'||unistr('\000a')||
'   1 sort_typ,'||unistr('\000a')||
'   --fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id) sort_art,'||unistr('\000a')||
'   trim(fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'',m.ID,:fas_sprache_id)) sort_art,'||unistr('\000a')||
'   null sort_rez,'||unistr('\000a')||
'   NULL last_bestelldatum, --to_char(frgbg_s.WK_GET_LAST_BEST';

s:=s||'ELL_DAT(NULL,m.id),''DD.MM.YYYY'')'||unistr('\000a')||
'   null akt_datum,'||unistr('\000a')||
'   null reichweite'||unistr('\000a')||
'FROM mengenarts m,  warenkoerbe_tmp wk    -- Wiederverkäufer gehen nur über die Preisliste Sortiment_details gibt es nicht'||unistr('\000a')||
'where -- m.satz_kennzeichen is null and'||unistr('\000a')||
'      ((:P500_suche is NULL and :p500_artikelkategorie = 0 and 1=2) /* keine Ergebnisse => Maskeneinstieg */'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P500_suche is NULL and :p500_artikelkat';

s:=s||'egorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P500_suche is NOT NULL AND '||unistr('\000a')||
'        instr(UPPER (fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id)'||unistr('\000a')||
'        ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id) '||unistr('\000a')||
'        ||m.pzn),UPPER(:P500_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Artikel die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p500';

s:=s||'_id'||unistr('\000a')||
'  /*and ( m.id is not null AND'||unistr('\000a')||
'        m.id not in (SELECT mengenart_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p500_id'||unistr('\000a')||
'                       and mengenart_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       OR m.id is null'||unistr('\000a')||
'      )'||unistr('\000a')||
'  */'||unistr('\000a')||
'  -- gewählte Artikelkategorie berücksichtigen'||unistr('\000a')||
'  AND (:P500_artikelkategorie = 0 OR m.artgruppe_id = :P500_artikelkategorie)'||unistr('\000a')||
'  -- K';

s:=s||'eine Artikel mit Preis -1, d.h. Preis muss >=0  => Fehler bei der Artikeluebernahme'||unistr('\000a')||
'  -- Muss in Preisliste sein'||unistr('\000a')||
'  AND exists'||unistr('\000a')||
'       (select * '||unistr('\000a')||
'        from preislisten_details pd, mengenarts m1'||unistr('\000a')||
'        where pd.mengenart_id = m1.id'||unistr('\000a')||
'        and m1.id = m.id'||unistr('\000a')||
'        and m1.id = pd.mengenart_id'||unistr('\000a')||
'        and m1.satz_kennzeichen is null'||unistr('\000a')||
'        and pd.preisliste_id = wk.preisliste_id'||unistr('\000a')||
'        and pd.GUE';

s:=s||'LTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND pd.GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND pd.MIN_MENGE <= 1'||unistr('\000a')||
'        AND pd.MAX_MENGE >= 1'||unistr('\000a')||
'        AND pd.preis >= 0'||unistr('\000a')||
'        and pd.satz_kennzeichen is null'||unistr('\000a')||
'       )'||unistr('\000a')||
'order by  sort_typ, sort_art asc, sort_rez desc '||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 500,
  p_name=> 'ARTIKEL_REZEPTE',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 30,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P300_HEIGHT_ARTIKEL.px;width:430px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(4526,:fas_sprache_id))',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '200',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> '</br>&P500_MELDUNG_ARTSUCHE.',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '2000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6385622137817087 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6385731192817089 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ARTIKEL',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6385809337817090 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'STUECKPREIS',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p500_artikelkategorie >=0 or   /* Suchbed. od. Artikel */ '||unistr('\000a')||
':p500_artikelkategorie = 20     /* Laborartikel */',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6385922194817090 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'IMG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6386024800817090 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'WK_LINK',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6386114028817090 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_TYP',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6386231951817090 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_ART',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6386319512817090 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_REZ',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6386423054817090 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'LAST_BESTELLDATUM',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie in (0,-1)  /* Suchbed. od. Rezepte*/ ',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6386505269817090 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'AKT_DATUM',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8016914074484832 + wwv_flow_api.g_id_offset,
  p_region_id=> 6385401498817074 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'REICHWEITE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'NEVER',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6392826150817113 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 500,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 4,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p500_zurueck_seite = 135',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6393012442817115 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 500,
  p_plug_name=> '&P500_REGION_TITEL_WARENKORB.: &P500_NAME.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 5572010060380233+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 40,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 3,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="width: 520px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6395817351817128 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 500,
  p_plug_name=> 'Adresse',
  p_region_name=>'',
  p_parent_plug_id=>6393012442817115 + wwv_flow_api.g_id_offset,
  p_escape_on_http_output=>'N',
  p_plug_template=> 0,
  p_plug_display_sequence=> 60,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'NEVER',
  p_plug_display_when_condition => ':p500_flag_hide_show = 1',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'wkd."ID",'||unistr('\000a')||
'wkd."ID" ID_DISPLAY,'||unistr('\000a')||
'wkd."WARENKORB_TMP_ID",'||unistr('\000a')||
'wkd."PRODKENNZ_ID",'||unistr('\000a')||
'wkd."P_REZEPT_ID" ,'||unistr('\000a')||
'wkd."MENGENART_ID",'||unistr('\000a')||
'wkd."MENGE",'||unistr('\000a')||
'wkd."VOLUMEN",'||unistr('\000a')||
'wkd."GEWICHT",'||unistr('\000a')||
'wkd."PREIS",'||unistr('\000a')||
'wkd."MWST_BETRAG",'||unistr('\000a')||
'wkd."MWST_SATZ",'||unistr('\000a')||
'wkd."WK_STATUS_ID",'||unistr('\000a')||
'wkd."STATUS_AENDERDATUM",'||unistr('\000a')||
'wkd."STATUS_AENDERVISUM",'||unistr('\000a')||
'wkd."ETIKETTENTYP",'||unistr('\000a')||
'wkd."BEMERKUNG",'||unistr('\000a')||
'wkd."ERFDAT",'||unistr('\000a')||
'wkd."ERFUSER",'||unistr('\000a')||
'wkd."MUTDAT",'||unistr('\000a')||
'wkd."MUTUSER",'||unistr('\000a')||
'  null rezept_nr , ';

s:=s||'-- pr.rezept_nr||DECODE(pr.version,NULL,NULL,''/''||pr.version) rezept_nr, --bisher keine Produktrezepte'||unistr('\000a')||
'  /*CASE WHEN wkd.PRODKENNZ_ID = 1 THEN -- HCK-Mischung'||unistr('\000a')||
'      frgbg_s.get_pers_name_rezept(p_rezept_id) ||''</br>''||'||unistr('\000a')||
'      frgbg_s.holen_uebersetzung(585,:fas_sprache_id)||'': ''||wkd.reichweite||'||unistr('\000a')||
'      DECODE (rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version),0,'''','||unistr('\000a')||
'         ''</br>''||fas_synch.get_';

s:=s||'tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version)'||unistr('\000a')||
'      ,:fas_sprache_id))'||unistr('\000a')||
'  ELSE '||unistr('\000a')||
'  */'||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)|| ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id) '||unistr('\000a')||
'  --END kuerzel,'||unistr('\000a')||
'      kuerzel,'||unistr('\000a')||
'  TRUNC(NVL(wkd.PRE';

s:=s||'IS,0) + NVL(wkd.MWST_BETRAG,0),2) einzelpreis_brutto,'||unistr('\000a')||
' (trunc(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2))*NVL(wkd.MENGE,0)'||unistr('\000a')||
'               gesamtpreis_brutto,'||unistr('\000a')||
'  DECODE ((select count(*) from  WKORB_DET_VERORDNUNGEN_TMP wkdv '||unistr('\000a')||
'           where WARENKORB_DETAIL_TMP_ID=wkd.id'||unistr('\000a')||
'           ),0,'''',''<span style="background-color:green;">'')'||unistr('\000a')||
'||''<a href="'''||unistr('\000a')||
'||apex_util.prepare_url(''f?p=&APP_ID.:303:&SESSION.:';

s:=s||':&DEBUG.::'''||unistr('\000a')||
'||''P303_WARENKORB_DETAIL_TMP_ID:'''||unistr('\000a')||
'||to_char(wkd.id))'||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#edit_big.gif">'''||unistr('\000a')||
'|| ''</a>''  verord_link'||unistr('\000a')||
'/*wkd.id delete_link'||unistr('\000a')||
'''<a href="'''||unistr('\000a')||
'||''javascript:apex.submit({request:''''MULTI_ROW_DELETE'''',set:{''''P500_WK_DET_ID'''':''''#ROWNUM#''''}})'''||unistr('\000a')||
'|| ''">'''||unistr('\000a')||
'|| ''<img src="#IMAGE_PREFIX#del.gif">'''||unistr('\000a')||
'|| ''</a>'' delete_link'||unistr('\000a')||
'*/'||unistr('\000a')||
',wkd.reichweite reichweite'||unistr('\000a')||
'from WARENKORB_DETAILS_TMP wkd,';

s:=s||' mengenarts m   -- , prod_rezepte pr  bisher keine Produktrezepte bei Wiederverkäufer'||unistr('\000a')||
'where warenkorb_tmp_id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'  --and p_rezept_id = pr.id (+)'||unistr('\000a')||
'  and mengenart_id = m.id (+)'||unistr('\000a')||
'  and (wkd.mengenart_id is NULL or wkd.mengenart_id != 101)'||unistr('\000a')||
'order by wkd.id';

wwv_flow_api.create_report_region (
  p_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 500,
  p_name=> '&P500_REGION_TITEL_WARENKORB.',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 40,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 3,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P300_HEIGHT_WARENKORB.px; min-width: 520px">',
  p_footer=> '</div>'||unistr('\000a')||
'<script type="text/javascript">'||unistr('\000a')||
'var rowsFetched = #ROWS_FETCHED#;'||unistr('\000a')||
'if (rowsFetched == 0) {'||unistr('\000a')||
'  $x_Hide($x(''CHECK$01'').parentNode);'||unistr('\000a')||
'}'||unistr('\000a')||
'</script>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3081,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '50',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> '&P300_MELDUNG_WK.',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403124017817142 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403208670817143 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403314327817143 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID_DISPLAY',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID_DISPLAY',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403428311817143 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_TMP_ID',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WARENKORB_TMP_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403520946817143 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PRODKENNZ_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403618299817143 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'P_REZEPT_ID',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'P_REZEPT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403713177817143 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403813208817143 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G990',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'TEXT',
  p_inline_lov=> '1,2,3,4,5,6,7,8,9,10',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '5',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403920497817144 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'VOLUMEN',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'VOLUMEN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404010516817144 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'GEWICHT',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'GEWICHT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404129331817144 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'PREIS',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PREIS',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404212747817144 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_BETRAG',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_BETRAG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404332405817144 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_SATZ',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_SATZ',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404413247817144 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS_ID',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WK_STATUS_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404529657817144 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERDATUM',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERDATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404622917817145 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERVISUM',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERVISUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404713712817145 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'ETIKETTENTYP',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ETIKETTENTYP',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404824060817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '20',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'BEMERKUNG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6404922162817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'ERFDAT',
  p_column_display_sequence=> 23,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6405019433817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'ERFUSER',
  p_column_display_sequence=> 24,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6405110753817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'MUTDAT',
  p_column_display_sequence=> 25,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6405225937817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'MUTUSER',
  p_column_display_sequence=> 26,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6405309221817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6405412200817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6405516554817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'EINZELPREIS_BRUTTO',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6405624874817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'GESAMTPREIS_BRUTTO',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6405716135817146 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 27,
  p_form_element_id=> null,
  p_column_alias=> 'VERORD_LINK',
  p_column_display_sequence=> 27,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6403024012817142 + wwv_flow_api.g_id_offset,
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 28,
  p_form_element_id=> null,
  p_column_alias=> 'REICHWEITE',
  p_column_display_sequence=> 28,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'','||unistr('\000a')||
'                                       ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'       kuerzel,id,sort,'||unistr('\000a')||
'       CASE WHEN dokument_id is not null THEN'||unistr('\000a')||
'         ''<img src="'' || frgbg_t.get_sys_param(63) || frgbg_s.holen_uebersetzung(NVL(dokument_id, 0),:fas_sprache_id) --#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         --|| NVL (dokument_id, ';

s:=s||'0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'        -- || ''" height="'''||unistr('\000a')||
'        -- || 90'||unistr('\000a')||
'        -- || ''" width="'''||unistr('\000a')||
'        -- || 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'       ELSE NULL END img'||unistr('\000a')||
'FROM artgruppen '||unistr('\000a')||
'WHERE id in (                           -- alle Artikel der WV_PL sind verkaufsfähig=> Sortimentsinhalt wird von GUS bestimmt'||unistr('\000a')||
'             SELECT distinct g.id'||unistr('\000a')||
'             FROM artgruppen g, mengenarts m, preislis';

s:=s||'ten_details pd, warenkoerbe_tmp wk '||unistr('\000a')||
'             WHERE g.id = m.artgruppe_id'||unistr('\000a')||
'               AND m.satz_kennzeichen is null'||unistr('\000a')||
'               AND pd.mengenart_id = m.id'||unistr('\000a')||
'               AND pd.preisliste_id=wk.preisliste_id'||unistr('\000a')||
'               AND wk.id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'               AND pd.GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'               AND pd.GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'               AND ';

s:=s||'pd.MIN_MENGE <= 1'||unistr('\000a')||
'               AND pd.MAX_MENGE >= 1'||unistr('\000a')||
'               AND pd.preis >= 0'||unistr('\000a')||
'               AND pd.satz_kennzeichen is null'||unistr('\000a')||
'            )'||unistr('\000a')||
'and ID not in (20,76,94)  -- NEI 23.06.14 keine Laborartikel und keine Standardmischartikel und kein HCK-Zubehör'||unistr('\000a')||
'order by 4'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 6406700417817154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 500,
  p_name=> 'KATEGORIE',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 20,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto;height: &P300_HEIGHT_KATEGORIE.px;width: 220px ">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3666,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '100',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '1000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6406915206817155 + wwv_flow_api.g_id_offset,
  p_region_id=> 6406700417817154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'BEZEICHNUNG',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_link=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.::P500_ARTIKELKATEGORIE,P500_ARTIKELKATEGORIE_BEZ,P500_SUCHE:#ID#,#BEZEICHNUNG#,',
  p_column_linktext=>'#BEZEICHNUNG#',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6407029127817155 + wwv_flow_api.g_id_offset,
  p_region_id=> 6406700417817154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6407110153817155 + wwv_flow_api.g_id_offset,
  p_region_id=> 6406700417817154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6407212787817155 + wwv_flow_api.g_id_offset,
  p_region_id=> 6406700417817154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'SORT',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6407319788817155 + wwv_flow_api.g_id_offset,
  p_region_id=> 6406700417817154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'IMG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6407416983817156 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 500,
  p_plug_name=> '&P500_REGION_TITEL_ARTIKEL.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 5572010060380233+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_header=> '<div style="min-width: 630px;text-align:left">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 6393623605817121 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 500,
  p_button_sequence=> 10,
  p_button_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_HIDE',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P500_BL_BUT_HIDE.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:500:&SESSION.:HIDE_SHOW:&DEBUG.::P500_FLAG_HIDE_SHOW:-1',
  p_button_condition=> ':P500_FLAG_HIDE_SHOW = 1',
  p_button_condition_type=> 'NEVER',
  p_button_image_attributes=>'onmouseover="toolTip_enable(event,this,this.alt)"  popupfieldhelp ',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6393807472817122 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 500,
  p_button_sequence=> 15,
  p_button_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_show',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P500_BL_BUT_SHOW.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:500:&SESSION.:HIDE_SHOW:&DEBUG.::P500_FLAG_HIDE_SHOW:1',
  p_button_condition=> ':P500_FLAG_HIDE_SHOW = -1',
  p_button_condition_type=> 'NEVER',
  p_button_image_attributes=>'onmouseover="toolTip_enable(event,this,this.alt)"  popupfieldhelp ',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6393205117817117 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 500,
  p_button_sequence=> 20,
  p_button_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_button_name    => 'MULTI_ROW_DELETE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P500_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT * '||unistr('\000a')||
'FROM warenkorb_details_tmp '||unistr('\000a')||
'where warenkorb_tmp_id=:P500_WARENKORB_TMP_ID',
  p_button_condition_type=> 'EXISTS',
  p_button_image_attributes=>'onmouseover="toolTip_enable(event,this,this.alt)"  popupfieldhelp ',
  p_database_action=>'DELETE',
  p_button_comment=>'width="14" height="16"',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6393407103817121 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 500,
  p_button_sequence=> 40,
  p_button_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_button_name    => 'KASSE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P500_BL_ZUR_KASSE.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT * '||unistr('\000a')||
'FROM warenkorb_details_tmp '||unistr('\000a')||
'where warenkorb_tmp_id=:P500_WARENKORB_TMP_ID',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6407624192817157 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 500,
  p_button_sequence=> 40,
  p_button_plug_id => 6407416983817156+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P500_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6407804123817157 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 500,
  p_button_sequence=> 50,
  p_button_plug_id => 6407416983817156+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P500_BL_SUCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 6405905428817146 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 500,
  p_button_sequence=> 30,
  p_button_plug_id => 6402804900817140+wwv_flow_api.g_id_offset,
  p_button_name    => 'SUBMIT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P500_BL_SPEICHERN.',
  p_button_position=> 'TEMPLATE_DEFAULT',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT * FROM warenkorb_details_tmp where warenkorb_tmp_id=:P500_WARENKORB_TMP_ID;',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6416901634817208 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P500_ZURUECK_SEITE.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6407624192817157+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>6417109832817208 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:505:&SESSION.::&DEBUG.:505:P505_WARENKORB_TMP_ID,P505_ZURUECK_SEITE,P505_ZURUECK_SEITE_NACH_BEST:&P500_WARENKORB_TMP_ID.,&APP_PAGE_ID.,&P500_ZURUECK_SEITE.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6393407103817121+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 12,
  p_branch_condition_type=> 'NEVER',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-DEC-2012 10:51 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>8011806484009518 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:508:&SESSION.::&DEBUG.:508:P508_WARENKORB_TMP_ID,P508_ZURUECK_SEITE,P508_ZURUECK_SEITE_NACH_BEST:&P500_WARENKORB_TMP_ID.,&APP_PAGE_ID.,&P500_ZURUECK_SEITE.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6393407103817121+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 12,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-DEC-2012 10:51 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>6417302003817208 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:304:P304_ID:&P500_PERSSTAMM_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6397811490817132+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 15,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>6418732037817210 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:302:P302_ID,P302_ADRESSTYP,P302_ZURUECK_SEITE,P302_CALLING_PAGE:&P500_PERSSTAMM_ID_LIEFERUNG.,L,500,500',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6402612345817139+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 16,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>6418914583817210 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:302:P302_ID,P302_ADRESSTYP,P302_ZURUECK_SEITE,P302_CALLING_PAGE:&P500_PERSSTAMM_ID_RECHNUNG.,L,300,300',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6396406601817130+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 17,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>6417519467817209 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301:P301_PERSSTAMM_ID_BETREUER,P301_persstamm_id_patient,p301_adresstyp,p301_zurueck_seite,P301_PERSSTAMM_ID_STDADRESSE:&P500_PERSSTAMM_ID_LOGIN.,&P500_PERSSTAMM_ID.,L,&APP_PAGE_ID.,&P500_PERSSTAMM_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6401628885817138+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>6417724141817209 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301:P301_PERSSTAMM_ID_BETREUER,P301_persstamm_id_patient,p301_adresstyp,p301_zurueck_seite,P301_PERSSTAMM_ID_STDADRESSE:&P500_PERSSTAMM_ID_LOGIN.,&P500_PERSSTAMM_ID.,R,&APP_PAGE_ID.,&P500_PERSSTAMM_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>6401818553817138+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>6418132406817209 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:500:&SESSION.:FEHLERAUSGABE:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 50,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request =''WARENKORB''',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 13-MAR-2012 10:44 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>6418322021817209 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:500:&SESSION.::&DEBUG.::P500_PERSSTAMM_ID_EXTERN_UPD,P500_ADRESSTYP_EXTERN:&P500_PERSSTAMM_ID_RECHSTELLER.,RS&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 60,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request = ''P500_PERSSTAMM_ID_RECHSTELLER''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-MAR-2012 12:01 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>6416707242817205 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:500:&SESSION.::&DEBUG.::P500_PERSSTAMM_ID_EXTERN_UPD,P500_ADRESSTYP_EXTERN:&P500_PERSSTAMM_ID_RECHSTELLER.,L&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 80,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request = ''P500_WK_VERSANDART_ID'' and :p500_wk_versandart_id = 3',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-MAR-2012 12:01 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>6418519610817210 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6386617877817093 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MWST_LABEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6386810025817098 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PERGEBNIS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 306,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6387432046817100 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6387623765817101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_ZUR_KASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6387825341817101 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6388024698817102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_AUSWAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 340,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6388231204817102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 350,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6388423151817102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 360,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6388604633817102 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_INDIV_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 370,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6388816044817103 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_REGION_TITEL_ARTIKEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 380,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6389012610817103 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_REGION_TITEL_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 390,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6389220115817104 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_REGION_TITEL_ADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 400,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6389426469817105 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 410,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6389611254817105 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PERSSTAMM_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 420,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6389811508817105 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_REGION_TITEL_KATEGORIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 375,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6390009497817105 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_HEIGHT_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 430,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6390223571817106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_HEIGHT_ARTIKEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 440,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6390418610817106 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 315,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6390628258817107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_REZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 305,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'rezept',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6390808473817107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6391017910817107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6391201053817108 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 15,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onChange="javascript:doSubmit(''CHANGE'') "',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6391415178817109 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_HEIGHT_KATEGORIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 450,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6391616703817109 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_BUT_HIDE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 372,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6391817216817110 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BL_BUT_SHOW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 373,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6392012866817111 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_IN_WK_FEHLERTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6392203996817111 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MELDUNG_ARTSUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6392423120817111 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_NV_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6392624952817111 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MELDUNG_WK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6394013288817122 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6394203140817122 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_AERZTLICH_VERORDNET',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ärztlich verordnet',
  p_source=>'AERZTLICH_VERORDNET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(77,:fas_sprache_id) a, 0 FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(76,:fas_sprache_id) a, 1 FROM DUAL',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'SELECT *'||unistr('\000a')||
'from warenkorb_details_tmp wkd, mengenarts m'||unistr('\000a')||
'where wkd.warenkorb_tmp_id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'  and wkd.mengenart_id = m.id'||unistr('\000a')||
'  and m.artgruppe_id= 20;',
  p_display_when_type=>'EXISTS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'REDIRECT_SET_VALUE',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6394400236817124 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_WARENKORB_TMP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb-ID',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6394622417817124 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_GESAMTWERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtwert',
  p_format_mask=>'999G999G999G999G990D00',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P500_GESAMTWERT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6394825332817124 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_GESAMT_MWST_BETRAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'enthaltene Mwst',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'to_char(trunc(NVL(to_number(:p500_mwst_betrag_1,''999G999G999G999G990D00''),0) + NVL(to_number(:p500_mwst_betrag_2,''999G999G999G999G990D00''),0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6395027908817126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_WAEHRUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'rezepte.get_waehrung_zeichen(:p500_waehrung_id)||'' ''||:P500_MWST_LABEL;',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6395224521817126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_ETIKETTENTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ettikettentyp',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,1);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6395417428817127 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_WK_DET_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 400,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6395622738817127 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_VERSANDKOSTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'SELECT to_char(NVL(sum(preis+mwst_betrag),0),''999G999G999G999G990D00'')'||unistr('\000a')||
'from warenkorb_details_tmp'||unistr('\000a')||
'where warenkorb_tmp_id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'  and mengenart_id = 101;',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6396001648817129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PATIENTADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_adresse(:p500_persstamm_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6396206478817129 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PERSSTAMM_PROD_APO_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 17,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'substr(frgbg_s.get_pers_adresse(:p500_persstamm_id_prod_apo),1,80)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6396406601817130 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_RECHADRESSE_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 11,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P500_BL_AENDERN.',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P500_persstamm_id != :p500_persstamm_id_rechnung',
  p_display_when_type=>'NEVER',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6397007536817130 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_WK_VERSANDART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 18,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6397415363817131 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 36,
  p_item_plug_id => 6393012442817115+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6397603411817131 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_ADRESSTYP_EXTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ext Adresstyp',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6397811490817132 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PATIENT_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'PATIENT',
  p_prompt=>'&P500_BL_AENDERN.',
  p_source=>'PATIENT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6398215701817132 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 21,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6398407099817132 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 23,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Plandatum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6398617952817133 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land Id',
  p_source=>'VERRECH_LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6398818364817133 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 22,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Waehrung Id',
  p_source=>'WAEHRUNG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6399015119817133 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtpreis',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'GESAMTPREIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6399200606817133 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MWST_JN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Jn',
  p_source=>'MWST_JN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6399405846817134 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MWST_BETRAG_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 1',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'MWST_BETRAG_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6399615536817134 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MWST_BETRAG_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 2',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'MWST_BETRAG_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6399823404817134 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MWST_SATZ_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 1',
  p_source=>'MWST_SATZ_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6400022025817135 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MWST_SATZ_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 2',
  p_source=>'MWST_SATZ_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6400217975817135 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_WK_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wk Status Id',
  p_source=>'WK_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6400410100817135 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_STATUS_AENDERDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aenderdatum',
  p_source=>'STATUS_AENDERDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6400617557817135 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_STATUS_AENDERVISUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aendervisum',
  p_source=>'STATUS_AENDERVISUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6400810748817137 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Login',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6401030883817137 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bemerkung',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6401203999817138 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_LIEFERADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 6,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_adresse(:p500_persstamm_id_lieferung)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6401401889817138 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_RECHNUNGSADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_adresse(:p500_persstamm_id_rechnung)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6401628885817138 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_LIEFERADRESSE_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 8,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'LIEFERADRESSE',
  p_prompt=>'&P500_BL_AUSWAHL.',
  p_source=>'LIEFERADRESSE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6401818553817138 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_RECHADR_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'RECHADRESSE',
  p_prompt=>'&P500_BL_AUSWAHL.',
  p_source=>'RECHADRESSE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6402026865817139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PERSSTAMM_ID_EXTERN_UPD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'ext Persstamm Id Upd',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6402205457817139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_FLAG_HIDE_SHOW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 410,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '-1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6402412732817139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_PERSSTAMM_ID_RECHSTELLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 14,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PERSSTAMM_ID_RECHNUNGSSTELLER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select substr(frgbg_s.get_pers_adresse(:p500_persstamm_id_rechsteller),1,80) a,'||unistr('\000a')||
':p500_persstamm_id_rechsteller b'||unistr('\000a')||
'from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6402612345817139 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_LIEFERADRESSE_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 7,
  p_item_plug_id => 6395817351817128+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P500_BL_AENDERN.',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p500_persstamm_id != :p500_persstamm_id_lieferung',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6408030000817158 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_SA_AUFTRAGSNUMMER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 6407416983817156+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'SA-Auftragsnr',
  p_format_mask=>'99999999',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 10,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onblur="javascript:doSubmit ()"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'DECLARE'||unistr('\000a')||
'   v_anz_wk    number;'||unistr('\000a')||
'   v_anz_fb    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p500_wk_artikeltyp_flag = 1 THEN'||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   ELSE '||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
' '||unistr('\000a')||
''||unistr('\000a')||
'   SELECT count(*) into v_anz_fb'||unistr('\000a')||
'   FROM  warenkoerbe_tmp wk, pergebnisse p'||unistr('\000a')||
'   where wk.id = :p500_id   -- WK'||unistr('\000a')||
'     -- hoechste Version eines FB ohne Auswertung muss vorhanden sein '||unistr('\000a')||
'     AND p.persstamm_id = wk.persstamm_id_kunde -- Nur FB des Kunden'||unistr('\000a')||
'     and p.id is not null'||unistr('\000a')||
'     and p.versions_id = frgbg_s.GET_FB_MAX_VERSION(p.fragebogen_id,p.persstamm_id) -- hoechste Version'||unistr('\000a')||
'     and frgbg_s.FB_CHECK_AUSWERTUNG(p.id)= 0'||unistr('\000a')||
'     and p.fragebogen_id = 5             -- zZ. nur FB MNR'||unistr('\000a')||
'   ;'||unistr('\000a')||
'   -- WK mit Einträge ohne Laboranalyse'||unistr('\000a')||
'   SELECT count(*) into v_anz_wk'||unistr('\000a')||
'   FROM warenkorb_details_tmp wkd,mengenarts m'||unistr('\000a')||
'   where wkd.warenkorb_tmp_id = :p500_id   -- WK'||unistr('\000a')||
'     and wkd.mengenart_id = m.id (+)'||unistr('\000a')||
'     and (m.artgruppe_id != 20'||unistr('\000a')||
'        OR'||unistr('\000a')||
'         m.id is null   '||unistr('\000a')||
'        )'||unistr('\000a')||
'   ;'||unistr('\000a')||
'   IF v_anz_wk > 0  OR v_anz_fb = 0 THEN'||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   ELSE '||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_display_when_type=>'FUNCTION_BODY',
  p_read_only_when=>'SELECT *'||unistr('\000a')||
'from warenkorb_details_tmp wkd'||unistr('\000a')||
'where wkd.warenkorb_tmp_id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'  ;',
  p_read_only_when_type=>'EXISTS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6408231982817159 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_ARTIKELKATEGORIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 4,
  p_item_plug_id => 6407416983817156+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''ARTGRUPPEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung,id'||unistr('\000a')||
'FROM artgruppen -- Keine Einschränkung, da dies nur zum Einblenden der Bezeichnung einer vorhandenen Kategorie dient'||unistr('\000a')||
''||unistr('\000a')||
'/*UNION SELECT frgbg_s.holen_uebersetzung(511,:fas_sprache_id), 0 FROM DUAL*/'||unistr('\000a')||
'UNION SELECT '''', 0 FROM DUAL'||unistr('\000a')||
'UNION SELECT frgbg_s.holen_uebersetzung(4859,:fas_sprache_id),-1 FROM DUAL /*Mischungen*/'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6408409380817159 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_SUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 6407416983817156+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 70,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6408605156817159 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_ARTIKELKATEGORIE_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6407416983817156+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6408813967817160 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_SUCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 6,
  p_item_plug_id => 6407416983817156+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'SUCHEN',
  p_source=>'SUCHEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_button_image => '24find.gif',
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7214030405391558 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MENGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Menge',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7217815907415699 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 500,
  p_name=>'P500_MENGENART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 6385401498817074+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6410726561817170 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'PLSQL',
  p_validation_sequence=> 1,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   mel.p(''102/300:testval request:%1,%2,%3,%4'',v_prot_id,''INFO'',''test'',:request,:P500_WK_DET_ID,:P500_MENGENART_ID,:p500_rezept_nr);'||unistr('\000a')||
'--  IF :request = ''MULTI_ROW_DELETE'' THEN'||unistr('\000a')||
'--     apex_application.g_f01(1):= :P500_WK_DET_ID;'||unistr('\000a')||
'--  END IF;'||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6409517568817167 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P500_mengenart_id',
  p_validation_sequence=> 30,
  p_validation => 'DECLARE '||unistr('\000a')||
'   v_mengenart_id       mengenarts.id%TYPE;'||unistr('\000a')||
'   v_INDIVIDUALISIERBAR mengenarts.INDIVIDUALISIERBAR%TYPE;'||unistr('\000a')||
'   v_fehlertext         uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_prot_id            NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check1 mengenart_id %1,%2,%3,%4'',v_prot_id,v_prot_id,''TEST'',:p500_mengenart_id, v_INDIVIDUALISIERBAr);'||unistr('\000a')||
''||unistr('\000a')||
'   IF :p500_mengenart_id is not null THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'          -- Sortiment bestimmt GUS über das Laden der Preisliste'||unistr('\000a')||
'          -- => Artikel muss in Preisliste sein'||unistr('\000a')||
'          SELECT m1.id ,m1.INDIVIDUALISIERBAR'||unistr('\000a')||
'          into v_mengenart_id, v_INDIVIDUALISIERBAR'||unistr('\000a')||
'          from preislisten_details pd, mengenarts m1,warenkoerbe_tmp wk'||unistr('\000a')||
'          where m1.id = :p500_mengenart_id'||unistr('\000a')||
'            and m1.id = pd.mengenart_id'||unistr('\000a')||
'            and m1.satz_kennzeichen is null'||unistr('\000a')||
'            and pd.preisliste_id = wk.preisliste_id'||unistr('\000a')||
'            and pd.GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'            AND pd.GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'            AND pd.MIN_MENGE <= 1'||unistr('\000a')||
'            AND pd.MAX_MENGE >= 1'||unistr('\000a')||
'            AND pd.preis >= 0'||unistr('\000a')||
'            AND wk.id = :p500_warenkorb_tmp_id --773854'||unistr('\000a')||
'          ;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN no_data_found THEN'||unistr('\000a')||
'         --v_fehlertext := ''Artikel ist unbekannt! Bestellung nicht möglich.'';'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(4331,:fas_sprache_id);'||unistr('\000a')||
'         RETURN v_fehlertext;         '||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         mel.p(''Interner Fehler bei der Artikelauswahl im WK mengenart_id %1 Fehler: %2'',v_prot_id,''FEHLER'',:p500_mengenart_id, SQLERRM);'||unistr('\000a')||
'         --v_fehlertext := ''Artikel ist unbekannt! Bestellung nicht möglich.'';'||unistr('\000a')||
'         v_fehlertext:=frgbg_s.holen_uebersetzung(4331,:fas_sprache_id);'||unistr('\000a')||
'         RETURN v_fehlertext;'||unistr('\000a')||
'      END ;'||unistr('\000a')||
'/*mel.p(''check2 mengenart_id %1,%2,%3,%4'',v_prot_id,v_prot_id,''TEST'',:p500_mengenart_id, v_INDIVIDUALISIERBAR, :p500_groesse,:p500_gewicht);'||unistr('\000a')||
'*/'||unistr('\000a')||
'  '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request = ''WARENKORB''',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6409321378817167 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_kunde_adressen_vollstaendigkeit',
  p_validation_sequence=> 35,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_gus_id       personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_extern_verwaltet warenkoerbe.extern_verwaltet%TYPE;'||unistr('\000a')||
'   v_prot_id      number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/300: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Kunderadresse müssen vollständig sein, wenn der Auftrag an GUS geht und noch keine GUS-ID für den Kunden vorhanden ist, sonst kann GUS den Kunden nicht anlegen'||unistr('\000a')||
'   -- holen der Kundenadr. aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          p.gus_id,wk.extern_verwaltet'||unistr('\000a')||
'   INTO v_plz, v_ort, v_land_id,v_strasse,v_name,v_vorname,'||unistr('\000a')||
'        v_gus_id,v_extern_verwaltet'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'     AND wk.persstamm_id_kunde =p.id;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_gus_id is NULL THEN '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9129,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
''||unistr('\000a')||
'   /* wird zur Zeit nicht benötigt'||unistr('\000a')||
'   IF v_gus_id is NULL AND v_extern_verwaltet=1 AND'||unistr('\000a')||
'      (v_plz is NULL OR v_ort is NULL OR v_land_id IS NULL OR '||unistr('\000a')||
'       v_strasse IS NULL OR v_name IS NULL OR v_vorname IS NULL'||unistr('\000a')||
'      )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Kundenadresse ist unvollständig! Die Felder Name, Vorname, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5901,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
'   */'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_when_button_pressed=> 6393407103817121 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6410329523817168 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_lief_adressen_vollstaendigkeit',
  p_validation_sequence=> 40,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz_lief          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort_lief          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id_lief      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse_lief      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name_lief         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname_lief      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/300: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Lieferadresse müssen vollständig sein'||unistr('\000a')||
'   -- holen der Lieferadr. aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname'||unistr('\000a')||
'   INTO v_plz_lief, v_ort_lief, v_land_id_lief,v_strasse_lief,v_name_lief,v_vorname_lief'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'     AND wk.persstamm_id_lieferung =p.id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF v_plz_lief is NULL OR v_ort_lief is NULL OR v_land_id_lief IS NULL OR '||unistr('\000a')||
'      v_strasse_lief IS NULL OR v_name_lief IS NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Lieferadresse ist unvollständig! Die Felder Name, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5900,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_when_button_pressed=> 6393407103817121 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6409104113817164 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_rech_adressen_vollstaendigkeit',
  p_validation_sequence=> 45,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz_rech          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort_rech          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id_rech      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse_rech      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name_rech         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname_rech      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/300: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Rechnungsadresse müssen vollständig sein'||unistr('\000a')||
'   -- holen der Rechadr aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname'||unistr('\000a')||
'   INTO v_plz_rech, v_ort_rech, v_land_id_rech,v_strasse_rech,v_name_rech,v_vorname_rech'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'     AND wk.persstamm_id_rechnung =p.id;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_plz_rech is NULL OR v_ort_rech is NULL OR v_land_id_rech is NULL OR'||unistr('\000a')||
'      v_strasse_rech IS NULL OR v_name_rech IS NULL OR v_vorname_rech IS NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Rechnungsadresse ist unvollständig! Die Felder Name, Vorname, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5569,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_when_button_pressed=> 6393407103817121 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 6410130264817168 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_adress_kompatibel',
  p_validation_sequence=> 50,
  p_validation => 'Declare'||unistr('\000a')||
'   v_return NUMBER;'||unistr('\000a')||
'   v_fehlertext  uebersetzungen.text%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   v_rec_wk.persstamm_id_prod_apo  := :P500_PERSSTAMM_ID_prod_apo;'||unistr('\000a')||
'   v_rec_wk.persstamm_id_kunde     := :P500_PERSSTAMM_ID;'||unistr('\000a')||
'   v_rec_wk.persstamm_id_lieferung := :P500_PERSSTAMM_ID_LIEFERUNG;'||unistr('\000a')||
'   v_rec_wk.persstamm_id_rechnung  := :P500_PERSSTAMM_ID_RECHNUNG;'||unistr('\000a')||
'*/ '||unistr('\000a')||
'   v_return := frgbg_s.WK_CHECK_ADR_KOMPATIBEL(p_persstamm_id_prod_apo => :P500_PERSSTAMM_ID_prod_apo,'||unistr('\000a')||
'                                               p_persstamm_id_kunde    => :P500_PERSSTAMM_ID,'||unistr('\000a')||
'                                               p_persstamm_id_lieferung=> :P500_PERSSTAMM_ID_LIEFERUNG,'||unistr('\000a')||
'                                               p_persstamm_id_rechnung => :P500_PERSSTAMM_ID_RECHNUNG,'||unistr('\000a')||
'                                               p_warenkorb_tmp_id      => NULL,  -- NEI 05.06.2014'||unistr('\000a')||
'                                               p_sprache_id            => :fas_sprache_id ,'||unistr('\000a')||
'                                               p_fehlertext_out        => v_fehlertext'||unistr('\000a')||
'                                               );'||unistr('\000a')||
'   IF v_return = 1 THEN'||unistr('\000a')||
'      RETURN '''';'||unistr('\000a')||
'   ELSIF p_fehlertext_out is not null THEN'||unistr('\000a')||
'      --''Die Lieferadresse muss auch in der Schweiz liegen, da die Kunden-/ die Rechnungsadresse in der Schweiz liegt!'''||unistr('\000a')||
'      -- ''Liefer- und Kundenadresse müssen im gleichen Land liegen'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5727,:fas_sprache_id);'||unistr('\000a')||
'   END IF;    '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_when_button_pressed=> 6393407103817121 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 6415812563817202 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 500
 ,p_name => 'wk_aktualisierren'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'JQUERY_SELECTOR'
 ,p_triggering_element => 'input:[name=''f02'']'
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '/^[0-9]+$/g.test($(this.triggeringElement).val())'
 ,p_bind_type => 'live'
 ,p_bind_event_type => 'change'
 ,p_da_event_comment => 'Die Condition erlaubt nur positive Ganzzahlen in dem Feld'
  );
wwv_flow_api.create_page_da_action (
  p_id => 7181224716217844 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 500
 ,p_event_id => 6415812563817202 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 5
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P500_MENGENART_ID'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => 'parseInt($(''#f06'' + $(this.triggeringElement).attr(''ID'').substr(3)).val())'
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 7181408917222781 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 500
 ,p_event_id => 6415812563817202 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 6
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P500_MENGE'
 ,p_attribute_01 => 'JAVASCRIPT_EXPRESSION'
 ,p_attribute_05 => 'parseInt($(this.triggeringElement).val())'
 ,p_attribute_09 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 6416129853817203 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 500
 ,p_event_id => 6415812563817202 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'DECLARE'||unistr('\000a')||
'   v_warenkorb_detail_id  warenkorb_details_tmp.id%TYPE;'||unistr('\000a')||
'   v_prod_rezept_id       warenkorb_details_tmp.p_rezept_id%TYPE;'||unistr('\000a')||
'   v_version        prod_rezepte.version%TYPE;'||unistr('\000a')||
'   v_mengenart_id   mengenarts.id%TYPE;'||unistr('\000a')||
'   v_HINWEIStext                 VARCHAR2(2000);'||unistr('\000a')||
'   v_menge_db                    number;'||unistr('\000a')||
'   v_menge                       number;'||unistr('\000a')||
'   v_gesamtwert     VARCHAR2(2000);'||unistr('\000a')||
''||unistr('\000a')||
'   v_return         NUMBER;'||unistr('\000a')||
'   v_prot_id        NUMBER;'||unistr('\000a')||
'   v_fehler         exception;'||unistr('\000a')||
'   v_fehler_mehrfachmisch exception;'||unistr('\000a')||
'   v_fehlertext     VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlernummer   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''Dynamic Action in_wk:Art %1, menge %2,%3,4'',v_prot_id,''Info'',''in_warenkorb'',:p500_mengenart_id,NVL(:p500_menge,0));'||unistr('\000a')||
''||unistr('\000a')||
'   :P500_IN_WK_FEHLERTEXT:= null;'||unistr('\000a')||
'   -- Einzelartikel '||unistr('\000a')||
'   IF :p500_mengenart_id is not null AND :p500_menge is not null THEN'||unistr('\000a')||
'      SELECT min(id), NVL(min(menge),0) INTO v_warenkorb_detail_id, v_menge_db'||unistr('\000a')||
'      FROM warenkorb_details_tmp'||unistr('\000a')||
'      WHERE warenkorb_tmp_id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'        AND mengenart_id = :p500_mengenart_id'||unistr('\000a')||
'        AND p_rezept_id is null       -- Artikel darf nicht als Fertigartikel in einem Rezept sein'||unistr('\000a')||
'      ;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Menge im Warenkorb geändert'||unistr('\000a')||
'      v_menge := :p500_menge;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_warenkorb_detail_id is NULL THEN'||unistr('\000a')||
'         -- Artikel nicht vorhanden => neu einfuegen'||unistr('\000a')||
'         v_fehlertext := ''Artikel nicht im Warenkorb vorhanden! Menge kann nicht geändert werden.'';'||unistr('\000a')||
'         v_fehlernummer := 80;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         -- Menge auf Ganzzahligkeit prüfen'||unistr('\000a')||
'         IF regexp_like(v_menge,''^[0-9]+$'') THEN'||unistr('\000a')||
'            NULL;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            v_fehlertext := ''Die Menge ist nicht ganzzahlig! Mengenänderung nicht möglich.'';'||unistr('\000a')||
'            v_fehlernummer:= 85;'||unistr('\000a')||
'            RAISE v_fehler;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
''||unistr('\000a')||
'         -- Menge erhoehen'||unistr('\000a')||
'         -- Mengenänderungen Preisermittlung mit Berücksichtigung von Staffelpreis für Fertigartikel (ohne Mischungen)'||unistr('\000a')||
'         v_return := frgbg_s.WK_UPD_DETAILS_ART ( :p500_warenkorb_tmp_id,:p500_mengenart_id,v_menge);'||unistr('\000a')||
'         IF v_return < 0 THEN'||unistr('\000a')||
'            v_fehlertext := ''Preisermittlung konnte nicht durchgeführt werden! Menge kann nicht geändert werden.'';'||unistr('\000a')||
'            v_fehlernummer := 90;'||unistr('\000a')||
'            RAISE v_fehler;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      :p500_mengenart_id := NULL;'||unistr('\000a')||
'      :p500_menge := NULL;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,''Ungültige Parameter!'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'   SELECT to_char(NVL(gesamtpreis,0) + '||unistr('\000a')||
'                  NVL(mwst_betrag_1,0)+'||unistr('\000a')||
'                  NVL(mwst_betrag_2,0),''999G999G999G999G990D00'')'||unistr('\000a')||
'   INTO v_gesamtwert'||unistr('\000a')||
'   FROM warenkoerbe_tmp'||unistr('\000a')||
'   WHERE id = :p500_warenkorb_tmp_id;'||unistr('\000a')||
'--mel.p(''Dynamic Action2 in_wk:Art %1, menge %2,%3,%4'', v_prot_id,''Info'',''in_warenkorb'',:p500_mengenart_id,NVL(:p500_menge,0),v_gesamtwert);'||unistr('\000a')||
''||unistr('\000a')||
'   :P500_GESAMTWERT := v_gesamtwert;'||unistr('\000a')||
'   apex_util.set_session_state(''P500_GESAMTWERT'', v_gesamtwert);'||unistr('\000a')||
''||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   MEL.P (v_fehlertext||'' [,FAS/P500 in_warenkorb''||to_char(-v_fehlernummer)||'']'','||unistr('\000a')||
'          v_prot_id,''Fehler'',''FAS/P500 in_warenkorb'');'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(9180,:fas_sprache_id);'||unistr('\000a')||
'   :p500_mengenart_id := NULL;'||unistr('\000a')||
'   :p500_menge := NULL;'||unistr('\000a')||
'   RAISE_APPLICATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   --:P500_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   MEL.P (''Artikel konnte nicht in den Warenkorb gestellt werden!''||'' [,FAS/P500 in_warenkorb''||to_char(-99)||'']''||SQLERRM,'||unistr('\000a')||
'          v_prot_id,''Fehler'',''FAS/P500 in_warenkorb'');'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(9180,:fas_sprache_id);'||unistr('\000a')||
'   :p500_mengenart_id := NULL;'||unistr('\000a')||
'   :p500_menge := NULL;'||unistr('\000a')||
'   RAISE_APPLICATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   --:P500_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'END;'
 ,p_attribute_02 => 'P500_MENGE,P500_MENGENART_ID'
 ,p_attribute_03 => 'P500_GESAMTWERT'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 7082819659096528 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 500
 ,p_event_id => 6415812563817202 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_ALERT'
 ,p_attribute_01 => 'Ungültige Menge!'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 7205623882793550 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 500
 ,p_event_id => 6415812563817202 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P500_GESAMTWERT'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 7206009814798919 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 500
 ,p_event_id => 6415812563817202 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 30
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 6402804900817140 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p500_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   --:p500_bl_info  := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   --:p500_bl_artikelliste := frgbg_s.holen_uebersetzung(3078,v_sprache_id);'||unistr('\000a')||
'   --:p500_bl_in_warenkorb   := frgbg_s.holen_uebersetzung(3079,v_sprache_id);'||unistr('\000a')||
'   :p500_bl_zur_kasse :';

p:=p||'= frgbg_s.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'--   :p500_bl_loeschen := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p500_bl_loeschen := frgbg_s.holen_uebersetzung(3591,v_sprache_id);'||unistr('\000a')||
'   :p500_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id);'||unistr('\000a')||
'   :p500_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprache_id);'||unistr('\000a')||
'   :p500_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id';

p:=p||');'||unistr('\000a')||
'   --:P500_BL_INDIV_REZEPT := frgbg_s.holen_uebersetzung(3082,v_sprache_id);'||unistr('\000a')||
'   :P500_BL_SUCHEN := frgbg_s.holen_uebersetzung(481,v_sprache_id);'||unistr('\000a')||
'   :p500_bl_but_hide := frgbg_s.holen_uebersetzung(4924,v_sprache_id);'||unistr('\000a')||
'   :p500_bl_but_show := frgbg_s.holen_uebersetzung(4923,v_sprache_id);'||unistr('\000a')||
'   --:P500_MWST_LABEL:= frgbg_s.holen_uebersetzung(9181,v_sprache_id);'||unistr('\000a')||
'   :P500_MWST_LABEL:= frgbg_s.holen_ueb';

p:=p||'ersetzung(9726,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P500_REGION_TITEL_KATEGORIE:=NULL;'||unistr('\000a')||
'   :p500_region_titel_artikel:= frgbg_s.holen_uebersetzung(4858,v_sprache_id);'||unistr('\000a')||
'   :p500_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :P500_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   --:P500_REGION_TITEL_ADRESSE := frgbg_s.holen_uebersetzung(1569,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P5';

p:=p||'00_NV_WARENKORB := frgbg_s.holen_uebersetzung(3844,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   -- Hinweistext auf Suchbedingung oder Kategorieeingabe'||unistr('\000a')||
'   :P500_MELDUNG_ARTSUCHE:=frgbg_s.holen_uebersetzung(5443,v_sprache_id);'||unistr('\000a')||
'   :P500_MELDUNG_WK:= frgbg_s.holen_uebersetzung(4860,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6411424364817172 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 51,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_aenderbar     personenstamm.aenderbar%TYPE;'||unistr('\000a')||
'   v_user_account  personenstamm.user_account%TYPE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT aenderbar, user_account into v_aenderbar, v_user_account'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :p500_persstamm_id;'||unistr('\000a')||
'   IF   (v_aenderbar = ''J'') '||unistr('\000a')||
'     OR (v_aenderbar = ''N'' AND'||unistr('\000a')||
'         -- speziell berechtigt'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''GESCHUETZTE_PERSONENDATEN_';

p:=p||'AENDERN'') > 0 '||unistr('\000a')||
'         )'||unistr('\000a')||
'      OR (v_aenderbar = ''N'' AND                 -- User hat sich selbst eingeloggt'||unistr('\000a')||
'          :fas_aufgerufen_von != ''BETREUER'' and'||unistr('\000a')||
'          UPPER(v_USER_ACCOUNT)= UPPER(:APP_USER)'||unistr('\000a')||
'         )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :fas_pers_aenderbar := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_aenderbar := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6411632705817174 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 91,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_fas_pers_aenderbar',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'  v_SCROLLREGION_HEIGHT_MAX  NUmber;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'/*   :P500_HEIGHT_warenkorb := (:FAS_SCROLLREGION_HEIGHT_MAX * 0.9)-4;'||unistr('\000a')||
'   :P500_HEIGHT_artikel := (:FAS_SCROLLREGION_HEIGHT_MAX * 0.9)-4;'||unistr('\000a')||
'   :P500_HEIGHT_KATEGORIE := (:FAS_SCROLLREGION_HEIGHT_MAX * 0.9)-4;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   v_SCROLLREGION_HEIGHT_MAX:= :FAS_SCROLLREGION_HEIGHT_MAX;'||unistr('\000a')||
'   :P500_HEIGH';

p:=p||'T_warenkorb := trunc(v_SCROLLREGION_HEIGHT_MAX * 0.88);'||unistr('\000a')||
'   :P500_HEIGHT_artikel   := trunc(v_SCROLLREGION_HEIGHT_MAX * 0.88);'||unistr('\000a')||
'   :P500_HEIGHT_KATEGORIE := trunc(v_SCROLLREGION_HEIGHT_MAX * 0.88);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6411815407817174 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 100,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   UPDATE warenkoerbe_tmp'||unistr('\000a')||
'   SET wk_versandart_id = :p500_wk_versandart_id'||unistr('\000a')||
'   WHERE id = :p500_warenkorb_tmp_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6411225821817171 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_versandart',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request = ''P500_WK_VERSANDART_ID''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:WARENKORB_DETAILS_TMP:ID';

wwv_flow_api.create_page_process(
  p_id     => 6406309666817153 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_region_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_process_type=> 'MULTI_ROW_DELETE',
  p_process_name=> 'ApplyMRD',
  p_process_sql_clob => p,
  p_process_error_message=> 'Verarbeiten von Löschvorgang nicht möglich.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''MULTI_ROW_DELETE'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_warenkorb_detail_id  warenkorb_details_tmp.id%TYPE;'||unistr('\000a')||
'   v_prod_rezept_id       warenkorb_details_tmp.p_rezept_id%TYPE;'||unistr('\000a')||
'   v_version        prod_rezepte.version%TYPE;'||unistr('\000a')||
'   v_mengenart_id   mengenarts.id%TYPE;'||unistr('\000a')||
'   v_HINWEIStext                 VARCHAR2(2000);'||unistr('\000a')||
'   v_menge_db                    number;'||unistr('\000a')||
'   v_menge                       number;'||unistr('\000a')||
''||unistr('\000a')||
'   v_return         NUMBER;'||unistr('\000a')||
'   v_prot_id        NU';

p:=p||'MBER;'||unistr('\000a')||
'   v_fehler         exception;'||unistr('\000a')||
'   v_fehler_mehrfachmisch exception;'||unistr('\000a')||
'   v_fehlertext     VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlernummer   NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''in_wk:Art %1, rezept %2,%3,%4'',v_prot_id,''Info'',''in_warenkorb'',:p500_mengenart_id,:p500_rezept_nr);'||unistr('\000a')||
''||unistr('\000a')||
'   :P500_IN_WK_FEHLERTEXT:= null;'||unistr('\000a')||
'   v_HINWEIStext:= NULL;'||unistr('\000a')||
'   -- Einzelartikel '||unistr('\000a')||
'   IF :p500_mengenart_id is not null THEN'||unistr('\000a')||
'      SELECT min(id), NV';

p:=p||'L(min(menge),0) INTO v_warenkorb_detail_id, v_menge_db'||unistr('\000a')||
'      FROM warenkorb_details_tmp'||unistr('\000a')||
'      WHERE warenkorb_tmp_id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'        AND mengenart_id = :p500_mengenart_id'||unistr('\000a')||
'        AND p_rezept_id is null       -- Artikel darf nicht als Fertigartikel in einem Rezept sein'||unistr('\000a')||
'      ;'||unistr('\000a')||
'      IF :request = ''WARENKORB'' THEN  -- von Artikelliste neu ausgewählt'||unistr('\000a')||
'         v_menge := v_menge_db+1';

p:=p||';'||unistr('\000a')||
'      ELSIF :request = ''SUBMIT'' THEN  -- Menge im Warenkorb geändert'||unistr('\000a')||
'         v_menge := :p500_menge;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         RETURN;  -- nichts machen'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      IF v_warenkorb_detail_id is NULL THEN'||unistr('\000a')||
'         -- Artikel nicht vorhanden => neu einfuegen'||unistr('\000a')||
'         v_return := frgbg_s.wk_gen_details_art ('||unistr('\000a')||
'                      :p500_warenkorb_tmp_id'||unistr('\000a')||
'                      ,:p500_mengenart_id'||unistr('\000a')||
' ';

p:=p||'                     ,1 -- i.R.Menge immer 1'||unistr('\000a')||
'                      ,:p500_etikettentyp'||unistr('\000a')||
'                      ,1    -- Modus 0=fix in WK oder 1=temporär in WK_tmp'||unistr('\000a')||
'                      ,null --:p500_pergebnis_id'||unistr('\000a')||
'                      ,null --laborauftragsnummer'||unistr('\000a')||
'                      ,null --labor_id '||unistr('\000a')||
'                       );'||unistr('\000a')||
'         IF v_return < 0 THEN -- Fehler'||unistr('\000a')||
'            v_fehlertext := ''Arti';

p:=p||'kel konnte nicht in den Warenkorb gestellt werden!'';'||unistr('\000a')||
'            v_fehlernummer := 80;'||unistr('\000a')||
'            RAISE v_fehler;'||unistr('\000a')||
'         END IF;   '||unistr('\000a')||
'         -- Mengenänderungen Preisermittlung mit Berücksichtigung von Staffelpreis für Fertigartikel (ohne Mischungen)'||unistr('\000a')||
'         -- Zur Sicherheit nochmals eine GUS-Anfrage'||unistr('\000a')||
'         v_return := frgbg_s.WK_UPD_DETAILS_ART ( :p500_warenkorb_tmp_id,:p500_mengenart_id,1';

p:=p||');   '||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         -- Menge erhoehen'||unistr('\000a')||
'         /*UPDATE warenkorb_details_tmp'||unistr('\000a')||
'         SET menge = v_menge        --menge + 1'||unistr('\000a')||
'         WHERE id = v_warenkorb_detail_id;'||unistr('\000a')||
'         */'||unistr('\000a')||
'         -- Mengenänderungen Preisermittlung mit Berücksichtigung von Staffelpreis für Fertigartikel (ohne Mischungen)'||unistr('\000a')||
'         v_return := frgbg_s.WK_UPD_DETAILS_ART ( :p500_warenkorb_tmp_id,:p500_mengenart_id,v_';

p:=p||'menge);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      :p500_mengenart_id := NULL;'||unistr('\000a')||
'      :p500_pergebnis_id := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :P500_IN_WK_FEHLERTEXT:=v_HINWEIStext;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler_mehrfachmisch THEN'||unistr('\000a')||
'   MEL.P (v_fehlertext||'' [,FAS/P500 in_warenkorb''||to_char(-v_fehlernummer)||'']'','||unistr('\000a')||
'          v_prot_id,''Fehler'',''FAS/P500 in_warenkorb'');'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(5037,:fas_sprache_id);'||unistr('\000a')||
'   :p500';

p:=p||'_mengenart_id := NULL;'||unistr('\000a')||
'   :p500_menge := NULL;'||unistr('\000a')||
'   --RAISE_APPLICATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   :P500_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   MEL.P (v_fehlertext||'' [,FAS/P500 in_warenkorb''||to_char(-v_fehlernummer)||'']'','||unistr('\000a')||
'          v_prot_id,''Fehler'',''FAS/P500 in_warenkorb'');'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(4326,:fas_sprache_id);'||unistr('\000a')||
'   :p500_mengenart_id := NULL;'||unistr('\000a')||
'   ';

p:=p||':p500_menge := NULL;'||unistr('\000a')||
'   --RAISE_APPLICATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   :P500_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   v_fehlertext := ''Artikel/Rezept konnte nicht in den Warenkorb gestellt werden!'' ;'||unistr('\000a')||
'   MEL.P (v_fehlertext||'' [,FAS/P500 in_warenkorb''||to_char(-99)||'']''||SQLERRM,'||unistr('\000a')||
'          v_prot_id,''Fehler'',''FAS/P500 in_warenkorb'');'||unistr('\000a')||
'   v_fehlertext:= frgbg_s.holen_uebersetzung(432';

p:=p||'6,:fas_sprache_id);'||unistr('\000a')||
'   :p500_mengenart_id := NULL;'||unistr('\000a')||
'   :p500_menge := NULL;'||unistr('\000a')||
'   --RAISE_APPLICATION_ERROR (-20000,v_fehlertext);'||unistr('\000a')||
'   :P500_IN_WK_FEHLERTEXT:= v_fehlertext;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6412227194817175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 40,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'in_warenkorb',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request in (''WARENKORB'',''SUBMIT'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Versandkosten einhängen'||unistr('\000a')||
'   /* zur Zeit sollen keine Versandkosten ermittelt werden'||unistr('\000a')||
'   v_return:= frgbg_s.wk_gen_versandkosten(:P500_WARENKORB_TMP_ID,1);'||unistr('\000a')||
'   */'||unistr('\000a')||
'   NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6412415907817177 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_versandkosten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>6393407103817121 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   mel.p(''102/300:test request:%1'',v_prot_id,''INFO'',''test'',:request);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6412603944817178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 60,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'test',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
' frgbg_jobs.sleep (5000);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7434600919525200 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'sleep_test',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_text VARCHAR2(2000);'||unistr('\000a')||
'   v_prot_id   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''In fehlerausgabe WK'',v_prot_id,''INFO'',''p500/fehlerausgabe'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
''||unistr('\000a')||
'   v_text := :P500_IN_WK_FEHLERTEXT;'||unistr('\000a')||
'   :P500_IN_WK_FEHLERTEXT := NULL;'||unistr('\000a')||
'   IF v_text is not null THEN'||unistr('\000a')||
'      htp.p(''alert("''||v_text||''");'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6412824000817178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'in_wk_fehlermeldung_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''FEHLERAUSGABE'' '||unistr('\000a')||
'',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_identitaet_persstamm_id   personenstamm.id%TYPE;'||unistr('\000a')||
'   v_persstamm_id              personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fas_pers_schema_id        fas_schemas.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                varchar2(2000);'||unistr('\000a')||
'   v_prot_id                   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P (''Bst. persstamm %1; Login-id %2'', v_PROT_ID, ''TEST'', ''aktive_identitaet_pers_schema_sortiment_setzen'', :p500_persstamm_id,:fas_logi';

p:=p||'n_personenstamm_id);'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   -- Diese Routine best. die aktive Identität, Kunden-Schema, Sortiment eines ausgewählten Kunden'||unistr('\000a')||
''||unistr('\000a')||
'   v_persstamm_id := :p500_persstamm_id;'||unistr('\000a')||
'   IF v_persstamm_id IS NULL THEN -- Patient muss vorhanden sein'||unistr('\000a')||
'       v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'       RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Bestimmen der aktiven Ident';

p:=p||'ität'||unistr('\000a')||
'   IF :fas_aufgerufen_von != ''BETREUER'' THEN  '||unistr('\000a')||
'      -- Nur möglich bei Betreuer-Login'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'   ELSE -- Aktive Identität gleich ausgewählte Identität'||unistr('\000a')||
'      v_identitaet_persstamm_id:= v_persstamm_id;'||unistr('\000a')||
'      :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'      :fas_';

p:=p||'identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Schema-Id des Kunden setzen, abgeleitet aus der bevorzugt betreuenden Identitaet => wird beim Druck für die Auswahllistten von Kundensprache verwendet'||unistr('\000a')||
'   -- Schema der bevorzugt betreuenden Identitaet bestimmen '||unistr('\000a')||
'   v_fas_pers_schema_id := frgbg_s.get_fas_schema(v_identitaet_persstamm_id,''IDENTITA';

p:=p||'ET'');'||unistr('\000a')||
'        -- frgbg_s.get_identitaet_kunde(NULL,-1,v_persstamm_id),'||unistr('\000a')||
'        --  ''IDENTITAET'');'||unistr('\000a')||
'   IF v_fas_pers_schema_id <= 0 OR '||unistr('\000a')||
'      v_fas_pers_schema_id is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :fas_pers_schema_id := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3505,:fas_sprache_id);'||unistr('\000a')||
'      RAISE_APPLICATION_ERROR (-20002,v_fehlertext );'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_schema_id := v_fas_pers_schema_id;'||unistr('\000a')||
'   E';

p:=p||'ND IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Sortiment-ID der Wiederverkäufer => Wird nur zur Anlage im WK benutzt => Sortiment wird nur über die Artikel in PL festgelegt und die kommt von GUS'||unistr('\000a')||
'   :FAS_SORTIMENT_ID := 0;'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''Bst. genereller Parameter Wahlident %1; Login-id %2; aktive Ident %3; Schema-kunde:%4, akt.Schema:%5,Sortiment:%6,Person:%7'', v_PROT_ID, ''TEST'', ''aktive_identitaet_pers_schema_sortiment_setzen'',:p110_';

p:=p||'wahl_identitaet,:fas_login_personenstamm_id,'||unistr('\000a')||
'v_identitaet_persstamm_id,:fas_pers_schema_id,:fas_schema_id,:FAS_SORTIMENT_ID,v_persstamm_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6413025932817178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'aktive_identitaet_pers_schema_sortiment_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_VERRECH_LAND_ID        warenkoerbe.VERRECH_LAND_ID%TYPE;'||unistr('\000a')||
'   v_WAEHRUNG_ID            warenkoerbe.WAEHRUNG_ID%TYPE;'||unistr('\000a')||
'   v_MWST_JN                warenkoerbe.MWST_JN%TYPE;'||unistr('\000a')||
'   v_WK_STATUS_ID           warenkoerbe.WK_STATUS_ID%TYPE;'||unistr('\000a')||
'   v_STATUS_AENDERDATUM     warenkoerbe.STATUS_AENDERDATUM%TYPE;'||unistr('\000a')||
'   v_STATUS_AENDERVISUM     warenkoerbe.STATUS_AENDERVISUM%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_RECHNUNG  w';

p:=p||'arenkoerbe.PERSSTAMM_ID_RECHNUNG%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_LOGIN     warenkoerbe.PERSSTAMM_ID_LOGIN%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_LIEFERUNG warenkoerbe.PERSSTAMM_ID_LIEFERUNG%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_prod_apo  warenkoerbe.PERSSTAMM_ID_prod_apo%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechsteller warenkoerbe.PERSSTAMM_ID_prod_apo%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID_identitaet  warenkoerbe.PERSSTAMM_ID_identitaet%TYPE;'||unistr('\000a')||
'   v_PERSSTAMM_ID';

p:=p||'_kunde     warenkoerbe.PERSSTAMM_ID_kunde%TYPE;'||unistr('\000a')||
'   v_extern_verwaltet       warenkoerbe.extern_verwaltet%TYPE;'||unistr('\000a')||
'   v_preislistentyp       preislisten.typ%TYPE;'||unistr('\000a')||
'   v_preislisten_land_id  preislisten.land_id%TYPE;'||unistr('\000a')||
'   v_sortiment_id         sortimente.id%TYPE;   -- NEI 14.02.2011 Sortimentseinfuehrung:'||unistr('\000a')||
'                                                -- sortiment_id statt preislisten_set_id'||unistr('\000a')||
'   v_preisl';

p:=p||'iste_id        preislisten.id%TYPE;'||unistr('\000a')||
'   v_art_mwst_typ_id      preislisten_details.art_mwst_typ_id%TYPE;'||unistr('\000a')||
'   v_preisfaktor          warenkoerbe.preisfaktor%TYPE;'||unistr('\000a')||
'   v_widerrufsfrist       warenkoerbe.widerrufsfrist%TYPE; -- NEI 28.03.12'||unistr('\000a')||
'   v_return               number;'||unistr('\000a')||
''||unistr('\000a')||
'   v_url                  VARCHAR2(2000);'||unistr('\000a')||
'   v_sqlerror             VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlertext           VARCHAR2(2000);'||unistr('\000a')||
'   v';

p:=p||'_fehlernummer         number;'||unistr('\000a')||
'   v_fehler               EXCEPTION;'||unistr('\000a')||
'   v_prot_id              NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p500_warenkorb_tmp_id is null THEN'||unistr('\000a')||
'--mel.p(''In wk_aktualisieren init WK-ID %1'', v_prot_id,''Info'',''102/500:wk_init'',:p500_warenkorb_tmp_id);'||unistr('\000a')||
''||unistr('\000a')||
'-- mel.p(''In wk_aktualisieren init nach holen WK-ID --%1'',v_prot_id,''Info'',''wk_aktualisieren'',:p500_warenkorb_tmp_id);'||unistr('\000a')||
'      -- Info zu Wiederver';

p:=p||'käufer holen'||unistr('\000a')||
'      SELECT 0, -- MWST_JN'||unistr('\000a')||
'             NVL(p.PERSSTAMM_ID_RECHNUNG,:p500_persstamm_id),'||unistr('\000a')||
'             NVL(p.PERSSTAMM_ID_LIEFERUNG,:p500_persstamm_id),'||unistr('\000a')||
'             :fas_login_personenstamm_id'||unistr('\000a')||
'      INTO   v_MWST_JN,v_PERSSTAMM_ID_RECHNUNG,v_PERSSTAMM_ID_LIEFERUNG,v_persstamm_id_login'||unistr('\000a')||
'      FROM personenstamm p'||unistr('\000a')||
'      WHERE p.id = :p500_persstamm_id;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Bestimmung Rechnungsstell';

p:=p||'er'||unistr('\000a')||
'      v_persstamm_id_rechsteller := frgbg_s.WKWV_GEN_RECHNUNGSSTELLER (:p500_persstamm_id );'||unistr('\000a')||
'      IF v_persstamm_id_rechsteller <=0 THEN'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(5499,:fas_sprache_id);'||unistr('\000a')||
'         v_fehlernummer := -70;'||unistr('\000a')||
'         mel.p(''Rechnungssteller kann für den WV-Warenkorb nicht ermittelt werden! Persstamm_id_WV ''||:p500_persstamm_id '||unistr('\000a')||
'                ,v_prot_id,''ER';

p:=p||'ROR'',''102/500:wk_init,''||v_fehlernummer);'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Bestimmung Verrechnungsland'||unistr('\000a')||
'      -- Verrechnungsland_id wird gemaess Rechnungssteller bestimmt'||unistr('\000a')||
'      v_verrech_land_id := rezepte.GET_VERRECHNUNGSLAND_ID(v_persstamm_id_rechsteller, v_persstamm_id_rechsteller);'||unistr('\000a')||
''||unistr('\000a')||
'      -- Bestimmung prod. Apo'||unistr('\000a')||
'      v_persstamm_id_prod_apo := 1430;  -- frgbg_s.get_pers_option';

p:=p||'(:APP_USER,21);'||unistr('\000a')||
''||unistr('\000a')||
'      -- Prüfe Existenz der passenden Preisliste'||unistr('\000a')||
'      v_preislistentyp := rezepte.get_preislisten_typ_wv (:p500_persstamm_id); -- zZ nur id=102 Wiederverkäufer ohne Mwst'||unistr('\000a')||
''||unistr('\000a')||
'      -- Standard-Sortiment Wiederverkäufer'||unistr('\000a')||
'      v_sortiment_id := 0;  '||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''In wk_init 1 waehrung %1, preisfaktor %2, login %3, identitaet %4,verrech %5,pl %6, mwsttyp %7'',v_prot_id,''Info'',''102/500:wk_ini';

p:=p||'t'',v_waehrung_id,v_preisfaktor ,v_PERSSTAMM_ID_LOGIN,:fas_identitaet_persstamm_id, v_verrech_land_id,v_preisliste_id,v_art_mwst_typ_id);'||unistr('\000a')||
'      -- Bestimmung der Preisliste und der Währung anhand des Wiederverkäufers'||unistr('\000a')||
'      BEGIN '||unistr('\000a')||
'         v_preisliste_id :=  rezepte.get_preisliste_id_wv(:p500_persstamm_id,v_preislistentyp,v_waehrung_id,1);'||unistr('\000a')||
'         COMMIT; -- Preislisten-Anlage festschreiben, da Pr';

p:=p||'eisliste laden in autonome TA läuft und diese sonst nicht sieht'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         v_fehlertext :=  frgbg_s.holen_uebersetzung(9176,:fas_sprache_id);'||unistr('\000a')||
'         v_fehlernummer := -80;'||unistr('\000a')||
'         mel.p(''Die Preisliste kann für den WV-Warenkorb nicht ermittelt werden! Persstamm_id_WV ''||:p500_persstamm_id '||unistr('\000a')||
'                ,v_prot_id,''ERROR'',''102/500:wk_init,''||v_fehlernummer';

p:=p||');'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END;'||unistr('\000a')||
'--mel.p(''In wk_init 2 waehrung %1, preisfaktor %2, login %3, identitaet %4,verrech %5,pl %6, mwsttyp %7'',v_prot_id,''Info'',''102/500:wk_init'',v_waehrung_id,v_preisfaktor ,v_PERSSTAMM_ID_LOGIN,:fas_identitaet_persstamm_id,v_verrech_land_id,v_preisliste_id,v_art_mwst_typ_id);'||unistr('\000a')||
''||unistr('\000a')||
'      -- Prüfen, Ladedatum der PL und ggf. Laden'||unistr('\000a')||
'      v_return:= frgbg_at.WS_WV_PL_LAD';

p:=p||'EN(v_preisliste_id);'||unistr('\000a')||
'      IF v_return < 0 THEN'||unistr('\000a')||
'         v_fehlertext :=  frgbg_s.holen_uebersetzung(9176,:fas_sprache_id);'||unistr('\000a')||
'         v_fehlernummer := -85;'||unistr('\000a')||
'         mel.p(''Die Preisliste konnte nicht geladen werden! Persstamm_id_WV ''||:p500_persstamm_id '||unistr('\000a')||
'                ,v_prot_id,''ERROR'',''102/500:wk_init,''||v_fehlernummer);'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Währung nach Laden ermit';

p:=p||'teln, falls sich die Währung von GUS her geändert hat'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         SELECT waehrung_id INTO v_waehrung_id'||unistr('\000a')||
'         FROM preislisten'||unistr('\000a')||
'         WHERE id = v_preisliste_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         mel.p(''Zugriff auf die Preisliste fehlgeschlagen! Persstamm_id_WV (''||:p500_persstamm_id||'')''||SQLERRM '||unistr('\000a')||
'                ,v_prot_id,''ERROR'',''102/500:wk_init,''||-87);'||unistr('\000a')||
'         v_';

p:=p||'fehlertext :=  frgbg_s.holen_uebersetzung(9176,:fas_sprache_id);'||unistr('\000a')||
'         v_fehlernummer := -87;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Art_mwst_typ_id für Mischungen ermitteln => Default wird bei WV-WK nicht benötigt'||unistr('\000a')||
'      v_art_mwst_typ_id := 1;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Preisfaktor => Preis kommen von GUS => kein Preisfaktor'||unistr('\000a')||
'      v_preisfaktor := 1;'||unistr('\000a')||
''||unistr('\000a')||
'      v_PERSSTAMM_ID_kunde    := :p500_persstamm_id;';

p:=p||''||unistr('\000a')||
'      v_PERSSTAMM_ID_identitaet:= :p500_persstamm_id;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'mel.p(''In wk_init waehrung %1, preisfaktor %2, login %3, identitaet %4,verrech %5,pl %6, mwsttyp %7'',v_prot_id,''Info'',''wk_init'',v_waehrung_id,v_preisfaktor ,v_PERSSTAMM_ID_LOGIN,:fas_identitaet_persstamm_id,v_verrech_land_id,v_preisliste_id,v_art_mwst_typ_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      v_widerrufsfrist := frgbg_s.wk_get_widerrufsfrist;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Warenkorb';

p:=p||' initialisieren'||unistr('\000a')||
'      select WARENKORB_tmp_SEQ.nextval into :p500_warenkorb_tmp_id from dual;'||unistr('\000a')||
''||unistr('\000a')||
'      INSERT INTO warenkoerbe_tmp ('||unistr('\000a')||
'                    ID ,'||unistr('\000a')||
'                    PLANDATUM ,'||unistr('\000a')||
'                    VERRECH_LAND_ID,'||unistr('\000a')||
'                    WAEHRUNG_ID,'||unistr('\000a')||
'                    MWST_JN ,'||unistr('\000a')||
'                    WK_STATUS_ID ,'||unistr('\000a')||
'                    STATUS_AENDERDATUM ,'||unistr('\000a')||
'                    STATUS_AENDERVIS';

p:=p||'UM,'||unistr('\000a')||
'                    PERSSTAMM_ID_RECHNUNG,'||unistr('\000a')||
'                    PERSSTAMM_ID_LOGIN,'||unistr('\000a')||
'                    PERSSTAMM_ID_LIEFERUNG ,'||unistr('\000a')||
'                    session_id,'||unistr('\000a')||
'                    persstamm_id_identitaet,'||unistr('\000a')||
'                    persstamm_id_prod_apo,'||unistr('\000a')||
'                    preisliste_id,            '||unistr('\000a')||
'                    art_mwst_typ_id,          '||unistr('\000a')||
'                    preisfaktor               '||unistr('\000a')||
'       ';

p:=p||'             ,persstamm_id_kunde       '||unistr('\000a')||
'                    ,sortiment_id             '||unistr('\000a')||
'                    ,persstamm_id_rechnungssteller '||unistr('\000a')||
'                    ,widerrufsfrist           '||unistr('\000a')||
'                    )'||unistr('\000a')||
'      VALUES (:p500_warenkorb_tmp_id,'||unistr('\000a')||
'              to_date(to_char(sysdate,''DD.MM.YYYY''),''DD.MM.YYYY''),'||unistr('\000a')||
'              v_VERRECH_LAND_ID       ,'||unistr('\000a')||
'              v_WAEHRUNG_ID            ,'||unistr('\000a')||
'      ';

p:=p||'        v_MWST_JN                ,'||unistr('\000a')||
'              10           ,'||unistr('\000a')||
'              sysdate     ,'||unistr('\000a')||
'              :app_user    ,'||unistr('\000a')||
'              v_PERSSTAMM_ID_RECHNUNG  ,'||unistr('\000a')||
'              v_PERSSTAMM_ID_LOGIN     ,'||unistr('\000a')||
'              v_PERSSTAMM_ID_LIEFERUNG,'||unistr('\000a')||
'              :APP_SESSION,'||unistr('\000a')||
'              v_PERSSTAMM_ID_identitaet,'||unistr('\000a')||
'              v_persstamm_id_prod_apo,'||unistr('\000a')||
'              v_preisliste_id,            '||unistr('\000a')||
'      ';

p:=p||'        v_art_mwst_typ_id,          '||unistr('\000a')||
'              v_preisfaktor               '||unistr('\000a')||
'              ,v_PERSSTAMM_ID_kunde         '||unistr('\000a')||
'              ,v_sortiment_id    -- Legt Wiederverkäufer WK´s fest sortiment_id=0         '||unistr('\000a')||
'              ,v_persstamm_id_rechsteller '||unistr('\000a')||
'              ,v_widerrufsfrist           '||unistr('\000a')||
'             ); '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p500_id:=:p500_warenkorb_tmp_id;'||unistr('\000a')||
'   :p500_artikelkategorie:= 0;'||unistr('\000a')||
'  ';

p:=p||' :p500_flag_hide_show:= -1;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Setzen Extern_verwaltet FLAG'||unistr('\000a')||
'   v_extern_verwaltet := frgbg_s.wk_check_extern_verwaltet(:p500_warenkorb_tmp_id,1);'||unistr('\000a')||
'--mel.p(''Extern verwaltete %1'',v_prot_id,''TEST'',''wk_init'',v_extern_verwaltet);'||unistr('\000a')||
'   IF v_extern_verwaltet >=0 THEN'||unistr('\000a')||
'      UPDATE warenkoerbe_tmp'||unistr('\000a')||
'      SET extern_verwaltet = v_extern_verwaltet'||unistr('\000a')||
'      WHERE id = :p500_warenkorb_tmp_id;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      v_feh';

p:=p||'lertext :=  frgbg_s.holen_uebersetzung(5499,:fas_sprache_id);'||unistr('\000a')||
'      v_fehlernummer := -90;'||unistr('\000a')||
'      mel.p(''Fehler beim Bestimmen des WK auf extern/intern verwaltet!'',v_prot_id,''ERROR'',''102/500:wk_init,''||v_fehlernummer);'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''In wk_aktualisieren init WK-ID ENDE %1'', v_prot_id,''Info'',''wk_init'',:p500_warenkorb_tmp_id);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   ROLLBACK;'||unistr('\000a')||
'   v';

p:=p||'_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':''||:P500_ZURUECK_SEITE||'':''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P135_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   apex_application.g_unrecoverable_error := true;   --- stops all further p';

p:=p||'age processing   '||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   v_sqlerror:= SQLERRM;'||unistr('\000a')||
'   ROLLBACK;'||unistr('\000a')||
'   v_fehlertext := frgbg_s.holen_uebersetzung(5499,:fas_sprache_id);'||unistr('\000a')||
'   v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':''||:P500_ZURUECK_SEITE||'':''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P135_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''window.locati';

p:=p||'on.href= "''||v_url||''"'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   mel.p(v_fehlertext||''(SQL: ''||v_sqlerror||'')'',v_prot_id,''ERROR'',''102/300:wk_init'');'||unistr('\000a')||
'   apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6413412812817180 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'wk_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p500_warenkorb_tmp_id is null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :P500_SUCHE IS NOT NULL THEN'||unistr('\000a')||
'      :P500_ARTIKELKATEGORIE := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6413629838817182 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 40,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'switch_artikelkategorie',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'   v_PERSSTAMM_ID_EXTERN_UPD personenstamm.id%TYPE;'||unistr('\000a')||
'   v_extern_typ   VARCHAR2(2);'||unistr('\000a')||
'   v_return       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.p(''Rechnungsadresse eintragen: Pers=%1 id:%2 typ:%3! [page300,extadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'',:p500_id,:p500_persstamm_id_extern_upd,:p500_adresstyp_extern);'||unistr('\000a')||
'   v_PERSSTAMM_ID_EXTERN_UPD := :P500_persstamm_id_extern_upd;'||unistr('\000a')||
'   v_e';

p:=p||'xtern_typ   := :p500_adresstyp_extern;'||unistr('\000a')||
'   :P500_persstamm_id_extern_upd := NULL;'||unistr('\000a')||
'   :P500_adresstyp_extern:= NULL;'||unistr('\000a')||
'   IF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''R'' THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET persstamm_id_rechnung = v_PERSSTAMM_ID_EXTERN_UPD'||unistr('\000a')||
'         WHERE id = :p500_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         MEL.p(''Rechnungsadresse spei';

p:=p||'chern: WK=%1 id:%2! Fehler:%3 [page300,Rechnungsadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'',:p500_id,v_PERSSTAMM_ID_EXTERN_UPD, SQLERRM);'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSIF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''L'' THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET persstamm_id_lieferung = v_PERSSTAMM_ID_EXTERN_UPD'||unistr('\000a')||
'         WHERE id = :p500_id;'||unistr('\000a')||
'         -- Neue Versandkosten ermi';

p:=p||'tteln'||unistr('\000a')||
'         --v_return := frgbg_s.WK_GEN_VERSANDKOSTEN( :p500_id,1) ;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         MEL.p(''Lieferadresse speichern: WK=%1 id:%2! Fehler:%3 [page300,Lieferadresse speichern]'','||unistr('\000a')||
'               v_PROT_ID, ''ERROR'', ''fas'',:p500_id,v_PERSSTAMM_ID_EXTERN_UPD, SQLERRM);'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSIF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''P'' THEN'||unistr('\000a')||
'      -- 6.12.1';

p:=p||'0 Wechsel des Patient eigentlich nicht mehr möglich, da nur noch Patientenstamm'||unistr('\000a')||
'      -- aenderbar => wk verlassen u. korrekten Patient auswaehlen'||unistr('\000a')||
'      :P500_PERSSTAMM_ID:= v_PERSSTAMM_ID_EXTERN_UPD; '||unistr('\000a')||
'   ELSIF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''RS'' THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET persstamm_id_rechnungssteller = v_PERSSTAMM_ID_EXTERN_UPD'||unistr('\000a')||
'       ';

p:=p||'  WHERE id = :p500_id;'||unistr('\000a')||
'         -- Neue Versandkosten ermitteln'||unistr('\000a')||
'         --v_return := frgbg_s.WK_GEN_VERSANDKOSTEN( :p500_id,1);'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         MEL.p(''Rechnungssteller speichern: WK=%1 id:%2! Fehler:%3 [page300,Rechnungssteller speichern]'','||unistr('\000a')||
'               v_PROT_ID, ''ERROR'', ''fas'',:p500_id,v_PERSSTAMM_ID_EXTERN_UPD, SQLERRM);'||unistr('\000a')||
'      END; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6413805589817182 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'externe_adressen_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p500_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND :p500_adresstyp_extern is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_name   VARCHAR2(1000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P500_PERSSTAMM_ID is not null  THEN'||unistr('\000a')||
'      SELECT NAME||'' ''||VORNAME ||'' ''||to_char(GEBURTSDATUM,''DD.MM.RRRR''), gewicht, groesse'||unistr('\000a')||
'      INTO v_name, :p500_gewicht, :p500_groesse'||unistr('\000a')||
'      from personenstamm'||unistr('\000a')||
'      where id = :P500_PERSSTAMM_ID;'||unistr('\000a')||
'      :p500_name := v_name;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6414019079817183 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_person',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   DELETE FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id =  :p500_warenkorb_tmp_id'||unistr('\000a')||
'     AND mengenart_id = 101;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8138101824889665 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 65,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'delete_versandkosten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'p300_warenkorb_tmp_id',
  p_process_when_type=>'',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_waehrung_id          warenkoerbe_tmp.waehrung_id%TYPE;'||unistr('\000a')||
'   v_liefer_land_id       laender.id%TYPE;'||unistr('\000a')||
'   v_verrech_land_id      warenkoerbe_tmp.verrech_land_id%TYPE;'||unistr('\000a')||
'   v_preislistentyp       preislisten.typ%TYPE;'||unistr('\000a')||
'   v_preislisten_land_id  preislisten.land_id%TYPE;'||unistr('\000a')||
'   v_sortiment_id         sortimente.id%TYPE; -- NEI 14.02.2011 Sortimentseinfuehrung: '||unistr('\000a')||
'                                     ';

p:=p||'         -- sortiment_id statt preislisten_set_id'||unistr('\000a')||
'   v_preisliste_id        preislisten.id%TYPE;'||unistr('\000a')||
'   v_art_mwst_typ_id      preislisten_details.art_mwst_typ_id%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechsteller personenstamm.id%type;'||unistr('\000a')||
'   v_persstamm_id_lieferung   personenstamm.id%type;'||unistr('\000a')||
'   v_verrech_land_id_db       warenkoerbe_tmp.verrech_land_id%TYPE;'||unistr('\000a')||
'   v_waehrung_id_db           warenkoerbe_tmp.waehrung_id%TYP';

p:=p||'E;'||unistr('\000a')||
'   v_preisliste_id_db         warenkoerbe_tmp.preisliste_id%TYPE;      '||unistr('\000a')||
'   v_persstamm_id_prod_apo    warenkoerbe_tmp.persstamm_id_prod_apo%TYPE;'||unistr('\000a')||
'   v_persstamm_id_identitaet  warenkoerbe_tmp.persstamm_id_identitaet%TYPE;'||unistr('\000a')||
'   v_persstamm_id_rechnung    warenkoerbe_tmp.persstamm_id_rechnung%TYPE;'||unistr('\000a')||
'   v_persstamm_id_kunde       warenkoerbe_tmp.persstamm_id_kunde%TYPE;'||unistr('\000a')||
'   v_aerztlich_verordnet      ';

p:=p||'warenkoerbe_tmp.aerztlich_verordnet%TYPE;'||unistr('\000a')||
'   v_anz                      NUMBER;'||unistr('\000a')||
''||unistr('\000a')||
'   v_fehler            exception;'||unistr('\000a')||
'   v_return            NUMBER;'||unistr('\000a')||
'   v_prot_id           NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*MEL.P (''vor check_waerhung:MaskeWaehr %1,MaskeVerrech %2,WK_tmp_id %3, %4, %5, %6, %7'','||unistr('\000a')||
'           v_prot_id,''Info'',''change_waehrung 102/300'','||unistr('\000a')||
'          :p500_waehrung_id,:P500_VERRECH_LAND_ID,'||unistr('\000a')||
'          :p500_waren';

p:=p||'korb_tmp_id);   '||unistr('\000a')||
'*/'||unistr('\000a')||
'-- ACHTUNG: Zur Zeit wird keine entsprechende Änderung im Wiederverkäufer WK (Währung, verrechnland etc) durchgeführt) => keine Neuberechnung notwendig'||unistr('\000a')||
''||unistr('\000a')||
'RETURN;'||unistr('\000a')||
''||unistr('\000a')||
'   IF :p500_warenkorb_tmp_id is not null THEN'||unistr('\000a')||
'      -- Prüfen, ob die angezeigte Währung noch die aktuell gültige ist'||unistr('\000a')||
'      -- Verrechnungsland bestimmen und entsprechende Währung holen'||unistr('\000a')||
'      --SELECT NVL(min(land_id),';

p:=p||'198), into v_liefer_land_id'||unistr('\000a')||
'      SELECT persstamm_id_lieferung, persstamm_id_rechnungssteller,verrech_land_id,waehrung_id, '||unistr('\000a')||
'             persstamm_id_prod_apo,persstamm_id_identitaet,persstamm_id_rechnung,v_persstamm_id_kunde,preisliste_id,aerztlich_verordnet'||unistr('\000a')||
'      INTO v_persstamm_id_lieferung,v_persstamm_id_rechsteller,v_verrech_land_id_db,v_waehrung_id_db,'||unistr('\000a')||
'             v_persstamm_id_prod_apo,';

p:=p||'v_persstamm_id_identitaet,v_persstamm_id_rechnung,v_persstamm_id_kunde,v_preisliste_id_db,v_aerztlich_verordnet'||unistr('\000a')||
'      FROM warenkoerbe_tmp wk'||unistr('\000a')||
'      WHERE wk.id = :p500_warenkorb_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'      v_verrech_land_id := rezepte.get_verrechnungsland_id '||unistr('\000a')||
'                            (v_persstamm_id_lieferung,v_persstamm_id_rechsteller);'||unistr('\000a')||
''||unistr('\000a')||
'      -- NEI 13.06.13 Falls es sich um einen reinen Laboranalysen han';

p:=p||'delt soll das Verrechnungsland immer CH sein => Diese Dienstleistungen die CH-Preise und Mwst '||unistr('\000a')||
'      -- Pruefen, ob details vorhanden sind, falls keine Details, dann aerztlich_verordnet = 0'||unistr('\000a')||
'      IF :p500_sa_auftragsnummer is not null THEN  -- Laboranalyseauftrag'||unistr('\000a')||
'         v_verrech_land_id := 198;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      v_waehrung_id := rezepte.get_id_waehrung(v_verrech_land_id);'||unistr('\000a')||
''||unistr('\000a')||
'      -- Prüfe Exi';

p:=p||'stenz der passenden Preisliste; ggf. wird die Waehrung und das'||unistr('\000a')||
'      -- Verrechnungsland-ID,Typ  an die Standardpreisliste angepasst'||unistr('\000a')||
'      v_preislistentyp := rezepte.get_preislisten_typ (      -- NEI 06.05.13 Einfuehrung mit/ohne Mwst PL'||unistr('\000a')||
'                v_VERRECH_LAND_ID,'||unistr('\000a')||
'                v_persstamm_id_rechsteller,'||unistr('\000a')||
'                v_persstamm_id_prod_apo,'||unistr('\000a')||
'                v_persstamm_id_identitaet';

p:=p||','||unistr('\000a')||
'                v_persstamm_id_kunde,'||unistr('\000a')||
'                v_persstamm_id_rechnung,'||unistr('\000a')||
'                v_persstamm_id_lieferung );'||unistr('\000a')||
''||unistr('\000a')||
'      v_sortiment_id := NVL(v(''FAS_SORTIMENT_ID''),         -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'                              rezepte.GET_SORTIMENT_STD);  -- Standard-Sortiment der oberste Ident.'||unistr('\000a')||
'      v_preisliste_id := rezepte.get_preisliste_id(v_waehrung_id,v_verrech_';

p:=p||'land_id,'||unistr('\000a')||
'                                                   v_preislistentyp,v_sortiment_id); '||unistr('\000a')||
'      -- Art_mwst_typ_id für Mischungen ermitteln'||unistr('\000a')||
'      /*'||unistr('\000a')||
'      SELECT min(art_mwst_typ_id) into v_art_mwst_typ_id'||unistr('\000a')||
'      FROM laender'||unistr('\000a')||
'      WHERE id = v_verrech_land_id; '||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_art_mwst_typ_id := 1;'||unistr('\000a')||
'/*MEL.P (''check_waerhung nach holen :Waehrneu %1,Verrechneu %2,WK_tmp_id %3, Waehralt %4, verr';

p:=p||'echalt %5, %6, %7'','||unistr('\000a')||
'           v_prot_id,''Info'',''change_waehrung 102/300'','||unistr('\000a')||
'          v_waehrung_id,v_verrech_land_id,'||unistr('\000a')||
'          :p500_warenkorb_tmp_id,v_waehrung_id_db,v_verrech_land_id_db);   '||unistr('\000a')||
'*/'||unistr('\000a')||
'      -- Pruefen, ob details vorhanden sind, falls keine Details, dann aerztlich_verordnet = 0'||unistr('\000a')||
'      SELECT count(*) INTO v_anz'||unistr('\000a')||
'      from warenkorb_details_tmp wkd'||unistr('\000a')||
'      where wkd.warenkorb_tmp_id = :p5';

p:=p||'00_warenkorb_tmp_id;'||unistr('\000a')||
'      IF v_anz = 0 THEN'||unistr('\000a')||
'         :p500_aerztlich_verordnet := 0;  '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Änderung feststellen'||unistr('\000a')||
'      IF v_verrech_land_id != v_verrech_land_id_db OR'||unistr('\000a')||
'         v_waehrung_id != v_waehrung_id_db OR'||unistr('\000a')||
'         v_preisliste_id != v_preisliste_id_db OR'||unistr('\000a')||
'         v_aerztlich_verordnet != :p500_aerztlich_verordnet'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         -- Warenkorb bzgl. Währung aktualisie';

p:=p||'ren'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET  waehrung_id = v_waehrung_id,'||unistr('\000a')||
'              verrech_land_id = v_verrech_land_id,'||unistr('\000a')||
'              preisliste_id  = v_preisliste_id,'||unistr('\000a')||
'              art_mwst_typ_id = v_art_mwst_typ_id,'||unistr('\000a')||
'              aerztlich_verordnet = :p500_aerztlich_verordnet'||unistr('\000a')||
'         WHERE id = :p500_warenkorb_tmp_id;'||unistr('\000a')||
'         -- Details gemäss neuer Währung berechnen'||unistr('\000a')||
'         v_ret';

p:=p||'urn := frgbg_s.wk_calc_details(:p500_warenkorb_tmp_id,1,1,'||unistr('\000a')||
'                                             1 -- NEI 18.06.14 keine Reichweitenstaffel-Rabattberechnung (=0) für Mischungen,'||unistr('\000a')||
'                                               --              nur  noch im WK und auf Bestellschein sonst keine Rabattrechnung'||unistr('\000a')||
'                                            );'||unistr('\000a')||
'         IF v_return < 0 THEN'||unistr('\000a')||
'          ';

p:=p||'  NULL;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''check_waerhung toggle:Mwsttyp %1, waehralt %2, maskeverrech %3, verrechneu%4, waehrneu%5, Return %6, PL:%7'','||unistr('\000a')||
'           v_prot_id,''Info'',''change_waehrung 102/300'','||unistr('\000a')||
'           v_art_mwst_typ_id,:p500_waehrung_id,:p500_verrech_land_id, v_verrech_land_id,     '||unistr('\000a')||
'           v_waehrung_id,v_return,v_preisliste_id); '||unistr('\000a')||
'*/           '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6414200176817183 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_waehrung_neu',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:WARENKOERBE_TMP:P500_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 6414406954817190 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 80,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from WARENKOERBE_TMP',
  p_process_sql_clob => p,
  p_process_error_message=> 'fehler in row select #SQLERRM# &P500_WARENKORB_TMP_ID.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p500_warenkorb_tmp_id is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_gus_id     personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_anz        number;'||unistr('\000a')||
'   v_url        VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* Zukuenftig muessen die Identitaeten immer eine GUS-ID haben */'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT gus_id INTO v_gus_id'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :P500_PERSSTAMM_ID; -- Wiederverkäufer-Ident'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_gus_id IS NULL OR        -- Identität hat keine GUS-ID'||unistr('\000a')||
'      --';

p:=p||' Betreuer hat keine Berechtigung eine Eigenbestellung für die Ident auszuführen'||unistr('\000a')||
'      frgbg_s.wkwv_check_zugriff (:FAS_LOGIN_PERSONENSTAMM_ID ,:P500_PERSSTAMM_ID) = 0 '||unistr('\000a')||
'   THEN  '||unistr('\000a')||
'      --v_fehlertext := ''Wenn Sie die Warenkorb-Funktion nutzen wollen beantragen sie bitte einen Zugang bei Ihrem Kundenberater!'';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(5498,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   sel';

p:=p||'ect count(*) INTO v_anz '||unistr('\000a')||
'   from preislisten_details pd, mengenarts m1,warenkoerbe_tmp wk'||unistr('\000a')||
'   where pd.mengenart_id = m1.id'||unistr('\000a')||
'        and m1.id = pd.mengenart_id'||unistr('\000a')||
'        and m1.satz_kennzeichen is null'||unistr('\000a')||
'        and wk.id = :p500_warenkorb_tmp_id'||unistr('\000a')||
'        and pd.preisliste_id = wk.preisliste_id'||unistr('\000a')||
'        and pd.GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND pd.GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND';

p:=p||' pd.MIN_MENGE <= 1'||unistr('\000a')||
'        AND pd.MAX_MENGE >= 1'||unistr('\000a')||
'        AND pd.preis >= 0'||unistr('\000a')||
'        and pd.satz_kennzeichen is null;'||unistr('\000a')||
'   IF v_anz = 0 THEN'||unistr('\000a')||
'      --v_fehlertext := ''Keine Bestellartikel vorhanden!'';	9176'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(9176,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF v_fehlertext is not null THEN'||unistr('\000a')||
'      v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':''||'||unistr('\000a')||
'                    ';

p:=p||'                 :P500_ZURUECK_SEITE||'||unistr('\000a')||
'                                    -- v(''P''||:P500_ZURUECK_SEITE||''_ZURUECK_ZUR_SEITE'')||'||unistr('\000a')||
'                                     '':''||:APP_SESSION||''::::''||'||unistr('\000a')||
'                                     ''P''||:P500_ZURUECK_SEITE||''_HINWEIS''||'||unistr('\000a')||
'                                     '':''|| v_fehlertext);'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'';

p:=p||'      htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'      apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'/*      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      --htp.p('||unistr('\000a')||
'      htp.p(''window.opener.location.href="f?p=&APP_ID.:130:&SESSION.";'');'||unistr('\000a')||
'      htp.p(''window.close(this);'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'   ';

p:=p||'   --apex_application.stop_apex_engine;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 6413217715817180 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 85,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_zugang',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p500_gesamtwert := to_char('||unistr('\000a')||
'NVL(to_number(:p500_gesamtpreis,''999G999G999G999G990D00''),0) + '||unistr('\000a')||
'NVL(to_number(:p500_mwst_betrag_1,''999G999G999G999G990D00''),0)+ '||unistr('\000a')||
'NVL(to_number(:p500_mwst_betrag_2,''999G999G999G999G990D00''),0),''999G999G999G999G990D00'') ;';

wwv_flow_api.create_page_process(
  p_id     => 6411000543817171 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 500,
  p_process_sequence=> 90,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_wk_gesamtwert',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 500
--
 
begin
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18577416908727690 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 1,
  p_query_column_name=> 'ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18577511932727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 2,
  p_query_column_name=> 'ID_DISPLAY',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18577600279727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 3,
  p_query_column_name=> 'WARENKORB_TMP_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18577730906727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 4,
  p_query_column_name=> 'PRODKENNZ_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18577831684727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 5,
  p_query_column_name=> 'P_REZEPT_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18577906482727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 6,
  p_query_column_name=> 'MENGENART_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578001858727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 7,
  p_query_column_name=> 'MENGE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578132480727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 8,
  p_query_column_name=> 'VOLUMEN',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578232574727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 9,
  p_query_column_name=> 'GEWICHT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578307922727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 10,
  p_query_column_name=> 'PREIS',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578429188727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 11,
  p_query_column_name=> 'MWST_BETRAG',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578511115727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 12,
  p_query_column_name=> 'MWST_SATZ',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578628345727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 13,
  p_query_column_name=> 'WK_STATUS_ID',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578700842727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 14,
  p_query_column_name=> 'STATUS_AENDERDATUM',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578811277727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 15,
  p_query_column_name=> 'STATUS_AENDERVISUM',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18578913775727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 16,
  p_query_column_name=> 'ETIKETTENTYP',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579021055727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 17,
  p_query_column_name=> 'BEMERKUNG',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579108217727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 18,
  p_query_column_name=> 'ERFDAT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579225937727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 19,
  p_query_column_name=> 'ERFUSER',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579305257727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 20,
  p_query_column_name=> 'MUTDAT',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579411437727691 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 21,
  p_query_column_name=> 'MUTUSER',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579526769727692 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 22,
  p_query_column_name=> 'REZEPT_NR',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579605048727692 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 23,
  p_query_column_name=> 'KUERZEL',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579702238727692 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 24,
  p_query_column_name=> 'EINZELPREIS_BRUTTO',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579827392727692 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 25,
  p_query_column_name=> 'GESAMTPREIS_BRUTTO',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18579907187727692 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 26,
  p_query_column_name=> 'VERORD_LINK',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
wwv_flow_api.create_region_rpt_cols (
  p_id     => 18580015369727692 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_plug_id=> 6402804900817140 + wwv_flow_api.g_id_offset,
  p_column_sequence=> 27,
  p_query_column_name=> 'REICHWEITE',
  p_display_as=> 'TEXT',
  p_column_comment=> '');
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00505
prompt  ...PAGE 505: Warenkorb_WV_Kasse
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 505
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Warenkorb_WV_Kasse'
 ,p_step_title => 'Warenkorb_WV_Kasse'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Warenkorb_WV_Kasse'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140711112409'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7161714091917885 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 505,
  p_plug_name=> '&P505_REGION_TITEL_KASSE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 5,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':request not in (''BESTELL_ERROR'',''BESTELL_OK'',''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_SPEICHERN'',''WINDOW_CLOSE_PAY_CANCEL''   ) OR :request is NULL',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'wkd."ID",'||unistr('\000a')||
'wkd."ID" ID_DISPLAY,'||unistr('\000a')||
'wkd."WARENKORB_TMP_ID",'||unistr('\000a')||
'wkd."PRODKENNZ_ID",'||unistr('\000a')||
'wkd."P_REZEPT_ID",'||unistr('\000a')||
'wkd."MENGENART_ID",'||unistr('\000a')||
'wkd."MENGE",'||unistr('\000a')||
'wkd."VOLUMEN",'||unistr('\000a')||
'wkd."GEWICHT",'||unistr('\000a')||
'wkd."PREIS",'||unistr('\000a')||
'wkd."MWST_BETRAG",'||unistr('\000a')||
'wkd."MWST_SATZ",'||unistr('\000a')||
'wkd."WK_STATUS_ID",'||unistr('\000a')||
'wkd."STATUS_AENDERDATUM",'||unistr('\000a')||
'wkd."STATUS_AENDERVISUM",'||unistr('\000a')||
'wkd."ETIKETTENTYP",'||unistr('\000a')||
'wkd."BEMERKUNG",'||unistr('\000a')||
'wkd."ERFDAT",'||unistr('\000a')||
'wkd."ERFUSER",'||unistr('\000a')||
'wkd."MUTDAT",'||unistr('\000a')||
'wkd."MUTUSER",'||unistr('\000a')||
'  pr.rezept_nr||DECO';

s:=s||'DE(pr.version,NULL,NULL,''/''||pr.version) rezept_nr,'||unistr('\000a')||
'  CASE WHEN wkd.PRODKENNZ_ID = 1 THEN -- HCK-Mischung'||unistr('\000a')||
'      frgbg_s.get_pers_name_rezept(p_rezept_id)|| ''</br>''||'||unistr('\000a')||
'      frgbg_s.holen_uebersetzung(585,:fas_sprache_id)||'': ''||wkd.reichweite||'||unistr('\000a')||
'      DECODE (rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version),0,'''','||unistr('\000a')||
'         ''</br>''||fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',rezepte.GE';

s:=s||'T_MNR_REZART_ID(pr.REZEPT_NR,pr.version)'||unistr('\000a')||
'      ,:fas_sprache_id))'||unistr('\000a')||
'  ELSE '||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)|| ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'  END kuerzel,'||unistr('\000a')||
'  TRUNC(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2) einzelpreis_brutto,'||unistr('\000a')||
' (trunc(NVL(wkd.PREIS,';

s:=s||'0) + NVL(wkd.MWST_BETRAG,0),2))*NVL(wkd.MENGE,0)'||unistr('\000a')||
'               gesamtpreis_brutto'||unistr('\000a')||
'from WARENKORB_DETAILS_TMP wkd , prod_rezepte pr, mengenarts m'||unistr('\000a')||
'where warenkorb_tmp_id = :p505_warenkorb_tmp_id'||unistr('\000a')||
'  and p_rezept_id = pr.id (+)'||unistr('\000a')||
'  and mengenart_id = m.id (+)'||unistr('\000a')||
'  and (wkd.mengenart_id is NULL or wkd.mengenart_id != 101)'||unistr('\000a')||
'order by wkd.id';

wwv_flow_api.create_report_region (
  p_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 505,
  p_name=> '&P505_REGION_TITEL_WARENKORB.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_display_when_condition=> ':request not in (''BESTELL_ERROR'',''BESTELL_OK'','||unistr('\000a')||
'''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_SPEICHERN'',''WINDOW_CLOSE_PAY_CANCEL'') or :request is NULL',
  p_display_condition_type=> 'PLSQL_EXPRESSION',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P305_HEIGHT_WARENKORB.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3081,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '100',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7169908051917915 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170013713917918 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170107269917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID_DISPLAY',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID_DISPLAY',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170223994917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_TMP_ID',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WARENKORB_TMP_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170328423917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PRODKENNZ_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170430737917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'P_REZEPT_ID',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'P_REZEPT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170528135917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170614648917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_inline_lov=> '1,2,3,4,5,6,7,8,9,10',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '5',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170705015917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'VOLUMEN',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'VOLUMEN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170825449917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'GEWICHT',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'GEWICHT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7170901134917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'PREIS',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PREIS',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171007085917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_BETRAG',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_BETRAG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171127390917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_SATZ',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_SATZ',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171219012917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS_ID',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WK_STATUS_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171312385917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERDATUM',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERDATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171425627917921 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERVISUM',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERVISUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171505305917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'ETIKETTENTYP',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ETIKETTENTYP',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171621402917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '20',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'BEMERKUNG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171729037917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'ERFDAT',
  p_column_display_sequence=> 23,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171803378917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'ERFUSER',
  p_column_display_sequence=> 24,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7171918951917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'MUTDAT',
  p_column_display_sequence=> 25,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7172016506917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'MUTUSER',
  p_column_display_sequence=> 26,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7172104551917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'NEVER',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7172206326917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7172300833917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'EINZELPREIS_BRUTTO',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7172412313917922 + wwv_flow_api.g_id_offset,
  p_region_id=> 7169706828917912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'GESAMTPREIS_BRUTTO',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7174319623917926 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 505,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':p505_bestell_status = ''KASSE''',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7174524596917927 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 505,
  p_plug_name=> '&P505_REGION_TITEL_BESTELLINFO.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 25,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':request in (''BESTELL_ERROR'',''BESTELL_OK'','||unistr('\000a')||
'''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_SPEICHERN'',''WINDOW_CLOSE_PAY_CANCEL'')',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 7161929045917888 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 505,
  p_button_sequence=> 10,
  p_button_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P505_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7162131857917891 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 505,
  p_button_sequence=> 40,
  p_button_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_button_name    => 'BESTELLEN',
  p_button_action  => 'DEFINED_BY_DA',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P505_BL_BESTELLEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   SELECT count(* )'||unistr('\000a')||
'   INTO v_anz'||unistr('\000a')||
'   FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id=:P505_WARENKORB_TMP_ID;'||unistr('\000a')||
'   IF v_anz >0 --and :P505_persstamm_id_prod_apo = 1430  Wiederverkäufer immer bestellen'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7162311026917891 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 505,
  p_button_sequence=> 50,
  p_button_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_button_name    => 'BESTELLEN_GUS',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'GUS Bestellen',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'DECLARE'||unistr('\000a')||
'   v_anz NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'RETURN FALSE; -- Kein GUS-BEstellen button mehr'||unistr('\000a')||
'/*'||unistr('\000a')||
'   SELECT count(* )'||unistr('\000a')||
'   INTO v_anz'||unistr('\000a')||
'   FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id=:P505_WARENKORB_TMP_ID;'||unistr('\000a')||
'   IF v_anz >0 and :P505_persstamm_id_prod_apo = 1430 '||unistr('\000a')||
'      --and frgbg_s.check_fas_rolle(:APP_USER,''GUS_BESTELLUNG_AUSLOESEN'')> 0 -- immer GUS-Bestellen'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      RETURN true;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN false;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'END;',
  p_button_condition_type=> 'FUNCTION_BODY',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>7176825216917940 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P505_ZURUECK_SEITE.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7161929045917888+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>7177008164917942 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:505:&SESSION.:BESTELL_OK:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 20,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BESTELLEN'',''BESTELLEN_GUS'') and '||unistr('\000a')||
':p505_bestell_status=''BESTELL_OK'' and'||unistr('\000a')||
':p505_zahlungsart in (1,3) /* Rechnung/Vorkasse */',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-JAN-2011 09:55 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>7177225614917942 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:220:&SESSION.:BRANCH_TO_PAGE_ACCEPT|START:&DEBUG.:220:P220_WARENKORB_ID,P220_ZURUECK_SEITE:&P505_WARENKORB_ID.,&APP_PAGE_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 25,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BESTELLEN'',''BESTELLEN_GUS'') '||unistr('\000a')||
'AND :p505_zahlungsart in (2) /* Kreditkarte */'||unistr('\000a')||
'AND :p505_bestell_status = ''BESTELL_OK''',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 27-SEP-2010 10:40 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>7177407251917943 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:505:&SESSION.:BESTELL_ERROR:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 30,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BESTELLEN'',''BESTELLEN_GUS'') and '||unistr('\000a')||
':p505_bestell_status=''BESTELL_ERROR''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-JAN-2011 09:55 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>7177601507917943 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P505_ZURUECK_SEITE_NACH_BEST.:&SESSION.::&DEBUG.:305,300::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7174932411917927+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 40,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p505_bestell_status = ''BESTELL_ERROR''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-JAN-2011 10:26 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>7177829236917943 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P505_ZURUECK_SEITE_NACH_BEST.:&SESSION.::&DEBUG.:305,300::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7174932411917927+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 50,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p505_bestell_status = ''BESTELL_OK''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-JAN-2011 10:26 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>7178011735917943 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:505:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7162521338917892 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_MWST_LABEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 300,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7162729884917894 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_ZAHLUNGSART',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_RADIOGROUP',
  p_lov=> 'SELECT fas_synch.get_tab_uebersetzung(''WK_ZAHLUNGSARTEN.BEZEICHNUNG'','||unistr('\000a')||
'                                       ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'       id'||unistr('\000a')||
'FROM WK_ZAHLUNGSARTEN'||unistr('\000a')||
'WHERE satz_kennzeichen is null '||unistr('\000a')||
'  and frgbg_s.WK_CHECK_ZAHLUNGSART(id)=1'||unistr('\000a')||
'order by sortierung',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => '1',
  p_attribute_02 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7162921526917896 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_PERSSTAMM_ID_KUNDE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id',
  p_source=>'PERSSTAMM_ID_KUNDE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7163116195917896 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'DECLARE'||unistr('\000a')||
'   v_name   VARCHAR2(1000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P505_PERSSTAMM_ID_KUNDE is not null THEN'||unistr('\000a')||
'      SELECT NAME||'' ''||VORNAME ||'' ''||to_char(GEBURTSDATUM,''DD.MM.RRRR'')'||unistr('\000a')||
'      INTO v_name'||unistr('\000a')||
'      from personenstamm'||unistr('\000a')||
'      where id = :P505_PERSSTAMM_ID_KUNDE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN v_name;'||unistr('\000a')||
'END;',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7163308943917898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 139,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7163520016917898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_REGION_TITEL_KASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Eingabe',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7163732690917898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_REGION_TITEL_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7163929039917898 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_BL_BESTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Zur Kasse',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7164117109917899 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_HEIGHT_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 180,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Height Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7164310833917899 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7164527338917899 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 23,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Plandatum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7164731750917900 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land Id',
  p_source=>'VERRECH_LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7164920126917900 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 22,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Waehrung Id',
  p_source=>'WAEHRUNG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7165120200917900 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtpreis',
  p_source=>'GESAMTPREIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7165311000917901 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_MWST_JN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Jn',
  p_source=>'MWST_JN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7165531525917901 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_MWST_BETRAG_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 1',
  p_source=>'MWST_BETRAG_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7165707438917903 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_MWST_BETRAG_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 2',
  p_source=>'MWST_BETRAG_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7165904775917903 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_MWST_SATZ_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 1',
  p_source=>'MWST_SATZ_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7166119252917904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_MWST_SATZ_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 2',
  p_source=>'MWST_SATZ_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7166311095917904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_WK_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wk Status Id',
  p_source=>'WK_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7166501286917904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_STATUS_AENDERDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aenderdatum',
  p_source=>'STATUS_AENDERDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7166702562917904 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_STATUS_AENDERVISUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aendervisum',
  p_source=>'STATUS_AENDERVISUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7166907524917905 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 140,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7167129584917905 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Login',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7167314004917905 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 160,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7167525933917905 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_REGION_TITEL_ADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 122,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7167715911917906 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 210,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7167922124917906 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_WAHL_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 220,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wahl Identitaet',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7168129945917906 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_NV_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 230,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7168315383917909 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_BESTELL_STATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bestell Status',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7168514047917909 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_NV_WK_KASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Wk Kasse',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7168709892917909 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_REGION_TITEL_BESTELLINFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 123,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Bestellinfo',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7168915131917910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_ZURUECK_SEITE_NACH_BEST',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 215,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7169116837917910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_PERSSTAMM_ID_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 290,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Ident',
  p_source=>'PERSSTAMM_ID_IDENTITAET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7169327133917910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 310,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7169506865917910 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 320,
  p_item_plug_id => 7161714091917885+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7172525764917923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_WARENKORB_TMP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 7169706828917912+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb-ID',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7172718222917923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_GESAMTWERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 7169706828917912+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'to_char(trunc(NVL(:p505_gesamtpreis,0) + NVL(:p505_mwst_betrag_1,0)+ NVL(:p505_mwst_betrag_2,0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P505_GESAMTWERT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7172926231917924 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_GESAMT_MWST_BETRAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 7169706828917912+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'to_char(trunc(NVL(:p505_mwst_betrag_1,0) + NVL(:p505_mwst_betrag_2,0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7173103612917924 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_WAEHRUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 7169706828917912+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'&#160',
  p_post_element_text=>'&#160&P505_MWST_LABEL.',
  p_source=>'rezepte.get_waehrung_zeichen(:p505_waehrung_id);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7173317397917925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_ETTIKETTENTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 7169706828917912+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ettikettentyp',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,1);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7173526574917925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_VERSANDKOSTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 7169706828917912+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'SELECT to_char(NVL(sum(preis+mwst_betrag),0),''999G999G999G999G990D00'')'||unistr('\000a')||
'       ||''  ''||:P505_WAEHRUNG'||unistr('\000a')||
'from warenkorb_details_tmp'||unistr('\000a')||
'where warenkorb_tmp_id = :p505_warenkorb_tmp_id'||unistr('\000a')||
'  and mengenart_id = 101;',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7173715181917925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_WARENKORB_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 215,
  p_item_plug_id => 7169706828917912+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7173905922917925 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_WK_VERSANDART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7169706828917912+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'(',
  p_post_element_text=>')',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7174110600917926 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_SORTIMENT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 7169706828917912+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'SORTIMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7174708086917927 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_BESTELLHINWEIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 250,
  p_item_plug_id => 7174524596917927+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7174932411917927 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 505,
  p_name=>'P505_HINWEIS_OK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 260,
  p_item_plug_id => 7174524596917927+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BESTELL_ENDE',
  p_prompt=>'OK',
  p_source=>'BESTELL_ENDE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 7175212045917929 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 505,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_kunde_adressen_vollstaendigkeit',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_gus_id       personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_extern_verwaltet warenkoerbe.extern_verwaltet%TYPE;'||unistr('\000a')||
'   v_prot_id      number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/300: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Kunderadresse müssen vollständig sein, wenn der Auftrag an GUS geht und noch keine GUS-ID für den Kunden vorhanden ist, sonst kann GUS den Kunden nicht anlegen'||unistr('\000a')||
'   -- holen der Kundenadr. aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          p.gus_id,wk.extern_verwaltet'||unistr('\000a')||
'   INTO v_plz, v_ort, v_land_id,v_strasse,v_name,v_vorname,'||unistr('\000a')||
'        v_gus_id,v_extern_verwaltet'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p505_id'||unistr('\000a')||
'     AND wk.persstamm_id_kunde =p.id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF v_gus_id is NULL AND :request = ''BESTELLEN_GUS'' AND'||unistr('\000a')||
'      (v_plz is NULL OR v_ort is NULL OR v_land_id IS NULL OR '||unistr('\000a')||
'       v_strasse IS NULL OR v_name IS NULL OR v_vorname IS NULL'||unistr('\000a')||
'      )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Kundenadresse ist unvollständig! Die Felder Name, Vorname, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5901,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 7162311026917891 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 9447202078082711 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 505
 ,p_name => 'Submit Page Button: BESTELLEN'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 7162131857917891 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 9447501885082739 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 505
 ,p_event_id => 9447202078082711 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SUBMIT_PAGE'
 ,p_attribute_01 => 'BESTELLEN'
 ,p_attribute_02 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p505_bl_abbrechen := frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'                         --frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p505_bl_bestellen := frgbg_s.holen_uebersetzung(4486,v_sprache_id);'||unistr('\000a')||
'   --:P505_INKL_MWST_LABEL:= frgbg_s.holen_uebersetzung(5522,v_sprache_id);'||unistr('\000a')||
'   --:P505_MWST_LABEL:= frg';

p:=p||'bg_s.holen_uebersetzung(9181,v_sprache_id);'||unistr('\000a')||
'   :P505_MWST_LABEL:= frgbg_s.holen_uebersetzung(9726,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p505_region_titel_kasse := frgbg_s.holen_uebersetzung(4357,v_sprache_id);'||unistr('\000a')||
'   :p505_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :p505_region_titel_adresse := frgbg_s.holen_uebersetzung(3091,v_sprache_id);'||unistr('\000a')||
'   :p505_region_titel_bestellinfo := frgbg_s.h';

p:=p||'olen_uebersetzung(4488,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P505_NV_WK_KASSE := frgbg_s.holen_uebersetzung(4487,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7175331788917932 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 505,
  p_process_sequence=> 51,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_wk_id                  warenkoerbe.id%TYPE;'||unistr('\000a')||
'   v_wkorb_detail_tmp_id    warenkorb_details.id%TYPE;'||unistr('\000a')||
'   v_wk_status_id           warenkoerbe.wk_status_id%TYPE;'||unistr('\000a')||
'   v_extern_verwaltet       warenkoerbe.extern_verwaltet%TYPE;'||unistr('\000a')||
'   v_anz      number;'||unistr('\000a')||
'   v_return   number;'||unistr('\000a')||
'   v_prot_id  number;'||unistr('\000a')||
'   v_fehlertext  uebersetzungen.text%TYPE;'||unistr('\000a')||
'  '||unistr('\000a')||
'   CURSOR c_wkorb_detail is'||unistr('\000a')||
'          SELECT * '||unistr('\000a')||
'      ';

p:=p||'    FROM warenkorb_details_tmp'||unistr('\000a')||
'          WHERE warenkorb_tmp_id = :p505_warenkorb_tmp_id'||unistr('\000a')||
'            -- Versandkosten werden neu ermittelt'||unistr('\000a')||
'            --AND (mengenart_id != 101 OR mengenart_id is null); NEI 12.12.12 wird nicht mehr über Trigger gesteuert, sondern beim Ausloesen der Kasse, da ggf. GUS-Anfrage'||unistr('\000a')||
'          ;'||unistr('\000a')||
'   CURSOR c_wkorb_det_verordnung is'||unistr('\000a')||
'          SELECT * '||unistr('\000a')||
'          FROM wkorb_';

p:=p||'det_verordnungen_tmp'||unistr('\000a')||
'          WHERE warenkorb_detail_tmp_id = v_wkorb_detail_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Prüfen, ob Details vorhanden'||unistr('\000a')||
'   SELECT count(*) INTO v_anz'||unistr('\000a')||
'   FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id = :p505_warenkorb_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P(''speichern Kasse anz: %1, %2, %3'',v_prot_id,''Info'',''speichern kasse 102/300'',v_anz,sqlerrm,:p505_zahlungsart);               */'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_anz = 0 THEN'||unistr('\000a')||
' ';

p:=p||'     return;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Kopieren der temporären WK ins die permanenten WK'||unistr('\000a')||
'   -- kopieren über rowtype geht nicht da wk_tmp und wk sich in der Spalte session_id unterscheiden'||unistr('\000a')||
'   select WARENKORB_SEQ.nextval into v_wk_id from dual;'||unistr('\000a')||
'   /* Status wird im onLoad gesetzt'||unistr('\000a')||
'   IF :p505_zahlungsart = 3 THEN -- Vorkasse'||unistr('\000a')||
'       v_wk_status_id := 5;         -- Z.Z noch manuelle Vorkasseanforderung späte';

p:=p||'r auch auf 6'||unistr('\000a')||
'   ELSIF :p505_zahlungsart = 1 THEN -- Rechnung  '||unistr('\000a')||
'       v_wk_status_id := 6;         -- Direkt auf 6 zur GUS-Prüfung und Druck'||unistr('\000a')||
'   ELSIF :p505_zahlungsart = 2 THEN -- Kreditkarte'||unistr('\000a')||
'      v_wk_status_id := 5;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
''||unistr('\000a')||
'   v_wk_status_id := 5;'||unistr('\000a')||
''||unistr('\000a')||
'   IF :request = ''BESTELLEN_GUS'' THEN'||unistr('\000a')||
'      v_extern_verwaltet := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      v_extern_verwaltet := :p505_extern_verwaltet;'||unistr('\000a')||
'   END IF';

p:=p||';'||unistr('\000a')||
'   '||unistr('\000a')||
'   INSERT INTO warenkoerbe ('||unistr('\000a')||
'                           ID ,'||unistr('\000a')||
'                           PLANDATUM ,'||unistr('\000a')||
'                           VERRECH_LAND_ID ,'||unistr('\000a')||
'                           WAEHRUNG_ID ,'||unistr('\000a')||
'                           GESAMTPREIS ,'||unistr('\000a')||
'                           MWST_JN ,'||unistr('\000a')||
'                           MWST_BETRAG_1 ,'||unistr('\000a')||
'                           MWST_BETRAG_2 ,'||unistr('\000a')||
'                           MWST_SATZ_1 ,'||unistr('\000a')||
'   ';

p:=p||'                        MWST_SATZ_2 ,'||unistr('\000a')||
'                           WK_STATUS_ID ,'||unistr('\000a')||
'                           STATUS_AENDERDATUM ,'||unistr('\000a')||
'                           STATUS_AENDERVISUM ,'||unistr('\000a')||
'                           PERSSTAMM_ID_RECHNUNG ,'||unistr('\000a')||
'                           PERSSTAMM_ID_LOGIN ,'||unistr('\000a')||
'                           PERSSTAMM_ID_LIEFERUNG ,'||unistr('\000a')||
'                           persstamm_id_identitaet,'||unistr('\000a')||
'                     ';

p:=p||'      persstamm_id_prod_apo,'||unistr('\000a')||
'                           persstamm_id_kunde,        -- NEI 14.01.11'||unistr('\000a')||
'                           persstamm_id_rechnungssteller, -- NEI 08.03.12 Verrechland Bestimmung neu'||unistr('\000a')||
'                           preisliste_id,             -- NEI 15.10.09'||unistr('\000a')||
'                           art_mwst_typ_id,           -- NEI 30.11.09 Artikel-MWST-Umstellung'||unistr('\000a')||
'                           preisfakt';

p:=p||'or,               -- NEI 03.12.09'||unistr('\000a')||
'                           sortiment_id,              -- NEI 09.06.11'||unistr('\000a')||
'                           wk_zahlungsart_id,         -- NEI 28.03.12'||unistr('\000a')||
'                           widerrufsfrist,            -- NEI 28.03.12'||unistr('\000a')||
'                           extern_verwaltet,          -- NEI 12.12.12'||unistr('\000a')||
'                           wk_versandart_id,          -- NEI 04.03.13'||unistr('\000a')||
'                ';

p:=p||'           aerztlich_verordnet,        -- NEI 08.06.13'||unistr('\000a')||
'                           BEMERKUNG ,'||unistr('\000a')||
'                           ERFDAT ,'||unistr('\000a')||
'                           ERFUSER ,'||unistr('\000a')||
'                           MUTDAT ,'||unistr('\000a')||
'                           MUTUSER )'||unistr('\000a')||
'   SELECT '||unistr('\000a')||
'                           v_wk_id,'||unistr('\000a')||
'                           PLANDATUM ,'||unistr('\000a')||
'                           VERRECH_LAND_ID ,'||unistr('\000a')||
'                           WA';

p:=p||'EHRUNG_ID ,'||unistr('\000a')||
'                           GESAMTPREIS ,'||unistr('\000a')||
'                           MWST_JN ,'||unistr('\000a')||
'                           MWST_BETRAG_1 ,'||unistr('\000a')||
'                           MWST_BETRAG_2 ,'||unistr('\000a')||
'                           MWST_SATZ_1 ,'||unistr('\000a')||
'                           MWST_SATZ_2 ,'||unistr('\000a')||
'                           v_wk_STATUS_ID ,'||unistr('\000a')||
'                           STATUS_AENDERDATUM ,'||unistr('\000a')||
'                           STATUS_AENDERVISUM ,'||unistr('\000a')||
'  ';

p:=p||'                         PERSSTAMM_ID_RECHNUNG ,'||unistr('\000a')||
'                           PERSSTAMM_ID_LOGIN ,'||unistr('\000a')||
'                           PERSSTAMM_ID_LIEFERUNG ,'||unistr('\000a')||
'                           persstamm_id_identitaet,'||unistr('\000a')||
'                           persstamm_id_prod_apo,'||unistr('\000a')||
'                           persstamm_id_kunde,          -- NEI 14.01.11'||unistr('\000a')||
'                           persstamm_id_rechnungssteller,-- NEI 08.03.12'||unistr('\000a')||
'    ';

p:=p||'                       preisliste_id,               -- NEI 15.10.09'||unistr('\000a')||
'                           art_mwst_typ_id ,            -- NEI 30.11.09 Artikel-MWST-Umstellung'||unistr('\000a')||
'                           preisfaktor  ,               -- NEI 03.12.09'||unistr('\000a')||
'                           sortiment_id ,               -- NEI 09.06.11'||unistr('\000a')||
'                           :p505_zahlungsart,           -- NEI 28.03.12'||unistr('\000a')||
'                    ';

p:=p||'       widerrufsfrist,              -- NEI 28.03.12'||unistr('\000a')||
'                           v_extern_verwaltet,          -- NEI 12.12.12'||unistr('\000a')||
'                           wk_versandart_id,            -- NEI 04.03.13'||unistr('\000a')||
'                           aerztlich_verordnet,        -- NEI 08.06.13'||unistr('\000a')||
'                           BEMERKUNG ,'||unistr('\000a')||
'                           SYSDATE ,'||unistr('\000a')||
'                           :APP_USER,'||unistr('\000a')||
'                   ';

p:=p||'        SYSDATE,'||unistr('\000a')||
'                           :APP_USER'||unistr('\000a')||
'   FROM warenkoerbe_tmp'||unistr('\000a')||
'   WHERE id = :p505_warenkorb_tmp_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Wkorb-Details und Verordnung kopieren'||unistr('\000a')||
'   FOR r_wkorb_detail in c_wkorb_detail LOOP'||unistr('\000a')||
'       v_wkorb_detail_tmp_id := r_wkorb_detail.id;'||unistr('\000a')||
'       select WKORB_DET_SEQ.nextval into r_wkorb_detail.id from dual ;'||unistr('\000a')||
'       r_wkorb_detail.warenkorb_tmp_id := v_wk_id;'||unistr('\000a')||
'       r_wkorb_detail';

p:=p||'.wk_status_id := v_wk_status_id;'||unistr('\000a')||
'       -- alle Blanks entfernen'||unistr('\000a')||
'       r_wkorb_detail.labor_auftrag_id :=regexp_replace(r_wkorb_detail.labor_auftrag_id,''[ ]'','''');'||unistr('\000a')||
'       INSERT INTO warenkorb_details'||unistr('\000a')||
'       VALUES r_wkorb_detail;'||unistr('\000a')||
'       -- Verordnungen kopieren'||unistr('\000a')||
'       FOR r_wkorb_det_verordnung in c_wkorb_det_verordnung LOOP'||unistr('\000a')||
'          select WK_VERORD_SEQ.nextval into r_wkorb_det_verordnung.id fr';

p:=p||'om dual;'||unistr('\000a')||
'          r_wkorb_det_verordnung.warenkorb_detail_tmp_id := r_wkorb_detail.id;'||unistr('\000a')||
'          INSERT INTO WKORB_DET_VERORDNUNGEN '||unistr('\000a')||
'          VALUES r_wkorb_det_verordnung;           '||unistr('\000a')||
'       END LOOP;'||unistr('\000a')||
'   END LOOP;    '||unistr('\000a')||
''||unistr('\000a')||
'   /* NEI 12.12.12 wg. GUS nicht mehr auf 50 '||unistr('\000a')||
'   -- Alle Positionen mit Fertigartikeln und Status 10 automatisch auf 50 setzen'||unistr('\000a')||
'   IF  v_wk_status_id = 10 THEN        '||unistr('\000a')||
'       v_ret';

p:=p||'urn := frgbg_s.WK_UPD_STATUS_FERTIGARTIKEL_50(v_wk_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
''||unistr('\000a')||
'   -- TMP''s loeschen'||unistr('\000a')||
'   DELETE wkorb_det_verordnungen_tmp'||unistr('\000a')||
'   WHERE warenkorb_detail_tmp_id in '||unistr('\000a')||
'           (SELECT id FROM warenkorb_details_tmp where warenkorb_tmp_id = :p505_warenkorb_tmp_id);'||unistr('\000a')||
''||unistr('\000a')||
'   DELETE warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id = :p505_warenkorb_tmp_id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   DELETE warenkoerbe_tmp'||unistr('\000a')||
'   WHERE id = :p5';

p:=p||'05_warenkorb_tmp_id;'||unistr('\000a')||
'--RAISE_APPLICATion_error(-20000,''test'');   '||unistr('\000a')||
'   :p505_warenkorb_tmp_id := NULL;'||unistr('\000a')||
'   :p505_id := NULL;'||unistr('\000a')||
'   :p505_warenkorb_id := v_wk_id;'||unistr('\000a')||
'   :p505_bestell_status:= ''BESTELL_OK'';'||unistr('\000a')||
'/*   v_return := frgbg_s.MAIL_BESTELLUNG '||unistr('\000a')||
'                  (NULL     --P_USER_ACCOUNT'||unistr('\000a')||
'                  ,1547     --P_PERSSTAMM_ID Frau Siegwart als Zieladresse'||unistr('\000a')||
'                  , v_wk_id --P_WARENKORB_';

p:=p||'ID '||unistr('\000a')||
'                  ,:FAS_LOGIN_PERSONENSTAMM_ID     --P_PERSSTAMM_ID_MAILABSENDER '||unistr('\000a')||
'                  ,1        --P_FLAG IN NUMBER '||unistr('\000a')||
'                  ,0        --P_NOTFALL_EMAIL'||unistr('\000a')||
'                 );'||unistr('\000a')||
'*/'||unistr('\000a')||
'--mel.p(''speichern Kasse: %1'',v_prot_id,''INFO'',''speichern kasse 102/305'',v_return);'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   MEL.P (''WK-Bestellung v_anz: %1, %2, %3'',v_prot_id,''Info'',''speichern kasse 102/305''';

p:=p||',v_anz,sqlerrm);               '||unistr('\000a')||
'   rollback;'||unistr('\000a')||
'   :p505_bestell_status:= ''BESTELL_ERROR'';'||unistr('\000a')||
'   --v_fehlertext := frgbg_s.holen_uebersetzung(1812,:fas_sprache_id,1);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7175502227917934 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 505,
  p_process_sequence=> 50,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_kasse',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BESTELLEN'',''BESTELLEN_GUS'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   DELETE FROM warenkorb_details_tmp'||unistr('\000a')||
'   WHERE warenkorb_tmp_id =  :p505_warenkorb_tmp_id'||unistr('\000a')||
'     AND mengenart_id = 101;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7175700163917936 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 505,
  p_process_sequence=> 110,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'delete_versandkosten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>7161929045917888 + wwv_flow_api.g_id_offset,
  p_process_when=>'p300_warenkorb_tmp_id',
  p_process_when_type=>'',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p505_id:=:p505_warenkorb_tmp_id;'||unistr('\000a')||
'   :p505_bestell_status:= NVL(:p505_bestell_status,''KASSE'');'||unistr('\000a')||
''||unistr('\000a')||
'   -- Zahlungsart vorbelegen'||unistr('\000a')||
'   /* NEI 13.08.12 Zahlungsart wird durch pers_option vorbelegt'||unistr('\000a')||
'   IF :FAS_IDENTITAET_PERSSTAMM_ID = 24377 THEN -- EOVITAL => Vorkasse  '||unistr('\000a')||
'      :P505_ZAHLUNGSART := 3;  -- NEI 25.04.12'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :P505_ZAHLUNGSART := 1; -- NEI 25.04.12 -- sonst => Rechnung'||unistr('\000a')||
'   END ';

p:=p||'IF;'||unistr('\000a')||
'   */'||unistr('\000a')||
'   IF :P505_ZAHLUNGSART is null THEN '||unistr('\000a')||
'      IF :p505_SORTIMENT_ID = 0 THEN -- Wiederverkäufer: Bestellung auf Rechnung'||unistr('\000a')||
'         :P505_ZAHLUNGSART := 1; '||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         IF frgbg_s.get_pers_option(:APP_USER,35) = 1 THEN --Bestellung auf Rechnung'||unistr('\000a')||
'            :P505_ZAHLUNGSART := 1; '||unistr('\000a')||
'         ELSE   -- sonst Default Vorkassen'||unistr('\000a')||
'            :P505_ZAHLUNGSART := 3;     '||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'   ';

p:=p||'   END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7175904169917936 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 505,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_wk',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:WARENKOERBE_TMP:P505_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 7176127545917936 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 505,
  p_process_sequence=> 50,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from WARENKOERBE_TMP',
  p_process_sql_clob => p,
  p_process_error_message=> 'fehler in row select #SQLERRM# &P300_WARENKORB_TMP_ID.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p505_warenkorb_tmp_id is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_hinweistext VARCHAR2(2000);'||unistr('\000a')||
'   v_return      number;'||unistr('\000a')||
'   v_prot_id     number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :request in (''BESTELL_OK'',''WINDOW_CLOSE_PAY_SPEICHERN'') THEN'||unistr('\000a')||
'      :p505_bestell_status := ''BESTELL_OK'';     '||unistr('\000a')||
'      v_hinweistext:=frgbg_s.holen_uebersetzung(4386,:fas_sprache_id);'||unistr('\000a')||
'      /* NEI 12.12.12 wird in wk_aktivieren gemacht'||unistr('\000a')||
'      IF :request in (''WINDOW_CLOSE_PAY_SPEICHERN'') THEN  -- WK-';

p:=p||'Status'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            update warenkorb_details'||unistr('\000a')||
'            --set wk_status_id = 10   NEI 12.12.12'||unistr('\000a')||
'            set wk_status_id = 6   -- WK GUS-Pruefung/Dokudruck'||unistr('\000a')||
'            WHERE warenkorb_id = :p505_warenkorb_id'||unistr('\000a')||
'              AND wk_status_id= 5;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            --v_hinweistext:= ''Fehler beim Aktivieren der Bestellung! WK-ID:''||:p505_warenkorb';

p:=p||'_id;'||unistr('\000a')||
'            :p505_bestell_status := ''BESTELL_ERROR'';     '||unistr('\000a')||
'            v_hinweistext:=frgbg_s.holen_uebersetzung(4387,:fas_sprache_id); '||unistr('\000a')||
'         END;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      -- Dokumentendruck/GUS-check'||unistr('\000a')||
'      IF :p505_zahlungsart != 3 THEN -- Nicht Vorkasse => wird in WK-Übersicht manuelle gesetzt auf Rechnung gedruckt '||unistr('\000a')||
'         v_return := frgbg_s.wk_aktivieren(:p505_warenkorb_id);'||unistr('\000a')||
'    ';

p:=p||'     IF v_return < 0 THEN'||unistr('\000a')||
'            --v_hinweistext:= ''Fehler beim Aktivieren der Bestellung! WK-ID:''||:p505_warenkorb_id;'||unistr('\000a')||
'            :p505_bestell_status := ''BESTELL_ERROR'';     '||unistr('\000a')||
'            v_hinweistext:=frgbg_s.holen_uebersetzung(4387,:fas_sprache_id); '||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      -- Druck Bestellbestätigung'||unistr('\000a')||
'      v_return := frgbg_s.MAIL_EING_BESTAETIGUNG(:p505_warenkorb_id);'||unistr('\000a')||
'   E';

p:=p||'LSIF :request in (''BESTELL_ERROR'') THEN'||unistr('\000a')||
'      -- Im Submit wurde bereits ein Rollback gefahren, die Bestellung wurde nicht in den permanenten WK übernommen'||unistr('\000a')||
'      --v_hinweistext:= ''Fehler im Bestellungsvorgang! Bestellung storniert.'';  '||unistr('\000a')||
'      :p505_bestell_status := ''BESTELL_ERROR'';     '||unistr('\000a')||
'      v_hinweistext:=frgbg_s.holen_uebersetzung(4387,:fas_sprache_id); '||unistr('\000a')||
'   ELSIF :request in (''WINDOW_CLOSE_PAY';

p:=p||'_ERROR'',''WINDOW_CLOSE_PAY_CANCEL'') THEN'||unistr('\000a')||
'      -- Zahlungsvorgang erfolgte nicht => permanenter WK storniert'||unistr('\000a')||
'      --v_hinweistext:= ''Zahlungsabbruch oder Fehler im Zahlvorgang! Bestellung storniert.'';   '||unistr('\000a')||
'      v_hinweistext:=frgbg_s.holen_uebersetzung(4484,:fas_sprache_id); '||unistr('\000a')||
'      :p505_bestell_status := ''BESTELL_ERROR'';    '||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         update warenkorb_details'||unistr('\000a')||
'         set wk_status_id= ';

p:=p||'90'||unistr('\000a')||
'         WHERE warenkorb_id = :p505_warenkorb_id'||unistr('\000a')||
'           AND wk_status_id= 5;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         -- Error-Mail versenden, da Status-Update nicht möglich'||unistr('\000a')||
'         --v_hinweistext:= ''Fehler beim Stornieren der Bestellung! WK-ID:%1''||:p505_warenkorb_id;'||unistr('\000a')||
'         v_hinweistext:=frgbg_s.holen_uebersetzung(4485,:fas_sprache_id,:p505_warenkorb_id); '||unistr('\000a')||
'      END; '||unistr('\000a')||
'      IF';

p:=p||' :request in (''WINDOW_CLOSE_PAY_ERROR'') THEN'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            update warenkoerbe'||unistr('\000a')||
'            set error_flag  = 1,'||unistr('\000a')||
'                error_text  = ''Es trat ein Fehler beim Kreditkarten-Zahlvorgang auf! Die Zahlung wurde nicht durchgeführt. WK storniert!'''||unistr('\000a')||
'            WHERE id = :p505_warenkorb_id;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            -- Error-Mail versenden, da Status-Upd';

p:=p||'ate nicht möglich'||unistr('\000a')||
'            --v_hinweistext:= ''Fehler der WK-Fehlermarkierung während der Stornierung der Bestellung! WK-ID:%1''||:p505_warenkorb_id;'||unistr('\000a')||
'            v_hinweistext:=frgbg_s.holen_uebersetzung(4485,:fas_sprache_id,:p505_warenkorb_id); '||unistr('\000a')||
'         END;'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      --v_hinweistext:= ''Unbekannter Bestellstatus'';  '||unistr('\000a')||
'      -- Error-Mail versenden, da Status-Update nicht möglic';

p:=p||'h'||unistr('\000a')||
'      v_hinweistext:=frgbg_s.holen_uebersetzung(4388,:fas_sprache_id||''(''||:p505_bestell_status||'')''); '||unistr('\000a')||
'      :p505_bestell_status := ''BESTELL_ERROR'';     '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p505_bestellhinweis := v_hinweistext;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7176304056917937 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 505,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'bestellung_aktivieren_bestellhinweis',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''BESTELL_ERROR'',''BESTELL_OK'','||unistr('\000a')||
'''WINDOW_CLOSE_PAY_ERROR'',''WINDOW_CLOSE_PAY_SPEICHERN'',''WINDOW_CLOSE_PAY_CANCEL'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P505_HEIGHT_warenkorb := :FAS_SCROLLREGION_HEIGHT_MAX * 0.8;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7176521181917938 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 505,
  p_process_sequence=> 100,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 505
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00508
prompt  ...PAGE 508: Warenkorb_WV_Versanddaten
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 508
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Warenkorb_WV_Versanddaten'
 ,p_step_title => 'Warenkorb_WV_Versanddaten'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'WV_Warenkorb_Versanddaten'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<script language="JavaScript" type="text/javascript">'||unistr('\000a')||
'<!--'||unistr('\000a')||
''||unistr('\000a')||
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150213080456'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'wkd."ID",'||unistr('\000a')||
'wkd."ID" ID_DISPLAY,'||unistr('\000a')||
'wkd."WARENKORB_TMP_ID",'||unistr('\000a')||
'wkd."PRODKENNZ_ID",'||unistr('\000a')||
'wkd."P_REZEPT_ID",'||unistr('\000a')||
'wkd."MENGENART_ID",'||unistr('\000a')||
'wkd."MENGE",'||unistr('\000a')||
'wkd."VOLUMEN",'||unistr('\000a')||
'wkd."GEWICHT",'||unistr('\000a')||
'wkd."PREIS",'||unistr('\000a')||
'wkd."MWST_BETRAG",'||unistr('\000a')||
'wkd."MWST_SATZ",'||unistr('\000a')||
'wkd."WK_STATUS_ID",'||unistr('\000a')||
'wkd."STATUS_AENDERDATUM",'||unistr('\000a')||
'wkd."STATUS_AENDERVISUM",'||unistr('\000a')||
'wkd."ETIKETTENTYP",'||unistr('\000a')||
'wkd."BEMERKUNG",'||unistr('\000a')||
'wkd."ERFDAT",'||unistr('\000a')||
'wkd."ERFUSER",'||unistr('\000a')||
'wkd."MUTDAT",'||unistr('\000a')||
'wkd."MUTUSER",'||unistr('\000a')||
'--pr.rezept_nr||DECO';

s:=s||'DE(pr.version,NULL,NULL,''/''||pr.version) rezept_nr,  -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'  CASE WHEN mnr.rezept_nr_splitbasis is NULL AND mnr.version_splitbasis is NULL THEN'||unistr('\000a')||
'       pr.rezept_nr||DECODE(pr.version,NULL,NULL,''/''||pr.version)'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'       mnr.rezept_nr_splitbasis||DECODE(mnr.version_splitbasis,NULL,NULL,''/''||mnr.version_splitbasis)'||unistr('\000a')||
'  END rezept_nr,   '||unistr('\000a')||
'  CASE WHEN w';

s:=s||'kd.PRODKENNZ_ID = 1 THEN -- HCK-Mischung'||unistr('\000a')||
'      frgbg_s.get_pers_name_rezept(p_rezept_id)|| ''</br>''||'||unistr('\000a')||
'      frgbg_s.holen_uebersetzung(585,:fas_sprache_id)||'': ''||wkd.reichweite||'||unistr('\000a')||
'      DECODE (rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version),0,'''','||unistr('\000a')||
'         ''</br>''||fas_synch.get_tab_uebersetzung(''MN_REZARTEN.BEZEICHNUNG'',rezepte.GET_MNR_REZART_ID(pr.REZEPT_NR,pr.version)'||unistr('\000a')||
'      ,:fas_sprache_id))';

s:=s||''||unistr('\000a')||
'  ELSE '||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)|| ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'  END kuerzel,'||unistr('\000a')||
'  TRUNC(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2) einzelpreis_brutto,'||unistr('\000a')||
' (trunc(NVL(wkd.PREIS,0) + NVL(wkd.MWST_BETRAG,0),2))*NVL(wkd.MENGE,0)'||unistr('\000a')||
'               g';

s:=s||'esamtpreis_brutto'||unistr('\000a')||
'from WARENKORB_DETAILS_TMP wkd , prod_rezepte pr, mengenarts m,'||unistr('\000a')||
'     mn_rezepte mnr  -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'where warenkorb_tmp_id = :p508_warenkorb_tmp_id'||unistr('\000a')||
'  and p_rezept_id = pr.id (+)'||unistr('\000a')||
'  and mengenart_id = m.id (+)'||unistr('\000a')||
'  and (wkd.mengenart_id is NULL or wkd.mengenart_id != 101)'||unistr('\000a')||
'  AND pr.rezept_nr = mnr.rezept_nr(+) -- NEI 10.01.2014 Kumulation Splits zu ';

s:=s||'Gesamtrezept'||unistr('\000a')||
'  AND pr.version  = mnr.version (+)   -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'order by wkd.id';

wwv_flow_api.create_report_region (
  p_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 508,
  p_name=> '&P508_REGION_TITEL_WARENKORB.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 15,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'UPDATABLE_SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P305_HEIGHT_WARENKORB.px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'N',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(3081,:fas_sprache_id));',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '100',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> 'ROW_RANGES_IN_SELECT_LIST',
  p_query_row_count_max=> '5000',
  p_pagination_display_position=> 'TOP_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_sort_null=> 'F',
  p_query_asc_image=> 'arrow_down_gray_dark.gif',
  p_query_asc_image_attr=> 'width="13" height="12" alt=""',
  p_query_desc_image=> 'arrow_up_gray_dark.gif',
  p_query_desc_image_attr=> 'width="13" height="12" alt=""',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995408326985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'CHECK$01',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'CHECKBOX',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_derived_column=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995510496985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'HIDDEN',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source_type=> 'T',
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995624995985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID_DISPLAY',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ID_DISPLAY',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995712546985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'WARENKORB_TMP_ID',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WARENKORB_TMP_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995829102985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'PRODKENNZ_ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PRODKENNZ_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995916645985158 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'P_REZEPT_ID',
  p_column_display_sequence=> 12,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'P_REZEPT_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7996018751985158 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'MENGENART_ID',
  p_column_display_sequence=> 13,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGENART_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7996116059985158 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'MENGE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_inline_lov=> '1,2,3,4,5,6,7,8,9,10',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '5',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MENGE',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7996224404985158 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'VOLUMEN',
  p_column_display_sequence=> 14,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'VOLUMEN',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7996301071985158 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'GEWICHT',
  p_column_display_sequence=> 15,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'GEWICHT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7996412906985158 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'PREIS',
  p_column_display_sequence=> 16,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'PREIS',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7996508405985158 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 12,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_BETRAG',
  p_column_display_sequence=> 17,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_BETRAG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995331864985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 13,
  p_form_element_id=> null,
  p_column_alias=> 'MWST_SATZ',
  p_column_display_sequence=> 18,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MWST_SATZ',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994027448985152 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 14,
  p_form_element_id=> null,
  p_column_alias=> 'WK_STATUS_ID',
  p_column_display_sequence=> 19,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'WK_STATUS_ID',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994126675985156 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 15,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERDATUM',
  p_column_display_sequence=> 20,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERDATUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994217236985156 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 16,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS_AENDERVISUM',
  p_column_display_sequence=> 21,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'STATUS_AENDERVISUM',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994332404985156 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 17,
  p_form_element_id=> null,
  p_column_alias=> 'ETIKETTENTYP',
  p_column_display_sequence=> 22,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ETIKETTENTYP',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994431948985156 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 18,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_column_width=> '20',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'BEMERKUNG',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994513272985156 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 19,
  p_form_element_id=> null,
  p_column_alias=> 'ERFDAT',
  p_column_display_sequence=> 23,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994623685985156 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 20,
  p_form_element_id=> null,
  p_column_alias=> 'ERFUSER',
  p_column_display_sequence=> 24,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'ERFUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994719680985156 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 21,
  p_form_element_id=> null,
  p_column_alias=> 'MUTDAT',
  p_column_display_sequence=> 25,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '7',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTDAT',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994824275985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 22,
  p_form_element_id=> null,
  p_column_alias=> 'MUTUSER',
  p_column_display_sequence=> 26,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_column_width=> '16',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_ref_schema=> 'FRGBG',
  p_ref_table_name=> 'WARENKORB_DETAILS_TMP',
  p_ref_column_name=> 'MUTUSER',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7994907900985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 23,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_NR',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995020715985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 24,
  p_form_element_id=> null,
  p_column_alias=> 'KUERZEL',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995102469985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 25,
  p_form_element_id=> null,
  p_column_alias=> 'EINZELPREIS_BRUTTO',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7995211098985157 + wwv_flow_api.g_id_offset,
  p_region_id=> 7993825206985145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 26,
  p_form_element_id=> null,
  p_column_alias=> 'GESAMTPREIS_BRUTTO',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7998617968985182 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 508,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7998807861985182 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 508,
  p_plug_name=> '&P508_REGION_TITEL_ADRESSE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 5,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 7999023552985182 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 508,
  p_button_sequence=> 5,
  p_button_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P508_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 7996631351985159 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 508,
  p_button_sequence=> 10,
  p_button_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_button_name    => 'KASSE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P508_BL_ZUR_KASSE.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'SELECT * '||unistr('\000a')||
'FROM warenkorb_details_tmp '||unistr('\000a')||
'where warenkorb_tmp_id=:P508_WARENKORB_TMP_ID',
  p_button_condition_type=> 'EXISTS',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8010302902985228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P508_ZURUECK_SEITE.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7999023552985182+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>8010105645985228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:304:P304_ID:&P300_PERSSTAMM_ID.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8002214616985188+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 15,
  p_branch_condition_type=> 'NEVER',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>8010509853985228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:302:P302_ID,P302_ADRESSTYP,P302_ZURUECK_SEITE,P302_CALLING_PAGE:&P508_PERSSTAMM_ID_LIEFERUNG.,L,308,308',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8006618496985197+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 16,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>8010711287985228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:302:P302_ID,P302_ADRESSTYP,P302_ZURUECK_SEITE,P302_CALLING_PAGE:&P508_PERSSTAMM_ID_RECHNUNG.,L,308,308',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8001613517985187+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 17,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>8009931708985224 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:505:&SESSION.::&DEBUG.:505:P505_WARENKORB_TMP_ID,P505_ZURUECK_SEITE,P505_ZURUECK_SEITE_NACH_BEST:&P508_WARENKORB_TMP_ID.,&APP_PAGE_ID.,&P508_ZURUECK_SEITE_NACH_BEST.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7996631351985159+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 13-DEC-2012 10:51 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>8010917636985228 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301:P301_PERSSTAMM_ID_BETREUER,P301_persstamm_id_patient,p301_adresstyp,p301_zurueck_seite,P301_PERSSTAMM_ID_STDADRESSE:&P508_PERSSTAMM_ID_LOGIN.,&P508_PERSSTAMM_ID_KUNDE.,L,&APP_PAGE_ID.,&P508_PERSSTAMM_ID_KUNDE.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8005822548985196+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 20,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>8011129351985229 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301:P301_PERSSTAMM_ID_BETREUER,P301_persstamm_id_patient,p301_adresstyp,p301_zurueck_seite,P301_PERSSTAMM_ID_STDADRESSE:&P508_PERSSTAMM_ID_LOGIN.,&P508_PERSSTAMM_ID_KUNDE.,R,&APP_PAGE_ID.,&P508_PERSSTAMM_ID_KUNDE.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8006011651985196+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 30,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 07-MAI-2009 09:38 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>8011322692985229 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:508:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 90,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7996822541985163 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_WARENKORB_TMP_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb-ID',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7997004007985173 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_GESAMTWERT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'to_char(trunc(NVL(to_number(:p508_gesamtpreis,''999G999G999G999G990D00''),0) + NVL(to_number(:p508_mwst_betrag_1,''999G999G999G999G990D00''),0)+ NVL(to_number(:p508_mwst_betrag_2,''999G999G999G999G990D00''),0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P508_GESAMTWERT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7997208388985175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_GESAMT_MWST_BETRAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'to_char(trunc(NVL(:p508_mwst_betrag_1,0) + NVL(:p508_mwst_betrag_2,0),2),''999G999G999G999G990D00'')',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7997406885985176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_WAEHRUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 45,
  p_item_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'&#160',
  p_post_element_text=>'&#160&#160&P508_MWST_LABEL.',
  p_source=>'rezepte.get_waehrung_zeichen(:p508_waehrung_id);--||'' &P508_MWST_LABEL.'';',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7997621547985177 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_ETTIKETTENTYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 35,
  p_item_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ettikettentyp',
  p_source=>'frgbg_s.get_pers_option(:APP_USER,1);',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7997809372985178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_VERSANDKOSTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 55,
  p_item_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160&#160&P508_WAEHRUNG.',
  p_source=>'SELECT to_char(NVL(sum(preis+mwst_betrag),0),''999G999G999G999G990D00'')'||unistr('\000a')||
'from warenkorb_details_tmp'||unistr('\000a')||
'where warenkorb_tmp_id = :p508_warenkorb_tmp_id'||unistr('\000a')||
'  and mengenart_id = 101;',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7998004550985179 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_WARENKORB_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 215,
  p_item_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Warenkorb Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7998223348985179 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_WK_VERSANDART_ID_DISP',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_pre_element_text=>'(',
  p_post_element_text=>')',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7998413631985180 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_SORTIMENT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 330,
  p_item_plug_id => 7993825206985145+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'SORTIMENT_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7999204245985183 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_REGION_TITEL_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 550,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7999426595985183 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PERSSTAMM_ID_KUNDE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'PERSSTAMM_ID_KUNDE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7999605645985183 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_HEIGHT_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Height Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7999810854985183 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_NV_WK_VERSAND',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 530,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Warenkorb',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8000021436985184 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_REGION_TITEL_ADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 540,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8000229293985184 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 9,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8000424633985184 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8000626049985185 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_BL_AUSWAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 580,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8000823666985185 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 590,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8001008090985185 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PERSSTAMM_ID_PROD_APO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 13,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_tag_attributes  => 'onChange="javascript:doSubmit(''CHANGE'') "',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8001203106985186 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PATIENTADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'frgbg_s.get_pers_adresse(:p508_persstamm_id_kunde)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8001400164985187 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PERSSTAMM_PROD_APO_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 17,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'P508_PERSSTAMM_ID_PROD_APO',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT substr(frgbg_s.get_pers_adresse(p.id),1,80) a,'||unistr('\000a')||
'       p.id b'||unistr('\000a')||
'FROM pers_identitaet_props i,    /* spez. Eigenschaften der Identitaeten */'||unistr('\000a')||
'     personenstamm p'||unistr('\000a')||
'where i.typ = ''PA'' /* Produzierende Apotheke */'||unistr('\000a')||
'  and p.id = i.persstamm_id'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'',
  p_lov_null_value=> '',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8001613517985187 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_RECHADRESSE_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 12,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P508_BL_AENDERN.',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':P508_persstamm_id_kunde != :p508_persstamm_id_rechnung and'||unistr('\000a')||
':p508_persstamm_id_lieferung != :p508_persstamm_id_rechnung ',
  p_display_when_type=>'NEVER',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8001822373985188 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_WK_VERSANDART_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> true,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 18,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'WK_VERSANDART_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT fas_synch.GET_TAB_UEBERSETZUNG (''WK_VERSANDARTEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung, id '||unistr('\000a')||
'FROM wk_versandarten'||unistr('\000a')||
'WHERE satz_kennzeichen is null'||unistr('\000a')||
'   -- Versandart Selbstabholer gibt es bei Wiederverkäufer nicht'||unistr('\000a')||
'  and id != 3  ',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8002007674985188 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_ADRESSTYP_EXTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 200,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Ext Adresstyp',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8002214616985188 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PATIENT_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'PATIENT',
  p_prompt=>'&P508_BL_AENDERN.',
  p_source=>'PATIENT',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8002416300985188 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8002619028985189 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PLANDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 23,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Plandatum',
  p_source=>'PLANDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8002803142985189 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_VERRECH_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Verrech Land Id',
  p_source=>'VERRECH_LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8003009239985189 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_WAEHRUNG_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 22,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Waehrung Id',
  p_source=>'WAEHRUNG_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8003224925985190 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_GESAMTPREIS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Gesamtpreis',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'GESAMTPREIS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8003417683985190 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_MWST_JN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Jn',
  p_source=>'MWST_JN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8003605930985190 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_MWST_BETRAG_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 1',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'MWST_BETRAG_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8003826697985191 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_MWST_BETRAG_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Betrag 2',
  p_format_mask=>'999G999G999G999G990D00',
  p_source=>'MWST_BETRAG_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8004028816985191 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_MWST_SATZ_1',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 1',
  p_source=>'MWST_SATZ_1',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8004231060985191 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_MWST_SATZ_2',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mwst Satz 2',
  p_source=>'MWST_SATZ_2',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8004426105985191 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_WK_STATUS_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 110,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wk Status Id',
  p_source=>'WK_STATUS_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8004601021985192 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_STATUS_AENDERDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 120,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aenderdatum',
  p_source=>'STATUS_AENDERDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8004831612985192 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_STATUS_AENDERVISUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 130,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Status Aendervisum',
  p_source=>'STATUS_AENDERVISUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8005014310985192 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PERSSTAMM_ID_LOGIN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 150,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Login',
  p_source=>'PERSSTAMM_ID_LOGIN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8005205885985192 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 170,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bemerkung',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8005414955985193 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_LIEFERADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 6,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEGIN'||unistr('\000a')||
'   IF :p508_persstamm_id_lieferung = :p508_persstamm_id_kunde THEN'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9067,:fas_sprache_id)||'' ''||frgbg_s.holen_uebersetzung(5521,:fas_sprache_id);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.get_pers_adresse(:p508_persstamm_id_lieferung);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8005611600985194 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_RECHNUNGSADRESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEGIN'||unistr('\000a')||
'   IF :p508_persstamm_id_rechnung = :p508_persstamm_id_kunde THEN    -- siehe Kundenadresse'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9067,:fas_sprache_id)||'' ''||frgbg_s.holen_uebersetzung(5521,:fas_sprache_id);'||unistr('\000a')||
'   ELSIF :p508_persstamm_id_rechnung = :p508_persstamm_id_lieferung THEN --siehe Lieferadresse'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9067,:fas_sprache_id)||'' ''||frgbg_s.holen_uebersetzung(3114,:fas_sprache_id);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.get_pers_adresse(:p508_persstamm_id_rechnung);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END',
  p_source_type=> 'FUNCTION_BODY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8005822548985196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_LIEFERADRESSE_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 7,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'LIEFERADRESSE',
  p_prompt=>'&P508_BL_AUSWAHL.',
  p_source=>'LIEFERADRESSE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8006011651985196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_RECHADR_WAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 11,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'RECHADRESSE',
  p_prompt=>'&P508_BL_AUSWAHL.',
  p_source=>'RECHADRESSE',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8006201065985196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PERSSTAMM_ID_EXTERN_UPD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 190,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'ext Persstamm Id Upd',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8006424540985196 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_PERSSTAMM_ID_RECHSTELLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 14,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PERSSTAMM_ID_RECHNUNGSSTELLER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select substr(frgbg_s.get_pers_adresse(:p508_persstamm_id_rechsteller),1,80) a,'||unistr('\000a')||
':p508_persstamm_id_rechsteller b'||unistr('\000a')||
'from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'SUBMIT',
  p_attribute_03 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8006618496985197 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_LIEFERADRESSE_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 8,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P508_BL_AENDERN.',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':p508_persstamm_id_kunde != :p508_persstamm_id_lieferung',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8006802603985197 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_ZURUECK_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8007007915985197 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_ZURUECK_SEITE_NACH_BEST',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8007209600985197 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_BL_ZUR_KASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 560,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8007400961985198 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 570,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8016113335456265 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_MWST_LABEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 600,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9463506322283912 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'BUT_VERSANDKOSTENINFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 19,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'&P508_BL_VERSANDKOSTEN.',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'N',
  p_button_action => 'DEFINED_BY_DA',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9465712658418186 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 508,
  p_name=>'P508_BL_VERSANDKOSTEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 592,
  p_item_plug_id => 7998807861985182+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8008327129985207 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_kunde_adressen_vollstaendigkeit',
  p_validation_sequence=> 10,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_gus_id       personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_extern_verwaltet warenkoerbe.extern_verwaltet%TYPE;'||unistr('\000a')||
'   v_prot_id      number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/308: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Kunderadresse müssen vollständig sein, wenn der Auftrag an GUS geht und noch keine GUS-ID für den Kunden vorhanden ist, sonst kann GUS den Kunden nicht anlegen => Hier gehts immer um Identitäten und die werden prinzipiell in GUS angelegt.'||unistr('\000a')||
'   -- holen der Kundenadr. aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          p.gus_id,wk.extern_verwaltet'||unistr('\000a')||
'   INTO v_plz, v_ort, v_land_id,v_strasse,v_name,v_vorname,'||unistr('\000a')||
'        v_gus_id,v_extern_verwaltet'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p508_id'||unistr('\000a')||
'     AND wk.persstamm_id_kunde =p.id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF v_gus_id is NULL THEN '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(9129,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
''||unistr('\000a')||
'   /* wird zur Zeit nicht benötigt'||unistr('\000a')||
'   IF v_gus_id is NULL AND v_extern_verwaltet=1 AND'||unistr('\000a')||
'      (v_plz is NULL OR v_ort is NULL OR v_land_id IS NULL OR '||unistr('\000a')||
'       v_strasse IS NULL OR v_name IS NULL OR v_vorname IS NULL'||unistr('\000a')||
'      )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Kundenadresse ist unvollständig! Die Felder Name, Vorname, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5901,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
'   */'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_when_button_pressed=> 7996631351985159 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8007722894985201 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_lief_adressen_vollstaendigkeit',
  p_validation_sequence=> 30,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz_lief          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort_lief          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id_lief      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse_lief      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name_lief         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname_lief      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_persstamm_id_lief personenstamm.id%TYPE;'||unistr('\000a')||
'   v_persstamm_id_kunde personenstamm.id%TYPE;'||unistr('\000a')||
'   v_land_id_kunde      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/308: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
''||unistr('\000a')||
'   -- Lieferadresse müssen vollständig sein'||unistr('\000a')||
'   -- holen der Lieferadr. aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname,'||unistr('\000a')||
'          wk.persstamm_id_lieferung,wk.persstamm_id_kunde'||unistr('\000a')||
'   INTO v_plz_lief, v_ort_lief, v_land_id_lief,v_strasse_lief,v_name_lief,v_vorname_lief,'||unistr('\000a')||
'          v_persstamm_id_lief,v_persstamm_id_kunde'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p508_id'||unistr('\000a')||
'     AND wk.persstamm_id_lieferung =p.id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF v_plz_lief is NULL OR v_ort_lief is NULL OR v_land_id_lief IS NULL OR '||unistr('\000a')||
'      v_strasse_lief IS NULL OR v_name_lief IS NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Lieferadresse ist unvollständig! Die Felder Name, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5900,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
''||unistr('\000a')||
'   -- Kundenadresse und Lieferadresse müssen im gleichen Land sein, damit kein Währungswechsel/Mwstwechsel erfolgen muss'||unistr('\000a')||
'   IF v_persstamm_id_lief != NVL(v_persstamm_id_kunde,0) THEN'||unistr('\000a')||
'      SELECT p.land_id'||unistr('\000a')||
'      INTO v_land_id_kunde'||unistr('\000a')||
'      FROM personenstamm p'||unistr('\000a')||
'      WHERE id = v_persstamm_id_kunde;'||unistr('\000a')||
'      IF v_land_id_kunde != v_land_id_lief THEN'||unistr('\000a')||
'         RETURN frgbg_s.holen_uebersetzung(9602,:fas_sprache_id);	'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 8006618496985197 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8007906271985204 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_rech_adressen_vollstaendigkeit',
  p_validation_sequence=> 40,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_plz_rech          personenstamm.plz%TYPE;'||unistr('\000a')||
'   v_ort_rech          personenstamm.ort%TYPE;'||unistr('\000a')||
'   v_land_id_rech      personenstamm.land_id%TYPE;'||unistr('\000a')||
'   v_strasse_rech      personenstamm.strasse%TYPE;'||unistr('\000a')||
'   v_name_rech         personenstamm.name%TYPE;'||unistr('\000a')||
'   v_vorname_rech      personenstamm.vorname%TYPE;'||unistr('\000a')||
'   v_prot_id           number;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''check_adressen_vollstaendigkeit 1'',v_prot_id,''TEST'',''102/308: check_adressen_vollstaendigkeit'');'||unistr('\000a')||
'   -- Rechnungsadresse müssen vollständig sein'||unistr('\000a')||
'   -- holen der Rechadr aus WK, da Region hidden sein kann und '||unistr('\000a')||
'   -- dann die Werte fuer die persstamm_id nicht vorhanden ist'||unistr('\000a')||
'   SELECT p.plz, p.ort, p.land_id,p.strasse,p.name, p.vorname'||unistr('\000a')||
'   INTO v_plz_rech, v_ort_rech, v_land_id_rech,v_strasse_rech,v_name_rech,v_vorname_rech'||unistr('\000a')||
'   FROM personenstamm p, warenkoerbe_tmp wk'||unistr('\000a')||
'   WHERE wk.id = :p508_id'||unistr('\000a')||
'     AND wk.persstamm_id_rechnung =p.id;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_plz_rech is NULL OR v_ort_rech is NULL OR v_land_id_rech is NULL OR'||unistr('\000a')||
'      v_strasse_rech IS NULL OR v_name_rech IS NULL -- OR v_vorname_rech IS NULL -- Vorname bei Ident meist NULL'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      -- ''Die Rechnungsadresse ist unvollständig! Die Felder Name, Vorname, Strasse, PLZ, Ort und Land sind eingabepflichtige Felder. Bitte tragen Sie die fehlende Information nach.'';  '||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5569,:fas_sprache_id);	'||unistr('\000a')||
'   END IF;   '||unistr('\000a')||
'   RETURN '''';'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_when_button_pressed=> 7996631351985159 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 8008122357985204 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_adress_kompatibel',
  p_validation_sequence=> 50,
  p_validation => 'Declare'||unistr('\000a')||
'   v_return NUMBER;'||unistr('\000a')||
'   v_fehlertext uebersetzungen.text%TYPE;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   v_return := frgbg_s.WK_CHECK_ADR_KOMPATIBEL(p_persstamm_id_prod_apo => :P508_PERSSTAMM_ID_prod_apo,'||unistr('\000a')||
'                                               p_persstamm_id_kunde    => :P508_PERSSTAMM_ID_kunde,'||unistr('\000a')||
'                                               p_persstamm_id_lieferung=> :P508_PERSSTAMM_ID_LIEFERUNG,'||unistr('\000a')||
'                                               p_persstamm_id_rechnung => :P508_PERSSTAMM_ID_RECHNUNG,'||unistr('\000a')||
'                                               p_warenkorb_tmp_id      => NULL,  -- NEI 05.06.2014'||unistr('\000a')||
'                                               p_sprache_id            => :fas_sprache_id ,'||unistr('\000a')||
'                                               p_fehlertext_out        => v_fehlertext'||unistr('\000a')||
'                                               );'||unistr('\000a')||
'   IF v_return = 1 THEN'||unistr('\000a')||
'      RETURN '''';'||unistr('\000a')||
'   ELSIF v_fehlertext is not null THEN'||unistr('\000a')||
'      --''Die Lieferadresse muss auch in der Schweiz liegen, da die Kunden-/ die Rechnungsadresse in der Schweiz liegt!'''||unistr('\000a')||
'      -- ''Liefer- und Kundenadresse müssen im gleichen Land liegen'||unistr('\000a')||
'      RETURN v_fehlertext;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      RETURN frgbg_s.holen_uebersetzung(5727,:fas_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition_type=> 'NEVER',
  p_when_button_pressed=> 7996631351985159 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 9486819228694534 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 508
 ,p_name => 'open_versandkosteninfo_modal'
 ,p_event_sequence => 10
 ,p_triggering_element_type => 'BUTTON'
 ,p_triggering_button_id => 9463506322283912 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'click'
  );
wwv_flow_api.create_page_da_action (
  p_id => 9487121266694542 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 508
 ,p_event_id => 9486819228694534 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_attribute_02 => 'STATIC'
 ,p_attribute_03 => 'f?p=&APP_ID.:995:&APP_SESSION.:::995:P995_INFO_TEXT_ID,P995_REGIONTITEL_TEXT_ID:10256,4319'
 ,p_attribute_06 => 'div#success-message'
 ,p_attribute_07 => 'AUTO'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p508_bl_abbrechen := --frgbg_s.holen_uebersetzung(510,v_sprache_id);'||unistr('\000a')||
'                         frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p508_bl_aendern := frgbg_s.holen_uebersetzung(3096,v_sprache_id);'||unistr('\000a')||
'   :p508_bl_auswahl := frgbg_s.holen_uebersetzung(4325,v_sprache_id);'||unistr('\000a')||
'   :P508_BL_VERSANDKOSTEN := frgbg';

p:=p||'_s.holen_uebersetzung(4319,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p508_BL_ZUR_KASSE :=  frgbg_s.holen_uebersetzung(3080,v_sprache_id);'||unistr('\000a')||
'   --:P508_MWST_LABEL:= frgbg_s.holen_uebersetzung(5522,v_sprache_id);'||unistr('\000a')||
'   :P508_MWST_LABEL:= frgbg_s.holen_uebersetzung(9726,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :p508_region_titel_warenkorb := frgbg_s.holen_uebersetzung(3075,v_sprache_id);'||unistr('\000a')||
'   :p508_region_titel_adresse := frgbg_s.holen_uebersetzung(9';

p:=p||'601,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P508_NV_WK_VERSAND:= frgbg_s.holen_uebersetzung(9600,v_sprache_id);'||unistr('\000a')||
'--mel.p(''button_labels_init ende'', v_prot_id,''Info'',''button_labels_init'');'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8008409328985210 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_process_sequence=> 51,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   UPDATE warenkoerbe_tmp'||unistr('\000a')||
'   SET wk_versandart_id = :p508_wk_versandart_id'||unistr('\000a')||
'   WHERE id = :p508_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8009622627985217 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'speichern_versandart',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request = ''P508_WK_VERSANDART_ID''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return number;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p (''In versankosten %1'',v_prot_id,''TEST'',''P102/308:gen_versandkosten'',:request);'||unistr('\000a')||
'   -- Versandkosten einhängen'||unistr('\000a')||
'   -- NEI 02.04.14 Zu Zeit noch keine Versandkosten bei WV'||unistr('\000a')||
'   --v_return:= frgbg_s.wk_gen_versandkosten(:P508_WARENKORB_TMP_ID,1);'||unistr('\000a')||
'   NULL;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8008628936985212 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_process_sequence=> 120,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'gen_versandkosten',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''P508_WK_VERSANDART_ID''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p508_id:=:p508_warenkorb_tmp_id;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8008829595985213 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_wk',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'   v_PERSSTAMM_ID_EXTERN_UPD personenstamm.id%TYPE;'||unistr('\000a')||
'   v_extern_typ   VARCHAR2(2);'||unistr('\000a')||
'   v_return       NUMBER;'||unistr('\000a')||
'   v_fehlertext   VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.p(''Rechnungsadresse eintragen: Pers=%1 id:%2 typ:%3! [page308,extadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'', :p508_id,:p508_persstamm_id_extern_upd,:p508_adresstyp_extern);'||unistr('\000a')||
'   v_PERSSTAMM_ID_EXTERN_UPD := :P';

p:=p||'508_persstamm_id_extern_upd;'||unistr('\000a')||
'   v_extern_typ   := :p508_adresstyp_extern;'||unistr('\000a')||
'   :P508_persstamm_id_extern_upd := NULL;'||unistr('\000a')||
'   :P508_adresstyp_extern:= NULL;'||unistr('\000a')||
'   IF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''R'' THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET persstamm_id_rechnung = v_PERSSTAMM_ID_EXTERN_UPD'||unistr('\000a')||
'         WHERE id = :p508_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'  ';

p:=p||'       MEL.p(''Rechnungsadresse speichern: WK=%1 id:%2! Fehler:%3 [page300,Rechnungsadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'',:p508_id,v_PERSSTAMM_ID_EXTERN_UPD, SQLERRM);'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSIF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''L'' THEN'||unistr('\000a')||
'      v_return := frgbg_s.WK_CHECK_ADR_KOMPATIBEL(p_persstamm_id_prod_apo => :P508_PERSSTAMM_ID_prod_apo,'||unistr('\000a')||
'                                ';

p:=p||'               p_persstamm_id_kunde    => :P508_PERSSTAMM_ID_kunde,'||unistr('\000a')||
'                                               p_persstamm_id_lieferung=> v_PERSSTAMM_ID_EXTERN_UPD,'||unistr('\000a')||
'                                               p_persstamm_id_rechnung => :P508_PERSSTAMM_ID_RECHNUNG,'||unistr('\000a')||
'                                               p_warenkorb_tmp_id      => NULL,  -- NEI 05.06.2014'||unistr('\000a')||
'                             ';

p:=p||'                  p_sprache_id            => :fas_sprache_id ,'||unistr('\000a')||
'                                               p_fehlertext_out        => v_fehlertext'||unistr('\000a')||
'                                               );'||unistr('\000a')||
'      IF v_return = 1 THEN'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
'            UPDATE warenkoerbe_tmp'||unistr('\000a')||
'            SET persstamm_id_lieferung = v_PERSSTAMM_ID_EXTERN_UPD'||unistr('\000a')||
'            WHERE id = :p508_id;'||unistr('\000a')||
'            -- Neue Ver';

p:=p||'sandkosten ermitteln'||unistr('\000a')||
'            --v_return := frgbg_s.WK_GEN_VERSANDKOSTEN( :p508_id,1) ;'||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
'         WHEN others THEN'||unistr('\000a')||
'            MEL.p(''Lieferadresse speichern: WK=%1 id:%2! Fehler:%3 [page308,Lieferadresse speichern]'','||unistr('\000a')||
'                  v_PROT_ID, ''ERROR'', ''fas'',:p508_id,v_PERSSTAMM_ID_EXTERN_UPD, SQLERRM);'||unistr('\000a')||
'         END;'||unistr('\000a')||
'      ELSIF v_fehlertext is not null THEN -- Adressprüffe';

p:=p||'hler; Adresse wurde nicht übernommen'||unistr('\000a')||
'         v_fehlertext:= v_fehlertext || '' ''|| frgbg_s.holen_uebersetzung(9604,:fas_sprache_id);'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         htp.p(''alert("''||v_fehlertext||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''</body>'');'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_fehlertext :=  frgbg_s.holen_uebersetzung(5727,:fas_sprache_id)|';

p:=p||'|'' ''|| frgbg_s.holen_uebersetzung(9604,:fas_sprache_id);'||unistr('\000a')||
'         htp.p(''<body>'');'||unistr('\000a')||
'         htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'         htp.p(''alert("''||v_fehlertext||''");'');'||unistr('\000a')||
'         htp.p(''</script>'');'||unistr('\000a')||
'         htp.p(''</body>'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSIF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''P'' THEN'||unistr('\000a')||
'      -- 6.12.10 Wechsel des Patient eigentlich nicht mehr möglich, da nu';

p:=p||'r noch Patientenstamm'||unistr('\000a')||
'      -- aenderbar => wk verlassen u. korrekten Patient auswaehlen'||unistr('\000a')||
'      :P508_PERSSTAMM_ID:= v_PERSSTAMM_ID_EXTERN_UPD; '||unistr('\000a')||
'   ELSIF v_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND v_extern_typ = ''RS'' THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE warenkoerbe_tmp'||unistr('\000a')||
'         SET persstamm_id_rechnungssteller = v_PERSSTAMM_ID_EXTERN_UPD'||unistr('\000a')||
'         WHERE id = :p508_id;'||unistr('\000a')||
'         -- Neue Versandkosten ermi';

p:=p||'tteln'||unistr('\000a')||
'         --v_return := frgbg_s.WK_GEN_VERSANDKOSTEN( :p508_id,1);'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         MEL.p(''Rechnungssteller speichern: WK=%1 id:%2! Fehler:%3 [page308,Rechnungssteller speichern]'','||unistr('\000a')||
'               v_PROT_ID, ''ERROR'', ''fas'',:p508_id,v_PERSSTAMM_ID_EXTERN_UPD, SQLERRM);'||unistr('\000a')||
'      END; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8009228680985216 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_process_sequence=> 60,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'externe_adressen_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p508_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND :p508_adresstyp_extern is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:WARENKOERBE_TMP:P508_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 8009012987985213 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_process_sequence=> 90,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'Fetch Row from WARENKOERBE_TMP',
  p_process_sql_clob => p,
  p_process_error_message=> 'fehler in row select #SQLERRM# &P300_WARENKORB_TMP_ID.',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':p508_warenkorb_tmp_id is not null',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   -- Prozentsatz der komplette Höhe ausnutzen (% des Maximums)'||unistr('\000a')||
'   :P508_HEIGHT_warenkorb := :FAS_SCROLLREGION_HEIGHT_MAX * 0.8;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8009412410985217 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 508,
  p_process_sequence=> 100,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'scrollheight_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 508
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00550
prompt  ...PAGE 550: Job Liste
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 550
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Job Liste'
 ,p_step_title => 'Job Liste'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Job Liste'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_step_template => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141204115740'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select'||unistr('\000a')||
'           CASE WHEN NVL(aufgabe_aktuell,beschreibung) is not NULL THEN'||unistr('\000a')||
'              ''<div style="height:20px; font-weight:bold;">'''||unistr('\000a')||
'              || CASE WHEN LENGTH(NVL(aufgabe_aktuell,beschreibung)) > 40 THEN'||unistr('\000a')||
'                    DBMS_LOB.SUBSTR(NVL(aufgabe_aktuell,beschreibung),40,1) || ''...'''||unistr('\000a')||
'                 ELSE'||unistr('\000a')||
'                    NVL(aufgabe_aktuell,beschreibung)'||unistr('\000a')||
'                 END';

s:=s||''||unistr('\000a')||
'               || ''</div>'''||unistr('\000a')||
'           ELSE'||unistr('\000a')||
'              '''''||unistr('\000a')||
'           END'||unistr('\000a')||
'           ||'||unistr('\000a')||
'           FRGBG_T.HTML_CREATE_GRAPH (fortschritt,'||unistr('\000a')||
'              case WHEN STATUS_ID = 1'||unistr('\000a')||
'                then trim(to_char(fortschritt,''990D9'')) || '' %'''||unistr('\000a')||
'              WHEN STATUS_ID = 4'||unistr('\000a')||
'                then'||unistr('\000a')||
'                  frgbg_s.HOLEN_UEBERSETZUNG(TEXT_ID,:FAS_SPRACHE_ID) ||'||unistr('\000a')||
'                  case when fe';

s:=s||'hlermeldung is not null then'||unistr('\000a')||
'                     '' (<a href="javascript:alert('''''' || FRGBG_T.JSON_ESCAPE_TEXT(fehlermeldung) || '' '''');">?</a>)'''||unistr('\000a')||
'                  else'||unistr('\000a')||
'                     '''''||unistr('\000a')||
'                  end'||unistr('\000a')||
'              ELSE'||unistr('\000a')||
'                  frgbg_s.HOLEN_UEBERSETZUNG(TEXT_ID,:FAS_SPRACHE_ID)'||unistr('\000a')||
'              END'||unistr('\000a')||
'              || CASE WHEN DOWNLOAD_DATEI IS NOT NULL THEN'||unistr('\000a')||
'               '' (<a';

s:=s||' href="javascript:apex.submit({request:''''DOWNLOAD_FILE'' || a.ID || ''''''});">'''||unistr('\000a')||
'                 || FRGBG_S.holen_uebersetzung(8026,:FAS_SPRACHE_ID) || ''</a>)'''||unistr('\000a')||
'              ELSE'||unistr('\000a')||
'                '''''||unistr('\000a')||
'              END'||unistr('\000a')||
'             ,280,20,''cccccc'','||unistr('\000a')||
'                  case when fortschritt <= 30'||unistr('\000a')||
'                     THEN ''BF381A'''||unistr('\000a')||
'                  when fortschritt > 30 and fortschritt <= 70'||unistr('\000a')||
'             ';

s:=s||'        then ''DF7401'' --''EFD13B'''||unistr('\000a')||
'                  when fortschritt > 70'||unistr('\000a')||
'                     then ''7DC24B'''||unistr('\000a')||
'                  else'||unistr('\000a')||
'                     ''5069B3'''||unistr('\000a')||
'                  end'||unistr('\000a')||
'              ,''000000'',''ffffff'''||unistr('\000a')||
'        ) FORTSCHRITT_GRAFIK'||unistr('\000a')||
'        , -- Löschbutton'||unistr('\000a')||
'        CASE WHEN NVL(aufgabe_aktuell,beschreibung) is not NULL'||unistr('\000a')||
'          THEN ''<div style="height:20px;">&nbsp;</div>'''||unistr('\000a')||
'          ';

s:=s||'ELSE '''''||unistr('\000a')||
'        END'||unistr('\000a')||
'        || ''<input type="button" style="height:20px; margin-bottom:1px;" value="X"'''||unistr('\000a')||
'        || '' onclick="javascript:apex.submit({request:''''DEL_JOB'' || a.ID || ''''''});" />'''||unistr('\000a')||
'        DEL'||unistr('\000a')||
''||unistr('\000a')||
'    from FRGBG.APP_JOBS a, FRGBG.APP_JOB_STATUS s'||unistr('\000a')||
'    where'||unistr('\000a')||
'      app_id = :APP_ID'||unistr('\000a')||
'      and USER_ACCOUNT = :APP_USER'||unistr('\000a')||
'      --and status_ID not in(STATUS_CANCELED)'||unistr('\000a')||
'      and a.MUTDAT > sysdate - ';

s:=s||'24/60 -- Maximal 60 Minuten halten'||unistr('\000a')||
'      and a.satz_kennzeichen is null'||unistr('\000a')||
'      and a.visible = 1'||unistr('\000a')||
'      and a.STATUS_ID = s.id'||unistr('\000a')||
'      and (a.STATUS_ID = 1 and a.JOB_ID in (select JOB from dba_jobs_running) or a.STATUS_ID <> 1)'||unistr('\000a')||
'    order by a.ERFDAT ASC';

wwv_flow_api.create_report_region (
  p_id=> 9170113175807029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 550,
  p_name=> 'App Jobs',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 10,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 12,
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9170324242807032 + wwv_flow_api.g_id_offset,
  p_region_id=> 9170113175807029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'FORTSCHRITT_GRAFIK',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9170427147807033 + wwv_flow_api.g_id_offset,
  p_region_id=> 9170113175807029 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'DEL',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'CENTER',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>9174813330807054 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 550,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:550:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 15-MAY-2014 18:28 by SASCHA.LENZ');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9170529187807034 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 550,
  p_name=>'P550_REQUEST',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 9170113175807029+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9170716758807037 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 550,
  p_name=>'P550_ANZAHL_JOBS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 9170113175807029+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'select  COUNT(*)'||unistr('\000a')||
'from FRGBG.APP_JOBS a, FRGBG.APP_JOB_STATUS s'||unistr('\000a')||
'where'||unistr('\000a')||
'  app_id = :APP_ID'||unistr('\000a')||
'  and USER_ACCOUNT = :APP_USER'||unistr('\000a')||
'  --and status_ID not in(STATUS_CANCELED)'||unistr('\000a')||
'  and a.MUTDAT > sysdate - 24/60 -- Maximal 60 Minuten halten'||unistr('\000a')||
'  and a.satz_kennzeichen is null'||unistr('\000a')||
'  and a.visible = 1'||unistr('\000a')||
'  and a.STATUS_ID = s.id'||unistr('\000a')||
'  and (a.STATUS_ID = 1 and a.JOB_ID in (select JOB from dba_jobs_running) or a.STATUS_ID <> 1)',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9170926592807038 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 550,
  p_name=>'P550_DOWNLOAD_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 9170113175807029+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => 'Wird verwendet um automatisch den Download anzubieten');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9171104627807039 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 550,
  p_name=>'P550_UMLEITUNG_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 9170113175807029+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 9173706767807053 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_name => 'Starte Aktualisierungstimer'
 ,p_event_sequence => 10
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 9174220166807053 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_event_id => 9173706767807053 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM.ORACLE.APEX.TIMER'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 9170113175807029 + wwv_flow_api.g_id_offset
 ,p_attribute_01 => 'add'
 ,p_attribute_02 => 'REFRESHER'
 ,p_attribute_04 => '2000'
 ,p_attribute_05 => 'infinite'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 9174014368807053 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_event_id => 9173706767807053 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '$(document).ready(function() {'||unistr('\000a')||
' '||unistr('\000a')||
'  if(parent && parent.document) {'||unistr('\000a')||
'    parent.$( "#jobliste").draggable();'||unistr('\000a')||
'  }'||unistr('\000a')||
''||unistr('\000a')||
'});'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 9171925923807045 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_name => 'Job Liste Aktualisieren'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'REGION'
 ,p_triggering_region_id => 9170113175807029 + wwv_flow_api.g_id_offset
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'PLUGIN_COM.ORACLE.APEX.TIMER|DYNAMIC ACTION|timer_expired'
  );
wwv_flow_api.create_page_da_action (
  p_id => 9172620946807051 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_event_id => 9171925923807045 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_REFRESH'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 9170113175807029 + wwv_flow_api.g_id_offset
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 9172825095807051 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_event_id => 9171925923807045 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'begin'||unistr('\000a')||
'select  NVL(COUNT(*),0) into :P550_ANZAHL_JOBS'||unistr('\000a')||
'from FRGBG.APP_JOBS a, FRGBG.APP_JOB_STATUS s'||unistr('\000a')||
'where'||unistr('\000a')||
'  app_id = :APP_ID'||unistr('\000a')||
'  and USER_ACCOUNT = :APP_USER'||unistr('\000a')||
'  --and status_ID not in(STATUS_CANCELED)'||unistr('\000a')||
'  and a.MUTDAT > sysdate - 24/60 -- Maximal 60 Minuten halten'||unistr('\000a')||
'  and a.satz_kennzeichen is null'||unistr('\000a')||
'  and a.visible = 1'||unistr('\000a')||
'  and a.STATUS_ID = s.id'||unistr('\000a')||
'  and (a.STATUS_ID = 1 and a.JOB_ID in (select JOB from dba_jobs_running) or a.STATUS_ID <> 1)'||unistr('\000a')||
';'||unistr('\000a')||
''||unistr('\000a')||
'end;'
 ,p_attribute_02 => 'P550_ANZAHL_JOBS'
 ,p_attribute_03 => 'P550_ANZAHL_JOBS'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 9172212639807049 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_event_id => 9171925923807045 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 30
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'if(parent && parent.$) {'||unistr('\000a')||
''||unistr('\000a')||
'   var anzahl_jobs = $v(''P550_ANZAHL_JOBS'');'||unistr('\000a')||
''||unistr('\000a')||
'   if(anzahl_jobs == ''0'') {'||unistr('\000a')||
'     '||unistr('\000a')||
'      // Entferne den iFrame, da kein Job mehr angezeigt wird'||unistr('\000a')||
'      parent.$(''#jobliste'').fadeOut(2000,function() { parent.$(''#jobliste'').remove(); }); '||unistr('\000a')||
''||unistr('\000a')||
'   } else if(anzahl_jobs !== null) {'||unistr('\000a')||
'      var listhoehe = parseInt(anzahl_jobs)*47 + 38;'||unistr('\000a')||
''||unistr('\000a')||
'      if(parent.$(''#jobliste'').height() <10) { // Beim Seitenaufruf keine Animation'||unistr('\000a')||
'          parent.$(''#jobliste'').css({ height: listhoehe.toString() + ''px'' }); '||unistr('\000a')||
'      } else {'||unistr('\000a')||
'          if(listhoehe  < parent.$(''#jobliste'').height()-5 || listhoehe > parent.$(''#jobliste'').height()+5) { // Nur Animieren wenn auch ein unterschied ist, da sonst das Fenster flackert'||unistr('\000a')||
'            //Ändere die Größe des Fensters abhängig von der Anzahl der Jobs'||unistr('\000a')||
'            parent.$(''#jobliste'').animate({ height: listhoehe.toString() + ''px'' },500); '||unistr('\000a')||
'          }'||unistr('\000a')||
'      }'||unistr('\000a')||
'   }'||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 9172400146807051 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_event_id => 9171925923807045 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 40
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_EXECUTE_PLSQL_CODE'
 ,p_attribute_01 => 'declare'||unistr('\000a')||
''||unistr('\000a')||
'    v_PROT_ID number;'||unistr('\000a')||
'    v_ERROR varchar2(32767);'||unistr('\000a')||
'    v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'    c_PROD constant varchar2(100) := ''APP 102, Page 550 Dynamic Action: Job Liste Aktualisieren'';'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR EXCEPTION;'||unistr('\000a')||
'    c_ERRNR constant number := -20100;'||unistr('\000a')||
''||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
''||unistr('\000a')||
'    -- Exception, die bewirkt das durchgereichte Exceptions einfach weitergegeben werden.'||unistr('\000a')||
'    e_ERROR_D EXCEPTION;'||unistr('\000a')||
'    c_ERRNR_D constant number := -20101;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Alle aktiven Jobs, die einen Status wechsel hatten'||unistr('\000a')||
'  cursor c_job is '||unistr('\000a')||
'      select * from APP_JOBS a'||unistr('\000a')||
'      where'||unistr('\000a')||
'       app_id = :APP_ID'||unistr('\000a')||
'       and USER_ACCOUNT = :APP_USER'||unistr('\000a')||
'       and a.MUTDAT > sysdate - 24/60 -- Maximal 60 Minuten halten'||unistr('\000a')||
'       and a.satz_kennzeichen is null'||unistr('\000a')||
'       and a.visible = 1'||unistr('\000a')||
'       and (a.STATUS_ID = FRGBG_JOBS.STATUS_RUNNING and a.JOB_ID in (select JOB from dba_jobs_running) or a.STATUS_ID <> FRGBG_JOBS.STATUS_RUNNING)'||unistr('\000a')||
'       and a.STATUS_ID <> a.STATUS_ID_LAST'||unistr('\000a')||
'  ;'||unistr('\000a')||
'  '||unistr('\000a')||
'  v_exit boolean := true;'||unistr('\000a')||
'begin'||unistr('\000a')||
'  :P550_DOWNLOAD_ID := NULL;'||unistr('\000a')||
'  :P550_UMLEITUNG_URL := NULL;'||unistr('\000a')||
''||unistr('\000a')||
'  for v_job in c_job loop'||unistr('\000a')||
''||unistr('\000a')||
'    if(v_job.DOWNLOAD_DATEI is not NULL AND v_job.STATUS_ID = FRGBG_JOBS.STATUS_COMPLETE) THEN'||unistr('\000a')||
'        :P550_DOWNLOAD_ID := v_job.ID;'||unistr('\000a')||
''||unistr('\000a')||
'        v_exit := true;'||unistr('\000a')||
'        '||unistr('\000a')||
''||unistr('\000a')||
'    end if;'||unistr('\000a')||
''||unistr('\000a')||
'    if(v_job.UMLEITUNG_URL is not null AND v_job.STATUS_ID = FRGBG_JOBS.STATUS_COMPLETE) THEN'||unistr('\000a')||
'      '||unistr('\000a')||
'        :P550_UMLEITUNG_URL := apex_util.prepare_url(v_job.UMLEITUNG_URL);'||unistr('\000a')||
''||unistr('\000a')||
'        v_exit := true;'||unistr('\000a')||
''||unistr('\000a')||
'    end if;'||unistr('\000a')||
''||unistr('\000a')||
'    if v_exit then'||unistr('\000a')||
''||unistr('\000a')||
'        begin'||unistr('\000a')||
'          -- Damit es beim nächsten Durchlauf nicht mehr gezogen wird. (Nur einmal zum Download anbieten.'||unistr('\000a')||
'          UPDATE APP_JOBS SET'||unistr('\000a')||
'             STATUS_ID_LAST = STATUS_ID'||unistr('\000a')||
'          WHERE'||unistr('\000a')||
'             ID = v_job.ID;'||unistr('\000a')||
'        exception'||unistr('\000a')||
'          when others then'||unistr('\000a')||
'            v_error := ''Fehler beim aktualisieren des letzten Job-Status '' || sqlerrm;'||unistr('\000a')||
'            v_errnr := -10;'||unistr('\000a')||
'            raise e_error;'||unistr('\000a')||
'        end;'||unistr('\000a')||
''||unistr('\000a')||
'        exit; -- Immer nur eins zum Dowload anbieten'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'    end if;'||unistr('\000a')||
'  end loop;'||unistr('\000a')||
''||unistr('\000a')||
'  begin'||unistr('\000a')||
'    UPDATE APP_JOBS SET'||unistr('\000a')||
'      VISIBLE = 0'||unistr('\000a')||
'    WHERE'||unistr('\000a')||
'     app_id = :APP_ID'||unistr('\000a')||
'     and USER_ACCOUNT = :APP_USER'||unistr('\000a')||
'     and VISIBLE = 1'||unistr('\000a')||
'     and SATZ_KENNZEICHEN is null'||unistr('\000a')||
'     and ((HIDE_BY_COMPLETE = 1 AND STATUS_ID = FRGBG_JOBS.STATUS_COMPLETE) '||unistr('\000a')||
'         OR STATUS_ID IN (FRGBG_JOBS.STATUS_KILLED,FRGBG_JOBS.STATUS_CANCELED)'||unistr('\000a')||
'     );'||unistr('\000a')||
'  exception'||unistr('\000a')||
'    when others then'||unistr('\000a')||
'      v_error := ''Fehler beim Entfernen von fertigen Jobs mit Auto-Hide. SQLERRM: '' || SQLERRM;'||unistr('\000a')||
'      v_errnr := -20;'||unistr('\000a')||
'      raise e_error;'||unistr('\000a')||
'  end;'||unistr('\000a')||
''||unistr('\000a')||
'exception'||unistr('\000a')||
'        when e_ERROR then'||unistr('\000a')||
'            MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v_error, v_PROT_ID, ''ERROR'', dbms_utility.format_error_backtrace);'||unistr('\000a')||
'            raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'            raise;'||unistr('\000a')||
'        when e_ERROR_D then'||unistr('\000a')||
'            raise; -- Einfach durchreichen'||unistr('\000a')||
'        when others then'||unistr('\000a')||
'            v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLERRM:'' || SQLERRM;'||unistr('\000a')||
'            MEL.P (c_PROD || '': '' || v_error, v_PROT_ID, ''ERROR'', dbms_utility.format_error_backtrace);'||unistr('\000a')||
'            raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'            raise;'||unistr('\000a')||
''||unistr('\000a')||
'end;'
 ,p_attribute_03 => 'P550_DOWNLOAD_ID,P550_UMLEITUNG_URL'
 ,p_attribute_04 => 'N'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 9172932077807051 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_name => 'Beende Aktualisierung'
 ,p_event_sequence => 30
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P550_ANZAHL_JOBS'
 ,p_triggering_condition_type => 'EQUALS'
 ,p_triggering_expression => '0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 9173222693807052 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_event_id => 9172932077807051 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'PLUGIN_COM.ORACLE.APEX.TIMER'
 ,p_affected_elements_type => 'REGION'
 ,p_affected_region_id => 9170113175807029 + wwv_flow_api.g_id_offset
 ,p_attribute_01 => 'remove'
 ,p_attribute_03 => 'REFRESHER'
 ,p_attribute_05 => 'infinite'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 9173332014807052 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_name => 'Starte Download automatisch'
 ,p_event_sequence => 40
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P550_DOWNLOAD_ID'
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$v(''P550_DOWNLOAD_ID'').length > 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 9173612889807052 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_event_id => 9173332014807052 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'if($v(''P550_DOWNLOAD_ID'').length > 0) {'||unistr('\000a')||
'  // Download automatisch starten '||unistr('\000a')||
'  apex.submit({request: ''DOWNLOAD_FILE'' + $v(''P550_DOWNLOAD_ID'')});'||unistr('\000a')||
''||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 9174320774807053 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_name => 'Auto-Umleitung'
 ,p_event_sequence => 50
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P550_UMLEITUNG_URL'
 ,p_triggering_condition_type => 'JAVASCRIPT_EXPRESSION'
 ,p_triggering_expression => '$v(''P550_UMLEITUNG_URL'').length > 0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
  );
wwv_flow_api.create_page_da_action (
  p_id => 9174625298807054 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 550
 ,p_event_id => 9174320774807053 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => 'if(parent.window) {'||unistr('\000a')||
'    parent.window.location.href = $v(''P550_UMLEITUNG_URL'');'||unistr('\000a')||
'}'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
''||unistr('\000a')||
'  :P550_REQUEST := :REQUEST;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 9171700286807045 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 550,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set download request',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'  c_PROD constant varchar2(2000) := ''app:'' || :APP_ID || '' page: '' ||:APP_PAGE_ID || '' Process: Entferne Job'';'||unistr('\000a')||
'  -- Globale Variablen'||unistr('\000a')||
'  v_PROT_ID number;'||unistr('\000a')||
'  v_ERROR varchar2(32767);'||unistr('\000a')||
'  v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'  c_PACKAGE constant varchar2(100) := ''UTIL_DATEIEN'';'||unistr('\000a')||
''||unistr('\000a')||
'  e_ERROR EXCEPTION;'||unistr('\000a')||
'  c_ERRNR constant number := -20100;'||unistr('\000a')||
''||unistr('\000a')||
'  PRAGMA EXCEPTION_INIT(e_ERROR,-20100);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Exception, die bewirkt das durc';

p:=p||'hgereichte Exceptions einfach weitergegeben werden.'||unistr('\000a')||
'  e_ERROR_D EXCEPTION;'||unistr('\000a')||
'  c_ERRNR_D constant number := -20101;'||unistr('\000a')||
'  PRAGMA EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
''||unistr('\000a')||
'  v_status number;'||unistr('\000a')||
'  v_job_id number;'||unistr('\000a')||
'  '||unistr('\000a')||
''||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'   begin '||unistr('\000a')||
'      v_job_id := to_number(substr(:REQUEST,length(''DEL_JOB'') + 1));'||unistr('\000a')||
'   exception'||unistr('\000a')||
'      when others then'||unistr('\000a')||
'        v_error := ''Die Job ID konnte nicht aus der Anfrage '' ||:REQUEST '||unistr('\000a')||
'    ';

p:=p||'       || '' ermittelt werden. SQLERRM:'' || sqlerrm;'||unistr('\000a')||
'        v_errnr := -10;'||unistr('\000a')||
'        raise e_error;'||unistr('\000a')||
'   end;'||unistr('\000a')||
''||unistr('\000a')||
'   FRGBG_JOBS.REMOVE_JOB(v_job_id);'||unistr('\000a')||
''||unistr('\000a')||
'exception'||unistr('\000a')||
'        when e_ERROR then'||unistr('\000a')||
'            MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v_error, v_PROT_ID, ''ERROR'', dbms_utility.format_error_backtrace);'||unistr('\000a')||
'            raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'            raise;'||unistr('\000a')||
'        when e_ERRO';

p:=p||'R_D then'||unistr('\000a')||
'            raise; -- Einfach durchreichen'||unistr('\000a')||
'        when others then'||unistr('\000a')||
'            v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLERRM:'' || SQLERRM;'||unistr('\000a')||
'            MEL.P (c_PROD || '': '' || v_error, v_PROT_ID, ''ERROR'', dbms_utility.format_error_backtrace);'||unistr('\000a')||
'            raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'            raise;'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 9171310007807042 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 550,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Job Abbrechen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':REQUEST is not null and SUBSTR(:REQUEST,1,length(''DEL_JOB'')) = ''DEL_JOB''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_blob blob;'||unistr('\000a')||
'   v_dateiname varchar2(2000);'||unistr('\000a')||
'   v_size number;'||unistr('\000a')||
'   v_lastchange date;'||unistr('\000a')||
'   v_id number;'||unistr('\000a')||
'   v_mimetype varchar2(100);'||unistr('\000a')||
''||unistr('\000a')||
'   v_PROT_ID number;'||unistr('\000a')||
'    v_ERROR varchar2(32767);'||unistr('\000a')||
'    v_ERRNR number;'||unistr('\000a')||
''||unistr('\000a')||
'    c_PROD constant varchar2(100) := ''APP 102, Page 550 Process: Download Datei'';'||unistr('\000a')||
''||unistr('\000a')||
'    e_ERROR EXCEPTION;'||unistr('\000a')||
'    c_ERRNR constant number := -20100;'||unistr('\000a')||
''||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR,-20100);';

p:=p||''||unistr('\000a')||
''||unistr('\000a')||
'    -- Exception, die bewirkt das durchgereichte Exceptions einfach weitergegeben werden.'||unistr('\000a')||
'    e_ERROR_D EXCEPTION;'||unistr('\000a')||
'    c_ERRNR_D constant number := -20101;'||unistr('\000a')||
'    PRAGMA EXCEPTION_INIT(e_ERROR_D,-20101);'||unistr('\000a')||
''||unistr('\000a')||
'begin'||unistr('\000a')||
''||unistr('\000a')||
'   begin'||unistr('\000a')||
'   -- Hole Blob content'||unistr('\000a')||
'   select DOWNLOAD_DATEI,'||unistr('\000a')||
'          dbms_lob.getlength(DOWNLOAD_DATEI),'||unistr('\000a')||
'          mutdat,'||unistr('\000a')||
'          id,'||unistr('\000a')||
'          DOWNLOAD_DATEINAME'||unistr('\000a')||
'   into v_blob,'||unistr('\000a')||
'       ';

p:=p||' v_size,'||unistr('\000a')||
'        v_lastchange,'||unistr('\000a')||
'        v_id,'||unistr('\000a')||
'        v_dateiname'||unistr('\000a')||
'   from APP_JOBS'||unistr('\000a')||
'   where id = to_number(substr(:P550_REQUEST,length(''DOWNLOAD_FILE'') + 1)) -- Die ID steht direkt nach dem Request namen'||unistr('\000a')||
'         and app_id = :APP_ID'||unistr('\000a')||
'         and USER_ACCOUNT = :APP_USER'||unistr('\000a')||
'         and satz_kennzeichen is null;'||unistr('\000a')||
'   exception'||unistr('\000a')||
'    when no_data_found then '||unistr('\000a')||
'      v_blob := null;'||unistr('\000a')||
'   end;'||unistr('\000a')||
''||unistr('\000a')||
'   if(v_blob is n';

p:=p||'ot null) then'||unistr('\000a')||
'    v_mimetype := ''application/octet'';'||unistr('\000a')||
'    '||unistr('\000a')||
'    -- Im HTTP-Header wird der Dateityp gesetzt. Damit erkennt der Browser'||unistr('\000a')||
'    -- welche Applikation (bspw. MS Word) zu starten ist'||unistr('\000a')||
'    owa_util.mime_header(NVL(v_mimetype,''application/octet''),false);'||unistr('\000a')||
''||unistr('\000a')||
'    -- Die Dateigröße wird dem Browser ebenfalls mitgeteilt'||unistr('\000a')||
'    htp.p(''Content-length:''|| v_size);'||unistr('\000a')||
''||unistr('\000a')||
'    -- Das Datum (LETZTE_AENDERUNG) wird';

p:=p||' ebenfalls als HTTP-Header gesetzt'||unistr('\000a')||
'    htp.p(''Date:''||to_char(v_lastchange,''Dy, DD Mon RRRR hh24:mi:ss'')||'' CET'');'||unistr('\000a')||
''||unistr('\000a')||
'    -- Der Parameter p_display steuert, ob die Datei direkt dargestellt oder'||unistr('\000a')||
'    -- ob dem Anwender ein Download-Dialog angeboten werden soll. Wie man sehen'||unistr('\000a')||
'    -- kann, richtet sich der Browser nach den Feldern im HTTP Header.'||unistr('\000a')||
'    htp.p(''Content-Disposition: attachment; filename="''|';

p:=p||'|v_dateiname || ''"'');'||unistr('\000a')||
''||unistr('\000a')||
'    -- Der Browser soll die Datei unter keinen Umständen aus dem Cache holen.'||unistr('\000a')||
'    htp.p(''Cache-Control: must-revalidate, max-age=0'');'||unistr('\000a')||
'    htp.p(''Expires: Thu, 01 Jan 1970 01:00:00 CET'');'||unistr('\000a')||
''||unistr('\000a')||
'    -- Die Datei bekommt eine ID - damit kann der Browser sie eindeutig erkennen.'||unistr('\000a')||
'    htp.p(''Etag: TAB_DATEIEN...''||v_id||''...''||to_char(v_lastchange, ''JHH24MISS''));'||unistr('\000a')||
''||unistr('\000a')||
'    -- Alle HTTP-Heade';

p:=p||'r-Felder sind gesetzt'||unistr('\000a')||
'    owa_util.http_header_close;'||unistr('\000a')||
''||unistr('\000a')||
'    -- Dieser kurze Aufruf führt den eigentlichen Datei-Download durch.'||unistr('\000a')||
'    wpg_docload.download_file(v_blob);'||unistr('\000a')||
''||unistr('\000a')||
'    :P550_REQUEST := null;'||unistr('\000a')||
'    -- Damit Apex nicht die Oberfläche darstellt'||unistr('\000a')||
'    apex_application.g_unrecoverable_error := true;'||unistr('\000a')||
''||unistr('\000a')||
'  end if;'||unistr('\000a')||
'exception'||unistr('\000a')||
'        when e_ERROR then'||unistr('\000a')||
'            MEL.P (c_PROD ||  ''('' || v_ERRNR || ''): '' || v';

p:=p||'_error, v_PROT_ID, ''ERROR'', dbms_utility.format_error_backtrace);'||unistr('\000a')||
'            raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'            raise;'||unistr('\000a')||
'        when e_ERROR_D then'||unistr('\000a')||
'            raise; -- Einfach durchreichen'||unistr('\000a')||
'        when others then'||unistr('\000a')||
'            v_ERROR := ''Unbekannter Fehler in '' || c_PROD || '' SQLERRM:'' || SQLERRM;'||unistr('\000a')||
'            MEL.P (c_PROD || '': '' || v_error, v_PROT_ID, ''ERROR'', dbms_utilit';

p:=p||'y.format_error_backtrace);'||unistr('\000a')||
'            raise_application_error(c_ERRNR_D, v_ERROR);'||unistr('\000a')||
'            raise;'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 9171505086807043 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 550,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Download Datei',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'upper(substr(:P550_REQUEST,1,length(''DOWNLOAD_FILE''))) = ''DOWNLOAD_FILE''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 550
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00900
prompt  ...PAGE 900: test
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 900
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'test'
 ,p_step_title => 'test'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141204115208'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 7718332431779800 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 900,
  p_plug_name=> 'Job Test',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => true,
  p_plug_new_grid_column  => true,
  p_plug_display_column=> null,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7718507628782128 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 900,
  p_name=>'P900_START_JOB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 7718332431779800+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_prompt=>'Start Job',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'begin'||unistr('\000a')||
''||unistr('\000a')||
'   FRGBG_JOBS.START_JOB('||unistr('\000a')||
'       p_what => ''FRGBG_JOBS.SLEEP(120000);'','||unistr('\000a')||
'       p_max_jobs_same          => 1,'||unistr('\000a')||
'       p_max_jobs_total         => 1'||unistr('\000a')||
'    );'||unistr('\000a')||
''||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 7718721106909056 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 900,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Start Job',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when_button_id=>7718507628782128 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> 'Empty Job gestartet',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 900
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00989
prompt  ...PAGE 989: PATIENTENSTAMMANZEIGE_MIT_PARAMEDI_140814
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 989
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'PATIENTENSTAMMANZEIGE_MIT_PARAMEDI_140814'
 ,p_step_title => 'PATIENTENSTAMMANZEIGE_MIT_PARAMEDI_140814'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'PATIENTENSTAMMANZEIGE_MIT_PARAMEDI_140814'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_help_text => 
'Keine Hilfe verhanden.'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140909145822'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10260917283603043 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 989,
  p_plug_name=> '&P989_PAGE_TITEL_RECHNUNGSADR.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON = ''BETREUER'' AND'||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_plug_header=> '<div style="min-width: 430px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10263115378603053 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 989,
  p_plug_name=> 'Navigationspfad',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2886213363489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'REGION_POSITION_01',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'M'|| to_char(6313313272633459 + wwv_flow_api.g_id_offset),
  p_menu_template_id=> 2900231998489446+ wwv_flow_api.g_id_offset,
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10263314150603053 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 989,
  p_plug_name=> '&P989_PAGE_TITEL_LIEFERADR.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 20,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 2,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => 'PLSQL_EXPRESSION',
  p_plug_display_when_condition => ':FAS_AUFGERUFEN_VON = ''BETREUER'' AND '||unistr('\000a')||
'NVL(:fas_modus_id,0) != 1 /* 1= IABC-Modus */',
  p_plug_header=> '<div style="min-width: 430px">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 10265517576603065 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 989,
  p_plug_name=> '&P989_PAGE_TITEL_PATIENTANZEIGE.',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 9,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="height: &FAS_SCROLLREGION_HEIGHT_MAX.px;max-width: 550px">'||unistr('\000a')||
'',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 10265705787603066 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 11,
  p_button_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_IDENTITAET',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_IDENTITAET.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(''&P989_IDENTABFR_TEXT.'',''APPLY_CHANGES_IDENTITAET'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER'' and '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''IDENTITAET_BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p989_betreuer in (''N'')'||unistr('\000a')||
'and :p989_id is not null'||unistr('\000a')||
'and :fas_pers_aenderbar = 1'||unistr('\000a')||
'and :p989_EXTERN_VERWALTET = 0   /* nicht GUS-Verwalt.*/',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10265927504603066 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 15,
  p_button_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_button_name    => 'APPLY_CHANGES_BETREUER',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_BETREUER.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(''&P989_BETRABFR_TEXT.'',''APPLY_CHANGES_BETREUER'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER'' and '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p989_betreuer in (''J'',''N'')'||unistr('\000a')||
'and :p989_id is not null'||unistr('\000a')||
'and :fas_pers_aenderbar = 1'||unistr('\000a')||
'/*GUS-Verwalt.*/'||unistr('\000a')||
'and (:p989_EXTERN_VERWALTET = 0 OR '||unistr('\000a')||
'     :p989_EXTERN_VERWALTET = 1  and :p989_betreuer=''J'' --wg. Zusatzdaten moegl. fuer GUS-Personen'||unistr('\000a')||
'    )'||unistr('\000a')||
'/* Betreuer mit spez.Iabc-Betreuerzugriff duerfen nur'||unistr('\000a')||
'   Patienten zu Betreuern machen, aber nicht wieder zu'||unistr('\000a')||
'   Patienten oder gar PW des Betreuers ändern'||unistr('\000a')||
'*/'||unistr('\000a')||
'and ((frgbg_s.get_pers_option(:APP_USER,28)= 1 AND'||unistr('\000a')||
'      :p989_betreuer in (''N''))'||unistr('\000a')||
'     OR'||unistr('\000a')||
'     frgbg_s.get_pers_option(:APP_USER,28)= 0'||unistr('\000a')||
'    )',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10261102276603046 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 70,
  p_button_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_button_name    => 'RECHNUNGSADRESSE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_AUSWAEHLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON = ''BETREUER'' AND '||unistr('\000a')||
':p989_id IS NOT NULL /* vorhandener Patient */ and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10263531503603053 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 70,
  p_button_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_button_name    => 'LIEFERADRESSE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_AUSWAEHLEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':FAS_AUFGERUFEN_VON = ''BETREUER'' AND '||unistr('\000a')||
':p989_id IS NOT NULL /* vorhandener Patient */'||unistr('\000a')||
'and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10261305903603047 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 80,
  p_button_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_button_name    => 'RECHLOESCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P989_PERSSTAMM_ID_RECHNUNG IS NOT NULL and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10263708604603054 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 80,
  p_button_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_button_name    => 'LIEFERLOESCHEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P989_PERSSTAMM_ID_LIEFERUNG IS NOT NULL and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10266107414603066 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 10,
  p_button_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_condition=> ':fas_aufgerufen_von = ''BETREUER''',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10266311467603067 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 30,
  p_button_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_button_name    => 'WARENKORB',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_WARENKORB.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':fas_aufgerufen_von != ''BETREUER'' AND :p989_id is not null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10266528552603067 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 35,
  p_button_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_button_name    => 'PASSWORT_CHANGE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_PASSWORT_CHG.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:popUp2(''&P989_PREPARE_URL_PW.'',700,380);',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'UPPER(:P989_USER_ACCOUNT)= UPPER(:APP_USER) AND :p989_id IS NOT NULL AND :fas_aufgerufen_von != ''ANONYM'''||unistr('\000a')||
'and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10266720712603067 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 40,
  p_button_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_button_name    => 'CREATE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':P989_ID is null',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'INSERT',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10266929263603067 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 50,
  p_button_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_button_name    => 'DELETE',
  p_button_action  => 'REDIRECT_URL',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_LOESCHEN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:confirmDelete(''&FAS_LOESCHABFRAGE_TEXT.'',''DELETE'');',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p989_id is not null AND :fas_aufgerufen_von != ''ANONYM'''||unistr('\000a')||
'and :fas_pers_aenderbar = 1'||unistr('\000a')||
'and :p989_EXTERN_VERWALTET = 0   /*nicht GUS-Verwalt.*/',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10267114423603068 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 90,
  p_button_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_button_name    => 'SAVE',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_AENDERN.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> ':p989_id is not null and :fas_pers_aenderbar = 1',
  p_button_condition_type=> 'PLSQL_EXPRESSION',
  p_database_action=>'UPDATE',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 10267327681603068 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 989,
  p_button_sequence=> 100,
  p_button_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_button_name    => 'FB_REZEPT',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P989_BL_FB_REZEPT.',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_button_condition=> 'P989_id',
  p_button_condition_type=> 'ITEM_IS_NOT_NULL',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>10298909745603172 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:140::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>10267327681603068+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 1,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>10299125982603174 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:111:&SESSION.::&DEBUG.::P111_ID:&P989_ID.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>10265927504603066+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 5,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p989_betreuer = ''J''',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>10299309095603174 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:300:P300_PERSSTAMM_ID,P300_ZURUECK_SEITE:&P989_ID.,&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>10266311467603067+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
wwv_flow_api.create_page_branch(
  p_id=>10299526809603175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:133:P133_PERSSTAMM_PATIENT_ID,P133_EXTERN_TYP:&P989_ID.,L&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3714421538647668+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 06-MAI-2008 11:13 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10299727366603175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:133:P133_PERSSTAMM_PATIENT_ID,P133_EXTERN_TYP:&P989_ID.,R&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3017725232670003+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 11,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 06-MAI-2008 11:13 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10299902356603175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:989::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 12,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':fas_aufgerufen_von = ''BETREUER'' AND :REQUEST in (''DELETE'',''CANCEL'')',
  p_branch_condition_text=>'130',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 04-AUG-2006 17:22 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10300108281603175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:989::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 31,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':fas_aufgerufen_von != ''BETREUER'' AND :REQUEST in (''DELETE'',''CANCEL'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 10-SEP-2007 14:24 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10300317264603176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'DOKUMENTEN_DRUCK.HCK_MED_ETIKETT?P_BESTELL_ID=&P989_BESTELL_ID.&P_POSITION=&P989_HCK_MED_DRUCKPOS.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 41,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p989_bestell_id is not null and'||unistr('\000a')||
':request in (''HCK_MED'')'||unistr('\000a')||
'and 1=2 /* Ersetzt durch Druck Prozess */',
  p_save_state_before_branch_yn=>'N',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset,
  p_branch_comment=> 'Created 02-SEP-2008 09:21 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10300500847603176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'DOKUMENTEN_DRUCK.HCK_MED_ETIKETT?P_BESTELL_ID=&P989_BESTELL_ID.&P_POSITION=&P989_HCK_MED_DRUCKPOS.',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 50,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p989_bestell_id is not null and :request in (''HCK_MED_NACHDRUCK'') '||unistr('\000a')||
'and 1=2 /* Ersetzt durch Druck Prozess */',
  p_save_state_before_branch_yn=>'N',
  p_required_patch => 7840116691585255 + wwv_flow_api.g_id_offset,
  p_branch_comment=> 'Created 02-SEP-2008 09:21 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10300709317603176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:989:&SESSION.:NACHDRUCKHINWEIS:&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 60,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p989_bestell_id is null and :request in (''HCK_MED_NACHDRUCK'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 11-SEP-2008 11:11 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10300907502603176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:989:&SESSION.:BESTELLHINWEIS:&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 70,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':request in (''BESTELLEN'')',
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 11-SEP-2008 11:11 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10301119784603176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:989:&SESSION.:BETREUER_HINWEIS:&DEBUG.::P989_WAHL_IDENTITAET:0',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>10265705787603066+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 80,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 05-FEB-2010 21:16 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10301317907603177 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:989:&SESSION.:BETREUER_HINWEIS:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>10265927504603066+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 90,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 06-FEB-2010 20:27 by FRGBG');
 
wwv_flow_api.create_page_branch(
  p_id=>10301516709603178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:989:&SESSION.:GUTSCHEIN_EMAILVERSAND:&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 91,
  p_branch_condition_type=> 'PLSQL_EXPRESSION',
  p_branch_condition=> ':p989_gutscheinstatus = 1 and '||unistr('\000a')||
':p989_gutscheinstatus_db = 0 and'||unistr('\000a')||
':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'','||unistr('\000a')||
'             ''APPLY_CHANGES_BETREUER'',''IDENTITAET'') AND '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,  '||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0    /* Gutscheinverfahren */',
  p_save_state_before_branch_yn=>'Y',
  p_branch_comment=> 'Created 12-OCT-2011 10:13 by BRIGITTE.NEIDHART');
 
wwv_flow_api.create_page_branch(
  p_id=>10301721892603178 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:989:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 99,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10261524071603047 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10261709610603050 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_NAME_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10261910597603050 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_VORNAME_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10262117777603050 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_STRASSE_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10262324940603051 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_NR_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10262518457603051 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PLZ_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 90,
  p_item_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10262715012603051 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_ORT_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10262910447603051 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_LAND_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 280,
  p_item_plug_id => 10260917283603043+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10263919999603057 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 760,
  p_item_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10264110339603061 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_NAME_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 770,
  p_item_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10264329092603062 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_VORNAME_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 780,
  p_item_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10264515218603063 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_STRASSE_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 790,
  p_item_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10264710893603063 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_NR_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 800,
  p_item_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10264920583603063 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PLZ_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 810,
  p_item_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10265114922603064 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_ORT_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 820,
  p_item_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10265301056603064 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_LAND_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 830,
  p_item_plug_id => 10263314150603053+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> null,
  p_cHeight=> null,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10267530725603068 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_IDENTABFR_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1030,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Identabfrage Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10267717760603069 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PASSWORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 100,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'PASSWORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10267912532603069 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_WARENKORB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 544,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zum WK',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10268118733603069 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_WAHL_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 980,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Wahl Identitaet',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10268318676603069 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_SCHNELLBESTELLUNG_PROMPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 850,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'frgbg_s.holen_uebersetzung(3102,:fas_sprache_id);',
  p_item_default_type=> 'PLSQL_EXPRESSION',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_cattributes_element=>'style="font-weight:bold;"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND                  /* Betreuer */ '||unistr('\000a')||
'(frgbg_s.check_fas_rolle(:APP_USER,''HCK_MED'')> 0 AND   /* Rolle */'||unistr('\000a')||
' :p989_land_id = 53    or                              /* Patient wohnt in Dtl. */'||unistr('\000a')||
' frgbg_s.check_fas_rolle(:APP_USER,''PARAMEDIFORM'')> 0'||unistr('\000a')||
')and'||unistr('\000a')||
':p989_id is not null    /* Patient angelegt */'||unistr('\000a')||
'and 1=2  /* NEI 12.05.14 Std-Mischartikel */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10268529761603071 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PREPARE_URL_PW',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 990,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Prepare Url Pw',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10268726380603071 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PERSSTAMM_ID_RECHNUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 740,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Rechnung',
  p_source=>'PERSSTAMM_ID_RECHNUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10268902808603071 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PERSSTAMM_ID_EXTERN_UPD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 750,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'P989 Persstamm Id Rechnung Upd',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10269110584603077 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PAGE_TITEL_RECHNUNGSADR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 553,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rechnung Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10269311322603077 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_AUSWAEHLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 543,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rechnungsadr',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10269517284603077 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_GUTSCHEINSTATUS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 68,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'GUTSCHEINSTATUS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(4902,:fas_sprache_id) a, 0 FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4903,:fas_sprache_id) a, 1 FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4904,:fas_sprache_id) a, 2 FROM DUAL'||unistr('\000a')||
'UNION '||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4905,:fas_sprache_id) a, 3 FROM DUAL'||unistr('\000a')||
'order by 2',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'frgbg_s.check_fas_rolle(:APP_USER,  /* Gutscheinverfahren */'||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0 ',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10269728986603078 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_GUTSCHEINANZAHL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 69,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'GUTSCHEINANZAHL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'STATIC2:0;0,1;1,2;2,3;3,4;4,5;5',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>'--:p989_gutscheinstatus > 0 and  dynamic action'||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,  /* Gutscheinverfahren */'||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0 ',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10269925642603079 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_GUTSCHEINSTATUS_DB',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 69,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'P989_GUTSCHEINSTATUS',
  p_source_type=> 'ITEM',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10270129263603079 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PAGE_TITEL_LIEFERADR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 556,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Rechnung Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10270313501603079 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_EXTERN_TYP',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 751,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Extern Typ',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10270520296603080 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PERSSTAMM_ID_LIEFERUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 741,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Persstamm Id Lieferung',
  p_source=>'PERSSTAMM_ID_LIEFERUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10270721199603080 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_IDENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 62,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'IDENT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10270911790603080 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BEMERKUNG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 99,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'BEMERKUNG',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 57,
  p_cMaxlength=> 2000,
  p_cHeight=> 2,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10271104811603080 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_TELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 94,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'TELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10271305241603081 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_MOBILTELEFON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 96,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'MOBILTELEFON',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10271500891603082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_FAX',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 95,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'FAX',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10271708855603082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_URL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 97,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'URL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10271922261603082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 63,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'N',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_pre_element_text=>'&#160',
  p_post_element_text=>'&#160 &#160',
  p_source=>'BETREUER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT frgbg_s.holen_uebersetzung(3578,:fas_sprache_id) a,''N'' b from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(1854,:fas_sprache_id),''J''  from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(3101,:fas_sprache_id),''I''  from dual'||unistr('\000a')||
'',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>'frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p989_betreuer in (''J'',''N'') ',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when=>'frgbg_s.check_fas_rolle(:APP_USER,''BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p989_betreuer in (''J'',''N'')',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10272104315603082 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_GEWICHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 840,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_post_element_text=>'&#160;&#160;&#160;',
  p_source=>'GEWICHT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND                  /* Betreuer */ '||unistr('\000a')||
':p989_rezept_nr > 0 and                       /* Rezept gewählt */'||unistr('\000a')||
'(frgbg_s.check_fas_rolle(:APP_USER,''HCK_MED'')> 0 AND  /* Rolle */'||unistr('\000a')||
' :p989_land_id = 53   OR                              /* Patient wohnt in Dtl. */'||unistr('\000a')||
' frgbg_s.check_fas_rolle(:APP_USER,''PARAMEDIFORM'')> 0 /* Rolle */'||unistr('\000a')||
') AND'||unistr('\000a')||
'(frgbg_s.check_rolle_prodr(''HCK_MED'',:p989_rezept_nr)> 0  OR /* HCK-MED-Rezept */'||unistr('\000a')||
' frgbg_s.check_rolle_prodr(''PARAMEDIFORM'',:p989_rezept_nr)> 0/* Paramedi-Rezept */'||unistr('\000a')||
')'||unistr('\000a')||
'OR'||unistr('\000a')||
'1=1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10272322725603083 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_REZEPT_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 851,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'REZEPT_NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT '||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''PRODR_VERWEISE.KUERZEL'',ID,:fas_sprache_id)  a, '||unistr('\000a')||
'   rezept_nr b'||unistr('\000a')||
'FROM prodr_verweise v'||unistr('\000a')||
'WHERE /* Rollenprüfung Betreuer, aktive Identitaet od. Std.Identitaet */'||unistr('\000a')||
'      (rolle_id in (SELECT rolle_id         /* Betreuer Rollen */'||unistr('\000a')||
'                   FROM pers_rollen'||unistr('\000a')||
'                   WHERE persstamm_id = :FAS_LOGIN_PERSONENSTAMM_ID'||unistr('\000a')||
'                  ) '||unistr('\000a')||
'       OR   /* Rollen der akt. Identitaet und oberhalb */'||unistr('\000a')||
'       rolle_id in (SELECT rolle_id'||unistr('\000a')||
'                    FROM pers_rollen b'||unistr('\000a')||
'                    where b.persstamm_id in ('||unistr('\000a')||
'                                select persstamm_id_identitaet'||unistr('\000a')||
'                                from pers_identitaeten'||unistr('\000a')||
'                                start with persstamm_id_identitaet = '||unistr('\000a')||
'                                            :fas_identitaet_persstamm_id'||unistr('\000a')||
'                                connect by prior persstamm_id_oberidentitaet ='||unistr('\000a')||
'                                            persstamm_id_identitaet'||unistr('\000a')||
'                               )'||unistr('\000a')||
'                   )'||unistr('\000a')||
'       OR   /* Rollen der def. Identitaet und oberhalb */'||unistr('\000a')||
'       rolle_id in (SELECT rolle_id'||unistr('\000a')||
'                    FROM pers_rollen b'||unistr('\000a')||
'                    where b.persstamm_id in ('||unistr('\000a')||
'                      select persstamm_id_identitaet'||unistr('\000a')||
'                      from pers_identitaeten'||unistr('\000a')||
'                      start with persstamm_id_identitaet =            '||unistr('\000a')||
'                        frgbg_s.get_identitaet_betr(:fas_login_personenstamm_id)'||unistr('\000a')||
'                      connect by prior persstamm_id_oberidentitaet ='||unistr('\000a')||
'                                         persstamm_id_identitaet'||unistr('\000a')||
'                               )'||unistr('\000a')||
'                   )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  /* Hckmed nur für Deutschland */'||unistr('\000a')||
'  and ((rolle_id = 14 and :p989_land_id = 53) OR rolle_id != 14)'||unistr('\000a')||
' /* Keine aktuellen Rezepte mit Flag neuberechen bzw. gelöschte rezepte */'||unistr('\000a')||
'  and not exists '||unistr('\000a')||
'     (Select rezept_nr'||unistr('\000a')||
'      FROM v_mn_rezepte mn'||unistr('\000a')||
'      WHERE mn.rezept_nr = v.REZEPT_NR'||unistr('\000a')||
'        and mn.akt_version = 1'||unistr('\000a')||
'        and (mn.neuberechnen=''J'' OR  '||unistr('\000a')||
'             mn.neuberechnen_sortiment=''J'' OR /*NEI 14.02.11 Sortimentseinf.*/'||unistr('\000a')||
'             mn.status in (2,3))  /* gelöscht*/'||unistr('\000a')||
'     )'||unistr('\000a')||
'/* Vorgaberezept muss auf der Basis des gleichen Sortiments sein */  /*NEI 14.02.11 Sortimentseinf.*/'||unistr('\000a')||
'  and exists (Select mn.rezept_nr'||unistr('\000a')||
'      FROM v_mn_rezepte mn, prod_rezepte p'||unistr('\000a')||
'      WHERE mn.rezept_nr = v.REZEPT_NR'||unistr('\000a')||
'        and mn.akt_version = 1'||unistr('\000a')||
'        and mn.rezept_nr = p.rezept_nr'||unistr('\000a')||
'        and mn.version = p.version'||unistr('\000a')||
'        and p.sortiment_id = :fas_sortiment_id'||unistr('\000a')||
'      )'||unistr('\000a')||
'order by sort',
  p_lov_display_null=> 'YES',
  p_lov_translated=> 'N',
  p_lov_null_text=>'%',
  p_lov_null_value=> '0',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 4,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND                  /* Betreuer */ '||unistr('\000a')||
'(frgbg_s.check_fas_rolle(:APP_USER,''HCK_MED'')> 0 AND   /* Rolle */'||unistr('\000a')||
' :p989_land_id = 53    or                              /* Patient wohnt in Dtl. */'||unistr('\000a')||
' frgbg_s.check_fas_rolle(:APP_USER,''PARAMEDIFORM'')> 0'||unistr('\000a')||
')and'||unistr('\000a')||
':p989_id is not null    /* Patient angelegt */'||unistr('\000a')||
'and 1=2  /* NEI 12.05.14 Std-Mischartikel */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10272500493603084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_HCK_MED',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 900,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Hck Med',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10272717005603084 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_HCK_MED_DRUCKPOS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 870,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT 1 a, 1 b'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT 2,2'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT 3,3'||unistr('\000a')||
'from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT 4,4'||unistr('\000a')||
'from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND                  /* Betreuer */ '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''HCK_MED'')> 0 AND   /* Rolle */'||unistr('\000a')||
':p989_land_id = 53                                    /* Patient wohnt in Dtl. */'||unistr('\000a')||
'AND'||unistr('\000a')||
'frgbg_s.check_rolle_prodr(''HCK_MED'',:p989_rezept_nr)> 0   /* HCK-MED-Rezept */'||unistr('\000a')||
'and 1=2  /* NEI 12.05.14 Std-Mischartikel */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10272916919603085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_EXTERN_VERWALTET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1050,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> '0',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'EXTERN_VERWALTET',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10273124203603085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_BETREUER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1000,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Betreuer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10273301661603085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BESTELL_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 930,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bestell Id Hck Med',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10273520560603085 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_HCK_MED_NACHDRUCK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 901,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'HCK_MED_NACHDRUCK',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10273713474603087 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_IDENTITAET',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1010,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Betreuer',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10273920489603087 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_HCK_MED',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 940,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'HCK_MED',
  p_prompt=>'&P989_BL_HCK_MED.',
  p_source=>'HCK_MED',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND                  /* Betreuer */ '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''HCK_MED'')> 0 AND   /* Rolle */'||unistr('\000a')||
':p989_land_id = 53 AND                                /* Patient wohnt in Dtl. */'||unistr('\000a')||
'frgbg_s.check_rolle_prodr(''HCK_MED'',:p989_rezept_nr)> 0 /* HCK-MED-Rezept */ AND'||unistr('\000a')||
':fas_pers_aenderbar = 1'||unistr('\000a')||
'and 1=2  /* NEI 12.05.14 Std-Mischartikel */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10274116109603088 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_HCK_MED_NACHDRUCK',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 950,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'HCK_MED_NACHDRUCK',
  p_prompt=>'&P989_BL_HCK_MED_NACHDRUCK.',
  p_source=>'HCK_MED_NACHDRUCK',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND                  /* Betreuer */ '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''HCK_MED'')> 0 AND   /* Rolle */'||unistr('\000a')||
':p989_land_id = 53   AND                              /* Patient wohnt in Dtl. */'||unistr('\000a')||
'frgbg_s.check_rolle_prodr(''HCK_MED'',:p989_rezept_nr)> 0 /* HCK-MED-Rezept */ AND'||unistr('\000a')||
':fas_pers_aenderbar = 1'||unistr('\000a')||
'and 1=2  /* NEI 12.05.14 Std-Mischartikel */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10274303809603088 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_GROESSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 841,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_pre_element_text=>'&#160;',
  p_post_element_text=>'&#160;&#160;&#160;',
  p_source=>'GROESSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 3,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND                 /* Betreuer */ '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''PARAMEDIFORM'')> 0 AND    /* Rolle Paramedi */'||unistr('\000a')||
'frgbg_s.check_rolle_prodr(''PARAMEDIFORM'',:p989_rezept_nr)> 0/* Paramedi-Rezept */'||unistr('\000a')||
'OR'||unistr('\000a')||
'1=1',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10274517702603088 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BESTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 960,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BESTELLEN',
  p_prompt=>'&P989_BL_BESTELLEN.',
  p_source=>'BESTELLEN',
  p_source_type=> 'STATIC',
  p_display_as=> 'BUTTON',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 2000,
  p_cHeight=> null,
  p_tag_attributes  => 'template:'||to_char(2885332167489437 + wwv_flow_api.g_id_offset),
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' AND   /* Betreuer */ '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''PARAMEDIFORM'')> 0 AND'||unistr('\000a')||
'--frgbg_s.check_rolle_prodr(''PARAMEDIFORM'',:p989_rezept_nr)> 0 AND'||unistr('\000a')||
'                                       /* Paramediform-Rezept */'||unistr('\000a')||
':fas_pers_aenderbar = 1'||unistr('\000a')||
'and 1=2  /* NEI 12.05.14 Std-Mischartikel */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_is_persistent=> 'N',
  p_protection_level => 'N',
  p_button_execute_validations=>'Y',
  p_button_action => 'SUBMIT',
  p_button_is_hot=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10274702869603089 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_BESTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 902,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Bestellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10274930758603089 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_IDENT_OPTION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 64,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Option',
  p_pre_element_text=>'&#160 ',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'SELECT ''Mitglied'' a, 0 from dual'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT ''Master'' ,1 from dual',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_display_when=>':fas_aufgerufen_von = ''BETREUER'' and '||unistr('\000a')||
'frgbg_s.check_fas_rolle(:APP_USER,''IDENTITAET_BETREUER_VERWALTEN'')> 0'||unistr('\000a')||
'and :p989_betreuer in (''N'')'||unistr('\000a')||
'and :p989_id is not null'||unistr('\000a')||
'and :fas_pers_aenderbar = 1'||unistr('\000a')||
'and :p989_EXTERN_VERWALTET = 0   /* nicht GUS-Verwalt.*/'||unistr('\000a')||
'and frgbg_s.check_fas_rolle(:APP_USER,''COMMUNITY_ADMIN'')> 0 /*Community-Admin */',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10275115362603089 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_AENDERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 490,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Änderung anwenden',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Ändern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10275320016603089 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_ERSTELLEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 500,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Erstellen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Erstellen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10275527997603090 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 510,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10275729092603093 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_LOESCHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 520,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Löschen',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Loeschen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10275916628603093 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_PASSWORT_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 530,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Passwort ändern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Passwort Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10276103610603094 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_SPEICHERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 540,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> 'Speichern',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Speichern',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10276321764603094 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_FEHLER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 560,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10276518429603094 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_REGION_TITEL_PWD_CHG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 551,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Pwd Chg',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10276726960603094 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_INFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 570,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10276920795603095 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PERSON',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 620,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Person',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10277117657603095 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_USER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 630,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pisuser',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10277316816603095 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_REGION_TITEL_HILFETEXTE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 550,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Region Titel Hilfetexte',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10277528997603095 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_REGION_TITEL_INFOTEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 552,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10277711342603096 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Id',
  p_source=>'ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Login Benutzer Name ist nicht veränderbar.';

wwv_flow_api.create_page_item(
  p_id=>10277925785603097 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_USER_ACCOUNT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 61,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'USER_ACCOUNT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_aufgerufen_von != ''BETREUER''',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_read_only_when=>':p989_id is not null',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.'||unistr('\000a')||
'Der Eintrag muss mit mindestens einem Zeichen beginnen, anschliessend ein @-Zeichen beinhalten, danach beliebig viele Zeichen. Nach dem Punkt sind bis zu 4 Zeichen erlaubt. Allgemeiner Aufbau: [zeichen]@[zeichen].[zeichen]';

wwv_flow_api.create_page_item(
  p_id=>10278418195603107 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_EMAIL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 65,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'EMAIL',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>10278923047603113 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_NAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>10279407112603113 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_VORNAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 72,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'VORNAME',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>10279914282603117 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_STRASSE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 74,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'STRASSE',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1  /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 10 Zeichen sind erlaubt.';

wwv_flow_api.create_page_item(
  p_id=>10280407995603117 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_NR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 76,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'NR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte mit Postleitzahlen in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 10 Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>10280932295603118 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PLZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 78,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'PLZ',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Für Orte in der Schweiz wird die PLZ/Ort-Kombination auf Existenz geprüft.'||unistr('\000a')||
'Bis zu 100 beliebige Zeichen sind erlaubt.'||unistr('\000a')||
'';

wwv_flow_api.create_page_item(
  p_id=>10281400838603118 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_ORT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 81,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ORT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_POPUP_LOV',
  p_lov=> '         SELECT distinct o.ort ||'' ''||o.PLZ a, o.ort b'||unistr('\000a')||
'         FROM   orte o,  laender l, gebiete  g'||unistr('\000a')||
'         WHERE  o.id_gebiet = g.id'||unistr('\000a')||
'           AND  g.id_land = l.id'||unistr('\000a')||
'           AND  (l.ID = :P989_LAND_ID OR :P989_land_id is null)'||unistr('\000a')||
'           AND  (o.plz like trim(:p989_plz)||''%'' OR :p989_plz is null)'||unistr('\000a')||
'           and  o.satz_kennzeichen is null '||unistr('\000a')||
'           and  l.satz_kennzeichen is null'||unistr('\000a')||
'           and  g.satz_kennzeichen is null'||unistr('\000a')||
'		   and (l.iso3_id not in (''CHE'',''LIE'') '||unistr('\000a')||
'	        		 or'||unistr('\000a')||
'	           (l.iso3_id in (''CHE'',''LIE'') and o.onrp is not null))'||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'ENTERABLE',
  p_attribute_02 => 'FIRST_ROWSET_FILTER',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10281926591603119 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_SATZKENNZEICHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 240,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Satzkennzeichen',
  p_source=>'SATZKENNZEICHEN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Datumsangabe der Form TT.MM.JJJJ z.B. 20.11.2001';

wwv_flow_api.create_page_item(
  p_id=>10282110809603119 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_GEBURTSDATUM',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 85,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_format_mask=>'DD.MM.RRRR',
  p_source=>'GEBURTSDATUM',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DATE_PICKER_CLASSIC',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Auswahl des Geschlechts.';

wwv_flow_api.create_page_item(
  p_id=>10282618968603120 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_GESCHLECHT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 89,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'GESCHLECHT',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Anzeigesprache';

wwv_flow_api.create_page_item(
  p_id=>10283122184603120 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_APP_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 92,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      -- Sprache des Patienten von der Betreuer-Sprache ableiten'||unistr('\000a')||
'      :p989_app_sprache_id := frgbg_s.get_app_sprache_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT min(s.id) into :p989_app_sprache_id'||unistr('\000a')||
'      FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'      WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'        AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'        AND s.standard = 1;     -- Defaultsprache       '||unistr('\000a')||
'      IF :p989_app_sprache_id is NULL THEN'||unistr('\000a')||
'         SELECT min(s.id) into :p989_app_sprache_id'||unistr('\000a')||
'         FROM app_sprachen s, fas_schemas fs'||unistr('\000a')||
'         WHERE fs.id = :fas_schema_id'||unistr('\000a')||
'           AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'           AND s.aktiv=1;  -- NEI 09.09.2014 '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN (:p989_app_sprache_id);'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'APP_SPRACHE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select s.sprache display_value, s.ID return_value'||unistr('\000a')||
'from app_sprachen s, fas_schemas fs '||unistr('\000a')||
'where fs.id = :fas_pers_schema_id'||unistr('\000a')||
'  AND fs.app_sprachenset_id = s.app_sprachenset_id'||unistr('\000a')||
'  AND s.aktiv=1  -- NEI 09.09.2014'||unistr('\000a')||
'  --AND s.sprache_id in (select sprache_id from uebersetzungen) -- NEI 20.11.13 Umstellung Zugriff uebersetzungen auf Fallback'||unistr('\000a')||
''||unistr('\000a')||
'order by 1',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10283609918603122 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PAGE_TITEL_PATIENTANZEIGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 554,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Page Title Personenstammanzeige',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10283816981603122 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PIS_PAT_AKTE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 670,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Pis Pat Akte Id',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10284023744603122 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_AENDERBAR',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 970,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Aenderbar',
  p_source=>'AENDERBAR',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10284217104603123 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_ERFUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 680,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Erfuser',
  p_source=>'ERFUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10284416278603123 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_MUTUSER',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 690,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mutuser',
  p_source=>'MUTUSER',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10284612121603123 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_LOGIN_PAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 700,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Login Page',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10284825842603124 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_TAB1_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 710,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10285031603603124 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BL_FB_REZEPT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 545,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'Bis zu 100 Zeichen sind erlaubt.'||unistr('\000a')||
'Der Eintrag muss mit mindestens einem Zeichen beginnen, anschliessend ein @-Zeichen beinhalten, danach beliebig viele Zeichen. Nach dem Punkt sind bis zu 4 Zeichen erlaubt. Allgemeiner Aufbau: [zeichen]@[zeichen].[zeichen]';

wwv_flow_api.create_page_item(
  p_id=>10285214781603124 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_EMAIL_INTERN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 66,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'EMAIL_INTERN',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 2,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when=>':fas_modus_id in (1,2)',
  p_display_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10285722019603125 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_BETRABFR_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1020,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Betreuerabfrage Text',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10285924829603125 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_NV_PATIENT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1040,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Nv Patient',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10286110179603125 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_MN_REZEPT_ID_KOPIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 730,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Mn Rezept Id Kopie',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10286309069603125 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_PIS_ADRESSE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 671,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>10286527738603126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_ANREDE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 67,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'ANREDE_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select  '||unistr('\000a')||
' fas_synch.get_tab_uebersetzung(''ANREDEN_FRGBG.CODE'',ID,:fas_sprache_id) a,'||unistr('\000a')||
' id b'||unistr('\000a')||
'from anreden_frgbg',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2899910455489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
h := null;
h:=h||'no help test';

wwv_flow_api.create_page_item(
  p_id=>10286721334603126 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 989,
  p_name=>'P989_LAND_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 77,
  p_item_plug_id => 10265517576603065+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default=> 'BEGIN'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      -- Land des Patienten vom Betreuer-Land ableiten'||unistr('\000a')||
'      :p989_land_id := frgbg_s.get_betreuer_land_id(:APP_USER);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p989_land_id := 198;  -- Default Schweiz '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   RETURN (:p989_land_id);'||unistr('\000a')||
'END;',
  p_item_default_type=> 'PLSQL_FUNCTION_BODY',
  p_prompt=>'"SET_ITEM_LABEL"',
  p_source=>'LAND_ID',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_SELECT_LIST',
  p_lov=> 'select substr(fas_synch.get_tab_uebersetzung(''LAND.LAND'',id,:fas_sprache_id),1,27)  a, id b'||unistr('\000a')||
'from v_laender'||unistr('\000a')||
'order by sort',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when=>':p989_EXTERN_VERWALTET = 1   /*GUS-Verwalt.*/',
  p_read_only_when_type=>'PLSQL_EXPRESSION',
  p_field_template=> 2900122745489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_help_text=> h,
  p_attribute_01 => 'NONE',
  p_attribute_02 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10290113229603137 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_PLZ_not_null',
  p_validation_sequence=> 1,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P989_PLZ IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(209,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10280932295603118 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10289110130603135 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_ORT_not_null',
  p_validation_sequence=> 11,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P989_ORT IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(210,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10281400838603118 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10287717934603133 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_LAND_ID_not_null',
  p_validation_sequence=> 31,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P989_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_validation_condition=> ':request in (''SAVE'',''CREATE'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_when_button_pressed=> 10266720712603067 + wwv_flow_api.g_id_offset,
  p_associated_item=> 10286721334603126 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10287918094603133 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_LAND_exists',
  p_validation_sequence=> 53,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p989_land_id IS NOT NULL THEN'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM   v_laender'||unistr('\000a')||
'      --WHERE  UPPER(land) = UPPER(:p989_land);'||unistr('\000a')||
'      WHERE id = :p989_land_id;'||unistr('\000a')||
'      IF v_anz != 1 THEN'||unistr('\000a')||
'         --RETURN(''Ungültige Eingabe im Feld Land!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'               frgbg_s.holen_uebersetzung(211,:fas_sprache_id)));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Land ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(211,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P989_land_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
''||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10286721334603126 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10288125495603134 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_PLZ_ORT_exists',
  p_validation_sequence=> 63,
  p_validation => 'DECLARE'||unistr('\000a')||
'    v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   --IF UPPER(:p989_land) = ''SCHWEIZ'' THEN'||unistr('\000a')||
'   IF :p989_land_id IS NOT NULL AND :p989_ort IS NOT NULL AND'||unistr('\000a')||
'      :p989_plz IS NOT NULL '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      IF :p989_land_id = 198 and -- Schweiz'||unistr('\000a')||
'         :P989_EXTERN_VERWALTET = 0  -- NEI 11.07.13 Nur FAS-Verwaltete Aufträge prüfen, '||unistr('\000a')||
'                                     -- da nur diese PLZ/Ort verändert werden können,'||unistr('\000a')||
'                                     -- sonst ist GUS führend und die Änderungen kommen von dort'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         select count(*) INTO v_anz'||unistr('\000a')||
'         from v_orte'||unistr('\000a')||
'         where upper(ort) = upper(:p989_ort)'||unistr('\000a')||
'           and plz = trim(:p989_plz);'||unistr('\000a')||
'         IF v_anz = 0 THEN'||unistr('\000a')||
'            --RETURN(''PLZ/Ort-Kombination ist ungültig!'');'||unistr('\000a')||
'            RETURN(frgbg_s.holen_uebersetzung(179,'||unistr('\000a')||
'                        :fas_sprache_id));'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Ort bzw. PLZ ungültig!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'            frgbg_s.holen_uebersetzung(209,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P989_plz_ort_exists'')'||unistr('\000a')||
'          );'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10280932295603118 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10288318965603134 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p989_geburtsdatum_not_null',
  p_validation_sequence=> 73,
  p_validation => 'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :P989_GEBURTSDATUM IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/ NULL; -- Geburtsdatum optional NEI 05.05.08'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10282110809603119 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10288528059603134 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p989_geburtdatum_must_be_date',
  p_validation_sequence=> 83,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P989_GEBURTSDATUM IS NOT NULL THEN'||unistr('\000a')||
'      :P989_GEBURTSDATUM := '||unistr('\000a')||
'         to_char(to_date(:P989_GEBURTSDATUM,''DD.MM.RRRR''),''DD.MM.RRRR'');'||unistr('\000a')||
'            -- to_date(:P989_GEBURTSDATUM);'||unistr('\000a')||
'      IF to_date(:P989_GEBURTSDATUM,''DD.MM.RRRR'') >= trunc(sysdate,''DD'')THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(9430,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(HTMLDB_LANG.MESSAGE(''DATUM_UNGUELTIG''));'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(212,:fas_sprache_id)));'||unistr('\000a')||
'   '||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Ungültiges Datum!',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10282110809603119 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10288727002603135 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'p989_name_not_null',
  p_validation_sequence=> 123,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P989_NAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(206,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10278923047603113 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10289915580603136 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_VORNAME_not_null',
  p_validation_sequence=> 133,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :P989_VORNAME IS NULL THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(205,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'NEVER',
  p_associated_item=> 10279407112603113 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10289328628603135 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_EMAIL_not_null',
  p_validation_sequence=> 183,
  p_validation => 'BEGIN'||unistr('\000a')||
'   -- NEI 5.5.11 check für Betreuer und Identitaet wieder aktiviert '||unistr('\000a')||
'   IF :P989_EMAIL IS NULL '||unistr('\000a')||
'      and '||unistr('\000a')||
'     (:p989_betreuer !=''N'' OR '||unistr('\000a')||
'      (:p989_gutscheinstatus > 0 AND :p989_betreuer=''N'') OR'||unistr('\000a')||
'      :request in (''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')'||unistr('\000a')||
'     )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --RETURN(HTMLDB_LANG.MESSAGE(''FELD_EINGABEPFLICHTIG''));'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(203,:fas_sprache_id)));'||unistr('\000a')||
''||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => 'Wert muss angegeben werden.',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10278418195603107 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10289523306603136 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_EMAIL_check',
  p_validation_sequence=> 190,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p989_email IS NOT NULL THEN '||unistr('\000a')||
'      IF instr(:p989_email,''@'') <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(224,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'      v_string :=  '||unistr('\000a')||
'         substr(:p989_email,instr(:p989_email,''@'')+1,length(:p989_email));'||unistr('\000a')||
'      v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'      IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'         --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(225,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'      -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'      IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(226,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,     '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(203,:fas_sprache_id)),'||unistr('\000a')||
'            ''Validierung p989_email_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10278418195603107 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10289721048603136 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_EMAIL_intern_check',
  p_validation_sequence=> 191,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_string    VARCHAR2(100);'||unistr('\000a')||
'   v_anz       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p989_email_intern IS NOT NULL THEN '||unistr('\000a')||
'      IF instr(:p989_email_intern,''@'') <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Vor dem @-Zeichen muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(224,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      -- Hinterm Punkt 2-4 Zeichen'||unistr('\000a')||
'      v_string :=  '||unistr('\000a')||
'         substr(:p989_email_intern,'||unistr('\000a')||
'                  instr(:p989_email_intern,''@'')+1,length(:p989_email_intern));'||unistr('\000a')||
'      v_anz :=  length(v_string) - instr(v_string,''.'',-1) ;'||unistr('\000a')||
'      IF v_anz < 2 OR v_anz > 4 THEN'||unistr('\000a')||
'         --RETURN(''Nach dem letzten Punkt müssen mindestens 2-4 Zeichen vorhanden sein!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(225,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'      -- Zwischen @ und . muss mind. 1 Zeichen sein'||unistr('\000a')||
'      IF instr(v_string,''.'',-1) <= 1 THEN'||unistr('\000a')||
'         --RETURN(''Zwischen dem @-Zeichen und dem letzten Punkt muss mindestens ein Zeichen stehen!'');'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(226,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   --RETURN(''Email-Eingabe hat einen fehlerhaften Aufbau!'');'||unistr('\000a')||
'   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,     '||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(3767,:fas_sprache_id)),'||unistr('\000a')||
'            ''Validierung p989_email_intern_check''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10285214781603124 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10288902730603135 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'check_rezept_nr_paramedi',
  p_validation_sequence=> 195,
  p_validation => 'IF :p989_rezept_nr is not null and :p989_rezept_nr > 0 THEN'||unistr('\000a')||
'   IF frgbg_s.check_rolle_prodr(''PARAMEDIFORM'',:p989_rezept_nr)> 0 THEN'||unistr('\000a')||
'                                       /* Paramediform-Rezept */'||unistr('\000a')||
'      RETURN '''';  --ok'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END IF;'||unistr('\000a')||
'RETURN (frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(518,:fas_sprache_id)));;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request = ''P989_REZEPT_NR''',
  p_when_button_pressed=> 10274517702603088 + wwv_flow_api.g_id_offset,
  p_only_for_changed_rows=> 'Y',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10290314335603137 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_USER_ACCOUNT_EINGABE',
  p_validation_sequence=> 200,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'   v_anz   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p989_user_account IS NULL THEN'||unistr('\000a')||
'      --RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,   -- NEI 23.06.08'||unistr('\000a')||
'      --       frgbg_s.holen_uebersetzung(202,:fas_sprache_id)));'||unistr('\000a')||
'      -- User-Account autom. generieren'||unistr('\000a')||
'      :p989_user_account := frgbg_s.GEN_USER_ACCOUNT'||unistr('\000a')||
'                    (:p989_name,:p989_vorname,--:p989_geburtsdatum);'||unistr('\000a')||
'                     to_date(:p989_geburtsdatum,''DD.MM.YYYY''));'||unistr('\000a')||
'      IF :p989_user_account IS NULL THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(1814,:fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      SELECT count(*) INTO v_anz'||unistr('\000a')||
'      FROM personenstamm'||unistr('\000a')||
'      WHERE UPPER(user_account)= UPPER(:p989_user_account);'||unistr('\000a')||
'      IF v_anz > 0 THEN'||unistr('\000a')||
'         --RETURN (''Der Benutzer ist bereits vergeben!'');'||unistr('\000a')||
'         RETURN (frgbg_s.holen_uebersetzung(448,'||unistr('\000a')||
'                      :fas_sprache_id));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'mel.p(''Exception bei Validierung P989_user_account_eingabe Name %1, Vorname %2, GEbdat %3, ACcount %4, Sprache %5, Fehler: %6'', v_PROT_ID, ''ERROR'', ''page110/val_user_account'',:p989_name,:p989_vorname,:p989_geburtsdatum,:p989_user_account,:fas_sprache_id,SQLERRM);   RETURN(frgbg_s.holen_uebersetzung(181,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(223,:fas_sprache_id,'||unistr('\000a')||
'          frgbg_s.holen_uebersetzung(202,:fas_sprache_id)),'||unistr('\000a')||
'                              ''Validierung P989_user_account_eingabe''));'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_when_button_pressed=> 10266720712603067 + wwv_flow_api.g_id_offset,
  p_associated_item=> 10277925785603097 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10290521717603137 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_GEWICHT_not_null',
  p_validation_sequence=> 210,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :p989_gewicht is NULL THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(2151,:fas_sprache_id))); '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''HCK_MED'',''BESTELLEN'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10272104315603082 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10290711949603137 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_rezept_nr',
  p_validation_sequence=> 220,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :p989_rezept_nr = 0 THEN'||unistr('\000a')||
'      RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'             frgbg_s.holen_uebersetzung(527,:fas_sprache_id)));'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''P989_HCK_MED'',''P989_HCK_MED_NACHDRUCK'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10272322725603083 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10290911316603138 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_GROESSE_not_null',
  p_validation_sequence=> 230,
  p_validation => 'BEGIN'||unistr('\000a')||
'   IF :p989_groesse is NULL THEN'||unistr('\000a')||
'      IF frgbg_s.check_rolle_prodr(''PARAMEDIFORM'',:p989_rezept_nr)> 0 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(164,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(4,:fas_sprache_id)));'||unistr('\000a')||
'      END IF;    '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''BESTELLEN'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_associated_item=> 10274303809603088 + wwv_flow_api.g_id_offset,
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10287327483603130 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_GEWICHT_Bereich',
  p_validation_sequence=> 240,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_zahl   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p989_gewicht is not null THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         v_zahl := frgbg_s.FB_FORMAT_FANT_WERT(:P989_GEWICHT,''999D9'',1);'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2151,:fas_sprache_id)||'': ''||'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(3533,:fas_sprache_id));'||unistr('\000a')||
'      END; '||unistr('\000a')||
'      :p989_gewicht:= v_zahl;'||unistr('\000a')||
'      IF :p989_gewicht < 17 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2173,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(2151,:fas_sprache_id),17));      '||unistr('\000a')||
'      ELSIF :p989_gewicht > 150 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2174,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(2151,:fas_sprache_id),150));      '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'',''HCK_MED'',''BESTELLEN'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_validation(
  p_id => 10287506023603133 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_tabular_form_region_id => null + wwv_flow_api.g_id_offset,
  p_validation_name => 'P989_GROESSE_BEREICH',
  p_validation_sequence=> 250,
  p_validation => 'DECLARE'||unistr('\000a')||
'   v_zahl   number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p989_groesse is not null THEN'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         v_zahl := frgbg_s.FB_FORMAT_FANT_WERT(:P989_groesse ,''999D9'',1);'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(4,:fas_sprache_id)||'': ''||'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(3533,:fas_sprache_id));'||unistr('\000a')||
'      END; '||unistr('\000a')||
'      :p989_groesse := v_zahl;'||unistr('\000a')||
'      IF :p989_groesse < 120 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2173,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(4,:fas_sprache_id),120));      '||unistr('\000a')||
'      ELSIF :p989_groesse > 230 THEN'||unistr('\000a')||
'         RETURN(frgbg_s.holen_uebersetzung(2174,:fas_sprache_id,'||unistr('\000a')||
'                frgbg_s.holen_uebersetzung(4,:fas_sprache_id),230));      '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;',
  p_validation_type => 'FUNC_BODY_RETURNING_ERR_TEXT',
  p_error_message => '',
  p_always_execute=>'N',
  p_validation_condition=> ':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''APPLY_CHANGES_IDENTITAET'',''HCK_MED'',''BESTELLEN'')',
  p_validation_condition_type=> 'PLSQL_EXPRESSION',
  p_error_display_location=>'INLINE_IN_NOTIFICATION',
  p_validation_comment=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 10297810416603162 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 989
 ,p_name => 'hide_show_check_gutschein'
 ,p_event_sequence => 20
 ,p_triggering_element_type => 'ITEM'
 ,p_triggering_element => 'P989_GUTSCHEINSTATUS'
 ,p_triggering_condition_type => 'EQUALS'
 ,p_triggering_expression => '0'
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'change'
 ,p_display_when_type => 'PLSQL_EXPRESSION'
 ,p_display_when_cond => 'frgbg_s.check_fas_rolle(:APP_USER,  /* Gutscheinverfahren */'||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0 '
  );
wwv_flow_api.create_page_da_action (
  p_id => 10298103274603167 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 989
 ,p_event_id => 10297810416603162 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_HIDE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P989_GUTSCHEINANZAHL'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 10298312489603169 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 989
 ,p_event_id => 10297810416603162 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'Y'
 ,p_action => 'NATIVE_SHOW'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P989_GUTSCHEINANZAHL'
 ,p_attribute_01 => 'N'
 ,p_stop_execution_on_error => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 10298519956603169 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 989
 ,p_event_id => 10297810416603162 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P989_GUTSCHEINANZAHL'
 ,p_attribute_01 => 'STATIC_ASSIGNMENT'
 ,p_attribute_02 => '0'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
wwv_flow_api.create_page_da_action (
  p_id => 10298723222603169 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 989
 ,p_event_id => 10297810416603162 + wwv_flow_api.g_id_offset
 ,p_event_result => 'FALSE'
 ,p_action_sequence => 20
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_SET_VALUE'
 ,p_affected_elements_type => 'ITEM'
 ,p_affected_elements => 'P989_GUTSCHEINANZAHL'
 ,p_attribute_01 => 'FUNCTION_BODY'
 ,p_attribute_06 => 'IF NVL(:p989_gutscheinanzahl,0) = 0 THEN'||unistr('\000a')||
'   RETURN 1;'||unistr('\000a')||
'ELSE'||unistr('\000a')||
'   RETURN :p989_gutscheinanzahl;'||unistr('\000a')||
'END IF;'||unistr('\000a')||
''
 ,p_attribute_07 => 'P989_GUTSCHEINANZAHL'
 ,p_attribute_08 => 'Y'
 ,p_stop_execution_on_error => 'Y'
 ,p_wait_for_result => 'Y'
 );
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   IF :P989_PERSSTAMM_ID_RECHNUNG is not null THEN'||unistr('\000a')||
'      SELECT p.id,p.name, p.vorname, p.strasse,p.nr, p.plz, p.ort, l.land'||unistr('\000a')||
'      INTO :p989_id_rechnung, :p989_name_rechnung,:p989_vorname_rechnung, '||unistr('\000a')||
'           :p989_strasse_rechnung,:p989_nr_rechnung,'||unistr('\000a')||
'           :p989_plz_rechnung,:p989_ort_rechnung, :p989_land_rechnung'||unistr('\000a')||
'      FROM personenstamm p,v_laender l'||unistr('\000a')||
'      WHERE p.id = :P989_PERSSTA';

p:=p||'MM_ID_RECHNUNG '||unistr('\000a')||
'        and p.land_id = l.id (+);'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p989_id_rechnung := NULL;'||unistr('\000a')||
'      :p989_name_rechnung := NULL;'||unistr('\000a')||
'      :p989_vorname_rechnung := NULL;'||unistr('\000a')||
'      :p989_strasse_rechnung := NULL;'||unistr('\000a')||
'      :p989_nr_rechnung := NULL;'||unistr('\000a')||
'      :p989_plz_rechnung := NULL;'||unistr('\000a')||
'      :p989_ort_rechnung := NULL;'||unistr('\000a')||
'      :p989_land_rechnung := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   IF :P989_PERSSTAMM_ID_LIEFERUNG is not null THEN';

p:=p||''||unistr('\000a')||
'      SELECT p.id,p.name, p.vorname, p.strasse,p.nr, p.plz, p.ort, l.land'||unistr('\000a')||
'      INTO :p989_id_lieferung, :p989_name_lieferung,:p989_vorname_lieferung, '||unistr('\000a')||
'           :p989_strasse_lieferung,:p989_nr_lieferung,'||unistr('\000a')||
'           :p989_plz_lieferung,:p989_ort_lieferung, :p989_land_lieferung'||unistr('\000a')||
'      FROM personenstamm p,v_laender l'||unistr('\000a')||
'      WHERE p.id = :P989_PERSSTAMM_ID_LIEFERUNG'||unistr('\000a')||
'        and p.land_id = l.id (+)';

p:=p||';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p989_id_lieferung := NULL;'||unistr('\000a')||
'      :p989_name_lieferung := NULL;'||unistr('\000a')||
'      :p989_vorname_lieferung := NULL;'||unistr('\000a')||
'      :p989_strasse_lieferung := NULL;'||unistr('\000a')||
'      :p989_nr_lieferung := NULL;'||unistr('\000a')||
'      :p989_plz_lieferung := NULL;'||unistr('\000a')||
'      :p989_ort_lieferung := NULL;'||unistr('\000a')||
'      :p989_land_lieferung := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10292401194603142 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_externe_adressen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''In setze_fas_pers_aenderbar'',v_prot_id,''INFO'',''102/110 setze_fas_pers_aenderbar'');'||unistr('\000a')||
'   IF   (:p989_aenderbar = ''J'') '||unistr('\000a')||
'     OR (:p989_aenderbar = ''N'' AND'||unistr('\000a')||
'         -- speziell berechtigt'||unistr('\000a')||
'         frgbg_s.check_fas_rolle(:APP_USER,''GESCHUETZTE_PERSONENDATEN_AENDERN'') > 0 '||unistr('\000a')||
'         )'||unistr('\000a')||
'      OR (:p989_aenderbar = ''N'' AND                 -- User hat sich selbst e';

p:=p||'ingeloggt'||unistr('\000a')||
'          :fas_aufgerufen_von != ''BETREUER'' and'||unistr('\000a')||
'          UPPER(:P989_USER_ACCOUNT)= UPPER(:APP_USER)'||unistr('\000a')||
'         )'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :fas_pers_aenderbar := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :fas_pers_aenderbar := 0;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10292632026603143 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 41,
  p_process_point=> 'AFTER_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'setze_fas_pers_aenderbar',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_prot_id    number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   mel.p(''Rezept-NR geaendert!%1'',v_prot_id,''TEST'',''P989/test'',:P989_gewicht);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10291020400603138 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 1,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'test',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':request = ''P989_REZEPT_NR''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'    :p989_satzkennzeichen := ''GELOESCHT von ''||:APP_USER||'' am ''||SYSDATE; '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10292823856603143 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 1,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_satz_delete',
  p_process_sql_clob => p,
  p_process_error_message=> 'Datensatz konnte nicht gelöscht werden!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>10266929263603067 + wwv_flow_api.g_id_offset,
  p_process_success_message=> 'Datensatz wurde erfolgreich gelöscht!',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p989_mutuser := :APP_USER;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10293013567603144 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 2,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mutuser_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'/*SAVE DELETE RECHLOE*/'||unistr('\000a')||
':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'') ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p989_passwort := frgbg_s.gen_passwort(1);'||unistr('\000a')||
'   IF frgbg_s.get_pers_option(:APP_USER,28)= 1 THEN /* IABC-Betr.zugr*/  /* NEI 11.01.10 */'||unistr('\000a')||
'      :p989_erfuser := :APP_USER||''##''||to_char(:FAS_IDENTITAET_PERSSTAMM_ID)||''##'''||unistr('\000a')||
'                                ||to_char(:FAS_LOGIN_PERSONENSTAMM_ID)||''##'';'||unistr('\000a')||
'   ELSE /* Std.zugriff Identität */              '||unistr('\000a')||
'      :p989_erfuser := :APP_USER||''##''||to_c';

p:=p||'har(:FAS_IDENTITAET_PERSSTAMM_ID)||''##'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   :p989_mutuser := :p989_erfuser;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10293222413603144 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 3,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'erfuser_pw_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>10266720712603067 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''set_land_id_null request:%1'',v_prot_id,''INFO'',''102/110:set_land_id_null'',:request);'||unistr('\000a')||
'   IF :p989_land_id = ''#NULL#'' THEN'||unistr('\000a')||
'      :p989_land_id := NULL;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10293423093603144 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 4,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_land_id_null',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*MEL.p(''Adresse löschen: Pers=%1 Rech-id:%2  Lief-id:%3 request:%4 [page110,adresse löschen]'', v_PROT_ID, ''ERROR'', ''fas'',:p989_id,:p989_persstamm_id_rechnung,:p989_persstamm_id_lieferung,:request);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :REQUEST = ''RECHLOESCHEN'' THEN'||unistr('\000a')||
'      :P989_PERSSTAMM_ID_RECHNUNG := NULL;'||unistr('\000a')||
'/*MEL.p(''Adresse löschen2: Pers=%1 id:%2 request:%3 [page110,adresse löschen]'', v_P';

p:=p||'ROT_ID, ''ERROR'', ''fas'',:p989_id,:p989_persstamm_id_rechnung,:request);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   ELSIF :REQUEST = ''LIEFERLOESCHEN'' THEN'||unistr('\000a')||
'      :P989_PERSSTAMM_ID_LIEFERUNG := NULL;'||unistr('\000a')||
'/*MEL.p(''Adresse löschen2: Pers=%1 id:%2 request:%3 [page110,adresse löschen]'', v_PROT_ID, ''ERROR'', ''fas'',:p989_id,:p989_persstamm_id_lieferung,:request);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10293615352603144 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'externe_adressen_loeschen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'#OWNER#:PERSONENSTAMM:P989_ID:ID|IU';

wwv_flow_api.create_page_process(
  p_id     => 10293804244603145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 11,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'DML_PROCESS_ROW',
  p_process_name=> 'personenstamm_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'',''APPLY_CHANGES_BETREUER'',''IDENTITAET'',''P989_REZEPT_NR'') ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_return_key_into_item1=>'P989_ID',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_mn_rezept_id_orig mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_mn_rezept_id     mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_mn_rezept_id_neu mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_kuerzel          mengenarts.kuerzel%TYPE;'||unistr('\000a')||
'   v_bemerkung        mn_rezepte.bemerkung%TYPE;'||unistr('\000a')||
'   v_menge            mengenarts.menge%TYPE;'||unistr('\000a')||
'   v_menge_einheit_id mengenarts.menge_einheit_id%TYPE;'||unistr('\000a')||
'   v_reichweite       mengenarts.reichweite%TYPE;'||unistr('\000a')||
'   v_sortiment_id ';

p:=p||'    sortimente.id%TYPE;   -- NEI 14.02.2011 Sortimentseinfuehrung '||unistr('\000a')||
'   v_rezept_nr_orig   mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_version          mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_rezept_nr        mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_version_orig     mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_prod_rezept_id   prod_rezepte.id%TYPE;'||unistr('\000a')||
'   v_prod_rezept_id_orig prod_rezepte.id%TYPE;'||unistr('\000a')||
'   v_prodr_verweis_rolle_id rollen.id%TYPE;'||unistr('\000a')||
'   v_e';

p:=p||'tikettentyp     number;--prodr_verweise.etikettentyp%TYPE;'||unistr('\000a')||
'   v_plandatum        date;'||unistr('\000a')||
'   v_istdatum         date;'||unistr('\000a')||
'   v_wk_status_id     warenkoerbe.wk_status_id%TYPE;'||unistr('\000a')||
'   v_wk_zahlungsart_id warenkoerbe.wk_zahlungsart_id%TYPE;     -- NEI 28.03.12'||unistr('\000a')||
'   v_sprache_id       number := :fas_sprache_id;'||unistr('\000a')||
'   v_persstamm_id_prod_apo  personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fehlertext       varchar2(2000);'||unistr('\000a')||
'   v_fehlernumm';

p:=p||'er     number;'||unistr('\000a')||
'   v_return           number;'||unistr('\000a')||
'   v_prot_id          number;'||unistr('\000a')||
'   v_fehler           exception;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p989_bestell_id := NULL;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Gewicht und Artikel speichern'||unistr('\000a')||
'   UPDATE personenstamm'||unistr('\000a')||
'   SET gewicht = :p989_gewicht,'||unistr('\000a')||
'       groesse = :p989_groesse,'||unistr('\000a')||
'       rezept_nr = :p989_rezept_nr'||unistr('\000a')||
'   WHERE id = :p989_id;'||unistr('\000a')||
'   '||unistr('\000a')||
'   -- Neues mn_rezept initialisieren'||unistr('\000a')||
'   SELECT mn_rezept_seq.nextval ';

p:=p||'into v_mn_rezept_id from dual;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Rezept holen '||unistr('\000a')||
'   --SELECT rezept_nr,kuerzel,rolle_id,etikettentyp -- NEI 15.07.09 wg.Biogena sprachabhängig'||unistr('\000a')||
'   SELECT rezept_nr,'||unistr('\000a')||
'          fas_synch.get_tab_uebersetzung(''PRODR_VERWEISE.KUERZEL'',ID,:fas_sprache_id),'||unistr('\000a')||
'          rolle_id, etikettentyp'||unistr('\000a')||
'   into v_rezept_nr, v_kuerzel,v_prodr_verweis_rolle_id, v_etikettentyp'||unistr('\000a')||
'   FROM prodr_verweise'||unistr('\000a')||
'   WHERE rezept_nr';

p:=p||' = :p989_rezept_nr;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_prodr_verweis_rolle_id not in (16,14) THEN  -- PARAMEDI/HCKMED'||unistr('\000a')||
'      v_fehlertext:=''Ungültiger Rezepttyp! Nur Typ Paramediform oder HCKMED erlaubt. (''||'||unistr('\000a')||
'                     to_char(v_prodr_verweis_rolle_id)||'')'' ;'||unistr('\000a')||
'      v_fehlernummer := 1;'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'  '||unistr('\000a')||
'   v_rezept_nr_orig := :p989_rezept_nr;'||unistr('\000a')||
'   -- aktuellste Rezept-version holen'||unistr('\000a')||
'   v_version_or';

p:=p||'ig := rezepte.get_mnr_max_version(v_rezept_nr_orig);'||unistr('\000a')||
''||unistr('\000a')||
'--MEL.P(''HCK-MED-Prod 0a MNR-Details speichern Rezept-ID: %1,%2,%3, '',v_prot_id,''Info'',''MNR-Details --speichern'',  v_mn_rezept_id,v_rezept_nr_orig,v_version_orig);   '||unistr('\000a')||
''||unistr('\000a')||
'   -- Reichweite ermitteln'||unistr('\000a')||
'   select id, reichweite,sortiment_id                -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'   into v_prod_rezept_id_orig, v_reichweite,v_sortiment_id';

p:=p||''||unistr('\000a')||
'   from prod_rezepte '||unistr('\000a')||
'   where rezept_nr = v_rezept_nr_orig'||unistr('\000a')||
'     and version = v_version_orig;'||unistr('\000a')||
'--MEL.P(''HCK-MED-Prod 0a MNR-Details speichern Rezept-ID: %1,%2,%3,%4 ,%5,%6'',v_prot_id,''Info'',''MNR-Details speichern'',  v_mn_rezept_id,v_rezept_nr_orig,v_version_orig,v_sortiment_id,v_reichweite,v_prod_rezept_id_orig);   '||unistr('\000a')||
''||unistr('\000a')||
'   -- Kuerzel aus MN-Rezept holen'||unistr('\000a')||
'   select id, bemerkung '||unistr('\000a')||
'   into v_mn_rezept_i';

p:=p||'d_orig, v_bemerkung'||unistr('\000a')||
'   from mn_rezepte '||unistr('\000a')||
'   where rezept_nr = v_rezept_nr_orig'||unistr('\000a')||
'     and version = v_version_orig;'||unistr('\000a')||
''||unistr('\000a')||
'   v_bemerkung := v_kuerzel ||'', ''|| v_bemerkung;'||unistr('\000a')||
''||unistr('\000a')||
'   INSERT INTO v_mn_rezepte '||unistr('\000a')||
'          (id,mn_reztyp_id,mnrezlevel_id, bezeichnung,bemerkung,personenstamm_id,'||unistr('\000a')||
'           aenderbar,rezept_nr_orig,version_orig,'||unistr('\000a')||
'           rezept_nr_kopie,version_kopie )   -- NEI 24.01.13'||unistr('\000a')||
'   VALUES (v_';

p:=p||'mn_rezept_id, '||unistr('\000a')||
'           3, -- manuell erstelltes Rezepts'||unistr('\000a')||
'           3, -- Complete'||unistr('\000a')||
'           :p989_name||'', ''||:p989_vorname||'', ''||:p989_geburtsdatum,'||unistr('\000a')||
'           v_bemerkung,'||unistr('\000a')||
'           :p989_id,'||unistr('\000a')||
'           ''N'',v_rezept_nr_orig,v_version_orig,'||unistr('\000a')||
'           v_rezept_nr_orig,v_version_orig);-- NEI 24.01.13'||unistr('\000a')||
'   '||unistr('\000a')||
'   -- Rezept auf rückberechnet setzen'||unistr('\000a')||
'   UPDATE v_mn_rezepte'||unistr('\000a')||
'   set mn_reztyp_id = 5'||unistr('\000a')||
'   ';

p:=p||'WHERE id = v_mn_rezept_id;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Neue Rezept-id/Version holen '||unistr('\000a')||
'   SELECT rezept_nr'||unistr('\000a')||
'   INTO v_rezept_nr'||unistr('\000a')||
'   FROM mn_rezepte'||unistr('\000a')||
'   WHERE id =  v_mn_rezept_id;'||unistr('\000a')||
'   v_version := rezepte.get_mnr_max_version(v_rezept_nr);'||unistr('\000a')||
'   select id into v_mn_rezept_id_neu'||unistr('\000a')||
'   from mn_rezepte '||unistr('\000a')||
'   where rezept_nr = v_rezept_nr'||unistr('\000a')||
'     and version = v_version;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Produktrezept anlegen'||unistr('\000a')||
'   IF v_prodr_verweis_rolle_id = 14 THE';

p:=p||'N   -- HCK-MED'||unistr('\000a')||
'      -- Anpassen der Reichweite gemaess Gewichtseingabe: Reichweite ist für 1 Person von 50 kg     '||unistr('\000a')||
'      -- v_reichweite := round(50 * (v_reichweite / :p989_gewicht )); -- runden auf Ganzzahl'||unistr('\000a')||
'      v_reichweite := rezepte.CALC_REICHWEITE_BMI (:p989_gewicht,:p989_groesse,v_reichweite,1);'||unistr('\000a')||
'      IF v_reichweite <= 0 THEN -- Fehler'||unistr('\000a')||
'         v_fehlertext:=''Reichweitenberechnung(HCK-MED';

p:=p||') fehltgeschlagen! (''||to_char(v_return)||'')'' ;'||unistr('\000a')||
'         v_fehlernummer := 5;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      -- Datumsangaben für die Bestellung'||unistr('\000a')||
'      v_plandatum := NULL;'||unistr('\000a')||
'      v_istdatum := SYSDATE;'||unistr('\000a')||
'      v_wk_status_id := 60;'||unistr('\000a')||
'      v_wk_zahlungsart_id := 1;    -- NEI 28.03.12'||unistr('\000a')||
'   ELSIF v_prodr_verweis_rolle_id = 16 THEN  -- PARAMEDI'||unistr('\000a')||
'      -- Anpassen der Reichweite gemaess Gewichts';

p:=p||'-/Groesseneingabe: '||unistr('\000a')||
'      v_reichweite := rezepte.CALC_REICHWEITE_BMI (:p989_gewicht,:p989_groesse,v_reichweite,2);'||unistr('\000a')||
'      IF v_reichweite <= 0 THEN -- Fehler'||unistr('\000a')||
'         v_fehlertext:=''Reichweitenberechnung(PARAMEDI) fehltgeschlagen! (''||to_char(v_return)||'')'' ;'||unistr('\000a')||
'         v_fehlernummer := 6;'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      -- Datumsangaben für die Bestellung'||unistr('\000a')||
'      v_plandatum := to_date(';

p:=p||'to_char(sysdate,''DD.MM.YYYY''),''DD.MM.YYYY'');'||unistr('\000a')||
'      v_istdatum := null;'||unistr('\000a')||
'      IF :fas_identitaet_persstamm_id = 24377 THEN -- eovital NEI 20.02.12 => Freigabe mittels WK-uebersicht'||unistr('\000a')||
'         v_wk_status_id := 5;'||unistr('\000a')||
'         v_wk_zahlungsart_id := 3;   -- NEI 28.03.12'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         --v_wk_status_id := 10;     -- NEI 12.12.12 GUS Integration'||unistr('\000a')||
'         v_wk_status_id := 5;        --              wird';

p:=p||' in wk_gen_wk bei Zahlungsart=10 sofort aktiviert'||unistr('\000a')||
'         v_wk_zahlungsart_id := 1;   -- NEI 28.03.12'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'--MEL.P(''HCK-MED-Prod 2 Reichweite: %1 '',v_prot_id,''Info'',''MNR-Details speichern'',  v_reichweite);   '||unistr('\000a')||
''||unistr('\000a')||
'   SELECT p_rezept_seq.nextval INTO v_prod_rezept_id FROM dual;'||unistr('\000a')||
'   INSERT INTO prod_rezepte'||unistr('\000a')||
'         (ID ,'||unistr('\000a')||
'          REZEPT_NR ,'||unistr('\000a')||
'          VERSION ,'||unistr('\000a')||
'          BEZ';

p:=p||'EICHNUNG ,'||unistr('\000a')||
'          BEMERKUNG ,'||unistr('\000a')||
'          PROD_REZTYP_ID ,'||unistr('\000a')||
'          MNREZLEVEL_ID ,'||unistr('\000a')||
'          MAN_GEAENDERT_AM ,'||unistr('\000a')||
'          MAN_GEAENDERT_DURCH ,'||unistr('\000a')||
'          PROD_REZSTATUS_ID,'||unistr('\000a')||
'          prodhinweis2,'||unistr('\000a')||
'          reichweite,'||unistr('\000a')||
'          aenderbar,'||unistr('\000a')||
'          sortiment_id  -- NEI 14.02.2011 Sortimentseinfuehrung    '||unistr('\000a')||
'         )'||unistr('\000a')||
'      VALUES'||unistr('\000a')||
'          (v_prod_rezept_id,'||unistr('\000a')||
'           v_rezept_nr,'||unistr('\000a')||
'           v';

p:=p||'_version,'||unistr('\000a')||
'           ''Produktrezept fÃ¼r MNR-ID ''||to_char(v_mn_rezept_id_neu),'||unistr('\000a')||
'           NULL,'||unistr('\000a')||
'           2,     -- aus MNR erstellt'||unistr('\000a')||
'           3,--v_mnrezlevel_id,'||unistr('\000a')||
'           SYSDATE,'||unistr('\000a')||
'           :APP_USER,'||unistr('\000a')||
'           2,      -- gÃ¼ltig Prodrezept mit zurÃ¼ckgerechnetem MNR '||unistr('\000a')||
'           ''B'',    -- Stueckware bevorzugt, hier nicht von Bedeutung, da nicht generiert wurde'||unistr('\000a')||
'           v_reichweite,'||unistr('\000a')||
'  ';

p:=p||'         ''N'',     -- derartige Rezepte nicht mehr manuelle veränderbar'||unistr('\000a')||
'           v_SORTIMENT_ID   -- NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'         );'||unistr('\000a')||
''||unistr('\000a')||
'    -- Mengenartikel vom Original kopieren'||unistr('\000a')||
'    BEGIN'||unistr('\000a')||
'       v_return := rezepte.kopieren_prodr(v_prod_rezept_id,v_prod_rezept_id_orig);'||unistr('\000a')||
'    EXCEPTION'||unistr('\000a')||
'    WHEN others THEN'||unistr('\000a')||
'       v_fehlertext := ''Artikel konnten nicht eingetragen werden! '' ;'||unistr('\000a')||
'       ';

p:=p||'v_fehlernummer := 10;'||unistr('\000a')||
'       RAISE v_fehler;'||unistr('\000a')||
'    END; '||unistr('\000a')||
''||unistr('\000a')||
'    -- MN-Rezept-Details errechnen'||unistr('\000a')||
'    v_return := rezepte.akt_mnr_details_prod ( v_prod_rezept_id,1); '||unistr('\000a')||
'    IF v_return < 1 THEN'||unistr('\000a')||
'       v_fehlertext := ''MNR konnte nicht aktualisiert werden! (''||to_char(v_return)||'')'' ;'||unistr('\000a')||
'       v_fehlernummer := 20;'||unistr('\000a')||
'       RAISE v_fehler;'||unistr('\000a')||
'    END IF;   '||unistr('\000a')||
'     '||unistr('\000a')||
'    IF v_prodr_verweis_rolle_id = 14 THEN   -- HCK-';

p:=p||'MED'||unistr('\000a')||
'       -- Nur Bestellung eintragen => nicht in Warenkorb, dient nur dem Etikettendruck für Externe'||unistr('\000a')||
'       v_return := auftragsdispo.ad_gen_bestellung(v_rezept_nr,v_version,'||unistr('\000a')||
'                                                :fas_login_personenstamm_id, --Betreuer'||unistr('\000a')||
'                                                v_plandatum,                 -- Plandatum'||unistr('\000a')||
'                                             ';

p:=p||'   v_istdatum,                  -- Istdatum'||unistr('\000a')||
'                                                v_etikettentyp,              -- Eti.typ'||unistr('\000a')||
'                                                :APP_USER'||unistr('\000a')||
'                                               );'||unistr('\000a')||
'       IF v_return > 0 THEN'||unistr('\000a')||
'          -- Vorbereitung für evt. Etikettendruck in der Verzweigung'||unistr('\000a')||
'          :p989_bestell_id := v_return;'||unistr('\000a')||
'       ELSE'||unistr('\000a')||
'          :';

p:=p||'p989_bestell_id := NULL;'||unistr('\000a')||
'          v_fehlertext := ''Bestellung fehlgeschlagen!'';'||unistr('\000a')||
'          v_fehlernummer := 30;'||unistr('\000a')||
'          RAISE v_fehler;'||unistr('\000a')||
'       END IF;'||unistr('\000a')||
'    ELSIF v_prodr_verweis_rolle_id = 16 THEN  -- Paramediformbestellung'||unistr('\000a')||
''||unistr('\000a')||
'--MEL.P(''HCK-MED-Prod Vor warenkorb: %1 '',v_prot_id,''Info'',''MNR-Details speichern'',  v_wk_status_id); '||unistr('\000a')||
'       -- Warenkorb auf der Basis eines Rezepts mit '||unistr('\000a')||
'       -- Warenko';

p:=p||'rb_Details erstellen, aufgesplittet nach Komponenten gemaess prodkennzeichen'||unistr('\000a')||
'       v_persstamm_id_prod_apo := frgbg_s.get_pers_option(v(''APP_USER''),21);'||unistr('\000a')||
'       v_return := frgbg_s.wk_gen_warenkorb ('||unistr('\000a')||
'                      v_rezept_nr,'||unistr('\000a')||
'                      v_version,'||unistr('\000a')||
'                      :FAS_LOGIN_PERSONENSTAMM_ID,'||unistr('\000a')||
'                      v_persstamm_id_prod_apo, -- Prod. Apo wird defaultmaessig a';

p:=p||'us App-User abgeleitet'||unistr('\000a')||
'                      v_plandatum,'||unistr('\000a')||
'                      v_wk_status_id,    -- wk_status_id = bestellt'||unistr('\000a')||
'                      1, -- Menge immer 1'||unistr('\000a')||
'                      v_etikettentyp,'||unistr('\000a')||
'                      :FAS_IDENTITAET_PERSSTAMM_ID ,-- aktive Identitaet  NEI 08.03.2012'||unistr('\000a')||
'                      v_persstamm_id_prod_apo,      -- Rechnungssteller: def. Prod Apo  NEI 08.03.2012'||unistr('\000a')||
'  ';

p:=p||'                    v_wk_zahlungsart_id,           -- NEI 28.03.12 '||unistr('\000a')||
'                      0, -- fixer WK wie bisher NEI 17.10.13'||unistr('\000a')||
'                      0, -- 0 = wie bisher ohne Rundung ganze Packungen bei Fertigartikel aus Mischung NEI 17.10.13'||unistr('\000a')||
'                      0, -- 0 = wie bisher ohne Hinzufügen aller Rezepte, die aus einem Split entstanden sind   NEI 17.10.13'||unistr('\000a')||
'                      1  -- NE';

p:=p||'I 18.06.14 keine Reichweitenstaffel-Rabattberechnung (=0) für Mischungen,'||unistr('\000a')||
'                         --              nur  noch im WK und auf Bestellschein sonst keine Rabattrechnung'||unistr('\000a')||
'                 );'||unistr('\000a')||
'--MEL.P(''HCK-MED-Prod Nach warenkorb: %1 '',v_prot_id,''Info'',''MNR-Details speichern'',  v_return); '||unistr('\000a')||
''||unistr('\000a')||
'       IF v_return > 0 THEN'||unistr('\000a')||
'          -- Vorbereitung für evt. Etikettendruck in der Verzweigung'||unistr('\000a')||
'    ';

p:=p||'      :p989_bestell_id := NULL;  '||unistr('\000a')||
'          /* Zur Zeit kein Druck     '||unistr('\000a')||
'          SELECT min(b.id) INTO  :p989_bestell_id'||unistr('\000a')||
'          FROM bestellungen b,warenkorb_details wd'||unistr('\000a')||
'          WHERE wd.warenkorb_id = v_return'||unistr('\000a')||
'            and wd.id = b.WARENKORB_DETAIL_ID'||unistr('\000a')||
'            and wd.wk_status_id = v_wk_status_id     -- bestellt'||unistr('\000a')||
'            AND wd.prodkennz_id = 1;     -- HCK-Mischung'||unistr('\000a')||
'          */'||unistr('\000a')||
'   ';

p:=p||'    ELSE                   -- Fehler'||unistr('\000a')||
'          :p989_bestell_id := NULL;'||unistr('\000a')||
'          v_fehlertext := ''Bestellung fehlgeschlagen!'';'||unistr('\000a')||
'          v_fehlernummer := 30;'||unistr('\000a')||
'          RAISE v_fehler;'||unistr('\000a')||
'       END IF;'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   ROLLBACK;'||unistr('\000a')||
'   -- Fehler bei der Erstellung des Produktrezepts zu HCK-MED Artikel %0!'||unistr('\000a')||
'   v_fehlertext := frgbg_s.holen_uebersetzung(2216,v_sprache_id,to_cha';

p:=p||'r(:p989_rezept_nr));'||unistr('\000a')||
'   MEL.P(v_fehlertext,v_prot_id,''Fehler'',''Persstamm Schnellrezeptierung'');   '||unistr('\000a')||
'   RAISE_APPLICATION_ERROR (-(20000+v_fehlernummer),v_fehlertext );'||unistr('\000a')||
'WHEN OTHERS THEN'||unistr('\000a')||
'   ROLLBACK;'||unistr('\000a')||
'   -- Fehler bei der Erstellung des Produktrezepts zu HCK-MED Artikel %0!'||unistr('\000a')||
'   v_fehlertext := frgbg_s.holen_uebersetzung(2216,v_sprache_id,to_char(:p989_rezept_nr))'||unistr('\000a')||
'                  ||'' ''||SQLERRM;'||unistr('\000a')||
'   ME';

p:=p||'L.P(v_fehlertext,v_prot_id,''Fehler'',''Persstamm Schnellrezeptierung'');   '||unistr('\000a')||
'   RAISE_APPLICATION_ERROR (-20099,v_fehlertext );'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10294031170603145 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 15,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'rezept_erstellen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''HCK_MED'',''BESTELLEN'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p989_bestell_id:= NULL;'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'   SELECT max(b1.id) INTO :p989_bestell_id'||unistr('\000a')||
'   from bestellungen b1 ,   prodr_details pd1'||unistr('\000a')||
'   where b1.persstamm_id = :p989_id                                       -- aktuelle Person'||unistr('\000a')||
'     and b1.P_REZEPT_ID = pd1.P_REZEPT_ID'||unistr('\000a')||
'     and pd1.MENGENART_ID = :p989_mengenart_id                            -- eingestellter ARtikel'||unistr('\000a')||
'     and b1.istdatum = ';

p:=p||'('||unistr('\000a')||
'          SELECT max(istdatum)'||unistr('\000a')||
'          FROM bestellungen b, prodr_details pd'||unistr('\000a')||
'          WHERE istdatum >= to_date(to_char(sysdate,''DD.MM.YYYY''),''DD.MM.YYYY'')     -- Tagesdatum'||unistr('\000a')||
'            and istdatum <  to_date(to_char(sysdate+1,''DD.MM.YYYY''),''DD.MM.YYYY'')'||unistr('\000a')||
'            and persstamm_id = :p989_id                                     -- aktuelle Person'||unistr('\000a')||
'            and b.P_REZEPT_ID = pd.P_REZEPT_';

p:=p||'ID'||unistr('\000a')||
'            and pd.MENGENART_ID = :p989_mengenart_id                        -- eingestellter ARtikel'||unistr('\000a')||
'         )     ;'||unistr('\000a')||
''||unistr('\000a')||
'   -- letzte Bestellung des Rezept für die Person am aktuellen Tag'||unistr('\000a')||
'   SELECT max(b1.id) INTO :p989_bestell_id'||unistr('\000a')||
'   from bestellungen b1'||unistr('\000a')||
'   where b1.persstamm_id = :p989_id                                       -- aktuelle Person'||unistr('\000a')||
'     and b1.rezept_nr = :p989_rezept_nr            ';

p:=p||'                       -- eingestelltes Rezept'||unistr('\000a')||
'     and b1.istdatum = ('||unistr('\000a')||
'          SELECT max(istdatum)'||unistr('\000a')||
'          FROM bestellungen b'||unistr('\000a')||
'          WHERE istdatum >= to_date(to_char(sysdate,''DD.MM.YYYY''),''DD.MM.YYYY'')     -- Tagesdatum'||unistr('\000a')||
'            and istdatum <  to_date(to_char(sysdate+1,''DD.MM.YYYY''),''DD.MM.YYYY'')'||unistr('\000a')||
'            and persstamm_id = :p989_id                                   -- aktuelle P';

p:=p||'erson'||unistr('\000a')||
'            and b.rezept_nr =  :p989_rezept_nr                            -- eingestelltes Rezept'||unistr('\000a')||
'          ); '||unistr('\000a')||
'*/'||unistr('\000a')||
' SELECT max(b1.id) INTO :p989_bestell_id'||unistr('\000a')||
'   from bestellungen b1, mn_rezepte mnr1'||unistr('\000a')||
'   where b1.persstamm_id = :p989_id                                        -- aktuelle Person'||unistr('\000a')||
'            and b1.mn_rezept_id = mnr1.id'||unistr('\000a')||
'            and mnr1.rezept_nr_orig = :p989_rezept_nr        ';

p:=p||'              -- eingestelltes Rezept'||unistr('\000a')||
'     and b1.istdatum = ('||unistr('\000a')||
'          SELECT max(istdatum)'||unistr('\000a')||
'          FROM bestellungen b, mn_rezepte mnr'||unistr('\000a')||
'          WHERE istdatum >= to_date(to_char(sysdate,''DD.MM.YYYY''),''DD.MM.YYYY'')     -- Tagesdatum'||unistr('\000a')||
'            and istdatum <  to_date(to_char(sysdate+1,''DD.MM.YYYY''),''DD.MM.YYYY'')'||unistr('\000a')||
'            and  persstamm_id = :p989_id                                   -- ak';

p:=p||'tuelle Person'||unistr('\000a')||
'            and b.mn_rezept_id = mnr.id'||unistr('\000a')||
'            and mnr.rezept_nr_orig = :p989_rezept_nr                       -- eingestelltes Rezept'||unistr('\000a')||
'          );    '||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others THEN'||unistr('\000a')||
'      NULL;'||unistr('\000a')||
'   END;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10294231464603150 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 20,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'rezept_nachdrucken',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request in (''HCK_MED_NACHDRUCK'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'-- Da evt. beim Speichern die Patientensprache geändert wird, kann dies '||unistr('\000a')||
'-- auf die FAS-Sprache auswirkungen haben => FAS-Sprache neu bestimmen'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :fas_sprache_id:= frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10294421905603150 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 30,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'fas_sprache_festlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'2175419584582678';

wwv_flow_api.create_page_process(
  p_id     => 10294616609603151 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 61,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'ON_DEMAND',
  p_process_name=> 'set_fas_texte',
  p_process_sql_clob => 2175419584582678 + wwv_flow_api.g_id_offset,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'SAVE DELETE',
  p_process_when_type=>'REQUEST_IN_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_persstamm_id_identitaet  pers_zugriffe.persstamm_id_betreuerzugriff%TYPE;'||unistr('\000a')||
'   v_standard                 pers_zugriffe.standard%TYPE;'||unistr('\000a')||
'   v_anz     number;'||unistr('\000a')||
'   v_anz_std number;'||unistr('\000a')||
'   v_return  number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p989_betreuer = ''N'' THEN '||unistr('\000a')||
'      -- Default-Identität der Login-Betreuers holen'||unistr('\000a')||
'      --v_persstamm_id_identitaet := frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'    ';

p:=p||'  -- Aktive Identität'||unistr('\000a')||
'      v_persstamm_id_identitaet :=:fas_identitaet_persstamm_id;'||unistr('\000a')||
'      /*'||unistr('\000a')||
'      -- Check Vorhandensein der Zugriffe'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM pers_zugriffe'||unistr('\000a')||
'      WHERE persstamm_id_betreuer = :p989_id'||unistr('\000a')||
'        AND persstamm_id_betreuerzugriff = :p989_id;'||unistr('\000a')||
'      IF v_anz = 0 THEN'||unistr('\000a')||
'         INSERT INTO pers_zugriffe (persstamm_id_betreuer,persstamm_id_betreuerzugr';

p:=p||'iff)'||unistr('\000a')||
'         VALUES (:p989_id,:p989_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      -- Check Std-Identitaeten Zugriff'||unistr('\000a')||
'      SELECT count(*) into v_anz_std'||unistr('\000a')||
'      FROM pers_zugriffe'||unistr('\000a')||
'      WHERE persstamm_id_betreuer = :p989_id'||unistr('\000a')||
'        AND standard = ''J'';'||unistr('\000a')||
'      SELECT count(*) into v_anz'||unistr('\000a')||
'      FROM pers_zugriffe'||unistr('\000a')||
'      WHERE persstamm_id_betreuer = :p989_id'||unistr('\000a')||
'        AND persstamm_id_betreuerzugriff = v_persstamm_id_identita';

p:=p||'et;'||unistr('\000a')||
'      IF v_anz = 0 THEN'||unistr('\000a')||
'         IF v_anz_std = 0 THEN'||unistr('\000a')||
'            v_standard := ''J''; -- Als Standard eintragen, da bisher kein Standard vorhanden'||unistr('\000a')||
'         ELSE '||unistr('\000a')||
'            v_standard := ''N''; -- Es gibt bereits einen Standard => nur als Zugriff eintragen'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         INSERT INTO pers_zugriffe (persstamm_id_betreuer,persstamm_id_betreuerzugriff,standard)'||unistr('\000a')||
'         VALUES (:p989_id,';

p:=p||'v_persstamm_id_identitaet,v_standard);'||unistr('\000a')||
'      END IF;  '||unistr('\000a')||
'      UPDATE personenstamm'||unistr('\000a')||
'      SET betreuer = ''J'''||unistr('\000a')||
'      WHERE id = :p989_id;'||unistr('\000a')||
'      */'||unistr('\000a')||
'      v_return := frgbg_s.gen_betreuer (:p989_id,v_persstamm_id_identitaet,'||unistr('\000a')||
'                                        :FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
'         ROLLBACK;'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR (-20000,frgbg_s.holen_uebersetz';

p:=p||'ung(1915,:fas_sprache_id,v_return));'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10294800343603152 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 71,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'betreuer_anlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>10265927504603066 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_persstamm_id_identitaet      pers_zugriffe.persstamm_id_betreuer%TYPE;'||unistr('\000a')||
'   v_persstamm_id_oberidentitaet  pers_zugriffe.persstamm_id_betreuerzugriff%TYPE;'||unistr('\000a')||
'   v_standard                     pers_zugriffe.standard%TYPE;'||unistr('\000a')||
'   v_provisionshierarchie         number;'||unistr('\000a')||
'   v_anz_std number;'||unistr('\000a')||
'   v_return  number;'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :p989_betreuer = ''N'' THEN '||unistr('\000a')||
'      -- Default-Identität';

p:=p||' der Login-Betreuers holen'||unistr('\000a')||
'      -- v_persstamm_id_identitaet := frgbg_s.get_identitaet_betr(:FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'      -- Aktive Identität'||unistr('\000a')||
'      v_persstamm_id_identitaet := :fas_identitaet_persstamm_id;'||unistr('\000a')||
'      -- Oberidentitaet holen'||unistr('\000a')||
'      SELECT persstamm_id_oberidentitaet into v_persstamm_id_oberidentitaet'||unistr('\000a')||
'      FROM pers_identitaeten'||unistr('\000a')||
'      WHERE persstamm_id_identitaet = v_persstamm_i';

p:=p||'d_identitaet;'||unistr('\000a')||
''||unistr('\000a')||
'      -- NEI 18.04.12 Pruefen, ob Provionshierachie automatisch verwaltet werden soll'||unistr('\000a')||
'      IF :p989_ident_option = 0 THEN -- Community-Mitglied ohne Rolle 24 soll angelegt werden'||unistr('\000a')||
'         v_provisionshierarchie := frgbg_s.get_pers_option(NULL,34,:fas_identitaet_persstamm_id,'||unistr('\000a')||
'                                                       :FAS_LOGIN_PERSONENSTAMM_ID);'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         v_p';

p:=p||'rovisionshierarchie := 0; -- Community-Master werden nie in Hierarchie eingetragen'||unistr('\000a')||
'                                      -- Haengen in der Hierarchie automatisch ganz oben'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.P (''Beim Anlegen einer Ident/Betreuerstruktur pers: %1, Ober-Identitaet: %2, akt.Ident %3, r24: %4, Provision: %5, Return:%6! [FAS102/110,identitaet_anlegen]''||SQLERRM, v_PROT_ID, ''INFO'', ''FAS102/110,identit';

p:=p||'aet_anlegen'',:p989_id,v_persstamm_id_oberidentitaet,v_persstamm_id_identitaet,:p989_ident_option,v_provisionshierarchie,v_return);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      -- Identitaetstruktur anlegen'||unistr('\000a')||
'      v_return := frgbg_s.gen_ident_betreuer (:p989_id,v_persstamm_id_oberidentitaet,'||unistr('\000a')||
'                            v_persstamm_id_identitaet,'||unistr('\000a')||
'                            :p989_ident_option,     -- NEI 18.04.12 Rolle 24 bei Ident ei';

p:=p||'nhaengen'||unistr('\000a')||
'                            v_provisionshierarchie) -- NEI 18.04.12 Provisionshierarchie eintragen'||unistr('\000a')||
'                   ;'||unistr('\000a')||
'/*MEL.P (''Beim Anlegen einer Ident/Betreuerstruktur pers: %1, Ober-Identitaet: %2, akt.Ident %3, r24: %4, Provision: %5, Return:%6! [FAS102/110,identitaet_anlegen]''||SQLERRM, v_PROT_ID, ''INFO'', ''FAS102/110,identitaet_anlegen'',:p989_id,v_persstamm_id_oberidentitaet,v_pers';

p:=p||'stamm_id_identitaet,:p989_ident_option,v_provisionshierarchie,v_return);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
'         RAISE_APPLICATION_ERROR'||unistr('\000a')||
'                  (-20000,frgbg_s.holen_uebersetzung(1915,:fas_sprache_id,v_return));         '||unistr('\000a')||
'         ROLLBACK;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10295007556603152 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 81,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'identitaet_anlegen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when_button_id=>10265705787603066 + wwv_flow_api.g_id_offset,
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   DOKUMENTEN_DRUCK.HCK_MED_ETIKETT('||unistr('\000a')||
'         P_BESTELL_ID=>:P989_BESTELL_ID,'||unistr('\000a')||
'         P_POSITION  =>:P989_HCK_MED_DRUCKPOS'||unistr('\000a')||
'       );'||unistr('\000a')||
'   apex_application.stop_apex_engine;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10291227943603140 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 90,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'PLSQL',
  p_process_name=> 'Druck HCK-MED-Etikett',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_when=>':p989_bestell_id is not null and'||unistr('\000a')||
':request in (''HCK_MED'',''HCK_MED_NACHDRUCK'')'||unistr('\000a')||
'',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :P989_GUTSCHEINSTATUS := NVL(:P989_GUTSCHEINSTATUS,0);'||unistr('\000a')||
'   :P989_GUTSCHEINANZAHL := NVL(:P989_GUTSCHEINANZAHL,0);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10295221326603153 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_gutschein',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'    IF frgbg_s.check_fas_rolle(:APP_USER,''COMMUNITY_ADMIN'')> 0 /*Community-Admin */ THEN'||unistr('\000a')||
'       :p989_ident_option := NVL(:p989_ident_option,1);'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'       :p989_ident_option := NVL(:p989_ident_option,0);'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10295420808603153 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_ident_option',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   :p989_betreuer := NVL(:p989_betreuer,''N'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10295603742603154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 1,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_betreuer',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := :fas_sprache_id;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p989_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :p989_bl_loeschen  := frgbg_s.holen_uebersetzung(167,v_sprache_id);'||unistr('\000a')||
'   :p989_bl_speichern := frgbg_s.holen_uebersetzung(172,v_sprache_id);'||unistr('\000a')||
'   :p989_bl_aendern   := frgbg_s.holen_uebersetzung(162,v_sprache_id);'||unistr('\000a')||
'   :p989_bl_erstellen := frgbg_s.holen_uebersetzung(163,v_s';

p:=p||'prache_id);'||unistr('\000a')||
'   :p989_bl_passwort_chg := frgbg_s.holen_uebersetzung(171,v_sprache_id);'||unistr('\000a')||
'   :P989_BL_warenkorb := frgbg_s.holen_uebersetzung(3097,v_sprache_id);'||unistr('\000a')||
'   :P989_BL_auswaehlen := frgbg_s.holen_uebersetzung(1597,v_sprache_id); '||unistr('\000a')||
'   :P989_BL_hck_med := frgbg_s.holen_uebersetzung(2152,v_sprache_id); '||unistr('\000a')||
'   :P989_BL_hck_med_nachdruck := frgbg_s.holen_uebersetzung(2217,v_sprache_id); '||unistr('\000a')||
'   :P989_BL_best';

p:=p||'ellen := frgbg_s.holen_uebersetzung(1980,v_sprache_id); '||unistr('\000a')||
'   :p989_bl_fb_rezept := frgbg_s.holen_uebersetzung(485,v_sprache_id); '||unistr('\000a')||
'   :p989_bl_betreuer  := frgbg_s.holen_uebersetzung(1854,v_sprache_id); '||unistr('\000a')||
'   :p989_bl_identitaet:= frgbg_s.holen_uebersetzung(3581,v_sprache_id); '||unistr('\000a')||
''||unistr('\000a')||
'   :p989_region_titel_pwd_chg := frgbg_s.holen_uebersetzung(170,v_sprache_id);'||unistr('\000a')||
'   :p989_region_titel_hilfetexte := frgbg_s.h';

p:=p||'olen_uebersetzung(220,v_sprache_id);'||unistr('\000a')||
'   :p989_region_titel_infotext := frgbg_s.holen_uebersetzung(247,v_sprache_id);'||unistr('\000a')||
'   :p989_page_titel_patientanzeige := frgbg_s.holen_uebersetzung(482,v_sprache_id);'||unistr('\000a')||
'   :P989_PAGE_TITEL_RECHNUNGSADR:= frgbg_s.holen_uebersetzung(1596,v_sprache_id);'||unistr('\000a')||
'   :P989_PAGE_TITEL_LIEFERADR:= frgbg_s.holen_uebersetzung(1685,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P989_BETRABFR_TEXT := frgbg_s.hol';

p:=p||'en_uebersetzung(3831,v_sprache_id);'||unistr('\000a')||
'   :P989_IDENTABFR_TEXT := frgbg_s.holen_uebersetzung(3832,v_sprache_id);'||unistr('\000a')||
''||unistr('\000a')||
'   :P989_NV_PATIENT := frgbg_s.holen_uebersetzung(3835,v_sprache_id);'||unistr('\000a')||
'  '||unistr('\000a')||
'   :p989_info := frgbg_s.holen_uebersetzung(173,v_sprache_id);'||unistr('\000a')||
'   :p989_fehler := frgbg_s.holen_uebersetzung(487,v_sprache_id);'||unistr('\000a')||
'   :p989_tab1_text := frgbg_s.holen_uebersetzung(484,v_sprache_id);'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10295800349603154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 2,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_init',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'BEGIN'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''alert("''||frgbg_s.holen_uebersetzung(2249,:fas_sprache_id)||''");'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10296017277603155 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 5,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'nachdruckhinweis_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'NACHDRUCKHINWEIS',
  p_process_when_type=>'REQUEST_EQUALS_CONDITION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_plandatum DATE;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_plandatum := to_date(to_char(sysdate,''DD.MM.YYYY''),''DD.MM.YYYY'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''alert("''||frgbg_s.holen_uebersetzung(2000,:fas_sprache_id,v_plandatum)||''");'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10296202520603155 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 6,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'bestellhinweis_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':REQUEST in (''BESTELLHINWEIS'')',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_return         number;'||unistr('\000a')||
'   v_user_account   personenstamm.user_account%TYPE;'||unistr('\000a')||
'   v_passwort       personenstamm.passwort%TYPE;'||unistr('\000a')||
'   v_prot_id        number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   -- Holen des aktuellen PW/UserAccount: Noch bevor neue akt. Ident geholt wird '||unistr('\000a')||
'   -- und persstamm geladen wird,'||unistr('\000a')||
'   -- da dies evt. nicht funktioniert und auf die Page 130 gesprungen werden muss.'||unistr('\000a')||
'   -- Zuvor muss der Vorgang';

p:=p||' noch ordnungsgemaess abgeschlossen werden'||unistr('\000a')||
'   SELECT user_account, passwort '||unistr('\000a')||
'   INTO v_user_account, v_passwort'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :p989_id;'||unistr('\000a')||
''||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
''||unistr('\000a')||
'   IF frgbg_s.get_pers_option(:APP_USER,30) = 1 THEN -- Betreuerhinweis und PW mailen'||unistr('\000a')||
'      IF frgbg_s.get_pers_option(:APP_USER,28) = 1 THEN  -- Betreuer-/Sperr-Hinweis ohne ';

p:=p||'PW mailen'||unistr('\000a')||
'         -- Sperrhinweis anzeigen und Mail erst beim entsperren'||unistr('\000a')||
'         htp.p(''alert("''||frgbg_s.holen_uebersetzung(3768,:fas_sprache_id,'||unistr('\000a')||
'                                         --      :p989_USER_ACCOUNT)||''");'');'||unistr('\000a')||
'                                                 v_USER_ACCOUNT)||''");'');'||unistr('\000a')||
'      ELSE  -- Betreuerhinweis mit PW mailen zusätzlich Anzeige'||unistr('\000a')||
'         htp.p(''alert("''||frgbg_s.h';

p:=p||'olen_uebersetzung(3774,:fas_sprache_id,'||unistr('\000a')||
'                                         --      :p989_USER_ACCOUNT,:p989_passwort)||''");'');'||unistr('\000a')||
'                                                 v_USER_ACCOUNT,v_passwort)||''");'');'||unistr('\000a')||
'         --v_return := frgbg_s.MAIL_NEUES_PASSWORT(:p989_USER_ACCOUNT,NULL,  -- Zielperson'||unistr('\000a')||
'         v_return := frgbg_s.MAIL_NEUES_PASSWORT(v_USER_ACCOUNT,NULL,  -- Zielperson'||unistr('\000a')||
'      ';

p:=p||'                                           3771,3772,                -- Betreff-/Mailtexte'||unistr('\000a')||
'                                                 :FAS_IDENTITAET_PERSSTAMM_ID,-- Absender'||unistr('\000a')||
'                                                 0,0,   -- keine neue PW-Vergabe,no_reply-adresse'||unistr('\000a')||
'                                                 0);    -- keine Notfallemail'||unistr('\000a')||
'    '||unistr('\000a')||
'         IF v_return <= 0 THEN'||unistr('\000a')||
'       ';

p:=p||'     htp.p(''alert("''||frgbg_s.holen_uebersetzung(3773,:fas_sprache_id,'||unistr('\000a')||
'                                               --:p989_USER_ACCOUNT,:p989_passwort)||''");'');'||unistr('\000a')||
'                                               v_USER_ACCOUNT,v_passwort)||''");'');'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;  '||unistr('\000a')||
'   ELSE  -- PW anzeigen'||unistr('\000a')||
'      htp.p(''alert("''||frgbg_s.holen_uebersetzung(3580,:fas_sprache_id,'||unistr('\000a')||
'                        ';

p:=p||'                       --:p989_USER_ACCOUNT,:p989_passwort)||''");'');'||unistr('\000a')||
'                                               v_USER_ACCOUNT,v_passwort)||''");'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   mel.p(''Zugriff auf Patientendaten fehlgeschlagen Ident/Betreuerhinweis!ID %1,%2'', '||unistr('\000a')||
'          v_prot_id,''ERROR'',  '||unistr('\000a')||
'          ''102/110:betreuerhinweis_ausgeben'',:p9';

p:=p||'89_id,SQLERRM);'||unistr('\000a')||
'   RAISE_APPLICATION_ERROR(-20000,''Fehler'');'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10296401510603156 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 7,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'betreuerhinweis_ausgeben',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''BETREUER_HINWEIS'' ',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_user   VARCHAR2(100);'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'   v_return NUMBER;'||unistr('\000a')||
'   v_prot_id NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*mel.p(''p989_person %1,p989_pis_pat_akte_id %2,fas_aufgerufen_von %3,:p989_id %4,%5'',v_prot_id,''INFO'', ''102/P989 get_personendaten'',:p989_person,:p989_pis_pat_akte_id,:fas_aufgerufen_von,:p989_id,:APP_USER);'||unistr('\000a')||
'*/'||unistr('\000a')||
'   IF :p989_person is null AND :p989_pis_pat_akte_id IS NULL '||unistr('\000a')||
'   THEN   '||unistr('\000a')||
' ';

p:=p||'     --IF :p989_abbrechen_zu_seite = 130 THEN  -- Anlegen eines Patienten'||unistr('\000a')||
'      IF :fas_aufgerufen_von = ''BETREUER'' THEN -- Anlegen eines Patienten'||unistr('\000a')||
'         --:p989_id := NULL;'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'      ELSE              -- externes Login :p989_person wird mit dem aktuellen Benutzer bestückt'||unistr('\000a')||
'         v_user  := :APP_USER;'||unistr('\000a')||
'         SELECT id   '||unistr('\000a')||
'         INTO :p989_id '||unistr('\000a')||
'         FROM personenstamm'||unistr('\000a')||
'       ';

p:=p||'  WHERE user_account = UPPER(v_user)'||unistr('\000a')||
'           AND satzkennzeichen is null;  -- gelöschte Sätze nicht mehr anzeigen'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSE  -- Aufruf via Pis p989_person oder betreuer-Login enthält bereits die Personenstamm_id; '||unistr('\000a')||
'      IF :p989_person is not NULL THEN'||unistr('\000a')||
'         :p989_id := :p989_person;'||unistr('\000a')||
'      ELSE  -- Person nur in PIS => in Personenstamm von FAS anlegen'||unistr('\000a')||
'         -- Check ADR-Verwei';

p:=p||'s      NEI 13.12.07'||unistr('\000a')||
'         v_return := mailingauftraege_s.GET_ADR_VERWEIS_FAS(:p989_pis_adresse_id); '||unistr('\000a')||
'         IF v_return <= 0 THEN'||unistr('\000a')||
'            -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id)||'||unistr('\000a')||
'                                                    '' (''||to_char(v_return)||'',1)'';'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR (-20000,v_f';

p:=p||'ehlertext );'||unistr('\000a')||
'         ELSIF v_return > 0 THEN'||unistr('\000a')||
'            :p989_id := v_return;'||unistr('\000a')||
'         ELSE -- NULL Es wurde kein Verweis gefunden => Person neu aufnehmen'||unistr('\000a')||
'            v_return := frgbg_s.gen_personenstamm(:p989_pis_pat_akte_id,NULL,:APP_USER,'||unistr('\000a')||
'                                                  1,-- mit Dummy-Passwort'||unistr('\000a')||
'                                                  1,-- mit PIS-Adr-Verweis'||unistr('\000a')||
'      ';

p:=p||'                                            0);-- als Kunde u. nicht als Betreuer'||unistr('\000a')||
'            IF v_return <= 0 THEN'||unistr('\000a')||
'               -- Zugriff auf Personenstamm fehlgeschlagen'||unistr('\000a')||
'               v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id)||'||unistr('\000a')||
'                                                       '' (''||to_char(v_return)||'',2)'';'||unistr('\000a')||
'               ROLLBACK;'||unistr('\000a')||
'               RAISE_APPLICATION';

p:=p||'_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'            ELSE'||unistr('\000a')||
'               COMMIT;'||unistr('\000a')||
'               :p989_id := v_return;'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         END IF;          '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF; '||unistr('\000a')||
'/*mel.p(''p989_person %1,p989_pis_pat_akte_id %2,fas_aufgerufen_von %3,:p989_id %4'',v_prot_id,''INFO'', ''102/P989 get_personendaten'',:p989_person,:p989_pis_pat_akte_id,:fas_aufgerufen_von,:p989_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
' END;';

wwv_flow_api.create_page_process(
  p_id     => 10296608883603157 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 9,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'get_personendaten',
  p_process_sql_clob => p,
  p_process_error_message=> 'Login ungültig!',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_kunde        VARCHAR2(2000);'||unistr('\000a')||
'   v_user_account VARCHAR2(2000);'||unistr('\000a')||
'   v_hinweis      varchar2(2000);'||unistr('\000a')||
'   v_return      number := 1;'||unistr('\000a')||
'   v_prot_id     number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''Gutschein-Email versenden %1'',v_prot_id,''TEST'',''102/110:send_gutschein_email'');'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   --htp.p(''alert("''||frgbg_s.holen_uebersetzung(4907,:fas_sprache_id)||''")';

p:=p||';'');'||unistr('\000a')||
'   htp.p(''if (!confirm("''||frgbg_s.holen_uebersetzung(4907,:fas_sprache_id)||''")) redirect(''''f?p=&APP_ID.:110:&APP_SESSION.'''');'');'||unistr('\000a')||
''||unistr('\000a')||
'   -- Mail-Parameter vorbereiten'||unistr('\000a')||
'   -- auf p989_user_account kann nicht immer zugegriffen werden, da Feld teilweise ausgeblendet wird'||unistr('\000a')||
'   -- und daher nicht bestückt ist => Select über id'||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
'      SELECT user_account INTO v_user_account'||unistr('\000a')||
'      FROM personenst';

p:=p||'amm'||unistr('\000a')||
'      WHERE id = :p989_id;'||unistr('\000a')||
''||unistr('\000a')||
'--mel.p(''Gutschein-Email versenden %1, %2'',v_prot_id,''TEST'',''102/110:send_gutschein_email'',v_user_account,:p989_user_account);'||unistr('\000a')||
'      v_return := frgbg_s.MAIL_TEXT'||unistr('\000a')||
'                       (NULL'||unistr('\000a')||
'                       ,:p989_id'||unistr('\000a')||
'                       ,4908                     -- BETREFF_TEXT_ID'||unistr('\000a')||
'                       ,4909                     -- MAIL_TEXT_ID  '||unistr('\000a')||
'        ';

p:=p||'               ,:FAS_IDENTITAET_PERSSTAMM_ID    -- PERSSTAMM_ID_MAILABSENDER => Identität'||unistr('\000a')||
'                       ,0                        -- Replay-Adresse'||unistr('\000a')||
'                       ,1                        -- NOTFALL_EMAIL '||unistr('\000a')||
'                       ,v_user_account           -- Param1  '||unistr('\000a')||
'                       ,NULL                     -- Param2'||unistr('\000a')||
'              );'||unistr('\000a')||
'      IF v_return <= 0 THEN'||unistr('\000a')||
'         --';

p:=p||' ''Die Email konnte nicht ordnungsgemäss übermittelt werden! ...'||unistr('\000a')||
'         v_hinweis := frgbg_s.holen_uebersetzung(4910,:fas_sprache_id,'||unistr('\000a')||
'                                        frgbg_s.get_pers_adresse(:FAS_IDENTITAET_PERSSTAMM_ID));'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         -- ''Die Email wurde versendet!'';'||unistr('\000a')||
'         v_hinweis := frgbg_s.holen_uebersetzung(4911,:fas_sprache_id);'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   EXCEPTION'||unistr('\000a')||
'   WHEN others T';

p:=p||'HEN'||unistr('\000a')||
'      -- ''Die Email konnte nicht ordnungsgemäss übermittelt werden! ...'||unistr('\000a')||
'      v_hinweis := frgbg_s.holen_uebersetzung(4910,:fas_sprache_id,'||unistr('\000a')||
'                                        frgbg_s.get_pers_adresse(:FAS_IDENTITAET_PERSSTAMM_ID));'||unistr('\000a')||
'   END;'||unistr('\000a')||
'   '||unistr('\000a')||
'   htp.p(''alert("''||v_hinweis||''");'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   '||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10296826941603159 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'send_gutschein_email',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>':request = ''GUTSCHEIN_EMAILVERSAND''',
  p_process_when_type=>'PLSQL_EXPRESSION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_identitaet_persstamm_id   personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fas_pers_schema_id        fas_schemas.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                varchar2(2000);'||unistr('\000a')||
'   v_url                       varchar2(2000);'||unistr('\000a')||
'   v_prot_id                   number;'||unistr('\000a')||
'   v_fehler                    exception;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.P (''Wahlidentitaet %1; Login-id %2; Kunde %3, fas_ident %4, p130_ident %5'', v_PROT_ID, --''ERROR'', ''';

p:=p||'aktive_identitaet_setzen'',:p989_wahl_identitaet,:fas_login_personenstamm_id,:p989_id, --:fas_identitaet_persstamm_id,:P130_IDENTITAET);'||unistr('\000a')||
'   IF :fas_aufgerufen_von = ''BETREUER'' THEN'||unistr('\000a')||
'      IF :p989_wahl_identitaet IS NOT NULL THEN  -- Prüfen, ob Identitaet neu gesetzt werden muss'||unistr('\000a')||
'         IF :p989_id IS NULL THEN -- Neue Person'||unistr('\000a')||
'            IF :p989_wahl_identitaet = 0 THEN -- aktive Identität verwend';

p:=p||'en'||unistr('\000a')||
'               v_identitaet_persstamm_id:= :fas_identitaet_persstamm_id; '||unistr('\000a')||
'            ELSE  -- eingestellte Identität verwenden'||unistr('\000a')||
'               v_identitaet_persstamm_id:= :p989_wahl_identitaet; '||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         ELSE  -- vorhandene Person'||unistr('\000a')||
'            /* NEI 16.09.11 => Zukünftig soll keine Rücksicht auf die Wahlidentität genommen werden'||unistr('\000a')||
'                               sondern nur noc';

p:=p||'h die bevorzugt betreuende Person des Kunden wird'||unistr('\000a')||
'                               aktive Identität, sofern der Betreuerzugriff hat'||unistr('\000a')||
'            v_identitaet_persstamm_id:=  '||unistr('\000a')||
'               frgbg_s.get_identitaet_kunde(:fas_login_personenstamm_id,'||unistr('\000a')||
'                                            :p989_wahl_identitaet,'||unistr('\000a')||
'                                            :p989_id);'||unistr('\000a')||
'            */'||unistr('\000a')||
'            /* NEI';

p:=p||' 20.09.13: => Zukünftig wird nur noch die bevorzugt betreuende Person des Kunden zur'||unistr('\000a')||
'                               aktive Identität egal ob der Betreuer Zugriff auf die Identität hat.'||unistr('\000a')||
'                               Er sieht den Kunden, vielleicht auch nur, weil er speziell Zugriff auf den Kunden hat, '||unistr('\000a')||
'                               da der Kunde von einer Idenität (Apo Richter) noch zusätzlich bet';

p:=p||'reut wird, '||unistr('\000a')||
'                               auf die der Betreuer auch Zugriff hat. D.h. der Betreuer hat nicht direkten Zugriff'||unistr('\000a')||
'                               auf die bevorzugt betreuende Identität und daher auf alle Kunden von dieser Identität, '||unistr('\000a')||
'                               sondern nur ein spezieller Kunde dieser bevorzugt betreuende Identität ist für den Betreuer bzw.'||unistr('\000a')||
'                          ';

p:=p||'     seiner zugreifbaren Identitäten freigeschaltet.'||unistr('\000a')||
'            */'||unistr('\000a')||
'            v_identitaet_persstamm_id:=  '||unistr('\000a')||
'               frgbg_s.get_identitaet_kunde(NULL,      --:fas_login_personenstamm_id,'||unistr('\000a')||
'                                            -1,'||unistr('\000a')||
'                                            :p989_id);'||unistr('\000a')||
''||unistr('\000a')||
'/* MEL.P (''2 Wahlidentitaet %1; Login-id %2; Ident %3;%4'', v_PROT_ID, ''TESTINFO'', aktive_identitaet_';

p:=p||'setzen'',:p989_wahl_identitaet,:fas_login_personenstamm_id,v_identitaet_persstamm_id,:p130_identitaet); '||unistr('\000a')||
'*/'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         IF v_identitaet_persstamm_id <= 0 OR '||unistr('\000a')||
'            v_identitaet_persstamm_id is NULL'||unistr('\000a')||
'         THEN '||unistr('\000a')||
'            :fas_identitaet := '''';'||unistr('\000a')||
'            :fas_identitaet_persstamm_id := NULL;'||unistr('\000a')||
'            v_fehlertext := frgbg_s.holen_uebersetzung(3098,:fas_sprache_id);'||unistr('\000a')||
'     ';

p:=p||'       RAISE v_fehler;'||unistr('\000a')||
'            --RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'            :fas_identitaet := frgbg_s.get_identitaet_name(v_identitaet_persstamm_id,'||unistr('\000a')||
'                                                          :FAS_SCHEMA_ID);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         :p989_wahl_identitaet := NULL; -- muss nur ';

p:=p||'einmal gesetzt werden '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''ANONYM'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Betreuende Identitaet für Endkunden holen'||unistr('\000a')||
'       SELECT parameter'||unistr('\000a')||
'       INTO v_identitaet_persstamm_id'||unistr('\000a')||
'       FROM sysareas_frgbg'||unistr('\000a')||
'       WHERE id = 6;'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identita';

p:=p||'et_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   ELSIF :fas_aufgerufen_von in (''KUNDE'') and :FAS_IDENTITAET_PERSSTAMM_ID is null THEN'||unistr('\000a')||
'       -- Holen der Identitaet aus Pers_betreuer mit standard = J'||unistr('\000a')||
'       v_identitaet_persstamm_id := frgbg_s.GET_IDENTITAET_KUNDE(NULL,-1,:p989_id);'||unistr('\000a')||
'       :FAS_IDENTITAET_PERSSTAMM_ID := v_identitaet_persstamm_id;'||unistr('\000a')||
'       :fas_identitaet := frgbg_s.get_identit';

p:=p||'aet_name(v_identitaet_persstamm_id,:FAS_SCHEMA_ID);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   -- Schema-Id des Kunden setzen, abgeleitet aus der bevorzugt betreuenden Identitaet'||unistr('\000a')||
'   IF :p989_id IS NULL THEN -- Erstellen eines neuen Patienten'||unistr('\000a')||
'      :fas_pers_schema_id := :fas_schema_id; -- Schema der eingeloggten Person'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      -- Schema der bevorzugt betreuenden Identitaet bestimmen '||unistr('\000a')||
'      v_fas_pers_schema_id := frgbg_';

p:=p||'s.get_fas_schema('||unistr('\000a')||
'            frgbg_s.get_identitaet_kunde(NULL,-1,:p989_id),'||unistr('\000a')||
'             ''IDENTITAET'');'||unistr('\000a')||
'      IF v_fas_pers_schema_id <= 0 OR '||unistr('\000a')||
'         v_fas_pers_schema_id is NULL'||unistr('\000a')||
'      THEN '||unistr('\000a')||
'         :fas_pers_schema_id := '''';'||unistr('\000a')||
'         v_fehlertext := frgbg_s.holen_uebersetzung(3505,:fas_sprache_id);'||unistr('\000a')||
'         RAISE v_fehler;'||unistr('\000a')||
'         --         RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
' ';

p:=p||'     ELSE'||unistr('\000a')||
'         :fas_pers_schema_id := v_fas_pers_schema_id;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   -- Sortiment-ID der aktiven Identitaet '||unistr('\000a')||
'   -- NEI 14.02.2011 Sortimentseinfuehrung: sortiment_id statt preislisten_set_id      '||unistr('\000a')||
'   :FAS_SORTIMENT_ID:= rezepte.get_sortiment(:FAS_IDENTITAET_PERSSTAMM_ID,''IDENTITAET'');'||unistr('\000a')||
'   IF :FAS_SORTIMENT_ID <= 0 OR '||unistr('\000a')||
'      :FAS_SORTIMENT_ID is NULL'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      :FAS_SORTI';

p:=p||'MENT_ID := '''';'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(3518,:fas_sprache_id);'||unistr('\000a')||
'      RAISE v_fehler;'||unistr('\000a')||
'      --      RAISE_APPLICATION_ERROR (-20000,v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''2 Wahlidentitaet %1; Login-id %2; Ident %3; Schema-kunde:%4, Schema:%5,Sortiment:%6,Person:%7'', v_PROT_ID, ''TEST'', ''aktive_identitaet_setzen'',:p989_wahl_identitaet,:fas_login_personenstamm_id,'||unistr('\000a')||
':FAS_IDENTITAE';

p:=p||'T_PERSSTAMM_ID,:fas_pers_schema_id,:fas_schema_id,:FAS_SORTIMENT_ID,:p989_id);'||unistr('\000a')||
'*/'||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
'WHEN v_fehler THEN'||unistr('\000a')||
'   v_url:= APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':130:''||:APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   apex_application.g_';

p:=p||'unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'WHEN others THEN'||unistr('\000a')||
'   mel.p(''Zugriff auf Patientendaten fehlgeschlagen!%1'',v_prot_id,''ERROR'',  '||unistr('\000a')||
'            ''102/110:aktive_identitaet_pers_schema_sortiment_setzen'',SQLERRM);'||unistr('\000a')||
'   v_fehlertext := frgbg_s.holen_uebersetzung(483,:fas_sprache_id);'||unistr('\000a')||
'   v_url:= APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':130:''||:APP_SESSION||''::::P130_HINWEIS';

p:=p||':''||v_fehlertext);'||unistr('\000a')||
'   htp.p(''<body>'');'||unistr('\000a')||
'   htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'   htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'   htp.p(''</script>'');'||unistr('\000a')||
'   htp.p(''</body>'');'||unistr('\000a')||
'   apex_application.g_unrecoverable_error := true;   --- stops all further page processing'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10297032734603160 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 20,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'aktive_identitaet_pers_schema_sortiment_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE '||unistr('\000a')||
'   v_gus_id     personenstamm.gus_id%TYPE;'||unistr('\000a')||
'   v_satzkennzeichen personenstamm.satzkennzeichen%TYPE;'||unistr('\000a')||
'   v_url        VARCHAR2(2000);'||unistr('\000a')||
'   v_fehlertext VARCHAR2(2000);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   /* Identitaeten dürfen nicht gelöscht sein  */'||unistr('\000a')||
''||unistr('\000a')||
'   SELECT gus_id,satzkennzeichen INTO v_gus_id,v_satzkennzeichen'||unistr('\000a')||
'   FROM personenstamm'||unistr('\000a')||
'   WHERE id = :FAS_IDENTITAET_PERSSTAMM_ID;'||unistr('\000a')||
''||unistr('\000a')||
'   IF v_satzkennzeichen is not null TH';

p:=p||'EN'||unistr('\000a')||
'      v_fehlertext := frgbg_s.holen_uebersetzung(10179,:fas_sprache_id);'||unistr('\000a')||
'      v_url:=  APEX_UTIL.PREPARE_URL(''f?p=''||:APP_ID||'':130:''||'||unistr('\000a')||
'                                     :APP_SESSION||''::::P130_HINWEIS:''||v_fehlertext);'||unistr('\000a')||
'      htp.p(''<body>'');'||unistr('\000a')||
'      htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'      htp.p(''window.location.href= "''||v_url||''"'');'||unistr('\000a')||
'      htp.p(''</script>'');'||unistr('\000a')||
'      htp.p(''</body>'');'||unistr('\000a')||
'';

p:=p||'      apex_application.g_unrecoverable_error := true;   --- stops all further page processing      '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10291402666603141 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 21,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_zugang',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_von_mn_rezept_id mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_von_bemerkung    mn_rezepte.bemerkung%TYPE;'||unistr('\000a')||
'   v_von_bezeichnung  mn_rezepte.bezeichnung%TYPE; '||unistr('\000a')||
'   v_von_rezept_nr    mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_von_version      mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_von_reichweite   prod_rezepte.reichweite%TYPE;'||unistr('\000a')||
'   v_mn_rezept_id     mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_mn_rezept_id_neu mn_rezepte.id%TYPE;'||unistr('\000a')||
'   v_rezept_nr   ';

p:=p||'     mn_rezepte.rezept_nr%TYPE;'||unistr('\000a')||
'   v_version          mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_version_neu      mn_rezepte.version%TYPE;'||unistr('\000a')||
'   v_verrechnungsland mn_rezepte.verrechnungsland%type;'||unistr('\000a')||
''||unistr('\000a')||
'   v_sprache_id   NUMBER := :fas_sprache_id;  '||unistr('\000a')||
'   v_fehlertext   VARCHAR2(2000);'||unistr('\000a')||
'   v_return       NUMBER;'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   IF :P989_MN_REZEPT_ID_KOPIE IS NOT NULL THEN'||unistr('\000a')||
' /*MEL.P (''Rezept Kopieren: Pe';

p:=p||'rs=%1 MN-REZEPT:%2! [page110,rezept_kopieren]'', v_PROT_ID, ''ERROR'', ''fas'',:p989_id,:p989_mn_rezept_id_kopie);'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'      v_von_mn_rezept_id := :P989_MN_REZEPT_ID_KOPIE;'||unistr('\000a')||
'      :P989_MN_REZEPT_ID_KOPIE := NULL;'||unistr('\000a')||
'      v_return := rezepte.gen_kopie_mnr_prodr('||unistr('\000a')||
'                   v_von_mn_rezept_id,'||unistr('\000a')||
'                   -- 1 ,     -- gen_hint1=1 =>Maximalmenge muss eingehalten werden -- NEI 15.4.10'||unistr('\000a')||
'       ';

p:=p||'            0,      -- gen_hint1 = 0 => Sollmengen muessen eingehalten werden'||unistr('\000a')||
'                   NULL,   -- gen_hint2 NULL => Wert aus Vorgängerversion benutzen i.R. Reichweite'||unistr('\000a')||
'                   :p989_id,'||unistr('\000a')||
'                   :APP_USER,'||unistr('\000a')||
'                   0, --1=Def.aus der Vorgängerversion, 0= Standarddef.'||unistr('\000a')||
'                   :fas_sortiment_id,            -- NEI 14.02.2011 Sortimentseinfuehrung '||unistr('\000a')||
'  ';

p:=p||'                 :fas_identitaet_persstamm_id, -- NEI 16.09.2011 Grenzewerte pers_typ_id abhaengig'||unistr('\000a')||
'                   v_fehlertext );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10297209334603161 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 23,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'mnr_kopieren',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id      NUMBER;'||unistr('\000a')||
'   v_persstamm_id NUMBER;'||unistr('\000a')||
'   v_return       NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--MEL.p(''Rechnungsadresse eintragen: Pers=%1 id:%2 typ:%3! [page110,rechnungsadresse speichern]'', --v_PROT_ID, ''ERROR'', ''fas'',:p989_id,:p989_persstamm_id_extern_upd,:p989_extern_typ);'||unistr('\000a')||
'   IF :P989_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND :p989_extern_typ = ''R'' THEN'||unistr('\000a')||
'      v_persstamm_id := :P989_persstamm_id_e';

p:=p||'xtern_upd;'||unistr('\000a')||
'      :P989_persstamm_id_extern_upd := NULL;'||unistr('\000a')||
'      :P989_extern_typ:= NULL;'||unistr('\000a')||
' '||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET persstamm_id_rechnung = v_persstamm_id'||unistr('\000a')||
'         WHERE id = :p989_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
'/*MEL.p(''Rechnungsadresse speichern: Pers=%1 id:%2! Fehler:%3 [page110,Rechnungsadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'',:p989_';

p:=p||'id,:p989_persstamm_id_rechnung, SQLERRM);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      END;'||unistr('\000a')||
'   ELSIF :P989_PERSSTAMM_ID_EXTERN_UPD IS NOT NULL AND :p989_extern_typ = ''L'' THEN'||unistr('\000a')||
'      v_persstamm_id := :P989_persstamm_id_extern_upd;'||unistr('\000a')||
'      :P989_persstamm_id_extern_upd := NULL;'||unistr('\000a')||
'      :P989_extern_typ:= NULL;'||unistr('\000a')||
''||unistr('\000a')||
'/*MEL.p(''Lieferadresse speichern: Pers=%1 id:%2! Fehler:%3 [page110,Lieferadresse speichern]'', v_PROT_ID, ''ERROR'', ''fas'',:p989_id';

p:=p||',:P989_persstamm_id_lieferung, SQLERRM);'||unistr('\000a')||
'*/'||unistr('\000a')||
'      BEGIN'||unistr('\000a')||
'         UPDATE personenstamm'||unistr('\000a')||
'         SET persstamm_id_lieferung = v_persstamm_id'||unistr('\000a')||
'         WHERE id = :p989_id;'||unistr('\000a')||
'      EXCEPTION'||unistr('\000a')||
'      WHEN others THEN'||unistr('\000a')||
'         NULL;'||unistr('\000a')||
''||unistr('\000a')||
'      END;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10297423265603161 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 30,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'externe_adressen_speichern',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||':p989_prepare_url_pw:= apex_util.prepare_url('||unistr('\000a')||
'   ''f?p=&APP_ID.:102:&SESSION.::&DEBUG.::P102_ID:''||:P989_ID);';

wwv_flow_api.create_page_process(
  p_id     => 10297619868603162 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 61,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_prepare_url_pw',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'F|#OWNER#:PERSONENSTAMM:P989_ID:ID';

wwv_flow_api.create_page_process(
  p_id     => 10291817054603142 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 62,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'DML_FETCH_ROW',
  p_process_name=> 'personenstamm_holen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DELETE wkorb_det_verordnungen_tmp'||unistr('\000a')||
'WHERE warenkorb_detail_tmp_id in (SELECT wkd.id '||unistr('\000a')||
'                           FROM warenkoerbe_tmp wk, warenkorb_details_tmp wkd'||unistr('\000a')||
'                           WHERE wk.session_id =  :app_session'||unistr('\000a')||
'                             and wk.id = wkd.warenkorb_tmp_id'||unistr('\000a')||
'                           );'||unistr('\000a')||
'DELETE warenkorb_details_tmp'||unistr('\000a')||
'WHERE warenkorb_tmp_id in (SELECT id '||unistr('\000a')||
'                 ';

p:=p||'          FROM warenkoerbe_tmp'||unistr('\000a')||
'                           WHERE session_id =  :app_session'||unistr('\000a')||
'                          );'||unistr('\000a')||
'DELETE warenkoerbe_tmp'||unistr('\000a')||
'where session_id = :app_session;';

wwv_flow_api.create_page_process(
  p_id     => 10292027198603142 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 70,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'init_warenkorb_tmp',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_PERSSTAMM_ID_prod_apo     personenstamm.id%TYPE;'||unistr('\000a')||
'   v_fehlertext                uebersetzungen.text%TYPE;'||unistr('\000a')||
'   v_return                    NUMBER;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   -- Adressprüfung'||unistr('\000a')||
'   IF :P989_ID is not null and (:P989_PERSSTAMM_ID_LIEFERUNG is not null or :P989_PERSSTAMM_ID_RECHNUNG is not null) THEN'||unistr('\000a')||
'      v_persstamm_id_prod_apo := frgbg_s.get_pers_option(v(''APP_USER''),21);'||unistr('\000a')||
'      v_return := ';

p:=p||'frgbg_s.WK_CHECK_ADR_KOMPATIBEL(p_persstamm_id_prod_apo => v_PERSSTAMM_ID_prod_apo,'||unistr('\000a')||
'                                               p_persstamm_id_kunde    => :P989_ID,'||unistr('\000a')||
'                                               p_persstamm_id_lieferung=> NVL(:P989_PERSSTAMM_ID_LIEFERUNG,:P989_ID),'||unistr('\000a')||
'                                               p_persstamm_id_rechnung => NVL(:P989_PERSSTAMM_ID_RECHNUNG,:P989_ID';

p:=p||'),'||unistr('\000a')||
'                                               p_warenkorb_tmp_id      => NULL,    -- NEI 05.06.2014'||unistr('\000a')||
'                                               p_sprache_id            => :fas_sprache_id ,'||unistr('\000a')||
'                                               p_fehlertext_out        => v_fehlertext'||unistr('\000a')||
'                                             );'||unistr('\000a')||
'        '||unistr('\000a')||
'      IF v_return < 0 THEN   -- Hinweismeldung; die eigentli';

p:=p||'che scharfe Prüfung findet im WK statt'||unistr('\000a')||
'         IF v_fehlertext is NOT NULL THEN'||unistr('\000a')||
'            --''Die Lieferadresse muss auch in der Schweiz liegen, da die Kunden-/ die Rechnungsadresse in der Schweiz liegt!'''||unistr('\000a')||
'            htp.p(''<body>'');'||unistr('\000a')||
'            htp.p(''<script type="text/javascript">'');'||unistr('\000a')||
'            --htp.p(''alert("''||frgbg_s.holen_uebersetzung(5689,:fas_sprache_id)||''");'');'||unistr('\000a')||
'            htp.p(''al';

p:=p||'ert("''||v_fehlertext||''");'');'||unistr('\000a')||
'            htp.p(''</script>'');'||unistr('\000a')||
'            htp.p(''</body>'');'||unistr('\000a')||
'         END IF; '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 10291615052603141 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 75,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'check_adressen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id     number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*mel.p(''Gutscheinemail setzen status %1,statusdb %2 '',v_prot_id,''TEST'',''102/110:set_gutscheinemail'',:p989_gutscheinstatus,:p989_gutscheinstatus_db);'||unistr('\000a')||
'*/'||unistr('\000a')||
'NULL;'||unistr('\000a')||
'/*'||unistr('\000a')||
'   IF :p989_gutscheinstatus = 1 and '||unistr('\000a')||
'      :p989_gutscheinstatus_db = 0 and'||unistr('\000a')||
'      :request in (''SAVE'',''DELETE'',''CREATE'',''RECHLOESCHEN'',''LIEFERLOESCHEN'','||unistr('\000a')||
'                   ''APPLY_CHANGES_BETREUER'',''I';

p:=p||'DENTITAET'') AND '||unistr('\000a')||
'      frgbg_s.check_fas_rolle(:APP_USER,  '||unistr('\000a')||
'         ''FB_GUTSCHEINVERFAHREN'') > 0    --Gutscheinverfahren '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      :p989_gutscheinemail := 1;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      :p989_gutscheinemail := 0; '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'*/'||unistr('\000a')||
'/*mel.p(''Gutscheinemail gesetzt %1, status %2,statusdb %3 '',v_prot_id,''TEST'',''102/110:set_gutscheinemail'',:p989_gutscheinemail,:p989_gutscheinstatus,:p989_gutscheinstatus_db);'||unistr('\000a')||
'*/'||unistr('\000a')||
'E';

p:=p||'ND;';

wwv_flow_api.create_page_process(
  p_id     => 10292209512603142 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 989,
  p_process_sequence=> 5,
  p_process_point=> 'ON_SUBMIT_BEFORE_COMPUTATION',
  p_process_type=> 'PLSQL',
  p_process_name=> 'set_gutscheinemail',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_when=>'',
  p_process_when_type=>'NEVER',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 989
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00990
prompt  ...PAGE 990: Testartikelkategorie
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 990
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Testartikelkategorie'
 ,p_step_title => 'Testartikelkategorie'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Testartikelkategorie'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<style type="text/css">'||unistr('\000a')||
'.closed div {height:0px!important}'||unistr('\000a')||
'li.leaf, li.closed, li.open {height:40px!important;}'||unistr('\000a')||
'li.open li.leaf, li.open li.closed, li.open li.open {height:10px!important;}'||unistr('\000a')||
'li.leaf a ins, li.closed a ins, li.open a ins {height:48px!important; width:48px!important}'||unistr('\000a')||
'li.open li.leaf a ins, li.open li.closed a ins, li.open li.open a ins {height:10px!important; width:10px!important}'||unistr('\000a')||
''||unistr('\000a')||
'li'||
'.open ul { margin-top:40px; margin-left:20px; margin-bottom:25px; }'||unistr('\000a')||
''||unistr('\000a')||
'</style>'
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140718100617'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select case when connect_by_isleaf = 1 then 0'||unistr('\000a')||
'            when level = 1             then 1'||unistr('\000a')||
'            else                           -1'||unistr('\000a')||
'       end as status, '||unistr('\000a')||
'       level, '||unistr('\000a')||
'       "BEZEICHNUNG" as title, '||unistr('\000a')||
'       null as icon, '||unistr('\000a')||
'       "ID" as value, '||unistr('\000a')||
'       null as tooltip, '||unistr('\000a')||
'       null as link '||unistr('\000a')||
'from "PIS"."ARTGRUPPEN"'||unistr('\000a')||
'where and sort >=30 and sort < 40'||unistr('\000a')||
'start with "ARTGRUPPE_ID" is null'||unistr('\000a')||
'connect b';

s:=s||'y prior "ID" = "ARTGRUPPE_ID"'||unistr('\000a')||
'order siblings by "SORT"';

wwv_flow_api.create_page_plug (
  p_id=> 8865913816441401 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 990,
  p_plug_name=> 'Kategorien',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_2',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'JSTREE',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow: auto;height: 500px;width: 250px; border-right: 1px dashed #C7C7C7; background-color:#F7F7E7">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||' select case when connect_by_isleaf = 1 then 0'||unistr('\000a')||
'             when level = 1             then 1'||unistr('\000a')||
'             else                           -1'||unistr('\000a')||
'       end as status,'||unistr('\000a')||
'       level,'||unistr('\000a')||
'       "BEZEICHNUNG" as title,'||unistr('\000a')||
'       img as icon,'||unistr('\000a')||
'       "ID" as value,'||unistr('\000a')||
'       null as tooltip,'||unistr('\000a')||
'       CASE when connect_by_isleaf = 1 THEN'||unistr('\000a')||
'APEX_UTIL.PREPARE_URL(''f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::::P990_ARTIKELKATEGOR';

a1:=a1||'IE,P990_ARTIKELKATEGORIE_BEZ,P990_SUCHE:''||ID||'',''||BEZEICHNUNG)'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'       NULL'||unistr('\000a')||
'    END as link'||unistr('\000a')||
'from (    -- Artikel mit Obergruppen'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'       kuerzel,id,sort, '||unistr('\000a')||
'       CASE WHEN dokument_id is not null THEN'||unistr('\000a')||
'         ''#OWNER#.frgbg_t.display_thumb?p_bild_id=''|| NVL (dokument_id, 0)||''&p_sprache_id=''||';

a1:=a1||':fas_sprache_id|| '''''||unistr('\000a')||
'       ELSE NULL END img,'||unistr('\000a')||
'       artgruppe_id'||unistr('\000a')||
'FROM artgruppen'||unistr('\000a')||
'WHERE :p990_wk_artikeltyp_flag in (2)   -- NEI 22.05.13 Keine Mischaufträge mit Laborartikel'||unistr('\000a')||
'                                        -- (1=nur Labor,2=nur sonstige '||unistr('\000a')||
'start with ID in ('||unistr('\000a')||
'      SELECT distinct g.id'||unistr('\000a')||
'      FROM artgruppen g, mengenarts m, sortiment_details sd'||unistr('\000a')||
'      WHERE g.id = m.artgruppe_id'||unistr('\000a')||
'        AND ';

a1:=a1||'m.satz_kennzeichen is null'||unistr('\000a')||
'        AND m.id = sd.mengenart_id'||unistr('\000a')||
'        AND sd.sortiment_id in ( 4)--:fas_sortiment_id)'||unistr('\000a')||
'        AND sd.satz_kennzeichen is null'||unistr('\000a')||
'        AND sd.verkaufsartikel != ''N'''||unistr('\000a')||
'        AND g.id != 20 /* nicht Laborauftragsartikel */'||unistr('\000a')||
'        AND (g.id = 76 AND  :P990_std_mischartikel>0  /* Std.Michartikel nur mit Rollenfreigabe*/'||unistr('\000a')||
'             OR'||unistr('\000a')||
'             g.id != 76'||unistr('\000a')||
'          ';

a1:=a1||'  )'||unistr('\000a')||
'       )'||unistr('\000a')||
'connect by prior ARTGRUPPE_ID=id'||unistr('\000a')||
''||unistr('\000a')||
'UNION  -- Rezepte nur 1 Ebene'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4859,:fas_sprache_id),'||unistr('\000a')||
'       frgbg_s.holen_uebersetzung(4859,:fas_sprache_id),-1,0.2,'||unistr('\000a')||
'       ''#OWNER#.frgbg_t.display_thumb?p_bild_id= 10660 &p_sprache_id=''||:fas_sprache_id,'||unistr('\000a')||
'       NULL'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'WHERE :p990_wk_artikeltyp_flag in (2) -- NEI 22.05.13 Keine Mischaufträge mit Laborartikel'||unistr('\000a')||
'';

a1:=a1||'                                      -- (1=nur Labor,2=nur sonstige '||unistr('\000a')||
''||unistr('\000a')||
'UNION  -- Laborauftrag nur 1 Ebene'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'       kuerzel,id,0.1,'||unistr('\000a')||
'       CASE WHEN dokument_id is not null THEN'||unistr('\000a')||
'         ''#OWNER#.frgbg_t.display_thumb?p_bild_id=''|| NVL (dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'       ELSE NULL EN';

a1:=a1||'D img,'||unistr('\000a')||
'       NULL'||unistr('\000a')||
'FROM artgruppen'||unistr('\000a')||
'WHERE :p990_wk_artikeltyp_flag in (1)    -- NEI 22.05.13 Keine Mischaufträge mit Laborartikel'||unistr('\000a')||
'                                         -- (1=nur Labor,2=nur sonstige '||unistr('\000a')||
'  and id in ('||unistr('\000a')||
'             SELECT distinct g.id'||unistr('\000a')||
'             FROM artgruppen g, mengenarts m, sortiment_details sd'||unistr('\000a')||
'             WHERE g.id = m.artgruppe_id'||unistr('\000a')||
'               AND m.satz_kennzeichen is n';

a1:=a1||'ull'||unistr('\000a')||
'               AND m.id = sd.mengenart_id'||unistr('\000a')||
'               AND sd.sortiment_id in ( 4) --:fas_sortiment_id)'||unistr('\000a')||
'               AND sd.satz_kennzeichen is null'||unistr('\000a')||
'               AND sd.verkaufsartikel != ''N'''||unistr('\000a')||
'               AND g.id = 20 -- nur Laborauftragsartikel '||unistr('\000a')||
'            )'||unistr('\000a')||
'   and (select count(*)       -- nicht ausgewertete FB zu der Person vorhanden?'||unistr('\000a')||
'       from v_fb_fas'||unistr('\000a')||
'       where personenstam';

a1:=a1||'m_id = 47037 --:P300_PERSSTAMM_ID'||unistr('\000a')||
'         and pergebnis_id is not null'||unistr('\000a')||
'         and perg_akt_version = 1'||unistr('\000a')||
'         and frgbg_s.FB_CHECK_AUSWERTUNG(pergebnis_id)= 0'||unistr('\000a')||
'         and fragebogen_id = 5'||unistr('\000a')||
'        ) > 0'||unistr('\000a')||
'   --AND :p300_extern_verwaltet = 1 --GUS verwaltete Auftraege '||unistr('\000a')||
''||unistr('\000a')||
')'||unistr('\000a')||
'start with "ARTGRUPPE_ID" is null'||unistr('\000a')||
'connect by prior "ID" = "ARTGRUPPE_ID"'||unistr('\000a')||
'order siblings by "SORT"';

wwv_flow_api.create_jstree(
  p_id => 8865822914441401+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id => 990,
  p_region_id => 8865913816441401+wwv_flow_api.g_id_offset,
  p_tree_template     =>'classic',
  p_tree_source             =>'',
  p_tree_query             =>a1,
  p_tree_node_title   =>'BEZEICHNUNG',
  p_tree_node_value   =>'ID',
  p_tree_node_icon   =>'',
  p_tree_node_link   =>'',
  p_tree_node_hints   =>'ARTGRUPPE_ID',
  p_tree_start_item   =>'ARTGRUPPE_ID',
  p_tree_start_value   =>'',
  p_tree_button_option   =>'CONTRACT_ALL:EXPAND_ALL',
  p_show_node_link   =>'',
  p_node_link_checksum_type   =>null,
  p_tree_comment          =>'',
  p_show_hints          =>'N',
  p_tree_has_focus          =>'N',
  p_tree_hint_text          =>'',
  p_tree_click_action          =>'S',
  p_selected_node          =>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select m.id,                                                                        /* Artikel */'||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)'||unistr('\000a')||
'      --||CASE WHEN m.beschreibung is not null THEN  -- NEI 26.03.2014 nur noch die beschreibung_text_id ist aktiv wg. langen Texten'||unistr('\000a')||
'      ||CASE WHEN m.beschreibung_text_id is not null THEN'||unistr('\000a')||
'/*         ''    <a href="''||APE';

s:=s||'X_UTIL.PREPARE_URL('||unistr('\000a')||
'         ''f?p=''||:APP_ID||'':306:''||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id)    '||unistr('\000a')||
'         || ''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'         ''    <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':306:'''||unistr('\000a')||
'         ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id||'''''',700,380)">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >';

s:=s||''''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END'||unistr('\000a')||
'      || ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'             artikel,'||unistr('\000a')||
'      to_char(rezepte.calc_preis_mwst_ges(wk.verrech_land_id,'||unistr('\000a')||
'             m.prodkennz_id,m.id,wk.preisliste_id,'||unistr('\000a')||
'             wk.art_mwst_typ_id, wk.preisfaktor,wk.persstamm_id_prod_a';

s:=s||'po,0)'||unistr('\000a')||
'        ,''999G990D00'')||'' ''||rezepte.get_waehrung_zeichen(wk.waehrung_id)'||unistr('\000a')||
'             stueckpreis,'||unistr('\000a')||
'      CASE WHEN m.dokument_id is not null THEN'||unistr('\000a')||
'      ''<img src="#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         || NVL (m.dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" width="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'      ELSE N';

s:=s||'ULL END img,'||unistr('\000a')||
'/*'||unistr('\000a')||
'  ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':300:''||:APP_SESSION|| '':WARENKORB:::'''||unistr('\000a')||
'     ||''P990_MENGENART_ID:'''||unistr('\000a')||
'     ||m.id)    '||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   wk_link'||unistr('\000a')||
'*/'||unistr('\000a')||
'   CASE WHEN :p990_wk_artikeltyp_flag = 1  -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                           -- =1 h';

s:=s||'eisst bereits Laborartikel im WK => keine sonstigen Artikel mehr '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      '' '''||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P990_MENGENART_ID'''':''||m.id||''}})'''||unistr('\000a')||
'        || ''">'''||unistr('\000a')||
'        || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'        || ''</a>'''||unistr('\000a')||
'   END wk_link,'||unistr('\000a')||
'   1 sort_typ,'||unistr('\000a')||
'   --fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_spra';

s:=s||'che_id) sort_art,'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'',m.ID,:fas_sprache_id) sort_art,'||unistr('\000a')||
'   null sort_rez,'||unistr('\000a')||
'   --to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(NULL,m.id),''DD.MM.YYYY'') last_bestelldatum,'||unistr('\000a')||
'   NULL last_bestelldatum,'||unistr('\000a')||
'   null akt_datum,'||unistr('\000a')||
'   null|| apex_item.hidden(32, NULL) rezept_reichweite '||unistr('\000a')||
'FROM mengenarts m, sortiment_details s, --NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'   ';

s:=s||'  warenkoerbe_tmp wk'||unistr('\000a')||
'where m.satz_kennzeichen is null'||unistr('\000a')||
'  --and m.prodkennz_id = 2   Nur noch über Sortiment-det.verkaufsartikel'||unistr('\000a')||
'  and m.id = s.mengenart_id'||unistr('\000a')||
'  and s.sortiment_id = 4 --:fas_sortiment_id --NEI 14.02.2011 Sortimentseinf.'||unistr('\000a')||
'  and s.satz_kennzeichen is null'||unistr('\000a')||
'  and s.verkaufsartikel != ''N'''||unistr('\000a')||
'  AND ((:P990_suche is NULL and :p990_artikelkategorie = 0 and 1=2) -- keine Ergebnisse => Maskeneinsti';

s:=s||'eg '||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P990_suche is NULL and :p990_artikelkategorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P990_suche is NOT NULL AND '||unistr('\000a')||
'        instr(UPPER (fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id)'||unistr('\000a')||
'        ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id) ),UPPER(:P990_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Art';

s:=s||'ikel die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p990_id'||unistr('\000a')||
'  /*and ( m.id is not null AND'||unistr('\000a')||
'        m.id not in (SELECT mengenart_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p990_id'||unistr('\000a')||
'                       and mengenart_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       OR m.id is null'||unistr('\000a')||
'      )'||unistr('\000a')||
'  */'||unistr('\000a')||
'  --AND :P990_ARTIKELKATEGORIE != -1  /* -1 nur Rezepte */ NEI 21.5.13 Einführ. Labora';

s:=s||'nforderung'||unistr('\000a')||
'  AND :P990_ARTIKELKATEGORIE not in (-1,20)  /* -1 Rezepte, 20 Laboranforderungen */'||unistr('\000a')||
'  AND ((:P990_artikelkategorie = 0 and m.artgruppe_id!=20)  OR m.artgruppe_id = :P990_artikelkategorie)'||unistr('\000a')||
'  -- Keine Artikel mit Preis -1, d.h. Preis muss >=0  => Fehler bei der Artikeluebernahme'||unistr('\000a')||
'  AND exists'||unistr('\000a')||
'       (select * '||unistr('\000a')||
'        from preislisten_details'||unistr('\000a')||
'        where mengenart_id = s.mengenart_id'||unistr('\000a')||
'  ';

s:=s||'      and preisliste_id = wk.preisliste_id'||unistr('\000a')||
'        and GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND MIN_MENGE <= 1'||unistr('\000a')||
'        AND MAX_MENGE >= 1'||unistr('\000a')||
'        AND preis >= 0'||unistr('\000a')||
'       )'||unistr('\000a')||
'UNION                                                                                         /* Rezepte */'||unistr('\000a')||
'SELECT mnr.rezept_nr,'||unistr('\000a')||
'       mnr.rezept_nr                            ';

s:=s||''||unistr('\000a')||
'       ||''/''||mnr.version||'', '''||unistr('\000a')||
'/*       ||mnr.Bezeichnung'||unistr('\000a')||
'*/'||unistr('\000a')||
'       ||mnr.Bemerkung||''</br>''||'||unistr('\000a')||
'      frgbg_s.holen_uebersetzung(585,:fas_sprache_id)||'': ''||prodr.reichweite'||unistr('\000a')||
'/*       ||DECODE(mnr.neuberechnen||mnr.neuberechnen_sortiment,'||unistr('\000a')||
'                       ''NN'','' '',''* '')         -- Neuberechnen markieren    '||unistr('\000a')||
'*/'||unistr('\000a')||
'       ||CASE WHEN mnr.neuberechnen = ''J'' OR '||unistr('\000a')||
'               mnr.neuberechnen_sort';

s:=s||'iment=''J'' OR --NEI 14.02.11 Sortimentseinf.'||unistr('\000a')||
'               prodr.sortiment_id != :FAS_SORTIMENT_ID -- NEI 26.4.11'||unistr('\000a')||
'         THEN           -- Neuberechnen markieren'||unistr('\000a')||
'            '' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'          ||frgbg_s.holen_uebersetzung(4890,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'          ||''  <img src="#IMAGE_PREFIX#yellow_flag.gif">  '''||unistr('\000a')||
'         ELSE NULL'||unistr('\000a')||
'         END';

s:=s||''||unistr('\000a')||
'       ||CASE WHEN prodr.prod_rezstatus_id = 1  -- Arbeitsversion markieren'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            '' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'          ||frgbg_s.holen_uebersetzung(4889,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'          ||''  <img src="#IMAGE_PREFIX#red_flag.gif">  '''||unistr('\000a')||
'         ELSE NULL'||unistr('\000a')||
'         END'||unistr('\000a')||
'       ,'||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       ''<img src="#OWNER#.frgbg_t.display_thumb?p_bil';

s:=s||'d_id='''||unistr('\000a')||
'         || (select min(dokument_id) from mengenarts where id=102)'||unistr('\000a')||
'         ||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" width="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'' img,'||unistr('\000a')||
'  CASE WHEN mnr.neuberechnen=''J'' OR                  -- Neuberechnen'||unistr('\000a')||
'            mnr.neuberechnen_sortiment =''J'' OR'||unistr('\000a')||
'            prodr.sortiment_id!= 4 /*:fas_sortiment_id';

s:=s||'*/ OR -- geändertes Sortiment'||unistr('\000a')||
'            prodr.PROD_REZSTATUS_ID = 1   OR         -- Arbeitsversion'||unistr('\000a')||
'            :p990_wk_artikeltyp_flag =1              -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                                     -- =1 heisst bereits Laborartikel im WK => keine Rezepte mehr '||unistr('\000a')||
'  THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'/*'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':';

s:=s||'300:''||:APP_SESSION|| '':WARENKORB:::'''||unistr('\000a')||
'     ||''P990_REZEPT_NR:'''||unistr('\000a')||
'     ||mnr.rezept_nr)    '||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'--''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P990_REZEPT_NR'''':''||mnr.rezept_nr||''}})'''||unistr('\000a')||
'''<a href="javascript:f_checkBestelldatBestellen(''''WARENKORB'''',''''''||to_char(sysdate,''DD.MM.YYYY'')'||unistr('\000a')||
'     --||''''''';

s:=s||',''''''||to_char(auftragsdispo.GET_LAST_BESTELL_DAT(mnr.id),''DD.MM.YYYY'')'||unistr('\000a')||
'     ||'''''',''''''||to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(prodr.id,NULL),''DD.MM.YYYY'')'||unistr('\000a')||
'     ||'''''',''''''||mnr.rezept_nr'||unistr('\000a')||
'     ||'''''',html_GetElement(''''RW'' || mnr.rezept_nr || '''''').value )''   -- neu'||unistr('\000a')||
'     --||'''''')'''||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END  wk_link,'||unistr('\000a')||
'  2 sort_typ,'||unistr('\000a')||
'';

s:=s||'  null sort_art,'||unistr('\000a')||
'  mnr.rezept_nr sort_rez,'||unistr('\000a')||
'  --to_char(auftragsdispo.GET_LAST_BESTELL_DAT(mnr.id),''DD.MM.YYYY''),'||unistr('\000a')||
'  to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(prodr.id,NULL),''DD.MM.YYYY''),'||unistr('\000a')||
'  to_char(sysdate,''DD.MM.YYYY''),'||unistr('\000a')||
'  NULL ||'||unistr('\000a')||
'  CASE WHEN prodr.reichweite in (SELECT reichweite_ab from wk_reichweiten_staffeln WHERE staffelgruppe_id = :p990_staffelgruppe_id) THEN'||unistr('\000a')||
'     apex_item.select_list_from_que';

s:=s||'ry'||unistr('\000a')||
'       (32,'||unistr('\000a')||
'       prodr.reichweite ,'||unistr('\000a')||
'       ''SELECT  frgbg_s.WK_GET_REICHW_STAFFEL_TEXT(id,NULL,NULL,357) a, reichweite_ab b from wk_reichweiten_staffeln WHERE staffelgruppe_id =''|| :p990_staffelgruppe_id ||'||unistr('\000a')||
'       '' order by 2'' ,'||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       ''NO'','||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       ''RW''||mnr.rezept_nr'||unistr('\000a')||
'       )'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'     apex_item.select_list_from_query'||unistr('\000a')||
'          (32,'||unistr('\000a')||
'           prodr';

s:=s||'.reichweite ,'||unistr('\000a')||
'           ''SELECT frgbg_s.WK_GET_REICHW_STAFFEL_TEXT(id,NULL,NULL,357) a, reichweite_ab b from wk_reichweiten_staffeln WHERE staffelgruppe_id = ''|| :p990_staffelgruppe_id ||'||unistr('\000a')||
'           '' UNION SELECT frgbg_s.WK_GET_REICHW_STAFFEL_TEXT ( NULL,''||prodr.reichweite||'',:p990_staffelgruppe_id,357),''||prodr.reichweite ||'' from dual order by 2'','||unistr('\000a')||
'           NULL,'||unistr('\000a')||
'           ''NO'','||unistr('\000a')||
'           ';

s:=s||'NULL,'||unistr('\000a')||
'           NULL,'||unistr('\000a')||
'           ''RW''||mnr.rezept_nr'||unistr('\000a')||
'         )'||unistr('\000a')||
'  END'||unistr('\000a')||
'FROM v_mn_rezepte mnr, v_prod_rezepte prodr,warenkoerbe_tmp wk'||unistr('\000a')||
'WHERE mnr.personenstamm_id = :p990_persstamm_id'||unistr('\000a')||
'  AND mnr.satz_kennzeichen is null'||unistr('\000a')||
'  AND mnr.akt_version = 1 '||unistr('\000a')||
'  /* AND neuberechnen = ''N'' AND neuberechnen_sortiment = ''N''*/'||unistr('\000a')||
'  AND mnr.aenderbar = ''J'' '||unistr('\000a')||
'  AND :fas_pers_aenderbar = 1 '||unistr('\000a')||
'  AND mnr.rezept_nr = prodr.rezept_';

s:=s||'nr'||unistr('\000a')||
'  AND mnr.version = prodr.version'||unistr('\000a')||
'  /*and prodr.sortiment_id = :fas_sortiment_id*/'||unistr('\000a')||
'  -- Suchkategorie'||unistr('\000a')||
'  AND :P990_ARTIKELKATEGORIE in (-1,0)'||unistr('\000a')||
'  -- Suchbedingung'||unistr('\000a')||
'  AND ((:P990_suche is NULL and :p990_artikelkategorie = 0 and 1=2) /* keine Ergebnisse => Maskeneinstieg */'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P990_suche is NULL and :p990_artikelkategorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P990_suche is NOT NULL AND '||unistr('\000a')||
'        inst';

s:=s||'r(UPPER (mnr.rezept_nr     '||unistr('\000a')||
'        ||''/''||mnr.version '||unistr('\000a')||
'        ||mnr.bemerkung),UPPER(:P990_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Rezepte die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p990_id'||unistr('\000a')||
'/*  '||unistr('\000a')||
'and ( prodr.id not in (SELECT p_rezept_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p990_id'||unistr('\000a')||
'                       and p_rezept_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       '||unistr('\000a')||
'      ';

s:=s||')'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'   -- Nur Rezept ohne Splitbasiseintrag'||unistr('\000a')||
'   and mnr.rezept_nr_splitbasis is NULL and mnr.version_splitbasis is null'||unistr('\000a')||
'UNION'||unistr('\000a')||
'select m.id,                                                                        /* Laborauftrag-Artikel */'||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)'||unistr('\000a')||
'      ||CASE WHEN m.beschrei';

s:=s||'bung is not null THEN'||unistr('\000a')||
'/*         ''    <a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'         ''f?p=''||:APP_ID||'':306:''||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id)    '||unistr('\000a')||
'         || ''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'         ''    <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':306:'''||unistr('\000a')||
'         ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id||'''''',700,380)">''';

s:=s||''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END'||unistr('\000a')||
'      || ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'             artikel,'||unistr('\000a')||
'      to_char(rezepte.calc_preis_mwst_ges(wk.verrech_land_id,'||unistr('\000a')||
'             m.prodkennz_id,m.id,wk.preisliste_id,'||unistr('\000a')||
'             wk.a';

s:=s||'rt_mwst_typ_id, wk.preisfaktor,wk.persstamm_id_prod_apo,0)'||unistr('\000a')||
'        ,''999G990D00'')||'' ''||rezepte.get_waehrung_zeichen(wk.waehrung_id)'||unistr('\000a')||
'             stueckpreis,'||unistr('\000a')||
'      CASE WHEN m.dokument_id is not null THEN'||unistr('\000a')||
'      ''<img src="#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         || NVL (m.dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" widt';

s:=s||'h="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'      ELSE NULL END img,'||unistr('\000a')||
'     CASE WHEN  :p990_wk_artikeltyp_flag = 2   -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                               -- =2 heisst bereits sonstiges im WK => keine Laborartikel mehr '||unistr('\000a')||
'     THEN'||unistr('\000a')||
'        '' '''||unistr('\000a')||
'     ELSE'||unistr('\000a')||
'--      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P990_MENGENART_ID'''':''||m.id||''}})''';

s:=s||''||unistr('\000a')||
'--      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P990_MENGENART_ID'''':''||m.id||'', ''''P990_PERGEBNIS_ID'''':''||p.id||''}})'' -- NEI 05.05.2014'||unistr('\000a')||
'        ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P990_MENGENART_ID'''':''||m.id||''}})'''||unistr('\000a')||
'          || ''">'''||unistr('\000a')||
'        || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'        || ''</a>'''||unistr('\000a')||
'     END wk_link,'||unistr('\000a')||
'     1 sort_t';

s:=s||'yp, '||unistr('\000a')||
'     fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'',m.ID,:fas_sprache_id) sort_art,'||unistr('\000a')||
'     null sort_rez,'||unistr('\000a')||
'     --to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(NULL,m.id),''DD.MM.YYYY'') ,'||unistr('\000a')||
'     null,'||unistr('\000a')||
'     null,'||unistr('\000a')||
'     NULL|| apex_item.hidden(32, NULL) '||unistr('\000a')||
'FROM mengenarts m, sortiment_details s, --NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'     warenkoerbe_tmp wk'||unistr('\000a')||
'     --, pergebnisse p                  --N';

s:=s||'EI 05.05.2014 perg_id wird zuvor bereits festgelegt wg. Laborauswahl'||unistr('\000a')||
'where m.satz_kennzeichen is null'||unistr('\000a')||
'  --and m.prodkennz_id = 2   Nur noch über Sortiment-det.verkaufsartikel'||unistr('\000a')||
'  --and :P990_SA_AUFTRAGSNUMMER is not null --NEI 05.05.2014'||unistr('\000a')||
'  and m.id = s.mengenart_id'||unistr('\000a')||
'  and s.sortiment_id = 4 --:fas_sortiment_id --NEI 14.02.2011 Sortimentseinf.'||unistr('\000a')||
'  and s.satz_kennzeichen is null'||unistr('\000a')||
'  and s.verkaufsartikel !';

s:=s||'= ''N'''||unistr('\000a')||
'  AND ((:P990_suche is NULL and :p990_artikelkategorie = 0 and 1=2) -- keine Ergebnisse => Maskeneinstieg'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P990_suche is NULL and :p990_artikelkategorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P990_suche is NOT NULL AND '||unistr('\000a')||
'        instr(UPPER (fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id)'||unistr('\000a')||
'        ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZ';

s:=s||'EICHNUNG'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id) ),UPPER(:P990_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Artikel die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p990_id'||unistr('\000a')||
'  /*and ( m.id is not null AND'||unistr('\000a')||
'        m.id not in (SELECT mengenart_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p990_id'||unistr('\000a')||
'                       and mengenart_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       OR m.id';

s:=s||' is null'||unistr('\000a')||
'      )'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND :P990_ARTIKELKATEGORIE in (20,0)  -- 20 Laboranforderungen, 0 Maskeneinstieg kein Ergeb. '||unistr('\000a')||
'  AND m.artgruppe_id = 20 /*Laborartikel Artikelgruppe 20*/'||unistr('\000a')||
'  -- Keine Artikel mit Preis -1, d.h. Preis muss >=0  => Fehler bei der Artikeluebernahme'||unistr('\000a')||
'  AND exists'||unistr('\000a')||
'       (select * '||unistr('\000a')||
'        from preislisten_details'||unistr('\000a')||
'        where mengenart_id = s.mengenart_id'||unistr('\000a')||
'        and preisliste_i';

s:=s||'d = wk.preisliste_id'||unistr('\000a')||
'        and GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND MIN_MENGE <= 1'||unistr('\000a')||
'        AND MAX_MENGE >= 1'||unistr('\000a')||
'        AND preis >= 0'||unistr('\000a')||
'       )'||unistr('\000a')||
'  /* hoechste Version eines FB ohne Auswertung muss vorhanden sein */'||unistr('\000a')||
'  /* NEI 5.5.2014 Perg-ID wird nun direkt in der Maske bestimmt, da noch Labor-Auswahl abhängig von perg stattfinden muss'||unistr('\000a')||
'  AND p.';

s:=s||'persstamm_id = wk.persstamm_id_kunde -- Nur FB des Kunden'||unistr('\000a')||
'  and p.id is not null'||unistr('\000a')||
'  and p.versions_id = frgbg_s.GET_FB_MAX_VERSION(p.fragebogen_id,p.persstamm_id) -- hoechste Version'||unistr('\000a')||
'  and frgbg_s.FB_CHECK_AUSWERTUNG(p.id)= 0'||unistr('\000a')||
'  and p.fragebogen_id = 5              -- zZ. nur FB MNR'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND :p990_pergebnis_id is not null'||unistr('\000a')||
'  AND :p990_labor_id is not null'||unistr('\000a')||
'  AND( (:P990_AUFTRAG_ID_INTERN = 0 AND :p9';

s:=s||'90_sa_auftragsnummer is not null) '||unistr('\000a')||
'       OR'||unistr('\000a')||
'       (:P990_AUFTRAG_ID_INTERN = 1)'||unistr('\000a')||
'     )'||unistr('\000a')||
'  -- NEI 05.05.2014 Laborspezifische Profile beachten'||unistr('\000a')||
'  AND (exists (SELECT *             -- Profilartikel des aktuellen Labors'||unistr('\000a')||
'              FROM labor_mengenart_profile'||unistr('\000a')||
'              WHERE satz_kennzeichen is null'||unistr('\000a')||
'                AND mengenart_id = s.mengenart_id'||unistr('\000a')||
'                AND labor_id = :p990_labor_id';

s:=s||''||unistr('\000a')||
'             )'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       not exists ( SELECT *        -- Artikel, die in keinem Profil von Laboren des gleichen fkategorie_modul_id(Labor neu/alt) wie des des akt. Labors vorkommen'||unistr('\000a')||
'                  FROM labor_mengenart_profile lmp'||unistr('\000a')||
'                  WHERE lmp.satz_kennzeichen is null'||unistr('\000a')||
'                    AND lmp.mengenart_id = m.id'||unistr('\000a')||
'                    and lmp.LABOR_id in (SELECT l2.id'||unistr('\000a')||
'     ';

s:=s||'                                    from labors l1, labors l2'||unistr('\000a')||
'                                         WHERE l1.id = :p990_labor_id'||unistr('\000a')||
'                                           and l1.fkategorie_modul_id = l2.fkategorie_modul_id'||unistr('\000a')||
'                                        )'||unistr('\000a')||
'                   )'||unistr('\000a')||
'        )'||unistr('\000a')||
'order by  sort_typ, sort_art asc, sort_rez desc '||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 990,
  p_name=> 'ARTIKEL_REZEPTE',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 40,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P300_HEIGHT_ARTIKEL.px;width:590px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(4526,:fas_sprache_id))',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '200',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> '</br>&P300_MELDUNG_ARTSUCHE.',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '2000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9532726707344918 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9532806185344922 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ARTIKEL',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9532928862344923 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'STUECKPREIS',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie >=0 or   /* Suchbed. od. Artikel */ '||unistr('\000a')||
':p300_artikelkategorie = 20     /* Laborartikel */',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9533024344344923 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'IMG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9533117561344923 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'WK_LINK',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9533226037344923 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_TYP',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9533329584344923 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_ART',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9533416862344923 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_REZ',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9533507607344923 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'LAST_BESTELLDATUM',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie in (0,-1)  /* Suchbed. od. Rezepte*/ ',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9533630329344923 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'AKT_DATUM',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9533714652344923 + wwv_flow_api.g_id_offset,
  p_region_id=> 9532517596344897 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_REICHWEITE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie in (0,-1)  /* Suchbed. od. Rezepte*/ ',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_inline_lov=> 'SELECT 60 a, 60 b from dual UNION'||unistr('\000a')||
'SELECT 90  , 90   from dual UNION'||unistr('\000a')||
'SELECT 120 , 120  from dual '||unistr('\000a')||
'order by 1',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 9534400889358985 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 990,
  p_plug_name=> 'allg',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 40,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'Select 1  '||unistr('\000a')||
'from dual '||unistr('\000a')||
'where 1!= 2'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 9538014282504761 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 990,
  p_name=> 'test',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 20,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_condition_type=> 'NEVER',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto;width: 250px ">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9540322818573521 + wwv_flow_api.g_id_offset,
  p_region_id=> 9538014282504761 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> '1',
  p_column_display_sequence=> 1,
  p_column_heading=> '1',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 9540819617591489 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 990,
  p_plug_name=> 'Kategorietitel',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 11,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_2',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'NEVER',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 8864930049892184 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 990,
  p_button_sequence=> 10,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8866221730441406 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 990,
  p_button_sequence=> 10,
  p_button_plug_id => 8865913816441401+wwv_flow_api.g_id_offset,
  p_button_name    => 'CONTRACT_ALL',
  p_button_action  => 'REDIRECT_URL',
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Collapse All',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.widget.tree.collapse_all(''tree'||to_char(8865822914441401+wwv_flow_api.g_id_offset)||''');',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 8866400923441415 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 990,
  p_button_sequence=> 10,
  p_button_plug_id => 8865913816441401+wwv_flow_api.g_id_offset,
  p_button_name    => 'EXPAND_ALL',
  p_button_action  => 'REDIRECT_URL',
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Expand All',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.widget.tree.expand_all(''tree'||to_char(8865822914441401+wwv_flow_api.g_id_offset)||''');',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8865405884892201 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 990,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P990_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 130,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8865111810892192 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 990,
  p_name=>'P990_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 9534400889358985+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '990',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8867407161192277 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 990,
  p_name=>'P990_ARTIKELKATEGORIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 9534400889358985+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Artikelkategorie',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8867617897195368 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 990,
  p_name=>'P990_ARTIKELKATEGORIE_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 9534400889358985+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Artikelkategorie Bez',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8867825169197471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 990,
  p_name=>'P990_SUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 9534400889358985+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Suche',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9531615153192797 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 990,
  p_name=>'P990_WK_ARTIKELTYP_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 9534400889358985+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '2',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9531800047197871 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 990,
  p_name=>'P990_STD_MISCHARTIKEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 9534400889358985+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9535827302423358 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 990,
  p_name=>'P990_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 9534400889358985+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '516957',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9539724288555004 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 990,
  p_name=>'P990_TITEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 9540819617591489+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kategorien',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 8873604125040840 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 990
 ,p_name => 'öffne ausgewählten Knoten (Seitenstart)'
 ,p_event_sequence => 10
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 8873917410040850 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 990
 ,p_event_id => 8873604125040840 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '$(document).ready(function() {'||unistr('\000a')||
''||unistr('\000a')||
'   if($v(''P990_ARTIKELKATEGORIE'').length > 0) {'||unistr('\000a')||
'     //Öffne alle Baumknoten, die das Listenelement haben, das die in P990_ARTIKELKATEGORIE angegebene Id hat'||unistr('\000a')||
'     //Sollte auch funktioniert über mehrere Hierarchien hinweg'||unistr('\000a')||
'     $(''div[class~="tree"] li[class~="closed"]'').has(''li[id="'' + $v(''P990_ARTIKELKATEGORIE'') + ''"]'').removeClass(''closed'').addClass(''open'')'||unistr('\000a')||
''||unistr('\000a')||
'  }'||unistr('\000a')||
''||unistr('\000a')||
'});'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 990
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00991
prompt  ...PAGE 991: Testartikelkategorie
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 991
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Testartikelkategorie'
 ,p_step_title => 'Testartikelkategorie'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Testartikelkategorie'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'AUTO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_html_page_header => 
'<style type="text/css">'||unistr('\000a')||
'.closed div {height:0px!important}'||unistr('\000a')||
''||unistr('\000a')||
'/* Level 0 Kategorieknoten */'||unistr('\000a')||
'li.leaf,li.closed,li.open {min-height:20px!important;}'||unistr('\000a')||
'li.leaf a ins,li.closed a ins,li.open a ins {height:20px!important; width:50px!important}'||unistr('\000a')||
'li.open ul { margin-top:10px; margin-left:20px; margin-bottom:25px; }'||unistr('\000a')||
''||unistr('\000a')||
'/* ab Level 1 muss aufklappbar sein aber mindestens die Grösse der Icons */'||unistr('\000a')||
'li.open li.leaf,li'||
'.open li.closed,li.open li.open {min-height:50px!important;}'||unistr('\000a')||
''||unistr('\000a')||
'/* Level 2 sind alle Icons klein also überschreib die Mindesthöhe und setzte es auf eine fixe Höhe*/'||unistr('\000a')||
'li.open li.open li.leaf, li.open li.open li.closed, li.open li.open li.open {min-height:15px !important; height:15px!important;}'||unistr('\000a')||
''||unistr('\000a')||
'/* Setze erst einmal alle Bilder auf Gross ab Level 1*/'||unistr('\000a')||
'li.open li.leaf a ins,li.open li.closed a ins,li.op'||
'en li.open a ins {height:48px!important; width:48px!important}'||unistr('\000a')||
'/* Level 2 sind alle Bilder Klein */'||unistr('\000a')||
'li.open li.open li.leaf a ins, li.open li.open li.closed a ins, li.open li.open li.open a ins {height:10px!important; width:10px!important}'||unistr('\000a')||
''||unistr('\000a')||
'/* Der Abstand des Unterbaums */'||unistr('\000a')||
'li.open li.open ul { margin-top:38px; margin-left:20px; margin-bottom:25px; }'||unistr('\000a')||
''||unistr('\000a')||
'/* Level 0 Knoten */'||unistr('\000a')||
'div.tree >ul > li >  a {'||unistr('\000a')||
' '||
'  font-size: 18px;'||unistr('\000a')||
'   font-weight:bold;'||unistr('\000a')||
'   line-eight:18px;'||unistr('\000a')||
'   vertical-align:middle;'||unistr('\000a')||
'   margin-top:3px;'||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'div.tree >ul > li >  a > ins {'||unistr('\000a')||
'   position: relative;'||unistr('\000a')||
'   top:-4px;'||unistr('\000a')||
'}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
''
 ,p_required_role => 3842620454521302 + wwv_flow_api.g_id_offset
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_help_text => 
'No help is available for this page.'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20141002152147'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select m.id,                                                                        /* Artikel */'||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)'||unistr('\000a')||
'      --||CASE WHEN m.beschreibung is not null THEN  -- NEI 26.03.2014 nur noch die beschreibung_text_id ist aktiv wg. langen Texten'||unistr('\000a')||
'      ||CASE WHEN m.beschreibung_text_id is not null THEN'||unistr('\000a')||
'/*         ''    <a href="''||APE';

s:=s||'X_UTIL.PREPARE_URL('||unistr('\000a')||
'         ''f?p=''||:APP_ID||'':306:''||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id)    '||unistr('\000a')||
'         || ''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'         ''    <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':306:'''||unistr('\000a')||
'         ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id||'''''',700,380)">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >';

s:=s||''''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END'||unistr('\000a')||
'      || ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'             artikel,'||unistr('\000a')||
'      to_char(rezepte.calc_preis_mwst_ges(wk.verrech_land_id,'||unistr('\000a')||
'             m.prodkennz_id,m.id,wk.preisliste_id,'||unistr('\000a')||
'             wk.art_mwst_typ_id, wk.preisfaktor,wk.persstamm_id_prod_a';

s:=s||'po,0)'||unistr('\000a')||
'        ,''999G990D00'')||'' ''||rezepte.get_waehrung_zeichen(wk.waehrung_id)'||unistr('\000a')||
'             stueckpreis,'||unistr('\000a')||
'      CASE WHEN m.dokument_id is not null THEN'||unistr('\000a')||
'      ''<img src="#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         || NVL (m.dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" width="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'      ELSE N';

s:=s||'ULL END img,'||unistr('\000a')||
'/*'||unistr('\000a')||
'  ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':300:''||:APP_SESSION|| '':WARENKORB:::'''||unistr('\000a')||
'     ||''P991_MENGENART_ID:'''||unistr('\000a')||
'     ||m.id)    '||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'   wk_link'||unistr('\000a')||
'*/'||unistr('\000a')||
'   CASE WHEN :p991_wk_artikeltyp_flag = 1  -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                           -- =1 h';

s:=s||'eisst bereits Laborartikel im WK => keine sonstigen Artikel mehr '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      '' '''||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P991_MENGENART_ID'''':''||m.id||''}})'''||unistr('\000a')||
'        || ''">'''||unistr('\000a')||
'        || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'        || ''</a>'''||unistr('\000a')||
'   END wk_link,'||unistr('\000a')||
'   1 sort_typ,'||unistr('\000a')||
'   --fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_spra';

s:=s||'che_id) sort_art,'||unistr('\000a')||
'   fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'',m.ID,:fas_sprache_id) sort_art,'||unistr('\000a')||
'   null sort_rez,'||unistr('\000a')||
'   --to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(NULL,m.id),''DD.MM.YYYY'') last_bestelldatum,'||unistr('\000a')||
'   NULL last_bestelldatum,'||unistr('\000a')||
'   null akt_datum,'||unistr('\000a')||
'   null|| apex_item.hidden(32, NULL) rezept_reichweite '||unistr('\000a')||
'FROM mengenarts m, sortiment_details s, --NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'   ';

s:=s||'  warenkoerbe_tmp wk'||unistr('\000a')||
'where m.satz_kennzeichen is null'||unistr('\000a')||
'  --and m.prodkennz_id = 2   Nur noch über Sortiment-det.verkaufsartikel'||unistr('\000a')||
'  and m.id = s.mengenart_id'||unistr('\000a')||
'  and s.sortiment_id = 4 --:fas_sortiment_id --NEI 14.02.2011 Sortimentseinf.'||unistr('\000a')||
'  and s.satz_kennzeichen is null'||unistr('\000a')||
'  and s.verkaufsartikel != ''N'''||unistr('\000a')||
'  AND ((:P991_suche is NULL and :p991_artikelkategorie = 0 and 1=2) -- keine Ergebnisse => Maskeneinsti';

s:=s||'eg '||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P991_suche is NULL and :p991_artikelkategorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P991_suche is NOT NULL AND '||unistr('\000a')||
'        instr(UPPER (fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id)'||unistr('\000a')||
'        ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id) ),UPPER(:P991_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Art';

s:=s||'ikel die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p991_id'||unistr('\000a')||
'  /*and ( m.id is not null AND'||unistr('\000a')||
'        m.id not in (SELECT mengenart_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p991_id'||unistr('\000a')||
'                       and mengenart_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       OR m.id is null'||unistr('\000a')||
'      )'||unistr('\000a')||
'  */'||unistr('\000a')||
'  --AND :P991_ARTIKELKATEGORIE != -1  /* -1 nur Rezepte */ NEI 21.5.13 Einführ. Labora';

s:=s||'nforderung'||unistr('\000a')||
'  AND :P991_ARTIKELKATEGORIE not in (-1,20)  /* -1 Rezepte, 20 Laboranforderungen */'||unistr('\000a')||
'  AND ((:P991_artikelkategorie = 0 and m.artgruppe_id!=20)  OR m.artgruppe_id = :P991_artikelkategorie)'||unistr('\000a')||
'  -- Keine Artikel mit Preis -1, d.h. Preis muss >=0  => Fehler bei der Artikeluebernahme'||unistr('\000a')||
'  AND exists'||unistr('\000a')||
'       (select * '||unistr('\000a')||
'        from preislisten_details'||unistr('\000a')||
'        where mengenart_id = s.mengenart_id'||unistr('\000a')||
'  ';

s:=s||'      and preisliste_id = wk.preisliste_id'||unistr('\000a')||
'        and GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND MIN_MENGE <= 1'||unistr('\000a')||
'        AND MAX_MENGE >= 1'||unistr('\000a')||
'        AND preis >= 0'||unistr('\000a')||
'       )'||unistr('\000a')||
'UNION                                                                                         /* Rezepte */'||unistr('\000a')||
'SELECT mnr.rezept_nr,'||unistr('\000a')||
'       mnr.rezept_nr                            ';

s:=s||''||unistr('\000a')||
'       ||''/''||mnr.version||'', '''||unistr('\000a')||
'/*       ||mnr.Bezeichnung'||unistr('\000a')||
'*/'||unistr('\000a')||
'       ||mnr.Bemerkung||''</br>''||'||unistr('\000a')||
'      frgbg_s.holen_uebersetzung(585,:fas_sprache_id)||'': ''||prodr.reichweite'||unistr('\000a')||
'/*       ||DECODE(mnr.neuberechnen||mnr.neuberechnen_sortiment,'||unistr('\000a')||
'                       ''NN'','' '',''* '')         -- Neuberechnen markieren    '||unistr('\000a')||
'*/'||unistr('\000a')||
'       ||CASE WHEN mnr.neuberechnen = ''J'' OR '||unistr('\000a')||
'               mnr.neuberechnen_sort';

s:=s||'iment=''J'' OR --NEI 14.02.11 Sortimentseinf.'||unistr('\000a')||
'               prodr.sortiment_id != :FAS_SORTIMENT_ID -- NEI 26.4.11'||unistr('\000a')||
'         THEN           -- Neuberechnen markieren'||unistr('\000a')||
'            '' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'          ||frgbg_s.holen_uebersetzung(4890,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'          ||''  <img src="#IMAGE_PREFIX#yellow_flag.gif">  '''||unistr('\000a')||
'         ELSE NULL'||unistr('\000a')||
'         END';

s:=s||''||unistr('\000a')||
'       ||CASE WHEN prodr.prod_rezstatus_id = 1  -- Arbeitsversion markieren'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            '' <a onmouseover="javascript:toolTip_enable(event,this,'''''''||unistr('\000a')||
'          ||frgbg_s.holen_uebersetzung(4889,:fas_sprache_id)||'''''')" </a>'''||unistr('\000a')||
'          ||''  <img src="#IMAGE_PREFIX#red_flag.gif">  '''||unistr('\000a')||
'         ELSE NULL'||unistr('\000a')||
'         END'||unistr('\000a')||
'       ,'||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       ''<img src="#OWNER#.frgbg_t.display_thumb?p_bil';

s:=s||'d_id='''||unistr('\000a')||
'         || (select min(dokument_id) from mengenarts where id=102)'||unistr('\000a')||
'         ||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" width="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'' img,'||unistr('\000a')||
'  CASE WHEN mnr.neuberechnen=''J'' OR                  -- Neuberechnen'||unistr('\000a')||
'            mnr.neuberechnen_sortiment =''J'' OR'||unistr('\000a')||
'            prodr.sortiment_id!= 4 /*:fas_sortiment_id';

s:=s||'*/ OR -- geändertes Sortiment'||unistr('\000a')||
'            prodr.PROD_REZSTATUS_ID = 1   OR         -- Arbeitsversion'||unistr('\000a')||
'            :p991_wk_artikeltyp_flag =1              -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                                     -- =1 heisst bereits Laborartikel im WK => keine Rezepte mehr '||unistr('\000a')||
'  THEN'||unistr('\000a')||
'     '' '''||unistr('\000a')||
'  ELSE'||unistr('\000a')||
'/*'||unistr('\000a')||
'     ''<a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'      ''f?p=''||:APP_ID||'':';

s:=s||'300:''||:APP_SESSION|| '':WARENKORB:::'''||unistr('\000a')||
'     ||''P991_REZEPT_NR:'''||unistr('\000a')||
'     ||mnr.rezept_nr)    '||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'--''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P991_REZEPT_NR'''':''||mnr.rezept_nr||''}})'''||unistr('\000a')||
'''<a href="javascript:f_checkBestelldatBestellen(''''WARENKORB'''',''''''||to_char(sysdate,''DD.MM.YYYY'')'||unistr('\000a')||
'     --||''''''';

s:=s||',''''''||to_char(auftragsdispo.GET_LAST_BESTELL_DAT(mnr.id),''DD.MM.YYYY'')'||unistr('\000a')||
'     ||'''''',''''''||to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(prodr.id,NULL),''DD.MM.YYYY'')'||unistr('\000a')||
'     ||'''''',''''''||mnr.rezept_nr'||unistr('\000a')||
'     ||'''''',html_GetElement(''''RW'' || mnr.rezept_nr || '''''').value )''   -- neu'||unistr('\000a')||
'     --||'''''')'''||unistr('\000a')||
'     || ''">'''||unistr('\000a')||
'     || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'     || ''</a>'''||unistr('\000a')||
'  END  wk_link,'||unistr('\000a')||
'  2 sort_typ,'||unistr('\000a')||
'';

s:=s||'  null sort_art,'||unistr('\000a')||
'  mnr.rezept_nr sort_rez,'||unistr('\000a')||
'  --to_char(auftragsdispo.GET_LAST_BESTELL_DAT(mnr.id),''DD.MM.YYYY''),'||unistr('\000a')||
'  to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(prodr.id,NULL),''DD.MM.YYYY''),'||unistr('\000a')||
'  to_char(sysdate,''DD.MM.YYYY''),'||unistr('\000a')||
'  NULL ||'||unistr('\000a')||
'  CASE WHEN prodr.reichweite in (SELECT reichweite_ab from wk_reichweiten_staffeln WHERE staffelgruppe_id = :p991_staffelgruppe_id) THEN'||unistr('\000a')||
'     apex_item.select_list_from_que';

s:=s||'ry'||unistr('\000a')||
'       (32,'||unistr('\000a')||
'       prodr.reichweite ,'||unistr('\000a')||
'       ''SELECT  frgbg_s.WK_GET_REICHW_STAFFEL_TEXT(id,NULL,NULL,357) a, reichweite_ab b from wk_reichweiten_staffeln WHERE staffelgruppe_id =''|| :p991_staffelgruppe_id ||'||unistr('\000a')||
'       '' order by 2'' ,'||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       ''NO'','||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       NULL,'||unistr('\000a')||
'       ''RW''||mnr.rezept_nr'||unistr('\000a')||
'       )'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'     apex_item.select_list_from_query'||unistr('\000a')||
'          (32,'||unistr('\000a')||
'           prodr';

s:=s||'.reichweite ,'||unistr('\000a')||
'           ''SELECT frgbg_s.WK_GET_REICHW_STAFFEL_TEXT(id,NULL,NULL,357) a, reichweite_ab b from wk_reichweiten_staffeln WHERE staffelgruppe_id = ''|| :p991_staffelgruppe_id ||'||unistr('\000a')||
'           '' UNION SELECT frgbg_s.WK_GET_REICHW_STAFFEL_TEXT ( NULL,''||prodr.reichweite||'',:p991_staffelgruppe_id,357),''||prodr.reichweite ||'' from dual order by 2'','||unistr('\000a')||
'           NULL,'||unistr('\000a')||
'           ''NO'','||unistr('\000a')||
'           ';

s:=s||'NULL,'||unistr('\000a')||
'           NULL,'||unistr('\000a')||
'           ''RW''||mnr.rezept_nr'||unistr('\000a')||
'         )'||unistr('\000a')||
'  END'||unistr('\000a')||
'FROM v_mn_rezepte mnr, v_prod_rezepte prodr,warenkoerbe_tmp wk'||unistr('\000a')||
'WHERE mnr.personenstamm_id = :p991_persstamm_id'||unistr('\000a')||
'  AND mnr.satz_kennzeichen is null'||unistr('\000a')||
'  AND mnr.akt_version = 1 '||unistr('\000a')||
'  /* AND neuberechnen = ''N'' AND neuberechnen_sortiment = ''N''*/'||unistr('\000a')||
'  AND mnr.aenderbar = ''J'' '||unistr('\000a')||
'  AND :fas_pers_aenderbar = 1 '||unistr('\000a')||
'  AND mnr.rezept_nr = prodr.rezept_';

s:=s||'nr'||unistr('\000a')||
'  AND mnr.version = prodr.version'||unistr('\000a')||
'  /*and prodr.sortiment_id = :fas_sortiment_id*/'||unistr('\000a')||
'  -- Suchkategorie'||unistr('\000a')||
'  AND :P991_ARTIKELKATEGORIE in (-1,0)'||unistr('\000a')||
'  -- Suchbedingung'||unistr('\000a')||
'  AND ((:P991_suche is NULL and :p991_artikelkategorie = 0 and 1=2) /* keine Ergebnisse => Maskeneinstieg */'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P991_suche is NULL and :p991_artikelkategorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P991_suche is NOT NULL AND '||unistr('\000a')||
'        inst';

s:=s||'r(UPPER (mnr.rezept_nr     '||unistr('\000a')||
'        ||''/''||mnr.version '||unistr('\000a')||
'        ||mnr.bemerkung),UPPER(:P991_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Rezepte die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p991_id'||unistr('\000a')||
'/*  '||unistr('\000a')||
'and ( prodr.id not in (SELECT p_rezept_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p991_id'||unistr('\000a')||
'                       and p_rezept_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       '||unistr('\000a')||
'      ';

s:=s||')'||unistr('\000a')||
'*/'||unistr('\000a')||
'   -- NEI 10.01.2014 Kumulation Splits zu Gesamtrezept'||unistr('\000a')||
'   -- Nur Rezept ohne Splitbasiseintrag'||unistr('\000a')||
'   and mnr.rezept_nr_splitbasis is NULL and mnr.version_splitbasis is null'||unistr('\000a')||
'UNION'||unistr('\000a')||
'select m.id,                                                                        /* Laborauftrag-Artikel */'||unistr('\000a')||
'      fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'',m.ID,:fas_sprache_id)'||unistr('\000a')||
'      ||CASE WHEN m.beschrei';

s:=s||'bung is not null THEN'||unistr('\000a')||
'/*         ''    <a href="''||APEX_UTIL.PREPARE_URL('||unistr('\000a')||
'         ''f?p=''||:APP_ID||'':306:''||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id)    '||unistr('\000a')||
'         || ''">'''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
'*/'||unistr('\000a')||
'         ''    <a href="javascript:popUp2(''''f?p=''||:APP_ID||'':306:'''||unistr('\000a')||
'         ||:APP_SESSION|| ''::::'''||unistr('\000a')||
'         ||''P306_ID:''||m.id||'''''',700,380)">''';

s:=s||''||unistr('\000a')||
'         || ''<img src="#IMAGE_PREFIX#fndtip11.gif" >'''||unistr('\000a')||
'         || ''</a>'''||unistr('\000a')||
''||unistr('\000a')||
'        ELSE NULL'||unistr('\000a')||
'        END'||unistr('\000a')||
'      || ''</br>'''||unistr('\000a')||
'      ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'','||unistr('\000a')||
'                                       m.ID,:fas_sprache_id)'||unistr('\000a')||
'             artikel,'||unistr('\000a')||
'      to_char(rezepte.calc_preis_mwst_ges(wk.verrech_land_id,'||unistr('\000a')||
'             m.prodkennz_id,m.id,wk.preisliste_id,'||unistr('\000a')||
'             wk.a';

s:=s||'rt_mwst_typ_id, wk.preisfaktor,wk.persstamm_id_prod_apo,0)'||unistr('\000a')||
'        ,''999G990D00'')||'' ''||rezepte.get_waehrung_zeichen(wk.waehrung_id)'||unistr('\000a')||
'             stueckpreis,'||unistr('\000a')||
'      CASE WHEN m.dokument_id is not null THEN'||unistr('\000a')||
'      ''<img src="#OWNER#.frgbg_t.display_thumb?p_bild_id='''||unistr('\000a')||
'         || NVL (m.dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'         --|| ''" height="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         --|| ''" widt';

s:=s||'h="'''||unistr('\000a')||
'         --|| 90'||unistr('\000a')||
'         || ''" />'''||unistr('\000a')||
'      ELSE NULL END img,'||unistr('\000a')||
'     CASE WHEN  :p991_wk_artikeltyp_flag = 2   -- NEI 22.05.13 Keine Mischauftraege '||unistr('\000a')||
'                                               -- =2 heisst bereits sonstiges im WK => keine Laborartikel mehr '||unistr('\000a')||
'     THEN'||unistr('\000a')||
'        '' '''||unistr('\000a')||
'     ELSE'||unistr('\000a')||
'--      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P991_MENGENART_ID'''':''||m.id||''}})''';

s:=s||''||unistr('\000a')||
'--      ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P991_MENGENART_ID'''':''||m.id||'', ''''P991_PERGEBNIS_ID'''':''||p.id||''}})'' -- NEI 05.05.2014'||unistr('\000a')||
'        ''<a href="javascript:apex.submit({request:''''WARENKORB'''',set:{''''P991_MENGENART_ID'''':''||m.id||''}})'''||unistr('\000a')||
'          || ''">'''||unistr('\000a')||
'        || ''<img src="#IMAGE_PREFIX#shopping_cart.gif" border="0">'''||unistr('\000a')||
'        || ''</a>'''||unistr('\000a')||
'     END wk_link,'||unistr('\000a')||
'     1 sort_t';

s:=s||'yp, '||unistr('\000a')||
'     fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZEICHNUNG'',m.ID,:fas_sprache_id) sort_art,'||unistr('\000a')||
'     null sort_rez,'||unistr('\000a')||
'     --to_char(frgbg_s.WK_GET_LAST_BESTELL_DAT(NULL,m.id),''DD.MM.YYYY'') ,'||unistr('\000a')||
'     null,'||unistr('\000a')||
'     null,'||unistr('\000a')||
'     NULL|| apex_item.hidden(32, NULL) '||unistr('\000a')||
'FROM mengenarts m, sortiment_details s, --NEI 14.02.2011 Sortimentseinfuehrung'||unistr('\000a')||
'     warenkoerbe_tmp wk'||unistr('\000a')||
'     --, pergebnisse p                  --N';

s:=s||'EI 05.05.2014 perg_id wird zuvor bereits festgelegt wg. Laborauswahl'||unistr('\000a')||
'where m.satz_kennzeichen is null'||unistr('\000a')||
'  --and m.prodkennz_id = 2   Nur noch über Sortiment-det.verkaufsartikel'||unistr('\000a')||
'  --and :P991_SA_AUFTRAGSNUMMER is not null --NEI 05.05.2014'||unistr('\000a')||
'  and m.id = s.mengenart_id'||unistr('\000a')||
'  and s.sortiment_id = 4 --:fas_sortiment_id --NEI 14.02.2011 Sortimentseinf.'||unistr('\000a')||
'  and s.satz_kennzeichen is null'||unistr('\000a')||
'  and s.verkaufsartikel !';

s:=s||'= ''N'''||unistr('\000a')||
'  AND ((:P991_suche is NULL and :p991_artikelkategorie = 0 and 1=2) -- keine Ergebnisse => Maskeneinstieg'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P991_suche is NULL and :p991_artikelkategorie != 0)'||unistr('\000a')||
'      OR'||unistr('\000a')||
'       (:P991_suche is NOT NULL AND '||unistr('\000a')||
'        instr(UPPER (fas_synch.get_tab_uebersetzung(''MENGENARTS.KUERZEL'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id)'||unistr('\000a')||
'        ||fas_synch.get_tab_uebersetzung(''MENGENARTS.BEZ';

s:=s||'EICHNUNG'','||unistr('\000a')||
'                    m.ID,:fas_sprache_id) ),UPPER(:P991_suche))> 0 '||unistr('\000a')||
'       )'||unistr('\000a')||
'      )'||unistr('\000a')||
'  -- Nur Artikel die noch nicht im WK'||unistr('\000a')||
'  and wk.id = :p991_id'||unistr('\000a')||
'  /*and ( m.id is not null AND'||unistr('\000a')||
'        m.id not in (SELECT mengenart_id from warenkorb_details_tmp'||unistr('\000a')||
'                     where warenkorb_tmp_id = :p991_id'||unistr('\000a')||
'                       and mengenart_id is not null'||unistr('\000a')||
'                    ) '||unistr('\000a')||
'       OR m.id';

s:=s||' is null'||unistr('\000a')||
'      )'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND :P991_ARTIKELKATEGORIE in (20,0)  -- 20 Laboranforderungen, 0 Maskeneinstieg kein Ergeb. '||unistr('\000a')||
'  AND m.artgruppe_id = 20 /*Laborartikel Artikelgruppe 20*/'||unistr('\000a')||
'  -- Keine Artikel mit Preis -1, d.h. Preis muss >=0  => Fehler bei der Artikeluebernahme'||unistr('\000a')||
'  AND exists'||unistr('\000a')||
'       (select * '||unistr('\000a')||
'        from preislisten_details'||unistr('\000a')||
'        where mengenart_id = s.mengenart_id'||unistr('\000a')||
'        and preisliste_i';

s:=s||'d = wk.preisliste_id'||unistr('\000a')||
'        and GUELTIG_AB <= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND GUELTIG_BIS >= TRUNC(sysdate,''DD'')'||unistr('\000a')||
'        AND MIN_MENGE <= 1'||unistr('\000a')||
'        AND MAX_MENGE >= 1'||unistr('\000a')||
'        AND preis >= 0'||unistr('\000a')||
'       )'||unistr('\000a')||
'  /* hoechste Version eines FB ohne Auswertung muss vorhanden sein */'||unistr('\000a')||
'  /* NEI 5.5.2014 Perg-ID wird nun direkt in der Maske bestimmt, da noch Labor-Auswahl abhängig von perg stattfinden muss'||unistr('\000a')||
'  AND p.';

s:=s||'persstamm_id = wk.persstamm_id_kunde -- Nur FB des Kunden'||unistr('\000a')||
'  and p.id is not null'||unistr('\000a')||
'  and p.versions_id = frgbg_s.GET_FB_MAX_VERSION(p.fragebogen_id,p.persstamm_id) -- hoechste Version'||unistr('\000a')||
'  and frgbg_s.FB_CHECK_AUSWERTUNG(p.id)= 0'||unistr('\000a')||
'  and p.fragebogen_id = 5              -- zZ. nur FB MNR'||unistr('\000a')||
'  */'||unistr('\000a')||
'  AND :p991_pergebnis_id is not null'||unistr('\000a')||
'  AND :p991_labor_id is not null'||unistr('\000a')||
'  AND( (:P991_AUFTRAG_ID_INTERN = 0 AND :p9';

s:=s||'91_sa_auftragsnummer is not null) '||unistr('\000a')||
'       OR'||unistr('\000a')||
'       (:P991_AUFTRAG_ID_INTERN = 1)'||unistr('\000a')||
'     )'||unistr('\000a')||
'  -- NEI 05.05.2014 Laborspezifische Profile beachten'||unistr('\000a')||
'  AND (exists (SELECT *             -- Profilartikel des aktuellen Labors'||unistr('\000a')||
'              FROM labor_mengenart_profile'||unistr('\000a')||
'              WHERE satz_kennzeichen is null'||unistr('\000a')||
'                AND mengenart_id = s.mengenart_id'||unistr('\000a')||
'                AND labor_id = :p991_labor_id';

s:=s||''||unistr('\000a')||
'             )'||unistr('\000a')||
'       OR'||unistr('\000a')||
'       not exists ( SELECT *        -- Artikel, die in keinem Profil von Laboren des gleichen fkategorie_modul_id(Labor neu/alt) wie des des akt. Labors vorkommen'||unistr('\000a')||
'                  FROM labor_mengenart_profile lmp'||unistr('\000a')||
'                  WHERE lmp.satz_kennzeichen is null'||unistr('\000a')||
'                    AND lmp.mengenart_id = m.id'||unistr('\000a')||
'                    and lmp.LABOR_id in (SELECT l2.id'||unistr('\000a')||
'     ';

s:=s||'                                    from labors l1, labors l2'||unistr('\000a')||
'                                         WHERE l1.id = :p991_labor_id'||unistr('\000a')||
'                                           and l1.fkategorie_modul_id = l2.fkategorie_modul_id'||unistr('\000a')||
'                                        )'||unistr('\000a')||
'                   )'||unistr('\000a')||
'        )'||unistr('\000a')||
'order by  sort_typ, sort_art asc, sort_rez desc '||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 991,
  p_name=> 'ARTIKEL_REZEPTE',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 40,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 2,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto; height: &P300_HEIGHT_ARTIKEL.px;width:590px">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(4526,:fas_sprache_id))',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '200',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_no_data_found=> '</br>&P300_MELDUNG_ARTSUCHE.',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '2000',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9554620724098842 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 11,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9554729367098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'ARTIKEL',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9554823804098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'STUECKPREIS',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_format=> '999G999G999G999G990D00',
  p_column_alignment=>'RIGHT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie >=0 or   /* Suchbed. od. Artikel */ '||unistr('\000a')||
':p300_artikelkategorie = 20     /* Laborartikel */',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9554924405098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'IMG',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9555006422098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'WK_LINK',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9555116894098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_TYP',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9555231476098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_ART',
  p_column_display_sequence=> 9,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9555330174098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'SORT_REZ',
  p_column_display_sequence=> 10,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9555425728098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 9,
  p_form_element_id=> null,
  p_column_alias=> 'LAST_BESTELLDATUM',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie in (0,-1)  /* Suchbed. od. Rezepte*/ ',
  p_display_as=>'ESCAPE_SC',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9555516334098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 10,
  p_form_element_id=> null,
  p_column_alias=> 'AKT_DATUM',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9555600940098845 + wwv_flow_api.g_id_offset,
  p_region_id=> 9554415061098833 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 11,
  p_form_element_id=> null,
  p_column_alias=> 'REZEPT_REICHWEITE',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_when_cond_type=> 'PLSQL_EXPRESSION',
  p_display_when_condition=> ':p300_artikelkategorie in (0,-1)  /* Suchbed. od. Rezepte*/ ',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_inline_lov=> 'SELECT 60 a, 60 b from dual UNION'||unistr('\000a')||
'SELECT 90  , 90   from dual UNION'||unistr('\000a')||
'SELECT 120 , 120  from dual '||unistr('\000a')||
'order by 1',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 9555707732098849 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 991,
  p_plug_name=> 'allg',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 40,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_1',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'Select 1  '||unistr('\000a')||
'from dual '||unistr('\000a')||
'where 1!= 2'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 9557301332098855 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 991,
  p_name=> 'test',
  p_region_name=>'',
  p_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 20,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_2',
  p_item_display_point=> 'BELOW',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_condition_type=> 'NEVER',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="overflow: auto;width: 250px ">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings_type=> 'COLON_DELMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_break_cols=> '0',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9557500519098856 + wwv_flow_api.g_id_offset,
  p_region_id=> 9557301332098855 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> '1',
  p_column_display_sequence=> 1,
  p_column_heading=> '1',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 9557612871098856 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 991,
  p_plug_name=> 'Kategorietitel',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 11,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_2',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows => 15,
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => 'NEVER',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'select case when connect_by_isleaf = 1 then 0'||unistr('\000a')||
'            when level = 1             then 1'||unistr('\000a')||
'            else                           -1'||unistr('\000a')||
'       end as status, '||unistr('\000a')||
'       level, '||unistr('\000a')||
'       "BEZEICHNUNG" as title, '||unistr('\000a')||
'       null as icon, '||unistr('\000a')||
'       "ID" as value, '||unistr('\000a')||
'       null as tooltip, '||unistr('\000a')||
'       null as link '||unistr('\000a')||
'from "PIS"."ARTGRUPPEN"'||unistr('\000a')||
'where and sort >=30 and sort < 40'||unistr('\000a')||
'start with "ARTGRUPPE_ID" is null'||unistr('\000a')||
'connect b';

s:=s||'y prior "ID" = "ARTGRUPPE_ID"'||unistr('\000a')||
'order siblings by "SORT"';

wwv_flow_api.create_page_plug (
  p_id=> 9558014885098857 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 991,
  p_plug_name=> 'Kategorien',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2888300769489439+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 1,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_2',
  p_plug_item_display_point=> 'BELOW',
  p_plug_source=> s,
  p_plug_source_type=> 'JSTREE',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_header=> '<div style="overflow: auto;height: 500px;width: 270px; border-right: 1px dashed #C7C7C7; background-color:#F7F7E7">',
  p_plug_footer=> '</div>',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
declare
 a1 varchar2(32767) := null;
begin
a1:=a1||'select case when connect_by_isleaf = 1 then 0'||unistr('\000a')||
'             when level = 1            then 1'||unistr('\000a')||
'             else                          -1'||unistr('\000a')||
'       end as status,'||unistr('\000a')||
'       level,'||unistr('\000a')||
'       "BEZEICHNUNG" as title,'||unistr('\000a')||
'       img as icon,'||unistr('\000a')||
'       "ID" as value,'||unistr('\000a')||
'       null as tooltip,'||unistr('\000a')||
'       CASE when connect_by_isleaf = 1 THEN'||unistr('\000a')||
'APEX_UTIL.PREPARE_URL(''f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::::P991_ARTIKELKATEGORIE,';

a1:=a1||'P991_ARTIKELKATEGORIE_BEZ,P991_SUCHE:''||ID||'',''||BEZEICHNUNG)'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'       NULL'||unistr('\000a')||
'    END as link'||unistr('\000a')||
'from ( select a.*'||unistr('\000a')||
'from ('||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICHNUNG'',ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'       kuerzel,id,sort,'||unistr('\000a')||
'       CASE WHEN dokument_id is not null THEN'||unistr('\000a')||
'         ''#OWNER#.frgbg_t.display_thumb?p_bild_id=''|| NVL (dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id|';

a1:=a1||'| '''''||unistr('\000a')||
'       ELSE NULL END img,'||unistr('\000a')||
'       NVL(artgruppe_id,0) artgruppe_id'||unistr('\000a')||
'FROM artgruppen'||unistr('\000a')||
'WHERE :p991_wk_artikeltyp_flag in (2)   -- NEI 22.05.13 Keine Mischaufträge mit Laborartikel'||unistr('\000a')||
'                                        -- (1=nur Labor,2=nur sonstige'||unistr('\000a')||
'UNION'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(3666,:fas_sprache_id)||''n'','||unistr('\000a')||
'       '''', 0,0,'||unistr('\000a')||
'       ''#OWNER#.frgbg_t.display_thumb?p_bild_id=11170&p_sprache_i';

a1:=a1||'d=''||:fas_sprache_id,'||unistr('\000a')||
'       NULL'||unistr('\000a')||
'from dual'||unistr('\000a')||
')  a'||unistr('\000a')||
''||unistr('\000a')||
'start with ID in ('||unistr('\000a')||
'      SELECT distinct g.id'||unistr('\000a')||
'      FROM artgruppen g, mengenarts m, sortiment_details sd'||unistr('\000a')||
'      WHERE g.id = m.artgruppe_id'||unistr('\000a')||
'        AND m.satz_kennzeichen is null'||unistr('\000a')||
'        AND m.id = sd.mengenart_id'||unistr('\000a')||
'        AND sd.sortiment_id in (4)--:fas_sortiment_id)'||unistr('\000a')||
'        AND sd.satz_kennzeichen is null'||unistr('\000a')||
'        AND sd.verkaufsartikel != ''N'''||unistr('\000a')||
'   ';

a1:=a1||'     AND g.id != 20 /* nicht Laborauftragsartikel */'||unistr('\000a')||
'        AND (g.id = 76 AND  :P991_std_mischartikel>0  /* Std.Michartikel nur mit Rollenfreigabe*/'||unistr('\000a')||
'             OR'||unistr('\000a')||
'             g.id != 76'||unistr('\000a')||
'            )'||unistr('\000a')||
'       UNION select 0 from dual'||unistr('\000a')||
'       )'||unistr('\000a')||
'connect by prior ARTGRUPPE_ID=id'||unistr('\000a')||
''||unistr('\000a')||
'UNION  -- Rezepte nur 1 Ebene'||unistr('\000a')||
'SELECT frgbg_s.holen_uebersetzung(4859,:fas_sprache_id),'||unistr('\000a')||
'       frgbg_s.holen_uebersetzung';

a1:=a1||'(4859,:fas_sprache_id),-1,0.2,'||unistr('\000a')||
'       ''#OWNER#.frgbg_t.display_thumb?p_bild_id= 10660 &p_sprache_id=''||:fas_sprache_id,'||unistr('\000a')||
'       0 --NULL'||unistr('\000a')||
'FROM DUAL'||unistr('\000a')||
'WHERE :p991_wk_artikeltyp_flag in (2) -- NEI 22.05.13 Keine Mischaufträge mit Laborartikel'||unistr('\000a')||
'                                      -- (1=nur Labor,2=nur sonstige '||unistr('\000a')||
''||unistr('\000a')||
'UNION  -- Laborauftrag nur 1 Ebene'||unistr('\000a')||
'SELECT fas_synch.get_tab_uebersetzung(''ARTGRUPPEN.BEZEICH';

a1:=a1||'NUNG'',ID,:fas_sprache_id) bezeichnung,'||unistr('\000a')||
'       kuerzel,id,0.1,'||unistr('\000a')||
'       CASE WHEN dokument_id is not null THEN'||unistr('\000a')||
'         ''#OWNER#.frgbg_t.display_thumb?p_bild_id=''|| NVL (dokument_id, 0)||''&p_sprache_id=''||:fas_sprache_id'||unistr('\000a')||
'       ELSE NULL END img,'||unistr('\000a')||
'       0 --NULL'||unistr('\000a')||
'FROM artgruppen'||unistr('\000a')||
'WHERE :p991_wk_artikeltyp_flag in (1)    -- NEI 22.05.13 Keine Mischaufträge mit Laborartikel'||unistr('\000a')||
'                              ';

a1:=a1||'           -- (1=nur Labor,2=nur sonstige '||unistr('\000a')||
'  and id in ('||unistr('\000a')||
'             SELECT distinct g.id'||unistr('\000a')||
'             FROM artgruppen g, mengenarts m, sortiment_details sd'||unistr('\000a')||
'             WHERE g.id = m.artgruppe_id'||unistr('\000a')||
'               AND m.satz_kennzeichen is null'||unistr('\000a')||
'               AND m.id = sd.mengenart_id'||unistr('\000a')||
'               AND sd.sortiment_id in (4)--:fas_sortiment_id)'||unistr('\000a')||
'               AND sd.satz_kennzeichen is null'||unistr('\000a')||
'    ';

a1:=a1||'           AND sd.verkaufsartikel != ''N'''||unistr('\000a')||
'               AND g.id = 20 -- nur Laborauftragsartikel '||unistr('\000a')||
'            )'||unistr('\000a')||
'   and (select count(*)       -- nicht ausgewertete FB zu der Person vorhanden?'||unistr('\000a')||
'       from v_fb_fas'||unistr('\000a')||
'       where personenstamm_id = 47037 --:P300_PERSSTAMM_ID'||unistr('\000a')||
'         and pergebnis_id is not null'||unistr('\000a')||
'         and perg_akt_version = 1'||unistr('\000a')||
'         and frgbg_s.FB_CHECK_AUSWERTUNG(pergebnis_id)=';

a1:=a1||' 0'||unistr('\000a')||
'         and fragebogen_id = 5'||unistr('\000a')||
'        ) > 0'||unistr('\000a')||
'   --AND :p300_extern_verwaltet = 1 --GUS verwaltete Auftraege '||unistr('\000a')||
''||unistr('\000a')||
')'||unistr('\000a')||
'start with "ARTGRUPPE_ID" is null'||unistr('\000a')||
'connect by prior "ID" = "ARTGRUPPE_ID"'||unistr('\000a')||
'order siblings by "SORT"';

wwv_flow_api.create_jstree(
  p_id => 9558209290098858+wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id => 991,
  p_region_id => 9558014885098857+wwv_flow_api.g_id_offset,
  p_tree_template     =>'classic',
  p_tree_source             =>'',
  p_tree_query             =>a1,
  p_tree_node_title   =>'BEZEICHNUNG',
  p_tree_node_value   =>'ID',
  p_tree_node_icon   =>'',
  p_tree_node_link   =>'',
  p_tree_node_hints   =>'ARTGRUPPE_ID',
  p_tree_start_item   =>'ARTGRUPPE_ID',
  p_tree_start_value   =>'',
  p_tree_button_option   =>'CONTRACT_ALL:EXPAND_ALL',
  p_show_node_link   =>'',
  p_node_link_checksum_type   =>null,
  p_tree_comment          =>'',
  p_show_hints          =>'N',
  p_tree_has_focus          =>'N',
  p_tree_hint_text          =>'',
  p_tree_click_action          =>'S',
  p_selected_node          =>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 9702314022041630 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 991,
  p_button_sequence=> 20,
  p_button_plug_id => 9555707732098849+wwv_flow_api.g_id_offset,
  p_button_name    => 'BUT_ZURÜCK',
  p_button_action  => 'REDIRECT_PAGE',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:991::',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 9558825830098864 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 991,
  p_button_sequence=> 10,
  p_button_name    => 'CANCEL',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Zurück',
  p_button_position=> 'REGION_TEMPLATE_CLOSE',
  p_button_alignment=> 'LEFT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 9558432367098861 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 991,
  p_button_sequence=> 10,
  p_button_plug_id => 9558014885098857+wwv_flow_api.g_id_offset,
  p_button_name    => 'CONTRACT_ALL',
  p_button_action  => 'REDIRECT_URL',
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Collapse All',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.widget.tree.collapse_all(''tree'||to_char(8865822914441401+wwv_flow_api.g_id_offset)||''');',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
wwv_flow_api.create_page_button(
  p_id             => 9558608736098863 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 991,
  p_button_sequence=> 10,
  p_button_plug_id => 9558014885098857+wwv_flow_api.g_id_offset,
  p_button_name    => 'EXPAND_ALL',
  p_button_action  => 'REDIRECT_URL',
  p_button_is_hot=>'N',
  p_button_image_alt=> 'Expand All',
  p_button_position=> 'REGION_TEMPLATE_CREATE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> 'javascript:apex.widget.tree.expand_all(''tree'||to_char(8865822914441401+wwv_flow_api.g_id_offset)||''');',
  p_button_execute_validations=>'Y',
  p_button_condition_type=> 'NEVER',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>9559526719098880 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P991_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_sequence=> 130,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 17-APR-2009 11:25 by FRGBG');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5216221797390431 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_name=>'P991_TESTBILD',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 80,
  p_item_plug_id => 9555707732098849+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Testbild',
  p_source=>'SELECT ''<img src="#OWNER#.frgbg_t.display_thumb?p_bild_id=11170&p_sprache_id=''||:fas_sprache_id || ''"/>'' from dual',
  p_source_type=> 'QUERY',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> null,
  p_rowspan=> null,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9555910991098850 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_name=>'P991_ARTIKELKATEGORIE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 9555707732098849+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Artikelkategorie',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9556100901098853 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_name=>'P991_SUCHE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 9555707732098849+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Suche',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9556301009098853 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_name=>'P991_ARTIKELKATEGORIE_BEZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 9555707732098849+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Artikelkategorie Bez',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2899703987489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9556514668098854 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_name=>'P991_WK_ARTIKELTYP_FLAG',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 9555707732098849+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '2',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9556714862098855 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_name=>'P991_STD_MISCHARTIKEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 9555707732098849+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '1',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9556908892098855 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_name=>'P991_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 70,
  p_item_plug_id => 9555707732098849+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '516957',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9557121696098855 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_name=>'P991_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 9555707732098849+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> '990',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9557806000098857 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 991,
  p_name=>'P991_TITEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 1,
  p_item_plug_id => 9557612871098856+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Kategorien',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_da_event (
  p_id => 9559012445098866 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 991
 ,p_name => 'öffne ausgewählten Knoten (Seitenstart)'
 ,p_event_sequence => 10
 ,p_bind_type => 'bind'
 ,p_bind_event_type => 'ready'
  );
wwv_flow_api.create_page_da_action (
  p_id => 9559322127098875 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_page_id => 991
 ,p_event_id => 9559012445098866 + wwv_flow_api.g_id_offset
 ,p_event_result => 'TRUE'
 ,p_action_sequence => 10
 ,p_execute_on_page_init => 'N'
 ,p_action => 'NATIVE_JAVASCRIPT_CODE'
 ,p_attribute_01 => '$(document).ready(function() {'||unistr('\000a')||
''||unistr('\000a')||
'   if($v(''P991_ARTIKELKATEGORIE'').length > 0) {'||unistr('\000a')||
'     //Öffne alle Baumknoten, die das Listenelement haben, das die in P991_ARTIKELKATEGORIE angegebene Id hat'||unistr('\000a')||
'     //Sollte auch funktioniert über mehrere Hierarchien hinweg'||unistr('\000a')||
'     $(''div[class~="tree"] li[class~="closed"]'').has(''li[id="'' + $v(''P991_ARTIKELKATEGORIE'') + ''"]'').removeClass(''closed'').addClass(''open'')'||unistr('\000a')||
''||unistr('\000a')||
'  }'||unistr('\000a')||
''||unistr('\000a')||
'});'
 ,p_stop_execution_on_error => 'Y'
 );
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 991
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00995
prompt  ...PAGE 995: Popupinfo
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 995
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Popupinfo'
 ,p_step_title => 'Popupinfo'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'Popupinfo'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'SASCHA.LENZ'
 ,p_last_upd_yyyymmddhh24miss => '20140718101359'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT '||unistr('\000a')||
'   uebersetzung.holen_uebersetzung_clob(:p995_info_text_id,:fas_sprache_id) text'||unistr('\000a')||
'FROM dual'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 9460201392220154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 995,
  p_name=> '&P995_REGION_TITEL_INFO.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 30,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_condition_type=> 'NEVER',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="max-width: 900px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(519,:fas_sprache_id))',
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 9460429731220160 + wwv_flow_api.g_id_offset,
  p_region_id=> 9460201392220154 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_css_style=>'font-weight:normal;',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 9467305797596063 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 995,
  p_plug_name=> '&P995_REGION_TITEL_INFO.',
  p_region_name=>'',
  p_escape_on_http_output=>'Y',
  p_plug_template=> 2890106833489440+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 40,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 9460530774220163 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 995,
  p_button_sequence=> 10,
  p_button_plug_id => 9460201392220154+wwv_flow_api.g_id_offset,
  p_button_name    => 'SCHLIESSEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P995_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>9461827913220189 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 995,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P995_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>9460530774220163+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9460709794220168 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 995,
  p_name=>'P995_INFO_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 9460201392220154+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 2000,
  p_cHeight=> 20,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9460904741220175 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 995,
  p_name=>'P995_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 9460201392220154+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Zur Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9461122981220176 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 995,
  p_name=>'P995_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 9460201392220154+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9461329991220177 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 995,
  p_name=>'P995_REGION_TITEL_INFO',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 9460201392220154+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9462623675241661 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 995,
  p_name=>'P995_SPRACHE_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 9460201392220154+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default=> ':FAS_SPRACHE_ID',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9462912031247729 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 995,
  p_name=>'P995_REGIONTITEL_TEXT_ID',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 60,
  p_item_plug_id => 9460201392220154+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>9466419556543204 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 995,
  p_name=>'P995_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 5,
  p_item_plug_id => 9467305797596063+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'uebersetzung.holen_uebersetzung_clob(:p995_info_text_id,:fas_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_DISPLAY_ONLY',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT-CENTER',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'N',
  p_attribute_01 => 'N',
  p_attribute_02 => 'VALUE',
  p_attribute_04 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p := null;
wwv_flow_api.create_page_process(
  p_id     => 9464526894374988 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 995,
  p_process_sequence=> 5,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLEAR_CACHE_FOR_PAGES',
  p_process_name=> 'clear_cache',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'CLOSE_WINDOW';

wwv_flow_api.create_page_process(
  p_id     => 9461911769228751 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 995,
  p_process_sequence=> 10,
  p_process_point=> 'AFTER_SUBMIT',
  p_process_type=> 'CLOSE_WINDOW',
  p_process_name=> 'Close Window',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'INLINE_IN_NOTIFICATION',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER ;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   v_sprache_id := NVL(:P995_sprache_id, :fas_sprache_id);'||unistr('\000a')||
'   :p995_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   IF :P995_REGIONTITEL_TEXT_ID is not null THEN'||unistr('\000a')||
'      :P995_REGION_TITEL_INFO := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(:P995_REGIONTITEL_TEXT_ID,v_sprache_id);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 9461505292220180 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 995,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 995
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00996
prompt  ...PAGE 996:  Handbuch
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 996
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => ' Handbuch'
 ,p_step_title => ' Handbuch'
 ,p_step_sub_title => ' Handbuch'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140513105759'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT '||unistr('\000a')||
'   uebersetzung.holen_uebersetzung_blob(10026,:fas_sprache_id) text'||unistr('\000a')||
'FROM dual'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 8018425258944556 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 996,
  p_name=> '&P996_REGION_TITEL_HANDBUCH.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 30,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_display_condition_type=> 'NEVER',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="max-width: 900px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(519,:fas_sprache_id))',
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 8018631080944559 + wwv_flow_api.g_id_offset,
  p_region_id=> 8018425258944556 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_css_style=>'font-weight:normal;',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 8018724839944562 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 996,
  p_button_sequence=> 10,
  p_button_plug_id => 8018425258944556+wwv_flow_api.g_id_offset,
  p_button_name    => 'SCHLIESSEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P996_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>8020020405944571 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 996,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P996_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>8018724839944562+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8018911477944564 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 996,
  p_name=>'P996_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 8018425258944556+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'unbekannt',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 2000,
  p_cHeight=> 20,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8019112823944567 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 996,
  p_name=>'P996_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 8018425258944556+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Zur Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8019320621944567 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 996,
  p_name=>'P996_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 8018425258944556+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>8019524622944568 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 996,
  p_name=>'P996_REGION_TITEL_HANDBUCH',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 8018425258944556+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p996_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :P996_REGION_TITEL_HANDBUCH:= '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(9449,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 8019719428944569 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 996,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'declare'||unistr('\000a')||
'   v_blob blob;'||unistr('\000a')||
'   v_dateiname varchar2(100);'||unistr('\000a')||
'   v_size number;'||unistr('\000a')||
'   v_lastchange date;'||unistr('\000a')||
'   v_id number;'||unistr('\000a')||
'   v_mimetype varchar2(100);'||unistr('\000a')||
'   v_text_id number := 10026;'||unistr('\000a')||
'begin'||unistr('\000a')||
'/*  '||unistr('\000a')||
'   -- Hole Blob content'||unistr('\000a')||
'   select blob_dat,'||unistr('\000a')||
'          dbms_lob.getlength(blob_dat),'||unistr('\000a')||
'          mutdat,'||unistr('\000a')||
'          id'||unistr('\000a')||
'   into v_blob,'||unistr('\000a')||
'        v_size,'||unistr('\000a')||
'        v_lastchange,'||unistr('\000a')||
'        v_id'||unistr('\000a')||
'   from uebersetzungen '||unistr('\000a')||
'   where text_';

p:=p||'id = :P143_ID '||unistr('\000a')||
'         and id = :P143_UEB_ID'||unistr('\000a')||
'         and satz_kennzeichen is null;'||unistr('\000a')||
'*/'||unistr('\000a')||
'   v_blob := uebersetzung.holen_uebersetzung_blob(v_text_id,:fas_sprache_id);'||unistr('\000a')||
'   v_size := dbms_lob.getlength(v_blob);'||unistr('\000a')||
'   v_lastchange:= sysdate;'||unistr('\000a')||
'   v_id := v_text_id;'||unistr('\000a')||
''||unistr('\000a')||
'    -- Erstelle ein Dateiname '||unistr('\000a')||
'    select ''FAS_Handbuch_''||to_char(t.id) '||unistr('\000a')||
'/*'||unistr('\000a')||
'           to_char(t.id) || ''_'' || to_char(s.id) '||unistr('\000a')||
'            || ''';

p:=p||'_'' || regexp_replace(lower(to_Char(NVL(s.ISO2_ID,s.ISO3_ID))),''[^a-z0-9_-]'',''_'') '||unistr('\000a')||
'*/'||unistr('\000a')||
'            || ''.'' || DOKTYP,'||unistr('\000a')||
'           dt.mimetype'||unistr('\000a')||
'    into v_dateiname,'||unistr('\000a')||
'         v_mimetype'||unistr('\000a')||
'    from TEXTE t, PIS.DOKUMENTTYPEN dt --, sprachen s'||unistr('\000a')||
'    where'||unistr('\000a')||
'       t.ID = v_text_id'||unistr('\000a')||
'  --     and s.ID = (select sprache_id from uebersetzungen where id = :P143_UEB_ID)'||unistr('\000a')||
'       and t.DOKUMENTTYP_ID = dt.ID;'||unistr('\000a')||
''||unistr('\000a')||
'  -- Im HT';

p:=p||'TP-Header wird der Dateityp gesetzt. Damit erkennt der Browser'||unistr('\000a')||
'  -- welche Applikation (bspw. MS Word) zu starten ist'||unistr('\000a')||
'  owa_util.mime_header(NVL(v_mimetype,''application/octet''),false);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Die Dateigröße wird dem Browser ebenfalls mitgeteilt'||unistr('\000a')||
'  htp.p(''Content-length:''|| v_size);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Das Datum (LETZTE_AENDERUNG) wird ebenfalls als HTTP-Header gesetzt'||unistr('\000a')||
'  htp.p(''Date:''||to_char(v_lastchange,''Dy, DD';

p:=p||' Mon RRRR hh24:mi:ss'')||'' CET'');'||unistr('\000a')||
''||unistr('\000a')||
'  -- Der Parameter p_display steuert, ob die Datei direkt dargestellt oder'||unistr('\000a')||
'  -- ob dem Anwender ein Download-Dialog angeboten werden soll. Wie man sehen'||unistr('\000a')||
'  -- kann, richtet sich der Browser nach den Feldern im HTTP Header.'||unistr('\000a')||
'  htp.p(''Content-Disposition: attachment; filename=''||v_dateiname);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Der Browser soll die Datei unter keinen Umständen aus dem Cache holen.';

p:=p||''||unistr('\000a')||
'  htp.p(''Cache-Control: must-revalidate, max-age=0'');'||unistr('\000a')||
'  htp.p(''Expires: Thu, 01 Jan 1970 01:00:00 CET'');'||unistr('\000a')||
''||unistr('\000a')||
'  -- Die Datei bekommt eine ID - damit kann der Browser sie eindeutig erkennen.'||unistr('\000a')||
'  htp.p(''Etag: TAB_DATEIEN...''||v_id||''...''||to_char(v_lastchange, ''JHH24MISS''));'||unistr('\000a')||
''||unistr('\000a')||
'  -- Alle HTTP-Header-Felder sind gesetzt'||unistr('\000a')||
'  owa_util.http_header_close;'||unistr('\000a')||
''||unistr('\000a')||
'  -- Dieser kurze Aufruf führt den eigentlichen Datei-Dow';

p:=p||'nload durch.'||unistr('\000a')||
'  wpg_docload.download_file(v_blob);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Damit Apex nicht die Oberfläche darstellt'||unistr('\000a')||
'  apex_application.g_unrecoverable_error := true;'||unistr('\000a')||
'end;';

wwv_flow_api.create_page_process(
  p_id     => 8021609579309646 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 996,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'download_handbuch',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_only_for_changed_rows=> 'Y',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 996
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00997
prompt  ...PAGE 997: Datenschutz
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 997
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Datenschutz'
 ,p_step_title => 'Datenschutz'
 ,p_step_sub_title => 'Datenschutz'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20140210090713'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT '||unistr('\000a')||
'   uebersetzung.holen_uebersetzung_clob(9451,:fas_sprache_id) text'||unistr('\000a')||
'FROM dual'||unistr('\000a')||
'';

wwv_flow_api.create_report_region (
  p_id=> 7480123416572399 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 997,
  p_name=> '&P997_REGION_TITEL_DATENSCHUTZ.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 30,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="max-width: 900px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 11,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(519,:fas_sprache_id))',
  p_query_headings_type=> 'NO_HEADINGS',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> '0',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 7480625823572428 + wwv_flow_api.g_id_offset,
  p_region_id=> 7480123416572399 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'TEXT',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_css_style=>'font-weight:normal;',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 7481118318572429 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 997,
  p_button_sequence=> 10,
  p_button_plug_id => 7480123416572399+wwv_flow_api.g_id_offset,
  p_button_name    => 'SCHLIESSEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P997_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>7482630022572450 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 997,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P997_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>7481118318572429+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7481307732572437 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 997,
  p_name=>'P997_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 7480123416572399+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(9400,:fas_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_RICH_TEXT_EDITOR',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 2000,
  p_cHeight=> 20,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'CKEDITOR3',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7481506716572442 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 997,
  p_name=>'P997_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 7480123416572399+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Zur Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7481706071572442 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 997,
  p_name=>'P997_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 7480123416572399+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>7481903245572443 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 997,
  p_name=>'P997_REGION_TITEL_DATENSCHUTZ',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 7480123416572399+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p997_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :P997_REGION_TITEL_DATENSCHUTZ := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(9449,v_sprache_id);'||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 7482311185572446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 997,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 997
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00998
prompt  ...PAGE 998: Versionsinformation
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 998
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Versionsinformation'
 ,p_step_title => 'Versionsinformation'
 ,p_step_sub_title => 'Versionsinformation'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20150913220449'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s:=s||'SELECT '||unistr('\000a')||
'to_char(version,''FM999.00'')||'' ''||CASE WHEN status = 0 THEN '||unistr('\000a')||
'''<span style="text-decoration:underline; font-weight:bold;">''|| frgbg_s.holen_uebersetzung(8029,:fas_sprache_id) ||''</span> '' else frgbg_s.holen_uebersetzung(8030,:fas_sprache_id) ||'' '' END ||'||unistr('\000a')||
'to_char(datum,''DD.MM.YYYY'') info,'||unistr('\000a')||
'--replace(frgbg_s.holen_uebersetzung(text_id,:fas_sprache_id),chr(10),''<br/>'') text,'||unistr('\000a')||
'uebersetzung.holen_';

s:=s||'uebersetzung_clob(text_id,:fas_sprache_id) text,'||unistr('\000a')||
'id,version,text_id, status,datum,bemerkung'||unistr('\000a')||
'FROM FAS_VERSIONEN'||unistr('\000a')||
'where satz_kennzeichen is null'||unistr('\000a')||
'order by version desc';

wwv_flow_api.create_report_region (
  p_id=> 6193029714208457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 998,
  p_name=> '&P998_REGION_TITEL_VERSION.',
  p_region_name=>'',
  p_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_display_sequence=> 30,
  p_new_grid         => false,
  p_new_grid_row     => false,
  p_new_grid_column  => false,
  p_display_column=> 1,
  p_display_point=> 'BODY_3',
  p_item_display_point=> 'ABOVE',
  p_source=> s,
  p_source_type=> 'SQL_QUERY',
  p_plug_caching=> 'NOT_CACHED',
  p_header=> '<div style="max-width: 900px;">',
  p_footer=> '</div>',
  p_customized=> '0',
  p_translate_title=> 'Y',
  p_ajax_enabled=> 'Y',
  p_query_row_template=> 3,
  p_query_headings=> 'RETURN(frgbg_s.holen_uebersetzung(519,:fas_sprache_id))',
  p_query_headings_type=> 'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST',
  p_query_num_rows=> '15',
  p_query_options=> 'DERIVED_REPORT_COLUMNS',
  p_query_show_nulls_as=> ' - ',
  p_query_break_cols=> '0',
  p_query_no_data_found=> 'no data found',
  p_query_num_rows_type=> 'NEXT_PREVIOUS_LINKS',
  p_query_row_count_max=> '500',
  p_pagination_display_position=> 'BOTTOM_RIGHT',
  p_break_type_flag=> 'DEFAULT_BREAK_FORMATTING',
  p_csv_output=> 'N',
  p_query_asc_image=> 'apex/builder/dup.gif',
  p_query_asc_image_attr=> 'width="16" height="16" alt="" ',
  p_query_desc_image=> 'apex/builder/ddown.gif',
  p_query_desc_image_attr=> 'width="16" height="16" alt="" ',
  p_plug_query_strip_html=> 'Y',
  p_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6194719634252872 + wwv_flow_api.g_id_offset,
  p_region_id=> 6193029714208457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 1,
  p_form_element_id=> null,
  p_column_alias=> 'INFO',
  p_column_display_sequence=> 1,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6193614535208467 + wwv_flow_api.g_id_offset,
  p_region_id=> 6193029714208457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 2,
  p_form_element_id=> null,
  p_column_alias=> 'TEXT',
  p_column_display_sequence=> 2,
  p_column_heading=> '',
  p_use_as_row_header=> 'N',
  p_column_css_style=>'font-weight:normal;',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'LEFT',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'N',
  p_display_as=>'WITHOUT_MODIFICATION',
  p_lov_show_nulls=> 'NO',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_lov_display_extra=> 'YES',
  p_include_in_export=> 'Y',
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6193313855208464 + wwv_flow_api.g_id_offset,
  p_region_id=> 6193029714208457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 3,
  p_form_element_id=> null,
  p_column_alias=> 'ID',
  p_column_display_sequence=> 3,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6193415013208467 + wwv_flow_api.g_id_offset,
  p_region_id=> 6193029714208457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 4,
  p_form_element_id=> null,
  p_column_alias=> 'VERSION',
  p_column_display_sequence=> 4,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6193512478208467 + wwv_flow_api.g_id_offset,
  p_region_id=> 6193029714208457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 5,
  p_form_element_id=> null,
  p_column_alias=> 'TEXT_ID',
  p_column_display_sequence=> 7,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6193707395208467 + wwv_flow_api.g_id_offset,
  p_region_id=> 6193029714208457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 6,
  p_form_element_id=> null,
  p_column_alias=> 'STATUS',
  p_column_display_sequence=> 5,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6193813065208467 + wwv_flow_api.g_id_offset,
  p_region_id=> 6193029714208457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 7,
  p_form_element_id=> null,
  p_column_alias=> 'DATUM',
  p_column_display_sequence=> 6,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
declare
  s varchar2(32767) := null;
begin
s := null;
wwv_flow_api.create_report_columns (
  p_id=> 6193900944208467 + wwv_flow_api.g_id_offset,
  p_region_id=> 6193029714208457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_query_column_id=> 8,
  p_form_element_id=> null,
  p_column_alias=> 'BEMERKUNG',
  p_column_display_sequence=> 8,
  p_column_heading=> '',
  p_column_alignment=>'LEFT',
  p_heading_alignment=>'CENTER',
  p_default_sort_column_sequence=>0,
  p_disable_sort_column=>'Y',
  p_sum_column=> 'N',
  p_hidden_column=> 'Y',
  p_display_as=>'ESCAPE_SC',
  p_is_required=> false,
  p_pk_col_source=> s,
  p_column_comment=>'');
end;
/
 
begin
 
wwv_flow_api.create_page_button(
  p_id             => 3832309237268230 + wwv_flow_api.g_id_offset,
  p_flow_id        => wwv_flow.g_flow_id,
  p_flow_step_id   => 998,
  p_button_sequence=> 10,
  p_button_plug_id => 6193029714208457+wwv_flow_api.g_id_offset,
  p_button_name    => 'SCHLIESSEN',
  p_button_action  => 'SUBMIT',
  p_button_image   => 'template:'||to_char(2885332167489437+wwv_flow_api.g_id_offset),
  p_button_is_hot=>'N',
  p_button_image_alt=> '&P998_BL_ABBRECHEN.',
  p_button_position=> 'REGION_TEMPLATE_CHANGE',
  p_button_alignment=> 'RIGHT',
  p_button_redirect_url=> '',
  p_button_execute_validations=>'Y',
  p_required_patch => null + wwv_flow_api.g_id_offset);
 
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>3833014269268232 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 998,
  p_branch_name=> '',
  p_branch_action=> 'f?p=&APP_ID.:&P998_ZURUECK_ZUR_SEITE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'REDIRECT_URL',
  p_branch_when_button_id=>3832309237268230+ wwv_flow_api.g_id_offset,
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3832515340268230 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 998,
  p_name=>'P998_TEXT',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6193029714208457+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source=>'frgbg_s.holen_uebersetzung(1000,:fas_sprache_id)',
  p_source_type=> 'FUNCTION',
  p_display_as=> 'NATIVE_TEXTAREA',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 100,
  p_cMaxlength=> 2000,
  p_cHeight=> 20,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_display_when_type=>'NEVER',
  p_read_only_when_type=>'ALWAYS',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_attribute_02 => 'N',
  p_attribute_03 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>3832718541268232 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 998,
  p_name=>'P998_ZURUECK_ZUR_SEITE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 20,
  p_item_plug_id => 6193029714208457+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Zurueck Zur Seite',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'Y',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6202310255723261 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 998,
  p_name=>'P998_BL_ABBRECHEN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 6193029714208457+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Bl Abbrechen',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6202526877727977 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 998,
  p_name=>'P998_REGION_TITEL_VERSION',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 40,
  p_item_plug_id => 6193029714208457+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'NO',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'NO',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6204606979835774 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 998,
  p_name=>'P998_VERSION_LABEL',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 50,
  p_item_plug_id => 6193029714208457+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'Y',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_sprache_id NUMBER := frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   :p998_bl_abbrechen := frgbg_s.holen_uebersetzung(161,v_sprache_id);'||unistr('\000a')||
'   :P998_REGION_TITEL_VERSION := '||unistr('\000a')||
'                      frgbg_s.holen_uebersetzung(8028,v_sprache_id);'||unistr('\000a')||
'   :P998_version_label := frgbg_s.holen_uebersetzung(519,v_sprache_id);'||unistr('\000a')||
'   --:P998_NV_PATIENTENLISTE := frgbg_s.holen_uebersetzung(3833,v_sprache_id);'||unistr('\000a')||
'';

p:=p||'END;';

wwv_flow_api.create_page_process(
  p_id     => 6201901335701751 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 998,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'button_labels_setzen',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 998
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_00999
prompt  ...PAGE 999: Logout
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 999
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'Logout'
 ,p_alias => 'LOGOUT'
 ,p_step_title => 'Logout'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'N'
 ,p_protection_level => 'C'
 ,p_cache_page_yn => 'N'
 ,p_last_updated_by => 'BRIGITTE.NEIDHART'
 ,p_last_upd_yyyymmddhh24miss => '20130116113836'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 5218123030861565 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 999,
  p_plug_name=> 'Logout',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_template=> 2885905427489437+ wwv_flow_api.g_id_offset,
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'QUERY_COLUMNS',
  p_plug_query_num_rows_type => 'NEXT_PREVIOUS_LINKS',
  p_plug_query_row_count_max => 500,
  p_plug_query_show_nulls_as => ' - ',
  p_plug_display_condition_type => '',
  p_pagination_display_position=>'BOTTOM_RIGHT',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
null;
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>5219030649863785 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 999,
  p_name=>'P999_LOGIN_PAGE',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 5218123030861565+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Login Page',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_TEXT_FIELD',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 2000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 2900025213489446+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_attribute_02 => 'N',
  p_attribute_04 => 'TEXT',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
declare
  p varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
p:=p||'DECLARE'||unistr('\000a')||
'   v_prot_id number;'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'--mel.p(''logout schema %1'',v_prot_id,''Info'',''P999 logout'',:fas_schema_id);'||unistr('\000a')||
'   apex_application.g_unrecoverable_error := true; '||unistr('\000a')||
'   wwv_flow_custom_auth_std.logout('||unistr('\000a')||
'            p_this_flow=>:APP_ID,'||unistr('\000a')||
'--            p_next_flow_page_sess=>''&APP_ID.:&P999_LOGIN_PAGE.:&SESSION.:LOGOUT'');'||unistr('\000a')||
'--            p_next_flow_page_sess=>''&APP_ID.:&P999_LOGIN_PAGE.::LOGOUT::121:'');'||unistr('\000a')||
' ';

p:=p||'             p_next_flow_page_sess=>''&APP_ID.:&P999_LOGIN_PAGE.:::::FAS_SCHEMA_ID:''||:FAS_SCHEMA_ID);'||unistr('\000a')||
''||unistr('\000a')||
'END;';

wwv_flow_api.create_page_process(
  p_id     => 5216617358850451 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id => 999,
  p_process_sequence=> 10,
  p_process_point=> 'BEFORE_HEADER',
  p_process_type=> 'PLSQL',
  p_process_name=> 'logout',
  p_process_sql_clob => p,
  p_process_error_message=> '',
  p_error_display_location=> 'ON_ERROR_PAGE',
  p_process_success_message=> '',
  p_process_is_stateful_y_n=>'N',
  p_process_comment=>'');
end;
null;
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 999
--
 
begin
 
null;
end;
null;
 
end;
/

 
--application/pages/page_57565
prompt  ...PAGE 57565: pre HTML5 File Upload
--
 
begin
 
wwv_flow_api.create_page (
  p_flow_id => wwv_flow.g_flow_id
 ,p_id => 57565
 ,p_user_interface_id => 64716079194770 + wwv_flow_api.g_id_offset
 ,p_name => 'pre HTML5 File Upload'
 ,p_step_title => 'pre HTML5 File Upload'
 ,p_allow_duplicate_submissions => 'Y'
 ,p_step_sub_title => 'pre HTML5 File Upload'
 ,p_step_sub_title_type => 'TEXT_WITH_SUBSTITUTIONS'
 ,p_first_item => 'NO_FIRST_ITEM'
 ,p_include_apex_css_js_yn => 'Y'
 ,p_autocomplete_on_off => 'ON'
 ,p_page_is_public_y_n => 'Y'
 ,p_protection_level => 'N'
 ,p_cache_page_yn => 'N'
 ,p_cache_timeout_seconds => 21600
 ,p_cache_by_user_yn => 'N'
 ,p_last_updated_by => 'SASCHA-LENZ-CH'
 ,p_last_upd_yyyymmddhh24miss => '20131107141041'
  );
null;
 
end;
/

declare
  s varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
s := null;
wwv_flow_api.create_page_plug (
  p_id=> 6366629271461357 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_page_id=> 57565,
  p_plug_name=> 'Form on WWV_FLOW_FILES',
  p_region_name=>'',
  p_escape_on_http_output=>'N',
  p_plug_display_sequence=> 10,
  p_plug_new_grid         => false,
  p_plug_new_grid_row     => false,
  p_plug_new_grid_column  => false,
  p_plug_display_column=> 1,
  p_plug_display_point=> 'BODY_3',
  p_plug_item_display_point=> 'ABOVE',
  p_plug_source=> s,
  p_plug_source_type=> 'STATIC_TEXT',
  p_translate_title=> 'Y',
  p_plug_query_row_template=> 1,
  p_plug_query_headings_type=> 'COLON_DELMITED_LIST',
  p_plug_query_row_count_max => 500,
  p_plug_display_condition_type => '',
  p_plug_customized=>'0',
  p_plug_caching=> 'NOT_CACHED',
  p_plug_comment=> '');
end;
/
 
begin
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_page_branch(
  p_id=>6366807594461362 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 57565,
  p_branch_name=> '',
  p_branch_action=> 'htp.init;'||unistr('\000a')||
'apex_application.show'||unistr('\000a')||
'( p_flow_id      => :APP_ID '||unistr('\000a')||
', p_flow_step_id => :P57565_PAGE_RETURN'||unistr('\000a')||
', p_instance     => :APP_SESSION '||unistr('\000a')||
', p_request      => apex_application.g_request'||unistr('\000a')||
', p_widget_name  => ''jquery.plugin.fileuploader.iframe'''||unistr('\000a')||
', x01            => apex_application.g_x01'||unistr('\000a')||
');',
  p_branch_point=> 'AFTER_PROCESSING',
  p_branch_type=> 'PLSQL',
  p_branch_sequence=> 10,
  p_save_state_before_branch_yn=>'N',
  p_branch_comment=> 'Created 19-FEB-2011 16:37 by ADMIN');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6367025921461364 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 57565,
  p_name=>'P57565_CONTENTS',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 30,
  p_item_plug_id => 6366629271461357+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'NO',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_prompt=>'Contents',
  p_source=>'CONTENTS',
  p_source_type=> 'DB_COLUMN',
  p_display_as=> 'NATIVE_FILE',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 60,
  p_cMaxlength=> 255,
  p_cHeight=> 1,
  p_new_grid=> false,
  p_begin_on_new_line=> 'YES',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'RIGHT',
  p_field_alignment=> 'LEFT',
  p_field_template=> 6366629271461357+wwv_flow_api.g_id_offset,
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'WWV_FLOW_FILES',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6367225163461366 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 57565,
  p_name=>'P57565_FILENAME',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 10,
  p_item_plug_id => 6366629271461357+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> null,
  p_cMaxlength=> 4000,
  p_cHeight=> null,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_attribute_01 => 'N',
  p_item_comment => '');
 
 
end;
/

declare
    h varchar2(32767) := null;
begin
wwv_flow_api.create_page_item(
  p_id=>6367428010461366 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_flow_step_id=> 57565,
  p_name=>'P57565_PAGE_RETURN',
  p_data_type=> 'VARCHAR',
  p_is_required=> false,
  p_accept_processing=> 'REPLACE_EXISTING',
  p_item_sequence=> 2,
  p_item_plug_id => 6366629271461357+wwv_flow_api.g_id_offset,
  p_use_cache_before_default=> 'YES',
  p_item_default_type=> 'STATIC_TEXT_WITH_SUBSTITUTIONS',
  p_source_type=> 'STATIC',
  p_display_as=> 'NATIVE_HIDDEN',
  p_lov_display_null=> 'NO',
  p_lov_translated=> 'N',
  p_cSize=> 30,
  p_cMaxlength=> 4000,
  p_cHeight=> 1,
  p_cAttributes=> 'nowrap="nowrap"',
  p_new_grid=> false,
  p_begin_on_new_line=> 'NO',
  p_begin_on_new_field=> 'YES',
  p_colspan=> 1,
  p_rowspan=> 1,
  p_grid_column=> null,
  p_label_alignment=> 'LEFT',
  p_field_alignment=> 'LEFT',
  p_is_persistent=> 'Y',
  p_lov_display_extra=>'YES',
  p_protection_level => 'N',
  p_escape_on_http_output => 'Y',
  p_attribute_01 => 'N',
  p_show_quick_picks=>'N',
  p_item_comment => '');
 
 
end;
/

 
begin
 
---------------------------------------
-- ...updatable report columns for page 57565
--
 
begin
 
null;
end;
null;
 
end;
/

prompt  ...lists
--
--application/shared_components/navigation/breadcrumbs
prompt  ...breadcrumbs
--
 
begin
 
wwv_flow_api.create_menu (
  p_id=> 2476427657082606 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=> 'navi_wk');
 
wwv_flow_api.create_menu_option (
  p_id=>2476602854084910 + wwv_flow_api.g_id_offset,
  p_menu_id=>2476427657082606 + wwv_flow_api.g_id_offset,
  p_parent_id=>0,
  p_option_sequence=>10,
  p_short_name=>'Patient',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:::',
  p_page_id=>110,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2476811858087523 + wwv_flow_api.g_id_offset,
  p_menu_id=>2476427657082606 + wwv_flow_api.g_id_offset,
  p_parent_id=>2476602854084910 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P300_NV_WARENKORB.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:::',
  p_page_id=>300,
  p_display_when_cond_type=>'PLSQL_EXPRESSION',
  p_display_when_condition=>':fas_aufgerufen_von != ''BETREUER''',
  p_display_when_condition2=>'',
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2487614964063034 + wwv_flow_api.g_id_offset,
  p_menu_id=>2476427657082606 + wwv_flow_api.g_id_offset,
  p_parent_id=>2476811858087523 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P301_NV_ADRESSLISTE.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:::',
  p_page_id=>301,
  p_display_when_cond_type=>'PLSQL_EXPRESSION',
  p_display_when_condition=>':fas_aufgerufen_von != ''BETREUER''',
  p_display_when_condition2=>'',
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2487825007065893 + wwv_flow_api.g_id_offset,
  p_menu_id=>2476427657082606 + wwv_flow_api.g_id_offset,
  p_parent_id=>2487614964063034 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P302_NV_ADRESSSTAMM.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:::',
  p_page_id=>302,
  p_display_when_cond_type=>'PLSQL_EXPRESSION',
  p_display_when_condition=>':fas_aufgerufen_von != ''BETREUER''',
  p_display_when_condition2=>'',
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2515510307751965 + wwv_flow_api.g_id_offset,
  p_menu_id=>2476427657082606 + wwv_flow_api.g_id_offset,
  p_parent_id=>2476811858087523 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P303_NV_VERORDNUNG.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:303:&SESSION.::&DEBUG.:::',
  p_page_id=>303,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>6669720904810585 + wwv_flow_api.g_id_offset,
  p_menu_id=>2476427657082606 + wwv_flow_api.g_id_offset,
  p_parent_id=>2476811858087523 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Patientenstamm',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:::',
  p_page_id=>304,
  p_also_current_for_pages=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_menu (
  p_id=> 5557414378428469 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=> 'navi_labor');
 
wwv_flow_api.create_menu_option (
  p_id=>5559331571499709 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>0,
  p_option_sequence=>10,
  p_short_name=>'Patientenliste',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::',
  p_page_id=>130,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8719030304891626 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>' &P1_NV_FRAGEBOGEN.	',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::',
  p_page_id=>33,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8719203423893299 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>' &P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:::',
  p_page_id=>34,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8719408271894718 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>0,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:::',
  p_page_id=>35,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5557718318439050 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5559331571499709 + wwv_flow_api.g_id_offset,
  p_option_sequence=>20,
  p_short_name=>'Laborauftragsübersicht',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:322:&SESSION.::&DEBUG.:::',
  p_page_id=>322,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557718318439050 + wwv_flow_api.g_id_offset,
  p_option_sequence=>30,
  p_short_name=>'Laborwerte',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:323:&SESSION.::&DEBUG.:::',
  p_page_id=>323,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5558104035453849 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::',
  p_page_id=>1,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5563924935743756 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::',
  p_page_id=>2,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5564310867749191 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::',
  p_page_id=>3,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5564517101750920 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::',
  p_page_id=>4,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5564721603752209 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::',
  p_page_id=>5,
  p_also_current_for_pages=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_menu_option (
  p_id=>5564927144753842 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::',
  p_page_id=>6,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5565100609755701 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:::',
  p_page_id=>7,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5565718271760753 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::',
  p_page_id=>8,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5565924851762605 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::',
  p_page_id=>9,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5566131084764489 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>40,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::',
  p_page_id=>10,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5566519441770571 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>50,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::',
  p_page_id=>31,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8677515469641342 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>50,
  p_short_name=>' &P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:::',
  p_page_id=>32,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5567524420781458 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>60,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:::',
  p_page_id=>90,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5567729268782819 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>60,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::',
  p_page_id=>91,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5567903773784976 + wwv_flow_api.g_id_offset,
  p_menu_id=>5557414378428469 + wwv_flow_api.g_id_offset,
  p_parent_id=>5557901826443747 + wwv_flow_api.g_id_offset,
  p_option_sequence=>60,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::',
  p_page_id=>95,
  p_also_current_for_pages=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_menu (
  p_id=> 6313313272633459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=> 'Navigation 01');
 
wwv_flow_api.create_menu_option (
  p_id=>1122816365655248 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>7856503033003725 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P305_NV_WK_KASSE.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:305:&SESSION.::&DEBUG.:::',
  p_page_id=>305,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2047900363001715 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3170228890786593 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P201_NV_VERORDNUNG.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:203:&SESSION.::&DEBUG.:::',
  p_page_id=>203,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2362915124581490 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>2154132006926398 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P301_NV_ADRESSLISTE.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:::',
  p_page_id=>301,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2394215456024639 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>2362915124581490 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P302_NV_ADRESSSTAMM.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:::',
  p_page_id=>302,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2515324028746443 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>2154132006926398 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P303_NV_VERORDNUNG.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:303:&SESSION.::&DEBUG.:::',
  p_page_id=>303,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2985404522016942 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:::',
  p_page_id=>7,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>0,
  p_option_sequence=>10,
  p_short_name=>'&P130_NV_PATIENTENLISTE.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:110, 140, 201, 202, 215,300,1,130::',
  p_page_id=>130,
  p_display_when_cond_type=>'PLSQL_EXPRESSION',
  p_display_when_condition=>':fas_aufgerufen_von = ''BETREUER''',
  p_display_when_condition2=>'',
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3168215298534582 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P110_NV_PATIENT.',
  p_long_name=>'Patienten Stammdaten',
  p_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:140, 201, 202, 215::',
  p_page_id=>110,
  p_display_when_cond_type=>'PLSQL_EXPRESSION',
  p_display_when_condition=>':fas_aufgerufen_von !=''PIS''',
  p_display_when_condition2=>'',
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3168723887576232 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3168215298534582 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P133_NV_AUSWAHL_ADRESSE.',
  p_long_name=>'Auswahlliste Rechnungsempfänger',
  p_link=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:::',
  p_page_id=>133,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3168215298534582 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P140_NV_PATIENTEN_UEBERSICHT.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:201, 202, 215,250::',
  p_page_id=>140,
  p_display_when_cond_type=>'PLSQL_EXPRESSION',
  p_display_when_condition=>':fas_aufgerufen_von !=''PIS''',
  p_display_when_condition2=>'',
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3169815747777537 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P201_NV_REZEPTKOPF.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:::',
  p_page_id=>201,
  p_also_current_for_pages=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_menu_option (
  p_id=>3170228890786593 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169815747777537 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P201_NV_RZEPTDETAILS.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:202:&SESSION.::&DEBUG.:::',
  p_page_id=>202,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3170816511898735 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P145_NV_OTA_REZEPTSUCHE.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.:::',
  p_page_id=>145,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3171220380912079 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::',
  p_page_id=>1,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3171612185915939 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::',
  p_page_id=>2,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3172031582922107 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::',
  p_page_id=>3,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3172425328925039 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::',
  p_page_id=>4,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3172818642928123 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::',
  p_page_id=>6,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3174016474944370 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P132_NV_KONFIGURATION.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:::',
  p_page_id=>132,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3947118022972612 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P260_NV_PROVISIONSUEBERSICHT.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:::',
  p_page_id=>260,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>4078029687804621 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P250_NV_EOVITAL_PROGRAMM.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:250:&SESSION.::&DEBUG.:::',
  p_page_id=>250,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>4295307658315779 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Warenkorbübersicht',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:320:&SESSION.::&DEBUG.:::',
  p_page_id=>320,
  p_also_current_for_pages=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_menu_option (
  p_id=>4295427337315779 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>4295307658315779 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Warenkorbdetails',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:321:&SESSION.::&DEBUG.:::',
  p_page_id=>321,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5208624957566599 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P350_NV_SB_AUFTRAEGE.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:350:&SESSION.::&DEBUG.:::',
  p_page_id=>350,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5209704876606259 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>5208624957566599 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Auftragdetails',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:351:&SESSION.::&DEBUG.:::',
  p_page_id=>351,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5210521889628815 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>5209704876606259 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Detailsatz',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:::',
  p_page_id=>352,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5402430709760795 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>5208624957566599 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Auftragdetails',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:355:&SESSION.::&DEBUG.:::',
  p_page_id=>355,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5431520257946646 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::',
  p_page_id=>5,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5519621462996417 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Laborwerte',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:324:&SESSION.::&DEBUG.:::',
  p_page_id=>324,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5519907657020772 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Laborauftragsübersicht',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:322:&SESSION.::&DEBUG.:::',
  p_page_id=>322,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5726208780741083 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>5402430709760795 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Auftragsbilder',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:357:&SESSION.::&DEBUG.:::',
  p_page_id=>357,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5726520583741086 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>5726208780741083 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Auftragsbild bearbeiten',
  p_long_name=>'',
  p_link=>'f?p=&FLOW_ID.:358:&SESSION.',
  p_page_id=>358,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5927028464548254 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::',
  p_page_id=>95,
  p_also_current_for_pages=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_menu_option (
  p_id=>5927616794584034 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::',
  p_page_id=>31,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5928200835591445 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::',
  p_page_id=>8,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5929200392606776 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::',
  p_page_id=>9,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>5929921514612167 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::',
  p_page_id=>10,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>6053618212343768 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P400_NV_SERIENBRIEFE.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::',
  p_page_id=>400,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>6076613229126235 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>6053618212343768 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P401_NV_SB_ERSTELLEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::',
  p_page_id=>401,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>6452224726536138 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P402_NV_SB_SERIENBRIEF_INTERN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:402:&SESSION.',
  p_page_id=>402,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>6454900767607799 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>6452224726536138 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Serienbrief Intern Identitäten Zuordnung',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:403:&SESSION.',
  p_page_id=>403,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>6592922596258120 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P141_NV_PATIENTEN_UEBERSICHT.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:::',
  p_page_id=>141,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>6670515272843607 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>2154132006926398 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P304_NV_PATIENT.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:::',
  p_page_id=>304,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>6908505861428736 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P135_NV_IDENTLISTE.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:135:&SESSION.::&DEBUG.:135::',
  p_page_id=>135,
  p_also_current_for_pages=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_menu_option (
  p_id=>6911515090497605 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>6908505861428736 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P500_NV_WARENKORB.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:::',
  p_page_id=>500,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>7400323848659359 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Provisionshierarchie',
  p_long_name=>'',
  p_link=>'f?p=&FLOW_ID.:261:&SESSION.',
  p_page_id=>261,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>7407701000691452 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P136_REGION_TITEL_ADRESSEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:136:&SESSION.::&DEBUG.:::',
  p_page_id=>136,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>7856503033003725 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>2154132006926398 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P308_NV_WK_VERSAND.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:308:&SESSION.::&DEBUG.:::',
  p_page_id=>308,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8137331288775137 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>6911515090497605 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P508_NV_WK_VERSAND.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:508:&SESSION.::&DEBUG.:::',
  p_page_id=>508,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8137732159813241 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>8137331288775137 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P505_NV_WK_KASSE.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:505:&SESSION.::&DEBUG.:505::',
  p_page_id=>505,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8402608886565865 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Laborschnittstelle',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:326:&SESSION.::&DEBUG.:RP::',
  p_page_id=>326,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8677916985651172 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:::',
  p_page_id=>32,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8696010809826311 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>' &P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&FLOW_ID.:33:&SESSION.',
  p_page_id=>33,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8718609872885749 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>' &P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:::',
  p_page_id=>34,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>8718815066887248 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>' &P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:::',
  p_page_id=>35,
  p_also_current_for_pages=> '');
 
null;
 
end;
/

 
begin
 
wwv_flow_api.create_menu_option (
  p_id=>10241607548416318 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>5519907657020772 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Laboraustausch Dateien',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:327:&SESSION.',
  p_page_id=>327,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>18559925996216845 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>5519621462996417 + wwv_flow_api.g_id_offset,
  p_option_sequence=>10,
  p_short_name=>'Labor-WK-FB-Zuordnung',
  p_long_name=>'',
  p_link=>'f?p=&FLOW_ID.:329:&SESSION.',
  p_page_id=>329,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3173205703934118 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>11,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:::',
  p_page_id=>90,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>3173631354937442 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3169216000731840 + wwv_flow_api.g_id_offset,
  p_option_sequence=>12,
  p_short_name=>'&P1_NV_FRAGEBOGEN.',
  p_long_name=>'',
  p_link=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::',
  p_page_id=>91,
  p_also_current_for_pages=> '');
 
wwv_flow_api.create_menu_option (
  p_id=>2154132006926398 + wwv_flow_api.g_id_offset,
  p_menu_id=>6313313272633459 + wwv_flow_api.g_id_offset,
  p_parent_id=>3167825446514740 + wwv_flow_api.g_id_offset,
  p_option_sequence=>20,
  p_short_name=>'&P300_NV_WARENKORB.',
  p_long_name=>'Warenkorb',
  p_link=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:::',
  p_page_id=>300,
  p_also_current_for_pages=> '');
 
null;
 
end;
/

prompt  ...page templates for application: 102
--
--application/shared_components/user_interface/templates/page/no_tabs_with_sidebar
prompt  ......Page template 2778622263266410
 
begin
 
wwv_flow_api.create_template (
  p_id => 2778622263266410 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 15
 ,p_name => 'No Tabs With Sidebar'
 ,p_is_popup => false
 ,p_body_title => '#BODY_TITLE#'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><div class="t15logo">#LOGO#</div><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td><div class="t15NavBar"><span class="t15NavBarItem">&USER.</span>#NAVIGATION_BAR#</div><br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'<table summary="" cellpadding="0'||
'" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" class="t15pagelinecenter"><img src="#IMAGE_PREFIX#themes/theme_15/page_line_center.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr class="t15PageTopLine">'||unistr('\000a')||
'<td>#REGION_POSITION_01#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<table width="100%" summary="" height="70%" cellspacing="0" cellpadding="0" border="0">'||unistr('\000a')||
'	<tr>'||unistr('\000a')||
'        <td valign="top"><table cellspacing="0" cell'||
'padding="0" border="0" class="t15Sidebar" summary="">'||unistr('\000a')||
'<td class="L"><img src="#IMAGE_PREFIX#themes/theme_15/left_curve.gif" alt=""/></td>'||unistr('\000a')||
'<td class="C" width="100%"><br /></td>'||unistr('\000a')||
'<td class="R" align="right"><img src="#IMAGE_PREFIX#themes/theme_15/right_curve.gif" alt=""/></td>'||unistr('\000a')||
'<tr><td colspan="3" class="B">#REGION_POSITION_02#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="L"><img src="#IMAGE_PREFIX#themes/theme_15/left'||
'_curve_bottom.gif" alt=""/></td>'||unistr('\000a')||
'<td class="C" width="100%"><br /></td>'||unistr('\000a')||
'<td class="R" align="right"><img src="#IMAGE_PREFIX#themes/theme_15/right_curve_bottom.gif" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'	<td align="right" valign="top"><img src="#IMAGE_PREFIX#f_spacer.gif" width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td class="t15PageBody"><div class="t15Messages" align="center">#GLOBAL_NOTIFICATION##NOTIFICA'||
'TION_MESSAGE##SUCCESS_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'	<td align="right" valign="top"><img src="#IMAGE_PREFIX#f_spacer.gif" width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td class="t15RightBar" align="right" valign="top">#REGION_POSITION_03#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<hr />'||unistr('\000a')||
'<div class="t15customize">#CUSTOMIZE#</div>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t15Success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t15Notification">#MESSAGE#</div>'||unistr('\000a')||
''
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t15NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%"  summary=""'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 17
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs
prompt  ......Page template 2778820988266420
 
begin
 
wwv_flow_api.create_template (
  p_id => 2778820988266420 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 15
 ,p_name => 'Two Level Tabs'
 ,p_is_popup => false
 ,p_body_title => '<!--#BODY_TITLE#-->'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="97%" align="center">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><div class="t15logo">#LOGO#</div><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td><div class="t15NavBar"><span class="t15NavBarItem">&USER.</span>#NAVIGATION_BAR#</div><br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'<table summary="" '||
'cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr><td width="100%"><br /></td>#PARENT_TAB_CELLS#</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" style="background-color:#336699">#TAB_CELLS#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr class="t15PageTopLine"><td>#REGION_POSITION_01#</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<table width="100%" summary'||
'="" height="70%" cellspacing="0" cellpadding="0" border="0">'||unistr('\000a')||
'	<tr>'||unistr('\000a')||
'	<td align="right" valign="top"><img src="#IMAGE_PREFIX#f_spacer.gif" width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td class="t15PageBody"><div class="t15Messages" align="center">#GLOBAL_NOTIFICATION##NOTIFICATION_MESSAGE##SUCCESS_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'	<td align="right" valign="top"><img sr'||
'c="#IMAGE_PREFIX#f_spacer.gif" width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td class="t15RightBar" align="right" valign="top">#REGION_POSITION_03#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<hr />'||unistr('\000a')||
'<div class="t15customize">#CUSTOMIZE#</div>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t15Success">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''
 ,p_current_tab => '<a class="t15ChildTabCurrent" href="#TAB_LINK#">#TAB_LABEL#</a>'
 ,p_non_current_tab => '<a class="t15ChildTab" href="#TAB_LINK#">#TAB_LABEL#</a>'
 ,p_top_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_open_c.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15CurrentTabCenter"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_close_c.gif" alt="" /></td>'
 ,p_top_non_curr_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_open.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15TabCenter"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_close.gif" alt="" /></td>'
 ,p_notification_message => '<div class="t15Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t15NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" summary=""'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 2
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/printer_friendly
prompt  ......Page template 2779110374266420
 
begin
 
wwv_flow_api.create_template (
  p_id => 2779110374266420 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 15
 ,p_name => 'Printer Friendly'
 ,p_is_popup => false
 ,p_body_title => '<!--#BODY_TITLE#-->'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top">'||unistr('\000a')||
'<div style="border:1px solid black;">#SUCCESS_MESSAG'||
'E##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#REGION_POSITION_05#'
 ,p_footer_template => 
'#FORM_CLOSE#'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t15Success">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t15Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t15NavBarItem">#TEXT#</a>'
 ,p_region_table_cattributes => 'width="100%"'
 ,p_theme_class_id => 5
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs
prompt  ......Page template 2779420236266420
 
begin
 
wwv_flow_api.create_template (
  p_id => 2779420236266420 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 15
 ,p_name => 'One Level Tabs'
 ,p_is_popup => false
 ,p_body_title => '#BODY_TITLE#'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><div class="t15logo">#LOGO#</div><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td><div class="t15NavBar"><span class="t15NavBarItem">&USER.</span>#NAVIGATION_BAR#</div><br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'<table summary="" cellpadding="0'||
'" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr><td width="100%"><br /></td>#TAB_CELLS#</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" class="t15pagelinecenter"><img src="#IMAGE_PREFIX#themes/theme_15/page_line_center.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr class="t15PageTopLine"><td>#REGION_POSITION_01#</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<b'||
'r />'||unistr('\000a')||
'<table width="100%" summary="" height="70%" cellspacing="0" cellpadding="0" border="0">'||unistr('\000a')||
'	<tr>'||unistr('\000a')||
'	<td class="t15PageBody"><div class="t15Messages" align="center">#GLOBAL_NOTIFICATION##NOTIFICATION_MESSAGE##SUCCESS_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'	<td align="right" valign="top"><img src="#IMAGE_PREFIX#f_spacer.gif" width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td cl'||
'ass="t15RightBar" align="right" valign="top">#REGION_POSITION_03#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<hr />'||unistr('\000a')||
'<div class="t15customize">#CUSTOMIZE#</div>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t15Success">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''
 ,p_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_open_c.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15CurrentTabCenter"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_close_c.gif" alt="" /></td>'
 ,p_non_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_open.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15TabCenter"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_close.gif" alt="" /></td>'
 ,p_notification_message => '<div class="t15Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t15NavBarItem">#TEXT#</a>'
 ,p_region_table_cattributes => 'width="100%" summary=""'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs
prompt  ......Page template 2779717929266420
 
begin
 
wwv_flow_api.create_template (
  p_id => 2779717929266420 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 15
 ,p_name => 'No Tabs'
 ,p_is_popup => false
 ,p_body_title => '#BODY_TITLE#'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><div class="t15logo">#LOGO#</div><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td><div class="t15NavBar"><span class="t15NavBarItem">&USER.</span>#NAVIGATION_BAR#</div><br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'<table summary="" cellpadding="0'||
'" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" class="t15pagelinecenter"><img src="#IMAGE_PREFIX#themes/theme_15/page_line_center.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr class="t15PageTopLine">'||unistr('\000a')||
'<td>#REGION_POSITION_01#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<table width="100%" summary="" height="70%" cellspacing="0" cellpadding="0" border="0">'||unistr('\000a')||
'	<tr>'||unistr('\000a')||
'	<td class="t15PageBody"><div class="t15Messages" al'||
'ign="center">#GLOBAL_NOTIFICATION##NOTIFICATION_MESSAGE##SUCCESS_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'	<td align="right" valign="top"><img src="#IMAGE_PREFIX#f_spacer.gif" width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td class="t15RightBar" align="right" valign="top">#REGION_POSITION_03#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<hr />'||unistr('\000a')||
'<div class="t15customize">#CUSTOMIZE#</div>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t15Success">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t15Notification">#MESSAGE#</div>'||unistr('\000a')||
''
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t15NavBarItem">#TEXT#</a>'
 ,p_region_table_cattributes => 'width="100%" summary=""'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 3
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs_with_sidebar
prompt  ......Page template 2780030592266421
 
begin
 
wwv_flow_api.create_template (
  p_id => 2780030592266421 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 15
 ,p_name => 'One Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_body_title => '#BODY_TITLE#'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="97%" align="center">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><div class="t15logo">#LOGO#</div><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td><div class="t15NavBar"><span class="t15NavBarItem">&USER.</span>#NAVIGATION_BAR#</div><br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'<table summary="" '||
'cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr><td width="100%"><br /></td>#TAB_CELLS#</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" class="t15pagelinecenter"><img src="#IMAGE_PREFIX#themes/theme_15/page_line_center.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr class="t15PageTopLine"><td>#REGION_POSITION_01#</td></t'||
'r>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<table width="100%" summary="" height="70%" cellspacing="0" cellpadding="0" border="0">'||unistr('\000a')||
'	<tr>'||unistr('\000a')||
'        <td valign="top">'||unistr('\000a')||
'<table cellspacing="0" cellpadding="0" border="0" class="t15Sidebar" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="L"><img src="#IMAGE_PREFIX#themes/theme_15/left_curve.gif" alt=""/></td>'||unistr('\000a')||
'<td class="C" width="100%"><br /></td>'||unistr('\000a')||
'<td class="R" align="right"><img src="#IMAGE_PREFIX#'||
'themes/theme_15/right_curve.gif" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr><td colspan="3" class="B">#REGION_POSITION_02#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="L"><img src="#IMAGE_PREFIX#themes/theme_15/left_curve_bottom.gif" alt=""/></td>'||unistr('\000a')||
'<td class="C" width="100%"><br /></td>'||unistr('\000a')||
'<td class="R" align="right"><img src="#IMAGE_PREFIX#themes/theme_15/right_curve_bottom.gif" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'	<td align="right" valig'||
'n="top"><img src="#IMAGE_PREFIX#f_spacer.gif" width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td class="t15PageBody"><div class="t15Messages" align="center">#GLOBAL_NOTIFICATION##NOTIFICATION_MESSAGE##SUCCESS_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'	<td align="right" valign="top"><img src="#IMAGE_PREFIX#f_spacer.gif" width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td class="t15RightBar" align="right" vali'||
'gn="top">#REGION_POSITION_03#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<hr />'||unistr('\000a')||
'<div class="t15customize">#CUSTOMIZE#</div>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t15Success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_open_c.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15CurrentTabCenter"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_close_c.gif" alt="" /></td>'
 ,p_non_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_open.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15TabCenter"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_close.gif" alt="" /></td>'
 ,p_notification_message => '<div class="t15Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t15NavBarItem">#TEXT#</a>'
 ,p_region_table_cattributes => 'width="100%"  summary=""'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 16
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs_with_side_bar
prompt  ......Page template 2780308706266423
 
begin
 
wwv_flow_api.create_template (
  p_id => 2780308706266423 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 15
 ,p_name => 'Two Level Tabs with Side Bar'
 ,p_is_popup => false
 ,p_body_title => '<!--#BODY_TITLE#-->'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="97%" align="center">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><div class="t15logo">#LOGO#</div><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td><div class="t15NavBar"><span class="t15NavBarItem">&USER.</span>#NAVIGATION_BAR#</div><br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'<table summary="" '||
'cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr><td width="100%"><br /></td>#PARENT_TAB_CELLS#</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" style="background-color:#336699">#TAB_CELLS#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr class="t15PageTopLine"><td>#REGION_POSITION_01#</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<table width="100%" summary'||
'="" height="70%" cellspacing="0" cellpadding="0" border="0">'||unistr('\000a')||
'	<tr>'||unistr('\000a')||
'        <td valign="top">'||unistr('\000a')||
'<table cellspacing="0" cellpadding="0" border="0" class="t15Sidebar" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="L"><img src="#IMAGE_PREFIX#themes/theme_15/left_curve.gif" alt=""/></td>'||unistr('\000a')||
'<td class="C" width="100%"><br /></td>'||unistr('\000a')||
'<td class="R" align="right"><img src="#IMAGE_PREFIX#themes/theme_15/right_curve.gif" alt=""/></td>'||
''||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr><td colspan="3" class="B">#REGION_POSITION_02#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="L"><img src="#IMAGE_PREFIX#themes/theme_15/left_curve_bottom.gif" alt=""/></td>'||unistr('\000a')||
'<td class="C" width="100%"><br /></td>'||unistr('\000a')||
'<td class="R" align="right"><img src="#IMAGE_PREFIX#themes/theme_15/right_curve_bottom.gif" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'	<td align="right" valign="top"><img src="#IMAGE_PREFIX#f_spacer.gif" '||
'width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td class="t15PageBody"><div class="t15Messages" align="center">#GLOBAL_NOTIFICATION##NOTIFICATION_MESSAGE##SUCCESS_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'	<td align="right" valign="top"><img src="#IMAGE_PREFIX#f_spacer.gif" width="15" height="3" alt="" /></td>'||unistr('\000a')||
'	<td class="t15RightBar" align="right" valign="top">#REGION_POSITION_03#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tab'||
'le>'
 ,p_footer_template => 
'<hr />'||unistr('\000a')||
'<div class="t15customize">#CUSTOMIZE#</div>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t15Success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<a class="t15ChildTabCurrent" href="#TAB_LINK#">#TAB_LABEL#</a>'
 ,p_non_current_tab => '<a class="t15ChildTab" href="#TAB_LINK#">#TAB_LABEL#</a>'
 ,p_top_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_open_c.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15CurrentTabCenter"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_close_c.gif" alt="" /></td>'
 ,p_top_non_curr_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_open.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15TabCenter"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_15/tab_close.gif" alt="" /></td>'
 ,p_notification_message => '<div class="t15Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t15NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" summary=""'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 18
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup
prompt  ......Page template 2780617608266423
 
begin
 
wwv_flow_api.create_template (
  p_id => 2780617608266423 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 15
 ,p_name => 'Popup'
 ,p_is_popup => false
 ,p_body_title => '#BODY_TITLE#'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<div style="padding:10px;text-align:left;" valign="top">#BOX_BODY#</div>'||unistr('\000a')||
''
 ,p_footer_template => 
'#FORM_CLOSE#'||unistr('\000a')||
''||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body> '||unistr('\000a')||
'</html>'||unistr('\000a')||
''
 ,p_success_message => '<div class="t15Success">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_notification_message => '<div class="t15Notification">#MESSAGE#</b>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t15NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%"'
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/login
prompt  ......Page template 2780916469266423
 
begin
 
wwv_flow_api.create_template (
  p_id => 2780916469266423 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 15
 ,p_name => 'Login'
 ,p_is_popup => false
 ,p_body_title => '#BODY_TITLE#'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'#NOTIFICATION_MESSAGE##SUCCESS_MESSAGE#'||unistr('\000a')||
'<table border="0" summary="" align="center" style="margin:100px auto;width:50%;">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td>#BOX_BODY#'||unistr('\000a')||
'#REGION_POSITION_01#'||unistr('\000a')||
'#REGION_POSITION_02#'||unistr('\000a')||
'#REGION_POSITION_03#'||unistr('\000a')||
'#REGION_POSITION_04#'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#REGION_POSITION_06#'||unistr('\000a')||
'#REGION_POSITION_07#'||unistr('\000a')||
'#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_footer_template => 
'#FORM_CLOSE#'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t15Notification">#MESSAGE#</div>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%"'
 ,p_theme_class_id => 6
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs
prompt  ......Page template 2799615122273775
 
begin
 
wwv_flow_api.create_template (
  p_id => 2799615122273775 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 8
 ,p_name => 'Two Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE.">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<table width="100%" height="51" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr valign="middle"> '||unistr('\000a')||
'<td height="28" class="t8TopBar" valign="top"><div id="t8Logo">#LOGO#</div><table border="0" cellpadding="0" cellspacing="0" align="left" valign="top" summary=""><tr><td><br /></td>#PARENT_TAB_CELLS#</tr></table><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" class="t8TopBar" valign="top">'||
'#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="28" class="t8TopBar" align="right" valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td colspan="3" class="t8TopBarBottom"><img src="#IMAGE_PREFIX#themes/theme_8/t3top_bg_stripe.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3" class="t8ChildTabs"><table border="0" cellpadding="0" cellspacing="0" align="left" summary=""><tr><td><br /></td>'||
'#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" height="90%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td height="4" style="background-color:E5E5DC; border-right: 1px #BFBFB8;"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="4" style="background-color:BFBFB8"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" wi'||
'dth="1" height="1" alt=""  /></td>'||unistr('\000a')||
'<td height="4" style="background-color:BFBFB8"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="1" style="background-color:FFFFFF"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td width="100%" align="center" valign="top">'||unistr('\000a')||
'	<!-- BEGIN FRAME -->'||unistr('\000a')||
'<table height="98%'||
'" border="0" align="center" cellpadding="0" cellspacing="0" style="background-color:E5E5DC;" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="21" colspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<!-- BEGIN TITLE -->#REGION_POSITION_01#<!-- END TITLE -->'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td colspan="3" height="7"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt='||
'"" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="26" height="100%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'<td align="center" valign="top" width="100%" style="background-color:BFBFB8" class="t8contentborder"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t8messages">#GLOBAL_NOTIFICATION##SUC'||
'CESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'<td width="26" height="100%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" align="right" valign="middle" colspan="3" class="t8copyright"><span class="t8User">&APP_U'||
'SER.</span><!-- Copyright --><span class="t8Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<div class="t8PageBottom"><img src="#IMAGE_PREFIX#themes/theme_8/t3bottom_bg_stripe.gif" alt="" /></div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t8success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt="" /></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt="" /></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_non_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" class="t8standardtab">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_right.gif" width="2" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt="" /></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt="" /></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
''
 ,p_top_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt="" /></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt="" /></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_top_non_curr_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" class="t8standardtab" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_left.gif" width="2" height="18" alt="" /></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_right.gif" width="2" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt="" /></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt="" /></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_notification_message => '<div class="t8notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t8NavigationBar"><table border="0" cellspacing="0" cellpadding="0" summary="" align="right"><tr><td><br /></td>#BAR_BODY#</tr></table></div>'
 ,p_navbar_entry => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#LINK#" class="t8btn" style="white-space:nowrap;">#TEXT#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 2
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs
prompt  ......Page template 2799805029273775
 
begin
 
wwv_flow_api.create_template (
  p_id => 2799805029273775 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 8
 ,p_name => 'One Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE.">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<!-- BEGIN HEADER height="51" -->'||unistr('\000a')||
'<table width="100%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr><td class="t8TopBar" valign="top"><table border="0" cellpadding="0" cellspacing="0" summary=""><tr>'||unistr('\000a')||
'<td valign="top"><div id="t8Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr></table>'||unistr('\000a')||
'<t'||
'able border="0" cellpadding="0" cellspacing="0" summary="" width="100%"><tr><td width="100%"><br/></td>#TAB_CELLS#</tr></table></td></tr>'||unistr('\000a')||
'<tr><td class="t8TopBarBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="11" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END HEADER -->'||unistr('\000a')||
'<!-- BEGIN BODY -->'||unistr('\000a')||
'<table width="100%" height="90%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<'||
'!-- tr>'||unistr('\000a')||
'<td height="4" style="background-color:#BFBFB8"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr -->'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="100%" align="center" valign="top" style="background-color:#E5E5DC;">'||unistr('\000a')||
'<!-- BEGIN FRAME -->'||unistr('\000a')||
'<table width="100%" height="100%" border="0" align="center" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td colspan="3" height="21"><im'||
'g src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#REGION_POSITION_01#'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td colspan="3" height="7"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="26" height="100%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'<td align="center" valign="top" style="b'||
'ackground-color:#BFBFB8" class="t8contentborder"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div '||unistr('\000a')||
'class="t8messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'<td width="26" height="10'||
'0%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<!-- BEGIN COPYRIGHT -->'||unistr('\000a')||
'<td colspan="3" height="41" align="right" valign="middle" style="background-color:#E5E5DC" class="t8copyright"><span class="t8User">&APP_USER.</span><!-- Copyright --><span class="t8Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'<!-- END COPYRIGHT -->'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END FRAME -'||
'->'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'
 ,p_footer_template => 
'<div class="t8PageBottom"><img src="#IMAGE_PREFIX#themes/theme_8/t3bottom_bg_stripe.gif" alt="" /></div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t8success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
''
 ,p_non_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" class="t8standardtab" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_notification_message => '<div class="t8notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t8NavigationBar"><table border="0" cellspacing="0" cellpadding="0" summary=""><tr><td></td>#BAR_BODY#</tr></table></div>'
 ,p_navbar_entry => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#LINK#" class="t8btn" style="white-space:nowrap;">#TEXT#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/login
prompt  ......Page template 2800126981273775
 
begin
 
wwv_flow_api.create_template (
  p_id => 2800126981273775 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 8
 ,p_name => 'Login'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE.">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<div class="t8messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<table border="0" summary="" width="100%" style="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="center">'||unistr('\000a')||
'<table cellpadding="0" cellspacing="0" border="1" summary="" class="t8WizardRegion" style="width:300px;top:100px;">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt=""'||
' style="margin-right:5px;" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BOX_BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_footer_template => 
'#FORM_CLOSE#'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'||unistr('\000a')||
''
 ,p_success_message => '<div class="t8SuccessMessage">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t8notification">#MESSAGE#</div>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_theme_class_id => 6
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '18'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs_with_side_bar
prompt  ......Page template 2800409142273776
 
begin
 
wwv_flow_api.create_template (
  p_id => 2800409142273776 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 8
 ,p_name => 'Two Level Tabs with Side Bar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE.">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<table width="100%" height="51" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr valign="middle"> '||unistr('\000a')||
'<td height="28" class="t8TopBar" valign="top"><div id="t8Logo">#LOGO#</div><table border="0" cellpadding="0" cellspacing="0" align="left" valign="top" summary=""><tr><td><br /></td>#PARENT_TAB_CELLS#</tr></table><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" class="t8TopBar" valign="top">'||
'#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="28" class="t8TopBar" align="right" valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td colspan="3" class="t8TopBarBottom"><img src="#IMAGE_PREFIX#themes/theme_8/t3top_bg_stripe.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3" class="t8ChildTabs"><table border="0" cellpadding="0" cellspacing="0" align="left" summary=""><tr><td><br /></td>'||
'#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" height="90%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td height="4" style="background-color:#E5E5DC; border-right: 1px #BFBFB8 solid;"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="4" style="background-color:#BFBFB8"><img src="#IMAGE_PREFIX#themes/theme_8/spacer'||
'.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="4" style="background-color:#BFBFB8"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td class="t8NavBar" valign="top"><!-- BEGIN LEFT NAV -->#REGION_POSITION_02#<!-- END LEFT NAV --></td>'||unistr('\000a')||
'<td width="1" style="background-color:#FFFFFF"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1"'||
' height="1" alt="" /></td>'||unistr('\000a')||
'<td width="100%" align="center" valign="top">'||unistr('\000a')||
'<!-- BEGIN FRAME -->'||unistr('\000a')||
'<table width="98%" height="98%" border="0" align="center" cellpadding="0" cellspacing="0" class="t8contentborder" style="margin-top: 5px;" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="26" height="21" style="background-color:#E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<t'||
'd height="21" style="background-color:#E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td width="26" height="21" style="background-color:#E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#REGION_POSITION_01#'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="26" height="7" style="background-color:#E5E5DC"><img src="#IMAGE_PREFIX#the'||
'mes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="7" style="background-color:#E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td width="26" height="7" style="background-color:#E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="26" height="100%" style="background-'||
'color:#E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#BFBFB8" class="t8contentborder"><table style="background-color:#BFBFB8"  summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t8messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##N'||
'OTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'<td width="26" height="100%" style="background-color:#E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="'||
'1" height="1" alt="" /></td>'||unistr('\000a')||
'<!-- BEGIN COPYRIGHT -->'||unistr('\000a')||
'<td height="41" align="right" valign="middle" style="background-color:#E5E5DC" class="t8copyright"><span class="t8User">&APP_USER.</span><!-- Copyright --><span class="t8Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'<!-- END COPYRIGHT -->'||unistr('\000a')||
'<td height="41" style="background-color:#E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="'||
'1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END FRAME -->'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'
 ,p_footer_template => 
'<div class="t8PageBottom"><img src="#IMAGE_PREFIX#themes/theme_8/t3bottom_bg_stripe.gif" alt="" /></div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t8success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_non_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" class="t8standardtab" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_top_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_top_non_curr_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" class="t8standardtab" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_notification_message => '<div class="t8notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t8NavigationBar"><table border="0" cellspacing="0" cellpadding="0" summary="" align="right"><tr><td></td>#BAR_BODY#</tr></table></div>'
 ,p_navbar_entry => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#LINK#" class="t8btn" style="white-space:nowrap;">#TEXT#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 18
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs_with_side_bar
prompt  ......Page template 2800713367273778
 
begin
 
wwv_flow_api.create_template (
  p_id => 2800713367273778 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 8
 ,p_name => 'One Level Tabs with Side Bar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE.">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{background-image:url();border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<!-- BEGIN HEADER height="51" -->'||unistr('\000a')||
'<table width="100%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr><td class="t8TopBar" valign="top"><table border="0" cellpadding="0" cellspacing="0" summary=""><tr>'||unistr('\000a')||
'<td valign="top"><div id="t8Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr></table>'||unistr('\000a')||
'<t'||
'able border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr><td width="100%"><br/></td>#TAB_CELLS#</tr></table></td></tr>'||unistr('\000a')||
'<tr><td class="t8TopBarBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="11" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END HEADER -->'||unistr('\000a')||
'<!-- BEGIN BODY -->'||unistr('\000a')||
'<table width="100%" height="90%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
''||
'<tr>'||unistr('\000a')||
'<td height="4" style="background-color:#E5E5DC; border-right: 1px #BFBFB8 solid;"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="4" style="background-color:#BFBFB8"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="4" style="background-color:#BFBFB8"><img src="#IMAGE_PREFIX#themes/theme_8/spac'||
'er.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td class="t8NavBar" valign="top"><!-- BEGIN LEFT NAV -->#REGION_POSITION_02#<!-- END LEFT NAV --></td>'||unistr('\000a')||
'<td width="1" style="background-color:#FFFFFF"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td width="100%" align="center" valign="top">'||unistr('\000a')||
'<!-- BEGIN FRAME -->'||unistr('\000a')||
'<table width="98%" height="98%" border='||
'"0" align="center" cellpadding="0" cellspacing="0" class="t8contentborder" style="margin-top: 5px;background-color:#E5E5DC" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="21" colspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#REGION_POSITION_01#'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="7" colspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></'||
'td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="26" height="100%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'<td align="center" valign="top" width="100%" style="background-color:#BFBFB8" class="t8contentborder"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t8messages">#GLOBAL_NOTIFICATION##SUCCESS_M'||
'ESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'<td width="26" height="100%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" align="right" valign="middle" colspan="3" class="t8copyright"><span class="t8User">&APP_USER.</span><!-- Copyright '||
'--><span class="t8Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END FRAME -->'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'
 ,p_footer_template => 
'<div class="t8PageBottom"><img src="#IMAGE_PREFIX#themes/theme_8/t3bottom_bg_stripe.gif" alt="" /></div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t8success">SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14"  alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14"  alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_non_current_tab => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" class="t8standardtab" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_orange_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#TAB_LINK#" class="t8btn">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_notification_message => '<div class="t8notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t8NavigationBar"><table border="0" cellspacing="0" cellpadding="0" summary=""><tr><td></td>#BAR_BODY#</tr></table></div>'
 ,p_navbar_entry => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#LINK#" class="t8btn" style="white-space:nowrap;">#TEXT#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 16
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/printer_friendly
prompt  ......Page template 2801022383273778
 
begin
 
wwv_flow_api.create_template (
  p_id => 2801022383273778 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 8
 ,p_name => 'Printer Friendly'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE.">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top">'||unistr('\000a')||
'<div style="border:1px solid black;">#SUCCESS_MESSAG'||
'E##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#REGION_POSITION_05#'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t8success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t8notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t8NavigationBar">#BAR_BODY#</div>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_theme_class_id => 5
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '3'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs_with_side_bar
prompt  ......Page template 2801330409273779
 
begin
 
wwv_flow_api.create_template (
  p_id => 2801330409273779 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 8
 ,p_name => 'No Tabs with Side Bar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE.">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<!-- BEGIN HEADER height="51" -->'||unistr('\000a')||
'<table width="100%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr><td class="t8TopBar" valign="top"><table border="0" cellpadding="0" cellspacing="0" summary=""><tr>'||unistr('\000a')||
'<td valign="top"><div id="t8Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr></table></t'||
'd></tr>'||unistr('\000a')||
'<tr><td class="t8TopBarBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="11" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" height="90%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td height="4" style="background-color:E5E5DC; border-right: 1px #BFBFB8;"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td '||
'height="4" style="background-color:BFBFB8"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td height="4" style="background-color:BFBFB8"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="left" valign="top" class="t8NavBar"><!-- BEGIN LEFT NAV -->#REGION_POSITION_02#<!-- END LEFT NAV --></td>'||unistr('\000a')||
'<td wid'||
'th="1" style="background-color:FFFFFF"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td width="100%" align="center" valign="top">'||unistr('\000a')||
'<!-- BEGIN FRAME -->'||unistr('\000a')||
'<table width="98%" height="98%" border="0" align="center" cellpadding="0" cellspacing="0" class="t8contentborder" style="margin-top: 5px;background-color:#E5E5DC" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="21" colspan="3'||
'"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#REGION_POSITION_01#'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="7" colspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="26" height="100%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'<td align="center" valign="top" sty'||
'le="background-color:BFBFB8" width="100%" class="t8contentborder"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" align="center"><div class="t8messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'<td width="26"'||
' height="100%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" align="right" valign="middle" colspan="3" class="t8copyright"><span class="t8User">&APP_USER.</span><!-- Copyright --><span class="t8Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<div class="t8PageBottom"><img src="#IMAGE_PREFIX#themes/theme_8/t3bottom_bg_stripe.gif" alt="" /></div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t8success">SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t8notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t8NavigationBar"><table border="0" cellspacing="0" cellpadding="0" summary="" align="right"><tr><td><br /></td>#BAR_BODY#</tr></table></div>'
 ,p_navbar_entry => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#LINK#" class="t8btn" style="white-space:nowrap;">#TEXT#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 17
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs
prompt  ......Page template 2801609471273779
 
begin
 
wwv_flow_api.create_template (
  p_id => 2801609471273779 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 8
 ,p_name => 'No Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE.">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<!-- BEGIN HEADER height="51" -->'||unistr('\000a')||
'<table width="100%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr><td class="t8TopBar" valign="top"><table border="0" cellpadding="0" cellspacing="0" summary=""><tr>'||unistr('\000a')||
'<td valign="top"><div id="t8Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr></table></t'||
'd></tr>'||unistr('\000a')||
'<tr><td class="t8TopBarBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="11" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" height="90%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="100%" style="background-color:#E5E5DC" align="center" valign="top"><table width="98%" height="98%" border="0" align="center" cellpadding="0" cellspacing="'||
'0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="21" colspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#REGION_POSITION_01#'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="7" colspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="26" height="100%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt'||
'="" /></td>'||unistr('\000a')||
'<td align="center" valign="top" style="background-color:BFBFB8" width="100%" class="t8contentborder"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" align="center"><div class="t8messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top"'||
'>#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'<td width="26" height="100%"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="26" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" align="right" valign="middle" colspan="3" class="t8copyright"><span class="t8User">&APP_USER.</span><!-- Copyright --><span class="t8Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table'||
'>'
 ,p_footer_template => 
'<div class="t8PageBottom"><img src="#IMAGE_PREFIX#themes/theme_8/t3bottom_bg_stripe.gif" alt="" /></div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t8success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t8notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t8NavigationBar"><table border="0" cellspacing="0" cellpadding="0" summary="" align="right"><tr><td></td>#BAR_BODY#</tr></table></div>'
 ,p_navbar_entry => '<td style="padding-left:5px;"><table height="18"  cellpadding="0" cellspacing="0" border="0" summary="" class="t8standardtabcurrent">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="2" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_left.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabTop"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td width="2" height="18" rowspan="3"><img src="#IMAGE_PREFIX#themes/theme_8/t3btn_lit_right.gif" width="2" height="18" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="14" height="14" class="t8TabL"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="14" height="14" alt=""/></td>'||unistr('\000a')||
'<td width="1" class="t8TabM"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="14" alt=""/></td>'||unistr('\000a')||
'<td height="14" class="t8TabR"><a href="#LINK#" class="t8btn" style="white-space:nowrap;">#TEXT#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="17" height="2" colspan="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt=""/></td>'||unistr('\000a')||
'<td height="2" class="t8TabBottom"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1"  alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 3
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup
prompt  ......Page template 2801927526273779
 
begin
 
wwv_flow_api.create_template (
  p_id => 2801927526273779 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 8
 ,p_name => 'Popup'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE.">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t8messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_01##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t8success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t8notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t8NavigationBar">#BAR_BODY#</div>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs
prompt  ......Page template 2819900905468445
 
begin
 
wwv_flow_api.create_template (
  p_id => 2819900905468445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 11
 ,p_name => 'One Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28"   border="0" alt=""/></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="'||
'#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><table height="28" border="0" cellpadding="0" cellspacing="0"><tr>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner_top.gif" al'||
't="" /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4midleftcorner.gi'||
'f" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width="35" height="41"  alt=""/></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_P'||
'REFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" c'||
'olspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREF'||
'IX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45"  alt="" /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_'||
'PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt=""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td align="right" style="padding-left:5px"><table height="28" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="8" align="center"><img src="#IMAGE_PREFIX#themes/theme_11/t4toparrow.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="20" align="center" class="t11StandardTab"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td align="right" style="padding-left:5px"><table height="28" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td height="8" align="center"></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="20" align="center" class="t11StandardTab"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#</td>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '12'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/login
prompt  ......Page template 2820111338468445
 
begin
 
wwv_flow_api.create_template (
  p_id => 2820111338468445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 11
 ,p_name => 'Login'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# style="background-color:#8fc58d;">#FORM_OPEN#'
 ,p_box => 
'<div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<table align="center" border="0" cellpadding="0" cellspacing="0" summary="" class="t11Login">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table summary="" class="t11ReportsRegion" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-tl.gif" width="15" height="15" /></td>'||unistr('\000a')||
'<td align="righ'||
't" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-tr.gif" width="15" height="15" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t11RegionBody">#BOX_BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-bl.gif" width="15" height="15" /></td>'||unistr('\000a')||
'<td align="right" valign="bottom" class="t11RegionFooter"><img src="#IMAG'||
'E_PREFIX#themes/theme_11/t11corner-br.gif" width="15" height="15" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'||unistr('\000a')||
''
 ,p_success_message => '<div class="t11success">#MESSAGE#</div>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 6
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs
prompt  ......Page template 2820409366468445
 
begin
 
wwv_flow_api.create_template (
  p_id => 2820409366468445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 11
 ,p_name => 'Two Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt="" /></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFI'||
'X#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#PARENT_TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/th'||
'eme_11/t4midrightcorner_top.gif"  alt=""/></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX'||
'#themes/theme_11/t4midleftcorner.gif" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width'||
'="35" height="41"  alt="" /></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1p'||
'x_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" colspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04##REGION_POSITION_05##REGION_POS'||
'ITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-colo'||
'r:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45" alt="" /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt=""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span cl'||
'ass="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td class="t11SubTab" valign="top"><div class="t11SubTabB"><a href="#TAB_LINK#">#TAB_LABEL#</a></div><div><img src="#IMAGE_PREFIX#themes/theme_11/t11toparrow2.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td class="t11SubTab" valign="top"><div><a href="#TAB_LINK#">#TAB_LABEL#</a></div><div><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" width="16" height="8" /></div>#TAB_INLINE_EDIT#</td>'
 ,p_top_current_tab => '<td class="t11StandardTab"><div><img src="#IMAGE_PREFIX#themes/theme_11/t4toparrow.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>'||unistr('\000a')||
'<div height="20" class="t4topnav"><a href="#TAB_LINK#">#TAB_LABEL#</a></div>#TAB_INLINE_EDIT#</td>'
 ,p_top_non_curr_tab => '<td class="t11StandardTab"><div><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>'||unistr('\000a')||
'<div height="20" class="t4topnav"><a href="#TAB_LINK#">#TAB_LABEL#</a></div>#TAB_INLINE_EDIT#</td>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => ': <a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 2
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '8'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup
prompt  ......Page template 2820727367468445
 
begin
 
wwv_flow_api.create_template (
  p_id => 2820727367468445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 11
 ,p_name => 'Popup'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_01##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs_with_sidebar
prompt  ......Page template 2821028888468445
 
begin
 
wwv_flow_api.create_template (
  p_id => 2821028888468445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 11
 ,p_name => 'No Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt=""/></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFIX'||
'#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><br /></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner_top.gif" alt="" /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" wid'||
'th="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4midleftcorner.gif" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IM'||
'AGE_PREFIX#themes/theme_11/t4top.gif"><br /></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width="35" height="41"  alt=""/></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img s'||
'rc="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" colspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" w'||
'idth="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="'||
'#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45" alt="" /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif"'||
' width="31" height="45" alt=""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 17
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs_with_sidebar
prompt  ......Page template 2821303987468445
 
begin
 
wwv_flow_api.create_template (
  p_id => 2821303987468445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 11
 ,p_name => 'Two Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt="" /></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFI'||
'X#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#PARENT_TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/th'||
'eme_11/t4midrightcorner_top.gif" alt="" /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX'||
'#themes/theme_11/t4midleftcorner.gif" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width'||
'="35" height="41" alt=""  /></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1p'||
'x_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" colspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_'||
'POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width'||
'="28" height="45" alt=""  /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt="" /></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -'||
'->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td class="t11SubTab" valign="top"><div class="t11SubTabB"><a href="#TAB_LINK#">#TAB_LABEL#</a></div><div><img src="#IMAGE_PREFIX#themes/theme_11/t11toparrow2.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td class="t11SubTab" valign="top"><div><a href="#TAB_LINK#">#TAB_LABEL#</a></div><div><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" width="16" height="8" /></div>#TAB_INLINE_EDIT#</td>'
 ,p_top_current_tab => '<td class="t11StandardTab"><div><img src="#IMAGE_PREFIX#themes/theme_11/t4toparrow.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>'||unistr('\000a')||
'<div height="20" class="t4topnav"><a href="#TAB_LINK#">#TAB_LABEL#</a></div>#TAB_INLINE_EDIT#</td>'
 ,p_top_non_curr_tab => '<td class="t11StandardTab"><div><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>'||unistr('\000a')||
'<div height="20" class="t4topnav"><a href="#TAB_LINK#">#TAB_LABEL#</a></div>#TAB_INLINE_EDIT#</td>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 18
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs_with_sidebar
prompt  ......Page template 2821606012468446
 
begin
 
wwv_flow_api.create_template (
  p_id => 2821606012468446 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 11
 ,p_name => 'One Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt=""/></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFIX'||
'#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><table height="28" border="0" cellpadding="0" cellspacing="0" summary=""><tr>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner_top.gif"  alt'||
'=""/></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4midleftcorner.gif"'||
' width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width="35" height="41" alt=""/></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREF'||
'IX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" co'||
'lspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFI'||
'X#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45"  alt="" /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_P'||
'REFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt=""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td align="right" style="padding-left:5px"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="8" align="center"><img src="#IMAGE_PREFIX#themes/theme_11/t4toparrow.gif" width="16" height="8" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="20" align="center" class="t11StandardTab"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td align="right" style="padding-left:5px"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td height="8" align="center"></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="20" align="center" class="t11StandardTab"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#</td>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 16
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/printer_friendly
prompt  ......Page template 2821910697468446
 
begin
 
wwv_flow_api.create_template (
  p_id => 2821910697468446 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 11
 ,p_name => 'Printer Friendly'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top">'||unistr('\000a')||
'<div style="border:1px solid black;">#SUCCESS_MESSAG'||
'E##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#REGION_POSITION_05#'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t4success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t4notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 5
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '3'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs
prompt  ......Page template 2822223382468446
 
begin
 
wwv_flow_api.create_template (
  p_id => 2822223382468446 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 11
 ,p_name => 'No Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt="" /></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFI'||
'X#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><br /></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner_top.gif"  alt=""/></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" wi'||
'dth="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><br /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4midleftcorner.gif" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/1'||
'px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width="35" height="41"  alt=""/></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D"><br  /></td>'||unistr('\000a')||
'<td width="'||
'31"><br /></td>'||unistr('\000a')||
'<td align="left" valign="top" colspan="2">'||unistr('\000a')||
'#REGION_POSITION_01#'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"'||
'><br  /></td>'||unistr('\000a')||
'<td width="30"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45"   border="0"  alt=""/></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt='||
'""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</div>'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 3
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs_with_sidebar
prompt  ......Page template 2840523414474907
 
begin
 
wwv_flow_api.create_template (
  p_id => 2840523414474907 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 17
 ,p_name => 'No Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Logo" valign="top">#LOGO#<br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td id="t17HeaderMiddle"  valign="top" width="100%">#REGION_POSITION_07#<br /></td>'||unistr('\000a')||
'<td id="t17NavBar" valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageB'||
'ody"  width="100%" height="70%">'||unistr('\000a')||
'<td valign="top" id="t17ContentBody">'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" height="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17ContentLeftTop"><br /></td>'||unistr('\000a')||
'<td colspan="2" valign="top" height="0"><div id="t17BreadCrumbsLeft">#REGION_POSITION_01#</div></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="200" id="t17ContentLeft">#REGION_POSITION_02#<br /></td>'||unistr('\000a')||
'<td '||
'width="100%" valign="top" height="100%">'||unistr('\000a')||
'<div id="t17Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<div id="t17ContentMiddle" style="padding:5px;">#BOX_BODY##REGION_POSITION_04#</div>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td valign="top" width="200" id="t17ContentRight">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Left" valign="top"><span id="t17UserPrompt">&APP_USER.</span><br /></td>'||unistr('\000a')||
'<td id="t17Center" valign="top">#REGION_POSITION_05#</td>'||unistr('\000a')||
'<td id="t17Right" valign="top"><span id="t17Customize">#CUSTOMIZE#</span><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t17Break"/>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#G'||
'ENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div id="t17Success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div id="t17Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t17NavBar">#TEXT#</a> |'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" align="left"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 17
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs
prompt  ......Page template 2840730088474907
 
begin
 
wwv_flow_api.create_template (
  p_id => 2840730088474907 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 17
 ,p_name => 'Two Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Logo" valign="top">#LOGO#<br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td id="t17HeaderMiddle"  valign="top" width="100%">#REGION_POSITION_07#<br /></td>'||unistr('\000a')||
'<td id="t17NavBar" valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageB'||
'ody"  width="100%" height="70%">'||unistr('\000a')||
'<td valign="top" id="t17ContentBody">'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" valign="top" height="0"><div id="t17Tabs">#PARENT_TAB_CELLS#</div><div id="t17Tabs">#TAB_CELLS#</div><div id="t17BreadCrumbsLeft">#REGION_POSITION_01#</div></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" height="100%">'||unistr('\000a')||
'<div id="t17Mess'||
'ages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<div id="t17ContentMiddle" style="padding:5px;">#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</div>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td valign="top" width="200" id="t17ContentRight">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Left" valign="top"><span id="t17UserPrompt">&APP_USER.</span><br /></td>'||unistr('\000a')||
'<td id="t17Center" valign="top">#REGION_POSITION_05#</td>'||unistr('\000a')||
'<td id="t17Right" valign="top"><span id="t17Customize">#CUSTOMIZE#</span><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t17Break"/>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#G'||
'ENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div id="t17Success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<a href="#TAB_LINK#" class="t17CurrentTab">#TAB_LABEL#</a>'
 ,p_non_current_tab => '<a href="#TAB_LINK#" class="t17Tab">#TAB_LABEL#</a>'
 ,p_top_current_tab => '<a href="#TAB_LINK#" class="t17CurrentTab">#TAB_LABEL#</a>'
 ,p_top_non_curr_tab => '<a href="#TAB_LINK#" class="t17Tab">#TAB_LABEL#</a>'
 ,p_notification_message => '<div id="t17Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t17NavBar">#TEXT#</a> |'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="5" align="left"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 2
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '8'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs_with_sidebar
prompt  ......Page template 2841026610474907
 
begin
 
wwv_flow_api.create_template (
  p_id => 2841026610474907 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 17
 ,p_name => 'Two Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Logo" valign="top">#LOGO#<br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td id="t17HeaderMiddle"  valign="top" width="100%">#REGION_POSITION_07#<br /></td>'||unistr('\000a')||
'<td id="t17NavBar" valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageB'||
'ody"  width="100%" height="70%">'||unistr('\000a')||
'<td valign="top" id="t17ContentBody">'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0" height="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17ContentLeftTop"><br /></td>'||unistr('\000a')||
'<td colspan="2" valign="top" height="0"><div id="t17Tabs">#PARENT_TAB_CELLS#</div><div id="t17Tabs">#TAB_CELLS#</div><div id="t17BreadCrumbsLeft">#REGION_POSITION_01#</div></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td vali'||
'gn="top" width="200" id="t17ContentLeft">#REGION_POSITION_02#<br /></td>'||unistr('\000a')||
'<td width="100%" valign="top" height="100%">'||unistr('\000a')||
'<div id="t17Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<div id="t17ContentMiddle" style="padding:5px;">#BOX_BODY##REGION_POSITION_04#</div>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td valign="top" width="200" id="t17ContentRight">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
''||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Left" valign="top"><span id="t17UserPrompt">&APP_USER.</span><br /></td>'||unistr('\000a')||
'<td id="t17Center" valign="top">#REGION_POSITION_05#</td>'||unistr('\000a')||
'<td id="t17Right" valign="top"><span id="t17Customize">#CUSTOMIZE#</span><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t17Break"/>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#G'||
'ENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div id="t17Success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<a href="#TAB_LINK#" class="t17CurrentTab">#TAB_LABEL#</a>'
 ,p_non_current_tab => '<a href="#TAB_LINK#" class="t17Tab">#TAB_LABEL#</a>'
 ,p_top_current_tab => '<a href="#TAB_LINK#" class="t17CurrentTab">#TAB_LABEL#</a>'
 ,p_top_non_curr_tab => '<a href="#TAB_LINK#" class="t17Tab">#TAB_LABEL#</a>'
 ,p_notification_message => '<div id="t17Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t17NavBar">#TEXT#</a> |'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="5" align="left"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 18
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup
prompt  ......Page template 2841306994474907
 
begin
 
wwv_flow_api.create_template (
  p_id => 2841306994474907 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 17
 ,p_name => 'Popup'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top">'||unistr('\000a')||
'<div style="border:1px solid black;">#SUCCESS_MESSAG'||
'E##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
''
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t17success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t17notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t17NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t17NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs
prompt  ......Page template 2841627537474907
 
begin
 
wwv_flow_api.create_template (
  p_id => 2841627537474907 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 17
 ,p_name => 'One Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Logo" valign="top">#LOGO#<br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td id="t17HeaderMiddle"  valign="top" width="100%">#REGION_POSITION_07#<br /></td>'||unistr('\000a')||
'<td id="t17NavBar" valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageB'||
'ody"  width="100%" height="70%">'||unistr('\000a')||
'<td valign="top" id="t17ContentBody">'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" height="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" valign="top" height="0"><div id="t17Tabs">#TAB_CELLS#</div><div id="t17BreadCrumbsLeft">#REGION_POSITION_01#</div></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" height="100%">'||unistr('\000a')||
'<div id="t17Messages">#GLOBAL_NOTIFICATION##'||
'SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<div id="t17ContentMiddle" style="padding:5px;">#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</div>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td valign="top" width="200" id="t17ContentRight">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Left" valign="top"><span id="t17UserPrompt">&APP_USER.</span><br /></td>'||unistr('\000a')||
'<td id="t17Center" valign="top">#REGION_POSITION_05#</td>'||unistr('\000a')||
'<td id="t17Right" valign="top"><span id="t17Customize">#CUSTOMIZE#</span><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t17Break"/>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#G'||
'ENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div id="t17Success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<a href="#TAB_LINK#" class="t17CurrentTab">#TAB_LABEL#</a>'
 ,p_non_current_tab => '<a href="#TAB_LINK#" class="t17Tab">#TAB_LABEL#</a>'
 ,p_notification_message => '<div id="t17Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t17NavBar">#TEXT#</a> |'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="5" align="left"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/login
prompt  ......Page template 2841903861474909
 
begin
 
wwv_flow_api.create_template (
  p_id => 2841903861474909 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 17
 ,p_name => 'Login'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<div class="t17messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<table align="center" border="0" cellpadding="0" cellspacing="0" summary="" class="t17Login">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_03##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'||unistr('\000a')||
''
 ,p_success_message => '<div id="t17Success">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''
 ,p_notification_message => '<div id="t17Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div id="t17NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t17NavigationBar">#TEXT#</a> |'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 6
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs_with_sidebar
prompt  ......Page template 2842231718474909
 
begin
 
wwv_flow_api.create_template (
  p_id => 2842231718474909 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 17
 ,p_name => 'One Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Logo" valign="top">#LOGO#<br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td id="t17HeaderMiddle"  valign="top" width="100%">#REGION_POSITION_07#<br /></td>'||unistr('\000a')||
'<td id="t17NavBar" valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageB'||
'ody"  width="100%" height="70%">'||unistr('\000a')||
'<td valign="top" id="t17ContentBody">'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" height="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17ContentLeftTop"><br /></td>'||unistr('\000a')||
'<td colspan="2" valign="top" height="0"><div id="t17Tabs">#TAB_CELLS#</div><div id="t17BreadCrumbsLeft">#REGION_POSITION_01#</div></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="200" id="t17ContentLeft">#'||
'REGION_POSITION_02#<br /></td>'||unistr('\000a')||
'<td width="100%" valign="top" height="100%">'||unistr('\000a')||
'<div id="t17Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<div id="t17ContentMiddle" style="padding:5px;">#BOX_BODY##REGION_POSITION_04#</div>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td valign="top" width="200" id="t17ContentRight">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Left" valign="top"><span id="t17UserPrompt">&APP_USER.</span><br /></td>'||unistr('\000a')||
'<td id="t17Center" valign="top">#REGION_POSITION_05#</td>'||unistr('\000a')||
'<td id="t17Right" valign="top"><span id="t17Customize">#CUSTOMIZE#</span><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t17Break"/>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#G'||
'ENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div id="t17Success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<a href="#TAB_LINK#" class="t17CurrentTab">#TAB_LABEL#</a>'
 ,p_non_current_tab => '<a href="#TAB_LINK#" class="t17Tab">#TAB_LABEL#</a>'
 ,p_notification_message => '<div id="t17Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t17NavBar">#TEXT#</a> |'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="5" align="left"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 16
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs
prompt  ......Page template 2842504878474909
 
begin
 
wwv_flow_api.create_template (
  p_id => 2842504878474909 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 17
 ,p_name => 'No Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Logo" valign="top">#LOGO#<br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td id="t17HeaderMiddle"  valign="top" width="100%">#REGION_POSITION_07#<br /></td>'||unistr('\000a')||
'<td id="t17NavBar" valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageB'||
'ody"  width="100%" height="70%">'||unistr('\000a')||
'<td valign="top" id="t17ContentBody">'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" valign="top" height="0"><div id="t17BreadCrumbsLeft">#REGION_POSITION_01#</div></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" height="100%">'||unistr('\000a')||
'<div id="t17Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<div'||
' id="t17ContentMiddle">#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</div>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td valign="top" width="200" id="t17ContentRight">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Left" valign="top"><span id="t17UserPrompt">&APP_USER.</span><br /></td>'||unistr('\000a')||
'<td id="t17Center" valign="top">#REGION_POSITION_05#</td>'||unistr('\000a')||
'<td id="t17Right" valign="top"><span id="t17Customize">#CUSTOMIZE#</span><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t17Break"/>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#G'||
'ENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div id="t17Success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div id="t17Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t17NavBar">#TEXT#</a> |'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" align="left"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 3
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/printer_friendly
prompt  ......Page template 2842816710474909
 
begin
 
wwv_flow_api.create_template (
  p_id => 2842816710474909 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 17
 ,p_name => 'Printer Friendly'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Logo" valign="top">#LOGO#<br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td id="t17HeaderMiddle"  valign="top" width="100%">#REGION_POSITION_07#<br /></td>'||unistr('\000a')||
'<td id="t17NavBar" valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<t'||
'd width="100%" valign="top"><div class="t17messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t17PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td id="t17Left" valign="top"><span id="t17UserPrompt">&APP_USER.</span><br /></td>'||unistr('\000a')||
'<td id="t17Center" valign="top">#REGION_POSITION_05#</td>'||unistr('\000a')||
'<td id="t17Right" valign="top"><span id="t17Customize">#CUSTOMIZE#</span><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t17Break"/>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#G'||
'ENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t17success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t17notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t17NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t17NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 5
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '3'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs_with_sidebar
prompt  ......Page template 2861212464481231
 
begin
 
wwv_flow_api.create_template (
  p_id => 2861212464481231 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 16
 ,p_name => 'No Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><div class="t16Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top"><div class="t16NavigationBar"><span class="t16NavigationBar">(&APP_USER.)</span>#NAVIGATION_BAR#</div>#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpaddin'||
'g="0" cellspacing="0" summary=""  width="100%" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16SideBarTitle" align="right"><img src="#IMAGE_PREFIX#themes/theme_16/left_sidebar_cap.png" alt="" /></td>'||unistr('\000a')||
'<td class="t16NavBodySpace"><img src="#IMAGE_PREFIX#themes/theme_16/1px_trans.gif" height="1" width="1" alt="" /></td>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src'||
'="#IMAGE_PREFIX#themes/theme_16/breadcrumb_cap.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16BreadCrumbRegion" valign="middle">#REGION_POSITION_01#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/breadcrumb_cap_right.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16SideBar" valign="top">#REGION_POSITION_02#</td>'||unistr('\000a')||
'<td class="t16NavBodySpace"><br /></td>'||unistr('\000a')||
'<td valign="top" height="100%'||
'">'||unistr('\000a')||
'<table cellpadding="0" cellspacing="0" border="0" summary="" width="100%" class="t16PageCap">'||unistr('\000a')||
'<tr><td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16PageTopMiddle"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapMiddle.png" alt="" /></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapRight.png" alt="" /></td></tr>'||unistr('\000a')||
'</table'||
'>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" height="100%" cellspacing="0" border="0" id="t16PageBody">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" height="100%" class="t16ContentBody"><div class="t16messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td style="width:15px;"><br /></td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</'||
'table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16BottomRight"><br /></td>'||unistr('\000a')||
'<td class="t16NavBodySpace"><br /></td>'||unistr('\000a')||
'<td><table summary="" width="100%" cellpadding="0" cellspacing="0" class="pageBottom">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td align="right"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapRight.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table'||
'></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t16PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16UserPrompt"><br /></td>'||unistr('\000a')||
'<td class="t16Copyright"><!-- Copyright --><span class="t16Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t16Break"/>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t16success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t16notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => ' | <a href="#LINK#" class="t16NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 17
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs_with_sidebar
prompt  ......Page template 2861416501481231
 
begin
 
wwv_flow_api.create_template (
  p_id => 2861416501481231 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 16
 ,p_name => 'Two Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><div class="t16Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top"><div class="t16NavigationBar"><span class="t16NavigationBar">(&APP_USER.)</span>#NAVIGATION_BAR#</div>#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div class="TabHolder">#PARE'||
'NT_TAB_CELLS#</div>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary=""  width="100%" height="70%">'||unistr('\000a')||
''||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3">'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary=""  width="100%" class="t16SubTab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'#TAB_CELLS#<td width="100%"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
''||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16SideBarTitle" align="right"><img src="#IMAGE_PREFIX#themes/theme_16/left_sidebar_c'||
'ap.png" alt="" /></td>'||unistr('\000a')||
'<td class="t16NavBodySpace"><img src="#IMAGE_PREFIX#themes/theme_16/1px_trans.gif" height="1" width="1" alt="" /></td>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/breadcrumb_cap.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16BreadCrumbRegion" valign="middle">#REGION_POSITION_01#</td>'||unistr('\000a')||
'<td><img'||
' src="#IMAGE_PREFIX#themes/theme_16/breadcrumb_cap_right.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16SideBar" valign="top"><div class="t16Tabs">#REGION_POSITION_02#</td>'||unistr('\000a')||
'<td class="t16NavBodySpace"><br /></td>'||unistr('\000a')||
'<td valign="top" height="100%">'||unistr('\000a')||
'<table cellpadding="0" cellspacing="0" border="0" summary="" width="100%" class="t16PageCap">'||unistr('\000a')||
'<tr><td><img src="#IMAGE_PREFIX#themes/theme'||
'_16/t16PageTopCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16PageTopMiddle"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapMiddle.png" alt="" /></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapRight.png" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" height="100%" cellspacing="0" border="0" id="t16PageBody">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top'||
'" height="100%" class="t16ContentBody"><div class="t16messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td style="width:15px;"><br /></td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16BottomRight"><br /></td>'||unistr('\000a')||
'<td class="t16NavBodySpace"><br /></td>'||unistr('\000a')||
'<td><table summary="" width="100%" cel'||
'lpadding="0" cellspacing="0" class="pageBottom">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td align="right"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapRight.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t16PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16UserPrompt"><br /></td>'||unistr('\000a')||
'<td class="t16Copyright"><!-- Copyright --><span class="t16Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t16Break"/>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t16success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td class="M" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
''
 ,p_non_current_tab => '<td class="MC" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
''
 ,p_top_current_tab => '<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Tab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Tab-1-1.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'<td class="M" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Tab-1-4.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#'
 ,p_top_non_curr_tab => '<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Tab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16TabC-1-1.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'<td class="MC" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16TabC-1-4.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#'
 ,p_notification_message => '<div class="t16notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => ' | <a href="#LINK#" class="t16NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 18
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup
prompt  ......Page template 2861722150481231
 
begin
 
wwv_flow_api.create_template (
  p_id => 2861722150481231 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 16
 ,p_name => 'Popup'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# class="popup">#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t16messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_01##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t16success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t16notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t16NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t16NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs_with_sidebar
prompt  ......Page template 2862006406481231
 
begin
 
wwv_flow_api.create_template (
  p_id => 2862006406481231 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 16
 ,p_name => 'One Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><div class="t16Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top"><div class="t16NavigationBar"><span class="t16NavigationBar">(&APP_USER.)</span>#NAVIGATION_BAR#</div>#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpaddin'||
'g="0" cellspacing="0" summary="" width="100%" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3">'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><div class="TabHolder">#TAB_CELLS#</div></td>'||unistr('\000a')||
'<td style="width:5px;"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16SideBarTitle" align="right"><img src="#IMAGE_PREFIX#themes/theme_16/left_sidebar_cap.png" alt='||
'"" /></td>'||unistr('\000a')||
'<td class="t16NavBodySpace"><img src="#IMAGE_PREFIX#themes/theme_16/1px_trans.gif" height="1" width="1" alt="" /></td>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/breadcrumb_cap.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16BreadCrumbRegion" valign="middle">#REGION_POSITION_01#</td>'||unistr('\000a')||
'<td><img src="#IMAGE'||
'_PREFIX#themes/theme_16/breadcrumb_cap_right.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16SideBar" valign="top">#REGION_POSITION_02#</td>'||unistr('\000a')||
'<td class="t16NavBodySpace"><br /></td>'||unistr('\000a')||
'<td valign="top" height="100%">'||unistr('\000a')||
'<table cellpadding="0" cellspacing="0" border="0" summary="" width="100%" class="t16PageCap">'||unistr('\000a')||
'<tr><td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapLeft.png" alt=""'||
' /></td>'||unistr('\000a')||
'<td width="100%" class="t16PageTopMiddle"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapMiddle.png" alt="" /></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapRight.png" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" height="100%" cellspacing="0" border="0" id="t16PageBody">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" height="100%"><div class="t16me'||
'ssages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td style="width:15px;"><img src="#IMAGE_PREFIX#themes/theme_16/1px_trans.gif" height="400" width="1" alt="" /><br /></td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16BottomRight"><br /></td>'||unistr('\000a')||
'<td class="t16NavBodySpace"><br /></td>'||unistr('\000a')||
'<td><ta'||
'ble summary="" width="100%" cellpadding="0" cellspacing="0" border="0" class="pageBottom">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td align="right"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapRight.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<img src="#IMAGE_PREFIX#themes/theme_16/1px_trans.gif" height="1" width="400" alt="" />'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</t'||
'r>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t16PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16UserPrompt"><br /></td>'||unistr('\000a')||
'<td class="t16Copyright"><!-- Copyright --><span class="t16Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t16Break"/>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t16success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Tab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Tab-1-1.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'<td class="M" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Tab-1-4.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#'
 ,p_non_current_tab => '<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Tab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16TabC-1-1.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'<td class="MC" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16TabC-1-4.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#'
 ,p_notification_message => '<div class="t16notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '| <a href="#LINK#" class="t16NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 16
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/login
prompt  ......Page template 2862305055481232
 
begin
 
wwv_flow_api.create_template (
  p_id => 2862305055481232 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 16
 ,p_name => 'Login'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><div class="t16Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">>#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="50%" align="center">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" class="t15ContentB'||
'ody" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0" align="center">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<tr><td><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%" class="t16PageCap">'||unistr('\000a')||
'<tr><td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16PageTopMiddle"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapMid'||
'dle.png" alt="" /></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapRight.png" alt="" /></td></tr>'||unistr('\000a')||
'</table></td></tr>'||unistr('\000a')||
'<td width="100%" valign="top" height="100%" id="t16PageBody" style="padding:4px;"><div class="t16messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_01##REGION_POSITION_02##REGION_POSITION_03##REGION_POSITION_04#</td>'||unistr('\000a')||
''||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="pageBottom"><table summary="" width="100%" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td align="right"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapRight.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'||unistr('\000a')||
''
 ,p_success_message => '<div class="t16success">#MESSAGE#</div>'
 ,p_notification_message => '<div class="t16notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t16NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t16NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 6
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs
prompt  ......Page template 2862612813481232
 
begin
 
wwv_flow_api.create_template (
  p_id => 2862612813481232 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 16
 ,p_name => 'One Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><div class="t16Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top"><div class="t16NavigationBar"><span class="t16NavigationBar">(&APP_USER.)</span>#NAVIGATION_BAR#</div>#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpaddin'||
'g="0" cellspacing="0" summary="" width="100%" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><div class="TabHolder">#TAB_CELLS#</div></td>'||unistr('\000a')||
'<td style="width:5px;"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td>	'||unistr('\000a')||
'<table cellpadding="0" cellspacing="0" border="0" summary="" width="100%" height="8">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/t'||
'heme_16/breadcrumb_cap.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16BreadCrumbRegion" valign="middle">#REGION_POSITION_01#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/breadcrumb_cap_right.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" height="100%">'||unistr('\000a')||
'<table cellpadding="0" cellspacing="0" border="0" summary="" width="100%" class="t16PageCap">'||unistr('\000a')||
'<tr><td><img src="#IMAGE_PREF'||
'IX#themes/theme_16/t16PageTopCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16PageTopMiddle"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapMiddle.png" alt="" /></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapRight.png" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" height="100%" cellspacing="0" border="0" id="t16PageBody">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="10'||
'0%" valign="top" height="100%"><div class="t16messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table summary="" width="100%" cellpadding="0" cellspacing="0" border="0" class="pageBottom">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left"><img src="#IMAGE_PREFIX#the'||
'mes/theme_16/t16PageBotCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td align="right"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapRight.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t16PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16Copyright"><!-- Copyright --><span class="t16Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t16Break"/>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t16success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Tab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Tab-1-1.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'<td class="M" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Tab-1-4.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#'
 ,p_non_current_tab => '<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Tab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16TabC-1-1.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'<td class="MC" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16TabC-1-4.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#'
 ,p_notification_message => '<div class="t16notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '| <a href="#LINK#" class="t16NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '12'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs
prompt  ......Page template 2862903700481232
 
begin
 
wwv_flow_api.create_template (
  p_id => 2862903700481232 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 16
 ,p_name => 'No Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><div class="t16Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top"><div class="t16NavigationBar"><span class="t16NavigationBar">(&APP_USER.)</span>#NAVIGATION_BAR#</div>#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpaddin'||
'g="0" cellspacing="0" summary=""  width="100%" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/breadcrumb_cap.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16BreadCrumbRegion">#REGION_POSITION_01#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/breadcrumb_cap_right.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table><'||
'/td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" height="100%">'||unistr('\000a')||
'<table cellpadding="0" cellspacing="0" border="0" summary="" width="100%" class="t16PageCap">'||unistr('\000a')||
'<tr><td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16PageTopMiddle"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapMiddle.png" alt="" /></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Page'||
'TopCapRight.png" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" height="100%" cellspacing="0" border="0" id="t16PageBody">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" height="100%" class="t16ContentBody"><div class="t16messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td style="width:15px;"><br /'||
'></td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table summary="" width="100%" cellpadding="0" cellspacing="0" border="0" class="pageBottom">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td align="right"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapRight.png" alt="" /></td></tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t16PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16UserPrompt"><br /></td>'||unistr('\000a')||
'<td class="t16Copyright"><!-- Copyright --><span class="t16Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t16Break"/>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t16success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t16notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => ' | <a href="#LINK#" class="t16NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 3
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/printer_friendly
prompt  ......Page template 2863221420481232
 
begin
 
wwv_flow_api.create_template (
  p_id => 2863221420481232 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 16
 ,p_name => 'Printer Friendly'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t16messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_01##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t16success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t16notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t16NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t16NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 5
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '3'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs
prompt  ......Page template 2863509740481232
 
begin
 
wwv_flow_api.create_template (
  p_id => 2863509740481232 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 16
 ,p_name => 'Two Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><div class="t16Logo">#LOGO#</div>#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top"><div class="t16NavigationBar"><span class="t16NavigationBar">(&APP_USER.)</span>#NAVIGATION_BAR#</div>#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div class="TabHolder">#PARE'||
'NT_TAB_CELLS#</div>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary=""  width="100%" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" summary=""  width="100%" class="t16SubTab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'#TAB_CELLS#<td width="100%"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFI'||
'X#themes/theme_16/breadcrumb_cap.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16BreadCrumbRegion" valign="middle">#REGION_POSITION_01#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/breadcrumb_cap_right.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" height="100%">'||unistr('\000a')||
'<table cellpadding="0" cellspacing="0" border="0" summary="" width="100%" class="t16PageCap">'||unistr('\000a')||
'<tr><td><img src="#'||
'IMAGE_PREFIX#themes/theme_16/t16PageTopCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td width="100%" class="t16PageTopMiddle"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapMiddle.png" alt="" /></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16PageTopCapRight.png" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" height="100%" cellspacing="0" border="0" id="t16PageBody">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td'||
' width="100%" valign="top" height="100%" class="t16ContentBody"><div class="t16messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td style="width:15px;"><br /></td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table summary="" width="100%" cellpadding="0" cellspacing="0" class'||
'="pageBottom">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapLeft.png" alt="" /></td>'||unistr('\000a')||
'<td align="right"><img src="#IMAGE_PREFIX#themes/theme_16/t16PageBotCapRight.png" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table border="0" cellpadding="0" cellspacing="0" summary="" id="t16PageFooter" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16UserPrompt"><br /></td>'||unistr('\000a')||
'<td class="t16Copyright"><!-- Copyright --><span class="t16Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br class="t16Break"/>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t16success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td class="M" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>#TAB_INLINE_EDIT#'
 ,p_non_current_tab => '<td class="MC" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>#TAB_INLINE_EDIT#'
 ,p_top_current_tab => '<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Tab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Tab-1-1.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'<td class="M" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Tab-1-4.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#'
 ,p_top_non_curr_tab => '<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Tab">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16TabC-1-1.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'<td class="MC" valign="middle"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16TabC-1-4.gif" width="8" height="22" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#'
 ,p_notification_message => '<div class="t16notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => ' | <a href="#LINK#" class="t16NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 2
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '8'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs
prompt  ......Page template 2882508093489434
 
begin
 
wwv_flow_api.create_template (
  p_id => 2882508093489434 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'No Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
'.t1NavigationBar{white-space:nowrap;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>'||unistr('\000a')||
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src='||
'"#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1topbarMiddle"><br />#REGION_POSITION_01#</td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table class="t1PageBody" cellpadding="0" cellspacing="0" border="0" summary="" width="100%" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1PageCenter" valign="top"><table summary="" cellpadd'||
'ing="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_footer_template => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/th'||
'eme_1/bot_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t1success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t1Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t1NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 3
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/login
prompt  ......Page template 2882731585489434
 
begin
 
wwv_flow_api.create_template (
  p_id => 2882731585489434 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'Login'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="shortcut icon" href="#WORKSPACE_IMAGES#goi.ico" type="image/ico">'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./theme_V2.css" type="text/css" />'||unistr('\000a')||
'<script type="application/x-javascript" src="#WORKSPACE_IMAGES#library.js"></script>'||unistr('\000a')||
'<script type="text/javascript">'||unistr('\000a')||
'function AJAX_HELP(pThis,pId){'||unistr('\000a')||
'	this.dTimeout;'||unistr('\000a')||
' 	clearTimeout(this.dTimeout);'||unistr('\000a')||
' 	this.dGet = dGet;'||unistr('\000a')||
' 	this.dShow = dShow;'||unistr('\000a')||
' 	this.dCancel = dCancel;'||unistr('\000a')||
' 	var get = new htmldb_Get(null,$x(''pFlowId'').value,''APPLICATION_PROCESS=get_item_help'',0);'||unistr('\000a')||
' 	this.dGet();'||unistr('\000a')||
'	return;'||unistr('\000a')||
'	'||unistr('\000a')||
'	function dGet(){'||unistr('\000a')||
'	 	this.dTimeout = setTimeout("this.dCancel()",5000);'||unistr('\000a')||
'      get.add(''TEMPORARY_ITEM'',pId);'||unistr('\000a')||
'      get.add(''TEMPORARY_PAGE_ID'',$x(''pFlowStepId'').value);'||unistr('\000a')||
'	 	get.GetAsync(dShow);'||unistr('\000a')||
'	}'||unistr('\000a')||
'	'||unistr('\000a')||
'	function dShow(){'||unistr('\000a')||
'	 	$x_Hide(''rollover'');'||unistr('\000a')||
'	 	if(p.readyState == 1){'||unistr('\000a')||
'	 	}else if(p.readyState == 2){'||unistr('\000a')||
'	 	}else if(p.readyState == 3){'||unistr('\000a')||
'	 	}else if(p.readyState == 4){'||unistr('\000a')||
'	 	 	$x(''rollover_content'').innerHTML = p.responseText;'||unistr('\000a')||
'	 	 	$x_Show(''rollover'');'||unistr('\000a')||
'	 	 	$x_Style(''rollover'',''left'',findPosX(pThis)+pThis.offsetWidth+5);'||unistr('\000a')||
'	 	 	$x_Style(''rollover'',''top'',findPosY(pThis)-($x(''rollover'').offsetHeight/2)+($x(pThis).offsetHeight/2));'||unistr('\000a')||
'			document.onclick = function(e){'||unistr('\000a')||
'			dCheckClick(e);'||unistr('\000a')||
'			}'||unistr('\000a')||
'	 	}else{return false;}'||unistr('\000a')||
'	}'||unistr('\000a')||
'	function dCheckClick(e){'||unistr('\000a')||
'		var elem = html_GetTarget(e);'||unistr('\000a')||
'		try{'||unistr('\000a')||
'				var lTable = $x_UpTill(elem,"DIV");'||unistr('\000a')||
'				if(lTable.id!=''rollover_content''){dCancel();}'||unistr('\000a')||
'				else{}'||unistr('\000a')||
'		}catch(err){dCancel();}'||unistr('\000a')||
'	}'||unistr('\000a')||
'	'||unistr('\000a')||
'	function dCancel(){'||unistr('\000a')||
'	 	$x_Hide(''rollover'');'||unistr('\000a')||
'		document.onclick = null;'||unistr('\000a')||
'	 	get = null;'||unistr('\000a')||
'	}'||unistr('\000a')||
'}'||unistr('\000a')||
'</script>'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
'.t1NavigationBar{white-space:nowrap;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top" class="t1Logo">#LOGO#</td>'||unistr('\000a')||
'    <td align="right" valign="top"><br /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./top_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1topbarMiddle"><br '||
'/></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./top_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table class="t1PageBody" cellpadding="0" cellspacing="0" border="0" summary="" width="100%" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1PageCenter" valign="top"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" class="t1PageBody"><div c'||
'lass="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_03##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_footer_template => 
'<div id="rollover" style="display:none;background:#FFF;border:2px solid #369;width:150px;position:absolute;padding:4px;"><div id="rollover_content"></div></div>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./bot_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><br /></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_'||
'PREFIX#themes/&FAS_THEME_NAME./bot_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t1success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t1notification">#MESSAGE#</div>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0"'
 ,p_theme_class_id => 6
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '18'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs
prompt  ......Page template 2883027267489434
 
begin
 
wwv_flow_api.create_template (
  p_id => 2883027267489434 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'Two Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
'.t1NavigationBar{white-space:nowrap;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>'||unistr('\000a')||
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    '||
'<td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#PARENT_TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td align="right" class="t1topbarLeft"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left2.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1topbarMiddle" valign="top"><table border="0" cellpadding="0" cellspacing="0" su'||
'mmary=""><tr><td height="20">#TAB_CELLS#</td></tr><tr><td height="20">#REGION_POSITION_01#</td></tr></table></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><br /></td>'||unistr('\000a')||
'    <td class="t1PageRight" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign'||
'="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/th'||
'eme_1/bot_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t1success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<span class="t1ChildTab">[&nbsp;#TAB_LABEL#&nbsp;]</span>#TAB_INLINE_EDIT#'
 ,p_non_current_tab => '<a href="#TAB_LINK#" class="t1ChildTab">#TAB_LABEL#</a>#TAB_INLINE_EDIT#'
 ,p_top_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>'
 ,p_top_non_curr_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>'
 ,p_notification_message => '<div class="t1notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t1NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 2
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs_with_side_bar
prompt  ......Page template 2883314482489434
 
begin
 
wwv_flow_api.create_template (
  p_id => 2883314482489434 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'Two Level Tabs with Side Bar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
'.t1NavigationBar{white-space:nowrap;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>'||unistr('\000a')||
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    '||
'<td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#PARENT_TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td class="t1topbarLeft" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_far_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1topbarLeft" colspan="2"  valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/'||
'top_barleft2_1.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1topbarLeft" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_barleft2_2.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1topbarMiddle" valign="top"><table height="100%" cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="20">#TAB_CELLS#</td></tr><tr><td valign="bottom" height="20">#REGION_POSITION_01#</td></tr></table></td>'||unistr('\000a')||
'    <td v'||
'align="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td class="t1PageLeft" colspan="3" align="left" valign="top">#REGION_POSITION_02#</td>'||unistr('\000a')||
'    <td><br /></td>'||unistr('\000a')||
'    <td class="t1PageRight" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" class="t1Pag'||
'eBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/th'||
'eme_1/bot_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t1success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<span class="t1ChildTab">[&nbsp;#TAB_LABEL#&nbsp;]</span>#TAB_INLINE_EDIT#'
 ,p_non_current_tab => '<a href="#TAB_LINK#" class="t1ChildTab">#TAB_LABEL#</a>#TAB_INLINE_EDIT#'
 ,p_top_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>'
 ,p_top_non_curr_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>'
 ,p_notification_message => '<div class="t1notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t1NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 18
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs_with_side_bar
prompt  ......Page template 2883619483489434
 
begin
 
wwv_flow_api.create_template (
  p_id => 2883619483489434 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'One Level Tabs with Side Bar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
'.t1NavigationBar{white-space:nowrap;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>'||unistr('\000a')||
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    '||
'<td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td class="t1topbarLeft" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_far_left.png" alt="" /></td>'||unistr('\000a')||
'    <td align="right" class="t1topbarLeft" colspan="2"  valign="top"><img src="#IMAGE_PREFIX#themes/t'||
'heme_1/top_barleft2_1.png" alt="" /></td>'||unistr('\000a')||
'    <td align="right" class="t1topbarLeft" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_barleft2_2.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1topbarMiddle" valign="top"><table height="100%" cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="20"><br /></td></tr><tr><td valign="bottom" height="20">#REGION_POSITION_01#</td></tr></table'||
'></td>'||unistr('\000a')||
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td class="t1PageLeft" colspan="3" align="left" valign="top">#REGION_POSITION_02#</td>'||unistr('\000a')||
'    <td><br /></td>'||unistr('\000a')||
'    <td class="t1PageRight" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="t'||
'op" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/th'||
'eme_1/bot_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t1success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>'||unistr('\000a')||
''
 ,p_non_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t2notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t1NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 16
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs_with_side_bar
prompt  ......Page template 2883901059489435
 
begin
 
wwv_flow_api.create_template (
  p_id => 2883901059489435 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'No Tabs with Side Bar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
'.t1NavigationBar{white-space:nowrap;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>'||unistr('\000a')||
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    '||
'<td class="t1topbarLeft" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_far_left.png" alt="" /></td>'||unistr('\000a')||
'    <td align="right" class="t1topbarLeft" colspan="2"  valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_barleft2_1.png" alt="" /></td>'||unistr('\000a')||
'    <td align="right" class="t1topbarLeft" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_barleft2_2.png" alt="" /></td>'||unistr('\000a')||
'    <td class'||
'="t1topbarMiddle" valign="top"><table height="100%" cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="20"><br /></td></tr><tr><td valign="bottom" height="20">#REGION_POSITION_01#</td></tr></table></td>'||unistr('\000a')||
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td class="t1PageLeft" colspan="3" align="left" valign="top">#REG'||
'ION_POSITION_02#</td>'||unistr('\000a')||
'    <td><br /></td>'||unistr('\000a')||
'    <td class="t1PageRight" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03'||
'#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/th'||
'eme_1/bot_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t1success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t1notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t1NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => 'summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 17
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs
prompt  ......Page template 2884210922489435
 
begin
 
wwv_flow_api.create_template (
  p_id => 2884210922489435 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'One Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
''||unistr('\000a')||
'<script type="text/javascript" src="#WORKSPACE_IMAGES#jquery-1.10.2.js"></script>'||unistr('\000a')||
'<script type="text/javascript" src="#WORKSPACE_IMAGES#jquery-ui-1.10.4.custom.min.js"></script>'||unistr('\000a')||
'<script type="text/javascript" src="#WORKSPACE_IMAGES#jquery-ui-sliderAccess.js"></script>'||unistr('\000a')||
'<script type="text/javascript" src="#WORKSPACE_IMAGES#jquery-ui-timepicker-addon.min.js"></script>'||unistr('\000a')||
'<script type="text/javascript">'||unistr('\000a')||
'  // Für die Programmteile, die die neueste Version benötigen'||unistr('\000a')||
'  // z.B. datetimepicker'||unistr('\000a')||
'  var $j = jQuery.noConflict();'||unistr('\000a')||
''||unistr('\000a')||
'</script>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="shortcut icon" href="#WORKSPACE_IMAGES#goi.ico" type="image/ico">'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./theme_V2.css" type="text/css" />'||unistr('\000a')||
'<script type="application/x-javascript" src="#WORKSPACE_IMAGES#library.js"></script>'||unistr('\000a')||
'<script type="text/javascript" src="#WORKSPACE_IMAGES#attrchange.js"></script>'||unistr('\000a')||
'<script type="application/x-javascript" src="#WORKSPACE_IMAGES#fas.js"></script>'||unistr('\000a')||
'<script type="text/javascript">'||unistr('\000a')||
'  '||unistr('\000a')||
'   $j(document).ready(function() {'||unistr('\000a')||
'    var conf = "{}";'||unistr('\000a')||
''||unistr('\000a')||
'    //Datepicker'||unistr('\000a')||
'    if($(''#P0_DATE_PICKER_CONF'').length > 0 && $(''#P0_DATE_PICKER_CONF'').val() != null && $(''#P0_DATE_PICKER_CONF'').val() != "{}") {'||unistr('\000a')||
'      conf = $(''#P0_DATE_PICKER_CONF'').val(); '||unistr('\000a')||
'      try {'||unistr('\000a')||
'        conf = jQuery.parseJSON(conf); '||unistr('\000a')||
'        $j.datepicker.setDefaults(conf);  '||unistr('\000a')||
'      } catch(err) {'||unistr('\000a')||
'        alert(err + conf);'||unistr('\000a')||
'      }'||unistr('\000a')||
'    }  '||unistr('\000a')||
''||unistr('\000a')||
'    // Timepicker'||unistr('\000a')||
'    if($(''#P0_TIME_PICKER_CONF'').length > 0 && $(''#P0_TIME_PICKER_CONF'').val() != null && $(''#P0_TIME_PICKER_CONF'').val() != "{}") {'||unistr('\000a')||
'      conf = $(''#P0_TIME_PICKER_CONF'').val(); '||unistr('\000a')||
'      try {'||unistr('\000a')||
'        conf = jQuery.parseJSON(conf); '||unistr('\000a')||
'        $j.timepicker.setDefaults(conf);  '||unistr('\000a')||
'      } catch(err) {'||unistr('\000a')||
'        alert(err + conf);'||unistr('\000a')||
'      }'||unistr('\000a')||
'    }  '||unistr('\000a')||
'    '||unistr('\000a')||
'    '||unistr('\000a')||
'    $j(''.fas-date-picker'').datepicker({'||unistr('\000a')||
'        dateFormat: "dd.mm.yy"'||unistr('\000a')||
'    });'||unistr('\000a')||
''||unistr('\000a')||
'    $j(''.fas-date-time-picker'').datetimepicker({'||unistr('\000a')||
'        controlType: ''select'','||unistr('\000a')||
'	timeFormat: "HH:mm",'||unistr('\000a')||
'        dateFormat: "dd.mm.yy"'||unistr('\000a')||
'    });'||unistr('\000a')||
'  '||unistr('\000a')||
'    $j(''.fas-time-picker'').timepicker({'||unistr('\000a')||
'        controlType: ''select'','||unistr('\000a')||
'	timeFormat: "HH:mm",'||unistr('\000a')||
'        dateFormat: "dd.mm.yy"'||unistr('\000a')||
'    });'||unistr('\000a')||
''||unistr('\000a')||
'  });'||unistr('\000a')||
'</script>'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'<link rel="stylesheet" href="#WORKSPACE_IMAGES#fas.css" type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#  '
 ,p_box => 
'<table width="10%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>'||unistr('\000a')||
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <'||
'td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./top_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td he'||
'ight="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>'||unistr('\000a')||
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./top_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><br /></td>'||unistr('\000a')||
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" cl'||
'ass="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<div id="rollover" style="display:none;background:#FFF;border:2px solid #369;width:150px;position:absolute;padding:4px;"><div id="rollover_content"></div></div>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./bot_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER. &FAS_IDEN'||
'TITAET.</div></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./bot_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t1success" id="MESSAGE"><img src="#IMAGE_PREFIX#delete.gif" onclick="$x_Remove(''MESSAGE'')"  style="float:right;" class="pb" alt="" />#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./tab_on_right.png" border="0" alt="" /></td>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_non_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./tab_off_right.png" border="0" alt="" /></td>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t1notification" id="MESSAGE"><img src="#IMAGE_PREFIX#delete.gif" onclick="$x_Remove(''MESSAGE'')"  style="float:right;" class="pb" alt="" />#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t1NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_grid_type => 'TABLE'
 ,p_grid_always_use_max_columns => false
 ,p_grid_has_column_span => true
 ,p_grid_emit_empty_leading_cols => true
 ,p_grid_emit_empty_trail_cols => false
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '12'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/printer_friendly
prompt  ......Page template 2884522145489435
 
begin
 
wwv_flow_api.create_template (
  p_id => 2884522145489435 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'Printer Friendly'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
'.t1NavigationBar{white-space:nowrap;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top">'||unistr('\000a')||
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 5
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '3'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup
prompt  ......Page template 2884821992489435
 
begin
 
wwv_flow_api.create_template (
  p_id => 2884821992489435 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'Popup'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/&FAS_THEME_NAME./theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
'.t1NavigationBar{white-space:nowrap;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t1messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_01##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t1success" id="MESSAGE"><img src="#IMAGE_PREFIX#delete.gif" onclick="$x_Remove(''MESSAGE'')"  style="float:right;" class="pb" alt="" />#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t1notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs_with_sidebar
prompt  ......Page template 2903505931507739
 
begin
 
wwv_flow_api.create_template (
  p_id => 2903505931507739 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 13
 ,p_name => 'One Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><a id="t13Logo2" href="#">#LOGO#</a><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div id="t13PageTabs"><table cellpadding="0" cellspacing="0" border="0" summary="" class="t13PageTa'||
'bs"><tbody><tr>#TAB_CELLS#</tr></tbody></table>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<div id="t13BreadcrumbTop">&nbsp;</div>'||unistr('\000a')||
'<table class="t13Layout" cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13BreadcrumbRegion"><div class="t13Breadcrumbs">#REGION_POSITION_01#<span id="t13Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<a name="SkipRepNav"></a>'||unistr('\000a')||
'<div id="t13MessageHolder">#SUCCESS_ME'||
'SSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>'||unistr('\000a')||
'<div class="t13BodyMargin">'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_02#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top" width="100%">#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="htmldbColumnSep"><br '||
'/></div></td>'||unistr('\000a')||
'<td valign="top"><div style="float:right;">#REGION_POSITION_03#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</div>'
 ,p_footer_template => 
'<div class="t13NewBottom"><div id="t13User">&USER.</div><div class="t13NewBottom1">&BROWSER_LANGUAGE.</div>'||unistr('\000a')||
'<div class="t13NewBottom2">&MSG_COPYRIGHT.</div>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'<a name="END"><br /></a>'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t13SuccessMessage">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''
 ,p_current_tab => '<td class="OnL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OnC"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td class="OnR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnR.png" alt="" /></td>'
 ,p_non_current_tab => '<td class="OffL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OffC"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td class="OffR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffR.png" alt="" /></td>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t13Notification">#MESSAGE#</div>'||unistr('\000a')||
''
 ,p_navigation_bar => '<div id="t13NavBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t13NavLink">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 16
 ,p_error_page_template => '<br />'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<pre>#MESSAGE#</pre>'||unistr('\000a')||
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs
prompt  ......Page template 2903724887507740
 
begin
 
wwv_flow_api.create_template (
  p_id => 2903724887507740 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 13
 ,p_name => 'One Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<!--[if IE]><link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/ie.css" type="text/css" /><![endif]-->'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><a id="t13Logo2" href="#">#LOGO#</a><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div id="t13PageTabs"><table cellpadding="0" cellspacing="0" border="0" summary="" class="t13PageTa'||
'bs"><tbody><tr>#TAB_CELLS#</tr></tbody></table>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<div id="t13BreadcrumbTop">&nbsp;</div>'||unistr('\000a')||
'<table class="t13Layout" cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13BreadcrumbRegion"><div class="t13Breadcrumbs">#REGION_POSITION_01#<span id="t13Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<a name="SkipRepNav"></a>'||unistr('\000a')||
'<div id="t13MessageHolder">#SUCCESS_ME'||
'SSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>'||unistr('\000a')||
'<div class="t13BodyMargin">'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%">#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top"><div style="float:right;">#REGION_POSITION_03#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
''||
'</table>'||unistr('\000a')||
'</div>'
 ,p_footer_template => 
'<div class="t13NewBottom"><div id="t13User">&USER.</div><div class="t13NewBottom1">&BROWSER_LANGUAGE.</div>'||unistr('\000a')||
'<div class="t13NewBottom2">&MSG_COPYRIGHT.</div>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'<a name="END"><br /></a>'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t13SuccessMessage">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''
 ,p_current_tab => '<td class="OnL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OnC"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td class="OnR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnR.png" alt="" /></td>'
 ,p_non_current_tab => '<td class="OffL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OffC"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td class="OffR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffR.png" alt="" /></td>'
 ,p_top_non_curr_tab_font_attr => 'class="parenttabtextoff"'
 ,p_notification_message => '<div class="t13Notification">#MESSAGE#</div>'||unistr('\000a')||
''
 ,p_navigation_bar => '<div id="t13NavBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t13NavLink">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="2"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_error_page_template => '<br />'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<pre>#MESSAGE#</pre>'||unistr('\000a')||
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/printer_friendly
prompt  ......Page template 2904014312507740
 
begin
 
wwv_flow_api.create_template (
  p_id => 2904014312507740 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 13
 ,p_name => 'Printer Friendly'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top">'||unistr('\000a')||
'<div style="border:1px solid black;">#SUCCESS_MESSAG'||
'E##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#REGION_POSITION_05#'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t13success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t13notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div id="t13NavBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t13NavLink">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 5
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '3'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs_with_sidebar
prompt  ......Page template 2904306530507740
 
begin
 
wwv_flow_api.create_template (
  p_id => 2904306530507740 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 13
 ,p_name => 'Two Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><a id="t13Logo2" href="#">#LOGO#</a><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div id="t13PageTabs"><table cellpadding="0" cellspacing="0" border="0" summary="" class="t13PageTa'||
'bs"><tbody><tr>#PARENT_TAB_CELLS#</tr></tbody></table>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<div id="t13BreadcrumbTop2"><div>#TAB_CELLS#</div></div>'||unistr('\000a')||
'<table class="t13Layout" cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13BreadcrumbRegion"><div class="t13Breadcrumbs">#REGION_POSITION_01#</div><span id="t13Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<a name="SkipRepNav"></a>'||unistr('\000a')||
'<div id="t13Me'||
'ssageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>'||unistr('\000a')||
'<div class="t13BodyMargin">'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_02#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top" width="100%">#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div clas'||
's="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top"><div style="float:right;">#REGION_POSITION_03#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</div>'
 ,p_footer_template => 
'<div class="t13NewBottom"><div id="t13User">&USER.</div><div class="t13NewBottom1">&BROWSER_LANGUAGE.</div>'||unistr('\000a')||
'<div class="t13NewBottom2">&MSG_COPYRIGHT.</div>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'<a name="END"><br /></a>'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t13SuccessMessage">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<span class="OnC"><a href="#TAB_LINK#">#TAB_LABEL#</a></span><b>|</b>'
 ,p_non_current_tab => '<span class="OffC"><a href="#TAB_LINK#">#TAB_LABEL#</a></span><b>|</b>'||unistr('\000a')||
''
 ,p_top_current_tab => '<td class="OnL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OnC"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td class="OnR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnR.png" alt="" /></td>'
 ,p_top_non_curr_tab => '<td class="OffL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OffC"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td class="OffR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffR.png" alt="" /></td>'
 ,p_notification_message => '<div class="t13Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div id="t13NavBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t13NavLink">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width=""'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 18
 ,p_error_page_template => '<br />'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<pre>#MESSAGE#</pre>'||unistr('\000a')||
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs
prompt  ......Page template 2904619713507740
 
begin
 
wwv_flow_api.create_template (
  p_id => 2904619713507740 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 13
 ,p_name => 'No Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><a id="t13Logo2" href="#">#LOGO#</a><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div id="t13BreadcrumbTop">&nbsp;</div>'||unistr('\000a')||
'<table class="t13Layout" cellpadding="0" cellspacing="0" bo'||
'rder="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13BreadcrumbRegion"><div class="t13Breadcrumbs">#REGION_POSITION_01#<span id="t13Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<a name="SkipRepNav"></a>'||unistr('\000a')||
'<div id="t13MessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>'||unistr('\000a')||
'<div class="t13BodyMargin">'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" height="7'||
'0%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%">#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top"><div style="float:right;">#REGION_POSITION_03#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</div>'
 ,p_footer_template => 
'<div class="t13NewBottom"><div id="t13User">&USER.</div><div class="t13NewBottom1">&BROWSER_LANGUAGE.</div>'||unistr('\000a')||
'<div class="t13NewBottom2">&MSG_COPYRIGHT.</div>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'<a name="END"><br /></a>'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t13SuccessMessage">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t13Notification">#MESSAGE#</div>'||unistr('\000a')||
''
 ,p_navigation_bar => '<div id="t13NavBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t13NavLink">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="2" width=""'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 3
 ,p_error_page_template => '<br />'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<pre>#MESSAGE#</pre>'||unistr('\000a')||
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs
prompt  ......Page template 2904922381507740
 
begin
 
wwv_flow_api.create_template (
  p_id => 2904922381507740 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 13
 ,p_name => 'Two Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'||unistr('\000a')||
''
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><a id="t13Logo2" href="#">#LOGO#</a><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div id="t13PageTabs"><table cellpadding="0" cellspacing="0" border="0" summary="" class="t13PageTa'||
'bs"><tbody><tr>#PARENT_TAB_CELLS#</tr></tbody></table>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<div id="t13BreadcrumbTop2"><div>#TAB_CELLS#</div></div>'||unistr('\000a')||
'<table class="t13Layout" cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13BreadcrumbRegion"><div class="t13Breadcrumbs">#REGION_POSITION_01#</div><span id="t13Customize">#CUSTOMIZE#</span></td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<a name="SkipRepNav"></a>'||unistr('\000a')||
'<div id="t13Me'||
'ssageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>'||unistr('\000a')||
'<div class="t13BodyMargin">'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%">#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top"><div style="float:right;">#REGION_POSITI'||
'ON_03#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</div>'
 ,p_footer_template => 
'<div class="t13NewBottom"><div id="t13User">&USER.</div><div class="t13NewBottom1">&BROWSER_LANGUAGE.</div>'||unistr('\000a')||
'<div class="t13NewBottom2">&MSG_COPYRIGHT.</div>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'<a name="END"><br /></a>'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t13SuccessMessage">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<span class="OnC"><a href="#TAB_LINK#">#TAB_LABEL#</a></span><b>|</b>'||unistr('\000a')||
''
 ,p_non_current_tab => '<span class="OffC"><a href="#TAB_LINK#">#TAB_LABEL#</a></span><b>|</b>'||unistr('\000a')||
''
 ,p_top_current_tab => '<td class="OnL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OnC"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td class="OnR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnR.png" alt="" /></td>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_top_non_curr_tab => '<td class="OffL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OffC"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'<td class="OffR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffR.png" alt="" /></td>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t13Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div id="t13NavBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t13NavLink">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="2" width=""'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 2
 ,p_error_page_template => '<br />'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<pre>#MESSAGE#</pre>'||unistr('\000a')||
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup
prompt  ......Page template 2905227841507740
 
begin
 
wwv_flow_api.create_template (
  p_id => 2905227841507740 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 13
 ,p_name => 'Popup'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t13messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_01##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t13success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t13notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t13NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/login
prompt  ......Page template 2905507779507742
 
begin
 
wwv_flow_api.create_template (
  p_id => 2905507779507742 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 13
 ,p_name => 'Login'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'
 ,p_box => 
'<div id="t13Logo2">#LOGO#</div>'||unistr('\000a')||
'<div class="t13Sep"><br/></div>'||unistr('\000a')||
'<div id="t13BreadcrumbTop">&nbsp;</div>'||unistr('\000a')||
'<div class="t13BreadcrumbRegion"><br /></div>'||unistr('\000a')||
'<a name="SkipRepNav"></a>'||unistr('\000a')||
'<div id="t13MessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>'||unistr('\000a')||
'<div class="t13BodyMargin">'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" height="70%" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valig'||
'n="top">#REGION_POSITION_01#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top" width="100%" align="center"><table cellspacing="0" cellpadding="0" border="0" class="t13Sidebar" summary="" align="center" style="width:400px;">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="L"><br /></th>'||unistr('\000a')||
'<th class="C">&nbsp;</th>'||unistr('\000a')||
'<th class="R"><br /></th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3" '||
'class="B">#REGION_POSITION_02##REGION_POSITION_04##BOX_BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top" style="width:100%"><div style="float:right;">#REGION_POSITION_03##REGION_POSITION_05#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</div>'
 ,p_footer_template => 
'<div class="t13NewBottom"><div class="t13NewBottom1">&BROWSER_LANGUAGE.</div><div class="t13NewBottom2">&MSG_COPYRIGHT.</div><br style="clear:both;"/>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'<a name="END"><br /></a>'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t13SuccessMessage">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t13Notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t13NavLink">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
 ,p_theme_class_id => 6
 ,p_error_page_template => '<br />'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<pre>#MESSAGE#</pre>'||unistr('\000a')||
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs_with_sidebar
prompt  ......Page template 2905800183507742
 
begin
 
wwv_flow_api.create_template (
  p_id => 2905800183507742 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 13
 ,p_name => 'No Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css" />'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'
 ,p_box => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><a id="t13Logo2" href="#">#LOGO#</a><br />#REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#NAVIGATION_BAR#<br />#REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div id="t13BreadcrumbTop">&nbsp;</div>'||unistr('\000a')||
'<table class="t13Layout" cellpadding="0" cellspacing="0" bo'||
'rder="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13BreadcrumbRegion"><div class="t13Breadcrumbs">#REGION_POSITION_01#<span id="t13Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<a name="SkipRepNav"></a>'||unistr('\000a')||
'<div id="t13MessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>'||unistr('\000a')||
'<div class="t13BodyMargin">'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" height="7'||
'0%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_02#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top" width="100%">#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td class="t13ColumnSep"><div class="t13ColumnSep"><br /></div></td>'||unistr('\000a')||
'<td valign="top"><div style="float:right;">#REGION_POSITION_03#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</div>'
 ,p_footer_template => 
'<div class="t13NewBottom"><div id="t13User">&USER.</div><div class="t13NewBottom1">&BROWSER_LANGUAGE.</div>'||unistr('\000a')||
'<div class="t13NewBottom2">&MSG_COPYRIGHT.</div>'||unistr('\000a')||
'<br style="clear:both;"/>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE#'||unistr('\000a')||
'<a name="END"><br /></a>'||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t13SuccessMessage">#SUCCESS_MESSAGE#</div>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t13Notification">#MESSAGE#</div>'||unistr('\000a')||
''
 ,p_navigation_bar => '<div id="t13NavBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t13NavLink">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="2" width=""'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 17
 ,p_error_page_template => '<br />'||unistr('\000a')||
'<br />'||unistr('\000a')||
'<pre>#MESSAGE#</pre>'||unistr('\000a')||
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/login
prompt  ......Page template 2946322347426546
 
begin
 
wwv_flow_api.create_template (
  p_id => 2946322347426546 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'Login'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# style="background-color:#8fc58d;">#FORM_OPEN#'
 ,p_box => 
'<div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'<table align="center" border="0" cellpadding="0" cellspacing="0" summary="" class="t11Login">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table summary="" class="t11ReportsRegion" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-tl.gif" width="15" height="15" /></td>'||unistr('\000a')||
'<td align="righ'||
't" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-tr.gif" width="15" height="15" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t11RegionBody">#BOX_BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-bl.gif" width="15" height="15" /></td>'||unistr('\000a')||
'<td align="right" valign="bottom" class="t11RegionFooter"><img src="#IMAG'||
'E_PREFIX#themes/theme_11/t11corner-br.gif" width="15" height="15" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'||unistr('\000a')||
''
 ,p_success_message => '<div class="t11success">#MESSAGE#</div>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 6
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs
prompt  ......Page template 2946502947426557
 
begin
 
wwv_flow_api.create_template (
  p_id => 2946502947426557 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'No Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt="" /></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFI'||
'X#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><br /></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner_top.gif"  alt=""/></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" wi'||
'dth="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><br /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4midleftcorner.gif" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/1'||
'px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width="35" height="41"  alt=""/></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D"><br  /></td>'||unistr('\000a')||
'<td width="'||
'31"><br /></td>'||unistr('\000a')||
'<td align="left" valign="top" colspan="2">'||unistr('\000a')||
'#REGION_POSITION_01#'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"'||
'><br  /></td>'||unistr('\000a')||
'<td width="30"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45"   border="0"  alt=""/></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt='||
'""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</div>'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 3
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs_with_sidebar
prompt  ......Page template 2946819415426562
 
begin
 
wwv_flow_api.create_template (
  p_id => 2946819415426562 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'No Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt=""/></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFIX'||
'#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><br /></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner_top.gif" alt="" /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" wid'||
'th="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4midleftcorner.gif" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IM'||
'AGE_PREFIX#themes/theme_11/t4top.gif"><br /></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width="35" height="41"  alt=""/></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img s'||
'rc="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" colspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" w'||
'idth="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="'||
'#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45" alt="" /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif"'||
' width="31" height="45" alt=""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 17
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs
prompt  ......Page template 2947123360426564
 
begin
 
wwv_flow_api.create_template (
  p_id => 2947123360426564 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'One Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="shortcut icon" href="#WORKSPACE_IMAGES#goi.ico" type="image/ico">'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
''||unistr('\000a')||
'<script type="application/x-javascript" src="#WORKSPACE_IMAGES#library.js"></script>'||unistr('\000a')||
'<script type="application/x-javascript" src="#WORKSPACE_IMAGES#fas.js"></script>'||unistr('\000a')||
''||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28"   border="0" alt=""/></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="'||
'#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><table height="28" border="0" cellpadding="0" cellspacing="0"><tr>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner_top.gif" al'||
't="" /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4midleftcorner.gi'||
'f" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width="35" height="41"  alt=""/></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_P'||
'REFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" c'||
'olspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREF'||
'IX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45"  alt="" /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_'||
'PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt=""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'<div id="rollover" style="display:none;background:#FFF;border:2px solid #369;width:150px;position:absolute;padding:4px;"><div id="rollover_content"></div></div>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" '||
'/></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER. &FAS_IDENTITAET.</div></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td align="right" style="padding-left:5px"><table height="28" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="8" align="center"><img src="#IMAGE_PREFIX#themes/theme_11/t4toparrow.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="20" align="center" class="t11StandardTab"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td align="right" style="padding-left:5px"><table height="28" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td height="8" align="center"></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="20" align="center" class="t11StandardTab"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#</td>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '12'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs_with_sidebar
prompt  ......Page template 2947404400426565
 
begin
 
wwv_flow_api.create_template (
  p_id => 2947404400426565 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'One Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt=""/></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFIX'||
'#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><table height="28" border="0" cellpadding="0" cellspacing="0" summary=""><tr>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner_top.gif"  alt'||
'=""/></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4midleftcorner.gif"'||
' width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width="35" height="41" alt=""/></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREF'||
'IX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" co'||
'lspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFI'||
'X#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45"  alt="" /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_P'||
'REFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt=""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td align="right" style="padding-left:5px"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="8" align="center"><img src="#IMAGE_PREFIX#themes/theme_11/t4toparrow.gif" width="16" height="8" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="20" align="center" class="t11StandardTab"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td align="right" style="padding-left:5px"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td height="8" align="center"></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="20" align="center" class="t11StandardTab"><a href="#TAB_LINK#">#TAB_LABEL#</a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#TAB_INLINE_EDIT#</td>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 16
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup
prompt  ......Page template 2947727529426567
 
begin
 
wwv_flow_api.create_template (
  p_id => 2947727529426567 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'Popup'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_01##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/printer_friendly
prompt  ......Page template 2948025410426568
 
begin
 
wwv_flow_api.create_template (
  p_id => 2948025410426568 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'Printer Friendly'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" valign="top">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_08#</td>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top">'||unistr('\000a')||
'<div style="border:1px solid black;">#SUCCESS_MESSAG'||
'E##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#REGION_POSITION_05#'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t4success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t4notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 5
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '3'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs
prompt  ......Page template 2948326711426568
 
begin
 
wwv_flow_api.create_template (
  p_id => 2948326711426568 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'Two Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt="" /></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFI'||
'X#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#PARENT_TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/th'||
'eme_11/t4midrightcorner_top.gif"  alt=""/></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX'||
'#themes/theme_11/t4midleftcorner.gif" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width'||
'="35" height="41"  alt="" /></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1p'||
'x_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" colspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04##REGION_POSITION_05##REGION_POS'||
'ITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-colo'||
'r:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width="28" height="45" alt="" /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt=""/></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span cl'||
'ass="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td class="t11SubTab" valign="top"><div class="t11SubTabB"><a href="#TAB_LINK#">#TAB_LABEL#</a></div><div><img src="#IMAGE_PREFIX#themes/theme_11/t11toparrow2.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td class="t11SubTab" valign="top"><div><a href="#TAB_LINK#">#TAB_LABEL#</a></div><div><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" width="16" height="8" /></div>#TAB_INLINE_EDIT#</td>'
 ,p_top_current_tab => '<td class="t11StandardTab"><div><img src="#IMAGE_PREFIX#themes/theme_11/t4toparrow.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>'||unistr('\000a')||
'<div height="20" class="t4topnav"><a href="#TAB_LINK#">#TAB_LABEL#</a></div>#TAB_INLINE_EDIT#</td>'
 ,p_top_non_curr_tab => '<td class="t11StandardTab"><div><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>'||unistr('\000a')||
'<div height="20" class="t4topnav"><a href="#TAB_LINK#">#TAB_LABEL#</a></div>#TAB_INLINE_EDIT#</td>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => ': <a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 2
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '8'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs_with_sidebar
prompt  ......Page template 2948630688426571
 
begin
 
wwv_flow_api.create_template (
  p_id => 2948630688426571 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'Two Level Tabs with Sidebar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<div align="right">'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">&USER.#NAVIGATION_BAR##REGION_POSITION_06#</td>'||unistr('\000a')||
'<td width="100%" height="35" align="left" valign="top" class="t11top" style="padding-left:30px;">#REGION_POSITION_07#</td>'||unistr('\000a')||
'<td height="35" align="right" valign="top" cl'||
'ass="t11top" style="padding-right:30px;">#LOGO##REGION_POSITION_08#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="97%" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" align="left" valign="top" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4topleftcorner.jpg" width="28" height="28" alt="" /></td>'||unistr('\000a')||
'<td style="background-color:#91C58D"><img src="#IMAGE_PREFI'||
'X#themes/theme_11/1px_trans.gif" height="40" width="1" alt=""  /></td>'||unistr('\000a')||
'<td colspan="2" align="right" valign="top" nowrap="nowrap" style="background-color:#91C58D"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#PARENT_TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" style="background-color:#91C58D" valign="top"><img src="#IMAGE_PREFIX#themes/th'||
'eme_11/t4midrightcorner_top.gif" alt="" /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><img src="#IMAGE_PREFIX'||
'#themes/theme_11/t4midleftcorner.gif" width="31" height="41" alt="" /></td>'||unistr('\000a')||
'<td colspan="2" width="100%" height="41" background="#IMAGE_PREFIX#themes/theme_11/t4top.gif"><table height="28" border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'<td width="35" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/t4midrightcorner.gif" width'||
'="35" height="41" alt=""  /></td>'||unistr('\000a')||
'<td width="30" height="41"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="30" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td align="center" valign="top" style="background-color:#91C58D">#REGION_POSITION_02#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="31"><img src="#IMAGE_PREFIX#themes/theme_11/1p'||
'x_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td align="left" valign="top" colspan="2">'||unistr('\000a')||
'<!-- BEGIN BREADCRUMB -->#REGION_POSITION_01#<!-- BREADCRUMB  -->'||unistr('\000a')||
'<table summary="" cellpadding="0" cellspacing="0" border="0" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="100%"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_'||
'POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'</td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'<td width="30"><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="1" alt=""  /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td width="28" height="41" style="background-color:#91C58D"><img src="#IMAGE_PREFIX#themes/theme_11/t4bottomcornerleft.gif" width'||
'="28" height="45" alt=""  /></td>'||unistr('\000a')||
'<td width="31" align="left" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><img src="#IMAGE_PREFIX#themes/theme_11/t4lowleftcorner.gif" width="31" height="45" alt="" /></td>'||unistr('\000a')||
'<td width="31" colspan="4" align="right" background="#IMAGE_PREFIX#themes/theme_11/t4bottom.gif"><span class="t11Customize">#CUSTOMIZE#</span><br/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<!-- END BODY -'||
'->'||unistr('\000a')||
'</div>'||unistr('\000a')||
'<!-- END PAGE -->'
 ,p_footer_template => 
'<!-- BEGIN FOOTER -->'||unistr('\000a')||
'<div class="t11top"><!-- Copyright --></div>'||unistr('\000a')||
'<!-- END PAGE -->'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td class="t11SubTab" valign="top"><div class="t11SubTabB"><a href="#TAB_LINK#">#TAB_LABEL#</a></div><div><img src="#IMAGE_PREFIX#themes/theme_11/t11toparrow2.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td class="t11SubTab" valign="top"><div><a href="#TAB_LINK#">#TAB_LABEL#</a></div><div><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" width="16" height="8" /></div>#TAB_INLINE_EDIT#</td>'
 ,p_top_current_tab => '<td class="t11StandardTab"><div><img src="#IMAGE_PREFIX#themes/theme_11/t4toparrow.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>'||unistr('\000a')||
'<div height="20" class="t4topnav"><a href="#TAB_LINK#">#TAB_LABEL#</a></div>#TAB_INLINE_EDIT#</td>'
 ,p_top_non_curr_tab => '<td class="t11StandardTab"><div><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" width="16" height="8" hspace="0" vspace="0" border="0" /></div>'||unistr('\000a')||
'<div height="20" class="t4topnav"><a href="#TAB_LINK#">#TAB_LABEL#</a></div>#TAB_INLINE_EDIT#</td>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '&nbsp;:&nbsp;<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 18
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup_tabs
prompt  ......Page template 2972201276275107
 
begin
 
wwv_flow_api.create_template (
  p_id => 2972201276275107 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 103
 ,p_name => 'Popup Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'*{font-size:12px;font-family:Arial, Helvetica, Geneva, sans-serif;}'||unistr('\000a')||
'body{padding:0;margin:0;font-family:Arial, Helvetica, sans-serif;font-size:12px;}'||unistr('\000a')||
'a{color:#000000;}'||unistr('\000a')||
''||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
''||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD# >#FORM_OPEN#'
 ,p_box => 
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top"><div class="t11messages">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_01##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t11success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t11notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup_tabs
prompt  ......Page template 5388107276385937
 
begin
 
wwv_flow_api.create_template (
  p_id => 5388107276385937 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 1
 ,p_name => 'Popup Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css" />'||unistr('\000a')||
'<script type="application/x-javascript" src="#WORKSPACE_IMAGES#library.js"></script>'||unistr('\000a')||
'<style type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.t1NavigationBar{white-space:nowrap;}'||unistr('\000a')||
'ul.dhtmlTree {list-style:none;}'||unistr('\000a')||
'ul.dhtmlTree li{padding:2px 0;vertical-align:middle;}'||unistr('\000a')||
'ul.dhtmlTree li img{margin:0 4px;vertical-align:middle;}'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li a{float:left;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2{list-style-type:none;padding:0;margin:0;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 *{float:left;text-decoration:none;display:block;line-height:25px;height:25px;vertical-align:middle;white-space:nowrap;}'||unistr('\000a')||
'.dhtmlMenuLG2 li{border:1px solid #999;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem{margin:0 4px 0 0;} '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem a{padding:0 4px;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1{margin:0 4px 0 0;}  '||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 a{padding:0 4px;margin:0 4px 0 0;}'||unistr('\000a')||
'.dhtmlMenuLG2 li.dhtmlMenuItem1 img{margin:0 2px 0 0;}'||unistr('\000a')||
''||unistr('\000a')||
'.dhtmlSubMenu2 {background-color: #eee;font-size: 11px;width: 200px;border:1px solid #b7b7b7;list-style-type : none;margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlSubMenu2 li{margin:0em;padding-left:0em;}'||unistr('\000a')||
'.dhtmlMenuSep2{text-align:center;}'||unistr('\000a')||
'img.dhtmlMenuSep2{display:block; margin:auto; width:80%;border:1px solid #efefef; height:1px; background-color:#ccc; }'||unistr('\000a')||
'.dhtmlSubMenu2 img.dhtmlSep {width:180px;height:1px;}'||unistr('\000a')||
'.dhtmlSubMenu2 .t13MIMG {vertical-align:middle;float:right}'||unistr('\000a')||
'.dhtmlSubMenu2 .dhtmlSubMenuP {background-color:#ddd;text-align:center;color: #808080;border-bottom:#ccc 1px solid;padding:3px 8px;text-decoration: none;white-space: nowrap;font-weight:bold;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:link,.dhtmlSubMenu2 a.dhtmlSubMenuN:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuN:hover {background-color:#ddd;color:#000;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:link,.dhtmlSubMenu2 a.dhtmlSubMenuS:visited {color:#808080;display:block;font-weight:normal;padding:3px 8px;text-decoration:none;white-space:nowrap;height:1%;overflow:hidden;}'||unistr('\000a')||
'.dhtmlSubMenu2 a.dhtmlSubMenuS:hover {background-color:#ddd;color: #000;}'||unistr('\000a')||
'</style>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>'||unistr('\000a')||
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>'||unistr('\000a')||
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    '||
'<td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50'||
'%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>'||unistr('\000a')||
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><br /></td>'||unistr('\000a')||
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td width="100%" valign="top" class="t1PageBody">'||
'<div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04#</td>'||unistr('\000a')||
'<td valign="top">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>'||unistr('\000a')||
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>'||unistr('\000a')||
'    <td><img src="#IMAGE_PREFIX#themes/th'||
'eme_1/bot_bar_right.png" alt="" /></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<br />'||unistr('\000a')||
'#REGION_POSITION_05#'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t1success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_non_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>'||unistr('\000a')||
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t1notification">#MESSAGE#</div>'
 ,p_navigation_bar => '<div class="t1NavigationBar">#BAR_BODY#</div>'
 ,p_navbar_entry => '<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
 ,p_region_table_cattributes => ' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '12'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs
prompt  ......Page template 7159107367739435
 
begin
 
wwv_flow_api.create_template (
  p_id => 7159107367739435 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 12
 ,p_name => 'Two Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table class="t12PageBody" cellpadding="0" cellspacing="0" width="100%" summary="">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td colspan="2" class="t12ApplicationLogo">#LOGO#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12UserName">&APP_USER. <span class="t12NavBar">#NAVIGATION_BAR#</span></td>'||unistr('\000a')||
'  <td align="right" valign="bottom"><table cellpadding="0" cellspacing="0" summary=""><tr>#PARENT_TAB_CELLS#</tr></table></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td cols'||
'pan="2" class="t12Tabs"><table cellpadding="0" cellspacing="0" summary=""><tr>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr><td colspan="2">#REGION_POSITION_01#</td></tr> '||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" summary="" height="70%">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12ContentBody" valign="top"><div class="t12Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_02##REGION_'||
'POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'  <td align="right" valign="top" class="t12ContentBody">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table class="t12PageFooter" width="100%" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr><td align="right">#CUSTOMIZE#</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterTop">&nbsp;</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterBottom">&nbsp;</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t12success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td><a href="#TAB_LINK#" class="t12standardtabcurrent">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td><a href="#TAB_LINK#" class="t12standardtabnoncurrent">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'
 ,p_top_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentLeft.gif" alt="" /></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentBackground.gif); background-repeat:repeat;"><a class="t12standardtabcurrent" href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentRight.gif" alt="" /></td>'||unistr('\000a')||
''
 ,p_top_non_curr_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentLeft.gif" alt="" /></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentBackground.gif); background-repeat:repeat;"><a class="t12standardtabnoncurrent"  href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentRight.gif" alt="" /></td>'
 ,p_notification_message => '<div class="t12notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t12NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 2
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '8'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/two_level_tabs_with_side_bar
prompt  ......Page template 7159224179739442
 
begin
 
wwv_flow_api.create_template (
  p_id => 7159224179739442 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 12
 ,p_name => 'Two Level Tabs with Side Bar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'||unistr('\000a')||
''
 ,p_box => 
'<table class="t12PageBody" cellpadding="0" cellspacing="0" width="100%" summary="">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td colspan="2" class="t12ApplicationLogo">#LOGO#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12UserName">&APP_USER. <span class="t12NavBar">#NAVIGATION_BAR#</span></td>'||unistr('\000a')||
'  <td align="right" valign="bottom"><table cellpadding="0" cellspacing="0" summary=""><tr>#PARENT_TAB_CELLS#</tr></table>'||unistr('\000a')||
'  </td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td c'||
'olspan="2" class="t12Tabs">'||unistr('\000a')||
'   <table cellpadding="0" cellspacing="0" summary=""><tr>#TAB_CELLS#</tr></table>'||unistr('\000a')||
'  </td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div>#REGION_POSITION_01#</div>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" class="t12SidebarLayout" width="100%" summary="" height="70%">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td valign="top" width="150">'||unistr('\000a')||
'     <table cellpadding="0" cellspacing="0" width="100%" class="t12SidebarColor" s'||
'ummary="">'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td><br /></td>'||unistr('\000a')||
'          <td width="5" valign="top" background="#IMAGE_PREFIX#themes/theme_12/SidebarRightSide.gif"><img src="#IMAGE_PREFIX#themes/theme_12/SidebarUpperRight.gif" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'         <td valign="top" class="t12SideBarNav">#REGION_POSITION_02#</td>'||unistr('\000a')||
'         <td width="5" background="#IMAGE_PREFIX#themes/theme_12/Sideb'||
'arRightSide.gif"><br /></td>'||unistr('\000a')||
'       </tr>'||unistr('\000a')||
'       <tr bgcolor="#FFFFFF">'||unistr('\000a')||
'          <td valign="top"><img width="100%" height="14" src="#IMAGE_PREFIX#themes/theme_12/SidebarBottomMiddle.gif" alt="" /></td> '||unistr('\000a')||
'          <td valign="top" width="5"><img src="#IMAGE_PREFIX#themes/theme_12/SidebarBottomRight.gif" alt="" /><br /><br /></td>'||unistr('\000a')||
'       </tr>  '||unistr('\000a')||
'     </table>'||unistr('\000a')||
'   </td>'||unistr('\000a')||
'   <td class="t12ContentBody"'||
' valign="top"><div class="t12Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'  <td align="right" valign="top" class="t12ContentBody">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table class="t12PageFooter" width="100%" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr><td align="right">#CUSTOMIZE#</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterTop">&nbsp;</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterBottom">&nbsp;</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t12success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td><a href="#TAB_LINK#" class="t12standardtabcurrent">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'
 ,p_non_current_tab => '<td><a href="#TAB_LINK#" class="t12standardtabnoncurrent">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'
 ,p_top_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentLeft.gif" alt="" /></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentBackground.gif); background-repeat:repeat;"><a class="t12parenttabcurrent" href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentRight.gif" alt="" /></td>'
 ,p_top_non_curr_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentLeft.gif" alt="" /></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentBackground.gif); background-repeat:repeat;"><a class="t12parenttabnoncurrent" href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentRight.gif" alt="" /></td>'
 ,p_notification_message => '<div class="t12notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t12NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 18
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs
prompt  ......Page template 7159330264739443
 
begin
 
wwv_flow_api.create_template (
  p_id => 7159330264739443 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 12
 ,p_name => 'No Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table class="t12PageBody" cellpadding="0" cellspacing="0" width="100%" summary="">'||unistr('\000a')||
' <tr><td colspan="2" class="t12ApplicationLogo">#LOGO#</td></tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12UserName">&APP_USER. <span class="t12NavBar">#NAVIGATION_BAR#</span></td>'||unistr('\000a')||
'  <td align="right" valign="bottom"><br /></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr><td colspan="2" class="t12VerticalBar"><img src="#IMAGE_PREFIX#themes/theme_12/ParentTabBase.gi'||
'f" alt="" /></td></tr>'||unistr('\000a')||
' <tr><td colspan="2">#REGION_POSITION_01#</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" summary="" height="70%"><tr>'||unistr('\000a')||
'<td valign="top" class="t12ContentBody"><div class="t12Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||
''||unistr('\000a')||
'<td align="right" valign="top" class="t12ContentBody">#REGION_POSITION_03##CUSTOMIZE#<br /></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table class="t12PageFooter" width="100%" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr><td align="right">#CUSTOMIZE#</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterTop">&nbsp;</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterBottom">&nbsp;</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t12success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t12notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t12NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 3
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs_with_side_bar
prompt  ......Page template 7159424851739443
 
begin
 
wwv_flow_api.create_template (
  p_id => 7159424851739443 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 12
 ,p_name => 'One Level Tabs with Side Bar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table class="t12PageBody" cellpadding="0" cellspacing="0" width="100%" summary="">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td colspan="2" class="t12ApplicationLogo">#LOGO#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12UserName">&APP_USER. <span class="t12NavBar">#NAVIGATION_BAR#</span></td>'||unistr('\000a')||
'  <td align="right" valign="bottom">'||unistr('\000a')||
'   <table cellpadding="0" cellspacing="0" summary=""><tr>#TAB_CELLS#</tr></table>'||unistr('\000a')||
'  </td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr><td colspan'||
'="2" class="t12VerticalBar"><img src="#IMAGE_PREFIX#themes/theme_12/ParentTabBase.gif" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div>#REGION_POSITION_01#</div>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" class="t12SidebarLayout" width="100%" summary="" height="70%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'  <td valign="top" width="150">'||unistr('\000a')||
'    <table cellpadding="0" cellspacing="0" width="100%" class="t12SidebarColor" summary="">'||unistr('\000a')||
'       <tr'||
'>'||unistr('\000a')||
'         <td>&nbsp;</td>'||unistr('\000a')||
'         <td width="15" valign="top" background="#IMAGE_PREFIX#themes/theme_12/SidebarRightSide.gif"><img src="#IMAGE_PREFIX#themes/theme_12/SidebarUpperRight.gif" alt="" /></td>'||unistr('\000a')||
'       </tr>'||unistr('\000a')||
'       <tr>'||unistr('\000a')||
'        <td valign="top" class="t12SideBarNav">#REGION_POSITION_02#</td>'||unistr('\000a')||
'        <td width="15" background="#IMAGE_PREFIX#themes/theme_12/SidebarRightSide.gif">&nbsp;</t'||
'd>'||unistr('\000a')||
'      </tr>'||unistr('\000a')||
'      <tr bgcolor="#FFFFFF">'||unistr('\000a')||
'         <td valign="top">'||unistr('\000a')||
'           <img width="100%" height="14" src="#IMAGE_PREFIX#themes/theme_12/SidebarBottomMiddle.gif" alt="" /></td> '||unistr('\000a')||
'         <td valign="top" width="15"><img src="#IMAGE_PREFIX#themes/theme_12/SidebarBottomRight.gif" alt="" /><br /><br /></td>'||unistr('\000a')||
'      </tr>  '||unistr('\000a')||
'    </table>'||unistr('\000a')||
'  </td>'||unistr('\000a')||
'  <td class="t12ContentBody" valign="top"><div cl'||
'ass="t12Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'  <td align="right" valign="top" class="t12ContentBody">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table class="t12PageFooter" width="100%" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr><td align="right">#CUSTOMIZE#</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterTop">&nbsp;</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterBottom">&nbsp;</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t12success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentLeft.gif" alt="" /></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentBackground.gif); background-repeat:repeat;"><a class="t12parenttabcurrent" href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentRight.gif" alt="" /></td>'
 ,p_non_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentLeft.gif" alt="" /></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentBackground.gif); background-repeat:repeat;"><a class="t12parenttabnoncurrent" href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentRight.gif" alt="" /></td>'
 ,p_notification_message => '<div class="t12notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t12NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 16
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/popup
prompt  ......Page template 7159522112739443
 
begin
 
wwv_flow_api.create_template (
  p_id => 7159522112739443 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 12
 ,p_name => 'Popup'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme.css" type="text/css" />'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body bgcolor="#FFFFFF" #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<div class="t12Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_02##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#'||unistr('\000a')||
''
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t12success"><img src="#IMAGE_PREFIX#themes/theme_12/success_w.gif" width="24" height="23" alt="" class="success" />#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t12notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t12NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_theme_class_id => 4
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/one_level_tabs
prompt  ......Page template 7159632687739445
 
begin
 
wwv_flow_api.create_template (
  p_id => 7159632687739445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 12
 ,p_name => 'One Level Tabs'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table class="t12PageBody" cellpadding="0" cellspacing="0" width="100%" summary="">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td colspan="2" class="t12ApplicationLogo">#LOGO#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12UserName">&APP_USER. <span class="t12NavBar">#NAVIGATION_BAR#</span></td>'||unistr('\000a')||
'  <td align="right" valign="bottom"><table cellpadding="0" cellspacing="0" summary=""><tr>#TAB_CELLS#</tr></table></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr><td colspan="2" cl'||
'ass="t12VerticalBar"><img src="#IMAGE_PREFIX#themes/theme_12/ParentTabBase.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td colspan="2">#REGION_POSITION_01#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table width="100%" summary="" height="70%">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12ContentBody" valign="top"><div class="t12Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_02##REGION_POSITION_'||
'04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'  <td align="right" valign="top" class="t12ContentBody">#REGION_POSITION_03#<br /></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table class="t12PageFooter" width="100%" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
' <td align="right">#CUSTOMIZE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
' <td class="t12FooterTop">&nbsp;</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
' <td class="t12FooterBottom">&nbsp;</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t12success">#SUCCESS_MESSAGE#</div>'
 ,p_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentLeft.gif" alt=""></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentBackground.gif); background-repeat:repeat;"><a class="t12parenttabcurrent" href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabCurrentRight.gif" alt=""></td>'
 ,p_non_current_tab => '<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentLeft.gif" alt="" /></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentBackground.gif); background-repeat:repeat;"><a class="t12parenttabnoncurrent" href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/StandardTabNonCurrentRight.gif" alt="" /></td>'
 ,p_notification_message => '<div class="t12notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t12NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_03'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 1
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/login
prompt  ......Page template 7159710321739445
 
begin
 
wwv_flow_api.create_template (
  p_id => 7159710321739445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 12
 ,p_name => 'Login'
 ,p_is_popup => false
 ,p_body_title => '#BODY_TITLE#'
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'    #APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'#NOTIFICATION_MESSAGE#'||unistr('\000a')||
'<table class="t12Login" align="center" summary=""><tr><td class="t12Body">#BOX_BODY#</td></tr></table>'||unistr('\000a')||
''
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'||unistr('\000a')||
''
 ,p_notification_message => '<div class="t12notification">#MESSAGE#</div>'
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_theme_class_id => 6
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/printer_friendly
prompt  ......Page template 7159810642739445
 
begin
 
wwv_flow_api.create_template (
  p_id => 7159810642739445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 12
 ,p_name => 'Printer Friendly'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme.css" type="text/css" />'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body bgcolor="#FFFFFF" #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'#LOGO#'||unistr('\000a')||
'<br />#BOX_BODY#'
 ,p_footer_template => 
'#FORM_CLOSE##DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t12success"><img src="#IMAGE_PREFIX#themes/theme_12/success_w.gif" width="24" height="23" alt="" class="t12success" />#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t12notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t12NavBarItem">#TEXT#</a>'||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_03'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 5
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
 ,p_template_comment => '3'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/page/no_tabs_with_side_bar
prompt  ......Page template 7159911286739445
 
begin
 
wwv_flow_api.create_template (
  p_id => 7159911286739445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_theme_id => 12
 ,p_name => 'No Tabs with Side Bar'
 ,p_is_popup => false
 ,p_header_template => '<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">'||unistr('\000a')||
'<head>'||unistr('\000a')||
'#APEX_CSS#'||unistr('\000a')||
'#TEMPLATE_CSS#'||unistr('\000a')||
'#THEME_CSS#'||unistr('\000a')||
'#PAGE_CSS#'||unistr('\000a')||
'#APEX_JAVASCRIPT#'||unistr('\000a')||
'#TEMPLATE_JAVASCRIPT#'||unistr('\000a')||
'#APPLICATION_JAVASCRIPT#'||unistr('\000a')||
'#PAGE_JAVASCRIPT#'||unistr('\000a')||
'#HEAD#'||unistr('\000a')||
'<title>#TITLE#</title>'||unistr('\000a')||
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme_V2.css" type="text/css" />'||unistr('\000a')||
'</head>'||unistr('\000a')||
'<body #ONLOAD#>#FORM_OPEN#'
 ,p_box => 
'<table class="t12PageBody" cellpadding="0" cellspacing="0" width="100%" summary="">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td colspan="2" class="t12ApplicationLogo">#LOGO#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12UserName">&APP_USER. <span class="t12NavBar">#NAVIGATION_BAR#</span></td>'||unistr('\000a')||
'  <td align="right" valign="bottom"><br /></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr><td colspan="2" class="t12VerticalBar"><img src="#IMAGE_PREFIX#themes/theme_12/ParentTabBa'||
'se.gif" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<div>#REGION_POSITION_01#</div>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0" class="t12SidebarLayout" width="100%" summary="" height="70%">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td valign="top" width="150">'||unistr('\000a')||
'     <table cellpadding="0" cellspacing="0" width="100%" class="t12SidebarColor" summary="">'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td><br /></td>'||unistr('\000a')||
'          <td width="5" valign="top" background'||
'="#IMAGE_PREFIX#themes/theme_12/SidebarRightSide.gif"><img src="#IMAGE_PREFIX#themes/theme_12/SidebarUpperRight.gif" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'         <td valign="top" class="t12SideBarNav">#REGION_POSITION_02#</td>'||unistr('\000a')||
'         <td width="5" background="#IMAGE_PREFIX#themes/theme_12/SidebarRightSide.gif" alt="" />&nbsp;</td>'||unistr('\000a')||
'       </tr>'||unistr('\000a')||
'       <tr bgcolor="#FFFFFF">'||unistr('\000a')||
'          <td va'||
'lign="top"><img width="100%" height="14" src="#IMAGE_PREFIX#themes/theme_12/SidebarBottomMiddle.gif" alt="" /></td> '||unistr('\000a')||
'          <td valign="top" width="5"><img src="#IMAGE_PREFIX#themes/theme_12/SidebarBottomRight.gif" alt="" /><br /><br /></td>'||unistr('\000a')||
'       </tr>  '||unistr('\000a')||
'     </table>'||unistr('\000a')||
'   </td>'||unistr('\000a')||
'   <td class="t12ContentBody" valign="top"><div class="t12Messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATI'||
'ON_MESSAGE#</div>'||unistr('\000a')||
'#BOX_BODY##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##REGION_POSITION_07##REGION_POSITION_08#</td>'||unistr('\000a')||
'   <td align="right" valign="top" class="t12ContentBody">#REGION_POSITION_03# #CUSTOMIZE#<br /></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'
 ,p_footer_template => 
'<table class="t12PageFooter" width="100%" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr><td align="right">#CUSTOMIZE#</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterTop">&nbsp;</td></tr>'||unistr('\000a')||
'<tr><td class="t12FooterBottom">&nbsp;</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#FORM_CLOSE# '||unistr('\000a')||
'#DEVELOPER_TOOLBAR#'||unistr('\000a')||
'#GENERATED_CSS#'||unistr('\000a')||
'#GENERATED_JAVASCRIPT#'||unistr('\000a')||
'</body>'||unistr('\000a')||
'</html>'
 ,p_success_message => '<div class="t12success">#SUCCESS_MESSAGE#</div>'
 ,p_notification_message => '<div class="t12notification">#MESSAGE#</div>'
 ,p_navigation_bar => '#BAR_BODY#'
 ,p_navbar_entry => '<a href="#LINK#" class="t12NavBarItem">#TEXT#</a>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_region_table_cattributes => 'width="100%" border="0" cellpadding="0" cellspacing="0" summary="" '
 ,p_sidebar_def_reg_pos => 'REGION_POSITION_02'
 ,p_breadcrumb_def_reg_pos => 'REGION_POSITION_01'
 ,p_theme_class_id => 17
 ,p_grid_type => 'TABLE'
 ,p_has_edit_links => true
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

prompt  ...button templates
--
--application/shared_components/user_interface/templates/button/button_alternative_2
prompt  ......Button Template 2781227687266423
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2781227687266423 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 2'
 ,p_template => 
'<a href="#LINK#" class="t15Button2">#LABEL#</a>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 5
 ,p_theme_id => 15
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_1
prompt  ......Button Template 2781415154266426
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2781415154266426 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 1'
 ,p_template => 
'<table class="t15Button1" cellspacing="0" cellpadding="0" border="0"  summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_15/button_left.gif" alt="" width="4" height="24" /></a></td>'||unistr('\000a')||
'<td class="t15C"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'<td class="t15R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_15/button_right.gif" width="4" height="24" alt="" /></a></t'||
'd>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 4
 ,p_template_comment => 'BLAF style, rounded on left side only. Uses classes in platform2.css or /css/einstein.css'
 ,p_theme_id => 15
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button
prompt  ......Button Template 2781605937266426
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2781605937266426 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button'
 ,p_template => 
'<table class="t15Button" cellspacing="0" cellpadding="0" border="0"  summary=""><tr>'||unistr('\000a')||
'<td class="t15L"><img src="#IMAGE_PREFIX#themes/theme_15/button-l.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15C"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'<td class="t15R"><img src="#IMAGE_PREFIX#themes/theme_15/button-r.gif" alt="" /></td>'||unistr('\000a')||
'</tr></table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_theme_id => 15
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_3
prompt  ......Button Template 2781817621266426
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2781817621266426 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 3'
 ,p_template => 
'<a href="#LINK#" class="t15Button3">#LABEL#</a>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 2
 ,p_template_comment => 'Standard Button'
 ,p_theme_id => 15
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_1
prompt  ......Button Template 2802210235273779
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2802210235273779 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 1'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ButtonAlternative1">'||unistr('\000a')||
'    <tr>'||unistr('\000a')||
'      <td class="t8C"><a href="#" class="t8C">#LABEL#</a></td>'||unistr('\000a')||
'    </tr>'||unistr('\000a')||
'  </table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 4
 ,p_theme_id => 8
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_3
prompt  ......Button Template 2802416541273779
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2802416541273779 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 3'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ButtonAlternative3">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="middle"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" style="margin-left:3px;margin-right:3px;" alt=""/></a></td>'||unistr('\000a')||
'<td class="t8R"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" alt="" width="14" height="14" /></td>'||unistr('\000a')||
'<td class="t8C"><a href='||
'"#LINK#" class="t8C">#LABEL#</a></td>'||unistr('\000a')||
'<td class="t8L"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" alt="" width="14" height="14" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 2
 ,p_theme_id => 8
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_2
prompt  ......Button Template 2802623737273779
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2802623737273779 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 2'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ButtonAlternative2">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td class="t8C"><a href="#" class="t8C">#LABEL#</a></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 5
 ,p_theme_id => 8
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button
prompt  ......Button Template 2802823752273779
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2802823752273779 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8Button" height="18"><tr><td class="t8C"><a href="#LINK#" class="t8C">#LABEL#</a></td></tr></table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_theme_id => 8
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_3
prompt  ......Button Template 2822531302468448
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2822531302468448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 3'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t11Button">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn1_corner_tl.gif" width="8" height="16"  alt=""/></a></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#LABEL#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><a href="#LINK#"><img src="#IMAGE_PREFIX#t'||
'hemes/theme_11/t11btn1_corner_tr.gif" width="8" height="16"  alt=""/></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 2
 ,p_theme_id => 11
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_1
prompt  ......Button Template 2822724687468448
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2822724687468448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 1'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ButtonAlternative1">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn2_corner_tl.gif" width="8" height="16"  alt=""/></a></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#LABEL#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><span class="t11R"><a href="#L'||
'INK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn2_corner_tr.gif" width="8" height="16"  alt=""/></a></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 4
 ,p_theme_id => 11
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button
prompt  ......Button Template 2822918909468448
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2822918909468448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ButtonAlternative3">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><a href="#LINK#" class="t11C" title=""><img src="#IMAGE_PREFIX#themes/theme_11/t11btn4_corner_tl.gif" width="8" height="16" alt=""/></a></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C" title="">#LABEL#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L">'||
'<span class="t11R"><a href="#LINK#" title="" class="t11C"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn4_corner_tr.gif" width="8" height="16"  alt=""/></a></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_theme_id => 11
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_2
prompt  ......Button Template 2823106973468448
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2823106973468448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 2'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ButtonAlternative2">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn3_corner_tl.gif" width="8" height="16"  alt=""/></a></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#LABEL#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><span class="t11R"><a href="#L'||
'INK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn3_corner_tr.gif" width="8" height="16"  alt=""/></a></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 5
 ,p_theme_id => 11
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button
prompt  ......Button Template 2843105788474909
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2843105788474909 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button'
 ,p_template => 
'<input onclick="#LINK#" class="t17Button" value="#LABEL#" type="button" />'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_template_comment => 'Standard Button'
 ,p_theme_id => 17
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_2
prompt  ......Button Template 2843328563474909
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2843328563474909 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 2'
 ,p_template => 
'<input onclick="#LINK#" class="t17ButtonAlternative2" value="#LABEL#" type="button" />'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 5
 ,p_template_comment => 'Standard Button'
 ,p_theme_id => 17
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_1
prompt  ......Button Template 2843519489474909
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2843519489474909 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 1'
 ,p_template => 
'<input onclick="#LINK#" class="t17ButtonAlternative1" value="#LABEL#" type="button" />'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 4
 ,p_template_comment => 'XP Square FFFFFF'
 ,p_theme_id => 17
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_3
prompt  ......Button Template 2843713686474909
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2843713686474909 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 3'
 ,p_template => 
'<input onclick="#LINK#" class="t17ButtonAlternative3" value="#LABEL#" type="button" />'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 2
 ,p_template_comment => 'Standard Button'
 ,p_theme_id => 17
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button
prompt  ......Button Template 2863829455481232
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2863829455481232 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Button">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Button1Left.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'<td class="M" valign="middle"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Button1Right.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_template_comment => 'Standard Button'
 ,p_theme_id => 16
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_2
prompt  ......Button Template 2864011146481234
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2864011146481234 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 2'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Button2">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Button2Left.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'<td class="M" valign="middle"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Button2Right.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 5
 ,p_template_comment => 'Standard Button'
 ,p_theme_id => 16
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_1
prompt  ......Button Template 2864208960481234
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2864208960481234 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 1'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Button1">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16ButtonC1Left.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'<td class="M" valign="middle"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16ButtonC1Right.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 4
 ,p_template_comment => 'XP Square FFFFFF'
 ,p_theme_id => 16
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_3
prompt  ......Button Template 2864409607481234
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2864409607481234 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 3'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Button3">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Button3Left.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'<td class="M" valign="middle"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Button3Right.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 2
 ,p_template_comment => 'Standard Button'
 ,p_theme_id => 16
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_3
prompt  ......Button Template 2885111887489435
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2885111887489435 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 3'
 ,p_template => 
'<table class="t1ButtonAlternative3" cellspacing="0" cellpadding="0" border="0"  summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_alt3_left.gif" alt="" width="6" height="25" /></a></td>'||unistr('\000a')||
'<td class="t1C"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_alt3_right.gif" width="6" height="25" a'||
'lt="" /></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 2
 ,p_template_comment => 'Standard Button'
 ,p_theme_id => 1
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button
prompt  ......Button Template 2885332167489437
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2885332167489437 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button'
 ,p_template => 
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="" id="#BUTTON_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>'||unistr('\000a')||
'<td class="t1C"><a href="#LINK#" #BUTTON_ATTRIBUTES#>#LABEL#</a></td>'||unistr('\000a')||
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4'||
'" height="24" alt="" /></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_theme_id => 1
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_1
prompt  ......Button Template 2885505659489437
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2885505659489437 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 1'
 ,p_template => 
'<table class="t1ButtonAlternative1" cellspacing="0" cellpadding="0" border="0"  summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_alt1_left.gif" alt="" width="11" height="20" /></a></td>'||unistr('\000a')||
'<td class="t1C"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_alt1_right.gif" width="11" height="20"'||
' alt="" /></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 4
 ,p_theme_id => 1
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_2
prompt  ......Button Template 2885726143489437
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2885726143489437 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 2'
 ,p_template => 
'<table class="t1ButtonAlternative2" cellspacing="0" cellpadding="0" border="0"  summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_alt2_left.gif" alt="" width="11" height="20" /></a></td>'||unistr('\000a')||
'<td class="t1C"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_alt2_right.gif" width="11" height="20"'||
' alt="" /></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 5
 ,p_template_comment => 'XP Square FFFFFF'
 ,p_theme_id => 1
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_2
prompt  ......Button Template 2906101054507742
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2906101054507742 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 2'
 ,p_template => 
'<a href="#LINK#" class="t13ButtonAlternative2">#LABEL#</a>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 5
 ,p_theme_id => 13
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_3
prompt  ......Button Template 2906314343507742
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2906314343507742 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 3'
 ,p_template => 
'<a href="#LINK#" class="t13ButtonAlternative3">#LABEL#</a>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 2
 ,p_theme_id => 13
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_1
prompt  ......Button Template 2906506282507742
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2906506282507742 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 1'
 ,p_template => 
'<a href="#LINK#" class="t13ButtonAlternative1">#LABEL#</a>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 4
 ,p_theme_id => 13
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button
prompt  ......Button Template 2906714293507742
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2906714293507742 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button'
 ,p_template => 
'<input type="button" onclick="#LINK#" value="#LABEL#" class="t13Button" />'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_theme_id => 13
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button
prompt  ......Button Template 2962031294426603
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2962031294426603 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ButtonAlternative3">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><a href="#LINK#" class="t11C" title=""><img src="#IMAGE_PREFIX#themes/theme_11/t11btn4_corner_tl.gif" width="8" height="16" alt=""/></a></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C" title="">#LABEL#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L">'||
'<span class="t11R"><a href="#LINK#" title="" class="t11C"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn4_corner_tr.gif" width="8" height="16"  alt=""/></a></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_theme_id => 103
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_1
prompt  ......Button Template 2962205888426604
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2962205888426604 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 1'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ButtonAlternative1">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn2_corner_tl.gif" width="8" height="16"  alt=""/></a></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#LABEL#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><span class="t11R"><a href="#L'||
'INK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn2_corner_tr.gif" width="8" height="16"  alt=""/></a></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 4
 ,p_theme_id => 103
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_2
prompt  ......Button Template 2962425076426604
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2962425076426604 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 2'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ButtonAlternative2">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn3_corner_tl.gif" width="8" height="16"  alt=""/></a></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#LABEL#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><span class="t11R"><a href="#L'||
'INK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn3_corner_tr.gif" width="8" height="16"  alt=""/></a></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 5
 ,p_theme_id => 103
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_3
prompt  ......Button Template 2962606464426604
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2962606464426604 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 3'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t11Button">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn1_corner_tl.gif" width="8" height="16"  alt=""/></a></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#LABEL#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><a href="#LINK#"><img src="#IMAGE_PREFIX#t'||
'hemes/theme_11/t11btn1_corner_tr.gif" width="8" height="16"  alt=""/></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 2
 ,p_theme_id => 103
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_ohne_check
prompt  ......Button Template 2964109197498468
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 2964109197498468 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'button_ohne_check'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ButtonAlternative3">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><a href="#LINK#" class="t11C" title=""><img src="#IMAGE_PREFIX#themes/theme_11/t11btn4_corner_tl.gif" width="8" height="16" alt=""/></a></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" onclick="xwoher=2" class="t11C" title="">#LABEL#</a></td>'||unistr('\000a')||
'<td align="right" valign='||
'"top" class="t11L"><span class="t11R"><a href="#LINK#" title="" class="t11C"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn4_corner_tr.gif" width="8" height="16"  alt=""/></a></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_theme_id => 103
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_ohne_check
prompt  ......Button Template 5444705864405057
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 5444705864405057 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button_ohne_check'
 ,p_template => 
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="" id="#BUTTON_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>'||unistr('\000a')||
'<td class="t1C"><a href="#LINK#" onclick="xwoher=2" #BUTTON_ATTRIBUTES#>#LABEL#</a></td>'||unistr('\000a')||
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_'||
'right.gif" width="4" height="24" alt="" /></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_theme_id => 1
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_1
prompt  ......Button Template 7160029788739445
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 7160029788739445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 1'
 ,p_template => 
'<a href="#LINK#" class="t12ButtonAlternative1">#LABEL#</a>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 4
 ,p_theme_id => 12
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_3
prompt  ......Button Template 7160129720739448
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 7160129720739448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 3'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" class="t12ButtonAlternative3" summary="">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12ButtonAlternative3Left" width="3"><br /></td>'||unistr('\000a')||
'  <td style="padding-left: 10px; padding-right: 10px;"><a href="#LINK#">#LABEL#</a></td>'||unistr('\000a')||
'  <td class="t12ButtonAlternative3Right" width="3"><br /></td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 2
 ,p_theme_id => 12
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button_alternative_2
prompt  ......Button Template 7160200885739448
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 7160200885739448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button, Alternative 2'
 ,p_template => 
'<a href="#LINK#" class="t12ButtonAlternative2">#LABEL#</a>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 5
 ,p_theme_id => 12
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/button/button
prompt  ......Button Template 7160316886739448
 
begin
 
wwv_flow_api.create_button_templates (
  p_id => 7160316886739448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_template_name => 'Button'
 ,p_template => 
'<a href="#LINK#" class="t12Button">#LABEL#</a>'
 ,p_translate_this_template => 'N'
 ,p_theme_class_id => 1
 ,p_theme_id => 12
  );
null;
 
end;
/

---------------------------------------
prompt  ...region templates
--
--application/shared_components/user_interface/templates/region/button_region_without_title
prompt  ......region template 2782004903266426
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2782004903266426 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellspacing="0" border="0" summary="" class="t15ButtonRegionwithoutTitle" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#BODY#'
 ,p_page_plug_template_name => 'Button Region without Title'
 ,p_theme_id => 15
 ,p_theme_class_id => 17
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/borderless_region
prompt  ......region template 2782332346266429
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2782332346266429 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t15BorderlessRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td align="right" class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Borderless Region'
 ,p_theme_id => 15
 ,p_theme_class_id => 7
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region_alternative_1
prompt  ......region template 2782619174266429
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2782619174266429 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellspacing="0" cellpadding="0" border="0" class="t15SidebarRegionAlt1" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tr class="t15RegionHeader">'||unistr('\000a')||
'<th class="L" valign="top"><img src="#IMAGE_PREFIX#1px_trans.gif" width="10" height="10" alt="" /></th>'||unistr('\000a')||
'<th class="C">#TITLE#</th>'||unistr('\000a')||
'<th class="R" valign="top"><img src="#IMAGE_PREFIX#1px_trans.gif" width="10" height="10" alt="" /></th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3" c'||
'lass="t15Body">#BODY#<img src="#IMAGE_PREFIX#1px_trans.gif" width="200" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region, Alternative 1'
 ,p_theme_id => 15
 ,p_theme_class_id => 3
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region
prompt  ......region template 2782916923266429
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2782916923266429 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t15NavigationRegion" id="#REGION_ID#">#BODY#<img src="#IMAGE_PREFIX#1px_trans.gif" width="200" height="1" alt="" class="vsp" /></div>'
 ,p_page_plug_template_name => 'Navigation Region'
 ,p_theme_id => 15
 ,p_theme_class_id => 5
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region
prompt  ......region template 2783227175266429
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2783227175266429 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellspacing="0" cellpadding="0" border="0" class="t15SidebarRegion" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tr class="t15RegionHeader">'||unistr('\000a')||
'<th class="L" valign="top"><img src="#IMAGE_PREFIX#1px_trans.gif" width="10" height="10" alt="" /></th>'||unistr('\000a')||
'<th class="C">#TITLE#</th>'||unistr('\000a')||
'<th class="R" valign="top"><img src="#IMAGE_PREFIX#1px_trans.gif" width="10" height="10" alt="" /></th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3" class'||
'="t15Body">#BODY#<img src="#IMAGE_PREFIX#1px_trans.gif" width="200" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 15
 ,p_theme_class_id => 2
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/bracketed_region
prompt  ......region template 2783521576266429
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2783521576266429 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t15BracketedRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'    <td class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'    <td class="t15Bracket"><table summary=""><tr><td class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr><td class="t15Body">#B'||
'ODY#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Bracketed Region'
 ,p_theme_id => 15
 ,p_theme_class_id => 18
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/breadcrumb_region
prompt  ......region template 2783831292266429
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2783831292266429 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div id="#REGION_ID#" class="t15breadcrumb">#BODY#</div>'
 ,p_page_plug_template_name => 'Breadcrumb Region'
 ,p_theme_id => 15
 ,p_theme_class_id => 6
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/list_region_with_icon_chart_list
prompt  ......region template 2784124258266429
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2784124258266429 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t15ListRegionwithIcon" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
''||unistr('\000a')||
'<td align="right" class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15Body" colspan="2"><table cellpadding="0" cellspacing="0" border="0" summ'||
'ary="" ><tr><td valign="top"><img src="#IMAGE_PREFIX#themes/theme_15/monitor_icons_graph.gif" alt=""/></td>'||unistr('\000a')||
'<td>#BODY#</td></tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'List Region with Icon - Chart List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 15
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_title
prompt  ......region template 2784428568266431
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2784428568266431 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" class="t15instructiontext">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Region without Title'
 ,p_theme_id => 15
 ,p_theme_class_id => 11
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region
prompt  ......region template 2784715709266431
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2784715709266431 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t15WizardRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<thead class="t15RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t15RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<td align="right" class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr><td colspan="2" class="t15Body">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region'
 ,p_theme_id => 15
 ,p_theme_class_id => 12
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region_alternative_1
prompt  ......region template 2785019642266431
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2785019642266431 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t15NavigationRegionAlternative1" id="#REGION_ID#"><h2 class="t15RegionHeader">#TITLE#</h2><div class="t15Body">#BODY#<img src="#IMAGE_PREFIX#1px_trans.gif" width="200" height="1" alt="" class="vsp" /></div></div>'
 ,p_page_plug_template_name => 'Navigation Region, Alternative 1'
 ,p_theme_id => 15
 ,p_theme_class_id => 16
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_buttons_and_titles
prompt  ......region template 2785332277266431
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2785332277266431 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" class="t15RegionwithoutButtonsandTitles" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Region without Buttons and Titles'
 ,p_theme_id => 15
 ,p_theme_class_id => 19
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region
prompt  ......region template 2785600597266431
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2785600597266431 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table width="100%" border="0" cellspacing="0" cellpadding="0" id="#REGION_ID#" class="t15ReportsRegion" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="bottom" class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td align="right" class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" valign="top" class="t15Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
''||
'</table>'
 ,p_page_plug_template_name => 'Reports Region'
 ,p_theme_id => 15
 ,p_theme_class_id => 9
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_region
prompt  ......region template 2785909435266431
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2785909435266431 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t15ChartRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td align="right" class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 15
 ,p_theme_class_id => 30
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/list_region_with_icon_report_list
prompt  ......region template 2786224018266432
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2786224018266432 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t15ListRegionwithIcon" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
''||unistr('\000a')||
'<td align="right" class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15Body" colspan="2"><table cellpadding="0" cellspacing="0" border="0" summ'||
'ary="" ><tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_15/provisioning_reports.gif" alt=""/></td>'||unistr('\000a')||
'<td>#BODY#</td></tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'List Region with Icon - Report List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 15
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/hide_and_show_region
prompt  ......region template 2786519711266432
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2786519711266432 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t15HideandShowRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15RegionHeader"><a style="margin-left:5px;" href="javascript:hideShow(''region#REGION_SEQUENCE_ID#'',''shIMG#REGION_SEQUENCE_ID#'',''#IMAGE_PREFIX#themes/theme_15/rollup_plus_dgray.gif'',''#IMAGE_PR'||
'EFIX#themes/theme_15/rollup_minus_dgray.gif'');" class="t15HideandShowRegionLink"><img src="#IMAGE_PREFIX#themes/theme_15/rollup_plus_dgray.gif" '||unistr('\000a')||
'  id="shIMG#REGION_SEQUENCE_ID#" alt="" /></a>#TITLE#</td>'||unistr('\000a')||
'<td class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15Body"><div class='||
'"t15Hide" id="region#REGION_SEQUENCE_ID#">#BODY#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Hide and Show Region'
 ,p_theme_id => 15
 ,p_theme_class_id => 1
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Gray Head, white body'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region_with_icon
prompt  ......region template 2786830329266432
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2786830329266432 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t15WizardRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<thead class="t15RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t15RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<td align="right" class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr><td colspan="2" class="t15Body">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region with Icon'
 ,p_theme_id => 15
 ,p_theme_class_id => 20
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_100_width
prompt  ......region template 2787114958266432
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2787114958266432 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" width="100%" class="t15ReportsRegion100Width" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td align="right" class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region 100% Width'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 15
 ,p_theme_class_id => 13
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/form_region
prompt  ......region template 2787428386266434
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2787428386266434 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t15FormRegion" cellspacing="0"  border="0" summary="layout" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td align="right" class="t15ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr class="t15Body">'||unistr('\000a')||
'<td colspan="2" class="t15Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Form Region'
 ,p_theme_id => 15
 ,p_theme_class_id => 8
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_1
prompt  ......region template 2787725395266434
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2787725395266434 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t15ReportsRegionAlternative1" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region, Alternative 1'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 15
 ,p_theme_class_id => 10
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_with_title
prompt  ......region template 2788023425266434
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2788023425266434 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t15ButtonRegionwithTitle" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region with Title'
 ,p_theme_id => 15
 ,p_theme_class_id => 4
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/report_list
prompt  ......region template 2803024699273781
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2803024699273781 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ListRegionwithIcon" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDI'||
'T##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody"><table cellpadding="0" cellspacing="0" border="0" summary="" ><tr><td valign="top"><img src="#IMAGE_PREFIX#themes/theme_8/report.gif" alt="" /></td>'||unistr('\000a')||
'<td>#BODY#</td></tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Report List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 8
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_title
prompt  ......region template 2803302593273781
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2803302593273781 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8RegionwithoutTitle" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" /></div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHAN'||
'GE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Region without Title'
 ,p_theme_id => 8
 ,p_theme_class_id => 11
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/bracketed_region
prompt  ......region template 2803629390273781
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2803629390273781 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8BracketedRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##'||
'CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Bracketed Region'
 ,p_theme_id => 8
 ,p_theme_class_id => 18
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region_alternative_1
prompt  ......region template 2803921839273781
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2803921839273781 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellspacing="0" cellpadding="0" border="0" class="t8SidebarRegionAlternative1" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region, Alternative 1'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 8
 ,p_theme_class_id => 3
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region
prompt  ......region template 2804231144273781
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2804231144273781 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellspacing="0" cellpadding="0" border="0" class="t8SidebarRegion" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 8
 ,p_theme_class_id => 2
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => '<table border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td rowspan="2" valign="top" width="4" bgcolor="#FF0000"><img src="#IMAGE_PREFIX#tl_img.gif" border="0" width="4" height="18" alt="" /></td>'||unistr('\000a')||
'          <td bgcolor="#000000" height="1"><img src="#IMAGE_PREFIX#stretch.gif" width="142" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'          <td rowspan="2" valign="top" width="4" bgcolor="#FF0000"><img src="#IMAGE_PREFIX#tr_img.gif" border="0" width="4" height="18" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td bgcolor="#FF0000" height="16">'||unistr('\000a')||
'            <table border="0" cellpadding="0" cellspacing="0" width="100%">'||unistr('\000a')||
'              <tr>'||unistr('\000a')||
'                <td align=middle valign="top">'||unistr('\000a')||
'                  <div align="center">'||unistr('\000a')||
'                     <font color="#ffffff" face="Arial, Helvetica, sans-serif" size="1">'||unistr('\000a')||
'                      <b>#TITLE# </b></font></div>'||unistr('\000a')||
'                </td>'||unistr('\000a')||
'              </tr>'||unistr('\000a')||
'            </table>'||unistr('\000a')||
'          </td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'   <tr>'||unistr('\000a')||
'   <td bgcolor="#000000" width="1" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'   <td valign="top" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="146" height="1" border="0" alt="" /><br />'||unistr('\000a')||
'            <table border="0" cellpadding="1" cellspacing="0" width="146" summary="">'||unistr('\000a')||
'              <tr>'||unistr('\000a')||
'                <td colspan="2">'||unistr('\000a')||
'                  <table border="0" cellpadding="2" cellspacing="0" width="124" summary="">'||unistr('\000a')||
'                    <tr>'||unistr('\000a')||
'                      <td>&nbsp;</td>'||unistr('\000a')||
'                      <td valign="top" width="106">'||unistr('\000a')||
'                        <P><FONT face="arial, helvetica" size="1">'||unistr('\000a')||
'                            #BODY#'||unistr('\000a')||
'                           </font>'||unistr('\000a')||
'                        </P>'||unistr('\000a')||
'                      </td>'||unistr('\000a')||
'                    </tr>'||unistr('\000a')||
'                  </table>'||unistr('\000a')||
'            </table>'||unistr('\000a')||
'          </td>'||unistr('\000a')||
'          <td bgcolor="#000000" width="1" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'          <td bgcolor="#9a9c9a" width="1" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'          <td bgcolor="#b3b4b3" width="1" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'      </table>'||unistr('\000a')||
'      <table border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td rowspan="4" valign="top" width="4"><img src="#IMAGE_PREFIX#bl_img.gif" border="0" width="4" height="6" alt="" /></td>'||unistr('\000a')||
'          <td bgcolor="#ffffff" height="2"><img src="#IMAGE_PREFIX#stretch.gif" width="142" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'          <td rowspan="4" valign="top" width="4"><img src="#IMAGE_PREFIX#br_img.gif" border="0" width="4" height="6" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td bgcolor="#000000" width="1"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td bgcolor="#9a9c9a" width="1"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td bgcolor="#b3b4b3" width="1" height="2"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/breadcrumb_region
prompt  ......region template 2804501406273781
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2804501406273781 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<tr> '||unistr('\000a')||
'<td style="background-color:E5E5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td align="left" valign="middle" style="background-color:BFBFB8" class="t8BreadCrumbRegion"><div class="t8BreadcrumbHolder" id="#REGION_ID#">#BODY#</div><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'<td style="background-color:E5E'||
'5DC"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="1" height="1" alt="" /></td>'||unistr('\000a')||
'</tr>'
 ,p_page_plug_template_name => 'Breadcrumb Region'
 ,p_theme_id => 8
 ,p_theme_class_id => 6
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region_alternative_1
prompt  ......region template 2804825896273782
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2804825896273782 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8NavigationRegionAlternative1" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Navigation Region, Alternative 1'
 ,p_theme_id => 8
 ,p_theme_class_id => 16
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_region
prompt  ......region template 2805113769273782
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2805113769273782 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ChartRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHAN'||
'GE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 8
 ,p_theme_class_id => 30
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_with_title
prompt  ......region template 2805420739273782
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2805420739273782 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ButtonRegionwithTitle" id="#REGION_ID#">'||unistr('\000a')||
'<tr><td class="t8RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</td></tr>'||unistr('\000a')||
'<tr><td class="t8ButtonHolder" style="margin:5px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREA'||
'TE2##EXPAND##COPY##HELP#<img src="#IMAGE_PREFIX#themes/theme_5/1px_trans.gif" alt="" style="display:block;" width="600" height="1" /></td></tr>'||unistr('\000a')||
'</table>#BODY#'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Button Region with Title'
 ,p_theme_id => 8
 ,p_theme_class_id => 4
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_list
prompt  ......region template 2805723349273782
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2805723349273782 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ListRegionwithIcon" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDI'||
'T##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody" colspan="2"><table cellpadding="0" cellspacing="0" border="0" summary="" ><tr><td valign="top"><img src="#IMAGE_PREFIX#themes/theme_8/chart.gif" alt="" /></td>'||unistr('\000a')||
'<td>#BODY#</td></tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Chart List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 8
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_1
prompt  ......region template 2806030988273782
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2806030988273782 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ReportsRegionAlternative1" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELE'||
'TE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr><td class="t8RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region, Alternative 1'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 8
 ,p_theme_class_id => 10
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/borderless_region
prompt  ......region template 2806329253273782
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2806329253273782 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8BorderlessRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT#'||
'#CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Borderless Region'
 ,p_theme_id => 8
 ,p_theme_class_id => 7
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region_with_icon
prompt  ......region template 2806621326273782
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2806621326273782 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8WizardRegionwithIcon" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##E'||
'DIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody"><table summary="" cellpadding="0" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_8/t8iconwizard.gif" alt=""/></td>'||unistr('\000a')||
'<td width="100%" valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region with Icon'
 ,p_theme_id => 8
 ,p_theme_class_id => 20
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_buttons_and_titles
prompt  ......region template 2806915817273782
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2806915817273782 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8RegionwithoutButtonsandTitle" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" width="300"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Region without Buttons and Titles'
 ,p_theme_id => 8
 ,p_theme_class_id => 19
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region
prompt  ......region template 2807213750273782
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2807213750273782 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8WizardRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHA'||
'NGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region'
 ,p_theme_id => 8
 ,p_theme_class_id => 12
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/form_region
prompt  ......region template 2807531875273784
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2807531875273784 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8FormRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANG'||
'E##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#<img src="#IMAGE_PREFIX#themes/theme_8/1px_trans.gif" alt="" width="600" height="1" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Form Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 8
 ,p_theme_class_id => 8
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region
prompt  ......region template 2807809797273784
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2807809797273784 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t8NavigationRegion" id="#REGION_ID#">#BODY#</div>'
 ,p_page_plug_template_name => 'Navigation Region'
 ,p_theme_id => 8
 ,p_theme_class_id => 5
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region
prompt  ......region template 2808121931273785
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2808121931273785 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ReportsRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CH'||
'ANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 8
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_without_title
prompt  ......region template 2808409270273785
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2808409270273785 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ButtonRegionwithoutTitle" id="#REGION_ID#">'||unistr('\000a')||
'<tr><td class="t8ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#<img src="#IMAGE_PREFIX#themes/theme_8/1px_trans.gif" alt="" width="600" height="1" style="display:block;"/></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#BODY#'
 ,p_page_plug_template_name => 'Button Region without Title'
 ,p_theme_id => 8
 ,p_theme_class_id => 17
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_100_width
prompt  ......region template 2808701153273785
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2808701153273785 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ReportsRegion100Width" width="100%" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#</div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##N'||
'EXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region 100% Width'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 8
 ,p_theme_class_id => 13
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/hide_and_show_region
prompt  ......region template 2809011682273785
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2809011682273785 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t8HideandShowRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionHeader" valign="top"><div style="float:left;"><img src="#IMAGE_PREFIX#themes/theme_8/t8bullet01.gif" width="10" height="10" alt="" style="margin-right:5px;" />#TITLE#<a style="margin-left:5px;" href="javascript:hideShow(''region#REGION_SEQUENCE_ID#'',''shIMG#REGION_SEQUEN'||
'CE_ID#'',''#IMAGE_PREFIX#themes/theme_8/showhide_hidden.gif'',''#IMAGE_PREFIX#themes/theme_8/showhide_show.gif'');" class="htmldbHideShowMinLink"><img src="#IMAGE_PREFIX#themes/theme_8/showhide_hidden.gif" '||unistr('\000a')||
'  id="shIMG#REGION_SEQUENCE_ID#" alt="" /></a></div><div style="float:right;margin-left:45px;">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</d'||
'iv></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t8RegionBody"><div id="region#REGION_SEQUENCE_ID#" class="t8Hide">#BODY#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Hide and Show Region'
 ,p_theme_id => 8
 ,p_theme_class_id => 1
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region_alternative_1
prompt  ......region template 2823313901468448
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2823313901468448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table border="0" cellpadding="0" cellspacing="0" class="t11SidebarRegionAlternative1" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Sidebar Region, Alternative 1'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 11
 ,p_theme_class_id => 3
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/borderless_region
prompt  ......region template 2823617208468448
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2823617208468448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11BorderlessRegion" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Borderless Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 11
 ,p_theme_class_id => 7
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_1
prompt  ......region template 2823916416468448
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2823916416468448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ReportsRegionAlternative1" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>              '
 ,p_page_plug_template_name => 'Reports Region, Alternative 1'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 11
 ,p_theme_class_id => 10
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/bracketed_region
prompt  ......region template 2824209426468448
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2824209426468448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary=""  class="t11BracketedRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2"><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11bracket"><img  height="5" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" alt="" /></td>'||
''||unistr('\000a')||
'<td rowspan="3">'||unistr('\000a')||
'<div class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div><div class="t11RegionBody">#BODY#</div></td>'||unistr('\000a')||
'<td class="t11bracket"><img  height="5" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11bracketspace"><img  height="1" width="1" src="#IMAGE_PREFIX#t'||
'hemes/theme_11/1px_trans.gif"  alt="" /></td>'||unistr('\000a')||
'<td class="t11bracketspace"><img  height="1" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11bracket"><img  height="5" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif"  alt="" /></td>'||unistr('\000a')||
'<td class="t11bracket"><img  height="5" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif"  alt="'||
'" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Bracketed Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 11
 ,p_theme_class_id => 18
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_without_title
prompt  ......region template 2824513317468448
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2824513317468448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ButtonRegionwithoutTitle" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" style="display:block;" height="1" width="600" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region without Title'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 11
 ,p_theme_class_id => 17
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/form_region
prompt  ......region template 2824805879468450
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2824805879468450 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11FormRegion" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" style="display:block;" height="1"'||
' width="600" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Form Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 11
 ,p_theme_class_id => 8
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region
prompt  ......region template 2825107973468450
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2825107973468450 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11SidebarRegion" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Sidebar Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 11
 ,p_theme_class_id => 2
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_buttons_and_title
prompt  ......region template 2825416025468450
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2825416025468450 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11RegionwithoutButtonsandTitle" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Region without Buttons and Title'
 ,p_theme_id => 11
 ,p_theme_class_id => 19
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_with_title
prompt  ......region template 2825710587468450
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2825710587468450 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ButtonRegionwithTitle" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" style="display:block;"'||
' height="1" width="600" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region with Title'
 ,p_theme_id => 11
 ,p_theme_class_id => 4
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/breadcrumb_region
prompt  ......region template 2826016121468450
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2826016121468450 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t11BreadcrumbRegion" id="#REGION_ID#">#BODY#</div>'||unistr('\000a')||
'          '
 ,p_page_plug_template_name => 'Breadcrumb Region'
 ,p_theme_id => 11
 ,p_theme_class_id => 6
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region
prompt  ......region template 2826316729468450
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2826316729468450 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table border="0" cellpadding="0" cellspacing="0" class="t11WizardRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-tl.gif" width="15" height="15"  alt="" />#TITLE#</td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-tr.gif" width'||
'="15" height="15"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder" colspan="2">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-bl.gif" width="15" height='||
'"15"  alt="" /></td>'||unistr('\000a')||
'<td align="right" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-br.gif" width="15" height="15"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region'
 ,p_theme_id => 11
 ,p_theme_class_id => 12
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_list
prompt  ......region template 2826601975468450
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2826601975468450 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ListRegionwithIcon" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody"><table summary="" cellpadding="0" cel'||
'lspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/chart.gif" alt="" /></td>'||unistr('\000a')||
'<td valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Chart List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 11
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region
prompt  ......region template 2826920007468450
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2826920007468450 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div id="#REGION_ID#" style="clear:both;">#BODY#</div>'
 ,p_page_plug_template_name => 'Navigation Region'
 ,p_theme_id => 11
 ,p_theme_class_id => 5
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'In Round Green Theme Navigation Region and Navigation Region, Alternative 1 are the identical'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region_alternative_1
prompt  ......region template 2827212733468451
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2827212733468451 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div id="#REGION_ID#" style="clear:both;">#BODY#</div>'
 ,p_page_plug_template_name => 'Navigation Region, Alternative 1'
 ,p_theme_id => 11
 ,p_theme_class_id => 16
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'In Round Green Theme Navigation Region and Navigation Region, Alternative 1 are the identical'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_100_width
prompt  ......region template 2827526232468451
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2827526232468451 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t11ReportsRegion100Width" border="0" cellpadding="0" cellspacing="0" summary="" id="#REGION_ID#" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</t'||
'able>'
 ,p_page_plug_template_name => 'Reports Region 100% Width'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 11
 ,p_theme_class_id => 13
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/list_region_with_icon_report
prompt  ......region template 2827823207468451
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2827823207468451 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ListRegionwithIcon" id="htmldb#REGION_SEQUENCE_ID#" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody"><tabl'||
'e summary="" cellpadding="0" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/report.gif" alt="" /></td>'||unistr('\000a')||
'<td valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'List Region with Icon (Report)'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 11
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/hide_and_show_region
prompt  ......region template 2828112744468451
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2828112744468451 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11HideandShowRegion" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#<a style="margin-left:5px;" href="javascript:hideShow(''region#REGION_SEQUENCE_ID#'',''shIMG#REGION_SEQUENCE_ID#'',''#IMAGE_PREFIX#themes/theme_11/t11showhide_hidden.gif'',''#IMAGE_PREFIX#themes/theme_11/t11showhide_show.gif'');" clas'||
's="htmldbHideShowMinLink"><img src="#IMAGE_PREFIX#themes/theme_11/t11showhide_hidden.gif" '||unistr('\000a')||
'  id="shIMG#REGION_SEQUENCE_ID#" alt="" /></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody"><div class="t11Hide" id="region#REGION_SEQUENCE_ID#"><div class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div><div style="padding:10px">#BODY#'||
'</div></div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Hide and Show Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 11
 ,p_theme_class_id => 1
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_title
prompt  ......region template 2828414913468451
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2828414913468451 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11RegionwithoutTitle" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">&nbsp;</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Region without Title'
 ,p_theme_id => 11
 ,p_theme_class_id => 11
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_region
prompt  ......region template 2828724650468451
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2828724650468451 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ChartRegion" border="0" id="#REGION_ID#" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 11
 ,p_theme_class_id => 30
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region
prompt  ......region template 2829022561468451
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2829022561468451 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t11ReportsRegion" border="0" cellpadding="0" cellspacing="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 11
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region_with_icon
prompt  ......region template 2829326113468451
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2829326113468451 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table border="0" cellpadding="0" cellspacing="0" class="t11WizardRegionwithIcon" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-tl.gif" width="15" height="15"  alt="" />#TITLE#</td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-tr.gi'||
'f" width="15" height="15"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t11RegionBody"><table summary="" cellpadding="0" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t11iconwizard.gif" alt="" />'||
'</td>'||unistr('\000a')||
'<td width="100%" valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-bl.gif" width="15" height="15"  alt="" /></td>'||unistr('\000a')||
'<td align="right" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-br.gif" width="15" height="15"  alt="" /></td>'||unistr('\000a')||
'</tr'||
'>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region with Icon'
 ,p_theme_id => 11
 ,p_theme_class_id => 20
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region_alternative_1
prompt  ......region template 2843923761474910
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2843923761474910 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t17Region" id="#REGION_ID#" style="border:none;">'||unistr('\000a')||
'<div class="NavigationRegionAlternative1">'||unistr('\000a')||
'<div class="t17RegionHeader">#TITLE#</div>'||unistr('\000a')||
'<div class="t17RegionBody">#BODY#<img src="IMAGE_PREFIX#themes/theme_17/1px_trans.gif" width="200" height="1" alt="" /></div>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'</div>'
 ,p_page_plug_template_name => 'Navigation Region, Alternative 1'
 ,p_theme_id => 17
 ,p_theme_class_id => 16
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region_alternative_1
prompt  ......region template 2844226940474910
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2844226940474910 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="SidebarRegionAlternative1">'||unistr('\000a')||
'<tr><th class="t17RegionHeader" width="100%">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#<img src="IMAGE_PREFIX#themes/theme_17/1px_trans.gif" width="200" height="1" alt="" /></td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region, Alternative 1'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 17
 ,p_theme_class_id => 3
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/bracketed_region
prompt  ......region template 2844516976474910
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2844516976474910 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" style="border:none;">'||unistr('\000a')||
'<tbody class="bracket">'||unistr('\000a')||
'<tr><th class="t17RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'<tr><td class="t17'||
'Bracket">&nbsp;</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Bracketed Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 17
 ,p_theme_class_id => 18
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_1
prompt  ......region template 2844810645474910
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2844810645474910 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="ReportsRegionAlternative1">'||unistr('\000a')||
'<tr><th class="t17RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region, Alternative 1'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 17
 ,p_theme_class_id => 10
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_buttons_and_title
prompt  ......region template 2845122117474910
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2845122117474910 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary=""><tbody class="regionwithoutbuttonsandtitle"><tr><td class="t17RegionBody">#BODY#</td></tr></tbody></table>'
 ,p_page_plug_template_name => 'Region without Buttons and Title'
 ,p_theme_id => 17
 ,p_theme_class_id => 19
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_region
prompt  ......region template 2845424029474910
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2845424029474910 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="Chart">'||unistr('\000a')||
'<tr><th class="t17RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 17
 ,p_theme_class_id => 30
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_title
prompt  ......region template 2845712089474910
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2845712089474910 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary=""><tbody class="regionwithouttitle"><tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr><tr><td class="t17RegionBody">#BODY#</td></tr></tbody></table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Region without Title'
 ,p_theme_id => 17
 ,p_theme_class_id => 11
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region
prompt  ......region template 2846019653474910
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2846019653474910 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" width="100%" style="border:none;">'||unistr('\000a')||
'<tbody class="ReportsRegion">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t17RegionHeader">#TITLE#</th>'||unistr('\000a')||
'<th class="t17RegionHeader2" width="100%""><br /></th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t17ButtonHolder" colspan="2">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND'||
'##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t17RegionBody" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 17
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/breadcrumb_region
prompt  ......region template 2846329393474912
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2846329393474912 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div id="#REGION_ID#" class="t17Breadcrumbs">#BODY#</div>'
 ,p_page_plug_template_name => 'Breadcrumb Region'
 ,p_theme_id => 17
 ,p_theme_class_id => 6
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_without_title
prompt  ......region template 2846612647474912
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2846612647474912 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="buttonregionwithouttitle">'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region without Title'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 17
 ,p_theme_class_id => 17
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/borderless_region
prompt  ......region template 2846932452474912
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2846932452474912 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" style="border:none;">'||unistr('\000a')||
'<tbody class="borderless">'||unistr('\000a')||
'<tr><th class="t17RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</tabl'||
'e>'
 ,p_page_plug_template_name => 'Borderless Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 17
 ,p_theme_class_id => 7
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_with_title
prompt  ......region template 2847207732474912
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2847207732474912 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="buttonregionwithtitle">'||unistr('\000a')||
'<tr><th class="t17RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region with Title'
 ,p_theme_id => 17
 ,p_theme_class_id => 4
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region_with_icon
prompt  ......region template 2847508546474912
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2847508546474912 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="wizardwithicon">'||unistr('\000a')||
'<tr><th class="t17RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region with Icon'
 ,p_theme_id => 17
 ,p_theme_class_id => 20
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region
prompt  ......region template 2847827195474912
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2847827195474912 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="wizard">'||unistr('\000a')||
'<tr><th class="t17RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region'
 ,p_theme_id => 17
 ,p_theme_class_id => 12
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/list_region_with_icon_chart
prompt  ......region template 2848116327474912
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2848116327474912 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="listregionwithicon">'||unistr('\000a')||
'<tr><th class="t17RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr class="ChartIcon"><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<'||
'/table>'
 ,p_page_plug_template_name => 'List Region with Icon (Chart)'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 17
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region
prompt  ......region template 2848410423474914
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2848410423474914 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t17Region" id="#REGION_ID#" style="border:none;">'||unistr('\000a')||
'<div class="NavigationRegion">'||unistr('\000a')||
'<div class="t17RegionHeader">#TITLE#</div>'||unistr('\000a')||
'<div class="t17RegionBody">#BODY#<img src="IMAGE_PREFIX#themes/theme_17/1px_trans.gif" width="200" height="1" alt="" /></div>'||unistr('\000a')||
'</div>'||unistr('\000a')||
'</div>'
 ,p_page_plug_template_name => 'Navigation Region'
 ,p_theme_id => 17
 ,p_theme_class_id => 5
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/form_region
prompt  ......region template 2848712422474914
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2848712422474914 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="form">'||unistr('\000a')||
'<tr><th class="t17RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Form Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 17
 ,p_theme_class_id => 8
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_100_width
prompt  ......region template 2849005097474914
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2849005097474914 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" width="100%" style="border:none;">'||unistr('\000a')||
'<tbody class="ReportsRegion100Width">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t17RegionHeader">#TITLE#</th>'||unistr('\000a')||
'<th class="t17RegionHeader2" width="100%""><br /></th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t17ButtonHolder" colspan="2">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2'||
'##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t17RegionBody" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region 100% Width'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 17
 ,p_theme_class_id => 13
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/report_list
prompt  ......region template 2849323800474914
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2849323800474914 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary=""><tbody class="listregionwithicon"><tr><th class="t17RegionHeader">#TITLE#</th></tr><tr><td class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr class="ReportIcon"><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</t'||
'able>'
 ,p_page_plug_template_name => 'Report List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 17
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/hide_and_show_region
prompt  ......region template 2849613223474914
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2849613223474914 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="hideshow">'||unistr('\000a')||
'<tr><th class="t17RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_17/collapse_plus.gif" onclick="htmldb_ToggleWithImage(this,''#REGION_ID#body'')" class="pb" alt="" />#TITLE#</th></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tbody id="#REGION_ID#body" style="display:none;" class="hideshowcontent">'||unistr('\000a')||
'<tr><td '||
'class="t17ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Hide and Show Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 17
 ,p_theme_class_id => 1
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region
prompt  ......region template 2849929525474914
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2849929525474914 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t17Region" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody class="SidebarRegion">'||unistr('\000a')||
'<tr><th class="t17RegionHeader" width="100%">#TITLE#</th></tr>'||unistr('\000a')||
'<tr><td class="t17RegionBody">#BODY#<img src="IMAGE_PREFIX#themes/theme_17/1px_trans.gif" width="200" height="1" alt="" /></td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 17
 ,p_theme_class_id => 2
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region_alternative_1
prompt  ......region template 2864627773481234
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2864627773481234 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16NavigationRegionAlternative1" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" width="210" style="table-layout:fixed;">'||unistr('\000a')||
'<col width="25" /><col width="185" />'||unistr('\000a')||
'<tr><td><br /></td><th class="t16RegionHeader">#TITLE#</th></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><br /></td><td class="t16RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Navigation Region, Alternative 1'
 ,p_theme_id => 16
 ,p_theme_class_id => 16
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_without_title
prompt  ......region template 2864912680481234
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2864912680481234 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody id="body#REGION_ID#" class="t16ButtonRegionWithoutTitle">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region without Title'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 16
 ,p_theme_class_id => 17
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/report_list
prompt  ......region template 2865219031481234
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2865219031481234 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_16/collapse_minus.gif" alt="" align="middle" onclick="htmldb_ToggleTableBody(this,''body#REGION_'||
'ID#'')" class="pseudoButtonActive" />#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#" class="t16ReportIcon">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#<'||
'/td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16RegionBody">#BODY#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBRight.png" alt="'||
'"/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Report List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 16
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region_alternative_1
prompt  ......region template 2865503760481234
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2865503760481234 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" style="width:200px;">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader">#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" h'||
'eight="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#" class="t16ChartIcon">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="">#BODY#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#theme'||
's/theme_16/t16RegionCapBRight.png" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Sidebar Region, Alternative 1'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 16
 ,p_theme_class_id => 3
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region
prompt  ......region template 2865821068481234
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2865821068481234 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top" width="7"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_16/collapse_minus.gif" alt="" align="middle" onclick="htmldb_ToggleTableBody(this,''bo'||
'dy#REGION_ID#'')" class="pseudoButtonActive" />#TITLE#</th>'||unistr('\000a')||
'<td valign="top" width="7"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</t'||
'd>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td>#BODY#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBRight.png" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
''||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Reports Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 16
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region
prompt  ......region template 2866117927481235
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2866117927481235 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16SideBarRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr class="t16RegionHeader"><th>#TITLE#</th></tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#">'||unistr('\000a')||
'<tr><td class="t16RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 16
 ,p_theme_class_id => 2
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_title
prompt  ......region template 2866411038481235
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2866411038481235 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16RegionWithoutTitle" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<td class="t16ButtonHolder"><img src="#IMAGE_PREFIX#themes/theme_16/collapse_minus.gif" alt="" align="middle" onclick="htmldb_ToggleTableBody(this,''body#REGION_ID#'')" class="pseudoButtonActive" />#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND'||
'##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#">'||unistr('\000a')||
'<tr><td class="t16RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Region without Title'
 ,p_theme_id => 16
 ,p_theme_class_id => 11
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_buttons_and_title
prompt  ......region template 2866719136481235
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2866719136481235 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16RegionWithoutButtonsAndTitle" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tbody id="body#REGION_ID#" class="">'||unistr('\000a')||
'<tr><td class="t16RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Region without Buttons and Title'
 ,p_theme_id => 16
 ,p_theme_class_id => 19
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_with_title
prompt  ......region template 2867006787481235
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2867006787481235 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ButtonRegionWithTitle" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t16RegionHeader">#TITLE#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#BODY#'
 ,p_page_plug_template_name => 'Button Region with Title'
 ,p_theme_id => 16
 ,p_theme_class_id => 4
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/hide_and_show_region
prompt  ......region template 2867324907481235
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2867324907481235 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_16/collapse_plus.gif" alt="Toggle" align="middle" onclick="htmldb_ToggleTableBody(this,''body#RE'||
'GION_ID#'')" class="pseudoButtonActive" />#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#" style="display:none;">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##H'||
'ELP#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr><td class="RL"><br /></td><td class="t16RegionBody">#BODY#</td><td class="RR"><br /></td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBRight.png" alt='||
'""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Hide and Show Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 16
 ,p_theme_class_id => 1
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/bracketed_region
prompt  ......region template 2867601815481235
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2867601815481235 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_16/collapse_minus.gif" alt="Toggle" align="middle" onclick="htmldb_ToggleTableBody(this,''body#R'||
'EGION_ID#'')" class="pseudoButtonActive" />#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#" class="t16Bracketed">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16ButtonHolder" colspan="3">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||
''||unistr('\000a')||
'<tr><td class="t16RegionBody" colspan="3">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionBCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeaderB"><br /></th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionBCapRight.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Bracketed Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 16
 ,p_theme_class_id => 18
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region
prompt  ......region template 2867911799481235
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2867911799481235 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" style="width:600px;">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader">#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" h'||
'eight="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td>#BODY#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#'||
'themes/theme_16/t16RegionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBRight.png" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Wizard Region'
 ,p_theme_id => 16
 ,p_theme_class_id => 12
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region_with_icon
prompt  ......region template 2868204496481235
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2868204496481235 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" style="width:600px;">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader">#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" h'||
'eight="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td>#BODY#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#'||
'themes/theme_16/t16RegionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBRight.png" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region with Icon'
 ,p_theme_id => 16
 ,p_theme_class_id => 20
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/breadcrumb_region
prompt  ......region template 2868503403481237
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2868503403481237 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div id="#REGION_ID#">#BODY#</div>'
 ,p_page_plug_template_name => 'Breadcrumb Region'
 ,p_theme_id => 16
 ,p_theme_class_id => 6
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region
prompt  ......region template 2868813784481237
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2868813784481237 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16NavigationRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" width="210" style="table-layout:fixed;">'||unistr('\000a')||
'<col width="25" /><col width="185" />'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th align="center" style="border-top:2px solid #839fcd;border-bottom:1px solid #275096;background-color:#4167a7;" colspan="2"><img src="#IMAGE_PREFIX#themes/theme_16/navbar_top.gif" onclick="htmldb_ToggleWithIm'||
'age(''t#REGION_ID#'',''body#REGION_ID#'')"" class="pb" /></th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td style="background-color:#4167A7;"><img src="#IMAGE_PREFIX#themes/theme_16/sidebar_tab_minus.png" onclick="htmldb_ToggleWithImage(this,''body#REGION_ID#'')" id="t#REGION_ID#" class="pb" /></td>'||unistr('\000a')||
'<th width="100%" style="background-color:#4167A7;">#TITLE#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tbody id="body#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><br /></td>'||unistr('\000a')||
'<td class="t16R'||
'egionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Navigation Region'
 ,p_theme_id => 16
 ,p_theme_class_id => 5
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_region
prompt  ......region template 2869121222481237
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2869121222481237 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_16/collapse_minus.gif" alt="" align="middle" onclick="htmldb_ToggleTableBody(this,''body#REGION_'||
'ID#'')" class="pseudoButtonActive" />#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#" class="t16ChartIcon">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</'||
'td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="">#BODY#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBRight.png" alt=""/></td>'||unistr('\000a')||
'</tr>'||
''||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 16
 ,p_theme_class_id => 30
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_100_width
prompt  ......region template 2869402026481237
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2869402026481237 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader">#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" height="27" alt="" /><'||
'/td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td>#BODY#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Re'||
'gionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBRight.png" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Reports Region 100% Width'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 16
 ,p_theme_class_id => 13
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_list
prompt  ......region template 2869724319481239
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2869724319481239 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_16/collapse_minus.gif" alt="" align="middle" onclick="htmldb_ToggleTableBody(this,''body#REGION_'||
'ID#'')" class="pseudoButtonActive" />#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" height="27" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#" class="t16ChartIcon">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</'||
'td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16RegionBody">#BODY#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBRight.png" alt=""'||
'/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Chart List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 16
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/borderless_region
prompt  ......region template 2870027009481239
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2870027009481239 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th align="left" style="text-align:left;">#TITLE#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#" class="t16Borderless">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr><td class="t1'||
'6RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Borderless Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 16
 ,p_theme_class_id => 7
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_1
prompt  ......region template 2870307198481239
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2870307198481239 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="" style="border:#a2a2a2 1px solid;border-top:none;">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t16RegionHeader" style="padding-left:12px;"><img src="#IMAGE_PREFIX#themes/theme_16/collapse_minus.gif" alt="" align="middle" onclick="htmldb_ToggleTableBody(this,''body#REGION_ID#'')" class="pb" />#TITLE#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead'||
'>'||unistr('\000a')||
'<tbody id="body#REGION_ID#" class="t16Alt1">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr><td class="t16RegionBody">#BODY#</td></tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region, Alternative 1'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 16
 ,p_theme_class_id => 10
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/form_region
prompt  ......region template 2870621741481240
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2870621741481240 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t16ReportsRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapLeft.png" border="0" height="27" width="7" alt="" /></td>'||unistr('\000a')||
'<th class="t16RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_16/collapse_minus.gif" alt="" align="middle" onclick="htmldb_ToggleTableBody(this,''bo'||
'dy#REGION_ID#'')" class="pseudoButtonActive" />#TITLE#</th>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_16/t16ReportRegionCapRight.png" border="0" height="27" width="7" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="body#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td class="t16ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</t'||
'd>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="RL"><br /></td>'||unistr('\000a')||
'<td>#BODY#</td>'||unistr('\000a')||
'<td class="RR"><br /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'<tfoot>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBLeft.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBMiddle.png" alt=""/></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16RegionCapBRight.png" alt=""/></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tfoot>'||unistr('\000a')||
''||
'</table>'
 ,p_page_plug_template_name => 'Form Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 16
 ,p_theme_class_id => 8
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region
prompt  ......region template 2885905427489437
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2885905427489437 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#" #REGION_ATTRIBUTES#>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 1
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'||unistr('\000a')||
''
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/breadcrumb_region
prompt  ......region template 2886213363489437
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2886213363489437 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t1BreadcrumbRegion" id="#REGION_ID#">#BODY#</div>'
 ,p_page_plug_template_name => 'Breadcrumb Region'
 ,p_theme_id => 1
 ,p_theme_class_id => 6
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'Y'
 ,p_template_comment => 'Use this region template to contain breadcrumb menus.  Breadcrumb menus are implemented using breadcrumbs.  Breadcrumb menus are designed to displayed in #REGION_POSITION_01#'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region
prompt  ......region template 2886523266489437
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2886523266489437 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t1NavigationRegion" id="#REGION_ID#">#BODY#</div>'
 ,p_page_plug_template_name => 'Navigation Region'
 ,p_theme_id => 1
 ,p_theme_class_id => 5
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/report_list
prompt  ......region template 2886808322489437
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2886808322489437 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ListRegionwithIcon" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2"><table cellpadding="0" cellspacing="0" border="0" summary="" ><tr>'||unistr('\000a')||
'<td valign="top"><img src="#'||
'IMAGE_PREFIX#themes/theme_1/report.gif" alt=""/></td>'||unistr('\000a')||
'<td>#BODY#</td></tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Report List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 1
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_list
prompt  ......region template 2887131667489437
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2887131667489437 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ListRegionwithIcon" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2"><table cellpadding="0" cellspacing="0" border="0" summary="" ><tr><td valign="top"><img src="#I'||
'MAGE_PREFIX#themes/theme_1/chart.gif" alt=""/></td>'||unistr('\000a')||
'<td>#BODY#</td></tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 1
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_title
prompt  ......region template 2887429229489439
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2887429229489439 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1RegionwithoutTitle" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Region without Title'
 ,p_theme_id => 1
 ,p_theme_class_id => 11
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/hide_and_show_region
prompt  ......region template 2887726313489439
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2887726313489439 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1HideandShowRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#<a style="margin-left:5px;" href="javascript:hideShow(''region#REGION_SEQUENCE_ID#'',''shIMG#REGION_SEQUENCE_ID#'',''#IMAGE_PREFIX#themes/theme_1/rollup_plus_dgray.gif'',''#IMAG'||
'E_PREFIX#themes/theme_1/rollup_minus_dgray.gif'');" class="t1HideandShowRegionLink"><img src="#IMAGE_PREFIX#themes/theme_1/rollup_plus_dgray.gif" '||unistr('\000a')||
'  id="shIMG#REGION_SEQUENCE_ID#" alt="" /></a></td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body"><div class="t1Hide" id="region#REGION_SEQU'||
'ENCE_ID#">#BODY#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Hide and Show Region'
 ,p_theme_id => 1
 ,p_theme_class_id => 1
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Gray Head, white body'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_without_title
prompt  ......region template 2888025226489439
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2888025226489439 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ButtonRegionwithoutTitle" id="#REGION_ID#">'||unistr('\000a')||
'<tr><td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#<img src="#IMAGE_PREFIX#/themes/theme_1/1px_trans.gif" height="1" width="600" style="display:block;" alt="" /></td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'#BODY#'
 ,p_page_plug_template_name => 'Button Region without Title'
 ,p_theme_id => 1
 ,p_theme_class_id => 17
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_buttons_and_titles
prompt  ......region template 2888300769489439
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2888300769489439 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" cellpadding="0" cellspacing="0" border="0" class="t1RegionwithoutButtonsandTitles" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Region without Buttons and Titles'
 ,p_theme_id => 1
 ,p_theme_class_id => 19
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_1
prompt  ......region template 2888602376489439
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2888602376489439 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegionAlternative1" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region, Alternative 1'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 1
 ,p_theme_class_id => 10
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/borderless_region
prompt  ......region template 2888901989489439
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2888901989489439 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1BorderlessRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##COPY##CREATE##CREATE2##EXPAND##HELP#</td>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Borderless Region'
 ,p_theme_id => 1
 ,p_theme_class_id => 7
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Use this region template when you want to contain content without a border.'||unistr('\000a')||
''||unistr('\000a')||
'TITLE=YES'||unistr('\000a')||
'BUTTONS=YES'||unistr('\000a')||
'100% WIDTH=NO'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_with_title
prompt  ......region template 2889215533489439
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2889215533489439 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ButtonRegionwithTitle" id="#REGION_ID#">'||unistr('\000a')||
'<tr><td class="t1RegionHeader">#TITLE#</td></tr>'||unistr('\000a')||
'<tr><td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##COPY##EXPAND##HELP#<img src="#IMAGE_PREFIX#/themes/theme_1/1px_trans.gif" height="1" width="600" style="display:block;" alt="" /'||
'></td></tr>'||unistr('\000a')||
'</table>#BODY#'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Button Region with Title'
 ,p_theme_id => 1
 ,p_theme_class_id => 4
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region_alternative_1
prompt  ......region template 2889528351489439
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2889528351489439 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellspacing="0" cellpadding="0" border="0" class="t1SidebarRegionAlternative1" summary="" id="#REGION_ID#" align="right">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1EndCaps" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/left_curve.gif" width="10" height="20" alt="" /></td>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1EndCaps" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/right_curve.gif" width="'||
'10" height="20" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3" class="t1Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table><br />'
 ,p_page_plug_template_name => 'Sidebar Region, Alternative 1'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 1
 ,p_theme_class_id => 3
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region
prompt  ......region template 2889831731489440
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2889831731489440 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellspacing="0" cellpadding="0" border="0" class="t1SidebarRegion" summary="" id="#REGION_ID#" align="right">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1EndCaps" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/left_curve.gif" width="10" height="20" alt="" /></td>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1EndCaps" valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/right_curve.gif" width="10" height="'||
'20" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3" class="t1Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table><br />'
 ,p_page_plug_template_name => 'Sidebar Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 1
 ,p_theme_class_id => 2
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => '<table border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td rowspan="2" valign="top" width="4" bgcolor="#FF0000"><img src="#IMAGE_PREFIX#tl_img.gif" border="0" width="4" height="18" alt="" /></td>'||unistr('\000a')||
'          <td bgcolor="#000000" height="1"><img src="#IMAGE_PREFIX#stretch.gif" width="142" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'          <td rowspan="2" valign="top" width="4" bgcolor="#FF0000"><img src="#IMAGE_PREFIX#tr_img.gif" border="0" width="4" height="18" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td bgcolor="#FF0000" height="16">'||unistr('\000a')||
'            <table border="0" cellpadding="0" cellspacing="0" width="100%">'||unistr('\000a')||
'              <tr>'||unistr('\000a')||
'                <td align=middle valign="top">'||unistr('\000a')||
'                  <div align="center">'||unistr('\000a')||
'                     <font color="#ffffff" face="Arial, Helvetica, sans-serif" size="1">'||unistr('\000a')||
'                      <b>#TITLE# </b></font></div>'||unistr('\000a')||
'                </td>'||unistr('\000a')||
'              </tr>'||unistr('\000a')||
'            </table>'||unistr('\000a')||
'          </td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<table border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'   <tr>'||unistr('\000a')||
'   <td bgcolor="#000000" width="1" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'   <td valign="top" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="146" height="1" border="0" alt="" /><br />'||unistr('\000a')||
'            <table border="0" cellpadding="1" cellspacing="0" width="146" summary="">'||unistr('\000a')||
'              <tr>'||unistr('\000a')||
'                <td colspan="2">'||unistr('\000a')||
'                  <table border="0" cellpadding="2" cellspacing="0" width="124" summary="">'||unistr('\000a')||
'                    <tr>'||unistr('\000a')||
'                      <td>&nbsp;</td>'||unistr('\000a')||
'                      <td valign="top" width="106">'||unistr('\000a')||
'                        <P><FONT face="arial, helvetica" size="1">'||unistr('\000a')||
'                            #BODY#'||unistr('\000a')||
'                           </font>'||unistr('\000a')||
'                        </P>'||unistr('\000a')||
'                      </td>'||unistr('\000a')||
'                    </tr>'||unistr('\000a')||
'                  </table>'||unistr('\000a')||
'            </table>'||unistr('\000a')||
'          </td>'||unistr('\000a')||
'          <td bgcolor="#000000" width="1" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'          <td bgcolor="#9a9c9a" width="1" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'          <td bgcolor="#b3b4b3" width="1" height="96"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'      </table>'||unistr('\000a')||
'      <table border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td rowspan="4" valign="top" width="4"><img src="#IMAGE_PREFIX#bl_img.gif" border="0" width="4" height="6" alt="" /></td>'||unistr('\000a')||
'          <td bgcolor="#ffffff" height="2"><img src="#IMAGE_PREFIX#stretch.gif" width="142" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'          <td rowspan="4" valign="top" width="4"><img src="#IMAGE_PREFIX#br_img.gif" border="0" width="4" height="6" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td bgcolor="#000000" width="1"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td bgcolor="#9a9c9a" width="1"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'        <tr>'||unistr('\000a')||
'          <td bgcolor="#b3b4b3" width="1" height="2"><img src="#IMAGE_PREFIX#stretch.gif" width="1" height="1" border="0" alt="" /></td>'||unistr('\000a')||
'        </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/form_region
prompt  ......region template 2890106833489440
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2890106833489440 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1FormRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/1px_trans.gif" height="1" width="400" alt="" /><table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CH'||
'ANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body">#BODY#<img src="#IMAGE_PREFIX#/themes/theme_1/1px_trans.gif" height="1" width="600" style="display:block;" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Form Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 1
 ,p_theme_class_id => 8
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'||unistr('\000a')||
''
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region_alternative_1
prompt  ......region template 2890404591489440
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2890404591489440 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1NavigationRegionAlternative1" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Navigation Region, Alternative 1'
 ,p_theme_id => 1
 ,p_theme_class_id => 16
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region_with_icon
prompt  ......region template 2890721784489440
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2890721784489440 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1WizardRegionwithIcon" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2"><table summary="" cellpadding="0" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src='||
'"#IMAGE_PREFIX#alert_warning.gif" alt=""/></td>'||unistr('\000a')||
'<td width="100%" valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region with Icon'
 ,p_theme_id => 1
 ,p_theme_class_id => 20
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_region
prompt  ......region template 2891013448489440
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2891013448489440 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ChartRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body">#BODY#</td'||
'>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 1
 ,p_theme_class_id => 30
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/bracketed_region
prompt  ......region template 2891324424489440
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2891324424489440 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1BracketedRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##COPY##CREATE##CREATE2##EXPAND##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2"><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class='||
'"t1bracket"><img src="" height="5" width="1" alt="#IMAGE_PREFIX#themes/theme_1/1px_trans.gif" /></td>'||unistr('\000a')||
'<td rowspan="3" class="t1Body">#BODY#</td>'||unistr('\000a')||
'<td class="t1bracket"><img src="" height="5" width="1" alt="#IMAGE_PREFIX#themes/theme_1/1px_trans.gif" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_1/1px_trans.gif" height="1" width="1" alt="" /></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/the'||
'me_1/1px_trans.gif" height="1" width="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1bracket"><img src="" height="5" width="1" alt="#IMAGE_PREFIX#themes/theme_1/1px_trans.gif" /></td>'||unistr('\000a')||
'<td class="t1bracket"><img src="" height="5" width="1" alt="#IMAGE_PREFIX#themes/theme_1/1px_trans.gif" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Bracketed Region'
 ,p_theme_id => 1
 ,p_theme_class_id => 18
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Use this region template when you want to contain content with a bracket UI.'||unistr('\000a')||
''||unistr('\000a')||
'TITLE=YES'||unistr('\000a')||
'BUTTONS=YES'||unistr('\000a')||
'100% WIDTH=NO'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region
prompt  ......region template 2891602476489440
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2891602476489440 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1WizardRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region'
 ,p_theme_id => 1
 ,p_theme_class_id => 12
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_100_width
prompt  ......region template 2891922013489440
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2891922013489440 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion100Width" width="100%" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#</td>'||unistr('\000a')||
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region 100% Width'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 1
 ,p_theme_class_id => 13
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_100_width
prompt  ......region template 2906932684507742
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2906932684507742 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13ReportRegion" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#" width="100%">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BODY#'||
'</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region 100% Width'
 ,p_plug_table_bgcolor => '#FFFFFF'
 ,p_theme_id => 13
 ,p_theme_class_id => 13
 ,p_plug_heading_bgcolor => '#FFFFFF'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_title
prompt  ......region template 2907229673507742
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2907229673507742 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13RegionWithoutTitle" cellspacing="0" cellpadding="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Region without Title'
 ,p_theme_id => 13
 ,p_theme_class_id => 11
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region_alternative_1
prompt  ......region template 2907501150507743
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2907501150507743 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13NavigationRegionAlternative1" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<thead class="t13RegionHeader"><tr><th class="t13RegionTitle">#TITLE#</th></tr></thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Navigation Region, Alternative 1'
 ,p_theme_id => 13
 ,p_theme_class_id => 16
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/report_list
prompt  ......region template 2907828894507743
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2907828894507743 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13ListRegionwithIcon" cellspacing="0" cellpadding="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody"><table summar'||
'y="" cellpadding="0" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_13/report.gif""/></td>'||unistr('\000a')||
'<td valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Report List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 13
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region
prompt  ......region template 2908131741507743
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2908131741507743 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13ReportRegion" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons" valign="bottom">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BO'||
'DY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region'
 ,p_plug_table_bgcolor => '#FFFFFF'
 ,p_theme_id => 13
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#FFFFFF'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_1
prompt  ......region template 2908403702507743
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2908403702507743 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13ReportRegionAlt1" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons" valign="bottom">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody"'||
'>#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region, Alternative 1'
 ,p_plug_table_bgcolor => '#FFFFFF'
 ,p_theme_id => 13
 ,p_theme_class_id => 10
 ,p_plug_heading_bgcolor => '#FFFFFF'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_list
prompt  ......region template 2908707654507745
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2908707654507745 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13ListRegionwithIcon" cellspacing="0" cellpadding="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody"><table summar'||
'y="" cellpadding="0" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_13/chart.gif" alt="Chart"/></td>'||unistr('\000a')||
'<td valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 13
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region
prompt  ......region template 2909011243507745
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2909011243507745 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellspacing="0" cellpadding="0" border="0" class="t13Sidebar" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="L"><br /></th>'||unistr('\000a')||
'<th class="C">#TITLE#</th>'||unistr('\000a')||
'<th class="R"><br /></th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3" class="B">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region'
 ,p_plug_table_bgcolor => '#F7F7E7'
 ,p_theme_id => 13
 ,p_theme_class_id => 2
 ,p_plug_heading_bgcolor => '#F7F7E7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'Y'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/borderless_region
prompt  ......region template 2909305320507745
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2909305320507745 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13BorderlessRegion" cellspacing="0" cellpadding="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BODY#</td>'||unistr('\000a')||
'</t'||
'r>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Borderless Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 13
 ,p_theme_class_id => 7
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_without_title
prompt  ......region template 2909620825507745
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2909620825507745 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13ButtonRegionwithoutTitle" cellspacing="0" cellpadding="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region without Title'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 13
 ,p_theme_class_id => 17
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region_alternative_1
prompt  ......region template 2909900379507745
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2909900379507745 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellspacing="0" cellpadding="0" border="0" class="t13SidebarAlt1" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead>'||unistr('\000a')||
'<tr><th class="L"><br /></th><th class="C">#TITLE#</th><th class="R"><br /></th></tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="3" class="B">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region, Alternative 1'
 ,p_plug_table_bgcolor => '#F7F7E7'
 ,p_theme_id => 13
 ,p_theme_class_id => 3
 ,p_plug_heading_bgcolor => '#F7F7E7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/form_region
prompt  ......region template 2910222667507745
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2910222667507745 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13FormRegion" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BODY#<img src="#IMAG'||
'E_PREFIX#themes/theme_13/1px_trans.gif" height="1" width="500" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Form Region'
 ,p_theme_id => 13
 ,p_theme_class_id => 8
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Form Region is shimed out a minimum of 600px'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_region
prompt  ......region template 2910505663507745
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2910505663507745 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13ChartRegion" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</'||
'tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart Region'
 ,p_plug_table_bgcolor => '#FFFFFF'
 ,p_theme_id => 13
 ,p_theme_class_id => 30
 ,p_plug_heading_bgcolor => '#FFFFFF'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_with_title
prompt  ......region template 2910809433507745
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2910809433507745 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13ButtonRegionwithTitle" cellspacing="0" cellpadding="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region with Title'
 ,p_theme_id => 13
 ,p_theme_class_id => 4
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/hide_and_show_region
prompt  ......region template 2911121293507746
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2911121293507746 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13FormRegion" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#<img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#REGION_ID#Body'')" style="margin:0 5px;" class="pseudoButtonInactive" /></th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEX'||
'T#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody id="#REGION_ID#Body" style="display:none;">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Hide and Show Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 13
 ,p_theme_class_id => 1
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/bracketed_region
prompt  ......region template 2911409434507746
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2911409434507746 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t13BracketedRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13bracket"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif" height="5" width="1" alt="" /></td>'||unistr('\000a')||
'<td rowspan="3" class="t13RegionBody">'||unistr('\000a')||
'<div class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PR'||
'EVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div>#BODY#</td>'||unistr('\000a')||
'<td class="t13bracket"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif" height="5" width="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif" height="48" width="1" alt="" /></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif" height="48" width="1" al'||
't="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13bracket"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif" height="5" width="1" alt="" /></td>'||unistr('\000a')||
'<td class="t13bracket"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif" height="5" width="1" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Bracketed Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 13
 ,p_theme_class_id => 18
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region
prompt  ......region template 2911725918507746
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2911725918507746 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13WizardRegion" summary="" cellpadding="0" cellspacing="0" border="0" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<'||
'/tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region'
 ,p_theme_id => 13
 ,p_theme_class_id => 12
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region_with_icon
prompt  ......region template 2912027152507746
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2912027152507746 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13WizardRegion" summary="" cellpadding="0" cellspacing="0" border="0" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody class="Confirm">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BO'||
'DY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region with Icon'
 ,p_theme_id => 13
 ,p_theme_class_id => 20
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/breadcrumb_region
prompt  ......region template 2912313460507746
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2912313460507746 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div id="#REGION_ID#">#BODY#</div>'
 ,p_page_plug_template_name => 'Breadcrumb Region'
 ,p_theme_id => 13
 ,p_theme_class_id => 6
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region
prompt  ......region template 2912627103507746
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2912627103507746 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13NavigationRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t13RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Navigation Region'
 ,p_theme_id => 13
 ,p_theme_class_id => 5
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_buttons_and_title
prompt  ......region template 2912930610507746
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2912930610507746 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13RegionWithoutButtonTitle" cellspacing="0" cellpadding="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Region without Buttons and Title'
 ,p_theme_id => 13
 ,p_theme_class_id => 19
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/kopie_von_form_region
prompt  ......region template 2927228089529554
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2927228089529554 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t13FormRegion" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<thead class="t13RegionHeader">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<th class="t13RegionTitle">#TITLE#</th>'||unistr('\000a')||
'<th class="t13RegionButtons">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT#&nbsp;#DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</th>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</thead>'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t13RegionBody">#BODY#<img src="#IMAG'||
'E_PREFIX#themes/theme_13/1px_trans.gif" height="1" width="500" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Kopie von Form Region'
 ,p_theme_id => 101
 ,p_theme_class_id => 8
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Form Region is shimed out a minimum of 600px'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/borderless_region
prompt  ......region template 2948919776426571
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2948919776426571 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11BorderlessRegion" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Borderless Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 103
 ,p_theme_class_id => 7
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/bracketed_region
prompt  ......region template 2949214010426578
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2949214010426578 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary=""  class="t11BracketedRegion" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2"><table cellpadding="0" cellspacing="0" border="0" summary="" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11bracket"><img  height="5" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" alt="" /></td>'||
''||unistr('\000a')||
'<td rowspan="3">'||unistr('\000a')||
'<div class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div><div class="t11RegionBody">#BODY#</div></td>'||unistr('\000a')||
'<td class="t11bracket"><img  height="5" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11bracketspace"><img  height="1" width="1" src="#IMAGE_PREFIX#t'||
'hemes/theme_11/1px_trans.gif"  alt="" /></td>'||unistr('\000a')||
'<td class="t11bracketspace"><img  height="1" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11bracket"><img  height="5" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif"  alt="" /></td>'||unistr('\000a')||
'<td class="t11bracket"><img  height="5" width="1" src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif"  alt="'||
'" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Bracketed Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 103
 ,p_theme_class_id => 18
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/breadcrumb_region
prompt  ......region template 2949519638426579
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2949519638426579 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t11BreadcrumbRegion" id="#REGION_ID#">#BODY#</div>'||unistr('\000a')||
'          '
 ,p_page_plug_template_name => 'Breadcrumb Region'
 ,p_theme_id => 103
 ,p_theme_class_id => 6
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_with_title
prompt  ......region template 2949827714426581
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2949827714426581 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ButtonRegionwithTitle" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" style="display:block;"'||
' height="1" width="600" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region with Title'
 ,p_theme_id => 103
 ,p_theme_class_id => 4
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_without_title
prompt  ......region template 2950124668426581
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2950124668426581 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ButtonRegionwithoutTitle" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" style="display:block;" height="1" width="600" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>#BODY#'
 ,p_page_plug_template_name => 'Button Region without Title'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 103
 ,p_theme_class_id => 17
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_list
prompt  ......region template 2950411024426581
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2950411024426581 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ListRegionwithIcon" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody"><table summary="" cellpadding="0" cel'||
'lspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/chart.gif" alt="" /></td>'||unistr('\000a')||
'<td valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Chart List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 103
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_region
prompt  ......region template 2950700225426581
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2950700225426581 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ChartRegion" border="0" id="#REGION_ID#" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 103
 ,p_theme_class_id => 30
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/form_region
prompt  ......region template 2951006829426581
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2951006829426581 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11FormRegion" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#<img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" style="display:block;" height="1"'||
' width="600" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Form Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 103
 ,p_theme_class_id => 8
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/hide_and_show_region
prompt  ......region template 2951322555426582
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2951322555426582 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11HideandShowRegion" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#<a style="margin-left:5px;" href="javascript:hideShow(''region#REGION_SEQUENCE_ID#'',''shIMG#REGION_SEQUENCE_ID#'',''#IMAGE_PREFIX#themes/theme_11/t11showhide_hidden.gif'',''#IMAGE_PREFIX#themes/theme_11/t11showhide_show.gif'');" clas'||
's="htmldbHideShowMinLink"><img src="#IMAGE_PREFIX#themes/theme_11/t11showhide_hidden.gif" '||unistr('\000a')||
'  id="shIMG#REGION_SEQUENCE_ID#" alt="" /></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody"><div class="t11Hide" id="region#REGION_SEQUENCE_ID#"><div class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</div><div style="padding:10px">#BODY#'||
'</div></div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Hide and Show Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 103
 ,p_theme_class_id => 1
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/list_region_with_icon_report
prompt  ......region template 2951625544426582
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2951625544426582 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ListRegionwithIcon" id="htmldb#REGION_SEQUENCE_ID#" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody"><tabl'||
'e summary="" cellpadding="0" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/report.gif" alt="" /></td>'||unistr('\000a')||
'<td valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'List Region with Icon (Report)'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 103
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region
prompt  ......region template 2951912897426582
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2951912897426582 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div id="#REGION_ID#" style="clear:both;">#BODY#</div>'
 ,p_page_plug_template_name => 'Navigation Region'
 ,p_theme_id => 103
 ,p_theme_class_id => 5
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'In Round Green Theme Navigation Region and Navigation Region, Alternative 1 are the identical'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region_alternative_1
prompt  ......region template 2952204418426582
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2952204418426582 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div id="#REGION_ID#" style="clear:both;">#BODY#</div>'
 ,p_page_plug_template_name => 'Navigation Region, Alternative 1'
 ,p_theme_id => 103
 ,p_theme_class_id => 16
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'In Round Green Theme Navigation Region and Navigation Region, Alternative 1 are the identical'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_buttons_and_title
prompt  ......region template 2952505198426582
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2952505198426582 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11RegionwithoutButtonsandTitle" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Region without Buttons and Title'
 ,p_theme_id => 103
 ,p_theme_class_id => 19
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_title
prompt  ......region template 2952827288426582
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2952827288426582 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11RegionwithoutTitle" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">&nbsp;</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Region without Title'
 ,p_theme_id => 103
 ,p_theme_class_id => 11
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region
prompt  ......region template 2953114451426584
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2953114451426584 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t11ReportsRegion" border="0" cellpadding="0" cellspacing="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 103
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_100_width
prompt  ......region template 2953420364426584
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2953420364426584 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t11ReportsRegion100Width" border="0" cellpadding="0" cellspacing="0" summary="" id="#REGION_ID#" width="100%">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</t'||
'able>'
 ,p_page_plug_template_name => 'Reports Region 100% Width'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 103
 ,p_theme_class_id => 13
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_1
prompt  ......region template 2953725766426585
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2953725766426585 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11ReportsRegionAlternative1" id="#REGION_ID#" border="0" cellpadding="0" cellspacing="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>              '
 ,p_page_plug_template_name => 'Reports Region, Alternative 1'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 103
 ,p_theme_class_id => 10
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region
prompt  ......region template 2954017957426585
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2954017957426585 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table summary="" class="t11SidebarRegion" border="0" cellpadding="0" cellspacing="0" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Sidebar Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 103
 ,p_theme_class_id => 2
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region_alternative_1
prompt  ......region template 2954304336426585
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2954304336426585 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table border="0" cellpadding="0" cellspacing="0" class="t11SidebarRegionAlternative1" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader">#TITLE#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Sidebar Region, Alternative 1'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 103
 ,p_theme_class_id => 3
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region
prompt  ......region template 2954602903426585
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2954602903426585 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table border="0" cellpadding="0" cellspacing="0" class="t11WizardRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-tl.gif" width="15" height="15"  alt="" />#TITLE#</td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-tr.gif" width'||
'="15" height="15"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t11ButtonHolder" colspan="2">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t11RegionBody">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-bl.gif" width="15" height='||
'"15"  alt="" /></td>'||unistr('\000a')||
'<td align="right" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-br.gif" width="15" height="15"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region'
 ,p_theme_id => 103
 ,p_theme_class_id => 12
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region_with_icon
prompt  ......region template 2954921057426585
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 2954921057426585 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table border="0" cellpadding="0" cellspacing="0" class="t11WizardRegionwithIcon" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="top" class="t11RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-tl.gif" width="15" height="15"  alt="" />#TITLE#</td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11RegionHeader"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-tr.gi'||
'f" width="15" height="15"  alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t11ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td colspan="2" class="t11RegionBody"><table summary="" cellpadding="0" cellspacing="0" border="0">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td valign="top"><img src="#IMAGE_PREFIX#themes/theme_11/t11iconwizard.gif" alt="" />'||
'</td>'||unistr('\000a')||
'<td width="100%" valign="top">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="left" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-bl.gif" width="15" height="15"  alt="" /></td>'||unistr('\000a')||
'<td align="right" valign="bottom" class="t11RegionFooter"><img src="#IMAGE_PREFIX#themes/theme_11/t11corner-wiz-br.gif" width="15" height="15"  alt="" /></td>'||unistr('\000a')||
'</tr'||
'>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Wizard Region with Icon'
 ,p_theme_id => 103
 ,p_theme_class_id => 20
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_2
prompt  ......region template 4110207217669148
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 4110207217669148 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'||unistr('\000a')||
'#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region, Alternative 2'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 1
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'||unistr('\000a')||
'wie Report Region nur Buttons direkt links nach dem Region Titel'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_3_buttons_below_title
prompt  ......region template 5572010060380233
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 5572010060380233 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1RegionHeader">#TITLE#&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>'||unistr('\000a')||
'#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1Body" colspan="2">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Reports Region, Alternative 3 (Buttons below Title)'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 1
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'||unistr('\000a')||
'wie Report Region nur Buttons direkt links nach dem Region Titel'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region
prompt  ......region template 7160426382739448
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7160426382739448 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12SidebarRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
' <tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
' <tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
' <tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Sidebar Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 12
 ,p_theme_class_id => 2
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/sidebar_region_alternative_1
prompt  ......region template 7160521077739453
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7160521077739453 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12SidebarRegionAlternative1" id="#REGION_ID#" summary="">'||unistr('\000a')||
' <tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
' <tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
' <tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Sidebar Region, Alternative 1'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 12
 ,p_theme_class_id => 3
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/form_region
prompt  ......region template 7160632046739453
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7160632046739453 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12FormRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
'<tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'<tr><td><img src="#IMAGE_PREFIX#themes/theme_12/t.gif" width="400" height="1"></td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Form Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 12
 ,p_theme_class_id => 8
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_alternative_1
prompt  ......region template 7160721149739453
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7160721149739453 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12ReportsRegionAlternative1" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
'<tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Reports Region, Alternative 1'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 10
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region_alternative_1
prompt  ......region template 7160821375739453
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7160821375739453 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12NavigationRegionAlternative1" id="#REGION_ID#" summary="">'||unistr('\000a')||
' <tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
' <tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Navigation Region, Alternative 1'
 ,p_theme_id => 12
 ,p_theme_class_id => 16
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/list_region_with_icon
prompt  ......region template 7160919616739453
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7160919616739453 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12ListRegionWithIcon" id="#REGION_ID#" summary="">'||unistr('\000a')||
' <tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
' <tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
' <td><td class="t12Body"><img src="#IMAGE_PREFIX#themes/theme_12/provisioning_reports.gif" alt="" />#BODY#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'List Region with Icon'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/breadcrumb_region
prompt  ......region template 7161006868739453
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161006868739453 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<div class="t12BreadcrumbRegion" id="#REGION_ID#">#BODY#</div>'
 ,p_page_plug_template_name => 'Breadcrumb Region'
 ,p_theme_id => 12
 ,p_theme_class_id => 6
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/navigation_region
prompt  ......region template 7161107059739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161107059739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12NavigationRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
' <tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
' <tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Navigation Region'
 ,p_theme_id => 12
 ,p_theme_class_id => 5
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region_100_width
prompt  ......region template 7161232158739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161232158739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12ReportsRegion100PercentWidth" id="#REGION_ID#" summary="">'||unistr('\000a')||
' <tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
' <tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
' <tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Reports Region 100% Width'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 13
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_title
prompt  ......region template 7161319176739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161319176739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12RegionWithoutTitle" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Region without Title'
 ,p_theme_id => 12
 ,p_theme_class_id => 11
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/region_without_buttons_and_title
prompt  ......region template 7161410448739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161410448739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12RegionWithoutButtonsAndTitle" id="#REGION_ID#" summary="">'||unistr('\000a')||
' <tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Region without Buttons and Title'
 ,p_theme_id => 12
 ,p_theme_class_id => 19
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_with_title
prompt  ......region template 7161525320739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161525320739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12ButtonRegionWithTitle" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
'<tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Button Region with Title'
 ,p_theme_id => 12
 ,p_theme_class_id => 4
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/button_region_without_title
prompt  ......region template 7161608923739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161608923739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12ButtonRegionWithoutTitle" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Button Region without Title'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 17
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_list
prompt  ......region template 7161728708739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161728708739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12ListRegionWithIcon" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr><td colspan="2" class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
'<tr><td colspan="2" class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'  <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_12/ChartList.gif" />&nbsp;</td>'||unistr('\000a')||
'  <td valign="top" class="t12Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Chart List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/borderless_region
prompt  ......region template 7161814028739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161814028739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12BorderlessRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
'<tr><td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'<tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Borderless Region'
 ,p_plug_table_bgcolor => '#f7f7e7'
 ,p_theme_id => 12
 ,p_theme_class_id => 7
 ,p_plug_heading_bgcolor => '#f7f7e7'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/chart_region
prompt  ......region template 7161921005739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7161921005739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12ChartRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12Header">#TITLE#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12Body">#BODY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Chart Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 30
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region
prompt  ......region template 7162020914739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7162020914739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12WizardRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'  <td class="t12Header">#TITLE#</td>'||unistr('\000a')||
'  <td class="t12ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
' <td colspan="2" class="t12Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Wizard Region'
 ,p_theme_id => 12
 ,p_theme_class_id => 12
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/report_list
prompt  ......region template 7162125175739454
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7162125175739454 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12ListRegionWithIcon" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr><td colspan="2" class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
'<tr><td colspan="2" class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'  <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_12/ReportList.gif" alt="" /></td>'||unistr('\000a')||
'  <td valign="top" class="t12Body">#BODY#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Report List'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 29
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/bracketed_region
prompt  ......region template 7162218136739456
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7162218136739456 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12BracketedRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr><td class="t12Header">#TITLE#</td></tr>'||unistr('\000a')||
'<tr><td align="center"><table width="100%" class="t12ButtonHolder" summary=""><tr><td><br /></td></tr></table></td></tr>'||unistr('\000a')||
'<tr><td class="t12Body">#BODY#</td></tr>'||unistr('\000a')||
'<tr><td class="t12Body">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td></tr>'||unistr('\000a')||
'</table>'
 ,p_page_plug_template_name => 'Bracketed Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 18
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
 ,p_template_comment => 'Red Theme'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/hide_and_show_region
prompt  ......region template 7162308693739456
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7162308693739456 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table width="100%" cellpadding="0" cellspacing="0" border="0"  class="t12HideAndShowRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t12Header">#TITLE#<a href="javascript:hideShow(''region#REGION_SEQUENCE_ID#'',''shIMG#REGION_SEQUENCE_ID#'',''#IMAGE_PREFIX#htmldb/builder/rollup_plus_dgray.gif'',''#IMAGE_PREFIX#htmldb/builder/rollup_minus_dgray.gif'');" class="htmldbHideShowMinLink"><img src="#IMAGE_P'||
'REFIX#htmldb/builder/rollup_plus_dgray.gif" id="shIMG#REGION_SEQUENCE_ID#" alt="" /></a></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><div class="t12Hide" id="region#REGION_SEQUENCE_ID#">'||unistr('\000a')||
'<div class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</div>'||unistr('\000a')||
'<div class="t12Body">#BODY#</div>'||unistr('\000a')||
'</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Hide and Show Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 1
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/reports_region
prompt  ......region template 7162404982739456
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7162404982739456 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12ReportsRegion" id="#REGION_ID#" summary="">'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12Header">#TITLE#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12ButtonHolder">#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
'  <td class="t12Body">#BODY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Reports Region'
 ,p_plug_table_bgcolor => '#ffffff'
 ,p_theme_id => 12
 ,p_theme_class_id => 9
 ,p_plug_heading_bgcolor => '#ffffff'
 ,p_plug_font_size => '-1'
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

--application/shared_components/user_interface/templates/region/wizard_region_with_icon
prompt  ......region template 7162506602739456
 
begin
 
wwv_flow_api.create_plug_template (
  p_id => 7162506602739456 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_layout => 'TABLE'
 ,p_template => 
'<table class="t12WizardRegion" id="#REGION_ID#" summary="" border="1">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t12Header">#TITLE#</td>'||unistr('\000a')||
'<td class="t12ButtonHolder">#CLOSE#&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
' <td colspan="2" class="t12Body"><table width="100%" summary="">'||unistr('\000a')||
'    <tr><td><img src="#IMAGE_PREFIX#themes/theme_12/WizardIcon.gif" alt="" />&nbsp;</td><td>#BODY#</td></tr>'||
''||unistr('\000a')||
'  </table>'||unistr('\000a')||
' </td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''
 ,p_page_plug_template_name => 'Wizard Region with Icon'
 ,p_theme_id => 12
 ,p_theme_class_id => 20
 ,p_default_label_alignment => 'RIGHT'
 ,p_default_field_alignment => 'LEFT'
 ,p_translate_this_template => 'N'
  );
null;
 
end;
/

prompt  ...List Templates
--
--application/shared_components/user_interface/templates/list/dhtml_menu_with_sublist
prompt  ......list template 2788332252266434
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li class="dhtmlMenuSep2"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep2" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t6:=t6||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#themes/theme_13/menu_open_right.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#themes/theme_13/menu_open_right.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2788332252266434 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Menu with Sublist',
  p_theme_id  => 15,
  p_theme_class_id => 20,
  p_list_template_before_rows=>'<ul class="dhtmlMenuLG2">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_tree
prompt  ......list template 2788600107266437
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif"  align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  alt="" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" alt="" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2788600107266437 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Tree',
  p_theme_id  => 15,
  p_theme_class_id => 22,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" style="display:none;" class="dhtmlTree">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist
prompt  ......list template 2788917564266437
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t2:=t2||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t6:=t6||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2788917564266437 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML List (Image) with Sublist',
  p_theme_id  => 15,
  p_theme_class_id => 21,
  p_list_template_before_rows=>'<div class="dhtmlMenuLG">',
  p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;"><li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_without_bullet
prompt  ......list template 2789212195266437
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t15current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2789212195266437 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List without Bullet',
  p_theme_id  => 15,
  p_theme_class_id => 18,
  p_list_template_before_rows=>'<ul class="t15VerticalUnorderedListwithoutBullet">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_images_with_label_list
prompt  ......list template 2789527057266437
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t15current"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /><br />#TEXT#</td>';

t2:=t2||'<td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a><br /><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2789527057266437 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Images with Label List',
  p_theme_id  => 15,
  p_theme_class_id => 4,
  p_list_template_before_rows=>'<table cellspacing="0" cellpadding="0" border="0" class="t15HorizontalImageswithLabelList" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_links_list
prompt  ......list template 2789811920266437
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t15Current">&gt;#TEXT#&lt;</a>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2789811920266437 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Links List',
  p_theme_id  => 15,
  p_theme_class_id => 3,
  p_list_template_before_rows=>'<div class="t15HorizontalLinksList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_images_list
prompt  ......list template 2790120231266439
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t15current"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></td></tr>';

t2:=t2||'<tr><td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2790120231266439 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Images List',
  p_theme_id  => 15,
  p_theme_class_id => 5,
  p_list_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="0" class="t15VerticalImagesList">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_ordered_list
prompt  ......list template 2790431854266439
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t15current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2790431854266439 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Ordered List',
  p_theme_id  => 15,
  p_theme_class_id => 2,
  p_list_template_before_rows=>'<ol class="t15VerticalOrderedList">',
  p_list_template_after_rows=>'</ol>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tabbed_navigation_list
prompt  ......list template 2790726183266439
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td valign="bottom" class="t15SepL"><img src="#IMAGE_PREFIX#themes/theme_15/tab_list_left_cap.gif" /></td>'||unistr('\000a')||
'<td class="t15CurrentListTab"><a class="t15CurrentListTab" href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td valign="bottom" class="t15SepR"><img src="#IMAGE_PREFIX#themes/theme_15/tab_list_right_cap.gif" /></td>';

t2:=t2||'<td><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2790726183266439 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tabbed Navigation List',
  p_theme_id  => 15,
  p_theme_class_id => 7,
  p_list_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0"  summary="" width="100%" class="t15TabbedNavigationList"><tbody><tr><td class="t15LeftTabList">&nbsp;&nbsp;&nbsp;&nbsp;</td>',
  p_list_template_after_rows=>'<td class="t14EndCap" width="100%">&nbsp;</td></tr></tbody></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
prompt  ......list template 2791027858266439
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2791027858266439 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List with Bullets',
  p_theme_id  => 15,
  p_theme_class_id => 1,
  p_list_template_before_rows=>'<ul class="t15noIndent">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/button_list
prompt  ......list template 2791324591266439
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<table class="t15Button" cellspacing="0" cellpadding="0" border="0"  summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15L"><img src="#IMAGE_PREFIX#themes/theme_15/button-l.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15C"><a href="#LINK#" style="font-weight:bold;">>#TEXT#<</a></td>'||unistr('\000a')||
'<td class="t15R"><img src="#IMAGE_PREFIX#themes/theme_15/button-r.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>';

t2:=t2||'<table class="t15Button" cellspacing="0" cellpadding="0" border="0"  summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t15L"><img src="#IMAGE_PREFIX#themes/theme_15/button-l.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t15C"><a href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td class="t15R"><img src="#IMAGE_PREFIX#themes/theme_15/button-r.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2791324591266439 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Button List',
  p_theme_id  => 15,
  p_theme_class_id => 6,
  p_list_template_before_rows=>'<div class="t15ButtonList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/wizard_progress_list
prompt  ......list template 2791606307266439
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t15Current">#TEXT#</td></tr>'||unistr('\000a')||
'<tr><td class="t15CurrentImage"><img src="#IMAGE_PREFIX#arrow_down.gif" width="7" height="6" alt="" /></td></tr>';

t2:=t2||'<tr><td>#TEXT#</td></tr>'||unistr('\000a')||
'<tr><td class="t15Image"><img src="#IMAGE_PREFIX#arrow_down.gif" width="7" height="6" alt="" /></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2791606307266439 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Wizard Progress List',
  p_theme_id  => 15,
  p_theme_class_id => 17,
  p_list_template_before_rows=>'<table class="t15WizardProgressList" cellpadding="0" cellspacing="0" border="0" summary="">',
  p_list_template_after_rows=>'<tr><td align="center">Done</td></tr>'||unistr('\000a')||
'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tree_list
prompt  ......list template 2791930099266440
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2791930099266440 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tree List',
  p_theme_id  => 15,
  p_theme_class_id => 23,
  p_list_template_before_rows=>'<ul class="htmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_sidebar_list
prompt  ......list template 2792232011266440
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#" class="t15Current">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2792232011266440 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Sidebar List',
  p_theme_id  => 15,
  p_theme_class_id => 19,
  p_list_template_before_rows=>'<ul class="t15VerticalSidebarList">'||unistr('\000a')||
'',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_ordered_list
prompt  ......list template 2809304455273785
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t8current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2809304455273785 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Ordered List',
  p_theme_id  => 8,
  p_theme_class_id => 2,
  p_list_template_before_rows=>'<ol class="t8VerticalOrderedList">',
  p_list_template_after_rows=>'</ol>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_links_list
prompt  ......list template 2809620618273787
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<span class="t8current">#TEXT#</span>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2809620618273787 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Links List',
  p_theme_id  => 8,
  p_theme_class_id => 3,
  p_list_template_before_rows=>'<div class="t8HorizontalLinksList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_menu_with_sublist
prompt  ......list template 2809915170273787
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li class="dhtmlMenuSep2"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep2" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t6:=t6||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2809915170273787 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Menu with Sublist',
  p_theme_id  => 8,
  p_theme_class_id => 20,
  p_list_template_before_rows=>'<ul class="dhtmlMenuLG2">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_sidebar_list
prompt  ......list template 2810201872273787
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr align="center" valign="middle"> '||unistr('\000a')||
'<td width="15" height="25" align="left"><img src="#IMAGE_PREFIX#themes/theme_8/t3left_nav_mark_orange.gif" width="10" height="13" alt="" /></td>'||unistr('\000a')||
'<td class="t8lefthot">#TEXT#</td>'||unistr('\000a')||
'</tr>';

t2:=t2||'<tr align="center" valign="middle"> '||unistr('\000a')||
'<td width="15" align="left"><img src="#IMAGE_PREFIX#themes/theme_8/t3left_nav_mark_gray.gif" width="10" height="13" alt="" /></td>'||unistr('\000a')||
'<td height="25" class="t8leftnavtable"><a href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'</tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2810201872273787 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Sidebar List',
  p_theme_id  => 8,
  p_theme_class_id => 19,
  p_list_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" style="background-color:#e5e5dc;border-right:1px #BFBFB8 solid;" summary="">',
  p_list_template_after_rows=>'<tr> '||unistr('\000a')||
'<td height="18" align="left" style="background-color:E5E5DC" colspan="2"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="170" height="1" alt="0" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'<tr> '||unistr('\000a')||
'<td height="4" align="left" style="background-color:BFBFB8" colspan="2"><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" width="170" height="1" alt="0" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/button_list
prompt  ......list template 2810509742273787
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t8C">#TEXT#</td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" alt="" width="14" height="14" /></td>'||unistr('\000a')||
'';

t2:=t2||'<td class="t8C"><a href="#" class="t8C">#TEXT#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_8/spacer.gif" alt="" width="14" height="14" /></td>'||unistr('\000a')||
'';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2810509742273787 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Button List',
  p_theme_id  => 8,
  p_theme_class_id => 6,
  p_list_template_before_rows=>'<table class="t8ButtonList" summary="" cellpadding="0" cellspacing="0" border="0"><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
prompt  ......list template 2810818429273787
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t8VerticalUnorderedListwithBullets"><span class="t8current">#TEXT#</span></li>';

t2:=t2||'<li class="t8VerticalUnorderedListwithBullets"><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2810818429273787 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List with Bullets',
  p_theme_id  => 8,
  p_theme_class_id => 1,
  p_list_template_before_rows=>'<ul class="t8VerticalUnorderedListwithBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_without_bullet
prompt  ......list template 2811100993273789
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t8current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2811100993273789 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List without Bullet',
  p_theme_id  => 8,
  p_theme_class_id => 18,
  p_list_template_before_rows=>'<ul class="t8VerticalUnorderedListwithoutBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist
prompt  ......list template 2811423278273789
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# alt="" /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" alt="" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t2:=t2||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# alt="" /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" alt="" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# alt="" /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" alt="" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t6:=t6||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# alt="" /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" alt="" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2811423278273789 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML List (Image) with Sublist',
  p_theme_id  => 8,
  p_theme_class_id => 21,
  p_list_template_before_rows=>'<div class="dhtmlMenuLG">',
  p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;"><li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/wizard_progress_list
prompt  ......list template 2811719427273789
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t8current">#TEXT#<br /><img src="#IMAGE_PREFIX#themes/theme_8/t8arrowdown01.gif" alt="Down" /></td></tr>';

t2:=t2||'<tr><td>#TEXT#<br /><img src="#IMAGE_PREFIX#themes/theme_8/t8arrowdown01.gif" alt="Down" /></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2811719427273789 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Wizard Progress List',
  p_theme_id  => 8,
  p_theme_class_id => 17,
  p_list_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="" class="t8WizardProgressList">',
  p_list_template_after_rows=>'<tr><td>&DONE.</td></tr>'||unistr('\000a')||
'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_tree
prompt  ......list template 2812004287273789
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif"  align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2812004287273789 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Tree',
  p_theme_id  => 8,
  p_theme_class_id => 22,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" style="display:none;" class="dhtmlTree">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tree_list
prompt  ......list template 2812316087273789
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2812316087273789 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tree List',
  p_theme_id  => 8,
  p_theme_class_id => 23,
  p_list_template_before_rows=>'<ul class="htmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_images_with_label_list
prompt  ......list template 2812606279273789
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t8current"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR#/><br />#TEXT#</td>';

t2:=t2||'<td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR#/></a><br /><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2812606279273789 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Images with Label List',
  p_theme_id  => 8,
  p_theme_class_id => 4,
  p_list_template_before_rows=>'<table cellspacing="0" cellpadding="0" border="0" class="t8HorizontalImageswithLabelList" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_images_list
prompt  ......list template 2812900841273789
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t8current"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /><br/>#TEXT#</td></tr>';

t2:=t2||'<tr><td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /><br/>#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2812900841273789 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Images List',
  p_theme_id  => 8,
  p_theme_class_id => 5,
  p_list_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="0" class="t8VerticalImagesList">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tabbed_navigation_list
prompt  ......list template 2813222213273790
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a class="t8current" href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2813222213273790 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tabbed Navigation List',
  p_theme_id  => 8,
  p_theme_class_id => 7,
  p_list_template_before_rows=>'<ul class="t8TabbedNavigationList">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_images_with_label_list
prompt  ......list template 2829624466468453
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t11current"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/><br />#TEXT#</td>';

t2:=t2||'<td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/></a><br /><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2829624466468453 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Images with Label List',
  p_theme_id  => 11,
  p_theme_class_id => 4,
  p_list_template_before_rows=>'<table class="t11HorizontalImageswithLabelList" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_ordered_list
prompt  ......list template 2829910915468453
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t11current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2829910915468453 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Ordered List',
  p_theme_id  => 11,
  p_theme_class_id => 2,
  p_list_template_before_rows=>'<ol class="t11VerticalOrderedList">',
  p_list_template_after_rows=>'</ol>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_links_list
prompt  ......list template 2830209799468453
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<span class="t11current">#TEXT#</span>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2830209799468453 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Links List',
  p_theme_id  => 11,
  p_theme_class_id => 3,
  p_list_template_before_rows=>'<div class="t11HorizontalLinksList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist
prompt  ......list template 2830531508468453
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t2:=t2||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t6:=t6||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2830531508468453 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML List (Image) with Sublist',
  p_theme_id  => 11,
  p_theme_class_id => 21,
  p_list_template_before_rows=>'<div class="dhtmlMenuLG">',
  p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;"><li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
prompt  ......list template 2830807827468453
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t11current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2830807827468453 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List with Bullets',
  p_theme_id  => 11,
  p_theme_class_id => 1,
  p_list_template_before_rows=>'<ul class="t11VerticalUnorderedListwithBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tree_list
prompt  ......list template 2831102714468453
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2831102714468453 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tree List',
  p_theme_id  => 11,
  p_theme_class_id => 23,
  p_list_template_before_rows=>'<ul class="htmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/wizard_progress_list
prompt  ......list template 2831412306468453
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td><div class="t11current">#TEXT#</div><img src="#IMAGE_PREFIX#themes/theme_11/t11arrowdown01.gif" alt="Down" /></td></tr>';

t2:=t2||'<tr><td><div>#TEXT#</div><img src="#IMAGE_PREFIX#themes/theme_11/t11arrowdown01.gif" alt="Down" /></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2831412306468453 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Wizard Progress List',
  p_theme_id  => 11,
  p_theme_class_id => 17,
  p_list_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="" class="t11WizardProgressList">',
  p_list_template_after_rows=>'<tr><td>&DONE.</td></tr>'||unistr('\000a')||
'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_links_without_bullets
prompt  ......list template 2831702333468454
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t11current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2831702333468454 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered Links without Bullets',
  p_theme_id  => 11,
  p_theme_class_id => 18,
  p_list_template_before_rows=>'<ul class="t11VerticalUnorderedListwithoutBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_tree
prompt  ......list template 2832025101468454
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif"  align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2832025101468454 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Tree',
  p_theme_id  => 11,
  p_theme_class_id => 22,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" style="display:none;" class="dhtmlTree">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_menu_with_sublist
prompt  ......list template 2832304361468454
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li class="dhtmlMenuSep2"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep2" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t6:=t6||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2832304361468454 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Menu with Sublist',
  p_theme_id  => 11,
  p_theme_class_id => 20,
  p_list_template_before_rows=>'<ul class="dhtmlMenuLG2">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_sidebar_list
prompt  ......list template 2832628925468454
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td align="right" valign="middle" class="t11current">#TEXT#</td></tr>';

t2:=t2||'<tr><td align="right" valign="middle"><a href="#LINK#" class="t11nav">#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2832628925468454 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Sidebar List',
  p_theme_id  => 11,
  p_theme_class_id => 19,
  p_list_template_before_rows=>'<table border="0" cellspacing="0" cellpadding="0" summary="" width="100%" class="t11VerticalSidebarList">',
  p_list_template_after_rows=>'<tr><td><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="100" alt="" style="display:block;" /></td></tr>'||unistr('\000a')||
'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tabbed_navigation_list
prompt  ......list template 2832917073468454
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#" class="t11current">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2832917073468454 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tabbed Navigation List',
  p_theme_id  => 11,
  p_theme_class_id => 7,
  p_list_template_before_rows=>'<ul class="t11TabbedNavigationList">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/button_list
prompt  ......list template 2833225847468454
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t11Button" align="right">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn1_corner_tl.gif" width="8" height="16" /></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#TEXT#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><span class="t11R"><img src="#IMAGE_PREFIX#themes/the';

t:=t||'me_11/t11btn1_corner_tr.gif" width="8" height="16" /></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>';

t2:=t2||'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ButtonAlternative1" align="right">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn2_corner_tl.gif" width="8" height="16" /></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#TEXT#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><span class="t11R"><img src="#IMAGE_PREFI';

t2:=t2||'X#themes/theme_11/t11btn2_corner_tr.gif" width="8" height="16" /></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2833225847468454 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Button List',
  p_theme_id  => 11,
  p_theme_class_id => 6,
  p_list_template_before_rows=>'<table border="0" cellspacing="0" cellpadding="0" summary="" class="t11ButtonList"><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_images_list
prompt  ......list template 2833507237468454
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t11current"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</td></tr>';

t2:=t2||'<tr><td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2833507237468454 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Images List',
  p_theme_id  => 11,
  p_theme_class_id => 5,
  p_list_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="" class="t11VerticalImagesList">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_menu_with_sublist
prompt  ......list template 2850211562474914
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li class="dhtmlMenuSep2"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep2" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t6:=t6||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2850211562474914 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Menu with Sublist',
  p_theme_id  => 17,
  p_theme_class_id => 20,
  p_list_template_before_rows=>'<ul class="dhtmlMenuLG2">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tabbed_navigation_list
prompt  ......list template 2850510776474915
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td valign="bottom" class="t17SepL"><img src="#IMAGE_PREFIX#themes/theme_17/tab_list_left_cap.gif" /></td>'||unistr('\000a')||
'<td class="t17CurrentListTab"><a class="t17CurrentListTab" href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td valign="bottom" class="t17SepR"><img src="#IMAGE_PREFIX#themes/theme_17/tab_list_right_cap.gif" /></td>';

t2:=t2||'<td><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2850510776474915 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tabbed Navigation List',
  p_theme_id  => 17,
  p_theme_class_id => 7,
  p_list_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0"  summary="" width="100%" class="t17TabbedNavigationList"><tbody><tr><td class="t17LeftTabList">&nbsp;&nbsp;&nbsp;&nbsp;</td>',
  p_list_template_after_rows=>'<td class="t17EndCap" width="100%">&nbsp;</td></tr></tbody></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
prompt  ......list template 2850825852474915
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t17current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2850825852474915 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List with Bullets',
  p_theme_id  => 17,
  p_theme_class_id => 1,
  p_list_template_before_rows=>'<ul class="t17VerticalUnorderedListwithBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_images_list
prompt  ......list template 2851122883474915
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t17current"><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></td></tr>';

t2:=t2||'<tr><td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2851122883474915 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Images List',
  p_theme_id  => 17,
  p_theme_class_id => 5,
  p_list_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="" class="t17VerticalImagesList">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_tree
prompt  ......list template 2851415643474915
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif"  align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2851415643474915 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Tree',
  p_theme_id  => 17,
  p_theme_class_id => 22,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" style="display:none;" class="dhtmlTree">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist
prompt  ......list template 2851704445474915
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t2:=t2||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t6:=t6||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2851704445474915 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML List (Image) with Sublist',
  p_theme_id  => 17,
  p_theme_class_id => 21,
  p_list_template_before_rows=>'<div class="dhtmlMenuLG">',
  p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;"><li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_images_with_label_list
prompt  ......list template 2852004265474917
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t17current"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/><br />#TEXT#</td>';

t2:=t2||'<td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/></a><br /><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2852004265474917 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Images with Label List',
  p_theme_id  => 17,
  p_theme_class_id => 4,
  p_list_template_before_rows=>'<table class="t17HorizontalImageswithLabelList" cellpadding="0" border="0" cellspacing="0" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/button_list
prompt  ......list template 2852325797474917
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t17Button" style="background-color:#CCCCCC;">#TEXT#</a>';

t2:=t2||'<a href="#LINK#" class="t17Button">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2852325797474917 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Button List',
  p_theme_id  => 17,
  p_theme_class_id => 6,
  p_list_template_before_rows=>'<div class="t17ButtonList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_links_list
prompt  ......list template 2852627580474917
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t17current">#TEXT#</a>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2852627580474917 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Links List',
  p_theme_id  => 17,
  p_theme_class_id => 3,
  p_list_template_before_rows=>'<div class="t17HorizontalLinksList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/wizard_progress_list
prompt  ......list template 2852927937474917
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="t17current">#TEXT#</div>';

t2:=t2||'<div>#TEXT#</div>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2852927937474917 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Wizard Progress List',
  p_theme_id  => 17,
  p_theme_class_id => 17,
  p_list_template_before_rows=>'<div class="t17WizardProgressList">',
  p_list_template_after_rows=>'<center>&DONE.</center>'||unistr('\000a')||
'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_sidebar_list
prompt  ......list template 2853212599474917
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="current">#TEXT#</a>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2853212599474917 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Sidebar List',
  p_theme_id  => 17,
  p_theme_class_id => 19,
  p_list_template_before_rows=>'<div class="t17VerticalSidebarList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_links_without_bullets
prompt  ......list template 2853510849474918
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t17current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2853510849474918 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered Links without Bullets',
  p_theme_id  => 17,
  p_theme_class_id => 18,
  p_list_template_before_rows=>'<ul class="t17VerticalUnorderedLinkswithoutBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_ordered_list
prompt  ......list template 2853814761474920
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t17current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2853814761474920 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Ordered List',
  p_theme_id  => 17,
  p_theme_class_id => 2,
  p_list_template_before_rows=>'<ol class="t17VerticalOrderedList">',
  p_list_template_after_rows=>'</ol>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tree_list
prompt  ......list template 2854122986474920
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2854122986474920 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tree List',
  p_theme_id  => 17,
  p_theme_class_id => 23,
  p_list_template_before_rows=>'<ul class="htmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_ordered_list
prompt  ......list template 2870905609481240
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t16current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2870905609481240 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Ordered List',
  p_theme_id  => 16,
  p_theme_class_id => 2,
  p_list_template_before_rows=>'<ol class="t16VerticalOrderedList">',
  p_list_template_after_rows=>'</ol>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_links_list
prompt  ......list template 2871224253481240
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t16current">#TEXT#</a>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2871224253481240 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Links List',
  p_theme_id  => 16,
  p_theme_class_id => 3,
  p_list_template_before_rows=>'<div class="t16HorizontalLinksList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/wizard_progress_list
prompt  ......list template 2871527800481240
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="t16current">#TEXT#</div>';

t2:=t2||'<div>#TEXT#</div>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2871527800481240 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Wizard Progress List',
  p_theme_id  => 16,
  p_theme_class_id => 17,
  p_list_template_before_rows=>'<div class="t16WizardProgressList">',
  p_list_template_after_rows=>'<center>&DONE.</center>'||unistr('\000a')||
'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tree_list
prompt  ......list template 2871810994481240
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2871810994481240 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tree List',
  p_theme_id  => 16,
  p_theme_class_id => 23,
  p_list_template_before_rows=>'<ul class="htmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_images_list
prompt  ......list template 2872103559481240
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t16current"><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></td></tr>';

t2:=t2||'<tr><td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2872103559481240 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Images List',
  p_theme_id  => 16,
  p_theme_class_id => 5,
  p_list_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="" class="t16VerticalImagesList">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tabbed_navigation_list
prompt  ......list template 2872405115481240
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td valign="bottom" class="t16SepL"><img src="#IMAGE_PREFIX#themes/theme_16/tab_list_left_cap.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t16CurrentListTab"><a class="t16CurrentListTab" href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td valign="bottom" class="t16SepR"><img src="#IMAGE_PREFIX#themes/theme_16/tab_list_right_cap.gif" alt="" /></td>';

t2:=t2||'<td><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2872405115481240 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tabbed Navigation List',
  p_theme_id  => 16,
  p_theme_class_id => 7,
  p_list_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0"  summary="" width="100%" class="t16TabbedNavigationList"><tbody><tr><td class="t16LeftTabList">&nbsp;&nbsp;&nbsp;&nbsp;</td>',
  p_list_template_after_rows=>'<td class="t14EndCap" width="100%">&nbsp;</td></tr></tbody></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_links_without_bullets
prompt  ......list template 2872724197481242
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t16current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2872724197481242 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered Links without Bullets',
  p_theme_id  => 16,
  p_theme_class_id => 18,
  p_list_template_before_rows=>'<ul class="t16VerticalUnorderedLinkswithoutBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_sidebar_list
prompt  ......list template 2873030894481242
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t16ItemC">#TEXT#</a>';

t2:=t2||'<a href="#LINK#" class="t16Item">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2873030894481242 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Sidebar List',
  p_theme_id  => 16,
  p_theme_class_id => 19,
  p_list_template_before_rows=>'<div class="t16VerticalSidebarList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
prompt  ......list template 2873328471481242
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t16current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2873328471481242 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List with Bullets',
  p_theme_id  => 16,
  p_theme_class_id => 1,
  p_list_template_before_rows=>'<ul class="t16VerticalUnorderedListwithBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_images_with_label_list
prompt  ......list template 2873625582481242
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t16current"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/><br />#TEXT#</td>';

t2:=t2||'<td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/></a><br /><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2873625582481242 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Images with Label List',
  p_theme_id  => 16,
  p_theme_class_id => 4,
  p_list_template_before_rows=>'<table class="t16HorizontalImageswithLabelList" cellpadding="0" border="0" cellspacing="0" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/button_list
prompt  ......list template 2873901817481242
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Button">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16ButtonC1Left.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'<td class="MC" valign="middle"><a href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16ButtonC1Right.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>';

t2:=t2||'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t16Button">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Button1Left.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'<td class="M" valign="middle"><a href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_16/t16Button1Right.gif" width="3" height="18" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2873901817481242 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Button List',
  p_theme_id  => 16,
  p_theme_class_id => 6,
  p_list_template_before_rows=>'<div class="t16ButtonList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_menu_with_sublist
prompt  ......list template 2874221453481242
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li class="dhtmlMenuSep2"><img src="#IMAGE_PREFIX#themes/theme_16/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep2" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_16/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t6:=t6||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_16/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t16MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2874221453481242 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Menu with Sublist',
  p_theme_id  => 16,
  p_theme_class_id => 20,
  p_list_template_before_rows=>'<ul class="dhtmlMenuLG2">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_tree
prompt  ......list template 2874518635481242
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif"  align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2874518635481242 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Tree',
  p_theme_id  => 16,
  p_theme_class_id => 22,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" style="display:none;" class="dhtmlTree">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist
prompt  ......list template 2874808003481243
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t2:=t2||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_16/1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li class="dhtmlSubMenuN"><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)"><span style="float:left;">#TEXT#</span></a></li>';

t5:=t5||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t6:=t6||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t16MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t16MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2874808003481243 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML List (Image) with Sublist',
  p_theme_id  => 16,
  p_theme_class_id => 21,
  p_list_template_before_rows=>'<div class="dhtmlMenuLG">',
  p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;"><li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist
prompt  ......list template 2892215545489442
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# / alt=""></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" alt="" / ><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t2:=t2||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# alt="" / ></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" alt="" / ><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# alt="" / ></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" alt="" / ><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t6:=t6||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# alt="" / ></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" alt="" / ><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif"  alt="" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2892215545489442 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML List (Image) with Sublist',
  p_theme_id  => 1,
  p_theme_class_id => 21,
  p_list_template_before_rows=>'<div class="dhtmlMenuLG">',
  p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;"><li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_menu_with_sublist
prompt  ......list template 2892523069489442
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li class="dhtmlMenuSep2"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep2" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t6:=t6||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2892523069489442 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Menu with Sublist',
  p_theme_id  => 1,
  p_theme_class_id => 20,
  p_list_template_before_rows=>'<ul class="dhtmlMenuLG2">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_tree
prompt  ......list template 2892816292489442
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif"  align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" alt="" /><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2892816292489442 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Tree',
  p_theme_id  => 1,
  p_theme_class_id => 22,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" style="display:none;" class="dhtmlTree">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/wizard_progress_list
prompt  ......list template 2893113725489442
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td><div class="t1current">#TEXT#</div><img src="#IMAGE_PREFIX#themes/theme_1/arrow_down.gif" alt="Down" /></td></tr>';

t2:=t2||'<tr><td><div>#TEXT#</div><img src="#IMAGE_PREFIX#themes/theme_1/arrow_down.gif" alt="Down" /></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2893113725489442 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Wizard Progress List',
  p_theme_id  => 1,
  p_theme_class_id => 17,
  p_list_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="" class="t1WizardProgressList">',
  p_list_template_after_rows=>'<tr><td>&DONE.</td></tr>'||unistr('\000a')||
'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_ordered_list
prompt  ......list template 2893400312489442
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t1current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2893400312489442 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Ordered List',
  p_theme_id  => 1,
  p_theme_class_id => 2,
  p_list_template_before_rows=>'<ol class="t1VerticalOrderedList">',
  p_list_template_after_rows=>'</ol>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/button_list
prompt  ......list template 2893715870489442
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<table class="t1ButtonList" cellspacing="0" cellpadding="0" border="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1L"><img src="#IMAGE_PREFIX#/themes/theme_1/list_button_left_hl.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t1C"><a href="#LINK#" style="color:#FFFFFF;">#TEXT#</a></td>'||unistr('\000a')||
'<td class="t1R"><img src="#IMAGE_PREFIX#/themes/theme_1/list_button_right_hl.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>';

t2:=t2||'<table class="t1ButtonList" cellspacing="0" cellpadding="0" border="0" summary="">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td class="t1L"><img src="#IMAGE_PREFIX#/themes/theme_1/list_button_left.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t1NC"><a href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td class="t1R"><img src="#IMAGE_PREFIX#/themes/theme_1/list_button_right.gif" alt="" /></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2893715870489442 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Button List',
  p_theme_id  => 1,
  p_theme_class_id => 6,
  p_list_template_before_rows=>'<div class="t1ButtonList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_links_list
prompt  ......list template 2894024135489442
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t1current">#TEXT#</a>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2894024135489442 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Links List',
  p_theme_id  => 1,
  p_theme_class_id => 3,
  p_list_template_before_rows=>'<div class="t1HorizontalLinksList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_images_list
prompt  ......list template 2894330247489443
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t1current"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" / >#TEXT#</td></tr>';

t2:=t2||'<tr><td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" / >#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2894330247489443 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Images List',
  p_theme_id  => 1,
  p_theme_class_id => 5,
  p_list_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="0" class="t1VerticalImagesList">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_sidebar_list
prompt  ......list template 2894628070489443
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t1navcurrent">#TEXT#</a>';

t2:=t2||'<a href="#LINK#" class="t1nav">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2894628070489443 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Sidebar List',
  p_theme_id  => 1,
  p_theme_class_id => 19,
  p_list_template_before_rows=>'<div class="t1VerticalSidebarList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_without_bullet
prompt  ......list template 2894907433489443
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t1current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2894907433489443 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List without Bullet',
  p_theme_id  => 1,
  p_theme_class_id => 18,
  p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithoutBullet">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
prompt  ......list template 2895203907489443
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t1current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2895203907489443 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List with Bullets',
  p_theme_id  => 1,
  p_theme_class_id => 1,
  p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tabbed_navigation_list
prompt  ......list template 2895519652489443
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a class="t1current" href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2895519652489443 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tabbed Navigation List',
  p_theme_id  => 1,
  p_theme_class_id => 7,
  p_list_template_before_rows=>'<ul class="t1TabbedNavigationList">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/hierarchical_expanded
prompt  ......list template 2895827839489443
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2895827839489443 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Hierarchical Expanded',
  p_theme_id  => 1,
  p_theme_class_id => 23,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_images_with_label_list
prompt  ......list template 2896122830489443
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t1current"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" / ><br />#TEXT#</td>';

t2:=t2||'<td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" / ></a><br /><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2896122830489443 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Images with Label List',
  p_theme_id  => 1,
  p_theme_class_id => 4,
  p_list_template_before_rows=>'<table cellspacing="0" cellpadding="0" border="0" class="t1HorizontalImageswithLabelList" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist
prompt  ......list template 2913218538507746
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t2:=t2||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t6:=t6||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2913218538507746 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML List (Image) with Sublist',
  p_theme_id  => 13,
  p_theme_class_id => 21,
  p_list_template_before_rows=>'<div class="dhtmlMenuLG">',
  p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;"><li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_menu_with_sublist
prompt  ......list template 2913506042507748
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li class="dhtmlMenuSep2"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep2" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t6:=t6||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#themes/theme_13/menu_open_right.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#themes/theme_13/menu_open_right.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2913506042507748 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Menu with Sublist',
  p_theme_id  => 13,
  p_theme_class_id => 20,
  p_list_template_before_rows=>'<ul class="dhtmlMenuLG2">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/page_tab_navigation
prompt  ......list template 2913812587507748
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="OnL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OnC"><a href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td class="OnR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOnR.png" alt="" /></td>';

t2:=t2||'<td class="OffL"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffL.png" alt="" /></td>'||unistr('\000a')||
'<td class="OffC"><a href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td class="OffR"><img src="#IMAGE_PREFIX#themes/theme_13/tabOffR.png" alt="" /></td>'||unistr('\000a')||
'';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2913812587507748 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Page Tab Navigation',
  p_theme_id  => 13,
  p_theme_class_id => 0,
  p_list_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t13PageTabs">'||unistr('\000a')||
'<tbody>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'',
  p_list_template_after_rows=>'</tr>'||unistr('\000a')||
'</tbody>'||unistr('\000a')||
'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'This is the list template to simulate tabs in the builder application');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tree_list
prompt  ......list template 2914101037507748
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2914101037507748 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tree List',
  p_theme_id  => 13,
  p_theme_class_id => 23,
  p_list_template_before_rows=>'<ul class="htmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_images_list
prompt  ......list template 2914402658507748
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t13current"><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></td></tr>';

t2:=t2||'<tr><td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2914402658507748 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Images List',
  p_theme_id  => 13,
  p_theme_class_id => 5,
  p_list_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="" class="t13VerticalImagesList">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_tree
prompt  ......list template 2914714695507748
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif"  align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2914714695507748 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Tree',
  p_theme_id  => 13,
  p_theme_class_id => 22,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" style="display:none;" class="dhtmlTree">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_ordered_list
prompt  ......list template 2915004016507748
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t13current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2915004016507748 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Ordered List',
  p_theme_id  => 13,
  p_theme_class_id => 2,
  p_list_template_before_rows=>'<ol class="t13VerticalOrderedList">',
  p_list_template_after_rows=>'</ol>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_links_list
prompt  ......list template 2915323209507750
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t13current">#TEXT#</a>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2915323209507750 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Links List',
  p_theme_id  => 13,
  p_theme_class_id => 3,
  p_list_template_before_rows=>'<div class="t13HorizontalLinksList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_links_without_bullets
prompt  ......list template 2915625977507750
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t13current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2915625977507750 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered Links without Bullets',
  p_theme_id  => 13,
  p_theme_class_id => 18,
  p_list_template_before_rows=>'<ul class="t13VerticalUnorderedLinkswithoutBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_images_with_label_list
prompt  ......list template 2915920877507750
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t13current"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/><br />#TEXT#</td>';

t2:=t2||'<td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/></a><br /><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2915920877507750 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Images with Label List',
  p_theme_id  => 13,
  p_theme_class_id => 4,
  p_list_template_before_rows=>'<table class="t13HorizontalImageswithLabelList" cellpadding="0" border="0" cellspacing="0" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tabbed_navigation_list
prompt  ......list template 2916220959507750
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td valign="bottom" class="t13SepL"><img src="#IMAGE_PREFIX#themes/theme_13/tab_list_left_cap.gif" alt="" /></td>'||unistr('\000a')||
'<td class="t13CurrentListTab"><a class="t13CurrentListTab" href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td valign="bottom" class="t13SepR"><img src="#IMAGE_PREFIX#themes/theme_13/tab_list_right_cap.gif" alt="" /></td>';

t2:=t2||'<td><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2916220959507750 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tabbed Navigation List',
  p_theme_id  => 13,
  p_theme_class_id => 7,
  p_list_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0"  summary="" width="100%" class="t13TabbedNavigationList"><tbody><tr><td class="t13LeftTabList">&nbsp;&nbsp;&nbsp;&nbsp;</td>',
  p_list_template_after_rows=>'<td class="t13EndCap" width="100%">&nbsp;</td></tr></tbody></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
prompt  ......list template 2916503643507750
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t13current"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2916503643507750 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List with Bullets',
  p_theme_id  => 13,
  p_theme_class_id => 1,
  p_list_template_before_rows=>'<ul class="t13VerticalUnorderedListwithBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/button_list
prompt  ......list template 2916818807507750
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t13Current">#TEXT#</a>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2916818807507750 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Button List',
  p_theme_id  => 13,
  p_theme_class_id => 6,
  p_list_template_before_rows=>'<div class="t13ButtonList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_sidebar_list
prompt  ......list template 2917116757507750
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a class="t13current" href="#LINK#">#TEXT#</a>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2917116757507750 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Sidebar List',
  p_theme_id  => 13,
  p_theme_class_id => 19,
  p_list_template_before_rows=>'<div class="t13VerticalSidebarList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/wizard_progress_list
prompt  ......list template 2917413574507750
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="t13WizCurrent">#TEXT#</div>';

t2:=t2||'<div class="t13WizNon">#TEXT#</div>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2917413574507750 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Wizard Progress List',
  p_theme_id  => 13,
  p_theme_class_id => 17,
  p_list_template_before_rows=>'<div class="t13WizBar">',
  p_list_template_after_rows=>'</div>',
  p_between_items=>'<div class="t13WizArrow"><img src="#IMAGE_PREFIX#arrow_down.gif" width="7" height="6" alt="Down" /></div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/button_list
prompt  ......list template 2957319932426592
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t11Button" align="right">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn1_corner_tl.gif" width="8" height="16" /></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#TEXT#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><span class="t11R"><img src="#IMAGE_PREFIX#themes/the';

t:=t||'me_11/t11btn1_corner_tr.gif" width="8" height="16" /></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>';

t2:=t2||'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ButtonAlternative1" align="right">'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td align="right" valign="top" class="t11R"><img src="#IMAGE_PREFIX#themes/theme_11/t11btn2_corner_tl.gif" width="8" height="16" /></td>'||unistr('\000a')||
'<td class="t11C"><a href="#LINK#" class="t11C">#TEXT#</a></td>'||unistr('\000a')||
'<td align="right" valign="top" class="t11L"><span class="t11R"><img src="#IMAGE_PREFI';

t2:=t2||'X#themes/theme_11/t11btn2_corner_tr.gif" width="8" height="16" /></span></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2957319932426592 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Button List',
  p_theme_id  => 103,
  p_theme_class_id => 6,
  p_list_template_before_rows=>'<table border="0" cellspacing="0" cellpadding="0" summary="" class="t11ButtonList"><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist
prompt  ......list template 2957608676426595
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t2:=t2||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t6:=t6||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2957608676426595 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML List (Image) with Sublist',
  p_theme_id  => 103,
  p_theme_class_id => 21,
  p_list_template_before_rows=>'<div class="dhtmlMenuLG">',
  p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;"><li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_menu_with_sublist
prompt  ......list template 2957919728426595
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li class="dhtmlMenuSep2"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep2" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t6:=t6||'<li class="dhtmlMenuItem1"><a href="#LINK#">#TEXT#</a><img src="#IMAGE_PREFIX#themes/theme_13/menu_small.gif" alt="Expand" onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" /></li>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>2957919728426595 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Menu with Sublist',
  p_theme_id  => 103,
  p_theme_class_id => 20,
  p_list_template_before_rows=>'<ul class="dhtmlMenuLG2">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu2" style="display:none;">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_tree
prompt  ......list template 2958208372426596
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif" align="middle"  alt="" /><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><img src="#IMAGE_PREFIX#themes/theme_13/node.gif"  align="middle" alt="" /><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" align="middle"  onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><img src="#IMAGE_PREFIX#themes/theme_13/plus.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" align="middle" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2958208372426596 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Tree',
  p_theme_id  => 103,
  p_theme_class_id => 22,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" style="display:none;" class="dhtmlTree">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_images_with_label_list
prompt  ......list template 2958510912426596
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t11current"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/><br />#TEXT#</td>';

t2:=t2||'<td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/></a><br /><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2958510912426596 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Images with Label List',
  p_theme_id  => 103,
  p_theme_class_id => 4,
  p_list_template_before_rows=>'<table class="t11HorizontalImageswithLabelList" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_links_list
prompt  ......list template 2958830462426596
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<span class="t11current">#TEXT#</span>';

t2:=t2||'<a href="#LINK#">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2958830462426596 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Links List',
  p_theme_id  => 103,
  p_theme_class_id => 3,
  p_list_template_before_rows=>'<div class="t11HorizontalLinksList">',
  p_list_template_after_rows=>'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tabbed_navigation_list
prompt  ......list template 2959112383426596
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#" class="t11current">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2959112383426596 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tabbed Navigation List',
  p_theme_id  => 103,
  p_theme_class_id => 7,
  p_list_template_before_rows=>'<ul class="t11TabbedNavigationList">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tree_list
prompt  ......list template 2959427091426596
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>2959427091426596 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tree List',
  p_theme_id  => 103,
  p_theme_class_id => 23,
  p_list_template_before_rows=>'<ul class="htmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_images_list
prompt  ......list template 2959716648426596
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td class="t11current"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</td></tr>';

t2:=t2||'<tr><td><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2959716648426596 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Images List',
  p_theme_id  => 103,
  p_theme_class_id => 5,
  p_list_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="" class="t11VerticalImagesList">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_ordered_list
prompt  ......list template 2960025374426598
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t11current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2960025374426598 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Ordered List',
  p_theme_id  => 103,
  p_theme_class_id => 2,
  p_list_template_before_rows=>'<ol class="t11VerticalOrderedList">',
  p_list_template_after_rows=>'</ol>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_sidebar_list
prompt  ......list template 2960323654426598
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td align="right" valign="middle" class="t11current">#TEXT#</td></tr>';

t2:=t2||'<tr><td align="right" valign="middle"><a href="#LINK#" class="t11nav">#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2960323654426598 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Sidebar List',
  p_theme_id  => 103,
  p_theme_class_id => 19,
  p_list_template_before_rows=>'<table border="0" cellspacing="0" cellpadding="0" summary="" width="100%" class="t11VerticalSidebarList">',
  p_list_template_after_rows=>'<tr><td><img src="#IMAGE_PREFIX#themes/theme_11/1px_trans.gif" height="1" width="100" alt="" style="display:block;" /></td></tr>'||unistr('\000a')||
'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_links_without_bullets
prompt  ......list template 2960627894426598
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t11current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2960627894426598 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered Links without Bullets',
  p_theme_id  => 103,
  p_theme_class_id => 18,
  p_list_template_before_rows=>'<ul class="t11VerticalUnorderedListwithoutBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
prompt  ......list template 2960927459426598
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="t11current">#TEXT#</li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2960927459426598 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List with Bullets',
  p_theme_id  => 103,
  p_theme_class_id => 1,
  p_list_template_before_rows=>'<ul class="t11VerticalUnorderedListwithBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/wizard_progress_list
prompt  ......list template 2961221990426598
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td><div class="t11current">#TEXT#</div><img src="#IMAGE_PREFIX#themes/theme_11/t11arrowdown01.gif" alt="Down" /></td></tr>';

t2:=t2||'<tr><td><div>#TEXT#</div><img src="#IMAGE_PREFIX#themes/theme_11/t11arrowdown01.gif" alt="Down" /></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>2961221990426598 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Wizard Progress List',
  p_theme_id  => 103,
  p_theme_class_id => 17,
  p_list_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="" class="t11WizardProgressList">',
  p_list_template_after_rows=>'<tr><td>&DONE.</td></tr>'||unistr('\000a')||
'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tabbed_navigation_list
prompt  ......list template 7162631967739456
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td><img src="#IMAGE_PREFIX#themes/theme_12/ListTabCurrentLeft.gif" alt="" /></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/ListTabCurrentBackground.gif); background-repeat:repeat;"><a class="t12current" href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/ListTabCurrentRight.gif" alt="" /></td>';

t2:=t2||'<td><img src="#IMAGE_PREFIX#themes/theme_12/ListTabNonCurrentLeft.gif" alt="" /></td>'||unistr('\000a')||
'<td style="background-image: url(#IMAGE_PREFIX#themes/theme_12/ListTabNonCurrentBackground.gif); background-repeat:repeat;"><a class="t12noncurrent" href="#LINK#">#TEXT#</a></td>'||unistr('\000a')||
'<td><img src="#IMAGE_PREFIX#themes/theme_12/ListTabNonCurrentRight.gif" alt="" /></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7162631967739456 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tabbed Navigation List',
  p_theme_id  => 12,
  p_theme_class_id => 7,
  p_list_template_before_rows=>'<table class="t12TabbedNavigationList" cellspacing="0" cellpadding="0" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_ordered_list
prompt  ......list template 7162721612739460
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a class="t12current" href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7162721612739460 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Ordered List',
  p_theme_id  => 12,
  p_theme_class_id => 2,
  p_list_template_before_rows=>'<ol class="t12VerticalOrderedList">',
  p_list_template_after_rows=>'</ol>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_links_list
prompt  ......list template 7162821600739460
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t12current"><a href="#LINK#" class="t12current">#TEXT#</a></td>';

t2:=t2||'<td class="t12noncurrent"><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7162821600739460 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Links List',
  p_theme_id  => 12,
  p_theme_class_id => 3,
  p_list_template_before_rows=>'<table class="t12HorizontalLinksList" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/button_list
prompt  ......list template 7162904997739460
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<a href="#LINK#" class="t12Button">#TEXT#</a>';

t2:=t2||'<a href="#LINK#" class="t12Button">#TEXT#</a>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7162904997739460 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Button List',
  p_theme_id  => 12,
  p_theme_class_id => 6,
  p_list_template_before_rows=>'<div class="t12ButtonList">',
  p_list_template_after_rows=>'</div><br />',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/horizontal_images_with_label_list
prompt  ......list template 7163023114739460
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<td class="t12current"><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/></a><br /><a href="#LINK#">#TEXT#</a></td>';

t2:=t2||'<td class="t12noncurrent"><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" border="0" #IMAGE_ATTR#/></a><br /><a href="#LINK#">#TEXT#</a></td>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7163023114739460 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Horizontal Images with Label List',
  p_theme_id  => 12,
  p_theme_class_id => 4,
  p_list_template_before_rows=>'<table class="t12HorozontalImagesWithLabelList" summary=""><tr>',
  p_list_template_after_rows=>'</tr></table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_images_list
prompt  ......list template 7163130391739460
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td align="center" class="t12current"><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a></td></tr>';

t2:=t2||'<tr><td align="center"><a href="#LINK#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7163130391739460 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Images List',
  p_theme_id  => 12,
  p_theme_class_id => 5,
  p_list_template_before_rows=>'<table class="t12VerticalImagesList" summary="">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/wizard_progress_list
prompt  ......list template 7163213784739460
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<img src="#IMAGE_PREFIX#themes/theme_12/WizardDownArrow.gif" width="7" height="12" alt="Down" /><br />'||unistr('\000a')||
'<div class="current">#TEXT#</div>';

t2:=t2||'<img src="#IMAGE_PREFIX#themes/theme_12/WizardDownArrow.gif" width="7" height="12" alt="Down" /><br />'||unistr('\000a')||
'<div class="noncurrent">#TEXT#</div>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7163213784739460 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Wizard Progress List',
  p_theme_id  => 12,
  p_theme_class_id => 17,
  p_list_template_before_rows=>'<div class="t12WizardProgressList">'||unistr('\000a')||
'<div class="noncurrent">Start</div>',
  p_list_template_after_rows=>'<div>&DONE.</div>'||unistr('\000a')||
'</div>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_without_bullets
prompt  ......list template 7163300783739462
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td><a class="t12current" href="#LINK#">#TEXT#</a></td></tr>';

t2:=t2||'<tr><td><a href="#LINK#">#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7163300783739462 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List without Bullets',
  p_theme_id  => 12,
  p_theme_class_id => 18,
  p_list_template_before_rows=>'<table class="t12VerticalUnorderedListWithoutBullets" summary="">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_sidebar_list
prompt  ......list template 7163420978739462
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<tr><td><a class="t12current" href="#LINK#">#TEXT#</a></td></tr>';

t2:=t2||'<tr><td><a href="#LINK#">#TEXT#</a></td></tr>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7163420978739462 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Sidebar List',
  p_theme_id  => 12,
  p_theme_class_id => 19,
  p_list_template_before_rows=>'<table class="t12VerticalSidebarList" cellpadding="0" cellspacing="0" width="100%" summary="">',
  p_list_template_after_rows=>'</table>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
prompt  ......list template 7163510605739462
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a class="t12current" href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3 := null;
t4 := null;
t5 := null;
t6 := null;
t7 := null;
t8 := null;
wwv_flow_api.create_list_template (
  p_id=>7163510605739462 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Vertical Unordered List with Bullets',
  p_theme_id  => 12,
  p_theme_class_id => 1,
  p_list_template_before_rows=>'<ul class="t12VerticalUnorderedListWithBullets">',
  p_list_template_after_rows=>'</ul>',
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist
prompt  ......list template 7163614082739462
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t2:=t2||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_nochild.gif" width="22" height="75" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t6:=t6||'<div class="dhtmlMenuItem"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/generic_list.gif" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#themes/generic_open.gif" width="22" height="75" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#LIST_ITEM_ID#'',false)" /><a href="#LINK#" class="dhtmlBottom">#TEXT#</a></div>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="htmldbMIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="htmldbMIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>7163614082739462 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML List (Image) with Sublist',
  p_theme_id  => 12,
  p_theme_class_id => 21,
  p_list_template_before_rows=>'<div class="dhtmlMenuLG">',
  p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">'||unistr('\000a')||
'<li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_menu_with_sublist
prompt  ......list template 7163724424739462
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li class="dhtmlMenuItem"><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>';

t4:=t4||'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>';

t5:=t5||'<li class="dhtmlMenuItem"><a href="#" onclick="javascript:app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)">#TEXT#</a></li>';

t6:=t6||'<li class="dhtmlMenuItem"><a href="#" onclick="javascript:app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)">#TEXT#</a></li>';

t7:=t7||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="htmldbMIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

t8:=t8||'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="htmldbMIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>';

wwv_flow_api.create_list_template (
  p_id=>7163724424739462 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Menu with Sublist',
  p_theme_id  => 12,
  p_theme_class_id => 20,
  p_list_template_before_rows=>'<ul class="dhtmlMenuLG2">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/dhtml_tree
prompt  ......list template 7163816460739467
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><img src="#IMAGE_PREFIX#themes/theme_4/rollup_plus_dgray.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><img src="#IMAGE_PREFIX#themes/theme_4/rollup_plus_dgray.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><img src="#IMAGE_PREFIX#themes/theme_4/rollup_plus_dgray.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><img src="#IMAGE_PREFIX#themes/theme_4/rollup_plus_dgray.gif" onclick="htmldb_ToggleWithImage(this,''#LIST_ITEM_ID#'')" class="pseudoButtonInactive" /><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>7163816460739467 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'DHTML Tree',
  p_theme_id  => 12,
  p_theme_class_id => 22,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" style="display:none;" class="dhtmlTree">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/list/tree_list
prompt  ......list template 7163927029739467
 
begin
 
declare
  t varchar2(32767) := null;
  t2 varchar2(32767) := null;
  t3 varchar2(32767) := null;
  t4 varchar2(32767) := null;
  t5 varchar2(32767) := null;
  t6 varchar2(32767) := null;
  t7 varchar2(32767) := null;
  t8 varchar2(32767) := null;
  l_clob clob;
  l_clob2 clob;
  l_clob3 clob;
  l_clob4 clob;
  l_clob5 clob;
  l_clob6 clob;
  l_clob7 clob;
  l_clob8 clob;
  l_length number := 1;
begin
t:=t||'<li><a href="#LINK#">#TEXT#</a></li>';

t2:=t2||'<li><a href="#LINK#">#TEXT#</a></li>';

t3:=t3||'<li><a href="#LINK#">#TEXT#</a></li>';

t4:=t4||'<li><a href="#LINK#">#TEXT#</a></li>';

t5:=t5||'<li><a href="#LINK#">#TEXT#</a></li>';

t6:=t6||'<li><a href="#LINK#">#TEXT#</a></li>';

t7:=t7||'<li><a href="#LINK#">#TEXT#</a></li>';

t8:=t8||'<li><a href="#LINK#">#TEXT#</a></li>';

wwv_flow_api.create_list_template (
  p_id=>7163927029739467 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_list_template_current=>t,
  p_list_template_noncurrent=> t2,
  p_list_template_name=>'Tree List',
  p_theme_id  => 12,
  p_theme_class_id => 23,
  p_list_template_before_rows=>'<ul class="dhtmlTree">',
  p_list_template_after_rows=>'</ul><br style="clear:both;"/><br style="clear:both;"/>',
  p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#">',
  p_after_sub_list=>'</ul>',
  p_sub_list_item_current=> t3,
  p_sub_list_item_noncurrent=> t4,
  p_item_templ_curr_w_child=> t5,
  p_item_templ_noncurr_w_child=> t6,
  p_sub_templ_curr_w_child=> t7,
  p_sub_templ_noncurr_w_child=> t8,
  p_translate_this_template => 'N',
  p_list_template_comment=>'');
end;
null;
 
end;
/

prompt  ...report templates
--
--application/shared_components/user_interface/templates/report/copy_of_product_list_custom
prompt  ......report template 2484025574997933
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr><td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>';

c2:=c2||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>';

c3:=c3||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td></tr>';

c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2484025574997933 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Copy of Product List (custom)',
  p_row_template1=> c1,
  p_row_template_condition1=> 'mod(#ROWNUM#,3)=1',
  p_row_template2=> c2,
  p_row_template_condition2=> 'mod(#ROWNUM#,3)=2',
  p_row_template3=> c3,
  p_row_template_condition3=> 'mod(#ROWNUM#,3)=0',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="t1Borderless"  border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tbody>',
  p_row_template_after_rows =>'</tbody>'||unistr('\000a')||
'<tfoot>#PAGINATION#</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<span class="t13CSV">#CSV_LINK#</span>'||unistr('\000a')||
''||unistr('\000a')||
'<script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1ReportHeader">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'NOT_CONDITIONAL',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'NOT_CONDITIONAL',
  p_pagination_template=>'#TEXT#'||unistr('\000a')||
'',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>',
  p_row_style_mouse_over=>'#CCCCCC',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 1,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '<br /><img class="psuedoButton" src="#IMAGE_PREFIX#pdf.png" onclick="pdf_Grab_XML2(''f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:FLOW_FOP_OUTPUT_#REGION_ID#'')" />');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2484025574997933 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'OMIT');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_report
prompt  ......report template 2792516201266440
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t15data" #ALIGNMENT#>#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2792516201266440 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard Report',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table class="t15standard" summary="Report">',
  p_row_template_after_rows =>'<tr>'||unistr('\000a')||
'    <td colspan="99" class="t15afterrows">'||unistr('\000a')||
'        <span class="left">#EXTERNAL_LINK##CSV_LINK#</span>'||unistr('\000a')||
'        <table style="float:right;text-align:right;" summary="pagination">#PAGINATION#</table>'||unistr('\000a')||
'    </td>'||unistr('\000a')||
'</tr></table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t15header" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_row_style_mouse_over=>'#cfe0f1',
  p_row_style_checked=>'#cfe0f1',
  p_theme_id  => 15,
  p_theme_class_id => 4,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2792516201266440 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/borderless
prompt  ......report template 2793002898266442
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t15data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2793002898266442 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Borderless',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table class="t15borderless" cellpadding="0" border="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'#PAGINATION#'||unistr('\000a')||
'</table><span class="left">#EXTERNAL_LINK##CSV_LINK#</span></td></tr></table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t15header"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_row_style_mouse_over=>'#cfe0f1',
  p_row_style_checked=>'#cfe0f1',
  p_theme_id  => 15,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '.t1reportborderless{ }'||unistr('\000a')||
'.t1reportborderless .t1reportheader{ }'||unistr('\000a')||
'.t1reportborderless .t1reportdata{ }');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2793002898266442 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/horizontal_border
prompt  ......report template 2793516213266442
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t15data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2793516213266442 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Horizontal Border',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" class="t15horizontalborder" summary="">',
  p_row_template_after_rows =>'<tr>'||unistr('\000a')||
'    <td colspan="99" class="t15afterrows">'||unistr('\000a')||
'        <span class="left">#EXTERNAL_LINK##CSV_LINK#</span>'||unistr('\000a')||
'        <table style="float:right;text-align:right;" summary="pagination"><tr><td></td></tr>#PAGINATION#</table>'||unistr('\000a')||
'    </td>'||unistr('\000a')||
'</tr></table></td></tr></table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t15header">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_row_style_mouse_over=>'#cfe0f1',
  p_row_style_checked=>'#cfe0f1',
  p_theme_id  => 15,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2793516213266442 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/value_attribute_pairs
prompt  ......report template 2794015784266443
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr><th class="t15header">#COLUMN_HEADER#</th><td class="t15data">#COLUMN_VALUE#</td></tr>'||unistr('\000a')||
'';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2794015784266443 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Value Attribute Pairs',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t15ValueAttributePairs">',
  p_row_template_after_rows =>'</table>#EXTERNAL_LINK#</td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_theme_id  => 15,
  p_theme_class_id => 6,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2794015784266443 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'<tr><td colspan="2" class="t15seperate"><hr /></td></tr>'||unistr('\000a')||
'');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_report_with_alt_row_colors
prompt  ......report template 2794506321266443
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t15data"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c2:=c2||'<td class="t15dataalt"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c3:=c3||'<td bgcolor="red" class="alt"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2794506321266443 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard Report (with alt row colors)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table class="t15standardalternatingrowcolors" cellpadding="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'<tr>'||unistr('\000a')||
'    <td colspan="99" class="t15afterrows">'||unistr('\000a')||
'        <span class="left">#EXTERNAL_LINK##CSV_LINK#</span>'||unistr('\000a')||
'        <table style="float:right;text-align:right;" summary="pagination">#PAGINATION#</table>'||unistr('\000a')||
'    </td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t15header" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'EVEN_ROW_NUMBERS',
  p_row_template_display_cond2=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'EVEN_ROW_NUMBERS',
  p_row_style_mouse_over=>'#cfe0f1',
  p_row_style_checked=>'#cfe0f1',
  p_theme_id  => 15,
  p_theme_class_id => 5,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2794506321266443 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/one_column_unordered_list
prompt  ......report template 2795019512266443
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<li>#COLUMN_VALUE#</li>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2795019512266443 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'One Column Unordered List',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><ul class="t1OneColumnUnorderedList">',
  p_row_template_after_rows =>'</ul>#EXTERNAL_LINK##CSV_LINK#</td></tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'NOT_CONDITIONAL',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'NOT_CONDITIONAL',
  p_theme_id  => 15,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2795019512266443 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'OMIT');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_report_ppr
prompt  ......report template 2795527713266445
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t15data" #ALIGNMENT#>#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2795527713266445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard Report (PPR)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table summary="" border="0" cellpadding="0" border="0"><tr><td colspan="2"><table class="t15standard" summary="" border="0" cellpadding="0" border="0">',
  p_row_template_after_rows =>'</tr></table></td></tr>'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'	<td valign="top">#EXTERNAL_LINK##CSV_LINK#</td>'||unistr('\000a')||
'	<td valign="top" align="right"><table summary="" align="right">#PAGINATION#</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
''||unistr('\000a')||
'<script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t15header" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="/i/jtfunexe.gif" alt="" /></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="/i/jtfupree.gif" alt=""/></a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="/i/jtfunexe.gif" alt="" /></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="/i/jtfupree.gif" alt=""/></a>',
  p_row_style_mouse_over=>'#cfe0f1',
  p_row_style_checked=>'#cfe0f1',
  p_theme_id  => 15,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2795527713266445 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_alternating_row_colors
prompt  ......report template 2813507049273790
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t8data" #ALIGNMENT#>#COLUMN_VALUE#</td>';

c2:=c2||'<td class="t8dataalt" #ALIGNMENT#>#COLUMN_VALUE#</td>';

c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2813507049273790 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard, Alternating Row Colors',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table border="0" cellpadding="0" cellspacing="0" summary="" class="t8standardalternatingrowcolors">',
  p_row_template_after_rows =>'</table><div class="t8CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t8ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'ODD_ROW_NUMBERS',
  p_next_page_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 8,
  p_theme_class_id => 5,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2813507049273790 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard
prompt  ......report template 2814000656273790
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t8data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2814000656273790 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t8standard">',
  p_row_template_after_rows =>'</table><div class="t8CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t8ReportHeader">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#EEEEEE',
  p_theme_id  => 8,
  p_theme_class_id => 4,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2814000656273790 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/value_attribute_pairs
prompt  ......report template 2814528140273790
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr><th class="t8ReportHeader">#COLUMN_HEADER#</th><td class="t8data">#COLUMN_VALUE#</td></tr>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2814528140273790 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Value Attribute Pairs',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t8ValueAttributePairs">',
  p_row_template_after_rows =>'</table><div class="t8CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 8,
  p_theme_class_id => 6,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2814528140273790 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'<tr><td colspan="2" class="t8seperate"><hr /></td></tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/bottom_border_only
prompt  ......report template 2815018916273792
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t8data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2815018916273792 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Bottom Border Only',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" class="t8HorizontalBorder" summary="">',
  p_row_template_after_rows =>'</table><div class="t8CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t8ReportHeader">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 8,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2815018916273792 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/borderless
prompt  ......report template 2815507189273792
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t8data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2815507189273792 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Borderless',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table class="t8borderless" cellpadding="0" border="0" cellspacing="0" summary="0">',
  p_row_template_after_rows =>'</table><div class="t8CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t8ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 8,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2815507189273792 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/one_column_unordered_list
prompt  ......report template 2816007971273792
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<li class="t8OneColumnUnorderedList">#COLUMN_VALUE#</li>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2816007971273792 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'One Column Unordered List',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" cellspacing="0" summary="" border="0">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><ul class="t8OneColumnUnorderedList">',
  p_row_template_after_rows =>'</ul><div class="t8CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'NOT_CONDITIONAL',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'NOT_CONDITIONAL',
  p_next_page_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t8pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 8,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2816007971273792 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'OMIT');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_ppr
prompt  ......report template 2816502095273792
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t8data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2816502095273792 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard (PPR)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t8standard">',
  p_row_template_after_rows =>'</table><div class="t8CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table><script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t8ReportHeader">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t8pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t8pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_8/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t8pagination"><img src="#IMAGE_PREFIX#themes/theme_8/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#EEEEEE',
  p_theme_id  => 8,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2816502095273792 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/borderless
prompt  ......report template 2833806384468454
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t11data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2833806384468454 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Borderless',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table class="t11Borderless" cellpadding="0" border="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>'||unistr('\000a')||
'',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 11,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2833806384468454 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_alternating_row_colors
prompt  ......report template 2834319639468456
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t11data">#COLUMN_VALUE#</td>';

c2:=c2||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t11dataalt">#COLUMN_VALUE#</td>';

c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2834319639468456 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard, Alternating Row Colors',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table border="0" cellpadding="0" cellspacing="0" summary="" class="t11StandardAlternatingRowColors">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'ODD_ROW_NUMBERS',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 11,
  p_theme_class_id => 5,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2834319639468456 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/horizontal_border
prompt  ......report template 2834827400468456
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t11data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2834827400468456 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Horizontal Border',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table class="t11HorizontalBorder" border="0" cellpadding="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"  id="#COLUMN_HEADER_NAME#" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next" /></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next" /></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 11,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2834827400468456 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/value_attribute_pairs
prompt  ......report template 2835313599468456
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr>'||unistr('\000a')||
'<th class="t11ReportHeader">#COLUMN_HEADER#</th>'||unistr('\000a')||
'<td class="t11data">#COLUMN_VALUE#</td>'||unistr('\000a')||
'</tr>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2835313599468456 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Value Attribute Pairs',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ValueAttributePairs">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'OMIT',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 11,
  p_theme_class_id => 6,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2835313599468456 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'<tr><td colspan="2" class="t11seperate"><hr /></td></tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard
prompt  ......report template 2835805231468456
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER#" class="t11data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2835805231468456 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t11Standard">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 11,
  p_theme_class_id => 4,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2835805231468456 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/one_column_unordered_list
prompt  ......report template 2836322405468457
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<li>#COLUMN_VALUE#</li>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2836322405468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'One Column Unordered List',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#<tr><td><ul class="t11OneColumnUnorderedList">',
  p_row_template_after_rows =>'</ul><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'OMIT',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next" /></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next" /></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 11,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2836322405468457 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'OMIT');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_ppr
prompt  ......report template 2836831611468457
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER#" class="t11data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2836831611468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard (PPR)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t11Standard">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table><script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 11,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2836831611468457 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard
prompt  ......report template 2854417829474920
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER#" class="t17data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2854417829474920 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t17Standard">',
  p_row_template_after_rows =>'</table><div class="t17CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t17ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t17pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t17pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 17,
  p_theme_class_id => 4,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2854417829474920 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_ppr
prompt  ......report template 2854918555474920
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER#" class="t17data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2854918555474920 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard (PPR)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t17Standard">',
  p_row_template_after_rows =>'</table><div class="t17CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table><script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t17ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t17pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t17pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t17pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t17pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 17,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2854918555474920 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/one_column_unordered_list
prompt  ......report template 2855413079474920
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'#COLUMN_VALUE#';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2855413079474920 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'One Column Unordered List',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#<tr><td><ul class="t17OneColumnUnorderedList">',
  p_row_template_after_rows =>'</ul><div class="t17CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t17pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t17pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 17,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2855413079474920 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<li>',
  p_row_template_after_last =>'</li>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/horizontal_border
prompt  ......report template 2855903065474921
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t17data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2855903065474921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Horizontal Border',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table class="t17HorizontalBorder" border="0" cellpadding="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'</table><div class="t17CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t17ReportHeader"  id="#COLUMN_HEADER_NAME#" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t17pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t17pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 17,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2855903065474921 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/value_attribute_pairs
prompt  ......report template 2856404222474921
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr>'||unistr('\000a')||
'<th class="t17ReportHeader">#COLUMN_HEADER#</th>'||unistr('\000a')||
'<td class="t17data">#COLUMN_VALUE#</td>'||unistr('\000a')||
'</tr>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2856404222474921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Value Attribute Pairs',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t17ValueAttributePairs">',
  p_row_template_after_rows =>'</table><div class="t17CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t17pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t17pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 17,
  p_theme_class_id => 6,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2856404222474921 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'',
  p_row_template_after_last =>'<tr><td colspan="2" class="t17seperate"><hr /></td></tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/borderless
prompt  ......report template 2856932637474921
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t17data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2856932637474921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Borderless',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table class="t17Borderless" cellpadding="0" border="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'</table><div class="t17CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>'||unistr('\000a')||
'',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t17ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t17pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t17pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 17,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2856932637474921 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_alternating_row_colors
prompt  ......report template 2857414866474921
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t17data">#COLUMN_VALUE#</td>';

c2:=c2||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t17dataalt">#COLUMN_VALUE#</td>';

c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2857414866474921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard, Alternating Row Colors',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table border="0" cellpadding="0" cellspacing="0" summary="" class="t17StandardAlternatingRowColors">',
  p_row_template_after_rows =>'</table><div class="t17CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t17ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'ODD_ROW_NUMBERS',
  p_next_page_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t17pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t17pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t17pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 17,
  p_theme_class_id => 5,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2857414866474921 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_alternating_row_colors
prompt  ......report template 2875104723481243
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t16data">#COLUMN_VALUE#</td>';

c2:=c2||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t16dataalt">#COLUMN_VALUE#</td>';

c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2875104723481243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard, Alternating Row Colors',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table border="0" cellpadding="0" cellspacing="0" summary="" class="t16StandardAlternatingRowColors" width="100%">',
  p_row_template_after_rows =>'</table><div class="t16CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t16ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'ODD_ROW_NUMBERS',
  p_next_page_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t16pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t16pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 16,
  p_theme_class_id => 5,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2875104723481243 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_ppr
prompt  ......report template 2875610447481243
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER#" class="t16data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2875610447481243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard (PPR)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t16Standard" width="100%">',
  p_row_template_after_rows =>'</table><div class="t16CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table><script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t16ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t16pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t16pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t16pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t16pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 16,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2875610447481243 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/borderless
prompt  ......report template 2876100207481243
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t16data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2876100207481243 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Borderless',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table class="t16Borderless" cellpadding="0" border="0" cellspacing="1" summary="" width="100%">',
  p_row_template_after_rows =>'</table><div class="t16CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>'||unistr('\000a')||
'',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t16ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t16pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t16pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 16,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2876100207481243 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/value_attribute_pairs
prompt  ......report template 2876600418481245
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr>'||unistr('\000a')||
'<th class="t16ReportHeader">#COLUMN_HEADER#</th>'||unistr('\000a')||
'<td class="t16data">#COLUMN_VALUE#</td>'||unistr('\000a')||
'</tr>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2876600418481245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Value Attribute Pairs',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t16ValueAttributePairs">',
  p_row_template_after_rows =>'</table><div class="t16CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t16pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t16pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 16,
  p_theme_class_id => 6,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2876600418481245 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'',
  p_row_template_after_last =>'<tr><td colspan="2" class="t16seperate"><hr /></td></tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/horizontal_border
prompt  ......report template 2877117360481245
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t16data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2877117360481245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Horizontal Border',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table class="t16HorizontalBorder" border="0" cellpadding="0" cellspacing="0" summary="" width="100%">',
  p_row_template_after_rows =>'</table><div class="t16CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t16ReportHeader"  id="#COLUMN_HEADER_NAME#" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t16pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t16pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 16,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2877117360481245 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/one_column_unordered_list
prompt  ......report template 2877611298481245
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'#COLUMN_VALUE#';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2877611298481245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'One Column Unordered List',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#<tr><td><ul class="t16OneColumnUnorderedList">',
  p_row_template_after_rows =>'</ul><div class="t16CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t16pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t16pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 16,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2877611298481245 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<li>',
  p_row_template_after_last =>'</li>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard
prompt  ......report template 2878118297481245
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER#" class="t16data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2878118297481245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t16Standard" width="100%">',
  p_row_template_after_rows =>'</table><div class="t16CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t16ReportHeader" #ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t16pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t16pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t16pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 16,
  p_theme_class_id => 4,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2878118297481245 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_alternating_row_colors
prompt  ......report template 2896428236489443
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t1data"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c2:=c2||'<td class="t1dataalt"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2896428236489443 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard, Alternating Row Colors',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table border="0" cellpadding="0" cellspacing="0" summary="" class="t1standardalternatingrowcolors">',
  p_row_template_after_rows =>'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t1header"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'ODD_ROW_NUMBERS',
  p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'||unistr('\000a')||
'',
  p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 1,
  p_theme_class_id => 5,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_ppr
prompt  ......report template 2896703535489445
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2896703535489445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard (PPR)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">',
  p_row_template_after_rows =>'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')"  class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')"  class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')"  class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')"  class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 1,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2896703535489445 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/horizontal_border
prompt  ......report template 2897206339489445
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2897206339489445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Horizontal Border',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" class="t1HorizontalBorder" summary="">',
  p_row_template_after_rows =>'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'||unistr('\000a')||
'',
  p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 1,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2897206339489445 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/value_attribute_pairs
prompt  ......report template 2897704774489445
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr><th class="t1header">#COLUMN_HEADER#</th><td class="t1data">#COLUMN_VALUE#</td></tr>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2897704774489445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Value Attribute Pairs',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ValueAttributePairs">',
  p_row_template_after_rows =>'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 1,
  p_theme_class_id => 6,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2897704774489445 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'<tr><td colspan="2" class="t1seperate"><hr /></td></tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/borderless
prompt  ......report template 2898227179489445
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2898227179489445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Borderless',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table class="t1borderless" cellpadding="0" border="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t1header"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 1,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2898227179489445 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/one_column_unordered_list
prompt  ......report template 2898727735489446
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<li>#COLUMN_VALUE#</li>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2898727735489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'One Column Unordered List',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><ul class="t1OneColumnUnorderedList">',
  p_row_template_after_rows =>'</ul><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'NOT_CONDITIONAL',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'NOT_CONDITIONAL',
  p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 1,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2898727735489446 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'OMIT');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard
prompt  ......report template 2899210279489446
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2899210279489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">',
  p_row_template_after_rows =>'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 1,
  p_theme_class_id => 4,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2899210279489446 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_ppr
prompt  ......report template 2917723674507751
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t13data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2917723674507751 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard (PPR)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="t13Standard"  border="0" summary="" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">'||unistr('\000a')||
'<tbody>',
  p_row_template_after_rows =>'</tbody>'||unistr('\000a')||
'<tfoot>#PAGINATION#</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<span class="t13CSV">#CSV_LINK#</span>'||unistr('\000a')||
''||unistr('\000a')||
'<script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t13ReportHeader">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_pagination_template=>'#TEXT#'||unistr('\000a')||
'',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>',
  p_row_style_mouse_over=>'#CCCCCC',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 13,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '<br /><img class="psuedoButton" src="#IMAGE_PREFIX#pdf.png" onclick="pdf_Grab_XML2(''f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:FLOW_FOP_OUTPUT_#REGION_ID#'')" />');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2917723674507751 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/value_attribute_pairs
prompt  ......report template 2918204838507751
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr>'||unistr('\000a')||
'<th class="t13ReportHeader">#COLUMN_HEADER#</th>'||unistr('\000a')||
'<td class="t13data">#COLUMN_VALUE#</td>'||unistr('\000a')||
'</tr>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2918204838507751 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Value Attribute Pairs',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t13ValueAttributePairs">',
  p_row_template_after_rows =>'</table><div class="t13CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t13pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t13pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t13pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t13pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 13,
  p_theme_class_id => 6,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2918204838507751 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'',
  p_row_template_after_last =>'<tr><td colspan="2" class="t13seperate"><hr /></td></tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard
prompt  ......report template 2918720490507751
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t13data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2918720490507751 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="t13Standard"  border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tbody>',
  p_row_template_after_rows =>'</tbody>'||unistr('\000a')||
'<tfoot>#PAGINATION#</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<span class="t13CSV">#CSV_LINK#</span>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t13ReportHeader">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_pagination_template=>'#TEXT#'||unistr('\000a')||
'',
  p_row_style_mouse_over=>'#CCCCCC',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 13,
  p_theme_class_id => 4,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2918720490507751 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/horizontal_border
prompt  ......report template 2919210729507753
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t13data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2919210729507753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Horizontal Border',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="t13HorizontalBorder"  border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tbody>',
  p_row_template_after_rows =>'</tbody>'||unistr('\000a')||
'<tfoot>#PAGINATION#</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<span class="t13CSV">#CSV_LINK#</span>'||unistr('\000a')||
''||unistr('\000a')||
'<script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t13ReportHeader">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_pagination_template=>'#TEXT#'||unistr('\000a')||
'',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>',
  p_row_style_mouse_over=>'#CCCCCC',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 13,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_row_template_comment=> '<br /><img class="psuedoButton" src="#IMAGE_PREFIX#pdf.png" onclick="pdf_Grab_XML2(''f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:FLOW_FOP_OUTPUT_#REGION_ID#'')" />');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2919210729507753 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/borderless
prompt  ......report template 2919700079507753
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t13data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2919700079507753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Borderless',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="t13Borderless"  border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tbody>',
  p_row_template_after_rows =>'</tbody>'||unistr('\000a')||
'<tfoot>#PAGINATION#</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<span class="t13CSV">#CSV_LINK#</span>'||unistr('\000a')||
''||unistr('\000a')||
'<script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t13ReportHeader">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_pagination_template=>'#TEXT#'||unistr('\000a')||
'',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>',
  p_row_style_mouse_over=>'#CCCCCC',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 13,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '<br /><img class="psuedoButton" src="#IMAGE_PREFIX#pdf.png" onclick="pdf_Grab_XML2(''f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:FLOW_FOP_OUTPUT_#REGION_ID#'')" />');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2919700079507753 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_alternating_row_colors
prompt  ......report template 2920215564507753
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t13data">#COLUMN_VALUE#</td>';

c2:=c2||'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t13dataalt">#COLUMN_VALUE#</td>';

c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2920215564507753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard, Alternating Row Colors',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="t13Standard"  border="0" summary="" id="#REGION_ID#">'||unistr('\000a')||
'<tbody>',
  p_row_template_after_rows =>'</tbody>'||unistr('\000a')||
'<tfoot>#PAGINATION#</tfoot>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'<span class="t13CSV">#CSV_LINK#</span>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t13ReportHeader">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'EVEN_ROW_NUMBERS',
  p_row_template_display_cond2=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'EVEN_ROW_NUMBERS',
  p_pagination_template=>'#TEXT#'||unistr('\000a')||
'',
  p_row_style_mouse_over=>'#CCCCCC',
  p_row_style_checked=>'#CCCCCC',
  p_theme_id  => 13,
  p_theme_class_id => 5,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2920215564507753 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/one_column_unordered_list
prompt  ......report template 2920715780507753
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'#COLUMN_VALUE#';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2920715780507753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'One Column Unordered List',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#<tr><td><ul class="t13OneColumnUnorderedList">',
  p_row_template_after_rows =>'</ul><div class="t13CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t13pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t13pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t13pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t13pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 13,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2920715780507753 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<li>',
  p_row_template_after_last =>'</li>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/borderless
prompt  ......report template 2955223545426585
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t11data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2955223545426585 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Borderless',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table class="t11Borderless" cellpadding="0" border="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>'||unistr('\000a')||
'',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 103,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2955223545426585 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_alternating_row_colors
prompt  ......report template 2955529052426589
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t11data">#COLUMN_VALUE#</td>';

c2:=c2||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t11dataalt">#COLUMN_VALUE#</td>';

c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2955529052426589 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard, Alternating Row Colors',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table border="0" cellpadding="0" cellspacing="0" summary="" class="t11StandardAlternatingRowColors">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'ODD_ROW_NUMBERS',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 103,
  p_theme_class_id => 5,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2955529052426589 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/horizontal_border
prompt  ......report template 2955809934426590
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td headers="#COLUMN_HEADER_NAME#" #ALIGNMENT# class="t11data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2955809934426590 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Horizontal Border',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table class="t11HorizontalBorder" border="0" cellpadding="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"  id="#COLUMN_HEADER_NAME#" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next" /></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next" /></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 103,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2955809934426590 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/value_attribute_pairs
prompt  ......report template 2956107029426590
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr>'||unistr('\000a')||
'<th class="t11ReportHeader">#COLUMN_HEADER#</th>'||unistr('\000a')||
'<td class="t11data">#COLUMN_VALUE#</td>'||unistr('\000a')||
'</tr>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2956107029426590 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Value Attribute Pairs',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t11ValueAttributePairs">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'OMIT',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 103,
  p_theme_class_id => 6,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2956107029426590 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'<tr><td colspan="2" class="t11seperate"><hr /></td></tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard
prompt  ......report template 2956414792426590
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER#" class="t11data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2956414792426590 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t11Standard">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 103,
  p_theme_class_id => 4,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2956414792426590 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/one_column_unordered_list
prompt  ......report template 2956714579426590
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<li>#COLUMN_VALUE#</li>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2956714579426590 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'One Column Unordered List',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table border="0" cellpadding="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#<tr><td><ul class="t11OneColumnUnorderedList">',
  p_row_template_after_rows =>'</ul><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'OMIT',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next" /></a>',
  p_previous_page_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next" /></a>',
  p_previous_set_template=>'<a href="#LINK#" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_theme_id  => 103,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2956714579426590 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'OMIT');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_ppr
prompt  ......report template 2957005080426590
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td #ALIGNMENT# headers="#COLUMN_HEADER#" class="t11data">#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 2957005080426590 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard (PPR)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t11Standard">',
  p_row_template_after_rows =>'</table><div class="t11CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table><script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t11ReportHeader"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t11pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t11pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_11/paginate_next.gif" alt="Next"></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" class="t11pagination"><img src="#IMAGE_PREFIX#themes/theme_11/paginate_prev.gif" alt="Previous" />#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_checked=>'#c5d5c5',
  p_theme_id  => 103,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 2957005080426590 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/zeilenformat
prompt  ......report template 3037516400273420
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr>'||unistr('\000a')||
'<td class="t13data">#COLUMN_VALUE#</td>'||unistr('\000a')||
'</tr>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 3037516400273420 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Zeilenformat',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" cellspacing="0" border="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" cellspacing="0" border="0" summary="" class="t13Zeilenformat">',
  p_row_template_after_rows =>'</table><div class="t13CVS">#EXTERNAL_LINK##CSV_LINK#</div></td></tr>#PAGINATION#</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_next_page_template=>'<a href="#LINK#" class="t13pagination">#PAGINATION_NEXT# &gt;</a>',
  p_previous_page_template=>'<a href="#LINK#" class="t13pagination">&lt;#PAGINATION_PREVIOUS#</a>',
  p_next_set_template=>'<a href="#LINK#" class="t13pagination">#PAGINATION_NEXT_SET#&gt;&gt;</a>',
  p_previous_set_template=>'<a href="#LINK#" class="t13pagination">&lt;&lt;#PAGINATION_PREVIOUS_SET#</a>',
  p_row_style_mouse_over=>'#6CAAD0',
  p_row_style_checked=>'#FF0000',
  p_theme_id  => 13,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 3037516400273420 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'',
  p_row_template_after_last =>'<tr><td colspan="1" class="t13seperate"><hr /></td></tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/horizontal_border
prompt  ......report template 7164024460739468
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t12data" #ALIGNMENT#>#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 7164024460739468 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Horizontal Border',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div class="t12contentcollapse"><table cellpadding="0" border="0" cellspacing="0" summary="" width="100%">#TOP_PAGINATION#</table><table class="t12bottomborderonly" border="0" cellpadding="0" cellspacing="0" summary="">',
  p_row_template_after_rows =>'#PAGINATION#'||unistr('\000a')||
'<tr><td class="t12bottom" colspan="99">#EXTERNAL_LINK##CSV_LINK#</td></tr>'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t12header"  id="#COLUMN_HEADER_NAME#" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_pagination_template=>'<span class="t12Pagination">#TEXT#</span>',
  p_next_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextPage.gif"></a>',
  p_previous_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousPage.gif"></a>',
  p_next_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextSet.gif"></a>',
  p_previous_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousSet.gif"></a>',
  p_row_style_checked=>'#6CAAD9',
  p_theme_id  => 12,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 7164024460739468 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/value_attribute_pairs
prompt  ......report template 7164126436739470
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<tr><th class="t12header">#COLUMN_HEADER#</th><td class="t12data">#COLUMN_VALUE#</td></tr>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 7164126436739470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Value Attribute Pairs',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t12valueattributepairs">',
  p_row_template_after_rows =>'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'<tr><td class="t12bottom" colspan="99">#EXTERNAL_LINK##CSV_LINK#</td></tr>'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_pagination_template=>'<span class="t12Pagination">#TEXT#</span>',
  p_next_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextPage.gif"></a>',
  p_previous_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousPage.gif"></a>',
  p_next_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextSet.gif"></a>',
  p_previous_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousSet.gif"></a>',
  p_theme_id  => 12,
  p_theme_class_id => 6,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 7164126436739470 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'OMIT',
  p_row_template_after_last =>'<tr><td colspan="2">&nbsp;</td></tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_alternating_row_colors
prompt  ......report template 7164205071739470
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t12data"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c2:=c2||'<td class="t12dataalt"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 7164205071739470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard, Alternating Row Colors',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t12standardalternatingrowcolors">',
  p_row_template_after_rows =>'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'<tr><td class="t12bottom" colspan="99">#EXTERNAL_LINK##CSV_LINK#</td></tr>'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t12header"#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'ODD_ROW_NUMBERS',
  p_pagination_template=>'<span class="t12Pagination">#TEXT#</span>',
  p_next_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextPage.gif"></a>',
  p_previous_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousPage.gif"></a>',
  p_next_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextSet.gif"></a>',
  p_previous_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousSet.gif"></a>',
  p_row_style_checked=>'#6CAAD9',
  p_theme_id  => 12,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 7164205071739470 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/borderless
prompt  ......report template 7164322273739470
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t12data"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 7164322273739470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Borderless',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t12borderless">',
  p_row_template_after_rows =>'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'<tr><td class="t12bottom" colspan="99">#EXTERNAL_LINK##CSV_LINK#</td></tr>'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t12header" #ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_pagination_template=>'<span class="t12Pagination">#TEXT#</span>',
  p_next_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextPage.gif"></a>',
  p_previous_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousPage.gif"></a>',
  p_next_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextSet.gif"></a>',
  p_previous_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousSet.gif"></a>',
  p_row_style_checked=>'#6CAAD9',
  p_theme_id  => 12,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 7164322273739470 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard
prompt  ......report template 7164422711739470
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t12data"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 7164422711739470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t12standard">',
  p_row_template_after_rows =>'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'<tr><td class="t12bottom" colspan="99">#EXTERNAL_LINK##CSV_LINK#</td></tr>'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t12header" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_pagination_template=>'<span class="t12Pagination">#TEXT#</span>',
  p_next_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextPage.gif"></a>',
  p_previous_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousPage.gif"></a>',
  p_next_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextSet.gif"></a>',
  p_previous_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousSet.gif"></a>',
  p_row_style_checked=>'#6CAAD9',
  p_theme_id  => 12,
  p_theme_class_id => 4,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 7164422711739470 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/standard_ppr
prompt  ......report template 7164530857739470
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<td class="t12data"#ALIGNMENT#>#COLUMN_VALUE#</td>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 7164530857739470 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'Standard (PPR)',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr>'||unistr('\000a')||
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t12standard">',
  p_row_template_after_rows =>'</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'<tr><td class="t12bottom" colspan="99">#EXTERNAL_LINK##CSV_LINK#</td></tr>'||unistr('\000a')||
'</table><script language=JavaScript type=text/javascript>'||unistr('\000a')||
'<!--'||unistr('\000a')||
'init_htmlPPRReport(''#REGION_ID#'');'||unistr('\000a')||
''||unistr('\000a')||
'//-->'||unistr('\000a')||
'</script>'||unistr('\000a')||
'</htmldb:#REGION_ID#>'||unistr('\000a')||
'</div>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'<th class="t12header" #ALIGNMENT#>#COLUMN_HEADER#</th>',
  p_row_template_display_cond1=>'0',
  p_row_template_display_cond2=>'0',
  p_row_template_display_cond3=>'0',
  p_row_template_display_cond4=>'0',
  p_pagination_template=>'<span class="t12Pagination">#TEXT#</span>',
  p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')"><img src="#IMAGE_PREFIX#themes/theme_12/NextPage.gif"></a>',
  p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousPage.gif"></a>',
  p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')"><img src="#IMAGE_PREFIX#themes/theme_12/NextSet.gif"></a>',
  p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousSet.gif"></a>',
  p_row_style_checked=>'#6CAAD9',
  p_theme_id  => 12,
  p_theme_class_id => 7,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

 
begin
 
begin
wwv_flow_api.create_row_template_patch (
  p_id => 7164530857739470 + wwv_flow_api.g_id_offset,
  p_row_template_before_first =>'<tr #HIGHLIGHT_ROW#>',
  p_row_template_after_last =>'</tr>');
exception when others then null;
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/report/one_column_unordered_list
prompt  ......report template 7164612713739471
 
begin
 
declare
  c1 varchar2(32767) := null;
  c2 varchar2(32767) := null;
  c3 varchar2(32767) := null;
  c4 varchar2(32767) := null;
begin
c1:=c1||'<li>#COLUMN_VALUE#</li>';

c2 := null;
c3 := null;
c4 := null;
wwv_flow_api.create_row_template (
  p_id=> 7164612713739471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_row_template_name=> 'One Column Unordered List',
  p_row_template1=> c1,
  p_row_template_condition1=> '',
  p_row_template2=> c2,
  p_row_template_condition2=> '',
  p_row_template3=> c3,
  p_row_template_condition3=> '',
  p_row_template4=> c4,
  p_row_template_condition4=> '',
  p_row_template_before_rows=>'<table cellspacing="0" cellpadding="0" width="100%" summary="">'||unistr('\000a')||
'#TOP_PAGINATION#'||unistr('\000a')||
'<tr><td><ul class="t12OneColumnUnorderedList">',
  p_row_template_after_rows =>'</ul></td></tr>'||unistr('\000a')||
'#PAGINATION#'||unistr('\000a')||
'<tr><td class="t12bottom" colspan="99">#EXTERNAL_LINK##CSV_LINK#</td></tr>'||unistr('\000a')||
'</table>',
  p_row_template_table_attr =>'OMIT',
  p_row_template_type =>'GENERIC_COLUMNS',
  p_column_heading_template=>'',
  p_row_template_display_cond1=>'ODD_ROW_NUMBERS',
  p_row_template_display_cond2=>'NOT_CONDITIONAL',
  p_row_template_display_cond3=>'NOT_CONDITIONAL',
  p_row_template_display_cond4=>'ODD_ROW_NUMBERS',
  p_pagination_template=>'<span class="t12Pagination">#TEXT#</span>',
  p_next_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextPage.gif"></a>',
  p_previous_page_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousPage.gif"></a>',
  p_next_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/NextSet.gif"></a>',
  p_previous_set_template=>'<a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_12/PreviousSet.gif"></a>',
  p_theme_id  => 12,
  p_theme_class_id => 3,
  p_translate_this_template => 'N',
  p_row_template_comment=> '');
end;
null;
 
end;
/

prompt  ...label templates
--
--application/shared_components/user_interface/templates/label/no_label
prompt  ......label template 2796011051266445
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2796011051266445 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'No Label',
  p_template_body1=>'<span class="t15NoLabel">',
  p_template_body2=>'</span>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 15,
  p_theme_class_id => 13,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required
prompt  ......label template 2796104948266446
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2796104948266446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_15/requiredicon_status2.gif" alt="" /><span class="t15required">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 15,
  p_theme_class_id => 4,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label_with_help
prompt  ......label template 2796223897266446
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2796223897266446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_15/requiredicon_status2.gif" alt="" /><a class="t15requiredwithhelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 15,
  p_theme_class_id => 2,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional
prompt  ......label template 2796331561266446
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2796331561266446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><span class="t15Optional">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 15,
  p_theme_class_id => 3,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label_with_help
prompt  ......label template 2796412512266446
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2796412512266446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label with Help',
  p_template_body1=>'<a class="t15optionalwithhelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 15,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_with_help
prompt  ......label template 2817026921273792
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2817026921273792 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required with help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_8/required.gif" alt="" style="margin-right:5px;"/><a class="t8RequiredwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t8InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 8,
  p_theme_class_id => 2,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required
prompt  ......label template 2817114174273792
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2817114174273792 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_8/required.gif" alt="" style="margin-right:5px;" /><span class="t8Required">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t8InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 8,
  p_theme_class_id => 4,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/no_label
prompt  ......label template 2817227771273793
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2817227771273793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'No Label',
  p_template_body1=>'<span class="t8NoLabel">',
  p_template_body2=>'</span>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t8InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 8,
  p_theme_class_id => 13,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional
prompt  ......label template 2817320182273793
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2817320182273793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><span class="t8Optional">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t8InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 8,
  p_theme_class_id => 3,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_with_help
prompt  ......label template 2817414203273793
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2817414203273793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional with help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><a class="t8OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t8InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 8,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label
prompt  ......label template 2837325371468457
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2837325371468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><span class="t11OptionalLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 11,
  p_theme_class_id => 3,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label_with_help
prompt  ......label template 2837417667468457
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2837417667468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_11/required.gif" alt="Required" style="margin-right:5px;"/><a class="t11RequiredLabelwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 11,
  p_theme_class_id => 2,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label_with_help
prompt  ......label template 2837513631468457
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2837513631468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><a class="t11OptionalLabelwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 11,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label
prompt  ......label template 2837602594468457
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2837602594468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_11/required.gif" alt=""  style="margin-right:5px;"/><span class="t11RequiredLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 11,
  p_theme_class_id => 4,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/no_label
prompt  ......label template 2837721487468457
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2837721487468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'No Label',
  p_template_body1=>'<span class="t11NoLabel">',
  p_template_body2=>'</span>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 11,
  p_theme_class_id => 13,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label
prompt  ......label template 2857930455474921
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2857930455474921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><span class="t17RequiredLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t17InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 17,
  p_theme_class_id => 4,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label
prompt  ......label template 2858029756474921
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2858029756474921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><span class="t17OptionalLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t17InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 17,
  p_theme_class_id => 3,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/no_label
prompt  ......label template 2858122791474921
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2858122791474921 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'No Label',
  p_template_body1=>'<span class="t17NoLabel">',
  p_template_body2=>'</span>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t17InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 17,
  p_theme_class_id => 13,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label_with_help
prompt  ......label template 2858217397474923
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2858217397474923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><a class="t17RequiredLabelwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t17InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 17,
  p_theme_class_id => 2,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label_with_help
prompt  ......label template 2858320316474923
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2858320316474923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><a class="t17OptionalLabelwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t17InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 17,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/no_label
prompt  ......label template 2878607656481245
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2878607656481245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'No Label',
  p_template_body1=>'<span class="t16NoLabel">',
  p_template_body2=>'</span>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t16InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 16,
  p_theme_class_id => 13,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label
prompt  ......label template 2878709713481245
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2878709713481245 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><span class="t16OptionalLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t16InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 16,
  p_theme_class_id => 3,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label_with_help
prompt  ......label template 2878818561481246
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2878818561481246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><a class="t16RequiredLabelwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t16InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 16,
  p_theme_class_id => 2,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label_with_help
prompt  ......label template 2878930736481246
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2878930736481246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><a class="t16OptionalLabelwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t16InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 16,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label
prompt  ......label template 2879007586481246
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2879007586481246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><span class="t16RequiredLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t16InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 16,
  p_theme_class_id => 4,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_with_help
prompt  ......label template 2899703987489446
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2899703987489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional with help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><a class="t1OptionalwithHelp"  href="javascript:void(return false);" onmouseover="AJAX_HELP(this,''#CURRENT_ITEM_ID#'')" id="#CURRENT_ITEM_ID#_label" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t1InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 1,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> 'Original-Eintrag in Definition vor Label:'||unistr('\000a')||
'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'||unistr('\000a')||
'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/no_label
prompt  ......label template 2899816394489446
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2899816394489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'No Label',
  p_template_body1=>'<span class="t1NoLabel">',
  p_template_body2=>'</span>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t1InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 1,
  p_theme_class_id => 13,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required
prompt  ......label template 2899910455489446
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2899910455489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><img src="#IMAGE_PREFIX#themes/theme_1/required.gif" alt="Required Field Icon" tabindex="999" /><span class="t1Required">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t1InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 1,
  p_theme_class_id => 4,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional
prompt  ......label template 2900025213489446
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2900025213489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><span class="t1Optional">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t1InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 1,
  p_theme_class_id => 3,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_with_help
prompt  ......label template 2900122745489446
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2900122745489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required with help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><img src="#IMAGE_PREFIX#themes/theme_1/required.gif" alt="Required Field Icon" tabindex="999" /><a class="t1RequiredwithHelp" href="javascript:void(return false);" onmouseover="AJAX_HELP(this,''#CURRENT_ITEM_ID#'')" id="#CURRENT_ITEM_ID#_label" tabindex="999">'||unistr('\000a')||
''||unistr('\000a')||
'',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t1InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 1,
  p_theme_class_id => 2,
  p_translate_this_template=> 'N',
  p_template_comment=> 'Original-Eintrag in Definition vor Label:'||unistr('\000a')||
'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><img src="#IMAGE_PREFIX#themes/theme_1/required.gif" alt="Required Field Icon" tabindex="999" /><a class="t1RequiredwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'||unistr('\000a')||
'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/no_label
prompt  ......label template 2921223710507753
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2921223710507753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'No Label',
  p_template_body1=>'<span class="t13NoLabel">',
  p_template_body2=>'</span>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t13InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 13,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label_with_help
prompt  ......label template 2921323135507753
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2921323135507753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><a class="t13OptionalLabelwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 13,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label
prompt  ......label template 2921428072507753
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2921428072507753 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><span class="t13OptionalLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 13,
  p_theme_class_id => 3,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label_with_help
prompt  ......label template 2921515415507754
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2921515415507754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><a class="t13RequiredLabelwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999"><img src="#IMAGE_PREFIX#requiredicon_status2.gif" alt="" />',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 13,
  p_theme_class_id => 2,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label
prompt  ......label template 2921632174507754
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2921632174507754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><span class="t13RequiredLabel"><img src="#IMAGE_PREFIX#requiredicon_status2.gif" alt="" />',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t13InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 13,
  p_theme_class_id => 4,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/no_label
prompt  ......label template 2961511280426598
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2961511280426598 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'No Label',
  p_template_body1=>'<span class="t11NoLabel">',
  p_template_body2=>'</span>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 103,
  p_theme_class_id => 13,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label
prompt  ......label template 2961631112426601
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2961631112426601 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><span class="t11OptionalLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 103,
  p_theme_class_id => 3,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label_with_help
prompt  ......label template 2961706517426603
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2961706517426603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" tabindex="999"><a class="t1OptionalwithHelp"  href="javascript:void(return false);" onmouseover="AJAX_HELP(this,''#CURRENT_ITEM_ID#'')" id="#CURRENT_ITEM_ID#_label" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 103,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label
prompt  ......label template 2961813827426603
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2961813827426603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_11/required.gif" alt=""  style="margin-right:5px;"/><span class="t11RequiredLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 103,
  p_theme_class_id => 4,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label_with_help
prompt  ......label template 2961925178426603
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 2961925178426603 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_11/required.gif" alt="Required" style="margin-right:5px;"/><a class="t11RequiredLabelwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'<div class="t11InlineError">',
  p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>',
  p_theme_id  => 103,
  p_theme_class_id => 2,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label
prompt  ......label template 7164729674739471
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 7164729674739471 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_12/required.gif" alt="Required Field Icon" /><span class="t12RequiredLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 12,
  p_theme_class_id => 4,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/no_label
prompt  ......label template 7164808356739475
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 7164808356739475 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'No Label',
  p_template_body1=>'<span class="t12NoLabel">',
  p_template_body2=>'</span>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 12,
  p_theme_class_id => 13,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label
prompt  ......label template 7164922282739475
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 7164922282739475 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><span class="t12OptionalLabel">',
  p_template_body2=>'</span></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 12,
  p_theme_class_id => 3,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/optional_label_with_help
prompt  ......label template 7165025252739475
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 7165025252739475 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Optional Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><a class="t12OptionalLabelWithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 12,
  p_theme_class_id => 1,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/label/required_label_with_help
prompt  ......label template 7165106605739475
 
begin
 
begin
wwv_flow_api.create_field_template (
  p_id=> 7165106605739475 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_template_name=>'Required Label with Help',
  p_template_body1=>'<label for="#CURRENT_ITEM_NAME#"><img src="#IMAGE_PREFIX#themes/theme_12/required.gif" alt="Required Field Icon" /><a class="t12RequiredLabelWithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">',
  p_template_body2=>'</a></label>',
  p_before_item=>'',
  p_after_item=>'',
  p_on_error_before_label=>'',
  p_on_error_after_label=>'',
  p_theme_id  => 12,
  p_theme_class_id => 2,
  p_translate_this_template=> 'N',
  p_template_comment=> '');
end;
null;
 
end;
/

prompt  ...breadcrumb templates
--
--application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
prompt  ......template 2796520544266446
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2796520544266446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Hierarchical Menu',
  p_before_first=>'<ul class="t15HierarchicalMenu">',
  p_current_page_option=>'<li class="t15current"><a href="#LINK#">#NAME#</a></li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'',
  p_after_last=>'</ul>',
  p_max_levels=>11,
  p_start_with_node=>'CHILD_MENU',
  p_theme_id  => 15,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/breadcrumbs
prompt  ......template 2796631194266448
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2796631194266448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Breadcrumbs',
  p_before_first=>'<ul>',
  p_current_page_option=>'<li class="t15Current"><span>#NAME#</span></li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'<li><span>></span></li>',
  p_after_last=>'</ul>',
  p_max_levels=>12,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 15,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
prompt  ......template 2817517750273793
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2817517750273793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Breadcrumb Menu',
  p_before_first=>'<div class="t8BreadcrumbMenu">',
  p_current_page_option=>'<span class="t8current">#NAME#</span>',
  p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>',
  p_menu_link_attributes=>'',
  p_between_levels=>'&nbsp;/&nbsp;',
  p_after_last=>'</div>',
  p_max_levels=>12,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 8,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
prompt  ......template 2817629872273793
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2817629872273793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Hierarchical Menu',
  p_before_first=>'<ul class="t1HierarchicalMenu">',
  p_current_page_option=>'<li class="t1current">#NAME#</li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'',
  p_after_last=>'</ul>',
  p_max_levels=>11,
  p_start_with_node=>'CHILD_MENU',
  p_theme_id  => 8,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
prompt  ......template 2837830185468457
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2837830185468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Breadcrumb Menu',
  p_before_first=>'<div class="t11BreadcrumbMenu" style="color:#91C58D">',
  p_current_page_option=>'<a href="#LINK#" class="t11current">#NAME#</a>',
  p_non_current_page_option=>'<a href="#LINK#" style="text-decoration:underline;">#NAME#</a>',
  p_menu_link_attributes=>'',
  p_between_levels=>'&nbsp;&gt;&nbsp;',
  p_after_last=>'</div>',
  p_max_levels=>12,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 11,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
prompt  ......template 2837926989468457
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2837926989468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Hierarchical Menu',
  p_before_first=>'<ul class="t4HierarchicalMenu">',
  p_current_page_option=>'<li class="t4current"><a href="#LINK#">#NAME#</a></li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'',
  p_after_last=>'</ul>',
  p_max_levels=>11,
  p_start_with_node=>'CHILD_MENU',
  p_theme_id  => 11,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
prompt  ......template 2858426845474923
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2858426845474923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Hierarchical Menu',
  p_before_first=>'<ul class="t17HierarchicalMenu">',
  p_current_page_option=>'<li class="t17current"><a href="#LINK#">#NAME#</a></li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'',
  p_after_last=>'</ul>',
  p_max_levels=>11,
  p_start_with_node=>'CHILD_MENU',
  p_theme_id  => 17,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
prompt  ......template 2858502359474923
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2858502359474923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Breadcrumb Menu',
  p_before_first=>'',
  p_current_page_option=>'<a href="#LINK#" class="t17BreadC">#NAME#</a>',
  p_non_current_page_option=>'<a href="#LINK#" class="t17Bread">#NAME#</a>',
  p_menu_link_attributes=>'',
  p_between_levels=>'<b>&gt;</b>',
  p_after_last=>'',
  p_max_levels=>12,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 17,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
prompt  ......template 2879130666481246
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2879130666481246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Breadcrumb Menu',
  p_before_first=>'',
  p_current_page_option=>'<a href="#LINK#" class="t16current">#NAME#</a>',
  p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>',
  p_menu_link_attributes=>'',
  p_between_levels=>'<img src="#IMAGE_PREFIX#themes/theme_16/breadcrumb_sep.gif" align="middle" alt="" />',
  p_after_last=>'',
  p_max_levels=>12,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 16,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
prompt  ......template 2879201676481246
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2879201676481246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Hierarchical Menu',
  p_before_first=>'<ul class="t16HierarchicalMenu">',
  p_current_page_option=>'<li class="t16current"><a href="#LINK#">#NAME#</a></li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'',
  p_after_last=>'</ul>',
  p_max_levels=>11,
  p_start_with_node=>'CHILD_MENU',
  p_theme_id  => 16,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
prompt  ......template 2900231998489446
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2900231998489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Breadcrumb Menu',
  p_before_first=>'<div class="t12BreadcrumbMenu">',
  p_current_page_option=>'#NAME#',
  p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>',
  p_menu_link_attributes=>'',
  p_between_levels=>'&nbsp;&gt;&nbsp;',
  p_after_last=>'</div>',
  p_max_levels=>12,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 1,
  p_theme_class_id => 1,
  p_reference_id            => 10644341584233797,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
prompt  ......template 2900302868489446
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2900302868489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Hierarchical Menu',
  p_before_first=>'<ul class="t1HierarchicalMenu">',
  p_current_page_option=>'<li class="t1current">#NAME#</li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'',
  p_after_last=>'</ul>',
  p_max_levels=>11,
  p_start_with_node=>'CHILD_MENU',
  p_theme_id  => 1,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
prompt  ......template 2921707127507754
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2921707127507754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Hierarchical Menu',
  p_before_first=>'<ul class="t13HierarchicalMenu">',
  p_current_page_option=>'<li class="t13current"><a href="#LINK#">#NAME#</a></li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'',
  p_after_last=>'</ul>',
  p_max_levels=>11,
  p_start_with_node=>'CHILD_MENU',
  p_theme_id  => 13,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
prompt  ......template 2921831663507754
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2921831663507754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Breadcrumb Menu',
  p_before_first=>'',
  p_current_page_option=>'<span class="t13Breadcrumb">#NAME#</span>',
  p_non_current_page_option=>'<a href="#LINK#" class="t13Breadcrumb">#NAME#</a>',
  p_menu_link_attributes=>'',
  p_between_levels=>'<span class="t13BreadcrumbSep">&gt;</span>',
  p_after_last=>'',
  p_max_levels=>12,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 13,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
prompt  ......template 2962821485426606
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2962821485426606 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Breadcrumb Menu',
  p_before_first=>'<div class="t11BreadcrumbMenu" style="color:#91C58D">',
  p_current_page_option=>'<a href="#LINK#" class="t11current">#NAME#</a>',
  p_non_current_page_option=>'<a href="#LINK#" style="text-decoration:underline;">#NAME#</a>',
  p_menu_link_attributes=>'',
  p_between_levels=>'&nbsp;&gt;&nbsp;',
  p_after_last=>'</div>',
  p_max_levels=>12,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 103,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
prompt  ......template 2962913844426609
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 2962913844426609 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Hierarchical Menu',
  p_before_first=>'<ul class="t4HierarchicalMenu">',
  p_current_page_option=>'<li class="t4current"><a href="#LINK#">#NAME#</a></li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'',
  p_after_last=>'</ul>',
  p_max_levels=>11,
  p_start_with_node=>'CHILD_MENU',
  p_theme_id  => 103,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
prompt  ......template 7165217377739476
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 7165217377739476 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Hierarchical Menu',
  p_before_first=>'<ul class="t12HierarchicalMenu">',
  p_current_page_option=>'<li><a style="font-weight:bold;" href="#LINK#">#NAME#</a></li>',
  p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>',
  p_menu_link_attributes=>'',
  p_between_levels=>'',
  p_after_last=>'</ul>',
  p_max_levels=>11,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 12,
  p_theme_class_id => 2,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
prompt  ......template 7165316006739479
 
begin
 
begin
wwv_flow_api.create_menu_template (
  p_id=> 7165316006739479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_name=>'Breadcrumb Menu',
  p_before_first=>'<div class="t12BreadcrumbMenu">',
  p_current_page_option=>'#NAME#',
  p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>',
  p_menu_link_attributes=>'',
  p_between_levels=>'&nbsp;&gt;&nbsp;',
  p_after_last=>'</div>',
  p_max_levels=>12,
  p_start_with_node=>'PARENT_TO_LEAF',
  p_theme_id  => 12,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_template_comments=>'');
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/popuplov
prompt  ...popup list of values templates
--
prompt  ......template 2797327229266451
 
begin
 
begin
wwv_flow_api.create_popup_lov_template (
  p_id=> 2797327229266451 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif',
  p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"',
  p_popup_icon2=>'',
  p_popup_icon_attr2=>'',
  p_page_name=>'Popup LOV',
  p_page_title=>'Search Dialog',
  p_page_html_head=>'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_15/theme_V2.css" type="text/css" />'||unistr('\000a')||
''||unistr('\000a')||
'#THEME_CSS#',
  p_page_body_attr=>'onload="first_field()" style="margin:0;"',
  p_before_field_text=>'<div class="t15PopupHead">',
  p_page_heading_text=>'',
  p_page_footer_text =>'',
  p_filter_width     =>'20',
  p_filter_max_width =>'100',
  p_filter_text_attr =>'',
  p_find_button_text =>'Search',
  p_find_button_image=>'',
  p_find_button_attr =>'',
  p_close_button_text=>'Close',
  p_close_button_image=>'',
  p_close_button_attr=>'',
  p_next_button_text =>'Next &gt;',
  p_next_button_image=>'',
  p_next_button_attr =>'',
  p_prev_button_text =>'&lt; Previous',
  p_prev_button_image=>'',
  p_prev_button_attr =>'',
  p_after_field_text=>'</div>',
  p_scrollbars=>'1',
  p_resizable=>'1',
  p_width =>'400',
  p_height=>'450',
  p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>',
  p_result_rows_per_pg=>500,
  p_before_result_set=>'<div class="t15PopupBody">',
  p_theme_id  => 15,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_after_result_set   =>'</div>');
end;
null;
 
end;
/

prompt  ......template 2818312277273793
 
begin
 
begin
wwv_flow_api.create_popup_lov_template (
  p_id=> 2818312277273793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif',
  p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"',
  p_popup_icon2=>'',
  p_popup_icon_attr2=>'',
  p_page_name=>'winlov',
  p_page_title=>'Search Dialog',
  p_page_html_head=>'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_8/theme_V2.css" type="text/css" />'||unistr('\000a')||
''||unistr('\000a')||
'#THEME_CSS#',
  p_page_body_attr=>'onload="first_field()" style="margin:0;"',
  p_before_field_text=>'<div class="t8PopupHead">',
  p_page_heading_text=>'',
  p_page_footer_text =>'',
  p_filter_width     =>'20',
  p_filter_max_width =>'100',
  p_filter_text_attr =>'',
  p_find_button_text =>'Search',
  p_find_button_image=>'',
  p_find_button_attr =>'',
  p_close_button_text=>'Close',
  p_close_button_image=>'',
  p_close_button_attr=>'',
  p_next_button_text =>'Next >',
  p_next_button_image=>'',
  p_next_button_attr =>'',
  p_prev_button_text =>'< Previous',
  p_prev_button_image=>'',
  p_prev_button_attr =>'',
  p_after_field_text=>'</div>',
  p_scrollbars=>'1',
  p_resizable=>'1',
  p_width =>'400',
  p_height=>'450',
  p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>',
  p_result_rows_per_pg=>500,
  p_before_result_set=>'<div class="t8PopupBody">',
  p_theme_id  => 8,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_after_result_set   =>'</div>');
end;
null;
 
end;
/

prompt  ......template 2838606106468459
 
begin
 
begin
wwv_flow_api.create_popup_lov_template (
  p_id=> 2838606106468459 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif',
  p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"',
  p_popup_icon2=>'',
  p_popup_icon_attr2=>'',
  p_page_name=>'winlov',
  p_page_title=>'Search Dialog',
  p_page_html_head=>'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
''||unistr('\000a')||
'#THEME_CSS#',
  p_page_body_attr=>'onload="first_field()" style="margin:0px;"',
  p_before_field_text=>'<div class="t11PopupHead">',
  p_page_heading_text=>'',
  p_page_footer_text =>'',
  p_filter_width     =>'20',
  p_filter_max_width =>'100',
  p_filter_text_attr =>'',
  p_find_button_text =>'Search',
  p_find_button_image=>'',
  p_find_button_attr =>'',
  p_close_button_text=>'Close',
  p_close_button_image=>'',
  p_close_button_attr=>'',
  p_next_button_text =>'Next >',
  p_next_button_image=>'',
  p_next_button_attr =>'',
  p_prev_button_text =>'< Previous',
  p_prev_button_image=>'',
  p_prev_button_attr =>'',
  p_after_field_text=>'</div>',
  p_scrollbars=>'1',
  p_resizable=>'1',
  p_width =>'400',
  p_height=>'450',
  p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>',
  p_result_rows_per_pg=>500,
  p_before_result_set=>'<div class="t11PopupBody">',
  p_theme_id  => 11,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_after_result_set   =>'</div>');
end;
null;
 
end;
/

prompt  ......template 2859225298474923
 
begin
 
begin
wwv_flow_api.create_popup_lov_template (
  p_id=> 2859225298474923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif',
  p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"',
  p_popup_icon2=>'',
  p_popup_icon_attr2=>'',
  p_page_name=>'winlov',
  p_page_title=>'Search Dialog',
  p_page_html_head=>'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_17/theme_V22.css" type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'#THEME_CSS#',
  p_page_body_attr=>'onload="first_field()" style="background-color:#FFFFFF;margin:0;"',
  p_before_field_text=>'<div class="t17PopupHead">',
  p_page_heading_text=>'',
  p_page_footer_text =>'',
  p_filter_width     =>'20',
  p_filter_max_width =>'100',
  p_filter_text_attr =>'',
  p_find_button_text =>'Search',
  p_find_button_image=>'',
  p_find_button_attr =>'',
  p_close_button_text=>'Close',
  p_close_button_image=>'',
  p_close_button_attr=>'',
  p_next_button_text =>'Next >',
  p_next_button_image=>'',
  p_next_button_attr =>'',
  p_prev_button_text =>'< Previous',
  p_prev_button_image=>'',
  p_prev_button_attr =>'',
  p_after_field_text=>'</div>',
  p_scrollbars=>'1',
  p_resizable=>'1',
  p_width =>'400',
  p_height=>'450',
  p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>',
  p_result_rows_per_pg=>500,
  p_before_result_set=>'<div class="t17PopupBody">',
  p_theme_id  => 17,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_after_result_set   =>'</div>');
end;
null;
 
end;
/

prompt  ......template 2879915668481246
 
begin
 
begin
wwv_flow_api.create_popup_lov_template (
  p_id=> 2879915668481246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif',
  p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"',
  p_popup_icon2=>'',
  p_popup_icon_attr2=>'',
  p_page_name=>'winlov',
  p_page_title=>'Search Dialog',
  p_page_html_head=>'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_16/theme_V2.css" type="text/css" />'||unistr('\000a')||
'#THEME_CSS#',
  p_page_body_attr=>'onload="first_field()" class="popuplov"',
  p_before_field_text=>'<div class="t16PopupHead">',
  p_page_heading_text=>'',
  p_page_footer_text =>'',
  p_filter_width     =>'20',
  p_filter_max_width =>'100',
  p_filter_text_attr =>'',
  p_find_button_text =>'Search',
  p_find_button_image=>'',
  p_find_button_attr =>'',
  p_close_button_text=>'Close',
  p_close_button_image=>'',
  p_close_button_attr=>'',
  p_next_button_text =>'Next >',
  p_next_button_image=>'',
  p_next_button_attr =>'',
  p_prev_button_text =>'< Previous',
  p_prev_button_image=>'',
  p_prev_button_attr =>'',
  p_after_field_text=>'</div>',
  p_scrollbars=>'1',
  p_resizable=>'1',
  p_width =>'400',
  p_height=>'450',
  p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>',
  p_result_rows_per_pg=>10,
  p_before_result_set=>'<div class="t16PopupBody">',
  p_theme_id  => 16,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_after_result_set   =>'</div>');
end;
null;
 
end;
/

prompt  ......template 2901017698489446
 
begin
 
begin
wwv_flow_api.create_popup_lov_template (
  p_id=> 2901017698489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif',
  p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"',
  p_popup_icon2=>'',
  p_popup_icon_attr2=>'',
  p_page_name=>'winlov',
  p_page_title=>'Search Dialog',
  p_page_html_head=>'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'#THEME_CSS#',
  p_page_body_attr=>'onload="first_field()" style="margin:0;"',
  p_before_field_text=>'<div class="t1PopupHead">',
  p_page_heading_text=>'',
  p_page_footer_text =>'',
  p_filter_width     =>'20',
  p_filter_max_width =>'100',
  p_filter_text_attr =>'',
  p_find_button_text =>'Search',
  p_find_button_image=>'',
  p_find_button_attr =>'',
  p_close_button_text=>'Close',
  p_close_button_image=>'',
  p_close_button_attr=>'',
  p_next_button_text =>'Next >',
  p_next_button_image=>'',
  p_next_button_attr =>'',
  p_prev_button_text =>'< Previous',
  p_prev_button_image=>'',
  p_prev_button_attr =>'',
  p_after_field_text=>'</div>',
  p_scrollbars=>'1',
  p_resizable=>'1',
  p_width =>'400',
  p_height=>'450',
  p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>',
  p_result_rows_per_pg=>500,
  p_before_result_set=>'<div class="t1PopupBody">',
  p_theme_id  => 1,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_after_result_set   =>'</div>');
end;
null;
 
end;
/

prompt  ......template 2922523778507754
 
begin
 
begin
wwv_flow_api.create_popup_lov_template (
  p_id=> 2922523778507754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif',
  p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"',
  p_popup_icon2=>'',
  p_popup_icon_attr2=>'',
  p_page_name=>'winlov',
  p_page_title=>'Search Dialog',
  p_page_html_head=>'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_13/theme_V22.css" type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'#THEME_CSS#',
  p_page_body_attr=>'onload="first_field()" style="background-color:#FFFFFF;margin:0;"',
  p_before_field_text=>'<div class="t13PopupHead">',
  p_page_heading_text=>'',
  p_page_footer_text =>'',
  p_filter_width     =>'20',
  p_filter_max_width =>'100',
  p_filter_text_attr =>'',
  p_find_button_text =>'Search',
  p_find_button_image=>'',
  p_find_button_attr =>'',
  p_close_button_text=>'Close',
  p_close_button_image=>'',
  p_close_button_attr=>'',
  p_next_button_text =>'Next >',
  p_next_button_image=>'',
  p_next_button_attr =>'',
  p_prev_button_text =>'< Previous',
  p_prev_button_image=>'',
  p_prev_button_attr =>'',
  p_after_field_text=>'</div>',
  p_scrollbars=>'1',
  p_resizable=>'1',
  p_width =>'400',
  p_height=>'450',
  p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>',
  p_result_rows_per_pg=>500,
  p_before_result_set=>'<div class="t13PopupBody">',
  p_theme_id  => 13,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_after_result_set   =>'</div>');
end;
null;
 
end;
/

prompt  ......template 2963303450426614
 
begin
 
begin
wwv_flow_api.create_popup_lov_template (
  p_id=> 2963303450426614 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif',
  p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"',
  p_popup_icon2=>'',
  p_popup_icon_attr2=>'',
  p_page_name=>'winlov',
  p_page_title=>'Search Dialog',
  p_page_html_head=>'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_11/theme_V2.css" type="text/css" />'||unistr('\000a')||
''||unistr('\000a')||
'#THEME_CSS#',
  p_page_body_attr=>'onload="first_field()" style="margin:0px;"',
  p_before_field_text=>'<div class="t11PopupHead">',
  p_page_heading_text=>'',
  p_page_footer_text =>'',
  p_filter_width     =>'20',
  p_filter_max_width =>'100',
  p_filter_text_attr =>'',
  p_find_button_text =>'Search',
  p_find_button_image=>'',
  p_find_button_attr =>'',
  p_close_button_text=>'Close',
  p_close_button_image=>'',
  p_close_button_attr=>'',
  p_next_button_text =>'Next >',
  p_next_button_image=>'',
  p_next_button_attr =>'',
  p_prev_button_text =>'< Previous',
  p_prev_button_image=>'',
  p_prev_button_attr =>'',
  p_after_field_text=>'</div>',
  p_scrollbars=>'1',
  p_resizable=>'1',
  p_width =>'400',
  p_height=>'450',
  p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>',
  p_result_rows_per_pg=>500,
  p_before_result_set=>'<div class="t11PopupBody">',
  p_theme_id  => 103,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_after_result_set   =>'</div>');
end;
null;
 
end;
/

prompt  ......template 7166015270739482
 
begin
 
begin
wwv_flow_api.create_popup_lov_template (
  p_id=> 7166015270739482 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif',
  p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"',
  p_popup_icon2=>'',
  p_popup_icon_attr2=>'',
  p_page_name=>'winlov',
  p_page_title=>'Search Dialog',
  p_page_html_head=>'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_12/theme.css" type="text/css">'||unistr('\000a')||
''||unistr('\000a')||
'#THEME_CSS#',
  p_page_body_attr=>'OnLoad="first_field()" style="margin:0;"',
  p_before_field_text=>'<div class="t12PopupHead">',
  p_page_heading_text=>'',
  p_page_footer_text =>'',
  p_filter_width     =>'20',
  p_filter_max_width =>'100',
  p_filter_text_attr =>'',
  p_find_button_text =>'Search',
  p_find_button_image=>'',
  p_find_button_attr =>'',
  p_close_button_text=>'Close',
  p_close_button_image=>'',
  p_close_button_attr=>'',
  p_next_button_text =>'Next >',
  p_next_button_image=>'',
  p_next_button_attr =>'',
  p_prev_button_text =>'< Previous',
  p_prev_button_image=>'',
  p_prev_button_attr =>'',
  p_after_field_text=>'</div>',
  p_scrollbars=>'1',
  p_resizable=>'1',
  p_width =>'400',
  p_height=>'450',
  p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>',
  p_result_rows_per_pg=>10,
  p_before_result_set=>'<div class="t12PopupBody">',
  p_theme_id  => 12,
  p_theme_class_id => 1,
  p_translate_this_template => 'N',
  p_after_result_set   =>'</div>');
end;
null;
 
end;
/

prompt  ...calendar templates
--
--application/shared_components/user_interface/templates/calendar/calendar
prompt  ......template 2796732045266448
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2796732045266448 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t15DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t15StandardCalHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t15MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t15StandardCal">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t15DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t15Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td><!--CAN YOU SEE THIS? #4-->',
  p_today_open_format=> '<td valign="top" class="t15Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t15WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t15WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td><!--CAN YOU SEE THIS? #3-->',
  p_nonday_title_format => '<div class="t15NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t15NonDay" valign="top">',
  p_nonday_close_format => '</td><!--CAN YOU SEE THIS? #2-->',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> <!--CAN YOU SEE THIS? #1-->',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 15,
  p_theme_class_id => 1,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar_alternative_1
prompt  ......template 2796923977266451
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2796923977266451 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar, Alternative 1',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t15DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t15CalendarAlternative1Holder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t15MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t15CalendarAlternative1">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t15DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t15Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t15Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t15WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t15WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t15NonDayTitle">#DD#</div></td>',
  p_nonday_open_format => '<td class="t15NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '',
  p_daily_open_format => '',
  p_daily_close_format => '',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 15,
  p_theme_class_id => 2,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/small_calendar
prompt  ......template 2797125157266451
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2797125157266451 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Small Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t15SmallCalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t15MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t15SmallCalendar">',
  p_month_close_format=> '</tr></table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t15DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t15Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t15Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t15WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t15WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t15NonDayTitle">#DD#</div></td>',
  p_nonday_open_format => '<td class="t15NonDay" valign="top">',
  p_nonday_close_format => '',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 15,
  p_theme_class_id => 3,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar
prompt  ......template 2817707413273793
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2817707413273793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t8DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t8CalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t8MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t8Calendar">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t8DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t8Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t8Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t8WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t8WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t8NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t8NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 8,
  p_theme_class_id => 1,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/small_calendar
prompt  ......template 2817908587273793
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2817908587273793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Small Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t8DayOfWeek" height="12">#DY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t8SmallCalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t8MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t8SmallCalendar">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t8DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t8Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t8Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t8WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t8WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t8NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t8NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 8,
  p_theme_class_id => 3,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar_alternative_1
prompt  ......template 2818119993273793
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2818119993273793 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar, Alternative 1',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t8DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t8CalendarAlternative1Holder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t8MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="4" summary="0" class="t8CalendarAlternative1">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t8DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t8Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t8Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t8WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t8WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t8NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t8NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 8,
  p_theme_class_id => 2,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar
prompt  ......template 2838015022468457
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2838015022468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t11DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t11CalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t11MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t11Calendar">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t11DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t11Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t11Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t11WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t11WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t11NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t11NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 11,
  p_theme_class_id => 1,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/small_calender
prompt  ......template 2838222777468457
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2838222777468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Small Calender',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t11SmallCalenderHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t11MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="1" summary="0" class="t11SmallCalender">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t11DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t11Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t11Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t11WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t11WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t11NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t11NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 11,
  p_theme_class_id => 3,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar_alternative_1
prompt  ......template 2838410813468457
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2838410813468457 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar, Alternative 1',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t11DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t11CalendarAlternative1Holder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t11MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t11CalendarAlternative1">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t11DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t11Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t11Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t11WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t11WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t4NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t11NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 11,
  p_theme_class_id => 2,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/small_calender
prompt  ......template 2858609770474923
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2858609770474923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Small Calender',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t17SmallCalenderHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t17MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td class="t17MonthBody">',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t17SmallCalender">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t17DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t17Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t17Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t17WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t17WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t17NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t17NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 17,
  p_theme_class_id => 3,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar
prompt  ......template 2858818116474923
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2858818116474923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t17DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t17CalendarAlternative1Holder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t17MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td class="t17MonthBody">',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t17CalendarAlternative1">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t17DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t17Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t17Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t17WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t17WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t17NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t17NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 17,
  p_theme_class_id => 1,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar_alternative_1
prompt  ......template 2859020003474923
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2859020003474923 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar, Alternative 1',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t17DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t17CalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t17MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td class="t17MonthBody">',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t17Calendar">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t17DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t17Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t17Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t17WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t17WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t17NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t17NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 17,
  p_theme_class_id => 2,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar_alternative_1
prompt  ......template 2879305184481246
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2879305184481246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar, Alternative 1',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t16DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t16CalendarAlternative1Holder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t16MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t16CalendarAlternative1">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t16DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t16Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t16Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t16WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t16WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t16NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t16NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 16,
  p_theme_class_id => 2,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar
prompt  ......template 2879508556481246
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2879508556481246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t16DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t16CalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t16MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t16Calendar">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t16DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t16Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t16Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t16WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t16WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t16NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t16NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 16,
  p_theme_class_id => 1,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/small_calender
prompt  ......template 2879717820481246
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2879717820481246 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Small Calender',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t16SmallCalenderHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t16MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t16SmallCalender">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t16DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t16Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t16Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t16WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t16WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t16NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t16NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 16,
  p_theme_class_id => 3,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar
prompt  ......template 2900410657489446
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2900410657489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t1DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1CalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t1DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t1WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t1NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t1NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 1,
  p_theme_class_id => 1,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar_alternative_1
prompt  ......template 2900612757489446
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2900612757489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar, Alternative 1',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th valign="bottom" class="t1DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1CalendarAlternative1Holder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t1DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t1WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t1NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t1NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 1,
  p_theme_class_id => 2,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/small_calendar
prompt  ......template 2900825381489446
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2900825381489446 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Small Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t1DayOfWeek">#DY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1SmallCalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="1" summary="" class="t1SmallCalendar">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t1DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t1WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t1NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t1NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 1,
  p_theme_class_id => 3,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/small_calender
prompt  ......template 2921906076507754
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2921906076507754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Small Calender',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t13SmallCalenderHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t13MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t13SmallCalender">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t13DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t13Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t13Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t13WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t13WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t13NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t13NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 13,
  p_theme_class_id => 3,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar
prompt  ......template 2922124439507754
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2922124439507754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t13DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t13CalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t13MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t13Calendar">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t13DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t13Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t13Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t13WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t13WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t13NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t13NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 13,
  p_theme_class_id => 1,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar_alternative_1
prompt  ......template 2922306879507754
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2922306879507754 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar, Alternative 1',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t13DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t13CalendarAlternative1Holder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t13MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t13CalendarAlternative1">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t13DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t13Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t13Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t13WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t13WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t13NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t13NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 13,
  p_theme_class_id => 2,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar
prompt  ......template 2963023551426610
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2963023551426610 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t11DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t11CalendarHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t11MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t11Calendar">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t11DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t11Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t11Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t11WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t11WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t11NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t11NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 103,
  p_theme_class_id => 1,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar_alternative_1
prompt  ......template 2963109450426614
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2963109450426614 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar, Alternative 1',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<th class="t11DayOfWeek">#IDAY#</th>',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t11CalendarAlternative1Holder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t11MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t11CalendarAlternative1">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t11DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t11Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t11Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t11WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t11WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t4NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t11NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 103,
  p_theme_class_id => 2,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/small_calender
prompt  ......template 2963221931426614
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 2963221931426614 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Small Calender',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '',
  p_month_title_format=> '<table cellspacing="0" cellpadding="0" border="0" summary="" class="t11SmallCalenderHolder"> '||unistr('\000a')||
' <tr>'||unistr('\000a')||
'   <td class="t11MonthTitle">#IMONTH# #YYYY#</td>'||unistr('\000a')||
' </tr>'||unistr('\000a')||
' <tr>'||unistr('\000a')||
' <td>',
  p_month_open_format=> '<table border="0" cellpadding="0" cellspacing="1" summary="0" class="t11SmallCalender">',
  p_month_close_format=> '</table></td>'||unistr('\000a')||
'</tr>'||unistr('\000a')||
'</table>'||unistr('\000a')||
'',
  p_day_title_format=> '<div class="t11DayTitle">#DD#</div>',
  p_day_open_format=> '<td class="t11Day" valign="top">#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</td>',
  p_today_open_format=> '<td valign="top" class="t11Today">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div class="t11WeekendDayTitle">#DD#</div>',
  p_weekend_open_format => '<td valign="top" class="t11WeekendDay">#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '</td>',
  p_nonday_title_format => '<div class="t11NonDayTitle">#DD#</div>',
  p_nonday_open_format => '<td class="t11NonDay" valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr>',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 103,
  p_theme_class_id => 3,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar_alternative_1
prompt  ......template 7165421586739479
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 7165421586739479 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar, Alternative 1',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<td width="60">#IDY#</td>',
  p_month_title_format=> '<table class="t12StandardCalendar" width="100%" cellpadding="0" cellspacing="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td align="middle" class="formRegionHeader">#IMONTH#&nbsp;#YYYY#</td>'||unistr('\000a')||
'  </tr>',
  p_month_open_format=> '  <tr>'||unistr('\000a')||
'    <td align="center"  class="formRegionHeader"><table cellspacing="0" cellpadding="0" class="condensedTable">',
  p_month_close_format=> '    </table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>',
  p_day_title_format=> '#DD#<br/><span style="font-weight:bold">'||unistr('\000a')||
'',
  p_day_open_format=> '<td valign="top"  width="60" class="formRegionBody">'||unistr('\000a')||
'#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</span>&nbsp;</td>',
  p_today_open_format=> '<td valign="top" class="formRegionBodyCurrent">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div>#DD#</div><span style="font-weight:bold">'||unistr('\000a')||
'',
  p_weekend_open_format => '<td valign="top" class="formRegionBodyWE">'||unistr('\000a')||
'#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '<span></td>',
  p_nonday_title_format => '<div>&nbsp;</div>',
  p_nonday_open_format => '<td valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr class="formRegionHeader">',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 12,
  p_theme_class_id => 2,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/small_calendar
prompt  ......template 7165618740739481
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 7165618740739481 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Small Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<td width="40" class="simpleHeadings">#IDY#</td>',
  p_month_title_format=> '<table class="t12SimpleCalendar" width="100%" cellpadding="0" cellspacing="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td align="middle" class="simpleHeader">#IMONTH#&nbsp;#YYYY#</td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'',
  p_month_open_format=> '  <tr>'||unistr('\000a')||
'    <td align="center" class="simpleHeader"><table cellspacing="0" cellpadding="0" class="simpleTable">',
  p_month_close_format=> '    </table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>',
  p_day_title_format=> '#DD#<br/><span style="font-weight:bold;">'||unistr('\000a')||
'',
  p_day_open_format=> '<td valign="top" class="simpleBody">'||unistr('\000a')||
'#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</span>&nbsp;</td>',
  p_today_open_format=> '<td valign="top" class="simpleBodyCurrent">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div>#DD#</div><span style="font-weight:bold;">'||unistr('\000a')||
'',
  p_weekend_open_format => '<td valign="top" class="simpleBodyWE">'||unistr('\000a')||
'#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '<span></td>',
  p_nonday_title_format => '<div>&nbsp;</div>',
  p_nonday_open_format => '<td valign="top" class="simpleBody">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr class="formRegionHeader">',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 12,
  p_theme_class_id => 3,
  p_reference_id=> null);
end;
null;
 
end;
/

--application/shared_components/user_interface/templates/calendar/calendar
prompt  ......template 7165831360739481
 
begin
 
begin
wwv_flow_api.create_calendar_template(
  p_id=> 7165831360739481 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_cal_template_name=>'Calendar',
  p_translate_this_template=> 'N',
  p_day_of_week_format=> '<td width="100">#IDAY#</td>',
  p_month_title_format=> '<table class="t12StandardCalendar" width="100%" cellpadding="0" cellspacing="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td align="middle" class="formRegionHeader">#IMONTH#&nbsp;#YYYY#</td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>',
  p_month_open_format=> '<table class="t12StandardCalendar" width="100%" cellpadding="0" cellspacing="0" border="0" cellspacing="0" summary="">'||unistr('\000a')||
'  <tr>'||unistr('\000a')||
'    <td align="center"  class="formRegionHeader"><table cellspacing="2" cellpadding="2">',
  p_month_close_format=> '    </table></td>'||unistr('\000a')||
'  </tr>'||unistr('\000a')||
'</table>',
  p_day_title_format=> '#DD#<br/><span style="font-weight:bold">'||unistr('\000a')||
'',
  p_day_open_format=> '<td valign="top" width="100" class="formRegionBody">'||unistr('\000a')||
'#TITLE_FORMAT##DATA#',
  p_day_close_format=> '</span>&nbsp;</td>',
  p_today_open_format=> '<td valign="top" class="formRegionBodyCurrent">#TITLE_FORMAT##DATA#',
  p_weekend_title_format=> '<div>#DD#</div><span style="font-weight:bold">'||unistr('\000a')||
'',
  p_weekend_open_format => '<td valign="top" class="formRegionBodyWE">'||unistr('\000a')||
'#TITLE_FORMAT##DATA#',
  p_weekend_close_format => '<span></td>',
  p_nonday_title_format => '<div>&nbsp;</div>',
  p_nonday_open_format => '<td valign="top">',
  p_nonday_close_format => '</td>',
  p_week_title_format => '',
  p_week_open_format => '<tr class="formRegionHeader">',
  p_week_close_format => '</tr> ',
  p_daily_title_format => '<th width="14%" class="calheader">#IDAY#</th>',
  p_daily_open_format => '<tr>',
  p_daily_close_format => '</tr>',
  p_weekly_title_format => '',
  p_weekly_day_of_week_format => '',
  p_weekly_month_open_format => '',
  p_weekly_month_close_format => '',
  p_weekly_day_title_format => '',
  p_weekly_day_open_format => '',
  p_weekly_day_close_format => '',
  p_weekly_today_open_format => '',
  p_weekly_weekend_title_format => '',
  p_weekly_weekend_open_format => '',
  p_weekly_weekend_close_format => '',
  p_weekly_time_open_format => '',
  p_weekly_time_close_format => '',
  p_weekly_time_title_format => '',
  p_weekly_hour_open_format => '',
  p_weekly_hour_close_format => '',
  p_daily_day_of_week_format => '',
  p_daily_month_title_format => '',
  p_daily_month_open_format => '',
  p_daily_month_close_format => '',
  p_daily_day_title_format => '',
  p_daily_day_open_format => '',
  p_daily_day_close_format => '',
  p_daily_today_open_format => '',
  p_daily_time_open_format => '',
  p_daily_time_close_format => '',
  p_daily_time_title_format => '',
  p_daily_hour_open_format => '',
  p_daily_hour_close_format => '',
  p_cust_month_title_format => '',
  p_cust_day_of_week_format => '',
  p_cust_month_open_format => '',
  p_cust_month_close_format => '',
  p_cust_week_title_format => '',
  p_cust_week_open_format => '',
  p_cust_week_close_format => '',
  p_cust_day_title_format => '',
  p_cust_day_open_format => '',
  p_cust_day_close_format => '',
  p_cust_today_open_format => '',
  p_cust_daily_title_format => '',
  p_cust_daily_open_format => '',
  p_cust_daily_close_format => '',
  p_cust_nonday_title_format => '',
  p_cust_nonday_open_format => '',
  p_cust_nonday_close_format => '',
  p_cust_weekend_title_format => '',
  p_cust_weekend_open_format => '',
  p_cust_weekend_close_format => '',
  p_cust_hour_open_format => '',
  p_cust_hour_close_format => '',
  p_cust_time_title_format => '',
  p_cust_time_open_format => '',
  p_cust_time_close_format => '',
  p_cust_wk_month_title_format => '',
  p_cust_wk_day_of_week_format => '',
  p_cust_wk_month_open_format => '',
  p_cust_wk_month_close_format => '',
  p_cust_wk_week_title_format => '',
  p_cust_wk_week_open_format => '',
  p_cust_wk_week_close_format => '',
  p_cust_wk_day_title_format => '',
  p_cust_wk_day_open_format => '',
  p_cust_wk_day_close_format => '',
  p_cust_wk_today_open_format => '',
  p_cust_wk_weekend_title_format => '',
  p_cust_wk_weekend_open_format => '',
  p_cust_wk_weekend_close_format => '',
  p_cust_month_day_height_pix => '',
  p_cust_month_day_height_per => '',
  p_cust_week_day_width_pix => '',
  p_cust_week_day_width_per => '',
  p_agenda_format => '',
  p_agenda_past_day_format => '',
  p_agenda_today_day_format => '',
  p_agenda_future_day_format => '',
  p_agenda_past_entry_format => '',
  p_agenda_today_entry_format => '',
  p_agenda_future_entry_format => '',
  p_month_data_format => '#DAYS#',
  p_month_data_entry_format => '#DATA#',
  p_theme_id  => 12,
  p_theme_class_id => 1,
  p_reference_id=> null);
end;
null;
 
end;
/

prompt  ...application themes
--
--application/shared_components/user_interface/themes/light_blue
prompt  ......theme 2797511567266454
begin
wwv_flow_api.create_theme (
  p_id =>2797511567266454 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 15,
  p_theme_name=>'Light Blue',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>2779420236266420 + wwv_flow_api.g_id_offset,
  p_error_template=>2780916469266423 + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>2779110374266420 + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'REGION_POSITION_01',
  p_sidebar_display_point=>'REGION_POSITION_02',
  p_login_template=>2780916469266423 + wwv_flow_api.g_id_offset,
  p_default_button_template=>2781605937266426 + wwv_flow_api.g_id_offset,
  p_default_region_template=>2785600597266431 + wwv_flow_api.g_id_offset,
  p_default_chart_template =>2785909435266431 + wwv_flow_api.g_id_offset,
  p_default_form_template  =>2787428386266434 + wwv_flow_api.g_id_offset,
  p_default_reportr_template   =>2785600597266431 + wwv_flow_api.g_id_offset,
  p_default_tabform_template=>2785600597266431 + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>2784715709266431 + wwv_flow_api.g_id_offset,
  p_default_menur_template=>2783831292266429 + wwv_flow_api.g_id_offset,
  p_default_listr_template=>2785600597266431 + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template   =>2792516201266440 + wwv_flow_api.g_id_offset,
  p_default_label_template=>2796412512266446 + wwv_flow_api.g_id_offset,
  p_default_menu_template=>2796631194266448 + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>2796732045266448 + wwv_flow_api.g_id_offset,
  p_default_list_template=>2791027858266439 + wwv_flow_api.g_id_offset,
  p_default_option_label=>2796412512266446 + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>2796223897266446 + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/orange_and_grey
prompt  ......theme 2818519085273793
begin
wwv_flow_api.create_theme (
  p_id =>2818519085273793 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 8,
  p_theme_name=>'Orange And Grey',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>2799805029273775 + wwv_flow_api.g_id_offset,
  p_error_template=>2799805029273775 + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>2801022383273778 + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'REGION_POSITION_01',
  p_sidebar_display_point=>'REGION_POSITION_02',
  p_login_template=>2800126981273775 + wwv_flow_api.g_id_offset,
  p_default_button_template=>2802823752273779 + wwv_flow_api.g_id_offset,
  p_default_region_template=>2808121931273785 + wwv_flow_api.g_id_offset,
  p_default_chart_template =>2805113769273782 + wwv_flow_api.g_id_offset,
  p_default_form_template  =>2807531875273784 + wwv_flow_api.g_id_offset,
  p_default_reportr_template   =>2808121931273785 + wwv_flow_api.g_id_offset,
  p_default_tabform_template=>2808121931273785 + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>2807213750273782 + wwv_flow_api.g_id_offset,
  p_default_menur_template=>2804501406273781 + wwv_flow_api.g_id_offset,
  p_default_listr_template=>2808121931273785 + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template   =>2814000656273790 + wwv_flow_api.g_id_offset,
  p_default_label_template=>2817414203273793 + wwv_flow_api.g_id_offset,
  p_default_menu_template=>2817517750273793 + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>2817707413273793 + wwv_flow_api.g_id_offset,
  p_default_list_template=>2810818429273787 + wwv_flow_api.g_id_offset,
  p_default_option_label=>2817414203273793 + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>2817026921273792 + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/round_green
prompt  ......theme 2838810423468459
begin
wwv_flow_api.create_theme (
  p_id =>2838810423468459 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 11,
  p_theme_name=>'Round Green',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>2819900905468445 + wwv_flow_api.g_id_offset,
  p_error_template=>2819900905468445 + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>2821910697468446 + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'REGION_POSITION_01',
  p_sidebar_display_point=>'REGION_POSITION_02',
  p_login_template=>2820111338468445 + wwv_flow_api.g_id_offset,
  p_default_button_template=>2822918909468448 + wwv_flow_api.g_id_offset,
  p_default_region_template=>2829022561468451 + wwv_flow_api.g_id_offset,
  p_default_chart_template =>2828724650468451 + wwv_flow_api.g_id_offset,
  p_default_form_template  =>2824805879468450 + wwv_flow_api.g_id_offset,
  p_default_reportr_template   =>2829022561468451 + wwv_flow_api.g_id_offset,
  p_default_tabform_template=>2829022561468451 + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>2826316729468450 + wwv_flow_api.g_id_offset,
  p_default_menur_template=>2826016121468450 + wwv_flow_api.g_id_offset,
  p_default_listr_template=>2829022561468451 + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template   =>2835805231468456 + wwv_flow_api.g_id_offset,
  p_default_label_template=>2837513631468457 + wwv_flow_api.g_id_offset,
  p_default_menu_template=>2837830185468457 + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>2838015022468457 + wwv_flow_api.g_id_offset,
  p_default_list_template=>2830807827468453 + wwv_flow_api.g_id_offset,
  p_default_option_label=>2837513631468457 + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>2837417667468457 + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/greyscale
prompt  ......theme 2859404627474923
begin
wwv_flow_api.create_theme (
  p_id =>2859404627474923 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 17,
  p_theme_name=>'Greyscale',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>2841627537474907 + wwv_flow_api.g_id_offset,
  p_error_template=>2841627537474907 + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>2842816710474909 + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'REGION_POSITION_01',
  p_sidebar_display_point=>'REGION_POSITION_02',
  p_login_template=>2841903861474909 + wwv_flow_api.g_id_offset,
  p_default_button_template=>2843105788474909 + wwv_flow_api.g_id_offset,
  p_default_region_template=>2846019653474910 + wwv_flow_api.g_id_offset,
  p_default_chart_template =>2845424029474910 + wwv_flow_api.g_id_offset,
  p_default_form_template  =>2848712422474914 + wwv_flow_api.g_id_offset,
  p_default_reportr_template   =>2846019653474910 + wwv_flow_api.g_id_offset,
  p_default_tabform_template=>2846019653474910 + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>2847827195474912 + wwv_flow_api.g_id_offset,
  p_default_menur_template=>2846329393474912 + wwv_flow_api.g_id_offset,
  p_default_listr_template=>2846019653474910 + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template   =>2854417829474920 + wwv_flow_api.g_id_offset,
  p_default_label_template=>2858320316474923 + wwv_flow_api.g_id_offset,
  p_default_menu_template=>2858502359474923 + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>2858818116474923 + wwv_flow_api.g_id_offset,
  p_default_list_template=>2850825852474915 + wwv_flow_api.g_id_offset,
  p_default_option_label=>2858320316474923 + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>2858217397474923 + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/dark_blue
prompt  ......theme 2880132282481246
begin
wwv_flow_api.create_theme (
  p_id =>2880132282481246 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 16,
  p_theme_name=>'Dark Blue',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>2862612813481232 + wwv_flow_api.g_id_offset,
  p_error_template=>2862612813481232 + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>2863221420481232 + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'REGION_POSITION_01',
  p_sidebar_display_point=>'REGION_POSITION_02',
  p_login_template=>2862305055481232 + wwv_flow_api.g_id_offset,
  p_default_button_template=>2863829455481232 + wwv_flow_api.g_id_offset,
  p_default_region_template=>2865821068481234 + wwv_flow_api.g_id_offset,
  p_default_chart_template =>2869121222481237 + wwv_flow_api.g_id_offset,
  p_default_form_template  =>2870621741481240 + wwv_flow_api.g_id_offset,
  p_default_reportr_template   =>2865821068481234 + wwv_flow_api.g_id_offset,
  p_default_tabform_template=>2865821068481234 + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>2867911799481235 + wwv_flow_api.g_id_offset,
  p_default_menur_template=>2868503403481237 + wwv_flow_api.g_id_offset,
  p_default_listr_template=>2865821068481234 + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template   =>2878118297481245 + wwv_flow_api.g_id_offset,
  p_default_label_template=>2878930736481246 + wwv_flow_api.g_id_offset,
  p_default_menu_template=>2879130666481246 + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>2879508556481246 + wwv_flow_api.g_id_offset,
  p_default_list_template=>2873328471481242 + wwv_flow_api.g_id_offset,
  p_default_option_label=>2878930736481246 + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>2878818561481246 + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/red
prompt  ......theme 2901204302489446
begin
wwv_flow_api.create_theme (
  p_id =>2901204302489446 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 1,
  p_theme_name=>'Red',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>2884210922489435 + wwv_flow_api.g_id_offset,
  p_error_template=>2884210922489435 + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>2884522145489435 + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'REGION_POSITION_01',
  p_sidebar_display_point=>'REGION_POSITION_02',
  p_login_template=>2882731585489434 + wwv_flow_api.g_id_offset,
  p_default_button_template=>2885332167489437 + wwv_flow_api.g_id_offset,
  p_default_region_template=>2885905427489437 + wwv_flow_api.g_id_offset,
  p_default_chart_template =>2891013448489440 + wwv_flow_api.g_id_offset,
  p_default_form_template  =>2890106833489440 + wwv_flow_api.g_id_offset,
  p_default_reportr_template   =>2885905427489437 + wwv_flow_api.g_id_offset,
  p_default_tabform_template=>2885905427489437 + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>2891602476489440 + wwv_flow_api.g_id_offset,
  p_default_menur_template=>2886213363489437 + wwv_flow_api.g_id_offset,
  p_default_listr_template=>2887131667489437 + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template   =>2899210279489446 + wwv_flow_api.g_id_offset,
  p_default_label_template=>2899703987489446 + wwv_flow_api.g_id_offset,
  p_default_menu_template=>2900231998489446 + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>2900410657489446 + wwv_flow_api.g_id_offset,
  p_default_list_template=>2895203907489443 + wwv_flow_api.g_id_offset,
  p_default_option_label=>2899703987489446 + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>2900122745489446 + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/blue_gray
prompt  ......theme 2922729381507754
begin
wwv_flow_api.create_theme (
  p_id =>2922729381507754 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 13,
  p_theme_name=>'Blue Gray',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>2903724887507740 + wwv_flow_api.g_id_offset,
  p_error_template=>2905227841507740 + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>2904014312507740 + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'REGION_POSITION_01',
  p_sidebar_display_point=>'REGION_POSITION_02',
  p_login_template=>2905507779507742 + wwv_flow_api.g_id_offset,
  p_default_button_template=>2906714293507742 + wwv_flow_api.g_id_offset,
  p_default_region_template=>2908131741507743 + wwv_flow_api.g_id_offset,
  p_default_chart_template =>2910505663507745 + wwv_flow_api.g_id_offset,
  p_default_form_template  =>2910222667507745 + wwv_flow_api.g_id_offset,
  p_default_reportr_template   =>2908131741507743 + wwv_flow_api.g_id_offset,
  p_default_tabform_template=>2908131741507743 + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>2911725918507746 + wwv_flow_api.g_id_offset,
  p_default_menur_template=>2912313460507746 + wwv_flow_api.g_id_offset,
  p_default_listr_template=>2908131741507743 + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template   =>2918720490507751 + wwv_flow_api.g_id_offset,
  p_default_label_template=>2921223710507753 + wwv_flow_api.g_id_offset,
  p_default_menu_template=>2921831663507754 + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>2922124439507754 + wwv_flow_api.g_id_offset,
  p_default_list_template=>2916503643507750 + wwv_flow_api.g_id_offset,
  p_default_option_label=>2921323135507753 + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>2921515415507754 + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/hepart
prompt  ......theme 2924801560515954
begin
wwv_flow_api.create_theme (
  p_id =>2924801560515954 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 101,
  p_theme_name=>'Hepart',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>null + wwv_flow_api.g_id_offset,
  p_error_template=>null + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>null + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'',
  p_sidebar_display_point=>'',
  p_login_template=>null + wwv_flow_api.g_id_offset,
  p_default_button_template=>null + wwv_flow_api.g_id_offset,
  p_default_region_template=>null + wwv_flow_api.g_id_offset,
  p_default_chart_template =>null + wwv_flow_api.g_id_offset,
  p_default_form_template  =>null + wwv_flow_api.g_id_offset,
  p_default_reportr_template => null,
  p_default_tabform_template=>null + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>null + wwv_flow_api.g_id_offset,
  p_default_menur_template=>null + wwv_flow_api.g_id_offset,
  p_default_listr_template=>null + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template => null,
  p_default_label_template=>null + wwv_flow_api.g_id_offset,
  p_default_menu_template=>null + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>null + wwv_flow_api.g_id_offset,
  p_default_list_template=>null + wwv_flow_api.g_id_offset,
  p_default_option_label=>null + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>null + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/biogena_round_green
prompt  ......theme 2963515728426618
begin
wwv_flow_api.create_theme (
  p_id =>2963515728426618 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 103,
  p_theme_name=>'Biogena Round Green',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>2947123360426564 + wwv_flow_api.g_id_offset,
  p_error_template=>2947123360426564 + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>2948025410426568 + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'REGION_POSITION_01',
  p_sidebar_display_point=>'REGION_POSITION_02',
  p_login_template=>2946322347426546 + wwv_flow_api.g_id_offset,
  p_default_button_template=>2962031294426603 + wwv_flow_api.g_id_offset,
  p_default_region_template=>2953114451426584 + wwv_flow_api.g_id_offset,
  p_default_chart_template =>2950700225426581 + wwv_flow_api.g_id_offset,
  p_default_form_template  =>2951006829426581 + wwv_flow_api.g_id_offset,
  p_default_reportr_template   =>2953114451426584 + wwv_flow_api.g_id_offset,
  p_default_tabform_template=>2953114451426584 + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>2954602903426585 + wwv_flow_api.g_id_offset,
  p_default_menur_template=>2949519638426579 + wwv_flow_api.g_id_offset,
  p_default_listr_template=>2953114451426584 + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template   =>2956414792426590 + wwv_flow_api.g_id_offset,
  p_default_label_template=>2961706517426603 + wwv_flow_api.g_id_offset,
  p_default_menu_template=>2962821485426606 + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>2963023551426610 + wwv_flow_api.g_id_offset,
  p_default_list_template=>2960927459426598 + wwv_flow_api.g_id_offset,
  p_default_option_label=>2961706517426603 + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_theme_description=>'Kopie aus round green 11 mit folgenden Anpassungen:'||unistr('\000a')||
'- Code Source Check im Seitentemplate one_level_tab'||unistr('\000a')||
'- button_ohne_check Template'||unistr('\000a')||
'- Help-Code in Label with help Templates'||unistr('\000a')||
'- im Seitentemplate Identität mit eingeblendet',
  p_default_required_label=>2961925178426603 + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/saluscom
prompt  ......theme 3028400639880964
begin
wwv_flow_api.create_theme (
  p_id =>3028400639880964 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 102,
  p_theme_name=>'Saluscom',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>null + wwv_flow_api.g_id_offset,
  p_error_template=>null + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>null + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'',
  p_sidebar_display_point=>'',
  p_login_template=>null + wwv_flow_api.g_id_offset,
  p_default_button_template=>null + wwv_flow_api.g_id_offset,
  p_default_region_template=>null + wwv_flow_api.g_id_offset,
  p_default_chart_template =>null + wwv_flow_api.g_id_offset,
  p_default_form_template  =>null + wwv_flow_api.g_id_offset,
  p_default_reportr_template => null,
  p_default_tabform_template=>null + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>null + wwv_flow_api.g_id_offset,
  p_default_menur_template=>null + wwv_flow_api.g_id_offset,
  p_default_listr_template=>null + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template => null,
  p_default_label_template=>null + wwv_flow_api.g_id_offset,
  p_default_menu_template=>null + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>null + wwv_flow_api.g_id_offset,
  p_default_list_template=>null + wwv_flow_api.g_id_offset,
  p_default_option_label=>null + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>null + wwv_flow_api.g_id_offset);
end;
/
 
--application/shared_components/user_interface/themes/blue
prompt  ......theme 7166102449739485
begin
wwv_flow_api.create_theme (
  p_id =>7166102449739485 + wwv_flow_api.g_id_offset,
  p_flow_id =>wwv_flow.g_flow_id,
  p_theme_id  => 12,
  p_theme_name=>'Blue',
  p_ui_type_name=>'DESKTOP',
  p_is_locked=>false,
  p_default_page_template=>7159632687739445 + wwv_flow_api.g_id_offset,
  p_error_template=>7159632687739445 + wwv_flow_api.g_id_offset,
  p_printer_friendly_template=>7159810642739445 + wwv_flow_api.g_id_offset,
  p_breadcrumb_display_point=>'REGION_POSITION_01',
  p_sidebar_display_point=>'REGION_POSITION_02',
  p_login_template=>7159710321739445 + wwv_flow_api.g_id_offset,
  p_default_button_template=>7160316886739448 + wwv_flow_api.g_id_offset,
  p_default_region_template=>7162404982739456 + wwv_flow_api.g_id_offset,
  p_default_chart_template =>7161921005739454 + wwv_flow_api.g_id_offset,
  p_default_form_template  =>7160632046739453 + wwv_flow_api.g_id_offset,
  p_default_reportr_template   =>7162404982739456 + wwv_flow_api.g_id_offset,
  p_default_tabform_template=>7162404982739456 + wwv_flow_api.g_id_offset,
  p_default_wizard_template=>7162020914739454 + wwv_flow_api.g_id_offset,
  p_default_menur_template=>7161006868739453 + wwv_flow_api.g_id_offset,
  p_default_listr_template=>7160721149739453 + wwv_flow_api.g_id_offset,
  p_default_irr_template=>null + wwv_flow_api.g_id_offset,
  p_default_report_template   =>7164205071739470 + wwv_flow_api.g_id_offset,
  p_default_label_template=>7165025252739475 + wwv_flow_api.g_id_offset,
  p_default_menu_template=>7165316006739479 + wwv_flow_api.g_id_offset,
  p_default_calendar_template=>7165831360739481 + wwv_flow_api.g_id_offset,
  p_default_list_template=>7163510605739462 + wwv_flow_api.g_id_offset,
  p_default_option_label=>7165025252739475 + wwv_flow_api.g_id_offset,
  p_default_header_template=>null + wwv_flow_api.g_id_offset,
  p_default_footer_template=>null + wwv_flow_api.g_id_offset,
  p_default_page_transition=>'NONE',
  p_default_popup_transition=>'NONE',
  p_default_required_label=>7165106605739475 + wwv_flow_api.g_id_offset);
end;
/
 
prompt  ...theme styles
--
 
begin
 
null;
 
end;
/

prompt  ...theme display points
--
 
begin
 
null;
 
end;
/

prompt  ...build options
--
 
begin
 
--application/shared_components/logic/build_options/disabled
wwv_flow_api.create_build_option (
  p_id=> 7840116691585255 + wwv_flow_api.g_id_offset,
  p_flow_id=> wwv_flow.g_flow_id,
  p_build_option_name=> 'DISABLED',
  p_build_option_status=> 'EXCLUDE',
  p_default_on_export=>'EXCLUDE',
  p_build_option_comment=> '');
 
end;
/

--application/shared_components/globalization/language
prompt  ...Language Maps for Application 102
--
 
begin
 
null;
 
end;
/

--application/shared_components/globalization/messages
prompt  ...text messages
--
prompt  ......Message xplz_ort_ungueltig
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'PLZ/Ort-Kombination ist ungültig!';

wwv_flow_api.create_message (
  p_id=>3530512167561367 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XPLZ_ORT_UNGUELTIG',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xplz_ort_ungueltig
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Postal Code and Name of Residence is not valid!';

wwv_flow_api.create_message (
  p_id=>3530914029571368 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XPLZ_ORT_UNGUELTIG',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xabbrechen
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Abbrechen';

wwv_flow_api.create_message (
  p_id=>3537805297663495 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XABBRECHEN',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xabbrechen
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Cancel';

wwv_flow_api.create_message (
  p_id=>3538218110667115 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XABBRECHEN',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xloeschen
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Löschen';

wwv_flow_api.create_message (
  p_id=>3538623305668712 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XLOESCHEN',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xloeschen
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Delete';

wwv_flow_api.create_message (
  p_id=>3539131616671096 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XLOESCHEN',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xspeichern
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Speichern';

wwv_flow_api.create_message (
  p_id=>3539503004672290 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XSPEICHERN',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xspeichern
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Save';

wwv_flow_api.create_message (
  p_id=>3539911315674618 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XSPEICHERN',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xaendern
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Änderung anwenden';

wwv_flow_api.create_message (
  p_id=>3540419280676970 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XAENDERN',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xaendern
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Save';

wwv_flow_api.create_message (
  p_id=>3540825514678731 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XAENDERN',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xerstellen
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Erstellen';

wwv_flow_api.create_message (
  p_id=>3541231054680339 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XERSTELLEN',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xerstellen
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Create';

wwv_flow_api.create_message (
  p_id=>3541602788681673 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XERSTELLEN',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xpasswort_chg
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Passwort ändern';

wwv_flow_api.create_message (
  p_id=>3542009368683543 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XPASSWORT_CHG',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xpasswort_chg
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Change password';

wwv_flow_api.create_message (
  p_id=>3542415255685273 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XPASSWORT_CHG',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xfeld_eingabepflichtig
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Wert muss angegeben werden.';

wwv_flow_api.create_message (
  p_id=>3551126964858959 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XFELD_EINGABEPFLICHTIG',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xfeld_eingabepflichtig
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Field is mandatory!';

wwv_flow_api.create_message (
  p_id=>3551504716871418 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XFELD_EINGABEPFLICHTIG',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xdatum_ungueltig
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Kein gültiges Datum!';

wwv_flow_api.create_message (
  p_id=>3611820297694253 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XDATUM_UNGUELTIG',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xdatum_ungueltig
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'It is not a valid date!';

wwv_flow_api.create_message (
  p_id=>3612201382698234 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XDATUM_UNGUELTIG',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xpasswortaenderung
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Passwortänderung';

wwv_flow_api.create_message (
  p_id=>3875301806128792 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XPASSWORTAENDERUNG',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xpasswortaenderung
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Change password';

wwv_flow_api.create_message (
  p_id=>3875709771131128 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XPASSWORTAENDERUNG',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xausdruck_keine_zahl
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Der Ausdruck %0 kann nicht in eine Zahl konvertiert werden! Fehler bei Frage: %1';

wwv_flow_api.create_message (
  p_id=>4097322402665710 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XAUSDRUCK_KEINE_ZAHL',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xausdruck_keine_zahl
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'%0 is not a numeric value! Error at question: %1';

wwv_flow_api.create_message (
  p_id=>4098323572675535 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XAUSDRUCK_KEINE_ZAHL',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xausdruck_kein_datum
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Der Ausdruck %0 kann nicht in ein Datum konvertiert werden! Fehler bei Frage: %1';

wwv_flow_api.create_message (
  p_id=>4112131911905017 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XAUSDRUCK_KEIN_DATUM',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xunbestimmter_fehler
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Unbestimmter Fehler (%0) in Prozedur %1.';

wwv_flow_api.create_message (
  p_id=>4112511610908560 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XUNBESTIMMTER_FEHLER',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xausdruck_kein_datum
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'%0 is not a valid date!  Error at question: %1';

wwv_flow_api.create_message (
  p_id=>4113509317917354 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XAUSDRUCK_KEIN_DATUM',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xunbestimmter_fehler
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Undefined error (%0) in procedure %1.';

wwv_flow_api.create_message (
  p_id=>4114414296928270 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XUNBESTIMMTER_FEHLER',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xunbekannter_anzeigetyp
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Interner Fehler: Der Anzeigetyp %0 wird beim Speichern noch nicht behandelt.';

wwv_flow_api.create_message (
  p_id=>4114810749946218 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XUNBEKANNTER_ANZEIGETYP',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xunbekannter_anzeigetyp
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Internal error: Field type %0 is unknown for saving process.';

wwv_flow_api.create_message (
  p_id=>4115212396965545 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XUNBEKANNTER_ANZEIGETYP',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xweiblich
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Weiblich';

wwv_flow_api.create_message (
  p_id=>4141505470586959 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XWEIBLICH',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xweiblich
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'female';

wwv_flow_api.create_message (
  p_id=>4141911357588593 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XWEIBLICH',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xmaennlich
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Männlich';

wwv_flow_api.create_message (
  p_id=>4147725144762917 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XMAENNLICH',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xmaennlich
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'male';

wwv_flow_api.create_message (
  p_id=>4148131031764590 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XMAENNLICH',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xherr
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Herr';

wwv_flow_api.create_message (
  p_id=>4151019088799078 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XHERR',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xherr
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Mr.';

wwv_flow_api.create_message (
  p_id=>4151426707801198 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XHERR',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xfrau
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Frau';

wwv_flow_api.create_message (
  p_id=>4151829824802150 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XFRAU',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xfrau
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Mrs.';

wwv_flow_api.create_message (
  p_id=>4152201211803298 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XFRAU',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xausdruck_null
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Keine Eingabe zur Frage: %0';

wwv_flow_api.create_message (
  p_id=>4184423660556873 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XAUSDRUCK_NULL',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xausdruck_null
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'No input for question: %0';

wwv_flow_api.create_message (
  p_id=>4184819982565282 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XAUSDRUCK_NULL',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xspeichern_seite_1
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Aktion verarbeitet. Wenn Sie die Sprache geändert haben, drücken Sie bitte den ''Aktualiseren'' - Button Ihres Browsers.';

wwv_flow_api.create_message (
  p_id=>4191521083485951 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XSPEICHERN_SEITE_1',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xspeichern_seite_1
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Successfully saved to Database. In case you changed the base language please press the ''RELOAD'' - Button of your browser.';

wwv_flow_api.create_message (
  p_id=>4248224159704215 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XSPEICHERN_SEITE_1',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xinfotext
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'Wenn Sie mit einer Bildschirmauflösung mit weniger als 850 Pixeln in der Vertikalen arbeiten, empfehlen wir die Verwendung des Vollbildmodus Ihres Bildschirmes.';

wwv_flow_api.create_message (
  p_id=>4352224587153532 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XINFOTEXT',
  p_message_language=>'de',
  p_message_text=>h);
null;
 
end;
/

prompt  ......Message xinfotext
declare
  h varchar2(32767) := null;
 
begin
 
h:=h||'If the vertical resolution of your screen is less than 850 we strongly recommend to use the fullscreen mode of your browser.';

wwv_flow_api.create_message (
  p_id=>4352619177161439 + wwv_flow_api.g_id_offset,
  p_flow_id=>wwv_flow.g_flow_id,
  p_name=>'XINFOTEXT',
  p_message_language=>'en',
  p_message_text=>h);
null;
 
end;
/

--application/shared_components/globalization/dyntranslations
prompt  ...dynamic translations
--
prompt  ...Shortcuts
--
--application/shared_components/user_interface/shortcuts/set_item_label
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'DECLARE'||unistr('\000a')||
'   v_sprache  NUMBER ; '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'  --v_sprache  := :p110_sprache_id;'||unistr('\000a')||
'  v_sprache := :fas_sprache_id; --frgbg_s.get_sprache_id(:APP_USER);'||unistr('\000a')||
'  if ''#CURRENT_ITEM_NAME#'' in (''P1_USER_ACCOUNT'',''P110_USER_ACCOUNT'','||unistr('\000a')||
'                               ''P132_USER_ACCOUNT'',''P111_USER_ACCOUNT'','||unistr('\000a')||
'                               ''P304_USER_ACCOUNT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(202,v_sprache));'||unistr('\000a')||
'  ';

c1:=c1||'elsif ''#CURRENT_ITEM_NAME#'' in (''P110_EMAIL'','||unistr('\000a')||
'                                  ''P132_EMAIL'',''P111_EMAIL'','||unistr('\000a')||
'                                  ''P304_EMAIL'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(203,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_ANREDE_ID'',''P110_ANREDE_ID'','||unistr('\000a')||
'                  ''P132_ANREDE_ID'',''P302_ANREDE_ID'',''P111_ANREDE_ID'','||unistr('\000a')||
'                  ''P304_ANREDE_ID'') then'||unistr('\000a')||
'     r';

c1:=c1||'eturn(frgbg_s.holen_uebersetzung(204,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_VORNAME'',''P110_VORNAME'','||unistr('\000a')||
'                  ''P145_FAS_VORNAME'',''P132_VORNAME'','||unistr('\000a')||
'                  ''P110_VORNAME_RECHNUNG'',''P110_VORNAME_LIEFERUNG'','||unistr('\000a')||
'                  ''P302_VORNAME'',''P111_VORNAME'',''P304_VORNAME'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(205,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_NAM';

c1:=c1||'E'',''P110_NAME'',''P145_FAS_NAME'','||unistr('\000a')||
'                  ''P132_NAME'',''P110_NAME_RECHNUNG'',''P110_NAME_LIEFERUNG'','||unistr('\000a')||
'                  ''P302_NAME'',''P111_NAME'',''P304_NAME'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(206,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_ADRESSZUSATZ'',''P110_ADRESSZUSATZ'','||unistr('\000a')||
'          ''P132_ADRESSZUSATZ'','||unistr('\000a')||
'          ''P110_ADRESSZUSATZ_RECHNUNG'',''P110_ADRESSZUSATZ_LIEFERUNG'','||unistr('\000a')||
'    ';

c1:=c1||'      ''P302_ADRESSZUSATZ'',''P111_ADRESSZUSATZ'',''P304_ADRESSZUSATZ'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(10368,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_STRASSE'',''P110_STRASSE'','||unistr('\000a')||
'          ''P132_STRASSE'',''P110_STRASSE_RECHNUNG'',''P110_STRASSE_LIEFERUNG'','||unistr('\000a')||
'          ''P302_STRASSE'',''P111_STRASSE'',''P304_STRASSE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(207,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRE';

c1:=c1||'NT_ITEM_NAME#'' in (''P1_NR'',''P110_NR'',''P132_NR'','||unistr('\000a')||
'           ''P110_NR_RECHNUNG'',''P110_NR_LIEFERUNG'','||unistr('\000a')||
'           ''P302_NR'',''P111_NR'',''P304_NR'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(208,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_PLZ'',''P110_PLZ'',''P132_PLZ'','||unistr('\000a')||
'           ''P110_PLZ_RECHNUNG'',''P110_PLZ_LIEFERUNG'','||unistr('\000a')||
'           ''P302_PLZ'',''P111_PLZ'',''P304_PLZ'') then'||unistr('\000a')||
'     return(frgbg_s.holen_ueb';

c1:=c1||'ersetzung(209,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_ORT'',''P110_ORT'',''P132_ORT'','||unistr('\000a')||
'           ''P110_ORT_RECHNUNG'',''P110_ORT_LIEFERUNG'','||unistr('\000a')||
'           ''P302_ORT'',''P111_ORT'',''P304_ORT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(210,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_LAND_ID'',''P110_LAND_ID'','||unistr('\000a')||
'               ''P132_LAND_ID'',''P110_LAND_RECHNUNG'',''P110_LAND_LIEFERUNG'','||unistr('\000a')||
'           ';

c1:=c1||'    ''P302_LAND_ID'',''P111_LAND_ID'',''P304_LAND_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(211,v_sprache));  '||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_GEBURTSDATUM'',''P110_GEBURTSDATUM'','||unistr('\000a')||
'               ''P132_GEBURTSDATUM'',''P111_GEBURTSDATUM'',''P304_GEBURTSDATUM'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(212,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_GESCHLECHT'',''P110_GESCHLECHT'','||unistr('\000a')||
'        ';

c1:=c1||'       ''P132_GESCHLECHT'',''P111_GESCHLECHT'',''P304_GESCHLECHT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(213,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_APP_SPRACHE_ID'',''P110_APP_SPRACHE_ID'','||unistr('\000a')||
'               ''P132_APP_SPRACHE_ID'',''P111_APP_SPRACHE_ID'','||unistr('\000a')||
'               ''P304_APP_SPRACHE_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_HRV';

c1:=c1||'_DATEI'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(5520,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_HRV_ZULETZT_GELADEN'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(5545,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_IDENT'',''P110_IDENT'','||unistr('\000a')||
'               ''P132_IDENT'',''P111_IDENT'',''P304_IDENT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1686,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' i';

c1:=c1||'n (''P1_BEMERKUNG'',''P110_BEMERKUNG'','||unistr('\000a')||
'               ''P132_BEMERKUNG'',''P111_BEMERKUNG'',''P304_BEMERKUNG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1689,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_TELEFON'',''P110_TELEFON'','||unistr('\000a')||
'               ''P132_TELEFON'',''P111_TELEFON'',''P304_TELEFON'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1687,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_FAX'',''P110_';

c1:=c1||'FAX'','||unistr('\000a')||
'               ''P132_FAX'',''P111_FAX'',''P304_FAX'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3527,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_URL'',''P110_URL'','||unistr('\000a')||
'               ''P132_URL'',''P111_URL'',''P304_URL'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3528,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_MOBILTELEFON'',''P110_MOBILTELEFON'','||unistr('\000a')||
'               ''P132_MOBILTELEFON'',''P111_MOB';

c1:=c1||'ILTELEFON'',''P304_MOBILTELEFON'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1688,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_GEWICHT'',''P110_GEWICHT'',''P304_GEWICHT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(2151,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_GROESSE'',''P110_GROESSE'',''P304_GROESSE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(2330,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAM';

c1:=c1||'E#'' = ''P102_PASSWORT'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(215,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P102_PASSWORT_WDH'' then         '||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(216,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P91_NAME'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(302,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P95_REZEPTREICHWEITE_NOSAVE'') then'||unistr('\000a')||
'     return(frgbg_s.h';

c1:=c1||'olen_uebersetzung(585,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P95_REZEPTKOSTEN_NOSAVE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3055,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P95_DRUCKOPTION_NOSAVE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1521,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P110_USER_ACCOUNT_EINGABE'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(202,v_sprache));';

c1:=c1||''||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P110_REZEPT_NR'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(518,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P110_HCK_MED_DRUCKPOS'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(2153,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P110_BETREUER'',''P111_BETREUER_DISP'','||unistr('\000a')||
'                                  ''P304_BETREUER'') then'||unistr('\000a')||
'     --return(frgbg_s.holen_uebersetzung(18';

c1:=c1||'54,v_sprache));'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3566,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P110_EMAIL_INTERN'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3767,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P110_GUTSCHEINSTATUS'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(4906,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P111_PROVISIONSSTATUS'') then'||unistr('\000a')||
'     return(frgbg_s.holen_';

c1:=c1||'uebersetzung(4876,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P130_SUCHNAME'',''P131_SUCHNAME'','||unistr('\000a')||
'                                  ''P133_SUCHNAME'',''P135_SUCHNAME'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(478,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P130_SUCHADRESSE'',''P131_SUCHADRESSE'','||unistr('\000a')||
'                                  ''P133_SUCHADRESSE'',''P135_SUCHADRESSE'') then'||unistr('\000a')||
'     return(frgbg_s.hol';

c1:=c1||'en_uebersetzung(479,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P130_SUCHZUSATZ'',''P131_SUCHZUSATZ'','||unistr('\000a')||
'                                  ''P133_SUCHZUSATZ'',''P135_SUCHZUSATZ'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1689,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P130_SUCH_PERSSTAMM_ID'', '||unistr('\000a')||
'                                  ''P131_SUCH_PERSSTAMM_ID'','||unistr('\000a')||
'                                  ''P133_SU';

c1:=c1||'CH_PERSSTAMM_ID'','||unistr('\000a')||
'                                  ''P135_SUCH_PERSSTAMM_ID'' ) then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3481,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P130_SUCH_PIS_ID'',''P131_SUCH_PIS_ID'','||unistr('\000a')||
'                                  ''P133_SUCH_PIS_ID'',''P135_SUCH_GUS_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3480,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P130_SUCHREZEPT_';

c1:=c1||'NR'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1690,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P130_SUCHREZEPTBEMERKUNG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1689,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P130_IDENTITAET'',''P136_IDENTITAET'','||unistr('\000a')||
'                                  ''P111_PERSSTAMM_ID_IDENTITAET'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3101,v_sprache));'||unistr('\000a')||
'  elsif ''#';

c1:=c1||'CURRENT_ITEM_NAME#'' in (''P130_SUCHART'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3477,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_ADRESSE_ZEILE1'','||unistr('\000a')||
'                                  ''P111_ADRESSE_ZEILE1'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1588,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_ADRESSE_ZEILE2'','||unistr('\000a')||
'                                  ''P111_ADRESSE_ZEILE2'') then'||unistr('\000a')||
'   ';

c1:=c1||'  return(frgbg_s.holen_uebersetzung(1589,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_ADRESSE_ZEILE3'','||unistr('\000a')||
'                                  ''P111_ADRESSE_ZEILE3'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1590,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_ADRESSE_ZEILE4'','||unistr('\000a')||
'                                  ''P111_ADRESSE_ZEILE4'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1591,v_sprac';

c1:=c1||'he));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_DRUCKART'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(2310,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_ETIKETTENTYP'',''P215_ETIKETTENTYP'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1522,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_ETIKETTENANZAHL'','||unistr('\000a')||
'                                  ''P215_ETIKETTENANZAHL'') then'||unistr('\000a')||
'     return(frgbg_s.hol';

c1:=c1||'en_uebersetzung(1551,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_PROD_AUFTRAG_ANZAHL'','||unistr('\000a')||
'                                  ''P215_PROD_AUFTRAG_ANZAHL'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1552,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_ZUSATZFORMULAR_ANZAHL'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1813,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_HCK_MED_DRUCKE';

c1:=c1||'R'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3109,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_DOKUMENTENDRUCKER'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3108,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_ETIKETTENDRUCKER'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3107,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_HCK_MED_SCHACHT'', '||unistr('\000a')||
'                                ';

c1:=c1||'  ''P132_DOKUMENTENSCHACHT'','||unistr('\000a')||
'                                  ''P132_ETIKETTENSCHACHT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3105,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_MAX_SCREEN_HEIGHT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1594,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_VERRECHNUNGSLAND'','||unistr('\000a')||
'                                  ''P140_VERRECHNUNGSLAND'','||unistr('\000a')||
'           ';

c1:=c1||'                       ''P201_VERRECHNUNGSLAND'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1855,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_PREISFAKTOR'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3532,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_PRODUZIERENDE_APOTHEKE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3111,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P132_LOGO'') ';

c1:=c1||'then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3106,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P134_DATEINAME'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(2252,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P140_TOGGLE_REZEPTART'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1834,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P140_MN_REZART_ID'',''P201_MN_REZART_ID'') then'||unistr('\000a')||
'     return(frgbg_s.hol';

c1:=c1||'en_uebersetzung(9184,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P140_TOGGLE_MNR_VORSCHRIFT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(2487,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P145_BEZEICHNUNG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(516,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P150_SUCH_TEXT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(626,v_sprache));'||unistr('\000a')||
'  elsif ''#CU';

c1:=c1||'RRENT_ITEM_NAME#'' in (''P150_SUCH_SPRACHE_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(629,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P150_SUCH_TSTATUS_ID'',''P150_TSTATUS_IDS_ZIEL'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(627,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P150_SUCH_UEB_SPRACHE_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(628,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME';

c1:=c1||'#'' in (''P150_SUCH_TEXTKATEGORIE_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(630,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P150_ANZ_TEXTE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(631,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P151_SPRACHE_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P151_TEXT'') then'||unistr('\000a')||
'     return(frgbg_s.hol';

c1:=c1||'en_uebersetzung(3698,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P151_TSTATUS_ID'',''P152_TSTATUS_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3699,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_BEMERKUNG'',''P140_BEMERKUNG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(5396,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_ZUSATZBEMERKUNG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(';

c1:=c1||'5397,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_REZEPT_NR_VRS_DISP'','||unistr('\000a')||
'                                  ''P202_REZEPT_NR_VRS_DISP'','||unistr('\000a')||
'                                  ''P215_REZEPT_NR_VRS_DISP'','||unistr('\000a')||
'                                  ''P203_REZEPT_NR'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(518,v_sprache));'||unistr('\000a')||
'  --elsif ''#CURRENT_ITEM_NAME#'' in (''P201_VERSION'',''P202_VERSION'') then'||unistr('\000a')||
'  --   return(';

c1:=c1||'frgbg_s.holen_uebersetzung(519,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_AKT_VERSION_J_N'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(514,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_MNR_VORSCHRIFT_J_N'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(2487,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_REZEPTHINWEIS'','||unistr('\000a')||
'                                  ''P140_REZEPTHINWEIS_EING';

c1:=c1||'ABE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(635,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_ARZT_REZEPT'',''P140_ARZT_REZEPT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(636,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_ARZT_REZEPT_GUELTIG_BIS'','||unistr('\000a')||
'                                  ''P140_ARZT_REZEPT_GUELTIG_BIS'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(637,v_sprache));'||unistr('\000a')||
'  elsi';

c1:=c1||'f ''#CURRENT_ITEM_NAME#'' in (''P201_TAGESMENGE_G'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1836,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_TAGESMENGE_KAPS'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1837,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P201_REICHWEITE'',''P202_REICHWEITE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(585,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P2';

c1:=c1||'02_GESAMTPREIS'',''P201_GESAMTPREIS'','||unistr('\000a')||
'                                  ''P215_GESAMTPREIS'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1835,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = (''P202_ABWEICHUNG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(586,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P202_GESAMTGEWICHT'',''P201_GESAMTGEWICHT'','||unistr('\000a')||
'                                  ''P215_GESAMTGEWICHT'') th';

c1:=c1||'en'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1575,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P202_GESAMTVOLUMEN'',''P201_GESAMTVOLUMEN'','||unistr('\000a')||
'                                  ''P215_GESAMTVOLUMEN'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1576,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P202_GESAMTPREIS'',''P201_GESAMTPREIS'','||unistr('\000a')||
'                                  ''P215_GESAMTPREIS'') then'||unistr('\000a')||
'     return(f';

c1:=c1||'rgbg_s.holen_uebersetzung(1576,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P202_HCK_PREIS'',''P201_HCK_PREIS'','||unistr('\000a')||
'                                  ''P215_HCK_PREIS'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3498,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P215_BESTELLDATUM'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(5442,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P215_NAME'','||unistr('\000a')||
'         ';

c1:=c1||'                         ''P300_NAME'',''P305_NAME'','||unistr('\000a')||
'                                  ''P500_NAME'',''P505_NAME'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(482,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P215_PROD_PROBEDRUCKEN'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(741,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P215_PRODUKTIONSAUFTRAG_LABEL'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzun';

c1:=c1||'g(1572,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P215_ETIDRUCKEN'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(552,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P215_PLANDATUM'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1894,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P215_PERSSTAMM_ID_PROD_APO'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3111,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAM';

c1:=c1||'E#'' in (''P260_STICHTAG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(4917,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P260_PROVISIONSKOPF_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(4918,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P300_PATIENTADRESSE'''||unistr('\000a')||
'                                 ,''P308_PATIENTADRESSE'' '||unistr('\000a')||
'                                 ,''P508_PATIENTADRESSE'' '||unistr('\000a')||
'                     ';

c1:=c1||'            ,''P500_PATIENTADRESSE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(5521,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P300_LIEFERADRESSE'''||unistr('\000a')||
'                                 ,''P308_LIEFERADRESSE''                                    '||unistr('\000a')||
'                                 ,''P508_LIEFERADRESSE''                                    '||unistr('\000a')||
'                                 ,''P500_LIEFERADRESSE'') then'||unistr('\000a')||
'    ';

c1:=c1||' return(frgbg_s.holen_uebersetzung(3114,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P300_RECHNUNGSADRESSE'''||unistr('\000a')||
'                                 ,''P308_RECHNUNGSADRESSE'''||unistr('\000a')||
'                                 ,''P508_RECHNUNGSADRESSE'''||unistr('\000a')||
'                                 ,''P500_RECHNUNGSADRESSE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3113,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P300_PERSSTAMM_PR';

c1:=c1||'OD_APO_BEZ'''||unistr('\000a')||
'                                 ,''P308_PERSSTAMM_PROD_APO_BEZ'''||unistr('\000a')||
'                                 ,''P508_PERSSTAMM_PROD_APO_BEZ'''||unistr('\000a')||
'                                 ,''P500_PERSSTAMM_PROD_APO_BEZ'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3115,v_sprache));'||unistr('\000a')||
'/*  elsif ''#CURRENT_ITEM_NAME#'' in (''P300_WAEHRUNG_TOGGLE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3116,v_sprache));*/'||unistr('\000a')||
'  elsif ''';

c1:=c1||'#CURRENT_ITEM_NAME#'' in (''P300_PERSSTAMM_ID_RECHSTELLER'','||unistr('\000a')||
'                                  ''P308_PERSSTAMM_ID_RECHSTELLER'','||unistr('\000a')||
'                                  ''P508_PERSSTAMM_ID_RECHSTELLER'','||unistr('\000a')||
'                                  ''P500_PERSSTAMM_ID_RECHSTELLER'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(5067,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P300_WK_VERSANDART_ID'','||unistr('\000a')||
'                    ';

c1:=c1||'              ''P308_WK_VERSANDART_ID'','||unistr('\000a')||
'                                  ''P508_WK_VERSANDART_ID'','||unistr('\000a')||
'                                  ''P321_WK_VERSANDART_ID'','||unistr('\000a')||
'                                  ''P500_WK_VERSANDART_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(5573,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P300_VERSANDKOSTEN'','||unistr('\000a')||
'                                  ''P308_VERSANDKOSTEN'','||unistr('\000a')||
'          ';

c1:=c1||'                        ''P305_VERSANDKOSTEN'','||unistr('\000a')||
'                                  ''P508_VERSANDKOSTEN'','||unistr('\000a')||
'                                  ''P500_VERSANDKOSTEN'','||unistr('\000a')||
'                                  ''P505_VERSANDKOSTEN'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(4319,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P300_GESAMT_MWST_BETRAG'','||unistr('\000a')||
'                                  ''P308_GESAMT_MWST_BETRAG'','||unistr('\000a')||
'  ';

c1:=c1||'                                ''P305_GESAMT_MWST_BETRAG'','||unistr('\000a')||
'                                  ''P508_GESAMT_MWST_BETRAG'','||unistr('\000a')||
'                                  ''P500_GESAMT_MWST_BETRAG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(4356,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P300_GESAMTWERT'','||unistr('\000a')||
'                                  ''P308_GESAMTWERT'','||unistr('\000a')||
'                                  ''P305_GESAMTWERT''';

c1:=c1||','||unistr('\000a')||
'                                  ''P508_GESAMTWERT'','||unistr('\000a')||
'                                  ''P500_GESAMTWERT'','||unistr('\000a')||
'                                  ''P505_GESAMTWERT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1835,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P301_SUCHBEDINGUNG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(626,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P305_ZAHLUNGSART'''||unistr('\000a')||
'       ';

c1:=c1||'                           ,''P308_ZAHLUNGSART'''||unistr('\000a')||
'                                  ,''P505_ZAHLUNGSART'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(4395,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P351_ART_ID'',''P355_ART_ID'',''P401_ART_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3566,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P351_BEZEICHNUNG'',''P355_BEZEICHNUNG'') then'||unistr('\000a')||
'     return(frgbg_s';

c1:=c1||'.holen_uebersetzung(516,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P351_SPRACHE_ID'',''P355_SPRACHE_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P351_TYP_ID'',''P355_TYP_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3566,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P351_ID'',''P355_ID'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(3555,v_';

c1:=c1||'sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P351_BEMERKUNG'',''P355_BEMERKUNG'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(1689,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P401_PERSSTAMM_ID_WAHLIDENT'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(8009,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P1_FKAT_MODULE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(9123,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT';

c1:=c1||'_ITEM_NAME#'' in (''P215_DOSENANZAHL'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(9476,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P401_IDENT_SUCHE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(481,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P136_IDENT_SUCHE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(11617,v_sprache));	'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P401_FRANKIERUNG_IMAGE'') then'||unistr('\000a')||
'   ';

c1:=c1||'  return(frgbg_s.holen_uebersetzung(10381,v_sprache));'||unistr('\000a')||
'  elsif  ''#CURRENT_ITEM_NAME#'' in (''P401_ANZ_DATENSAETZE'') then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(10393,v_sprache));'||unistr('\000a')||
'  elsif  ''#CURRENT_ITEM_NAME#'' in (''P150_SPRACHE_ID_VON'',''P152_SPRACHE_VON'') then '||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(11569,v_sprache)); -- Von'||unistr('\000a')||
'  elsif  ''#CURRENT_ITEM_NAME#'' in (''P150_SPRACHE_ID_NACH'',''P152_SPRACHE_NAC';

c1:=c1||'H'') then '||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(11568,v_sprache)); -- Auf'||unistr('\000a')||
'  elsif  ''#CURRENT_ITEM_NAME#'' in (''P150_DOKUMENTTYP_IDS'',''P152_DOKUMENTTYP'') then '||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(11570,v_sprache)); '||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P152_BASIS_EDITOR_TEXT'',''P152_BASIS_EDITOR_HTML'','||unistr('\000a')||
'         ''P152_BASIS_DOWNLOAD_FILE,'') THEN'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(11573,v_sprache';

c1:=c1||')); '||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P152_EDITOR_TEXT'',''P152_EDITOR_HTML'',''P152_EDITOR_FILE'') THEN'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(11574,v_sprache)); '||unistr('\000a')||
''||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' in (''P152_TEXT_ID_DISPLAY'') THEN'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(11575,v_sprache)); '||unistr('\000a')||
'  ELSE  -- Fehler Feld unbekannt'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(217,v_sprache));'||unistr('\000a')||
'  end if; '||unistr('\000a')||
'END;';

wwv_flow_api.create_shortcut (
 p_id=> 3092504352275959 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'SET_ITEM_LABEL',
 p_shortcut_type=> 'FUNCTION_BODY',
 p_shortcut=> c1);
end;
null;
 
end;
/

--application/shared_components/user_interface/shortcuts/set_item_label_login_anonym
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'DECLARE'||unistr('\000a')||
'   v_sprache  NUMBER ; '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'  SELECT sprache_id into :p101_sprache_id '||unistr('\000a')||
'  FROM app_sprachen'||unistr('\000a')||
'  WHERE id = :p101_app_sprache_id;'||unistr('\000a')||
'*/'||unistr('\000a')||
'  v_sprache  := :p123_sprache_id;'||unistr('\000a')||
'  if ''#CURRENT_ITEM_NAME#'' = ''P123_APP_SPRACHE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  ELSE  -- Fehler Feld unbekannt'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(217,v_sprache));'||unistr('\000a')||
'  end if; '||unistr('\000a')||
'END;';

wwv_flow_api.create_shortcut (
 p_id=> 3593001007805799 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'SET_ITEM_LABEL_LOGIN_ANONYM',
 p_shortcut_type=> 'FUNCTION_BODY',
 p_shortcut=> c1);
end;
null;
 
end;
/

--application/shared_components/user_interface/shortcuts/set_item_label_login_kunde
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'DECLARE'||unistr('\000a')||
'   v_sprache  NUMBER ; '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'  SELECT sprache_id into :p101_sprache_id '||unistr('\000a')||
'  FROM app_sprachen'||unistr('\000a')||
'  WHERE id = :p101_app_sprache_id;'||unistr('\000a')||
'*/'||unistr('\000a')||
'  v_sprache  := :p124_sprache_id;'||unistr('\000a')||
'  if ''#CURRENT_ITEM_NAME#'' = ''P124_USERNAME'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(202,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P124_PASSWORD'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(215,v_sprache));'||unistr('\000a')||
'  elsif ''';

c1:=c1||'#CURRENT_ITEM_NAME#'' = ''P124_APP_SPRACHE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_USER_ACCOUNT'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(202,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_EMAIL'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(203,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_ANREDE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.h';

c1:=c1||'olen_uebersetzung(204,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_NAME'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(206,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_VORNAME'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(205,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_STRASSE'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(207,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_NR'' th';

c1:=c1||'en'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(208,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_PLZ'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(209,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_ORT'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(210,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_LAND_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(211,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NA';

c1:=c1||'ME#'' = ''P105_APP_SPRACHE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_EMAIL'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(203,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P104_KUNDENNUMMER'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(436,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P104_EMAIL'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(20';

c1:=c1||'3,v_sprache));'||unistr('\000a')||
'  ELSE  -- Fehler Feld unbekannt'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(217,v_sprache));'||unistr('\000a')||
'  end if; '||unistr('\000a')||
'END;';

wwv_flow_api.create_shortcut (
 p_id=> 3635106622938852 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'SET_ITEM_LABEL_LOGIN_KUNDE',
 p_shortcut_type=> 'FUNCTION_BODY',
 p_shortcut=> c1);
end;
null;
 
end;
/

--application/shared_components/user_interface/shortcuts/set_item_label_login
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'DECLARE'||unistr('\000a')||
'   v_sprache  NUMBER ; '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'  SELECT sprache_id into :p101_sprache_id '||unistr('\000a')||
'  FROM app_sprachen'||unistr('\000a')||
'  WHERE id = :p101_app_sprache_id;'||unistr('\000a')||
'*/'||unistr('\000a')||
'  v_sprache  := :p101_sprache_id;'||unistr('\000a')||
'  if ''#CURRENT_ITEM_NAME#'' = ''P101_USERNAME'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(202,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P101_PASSWORD'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(215,v_sprache));'||unistr('\000a')||
'  elsif ''';

c1:=c1||'#CURRENT_ITEM_NAME#'' = ''P101_APP_SPRACHE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_USER_ACCOUNT'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(202,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_EMAIL'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(203,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_ANREDE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.h';

c1:=c1||'olen_uebersetzung(204,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_NAME'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(206,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_VORNAME'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(205,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_STRASSE'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(207,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_NR'' th';

c1:=c1||'en'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(208,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_PLZ'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(209,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_ORT'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(210,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_LAND_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(211,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NA';

c1:=c1||'ME#'' = ''P105_APP_SPRACHE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P105_EMAIL'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(203,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P104_KUNDENNUMMER'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(436,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P104_EMAIL'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(20';

c1:=c1||'3,v_sprache));'||unistr('\000a')||
'  ELSE  -- Fehler Feld unbekannt'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(217,v_sprache));'||unistr('\000a')||
'  end if; '||unistr('\000a')||
'END;';

wwv_flow_api.create_shortcut (
 p_id=> 3917918248722376 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'SET_ITEM_LABEL_LOGIN',
 p_shortcut_type=> 'FUNCTION_BODY',
 p_shortcut=> c1);
end;
null;
 
end;
/

--application/shared_components/user_interface/shortcuts/set_item_label_login_betreuer
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'DECLARE'||unistr('\000a')||
'   v_prot_id  number;'||unistr('\000a')||
'   v_sprache  NUMBER ; '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*MEL.P (''a short betreuer button_labels_setzen :%1,%2'',v_prot_id,''Fehler'',''SET_ITEM_LABEL_LOGIN_BETREUER'','||unistr('\000a')||
'           to_char(:p121_app_sprache_id),:p121_sprache_id'||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'     SELECT sprache_id into :p121_sprache_id '||unistr('\000a')||
'     FROM app_sprachen'||unistr('\000a')||
'     WHERE id = :p121_app_sprache_id;'||unistr('\000a')||
'*/'||unistr('\000a')||
'/*'||unistr('\000a')||
'MEL.P (''b short button_labels_setzen :%1,';

c1:=c1||'%2,%3'',v_prot_id,''Fehler'',''SET_ITEM_LABEL_LOGIN_BETREUER'','||unistr('\000a')||
'           to_char(:p121_app_sprache_id),:p121_sprache_id,''#CURRENT_ITEM_NAME#'''||unistr('\000a')||
'          );'||unistr('\000a')||
'*/'||unistr('\000a')||
''||unistr('\000a')||
'  v_sprache  := :p121_sprache_id;'||unistr('\000a')||
'  if ''#CURRENT_ITEM_NAME#'' = ''P121_USERNAME'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(202,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P121_PASSWORD'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(215,v_sprach';

c1:=c1||'e));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P121_APP_SPRACHE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  ELSE  -- Fehler Feld unbekannt'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(217,v_sprache));'||unistr('\000a')||
'  end if; '||unistr('\000a')||
'END;';

wwv_flow_api.create_shortcut (
 p_id=> 4503623262524007 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'SET_ITEM_LABEL_LOGIN_BETREUER',
 p_shortcut_type=> 'FUNCTION_BODY',
 p_shortcut=> c1);
end;
null;
 
end;
/

--application/shared_components/user_interface/shortcuts/set_item_label_login_verteiler
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'DECLARE'||unistr('\000a')||
'   v_sprache  NUMBER ; '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'/*'||unistr('\000a')||
'  SELECT sprache_id into :p100_sprache_id '||unistr('\000a')||
'  FROM app_sprachen'||unistr('\000a')||
'  WHERE id = :p100_app_sprache_id;'||unistr('\000a')||
'*/'||unistr('\000a')||
'  v_sprache  := :p100_sprache_id;'||unistr('\000a')||
'  if ''#CURRENT_ITEM_NAME#'' = ''P100_APP_SPRACHE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  ELSE  -- Fehler Feld unbekannt'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(217,v_sprache));'||unistr('\000a')||
'  end if; '||unistr('\000a')||
'END;';

wwv_flow_api.create_shortcut (
 p_id=> 4770425745928596 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'SET_ITEM_LABEL_LOGIN_VERTEILER',
 p_shortcut_type=> 'FUNCTION_BODY',
 p_shortcut=> c1);
end;
null;
 
end;
/

--application/shared_components/user_interface/shortcuts/set_item_label_champ_p352
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'DECLARE'||unistr('\000a')||
'   v_sprache  NUMBER ; '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   return(frgbg_t.SB_CHANGE_CHAMP_LABEL(''#CURRENT_ITEM_NAME#'','||unistr('\000a')||
'          :P352_CHAMP_LABELS));'||unistr('\000a')||
'END;';

wwv_flow_api.create_shortcut (
 p_id=> 5516603200474916 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'SET_ITEM_LABEL_CHAMP_P352',
 p_shortcut_type=> 'FUNCTION_BODY',
 p_shortcut=> c1);
end;
null;
 
end;
/

--application/shared_components/user_interface/shortcuts/ok_to_get_next_prev_pk_value
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'Möchten Sie diese Seite wirklich verlassen, ohne die Änderungen zu speichern?';

wwv_flow_api.create_shortcut (
 p_id=> 6846214185120407 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'OK_TO_GET_NEXT_PREV_PK_VALUE',
 p_shortcut_type=> 'TEXT_ESCAPE_JS',
 p_shortcut=> c1);
end;
null;
 
end;
/

--application/shared_components/user_interface/shortcuts/delete_confirm_msg
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'Soll dieser Löschvorgang ausgeführt werden?';

wwv_flow_api.create_shortcut (
 p_id=> 7168532037739585 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'DELETE_CONFIRM_MSG',
 p_shortcut_type=> 'TEXT_ESCAPE_JS',
 p_shortcut=> c1);
end;
null;
 
end;
/

--application/shared_components/user_interface/shortcuts/set_item_label_login_uebersetzer
 
begin
 
declare
  c1 varchar2(32767) := null;
  l_clob clob;
  l_length number := 1;
begin
c1:=c1||'DECLARE'||unistr('\000a')||
'   v_sprache  NUMBER ; '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'/*'||unistr('\000a')||
'  SELECT sprache_id into :p122_sprache_id '||unistr('\000a')||
'  FROM app_sprachen'||unistr('\000a')||
'  WHERE id = :p122_app_sprache_id;'||unistr('\000a')||
'*/'||unistr('\000a')||
'  v_sprache  := :p122_sprache_id;'||unistr('\000a')||
'  if ''#CURRENT_ITEM_NAME#'' = ''P122_USERNAME'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(202,v_sprache));'||unistr('\000a')||
'  elsif ''#CURRENT_ITEM_NAME#'' = ''P122_PASSWORD'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(215,v_sprache));'||unistr('\000a')||
'  elsif ';

c1:=c1||'''#CURRENT_ITEM_NAME#'' = ''P122_APP_SPRACHE_ID'' then'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(214,v_sprache));'||unistr('\000a')||
'  ELSE  -- Fehler Feld unbekannt'||unistr('\000a')||
'     return(frgbg_s.holen_uebersetzung(217,v_sprache));'||unistr('\000a')||
'  end if; '||unistr('\000a')||
'END;';

wwv_flow_api.create_shortcut (
 p_id=> 8721320936517590 + wwv_flow_api.g_id_offset,
 p_flow_id=> wwv_flow.g_flow_id,
 p_shortcut_name=> 'SET_ITEM_LABEL_LOGIN_UEBERSETZER',
 p_shortcut_type=> 'FUNCTION_BODY',
 p_shortcut=> c1);
end;
null;
 
end;
/

prompt  ...web services (9iR2 or better)
--
prompt  ...shared queries
--
prompt  ...report layouts
--
prompt  ...authentication schemes
--
--application/shared_components/security/authentication/auth_frgbg
prompt  ......authentication 4256129844199370
 
begin
 
wwv_flow_api.create_authentication (
  p_id => 4256129844199370 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'AUTH_FRGBG'
 ,p_scheme_type => 'NATIVE_CUSTOM'
 ,p_attribute_03 => 'frgbg_s.valid_user'
 ,p_attribute_05 => 'N'
 ,p_invalid_session_type => 'URL'
 ,p_invalid_session_url => 'f?p=&APP_ID.:100:&SESSION.'
 ,p_logout_url => 'f?p=&APP_ID.:100'
 ,p_use_secure_cookie_yn => 'N'
  );
null;
 
end;
/

--application/shared_components/security/authentication/html_db
prompt  ......authentication 7166223770739495
 
begin
 
wwv_flow_api.create_authentication (
  p_id => 7166223770739495 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'HTML DB'
 ,p_scheme_type => 'NATIVE_APEX_ACCOUNTS'
 ,p_attribute_15 => '7166223770739495'
 ,p_invalid_session_type => 'LOGIN'
 ,p_logout_url => 'f?p=&APP_ID.:1'
 ,p_use_secure_cookie_yn => 'N'
 ,p_comments => 'ID-Daten von internem Application Express Account und Anmeldeseite in dieser Anwendung verwenden.'
  );
null;
 
end;
/

--application/shared_components/security/authentication/database
prompt  ......authentication 7166330249739495
 
begin
 
wwv_flow_api.create_authentication (
  p_id => 7166330249739495 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'DATABASE'
 ,p_scheme_type => 'NATIVE_DAD'
 ,p_attribute_15 => '7166330249739495'
 ,p_invalid_session_type => 'LOGIN'
 ,p_use_secure_cookie_yn => 'N'
 ,p_comments => 'Datenbank-Authentifizierung verwenden (Benutzer von DAD identifiziert).'
  );
null;
 
end;
/

--application/shared_components/security/authentication/database_account
prompt  ......authentication 7166432467739495
 
begin
 
wwv_flow_api.create_authentication (
  p_id => 7166432467739495 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_name => 'DATABASE ACCOUNT'
 ,p_scheme_type => 'NATIVE_DB_ACCOUNTS'
 ,p_attribute_15 => '7166432467739495'
 ,p_invalid_session_type => 'LOGIN'
 ,p_logout_url => 'f?p=&APP_ID.:1'
 ,p_use_secure_cookie_yn => 'N'
 ,p_comments => 'Verwenden Sie Datenbank-Account-ID-Daten.'
  );
null;
 
end;
/

prompt  ...ui types
--
 
begin
 
null;
 
end;
/

prompt  ...plugins
--
--application/shared_components/plugins/region_type/dinh_de_treetable
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 5800313176995941 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'REGION TYPE'
 ,p_name => 'DINH.DE.TREETABLE'
 ,p_display_name => 'DTreeTable'
 ,p_supported_ui_types => 'DESKTOP'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'/***************************************************************************************************'||unistr('\000a')||
' * DTreeTable ApEx Plugin puts hierarchical data in columns, but use an indented outline structure'||unistr('\000a')||
' * in the first column to illustrate the tree structure.'||unistr('\000a')||
' *'||unistr('\000a')||
' * Author: Linh Dinh (linh@dinh.de)'||unistr('\000a')||
' * URL: http://www.dinh.de'||unistr('\000a')||
' * Created On: 2010-11-06'||unistr('\000a')||
' * Version: 0.9 (2010-11-06)'||unistr('\000a')||
' * CHANGED:     (2012-'||
'03-07) NEI Tabellenelemente rechtsbuendig ausrichten'||unistr('\000a')||
' '||unistr('\000a')||
' * This Plugin is dual licensed under the MIT and GPL licenses:'||unistr('\000a')||
' * http://www.opensource.org/licenses/mit-license.php'||unistr('\000a')||
' * http://www.gnu.org/licenses/gpl.html'||unistr('\000a')||
' **************************************************************************************************/'||unistr('\000a')||
''||unistr('\000a')||
'FUNCTION render_dtreetable('||unistr('\000a')||
'    p_region              IN apex_plugin.t_region,'||unistr('\000a')||
'    p_'||
'plugin              IN apex_plugin.t_plugin,'||unistr('\000a')||
'    p_is_printer_friendly IN BOOLEAN )'||unistr('\000a')||
'  RETURN apex_plugin.t_region_render_result'||unistr('\000a')||
'IS'||unistr('\000a')||
'  l_col_header htmldb_application_global.vc_arr2;'||unistr('\000a')||
'  l_value_list apex_plugin_util.t_column_value_list;'||unistr('\000a')||
'  v_indenting INTEGER;'||unistr('\000a')||
'  v_width_1 INTEGER;'||unistr('\000a')||
'  v_expand CHAR(1);'||unistr('\000a')||
'  v_level_1 INTEGER;'||unistr('\000a')||
'  v_level_tmp INTEGER;'||unistr('\000a')||
'  v_class_display VARCHAR(30);'||unistr('\000a')||
'  v_class_leaf VARCHAR(30);'||
''||unistr('\000a')||
'  v_version VARCHAR2(10) := ''''; --0.9'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'  v_indenting := p_region.attribute_01;'||unistr('\000a')||
'  l_col_header := htmldb_util.string_to_table(p_region.attribute_02, '':'');'||unistr('\000a')||
'  v_expand := p_region.attribute_03;'||unistr('\000a')||
'  v_width_1 := p_region.attribute_04;'||unistr('\000a')||
'  '||unistr('\000a')||
'  '||unistr('\000a')||
'  APEX_PLUGIN_UTIL.DEBUG_REGION ( '||unistr('\000a')||
'    p_plugin, '||unistr('\000a')||
'    p_region'||unistr('\000a')||
'  );'||unistr('\000a')||
'  '||unistr('\000a')||
'  -- Assign javascript file'||unistr('\000a')||
'  apex_javascript.add_library ('||unistr('\000a')||
'    p_name      => ''dtt'','||unistr('\000a')||
'  '||
'  p_directory => p_plugin.file_prefix,'||unistr('\000a')||
'    p_version   => v_version'||unistr('\000a')||
'  );'||unistr('\000a')||
'    '||unistr('\000a')||
'  -- Assign css file'||unistr('\000a')||
'  apex_css.add_file ( '||unistr('\000a')||
'    p_name => ''dtt_style'', '||unistr('\000a')||
'    p_directory => p_plugin.file_prefix, '||unistr('\000a')||
'    p_version => v_version'||unistr('\000a')||
'  );'||unistr('\000a')||
'  '||unistr('\000a')||
'  -- Get resultset from query'||unistr('\000a')||
'  l_value_list := apex_plugin_util.get_data ( '||unistr('\000a')||
'    p_sql_statement => p_region.source, '||unistr('\000a')||
'    p_min_columns => 2, '||unistr('\000a')||
'    p_max_columns => 50, '||unistr('\000a')||
'    '||
'p_component_name => p_region.name '||unistr('\000a')||
'  );'||unistr('\000a')||
'  '||unistr('\000a')||
'  -- Set level value for the first node'||unistr('\000a')||
'  v_level_1 := l_value_list(1)(1);'||unistr('\000a')||
'  '||unistr('\000a')||
'  -- Start print table'||unistr('\000a')||
'  sys.htp.p(''<table id="dtt_'' '||unistr('\000a')||
'    || p_region.id '||unistr('\000a')||
'    || ''_table" class="dtt_table">'''||unistr('\000a')||
'  );'||unistr('\000a')||
'  '||unistr('\000a')||
'  -- Start print thead'||unistr('\000a')||
'  IF (l_col_header.COUNT > 0) THEN'||unistr('\000a')||
'	  sys.htp.p(''<thead class="dtt_thead">'');'||unistr('\000a')||
'	  sys.htp.p(''<tr class="dtt_head_tr">'');'||unistr('\000a')||
'	  '||unistr('\000a')||
'    	  sys.htp'||
'.p(''<th class="dtt_head_td" align="left">'' || l_col_header(1) || ''</th>'');  -- NEI 07.03.2012 neu'||unistr('\000a')||
''||unistr('\000a')||
'	  FOR i IN 2 .. l_col_header.COUNT LOOP'||unistr('\000a')||
'	  	--sys.htp.p(''<th class="dtt_head_td">'' || l_col_header(i) || ''</th>'');       -- NEI 07.03.2012'||unistr('\000a')||
'	  	sys.htp.p(''<th class="dtt_head_td" align="right">'' || l_col_header(i) || ''</th>'');'||unistr('\000a')||
'	  END LOOP;'||unistr('\000a')||
'	  '||unistr('\000a')||
'	  sys.htp.p(''</tr>'');'||unistr('\000a')||
'	  sys.htp.p(''</thead>'');'||unistr('\000a')||
'  END IF'||
';'||unistr('\000a')||
'  '||unistr('\000a')||
'  -- Start print for tbody'||unistr('\000a')||
'  sys.htp.p(''<tbody id="dtt_'' '||unistr('\000a')||
'    || p_region.id '||unistr('\000a')||
'    || ''_tbody" class="dtt_tbody">'');'||unistr('\000a')||
'    '||unistr('\000a')||
'  FOR i IN 1 .. l_value_list(1).count'||unistr('\000a')||
'  LOOP'||unistr('\000a')||
'    -- Check wheather the settings are collapsed or expanded on start up'||unistr('\000a')||
'    IF i <= l_value_list(1).count THEN'||unistr('\000a')||
'      IF v_expand = ''Y'' OR l_value_list(1)(i) = v_level_1 THEN'||unistr('\000a')||
'        v_class_display := ''dtt_expanded'';'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
''||
'        v_class_display := ''dtt_collapsed'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'      v_class_display := ''dtt_collapsed'';'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'    sys.htp.p('||unistr('\000a')||
'      ''<tr dtt_level="'' '||unistr('\000a')||
'      || sys.htf.escape_sc(l_value_list(1)(i))'||unistr('\000a')||
'      || ''" class="'' || v_class_display || ''_tr" rownum="''|| i || ''"> '''||unistr('\000a')||
'    );'||unistr('\000a')||
'    '||unistr('\000a')||
'    IF i < l_value_list(1).count THEN'||unistr('\000a')||
'      IF v_expand = ''N'' AND l_value_list(1)(i) = v_level_1 THEN'||unistr('\000a')||
' '||
'       v_class_display := ''dtt_collapsed'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      '||unistr('\000a')||
'      IF l_value_list(1)(i) < l_value_list(1)(i+1) THEN'||unistr('\000a')||
'        v_class_leaf := ''dtt_branch'';'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'        v_class_leaf := ''dtt_leaf'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'    ELSE'||unistr('\000a')||
'      v_class_leaf := ''dtt_leaf'';'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'    '||unistr('\000a')||
'    -- Rendering level value as first col and second value into one column'||unistr('\000a')||
'    sys.htp.p('||unistr('\000a')||
'      ''<td class="dtt_td" '||
'style="'''||unistr('\000a')||
'    );'||unistr('\000a')||
'    '||unistr('\000a')||
'    IF v_width_1 > 0 THEN'||unistr('\000a')||
'    	sys.htp.p(''width: '' || v_width_1 || ''px; '');'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'    sys.htp.p(''" name="dtt_level">'');'||unistr('\000a')||
'    sys.htp.p('||unistr('\000a')||
'      ''<span style="margin-left:'' '||unistr('\000a')||
'      || (sys.htf.escape_sc(l_value_list(1)(i)) - 1) * v_indenting '||unistr('\000a')||
'      || ''px; ">&#160;</span>'''||unistr('\000a')||
'    );'||unistr('\000a')||
'    sys.htp.p(''<a href="#" class="dtt_toggle" onclick="dttToggleNode('''''' || p_region.id || '''||
''''', '' || i || '');">'');'||unistr('\000a')||
'    sys.htp.p(''<span class="dtt_icon '' || v_class_leaf || ''_span '' || v_class_display || ''_span">&#160;</span>'');'||unistr('\000a')||
'    sys.htp.p(''</a>'');'||unistr('\000a')||
'    sys.htp.p('||unistr('\000a')||
'      sys.htf.escape_sc(l_value_list(2)(i)) '||unistr('\000a')||
'      || ''</td>'''||unistr('\000a')||
'    );'||unistr('\000a')||
'    -- Render all other columns'||unistr('\000a')||
'    FOR j IN 3 .. l_value_list.count'||unistr('\000a')||
'    LOOP'||unistr('\000a')||
'      sys.htp.p(''<td class="dtt_td" align="right">'' || sys.htf.escape_sc(l_val'||
'ue_list(j)(i)) || ''</td>'');'||unistr('\000a')||
'    END LOOP;'||unistr('\000a')||
'    '||unistr('\000a')||
'    sys.htp.p(''</tr>'');'||unistr('\000a')||
'    '||unistr('\000a')||
'  END LOOP;'||unistr('\000a')||
'  sys.htp.p(''</tbody>'');'||unistr('\000a')||
'  sys.htp.p(''</table>'');'||unistr('\000a')||
'  RETURN NULL;'||unistr('\000a')||
'END render_dtreetable;'||unistr('\000a')||
''
 ,p_render_function => 'render_dtreetable'
 ,p_standard_attributes => 'SOURCE_SQL:SOURCE_REQUIRED'
 ,p_sql_min_column_count => 2
 ,p_sql_max_column_count => 50
 ,p_sql_examples => 'SELECT level, ename, mgr, dept FROM emp'||unistr('\000a')||
'START WITH empno       = 7839'||unistr('\000a')||
'CONNECT BY prior empno = mgr'
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_help_text => '<p>'||unistr('\000a')||
'	DTreeTable provides the possibility to render a composite of a tree view with a table view.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	SQL-Example:</p>'||unistr('\000a')||
'<pre>'||unistr('\000a')||
'SELECT level, ename, mgr, deptno FROM emp'||unistr('\000a')||
'START WITH empno       = 7839'||unistr('\000a')||
'CONNECT BY prior empno = mgr'||unistr('\000a')||
'</pre>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	Please pay attention that the level value must be the first value of the SQL Statement.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	<b>Indenting in px</b> <i>(Default: 10)</i><br />'||unistr('\000a')||
'	Higher level values increase margin-left in px by defined indenting value</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	<b>Column Header Name (Colon seperated)</b><br />'||unistr('\000a')||
'	Column Names will be shown in table header. The first and second column of the SQL Statement will be merge to one column.</p>'||unistr('\000a')||
'<pre>'||unistr('\000a')||
'Name:Manager Id:Department No.</pre>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	<b>Expand On Start Up</b> <i>(Default: Yes)</i><br />'||unistr('\000a')||
'	Defines wheather the tree will be expanded on start up or collapsed.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	<b>First Column Width in px</b><br />'||unistr('\000a')||
'	If set, the first column will have a fix width.</p>'||unistr('\000a')||
''
 ,p_version_identifier => '0.9'
 ,p_about_url => 'http://www.dinh.de/'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5803227647510119 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 5800313176995941 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Indenting in px'
 ,p_attribute_type => 'INTEGER'
 ,p_is_required => true
 ,p_default_value => '10'
 ,p_is_translatable => false
 ,p_help_text => '<p>'||unistr('\000a')||
'	<b>Indenting in px</b> <i>(Default: 10)</i><br />'||unistr('\000a')||
'	Higher level values increase margin-left in px by defined indenting value</p>'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5804636530574039 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 5800313176995941 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'Column Header Name (Colon Seperated)'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_is_translatable => false
 ,p_help_text => '<p>'||unistr('\000a')||
'	<b>Column Header Name (Colon seperated)</b><br />'||unistr('\000a')||
'	Column Names will be shown in table header. The first and second column of the SQL Statement will be merge to one column.</p>'||unistr('\000a')||
'<pre>'||unistr('\000a')||
'Name:Manager Id:Department No.</pre>'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5830712460634575 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 5800313176995941 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Expand on Start Up'
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
 ,p_help_text => '<p>'||unistr('\000a')||
'	<b>Expand On Start Up</b> <i>(Default: Yes)</i><br />'||unistr('\000a')||
'	Defines wheather the tree will be expanded on start up or collapsed.</p>'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5837215060371340 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 5800313176995941 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'First Column Width in px'
 ,p_attribute_type => 'NUMBER'
 ,p_is_required => false
 ,p_is_translatable => false
 ,p_help_text => '<p>'||unistr('\000a')||
'	<b>First Column Width in px</b><br />'||unistr('\000a')||
'	If set, the first column will have a fix width.</p>'
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000009000000090806000000E09106100000001974455874536F6674776172650041646F626520496D616765526561647971C9653C0000004E4944415478DA6260089D16CF40003001F102A0C2FBF814330225';
wwv_flow_api.g_varchar2_table(2) := 'FF23F11F007103C3EAAC85F81461558C4B118A6226026E06297AC08243F200D4BA83200EBAA20550C987C8822CF824610020C0007E3C1D5E20C8B7790000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 5810517772956665 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 5800313176995941 + wwv_flow_api.g_id_offset
 ,p_file_name => 'dtt_collapsed.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000009000000090806000000E0910610000002EE694343504943432050726F66696C65000078018554CF6B134114FE366EA9D022085A6B0EB27890224959AB6845D436FD11626B0CDB1FB64590643349D66E36';
wwv_flow_api.g_varchar2_table(2) := 'EBEE26B5A588E4E2D12ADE45EDA107FF801E7AF0642F4A855A4528DEAB2862A1172DF1CD6E4CB6A5EAC0CE7EF3DE37EF7D6F76DF000D72D234F58004E40DC752A211696C7C426AFC88008EA20941342555DBEC4E2406418373F97BE7D87A0F815B56C37B';
wwv_flow_api.g_varchar2_table(3) := 'FB77B277AD9AD2B69A0784FD40E0479AD92AB0EF17710A591202883CDFA129C77408DFE3D8F2EC8F394E7978C1B50F2B3DC459227C40352DCE7F4DB853CD25D34083483894F571523E9CD78B94D71D07696E66C6C810BD4F90A6BBCCEEAB62A19C4EF60E';
wwv_flow_api.g_varchar2_table(4) := '90BD9DF47E4EB3DE3EC221C20B19AD3F46B88D9EF58CD53FE261E1A4E6C4863D1C1835F4F86015B71AA9F835C2145F104D27A25471D92E0DF198AEFD56F24A82709038CA646180735A484FD74C6EF8BA87057D26D713AFE2775651E1798F1367DED4DDEF';
wwv_flow_api.g_varchar2_table(5) := '45DA02AF300E1D0C1A0C9A0D48501045046198B05040863C1A3134B2723F23AB061B937B3275246ABB746244B1417B36DC3DB751A4DD3CFE2822719443B50892FC41FE2AAFC94FE579F9CB5CB0D856F794AD9B9ABAF2E03BC5E599B91A1ED7D3C8E3734D';
wwv_flow_api.g_varchar2_table(6) := '5E7C95D47693574796AC797ABC9AEC1A3FEC579731E682358FC473B0FBF12D5F95CC97298C14C5E355F3EA4B84755A3137DF9F6C7F3B3DE22ECF2EB5D673AD898B37569B9767FD6A48FBEEAABC93E655F94F5EF5F1FC67CDC463E2293126768AE7218997';
wwv_flow_api.g_varchar2_table(7) := 'C52EF192D84BAB0BE2606DC7089D958629D26D91FA24D560609ABCF52F5D3F5B78BD467F0CF5519419CCD25489F77FC22A64349DB90E6FFA8FDBC7FC17E4F78AE79F28022F6CE0C899BA6D5371EF10A165A56E73AE0217BFD17DF0B66E6BA37E38FC0458';
wwv_flow_api.g_varchar2_table(8) := '3CAB16AD52359F20BC011C76877A1EE82998D39696CD3952872C9F93BAE9CA6252CC50DB435252D725D7654B16B3995562E976D899D31D6E1CA13942F7C4A74A6593FAAFF111B0FDB052F9F9AC52D97E4E1AD68197FA6FC0BCFD45C0788B890000000970';
wwv_flow_api.g_varchar2_table(9) := '48597300000B1300000B1301009A9C18000000814944415418196364706DFDCF800F3032263001E517E051F3E0FFCECA854C0C7FFF37E054C4C8089663FABFB7FA2150D1022C0AC1A680C441D63160350D6A0A489AF1FF7F88BB19DDDAF73330FC770009';
wwv_flow_api.g_varchar2_table(10) := '02C183FFBBAA14214C9849105E034C9001C914B018C8241866706DDB0F0C92FB303E8C6681EB86301A80A628A08931000096EC36B39617B57C0000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 5811214969957828 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 5800313176995941 + wwv_flow_api.g_id_offset
 ,p_file_name => 'dtt_expanded.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(2) := '0A202A2054686973204A6176615363726970742066696C652069732070617274206F662044547265655461626C65204170457820506C7567696E0A202A2044547265655461626C65204170457820506C7567696E20707574732068696572617263686963';
wwv_flow_api.g_varchar2_table(3) := '616C206461746120696E20636F6C756D6E732C206275742075736520616E20696E64656E746564206F75746C696E65207374727563747572650A202A20696E2074686520666972737420636F6C756D6E20746F20696C6C75737472617465207468652074';
wwv_flow_api.g_varchar2_table(4) := '726565207374727563747572652E0A202A0A202A20417574686F723A204C696E682044696E6820286C696E684064696E682E6465290A202A2055524C3A20687474703A2F2F7777772E64696E682E64650A202A2043726561746564204F6E3A2032303130';
wwv_flow_api.g_varchar2_table(5) := '2D31312D30360A202A2056657273696F6E3A20302E392028323031302D31312D3036290A200A202A205468697320506C7567696E206973206475616C206C6963656E73656420756E64657220746865204D495420616E642047504C206C6963656E736573';
wwv_flow_api.g_varchar2_table(6) := '3A0A202A20687474703A2F2F7777772E6F70656E736F757263652E6F72672F6C6963656E7365732F6D69742D6C6963656E73652E7068700A202A20687474703A2F2F7777772E676E752E6F72672F6C6963656E7365732F67706C2E68746D6C0A202A2A2A';
wwv_flow_api.g_varchar2_table(7) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A0A2F2A';
wwv_flow_api.g_varchar2_table(8) := '2A0A202A2066756E6374696F6E20746F67676C6520616C6C206E6F6465732062656C6F772074686520646566696E6564206272616E63680A202A20506172616D313A20726567696F6E49642070726F76696465642066726F6D20417045780A202A205061';
wwv_flow_api.g_varchar2_table(9) := '72616D323A20726F776E756D2070726F76696465642066726F6D2053514C2073746174656D656E740A202A0A202A2F0A66756E6374696F6E20647474546F67676C654E6F646528726567696F6E49642C20726F776E756D29207B0A0976617220656C203D';
wwv_flow_api.g_varchar2_table(10) := '20242827236474745F27202B20726567696F6E4964202B20275F7461626C652074626F6479207472207370616E2E6474745F69636F6E27295B726F776E756D202D20315D3B0A09696620282428656C292E686173436C61737328276474745F636F6C6C61';
wwv_flow_api.g_varchar2_table(11) := '707365645F7370616E272929207B0A09092F2F2063616C6C20657870616E642066756E6374696F6E0A0909647474457870616E6428726567696F6E49642C20726F776E756D293B0A097D20656C7365207B0A09092F2F2063616C6C20636F6C6C61707365';
wwv_flow_api.g_varchar2_table(12) := '2066756E6374696F6E0A0909647474436F6C6C6170736528726567696F6E49642C20726F776E756D293B0A097D0A7D0A0A2F2A2A0A202A2066756E6374696F6E20657870616E6420616C6C206E6F6465732062656C6F772074686520646566696E656420';
wwv_flow_api.g_varchar2_table(13) := '6272616E63680A202A0A202A2F0A66756E6374696F6E20647474457870616E6428726567696F6E49642C20726F776E756D29207B0A092F2F206765742072656C61746564207461626C6520726F770A0976617220656C203D20242827236474745F27202B';
wwv_flow_api.g_varchar2_table(14) := '20726567696F6E4964202B20275F7461626C652074626F647920747227295B726F776E756D202D20315D3B0A092F2F2073746F72652063757272656E74206C6576656C0A09766172206C6576656C203D204E756D626572282428656C292E617474722827';
wwv_flow_api.g_varchar2_table(15) := '6474745F6C6576656C2729293B0A092F2F206368616E67652069636F6E0A092428656C292E66696E6428277370616E2E6474745F69636F6E27292E72656D6F7665436C61737328276474745F636F6C6C61707365645F7370616E27293B0A092428656C29';
wwv_flow_api.g_varchar2_table(16) := '2E66696E6428277370616E2E6474745F69636F6E27292E616464436C61737328276474745F657870616E6465645F7370616E27293B0A097768696C65202824282428656C292E6E6578742829292E6174747228276474745F6C6576656C272920213D206E';
wwv_flow_api.g_varchar2_table(17) := '756C6C29207B0A092020202076617220656C203D202428656C292E6E65787428293B0A0920202020696620282428656C292E6174747228276474745F6C6576656C2729203D3D20286C6576656C202B20312929207B0A0920202020092F2F206368616E67';
wwv_flow_api.g_varchar2_table(18) := '6520646973706C61790A090909656C2E72656D6F7665436C61737328276474745F636F6C6C61707365645F747227293B0A090909656C2E616464436C61737328276474745F657870616E6465645F747227293B0A09097D20656C73652069662028242865';
wwv_flow_api.g_varchar2_table(19) := '6C292E6174747228276474745F6C6576656C272920203D3D206C6576656C29207B0A090909627265616B3B0A09097D0A097D3B0A7D0A0A2F2A2A0A202A2066756E6374696F6E20636F6C6C6170736520616C6C206E6F6465732062656C6F772074686520';
wwv_flow_api.g_varchar2_table(20) := '646566696E6564206272616E63680A202A0A202A2F0A66756E6374696F6E20647474436F6C6C6170736528726567696F6E49642C20726F776E756D29207B0A092F2F206765742072656C61746564207461626C6520726F770A0976617220656C203D2024';
wwv_flow_api.g_varchar2_table(21) := '2827236474745F27202B20726567696F6E4964202B20275F7461626C652074626F647920747227295B726F776E756D202D20315D3B0A092F2F2073746F72652063757272656E74206C6576656C0A09766172206C6576656C203D204E756D626572282428';
wwv_flow_api.g_varchar2_table(22) := '656C292E6174747228276474745F6C6576656C2729293B0A092F2F206368616E67652069636F6E0A092428656C292E66696E6428277370616E2E6474745F69636F6E27292E616464436C61737328276474745F636F6C6C61707365645F7370616E27293B';
wwv_flow_api.g_varchar2_table(23) := '0A092428656C292E66696E6428277370616E2E6474745F69636F6E27292E72656D6F7665436C61737328276474745F657870616E6465645F7370616E27293B0A097768696C65202824282428656C292E6E6578742829292E6174747228276474745F6C65';
wwv_flow_api.g_varchar2_table(24) := '76656C272920213D206E756C6C29207B0A092020202076617220656C203D202428656C292E6E65787428293B0A0920202020696620282428656C292E6174747228276474745F6C6576656C2729203E206C6576656C29207B0A0920202020092F2F206368';
wwv_flow_api.g_varchar2_table(25) := '616E676520646973706C61790A090909656C2E616464436C61737328276474745F636F6C6C61707365645F747227293B0A090909656C2E72656D6F7665436C61737328276474745F657870616E6465645F747227293B0A0909092F2F206368616E676520';
wwv_flow_api.g_varchar2_table(26) := '69636F6E0A0909092428656C292E66696E6428277370616E2E6474745F69636F6E27292E616464436C61737328276474745F636F6C6C61707365645F7370616E27293B0A0909092428656C292E66696E6428277370616E2E6474745F69636F6E27292E72';
wwv_flow_api.g_varchar2_table(27) := '656D6F7665436C61737328276474745F657870616E6465645F7370616E27293B0A09097D20656C736520696620282428656C292E6174747228276474745F6C6576656C272920203D3D206C6576656C29207B0A090909627265616B3B0A09097D0A097D3B';
wwv_flow_api.g_varchar2_table(28) := '0A7D';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 5834031754196441 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 5800313176995941 + wwv_flow_api.g_id_offset
 ,p_file_name => 'dtt.js'
 ,p_mime_type => 'application/x-javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(2) := '0A202A2054686973204353532066696C652069732070617274206F662044547265655461626C65204170457820506C7567696E0A202A2044547265655461626C65204170457820506C7567696E20707574732068696572617263686963616C2064617461';
wwv_flow_api.g_varchar2_table(3) := '20696E20636F6C756D6E732C206275742075736520616E20696E64656E746564206F75746C696E65207374727563747572650A202A20696E2074686520666972737420636F6C756D6E20746F20696C6C7573747261746520746865207472656520737472';
wwv_flow_api.g_varchar2_table(4) := '7563747572652E0A202A0A202A20417574686F723A204C696E682044696E6820286C696E684064696E682E6465290A202A2055524C3A20687474703A2F2F7777772E64696E682E64650A202A2043726561746564204F6E3A20323031302D31312D30360A';
wwv_flow_api.g_varchar2_table(5) := '202A2056657273696F6E3A20302E392028323031302D31312D3036290A200A202A205468697320506C7567696E206973206475616C206C6963656E73656420756E64657220746865204D495420616E642047504C206C6963656E7365733A0A202A206874';
wwv_flow_api.g_varchar2_table(6) := '74703A2F2F7777772E6F70656E736F757263652E6F72672F6C6963656E7365732F6D69742D6C6963656E73652E7068700A202A20687474703A2F2F7777772E676E752E6F72672F6C6963656E7365732F67706C2E68746D6C0A202A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(7) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A0A7370616E2E6474745F';
wwv_flow_api.g_varchar2_table(8) := '69636F6E207B0A0970616464696E672D6C6566743A20313070782021696D706F7274616E743B0A7D0A0A7370616E2E6474745F6272616E63685F7370616E2E6474745F657870616E6465645F7370616E207B0A202020206261636B67726F756E643A2075';
wwv_flow_api.g_varchar2_table(9) := '726C2823504C5547494E5F505245464958236474745F657870616E6465642E706E6729206E6F2D7265706561743B0A7D0A0A7370616E2E6474745F6272616E63685F7370616E2E6474745F636F6C6C61707365645F7370616E207B0A202020206261636B';
wwv_flow_api.g_varchar2_table(10) := '67726F756E643A2075726C2823504C5547494E5F505245464958236474745F636F6C6C61707365642E706E6729206E6F2D7265706561743B0A7D0A0A74722E6474745F657870616E6465645F7472207B0A20202020646973706C61793A207461626C652D';
wwv_flow_api.g_varchar2_table(11) := '726F772021696D706F7274616E743B0A7D0A0A74722E6474745F636F6C6C61707365645F7472207B0A20202020646973706C61793A206E6F6E652021696D706F7274616E743B0A7D0A0A2E6474745F746F67676C65207B0A09746578742D6465636F7261';
wwv_flow_api.g_varchar2_table(12) := '74696F6E3A206E6F6E653B0A7D0A0A2E6474745F7464207B0A0970616464696E672D6C6566743A203570783B0A0970616464696E672D72696768743A203570783A090A7D';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 5839409663559783 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 5800313176995941 + wwv_flow_api.g_id_offset
 ,p_file_name => 'dtt_style.css'
 ,p_mime_type => 'text/css'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

--application/shared_components/plugins/dynamic_action/com_enkitec_clob_load
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'DYNAMIC ACTION'
 ,p_name => 'COM_ENKITEC_CLOB_LOAD'
 ,p_display_name => 'Enkitec CLOB Load'
 ,p_category => 'MISC'
 ,p_supported_ui_types => 'DESKTOP'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'FUNCTION enkitec_clob_load_render ('||unistr('\000a')||
'   p_dynamic_action IN APEX_PLUGIN.T_DYNAMIC_ACTION,'||unistr('\000a')||
'   p_plugin         IN APEX_PLUGIN.T_PLUGIN'||unistr('\000a')||
')'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN APEX_PLUGIN.T_DYNAMIC_ACTION_RENDER_RESULT'||unistr('\000a')||
''||unistr('\000a')||
'IS'||unistr('\000a')||
''||unistr('\000a')||
'   l_retval           APEX_PLUGIN.T_DYNAMIC_ACTION_RENDER_RESULT;'||unistr('\000a')||
'   l_show_modal       VARCHAR2(1) := p_plugin.attribute_01;'||unistr('\000a')||
'   l_dialog_title     VARCHAR2(4000) := NVL(p_plugin.attribute_02, ''Please wait.'||
'..'');'||unistr('\000a')||
'   l_loading_img_type VARCHAR2(30) := p_plugin.attribute_03;'||unistr('\000a')||
'   l_loading_img_c    VARCHAR2(4000) := p_plugin.attribute_04; '||unistr('\000a')||
'   l_action           VARCHAR2(10) := NVL(p_dynamic_action.attribute_01, ''RENDER'');'||unistr('\000a')||
'   l_change_only      VARCHAR2(1) := NVL(p_dynamic_action.attribute_06, ''Y'');'||unistr('\000a')||
'   l_make_blocking    VARCHAR2(1) := NVL(p_dynamic_action.attribute_07, ''Y'');'||unistr('\000a')||
'   l_loading_img_src  VARCHAR'||
'2(32767);'||unistr('\000a')||
'   l_crlf             VARCHAR2(2) := CHR(13)||CHR(10);'||unistr('\000a')||
'   l_js_function      VARCHAR2(32767);'||unistr('\000a')||
'   l_onload_code      VARCHAR2(32767);'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF apex_application.g_debug'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      apex_plugin_util.debug_dynamic_action('||unistr('\000a')||
'         p_plugin         => p_plugin,'||unistr('\000a')||
'         p_dynamic_action => p_dynamic_action '||unistr('\000a')||
'      );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   IF l_loading_img_type = ''DEFAULT'''||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_loadi'||
'ng_img_src := p_plugin.file_prefix || ''enkitec-loading.gif'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      l_loading_img_src := REPLACE(l_loading_img_c, ''#IMAGE_PREFIX#'', apex_application.g_image_prefix);'||unistr('\000a')||
'      l_loading_img_src := REPLACE(l_loading_img_src, ''#PLUGIN_PREFIX#'', p_plugin.file_prefix);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   apex_css.add('||unistr('\000a')||
'      p_css => ''.clob-load-dialog .ui-dialog-titlebar-close {display: none;}'','||unistr('\000a')||
'      p_key => ''clob-lo'||
'ad-hide-modal-close'''||unistr('\000a')||
'   );'||unistr('\000a')||
'   '||unistr('\000a')||
'   apex_javascript.add_library('||unistr('\000a')||
'      p_name      => ''enkitec-clob-load.min'','||unistr('\000a')||
'      p_directory => p_plugin.file_prefix,'||unistr('\000a')||
'      p_version   => NULL'||unistr('\000a')||
'   );'||unistr('\000a')||
''||unistr('\000a')||
'   l_onload_code :='||unistr('\000a')||
'      ''apex.jQuery(document).clob_load({''|| l_crlf ||'||unistr('\000a')||
'      ''   showModal: "'' || l_show_modal ||''",''|| l_crlf ||'||unistr('\000a')||
'      ''   dialogTitle: "'' || l_dialog_title ||''",''|| l_crlf ||'||unistr('\000a')||
'      ''   loadingIm'||
'ageSrc: "'' || l_loading_img_src ||''",''|| l_crlf ||'||unistr('\000a')||
'      ''   pluginFilePrefix: "'' || p_plugin.file_prefix || ''",'' || l_crlf || '||unistr('\000a')||
'      ''   apexImagePrefix: "'' || apex_application.g_image_prefix || '',"'' || l_crlf ||'||unistr('\000a')||
'      ''});'';'||unistr('\000a')||
''||unistr('\000a')||
'   apex_javascript.add_onload_code('||unistr('\000a')||
'      p_code => l_onload_code'||unistr('\000a')||
'   ); '||unistr('\000a')||
''||unistr('\000a')||
'   IF l_action = ''RENDER'''||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_js_function :='||unistr('\000a')||
'         ''function(){''|| l_crlf || '||unistr('\000a')||
'     '||
'    ''   apex.jQuery(document).clob_load("renderClob", {'' || l_crlf ||'||unistr('\000a')||
'         ''      $elmt: this.affectedElements.eq(0),'' || l_crlf ||'||unistr('\000a')||
'         ''      ajaxIdentifier: "'' || apex_plugin.get_ajax_identifier() || ''"'' || l_crlf ||'||unistr('\000a')||
'         ''   });''|| l_crlf ||'||unistr('\000a')||
'         ''}'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      l_js_function :='||unistr('\000a')||
'         ''function(){''|| l_crlf || '||unistr('\000a')||
'         ''   apex.jQuery(document).clob_load("submitClob", {'''||
' || l_crlf ||'||unistr('\000a')||
'         ''      $elmt: this.affectedElements.eq(0),'' || l_crlf ||'||unistr('\000a')||
'         ''      ajaxIdentifier: "'' || apex_plugin.get_ajax_identifier() || ''",'' || l_crlf ||'||unistr('\000a')||
'         ''      changeOnly: "'' || l_change_only || ''",'' || l_crlf || '||unistr('\000a')||
'         ''      makeBlocking: "'' || l_make_blocking || ''"'' || l_crlf ||'||unistr('\000a')||
'         ''   });''|| l_crlf ||'||unistr('\000a')||
'         ''}'';'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   l_retval.javascript_functi'||
'on := l_js_function;'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN l_retval;'||unistr('\000a')||
'    '||unistr('\000a')||
'END enkitec_clob_load_render;'||unistr('\000a')||
''||unistr('\000a')||
'FUNCTION enkitec_clob_load_ajax ('||unistr('\000a')||
'   p_dynamic_action IN APEX_PLUGIN.T_DYNAMIC_ACTION,'||unistr('\000a')||
'   p_plugin         IN APEX_PLUGIN.T_PLUGIN'||unistr('\000a')||
')'||unistr('\000a')||
''||unistr('\000a')||
'    RETURN APEX_PLUGIN.T_DYNAMIC_ACTION_AJAX_RESULT'||unistr('\000a')||
''||unistr('\000a')||
'IS'||unistr('\000a')||
''||unistr('\000a')||
'   l_retval                   APEX_PLUGIN.T_DYNAMIC_ACTION_AJAX_RESULT;'||unistr('\000a')||
'   l_ajax_function            VARCHAR2(32767) := apex_appli'||
'cation.g_x01;'||unistr('\000a')||
'   l_source                   VARCHAR2(20) := NVL(p_dynamic_action.attribute_02, ''COLLECTION'');'||unistr('\000a')||
'   l_render_collection_name   VARCHAR2(255) := p_dynamic_action.attribute_03;'||unistr('\000a')||
'   l_query                    VARCHAR2(32767) := p_dynamic_action.attribute_04;'||unistr('\000a')||
'   l_submit_collection_name   VARCHAR2(255) := p_dynamic_action.attribute_05;'||unistr('\000a')||
'   l_column_value_list        APEX_PLUGIN_UTIL.T_COLUM'||
'N_VALUE_LIST2;     '||unistr('\000a')||
'   l_clob_text                CLOB := EMPTY_CLOB();'||unistr('\000a')||
'   l_token                    VARCHAR2(32000);'||unistr('\000a')||
'   l_chunk_size               NUMBER := 4000;'||unistr('\000a')||
'   '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF l_ajax_function = ''RENDER_CLOB'''||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      IF l_source = ''COLLECTION'''||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         IF apex_collection.collection_exists(l_render_collection_name)'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            SELECT clob001'||unistr('\000a')||
'            INTO l_cl'||
'ob_text'||unistr('\000a')||
'            FROM apex_collections'||unistr('\000a')||
'            WHERE collection_name = l_render_collection_name'||unistr('\000a')||
'               AND seq_id = 1;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      ELSE --must be SQL_QUERY'||unistr('\000a')||
'         BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'            l_column_value_list := apex_plugin_util.get_data2('||unistr('\000a')||
'               p_sql_statement  => l_query, '||unistr('\000a')||
'               p_min_columns    => 1, '||unistr('\000a')||
'               p_max_columns    => 1, '||unistr('\000a')||
'               p'||
'_component_name => p_dynamic_action.action,'||unistr('\000a')||
'               p_first_row      => 1,'||unistr('\000a')||
'               p_max_rows       => 1'||unistr('\000a')||
'            );  '||unistr('\000a')||
''||unistr('\000a')||
'         EXCEPTION'||unistr('\000a')||
''||unistr('\000a')||
'            WHEN NO_DATA_FOUND'||unistr('\000a')||
'            THEN'||unistr('\000a')||
'               NULL;'||unistr('\000a')||
''||unistr('\000a')||
'         END;'||unistr('\000a')||
''||unistr('\000a')||
'         IF l_column_value_list.exists(1)'||unistr('\000a')||
'            AND l_column_value_list(1).value_list.exists(1)'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            l_clob_text := l_column_value_'||
'list(1).value_list(1).clob_value;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'      FOR i IN 0 .. FLOOR(LENGTH(l_clob_text)/l_chunk_size) '||unistr('\000a')||
'      LOOP  '||unistr('\000a')||
'         sys.htp.prn(substr(l_clob_text, i * l_chunk_size + 1, l_chunk_size));  '||unistr('\000a')||
'      END LOOP;'||unistr('\000a')||
'   ELSE --must be SUBMIT_CLOB'||unistr('\000a')||
'      dbms_lob.createtemporary(l_clob_text, false, dbms_lob.session);'||unistr('\000a')||
''||unistr('\000a')||
'      FOR i IN 1..apex_application.g_f01.count '||unistr('\000a')||
'      LOOP'||unistr('\000a')||
'   '||
'      l_token := wwv_flow.g_f01(i);'||unistr('\000a')||
''||unistr('\000a')||
'         IF length(l_token) > 0'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            dbms_lob.writeappend(l_clob_text, length(l_token), l_token);'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END LOOP;'||unistr('\000a')||
''||unistr('\000a')||
'      apex_collection.create_or_truncate_collection('||unistr('\000a')||
'         p_collection_name => l_submit_collection_name'||unistr('\000a')||
'      );'||unistr('\000a')||
'      '||unistr('\000a')||
'      apex_collection.add_member('||unistr('\000a')||
'         p_collection_name => l_submit_collection_na'||
'me,'||unistr('\000a')||
'         p_clob001         => l_clob_text'||unistr('\000a')||
'      );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN l_retval;'||unistr('\000a')||
''||unistr('\000a')||
'END enkitec_clob_load_ajax;'
 ,p_render_function => 'enkitec_clob_load_render'
 ,p_ajax_function => 'enkitec_clob_load_ajax'
 ,p_standard_attributes => 'ITEM:JQUERY_SELECTOR:REQUIRED'
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_help_text => '<br />'||unistr('\000a')||
''
 ,p_version_identifier => '1.0'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64247453858598958 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Show Modal Dialog While Loading'
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64248349964616787 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'Dialog Title'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_default_value => 'Please wait...'
 ,p_display_length => 50
 ,p_max_length => 500
 ,p_is_translatable => true
 ,p_depending_on_attribute_id => 64247453858598958 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'Y'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64248852866627073 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Loading Image Type'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'DEFAULT'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 64247453858598958 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'Y'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 64249357021628277 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 64248852866627073 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Default'
 ,p_return_value => 'DEFAULT'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 64249752651636447 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 64248852866627073 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Custom'
 ,p_return_value => 'CUSTOM'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64251968889688496 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'Loading Image'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_display_length => 50
 ,p_max_length => 500
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 64248852866627073 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'CUSTOM'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64257373476020923 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'CLOB Action'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => false
 ,p_default_value => 'RENDER'
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 64257875900021630 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 64257373476020923 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Render'
 ,p_return_value => 'RENDER'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 64258278324022305 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 64257373476020923 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Submit'
 ,p_return_value => 'SUBMIT'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64274174001509832 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'Source'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'SQL_QUERY'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 64257373476020923 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'RENDER'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 64274676772510663 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 64274174001509832 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Collection'
 ,p_return_value => 'COLLECTION'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 64275081620511978 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 64274174001509832 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'SQL Query'
 ,p_return_value => 'SQL_QUERY'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64244778615868104 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Collection Name'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_display_length => 50
 ,p_max_length => 255
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 64274174001509832 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'COLLECTION'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64276653709589149 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'SQL Query'
 ,p_attribute_type => 'SQL'
 ,p_is_required => true
 ,p_sql_min_column_count => 1
 ,p_sql_max_column_count => 1
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 64274174001509832 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'SQL_QUERY'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64277170331593884 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Collection Name'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_display_length => 50
 ,p_max_length => 255
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 64257373476020923 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'SUBMIT'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64246955674580549 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 6
 ,p_display_sequence => 60
 ,p_prompt => 'Submit Only When Value Changed'
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 64257373476020923 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'SUBMIT'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 64303756299002837 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 7
 ,p_display_sequence => 70
 ,p_prompt => 'Make Synchronous (Blocking) '
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 64257373476020923 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'SUBMIT'
  );
wwv_flow_api.create_plugin_event (
  p_id => 64305058994098268 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_name => 'enkitecclobloadrendercomplete'
 ,p_display_name => 'CLOB(s) Render Complete'
  );
wwv_flow_api.create_plugin_event (
  p_id => 64304752068096282 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_name => 'enkitecclobloadsubmitcomplete'
 ,p_display_name => 'CLOB(s) Submit Complete'
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '766172207175657279537472696E673D22223B66756E6374696F6E20616464506172616D28612C62297B6966287175657279537472696E673D3D3D2222297B7175657279537472696E673D612B223D222B282862213D6E756C6C293F656E636F64655552';
wwv_flow_api.g_varchar2_table(2) := '49436F6D706F6E656E742862293A2222297D656C73657B7175657279537472696E673D7175657279537472696E672B2226222B612B223D222B282862213D6E756C6C293F656E636F6465555249436F6D706F6E656E742862293A2222297D7D66756E6374';
wwv_flow_api.g_varchar2_table(3) := '696F6E206368756E6B436C6F6228642C63297B76617220613D4D6174682E666C6F6F7228642E6C656E6774682F63292B313B666F722876617220623D303B623C613B622B2B297B616464506172616D2822663031222C642E736C69636528632A622C632A';
wwv_flow_api.g_varchar2_table(4) := '28622B312929297D7D66756E6374696F6E20242861297B696628747970656F6620613D3D22737472696E6722297B613D646F63756D656E742E676574456C656D656E74427949642861297D72657475726E20617D66756E6374696F6E20636F6C6C656374';
wwv_flow_api.g_varchar2_table(5) := '28622C65297B76617220673D5B5D3B666F722876617220643D303B643C622E6C656E6774683B642B2B297B76617220633D6528625B645D293B69662863213D6E756C6C297B672E707573682863297D7D72657475726E20677D616A61783D7B7D3B616A61';
wwv_flow_api.g_varchar2_table(6) := '782E783D66756E6374696F6E28297B7472797B72657475726E206E657720416374697665584F626A65637428224D73786D6C322E584D4C4854545022297D63617463682861297B7472797B72657475726E206E657720416374697665584F626A65637428';
wwv_flow_api.g_varchar2_table(7) := '224D6963726F736F66742E584D4C4854545022297D63617463682861297B72657475726E206E657720584D4C487474705265717565737428297D7D7D3B616A61782E73657269616C697A653D66756E6374696F6E2868297B76617220653D66756E637469';
wwv_flow_api.g_varchar2_table(8) := '6F6E2866297B72657475726E20682E676574456C656D656E747342795461674E616D652866297D3B76617220613D66756E6374696F6E2866297B696628662E6E616D65297B72657475726E20656E636F6465555249436F6D706F6E656E7428662E6E616D';
wwv_flow_api.g_varchar2_table(9) := '65292B223D222B656E636F6465555249436F6D706F6E656E7428662E76616C7565297D656C73657B72657475726E22227D7D3B76617220633D636F6C6C65637428652822696E70757422292C66756E6374696F6E2866297B69662828662E74797065213D';
wwv_flow_api.g_varchar2_table(10) := '22726164696F222626662E74797065213D22636865636B626F7822297C7C662E636865636B6564297B72657475726E20612866297D7D293B76617220643D636F6C6C6563742865282273656C65637422292C61293B76617220623D636F6C6C6563742865';
wwv_flow_api.g_varchar2_table(11) := '2822746578746172656122292C61293B72657475726E20632E636F6E6361742864292E636F6E6361742862292E6A6F696E28222622297D3B616A61782E73656E643D66756E6374696F6E28652C672C632C64297B76617220623D616A61782E7828293B62';
wwv_flow_api.g_varchar2_table(12) := '2E6F70656E28632C652C74727565293B622E6F6E726561647973746174656368616E67653D66756E6374696F6E28297B696628622E726561647953746174653D3D34297B6728622E726573706F6E736554657874297D7D3B696628633D3D22504F535422';
wwv_flow_api.g_varchar2_table(13) := '297B622E736574526571756573744865616465722822436F6E74656E742D74797065222C226170706C69636174696F6E2F782D7777772D666F726D2D75726C656E636F64656422297D622E73656E642864297D3B616A61782E6765743D66756E6374696F';
wwv_flow_api.g_varchar2_table(14) := '6E28612C62297B616A61782E73656E6428612C622C2247455422297D3B616A61782E676574733D66756E6374696F6E2862297B76617220613D616A61782E7828293B612E6F70656E2822474554222C622C66616C7365293B612E73656E64286E756C6C29';
wwv_flow_api.g_varchar2_table(15) := '3B72657475726E20612E726573706F6E7365546578747D3B616A61782E706F73743D66756E6374696F6E28622C632C61297B616A61782E73656E6428622C632C22504F5354222C61297D3B616A61782E7570646174653D66756E6374696F6E28612C6429';
wwv_flow_api.g_varchar2_table(16) := '7B76617220633D242864293B76617220623D66756E6374696F6E2865297B632E696E6E657248544D4C3D657D3B616A61782E67657428612C62297D3B616A61782E7375626D69743D66756E6374696F6E28612C672C63297B76617220643D242867293B76';
wwv_flow_api.g_varchar2_table(17) := '617220623D66756E6374696F6E2865297B642E696E6E657248544D4C3D657D3B616A61782E706F737428612C622C616A61782E73657269616C697A65286329297D3B6164644576656E744C697374656E657228226D657373616765222C66756E6374696F';
wwv_flow_api.g_varchar2_table(18) := '6E2862297B76617220633D746869732C613D622E646174613B696628612E7830313D3D3D225355424D49545F434C4F4222297B616464506172616D2822705F666C6F775F6964222C612E705F666C6F775F6964293B616464506172616D2822705F666C6F';
wwv_flow_api.g_varchar2_table(19) := '775F737465705F6964222C612E705F666C6F775F737465705F6964293B616464506172616D2822705F696E7374616E6365222C612E705F696E7374616E6365293B616464506172616D2822705F72657175657374222C612E705F72657175657374293B61';
wwv_flow_api.g_varchar2_table(20) := '6464506172616D2822783031222C612E783031293B6368756E6B436C6F6228612E636C6F62446174612C3330303030293B616A61782E706F737428227777765F666C6F772E73686F77222C66756E6374696F6E2864297B632E706F73744D657373616765';
wwv_flow_api.g_varchar2_table(21) := '28227375636365737322297D2C7175657279537472696E67297D656C73657B616464506172616D2822705F666C6F775F6964222C612E705F666C6F775F6964293B616464506172616D2822705F666C6F775F737465705F6964222C612E705F666C6F775F';
wwv_flow_api.g_varchar2_table(22) := '737465705F6964293B616464506172616D2822705F696E7374616E6365222C612E705F696E7374616E6365293B616464506172616D2822705F72657175657374222C612E705F72657175657374293B616464506172616D2822783031222C612E78303129';
wwv_flow_api.g_varchar2_table(23) := '3B616A61782E706F737428227777765F666C6F772E73686F77222C66756E6374696F6E2865297B76617220643D7B7D3B642E636C6F623D653B632E706F73744D6573736167652864297D2C7175657279537472696E67297D7D2C66616C7365293B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 41167351361373650 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_file_name => 'enkitec-clob-load-worker.min.js'
 ,p_mime_type => 'text/javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2866756E6374696F6E2861297B612E7769646765742822656E6B697465632E636C6F625F6C6F6164222C7B6F7074696F6E733A7B73686F774D6F64616C3A6E756C6C2C6469616C6F675469746C653A6E756C6C2C6C6F6164696E67496D6167655372633A';
wwv_flow_api.g_varchar2_table(2) := '6E756C6C2C616A61784964656E7469666965723A6E756C6C2C61706578546869733A6E756C6C2C706C7567696E46696C655072656669783A6E756C6C2C61706578496D6167655072656669783A6E756C6C7D2C5F6372656174653A66756E6374696F6E28';
wwv_flow_api.g_varchar2_table(3) := '297B76617220623D746869733B622E5F6372656174655072697661746553746F7261676528293B622E5F696E6974456C656D656E747328297D2C5F6372656174655072697661746553746F726167653A66756E6374696F6E28297B76617220623D746869';
wwv_flow_api.g_varchar2_table(4) := '733B622E5F76616C7565733D7B6469616C6F67436F756E74446174613A22636C6F625F6C6F61645F6469616C6F675F636F756E74227D3B622E5F656C656D656E74733D7B246469616C6F673A7B7D7D7D2C5F696E6974456C656D656E74733A66756E6374';
wwv_flow_api.g_varchar2_table(5) := '696F6E28297B76617220623D746869733B622E5F656C656D656E74732E246469616C6F673D6128226469762E636C6F622D6C6F61642D636F6E7461696E657222297D2C5F73686F774469616C6F673A66756E6374696F6E28297B76617220623D74686973';
wwv_flow_api.g_varchar2_table(6) := '2C633B633D273C64697620636C6173733D22636C6F622D6C6F61642D636F6E7461696E65722075692D776964676574223E2020203C696D67207372633D22272B622E6F7074696F6E732E6C6F6164696E67496D6167655372632B27222F3E3C2F6469763E';
wwv_flow_api.g_varchar2_table(7) := '273B612822626F647922292E617070656E642863293B622E5F696E6974456C656D656E747328293B622E5F656C656D656E74732E246469616C6F672E6469616C6F67287B64697361626C65643A66616C73652C6175746F4F70656E3A747275652C636C6F';
wwv_flow_api.g_varchar2_table(8) := '73654F6E4573636170653A66616C73652C6469616C6F67436C6173733A22636C6F622D6C6F61642D6469616C6F67222C647261676761626C653A747275652C6865696768743A226175746F222C686964653A6E756C6C2C6D6178684865696768743A6661';
wwv_flow_api.g_varchar2_table(9) := '6C73652C6D617857696474683A66616C73652C6D696E4865696768743A3130302C6D696E57696474683A66616C73652C6D6F64616C3A747275652C726573697A61626C653A66616C73652C73686F773A6E756C6C2C737461636B3A747275652C7469746C';
wwv_flow_api.g_varchar2_table(10) := '653A622E6F7074696F6E732E6469616C6F675469746C652C636C6F73653A66756E6374696F6E28297B612874686973292E6469616C6F67282264657374726F7922293B622E5F656C656D656E74732E246469616C6F672E72656D6F766528297D7D293B62';
wwv_flow_api.g_varchar2_table(11) := '2E5F696E6974456C656D656E747328297D2C72656E646572436C6F623A66756E6374696F6E2862297B76617220633D746869732C652C643B696628632E6F7074696F6E732E73686F774D6F64616C3D3D3D225922297B632E5F696E634469616C6F67436F';
wwv_flow_api.g_varchar2_table(12) := '756E7428293B696628632E5F6765744469616C6F67436F756E7428293D3D3D31297B632E5F73686F774469616C6F6728297D7D69662877696E646F772E576F726B6572297B643D6E657720576F726B657228632E6F7074696F6E732E706C7567696E4669';
wwv_flow_api.g_varchar2_table(13) := '6C655072656669782B22656E6B697465632D636C6F622D6C6F61642D776F726B65722E6D696E2E6A7322293B642E6164644576656E744C697374656E657228226D657373616765222C66756E6374696F6E2866297B632E5F68616E646C65436C6F625265';
wwv_flow_api.g_varchar2_table(14) := '6E6465725375636365737328662E646174612E636C6F622C622E24656C6D745B305D297D2C66616C7365293B642E706F73744D657373616765287B705F666C6F775F69643A6128222370466C6F77496422292E76616C28292C705F666C6F775F73746570';
wwv_flow_api.g_varchar2_table(15) := '5F69643A6128222370466C6F7753746570496422292E76616C28292C705F696E7374616E63653A6128222370496E7374616E636522292E76616C28292C705F726571756573743A22504C5547494E3D222B622E616A61784964656E7469666965722C7830';
wwv_flow_api.g_varchar2_table(16) := '313A2252454E4445525F434C4F42227D297D656C73657B653D7B705F666C6F775F69643A6128222370466C6F77496422292E76616C28292C705F666C6F775F737465705F69643A6128222370466C6F7753746570496422292E76616C28292C705F696E73';
wwv_flow_api.g_varchar2_table(17) := '74616E63653A6128222370496E7374616E636522292E76616C28292C705F726571756573743A22504C5547494E3D222B622E616A61784964656E7469666965722C7830313A2252454E4445525F434C4F42227D3B612E616A6178287B747970653A22504F';
wwv_flow_api.g_varchar2_table(18) := '5354222C75726C3A227777765F666C6F772E73686F77222C646174613A652C64617465547970653A2274657874222C6173796E633A747275652C636F6E746578743A746869732C737563636573733A66756E6374696F6E2866297B632E5F68616E646C65';
wwv_flow_api.g_varchar2_table(19) := '436C6F6252656E6465725375636365737328662C622E24656C6D745B305D297D7D297D7D2C5F68616E646C65436C6F6252656E646572537563636573733A66756E6374696F6E28642C62297B76617220633D746869733B247328622C64293B612E646174';
wwv_flow_api.g_varchar2_table(20) := '6128622C2264656661756C7456616C7565222C64293B696628632E6F7074696F6E732E73686F774D6F64616C3D3D3D225922297B632E5F6465634469616C6F67436F756E7428297D696628632E5F6765744469616C6F67436F756E7428293D3D3D30297B';
wwv_flow_api.g_varchar2_table(21) := '69662821612E6973456D7074794F626A65637428632E5F656C656D656E74732E246469616C6F6729297B632E5F656C656D656E74732E246469616C6F672E6469616C6F672822636C6F736522297D6128646F63756D656E74292E74726967676572282265';
wwv_flow_api.g_varchar2_table(22) := '6E6B69746563636C6F626C6F616472656E646572636F6D706C65746522297D7D2C7375626D6974436C6F623A66756E6374696F6E2865297B76617220663D746869732C642C632C622C682C673B643D652E24656C6D745B305D3B633D24762864293B623D';
wwv_flow_api.g_varchar2_table(23) := '612E6461746128642C2264656661756C7456616C756522293B247328642C2222293B696628652E6368616E67654F6E6C793D3D3D224E227C7C63213D3D62297B696628662E6F7074696F6E732E73686F774D6F64616C3D3D3D225922297B662E5F696E63';
wwv_flow_api.g_varchar2_table(24) := '4469616C6F67436F756E7428293B696628662E5F6765744469616C6F67436F756E7428293D3D3D31297B662E5F73686F774469616C6F6728297D7D696628652E6D616B65426C6F636B696E673D3D3D225922297B683D7B705F666C6F775F69643A612822';
wwv_flow_api.g_varchar2_table(25) := '2370466C6F77496422292E76616C28292C705F666C6F775F737465705F69643A6128222370466C6F7753746570496422292E76616C28292C705F696E7374616E63653A6128222370496E7374616E636522292E76616C28292C705F726571756573743A22';
wwv_flow_api.g_varchar2_table(26) := '504C5547494E3D222B652E616A61784964656E7469666965722C7830313A225355424D49545F434C4F42222C6630313A5B5D7D3B683D662E5F6368756E6B436C6F6228632C33303030302C68293B612E616A6178287B747970653A22504F5354222C7572';
wwv_flow_api.g_varchar2_table(27) := '6C3A227777765F666C6F772E73686F77222C646174613A682C64617465547970653A2274657874222C6173796E633A66616C73652C636F6E746578743A746869732C737563636573733A66756E6374696F6E2869297B662E5F68616E646C655375626D69';
wwv_flow_api.g_varchar2_table(28) := '74436C6F625375636365737328297D7D297D656C73657B69662877696E646F772E576F726B6572297B673D6E657720576F726B657228662E6F7074696F6E732E706C7567696E46696C655072656669782B22656E6B697465632D636C6F622D6C6F61642D';
wwv_flow_api.g_varchar2_table(29) := '776F726B65722E6D696E2E6A7322293B672E6164644576656E744C697374656E657228226D657373616765222C66756E6374696F6E2869297B662E5F68616E646C655375626D6974436C6F625375636365737328297D2C66616C7365293B672E706F7374';
wwv_flow_api.g_varchar2_table(30) := '4D657373616765287B705F666C6F775F69643A6128222370466C6F77496422292E76616C28292C705F666C6F775F737465705F69643A6128222370466C6F7753746570496422292E76616C28292C705F696E7374616E63653A6128222370496E7374616E';
wwv_flow_api.g_varchar2_table(31) := '636522292E76616C28292C705F726571756573743A22504C5547494E3D222B652E616A61784964656E7469666965722C7830313A225355424D49545F434C4F42222C636C6F62446174613A637D297D656C73657B683D7B705F666C6F775F69643A612822';
wwv_flow_api.g_varchar2_table(32) := '2370466C6F77496422292E76616C28292C705F666C6F775F737465705F69643A6128222370466C6F7753746570496422292E76616C28292C705F696E7374616E63653A6128222370496E7374616E636522292E76616C28292C705F726571756573743A22';
wwv_flow_api.g_varchar2_table(33) := '504C5547494E3D222B652E616A61784964656E7469666965722C7830313A225355424D49545F434C4F42222C6630313A5B5D7D3B683D662E5F6368756E6B436C6F6228632C33303030302C68293B612E616A6178287B747970653A22504F5354222C7572';
wwv_flow_api.g_varchar2_table(34) := '6C3A227777765F666C6F772E73686F77222C646174613A682C64617465547970653A2274657874222C6173796E633A747275652C636F6E746578743A746869732C737563636573733A66756E6374696F6E2869297B662E5F68616E646C655375626D6974';
wwv_flow_api.g_varchar2_table(35) := '436C6F625375636365737328297D7D297D7D7D7D2C5F68616E646C655375626D6974436C6F62537563636573733A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E73686F774D6F64616C3D3D3D225922297B622E';
wwv_flow_api.g_varchar2_table(36) := '5F6465634469616C6F67436F756E7428297D696628622E5F6765744469616C6F67436F756E7428293D3D3D30297B69662821612E6973456D7074794F626A65637428622E5F656C656D656E74732E246469616C6F6729297B622E5F656C656D656E74732E';
wwv_flow_api.g_varchar2_table(37) := '246469616C6F672E6469616C6F672822636C6F736522297D6128646F63756D656E74292E747269676765722822656E6B69746563636C6F626C6F61647375626D6974636F6D706C65746522297D7D2C5F696E634469616C6F67436F756E743A66756E6374';
wwv_flow_api.g_varchar2_table(38) := '696F6E28297B76617220633D746869732C623D632E5F6765744469616C6F67436F756E7428293B696628623D3D3D756E646566696E65647C7C623C30297B623D313B632E5F7365744469616C6F67436F756E742862297D656C73657B622B2B3B632E5F73';
wwv_flow_api.g_varchar2_table(39) := '65744469616C6F67436F756E742862297D7D2C5F6465634469616C6F67436F756E743A66756E6374696F6E28297B76617220633D746869732C623D632E5F6765744469616C6F67436F756E7428293B696628623E3D30297B622D2D3B632E5F7365744469';
wwv_flow_api.g_varchar2_table(40) := '616C6F67436F756E742862297D7D2C5F6765744469616C6F67436F756E743A66756E6374696F6E28297B76617220633D746869732C623D612E6461746128646F63756D656E742C632E5F76616C7565732E6469616C6F67436F756E7444617461293B7265';
wwv_flow_api.g_varchar2_table(41) := '7475726E28623D3D3D756E646566696E65647C7C623C30293F303A627D2C5F7365744469616C6F67436F756E743A66756E6374696F6E2863297B76617220623D746869733B612E6461746128646F63756D656E742C622E5F76616C7565732E6469616C6F';
wwv_flow_api.g_varchar2_table(42) := '67436F756E74446174612C63297D2C5F6368756E6B436C6F623A66756E6374696F6E28672C642C66297B76617220653D746869732C623D4D6174682E666C6F6F7228672E6C656E6774682F64292B313B666F722876617220633D303B633C623B632B2B29';
wwv_flow_api.g_varchar2_table(43) := '7B662E6630312E7075736828672E736C69636528642A632C642A28632B312929297D72657475726E20667D7D297D2928617065782E6A5175657279293B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 41168048558374911 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_file_name => 'enkitec-clob-load.min.js'
 ,p_mime_type => 'text/javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396180000F00F20000FFFFFF000000C6C6C6B2B2B242424200000000000000000021FF0B4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904090A0000002C0000000080';
wwv_flow_api.g_varchar2_table(2) := '000F000003E708B20BFEAC3D17C5A4F1AA7CABF61D3781A3089918B391AB5949A9FB96EC6B9DF58CCBB9DDF340D54E1823B68C365A107664FA744527B4798B56A94AE4343994FE9E57AE35EB5D86B7E86F590B5EBBCF6AB8992C67CFBB3EBA1EBF1FF3FF';
wwv_flow_api.g_varchar2_table(3) := '7E81587862838285886977878A760C039091031392919495930F98990E9B97959F92A1969A98A390A79C009B9EA5A0AEA2B0A49DA6B2A8B6AAADB4AFBBB1BDB3ABACBCC1C3BAC4BEC7C0C6CBB5BFB7CEB9CDC9C2A9D5B8D6D0D8D3D1C5D2CCC2CADEE2DD';
wwv_flow_api.g_varchar2_table(4) := 'E4C8DFE6E3E8E5E0DAE7E1EBCFDBEDE9EFEAA2C3BF1AF8C9FAC8F917FB02FAE3077020A8040021F904090A0000002C0000000080000F000003FF08B40BFE22C607A5A0CE5EAC31E89CE581145949A318A24C5B6A5B06BF261C7FF3A9CA75CEEFB89EA6C5';
wwv_flow_api.g_varchar2_table(5) := 'A0016D46944EF963068FBEA713B99C5405C4C635696D76A55FAAF7260693A3655B96C03D0BA1EF297A1E0FD32DEBB67ECB1FEFFD7D667F667981697772756E708C898D11858092828688768A83871A059C9D051403A1A203A0A3A1A5A6A8A3AAA2ACA70F';
wwv_flow_api.g_varchar2_table(6) := 'A6AF0EB1A4B0B1AEB5B3B19E9DB8BEB6A9C0ABC2ADC4B200B4BFBAC1CBC3CDA2BC9CCAC8B7C6B9D4CCD8CEDAC5CFC7C9D6D3B4D19FE1E6DED7E0E8E2D5EBE7DCDFBBD1ECD9EAF0E9EDF7F4DBF6FDF2BCFBBAE97BE7AF5EBE82FC0EDE028821DB330F0EB9';
wwv_flow_api.g_varchar2_table(7) := '41DCF6B021458916055664052001010021F904090A0000002C0000000080000F000003FF08B40BFEAC3D276A9DD40A0CF4C61E17829A58929699A257C44CAE948DF359AFF7F5787AFEF913DEAFC30BF2620458CC482336854C9B530ADD15ADCFAB0FA974';
wwv_flow_api.g_varchar2_table(8) := '457153701588A56AC33DF470ACE6429665F1994D9FDBB378B3C7EDE0ABBF697579728381777A1A7E7E8288848D86856B878E168A7064987F71908F9291809E1A05A3A40513A5A41303ABAC03AAADABAFB0B2ADB4ACB6B10FB0B90EBBAEBABBB803A8A3A7';
wwv_flow_api.g_varchar2_table(9) := 'C4C2C8C0B3CAB5CCB7CEBC00BEC9BDC1D0C3C70FC4A6D7D4D2D6D5CBE1CDE3CFE5D1D3DDD7DBC6A8DEE9E7BFF1EFE0DFE2F6E4F8E6FAABECDAD9F3D4051CC84F5E417AF7E015F4E780E141810F092A9C588F62C260EE3064B4C5E10F5EB98EF93E62F0A8';
wwv_flow_api.g_varchar2_table(10) := '0FE43E911C13000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C97422E70BF4BE9EC085A3576AE73791A05949D43BBDD613AADDBDEA368FF939D64F1834F542B4990CB21C1A9DA8E3B31885E26E2269957ABD2599156558DB2562';
wwv_flow_api.g_varchar2_table(11) := '7766E0999CB5B6B9826F6C3C8FA0A76BF77D9B87EFCB785E4D0A83727E6C7F6F7D8B6A8D6948859174877A88969598949A58869D838C8F81A17C8EA2A61A05A9AA0513ABAAADAEAC0F03B4B50313B6B5B8B9B7B3BCBBB9C0B6C2BABEC1C6B6B1B20ECAB0';
wwv_flow_api.g_varchar2_table(12) := 'AEC4B4D0BD0EBCD300D5D2D9C8C5D4BFDBB4CD0FE1CCB1DADDC7E7C3DFD6D8EBE6D7DEE9B5E300F4F4EDF2D1EEFBF9ECF1F0E800AAEB67AF9C3883FDDEE113C88DA1BE84FC1CFACB55F0D9418B10334A54F86F1AA1C78EBF305E4CC541A43C0E014F5E48';
wwv_flow_api.g_varchar2_table(13) := 'C910E5C06D2E1B9E4C000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F102C1B9EEDE050A1F587667388D2959495835BD16F4AE23F9E4BAC3E3AC5D0E6812067D39DAEC66933533C622F2B8194651575595FACB0A944FC6D2';
wwv_flow_api.g_varchar2_table(14) := '19834EA55B74F78C656BD7E9769C032E8BC33005D3DD9BF7E180567C44723C757A6488668A77835E846F827E907F92867B8C798787815C969F9EA16A49989BA5989DA3A285A0AAAE1D05B1B20513B3B2B5B6B40FB9BA0E03BFC00313C1C0C3C4C20FC7C8';
wwv_flow_api.g_varchar2_table(15) := 'BEC7C6C4CEC1D0C0BCB8B6D5B3D7B7C9CDDBCFDDD1DFC5E1BFD2E4E3CB00CAD4BBB9D9B1EEBDE9DCCCDEF4E0F6E2F8E6FAE8CAE503EB1C04043070A0BF73FF12225CC8EF5FC176ECAC45C4C6505E3D8BF730E6D3B88F2B63BF791E1F4A140891E4488F0A';
wwv_flow_api.g_varchar2_table(16) := '1B563CA8B225CA9326DF5D804990A2340D17F1E1CCA8F3424E8D3B8B25000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7C85F7DA07766258929F99A2602561D5E45A902BDB8FB83AFAC8F7939E2008CC157FBAD92D56';
wwv_flow_api.g_varchar2_table(17) := '63C2384F0651373D21AD006175973D7693B8E86BE32443CD5223558DD5B2B9EE2BBCA76C9EEB625A7EEBFBB6BD717E736B721E786863878A61827D818F8091848D028B6596778C90939B7F9C922298697B76A3887A947C436F8EA0839E2205B2B30513B4';
wwv_flow_api.g_varchar2_table(18) := 'B3B6B7B50FBABB0EBD1303C2C303C1C4C2C6C7C9C4CBC3CDC80FC7C2C0BCBAB9B7D7B4D9B8D1D2CFC5DDCAE1CCE3CEE5D00ED203D4BFD6D5D8EFDAF1DCE9DEE7E0F5E2F9E4FBE6FDE800D4B10330B0A0BB76F0FEE10B684FE1B787F7BE194C48F060458A';
wwv_flow_api.g_varchar2_table(19) := '03D5417418B12D23478513E52114799164C6860CF5A5E4B7D25F4B801A23521CE96B9E8699256BF6D3A072E7859E2D79B2DC99000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CAB1620F885C2189AE245962AB97950';
wwv_flow_api.g_varchar2_table(20) := '65C53056BF9C9D036BEAF4AC5F6F02240E1F40D94CC798289D32E8ED893C0A57466C557B756D4954A644BCC43569BB30CFBAE6B6BDDDD3571E07A9EF51F4992CDD15E73E6F7482817F75027853797C7A63668E8684419259709480888B8F6589699A6A91';
wwv_flow_api.g_varchar2_table(21) := 'A16CA26E499FA78AA99E37A496AD83AF2005B3B40513B5B4B7B8B60FBBBC0EBEBAB81303C5C603C4C7C5C9CACCC7CEC6D0C5C1BDBBC2B5D7B9D5C3DBD80FCACBDFE0D2C8E2CDE6CFE8C6D4C0D6DDDAEDDCF1DEF3F000E0E50EF8E4FCEAE1FAE0D8011048';
wwv_flow_api.g_varchar2_table(22) := 'D05DBD59D910FACB776FDCC27E00CF453C5650DE4083172D56A4D7503362C77413A33D1C19721AC68DF6502A3CF8EBA3C8920CF79174F98F26328BF534E0CCB8F29D4E8E2135780C7A61A84BA1CF12000021F904090A0000002C0000000080000F000003';
wwv_flow_api.g_varchar2_table(23) := 'FF08B40BFEAC3D17C9A4F1AA7CABF697208ADA48866699A2E30662AFCBC1B3CC4C9544DF8FD9F63EC1242804FA86C19C0592C3359931A533FA74109147E3CA1AC49AA4D01A78A7B395C7E62537BBDE02AEDA5F7B84AE57D353F11D0D9F9FFC45805E747B';
wwv_flow_api.g_varchar2_table(24) := '8554877A883C82717F6F5D8D818F3E768A678689998B936E7D9C729F8E44959A97966A78619B9EAC908C8005B1B20513B3B2B5B6B40FB9BA0EBCB8B6C0B31303C5C603C4C7C5C9CACCC7CEC6BFBBB9C2B7D3C1D7C3D9D6BED40FCACBDFE0D0E10EE0C8E2';
wwv_flow_api.g_varchar2_table(25) := 'CAD2DDD8ECDAEEDC00EBF2DEF0B1E4E8E6E3E9CFFCC6F8F302D6A3D78EE03B83F1E69DC3C7D05F3900E7041694789062C2810B1DE683B84F2E5F338D16EF6D1369AF174292274D2AECC8F1A3C77E2FFF6944A8A120BC9A076F5EB049F3824B7F1A7EC60C';
wwv_flow_api.g_varchar2_table(26) := 'FA2C010021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CABF61D370924A995E6850A27BA8118FC8A333355524CE316848F2BD623287410812BDEEDE793299B3BA6CE06A51A8348D710BB4D4A6B39706F1A7E92C7E2A5EC';
wwv_flow_api.g_varchar2_table(27) := 'D8D55E57D992395D2D7FE7F8FB97FD7603F87F41794E7A848651875681706D2571297D728588948A8395766B5C91908B7E44979693A28999986880A99B9E2505AEAF0513B0AFB2B3B10FB6B70EB9B5B3BDB0BFB40F03C4C50313C6C5C8C9C7C3CCBCB8B6';
wwv_flow_api.g_varchar2_table(28) := 'C1AED3BA00D0BBD2D1BEDBC0CEC9CBE0DFC6E1C6D8D7DAD9DCEADEECC2EED4DDEFE8EB00CCCD0EF7E5CAE3C5E7FFE9E8B513380F60BD73FAFA11DBB750E100830321160C28311E3C6B09F3316388CF27DE338A200F868C387262BD8C1EC5695499925C3D';
wwv_flow_api.g_varchar2_table(29) := '771A5E128C3910E605993259AE6CB84F03B8040021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CABF61D378193609ADA895EAAB091AF1833636541760DDB37B6E78FD6CA217405853C9D2C89FB3997401F14562C09AD2D';
wwv_flow_api.g_varchar2_table(30) := 'A694D69C7AB95B49B8371397C9D5630BABD29E95E07737EEAE47E5C4AB5AC53ED99F74777F5F66837169796B7B7E828D80858E8464866688009645949391818F9B9E70957A897C8B2605A8A90513AAA9ACADAB0FB0B10EB3AFADB7AAB9AEB2B01303C0C1';
wwv_flow_api.g_varchar2_table(31) := '03BFC2C0C4C5B6BDB8CABACCBCB5BECEA8BBD3D2B400C90EC5C60FDBC3DDDBD9D8D1D0CBE5CDE7CFE3E6EBE8EDEAE2DEC7C2F3C1E2F7E4EFD5E9FBFAD7F8ECE26DABC74D5BB87C00DD258487B061C07CF2C015233860613F8BFF1C2AD4C8901B5D448313';
wwv_flow_api.g_varchar2_table(32) := '25D263974E03C97726DD95BC70B2A54A0021EB699898000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CABF61D3781A3F80828AAA56A2561E416BB16E496F36DE7BCC9A6931F8A86331177461D2CD963149D48A84328';
wwv_flow_api.g_varchar2_table(33) := '080A8F4BA98CC9D562B75E25F835AE4D85D6DF772D6637C9EE2E5C4C4DB3E2E1B7B9FC9CEBFB7B5F7527576D867F517E7281878B7640846A8D798E898C88598A945A83673F05A0A10513A2A1A4A5A30FA8A90EABA7A5AFA2B1A6AAA8B3A01303BABB03B9';
wwv_flow_api.g_varchar2_table(34) := 'BCBAAEB5B0C2B2C4B4ADB6C6B8CAAC00C1C8C3D0C50EBFBABEBFCFCEC9D2C7DAD1DED3E0DDD9E4DBE2CBD4D5D7BCE5DFEDE1EFE3E6F1E8E7CDD5BD0FF8F4CDFCB7FDF302BA13180EDFBA5DFE98FD5BA8B021B77A09D3FD3A68ED1B370D16C5610C77F10C';
wwv_flow_api.g_varchar2_table(35) := '42C68F1C355E9838921780040021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CABF61D3781A308998EA0AA1BD99A9584B9B175D27189EF70FEACC09AAEC7630C8D37A212395BCA5E4C0070254C46ABCDAB2FFBC442BBDB';
wwv_flow_api.g_varchar2_table(36) := 'AF8D3B964E05DE74585D04B7CB6C67F98C5EDBDF47B73C0FBFEF7F67715A78567A837F647C8A805382868F7D8489859188621374059A9B05139C9B9E9F9D0FA2A30EA5A19FA99CABA0A4A2AD9AB1A60003B6B703A8AFAABBACBDAEA7B0BFB2C3B4BAC1BC';
wwv_flow_api.g_varchar2_table(37) := 'C8BECAC0B5B8B6C700D1D3C2CCC4D6C6D5D2DAD4C9DBDECFD0DCE3DEDDCBDFE7E6CDEAD7E8CDE1B9E4E9F2EBF4EDECD9E5F6B4F0F8B3FFC5006213E8EEDEBE09F0DC69F0C66CE1B98617182A8CF870622B87CD1C3C0390000021F904090A0000002C0000';
wwv_flow_api.g_varchar2_table(38) := '000080000F000003E708B40BFEAC3D17C9A4F1AA7CABF61D3781A3089918B391AB5949A9FB96EC6B9DF58CCBB9DDF340D54E1823B68C365A107664FA744527B4798B56A94AE4343994FE9E57AE35EB5D86B7E86F590B5EBBCF6AB8992C67CFBB3EBA1EBF';
wwv_flow_api.g_varchar2_table(39) := '1FF3FF7E81587862838285886977878A760C059091051392919495930F98990E9B97959F92A1969A98A390A79C009B9EA5A0AEA2B0A49DA6B2A8B6AAADB4AFBBB1BDB3ABACBCC1C3BAC4BEC7C0C6CBB5BFB7CEB9CDC9C2A9D5B8D6D0D8D3D1C5D2CCC2CA';
wwv_flow_api.g_varchar2_table(40) := 'DEE2DDE4C8DFE6E3E8E5E0DAE7E1EBCFDBEDE9EFEAA2C3BF1AF8C9FAC8F917FB02FAE3077020A804003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 64252976778717210 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 64241756396757628 + wwv_flow_api.g_id_offset
 ,p_file_name => 'enkitec-loading.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

--application/shared_components/plugins/process_type/gpv_ir_to_msexcel
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 150521812936685592 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'PROCESS TYPE'
 ,p_name => 'GPV_IR_TO_MSEXCEL'
 ,p_display_name => 'GPV Interactive Report to MSExcel'
 ,p_supported_ui_types => 'DESKTOP'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_execution_function => 'IR_TO_MSEXCEL.get_xlsx_from_ir'
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_help_text => '<p>'||unistr('\000a')||
'	The &quot;GPV Interactive Report to MSExcel&quot; APEX plugin lets you getting results of your Interactive Report in Excel-format, with <span class="short_text" id="result_box" lang="en"><span class="hps">correct displaying of Strings</span></span>, Number and Dates.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	Supported IR features:<br />'||unistr('\000a')||
'	* Filtering and Sorting<br />'||unistr('\000a')||
'	* Control Break<br />'||unistr('\000a')||
'	* Computations<br />'||unistr('\000a')||
'	* Aggregations<br />'||unistr('\000a')||
'	<br />'||unistr('\000a')||
'	<br />'||unistr('\000a')||
'	<br />'||unistr('\000a')||
'	&nbsp;</p>'||unistr('\000a')||
''
 ,p_version_identifier => '1.9'
 ,p_about_url => 'http://glebovpavel.github.io/plugin'
 ,p_plugin_comment => 'Do not move ExcelTemplate.zip to the WEB-Server !!!'||unistr('\000a')||
'Package IR_TO_MSEXCEL need to be installed on each oracle-scheme where the plugin is used.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 77485432691089486 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 150521812936685592 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Maximum Rows'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_is_translatable => false
 ,p_help_text => 'Rows greater than this value will not be exported. '||unistr('\000a')||
'To export all the rows set the value to 1000000000.'||unistr('\000a')||
'When empty - value from Interactive Report Attributes-> Maximum Row Count will be used.'||unistr('\000a')||
''
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 145046964382695812 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 150521812936685592 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 6
 ,p_display_sequence => 60
 ,p_prompt => 'Download when click on (JQuery Selector)'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_is_translatable => false
 ,p_help_text => 'Download XLSX process stared when user clicks on items with this jquery selector.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 145025261105909795 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 150521812936685592 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 7
 ,p_display_sequence => 70
 ,p_prompt => 'Download Type'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'E'
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 145025652910913626 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 145025261105909795 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Excel XLSX'
 ,p_return_value => 'E'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 145026049244915294 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 145025261105909795 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'XML (Debug)'
 ,p_return_value => 'X'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 145026445577916975 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 145025261105909795 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => 'Debug TXT'
 ,p_return_value => 'T'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 145049064650956721 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 150521812936685592 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 10
 ,p_display_sequence => 10
 ,p_prompt => 'Replace standard IR XLS download'
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
 ,p_help_text => 'Replace standard IR download XLS menu functionality to download XLSX feature. '
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '504B03041400060008000000210062EE9D686101000090040000130008025B436F6E74656E745F54797065735D2E786D6C20A2040228A0000200000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(2) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(3) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(4) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(5) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(6) := '000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000AC944D4FC3300C86EF48FC872A57D466E380105AB7031F4798C4F801A171D7';
wwv_flow_api.g_varchar2_table(7) := '686912C5DED8FE3D6EF62184CAA6895D1AB5B1DFF7896B673459B7365B4144E35D2986C54064E02AAF8D9B97E263F692DF8B0C4939ADAC77508A0DA0988CAFAF46B34D00CC38DB61291AA2F02025560DB40A0B1FC0F14EED63AB885FE35C06552DD41CE4';
wwv_flow_api.g_varchar2_table(8) := 'ED6070272BEF081CE5D46988F1E8096AB5B4943DAFF9F396248245913D6E033BAF52A810ACA91431A95C39FDCB25DF39149C9962B031016F1843C85E876EE76F835DDE1B97261A0DD954457A552D63C8B5955F3E2E3EBD5F14C7457A287D5D9B0AB4AF96';
wwv_flow_api.g_varchar2_table(9) := '2D57A0C01041696C00A8B5455A8B5619B7E73EE29F8251A665786190EE7C49F80407F1FF06999EFF474832270C913616F0C2A7DD8A9E726E5404FD4E9127E3E2003FB58F7170DF4CA30FC81314E1FC2AEC47A4CBCE030B4124038721E96BB683234FDFF9';
wwv_flow_api.g_varchar2_table(10) := '86BFBA1DBAF9D6A07BBC65BA4FC6DF000000FFFF0300504B030414000600080000002100B5553023F50000004C0200000B0008025F72656C732F2E72656C7320A2040228A000020000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(11) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(12) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(13) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(14) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(15) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000008C92CF4EC3300CC6EF48BC43E4FBEA6E48';
wwv_flow_api.g_varchar2_table(16) := '08A1A5BB4C48BB21541EC024EE1FB58DA32440F7F68403824A63DBD1F6E7CF3F5BDEEEE669541F1C622F4EC3BA2841B133627BD76A78AD9F560FA06222676914C71A8E1C6157DDDE6C5F78A4949B62D7FBA8B28B8B1ABA94FC2362341D4F140BF1EC72A5';
wwv_flow_api.g_varchar2_table(17) := '913051CA6168D19319A865DC94E53D86BF1E502D3CD5C16A08077B07AA3EFA3CF9B2B7344D6F782FE67D62974E8C409E133BCB76E543660BA9CFDBA89A42CB498315F39CD311C9FB2263039E26DA5C4FF4FFB63871224B89D048E0F33CDF8A7340EBEB81';
wwv_flow_api.g_varchar2_table(18) := '2E9F68A9F8BDCE3CE2A784E14D64F861C1C50F545F000000FFFF0300504B030414000600080000002100F04C147DD30000004A01000023000000786C2F776F726B7368656574732F5F72656C732F7368656574312E786D6C2E72656C7384D0C14A04310C';
wwv_flow_api.g_varchar2_table(19) := '06E0BBE03B94DC9DCE7A109199D98B0A7BF022EB03C436D3966D93D256D9797B7B515C103CFE24F91232EDCF29AA4F2A3508CFB01B4650C4466C6037C3DBF1F9E61E546DC816A330CDB05185FD727D35BD52C4D687AA0FB9AAAE709DC1B7961FB4AEC653';
wwv_flow_api.g_varchar2_table(20) := 'C23A4826EE95554AC2D663713AA339A1237D3B8E77BAFC3660B930D5C1CE500E7607EAB8E5BEF97F5BD635187A14F39188DB1F2BB4EF5289814F1DC5E2A8FDB08D8C6789E2B60153A80347FDDE93FE6E7C11DB6F783A372A8C11F432E98B0F2C5F000000';
wwv_flow_api.g_varchar2_table(21) := 'FFFF0300504B03041400000008001578084583AFEAE3B5050000E31B000013000000786C2F7468656D652F7468656D65312E786D6CED59C9CBD34014BF0BFE0F43EE9A74C96715ABD8DABA2F68553CBEA6D36674920933D34F7B133D0A82B8E045F0E641';
wwv_flow_api.g_varchar2_table(22) := '5C40C18BFE356EB880FF822F49DB24CD54EB2EEAF7413BCBEFEDF3DE2CDDBEF37CC0C93A958A89B06955363B16A1A127062C1C35AD13BDEEA68645948670005C84B4694DA8B276EED8B8613B6CD33E0D2841FA506D83A6E56B1D6DB36DE5E130A8CD22A2';
wwv_flow_api.g_varchar2_table(23) := '21CE0D850C4063578EEC818473C837E076D571D6EC005868911002647B6438641E25BD98A5B563C6BCC3F123D42A1EF0B83CEEC583798A143B385B89BFD444B5B924EBC09B16CA1988733D7A5E5B8483D238D1B49CE4CFB2776CB7E7445C2FA1CDD17593';
wwv_flow_api.g_varchar2_table(24) := 'BF846E4A109357133A39EACF092BDDFAD62DBBE7FCAB29FF32AED3E9B43B9504370780E7A1A59512B6DE6D545A539E1968D62CF36E3BAE532FE0F3FC6B25FCD656ABE56E2DE06B19BE5EC2379CB5FAAE6A015FCFF06E59FFD6AE767BAD807733FC5A09DF';
wwv_flow_api.g_varchar2_table(25) := 'DDB275AD3EC767209FB3F0EC023A8DE82C32196428F85E23BC81F0C66C0164283BB7BA52FA502F5B6B019C11B28B8024B8A05948F424A243F010D786A02F1958248250281C70AA4ED7A9E167FC5F4F5A75148FA4147274E990A70A43334D88F2248B74D3';
wwv_flow_api.g_varchar2_table(26) := 'DA8F5CAD1CE4E3B3FB1F9F3D261F9F3D7A71F1C98B8B4F5F5CBAF4E2E24303E15E084779C2F777AF7EB87D81BC7B7CE7FDF51B66BCCAE35F3DB8FCF2F9353350E781AF6F3E7AF3E4D1EB5B57DEDEBB6E80EF92D0CFC37B2CA08A1CA6E7C8311140681240';
wwv_flow_api.g_varchar2_table(27) := 'FBF2EB287A3EB00205F88834003BDA2F000F4F809B702D5A74DE4989E5C104DC333E53D0F5B82FC79A198007FCA0003C24046F096934E700CA2A98330E4766E1729CC71D035837C96E2F84B6338E709D3330417D5A50F328C768C388865493784E9CA5D4';
wwv_flow_api.g_varchar2_table(28) := '40769A3156B08E79522831D4E434232D604697F4585F9B89F6B200E3320173A8A1407492B40437B1DF4DD78B48402F72134BCA0B6EDC03630D81516308781E7910B46F52F2F8447A05872B2D513AE5827406542913CD113929A87B00383387FD109F0445';
wwv_flow_api.g_varchar2_table(29) := 'A4D4EC6C1919EB27441EB95B9C6DFB1044469D59E8E7B1FBD4595CA2408E0A6D5442E43324ED631C205C1AEE938CEAAF4BEB136CE49B17483C3396A694A0A2988F133E049A30B717EA78C0C2CF1575CEB0AA2F1475F77F513717F55DB801F2CF97F20CF7';
wwv_flow_api.g_varchar2_table(30) := '7714F0DD300E8FD2D0FF5FBFFFD7EF7FB27E27B9FC4BAA7656A8ED9430776A0F961EDA878CF3E37AC2E94195947885E60DBA38987412A2F91D21F2B199885BC08D24246D22853EC5B47FDC8708C554AC645221EBB44122A17093B096F14E26708BD1E998';
wwv_flow_api.g_varchar2_table(31) := '9BDE491334E84362900ED7B2BB6A8E0DF6621179413564B0B2B0DA96EF135641D8EAD22AAE599AFB596976CE9B983704B30D59AD5553D1B85080D3018E240C92B0FC9C10291F06741AA38AD1904A6D25B7A5F7CED5A56DAD2D91F603839417575F22CEFD';
wwv_flow_api.g_varchar2_table(32) := '0151724A51B2CBE9C8C3628F9C43ADDCAA6B110FA2A635C41319368308F9A9B854011FE15B95A71353B2245DD960D76CB0B3C4E0051191547A37283FA54AA6664F3961A67FD545B7FE2803EC6FD5A2D6A8FC462DECC5D0D2E1907A7AC948D69DCE89B1A6';
wwv_flow_api.g_varchar2_table(33) := 'F2B83F3847FA7C2C8F01EA5D4F57D780298D2E9E75F0890EBD9DF41632DFB1CA4F465976008F7C98D6A4C62CF67378DCCE74C05E413DBBA0FB779B52FB81A6B8FFAE29F1CAC5036E6D905CBDF01820814432564B48ED0BAC4291CFBCAEC48343220BF5C2';
wwv_flow_api.g_varchar2_table(34) := '675E9C461DF17D3BF996747D56B7663CD22237F2F53136229261A5D3BEA4F4A89EDAF90566956AB6BF668CB053505745E9779FAE53DE8BB3770DED471E7E524DA6F429AE1C34DB945DFD51F70F3EF9D49DAF3F1E648252FAD585A54B69712BD8BA44859F';
wwv_flow_api.g_varchar2_table(35) := 'B3D556CD1657DD95B7DA08AF2924FEC0C2CDA4C7B3F36D4F1CC3E893F98992E042DCD498A6DF7CB08F3A37E6C6A5FC7EEE312A0B41C3F9F987CF9CB36B8BE2E631F839CE760DBE763FEF6ABB9CA276EE2213F7CA3F8489FE1994BD1BEF4763AE55FAEE74';
wwv_flow_api.g_varchar2_table(36) := '1E2FA5EDE94F18311F3B23DDF109504B030414000600080000002100A69888AE7E010000FD02000010000801646F6350726F70732F6170702E786D6C20A2040128A000010000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(37) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(38) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(39) := '0000000000000000000000000000000000000000000000009C92414FE3301085EF48FB1F22DFA9D32E5AA1CA314285158745546ACB9E8D33692C5C3BF20C51BBBF9E49A2D214F6C46D66DED3F3E7B1D5CD7EE7B31612BA180A319DE422836063E9C2B610';
wwv_flow_api.g_varchar2_table(40) := '9BF5EFCB6B912199501A1F0314E200286EF48F0BB54CB181440E30E3888085A8899AB994686BD8199CB01C58A962DA19E2366D65AC2A67E12EDAB71D0492B33CFF25614F104A282F9B8F403124CE5BFA6E68196DC787CFEB43C3C05ADD368D77D610DF52';
wwv_flow_api.g_varchar2_table(41) := '3F3A9B22C68AB2FBBD05AFE458544CB702FB961C1D74AEE4B8552B6B3C2C385857C62328791AA80730DDD296C625D4AAA5790B9662CAD0FDE3B5CD44F662103A9C42B426391388B13ADBD0F4B56F9092FE1BD32BD600844AB26118F6E5D83BAEDD959EF6';
wwv_flow_api.g_varchar2_table(42) := '062ECE8D5DC000C2C239E2DA91077CAA9626D17F88A763E29E61E01D70183F862F78FD8DF9A04FD17F5C78C54DB38E7786E0B8BAF3A15AD52641C9DB3EEAA7817AE0AD25DF852C6A13B6501E3D5F85EEA19F87DFACA75793FC67CE6F389A2979FAB7FA1D';
wwv_flow_api.g_varchar2_table(43) := '0000FFFF0300504B0304140006000800000021007D21B1C23C0100005102000011000801646F6350726F70732F636F72652E786D6C20A2040128A00001000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(44) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(45) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(46) := '00000000000000000000000000000000008C925F4BC33014C5DF05BF43C97B9B3F8529A1ED40654F0E04278A6F21B9DB8A4D1A9268B76F6FDA6EB5833DF878EF39F9DD732F299607DD243FE07CDD9A12D18CA0048C6C556D76257ADBACD27B94F8208C12';
wwv_flow_api.g_varchar2_table(47) := '4D6BA04447F06859DDDE14D272D93A7871AD05176AF0492419CFA52DD13E04CB31F6720F5AF82C3A4C14B7ADD322C4D2EDB015F24BEC003342165843104A04817B606A27223A21959C90F6DB350340490C0D6830C1639A51FCE70DE0B4BFFA6050664E5D';
wwv_flow_api.g_varchar2_table(48) := '87A38D3B9DE2CED94A8EE2E43EF87A32765D9775F91023E6A7F863FDFC3AAC9AD6A6BF950454154A72E94084D655059E17F1708DF0611D6FBCAD413D1CA37EA5A7E4107784804A62003EC63D2BEFF9E3D366852A462849294B49BE618CB33B4E169FFDC8';
wwv_flow_api.g_varchar2_table(49) := '8BF77DA0B1A14F83FF41A4AC27E639276C463C03C6DC979FA0FA050000FFFF0300504B01022D001400060008000000210062EE9D6861010000900400001300000000000000000000000000000000005B436F6E74656E745F54797065735D2E786D6C504B';
wwv_flow_api.g_varchar2_table(50) := '01022D0014000600080000002100B5553023F50000004C0200000B000000000000000000000000009A0300005F72656C732F2E72656C73504B01022D0014000600080000002100F04C147DD30000004A0100002300000000000000000000000000C00600';
wwv_flow_api.g_varchar2_table(51) := '00786C2F776F726B7368656574732F5F72656C732F7368656574312E786D6C2E72656C73504B01023F001400000008001578084583AFEAE3B5050000E31B00001300240000000000000020000000D4070000786C2F7468656D652F7468656D65312E786D';
wwv_flow_api.g_varchar2_table(52) := '6C0A0020000000000001001800FFC87F6000B3CF01E8A17F6000B3CF015F235B6000B3CF01504B01022D0014000600080000002100A69888AE7E010000FD0200001000000000000000000000000000BA0D0000646F6350726F70732F6170702E786D6C50';
wwv_flow_api.g_varchar2_table(53) := '4B01022D00140006000800000021007D21B1C23C0100005102000011000000000000000000000000006E100000646F6350726F70732F636F72652E786D6C504B05060000000006000600AD010000E11200000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 145017969036206052 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 150521812936685592 + wwv_flow_api.g_id_offset
 ,p_file_name => 'ExcelTemplate.zip'
 ,p_mime_type => 'application/zip'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

--application/shared_components/plugins/region_type/com_jwilson_apex_drop_menu
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'REGION TYPE'
 ,p_name => 'COM.JWILSON.APEX.DROP_MENU'
 ,p_display_name => 'DropDownMenu'
 ,p_supported_ui_types => 'DESKTOP'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'function render_dropdown_menu ('||unistr('\000a')||
'      p_region              in apex_plugin.t_region,'||unistr('\000a')||
'      p_plugin              in apex_plugin.t_plugin,'||unistr('\000a')||
'      p_is_printer_friendly in boolean '||unistr('\000a')||
') return apex_plugin.t_region_render_result'||unistr('\000a')||
'is'||unistr('\000a')||
'    -- It''s better to have named variables instead of using the generic ones,'||unistr('\000a')||
'    -- makes the code more readable'||unistr('\000a')||
'    l_skip_level        NUMBER := nvl(p_region.attribute_01, '||
'0);'||unistr('\000a')||
'    '||unistr('\000a')||
'    l_sql_handler       apex_plugin_util.t_sql_handler;'||unistr('\000a')||
'    l_column_value_list apex_plugin_util.t_column_value_list;'||unistr('\000a')||
'    l_id	        NUMBER :=0;'||unistr('\000a')||
'    l_parent_id         NUMBER :=0;'||unistr('\000a')||
'    l_label             VARCHAR2(32767) := '''';'||unistr('\000a')||
'    l_link              VARCHAR2(32767) := '''';'||unistr('\000a')||
'    l_level             NUMBER :=0; '||unistr('\000a')||
'    l_prev_id	        NUMBER;'||unistr('\000a')||
'    l_prev_parent_id    NUMBER;'||unistr('\000a')||
'    l_prev_labe'||
'l        VARCHAR2(32767);'||unistr('\000a')||
'    l_prev_link         VARCHAR2(32767);'||unistr('\000a')||
'    l_prev_level        NUMBER;   '||unistr('\000a')||
'    l_fut_dir		NUMBER :=0;'||unistr('\000a')||
'    l_prev_dir		NUMBER;'||unistr('\000a')||
'    '||unistr('\000a')||
'begin'||unistr('\000a')||
'    -- Register the javascript library the plug-in uses.'||unistr('\000a')||
'    apex_javascript.add_library ('||unistr('\000a')||
'            p_name      => ''stuHover'','||unistr('\000a')||
'            p_directory => p_plugin.file_prefix,'||unistr('\000a')||
'            p_version   => null );'||unistr('\000a')||
''||unistr('\000a')||
'    apex_css.add_file'||
' ('||unistr('\000a')||
'        p_name      => ''pro_dropdown_3jw'','||unistr('\000a')||
'        p_directory =>p_plugin.file_prefix,'||unistr('\000a')||
'        p_version   => null );   '||unistr('\000a')||
''||unistr('\000a')||
'    -- check sql statement, it has to be in the format "label", "link" and "value"'||unistr('\000a')||
'    begin'||unistr('\000a')||
'        l_sql_handler := apex_plugin_util.get_sql_handler ('||unistr('\000a')||
'                             p_sql_statement  => p_region.source,'||unistr('\000a')||
'                             p_min_columns    => 5,'||unistr('\000a')||
'    '||
'                         p_max_columns    => 5,'||unistr('\000a')||
'                             p_component_name => p_region.static_id );'||unistr('\000a')||
'                             '||unistr('\000a')||
'        -- column "value" has to be of type NUMBER for columns 1 ,2, and 5'||unistr('\000a')||
'        if l_sql_handler.column_list(1).col_type <> dbms_types.TYPECODE_NUMBER then '||unistr('\000a')||
'            raise_application_error(-20000, ''First column in select list must be of type NU'||
'MBER'');'||unistr('\000a')||
'        end if;'||unistr('\000a')||
'        '||unistr('\000a')||
'        if l_sql_handler.column_list(2).col_type <> dbms_types.TYPECODE_NUMBER then '||unistr('\000a')||
'	    raise_application_error(-20000, ''Second column in select list must be of type NUMBER'');'||unistr('\000a')||
'        end if;'||unistr('\000a')||
'      '||unistr('\000a')||
'        if l_sql_handler.column_list(5).col_type <> dbms_types.TYPECODE_NUMBER then '||unistr('\000a')||
'		    raise_application_error(-20000, ''Fifth column in select list must be of typ'||
'e NUMBER'');'||unistr('\000a')||
'        end if;'||unistr('\000a')||
'        '||unistr('\000a')||
''||unistr('\000a')||
'        apex_plugin_util.free_sql_handler(l_sql_handler);'||unistr('\000a')||
'    exception when others then'||unistr('\000a')||
'        apex_plugin_util.free_sql_handler(l_sql_handler);'||unistr('\000a')||
'        raise;'||unistr('\000a')||
'    end;'||unistr('\000a')||
'    '||unistr('\000a')||
'    -- get data based on our new sql statement'||unistr('\000a')||
'    l_column_value_list := apex_plugin_util.get_data ('||unistr('\000a')||
'                               p_sql_statement  => p_region.source,'||unistr('\000a')||
'                '||
'               p_min_columns    => 5,'||unistr('\000a')||
'                               p_max_columns    => 5,'||unistr('\000a')||
'                               p_component_name => p_region.static_id );'||unistr('\000a')||
'                               '||unistr('\000a')||
'  --Start the menu code'||unistr('\000a')||
'  sys.htp.prn(''<ul id="nav" style="display:none">'');'||unistr('\000a')||
''||unistr('\000a')||
'  -- print menu based on the result set'||unistr('\000a')||
'  FOR i in 1 .. l_column_value_list(1).count /* label */'||unistr('\000a')||
'  LOOP'||unistr('\000a')||
'	l_prev_id	:= l_id;'||unistr('\000a')||
' '||
'       l_prev_parent_id:= l_parent_id;'||unistr('\000a')||
'        l_prev_label	:= l_label;'||unistr('\000a')||
'        l_prev_link	:= l_link;'||unistr('\000a')||
'        l_prev_level	:= l_level;  '||unistr('\000a')||
'        l_prev_dir	:= l_fut_dir;'||unistr('\000a')||
'	l_id		:= l_column_value_list(1)(i);'||unistr('\000a')||
'        l_parent_id	:= l_column_value_list(2)(i);'||unistr('\000a')||
'        l_label		:= l_column_value_list(3)(i);'||unistr('\000a')||
'        l_link		:= l_column_value_list(4)(i);'||unistr('\000a')||
'        l_level		:= l_column_value_list(5)(i);'||unistr('\000a')||
'  '||
'      '||unistr('\000a')||
'        /********************************************'||unistr('\000a')||
'        First check which direction the level is going'||unistr('\000a')||
'        Positive = downward'||unistr('\000a')||
'        Zero = equal'||unistr('\000a')||
'        Negative = upward'||unistr('\000a')||
'        **********************************************/'||unistr('\000a')||
'        l_fut_dir := l_level-l_prev_level;     '||unistr('\000a')||
'        '||unistr('\000a')||
'          '||unistr('\000a')||
'        /* Need to work with the previous record at all times so we can determine if '||
'the '||unistr('\000a')||
'        current record is a child.  We''ll print the last record at the end.'||unistr('\000a')||
'        */'||unistr('\000a')||
'        IF l_prev_id = 0 THEN'||unistr('\000a')||
'          --Skip the first time through'||unistr('\000a')||
'          NULL;'||unistr('\000a')||
'	ELSIF l_prev_level = l_skip_level THEN'||unistr('\000a')||
'	  --Do Nothing'||unistr('\000a')||
'	  NULL;  '||unistr('\000a')||
'	ELSE'||unistr('\000a')||
'	  --End any prior menus started'||unistr('\000a')||
'	  IF l_prev_dir < 0 THEN'||unistr('\000a')||
'	    FOR i IN 1..(-1 * l_prev_dir) LOOP'||unistr('\000a')||
'		sys.htp.prn(''</ul></li>'');'||unistr('\000a')||
' 	    END LOOP;'||unistr('\000a')||
' 	  E'||
'ND IF;'||unistr('\000a')||
'		'||unistr('\000a')||
'	  --Check to see if this is a top level record'||unistr('\000a')||
'	  IF l_prev_level = l_skip_level + 1 THEN    '||unistr('\000a')||
'	    --Check to see if this has a child record'||unistr('\000a')||
'	    IF l_fut_dir >= 1 THEN'||unistr('\000a')||
'	      --Print the top level structure with the down arrow'||unistr('\000a')||
'	      sys.htp.prn(''<li class="top" onmousemove="$(this).find(''''ul:first'''').addClass(''''showmenu'''')" onmouseout="$(this).find(''''ul:first'''').removeClass(''''showmenu'||
''''')"><a href= "''||'||unistr('\000a')||
'	      l_prev_link ||''" id= "'' || l_prev_id ||''" class="top_link"><span class="down">''||'||unistr('\000a')||
'	      l_prev_label ||''</span></a>'');	    '||unistr('\000a')||
'	    ELSE'||unistr('\000a')||
'	      --Print the top level structure with no down arrow'||unistr('\000a')||
'	      sys.htp.prn(''<li class="top"><a href= "''||'||unistr('\000a')||
'	      l_prev_link ||''" id= "'' || l_prev_id ||''" class="top_link"><span>''||'||unistr('\000a')||
'	      l_prev_label ||''</span></a></li>''); '||unistr('\000a')||
'	    END IF'||
';'||unistr('\000a')||
'	    '||unistr('\000a')||
'	  --Check to see if this is a second level record '||unistr('\000a')||
'	  ELSIF l_prev_level = l_skip_level + 2 THEN'||unistr('\000a')||
'	    IF l_prev_dir >= 1 THEN'||unistr('\000a')||
'	      --Start the sub-menu'||unistr('\000a')||
'	      sys.htp.prn(''<ul class="sub">'');'||unistr('\000a')||
'	    END IF;    '||unistr('\000a')||
'	      '||unistr('\000a')||
'	    --Check to see if this has a child record'||unistr('\000a')||
'	    IF l_fut_dir >= 1 THEN'||unistr('\000a')||
'	      --Print the second level structure with the flyout'||unistr('\000a')||
'	      sys.htp.prn(''<li onmousemove="$('||
'this).find(''''ul:first'''').addClass(''''showmenu'''')" onmouseout="$(this).find(''''ul:first'''').removeClass(''''showmenu'''')"><a href="''||l_prev_link ||''" class="fly">''||l_prev_label ||''</a>'');	    '||unistr('\000a')||
'	    ELSE'||unistr('\000a')||
'	      --Print the second level structure with no flyout'||unistr('\000a')||
'	      sys.htp.prn(''<li><a href="''||l_prev_link ||''">''||l_prev_label ||''</a></li>'');'||unistr('\000a')||
'	    END IF;'||unistr('\000a')||
'  '||unistr('\000a')||
'	  --Check to see if this is a third level r'||
'ecord '||unistr('\000a')||
'	  ELSIF l_prev_level = l_skip_level + 3 THEN'||unistr('\000a')||
'	    IF l_prev_dir >= 1 THEN'||unistr('\000a')||
'	      --Start the sub-menu'||unistr('\000a')||
'	      sys.htp.prn(''<ul>'');'||unistr('\000a')||
'	    END IF;    '||unistr('\000a')||
'	      '||unistr('\000a')||
'	    sys.htp.prn(''<li><a href="''||l_prev_link ||''">''||l_prev_label ||''</a></li>'');	    '||unistr('\000a')||
'  '||unistr('\000a')||
'	  END IF;'||unistr('\000a')||
'	END IF;'||unistr('\000a')||
'   end loop;'||unistr('\000a')||
'   '||unistr('\000a')||
'  --Finish off the last item'||unistr('\000a')||
'   IF l_level = l_skip_level + 1 THEN'||unistr('\000a')||
'    IF l_fut_dir = -1 THEN'||unistr('\000a')||
'      --End the'||
' sub-menu'||unistr('\000a')||
'      sys.htp.prn(''</ul><li>'');'||unistr('\000a')||
'    END IF; '||unistr('\000a')||
'      sys.htp.prn(''<li class="top"><a href= "''||'||unistr('\000a')||
'      l_link ||''" id= "'' || l_id ||''" class="top_link"><span>''||'||unistr('\000a')||
'      l_label ||''</span></a></li>'');    '||unistr('\000a')||
'   '||unistr('\000a')||
'   ELSIF l_level = l_skip_level + 2 THEN'||unistr('\000a')||
'    IF l_fut_dir = 1 THEN'||unistr('\000a')||
'      --Start the sub-menu'||unistr('\000a')||
'      sys.htp.prn(''<ul class="sub">'');'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'    IF l_fut_dir = -1 THEN'||unistr('\000a')||
'      --End th'||
'e sub-menu'||unistr('\000a')||
'      sys.htp.prn(''</ul></li>'');'||unistr('\000a')||
'    END IF;   '||unistr('\000a')||
'    sys.htp.prn(''<li><a href="''||l_link ||''">''||l_label ||''</a></li></ul></li>'');   '||unistr('\000a')||
'   '||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'    IF l_fut_dir = 1 THEN'||unistr('\000a')||
'      --Start the sub-menu'||unistr('\000a')||
'      sys.htp.prn(''<ul>'');'||unistr('\000a')||
'    END IF;'||unistr('\000a')||
'    IF l_fut_dir = -1 THEN'||unistr('\000a')||
'      --End the sub-menu'||unistr('\000a')||
'      sys.htp.prn(''</ul></li>'');'||unistr('\000a')||
'    END IF;	   	'||unistr('\000a')||
'   	sys.htp.prn(''<li><a href="''||l_link ||''">''||l_'||
'label ||''</a></li></ul></li></ul></li>'');'||unistr('\000a')||
'   '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'    '||unistr('\000a')||
'  --End the menu'||unistr('\000a')||
'  sys.htp.prn(''</ul>'');'||unistr('\000a')||
''||unistr('\000a')||
'  sys.htp.prn(''<script type="text/javascript"> $(document).ready(function() { $("#nav").css("display","block"); }); </script>'');'||unistr('\000a')||
'    return null;'||unistr('\000a')||
'end render_dropdown_menu;'
 ,p_render_function => 'render_dropdown_menu'
 ,p_standard_attributes => 'SOURCE_SQL:SOURCE_REQUIRED'
 ,p_sql_min_column_count => 5
 ,p_sql_max_column_count => 5
 ,p_sql_examples => 'select "M_APPLICATION_NUM" id, '||unistr('\000a')||
'	"PARENT_M_APP_NUM" pid, '||unistr('\000a')||
'	"DESCRIPTION" name, '||unistr('\000a')||
'	nvl("URL",''f?p=&APP_ID.:1'') || '||unistr('\000a')||
'	case substr(URL,1,4) when ''f?p='' then '||unistr('\000a')||
'		'':'' ||v(session_id) '||unistr('\000a')||
'	else null '||unistr('\000a')||
'	end link, level'||unistr('\000a')||
'from "M_APPLICATIONS"'||unistr('\000a')||
'where in_use = ''Y'''||unistr('\000a')||
'start with PARENT_M_APP_NUM is null'||unistr('\000a')||
'connect by prior M_APPLICATION_NUM = PARENT_M_APP_NUM'
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_help_text => '<p>'||unistr('\000a')||
'	This region plug-in provides an elegant drop-down menu using css and javascript.&nbsp; It takes a source query that provides a menu_id, a parent_id, a menu_name, and a link. This menu region is ideally used on page 0 to create a uniform menu throughout your application.&nbsp; Modification of the page template is suggested to get the menu exactly where you want it.</p>'||unistr('\000a')||
''
 ,p_version_identifier => '1.0'
 ,p_plugin_comment => 'Credit goes to Stu Nicholls for providing the great drop-down menu code and to Tony Jedlinski who had a great example of a menu framework that I used for the back-end menu table.  '||unistr('\000a')||
'http://www.stunicholls.com/'||unistr('\000a')||
'http://www.oracle.com/technetwork/issue-archive/2006/06-may/o36apex-086847.html'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 3880061236518404891 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Skip Level'
 ,p_attribute_type => 'NUMBER'
 ,p_is_required => false
 ,p_default_value => '0'
 ,p_display_length => 5
 ,p_max_length => 5
 ,p_is_translatable => false
 ,p_help_text => 'If there is a top level that you want to skip, enter that level number.'
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D200D0A5468697320636F70797269676874206E6F74696365206D75737420626520';
wwv_flow_api.g_varchar2_table(2) := '6B65707420756E746F756368656420696E20746865207374796C657368656574206174200D0A616C6C2074696D65732E0D0A0D0A546865206F726967696E616C2076657273696F6E206F6620746869732073637269707420616E6420746865206173736F';
wwv_flow_api.g_varchar2_table(3) := '6369617465642028782968746D6C0D0A697320617661696C61626C6520617420687474703A2F2F7777772E7374756E6963686F6C6C732E636F6D2F6D656E752F70726F5F64726F705F312E68746D6C0D0A436F707972696768742028632920323030352D';
wwv_flow_api.g_varchar2_table(4) := '3230303720537475204E6963686F6C6C732E20416C6C207269676874732072657365727665642E0D0A546869732073637269707420616E6420746865206173736F6369617465642028782968746D6C206D6179206265206D6F64696669656420696E2061';
wwv_flow_api.g_varchar2_table(5) := '6E79200D0A77617920746F2066697420796F757220726571756972656D656E74732E0D0A3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(6) := '3D3D3D202A2F0D0A737475486F766572203D2066756E6374696F6E2829207B0D0A097661722063737352756C653B0D0A09766172206E657753656C6563746F723B0D0A092F2A0D0A09666F7220287661722069203D20303B2069203C20646F63756D656E';
wwv_flow_api.g_varchar2_table(7) := '742E7374796C655368656574732E6C656E6774683B20692B2B290D0A0909666F7220287661722078203D20303B2078203C20646F63756D656E742E7374796C655368656574735B695D2E72756C65732E6C656E677468203B20782B2B290D0A0909097B0D';
wwv_flow_api.g_varchar2_table(8) := '0A09090963737352756C65203D20646F63756D656E742E7374796C655368656574735B695D2E72756C65735B785D3B0D0A0909096966202863737352756C652E73656C6563746F72546578742E696E6465784F6628224C493A686F766572222920213D20';
wwv_flow_api.g_varchar2_table(9) := '2D31290D0A0909097B0D0A09090909206E657753656C6563746F72203D2063737352756C652E73656C6563746F72546578742E7265706C616365282F4C493A686F7665722F67692C20224C492E6965686F76657222293B0D0A09090909646F63756D656E';
wwv_flow_api.g_varchar2_table(10) := '742E7374796C655368656574735B695D2E61646452756C65286E657753656C6563746F72202C2063737352756C652E7374796C652E63737354657874293B0D0A0909097D0D0A09097D0D0A0976617220676574456C6D203D20646F63756D656E742E6765';
wwv_flow_api.g_varchar2_table(11) := '74456C656D656E744279496428226E617622292E676574456C656D656E747342795461674E616D6528224C4922293B0D0A09666F72202876617220693D303B20693C676574456C6D2E6C656E6774683B20692B2B29207B0D0A0909676574456C6D5B695D';
wwv_flow_api.g_varchar2_table(12) := '2E6F6E6D6F7573656F7665723D66756E6374696F6E2829207B0D0A090909746869732E636C6173734E616D652B3D22206965686F766572223B0D0A09097D0D0A0909676574456C6D5B695D2E6F6E6D6F7573656F75743D66756E6374696F6E2829207B0D';
wwv_flow_api.g_varchar2_table(13) := '0A090909746869732E636C6173734E616D653D746869732E636C6173734E616D652E7265706C616365286E6577205265674578702822206965686F7665725C5C6222292C202222293B0D0A09097D0D0A097D2A2F0D0A7D0D0A6966202877696E646F772E';
wwv_flow_api.g_varchar2_table(14) := '6174746163684576656E74292077696E646F772E6174746163684576656E7428226F6E6C6F6164222C20737475486F766572293B0D0A0D0A';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 5490001439935126 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_file_name => 'stuHover.js'
 ,p_mime_type => 'application/javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D200D0A5468697320636F70797269676874206E6F74696365206D75737420626520';
wwv_flow_api.g_varchar2_table(2) := '6B65707420756E746F756368656420696E20746865207374796C657368656574206174200D0A616C6C2074696D65732E0D0A0D0A546865206F726967696E616C2076657273696F6E206F662074686973207374796C65736865657420616E642074686520';
wwv_flow_api.g_varchar2_table(3) := '6173736F6369617465642028782968746D6C0D0A697320617661696C61626C6520617420687474703A2F2F7777772E7374756E6963686F6C6C732E636F6D2F6D656E752F70726F5F64726F70646F776E5F332E68746D6C0D0A436F707972696768742028';
wwv_flow_api.g_varchar2_table(4) := '632920323030352D3230303720537475204E6963686F6C6C732E20416C6C207269676874732072657365727665642E0D0A54686973207374796C65736865657420616E6420746865206173736F6369617465642028782968746D6C206D6179206265206D';
wwv_flow_api.g_varchar2_table(5) := '6F64696669656420696E20616E79200D0A77617920746F2066697420796F757220726571756972656D656E74732E0D0A3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(6) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0D0A0D0A2E7072656C6F616431207B6261636B67726F756E643A2075726C2823504C5547494E5F5052454649582374687265655F30612E676966293B7D0D0A2E7072656C6F616432207B6261636B67726F75';
wwv_flow_api.g_varchar2_table(7) := '6E643A2075726C2823504C5547494E5F5052454649582374687265655F31612E676966293B7D0D0A0D0A236E6176207B70616464696E673A303B206D617267696E3A303B206C6973742D7374796C653A6E6F6E653B206865696768743A333870783B2062';
wwv_flow_api.g_varchar2_table(8) := '61636B67726F756E643A236666662075726C2823504C5547494E5F5052454649582374687265655F302E67696629207265706561742D783B20706F736974696F6E3A72656C61746976653B207A2D696E6465783A3530303B20666F6E742D66616D696C79';
wwv_flow_api.g_varchar2_table(9) := '3A617269616C2C2076657264616E612C2073616E732D73657269663B20646973706C61793A6E6F6E653B202F2A206869646520756E74696C20636F6D706C6574656C79206C6F61646564202A2F7D0D0A236E6176206C692E746F70207B646973706C6179';
wwv_flow_api.g_varchar2_table(10) := '3A626C6F636B3B20666C6F61743A6C6566743B7D0D0A236E6176206C6920612E746F705F6C696E6B207B646973706C61793A626C6F636B3B20666C6F61743A6C6566743B206865696768743A333570783B206C696E652D6865696768743A333370783B20';
wwv_flow_api.g_varchar2_table(11) := '636F6C6F723A236363633B20746578742D6465636F726174696F6E3A6E6F6E653B20666F6E742D73697A653A313170783B20666F6E742D7765696768743A626F6C643B2070616464696E673A302030203020313270783B20637572736F723A706F696E74';
wwv_flow_api.g_varchar2_table(12) := '65723B6261636B67726F756E643A2075726C2823504C5547494E5F5052454649582374687265655F302E676966293B7D0D0A236E6176206C6920612E746F705F6C696E6B207370616E207B666C6F61743A6C6566743B20646973706C61793A626C6F636B';
wwv_flow_api.g_varchar2_table(13) := '3B2070616464696E673A302032347078203020313270783B206865696768743A333570783B206261636B67726F756E643A2075726C2823504C5547494E5F5052454649582374687265655F302E6769662920726967687420746F70206E6F2D7265706561';
wwv_flow_api.g_varchar2_table(14) := '743B7D0D0A236E6176206C6920612E746F705F6C696E6B207370616E2E646F776E207B666C6F61743A6C6566743B20646973706C61793A626C6F636B3B2070616464696E673A302032347078203020313270783B206865696768743A333570783B206261';
wwv_flow_api.g_varchar2_table(15) := '636B67726F756E643A2075726C2823504C5547494E5F5052454649582374687265655F30612E67696629206E6F2D72657065617420726967687420746F703B7D0D0A0D0A236E6176206C693A686F76657220612E746F705F6C696E6B207B636F6C6F723A';
wwv_flow_api.g_varchar2_table(16) := '236666663B206261636B67726F756E643A2075726C2823504C5547494E5F5052454649582374687265655F312E67696629206E6F2D7265706561743B7D0D0A236E6176206C693A686F76657220612E746F705F6C696E6B207370616E207B6261636B6772';
wwv_flow_api.g_varchar2_table(17) := '6F756E643A75726C2823504C5547494E5F5052454649582374687265655F312E67696629206E6F2D72657065617420726967687420746F703B7D0D0A236E6176206C693A686F76657220612E746F705F6C696E6B207370616E2E646F776E207B6261636B';
wwv_flow_api.g_varchar2_table(18) := '67726F756E643A75726C2823504C5547494E5F5052454649582374687265655F31612E67696629206E6F2D72657065617420726967687420746F703B2070616464696E672D626F74746F6D3A3370783B7D0D0A0D0A2F2A2044656661756C74206C697374';
wwv_flow_api.g_varchar2_table(19) := '207374796C696E67202A2F0D0A0D0A236E6176206C693A686F766572207B706F736974696F6E3A72656C61746976653B207A2D696E6465783A3230303B7D0D0A0D0A236E6176206C693A686F76657220756C2E7375622C20236E6176206C6920756C2E73';
wwv_flow_api.g_varchar2_table(20) := '686F776D656E750D0A7B6C6566743A3170783B20746F703A333470783B206261636B67726F756E643A20234346453046313B2070616464696E673A3370783B20626F726465723A31707820736F6C696420233062346439373B2077686974652D73706163';
wwv_flow_api.g_varchar2_table(21) := '653A6E6F777261703B2077696474683A31323570783B206865696768743A6175746F3B207A2D696E6465783A3330303B7D0D0A236E6176206C693A686F76657220756C2E737562206C692C20236E6176206C6920756C2E73686F776D656E75206C690D0A';
wwv_flow_api.g_varchar2_table(22) := '7B646973706C61793A626C6F636B3B206865696768743A323070783B20706F736974696F6E3A72656C61746976653B20666C6F61743A6C6566743B2077696474683A31323570783B20666F6E742D7765696768743A6E6F726D616C3B7D0D0A236E617620';
wwv_flow_api.g_varchar2_table(23) := '6C693A686F76657220756C2E737562206C6920612C20236E6176206C6920756C2E73686F776D656E75206C6920610D0A7B646973706C61793A626C6F636B3B20666F6E742D73697A653A313170783B206865696768743A313870783B2077696474683A31';
wwv_flow_api.g_varchar2_table(24) := '323570783B206C696E652D6865696768743A313870783B20746578742D696E64656E743A3570783B20636F6C6F723A233030303B20746578742D6465636F726174696F6E3A6E6F6E653B626F726465723A31707820736F6C696420234346453046313B7D';
wwv_flow_api.g_varchar2_table(25) := '0D0A236E6176206C6920756C2E737562206C6920612E666C790D0A7B6261636B67726F756E643A234346453046312075726C2823504C5547494E5F505245464958236172726F772E6769662920313230707820367078206E6F2D7265706561743B7D0D0A';
wwv_flow_api.g_varchar2_table(26) := '236E6176206C693A686F76657220756C2E737562206C6920613A686F7665722C20236E6176206C6920756C2E73686F776D656E75206C6920613A686F76657220200D0A7B6261636B67726F756E643A233366393661393B20636F6C6F723A236666663B20';
wwv_flow_api.g_varchar2_table(27) := '626F726465722D636F6C6F723A236666663B7D0D0A236E6176206C693A686F76657220756C2E737562206C6920612E666C793A686F7665722C20236E6176206C6920756C2E73686F776D656E75206C6920612E666C793A686F7665720D0A7B6261636B67';
wwv_flow_api.g_varchar2_table(28) := '726F756E643A233366393661392075726C2823504C5547494E5F505245464958236172726F775F6F7665722E6769662920313230707820367078206E6F2D7265706561743B20636F6C6F723A236666663B7D0D0A0D0A236E6176206C692062207B646973';
wwv_flow_api.g_varchar2_table(29) := '706C61793A626C6F636B3B20666F6E742D73697A653A313170783B206865696768743A313870783B2077696474683A383870783B206C696E652D6865696768743A313870783B206D617267696E2D626F74746F6D3A3370783B20746578742D696E64656E';
wwv_flow_api.g_varchar2_table(30) := '743A3670783B20636F6C6F723A236666363B20626F726465722D626F74746F6D3A31707820736F6C696420236666363B20637572736F723A64656661756C743B7D0D0A0D0A236E6176206C693A686F766572206C693A686F76657220756C2C0D0A236E61';
wwv_flow_api.g_varchar2_table(31) := '76206C6920756C2E73686F776D656E75206C692020756C2E73686F776D656E752C0D0A236E6176206C693A686F766572206C693A686F766572206C693A686F76657220756C2C0D0A236E6176206C6920756C2E73686F776D656E75206C6920756C2E7368';
wwv_flow_api.g_varchar2_table(32) := '6F776D656E75206C6920756C2E73686F776D656E752C0D0A236E6176206C693A686F766572206C693A686F766572206C693A686F766572206C693A686F76657220756C2C0D0A236E6176206C6920756C2E73686F776D656E75206C6920756C2E73686F77';
wwv_flow_api.g_varchar2_table(33) := '6D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E752C0D0A236E6176206C693A686F766572206C693A686F766572206C693A686F766572206C693A686F766572206C693A686F76657220756C2C0D0A236E6176206C6920';
wwv_flow_api.g_varchar2_table(34) := '756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E750D0A7B6C6566743A31323570783B20746F703A2D3470783B206261636B';
wwv_flow_api.g_varchar2_table(35) := '67726F756E643A20234346453046313B2070616464696E673A3370783B20626F726465723A31707820736F6C696420233062346439373B2077686974652D73706163653A6E6F777261703B2077696474683A31323570783B207A2D696E6465783A343030';
wwv_flow_api.g_varchar2_table(36) := '3B206865696768743A6175746F3B7D0D0A0D0A0D0A236E617620756C2C200D0A236E6176206C693A686F76657220756C20756C2C0D0A236E6176206C693A686F766572206C693A686F76657220756C20756C2C0D0A236E6176206C693A686F766572206C';
wwv_flow_api.g_varchar2_table(37) := '693A686F766572206C693A686F76657220756C20756C2C0D0A236E6176206C693A686F766572206C693A686F766572206C693A686F766572206C693A686F76657220756C20756C2C0D0A236E6176206C6920756C2E73686F776D656E7520756C2C0D0A23';
wwv_flow_api.g_varchar2_table(38) := '6E6176206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E7520756C2C0D0A236E6176206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E7520756C2C0D0A236E6176206C';
wwv_flow_api.g_varchar2_table(39) := '6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E7520756C0D0A7B706F736974696F6E3A6162736F6C7574653B206C6566743A2D3939393970783B20746F70';
wwv_flow_api.g_varchar2_table(40) := '3A2D3939393970783B2077696474683A303B206865696768743A303B206D617267696E3A303B2070616464696E673A303B206C6973742D7374796C653A6E6F6E653B7D0D0A0D0A236E6176206C693A686F766572206C693A686F76657220612E666C792C';
wwv_flow_api.g_varchar2_table(41) := '0D0A236E6176206C693A686F766572206C693A686F766572206C693A686F76657220612E666C792C0D0A236E6176206C693A686F766572206C693A686F766572206C693A686F766572206C693A686F76657220612E666C792C0D0A236E6176206C693A68';
wwv_flow_api.g_varchar2_table(42) := '6F766572206C693A686F766572206C693A686F766572206C693A686F766572206C693A686F76657220612E666C790D0A2F2A236E6176206C6920756C2E73686F776D656E75206C6920612E666C792C0D0A236E6176206C6920756C2E73686F776D656E75';
wwv_flow_api.g_varchar2_table(43) := '206C6920756C2E73686F776D656E75206C692020756C2E73686F776D656E7520612E666C792C0D0A236E6176206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920612E666C792C0D';
wwv_flow_api.g_varchar2_table(44) := '0A236E6176206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920612E666C792A2F0D0A7B6261636B67726F756E643A23336639366139207572';
wwv_flow_api.g_varchar2_table(45) := '6C2823504C5547494E5F505245464958236172726F775F6F7665722E6769662920313230707820367078206E6F2D7265706561743B20636F6C6F723A236666663B20626F726465722D636F6C6F723A236666663B7D200D0A0D0A236E6176206C6920756C';
wwv_flow_api.g_varchar2_table(46) := '2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920612E666C792C0D0A236E6176206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920612E666C792C0D0A236E61';
wwv_flow_api.g_varchar2_table(47) := '76206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920756C2E73686F776D656E75206C6920612E666C790D0A7B6261636B67726F756E643A234346453046312075726C2823504C55';
wwv_flow_api.g_varchar2_table(48) := '47494E5F505245464958236172726F772E67696629203830707820367078206E6F2D7265706561743B20636F6C6F723A233030303B20626F726465722D636F6C6F723A234346453046313B7D200D0A2F2A2A2F';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7908207627930366 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_file_name => 'pro_dropdown_3jw.css'
 ,p_mime_type => 'text/css'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396104000700800000FFFFFF00000021F90401070000002C00000000040007000002080C1E0669ECAB1428003B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 3879935934034338993 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_file_name => 'arrow.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396104000700800000FFFFFFFF000021F90401070001002C0000000004000700000208440E1669ECAB5428003B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 3879938331878339994 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_file_name => 'arrow_over.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '4749463837612C0123004400002C000000002C012300841A1C1D181A1B181A1C191B1C94959517191A8182828788887B7C7D6F70707576779A9A9A9798988F90908B8C8CC1C2C2696A6A17191B191B1D17181A1213141618193A3C3D6262626465665E5E';
wwv_flow_api.g_varchar2_table(2) := '5F52545457595900000000000000000000000005FFE0258E64699E68AAAE6CEBBE702CCF746DDFF8A3EF7CEFFFC0A070482C1A8FC8A472C96C3A9FD085744AAD5AAFD8AC76CBED7ABFE0B0784C2E9BCF68867ACD6EBBDFF0B87C4EAFDBEFF8BC7ECFEFFB';
wwv_flow_api.g_varchar2_table(3) := 'FF800482838485868788898A8B8C8D8E8F909192939495969798999A9B9C9D9E9FA0A1A2850DA5A6A7A8A9AAABACADAEAFB0B1B2B3B4B5B6B7B8B9BABB0EBDBEBFC0C1C2C3C4C5C6C7C8C9CACBCCCDCECFD0D1D2D307D5D6D7D8D9DADBDCDDDEDFE0E1E2';
wwv_flow_api.g_varchar2_table(4) := 'E3E4E5E6E7E8E9EAEB06EDEEEFF0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF00030A1C88A0A0C18308132A5CC8B0A1C38710234A9C48B1A2C58B18336ADCA8A0A3C78F20438A1C49B2A4C9932853FFAA5CC9B2A5CB973063CA9C99A0A6CD9B3873EADCC9B3A7';
wwv_flow_api.g_varchar2_table(5) := 'CF9F40830A1D4AB4A8D1A348932A5D0AA1A9D3A750A34A9D4AB5AAD5AB58B36ADDCAB5ABD7AF60C38A1D8BA1ACD9B368D3AA5DCBB6ADDBB770E3CA9D4BB7AEDDBB78F3EADD9BA1AFDFBF80030B1E4CB8B0E1C388132B5ECCB8B1E3C790234B9EBCA1B2E5';
wwv_flow_api.g_varchar2_table(6) := 'CB98336BDECCB9B3E7CFA0438B1E4DBAB4E9D3A853AB5EADA1B5EBD7B063CB9E4DBBB6EDDBB873EBDECDBBB7EFDFC0830B1F6EA1B8F1E3C8932B5FCEBCB9F3E7D0A34B9F4EBDBAF5EBD8B36BDF0EA0BBF7EFE0C38B1F4FBEBCF9F3E8D3AB5FCFBEBDFBF7';
wwv_flow_api.g_varchar2_table(7) := 'F0E3CB9F4FBFBEFDFBF8F3EBDFCFBFBFFFFF000628E080040A28C1810826A8E0FF820C36E8E083104628E184145668E1851866A8E1861C7638C087208628E288249668E28928A6A8E28A2CB6E8E28B30C628E38C34D668E38D38E6A8E38E3CF6E8E38F22';
wwv_flow_api.g_varchar2_table(8) := '0A20E490441669E4914826A9E4924C36E9E493504629E594545669E5955866A9E5965C76E9E5976086296691019469E69968A6A9E69A6CB6E9E69B70C629E79C74D669E79D78E6A9E79E7CF6E9E79F80062AE8A084168A66048826AAE8A28C36EAE8A390';
wwv_flow_api.g_varchar2_table(9) := '462AE9A494566AE9A59866AAE9A69C76EA6901A0862AEAA8A4966AEAA9A8A6AAEAAAACB6EAEAABB0C62AEBACB4D66AEBADB8E6AAEBAEBCF6EAEBAFC08E3AC1B0C4166BECB1C826ABECB2CC36EBECB3D0462BEDB4D4566BED41B5D8665BC1B6DC76EBEDB7';
wwv_flow_api.g_varchar2_table(10) := 'E0862BEEB8E4966BEEB9E8A6ABEEBAECB6EBEEBBF0C64BC1BCF4D66BEFBDF8E6ABEFBEFCF6EBEFBF00072CF0C004176CF0C108271C02003B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 3879940529074341209 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_file_name => 'three_0.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '4749463839612C012300C40000C1C2C29A9A9A9798989495958F90908B8C8C8788888182827B7C7D7576776F7070696A6A6465666262625E5E5F5759595254543A3C3D1A1C1D191B1C191B1D181A1C181A1B17191A17191B16181917181A121314000000';
wwv_flow_api.g_varchar2_table(2) := '00000000000000000021F904000700FF002C000000002C0123000005FF60238E64699E68AAAE6CEBBE702CCF746DDF38A0EF7CEFFFC0A070482C1A8FC8A472C96C3A9FD080744AAD5AAFD8AC76CBED7ABFE0B0784C2E9BCF68817ACD6EBBDFF0B87C4EAF';
wwv_flow_api.g_varchar2_table(3) := 'DBEFF8BC7ECFEFFBFF800382838485868788898A8B8C8D8E8F909192939495969798999A9B9C9D9E9FA0A1A28504A5A6A7A8A9AAABACADAEAFB0B1B2B3B4B5B6B7B8B9BABB05BDBEBFC0C1C2C3C4C5C6C7C8C9CACBCCCDCECFD0D1D2D306D5D6D7D8D9DA';
wwv_flow_api.g_varchar2_table(4) := 'DBDCDDDEDFE0E1E2E3E4E5E6E7E8E9EAEB07EDEEEFF0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF00030A1C88A0A0C18308132A5CC8B0A1C38710234A9C48B1A2C58B18336ADC98A0A3C78F20438A1C49B2A4C9932853FFAA5CC9B2A5CB973063CA9CA9A0A6CD';
wwv_flow_api.g_varchar2_table(5) := '9B3873EADCC9B3A7CF9F40830A1D4AB4A8D1A348932A5DBAA0A9D3A750A34A9D4AB5AAD5AB58B36ADDCAB5ABD7AF60C38A1DCBA0ACD9B368D3AA5DCBB6ADDBB770E3CA9D4BB7AEDDBB78F3EADDEBA0AFDFBF80030B1E4CB8B0E1C388132B5ECCB8B1E3C7';
wwv_flow_api.g_varchar2_table(6) := '90234B9EFCA0B2E5CB98336BDECCB9B3E7CFA0438B1E4DBAB4E9D3A853AB5E0DA1B5EBD7B063CB9E4DBBB6EDDBB873EBDECDBBB7EFDFC0830B87FDE37684E3C8932B5FCEBCB9F3E7D0A34B9F4EBDBAF5EBD8B36BDFCE7D790FE912C28B1F4FBEBCF9F3E8';
wwv_flow_api.g_varchar2_table(7) := 'D3AB5FCFBEBDFBF7F0E3CB9F4FBFBE7DF33BEEEBDFCFBFBFFFFF000628207B000C68E0810826A8E0FF820CBA47C183104628E184145668E1851866A8E1861C76E8E187208628E288249638C18928A6A8E28A2CB6E8E28B30C628E38C34D668E38D38E6A8';
wwv_flow_api.g_varchar2_table(8) := 'E38E3CF6E8E38F400629E490441669E4912A56A0E4924C36E9E493504629E594545669E5955866A9E5965C76E9E597608629E698649669E69968A6A9669316B4E9E69B70C629E79C74D669E79D78E6A9E79E7CF6E9E79F80062AE8A084166AE8A18826AA';
wwv_flow_api.g_varchar2_table(9) := 'E8A28C360A270690462AE9A494566AE9A59866AAE9A69C76EAE9A7A0862AEAA8A4966AEA05A8A6AAEAAAACB6EAEAABB0C62AEBACB4D66AEBADB8E6AAEBAEBCF6EAEBAFC0062BECB0C4166BECB1C8AEAAC1B2CC36EBECB3D0462BEDB4D4566BED4BB5D866';
wwv_flow_api.g_varchar2_table(10) := 'ABEDB6DC76EBEDB7E0869BC1B8E4966BEEB9E8A6ABEEBAECB6EBEEBBF0C62BEFBCF4D66BEFBDF8E6BBC1BEFCF6EBEFBF00072CF0C004176CF0C10827ACF0C20C37ECF0C310471C02003B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 3879942026918342278 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_file_name => 'three_0a.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '4749463837612C0123007700002C000000002C012300873333334CA1B2626262121314C1C2C235373818768E19778F116F8A1B788F0060A40000000D5C6C2B869A207B922781970B4F800B4E5B0B4E6E0B515A0B4D970B4E630B50850B4E690B505A0B4F';
wwv_flow_api.g_varchar2_table(2) := '740B4E8E0B4F890B4F7B4CA1B1449CAD328AA03F96A93990A450B5D0328A9F3F96A83990A3449CAC50B5CF4BA0B10C4E690C4E6E0C4E630C50850C4F740C4F800C4F7B0C4D970C4E8E0C4F890C515A0B4D5A0B4F590C4E5B0B4D620C505A0B50594FB4CF';
wwv_flow_api.g_varchar2_table(3) := '3E95A8388FA30B4E7A0B4D8D0B4F84318A9F0B4E7F0B4E88439BAC0B4D6D0B4E730B4C960B4D680B4E80207B912781962B86990D5B6C0B4D690B4D8E0B4E890B4E740B4E7B0B4F850B4C970B4D6E1618191A1C1D383838383A3B4DB2CC36383917191A17';
wwv_flow_api.g_varchar2_table(4) := '181A36383A181A1C191B1C181A1BB2B3B3B5B6B637393A9495958788889A9A9A005FA40A4C960A4E730A5059010101439BAD0A4D620A4D680A4D6D0303030404040A4D8D4EB3CD0C5B6C1A778F1F7A912A859931899F2680960A4D5A3636360A4F590A4E';
wwv_flow_api.g_varchar2_table(5) := '880A4E7A0A4E7F1D1D1D0A4F848182824DB1CA4DB0CA4EB3CE4FB4CE828384A5A6A6020202A9AAAA060606050505045D77035D7B055C729FA0A0999A9B17191B373737353739191B1D3535353434343A3C3DADAEAE3A3A3A37393B3939397B7C7D7C7C7D';
wwv_flow_api.g_varchar2_table(6) := '757777707272757677035E808D8E8E8B8C8C8F9090035F86939495525454575959525252979898515151646566696A6A6F7070585A5B5E5E5F44A5BA48ADC748ACC74DB2CD4DB2CB40A5C040A4C044A9C344A8C3035F8B005F9E136D7F035F8A005F9F00';
wwv_flow_api.g_varchar2_table(7) := '609300609401608F016090126D7F00486E065C6B1E1E1E00486C075C6B095F6A0A5F6A085E6A095E6A0060973297B33398B32D91AD2E92AD369BB73BA0BC44A4B9379CB73B9FBC2A8EA82184A12285A10060980060A5268AA5288CA6298DA8278BA5278B';
wwv_flow_api.g_varchar2_table(8) := 'A600000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000008FF0005081C48B0A0';
wwv_flow_api.g_varchar2_table(9) := 'C18308132A5CC8B0A1C38710234A9C48B1A2C58B180968DCC8B1A3C78F20438A1C49B2A4C9932853AA5CC9B2A5CB9730CD9811A34A13809B3873EADCC9B3A7CF9F40830A1D4AB4A8D1A348932A5DCA14C0A54B962CED993A69D2952B9C3869522546E62A';
wwv_flow_api.g_varchar2_table(10) := '31ACAAD91241B6ACD9B368D3AA5DCB96AD0E1D27E09E984BB76E5CB872EDDA6DCB77EDDBB87A030B16FC36EFE0137D139F2D7CB831E1BF8E158B28ACC390A14285E668AE95A5736759ACC4AC2213E6CAA000A853AB5ECDBAB5EBD7B063A340D1817687DB';
wwv_flow_api.g_varchar2_table(11) := 'B873D7A66D5BB7EED8C05FCFAEEDBBB871E3B37B1FEF10BCF9EAE4CBA3231F2EDDB975D484AE842143DAF4F5EFE0810FFF573E9D78F4F0E2794B5F9F1B7A75F4B0DDB35F2F7F39FCD8D9B797CA04609687FF000628E080041668E081080E3184090B9AE0';
wwv_flow_api.g_varchar2_table(12) := 'E0831032B86083114688E085062AC860851C76D8A182147A680286240A08A288287EA8618A257AC0C68B24D2024026A590A20800B980A0E38E3CF6E8E38F400629E4903BEC4082912424A9E492471A8924934C0E296590451E09E595586259E493599230';
wwv_flow_api.g_varchar2_table(13) := 'E5973D6ED9E5985A564926982088492609BA00A00829652002C02D21D469E79D78E6A9E79E7CF6E9270F3C9410680984166AA8A0810E7AE8A17E36CA27A0822E2AE9A49302AA28A52538AA299E9662EA69A5907EBA69089D7E5A022E0020528620900040';
wwv_flow_api.g_varchar2_table(14) := 'CD07B0C6FF2AEBACB4D66AEBADB8E60A041023F03AC2AFC006DB2BAFBE0A2B6CAEC8DEBA6BAFC636EBACB3BB16FBEC08C9563B6BB4D3660BEDB2DA5AFB011EE06AFBEB3500402248279100604D03ECB6EBEEBBF0C62BEFBCF4D66BEFBDF8E6ABEFBEFCF6';
wwv_flow_api.g_varchar2_table(15) := 'EBEFBF00037CC7C04B146CF0C1074F0340249D84720A00D03C20F1C414576CF1C51867ACF1C61C77ECF1C720872CF2C824976CB2C979A4ACC4CA2CB7DCF233009C12CA2BA300208D0338E7ACF3CE3CF7ECF3CF40072DF4D044176DF4D14827ADF4D24C33';
wwv_flow_api.g_varchar2_table(16) := '6DC7D349442DF5D4534703C028AFB8520600D824E0F5D760872DF6D864976DF6D968A7ADF6DA6CB7EDF6DB70C72DB7DC75D4ADF6370094E14A2B8700FFE0CD0180072EF8E084176EF8E18827AEF8E28C37EEF8E390472EF9E49457EE7838001CD24A2C9E';
wwv_flow_api.g_varchar2_table(17) := '00008E01A0872EFAE8A4976EFAE9A8A7AEFAEAACB7EEFAEBB0C72EFBECB4D7EE7A370078124B2A9F00A00D02C0072FFCF0C4176FFCF1C827AFFCF2CC37EFFCF3D0472FFDF4D457EF7C36007C920A2AA000D00B03E0872FFEF8E4976FFEF9E8A7AFFEFAEC';
wwv_flow_api.g_varchar2_table(18) := 'B7EFFEFBF0C72FFFFCF4D34FC7FD4CE4AFFFFEFB13030028A8C0042C00B08C0918F080084CA00217C8C0063AF08139C8C1042408410952F08118CCA0022338C10CCEE083200CA1086710C10B6AF084192CA10747C8C20FAA10851854830C4B48C31A4650';
wwv_flow_api.g_varchar2_table(19) := '1900800526AC800500340303400CA210FF8748C4221AF188484C620D6A8001262A91894E4CA214A748C42536718A38C8A216B7C8451C2C318A540CE314BF88C52E9A318B6414A314F9C0C62FBAF18D4B640600B060051E02201911C8A31EF7C8C73EFAF1';
wwv_flow_api.g_varchar2_table(20) := '8F800CA42069408308147290853CA42017C9C83E12D2908CB481242749C94ADA80908A6CA4261989C9485AF29392ECE42617A9875262F294A824A431E658C71E3EA202B08CA52C6749CB5ADAF296B8CCE50D6E50015EEA9297BECCA5308749CB5DF67298';
wwv_flow_api.g_varchar2_table(21) := '2B48A63297C9CC15EC3298C48CE6309F89CC665A3399D494A630DBC0CD677AF39BBB7C042B2BB1090034E202E84CA73AD7C9CE76BAF39DF08CE7118E70017ACA939EF68CA73EF7C9FFCE79D6739F2908A840074AD014CC339FFC4CE83E0F0AD0823A34A0';
wwv_flow_api.g_varchar2_table(22) := '0C55A83EDD40D12658F4A218C5682300B0894A7C610C00708404464AD2929AF4A4284DA94A57CA52221041022F6DE94B63CAD29ADAF4A42E85A94D55C0D39EFAF4A72A70294D6F4A549B0A75A7404D2A4F8F5AD49ABEE1A95488AA54A73A554700600C5F';
wwv_flow_api.g_varchar2_table(23) := 'F82800449181AE7AF5AB600DAB58C74AD6B29AB50845C8405ACF9AD6B59AF5AD700D2B5AD50AD716D8F5AE78CD6B0BD0EAD6B8FA15AE7CADAB5E076BD7C0FEF5AD69482C1416CBD8C636561457FD8217BA00005370E0B298CDAC6637CBD9CE7AF6B3A0ED';
wwv_flow_api.g_varchar2_table(24) := '410F3830DAD08EB6B4A04DAD6A372B5AD2AAF605B08DAD6C67FB02D1FFA276B5B855AD6D5F4BDBDEC276B7B94DAD1F861B85E21AF7B8C7350500BAE085C90260171088AE74A74BDDEA5AF7BAD8CDAE76831004087477BBDDFDAE76C74BDEEA72D7BBE475';
wwv_flow_api.g_varchar2_table(25) := '817AD7CBDEF6BA80BBE22DAF7CC90BDFF4BAF7BEEAADEF7CC7FB87FE22E1BF000E70807DB15C2F80410B0018860516CCE0063BF8C1108EB084274CE11FFCC00217AEF085334CE10E7BF8C116C6B0875940E2129BF8C42CB030873FCC620FAB78C4288E31';
wwv_flow_api.g_varchar2_table(26) := '895FDCE20E07E2C652C8B18E77BC636100400B6038300082B181221BF9C8484EB29297CCE4263B590842D840949F1CE5293BF9CA584E3294A58C651978F9CB600EB30CA06CE52C9B19CB64EEB298D7ECE5349FF9FFCA7D88F313E64CE73AD719183F0683';
wwv_flow_api.g_varchar2_table(27) := '242801806D68E0CF800EB4A0074DE8421BFAD088F6810F34B0E8442FBAD1888EB4A407AD68464B3A0698CEB4A6371D0345437AD2A096B4A72FCDE952637AD4A18EB41C56ED8456BBFAD5AF7606002821892D140000BFA080AE77CDEB5EFBFAD7C00EB6B0';
wwv_flow_api.g_varchar2_table(28) := '876D042350C0D8C43636B287CDEC66FBBAD8C76E360CA64DED6A5B1B06C55EB6B3B7DDEC6C4BFBDAE09EB6B7B9CD6C34987B0AE84EB7BAD5CD0B0014600BB63E06321440EF7ADBFBDEF8CEB7BEF7CDEF7EFBFBDF000FB8C0074EF0821BFCE00847F81916';
wwv_flow_api.g_varchar2_table(29) := 'FE6F6E140310EFE602170A0088452CE0E218CFB8C637CEF18E7BFCE3200FB9C8474EF2929BFCE428624FB9CA57CEF205ACE1E58948041C661E879A3382118B80B8C4ABC0F302F8FCE7400FBAD0874EF4A21BFDE8484FBAD297CEF4A63BFDE9508FBAD4A7';
wwv_flow_api.g_varchar2_table(30) := 'EE749E57610058CFBAD6B7CEF5AE7BFDEB600FBBD8C74EF6B29BFDEC684FBBDAD7CEF6B6BB3D20003B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 3879996807712366326 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_file_name => 'three_1.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '4749463839612C012300F70000FFFFFFC1C2C2B5B6B6B2B3B3ADAEAEA9AAAAA5A6A650B5CF50B5D04FB4CF4FB4CE9FA0A04EB3CE4EB3CD4DB2CD4DB2CB4DB2CC4DB1CA4DB0CA9A9A9A48ADC7999A9B48ACC797989844A9C394959544A8C393949540A5C0';
wwv_flow_api.g_varchar2_table(2) := '44A4B944A5BA40A4C04CA1B24CA1B14BA0B18F90908D8E8E3BA0BC8B8C8C3B9FBC449CAC449CAD439BAD439BAC379CB7878888369BB73F96A83398B33F96A93297B33E95A88283848182823990A43990A32E92AD388FA32D91AD7C7C7D7B7C7D2A8EA829';
wwv_flow_api.g_varchar2_table(3) := '8DA8288CA6328AA0328A9F318A9F278BA6278BA531899F757777268AA57576772B86992B869A2A85997072722285A12184A12781976F7070278196268096696A6A207B92207B911F7A911B788F64656619778F1A778F18768E6262625E5E5F116F8A136D';
wwv_flow_api.g_varchar2_table(4) := '7F126D7F585A5B5759595254545252525151510060A50060A4006093005F9F005F9E00609700609801608F006094005FA4016090035F86035F8A035F8B0A5F6A095F6A035E80095E6A035D7B0D5C6C085E6A0D5B6C055C72045D770C5B6C075C6B065C6B';
wwv_flow_api.g_varchar2_table(5) := '0C50850B50850B4D970C4F800B4E8E0B4E890C4F890B4F890A4F840B4F800B4F840B4F850C4E8E0C4D970A4E7F0A4E880B4E7F0B4E800B4E880B4F7B0A4C960A4D8D0C4F740B4C960B4C970B4D8D0B4D8E0B4F740C4F7B0B515A0B505A0A4E7A0C505A0C';
wwv_flow_api.g_varchar2_table(6) := '4E6E0B4E730B4E7B0B4E6E0B4E740B4E7A0C515A0A4E730B4D6D0B4D6E0A4D6D0B4F590A50590B4E690A4F590C4E690C4E630B50590B4E630C4E5B0B4D690A4D680A4D620B4D680B4D620B4E5B0A4D5A0B4D5A00486E3A3C3D00486C3A3A3A383A3B3939';
wwv_flow_api.g_varchar2_table(7) := '3938383837393B37393A36383936383A3737373537383636363537393535353434343333331E1E1E1D1D1D1A1C1D191B1D191B1C181A1C181A1B17191B17191A16181917181A121314060606050505040404030303020202010101000000000000000000';
wwv_flow_api.g_varchar2_table(8) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000021F904000700FF002C000000002C0123000008';
wwv_flow_api.g_varchar2_table(9) := 'FF00B9081C48B0A0C18308132A5CC8B0A1C38710234A9C48B1A2C58B180368DCC8B1A3C78F20438A1C49B2A4C9932853AA5CC9B2A5CB9730274C104026D8B39B3873EADCC9B3A7CF9F40830A1D4AB4A8D1A348932A5DCA54E7B2A750970D9B4A4680CC99';
wwv_flow_api.g_varchar2_table(10) := '653A3C40C0B5ABD7AF60C38A1D4BB66CD70368D3AA5DCBB6ADD9B765DBCA9DBB36815DBA69E1EAED6A3701DEBF6CFB02DEDBB7708206881B4058BCD843190117320C20160184E5CB98336BDECCB9B3E7CF9843881E4DBAB4E9D3A0537F3ECDBA756911B0';
wwv_flow_api.g_varchar2_table(11) := '5D8F564DFB326C11B2739BBEADBBB66F09C40664904CD9B7F1E3B5752B0F813CF972DDBC7337FF1CFDB9ECEAAEA77F062E7C048167145288FF1F4FBEBCF9F3E8D3AB5F4F1E85FBF7F0E3CB9FCFBEFEFAF9F8F3C75FC15FFF7BFB008EC7DF0AFE1528DF80';
wwv_flow_api.g_varchar2_table(12) := '0606A8C282F659F00C01239850C03318C460E1851866A8E1861C76E8E18718BE20E288249668E28920A6F8E1892CB658E20C30BA38A28A345E08E30C32E668E28D3AD6C8A38E1A3C5380092D18F00C073624A9E4924C36E9E493504629E592375469E595';
wwv_flow_api.g_varchar2_table(13) := '5866A9E5945C4AA9E597606299C398615AD9E5994A8E9943996C66A9669B68BED9E607CF18D0420D0B3C5302107CF6E9E79F80062AE8A08416EA67108826AAE8A28C366AE8A385362AE9A48B0A6129A58942AA699F960A81E9A78C760AEAA645940A6A10';
wwv_flow_api.g_varchar2_table(14) := '273CB3400D3C54F00C0B4AC4FF2AEBACB4D66AEBADB8E6AAEBAEBCF6EAEBAFC0062BECB0C4165BEC12C826A1ECB2CC32EBC23315F080C406CFC0F0C4B5D866ABEDB6DC76EBEDB7E0862BEEB8E4966BEEB9E8A6ABEEBAEB4AE16E14F0C62BAFBC323CB301';
wwv_flow_api.g_varchar2_table(15) := '125090F00C0E54F4EBEFBF00072CF0C004176CF0C10827ACF0C20C37ECF0C310471CB115145761F1C51863ACC333244031450BCFF470C5C824976CF2C928A7ACF2CA2CB7ECF2CB30C72CF3CC34D76CF3CD376BA1F3CB3E3CD3C21458D0F0CC0F59146DF4';
wwv_flow_api.g_varchar2_table(16) := 'D14827ADF4D24C37EDF4D350472DF5D454576DF5D55867ADF5D4433C4303165DECF00C115B946DF6D968A7ADF6DA6CB7EDF6DB70C72DF7DC74D76DF7DD78E7ADF7DC473CFFB343176218F14C135E146EF8E18827AEF8E28C37EEF8E390472EF9E494576E';
wwv_flow_api.g_varchar2_table(17) := 'F9E59867AEF9E44E3C6384186330F1CC1779946EFAE9A8A7AEFAEAACB7EEFAEBB0C72EFBECB4D76EFBEDB8E7AE7B1E00F4EE3B007B042F7CF0603CC3C418BF84F10C1D9E34EFFCF3D0472FFDF4D4576FFDF5D867AFFDF6D6A3E2FDF7E0878FCA2CE4736F';
wwv_flow_api.g_varchar2_table(18) := '7EF5E4CF82BDF8EC7F9FFEF9D5BB22FFEF00A46F3FF9753C13C62FD208F3CC1D9F08A0000748C0021AF080084CA00217C8C0063AF0810A0C85042748C10A86A2151884A0061388C15630D082209C600737984058981016BEEBA00A3BA8876708431AFD7B';
wwv_flow_api.g_varchar2_table(19) := 'C61F7641C31ADAF08638CCA10E77C8C31EFAF087400CA210FF7B588B221AF18848AC452F9638C426F27089BDF86112A76844283A9187BCC862160100C52E7611102E84A1FFF8408B329AF18C684CA31AD7C8C636BAF18D708CA31CE7E84659D8F18E78CC';
wwv_flow_api.g_varchar2_table(20) := 'A32C74C1473AFAB18D7CD4051CF548C83B06F28F6DC4852203C9C846F2910F619446319ED1875758F29298CCA42637C9C94E7AF293A00CA5284749CA4FC6E294A84CA52A63918B5696F2959E6C652E42B9CA5AA25296B0F4E42D76698B5EFAF297BFECC3';
wwv_flow_api.g_varchar2_table(21) := '338A318D6918E3197828853297C9CC663AF399D08CA634A749CD6A5AF39AD89CA628B6C9CD6E7A5314AA086736C729CD70AAA29ADF4C2737CD494E69B2E29DAB88A73CE7394F3C3CC318D4A0C631EDC0FF897EFAF39F000DA840074AD0821AF4A0084DA8';
wwv_flow_api.g_varchar2_table(22) := '42176AD04B38F4A1108DE825464151865AB4A0141D054225CAD18766F4A2054D85484D41D2929AD4A476B8673E91F18C3850E2A5308DA94C674AD39ADAF4A638CDA94E77CAD39EE2B413400DAA5087DA895318D5A748BDA9514FA153A23A35A84B4DEA4D';
wwv_flow_api.g_varchar2_table(23) := '4141555258F5AA58C56A1C9E818C6A5483A573508458C74AD6B29AF5AC684DAB5AD7CAD6B6BAF5AD705D2B21E64AD7BADA951091C86B5CF7AAD6BC46A2AD770D2C5DFDCA57B53EE2B09248AC6217BB583970D5ABC778061C0441D9CA5AF6B298CDAC6637';
wwv_flow_api.g_varchar2_table(24) := 'CBD9CE7AF6B3A00DAD683B1B88D29AF6B4A80DC422563BDAD67276B58BF86C6A676B5AD8FFBA96B389C82D2376CBDBDEF6B60DCF388635AC11593720E2B8C84DAE7297CBDCE63AF7B9D08DAE74A74BDDEA42F710D8CDAE76B77B884978D7BAE07DAE7727';
wwv_flow_api.g_varchar2_table(25) := '215DEE9A37BBE30DEF7321C15E43B8F7BDF0852F1A823B5C663C830D85C8AF7EF7CBDFFEFAF7BF000EB080074CE0021BF8C0026E848217CCE0063742131046B084030C614D10D8C1185E7085271C604B787813200EB18845BC866730E31AD750C633D230';
wwv_flow_api.g_varchar2_table(26) := '8816BBF8C5308EB18C674CE31ADBF8C638CEB18E776C6347F8F8C7400EB2233041641E1BB9C644C6048E85CCE41F27F9C835AE84943341E52A5BD9CA6A788632B0810D654003186708B398C74CE6329BF9CC684EB39AD7CCE636BBF992CD708EB39CE74C';
wwv_flow_api.g_varchar2_table(27) := 'E73AD7F90D786EB32FA2B1652E2B231ADC1087A0074DE8421BFAD0884EB4A217CDE8463BFAD1908EB4A4274DE94A5BFAD2E20887A635FD8D4E7BE3D3A0E6B336B4918D522BE3D4A84EB5AA57CDEA56BBFAD5B08EB5AC674DEB5ADBFAD6B8CEB5AE77CDEB';
wwv_flow_api.g_varchar2_table(28) := '5B973A1BDB08B6B0874DEC621BFBD8C84EB6B297CDEC663BFBD9D08EB6B4A74DED6A5BFBDA0101003B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 3879999405555367337 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 3879752120485267805 + wwv_flow_api.g_id_offset
 ,p_file_name => 'three_1a.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

--application/shared_components/plugins/dynamic_action/com_oracle_apex_timer
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 4028023753162059496 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'DYNAMIC ACTION'
 ,p_name => 'COM.ORACLE.APEX.TIMER'
 ,p_display_name => 'Timer'
 ,p_category => 'INIT'
 ,p_supported_ui_types => 'DESKTOP'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'function render_timer ('||unistr('\000a')||
'    p_dynamic_action  in apex_plugin.t_dynamic_action,'||unistr('\000a')||
'    p_plugin          in apex_plugin.t_plugin )'||unistr('\000a')||
'    return apex_plugin.t_dynamic_action_render_result'||unistr('\000a')||
'is'||unistr('\000a')||
'    l_action     varchar2(10) := nvl(p_dynamic_action.attribute_01, ''add'');'||unistr('\000a')||
'    l_timer_name varchar2(20) := substr(nvl(case l_action'||unistr('\000a')||
'                                              when ''add''    then p_dynamic_action.'||
'attribute_02'||unistr('\000a')||
'                                              when ''remove'' then p_dynamic_action.attribute_03'||unistr('\000a')||
'                                            end, p_dynamic_action.id), 1, 20);'||unistr('\000a')||
'    l_expire_in  number       := nvl(p_dynamic_action.attribute_04, 1000);'||unistr('\000a')||
'    l_occurrence varchar2(10) := nvl(p_dynamic_action.attribute_05, ''infinite'');'||unistr('\000a')||
''||unistr('\000a')||
'    l_result apex_plugin.t_dynamic_action_render_result;'||
''||unistr('\000a')||
'begin'||unistr('\000a')||
'    apex_javascript.add_library ('||unistr('\000a')||
'        p_name      => ''com_oracle_apex_timer.min'','||unistr('\000a')||
'        p_directory => p_plugin.file_prefix,'||unistr('\000a')||
'        p_version   => null );'||unistr('\000a')||
''||unistr('\000a')||
'    l_result.javascript_function := ''com_oracle_apex_timer.init'';'||unistr('\000a')||
'    l_result.attribute_01        := l_action;'||unistr('\000a')||
'    l_result.attribute_02        := l_timer_name;'||unistr('\000a')||
'    l_result.attribute_03        := l_expire_in;'||unistr('\000a')||
'    l_result.attrib'||
'ute_04        := l_occurrence;'||unistr('\000a')||
'    return l_result;'||unistr('\000a')||
'end render_timer;'
 ,p_render_function => 'render_timer'
 ,p_standard_attributes => 'ITEM:REGION:DOM_OBJECT:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_help_text => '<p>'||unistr('\000a')||
'	&nbsp;</p>'||unistr('\000a')||
'<div id="cke_pastebin">'||unistr('\000a')||
'	This plug-in is a dynamic action which allows to periodically fire other dynamic actions in the browser.&nbsp;For example to refresh a region. But you can perform any action you want, because the plug-in just provides&nbsp;the infrastructure so that you can hook up your own actions which you want to execute periodically.</div>'||unistr('\000a')||
'<div>'||unistr('\000a')||
'	&nbsp;</div>'||unistr('\000a')||
'<ol>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Create a dynamic action with the &quot;Timer&quot; plug-in which sets up the periodic timer</li>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Create a dynamic action for the event &quot;Timer Expired [Plug-in]&quot; where you execute your periodic actions.</li>'||unistr('\000a')||
'</ol>'||unistr('\000a')||
''
 ,p_version_identifier => '1.0'
 ,p_about_url => 'http://www.oracleapex.info/'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 4028024256409069873 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 4028023753162059496 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Action'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'add'
 ,p_is_translatable => false
 ,p_help_text => 'Specify if you want to <strong>add</strong> or <strong>remove</strong> a timer. If you add a timer with the same name again, the existing one will be removed and created again. If you remove an existing timer, you have to specify a name when you add the timer so that you are able to identify it when you remove it.'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 4028024864375072152 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 4028024256409069873 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Add Timer'
 ,p_return_value => 'add'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 4028025251000077826 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 4028024256409069873 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Remove Timer'
 ,p_return_value => 'remove'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 4028025564253138411 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 4028023753162059496 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'Timer Name'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_display_length => 20
 ,p_max_length => 20
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 4028024256409069873 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'add'
 ,p_help_text => 'If you want to remove a timer with the "Remove Timer" action you have to specify a name for the timer when you create it. If you just want to create a timer you don''t have to specify a timer name.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 4028026052263144401 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 4028023753162059496 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Timer Name'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_display_length => 20
 ,p_max_length => 20
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 4028024256409069873 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'remove'
 ,p_help_text => 'Name of the timer you want to remove. Use the same name you used when you created the timer.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 4028026548369162138 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 4028023753162059496 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'Expire in x Milliseconds'
 ,p_attribute_type => 'INTEGER'
 ,p_is_required => true
 ,p_display_length => 10
 ,p_max_length => 10
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 4028024256409069873 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'add'
 ,p_help_text => 'Specify the number of milliseconds after which the timer should expire. There are 1000 milliseconds in one second.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 4028027037072168347 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 4028023753162059496 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Occurrence'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'infinite'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 4028024256409069873 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'add'
 ,p_help_text => 'Specify how often the timer should fire. The timer can be fired just <strong>once</strong> or <strong>infinite</strong> until you remove it with the "Remove Timer" action.'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 4028027645384170774 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 4028027037072168347 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Once'
 ,p_return_value => 'once'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 4028028050578172271 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 4028027037072168347 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Infinite'
 ,p_return_value => 'infinite'
  );
wwv_flow_api.create_plugin_event (
  p_id => 4028024037709064517 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 4028023753162059496 + wwv_flow_api.g_id_offset
 ,p_name => 'timer_expired'
 ,p_display_name => 'Timer Expired'
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '636F6D5F6F7261636C655F617065785F74696D65723D7B6372656174656454696D6572733A7B7D2C696E69743A66756E6374696F6E28297B76617220613D746869732E616374696F6E2E61747472696275746530312C663D746869732E616374696F6E2E';
wwv_flow_api.g_varchar2_table(2) := '61747472696275746530322C653D7061727365496E7428746869732E616374696F6E2E61747472696275746530332C3130292C633D746869732E616374696F6E2E61747472696275746530342C643D746869732E6166666563746564456C656D656E7473';
wwv_flow_api.g_varchar2_table(3) := '3B66756E6374696F6E206228297B696628633D3D3D22696E66696E69746522297B636F6D5F6F7261636C655F617065785F74696D65722E6372656174656454696D6572735B665D3D73657454696D656F757428622C65297D656C73657B64656C65746520';
wwv_flow_api.g_varchar2_table(4) := '636F6D5F6F7261636C655F617065785F74696D65722E6372656174656454696D6572735B665D7D642E74726967676572282274696D65725F657870697265642E434F4D5F4F5241434C455F415045585F54494D4552222C66297D696628613D3D3D226164';
wwv_flow_api.g_varchar2_table(5) := '6422297B696628636F6D5F6F7261636C655F617065785F74696D65722E6372656174656454696D6572735B665D297B636C65617254696D656F757428636F6D5F6F7261636C655F617065785F74696D65722E6372656174656454696D6572735B665D297D';
wwv_flow_api.g_varchar2_table(6) := '636F6D5F6F7261636C655F617065785F74696D65722E6372656174656454696D6572735B665D3D73657454696D656F757428622C65297D656C73657B696628613D3D3D2272656D6F766522297B696628636F6D5F6F7261636C655F617065785F74696D65';
wwv_flow_api.g_varchar2_table(7) := '722E6372656174656454696D6572735B665D297B636C65617254696D656F757428636F6D5F6F7261636C655F617065785F74696D65722E6372656174656454696D6572735B665D293B64656C65746520636F6D5F6F7261636C655F617065785F74696D65';
wwv_flow_api.g_varchar2_table(8) := '722E6372656174656454696D6572735B665D7D7D7D7D7D3B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 4028037441457391292 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 4028023753162059496 + wwv_flow_api.g_id_offset
 ,p_file_name => 'com_oracle_apex_timer.min.js'
 ,p_mime_type => 'text/javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

--application/shared_components/plugins/dynamic_action/com_aaw_loadingicon
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'DYNAMIC ACTION'
 ,p_name => 'COM.AAW.LOADINGICON'
 ,p_display_name => 'Loading Icon'
 ,p_category => 'EFFECT'
 ,p_supported_ui_types => 'DESKTOP'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'-- Developed by Tobias Arnhold - http://apex-at-work.blogspot.com/'||unistr('\000a')||
'-- tobias-arnhold@hotmail.de'||unistr('\000a')||
'FUNCTION render_loadingIcon (p_dynamic_action IN apex_plugin.t_dynamic_action, p_plugin IN apex_plugin.t_plugin)'||unistr('\000a')||
'  RETURN apex_plugin.t_dynamic_action_render_result'||unistr('\000a')||
'AS'||unistr('\000a')||
'  -- Return variable'||unistr('\000a')||
'  v_result                      apex_plugin.t_dynamic_action_render_result;'||unistr('\000a')||
''||unistr('\000a')||
'  -- Save plugin-parameter in local va'||
'riables'||unistr('\000a')||
'  iconAction        apex_application_page_regions.attribute_01%type := p_dynamic_action.attribute_01;'||unistr('\000a')||
'  iconText          apex_application_page_regions.attribute_02%type := p_dynamic_action.attribute_02;'||unistr('\000a')||
'  iconImage         apex_application_page_regions.attribute_03%type := p_dynamic_action.attribute_03;'||unistr('\000a')||
'  iconWidth         apex_application_page_regions.attribute_04%type := p_dynamic_actio'||
'n.attribute_04;'||unistr('\000a')||
'  iconHeight        apex_application_page_regions.attribute_05%type := p_dynamic_action.attribute_05;'||unistr('\000a')||
'  iconOpacity       apex_application_page_regions.attribute_06%type := p_dynamic_action.attribute_06;'||unistr('\000a')||
'  iconColor         apex_application_page_regions.attribute_07%type := UPPER(p_dynamic_action.attribute_07);'||unistr('\000a')||
'  backgroundOpacity apex_application_page_regions.attribute_08%type := '||
'p_dynamic_action.attribute_08;'||unistr('\000a')||
'  iconDefaultImage  apex_application_page_regions.attribute_09%type := p_dynamic_action.attribute_09;'||unistr('\000a')||
'  '||unistr('\000a')||
'  -- Variables for javascript parts'||unistr('\000a')||
'  completeCode varchar2(2000);'||unistr('\000a')||
'  '||unistr('\000a')||
'  v_prot_id number;'||unistr('\000a')||
''||unistr('\000a')||
'begin'||unistr('\000a')||
'/* During plug-in development it''s very helpful to have some debug information */'||unistr('\000a')||
'  IF APEX_APPLICATION.g_debug THEN'||unistr('\000a')||
'    apex_plugin_util.debug_dynamic_action (p_plugi'||
'n => p_plugin, p_dynamic_action => p_dynamic_action);'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
''||unistr('\000a')||
'/* Load JavaScript/CSS Libraries */'||unistr('\000a')||
'  apex_javascript.add_library (p_name => ''loading.icon'', p_directory => p_plugin.file_prefix, p_version => null);'||unistr('\000a')||
'  '||unistr('\000a')||
'/* Escaping der Parameter */'||unistr('\000a')||
'  iconText          := apex_plugin_util.escape(iconText, true);'||unistr('\000a')||
'  iconImage         := apex_plugin_util.escape(iconImage, true);'||unistr('\000a')||
'  iconWidth         := a'||
'pex_plugin_util.escape(iconWidth, true);'||unistr('\000a')||
'  iconHeight        := apex_plugin_util.escape(iconHeight, true);'||unistr('\000a')||
'  iconOpacity       := apex_plugin_util.escape(iconOpacity, true);'||unistr('\000a')||
'  iconColor         := apex_plugin_util.escape(iconColor, true);'||unistr('\000a')||
'  backgroundOpacity := apex_plugin_util.escape(backgroundOpacity, true);'||unistr('\000a')||
''||unistr('\000a')||
'/* Function declaration */'||unistr('\000a')||
'  completeCode := ''function(){''||chr(10);'||unistr('\000a')||
'  '||unistr('\000a')||
'/* Set default '||
'image */'||unistr('\000a')||
'if iconImage = ''default'' then'||unistr('\000a')||
' if iconDefaultImage = ''ICON1'' then'||unistr('\000a')||
'   iconImage := p_plugin.file_prefix || ''default.loading.icon1.gif'';'||unistr('\000a')||
' elsif iconDefaultImage = ''ICON2'' then'||unistr('\000a')||
'   iconImage := p_plugin.file_prefix || ''default.loading.icon2.gif'';'||unistr('\000a')||
' elsif iconDefaultImage = ''ICON3'' then'||unistr('\000a')||
'   iconImage := p_plugin.file_prefix || ''default.loading.icon3.gif'';'||unistr('\000a')||
' elsif iconDefaultImage = ''ICON4'' then'||unistr('\000a')||
' '||
'  iconImage := p_plugin.file_prefix || ''default.loading.icon4.gif'';'||unistr('\000a')||
' elsif iconDefaultImage = ''ICON5'' then'||unistr('\000a')||
'   iconImage := p_plugin.file_prefix || ''default.loading.icon5.gif'';'||unistr('\000a')||
' end if;'||unistr('\000a')||
'else'||unistr('\000a')||
' iconImage := v(''IMAGE_PREFIX'')||''themes/''||v(''FAS_THEME_NAME'')||''/''||iconImage;'||unistr('\000a')||
'--mel.p(''Plugin 2 Image %1'',v_prot_id,''TEST'',''Plugin waiting'',iconImage );'||unistr('\000a')||
'end if;'||unistr('\000a')||
'  '||unistr('\000a')||
'/* Code definition*/'||unistr('\000a')||
'if iconAction = ''START'||
''' then'||unistr('\000a')||
'  /* Start LoadIcon */'||unistr('\000a')||
'  completeCode := completeCode || ''fnc_startLoadIcon("''||iconText||''","''||iconImage||''",''||iconWidth||'',''||iconHeight||'',''||iconOpacity||'',"''||iconColor||''",''||backgroundOpacity||'');''||chr(10);'||unistr('\000a')||
'elsif iconAction = ''STOP'' then'||unistr('\000a')||
'  /* Stop LoadIcon */'||unistr('\000a')||
'  completeCode := completeCode || ''fnc_stopLoadIcon();''||chr(10);'||unistr('\000a')||
'elsif iconAction = ''PRELOAD_IMAGE'' then'||unistr('\000a')||
'  /* Preload Imag'||
'e */'||unistr('\000a')||
'  completeCode := completeCode || ''var v_load_image = new Image(); v_load_image.src = "''||iconImage||''";''||chr(10);'||unistr('\000a')||
'end if;'||unistr('\000a')||
'  '||unistr('\000a')||
'/* Finish Code */'||unistr('\000a')||
'  completeCode := completeCode || ''}'';'||unistr('\000a')||
''||unistr('\000a')||
'  v_result.javascript_function := completeCode;'||unistr('\000a')||
'  return v_result;'||unistr('\000a')||
'end render_loadingIcon;'
 ,p_render_function => 'render_loadingIcon'
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_help_text => '<p>'||unistr('\000a')||
'	This plug-in creates a loading icon frame on top of all other elements. You can use different settings to build up your own loading theme.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	<strong>How To:</strong></p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	Create a dynamic action &quot;Before Page Submit&quot;, then execute the &quot;Loading Icon&quot; plug-in with the action &quot;Start LoadingIcon&quot;.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	If you have problems displaying the icon. Build another dynamic action &quot;Page Load&quot; with the &quot;Loading Icon&quot; plug-in and the action &quot;Preload Image&quot;.</p>'||unistr('\000a')||
''
 ,p_version_identifier => '1.1'
 ,p_about_url => 'http://apex-at-work.blogspot.com/'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Execution type'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'START'
 ,p_is_translatable => false
 ,p_help_text => 'Define what action should be executed.'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141068751320519950 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Start LoadingIcon'
 ,p_return_value => 'START'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141069154091520730 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Stop LoadingIcon'
 ,p_return_value => 'STOP'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141098460070279397 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => 'Preload Image'
 ,p_return_value => 'PRELOAD_IMAGE'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 8141069932189533310 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'Icon text'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_default_value => '...loading...'
 ,p_display_length => 50
 ,p_max_length => 100
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'START'
 ,p_help_text => 'Enter the loading text which should appear during the execution. <br>If you add "empty" inside the field then no text will be generated!'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 8141080154980710265 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Icon Image'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_default_value => 'default'
 ,p_display_length => 50
 ,p_max_length => 200
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'IN_LIST'
 ,p_depending_on_expression => 'START,PRELOAD_IMAGE'
 ,p_help_text => 'Define the image name.<br>If it is set to "default" then the default icon will be used.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 8141073428951598651 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'Icon width (px)'
 ,p_attribute_type => 'NUMBER'
 ,p_is_required => true
 ,p_default_value => '32'
 ,p_display_length => 10
 ,p_max_length => 5
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'START'
 ,p_help_text => 'Icon width in pixel'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 8141073939340601652 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Icon height (px)'
 ,p_attribute_type => 'NUMBER'
 ,p_is_required => true
 ,p_default_value => '32'
 ,p_display_length => 10
 ,p_max_length => 5
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'START'
 ,p_help_text => 'Icon height in pixel.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 6
 ,p_display_sequence => 60
 ,p_prompt => 'Icon opacity:'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => '8'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'START'
 ,p_help_text => 'Set icon opacity. 1 is almost invisible, 10 is fully visible'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141074928735608036 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => '1'
 ,p_return_value => '1'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141075329774608296 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => '2'
 ,p_return_value => '2'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141075730467608535 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => '3'
 ,p_return_value => '3'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141076131506608776 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 40
 ,p_display_value => '4'
 ,p_return_value => '4'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141076532198608994 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 50
 ,p_display_value => '5'
 ,p_return_value => '5'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141076932891609223 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 60
 ,p_display_value => '6'
 ,p_return_value => '6'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141077333584609433 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 70
 ,p_display_value => '7'
 ,p_return_value => '7'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141077734276609648 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 80
 ,p_display_value => '8'
 ,p_return_value => '8'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141078134969609845 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 90
 ,p_display_value => '9'
 ,p_return_value => '9'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141078536700610292 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141074427696607730 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 100
 ,p_display_value => '10'
 ,p_return_value => '10'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 8141081442775725588 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 7
 ,p_display_sequence => 70
 ,p_prompt => 'Color:'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_default_value => '#98AAC8'
 ,p_display_length => 10
 ,p_max_length => 7
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'START'
 ,p_help_text => 'Set the color of the image box border and the image text.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 8
 ,p_display_sequence => 80
 ,p_prompt => 'Background opacity'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => '6'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 8141068247164518753 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'START'
 ,p_help_text => 'Set the background opacity opacity. 1 is almost invisible, 10 is fully visible'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141082857666729955 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => '1'
 ,p_return_value => '1'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141083258358730146 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => '2'
 ,p_return_value => '2'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141083659051730349 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => '3'
 ,p_return_value => '3'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141084059744730539 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 40
 ,p_display_value => '4'
 ,p_return_value => '4'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141084427668730772 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 50
 ,p_display_value => '5'
 ,p_return_value => '5'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141084828707730988 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 60
 ,p_display_value => '6'
 ,p_return_value => '6'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141085229400731188 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 70
 ,p_display_value => '7'
 ,p_return_value => '7'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141085630092731416 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 80
 ,p_display_value => '8'
 ,p_return_value => '8'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141086031131731708 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 90
 ,p_display_value => '9'
 ,p_return_value => '9'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8141086432516732079 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8141082356627729629 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 100
 ,p_display_value => '10'
 ,p_return_value => '10'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 8126555532460303152 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 9
 ,p_display_sequence => 35
 ,p_prompt => 'Default icon'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'ICON1'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 8141080154980710265 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'default'
 ,p_help_text => 'Select your default icon. <br> All icons come from: http://ajaxload.info/'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8126567208481315089 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8126555532460303152 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Indicator Big - black - 32x32px'
 ,p_return_value => 'ICON1'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8126664321210337705 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8126555532460303152 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Bar 2 - grey - 126x22px'
 ,p_return_value => 'ICON2'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8126742211298344274 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8126555532460303152 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => 'Big Roller - black - 32x32px'
 ,p_return_value => 'ICON3'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8126750928267349171 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8126555532460303152 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 40
 ,p_display_value => 'Wheel Troober - blue - 32x32px'
 ,p_return_value => 'ICON4'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 8126769018833365421 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 8126555532460303152 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 50
 ,p_display_value => 'Big Snake - red - 32x32px'
 ,p_return_value => 'ICON5'
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F30000FFFFFF000000C6C6C6848484B6B6B69A9A9A363636565656D8D8D8E4E4E4BCBCBC1E1E1E04040400000000000000000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904000A00000021';
wwv_flow_api.g_varchar2_table(2) := 'FF0B4E45545343415045322E3003010000002C00000000200020000004E710C8496961A5EACDE7624B85249D460C15A35202419454B22C07A53253E22A30352F2FC96DA270217A93C1CC301902103B24C53043019C2E02492A21FC4843284140116F0104';
wwv_flow_api.g_varchar2_table(3) := '832133395435BA5CD13829A80D87A060C1EEB4B26414077778473D59040A67140483774862861D7606413D923009565C9C5C883B09020503A4A59C9F3BA5AA9B48A88AA2ABAC9DB31D9830B6B57425914873898B72593C487F2E8113C589B79609BE9262';
wwv_flow_api.g_varchar2_table(4) := 'BF135A1A62C74F45673A04987F47595D2EC03DDA41DF4F519C7386E600EA5C62C3682E39EC3D7367F57F9E638CF365E21D12D82A128FD68666003744000021F904000A0001002C00000000200020000004EA10C8496959A4EACDA7594635149D4690D4A2';
wwv_flow_api.g_varchar2_table(5) := '5206C39454621847BA4A85BBC0ECAC4CAA9D64E11AF02685596D781BE88E94C30C1504205C0C14144098191280EAC1159A200804B0043118FC265283B1921348120A34013151B4DB7C56061925027A047614047F236A30870A8E146C8C47677B307E0389';
wwv_flow_api.g_varchar2_table(6) := '3C813C09845BA25B87689178A5A147A9040A79A9A2A9A7AF87A3B6965B9E3097BA1BBC47B4911BA8A650867A9C12C768C9BEA1C4986B7AC212691A97C908798EA0D1CA687C7AD5689247DD84E256C5A2AF81E900EDB9EB5C6813E75BAF8EEF00C7A4888A';
wwv_flow_api.g_varchar2_table(7) := 'F526952B91A0579E37B738E019C821020021F904000A0002002C00000000200020000004EE10C8492931A4EACDE7314735645D852895A152C7B29454328C946A4C847BC3D33C20135BD035E04D14BEE00A30D0192985190A204CB816A4490286F06D85CD';
wwv_flow_api.g_varchar2_table(8) := '45A8C76014B404057012A5550A0B81045E66142508825EB105C8E41D0206750C3B13027A7A027D3084581B090A8953300365771D79046B3C079C25099F4FA3A389930991A67AA4AA7B92ADACAA7CA9AAA4B6A3A225B91C9ABB14BD46AF698C31C2943088';
wwv_flow_api.g_varchar2_table(9) := '898087A6CBBC59B49B139AC338C4788ABF928C097A9FC940891289D73CDDAB00E2009AC7C1DEE3E800AFBE1BEC38F1E7593CAF8CEA12C9A50838F387A75C87501524B5BBA52192C10D11000021F904000A0003002C00000000200020000004E710C849A9';
wwv_flow_api.g_varchar2_table(10) := '18A2EACD67194555109D9620D5A052876194544210D9A40E13E1BE703E27B695A46508F5248899228803145C8723453143016E80C48E1483C97ED7D5004A192C16DC2C41619508AA1A9D55775E3401492550DDDE080E750B51163333027B308106693154';
wwv_flow_api.g_varchar2_table(11) := '85470567771C797D2503882527529C9D130CA0A10B05098E858C3DA1AA0CA6A79DAB0CA3A5A7339EB6479625B99470BABD30A60A9913B34A526F853513C8863049C4A66D796B8804C378CD130854885F7DC8288F0085D75EE2E2794B9D8E73B512EC9CE9';
wwv_flow_api.g_varchar2_table(12) := '3E695FA8258ED5EE6EFA3DD912E2DACA71D83465CD2D4DC2A444000021F904000A0004002C00000000200020000004EE10C849292AA8EACD272945A5645D95901318A6C35052094108943A21ADFB7A729282939C6277930D2536802247A42864245B2287';
wwv_flow_api.g_varchar2_table(13) := '92F84AB11EC04668AD90060361121B5104508D6070251CC2862F4246505C63550DE20D3F54D07402572F70060747264F744405615F1C7304791D6C44274D9899130B9C9D71098A7463989DA50BA1A299A60B62A0A2329AB1440393904D030C0C3A1D91B5';
wwv_flow_api.g_varchar2_table(14) := '1AB9B90B8F64A188250206C00C067FA2342573290BC0BB9175830483453314B80CA300595580198B0074DA96E6E691C6448A24E64A694DED3CE059E03B8AD8B0138098643C93204F02827458F23C71272B11420E11000021F904000A0005002C00000000';
wwv_flow_api.g_varchar2_table(15) := '200020000004F310C8496952A9EACDA7224A25209D969014A1A645515AAA90AE12D212EF4C64928AF72D59AEA60AF56882966BE851A17C80841235E17512BE0C3459F84914830115ABA002044E0D62570B878D80759187359B0AEEC17282F609AC257962';
wwv_flow_api.g_varchar2_table(16) := '1B173E5E25026F2F72761D6C39274C929313069697073B1F868739979F069B9C93A0069985A394AA390380258D1C050B0B038B6939B3B3069D12A820430807B90B072286421D030C420406B9B54473138F14070C0C061403CE5E5804667D245009D70C7B';
wwv_flow_api.g_varchar2_table(17) := '4CDE3F5000CA0C0B949B4F34000BD7D0C045D3F304E5929B56EB2418B8E6CA11016400024AD0232912850F705611C2C024020021F904000A0006002C00000000200020000004EB10C8496952A9EACDA7224A85645D952015A152C25A4E892A502A01ABE1';
wwv_flow_api.g_varchar2_table(18) := '3BD524507B2A944E82C0ED5C45D090F221087F31554F32DD4409995F723649F6620AA1A4E5D4C448979A380942973B09B2AC222708AA9C5ADBDA74BD92621C804B2343274B888913038C8D05777D3F888D940391924B95038F697A368AA03A0378824B04';
wwv_flow_api.g_varchar2_table(19) := '0606057F4143A8A8079F267D397F07AE0607747A5C1D050B5C04B6A8AA4435183B78030B0BB91305A8B1518164280CD60009CB0BB14B5712D60C12CA0B068A4D42E01306CB038849B4E91204DA884D3DF11207CBA41B7313F8E2B8BD384461018305A14A';
wwv_flow_api.g_varchar2_table(20) := '1460404C47040021F904000A0007002C00000000200020000004EF10C8496952A9EACDA7224A85645D952015A152C25A4E892A502A01ABE13BD524507B2A944E82C0ED5C45D090F221087F31554F32DD4409995F723649F6620AA1A4E5D4C448979A3809';
wwv_flow_api.g_varchar2_table(21) := '42973B09B2AC222708AA9C5ADBDA74BD92621C804B2343274B8889477A18697A36888F387D7A89928D947E8A9B2558844B020303391D833AA2A881307DA4250905A80305747A5C1D04064208B1A46C18630C031A030606074CA2625181060C0CC70BD100';
wwv_flow_api.g_varchar2_table(22) := '09C506908805CE0C19D10B1205C5C7890BCEC200DD1307C5B34B03CEDE12E812B8C588E40CECE7D2E9C5781CCE0628C89B50E09A0E58150C2C08C8E9D6827C2F22000021F904000A0008002C00000000200020000004F010C8496952A9EACDA7224A8564';
wwv_flow_api.g_varchar2_table(23) := '5D952015A152C25A4E892A502A01ABE13BD524507B2A944E82C0ED5C45D090F221087F31554F32DD4409995F723649F6620AA1A4E5D4C448979A380942973B09B2AC222708AA9C5ADBDA74BD92621C804B2343274B8889477A18697A36888F387D7A8992';
wwv_flow_api.g_varchar2_table(24) := '8D947E8A9B25853A080784412F030C0C03437D181B040BA6A686755C1306AF0C06B31B0203687D62A5A60B0544C21A040303C35D1F3D05A6A813070B0BA806D60009C803815629D30B19D606120ADA8A06D3D0E21305C8394303D3E312EB44E64BE80B90';
wwv_flow_api.g_varchar2_table(25) := '00F512EDBC4BA685A2758D09B712C72A1C303090531E03CA7444000021F904000A0009002C00000000200020000004EB10C8496952A9EACDA7224A85645D952015A152C25A4E892A502A01ABE13BD524507B2A944E82C0ED5C45D090F221087F31554F32';
wwv_flow_api.g_varchar2_table(26) := 'DD4409995F723649F6620AA1A4E5D4C448979A380942973B09B2AC222708AA9C5ADBDA74BD92621C804B2343274B8889477A18050B0C9091897A350A91970C93948D8F988A9F43853A090384412F030B0B05437D181B0406AAAA86755C1307B30B07B71B';
wwv_flow_api.g_varchar2_table(27) := '45687D62A9AA06360008C51A5B14081F3D04AAA5B80606A503D70057782629D40619D7D249398807D4AC00E1406F4305D40713EA543F4BDEC6E9D81364DB1BEF14F25DF8C14237A1C00082A0360818D0AB44040021F904000A000A002C00000000200020';
wwv_flow_api.g_varchar2_table(28) := '000004E810C8496952A9EACDA7224A85645D952015A152C25A4E892A502A01ABE13BD524507B2A944E82C0ED5C45D090F221087F31554F32DD4409995F723649F6080CC68015D4C448979A103008331605AAB39468D5B813839B61C0976A205512050B7B';
wwv_flow_api.g_varchar2_table(29) := '43496B1C6D624B2387634B919212803809847B61929538996E9B9518989993A5878256903A882F050606713A4D811B0A07AFAF4375807E00B7B807891A4568B36BAEAF0736000903BD005B14081F5FAFB183030336503C2F5508D90359484692E1393F12';
wwv_flow_api.g_varchar2_table(30) := '4DC2250AE147CBCCE943E16BF30076A81BD9F13E2E5DFA3614A9F02187290E17025688000021F904000A000B002C00000000200020000004F010C8496952A9EACDA7224A85645D550C15A152C25A4E09C318944AC06AF84E32734B368F0AB19B0C648B49';
wwv_flow_api.g_varchar2_table(31) := '1080C815290B190A104CD848B057A1470C360902CA174B5818A61283ECA0B1922E36A264B0A81B7E02067A9368D9C21407757507722F362058350683493B5F861C740B054F2345097B4F9B9B8839560706A2A39C9E39A3A8349D9E1804A1A99CB19B973B';
wwv_flow_api.g_varchar2_table(32) := '5696432F0A030380B936181B08BBC3987E2ABD1227C3058A1A4D6F1FB812BABB05806ECEC7621F58C2033A127E5D2B562ACD6D15E504194B5FE04FD1724B00F1B34E402E00EA9BD164F9007ECE71D0A6E41F13811C1244A20742D68B0B08354400003B00';
wwv_flow_api.g_varchar2_table(33) := '0000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 8126787429235391332 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_file_name => 'default.loading.icon1.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '4749463839617E001600F40000FFFFFF2A2A2A5757575353538787878484847171716161615D5D5D5252525050505F5F5F6666666767676969696B6B6B6E6E6E7070706262625555555858585A5A5A5C5C5C767676000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(2) := '00000000000000000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904000A00000021FF0B4E45545343415045322E3003010000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7C';
wwv_flow_api.g_varchar2_table(3) := 'EFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258552C18F0865CA295C8EF0D7A62629A68F9257E7B7D7F8483818588872482808C898F8B1393030A6C02440A700C0D0E9E0E5A9FA2A009285AA6A527';
wwv_flow_api.g_varchar2_table(4) := 'A7AAA926ABAEAD25AFB2B124B302931396076D710E0FC00F0303C1C5C20314C9CAC9C3CBCBCDCECCC8D114D0D1D6CED8CFD3D7DCD9DE2293BB55099CBF0F10E993E9ECEC9315F0F1F0EFF2F1F4F515F7F5FAF2FCF613F8E6010CE84F60BC64E1D6F0C264';
wwv_flow_api.g_varchar2_table(5) := '450EB076EBDAB99B60A1A2C58A932E5ECCA81123C58E16387614A991E4C68F2351FF96445901A10085E43AA163174144849B386F8A00696127489F1D816A147A91A845A31591F614C053684B113019269049B3A6809C39956A65FA936B50AF43C116157B';
wwv_flow_api.g_varchar2_table(6) := '946C52B34B2F3E7D7989C8D45F556D62D589766BD3BA78EFEAEDBAB7E25A98030A20783B339DD5B974FB86553C967159C76715FF153C40AAC3C210224ACCACF2244F9316417BFCDC3974E9D120458764E932AA5B730FD54DD82C3B60BE81F80ADEB6ADBB';
wwv_flow_api.g_varchar2_table(7) := '37EE7DBFFB05FF779042C2B60734C10E36CC18736FDBA85583AE4C5B75EAD2A45BCF4E6DFBF465E17421576EEE53A8519E6E8D500FB5D67AF7ED51C967351F562071E3DFC49953070FFF45233462882301425220800921888B36810912D8E0800152328E';
wwv_flow_api.g_varchar2_table(8) := '54699C61E1851866A8211A592007C487208628E2883A2C64C01428A6A8E28A2C3E01C38B30C628E38C3084000021F904000A0001002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C9';
wwv_flow_api.g_varchar2_table(9) := '6C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1442B69D8EF12FA1DAF9D98E6097E25808224847F7D88818A857289838F027013030A6C02440A93255A0E9E9F9E9DA09F5A28A527A726A99C09A6ADA8AFAAB1AC837096';
wwv_flow_api.g_varchar2_table(10) := '076D710214BC1403030FC1C2C1BFC3C3BFBDC9BE03CABDC8CDCBD0D1D0CFCDD5CAD7C9D722B697448BBB1415E37010E6E7E6E5E8E770E3EEEEEDEFF013F2F3F5E4F4F7F1F5FBF2FDEFFB78715B830B931511BC2A5858A86E1D8486EBE02C9C385122C58A';
wwv_flow_api.g_varchar2_table(11) := '132E62D4C83023478B1A415E1449116405810208FF5679258EA288083063C27C2933A6088E166E72D4A991E7459F2E05E0043A91E8429F2745A834C852615101356D428D1AC1684EA13BB1F6D4FA936BD0A15E9F82A59834A5B783BB9C1E9D1A9566DBB0';
wwv_flow_api.g_varchar2_table(12) := '6BC76695BB956E57BB65550E2880A06950AA55D9D6B44A18EE55BB5FE72AAE3B312FDF014C11B6ECE830DD84CA0F3D86D43C927349CF1B3F82EE889364680B2729283D0B2E213ECC10D1FDB3A72F1F3FDBFE7003D44DFBF6BD0A01554B5A9A49973660C6';
wwv_flow_api.g_varchar2_table(13) := '88214F9ECD19336ACFAD45C736FDB8B4E6BCB04F43D9AD60715D23448D72207ED42A12E7C3CF42BF5EBDABF7B0E0CBE9DEE60D784075F634C89320FF1EFE8D0C048E21913832A081010E77A03580091E02C9809354C25A1A675468E18518668846166701';
wwv_flow_api.g_varchar2_table(14) := 'E1E187208628A20E051930C58928A6A8E28A4FC0E0E28B30C628230C21000021F904000A0002002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CB';
wwv_flow_api.g_varchar2_table(15) := 'ED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD1392867E2FD1E6F77A7D0975257784248676748A838C87728B8591027013030A6C02440A95255A285A0EA2A3A2A1A4A39F27A926AB9E09A0AFAAB1ACB3AE857098076D710214BE140303BFC3C0';
wwv_flow_api.g_varchar2_table(16) := '030FC7C8C7C1C9C9C1C4BFCECFC5D2D3D2D1CFD7C4D9C3D922B899448DBD1415E570E5E8E87010ECEDECEBEEEDE7E9EA13F4F5F7E6F6F9F3F7FDF4FFD2F5F3E56D8D2E4D5644F8AA60A1219C861021C28B076162BC8711254EC8A891A3C38D1E31721499';
wwv_flow_api.g_varchar2_table(17) := '916444911508FF0A30582516B988223C5A1011A1A6CD9A346FDA8CE99127479F1981C21420532844A30D81A614C112A14B864789F614A07327D5AA1190CE94FA936B50AF438B828D2A36E2D295E012F6829A746C5BAC59AF56D54AD7EDD6B253F176354B';
wwv_flow_api.g_varchar2_table(18) := '81299B0105103C0D3B156ECEB976EBEAFDBA98F05E886713041EE054E1CB8F322DBAD32C0FE448CF25419F14DD312469CCA621AB6C1A8ED0427DF92A707E378122EDD801F1F1DBE78F3740DF0281EB4ED99712EB039C5C431366CD183365CE9F6F5B4E6D';
wwv_flow_api.g_varchar2_table(19) := 'BA2FEBD5B031D75E7D7BF16F07377522D18A7C8253A8CEA377507E447BA6B5CCC39A2F8BBE1CF06DDEF0322E0E911F4081FC07A0208F14D41F24071A5820377F0B262249820CDE67492E2DA571C6851866A8E1866864911610208628E28824EA70900153';
wwv_flow_api.g_varchar2_table(20) := 'A4A8E28A2CB6F8040C30C628E38C34C210020021F904000A0003002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF5845';
wwv_flow_api.g_varchar2_table(21) := '8258550C26F0D1443B31CD13F5D25DD2E8FB255A7C7E7D8078767487867A888B8A2477798F8C027013030A6C02440A95255A289F275A0EA4A5A4A3A6A5A126AB9E09A0AFA2B1ACB3AE7A7098076D710214BE140303BFC3C0C2C4BEC10FCACBCAC9CCCBC1';
wwv_flow_api.g_varchar2_table(22) := 'C7C8C6C7D1D2D6D5D4C4D8DBDA22B899448ABE15E570E5E8E8E7E9EA1310EFF0EF70F1F1EBEC15F6ECF9E9FBEDF7E613FEE10B58CED7B735BA34591141CE8243380E2346842871A23B7AF22E62A458D102C78A1F2586B4D8F1E184921E4FFF3AAC605000';
wwv_flow_api.g_varchar2_table(23) := 'C22AB1285490280265CD922222E8DCA93327CF9D373B06AD3894A6009B47712615BAD4024B112F15C69C19B168D5A6467F0215A0B527D6AB48C32A15CB54E25397E116F6A2EAD06ADBAF6FBB46F0A9D5AD05BB78E1DED59BD72C05A86C06144030D52859';
wwv_flow_api.g_varchar2_table(24) := 'A25CBBD2FDD977ACE3B28F11FB853A788054863249961C69126346CF1038A74429BAB4CA8EA623B2FC8B36A1B83CE4000AEC0710F43CCFB407CE26782FB76FDEFA78B79C939613EC5FDC8625473EE019B4E6CE1F2C9F26AD58F5E9D6AF6953EE8DD2845C';
wwv_flow_api.g_varchar2_table(25) := 'BB788D684582FCF804A954A14FEFC03CD45AE5E19F87455FD6ADEFC5DF88879428929C40831002608085F8779023FF2178A03A81944C922083FC7D03C725695D91C5191866A8E1861C7A914654440021E288249668A20E091930C58A2CB6E8E28B4FC020';
wwv_flow_api.g_varchar2_table(26) := 'E38C34D668230C21000021F904000A0004002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B';
wwv_flow_api.g_varchar2_table(27) := '31CD13F5D23D4FBA4B1A8081125A7F8180837876748A897A8B8E8D7D8F027013030A6C02440A95255A289F27A1265A0EA6A7A6A5A8A7A39E09A0AFA2B1A4B3AE7A7098076D710214BE140303BFC3C0C2C4BEC1C7C8030FCDCECDC1CFCFC9CAD4C7D6C4D8';
wwv_flow_api.g_varchar2_table(28) := 'C3DABFD822B899448DBE15E570E5E8E8E7E9EA13ECED10F1F2F170F3F3EBEFF8ECFAE9FCEDEFE6DC95F3F56D8D2E4D564490B3C0100EC3870F1D428C386122457BF2EA618420D162C7891F2186A468B16145861508FF0A30582516850A104594B420B364';
wwv_flow_api.g_varchar2_table(29) := '4D8B2222E8DCA93327CF9D3727068D2960E6D0874719064D2982254297309116B539156755A1027E02CDAA3542529A57891A0D2B752C44A62BC325EC15552959B766A976F5CA55EBD7BB6FC1C6B57A96425336030A20802A96EA5EAC737DDACD8BF77061';
wwv_flow_api.g_varchar2_table(30) := 'BE0FD126103CE0A9C297244B8E3439532346CFF6365B104DFAA447D3204DA7F49BF6A0B83CE40202ACE04F3640D0F7266CE428305FEF7DBFFB05FF77BBB7CA396A39C1EE66EC5AF36CCFB73193066D3A756ECB9415D38E7D7BB5E7DF26E4DAC56B442B12';
wwv_flow_api.g_varchar2_table(31) := 'E7CDD7429F6015ABF6EE1DA46FBA5E3DACFBB26E894FFEA6FC1E467CC83189800914620822060A32603D4191101820830F52B2A084915472895A576471C6861C76E8E1875EA4E11411409468E28928A6A8C341064CE1E28B30C628E31330D468E38D38E6';
wwv_flow_api.g_varchar2_table(32) := '0843080021F904000A0005002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D';
wwv_flow_api.g_varchar2_table(33) := '4FDADBB5120D828312808384747F788A7C72897A8F027013030A6C02440A93255A289D279F26A19C090EA6A7A65AA8A8A324AD23AF22B102AD9396076D710214BC140303BDC1BEC0C2BCBFC5C6C4C5BF0FCDCECDCCCFCEC7C8D4CBCAC2D6D9D82270B755';
wwv_flow_api.g_varchar2_table(34) := '8BBB1415E470E4E7E7E6E8E913EBECEEE51310F3F4F370F5F5EAEEFAEBFCE8FEEFC8F1EAB60617262B227855B0C0100EC3870F1D428C386122458B0DE5E1B3A771A3448B1F27868438F222C30A0369FF5D229220E1C28722305A888991A6459B134544D8';
wwv_flow_api.g_varchar2_table(35) := 'C973A7CE9E3C7142140A53804CA20C71A294B512E1AE97498DD6947A936A4EAB4305000DAA756B04A433B1163D2A362AC4A52A0DB2749995ACDBA964BD7EEDBA15ACDDB261DF9EA4C014D78002085A3E6D0BB770D5B85E7FD6C57B57EFD5B37C69011E70';
wwv_flow_api.g_varchar2_table(36) := '50B04293202B622C9951E6BD8D103E7BD49CD9336991A749924619B920B83C0AE3C1AB005036BCDAB43BE213BDBBDD6DDFFB80F713FE0F78CA394D35C1EEA52D5873E6D89C47872E6DDA80EAD0A62743368CFBF3EDBDBA4DF8765079235A8245A527E569';
wwv_flow_api.g_varchar2_table(37) := 'BDAB52AB52C18F3FABBE7B58F765B9B795FC8D2E499138124E1F011234A080811CD24041210924780883E70178A08111FA01C9809354D2D415599CE1E187208628A21769B876101028A6A8E28A2CEA60900153C428E38C34D6F8040C38E6A8E38E3CC210';
wwv_flow_api.g_varchar2_table(38) := '020021F904000A0006002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDA';
wwv_flow_api.g_varchar2_table(39) := 'DBE97F09120D8485125A8385848778817C72807A91027013030A6C02440A95255A289F27A126A39E09A0090EAAABAA5AACACA524B123B322B19598076D710214BE140303BFC3C0C2C4BEC1C7C8C6C7C9CAC10FD1D2D1D0D3D2CECDCCC4D8DBDA2270B955';
wwv_flow_api.g_varchar2_table(40) := '8DBD1415E670E6E9E9E8EAEB13EDEEF0E7EFF27010F7F8F7F6F9F8ECF0FEED00AAF3E7EBDB1A5D9AAC88F055C18243380E2346842871E2848A16313EBCA8711F3F081EF951C438B2624989232BFF14147050DCC286114568B42053634D8C372BE6942822';
wwv_flow_api.g_varchar2_table(41) := '82CF9F3E7B02FDB933A68099451DE654692B139153BD602A3D6A932A4EAB3AB1F2D46A742851015E83729D8A742C4DAC4C593A5518756BD9B755E15E0D1B41A8D7A467E5669598B6E5800208A096731BB7F055BD5BE9DA1D8AB7B1D9A5146C011E9050F0';
wwv_flow_api.g_varchar2_table(42) := 'E08D334F66ECC891646793133EEA0B2D5A3366CE993BAB8CAC16E1D33C0CE7C9AB20305E3D7AFF700724FD3164BEDAB26FCF26C87ACE5A4EB07F711BB65CB936E6CF9D2B2B66EDDA80EAD4A22F9BDE7CFBAF6F13C22544FE88255452E74DA15A2F2AD5AB';
wwv_flow_api.g_varchar2_table(43) := '56EEDFD732CF1EBD1E70C7DFF0A23409D2B83EFD19F49F7FE5F12788228B2082603B038C14E88724030AC8472597AC7545166764A8E1861C76E8451A2D2504C488249668E2893A2064C0142CB6E8E28B303E01C38C34D668E38D3084000021F904000A00';
wwv_flow_api.g_varchar2_table(44) := '07002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDADBE97F7881120D85';
wwv_flow_api.g_varchar2_table(45) := '86125A84868588827A808F8E027013030A6C02440A94255A289E27A026A29D099FA6A1090EABACAB5AADADA424B223B29497076D710214BD140303BEC2BFC1C3BDC0C6C7C5C6C8C9CDCC030FD2D3D2C0D4D4CFC3D9C2D92270B8558EBD15E470E4E7E7E6';
wwv_flow_api.g_varchar2_table(46) := 'E8E913EBECEEE5EDF0EAEE7010F7F8F7F6F9F8F4EBFEE8E8F5F2B62657262B22C659580867A143870D1F429C2071624586142F46ACB88F1F848EFC364A14F970638581020AFF864B58E1A1888B165E5E945991A6449B2E05C01411A1A7CF9E3C7FFAC4E9';
wwv_flow_api.g_varchar2_table(47) := '90E8429B2745A83C888A42CBA23A6746AD39F566D59C3BAF42153A540057A05A8F868D5935694A4C449A3E159BB5AD54B754B37E8D1094AB51B2702D985539A00002B558DF0A8E3BD8AADCAF7585DE5D5C968252BF039826746A5163468E9747662EB9B9';
wwv_flow_api.g_varchar2_table(48) := '32668FFA2680FED819234C932897A6CD332E1EBC0A00DFCD93578FF63FDB01458306992FB6EBD9E750CE417B60136B5FDB902FD3B69C5B73E5C98845B776AD5AB4EA0F922B9BBEDCDB0470078DF3518A6A54F952A7D2A73A058BD5ABF60E6891572FE71B';
wwv_flow_api.g_varchar2_table(49) := '71379C084A9203A94F7FFEFBE9379E80832CC248220636D0C8358093FC47A077958097561A675468E1851866884616C401E1E187208628A20E061930C58928A6A8E28A4FC0E0E28B30C628230C21000021F904000A0008002C000000007E0016000005FF';
wwv_flow_api.g_varchar2_table(50) := 'A0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDADBE97F78817C725A120D88891286898A807A8F027013';
wwv_flow_api.g_varchar2_table(51) := '030A6C02440A93255A289D279F26A19C099EA5A0A7A2090EACADAC5AAEAEA324B39396076D710214BC140303BDC1BEC0C2BCBFC5C6C4C5C7C8CCCBCAC2BF0FD3D4D3D2D5D4CED1D02270B75582BB1415E470E4E7E7E6E8E913EBECEEE5EDF0EAEEF4EB70';
wwv_flow_api.g_varchar2_table(52) := '10F9FAF9F8FBFAF6E8E8F1EAB60617262B227855B0C0100EC3870F1D428C386122458B0D2B62946891E3C47EFE2080F4E71122C70A0305FF14049770E14311182DC0C438D362CD893721E67C2920A68808408302FD2934E84E8637518A5879F0D4389D3D';
wwv_flow_api.g_varchar2_table(53) := '6946B539156755A83EAFF2CC5AD4A880AE43B522ADAA54E525224E5D8ECDCA566A5BAA6FAD828D40B4EB519964292C6533A00082B458DD0A863BD86A5CA873EB16BD9B54AF4ABF039A267C9A3166C98B1B3576D4FC91B349CF1443F29B205A24E8CA0C51';
wwv_flow_api.g_varchar2_table(54) := '3A668A368FC278F02A007C374F5E3DDBF77007D4CDAEF4C87DB361934B39E7EC014DAE7B690BB65C3934E6CF9D231B36BD79326CD90660B7163D59B06E13BE1D444E48652A52A6D2A352AFCA54AC56B0DE3B9835A29637E36E36110CD7275221FEFF9527';
wwv_flow_api.g_varchar2_table(55) := '897FFB09E80724091CD2483B038B24B82083040EC8DF2495187745166764A8E1861C76E8451AAC1D00C488249668E2893A1864C0142CB6E8E28B303E01C38C34D668E38D3084000021F904000A0009002C000000007E0016000005FFA0208E64699E68AA';
wwv_flow_api.g_varchar2_table(56) := 'AE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDADBE97F78817C72807A5A120D8A8B12888B8C86027013030A6C02440A9325';
wwv_flow_api.g_varchar2_table(57) := '5A289D279F26A19C099EA5A0A7A2A9A40EADAEAD5AAFAFA3927096076D710214BC140303BDC1BEC0C2BCBFC5C6C4C5C7C8CCCBCAC2CED1030FD5D6D5BFD7D7D222B6974482BB1415E470E4E7E7E6E8E913EBECEEE5EDF0EAEEF4EBF6E87010FBFCFBFAFD';
wwv_flow_api.g_varchar2_table(58) := 'FCE8F1EAB60617262B227855B0C0100EC3870F1D428C386122458B0D2B62946891E3448F10FF0184201220C70A0305FF14AC726A1C4411182DC0C438D362CD89375F0A8899F3614F862222081D2A3428D1A137518A5879B0E5429F3B6946B5391567559D';
wwv_flow_api.g_varchar2_table(59) := '3CAF42CD9AF52852015E8B5655AAF21BC25D4F816A55CB556A5BAA6FAD760D6BD46B520A4BD90C2880C02956B780E106963BF82FD5B011EA1EBDBB94EF80A6095D668C09F2E2468D1D317FD41C92B3E5CC23FD4D084D12334ABC650D82CBA3301EBC0AF8';
wwv_flow_api.g_varchar2_table(60) := 'DECD93578FF63DDBF970CBAE4DBA643F81A8E798D5C4BA97B460C78D4343BE5C39B261CF93278B4E4D1BB6EAD6B9D5BA954BD7085ADF579100BF547C7853E8519992E52A167B07B426713FE86613C1707D2215C2BF9FD07DFF92E8F7DF208124F248038D';
wwv_flow_api.g_varchar2_table(61) := '2460E0352309F2314925665D91C519145668E185187A9106534400E1E187208628A20E061930C58928A6A8E28A4FC0E0E28B30C628230C21000021F904000A000A002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7C';
wwv_flow_api.g_varchar2_table(62) := 'EFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDADBE97F78817C72807A867D5A120D8C8D128A8D0C920B0A6C02440A7084025A289D279F26A125A324A523A722';
wwv_flow_api.g_varchar2_table(63) := 'A99C099E090EB0B1B05AB20D920C95076D710214BE140303BFC3C0C2C4BEC1C7C8C6C7C9CACECDCCC4D0D3D2C3C10FD9DAD9D8DA0EB6B8964482BD1415E770E7EAEAE9EBEC13EEEFF1E8F0F3EDF1F7EEF9EBFBEF10FF00FFC10198ED1B8335BA2E5911E1';
wwv_flow_api.g_varchar2_table(64) := 'AB828587701E4A94187122C509162F6684887163C58C1F2D869C38F262C0800309FF3E6084B04AAB5E0E258AD86861E6469B19715AD43991A74C01347D3E145A534084A3488F8A8810F0C1B7960A5F9AEB09F466D59C577766A51A74EBCFAE60AD264DBA';
wwv_flow_api.g_varchar2_table(65) := '94E93FA70DA08E631873A857B761B1C6D53A97ABD5AE63919625F894CD800208A4B62D5AF7EBDDC37211D3554C35AF52A34D9F021E1095E1548E344B62F6D8116467919F4986D6C839F3849300539E5D99569C953C0DE9CDABD04FB6BD7AF870EBD3CD8F';
wwv_flow_api.g_varchar2_table(66) := 'B7BCDBB3559F545DD096DA039960FFA276CDDA72E7CB941593CEFC3975E8D39F0DD8B6AD5B7149B976F142F552547952E74DA527EFAA3DA8F5AAE0B392258B562C70E112627A33DECF2172890058888022F817E026021838203C820A160849238C3C92C0';
wwv_flow_api.g_varchar2_table(67) := '228CDC42896B576471C6861C76E8E1875EA4711C10249668E28928EA90900153B4E8E28B30C6F8040C34D668E38D38C210020021F904000A000B002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF3383887028';
wwv_flow_api.g_varchar2_table(68) := '1A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258552C18F0865CA29D9826F57BBE844FD8F97B247D7F828123837A7E8984875A12720D700C0B0A04060D02440A920D0E9E0E5A28A127A326A525A724A923AB22AD02AF';
wwv_flow_api.g_varchar2_table(69) := 'B1099F0E91709517989A710E0FBE0F030314C3C4C3C1C5C5C7C8C6C2CB14CACBD0C8D2C9CDD1D6D3D8D5BF0FB5B704B999560C9DBE10E7131315EBECEBE9EDEDEFF0EEEAF315F2F3F8F0FAF1F5F9FEFB00F63B07C197B735E1882490638E603A0B102342';
wwv_flow_api.g_varchar2_table(70) := '7C283122C58A162E56D42891A3C5091827820CE95164C88C1308FF167C2007A12E2BE5544610719266489B187156D4299167449F10815A104A54400495DD1AB814B7B017C1083305D4947A936A4EAB3BB1F6D4FA936B50AF43C116854A30E9528531CF41';
wwv_flow_api.g_varchar2_table(71) := '2D3AB56D55B757E16695BB95EC39B3E01A0C2880A0E903996CDF0A8E3B786EE1AD74BB1E2D5B2B410103129832FCEB7024C692284F62DE6C7963E78E9F3F6A0E2D12294BA5799992EB4519023F76AFE9D9BB2710766DD9F662D39EADBB77CABB49199C3D';
wwv_flow_api.g_varchar2_table(72) := 'B06935376AC4903373F64C5B72E7CB9D296FCE7CBAF501DCBC31C0F5B2F8EA4FB24425104F9ED478F3E54D9D572F9E96ADEDA935BD8933C79008448014E56774DFBE00FC85E817207FFFF9076023093C228735249458F2D215599C21E184145668A11769';
wwv_flow_api.g_varchar2_table(73) := 'AC7140154074E8E1872086A8C386021830C58928A6A8E28A4FC0E0E28B30C628230C2100003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 8126788227079392280 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_file_name => 'default.loading.icon2.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F60000FFFFFF000000FAFAFAE2E2E2D2D2D2D4D4D4EEEEEEFCFCFCF6F6F6B8B8B86C6C6C4444444E4E4E888888D6D6D6F4F4F4C6C6C64C4C4C0404041E1E1EE0E0E0EAEAEA9E9E9EA6A6A6F2F2F28A8A8A1A1A1A363636BABABA';
wwv_flow_api.g_varchar2_table(2) := 'DEDEDEDADADA7A7A7A3C3C3C2828282C2C2CA8A8A87676760E0E0E222222AAAAAA565656ECECEC8686862020200C0C0CACACAC1C1C1CC8C8C81616160A0A0A262626848484C2C2C23E3E3E1212127474749292929090901818188C8C8CB6B6B6303030BC';
wwv_flow_api.g_varchar2_table(3) := 'BCBC949494424242D8D8D8A4A4A4C0C0C0CACACACCCCCC5A5A5A2424248E8E8E7E7E7E727272808080080808BEBEBEAEAEAE7C7C7C9696966868686A6A6AB4B4B4DCDCDC606060B2B2B2B0B0B0787878CECECE828282585858323232C4C4C4E4E4E4F8F8';
wwv_flow_api.g_varchar2_table(4) := 'F8F0F0F0E6E6E62A2A2A6262625E5E5EE8E8E870707000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000021FE1A';
wwv_flow_api.g_varchar2_table(5) := '43726561746564207769746820616A61786C6F61642E696E666F0021F904000A00000021FF0B4E45545343415045322E3003010000002C00000000200020000007FF800082838485868788898A8B8C8D8D07860829028E86290434052983021C33049584';
wwv_flow_api.g_varchar2_table(6) := '1E2A0C350C0D419008394009A182151F2B12B4261F1507070E3C1585151D0F89020920B4C61B099000B984294B464E08880F1621C6B516D287041B250A0688081722D7122127948715CFD18807040C2CD70C44CAEA1EC18906230B1A362E0B84607855E8';
wwv_flow_api.g_varchar2_table(7) := '00060F2D5490D8E1031CC141082064209181C30003E91C31E39420828612005FBC7260C1028541031494BB91AF518527134CEC70486041B905BD1C5130424B41CE020CCA31C8D90803941A0B460C0460A0C104632E70646C6480081187CB1C28D8606203';
wwv_flow_api.g_varchar2_table(8) := '89930F0B52E0702281038C610F3D786121072F7B899836BA838042C604103F36C5256281C652752460180332242E871A2E366443D401450C632146284380411B5312256845A182A88282CCB440F80020A0089224277262500183490929440B76D4A0A3C7';
wwv_flow_api.g_varchar2_table(9) := '8C01BA8CC028D1C302B877466A189932B5D08304333E58E870409C0C63463C083AE0A14901CB880454A8900F819023B44A442704371401DDBC2DFC4D4B9AC60C2526D917126080BBA3400021F904000A0001002C00000000200020000007FF8000828384';
wwv_flow_api.g_varchar2_table(10) := '83071554542907858D8E8E0F104928284B2F0F8F998D0234461A12121A4610029AA600154B13A0A0134915A785060E04150241464CACA04641B182070E0D280C584D4446BB1225BDBF000324AB123A284E49D2A02EAF8215158C8F023C1BBB13193C2830';
wwv_flow_api.g_varchar2_table(11) := 'A0365B43A5A9490399084221CA2415455A0C0C330408DC51A238C824C0CA38562B726042902205826F006E0529958982924F12603080E04CDE8B270C22284880A163230C0586100942A0D63F9384303831B20085055B300B1D1812A104A80D2720C64200';
wwv_flow_api.g_varchar2_table(12) := 'C102018A0F7E602B410293B30E4642288005E0018EA54D3B7A882283443C00079AF494C062430BA1A71074314A11800127559C6ADECC891600CA21040CE4D424E080000C0FEAEE75CB0109147FA71E38E47B65C18A2351B2081E94C2028911251F555090';
wwv_flow_api.g_varchar2_table(13) := '4EC211284E1D1DB0D2A3448D2615A3B09A802473C4B660479890C0654A260C38443081B12041A90305840829D0B68392084BBE6AC61145CA15BD003C4831B1220A1542156A993A8081024EB03C7A80EAC163B2C9212040811862BE63851C2173501D8CBD';
wwv_flow_api.g_varchar2_table(14) := '4891F9F40707020021F904000A0002002C00000000200020000007FF800082838485000786898A890715455D410F8B9386070E4B0B35462315949E00144F2B121225402D92070F18089E0F03050308023E404CA4123A1F0318441638270E028B184E0A5B';
wwv_flow_api.g_varchar2_table(15) := '0A3C152D5CB8A55104275B22261B0A2F5F89B40B25253A0C094D11CE2E4F171125B82E0A5489060D3AB82639412A47A42C114E1926CE120B1C10154A9104062E0D190C54B06084C1872E1596C473B6A1C5B042084E70892181090827880E28C400E00194';
wwv_flow_api.g_varchar2_table(16) := '7BB85800F171B15005150B7A44C8314051171436E47DE8A0084185262D8654106808C315233D426CB841A4952104184212ED59C089101E14A60AC240408890022D3D2198A5ADC99610328C40F8544855B64106B5546820A5418B53B6003C407162605005';
wwv_flow_api.g_varchar2_table(17) := '12E94A29B8CB96068A5D831058E0D26D8385B09F2A70684AA8020E23462CD4C43BE9400A0F0E3A711E4DDA1306035A4B0F3A4000C9121F9228A520E02535A10E5134C00008B9D0831C35945098046103291350622B4AA10046842293826C8151E2E3DD07';
wwv_flow_api.g_varchar2_table(18) := '14860E1270450A14D18A1E3889927933000C23A2242140D427494A082804E93BC8C1B82339DEAB26548041892338E8B79F20065CA01E7B03168241768425485A200021F904000A0003002C00000000200020000007FF800082838485070207858A8B8C82';
wwv_flow_api.g_varchar2_table(19) := '0604534D14898D95850F175B1B404B0494969507440C251212621915A08A08600882082D62A61225510E02154510410F96032D19174102084E22B4B605042A0C0B512D298D152A1B1A3D491D071E6330B51B162F5847A6251153AF8B450BB4350900084D';
wwv_flow_api.g_varchar2_table(20) := '0A0B0C161E3C35B4121A49AA8B2F359898DA6045D0810A1D283C10D0A2873E5B1E18555060A28489280418355950CA948919FE141D78A1C2C89226BE160DD0D2238604182838A45B74D04185998A0438C861848102214152E05CB50843902E57702CC970';
wwv_flow_api.g_varchar2_table(21) := '65C027301D060CB5740082821E2E4C0041E26F008E2D465A18200AA0020917FA365C0020600A88970CB5321225904F1F0C05F02C8418E8832C01870FC900384003C584230A82900D1281853E1D4904A5E0D1000791A98D1EE468690A0683218310A430F0';
wwv_flow_api.g_varchar2_table(22) := '89A8871D0B7A6C8872652C594607BB38994200C36B50074A2BAA50208C6E4688407558B24081274B419024C03CE8C0152EA72CA46C9460810AD7B07D44D001E4CA4C01296C1302464480A5142D48080929E045030B2105050785A0C2834F06541C89D0E5';
wwv_flow_api.g_varchar2_table(23) := 'F7ED410F58500346FF554201072F88572070FE2D5860200021F904000A0004002C00000000200020000007FF8000828384858687888900184144410F8A91850F3C51110A3C18929207054630123051450783A59B080FA7073E1B12AF403C0200081D4541';
wwv_flow_api.g_varchar2_table(24) := '9A89070E17164490072F112512250C5D0206090A0C512315891D583D325110A5153F40620B161508435B3AA10B5690874335AF3D16E7151C164DD0183F32AF122B33D0860744C3121B4E9C13740A80811C47EEB9783200510A0B282234E850B010021E0B';
wwv_flow_api.g_varchar2_table(25) := '4A30290142482E7E1588D01850D150050B0C3644D84151D1819287045478618507810118606E029960C7120B0410147AB973108216284C6810A180C0A907442C58D9B7B3831162AF4C64480160970231202E0C9404A1C7BD62463A7485B040820B155CC8';
wwv_flow_api.g_varchar2_table(26) := '77127175AF44142A823C24A9C1608AD09D03A28C7B2506492E011D7CBC30509456822A5C42804852A0E001013A111D301004420B283F5A0499D59810020239A2A05060C141CED285826011F10AC60221710F1DE8F0C24B6604163630B9278A0069431D3E';
wwv_flow_api.g_varchar2_table(27) := '2C4042B590012D83EF81B072BC10812D1314A83D946249F45735A6542754E1C28D4C8404BC06CEE5AC0E23A4123DF896FE055041419EF4B051424304DCA53D009113A50850000E5118A1C009CDED24807D0E985281030550F0516902A802DB861C761808';
wwv_flow_api.g_varchar2_table(28) := '0021F904000A0005002C00000000200020000007FF8000828384858687888982070F5F8A8F87182F425314029098075D463D40390398900F502612255B44078307AA900797830F1632A64604AA07142F4415AD88065D5741B0024566200C16150007044A';
wwv_flow_api.g_varchar2_table(29) := '0B113341BE8502095B20491E83080E5310BD002948B4121B421888180D13120B3ED485140A2512122B5ACB87082D113D0AB7125568508A05176502AF58E8F2401102085236D4C04200D6A1030830584CF480C0151E0E1A86CAC4EAC1838D2311210872E5';
wwv_flow_api.g_varchar2_table(30) := 'C40B03840E60A8802025000110A270E9910C26B30A42663411196AC09376A65040108460080A191F408D2480A29EBD1E2706115010018ABE5041A25865028207B7025DA48E4C2104880E1822C93E742814CFD5030F16A244D951A4A6CD410206F818D1A2';
wwv_flow_api.g_varchar2_table(31) := '0B01021550A63C1024C3821E206E307C54B7500A0B1BEC49089164AE401E04FC02005360D7802F05A2C0D02C21C290CA378730C8508619851F0CB8805090A04955D60B9AC0668C640A860315306B9E60E4C28D159A614421A0E8408A86387F6B9691A145';
wwv_flow_api.g_varchar2_table(32) := '95233A2644B8902294001E35584B8081C5C1901D0A924CF90A494093084C58EB9841B342870AE9A41484122E681603082D10F517000F3461840925C000820A9E2D18CB0B1944A1C4051D285648200021F904000A0006002C00000000200020000007FF80';
wwv_flow_api.g_varchar2_table(33) := '0082838485868788898A8B8C02151D29078C938205190A1615948C08161B1A2810929B899D22250B34A3001814140F8C1861B083044946509A821516520A4E298A06575A3C1883081405150282075D0C302E4644CD880446470A418A0F23211212353C08';
wwv_flow_api.g_varchar2_table(34) := '89032A1148038ACF0C2E265145AB86020E1C41D689064E244FC68B0704CC4BF480C2005AA4122AEC368082818100204EAA20244A941F1E563D700041D7A6074E80C090B0018A814103764469223151850C2EC295884265508A133B08B44464E00738092E';
wwv_flow_api.g_varchar2_table(35) := '94786455A11CA9032FA2F41081A2C5314301771A7A00E1470E1E430509A0E063C4150227170910802045058483EAA958C06543942B61D10FA52892A063CB0A487A9408A7C1088D7C842A8C305283418E0E100FD04011AE71881C150E80F1521400020E11';
wwv_flow_api.g_varchar2_table(36) := '4696D86021582104536AC4682C41031607345418C114A402949F127428E900750803D212562C9962C44489125C5410B1D0A3F1840FB40D7978628289CC051632C820BDA00507232E4AC00032222E210443A270991022029421247490166161C01429288C';
wwv_flow_api.g_varchar2_table(37) := '58A09008C3F01939A6B89AB182F4861608604040170444C60E0615A450CE033C2CB0576E52103048400BA560C1161BD4A0C010682D24887D5770D081518A04020021F904000A0007002C00000000200020000007FF800082838485868788898A8B8C0007';
wwv_flow_api.g_varchar2_table(38) := '5F078D92000F043E1D91938B414F2850159A8B4428211F03840F060F8D8F998215164F3C1883152D0D2DA08A021D3E03AE022914B48202430C260C09088A06165B2DC488084E5C121B17AB890F4D3B44CC8907050A112404AE881815DA8A089604EC8507';
wwv_flow_api.g_varchar2_table(39) := '02080207E8BBF6E90E3E565D1402421D7A30044B0420287678C0B7E800060C0101082012658504092544E4D0D5C89D851C3E40A5B0D0E3A2C9084418220A8245C4912D1C100CF8E0C2E4452E1C541A3A3064C145313F0C546860C2A604104D2236246044';
wwv_flow_api.g_varchar2_table(40) := '470910421E3CB812A18449180A16B24A31220A8A0C0EEE75405263020C190CA6486B548148970EE0E0789D50814585051F052A286574CFD0830A054E7CD812050781BD850454E8A037118217518E9480C1454B8769447628C8F00D510A1C476C0299028E';
wwv_flow_api.g_varchar2_table(41) := 'D0010758241F5150406585273A6C8AB05021451002545609F0E1F3E2021EA50955C850F422930D23825C9082E243130C088654C5B8C047F041083830D0C144C2EA262316C0906022CA8B071D546C30B16189D643B6A24460408203019A26B9583080A080';
wwv_flow_api.g_varchar2_table(42) := '85251610709D691510C041130ED8A6446C17F500850100205001058D2D22C08591C0D243772544C0433C024558C0124070C18005148468082F575C10924E840402003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 8126791422119394607 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_file_name => 'default.loading.icon3.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F60000FFFFFF7494B7FBFCFCE8EDF2EAEEF3FCFDFDD9E1EAB9C9DABECDDDDCE4ECF9FAFBF2F4F7BDCCDDB8C8DACAD6E3F0F3F7B0C2D6A0B6CDBACADBEFF3F6F7F8FAB7C7D9CCD7E4D2DCE791AAC693ACC796AEC8ADC0D4EBEFF4';
wwv_flow_api.g_varchar2_table(2) := 'F8F9FBB6C6D9CED9E5FAFBFCE0E7EE94ADC7AEC1D5F3F5F8C9D5E3B5C6D8DBE3ECE6EBF190A9C592ABC6D1DBE7DFE6EEE2E9F0F5F7F9E7ECF28EA8C4D5DFE9DAE2EBCFDAE5F6F8FAAFC1D5C3D0DFE9EEF3EEF2F6BCCBDC7D9BBC7C9ABB87A3C17B99BA8C';
wwv_flow_api.g_varchar2_table(3) := 'A7C3C7D4E2EDF1F5ECF0F5F4F6F8D3DDE8C8D5E2C5D2E0A9BCD2C1CFDEC4D1E09AB1CA9DB3CC9FB5CD98B0CA9CB2CBC2D0DFE3E9F09BB2CB97AFC9E5EAF1DDE4ED9EB4CCC6D3E1829EBE89A4C28FA8C47F9DBD7E9CBCD7E0EAA4B9D0A1B7CECDD8E4B1C3';
wwv_flow_api.g_varchar2_table(4) := 'D6A3B8CFA7BBD1AABDD2A5BAD0A2B7CF86A2C085A1BF84A0BF8AA5C2E1E8EFDEE5EDACBFD4D6DFE9ABBED38BA6C3D0DAE6819EBDA8BCD1839FBEB3C4D7B4C5D7D4DEE888A3C1BBCBDB95ADC8C0CEDE7A99BA00000000000000000000000000000021FE1A';
wwv_flow_api.g_varchar2_table(5) := '43726561746564207769746820616A61786C6F61642E696E666F0021F904000500000021FF0B4E45545343415045322E3003010000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B39363493820F17218305353A3B';
wwv_flow_api.g_varchar2_table(6) := '12990A101822168214223B3D359E900B111918190E00141AAD3F820B3740028E02121A1929183200363C3E28004228D12E8F131B1A2A30A300041C8213D12814901C231A223386422F283892242B31C1861D988F0A141D058DFA8B02060C1224941097A8';
wwv_flow_api.g_varchar2_table(7) := '0090010408221A70A041050F2658282201AE5B220208186844D04211B46816111548E0C0C28713201415C0412088C2440A14A4CCD4CF450744145E3A2AC001C58B698548AC0312E95BB4098240CCC4014EE72202D15E60123AE0E64714401D3DF0494210';
wwv_flow_api.g_varchar2_table(8) := '54144401F80A22EF110505836E440B028BA620A62810BABA2D246082DCB978F3EADDCB7752200021F90400050001002C00000000200020000007FF800082838485868788898A8B8C8D8E870F138F8E172A585B938B0A1156595C0599830B312D831D4C9D';
wwv_flow_api.g_varchar2_table(9) := '510AA100200D494A338214A85A512082A08F24464A4C50B20A54565A5DA00B3740BA8C05474B4D514C530055573C5E004228DB2E8F0B264B501A088252A50013DB281493401E4B4A1786422F2838A1423132CB841D3493203AAC6AC42F510B224590AC18';
wwv_flow_api.g_varchar2_table(10) := '88A800900104D825A2E020A10D2752149150C74111882116425AB8A148DBB68E8A80243020E3890045057010082271918082AC1ABAE8808842CD470582A078D1AD10897A40323D5027A9152E0038D4FD64C461DB8B7F4707F03489A2A8A3A32F480822B0';
wwv_flow_api.g_varchar2_table(11) := '2D290064415E4E1238E8C6B620831570864A874248CE860BBCDEDDCBB7AFDFBF800705020021F90400050002002C00000000200020000007FF800082838485868788898A8B8C8D8E86244E3F148F8D123C650C958B1D4B3C664A209B8342322883344D3C';
wwv_flow_api.g_varchar2_table(12) := '674C0AA3002008606343821D54AB50A2001D952E5F61646017B064AB5C050A123340058E054462635D5D2C003F3E681F0036622D282E8F240C625C1148000221218255532828948F1308D23186402F2838A32E2753CE0C75A0B109C42E4601179190B162';
wwv_flow_api.g_varchar2_table(13) := 'C59483870A001940405E2216432EAC98C141110978283A2A7A72A2E4097E898480149988C200142F9A292A808340108B335F3D73D1EB10059CCF82C00C5788843E209B16809C20C8A0201C20812E120A93A0D101BD54C223EAC8C58017240411808714C0';
wwv_flow_api.g_varchar2_table(14) := '821B4104143C7883ECA0843A13014C8027246EC4055CEDEADDCBB7AFDFBD81000021F90400050003002C00000000200020000007FF800082838485868788898A8B8C8D8E8624550E148F8D08583E47958B0A63586E5D209B8305374183146458684A0AA3';
wwv_flow_api.g_varchar2_table(15) := '822B5F105B821D5CAB11A2000F1D8F05365F1B1B6C002046AB46050A0D6E11388F171E5F6B6D2D000E19186F00485A3D70538F2E3F1E10620E00052D69826D3D654734950B44E52786475844CF9B142169050C090022AF5201018E023202F182C5141408';
wwv_flow_api.g_varchar2_table(16) := '131500328000254538D68550B34011091420392C9A0012A40B45424A8A542400C78D1B131615C04120C84599AF12BAE87588C24D5F4150BC385988C40B1440367D0419B358441C257F322229549ED11BBD529AAC4461C000128208804C0A6081A9888F04';
wwv_flow_api.g_varchar2_table(17) := 'A0BD3196544E42541085BC3D546001D1B978F3EADDCB576F200021F90400050004002C00000000200020000007FF800082838485868788898A8B8C8D8E864216431D8F8D48512245958B0A6B511971209B84200A831D621A1960A6A3000F444E6A829D1A';
wwv_flow_api.g_varchar2_table(18) := '2A63A2000B2E950908070D090020101A1823000A12294A1C8F4F360C0D1E280033505143005572593A3F8F1D174E391E2B0005524F8223DE3A17952EE3392C8636703B61149B1D282F87200CBC11E2AA510183136EDCC0B1A800900104F6297281A2220A';
wwv_flow_api.g_varchar2_table(19) := '1A8A48587436D1E24545423636C4A170C248024124362C68D005A54314543E2A10C41FAF42245EA000B249634593C30408C2615126A309155F60CC798352C88A371D292030808420021579EABA014468A5020705DDC83A282C4B004851103C5BA80089A8';
wwv_flow_api.g_varchar2_table(20) := '6C08E3CA9D4BB7EEA8400021F90400050005002C00000000200020000007FF800082838485868788898A8B8C8D8E862E2B6C0A8F8D25115433958B2026114D23029B891D739F622082202F0F954F6C28820A7411506BA20B5F6E51528E135E3F48690002';
wwv_flow_api.g_varchar2_table(21) := '0D114974000A5F6567724EBE2B16454E04007560116C003F76CE56758E20536F0E365B00052FB1024666727046148F146A6F25BD8547F046249B2041821CA2F0C68290518D405028D08804010213161568D18240874514506844414311898D1C306EE4A8';
wwv_flow_api.g_varchar2_table(22) := '480848460F6EDC88A8A8000E02402E326288B0510117320D5198B7A94010142F5C1822B10EC8A68F1A5982100500C7469E8E1E687CD191E88D8B26350A7D0482C0007F000868340A60C10D204C2BD1047063ECA0B53514014CD07830AEA10224B6DADDCB';
wwv_flow_api.g_varchar2_table(23) := 'B7AFDFBF7D03010021F90400050006002C00000000200020000007FF800082838485868788898A8B8C8D8E860503038F8E6C236D32948B200C6D6307059A890A779E5F2082203243148F24280FA99D5C740200241E296E478E0A6A31179302476D5C1200';
wwv_flow_api.g_varchar2_table(24) := '0A1530687663B68C1D21AB333800322346990E29CC3C3F8F1C2C062B210005379305236E76651BAD8E20042C5B1C864557656B249A05240B87285CF8E04254231038F831224180C0844513C0D8C960609182172832D25084E4CC151F6D508DC2A8511101';
wwv_flow_api.g_varchar2_table(25) := '360958DC60B4E0C68D878A0AE020004481C19B880AB8E88088023C4A0582A07851B010098C4034BDCA0813C4331C1951FC6CF420E38B8D476FF01412B5683C02371412C89814404B20CF800EBA417650289C821126641402171209AF75F3EADDCBB7AFA8';
wwv_flow_api.g_varchar2_table(26) := '400021F90400050007002C00000000200020000007FF800082838485868788898A8B8C8D8E8720028F8E41453F40938C1F155F1F998A023F15100C920002096C1D8F054234820244A3079242775119488F414F213800050E153547052039782A2962A68B';
wwv_flow_api.g_varchar2_table(27) := '022F282D5324002177742D0033B829580E8F402852213782139805741929305FAB8E201CE20B8644293E104299ADAF861D752B5C7C6A0462823E4642081098B0684218371A642C02010D058A7E88F2E8D8984481228A162F2A3AD2A36413108B16DCB8C1';
wwv_flow_api.g_varchar2_table(28) := '50D1030F54A8841808AA59A3022EDE19A240E1538120285E082C44021AA6492442B68C240847C89E8F1E587CF1AAE88D5542420E8547E0063500042C1E5509A480CF4137C40E324B73D0048B070FDB162A4062ABDCBB78F3EADD8B37100021F904000500';
wwv_flow_api.g_varchar2_table(29) := '08002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90870A69210A918B53480C32978905439A3F0582022C321D901D9600021748393602002E47114D258F132F03420005754877B8204E54504C10B28C053728282F14002F3F082F';
wwv_flow_api.g_varchar2_table(30) := '00435D4D4C1A338F40CE280F8224E20512DA7815A88E201CCF2E865E4C781EF090052ED1861D5B75349D8C404CE8C54808010213163D688381099B45020680FB97C8861C2B569480501471A2221B59426A5C64F04642450FC48858F210E0A102149439C2';
wwv_flow_api.g_varchar2_table(31) := 'B7CE10057DF782BC3344E2050A209148803B0942190E70381B3D70F6E25FCF1BA88480B3C78EC00D12820838030A60C10D1CA3228505D0ECE7A0B12E273823E8B2500112540ADBCA9D4BB7AEDDB981000021F90400050009002C00000000200020000007';
wwv_flow_api.g_varchar2_table(32) := 'FF800082838485868788898A8B8C8D8E8F9088240B918C1C433337958A2C170E4383022F6A0A90202082059D251F050034446D631F8F242F03428269174417000225465C5D0DAE8D1C28282F14004075161C0006B25D4BBE8E38C9280F823424824E635D';
wwv_flow_api.g_varchar2_table(33) := '5439A58E20C82F34861764E4EB90052ECC860A275BF09B8A020F4142C689841020306111901A1A5424F992CF908001DA1A1ABA63A7228F2B32121580984C62210466429AB16340910B02370A2A7AB0210A13264E04E83354A083CD47F23A2062314467BC';
wwv_flow_api.g_varchar2_table(34) := '20CA5C182291E04B1BA1B5B4A90421134036290E50407A904C1D005B37740AD196EB110894DF0010480644D0821B3800E21C7483EC20B5FA132624EB3AB350011248EBEADDCBB7AF5FBE81000021F9040005000A002C00000000200020000007FF800082';
wwv_flow_api.g_varchar2_table(35) := '838485868788898A8B8C8D8E8F90882002918C424F2C24958A0469322C83051C409120058337690632821D6F1E262D8F422F3742829D5B5300052B26106B0E8F1C28282F1400422D0613006A15C0625B8F38C5280F820A34820E5F6B46480A8F20C42FDB';
wwv_flow_api.g_varchar2_table(36) := '855B1B7136E78F052EC886202C27F19B8A020B4040F6884204049A29E230874A12266250241230C05ABB433952A4C04211C22944041C2ABAE3A66347088A5C10B82130110E084A94509943E09EA1021D625E64F4AEC321104386D8845420883117861C68';
wwv_flow_api.g_varchar2_table(37) := 'D13206E82312D6044E1294068A1E1D31203D28660E00895A368518C0A387082410233501C88882148005322A947487AA98595E2E14074D28762B6EA102248CDADDCBB7AFDFBF9B02010021F9040005000B002C00000000200020000007FF800082838485';
wwv_flow_api.g_varchar2_table(38) := '868788898A8B8C8D8E8F908805918D1437040A948A1C28281C8420939005A200049D2F820A094417998E3437374282A75203000532473907288F41A814004203282E0052360C0D0D9F8E389D280B8220AF75CC265EA58C209C2FC3856A07740E1D91052E';
wwv_flow_api.g_varchar2_table(39) := 'E185204F21E79A8B02243838EB882E0404138B40076364BA40C095E854271A8A8E3089C2508307450651204C942783458B0F13512070839FA2091EC8800153E1593C42053A7478D5281DBC420262C478E9A840B017C80A31B022C7484E4724A479042140';
wwv_flow_api.g_varchar2_table(40) := '50981D5AACB081F4001542122F6E9C43A203A90348203892A8D5090800050DDC88F1386AD08DAE831E143D096042275A6C0E0B1520F133AEDDBB78F3EAA514080021F9040005000C002C00000000200020000007FF800082838485868788898A8B8C8D8E';
wwv_flow_api.g_varchar2_table(41) := '8F909192840A40400293894028280F9983050583049C1C8205035304901D37374282A42841824F330E0E348F389C2F1D004203031400412B0E45552E8F139C280B820220822C1645477590201C282FC485525579170A91052EDF85023703E59F8905420F';
wwv_flow_api.g_varchar2_table(42) := '0FBF8A140404138B1379356D620D562592854257A21F64BA74891021872282061115694291E21D7B046EE853F4E08E988F3968BDA3A4C05DA373F5D46DD992D2518120DD9615CAC3E3CA86888D4838DB080213002356CED83100E9412F5D245EDCF855C4';
wwv_flow_api.g_varchar2_table(43) := '4A502FDA329288C50908000512B07031656ED08DAA83164C7BD70C05AC91840A909089B6ADDBB77004E3360A040021F9040005000D002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840A40380293893828280F99830505';
wwv_flow_api.g_varchar2_table(44) := '83049C1C83241C14901D37374282A4284182402C062190139C2F1D00420303AA242132756C988E0F9C280B820220821CC533B88F021C282FAA8538751F09D090052EDB863841E19F8805342424C889140404138B0B44071E2648408AB12834147DD8B0A6';
wwv_flow_api.g_varchar2_table(45) := '8D4124FE96054CE460CC98300E6D289277A39E221247BE7C99630387BA420A14A46334AE97210A6F2E987C5420483617868EB8C132E7D52312CB2C820828800B0F343EE82878A42C5B40122FBEB0018084078F2B584E3C0241E0060958283C9029A0E04B';
wwv_flow_api.g_varchar2_table(46) := '99A75E22891274030591AD006878C0A264C0275D17148880E270F55301120B467EDCCBB7AFDFBF9002010021F9040005000E002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928402130B0593893828280B99839883049C1C';
wwv_flow_api.g_varchar2_table(47) := '83142E911D04374282A3284182132F283890139C2F1D0042030314BC9C2D2F900B9C9D820220B2282D6A4090051C282FC085422D5328A18F052ED68642979F8BA71DDC88140404138B422B454E361FAD89AF28348A31070D15151E5B14DDCB97E8C29783';
wwv_flow_api.g_varchar2_table(48) := '0763285277A39D22214424DCB9E30015394220327673B1CB908B156C3A760B42CD22211B19343430D988C431874F4A29E08245059E0322193DC8950F880A3401ABF8C082018F974720569110F442C58E31054078188A61848068835AF8D841069310083E';
wwv_flow_api.g_varchar2_table(49) := '52FCF8F4E28A8E22A6D884FC44E148959C1708E3CA9D4BB72EA4400021F9040005000F002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A3828280B9888049B1C831D1D910A1C044282A0284182132F2F978F';
wwv_flow_api.g_varchar2_table(50) := '0F9B2FA54203031400429BAD900BBF9D000220AFBFAA8F051C282FBC85BE283892052ED08614349E8C0A14C78B140404138B1D532B1F2B528BAC28DB892C554548483FF09FBFF887530CFE0C365C281277A3DCC037486C1061C7AD9000050296B9286588';
wwv_flow_api.g_varchar2_table(51) := '460C190A221508E24C60A11F4D2220D8C788C4AF72025AB802214603142A792836AAE56C5B0E39580C0070204243122A2B1E812070E31205153AE01829004242CF24260A40920A80048CA461A4BAF020228A054F6D92FE1844C100464F138EFC90D9B0AD';
wwv_flow_api.g_varchar2_table(52) := 'DBB77004E3460A040021F90400050010002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A1328280B9888049B1C832020910A1C044282A02841820F2F0334900F9B2F1D0042033714B99B2838900BBF9D0002';
wwv_flow_api.g_varchar2_table(53) := '02829A9BAA8F051C282FBD85429BC191052ED28614B39E8B0220058C14040413DF2F6A092CCC89AC28DD883775431717278BEFF1875216FE16061651E070E39CA20E0666BC8971C95B2101E29AB9C06588860C35A520150802CD85212F63DA54D1D688C4';
wwv_flow_api.g_varchar2_table(54) := 'AF73029E000100E24B042E71AA2878540BDA2C043C44E0FB4025029838311E812070E312053C56CA6C2800228F129F39223A8A280443D236E268DCA1D2E58DA71156789418D421CD94999826D87080D6A1DBB77005E3CA9514080021F90400050011002C';
wwv_flow_api.g_varchar2_table(55) := '00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052442938A0F28280B9888049B1C832005910A1C049700A02841820F2F371D909A282FB34203371400429B280F900BBF9D0002028213BFAA8E051CB6BC85422F283892052E';
wwv_flow_api.g_varchar2_table(56) := 'D1861D349E8C05A58C140404138B0540030340C88AAC28DD890F4F2D6969D6EEBFF1884132FE32AE1451E070C39C22102D4E9C9002C29B217090B0CDDAC6E249C3884150480961E802040F1F263A72B1E9C81C632150183BD0A6069D0F171B697A83C50B';
wwv_flow_api.g_varchar2_table(57) := '00273EF0180030244E9B1173123C02F1420C03011492D88161C25895303F7F4012500C07163B3EDA20A3E0C4489B189816A8C0AA5590828D3123515062C7CD1D8785102EE0A192066EA10724ECEADDCB9750200021F90400050012002C00000000200020';
wwv_flow_api.g_varchar2_table(58) := '000007FF800082838485868788898A8B8C8D8E8F9091928405242E938A0F2828249888049B1C830205910A1C044282A02841820F030420909A282F1D0042033714B99B280B900BBFC100A48213BFAA8F051CB6BD85422F283892052ED0861D349E8CA58D';
wwv_flow_api.g_varchar2_table(59) := '140404138B0540BBD58BAC28DC89C3BFD99FBFED88EF9BF187141C37E48A05412F06A4EB46F05A10018640A0B8811052B322587E1892C1C0C6160590842030B30382B1342F8C39A970E7089B868D6658E901670680221994240060600EC93C2D1EA5C9E0';
wwv_flow_api.g_varchar2_table(60) := '268F800E4B52E0B963CCCB1C0F12D84022F14010092629447C29D5C182893B52303D8D5AE39B801BAE30B9689222830982853C447D8396D082126F0830B69D4BB7AEA0400021F90400050013002C00000000200020000007FF800082838485868788898A';
wwv_flow_api.g_varchar2_table(61) := '8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820F031C02909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BAC48BAB28DC89C2';
wwv_flow_api.g_varchar2_table(62) := '9BB6EABEED8842BEF18A141C37E48A0538043800EB4610480919B20A090882E39BA309497AC829612884831569123AAAB243079C3900043CB92168868D121F5A4032A1234B991500883419C302801A0436887C78F0A88586144E047418136589130005EA';
wwv_flow_api.g_varchar2_table(63) := 'E0240204929074429644A1728014882D3F0C80C014358A920ADF6E79A241C6EB1D8285EE78AD839610890F7508B6B69D4BB7AEA0400021F90400050014002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F';
wwv_flow_api.g_varchar2_table(64) := '2828249888049B1C8305920A1C044282A02841820B374102909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BA9D8BAB28DC89C29B03B28AEBED8842BEF18B141C37E4';
wwv_flow_api.g_varchar2_table(65) := '8A05380870A8D7AD1B0E0727E415227129D20425597858307443068B20DF1A1D8123A74C0500055EB4027062C59629231D799063C6CD10005EB8D47802408A85156CD48078F4040A9E220214ACE962A404C8295E569CD8F9480831002EC2748973849480';
wwv_flow_api.g_varchar2_table(66) := '1709AA617211A74B983C19BBD110E3D546C14247BC1A381BED8201A66C06E3CA9D0B20100021F90400050015002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A0';
wwv_flow_api.g_varchar2_table(67) := '2841820B3740A48F9A282F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28C140404138B0540BAA98BAB28DB8924BE37DE88036A09319D8942EFF1872D614D26B71215C0412008BB451D84ECE34608';
wwv_flow_api.g_varchar2_table(68) := '079121200EB9B814294817336E1C18A215EB11893065AEF89000A000016A0050849082E2C1230721DDA85801E0420D0903000439B192C0230976DCA4C823408189352668A6E429CA919408518ADCA251630D1D8D2581005100C9C538413420AC99438421';
wwv_flow_api.g_varchar2_table(69) := '210A73D67CB160969003B56A0DDA0EA220838500B978F3E60D040021F90400050016002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820B3740A48F9A28';
wwv_flow_api.g_varchar2_table(70) := '2F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28CB937138B0540BA978A42604A3512378A24BE048B24293D3D3B1FE8F18C174C2935D80A15C0412048C0431D5C78E36668828518200EB9380709C8';
wwv_flow_api.g_varchar2_table(71) := '181F2AF215828722D623216D7CA410910700396200800C7BE404C6482875006C9150A5154714A21A81E0922243140705403068E0E484A009D21E3C629041839388142434C8135310058A8D28C838A1C0EA9D060886302404220FD82D63091938E024675A';
wwv_flow_api.g_varchar2_table(72) := '931C07A8BD9D4B976E200021F90400050017002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202';
wwv_flow_api.g_varchar2_table(73) := 'B10013BDBF8E051CB4CA83422F283892052ECF841D349142A88DC68C2B18306B9D890540B9DB8A42183BEF6F8A24BD048B241959597033ECBDA28B439A889883AD50011C0482143CA4C005B851861ECC3000E21085858B70B41101E5822112D2603D1202';
wwv_flow_api.g_varchar2_table(74) := '010F132A555A5D020044D8A32A269570310040CD8F21C384F402E208441B264DBACC28208048911952043D78F1C25B23274D2210A948C346910F2C06755000A9C314355C01742852C48B1A8884047C286201055A42380D2E2458F756D0C3BA78F3D60D04';
wwv_flow_api.g_varchar2_table(75) := '0021F90400050018002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202B10013BDBF8E051CB4CA';
wwv_flow_api.g_varchar2_table(76) := '83422F283892052ECF841D34912EA88DC68C432218239D8905400304D8864278567070178A24BDA28A42516666656FF8F68C627449E2811D251C04821834A48006B85186165C4820E01085858A26CC51C2858D2112D280407251810A99385E04D1502008';
wwv_flow_api.g_varchar2_table(77) := '482F6F8D1C2C211366841A005262A4D925A4D7044720E6D05C13A380802143D45003F0E0C5008C86888469F3A662871943A6DC2305025287102D8C81B83024C1568882580C39310CED2005370A7EBA9D4BB7AE5D4381000021F90400050019002C000000';
wwv_flow_api.g_varchar2_table(78) := '00200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A02841822404400590322D282F1D0042033714B89B28BC8F3910B40B8202B10013BEC08E40505F4FCC83422F283892380EC587';
wwv_flow_api.g_varchar2_table(79) := '1D348F052E2442028DC88A245F1A19221BA88905400304B7895E76763C3C650EE7BEA28933DC0814E84591105FAC1291A0D304CA920697DEE178A56051251211472122C12604394314A4395A70204E8D048648540302890682381BE8D411A400842020BE';
wwv_flow_api.g_varchar2_table(80) := 'DC357A6364C31C094F00047932E0D6C14DDB180990B0E14B8513000AB0A0C512C00379151DCD70CA869C0035B4FE01380649819417C80AA4A1AAB11090272F0D44B6A590B5ADDDBB78F32A0A040021F9040005001A002C00000000200020000007FF8000';
wwv_flow_api.g_varchar2_table(81) := '82838485868788898A8B8C8D8E8F9091928405422E938A0F28282498831D0583049B1C9E00694D3F4282A3284182240440A18F733D29061D0042033714BB9B28BF8F123B3D460F8202B413C1C38E38493B654F86422F283892383F6CB4851D348F053496';
wwv_flow_api.g_varchar2_table(82) := '028DDF892C1B4D4C495F9D8905400304BA88204658FB3030488A2482BDC2B7218341830E1409090644518B0D64C88C61100F51011CB2402C022144883853895C2478926E1085678F48389973A7852112D81A3EA25085CE813C090481D0080047B08F8DD8';
wwv_flow_api.g_varchar2_table(83) := '983880E0C70D003007E85AB869C123220718207109A095CC05F578365293A7889A50056E6C1A08A0404946139289DAA40D24215E040D14B82D6476AEDDBB78F31E0A040021F9040005001B002C00000000200020000007FF800082838485868788898A8B';
wwv_flow_api.g_varchar2_table(84) := '8C8D8E8F9091928405422E938A0F2828249883144283049B1C9E002D4D294582A328418224044005901E593A56060042033714BB9B28BF8F0C705A3B128202B40013C1C38E385470671786422F28389213255BCC851D348F05344234E08AE9886973644B';
wwv_flow_api.g_varchar2_table(85) := '111EA189054003041D89203551511A1A7888282211EC152201749A2854384391906040144931D1A6CD081BF31015C0210BC422102E5C40337588469A1BEB045118E9C885853C3F6E1822912DE223106F8E54F9804210088F0070041BE70885932A5E623C';
wwv_flow_api.g_varchar2_table(86) := '00407340BE879B3A15AD62E1C200569B6C2EB807B49182136C640228706393C1B129190920C461D30292850E2870E0D015AEDDBB78F3EA5D14080021F9040005001C002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405';
wwv_flow_api.g_varchar2_table(87) := '422E938A0F2828249883344283049B1C9E002D50195582A3284182240440059007665665320042033714BB9B28BF8F473C6756398202B40013C1C38E13643C767586422F283892135E32CC851D348F05142E34E08AE988520762617139E389054003040A';
wwv_flow_api.g_varchar2_table(88) := '8902155D5D114B4B2E2822110C88BE3B6312261CA24848414503189830D1C0C13C440570C802B14800051A1D4C29EAF0C2E0210AD01E5188E185CD034324B2997C74E2439D29DB0080E00800C7B3472456D439F1645CCC01211D6EBAE4C8051B19695E02';
wwv_flow_api.g_varchar2_table(89) := '686572C18D200220D9EB04A0C08D4DAF04AD9B1464D30291851404993016ADDBB77005E3CA4514080021F9040005001D002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840F172E93840B13845F4D522498005349782582';
wwv_flow_api.g_varchar2_table(90) := '142A4A521CA1156E576E4400141964284182240440058F4E306E766806004E6D3714004228CCC98E0F6130683C158213BD0013CC28CE8E37D13E1686422F2838920F1F1702871D3490EE14D88BF3892F477310104EEF890540030828482420CF9A366DC4';
wwv_flow_api.g_varchar2_table(91) := '1861A388C43620FE907C99389158A265CC2026E2500501022717BA1D2A8063178845023A5018184A91021C42105110E9084488044F2E1522514EE3A317539EA0D80400C4490038B6D1741942E88B773C077450B64D67A3020350BC0005804046410B6EE0';
wwv_flow_api.g_varchar2_table(92) := 'A8C748C102AB3798E11244761210660B0F5A1A1230E19ADCBB78F3EADD8B29100021F9040005001E002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B45330A938242172184743B3A479902071822168214783B3D2699';
wwv_flow_api.g_varchar2_table(93) := '345C19292A0E00141AAC4482240440058F0C1A1958183200363C5828004228CE148F131B1A2A301282040F8213CE28D08F1C231A223386422F283892242B3102871D34900A141DBF8CF78A421639121225DF101500328000A644431A54F0E0C144024524';
wwv_flow_api.g_varchar2_table(94) := 'BA0151148381458B2CF44954E4828D03071F4E74505400472F108C1428409969910017230F5108F8A80007142F5C1822816E22246ECE260802C11247379A8C08387B218FE78091CD9E410282930436673E17DC5007A9808B83006E380B32285F4BA328AC';
wwv_flow_api.g_varchar2_table(95) := 'B63424E081DAB57007E3CA9D4B576E20003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 8126801419531395841 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_file_name => 'default.loading.icon4.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F50000FFFFFFCC0C0CEDADADE58989DE6767DA5454D84747DA5050DC5D5DE27676E79393EBA4A4E06D6DD63D3DD53B3BD74141D84A4AE27A7AECAAAAEEB1B1E07070D53939EEB3B3D43434DE6363E99999D33030D22C2CE68D8D';
wwv_flow_api.g_varchar2_table(2) := 'E99C9CE48484DC5A5AE48080D12828D22A2AD12626EAA0A0D02020F0BDBDCF1D1DEFB7B7F1C1C1F4D0D0F5D4D4F6D9D9F3CACAF2C6C6F8E3E3FAECECF9E7E7FBF0F0FCF6F6FDFCFCF7DDDDCC0F0FCC0C0CCD151500000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(3) := '000000000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904000700000021FF0B4E45545343415045322E3003010000002C00000000200020000006FF408070489C0C108E4BC9416C3A9F800522743A954A56A8962820';
wwv_flow_api.g_varchar2_table(4) := '6C46D7F009B2DD2E0CA1743A7C2D4333978D7A1D3EB89D0BC7462E5A3F08110A0A7745101A1B1A228A0619845014171A9287118E500B1517911A170396500C15999A959F4E020D150EAA1FA64F03AB0D0E0E8DAE4D04B30D0D76B64D050FC00F09BD4D06';
wwv_flow_api.g_varchar2_table(5) := 'C6060F1CC444C706101DCB43CD10B5D1071007D983D10008D9D91EDC0009DF0504E20A0705EA080BDC0205F10808C3DC1105F31804DBCB12F308FA08B8BB4363CB000CFA18304840C2CD8C825A2C3048B8108402145060C878584602818F092280F0A060';
wwv_flow_api.g_varchar2_table(6) := '8185142A56B060F122068C191C0140C44361A1C8011C32749060C1440B44152C35C2A441548B001021410C1890818449132E80B684F172861B0B196E0AEAB040008A143F59BA84E1082B4E0519163C8DAAF205D94F26042C70BA608209942CCA04010021';
wwv_flow_api.g_varchar2_table(7) := 'F90400070001002C00000000200020000006FF408070489C0C308F4AA9D4782040C4A894B8406842A1A5B674124DBF42014323128DB0A191D6A6004F1710CD6683C6AA9737893BDA7968E41B657677251B7B540F17177F7222060C110A0A110407874213';
wwv_flow_api.g_varchar2_table(8) := '0715158A8B07199760090E9BA41511A1600B0FA40D0E0D1CA960140DB5AE50B253020FBCBC08B95F1C06C3060F1DC0530CC406BFC852080710D2A8CE5107D7D76DD54405D807C7DB4305DD0705E0E10008DD0508DAE804051F080803E84211F2081809F6';
wwv_flow_api.g_varchar2_table(9) := '0019FA08081058604F803E0C023DF4038190008304E7B64910C8804282087AD07160F03002880119B759007131C280010A16A4F83283C6250111629E5490618105172A58BC88016346CB42501264A2ECB06082099C3A61C8F819CA0207940A881A45BAB3';
wwv_flow_api.g_varchar2_table(10) := '27D34B284848222A00458A162B6AF05CDAD26528130BB85A389A53ACD219CE4CA040C17645D23D41000021F90400070002002C00000000200020000006FF408070489C70308F4648F478200613A2743A5C602E1BD126341A95BEA7116241A50A28958B46';
wwv_flow_api.g_varchar2_table(11) := '93E586B8DFD2E94428131787B47A2D12BDDF7127372476421D061589177B1B6D255E5F360885000B060E150E988B1014200A0A11041791941305499A9A0719650A1A0394110F06064D0F2094BA0B10B5BE0ABABA09BEB5B9C185020710CA0675C7850A07';
wwv_flow_api.g_varchar2_table(12) := 'D2D21DCF8509D307CED66504050507051EDC7608DF0508ADE454081F08EF64EB53EF08181884F25218F51804EAF94318F423C00018C0212008106460EC20800C0B134410E010C0040A09247EAA084081C4081E0648A83841E380010A4C540C155241860E';
wwv_flow_api.g_varchar2_table(13) := '2A0F5A38C941418705124CA89089D2E6824409265CA8A81103C68C19346858B390210389051682AA60F102860CA4E44C2C781A552855AB58C9A5B020A1EBD4AA5795CA7361422A0BA24691AA95A7622ADCB473CB04010021F90400070003002C00000000';
wwv_flow_api.g_varchar2_table(14) := '200020000006FF408070489C280806C36693240C26C4A874B820342E588D66191A853488C5742A483C2A0E47762B0AB947A51241301E4A3E8D74BE72D16E446D6E71250F62631D070F060F0D796A7D4B6D5E8325220A53120749498C0E0709200A0A200C';
wwv_flow_api.g_varchar2_table(15) := '0D23707138370F52130806109B06081D630A06832704532007BEB1071E75430927370E9805BECB97C3431E08631107CABE03CED8000205DCDC14D9D8191FDC0861E0CE20E5E5DFE7C30C1818084EEDC304F6F6B5F463F70C0C12FAFBFA3148F00FA09404';
wwv_flow_api.g_varchar2_table(16) := '0813443064900808841140E46B3844814210039A5114B240A1878C26360AB1000223870C0C376618C04141061221455A68F972C1841622012C50D0618104470B265488344182844D14295AB088B1D1844FA02E54B0780143C60C1A34009A9800552A55AB';
wwv_flow_api.g_varchar2_table(17) := '590DBA306122EAD4AA5729AA7061F66BDA8D2C569C058B35678C183066E8AD8B2D080021F90400070004002C00000000200020000006FF408070489C281807C8E50231103813A2743A94300C0D47657BD1784517C4824A15440C86C7A391AD74BD1B9168';
wwv_flow_api.g_varchar2_table(18) := '431090AB98263ADD5E7E452121230F6364240807497B6B0E0D7E71802125251A195412888907064D05091E1919200C0F1A8181931A8543130407059A07181D64191022232393250F76430305B0C20377430922BB93045508081FCF0896C5BFBA93363612';
wwv_flow_api.g_varchar2_table(19) := '421E1818CD081CD3520925273706ACDCDC0411E1530E1A521904F3F3ABED42D952030C040C0CECF7A64560408141026901EF4448C03082BD845312448800024414886424821830E022C629153942F948850347050A7C9124D28183820C1DF2ADAC82B203';
wwv_flow_api.g_varchar2_table(20) := '09092E660E3101F3E60455133AAB905820008509154101985820C18209172A6A24453101450AA82C6204756114EA8A1A3160CCD0D9E2A90A162F60C8984183C64C152DCEA65DEB56278BBB6167B04D0AE0C5DCBD7CC3D2ADCB17805EC00183000021F904';
wwv_flow_api.g_varchar2_table(21) := '00070005002C00000000200020000006FF408070489C28128783A391642826C4A8742849400CD887A3C2BD5C2A98C5743A011592576CA3E17078359A0B4130A6120EE743DAF060BB2F701B220662630B0805894907597D6D6F1A2222211719531204081F';
wwv_flow_api.g_varchar2_table(22) := '8A4908110319191E09068082932317854313140818089A050C1D631907922121232506504303AFB1B11C7543111BBA212525047604D00418B5C6C01B23BBCC8503D1D00AD55109BCCC250800160914090C0C1EE05210E4CC122409F6F612EF5119E42727';
wwv_flow_api.g_varchar2_table(23) := '111C1244880062803E290F4AD8B86183C00010203C802071300A820D04F2018838A0239D8A753A0EE0A00005C83A2415843271728C02051D3A2C60D9524A4C120B24D0AC4984DE0256011676F214824202501329580C1DE24242D0142E542C1D62026954';
wwv_flow_api.g_varchar2_table(24) := '162FA6025061E26A8D1730B4AA50B1022B0C1833A6B250813506DA1934682C656156065CB9535FB89D0157AB90B37CF1FA0510783011C1869706010021F90400070006002C00000000200020000006FF408070480464128882C15028501493A2742A497C';
wwv_flow_api.g_varchar2_table(25) := '0E58C8D2F070381E84C5743A19249BD8C3B65B69572882F1504241203E85B47AF968782B17171062630B0C767678697C7D5E811A1A0E1953020C04041888080420031D190309078E901B1B178443162096979809A9451907171AA6A60651430A09099696';
wwv_flow_api.g_varchar2_table(26) := '0A724311B52221C7044313BDCCB0C2441C1B222223231A840A11DADA1DCF4511C621D508002820E71E20C1DE4507C7232523120B03F5F516ECB225C72525111D0A38285030295F9107FDFA150098A1611C834408242CD1A08345120B4C4024E261A20812';
wwv_flow_api.g_varchar2_table(27) := '18254870B17157C21325444EB060A14549210A4E965889C2440A152FA798B0E9C2C58A459C527ABA50A18205D0222A5A14655123C6D1212C8AD6781103C653A82C5EC0802163C6550031A8769D3183C6D7AD6469A8357B352DDBAF00D2C225A276AEDDBB';
wwv_flow_api.g_varchar2_table(28) := '78F3CA09020021F90400070007002C00000000200020000006FF4080704804744004CCE18041241493A2742A00353F85ECF260E83216D3A965906C220ADB03A46B683C1282F07002621092883C7AB9EE362A0E076061121109097677667B6C0F7F151506';
wwv_flow_api.g_varchar2_table(29) := '1D621186870C7609030A241D1C2005068E8F170F8343289F959620A7451D1F0EB217171A10514324031E03032011937242207FB51B1A0C43260A0ABDBD71C2430A15C6C7830BCCD912D145111A1AC71B1800291DE61D19AEDC42071B2221221B12280BF5';
wwv_flow_api.g_varchar2_table(30) := 'F529EB451922EF2321201604089820C0423E291042281481C0824313285C1C2CC240618811064C6874E142C544221E4A282CB12105C7162A587C945662C488122550AA58C1E2C54A210A60EA4CC9A2C68B4918370184D4298245CD1830600425A0B3C483';
wwv_flow_api.g_varchar2_table(31) := '172F92C29811F4038E1B364E7C403A75C60C1A41014C60A0210180AE34D2862DE255ED5AB65FDF4E892B570AD8BA78F3EADDCBB7EFDB200021F90400070008002C00000000200020000006FF4080704804743C0C02A24020443293A2742A185008188476';
wwv_flow_api.g_varchar2_table(32) := '5938782992E9D4A24850AE4DEDA7EB851820118178681924EE89A412B1F61EDC060F050B731303202011771449591F1F7E069281061D53280A0387898A110A19241D0A200807930F0D0E068445A299031E200361531D08810F0E15150751431319190AC3';
wwv_flow_api.g_varchar2_table(33) := '1CAC73001E060D15BA1514432E0B24A1A216C7440A0FBB171715AC2612E10B0BD6D7441115DCDC04002A2816F002E5E6441F171AF81A122D26FDFD2DF48A64C8B7618307152D5C287411508A010D220A22504191E28A8645186C0811D1008B8F1F6B6024';
wwv_flow_api.g_varchar2_table(34) := '3220448811212EBC5819E3458C9143149C1C3142048C9B38610A9149B3A68C54193364C880A11359099A2534005D3AA3288112504B3CA041956A539D0EA296284063088DAB23159C807AE204082254756A2831762CADA24340E0B8511601DC29096EE030';
wwv_flow_api.g_varchar2_table(35) := '76B74882BE80030B1E4CB8B0E18041000021F90400070009002C00000000200020000006FF40807048042C3891040143617832C5A814605124134D0201C12D7C129269D4441A80225786968B281C0A0590402C34653803332881D562101F1F6F07100861';
wwv_flow_api.g_varchar2_table(36) := '53261D0A8B031E677C6A7F8107941010071D52290B2419190A781E03191D0B0B190318829506060787441612129C9F191353240496ADAD05B8432916160202A6C0740307BD0F0D09432A29262628B22674440A060FCD0E0F0B422A2D2E2ED32ED8451EDC';
wwv_flow_api.g_varchar2_table(37) := '0E150E0C00352B2AF3E4E85108ECEC0D022F352CFF2A58D82B92815D850A1706C458D84FE0C02207105EB8400086C585311E1661504183C7033366C8B008432391011A36A4AC10B2A50C9343146C10B1A1268D9B3442C214A24084CF5D9A4372CED80960';
wwv_flow_api.g_varchar2_table(38) := '4088A3222E10A1411400831023468430D0B4C883A35111548D59026A54105B853C2811B58408584D139C28C1F684D6AD204AAC655B02DC560237E69E201056C880BC272ECCE90B00EF884C84FD2A48CCB8B1639841000021F9040007000A002C00000000';
wwv_flow_api.g_varchar2_table(39) := '200020000006FF40807048044C3A034F2201020D3AC5A814605A6414830128B26410BE20C934EAB22C3A574E12D4FD621008CF642C6CA104920529ADE57A096F1F050462532A26261616027A691E6C095E700805050824522C2D2E2E888B0B0B12121302';
wwv_flow_api.g_varchar2_table(40) := '7B0980700705071F85442B2AB12E29882E530B09081F07BC071873432F2CC3B02D2A74421C95BD06114330312FD2C32CC84319BC1006DB0B4230DFDF3131D6440307DBDB144232333332DFE44504E80F0602EDF8EDF1441DDB0F0F0E06CCA04190E0BE22';
wwv_flow_api.g_varchar2_table(41) := '1F003AA840C0A0101A07892468E0A0E2018811A50CA8B8F041C629192A54B840F2A31405242F68B86032CA00951A343868598441CC0D1A0CD024626083CF550D08760AC920A2E806111E840238104244D30DAE5A260841956AD09D0346380D314243379A';
wwv_flow_api.g_varchar2_table(42) := '094A9418C17504019A0234885D5BA281809D1770B00D0145A88D1362352850BAD446DBAF7C376078CB5748D4C26382000021F9040007000B002C00000000200020000006FF408070480498241D0567C0542C8AD028A0755C74320AC5C013497807022994';
wwv_flow_api.g_varchar2_table(43) := '4545592456ECB69BA010188389585853B55C26333AB90475190404081412622F2C2B2A2A782602122459037E09808208044F5030312F35888B26A1A1284803948108A908854530AE9C2C8A2A521220A8081F05047243333332329B2F2F73420A18A90505';
wwv_flow_api.g_varchar2_table(44) := '0720BDBEBEC130C5431DB807CB05AC34DB34CFD3440ACB07E309423443DDDF450CE30710106144DBEA441DE310060603F4C508F9F90CF8CD89F0CFC0078162383C30F060214229191A3E70D0E061940C0D1A38A850D16291010E425678E0B1480291150E';
wwv_flow_api.g_varchar2_table(45) := '942472E0C2850A1708AC14924183860B37F7CD3CA06183CD540BAC4A461021A2A706992B076C202AC267268F094484602A02A94505064A84D8BAF5413C84081C9418CB758406121E0F9C185B62C4D80B194A32B0C176EC83A71E6DAC5D8BE16B49BD213E';
wwv_flow_api.g_varchar2_table(46) := 'E05D99C1835F2841000021F9040007000C002C00000000200020000006FF4080704804B44C13C922C3EC488AD028E0B572B94C166546C11978400A81341AABAD54579460D15128BC91444261190F61B1176BD5BA66495B0320710914116252333332787A';
wwv_flow_api.g_varchar2_table(47) := '68585A6F8372140C0C0B5234348B782C2A2A7D7E0B0A93090C04A84F519B338D2F520203A6A804081413999C764219A7B5080803B932BB43241818C0C0AA459BC5440AC01F1F0511CFCF09D305DB88D76324D40705070ADEBB0407E90709E67620E91010';
wwv_flow_api.g_varchar2_table(48) := '08ED630AF01007F4521D06FDFDFA5132F8FB07B0088707030B1649F0A0E1830F0A891468E0A0228188BC1C54D0E84018C6021A2B5468D0AD60840B284532C038E082060D2931294CB0A1E6CB0B14140A141122844D4303259FB94940A042899E3D6B5620';
wwv_flow_api.g_varchar2_table(49) := '41EF4189A747438C18E1F342067D254E40953A35840199F42068855A62C4060241CD9D58CB360402B0000D9CB850E1C3005C6382000021F9040007000D002C00000000200020000006FF4080704804BC582A570A65114C2CC5A85408831D57499345B2C8';
wwv_flow_api.g_varchar2_table(50) := '2816D069744686C58ED96D57C11974C262006D3E9359592B9709355974D8032003137143346531352B2D2926027E0A031E201111128572875589487A127F92200909110298873353261DA1A31411705273980B94A30C040398BB0BB704BF97BB851D14BF';
wwv_flow_api.g_varchar2_table(51) := '04081EC29820BF080818A6CA620B1818CE080AD27114D71F11DA62031F1F050504E0530AE407051FE8521D0507EC07EF511DF3F9F6450AF9F3FB44221880301001C021080C283440E120800E0F161AE0E010C1838811A3ED03E1A06383060D017268D0B1';
wwv_flow_api.g_varchar2_table(52) := '8283070B0046A870A1824B0709F66538A0A166CB0A10341642402082024D0511183C10B1A1A6860B17502A7B50A269D310214488D05054C3830CD26E381D01B5EB86A210522A5B60636B881168896A60A07397061C279C3E1DA10181586D123EB82C71A2';
wwv_flow_api.g_varchar2_table(53) := 'C2030483E204010021F9040007000E002C00000000200020000006FF4080704804D0663358ACC652B55CC5A8B47854BE9A2E93C5929A7A8755D855959D481612D3574AABC6C6654927D341AD896DA4B2B672A550130B1D0A840277434832564D7F67190A';
wwv_flow_api.g_varchar2_table(54) := '1C030313875F2E020B8F92110316955F1690032011090A9F5F13A3A4090986A8530BAC09141CB05E1CAD140C0C94B7511209BC040419BF5211C4C420C7510ACA1814CD451D08D60804D34424D7D6DA43D508051F1FDF420A1F050507E5E62007EB07D9E6';
wwv_flow_api.g_varchar2_table(55) := '0407F60709E61D1007FC07A7DF3018300081DFAB6920062ACCA74D8181070A0D2CD016E18145880F22AC11700160940C071C5470E0A0C1830307A7D8C071A20101530A223030A0E1C285912325AE5170A284CF431223468418BA4143CD0A480D74B873E3';
wwv_flow_api.g_varchar2_table(56) := '8453A0418586285AF3E681896B3A387D0A55A8880D456F3248F965C187125C834EFD7A01035654AA10940C31C22282495F82000021F9040007000F002C00000000200020000006FF4080704824D2663318EC552B3A9F4FDA51F962A9AED0ACF3285B5A5D';
wwv_flow_api.g_varchar2_table(57) := 'A6944BAB9526635515D8324991A3C7736DA54A99268B05EAFD9C75635F2628020B1D1D267C5A2C6B12850A197B89592E841D190A0324925A2624979803139B59160A1C031E200AA3591DA820110916AC4F1603B009149AB44E1C11B1091CBC4E1909B909';
wwv_flow_api.g_varchar2_table(58) := '20C34524090CCE0CCA440B0C04D504D1430BD618D7D8001D0818E1DDD80308E708D0DE0C1F1FE711DE2405F3F3ABD8040705F90502E507FFFFE03DB99548010408000B487802E24489046F3C1898781042326236709428F12003940E051E4CA4F8A15F91';
wwv_flow_api.g_varchar2_table(59) := '08366C6C5C698081AA0C20121C70D0E081C88907163C91B06165894F10404508D5A0E142850A0D688A3CD021CB82060E4B8C18113404D1A2472BD02CA0538B000C2BA78ED820620351A3471F2430F966C1870D21A86E987BF6C203025D374D306733C406';
wwv_flow_api.g_varchar2_table(60) := '91043888CA12040021F90400070010002C00000000200020000006FF408070482C0E69B49971C96422673058AC495D3EA5AF5A750B784263B5956AC57526A1B0174BE572B5CACC994C5A5BBB4C28179C99B6A75016137B4D2C6D2616120B82834B2A7813';
wwv_flow_api.g_varchar2_table(61) := '891D268C4B2E02910A0B944B020B1D0AA0289B452619A0030312A3451D1CA8030AAB440B031E202003B24312B711BEBA4212BE09C4C00012C4C9C6240914CE09C60A0C04D411C609D4D41E46168C0B08181804181945170F8C0908EBEB024315372725D0';
wwv_flow_api.g_varchar2_table(62) := '70031F08F708DB422127F2F2B9B8643850A060010CAA84602821AF448911F4A80C384091E0817D42265C683822C40803E596744000A122450C8B867408E13084CB101B0C50009121038804071E183060B2802655230A44381CD151C4060D1A2E3858FA40';
wwv_flow_api.g_varchar2_table(63) := 'E74E08100A9068B2E041C78E308F26ADC074E74E04099B0820202284D10D472F54E05AA141530309DC71F9A60126D20B6AB93A30C0202C9C090330ECC45B928182944B82000021F90400070011002C00000000200020000006FF408070482C1A8FC86492';
wwv_flow_api.g_varchar2_table(64) := 'A66C366933A7B40895C1A6521A14168B6197DA9935567B7D8FE1190CF662B1CE4835BBB652A9E0C7394BE54ADDF1456D7C2E262680467C292616132E87442B8A160212868F438B020B1D129798129B1D1D9E4226241D190A19A40026A90A1C1CAC28B003';
wwv_flow_api.g_varchar2_table(65) := 'B6AC12B61EBB431E07118024201E2011B61A2736250D800311CF090A11272725D60A701209DBDB2412D6E00670200C0C14140916001FD5E0095F0A04F2F203420BE021231BF5521D18F3F23A0921602D84C10DC09A7040C010010604FC840870506284C1';
wwv_flow_api.g_varchar2_table(66) := '10220EAC3AD2814181020D1130985084C4851116436CD070E140020F193238FB70A0E681021F1010105824C3054F8C2236ACBCE0C04183070F0C18B0F9112489240B0C045DC9B2E851A50620D42C7060671301043488BD70A18251A458B7822029650186';
wwv_flow_api.g_varchar2_table(67) := '0A642BC87590542984043CB14CE040A066D19B1414B04512040021F90400070012002C00000000200020000006FF408070482C1A8FC8A472C96C3A9FD0288D368B32A7552B724A9DC1B447AC17160317676818ECC5361365EA578DC57213637296AAB5B2';
wwv_flow_api.g_varchar2_table(68) := '0B632C2B7B2E2D7E42832E262986002A892628288C2A90160212060F0F0606662E0297120B252727252519602E0BAC1D1D22A7A7116028AE19B70EB1250460120ABF0A1905A6A70F60191C03031C1D11A62121A85613CA1ECA0B12232523232110561C20';
wwv_flow_api.g_varchar2_table(69) := 'E2E2160008DCDD22B34F1D0911EF090A420B1BDCD01B1C4E0B141409FE091386108076EFC23A250A082864E04FDE10010F3648DCA0E1C2810E48482440804121010611CA11217141A2868A0E1C148830C0D500100410C8E4B850C2910C0E4E5EB850C141';
wwv_flow_api.g_varchar2_table(70) := '03484D9C0E082DF0E1C34C020B922C80B0B342CF9F9C0C081D6A1401059B4A043070EAD4C1264E10861628806040C0260B083C48F9D540D8A109B04299A0804181039CC826C8701649100021F90400070013002C00000000200020000006FF408070482C';
wwv_flow_api.g_varchar2_table(71) := '1A8FC8A472C96C3A9FD0A8744A55D2AACB2BF648A3CDB6C36B77F60503BADE190C00320CB0E4990C462F9C6CA7CB7B3A87C5622F0E25832504547E802C2C2284257B5231358A2B2A8D250A5435942A2A2E8423251C542C2D2EA6268C23212520542A2929';
wwv_flow_api.g_varchar2_table(72) := '26B20F25AA210C542E162816BD0821B6065413120212121620C02122221952260BD2242428121B22CC1B075224191D19DF2600081B1AE71A1150120AEDED0B420B1A1BE61A15A24D121E03FC1C0A284318CC3B57C141AB251D2280F0C0D0030922020C68';
wwv_flow_api.g_varchar2_table(73) := 'B870C181C50F1D904800912041848F1106002442A2C1850A151A3478F0000188011D3A281840810001060C3A7A147024C3034D940E561A187AE04001044811D82440C1A384240B0E3848F9602884A2469362580A82A71201091E08357015EB510418940E';
wwv_flow_api.g_varchar2_table(74) := 'B0E0640183A106CC1628F0016D5729131424A85B5469840C139404010021F90400070014002C00000000200020000006FF408070482C1A8FC8A472C96C3A9FD0A8744A8552AAC9450907C21A11A793ED34F00A25A55369FD310340EA7549E1A5D10AF252';
wwv_flow_api.g_varchar2_table(75) := '836A07D8670F25232325045433763433331A252121251E878B8B3222838F745332309D9D2198229A523031A62F2F1AA0222292533135A82C2C061B22211B0C542C2BBDBD081BC11A10542A2DC72D2A1EC21A1719522A262E29D42A121AD81A1505522616';
wwv_flow_api.g_varchar2_table(76) := '2628E12A000417CD150E5D4F260B1202131326420B1517E80E0FA34B1619240BFF125C0CA150A14283060F0CB852224181820C193A74984044C00107E8121A40D00189000E1E060C70A8A0833C220B0C384068A0E5010C23FF6550002241041021077050';
wwv_flow_api.g_varchar2_table(77) := '80E2480750031A0D403870A00002041808106090C0E64D100328225950402351A246912A65DA34C2000B4B04247089B5C007AD4A9B265000B6898404570B98459A9440020E02A44CC89040A951060C4074688B24080021F90400070015002C0000000020';
wwv_flow_api.g_varchar2_table(78) := '0020000006FF408070482C1A8FC8A472C96C3A9F4C8506DA5C6C70536A72E228956C59AD91E0F5DE36E2E2A2EC1D29D244446934F226E043C9A6140A952078432021237D256F810008847D06894206222122220C8F001A1B9422038F341BA0A019703434';
wwv_flow_api.g_varchar2_table(79) := '00A51A99A9885A3333A5343315A91A171E69AEB93310B51A15146930C2C30417C60E07692F313130CC031715150E0E1D5A2F2C2C2F2F352F020DD20E0D085A2A2A2BD9DA000C0ED30F06B74F2D2E2E2DE62B420B0F0EEF0610AC4B5C58306122450A17F8';
wwv_flow_api.g_varchar2_table(80) := '8424E867C0C0814E4B50489060C1020A142E880828D00FC28103044820B1402203890513055868A1E640438F1F3F30189061C102121D060CE0A0204387589312321AE9E012E6810F08301020C0204104103A79663069228904041F0B684590942985084F';
wwv_flow_api.g_varchar2_table(81) := '3DEC54D0A1AA120120B46EEDCA34815B10501798652221C107A45C9736751B2183052D13328060C0000101A71C16FC4D12040021F90400070016002C00000000200020000006FF408070482C1A8F48E222C9640A30B8A6B4B8789C4EA5E934B3C19E7013';
wwv_flow_api.g_varchar2_table(82) := '2D73B12999CD51F171F2308FCE06F591F00E85CC09B9913C1AD943037A4618217E85798244121B222122220789451E221A8F22199244081B9D1A719A43061A9E0CA1430E1AAA1781A70017B0171599AEB2150E150AAE000FB70E0EADA70715C40D887A34';
wwv_flow_api.g_varchar2_table(83) := '443404BF0D0F1F8934D200D2030E0D06D91D7A33DDD2343302060FD906187A3030DDDD4214E4D907C1533131E9E932420BD91007FDB4522C58D47841AFDE900806FAF52BA0AB898A162A5608AC118388800F0A0F14409060C91117264CB870A122228B3D';
wwv_flow_api.g_varchar2_table(84) := '05346A44808140820C24044C902061C1020116428E5471D20889570F050A7C40808000030A09407818A020438705122CA03091424512090436B22460344104100398C2843AC18455261340102DDA35E9D2A64E17A070A14502080C2D1924D80B56AC8414';
wwv_flow_api.g_varchar2_table(85) := '7A2C7418F0756FD80E024C3009020021F90400070017002C00000000200020000006FF408070489C0C3CC4A472995C7C4AA71B73CA14104AD85389CA1D2E1ED8B08DD0A5662ED851F87428331797D128140A37106EE5C4109AF74B0619794B0C22222187';
wwv_flow_api.g_varchar2_table(86) := '2209834B0B1A1B86221B038C4B048F1B9011954A12171A8F1A6D9C49039FA01A82A4441817AE1710AB490715150E0E8BB2430FB6B794BA420DB60D0DAAC00D0E0D0F0F0AC04206CBD0BFC00506D6069BCE0CD70678CE0306101007071DCE02E3E4070C95';
wwv_flow_api.g_varchar2_table(87) := '344B09EA0505CD793334EE49120507F21F08E66564CCB0E7EEDE1010FC0A204040801E9518300412C42764028102FE1812002181090B163520C2183843C982850B0930A09080C30201264CA47091A2850A162F448E5C42820006550C2A194400E1814386';
wwv_flow_api.g_varchar2_table(88) := '0E122CA0706113644E18530450004A802588010314745890D4840B15374372B1304065820443B31E7D89C2AB8B1535DC08187036C155A31D482C98B07445250B0B140CE09075AB05135C8200003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 8126802117374396803 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_file_name => 'default.loading.icon5.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A0D0A202A200D0A202A204C6F6164696E672049636F6E2050726F7A65647572656E0D0A202A2056657273696F6E20312E302E300D0A202A200D0A202A2F0D0A0D0A2F2A0D0A202A200D0A202A2043656E74657220506C7567696E3A20687474703A2F';
wwv_flow_api.g_varchar2_table(2) := '2F746573742E6C6561726E696E676A71756572792E636F6D2F63656E7465722E68746D6C0D0A202A204175667275663A20242827236C6F6164696E6749636F6E27292E63656E74657228293B0D0A202A200D0A202A2F0D0A6A51756572792E666E2E6365';
wwv_flow_api.g_varchar2_table(3) := '6E746572203D2066756E6374696F6E286F7074696F6E7329207B0D0A20202020202020202020202076617220706F73203D207B0D0A202020202020202020202020202073546F70203A2066756E6374696F6E2829207B0D0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(4) := '2020202072657475726E2077696E646F772E70616765594F6666736574207C7C20646F63756D656E742E646F63756D656E74456C656D656E7420262620646F63756D656E742E646F63756D656E74456C656D656E742E7363726F6C6C546F70207C7C0964';
wwv_flow_api.g_varchar2_table(5) := '6F63756D656E742E626F64792E7363726F6C6C546F703B0D0A20202020202020202020202020207D2C0D0A202020202020202020202020202077486569676874203A2066756E6374696F6E2829207B0D0A20202020202020202020202020202020726574';
wwv_flow_api.g_varchar2_table(6) := '75726E2077696E646F772E696E6E6572486569676874207C7C20646F63756D656E742E646F63756D656E74456C656D656E7420262620646F63756D656E742E646F63756D656E74456C656D656E742E636C69656E74486569676874207C7C20646F63756D';
wwv_flow_api.g_varchar2_table(7) := '656E742E626F64792E636C69656E744865696768743B0D0A20202020202020202020202020207D0D0A2020202020202020202020207D3B0D0A20202020202020202020202072657475726E20746869732E656163682866756E6374696F6E28696E646578';
wwv_flow_api.g_varchar2_table(8) := '29207B0D0A202020202020202020202020202069662028696E646578203D3D203029207B0D0A20202020202020202020202020202020766172202474686973203D20242874686973293B0D0A2020202020202020202020202020202076617220656C4865';
wwv_flow_api.g_varchar2_table(9) := '69676874203D2024746869732E6F7574657248656967687428293B0D0A2020202020202020202020202020202076617220656C546F70203D20706F732E73546F702829202B2028706F732E774865696768742829202F203229202D2028656C4865696768';
wwv_flow_api.g_varchar2_table(10) := '74202F2032293B0D0A2020202020202020202020202020202024746869732E637373287B0D0A202020202020202020202020202020202020706F736974696F6E3A20276162736F6C757465272C0D0A2020202020202020202020202020202020206D6172';
wwv_flow_api.g_varchar2_table(11) := '67696E3A202730272C0D0A202020202020202020202020202020202020746F703A20656C546F702C0D0A2020202020202020202020202020202020206C6566743A202828242877696E646F77292E77696474682829202D2024746869732E6F7574657257';
wwv_flow_api.g_varchar2_table(12) := '69647468282929202F203229202B20277078270D0A202020202020202020202020202020207D293B0D0A20202020202020202020202020207D0D0A2020202020202020202020207D293B0D0A202020202020202020207D3B0D0A0D0A2F2A0D0A202A200D';
wwv_flow_api.g_varchar2_table(13) := '0A202A204372656174652044796E616D6963204C6F61642049636F6E0D0A202A20496E666F3A2047656E6572696572756E6720766F6E207A77656920456C656D656E74656E2049636F6E20756E642048696E7465726772756E64207A7572204461727374';
wwv_flow_api.g_varchar2_table(14) := '656C6C756E6720646572204C61646570726F7A656475720D0A202A204175667275663A20666E635F73746172744C6F616449636F6E28272E2E2E6C6F6164696E672E2E2E272C2764656661756C74272C33352C33352C382C2723393841414338272C3629';
wwv_flow_api.g_varchar2_table(15) := '3B0D0A202A200D0A202A2F0D0A66756E6374696F6E20666E635F73746172744C6F616449636F6E28765F69636F6E5F746578742C765F69636F6E5F696D6167652C765F69636F6E5F77696474682C765F69636F6E5F6865696768742C765F69636F6E5F6F';
wwv_flow_api.g_varchar2_table(16) := '7061636974792C765F69636F6E5F636F6C6F722C765F6261636B67726F756E645F6F706163697479297B0D0A20202F2F206765742062726F777365722073697A650D0A202076617220765F62726F777365725769647468203D202428646F63756D656E74';
wwv_flow_api.g_varchar2_table(17) := '292E776964746828293B0D0A202076617220765F62726F77736572486569676874203D202428646F63756D656E74292E68656967687428293B0D0A0D0A20202F2F204C6F616420696D6167650D0A202076617220765F6C6F61645F696D616765203D206E';
wwv_flow_api.g_varchar2_table(18) := '657720496D61676528293B0D0A202020202020765F6C6F61645F696D6167652E737263203D20765F69636F6E5F696D6167653B0D0A20200D0A20202F2F20536574206F7061636974790D0A202069662028765F69636F6E5F6F706163697479203D3D2031';
wwv_flow_api.g_varchar2_table(19) := '30297B0D0A20202020765F69636F6E5F6F7061636974795F6965203D2027313030273B0D0A20202020765F69636F6E5F6F7061636974795F6666203D2027312E30273B0D0A20207D20656C7365207B0D0A20202020765F69636F6E5F6F7061636974795F';
wwv_flow_api.g_varchar2_table(20) := '6965203D20765F69636F6E5F6F706163697479202B202730273B0D0A20202020765F69636F6E5F6F7061636974795F6666203D2027302E27202B20765F69636F6E5F6F7061636974793B0D0A20207D0D0A20200D0A202069662028765F6261636B67726F';
wwv_flow_api.g_varchar2_table(21) := '756E645F6F706163697479203D3D203130297B0D0A20202020765F6261636B67726F756E645F6F7061636974795F6965203D2027313030273B0D0A20202020765F6261636B67726F756E645F6F7061636974795F6666203D2027312E30273B0D0A20207D';
wwv_flow_api.g_varchar2_table(22) := '20656C7365207B0D0A20202020765F6261636B67726F756E645F6F7061636974795F6965203D20765F6261636B67726F756E645F6F706163697479202B202730273B0D0A20202020765F6261636B67726F756E645F6F7061636974795F6666203D202730';
wwv_flow_api.g_varchar2_table(23) := '2E27202B20765F6261636B67726F756E645F6F7061636974793B0D0A20207D0D0A20200D0A20202F2F20736574207374796C657320666F7220656C656D656E74730D0A202076617220765F7374796C654C6F6164696E674261636B67726F756E64203D20';
wwv_flow_api.g_varchar2_table(24) := '277374796C653D2277696474683A272B765F62726F7773657257696474682B2770783B272B276865696768743A272B765F62726F777365724865696768742B2770783B706F736974696F6E3A6162736F6C7574653B6C6566743A303B746F703A303B6261';
wwv_flow_api.g_varchar2_table(25) := '636B67726F756E642D636F6C6F723A234646464646463B7A2D696E6465783A20343030303B273B0D0A202076617220765F7374796C654C6F6164696E674261636B67726F756E64203D20765F7374796C654C6F6164696E674261636B67726F756E64202B';
wwv_flow_api.g_varchar2_table(26) := '202766696C7465723A416C706861286F7061636974793D272B765F6261636B67726F756E645F6F7061636974795F69652B27293B2D6D6F7A2D6F7061636974793A272B765F6261636B67726F756E645F6F7061636974795F66662B273B6F706163697479';
wwv_flow_api.g_varchar2_table(27) := '3A272B765F6261636B67726F756E645F6F7061636974795F66662B273B2220273B0D0A202076617220765F7374796C654C6F6164696E6749636F6E203D20277374796C653D2270616464696E673A3570783B20666F6E742D73697A653A313870783B2077';
wwv_flow_api.g_varchar2_table(28) := '696474683A32303070783B20746578742D616C69676E3A63656E7465723B626F726465723A31707820736F6C696420272B765F69636F6E5F636F6C6F722B273B206261636B67726F756E642D636F6C6F723A234646464646463B20636F6C6F723A272B76';
wwv_flow_api.g_varchar2_table(29) := '5F69636F6E5F636F6C6F722B273B273B0D0A202076617220765F7374796C654C6F6164696E6749636F6E203D20765F7374796C654C6F6164696E6749636F6E202B202766696C7465723A416C706861286F7061636974793D272B765F69636F6E5F6F7061';
wwv_flow_api.g_varchar2_table(30) := '636974795F69652B27293B2D6D6F7A2D6F7061636974793A272B765F69636F6E5F6F7061636974795F66662B273B6F7061636974793A272B765F69636F6E5F6F7061636974795F66662B273B7A2D696E6465783A20343030313B2220270D0A2020766172';
wwv_flow_api.g_varchar2_table(31) := '20765F7374796C65496D674C6F616449636F6E203D20277374796C653D226865696768743A272B765F69636F6E5F6865696768742B2770783B77696474683A272B765F69636F6E5F77696474682B2770783B2220273B0D0A0D0A200D0A20202F2F207365';
wwv_flow_api.g_varchar2_table(32) := '7420656C656D656E7420736F757263650D0A202076617220765F6C6F6164696E674261636B67726F756E64203D20273C6469762069643D226C6F6164696E674261636B67726F756E642220272B765F7374796C654C6F6164696E674261636B67726F756E';
wwv_flow_api.g_varchar2_table(33) := '642B273E3C2F6469763E273B0D0A202076617220765F6C6F6164696E6749636F6E203D20273C6469762069643D226C6F6164696E6749636F6E2220272B765F7374796C654C6F6164696E6749636F6E2B273E273B0D0A2020202020202F2F20436865636B';
wwv_flow_api.g_varchar2_table(34) := '2069662049636F6E207465787420697320656D7074790D0A202020202069662028765F69636F6E5F7465787420213D2027656D7074792729207B0D0A20202020202020202020765F6C6F6164696E6749636F6E203D20765F6C6F6164696E6749636F6E20';
wwv_flow_api.g_varchar2_table(35) := '2B20765F69636F6E5F74657874202B20273C6272202F3E273B0D0A20202020207D0D0A2020202020765F6C6F6164696E6749636F6E203D20765F6C6F6164696E6749636F6E202B20273C696D672069643D227761697422207372633D2227202B20765F69';
wwv_flow_api.g_varchar2_table(36) := '636F6E5F696D616765202B2027222027202B20765F7374796C65496D674C6F616449636F6E202B2720616C69676E3D226D6964646C65222F3E3C2F6469763E273B0D0A20200D0A20202F2F2044656275670D0A20202F2F20616C6572742827765F6C6F61';
wwv_flow_api.g_varchar2_table(37) := '64696E674261636B67726F756E643A2027202B20765F6C6F6164696E674261636B67726F756E64293B0D0A20202F2F20616C6572742827765F6C6F6164696E6749636F6E3A2027202B20765F6C6F6164696E6749636F6E293B0D0A0D0A20202F2F206372';
wwv_flow_api.g_varchar2_table(38) := '6561746520656C656D656E74730D0A20202F2F20312E20486964652028446973706C6179204E6F6E65292C20322E20417070656E64546F20426F64792C20332E2046616465496E204566666563740D0A20202428765F6C6F6164696E674261636B67726F';
wwv_flow_api.g_varchar2_table(39) := '756E64292E6869646528292E617070656E64546F28242827626F64792729292E66616465496E2822736C6F7722293B0D0A20202428765F6C6F6164696E6749636F6E292E6869646528292E617070656E64546F28242827626F64792729292E6661646549';
wwv_flow_api.g_varchar2_table(40) := '6E2822736C6F7722293B0D0A0D0A0D0A20202F2F2063656E74657220656C656D656E740D0A2020242827236C6F6164696E6749636F6E27292E63656E74657228293B0D0A7D0D0A0D0A2F2A0D0A202A200D0A202A2052656D6F76652044796E616D696320';
wwv_flow_api.g_varchar2_table(41) := '4C6F61642049636F6E0D0A202A20496E666F3A204CF6736368656E20766F6E2049636F6E20756E642048696E7465726772756E640D0A202A204175667275663A20666E635F73746F704C6F616449636F6E28293B0D0A202A200D0A202A200D0A202A2F0D';
wwv_flow_api.g_varchar2_table(42) := '0A66756E6374696F6E20666E635F73746F704C6F616449636F6E28297B0D0A20202F2F20312E2046616465204F7574204566666563742C20322E2052656D6F766520456C656D656E740D0A2020242822236C6F6164696E674261636B67726F756E642229';
wwv_flow_api.g_varchar2_table(43) := '2E666164654F7574283530302C2066756E6374696F6E2829207B242827236C6F6164696E674261636B67726F756E6427292E72656D6F766528293B7D293B202F2F20226C696E656172222C200D0A2020242822236C6F6164696E6749636F6E22292E6661';
wwv_flow_api.g_varchar2_table(44) := '64654F7574283530302C2066756E6374696F6E2829207B242827236C6F6164696E6749636F6E27292E72656D6F766528293B7D293B0D0A7D0D0A';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 8126965209980476218 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 8141067932620514550 + wwv_flow_api.g_id_offset
 ,p_file_name => 'loading.icon.js'
 ,p_mime_type => 'application/x-unknown'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

--application/shared_components/plugins/dynamic_action/com_skillbuilders_modal_page
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'DYNAMIC ACTION'
 ,p_name => 'COM_SKILLBUILDERS_MODAL_PAGE'
 ,p_display_name => 'SkillBuilders Modal Page (2.0.0)'
 ,p_category => 'EFFECT'
 ,p_supported_ui_types => 'DESKTOP'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'FUNCTION apex_modal_page_render ('||unistr('\000a')||
'   p_dynamic_action IN APEX_PLUGIN.T_DYNAMIC_ACTION,'||unistr('\000a')||
'   p_plugin         IN APEX_PLUGIN.T_PLUGIN '||unistr('\000a')||
')'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN APEX_PLUGIN.T_DYNAMIC_ACTION_RENDER_RESULT'||unistr('\000a')||
'   '||unistr('\000a')||
'IS'||unistr('\000a')||
''||unistr('\000a')||
'   l_result             APEX_PLUGIN.T_DYNAMIC_ACTION_RENDER_RESULT;'||unistr('\000a')||
'   l_dialog_title       VARCHAR2(4000) := p_dynamic_action.attribute_01;'||unistr('\000a')||
'   l_url_location       VARCHAR2(50) := NVL(p_dynamic_action.at'||
'tribute_02, ''STATIC'');'||unistr('\000a')||
'   l_static_url         VARCHAR2(4000) := p_dynamic_action.attribute_03;'||unistr('\000a')||
'   l_attr_name          VARCHAR2(4000) := NVL(p_dynamic_action.attribute_05, ''data-url'');'||unistr('\000a')||
'   l_close_sel          VARCHAR2(4000) := NVL(p_dynamic_action.attribute_06, ''div#success-message'');'||unistr('\000a')||
'   l_hw_mode            VARCHAR2(4000) := NVL(p_dynamic_action.attribute_07, ''AUTO'');'||unistr('\000a')||
'   l_height             VAR'||
'CHAR2(4000) := p_dynamic_action.attribute_08;'||unistr('\000a')||
'   l_width              VARCHAR2(4000) := p_dynamic_action.attribute_09;'||unistr('\000a')||
'   l_modal_page_id      VARCHAR2(4000) := p_dynamic_action.attribute_10;'||unistr('\000a')||
'   l_theme              NUMBER := NVL(p_plugin.attribute_01, 3);'||unistr('\000a')||
'   l_overlay_opacity    NUMBER := NVL(TO_NUMBER(p_plugin.attribute_02, ''999.99'', ''NLS_NUMERIC_CHARACTERS = ''''.,''''''), .5);'||unistr('\000a')||
'   l_scrolling       '||
'   VARCHAR2(1) := NVL(p_plugin.attribute_03, ''N'');'||unistr('\000a')||
'   l_transition         VARCHAR2(50) := NVL(p_plugin.attribute_04, ''none'');'||unistr('\000a')||
'   l_initial_height     NUMBER := NVL(p_plugin.attribute_05, 100);'||unistr('\000a')||
'   l_initial_width      NUMBER := NVL(p_plugin.attribute_06, 100);'||unistr('\000a')||
'   l_draggable          VARCHAR2(1) := NVL(p_plugin.attribute_07, ''Y'');'||unistr('\000a')||
'   l_custom_css_path    VARCHAR2(4000) := p_plugin.attribute_08;'||unistr('\000a')||
'  '||
' l_custom_css_file    VARCHAR2(4000) := p_plugin.attribute_09;'||unistr('\000a')||
'   l_loading_image_src  VARCHAR2(32767);'||unistr('\000a')||
'   l_onload_code        VARCHAR2(32767);'||unistr('\000a')||
'   l_crlf               CHAR(2) := CHR(13)||CHR(10);'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF apex_application.g_debug'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      apex_plugin_util.debug_dynamic_action('||unistr('\000a')||
'         p_plugin         => p_plugin,'||unistr('\000a')||
'         p_dynamic_action => p_dynamic_action '||unistr('\000a')||
'      );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
''||
'   IF l_theme = 6 --User selected custom theme'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      apex_css.add_file('||unistr('\000a')||
'         p_name      => RTRIM(RTRIM(l_custom_css_file,''.css''),''.CSS''),'||unistr('\000a')||
'         p_directory => wwv_flow.do_substitutions(l_custom_css_path),'||unistr('\000a')||
'         p_version   => NULL'||unistr('\000a')||
'      );'||unistr('\000a')||
'   ELSE '||unistr('\000a')||
'      apex_css.add_file('||unistr('\000a')||
'         p_name      => ''t'' || l_theme || ''colorbox'','||unistr('\000a')||
'         p_directory => p_plugin.file_prefix,'||unistr('\000a')||
'       '||
'  p_version   => NULL'||unistr('\000a')||
'      );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   apex_javascript.add_library('||unistr('\000a')||
'      p_name      => ''jquery.colorbox-min'','||unistr('\000a')||
'      p_directory => p_plugin.file_prefix,'||unistr('\000a')||
'      p_version   => NULL'||unistr('\000a')||
'   );'||unistr('\000a')||
'   '||unistr('\000a')||
'   apex_javascript.add_library('||unistr('\000a')||
'      p_name      => ''apex_modal_page.min'','||unistr('\000a')||
'      p_directory => p_plugin.file_prefix,'||unistr('\000a')||
'      p_version   => NULL '||unistr('\000a')||
'   );'||unistr('\000a')||
''||unistr('\000a')||
'   l_onload_code := ''apex.jQuery(document).apex_m'||
'odal_page({'' || l_crlf'||unistr('\000a')||
'      || ''   '' || apex_javascript.add_attribute(''transition'',  l_transition) || l_crlf'||unistr('\000a')||
'      || ''   '' || apex_javascript.add_attribute(''draggable'',  '||unistr('\000a')||
'         CASE l_draggable'||unistr('\000a')||
'            WHEN ''Y'' THEN TRUE'||unistr('\000a')||
'            ELSE FALSE'||unistr('\000a')||
'         END'||unistr('\000a')||
'      ) || l_crlf'||unistr('\000a')||
'      || ''   '' || apex_javascript.add_attribute(''initialHeight'',  l_initial_height) || l_crlf'||unistr('\000a')||
'      || ''   '' || apex'||
'_javascript.add_attribute(''initialWidth'',  l_initial_width) || l_crlf'||unistr('\000a')||
'      || ''   '' || apex_javascript.add_attribute(''overlayOpacity'',  l_overlay_opacity) || l_crlf'||unistr('\000a')||
'      || ''   '' || apex_javascript.add_attribute(''scrolling'',  '||unistr('\000a')||
'         CASE l_scrolling'||unistr('\000a')||
'            WHEN ''Y'' THEN TRUE'||unistr('\000a')||
'            ELSE FALSE'||unistr('\000a')||
'         END'||unistr('\000a')||
'      ) || l_crlf'||unistr('\000a')||
'      || ''   '' || apex_javascript.add_attribute(''loadingImag'||
'eSrc'', l_loading_image_src, FALSE, FALSE) || l_crlf'||unistr('\000a')||
'      || ''});'';'||unistr('\000a')||
'      '||unistr('\000a')||
'   apex_javascript.add_onload_code('||unistr('\000a')||
'      p_code => l_onload_code'||unistr('\000a')||
'   ); '||unistr('\000a')||
''||unistr('\000a')||
'   l_result.javascript_function := '||unistr('\000a')||
'      ''function(){'' || l_crlf ||'||unistr('\000a')||
'      ''   if (this.browserEvent !== ''''load''''){'' || l_crlf ||'||unistr('\000a')||
'      ''      apex.jQuery(document).apex_modal_page(''''openPageFromApexThis'''', this);'' || l_crlf ||'||unistr('\000a')||
'      ''   }'' || l_crlf '||
'||'||unistr('\000a')||
'      ''}'';'||unistr('\000a')||
''||unistr('\000a')||
'   l_result.attribute_01 := l_dialog_title;'||unistr('\000a')||
'   l_result.attribute_02 := l_url_location;'||unistr('\000a')||
'   l_result.attribute_03 := l_static_url;'||unistr('\000a')||
'   l_result.attribute_05 := l_attr_name;'||unistr('\000a')||
'   l_result.attribute_06 := l_close_sel;'||unistr('\000a')||
'   l_result.attribute_07 := l_hw_mode;'||unistr('\000a')||
'   l_result.attribute_08 := l_height;'||unistr('\000a')||
'   l_result.attribute_09 := l_width;'||unistr('\000a')||
'   l_result.attribute_10 := l_modal_page_id;'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN l_r'||
'esult;'||unistr('\000a')||
'    '||unistr('\000a')||
'END apex_modal_page_render;'
 ,p_render_function => 'apex_modal_page_render'
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_help_text => '<br />'||unistr('\000a')||
''
 ,p_version_identifier => '2.0.0'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7736037914841082 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Theme'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => '3'
 ,p_is_translatable => false
 ,p_help_text => 'The Theme setting is used to change the look and feel of the modal window. The ColorBox website includes 5 example themes which have been included with this plug-in. Simply select a number from 1 to 5 to use one of these themes. The themes demonstrate the flexibility of the plug-in and can be used without making any changes. However, a custom option exists that, when selected, exposes two additional fields that allow for a custom CSS file to be defined. It is recommended that you start with an existing theme and make small changes to it until you are comfortable working with the CSS.'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7736539992841715 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7736037914841082 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => '1'
 ,p_return_value => '1'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7736941724842178 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7736037914841082 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => '2'
 ,p_return_value => '2'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7737343801842760 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7736037914841082 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => '3'
 ,p_return_value => '3'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7737745533843265 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7736037914841082 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 40
 ,p_display_value => '4'
 ,p_return_value => '4'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7738147957843934 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7736037914841082 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 50
 ,p_display_value => '5'
 ,p_return_value => '5'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7738517267844562 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7736037914841082 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 60
 ,p_display_value => 'Custom'
 ,p_return_value => '6'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7739316275872324 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'Overlay Opacity'
 ,p_attribute_type => 'NUMBER'
 ,p_is_required => true
 ,p_default_value => '.5'
 ,p_display_length => 3
 ,p_max_length => 3
 ,p_is_translatable => false
 ,p_help_text => 'The Overlay Opacity setting is used to adjust the darkness of the overlay behind the modal dialog. Specify a number between 0 and 1 where 0 is transparent and 1 is completely obscured. The default value of .5 is in the middle and allows the users to see the screen behind but focuses their attention on the modal dialog.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7739819654892183 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 17
 ,p_prompt => 'Scrolling'
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
 ,p_help_text => 'The Scrolling setting is used to specify whether or not the modal can include scroll bars across the top and bottom of the modal to allow users to see all of the content in the page. When set to No, any overflow cotent will be hidden from view.<br /> '||unistr('\000a')||
'<br />'||unistr('\000a')||
'This setting must be used in conjunction with the Height and Width settings in the component settings. A later version of this plug-in will move this setting to the component settings.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7740341471898391 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 15
 ,p_prompt => 'Transition'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'none'
 ,p_is_translatable => false
 ,p_help_text => 'The Transition setting can be used to apply some effects to the opening and closing of the modal dialog. '
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7740844934899403 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7740341471898391 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'None'
 ,p_return_value => 'none'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7741218184910514 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7740341471898391 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Elastic'
 ,p_return_value => 'elastic'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7741623032911945 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7740341471898391 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => 'Fade'
 ,p_return_value => 'fade'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 10303556518079792842 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Initial Height'
 ,p_attribute_type => 'INTEGER'
 ,p_is_required => true
 ,p_default_value => '100'
 ,p_display_length => 2
 ,p_max_length => 3
 ,p_is_translatable => false
 ,p_help_text => 'The Initial Height setting is used to specify the initial height (in pixels) of the modal page when it opens but before the main content loads. '
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 10303557700548797267 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 6
 ,p_display_sequence => 60
 ,p_prompt => 'Initial Width'
 ,p_attribute_type => 'INTEGER'
 ,p_is_required => true
 ,p_default_value => '300'
 ,p_display_length => 2
 ,p_max_length => 3
 ,p_is_translatable => false
 ,p_help_text => 'The Initial Width setting is used to specify the initial width (in pixels) of the modal page when it opens but before the main content loads.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7743243595927266 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 7
 ,p_display_sequence => 18
 ,p_prompt => 'Draggable'
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
 ,p_help_text => 'The Draggable setting is used to specify whether or not the user should be able to move the modal dialog around on the screen.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7744128620941736 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 8
 ,p_display_sequence => 12
 ,p_prompt => 'Custom CSS Path'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_display_length => 50
 ,p_max_length => 500
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 7736037914841082 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => '6'
 ,p_help_text => 'The Custom CSS Path setting is used to specify the path to a custom CSS file for the theme. This setting is only displayed when the Theme is set to custom. See Optional Performance Upgrade for additional information.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7744637409953715 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 9
 ,p_display_sequence => 13
 ,p_prompt => 'Custom CSS Filename'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_display_length => 50
 ,p_max_length => 500
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 7736037914841082 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => '6'
 ,p_help_text => 'The Custom CSS Filename setting is used to specify the name of the file that contains custom CSS for the theme. Only the name of the file should be included with this setting as it is assumed the extension will be â.cssâ. This setting is only displayed when the Theme is set to custom.  See Optional Performance Upgrade for additional information.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 27700607510937563829 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Dialog Title'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_display_length => 30
 ,p_max_length => 50
 ,p_is_translatable => false
 ,p_help_text => 'Use this attribute to specify the title displayed in the modal page.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 27700600321757548019 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'URL Location'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'STATIC'
 ,p_is_translatable => false
 ,p_help_text => 'Use this attribute to specify whether the URL for the modal page is static or dynamic. '
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 27700602603880552259 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 27700600321757548019 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Statically Defined'
 ,p_return_value => 'STATIC'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 27700603716347555880 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 27700600321757548019 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Attribute of Triggering Element'
 ,p_return_value => 'TRIG_ELEMENT_ATTR'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 27700594601325542086 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Static URL'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_default_value => 'f?p=&APP_ID.:1:&APP_SESSION.:::1:::'
 ,p_display_length => 50
 ,p_max_length => 500
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 27700600321757548019 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'STATIC'
 ,p_help_text => 'Use this attribute to specify a static URL for the modal page.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 35765303137464042364 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Attribute Name'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_default_value => 'href'
 ,p_display_length => 30
 ,p_max_length => 50
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 27700600321757548019 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'TRIG_ELEMENT_ATTR'
 ,p_help_text => 'Use this attribute to specify which attribute of the triggering element contains the URL for the modal page. This is often the href attribute of anchor elements.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 35765433135929231134 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 6
 ,p_display_sequence => 60
 ,p_prompt => 'Auto-close On Element Selector'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_default_value => 'div#success-message'
 ,p_display_length => 30
 ,p_max_length => 500
 ,p_is_translatable => false
 ,p_help_text => 'Use this attribute to specify a jQuery selector used to close the modal page automatically. The selector is executed when the modal page is loaded. If the selector selects anything, the modal page will close and the Auto Close event will be triggered. Typically this is only used for modal pages that are submitted for processing where the success message is used to auto-close the modal page.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 13097173620226222792 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 7
 ,p_display_sequence => 70
 ,p_prompt => 'Dialog Height/Width Mode'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'AUTO'
 ,p_is_translatable => false
 ,p_help_text => 'Use this attribute to control the size of the modal page. The default value of "Auto" will try to automatically determine the appropriate size of the page based on the content. However, if you need more control, this attribute allows you set the height and width as a percentage of the total window size or by a fixed number of pixels.'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 13097212209275229084 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 13097173620226222792 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 1
 ,p_display_value => 'Auto'
 ,p_return_value => 'AUTO'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 13097175425074224181 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 13097173620226222792 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Static by percent of window'
 ,p_return_value => 'STATIC_%'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 13097175994730224841 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 13097173620226222792 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Static by pixels'
 ,p_return_value => 'STATIC_PX'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 13097395496817301123 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 8
 ,p_display_sequence => 80
 ,p_prompt => 'Height'
 ,p_attribute_type => 'INTEGER'
 ,p_is_required => true
 ,p_display_length => 2
 ,p_max_length => 3
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 13097173620226222792 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'IN_LIST'
 ,p_depending_on_expression => 'STATIC_%,STATIC_PX'
 ,p_help_text => 'Use this attribute to set the height of the modal page. This value can be used to specify a percentage of the total screen or specific number of pixels which is determined by the Dialog Height/Width Mode attribute.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 13097397809977304935 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 9
 ,p_display_sequence => 90
 ,p_prompt => 'Width'
 ,p_attribute_type => 'INTEGER'
 ,p_is_required => true
 ,p_display_length => 2
 ,p_max_length => 3
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 13097173620226222792 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'IN_LIST'
 ,p_depending_on_expression => 'STATIC_%,STATIC_PX'
 ,p_help_text => 'Use this attribute to set the width of the modal page. This value can be used to specify a percentage of the total screen or specific number of pixels which is determined by the Dialog Height/Width Mode attribute.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 13097439501151340209 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 10
 ,p_display_sequence => 100
 ,p_prompt => 'Modal Page ID'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_display_length => 30
 ,p_max_length => 50
 ,p_is_translatable => false
 ,p_help_text => 'Use this attribute to associate an identifier, such as "create-customer-page", with the modal page that has been opened. When the modal page closes this identifier will be passed back with the event object so that the closing of one modal page can be differentiated from another. The value can be accessed from the data object of "this" in a Dynamic Action with: this.data.modalPageId'
  );
wwv_flow_api.create_plugin_event (
  p_id => 35702842021901579302 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_name => 'modalpageautoclose'
 ,p_display_name => 'Auto Close'
  );
wwv_flow_api.create_plugin_event (
  p_id => 10303125106952411236 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_name => 'modalpageclose'
 ,p_display_name => 'Close'
  );
wwv_flow_api.create_plugin_event (
  p_id => 7775616443489297 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_name => 'modalpageendopen'
 ,p_display_name => 'End Open'
  );
wwv_flow_api.create_plugin_event (
  p_id => 7776021638490828 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_name => 'modalpagemanualclose'
 ,p_display_name => 'Manual Close'
  );
wwv_flow_api.create_plugin_event (
  p_id => 7776327178492428 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_name => 'modalpagestartopen'
 ,p_display_name => 'Start Open'
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A0D0A20202020436F6C6F72426F7820436F7265205374796C653A0D0A2020202054686520666F6C6C6F77696E672043535320697320636F6E73697374656E74206265747765656E206578616D706C65207468656D657320616E642073686F756C6420';
wwv_flow_api.g_varchar2_table(2) := '6E6F7420626520616C74657265642E0D0A2A2F0D0A23636F6C6F72626F782C202363626F784F7665726C61792C202363626F78577261707065727B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B207A2D696E646578';
wwv_flow_api.g_varchar2_table(3) := '3A393939393B206F766572666C6F773A68696464656E3B7D0D0A2363626F784F7665726C61797B706F736974696F6E3A66697865643B2077696474683A313030253B206865696768743A313030253B7D0D0A2363626F784D6964646C654C6566742C2023';
wwv_flow_api.g_varchar2_table(4) := '63626F78426F74746F6D4C6566747B636C6561723A6C6566743B7D0D0A2363626F78436F6E74656E747B706F736974696F6E3A72656C61746976653B7D0D0A2363626F784C6F61646564436F6E74656E747B6F766572666C6F773A6175746F3B7D0D0A23';
wwv_flow_api.g_varchar2_table(5) := '63626F785469746C657B6D617267696E3A303B7D0D0A2363626F784C6F6164696E674F7665726C61792C202363626F784C6F6164696E67477261706869637B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B20776964';
wwv_flow_api.g_varchar2_table(6) := '74683A313030253B206865696768743A313030253B7D0D0A2363626F7850726576696F75732C202363626F784E6578742C202363626F78436C6F73652C202363626F78536C69646573686F777B637572736F723A706F696E7465723B7D0D0A2E63626F78';
wwv_flow_api.g_varchar2_table(7) := '50686F746F7B666C6F61743A6C6566743B206D617267696E3A6175746F3B20626F726465723A303B20646973706C61793A626C6F636B3B7D0D0A2E63626F78496672616D657B77696474683A313030253B206865696768743A313030253B20646973706C';
wwv_flow_api.g_varchar2_table(8) := '61793A626C6F636B3B20626F726465723A303B7D0D0A0D0A2F2A200D0A2020202055736572205374796C653A0D0A202020204368616E67652074686520666F6C6C6F77696E67207374796C657320746F206D6F646966792074686520617070656172616E';
wwv_flow_api.g_varchar2_table(9) := '6365206F6620436F6C6F72426F782E202054686579206172650D0A202020206F72646572656420262074616262656420696E206120776179207468617420726570726573656E747320746865206E657374696E67206F66207468652067656E6572617465';
wwv_flow_api.g_varchar2_table(10) := '642048544D4C2E0D0A2A2F0D0A2363626F784F7665726C61797B6261636B67726F756E643A75726C2823504C5547494E5F5052454649582374316F7665726C61792E706E672920726570656174203020303B7D0D0A23636F6C6F72626F787B7D0D0A2020';
wwv_flow_api.g_varchar2_table(11) := '20202363626F78546F704C6566747B77696474683A323170783B206865696768743A323170783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237431636F6E74726F6C732E706E6729206E6F2D726570656174202D313031';
wwv_flow_api.g_varchar2_table(12) := '707820303B7D0D0A202020202363626F78546F7052696768747B77696474683A323170783B206865696768743A323170783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237431636F6E74726F6C732E706E6729206E6F2D';
wwv_flow_api.g_varchar2_table(13) := '726570656174202D313330707820303B7D0D0A202020202363626F78426F74746F6D4C6566747B77696474683A323170783B206865696768743A323170783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237431636F6E74';
wwv_flow_api.g_varchar2_table(14) := '726F6C732E706E6729206E6F2D726570656174202D3130317078202D323970783B7D0D0A202020202363626F78426F74746F6D52696768747B77696474683A323170783B206865696768743A323170783B206261636B67726F756E643A75726C2823504C';
wwv_flow_api.g_varchar2_table(15) := '5547494E5F505245464958237431636F6E74726F6C732E706E6729206E6F2D726570656174202D3133307078202D323970783B7D0D0A202020202363626F784D6964646C654C6566747B77696474683A323170783B206261636B67726F756E643A75726C';
wwv_flow_api.g_varchar2_table(16) := '2823504C5547494E5F505245464958237431636F6E74726F6C732E706E6729206C65667420746F70207265706561742D793B7D0D0A202020202363626F784D6964646C6552696768747B77696474683A323170783B206261636B67726F756E643A75726C';
wwv_flow_api.g_varchar2_table(17) := '2823504C5547494E5F505245464958237431636F6E74726F6C732E706E672920726967687420746F70207265706561742D793B7D0D0A202020202363626F78546F7043656E7465727B6865696768743A323170783B206261636B67726F756E643A75726C';
wwv_flow_api.g_varchar2_table(18) := '2823504C5547494E5F505245464958237431626F726465722E706E672920302030207265706561742D783B7D0D0A202020202363626F78426F74746F6D43656E7465727B6865696768743A323170783B206261636B67726F756E643A75726C2823504C55';
wwv_flow_api.g_varchar2_table(19) := '47494E5F505245464958237431626F726465722E706E67292030202D32397078207265706561742D783B7D0D0A202020202363626F78436F6E74656E747B6261636B67726F756E643A236666663B206F766572666C6F773A68696464656E3B7D0D0A2020';
wwv_flow_api.g_varchar2_table(20) := '2020202020202E63626F78496672616D657B6261636B67726F756E643A236666663B7D0D0A20202020202020202363626F784572726F727B70616464696E673A353070783B20626F726465723A31707820736F6C696420236363633B7D0D0A2020202020';
wwv_flow_api.g_varchar2_table(21) := '2020202363626F784C6F61646564436F6E74656E747B6D617267696E2D626F74746F6D3A323870783B7D0D0A20202020202020202363626F785469746C657B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A3470783B206C6566743A30';
wwv_flow_api.g_varchar2_table(22) := '3B20746578742D616C69676E3A63656E7465723B2077696474683A313030253B20636F6C6F723A233934393439343B7D0D0A20202020202020202363626F7843757272656E747B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A347078';
wwv_flow_api.g_varchar2_table(23) := '3B206C6566743A353870783B20636F6C6F723A233934393439343B7D0D0A20202020202020202363626F78536C69646573686F777B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A3470783B2072696768743A333070783B20636F6C6F';
wwv_flow_api.g_varchar2_table(24) := '723A233030393265663B7D0D0A20202020202020202363626F7850726576696F75737B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A303B206C6566743A303B206261636B67726F756E643A75726C2823504C5547494E5F5052454649';
wwv_flow_api.g_varchar2_table(25) := '58237431636F6E74726F6C732E706E6729206E6F2D726570656174202D3735707820303B2077696474683A323570783B206865696768743A323570783B20746578742D696E64656E743A2D3939393970783B7D0D0A20202020202020202363626F785072';
wwv_flow_api.g_varchar2_table(26) := '6576696F75733A686F7665727B6261636B67726F756E642D706F736974696F6E3A2D37357078202D323570783B7D0D0A20202020202020202363626F784E6578747B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A303B206C6566743A';
wwv_flow_api.g_varchar2_table(27) := '323770783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237431636F6E74726F6C732E706E6729206E6F2D726570656174202D3530707820303B2077696474683A323570783B206865696768743A323570783B2074657874';
wwv_flow_api.g_varchar2_table(28) := '2D696E64656E743A2D3939393970783B7D0D0A20202020202020202363626F784E6578743A686F7665727B6261636B67726F756E642D706F736974696F6E3A2D35307078202D323570783B7D0D0A20202020202020202363626F784C6F6164696E674F76';
wwv_flow_api.g_varchar2_table(29) := '65726C61797B6261636B67726F756E643A75726C2823504C5547494E5F5052454649582374316C6F6164696E675F6261636B67726F756E642E706E6729206E6F2D7265706561742063656E7465722063656E7465723B7D0D0A2020202020202020236362';
wwv_flow_api.g_varchar2_table(30) := '6F784C6F6164696E67477261706869637B6261636B67726F756E643A75726C2823504C5547494E5F5052454649582374316C6F6164696E672E67696629206E6F2D7265706561742063656E7465722063656E7465723B7D0D0A2020202020202020236362';
wwv_flow_api.g_varchar2_table(31) := '6F78436C6F73657B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A303B2072696768743A303B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237431636F6E74726F6C732E706E6729206E6F2D7265706561';
wwv_flow_api.g_varchar2_table(32) := '74202D3235707820303B2077696474683A323570783B206865696768743A323570783B20746578742D696E64656E743A2D3939393970783B7D0D0A20202020202020202363626F78436C6F73653A686F7665727B6261636B67726F756E642D706F736974';
wwv_flow_api.g_varchar2_table(33) := '696F6E3A2D32357078202D323570783B7D0D0A0D0A2F2A0D0A202054686520666F6C6C6F77696E6720666978657320612070726F626C656D2077686572652049453720616E6420494538207265706C616365206120504E47277320616C70686120747261';
wwv_flow_api.g_varchar2_table(34) := '6E73706172656E63792077697468206120626C61636B2066696C6C0D0A20207768656E20616E20616C7068612066696C74657220286F706163697479206368616E67652920697320736574206F6E2074686520656C656D656E74206F7220616E63657374';
wwv_flow_api.g_varchar2_table(35) := '6F7220656C656D656E742E202054686973207374796C65206973206E6F74206170706C69656420746F206F72206E656564656420696E204945392E0D0A20205365653A20687474703A2F2F6A61636B6C6D6F6F72652E636F6D2F6E6F7465732F69652D74';
wwv_flow_api.g_varchar2_table(36) := '72616E73706172656E63792D70726F626C656D732F0D0A2A2F0D0A2E63626F784945202363626F78546F704C6566742C0D0A2E63626F784945202363626F78546F7043656E7465722C0D0A2E63626F784945202363626F78546F7052696768742C0D0A2E';
wwv_flow_api.g_varchar2_table(37) := '63626F784945202363626F78426F74746F6D4C6566742C0D0A2E63626F784945202363626F78426F74746F6D43656E7465722C0D0A2E63626F784945202363626F78426F74746F6D52696768742C0D0A2E63626F784945202363626F784D6964646C654C';
wwv_flow_api.g_varchar2_table(38) := '6566742C0D0A2E63626F784945202363626F784D6964646C655269676874207B0D0A2020202066696C7465723A2070726F6769643A4458496D6167655472616E73666F726D2E4D6963726F736F66742E6772616469656E74287374617274436F6C6F7273';
wwv_flow_api.g_varchar2_table(39) := '74723D2330304646464646462C656E64436F6C6F727374723D233030464646464646293B0D0A7D0D0A0D0A2F2A0D0A202054686520666F6C6C6F77696E672070726F766964657320504E47207472616E73706172656E637920737570706F727420666F72';
wwv_flow_api.g_varchar2_table(40) := '204945360D0A20204665656C206672656520746F2072656D6F7665207468697320616E6420746865202F6965362F206469726563746F727920696620796F7520686176652064726F707065642049453620737570706F72742E0D0A2A2F0D0A2E63626F78';
wwv_flow_api.g_varchar2_table(41) := '494536202363626F78546F704C6566747B6261636B67726F756E643A75726C2823504C5547494E5F505245464958237431626F72646572546F704C6566742E706E67293B7D0D0A2E63626F78494536202363626F78546F7043656E7465727B6261636B67';
wwv_flow_api.g_varchar2_table(42) := '726F756E643A75726C2823504C5547494E5F505245464958237431626F72646572546F7043656E7465722E706E67293B7D0D0A2E63626F78494536202363626F78546F7052696768747B6261636B67726F756E643A75726C2823504C5547494E5F505245';
wwv_flow_api.g_varchar2_table(43) := '464958237431626F72646572546F7052696768742E706E67293B7D0D0A2E63626F78494536202363626F78426F74746F6D4C6566747B6261636B67726F756E643A75726C2823504C5547494E5F505245464958237431626F72646572426F74746F6D4C65';
wwv_flow_api.g_varchar2_table(44) := '66742E706E67293B7D0D0A2E63626F78494536202363626F78426F74746F6D43656E7465727B6261636B67726F756E643A75726C2823504C5547494E5F505245464958237431626F72646572426F74746F6D43656E7465722E706E67293B7D0D0A2E6362';
wwv_flow_api.g_varchar2_table(45) := '6F78494536202363626F78426F74746F6D52696768747B6261636B67726F756E643A75726C2823504C5547494E5F505245464958237431626F72646572426F74746F6D52696768742E706E67293B7D0D0A2E63626F78494536202363626F784D6964646C';
wwv_flow_api.g_varchar2_table(46) := '654C6566747B6261636B67726F756E643A75726C2823504C5547494E5F505245464958237431626F726465724D6964646C654C6566742E706E67293B7D0D0A2E63626F78494536202363626F784D6964646C6552696768747B6261636B67726F756E643A';
wwv_flow_api.g_varchar2_table(47) := '75726C2823504C5547494E5F505245464958237431626F726465724D6964646C6552696768742E706E67293B7D0D0A0D0A2E63626F78494536202363626F78546F704C6566742C0D0A2E63626F78494536202363626F78546F7043656E7465722C0D0A2E';
wwv_flow_api.g_varchar2_table(48) := '63626F78494536202363626F78546F7052696768742C0D0A2E63626F78494536202363626F78426F74746F6D4C6566742C0D0A2E63626F78494536202363626F78426F74746F6D43656E7465722C0D0A2E63626F78494536202363626F78426F74746F6D';
wwv_flow_api.g_varchar2_table(49) := '52696768742C0D0A2E63626F78494536202363626F784D6964646C654C6566742C0D0A2E63626F78494536202363626F784D6964646C655269676874207B0D0A202020205F6265686176696F723A2065787072657373696F6E28746869732E737263203D';
wwv_flow_api.g_varchar2_table(50) := '20746869732E737263203F20746869732E737263203A20746869732E63757272656E745374796C652E6261636B67726F756E64496D6167652E73706C697428272227295B315D2C20746869732E7374796C652E6261636B67726F756E64203D20226E6F6E';
wwv_flow_api.g_varchar2_table(51) := '65222C20746869732E7374796C652E66696C746572203D202270726F6769643A4458496D6167655472616E73666F726D2E4D6963726F736F66742E416C706861496D6167654C6F61646572287372633D22202B20746869732E737263202B20222C207369';
wwv_flow_api.g_varchar2_table(52) := '7A696E674D6574686F643D277363616C65272922293B0D0A7D0D0A';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7748239717409265 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1colorbox.css'
 ,p_mime_type => 'text/css'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A0D0A20202020436F6C6F72426F7820436F7265205374796C653A0D0A2020202054686520666F6C6C6F77696E672043535320697320636F6E73697374656E74206265747765656E206578616D706C65207468656D657320616E642073686F756C6420';
wwv_flow_api.g_varchar2_table(2) := '6E6F7420626520616C74657265642E0D0A2A2F0D0A23636F6C6F72626F782C202363626F784F7665726C61792C202363626F78577261707065727B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B207A2D696E646578';
wwv_flow_api.g_varchar2_table(3) := '3A393939393B206F766572666C6F773A68696464656E3B7D0D0A2363626F784F7665726C61797B706F736974696F6E3A66697865643B2077696474683A313030253B206865696768743A313030253B7D0D0A2363626F784D6964646C654C6566742C2023';
wwv_flow_api.g_varchar2_table(4) := '63626F78426F74746F6D4C6566747B636C6561723A6C6566743B7D0D0A2363626F78436F6E74656E747B706F736974696F6E3A72656C61746976653B7D0D0A2363626F784C6F61646564436F6E74656E747B6F766572666C6F773A6175746F3B7D0D0A23';
wwv_flow_api.g_varchar2_table(5) := '63626F785469746C657B6D617267696E3A303B7D0D0A2363626F784C6F6164696E674F7665726C61792C202363626F784C6F6164696E67477261706869637B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B20776964';
wwv_flow_api.g_varchar2_table(6) := '74683A313030253B206865696768743A313030253B7D0D0A2363626F7850726576696F75732C202363626F784E6578742C202363626F78436C6F73652C202363626F78536C69646573686F777B637572736F723A706F696E7465723B7D0D0A2E63626F78';
wwv_flow_api.g_varchar2_table(7) := '50686F746F7B666C6F61743A6C6566743B206D617267696E3A6175746F3B20626F726465723A303B20646973706C61793A626C6F636B3B7D0D0A2E63626F78496672616D657B77696474683A313030253B206865696768743A313030253B20646973706C';
wwv_flow_api.g_varchar2_table(8) := '61793A626C6F636B3B20626F726465723A303B7D0D0A0D0A2F2A200D0A2020202055736572205374796C653A0D0A202020204368616E67652074686520666F6C6C6F77696E67207374796C657320746F206D6F646966792074686520617070656172616E';
wwv_flow_api.g_varchar2_table(9) := '6365206F6620436F6C6F72426F782E202054686579206172650D0A202020206F72646572656420262074616262656420696E206120776179207468617420726570726573656E747320746865206E657374696E67206F66207468652067656E6572617465';
wwv_flow_api.g_varchar2_table(10) := '642048544D4C2E0D0A2A2F0D0A2363626F784F7665726C61797B6261636B67726F756E643A236666663B7D0D0A23636F6C6F72626F787B7D0D0A202020202363626F78436F6E74656E747B6D617267696E2D746F703A333270783B206F766572666C6F77';
wwv_flow_api.g_varchar2_table(11) := '3A76697369626C653B7D0D0A20202020202020202E63626F78496672616D657B6261636B67726F756E643A236666663B7D0D0A20202020202020202363626F784572726F727B70616464696E673A353070783B20626F726465723A31707820736F6C6964';
wwv_flow_api.g_varchar2_table(12) := '20236363633B7D0D0A20202020202020202363626F784C6F61646564436F6E74656E747B6261636B67726F756E643A233030303B2070616464696E673A3170783B7D0D0A20202020202020202363626F784C6F6164696E67477261706869637B6261636B';
wwv_flow_api.g_varchar2_table(13) := '67726F756E643A75726C2823504C5547494E5F5052454649582374326C6F6164696E672E67696629206E6F2D7265706561742063656E7465722063656E7465723B7D0D0A20202020202020202363626F784C6F6164696E674F7665726C61797B6261636B';
wwv_flow_api.g_varchar2_table(14) := '67726F756E643A233030303B7D0D0A20202020202020202363626F785469746C657B706F736974696F6E3A6162736F6C7574653B20746F703A2D323270783B206C6566743A303B20636F6C6F723A233030303B7D0D0A20202020202020202363626F7843';
wwv_flow_api.g_varchar2_table(15) := '757272656E747B706F736974696F6E3A6162736F6C7574653B20746F703A2D323270783B2072696768743A32303570783B20746578742D696E64656E743A2D3939393970783B7D0D0A20202020202020202363626F78536C69646573686F772C20236362';
wwv_flow_api.g_varchar2_table(16) := '6F7850726576696F75732C202363626F784E6578742C202363626F78436C6F73657B746578742D696E64656E743A2D3939393970783B2077696474683A323070783B206865696768743A323070783B20706F736974696F6E3A6162736F6C7574653B2074';
wwv_flow_api.g_varchar2_table(17) := '6F703A2D323070783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237432636F6E74726F6C732E706E6729206E6F2D726570656174203020303B7D0D0A20202020202020202363626F7850726576696F75737B6261636B67';
wwv_flow_api.g_varchar2_table(18) := '726F756E642D706F736974696F6E3A307078203070783B2072696768743A343470783B7D0D0A20202020202020202363626F7850726576696F75733A686F7665727B6261636B67726F756E642D706F736974696F6E3A307078202D323570783B7D0D0A20';
wwv_flow_api.g_varchar2_table(19) := '202020202020202363626F784E6578747B6261636B67726F756E642D706F736974696F6E3A2D32357078203070783B2072696768743A323270783B7D0D0A20202020202020202363626F784E6578743A686F7665727B6261636B67726F756E642D706F73';
wwv_flow_api.g_varchar2_table(20) := '6974696F6E3A2D32357078202D323570783B7D0D0A20202020202020202363626F78436C6F73657B6261636B67726F756E642D706F736974696F6E3A2D35307078203070783B2072696768743A303B7D0D0A20202020202020202363626F78436C6F7365';
wwv_flow_api.g_varchar2_table(21) := '3A686F7665727B6261636B67726F756E642D706F736974696F6E3A2D35307078202D323570783B7D0D0A20202020202020202E63626F78536C69646573686F775F6F6E202363626F7850726576696F75732C202E63626F78536C69646573686F775F6F66';
wwv_flow_api.g_varchar2_table(22) := '66202363626F7850726576696F75737B72696768743A363670783B7D0D0A20202020202020202E63626F78536C69646573686F775F6F6E202363626F78536C69646573686F777B6261636B67726F756E642D706F736974696F6E3A2D37357078202D3235';
wwv_flow_api.g_varchar2_table(23) := '70783B2072696768743A343470783B7D0D0A20202020202020202E63626F78536C69646573686F775F6F6E202363626F78536C69646573686F773A686F7665727B6261636B67726F756E642D706F736974696F6E3A2D3130307078202D323570783B7D0D';
wwv_flow_api.g_varchar2_table(24) := '0A20202020202020202E63626F78536C69646573686F775F6F6666202363626F78536C69646573686F777B6261636B67726F756E642D706F736974696F6E3A2D3130307078203070783B2072696768743A343470783B7D0D0A20202020202020202E6362';
wwv_flow_api.g_varchar2_table(25) := '6F78536C69646573686F775F6F6666202363626F78536C69646573686F773A686F7665727B6261636B67726F756E642D706F736974696F6E3A2D37357078202D323570783B7D0D0A';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7748937776410138 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't2colorbox.css'
 ,p_mime_type => 'text/css'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A0D0A20202020436F6C6F72426F7820436F7265205374796C653A0D0A2020202054686520666F6C6C6F77696E672043535320697320636F6E73697374656E74206265747765656E206578616D706C65207468656D657320616E642073686F756C6420';
wwv_flow_api.g_varchar2_table(2) := '6E6F7420626520616C74657265642E0D0A2A2F0D0A23636F6C6F72626F782C202363626F784F7665726C61792C202363626F78577261707065727B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B207A2D696E646578';
wwv_flow_api.g_varchar2_table(3) := '3A393939393B206F766572666C6F773A68696464656E3B7D0D0A2363626F784F7665726C61797B706F736974696F6E3A66697865643B2077696474683A313030253B206865696768743A313030253B7D0D0A2363626F784D6964646C654C6566742C2023';
wwv_flow_api.g_varchar2_table(4) := '63626F78426F74746F6D4C6566747B636C6561723A6C6566743B7D0D0A2363626F78436F6E74656E747B706F736974696F6E3A72656C61746976653B7D0D0A2363626F784C6F61646564436F6E74656E747B6F766572666C6F773A6175746F3B7D0D0A23';
wwv_flow_api.g_varchar2_table(5) := '63626F785469746C657B6D617267696E3A303B7D0D0A2363626F784C6F6164696E674F7665726C61792C202363626F784C6F6164696E67477261706869637B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B20776964';
wwv_flow_api.g_varchar2_table(6) := '74683A313030253B206865696768743A313030253B7D0D0A2363626F7850726576696F75732C202363626F784E6578742C202363626F78436C6F73652C202363626F78536C69646573686F777B637572736F723A706F696E7465723B7D0D0A2E63626F78';
wwv_flow_api.g_varchar2_table(7) := '50686F746F7B666C6F61743A6C6566743B206D617267696E3A6175746F3B20626F726465723A303B20646973706C61793A626C6F636B3B7D0D0A2E63626F78496672616D657B77696474683A313030253B206865696768743A313030253B20646973706C';
wwv_flow_api.g_varchar2_table(8) := '61793A626C6F636B3B20626F726465723A303B7D0D0A0D0A2F2A200D0A2020202055736572205374796C653A0D0A202020204368616E67652074686520666F6C6C6F77696E67207374796C657320746F206D6F646966792074686520617070656172616E';
wwv_flow_api.g_varchar2_table(9) := '6365206F6620436F6C6F72426F782E202054686579206172650D0A202020206F72646572656420262074616262656420696E206120776179207468617420726570726573656E747320746865206E657374696E67206F66207468652067656E6572617465';
wwv_flow_api.g_varchar2_table(10) := '642048544D4C2E0D0A2A2F0D0A2363626F784F7665726C61797B6261636B67726F756E643A233030303B7D0D0A23636F6C6F72626F787B7D0D0A202020202363626F78436F6E74656E747B6D617267696E2D746F703A323070783B7D0D0A202020202020';
wwv_flow_api.g_varchar2_table(11) := '20202E63626F78496672616D657B6261636B67726F756E643A236666663B7D0D0A20202020202020202363626F784572726F727B70616464696E673A353070783B20626F726465723A31707820736F6C696420236363633B7D0D0A202020202020202023';
wwv_flow_api.g_varchar2_table(12) := '63626F784C6F61646564436F6E74656E747B626F726465723A35707820736F6C696420233030303B206261636B67726F756E643A236666663B7D0D0A20202020202020202363626F785469746C657B706F736974696F6E3A6162736F6C7574653B20746F';
wwv_flow_api.g_varchar2_table(13) := '703A2D323070783B206C6566743A303B20636F6C6F723A236363633B7D0D0A20202020202020202363626F7843757272656E747B706F736974696F6E3A6162736F6C7574653B20746F703A2D323070783B2072696768743A3070783B20636F6C6F723A23';
wwv_flow_api.g_varchar2_table(14) := '6363633B7D0D0A20202020202020202363626F78536C69646573686F777B706F736974696F6E3A6162736F6C7574653B20746F703A2D323070783B2072696768743A393070783B20636F6C6F723A236666663B7D0D0A20202020202020202363626F7850';
wwv_flow_api.g_varchar2_table(15) := '726576696F75737B706F736974696F6E3A6162736F6C7574653B20746F703A3530253B206C6566743A3570783B206D617267696E2D746F703A2D333270783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237433636F6E74';
wwv_flow_api.g_varchar2_table(16) := '726F6C732E706E6729206E6F2D72657065617420746F70206C6566743B2077696474683A323870783B206865696768743A363570783B20746578742D696E64656E743A2D3939393970783B7D0D0A20202020202020202363626F7850726576696F75733A';
wwv_flow_api.g_varchar2_table(17) := '686F7665727B6261636B67726F756E642D706F736974696F6E3A626F74746F6D206C6566743B7D0D0A20202020202020202363626F784E6578747B706F736974696F6E3A6162736F6C7574653B20746F703A3530253B2072696768743A3570783B206D61';
wwv_flow_api.g_varchar2_table(18) := '7267696E2D746F703A2D333270783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237433636F6E74726F6C732E706E6729206E6F2D72657065617420746F702072696768743B2077696474683A323870783B206865696768';
wwv_flow_api.g_varchar2_table(19) := '743A363570783B20746578742D696E64656E743A2D3939393970783B7D0D0A20202020202020202363626F784E6578743A686F7665727B6261636B67726F756E642D706F736974696F6E3A626F74746F6D2072696768743B7D0D0A202020202020202023';
wwv_flow_api.g_varchar2_table(20) := '63626F784C6F6164696E674F7665726C61797B6261636B67726F756E643A233030303B7D0D0A20202020202020202363626F784C6F6164696E67477261706869637B6261636B67726F756E643A75726C2823504C5547494E5F5052454649582374336C6F';
wwv_flow_api.g_varchar2_table(21) := '6164696E672E67696629206E6F2D7265706561742063656E7465722063656E7465723B7D0D0A20202020202020202363626F78436C6F73657B706F736974696F6E3A6162736F6C7574653B20746F703A3570783B2072696768743A3570783B2064697370';
wwv_flow_api.g_varchar2_table(22) := '6C61793A626C6F636B3B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237433636F6E74726F6C732E706E6729206E6F2D72657065617420746F702063656E7465723B2077696474683A333870783B206865696768743A3139';
wwv_flow_api.g_varchar2_table(23) := '70783B20746578742D696E64656E743A2D3939393970783B7D0D0A20202020202020202363626F78436C6F73653A686F7665727B6261636B67726F756E642D706F736974696F6E3A626F74746F6D2063656E7465723B7D';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7749636051410905 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't3colorbox.css'
 ,p_mime_type => 'text/css'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A0D0A20202020436F6C6F72426F7820436F7265205374796C653A0D0A2020202054686520666F6C6C6F77696E672043535320697320636F6E73697374656E74206265747765656E206578616D706C65207468656D657320616E642073686F756C6420';
wwv_flow_api.g_varchar2_table(2) := '6E6F7420626520616C74657265642E0D0A2A2F0D0A23636F6C6F72626F782C202363626F784F7665726C61792C202363626F78577261707065727B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B207A2D696E646578';
wwv_flow_api.g_varchar2_table(3) := '3A393939393B206F766572666C6F773A68696464656E3B7D0D0A2363626F784F7665726C61797B706F736974696F6E3A66697865643B2077696474683A313030253B206865696768743A313030253B7D0D0A2363626F784D6964646C654C6566742C2023';
wwv_flow_api.g_varchar2_table(4) := '63626F78426F74746F6D4C6566747B636C6561723A6C6566743B7D0D0A2363626F78436F6E74656E747B706F736974696F6E3A72656C61746976653B7D0D0A2363626F784C6F61646564436F6E74656E747B6F766572666C6F773A6175746F3B7D0D0A23';
wwv_flow_api.g_varchar2_table(5) := '63626F785469746C657B6D617267696E3A303B7D0D0A2363626F784C6F6164696E674F7665726C61792C202363626F784C6F6164696E67477261706869637B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B20776964';
wwv_flow_api.g_varchar2_table(6) := '74683A313030253B206865696768743A313030253B7D0D0A2363626F7850726576696F75732C202363626F784E6578742C202363626F78436C6F73652C202363626F78536C69646573686F777B637572736F723A706F696E7465723B7D0D0A2E63626F78';
wwv_flow_api.g_varchar2_table(7) := '50686F746F7B666C6F61743A6C6566743B206D617267696E3A6175746F3B20626F726465723A303B20646973706C61793A626C6F636B3B7D0D0A2E63626F78496672616D657B77696474683A313030253B206865696768743A313030253B20646973706C';
wwv_flow_api.g_varchar2_table(8) := '61793A626C6F636B3B20626F726465723A303B7D0D0A0D0A2F2A200D0A2020202055736572205374796C653A0D0A202020204368616E67652074686520666F6C6C6F77696E67207374796C657320746F206D6F646966792074686520617070656172616E';
wwv_flow_api.g_varchar2_table(9) := '6365206F6620436F6C6F72426F782E202054686579206172650D0A202020206F72646572656420262074616262656420696E206120776179207468617420726570726573656E747320746865206E657374696E67206F66207468652067656E6572617465';
wwv_flow_api.g_varchar2_table(10) := '642048544D4C2E0D0A2A2F0D0A2363626F784F7665726C61797B6261636B67726F756E643A236666663B7D0D0A23636F6C6F72626F787B7D0D0A202020202363626F78546F704C6566747B77696474683A323570783B206865696768743A323570783B20';
wwv_flow_api.g_varchar2_table(11) := '6261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572312E706E6729206E6F2D726570656174203020303B7D0D0A202020202363626F78546F7043656E7465727B6865696768743A323570783B206261636B6772';
wwv_flow_api.g_varchar2_table(12) := '6F756E643A75726C2823504C5547494E5F505245464958237434626F72646572312E706E6729207265706561742D782030202D353070783B7D0D0A202020202363626F78546F7052696768747B77696474683A323570783B206865696768743A32357078';
wwv_flow_api.g_varchar2_table(13) := '3B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572312E706E6729206E6F2D726570656174202D3235707820303B7D0D0A202020202363626F78426F74746F6D4C6566747B77696474683A323570783B20';
wwv_flow_api.g_varchar2_table(14) := '6865696768743A323570783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572312E706E6729206E6F2D7265706561742030202D323570783B7D0D0A202020202363626F78426F74746F6D43656E746572';
wwv_flow_api.g_varchar2_table(15) := '7B6865696768743A323570783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572312E706E6729207265706561742D782030202D373570783B7D0D0A202020202363626F78426F74746F6D52696768747B';
wwv_flow_api.g_varchar2_table(16) := '77696474683A323570783B206865696768743A323570783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572312E706E6729206E6F2D726570656174202D32357078202D323570783B7D0D0A2020202023';
wwv_flow_api.g_varchar2_table(17) := '63626F784D6964646C654C6566747B77696474683A323570783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572322E706E6729207265706561742D79203020303B7D0D0A202020202363626F784D6964';
wwv_flow_api.g_varchar2_table(18) := '646C6552696768747B77696474683A323570783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572322E706E6729207265706561742D79202D3235707820303B7D0D0A202020202363626F78436F6E7465';
wwv_flow_api.g_varchar2_table(19) := '6E747B6261636B67726F756E643A236666663B206F766572666C6F773A68696464656E3B7D0D0A20202020202020202E63626F78496672616D657B6261636B67726F756E643A236666663B7D0D0A20202020202020202363626F784572726F727B706164';
wwv_flow_api.g_varchar2_table(20) := '64696E673A353070783B20626F726465723A31707820736F6C696420236363633B7D0D0A20202020202020202363626F784C6F61646564436F6E74656E747B6D617267696E2D626F74746F6D3A323070783B7D0D0A20202020202020202363626F785469';
wwv_flow_api.g_varchar2_table(21) := '746C657B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A3070783B206C6566743A303B20746578742D616C69676E3A63656E7465723B2077696474683A313030253B20636F6C6F723A233939393B7D0D0A20202020202020202363626F';
wwv_flow_api.g_varchar2_table(22) := '7843757272656E747B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A3070783B206C6566743A31303070783B20636F6C6F723A233939393B7D0D0A20202020202020202363626F78536C69646573686F777B706F736974696F6E3A6162';
wwv_flow_api.g_varchar2_table(23) := '736F6C7574653B20626F74746F6D3A3070783B2072696768743A343270783B20636F6C6F723A233434343B7D0D0A20202020202020202363626F7850726576696F75737B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A3070783B206C';
wwv_flow_api.g_varchar2_table(24) := '6566743A303B20636F6C6F723A233434343B7D0D0A20202020202020202363626F784E6578747B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A3070783B206C6566743A363370783B20636F6C6F723A233434343B7D0D0A2020202020';
wwv_flow_api.g_varchar2_table(25) := '2020202363626F784C6F6164696E674F7665726C61797B6261636B67726F756E643A236666662075726C2823504C5547494E5F5052454649582374346C6F6164696E672E67696629206E6F2D72657065617420357078203570783B7D0D0A202020202020';
wwv_flow_api.g_varchar2_table(26) := '20202363626F78436C6F73657B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A303B2072696768743A303B20646973706C61793A626C6F636B3B20636F6C6F723A233434343B7D0D0A0D0A2F2A0D0A202054686520666F6C6C6F77696E';
wwv_flow_api.g_varchar2_table(27) := '6720666978657320612070726F626C656D2077686572652049453720616E6420494538207265706C616365206120504E47277320616C706861207472616E73706172656E63792077697468206120626C61636B2066696C6C0D0A20207768656E20616E20';
wwv_flow_api.g_varchar2_table(28) := '616C7068612066696C74657220286F706163697479206368616E67652920697320736574206F6E2074686520656C656D656E74206F7220616E636573746F7220656C656D656E742E202054686973207374796C65206973206E6F74206170706C69656420';
wwv_flow_api.g_varchar2_table(29) := '746F206F72206E656564656420696E204945392E0D0A20205365653A20687474703A2F2F6A61636B6C6D6F6F72652E636F6D2F6E6F7465732F69652D7472616E73706172656E63792D70726F626C656D732F0D0A2A2F0D0A2E63626F784945202363626F';
wwv_flow_api.g_varchar2_table(30) := '78546F704C6566742C0D0A2E63626F784945202363626F78546F7043656E7465722C0D0A2E63626F784945202363626F78546F7052696768742C0D0A2E63626F784945202363626F78426F74746F6D4C6566742C0D0A2E63626F784945202363626F7842';
wwv_flow_api.g_varchar2_table(31) := '6F74746F6D43656E7465722C0D0A2E63626F784945202363626F78426F74746F6D52696768742C0D0A2E63626F784945202363626F784D6964646C654C6566742C0D0A2E63626F784945202363626F784D6964646C655269676874207B0D0A2020202066';
wwv_flow_api.g_varchar2_table(32) := '696C7465723A2070726F6769643A4458496D6167655472616E73666F726D2E4D6963726F736F66742E6772616469656E74287374617274436F6C6F727374723D2330304646464646462C656E64436F6C6F727374723D233030464646464646293B0D0A7D';
wwv_flow_api.g_varchar2_table(33) := '0D0A0D0A2F2A0D0A202054686520666F6C6C6F77696E672070726F766964657320504E47207472616E73706172656E637920737570706F727420666F72204945360D0A20204665656C206672656520746F2072656D6F7665207468697320616E64207468';
wwv_flow_api.g_varchar2_table(34) := '65202F6965362F206469726563746F727920696620796F7520686176652064726F707065642049453620737570706F72742E0D0A2A2F0D0A2E63626F78494536202363626F78546F704C6566747B6261636B67726F756E643A75726C2823504C5547494E';
wwv_flow_api.g_varchar2_table(35) := '5F505245464958237434626F72646572546F704C6566742E706E67293B7D0D0A2E63626F78494536202363626F78546F7043656E7465727B6261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572546F7043656E';
wwv_flow_api.g_varchar2_table(36) := '7465722E706E67293B7D0D0A2E63626F78494536202363626F78546F7052696768747B6261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572546F7052696768742E706E67293B7D0D0A2E63626F784945362023';
wwv_flow_api.g_varchar2_table(37) := '63626F78426F74746F6D4C6566747B6261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572426F74746F6D4C6566742E706E67293B7D0D0A2E63626F78494536202363626F78426F74746F6D43656E7465727B62';
wwv_flow_api.g_varchar2_table(38) := '61636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F72646572426F74746F6D43656E7465722E706E67293B7D0D0A2E63626F78494536202363626F78426F74746F6D52696768747B6261636B67726F756E643A75726C2823';
wwv_flow_api.g_varchar2_table(39) := '504C5547494E5F505245464958237434626F72646572426F74746F6D52696768742E706E67293B7D0D0A2E63626F78494536202363626F784D6964646C654C6566747B6261636B67726F756E643A75726C2823504C5547494E5F50524546495823743462';
wwv_flow_api.g_varchar2_table(40) := '6F726465724D6964646C654C6566742E706E67293B7D0D0A2E63626F78494536202363626F784D6964646C6552696768747B6261636B67726F756E643A75726C2823504C5547494E5F505245464958237434626F726465724D6964646C6552696768742E';
wwv_flow_api.g_varchar2_table(41) := '706E67293B7D0D0A0D0A2E63626F78494536202363626F78546F704C6566742C0D0A2E63626F78494536202363626F78546F7043656E7465722C0D0A2E63626F78494536202363626F78546F7052696768742C0D0A2E63626F78494536202363626F7842';
wwv_flow_api.g_varchar2_table(42) := '6F74746F6D4C6566742C0D0A2E63626F78494536202363626F78426F74746F6D43656E7465722C0D0A2E63626F78494536202363626F78426F74746F6D52696768742C0D0A2E63626F78494536202363626F784D6964646C654C6566742C0D0A2E63626F';
wwv_flow_api.g_varchar2_table(43) := '78494536202363626F784D6964646C655269676874207B0D0A202020205F6265686176696F723A2065787072657373696F6E28746869732E737263203D20746869732E737263203F20746869732E737263203A20746869732E63757272656E745374796C';
wwv_flow_api.g_varchar2_table(44) := '652E6261636B67726F756E64496D6167652E73706C697428272227295B315D2C20746869732E7374796C652E6261636B67726F756E64203D20226E6F6E65222C20746869732E7374796C652E66696C746572203D202270726F6769643A4458496D616765';
wwv_flow_api.g_varchar2_table(45) := '5472616E73666F726D2E4D6963726F736F66742E416C706861496D6167654C6F61646572287372633D22202B20746869732E737263202B20222C2073697A696E674D6574686F643D277363616C65272922293B0D0A7D0D0A';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7750334326411671 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4colorbox.css'
 ,p_mime_type => 'text/css'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A0D0A20202020436F6C6F72426F7820436F7265205374796C653A0D0A2020202054686520666F6C6C6F77696E672043535320697320636F6E73697374656E74206265747765656E206578616D706C65207468656D657320616E642073686F756C6420';
wwv_flow_api.g_varchar2_table(2) := '6E6F7420626520616C74657265642E0D0A2A2F0D0A23636F6C6F72626F782C202363626F784F7665726C61792C202363626F78577261707065727B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B207A2D696E646578';
wwv_flow_api.g_varchar2_table(3) := '3A393939393B206F766572666C6F773A68696464656E3B7D0D0A2363626F784F7665726C61797B706F736974696F6E3A66697865643B2077696474683A313030253B206865696768743A313030253B7D0D0A2363626F784D6964646C654C6566742C2023';
wwv_flow_api.g_varchar2_table(4) := '63626F78426F74746F6D4C6566747B636C6561723A6C6566743B7D0D0A2363626F78436F6E74656E747B706F736974696F6E3A72656C61746976653B7D0D0A2363626F784C6F61646564436F6E74656E747B6F766572666C6F773A6175746F3B7D0D0A23';
wwv_flow_api.g_varchar2_table(5) := '63626F785469746C657B6D617267696E3A303B7D0D0A2363626F784C6F6164696E674F7665726C61792C202363626F784C6F6164696E67477261706869637B706F736974696F6E3A6162736F6C7574653B20746F703A303B206C6566743A303B20776964';
wwv_flow_api.g_varchar2_table(6) := '74683A313030253B206865696768743A313030253B7D0D0A2363626F7850726576696F75732C202363626F784E6578742C202363626F78436C6F73652C202363626F78536C69646573686F777B637572736F723A706F696E7465723B7D0D0A2E63626F78';
wwv_flow_api.g_varchar2_table(7) := '50686F746F7B666C6F61743A6C6566743B206D617267696E3A6175746F3B20626F726465723A303B20646973706C61793A626C6F636B3B7D0D0A2E63626F78496672616D657B77696474683A313030253B206865696768743A313030253B20646973706C';
wwv_flow_api.g_varchar2_table(8) := '61793A626C6F636B3B20626F726465723A303B7D0D0A0D0A2F2A200D0A2020202055736572205374796C653A0D0A202020204368616E67652074686520666F6C6C6F77696E67207374796C657320746F206D6F646966792074686520617070656172616E';
wwv_flow_api.g_varchar2_table(9) := '6365206F6620436F6C6F72426F782E202054686579206172650D0A202020206F72646572656420262074616262656420696E206120776179207468617420726570726573656E747320746865206E657374696E67206F66207468652067656E6572617465';
wwv_flow_api.g_varchar2_table(10) := '642048544D4C2E0D0A2A2F0D0A2363626F784F7665726C61797B6261636B67726F756E643A233030303B7D0D0A23636F6C6F72626F787B7D0D0A202020202363626F78546F704C6566747B77696474683A313470783B206865696768743A313470783B20';
wwv_flow_api.g_varchar2_table(11) := '6261636B67726F756E643A75726C2823504C5547494E5F505245464958237435636F6E74726F6C732E706E6729206E6F2D726570656174203020303B7D0D0A202020202363626F78546F7043656E7465727B6865696768743A313470783B206261636B67';
wwv_flow_api.g_varchar2_table(12) := '726F756E643A75726C2823504C5547494E5F505245464958237435626F726465722E706E6729207265706561742D7820746F70206C6566743B7D0D0A202020202363626F78546F7052696768747B77696474683A313470783B206865696768743A313470';
wwv_flow_api.g_varchar2_table(13) := '783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237435636F6E74726F6C732E706E6729206E6F2D726570656174202D3336707820303B7D0D0A202020202363626F78426F74746F6D4C6566747B77696474683A31347078';
wwv_flow_api.g_varchar2_table(14) := '3B206865696768743A343370783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237435636F6E74726F6C732E706E6729206E6F2D7265706561742030202D333270783B7D0D0A202020202363626F78426F74746F6D43656E';
wwv_flow_api.g_varchar2_table(15) := '7465727B6865696768743A343370783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237435626F726465722E706E6729207265706561742D7820626F74746F6D206C6566743B7D0D0A202020202363626F78426F74746F6D';
wwv_flow_api.g_varchar2_table(16) := '52696768747B77696474683A313470783B206865696768743A343370783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237435636F6E74726F6C732E706E6729206E6F2D726570656174202D33367078202D333270783B7D';
wwv_flow_api.g_varchar2_table(17) := '0D0A202020202363626F784D6964646C654C6566747B77696474683A313470783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237435636F6E74726F6C732E706E6729207265706561742D79202D313735707820303B7D0D';
wwv_flow_api.g_varchar2_table(18) := '0A202020202363626F784D6964646C6552696768747B77696474683A313470783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237435636F6E74726F6C732E706E6729207265706561742D79202D323131707820303B7D0D';
wwv_flow_api.g_varchar2_table(19) := '0A202020202363626F78436F6E74656E747B6261636B67726F756E643A236666663B206F766572666C6F773A76697369626C653B7D0D0A20202020202020202E63626F78496672616D657B6261636B67726F756E643A236666663B7D0D0A202020202020';
wwv_flow_api.g_varchar2_table(20) := '20202363626F784572726F727B70616464696E673A353070783B20626F726465723A31707820736F6C696420236363633B7D0D0A20202020202020202363626F784C6F61646564436F6E74656E747B6D617267696E2D626F74746F6D3A3570783B7D0D0A';
wwv_flow_api.g_varchar2_table(21) := '20202020202020202363626F784C6F6164696E674F7665726C61797B6261636B67726F756E643A75726C2823504C5547494E5F5052454649582374356C6F6164696E675F6261636B67726F756E642E706E6729206E6F2D7265706561742063656E746572';
wwv_flow_api.g_varchar2_table(22) := '2063656E7465723B7D0D0A20202020202020202363626F784C6F6164696E67477261706869637B6261636B67726F756E643A75726C2823504C5547494E5F5052454649582374356C6F6164696E672E67696629206E6F2D7265706561742063656E746572';
wwv_flow_api.g_varchar2_table(23) := '2063656E7465723B7D0D0A20202020202020202363626F785469746C657B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A2D323570783B206C6566743A303B20746578742D616C69676E3A63656E7465723B2077696474683A31303025';
wwv_flow_api.g_varchar2_table(24) := '3B20666F6E742D7765696768743A626F6C643B20636F6C6F723A233743374337433B7D0D0A20202020202020202363626F7843757272656E747B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A2D323570783B206C6566743A35387078';
wwv_flow_api.g_varchar2_table(25) := '3B20666F6E742D7765696768743A626F6C643B20636F6C6F723A233743374337433B7D0D0A20202020202020200D0A20202020202020202363626F7850726576696F75732C202363626F784E6578742C202363626F78436C6F73652C202363626F78536C';
wwv_flow_api.g_varchar2_table(26) := '69646573686F777B706F736974696F6E3A6162736F6C7574653B20626F74746F6D3A2D323970783B206261636B67726F756E643A75726C2823504C5547494E5F505245464958237435636F6E74726F6C732E706E6729206E6F2D72657065617420307078';
wwv_flow_api.g_varchar2_table(27) := '203070783B2077696474683A323370783B206865696768743A323370783B20746578742D696E64656E743A2D3939393970783B7D0D0A20202020202020202363626F7850726576696F75737B6C6566743A3070783B206261636B67726F756E642D706F73';
wwv_flow_api.g_varchar2_table(28) := '6974696F6E3A202D35317078202D323570783B7D0D0A20202020202020202363626F7850726576696F75733A686F7665727B6261636B67726F756E642D706F736974696F6E3A2D35317078203070783B7D0D0A20202020202020202363626F784E657874';
wwv_flow_api.g_varchar2_table(29) := '7B6C6566743A323770783B206261636B67726F756E642D706F736974696F6E3A2D37357078202D323570783B7D0D0A20202020202020202363626F784E6578743A686F7665727B6261636B67726F756E642D706F736974696F6E3A2D3735707820307078';
wwv_flow_api.g_varchar2_table(30) := '3B7D0D0A20202020202020202363626F78436C6F73657B72696768743A303B206261636B67726F756E642D706F736974696F6E3A2D3130307078202D323570783B7D0D0A20202020202020202363626F78436C6F73653A686F7665727B6261636B67726F';
wwv_flow_api.g_varchar2_table(31) := '756E642D706F736974696F6E3A2D3130307078203070783B7D0D0A20202020202020200D0A20202020202020202E63626F78536C69646573686F775F6F6E202363626F78536C69646573686F777B6261636B67726F756E642D706F736974696F6E3A2D31';
wwv_flow_api.g_varchar2_table(32) := '32357078203070783B2072696768743A323770783B7D0D0A20202020202020202E63626F78536C69646573686F775F6F6E202363626F78536C69646573686F773A686F7665727B6261636B67726F756E642D706F736974696F6E3A2D3135307078203070';
wwv_flow_api.g_varchar2_table(33) := '783B7D0D0A20202020202020202E63626F78536C69646573686F775F6F6666202363626F78536C69646573686F777B6261636B67726F756E642D706F736974696F6E3A2D3135307078202D323570783B2072696768743A323770783B7D0D0A2020202020';
wwv_flow_api.g_varchar2_table(34) := '2020202E63626F78536C69646573686F775F6F6666202363626F78536C69646573686F773A686F7665727B6261636B67726F756E642D706F736974696F6E3A2D3132357078203070783B7D';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7751032816412418 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't5colorbox.css'
 ,p_mime_type => 'text/css'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2866756E6374696F6E2861297B612E776964676574282275692E617065785F6D6F64616C5F70616765222C7B6F7074696F6E733A7B7472616E736974696F6E3A6E756C6C2C6C6F6164696E67496D6167655372633A6E756C6C2C696E697469616C486569';
wwv_flow_api.g_varchar2_table(2) := '6768743A6E756C6C2C696E697469616C57696474683A6E756C6C2C6F7665726C61794F7061636974793A6E756C6C2C7363726F6C6C696E673A6E756C6C2C647261676761626C653A6E756C6C7D2C5F6372656174655072697661746553746F726167653A';
wwv_flow_api.g_varchar2_table(3) := '66756E6374696F6E28297B76617220623D746869733B6966286128222370646562756722292E6C656E677468297B617065782E646562756728274D6F64616C2050616765202D20537461727420225F6372656174655072697661746553746F7261676522';
wwv_flow_api.g_varchar2_table(4) := '27297D622E5F76616C7565733D7B75726C3A6E756C6C2C6469616C6F675469746C653A6E756C6C2C636C6F736553656C6563746F723A6E756C6C2C70726576656E7444656661756C743A6E756C6C2C68656967687457696474684D6F64653A6E756C6C2C';
wwv_flow_api.g_varchar2_table(5) := '6865696768743A6E756C6C2C77696474683A6E756C6C2C636C6F7365456C656D656E7453656C6563746F723A6E756C6C2C6D6F64616C5061676549643A6E756C6C2C6D6F64616C50616765436C6F736556616C75653A6E756C6C2C6469616C6F67546F70';
wwv_flow_api.g_varchar2_table(6) := '3A302C6469616C6F674C6566743A302C696672616D654865696768743A302C696672616D6557696474683A302C686173565363726F6C6C3A66616C73652C686173485363726F6C6C3A66616C73652C6175746F436C6F7365643A66616C73652C64656275';
wwv_flow_api.g_varchar2_table(7) := '673A6128222370646562756722292E6C656E677468213D3D307D3B622E5F656C656D656E74733D7B2477696E646F773A7B7D2C246469616C6F673A7B7D2C24777261707065723A7B7D2C24696672616D653A7B7D7D3B696628622E5F76616C7565732E64';
wwv_flow_api.g_varchar2_table(8) := '65627567297B617065782E646562756728274D6F64616C2050616765202D20456E6420225F6372656174655072697661746553746F726167652227297D7D2C5F6372656174653A66756E6374696F6E28297B76617220633D746869733B76617220623D6E';
wwv_flow_api.g_varchar2_table(9) := '657720496D61676528293B622E7372633D632E6F7074696F6E732E6C6F6164696E67496D6167655372633B6966286128222370646562756722292E6C656E677468297B617065782E646562756728274D6F64616C2050616765202D20537461727420225F';
wwv_flow_api.g_varchar2_table(10) := '6372656174652227293B617065782E646562756728222E2E2E4F7074696F6E7322293B666F72286E616D6520696E20632E6F7074696F6E73297B617065782E646562756728222E2E2E2E2E2E222B6E616D652B273A2022272B632E6F7074696F6E735B6E';
wwv_flow_api.g_varchar2_table(11) := '616D655D2B272227297D7D632E5F6372656174655072697661746553746F7261676528293B632E5F656C656D656E74732E2477696E646F773D612877696E646F77293B696628632E5F76616C7565732E6465627567297B617065782E646562756728274D';
wwv_flow_api.g_varchar2_table(12) := '6F64616C2050616765202D20456E6420225F6372656174652227297D7D2C6F70656E506167653A66756E6374696F6E28642C632C662C652C622C67297B76617220683D746869733B76617220693D7B7469746C653A756E646566696E65642C636C6F7365';
wwv_flow_api.g_varchar2_table(13) := '53656C6563746F723A756E646566696E65642C6D6F64616C5061676549643A756E646566696E65642C6865696768743A756E646566696E65647D3B696628682E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C20506167';
wwv_flow_api.g_varchar2_table(14) := '65202D20537461727420226F70656E506167652227297D682E5F76616C7565732E6175746F436C6F7365643D66616C73653B682E5F76616C7565732E6469616C6F675469746C653D643B682E5F76616C7565732E636C6F7365456C656D656E7453656C65';
wwv_flow_api.g_varchar2_table(15) := '63746F723D633B682E5F76616C7565732E6D6F64616C5061676549643D663B682E5F76616C7565732E68656967687457696474684D6F64653D653B682E5F76616C7565732E6865696768743D623B682E5F76616C7565732E77696474683D673B612E636F';
wwv_flow_api.g_varchar2_table(16) := '6C6F72626F78287B7472616E736974696F6E3A682E6F7074696F6E732E7472616E736974696F6E2C7469746C653A682E5F76616C7565732E6469616C6F675469746C652C6865696768743A682E6F7074696F6E732E696E697469616C4865696768742B22';
wwv_flow_api.g_varchar2_table(17) := '7078222C77696474683A682E6F7074696F6E732E696E697469616C57696474682B227078222C696672616D653A747275652C7363726F6C6C696E673A682E6F7074696F6E732E7363726F6C6C696E672C66617374496672616D653A66616C73652C6F7665';
wwv_flow_api.g_varchar2_table(18) := '726C6179436C6F73653A66616C73652C6F7061636974793A682E6F7074696F6E732E6F7665726C61794F7061636974792C687265663A682E5F76616C7565732E75726C2C6F6E4F70656E3A66756E6374696F6E28297B696628682E6F7074696F6E732E64';
wwv_flow_api.g_varchar2_table(19) := '7261676761626C65297B61282223636F6C6F72626F7822292E647261676761626C6528292E6373732822637572736F72222C226D6F766522297D6128646F63756D656E74292E747269676765722822617065786D6F64616C706167656F70656E22297D2C';
wwv_flow_api.g_varchar2_table(20) := '6F6E436F6D706C6574653A66756E6374696F6E28297B682E5F68616E646C65496672616D654C6F616428293B6128646F63756D656E74292E747269676765722822617065786D6F64616C70616765636F6D706C65746522297D2C6F6E436C65616E75703A';
wwv_flow_api.g_varchar2_table(21) := '66756E6374696F6E28297B682E5F656C656D656E74732E2477696E646F772E756E62696E642822726573697A65222C682E5F636865636B526573697A6554696D6572293B69662821682E5F76616C7565732E6175746F436C6F736564297B6128646F6375';
wwv_flow_api.g_varchar2_table(22) := '6D656E74292E7472696767657228226D6F64616C706167656D616E75616C636C6F7365222C7B6D6F64616C5061676549643A682E5F76616C7565732E6D6F64616C5061676549642C6D6F64616C50616765436C6F736556616C75653A2828682E5F76616C';
wwv_flow_api.g_varchar2_table(23) := '7565732E6D6F64616C50616765436C6F736556616C7565293F682E5F76616C7565732E6D6F64616C50616765436C6F736556616C75653A2222297D297D682E5F76616C7565732E6D6F64616C50616765436C6F736556616C75653D6E756C6C7D2C6F6E43';
wwv_flow_api.g_varchar2_table(24) := '6C6F7365643A66756E6374696F6E28297B6128646F63756D656E74292E747269676765722822617065786D6F64616C70616765636C6F73656422297D7D293B682E5F656C656D656E74732E2477696E646F772E62696E642822726573697A65222C7B7569';
wwv_flow_api.g_varchar2_table(25) := '773A687D2C682E5F636865636B526573697A6554696D6572293B696628682E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20456E6420226F70656E506167652227297D7D2C6F70656E506167654672';
wwv_flow_api.g_varchar2_table(26) := '6F6D41706578546869733A66756E6374696F6E2869297B76617220673D746869733B76617220653D692E616374696F6E2E61747472696275746530323B76617220683D692E616374696F6E2E61747472696275746530333B76617220643D692E61637469';
wwv_flow_api.g_varchar2_table(27) := '6F6E2E61747472696275746530353B76617220633D692E616374696F6E2E61747472696275746530373B76617220623B76617220663B696628672E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D2053';
wwv_flow_api.g_varchar2_table(28) := '7461727420226F70656E5061676546726F6D41706578546869732227297D696628653D3D3D2253544154494322297B672E5F76616C7565732E75726C3D687D656C73657B696628653D3D3D22545249475F454C454D454E545F4154545222297B672E5F76';
wwv_flow_api.g_varchar2_table(29) := '616C7565732E75726C3D6128692E74726967676572696E67456C656D656E74292E617474722864297D7D696628633D3D3D224155544F22297B623D66616C73653B663D66616C73657D656C73657B696628633D3D3D225354415449435F505822297B623D';
wwv_flow_api.g_varchar2_table(30) := '692E616374696F6E2E61747472696275746530382B227078223B663D692E616374696F6E2E61747472696275746530392B227078227D656C73657B696628633D3D3D225354415449435F2522297B623D692E616374696F6E2E6174747269627574653038';
wwv_flow_api.g_varchar2_table(31) := '2B2225223B663D692E616374696F6E2E61747472696275746530392B2225227D7D7D672E6F70656E5061676528692E616374696F6E2E61747472696275746530312C692E616374696F6E2E61747472696275746530362C692E616374696F6E2E61747472';
wwv_flow_api.g_varchar2_table(32) := '696275746531302C632C622C66293B696628672E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20456E6420226F70656E5061676546726F6D41706578546869732227297D7D2C5F68616E646C654966';
wwv_flow_api.g_varchar2_table(33) := '72616D654C6F61643A66756E6374696F6E28297B76617220653D746869733B652E5F656C656D656E74732E24696672616D653D61282223636F6C6F72626F7820696672616D6522293B76617220623D652E5F656C656D656E74732E24696672616D652E63';
wwv_flow_api.g_varchar2_table(34) := '6F6E74656E747328292E66696E6428652E5F76616C7565732E636C6F7365456C656D656E7453656C6563746F72293B76617220643D652E5F656C656D656E74732E24696672616D652E6765742830292E636F6E74656E7457696E646F773B76617220633D';
wwv_flow_api.g_varchar2_table(35) := '642E617065782E6A51756572793B696628652E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20537461727420225F68616E646C65496672616D654C6F61642227297D6328652E5F656C656D656E7473';
wwv_flow_api.g_varchar2_table(36) := '2E24696672616D652E636F6E74656E747328292E676574283029292E62696E642822617065786265666F7265706167657375626D6974222C66756E6374696F6E28297B6128222363626F784C6F61646564436F6E74656E7422292E6869646528293B6128';
wwv_flow_api.g_varchar2_table(37) := '222363626F784C6F6164696E674F7665726C617922292E73686F7728293B6128222363626F784C6F6164696E674772617068696322292E73686F7728297D293B652E5F656C656D656E74732E24696672616D652E636F6E74656E747328292E66696E6428';
wwv_flow_api.g_varchar2_table(38) := '2223617065782D6465762D746F6F6C6261722C2368746D6C6462446576546F6F6C62617222292E72656D6F766528293B696628622E6C656E677468297B652E5F76616C7565732E6175746F436C6F7365643D747275653B6A51756572792E636F6C6F7262';
wwv_flow_api.g_varchar2_table(39) := '6F782E636C6F736528293B6128646F63756D656E74292E7472696767657228226D6F64616C706167656175746F636C6F7365222C7B6D6F64616C5061676549643A652E5F76616C7565732E6D6F64616C5061676549642C22246D6F64616C50616765436C';
wwv_flow_api.g_varchar2_table(40) := '6F73654F626A656374223A622E636C6F6E652874727565297D297D656C73657B652E5F656C656D656E74732E24696672616D652E636F6E74656E747328292E66696E642822626F647922292E63737328226D617267696E222C2230707822293B61282223';
wwv_flow_api.g_varchar2_table(41) := '63626F784C6F6164696E674F7665726C617922292E6869646528293B6128222363626F784C6F6164696E674772617068696322292E6869646528293B6128222363626F784C6F61646564436F6E74656E7422292E73686F7728293B652E5F726573697A65';
wwv_flow_api.g_varchar2_table(42) := '4D6F64616C28293B652E5F656C656D656E74732E24696672616D652E72656D6F7665436C617373282275692D68656C7065722D68696464656E2D61636365737369626C6522293B652E5F656C656D656E74732E24696672616D652E6F6E6528226C6F6164';
wwv_flow_api.g_varchar2_table(43) := '222C66756E6374696F6E28297B652E5F68616E646C65496672616D654C6F616428297D297D696628652E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20456E6420225F68616E646C65496672616D65';
wwv_flow_api.g_varchar2_table(44) := '4C6F61642227297D7D2C5F726573697A654D6F64616C3A66756E6374696F6E2862297B76617220633D746869733B696628632E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20537461727420225F72';
wwv_flow_api.g_varchar2_table(45) := '6573697A654D6F64616C2227297D632E5F656C656D656E74732E2477696E646F772E756E62696E642822726573697A65222C632E5F636865636B526573697A6554696D6572293B69662862297B6A51756572792E636F6C6F72626F782E726573697A6528';
wwv_flow_api.g_varchar2_table(46) := '7B77696474683A622E77696474682C6865696768743A622E6865696768742C696E6E65724865696768743A622E696E6E65724865696768742C696E6E657257696474683A622E696E6E657257696474687D297D656C73657B696628632E5F76616C756573';
wwv_flow_api.g_varchar2_table(47) := '2E68656967687457696474684D6F64653D3D3D224155544F22297B6A51756572792E636F6C6F72626F782E726573697A65287B696E6E65724865696768743A632E5F656C656D656E74732E24696672616D652E636F6E74656E747328292E686569676874';
wwv_flow_api.g_varchar2_table(48) := '28292C696E6E657257696474683A632E5F656C656D656E74732E24696672616D652E636F6E74656E747328292E776964746828297D297D656C73657B6A51756572792E636F6C6F72626F782E726573697A65287B696E6E65724865696768743A632E5F76';
wwv_flow_api.g_varchar2_table(49) := '616C7565732E6865696768742C696E6E657257696474683A632E5F76616C7565732E77696474687D297D7D632E5F656C656D656E74732E2477696E646F772E62696E642822726573697A65222C7B7569773A637D2C632E5F636865636B526573697A6554';
wwv_flow_api.g_varchar2_table(50) := '696D6572293B696628632E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20456E6420225F726573697A654D6F64616C2227297D7D2C5F636865636B526573697A6554696D65723A66756E6374696F6E';
wwv_flow_api.g_varchar2_table(51) := '2863297B76617220623D632E646174612E7569773B696628622E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20537461727420225F636865636B526573697A6554696D65722227297D696628622E5F';
wwv_flow_api.g_varchar2_table(52) := '76616C7565732E74696D6572297B636C65617254696D656F757428622E5F76616C7565732E74696D6572297D622E5F76616C7565732E74696D65723D73657454696D656F75742866756E6374696F6E28297B622E5F68616E646C6557696E646F77526573';
wwv_flow_api.g_varchar2_table(53) := '697A6528297D2C3530293B696628622E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20456E6420225F636865636B526573697A6554696D65722227297D7D2C5F68616E646C6557696E646F77526573';
wwv_flow_api.g_varchar2_table(54) := '697A653A66756E6374696F6E28297B76617220623D746869733B696628622E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20537461727420225F68616E646C6557696E646F77526573697A65222729';
wwv_flow_api.g_varchar2_table(55) := '7D696628622E5F76616C7565732E68656967687457696474684D6F6465213D3D224155544F22297B622E5F726573697A654D6F64616C28297D696628622E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C205061676520';
wwv_flow_api.g_varchar2_table(56) := '2D20456E6420225F68616E646C6557696E646F77526573697A652227297D7D2C636C6F73653A66756E6374696F6E2863297B76617220623D746869733B696628622E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050';
wwv_flow_api.g_varchar2_table(57) := '616765202D2053746172742022636C6F73652227297D622E5F76616C7565732E6D6F64616C50616765436C6F736556616C75653D633B6A51756572792E636F6C6F72626F782E636C6F736528293B696628622E5F76616C7565732E6465627567297B6170';
wwv_flow_api.g_varchar2_table(58) := '65782E646562756728274D6F64616C2050616765202D20456E642022636C6F73652227297D7D2C726573697A653A66756E6374696F6E2862297B7569773D746869733B6966287569772E5F76616C7565732E6465627567297B617065782E646562756728';
wwv_flow_api.g_varchar2_table(59) := '274D6F64616C2050616765202D2053746172742022726573697A652227297D7569772E5F726573697A654D6F64616C2862293B6966287569772E5F76616C7565732E6465627567297B617065782E646562756728274D6F64616C2050616765202D20456E';
wwv_flow_api.g_varchar2_table(60) := '642022726573697A652227297D7D7D297D2928617065782E6A5175657279293B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7751730013413685 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 'apex_modal_page.min.js'
 ,p_mime_type => 'application/javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000001000000320103000000A73523C900000006504C5445000000FFFFFFA5D99FDD0000000174524E5380AD5E5B460000001849444154785E95C1010D0000008230A31B9D066CFC330F0526820B01E3EC9A99';
wwv_flow_api.g_varchar2_table(2) := '0000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7753122465417187 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1border.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000001000000150103000000BD9C164700000006504C5445000000FFFFFFA5D99FDD0000000174524E5380AD5E5B460000001749444154785E7DC1210100000083B0477F7434866DD7007AAA03813389C49000';
wwv_flow_api.g_varchar2_table(2) := '00000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7753819445418540 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1borderBottomCenter.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000150000001504030000005B39B8A500000027504C5445000000000000000000656565B7B7B7000000000000CFCFCF000000000000000000000000FFFFFF94C88E050000000C74524E538000789FC75830D7';
wwv_flow_api.g_varchar2_table(2) := '386810181AE7B20E0000005349444154785E85CAB10D8020180561125DE05991D83088235830028D5B50390133D0B18503FC4311A289579878D5579C7B32B3EBCB19DEE019763B3CE5E1FF021CE1042FB08755E00AAFE1B51AAC13D6716F1D361416074A';
wwv_flow_api.g_varchar2_table(3) := 'BD57B20000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7754517504419473 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1borderBottomLeft.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000150000001504030000005B39B8A500000027504C5445000000000000000000656565B7B7B7000000000000CFCFCF000000000000000000000000FFFFFF94C88E050000000C74524E538000789FC75830D7';
wwv_flow_api.g_varchar2_table(2) := '386810181AE7B20E0000005549444154785E9DC6B10D80201005D0CB55DA791BD858D938822338026E60C2048EE0086C426179434142E05F2879D523558D54F47FCC0FFC27FCC43D0D5ACD2F7387F2824FE61FCE01DFA57D0EEDFC4AFD764B7E02967416';
wwv_flow_api.g_varchar2_table(3) := '07AA8DD7170000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7755215563420332 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1borderBottomRight.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000150000000101030000000B9E775800000006504C5445000000FFFFFFA5D99FDD0000000174524E5380AD5E5B460000001449444154785E0580B1090000004094FFFF350A6C010200FC69A300E400000000';
wwv_flow_api.g_varchar2_table(2) := '49454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7755946606421146 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1borderMiddleLeft.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000150000000101030000000B9E775800000006504C5445000000FFFFFFA5D99FDD0000000174524E5380AD5E5B460000001449444154785E05C001090000008020FF8F8E100302FE00FFBFDBF57F00000000';
wwv_flow_api.g_varchar2_table(2) := '49454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7756644018422373 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1borderMiddleRight.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000001000000150103000000BD9C164700000006504C5445000000FFFFFFA5D99FDD0000000174524E5380AD5E5B460000001749444154785E7DC1210100000083B0477F742C8A6DE50E18AA0381149316F900';
wwv_flow_api.g_varchar2_table(2) := '00000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7757341430423561 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1borderTopCenter.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000150000001504030000005B39B8A500000027504C5445000000000000000000000000000000000000000000000000656565CFCFCFB7B7B7000000FFFFFF3B8665F90000000C74524E538000783058106838';
wwv_flow_api.g_varchar2_table(2) := '9FD7C7183A2073AD0000005449444154785E9DC6A10D80401044D19104070681D9121014400D0834355007256C091441015B147709D99920F9E63F74A5D950AB3ECA5E6F488F46AFA0777A00EBC59378111BFED5F89DBE22DD067D8A5D1C1F3F3EC015AD';
wwv_flow_api.g_varchar2_table(3) := '86FEAAE00000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7758038842424775 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1borderTopLeft.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000150000001504030000005B39B8A500000027504C5445000000000000000000000000000000000000000000656565000000CFCFCFB7B7B7000000FFFFFF96FF543C0000000C74524E53800078583868109F';
wwv_flow_api.g_varchar2_table(2) := '30D7C718E289AB9F0000005249444154785E8DC6B10D406010C7D17F2EF46E03895263052318E1DBC0086CA0D31A452D379484E27E85C2AB9E1EDDEAEE8D5E36E65597BC7ADC4A5E135EE1866BC107BCD51FB1E371E0171E33BEE1E7C76FFB181607D27D';
wwv_flow_api.g_varchar2_table(3) := '175A0000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7758636470425825 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1borderTopRight.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000B0000000320806000000FCCF518D0000001974455874536F6674776172650041646F626520496D616765526561647971C9653C00000AEF4944415478DAEC5D5B6C14D719FEC137ECD8E035361787C66014';
wwv_flow_api.g_varchar2_table(2) := '1A2EA5126E5A356D95982E455C525AA4A86DA2A65221CB53D4F6A1AA5B449F1A8C1FA884821F705BA9A18E4915A04A534C2319DC848221C9D6A1D4405C2EB5C1C6368ED76137BE81E5CE77D8339C1DCFCCCECCEECCEE2CF349471EEFCECC37FF9E6FFEF3';
wwv_flow_api.g_varchar2_table(3) := '9FCBFC338388F690054C4D4DFD823CD8811912E2ED532595CA68F1397C7D21A95C8B96A0019D4C1934BACECAC5643F8C0A191B1B6365D6AC59ACB80810AE3F05A215E18B5E07BF96162342B60B6921E05BB76ED1F0F0308D8C8C4CFBAEA0A0808A8B8B69';
wwv_flow_api.g_varchar2_table(4) := 'E1C2850F330744F35CD4E3A613F87541CC6F46BDB3B3CD552A430854F6D5AB57E50A2E2C2AA2ECAC2CF9FB7B939314098765412C5DBA9489C02A47494989EC71F3F3F369747454F6C843434349E148821DCA10022209A4D8EB1A0D2D1A9422B63B844899';
wwv_flow_api.g_varchar2_table(5) := '80AF5FBFCE44830A2F292BA782FC5CCAC99A11D3A443587727A768647482866EF7320140844B962C31C581637C3E1F65E5E469724CDE1DA7502824EF6F94E3C6CD9B34D0DF6FDA8E79F3E7D3E7162D8A2760B7885753C41919037361A1128B0A0B256F34';
wwv_flow_api.g_varchar2_table(6) := '47753F16A34A7F8B1EC9A7BCEC290A47224C2C403C81891CC5BEB9EC1C7A1C924F6602CFCEC9B1C461D50E0D11733CE722F18A214543C6C6C0686E8D084B0934B9101880CA8747D56A86458EB2D252C31D355C4B4E56A9698E44ECB82FFC62BD9106B7A1';
wwv_flow_api.g_varchar2_table(7) := '327AED8E74EC663A6D1D624534B7A838A3952E0A0CC7E1781E736A71200CC0BE664719B03F8EC3F1F1386CB6C3EFE2811EC7AEDD5101A397CEBD90E87510479E3C7992156C739C3E73867D86BFA207E3C7F2F3A971141495E876C62E5DBA44E1CF4635BD';
wwv_flow_api.g_varchar2_table(8) := '248E8FC7A1B4432DC4D0F3C43A7654B92C74D01A6ACB2C01A3D985D7C108404C654A4DF0952B57A8ADAD8D8E3737336141B4FF686D659F95F862EB921F8FF3697120D68C77331D7AFD4F31378C087EBC1E87D20E11478F1E95AEFDACEE35E8D85149EE47';
wwv_flow_api.g_varchar2_table(9) := '65C60918BD6F0C31299B7534A91B366E64DBB76FDFA653EFB6D299D3A7D9FFCB972F6745D9CCA389571B6FD5E28060E111798168C0F5C6A143AA9ED20A07176353D321E6E12391700CA7924787C313703A8F42A801BDF167AAAB99D76D6F6F679F959595';
wwv_flow_api.g_varchar2_table(10) := 'D1BAF51B54C565161014BCB912E888EDDCB993B66FDF4E6BD7AE35CC218EF38AA1106E88898909F9666C6A6A92841CA1AEAE2EAAA8A8A0DADA5A231CBE0C10B02336CC4C85655A1557B5660DE5E6E6B20AEFE8E8A095AB5699EE20191520840B8ECECE4E';
wwv_flow_api.g_varchar2_table(11) := '1A1F1FA7FAFA7A6A96C217A3C0E484C8010F2F8A17801DDDDDDD3287870CF0C0F7EEDED5891BFF4267CF3E881BEBF7EFA7952B56989E1953E340D30E3185C3615531AD5FBF9E3646C3182B1C982286076F68B83F043A3838E8A92B534308BE9046443018';
wwv_flow_api.g_varchar2_table(12) := 'A423470EB3ED6DDBB651636323135A5D5D5D4CB3CB8F37CB81E6FBE9A79F91FFBF70E1DFCC33E6E5E54D0B1FAC7254555551201090455C5A5A1AC3A99CE830C26115D275F8A4E297AEC9542C2AD5C335E9FA5BA412F204AC007AEE68BA314120563CBCE3';
wwv_flow_api.g_varchar2_table(13) := 'DEBD7BD9F6B265CB98279C2379DDDF4A9F4164E8D16FDDBA35A6E2F934B4510E880B85430A4D595CBA6BD7AE699D44AB1C9CA7A6A686F64BAD07C2A1E79FFF81EE0DA0C591088E1D3BE6977E434BC35810FC810307025BB66C096EDAB4A9C513B0385C26';
wwv_flow_api.g_varchar2_table(14) := '89123D6E2CA211C3828E8B1769F3E667D97675F57D8FF5B5A79EA2FEBE3EA992C75911C117E1A885169C03D3B57AA147C5E20A76D368AD0EC3F1F138947670600A1A374673F371DDDF43CF8E54885704CE219D8BD25DC48E2FE641A8005859F5C5BD359F';
wwv_flow_api.g_varchar2_table(15) := 'BD123D6A2A38E039710358E540C70F378282038B792CD509C20678CF640A64C78E1D0D09841335762FE6717C1402A202B0F24B6B264C0BD81FC789E789C7A13611114F58463920BE44ECC0F17A1C16049CF4295C3BCEE9EA4E1CBC1506EFF9FADB499D05';
wwv_flow_api.g_varchar2_table(16) := '336AC2E2CB1DF58E5172186DA613E1B0C30E2BF16BB2EBCB8E73BA7E14822F534425A223835810D3AACA477CF8A33FF89E3FE96074ADAEC8212E79D4E21097385AE1B0CB0E0F6928605EF9E8C523D6E453A9A8540095CF8798442F6A36A61539204E14CE';
wwv_flow_api.g_varchar2_table(17) := '2122591C76D9E1210D05CC9B617460F8B36462258B4356893CAF96291C1ED250C01CA8545EB1763D312C72B8D90E0F692860119952E19E709DC14CEF27F0E009D8838787398410C74695E08FC427DA6B7722B1891376784823012B1382888947C48E10DF';
wwv_flow_api.g_varchar2_table(18) := '27194947301EAC9674A4B7B797956470D86187873413303C22046326210804505E5E6ED8531A4D9E8267F2440E33930C4ED8E121CD04CC2BDD6C421034CF380E8857F94E244F71C20E0F69266034B7BCD2AD2604C1F198B2B53BE948BCC42676DB611658';
wwv_flow_api.g_varchar2_table(19) := '8C9EECB50B38A7370A2120D18420109591C4264E244FB1DB0EB3C09314C9AE2F3BCEE95A016B250439FCF776DA77B09595B6F6FB373C961C36FCF99FF2E7FD839F4E3B3691A423E0ECEAFD44D34B268B43CF13EB7158145BA8B9B93969299D70AE747FB4';
wwv_flow_api.g_varchar2_table(20) := '282D129B3CB9FA31EAFCDF002B475BCE33B1BE73EA329DFFB8877DE69B5340F34B1FC49746129B14CED66F967B068669FFEBEFD1E56B7DAADF1BE1D04A6C829BAFB6E11D6A7DBF53F71AF438AC024F502443C43887F74891023CADA8728AB5A27C2E6DF8';
wwv_flow_api.g_varchar2_table(21) := 'C60A3A7EEA22EBA9D7379DA24F863F63DFCD2D7E84BEEB5F3DAD53A45CEFABE4C048800878767E4E00DBE07AB5F15DDABAEE8BF4CDAF3E619A436DAA185EFD0F87DB642EF10601DF9A958F19E24854C4814020E83DD469076156966AC56FAEFE025DBD31';
wwv_flow_api.g_varchar2_table(22) := 'C83C2EAFFCB1897BB4E37B5F9F16631A5963A0DCE7FD0B5DECDCD3BCE99D51FAF5ABCD74E2DC7F69F74F9F35CCA166076E12B420102A076E10D8D17D4BEAF40D7C4A1D6FFFCA941D898413527933D347211CEFC461E2400BDFDFB886FD8D8C8C5367D7A0';
wwv_flow_api.g_varchar2_table(23) := '1436CCA647E7DB33E00FE17E74B9873EFAB89786C363F4D6890BF4F26F0E5BB6E35F1DDDD4F8F60731E2857061C7D9F35D4CBC1E32C003EB2536D9D7F81E7DF89F1B14898A00A27AF1DB4FD213950B12E6B81319A39B7DC334327E8F86240F0F7189F8FC';
wwv_flow_api.g_varchar2_table(24) := '927954F392DF32C7E38BCB68F1A373A5EBEFA621E9E6B8131E95EDF090411E98792695841E07DF3AC7048B4A2F9FF7A0C3F6F22B47A63D346934E988889C9C6C2A9E9D4FE56545B4EAF10554989F2B7FB7F62BCBE8B5DA1762BCBD590E84393FDFE6A7A5';
wwv_flow_api.g_varchar2_table(25) := '1565CCDB72F17E69E5A29862D08E500668CB111BD222B1093A3A75BF3FC1B621AC3FEE7E81F6FCAE854E9EEB6462A895B6C5F8D44AD2919A97D6C5ECF7A39A83F461C74DFAA1E4E195DF59E500709D5F5E55413BF7FD8DFDFFDA9E17756F000D0E8C2556';
wwv_flow_api.g_varchar2_table(26) := 'B95CC08E4C8038EA81F9B8274FE8217BDFBF7E207BA85F06BEC53CE1EE9F6D923FEBE90B514FFF83A1A678894DD43894985D5840AFFC64B3AA7813E5F88E7F351DD9F7E3182F6F92E31AB91F8ED89092C42636250489E100F4567D212CD19A414B566213';
wwv_flow_api.g_varchar2_table(27) := 'DC745A9DD038894DF017BFAF5BD3AC227CA88BEA24B3129B601556321282E03C5A30923C454BBC4693A718B1434BBC06ED6821F7C2B16B777C14021E4B7CB120CD5B60682D012A7D70A04F4E08A2B78ACB89A4230ED8112477BEA9C8D03B945D2B604099';
wwv_flow_api.g_varchar2_table(28) := '100442C1D4AF9A0050E1913BC30925367122798A4D766022C26D2F3A7474F224A5AF9AE5EB6979CF1EC2C28B0631CB8589028CB54218FC31202B8BC0C57816B023E94892EDF05E35EB1601AB09402BDE74C3CBBEF96B67B5A0F37A593D017311A7E3CBBE';
wwv_flow_api.g_varchar2_table(29) := 'C5B041F565DF0F8580951E53395C956C38917424013BD404CC8198D89F46DE3814EDB00575749279EF4AD683130F3B3A9174C4263B828ACE5D650AC41C8A7A5C473B6B5AF8BF00030015B9F633044DE3E40000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7759333882427053 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1controls.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F60000FFFFFFFF5500FEFBFAFEE3D6FEE6DAFEFCFCFED0BAFEAA80FEB08AFED4C0FEF8F6FEEFE8FEAF88FEA87EFEBFA0FEEEE6FE9F70FE8B52FEAB82FEECE4FEF6F2FEA77CFEC0A2FEC8AEFE7836FE7B3AFE7F40FE9B6AFEE7DC';
wwv_flow_api.g_varchar2_table(2) := 'FEF7F4FEA67AFEC3A6FEFAF8FEDAC8FE7C3CFE9C6CFEF0EAFEBE9EFEA478FED3BEFEE0D2FE7734FE7A38FEC7ACFED8C6FEDCCCFEF3EEFEE2D4FE7430FECCB4FED2BCFEC4A8FEF4F0FE9E6EFEB692FEE4D8FEEBE2FEAE86FE6012FE5F10FE6C24FE5E0EFE';
wwv_flow_api.g_varchar2_table(3) := '732EFEBB9AFEEAE0FEE8DEFEF2ECFECAB0FEBC9CFEB896FE9662FEB38EFEB794FE8346FE874CFE8A50FE8244FE864AFEB490FEDECEFE8448FE8042FEDFD0FED6C2FE884EFEBA98FE661AFE6F28FE7632FE6316FE6214FECFB8FE905AFE8C54FEC2A4FEA0';
wwv_flow_api.g_varchar2_table(4) := '72FE8F58FE935EFE9764FE925CFE8E56FE6B22FE6A20FE681EFE702AFEDBCAFED7C4FE9A68FECEB6FE9866FE722CFEC6AAFE6418FE9460FE671CFEA274FEA376FECBB2FE6E26FEAC84FE7E3EFEB28CFE5C0C00000000000000000000000000000021FF0B';
wwv_flow_api.g_varchar2_table(5) := '4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B39363493820F17218305353A3B';
wwv_flow_api.g_varchar2_table(6) := '12990A101822168214223B3D359E900B111918190E00141AAD3F820B3740028E02121A1929183200363C3E28004228D12E8F131B1A2A30A300041C8213D12814901C231A223386422F283892242B31C1861D988F0A141D058DFA8B02060C1224941097A8';
wwv_flow_api.g_varchar2_table(7) := '0090010408221A70A041050F2658282201AE5B220208186844D04211B46816111548E0C0C28713201415C0412088C2440A14A4CCD4CF450744145E3A2AC001C58B698548AC0312E95BB4098240CCC4014EE72202D15E60123AE0E64714401D3DF0494210';
wwv_flow_api.g_varchar2_table(8) := '54144401F80A22EF110505836E440B028BA620A62810BABA2D246082DCB978F3EADDCB7752200021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E870F138F8E172A585B938B0A1156595C0599830B312D831D4C9D';
wwv_flow_api.g_varchar2_table(9) := '510AA100200D494A338214A85A512082A08F24464A4C50B20A54565A5DA00B3740BA8C05474B4D514C530055573C5E004228DB2E8F0B264B501A088252A50013DB281493401E4B4A1786422F2838A1423132CB841D3493203AAC6AC42F510B224590AC18';
wwv_flow_api.g_varchar2_table(10) := '88A800900104D825A2E020A10D2752149150C74111882116425AB8A148DBB68E8A80243020E3890045057010082271918082AC1ABAE8808842CD470582A078D1AD10897A40323D5027A9152E0038D4FD64C461DB8B7F4707F03489A2A8A3A32F480822B0';
wwv_flow_api.g_varchar2_table(11) := '2D290064415E4E1238E8C6B620831570864A874248CE860BBCDEDDCBB7AFDFBF800705020021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E86244E3F148F8D123C650C958B1D4B3C664A209B8342322883344D3C';
wwv_flow_api.g_varchar2_table(12) := '674C0AA3002008606343821D54AB50A2001D952E5F61646017B064AB5C050A123340058E054462635D5D2C003F3E681F0036622D282E8F240C625C1148000221218255532828948F1308D23186402F2838A32E2753CE0C75A0B109C42E4601179190B162';
wwv_flow_api.g_varchar2_table(13) := 'C59483870A001940405E2216432EAC98C141110978283A2A7A72A2E4097E898480149988C200142F9A292A808340108B335F3D73D1EB10059CCF82C00C5788843E209B16809C20C8A0201C20812E120A93A0D101BD54C223EAC8C58017240411808714C0';
wwv_flow_api.g_varchar2_table(14) := '821B4104143C7883ECA0843A13014C8027246EC4055CEDEADDCBB7AFDFBD81000021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8624550E148F8D08583E47958B0A63586E5D209B8305374183146458684A0AA3';
wwv_flow_api.g_varchar2_table(15) := '822B5F105B821D5CAB11A2000F1D8F05365F1B1B6C002046AB46050A0D6E11388F171E5F6B6D2D000E19186F00485A3D70538F2E3F1E10620E00052D69826D3D654734950B44E52786475844CF9B142169050C090022AF5201018E023202F182C5141408';
wwv_flow_api.g_varchar2_table(16) := '131500328000254538D68550B34011091420392C9A0012A40B45424A8A542400C78D1B131615C04120C84599AF12BAE87588C24D5F4150BC385988C40B1440367D0419B358441C257F322229549ED11BBD529AAC4461C000128208804C0A6081A9888F04';
wwv_flow_api.g_varchar2_table(17) := 'A0BD3196544E42541085BC3D546001D1B978F3EADDCB576F200021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E864216431D8F8D48512245958B0A6B511971209B84200A831D621A1960A6A3000F444E6A829D1A';
wwv_flow_api.g_varchar2_table(18) := '2A63A2000B2E950908070D090020101A1823000A12294A1C8F4F360C0D1E280033505143005572593A3F8F1D174E391E2B0005524F8223DE3A17952EE3392C8636703B61149B1D282F87200CBC11E2AA510183136EDCC0B1A800900104F6297281A2220A';
wwv_flow_api.g_varchar2_table(19) := '1A8A48587436D1E24545423636C4A170C248024124362C68D005A54314543E2A10C41FAF42245EA000B249634593C30408C2615126A309155F60CC798352C88A371D292030808420021579EABA014468A5020705DDC83A282C4B004851103C5BA80089A8';
wwv_flow_api.g_varchar2_table(20) := '6C08E3CA9D4BB7EEA8400021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E862E2B6C0A8F8D25115433958B2026114D23029B891D739F622082202F0F954F6C28820A7411506BA20B5F6E51528E135E3F48690002';
wwv_flow_api.g_varchar2_table(21) := '0D114974000A5F6567724EBE2B16454E04007560116C003F76CE56758E20536F0E365B00052FB1024666727046148F146A6F25BD8547F046249B2041821CA2F0C68290518D405028D08804010213161568D18240874514506844414311898D1C306EE4A8';
wwv_flow_api.g_varchar2_table(22) := '480848460F6EDC88A8A8000E02402E326288B0510117320D5198B7A94010142F5C1822B10EC8A68F1A5982100500C7469E8E1E687CD191E88D8B26350A7D0482C0007F000868340A60C10D204C2BD1047063ECA0B53514014CD07830AEA10224B6DADDCB';
wwv_flow_api.g_varchar2_table(23) := 'B7AFDFBF7D03010021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E860503038F8E6C236D32948B200C6D6307059A890A779E5F2082203243148F24280FA99D5C740200241E296E478E0A6A31179302476D5C1200';
wwv_flow_api.g_varchar2_table(24) := '0A1530687663B68C1D21AB333800322346990E29CC3C3F8F1C2C062B210005379305236E76651BAD8E20042C5B1C864557656B249A05240B87285CF8E04254231038F831224180C0844513C0D8C960609182172832D25084E4CC151F6D508DC2A8511101';
wwv_flow_api.g_varchar2_table(25) := '360958DC60B4E0C68D878A0AE020004481C19B880AB8E88088023C4A0582A07851B010098C4034BDCA0813C4331C1951FC6CF420E38B8D476FF01412B5683C02371412C89814404B20CF800EBA417650289C821126641402171209AF75F3EADDCBB7AFA8';
wwv_flow_api.g_varchar2_table(26) := '400021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8720028F8E41453F40938C1F155F1F998A023F15100C920002096C1D8F054234820244A3079242775119488F414F213800050E153547052039782A2962A68B';
wwv_flow_api.g_varchar2_table(27) := '022F282D5324002177742D0033B829580E8F402852213782139805741929305FAB8E201CE20B8644293E104299ADAF861D752B5C7C6A0462823E4642081098B0684218371A642C02010D058A7E88F2E8D8984481228A162F2A3AD2A36413108B16DCB8C1';
wwv_flow_api.g_varchar2_table(28) := '50D1030F54A8841808AA59A3022EDE19A240E1538120285E082C44021AA6492442B68C240847C89E8F1E587CF1AAE88D5542420E8547E0063500042C1E5509A480CF4137C40E324B73D0048B070FDB162A4062ABDCBB78F3EADD8B37100021F904090500';
wwv_flow_api.g_varchar2_table(29) := '00002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90870A69210A918B53480C32978905439A3F0582022C321D901D9600021748393602002E47114D258F132F03420005754877B8204E54504C10B28C053728282F14002F3F082F';
wwv_flow_api.g_varchar2_table(30) := '00435D4D4C1A338F40CE280F8224E20512DA7815A88E201CCF2E865E4C781EF090052ED1861D5B75349D8C404CE8C54808010213163D688381099B45020680FB97C8861C2B569480501471A2221B59426A5C64F04642450FC48858F210E0A102149439C2';
wwv_flow_api.g_varchar2_table(31) := 'B7CE10057DF782BC3344E2050A209148803B0942190E70381B3D70F6E25FCF1BA88480B3C78EC00D12820838030A60C10D1CA3228505D0ECE7A0B12E273823E8B2500112540ADBCA9D4BB7AEDDB981000021F90409050000002C00000000200020000007';
wwv_flow_api.g_varchar2_table(32) := 'FF800082838485868788898A8B8C8D8E8F9088240B918C1C433337958A2C170E4383022F6A0A90202082059D251F050034446D631F8F242F03428269174417000225465C5D0DAE8D1C28282F14004075161C0006B25D4BBE8E38C9280F823424824E635D';
wwv_flow_api.g_varchar2_table(33) := '5439A58E20C82F34861764E4EB90052ECC860A275BF09B8A020F4142C689841020306111901A1A5424F992CF908001DA1A1ABA63A7228F2B32121580984C62210466429AB16340910B02370A2A7AB0210A13264E04E83354A083CD47F23A2062314467BC';
wwv_flow_api.g_varchar2_table(34) := '20CA5C182291E04B1BA1B5B4A90421134036290E50407A904C1D005B37740AD196EB110894DF0010480644D0821B3800E21C7483EC20B5FA132624EB3AB350011248EBEADDCBB7AF5FBE81000021F90409050000002C00000000200020000007FF800082';
wwv_flow_api.g_varchar2_table(35) := '838485868788898A8B8C8D8E8F90882002918C424F2C24958A0469322C83051C409120058337690632821D6F1E262D8F422F3742829D5B5300052B26106B0E8F1C28282F1400422D0613006A15C0625B8F38C5280F820A34820E5F6B46480A8F20C42FDB';
wwv_flow_api.g_varchar2_table(36) := '855B1B7136E78F052EC886202C27F19B8A020B4040F6884204049A29E230874A12266250241230C05ABB433952A4C04211C22944041C2ABAE3A66347088A5C10B82130110E084A94509943E09EA1021D625E64F4AEC321104386D8845420883117861C68';
wwv_flow_api.g_varchar2_table(37) := 'D13206E82312D6044E1294068A1E1D31203D28660E00895A368518C0A387082410233501C88882148005322A947487AA98595E2E14074D28762B6EA102248CDADDCBB7AFDFBF9B02010021F90409050000002C00000000200020000007FF800082838485';
wwv_flow_api.g_varchar2_table(38) := '868788898A8B8C8D8E8F908805918D1437040A948A1C28281C8420939005A200049D2F820A094417998E3437374282A75203000532473907288F41A814004203282E0052360C0D0D9F8E389D280B8220AF75CC265EA58C209C2FC3856A07740E1D91052E';
wwv_flow_api.g_varchar2_table(39) := 'E185204F21E79A8B02243838EB882E0404138B40076364BA40C095E854271A8A8E3089C2508307450651204C942783458B0F13512070839FA2091EC8800153E1593C42053A7478D5281DBC420262C478E9A840B017C80A31B022C7484E4724A479042140';
wwv_flow_api.g_varchar2_table(40) := '50981D5AACB081F4001542122F6E9C43A203A90348203892A8D5090800050DDC88F1386AD08DAE831E143D096042275A6C0E0B1520F133AEDDBB78F3EAA514080021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E';
wwv_flow_api.g_varchar2_table(41) := '8F909192840A40400293894028280F9983050583049C1C8205035304901D37374282A42841824F330E0E348F389C2F1D004203031400412B0E45552E8F139C280B820220822C1645477590201C282FC485525579170A91052EDF85023703E59F8905420F';
wwv_flow_api.g_varchar2_table(42) := '0FBF8A140404138B1379356D620D562592854257A21F64BA74891021872282061115694291E21D7B046EE853F4E08E988F3968BDA3A4C05DA373F5D46DD992D2518120DD9615CAC3E3CA86888D4838DB080213002356CED83100E9412F5D245EDCF855C4';
wwv_flow_api.g_varchar2_table(43) := '4A502FDA329288C50908000512B07031656ED08DAA83164C7BD70C05AC91840A909089B6ADDBB77004E3360A040021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840A40380293893828280F99830505';
wwv_flow_api.g_varchar2_table(44) := '83049C1C83241C14901D37374282A4284182402C062190139C2F1D00420303AA242132756C988E0F9C280B820220821CC533B88F021C282FAA8538751F09D090052EDB863841E19F8805342424C889140404138B0B44071E2648408AB12834147DD8B0A6';
wwv_flow_api.g_varchar2_table(45) := '8D4124FE96054CE460CC98300E6D289277A39E221247BE7C99630387BA420A14A46334AE97210A6F2E987C5420483617868EB8C132E7D52312CB2C820828800B0F343EE82878A42C5B40122FBEB0018084078F2B584E3C0241E0060958283C9029A0E04B';
wwv_flow_api.g_varchar2_table(46) := '99A75E22891274030591AD006878C0A264C0275D17148880E270F55301120B467EDCCBB7AFDFBF9002010021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928402130B0593893828280B99839883049C1C';
wwv_flow_api.g_varchar2_table(47) := '83142E911D04374282A3284182132F283890139C2F1D0042030314BC9C2D2F900B9C9D820220B2282D6A4090051C282FC085422D5328A18F052ED68642979F8BA71DDC88140404138B422B454E361FAD89AF28348A31070D15151E5B14DDCB97E8C29783';
wwv_flow_api.g_varchar2_table(48) := '0763285277A39D22214424DCB9E30015394220327673B1CB908B156C3A760B42CD22211B19343430D988C431874F4A29E08245059E0322193DC8950F880A3401ABF8C082018F974720569110F442C58E31054078188A61848068835AF8D841069310083E';
wwv_flow_api.g_varchar2_table(49) := '52FCF8F4E28A8E22A6D884FC44E148959C1708E3CA9D4BB72EA4400021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A3828280B9888049B1C831D1D910A1C044282A0284182132F2F978F';
wwv_flow_api.g_varchar2_table(50) := '0F9B2FA54203031400429BAD900BBF9D000220AFBFAA8F051C282FBC85BE283892052ED08614349E8C0A14C78B140404138B1D532B1F2B528BAC28DB892C554548483FF09FBFF887530CFE0C365C281277A3DCC037486C1061C7AD9000050296B9286588';
wwv_flow_api.g_varchar2_table(51) := '460C190A221508E24C60A11F4D2220D8C788C4AF72025AB802214603142A792836AAE56C5B0E39580C0070204243122A2B1E812070E31205153AE01829004242CF24260A40920A80048CA461A4BAF020228A054F6D92FE1844C100464F138EFC90D9B0AD';
wwv_flow_api.g_varchar2_table(52) := 'DBB77004E3460A040021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A1328280B9888049B1C832020910A1C044282A02841820F2F0334900F9B2F1D0042033714B99B2838900BBF9D0002';
wwv_flow_api.g_varchar2_table(53) := '02829A9BAA8F051C282FBD85429BC191052ED28614B39E8B0220058C14040413DF2F6A092CCC89AC28DD883775431717278BEFF1875216FE16061651E070E39CA20E0666BC8971C95B2101E29AB9C06588860C35A520150802CD85212F63DA54D1D688C4';
wwv_flow_api.g_varchar2_table(54) := 'AF73029E000100E24B042E71AA2878540BDA2C043C44E0FB4025029838311E812070E312053C56CA6C2800228F129F39223A8A280443D236E268DCA1D2E58DA71156789418D421CD94999826D87080D6A1DBB77005E3CA9514080021F90409050000002C';
wwv_flow_api.g_varchar2_table(55) := '00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052442938A0F28280B9888049B1C832005910A1C049700A02841820F2F371D909A282FB34203371400429B280F900BBF9D0002028213BFAA8E051CB6BC85422F283892052E';
wwv_flow_api.g_varchar2_table(56) := 'D1861D349E8C05A58C140404138B0540030340C88AAC28DD890F4F2D6969D6EEBFF1884132FE32AE1451E070C39C22102D4E9C9002C29B217090B0CDDAC6E249C3884150480961E802040F1F263A72B1E9C81C632150183BD0A6069D0F171B697A83C50B';
wwv_flow_api.g_varchar2_table(57) := '00273EF0180030244E9B1173123C02F1420C03011492D88161C25895303F7F4012500C07163B3EDA20A3E0C4489B189816A8C0AA5590828D3123515062C7CD1D8785102EE0A192066EA10724ECEADDCB9750200021F90409050000002C00000000200020';
wwv_flow_api.g_varchar2_table(58) := '000007FF800082838485868788898A8B8C8D8E8F9091928405242E938A0F2828249888049B1C830205910A1C044282A02841820F030420909A282F1D0042033714B99B280B900BBFC100A48213BFAA8F051CB6BD85422F283892052ED0861D349E8CA58D';
wwv_flow_api.g_varchar2_table(59) := '140404138B0540BBD58BAC28DC89C3BFD99FBFED88EF9BF187141C37E48A05412F06A4EB46F05A10018640A0B8811052B322587E1892C1C0C6160590842030B30382B1342F8C39A970E7089B868D6658E901670680221994240060600EC93C2D1EA5C9E0';
wwv_flow_api.g_varchar2_table(60) := '268F800E4B52E0B963CCCB1C0F12D84022F14010092629447C29D5C182893B52303D8D5AE39B801BAE30B9689222830982853C447D8396D082126F0830B69D4BB7AEA0400021F90409050000002C00000000200020000007FF800082838485868788898A';
wwv_flow_api.g_varchar2_table(61) := '8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820F031C02909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BAC48BAB28DC89C2';
wwv_flow_api.g_varchar2_table(62) := '9BB6EABEED8842BEF18A141C37E48A0538043800EB4610480919B20A090882E39BA309497AC829612884831569123AAAB243079C3900043CB92168868D121F5A4032A1234B991500883419C302801A0436887C78F0A88586144E047418136589130005EA';
wwv_flow_api.g_varchar2_table(63) := 'E0240204929074429644A1728014882D3F0C80C014358A920ADF6E79A241C6EB1D8285EE78AD839610890F7508B6B69D4BB7AEA0400021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F';
wwv_flow_api.g_varchar2_table(64) := '2828249888049B1C8305920A1C044282A02841820B374102909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BA9D8BAB28DC89C29B03B28AEBED8842BEF18B141C37E4';
wwv_flow_api.g_varchar2_table(65) := '8A05380870A8D7AD1B0E0727E415227129D20425597858307443068B20DF1A1D8123A74C0500055EB4027062C59629231D799063C6CD10005EB8D47802408A85156CD48078F4040A9E220214ACE962A404C8295E569CD8F9480831002EC2748973849480';
wwv_flow_api.g_varchar2_table(66) := '1709AA617211A74B983C19BBD110E3D546C14247BC1A381BED8201A66C06E3CA9D0B20100021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A0';
wwv_flow_api.g_varchar2_table(67) := '2841820B3740A48F9A282F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28C140404138B0540BAA98BAB28DB8924BE37DE88036A09319D8942EFF1872D614D26B71215C0412008BB451D84ECE34608';
wwv_flow_api.g_varchar2_table(68) := '079121200EB9B814294817336E1C18A215EB11893065AEF89000A000016A0050849082E2C1230721DDA85801E0420D0903000439B192C0230976DCA4C823408189352668A6E429CA919408518ADCA251630D1D8D2581005100C9C538413420AC99438421';
wwv_flow_api.g_varchar2_table(69) := '210A73D67CB160969003B56A0DDA0EA220838500B978F3E60D040021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820B3740A48F9A28';
wwv_flow_api.g_varchar2_table(70) := '2F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28CB937138B0540BA978A42604A3512378A24BE048B24293D3D3B1FE8F18C174C2935D80A15C0412048C0431D5C78E36668828518200EB9380709C8';
wwv_flow_api.g_varchar2_table(71) := '181F2AF215828722D623216D7CA410910700396200800C7BE404C6482875006C9150A5154714A21A81E0922243140705403068E0E484A009D21E3C629041839388142434C8135310058A8D28C838A1C0EA9D060886302404220FD82D63091938E024675A';
wwv_flow_api.g_varchar2_table(72) := '931C07A8BD9D4B976E200021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202';
wwv_flow_api.g_varchar2_table(73) := 'B10013BDBF8E051CB4CA83422F283892052ECF841D349142A88DC68C2B18306B9D890540B9DB8A42183BEF6F8A24BD048B241959597033ECBDA28B439A889883AD50011C0482143CA4C005B851861ECC3000E21085858B70B41101E5822112D2603D1202';
wwv_flow_api.g_varchar2_table(74) := '010F132A555A5D020044D8A32A269570310040CD8F21C384F402E208441B264DBACC28208048911952043D78F1C25B23274D2210A948C346910F2C06755000A9C314355C01742852C48B1A8884047C286201055A42380D2E2458F756D0C3BA78F3D60D04';
wwv_flow_api.g_varchar2_table(75) := '0021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202B10013BDBF8E051CB4CA';
wwv_flow_api.g_varchar2_table(76) := '83422F283892052ECF841D34912EA88DC68C432218239D8905400304D8864278567070178A24BDA28A42516666656FF8F68C627449E2811D251C04821834A48006B85186165C4820E01085858A26CC51C2858D2112D280407251810A99385E04D1502008';
wwv_flow_api.g_varchar2_table(77) := '482F6F8D1C2C211366841A005262A4D925A4D7044720E6D05C13A380802143D45003F0E0C5008C86888469F3A662871943A6DC2305025287102D8C81B83024C1568882580C39310CED2005370A7EBA9D4BB7AE5D4381000021F90409050000002C000000';
wwv_flow_api.g_varchar2_table(78) := '00200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A02841822404400590322D282F1D0042033714B89B28BC8F3910B40B8202B10013BEC08E40505F4FCC83422F283892380EC587';
wwv_flow_api.g_varchar2_table(79) := '1D348F052E2442028DC88A245F1A19221BA88905400304B7895E76763C3C650EE7BEA28933DC0814E84591105FAC1291A0D304CA920697DEE178A56051251211472122C12604394314A4395A70204E8D048648540302890682381BE8D411A400842020BE';
wwv_flow_api.g_varchar2_table(80) := 'DC357A6364C31C094F00047932E0D6C14DDB180990B0E14B8513000AB0A0C512C00379151DCD70CA869C0035B4FE01380649819417C80AA4A1AAB11090272F0D44B6A590B5ADDDBB78F32A0A040021F90409050000002C00000000200020000007FF8000';
wwv_flow_api.g_varchar2_table(81) := '82838485868788898A8B8C8D8E8F9091928405422E938A0F28282498831D0583049B1C9E00694D3F4282A3284182240440A18F733D29061D0042033714BB9B28BF8F123B3D460F8202B413C1C38E38493B654F86422F283892383F6CB4851D348F053496';
wwv_flow_api.g_varchar2_table(82) := '028DDF892C1B4D4C495F9D8905400304BA88204658FB3030488A2482BDC2B7218341830E1409090644518B0D64C88C61100F51011CB2402C022144883853895C2478926E1085678F48389973A7852112D81A3EA25085CE813C090481D0080047B08F8DD8';
wwv_flow_api.g_varchar2_table(83) := '983880E0C70D003007E85AB869C123220718207109A095CC05F578365293A7889A50056E6C1A08A0404946139289DAA40D24215E040D14B82D6476AEDDBB78F31E0A040021F90409050000002C00000000200020000007FF800082838485868788898A8B';
wwv_flow_api.g_varchar2_table(84) := '8C8D8E8F9091928405422E938A0F2828249883144283049B1C9E002D4D294582A328418224044005901E593A56060042033714BB9B28BF8F0C705A3B128202B40013C1C38E385470671786422F28389213255BCC851D348F05344234E08AE9886973644B';
wwv_flow_api.g_varchar2_table(85) := '111EA189054003041D89203551511A1A7888282211EC152201749A2854384391906040144931D1A6CD081BF31015C0210BC422102E5C40337588469A1BEB045118E9C885853C3F6E1822912DE223106F8E54F9804210088F0070041BE70885932A5E623C';
wwv_flow_api.g_varchar2_table(86) := '00407340BE879B3A15AD62E1C200569B6C2EB807B49182136C640228706393C1B129190920C461D30292850E2870E0D015AEDDBB78F3EA5D14080021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405';
wwv_flow_api.g_varchar2_table(87) := '422E938A0F2828249883344283049B1C9E002D50195582A3284182240440059007665665320042033714BB9B28BF8F473C6756398202B40013C1C38E13643C767586422F283892135E32CC851D348F05142E34E08AE988520762617139E389054003040A';
wwv_flow_api.g_varchar2_table(88) := '8902155D5D114B4B2E2822110C88BE3B6312261CA24848414503189830D1C0C13C440570C802B14800051A1D4C29EAF0C2E0210AD01E5188E185CD034324B2997C74E2439D29DB0080E00800C7B3472456D439F1645CCC01211D6EBAE4C8051B19695E02';
wwv_flow_api.g_varchar2_table(89) := '686572C18D200220D9EB04A0C08D4DAF04AD9B1464D30291851404993016ADDBB77005E3CA4514080021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840F172E93840B13845F4D522498005349782582';
wwv_flow_api.g_varchar2_table(90) := '142A4A521CA1156E576E4400141964284182240440058F4E306E766806004E6D3714004228CCC98E0F6130683C158213BD0013CC28CE8E37D13E1686422F2838920F1F1702871D3490EE14D88BF3892F477310104EEF890540030828482420CF9A366DC4';
wwv_flow_api.g_varchar2_table(91) := '1861A388C43620FE907C99389158A265CC2026E2500501022717BA1D2A8063178845023A5018184A91021C42105110E9084488044F2E1522514EE3A317539EA0D80400C4490038B6D1741942E88B773C077450B64D67A3020350BC0005804046410B6EE0';
wwv_flow_api.g_varchar2_table(92) := 'A8C748C102AB3798E11244761210660B0F5A1A1230E19ADCBB78F3EADD8B29100021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B45330A938242172184743B3A479902071822168214783B3D2699';
wwv_flow_api.g_varchar2_table(93) := '345C19292A0E00141AAC4482240440058F0C1A1958183200363C5828004228CE148F131B1A2A301282040F8213CE28D08F1C231A223386422F283892242B3102871D34900A141DBF8CF78A421639121225DF101500328000A644431A54F0E0C144024524';
wwv_flow_api.g_varchar2_table(94) := 'BA0151148381458B2CF44954E4828D03071F4E74505400472F108C1428409969910017230F5108F8A80007142F5C1822816E22246ECE260802C11247379A8C08387B218FE78091CD9E410282930436673E17DC5007A9808B83006E380B32285F4BA328AC';
wwv_flow_api.g_varchar2_table(95) := 'B63424E081DAB57007E3CA9D4B576E20003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7760031079428373 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1loading.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000280000002808060000008CFEB86D000000644944415458C3EDD9B10DC0300CC4C01F41237B438FA21198C6459A944114809CE00075AF240950C0029AEFEB63A9DC709B796DA072B4535B1972D6C77387E1';
wwv_flow_api.g_varchar2_table(2) := '09142850A0408102050A142850A0408102050A1428F055600FF6F52F26E0D923FAF437C405F1FDCBC98CD47AF60000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7760721805432633 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1loading_background.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D494844520000001E0000001E0403000000C91EB39100000030504C5445FFFFFF0707070808081414141717170000000000000000000000000000000000000000000000000000000000000000006E6A76E400000041494441';
wwv_flow_api.g_varchar2_table(2) := '54789CECCEA10D002010C5D0AE503620B7C1850DD87F2724F91A8BA979A6B48E75C3D4DA372437C993644996644996E44172F1FF9EFE0E000000FFFF03002A7338C822DD04790000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7761419433433658 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't1overlay.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D494844520000007D000000320803000000465024AE0000004B504C5445BFBFBF9F9F9FEFEFEFFFFFFF8787870F0F0F3F3F3F7F7F7FDFDFDF808080000000CFCFCF979797B7B7B76F6F6FAFAFAFE7E7E7F7F7F72F2F2FA7A7';
wwv_flow_api.g_varchar2_table(2) := 'A78F8F8FC7C7C75F5F5FD7D7D74F4F4F00B3460C000001AA49444154785EEDD5D96AEC300C00502DDE9D7D96F6FFBFF47AC284D2B1CC44507A1F6A3D2460111D142205F87F46D7BB7E9381DBAA03C2225384087C4324495F8728037110F875300F643175';
wwv_flow_api.g_varchar2_table(3) := '126216F5102332C618047D31B1A5C702D54439DD1F0221352AF55CF0888897EFC88C88255175B3BB263F2E8BA0C7CBAAD1211EF1D2F711A3C4C71A3F6A0D745E1F634B7FC72F2CEBD1D0691D7E5E1FCEEB9CDFE959F9E671E5B3FA516C0480974A00E36E';
wwv_flow_api.g_varchar2_table(4) := '48B881E657372B278E86F6C40DA49CB8CC4A9DD7B9A18BE3B398E7B6117A3781B57A7BD3CA9B8BE8B8550AB11804F0C11F00D4FF715DFFEDE87AD7BBDEF5AB0C5C495932CB5470CEF3D5B920E9B42519489BC0D3661F48B675D227147548C9B14B09043D';
wwv_flow_api.g_varchar2_table(5) := 'DBD4D253816AA29CEE0F79213529752C7872CE7D7E47EEE5A824AA6E76D7E2E392053D7D9246F7E98897BE8F98243ED5F8516B0BE7F529B5F4777C66594F369CD6FDCFEBDB799DF19D8ECA37EF88CFEA47B1C97BFF52C9FB693724DCFAE65777574E5CD8';
wwv_flow_api.g_varchar2_table(6) := 'DA13B705E5C4212B75A67B4317C727DBE7B6117AB7C05ABDBD69513C0DE1B8554A603182F733CFDE87BFF88FEB7AD7BBFE0F185E5A60ACCE5D1E0000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7762144437437289 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't2controls.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F60000000000E2E2E20303032323232020200101013C3C3C7070706767673737370707071313136868687171715353531515157E7E7E9999996E6E6E1717170A0A0A737373515151474747B1B1B1AEAEAEA9A9A98383831E1E1E';
wwv_flow_api.g_varchar2_table(2) := '0808087575754E4E4E050505303030ACACAC818181111111555555777777383838272727B3B3B3B0B0B04848483131312C2C2C0E0E0E252525B7B7B74141413A3A3A4C4C4C0C0C0C8080806060602121211818186A6A6AD1D1D1D3D3D3C1C1C1D5D5D5B9';
wwv_flow_api.g_varchar2_table(3) := 'B9B95858581A1A1A1C1C1C1010104545455757575C5C5C8A8A8A6363635E5E5EA3A3A39E9E9E9A9A9AA5A5A5A0A0A06161612A2A2AA1A1A1A7A7A72828283535359C9C9C5A5A5ACACACABEBEBEB5B5B5CECECED0D0D03E3E3E9191919797975050507C7C';
wwv_flow_api.g_varchar2_table(4) := '7C9393938E8E8E898989909090959595C3C3C3C5C5C5C7C7C7BCBCBC2E2E2E333333858585404040878787BABABA4A4A4ACCCCCC8C8C8CC9C9C97A7A7A797979434343C0C0C06C6C6CAAAAAA656565D7D7D700000000000000000000000000000021FE1A';
wwv_flow_api.g_varchar2_table(5) := '43726561746564207769746820616A61786C6F61642E696E666F0021F904000500000021FF0B4E45545343415045322E3003010000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B39363493820F17218305353A3B';
wwv_flow_api.g_varchar2_table(6) := '12990A101822168214223B3D359E900B111918190E00141AAD3F820B3740028E02121A1929183200363C3E28004228D12E8F131B1A2A30A300041C8213D12814901C231A223386422F283892242B31C1861D988F0A141D058DFA8B02060C1224941097A8';
wwv_flow_api.g_varchar2_table(7) := '0090010408221A70A041050F2658282201AE5B220208186844D04211B46816111548E0C0C28713201415C0412088C2440A14A4CCD4CF450744145E3A2AC001C58B698548AC0312E95BB4098240CCC4014EE72202D15E60123AE0E64714401D3DF0494210';
wwv_flow_api.g_varchar2_table(8) := '54144401F80A22EF110505836E440B028BA620A62810BABA2D246082DCB978F3EADDCB7752200021F90400050001002C00000000200020000007FF800082838485868788898A8B8C8D8E870F138F8E172A585B938B0A1156595C0599830B312D831D4C9D';
wwv_flow_api.g_varchar2_table(9) := '510AA100200D494A338214A85A512082A08F24464A4C50B20A54565A5DA00B3740BA8C05474B4D514C530055573C5E004228DB2E8F0B264B501A088252A50013DB281493401E4B4A1786422F2838A1423132CB841D3493203AAC6AC42F510B224590AC18';
wwv_flow_api.g_varchar2_table(10) := '88A800900104D825A2E020A10D2752149150C74111882116425AB8A148DBB68E8A80243020E3890045057010082271918082AC1ABAE8808842CD470582A078D1AD10897A40323D5027A9152E0038D4FD64C461DB8B7F4707F03489A2A8A3A32F480822B0';
wwv_flow_api.g_varchar2_table(11) := '2D290064415E4E1238E8C6B620831570864A874248CE860BBCDEDDCBB7AFDFBF800705020021F90400050002002C00000000200020000007FF800082838485868788898A8B8C8D8E86244E3F148F8D123C650C958B1D4B3C664A209B8342322883344D3C';
wwv_flow_api.g_varchar2_table(12) := '674C0AA3002008606343821D54AB50A2001D952E5F61646017B064AB5C050A123340058E054462635D5D2C003F3E681F0036622D282E8F240C625C1148000221218255532828948F1308D23186402F2838A32E2753CE0C75A0B109C42E4601179190B162';
wwv_flow_api.g_varchar2_table(13) := 'C59483870A001940405E2216432EAC98C141110978283A2A7A72A2E4097E898480149988C200142F9A292A808340108B335F3D73D1EB10059CCF82C00C5788843E209B16809C20C8A0201C20812E120A93A0D101BD54C223EAC8C58017240411808714C0';
wwv_flow_api.g_varchar2_table(14) := '821B4104143C7883ECA0843A13014C8027246EC4055CEDEADDCBB7AFDFBD81000021F90400050003002C00000000200020000007FF800082838485868788898A8B8C8D8E8624550E148F8D08583E47958B0A63586E5D209B8305374183146458684A0AA3';
wwv_flow_api.g_varchar2_table(15) := '822B5F105B821D5CAB11A2000F1D8F05365F1B1B6C002046AB46050A0D6E11388F171E5F6B6D2D000E19186F00485A3D70538F2E3F1E10620E00052D69826D3D654734950B44E52786475844CF9B142169050C090022AF5201018E023202F182C5141408';
wwv_flow_api.g_varchar2_table(16) := '131500328000254538D68550B34011091420392C9A0012A40B45424A8A542400C78D1B131615C04120C84599AF12BAE87588C24D5F4150BC385988C40B1440367D0419B358441C257F322229549ED11BBD529AAC4461C000128208804C0A6081A9888F04';
wwv_flow_api.g_varchar2_table(17) := 'A0BD3196544E42541085BC3D546001D1B978F3EADDCB576F200021F90400050004002C00000000200020000007FF800082838485868788898A8B8C8D8E864216431D8F8D48512245958B0A6B511971209B84200A831D621A1960A6A3000F444E6A829D1A';
wwv_flow_api.g_varchar2_table(18) := '2A63A2000B2E950908070D090020101A1823000A12294A1C8F4F360C0D1E280033505143005572593A3F8F1D174E391E2B0005524F8223DE3A17952EE3392C8636703B61149B1D282F87200CBC11E2AA510183136EDCC0B1A800900104F6297281A2220A';
wwv_flow_api.g_varchar2_table(19) := '1A8A48587436D1E24545423636C4A170C248024124362C68D005A54314543E2A10C41FAF42245EA000B249634593C30408C2615126A309155F60CC798352C88A371D292030808420021579EABA014468A5020705DDC83A282C4B004851103C5BA80089A8';
wwv_flow_api.g_varchar2_table(20) := '6C08E3CA9D4BB7EEA8400021F90400050005002C00000000200020000007FF800082838485868788898A8B8C8D8E862E2B6C0A8F8D25115433958B2026114D23029B891D739F622082202F0F954F6C28820A7411506BA20B5F6E51528E135E3F48690002';
wwv_flow_api.g_varchar2_table(21) := '0D114974000A5F6567724EBE2B16454E04007560116C003F76CE56758E20536F0E365B00052FB1024666727046148F146A6F25BD8547F046249B2041821CA2F0C68290518D405028D08804010213161568D18240874514506844414311898D1C306EE4A8';
wwv_flow_api.g_varchar2_table(22) := '480848460F6EDC88A8A8000E02402E326288B0510117320D5198B7A94010142F5C1822B10EC8A68F1A5982100500C7469E8E1E687CD191E88D8B26350A7D0482C0007F000868340A60C10D204C2BD1047063ECA0B53514014CD07830AEA10224B6DADDCB';
wwv_flow_api.g_varchar2_table(23) := 'B7AFDFBF7D03010021F90400050006002C00000000200020000007FF800082838485868788898A8B8C8D8E860503038F8E6C236D32948B200C6D6307059A890A779E5F2082203243148F24280FA99D5C740200241E296E478E0A6A31179302476D5C1200';
wwv_flow_api.g_varchar2_table(24) := '0A1530687663B68C1D21AB333800322346990E29CC3C3F8F1C2C062B210005379305236E76651BAD8E20042C5B1C864557656B249A05240B87285CF8E04254231038F831224180C0844513C0D8C960609182172832D25084E4CC151F6D508DC2A8511101';
wwv_flow_api.g_varchar2_table(25) := '360958DC60B4E0C68D878A0AE020004481C19B880AB8E88088023C4A0582A07851B010098C4034BDCA0813C4331C1951FC6CF420E38B8D476FF01412B5683C02371412C89814404B20CF800EBA417650289C821126641402171209AF75F3EADDCBB7AFA8';
wwv_flow_api.g_varchar2_table(26) := '400021F90400050007002C00000000200020000007FF800082838485868788898A8B8C8D8E8720028F8E41453F40938C1F155F1F998A023F15100C920002096C1D8F054234820244A3079242775119488F414F213800050E153547052039782A2962A68B';
wwv_flow_api.g_varchar2_table(27) := '022F282D5324002177742D0033B829580E8F402852213782139805741929305FAB8E201CE20B8644293E104299ADAF861D752B5C7C6A0462823E4642081098B0684218371A642C02010D058A7E88F2E8D8984481228A162F2A3AD2A36413108B16DCB8C1';
wwv_flow_api.g_varchar2_table(28) := '50D1030F54A8841808AA59A3022EDE19A240E1538120285E082C44021AA6492442B68C240847C89E8F1E587CF1AAE88D5542420E8547E0063500042C1E5509A480CF4137C40E324B73D0048B070FDB162A4062ABDCBB78F3EADD8B37100021F904000500';
wwv_flow_api.g_varchar2_table(29) := '08002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90870A69210A918B53480C32978905439A3F0582022C321D901D9600021748393602002E47114D258F132F03420005754877B8204E54504C10B28C053728282F14002F3F082F';
wwv_flow_api.g_varchar2_table(30) := '00435D4D4C1A338F40CE280F8224E20512DA7815A88E201CCF2E865E4C781EF090052ED1861D5B75349D8C404CE8C54808010213163D688381099B45020680FB97C8861C2B569480501471A2221B59426A5C64F04642450FC48858F210E0A102149439C2';
wwv_flow_api.g_varchar2_table(31) := 'B7CE10057DF782BC3344E2050A209148803B0942190E70381B3D70F6E25FCF1BA88480B3C78EC00D12820838030A60C10D1CA3228505D0ECE7A0B12E273823E8B2500112540ADBCA9D4BB7AEDDB981000021F90400050009002C00000000200020000007';
wwv_flow_api.g_varchar2_table(32) := 'FF800082838485868788898A8B8C8D8E8F9088240B918C1C433337958A2C170E4383022F6A0A90202082059D251F050034446D631F8F242F03428269174417000225465C5D0DAE8D1C28282F14004075161C0006B25D4BBE8E38C9280F823424824E635D';
wwv_flow_api.g_varchar2_table(33) := '5439A58E20C82F34861764E4EB90052ECC860A275BF09B8A020F4142C689841020306111901A1A5424F992CF908001DA1A1ABA63A7228F2B32121580984C62210466429AB16340910B02370A2A7AB0210A13264E04E83354A083CD47F23A2062314467BC';
wwv_flow_api.g_varchar2_table(34) := '20CA5C182291E04B1BA1B5B4A90421134036290E50407A904C1D005B37740AD196EB110894DF0010480644D0821B3800E21C7483EC20B5FA132624EB3AB350011248EBEADDCBB7AF5FBE81000021F9040005000A002C00000000200020000007FF800082';
wwv_flow_api.g_varchar2_table(35) := '838485868788898A8B8C8D8E8F90882002918C424F2C24958A0469322C83051C409120058337690632821D6F1E262D8F422F3742829D5B5300052B26106B0E8F1C28282F1400422D0613006A15C0625B8F38C5280F820A34820E5F6B46480A8F20C42FDB';
wwv_flow_api.g_varchar2_table(36) := '855B1B7136E78F052EC886202C27F19B8A020B4040F6884204049A29E230874A12266250241230C05ABB433952A4C04211C22944041C2ABAE3A66347088A5C10B82130110E084A94509943E09EA1021D625E64F4AEC321104386D8845420883117861C68';
wwv_flow_api.g_varchar2_table(37) := 'D13206E82312D6044E1294068A1E1D31203D28660E00895A368518C0A387082410233501C88882148005322A947487AA98595E2E14074D28762B6EA102248CDADDCBB7AFDFBF9B02010021F9040005000B002C00000000200020000007FF800082838485';
wwv_flow_api.g_varchar2_table(38) := '868788898A8B8C8D8E8F908805918D1437040A948A1C28281C8420939005A200049D2F820A094417998E3437374282A75203000532473907288F41A814004203282E0052360C0D0D9F8E389D280B8220AF75CC265EA58C209C2FC3856A07740E1D91052E';
wwv_flow_api.g_varchar2_table(39) := 'E185204F21E79A8B02243838EB882E0404138B40076364BA40C095E854271A8A8E3089C2508307450651204C942783458B0F13512070839FA2091EC8800153E1593C42053A7478D5281DBC420262C478E9A840B017C80A31B022C7484E4724A479042140';
wwv_flow_api.g_varchar2_table(40) := '50981D5AACB081F4001542122F6E9C43A203A90348203892A8D5090800050DDC88F1386AD08DAE831E143D096042275A6C0E0B1520F133AEDDBB78F3EAA514080021F9040005000C002C00000000200020000007FF800082838485868788898A8B8C8D8E';
wwv_flow_api.g_varchar2_table(41) := '8F909192840A40400293894028280F9983050583049C1C8205035304901D37374282A42841824F330E0E348F389C2F1D004203031400412B0E45552E8F139C280B820220822C1645477590201C282FC485525579170A91052EDF85023703E59F8905420F';
wwv_flow_api.g_varchar2_table(42) := '0FBF8A140404138B1379356D620D562592854257A21F64BA74891021872282061115694291E21D7B046EE853F4E08E988F3968BDA3A4C05DA373F5D46DD992D2518120DD9615CAC3E3CA86888D4838DB080213002356CED83100E9412F5D245EDCF855C4';
wwv_flow_api.g_varchar2_table(43) := '4A502FDA329288C50908000512B07031656ED08DAA83164C7BD70C05AC91840A909089B6ADDBB77004E3360A040021F9040005000D002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840A40380293893828280F99830505';
wwv_flow_api.g_varchar2_table(44) := '83049C1C83241C14901D37374282A4284182402C062190139C2F1D00420303AA242132756C988E0F9C280B820220821CC533B88F021C282FAA8538751F09D090052EDB863841E19F8805342424C889140404138B0B44071E2648408AB12834147DD8B0A6';
wwv_flow_api.g_varchar2_table(45) := '8D4124FE96054CE460CC98300E6D289277A39E221247BE7C99630387BA420A14A46334AE97210A6F2E987C5420483617868EB8C132E7D52312CB2C820828800B0F343EE82878A42C5B40122FBEB0018084078F2B584E3C0241E0060958283C9029A0E04B';
wwv_flow_api.g_varchar2_table(46) := '99A75E22891274030591AD006878C0A264C0275D17148880E270F55301120B467EDCCBB7AFDFBF9002010021F9040005000E002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928402130B0593893828280B99839883049C1C';
wwv_flow_api.g_varchar2_table(47) := '83142E911D04374282A3284182132F283890139C2F1D0042030314BC9C2D2F900B9C9D820220B2282D6A4090051C282FC085422D5328A18F052ED68642979F8BA71DDC88140404138B422B454E361FAD89AF28348A31070D15151E5B14DDCB97E8C29783';
wwv_flow_api.g_varchar2_table(48) := '0763285277A39D22214424DCB9E30015394220327673B1CB908B156C3A760B42CD22211B19343430D988C431874F4A29E08245059E0322193DC8950F880A3401ABF8C082018F974720569110F442C58E31054078188A61848068835AF8D841069310083E';
wwv_flow_api.g_varchar2_table(49) := '52FCF8F4E28A8E22A6D884FC44E148959C1708E3CA9D4BB72EA4400021F9040005000F002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A3828280B9888049B1C831D1D910A1C044282A0284182132F2F978F';
wwv_flow_api.g_varchar2_table(50) := '0F9B2FA54203031400429BAD900BBF9D000220AFBFAA8F051C282FBC85BE283892052ED08614349E8C0A14C78B140404138B1D532B1F2B528BAC28DB892C554548483FF09FBFF887530CFE0C365C281277A3DCC037486C1061C7AD9000050296B9286588';
wwv_flow_api.g_varchar2_table(51) := '460C190A221508E24C60A11F4D2220D8C788C4AF72025AB802214603142A792836AAE56C5B0E39580C0070204243122A2B1E812070E31205153AE01829004242CF24260A40920A80048CA461A4BAF020228A054F6D92FE1844C100464F138EFC90D9B0AD';
wwv_flow_api.g_varchar2_table(52) := 'DBB77004E3460A040021F90400050010002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A1328280B9888049B1C832020910A1C044282A02841820F2F0334900F9B2F1D0042033714B99B2838900BBF9D0002';
wwv_flow_api.g_varchar2_table(53) := '02829A9BAA8F051C282FBD85429BC191052ED28614B39E8B0220058C14040413DF2F6A092CCC89AC28DD883775431717278BEFF1875216FE16061651E070E39CA20E0666BC8971C95B2101E29AB9C06588860C35A520150802CD85212F63DA54D1D688C4';
wwv_flow_api.g_varchar2_table(54) := 'AF73029E000100E24B042E71AA2878540BDA2C043C44E0FB4025029838311E812070E312053C56CA6C2800228F129F39223A8A280443D236E268DCA1D2E58DA71156789418D421CD94999826D87080D6A1DBB77005E3CA9514080021F90400050011002C';
wwv_flow_api.g_varchar2_table(55) := '00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052442938A0F28280B9888049B1C832005910A1C049700A02841820F2F371D909A282FB34203371400429B280F900BBF9D0002028213BFAA8E051CB6BC85422F283892052E';
wwv_flow_api.g_varchar2_table(56) := 'D1861D349E8C05A58C140404138B0540030340C88AAC28DD890F4F2D6969D6EEBFF1884132FE32AE1451E070C39C22102D4E9C9002C29B217090B0CDDAC6E249C3884150480961E802040F1F263A72B1E9C81C632150183BD0A6069D0F171B697A83C50B';
wwv_flow_api.g_varchar2_table(57) := '00273EF0180030244E9B1173123C02F1420C03011492D88161C25895303F7F4012500C07163B3EDA20A3E0C4489B189816A8C0AA5590828D3123515062C7CD1D8785102EE0A192066EA10724ECEADDCB9750200021F90400050012002C00000000200020';
wwv_flow_api.g_varchar2_table(58) := '000007FF800082838485868788898A8B8C8D8E8F9091928405242E938A0F2828249888049B1C830205910A1C044282A02841820F030420909A282F1D0042033714B99B280B900BBFC100A48213BFAA8F051CB6BD85422F283892052ED0861D349E8CA58D';
wwv_flow_api.g_varchar2_table(59) := '140404138B0540BBD58BAC28DC89C3BFD99FBFED88EF9BF187141C37E48A05412F06A4EB46F05A10018640A0B8811052B322587E1892C1C0C6160590842030B30382B1342F8C39A970E7089B868D6658E901670680221994240060600EC93C2D1EA5C9E0';
wwv_flow_api.g_varchar2_table(60) := '268F800E4B52E0B963CCCB1C0F12D84022F14010092629447C29D5C182893B52303D8D5AE39B801BAE30B9689222830982853C447D8396D082126F0830B69D4BB7AEA0400021F90400050013002C00000000200020000007FF800082838485868788898A';
wwv_flow_api.g_varchar2_table(61) := '8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820F031C02909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BAC48BAB28DC89C2';
wwv_flow_api.g_varchar2_table(62) := '9BB6EABEED8842BEF18A141C37E48A0538043800EB4610480919B20A090882E39BA309497AC829612884831569123AAAB243079C3900043CB92168868D121F5A4032A1234B991500883419C302801A0436887C78F0A88586144E047418136589130005EA';
wwv_flow_api.g_varchar2_table(63) := 'E0240204929074429644A1728014882D3F0C80C014358A920ADF6E79A241C6EB1D8285EE78AD839610890F7508B6B69D4BB7AEA0400021F90400050014002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F';
wwv_flow_api.g_varchar2_table(64) := '2828249888049B1C8305920A1C044282A02841820B374102909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BA9D8BAB28DC89C29B03B28AEBED8842BEF18B141C37E4';
wwv_flow_api.g_varchar2_table(65) := '8A05380870A8D7AD1B0E0727E415227129D20425597858307443068B20DF1A1D8123A74C0500055EB4027062C59629231D799063C6CD10005EB8D47802408A85156CD48078F4040A9E220214ACE962A404C8295E569CD8F9480831002EC2748973849480';
wwv_flow_api.g_varchar2_table(66) := '1709AA617211A74B983C19BBD110E3D546C14247BC1A381BED8201A66C06E3CA9D0B20100021F90400050015002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A0';
wwv_flow_api.g_varchar2_table(67) := '2841820B3740A48F9A282F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28C140404138B0540BAA98BAB28DB8924BE37DE88036A09319D8942EFF1872D614D26B71215C0412008BB451D84ECE34608';
wwv_flow_api.g_varchar2_table(68) := '079121200EB9B814294817336E1C18A215EB11893065AEF89000A000016A0050849082E2C1230721DDA85801E0420D0903000439B192C0230976DCA4C823408189352668A6E429CA919408518ADCA251630D1D8D2581005100C9C538413420AC99438421';
wwv_flow_api.g_varchar2_table(69) := '210A73D67CB160969003B56A0DDA0EA220838500B978F3E60D040021F90400050016002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820B3740A48F9A28';
wwv_flow_api.g_varchar2_table(70) := '2F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28CB937138B0540BA978A42604A3512378A24BE048B24293D3D3B1FE8F18C174C2935D80A15C0412048C0431D5C78E36668828518200EB9380709C8';
wwv_flow_api.g_varchar2_table(71) := '181F2AF215828722D623216D7CA410910700396200800C7BE404C6482875006C9150A5154714A21A81E0922243140705403068E0E484A009D21E3C629041839388142434C8135310058A8D28C838A1C0EA9D060886302404220FD82D63091938E024675A';
wwv_flow_api.g_varchar2_table(72) := '931C07A8BD9D4B976E200021F90400050017002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202';
wwv_flow_api.g_varchar2_table(73) := 'B10013BDBF8E051CB4CA83422F283892052ECF841D349142A88DC68C2B18306B9D890540B9DB8A42183BEF6F8A24BD048B241959597033ECBDA28B439A889883AD50011C0482143CA4C005B851861ECC3000E21085858B70B41101E5822112D2603D1202';
wwv_flow_api.g_varchar2_table(74) := '010F132A555A5D020044D8A32A269570310040CD8F21C384F402E208441B264DBACC28208048911952043D78F1C25B23274D2210A948C346910F2C06755000A9C314355C01742852C48B1A8884047C286201055A42380D2E2458F756D0C3BA78F3D60D04';
wwv_flow_api.g_varchar2_table(75) := '0021F90400050018002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202B10013BDBF8E051CB4CA';
wwv_flow_api.g_varchar2_table(76) := '83422F283892052ECF841D34912EA88DC68C432218239D8905400304D8864278567070178A24BDA28A42516666656FF8F68C627449E2811D251C04821834A48006B85186165C4820E01085858A26CC51C2858D2112D280407251810A99385E04D1502008';
wwv_flow_api.g_varchar2_table(77) := '482F6F8D1C2C211366841A005262A4D925A4D7044720E6D05C13A380802143D45003F0E0C5008C86888469F3A662871943A6DC2305025287102D8C81B83024C1568882580C39310CED2005370A7EBA9D4BB7AE5D4381000021F90400050019002C000000';
wwv_flow_api.g_varchar2_table(78) := '00200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A02841822404400590322D282F1D0042033714B89B28BC8F3910B40B8202B10013BEC08E40505F4FCC83422F283892380EC587';
wwv_flow_api.g_varchar2_table(79) := '1D348F052E2442028DC88A245F1A19221BA88905400304B7895E76763C3C650EE7BEA28933DC0814E84591105FAC1291A0D304CA920697DEE178A56051251211472122C12604394314A4395A70204E8D048648540302890682381BE8D411A400842020BE';
wwv_flow_api.g_varchar2_table(80) := 'DC357A6364C31C094F00047932E0D6C14DDB180990B0E14B8513000AB0A0C512C00379151DCD70CA869C0035B4FE01380649819417C80AA4A1AAB11090272F0D44B6A590B5ADDDBB78F32A0A040021F9040005001A002C00000000200020000007FF8000';
wwv_flow_api.g_varchar2_table(81) := '82838485868788898A8B8C8D8E8F9091928405422E938A0F28282498831D0583049B1C9E00694D3F4282A3284182240440A18F733D29061D0042033714BB9B28BF8F123B3D460F8202B413C1C38E38493B654F86422F283892383F6CB4851D348F053496';
wwv_flow_api.g_varchar2_table(82) := '028DDF892C1B4D4C495F9D8905400304BA88204658FB3030488A2482BDC2B7218341830E1409090644518B0D64C88C61100F51011CB2402C022144883853895C2478926E1085678F48389973A7852112D81A3EA25085CE813C090481D0080047B08F8DD8';
wwv_flow_api.g_varchar2_table(83) := '983880E0C70D003007E85AB869C123220718207109A095CC05F578365293A7889A50056E6C1A08A0404946139289DAA40D24215E040D14B82D6476AEDDBB78F31E0A040021F9040005001B002C00000000200020000007FF800082838485868788898A8B';
wwv_flow_api.g_varchar2_table(84) := '8C8D8E8F9091928405422E938A0F2828249883144283049B1C9E002D4D294582A328418224044005901E593A56060042033714BB9B28BF8F0C705A3B128202B40013C1C38E385470671786422F28389213255BCC851D348F05344234E08AE9886973644B';
wwv_flow_api.g_varchar2_table(85) := '111EA189054003041D89203551511A1A7888282211EC152201749A2854384391906040144931D1A6CD081BF31015C0210BC422102E5C40337588469A1BEB045118E9C885853C3F6E1822912DE223106F8E54F9804210088F0070041BE70885932A5E623C';
wwv_flow_api.g_varchar2_table(86) := '00407340BE879B3A15AD62E1C200569B6C2EB807B49182136C640228706393C1B129190920C461D30292850E2870E0D015AEDDBB78F3EA5D14080021F9040005001C002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405';
wwv_flow_api.g_varchar2_table(87) := '422E938A0F2828249883344283049B1C9E002D50195582A3284182240440059007665665320042033714BB9B28BF8F473C6756398202B40013C1C38E13643C767586422F283892135E32CC851D348F05142E34E08AE988520762617139E389054003040A';
wwv_flow_api.g_varchar2_table(88) := '8902155D5D114B4B2E2822110C88BE3B6312261CA24848414503189830D1C0C13C440570C802B14800051A1D4C29EAF0C2E0210AD01E5188E185CD034324B2997C74E2439D29DB0080E00800C7B3472456D439F1645CCC01211D6EBAE4C8051B19695E02';
wwv_flow_api.g_varchar2_table(89) := '686572C18D200220D9EB04A0C08D4DAF04AD9B1464D30291851404993016ADDBB77005E3CA4514080021F9040005001D002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840F172E93840B13845F4D522498005349782582';
wwv_flow_api.g_varchar2_table(90) := '142A4A521CA1156E576E4400141964284182240440058F4E306E766806004E6D3714004228CCC98E0F6130683C158213BD0013CC28CE8E37D13E1686422F2838920F1F1702871D3490EE14D88BF3892F477310104EEF890540030828482420CF9A366DC4';
wwv_flow_api.g_varchar2_table(91) := '1861A388C43620FE907C99389158A265CC2026E2500501022717BA1D2A8063178845023A5018184A91021C42105110E9084488044F2E1522514EE3A317539EA0D80400C4490038B6D1741942E88B773C077450B64D67A3020350BC0005804046410B6EE0';
wwv_flow_api.g_varchar2_table(92) := 'A8C748C102AB3798E11244761210660B0F5A1A1230E19ADCBB78F3EADD8B29100021F9040005001E002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B45330A938242172184743B3A479902071822168214783B3D2699';
wwv_flow_api.g_varchar2_table(93) := '345C19292A0E00141AAC4482240440058F0C1A1958183200363C5828004228CE148F131B1A2A301282040F8213CE28D08F1C231A223386422F283892242B3102871D34900A141DBF8CF78A421639121225DF101500328000A644431A54F0E0C144024524';
wwv_flow_api.g_varchar2_table(94) := 'BA0151148381458B2CF44954E4828D03071F4E74505400472F108C1428409969910017230F5108F8A80007142F5C1822816E22246ECE260802C11247379A8C08387B218FE78091CD9E410282930436673E17DC5007A9808B83006E380B32285F4BA328AC';
wwv_flow_api.g_varchar2_table(95) := 'B63424E081DAB57007E3CA9D4B576E20003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7762841634438574 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't2loading.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000620000008208030000008A3FEDBE000000D2504C5445FFFFFF0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000006666664E4F504A4A4A2929';
wwv_flow_api.g_varchar2_table(2) := '2919191A101010080808EFEFEF5A5A5A6B6B6B87898B7F80817B7B7B7677787373736E6F71EAEAEBEAEBEBE6E6E7525252DEDEDF4546474242423A3A3A2D2D2E212121BDBDBDCFD0D2333333C5C5C6D2D3D4ADAFB1A7A8A9A5A5A69999998F90928B8B8B';
wwv_flow_api.g_varchar2_table(3) := 'E2E3E4838384CCCCCCC1C3C4DADBDCB7B9BBD6D6D7B4B5B5F7F7F7FFFFFFE0E1E2D8D9DAC7C8CAA9ABAD939394ADADADA0A2A4A1BA27710000000F74524E5300112233445566778899AABBCCDDEE462AF5990000052F49444154785EEDDA5797B2380080';
wwv_flow_api.g_varchar2_table(4) := 'E1D00795848EBDF73ABDCFD776F7FFFFA50DC62102A36008672F76DE9BB970F43111029E0854703A4956AE20CAA8A6C9B2044EA7822A389FA09D05A00232AA0224838CD4734310B20419016464FE171D8747003F1A83982508060279DE491591AC8E1B0A';
wwv_flow_api.g_varchar2_table(5) := 'A3A68B485AA650432181A09A412844703BED3636EAF7F71D22C02C4185881018A968F1A4B88148F376ABED8E9ACD9E47884A1C90B478150C44443A4339260C6AB41E1F1BFE57F3A418281D214EA5273F0C62B4DB2616D2848E507E821A6962D2E974BA6E';
wwv_flow_api.g_varchar2_table(6) := '8220020B81941431E9F5CC6EB7E1A60805B111469298361A75DFC18C97240C46024971C233CD918F90D3685884880E7609B1126AE2FC5E5858C00686F689748D6124E84488E8ABE80AAA1527C0D55784CC9500B513D3C89110F4040055C089A0C9956340';
wwv_flow_api.g_varchar2_table(7) := '1701478226C987E8EBF32668EC84B3E0412C16A789756FC683589BF334112D419C0873FA25E14F4D7E0436D2846FE1071A6B1EC4DCC4597E92F0ED7A4898B3309795F09C39AE6E868DFC38E159754C60A3D1EB76BB33566256DF6712C3A30411A8C14E4C';
wwv_flow_api.g_varchar2_table(8) := '47D4C0799470ED1125B0C13E8A51CA20846B59A398518048180E215CDBC604C109B22E4E502324D698881BEC84450C8A4CF6843F4B1A05888461F921418C882F4A500337F5A383766E1FF145083B342264460F5A6A90E6ACC4DAA60611288116C786CB4A';
wwv_flow_api.g_varchar2_table(9) := 'B83631F6C822B90CBA7B7FCE65A5DD238BF462EE4EB0E1F0201C3C10DB43690279139B136147424450830BB1B0A7444813C89FF121663E4A12D4F07910FE7F771F553EF14D7C136A5E426526C4BC84C84A5441EEAA8C84949F90D808155C90CA404022E4';
wwv_flow_api.g_varchar2_table(10) := '37606E827EE9BD305187E7888A26C7920053921C4BAB4444550425255609A18312D343A20A4AAD8A09B15C4244400725A703A56C42015AD984068CB20903A09287A12180A054A620414C20A8942728F0B046554A42E4CAF14A5B8DA7319C90A2568D9775';
wwv_flow_api.g_varchar2_table(11) := 'BDD085CB0041BFFCAA57BBC8106A28836036A8C0425C72C668888D80F909C8482039AF207FDF991720BE896FC2BB337910E6DD49C25B0E3A3C88EEE0D98B1354E8F3213A83801849C2791BF6033E4410049B799A70B6C3E12068F2201E83E0E363384F12';
wwv_flow_api.g_varchar2_table(12) := '93D5C3B03F0882F7D7E57269B11293EB3F7FEF7641487CF4A77162F4327E180EFB980F6BB312D7E18B0C08F1E347FD98A8FF7A19FF24C3E0476083128F6F94087811D8F8B8FF245ADBB7B797F1F88118B80E3B11BD4FD22D21BA4FABED6118D8181422C2';
wwv_flow_api.g_varchar2_table(13) := 'A98819CD63E2606064D06527C84C45464008D45A916160638FF48B10641887B0400854C7C4C1089121337143662232EAF4A0B5881122A1528820C680089440D3CDC1D8D763256EA3C9C6C838B145E2EC8D5F4F37B85B8795706E6FAEAFAFDF8621F2324F';
wwv_flow_api.g_varchar2_table(14) := '2D83CF5B8C34782C83AD70204B27BD987BD7ABED960BD1C393F51ADF22A1C68A0F31FEF97A6A8BA4B532F910F7A7EF40BA160F62D4FEBFDDAAE972CEF402A390D41ACA485784A213A5C073404DE2F15948F08C20F0F9B8E508700930FF140C81D7115541';
wwv_flow_api.g_varchar2_table(15) := 'A4F6B3130A7FF5477483A32021C77FDBB8D83C6DB071377C7827022CFEA55848FCD8D5FE8D8DE678FC9EFCB1ABC04AE8E0B31A35F0F571E7A54E4D9D8D80427C938518BF9FF0185284005908288134D1593E6F36769A0012BC9CA8518112BDF7D7DBDD72';
wwv_flow_api.g_varchar2_table(16) := '39A104356A971186AE508012E69FDD9DBFF8F3FE3EA5044DD18DD384A18A7936BC16FFDC347DFCE766779F6BB749548D4F42CBBB58CF5AFE9E6AFB79F7FD3442A8203301B2EEFBA921A1315F73A47CCF048600F2A4B3EEFB09105C817C5D2500A8E47D22';
wwv_flow_api.g_varchar2_table(17) := '9041CE641D52C0D084DCCFFB17EA19E02C7345FE160000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7763538183440197 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't3controls.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F60000000000E2E2E20303032323232020200101013C3C3C7070706767673737370707071313136868687171715353531515157E7E7E9999996E6E6E1717170A0A0A737373515151474747B1B1B1AEAEAEA9A9A98383831E1E1E';
wwv_flow_api.g_varchar2_table(2) := '0808087575754E4E4E050505303030ACACAC818181111111555555777777383838272727B3B3B3B0B0B04848483131312C2C2C0E0E0E252525B7B7B74141413A3A3A4C4C4C0C0C0C8080806060602121211818186A6A6AD1D1D1D3D3D3C1C1C1D5D5D5B9';
wwv_flow_api.g_varchar2_table(3) := 'B9B95858581A1A1A1C1C1C1010104545455757575C5C5C8A8A8A6363635E5E5EA3A3A39E9E9E9A9A9AA5A5A5A0A0A06161612A2A2AA1A1A1A7A7A72828283535359C9C9C5A5A5ACACACABEBEBEB5B5B5CECECED0D0D03E3E3E9191919797975050507C7C';
wwv_flow_api.g_varchar2_table(4) := '7C9393938E8E8E898989909090959595C3C3C3C5C5C5C7C7C7BCBCBC2E2E2E333333858585404040878787BABABA4A4A4ACCCCCC8C8C8CC9C9C97A7A7A797979434343C0C0C06C6C6CAAAAAA656565D7D7D700000000000000000000000000000021FE1A';
wwv_flow_api.g_varchar2_table(5) := '43726561746564207769746820616A61786C6F61642E696E666F0021F904000500000021FF0B4E45545343415045322E3003010000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B39363493820F17218305353A3B';
wwv_flow_api.g_varchar2_table(6) := '12990A101822168214223B3D359E900B111918190E00141AAD3F820B3740028E02121A1929183200363C3E28004228D12E8F131B1A2A30A300041C8213D12814901C231A223386422F283892242B31C1861D988F0A141D058DFA8B02060C1224941097A8';
wwv_flow_api.g_varchar2_table(7) := '0090010408221A70A041050F2658282201AE5B220208186844D04211B46816111548E0C0C28713201415C0412088C2440A14A4CCD4CF450744145E3A2AC001C58B698548AC0312E95BB4098240CCC4014EE72202D15E60123AE0E64714401D3DF0494210';
wwv_flow_api.g_varchar2_table(8) := '54144401F80A22EF110505836E440B028BA620A62810BABA2D246082DCB978F3EADDCB7752200021F90400050001002C00000000200020000007FF800082838485868788898A8B8C8D8E870F138F8E172A585B938B0A1156595C0599830B312D831D4C9D';
wwv_flow_api.g_varchar2_table(9) := '510AA100200D494A338214A85A512082A08F24464A4C50B20A54565A5DA00B3740BA8C05474B4D514C530055573C5E004228DB2E8F0B264B501A088252A50013DB281493401E4B4A1786422F2838A1423132CB841D3493203AAC6AC42F510B224590AC18';
wwv_flow_api.g_varchar2_table(10) := '88A800900104D825A2E020A10D2752149150C74111882116425AB8A148DBB68E8A80243020E3890045057010082271918082AC1ABAE8808842CD470582A078D1AD10897A40323D5027A9152E0038D4FD64C461DB8B7F4707F03489A2A8A3A32F480822B0';
wwv_flow_api.g_varchar2_table(11) := '2D290064415E4E1238E8C6B620831570864A874248CE860BBCDEDDCBB7AFDFBF800705020021F90400050002002C00000000200020000007FF800082838485868788898A8B8C8D8E86244E3F148F8D123C650C958B1D4B3C664A209B8342322883344D3C';
wwv_flow_api.g_varchar2_table(12) := '674C0AA3002008606343821D54AB50A2001D952E5F61646017B064AB5C050A123340058E054462635D5D2C003F3E681F0036622D282E8F240C625C1148000221218255532828948F1308D23186402F2838A32E2753CE0C75A0B109C42E4601179190B162';
wwv_flow_api.g_varchar2_table(13) := 'C59483870A001940405E2216432EAC98C141110978283A2A7A72A2E4097E898480149988C200142F9A292A808340108B335F3D73D1EB10059CCF82C00C5788843E209B16809C20C8A0201C20812E120A93A0D101BD54C223EAC8C58017240411808714C0';
wwv_flow_api.g_varchar2_table(14) := '821B4104143C7883ECA0843A13014C8027246EC4055CEDEADDCBB7AFDFBD81000021F90400050003002C00000000200020000007FF800082838485868788898A8B8C8D8E8624550E148F8D08583E47958B0A63586E5D209B8305374183146458684A0AA3';
wwv_flow_api.g_varchar2_table(15) := '822B5F105B821D5CAB11A2000F1D8F05365F1B1B6C002046AB46050A0D6E11388F171E5F6B6D2D000E19186F00485A3D70538F2E3F1E10620E00052D69826D3D654734950B44E52786475844CF9B142169050C090022AF5201018E023202F182C5141408';
wwv_flow_api.g_varchar2_table(16) := '131500328000254538D68550B34011091420392C9A0012A40B45424A8A542400C78D1B131615C04120C84599AF12BAE87588C24D5F4150BC385988C40B1440367D0419B358441C257F322229549ED11BBD529AAC4461C000128208804C0A6081A9888F04';
wwv_flow_api.g_varchar2_table(17) := 'A0BD3196544E42541085BC3D546001D1B978F3EADDCB576F200021F90400050004002C00000000200020000007FF800082838485868788898A8B8C8D8E864216431D8F8D48512245958B0A6B511971209B84200A831D621A1960A6A3000F444E6A829D1A';
wwv_flow_api.g_varchar2_table(18) := '2A63A2000B2E950908070D090020101A1823000A12294A1C8F4F360C0D1E280033505143005572593A3F8F1D174E391E2B0005524F8223DE3A17952EE3392C8636703B61149B1D282F87200CBC11E2AA510183136EDCC0B1A800900104F6297281A2220A';
wwv_flow_api.g_varchar2_table(19) := '1A8A48587436D1E24545423636C4A170C248024124362C68D005A54314543E2A10C41FAF42245EA000B249634593C30408C2615126A309155F60CC798352C88A371D292030808420021579EABA014468A5020705DDC83A282C4B004851103C5BA80089A8';
wwv_flow_api.g_varchar2_table(20) := '6C08E3CA9D4BB7EEA8400021F90400050005002C00000000200020000007FF800082838485868788898A8B8C8D8E862E2B6C0A8F8D25115433958B2026114D23029B891D739F622082202F0F954F6C28820A7411506BA20B5F6E51528E135E3F48690002';
wwv_flow_api.g_varchar2_table(21) := '0D114974000A5F6567724EBE2B16454E04007560116C003F76CE56758E20536F0E365B00052FB1024666727046148F146A6F25BD8547F046249B2041821CA2F0C68290518D405028D08804010213161568D18240874514506844414311898D1C306EE4A8';
wwv_flow_api.g_varchar2_table(22) := '480848460F6EDC88A8A8000E02402E326288B0510117320D5198B7A94010142F5C1822B10EC8A68F1A5982100500C7469E8E1E687CD191E88D8B26350A7D0482C0007F000868340A60C10D204C2BD1047063ECA0B53514014CD07830AEA10224B6DADDCB';
wwv_flow_api.g_varchar2_table(23) := 'B7AFDFBF7D03010021F90400050006002C00000000200020000007FF800082838485868788898A8B8C8D8E860503038F8E6C236D32948B200C6D6307059A890A779E5F2082203243148F24280FA99D5C740200241E296E478E0A6A31179302476D5C1200';
wwv_flow_api.g_varchar2_table(24) := '0A1530687663B68C1D21AB333800322346990E29CC3C3F8F1C2C062B210005379305236E76651BAD8E20042C5B1C864557656B249A05240B87285CF8E04254231038F831224180C0844513C0D8C960609182172832D25084E4CC151F6D508DC2A8511101';
wwv_flow_api.g_varchar2_table(25) := '360958DC60B4E0C68D878A0AE020004481C19B880AB8E88088023C4A0582A07851B010098C4034BDCA0813C4331C1951FC6CF420E38B8D476FF01412B5683C02371412C89814404B20CF800EBA417650289C821126641402171209AF75F3EADDCBB7AFA8';
wwv_flow_api.g_varchar2_table(26) := '400021F90400050007002C00000000200020000007FF800082838485868788898A8B8C8D8E8720028F8E41453F40938C1F155F1F998A023F15100C920002096C1D8F054234820244A3079242775119488F414F213800050E153547052039782A2962A68B';
wwv_flow_api.g_varchar2_table(27) := '022F282D5324002177742D0033B829580E8F402852213782139805741929305FAB8E201CE20B8644293E104299ADAF861D752B5C7C6A0462823E4642081098B0684218371A642C02010D058A7E88F2E8D8984481228A162F2A3AD2A36413108B16DCB8C1';
wwv_flow_api.g_varchar2_table(28) := '50D1030F54A8841808AA59A3022EDE19A240E1538120285E082C44021AA6492442B68C240847C89E8F1E587CF1AAE88D5542420E8547E0063500042C1E5509A480CF4137C40E324B73D0048B070FDB162A4062ABDCBB78F3EADD8B37100021F904000500';
wwv_flow_api.g_varchar2_table(29) := '08002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90870A69210A918B53480C32978905439A3F0582022C321D901D9600021748393602002E47114D258F132F03420005754877B8204E54504C10B28C053728282F14002F3F082F';
wwv_flow_api.g_varchar2_table(30) := '00435D4D4C1A338F40CE280F8224E20512DA7815A88E201CCF2E865E4C781EF090052ED1861D5B75349D8C404CE8C54808010213163D688381099B45020680FB97C8861C2B569480501471A2221B59426A5C64F04642450FC48858F210E0A102149439C2';
wwv_flow_api.g_varchar2_table(31) := 'B7CE10057DF782BC3344E2050A209148803B0942190E70381B3D70F6E25FCF1BA88480B3C78EC00D12820838030A60C10D1CA3228505D0ECE7A0B12E273823E8B2500112540ADBCA9D4BB7AEDDB981000021F90400050009002C00000000200020000007';
wwv_flow_api.g_varchar2_table(32) := 'FF800082838485868788898A8B8C8D8E8F9088240B918C1C433337958A2C170E4383022F6A0A90202082059D251F050034446D631F8F242F03428269174417000225465C5D0DAE8D1C28282F14004075161C0006B25D4BBE8E38C9280F823424824E635D';
wwv_flow_api.g_varchar2_table(33) := '5439A58E20C82F34861764E4EB90052ECC860A275BF09B8A020F4142C689841020306111901A1A5424F992CF908001DA1A1ABA63A7228F2B32121580984C62210466429AB16340910B02370A2A7AB0210A13264E04E83354A083CD47F23A2062314467BC';
wwv_flow_api.g_varchar2_table(34) := '20CA5C182291E04B1BA1B5B4A90421134036290E50407A904C1D005B37740AD196EB110894DF0010480644D0821B3800E21C7483EC20B5FA132624EB3AB350011248EBEADDCBB7AF5FBE81000021F9040005000A002C00000000200020000007FF800082';
wwv_flow_api.g_varchar2_table(35) := '838485868788898A8B8C8D8E8F90882002918C424F2C24958A0469322C83051C409120058337690632821D6F1E262D8F422F3742829D5B5300052B26106B0E8F1C28282F1400422D0613006A15C0625B8F38C5280F820A34820E5F6B46480A8F20C42FDB';
wwv_flow_api.g_varchar2_table(36) := '855B1B7136E78F052EC886202C27F19B8A020B4040F6884204049A29E230874A12266250241230C05ABB433952A4C04211C22944041C2ABAE3A66347088A5C10B82130110E084A94509943E09EA1021D625E64F4AEC321104386D8845420883117861C68';
wwv_flow_api.g_varchar2_table(37) := 'D13206E82312D6044E1294068A1E1D31203D28660E00895A368518C0A387082410233501C88882148005322A947487AA98595E2E14074D28762B6EA102248CDADDCBB7AFDFBF9B02010021F9040005000B002C00000000200020000007FF800082838485';
wwv_flow_api.g_varchar2_table(38) := '868788898A8B8C8D8E8F908805918D1437040A948A1C28281C8420939005A200049D2F820A094417998E3437374282A75203000532473907288F41A814004203282E0052360C0D0D9F8E389D280B8220AF75CC265EA58C209C2FC3856A07740E1D91052E';
wwv_flow_api.g_varchar2_table(39) := 'E185204F21E79A8B02243838EB882E0404138B40076364BA40C095E854271A8A8E3089C2508307450651204C942783458B0F13512070839FA2091EC8800153E1593C42053A7478D5281DBC420262C478E9A840B017C80A31B022C7484E4724A479042140';
wwv_flow_api.g_varchar2_table(40) := '50981D5AACB081F4001542122F6E9C43A203A90348203892A8D5090800050DDC88F1386AD08DAE831E143D096042275A6C0E0B1520F133AEDDBB78F3EAA514080021F9040005000C002C00000000200020000007FF800082838485868788898A8B8C8D8E';
wwv_flow_api.g_varchar2_table(41) := '8F909192840A40400293894028280F9983050583049C1C8205035304901D37374282A42841824F330E0E348F389C2F1D004203031400412B0E45552E8F139C280B820220822C1645477590201C282FC485525579170A91052EDF85023703E59F8905420F';
wwv_flow_api.g_varchar2_table(42) := '0FBF8A140404138B1379356D620D562592854257A21F64BA74891021872282061115694291E21D7B046EE853F4E08E988F3968BDA3A4C05DA373F5D46DD992D2518120DD9615CAC3E3CA86888D4838DB080213002356CED83100E9412F5D245EDCF855C4';
wwv_flow_api.g_varchar2_table(43) := '4A502FDA329288C50908000512B07031656ED08DAA83164C7BD70C05AC91840A909089B6ADDBB77004E3360A040021F9040005000D002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840A40380293893828280F99830505';
wwv_flow_api.g_varchar2_table(44) := '83049C1C83241C14901D37374282A4284182402C062190139C2F1D00420303AA242132756C988E0F9C280B820220821CC533B88F021C282FAA8538751F09D090052EDB863841E19F8805342424C889140404138B0B44071E2648408AB12834147DD8B0A6';
wwv_flow_api.g_varchar2_table(45) := '8D4124FE96054CE460CC98300E6D289277A39E221247BE7C99630387BA420A14A46334AE97210A6F2E987C5420483617868EB8C132E7D52312CB2C820828800B0F343EE82878A42C5B40122FBEB0018084078F2B584E3C0241E0060958283C9029A0E04B';
wwv_flow_api.g_varchar2_table(46) := '99A75E22891274030591AD006878C0A264C0275D17148880E270F55301120B467EDCCBB7AFDFBF9002010021F9040005000E002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928402130B0593893828280B99839883049C1C';
wwv_flow_api.g_varchar2_table(47) := '83142E911D04374282A3284182132F283890139C2F1D0042030314BC9C2D2F900B9C9D820220B2282D6A4090051C282FC085422D5328A18F052ED68642979F8BA71DDC88140404138B422B454E361FAD89AF28348A31070D15151E5B14DDCB97E8C29783';
wwv_flow_api.g_varchar2_table(48) := '0763285277A39D22214424DCB9E30015394220327673B1CB908B156C3A760B42CD22211B19343430D988C431874F4A29E08245059E0322193DC8950F880A3401ABF8C082018F974720569110F442C58E31054078188A61848068835AF8D841069310083E';
wwv_flow_api.g_varchar2_table(49) := '52FCF8F4E28A8E22A6D884FC44E148959C1708E3CA9D4BB72EA4400021F9040005000F002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A3828280B9888049B1C831D1D910A1C044282A0284182132F2F978F';
wwv_flow_api.g_varchar2_table(50) := '0F9B2FA54203031400429BAD900BBF9D000220AFBFAA8F051C282FBC85BE283892052ED08614349E8C0A14C78B140404138B1D532B1F2B528BAC28DB892C554548483FF09FBFF887530CFE0C365C281277A3DCC037486C1061C7AD9000050296B9286588';
wwv_flow_api.g_varchar2_table(51) := '460C190A221508E24C60A11F4D2220D8C788C4AF72025AB802214603142A792836AAE56C5B0E39580C0070204243122A2B1E812070E31205153AE01829004242CF24260A40920A80048CA461A4BAF020228A054F6D92FE1844C100464F138EFC90D9B0AD';
wwv_flow_api.g_varchar2_table(52) := 'DBB77004E3460A040021F90400050010002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A1328280B9888049B1C832020910A1C044282A02841820F2F0334900F9B2F1D0042033714B99B2838900BBF9D0002';
wwv_flow_api.g_varchar2_table(53) := '02829A9BAA8F051C282FBD85429BC191052ED28614B39E8B0220058C14040413DF2F6A092CCC89AC28DD883775431717278BEFF1875216FE16061651E070E39CA20E0666BC8971C95B2101E29AB9C06588860C35A520150802CD85212F63DA54D1D688C4';
wwv_flow_api.g_varchar2_table(54) := 'AF73029E000100E24B042E71AA2878540BDA2C043C44E0FB4025029838311E812070E312053C56CA6C2800228F129F39223A8A280443D236E268DCA1D2E58DA71156789418D421CD94999826D87080D6A1DBB77005E3CA9514080021F90400050011002C';
wwv_flow_api.g_varchar2_table(55) := '00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052442938A0F28280B9888049B1C832005910A1C049700A02841820F2F371D909A282FB34203371400429B280F900BBF9D0002028213BFAA8E051CB6BC85422F283892052E';
wwv_flow_api.g_varchar2_table(56) := 'D1861D349E8C05A58C140404138B0540030340C88AAC28DD890F4F2D6969D6EEBFF1884132FE32AE1451E070C39C22102D4E9C9002C29B217090B0CDDAC6E249C3884150480961E802040F1F263A72B1E9C81C632150183BD0A6069D0F171B697A83C50B';
wwv_flow_api.g_varchar2_table(57) := '00273EF0180030244E9B1173123C02F1420C03011492D88161C25895303F7F4012500C07163B3EDA20A3E0C4489B189816A8C0AA5590828D3123515062C7CD1D8785102EE0A192066EA10724ECEADDCB9750200021F90400050012002C00000000200020';
wwv_flow_api.g_varchar2_table(58) := '000007FF800082838485868788898A8B8C8D8E8F9091928405242E938A0F2828249888049B1C830205910A1C044282A02841820F030420909A282F1D0042033714B99B280B900BBFC100A48213BFAA8F051CB6BD85422F283892052ED0861D349E8CA58D';
wwv_flow_api.g_varchar2_table(59) := '140404138B0540BBD58BAC28DC89C3BFD99FBFED88EF9BF187141C37E48A05412F06A4EB46F05A10018640A0B8811052B322587E1892C1C0C6160590842030B30382B1342F8C39A970E7089B868D6658E901670680221994240060600EC93C2D1EA5C9E0';
wwv_flow_api.g_varchar2_table(60) := '268F800E4B52E0B963CCCB1C0F12D84022F14010092629447C29D5C182893B52303D8D5AE39B801BAE30B9689222830982853C447D8396D082126F0830B69D4BB7AEA0400021F90400050013002C00000000200020000007FF800082838485868788898A';
wwv_flow_api.g_varchar2_table(61) := '8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820F031C02909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BAC48BAB28DC89C2';
wwv_flow_api.g_varchar2_table(62) := '9BB6EABEED8842BEF18A141C37E48A0538043800EB4610480919B20A090882E39BA309497AC829612884831569123AAAB243079C3900043CB92168868D121F5A4032A1234B991500883419C302801A0436887C78F0A88586144E047418136589130005EA';
wwv_flow_api.g_varchar2_table(63) := 'E0240204929074429644A1728014882D3F0C80C014358A920ADF6E79A241C6EB1D8285EE78AD839610890F7508B6B69D4BB7AEA0400021F90400050014002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F';
wwv_flow_api.g_varchar2_table(64) := '2828249888049B1C8305920A1C044282A02841820B374102909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BA9D8BAB28DC89C29B03B28AEBED8842BEF18B141C37E4';
wwv_flow_api.g_varchar2_table(65) := '8A05380870A8D7AD1B0E0727E415227129D20425597858307443068B20DF1A1D8123A74C0500055EB4027062C59629231D799063C6CD10005EB8D47802408A85156CD48078F4040A9E220214ACE962A404C8295E569CD8F9480831002EC2748973849480';
wwv_flow_api.g_varchar2_table(66) := '1709AA617211A74B983C19BBD110E3D546C14247BC1A381BED8201A66C06E3CA9D0B20100021F90400050015002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A0';
wwv_flow_api.g_varchar2_table(67) := '2841820B3740A48F9A282F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28C140404138B0540BAA98BAB28DB8924BE37DE88036A09319D8942EFF1872D614D26B71215C0412008BB451D84ECE34608';
wwv_flow_api.g_varchar2_table(68) := '079121200EB9B814294817336E1C18A215EB11893065AEF89000A000016A0050849082E2C1230721DDA85801E0420D0903000439B192C0230976DCA4C823408189352668A6E429CA919408518ADCA251630D1D8D2581005100C9C538413420AC99438421';
wwv_flow_api.g_varchar2_table(69) := '210A73D67CB160969003B56A0DDA0EA220838500B978F3E60D040021F90400050016002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820B3740A48F9A28';
wwv_flow_api.g_varchar2_table(70) := '2F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28CB937138B0540BA978A42604A3512378A24BE048B24293D3D3B1FE8F18C174C2935D80A15C0412048C0431D5C78E36668828518200EB9380709C8';
wwv_flow_api.g_varchar2_table(71) := '181F2AF215828722D623216D7CA410910700396200800C7BE404C6482875006C9150A5154714A21A81E0922243140705403068E0E484A009D21E3C629041839388142434C8135310058A8D28C838A1C0EA9D060886302404220FD82D63091938E024675A';
wwv_flow_api.g_varchar2_table(72) := '931C07A8BD9D4B976E200021F90400050017002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202';
wwv_flow_api.g_varchar2_table(73) := 'B10013BDBF8E051CB4CA83422F283892052ECF841D349142A88DC68C2B18306B9D890540B9DB8A42183BEF6F8A24BD048B241959597033ECBDA28B439A889883AD50011C0482143CA4C005B851861ECC3000E21085858B70B41101E5822112D2603D1202';
wwv_flow_api.g_varchar2_table(74) := '010F132A555A5D020044D8A32A269570310040CD8F21C384F402E208441B264DBACC28208048911952043D78F1C25B23274D2210A948C346910F2C06755000A9C314355C01742852C48B1A8884047C286201055A42380D2E2458F756D0C3BA78F3D60D04';
wwv_flow_api.g_varchar2_table(75) := '0021F90400050018002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202B10013BDBF8E051CB4CA';
wwv_flow_api.g_varchar2_table(76) := '83422F283892052ECF841D34912EA88DC68C432218239D8905400304D8864278567070178A24BDA28A42516666656FF8F68C627449E2811D251C04821834A48006B85186165C4820E01085858A26CC51C2858D2112D280407251810A99385E04D1502008';
wwv_flow_api.g_varchar2_table(77) := '482F6F8D1C2C211366841A005262A4D925A4D7044720E6D05C13A380802143D45003F0E0C5008C86888469F3A662871943A6DC2305025287102D8C81B83024C1568882580C39310CED2005370A7EBA9D4BB7AE5D4381000021F90400050019002C000000';
wwv_flow_api.g_varchar2_table(78) := '00200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A02841822404400590322D282F1D0042033714B89B28BC8F3910B40B8202B10013BEC08E40505F4FCC83422F283892380EC587';
wwv_flow_api.g_varchar2_table(79) := '1D348F052E2442028DC88A245F1A19221BA88905400304B7895E76763C3C650EE7BEA28933DC0814E84591105FAC1291A0D304CA920697DEE178A56051251211472122C12604394314A4395A70204E8D048648540302890682381BE8D411A400842020BE';
wwv_flow_api.g_varchar2_table(80) := 'DC357A6364C31C094F00047932E0D6C14DDB180990B0E14B8513000AB0A0C512C00379151DCD70CA869C0035B4FE01380649819417C80AA4A1AAB11090272F0D44B6A590B5ADDDBB78F32A0A040021F9040005001A002C00000000200020000007FF8000';
wwv_flow_api.g_varchar2_table(81) := '82838485868788898A8B8C8D8E8F9091928405422E938A0F28282498831D0583049B1C9E00694D3F4282A3284182240440A18F733D29061D0042033714BB9B28BF8F123B3D460F8202B413C1C38E38493B654F86422F283892383F6CB4851D348F053496';
wwv_flow_api.g_varchar2_table(82) := '028DDF892C1B4D4C495F9D8905400304BA88204658FB3030488A2482BDC2B7218341830E1409090644518B0D64C88C61100F51011CB2402C022144883853895C2478926E1085678F48389973A7852112D81A3EA25085CE813C090481D0080047B08F8DD8';
wwv_flow_api.g_varchar2_table(83) := '983880E0C70D003007E85AB869C123220718207109A095CC05F578365293A7889A50056E6C1A08A0404946139289DAA40D24215E040D14B82D6476AEDDBB78F31E0A040021F9040005001B002C00000000200020000007FF800082838485868788898A8B';
wwv_flow_api.g_varchar2_table(84) := '8C8D8E8F9091928405422E938A0F2828249883144283049B1C9E002D4D294582A328418224044005901E593A56060042033714BB9B28BF8F0C705A3B128202B40013C1C38E385470671786422F28389213255BCC851D348F05344234E08AE9886973644B';
wwv_flow_api.g_varchar2_table(85) := '111EA189054003041D89203551511A1A7888282211EC152201749A2854384391906040144931D1A6CD081BF31015C0210BC422102E5C40337588469A1BEB045118E9C885853C3F6E1822912DE223106F8E54F9804210088F0070041BE70885932A5E623C';
wwv_flow_api.g_varchar2_table(86) := '00407340BE879B3A15AD62E1C200569B6C2EB807B49182136C640228706393C1B129190920C461D30292850E2870E0D015AEDDBB78F3EA5D14080021F9040005001C002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405';
wwv_flow_api.g_varchar2_table(87) := '422E938A0F2828249883344283049B1C9E002D50195582A3284182240440059007665665320042033714BB9B28BF8F473C6756398202B40013C1C38E13643C767586422F283892135E32CC851D348F05142E34E08AE988520762617139E389054003040A';
wwv_flow_api.g_varchar2_table(88) := '8902155D5D114B4B2E2822110C88BE3B6312261CA24848414503189830D1C0C13C440570C802B14800051A1D4C29EAF0C2E0210AD01E5188E185CD034324B2997C74E2439D29DB0080E00800C7B3472456D439F1645CCC01211D6EBAE4C8051B19695E02';
wwv_flow_api.g_varchar2_table(89) := '686572C18D200220D9EB04A0C08D4DAF04AD9B1464D30291851404993016ADDBB77005E3CA4514080021F9040005001D002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840F172E93840B13845F4D522498005349782582';
wwv_flow_api.g_varchar2_table(90) := '142A4A521CA1156E576E4400141964284182240440058F4E306E766806004E6D3714004228CCC98E0F6130683C158213BD0013CC28CE8E37D13E1686422F2838920F1F1702871D3490EE14D88BF3892F477310104EEF890540030828482420CF9A366DC4';
wwv_flow_api.g_varchar2_table(91) := '1861A388C43620FE907C99389158A265CC2026E2500501022717BA1D2A8063178845023A5018184A91021C42105110E9084488044F2E1522514EE3A317539EA0D80400C4490038B6D1741942E88B773C077450B64D67A3020350BC0005804046410B6EE0';
wwv_flow_api.g_varchar2_table(92) := 'A8C748C102AB3798E11244761210660B0F5A1A1230E19ADCBB78F3EADD8B29100021F9040005001E002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B45330A938242172184743B3A479902071822168214783B3D2699';
wwv_flow_api.g_varchar2_table(93) := '345C19292A0E00141AAC4482240440058F0C1A1958183200363C5828004228CE148F131B1A2A301282040F8213CE28D08F1C231A223386422F283892242B3102871D34900A141DBF8CF78A421639121225DF101500328000A644431A54F0E0C144024524';
wwv_flow_api.g_varchar2_table(94) := 'BA0151148381458B2CF44954E4828D03071F4E74505400472F108C1428409969910017230F5108F8A80007142F5C1822816E22246ECE260802C11247379A8C08387B218FE78091CD9E410282930436673E17DC5007A9808B83006E380B32285F4BA328AC';
wwv_flow_api.g_varchar2_table(95) := 'B63424E081DAB57007E3CA9D4B576E20003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7764235811441329 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't3loading.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D494844520000003200000062080600000012B180460000001974455874536F6674776172650041646F626520496D616765526561647971C9653C000003C34944415478DAEC9AC16EDB300C404547E9760AB0F617761FB0EF';
wwv_flow_api.g_varchar2_table(2) := 'C87DBDF5BA4FDAB5B7EDDEDFD8BE60BF900CD8696B6C695161171A434A942379992A0284950491F44C52A62883B5560180CA2CB10E6DCEC11C832E3C6160002037A0CE3079C8046ED1EFB614080861A46036020129403A110202DFC14C9069D296810009';
wwv_flow_api.g_varchar2_table(3) := '8C9E0101C2B61402B781684761F44C88984A02DA0654111609C26821843FC1CEFBDCA12B0544816035E83AB521E082229090053A4F81688760420066FCFFD4A6029D85D189EE344D7AC5B4E7804C3A785698C448DD4C27C4863FE915A11C0C078221BAF1';
wwv_flow_api.g_varchar2_table(4) := '3AA0B18D245674E479805D6982D0E88A81A6FF29E279E0BBD3E0417404BC25ACE3670756EA5A80AC314DFE2FDD6EB76FEEEFEF3FCD492DEEEEEE3E3E3C3CFC3836FBC022117DB6004A1AB9C0D608623DAADEED769F379BCD5BADF5660E48DFF73F8FF2FD';
wwv_flow_api.g_varchar2_table(5) := 'E6E6E67684398CDA8F3A8C578356B5E7A5FA89C10301C6A57C4BAC7D7510D7D7D7EF7364B0FBFDFEDB087340DA7B2E8861460EFBECC7B1651707B8CE09E1C4F5E5FA24E2AE933C703B417288037DE562C2B953EE4D8CEBD3F51D5809D9C414BB16E55653';
wwv_flow_api.g_varchar2_table(6) := '5C5C4D7ABC735F725A8370B10FC7E6A3A77EBC9CC40AE55A8A587E29AB9416E97329EA5A1059C54A4B17890DE0402031DF2A2D29193528C1DDE592C6252C9274033BE11675496BA48C09A11839B772B244394914ECFFA5CC01B10BCCCB9E0362231DDB85';
wwv_flow_api.g_varchar2_table(7) := '2052C6B4528B70FBEBD262224509D62236B1DAB1A43570C9889C6717E824B4C75EC22226006353823DB4BF2E2D031A33EA0D5D626C3C81B8EDA9DBD9E59EBDEBD3F5CD65B921182A8D574CB1C1DF1D1649E5510A4FED120D51F722D3F8506C0C9EF66E5B';
wwv_flow_api.g_varchar2_table(8) := 'EA06CE0C718BB6B6432456EA2E3E28A6C67BB25F2F580EC24A59C6E0D58B0389ED0E4B14E806EFCE0F4CE5C470EE459D215A66602A2B3D59CDCE2C990E84050C530252D2DA2F556B35C48210839853C436C4F2AB224F7712245430C6D571FF3820C7B182';
wwv_flow_api.g_varchar2_table(9) := '95B892F45821740E81ADD12190DC073D4A986F054FACB8434AE34D94FA2EC7D19BD8121290989B5955E63054A54248403818FC9D52E71D4F73131641484128370B1D52CE7D6140FADB59208A81508CCBE5D8A7177B85831A2076900F89935BF4A51AC9C0';
wwv_flow_api.g_varchar2_table(10) := 'B1F748B26F979F72AD975AD7BA4859BA9E5B4C74036920E540560DE4C240742D20EB5A40AE6A0179D5402E0CE47515B9D66EB7FB5A0588AD248F7FD1E7EC0DA481349006D2401A480369200DA481349006D2401A4803292F3AE77B89FF52DC21CFBB2A2C';
wwv_flow_api.g_varchar2_table(11) := '72D45FB580FC6E201706F2580BC8A11690BE1690A1815C90AC54256F3E54055285FC11600099D96EB6044F96220000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7764930635443697 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4border1.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000320000000108060000009CD1FDB20000001974455874536F6674776172650041646F626520496D616765526561647971C9653C0000004C4944415478DAB4C6DB0980400C44D1597C7E279D58928559929D';
wwv_flow_api.g_varchar2_table(2) := '24DFEB8B3842041BF0C2815B22028501F86A524B1DF534A4D1CC161199F043EEBEAAEACCADB4A59D0E3AE94AF17ABA051800996F19FFA6CE6F580000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7765627400445163 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4border2.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000001000000190806000000F090447F0000001974455874536F6674776172650041646F626520496D616765526561647971C9653C0000003B4944415478DA62FE0F044C0C40401AF1EEDDBB7320863E88FB03';
wwv_flow_api.g_varchar2_table(2) := '44FC8413BF40C46F6620C10C2298400423480C6CD17F10978119682D0340800100F83E11DAD6E5713A0000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7766324812446336 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4borderBottomCenter.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000019000000190806000000C4E985630000001974455874536F6674776172650041646F626520496D616765526561647971C9653C0000017B4944415478DAB4964F4AC43014C6F362FD8F4845A4A2880B5D7A';
wwv_flow_api.g_varchar2_table(2) := '0C773D8F9BAECB78062FE101BC457B0517DD155C77F27C91A63CC3CB246D35F0233030DFD7EF6B5E6614222A5A40E8918C38208E8933E28228883BE291786ADBF60D672C2B3A77E148F2D2DE9763C2B8E0A1944E7C6A8ED15A2F4A820103D10800706D12';
wwv_flow_api.g_varchar2_table(3) := 'DC6160D62489556518DBBEEF3FFFC2044329AC495DD71FC3307CA59F479C924BB372449C12E7C425713DCECB43D3349BD439F14D9CD11EB14F1C1227E350E6C4157143DCDBC1ECBAEE7DEE3062A032C3F62D31388AA278A1E97F8D550736091D493F8D7B';
wwv_flow_api.g_varchar2_table(4) := '5F3C9923F329CB32AFAAEA39CFF35B638CD504BB3B4DC9849BF1F7A43D23BE73F8C3FD68654245E0D56778F2409DAE4ACD4CA656B21D4718BCDD083741CC2068221928211537E115C19224A1FBCC899B80F8546D16B956C013865114BCB446104F328955';
wwv_flow_api.g_varchar2_table(5) := '8782280807246A1232F23F5321835413A93AA9465C6BA202062A50E36213490422BFFBB0D44425FCF9F8756B00BBEAFF6D7D0B3000E71323D3EAA8BF120000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7767022224447575 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4borderBottomLeft.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000019000000190806000000C4E985630000001974455874536F6674776172650041646F626520496D616765526561647971C9653C000001784944415478DAB495CB4AC43014869358C71B83282215415CE872';
wwv_flow_api.g_varchar2_table(2) := '5ECF3728FA0CCE43B8999D6FD1F6115C745770A5D226FE296909E1E4E625F0D19469F24DCEC94998CA684DD33C33C636E01EDC80129C833538022B500061E0183675729A3264B55C892B53916FF22542083D503A92E8EAB2249C73151028DF6A7EBA1219';
wwv_flow_api.g_varchar2_table(3) := '10A95FADA4EFFB373C464B245342962C1986E1BDAAAA574792969BD41AA9EBFA119FDF99FAB80217E0149C8043AA46CCFC6992AEEB5E4C01DE826B7009CE4C111E8303B00FF62CC12211B110A1CA9FCAB27CD0AF16A3152EE909D5F25EB46DBB5DB61A76';
wwv_flow_api.g_varchar2_table(4) := '8FDEA6FAA993AC73B0DBED7A4240E5C5B78DA7256DAC1FED7F373A0CCE33B6CBD41C2E9DA80FE2A8B0078F04D22360D48AB4E493905022AAEF86890C97967C05246E8547C343896C09F31417B58BA4E734F6267E4DC45225120D954E3C37371A0B88627D';
wwv_flow_api.g_varchar2_table(5) := '163AB766C92A70E184268B0A6C4911BAD542959C7215CF129178DDB29CC97D129529CA92F0BF982C2899CEFB7F6EDF020C0055B087FA515FFC4F0000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7767719421448870 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4borderBottomRight.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000190000000408060000007BA194260000001974455874536F6674776172650041646F626520496D616765526561647971C9653C000000364944415478DA62FCFFFF3F032310303030206366286601625620';
wwv_flow_api.g_varchar2_table(2) := '6603627628E678FBF6ED3C2121212306220113031DC0F0B10420C000308407049528EC860000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7768416833450069 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4borderMiddleLeft.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000190000000408060000007BA194260000001974455874536F6674776172650041646F626520496D616765526561647971C9653C0000002D4944415478DA62FC0F040C44024646460D20F50F88FF22E13F48';
wwv_flow_api.g_varchar2_table(2) := 'F41F34B97F40E3FF3131D0010C1F4B00020C008D50140553B6B0B30000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7769147013451200 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4borderMiddleRight.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D494844520000000400000019080600000016B98F3B0000001974455874536F6674776172650041646F626520496D616765526561647971C9653C0000003B4944415478DA62FCFFFF3F03326084623860214F8099A0000BBA';
wwv_flow_api.g_varchar2_table(2) := '002BBA001BBA003B41010E14BFBC7DFBF62C8AC07F34EF3231A081412B0010600015860B0107A9792A0000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7769844425452483 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4borderTopCenter.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000019000000190806000000C4E985630000001974455874536F6674776172650041646F626520496D616765526561647971C9653C000001094944415478DAB496510EC2200C86F9A1FA48E2CEE0093CC70EE8';
wwv_flow_api.g_varchar2_table(2) := 'EBDEF4703BC31423092B941544920E16B6FFA32D65C3B66DE6DF8DC205C0685D64905162D23C0D10862A5C1DE268985343501143E51935A424A219AB2112E0C876205202D2976D726F595F828990DACA6D62288C33103586280A3A61AC8648A054D0154C';
wwv_flow_api.g_varchar2_table(3) := '026510BE457978228058CF61F1BD8F0E29F391AE9EB8CDF37C5996E5DE5AF110BC4941A7D0AFEBFAF0DE5F89C86B20A5A3826FD39D2701304DD3EDA89AAD72EBF264AB01254829F93CE92EE42084487DB2862FE3F7A325D5430CCF39DADB8BA7D60BC913';
wwv_flow_api.g_varchar2_table(4) := '5329C2086E6AB6226E2A474A17048DE7D7CF9E482103ABE42E08943033DA939E3F94ACBD041800AC481BD8CAD99F980000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7770541621453737 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4borderTopLeft.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000019000000190806000000C4E985630000001974455874536F6674776172650041646F626520496D616765526561647971C9653C000001734944415478DAB4964D4EC33010853BE6B7FC2A80A0880A81044B';
wwv_flow_api.g_varchar2_table(2) := '96DC2227621F71072EC1263B0E907D720516D945AC4363C6D1B872078F139732D2AB2D379DAFEFC971025AEBC97F1790DCDA28D598300035B2B9DE042406A06321DB034D75C477226437009146694D844C038031F320C8428E0380210D822CE48C41B83A';
wwv_flow_api.g_varchar2_table(3) := '36DAF92400FC05990900B7399F77239CAD406E0310AB8530F7395B0159C8A307C2015C128C6F8C25E4C9597463E18DBFD9B808C4B774D343AAAA7AB30B4A290D00DA8C4DD37C6659F691E779438DB9B833DF86E821E643ACB66DBFCAB27CA548EF5173D4';
wwv_flow_api.g_varchar2_table(4) := '15EA1C758A3A42EDD30D6D4E8E2D3AA6C08D2B08B155D7F53B81EE5037A84B5442F7D8016A0FB5C320100531458E1E68375EA32EC8CD2173A35C375110135D9AA6CF4E6CAE9BA9145914C45451142F8E9B199D162781C87A888A7900254932779A28963F';
wwv_flow_api.g_varchar2_table(5) := '48BF8B82745D074273083CCEE320681D3CCD5D80EF1D626D2712E8EF7179DE7260E09AB52083FFDA573F020C00D48DB1DF250578C70000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7771238818454998 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4borderTopRight.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F60000FFFFFF4D4D4DFBFBFBE2E2E2E4E4E4FCFCFCCECECEA6A6A6ADADADD2D2D2F8F8F8EEEEEEABABABA4A4A4BCBCBCEDEDED9B9B9B868686A7A7A7EBEBEBF5F5F5A3A3A3BDBDBDC6C6C6727272757575797979969696E6E6E6';
wwv_flow_api.g_varchar2_table(2) := 'F7F7F7A2A2A2C0C0C0F9F9F9D8D8D8767676989898F0F0F0BBBBBBA0A0A0D1D1D1DFDFDF717171747474C4C4C4D6D6D6DBDBDBF2F2F2E0E0E06E6E6ECACACAD0D0D0C2C2C2F4F4F4999999B2B2B2E3E3E3EAEAEAAAAAAA5959595858586666665656566D';
wwv_flow_api.g_varchar2_table(3) := '6D6DB8B8B8E9E9E9E7E7E7F1F1F1C7C7C7B9B9B9B5B5B5919191AFAFAFB4B4B47D7D7D8181818484847C7C7C808080B1B1B1DCDCDC7F7F7F7A7A7ADDDDDDD4D4D4838383B6B6B65F5F5F6868686F6F6F5C5C5C5A5A5ACDCDCD8B8B8B878787BFBFBF9C9C';
wwv_flow_api.g_varchar2_table(4) := '9C8A8A8A8E8E8E9292928D8D8D8888886464646363636161616A6A6AD9D9D9D5D5D5959595CBCBCB9494946B6B6BC3C3C35D5D5D8F8F8F6060609D9D9D9F9F9FC9C9C9676767A8A8A8787878AEAEAE55555500000000000000000000000000000021FE1A';
wwv_flow_api.g_varchar2_table(5) := '43726561746564207769746820616A61786C6F61642E696E666F0021F904000500000021FF0B4E45545343415045322E3003010000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B39363493820F17218305353A3B';
wwv_flow_api.g_varchar2_table(6) := '12990A101822168214223B3D359E900B111918190E00141AAD3F820B3740028E02121A1929183200363C3E28004228D12E8F131B1A2A30A300041C8213D12814901C231A223386422F283892242B31C1861D988F0A141D058DFA8B02060C1224941097A8';
wwv_flow_api.g_varchar2_table(7) := '0090010408221A70A041050F2658282201AE5B220208186844D04211B46816111548E0C0C28713201415C0412088C2440A14A4CCD4CF450744145E3A2AC001C58B698548AC0312E95BB4098240CCC4014EE72202D15E60123AE0E64714401D3DF0494210';
wwv_flow_api.g_varchar2_table(8) := '54144401F80A22EF110505836E440B028BA620A62810BABA2D246082DCB978F3EADDCB7752200021F90400050001002C00000000200020000007FF800082838485868788898A8B8C8D8E870F138F8E172A585B938B0A1156595C0599830B312D831D4C9D';
wwv_flow_api.g_varchar2_table(9) := '510AA100200D494A338214A85A512082A08F24464A4C50B20A54565A5DA00B3740BA8C05474B4D514C530055573C5E004228DB2E8F0B264B501A088252A50013DB281493401E4B4A1786422F2838A1423132CB841D3493203AAC6AC42F510B224590AC18';
wwv_flow_api.g_varchar2_table(10) := '88A800900104D825A2E020A10D2752149150C74111882116425AB8A148DBB68E8A80243020E3890045057010082271918082AC1ABAE8808842CD470582A078D1AD10897A40323D5027A9152E0038D4FD64C461DB8B7F4707F03489A2A8A3A32F480822B0';
wwv_flow_api.g_varchar2_table(11) := '2D290064415E4E1238E8C6B620831570864A874248CE860BBCDEDDCBB7AFDFBF800705020021F90400050002002C00000000200020000007FF800082838485868788898A8B8C8D8E86244E3F148F8D123C650C958B1D4B3C664A209B8342322883344D3C';
wwv_flow_api.g_varchar2_table(12) := '674C0AA3002008606343821D54AB50A2001D952E5F61646017B064AB5C050A123340058E054462635D5D2C003F3E681F0036622D282E8F240C625C1148000221218255532828948F1308D23186402F2838A32E2753CE0C75A0B109C42E4601179190B162';
wwv_flow_api.g_varchar2_table(13) := 'C59483870A001940405E2216432EAC98C141110978283A2A7A72A2E4097E898480149988C200142F9A292A808340108B335F3D73D1EB10059CCF82C00C5788843E209B16809C20C8A0201C20812E120A93A0D101BD54C223EAC8C58017240411808714C0';
wwv_flow_api.g_varchar2_table(14) := '821B4104143C7883ECA0843A13014C8027246EC4055CEDEADDCBB7AFDFBD81000021F90400050003002C00000000200020000007FF800082838485868788898A8B8C8D8E8624550E148F8D08583E47958B0A63586E5D209B8305374183146458684A0AA3';
wwv_flow_api.g_varchar2_table(15) := '822B5F105B821D5CAB11A2000F1D8F05365F1B1B6C002046AB46050A0D6E11388F171E5F6B6D2D000E19186F00485A3D70538F2E3F1E10620E00052D69826D3D654734950B44E52786475844CF9B142169050C090022AF5201018E023202F182C5141408';
wwv_flow_api.g_varchar2_table(16) := '131500328000254538D68550B34011091420392C9A0012A40B45424A8A542400C78D1B131615C04120C84599AF12BAE87588C24D5F4150BC385988C40B1440367D0419B358441C257F322229549ED11BBD529AAC4461C000128208804C0A6081A9888F04';
wwv_flow_api.g_varchar2_table(17) := 'A0BD3196544E42541085BC3D546001D1B978F3EADDCB576F200021F90400050004002C00000000200020000007FF800082838485868788898A8B8C8D8E864216431D8F8D48512245958B0A6B511971209B84200A831D621A1960A6A3000F444E6A829D1A';
wwv_flow_api.g_varchar2_table(18) := '2A63A2000B2E950908070D090020101A1823000A12294A1C8F4F360C0D1E280033505143005572593A3F8F1D174E391E2B0005524F8223DE3A17952EE3392C8636703B61149B1D282F87200CBC11E2AA510183136EDCC0B1A800900104F6297281A2220A';
wwv_flow_api.g_varchar2_table(19) := '1A8A48587436D1E24545423636C4A170C248024124362C68D005A54314543E2A10C41FAF42245EA000B249634593C30408C2615126A309155F60CC798352C88A371D292030808420021579EABA014468A5020705DDC83A282C4B004851103C5BA80089A8';
wwv_flow_api.g_varchar2_table(20) := '6C08E3CA9D4BB7EEA8400021F90400050005002C00000000200020000007FF800082838485868788898A8B8C8D8E862E2B6C0A8F8D25115433958B2026114D23029B891D739F622082202F0F954F6C28820A7411506BA20B5F6E51528E135E3F48690002';
wwv_flow_api.g_varchar2_table(21) := '0D114974000A5F6567724EBE2B16454E04007560116C003F76CE56758E20536F0E365B00052FB1024666727046148F146A6F25BD8547F046249B2041821CA2F0C68290518D405028D08804010213161568D18240874514506844414311898D1C306EE4A8';
wwv_flow_api.g_varchar2_table(22) := '480848460F6EDC88A8A8000E02402E326288B0510117320D5198B7A94010142F5C1822B10EC8A68F1A5982100500C7469E8E1E687CD191E88D8B26350A7D0482C0007F000868340A60C10D204C2BD1047063ECA0B53514014CD07830AEA10224B6DADDCB';
wwv_flow_api.g_varchar2_table(23) := 'B7AFDFBF7D03010021F90400050006002C00000000200020000007FF800082838485868788898A8B8C8D8E860503038F8E6C236D32948B200C6D6307059A890A779E5F2082203243148F24280FA99D5C740200241E296E478E0A6A31179302476D5C1200';
wwv_flow_api.g_varchar2_table(24) := '0A1530687663B68C1D21AB333800322346990E29CC3C3F8F1C2C062B210005379305236E76651BAD8E20042C5B1C864557656B249A05240B87285CF8E04254231038F831224180C0844513C0D8C960609182172832D25084E4CC151F6D508DC2A8511101';
wwv_flow_api.g_varchar2_table(25) := '360958DC60B4E0C68D878A0AE020004481C19B880AB8E88088023C4A0582A07851B010098C4034BDCA0813C4331C1951FC6CF420E38B8D476FF01412B5683C02371412C89814404B20CF800EBA417650289C821126641402171209AF75F3EADDCBB7AFA8';
wwv_flow_api.g_varchar2_table(26) := '400021F90400050007002C00000000200020000007FF800082838485868788898A8B8C8D8E8720028F8E41453F40938C1F155F1F998A023F15100C920002096C1D8F054234820244A3079242775119488F414F213800050E153547052039782A2962A68B';
wwv_flow_api.g_varchar2_table(27) := '022F282D5324002177742D0033B829580E8F402852213782139805741929305FAB8E201CE20B8644293E104299ADAF861D752B5C7C6A0462823E4642081098B0684218371A642C02010D058A7E88F2E8D8984481228A162F2A3AD2A36413108B16DCB8C1';
wwv_flow_api.g_varchar2_table(28) := '50D1030F54A8841808AA59A3022EDE19A240E1538120285E082C44021AA6492442B68C240847C89E8F1E587CF1AAE88D5542420E8547E0063500042C1E5509A480CF4137C40E324B73D0048B070FDB162A4062ABDCBB78F3EADD8B37100021F904000500';
wwv_flow_api.g_varchar2_table(29) := '08002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90870A69210A918B53480C32978905439A3F0582022C321D901D9600021748393602002E47114D258F132F03420005754877B8204E54504C10B28C053728282F14002F3F082F';
wwv_flow_api.g_varchar2_table(30) := '00435D4D4C1A338F40CE280F8224E20512DA7815A88E201CCF2E865E4C781EF090052ED1861D5B75349D8C404CE8C54808010213163D688381099B45020680FB97C8861C2B569480501471A2221B59426A5C64F04642450FC48858F210E0A102149439C2';
wwv_flow_api.g_varchar2_table(31) := 'B7CE10057DF782BC3344E2050A209148803B0942190E70381B3D70F6E25FCF1BA88480B3C78EC00D12820838030A60C10D1CA3228505D0ECE7A0B12E273823E8B2500112540ADBCA9D4BB7AEDDB981000021F90400050009002C00000000200020000007';
wwv_flow_api.g_varchar2_table(32) := 'FF800082838485868788898A8B8C8D8E8F9088240B918C1C433337958A2C170E4383022F6A0A90202082059D251F050034446D631F8F242F03428269174417000225465C5D0DAE8D1C28282F14004075161C0006B25D4BBE8E38C9280F823424824E635D';
wwv_flow_api.g_varchar2_table(33) := '5439A58E20C82F34861764E4EB90052ECC860A275BF09B8A020F4142C689841020306111901A1A5424F992CF908001DA1A1ABA63A7228F2B32121580984C62210466429AB16340910B02370A2A7AB0210A13264E04E83354A083CD47F23A2062314467BC';
wwv_flow_api.g_varchar2_table(34) := '20CA5C182291E04B1BA1B5B4A90421134036290E50407A904C1D005B37740AD196EB110894DF0010480644D0821B3800E21C7483EC20B5FA132624EB3AB350011248EBEADDCBB7AF5FBE81000021F9040005000A002C00000000200020000007FF800082';
wwv_flow_api.g_varchar2_table(35) := '838485868788898A8B8C8D8E8F90882002918C424F2C24958A0469322C83051C409120058337690632821D6F1E262D8F422F3742829D5B5300052B26106B0E8F1C28282F1400422D0613006A15C0625B8F38C5280F820A34820E5F6B46480A8F20C42FDB';
wwv_flow_api.g_varchar2_table(36) := '855B1B7136E78F052EC886202C27F19B8A020B4040F6884204049A29E230874A12266250241230C05ABB433952A4C04211C22944041C2ABAE3A66347088A5C10B82130110E084A94509943E09EA1021D625E64F4AEC321104386D8845420883117861C68';
wwv_flow_api.g_varchar2_table(37) := 'D13206E82312D6044E1294068A1E1D31203D28660E00895A368518C0A387082410233501C88882148005322A947487AA98595E2E14074D28762B6EA102248CDADDCBB7AFDFBF9B02010021F9040005000B002C00000000200020000007FF800082838485';
wwv_flow_api.g_varchar2_table(38) := '868788898A8B8C8D8E8F908805918D1437040A948A1C28281C8420939005A200049D2F820A094417998E3437374282A75203000532473907288F41A814004203282E0052360C0D0D9F8E389D280B8220AF75CC265EA58C209C2FC3856A07740E1D91052E';
wwv_flow_api.g_varchar2_table(39) := 'E185204F21E79A8B02243838EB882E0404138B40076364BA40C095E854271A8A8E3089C2508307450651204C942783458B0F13512070839FA2091EC8800153E1593C42053A7478D5281DBC420262C478E9A840B017C80A31B022C7484E4724A479042140';
wwv_flow_api.g_varchar2_table(40) := '50981D5AACB081F4001542122F6E9C43A203A90348203892A8D5090800050DDC88F1386AD08DAE831E143D096042275A6C0E0B1520F133AEDDBB78F3EAA514080021F9040005000C002C00000000200020000007FF800082838485868788898A8B8C8D8E';
wwv_flow_api.g_varchar2_table(41) := '8F909192840A40400293894028280F9983050583049C1C8205035304901D37374282A42841824F330E0E348F389C2F1D004203031400412B0E45552E8F139C280B820220822C1645477590201C282FC485525579170A91052EDF85023703E59F8905420F';
wwv_flow_api.g_varchar2_table(42) := '0FBF8A140404138B1379356D620D562592854257A21F64BA74891021872282061115694291E21D7B046EE853F4E08E988F3968BDA3A4C05DA373F5D46DD992D2518120DD9615CAC3E3CA86888D4838DB080213002356CED83100E9412F5D245EDCF855C4';
wwv_flow_api.g_varchar2_table(43) := '4A502FDA329288C50908000512B07031656ED08DAA83164C7BD70C05AC91840A909089B6ADDBB77004E3360A040021F9040005000D002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840A40380293893828280F99830505';
wwv_flow_api.g_varchar2_table(44) := '83049C1C83241C14901D37374282A4284182402C062190139C2F1D00420303AA242132756C988E0F9C280B820220821CC533B88F021C282FAA8538751F09D090052EDB863841E19F8805342424C889140404138B0B44071E2648408AB12834147DD8B0A6';
wwv_flow_api.g_varchar2_table(45) := '8D4124FE96054CE460CC98300E6D289277A39E221247BE7C99630387BA420A14A46334AE97210A6F2E987C5420483617868EB8C132E7D52312CB2C820828800B0F343EE82878A42C5B40122FBEB0018084078F2B584E3C0241E0060958283C9029A0E04B';
wwv_flow_api.g_varchar2_table(46) := '99A75E22891274030591AD006878C0A264C0275D17148880E270F55301120B467EDCCBB7AFDFBF9002010021F9040005000E002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928402130B0593893828280B99839883049C1C';
wwv_flow_api.g_varchar2_table(47) := '83142E911D04374282A3284182132F283890139C2F1D0042030314BC9C2D2F900B9C9D820220B2282D6A4090051C282FC085422D5328A18F052ED68642979F8BA71DDC88140404138B422B454E361FAD89AF28348A31070D15151E5B14DDCB97E8C29783';
wwv_flow_api.g_varchar2_table(48) := '0763285277A39D22214424DCB9E30015394220327673B1CB908B156C3A760B42CD22211B19343430D988C431874F4A29E08245059E0322193DC8950F880A3401ABF8C082018F974720569110F442C58E31054078188A61848068835AF8D841069310083E';
wwv_flow_api.g_varchar2_table(49) := '52FCF8F4E28A8E22A6D884FC44E148959C1708E3CA9D4BB72EA4400021F9040005000F002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A3828280B9888049B1C831D1D910A1C044282A0284182132F2F978F';
wwv_flow_api.g_varchar2_table(50) := '0F9B2FA54203031400429BAD900BBF9D000220AFBFAA8F051C282FBC85BE283892052ED08614349E8C0A14C78B140404138B1D532B1F2B528BAC28DB892C554548483FF09FBFF887530CFE0C365C281277A3DCC037486C1061C7AD9000050296B9286588';
wwv_flow_api.g_varchar2_table(51) := '460C190A221508E24C60A11F4D2220D8C788C4AF72025AB802214603142A792836AAE56C5B0E39580C0070204243122A2B1E812070E31205153AE01829004242CF24260A40920A80048CA461A4BAF020228A054F6D92FE1844C100464F138EFC90D9B0AD';
wwv_flow_api.g_varchar2_table(52) := 'DBB77004E3460A040021F90400050010002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A1328280B9888049B1C832020910A1C044282A02841820F2F0334900F9B2F1D0042033714B99B2838900BBF9D0002';
wwv_flow_api.g_varchar2_table(53) := '02829A9BAA8F051C282FBD85429BC191052ED28614B39E8B0220058C14040413DF2F6A092CCC89AC28DD883775431717278BEFF1875216FE16061651E070E39CA20E0666BC8971C95B2101E29AB9C06588860C35A520150802CD85212F63DA54D1D688C4';
wwv_flow_api.g_varchar2_table(54) := 'AF73029E000100E24B042E71AA2878540BDA2C043C44E0FB4025029838311E812070E312053C56CA6C2800228F129F39223A8A280443D236E268DCA1D2E58DA71156789418D421CD94999826D87080D6A1DBB77005E3CA9514080021F90400050011002C';
wwv_flow_api.g_varchar2_table(55) := '00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052442938A0F28280B9888049B1C832005910A1C049700A02841820F2F371D909A282FB34203371400429B280F900BBF9D0002028213BFAA8E051CB6BC85422F283892052E';
wwv_flow_api.g_varchar2_table(56) := 'D1861D349E8C05A58C140404138B0540030340C88AAC28DD890F4F2D6969D6EEBFF1884132FE32AE1451E070C39C22102D4E9C9002C29B217090B0CDDAC6E249C3884150480961E802040F1F263A72B1E9C81C632150183BD0A6069D0F171B697A83C50B';
wwv_flow_api.g_varchar2_table(57) := '00273EF0180030244E9B1173123C02F1420C03011492D88161C25895303F7F4012500C07163B3EDA20A3E0C4489B189816A8C0AA5590828D3123515062C7CD1D8785102EE0A192066EA10724ECEADDCB9750200021F90400050012002C00000000200020';
wwv_flow_api.g_varchar2_table(58) := '000007FF800082838485868788898A8B8C8D8E8F9091928405242E938A0F2828249888049B1C830205910A1C044282A02841820F030420909A282F1D0042033714B99B280B900BBFC100A48213BFAA8F051CB6BD85422F283892052ED0861D349E8CA58D';
wwv_flow_api.g_varchar2_table(59) := '140404138B0540BBD58BAC28DC89C3BFD99FBFED88EF9BF187141C37E48A05412F06A4EB46F05A10018640A0B8811052B322587E1892C1C0C6160590842030B30382B1342F8C39A970E7089B868D6658E901670680221994240060600EC93C2D1EA5C9E0';
wwv_flow_api.g_varchar2_table(60) := '268F800E4B52E0B963CCCB1C0F12D84022F14010092629447C29D5C182893B52303D8D5AE39B801BAE30B9689222830982853C447D8396D082126F0830B69D4BB7AEA0400021F90400050013002C00000000200020000007FF800082838485868788898A';
wwv_flow_api.g_varchar2_table(61) := '8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820F031C02909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BAC48BAB28DC89C2';
wwv_flow_api.g_varchar2_table(62) := '9BB6EABEED8842BEF18A141C37E48A0538043800EB4610480919B20A090882E39BA309497AC829612884831569123AAAB243079C3900043CB92168868D121F5A4032A1234B991500883419C302801A0436887C78F0A88586144E047418136589130005EA';
wwv_flow_api.g_varchar2_table(63) := 'E0240204929074429644A1728014882D3F0C80C014358A920ADF6E79A241C6EB1D8285EE78AD839610890F7508B6B69D4BB7AEA0400021F90400050014002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F';
wwv_flow_api.g_varchar2_table(64) := '2828249888049B1C8305920A1C044282A02841820B374102909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BA9D8BAB28DC89C29B03B28AEBED8842BEF18B141C37E4';
wwv_flow_api.g_varchar2_table(65) := '8A05380870A8D7AD1B0E0727E415227129D20425597858307443068B20DF1A1D8123A74C0500055EB4027062C59629231D799063C6CD10005EB8D47802408A85156CD48078F4040A9E220214ACE962A404C8295E569CD8F9480831002EC2748973849480';
wwv_flow_api.g_varchar2_table(66) := '1709AA617211A74B983C19BBD110E3D546C14247BC1A381BED8201A66C06E3CA9D0B20100021F90400050015002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A0';
wwv_flow_api.g_varchar2_table(67) := '2841820B3740A48F9A282F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28C140404138B0540BAA98BAB28DB8924BE37DE88036A09319D8942EFF1872D614D26B71215C0412008BB451D84ECE34608';
wwv_flow_api.g_varchar2_table(68) := '079121200EB9B814294817336E1C18A215EB11893065AEF89000A000016A0050849082E2C1230721DDA85801E0420D0903000439B192C0230976DCA4C823408189352668A6E429CA919408518ADCA251630D1D8D2581005100C9C538413420AC99438421';
wwv_flow_api.g_varchar2_table(69) := '210A73D67CB160969003B56A0DDA0EA220838500B978F3E60D040021F90400050016002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820B3740A48F9A28';
wwv_flow_api.g_varchar2_table(70) := '2F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28CB937138B0540BA978A42604A3512378A24BE048B24293D3D3B1FE8F18C174C2935D80A15C0412048C0431D5C78E36668828518200EB9380709C8';
wwv_flow_api.g_varchar2_table(71) := '181F2AF215828722D623216D7CA410910700396200800C7BE404C6482875006C9150A5154714A21A81E0922243140705403068E0E484A009D21E3C629041839388142434C8135310058A8D28C838A1C0EA9D060886302404220FD82D63091938E024675A';
wwv_flow_api.g_varchar2_table(72) := '931C07A8BD9D4B976E200021F90400050017002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202';
wwv_flow_api.g_varchar2_table(73) := 'B10013BDBF8E051CB4CA83422F283892052ECF841D349142A88DC68C2B18306B9D890540B9DB8A42183BEF6F8A24BD048B241959597033ECBDA28B439A889883AD50011C0482143CA4C005B851861ECC3000E21085858B70B41101E5822112D2603D1202';
wwv_flow_api.g_varchar2_table(74) := '010F132A555A5D020044D8A32A269570310040CD8F21C384F402E208441B264DBACC28208048911952043D78F1C25B23274D2210A948C346910F2C06755000A9C314355C01742852C48B1A8884047C286201055A42380D2E2458F756D0C3BA78F3D60D04';
wwv_flow_api.g_varchar2_table(75) := '0021F90400050018002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202B10013BDBF8E051CB4CA';
wwv_flow_api.g_varchar2_table(76) := '83422F283892052ECF841D34912EA88DC68C432218239D8905400304D8864278567070178A24BDA28A42516666656FF8F68C627449E2811D251C04821834A48006B85186165C4820E01085858A26CC51C2858D2112D280407251810A99385E04D1502008';
wwv_flow_api.g_varchar2_table(77) := '482F6F8D1C2C211366841A005262A4D925A4D7044720E6D05C13A380802143D45003F0E0C5008C86888469F3A662871943A6DC2305025287102D8C81B83024C1568882580C39310CED2005370A7EBA9D4BB7AE5D4381000021F90400050019002C000000';
wwv_flow_api.g_varchar2_table(78) := '00200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A02841822404400590322D282F1D0042033714B89B28BC8F3910B40B8202B10013BEC08E40505F4FCC83422F283892380EC587';
wwv_flow_api.g_varchar2_table(79) := '1D348F052E2442028DC88A245F1A19221BA88905400304B7895E76763C3C650EE7BEA28933DC0814E84591105FAC1291A0D304CA920697DEE178A56051251211472122C12604394314A4395A70204E8D048648540302890682381BE8D411A400842020BE';
wwv_flow_api.g_varchar2_table(80) := 'DC357A6364C31C094F00047932E0D6C14DDB180990B0E14B8513000AB0A0C512C00379151DCD70CA869C0035B4FE01380649819417C80AA4A1AAB11090272F0D44B6A590B5ADDDBB78F32A0A040021F9040005001A002C00000000200020000007FF8000';
wwv_flow_api.g_varchar2_table(81) := '82838485868788898A8B8C8D8E8F9091928405422E938A0F28282498831D0583049B1C9E00694D3F4282A3284182240440A18F733D29061D0042033714BB9B28BF8F123B3D460F8202B413C1C38E38493B654F86422F283892383F6CB4851D348F053496';
wwv_flow_api.g_varchar2_table(82) := '028DDF892C1B4D4C495F9D8905400304BA88204658FB3030488A2482BDC2B7218341830E1409090644518B0D64C88C61100F51011CB2402C022144883853895C2478926E1085678F48389973A7852112D81A3EA25085CE813C090481D0080047B08F8DD8';
wwv_flow_api.g_varchar2_table(83) := '983880E0C70D003007E85AB869C123220718207109A095CC05F578365293A7889A50056E6C1A08A0404946139289DAA40D24215E040D14B82D6476AEDDBB78F31E0A040021F9040005001B002C00000000200020000007FF800082838485868788898A8B';
wwv_flow_api.g_varchar2_table(84) := '8C8D8E8F9091928405422E938A0F2828249883144283049B1C9E002D4D294582A328418224044005901E593A56060042033714BB9B28BF8F0C705A3B128202B40013C1C38E385470671786422F28389213255BCC851D348F05344234E08AE9886973644B';
wwv_flow_api.g_varchar2_table(85) := '111EA189054003041D89203551511A1A7888282211EC152201749A2854384391906040144931D1A6CD081BF31015C0210BC422102E5C40337588469A1BEB045118E9C885853C3F6E1822912DE223106F8E54F9804210088F0070041BE70885932A5E623C';
wwv_flow_api.g_varchar2_table(86) := '00407340BE879B3A15AD62E1C200569B6C2EB807B49182136C640228706393C1B129190920C461D30292850E2870E0D015AEDDBB78F3EA5D14080021F9040005001C002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405';
wwv_flow_api.g_varchar2_table(87) := '422E938A0F2828249883344283049B1C9E002D50195582A3284182240440059007665665320042033714BB9B28BF8F473C6756398202B40013C1C38E13643C767586422F283892135E32CC851D348F05142E34E08AE988520762617139E389054003040A';
wwv_flow_api.g_varchar2_table(88) := '8902155D5D114B4B2E2822110C88BE3B6312261CA24848414503189830D1C0C13C440570C802B14800051A1D4C29EAF0C2E0210AD01E5188E185CD034324B2997C74E2439D29DB0080E00800C7B3472456D439F1645CCC01211D6EBAE4C8051B19695E02';
wwv_flow_api.g_varchar2_table(89) := '686572C18D200220D9EB04A0C08D4DAF04AD9B1464D30291851404993016ADDBB77005E3CA4514080021F9040005001D002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840F172E93840B13845F4D522498005349782582';
wwv_flow_api.g_varchar2_table(90) := '142A4A521CA1156E576E4400141964284182240440058F4E306E766806004E6D3714004228CCC98E0F6130683C158213BD0013CC28CE8E37D13E1686422F2838920F1F1702871D3490EE14D88BF3892F477310104EEF890540030828482420CF9A366DC4';
wwv_flow_api.g_varchar2_table(91) := '1861A388C43620FE907C99389158A265CC2026E2500501022717BA1D2A8063178845023A5018184A91021C42105110E9084488044F2E1522514EE3A317539EA0D80400C4490038B6D1741942E88B773C077450B64D67A3020350BC0005804046410B6EE0';
wwv_flow_api.g_varchar2_table(92) := 'A8C748C102AB3798E11244761210660B0F5A1A1230E19ADCBB78F3EADD8B29100021F9040005001E002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B45330A938242172184743B3A479902071822168214783B3D2699';
wwv_flow_api.g_varchar2_table(93) := '345C19292A0E00141AAC4482240440058F0C1A1958183200363C5828004228CE148F131B1A2A301282040F8213CE28D08F1C231A223386422F283892242B3102871D34900A141DBF8CF78A421639121225DF101500328000A644431A54F0E0C144024524';
wwv_flow_api.g_varchar2_table(94) := 'BA0151148381458B2CF44954E4828D03071F4E74505400472F108C1428409969910017230F5108F8A80007142F5C1822816E22246ECE260802C11247379A8C08387B218FE78091CD9E410282930436673E17DC5007A9808B83006E380B32285F4BA328AC';
wwv_flow_api.g_varchar2_table(95) := 'B63424E081DAB57007E3CA9D4B576E20003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7771936445456167 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't4loading.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000010000004B080300000086081DB100000033504C54455252524747474F4F4F4141414B4B4B5050503A3A3A6060608A8A8A333333D2D2D25A5A5A515151F2F2F2898989FFFFFFE6E5E57774AF770000002B';
wwv_flow_api.g_varchar2_table(2) := '49444154785EA5C1850D80401000B09E3C6EFB4FCB0C84D462C661482D94FB93D3E6F969B79A94D0D270BD188803D257F447F70000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7772633642457429 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't5border.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000E10000004B0803000000B1EA10C00000018F504C54454F4F4FDEDEDEDBDBDBD2D2D2BBBABAB9B8B8EAEAEA9999999292925A5A5AD4D4D4E3E3E3C5C5C5AFAFAFA0A0A05B5B5BB7B7B73D3D3DBBBBBBC2C2';
wwv_flow_api.g_varchar2_table(2) := 'C2ACACAC626161AAAAAAB9B9B95B5A5A5E5D5D979797C4C4C49B9A9ABAB9B98D8D8D7C7C7CF2F2F22B2B2B2D2D2D2C2C2C4D4D4D2E2E2E303030CDCDCD393939ECEBEBE5E5E52F2F2FEAE9E92A2A2A4C4C4C434343383838323232363636D9D9D93A3A3A';
wwv_flow_api.g_varchar2_table(3) := 'D8D8D8CCCCCC4B4B4BC0C0C0424242E8E7E74747473131314A4A4A414141EFEEEE373737484848454545515151F1F1F13B3B3B3C3C3C333333494949E9E9E9464646505050EBEAEA5E5E5EEDEDED606060A8A8A8EFEFEF3535358A8A8AE7E6E644444482';
wwv_flow_api.g_varchar2_table(4) := '82825D5D5DE9E8E84E4E4E7575754040403E3E3EA7A7A7EEEDEDBEBEBE5C5C5C525252898989CECECEECECEC535353F6F6F6F0F0F07676765F5F5FE6E5E57878789F9F9F6A6A6AA6A6A6D0D0D08E8E8ECACACAB3B3B3F8F8F8838383ADADADF3F3F33F3F';
wwv_flow_api.g_varchar2_table(5) := '3F343434ABABABBFBFBFCFCFCF747474696969818181F9F9F9F4F3F3686868CFCECEFFFFFFA2A2A211BB09BD0000061D49444154785EC4D7658FE33C1000E0FC144318CACCCCCB8CC7CCCCF7E20FBFB19B6DE26E3655BB9BBBF9504BEE58F2237B1C5BDA';
wwv_flow_api.g_varchar2_table(6) := '593AFE7DFA076367E34E7B2CE5CB35EDBFD078D3CFD4CA7969DCBE2BEDBCD8582E44E1AE31BC04181A4100DBF0C6D862FA6E20661DB1A8CFDA55853064B91084871D13CD534A28DB2905CCD7747B4B9D345AF720BBF0C76100D0FEEB168B877FBB6DFD66';
wwv_flow_api.g_varchar2_table(7) := '84EDE0B84A68A097DB687E7A8768BB80EC79A029A5724064C05CEA1888BEF4B7687259687CC494527CEB9DDBA2EB0A396E7C55CC9C82F01CED3B4E80D0715E338208C4B80144066C600788FEF49FE83C404809211484BCBDB690E9A4B0E04C4158DA320F';
wwv_flow_api.g_varchar2_table(8) := '28C501428CE90F73CB575D1300524A74AD6377349DC0A8EFC8F6A71F985BA54B42A2280A01216FAF29E4BE23598EB1C88B11E321CB8004A22784B9268842688090427F3BE7AB2E239BC2D0A96434A46514188453D98990DECA7586910A992F561D34CBC1';
wwv_flow_api.g_varchar2_table(9) := 'D16C0EAA31991167C2FB68932896652988C7BABB6D7910D69F3843DEE9095B9342B6DADBE8A93086C286F5969CA7D333743F322107C6AACDD15EBC580B8C627C6FD4CC037126AC9B8F01A8AAAAF5606DEDE0F6B169F3CDF8CFED83B5B507BC5F21FB5E75';
wwv_flow_api.g_varchar2_table(10) := '41F52588A55658A8164940457A4237FD31AACF0B2D5768DD8050AE963F848DF8526CB94410B203BFCD80D309B35DF7D560932A3814DC2E4421ACBA3CA26E55921020D419D0135EA4B7CD47A568847C099BFF870F795E6B0D62AEF010151A9449D8843911';
wwv_flow_api.g_varchar2_table(11) := '17A642CCBBDD7EBE19776744AD5B49F6FBFD64A5AB01D027F4D20B20F7848A2B546E42285747AFC285F74EE3E5AA3C151A690713058030DFA4282453F8B49F60C7AB451B3D7185CF902D1C4CBEF4AC1191109630FE2D5CA8654E5A55599AAD21504012BC';
wwv_flow_api.g_varchar2_table(12) := '864916016BA8F23FD4F935F4D2610D23DAA547F972F1DE0261E2746F1003E1DD8B3A9CD51BABC38258871C2ED6A196999D34BA26D6A19BDE4E475687D2517E545B20CCA57A7156882074CF5220FACED2897096565400BE17CE521DE8D3B0145D3C4B797A';
wwv_flow_api.g_varchar2_table(13) := '8467293B68AAAD9345C2ED5EB119634342BE8775C483F7EB9BC2F7304114E8EE3E811F58F484FF7BC8D3C96604DF4341F8693921BFD3E84AC89D46F35D528C740313085D439A4E2070233D77A761E9110BB505C2CF5D41187A2FA581F7520A2B67C36A52';
wwv_flow_api.g_varchar2_table(14) := '18758C6C7F7AF0BD14E420E4ED6F15AEF6B618FBDF1678EE6DB1BFD2DB227AA1F83E0C7DF00151E2C0A79C18C1FB301221C470A5377E76A5377EE4C25FECD8CF4B02411407F0B49A5D7656098A2E1DBE730B413A459151D22F22925AC9835D824208BA45';
wwv_flow_api.g_varchar2_table(15) := '03758CFCC76B67B7DE8E8D0312F216F37B11610E7E90376FDE2321D39E8641C890FF289C0BE7C2F94DD33F158E6E219DDD42FC740B69770BE1EE16C34A9AE17BFED966EAF8B176747CBDF9BBE38B5057F38E5FD50911E9F8481A43A4A9BCE49F4CAFB61A';
wwv_flow_api.g_varchar2_table(16) := 'E010022B866001819468808021D2F19ABA2BA3B0D51501C6085117D6CB3B051A62D3005362B3783C10DD56E984E6B78E1522AC16A727A99111550684961DEBF80D1D9F9A704379B33A221CA818268E8D7066888B13F0372C404E2D4CC03089D560CAC2B5';
wwv_flow_api.g_varchar2_table(17) := '456FD66D615B24C812065F4984D9088B7AFA254416AAAEACFA28A622478448547BBAC2A5276F9649682EFC105622B3898A40A1EA22A203484284F2B15512615F451A5E21517A1691800E217444725E6143025E21A5B8110E00D03DEA1002B231F3FF616F';
wwv_flow_api.g_varchar2_table(18) := 'B6EB5030D7A1FF2EEDCCC85DFAF77EA8E90A72F44356E1E46F9AFEA46F1A6621C3BB9441C8305BB009FDF361A49A13CF87FC42F6199F4158E63DCD673B77EC12310CC571BCC3093A950A7277A24E0776BA402994525A722789C50E42254849879E9B6E4E';
wwv_flow_api.g_varchar2_table(19) := 'E97CFEE3F60959AA2483C3F1E0FDFE830FE9F8BEFDA7F0244321242109494842129290842424210949A87DC2562215DAFB529F70994806C2034A613309AB4BB7F096F7AA462CDCEED8B95B78171B7BE78D51186CEABDBE7101AFB9CCE1561FADB0CB0AD6';
wwv_flow_api.g_varchar2_table(20) := 'A757EFAF43B8BA982D0C8775CFA586DE02A9F0E7332D0B66649C8C8FBF37B63C965A4D4F8858180051552612229D4F081999CA02510A7D6957CED41EC2AEAE79C02B74E779BBBACC20CE832744299C2796DB3FFACACE06963885D6D8381B590022168211';
wwv_flow_api.g_varchar2_table(21) := 'E6EC9C910AEDDE7C43FA4F856FD2C2B9C2643C24B90000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7773330407458902 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't5controls.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F60000FFFFFFFF5500FEFBFAFEE3D6FEE6DAFEFCFCFED0BAFEAA80FEB08AFED4C0FEF8F6FEEFE8FEAF88FEA87EFEBFA0FEEEE6FE9F70FE8B52FEAB82FEECE4FEF6F2FEA77CFEC0A2FEC8AEFE7836FE7B3AFE7F40FE9B6AFEE7DC';
wwv_flow_api.g_varchar2_table(2) := 'FEF7F4FEA67AFEC3A6FEFAF8FEDAC8FE7C3CFE9C6CFEF0EAFEBE9EFEA478FED3BEFEE0D2FE7734FE7A38FEC7ACFED8C6FEDCCCFEF3EEFEE2D4FE7430FECCB4FED2BCFEC4A8FEF4F0FE9E6EFEB692FEE4D8FEEBE2FEAE86FE6012FE5F10FE6C24FE5E0EFE';
wwv_flow_api.g_varchar2_table(3) := '732EFEBB9AFEEAE0FEE8DEFEF2ECFECAB0FEBC9CFEB896FE9662FEB38EFEB794FE8346FE874CFE8A50FE8244FE864AFEB490FEDECEFE8448FE8042FEDFD0FED6C2FE884EFEBA98FE661AFE6F28FE7632FE6316FE6214FECFB8FE905AFE8C54FEC2A4FEA0';
wwv_flow_api.g_varchar2_table(4) := '72FE8F58FE935EFE9764FE925CFE8E56FE6B22FE6A20FE681EFE702AFEDBCAFED7C4FE9A68FECEB6FE9866FE722CFEC6AAFE6418FE9460FE671CFEA274FEA376FECBB2FE6E26FEAC84FE7E3EFEB28CFE5C0C00000000000000000000000000000021FF0B';
wwv_flow_api.g_varchar2_table(5) := '4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B39363493820F17218305353A3B';
wwv_flow_api.g_varchar2_table(6) := '12990A101822168214223B3D359E900B111918190E00141AAD3F820B3740028E02121A1929183200363C3E28004228D12E8F131B1A2A30A300041C8213D12814901C231A223386422F283892242B31C1861D988F0A141D058DFA8B02060C1224941097A8';
wwv_flow_api.g_varchar2_table(7) := '0090010408221A70A041050F2658282201AE5B220208186844D04211B46816111548E0C0C28713201415C0412088C2440A14A4CCD4CF450744145E3A2AC001C58B698548AC0312E95BB4098240CCC4014EE72202D15E60123AE0E64714401D3DF0494210';
wwv_flow_api.g_varchar2_table(8) := '54144401F80A22EF110505836E440B028BA620A62810BABA2D246082DCB978F3EADDCB7752200021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E870F138F8E172A585B938B0A1156595C0599830B312D831D4C9D';
wwv_flow_api.g_varchar2_table(9) := '510AA100200D494A338214A85A512082A08F24464A4C50B20A54565A5DA00B3740BA8C05474B4D514C530055573C5E004228DB2E8F0B264B501A088252A50013DB281493401E4B4A1786422F2838A1423132CB841D3493203AAC6AC42F510B224590AC18';
wwv_flow_api.g_varchar2_table(10) := '88A800900104D825A2E020A10D2752149150C74111882116425AB8A148DBB68E8A80243020E3890045057010082271918082AC1ABAE8808842CD470582A078D1AD10897A40323D5027A9152E0038D4FD64C461DB8B7F4707F03489A2A8A3A32F480822B0';
wwv_flow_api.g_varchar2_table(11) := '2D290064415E4E1238E8C6B620831570864A874248CE860BBCDEDDCBB7AFDFBF800705020021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E86244E3F148F8D123C650C958B1D4B3C664A209B8342322883344D3C';
wwv_flow_api.g_varchar2_table(12) := '674C0AA3002008606343821D54AB50A2001D952E5F61646017B064AB5C050A123340058E054462635D5D2C003F3E681F0036622D282E8F240C625C1148000221218255532828948F1308D23186402F2838A32E2753CE0C75A0B109C42E4601179190B162';
wwv_flow_api.g_varchar2_table(13) := 'C59483870A001940405E2216432EAC98C141110978283A2A7A72A2E4097E898480149988C200142F9A292A808340108B335F3D73D1EB10059CCF82C00C5788843E209B16809C20C8A0201C20812E120A93A0D101BD54C223EAC8C58017240411808714C0';
wwv_flow_api.g_varchar2_table(14) := '821B4104143C7883ECA0843A13014C8027246EC4055CEDEADDCBB7AFDFBD81000021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8624550E148F8D08583E47958B0A63586E5D209B8305374183146458684A0AA3';
wwv_flow_api.g_varchar2_table(15) := '822B5F105B821D5CAB11A2000F1D8F05365F1B1B6C002046AB46050A0D6E11388F171E5F6B6D2D000E19186F00485A3D70538F2E3F1E10620E00052D69826D3D654734950B44E52786475844CF9B142169050C090022AF5201018E023202F182C5141408';
wwv_flow_api.g_varchar2_table(16) := '131500328000254538D68550B34011091420392C9A0012A40B45424A8A542400C78D1B131615C04120C84599AF12BAE87588C24D5F4150BC385988C40B1440367D0419B358441C257F322229549ED11BBD529AAC4461C000128208804C0A6081A9888F04';
wwv_flow_api.g_varchar2_table(17) := 'A0BD3196544E42541085BC3D546001D1B978F3EADDCB576F200021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E864216431D8F8D48512245958B0A6B511971209B84200A831D621A1960A6A3000F444E6A829D1A';
wwv_flow_api.g_varchar2_table(18) := '2A63A2000B2E950908070D090020101A1823000A12294A1C8F4F360C0D1E280033505143005572593A3F8F1D174E391E2B0005524F8223DE3A17952EE3392C8636703B61149B1D282F87200CBC11E2AA510183136EDCC0B1A800900104F6297281A2220A';
wwv_flow_api.g_varchar2_table(19) := '1A8A48587436D1E24545423636C4A170C248024124362C68D005A54314543E2A10C41FAF42245EA000B249634593C30408C2615126A309155F60CC798352C88A371D292030808420021579EABA014468A5020705DDC83A282C4B004851103C5BA80089A8';
wwv_flow_api.g_varchar2_table(20) := '6C08E3CA9D4BB7EEA8400021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E862E2B6C0A8F8D25115433958B2026114D23029B891D739F622082202F0F954F6C28820A7411506BA20B5F6E51528E135E3F48690002';
wwv_flow_api.g_varchar2_table(21) := '0D114974000A5F6567724EBE2B16454E04007560116C003F76CE56758E20536F0E365B00052FB1024666727046148F146A6F25BD8547F046249B2041821CA2F0C68290518D405028D08804010213161568D18240874514506844414311898D1C306EE4A8';
wwv_flow_api.g_varchar2_table(22) := '480848460F6EDC88A8A8000E02402E326288B0510117320D5198B7A94010142F5C1822B10EC8A68F1A5982100500C7469E8E1E687CD191E88D8B26350A7D0482C0007F000868340A60C10D204C2BD1047063ECA0B53514014CD07830AEA10224B6DADDCB';
wwv_flow_api.g_varchar2_table(23) := 'B7AFDFBF7D03010021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E860503038F8E6C236D32948B200C6D6307059A890A779E5F2082203243148F24280FA99D5C740200241E296E478E0A6A31179302476D5C1200';
wwv_flow_api.g_varchar2_table(24) := '0A1530687663B68C1D21AB333800322346990E29CC3C3F8F1C2C062B210005379305236E76651BAD8E20042C5B1C864557656B249A05240B87285CF8E04254231038F831224180C0844513C0D8C960609182172832D25084E4CC151F6D508DC2A8511101';
wwv_flow_api.g_varchar2_table(25) := '360958DC60B4E0C68D878A0AE020004481C19B880AB8E88088023C4A0582A07851B010098C4034BDCA0813C4331C1951FC6CF420E38B8D476FF01412B5683C02371412C89814404B20CF800EBA417650289C821126641402171209AF75F3EADDCBB7AFA8';
wwv_flow_api.g_varchar2_table(26) := '400021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8720028F8E41453F40938C1F155F1F998A023F15100C920002096C1D8F054234820244A3079242775119488F414F213800050E153547052039782A2962A68B';
wwv_flow_api.g_varchar2_table(27) := '022F282D5324002177742D0033B829580E8F402852213782139805741929305FAB8E201CE20B8644293E104299ADAF861D752B5C7C6A0462823E4642081098B0684218371A642C02010D058A7E88F2E8D8984481228A162F2A3AD2A36413108B16DCB8C1';
wwv_flow_api.g_varchar2_table(28) := '50D1030F54A8841808AA59A3022EDE19A240E1538120285E082C44021AA6492442B68C240847C89E8F1E587CF1AAE88D5542420E8547E0063500042C1E5509A480CF4137C40E324B73D0048B070FDB162A4062ABDCBB78F3EADD8B37100021F904090500';
wwv_flow_api.g_varchar2_table(29) := '00002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90870A69210A918B53480C32978905439A3F0582022C321D901D9600021748393602002E47114D258F132F03420005754877B8204E54504C10B28C053728282F14002F3F082F';
wwv_flow_api.g_varchar2_table(30) := '00435D4D4C1A338F40CE280F8224E20512DA7815A88E201CCF2E865E4C781EF090052ED1861D5B75349D8C404CE8C54808010213163D688381099B45020680FB97C8861C2B569480501471A2221B59426A5C64F04642450FC48858F210E0A102149439C2';
wwv_flow_api.g_varchar2_table(31) := 'B7CE10057DF782BC3344E2050A209148803B0942190E70381B3D70F6E25FCF1BA88480B3C78EC00D12820838030A60C10D1CA3228505D0ECE7A0B12E273823E8B2500112540ADBCA9D4BB7AEDDB981000021F90409050000002C00000000200020000007';
wwv_flow_api.g_varchar2_table(32) := 'FF800082838485868788898A8B8C8D8E8F9088240B918C1C433337958A2C170E4383022F6A0A90202082059D251F050034446D631F8F242F03428269174417000225465C5D0DAE8D1C28282F14004075161C0006B25D4BBE8E38C9280F823424824E635D';
wwv_flow_api.g_varchar2_table(33) := '5439A58E20C82F34861764E4EB90052ECC860A275BF09B8A020F4142C689841020306111901A1A5424F992CF908001DA1A1ABA63A7228F2B32121580984C62210466429AB16340910B02370A2A7AB0210A13264E04E83354A083CD47F23A2062314467BC';
wwv_flow_api.g_varchar2_table(34) := '20CA5C182291E04B1BA1B5B4A90421134036290E50407A904C1D005B37740AD196EB110894DF0010480644D0821B3800E21C7483EC20B5FA132624EB3AB350011248EBEADDCBB7AF5FBE81000021F90409050000002C00000000200020000007FF800082';
wwv_flow_api.g_varchar2_table(35) := '838485868788898A8B8C8D8E8F90882002918C424F2C24958A0469322C83051C409120058337690632821D6F1E262D8F422F3742829D5B5300052B26106B0E8F1C28282F1400422D0613006A15C0625B8F38C5280F820A34820E5F6B46480A8F20C42FDB';
wwv_flow_api.g_varchar2_table(36) := '855B1B7136E78F052EC886202C27F19B8A020B4040F6884204049A29E230874A12266250241230C05ABB433952A4C04211C22944041C2ABAE3A66347088A5C10B82130110E084A94509943E09EA1021D625E64F4AEC321104386D8845420883117861C68';
wwv_flow_api.g_varchar2_table(37) := 'D13206E82312D6044E1294068A1E1D31203D28660E00895A368518C0A387082410233501C88882148005322A947487AA98595E2E14074D28762B6EA102248CDADDCBB7AFDFBF9B02010021F90409050000002C00000000200020000007FF800082838485';
wwv_flow_api.g_varchar2_table(38) := '868788898A8B8C8D8E8F908805918D1437040A948A1C28281C8420939005A200049D2F820A094417998E3437374282A75203000532473907288F41A814004203282E0052360C0D0D9F8E389D280B8220AF75CC265EA58C209C2FC3856A07740E1D91052E';
wwv_flow_api.g_varchar2_table(39) := 'E185204F21E79A8B02243838EB882E0404138B40076364BA40C095E854271A8A8E3089C2508307450651204C942783458B0F13512070839FA2091EC8800153E1593C42053A7478D5281DBC420262C478E9A840B017C80A31B022C7484E4724A479042140';
wwv_flow_api.g_varchar2_table(40) := '50981D5AACB081F4001542122F6E9C43A203A90348203892A8D5090800050DDC88F1386AD08DAE831E143D096042275A6C0E0B1520F133AEDDBB78F3EAA514080021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E';
wwv_flow_api.g_varchar2_table(41) := '8F909192840A40400293894028280F9983050583049C1C8205035304901D37374282A42841824F330E0E348F389C2F1D004203031400412B0E45552E8F139C280B820220822C1645477590201C282FC485525579170A91052EDF85023703E59F8905420F';
wwv_flow_api.g_varchar2_table(42) := '0FBF8A140404138B1379356D620D562592854257A21F64BA74891021872282061115694291E21D7B046EE853F4E08E988F3968BDA3A4C05DA373F5D46DD992D2518120DD9615CAC3E3CA86888D4838DB080213002356CED83100E9412F5D245EDCF855C4';
wwv_flow_api.g_varchar2_table(43) := '4A502FDA329288C50908000512B07031656ED08DAA83164C7BD70C05AC91840A909089B6ADDBB77004E3360A040021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840A40380293893828280F99830505';
wwv_flow_api.g_varchar2_table(44) := '83049C1C83241C14901D37374282A4284182402C062190139C2F1D00420303AA242132756C988E0F9C280B820220821CC533B88F021C282FAA8538751F09D090052EDB863841E19F8805342424C889140404138B0B44071E2648408AB12834147DD8B0A6';
wwv_flow_api.g_varchar2_table(45) := '8D4124FE96054CE460CC98300E6D289277A39E221247BE7C99630387BA420A14A46334AE97210A6F2E987C5420483617868EB8C132E7D52312CB2C820828800B0F343EE82878A42C5B40122FBEB0018084078F2B584E3C0241E0060958283C9029A0E04B';
wwv_flow_api.g_varchar2_table(46) := '99A75E22891274030591AD006878C0A264C0275D17148880E270F55301120B467EDCCBB7AFDFBF9002010021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928402130B0593893828280B99839883049C1C';
wwv_flow_api.g_varchar2_table(47) := '83142E911D04374282A3284182132F283890139C2F1D0042030314BC9C2D2F900B9C9D820220B2282D6A4090051C282FC085422D5328A18F052ED68642979F8BA71DDC88140404138B422B454E361FAD89AF28348A31070D15151E5B14DDCB97E8C29783';
wwv_flow_api.g_varchar2_table(48) := '0763285277A39D22214424DCB9E30015394220327673B1CB908B156C3A760B42CD22211B19343430D988C431874F4A29E08245059E0322193DC8950F880A3401ABF8C082018F974720569110F442C58E31054078188A61848068835AF8D841069310083E';
wwv_flow_api.g_varchar2_table(49) := '52FCF8F4E28A8E22A6D884FC44E148959C1708E3CA9D4BB72EA4400021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A3828280B9888049B1C831D1D910A1C044282A0284182132F2F978F';
wwv_flow_api.g_varchar2_table(50) := '0F9B2FA54203031400429BAD900BBF9D000220AFBFAA8F051C282FBC85BE283892052ED08614349E8C0A14C78B140404138B1D532B1F2B528BAC28DB892C554548483FF09FBFF887530CFE0C365C281277A3DCC037486C1061C7AD9000050296B9286588';
wwv_flow_api.g_varchar2_table(51) := '460C190A221508E24C60A11F4D2220D8C788C4AF72025AB802214603142A792836AAE56C5B0E39580C0070204243122A2B1E812070E31205153AE01829004242CF24260A40920A80048CA461A4BAF020228A054F6D92FE1844C100464F138EFC90D9B0AD';
wwv_flow_api.g_varchar2_table(52) := 'DBB77004E3460A040021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052424938A1328280B9888049B1C832020910A1C044282A02841820F2F0334900F9B2F1D0042033714B99B2838900BBF9D0002';
wwv_flow_api.g_varchar2_table(53) := '02829A9BAA8F051C282FBD85429BC191052ED28614B39E8B0220058C14040413DF2F6A092CCC89AC28DD883775431717278BEFF1875216FE16061651E070E39CA20E0666BC8971C95B2101E29AB9C06588860C35A520150802CD85212F63DA54D1D688C4';
wwv_flow_api.g_varchar2_table(54) := 'AF73029E000100E24B042E71AA2878540BDA2C043C44E0FB4025029838311E812070E312053C56CA6C2800228F129F39223A8A280443D236E268DCA1D2E58DA71156789418D421CD94999826D87080D6A1DBB77005E3CA9514080021F90409050000002C';
wwv_flow_api.g_varchar2_table(55) := '00000000200020000007FF800082838485868788898A8B8C8D8E8F90919284052442938A0F28280B9888049B1C832005910A1C049700A02841820F2F371D909A282FB34203371400429B280F900BBF9D0002028213BFAA8E051CB6BC85422F283892052E';
wwv_flow_api.g_varchar2_table(56) := 'D1861D349E8C05A58C140404138B0540030340C88AAC28DD890F4F2D6969D6EEBFF1884132FE32AE1451E070C39C22102D4E9C9002C29B217090B0CDDAC6E249C3884150480961E802040F1F263A72B1E9C81C632150183BD0A6069D0F171B697A83C50B';
wwv_flow_api.g_varchar2_table(57) := '00273EF0180030244E9B1173123C02F1420C03011492D88161C25895303F7F4012500C07163B3EDA20A3E0C4489B189816A8C0AA5590828D3123515062C7CD1D8785102EE0A192066EA10724ECEADDCB9750200021F90409050000002C00000000200020';
wwv_flow_api.g_varchar2_table(58) := '000007FF800082838485868788898A8B8C8D8E8F9091928405242E938A0F2828249888049B1C830205910A1C044282A02841820F030420909A282F1D0042033714B99B280B900BBFC100A48213BFAA8F051CB6BD85422F283892052ED0861D349E8CA58D';
wwv_flow_api.g_varchar2_table(59) := '140404138B0540BBD58BAC28DC89C3BFD99FBFED88EF9BF187141C37E48A05412F06A4EB46F05A10018640A0B8811052B322587E1892C1C0C6160590842030B30382B1342F8C39A970E7089B868D6658E901670680221994240060600EC93C2D1EA5C9E0';
wwv_flow_api.g_varchar2_table(60) := '268F800E4B52E0B963CCCB1C0F12D84022F14010092629447C29D5C182893B52303D8D5AE39B801BAE30B9689222830982853C447D8396D082126F0830B69D4BB7AEA0400021F90409050000002C00000000200020000007FF800082838485868788898A';
wwv_flow_api.g_varchar2_table(61) := '8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820F031C02909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BAC48BAB28DC89C2';
wwv_flow_api.g_varchar2_table(62) := '9BB6EABEED8842BEF18A141C37E48A0538043800EB4610480919B20A090882E39BA309497AC829612884831569123AAAB243079C3900043CB92168868D121F5A4032A1234B991500883419C302801A0436887C78F0A88586144E047418136589130005EA';
wwv_flow_api.g_varchar2_table(63) := 'E0240204929074429644A1728014882D3F0C80C014358A920ADF6E79A241C6EB1D8285EE78AD839610890F7508B6B69D4BB7AEA0400021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F';
wwv_flow_api.g_varchar2_table(64) := '2828249888049B1C8305920A1C044282A02841820B374102909A282F1D0042033714B89B28A98F0BBE0B8202A40013BEBC8F051CB5CB84422F283892052ED0851D349E8CC78C140404138B0540BA9D8BAB28DC89C29B03B28AEBED8842BEF18B141C37E4';
wwv_flow_api.g_varchar2_table(65) := '8A05380870A8D7AD1B0E0727E415227129D20425597858307443068B20DF1A1D8123A74C0500055EB4027062C59629231D799063C6CD10005EB8D47802408A85156CD48078F4040A9E220214ACE962A404C8295E569CD8F9480831002EC2748973849480';
wwv_flow_api.g_varchar2_table(66) := '1709AA617211A74B983C19BBD110E3D546C14247BC1A381BED8201A66C06E3CA9D0B20100021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A0';
wwv_flow_api.g_varchar2_table(67) := '2841820B3740A48F9A282F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28C140404138B0540BAA98BAB28DB8924BE37DE88036A09319D8942EFF1872D614D26B71215C0412008BB451D84ECE34608';
wwv_flow_api.g_varchar2_table(68) := '079121200EB9B814294817336E1C18A215EB11893065AEF89000A000016A0050849082E2C1230721DDA85801E0420D0903000439B192C0230976DCA4C823408189352668A6E429CA919408518ADCA251630D1D8D2581005100C9C538413420AC99438421';
wwv_flow_api.g_varchar2_table(69) := '210A73D67CB160969003B56A0DDA0EA220838500B978F3E60D040021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C8305920A1C044282A02841820B3740A48F9A28';
wwv_flow_api.g_varchar2_table(70) := '2F1D0042033714B89B28BC8F0BBE0B8202B213BEC08E051CB5CA83422F283892052ECF841D349E8CB28CB937138B0540BA978A42604A3512378A24BE048B24293D3D3B1FE8F18C174C2935D80A15C0412048C0431D5C78E36668828518200EB9380709C8';
wwv_flow_api.g_varchar2_table(71) := '181F2AF215828722D623216D7CA410910700396200800C7BE404C6482875006C9150A5154714A21A81E0922243140705403068E0E484A009D21E3C629041839388142434C8135310058A8D28C838A1C0EA9D060886302404220FD82D63091938E024675A';
wwv_flow_api.g_varchar2_table(72) := '931C07A8BD9D4B976E200021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202';
wwv_flow_api.g_varchar2_table(73) := 'B10013BDBF8E051CB4CA83422F283892052ECF841D349142A88DC68C2B18306B9D890540B9DB8A42183BEF6F8A24BD048B241959597033ECBDA28B439A889883AD50011C0482143CA4C005B851861ECC3000E21085858B70B41101E5822112D2603D1202';
wwv_flow_api.g_varchar2_table(74) := '010F132A555A5D020044D8A32A269570310040CD8F21C384F402E208441B264DBACC28208048911952043D78F1C25B23274D2210A948C346910F2C06755000A9C314355C01742852C48B1A8884047C286201055A42380D2E2458F756D0C3BA78F3D60D04';
wwv_flow_api.g_varchar2_table(75) := '0021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A028418224044005909A282F1D0042033714B79B28BB8F0BBD0B8202B10013BDBF8E051CB4CA';
wwv_flow_api.g_varchar2_table(76) := '83422F283892052ECF841D34912EA88DC68C432218239D8905400304D8864278567070178A24BDA28A42516666656FF8F68C627449E2811D251C04821834A48006B85186165C4820E01085858A26CC51C2858D2112D280407251810A99385E04D1502008';
wwv_flow_api.g_varchar2_table(77) := '482F6F8D1C2C211366841A005262A4D925A4D7044720E6D05C13A380802143D45003F0E0C5008C86888469F3A662871943A6DC2305025287102D8C81B83024C1568882580C39310CED2005370A7EBA9D4BB7AE5D4381000021F90409050000002C000000';
wwv_flow_api.g_varchar2_table(78) := '00200020000007FF800082838485868788898A8B8C8D8E8F9091928405422E938A0F2828249888049B1C9E000A41044282A02841822404400590322D282F1D0042033714B89B28BC8F3910B40B8202B10013BEC08E40505F4FCC83422F283892380EC587';
wwv_flow_api.g_varchar2_table(79) := '1D348F052E2442028DC88A245F1A19221BA88905400304B7895E76763C3C650EE7BEA28933DC0814E84591105FAC1291A0D304CA920697DEE178A56051251211472122C12604394314A4395A70204E8D048648540302890682381BE8D411A400842020BE';
wwv_flow_api.g_varchar2_table(80) := 'DC357A6364C31C094F00047932E0D6C14DDB180990B0E14B8513000AB0A0C512C00379151DCD70CA869C0035B4FE01380649819417C80AA4A1AAB11090272F0D44B6A590B5ADDDBB78F32A0A040021F90409050000002C00000000200020000007FF8000';
wwv_flow_api.g_varchar2_table(81) := '82838485868788898A8B8C8D8E8F9091928405422E938A0F28282498831D0583049B1C9E00694D3F4282A3284182240440A18F733D29061D0042033714BB9B28BF8F123B3D460F8202B413C1C38E38493B654F86422F283892383F6CB4851D348F053496';
wwv_flow_api.g_varchar2_table(82) := '028DDF892C1B4D4C495F9D8905400304BA88204658FB3030488A2482BDC2B7218341830E1409090644518B0D64C88C61100F51011CB2402C022144883853895C2478926E1085678F48389973A7852112D81A3EA25085CE813C090481D0080047B08F8DD8';
wwv_flow_api.g_varchar2_table(83) := '983880E0C70D003007E85AB869C123220718207109A095CC05F578365293A7889A50056E6C1A08A0404946139289DAA40D24215E040D14B82D6476AEDDBB78F31E0A040021F90409050000002C00000000200020000007FF800082838485868788898A8B';
wwv_flow_api.g_varchar2_table(84) := '8C8D8E8F9091928405422E938A0F2828249883144283049B1C9E002D4D294582A328418224044005901E593A56060042033714BB9B28BF8F0C705A3B128202B40013C1C38E385470671786422F28389213255BCC851D348F05344234E08AE9886973644B';
wwv_flow_api.g_varchar2_table(85) := '111EA189054003041D89203551511A1A7888282211EC152201749A2854384391906040144931D1A6CD081BF31015C0210BC422102E5C40337588469A1BEB045118E9C885853C3F6E1822912DE223106F8E54F9804210088F0070041BE70885932A5E623C';
wwv_flow_api.g_varchar2_table(86) := '00407340BE879B3A15AD62E1C200569B6C2EB807B49182136C640228706393C1B129190920C461D30292850E2870E0D015AEDDBB78F3EA5D14080021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F9091928405';
wwv_flow_api.g_varchar2_table(87) := '422E938A0F2828249883344283049B1C9E002D50195582A3284182240440059007665665320042033714BB9B28BF8F473C6756398202B40013C1C38E13643C767586422F283892135E32CC851D348F05142E34E08AE988520762617139E389054003040A';
wwv_flow_api.g_varchar2_table(88) := '8902155D5D114B4B2E2822110C88BE3B6312261CA24848414503189830D1C0C13C440570C802B14800051A1D4C29EAF0C2E0210AD01E5188E185CD034324B2997C74E2439D29DB0080E00800C7B3472456D439F1645CCC01211D6EBAE4C8051B19695E02';
wwv_flow_api.g_varchar2_table(89) := '686572C18D200220D9EB04A0C08D4DAF04AD9B1464D30291851404993016ADDBB77005E3CA4514080021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840F172E93840B13845F4D522498005349782582';
wwv_flow_api.g_varchar2_table(90) := '142A4A521CA1156E576E4400141964284182240440058F4E306E766806004E6D3714004228CCC98E0F6130683C158213BD0013CC28CE8E37D13E1686422F2838920F1F1702871D3490EE14D88BF3892F477310104EEF890540030828482420CF9A366DC4';
wwv_flow_api.g_varchar2_table(91) := '1861A388C43620FE907C99389158A265CC2026E2500501022717BA1D2A8063178845023A5018184A91021C42105110E9084488044F2E1522514EE3A317539EA0D80400C4490038B6D1741942E88B773C077450B64D67A3020350BC0005804046410B6EE0';
wwv_flow_api.g_varchar2_table(92) := 'A8C748C102AB3798E11244761210660B0F5A1A1230E19ADCBB78F3EADD8B29100021F90409050000002C00000000200020000007FF800082838485868788898A8B8C8D8E8F909192840B45330A938242172184743B3A479902071822168214783B3D2699';
wwv_flow_api.g_varchar2_table(93) := '345C19292A0E00141AAC4482240440058F0C1A1958183200363C5828004228CE148F131B1A2A301282040F8213CE28D08F1C231A223386422F283892242B3102871D34900A141DBF8CF78A421639121225DF101500328000A644431A54F0E0C144024524';
wwv_flow_api.g_varchar2_table(94) := 'BA0151148381458B2CF44954E4828D03071F4E74505400472F108C1428409969910017230F5108F8A80007142F5C1822816E22246ECE260802C11247379A8C08387B218FE78091CD9E410282930436673E17DC5007A9808B83006E380B32285F4BA328AC';
wwv_flow_api.g_varchar2_table(95) := 'B63424E081DAB57007E3CA9D4B576E20003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7774026956460534 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't5loading.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000280000002804030000007ED0A55E00000012504C5445FFFFFFFFFFFFFFFFFF000000FFFFFFFFFFFF47D7349F0000000574524E53EF801000CF924B9CD50000003E49444154785EEDD3210100201043D121';
wwv_flow_api.g_varchar2_table(2) := 'F0181240828B400210EB5F05CF1600715F3EBD211A9FCAC0A4B4D0150FAAE2064D9F6062A21DAD9DB73D82BDCC05FAB0061ABD2A80320000000049454E44AE426082';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 7774724368461750 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 't5loading_background.png'
 ,p_mime_type => 'image/png'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A210A09436F6C6F72626F782076312E352E35202D20323031342D30332D31330A096A5175657279206C69676874626F7820616E64206D6F64616C2077696E646F7720706C7567696E0A092863292032303134204A61636B204D6F6F7265202D206874';
wwv_flow_api.g_varchar2_table(2) := '74703A2F2F7777772E6A61636B6C6D6F6F72652E636F6D2F636F6C6F72626F780A096C6963656E73653A20687474703A2F2F7777772E6F70656E736F757263652E6F72672F6C6963656E7365732F6D69742D6C6963656E73652E7068700A2A2F0A286675';
wwv_flow_api.g_varchar2_table(3) := '6E6374696F6E28742C652C69297B66756E6374696F6E206E28692C6E2C6F297B76617220723D652E637265617465456C656D656E742869293B72657475726E206E262628722E69643D5A2B6E292C6F262628722E7374796C652E637373546578743D6F29';
wwv_flow_api.g_varchar2_table(4) := '2C742872297D66756E6374696F6E206F28297B72657475726E20692E696E6E65724865696768743F692E696E6E65724865696768743A742869292E68656967687428297D66756E6374696F6E207228652C69297B69213D3D4F626A656374286929262628';
wwv_flow_api.g_varchar2_table(5) := '693D7B7D292C746869732E63616368653D7B7D2C746869732E656C3D652C746869732E76616C75653D66756E6374696F6E2865297B766172206E3B72657475726E20766F696420303D3D3D746869732E63616368655B655D2626286E3D7428746869732E';
wwv_flow_api.g_varchar2_table(6) := '656C292E617474722822646174612D63626F782D222B65292C766F69642030213D3D6E3F746869732E63616368655B655D3D6E3A766F69642030213D3D695B655D3F746869732E63616368655B655D3D695B655D3A766F69642030213D3D585B655D2626';
wwv_flow_api.g_varchar2_table(7) := '28746869732E63616368655B655D3D585B655D29292C746869732E63616368655B655D7D2C746869732E6765743D66756E6374696F6E2865297B76617220693D746869732E76616C75652865293B72657475726E20742E697346756E6374696F6E286929';
wwv_flow_api.g_varchar2_table(8) := '3F692E63616C6C28746869732E656C2C74686973293A697D7D66756E6374696F6E20682874297B76617220653D452E6C656E6774682C693D287A2B742925653B72657475726E20303E693F652B693A697D66756E6374696F6E207328742C65297B726574';
wwv_flow_api.g_varchar2_table(9) := '75726E204D6174682E726F756E6428282F252F2E746573742874293F282278223D3D3D653F572E776964746828293A6F2829292F3130303A31292A7061727365496E7428742C313029297D66756E6374696F6E206128742C65297B72657475726E20742E';
wwv_flow_api.g_varchar2_table(10) := '676574282270686F746F22297C7C742E676574282270686F746F526567657822292E746573742865297D66756E6374696F6E206C28742C65297B72657475726E20742E6765742822726574696E6155726C22292626692E646576696365506978656C5261';
wwv_flow_api.g_varchar2_table(11) := '74696F3E313F652E7265706C61636528742E676574282270686F746F526567657822292C742E6765742822726574696E615375666669782229293A657D66756E6374696F6E20642874297B22636F6E7461696E7322696E20785B305D262621785B305D2E';
wwv_flow_api.g_varchar2_table(12) := '636F6E7461696E7328742E746172676574292626742E746172676574213D3D765B305D262628742E73746F7050726F7061676174696F6E28292C782E666F6375732829297D66756E6374696F6E20632874297B632E737472213D3D74262628782E616464';
wwv_flow_api.g_varchar2_table(13) := '2876292E72656D6F7665436C61737328632E737472292E616464436C6173732874292C632E7374723D74297D66756E6374696F6E206728297B7A3D302C72656C2626226E6F666F6C6C6F7722213D3D72656C3F28453D7428222E222B7465292E66696C74';
wwv_flow_api.g_varchar2_table(14) := '65722866756E6374696F6E28297B76617220653D742E6461746128746869732C59292C693D6E6577207228746869732C65293B72657475726E20692E676574282272656C22293D3D3D72656C7D292C7A3D452E696E646578285F2E656C292C2D313D3D3D';
wwv_flow_api.g_varchar2_table(15) := '7A262628453D452E616464285F2E656C292C7A3D452E6C656E6774682D3129293A453D74285F2E656C297D66756E6374696F6E20752869297B742865292E747269676765722869292C73652E7472696767657248616E646C65722869297D66756E637469';
wwv_flow_api.g_varchar2_table(16) := '6F6E20662869297B766172206F3B477C7C286F3D742869292E646174612822636F6C6F72626F7822292C5F3D6E6577207228692C6F292C72656C3D5F2E676574282272656C22292C6728292C247C7C28243D713D21302C63285F2E6765742822636C6173';
wwv_flow_api.g_varchar2_table(17) := '734E616D652229292C782E637373287B7669736962696C6974793A2268696464656E222C646973706C61793A22626C6F636B222C6F7061636974793A22227D292C4C3D6E2861652C224C6F61646564436F6E74656E74222C2277696474683A303B206865';
wwv_flow_api.g_varchar2_table(18) := '696768743A303B206F766572666C6F773A68696464656E3B207669736962696C6974793A68696464656E22292C622E637373287B77696474683A22222C6865696768743A22227D292E617070656E64284C292C443D542E68656967687428292B6B2E6865';
wwv_flow_api.g_varchar2_table(19) := '6967687428292B622E6F75746572486569676874282130292D622E68656967687428292C6A3D432E776964746828292B482E776964746828292B622E6F757465725769647468282130292D622E776964746828292C413D4C2E6F75746572486569676874';
wwv_flow_api.g_varchar2_table(20) := '282130292C4E3D4C2E6F757465725769647468282130292C5F2E773D73285F2E6765742822696E697469616C576964746822292C227822292C5F2E683D73285F2E6765742822696E697469616C48656967687422292C227922292C4C2E637373287B7769';
wwv_flow_api.g_varchar2_table(21) := '6474683A22222C6865696768743A5F2E687D292C4A2E706F736974696F6E28292C75286565292C5F2E67657428226F6E4F70656E22292C4F2E6164642852292E6869646528292C782E666F63757328292C5F2E676574282274726170466F637573222926';
wwv_flow_api.g_varchar2_table(22) := '26652E6164644576656E744C697374656E6572262628652E6164644576656E744C697374656E65722822666F637573222C642C2130292C73652E6F6E652872652C66756E6374696F6E28297B652E72656D6F76654576656E744C697374656E6572282266';
wwv_flow_api.g_varchar2_table(23) := '6F637573222C642C2130297D29292C5F2E676574282272657475726E466F6375732229262673652E6F6E652872652C66756E6374696F6E28297B74285F2E656C292E666F63757328297D29292C762E637373287B6F7061636974793A7061727365466C6F';
wwv_flow_api.g_varchar2_table(24) := '6174285F2E67657428226F7061636974792229297C7C22222C637572736F723A5F2E67657428226F7665726C6179436C6F736522293F22706F696E746572223A22222C7669736962696C6974793A2276697369626C65227D292E73686F7728292C5F2E67';
wwv_flow_api.g_varchar2_table(25) := '65742822636C6F7365427574746F6E22293F422E68746D6C285F2E6765742822636C6F73652229292E617070656E64546F2862293A422E617070656E64546F28223C6469762F3E22292C772829297D66756E6374696F6E207028297B21782626652E626F';
wwv_flow_api.g_varchar2_table(26) := '6479262628563D21312C573D742869292C783D6E286165292E61747472287B69643A592C22636C617373223A742E737570706F72742E6F7061636974793D3D3D21313F5A2B224945223A22222C726F6C653A226469616C6F67222C746162696E6465783A';
wwv_flow_api.g_varchar2_table(27) := '222D31227D292E6869646528292C763D6E2861652C224F7665726C617922292E6869646528292C4D3D74285B6E2861652C224C6F6164696E674F7665726C617922295B305D2C6E2861652C224C6F6164696E674772617068696322295B305D5D292C793D';
wwv_flow_api.g_varchar2_table(28) := '6E2861652C225772617070657222292C623D6E2861652C22436F6E74656E7422292E617070656E6428523D6E2861652C225469746C6522292C463D6E2861652C2243757272656E7422292C503D7428273C627574746F6E20747970653D22627574746F6E';
wwv_flow_api.g_varchar2_table(29) := '222F3E27292E61747472287B69643A5A2B2250726576696F7573227D292C4B3D7428273C627574746F6E20747970653D22627574746F6E222F3E27292E61747472287B69643A5A2B224E657874227D292C493D6E2822627574746F6E222C22536C696465';
wwv_flow_api.g_varchar2_table(30) := '73686F7722292C4D292C423D7428273C627574746F6E20747970653D22627574746F6E222F3E27292E61747472287B69643A5A2B22436C6F7365227D292C792E617070656E64286E286165292E617070656E64286E2861652C22546F704C65667422292C';
wwv_flow_api.g_varchar2_table(31) := '543D6E2861652C22546F7043656E74657222292C6E2861652C22546F7052696768742229292C6E2861652C21312C22636C6561723A6C65667422292E617070656E6428433D6E2861652C224D6964646C654C65667422292C622C483D6E2861652C224D69';
wwv_flow_api.g_varchar2_table(32) := '64646C6552696768742229292C6E2861652C21312C22636C6561723A6C65667422292E617070656E64286E2861652C22426F74746F6D4C65667422292C6B3D6E2861652C22426F74746F6D43656E74657222292C6E2861652C22426F74746F6D52696768';
wwv_flow_api.g_varchar2_table(33) := '74222929292E66696E6428226469762064697622292E637373287B22666C6F6174223A226C656674227D292C533D6E2861652C21312C22706F736974696F6E3A6162736F6C7574653B2077696474683A3939393970783B207669736962696C6974793A68';
wwv_flow_api.g_varchar2_table(34) := '696464656E3B20646973706C61793A6E6F6E653B206D61782D77696474683A6E6F6E653B22292C4F3D4B2E6164642850292E6164642846292E6164642849292C7428652E626F6479292E617070656E6428762C782E617070656E6428792C532929297D66';
wwv_flow_api.g_varchar2_table(35) := '756E6374696F6E206D28297B66756E6374696F6E20692874297B742E77686963683E317C7C742E73686966744B65797C7C742E616C744B65797C7C742E6D6574614B65797C7C742E6374726C4B65797C7C28742E70726576656E7444656661756C742829';
wwv_flow_api.g_varchar2_table(36) := '2C66287468697329297D72657475726E20783F28567C7C28563D21302C4B2E636C69636B2866756E6374696F6E28297B4A2E6E65787428297D292C502E636C69636B2866756E6374696F6E28297B4A2E7072657628297D292C422E636C69636B2866756E';
wwv_flow_api.g_varchar2_table(37) := '6374696F6E28297B4A2E636C6F736528297D292C762E636C69636B2866756E6374696F6E28297B5F2E67657428226F7665726C6179436C6F7365222926264A2E636C6F736528297D292C742865292E62696E6428226B6579646F776E2E222B5A2C66756E';
wwv_flow_api.g_varchar2_table(38) := '6374696F6E2874297B76617220653D742E6B6579436F64653B2426265F2E67657428226573634B65792229262632373D3D3D65262628742E70726576656E7444656661756C7428292C4A2E636C6F73652829292C2426265F2E67657428226172726F774B';
wwv_flow_api.g_varchar2_table(39) := '657922292626455B315D262621742E616C744B657926262833373D3D3D653F28742E70726576656E7444656661756C7428292C502E636C69636B2829293A33393D3D3D65262628742E70726576656E7444656661756C7428292C4B2E636C69636B282929';
wwv_flow_api.g_varchar2_table(40) := '297D292C742E697346756E6374696F6E28742E666E2E6F6E293F742865292E6F6E2822636C69636B2E222B5A2C222E222B74652C69293A7428222E222B7465292E6C6976652822636C69636B2E222B5A2C6929292C2130293A21317D66756E6374696F6E';
wwv_flow_api.g_varchar2_table(41) := '207728297B766172206F2C722C682C643D4A2E707265702C633D2B2B6C653B713D21302C553D21312C75286865292C75286965292C5F2E67657428226F6E4C6F616422292C5F2E683D5F2E676574282268656967687422293F73285F2E67657428226865';
wwv_flow_api.g_varchar2_table(42) := '6967687422292C227922292D412D443A5F2E6765742822696E6E65724865696768742229262673285F2E6765742822696E6E657248656967687422292C227922292C5F2E773D5F2E6765742822776964746822293F73285F2E6765742822776964746822';
wwv_flow_api.g_varchar2_table(43) := '292C227822292D4E2D6A3A5F2E6765742822696E6E657257696474682229262673285F2E6765742822696E6E6572576964746822292C227822292C5F2E6D773D5F2E772C5F2E6D683D5F2E682C5F2E67657428226D6178576964746822292626285F2E6D';
wwv_flow_api.g_varchar2_table(44) := '773D73285F2E67657428226D6178576964746822292C227822292D4E2D6A2C5F2E6D773D5F2E7726265F2E773C5F2E6D773F5F2E773A5F2E6D77292C5F2E67657428226D617848656967687422292626285F2E6D683D73285F2E67657428226D61784865';
wwv_flow_api.g_varchar2_table(45) := '6967687422292C227922292D412D442C5F2E6D683D5F2E6826265F2E683C5F2E6D683F5F2E683A5F2E6D68292C6F3D5F2E67657428226872656622292C513D73657454696D656F75742866756E6374696F6E28297B4D2E73686F7728297D2C313030292C';
wwv_flow_api.g_varchar2_table(46) := '5F2E6765742822696E6C696E6522293F28683D6E286165292E6869646528292E696E736572744265666F72652874286F295B305D292C73652E6F6E652868652C66756E6374696F6E28297B682E7265706C61636557697468284C2E6368696C6472656E28';
wwv_flow_api.g_varchar2_table(47) := '29297D292C642874286F2929293A5F2E6765742822696672616D6522293F6428222022293A5F2E676574282268746D6C22293F64285F2E676574282268746D6C2229293A61285F2C6F293F286F3D6C285F2C6F292C553D652E637265617465456C656D65';
wwv_flow_api.g_varchar2_table(48) := '6E742822696D6722292C742855292E616464436C617373285A2B2250686F746F22292E62696E6428226572726F72222C66756E6374696F6E28297B64286E2861652C224572726F7222292E68746D6C285F2E6765742822696D674572726F72222929297D';
wwv_flow_api.g_varchar2_table(49) := '292E6F6E6528226C6F6164222C66756E6374696F6E28297B76617220653B633D3D3D6C65262628742E65616368285B22616C74222C226C6F6E6764657363222C22617269612D6465736372696265646279225D2C66756E6374696F6E28652C69297B7661';
wwv_flow_api.g_varchar2_table(50) := '72206E3D74285F2E656C292E617474722869297C7C74285F2E656C292E617474722822646174612D222B69293B6E2626552E73657441747472696275746528692C6E297D292C5F2E6765742822726574696E61496D61676522292626692E646576696365';
wwv_flow_api.g_varchar2_table(51) := '506978656C526174696F3E31262628552E6865696768743D552E6865696768742F692E646576696365506978656C526174696F2C552E77696474683D552E77696474682F692E646576696365506978656C526174696F292C5F2E67657428227363616C65';
wwv_flow_api.g_varchar2_table(52) := '50686F746F732229262628723D66756E6374696F6E28297B552E6865696768742D3D552E6865696768742A652C552E77696474682D3D552E77696474682A657D2C5F2E6D772626552E77696474683E5F2E6D77262628653D28552E77696474682D5F2E6D';
wwv_flow_api.g_varchar2_table(53) := '77292F552E77696474682C722829292C5F2E6D682626552E6865696768743E5F2E6D68262628653D28552E6865696768742D5F2E6D68292F552E6865696768742C72282929292C5F2E68262628552E7374796C652E6D617267696E546F703D4D6174682E';
wwv_flow_api.g_varchar2_table(54) := '6D6178285F2E6D682D552E6865696768742C30292F322B22707822292C455B315D2626285F2E67657428226C6F6F7022297C7C455B7A2B315D29262628552E7374796C652E637572736F723D22706F696E746572222C552E6F6E636C69636B3D66756E63';
wwv_flow_api.g_varchar2_table(55) := '74696F6E28297B4A2E6E65787428297D292C552E7374796C652E77696474683D552E77696474682B227078222C552E7374796C652E6865696768743D552E6865696768742B227078222C73657454696D656F75742866756E6374696F6E28297B64285529';
wwv_flow_api.g_varchar2_table(56) := '7D2C3129297D292C73657454696D656F75742866756E6374696F6E28297B552E7372633D6F7D2C3129293A6F2626532E6C6F6164286F2C5F2E67657428226461746122292C66756E6374696F6E28652C69297B633D3D3D6C6526266428226572726F7222';
wwv_flow_api.g_varchar2_table(57) := '3D3D3D693F6E2861652C224572726F7222292E68746D6C285F2E67657428227868724572726F722229293A742874686973292E636F6E74656E74732829297D297D76617220762C782C792C622C542C432C482C6B2C452C572C4C2C532C4D2C522C462C49';
wwv_flow_api.g_varchar2_table(58) := '2C4B2C502C422C4F2C5F2C442C6A2C412C4E2C7A2C552C242C712C472C512C4A2C562C583D7B68746D6C3A21312C70686F746F3A21312C696672616D653A21312C696E6C696E653A21312C7472616E736974696F6E3A22656C6173746963222C73706565';
wwv_flow_api.g_varchar2_table(59) := '643A3330302C666164654F75743A3330302C77696474683A21312C696E697469616C57696474683A22363030222C696E6E657257696474683A21312C6D617857696474683A21312C6865696768743A21312C696E697469616C4865696768743A22343530';
wwv_flow_api.g_varchar2_table(60) := '222C696E6E65724865696768743A21312C6D61784865696768743A21312C7363616C6550686F746F733A21302C7363726F6C6C696E673A21302C6F7061636974793A2E392C7072656C6F6164696E673A21302C636C6173734E616D653A21312C6F766572';
wwv_flow_api.g_varchar2_table(61) := '6C6179436C6F73653A21302C6573634B65793A21302C6172726F774B65793A21302C746F703A21312C626F74746F6D3A21312C6C6566743A21312C72696768743A21312C66697865643A21312C646174613A766F696420302C636C6F7365427574746F6E';
wwv_flow_api.g_varchar2_table(62) := '3A21302C66617374496672616D653A21302C6F70656E3A21312C7265706F736974696F6E3A21302C6C6F6F703A21302C736C69646573686F773A21312C736C69646573686F774175746F3A21302C736C69646573686F7753706565643A323530302C736C';
wwv_flow_api.g_varchar2_table(63) := '69646573686F7753746172743A22737461727420736C69646573686F77222C736C69646573686F7753746F703A2273746F7020736C69646573686F77222C70686F746F52656765783A2F5C2E286769667C706E677C6A7028657C677C6567297C626D707C';
wwv_flow_api.g_varchar2_table(64) := '69636F7C776562707C6A78727C737667292828237C5C3F292E2A293F242F692C726574696E61496D6167653A21312C726574696E6155726C3A21312C726574696E615375666669783A224032782E2431222C63757272656E743A22696D616765207B6375';
wwv_flow_api.g_varchar2_table(65) := '7272656E747D206F66207B746F74616C7D222C70726576696F75733A2270726576696F7573222C6E6578743A226E657874222C636C6F73653A22636C6F7365222C7868724572726F723A225468697320636F6E74656E74206661696C656420746F206C6F';
wwv_flow_api.g_varchar2_table(66) := '61642E222C696D674572726F723A225468697320696D616765206661696C656420746F206C6F61642E222C72657475726E466F6375733A21302C74726170466F6375733A21302C6F6E4F70656E3A21312C6F6E4C6F61643A21312C6F6E436F6D706C6574';
wwv_flow_api.g_varchar2_table(67) := '653A21312C6F6E436C65616E75703A21312C6F6E436C6F7365643A21312C72656C3A66756E6374696F6E28297B72657475726E20746869732E72656C7D2C687265663A66756E6374696F6E28297B72657475726E20742874686973292E61747472282268';
wwv_flow_api.g_varchar2_table(68) := '72656622297D2C7469746C653A66756E6374696F6E28297B72657475726E20746869732E7469746C657D7D2C593D22636F6C6F72626F78222C5A3D2263626F78222C74653D5A2B22456C656D656E74222C65653D5A2B225F6F70656E222C69653D5A2B22';
wwv_flow_api.g_varchar2_table(69) := '5F6C6F6164222C6E653D5A2B225F636F6D706C657465222C6F653D5A2B225F636C65616E7570222C72653D5A2B225F636C6F736564222C68653D5A2B225F7075726765222C73653D7428223C612F3E22292C61653D22646976222C6C653D302C64653D7B';
wwv_flow_api.g_varchar2_table(70) := '7D2C63653D66756E6374696F6E28297B66756E6374696F6E207428297B636C65617254696D656F75742868297D66756E6374696F6E206528297B285F2E67657428226C6F6F7022297C7C455B7A2B315D292626287428292C683D73657454696D656F7574';
wwv_flow_api.g_varchar2_table(71) := '284A2E6E6578742C5F2E6765742822736C69646573686F775370656564222929297D66756E6374696F6E206928297B492E68746D6C285F2E6765742822736C69646573686F7753746F702229292E756E62696E642861292E6F6E6528612C6E292C73652E';
wwv_flow_api.g_varchar2_table(72) := '62696E64286E652C65292E62696E642869652C74292C782E72656D6F7665436C61737328732B226F666622292E616464436C61737328732B226F6E22297D66756E6374696F6E206E28297B7428292C73652E756E62696E64286E652C65292E756E62696E';
wwv_flow_api.g_varchar2_table(73) := '642869652C74292C492E68746D6C285F2E6765742822736C69646573686F7753746172742229292E756E62696E642861292E6F6E6528612C66756E6374696F6E28297B4A2E6E65787428292C6928297D292C782E72656D6F7665436C61737328732B226F';
wwv_flow_api.g_varchar2_table(74) := '6E22292E616464436C61737328732B226F666622297D66756E6374696F6E206F28297B723D21312C492E6869646528292C7428292C73652E756E62696E64286E652C65292E756E62696E642869652C74292C782E72656D6F7665436C61737328732B226F';
wwv_flow_api.g_varchar2_table(75) := '666620222B732B226F6E22297D76617220722C682C733D5A2B22536C69646573686F775F222C613D22636C69636B2E222B5A3B72657475726E2066756E6374696F6E28297B723F5F2E6765742822736C69646573686F7722297C7C2873652E756E62696E';
wwv_flow_api.g_varchar2_table(76) := '64286F652C6F292C6F2829293A5F2E6765742822736C69646573686F7722292626455B315D262628723D21302C73652E6F6E65286F652C6F292C5F2E6765742822736C69646573686F774175746F22293F6928293A6E28292C492E73686F772829297D7D';
wwv_flow_api.g_varchar2_table(77) := '28293B742E636F6C6F72626F787C7C28742870292C4A3D742E666E5B595D3D745B595D3D66756E6374696F6E28652C69297B766172206E2C6F3D746869733B696628653D657C7C7B7D2C742E697346756E6374696F6E286F29296F3D7428223C612F3E22';
wwv_flow_api.g_varchar2_table(78) := '292C652E6F70656E3D21303B656C736520696628216F5B305D2972657475726E206F3B72657475726E206F5B305D3F287028292C6D282926262869262628652E6F6E436F6D706C6574653D69292C6F2E656163682866756E6374696F6E28297B76617220';
wwv_flow_api.g_varchar2_table(79) := '693D742E6461746128746869732C59297C7C7B7D3B742E6461746128746869732C592C742E657874656E6428692C6529297D292E616464436C617373287465292C6E3D6E65772072286F5B305D2C65292C6E2E67657428226F70656E2229262666286F5B';
wwv_flow_api.g_varchar2_table(80) := '305D29292C6F293A6F7D2C4A2E706F736974696F6E3D66756E6374696F6E28652C69297B66756E6374696F6E206E28297B545B305D2E7374796C652E77696474683D6B5B305D2E7374796C652E77696474683D625B305D2E7374796C652E77696474683D';
wwv_flow_api.g_varchar2_table(81) := '7061727365496E7428785B305D2E7374796C652E77696474682C3130292D6A2B227078222C625B305D2E7374796C652E6865696768743D435B305D2E7374796C652E6865696768743D485B305D2E7374796C652E6865696768743D7061727365496E7428';
wwv_flow_api.g_varchar2_table(82) := '785B305D2E7374796C652E6865696768742C3130292D442B227078227D76617220722C682C612C6C3D302C643D302C633D782E6F666673657428293B696628572E756E62696E642822726573697A652E222B5A292C782E637373287B746F703A2D396534';
wwv_flow_api.g_varchar2_table(83) := '2C6C6566743A2D3965347D292C683D572E7363726F6C6C546F7028292C613D572E7363726F6C6C4C65667428292C5F2E6765742822666978656422293F28632E746F702D3D682C632E6C6566742D3D612C782E637373287B706F736974696F6E3A226669';
wwv_flow_api.g_varchar2_table(84) := '786564227D29293A286C3D682C643D612C782E637373287B706F736974696F6E3A226162736F6C757465227D29292C642B3D5F2E676574282272696768742229213D3D21313F4D6174682E6D617828572E776964746828292D5F2E772D4E2D6A2D73285F';
wwv_flow_api.g_varchar2_table(85) := '2E6765742822726967687422292C227822292C30293A5F2E67657428226C6566742229213D3D21313F73285F2E67657428226C65667422292C227822293A4D6174682E726F756E64284D6174682E6D617828572E776964746828292D5F2E772D4E2D6A2C';
wwv_flow_api.g_varchar2_table(86) := '30292F32292C6C2B3D5F2E6765742822626F74746F6D2229213D3D21313F4D6174682E6D6178286F28292D5F2E682D412D442D73285F2E6765742822626F74746F6D22292C227922292C30293A5F2E6765742822746F702229213D3D21313F73285F2E67';
wwv_flow_api.g_varchar2_table(87) := '65742822746F7022292C227922293A4D6174682E726F756E64284D6174682E6D6178286F28292D5F2E682D412D442C30292F32292C782E637373287B746F703A632E746F702C6C6566743A632E6C6566742C7669736962696C6974793A2276697369626C';
wwv_flow_api.g_varchar2_table(88) := '65227D292C795B305D2E7374796C652E77696474683D795B305D2E7374796C652E6865696768743D22393939397078222C723D7B77696474683A5F2E772B4E2B6A2C6865696768743A5F2E682B412B442C746F703A6C2C6C6566743A647D2C65297B7661';
wwv_flow_api.g_varchar2_table(89) := '7220673D303B742E6561636828722C66756E6374696F6E2874297B72657475726E20725B745D213D3D64655B745D3F28673D652C766F69642030293A766F696420307D292C653D677D64653D722C657C7C782E6373732872292C782E6465717565756528';
wwv_flow_api.g_varchar2_table(90) := '292E616E696D61746528722C7B6475726174696F6E3A657C7C302C636F6D706C6574653A66756E6374696F6E28297B6E28292C713D21312C795B305D2E7374796C652E77696474683D5F2E772B4E2B6A2B227078222C795B305D2E7374796C652E686569';
wwv_flow_api.g_varchar2_table(91) := '6768743D5F2E682B412B442B227078222C5F2E67657428227265706F736974696F6E2229262673657454696D656F75742866756E6374696F6E28297B572E62696E642822726573697A652E222B5A2C4A2E706F736974696F6E297D2C31292C6926266928';
wwv_flow_api.g_varchar2_table(92) := '297D2C737465703A6E7D297D2C4A2E726573697A653D66756E6374696F6E2874297B76617220653B24262628743D747C7C7B7D2C742E77696474682626285F2E773D7328742E77696474682C227822292D4E2D6A292C742E696E6E657257696474682626';
wwv_flow_api.g_varchar2_table(93) := '285F2E773D7328742E696E6E657257696474682C22782229292C4C2E637373287B77696474683A5F2E777D292C742E6865696768742626285F2E683D7328742E6865696768742C227922292D412D44292C742E696E6E65724865696768742626285F2E68';
wwv_flow_api.g_varchar2_table(94) := '3D7328742E696E6E65724865696768742C22792229292C742E696E6E65724865696768747C7C742E6865696768747C7C28653D4C2E7363726F6C6C546F7028292C4C2E637373287B6865696768743A226175746F227D292C5F2E683D4C2E686569676874';
wwv_flow_api.g_varchar2_table(95) := '2829292C4C2E637373287B6865696768743A5F2E687D292C6526264C2E7363726F6C6C546F702865292C4A2E706F736974696F6E28226E6F6E65223D3D3D5F2E67657428227472616E736974696F6E22293F303A5F2E6765742822737065656422292929';
wwv_flow_api.g_varchar2_table(96) := '7D2C4A2E707265703D66756E6374696F6E2869297B66756E6374696F6E206F28297B72657475726E205F2E773D5F2E777C7C4C2E776964746828292C5F2E773D5F2E6D7726265F2E6D773C5F2E773F5F2E6D773A5F2E772C5F2E777D66756E6374696F6E';
wwv_flow_api.g_varchar2_table(97) := '207328297B72657475726E205F2E683D5F2E687C7C4C2E68656967687428292C5F2E683D5F2E6D6826265F2E6D683C5F2E683F5F2E6D683A5F2E682C5F2E687D69662824297B76617220642C673D226E6F6E65223D3D3D5F2E67657428227472616E7369';
wwv_flow_api.g_varchar2_table(98) := '74696F6E22293F303A5F2E6765742822737065656422293B4C2E72656D6F766528292C4C3D6E2861652C224C6F61646564436F6E74656E7422292E617070656E642869292C4C2E6869646528292E617070656E64546F28532E73686F772829292E637373';
wwv_flow_api.g_varchar2_table(99) := '287B77696474683A6F28292C6F766572666C6F773A5F2E67657428227363726F6C6C696E6722293F226175746F223A2268696464656E227D292E637373287B6865696768743A7328297D292E70726570656E64546F2862292C532E6869646528292C7428';
wwv_flow_api.g_varchar2_table(100) := '55292E637373287B22666C6F6174223A226E6F6E65227D292C63285F2E6765742822636C6173734E616D652229292C643D66756E6374696F6E28297B66756E6374696F6E206928297B742E737570706F72742E6F7061636974793D3D3D21312626785B30';
wwv_flow_api.g_varchar2_table(101) := '5D2E7374796C652E72656D6F7665417474726962757465282266696C74657222297D766172206E2C6F2C733D452E6C656E6774683B242626286F3D66756E6374696F6E28297B636C65617254696D656F75742851292C4D2E6869646528292C75286E6529';
wwv_flow_api.g_varchar2_table(102) := '2C5F2E67657428226F6E436F6D706C65746522297D2C522E68746D6C285F2E67657428227469746C652229292E73686F7728292C4C2E73686F7728292C733E313F2822737472696E67223D3D747970656F66205F2E676574282263757272656E74222926';
wwv_flow_api.g_varchar2_table(103) := '26462E68746D6C285F2E676574282263757272656E7422292E7265706C61636528227B63757272656E747D222C7A2B31292E7265706C61636528227B746F74616C7D222C7329292E73686F7728292C4B5B5F2E67657428226C6F6F7022297C7C732D313E';
wwv_flow_api.g_varchar2_table(104) := '7A3F2273686F77223A2268696465225D28292E68746D6C285F2E67657428226E6578742229292C505B5F2E67657428226C6F6F7022297C7C7A3F2273686F77223A2268696465225D28292E68746D6C285F2E676574282270726576696F75732229292C63';
wwv_flow_api.g_varchar2_table(105) := '6528292C5F2E67657428227072656C6F6164696E6722292626742E65616368285B68282D31292C682831295D2C66756E6374696F6E28297B76617220692C6E3D455B746869735D2C6F3D6E65772072286E2C742E64617461286E2C5929292C683D6F2E67';
wwv_flow_api.g_varchar2_table(106) := '657428226872656622293B68262661286F2C6829262628683D6C286F2C68292C693D652E637265617465456C656D656E742822696D6722292C692E7372633D68297D29293A4F2E6869646528292C5F2E6765742822696672616D6522293F286E3D652E63';
wwv_flow_api.g_varchar2_table(107) := '7265617465456C656D656E742822696672616D6522292C226672616D65426F7264657222696E206E2626286E2E6672616D65426F726465723D30292C22616C6C6F775472616E73706172656E637922696E206E2626286E2E616C6C6F775472616E737061';
wwv_flow_api.g_varchar2_table(108) := '72656E63793D227472756522292C5F2E67657428227363726F6C6C696E6722297C7C286E2E7363726F6C6C696E673D226E6F22292C74286E292E61747472287B7372633A5F2E67657428226872656622292C6E616D653A286E65772044617465292E6765';
wwv_flow_api.g_varchar2_table(109) := '7454696D6528292C22636C617373223A5A2B22496672616D65222C616C6C6F7746756C6C53637265656E3A21307D292E6F6E6528226C6F6164222C6F292E617070656E64546F284C292C73652E6F6E652868652C66756E6374696F6E28297B6E2E737263';
wwv_flow_api.g_varchar2_table(110) := '3D222F2F61626F75743A626C616E6B227D292C5F2E676574282266617374496672616D652229262674286E292E7472696767657228226C6F61642229293A6F28292C2266616465223D3D3D5F2E67657428227472616E736974696F6E22293F782E666164';
wwv_flow_api.g_varchar2_table(111) := '65546F28672C312C69293A692829297D2C2266616465223D3D3D5F2E67657428227472616E736974696F6E22293F782E66616465546F28672C302C66756E6374696F6E28297B4A2E706F736974696F6E28302C64297D293A4A2E706F736974696F6E2867';
wwv_flow_api.g_varchar2_table(112) := '2C64297D7D2C4A2E6E6578743D66756E6374696F6E28297B21712626455B315D2626285F2E67657428226C6F6F7022297C7C455B7A2B315D292626287A3D682831292C6628455B7A5D29297D2C4A2E707265763D66756E6374696F6E28297B2171262645';
wwv_flow_api.g_varchar2_table(113) := '5B315D2626285F2E67657428226C6F6F7022297C7C7A292626287A3D68282D31292C6628455B7A5D29297D2C4A2E636C6F73653D66756E6374696F6E28297B2426262147262628473D21302C243D21312C75286F65292C5F2E67657428226F6E436C6561';
wwv_flow_api.g_varchar2_table(114) := '6E757022292C572E756E62696E6428222E222B5A292C762E66616465546F285F2E6765742822666164654F757422297C7C302C30292C782E73746F7028292E66616465546F285F2E6765742822666164654F757422297C7C302C302C66756E6374696F6E';
wwv_flow_api.g_varchar2_table(115) := '28297B782E6869646528292C762E6869646528292C75286865292C4C2E72656D6F766528292C73657454696D656F75742866756E6374696F6E28297B473D21312C75287265292C5F2E67657428226F6E436C6F73656422297D2C31297D29297D2C4A2E72';
wwv_flow_api.g_varchar2_table(116) := '656D6F76653D66756E6374696F6E28297B78262628782E73746F7028292C742E636F6C6F72626F782E636C6F736528292C782E73746F7028292E72656D6F766528292C762E72656D6F766528292C473D21312C783D6E756C6C2C7428222E222B7465292E';
wwv_flow_api.g_varchar2_table(117) := '72656D6F7665446174612859292E72656D6F7665436C617373287465292C742865292E756E62696E642822636C69636B2E222B5A29297D2C4A2E656C656D656E743D66756E6374696F6E28297B72657475726E2074285F2E656C297D2C4A2E7365747469';
wwv_flow_api.g_varchar2_table(118) := '6E67733D58297D29286A51756572792C646F63756D656E742C77696E646F77293B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 8025803888435297 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 34420704228053846200 + wwv_flow_api.g_id_offset
 ,p_file_name => 'jquery.colorbox-min.js'
 ,p_mime_type => 'application/javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

--application/shared_components/plugins/item_type/com_skillbuilders_super_lov
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'ITEM TYPE'
 ,p_name => 'COM_SKILLBUILDERS_SUPER_LOV'
 ,p_display_name => 'SkillBuilders Super LOV (2.0.2)'
 ,p_supported_ui_types => 'DESKTOP'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'FUNCTION apex_super_lov_render ('||unistr('\000a')||
'   p_item                IN APEX_PLUGIN.T_PAGE_ITEM,'||unistr('\000a')||
'   p_plugin              IN APEX_PLUGIN.T_PLUGIN,'||unistr('\000a')||
'   p_value               IN VARCHAR2,'||unistr('\000a')||
'   p_is_readonly         IN BOOLEAN,'||unistr('\000a')||
'   p_is_printer_friendly IN BOOLEAN '||unistr('\000a')||
')'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN APEX_PLUGIN.T_PAGE_ITEM_RENDER_RESULT'||unistr('\000a')||
'   '||unistr('\000a')||
'IS'||unistr('\000a')||
''||unistr('\000a')||
'   l_retval                  APEX_PLUGIN.T_PAGE_ITEM_RENDER_RESULT;'||unistr('\000a')||
'   lc_not_enterable      '||
'    CONSTANT VARCHAR2(30) := ''NOT_ENTERABLE'';'||unistr('\000a')||
'   lc_enterable_unrestricted CONSTANT VARCHAR2(30) := ''ENTERABLE_UNRESTRICTED'';'||unistr('\000a')||
'   lc_enterable_restricted   CONSTANT VARCHAR2(30) := ''ENTERABLE_RESTRICTED'';'||unistr('\000a')||
'   l_name                    VARCHAR2(30);'||unistr('\000a')||
'   l_dialog_title            VARCHAR2(32767) := NVL(p_item.attribute_02, p_item.plain_label);'||unistr('\000a')||
'   l_dis_ret_cols            VARCHAR2(10) := NVL(p_item.att'||
'ribute_03, ''2,1'');'||unistr('\000a')||
'   l_searchable_cols         VARCHAR2(32767) := p_item.attribute_04;'||unistr('\000a')||
'   l_hidden_cols             VARCHAR2(32767) := p_item.attribute_05;'||unistr('\000a')||
'   l_map_from_cols           VARCHAR2(32767) := p_item.attribute_06;'||unistr('\000a')||
'   l_map_to_items            VARCHAR2(32767) := p_item.attribute_07;'||unistr('\000a')||
'   l_enterable               VARCHAR2(30) := NVL(p_item.attribute_08, lc_not_enterable);'||unistr('\000a')||
'   l_max_rows_pe'||
'r_page       PLS_INTEGER := NVL(p_item.attribute_09, 15);'||unistr('\000a')||
'   l_search_type             VARCHAR2(32767) := NVL(p_plugin.attribute_01, apex_plugin_util.c_search_contains_ignore);'||unistr('\000a')||
'   l_loading_image_type      VARCHAR2(30) := NVL(p_plugin.attribute_03, ''DEFAULT'');'||unistr('\000a')||
'   l_loading_image_def       VARCHAR2(30) := NVL(p_plugin.attribute_04, ''bar'');'||unistr('\000a')||
'   l_loading_image_cust      VARCHAR2(32767) := NVL(p_plugi'||
'n.attribute_05, apex_application.g_image_prefix || ''processing3.gif'');'||unistr('\000a')||
'   l_effects_speed           NUMBER := NVL(p_plugin.attribute_06, 400);'||unistr('\000a')||
'   l_clear_protection        VARCHAR2(1) := NVL(p_plugin.attribute_07, ''Y'');'||unistr('\000a')||
'   l_no_data_found_msg       VARCHAR2(32767) := NVL(p_plugin.attribute_08, ''Your search returned no results.'');'||unistr('\000a')||
'   l_return_col_num          PLS_INTEGER;'||unistr('\000a')||
'   l_display_col_num      '||
'   PLS_INTEGER;'||unistr('\000a')||
'   l_loading_image_src       VARCHAR2(32767);'||unistr('\000a')||
'   l_display_value           VARCHAR2(32767);'||unistr('\000a')||
'   l_onload_code             VARCHAR2(32767);'||unistr('\000a')||
'   l_sql_handler             APEX_PLUGIN_UTIL.T_SQL_HANDLER;'||unistr('\000a')||
'   l_display_values          WWV_FLOW_GLOBAL.VC_ARR2;'||unistr('\000a')||
'   l_search_values           WWV_FLOW_GLOBAL.VC_ARR2;'||unistr('\000a')||
'   l_js_headers_array        VARCHAR2(32767);'||unistr('\000a')||
'   l_crlf                    CH'||
'AR(2) := CHR(13)||CHR(10);'||unistr('\000a')||
'   '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'   IF apex_application.g_debug'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      apex_plugin_util.debug_page_item ('||unistr('\000a')||
'         p_plugin              => p_plugin,'||unistr('\000a')||
'         p_page_item           => p_item,'||unistr('\000a')||
'         p_value               => p_value,'||unistr('\000a')||
'         p_is_readonly         => p_is_readonly,'||unistr('\000a')||
'         p_is_printer_friendly => p_is_printer_friendly'||unistr('\000a')||
'      );'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF l_loading_image_ty'||
'pe = ''DEFAULT'''||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_loading_image_src := p_plugin.file_prefix || l_loading_image_def || ''.gif'';'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      l_loading_image_src := REPLACE(l_loading_image_cust, ''#IMAGE_PREFIX#'', apex_application.g_image_prefix);'||unistr('\000a')||
'      l_loading_image_src := REPLACE(l_loading_image_src, ''#PLUGIN_PREFIX#'', p_plugin.file_prefix);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   l_display_col_num := SUBSTR(l_dis_ret_cols, 1, INSTR(l_d'||
'is_ret_cols, '','') - 1);'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF l_searchable_cols IS NOT NULL'||unistr('\000a')||
'      AND INSTR('','' || l_searchable_cols || '','', '','' || l_display_col_num || '','') = 0'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --User forgot to add display column as a searchable column, let''s do it for them'||unistr('\000a')||
'      l_searchable_cols := l_display_col_num || '','' || l_searchable_cols;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF l_hidden_cols IS NOT NULL'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_hidden_cols := '','''||
' || l_hidden_cols || '','';'||unistr('\000a')||
'      '||unistr('\000a')||
'      IF INSTR(l_hidden_cols, '','' || l_display_col_num || '','') > 0'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         --User mared display column as hidden, let''s remove it for them'||unistr('\000a')||
'         l_hidden_cols := REPLACE(l_hidden_cols, '','' || l_display_col_num || '','', '''');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      '||unistr('\000a')||
'      l_hidden_cols := TRIM(BOTH '','' FROM l_hidden_cols);'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   l_return_col_num := SUBSTR(l_dis'||
'_ret_cols, INSTR(l_dis_ret_cols, '','') + 1);'||unistr('\000a')||
'   l_search_values(1) := p_value;'||unistr('\000a')||
''||unistr('\000a')||
'   l_sql_handler := apex_plugin_util.get_sql_handler ('||unistr('\000a')||
'      p_sql_statement  => p_item.lov_definition,'||unistr('\000a')||
'      p_min_columns    => 2,'||unistr('\000a')||
'      p_max_columns    => 100,'||unistr('\000a')||
'      p_component_name => p_item.name'||unistr('\000a')||
'   ); '||unistr('\000a')||
'   '||unistr('\000a')||
'   l_display_values := apex_plugin_util.get_display_data('||unistr('\000a')||
'      p_sql_handler       => l_sql_handler,'||unistr('\000a')||
'      '||
'p_display_column_no => l_display_col_num,'||unistr('\000a')||
'      p_search_column_no  => l_return_col_num,'||unistr('\000a')||
'      p_search_value_list => l_search_values,'||unistr('\000a')||
'      p_display_extra     => p_item.lov_display_extra '||unistr('\000a')||
'   );'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF l_display_values.exists(1) '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_display_value := l_display_values(1);'||unistr('\000a')||
'   ELSIF l_enterable = lc_enterable_unrestricted'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_display_value := p_value;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   l_j'||
's_headers_array := ''['''''';'||unistr('\000a')||
'   '||unistr('\000a')||
'   FOR x IN 1 .. l_sql_handler.column_list.count'||unistr('\000a')||
'   LOOP'||unistr('\000a')||
'      l_js_headers_array := l_js_headers_array || apex_javascript.escape(l_sql_handler.column_list(x).col_name) || '''''','''''';'||unistr('\000a')||
'   END LOOP;'||unistr('\000a')||
'   '||unistr('\000a')||
'   l_js_headers_array := RTRIM(l_js_headers_array, '''''','''''') || '''''']'';'||unistr('\000a')||
'   '||unistr('\000a')||
'   apex_plugin_util.free_sql_handler(l_sql_handler);'||unistr('\000a')||
''||unistr('\000a')||
'   IF p_is_readonly OR p_is_printer_friendly'||
''||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      apex_plugin_util.print_hidden_if_readonly ('||unistr('\000a')||
'         p_item_name           => p_item.name,'||unistr('\000a')||
'         p_value               => p_value,'||unistr('\000a')||
'         p_is_readonly         => p_is_readonly,'||unistr('\000a')||
'         p_is_printer_friendly => p_is_printer_friendly'||unistr('\000a')||
'      );'||unistr('\000a')||
'      '||unistr('\000a')||
'      apex_plugin_util.print_display_only ('||unistr('\000a')||
'         p_item_name        => p_item.name,'||unistr('\000a')||
'         p_display_value    => l_display_v'||
'alue,'||unistr('\000a')||
'         p_show_line_breaks => FALSE,'||unistr('\000a')||
'         p_escape           => TRUE,'||unistr('\000a')||
'         p_attributes       => p_item.element_attributes'||unistr('\000a')||
'      );'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      l_name := apex_plugin.get_input_name_for_page_item(FALSE);'||unistr('\000a')||
'      '||unistr('\000a')||
'      sys.htp.p('||unistr('\000a')||
'            ''<input type="hidden" name="'' || l_name || ''" id="'' || p_item.name || ''_HIDDENVALUE" value="'' || sys.htf.escape_sc(p_value) || ''" />'' || l_crlf'||unistr('\000a')||
''||
'         || ''<fieldset id="'' || p_item.name || ''_fieldset" class="superlov-controls lov '' ||'||unistr('\000a')||
'            CASE l_enterable'||unistr('\000a')||
'               WHEN lc_not_enterable THEN ''super-lov-not-enterable'''||unistr('\000a')||
'               WHEN lc_enterable_unrestricted THEN ''super-lov-enterable-unrestricted'''||unistr('\000a')||
'               WHEN lc_enterable_restricted THEN ''super-lov-enterable-restricted'''||unistr('\000a')||
'            END'||unistr('\000a')||
'         || ''">'' || l_crlf'||
''||unistr('\000a')||
'         || ''   <table cellspacing="0" cellpadding="0" border="0" id="'' || p_item.name || ''_holder" class="lov" summary="">'' || l_crlf'||unistr('\000a')||
'         || ''      <tbody>'' || l_crlf'||unistr('\000a')||
'         || ''         <tr>'' || l_crlf'||unistr('\000a')||
'         || ''            <td class="lov">'' || l_crlf'||unistr('\000a')||
'         || ''               <input class="superlov-input popup_lov" type="text" '' || '||unistr('\000a')||
'                               CASE'||unistr('\000a')||
'             '||
'                     WHEN l_enterable = lc_not_enterable'||unistr('\000a')||
'                                  THEN ''disabled="disabled" onfocus="this.blur();"'''||unistr('\000a')||
'                               END'||unistr('\000a')||
'                            || '' value="'' || sys.htf.escape_sc(l_display_value) || ''" maxlength="'' || p_item.element_max_length || ''" size="'''||unistr('\000a')||
'                            || p_item.element_width || ''" id="'' || p_item.name || '||
'''" '' || p_item.element_attributes'||unistr('\000a')||
'                            || '' />'' || l_crlf'||unistr('\000a')||
'         || CASE '||unistr('\000a')||
'               WHEN l_enterable IN (lc_enterable_unrestricted, lc_enterable_restricted)'||unistr('\000a')||
'               THEN ''               <script>'' || l_crlf ||'||unistr('\000a')||
'                    ''                  $("#'' || p_item.name || ''").bind("change", function(evnt) {'' || l_crlf ||'||unistr('\000a')||
'                    ''                    '||
' if (!$(this).apex_super_lov("changePropagationAllowed")) {'' || l_crlf ||'||unistr('\000a')||
'                    ''                        evnt.stopImmediatePropagation();'' || l_crlf ||'||unistr('\000a')||
'                    ''                     }'' || l_crlf ||'||unistr('\000a')||
'                    ''                  });'' || l_crlf ||'||unistr('\000a')||
'                    ''               </script>'' || l_crlf'||unistr('\000a')||
'            END'||unistr('\000a')||
'         || ''            </td>'' || l_crlf'||unistr('\000a')||
'    '||
'     || ''            <td>'' || l_crlf'||unistr('\000a')||
'         || ''               <div class="superlov-control-buttons">'' || l_crlf'||unistr('\000a')||
'         || ''                  <button type="button" class="superlov-modal-delete">&nbsp;</button>'' || l_crlf'||unistr('\000a')||
'         || ''                  <button type="button" class="superlov-modal-open">&nbsp;</button>'' || l_crlf'||unistr('\000a')||
'         || ''                  '' || l_crlf'||unistr('\000a')||
'         || ''           '||
'    </div>'' || l_crlf'||unistr('\000a')||
'         || ''            </td>'' || l_crlf'||unistr('\000a')||
'         || ''         </tr>'' || l_crlf'||unistr('\000a')||
'         || ''      </tbody>'' || l_crlf'||unistr('\000a')||
'         || ''   </table>'' || l_crlf'||unistr('\000a')||
'         || ''</fieldset>'' || l_crlf'||unistr('\000a')||
'      );'||unistr('\000a')||
'      '||unistr('\000a')||
'      apex_css.add_file('||unistr('\000a')||
'         p_name      => ''apex_super_lov'','||unistr('\000a')||
'         p_directory => p_plugin.file_prefix,'||unistr('\000a')||
'         p_version   => NULL'||unistr('\000a')||
'      );'||unistr('\000a')||
''||unistr('\000a')||
'      apex_javascr'||
'ipt.add_library('||unistr('\000a')||
'         p_name      => ''jquery.ui.button'','||unistr('\000a')||
'         p_directory => apex_application.g_image_prefix || ''libraries/jquery-ui/1.8/ui/'','||unistr('\000a')||
'         p_version   => NULL'||unistr('\000a')||
'      );'||unistr('\000a')||
''||unistr('\000a')||
'      apex_javascript.add_library('||unistr('\000a')||
'         p_name      => ''apex_super_lov.min'','||unistr('\000a')||
'         --p_name      => ''apex_super_lov'','||unistr('\000a')||
'         p_directory => p_plugin.file_prefix,'||unistr('\000a')||
'         p_version   => NULL'||unistr('\000a')||
'      );'||unistr('\000a')||
''||unistr('\000a')||
''||
'      l_onload_code := ''apex.jQuery("input#'' || p_item.name || ''").apex_super_lov({'' || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''enterable'', l_enterable) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''returnColNum'', l_return_col_num) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''displayColNum'', l_display_col_num) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_'||
'javascript.add_attribute(''hiddenCols'', sys.htf.escape_sc(l_hidden_cols)) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''searchableCols'', l_searchable_cols) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''mapFromCols'', l_map_from_cols) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''mapToItems'', l_map_to_items) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascrip'||
't.add_attribute(''maxRowsPerPage'', l_max_rows_per_page) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''noDataFoundMsg'', sys.htf.escape_sc(l_no_data_found_msg)) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''dialogTitle'', sys.htf.escape_sc(l_dialog_title)) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''effectsSpeed'', l_effects_speed) || l_crlf'||unistr('\000a')||
'         ||'||
' ''   '' || apex_javascript.add_attribute(''useClearProtection'', l_clear_protection) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''loadingImageSrc'', sys.htf.escape_sc(l_loading_image_src)) || l_crlf'||unistr('\000a')||
'         || ''   '' || apex_javascript.add_attribute(''dependingOnSelector'', sys.htf.escape_sc(apex_plugin_util.page_item_names_to_jquery(p_item.lov_cascade_parent_items))) || l_crlf'||unistr('\000a')||
'        '||
' || ''   '' || apex_javascript.add_attribute(''pageItemsToSubmit'', sys.htf.escape_sc(apex_plugin_util.page_item_names_to_jquery(p_item.ajax_items_to_submit))) || l_crlf'||unistr('\000a')||
'         || ''   "ajaxIdentifier": "'' || apex_plugin.get_ajax_identifier() || ''",'' || l_crlf'||unistr('\000a')||
'         || ''   "reportHeaders": '' || l_js_headers_array || l_crlf'||unistr('\000a')||
'         || ''});'';'||unistr('\000a')||
'         '||unistr('\000a')||
'      apex_javascript.add_onload_code('||unistr('\000a')||
'       '||
'  p_code => l_onload_code'||unistr('\000a')||
'      ); '||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   IF l_enterable = lc_not_enterable'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_retval.is_navigable := FALSE;'||unistr('\000a')||
'   ELSE'||unistr('\000a')||
'      l_retval.is_navigable := TRUE;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'        '||unistr('\000a')||
'   RETURN l_retval;'||unistr('\000a')||
''||unistr('\000a')||
'EXCEPTION'||unistr('\000a')||
''||unistr('\000a')||
'   WHEN OTHERS'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      apex_plugin_util.free_sql_handler(l_sql_handler);'||unistr('\000a')||
'    '||unistr('\000a')||
'END apex_super_lov_render;'||unistr('\000a')||
''||unistr('\000a')||
'FUNCTION apex_super_lov_ajax ('||unistr('\000a')||
'   p_item   IN APEX_PLUGIN.T_'||
'PAGE_ITEM,'||unistr('\000a')||
'   p_plugin IN APEX_PLUGIN.T_PLUGIN'||unistr('\000a')||
')'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN APEX_PLUGIN.T_PAGE_ITEM_AJAX_RESULT'||unistr('\000a')||
''||unistr('\000a')||
'IS'||unistr('\000a')||
''||unistr('\000a')||
'   l_column_value_list APEX_PLUGIN_UTIL.T_COLUMN_VALUE_LIST2;     '||unistr('\000a')||
'   l_dis_ret_cols      VARCHAR2(10) := NVL(p_item.attribute_03, ''2,1'');'||unistr('\000a')||
'   l_searchable_cols   VARCHAR2(32767) := p_item.attribute_04;'||unistr('\000a')||
'   l_hidden_cols       VARCHAR2(32767) := p_item.attribute_05;'||unistr('\000a')||
'   l_map_from_cols     VARCHAR2(32'||
'767) := p_item.attribute_06;'||unistr('\000a')||
'   l_map_to_items      VARCHAR2(32767) := p_item.attribute_07;'||unistr('\000a')||
'   l_max_rows_per_page PLS_INTEGER := NVL(p_item.attribute_09, 15); '||unistr('\000a')||
'   l_show_null_as      VARCHAR2(10) := NVL(p_item.attribute_10, ''&nbsp;'');'||unistr('\000a')||
'   l_map_from_parts    WWV_FLOW_GLOBAL.VC_ARR2;'||unistr('\000a')||
'   l_map_to_parts      WWV_FLOW_GLOBAL.VC_ARR2;'||unistr('\000a')||
'   l_search_type       VARCHAR2(32767) := NVL(p_plugin.attribute_01,'||
' apex_plugin_util.c_search_contains_ignore);'||unistr('\000a')||
'   l_return_col_num    PLS_INTEGER;'||unistr('\000a')||
'   l_display_col_num   PLS_INTEGER;'||unistr('\000a')||
'   l_lov_base_query    VARCHAR2(32767) := p_item.lov_definition;'||unistr('\000a')||
'   l_ajax_function     VARCHAR2(32767) := apex_application.g_x01;'||unistr('\000a')||
'   l_pagination        VARCHAR2(32767) := apex_application.g_x02;'||unistr('\000a')||
'   l_search_column_no  VARCHAR2(32767) := apex_application.g_x03;'||unistr('\000a')||
'   l_search_string  '||
'   VARCHAR2(32767) := apex_application.g_x04;'||unistr('\000a')||
'   l_fetch_lov_id      NUMBER := apex_application.g_x05;'||unistr('\000a')||
'   l_return_val_search VARCHAR2(32767) := apex_application.g_x06;'||unistr('\000a')||
'   l_pagination_parts  WWV_FLOW_GLOBAL.VC_ARR2;'||unistr('\000a')||
'   l_crlf              CHAR(2) := CHR(13)||CHR(10);'||unistr('\000a')||
''||unistr('\000a')||
'   FUNCTION column_row_value ('||unistr('\000a')||
'      p_row           IN PLS_INTEGER,'||unistr('\000a')||
'      p_column_values IN APEX_PLUGIN_UTIL.T_COLUMN_VALUES'||unistr('\000a')||
'   '||
')'||unistr('\000a')||
''||unistr('\000a')||
'      RETURN VARCHAR2'||unistr('\000a')||
''||unistr('\000a')||
'   IS'||unistr('\000a')||
''||unistr('\000a')||
'   BEGIN'||unistr('\000a')||
''||unistr('\000a')||
'      IF p_column_values.data_type = apex_plugin_util.c_data_type_varchar2'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN p_column_values.value_list(p_row).varchar2_value;'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_util.c_data_type_number'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN p_column_values.value_list(p_row).number_value;'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_ut'||
'il.c_data_type_date'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN p_column_values.value_list(p_row).date_value;'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_util.c_data_type_timestamp'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN p_column_values.value_list(p_row).timestamp_value;'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_util.c_data_type_timestamp_tz'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN p_column_values.value_list(p_row).timesta'||
'mp_tz_value;'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_util.c_data_type_timestamp_ltz'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN p_column_values.value_list(p_row).timestamp_ltz_value;'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_util.c_data_type_interval_y2m'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN p_column_values.value_list(p_row).interval_y2m_value;'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_util.c_'||
'data_type_interval_d2s'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN p_column_values.value_list(p_row).interval_d2s_value;'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_util.c_data_type_blob'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN ''[BLOB_DATATYPE]'';'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_util.c_data_type_bfile'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN ''[BFILE_DATATYPE]'';'||unistr('\000a')||
'      ELSIF p_column_values.data_type = apex_plugin_ut'||
'il.c_data_type_clob'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         RETURN p_column_values.value_list(p_row).clob_value;'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         RETURN ''[INVALID_DATATYPE]'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   END column_row_value; '||unistr('\000a')||
'  '||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'   '||unistr('\000a')||
'   l_display_col_num := SUBSTR(l_dis_ret_cols, 1, INSTR(l_dis_ret_cols, '','') - 1);'||unistr('\000a')||
'   l_return_col_num := SUBSTR(l_dis_ret_cols, INSTR(l_dis_ret_cols, '','') + 1);'||unistr('\000a')||
'   l_hidden_cols := '','' || l_hidden_cols |'||
'| '','';'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF l_searchable_cols IS NOT NULL'||unistr('\000a')||
'      AND INSTR('','' || l_searchable_cols || '','', '','' || l_display_col_num || '','') = 0'||unistr('\000a')||
'   THEN '||unistr('\000a')||
'      --User forgot to add display column as a searchable column, let''s do it for them'||unistr('\000a')||
'      l_searchable_cols := l_display_col_num || '','' || l_searchable_cols;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   IF INSTR(l_hidden_cols, '','' || l_display_col_num || '','') > 0'||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      --Us'||
'er mared display column as hidden, let''s remove it for them'||unistr('\000a')||
'      l_hidden_cols := REPLACE(l_hidden_cols, '','' || l_display_col_num || '','', '''');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   l_hidden_cols := TRIM(BOTH '','' FROM l_hidden_cols);'||unistr('\000a')||
'   l_hidden_cols := '','' || l_hidden_cols || '',''; --Prep for repeated INSTRs later'||unistr('\000a')||
''||unistr('\000a')||
'   IF l_ajax_function = ''FETCH_LOV'''||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_pagination_parts := apex_util.string_to_table(l_pag'||
'ination);    '||unistr('\000a')||
''||unistr('\000a')||
'      IF l_search_string IS NOT NULL'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         IF l_searchable_cols IS NOT NULL '||unistr('\000a')||
'            AND INSTR('','' || l_searchable_cols || '','', '','' || l_search_column_no || '','') = 0'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            RAISE_APPLICATION_ERROR(-20001, ''Super LOV Exception: Search attempt on non-searchable column.'');'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      '||unistr('\000a')||
'         l_search_string := apex_plugin_util.get_sear'||
'ch_string('||unistr('\000a')||
'            p_search_type   => l_search_type,'||unistr('\000a')||
'            p_search_string => l_search_string '||unistr('\000a')||
'         );'||unistr('\000a')||
'      '||unistr('\000a')||
'         l_column_value_list := apex_plugin_util.get_data2('||unistr('\000a')||
'            p_sql_statement    => l_lov_base_query, '||unistr('\000a')||
'            p_min_columns      => 2, '||unistr('\000a')||
'            p_max_columns      => 100, '||unistr('\000a')||
'            p_component_name   => p_item.name,'||unistr('\000a')||
'            p_search_type      => l_se'||
'arch_type,'||unistr('\000a')||
'            p_search_column_no => l_search_column_no,'||unistr('\000a')||
'            p_search_string    => l_search_string,'||unistr('\000a')||
'            p_first_row        => l_pagination_parts(1),'||unistr('\000a')||
'            p_max_rows         => l_pagination_parts(2) + 1'||unistr('\000a')||
'         );'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         l_column_value_list := apex_plugin_util.get_data2('||unistr('\000a')||
'            p_sql_statement  => l_lov_base_query, '||unistr('\000a')||
'            p_min_columns    => 2'||
', '||unistr('\000a')||
'            p_max_columns    => 100, '||unistr('\000a')||
'            p_component_name => p_item.name,'||unistr('\000a')||
'            p_first_row      => l_pagination_parts(1),'||unistr('\000a')||
'            p_max_rows       => l_pagination_parts(2) + 1'||unistr('\000a')||
'         );   '||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      '||unistr('\000a')||
'      sys.htp.p(''<table id="superlov-fetch-results" cellspacing="0" cellpadding="0" border="0" '' || '||unistr('\000a')||
'         ''data-fetch-lov-id="'' || l_fetch_lov_id || ''" class="su'||
'perlov-table ui-widget ui-widget-content ui-corner-all">'');'||unistr('\000a')||
'      sys.htp.p(''<thead>'');'||unistr('\000a')||
'      sys.htp.p(''<tr>'');'||unistr('\000a')||
'      '||unistr('\000a')||
''||unistr('\000a')||
'      FOR x IN 1 .. l_column_value_list.count'||unistr('\000a')||
'      LOOP'||unistr('\000a')||
'         IF INSTR(l_hidden_cols, '','' || x || '','') = 0'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            sys.htp.prn(''<th class="ui-widget-header">'');'||unistr('\000a')||
'            sys.htp.prn(l_column_value_list(x).name);'||unistr('\000a')||
'            sys.htp.prn(''</th>'');'||unistr('\000a')||
'        '||
' END IF;'||unistr('\000a')||
'      END LOOP;'||unistr('\000a')||
''||unistr('\000a')||
'      sys.htp.p(''</tr>'');'||unistr('\000a')||
'      sys.htp.p(''</thead>'');'||unistr('\000a')||
'      sys.htp.p(''<tbody>'');'||unistr('\000a')||
'      '||unistr('\000a')||
'      FOR x IN 1 .. LEAST(l_column_value_list(1).value_list.count, l_max_rows_per_page)'||unistr('\000a')||
'      LOOP '||unistr('\000a')||
'         sys.htp.p('||unistr('\000a')||
'            ''<tr data-return="'' || sys.htf.escape_sc(column_row_value(x, l_column_value_list(l_return_col_num))) '||unistr('\000a')||
'            || ''" data-display="'' || sys.htf.escap'||
'e_sc(column_row_value(x, l_column_value_list(l_display_col_num))) '||unistr('\000a')||
'            || ''"'''||unistr('\000a')||
'         );'||unistr('\000a')||
'         '||unistr('\000a')||
'         FOR y IN 1 .. l_column_value_list.count'||unistr('\000a')||
'         LOOP'||unistr('\000a')||
'            IF INSTR(l_hidden_cols, '','' || y || '','') > 0'||unistr('\000a')||
'            THEN'||unistr('\000a')||
'               sys.htp.prn('' data-col'' || y || ''-value="'');'||unistr('\000a')||
'               sys.htp.prn(NVL(sys.htf.escape_sc(column_row_value(x, l_column_value_list(y))), '||
'l_show_null_as));'||unistr('\000a')||
'               sys.htp.prn(''"'');'||unistr('\000a')||
'            END IF;'||unistr('\000a')||
'         END LOOP;'||unistr('\000a')||
'         '||unistr('\000a')||
'         sys.htp.p(''>'');'||unistr('\000a')||
'         '||unistr('\000a')||
'         IF p_item.escape_output'||unistr('\000a')||
'         THEN'||unistr('\000a')||
'            FOR y IN 1 .. l_column_value_list.count'||unistr('\000a')||
'            LOOP'||unistr('\000a')||
'               IF INSTR(l_hidden_cols, '','' || y || '','') = 0'||unistr('\000a')||
'               THEN'||unistr('\000a')||
'                  sys.htp.prn(''<td class="ui-state-default asl-col'' |'||
'| y || ''">'');'||unistr('\000a')||
'                  sys.htp.prn(NVL(sys.htf.escape_sc(column_row_value(x, l_column_value_list(y))), l_show_null_as));'||unistr('\000a')||
'                  sys.htp.prn(''</td>'');'||unistr('\000a')||
'               END IF;'||unistr('\000a')||
'            END LOOP;'||unistr('\000a')||
'         ELSE'||unistr('\000a')||
'            FOR y IN 1 .. l_column_value_list.count'||unistr('\000a')||
'            LOOP'||unistr('\000a')||
'               IF INSTR(l_hidden_cols, '','' || y || '','') = 0'||unistr('\000a')||
'               THEN'||unistr('\000a')||
'                  sys.'||
'htp.prn(''<td class="ui-state-default asl-col'' || y || ''">'');'||unistr('\000a')||
'                  sys.htp.prn(NVL(column_row_value(x, l_column_value_list(y)), l_show_null_as));'||unistr('\000a')||
'                  sys.htp.prn(''</td>'');'||unistr('\000a')||
'               END IF;'||unistr('\000a')||
'            END LOOP;'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'         '||unistr('\000a')||
'         sys.htp.p(''</tr>'');'||unistr('\000a')||
'      END LOOP;'||unistr('\000a')||
'      '||unistr('\000a')||
'      sys.htp.p(''</tbody></table>'');'||unistr('\000a')||
'      '||unistr('\000a')||
'      IF l_column_value_list(1).va'||
'lue_list.count > l_max_rows_per_page'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         sys.htp.p(''<input id="asl-super-lov-more-rows" type="hidden" value="Y" />'');'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'         sys.htp.p(''<input id="asl-super-lov-more-rows" type="hidden" value="N" />'');'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   ELSIF l_ajax_function = ''GET_VALUES_BY_RETURN'''||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_search_string := apex_plugin_util.get_search_string('||unistr('\000a')||
'         p_search_type   => apex_plu'||
'gin_util.c_search_lookup,'||unistr('\000a')||
'         p_search_string => l_return_val_search'||unistr('\000a')||
'      );'||unistr('\000a')||
'   '||unistr('\000a')||
'      l_column_value_list := apex_plugin_util.get_data2('||unistr('\000a')||
'         p_sql_statement    => l_lov_base_query, '||unistr('\000a')||
'         p_min_columns      => 2, '||unistr('\000a')||
'         p_max_columns      => 100, '||unistr('\000a')||
'         p_component_name   => p_item.name,'||unistr('\000a')||
'         p_search_type      => apex_plugin_util.c_search_lookup,'||unistr('\000a')||
'         p_search_column_'||
'no => l_return_col_num,'||unistr('\000a')||
'         p_search_string    => l_search_string'||unistr('\000a')||
'      );'||unistr('\000a')||
'      '||unistr('\000a')||
'      sys.htp.p(''{'');'||unistr('\000a')||
'      '||unistr('\000a')||
'      IF l_column_value_list(1).value_list.count = 0 '||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         sys.htp.p(''"matchFound": false'');'||unistr('\000a')||
'      ELSIF l_column_value_list(1).value_list.count > 1 '||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         sys.htp.p(''"matchFound": false,'');'||unistr('\000a')||
'         sys.htp.p(''"error": "too many rows"'');'||unistr('\000a')||
'      ELSE'||unistr('\000a')||
'     '||
'    sys.htp.p(''"matchFound": true,'');'||unistr('\000a')||
'         sys.htp.p(   ''"displayVal": "'' || APEX_JAVASCRIPT.ESCAPE(column_row_value(1, l_column_value_list(l_display_col_num))) || ''",'');'||unistr('\000a')||
'         sys.htp.p(   ''"returnVal": "'' || APEX_JAVASCRIPT.ESCAPE(column_row_value(1, l_column_value_list(l_return_col_num))) || ''"'');'||unistr('\000a')||
'         '||unistr('\000a')||
'         l_map_from_parts := apex_util.string_to_table(l_map_from_cols, '','');'||unistr('\000a')||
'   '||
'      l_map_to_parts := apex_util.string_to_table(l_map_to_items, '','');'||unistr('\000a')||
'         '||unistr('\000a')||
'         IF l_map_from_parts.COUNT > 0 THEN'||unistr('\000a')||
'            sys.htp.p('', "mappedColumns": ['');'||unistr('\000a')||
'            FOR i IN 1 .. l_map_from_parts.COUNT'||unistr('\000a')||
'            LOOP'||unistr('\000a')||
'               IF i != 1 THEN'||unistr('\000a')||
'                  sys.htp.p('','');'||unistr('\000a')||
'               END IF;'||unistr('\000a')||
'               sys.htp.p(''{'');'||unistr('\000a')||
'               sys.htp.p(   ''"mapItem": "'' '||
'|| APEX_JAVASCRIPT.ESCAPE(l_map_to_parts(i)) || ''",'');'||unistr('\000a')||
'               sys.htp.p(   ''"mapVal": "'' || APEX_JAVASCRIPT.ESCAPE(column_row_value(1, l_column_value_list(l_map_from_parts(i)))) || ''"'');'||unistr('\000a')||
'               sys.htp.p(''}'');'||unistr('\000a')||
'            END LOOP;'||unistr('\000a')||
'            sys.htp.p('']'');'||unistr('\000a')||
'         END IF;'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'      '||unistr('\000a')||
'      sys.htp.p(''}'');'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN NULL;'||unistr('\000a')||
''||unistr('\000a')||
'END apex_super_lov_ajax;'||unistr('\000a')||
''||unistr('\000a')||
'FUNCTION '||
'apex_super_lov_validation ('||unistr('\000a')||
'   p_item   IN APEX_PLUGIN.T_PAGE_ITEM,'||unistr('\000a')||
'   p_plugin IN APEX_PLUGIN.T_PLUGIN,'||unistr('\000a')||
'   p_value  IN VARCHAR2'||unistr('\000a')||
')'||unistr('\000a')||
''||unistr('\000a')||
'   RETURN APEX_PLUGIN.T_PAGE_ITEM_VALIDATION_RESULT'||unistr('\000a')||
''||unistr('\000a')||
'IS'||unistr('\000a')||
''||unistr('\000a')||
'   l_retval                  APEX_PLUGIN.T_PAGE_ITEM_VALIDATION_RESULT;'||unistr('\000a')||
'   lc_not_enterable          CONSTANT VARCHAR2(30) := ''NOT_ENTERABLE'';'||unistr('\000a')||
'   lc_enterable_unrestricted CONSTANT VARCHAR2(30) := ''ENTERABLE_UNR'||
'ESTRICTED'';'||unistr('\000a')||
'   l_return_value            VARCHAR2(32767);'||unistr('\000a')||
'   l_validate_value          VARCHAR2(1) := NVL(p_item.attribute_01, ''Y'');'||unistr('\000a')||
'   l_dis_ret_cols            VARCHAR2(10) := NVL(p_item.attribute_03, ''2,1'');'||unistr('\000a')||
'   l_enterable               VARCHAR2(30) := NVL(p_item.attribute_08, lc_not_enterable);'||unistr('\000a')||
'   l_return_col_num          PLS_INTEGER;'||unistr('\000a')||
''||unistr('\000a')||
'BEGIN'||unistr('\000a')||
''||unistr('\000a')||
''||unistr('\000a')||
'   IF p_value IS NOT NULL'||unistr('\000a')||
'      AND l_enterable !'||
'= lc_enterable_unrestricted'||unistr('\000a')||
'      AND l_validate_value = ''Y'' '||unistr('\000a')||
'   THEN'||unistr('\000a')||
'      l_return_col_num := SUBSTR(l_dis_ret_cols, INSTR(l_dis_ret_cols, '','') + 1);'||unistr('\000a')||
'   '||unistr('\000a')||
'      l_return_value := apex_plugin_util.get_display_data ('||unistr('\000a')||
'         p_sql_statement     => p_item.lov_definition,'||unistr('\000a')||
'         p_min_columns       => 1,'||unistr('\000a')||
'         p_max_columns       => 100,'||unistr('\000a')||
'         p_component_name    => p_item.name,'||unistr('\000a')||
'         p_d'||
'isplay_column_no => l_return_col_num,'||unistr('\000a')||
'         p_search_column_no  => l_return_col_num,'||unistr('\000a')||
'         p_search_string     => p_value,'||unistr('\000a')||
'         p_display_extra     => FALSE --Can''t trust this value'||unistr('\000a')||
'      );'||unistr('\000a')||
'      '||unistr('\000a')||
'      IF l_return_value IS NULL'||unistr('\000a')||
'      THEN'||unistr('\000a')||
'         l_retval.message := ''#LABEL# contains a value that was not in the list of values.'';'||unistr('\000a')||
'      END IF;'||unistr('\000a')||
'   END IF;'||unistr('\000a')||
'   '||unistr('\000a')||
'   RETURN l_retval;'||unistr('\000a')||
''||unistr('\000a')||
'END ap'||
'ex_super_lov_validation;'
 ,p_render_function => 'apex_super_lov_render'
 ,p_ajax_function => 'apex_super_lov_ajax'
 ,p_validation_function => 'apex_super_lov_validation'
 ,p_standard_attributes => 'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:ELEMENT_OPTION:LOV:LOV_REQUIRED:CASCADING_LOV'
 ,p_sql_min_column_count => 2
 ,p_sql_max_column_count => 100
 ,p_sql_examples => '<pre>SELECT empno AS "Emp No.",'||unistr('\000a')||
'   ename AS "Employee",'||unistr('\000a')||
'   job AS "Job",'||unistr('\000a')||
'   sal AS "Salary"'||unistr('\000a')||
'FROM emp</pre>'
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_help_text => '<br />'||unistr('\000a')||
''
 ,p_version_identifier => '2.0.2'
 ,p_about_url => 'http://skillbuilders.com/download/download-resource.cfm?file=Oracle-Apex/plugins/sbip_super_lov/instructions.pdf'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 37772506522700496492 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Search Type'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => false
 ,p_default_value => 'CONTAINS_IGNORE'
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to control how search strings are used to filter the LOV result set. '
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37772523034952509472 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37772506522700496492 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Contains/Case (uses INSTR)'
 ,p_return_value => 'CONTAINS_CASE'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37772532124001515785 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37772506522700496492 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Contains/Ignore (uses INSTR with UPPER)'
 ,p_return_value => 'CONTAINS_IGNORE'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37772533628503517097 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37772506522700496492 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => 'Exact/Case (uses LIKE value%)'
 ,p_return_value => 'EXACT_CASE'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37772537034390518819 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37772506522700496492 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 40
 ,p_display_value => 'Exact/Ignore (uses LIKE VALUE% with UPPER)'
 ,p_return_value => 'EXACT_IGNORE'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37772551040970520699 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37772506522700496492 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 50
 ,p_display_value => 'Like/Case (uses LIKE %value%)'
 ,p_return_value => 'LIKE_CASE'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37772553613396522176 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37772506522700496492 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 60
 ,p_display_value => 'Like/Ignore (uses LIKE %VALUE% with UPPER)'
 ,p_return_value => 'LIKE_IGNORE'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37772565620669524261 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37772506522700496492 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 70
 ,p_display_value => 'Lookup (uses = value)'
 ,p_return_value => 'LOOKUP'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 37774250918095062786 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Loading Image Type'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'DEFAULT'
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to choose between a default or custom loading image. The loading image is displayed when the LOV is opened, before the result set appears. There are a number of default loading images that can be used (see Loading Image next) but you can use your own as well.'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774263226753065317 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774250918095062786 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Default'
 ,p_return_value => 'DEFAULT'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774274530908066480 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774250918095062786 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Custom'
 ,p_return_value => 'CUSTOM'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 37774286735195077160 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'Loading Image'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'bar'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 37774250918095062786 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'DEFAULT'
 ,p_help_text => 'Use this setting to specify which loading image you would like to use. Based on the Loading Image Type selection, you will either choose from a number of default images or you will specify the path/name to a custom image.'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774431122868158792 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774286735195077160 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Bar'
 ,p_return_value => 'bar'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774432427717160167 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774286735195077160 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Bar 2'
 ,p_return_value => 'bar2'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774434531526161205 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774286735195077160 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => 'Bert'
 ,p_return_value => 'bert'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774435935335162358 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774286735195077160 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 40
 ,p_display_value => 'Bert 2'
 ,p_return_value => 'bert2'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774437039491163541 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774286735195077160 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 50
 ,p_display_value => 'Big Snake'
 ,p_return_value => 'big-snake'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774439311571164996 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774286735195077160 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 60
 ,p_display_value => 'Clock'
 ,p_return_value => 'clock'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774440518497166945 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774286735195077160 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 70
 ,p_display_value => 'Drip Circle'
 ,p_return_value => 'drip-circle'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 37774441422653168185 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 37774286735195077160 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 80
 ,p_display_value => 'Squares Circle'
 ,p_return_value => 'squares-circle'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 37775364923681792867 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Loading Image'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_default_value => '#IMAGE_PREFIX#processing3.gif'
 ,p_display_length => 40
 ,p_max_length => 500
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 37774250918095062786 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'CUSTOM'
 ,p_help_text => 'Enter the path to and name of the image you would like displayed when the dialog opens.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 31628847007973690034 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 6
 ,p_display_sequence => 25
 ,p_prompt => 'Effects Speed'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => '400'
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify the speed at which the modal dialog should perform certain effects such as sizing, resizing, and fading. Selecting “instant” will essentially disable any effects.'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 31628848512474691372 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 31628847007973690034 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Slow'
 ,p_return_value => '600'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 31628849115591692214 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 31628847007973690034 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Normal'
 ,p_return_value => '400'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 31628849718708693082 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 31628847007973690034 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => 'Fast'
 ,p_return_value => '200'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 31628850423210694453 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 31628847007973690034 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 40
 ,p_display_value => 'Instant'
 ,p_return_value => '0'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24260290920238140643 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 7
 ,p_display_sequence => 70
 ,p_prompt => 'Use Clear Confirm'
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to enable or disable the Clear Protection feature. Clear Protection requires the user to click the clear button twice to clear the selected value. This is done to help prevent accidental clearings that would require the LOV to be reopened.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 14609729996471846319 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 8
 ,p_display_sequence => 80
 ,p_prompt => 'When No Data Found Message'
 ,p_attribute_type => 'TEXTAREA'
 ,p_is_required => false
 ,p_default_value => 'Your search returned no results.'
 ,p_display_length => 60
 ,p_max_length => 500
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify what message should be displayed to users when the LOV query fails to retrieve any results.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 31062067820688225787 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 85
 ,p_prompt => 'Use Value Validation'
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 24171212307668711445 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'NOT_EQUALS'
 ,p_depending_on_expression => 'ENTERABLE_UNRESTRICTED'
 ,p_help_text => 'Use this setting to enable or disable the Value Validation feature. Value Validation will re-check the submitted value against the LOV. If the value is not found then the validation will fail and the user will see a validation error message.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24171195914285666024 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'Dialog Title'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_display_length => 30
 ,p_max_length => 100
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to explicitly set the title of the dialog. If no value is supplied then the item’s label will be used.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24171198116148675992 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Item Display & Return Columns'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_default_value => '2,1'
 ,p_display_length => 10
 ,p_max_length => 7
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify which column should be used for the item’s display value and which column should be used for the item’s return value. The value should be a comma separated pair of numbers where the numbers refer to the column in the LOV query. The first number should be the display column and the second number should be the return column. The display column will be used as the default search column.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24171203709484692956 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'Searchable Columns'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_display_length => 30
 ,p_max_length => 100
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify which columns should be displayed in the select list of columns that allows users to filter the LOV result set. The value should be a comma separated list of numbers where the numbers refer to columns in the LOV query. If no value is supplied then all columns will be searchable. If a value is supplied then only those columns will be searchable. The display column (defined via Item Display & Return Columns) will always be searchable and will be the default search column.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24171205024375697276 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Hidden Columns'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_display_length => 30
 ,p_max_length => 100
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify which columns should be hidden when the LOV is displayed. The value should be a comma separated list of numbers where the numbers refer to columns in the LOV query. If no value is supplied then all columns will be visible. The display column (defined via Item Display & Return Columns) will always be visible.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24171205897148698853 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 6
 ,p_display_sequence => 60
 ,p_prompt => 'Map From Columns'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => false
 ,p_display_length => 30
 ,p_max_length => 100
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify which columns should be used to map values to other items (see Map To Items). The value should be a comma separated list of numbers where the numbers refer to columns in the LOV query. Both visible and hidden columns can be used when mapping to other items.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24171207408922702300 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 7
 ,p_display_sequence => 70
 ,p_prompt => 'Map To Items'
 ,p_attribute_type => 'PAGE ITEMS'
 ,p_is_required => false
 ,p_display_length => 80
 ,p_max_length => 1000
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify which items should be used when mapping values from columns (see Map From Columns). The value should be a comma separated list of item names. The order of the items in Map To Items should match the order of the columns in Map To Columns.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24171212307668711445 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 8
 ,p_display_sequence => 80
 ,p_prompt => 'Enterable'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'NOT_ENTERABLE'
 ,p_display_length => 60
 ,p_max_length => 500
 ,p_is_translatable => false
 ,p_help_text => '<pre>Use this setting to make the item "enterable". If enterable, users will be able to type in the actual textbox.'||unistr('\000a')||
''||unistr('\000a')||
'If running as "Enterable - Restricted to LOV", any value entered into the textbox will be validated against the LOV. The display column (defined via Item Display & Return Columns) will be the default search column against which values entered will be validated. If one match is found then the display and return values will be set accordingly. If no match is found or multiple matches are found the modal dialog will open so that the user can make a selection.'||unistr('\000a')||
''||unistr('\000a')||
'If running as "Enterable - Not Restricted to LOV", any value entered into the textbox will be submitted into session state.</pre>'||unistr('\000a')||
''
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 13544247856085628285 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 24171212307668711445 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Not Enterable'
 ,p_return_value => 'NOT_ENTERABLE'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 13544285967167631456 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 24171212307668711445 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Enterable - Restrictred to LOV'
 ,p_return_value => 'ENTERABLE_RESTRICTED'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 13544316775478633870 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 24171212307668711445 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => 'Enterable - Not Restrictred to LOV'
 ,p_return_value => 'ENTERABLE_UNRESTRICTED'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24171251622475734579 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 9
 ,p_display_sequence => 90
 ,p_prompt => 'Max Rows Per Page'
 ,p_attribute_type => 'INTEGER'
 ,p_is_required => true
 ,p_default_value => '15'
 ,p_display_length => 3
 ,p_max_length => 3
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify the maximum number of records that should be displayed at one time.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 24171213318403714497 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 10
 ,p_display_sequence => 100
 ,p_prompt => 'Show Null Values As'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_default_value => '&nbsp;'
 ,p_display_length => 5
 ,p_max_length => 10
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify how null values should be displayed in the result set.'
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A2A2A2A20436F6E74726F6C205374796C6573202A2A2A2A2F0D0A6669656C647365742E73757065726C6F762D636F6E74726F6C73207B0D0A2020206261636B67726F756E643A207472616E73706172656E743B0D0A202020646973706C61793A2069';
wwv_flow_api.g_varchar2_table(2) := '6E6C696E652D626C6F636B3B0D0A7D0D0A0D0A6669656C647365742E73757065726C6F762D636F6E74726F6C73207461626C65207464207B0D0A20202070616464696E673A203070783B0D0A7D0D0A0D0A6669656C647365742E73757065726C6F762D63';
wwv_flow_api.g_varchar2_table(3) := '6F6E74726F6C7320646976207B0D0A2020206D617267696E3A20303B0D0A2020206261636B67726F756E643A206E6F6E6520726570656174207363726F6C6C20302030207472616E73706172656E742021696D706F7274616E743B0D0A20202077696474';
wwv_flow_api.g_varchar2_table(4) := '683A206175746F2021696D706F7274616E743B0D0A202020637572736F723A20706F696E7465723B0D0A2020206D696E2D6865696768743A20313270783B0D0A2020206D696E2D77696474683A20313270783B0D0A7D0D0A0D0A6669656C647365742E73';
wwv_flow_api.g_varchar2_table(5) := '757065726C6F762D636F6E74726F6C7320627574746F6E207B0D0A202020626F726465723A2030206E6F6E653B0D0A202020637572736F723A20706F696E7465723B0D0A202020666F6E742D7765696768743A206E6F726D616C3B0D0A20202070616464';
wwv_flow_api.g_varchar2_table(6) := '696E673A20303B0D0A202020746578742D616C69676E3A2063656E7465723B0D0A2020206F75746C696E653A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A696E7075742E73757065726C6F762D696E707574207B0D0A20206F75746C696E';
wwv_flow_api.g_varchar2_table(7) := '653A206E6F6E653B0D0A7D0D0A0D0A6669656C647365742E73757065726C6F762D636F6E74726F6C7320646976207370616E207B0D0A202070616464696E673A203070783B0D0A7D0D0A0D0A7370616E2E73757065726C6F762D6C6F6164696E67207B0D';
wwv_flow_api.g_varchar2_table(8) := '0A2020206D617267696E2D6C6566743A203570783B0D0A7D0D0A0D0A2F2A2A2A2A204D6F64616C205374796C6573202A2A2A2A2F0D0A6469762E73757065726C6F762D6469616C6F67207B0D0A2020206D617267696E3A20303B0D0A2020206D61782D77';
wwv_flow_api.g_varchar2_table(9) := '696474683A203930253B0D0A2020206D61782D6865696768743A203930253B0D0A7D0D0A0D0A6469762E73757065726C6F762D6469616C6F67207B0D0A2020206F766572666C6F773A2068696464656E3B0D0A7D0D0A0D0A6469762E73757065726C6F76';
wwv_flow_api.g_varchar2_table(10) := '2D6469616C6F67206469762E75692D6469616C6F672D627574746F6E70616E65207B0D0A2020206D617267696E2D746F703A203070783B0D0A7D0D0A0D0A6469762E73757065726C6F762D6469616C6F6720612E75692D6469616C6F672D7469746C6562';
wwv_flow_api.g_varchar2_table(11) := '61722D636C6F7365207B0D0A2020206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A0D0A6469762E73757065726C6F762D636F6E7461696E6572207B0D0A2020206D617267696E3A20';
wwv_flow_api.g_varchar2_table(12) := '313070783B0D0A20202070616464696E673A203070782021696D706F7274616E743B0D0A7D0D0A0D0A6469762E73757065726C6F762D636F6E7461696E6572207464207B0D0A2020766572746963616C2D616C69676E3A206D6964646C653B0D0A7D0D0A';
wwv_flow_api.g_varchar2_table(13) := '0D0A6469762E73757065726C6F762D627574746F6E2D636F6E7461696E6572207B0D0A2020206D617267696E3A20307078206175746F3B0D0A20202070616464696E673A203570782021696D706F7274616E743B0D0A7D0D0A0D0A6469762E7375706572';
wwv_flow_api.g_varchar2_table(14) := '6C6F762D627574746F6E2D636F6E7461696E6572207464207B0D0A202070616464696E673A203370783B0D0A7D0D0A0D0A6469762E73757065726C6F762D7365617263682D636F6E7461696E6572207B0D0A202020666C6F61743A206C6566743B0D0A20';
wwv_flow_api.g_varchar2_table(15) := '202077686974652D73706163653A206E6F777261703B0D0A20202070616464696E673A203070782021696D706F7274616E743B0D0A7D0D0A0D0A2373757065726C6F762D66696C746572207B0D0A2020206F75746C696E653A206E6F6E653B0D0A7D0D0A';
wwv_flow_api.g_varchar2_table(16) := '0D0A6469762E73757065726C6F762D7365617263682D69636F6E207B0D0A2020206261636B67726F756E643A207472616E73706172656E742021696D706F7274616E743B0D0A202020626F726465723A206E6F6E652021696D706F7274616E743B0D0A20';
wwv_flow_api.g_varchar2_table(17) := '2020637572736F723A20706F696E7465723B0D0A7D0D0A0D0A6469762E73757065726C6F762D706167696E6174696F6E2D636F6E7461696E6572207B0D0A202020666C6F61743A2072696768743B0D0A20202077686974652D73706163653A206E6F7772';
wwv_flow_api.g_varchar2_table(18) := '61703B0D0A20202070616464696E673A203070782021696D706F7274616E743B0D0A7D0D0A0D0A6469762E73757065726C6F762D706167696E6174696F6E2D636F6E7461696E657220627574746F6E207B0D0A2020206F75746C696E653A206E6F6E6520';
wwv_flow_api.g_varchar2_table(19) := '21696D706F7274616E743B0D0A7D0D0A0D0A6469762E73757065726C6F762D706167696E6174696F6E2D636F6E7461696E657220627574746F6E207370616E207B0D0A20202070616464696E673A20303B0D0A7D0D0A0D0A7370616E2E73757065726C6F';
wwv_flow_api.g_varchar2_table(20) := '762D706167696E6174696F6E2D646973706C6179207B0D0A20202077686974652D73706163653A206E6F777261703B0D0A7D0D0A0D0A6469762E73757065726C6F762D7461626C652D77726170706572207B0D0A2020206D617267696E2D746F703A2031';
wwv_flow_api.g_varchar2_table(21) := '3070783B0D0A2020206F766572666C6F773A206175746F3B0D0A20202070616464696E673A203070782021696D706F7274616E743B0D0A7D0D0A0D0A7461626C652373757065726C6F762D66657463682D726573756C74737B0D0A20202077696474683A';
wwv_flow_api.g_varchar2_table(22) := '206175746F3B0D0A7D0D0A0D0A7461626C652E73757065726C6F762D7461626C65207B0D0A202020656D7074792D63656C6C733A2073686F773B0D0A7D0D0A0D0A7461626C652E73757065726C6F762D7461626C65202A207B0D0A2020202D7765626B69';
wwv_flow_api.g_varchar2_table(23) := '742D757365722D73656C6563743A206E6F6E653B0D0A2020202D6D6F7A2D757365722D73656C6563743A206E6F6E653B0D0A202020757365722D73656C6563743A206E6F6E653B0D0A7D0D0A0D0A7461626C652E73757065726C6F762D7461626C652074';
wwv_flow_api.g_varchar2_table(24) := '68656164202A7B0D0A202020637572736F723A2064656661756C743B0D0A7D0D0A0D0A7461626C652E73757065726C6F762D7461626C65207468656164207472207468207B0D0A20202070616464696E673A20347078203870783B0D0A20202077686974';
wwv_flow_api.g_varchar2_table(25) := '652D73706163653A206E6F777261703B0D0A7D0D0A0D0A7461626C652E73757065726C6F762D7461626C652074626F6479202A7B0D0A202020637572736F723A20706F696E7465723B0D0A7D0D0A0D0A7461626C652E73757065726C6F762D7461626C65';
wwv_flow_api.g_varchar2_table(26) := '2074626F6479207472207464207B0D0A20202070616464696E673A20347078203870783B0D0A7D';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 29015191727148297295 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'apex_super_lov.css'
 ,p_mime_type => 'text/css'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '4749463839612A002A00F50000FFFFFF000000DCDCDCBEBEBED6D6D6C4C4C4929292B0B0B0FCFCFCD0D0D09E9E9EF6F6F6AAAAAAEEEEEEB6B6B6989898A4A4A4CACACAE8E8E8E2E2E27272720000000E0E0E3A3A3A4646461C1C1C606060343434404040';
wwv_flow_api.g_varchar2_table(2) := '7878782828284E4E4E5A5A5A8686866666662E2E2E1616168C8C8C7E7E7E6C6C6C54545400000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(3) := '000000000021FF0B4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904090A0000002C000000002A002A000006FF408070482C121F970DA5616C3A9FC64B653A1540AF5800854AF5';
wwv_flow_api.g_varchar2_table(4) := '64BF4D2ED70A2E03C45432118100130683489B6841572444C1410129CCA10E0A820A070B47681F4409068C8C0C7F4D040F1094100A0E4518624C420B0F8D8D09807C95969C431954A24302A08D984F7BA5967879531D4504AE8C075003A4950F6A431A15';
wwv_flow_api.g_varchar2_table(5) := 'A74211BB06AB4E0D82A50FCC43051C4603BB8F57020C0A0F0F82B0440D114610A00F0E904F0B02046F7BC74EAD07110212F16513E4500811136600030A04A80E4082030C0E1018D8448F0206FB001470958EE1348A005AED82504BE08203CADE28E31501';
wwv_flow_api.g_varchar2_table(6) := '1F3F0911148C8433D2008304269F3428A072A5AE5D0A86012450D39528C090A018C42CD380812B086D10FC32A06080218B4210D0F4E6E069A70656A10E41B020EB97825A9DE803BB35814EA213044400B9F0CA04037DCC4EF0EA0481834F8D14A8EB6AC4';
wwv_flow_api.g_varchar2_table(7) := '2828056D9F20000A2ADC9004810F2BFBF7E4A6AB02461CF42AA2D1D564270E944903D0C05B47216F719205706D974EA048C529D3FBA472A307C792BD2A42B8116428B50D44CCB86BF702738D52F38B60E9C069D1441644600071B411B07E5D0D851AFD35';
wwv_flow_api.g_varchar2_table(8) := 'DDB0006417C6DE64302808D3B5224820B9C0F52B41000021F904090A0000002C000000002A002A000006FF408070482C12050307C1C86C3A99838742F1703CAF58A1E001E9421483AC98E95078BB0CC4782D6498CF6963432D26380E09FAB07C56308A0F';
wwv_flow_api.g_varchar2_table(9) := '19151520125807068906100B44126F5D0A4B431D8396160D4F118A8A0745116F0A56430296A6144F109C8A994403660C8D430FA6961EA9AB8913450B6E024521B583B74E0EB906BF9F7F4514C215224F12C71172D44518C29857040AABCB45AD44C21786';
wwv_flow_api.g_varchar2_table(10) := '580B0209110EAAC94FB419221005E56C000802D64F2010F5FD420BE1FC091493E000830393061E39E0275F81550EF40C7CC8C98A806310E8F55B8028178101C7121D8810100B0209A0420E001992418292571A14E8A692C03105EDFA713B96004047B945';
wwv_flow_api.g_varchar2_table(11) := '0C60D66BC060150435085E1900234BA1BD990FAA34050070AA5321081658CD22F1EA930911BA16419020279B0613F0214AE864C2A20265276C6582C0C1034E0ABA6A3552142F5BBA3F158D2292E02F8004C77639B199AB80913B462EE6F2548C27B8A81A';
wwv_flow_api.g_varchar2_table(12) := '01B8CD95D709CB55663B1E25D2E0A65852B91E04DC24B848E0448E9FBCCE07403227DA0B54291AFD0441842F07427396B82002030661C79CEEBB4AA857E68A1ECCF5CABAA2D726080243707E9DEC9D02D39F04010021F904090A0000002C000000002A00';
wwv_flow_api.g_varchar2_table(13) := '2A000006FF408070482C12098E4302616C3A9F45C4C040353016D0AC1690A8561DDB7093E1A53E98E2344051369CD546A4123D3CB415C58983C1886CED55105843026D0544020A8A0A0F6050116D0745055E0C740D0C0A109B100A0450106D060D45800F';
wwv_flow_api.g_varchar2_table(14) := 'A443139A9C9D03A0A213450B6C0945020FACAD500EA2024605784504B8AC0AB54F12A27E4512AE4511AB9B0A0E744E046C954608A844078C8A10875B0B0209110EA1BE59AA0E11020DDC6A080211D54D09F170DAFAFCFD500907181CF8E4AF080412152A';
wwv_flow_api.g_varchar2_table(15) := '744043C90BB582423E249C780140A1361024F8933062A2C7075344193810215F96060534785CB921A42806F8D224E0B0922501510AD4E96B60A06642BD0A0000556160124E020B35494961A360C020880D5426BCA071C882064F210E912040A7187B5A9F';
wwv_flow_api.g_varchar2_table(16) := '4CA807054102AF6A1A4CA0678720940906C29D9D90F50902070FBC28B0B7A02E00327ADD3A4120F48B91048285746913EBC94D43469218B95846D2135E6D8E0D69F0E041D55438C10E71E9052D2008D578DE112D84729553442019EE06194A6103CB5AB7';
wwv_flow_api.g_varchar2_table(17) := 'C90D6041A840AC872088D0E980E9D5441644E043368C68C0658A8685FEDA6F5800B21D5E6F42D80B04E9D7CD2629603D4B100021F904090A0000002C000000002A002A000006FF408070482C12098E4302616C3A9F45C4C040353016D0AC1690A8561DDB';
wwv_flow_api.g_varchar2_table(18) := '7093E1A53EB0E2344051369C8D086618A9940F0F6D851D20382820057B4E7855106842026D05445D5E0C8245116D0745058E760B0F6D0950106D060D45840FA143896D604F9E6D13450B6C9C479F944F0E9F0246050A46929B50129F114612034653658F';
wwv_flow_api.g_varchar2_table(19) := '59046C8E70A544AB660E904D0B0209110E9EB8598907110212CF6A080211D4430811AD6A50E8EDF0F14509070C0704F24D130EF6F842965EA6E51B12E18182830A8A9D2A0341423E297F204884F040C0B15911C66D69108141C48910125E6CC32081C62C';
wwv_flow_api.g_varchar2_table(20) := '1C19180429518103029F14708B27C023CB07F808556170B25D03C1071F15D0826820E1A181003AFE7170744183A348852068D033CB3B0057DB4D3807A581085AF01A4C3087C71F9402152A70106182E716040E3455D1E30A2A000B69F356786055E71723';
wwv_flow_api.g_varchar2_table(21) := '09CC0E01A1372F03283015194962A444E1B424A0D8F245A4C183070E891C789CB62A809155660A2104618F00CE153C2FAC428A482F2AA9867878CC218B5F03C24CB5C92D4442610B999FA80B79403480DB458B4CF860C10208CF70C67CCA9A8F4C9907D4';
wwv_flow_api.g_varchar2_table(22) := 'E5BDFE1BD50902BF10A0474590204901BB5A82000021F904090A0000002C000000002A002A000006FF408070482C12098E4302616C3A9F45C4C040353016D0AC1690A8561DDB7093E1A53EB0E2344051369C8D086618A9940F0F6D851D20382820057B4E';
wwv_flow_api.g_varchar2_table(23) := '7855106842026D05445D5E0C8245116D0745058E760B0F6D0950106D060D45840FA143896D604F9E6D13450B6C9C479F944F0E9F0246050A46929B50129F114612034653658F59046C8E70A544AB660E904D0B0209110E9EB8598907110212CF6A080211';
wwv_flow_api.g_varchar2_table(24) := 'D4430811AD6A50E8EDF0ED9009070C0704F14E7D0A0CC242965EA6E52302F00B9F4F10240C5C40A80C8163B3228CD382404204666D06406CC320C1C42C0D747DA23280C02705DCE22DFBC4A92115061FDB3520E3050213296C140C3834100002C15D0F1E';
wwv_flow_api.g_varchar2_table(25) := '38E0B9A001CF9EE9161CDDF24E48CC7813CE296307AFC1047378F06591A0E09B00014FE138D054454F9170461C2850F0602D83944E10B8A4928A48870746083C80C017C25A854F4C2A3242628391097FFAFA2D568B65A50A1516116990B82F3F281BABC0';
wwv_flow_api.g_varchar2_table(26) := '056001B285220D14F3BDFCE4941752443040867CA1C880BD96FD3D992B1BC083D5AB4D1059C0602D5B5AEE22F83DB0B9336EC8A0B339A84DB1C9F1D59B9112790E19B074231F9EB7BEDEA481F1D554B9831641820408EB6282000021F904090A0000002C';
wwv_flow_api.g_varchar2_table(27) := '000000002A002A000006FF408070482C12098E4302616C3A9F45C4C040353016D0AC1690A8561DDB7093E1A53EB0E2344051369C8D086618A9940F0F6D851D20382820057B4E7855106842026D05445D5E0C8245116D0745058E760B0F6D0950106D060D';
wwv_flow_api.g_varchar2_table(28) := '45840FA143896D604F9E6D13450B6C9C479F944F0E9F0246050A46929B50129F114612034653658F59046C8E70A544AB660E904D0B0209110E9EB8598907110212CF6A080211D4430811AD6A50E8EDF0ED9009070C0704F14E7D0A0CC242965EA6E52302';
wwv_flow_api.g_varchar2_table(29) := 'F00B9F4F10240C5C40A80C8163B3228CD382404204666D06406CC320C1C42C0D747DA23280C02705DCE22DFBC4A92115061FDB3520E3050213296C140C3834100002BD5D0F1E38E019E75D3E040B786E5960B4A71106289A2648D92E01830727485428A1';
wwv_flow_api.g_varchar2_table(30) := '6582014053272875D2E04285B36827C6795A4601BE5F5AD19EDD60440055218DCAB07352422E5A0DC6521139558696130E7ECF5228D2008282895EF3BC439CF84111070A141816D2E0E43B03892B505D06C17131222EA92C7AD2C083DFC5431AFC29ED98';
wwv_flow_api.g_varchar2_table(31) := 'EA82685F9B360071D6025722036697E6E72A02837E4D63C7F4437B784CA74230372F9D3C1F8107CD754287823933BFE7DB85D08930564B100021F904090A0000002C000000002A002A000006FF408070482C12098E4302616C3A9F45C4C040353016D0AC';
wwv_flow_api.g_varchar2_table(32) := '1690A8561DDB7093E1A53EB0E2344051369C8D086618A9940F0F6D851D20382820057B4E7855106842026D05445D5E0C8245116D0745058E760B0F6D0950106D060D45840FA143896D604F9E6D13450B6C9C479F944F0E9F0246050A46929B50129F1146';
wwv_flow_api.g_varchar2_table(33) := '12034653658F59046C8E70A544AB660E904D0B0209110E9EB8598907110212CF6A080211D4430811AD6A50E8EDF0ED901D15F526F14E7D0A0CC24228F500378CC367C90B180700135648156F01A13204FE2904982104B73008244460D666C08789004994';
wwv_flow_api.g_varchar2_table(34) := 'B8B8A581AE4F54063C005981013E00CB3E71F2309164BC0664BC4060D2E00240BB0E125E1241A0EBC1030787F838082A14CE82A44DA3166910EB09820436D3346860CE8182AC46261800847502D42705182858BBCFC8532339AB2820A0C52B84BB101414';
wwv_flow_api.g_varchar2_table(35) := '2B92802EDF4FECF2FDC10BE1413F22498C9C2A43CBC946C285FD0E696094E910B179DE3D26FC5514959D441A7CD2F344C0E0BBFBC6F5A2C250C8C32A8BA0A8643B97C8E22A87012C8836F6DD90040C183808EC3A33910511829F131AD7CB40A9429A9B39';
wwv_flow_api.g_varchar2_table(36) := '0B7DF517E84D10BC86F01C3B80AB490A50CF12040021F904090A0000002C000000002A002A000006FF408070482C12098E4302616C3A9F45C4C040353016D0AC1690A8561DDB7093E1A53EB0E2344051369C8D08E67661F2644492E2A1AD900B05070A10';
wwv_flow_api.g_varchar2_table(37) := '057E4E0D1E1589890244026D05445D5E0C8546148A8A1E4505937E0B0F6D095016988AA2447B6E0D8D6D06604FA58A10450B6CA74304AD075017B1152146050A4611ADB74D0EBE1F461203465365945921BE9508AB45105E0F0E954E120F141ABD15B359';
wwv_flow_api.g_varchar2_table(38) := '8E07110212D86A0008102859081113EE4FEDF7FAFBEF46800C0718F12B024801830843222810B4D0D940219CBC8069200882450806F3EC5B90AA0C81080F2E5E5CE840403E2D0824286C656000489116499A4CD34018CB96022A8E6420501F01B836A100';
wwv_flow_api.g_varchar2_table(39) := '38D0A9E0C0C97B0DC8788120670046080E1FBE13F6801B9A2147A522587055AA5722132278238220414F770D260888B0878096090606999DD0F5090207A0AAF4A155178052BD6EA120E8F8C54882C0915AD97B92EB919124FE74417160AC4883AA1A87C0';
wwv_flow_api.g_varchar2_table(40) := 'E5335608B4326701A4624AA441ABBD4E1C957990AF5861548EA110368070886A2FB5852CD05685B4E0081803EAE14C64410406073B3719FBD74B56AFCDCDF4FDEA5AE2D7E584213CFF5A364981E9598200003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 37775455727944814302 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'drip-circle.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396180000F00F10000FFFFFF000000B6B6B600000021FF0B4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904090A0000002C0000000080000F000002A3942FA080B7DC';
wwv_flow_api.g_varchar2_table(2) := 'D28A52D17767C45B37FE7908488DA2731A246A756DF89A310BC1B57CD3A59BAB69D50366663EA290370CAE8AC1A41309B53DA551DCD4BAC352B7DAAEAEFAE586BDBBE551CCBC8ED769701B5D32CB7F73635D49CFDB7FEA37F9FC77D707C84658A687B7A7';
wwv_flow_api.g_varchar2_table(3) := '98C83828E81687E82809F908679965A88959C8E9D74999B9191A480ABA386994DA5869FAF93A8A2A1ACB7AE94ABB3A98DB2A6BDB5BFA7B50000021F904090A0000002C0000000080000F000002B09C3FA020EDB2D86B71D26521B695EFD981DF1392A383';
wwv_flow_api.g_varchar2_table(4) := '1CA5B35E4AD66AAF378BB579B3A72BD9FD9332C4863BD94F97E3C18AC4A471E90C26985467F3A8A4619F5AE83626BD7AC7DDB28F7C36E3B6E1EAD78D5EC7916F2BDCD2B6EBEBFC79360D28A786122436F8271848E7C7A588489862E8D89858B978487939';
wwv_flow_api.g_varchar2_table(5) := '99D7872969F9189A290A567837F9A9093ACA9ADAC0C9E8DA7ABA2A5B1A49ABAA4B9ACBBBC708EBD93BFB2B5CBC697A5C3B6CCB3C5C000021F904090A0000002C0000000080000F000002BE9C3FA080B720A2146FCA6AE9CA5A716C8193786D191935C6A3';
wwv_flow_api.g_varchar2_table(6) := '2666F88E71E99D738476905DC3BDFC93B458AA9CF1A6FB208F41DCF2D9140C17D32873E7C302B534AED30AF52633554631AC04ABC5D7341B4D3E2BCAEE3AEFBDB667F55B4E997EC7D725F88567483866F1277718E8B8F7D817393899C208089929A949C9';
wwv_flow_api.g_varchar2_table(7) := '598898B3D8D05699B879DA89FA592A8A40EA699A2ABB0AFB3AD1EA0057ABAB1A4BDB1B7AC908CA3BEB7B6C6B8CBB52FC6B9CEC1C8D8CB4EC92570A3D7DBD1B55000021F904090A0000002C0000000080000F000002CB9C3FA080B7DCD212B48A672BCE77';
wwv_flow_api.g_varchar2_table(8) := 'F29D8196A879A1694592A23E2D5A2A5C277F3045E2370DCC393F7BB1222EE2EE873C2A6B27E668D9E308218D6215EAC3DA9CB168D3FBE4EAC482A9D9484EA6B5DFECFA0DAE9CAF437A7C7C076EF36A3E3B9C37876035F8D7E5E60787B8B8178446555817';
wwv_flow_api.g_varchar2_table(9) := '9948C9D8D68879A999F228E860886709287A98392AD5996A471A6A5ABAF97A0A4BE16940F8A9E8DA3AABC7DBE76857BB52A9DB2B7B1C9BBCCB19AC3AC96AAC1CBD2CFD8BDA8CFD5C6CED0B3AFD2D7C6BEBCD8D4C7DFEFD53000021F904090A0000002C00';
wwv_flow_api.g_varchar2_table(10) := '00000080000F000002D19C3FA080B7DCD28A52898BC5CB7873BD7CA0F5799C99A118F5B053D4C261399F757A77F9A5F2FB0810B91443482376FCF580A2A5530925718A5419D11AA449715B5DD7F7656AB3B6703579451B11CF709BCC857BE560BA788A3D';
wwv_flow_api.g_varchar2_table(11) := 'B35FEA66D4FEE6E7F6279467A85624084838A6E8D8F8A1E7C0B79756B9389889B9F95866276980749908E9D919773A977A015AB1366909CB598A4AAB6A5B578878388AB57A576B8A0B7C8BB77BDCDB371CB8CC286C9C1C2D4BFA1C6C5D7C9D3BDC2A3AED';
wwv_flow_api.g_varchar2_table(12) := 'DBACF9CB5CBDC2EB8D2C2BEE9C4DAC4D7E51000021F904090A0000002C0000000080000F000002D59C3FA080B7DCD28A52D127B21678E7EE819BA891DFE265D7143DABD5B28DC9A1298DDBA13EF2DA0B99C910AE184CA848D59237DF89B983F6A425A700';
wwv_flow_api.g_varchar2_table(13) := '88350689438735477D0294E071337CD566915BEF918B2E93BFF4B8750D6F1B8A6CE0DC0E6816253845588586E7A657B1C897F7672806397916B96499B8D7A5F9A6E8574939185A38FAA376DA87FA08CA2ADA4AFA6A9A3A9B97C9582A199BEBCABB61EBE8';
wwv_flow_api.g_varchar2_table(14) := 'A9AA887B492CA79B461BACCCD9586779DC7B087D27DCFCBB798B1C0D2BBDEB6BCD88DDD96CFC6C1EA834EE4C2EAE854E9DBE6D55000021F904090A0000002C0000000080000F000002DA9C3FA080B7DCD28A52D17797D85CBCCE7DA0A78D227876991561';
wwv_flow_api.g_varchar2_table(15) := 'EDF4B28D3B97A8DDA521BE2B23E91BAD2035198276841589C9E0CD99E36D74532910F01B6A634C87B2D93550AFBFB1D93ADE2ED560B617DAC39AD07478D52E708BBFEF70C58FD4575627F754188597C6A5F7C718B8974838184979C8E1C8070998D9C835';
wwv_flow_api.g_varchar2_table(16) := '6979074A365799B578BA86DAE6492A7A56DA6A9A3ABB4ADB37F4991BBB6B285BFB7BAB1ABCA4DBCB8BE86A8569340CAC897B1C578C3C7D29FC7CDD69AB591DDA3D6A0CB2BCC98CBDFDF7FD9A0C2B9EFDA8ED0C2F18ED4D0F4E3D52000021F904090A0000';
wwv_flow_api.g_varchar2_table(17) := '002C0000000080000F000002D89C3FA080B7DCD28A52D177677CA27BC17D5D28929FE965D6A63518BBBA2DF2CA8A382E38A8E3687EC3A92036226DE6401A6AC75813B0FBF182A55E95FA196A61C6A4D3DB5D2A2B509FF574F648A5DB62FBF9060FA36960';
wwv_flow_api.g_varchar2_table(18) := 'F97A476353DCB8F8FB1746E64746B7676798A7562740C824D717E9C69558697638A5D8E138F618C8095878A9996989B7032AE839280947396AAA47CAD60A3979EB8A0B16BB88B9C6981A5CFBF97A0A7B6C2C22AC4BCCCC5AC48B882C8B3AFC9C8B6D9B1D';
wwv_flow_api.g_varchar2_table(19) := '185D3ADD4BBABC7DAD5DCEFD2D9D4C2D64BDEADE091FFAEBCB384F5A000021F904090A0000002C0000000080000F000002D59C3FA080B7DCD28A52D17767C47B890F0A4F088EA4E89D99D5B10DF76AB18BC0B57C2B27AA9F26F90BAD203362CEE8C02569';
wwv_flow_api.g_varchar2_table(20) := '4BA4C1D6DC054B296055D87256B4D0A7D2CB0473BF5BE995DAB3A6B1C5A13BFB6EC3B3E6351A50C7ABE6F2FE31FEC7779447E873F601D89428B6B8D538F501C9A3A746C916E8A728A899C9486768177938B9F348D6E5B8E9D959066A795748621A96CA8A';
wwv_flow_api.g_varchar2_table(21) := '7A7B3A2AB93B3A3B468B0B9C2B1C4AEA1A7BC989B9ACDCBCCA2C860C7BBC673BFC8BED3B242D5A2CA9AD5A0B2DEEDC5AC96D2C1B1E9CBD7EBD4D7D1E1F52000021F904090A0000002C0000000080000F000002CA9C3FA080B7DCD28A52D17767C45BB727';
wwv_flow_api.g_varchar2_table(22) := '84A2008E61696656B77E1EC2B92DFC3AB511D38A792E3CE9E3A92032A2CE689B2591B85B85F91CFE5023AA6888654173CB6CD17B9C064DD610B8AB3D3795EBAD93DB16EF7865813A9ACE7FF5C77BFD3F36E2F746C886B787D8A72507C0F833680877A898';
wwv_flow_api.g_varchar2_table(23) := '8856194717285207E91659E819DAE9983997C26749A99ACADA365ADA08FB88EA4A3BD97A5B7BF9444AA669662B290CDAF9EA6B5AF56B174CCCFCF92CBA283B7DBA3B0C5DEC1CDA9B8C7CA59D6DDD2CEEDD530E745E000021F904090A0000002C00000000';
wwv_flow_api.g_varchar2_table(24) := '80000F000002BF9C3FA080B7DCD28A52D17767C45B37FE2DC2480A4F496656B7862D02C29EFC3AB35D1B310EA0E3E953415C435A91274CB28EBA5B3357E9F9802825D16AC42297DA2733EA338982DCF2D59C456FCF6C63985AEA46E53B2FDD39577BDFE3';
wwv_flow_api.g_varchar2_table(25) := 'AA3EDFB6961668F7570736D517678877E8D80809F528A9480297C248A9F935C919E9B9C9A71076B7590A8A7A2A242AE5470838182B385BF8DAC94A9A99AAABCABB844B66FBD92B6CAA0BEC2A5BAB0C4BDBBCEC7C9B381ACCDC496C3D7C3CDD5A52000021';
wwv_flow_api.g_varchar2_table(26) := 'F904090A0000002C0000000080000F000002B29C3FA080B7DCD28A52D17767C45B37FE79C82394A690599D1AB2A3E8C006F8BAB13DCB15D402A799E2D58437620EB70B2A57C62433F82B2D7BD361B5783D3669586614F50C53C55672778C2EF7BE5967FA';
wwv_flow_api.g_varchar2_table(27) := 'AC8EC3E7DA36296AD771EB66FEDB2F0758C4D6E71668488728B8A8D878F79387B4E7A8572969B98549F84779E999F919093ABA7938798A29AA5AF878B2CA891ACA9A3AAB509A183BFA6A4A0BBB70CB98BB8BDBCBFB09DCA95BABEC2BDBEC1355000021F9';
wwv_flow_api.g_varchar2_table(28) := '04090A0000002C0000000080000F000002A39C3FA080B7DCD28A52D17767C45B37FE7908488DA2731A246A756DF89A310BC1B57CD3A59BAB69D50366663EA290370CAE8AC1A41309B53DA551DCD4BAC352B7DAAEAEFAE586BDBBE551CCBC8ED769701B5D';
wwv_flow_api.g_varchar2_table(29) := '32CB7F73635D49CFDB7FEA37F9FC77D707C84658A687B7A798C83828E81687E82809F908679965A88959C8E9D74999B9191A480ABA386994DA5869FAF93A8A2A1ACB7AE94ABB3A98DB2A6BDB5BFA7B5000003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 37775459422984816578 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'bert.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396180000F00F20000FFFFFF000000C6C6C6B2B2B242424200000000000000000021FF0B4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904090A0000002C0000000080';
wwv_flow_api.g_varchar2_table(2) := '000F000003E708B20BFEAC3D17C5A4F1AA7CABF61D3781A3089918B391AB5949A9FB96EC6B9DF58CCBB9DDF340D54E1823B68C365A107664FA744527B4798B56A94AE4343994FE9E57AE35EB5D86B7E86F590B5EBBCF6AB8992C67CFBB3EBA1EBF1FF3FF';
wwv_flow_api.g_varchar2_table(3) := '7E81587862838285886977878A760C039091031392919495930F98990E9B97959F92A1969A98A390A79C009B9EA5A0AEA2B0A49DA6B2A8B6AAADB4AFBBB1BDB3ABACBCC1C3BAC4BEC7C0C6CBB5BFB7CEB9CDC9C2A9D5B8D6D0D8D3D1C5D2CCC2CADEE2DD';
wwv_flow_api.g_varchar2_table(4) := 'E4C8DFE6E3E8E5E0DAE7E1EBCFDBEDE9EFEAA2C3BF1AF8C9FAC8F917FB02FAE3077020A8040021F904090A0000002C0000000080000F000003FF08B40BFE22C607A5A0CE5EAC31E89CE581145949A318A24C5B6A5B06BF261C7FF3A9CA75CEEFB89EA6C5';
wwv_flow_api.g_varchar2_table(5) := 'A0016D46944EF963068FBEA713B99C5405C4C635696D76A55FAAF7260693A3655B96C03D0BA1EF297A1E0FD32DEBB67ECB1FEFFD7D667F667981697772756E708C898D11858092828688768A83871A059C9D051403A1A203A0A3A1A5A6A8A3AAA2ACA70F';
wwv_flow_api.g_varchar2_table(6) := 'A6AF0EB1A4B0B1AEB5B3B19E9DB8BEB6A9C0ABC2ADC4B200B4BFBAC1CBC3CDA2BC9CCAC8B7C6B9D4CCD8CEDAC5CFC7C9D6D3B4D19FE1E6DED7E0E8E2D5EBE7DCDFBBD1ECD9EAF0E9EDF7F4DBF6FDF2BCFBBAE97BE7AF5EBE82FC0EDE028821DB330F0EB9';
wwv_flow_api.g_varchar2_table(7) := '41DCF6B021458916055664052001010021F904090A0000002C0000000080000F000003FF08B40BFEAC3D276A9DD40A0CF4C61E17829A58929699A257C44CAE948DF359AFF7F5787AFEF913DEAFC30BF2620458CC482336854C9B530ADD15ADCFAB0FA974';
wwv_flow_api.g_varchar2_table(8) := '457153701588A56AC33DF470ACE6429665F1994D9FDBB378B3C7EDE0ABBF697579728381777A1A7E7E8288848D86856B878E168A7064987F71908F9291809E1A05A3A40513A5A41303ABAC03AAADABAFB0B2ADB4ACB6B10FB0B90EBBAEBABBB803A8A3A7';
wwv_flow_api.g_varchar2_table(9) := 'C4C2C8C0B3CAB5CCB7CEBC00BEC9BDC1D0C3C70FC4A6D7D4D2D6D5CBE1CDE3CFE5D1D3DDD7DBC6A8DEE9E7BFF1EFE0DFE2F6E4F8E6FAABECDAD9F3D4051CC84F5E417AF7E015F4E780E141810F092A9C588F62C260EE3064B4C5E10F5EB98EF93E62F0A8';
wwv_flow_api.g_varchar2_table(10) := '0FE43E911C13000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C97422E70BF4BE9EC085A3576AE73791A05949D43BBDD613AADDBDEA368FF939D64F1834F542B4990CB21C1A9DA8E3B31885E26E2269957ABD2599156558DB2562';
wwv_flow_api.g_varchar2_table(11) := '7766E0999CB5B6B9826F6C3C8FA0A76BF77D9B87EFCB785E4D0A83727E6C7F6F7D8B6A8D6948859174877A88969598949A58869D838C8F81A17C8EA2A61A05A9AA0513ABAAADAEAC0F03B4B50313B6B5B8B9B7B3BCBBB9C0B6C2BABEC1C6B6B1B20ECAB0';
wwv_flow_api.g_varchar2_table(12) := 'AEC4B4D0BD0EBCD300D5D2D9C8C5D4BFDBB4CD0FE1CCB1DADDC7E7C3DFD6D8EBE6D7DEE9B5E300F4F4EDF2D1EEFBF9ECF1F0E800AAEB67AF9C3883FDDEE113C88DA1BE84FC1CFACB55F0D9418B10334A54F86F1AA1C78EBF305E4CC541A43C0E014F5E48';
wwv_flow_api.g_varchar2_table(13) := 'C910E5C06D2E1B9E4C000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F102C1B9EEDE050A1F587667388D2959495835BD16F4AE23F9E4BAC3E3AC5D0E6812067D39DAEC66933533C622F2B8194651575595FACB0A944FC6D2';
wwv_flow_api.g_varchar2_table(14) := '19834EA55B74F78C656BD7E9769C032E8BC33005D3DD9BF7E180567C44723C757A6488668A77835E846F827E907F92867B8C798787815C969F9EA16A49989BA5989DA3A285A0AAAE1D05B1B20513B3B2B5B6B40FB9BA0E03BFC00313C1C0C3C4C20FC7C8';
wwv_flow_api.g_varchar2_table(15) := 'BEC7C6C4CEC1D0C0BCB8B6D5B3D7B7C9CDDBCFDDD1DFC5E1BFD2E4E3CB00CAD4BBB9D9B1EEBDE9DCCCDEF4E0F6E2F8E6FAE8CAE503EB1C04043070A0BF73FF12225CC8EF5FC176ECAC45C4C6505E3D8BF730E6D3B88F2B63BF791E1F4A140891E4488F0A';
wwv_flow_api.g_varchar2_table(16) := '1B563CA8B225CA9326DF5D804990A2340D17F1E1CCA8F3424E8D3B8B25000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7C85F7DA07766258929F99A2602561D5E45A902BDB8FB83AFAC8F7939E2008CC157FBAD92D56';
wwv_flow_api.g_varchar2_table(17) := '63C2384F0651373D21AD006175973D7693B8E86BE32443CD5223558DD5B2B9EE2BBCA76C9EEB625A7EEBFBB6BD717E736B721E786863878A61827D818F8091848D028B6596778C90939B7F9C922298697B76A3887A947C436F8EA0839E2205B2B30513B4';
wwv_flow_api.g_varchar2_table(18) := 'B3B6B7B50FBABB0EBD1303C2C303C1C4C2C6C7C9C4CBC3CDC80FC7C2C0BCBAB9B7D7B4D9B8D1D2CFC5DDCAE1CCE3CEE5D00ED203D4BFD6D5D8EFDAF1DCE9DEE7E0F5E2F9E4FBE6FDE800D4B10330B0A0BB76F0FEE10B684FE1B787F7BE194C48F060458A';
wwv_flow_api.g_varchar2_table(19) := '03D5417418B12D23478513E52114799164C6860CF5A5E4B7D25F4B801A23521CE96B9E8699256BF6D3A072E7859E2D79B2DC99000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CAB1620F885C2189AE245962AB97950';
wwv_flow_api.g_varchar2_table(20) := '65C53056BF9C9D036BEAF4AC5F6F02240E1F40D94CC798289D32E8ED893C0A57466C557B756D4954A644BCC43569BB30CFBAE6B6BDDDD3571E07A9EF51F4992CDD15E73E6F7482817F75027853797C7A63668E8684419259709480888B8F6589699A6A91';
wwv_flow_api.g_varchar2_table(21) := 'A16CA26E499FA78AA99E37A496AD83AF2005B3B40513B5B4B7B8B60FBBBC0EBEBAB81303C5C603C4C7C5C9CACCC7CEC6D0C5C1BDBBC2B5D7B9D5C3DBD80FCACBDFE0D2C8E2CDE6CFE8C6D4C0D6DDDAEDDCF1DEF3F000E0E50EF8E4FCEAE1FAE0D8011048';
wwv_flow_api.g_varchar2_table(22) := 'D05DBD59D910FACB776FDCC27E00CF453C5650DE4083172D56A4D7503362C77413A33D1C19721AC68DF6502A3CF8EBA3C8920CF79174F98F26328BF534E0CCB8F29D4E8E2135780C7A61A84BA1CF12000021F904090A0000002C0000000080000F000003';
wwv_flow_api.g_varchar2_table(23) := 'FF08B40BFEAC3D17C9A4F1AA7CABF697208ADA48866699A2E30662AFCBC1B3CC4C9544DF8FD9F63EC1242804FA86C19C0592C3359931A533FA74109147E3CA1AC49AA4D01A78A7B395C7E62537BBDE02AEDA5F7B84AE57D353F11D0D9F9FFC45805E747B';
wwv_flow_api.g_varchar2_table(24) := '8554877A883C82717F6F5D8D818F3E768A678689998B936E7D9C729F8E44959A97966A78619B9EAC908C8005B1B20513B3B2B5B6B40FB9BA0EBCB8B6C0B31303C5C603C4C7C5C9CACCC7CEC6BFBBB9C2B7D3C1D7C3D9D6BED40FCACBDFE0D0E10EE0C8E2';
wwv_flow_api.g_varchar2_table(25) := 'CAD2DDD8ECDAEEDC00EBF2DEF0B1E4E8E6E3E9CFFCC6F8F302D6A3D78EE03B83F1E69DC3C7D05F3900E7041694789062C2810B1DE683B84F2E5F338D16EF6D1369AF174292274D2AECC8F1A3C77E2FFF6944A8A120BC9A076F5EB049F3824B7F1A7EC60C';
wwv_flow_api.g_varchar2_table(26) := 'FA2C010021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CABF61D370924A995E6850A27BA8118FC8A333355524CE316848F2BD623287410812BDEEDE793299B3BA6CE06A51A8348D710BB4D4A6B39706F1A7E92C7E2A5EC';
wwv_flow_api.g_varchar2_table(27) := 'D8D55E57D992395D2D7FE7F8FB97FD7603F87F41794E7A848651875681706D2571297D728588948A8395766B5C91908B7E44979693A28999986880A99B9E2505AEAF0513B0AFB2B3B10FB6B70EB9B5B3BDB0BFB40F03C4C50313C6C5C8C9C7C3CCBCB8B6';
wwv_flow_api.g_varchar2_table(28) := 'C1AED3BA00D0BBD2D1BEDBC0CEC9CBE0DFC6E1C6D8D7DAD9DCEADEECC2EED4DDEFE8EB00CCCD0EF7E5CAE3C5E7FFE9E8B513380F60BD73FAFA11DBB750E100830321160C28311E3C6B09F3316388CF27DE338A200F868C387262BD8C1EC5695499925C3D';
wwv_flow_api.g_varchar2_table(29) := '771A5E128C3910E605993259AE6CB84F03B8040021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CABF61D378193609ADA895EAAB091AF1833636541760DDB37B6E78FD6CA217405853C9D2C89FB3997401F14562C09AD2D';
wwv_flow_api.g_varchar2_table(30) := 'A694D69C7AB95B49B8371397C9D5630BABD29E95E07737EEAE47E5C4AB5AC53ED99F74777F5F66837169796B7B7E828D80858E8464866688009645949391818F9B9E70957A897C8B2605A8A90513AAA9ACADAB0FB0B10EB3AFADB7AAB9AEB2B01303C0C1';
wwv_flow_api.g_varchar2_table(31) := '03BFC2C0C4C5B6BDB8CABACCBCB5BECEA8BBD3D2B400C90EC5C60FDBC3DDDBD9D8D1D0CBE5CDE7CFE3E6EBE8EDEAE2DEC7C2F3C1E2F7E4EFD5E9FBFAD7F8ECE26DABC74D5BB87C00DD258487B061C07CF2C015233860613F8BFF1C2AD4C8901B5D448313';
wwv_flow_api.g_varchar2_table(32) := '25D263974E03C97726DD95BC70B2A54A0021EB699898000021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CABF61D3781A3F80828AAA56A2561E416BB16E496F36DE7BCC9A6931F8A86331177461D2CD963149D48A84328';
wwv_flow_api.g_varchar2_table(33) := '080A8F4BA98CC9D562B75E25F835AE4D85D6DF772D6637C9EE2E5C4C4DB3E2E1B7B9FC9CEBFB7B5F7527576D867F517E7281878B7640846A8D798E898C88598A945A83673F05A0A10513A2A1A4A5A30FA8A90EABA7A5AFA2B1A6AAA8B3A01303BABB03B9';
wwv_flow_api.g_varchar2_table(34) := 'BCBAAEB5B0C2B2C4B4ADB6C6B8CAAC00C1C8C3D0C50EBFBABEBFCFCEC9D2C7DAD1DED3E0DDD9E4DBE2CBD4D5D7BCE5DFEDE1EFE3E6F1E8E7CDD5BD0FF8F4CDFCB7FDF302BA13180EDFBA5DFE98FD5BA8B021B77A09D3FD3A68ED1B370D16C5610C77F10C';
wwv_flow_api.g_varchar2_table(35) := '42C68F1C355E9838921780040021F904090A0000002C0000000080000F000003FF08B40BFEAC3D17C9A4F1AA7CABF61D3781A308998EA0AA1BD99A9584B9B175D27189EF70FEACC09AAEC7630C8D37A212395BCA5E4C0070254C46ABCDAB2FFBC442BBDB';
wwv_flow_api.g_varchar2_table(36) := 'AF8D3B964E05DE74585D04B7CB6C67F98C5EDBDF47B73C0FBFEF7F67715A78567A837F647C8A805382868F7D8489859188621374059A9B05139C9B9E9F9D0FA2A30EA5A19FA99CABA0A4A2AD9AB1A60003B6B703A8AFAABBACBDAEA7B0BFB2C3B4BAC1BC';
wwv_flow_api.g_varchar2_table(37) := 'C8BECAC0B5B8B6C700D1D3C2CCC4D6C6D5D2DAD4C9DBDECFD0DCE3DEDDCBDFE7E6CDEAD7E8CDE1B9E4E9F2EBF4EDECD9E5F6B4F0F8B3FFC5006213E8EEDEBE09F0DC69F0C66CE1B98617182A8CF870622B87CD1C3C0390000021F904090A0000002C0000';
wwv_flow_api.g_varchar2_table(38) := '000080000F000003E708B40BFEAC3D17C9A4F1AA7CABF61D3781A3089918B391AB5949A9FB96EC6B9DF58CCBB9DDF340D54E1823B68C365A107664FA744527B4798B56A94AE4343994FE9E57AE35EB5D86B7E86F590B5EBBCF6AB8992C67CFBB3EBA1EBF';
wwv_flow_api.g_varchar2_table(39) := '1FF3FF7E81587862838285886977878A760C059091051392919495930F98990E9B97959F92A1969A98A390A79C009B9EA5A0AEA2B0A49DA6B2A8B6AAADB4AFBBB1BDB3ABACBCC1C3BAC4BEC7C0C6CBB5BFB7CEB9CDC9C2A9D5B8D6D0D8D3D1C5D2CCC2CA';
wwv_flow_api.g_varchar2_table(40) := 'DEE2DDE4C8DFE6E3E8E5E0DAE7E1EBCFDBEDE9EFEAA2C3BF1AF8C9FAC8F917FB02FAE3077020A804003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 37775461519102818296 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'bert2.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396132003200F20000FFFFFF0000003636360000009C9C9CE2E2E2C2C2C270707021FF0B4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904090A0000002C0000000032';
wwv_flow_api.g_varchar2_table(2) := '0032000003FB08BADCFE30CA49ABBD38EB25042B5BC80CC3420C8628921CBA80EAC52A83A710421A57B3311C2DDD6E323B0C08B7DF9057020806A0420D063820970E96D466BC5695D806CB07F4D9BEC0B0B8644C3D75C6B47AC4F69CD2F18F103B531841';
wwv_flow_api.g_varchar2_table(3) := '79261D737D0A806000060702077B4B85868C0A8A1D5E6A9086000538020454844D0E051D079F9AA63198264205060407B0A82BA110ADAF8C568EA9B40E38B00406B23BAA0BAEBA6A0496734B9BC9CECFCBB5CFD3CAD1D61B06C1D715AEC9C1C2DB9AD9CF';
wwv_flow_api.g_varchar2_table(4) := 'DAE1869FADDDE693D9A2E0CBE9EFD60554D9E5EBA754E9F7E6F4E8EDF8F23590078F5EC05A060FBA23188EA1C28710234A9C48B1A2456B09000021F904090A0000002C00000000320032000003FF08BADCFE30CA49ABBD38E3C2CE619CA61D03B10CC342';
wwv_flow_api.g_varchar2_table(5) := '0C8698ADC222A40A1902B71B15A84C038298C22068E92433E34068187C14C1DCD1B17ACE142B13203B95F0844BE88053083208C6AE8F732D0B49E98340ABAE9500BDE687F804C8FB755B4E7829704045350280813C29062604315589800552473397721C';
wwv_flow_api.g_varchar2_table(6) := '7F671E812474207E8A0B067F695D4D420E654F059107A9753D1064047204976A493BB9529675931168208F9F6AAB1405C71E68B34728BB2A1E0768D34786110606D8C907DE8153B08FE568C5E25EE7E6E5E9EEEE96E1EF0DDCF5C1F31396F5DCF7F8A320';
wwv_flow_api.g_varchar2_table(7) := 'CCB8F96B10EF813C71F10E0E4C38B042C186CB14429C48B1A2C58B18336ADCC8B107A3C78F20E725000021F904090A0000002C00000000320032000003FF08BADCFE30CA49ABBD38E3C2CE5905A769C6402C82B01082315622500CAA922E8710C76F67A2';
wwv_flow_api.g_varchar2_table(8) := '03540D7053185ABD066110541C062E62EDF871EA928D6775592D2EA3AC1396311B7066B562EE2C38C408D1E4326D96CADA0A563C3C2642014F27372527057879026263252A251F375F8057007C7D363F78062E041F4762950A2158653C4A57A000061E63';
wwv_flow_api.g_varchar2_table(9) := '5A121CA0069C04A52F4CB4640762059C077163731367AABDB749027FAEB2A5A258254D129A649A048AC63F1405D3D470C519A413B1D406CC968034C1E3E50F87EAEDA19AF0F1DDEED9F1F2EEF8EAE4F93021FEFC16FC090488ED1F411807132A5CC8B0A1';
wwv_flow_api.g_varchar2_table(10) := 'C38710234A9C48B1A2C58B18336AAC98000021F904090A0000002C00000000320032000003FB08BADCFE30CA49ABBD38E3C2CE619CA61903B108C2620886588540317C0ABA1C02EC42A459A7BF1B0D6038B4760CD2E03638DA62021FC0A3434E678A5E10';
wwv_flow_api.g_varchar2_table(11) := '406065A3D62E6330E0C8804F9CD9933C62040320375E2B039E025AD74D308AE072702D044D77292B26056C0A7D521A805974241F367B5307218D569057267944831F888C078E0555169067127D1C9A2A048E6F74A80EAEA50B05B106B5A9742FB10A0506';
wwv_flow_api.g_varchar2_table(12) := 'BB5677BF1421C4046EC69C15BBA8BDBE7213BC20C306CD7FC8C9D9DABCD317CF12E0DAE2DC3913A7E84882C6C6DB10ECF4ECF017F5F5F7FBFCFDFEFF00030A1C48B0A0C18308132A5CC8B0A1C38710234A9C48B1A2C58509000021F904090A0000002C00';
wwv_flow_api.g_varchar2_table(13) := '000000320032000003FF08BADCFE30CA49ABBD38E3C208D16063089F72088B711821C52985702CC7AC10C7DB4263090828930D505B1408BA1DA0300812052CA2AD70F0E192CAC3A064D80A15A3A82ADABA2E04034ECC560498DD3E80015BD13A09031BF0';
wwv_flow_api.g_varchar2_table(14) := '2B05AF52046418684E682C782C45312C543E06812D84604D72793F33231C6F8F8215068292445E55722C2A72A472900C740D78793A924C430F2A1C9CAC9F134703BD3EB22EAA64059F73165A4D5168AD10ABA5C61B684D6A20C4D02023BDB417C5CC18AF';
wwv_flow_api.g_varchar2_table(15) := '5E1B5805E4DE1154BD501AE5EC2D31E9E6ACED4A29BD962EF165E9F44A6BFCFF00030A1C48B0A0C18308132A5CC8B0A1C38710234A9C48B1A2C58B18336ADCC8310261020021F904090A0000002C00000000320032000003FF08BADCFE30CA49ABBD38E3';
wwv_flow_api.g_varchar2_table(16) := 'C208D1606308C6721C8B7170E1C40285802A67BAB6D258D28239039E4581F0C2C1043D0541C0AAC10E3B808168EC0C3E5201D6A9DA0DA3211503C989CD9C845F5058B41C0649E9E0CC04A0B1D357C1D076CF4D2440813505503004517B60196F49067F31';
wwv_flow_api.g_varchar2_table(17) := '1F352A1C790A7B7D1306606F6757761F9B521F5F97A21903732F9D473F0F96980C05B3144BA9587670301465A797B41585A981B99910BEB3C61231C36520C9CAB2BE0A23A98B16C91704A973544A7119D1AF0702DC708655202AE5DC32D7E9BC69E670DE';
wwv_flow_api.g_varchar2_table(18) := 'F01743ECDCE8F617EBA9AEFCEED50B48B0A0C18308132A5CC8B0A1C38710234A9C48B1A2C58B18336ADCC8B105A3C78309000021F904090A0000002C00000000320032000003E908BADCFE30CA49ABBD38EB45C8FE4B71189CA71444015EA209748B91AE';
wwv_flow_api.g_varchar2_table(19) := '912190CA7194FC69A8B49360A7201C8030000A073030832F81A9702B4E67CA1FCD40CC0980075352167B02338741D726262609B882F6543863D2DDC3B759852D154E21752078423B2D2F1E322A4E40757615810B8551247E2A72598E8318546A6785542E';
wwv_flow_api.g_varchar2_table(20) := '0F994A9C19360352936A4A168F2B0403AA387A9012A72022B347AE5013923102B3B7BF0D05B36A582F5DC61104C3C9434FCE145CD1AAD519723ADADECED8C9E2E3E2A350E1E4E9B3E6DFEDEEEFF0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF00030A1C48B0A0';
wwv_flow_api.g_varchar2_table(21) := '410709000021F904090A0000002C00000000320032000003F308BADCFE30CA49ABBD38EB65CCFE4B71780A418446015EE2A9182E50902B24D22617778C5A878703E7E083717C32E40F6010906E2FD7CC57A8D68C8BA0EFE0C2F214D61A41207C095C84B2';
wwv_flow_api.g_varchar2_table(22) := 'F7A95C1DC88BB4CA40649EA6E0B61B2E0BF63D46786120290C6365631E041E5633792B050267486F655C12838402034E71707A4B106303230A6FA0A1366FA42AA8A92F342F079CAEAF05039C5C4869AF13699BB864B1BD133092C1C4197431C9CD35B3B8';
wwv_flow_api.g_varchar2_table(23) := 'D1D1CC28B51BB392D9C7CC74C065CE0D05A3D29DE03269D29C8BE64CABD1C2EC00E3C1BAF160EF04D6CE5CC3F6FEFF00030A1C48B0A0C18308132A5CC8B0A1C3870413000021F904090A0000002C00000000320032000003F508BADCFE30CA49ABBD38EB';
wwv_flow_api.g_varchar2_table(24) := '55CAFE1CE12986C18CE04598240B74A954AC8B41D42E1C43C57193A21607B573180EAC19ABA4D0159B3F05E130A201982F62912088F67E3661F6C9E046A79E9907EB2403CC4DDF8BC66CC70C44F8157935C1EC29025D65836F516E0D47822E705A888982';
wwv_flow_api.g_varchar2_table(25) := '7C6F548F133382418E95780D3D829A8F05825D9C409510538203023E2EA711360702030307AF15054787B7BC18B2A3C085BD00BFC1980F3DB6C3A8B402BDB907CA24B3B5A0458AB4AB4DD402D6315CD9AB7C3DCDBB88D93E2804D9E68F5835D494CB1CDC';
wwv_flow_api.g_varchar2_table(26) := 'AEF307D9F6CBEBB4EDCBB4F2E635B022B0A0C18308132A5CC8B0A1C3871023CE4B000021F904090A0000002C00000000320032000003EE08BADCFE30CA49ABBD38EB55CAFE9CE1291D688ADC685605A11A46BA5A2D118EE5CC123150A03E95AED162106C';
wwv_flow_api.g_varchar2_table(27) := '0A1849385C180E481F2FD9CB351BCFA8C1E54359AF8C2C690AF032755F71990B042B0ED0701C4076CB05875E796E873CF1234F677D1C0407025C836E6D6380840D02783C2F518F498791927A960E2D98789C135B95A1A5129F99999B96A8A902AB61A611';
wwv_flow_api.g_varchar2_table(28) := '0203B0603F700FB4028A335BB40303020EBB7686C0C2750BBBBD26C1786D04C30AC57D8C65C031CCA50507CF1ED5A1DEC23DDB9C04C10351E19CC1072AE6A14ACBC2B2C4C2CD96ECF600DEBCFC46A6011C48B0A0C18308132A5C4821010021F904090A00';
wwv_flow_api.g_varchar2_table(29) := '00002C00000000320032000003FC08BADCFE30CA49ABBD38EBCD63E9A0537CA156182430969B612C2B9B9D692C7BEFE2C2E9FD18849C0AA5B0F97E4118D1787400853B55EF687C1697531FE1200458BDD966619B547C9B11E081400286D1CAC3FA8D668E';
wwv_flow_api.g_varchar2_table(30) := 'E5F4A37C4D2C12E0487202727D80385B02838615635D8B8F165B7B935C900A04839407028E96188A8B407F0F040302707789A60F050303792D9B02A602650E070307548983855B0D06AE68513AB3AF0CB3A38605B8B91F6DAB8B98A639B31FAE9D3E06B3';
wwv_flow_api.g_varchar2_table(31) := 'B50BDC63D180B30729B80223AEB025C400DC0AB8BA9EEDA61FC103F2F3A70AB3D980E624A5F479DAC6001BBE06F00E32B0A7CE5030650ACD348C48B1A2C58BF812000021F904090A0000002C00000000320032000003F208BADCFE30CA49ABBD38EBCDBB';
wwv_flow_api.g_varchar2_table(32) := 'FFA055846031929D79A295C9B86C6BAC001C4F85612CF62DE53B45CF27A4018BC406811014CE9049E772758C3A0ACB67AD696D18B234EB3037ED2A0807263767567CD187B4B6FD7AC709744835CF77C0E380715C567F81827D19060783376F1107037837';
wwv_flow_api.g_varchar2_table(33) := '3907029607110203611F5F95974C1105030231A0738A0F0403982C734290029C908C2C0595AC2361030351049A02419054A44406C09200B130ABAD37972BB135C59AB5213A0CD2CAAC00BC6DDA06C5E1A55DDA00D5DBC949E6ABE49A9C8DCEDD9BD3BD7C';
wwv_flow_api.g_varchar2_table(34) := '90ADE1F266A3F4E97CE192BDEB438C1C2237DC0E3A81A7B0A1C32809000021F904090A0000002C00000000320032000003EC08BADCFE30CA49ABBD38EBCDBBFF60288E641916A656AC69B6A2EDF5C611BCCCB463183680E7B71DEFC602320A4258D178DC';
wwv_flow_api.g_varchar2_table(35) := 'F580CB85900920109CC7270D69B562A95943D7007E20C9E574A3CBEE6A63ED365A7DB1E60A57C96090E21E0E02077A7C23627F81074383247F0757366211028422513E80026F007B31780281286F932D069F890A805A9C2506987307030796A325800436';
wwv_flow_api.g_varchar2_table(36) := 'B08205810CAB248AA8B1C10400BCB431B90A06030200CBCDBE29C90A9364B0C4C72604C2CADC9328D1AC820BDF3ECCD49439DBE3CBE3E12D05E7C168D931A5C4E830EFF037F2C5E94CDA2DD80785C1273A08135249000021F904090A0000002C00000000';
wwv_flow_api.g_varchar2_table(37) := '320032000003F608BADCFE30CA49ABBD38EBCDBBFF60288E64699E68AAAE6CBB14B02BC1851CD1B5FDE076DED0328330C6F0B160C22451A7282485CCDF321A3510ACD82BC1B8CA7AB7544CE1605039CB11C3406072120887036132188CACF0F895FB100C';
wwv_flow_api.g_varchar2_table(38) := 'F81C707B0C561204037321530005040207804D6B278D7A359100752606078F398E91070368219C8FA48E078C0F87AA227A0CA98C8F0E05932253B2008773B46F007E981EBA05026C6AAA7E00A28924BACBA3BB88C076C825CFD6D435CA996C249C0CC697';
wwv_flow_api.g_varchar2_table(39) := 'C60ADCC129BC0AD9DCCC28C50239A268DC6ADE9B02CDE2E5760A75C21E3E6CD9E346AD590A35CD342968D5C2489C2261224A3C91000021F904090A0000002C00000000320032000003FC08BADCFE30CA49ABBD38EBCDBBFF60288E64699E68AAAE6CEBBE';
wwv_flow_api.g_varchar2_table(40) := '702C03C5EC14786D2B79BFD33DDD0FF79B150CC86452C83A2A95CCA2E42088929C93C3E050C2190860036530B06E8EE0B0C1EC200C042135F34B110CC41F22A340381CD80B06645D067E6B34137604235F07043A7D80346492167C8E780004028B925A5C';
wwv_flow_api.g_varchar2_table(41) := '1F7D999A9C0A02A01064A3674C9B8BA4628E007454B36F24AE3CA7935C02705A8B8A22B90A54626E62BEB65C820371A50A06BB005435CA00B7D45B207C0CD5A67000D776350594B8D0D2AFD76EAF6EE12105D39A77E0D1D9D803AFDC0299DFE2F006DDDB';
wwv_flow_api.g_varchar2_table(42) := '7765DE356D992A7550B7C0CE82762DF4504385488AC58B1D12000021F904090A0000002C00000000320032000003F808BADCFE30CA49ABBD38EBCDBBFF60288E64699E68AAAE6CEBBE702CCF746DDFF858EC7C0FF7C042C520B4190682A28947112095A0';
wwv_flow_api.g_varchar2_table(43) := '9D613AAD38931F2995089D5CBB19EA8E513058BE1D7099400043D02103DB0C703FE0E9799170B03BF019056C6D0B7C047514668017730C860A0787110703428B156385910A0402669B559D0004480A97188F750707750287020200948A0392A715A9A37D';
wwv_flow_api.g_varchar2_table(44) := 'A39E00B00047AC47B1A64F1A069B0A06AE905807C4BFB203ACC5C418650CAB4502D4D194420503950BC91DCB74CB92CF9CB5ECD42105AB85BDBEC4E1EF4E745107FAEBCD0BD180B55BC20DA0B5592C0AD0AB576880BE177CC8E498487143020021F90409';
wwv_flow_api.g_varchar2_table(45) := '0A0000002C00000000320032000003FB08BADCFE30CA49ABBD38EBCDBBFF60288E64699E68AAAE6CEBBE702CCF746DDF78AE038450DC82C1E0802AFC2804E18030323A2D85835060E838AF1A4370E0D36019C68C41490419CE9BA4B0CA299C8F47A871DB';
wwv_flow_api.g_varchar2_table(46) := 'C5B8D10A0313CACD6F0F71127706717A5581103F41756A4B880E6F0C860A047B10523F52020C524B1388930006075595A2A58063658B929616A1514C05024C079B4955416C9A8FAF046C3C80A2A40007445A44057D0AAC59BF0BB194C2B6CC9BC59E0A9A';
wwv_flow_api.g_varchar2_table(47) := '5EC0C147C6D965B63FB375C5AE1BA36CB3BBD6497B496521D1D2DE65B3F1BA2205CFE00BD4D50BB4706B72C0D2374A0380F592472C9B355154649882B6A3A2C50A09000021F904090A0000002C00000000320032000003F608BADCFE30CA49ABBD38EBCD';
wwv_flow_api.g_varchar2_table(48) := 'BBFF60288E64699E68AAAE6CEBBE702CCF746DDF780E1444711F8381E060A01980C1A0805094F10449656F662040A387A9EC78551E7C18B066B8E02107844B61BD29481B058358B2666BEA48C1DC522F372B0502020A06575F7C760A713E7B0F3E408384';
wwv_flow_api.g_varchar2_table(49) := '4969137D7E4D4C125645900C488D957284539906450407000603A9009D7E19714D3C450544AEA99BAE034DAF6DA2A33E478FA981698191BBC961A6659900A80A07AD64D0680BBE6A730494D094D3D27A0A8262591F55B3B7B884024DABAD213CDDC3D2AD';
wwv_flow_api.g_varchar2_table(50) := 'C6D8BC223C62DCD8F007C90AFD2161AB1B3805BA56D0F2B740E0966E3A224AD490000021F904090A0000002C00000000320032000003DD08BADCFE30CA49ABBD38EBCDBBFF60288E64699E68AAAE6CEBBE702CCF746DDF780E1043EFFFC09FA0C40B1A81';
wwv_flow_api.g_varchar2_table(51) := '439DEB7030146C029FA049331CA252C2B375202C0A846B6FBB2A4405868621CD2AB80FBD03B9E3BE980F0A03D64BAF579E70780A04677C196E5B4E12848003820A7003737F7E058A6B007556007A82810C96877E9C696069045E8C00576C9F1C885F8A60';
wwv_flow_api.g_varchar2_table(52) := '4FA8995D99530BAEA26496897CB5AB82846CAB8E1B7398836CC1615B020264B71EBE0AA6837C7A6C7A8621CA9C5AD8D6D3ABD122D57986C1C20BDA2804C5EBCE6DE1E2795431EB4AFBFC17090021F904090A0000002C00000000320032000003E508BADC';
wwv_flow_api.g_varchar2_table(53) := 'FE30CA49ABBD38EBCDBBFF60288E64699E68AAAE6CEBBE702CC30671CC404108435FBC05C381D71B08082D21B12738187E2ADDB27720405586A9D10A3B309D0C439148BC9182D7B071CDE3997133DB130E581E0DB89AFD9856551741433E2D056D780C41';
wwv_flow_api.g_varchar2_table(54) := '8439434D7D2C050766905B8E283F436F595B2005950B363F3B6F003B029E169D0A73A935005948A44D88871DA9AEA14842A10750A223B668AE489078906FBE21B60687ADA4B03BB4C81EB6AECCCFBC8BA304B4B550C1C2AAD8AE476757DFCDC40B91A71A';
wwv_flow_api.g_varchar2_table(55) := '69CB0BCDCEF0602773AAB0AEE251F6F2E1EC28EFE8081C8822010021F904090A0000002C00000000320032000003ED08BADCFE30CA49ABBD38EBCDBBFF60288E64699E68AAAEAC68106D541CC350C40E510F30BE18BB836F5110D404B7E1EC6868BC58BA';
wwv_flow_api.g_varchar2_table(56) := '5A0F5020D06AC993C13810020C07EE715A2A1E9362C1A1895A0E046CC561DDE29287006B96B115F8FF7E5E2D7D807F827888796B7B78616F0204068C31558E8104932804642F7F9926336A710A05A3293755819FA7073DA190383704B00A607EA65A07B2';
wwv_flow_api.g_varchar2_table(57) := 'B40AB3482205A837064D333DB364A523C15F4D2FB2BABDBC65B5C59154AD0BC8A049C4BD6C6071DB24CCCDB5AE9B0CD7E4DD6C55DD746D59DE54EB8AAB1FE5E6BD53EFF23F719EB5D843AF1EBE7F89122A8C91000021F904090A0000002C000000003200';
wwv_flow_api.g_varchar2_table(58) := '32000003EB08BADCFE30CA49ABBD38EBCDBBFF60288E64C914E6261029260C426BBDB14CD1F60D33069B333845E13018A07E802080505C21933B80E135383CA1B102F57044E20A4D43C3206E290F3E408170A07649CA85A15D84A153710555B02A9BB451';
wwv_flow_api.g_varchar2_table(59) := '0D6C7E320681570E6F637C8C8D564F53026D937C8F88970E838A976D950484886B9D9E579F3C6C7C9B2943928A05A02D47A804AA366B3E6B92693F286C697392B0263D0A73BB73967F626B65C627B51E0528AF283D47CEB6D306D3A6C57732D2C5CDB472';
wwv_flow_api.g_varchar2_table(60) := 'DFAB47AF0B04C7D020E16ADB42DDBC5DF1C5E4F4727E6BED23EFF098D474A186E95FC08308AF24000021F904090A0000002C00000000320032000003F308BADCFE30CA49ABBD38EBCDBBFF506180203110A4370C63BA1DC3E16EC55A2C023A53C2890F82';
wwv_flow_api.g_varchar2_table(61) := 'DDC4B0FA0585925EAB7744424C4726C3D072026A839B54518065AD00986C0B2030AB48EC15A830F47C60404F77EBAE0EB738B1793D37A8482B68613A5706070289792E501006664C02078529588B0C30899397333D320F040483486671206E07A9AA8894';
wwv_flow_api.g_varchar2_table(62) := '7AABAFADA6B243A2B311A992A29CB6220488A9B5B3800B8FAAB305BE049C05BB5622A906CD71C1C8D0B66DC157C9A34222D86887B12ECC86798F68E44EE922E6D9A6E9C300E7C779ECC4EECE8BF1F2D2DD0BF6D7B8E8E3F66E11C06BE9023AE8A7B0A1C3';
wwv_flow_api.g_varchar2_table(63) := '87A612000021F904090A0000002C00000000320032000003FF08BADCFE30CA49ABBD386B5848D920440C446832C2602CDFB90DC332AE2E660CC202D3B575908ADFA187497D0AB016E0502272708A5413901A3A1FA3E12D171C58AF8EDF2A45AB822130C0';
wwv_flow_api.g_varchar2_table(64) := '882B6418785764EEF7692B0A078140E9CCDEA95E322902704E642C7A0A06835367690C473F02077C605B0E05559505852E3F8D323C9C04797B449903956EA47A93049D26373110A59306AA357658AF676E07B0BD200607C4C5C5A0C100C3C6C6C8C9CF16';
wwv_flow_api.g_varchar2_table(65) := '6FB8D00CA4C4AFD3D0A3C7BCD4CA7CDB5FD004D80D05D96706E4C0CF6F77EADDDE009C4A1DE4E83DE7EF70F0D4FAF3B720E1CB57CF9D3C16050782F9F74E611C700E1F1EE4103159C58918336ADCC891025A02003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 37775463515652819903 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'clock.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '47494638396120002000F50000FFFFFF000000AAAAAA8484846060604C4C4C3E3E3E4848485656567070708E8E8EA0A0A0666666343434323232383838424242747474A6A6A6AEAEAE6A6A6A303030B0B0B02A2A2A5C5C5C949494262626222222888888';
wwv_flow_api.g_varchar2_table(2) := '9898987E7E7E5252527A7A7A1E1E1E2020201C1C1C9C9C9C161616BABABA121212B4B4B4BEBEBECECECED2D2D2D8D8D8C8C8C8C4C4C4E2E2E2ECECECE6E6E6F0F0F0F6F6F6FCFCFCDCDCDC0404040000000A0A0A00000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(3) := '000000000021FF0B4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F90409070000002C00000000200020000006FF408070489C0C108E4BC9416C3A9F800522743A954A56A8962820';
wwv_flow_api.g_varchar2_table(4) := '6C46D7F009B2DD2E0CA1743A7C2D4333978D7A1D3EB89D0BC7462E5A3F08110A0A7745101A1B1A228A0619845014171A9287118E500B1517911A170396500C15999A959F4E020D150EAA1FA64F03AB0D0E0E8DAE4D04B30D0D76B64D050FC00F09BD4D06';
wwv_flow_api.g_varchar2_table(5) := 'C6060F1CC444C706101DCB43CD10B5D1071007D983D10008D9D91EDC0009DF0504E20A0705EA080BDC0205F10808C3DC1105F31804DBCB12F308FA08B8BB4363CB000CFA18304840C2CD8C825A2C3048B8108402145060C878584602818F092280F0A060';
wwv_flow_api.g_varchar2_table(6) := '8185142A56B060F122068C191C0140C44361A1C8011C32749060C1440B44152C35C2A441548B001021410C1890818449132E80B684F172861B0B196E0AEAB040008A143F59BA84E1082B4E0519163C8DAAF205D94F26042C70BA608209942CCA04010021';
wwv_flow_api.g_varchar2_table(7) := 'F90409070000002C00000000200020000006FF408070489C0C308F4AA9D4782040C4A894B8406842A1A5B674124DBF42014323128DB0A191D6A6004F1710CD6683C6AA9737893BDA7968E41B657677251B7B540F17177F7222060C110A0A110407874213';
wwv_flow_api.g_varchar2_table(8) := '0715158A8B07199760090E9BA41511A1600B0FA40D0E0D1CA960140DB5AE50B253020FBCBC08B95F1C06C3060F1DC0530CC406BFC852080710D2A8CE5107D7D76DD54405D807C7DB4305DD0705E0E10008DD0508DAE804051F080803E84211F2081809F6';
wwv_flow_api.g_varchar2_table(9) := '0019FA08081058604F803E0C023DF4038190008304E7B64910C8804282087AD07160F03002880119B759007131C280010A16A4F83283C6250111629E5490618105172A58BC88016346CB42501264A2ECB06082099C3A61C8F819CA0207940A881A45BAB3';
wwv_flow_api.g_varchar2_table(10) := '27D34B284848222A00458A162B6AF05CDAD26528130BB85A389A53ACD219CE4CA040C17645D23D41000021F90409070000002C00000000200020000006FF408070489C70308F4648F478200613A2743A5C602E1BD126341A95BEA7116241A50A28958B46';
wwv_flow_api.g_varchar2_table(11) := '93E586B8DFD2E94428131787B47A2D12BDDF7127372476421D061589177B1B6D255E5F360885000B060E150E988B1014200A0A11041791941305499A9A0719650A1A0394110F06064D0F2094BA0B10B5BE0ABABA09BEB5B9C185020710CA0675C7850A07';
wwv_flow_api.g_varchar2_table(12) := 'D2D21DCF8509D307CED66504050507051EDC7608DF0508ADE454081F08EF64EB53EF08181884F25218F51804EAF94318F423C00018C0212008106460EC20800C0B134410E010C0040A09247EAA084081C4081E0648A83841E380010A4C540C155241860E';
wwv_flow_api.g_varchar2_table(13) := '2A0F5A38C941418705124CA89089D2E6824409265CA8A81103C68C19346858B390210389051682AA60F102860CA4E44C2C781A552855AB58C9A5B020A1EBD4AA5795CA7361422A0BA24691AA95A7622ADCB473CB04010021F90409070000002C00000000';
wwv_flow_api.g_varchar2_table(14) := '200020000006FF408070489C280806C36693240C26C4A874B820342E588D66191A853488C5742A483C2A0E47762B0AB947A51241301E4A3E8D74BE72D16E446D6E71250F62631D070F060F0D796A7D4B6D5E8325220A53120749498C0E0709200A0A200C';
wwv_flow_api.g_varchar2_table(15) := '0D23707138370F52130806109B06081D630A06832704532007BEB1071E75430927370E9805BECB97C3431E08631107CABE03CED8000205DCDC14D9D8191FDC0861E0CE20E5E5DFE7C30C1818084EEDC304F6F6B5F463F70C0C12FAFBFA3148F00FA09404';
wwv_flow_api.g_varchar2_table(16) := '0813443064900808841140E46B3844814210039A5114B240A1878C26360AB1000223870C0C376618C04141061221455A68F972C1841622012C50D0618104470B265488344182844D14295AB088B1D1844FA02E54B0780143C60C1A34009A9800552A55AB';
wwv_flow_api.g_varchar2_table(17) := '590DBA306122EAD4AA5729AA7061F66BDA8D2C569C058B35678C183066E8AD8B2D080021F90409070000002C00000000200020000006FF408070489C281807C8E50231103813A2743A94300C0D47657BD1784517C4824A15440C86C7A391AD74BD1B9168';
wwv_flow_api.g_varchar2_table(18) := '431090AB98263ADD5E7E452121230F6364240807497B6B0E0D7E71802125251A195412888907064D05091E1919200C0F1A8181931A8543130407059A07181D64191022232393250F76430305B0C20377430922BB93045508081FCF0896C5BFBA93363612';
wwv_flow_api.g_varchar2_table(19) := '421E1818CD081CD3520925273706ACDCDC0411E1530E1A521904F3F3ABED42D952030C040C0CECF7A64560408141026901EF4448C03082BD845312448800024414886424821830E022C629153942F948850347050A7C9124D28183820C1DF2ADAC82B203';
wwv_flow_api.g_varchar2_table(20) := '09092E660E3101F3E60455133AAB905820008509154101985820C18209172A6A24453101450AA82C6204756114EA8A1A3160CCD0D9E2A90A162F60C8984183C64C152DCEA65DEB56278BBB6167B04D0AE0C5DCBD7CC3D2ADCB17805EC00183000021F904';
wwv_flow_api.g_varchar2_table(21) := '09070000002C00000000200020000006FF408070489C28128783A391642826C4A8742849400CD887A3C2BD5C2A98C5743A011592576CA3E17078359A0B4130A6120EE743DAF060BB2F701B220662630B0805894907597D6D6F1A2222211719531204081F';
wwv_flow_api.g_varchar2_table(22) := '8A4908110319191E09068082932317854313140818089A050C1D631907922121232506504303AFB1B11C7543111BBA212525047604D00418B5C6C01B23BBCC8503D1D00AD55109BCCC250800160914090C0C1EE05210E4CC122409F6F612EF5119E42727';
wwv_flow_api.g_varchar2_table(23) := '111C1244880062803E290F4AD8B86183C00010203C802071300A820D04F2018838A0239D8A753A0EE0A00005C83A2415843271728C02051D3A2C60D9524A4C120B24D0AC4984DE0256011676F214824202501329580C1DE24242D0142E542C1D62026954';
wwv_flow_api.g_varchar2_table(24) := '162FA6025061E26A8D1730B4AA50B1022B0C1833A6B250813506DA1934682C656156065CB9535FB89D0157AB90B37CF1FA0510783011C1869706010021F90409070000002C00000000200020000006FF408070480464128882C15028501493A2742A497C';
wwv_flow_api.g_varchar2_table(25) := '0E58C8D2F070381E84C5743A19249BD8C3B65B69572882F1504241203E85B47AF968782B17171062630B0C767678697C7D5E811A1A0E1953020C04041888080420031D190309078E901B1B178443162096979809A9451907171AA6A60651430A09099696';
wwv_flow_api.g_varchar2_table(26) := '0A724311B52221C7044313BDCCB0C2441C1B222223231A840A11DADA1DCF4511C621D508002820E71E20C1DE4507C7232523120B03F5F516ECB225C72525111D0A38285030295F9107FDFA150098A1611C834408242CD1A08345120B4C4024E261A20812';
wwv_flow_api.g_varchar2_table(27) := '18254870B17157C21325444EB060A14549210A4E965889C2440A152FA798B0E9C2C58A459C527ABA50A18205D0222A5A14655123C6D1212C8AD6781103C653A82C5EC0802163C6550031A8769D3183C6D7AD6469A8357B352DDBAF00D2C225A276AEDDBB';
wwv_flow_api.g_varchar2_table(28) := '78F3CA09020021F90409070000002C00000000200020000006FF4080704804744004CCE18041241493A2742A00353F85ECF260E83216D3A965906C220ADB03A46B683C1282F07002621092883C7AB9EE362A0E076061121109097677667B6C0F7F151506';
wwv_flow_api.g_varchar2_table(29) := '1D621186870C7609030A241D1C2005068E8F170F8343289F959620A7451D1F0EB217171A10514324031E03032011937242207FB51B1A0C43260A0ABDBD71C2430A15C6C7830BCCD912D145111A1AC71B1800291DE61D19AEDC42071B2221221B12280BF5';
wwv_flow_api.g_varchar2_table(30) := 'F529EB451922EF2321201604089820C0423E291042281481C0824313285C1C2CC240618811064C6874E142C544221E4A282CB12105C7162A587C945662C488122550AA58C1E2C54A210A60EA4CC9A2C68B4918370184D4298245CD1830600425A0B3C483';
wwv_flow_api.g_varchar2_table(31) := '172F92C29811F4038E1B364E7C403A75C60C1A41014C60A0210180AE34D2862DE255ED5AB65FDF4E892B570AD8BA78F3EADDCBB7EFDB200021F90409070000002C00000000200020000006FF4080704804743C0C02A24020443293A2742A185008188476';
wwv_flow_api.g_varchar2_table(32) := '5938782992E9D4A24850AE4DEDA7EB851820118178681924EE89A412B1F61EDC060F050B731303202011771449591F1F7E069281061D53280A0387898A110A19241D0A200807930F0D0E068445A299031E200361531D08810F0E15150751431319190AC3';
wwv_flow_api.g_varchar2_table(33) := '1CAC73001E060D15BA1514432E0B24A1A216C7440A0FBB171715AC2612E10B0BD6D7441115DCDC04002A2816F002E5E6441F171AF81A122D26FDFD2DF48A64C8B7618307152D5C287411508A010D220A22504191E28A8645186C0811D1008B8F1F6B6024';
wwv_flow_api.g_varchar2_table(34) := '3220448811212EBC5819E3458C9143149C1C3142048C9B38610A9149B3A68C54193364C880A11359099A2534005D3AA3288112504B3CA041956A539D0EA296284063088DAB23159C807AE204082254756A2831762CADA24340E0B8511601DC29096EE030';
wwv_flow_api.g_varchar2_table(35) := '76B74882BE80030B1E4CB8B0E18041000021F90409070000002C00000000200020000006FF40807048042C3891040143617832C5A814605124134D0201C12D7C129269D4441A80225786968B281C0A0590402C34653803332881D562101F1F6F07100861';
wwv_flow_api.g_varchar2_table(36) := '53261D0A8B031E677C6A7F8107941010071D52290B2419190A781E03191D0B0B190318829506060787441612129C9F191353240496ADAD05B8432916160202A6C0740307BD0F0D09432A29262628B22674440A060FCD0E0F0B422A2D2E2ED32ED8451EDC';
wwv_flow_api.g_varchar2_table(37) := '0E150E0C00352B2AF3E4E85108ECEC0D022F352CFF2A58D82B92815D850A1706C458D84FE0C02207105EB8400086C585311E1661504183C7033366C8B008432391011A36A4AC10B2A50C9343146C10B1A1268D9B3442C214A24084CF5D9A4372CED80960';
wwv_flow_api.g_varchar2_table(38) := '4088A3222E10A1411400831023468430D0B4C883A35111548D59026A54105B853C2811B58408584D139C28C1F684D6AD204AAC655B02DC560237E69E201056C880BC272ECCE90B00EF884C84FD2A48CCB8B1639841000021F90409070000002C00000000';
wwv_flow_api.g_varchar2_table(39) := '200020000006FF40807048044C3A034F2201020D3AC5A814605A6414830128B26410BE20C934EAB22C3A574E12D4FD621008CF642C6CA104920529ADE57A096F1F050462532A26261616027A691E6C095E700805050824522C2D2E2E888B0B0B12121302';
wwv_flow_api.g_varchar2_table(40) := '7B0980700705071F85442B2AB12E29882E530B09081F07BC071873432F2CC3B02D2A74421C95BD06114330312FD2C32CC84319BC1006DB0B4230DFDF3131D6440307DBDB144232333332DFE44504E80F0602EDF8EDF1441DDB0F0F0E06CCA04190E0BE22';
wwv_flow_api.g_varchar2_table(41) := '1F003AA840C0A0101A07892468E0A0E2018811A50CA8B8F041C629192A54B840F2A31405242F68B86032CA00951A343868598441CC0D1A0CD024626083CF550D08760AC920A2E806111E840238104244D30DAE5A260841956AD09D0346380D314243379A';
wwv_flow_api.g_varchar2_table(42) := '094A9418C17504019A0234885D5BA281809D1770B00D0145A88D1362352850BAD446DBAF7C376078CB5748D4C26382000021F90409070000002C00000000200020000006FF408070480498241D0567C0542C8AD028A0755C74320AC5C013497807022994';
wwv_flow_api.g_varchar2_table(43) := '4545592456ECB69BA010188389585853B55C26333AB90475190404081412622F2C2B2A2A782602122459037E09808208044F5030312F35888B26A1A1284803948108A908854530AE9C2C8A2A521220A8081F05047243333332329B2F2F73420A18A90505';
wwv_flow_api.g_varchar2_table(44) := '0720BDBEBEC130C5431DB807CB05AC34DB34CFD3440ACB07E309423443DDDF450CE30710106144DBEA441DE310060603F4C508F9F90CF8CD89F0CFC0078162383C30F060214229191A3E70D0E061940C0D1A38A850D16291010E425678E0B1480291150E';
wwv_flow_api.g_varchar2_table(45) := '942472E0C2850A1708AC14924183860B37F7CD3CA06183CD540BAC4A461021A2A706992B076C202AC267268F094484602A02A94505064A84D8BAF5413C84081C9418CB758406121E0F9C185B62C4D80B194A32B0C176EC83A71E6DAC5D8BE16B49BD213E';
wwv_flow_api.g_varchar2_table(46) := 'E05D99C1835F2841000021F90409070000002C00000000200020000006FF4080704804B44C13C922C3EC488AD028E0B572B94C166546C11978400A81341AABAD54579460D15128BC91444261190F61B1176BD5BA66495B0320710914116252333332787A';
wwv_flow_api.g_varchar2_table(47) := '68585A6F8372140C0C0B5234348B782C2A2A7D7E0B0A93090C04A84F519B338D2F520203A6A804081413999C764219A7B5080803B932BB43241818C0C0AA459BC5440AC01F1F0511CFCF09D305DB88D76324D40705070ADEBB0407E90709E67620E91010';
wwv_flow_api.g_varchar2_table(48) := '08ED630AF01007F4521D06FDFDFA5132F8FB07B0088707030B1649F0A0E1830F0A891468E0A0228188BC1C54D0E84018C6021A2B5468D0AD60840B284532C038E082060D2931294CB0A1E6CB0B14140A141122844D4303259FB94940A042899E3D6B5620';
wwv_flow_api.g_varchar2_table(49) := '41EF4189A747438C18E1F342067D254E40953A35840199F42068855A62C4060241CD9D58CB360402B0000D9CB850E1C3005C6382000021F90409070000002C00000000200020000006FF4080704804BC582A570A65114C2CC5A85408831D57499345B2C8';
wwv_flow_api.g_varchar2_table(50) := '2816D069744686C58ED96D57C11974C262006D3E9359592B9709355974D8032003137143346531352B2D2926027E0A031E201111128572875589487A127F92200909110298873353261DA1A31411705273980B94A30C040398BB0BB704BF97BB851D14BF';
wwv_flow_api.g_varchar2_table(51) := '04081EC29820BF080818A6CA620B1818CE080AD27114D71F11DA62031F1F050504E0530AE407051FE8521D0507EC07EF511DF3F9F6450AF9F3FB44221880301001C021080C283440E120800E0F161AE0E010C1838811A3ED03E1A06383060D017268D0B1';
wwv_flow_api.g_varchar2_table(52) := '8283070B0046A870A1824B0709F66538A0A166CB0A10341642402082024D0511183C10B1A1A6860B17502A7B50A269D310214488D05054C3830CD26E381D01B5EB86A210522A5B60636B881168896A60A07397061C279C3E1DA10181586D123EB82C71A2';
wwv_flow_api.g_varchar2_table(53) := 'C2030483E204010021F90409070000002C00000000200020000006FF4080704804D0663358ACC652B55CC5A8B47854BE9A2E93C5929A7A8755D855959D481612D3574AABC6C6654927D341AD896DA4B2B672A550130B1D0A840277434832564D7F67190A';
wwv_flow_api.g_varchar2_table(54) := '1C030313875F2E020B8F92110316955F1690032011090A9F5F13A3A4090986A8530BAC09141CB05E1CAD140C0C94B7511209BC040419BF5211C4C420C7510ACA1814CD451D08D60804D34424D7D6DA43D508051F1FDF420A1F050507E5E62007EB07D9E6';
wwv_flow_api.g_varchar2_table(55) := '0407F60709E61D1007FC07A7DF3018300081DFAB6920062ACCA74D8181070A0D2CD016E18145880F22AC11700160940C071C5470E0A0C1830307A7D8C071A20101530A223030A0E1C285912325AE5170A284CF431223468418BA4143CD0A480D74B873E3';
wwv_flow_api.g_varchar2_table(56) := '8453A0418586285AF3E681896B3A387D0A55A8880D456F3248F965C187125C834EFD7A01035654AA10940C31C22282495F82000021F90409070000002C00000000200020000006FF4080704824D2663318EC552B3A9F4FDA51F962A9AED0ACF3285B5A5D';
wwv_flow_api.g_varchar2_table(57) := 'A6944BAB9526635515D8324991A3C7736DA54A99268B05EAFD9C75635F2628020B1D1D267C5A2C6B12850A197B89592E841D190A0324925A2624979803139B59160A1C031E200AA3591DA820110916AC4F1603B009149AB44E1C11B1091CBC4E1909B909';
wwv_flow_api.g_varchar2_table(58) := '20C34524090CCE0CCA440B0C04D504D1430BD618D7D8001D0818E1DDD80308E708D0DE0C1F1FE711DE2405F3F3ABD8040705F90502E507FFFFE03DB99548010408000B487802E24489046F3C1898781042326236709428F12003940E051E4CA4F8A15F91';
wwv_flow_api.g_varchar2_table(59) := '08366C6C5C698081AA0C20121C70D0E081C88907163C91B06165894F10404508D5A0E142850A0D688A3CD021CB82060E4B8C18113404D1A2472BD02CA0538B000C2BA78ED820620351A3471F2430F966C1870D21A86E987BF6C203025D374D306733C406';
wwv_flow_api.g_varchar2_table(60) := '91043888CA12040021F90409070000002C00000000200020000006FF408070482C0E69B49971C96422673058AC495D3EA5AF5A750B784263B5956AC57526A1B0174BE572B5CACC994C5A5BBB4C28179C99B6A75016137B4D2C6D2616120B82834B2A7813';
wwv_flow_api.g_varchar2_table(61) := '891D268C4B2E02910A0B944B020B1D0AA0289B452619A0030312A3451D1CA8030AAB440B031E202003B24312B711BEBA4212BE09C4C00012C4C9C6240914CE09C60A0C04D411C609D4D41E46168C0B08181804181945170F8C0908EBEB024315372725D0';
wwv_flow_api.g_varchar2_table(62) := '70031F08F708DB422127F2F2B9B8643850A060010CAA84602821AF448911F4A80C384091E0817D42265C683822C40803E596744000A122450C8B867408E13084CB101B0C50009121038804071E183060B2802655230A44381CD151C4060D1A2E3858FA40';
wwv_flow_api.g_varchar2_table(63) := 'E74E08100A9068B2E041C78E308F26ADC074E74E04099B0820202284D10D472F54E05AA141530309DC71F9A60126D20B6AB93A30C0202C9C090330ECC45B928182944B82000021F90409070000002C00000000200020000006FF408070482C1A8FC86492';
wwv_flow_api.g_varchar2_table(64) := 'A66C366933A7B40895C1A6521A14168B6197DA9935567B7D8FE1190CF662B1CE4835BBB652A9E0C7394BE54ADDF1456D7C2E262680467C292616132E87442B8A160212868F438B020B1D129798129B1D1D9E4226241D190A19A40026A90A1C1CAC28B003';
wwv_flow_api.g_varchar2_table(65) := 'B6AC12B61EBB431E07118024201E2011B61A2736250D800311CF090A11272725D60A701209DBDB2412D6E00670200C0C14140916001FD5E0095F0A04F2F203420BE021231BF5521D18F3F23A0921602D84C10DC09A7040C010010604FC840870506284C1';
wwv_flow_api.g_varchar2_table(66) := '10220EAC3AD2814181020D1130985084C4851116436CD070E140020F193238FB70A0E681021F1010105824C3054F8C2236ACBCE0C04183070F0C18B0F9112489240B0C045DC9B2E851A50620D42C7060671301043488BD70A18251A458B7822029650186';
wwv_flow_api.g_varchar2_table(67) := '0A642BC87590542984043CB14CE040A066D19B1414B04512040021F90409070000002C00000000200020000006FF408070482C1A8FC8A472C96C3A9FD0288D368B32A7552B724A9DC1B447AC17160317676818ECC5361365EA578DC57213637296AAB5B2';
wwv_flow_api.g_varchar2_table(68) := '0B632C2B7B2E2D7E42832E262986002A892628288C2A90160212060F0F0606662E0297120B252727252519602E0BAC1D1D22A7A7116028AE19B70EB1250460120ABF0A1905A6A70F60191C03031C1D11A62121A85613CA1ECA0B12232523232110561C20';
wwv_flow_api.g_varchar2_table(69) := 'E2E2160008DCDD22B34F1D0911EF090A420B1BDCD01B1C4E0B141409FE091386108076EFC23A250A082864E04FDE10010F3648DCA0E1C2810E48482440804121010611CA11217141A2868A0E1C148830C0D500100410C8E4B850C2910C0E4E5EB850C141';
wwv_flow_api.g_varchar2_table(70) := '03484D9C0E082DF0E1C34C020B922C80B0B342CF9F9C0C081D6A1401059B4A043070EAD4C1264E10861628806040C0260B083C48F9D540D8A109B04299A0804181039CC826C8701649100021F90409070000002C00000000200020000006FF408070482C';
wwv_flow_api.g_varchar2_table(71) := '1A8FC8A472C96C3A9FD0A8744A55D2AACB2BF648A3CDB6C36B77F60503BADE190C00320CB0E4990C462F9C6CA7CB7B3A87C5622F0E25832504547E802C2C2284257B5231358A2B2A8D250A5435942A2A2E8423251C542C2D2EA6268C23212520542A2929';
wwv_flow_api.g_varchar2_table(72) := '26B20F25AA210C542E162816BD0821B6065413120212121620C02122221952260BD2242428121B22CC1B075224191D19DF2600081B1AE71A1150120AEDED0B420B1A1BE61A15A24D121E03FC1C0A284318CC3B57C141AB251D2280F0C0D0030922020C68';
wwv_flow_api.g_varchar2_table(73) := 'B870C181C50F1D904800912041848F1106002442A2C1850A151A3478F0000188011D3A281840810001060C3A7A147024C3034D940E561A187AE04001044811D82440C1A384240B0E3848F9602884A2469362580A82A71201091E08357015EB510418940E';
wwv_flow_api.g_varchar2_table(74) := 'B0E0640183A106CC1628F0016D5729131424A85B5469840C139404010021F90409070000002C00000000200020000006FF408070482C1A8FC8A472C96C3A9FD0A8744A8552AAC9450907C21A11A793ED34F00A25A55369FD310340EA7549E1A5D10AF252';
wwv_flow_api.g_varchar2_table(75) := '836A07D8670F25232325045433763433331A252121251E878B8B3222838F745332309D9D2198229A523031A62F2F1AA0222292533135A82C2C061B22211B0C542C2BBDBD081BC11A10542A2DC72D2A1EC21A1719522A262E29D42A121AD81A1505522616';
wwv_flow_api.g_varchar2_table(76) := '2628E12A000417CD150E5D4F260B1202131326420B1517E80E0FA34B1619240BFF125C0CA150A14283060F0CB852224181820C193A74984044C00107E8121A40D00189000E1E060C70A8A0833C220B0C384068A0E5010C23FF6550002241041021077050';
wwv_flow_api.g_varchar2_table(77) := '80E2480750031A0D403870A00002041808106090C0E64D100328225950402351A246912A65DA34C2000B4B04247089B5C007AD4A9B265000B6898404570B98459A9440020E02A44CC89040A951060C4074688B24080021F90409070000002C0000000020';
wwv_flow_api.g_varchar2_table(78) := '0020000006FF408070482C1A8FC8A472C96C3A9F4C8506DA5C6C70536A72E228956C59AD91E0F5DE36E2E2A2EC1D29D244446934F226E043C9A6140A952078432021237D256F810008847D06894206222122220C8F001A1B9422038F341BA0A019703434';
wwv_flow_api.g_varchar2_table(79) := '00A51A99A9885A3333A5343315A91A171E69AEB93310B51A15146930C2C30417C60E07692F313130CC031715150E0E1D5A2F2C2C2F2F352F020DD20E0D085A2A2A2BD9DA000C0ED30F06B74F2D2E2E2DE62B420B0F0EEF0610AC4B5C58306122450A17F8';
wwv_flow_api.g_varchar2_table(80) := '8424E867C0C0814E4B50489060C1020A142E880828D00FC28103044820B1402203890513055868A1E640438F1F3F30189061C102121D060CE0A0204387589312321AE9E012E6810F08301020C0204104103A79663069228904041F0B684590942985084F';
wwv_flow_api.g_varchar2_table(81) := '3DEC54D0A1AA120120B46EEDCA34815B10501798652221C107A45C9736751B2183052D13328060C0000101A71C16FC4D12040021F90409070000002C00000000200020000006FF408070482C1A8F48E222C9640A30B8A6B4B8789C4EA5E934B3C19E7013';
wwv_flow_api.g_varchar2_table(82) := '2D73B12999CD51F171F2308FCE06F591F00E85CC09B9913C1AD943037A4618217E85798244121B222122220789451E221A8F22199244081B9D1A719A43061A9E0CA1430E1AAA1781A70017B0171599AEB2150E150AAE000FB70E0EADA70715C40D887A34';
wwv_flow_api.g_varchar2_table(83) := '443404BF0D0F1F8934D200D2030E0D06D91D7A33DDD2343302060FD906187A3030DDDD4214E4D907C1533131E9E932420BD91007FDB4522C58D47841AFDE900806FAF52BA0AB898A162A5608AC118388800F0A0F14409060C91117264CB870A122228B3D';
wwv_flow_api.g_varchar2_table(84) := '05346A44808140820C24044C902061C1020116428E5471D20889570F050A7C40808000030A09407818A020438705122CA03091424512090436B22460344104100398C2843AC18455261340102DDA35E9D2A64E17A070A14502080C2D1924D80B56AC8414';
wwv_flow_api.g_varchar2_table(85) := '7A2C7418F0756FD80E024C3009020021F90409070000002C00000000200020000006FF408070489C0C3CC4A472995C7C4AA71B73CA14104AD85389CA1D2E1ED8B08DD0A5662ED851F87428331797D128140A37106EE5C4109AF74B0619794B0C22222187';
wwv_flow_api.g_varchar2_table(86) := '2209834B0B1A1B86221B038C4B048F1B9011954A12171A8F1A6D9C49039FA01A82A4441817AE1710AB490715150E0E8BB2430FB6B794BA420DB60D0DAAC00D0E0D0F0F0AC04206CBD0BFC00506D6069BCE0CD70678CE0306101007071DCE02E3E4070C95';
wwv_flow_api.g_varchar2_table(87) := '344B09EA0505CD793334EE49120507F21F08E66564CCB0E7EEDE1010FC0A204040801E9518300412C42764028102FE1812002181090B163520C2183843C982850B0930A09080C30201264CA47091A2850A162F448E5C42820006550C2A194400E1814386';
wwv_flow_api.g_varchar2_table(88) := '0E122CA0706113644E18530450004A802588010314745890D4840B15374372B1304065820443B31E7D89C2AB8B1535DC08187036C155A31D482C98B07445250B0B140CE09075AB05135C8200003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 37775465811123821995 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'big-snake.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '4749463839611F001F00F50000FFFFFF000000E8E8E8D2D2D2BCBCBCAEAEAEA2A2A2DCDCDCB8B8B89A9A9AE4E4E4D8D8D8AAAAAAA0A0A0B0B0B0CCCCCCF6F6F6A8A8A8D4D4D4E6E6E6363636262626505050C4C4C4707070929292565656FAFAFA686868';
wwv_flow_api.g_varchar2_table(2) := '464646C6C6C6F8F8F848484832323200000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(3) := '000000000021FF0B4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904090A0000002C000000001F001F000006FF40807048140C0805038062C1241EC4A874784024AE574065BBE5';
wwv_flow_api.g_varchar2_table(4) := '383E53A982802D6BB95C8C273C5C30CA66341AC460031AF0B89C1B0A2F1A007958677B15770B510A6F0981580E0F0A10000217191A688D0C0A446483091112611B061D8665045479009B766B790742566511137643131170089379A1B643127946700EBF';
wwv_flow_api.g_varchar2_table(5) := '510E70477050C6430F704870ACCDAB70497092D40010704ADACD06D8DFDC650605D2DF0AD69D58CCD4CFA703C4DFC8650302BDD4C1700200B258B48CE1D225E480AA696136BD1AC28ED1275F5324E46A7405D5104559CA3C8AB44DC1837A1913688AF287';
wwv_flow_api.g_varchar2_table(6) := 'A22A41591A209A8207A5493880D8B8718992C14A366304BDAC88D04E150F382F11C0FA660489127304EED909020021F904090A0000002C000000001F001F000006FF40807048140C080503C050200C04C4A874784024AE5700F68A384CA70AC216AB1D27';
wwv_flow_api.g_varchar2_table(7) := '088AEF70C13067DD09C6420D68C0136577E3BBD8DFF36600210C510A6D785B0E0F0A1000100A0F0E5B001515201E4462640911126A1211789595181F420781697469A3A30E42565B111374431E1DAD151C0002669EB54306B9150F0363AFC0431B1AB967';
wwv_flow_api.g_varchar2_table(8) := '630FC94419B9180563AAD10017B91606638DD9BCB914E1D9DE5BE0D910634CD7E50A634DCFE50F634EC7E5925B4FBED9126650626199956C42A82D084EA5AA95C68C17219ADE74FA140A10012286DE6051C4C811247D1A196013D207D01893931ACC9962';
wwv_flow_api.g_varchar2_table(9) := '070E4A2C7BD4B07109470EC38893DCA08956E5E4980C2EE5781D49B2A4C9133A41000021F904090A0000002C000000001F001F000006FF40807048140C080503C050200C04C4A874784024AE5700F68A384CA70AC216AB1D27088AEF70C13067DD09C642';
wwv_flow_api.g_varchar2_table(10) := '0D68C0136577E3BBD8DFF3667573440A6D785B0E0F0A1000100A0F0E5B650C694362640911126A12118758045481956A69665E00565B11137443139E5B080002669BAE43126646630EB851915B47630FBF440F634863A4C60A6349638CC64210634AD3D3';
wwv_flow_api.g_varchar2_table(11) := '06D1D8B415DEDE1405CBDC17DFDE169758C5D819E6151803BDD81B1AEE09B563B7BF06EE15C5AA5858FDF2D0C11D07210746B94AD3CF979074873471F204C01C860F430ABDC1926851A347C1B27803E1214A1F4063504A0AC1E08B1D382AB1EC51C30626';
wwv_flow_api.g_varchar2_table(12) := '1C390B21623283C658950E9463BA70A37524C992264FE804010021F904090A0000002C000000001F001F000006FF40807048140C080503C050200C04C4A874784024AE5700F68A384CA70AC216AB1D27088AEF70C13067DD09C6420D68C0136577E3BBD8';
wwv_flow_api.g_varchar2_table(13) := 'DFF3667573440A6D785B0E0F0A1000100A0F0E5B650C694362640911126A12118758045481956A69665E00565B11137443139E5B080002669BAE43126646630EB851915B47630FBF440F634863A4C60A6349638CC64210634AD3D306D1D88DD605CBDCCE';
wwv_flow_api.g_varchar2_table(14) := '5B4DC4DCC85B4EBDDCC1584FB6D3BA6350AA58ACBFB063B30007A3AE1E80575001B8F446D3970D063A5400146A48A13758122DA2752183860A18175EA114A50F404919436214F4C50E1C00224386A0C3E6644A8C2018B80AE306654A0CFF7E5519633323';
wwv_flow_api.g_varchar2_table(15) := '070F071FB81941A28482050C098AA909020021F904090A0000002C000000001F001F000006FF40807048140C080503C050200C04C4A874784024AE5700F68A384CA70AC216AB1D27088AEF70C13067DD09C6420D68C0136577E3BBD8DFF3667573440A6D';
wwv_flow_api.g_varchar2_table(16) := '785B0E0F0A1000100A0F0E5B650C694362640911126A12118758045481956A69665E00565B11137443139E5B080002669BAE43126646630EB851915B47630FBF440F634863A4C60A6349638CC64210634AD3D306D1D88DD605CBDCCE5B4DC4DCC85B4EBD';
wwv_flow_api.g_varchar2_table(17) := 'DCC1584FB6D3BA6350AA58ACBFB063B30007811EAEA6635001B894A54207031BBE74FA7425D49042052B48D490E102144790245DA114A50F00892043021A23E84B889028476ED9A38601089420556E1CA4C60306981564A2F9F5C101870F94F9044E4386';
wwv_flow_api.g_varchar2_table(18) := 'C10285254D9ED009020021F904090A0000002C000000001F001F000006FF40807048140C080503C050200C04C4A874784024AE5700F68A384CA70AC216AB1D27088AEF70C13067DD09C6420D68C0136577E3BBD8DFF3667573440A6D785B0E0F0A100010';
wwv_flow_api.g_varchar2_table(19) := '0A0F0E5B650C694362640911126A12118758045481956A69665E00565B11137443139E5B080002669BAE43126646630EB851915B47630FBF440F634863A4C60A6349638CC64210634AD3D31415DBDB50D8D55B0616DCDB17D800CE5B0518E41519E7C85B';
wwv_flow_api.g_varchar2_table(20) := '62ED1A1BD8C158030FED15D7BFBA63A07068D7C1C32F5863660170C00F9D2B5363507D60C74D8B264E9E00851AE201C436408916357A84EF13A5280C42001AB35252834152ECC06989658F1A3633E1C8797889A51B1134C6AAF894850A9B11244A9838F1';
wwv_flow_api.g_varchar2_table(21) := 'F625080021F904090A0000002C000000001F001F000006FF40807048140C080503C050200C04C4A874784024AE5700F68A384CA70AC216AB1D27088AEF70C13067DD09C6420D68C0136577E3CB08E5CD7F637573441E2015157F0E0F0A1000100A0F0E5B';
wwv_flow_api.g_varchar2_table(22) := '650C69421F1888885A11126A1211785B04430E9B9B00976A69665E001CA8151D1E744313A25B08000FB2154AB64312660209B21A1BC144935B039AA819CA440F630416B217D2430A630514B250DA8F63C0E2CA06638EE210E40563ABD2DC5B4D630FE6D4';
wwv_flow_api.g_varchar2_table(23) := 'A403630EE6CC584F663E491B36068A952D112628C3356617800380E0810994E01500316412780225EA4FA96D6D466159D4E851247F222D4559B0E70E45320D0849B103E7E5953D6AD8D48423C7561813372FD148AB22A8A1456D46902861E224DC972000';
wwv_flow_api.g_varchar2_table(24) := '21F904090A0000002C000000001F001F000006FF408070487C2430160AC050200C04C4A854F871702A582C20C1E5220ED3A907932D6FBB5D82223C6480CA66349AB1600342F0B8BCDB082FFA7959677B09000D75440A0C5C00651A191750100A0F0E6867';
wwv_flow_api.g_varchar2_table(25) := '0C6B430497151D061B61121185680443077B001E76006B7B600008721113AD4213A4680800027B12B743127B0203720EC1449668039C680FC94346A605729AD10A7205067210D142107206DFD1DC68DEDFE1684CD6E4D9684D72D0DFD369C668C8DFCB5D';
wwv_flow_api.g_varchar2_table(26) := '4FBFD1C372A0CC42532B582E39BC00A492E3AAD52B39B10038639420023051A4062538354411C52E0E1E28F036A9D2252E99A2FCD1C89010A343611AB82CE5B20F9B058B08B1EC42C7E1C415937BD4243B30B00BCB2FE47A35DBB6A4C9133B4100003B00';
wwv_flow_api.g_varchar2_table(27) := '0000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 37775471338284824687 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'squares-circle.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '4749463839617E001600F40000FFFFFF0000003636363232327070706C6C6C5656564242423E3E3E3030302E2E2E4040404848484A4A4A4C4C4C4E4E4E5252525454544444443434343838383A3A3A3C3C3C5C5C5C000000000000000000000000000000';
wwv_flow_api.g_varchar2_table(2) := '00000000000000000021FF0B4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904090A0000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7C';
wwv_flow_api.g_varchar2_table(3) := 'EFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258552C18F0865CA295C8EF0D7A62629A68F9257E7B7D7F8483818588872482808C898F8B1393030A6C02440A700C0D0E9E0E5A9FA2A009285AA6A527';
wwv_flow_api.g_varchar2_table(4) := 'A7AAA926ABAEAD25AFB2B124B302931396076D710E0FC00F0303C1C5C20314C9CAC9C3CBCBCDCECCC8D114D0D1D6CED8CFD3D7DCD9DE2293BB55099CBF0F10E993E9ECEC9315F0F1F0EFF2F1F4F515F7F5FAF2FCF613F8E6010CE84F60BC64E1D6F0C264';
wwv_flow_api.g_varchar2_table(5) := '450EB076EBDAB99B60A1A2C58A932E5ECCA81123C58E16387614A991E4C68F2351FF96445901A10085E43AA163174144849B386F8A00696127489F1D816A147A91A845A31591F614C053684B113019269049B3A6809C39956A65FA936B50AF43C116157B';
wwv_flow_api.g_varchar2_table(6) := '946C52B34B2F3E7D7989C8D45F556D62D589766BD3BA78EFEAEDBAB7E25A98030A20783B339DD5B974FB86553C967159C76715FF153C40AAC3C210224ACCACF2244F9316417BFCDC3974E9D120458764E932AA5B730FD54DD82C3B60BE81F80ADEB6ADBB';
wwv_flow_api.g_varchar2_table(7) := '37EE7DBFFB05FF779042C2B60734C10E36CC18736FDBA85583AE4C5B75EAD2A45BCF4E6DFBF465E17421576EEE53A8519E6E8D500FB5D67AF7ED51C967351F562071E3DFC49953070FFF45233462882301425220800921888B36810912D8E0800152328E';
wwv_flow_api.g_varchar2_table(8) := '54699C61E1851866A8211A592007C487208628E2883A2C64C01428A6A8E28A2C3E01C38B30C628E38C3084000021F904090A0000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C9';
wwv_flow_api.g_varchar2_table(9) := '6C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1442B69D8EF12FA1DAF9D98E6097E25808224847F7D88818A857289838F027013030A6C02440A93255A0E9E9F9E9DA09F5A28A527A726A99C09A6ADA8AFAAB1AC837096';
wwv_flow_api.g_varchar2_table(10) := '076D710214BC1403030FC1C2C1BFC3C3BFBDC9BE03CABDC8CDCBD0D1D0CFCDD5CAD7C9D722B697448BBB1415E37010E6E7E6E5E8E770E3EEEEEDEFF013F2F3F5E4F4F7F1F5FBF2FDEFFB78715B830B931511BC2A5858A86E1D8486EBE02C9C385122C58A';
wwv_flow_api.g_varchar2_table(11) := '132E62D4C83023478B1A415E1449116405810208FF5679258EA288083063C27C2933A6088E166E72D4A991E7459F2E05E0043A91E8429F2745A834C852615101356D428D1AC1684EA13BB1F6D4FA936BD0A15E9F82A59834A5B783BB9C1E9D1A9566DBB0';
wwv_flow_api.g_varchar2_table(12) := '6BC76695BB956E57BB65550E2880A06950AA55D9D6B44A18EE55BB5FE72AAE3B312FDF014C11B6ECE830DD84CA0F3D86D43C927349CF1B3F82EE889364680B2729283D0B2E213ECC10D1FDB3A72F1F3FDBFE7003D44DFBF6BD0A01554B5A9A49973660C6';
wwv_flow_api.g_varchar2_table(13) := '88214F9ECD19336ACFAD45C736FDB8B4E6BCB04F43D9AD60715D23448D72207ED42A12E7C3CF42BF5EBDABF7B0E0CBE9DEE60D784075F634C89320FF1EFE8D0C048E21913832A081010E77A03580091E02C9809354C25A1A675468E18518668846166701';
wwv_flow_api.g_varchar2_table(14) := 'E1E187208628A20E051930C58928A6A8E28A4FC0E0E28B30C628230C21000021F904090A0000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CB';
wwv_flow_api.g_varchar2_table(15) := 'ED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD1392867E2FD1E6F77A7D0975257784248676748A838C87728B8591027013030A6C02440A95255A285A0EA2A3A2A1A4A39F27A926AB9E09A0AFAAB1ACB3AE857098076D710214BE140303BFC3C0';
wwv_flow_api.g_varchar2_table(16) := '030FC7C8C7C1C9C9C1C4BFCECFC5D2D3D2D1CFD7C4D9C3D922B899448DBD1415E570E5E8E87010ECEDECEBEEEDE7E9EA13F4F5F7E6F6F9F3F7FDF4FFD2F5F3E56D8D2E4D5644F8AA60A1219C861021C28B076162BC8711254EC8A891A3C38D1E31721499';
wwv_flow_api.g_varchar2_table(17) := '916444911508FF0A30582516B988223C5A1011A1A6CD9A346FDA8CE99127479F1981C21420532844A30D81A614C112A14B864789F614A07327D5AA1190CE94FA936B50AF438B828D2A36E2D295E012F6829A746C5BAC59AF56D54AD7EDD6B253F176354B';
wwv_flow_api.g_varchar2_table(18) := '81299B0105103C0D3B156ECEB976EBEAFDBA98F05E886713041EE054E1CB8F322DBAD32C0FE448CF25419F14DD312469CCA621AB6C1A8ED0427DF92A707E378122EDD801F1F1DBE78F3740DF0281EB4ED99712EB039C5C431366CD183365CE9F6F5B4E6D';
wwv_flow_api.g_varchar2_table(19) := 'BA2FEBD5B031D75E7D7BF16F07377522D18A7C8253A8CEA377507E447BA6B5CCC39A2F8BBE1CF06DDEF0322E0E911F4081FC07A0208F14D41F24071A5820377F0B262249820CDE67492E2DA571C6851866A8E1866864911610208628E28824EA70900153';
wwv_flow_api.g_varchar2_table(20) := 'A4A8E28A2CB6F8040C30C628E38C34C210020021F904090A0000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF5845';
wwv_flow_api.g_varchar2_table(21) := '8258550C26F0D1443B31CD13F5D25DD2E8FB255A7C7E7D8078767487867A888B8A2477798F8C027013030A6C02440A95255A289F275A0EA4A5A4A3A6A5A126AB9E09A0AFA2B1ACB3AE7A7098076D710214BE140303BFC3C0C2C4BEC10FCACBCAC9CCCBC1';
wwv_flow_api.g_varchar2_table(22) := 'C7C8C6C7D1D2D6D5D4C4D8DBDA22B899448ABE15E570E5E8E8E7E9EA1310EFF0EF70F1F1EBEC15F6ECF9E9FBEDF7E613FEE10B58CED7B735BA34591141CE8243380E2346842871A23B7AF22E62A458D102C78A1F2586B4D8F1E184921E4FFF3AAC605000';
wwv_flow_api.g_varchar2_table(23) := 'C22AB1285490280265CD922222E8DCA93327CF9D373B06AD3894A6009B47712615BAD4024B112F15C69C19B168D5A6467F0215A0B527D6AB48C32A15CB54E25397E116F6A2EAD06ADBAF6FBB46F0A9D5AD05BB78E1DED59BD72C05A86C06144030D52859';
wwv_flow_api.g_varchar2_table(24) := 'A25CBBD2FDD977ACE3B28F11FB853A788054863249961C69126346CF1038A74429BAB4CA8EA623B2FC8B36A1B83CE4000AEC0710F43CCFB407CE26782FB76FDEFA78B79C939613EC5FDC8625473EE019B4E6CE1F2C9F26AD58F5E9D6AF6953EE8DD2845C';
wwv_flow_api.g_varchar2_table(25) := 'BB788D684582FCF804A954A14FEFC03CD45AE5E19F87455FD6ADEFC5DF88879428929C40831002608085F8779023FF2178A03A81944C922083FC7D03C725695D91C5191866A8E1861C7A914654440021E288249668A20E091930C58A2CB6E8E28B4FC020';
wwv_flow_api.g_varchar2_table(26) := 'E38C34D668230C21000021F904090A0000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B';
wwv_flow_api.g_varchar2_table(27) := '31CD13F5D23D4FBA4B1A8081125A7F8180837876748A897A8B8E8D7D8F027013030A6C02440A95255A289F27A1265A0EA6A7A6A5A8A7A39E09A0AFA2B1A4B3AE7A7098076D710214BE140303BFC3C0C2C4BEC1C7C8030FCDCECDC1CFCFC9CAD4C7D6C4D8';
wwv_flow_api.g_varchar2_table(28) := 'C3DABFD822B899448DBE15E570E5E8E8E7E9EA13ECED10F1F2F170F3F3EBEFF8ECFAE9FCEDEFE6DC95F3F56D8D2E4D564490B3C0100EC3870F1D428C386122457BF2EA618420D162C7891F2186A468B16145861508FF0A30582516850A104594B420B364';
wwv_flow_api.g_varchar2_table(29) := '4D8B2222E8DCA93327CF9D3727068D2960E6D0874719064D2982254297309116B539156755A1027E02CDAA3542529A57891A0D2B752C44A62BC325EC15552959B766A976F5CA55EBD7BB6FC1C6B57A96425336030A20802A96EA5EAC737DDACD8BF77061';
wwv_flow_api.g_varchar2_table(30) := 'BE0FD126103CE0A9C297244B8E3439532346CFF6365B104DFAA447D3204DA7F49BF6A0B83CE40202ACE04F3640D0F7266CE428305FEF7DBFFB05FF77BBB7CA396A39C1EE66EC5AF36CCFB73193066D3A756ECB9415D38E7D7BB5E7DF26E4DAC56B442B12';
wwv_flow_api.g_varchar2_table(31) := 'E7CDD7429F6015ABF6EE1DA46FBA5E3DACFBB26E894FFEA6FC1E467CC83189800914620822060A32603D4191101820830F52B2A084915472895A576471C6861C76E8E1875EA4E11411409468E28928A6A8C341064CE1E28B30C628E31330D468E38D38E6';
wwv_flow_api.g_varchar2_table(32) := '0843080021F904090A0000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D';
wwv_flow_api.g_varchar2_table(33) := '4FDADBB5120D828312808384747F788A7C72897A8F027013030A6C02440A93255A289D279F26A19C090EA6A7A65AA8A8A324AD23AF22B102AD9396076D710214BC140303BDC1BEC0C2BCBFC5C6C4C5BF0FCDCECDCCCFCEC7C8D4CBCAC2D6D9D82270B755';
wwv_flow_api.g_varchar2_table(34) := '8BBB1415E470E4E7E7E6E8E913EBECEEE51310F3F4F370F5F5EAEEFAEBFCE8FEEFC8F1EAB60617262B227855B0C0100EC3870F1D428C386122458B0DE5E1B3A771A3448B1F27868438F222C30A0369FF5D229220E1C28722305A888991A6459B134544D8';
wwv_flow_api.g_varchar2_table(35) := 'C973A7CE9E3C7142140A53804CA20C71A294B512E1AE97498DD6947A936A4EAB4305000DAA756B04A433B1163D2A362AC4A52A0DB2749995ACDBA964BD7EEDBA15ACDDB261DF9EA4C014D78002085A3E6D0BB770D5B85E7FD6C57B57EFD5B37C69011E70';
wwv_flow_api.g_varchar2_table(36) := '50B04293202B622C9951E6BD8D103E7BD49CD9336991A749924619B920B83C0AE3C1AB005036BCDAB43BE213BDBBDD6DDFFB80F713FE0F78CA394D35C1EEA52D5873E6D89C47872E6DDA80EAD0A62743368CFBF3EDBDBA4DF8765079235A8245A527E569';
wwv_flow_api.g_varchar2_table(37) := 'BDAB52AB52C18F3FABBE7B58F765B9B795FC8D2E499138124E1F011234A080811CD24041210924780883E70178A08111FA01C9809354D2D415599CE1E187208628A21769B876101028A6A8E28A2CEA60900153C428E38C34D6F8040C38E6A8E38E3CC210';
wwv_flow_api.g_varchar2_table(38) := '020021F904090A0000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDA';
wwv_flow_api.g_varchar2_table(39) := 'DBE97F09120D8485125A8385848778817C72807A91027013030A6C02440A95255A289F27A126A39E09A0090EAAABAA5AACACA524B123B322B19598076D710214BE140303BFC3C0C2C4BEC1C7C8C6C7C9CAC10FD1D2D1D0D3D2CECDCCC4D8DBDA2270B955';
wwv_flow_api.g_varchar2_table(40) := '8DBD1415E670E6E9E9E8EAEB13EDEEF0E7EFF27010F7F8F7F6F9F8ECF0FEED00AAF3E7EBDB1A5D9AAC88F055C18243380E2346842871E2848A16313EBCA8711F3F081EF951C438B2624989232BFF14147050DCC286114568B42053634D8C372BE6942822';
wwv_flow_api.g_varchar2_table(41) := '82CF9F3E7B02FDB933A68099451DE654692B139153BD602A3D6A932A4EAB3AB1F2D46A742851015E83729D8A742C4DAC4C593A5518756BD9B755E15E0D1B41A8D7A467E5669598B6E5800208A096731BB7F055BD5BE9DA1D8AB7B1D9A5146C011E9050F0';
wwv_flow_api.g_varchar2_table(42) := 'E08D334F66ECC891646793133EEA0B2D5A3366CE993BAB8CAC16E1D33C0CE7C9AB20305E3D7AFF700724FD3164BEDAB26FCF26C87ACE5A4EB07F711BB65CB936E6CF9D2B2B66EDDA80EAD4A22F9BDE7CFBAF6F13C22544FE88255452E74DA15A2F2AD5AB';
wwv_flow_api.g_varchar2_table(43) := '56EEDFD732CF1EBD1E70C7DFF0A23409D2B83EFD19F49F7FE5F12788228B2082603B038C14E88724030AC8472597AC7545166764A8E1861C76E8451A2D2504C488249668E2893A2064C0142CB6E8E28B303E01C38C34D668E38D3084000021F904090A00';
wwv_flow_api.g_varchar2_table(44) := '00002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDADBE97F7881120D85';
wwv_flow_api.g_varchar2_table(45) := '86125A84868588827A808F8E027013030A6C02440A94255A289E27A026A29D099FA6A1090EABACAB5AADADA424B223B29497076D710214BD140303BEC2BFC1C3BDC0C6C7C5C6C8C9CDCC030FD2D3D2C0D4D4CFC3D9C2D92270B8558EBD15E470E4E7E7E6';
wwv_flow_api.g_varchar2_table(46) := 'E8E913EBECEEE5EDF0EAEE7010F7F8F7F6F9F8F4EBFEE8E8F5F2B62657262B22C659580867A143870D1F429C2071624586142F46ACB88F1F848EFC364A14F970638581020AFF864B58E1A1888B165E5E945991A6449B2E05C01411A1A7CF9E3C7FFAC4E9';
wwv_flow_api.g_varchar2_table(47) := '90E8429B2745A83C888A42CBA23A6746AD39F566D59C3BAF42153A540057A05A8F868D5935694A4C449A3E159BB5AD54B754B37E8D1094AB51B2702D985539A00002B558DF0A8E3BD8AADCAF7585DE5D5C968252BF039826746A5163468E9747662EB9B9';
wwv_flow_api.g_varchar2_table(48) := '32668FFA2680FED819234C932897A6CD332E1EBC0A00DFCD93578FF63FDB01458306992FB6EBD9E750CE417B60136B5FDB902FD3B69C5B73E5C98845B776AD5AB4EA0F922B9BBEDCDB0470078DF3518A6A54F952A7D2A73A058BD5ABF60E6891572FE71B';
wwv_flow_api.g_varchar2_table(49) := '71379C084A9203A94F7FFEFBE9379E80832CC248220636D0C8358093FC47A077958097561A675468E1851866884616C401E1E187208628A20E061930C58928A6A8E28A4FC0E0E28B30C628230C21000021F904090A0000002C000000007E0016000005FF';
wwv_flow_api.g_varchar2_table(50) := 'A0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDADBE97F78817C725A120D88891286898A807A8F027013';
wwv_flow_api.g_varchar2_table(51) := '030A6C02440A93255A289D279F26A19C099EA5A0A7A2090EACADAC5AAEAEA324B39396076D710214BC140303BDC1BEC0C2BCBFC5C6C4C5C7C8CCCBCAC2BF0FD3D4D3D2D5D4CED1D02270B75582BB1415E470E4E7E7E6E8E913EBECEEE5EDF0EAEEF4EB70';
wwv_flow_api.g_varchar2_table(52) := '10F9FAF9F8FBFAF6E8E8F1EAB60617262B227855B0C0100EC3870F1D428C386122458B0D2B62946891E3C47EFE2080F4E71122C70A0305FF14049770E14311182DC0C438D362CD893721E67C2920A68808408302FD2934E84E8637518A5879F0D4389D3D';
wwv_flow_api.g_varchar2_table(53) := '6946B539156755A83EAFF2CC5AD4A880AE43B522ADAA54E525224E5D8ECDCA566A5BAA6FAD828D40B4EB519964292C6533A00082B458DD0A863BD86A5CA873EB16BD9B54AF4ABF039A267C9A3166C98B1B3576D4FC91B349CF1443F29B205A24E8CA0C51';
wwv_flow_api.g_varchar2_table(54) := '3A668A368FC278F02A007C374F5E3DDBF77007D4CDAEF4C87DB361934B39E7EC014DAE7B690BB65C3934E6CF9D231B36BD79326CD90660B7163D59B06E13BE1D444E48652A52A6D2A352AFCA54AC56B0DE3B9835A29637E36E36110CD7275221FEFF9527';
wwv_flow_api.g_varchar2_table(55) := '897FFB09E80724091CD2483B038B24B82083040EC8DF2495187745166764A8E1861C76E8451AAC1D00C488249668E2893A1864C0142CB6E8E28B303E01C38C34D668E38D3084000021F904090A0000002C000000007E0016000005FFA0208E64699E68AA';
wwv_flow_api.g_varchar2_table(56) := 'AE6CEBBE2721CF746DDF78AEEF7CEFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDADBE97F78817C72807A5A120D8A8B12888B8C86027013030A6C02440A9325';
wwv_flow_api.g_varchar2_table(57) := '5A289D279F26A19C099EA5A0A7A2A9A40EADAEAD5AAFAFA3927096076D710214BC140303BDC1BEC0C2BCBFC5C6C4C5C7C8CCCBCAC2CED1030FD5D6D5BFD7D7D222B6974482BB1415E470E4E7E7E6E8E913EBECEEE5EDF0EAEEF4EBF6E87010FBFCFBFAFD';
wwv_flow_api.g_varchar2_table(58) := 'FCE8F1EAB60617262B227855B0C0100EC3870F1D428C386122458B0D2B62946891E3448F10FF0184201220C70A0305FF14AC726A1C4411182DC0C438D362CD89375F0A8899F3614F862222081D2A3428D1A137518A5879B0E5429F3B6946B5391567559D';
wwv_flow_api.g_varchar2_table(59) := '3CAF42CD9AF52852015E8B5655AAF21BC25D4F816A55CB556A5BAA6FAD760D6BD46B520A4BD90C2880C02956B780E106963BF82FD5B011EA1EBDBB94EF80A6095D668C09F2E2468D1D317FD41C92B3E5CC23FD4D084D12334ABC650D82CBA3301EBC0AF8';
wwv_flow_api.g_varchar2_table(60) := 'DECD93578FF63DDBF970CBAE4DBA643F81A8E798D5C4BA97B460C78D4343BE5C39B261CF93278B4E4D1BB6EAD6B9D5BA954BD7085ADF579100BF547C7853E8519992E52A167B07B426713FE86613C1707D2215C2BF9FD07DFF92E8F7DF208124F248038D';
wwv_flow_api.g_varchar2_table(61) := '2460E0352309F2314925665D91C519145668E185187A9106534400E1E187208628A20E061930C58928A6A8E28A4FC0E0E28B30C628230C21000021F904090A0000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7C';
wwv_flow_api.g_varchar2_table(62) := 'EFFF33838870281A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258550C26F0D1443B31CD13F5D23D4FDADBE97F78817C72807A867D5A120D8C8D128A8D0C920B0A6C02440A7084025A289D279F26A125A324A523A722';
wwv_flow_api.g_varchar2_table(63) := 'A99C099E090EB0B1B05AB20D920C95076D710214BE140303BFC3C0C2C4BEC1C7C8C6C7C9CACECDCCC4D0D3D2C3C10FD9DAD9D8DA0EB6B8964482BD1415E770E7EAEAE9EBEC13EEEFF1E8F0F3EDF1F7EEF9EBFBEF10FF00FFC10198ED1B8335BA2E5911E1';
wwv_flow_api.g_varchar2_table(64) := 'AB828587701E4A94187122C509162F6684887163C58C1F2D869C38F262C0800309FF3E6084B04AAB5E0E258AD86861E6469B19715AD43991A74C01347D3E145A534084A3488F8A8810F0C1B7960A5F9AEB09F466D59C577766A51A74EBCFAE60AD264DBA';
wwv_flow_api.g_varchar2_table(65) := '94E93FA70DA08E631873A857B761B1C6D53A97ABD5AE63919625F894CD800208A4B62D5AF7EBDDC37211D3554C35AF52A34D9F021E1095E1548E344B62F6D8116467919F4986D6C839F3849300539E5D99569C953C0DE9CDABD04FB6BD7AF870EBD3CD8F';
wwv_flow_api.g_varchar2_table(66) := 'B7BCDBB3559F545DD096DA039960FFA276CDDA72E7CB941593CEFC3975E8D39F0DD8B6AD5B7149B976F142F552547952E74DA527EFAA3DA8F5AAE0B392258B562C70E112627A33DECF2172890058888022F817E026021838203C820A160849238C3C92C0';
wwv_flow_api.g_varchar2_table(67) := '228CDC42896B576471C6861C76E8E1875EA4711C10249668E28928EA90900153B4E8E28B30C6F8040C34D668E38D38C210020021F904090A0000002C000000007E0016000005FFA0208E64699E68AAAE6CEBBE2721CF746DDF78AEEF7CEFFF3383887028';
wwv_flow_api.g_varchar2_table(68) := '1A8FC8A472C96C3A9FD0A8D4383C2414D88476CBED7ABFE0B0784C2E9BBF58458258552C18F0865CA29D9826F57BBE844FD8F97B247D7F828123837A7E8984875A12720D700C0B0A04060D02440A920D0E9E0E5A28A127A326A525A724A923AB22AD02AF';
wwv_flow_api.g_varchar2_table(69) := 'B1099F0E91709517989A710E0FBE0F030314C3C4C3C1C5C5C7C8C6C2CB14CACBD0C8D2C9CDD1D6D3D8D5BF0FB5B704B999560C9DBE10E7131315EBECEBE9EDEDEFF0EEEAF315F2F3F8F0FAF1F5F9FEFB00F63B07C197B735E1882490638E603A0B102342';
wwv_flow_api.g_varchar2_table(70) := '7C283122C58A162E56D42891A3C5091827820CE95164C88C1308FF167C2007A12E2BE5544610719266489B187156D4299167449F10815A104A54400495DD1AB814B7B017C1083305D4947A936A4EAB3BB1F6D4FA936B50AF43C116854A30E9528531CF41';
wwv_flow_api.g_varchar2_table(71) := '2D3AB56D55B757E16695BB95EC39B3E01A0C2880A0E903996CDF0A8E3B786EE1AD74BB1E2D5B2B410103129832FCEB7024C692284F62DE6C7963E78E9F3F6A0E2D12294BA5799992EB4519023F76AFE9D9BB2710766DD9F662D39EADBB77CABB49199C3D';
wwv_flow_api.g_varchar2_table(72) := 'B06935376AC4903373F64C5B72E7CB9D296FCE7CBAF501DCBC31C0F5B2F8EA4FB24425104F9ED478F3E54D9D572F9E96ADEDA935BD8933C79008448014E56774DFBE00FC85E817207FFFF9076023093C228735249458F2D215599C21E184145668A11769';
wwv_flow_api.g_varchar2_table(73) := 'AC7140154074E8E1872086A8C386021830C58928A6A8E28A4FC0E0E28B30C628230C2100003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 37775474831382827870 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'bar2.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '474946383961DC001300F40000FFFFFF000000BEBEBEA6A6A69C9C9CB8B8B8B2B2B2C8C8C8D8D8D8C4C4C4D4D4D4DCDCDCE0E0E0E4E4E4B0B0B0BCBCBCE8E8E8ECECECCACACAF2F2F2F4F4F4CECECEF6F6F6C6C6C6D0D0D0EEEEEED6D6D6C2C2C2AAAAAA';
wwv_flow_api.g_varchar2_table(2) := 'F8F8F8A0A0A096969621FF0B4E45545343415045322E30030100000021FE1A43726561746564207769746820616A61786C6F61642E696E666F0021F904090A0000002C00000000DC0013000005FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7C';
wwv_flow_api.g_varchar2_table(3) := 'EFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B4040583C3F02883079CB17ADCDDB8DFC7F49AFD48D8EF1BB978EF68E3ED687C7B7E7F7A828478866B88778A83757F79738F911B8182068C808E99908593746066055E2B5D641215';
wwv_flow_api.g_varchar2_table(4) := '180A0AA2AE021BA41AB308B5081B64706EB2B6B609B9BABCBDB7C070C2BDBFBABB0FC3B5C9CAC7BEC5BACDC4CAB1CCCDCFC1D9C3DBC6DDC8D3B0C218A908032C0406090A0B0C0D100B0507A9F612170FF110FCFCF3F5F7F0E9EBD78F81A7800309CA3B78';
wwv_flow_api.g_varchar2_table(5) := '2F2141830011EE7BC8D09EC38215054EC418D0E2467F19F37D5C18B1E148881D13FF5C848781803A01EE08DA5945939580051372EACC309395CF563877E6ECF913A8D0A1E78ADE3C3A81E8CFA5479DFA842A54AACDA055933EC5BAD3AAD1A85AA772D5E9';
wwv_flow_api.g_varchar2_table(6) := '956A57972B081C580041E72D5A705359984BD7C282767067C9AD3BF76E5EBD15F8F6C59B772F5FBF7F0DD7455C38B060C6711D1F261C59B05DCAB414D3859C59F262CC802DDF45AB422D8308142CF02C4A6B83CE0EB03BACFEDBEA75ECD97F5DC7BEBD81';
wwv_flow_api.g_varchar2_table(7) := 'F52CDDBB65F7A60D7C37EEBCC579FBAE1D5CF8F2E4B08FC385EE9CB8EDE8C3735F57DD9B740AD3A82D846DCDC0F2F8DFE5059FD79060ECDCF5EDCD9F8FAF7E7E7ABEF0DD8BB72F9FB8FEFCFDE5765F5DE7788702781470C68ADB66B031009A020C76E0A0';
wwv_flow_api.g_varchar2_table(8) := '6F114EC85A850F6248A104CD49982187CD595894861782189C883F9138A289BB5968E009E04100936FD43555D353197498618DD9299563733BFE685C8F38EA78E354422A476392D81D691393D5B1C6A393184CC9CA8B260C500B04F8D0F8DF015E06A8D4';
wwv_flow_api.g_varchar2_table(9) := '9761D657267E604A49A69A626ED5A6586F5E15E75768FA94CE0A6034D00A95078846E4827D3EF62784814EC6676A869688E867870ADA68A22B2EBAD9A0F8483AD8A38C2AEAA84DA5E089C416A0862AEAA8A4966A2A155D14A1EAAAACB6EAEAABB0C62AEB';
wwv_flow_api.g_varchar2_table(10) := 'ACB4D66AEBAD2784000021F904090A0000002C00000000DC0013000005FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7CEFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B40405C7C7F1280B36E801C76170B0DD83027A9E';
wwv_flow_api.g_varchar2_table(11) := 'E6B4DD867C3CC14FA0131C6B6D797A0F7C1B7E8881836F0E038687896A8C777B7D73938D857D9C8B6F8496887D81788D7B887F80826C798E059C927683AD8F97A36B9F700666055E2B5D1E1C1215180AC61A1B06050F026768CB1A08D2D3C968CE7EBBD3';
wwv_flow_api.g_varchar2_table(12) := 'DA09067367D80FDAD3DC74CECBE2D2D5CE73E7E8E41BD7C9E1E8D5747EEDE2E4EBCFF3F9DDD6A8F069AB077083C071FFE0052C8000C3300403581008566101830610322E28706098848F1F1F60CC4872C183031540FF26083992240406863C82BC20D265';
wwv_flow_api.g_varchar2_table(13) := '46982B3DE6AC6913E6C7942025F07469B2E3CF9D2D49E20CFA9166528D27410215FAF4654C95129CDAB42A55C24AAD3DA332057B110101891E362C2039A12D9F62C5A46110B0A0AD5DB7128CE99596A0EE840C77F9E835268DEEDFBB19040F46A0C030E0';
wwv_flow_api.g_varchar2_table(14) := 'C0791723307CB86DE2C87B1BFBAD3C61E560057C373F4E9CE073E1CD951567A6FCF8AF6ABD1A2823F62C59F65F0867571070B0F6EE04041B106888160D41820A1692276F6B9CF870BEC8952B5F9040F8F0E218A22B9F6081FAF3E70A3E4A9F9EC079F1E3';
wwv_flow_api.g_varchar2_table(15) := 'E39997770E3D7DF7F5C4DB4B6FEBFDBB5CEDD2EB3F673C2CFD04FDC52120DE7CBFC1B75F76FEE5A602FF0117301001051658569A060A80D7585B1D64C85D62155E27CD85196AE85A85D6C9B54106217620216CD11873628A2B5A579C022F86B8E1061D0A';
wwv_flow_api.g_varchar2_table(16) := 'C71888365A90018E145E375C8D2272780C761B60582490FB3594248C23CAB823912A76C0217B2E2A196107112898020107380861721F1DF9A1000C8C4766641E4EB6809A1694D9618B7DD9259D9C4222932681B4E568DC9B7C62B61F5D70E2B95F9D6D2D';
wwv_flow_api.g_varchar2_table(17) := '17A7A074EEB9DDA23276A8969DCA197ADD068EDE298179A7F997809728802966720CC04798022B299762A94282669C761A76502A8BF7A9AAE27B830539A005AB1A085A78B076901C752C1AF3518A21B27A9D5EC7222B6B6992EDDA6BAED039FBECFF67C6';
wwv_flow_api.g_varchar2_table(18) := '4A606B86B32E86AA04C80EFBA944613EE823B4C77C48E58DA63939018C3E3249E194EFDA38E2671A4840A5860960B0AC89F52E594C6634067CEB8FEDD288A2BD461E738C000B0B2C19064FDAC8258EDE160CE58F039FAAB1C5116C8001A8270C200D046D';
wwv_flow_api.g_varchar2_table(19) := '617000ADA83240E99A2CA359286684B94969CA2B9BF9A77F2AD3EAA67B72A6FBE7CD1DF40C1B6332136874AE84AAB974CD4D3F1A34D4806E37C1D37A45ADA90211AD0006461394DAF131FAC249DDD88CAD34A6A267E3ABEFDA11FED72FB6121C00F7BB0C';
wwv_flow_api.g_varchar2_table(20) := '602CF4477093AAF7A96A1368DCD8D9F6FD1EE1E1D92DF8DC7B355481E162D3ADF87879E75AE1DB8BCFE58BD7486CE1F9E7A0872EFA1AE8A453D14511A8A7AEFAEAACB7EEFAEBB0C72EFBECB4D77E42080021F904090A0000002C00000000DC0013000005';
wwv_flow_api.g_varchar2_table(21) := 'FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7CEFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B4040587076978083668F480E37018DAED41214D5FB70D78B73C9140F3131C6C788306030F1B7D6980706F83867D898881';
wwv_flow_api.g_varchar2_table(22) := '8D8C7B916A1C6F6E8E0F7F7C988D8486889E80996E778505899E6C9BA29D9F6981AF9B7BA49F6B946D1C1E0E605E2B5D6B1C05180AC81A0A1A1B06026774050F08D4D40A08CDD090CDD3D5D5CD1B67DBD2DED5090668D06865E5D4E0747DECDED7E7DA88';
wwv_flow_api.g_varchar2_table(23) := '1BE4F308E78A69F9E5EFE8E0EB568E9FB834F20AA20B178DA03783F7E219905001C1001604063828606041030820412E28704082C993121EFF7C0C29F241490909609A54C91224830715509ABC40B3E64D8A3263A65CC9F2664E9D3C89865CF0C0648598';
wwv_flow_api.g_varchar2_table(24) := '3193D68470F3A5CE9E459B023D29D5A7D6A012BAB2640A546858AC21ABA214AA924103040430162BA001E484BB77F91CB3860083800578F166E083EC1A027A0B3204CE9BA0F043C08B07374676F8F0DFC5792538369738724CC7941300561CF83365CE13';
wwv_flow_api.g_varchar2_table(25) := '48E3356D989AE8BBAA2710A69CEC6FECD4AC9759861C78B0E6D3AE216780107705013C09304FC0A601417373152C480FBC4F8375BE09A24B9F3E614102EBCF5D6BB730817CF704CE9B1BCEBE9D7BF5EBD0B707F69EBE9A0293F2CD57778E7D3CF5EFFCC5';
wwv_flow_api.g_varchar2_table(26) := 'D7DE5DEFF1759F7F7759E01DFF7C95B1C7DD5D0B32B80F82C5A9705C011050601E6C8D5D67980202DCD54179B06DB04C78C884D8C188829908DF35186C90C18ABDB9A8DE32204E40638B2752A34C8E349267C160D7DCD8D706229238A48D2FCAB863893D';
wwv_flow_api.g_varchar2_table(27) := '5616A38E2C42199E354E56999A8D87C188248D2C66C0E5874E923762852910C081041168389D0526BD88587BE6C529A16874DE65A77ACABC961F9C128027E8060CC8B79A66F05987E783B2217AE5A286EE69DF65DC4967528FEB2D905F79769EB88C9F91';
wwv_flow_api.g_varchar2_table(28) := '062A687079020A9E8F0A2450E88368A24080030CB4C9DD82B4D113DD8A3B46F8A106315900E68A0C74F8DC32F80509EC64CA3CC71EAE235A10AC75D784766B076F06EB69FF6126318BEBB33F622B81B6C76E269EAFB84288EC4315686B6E61A72D5BAEB3';
wwv_flow_api.g_varchar2_table(29) := '93457B1845B872D7EA0904102A2B94BA59A34096246E292E32000B292606CA74792495782D794C325E521964A3094BF9258B349A56D96105F3BBAB5F3356499E893846FB6FC8356EB64C8C28377B306D58A29CE0CBF212DC326CF79A3000351024680106';
wwv_flow_api.g_varchar2_table(30) := '0760BA5B7986022DF43E9AD2F973D0A77D0A58A54B473927A31204FDA2067F192A9DD1FDA6F8B4795B33AD1EA9505F5A58C290BE59B5CAA9262DA49E4CB786B4D651B34B76A417AD00C6471368B800C9104F582A038077C9AB046E06ECDDC3FD66977882';
wwv_flow_api.g_varchar2_table(31) := 'C1321E2D4589374BF831C31EEEE6AC093C6C78D58F4B173945BBC8803EE07992DB1ABA821B78DEA5499B6F37BADD8E9FBE388ECA56F03884CF7C81C416C0072FFCF0C4176F3C155D14A1FCF2CC37EFFCF3D0472FFDF4D4576FFDF52784000021F904090A';
wwv_flow_api.g_varchar2_table(32) := '0000002C00000000DC0013000005FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7CEFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B40405876730F014049B74FAC871181C70F8A0A0AE0FDA86BCDB314FA41380091C1C79';
wwv_flow_api.g_varchar2_table(33) := '85797D757E6D7B857C0F1B7E6A8278716F030F91768B86067D816A776E9C9E817E03706FA29D8F909FA79C96989990787A7A97AD80B494701C650F672C5D776F050AC71A0A1A1A1B066889050F08D3080AD3CD7F9069D1D4DDCD687E91DCDDD7061BCF7F';
wwv_flow_api.g_varchar2_table(34) := 'E3E4D892DBD2D4D608ECE1EEDDF109E6DA6A06EFE4F875FBFA75C3074E92BA81E6D0A5E147AE5C413F0FDC544030800581530FC03080C0B1E382020724881C79E141838E1E0BFF884C208165829227514258F060A44D9832673EA8D0B2A7049C3269DA5C';
wwv_flow_api.g_varchar2_table(35) := '091425839A155C8A2CEAB1E6D09726731E95C07324D4982885F664F933AACCA33CB92EF59AF541C89512B63168808080450E0512488330A16EDD0C2CE3C5C32060815DBB78251C9B166F83DFBF75F3C6A396E0F0DFC083AD59338C38B1E0C5D5FA56862C';
wwv_flow_api.g_varchar2_table(36) := 'D99A86BE192A2BB6071A31677F7E43FF1D8D0C8166D38A9555FBEC18F0686FA921B85D4120A184CA13E421D0E0AF82050B8817245846781A06E3C791D755CE7C20F409D2275027AE976A74E916B6937B7E3CF972E2CD135CCFAE7C78730DDEB34F4FE0BE';
wwv_flow_api.g_varchar2_table(37) := '1BF9E876A937B7A6BE7CDDE3FAED179F79D54D03DF7513ECA642FF6FE74420DF0478C9B618061B4CD00176B6C9D61C8516FE654184E875264006173E968084CA1C53618919A2974C32235E881C722056A3578C181E97C106CA5497CC8A1EEEA8A15E403E';
wwv_flow_api.g_varchar2_table(38) := 'C663431CB278D789DCDD48628777F1C81D3C152277A18229F456800614E0871C4B21DEC3C0777681891E630B9069197329CA936679D189B4CC9CCB6C30A67C16C8E9E23209DC899899A8A999A70405F2F7E67FC8E9590D9A706228678FB219A6E6047AFA';
wwv_flow_api.g_varchar2_table(39) := 'D827998912EAA2A1FE25F8D6031174295D070C9CD8D9343C75A06A89E12DA717712CA96AE1AAA55697A248B25A402B931A22A0DEAA326AE7AA8DD5A4DA41A3DB1D33D8AFC05EE86B32CA1E836BB3A49A6A8FFFB1B2CED76B3554019B9FA9830DD7EDAA18';
wwv_flow_api.g_varchar2_table(40) := '2A17D9A2C6FA87250A0470A040A8A3D6B82190E009B9983549E608218FA72290EF7FFB2A9B8C8D1B9098EB87FCEEA740C125CA1AA16484F1F56476F612062DC376E92865643F3E692406AFFA0BA48C1D541C4FC72CD2686D67125FC8E2BA270C30115DD8';
wwv_flow_api.g_varchar2_table(41) := 'E98AC1016CDAD8D7A437E73C4D63DF457773B8911E5AF3043D8738DCCE0F266DB1024C238AF401435A1375CD1D0C3DE5CF460B4D353292310DA70543EBA54CD4D9954DCED5E5951DAEAF6FFA6741452B8071D204A22EC06F9B08FC84A9B020DB980C555D';
wwv_flow_api.g_varchar2_table(42) := '62381FC81A1E5838A2CA210EB10407141E6CE321C22A81A8D9F91A38D8372F5E5EE3D14E1639477ED881AEEC35A3235A6DE0362AF013E6D1E9EDB8649063FE2D062F52B341EA7F09E0050B476C21FCF0C4176FFCF1C857D14511CC37EFFCF3D0472FFDF4';
wwv_flow_api.g_varchar2_table(43) := 'D4576FFDF5D8677F42080021F904090A0000002C00000000DC0013000005FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7CEFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B404058767C0297B0A9BB47A43E638DEF0017A';
wwv_flow_api.g_varchar2_table(44) := '9D261B0C0E3C7EF0D824FE8076777779726A097E09036F838C86877E8B707A067C747F658384950F7F6B8A1C9A8472808891939A7CA589998D778F69806E8C7A0EAA9E6A6470651C05055E2B5D760F0F060F0A1AC81ACB1BC69009050F08080AD3D3CD7D';
wwv_flow_api.g_varchar2_table(45) := 'A67ED1D6DD09CEA688C6DDD6D890D8E4D706B1B1D0D2D4DEE06BDCF0D6DFDA89F4E4DF97EEE908F79EE98BD787CEB874CD1021EA5380C381012C082C227621C1030610326A5C50E080848F20255CD4B8B1938404273FFF5A6C403223830221538A64D9F2';
wwv_flow_api.g_varchar2_table(46) := '254A9427135C18D972C18390807662AC691227C807344932F80912E7CA96109602FDB33369C99B40792A35D9542752A84B3DA2F423A1990602117B55AC2060C184B77027FCA9370D43DBB870514EAB66CF2D5EB909FEDDC59B616E35BE0A06E39D6B4D81';
wwv_flow_api.g_varchar2_table(47) := '63C5700B07768C605962BF8B2574E39B007364BDE920E7D5EC58C35ED1130A4B40462DD9E5BFAAD3D9450001ED0A02EB5456F86B01C1867F0976FF5D10982EC00A162CC4B5401CF86EE5719B23AE8B1C3AF4E6B2852FC75E4FC1C709D0DF322F5ECDF4F1';
wwv_flow_api.g_varchar2_table(48) := 'BF13B8EFF52E21395EE97483C3759F9E3C3CEFDAA3179F66F9FB04DB2AE0169C5DE865B001658D255660FF02941DF6D8726F19E8D861AE0950E081A529A3206C0756C61A02186C908172E14988E0321A88482274129A675E8819CC1761877CD525228735';
wwv_flow_api.g_varchar2_table(49) := 'AE77236118D6E8D8067F75501882D6C0D8C17F111970015B0BB8075D071F518398770CD0371A39C9485065786F45894C7954AE48E2472896B90103104E106565667A069E056B5AB34C025B8A3701949AEDC5E699E259E7A59C29BA45A2786426631E404D';
wwv_flow_api.g_varchar2_table(50) := '72299704CBF0374D674EC2B566326CD209178029E0D6477B4F76D00103934DF991A7E2790AEA5E87CAE729A99F92472988CFADFA16711F165901A9E14977D8A3D5817767AB133A38AAACA63218AC63C3AE5AEC66D44870EB91F3A9C71706CFBE67ACFFA3';
wwv_flow_api.g_varchar2_table(51) := 'C7E1FAEBA9BBF24A1FA628685A00044FCE38DD842ADA99DA0618E869E388BECE88019120EE582E4A944E2BE291C991AAD7AE3FBE45AAB988B9962E5C4706D79ABE31BEE9A989AD4909248E11A39B01BFD01A38AFA301ABBBEEC6C7EE7B290B0348608002';
wwv_flow_api.g_varchar2_table(52) := '7DF2FB27826D5909DE9F8DB59CDCCC701E80AA945AF649689E6052891E06362F9C259A6FC205F47A38FBD56F7247E78881A56F4207F497F03C9D68D4161C2D658582E21567919DE9FCF26A350E4D9F0510AD008604104C408193B4BEDA6CAFB926302FD5';
wwv_flow_api.g_varchar2_table(53) := 'F8BD6D2D062E524781D8C4818CF30114F00B57E0116749B8A2816738F7DF5636DEA0778BDBF9698FEB4940B8C3B3DA2DE5979ABF4DB33305A0DEFD79E88CDB7DA8DF7109008CDA486C21FBECB4D76EFBEDB853D14511BCF7EEFBEFC0072FFCF0C4176FFC';
wwv_flow_api.g_varchar2_table(54) := 'F1C8277F42080021F904090A0000002C00000000DC0013000005FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7CEFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B404058E67C0293BC4858D7ABD213BDE70CE20BD4ED839';
wwv_flow_api.g_varchar2_table(55) := '6F8343FFE63CEC806A6406847B6F731B09898A09837C7A068889938D789084910F758C96857C039A9B95987C0EA0766A8C8EA4677F8CAA1C9E989280768E867B738A6C4778651C05055E2B73830FAE060F0A1ACCCC081BC9948905CA08D6D7D0A18B09C9';
wwv_flow_api.g_varchar2_table(56) := 'D7DED9A993DDDED6D0E1A9D4E4E5D18B6AC90AEAD0BB75D4F0E4DCA1A81BE9F1069BD30FD421C0272D9B40736CEC8C23074E5301031206B020E081DA830B801E3080C0B1E382070724881C294163478F7F24FF242079C1E449080C1E8C5C39F241839730';
wwv_flow_api.g_varchar2_table(57) := '53AAA4D972E3CB982201896C79F3E5479A244B163D0954254B974C65EEA499C026CEA349455AFD2975E7D0AD514326DAF980C044601831A815B06082DBB713ECA8C3C016EEDB95F6BCD5B51B3781C0BD7033C8B5A7A03060B87211145EA6E0B05BC109E0';
wwv_flow_api.g_varchar2_table(58) := '3183D7B82DDF95D6F23EB31C18B337C39C114B5896594365BE712528366DCFF104C1AAAF61A850A1EC447F220B8B846B618285670277F35D10599D840ABC7D130F8EDCAE85E58ABDCD76DBFB2DF46BBA25249FB09CB0B5E96F7B3F2FAEC1DB71D4D70B5B';
wwv_flow_api.g_varchar2_table(59) := '3B3FDC6F5ED3BB2D54F73D90727405C2ED429F9CDDEC0A02062450016909A026987A8A2D2600FF5F161C48993D186C405D6794B15698847C65B0C162CD1866E086A465D6986F7669688F33084438E1041D74702002E5C178E18A8F81784D79233A672276';
wwv_flow_api.g_varchar2_table(60) := '8B6D9041861B62F71D866E7550A3663D66E09F0A005E30207E0C90C8A25B7889584E68D48974238151F2259269323293C002F289E7D697CD3433268D16A099E6405DFA269E96D6A0B88165BD19995A7428B225DF8A9EC1C89A04515637E768310ABA266F';
wwv_flow_api.g_varchar2_table(61) := '6DC616A3986DCDE7DB9792C558D792290028D505DAB1D8628B0C14976076D47DDA41A8215E73DCA7535A802A98B255C0AA757ECD859CA4DC15A7D97979EA499C7A8BE127418B9E821A59B0D999FA69A8998D9A9F6FC6369BE0B3D4ED27DDFFAD9EFAC66C';
wwv_flow_api.g_varchar2_table(62) := '5EA44E80290A0016A0D58F7A1EF9E09034BE66A3880AF888EB8E5BB69B41754636B8815A845D38AF05C4DA8BC17DE896EB9B86FF3296E45B7A0A866F9DFACA47ACBA85E1C89A8F4092066CBBD08647308CAB35CC1BC1C12648B1B72C0C20810007F8C9AF';
wwv_flow_api.g_varchar2_table(63) := '94121C90A0888426D7E867BA3150E69F13607080C58CA94C9D7C2D4B56D880AE4D10B46916128A7396A33D689ACA1DFC3973AC0A8C59265C3ADB870168724A1DB4C1852D6A57CBD25D89737564336CCD5E1648B4021812A84181D4CA89EAAC76B812B7B0';
wwv_flow_api.g_varchar2_table(64) := '020326700005EDFD9B688A15CC2DA9DE052F26D2DCBC85AA968CBAFD1D38988A4BC0385C888F2A2CE079CAE778E291CF2DB03CDE114358F8CD6EE93D2A7C92379EC0BFE4CC06F804020CF336125BE4AEFBEEBCF7EEFBEF547451C4F0C4176FFCF1C827AF';
wwv_flow_api.g_varchar2_table(65) := 'FCF2CC37EFFCF3D09F10020021F904090A0000002C00000000DC0013000005FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7CEFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B4048502C1C3293BCE0E4F61C36E6F061CB4';
wwv_flow_api.g_varchar2_table(66) := '239E7EB013783CDD20370C1E791B79657C7C677E767882096F7B0E867F8C92826606969089927A1C8568887779097196720E7F778BA28F9787A78A8A70ABA488A192B18697A76E1B47651C615E2B03A29C0F8079060F1ACB1A08CB1BC982D209050F08D7';
wwv_flow_api.g_varchar2_table(67) := 'D80809D1B5C9D9D8DB80D26C02D6DF08D076A0E9E7E8C98A6DE5EDDB6E8AD5F3068BA8F7E7D0FAF6E6BE419B248DDFB770EBD8F57360A78001090358103065EC421E09091E3080C0B1E382070724881499E082C68E1E01FF8D246972234A080C1E605C89';
wwv_flow_api.g_varchar2_table(68) := 'F1E4CB981813ACCCD8E025CC633A679AECF9F2234D9D2D7DC60C4A52C2509F1F2F8EE40955E64E3C0F88A2645020E7CAA7370B1CD0998780C401062C62588B0083800513E2CA9D80E79B02B770E74EC850D7EE5BBD71759EC30B98AE846B0A12B7FD0B18';
wwv_flow_api.g_varchar2_table(69) := '4F62051A1213D6CB37C13205082433D6EB385BE4CD72F91E468C590168B98233474E7C7AAFCED5D826731E8DA142050966571018B041A4627415E25A9830DC82B6761282035E9000B9F2E271993B9F5B9C39E66C0A920FA72E9D74E6E4C2E776BF9E183C';
wwv_flow_api.g_varchar2_table(70) := 'F1F3139837C3565EB95EE9BF219B7FDFFCDA6A0DDAE56EB79E597576F7E259B69A64B9A9408001095400D9FF650214C6D75D8F41661A75713DF85B66130296C1061026B65A831A26B0E080195226227B126E9081861C2E83A28A7175D041851C62E0CC82';
wwv_flow_api.g_varchar2_table(71) := '0AC048598DCE38F3CC8AE1EDC5218611EA38D786A52116D906311EC9A3871A6050600A075EA0E0821B30D0A45CC961689F06595268D88DCDC8A725605D46C60C980C40275C726B3293409BFAC50527333E26009705C5F199E67ACBE839DC8C6F1EE6E28D';
wwv_flow_api.g_varchar2_table(72) := '12E4B59D9F86DEC76678C58984CDA11BE4451C9F16C0F965A096A227E9A1CF4C89C28156DD959C8CA8CAC84073114A268105A912D7DD37A74E30E37E27D25A01A1014EB75CAED9802763AF115E236CAA1DACDAAAB1BB229BEC89AD9A072BAACA7A87C0FF';
wwv_flow_api.g_varchar2_table(73) := '7CC4A96A995DC79E67C1AC8AFD27EA09077685C15D0200E9E4632FAA1BDA905E2666E4BBD74586218CB7D2485E91190CBBDD8636EE9BA3BAFFB6D8EAC0B6AE6B9F8739DACAAB90A5DDD7308BEC4A88B070C30A26E1BD04EB1BEE632A8E6BC20012087040';
wwv_flow_api.g_varchar2_table(74) := '0578E55BE8BE9931065DA6A345BB00A6C2657A008603265A73A412AC76257E6752E7DB8091E95C27CC386BB640077C7A2B695B579A36B35E306376EE6373D2CC338989E949B5CDD7D818B6CB737D7ADD623347B40218185570C0012F47575FC5D8CAC55C';
wwv_flow_api.g_varchar2_table(75) := 'C03F4B700005BF8ABDB0DE7CD37775B8C9058EDEDD037E5781E1762710708485F7DD2A0680DBDA747A8E1F1CB9E0F6AA06F8E5725F3D2031E58663BAAADF1862448100C1AC8DC416B0C72EFBECB4D76E3B155D14A1FBEEBCF7EEFBEFC0072FFCF0C4176F';
wwv_flow_api.g_varchar2_table(76) := 'FCF12784000021F904090A0000002C00000000DC0013000005FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7CEFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B4048582C3E019701C6834B9B069BB3766F4393D7824EEF8';
wwv_flow_api.g_varchar2_table(77) := 'C4D99036F83D761B78821C1C7C6A7F8177827A8663690E7509828C70867E90928C786687637E92798490998A837B877E069A798DAA9FAB768B8B7BB0A00F6F02090F65615E2B030906600EB283050F1A1A08CACA1BC3949309C808D5D608C2BA790FD4D7';
wwv_flow_api.g_varchar2_table(78) := 'D5C2946D93DDDED9956DE4D7C2936EE30FDEDFD0B3CFEFF0EBE294E9D6F78B82FAF1EC02FE43F04CDB9B817A0A189030800581611286E1914051C2830610326A5CF0E040C504142F5CD4B8F14145092025FF88C44812020393272B8E6CC93125C5943349';
wwv_flow_api.g_varchar2_table(79) := 'BE4C09B2674E8D0C0A7C3CF933E3CBA1218B42A81953A5D2A01FEFA07C5AC066C5952D971A4B40C0A1000C1D31884580A1DA860513D2AA9D70C79A826A60D1AE9D90A1ADDB6A02E4CEB50B178182BC73D382544098AC59BD6B076B205C9620E2B47525BC';
wwv_flow_api.g_varchar2_table(80) := '658CF7B16009D616570E1CD9EFE4C381D92650B0983061C073EB8EB6866131EAB5AA3154A820A1EB0A020776497E6B6D43050B13800BC7060F01C5C0161624282EE177F0B5CA9957482B3C78F4BB64A7AB053E217A61DEB2B96F57CEBBB071E7E2BB2FAF';
wwv_flow_api.g_varchar2_table(81) := 'F6FD7860F2EC979D0F1DBDF4620DEED3C327CDBB39726CA62980816D2A1020C042A429C39FFF00A165B04180CB9C461D6CA395C7DF06C8D565DA7D1272F62084AE65F82161CD68802167ABB10717861D7400DB83F7C987C10619A0481A33112A70A27816';
wwv_flow_api.g_varchar2_table(82) := '381860827FCDD5A286F1AD58636A150249600A0414530189F225C0808B6B5940116F0A6A20E5846A5D19A1825BCE65A564259296C002E959306689CD6CC00097972983E362670A672745F295E82695CFAD598D668E71A766707842E90C03D50947118E7F';
wwv_flow_api.g_varchar2_table(83) := '9AF8A69A838E39A77CA8A58767A31A2C890201755CD9986C2D869A167901C25581A8DC5DE70DA8CF51C7C07A6E29E09E5A2DBE2A9D901DD80A0FABB4E69AA45B14852AECABA6B127AB04C2864AEC8FC75A90ACAF9EC5071275C3C2EA57FF35CDB9285CAD';
wwv_flow_api.g_varchar2_table(84) := 'CB7D578DA62734291406E0D1E8216FD712666E6A237AB6D8BADBF9A859B935F2E863A9EAD64BA185A5ED98568B6C915B2C59F04E007002AD91E859C190C10865BE6B1D5C167F17D60B305DA3CD4B9804FE1AEC22C29E8107AE09034820C00115082C019A';
wwv_flow_api.g_varchar2_table(85) := '555A80C101D1F29657A269BDFCE361823ADB81CDA5C98C66A4844AF6E48D8EB5ECF2011B4EB632976AF24C99AC2C274A916CC5425D655A53971A689F6A5EA9F559DB41FA72636499C9729557B26666432B808152CAB21E509DABED82A75DD8AF520D6402';
wwv_flow_api.g_varchar2_table(86) := '0750F01EC8CC98C6B1DF73292770C812F4DD6A700C6C70B8E01210FE6FAE23B61779CB8D0748AE96910F1A9C05D8081C603BE292AB657891D995AE66DE3D9BEA37A4A302DE9E00BFB48DC416B8E7AEFBEEBCF7EE3B155D1421FCF0C4176FFCF1C827AFFC';
wwv_flow_api.g_varchar2_table(87) := 'F2CC37EFFCF32784000021F904090A0000002C00000000DC0013000005FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7CEFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B4048582C350F00C1C68B4C1E1296CDEF023C731';
wwv_flow_api.g_varchar2_table(88) := '4F3B068F847E9FE0D4C70681781B7B847D7F81820F868C7E6376778B0986937E8190837C7A038897787C841B8E9006998509676B806BA67C966B89A57993858EB18A717A0503645E2B03090602120F0E9A6F050F1A081ACDCD1B06A1B41BC908D6D708C1';
wwv_flow_api.g_varchar2_table(89) := '9A79D5D8D6DA70B4DDDEC18C6F09E3D8E5E1C80FDEDFD17AD2E9D7EBD3E8EEEFE5F2A102F9E4D14285A2078FDF3982088A199030800501610A1418B8A047824509931A40D8C87141810316135CBCF04023C78D0B1EFF80C4187243C9931B193CB84833C1';
wwv_flow_api.g_varchar2_table(90) := '4B98326B622469F264CA902C13F08409C123D0904361A6042912E9CD9339695A4C0A7526C68A12A8728C2A552BCA5909083814A040E6050C1810A48D2860C184B770334CB2A6E01A86B670E38ABC56F79BDBBC6FE75A5B9BF06F5EB91B22AAA58B17F004';
wwv_flow_api.g_varchar2_table(91) := '911A22A6B5F6C0B0DE0D08245BD3D018B0E0C8D73AEB95A0B8AF02D17027458EA818F504B912EC824E60F9ADDC0B152A4810BB82C081057715ABAB30C142F1E216B2BDCB463CAF050B0B122C4F40DC78DEE8D3AB1F378E9D6EBDE6C7DF462FFD1DF0F3EE';
wwv_flow_api.g_varchar2_table(92) := 'C21548D07E5D7AE6BA0A34AC770CDD7DFCF28EA3AF8E1C79BE75B8D8C5D71702F33937C17892F1A602FF011268B00106CEDC8741028EBD96006BCBB0B641787A95165F641B1A285744FCD53561068E8D88E132278A782189CD44142260237AC78C021B76';
wwv_flow_api.g_varchar2_table(93) := '4063621FF235E36117329361661BFE675C063CC2A8560228BED5818E4862E86385517EA880822930988792D608C080791660B4197FD9B8F55F600D66166399E64D80913364D2E69C716FC219195E67869966849C9969DC736EBA6767677FEAB9D9807222';
wwv_flow_api.g_varchar2_table(94) := '779C483036838097DB2DDAE0324296F91CA0CF5904673D667A169B901A60890201C958A4C064EA55F0E4936FD5C71AA2AAEAF85F77E4B0771CADEF319717AB0CB8878D0215500817AFBEF215ECAE3AF62A5C66CCADBAEA04CA9A169145CE12FBAAFF62D4';
wwv_flow_api.g_varchar2_table(95) := '55FB64B4742D435D71CE1EE82BACDBADCA6D5FA29E40001E1260D017884D1E9698771AC61BD783F00988A3BD47BEC82C5D45C2655D02EE9606EF9916E6BBDA691958C7EA04494ABB41BCAC56799F8013A798E49AFB0EABE363EEEEB764C30FBF86EF7B26';
wwv_flow_api.g_varchar2_table(96) := '32E9F0C7F82E9BAE09C008704005052B9068ABCF61700079CCE0C9A1CEAF728A33AB3A2FCC29A6C7E95C01898C1976E904400BC82CA4D65D5AB466F1F9FC27D433B336F597ADB61A757A1B747AA905630F08297280EA6CD77D3787EDF660F735B4021818';
wwv_flow_api.g_varchar2_table(97) := 'D13C2D8546BA0A1F5D05E22C6EC16B6244417E04DF886D058703169DBB28AB770005460E9EEFDE8D4FC0EAE35E4FCBB8C0C6F55A7042C892532E38E7AFCA3739E26B51CA5CE680A23EA004933F2D5EE2E43DE0CBDD486CE1FBEFC0072FFCF0C453D14511';
wwv_flow_api.g_varchar2_table(98) := 'C827AFFCF2CC37EFFCF3D0472FFDF4D4577F42080021F904090A0000002C00000000DC0013000005FF20208E64699E68AAAE6CEBBE702CCF746DDF78AEEF7CEFFFC0A0704804080684A472C96C3A9FD0A8744AAD5AAFD8AC763A10B4048582C3F0280F38';
wwv_flow_api.g_varchar2_table(99) := '8EB421EDF01436F0F8E6CCAE7B1E89BC7E8E36F8FF0378091B79841C7D7F7E8183858387756C81848D098F6C8082948F7F63068B8C700974978A999395886B699F7A8EA998A77A8789806F0279651B055E2B03090602121518BF7B8460021ACACA08081B';
wwv_flow_api.g_varchar2_table(100) := '0684D184BBCDD5CDCF7A99D4D6CDBFA193BA02DCDD0683DFE1E308DED209C8E9C5D18C050FE9D8F1EDF3EFE5DF79F9E3F6ECFC715B170A1F3D6B1824EC1AC0820030050B182028704082C58B121E3480C0B1E3820707125CCCB6B123C78F1244FFA6B478';
wwv_flow_api.g_varchar2_table(101) := '41A3498E0C4062BCE8F225CA950912662C6932A6C89F095BF2ECE87324CDA127F18C0C5AD3E4C78A4677BE84E0330F46A15363CEB438686883061A801168284001038E83106040A04041D00513E2CA9D20528135B702E0CE9D904124DB6A1814E4DD1BD7';
wwv_flow_api.g_varchar2_table(102) := 'EF5ABB6C071336DCCCAD60BD7BEBAEADF698705F096E9B69480C79AE480D881B2B8E2CE1EFDFCA8B31B7458C7AEE65B5A045778E7B59C2D815040E2C8030C1D9BB0A132C0417DE7BC3380516E55A20AEEE37E1DE099C0B273E6141F4D06C8505DF6BDD74';
wwv_flow_api.g_varchar2_table(103) := 'E3E47197C7B5DEB67137E084C9DB55B0591DFAF0E313B0BFAB9DB03AF6F8B3BF9F6B3D36E5FADBC5E7D66D2A102001031140B081FF63EDB525C0737D65569E8310CAD7163314C247DB82F9B1A5C0061958C621331E82A8215F0B62A00C6B0F5A66A16625';
wwv_flow_api.g_varchar2_table(104) := '42B8607B8D7D18E25E19A4F8D732260688A25BCCF01862071DC895E37C947D485807118246600A0622681189A231A01C715382D6A000561266117BFEA9D3A58F9F69594D027A8937410759AEA8CC066306D826981A24C0C074D4B5B98C06706EA7E694D8';
wwv_flow_api.g_varchar2_table(105) := 'A9B3807878EA89803276FA2997459A6D86E8A0782E97653588C62957991A3C8982810B08969969095440247C1D30F0A23522F948A4A9CE915A6A741E7E87DEA8F1DDE51678A3AE0A6B8DB7C6452B74947D270191B9BECA6B5B16115BA4AEAB8516AAB2C4';
wwv_flow_api.g_varchar2_table(106) := 'B2CA5683C228EB2BFFABA1212B4170D062DB8CA627E4265805886DD6568FAE7118EBB932AE161BBB271E891DBC3ECA3B6D8C225E38A18D6B16B96179A7F1FBEB91E63688AEAF7449B0628D1BF8EAEF8F1732BC268E1C027CEE900FDBFB2D0B03C4F4C030';
wwv_flow_api.g_varchar2_table(107) := 'AB05A6D8722427649A0622C3455D5C5FCE9BD772BFB60C5865D32D8A59839C0D475D42EFCA16DE9F0748682E978AB2AC9A698259491C96479F4634C94C035C25D436AB8564D2CAC985C101566FC6D00A608404B263E00DA72BD2D96D3B5CBF0CCC18A648';
wwv_flow_api.g_varchar2_table(108) := '14A497D36AC2C6CDDDDC74237780DDD4591718DDEA4810F7AF7EAFB79E3071ABF92A06818176EBDE6BC7F7F77CC8092EB78AF4414EA805A6069664421450B75C2BE7EB21F0002F6023B1C5EAACB7EEFAEBB0C74E451745D46EFBEDB8E7AEFBEEBCF7EEFB';
wwv_flow_api.g_varchar2_table(109) := 'EFC0072FFC092100003B000000000000000000';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 37775478124050831244 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'bar.gif'
 ,p_mime_type => 'image/gif'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2866756E6374696F6E2861297B612E776964676574282275692E617065785F73757065725F6C6F76222C7B6F7074696F6E733A7B656E74657261626C653A6E756C6C2C72657475726E436F6C4E756D3A6E756C6C2C646973706C6179436F6C4E756D3A6E';
wwv_flow_api.g_varchar2_table(2) := '756C6C2C68696464656E436F6C733A6E756C6C2C73656172636861626C65436F6C733A6E756C6C2C6D617046726F6D436F6C733A6E756C6C2C6D6170546F4974656D733A6E756C6C2C6D6178526F7773506572506167653A6E756C6C2C6469616C6F6754';
wwv_flow_api.g_varchar2_table(3) := '69746C653A6E756C6C2C757365436C65617250726F74656374696F6E3A6E756C6C2C6E6F44617461466F756E644D73673A6E756C6C2C6C6F6164696E67496D6167655372633A6E756C6C2C616A61784964656E7469666965723A6E756C6C2C7265706F72';
wwv_flow_api.g_varchar2_table(4) := '74486561646572733A6E756C6C2C6566666563747353706565643A6E756C6C2C646570656E64696E674F6E53656C6563746F723A6E756C6C2C706167654974656D73546F5375626D69743A6E756C6C2C64656275673A6128222370646562756722292E6C';
wwv_flow_api.g_varchar2_table(5) := '656E677468213D3D307D2C5F6372656174655072697661746553746F726167653A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2043';
wwv_flow_api.g_varchar2_table(6) := '726561746520507269766174652053746F726167652028222B6128622E656C656D656E74292E617474722822696422292B222922297D622E5F76616C7565733D7B617065784974656D49643A22222C636F6E74726F6C7349643A22222C64656C65746549';
wwv_flow_api.g_varchar2_table(7) := '636F6E54696D656F75743A22222C736561726368537472696E673A22222C706167696E6174696F6E3A22222C66657463684C6F76496E50726F636573733A66616C73652C66657463684C6F764D6F64653A22222C616A617852657475726E3A22222C6375';
wwv_flow_api.g_varchar2_table(8) := '72506167653A22222C6D6F7265526F77733A66616C73652C777261707065724865696768743A302C6469616C6F674865696768743A302C6469616C6F6757696474683A302C6469616C6F67546F703A302C6469616C6F674C6566743A302C70657263656E';
wwv_flow_api.g_varchar2_table(9) := '745265674578703A2F5E2D3F5B302D395D2B5C2E3F5B302D395D2A25242F2C706978656C5265674578703A2F5E2D3F5B302D395D2B5C2E3F5B302D395D2A7078242F692C68696464656E436F6C733A28622E6F7074696F6E732E68696464656E436F6C73';
wwv_flow_api.g_varchar2_table(10) := '293F622E6F7074696F6E732E68696464656E436F6C732E73706C697428222C22293A5B5D2C73656172636861626C65436F6C733A28622E6F7074696F6E732E73656172636861626C65436F6C73293F622E6F7074696F6E732E73656172636861626C6543';
wwv_flow_api.g_varchar2_table(11) := '6F6C732E73706C697428222C22293A5B5D2C6D617046726F6D436F6C733A28622E6F7074696F6E732E6D617046726F6D436F6C73293F622E6F7074696F6E732E6D617046726F6D436F6C732E73706C697428222C22293A5B5D2C6D6170546F4974656D73';
wwv_flow_api.g_varchar2_table(12) := '3A28622E6F7074696F6E732E6D6170546F4974656D73293F622E6F7074696F6E732E6D6170546F4974656D732E73706C697428222C22293A5B5D2C626F64794B65794D6F64653A22534541524348222C64697361626C65643A66616C73652C666F637573';
wwv_flow_api.g_varchar2_table(13) := '4F6E436C6F73653A22425554544F4E222C454E54455241424C455F524553545249435445443A22454E54455241424C455F52455354524943544544222C454E54455241424C455F554E524553545249435445443A22454E54455241424C455F554E524553';
wwv_flow_api.g_varchar2_table(14) := '54524943544544222C6C617374446973706C617956616C75653A22222C6368616E676550726F7061676174696F6E416C6C6F7765643A66616C73657D3B696628622E6F7074696F6E732E6465627567297B617065782E646562756728222E2E2E50726976';
wwv_flow_api.g_varchar2_table(15) := '6174652056616C75657322293B666F72286E616D6520696E20622E5F76616C756573297B617065782E646562756728222E2E2E2E2E2E222B6E616D652B273A2022272B622E5F76616C7565735B6E616D655D2B272227297D7D622E5F656C656D656E7473';
wwv_flow_api.g_varchar2_table(16) := '3D7B246974656D486F6C6465723A7B7D2C2477696E646F773A7B7D2C2468696464656E496E7075743A7B7D2C24646973706C6179496E7075743A7B7D2C246C6162656C3A7B7D2C246669656C647365743A7B7D2C24636C656172427574746F6E3A7B7D2C';
wwv_flow_api.g_varchar2_table(17) := '246F70656E427574746F6E3A7B7D2C246F757465724469616C6F673A7B7D2C246469616C6F673A7B7D2C24627574746F6E436F6E7461696E65723A7B7D2C24736561726368436F6E7461696E65723A7B7D2C24706167696E6174696F6E436F6E7461696E';
wwv_flow_api.g_varchar2_table(18) := '65723A7B7D2C24636F6C756D6E53656C6563743A7B7D2C2466696C7465723A7B7D2C24676F427574746F6E3A7B7D2C2470726576427574746F6E3A7B7D2C24706167696E6174696F6E446973706C61793A7B7D2C246E657874427574746F6E3A7B7D2C24';
wwv_flow_api.g_varchar2_table(19) := '777261707065723A7B7D2C247461626C653A7B7D2C246E6F646174613A7B7D2C246D6F7265526F77733A7B7D2C2473656C6563746564526F773A7B7D2C24616374696F6E6C657373466F6375733A7B7D7D3B696628622E6F7074696F6E732E6465627567';
wwv_flow_api.g_varchar2_table(20) := '297B617065782E646562756728222E2E2E43617368656420456C656D656E747322293B666F72286E616D6520696E20622E5F656C656D656E7473297B617065782E646562756728222E2E2E2E2E2E222B6E616D652B273A2022272B622E5F656C656D656E';
wwv_flow_api.g_varchar2_table(21) := '74735B6E616D655D2B272227297D7D7D2C5F6372656174653A66756E6374696F6E28297B76617220643D746869733B76617220673B76617220633B76617220663B76617220683B76617220623B76617220653B696628642E6F7074696F6E732E64656275';
wwv_flow_api.g_varchar2_table(22) := '67297B617065782E646562756728225375706572204C4F56202D20496E697469616C697A652028222B6128642E656C656D656E74292E617474722822696422292B222922293B617065782E646562756728222E2E2E4F7074696F6E7322293B666F72286E';
wwv_flow_api.g_varchar2_table(23) := '616D6520696E20642E6F7074696F6E73297B617065782E646562756728222E2E2E2E2E2E222B6E616D652B273A2022272B642E6F7074696F6E735B6E616D655D2B272227297D7D642E5F6372656174655072697661746553746F7261676528293B642E5F';
wwv_flow_api.g_varchar2_table(24) := '76616C7565732E617065784974656D49643D6128642E656C656D656E74292E617474722822696422293B642E5F76616C7565732E636F6E74726F6C7349643D642E5F76616C7565732E617065784974656D49642B225F6669656C64736574223B642E5F69';
wwv_flow_api.g_varchar2_table(25) := '6E697442617365456C656D656E747328293B642E5F76616C7565732E6C617374446973706C617956616C75653D642E5F656C656D656E74732E24646973706C6179496E7075742E76616C28293B633D642E5F656C656D656E74732E24646973706C617949';
wwv_flow_api.g_varchar2_table(26) := '6E7075742E63737328226261636B67726F756E642D636F6C6F7222293B663D642E5F656C656D656E74732E24646973706C6179496E7075742E63737328226261636B67726F756E642D696D61676522293B683D642E5F656C656D656E74732E2464697370';
wwv_flow_api.g_varchar2_table(27) := '6C6179496E7075742E63737328226261636B67726F756E642D72657065617422293B623D642E5F656C656D656E74732E24646973706C6179496E7075742E63737328226261636B67726F756E642D6174746163686D656E7422293B653D642E5F656C656D';
wwv_flow_api.g_varchar2_table(28) := '656E74732E24646973706C6179496E7075742E63737328226261636B67726F756E642D706F736974696F6E22293B642E5F656C656D656E74732E246669656C647365742E637373287B226261636B67726F756E642D636F6C6F72223A632C226261636B67';
wwv_flow_api.g_varchar2_table(29) := '726F756E642D696D616765223A662C226261636B67726F756E642D726570656174223A682C226261636B67726F756E642D6174746163686D656E74223A622C226261636B67726F756E642D706F736974696F6E223A657D293B642E5F656C656D656E7473';
wwv_flow_api.g_varchar2_table(30) := '2E246F70656E427574746F6E2E627574746F6E287B746578743A66616C73652C6C6162656C3A224F70656E204469616C6F67222C69636F6E733A7B7072696D6172793A2275692D69636F6E2D636972636C652D747269616E676C652D6E227D7D292E6373';
wwv_flow_api.g_varchar2_table(31) := '732822686569676874222C642E5F656C656D656E74732E24646973706C6179496E7075742E6F75746572486569676874287472756529292E62696E642822636C69636B222C7B7569773A647D2C642E5F68616E646C654F70656E436C69636B293B642E5F';
wwv_flow_api.g_varchar2_table(32) := '656C656D656E74732E24636C656172427574746F6E2E627574746F6E287B746578743A66616C73652C6C6162656C3A22436C65617220436F6E74656E7473222C69636F6E733A7B7072696D6172793A2275692D69636F6E2D636972636C652D636C6F7365';
wwv_flow_api.g_varchar2_table(33) := '227D7D292E6373732822686569676874222C642E5F656C656D656E74732E24646973706C6179496E7075742E6F75746572486569676874287472756529292E62696E642822636C69636B222C7B7569773A647D2C642E5F68616E646C65436C656172436C';
wwv_flow_api.g_varchar2_table(34) := '69636B292E706172656E7428292E627574746F6E73657428293B642E5F656C656D656E74732E24636C656172427574746F6E2E72656D6F7665436C617373282275692D636F726E65722D6C65667422293B642E5F656C656D656E74732E24646973706C61';
wwv_flow_api.g_varchar2_table(35) := '79496E7075742E62696E6428226170657872656672657368222C66756E6374696F6E28297B642E5F7265667265736828297D293B696628642E6F7074696F6E732E656E74657261626C653D3D3D642E5F76616C7565732E454E54455241424C455F524553';
wwv_flow_api.g_varchar2_table(36) := '545249435445447C7C642E6F7074696F6E732E656E74657261626C653D3D3D642E5F76616C7565732E454E54455241424C455F554E52455354524943544544297B642E5F656C656D656E74732E24646973706C6179496E7075742E62696E6428226B6579';
wwv_flow_api.g_varchar2_table(37) := '646F776E222C7B7569773A647D2C642E5F68616E646C65456E74657261626C654B6579646F776E292E62696E642822626C7572222C7B7569773A647D2C642E5F68616E646C65456E74657261626C65426C7572297D696628642E6F7074696F6E732E6465';
wwv_flow_api.g_varchar2_table(38) := '70656E64696E674F6E53656C6563746F72297B6128642E6F7074696F6E732E646570656E64696E674F6E53656C6563746F72292E62696E6428226368616E6765222C66756E6374696F6E28297B642E5F656C656D656E74732E24646973706C6179496E70';
wwv_flow_api.g_varchar2_table(39) := '75742E747269676765722822617065787265667265736822297D297D617065782E7769646765742E696E6974506167654974656D28642E5F656C656D656E74732E24646973706C6179496E7075742E617474722822696422292C7B73657456616C75653A';
wwv_flow_api.g_varchar2_table(40) := '66756E6374696F6E286B2C6A297B642E5F656C656D656E74732E2468696464656E496E7075742E76616C286B293B642E5F656C656D656E74732E24646973706C6179496E7075742E76616C286A293B642E5F76616C7565732E6C617374446973706C6179';
wwv_flow_api.g_varchar2_table(41) := '56616C75653D6A7D2C67657456616C75653A66756E6374696F6E28297B72657475726E20642E5F656C656D656E74732E2468696464656E496E7075742E76616C28297D2C73686F773A66756E6374696F6E28297B642E73686F7728297D2C686964653A66';
wwv_flow_api.g_varchar2_table(42) := '756E6374696F6E28297B642E6869646528297D2C656E61626C653A66756E6374696F6E28297B642E656E61626C6528297D2C64697361626C653A66756E6374696F6E28297B642E64697361626C6528297D7D297D2C5F696E697442617365456C656D656E';
wwv_flow_api.g_varchar2_table(43) := '74733A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20496E697469616C697A65204261736520456C656D656E74732028222B622E5F';
wwv_flow_api.g_varchar2_table(44) := '76616C7565732E617065784974656D49642B222922297D622E5F656C656D656E74732E246974656D486F6C6465723D6128227461626C6523222B622E5F76616C7565732E617065784974656D49642B225F686F6C64657222293B622E5F656C656D656E74';
wwv_flow_api.g_varchar2_table(45) := '732E2468696464656E496E7075743D61282223222B622E5F76616C7565732E617065784974656D49642B225F48494444454E56414C554522293B622E5F656C656D656E74732E24646973706C6179496E7075743D622E656C656D656E743B622E5F656C65';
wwv_flow_api.g_varchar2_table(46) := '6D656E74732E246C6162656C3D6128276C6162656C5B666F723D22272B622E5F76616C7565732E617065784974656D49642B27225D27293B622E5F656C656D656E74732E246669656C647365743D61282223222B622E5F76616C7565732E636F6E74726F';
wwv_flow_api.g_varchar2_table(47) := '6C734964293B622E5F656C656D656E74732E24636C656172427574746F6E3D61282223222B622E5F76616C7565732E636F6E74726F6C7349642B2220627574746F6E2E73757065726C6F762D6D6F64616C2D64656C65746522293B622E5F656C656D656E';
wwv_flow_api.g_varchar2_table(48) := '74732E246F70656E427574746F6E3D61282223222B622E5F76616C7565732E636F6E74726F6C7349642B2220627574746F6E2E73757065726C6F762D6D6F64616C2D6F70656E22297D2C5F696E6974456C656D656E74733A66756E6374696F6E28297B76';
wwv_flow_api.g_varchar2_table(49) := '617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20496E697469616C697A6520456C656D656E74732028222B622E5F76616C7565732E617065784974656D49642B2229';
wwv_flow_api.g_varchar2_table(50) := '22297D622E5F656C656D656E74732E2477696E646F773D612877696E646F77293B622E5F656C656D656E74732E246F757465724469616C6F673D6128226469762E73757065726C6F762D6469616C6F6722293B622E5F656C656D656E74732E246469616C';
wwv_flow_api.g_varchar2_table(51) := '6F673D6128226469762E73757065726C6F762D636F6E7461696E657222293B622E5F656C656D656E74732E24627574746F6E436F6E7461696E65723D6128226469762E73757065726C6F762D627574746F6E2D636F6E7461696E657222293B622E5F656C';
wwv_flow_api.g_varchar2_table(52) := '656D656E74732E24736561726368436F6E7461696E65723D6128226469762E73757065726C6F762D7365617263682D636F6E7461696E657222293B622E5F656C656D656E74732E24706167696E6174696F6E436F6E7461696E65723D6128226469762E73';
wwv_flow_api.g_varchar2_table(53) := '757065726C6F762D706167696E6174696F6E2D636F6E7461696E657222293B622E5F656C656D656E74732E24636F6C756D6E53656C6563743D61282273656C6563742373757065726C6F762D636F6C756D6E2D73656C65637422293B622E5F656C656D65';
wwv_flow_api.g_varchar2_table(54) := '6E74732E2466696C7465723D612822696E7075742373757065726C6F762D66696C74657222293B622E5F656C656D656E74732E24736561726368427574746F6E3D6128226469762E73757065726C6F762D7365617263682D69636F6E22293B622E5F656C';
wwv_flow_api.g_varchar2_table(55) := '656D656E74732E2470726576427574746F6E3D612822627574746F6E2373757065726C6F762D707265762D7061676522293B622E5F656C656D656E74732E24706167696E6174696F6E446973706C61793D6128227370616E2373757065726C6F762D7061';
wwv_flow_api.g_varchar2_table(56) := '67696E6174696F6E2D646973706C617922293B622E5F656C656D656E74732E246E657874427574746F6E3D612822627574746F6E2373757065726C6F762D6E6578742D7061676522293B622E5F656C656D656E74732E24777261707065723D6128226469';
wwv_flow_api.g_varchar2_table(57) := '762E73757065726C6F762D7461626C652D7772617070657222293B622E5F656C656D656E74732E24616374696F6E6C657373466F6375733D6128222373757065726C6F762D666F63757361626C6522297D2C5F696E69745472616E7369656E74456C656D';
wwv_flow_api.g_varchar2_table(58) := '656E74733A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20496E697469616C697A65205472616E7369656E7420456C656D656E7473';
wwv_flow_api.g_varchar2_table(59) := '2028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F656C656D656E74732E247461626C653D6128227461626C652E73757065726C6F762D7461626C6522293B622E5F656C656D656E74732E246E6F646174613D6128226469';
wwv_flow_api.g_varchar2_table(60) := '762E73757065726C6F762D6E6F6461746122293B622E5F656C656D656E74732E246D6F7265526F77733D612822696E7075742361736C2D73757065722D6C6F762D6D6F72652D726F777322297D2C5F696E6974427574746F6E733A66756E6374696F6E28';
wwv_flow_api.g_varchar2_table(61) := '297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20496E697469616C697A6520427574746F6E732028222B622E5F76616C7565732E617065784974656D49642B';
wwv_flow_api.g_varchar2_table(62) := '222922297D622E5F656C656D656E74732E24736561726368427574746F6E2E62696E642822636C69636B222C7B7569773A627D2C622E5F68616E646C65536561726368427574746F6E436C69636B293B622E5F656C656D656E74732E2470726576427574';
wwv_flow_api.g_varchar2_table(63) := '746F6E2E627574746F6E287B746578743A66616C73652C69636F6E733A7B7072696D6172793A2275692D69636F6E2D6172726F77746869636B2D312D77227D7D292E62696E642822636C69636B222C7B7569773A627D2C622E5F68616E646C6550726576';
wwv_flow_api.g_varchar2_table(64) := '427574746F6E436C69636B293B622E5F656C656D656E74732E246E657874427574746F6E2E627574746F6E287B746578743A66616C73652C69636F6E733A7B7072696D6172793A2275692D69636F6E2D6172726F77746869636B2D312D65227D7D292E62';
wwv_flow_api.g_varchar2_table(65) := '696E642822636C69636B222C7B7569773A627D2C622E5F68616E646C654E657874427574746F6E436C69636B297D2C5F696E6974436F6C756D6E53656C6563743A66756E6374696F6E28297B76617220633D746869733B76617220643D632E5F656C656D';
wwv_flow_api.g_varchar2_table(66) := '656E74732E24636F6C756D6E53656C6563742E6765742830293B76617220623D313B696628632E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20496E697469616C697A6520436F6C756D6E2053656C65';
wwv_flow_api.g_varchar2_table(67) := '63742028222B632E5F76616C7565732E617065784974656D49642B222922297D666F7228783D303B783C632E6F7074696F6E732E7265706F7274486561646572732E6C656E6774683B782B2B297B69662821632E5F697348696464656E436F6C28782B31';
wwv_flow_api.g_varchar2_table(68) := '292626632E5F697353656172636861626C65436F6C28782B3129297B642E6F7074696F6E735B625D3D6E6577204F7074696F6E28632E6F7074696F6E732E7265706F7274486561646572735B785D2C782B31293B622B3D317D7D61282773656C65637423';
wwv_flow_api.g_varchar2_table(69) := '73757065726C6F762D636F6C756D6E2D73656C656374206F7074696F6E5B76616C75653D22272B632E6F7074696F6E732E646973706C6179436F6C4E756D2B27225D27292E61747472282273656C6563746564222C2273656C656374656422297D2C5F68';
wwv_flow_api.g_varchar2_table(70) := '616E646C65436F6C756D6E4368616E67653A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2048616E646C6520436F6C756D6E204368';
wwv_flow_api.g_varchar2_table(71) := '616E67652028222B622E5F76616C7565732E617065784974656D49642B222922297D696628622E5F656C656D656E74732E24636F6C756D6E53656C6563742E76616C2829297B622E5F656C656D656E74732E2466696C7465722E72656D6F766541747472';
wwv_flow_api.g_varchar2_table(72) := '282264697361626C656422297D656C73657B622E5F656C656D656E74732E2466696C7465722E76616C282222292E61747472282264697361626C6564222C2264697361626C656422297D622E5F7570646174655374796C656446696C74657228297D2C5F';
wwv_flow_api.g_varchar2_table(73) := '69654E6F53656C656374546578743A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D204945204E6F2053656C65637420546578742028';
wwv_flow_api.g_varchar2_table(74) := '222B622E5F76616C7565732E617065784974656D49642B222922297D696628646F63756D656E742E6174746163684576656E74297B6128226469762E73757065726C6F762D7461626C652D77726170706572202A22292E656163682866756E6374696F6E';
wwv_flow_api.g_varchar2_table(75) := '28297B612874686973295B305D2E6174746163684576656E7428226F6E73656C6563747374617274222C66756E6374696F6E28297B72657475726E2066616C73657D297D297D7D2C5F697348696464656E436F6C3A66756E6374696F6E2863297B766172';
wwv_flow_api.g_varchar2_table(76) := '20643D746869733B76617220623D66616C73653B696628642E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2049732048696464656E20436F6C756D6E2028222B642E5F76616C7565732E617065784974';
wwv_flow_api.g_varchar2_table(77) := '656D49642B222922297D666F7228693D303B693C642E5F76616C7565732E68696464656E436F6C732E6C656E6774683B692B2B297B6966287061727365496E7428632C3130293D3D3D7061727365496E7428642E5F76616C7565732E68696464656E436F';
wwv_flow_api.g_varchar2_table(78) := '6C735B695D2C313029297B623D747275653B627265616B7D7D72657475726E20627D2C5F697353656172636861626C65436F6C3A66756E6374696F6E2863297B76617220643D746869733B76617220623D66616C73653B696628642E6F7074696F6E732E';
wwv_flow_api.g_varchar2_table(79) := '6465627567297B617065782E646562756728225375706572204C4F56202D2049732053656172636861626C6520436F6C756D6E2028222B642E5F76616C7565732E617065784974656D49642B222922297D696628642E5F76616C7565732E736561726368';
wwv_flow_api.g_varchar2_table(80) := '61626C65436F6C732E6C656E677468297B666F7228693D303B693C642E5F76616C7565732E73656172636861626C65436F6C732E6C656E6774683B692B2B297B6966287061727365496E7428632C3130293D3D3D7061727365496E7428642E5F76616C75';
wwv_flow_api.g_varchar2_table(81) := '65732E73656172636861626C65436F6C735B695D2C313029297B623D747275653B627265616B7D7D7D656C73657B623D747275657D72657475726E20627D2C5F73686F774469616C6F673A66756E6374696F6E28297B766172206A3D746869733B766172';
wwv_flow_api.g_varchar2_table(82) := '206D3B76617220623B76617220683B6966286A2E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2053686F77204469616C6F672028222B6A2E5F76616C7565732E617065784974656D49642B222922297D';
wwv_flow_api.g_varchar2_table(83) := '683D273C64697620636C6173733D2273757065726C6F762D636F6E7461696E65722075692D776964676574223E5C6E2020203C64697620636C6173733D2273757065726C6F762D627574746F6E2D636F6E7461696E65722075692D7769646765742D6865';
wwv_flow_api.g_varchar2_table(84) := '616465722075692D636F726E65722D616C6C2075692D68656C7065722D636C656172666978223E5C6E2020202020203C64697620636C6173733D2273757065726C6F762D7365617263682D636F6E7461696E6572223E5C6E2020202020202020203C7461';
wwv_flow_api.g_varchar2_table(85) := '626C653E5C6E2020202020202020202020203C74723E5C6E2020202020202020202020202020203C74642076616C69676E3D226D6964646C65223E5C6E2020202020202020202020202020202020205365617263683C612069643D2273757065726C6F76';
wwv_flow_api.g_varchar2_table(86) := '2D666F63757361626C652220687265663D222322207374796C653D22746578742D6465636F726174696F6E3A206E6F6E653B223E266E6273703B3C2F613E5C6E2020202020202020202020202020203C2F74643E5C6E2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(87) := '203C74642076616C69676E3D226D6964646C65223E5C6E2020202020202020202020202020202020203C73656C6563742069643D2273757065726C6F762D636F6C756D6E2D73656C656374222073697A653D2231223E5C6E202020202020202020202020';
wwv_flow_api.g_varchar2_table(88) := '2020202020202020203C6F7074696F6E2076616C75653D22223E2D2053656C65637420436F6C756D6E202D3C2F6F7074696F6E3E5C6E2020202020202020202020202020202020203C2F73656C6563743E5C6E2020202020202020202020202020203C2F';
wwv_flow_api.g_varchar2_table(89) := '74643E5C6E2020202020202020202020202020203C74643E5C6E2020202020202020202020202020202020203C6469762069643D2273757065726C6F765F7374796C65645F66696C7465722220636C6173733D2275692D636F726E65722D616C6C223E5C';
wwv_flow_api.g_varchar2_table(90) := '6E2020202020202020202020202020202020202020203C7461626C653E5C6E2020202020202020202020202020202020202020202020203C74626F64793E5C6E2020202020202020202020202020202020202020202020202020203C74723E5C6E202020';
wwv_flow_api.g_varchar2_table(91) := '2020202020202020202020202020202020202020202020202020203C74643E5C6E2020202020202020202020202020202020202020202020202020202020202020203C696E70757420747970653D2274657874222069643D2273757065726C6F762D6669';
wwv_flow_api.g_varchar2_table(92) := '6C7465722220636C6173733D2275692D636F726E65722D616C6C222F3E5C6E2020202020202020202020202020202020202020202020202020202020203C2F74643E5C6E2020202020202020202020202020202020202020202020202020202020203C74';
wwv_flow_api.g_varchar2_table(93) := '643E5C6E2020202020202020202020202020202020202020202020202020202020202020203C64697620636C6173733D2275692D73746174652D686967686C696768742073757065726C6F762D7365617263682D69636F6E223E3C7370616E20636C6173';
wwv_flow_api.g_varchar2_table(94) := '733D2275692D69636F6E2075692D69636F6E2D636972636C652D7A6F6F6D696E223E3C2F7370616E3E3C2F6469763E5C6E2020202020202020202020202020202020202020202020202020202020203C2F74643E5C6E2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(95) := '202020202020202020202020203C2F74723E5C6E2020202020202020202020202020202020202020202020203C2F74626F64793E5C6E2020202020202020202020202020202020202020203C2F7461626C653E5C6E202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(96) := '2020203C2F6469763E5C6E2020202020202020202020202020203C2F74643E5C6E2020202020202020202020203C2F74723E5C6E2020202020202020203C2F7461626C653E5C6E2020202020203C2F6469763E5C6E2020202020203C64697620636C6173';
wwv_flow_api.g_varchar2_table(97) := '733D2273757065726C6F762D706167696E6174696F6E2D636F6E7461696E6572223E5C6E2020202020202020203C7461626C653E5C6E2020202020202020202020203C74723E5C6E2020202020202020202020202020203C74642076616C69676E3D226D';
wwv_flow_api.g_varchar2_table(98) := '6964646C65223E5C6E2020202020202020202020202020202020203C627574746F6E2069643D2273757065726C6F762D707265762D70616765223E50726576696F757320506167653C2F627574746F6E3E5C6E2020202020202020202020202020203C2F';
wwv_flow_api.g_varchar2_table(99) := '74643E5C6E2020202020202020202020202020203C74642076616C69676E3D226D6964646C65223E5C6E2020202020202020202020202020202020203C7370616E2069643D2273757065726C6F762D706167696E6174696F6E2D646973706C6179223E50';
wwv_flow_api.g_varchar2_table(100) := '61676520313C2F7370616E3E5C6E2020202020202020202020202020203C2F74643E5C6E2020202020202020202020202020203C74642076616C69676E3D226D6964646C65223E5C6E2020202020202020202020202020202020203C627574746F6E2069';
wwv_flow_api.g_varchar2_table(101) := '643D2273757065726C6F762D6E6578742D70616765223E4E65787420506167653C2F627574746F6E3E5C6E2020202020202020202020202020203C2F74643E5C6E2020202020202020202020203C2F74723E5C6E2020202020202020203C2F7461626C65';
wwv_flow_api.g_varchar2_table(102) := '3E5C6E2020202020203C2F6469763E5C6E2020203C2F6469763E5C6E2020202020203C64697620636C6173733D2273757065726C6F762D7461626C652D77726170706572223E5C6E2020202020202020203C696D672069643D2273757065726C6F762D6C';
wwv_flow_api.g_varchar2_table(103) := '6F6164696E672D696D61676522207372633D22272B6A2E6F7074696F6E732E6C6F6164696E67496D6167655372632B27223E5C6E2020203C2F6469763E5C6E3C2F6469763E5C6E273B612822626F647922292E617070656E642868293B6A2E5F696E6974';
wwv_flow_api.g_varchar2_table(104) := '456C656D656E747328293B6A2E5F76616C7565732E706167696E6174696F6E3D22313A222B6A2E6F7074696F6E732E6D6178526F7773506572506167653B6A2E5F76616C7565732E637572506167653D313B6A2E5F696E6974427574746F6E7328293B6A';
wwv_flow_api.g_varchar2_table(105) := '2E5F696E6974436F6C756D6E53656C65637428293B6A2E5F656C656D656E74732E24636F6C756D6E53656C6563742E62696E6428226368616E6765222C66756E6374696F6E28297B6A2E5F68616E646C65436F6C756D6E4368616E676528297D293B6A2E';
wwv_flow_api.g_varchar2_table(106) := '5F656C656D656E74732E2466696C7465722E62696E642822666F637573222C7B7569773A6A7D2C6A2E5F68616E646C6546696C746572466F637573293B76617220633D6A2E5F656C656D656E74732E2466696C7465722E6373732822626F726465722D74';
wwv_flow_api.g_varchar2_table(107) := '6F702D636F6C6F7222293B766172206E3D6A2E5F656C656D656E74732E2466696C7465722E6373732822626F726465722D746F702D776964746822293B766172206C3D6A2E5F656C656D656E74732E2466696C7465722E6373732822626F726465722D74';
wwv_flow_api.g_varchar2_table(108) := '6F702D7374796C6522293B76617220673D6A2E5F656C656D656E74732E2466696C7465722E63737328226261636B67726F756E642D636F6C6F7222293B76617220663D6A2E5F656C656D656E74732E2466696C7465722E63737328226261636B67726F75';
wwv_flow_api.g_varchar2_table(109) := '6E642D696D61676522293B766172206B3D6A2E5F656C656D656E74732E2466696C7465722E63737328226261636B67726F756E642D72657065617422293B76617220653D6A2E5F656C656D656E74732E2466696C7465722E63737328226261636B67726F';
wwv_flow_api.g_varchar2_table(110) := '756E642D6174746163686D656E7422293B76617220643D6A2E5F656C656D656E74732E2466696C7465722E63737328226261636B67726F756E642D706F736974696F6E22293B69662828612E62726F777365722E6D7369657C7C612E62726F777365722E';
wwv_flow_api.g_varchar2_table(111) := '7765626B697429262663213D3D226E6F6E6522297B633D2223616161616161223B696628612E62726F777365722E6D73696526266C3D3D3D226E6F6E6522297B6C3D22696E736574227D7D6A2E5F656C656D656E74732E2466696C7465722E6373732822';
wwv_flow_api.g_varchar2_table(112) := '626F72646572222C226E6F6E6522293B6128222373757065726C6F765F7374796C65645F66696C74657222292E637373287B22626F726465722D636F6C6F72223A632C22626F726465722D7769647468223A6E2C22626F726465722D7374796C65223A6C';
wwv_flow_api.g_varchar2_table(113) := '2C226261636B67726F756E642D636F6C6F72223A672C226261636B67726F756E642D696D616765223A662C226261636B67726F756E642D726570656174223A6B2C226261636B67726F756E642D6174746163686D656E74223A652C226261636B67726F75';
wwv_flow_api.g_varchar2_table(114) := '6E642D706F736974696F6E223A647D293B6A2E5F64697361626C65536561726368427574746F6E28293B6A2E5F64697361626C6550726576427574746F6E28293B6A2E5F64697361626C654E657874427574746F6E28293B6D3D6A2E5F656C656D656E74';
wwv_flow_api.g_varchar2_table(115) := '732E24736561726368436F6E7461696E65722E776964746828292B6A2E5F656C656D656E74732E24706167696E6174696F6E436F6E7461696E65722E776964746828293B6A2E5F656C656D656E74732E24627574746F6E436F6E7461696E65722E637373';
wwv_flow_api.g_varchar2_table(116) := '28227769647468222C6D2B31302B22707822293B623D6A2E5F656C656D656E74732E24627574746F6E436F6E7461696E65722E68656967687428293B6A2E5F656C656D656E74732E24706167696E6174696F6E436F6E7461696E65722E63737328226865';
wwv_flow_api.g_varchar2_table(117) := '69676874222C622B22707822293B6A2E5F656C656D656E74732E24736561726368436F6E7461696E65722E6373732822686569676874222C622B22707822293B6A2E5F656C656D656E74732E246469616C6F672E6469616C6F67287B64697361626C6564';
wwv_flow_api.g_varchar2_table(118) := '3A66616C73652C6175746F4F70656E3A66616C73652C636C6F73654F6E4573636170653A747275652C636C6F7365546578743A22436C6F7365222C6469616C6F67436C6173733A2273757065726C6F762D6469616C6F67222C647261676761626C653A74';
wwv_flow_api.g_varchar2_table(119) := '7275652C6865696768743A226175746F222C686964653A6E756C6C2C6D61784865696768743A66616C73652C6D617857696474683A66616C73652C6D696E4865696768743A3135302C6D696E57696474683A66616C73652C6D6F64616C3A747275652C72';
wwv_flow_api.g_varchar2_table(120) := '6573697A61626C653A66616C73652C73686F773A6E756C6C2C737461636B3A747275652C7469746C653A6A2E6F7074696F6E732E6469616C6F675469746C652C6F70656E3A66756E6374696F6E28297B6A2E5F656C656D656E74732E2466696C7465722E';
wwv_flow_api.g_varchar2_table(121) := '747269676765722822666F63757322293B6966286A2E5F76616C7565732E66657463684C6F764D6F64653D3D3D224449414C4F4722297B6A2E5F66657463684C6F7628297D656C73657B6966286A2E5F76616C7565732E66657463684C6F764D6F64653D';
wwv_flow_api.g_varchar2_table(122) := '3D3D22454E54455241424C4522297B6A2E5F656C656D656E74732E2466696C7465722E76616C286A2E5F76616C7565732E736561726368537472696E67297D7D6A2E5F76616C7565732E66657463684C6F764D6F64653D224449414C4F47223B69662861';
wwv_flow_api.g_varchar2_table(123) := '2E62726F777365722E6D736965297B6A2E5F656C656D656E74732E246469616C6F672E6373732822686569676874222C226175746F22297D7D2C636C6F73653A66756E6374696F6E28297B612822626F647922292E756E62696E6428226B6579646F776E';
wwv_flow_api.g_varchar2_table(124) := '222C6A2E5F68616E646C65426F64794B6579646F776E293B6128646F63756D656E74292E756E62696E6428226B6579646F776E222C6A2E5F64697361626C654172726F774B65795363726F6C6C696E67293B6128227461626C652E73757065726C6F762D';
wwv_flow_api.g_varchar2_table(125) := '7461626C652074626F647920747222292E64696528293B6A2E5F76616C7565732E66657463684C6F76496E50726F636573733D66616C73653B612874686973292E6469616C6F67282264657374726F7922293B6A2E5F656C656D656E74732E246469616C';
wwv_flow_api.g_varchar2_table(126) := '6F672E72656D6F766528293B6966286A2E5F76616C7565732E666F6375734F6E436C6F73653D3D3D22425554544F4E22297B6A2E5F656C656D656E74732E246F70656E427574746F6E2E666F63757328297D656C73657B6966286A2E5F76616C7565732E';
wwv_flow_api.g_varchar2_table(127) := '666F6375734F6E436C6F73653D3D3D22494E50555422297B6A2E5F656C656D656E74732E24646973706C6179496E7075742E666F63757328297D7D6966286A2E5F656C656D656E74732E24646973706C6179496E7075742E76616C28293D3D3D2222297B';
wwv_flow_api.g_varchar2_table(128) := '6A2E616C6C6F774368616E676550726F7061676174696F6E28293B6A2E5F656C656D656E74732E2468696464656E496E7075742E7472696767657228226368616E676522293B6A2E5F656C656D656E74732E24646973706C6179496E7075742E74726967';
wwv_flow_api.g_varchar2_table(129) := '67657228226368616E676522293B6A2E70726576656E744368616E676550726F7061676174696F6E28297D6A2E5F76616C7565732E666F6375734F6E436C6F73653D22425554544F4E227D7D293B6A2E5F696E6974456C656D656E747328293B6A2E5F65';
wwv_flow_api.g_varchar2_table(130) := '6C656D656E74732E246469616C6F672E63737328226F766572666C6F77222C2268696464656E22293B6A2E5F656C656D656E74732E246F757465724469616C6F672E63737328226D696E2D7769647468222C6D2B34322B22707822293B6A2E5F76616C75';
wwv_flow_api.g_varchar2_table(131) := '65732E6469616C6F67546F703D6A2E5F656C656D656E74732E2477696E646F772E68656967687428292A302E30353B6A2E5F76616C7565732E6469616C6F674C6566743D286A2E5F656C656D656E74732E2477696E646F772E776964746828292F32292D';
wwv_flow_api.g_varchar2_table(132) := '286A2E5F656C656D656E74732E246F757465724469616C6F672E6F7574657257696474682874727565292F32293B6966286A2E5F76616C7565732E6469616C6F674C6566743C30297B6A2E5F76616C7565732E6469616C6F674C6566743D307D6A2E5F65';
wwv_flow_api.g_varchar2_table(133) := '6C656D656E74732E246469616C6F672E6469616C6F6728226F7074696F6E222C22706F736974696F6E222C5B6A2E5F76616C7565732E6469616C6F674C6566742C6A2E5F76616C7565732E6469616C6F67546F705D293B6A2E5F69654E6F53656C656374';
wwv_flow_api.g_varchar2_table(134) := '5465787428293B612822626F647922292E62696E6428226B6579646F776E222C7B7569773A6A7D2C6A2E5F68616E646C65426F64794B6579646F776E293B6128646F63756D656E74292E62696E6428226B6579646F776E222C7B7569773A6A7D2C6A2E5F';
wwv_flow_api.g_varchar2_table(135) := '64697361626C654172726F774B65795363726F6C6C696E67293B6128227461626C652E73757065726C6F762D7461626C652074626F647920747222292E6C69766528226D6F757365656E746572222C7B7569773A6A7D2C6A2E5F68616E646C654D61696E';
wwv_flow_api.g_varchar2_table(136) := '54724D6F757365656E746572292E6C69766528226D6F7573656C65617665222C7B7569773A6A7D2C6A2E5F68616E646C654D61696E54724D6F7573656C65617665292E6C6976652822636C69636B222C7B7569773A6A7D2C6A2E5F68616E646C654D6169';
wwv_flow_api.g_varchar2_table(137) := '6E5472436C69636B293B6A2E5F656C656D656E74732E2477696E646F772E62696E642822726573697A65222C7B7569773A6A7D2C6A2E5F68616E646C6557696E646F77526573697A65293B6A2E5F656C656D656E74732E246469616C6F672E6469616C6F';
wwv_flow_api.g_varchar2_table(138) := '6728226F70656E22297D2C5F68616E646C6557696E646F77526573697A653A66756E6374696F6E2864297B76617220633D642E646174612E7569773B76617220623B696628632E6F7074696F6E732E6465627567297B617065782E646562756728225375';
wwv_flow_api.g_varchar2_table(139) := '706572204C4F56202D2048616E646C652057696E646F7720526573697A652028222B632E5F76616C7565732E617065784974656D49642B222922297D69662821632E5F656C656D656E74732E247461626C652E6C656E677468262621632E5F656C656D65';
wwv_flow_api.g_varchar2_table(140) := '6E74732E246E6F646174612E6C656E677468297B632E5F696E69745472616E7369656E74456C656D656E747328297D632E5F7570646174654C6F764D6561737572656D656E747328293B632E5F656C656D656E74732E246F757465724469616C6F672E63';
wwv_flow_api.g_varchar2_table(141) := '7373287B6865696768743A632E5F76616C7565732E6469616C6F674865696768742C77696474683A632E5F76616C7565732E6469616C6F6757696474687D293B632E5F656C656D656E74732E24777261707065722E637373287B6865696768743A632E5F';
wwv_flow_api.g_varchar2_table(142) := '76616C7565732E777261707065724865696768742C77696474683A632E5F76616C7565732E7772617070657257696474682C6F766572666C6F773A2268696464656E227D293B623D28632E5F656C656D656E74732E2477696E646F772E77696474682829';
wwv_flow_api.g_varchar2_table(143) := '2F32292D28632E5F656C656D656E74732E246F757465724469616C6F672E6F7574657257696474682874727565292F32293B696628623C30297B623D307D632E5F656C656D656E74732E246F757465724469616C6F672E637373287B746F703A632E5F76';
wwv_flow_api.g_varchar2_table(144) := '616C7565732E6469616C6F67546F702C6C6566743A627D293B632E5F656C656D656E74732E24777261707065722E63737328226F766572666C6F77222C226175746F22297D2C5F68616E646C65426F64794B6579646F776E3A66756E6374696F6E286729';
wwv_flow_api.g_varchar2_table(145) := '7B76617220663D672E646174612E7569773B76617220653B76617220633B76617220643B76617220623B696628662E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2048616E646C6520426F6479204B65';
wwv_flow_api.g_varchar2_table(146) := '79646F776E2028222B662E5F76616C7565732E617065784974656D49642B222922297D696628672E77686963683D3D3D3337262621662E5F656C656D656E74732E2470726576427574746F6E2E61747472282264697361626C65642229297B696628662E';
wwv_flow_api.g_varchar2_table(147) := '5F76616C7565732E626F64794B65794D6F64653D3D3D22524F5753454C45435422297B662E5F68616E646C6550726576427574746F6E436C69636B2867297D7D656C73657B696628672E77686963683D3D3D3339262621662E5F656C656D656E74732E24';
wwv_flow_api.g_varchar2_table(148) := '6E657874427574746F6E2E61747472282264697361626C65642229297B696628662E5F76616C7565732E626F64794B65794D6F64653D3D3D22524F5753454C45435422297B662E5F68616E646C654E657874427574746F6E436C69636B2867297D7D656C';
wwv_flow_api.g_varchar2_table(149) := '73657B696628672E77686963683D3D3D33382626672E746172676574213D662E5F656C656D656E74732E24636F6C756D6E53656C6563745B305D297B662E5F76616C7565732E626F64794B65794D6F64653D22524F5753454C454354223B662E5F656C65';
wwv_flow_api.g_varchar2_table(150) := '6D656E74732E24616374696F6E6C657373466F6375732E747269676765722822666F63757322293B653D662E5F656C656D656E74732E247461626C652E66696E64282274626F64793E747222292E686173282274642E75692D73746174652D686F766572';
wwv_flow_api.g_varchar2_table(151) := '22293B696628652E6C656E6774683D3D3D30297B633D662E5F656C656D656E74732E247461626C652E66696E64282274626F64793E74723A6C61737422297D656C73657B696628652E6765742830293D3D3D662E5F656C656D656E74732E247461626C65';
wwv_flow_api.g_varchar2_table(152) := '2E66696E64282274626F64793E74723A666972737422292E676574283029297B633D662E5F656C656D656E74732E247461626C652E66696E64282274626F64793E74723A6C61737422297D656C73657B633D652E7072657628297D7D652E747269676765';
wwv_flow_api.g_varchar2_table(153) := '7228226D6F7573656F757422293B632E7472696767657228226D6F7573656F76657222292E666F63757328293B643D632E706F736974696F6E28292E746F702D662E5F656C656D656E74732E24777261707065722E706F736974696F6E28292E746F703B';
wwv_flow_api.g_varchar2_table(154) := '623D7B746F703A302C626F74746F6D3A662E5F656C656D656E74732E24777261707065722E6F757465724865696768742874727565297D3B696628635B305D3D3D3D662E5F656C656D656E74732E247461626C652E66696E64282274626F64793E74723A';
wwv_flow_api.g_varchar2_table(155) := '666972737422295B305D297B662E5F656C656D656E74732E24777261707065722E7363726F6C6C546F702830297D656C73657B696628643C622E746F70297B662E5F656C656D656E74732E24777261707065722E7363726F6C6C546F7028662E5F656C65';
wwv_flow_api.g_varchar2_table(156) := '6D656E74732E24777261707065722E7363726F6C6C546F7028292B642D35297D656C73657B696628642B632E68656967687428293E622E626F74746F6D297B662E5F656C656D656E74732E24777261707065722E7363726F6C6C546F7028662E5F656C65';
wwv_flow_api.g_varchar2_table(157) := '6D656E74732E24777261707065722E7363726F6C6C546F7028292B642B632E68656967687428292D622E626F74746F6D2B35297D7D7D7D656C73657B696628672E77686963683D3D3D34302626672E746172676574213D662E5F656C656D656E74732E24';
wwv_flow_api.g_varchar2_table(158) := '636F6C756D6E53656C6563745B305D297B662E5F76616C7565732E626F64794B65794D6F64653D22524F5753454C454354223B662E5F656C656D656E74732E24616374696F6E6C657373466F6375732E747269676765722822666F63757322293B653D66';
wwv_flow_api.g_varchar2_table(159) := '2E5F656C656D656E74732E247461626C652E66696E64282274626F64793E747222292E686173282274642E75692D73746174652D686F76657222293B696628652E6C656E6774683D3D3D30297B633D662E5F656C656D656E74732E247461626C652E6669';
wwv_flow_api.g_varchar2_table(160) := '6E64282274626F64793E74723A666972737422297D656C73657B696628652E6765742830293D3D3D662E5F656C656D656E74732E247461626C652E66696E64282274626F64793E74723A6C61737422292E676574283029297B633D662E5F656C656D656E';
wwv_flow_api.g_varchar2_table(161) := '74732E247461626C652E66696E64282274626F64793E74723A666972737422297D656C73657B633D652E6E65787428297D7D652E7472696767657228226D6F7573656F757422293B632E7472696767657228226D6F7573656F76657222292E666F637573';
wwv_flow_api.g_varchar2_table(162) := '28293B643D632E706F736974696F6E28292E746F702D662E5F656C656D656E74732E24777261707065722E706F736974696F6E28292E746F703B623D7B746F703A302C626F74746F6D3A662E5F656C656D656E74732E24777261707065722E6F75746572';
wwv_flow_api.g_varchar2_table(163) := '4865696768742874727565297D3B696628635B305D3D3D3D662E5F656C656D656E74732E247461626C652E66696E64282274626F64793E74723A666972737422295B305D297B662E5F656C656D656E74732E24777261707065722E7363726F6C6C546F70';
wwv_flow_api.g_varchar2_table(164) := '2830297D656C73657B696628643C622E746F70297B662E5F656C656D656E74732E24777261707065722E7363726F6C6C546F7028662E5F656C656D656E74732E24777261707065722E7363726F6C6C546F7028292B642D35297D656C73657B696628642B';
wwv_flow_api.g_varchar2_table(165) := '632E68656967687428293E622E626F74746F6D297B662E5F656C656D656E74732E24777261707065722E7363726F6C6C546F7028662E5F656C656D656E74732E24777261707065722E7363726F6C6C546F7028292B642B632E68656967687428292D622E';
wwv_flow_api.g_varchar2_table(166) := '626F74746F6D2B35297D7D7D7D656C73657B696628672E77686963683D3D3D3133297B696628662E5F76616C7565732E626F64794B65794D6F64653D3D3D22524F5753454C454354222626672E746172676574213D662E5F656C656D656E74732E24636F';
wwv_flow_api.g_varchar2_table(167) := '6C756D6E53656C6563745B305D2626672E746172676574213D662E5F656C656D656E74732E2470726576427574746F6E5B305D2626672E746172676574213D662E5F656C656D656E74732E246E657874427574746F6E5B305D2626672E74617267657421';
wwv_flow_api.g_varchar2_table(168) := '3D662E5F656C656D656E74732E24736561726368427574746F6E5B305D297B6128222373757065726C6F762D66657463682D726573756C74733E74626F64793E747222292E686173282274642E75692D73746174652D686F76657222292E747269676765';
wwv_flow_api.g_varchar2_table(169) := '722822636C69636B22293B672E70726576656E7444656661756C7428293B72657475726E2066616C73657D656C73657B696628662E5F76616C7565732E626F64794B65794D6F64653D3D3D22534541524348222626672E746172676574213D662E5F656C';
wwv_flow_api.g_varchar2_table(170) := '656D656E74732E24646973706C6179496E7075745B305D2626672E746172676574213D662E5F656C656D656E74732E24636F6C756D6E53656C6563745B305D2626672E746172676574213D662E5F656C656D656E74732E2470726576427574746F6E5B30';
wwv_flow_api.g_varchar2_table(171) := '5D2626672E746172676574213D662E5F656C656D656E74732E246E657874427574746F6E5B305D2626672E746172676574213D662E5F656C656D656E74732E24736561726368427574746F6E5B305D297B662E5F73656172636828297D7D7D7D7D7D7D7D';
wwv_flow_api.g_varchar2_table(172) := '2C5F68616E646C654F70656E436C69636B3A66756E6374696F6E2863297B76617220623D632E646174612E7569773B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2048616E646C65204F70';
wwv_flow_api.g_varchar2_table(173) := '656E20436C69636B22297D622E5F76616C7565732E66657463684C6F764D6F64653D224449414C4F47223B622E5F76616C7565732E736561726368537472696E673D22223B622E5F73686F774469616C6F6728297D2C5F68616E646C65456E7465726162';
wwv_flow_api.g_varchar2_table(174) := '6C654B6579646F776E3A66756E6374696F6E2863297B76617220623D632E646174612E7569773B696628632E77686963683D3D3D31332626622E5F656C656D656E74732E24646973706C6179496E7075742E76616C2829213D3D622E5F76616C7565732E';
wwv_flow_api.g_varchar2_table(175) := '6C617374446973706C617956616C7565297B622E5F76616C7565732E666F6375734F6E436C6F73653D22494E505554223B622E5F656C656D656E74732E24646973706C6179496E7075742E747269676765722822626C757222297D7D2C5F68616E646C65';
wwv_flow_api.g_varchar2_table(176) := '456E74657261626C65426C75723A66756E6374696F6E2863297B76617220623D632E646174612E7569773B696628622E5F656C656D656E74732E24646973706C6179496E7075742E76616C2829213D3D622E5F76616C7565732E6C617374446973706C61';
wwv_flow_api.g_varchar2_table(177) := '7956616C7565297B622E5F76616C7565732E6C617374446973706C617956616C75653D622E5F656C656D656E74732E24646973706C6179496E7075742E76616C28293B622E5F68616E646C65456E74657261626C654368616E676528297D7D2C5F68616E';
wwv_flow_api.g_varchar2_table(178) := '646C65456E74657261626C654368616E67653A66756E6374696F6E28297B76617220623D746869733B666F7228783D303B783C622E5F76616C7565732E6D6170546F4974656D732E6C656E6774683B782B2B297B247328622E5F76616C7565732E6D6170';
wwv_flow_api.g_varchar2_table(179) := '546F4974656D735B785D2C2222297D696628622E6F7074696F6E732E656E74657261626C653D3D3D622E5F76616C7565732E454E54455241424C455F52455354524943544544297B696628622E5F656C656D656E74732E24646973706C6179496E707574';
wwv_flow_api.g_varchar2_table(180) := '2E76616C2829297B622E5F76616C7565732E66657463684C6F764D6F64653D22454E54455241424C45223B622E5F66657463684C6F7628297D656C73657B622E5F656C656D656E74732E2468696464656E496E7075742E76616C282222297D7D656C7365';
wwv_flow_api.g_varchar2_table(181) := '7B696628622E6F7074696F6E732E656E74657261626C653D3D3D622E5F76616C7565732E454E54455241424C455F554E52455354524943544544297B622E5F656C656D656E74732E2468696464656E496E7075742E76616C28622E5F656C656D656E7473';
wwv_flow_api.g_varchar2_table(182) := '2E24646973706C6179496E7075742E76616C2829297D7D7D2C5F66657463684C6F763A66756E6374696F6E28297B76617220633D746869733B76617220623B76617220663B76617220653D303B76617220643B696628632E6F7074696F6E732E64656275';
wwv_flow_api.g_varchar2_table(183) := '67297B617065782E646562756728225375706572204C4F56202D204665746368204C4F562028222B632E5F76616C7565732E617065784974656D49642B222922297D696628632E5F76616C7565732E66657463684C6F76496E50726F63657373297B7265';
wwv_flow_api.g_varchar2_table(184) := '7475726E7D656C73657B632E5F76616C7565732E66657463684C6F76496E50726F636573733D747275657D696628632E5F76616C7565732E66657463684C6F764D6F64653D3D3D224449414C4F4722297B643D747275653B653D4D6174682E666C6F6F72';
wwv_flow_api.g_varchar2_table(185) := '284D6174682E72616E646F6D28292A3130303030303030303031293B632E5F656C656D656E74732E24777261707065722E64617461282266657463684C6F764964222C65293B632E5F64697361626C65536561726368427574746F6E28293B632E5F6469';
wwv_flow_api.g_varchar2_table(186) := '7361626C6550726576427574746F6E28293B632E5F64697361626C654E657874427574746F6E28293B632E5F656C656D656E74732E2477696E646F772E756E62696E642822726573697A65222C632E5F68616E646C6557696E646F77526573697A65293B';
wwv_flow_api.g_varchar2_table(187) := '696628632E5F656C656D656E74732E24636F6C756D6E53656C6563742E76616C28292626632E5F656C656D656E74732E2466696C7465722E76616C2829297B623D632E5F656C656D656E74732E24636F6C756D6E53656C6563742E76616C28293B632E5F';
wwv_flow_api.g_varchar2_table(188) := '76616C7565732E736561726368537472696E673D632E5F656C656D656E74732E2466696C7465722E76616C28297D656C73657B632E5F76616C7565732E736561726368537472696E673D22227D7D656C73657B696628632E5F76616C7565732E66657463';
wwv_flow_api.g_varchar2_table(189) := '684C6F764D6F64653D3D3D22454E54455241424C4522297B643D66616C73653B632E5F656C656D656E74732E246669656C647365742E616674657228273C7370616E20636C6173733D226C6F6164696E672D696E64696361746F722073757065726C6F76';
wwv_flow_api.g_varchar2_table(190) := '2D6C6F6164696E67223E3C2F7370616E3E27293B632E5F76616C7565732E706167696E6174696F6E3D22313A222B632E6F7074696F6E732E6D6178526F7773506572506167653B623D632E6F7074696F6E732E646973706C6179436F6C4E756D3B632E5F';
wwv_flow_api.g_varchar2_table(191) := '76616C7565732E736561726368537472696E673D632E5F656C656D656E74732E24646973706C6179496E7075742E76616C28297D7D663D7B705F666C6F775F69643A6128222370466C6F77496422292E76616C28292C705F666C6F775F737465705F6964';
wwv_flow_api.g_varchar2_table(192) := '3A6128222370466C6F7753746570496422292E76616C28292C705F696E7374616E63653A6128222370496E7374616E636522292E76616C28292C705F726571756573743A22504C5547494E3D222B632E6F7074696F6E732E616A61784964656E74696669';
wwv_flow_api.g_varchar2_table(193) := '65722C7830313A2246455443485F4C4F56222C7830323A632E5F76616C7565732E706167696E6174696F6E2C7830333A622C7830343A632E5F76616C7565732E736561726368537472696E672C7830353A652C705F6172675F6E616D65733A5B5D2C705F';
wwv_flow_api.g_varchar2_table(194) := '6172675F76616C7565733A5B5D7D3B6128632E6F7074696F6E732E646570656E64696E674F6E53656C6563746F72292E61646428632E6F7074696F6E732E706167654974656D73546F5375626D6974292E656163682866756E6374696F6E2867297B662E';
wwv_flow_api.g_varchar2_table(195) := '705F6172675F6E616D65735B675D3D746869732E69643B662E705F6172675F76616C7565735B675D3D24762874686973297D293B612E616A6178287B747970653A22504F5354222C75726C3A227777765F666C6F772E73686F77222C646174613A662C64';
wwv_flow_api.g_varchar2_table(196) := '617461547970653A2274657874222C6173796E633A642C737563636573733A66756E6374696F6E2867297B632E5F76616C7565732E616A617852657475726E3D673B632E5F68616E646C6546657463684C6F7652657475726E28297D7D297D2C5F68616E';
wwv_flow_api.g_varchar2_table(197) := '646C6546657463684C6F7652657475726E3A66756E6374696F6E28297B76617220653D746869733B76617220643B76617220633B76617220623D6128652E5F76616C7565732E616A617852657475726E293B696628652E6F7074696F6E732E6465627567';
wwv_flow_api.g_varchar2_table(198) := '297B617065782E646562756728225375706572204C4F56202D2048616E646C65204665746368204C4F562052657475726E2028222B652E5F76616C7565732E617065784974656D49642B222922297D696628652E5F76616C7565732E66657463684C6F76';
wwv_flow_api.g_varchar2_table(199) := '4D6F64653D3D3D224449414C4F472226264E756D626572286128652E5F76616C7565732E616A617852657475726E292E617474722822646174612D66657463682D6C6F762D6964222929213D3D652E5F656C656D656E74732E24777261707065722E6461';
wwv_flow_api.g_varchar2_table(200) := '7461282266657463684C6F7649642229297B696628652E6F7074696F6E732E6465627567297B617065782E646562756728222E2E2E416A61782072657475726E206D69736D61746368202D2065786974696E67206561726C7922297D72657475726E7D63';
wwv_flow_api.g_varchar2_table(201) := '3D622E66696E642822747222292E6C656E6774682D313B696628652E5F76616C7565732E66657463684C6F764D6F64653D3D3D22454E54455241424C4522297B652E5F656C656D656E74732E246669656C647365742E6E65787428227370616E2E6C6F61';
wwv_flow_api.g_varchar2_table(202) := '64696E672D696E64696361746F7222292E72656D6F766528293B696628633D3D3D31297B696628652E6F7074696F6E732E6465627567297B617065782E646562756728222E2E2E466F756E64206578616374206D617463682C2073657474696E67206469';
wwv_flow_api.g_varchar2_table(203) := '73706C617920616E642072657475726E20696E7075747322297D652E5F76616C7565732E66657463684C6F76496E50726F636573733D66616C73653B652E5F656C656D656E74732E2473656C6563746564526F773D622E66696E64282274723A65712831';
wwv_flow_api.g_varchar2_table(204) := '2922293B652E5F73657456616C75657346726F6D526F7728293B72657475726E7D656C73657B696628652E6F7074696F6E732E6465627567297B617065782E646562756728222E2E2E4578616374206D61746368206E6F7420666F756E642C206F70656E';
wwv_flow_api.g_varchar2_table(205) := '696E67206469616C6F6722297D652E5F656C656D656E74732E2468696464656E496E7075742E76616C282222293B652E5F656C656D656E74732E24646973706C6179496E7075742E76616C282222293B652E5F76616C7565732E6C617374446973706C61';
wwv_flow_api.g_varchar2_table(206) := '7956616C75653D22223B652E5F73686F774469616C6F6728297D7D652E5F656C656D656E74732E24777261707065722E66616465546F28302C30292E637373287B77696474683A223130303030307078222C6865696768743A22307078222C6F76657266';
wwv_flow_api.g_varchar2_table(207) := '6C6F773A2268696464656E227D292E656D70747928293B696628633D3D3D30297B643D273C64697620636C6173733D2275692D7769646765742073757065726C6F762D6E6F64617461223E5C6E2020203C64697620636C6173733D2275692D7374617465';
wwv_flow_api.g_varchar2_table(208) := '2D686967686C696768742075692D636F726E65722D616C6C22207374796C653D2270616464696E673A2030707420302E37656D3B223E5C6E2020202020203C703E5C6E2020202020203C7370616E20636C6173733D2275692D69636F6E2075692D69636F';
wwv_flow_api.g_varchar2_table(209) := '6E2D616C65727422207374796C653D22666C6F61743A206C6566743B206D617267696E2D72696768743A302E33656D3B223E3C2F7370616E3E5C6E202020202020272B652E6F7074696F6E732E6E6F44617461466F756E644D73672B225C6E2020202020';
wwv_flow_api.g_varchar2_table(210) := '203C2F703E5C6E2020203C2F6469763E5C6E3C2F6469763E5C6E223B652E5F656C656D656E74732E24777261707065722E68746D6C2864297D656C73657B652E5F656C656D656E74732E24777261707065722E68746D6C28652E5F76616C7565732E616A';
wwv_flow_api.g_varchar2_table(211) := '617852657475726E293B6128227461626C652E73757065726C6F762D7461626C652074683A666972737422292E616464436C617373282275692D636F726E65722D746C22293B6128227461626C652E73757065726C6F762D7461626C652074683A6C6173';
wwv_flow_api.g_varchar2_table(212) := '7422292E616464436C617373282275692D636F726E65722D747222293B6128227461626C652E73757065726C6F762D7461626C652074723A6C6173742074643A666972737422292E616464436C617373282275692D636F726E65722D626C22293B612822';
wwv_flow_api.g_varchar2_table(213) := '7461626C652E73757065726C6F762D7461626C652074723A6C6173742074643A6C61737422292E616464436C617373282275692D636F726E65722D627222297D652E5F69654E6F53656C6563745465787428293B652E5F696E69745472616E7369656E74';
wwv_flow_api.g_varchar2_table(214) := '456C656D656E747328293B652E5F76616C7565732E6D6F7265526F77733D28652E5F656C656D656E74732E246D6F7265526F77732E76616C28293D3D3D225922293F747275653A66616C73653B652E5F686967686C6967687453656C6563746564526F77';
wwv_flow_api.g_varchar2_table(215) := '28293B652E5F757064617465506167696E6174696F6E446973706C617928293B652E5F656E61626C65536561726368427574746F6E28293B696628652E5F76616C7565732E6D6F7265526F7773297B652E5F656E61626C654E657874427574746F6E2829';
wwv_flow_api.g_varchar2_table(216) := '7D656C73657B652E5F64697361626C654E657874427574746F6E28297D696628652E5F656C656D656E74732E247461626C652E6C656E677468297B617065782E64656275672822777261707065722077696474683A20222B652E5F656C656D656E74732E';
wwv_flow_api.g_varchar2_table(217) := '24777261707065722E77696474682829293B617065782E646562756728227461626C652077696474683A20222B652E5F656C656D656E74732E247461626C652E77696474682829293B652E5F656C656D656E74732E247461626C652E776964746828652E';
wwv_flow_api.g_varchar2_table(218) := '5F656C656D656E74732E247461626C652E77696474682829297D656C73657B696628652E5F656C656D656E74732E246E6F646174612E6C656E677468297B652E5F656C656D656E74732E246E6F646174612E776964746828652E5F656C656D656E74732E';
wwv_flow_api.g_varchar2_table(219) := '246E6F646174612E77696474682829297D7D652E5F726573697A654D6F64616C28293B652E5F76616C7565732E66657463684C6F76496E50726F636573733D66616C73657D2C5F726573697A654D6F64616C3A66756E6374696F6E28297B76617220623D';
wwv_flow_api.g_varchar2_table(220) := '746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20526573697A65204D6F64616C2028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F757064617465';
wwv_flow_api.g_varchar2_table(221) := '4C6F764D6561737572656D656E747328293B696628622E6F7074696F6E732E6566666563747353706565643D3D3D30297B622E5F656C656D656E74732E246F757465724469616C6F672E637373287B6865696768743A622E5F76616C7565732E6469616C';
wwv_flow_api.g_varchar2_table(222) := '6F674865696768742C77696474683A622E5F76616C7565732E6469616C6F6757696474682C6C6566743A622E5F76616C7565732E6469616C6F674C6566747D293B696628622E5F656C656D656E74732E246E6F646174612E6C656E677468297B622E5F65';
wwv_flow_api.g_varchar2_table(223) := '6C656D656E74732E246E6F646174612E776964746828622E5F76616C7565732E777261707065725769647468297D622E5F656C656D656E74732E24777261707065722E637373287B6865696768743A622E5F76616C7565732E7772617070657248656967';
wwv_flow_api.g_varchar2_table(224) := '68742C77696474683A622E5F76616C7565732E7772617070657257696474682C6F766572666C6F773A226175746F227D292E66616465546F28622E6F7074696F6E732E6566666563747353706565642C31293B622E5F656C656D656E74732E2477696E64';
wwv_flow_api.g_varchar2_table(225) := '6F772E62696E642822726573697A65222C7B7569773A627D2C622E5F68616E646C6557696E646F77526573697A65297D656C73657B622E5F656C656D656E74732E246F757465724469616C6F672E616E696D617465287B6865696768743A622E5F76616C';
wwv_flow_api.g_varchar2_table(226) := '7565732E6469616C6F674865696768747D2C622E6F7074696F6E732E6566666563747353706565642C66756E6374696F6E28297B622E5F656C656D656E74732E246F757465724469616C6F672E616E696D617465287B77696474683A622E5F76616C7565';
wwv_flow_api.g_varchar2_table(227) := '732E6469616C6F6757696474682C6C6566743A622E5F76616C7565732E6469616C6F674C6566747D2C622E6F7074696F6E732E6566666563747353706565642C66756E6374696F6E28297B696628622E5F656C656D656E74732E246E6F646174612E6C65';
wwv_flow_api.g_varchar2_table(228) := '6E677468297B622E5F656C656D656E74732E246E6F646174612E776964746828622E5F76616C7565732E777261707065725769647468297D622E5F656C656D656E74732E24777261707065722E637373287B6865696768743A622E5F76616C7565732E77';
wwv_flow_api.g_varchar2_table(229) := '7261707065724865696768742C77696474683A622E5F76616C7565732E7772617070657257696474682C6F766572666C6F773A226175746F227D292E66616465546F28622E6F7074696F6E732E6566666563747353706565642C31293B622E5F656C656D';
wwv_flow_api.g_varchar2_table(230) := '656E74732E2477696E646F772E62696E642822726573697A65222C7B7569773A627D2C622E5F68616E646C6557696E646F77526573697A65297D297D297D7D2C5F7365617263683A66756E6374696F6E28297B76617220623D746869733B696628622E6F';
wwv_flow_api.g_varchar2_table(231) := '7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D205365617263682028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F76616C7565732E637572506167653D313B622E5F76616C';
wwv_flow_api.g_varchar2_table(232) := '7565732E706167696E6174696F6E3D22313A222B622E6F7074696F6E732E6D6178526F7773506572506167653B696628622E5F656C656D656E74732E2466696C7465722E76616C28293D3D3D2222297B622E5F656C656D656E74732E24636F6C756D6E53';
wwv_flow_api.g_varchar2_table(233) := '656C6563742E76616C282222293B622E5F68616E646C65436F6C756D6E4368616E676528297D622E5F64697361626C6550726576427574746F6E28293B622E5F76616C7565732E66657463684C6F764D6F64653D224449414C4F47223B622E5F66657463';
wwv_flow_api.g_varchar2_table(234) := '684C6F7628297D2C5F757064617465506167696E6174696F6E446973706C61793A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2055';
wwv_flow_api.g_varchar2_table(235) := '706461746520506167696E6174696F6E20446973706C61792028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F656C656D656E74732E24706167696E6174696F6E446973706C61792E68746D6C28225061676520222B622E';
wwv_flow_api.g_varchar2_table(236) := '5F76616C7565732E63757250616765297D2C5F64697361626C65536561726368427574746F6E3A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C';
wwv_flow_api.g_varchar2_table(237) := '4F56202D2044697361626C652053656172636820427574746F6E2028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F64697361626C65427574746F6E282273656172636822297D2C5F64697361626C655072657642757474';
wwv_flow_api.g_varchar2_table(238) := '6F6E3A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2044697361626C65205072657620427574746F6E2028222B622E5F76616C7565';
wwv_flow_api.g_varchar2_table(239) := '732E617065784974656D49642B222922297D622E5F64697361626C65427574746F6E28227072657622297D2C5F64697361626C654E657874427574746F6E3A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465';
wwv_flow_api.g_varchar2_table(240) := '627567297B617065782E646562756728225375706572204C4F56202D2044697361626C65204E65787420427574746F6E2028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F64697361626C65427574746F6E28226E657874';
wwv_flow_api.g_varchar2_table(241) := '22297D2C5F64697361626C65427574746F6E3A66756E6374696F6E2864297B76617220633D746869733B76617220623B696628632E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2044697361626C6520';
wwv_flow_api.g_varchar2_table(242) := '427574746F6E2028222B632E5F76616C7565732E617065784974656D49642B222922297D696628643D3D2273656172636822297B623D632E5F656C656D656E74732E24736561726368427574746F6E3B622E61747472282264697361626C6564222C2264';
wwv_flow_api.g_varchar2_table(243) := '697361626C656422292E72656D6F7665436C617373282275692D73746174652D686F76657222292E72656D6F7665436C617373282275692D73746174652D666F63757322292E6373732822637572736F72222C2264656661756C7422293B72657475726E';
wwv_flow_api.g_varchar2_table(244) := '7D656C73657B696628643D3D227072657622297B623D632E5F656C656D656E74732E2470726576427574746F6E7D656C73657B696628643D3D226E65787422297B623D632E5F656C656D656E74732E246E657874427574746F6E7D7D7D622E6174747228';
wwv_flow_api.g_varchar2_table(245) := '2264697361626C6564222C2264697361626C656422292E72656D6F7665436C617373282275692D73746174652D686F76657222292E72656D6F7665436C617373282275692D73746174652D666F63757322292E637373287B6F7061636974793A22302E35';
wwv_flow_api.g_varchar2_table(246) := '222C637572736F723A2264656661756C74227D297D2C5F656E61626C65536561726368427574746F6E3A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E6465627567282253757065';
wwv_flow_api.g_varchar2_table(247) := '72204C4F56202D20456E61626C652053656172636820427574746F6E2028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F656E61626C65427574746F6E282273656172636822297D2C5F656E61626C655072657642757474';
wwv_flow_api.g_varchar2_table(248) := '6F6E3A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20456E61626C65205072657620427574746F6E2028222B622E5F76616C756573';
wwv_flow_api.g_varchar2_table(249) := '2E617065784974656D49642B222922297D622E5F656E61626C65427574746F6E28227072657622297D2C5F656E61626C654E657874427574746F6E3A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567';
wwv_flow_api.g_varchar2_table(250) := '297B617065782E646562756728225375706572204C4F56202D20456E61626C65204E65787420427574746F6E2028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F656E61626C65427574746F6E28226E65787422297D2C5F';
wwv_flow_api.g_varchar2_table(251) := '656E61626C65427574746F6E3A66756E6374696F6E2864297B76617220633D746869733B76617220623B696628632E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20456E61626C6520427574746F6E20';
wwv_flow_api.g_varchar2_table(252) := '28222B632E5F76616C7565732E617065784974656D49642B222922297D696628643D3D2273656172636822297B623D632E5F656C656D656E74732E24736561726368427574746F6E3B622E72656D6F766541747472282264697361626C656422292E6373';
wwv_flow_api.g_varchar2_table(253) := '732822637572736F72222C22706F696E74657222293B72657475726E7D656C73657B696628643D3D227072657622297B623D632E5F656C656D656E74732E2470726576427574746F6E7D656C73657B696628643D3D226E65787422297B623D632E5F656C';
wwv_flow_api.g_varchar2_table(254) := '656D656E74732E246E657874427574746F6E7D7D7D622E72656D6F766541747472282264697361626C656422292E637373287B6F7061636974793A2231222C637572736F723A22706F696E746572227D297D2C5F686967686C6967687453656C65637465';
wwv_flow_api.g_varchar2_table(255) := '64526F773A66756E6374696F6E28297B76617220633D746869733B76617220623D6128277461626C652E73757065726C6F762D7461626C652074626F64792074725B646174612D72657475726E3D22272B632E5F656C656D656E74732E2468696464656E';
wwv_flow_api.g_varchar2_table(256) := '496E7075742E76616C28292B27225D27293B696628632E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20486967686C696768742053656C656374656420526F772028222B632E5F76616C7565732E6170';
wwv_flow_api.g_varchar2_table(257) := '65784974656D49642B222922297D622E6368696C6472656E2822746422292E72656D6F7665436C617373282275692D73746174652D64656661756C7422292E616464436C617373282275692D73746174652D61637469766522297D2C5F68616E646C654D';
wwv_flow_api.g_varchar2_table(258) := '61696E54724D6F757365656E7465723A66756E6374696F6E2865297B76617220643D652E646174612E7569773B76617220623D6128652E63757272656E74546172676574293B76617220633D642E5F656C656D656E74732E247461626C652E66696E6428';
wwv_flow_api.g_varchar2_table(259) := '2274626F64793E747222292E686173282274642E75692D73746174652D686F76657222293B696628642E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F563A205F68616E646C654D61696E54724D6F757365656E';
wwv_flow_api.g_varchar2_table(260) := '7465722028222B642E5F76616C7565732E617065784974656D49642B222922297D696628632E6C656E677468297B696628632E6368696C6472656E282274642E75692D73746174652D686F7665722D61637469766522292E6C656E677468297B632E6368';
wwv_flow_api.g_varchar2_table(261) := '696C6472656E2822746422292E72656D6F7665436C617373282275692D73746174652D686F7665722075692D73746174652D686F7665722D61637469766522292E616464436C617373282275692D73746174652D61637469766522297D656C73657B632E';
wwv_flow_api.g_varchar2_table(262) := '6368696C6472656E2822746422292E72656D6F7665436C617373282275692D73746174652D686F76657222292E616464436C617373282275692D73746174652D64656661756C7422297D7D696628622E6368696C6472656E282274643A6E6F74282E7569';
wwv_flow_api.g_varchar2_table(263) := '2D73746174652D6163746976652922292E6C656E677468297B622E6368696C6472656E2822746422292E72656D6F7665436C617373282275692D73746174652D64656661756C7422292E616464436C617373282275692D73746174652D686F7665722229';
wwv_flow_api.g_varchar2_table(264) := '7D656C73657B622E6368696C6472656E2822746422292E72656D6F7665436C617373282275692D73746174652D61637469766522292E616464436C617373282275692D73746174652D686F7665722075692D73746174652D686F7665722D616374697665';
wwv_flow_api.g_varchar2_table(265) := '22297D7D2C5F68616E646C654D61696E54724D6F7573656C656176653A66756E6374696F6E2864297B76617220633D642E646174612E7569773B76617220623D6128642E63757272656E74546172676574293B696628632E6F7074696F6E732E64656275';
wwv_flow_api.g_varchar2_table(266) := '67297B617065782E646562756728225375706572204C4F563A205F68616E646C654D61696E54724D6F7573656C656176652028222B632E5F76616C7565732E617065784974656D49642B222922297D696628622E6368696C6472656E282274642E75692D';
wwv_flow_api.g_varchar2_table(267) := '73746174652D686F7665722D61637469766522292E6C656E677468297B622E6368696C6472656E2822746422292E72656D6F7665436C617373282275692D73746174652D686F7665722075692D73746174652D686F7665722D61637469766522292E6164';
wwv_flow_api.g_varchar2_table(268) := '64436C617373282275692D73746174652D61637469766522297D656C73657B622E6368696C6472656E2822746422292E72656D6F7665436C617373282275692D73746174652D686F76657222292E616464436C617373282275692D73746174652D646566';
wwv_flow_api.g_varchar2_table(269) := '61756C7422297D7D2C5F68616E646C654D61696E5472436C69636B3A66756E6374696F6E2863297B76617220623D632E646174612E7569773B622E5F656C656D656E74732E2473656C6563746564526F773D6128632E63757272656E7454617267657429';
wwv_flow_api.g_varchar2_table(270) := '3B622E5F73657456616C75657346726F6D526F7728297D2C5F73657456616C75657346726F6D526F773A66756E6374696F6E28297B76617220653D746869733B76617220643B76617220633D652E5F656C656D656E74732E2473656C6563746564526F77';
wwv_flow_api.g_varchar2_table(271) := '2E617474722822646174612D72657475726E22293B76617220623D652E5F656C656D656E74732E2473656C6563746564526F772E617474722822646174612D646973706C617922293B696628652E6F7074696F6E732E6465627567297B617065782E6465';
wwv_flow_api.g_varchar2_table(272) := '62756728225375706572204C4F56202D205365742076616C7565732066726F6D20726F772028222B652E5F76616C7565732E617065784974656D49642B222922293B617065782E646562756728272E2E2E72657475726E56616C3A2022272B632B272227';
wwv_flow_api.g_varchar2_table(273) := '293B617065782E646562756728272E2E2E646973706C617956616C3A2022272B622B272227297D643D652E5F656C656D656E74732E2468696464656E496E7075742E76616C2829213D3D633B696628652E6F7074696F6E732E6465627567297B61706578';
wwv_flow_api.g_varchar2_table(274) := '2E646562756728272E2E2E76616C4368616E6765643A2022272B642B272227297D652E5F656C656D656E74732E2468696464656E496E7075742E76616C2863293B652E5F656C656D656E74732E24646973706C6179496E7075742E76616C2862293B652E';
wwv_flow_api.g_varchar2_table(275) := '5F76616C7565732E6C617374446973706C617956616C75653D623B666F7228783D303B783C652E5F76616C7565732E6D6170546F4974656D732E6C656E6774683B782B2B297B696628652E5F697348696464656E436F6C28652E5F76616C7565732E6D61';
wwv_flow_api.g_varchar2_table(276) := '7046726F6D436F6C735B785D29297B247328652E5F76616C7565732E6D6170546F4974656D735B785D2C652E5F656C656D656E74732E2473656C6563746564526F772E617474722822646174612D636F6C222B652E5F76616C7565732E6D617046726F6D';
wwv_flow_api.g_varchar2_table(277) := '436F6C735B785D2B222D76616C75652229297D656C73657B247328652E5F76616C7565732E6D6170546F4974656D735B785D2C652E5F656C656D656E74732E2473656C6563746564526F772E6368696C6472656E282274642E61736C2D636F6C222B652E';
wwv_flow_api.g_varchar2_table(278) := '5F76616C7565732E6D617046726F6D436F6C735B785D292E746578742829297D7D696628652E5F76616C7565732E66657463684C6F764D6F64653D3D3D224449414C4F4722297B696628652E6F7074696F6E732E6465627567297B617065782E64656275';
wwv_flow_api.g_varchar2_table(279) := '6728222E2E2E496E206469616C6F67206D6F64653B20636C6F7365206469616C6F6722297D652E5F656C656D656E74732E246469616C6F672E6469616C6F672822636C6F736522297D69662864297B652E616C6C6F774368616E676550726F7061676174';
wwv_flow_api.g_varchar2_table(280) := '696F6E28293B652E5F656C656D656E74732E2468696464656E496E7075742E7472696767657228226368616E676522293B652E5F656C656D656E74732E24646973706C6179496E7075742E7472696767657228226368616E676522293B652E7072657665';
wwv_flow_api.g_varchar2_table(281) := '6E744368616E676550726F7061676174696F6E28297D7D2C5F68616E646C65536561726368427574746F6E436C69636B3A66756E6374696F6E2863297B76617220623D632E646174612E7569773B696628622E6F7074696F6E732E6465627567297B6170';
wwv_flow_api.g_varchar2_table(282) := '65782E646562756728225375706572204C4F56202D2048616E646C652053656172636820427574746F6E20436C69636B2028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F73656172636828297D2C5F68616E646C655072';
wwv_flow_api.g_varchar2_table(283) := '6576427574746F6E436C69636B3A66756E6374696F6E2865297B76617220643D652E646174612E7569773B76617220623B76617220633B696628642E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2048';
wwv_flow_api.g_varchar2_table(284) := '616E646C65205072657620427574746F6E20436C69636B2028222B642E5F76616C7565732E617065784974656D49642B222922297D642E5F76616C7565732E66657463684C6F764D6F64653D224449414C4F47223B642E5F76616C7565732E6375725061';
wwv_flow_api.g_varchar2_table(285) := '67653D642E5F76616C7565732E637572506167652D313B696628642E5F76616C7565732E637572506167653D3D3D31297B623D313B633D642E6F7074696F6E732E6D6178526F7773506572506167653B642E5F76616C7565732E706167696E6174696F6E';
wwv_flow_api.g_varchar2_table(286) := '3D622B223A222B633B642E5F66657463684C6F7628293B642E5F64697361626C6550726576427574746F6E28297D656C73657B623D2828642E5F76616C7565732E637572506167652D31292A642E6F7074696F6E732E6D6178526F777350657250616765';
wwv_flow_api.g_varchar2_table(287) := '292B313B633D642E5F76616C7565732E637572506167652A642E6F7074696F6E732E6D6178526F7773506572506167653B642E5F76616C7565732E706167696E6174696F6E3D622B223A222B633B642E5F66657463684C6F7628293B642E5F656E61626C';
wwv_flow_api.g_varchar2_table(288) := '6550726576427574746F6E28297D7D2C5F68616E646C654E657874427574746F6E436C69636B3A66756E6374696F6E2865297B76617220643D652E646174612E7569773B76617220623B76617220633B696628642E6F7074696F6E732E6465627567297B';
wwv_flow_api.g_varchar2_table(289) := '617065782E646562756728225375706572204C4F56202D2048616E646C65204E65787420427574746F6E20436C69636B2028222B642E5F76616C7565732E617065784974656D49642B222922297D642E5F76616C7565732E66657463684C6F764D6F6465';
wwv_flow_api.g_varchar2_table(290) := '3D224449414C4F47223B642E5F76616C7565732E637572506167653D642E5F76616C7565732E637572506167652B313B623D2828642E5F76616C7565732E637572506167652D31292A642E6F7074696F6E732E6D6178526F777350657250616765292B31';
wwv_flow_api.g_varchar2_table(291) := '3B633D642E5F76616C7565732E637572506167652A642E6F7074696F6E732E6D6178526F7773506572506167653B642E5F76616C7565732E706167696E6174696F6E3D622B223A222B633B642E5F66657463684C6F7628293B642E5F656C656D656E7473';
wwv_flow_api.g_varchar2_table(292) := '2E24706167696E6174696F6E446973706C61792E68746D6C28225061676520222B642E5F76616C7565732E63757250616765293B696628642E5F76616C7565732E637572506167653E3D322626642E5F656C656D656E74732E2470726576427574746F6E';
wwv_flow_api.g_varchar2_table(293) := '2E61747472282264697361626C65642229297B642E5F656E61626C6550726576427574746F6E28297D7D2C5F726566726573683A66756E6374696F6E28297B76617220633D746869733B76617220623D632E5F656C656D656E74732E2468696464656E49';
wwv_flow_api.g_varchar2_table(294) := '6E7075742E76616C28293B696628632E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20526566726573682028222B632E5F76616C7565732E617065784974656D49642B222922297D632E5F656C656D65';
wwv_flow_api.g_varchar2_table(295) := '6E74732E24646973706C6179496E7075742E747269676765722822617065786265666F72657265667265736822293B632E5F656C656D656E74732E2468696464656E496E7075742E76616C282222293B632E5F656C656D656E74732E24646973706C6179';
wwv_flow_api.g_varchar2_table(296) := '496E7075742E76616C282222293B632E5F76616C7565732E6C617374446973706C617956616C75653D22223B666F7228783D303B783C632E5F76616C7565732E6D6170546F4974656D732E6C656E6774683B782B2B297B247328632E5F76616C7565732E';
wwv_flow_api.g_varchar2_table(297) := '6D6170546F4974656D735B785D2C2222297D632E5F656C656D656E74732E24646973706C6179496E7075742E7472696767657228226170657861667465727265667265736822293B69662862213D3D632E5F656C656D656E74732E2468696464656E496E';
wwv_flow_api.g_varchar2_table(298) := '7075742E76616C2829297B632E616C6C6F774368616E676550726F7061676174696F6E28293B632E5F656C656D656E74732E2468696464656E496E7075742E7472696767657228226368616E676522293B632E5F656C656D656E74732E24646973706C61';
wwv_flow_api.g_varchar2_table(299) := '79496E7075742E7472696767657228226368616E676522293B632E70726576656E744368616E676550726F7061676174696F6E28297D72657475726E2066616C73657D2C5F7570646174654C6F764D6561737572656D656E74733A66756E6374696F6E28';
wwv_flow_api.g_varchar2_table(300) := '297B76617220713D746869733B766172206C3B766172206E3D32353B766172206D3D66616C73653B76617220633D66616C73653B76617220643D747275653B766172206B3B76617220733B76617220663B76617220683B76617220623B76617220723B76';
wwv_flow_api.g_varchar2_table(301) := '617220653B766172206A3B76617220703B766172206F3B76617220673B696628712E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20557064617465204C4F56204D6561737572656D656E74732028222B';
wwv_flow_api.g_varchar2_table(302) := '712E5F76616C7565732E617065784974656D49642B222922297D69662821712E5F656C656D656E74732E246E6F646174612E6C656E677468297B6C3D712E5F656C656D656E74732E247461626C657D656C73657B643D66616C73653B6C3D712E5F656C65';
wwv_flow_api.g_varchar2_table(303) := '6D656E74732E246E6F646174617D6B3D6128226469762E73757065726C6F762D6469616C6F67206469762E75692D6469616C6F672D7469746C6562617222292E6F757465724865696768742874727565292B712E5F656C656D656E74732E24627574746F';
wwv_flow_api.g_varchar2_table(304) := '6E436F6E7461696E65722E6F757465724865696768742874727565292B6128226469762E73757065726C6F762D6469616C6F67206469762E75692D6469616C6F672D627574746F6E70616E6522292E6F757465724865696768742874727565292B28712E';
wwv_flow_api.g_varchar2_table(305) := '5F656C656D656E74732E246469616C6F672E6F757465724865696768742874727565292D712E5F656C656D656E74732E246469616C6F672E6865696768742829292B28712E5F656C656D656E74732E24777261707065722E6F7574657248656967687428';
wwv_flow_api.g_varchar2_table(306) := '74727565292D712E5F656C656D656E74732E24777261707065722E6865696768742829293B733D712E5F656C656D656E74732E246F757465724469616C6F672E63737328226D61782D68656967687422293B696628712E5F76616C7565732E7065726365';
wwv_flow_api.g_varchar2_table(307) := '6E745265674578702E74657374287329297B733D7061727365466C6F61742873293B733D712E5F656C656D656E74732E2477696E646F772E68656967687428292A28732F313030297D656C73657B696628712E5F76616C7565732E706978656C52656745';
wwv_flow_api.g_varchar2_table(308) := '78702E74657374287329297B733D7061727365466C6F61742873297D656C73657B733D712E5F656C656D656E74732E2477696E646F772E68656967687428292A302E397D7D733D712E5F656C656D656E74732E2477696E646F772E68656967687428292A';
wwv_flow_api.g_varchar2_table(309) := '302E393B683D712E5F656C656D656E74732E246469616C6F672E6F7574657257696474682874727565292D712E5F656C656D656E74732E246469616C6F672E776964746828293B623D712E5F656C656D656E74732E246F757465724469616C6F672E6373';
wwv_flow_api.g_varchar2_table(310) := '7328226D696E2D776964746822293B696628712E5F76616C7565732E70657263656E745265674578702E74657374286229297B623D7061727365466C6F61742862293B623D712E5F656C656D656E74732E2477696E646F772E776964746828292A28622F';
wwv_flow_api.g_varchar2_table(311) := '313030297D656C73657B696628712E5F76616C7565732E706978656C5265674578702E74657374286229297B623D7061727365466C6F61742862297D656C73657B623D712E5F656C656D656E74732E24627574746F6E436F6E7461696E65722E6F757465';
wwv_flow_api.g_varchar2_table(312) := '7257696474682874727565297D7D723D712E5F656C656D656E74732E246F757465724469616C6F672E63737328226D61782D776964746822293B696628712E5F76616C7565732E70657263656E745265674578702E74657374287229297B723D70617273';
wwv_flow_api.g_varchar2_table(313) := '65466C6F61742872293B723D712E5F656C656D656E74732E2477696E646F772E776964746828292A28722F313030297D656C73657B696628712E5F76616C7565732E706978656C5265674578702E74657374287229297B723D7061727365466C6F617428';
wwv_flow_api.g_varchar2_table(314) := '72297D656C73657B723D712E5F656C656D656E74732E2477696E646F772E776964746828292A302E397D7D723D712E5F656C656D656E74732E2477696E646F772E776964746828292A302E393B6966286B2B6C2E6F757465724865696768742874727565';
wwv_flow_api.g_varchar2_table(315) := '293E73297B6D3D747275653B663D732D6B7D656C73657B663D6C2E6F757465724865696768742874727565297D69662864297B653D6C2E6F7574657257696474682874727565293B6966286D297B653D652B6E7D696628682B653C62297B653D622D687D';
wwv_flow_api.g_varchar2_table(316) := '656C73657B696628682B653E72297B633D747275653B653D722D683B696628653C62297B653D622D687D7D7D696628632626216D297B6966286B2B6C2E6F757465724865696768742874727565292B6E3E73297B6D3D747275653B663D732D6B7D656C73';
wwv_flow_api.g_varchar2_table(317) := '657B663D6C2E6F757465724865696768742874727565292B6E7D7D7D656C73657B653D622D687D703D6B2B663B6A3D682B653B712E5F76616C7565732E777261707065724865696768743D663B712E5F76616C7565732E7772617070657257696474683D';
wwv_flow_api.g_varchar2_table(318) := '653B712E5F76616C7565732E6469616C6F674865696768743D703B712E5F76616C7565732E6469616C6F6757696474683D6A3B6F3D28712E5F76616C7565732E6469616C6F6757696474682D712E5F656C656D656E74732E246F757465724469616C6F67';
wwv_flow_api.g_varchar2_table(319) := '2E77696474682829292F323B673D712E5F656C656D656E74732E246F757465724469616C6F672E63737328226C65667422293B696628712E5F76616C7565732E70657263656E745265674578702E74657374286729297B673D7061727365466C6F617428';
wwv_flow_api.g_varchar2_table(320) := '67293B673D712E5F656C656D656E74732E2477696E646F772E776964746828292A28672F313030297D656C73657B696628712E5F76616C7565732E706978656C5265674578702E74657374286729297B673D7061727365466C6F61742867297D656C7365';
wwv_flow_api.g_varchar2_table(321) := '7B673D307D7D673D672D6F3B696628673C30297B673D307D712E5F76616C7565732E6469616C6F674C6566743D673B712E5F76616C7565732E6469616C6F67546F703D712E5F656C656D656E74732E2477696E646F772E68656967687428292A302E3035';
wwv_flow_api.g_varchar2_table(322) := '2B6128646F63756D656E74292E7363726F6C6C546F7028297D2C5F7570646174655374796C656446696C7465723A66756E6374696F6E28297B76617220643D746869733B76617220633D642E5F656C656D656E74732E2466696C7465722E637373282262';
wwv_flow_api.g_varchar2_table(323) := '61636B67726F756E642D636F6C6F7222293B76617220663D642E5F656C656D656E74732E2466696C7465722E63737328226261636B67726F756E642D696D61676522293B76617220673D642E5F656C656D656E74732E2466696C7465722E637373282262';
wwv_flow_api.g_varchar2_table(324) := '61636B67726F756E642D72657065617422293B76617220623D642E5F656C656D656E74732E2466696C7465722E63737328226261636B67726F756E642D6174746163686D656E7422293B76617220653D642E5F656C656D656E74732E2466696C7465722E';
wwv_flow_api.g_varchar2_table(325) := '63737328226261636B67726F756E642D706F736974696F6E22293B696628642E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20557064617465205374796C65642046696C7465722028222B642E5F7661';
wwv_flow_api.g_varchar2_table(326) := '6C7565732E617065784974656D49642B222922297D6128222373757065726C6F765F7374796C65645F66696C74657222292E637373287B226261636B67726F756E642D636F6C6F72223A632C226261636B67726F756E642D696D616765223A662C226261';
wwv_flow_api.g_varchar2_table(327) := '636B67726F756E642D726570656174223A672C226261636B67726F756E642D6174746163686D656E74223A622C226261636B67726F756E642D706F736974696F6E223A657D297D2C5F7570646174655374796C6564496E7075743A66756E6374696F6E28';
wwv_flow_api.g_varchar2_table(328) := '297B76617220643D746869733B76617220633D642E5F656C656D656E74732E24646973706C6179496E7075742E63737328226261636B67726F756E642D636F6C6F7222293B76617220663D642E5F656C656D656E74732E24646973706C6179496E707574';
wwv_flow_api.g_varchar2_table(329) := '2E63737328226261636B67726F756E642D696D61676522293B76617220673D642E5F656C656D656E74732E24646973706C6179496E7075742E63737328226261636B67726F756E642D72657065617422293B76617220623D642E5F656C656D656E74732E';
wwv_flow_api.g_varchar2_table(330) := '24646973706C6179496E7075742E63737328226261636B67726F756E642D6174746163686D656E7422293B76617220653D642E5F656C656D656E74732E24646973706C6179496E7075742E63737328226261636B67726F756E642D706F736974696F6E22';
wwv_flow_api.g_varchar2_table(331) := '293B696628642E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20557064617465205374796C656420496E7075742028222B642E5F76616C7565732E617065784974656D49642B222922297D642E5F656C';
wwv_flow_api.g_varchar2_table(332) := '656D656E74732E246669656C647365742E637373287B226261636B67726F756E642D636F6C6F72223A632C226261636B67726F756E642D696D616765223A662C226261636B67726F756E642D726570656174223A672C226261636B67726F756E642D6174';
wwv_flow_api.g_varchar2_table(333) := '746163686D656E74223A622C226261636B67726F756E642D706F736974696F6E223A657D297D2C5F68616E646C65436C656172436C69636B3A66756E6374696F6E2864297B76617220633D642E646174612E7569773B76617220623D632E5F656C656D65';
wwv_flow_api.g_varchar2_table(334) := '6E74732E24636C656172427574746F6E2E66696E6428227370616E2E75692D69636F6E22293B696628632E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20436C656172204C4F562028222B632E5F7661';
wwv_flow_api.g_varchar2_table(335) := '6C7565732E617065784974656D49642B222922297D696628642E73637265656E58213D3D302626642E73637265656E59213D3D30297B642E7461726765742E626C757228297D696628632E5F656C656D656E74732E24646973706C6179496E7075742E76';
wwv_flow_api.g_varchar2_table(336) := '616C2829213D3D2222297B696628632E6F7074696F6E732E757365436C65617250726F74656374696F6E3D3D3D224E22297B632E5F7265667265736828297D656C73657B696628622E686173436C617373282275692D69636F6E2D636972636C652D636C';
wwv_flow_api.g_varchar2_table(337) := '6F73652229297B622E72656D6F7665436C617373282275692D69636F6E2D636972636C652D636C6F736522292E616464436C617373282275692D69636F6E2D616C65727422293B632E5F76616C7565732E64656C65746549636F6E54696D656F75743D73';
wwv_flow_api.g_varchar2_table(338) := '657454696D656F7574282224282723222B632E5F76616C7565732E636F6E74726F6C7349642B2220627574746F6E3E7370616E2E75692D69636F6E2D616C65727427292E72656D6F7665436C617373282775692D69636F6E2D616C65727427292E616464';
wwv_flow_api.g_varchar2_table(339) := '436C617373282775692D69636F6E2D636972636C652D636C6F736527293B222C31303030297D656C73657B636C65617254696D656F757428632E5F76616C7565732E64656C65746549636F6E54696D656F7574293B632E5F76616C7565732E64656C6574';
wwv_flow_api.g_varchar2_table(340) := '6549636F6E54696D656F75743D22223B632E5F7265667265736828293B622E72656D6F7665436C617373282275692D69636F6E2D616C65727422292E616464436C617373282275692D69636F6E2D636972636C652D636C6F736522297D7D7D7D2C5F6469';
wwv_flow_api.g_varchar2_table(341) := '7361626C654172726F774B65795363726F6C6C696E673A66756E6374696F6E2864297B76617220633D642E646174612E7569773B76617220623D642E77686963683B696628623D3D3D33377C7C623D3D3D3339297B696628632E5F76616C7565732E626F';
wwv_flow_api.g_varchar2_table(342) := '64794B65794D6F64653D3D3D22524F5753454C45435422297B642E70726576656E7444656661756C7428293B72657475726E2066616C73657D7D656C73657B696628623D3D3D33387C7C623D3D3D3430297B642E70726576656E7444656661756C742829';
wwv_flow_api.g_varchar2_table(343) := '3B72657475726E2066616C73657D7D72657475726E20747275657D2C5F68616E646C6546696C746572466F6375733A66756E6374696F6E2863297B76617220623D632E646174612E7569773B622E5F76616C7565732E626F64794B65794D6F64653D2253';
wwv_flow_api.g_varchar2_table(344) := '4541524348227D2C64697361626C653A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2044697361626C696E67204974656D2028222B';
wwv_flow_api.g_varchar2_table(345) := '622E5F76616C7565732E617065784974656D49642B222922297D696628622E5F76616C7565732E64697361626C65643D3D3D66616C7365297B696628622E6F7074696F6E732E656E74657261626C653D3D3D622E5F76616C7565732E454E54455241424C';
wwv_flow_api.g_varchar2_table(346) := '455F524553545249435445447C7C622E6F7074696F6E732E656E74657261626C653D3D3D622E5F76616C7565732E454E54455241424C455F554E52455354524943544544297B622E5F656C656D656E74732E24646973706C6179496E7075742E61747472';
wwv_flow_api.g_varchar2_table(347) := '282264697361626C6564222C2264697361626C656422292E756E62696E6428226B6579646F776E222C622E5F68616E646C65456E74657261626C654B6579646F776E292E756E62696E642822626C7572222C7B7569773A627D2C622E5F68616E646C6545';
wwv_flow_api.g_varchar2_table(348) := '6E74657261626C65426C7572297D622E5F656C656D656E74732E2468696464656E496E7075742E61747472282264697361626C6564222C2264697361626C656422293B622E5F656C656D656E74732E246F70656E427574746F6E2E756E62696E64282263';
wwv_flow_api.g_varchar2_table(349) := '6C69636B222C622E5F68616E646C654F70656E436C69636B293B622E5F656C656D656E74732E24636C656172427574746F6E2E756E62696E642822636C69636B222C622E5F68616E646C65436C656172436C69636B293B622E5F656C656D656E74732E24';
wwv_flow_api.g_varchar2_table(350) := '6974656D486F6C6465722E66696E6428226469762E73757065726C6F762D636F6E74726F6C2D627574746F6E7322292E627574746F6E736574282264697361626C6522297D622E5F76616C7565732E64697361626C65643D747275657D2C656E61626C65';
wwv_flow_api.g_varchar2_table(351) := '3A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20456E61626C696E67204974656D2028222B622E5F76616C7565732E617065784974';
wwv_flow_api.g_varchar2_table(352) := '656D49642B222922297D696628622E5F76616C7565732E64697361626C65643D3D3D74727565297B696628622E6F7074696F6E732E656E74657261626C653D3D3D622E5F76616C7565732E454E54455241424C455F524553545249435445447C7C622E6F';
wwv_flow_api.g_varchar2_table(353) := '7074696F6E732E656E74657261626C653D3D3D622E5F76616C7565732E454E54455241424C455F554E52455354524943544544297B622E5F656C656D656E74732E24646973706C6179496E7075742E72656D6F766541747472282264697361626C656422';
wwv_flow_api.g_varchar2_table(354) := '292E62696E6428226B6579646F776E222C7B7569773A627D2C622E5F68616E646C65456E74657261626C654B6579646F776E292E62696E642822626C7572222C7B7569773A627D2C622E5F68616E646C65456E74657261626C65426C7572297D622E5F65';
wwv_flow_api.g_varchar2_table(355) := '6C656D656E74732E2468696464656E496E7075742E72656D6F766541747472282264697361626C656422293B622E5F656C656D656E74732E246F70656E427574746F6E2E62696E642822636C69636B222C7B7569773A627D2C622E5F68616E646C654F70';
wwv_flow_api.g_varchar2_table(356) := '656E436C69636B293B622E5F656C656D656E74732E24636C656172427574746F6E2E62696E642822636C69636B222C7B7569773A627D2C622E5F68616E646C65436C656172436C69636B293B622E5F656C656D656E74732E246974656D486F6C6465722E';
wwv_flow_api.g_varchar2_table(357) := '66696E6428226469762E73757065726C6F762D636F6E74726F6C2D627574746F6E7322292E627574746F6E7365742822656E61626C6522297D622E5F76616C7565732E64697361626C65643D66616C73657D2C686964653A66756E6374696F6E28297B76';
wwv_flow_api.g_varchar2_table(358) := '617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20486964696E67204974656D2028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F656C';
wwv_flow_api.g_varchar2_table(359) := '656D656E74732E246669656C647365742E6869646528293B622E5F656C656D656E74732E246C6162656C2E6869646528297D2C73686F773A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B6170';
wwv_flow_api.g_varchar2_table(360) := '65782E646562756728225375706572204C4F56202D2053686F77696E67204974656D2028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F656C656D656E74732E246669656C647365742E73686F7728293B622E5F656C656D';
wwv_flow_api.g_varchar2_table(361) := '656E74732E246C6162656C2E73686F7728297D2C68696465526F773A66756E6374696F6E28297B76617220623D746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D20486964696E67';
wwv_flow_api.g_varchar2_table(362) := '20526F772028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F656C656D656E74732E246C6162656C2E636C6F736573742822747222292E6869646528297D2C73686F77526F773A66756E6374696F6E28297B76617220623D';
wwv_flow_api.g_varchar2_table(363) := '746869733B696628622E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2053686F77696E6720526F772028222B622E5F76616C7565732E617065784974656D49642B222922297D622E5F656C656D656E74';
wwv_flow_api.g_varchar2_table(364) := '732E246C6162656C2E636C6F736573742822747222292E73686F7728297D2C616C6C6F774368616E676550726F7061676174696F6E3A66756E6374696F6E28297B76617220623D746869733B622E5F76616C7565732E6368616E676550726F7061676174';
wwv_flow_api.g_varchar2_table(365) := '696F6E416C6C6F7765643D747275657D2C70726576656E744368616E676550726F7061676174696F6E3A66756E6374696F6E28297B76617220623D746869733B622E5F76616C7565732E6368616E676550726F7061676174696F6E416C6C6F7765643D66';
wwv_flow_api.g_varchar2_table(366) := '616C73657D2C6368616E676550726F7061676174696F6E416C6C6F7765643A66756E6374696F6E28297B76617220623D746869733B72657475726E20622E5F76616C7565732E6368616E676550726F7061676174696F6E416C6C6F7765647D2C67657456';
wwv_flow_api.g_varchar2_table(367) := '616C756573427952657475726E3A66756E6374696F6E2862297B76617220633D746869733B696628632E6F7074696F6E732E6465627567297B617065782E646562756728225375706572204C4F56202D2047657474696E672056616C7565732062792052';
wwv_flow_api.g_varchar2_table(368) := '657475726E2056616C75652028222B632E5F76616C7565732E617065784974656D49642B222922297D7175657279537472696E673D7B705F666C6F775F69643A6128222370466C6F77496422292E76616C28292C705F666C6F775F737465705F69643A61';
wwv_flow_api.g_varchar2_table(369) := '28222370466C6F7753746570496422292E76616C28292C705F696E7374616E63653A6128222370496E7374616E636522292E76616C28292C705F726571756573743A22504C5547494E3D222B632E6F7074696F6E732E616A61784964656E746966696572';
wwv_flow_api.g_varchar2_table(370) := '2C7830313A224745545F56414C5545535F42595F52455455524E222C7830363A627D3B612E616A6178287B747970653A22504F5354222C75726C3A227777765F666C6F772E73686F77222C646174613A7175657279537472696E672C6461746154797065';
wwv_flow_api.g_varchar2_table(371) := '3A226A736F6E222C6173796E633A66616C73652C737563636573733A66756E6374696F6E2864297B696628632E6F7074696F6E732E6465627567297B617065782E64656275672864297D632E5F76616C7565732E616A617852657475726E3D647D7D293B';
wwv_flow_api.g_varchar2_table(372) := '72657475726E20632E5F76616C7565732E616A617852657475726E7D2C73657456616C756573427952657475726E3A66756E6374696F6E2862297B76617220633D746869733B76617220643B643D632E67657456616C756573427952657475726E286229';
wwv_flow_api.g_varchar2_table(373) := '3B696628642E6572726F72213D3D756E646566696E6564297B696628632E5F656C656D656E74732E246669656C647365742E686173436C617373282273757065722D6C6F762D6E6F742D656E74657261626C6522297C7C632E5F656C656D656E74732E24';
wwv_flow_api.g_varchar2_table(374) := '6669656C647365742E686173436C617373282273757065722D6C6F762D656E74657261626C652D726573747269637465642229297B632E5F656C656D656E74732E2468696464656E496E7075742E76616C282222293B632E5F656C656D656E74732E2464';
wwv_flow_api.g_varchar2_table(375) := '6973706C6179496E7075742E76616C282222293B632E5F76616C7565732E6C617374446973706C617956616C75653D22227D656C73657B696628632E5F656C656D656E74732E246669656C647365742E686173436C617373282273757065722D6C6F762D';
wwv_flow_api.g_varchar2_table(376) := '656E74657261626C652D756E726573747269637465642229297B632E5F656C656D656E74732E2468696464656E496E7075742E76616C2862293B632E5F656C656D656E74732E24646973706C6179496E7075742E76616C2862293B632E5F76616C756573';
wwv_flow_api.g_varchar2_table(377) := '2E6C617374446973706C617956616C75653D627D7D666F7228783D303B783C632E5F76616C7565732E6D6170546F4974656D732E6C656E6774683B782B2B297B247328632E5F76616C7565732E6D6170546F4974656D735B785D2C2222297D7D656C7365';
wwv_flow_api.g_varchar2_table(378) := '7B69662821642E6D61746368466F756E64297B696628632E5F656C656D656E74732E246669656C647365742E686173436C617373282273757065722D6C6F762D6E6F742D656E74657261626C6522297C7C632E5F656C656D656E74732E246669656C6473';
wwv_flow_api.g_varchar2_table(379) := '65742E686173436C617373282273757065722D6C6F762D656E74657261626C652D726573747269637465642229297B632E5F656C656D656E74732E2468696464656E496E7075742E76616C282222293B632E5F656C656D656E74732E24646973706C6179';
wwv_flow_api.g_varchar2_table(380) := '496E7075742E76616C282222293B632E5F76616C7565732E6C617374446973706C617956616C75653D22227D656C73657B696628632E5F656C656D656E74732E246669656C647365742E686173436C617373282273757065722D6C6F762D656E74657261';
wwv_flow_api.g_varchar2_table(381) := '626C652D756E726573747269637465642229297B632E5F656C656D656E74732E2468696464656E496E7075742E76616C2862293B632E5F656C656D656E74732E24646973706C6179496E7075742E76616C2862293B632E5F76616C7565732E6C61737444';
wwv_flow_api.g_varchar2_table(382) := '6973706C617956616C75653D627D7D666F7228783D303B783C632E5F76616C7565732E6D6170546F4974656D732E6C656E6774683B782B2B297B247328632E5F76616C7565732E6D6170546F4974656D735B785D2C2222297D7D656C73657B632E5F656C';
wwv_flow_api.g_varchar2_table(383) := '656D656E74732E2468696464656E496E7075742E76616C28642E72657475726E56616C293B632E5F656C656D656E74732E24646973706C6179496E7075742E76616C28642E646973706C617956616C293B632E5F76616C7565732E6C617374446973706C';
wwv_flow_api.g_varchar2_table(384) := '617956616C75653D642E646973706C617956616C3B696628642E6D6170706564436F6C756D6E73297B666F7228783D303B783C642E6D6170706564436F6C756D6E732E6C656E6774683B782B2B297B247328642E6D6170706564436F6C756D6E735B785D';
wwv_flow_api.g_varchar2_table(385) := '2E6D61704974656D2C642E6D6170706564436F6C756D6E735B785D2E6D617056616C297D7D7D7D7D7D297D2928617065782E6A5175657279293B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 59036571644991239017 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 35179233361099294447 + wwv_flow_api.g_id_offset
 ,p_file_name => 'apex_super_lov.min.js'
 ,p_mime_type => 'application/x-javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

prompt  ...data loading
--
--application/deployment/definition
prompt  ...application deployment
--
 
begin
 
declare
    s varchar2(32767) := null;
    l_clob clob;
begin
s := null;
wwv_flow_api.create_install (
  p_id => 3840331551940789 + wwv_flow_api.g_id_offset,
  p_flow_id => wwv_flow.g_flow_id,
  p_include_in_export_yn => 'Y',
  p_welcome_message => 'Dieses Anwendungsinstallationsprogramm führt Sie durch den Prozess zum Erstellen von Datenbankobjekten und Seed-Daten.',
  p_configuration_message => 'Sie können die folgenden Attribute der Anwendung konfigurieren.',
  p_build_options_message => 'Sie können die folgenden Erstelloptionen einbeziehen.',
  p_validation_message => 'Die folgenden Validierungen werden durchgeführt, um sicherzustellen, dass das System mit dieser Anwendung kompatibel ist.',
  p_install_message=> 'Bestätigen Sie, dass Sie die unterstützenden Objekte dieser Anwendung installieren möchten.',
  p_install_success_message => 'Ihre unterstützenden Objekte wurden installiert.',
  p_install_failure_message => 'Installation der Datenbankobjekte und Seed-Daten nicht erfolgreich.',
  p_upgrade_message => 'Das Anwendungsinstallationsprogramm hat ermittelt, dass die unterstützenden Objekte dieser Anwendung zuvor installiert wurden. Dieser Assistent unterstützt Sie beim Upgrade dieser unterstützenden Objekte.',
  p_upgrade_confirm_message => 'Bestätigen Sie, dass Sie die unterstützenden Objekte dieser Anwendung installieren möchten.',
  p_upgrade_success_message => 'Ihre unterstützenden Objekte wurden installiert.',
  p_upgrade_failure_message => 'Installation der Datenbankobjekte und Seed-Daten nicht erfolgreich.',
  p_deinstall_success_message => 'Deinstallation abgeschlossen.',
  p_deinstall_script_clob => s,
  p_required_free_kb => 100,
  p_required_sys_privs => 'CREATE PROCEDURE:CREATE TABLE:CREATE TRIGGER:CREATE VIEW',
  p_deinstall_message=> '');
end;
 
 
end;
/

--application/deployment/install
prompt  ...application install scripts
--
--application/deployment/checks
prompt  ...application deployment checks
--
 
begin
 
null;
 
end;
/

--application/deployment/buildoptions
prompt  ...application deployment build options
--
 
begin
 
null;
 
end;
/

prompt  ...post import process
 
begin
 
wwv_flow_api.post_import_process(p_flow_id => wwv_flow.g_flow_id);
null;
 
end;
/

--application/end_environment
commit;
commit;
begin
execute immediate 'begin sys.dbms_session.set_nls( param => ''NLS_NUMERIC_CHARACTERS'', value => '''''''' || replace(wwv_flow_api.g_nls_numeric_chars,'''''''','''''''''''') || ''''''''); end;';
end;
/
set verify on
set feedback on
set define on
prompt  ...done
